/**
 * @license
 * Copyright 2019 The Emscripten Authors
 * SPDX-License-Identifier: MIT
 */

// wasm2js.js - enough of a polyfill for the WebAssembly object so that we can load
// wasm2js code that way.

// Emit "var WebAssembly" if definitely using wasm2js. Otherwise, in MAYBE_WASM2JS
// mode, we can't use a "var" since it would prevent normal wasm from working.
/** @suppress{duplicate, const} */
var
WebAssembly = {
  // Note that we do not use closure quoting (this['buffer'], etc.) on these
  // functions, as they are just meant for internal use. In other words, this is
  // not a fully general polyfill.
  Memory: function(opts) {
    this.buffer = new ArrayBuffer(opts['initial'] * 65536);
  },

  Module: function(binary) {
    // TODO: use the binary and info somehow - right now the wasm2js output is embedded in
    // the main JS
  },

  Instance: function(module, info) {
    // TODO: use the module and info somehow - right now the wasm2js output is embedded in
    // the main JS
    // This will be replaced by the actual wasm2js code.
    this.exports = (
// EMSCRIPTEN_START_ASM
function instantiate(XMa){function NMa(YMa){YMa.set=(function(ZMa,_Ma){this[ZMa]=_Ma});YMa.get=(function(ZMa){return this[ZMa]});return YMa}var a;var b=new ArrayBuffer(16);var c=new Int32Array(b);var d=new Float32Array(b);var e=new Float64Array(b);function OMa($Ma){return c[$Ma]}function PMa($Ma,aNa){c[$Ma]=aNa}function QMa(){return e[0]}function RMa(aNa){e[0]=aNa}function SMa(aNa){d[2]=aNa}function TMa(){return d[2]}function UMa(bNa){var f=bNa.a;var g=f.buffer;f.grow=WMa;var h=new Int8Array(g);var i=new Int16Array(g);var j=new Int32Array(g);var k=new Uint8Array(g);var l=new Uint16Array(g);var m=new Uint32Array(g);var n=new Float32Array(g);var o=new Float64Array(g);var p=Math.imul;var q=Math.fround;var r=Math.abs;var s=Math.clz32;var t=Math.min;var u=Math.max;var v=Math.floor;var w=Math.ceil;var x=Math.trunc;var y=Math.sqrt;var z=bNa.abort;var A=NaN;var B=Infinity;var C=bNa.b;var D=bNa.c;var E=bNa.d;var F=bNa.e;var G=bNa.f;var H=bNa.g;var I=bNa.h;var J=bNa.i;var K=bNa.j;var L=bNa.k;var M=bNa.l;var N=bNa.m;var O=bNa.n;var P=bNa.o;var Q=bNa.p;var R=bNa.q;var S=bNa.r;var T=bNa.s;var U=bNa.t;var V=bNa.u;var W=bNa.v;var X=bNa.w;var Y=bNa.x;var Z=bNa.y;var _=bNa.z;var $=bNa.A;var aa=bNa.B;var ba=bNa.C;var ca=bNa.D;var da=bNa.E;var ea=bNa.F;var fa=bNa.G;var ga=bNa.H;var ha=bNa.I;var ia=bNa.J;var ja=bNa.K;var ka=bNa.L;var la=bNa.M;var ma=bNa.N;var na=bNa.O;var oa=bNa.P;var pa=bNa.Q;var qa=bNa.R;var ra=bNa.S;var sa=bNa.T;var ta=bNa.U;var ua=bNa.V;var va=bNa.W;var wa=bNa.X;var xa=bNa.Y;var ya=bNa.Z;var za=bNa._;var Aa=bNa.$;var Ba=bNa.aa;var Ca=bNa.ba;var Da=bNa.ca;var Ea=bNa.da;var Fa=bNa.ea;var Ga=bNa.fa;var Ha=bNa.ga;var Ia=bNa.ha;var Ja=bNa.ia;var Ka=bNa.ja;var La=bNa.ka;var Ma=bNa.la;var Na=bNa.ma;var Oa=bNa.na;var Pa=bNa.oa;var Qa=bNa.pa;var Ra=bNa.qa;var Sa=bNa.ra;var Ta=bNa.sa;var Ua=bNa.ta;var Va=bNa.ua;var Wa=bNa.va;var Xa=bNa.wa;var Ya=bNa.xa;var Za=5707136;var _a=0;var $a=0;var ab=0;
// EMSCRIPTEN_START_FUNCS
function LGa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,n=0,o=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,J=0,M=0,O=0;d=Za-608|0;Za=d;rc(b);e=d+416|0;g=hFa(b,e);if(!g){dQ(e)}a:{b:{c:{if(!g){break c}if(!GQ(d+416|0)){break c}if(!yb(b,Tc(FQ(d+416|0),ab))){break c}if(!c){f=1;break c}od(a,32);h[d+415|0]=0;r=Qc(d+400|0);d:{e:{f:{g:{h:{i:{j:{k:{l:{m:{n:{o:{p:{q:{r:{s:{t:{u:{v:{w:{x:{y:{z:{A:{B:{C:{D:{E:{F:{G:{H:{I:{J:{if(j[d+416>>2]==778924148){j[114630]=0;F(621,a|0,16777216);e=j[114630];j[114630]=0;if((e|0)==1){break b}j[114630]=0;e=H(255,b|0)|0;f=j[114630];j[114630]=0;if((f|0)==1){break b}j[114630]=0;E(256,b|0,e-4|0)|0;e=j[114630];j[114630]=0;if((e|0)==1){break b}j[114630]=0;y=H(390,b|0)|0;e=j[114630];j[114630]=0;if((e|0)!=1){break J}break b}K:{L:{M:{N:{if((k[d+456|0]|k[d+457|0]<<8)>>>0<2185|(k[d+456|0]|k[d+457|0]<<8)>>>0>4095){break N}j[114630]=0;e=H(255,b|0)|0;f=j[114630];j[114630]=0;if((f|0)==1){break b}j[114630]=0;E(256,b|0,e-4|0)|0;e=j[114630];j[114630]=0;if((e|0)==1){break b}j[114630]=0;y=H(390,b|0)|0;e=j[114630];j[114630]=0;if((e|0)==1){break b}if(y>>>0<256){break N}j[114630]=0;e=H(255,b|0)|0;f=j[114630];j[114630]=0;if((f|0)==1){break b}if(e>>>0<=y>>>0){break N}j[114630]=0;e=E(256,b|0,y|0)|0;f=j[114630];j[114630]=0;if((f|0)==1){break b}if(!e){break N}j[114630]=0;e=E(622,b|0,13434)|0;f=j[114630];j[114630]=0;if((f|0)==1){break b}if(!e){break N}j[114630]=0;F(621,a|0,16777216);e=j[114630];j[114630]=0;if((e|0)==1){break b}if((k[d+456|0]|k[d+457|0]<<8)>>>0>=4096){j[114630]=0;b=E(623,d+224|0,13438)|0;c=j[114630];j[114630]=0;if((c|0)==1){break I}j[114630]=0;F(624,a|0,b|0);a=j[114630];j[114630]=0;if((a|0)!=1){gb(b);f=0;break d}f=D()|0;C()|0;gb(b);break a}if((k[d+456|0]|k[d+457|0]<<8)>>>0<2194){break N}j[114630]=0;e=E(623,d+224|0,13534)|0;f=j[114630];j[114630]=0;if((f|0)==1){break M}j[114630]=0;F(624,a|0,e|0);f=j[114630];j[114630]=0;if((f|0)==1){break L}gb(e)}if(j[a+480180>>2]!=32){break J}if(((k[d+456|0]|k[d+457|0]<<8)&61440)!=20480){break K}j[a+1074304>>2]=((k[d+456|0]|k[d+457|0]<<8)&4095)<<16;if(j[d+476>>2]!=1414548815){break J}h[d+415|0]=1;break J}f=D()|0;C()|0;break a}f=D()|0;C()|0;gb(e);break a}if(!((k[d+456|0]|k[d+457|0]<<8)!=2184?(k[d+458|0]|k[d+459|0]<<8)!=2184:0)){h[d+415|0]=1;j[a+1074304>>2]=18284544;break J}if(!((k[d+456|0]|k[d+457|0]<<8)!=535|(k[d+458|0]|k[d+459|0]<<8)!=512|(k[d+476|0]|k[d+477|0]<<8|(k[d+478|0]<<16|k[d+479|0]<<24)))){j[114630]=0;e=K(625,d+480|0,255,64)|0;f=j[114630];j[114630]=0;if((f|0)==1){break b}O:{if(e){j[a+1074304>>2]=18219008;j[114630]=0;e=E(2,d+224|0,13680)|0;f=j[114630];j[114630]=0;if((f|0)!=1){break O}f=D()|0;C()|0;break a}j[a+1074304>>2]=18284544;j[114630]=0;e=E(2,d+224|0,13708)|0;f=j[114630];j[114630]=0;if((f|0)==1){break H}}ob(r,e);gb(e);h[d+415|0]=1;break J}if(!((k[d+456|0]|k[d+457|0]<<8)!=532|(k[d+458|0]|k[d+459|0]<<8)!=514|(k[d+476|0]|k[d+477|0]<<8|(k[d+478|0]<<16|k[d+479|0]<<24)))){j[a+1074304>>2]=17367040;j[114630]=0;e=E(2,d+224|0,13744)|0;f=j[114630];j[114630]=0;if((f|0)!=1){ob(r,e);gb(e);h[d+415|0]=1;break J}f=D()|0;C()|0;break a}if((k[d+456|0]|k[d+457|0]<<8)!=768|(k[d+458|0]|k[d+459|0]<<8)!=768|(k[d+476|0]|k[d+477|0]<<8|(k[d+478|0]<<16|k[d+479|0]<<24)|(k[d+448|0]|k[d+449|0]<<8)!=256)){break J}if(k[d+469|0]|k[d+468|0]!=128){break J}j[a+1074304>>2]=18285088;h[d+415|0]=1}j[a+480208>>2]=j[a+480208>>2]&-17|(k[d+460|0]|k[d+461|0]<<8)<<1&16;j[a+480208>>2]=j[a+480208>>2]&-5|(k[d+460|0]|k[d+461|0]<<8)>>>2&4;j[a+480208>>2]=j[a+480208>>2]&-9|(k[d+460|0]|k[d+461|0]<<8)>>>2&8;j[a+480208>>2]=j[a+480208>>2]&-32769|(k[d+460|0]|k[d+461|0]<<8)<<3&32768;j[114630]=0;I(626,d+328|0,3,d+416|4);e=j[114630];j[114630]=0;if((e|0)==1){break G}j[114630]=0;F(415,d+224|0,d+328|0);e=j[114630];j[114630]=0;if((e|0)==1){break G}ob(a+1304400|0,d+224|0);gb(d+224|0);if(!(!(k[d+462|0]&4)|(m[a+1074304>>2]<18285314?j[a+1074304>>2]:0))){j[a+480216>>2]=k[d+446|0];j[a+480220>>2]=k[d+447|0]}e=k[d+464|0];j[a+480200>>2]=e>>>0>128?256:e<<1;if(k[d+466|0]){j[a+480196>>2]=k[d+466|0]}h[d+224|0]=31;e=k[d+467|0];j[114630]=0;h[d+328|0]=e;e=E(453,d+224|0,d+328|0)|0;f=j[114630];j[114630]=0;if((f|0)==1){break e}j[a+480204>>2]=p(k[e|0],1e4);e=k[d+465|0];j[114630]=0;h[d+224|0]=e;h[d+328|0]=128;e=E(391,d+224|0,d+328|0)|0;f=j[114630];j[114630]=0;if((f|0)==1){break f}j[a+480228>>2]=k[e|0];f=0;while(1){q=(d+416|0)+f|0;g=q- -64|0;P:{if(k[g|0]==255){break P}j[114630]=0;o=(f<<5)+a|0;e=o+480280|0;N(432,e|0);n=j[114630];j[114630]=0;if((n|0)==1){break F}M=o+480286|0,O=kd(k[q+128|0],0,64),i[M>>1]=O;if(h[g|0]<=-1){j[e>>2]=j[e>>2]|1024}g=k[g|0]&127;if(g>>>0<=64){i[o+480284>>1]=g<<2;break P}if((g|0)!=100){break P}j[e>>2]=j[e>>2]|256}f=f+1|0;if((f|0)!=64){continue}break}j[114630]=0;E(256,b|0,192)|0;e=j[114630];j[114630]=0;if((e|0)==1){break b}Q:{if(!(j[a+480180>>2]!=16777216|(k[d+456|0]|k[d+457|0]<<8)>>>0<2187|(k[d+456|0]|k[d+457|0]<<8)>>>0>2189)){f=0;j[114630]=0;e=H(357,b|0)|0;g=j[114630];j[114630]=0;if((g|0)==1){break E}if(e){break d}j[114630]=0;e=H(390,b|0)|0;g=j[114630];j[114630]=0;R:{if((g|0)==1){break R}if(e>>>0>l[j[19863]+12>>1]){break d}g=Eb(a+484360|0);j[114630]=0;e=U(627,g|0,b|0,e|0,65535,65535)|0;g=j[114630];j[114630]=0;if((g|0)==1){break R}if(!e){break d}break Q}f=D()|0;C()|0;break a}e=Eb(a+484360|0);f=k[d+448|0]|k[d+449|0]<<8;j[114630]=0;U(581,e|0,b|0,f|0,255,254)|0;e=j[114630];j[114630]=0;if((e|0)==1){break b}}x=jp(d+384|0);w=jp(d+368|0);t=jp(d+352|0);e=k[d+450|0]|k[d+451|0]<<8;f=0;j[114630]=0;e=K(628,b|0,x|0,e|0)|0;g=j[114630];j[114630]=0;S:{if((g|0)==1){break S}if(!e){break C}e=k[d+452|0]|k[d+453|0]<<8;j[114630]=0;e=K(628,b|0,w|0,e|0)|0;g=j[114630];j[114630]=0;if((g|0)==1){break S}if(!e){break C}e=k[d+454|0]|k[d+455|0]<<8;j[114630]=0;e=K(628,b|0,t|0,e|0)|0;g=j[114630];j[114630]=0;if((g|0)==1){break S}if(!e){break C}j[d+348>>2]=-1;M=d,O=Lb(x),j[M+224>>2]=O;M=d,O=Mb(x),j[M+328>>2]=O;if(!rb(d+224|0,d+328|0)){break D}while(1){e=j[d+224>>2];e=k[e|0]|k[e+1|0]<<8|(k[e+2|0]<<16|k[e+3|0]<<24);if(!(!e|e>>>0>=m[d+348>>2])){j[d+348>>2]=e}Id(d+224|0);if(rb(d+224|0,d+328|0)){continue}break}break D}f=D()|0;C()|0;break g}f=D()|0;C()|0;break a}f=D()|0;C()|0;break a}f=D()|0;C()|0;break a}f=D()|0;C()|0;break a}f=D()|0;C()|0;break a}M=d,O=Lb(w),j[M+224>>2]=O;M=d,O=Mb(w),j[M+328>>2]=O;if(rb(d+224|0,d+328|0)){while(1){e=j[d+224>>2];e=k[e|0]|k[e+1|0]<<8|(k[e+2|0]<<16|k[e+3|0]<<24);if(!(!e|e>>>0>=m[d+348>>2])){j[d+348>>2]=e}Id(d+224|0);if(rb(d+224|0,d+328|0)){continue}break}}M=d,O=Lb(t),j[M+224>>2]=O;M=d,O=Mb(t),j[M+328>>2]=O;if(rb(d+224|0,d+328|0)){while(1){e=j[d+224>>2];e=k[e|0]|k[e+1|0]<<8|(k[e+2|0]<<16|k[e+3|0]<<24);if(!(!e|e>>>0>=m[d+348>>2])){j[d+348>>2]=e}Id(d+224|0);if(rb(d+224|0,d+328|0)){continue}break}}T:{U:{if(h[d+462|0]&1){e=k[d+472|0]|k[d+473|0]<<8|(k[d+474|0]<<16|k[d+475|0]<<24);j[114630]=0;j[d+224>>2]=e;e=E(464,d+348|0,d+224|0)|0;f=j[114630];j[114630]=0;if((f|0)==1){break U}j[d+348>>2]=j[e>>2]}f=0;V:{W:{X:{Y:{if((k[d+458|0]|k[d+459|0]<<8)!=532|(k[d+456|0]|k[d+457|0]<<8?(k[d+456|0]|k[d+457|0]<<8)!=532:0)|(k[d+447|0]|k[d+446|0])){break Y}if(k[d+460|0]&192|(k[d+469|0]|(k[d+476|0]|k[d+477|0]<<8|(k[d+478|0]<<16|k[d+479|0]<<24)))){break Y}Z:{if(!(k[d+452|0]|k[d+453|0]<<8)|(k[d+450|0]|k[d+451|0]<<8)){break Z}if((j[b+8>>2]+(sb(w)<<2)|0)+2>>>0>m[d+348>>2]){break Z}if(k[d+452|0]|k[d+453|0]<<8){e=0;while(1){j[114630]=0;f=H(390,b|0)|0;g=j[114630];j[114630]=0;_:{if((g|0)!=1){if(!f){break _}cg(b,(e<<2)+4|0);break Z}f=D()|0;C()|0;break g}e=e+1|0;if(e>>>0<(k[d+452|0]|k[d+453|0]<<8)>>>0){continue}break}}j[114630]=0;e=E(2,d+224|0,13772)|0;f=j[114630];j[114630]=0;if((f|0)==1){break W}ob(r,e);gb(e)}f=1;if(k[d+456|0]|k[d+457|0]<<8){break Y}j[114630]=0;e=E(2,d+224|0,13785)|0;g=j[114630];j[114630]=0;if((g|0)==1){break X}ob(r,e);gb(e)}$:{aa:{ba:{if(k[d+462|0]&2){j[114630]=0;e=H(357,b|0)|0;g=j[114630];j[114630]=0;if((g|0)==1){break $}j[114630]=0;g=e<<3;o=E(258,b|0,g|0)|0;q=j[114630];j[114630]=0;if((q|0)==1){break $}if(!(!o|m[d+348>>2]<g+j[b+8>>2]>>>0)){j[114630]=0;g=a+1304500|0;F(629,g|0,e|0);o=j[114630];j[114630]=0;if((o|0)==1){break $}M=d,O=Lb(g),j[M+328>>2]=O;M=d,O=Mb(g),j[M+312>>2]=O;if(rb(d+328|0,d+312|0)){while(1){g=j[d+328>>2];j[114630]=0;E(630,b|0,d+224|0)|0;o=j[114630];j[114630]=0;if((o|0)==1){break aa}j[114630]=0;F(631,d+224|0,g|0);g=j[114630];j[114630]=0;if((g|0)==1){break aa}j[d+328>>2]=j[d+328>>2]+48;if(rb(d+328|0,d+312|0)){continue}break}}if(!(!e&f)){break ba}if(k[d+462|0]&4){j[114630]=0;e=E(2,d+224|0,13796)|0;f=j[114630];j[114630]=0;if((f|0)!=1){ob(r,e);gb(e);break ba}f=D()|0;C()|0;break g}j[114630]=0;e=E(2,d+224|0,13813)|0;f=j[114630];j[114630]=0;if((f|0)!=1){ob(r,e);gb(e);break ba}f=D()|0;C()|0;break g}cg(b,2);break ba}if(!f|(k[d+462|0]|k[d+463|0]<<8)>>>0>1){break ba}j[114630]=0;e=H(357,b|0)|0;f=j[114630];j[114630]=0;if((f|0)==1){break V}if(!e){j[114630]=0;e=E(2,d+224|0,13772)|0;f=j[114630];j[114630]=0;if((f|0)!=1){ob(r,e);gb(e);break ba}f=D()|0;C()|0;break g}cg(b,2)}ca:{if(k[d+462|0]&8?0:!(k[d+460|0]&128)){break ca}j[114630]=0;e=a+901404|0;f=E(632,b|0,e|0)|0;g=j[114630];j[114630]=0;if((g|0)==1){break h}if(!f){break ca}j[114630]=0;N(633,e|0);e=j[114630];j[114630]=0;if((e|0)==1){break h}}if((k[d+456|0]|k[d+457|0]<<8)>>>0<=531){j[114630]=0;N(634,a+901404|0);e=j[114630];j[114630]=0;if((e|0)==1){break h}}j[114630]=0;A=H(277,d+328|0)|0;e=j[114630];j[114630]=0;da:{ea:{fa:{ga:{ha:{ia:{ja:{if((e|0)!=1){j[114630]=0;e=E(618,b|0,13819)|0;f=j[114630];j[114630]=0;if((f|0)==1){break ja}if(e){j[114630]=0;e=H(390,b|0)|0;f=j[114630];j[114630]=0;if((f|0)==1){break ia}j[114630]=0;I(341,d+224|0,b|0,e|0);e=j[114630];j[114630]=0;if((e|0)==1){break ia}Ed(A,d+224|0);jb(d+224|0)}i[a+480188>>1]=1;j[114630]=0;e=E(618,b|0,13824)|0;f=j[114630];j[114630]=0;if((f|0)==1){break ja}if(e){j[114630]=0;e=H(390,b|0)|0;f=j[114630];j[114630]=0;if((f|0)==1){break ha}j[114630]=0;I(341,d+224|0,b|0,e|0);e=j[114630];j[114630]=0;if((e|0)==1){break ha}j[114630]=0;e=H(255,d+224|0)|0;f=j[114630];j[114630]=0;if((f|0)==1){break ga}j[114630]=0;i[d+312>>1]=(e>>>0)/20;e=E(477,13830,d+312|0)|0;f=j[114630];j[114630]=0;if((f|0)==1){break ga}e=l[e>>1];i[a+480188>>1]=e;if(e){f=0;while(1){j[114630]=0;K(635,d+224|0,((f<<5)+a|0)+480289|0,20)|0;g=j[114630];j[114630]=0;if((g|0)==1){break ga}f=f+1|0;if((e|0)!=(f|0)){continue}break}}jb(d+224|0)}if(m[b+8>>2]>m[d+348>>2]){break fa}e=j[d+348>>2]-j[b+8>>2]|0;break ea}f=D()|0;C()|0;break g}f=D()|0;C()|0;break i}f=D()|0;C()|0;break i}f=D()|0;C()|0;break i}f=D()|0;C()|0;jb(d+224|0);break i}j[114630]=0;e=H(540,b|0)|0;f=j[114630];j[114630]=0;if((f|0)==1){break da}}j[114630]=0;I(341,d+312|0,b|0,e|0);e=j[114630];j[114630]=0;if((e|0)==1){break da}j[114630]=0;J=E(636,a|0,d+312|0)|0;e=j[114630];j[114630]=0;ka:{la:{if((e|0)==1){break la}if(!(h[d+462|0]&1)|!(k[d+470|0]|k[d+471|0]<<8)){break ka}e=k[d+472|0]|k[d+473|0]<<8|(k[d+474|0]<<16|k[d+475|0]<<24);j[114630]=0;e=E(256,b|0,e|0)|0;f=j[114630];j[114630]=0;if((f|0)==1){break la}if(!e){break ka}e=k[d+470|0]|k[d+471|0]<<8;j[114630]=0;P(584,a+1304424|0,b|0,e|0,4)|0;e=j[114630];j[114630]=0;if((e|0)!=1){break ka}}f=D()|0;C()|0;break j}i[a+480192>>1]=0;ma:{if(k[d+460|0]&4){e=k[d+450|0]|k[d+451|0]<<8;j[114630]=0;i[d+224>>1]=e;i[d+208>>1]=255;e=E(477,d+224|0,d+208|0)|0;f=j[114630];j[114630]=0;if((f|0)==1){break ma}i[a+480192>>1]=l[e>>1]}na:{oa:{if(l[a+480192>>1]){f=0;while(1){e=xb(x,f);pa:{if(!(k[e|0]|k[e+1|0]<<8|(k[e+2|0]<<16|k[e+3|0]<<24))){break pa}e=xb(x,f);e=k[e|0]|k[e+1|0]<<8|(k[e+2|0]<<16|k[e+3|0]<<24);j[114630]=0;e=E(256,b|0,e|0)|0;g=j[114630];j[114630]=0;if((g|0)==1){break na}if(!e){break pa}j[114630]=0;e=E(258,b|0,554)|0;g=j[114630];j[114630]=0;if((g|0)==1){break na}if(!e){break pa}j[114630]=0;e=K(454,a|0,f+1&65535,0)|0;g=j[114630];j[114630]=0;if((g|0)==1){break oa}if(!e){break pa}g=k[d+458|0]|k[d+459|0]<<8;j[114630]=0;P(637,a|0,b|0,e|0,g|0)|0;g=j[114630];j[114630]=0;if((g|0)==1){break oa}h[e+33|0]=k[d+469|0]}f=f+1|0;if(f>>>0<l[a+480192>>1]){continue}break}}j[d+308>>2]=0;if(k[d+452|0]|k[d+453|0]<<8){e=xb(w,(k[d+452|0]|k[d+453|0]<<8)-1|0);j[d+308>>2]=(k[e|0]|k[e+1|0]<<8|(k[e+2|0]<<16|k[e+3|0]<<24))+80}e=k[d+452|0]|k[d+453|0]<<8;j[114630]=0;i[d+224>>1]=e;i[d+208>>1]=3999;e=E(477,d+224|0,d+208|0)|0;f=j[114630];j[114630]=0;if((f|0)!=1){i[a+480190>>1]=l[e>>1];o=0;qa:{if(l[a+480190>>1]){q=c&2;u=d+244|0;f=0;while(1){e=xb(w,f);ra:{if(!(k[e|0]|k[e+1|0]<<8|(k[e+2|0]<<16|k[e+3|0]<<24))){break ra}e=xb(w,f);e=k[e|0]|k[e+1|0]<<8|(k[e+2|0]<<16|k[e+3|0]<<24);j[114630]=0;e=E(256,b|0,e|0)|0;g=j[114630];j[114630]=0;sa:{ta:{ua:{va:{wa:{xa:{ya:{if((g|0)==1){break ya}if(!e){break ra}j[114630]=0;e=E(638,b|0,d+224|0)|0;g=j[114630];j[114630]=0;if((g|0)==1){break ya}if(!e){break ra}j[114630]=0;n=f+1|0;e=p(n,104)+a|0;g=e+484380|0;v=E(639,d+224|0,g|0)|0;s=j[114630];j[114630]=0;if((s|0)==1){break xa}j[114630]=0;I(626,d+192|0,3,u|0);s=j[114630];j[114630]=0;if((s|0)==1){break wa}j[114630]=0;F(415,d+208|0,d+192|0);s=j[114630];j[114630]=0;if((s|0)==1){break wa}j[114630]=0;E(369,((n<<5)+a|0)+946300|0,d+208|0)|0;s=j[114630];j[114630]=0;if((s|0)==1){break va}gb(d+208|0);j[114630]=0;v=E(256,b|0,v|0)|0;s=j[114630];j[114630]=0;if((s|0)==1){break xa}if(!v){break ra}e=l[e+484414>>1];if(!(e&512)){break ua}j[114630]=0;e=E(640,b|0,d+208|0)|0;n=j[114630];j[114630]=0;if((n|0)!=1){if(!e){break ta}j[114630]=0;j[d+16>>2]=j[d+216>>2];e=j[d+212>>2];j[d+8>>2]=j[d+208>>2];j[d+12>>2]=e;I(641,g|0,1,d+8|0);e=j[114630];j[114630]=0;if((e|0)!=1){break ta}}f=D()|0;C()|0;break j}f=D()|0;C()|0;break j}f=D()|0;C()|0;break j}f=D()|0;C()|0;break j}f=D()|0;C()|0;gb(d+208|0);break j}if(!(e&16384)){e=k[d+456|0]|k[d+457|0]<<8;j[114630]=0;I(642,d+208|0,d+224|0,e|0);e=j[114630];j[114630]=0;if((e|0)==1){break k}za:{if(q){e=0;j[114630]=0;K(400,d+208|0,g|0,b|0)|0;n=j[114630];j[114630]=0;if((n|0)!=1){break za}break k}e=1;n=k[d+211|0];if(n>>>0>18){break za}n=1<<n;Aa:{if(!(n&126991)){if(n&396800){break Aa}break za}if(!k[d+208|0]){break za}}e=j[g>>2];j[114630]=0;n=E(643,d+208|0,e|0)|0;e=j[114630];j[114630]=0;if((e|0)==1){break k}e=0;j[114630]=0;E(338,b|0,n|0)|0;n=j[114630];j[114630]=0;if((n|0)==1){break k}}if(k[d+211|0]!=1){break sa}o=j[g>>2]!=0|o;break sa}j[114630]=0;E(644,b|0,d+188|0)|0;e=j[114630];j[114630]=0;if((e|0)==1){break l}e=j[d+188>>2];if(!(!q|!e)){e=Cb(d+208|0);j[114630]=0;K(481,b|0,e|0,j[d+188>>2])|0;g=j[114630];j[114630]=0;Ba:{Ca:{Da:{Ea:{Fa:{Ga:{Ha:{Ia:{Ja:{if((g|0)!=1){j[114630]=0;g=E(2,d+160|0,13832)|0;v=j[114630];j[114630]=0;if((v|0)==1){break Ja}j[114630]=0;F(219,d+176|0,g|0);v=j[114630];j[114630]=0;if((v|0)==1){break Ia}j[114630]=0;j[d+156>>2]=n;I(13,d+144|0,0,e|0);n=j[114630];j[114630]=0;if((n|0)==1){break Ha}j[114630]=0;L(645,d+192|0,d+176|0,d+156|0,d+144|0);n=j[114630];j[114630]=0;if((n|0)==1){break Ga}j[114630]=0;I(646,a|0,2,d+192|0);n=j[114630];j[114630]=0;if((n|0)==1){break Fa}gb(d+192|0);gb(d+144|0);qb(d+176|0);gb(g);gb(e);break ta}f=D()|0;C()|0;break Ba}f=D()|0;C()|0;break Ba}f=D()|0;C()|0;break Ca}f=D()|0;C()|0;break Da}f=D()|0;C()|0;break Ea}f=D()|0;C()|0;gb(d+192|0)}gb(d+144|0)}qb(d+176|0)}gb(g)}gb(e);break j}j[114630]=0;E(338,b|0,e|0)|0;e=j[114630];j[114630]=0;if((e|0)==1){break l}}e=0}g=j[b+8>>2];j[114630]=0;j[d+208>>2]=g;g=E(647,d+308|0,d+208|0)|0;n=j[114630];j[114630]=0;if((n|0)==1){break qa}j[d+308>>2]=j[g>>2];B=(e|0)!=0}f=f+1|0;if(f>>>0<l[a+480190>>1]){continue}break}}i[d+224>>1]=1;e=l[a+480190>>1];j[114630]=0;i[d+208>>1]=e;e=E(452,d+224|0,d+208|0)|0;f=j[114630];j[114630]=0;if((f|0)!=1){i[a+480190>>1]=l[e>>1];Ka:{La:{if(!(o&1)|(k[d+456|0]|k[d+457|0]<<8)!=516|(k[d+462|0]|k[d+463|0]<<8|(k[d+458|0]|k[d+459|0]<<8)!=512)){break La}if(k[d+476|0]|k[d+477|0]<<8|(k[d+478|0]<<16|k[d+479|0]<<24)|((k[d+460|0]|k[d+461|0]<<8)&65527)!=21|(k[d+464|0]!=128|k[d+465|0]!=48)){break La}if(k[d+469|0]|k[d+468|0]!=128|(k[d+470|0]|k[d+471|0]<<8)){break La}g=d+544|0;e=d+480|0;f=1;while(1){f=(k[e|0]|128)!=160?0:f;e=e+1|0;if((g|0)!=(e|0)){continue}break}g=d+608|0;e=d+544|0;while(1){f=k[e|0]==64&f;e=e+1|0;if((g|0)!=(e|0)){continue}break}e=20;while(1){f=!k[(d+e|0)+420|0]&f;e=e+1|0;if(e>>>0<26){continue}break}if(!f){break La}j[114630]=0;e=E(2,d+224|0,13910)|0;f=j[114630];j[114630]=0;if((f|0)==1){break Ka}ob(r,e);gb(e)}j[a+480260>>2]=0;j[a+480264>>2]=2147483647;M=d,O=sb(t),i[M+224>>1]=O;e=j[a+8>>2];j[114630]=0;e=E(477,d+224|0,e+10|0)|0;f=j[114630];j[114630]=0;Ma:{Na:{Oa:{Pa:{Qa:{Ra:{Sa:{Ta:{Ua:{if((f|0)!=1){e=l[e>>1];i[d+188>>1]=e;if((sb(t)|0)!=(e|0)){j[114630]=0;F(508,d+208|0,13924);e=j[114630];j[114630]=0;if((e|0)==1){break Ua}e=sb(t);j[114630]=0;j[d+192>>2]=e;L(648,d+128|0,d+208|0,d+192|0,d+188|0);e=j[114630];j[114630]=0;if((e|0)==1){break Ta}j[114630]=0;e=E(649,d+224|0,d+128|0)|0;f=j[114630];j[114630]=0;if((f|0)==1){break Sa}j[114630]=0;F(624,a|0,e|0);f=j[114630];j[114630]=0;if((f|0)==1){break Ra}gb(e);gb(d+128|0);qb(d+208|0)}if(c&1){break Oa}i[d+188>>1]=0;break Na}f=D()|0;C()|0;break j}f=D()|0;C()|0;break j}f=D()|0;C()|0;break Pa}f=D()|0;C()|0;break Qa}f=D()|0;C()|0;gb(e)}gb(d+128|0)}qb(d+208|0);break j}if(!l[d+188>>1]){break Na}e=0;while(1){c=xb(t,e);Va:{if(!(k[c|0]|k[c+1|0]<<8|(k[c+2|0]<<16|k[c+3|0]<<24))){break Va}c=xb(t,e);c=k[c|0]|k[c+1|0]<<8|(k[c+2|0]<<16|k[c+3|0]<<24);j[114630]=0;c=E(256,b|0,c|0)|0;f=j[114630];j[114630]=0;if((f|0)==1){break Ma}if(!c){break Va}j[114630]=0;c=H(357,b|0)|0;f=j[114630];j[114630]=0;if((f|0)==1){break m}j[114630]=0;o=H(357,b|0)|0;f=j[114630];j[114630]=0;if((f|0)==1){break n}if((o-1&65535)>>>0>1023){break Va}j[114630]=0;f=E(338,b|0,4)|0;g=j[114630];j[114630]=0;if((g|0)==1){break n}if(!f){break Va}j[114630]=0;I(341,d+224|0,b|0,c|0);c=j[114630];j[114630]=0;if((c|0)==1){break o}c=0;f=l[a+480188>>1];j[114630]=0;g=E(650,d+208|0,f|0)|0;f=j[114630];j[114630]=0;if((f|0)==1){break q}while(1){Wa:{j[114630]=0;f=E(258,d+224|0,1)|0;q=j[114630];j[114630]=0;Xa:{Ya:{if((q|0)!=1){if(!f){break Wa}j[114630]=0;f=H(387,d+224|0)|0;q=j[114630];j[114630]=0;if((q|0)==1){break r}q=f<<24>>24;if(q){break Ya}c=c+1|0;break Xa}break r}Za:{f=q&127;n=f?f-1|0:0;f=n&65535;if(tc(g)>>>0>f>>>0){break Za}j[114630]=0;h[d+192|0]=0;I(651,g|0,f+1|0,d+192|0);u=j[114630];j[114630]=0;if((u|0)!=1){break Za}break r}if((q|0)<=-1){j[114630]=0;q=H(387,d+224|0)|0;u=j[114630];j[114630]=0;if((u|0)==1){break r}M=fc(g,f),O=q,h[M|0]=O}if(!(!(k[fc(g,f)|0]&15)|f>>>0<l[a+480188>>1])){i[a+480188>>1]=n+1}if(h[fc(g,f)|0]&1){j[114630]=0;E(338,d+224|0,1)|0;q=j[114630];j[114630]=0;if((q|0)==1){break r}}if(k[fc(g,f)|0]&2){j[114630]=0;E(338,d+224|0,1)|0;q=j[114630];j[114630]=0;if((q|0)==1){break r}}if(k[fc(g,f)|0]&4){j[114630]=0;E(338,d+224|0,1)|0;q=j[114630];j[114630]=0;if((q|0)==1){break r}}if(!(k[fc(g,f)|0]&8)){break Xa}j[114630]=0;E(338,d+224|0,2)|0;f=j[114630];j[114630]=0;if((f|0)==1){break r}}if(c>>>0<o>>>0){continue}}break}c=j[b+8>>2];j[114630]=0;j[d+192>>2]=c;c=E(647,d+308|0,d+192|0)|0;f=j[114630];j[114630]=0;if((f|0)==1){break r}j[d+308>>2]=j[c>>2];Od(g);jb(d+224|0)}e=e+1|0;if(e>>>0<l[d+188>>1]){continue}break}}_a:{$a:{c=j[d+308>>2];if(!c){break $a}j[114630]=0;E(256,b|0,c|0)|0;c=j[114630];j[114630]=0;if((c|0)==1){break s}if(!B){break $a}while(1){ab:{j[114630]=0;c=E(258,b|0,4)|0;e=j[114630];j[114630]=0;if((e|0)==1){break ab}if(!c){break $a}j[114630]=0;c=E(618,b|0,14016)|0;e=j[114630];j[114630]=0;if((e|0)==1){break ab}bb:{if(!c){j[114630]=0;c=E(618,b|0,14021)|0;e=j[114630];j[114630]=0;if((e|0)==1){break ab}if(!c){break bb}}j[114630]=0;c=H(390,b|0)|0;e=j[114630];j[114630]=0;if((e|0)==1){break _a}cg(b,8);if(c&-2139062144){break bb}if(c&1616928864){break $a}}j[114630]=0;c=H(357,b|0)|0;e=j[114630];j[114630]=0;if((e|0)==1){break ab}j[114630]=0;E(338,b|0,c|0)|0;c=j[114630];j[114630]=0;if((c|0)!=1){continue}}break}f=D()|0;C()|0;break j}j[114630]=0;c=E(652,a|0,b|0)|0;e=j[114630];j[114630]=0;if((e|0)==1){break s}c=c|k[d+415|0];h[d+415|0]=c;if(!(!c|J)){Vs(a+1074308|0);j[a+1074368>>2]=0}j[114630]=0;L(653,a|0,b|0,0,d+415|0);c=j[114630];j[114630]=0;if((c|0)==1){break s}j[114630]=0;u=a+484344|0;F(401,u|0,l[d+188>>1]);c=j[114630];j[114630]=0;if((c|0)==1){break s}i[d+156>>1]=0;if(!l[d+188>>1]){break T}f=0;while(1){cb:{db:{c=xb(t,f&65535);eb:{if(k[c|0]|k[c+1|0]<<8|(k[c+2|0]<<16|k[c+3|0]<<24)){c=xb(t,l[d+156>>1]);c=k[c|0]|k[c+1|0]<<8|(k[c+2|0]<<16|k[c+3|0]<<24);j[114630]=0;c=E(256,b|0,c|0)|0;e=j[114630];j[114630]=0;if((e|0)==1){break eb}if(c){break db}}j[114630]=0;c=K(402,u|0,l[d+156>>1],64)|0;e=j[114630];j[114630]=0;if((e|0)==1){break eb}if(!c){j[114630]=0;F(508,d+208|0,14026);c=j[114630];j[114630]=0;fb:{gb:{hb:{ib:{jb:{if((c|0)!=1){j[114630]=0;I(654,d+112|0,d+208|0,d+156|0);c=j[114630];j[114630]=0;if((c|0)==1){break jb}j[114630]=0;c=E(649,d+224|0,d+112|0)|0;e=j[114630];j[114630]=0;if((e|0)==1){break ib}j[114630]=0;F(624,a|0,c|0);e=j[114630];j[114630]=0;if((e|0)==1){break hb}gb(c);gb(d+112|0);qb(d+208|0);break T}f=D()|0;C()|0;break j}f=D()|0;C()|0;break fb}f=D()|0;C()|0;break gb}f=D()|0;C()|0;gb(c)}gb(d+112|0)}qb(d+208|0);break j}c=Hb(u,l[d+156>>1]);j[114630]=0;F(655,c|0,A|0);c=j[114630];j[114630]=0;if((c|0)!=1){break cb}}f=D()|0;C()|0;break j}j[114630]=0;c=H(357,b|0)|0;e=j[114630];j[114630]=0;kb:{lb:{if((e|0)!=1){j[114630]=0;v=H(357,b|0)|0;e=j[114630];j[114630]=0;if((e|0)==1){break lb}j[114630]=0;e=E(338,b|0,4)|0;f=j[114630];j[114630]=0;if((f|0)==1){break lb}if(!e){break cb}j[114630]=0;e=K(402,u|0,l[d+156>>1],v|0)|0;f=j[114630];j[114630]=0;if((f|0)==1){break lb}if(e){break kb}break cb}f=D()|0;C()|0;break j}f=D()|0;C()|0;break j}j[114630]=0;I(341,d+224|0,b|0,c|0);c=j[114630];j[114630]=0;if((c|0)!=1){c=Hb(u,l[d+156>>1]);j[114630]=0;F(655,c|0,A|0);c=j[114630];j[114630]=0;mb:{if((c|0)!=1){c=l[a+480188>>1];j[114630]=0;n=E(650,d+208|0,c|0)|0;c=j[114630];j[114630]=0;if((c|0)!=1){c=l[a+480188>>1];th(d+176|0);j[114630]=0;q=K(656,d+192|0,c|0,d+176|0)|0;c=j[114630];j[114630]=0;nb:{if((c|0)!=1){M=d,O=Lb(Hb(u,l[d+156>>1])),j[M+144>>2]=O;s=0;ob:{if(!v){break ob}while(1){j[114630]=0;c=E(258,d+224|0,1)|0;e=j[114630];j[114630]=0;pb:{if((e|0)!=1){qb:{if(!c){break ob}j[114630]=0;c=H(387,d+224|0)|0;e=j[114630];j[114630]=0;rb:{if((e|0)!=1){c=c<<24>>24;if(c){break rb}AQ(d+144|0,l[a+480188>>1]);s=s+1|0;break pb}break qb}sb:{e=c&127;o=e?e-1&65535:0;if(tc(n)>>>0>o>>>0){break sb}j[114630]=0;h[d+176|0]=0;e=o+1|0;I(651,n|0,e|0,d+176|0);f=j[114630];j[114630]=0;if((f|0)==1){break qb}th(d+176|0);j[114630]=0;I(657,q|0,e|0,d+176|0);e=j[114630];j[114630]=0;if((e|0)!=1){break sb}break qb}if((c|0)<=-1){j[114630]=0;c=H(387,d+224|0)|0;e=j[114630];j[114630]=0;if((e|0)==1){break qb}M=fc(n,o),O=c,h[M|0]=O}th(d+176|0);e=d+176|0;if(o>>>0<l[a+480188>>1]){e=wc(d+144|0,o)}if(k[fc(n,o)|0]&16){M=e,O=k[wc(q,o)|0],h[M|0]=O}if(k[fc(n,o)|0]&32){M=e,O=k[wc(q,o)+1|0],h[M+1|0]=O}if(k[fc(n,o)|0]&64){M=e,O=k[wc(q,o)+2|0],h[M+2|0]=O;M=e,O=k[wc(q,o)+4|0],h[M+4|0]=O}if(h[fc(n,o)|0]<=-1){M=e,O=k[wc(q,o)+3|0],h[M+3|0]=O;M=e,O=k[wc(q,o)+5|0],h[M+5|0]=O}if(h[fc(n,o)|0]&1){j[114630]=0;c=H(387,d+224|0)|0;f=j[114630];j[114630]=0;B=e;tb:{ub:{if((f|0)!=1){c=c+(((c^-1)&128)>>>7|0)|0;if(!(j[a+480180>>2]&16777216)){break ub}f=c;break tb}break qb}f=253;if((c-121&255)>>>0<132){break tb}f=(c&255)==253?0:c}h[B|0]=f;M=wc(q,o),O=f,h[M|0]=O}if(k[fc(n,o)|0]&2){j[114630]=0;c=H(387,d+224|0)|0;f=j[114630];j[114630]=0;if((f|0)==1){break qb}h[e+1|0]=c;M=wc(q,o),O=c,h[M+1|0]=O}if(k[fc(n,o)|0]&4){j[114630]=0;c=H(387,d+224|0)|0;f=j[114630];j[114630]=0;vb:{wb:{if((f|0)!=1){if(c>>>0>64){break wb}h[e+4|0]=c;h[e+2|0]=1;break vb}break qb}if(!(c<<24>>24>-1|c>>>0>192)){h[e+2|0]=2;h[e+4|0]=c^128;break vb}if(c>>>0<=74){h[e+2|0]=5;h[e+4|0]=c-65;break vb}if(c>>>0<=84){h[e+2|0]=6;h[e+4|0]=c-75;break vb}if(c>>>0<=94){h[e+2|0]=3;h[e+4|0]=c-85;break vb}if(c>>>0<=104){h[e+2|0]=4;h[e+4|0]=c-95;break vb}if(c>>>0<=114){h[e+2|0]=13;h[e+4|0]=c-105;break vb}if(c>>>0<=124){h[e+2|0]=12;h[e+4|0]=c-115;break vb}f=c+63|0;if((f&255)>>>0<=9){h[e+4|0]=f;h[e+2|0]=11;break vb}f=c+53|0;g=f&255;if(g>>>0<=9){h[e+4|0]=f;h[e+2|0]=8;if(!g|!j[a+1074304>>2]|m[a+1074304>>2]>18285140){break vb}h[e+2|0]=7;break vb}c=c+33|0;if((c&255)>>>0>9){break vb}h[e+4|0]=c;h[e+2|0]=15}c=k[e+2|0];M=wc(q,o),O=c,h[M+2|0]=O;c=k[e+4|0];M=wc(q,o),O=c,h[M+4|0]=O}if(!(k[fc(n,o)|0]&8)){break pb}j[114630]=0;F(472,d+104|0,d+224|0);c=j[114630];j[114630]=0;if((c|0)!=1){xb:{c=Pc(d+104|0);h[e+3|0]=k[d+104|0];h[e+5|0]=k[c|0];j[114630]=0;F(658,e|0,1);c=j[114630];j[114630]=0;if((c|0)==1){break xb}c=k[e+3|0];M=wc(q,o),O=c,h[M+3|0]=O;c=k[e+5|0];M=wc(q,o),O=c,h[M+5|0]=O;break pb}}}}f=D()|0;C()|0;ol(q);break nb}if(s>>>0<v>>>0){continue}break}}ol(q);Od(n);jb(d+224|0);break cb}f=D()|0;C()|0}Od(n);break mb}f=D()|0;C()|0;break mb}f=D()|0;C()|0}jb(d+224|0);break j}f=D()|0;C()|0;break j}f=l[d+156>>1]+1|0;i[d+156>>1]=f;if(l[d+188>>1]>(f&65535)>>>0){continue}break}break T}f=D()|0;C()|0;break j}f=D()|0;C()|0;break j}f=D()|0;C()|0;break j}f=D()|0;C()|0;break j}f=D()|0;C()|0;break j}f=D()|0;C()|0;break j}f=D()|0;C()|0;break j}f=D()|0;C()|0;break j}f=D()|0;C()|0;break j}f=D()|0;C()|0;break i}f=D()|0;C()|0;break g}f=D()|0;C()|0;break g}f=D()|0;C()|0;break g}f=D()|0;C()|0;break g}f=D()|0;C()|0;break g}f=D()|0;C()|0;break g}c=a+1074304|0;yb:{zb:{if(!j[a+1074304>>2]){Ab:{if((k[d+456|0]|k[d+457|0]<<8)==2184){j[c>>2]=18284544;f=18284544;break Ab}f=j[c>>2]}if(!f){break zb}}if(!Ec(r)){break zb}j[114630]=0;e=E(2,d+208|0,14078)|0;f=j[114630];j[114630]=0;Bb:{Cb:{Db:{Eb:{Fb:{Gb:{if((f|0)!=1){j[114630]=0;F(242,d+192|0,c|0);f=j[114630];j[114630]=0;if((f|0)==1){break Gb}j[114630]=0;I(3,d+224|0,e|0,d+192|0);f=j[114630];j[114630]=0;if((f|0)==1){break Fb}ob(r,d+224|0);gb(d+224|0);gb(d+192|0);gb(e);if(j[d+476>>2]==1414548815|((k[d+456|0]|k[d+457|0]<<8)&61440)!=20480){break Bb}j[114630]=0;c=E(2,d+224|0,14087)|0;e=j[114630];j[114630]=0;if((e|0)==1){break Db}j[114630]=0;E(192,r|0,c|0)|0;e=j[114630];j[114630]=0;if((e|0)==1){break Cb}gb(c);break yb}f=D()|0;C()|0;break j}f=D()|0;C()|0;break Eb}f=D()|0;C()|0;gb(d+192|0)}gb(e);break j}f=D()|0;C()|0;break j}f=D()|0;C()|0;gb(c);break j}if(!tB(c)){break yb}j[114630]=0;c=E(2,d+224|0,14111)|0;e=j[114630];j[114630]=0;Hb:{if((e|0)!=1){j[114630]=0;E(192,r|0,c|0)|0;e=j[114630];j[114630]=0;if((e|0)==1){break Hb}gb(c);break yb}f=D()|0;C()|0;break j}f=D()|0;C()|0;gb(c);break j}Ib:{switch((k[d+456|0]|k[d+457|0]<<8)>>>12|0){case 0:if(J){j[114630]=0;c=E(2,d+224|0,14125)|0;e=j[114630];j[114630]=0;if((e|0)!=1){ob(r,c);gb(c);break yb}f=D()|0;C()|0;break j}Jb:{if((k[d+456|0]|k[d+457|0]<<8)!=532|(k[d+458|0]|k[d+459|0]<<8)!=512|(k[d+462|0]|k[d+463|0]<<8|(k[d+460|0]|k[d+461|0]<<8)!=9)){break Jb}if(k[d+447|0]|k[d+446|0]|(k[d+450|0]|k[d+451|0]<<8|((k[d+454|0]|k[d+455|0]<<8)+1|0)!=(k[d+448|0]|k[d+449|0]<<8))){break Jb}if(k[d+464|0]!=128|k[d+465|0]!=100|(k[d+466|0]!=1|k[d+468|0]!=128)){break Jb}if(k[d+469|0]|(k[d+470|0]|k[d+471|0]<<8)|(k[d+472|0]|k[d+473|0]<<8|(k[d+474|0]<<16|k[d+475|0]<<24)|(k[d+476|0]|k[d+477|0]<<8|(k[d+478|0]<<16|k[d+479|0]<<24)))){break Jb}j[114630]=0;c=E(2,d+224|0,14137)|0;e=j[114630];j[114630]=0;if((e|0)!=1){ob(r,c);gb(c);break yb}f=D()|0;C()|0;break j}Kb:{if((k[d+456|0]|k[d+457|0]<<8)!=532|(k[d+458|0]|k[d+459|0]<<8)!=512|(k[d+447|0]|k[d+446|0])){break Kb}if(k[d+476|0]|k[d+477|0]<<8|(k[d+478|0]<<16|k[d+479|0]<<24)){break Kb}j[c>>2]=16777381;j[114630]=0;c=E(2,d+224|0,14156)|0;e=j[114630];j[114630]=0;if((e|0)!=1){ob(r,c);gb(c);h[d+415|0]=1;break yb}f=D()|0;C()|0;break j}if(!((k[d+456|0]|k[d+457|0]<<8)!=532|(k[d+458|0]|k[d+459|0]<<8)!=532|j[d+476>>2]!=1229080643)){j[114630]=0;c=E(2,d+224|0,14179)|0;e=j[114630];j[114630]=0;if((e|0)!=1){ob(r,c);gb(c);j[114630]=0;E(479,a+1074308|0,38)|0;c=j[114630];j[114630]=0;if((c|0)==1){break s}break yb}f=D()|0;C()|0;break j}Lb:{if((k[d+456|0]|k[d+457|0]<<8)!=532|(k[d+458|0]|k[d+459|0]<<8)!=532|(k[d+469|0]|(k[d+462|0]|k[d+463|0]<<8)>>>0>1)){break Lb}if(!l[a+480190>>1]|(k[d+476|0]|k[d+477|0]<<8|(k[d+478|0]<<16|k[d+479|0]<<24)|((k[d+460|0]|k[d+461|0]<<8)&4294)!=4)){break Lb}j[114630]=0;c=E(85,d+224|0,14192)|0;e=j[114630];j[114630]=0;Mb:{Nb:{if((e|0)!=1){j[114630]=0;e=E(659,a+484527|0,c|0)|0;f=j[114630];j[114630]=0;if((f|0)==1){break Nb}gb(c);if(!e){break Lb}j[114630]=0;c=E(2,d+224|0,14205)|0;e=j[114630];j[114630]=0;if((e|0)==1){break Mb}ob(r,c);gb(c);break yb}f=D()|0;C()|0;break j}f=D()|0;C()|0;gb(c);break j}f=D()|0;C()|0;break j}Ob:{if(k[d+456|0]|k[d+457|0]<<8){break Ob}if(!Ec(r)){break Ob}j[114630]=0;c=E(2,d+224|0,14219)|0;e=j[114630];j[114630]=0;if((e|0)!=1){ob(r,c);gb(c);break yb}f=D()|0;C()|0;break j}if((k[d+458|0]|k[d+459|0]<<8)>>>0>767){break yb}if(!Ec(r)){break yb}Pb:{Qb:{Rb:{Sb:{Tb:{Ub:{Vb:{if((k[d+458|0]|k[d+459|0]<<8)>>>0>=533){j[114630]=0;c=E(2,d+224|0,14227)|0;e=j[114630];j[114630]=0;if((e|0)!=1){ob(r,c);break Vb}f=D()|0;C()|0;break j}if((k[d+456|0]|k[d+457|0]<<8)>>>0>=533){j[114630]=0;c=E(2,d+88|0,14248)|0;e=j[114630];j[114630]=0;Wb:{Xb:{Yb:{if((e|0)!=1){j[114630]=0;F(219,d+208|0,c|0);e=j[114630];j[114630]=0;if((e|0)==1){break Yb}e=k[d+456|0]|k[d+457|0]<<8;j[114630]=0;j[d+192>>2]=e-532;I(245,d+224|0,d+208|0,d+192|0);e=j[114630];j[114630]=0;if((e|0)==1){break Xb}ob(r,d+224|0);gb(d+224|0);qb(d+208|0);break Vb}f=D()|0;C()|0;break j}f=D()|0;C()|0;break Wb}f=D()|0;C()|0;qb(d+208|0)}gb(c);break j}j[114630]=0;c=E(2,d+72|0,14272)|0;e=j[114630];j[114630]=0;if((e|0)==1){break Ub}j[114630]=0;F(219,d+208|0,c|0);e=j[114630];j[114630]=0;if((e|0)==1){break Tb}j[d+176>>2]=k[d+457|0]&15;e=k[d+456|0];j[114630]=0;j[d+144>>2]=e;F(660,d+192|0,d+144|0);e=j[114630];j[114630]=0;if((e|0)==1){break Sb}j[114630]=0;L(645,d+224|0,d+208|0,d+176|0,d+192|0);e=j[114630];j[114630]=0;if((e|0)==1){break Rb}ob(r,d+224|0);gb(d+224|0);gb(d+192|0);qb(d+208|0)}gb(c);c=a+1304500|0;if(!Xc(c)|!(k[d+476|0]|k[d+477|0]<<8|(k[d+478|0]<<16|k[d+479|0]<<24))){break yb}e=k[d+456|0]|k[d+457|0]<<8;f=k[d+476|0]|k[d+477|0]<<8|(k[d+478|0]<<16|k[d+479|0]<<24);j[114630]=0;e=E(661,e|0,f|0)|0;f=j[114630];j[114630]=0;if((f|0)==1){break v}f=qp(d+224|0);j[f+44>>2]=e;j[114630]=0;F(662,c|0,f|0);c=j[114630];j[114630]=0;if((c|0)!=1){break yb}f=D()|0;C()|0;break j}f=D()|0;C()|0;break j}f=D()|0;C()|0;break Pb}f=D()|0;C()|0;break Qb}f=D()|0;C()|0;gb(d+192|0)}qb(d+208|0)}gb(c);break j;case 1:c=k[d+456|0]|k[d+457|0]<<8;e=k[d+476|0]|k[d+477|0]<<8|(k[d+478|0]<<16|k[d+479|0]<<24);j[114630]=0;I(663,d+224|0,c|0,e|0);c=j[114630];j[114630]=0;Zb:{if((c|0)!=1){ob(r,d+224|0);gb(d+224|0);if((k[d+456|0]|k[d+457|0]<<8)>>>0>=6092){break Zb}j[114630]=0;E(479,a+1074308|0,7)|0;c=j[114630];j[114630]=0;if((c|0)!=1){break Zb}break s}f=D()|0;C()|0;break j}if((k[d+456|0]|k[d+457|0]<<8)>>>0>=6562){break yb}j[114630]=0;E(479,a+1074308|0,38)|0;c=j[114630];j[114630]=0;if((c|0)==1){break s}break yb;case 4:j[114630]=0;c=E(2,d+56|0,14294)|0;e=j[114630];j[114630]=0;_b:{$b:{ac:{bc:{cc:{if((e|0)!=1){j[114630]=0;F(219,d+208|0,c|0);e=j[114630];j[114630]=0;if((e|0)==1){break cc}j[d+176>>2]=k[d+457|0]&15;e=k[d+456|0];j[114630]=0;j[d+144>>2]=e;F(660,d+192|0,d+144|0);e=j[114630];j[114630]=0;if((e|0)==1){break bc}j[114630]=0;L(645,d+224|0,d+208|0,d+176|0,d+192|0);e=j[114630];j[114630]=0;if((e|0)==1){break ac}ob(r,d+224|0);gb(d+224|0);gb(d+192|0);qb(d+208|0);gb(c);break yb}f=D()|0;C()|0;break j}f=D()|0;C()|0;break _b}f=D()|0;C()|0;break $b}f=D()|0;C()|0;gb(d+192|0)}qb(d+208|0)}gb(c);break j;case 6:j[114630]=0;c=E(2,d+224|0,14125)|0;e=j[114630];j[114630]=0;if((e|0)!=1){ob(r,c);gb(c);break yb}f=D()|0;C()|0;break j;case 7:if(!((k[d+456|0]|k[d+457|0]<<8)!=32767|(k[d+458|0]|k[d+459|0]<<8)!=533)){j[114630]=0;c=E(2,d+224|0,14305)|0;e=j[114630];j[114630]=0;if((e|0)!=1){ob(r,c);gb(c);break yb}f=D()|0;C()|0;break j}j[114630]=0;c=E(2,d+40|0,14314)|0;e=j[114630];j[114630]=0;dc:{ec:{fc:{if((e|0)!=1){j[114630]=0;F(219,d+208|0,c|0);e=j[114630];j[114630]=0;if((e|0)==1){break fc}j[d+192>>2]=k[d+457|0]&15;j[d+176>>2]=(k[d+456|0]|k[d+457|0]<<8)>>>4&15;e=k[d+456|0]|k[d+457|0]<<8;j[114630]=0;j[d+144>>2]=e&15;V(239,d+224|0,d+208|0,d+192|0,d+176|0,d+144|0);e=j[114630];j[114630]=0;if((e|0)==1){break ec}ob(r,d+224|0);gb(d+224|0);qb(d+208|0);gb(c);break yb}f=D()|0;C()|0;break j}f=D()|0;C()|0;break dc}f=D()|0;C()|0;qb(d+208|0)}gb(c);break j;case 13:break Ib;default:break yb}}j[114630]=0;c=E(2,d+224|0,14329)|0;e=j[114630];j[114630]=0;if((e|0)==1){break u}ob(r,c);gb(c)}gc:{if(j[a+480180>>2]!=16777216|(k[d+456|0]|k[d+457|0]<<8)>>>0<2186){break gc}j[114630]=0;c=E(256,b|0,y|0)|0;e=j[114630];j[114630]=0;if((e|0)==1){break s}if(!c){break gc}c=k[d+456|0]|k[d+457|0]<<8;j[114630]=0;I(664,a|0,b|0,c|0);b=j[114630];j[114630]=0;if((b|0)==1){break s}}c=j[a+480180>>2];hc:{if((c|0)==16777216){j[114630]=0;E(2,d+224|0,14336)|0;b=j[114630];j[114630]=0;if((b|0)!=1){break hc}f=D()|0;C()|0;break j}j[114630]=0;b=E(2,d+24|0,14272)|0;e=j[114630];j[114630]=0;if((e|0)==1){break B}j[114630]=0;F(219,d+208|0,b|0);e=j[114630];j[114630]=0;if((e|0)==1){break A}j[d+176>>2]=k[d+459|0];e=k[d+458|0];j[114630]=0;j[d+144>>2]=e;F(660,d+192|0,d+144|0);e=j[114630];j[114630]=0;if((e|0)==1){break z}j[114630]=0;L(645,d+224|0,d+208|0,d+176|0,d+192|0);e=j[114630];j[114630]=0;if((e|0)==1){break y}}ob(a+1304436|0,d+224|0);gb(d+224|0);if((c|0)!=16777216){gb(d+192|0);qb(d+208|0);gb(d+24|0)}ic:{if(j[a+480180>>2]==16777216){j[114630]=0;E(2,d+224|0,14349)|0;b=j[114630];j[114630]=0;if((b|0)!=1){break ic}break t}j[114630]=0;E(2,d+224|0,14354)|0;b=j[114630];j[114630]=0;if((b|0)==1){break t}}ob(a+1304448|0,d+224|0);gb(d+224|0);ob(a+1304460|0,r);j[a+1304496>>2]=j[a+1074304>>2]?7:4;jb(d+312|0);jb(A);f=1}ji(t);ji(w);ji(x);break d}f=D()|0;C()|0;break j}f=D()|0;C()|0;break w}f=D()|0;C()|0;break x}f=D()|0;C()|0;gb(d+192|0)}qb(d+208|0)}gb(b);break j}f=D()|0;C()|0;break j}f=D()|0;C()|0;break j}f=D()|0;C()|0;break j}f=D()|0;C()|0;break j}f=D()|0;C()|0;Od(g);break p}f=D()|0;C()|0}jb(d+224|0);break j}f=D()|0;C()|0;break j}f=D()|0;C()|0;break j}f=D()|0;C()|0;break j}f=D()|0;C()|0;break j}f=D()|0;C()|0}jb(d+312|0)}jb(A);break g}f=D()|0;C()|0}ji(t);ji(w);ji(x);break a}f=D()|0;C()|0;break a}f=D()|0;C()|0;break a}gb(r)}Za=d+608|0;return f|0}f=D()|0;C()|0}gb(r);G(f|0);z()}function oCa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,n=0,o=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,M=0,O=0,Q=0,R=0,S=0,T=0,W=0,X=0,Y=0;e=Za-1584|0;Za=e;rc(b);a:{b:{if(!kf(b,e+1576|0)){break b}if(!bP(e+1576|0)){break b}if(!c){f=1;break b}h[e+1575|0]=k[e+1576|3];d=e+1576|4;g=k[d|0]|k[d+1|0]<<8|(k[d+2|0]<<16|k[d+3|0]<<24);d=-1;if(k[e+1575|0]>=5){d=hf(b);if(!yb(b,d)){break b}}Q=bz(e+1560|0,g);n=j[Q>>2];j[114630]=0;g=K(830,b|0,n|0,g|0)|0;n=j[114630];j[114630]=0;c:{d:{e:{f:{g:{h:{i:{j:{k:{l:{m:{n:{o:{p:{q:{r:{s:{t:{u:{v:{w:{x:{y:{if((n|0)==1){break y}if(!g){break u}if(k[e+1575|0]>=5){j[114630]=0;E(256,b|0,d+12|0)|0;d=j[114630];j[114630]=0;if((d|0)==1){break y}}j[114630]=0;F(447,a|0,0);d=j[114630];j[114630]=0;if((d|0)==1){break y}j[114630]=0;N(476,a|0);d=j[114630];j[114630]=0;if((d|0)==1){break y}j[114630]=0;F(831,e+1536|0,Q|0);g=j[114630];j[114630]=0;d=a;z:{A:{B:{C:{if((g|0)==1){break C}j[114630]=0;r=K(832,e+1544|0,e+1536|0,0)|0;g=j[114630];j[114630]=0;if((g|0)==1){break C}j[114630]=0;K(597,r|0,a+1304400|0,-1)|0;g=j[114630];j[114630]=0;if((g|0)==1){break B}j[114630]=0;K(597,r|0,a+1304424|0,-1)|0;g=j[114630];j[114630]=0;if((g|0)==1){break B}j[114630]=0;g=E(833,r|0,e+1112|0)|0;n=j[114630];j[114630]=0;if((n|0)==1){break e}if(!g|!k[e+1112|0]|h[e+1112|0]<0){break v}g=e+1121|0;if((k[g|0]|k[g+1|0]<<8)>>>0>255){break v}n=e+1123|0;if((k[n|0]|k[n+1|0]<<8)>>>0>3999){break v}i[a+480188>>1]=k[e+1112|0];q=a+484360|0;o=e+1112|3;Fe(Eb(q),k[o|0]|k[o+1|0]<<8);i[a+480192>>1]=k[g|0]|k[g+1|0]<<8;i[a+480190>>1]=k[n|0]|k[n+1|0]<<8;g=e+1125|0;if(k[g|0]){break A}g=6;break z}d=D()|0;C()|0;break c}d=D()|0;C()|0;break d}g=k[g|0]}j[d+480196>>2]=g;d=a;n=e+1126|0;g=125;D:{if(!k[n|0]){break D}g=k[n|0]}j[d+480204>>2]=p(g,1e4);v=e+1127|0;E:{if(h[v+1|0]&1){j[114630]=0;F(621,a|0,32);d=j[114630];j[114630]=0;if((d|0)!=1){break E}break e}if(k[v|0]&2){j[114630]=0;F(621,a|0,2);d=j[114630];j[114630]=0;if((d|0)==1){break e}break E}if(k[v|0]&128){j[114630]=0;F(621,a|0,1);d=j[114630];j[114630]=0;if((d|0)==1){break e}break E}if(k[v|0]&8){j[114630]=0;F(621,a|0,16);d=j[114630];j[114630]=0;if((d|0)==1){break e}break E}j[114630]=0;F(621,a|0,4);d=j[114630];j[114630]=0;if((d|0)==1){break e}}if(h[v|0]&1){j[a+480208>>2]=j[a+480208>>2]|16}if(!(!(k[v|0]&16)|j[a+480180>>2]!=2)){j[a+480208>>2]=j[a+480208>>2]|65536}if(!(!(k[v|0]&4)|j[a+480180>>2]!=2)){j[a+480208>>2]=j[a+480208>>2]|2}if(!(k[v+1|0]&8|j[a+480180>>2]!=32)){j[a+480208>>2]=j[a+480208>>2]|4}if(!(k[v+1|0]&4|j[a+480180>>2]!=32)){j[a+480208>>2]=j[a+480208>>2]|8}if(k[v+2|0]&32){j[a+480208>>2]=j[a+480208>>2]|32768}if(k[v+2|0]&8){j[114630]=0;K(478,a+1074308|0,5,1)|0;d=j[114630];j[114630]=0;if((d|0)==1){break e}}F:{d=j[a+480180>>2];G:{if((d|0)!=2){if((d|0)!=32){break G}d=k[e+1131|0];j[114630]=0;h[e+208|0]=d;h[e+136|0]=128;d=E(391,e+208|0,e+136|0)|0;g=j[114630];j[114630]=0;if((g|0)==1){break x}j[a+480200>>2]=k[d|0]<<1;break G}d=k[e+1131|0];j[114630]=0;h[e+208|0]=d;h[e+136|0]=64;d=E(391,e+208|0,e+136|0)|0;g=j[114630];j[114630]=0;if((g|0)==1){break F}j[a+480200>>2]=k[d|0]<<2}T=a+480188|0;n=e+1133|0;g=h[n|0];d=a;if(h[n|0]<=-1){g=g+52|0}else{S=xv(+(g|0)*.15500000000000003);H:{if(S<4294967296&S>=0){g=~~S>>>0;break H}g=0}g=g+51|0}j[d+480228>>2]=g;j[114630]=0;i[e+208>>1]=64;d=E(477,T|0,e+208|0)|0;g=j[114630];j[114630]=0;if((g|0)!=1){I:{g=l[d>>1];if(g){while(1){d=j[a+480180>>2];if((d|0)==32){d=k[(e+f|0)+1134|0];j[114630]=0;h[e+208|0]=d;h[e+136|0]=64;d=E(391,e+208|0,e+136|0)|0;n=j[114630];j[114630]=0;if((n|0)==1){break I}i[((f<<5)+a|0)+480286>>1]=k[d|0];d=j[a+480180>>2]}J:{if((d|0)==4){break J}d=(e+f|0)+1198|0;if(k[d|0]==127){j[((f<<5)+a|0)+480280>>2]=256;break J}if(k[d|0]==255){i[((f<<5)+a|0)+480284>>1]=256;break J}i[((f<<5)+a|0)+480284>>1]=k[d|0]}f=f+1|0;if((g|0)!=(f|0)){continue}break}}d=0;f=0;o=0;while(1){f=k[(e+o|0)+1262|0]!=0|f;o=o+1|0;if((o|0)!=16){continue}break}while(1){f=k[((d<<1)+e|0)+1279|0]!=0|f;d=d+1|0;if((d|0)!=128){continue}break}if(f&1){f=0;while(1){K:{d=(e+f|0)+1262|0;if(k[d|0]){j[114630]=0;F(508,e+136|0,15167);g=j[114630];j[114630]=0;L:{M:{N:{O:{P:{if((g|0)!=1){d=k[d|0];j[114630]=0;j[e+160>>2]=d-1;F(834,e+1096|0,e+160|0);d=j[114630];j[114630]=0;if((d|0)==1){break P}j[114630]=0;I(510,e+208|0,e+136|0,e+1096|0);d=j[114630];j[114630]=0;if((d|0)==1){break O}j[114630]=0;F(511,e+1080|0,((f<<5)+a|0)+901692|0);d=j[114630];j[114630]=0;if((d|0)==1){break N}j[114630]=0;E(470,e+1080|0,e+208|0)|0;d=j[114630];j[114630]=0;if((d|0)==1){break N}gb(e+208|0);gb(e+1096|0);qb(e+136|0);break K}d=D()|0;C()|0;break d}d=D()|0;C()|0;break L}d=D()|0;C()|0;break M}d=D()|0;C()|0;gb(e+208|0)}gb(e+1096|0)}qb(e+136|0);break d}j[114630]=0;g=E(85,e+208|0,15175)|0;d=j[114630];j[114630]=0;Q:{if((d|0)!=1){j[114630]=0;F(511,e+136|0,((f<<5)+a|0)+901692|0);d=j[114630];j[114630]=0;if((d|0)==1){break Q}j[114630]=0;E(470,e+136|0,g|0)|0;d=j[114630];j[114630]=0;if((d|0)==1){break Q}gb(g);break K}d=D()|0;C()|0;break d}d=D()|0;C()|0;gb(g);break d}f=f+1|0;if((f|0)!=16){continue}break}f=0;while(1){d=(e+1112|0)+(f<<1)|0;g=d;R:{if(k[d+167|0]){j[114630]=0;F(508,e+136|0,15176);n=j[114630];j[114630]=0;S:{T:{U:{V:{W:{X:{Y:{if((n|0)!=1){g=k[g+167|0];j[114630]=0;j[e+112>>2]=g-1;F(834,e+1096|0,e+112|0);g=j[114630];j[114630]=0;if((g|0)==1){break Y}d=k[d+166|0];j[114630]=0;h[e+1064|0]=d;F(835,e+1080|0,e+1064|0);d=j[114630];j[114630]=0;if((d|0)==1){break X}j[114630]=0;L(836,e+208|0,e+136|0,e+1096|0,e+1080|0);d=j[114630];j[114630]=0;if((d|0)==1){break W}j[114630]=0;F(511,e+160|0,((f<<5)+a|0)+902204|0);d=j[114630];j[114630]=0;if((d|0)==1){break V}j[114630]=0;E(470,e+160|0,e+208|0)|0;d=j[114630];j[114630]=0;if((d|0)==1){break V}gb(e+208|0);gb(e+1080|0);gb(e+1096|0);qb(e+136|0);break R}d=D()|0;C()|0;break d}d=D()|0;C()|0;break S}d=D()|0;C()|0;break T}d=D()|0;C()|0;break U}d=D()|0;C()|0;gb(e+208|0)}gb(e+1080|0)}gb(e+1096|0)}qb(e+136|0);break d}j[114630]=0;g=E(85,e+208|0,15175)|0;d=j[114630];j[114630]=0;Z:{if((d|0)!=1){j[114630]=0;F(511,e+136|0,((f<<5)+a|0)+902204|0);d=j[114630];j[114630]=0;if((d|0)==1){break Z}j[114630]=0;E(470,e+136|0,g|0)|0;d=j[114630];j[114630]=0;if((d|0)==1){break Z}gb(g);break R}d=D()|0;C()|0;break d}d=D()|0;C()|0;gb(g);break d}f=f+1|0;if((f|0)!=128){continue}break}}d=Eb(q);g=e+1112|1;g=k[g|0]|k[g+1|0]<<8;j[114630]=0;U(581,d|0,r|0,g|0,255,254)|0;d=j[114630];j[114630]=0;_:{$:{aa:{ba:{ca:{da:{if((d|0)!=1){g=e+1112|5;d=k[g|0]|k[g+1|0]<<8;n=k[e+1112|0];j[114630]=0;I(341,e+1096|0,r|0,p(d,n)<<1);d=j[114630];j[114630]=0;if((d|0)==1){break da}d=k[g|0]|k[g+1|0]<<8;j[114630]=0;I(341,e+1080|0,r|0,d<<1);d=j[114630];j[114630]=0;if((d|0)==1){break ca}d=e+1112|7;d=k[d|0]|k[d+1|0]<<8;j[114630]=0;O=E(395,e+1064|0,d|0)|0;d=j[114630];j[114630]=0;if((d|0)==1){break ba}X=e,Y=Lb(O),j[X+136>>2]=Y;X=e,Y=Mb(O),j[X+160>>2]=Y;if(rb(e+136|0,e+160|0)){while(1){d=j[e+136>>2];j[114630]=0;n=H(390,r|0)|0;f=j[114630];j[114630]=0;if((f|0)==1){break aa}j[114630]=0;I(341,e+208|0,r|0,n|0);n=j[114630];j[114630]=0;if((n|0)==1){break $}Ed(d,e+208|0);jb(e+208|0);yf(e+136|0);if(rb(e+136|0,e+160|0)){continue}break}}d=j[a+480180>>2];q=1;s=c&1;if(!s){break _}n=k[g|0]|k[g+1|0]<<8;j[114630]=0;F(401,a+484344|0,n|0);n=j[114630];j[114630]=0;if((n|0)!=1){break _}d=D()|0;C()|0;break h}d=D()|0;C()|0;break d}d=D()|0;C()|0;break d}d=D()|0;C()|0;break f}d=D()|0;C()|0;break g}d=D()|0;C()|0;break h}d=D()|0;C()|0;break h}ea:{fa:{ga:{ha:{ia:{ja:{if(k[g|0]|k[g+1|0]<<8){x=(d|0)==16?14:(d|0)==32?1:13;y=a+484344|0;while(1){j[114630]=0;d=H(357,e+1080|0)|0;n=j[114630];j[114630]=0;if((n|0)==1){break ea}j[e+136>>2]=d;ka:{if(!s){break ka}j[114630]=0;d=K(402,y|0,u&65535,d|0)|0;n=j[114630];j[114630]=0;if((n|0)==1){break ea}if(!d){break ka}w=0;if(!k[e+1112|0]){break ka}while(1){j[114630]=0;d=H(357,e+1096|0)|0;n=j[114630];j[114630]=0;if((n|0)==1){break fa}la:{if(Zc(O)>>>0<=d>>>0){break la}B=$b(O,d);rc(B);d=Hb(y,u);j[114630]=0;f=K(471,d|0,0,w&65535)|0;d=j[114630];j[114630]=0;if((d|0)==1){break i}n=0;if(!j[e+136>>2]){break la}while(1){j[114630]=0;A=H(387,B|0)|0;d=j[114630];j[114630]=0;ma:{na:{if((d|0)!=1){if(!A){break la}th(e+208|0);o=0;M=A&15;if(M){break na}break ma}d=D()|0;C()|0;break h}while(1){oa:{j[114630]=0;E(837,B|0,e+160|0)|0;d=j[114630];j[114630]=0;if((d|0)==1){break oa}pa:{qa:{ra:{sa:{ta:{ua:{va:{wa:{xa:{ya:{za:{Aa:{Ba:{Ca:{Da:{Ea:{Fa:{Ga:{Ha:{Ia:{Ja:{d=k[e+160|0];switch(d-1|0){case 2:case 3:case 4:case 7:case 8:case 9:case 11:case 12:case 13:case 16:case 18:case 21:case 22:case 23:case 24:case 25:case 27:case 32:break ra;case 33:break va;case 30:case 31:break wa;case 29:break xa;case 28:break ya;case 26:break za;case 19:case 20:break Aa;case 17:break Ba;case 15:break Ca;case 14:break Da;case 10:break Ea;case 6:break Fa;case 5:break Ga;case 1:break Ha;case 0:break Ia;default:break Ja}}switch(d-48|0){case 4:break sa;case 1:case 2:break ta;case 0:break ua;default:break ra}}d=k[e+161|0];Ka:{if(d>>>0<=119){h[e+208|0]=d+x;break Ka}La:{switch(d-254|0){case 1:h[e+208|0]=255;break Ka;case 0:h[e+208|0]=254;break Ka;default:break La}}h[e+208|0]=253}j[114630]=0;d=H(611,e+208|0)|0;t=j[114630];j[114630]=0;if((t|0)==1){break oa}q=d&q;break pa}h[e+209|0]=k[e+161|0]+1;break pa}Ma:{if(k[e+210|0]){break Ma}d=j[a+480180>>2];if((d|0)!=32){if((d|0)!=4){break Ma}d=k[e+161|0];if(d&15){break Ma}h[e+210|0]=11;h[e+212|0]=d>>>4;break pa}d=0;t=k[e+161|0];while(1){if((t|0)==k[d+20832|0]){h[e+212|0]=d;h[e+210|0]=11;break pa}d=d+1|0;if((d|0)!=10){continue}break}}h[e+211|0]=4;h[e+213|0]=k[e+161|0];break pa}d=k[e+161|0];if(!(k[e+210|0]|d>>>0>9|j[a+480180>>2]!=32)){h[e+212|0]=d;h[e+210|0]=8;break pa}h[e+213|0]=d;h[e+211|0]=5;break pa}Na:{if(k[e+210|0]){break Na}Oa:{d=j[a+480180>>2];if((d|0)!=4){if((d|0)!=32){break Na}d=k[e+161|0];if((d|0)!=255){break Oa}h[e+212|0]=64;h[e+210|0]=2;break pa}d=k[e+161|0];if(d&15){break Na}break qa}if(!(d&3)){break qa}}h[e+211|0]=9;h[e+213|0]=k[e+161|0];break pa}d=k[e+161|0];if(!(k[e+210|0]|d>>>0>64|j[a+480180>>2]==1)){h[e+212|0]=d;h[e+210|0]=1;break pa}h[e+213|0]=d;h[e+211|0]=13;break pa}h[e+211|0]=14;d=k[e+161|0];h[e+213|0]=d;if(j[a+480180>>2]==32){break pa}h[e+213|0]=p((d&240)>>>4|0,10)+(d&15);break pa}d=k[e+161|0];h[e+213|0]=d;if(d>>>0<=31){h[e+211|0]=16;break pa}h[e+211|0]=17;break pa}t=k[e+161|0];if(t>>>0>=16){h[e+212|0]=t>>>4;h[e+210|0]=(d|0)==20?3:5;break pa}h[e+212|0]=t;h[e+210|0]=(d|0)==20?4:6;break pa}d=k[e+161|0];if(d>>>0>=16){h[e+210|0]=10;h[e+212|0]=d>>>4;break pa}h[e+212|0]=d;h[e+210|0]=9;break pa}h[e+211|0]=28;h[e+213|0]=k[e+161|0]|16;break pa}h[e+211|0]=28;h[e+213|0]=k[e+161|0]|32;break pa}h[e+212|0]=k[e+161|0];h[e+210|0]=k[d+15200|0];break pa}h[e+213|0]=k[e+161|0];d=k[e+211|0];h[e+211|0]=(d|0)==4?6:(d|0)==5?7:11;break pa}d=k[e+161|0];h[e+212|0]=(d>>>0)%10;if(d>>>0<=9){h[e+210|0]=5;break pa}if(d>>>0<=19){h[e+210|0]=6;break pa}if(d>>>0<=29){h[e+210|0]=3;break pa}if(d>>>0>39){break pa}h[e+210|0]=4;break pa}h[e+212|0]=k[e+161|0];h[e+210|0]=k[d+15200|0];break pa}d=k[e+161|0]+33|0;if((d&255)>>>0>9){break pa}h[e+212|0]=d;h[e+210|0]=15;break pa}if(d>>>0>55){break pa}h[e+213|0]=k[e+161|0];h[e+211|0]=k[d+15200|0];break pa}h[e+210|0]=2;h[e+212|0]=d>>>2}o=o+1|0;if(M>>>0>(o&255)>>>0){continue}break ma}break}d=D()|0;C()|0;break h}j[114630]=0;j[e+160>>2]=(A>>>4|0)+n;d=E(464,e+160|0,e+136|0)|0;o=j[114630];j[114630]=0;if((o|0)==1){break ja}d=j[d>>2];if(d>>>0>n>>>0){while(1){o=j[e+208>>2];h[f|0]=o;h[f+1|0]=o>>>8;h[f+2|0]=o>>>16;h[f+3|0]=o>>>24;o=l[e+212>>1];h[f+4|0]=o;h[f+5|0]=o>>>8;f=p(k[e+1112|0],6)+f|0;n=n+1|0;if((d|0)!=(n|0)){continue}break}n=d}if(m[e+136>>2]>n>>>0){continue}break}}w=w+1|0;if(k[e+1112|0]>(w&65535)>>>0){continue}break}}u=u+1|0;if(u>>>0<(k[g|0]|k[g+1|0]<<8)>>>0){continue}break}}if(!((q^-1|l[a+480188>>1]!=4)&1|j[a+480180>>2]!=1)){j[a+480208>>2]=j[a+480208>>2]|8454144}if(j[a+480180>>2]!=4){break ia}o=0;break ha}d=D()|0;C()|0;break h}o=!((k[v|0]|k[v+1|0]<<8|(k[v+2|0]<<16|k[v+3|0]<<24))&512);d=0;if(j[a+480180>>2]!=4){break ga}}d=l[a+480192>>1]}j[114630]=0;A=E(838,e+1048|0,d|0)|0;d=j[114630];j[114630]=0;if((d|0)!=1){Pa:{Qa:{Ra:{if(l[a+480192>>1]){n=1;d=1;while(1){Sa:{Ta:{Ua:{if(!o){j[114630]=0;f=K(454,a|0,d&65535,0)|0;g=j[114630];j[114630]=0;if((g|0)==1){break Ua}if(f){break Ta}}while(1){j[114630]=0;g=H(387,r|0)|0;n=j[114630];j[114630]=0;if((n|0)==1){break k}if(g){continue}break}if(k[e+1575|0]>=5){while(1){j[114630]=0;g=H(387,r|0)|0;n=j[114630];j[114630]=0;if((n|0)==1){d=D()|0;C()|0;break j}if(g){continue}break}}j[114630]=0;E(338,r|0,826)|0;g=j[114630];j[114630]=0;if((g|0)!=1){break Sa}}d=D()|0;C()|0;break j}g=Cb(e+136|0);j[114630]=0;K(597,r|0,g|0,-1)|0;q=j[114630];j[114630]=0;if((q|0)==1){break Ra}j[114630]=0;E(369,f+492|0,g|0)|0;q=j[114630];j[114630]=0;if((q|0)==1){break Ra}Va:{if(k[e+1575|0]<5){break Va}j[114630]=0;K(597,r|0,g|0,-1)|0;q=j[114630];j[114630]=0;if((q|0)==1){break Ra}j[114630]=0;E(369,f+524|0,g|0)|0;q=j[114630];j[114630]=0;if((q|0)!=1){break Va}break Ra}j[114630]=0;q=E(839,r|0,e+208|0)|0;u=j[114630];j[114630]=0;if((u|0)==1){break Ra}if(!q){break Qa}q=j[a+480180>>2];j[114630]=0;I(840,e+208|0,f|0,q|0);f=j[114630];j[114630]=0;if((f|0)==1){break Ra}if(j[a+480180>>2]==4){n=xb(A,n-1|0);f=l[e+1010>>1]|l[e+1012>>1]<<16;h[n|0]=f;h[n+1|0]=f>>>8;h[n+2|0]=f>>>16;h[n+3|0]=f>>>24}gb(g)}d=d+1|0;n=d&65535;if(n>>>0<=l[a+480192>>1]){continue}break}}if(!o){break Pa}i[a+480192>>1]=0;break Pa}d=D()|0;C()|0;gb(g);break j}gb(g)}d=l[a+480190>>1];j[114630]=0;B=E(841,e+192|0,d|0)|0;d=j[114630];j[114630]=0;w=1;Wa:{Xa:{if((d|0)!=1){w=k[e+1575|0]<=4?!(h[v|0]&1):w;if(l[a+480190>>1]){break Xa}u=c&2;g=0;break Wa}d=D()|0;C()|0;break j}u=c&2;o=1;d=0;n=1;while(1){g=d;y=Cb(e+176|0);j[114630]=0;K(597,r|0,y|0,-1)|0;c=j[114630];j[114630]=0;Ya:{Za:{_a:{$a:{ab:{if((c|0)==1){break ab}j[114630]=0;E(369,((o<<5)+a|0)+946300|0,y|0)|0;c=j[114630];j[114630]=0;if((c|0)==1){break ab}s=p(o,104);q=s+a|0;if(k[e+1575|0]<5){break $a}j[114630]=0;K(597,r|0,y|0,-1)|0;c=j[114630];j[114630]=0;if((c|0)==1){break ab}j[114630]=0;E(370,q+484423|0,y|0)|0;c=j[114630];j[114630]=0;if((c|0)!=1){break $a}}d=D()|0;C()|0;break _a}j[114630]=0;c=E(842,r|0,e+208|0)|0;d=j[114630];j[114630]=0;bb:{cb:{db:{eb:{fb:{gb:{hb:{if((d|0)==1){break hb}if(!c){break gb}c=j[a+480180>>2];j[114630]=0;f=q+484380|0;L(843,e+208|0,f|0,c|0,w|0);c=j[114630];j[114630]=0;if((c|0)==1){break hb}d=0;ib:{if(((k[e+228|0]|k[e+229|0]<<8)&61440)!=28672|k[e+1575|0]<5){break ib}j[114630]=0;d=H(844,r|0)|0;c=j[114630];j[114630]=0;if((c|0)!=1){break ib}d=D()|0;C()|0;break _a}if(!u){break Za}M=k[e+228|0]|k[e+229|0]<<8;t=M&61440;if(!(t|(k[e+243|0]|k[e+244|0]<<8|(k[e+245|0]<<16|k[e+246|0]<<24)))){c=Kc(e+136|0,(k[e+228|0]|k[e+229|0]<<8)&1?16:8,(k[e+228|0]|k[e+229|0]<<8)&1024?3:1,0,0);j[114630]=0;K(400,c|0,f|0,b|0)|0;c=j[114630];j[114630]=0;if((c|0)!=1){break Za}d=D()|0;C()|0;break _a}if(!(((k[e+243|0]|k[e+244|0]<<8|(k[e+245|0]<<16|k[e+246|0]<<24))+o|0)<1|(k[e+243|0]|k[e+244|0]<<8|(k[e+245|0]<<16|k[e+246|0]<<24))>-1)){d=a+484380|0;t=p((k[e+243|0]|k[e+244|0]<<8|(k[e+245|0]<<16|k[e+246|0]<<24))+o|0,104);c=d+t|0;jc(f,j[c>>2]);d=d+s|0;o=l[d+34>>1]&-2|i[c+34>>1]&1;i[d+34>>1]=o;i[d+34>>1]=l[c+34>>1]&64|o&65471;if(!ke(c)){break Za}j[114630]=0;c=H(465,f|0)|0;d=j[114630];j[114630]=0;if((d|0)!=1){if(!c){break Za}c=j[q+484400>>2];j[114630]=0;c=H(466,c|0)|0;d=j[114630];j[114630]=0;if((d|0)==1){break a}d=j[(a+t|0)+484400>>2];j[114630]=0;d=H(845,d|0)|0;o=j[114630];j[114630]=0;if((o|0)==1){break a}Vb(c,d,jk(f));break Za}d=D()|0;C()|0;break _a}if((k[e+243|0]|k[e+244|0]<<8|(k[e+245|0]<<16|k[e+246|0]<<24))<1){break Za}if(h[e+228|0]&1){c=q+484414|0;i[c>>1]=l[c>>1]|1}if(k[e+229|0]&4){c=q+484414|0;i[c>>1]=l[c>>1]|64}c=k[e+243|0]|k[e+244|0]<<8|(k[e+245|0]<<16|k[e+246|0]<<24);j[114630]=0;I(341,e+160|0,b|0,c|0);s=j[114630];j[114630]=0;jb:{kb:{W=e;lb:{mb:{if((s|0)!=1){s=be(f);c=(t|0)==16384;if((t|0)!=8192?!c:0){break kb}j[114630]=0;x=H(255,e+160|0)|0;R=j[114630];j[114630]=0;if((R|0)==1){break jb}j[e+136>>2]=x;R=j[e+136>>2];x=4/(s>>>0)|0;if(R>>>0>4294967295/(x>>>0)>>>0){break mb}x=p(x,R);break lb}d=D()|0;C()|0;break _a}x=-1}j[W+136>>2]=x;jc(f,x);if(!c){if((t|0)!=8192){break kb}j[114630]=0;c=H(465,f|0)|0;d=j[114630];j[114630]=0;if((d|0)==1){break cb}if(!c){break eb}if(h[e+228|0]&1){c=j[q+484400>>2];d=j[f>>2];j[114630]=0;L(846,e+160|0,c|0,d|0,s|0);c=j[114630];j[114630]=0;d=g;if((c|0)!=1){break db}break cb}c=j[q+484400>>2];d=j[f>>2];j[114630]=0;L(847,e+160|0,c|0,d|0,s|0);c=j[114630];j[114630]=0;d=g;if((c|0)==1){break cb}break db}j[114630]=0;c=H(465,f|0)|0;d=j[114630];j[114630]=0;if((d|0)==1){break cb}if(!c){break eb}if(h[e+228|0]&1){c=j[q+484400>>2];d=j[f>>2];j[114630]=0;L(848,e+160|0,c|0,d|0,s|0);c=j[114630];j[114630]=0;d=g;if((c|0)==1){break cb}break db}c=j[q+484400>>2];d=j[f>>2];j[114630]=0;L(849,e+160|0,c|0,d|0,s|0);c=j[114630];j[114630]=0;d=g;if((c|0)==1){break cb}break db}if((M&45056)==12288){c=_O(e+136|0,e+160|0,k[e+247|0]|k[e+248|0]<<8,d);d=yy(B,o-1|0);Ed(d,c);j[d+16>>2]=j[c+16>>2];jb(c);break eb}if((t|0)!=32768){d=1;if((t|0)!=4096){break db}c=He(e+136|0,e+160|0);j[114630]=0;E(850,e+128|0,e+160|0)|0;d=j[114630];j[114630]=0;if((d|0)!=1){nb:{if(!k[e+133|0]){break nb}d=l[e+130>>1]<<1;if((d&65535)>>>0>(k[e+247|0]|k[e+248|0]<<8)>>>0){break nb}d=(k[e+247|0]|k[e+248|0]<<8)-d|0;h[e+247|0]=d;h[e+248|0]=d>>>8;j[114630]=0;E(256,e+160|0,l[e+128>>1])|0;d=j[114630];j[114630]=0;if((d|0)==1){break fb}j[114630]=0;d=H(540,e+160|0)|0;o=j[114630];j[114630]=0;if((o|0)==1){break fb}j[114630]=0;I(341,e+112|0,e+160|0,d|0);d=j[114630];j[114630]=0;if((d|0)==1){break fb}Ed(c,e+112|0);jb(e+112|0)}j[114630]=0;d=n&65535;o=U(851,a|0,d|0,c|0,1,1)|0;t=j[114630];j[114630]=0;if((t|0)==1){break fb}ob:{if(!o){j[114630]=0;o=P(852,a|0,d|0,c|0,1)|0;d=j[114630];j[114630]=0;if((d|0)==1){break fb}d=1;if(!o){break ob}}pb:{if(!(k[e+247|0]|k[e+248|0]<<8)){break pb}d=k[e+247|0]|k[e+248|0]<<8;if(jk(f)>>>0<=d>>>0){break pb}d=k[e+247|0]|k[e+248|0]<<8;o=Bn(f);q=q+484400|0;t=j[q>>2];j[114630]=0;t=H(466,t|0)|0;s=j[114630];j[114630]=0;if((s|0)==1){break a}q=j[q>>2];j[114630]=0;q=H(466,q|0)|0;s=j[114630];j[114630]=0;if((s|0)==1){break a}Ci(t,q+(k[e+247|0]|k[e+248|0]<<8)|0,jk(f)-(k[e+247|0]|k[e+248|0]<<8)|0);j[f>>2]=j[f>>2]-((d>>>0)/(o>>>0)|0)}d=j[e+216>>2];j[e+108>>2]=d;j[e+12>>2]=d;if(m[f>>2]>(k[e+12|0]|k[e+13|0]<<8|(k[e+14|0]<<16|k[e+15|0]<<24))>>>0){j[f>>2]=k[e+12|0]|k[e+13|0]<<8|(k[e+14|0]<<16|k[e+15|0]<<24)}d=g}jb(c);break db}break fb}j[114630]=0;c=E(640,e+160|0,e+136|0)|0;d=j[114630];j[114630]=0;if((d|0)!=1){if(!c){break eb}j[114630]=0;j[e+24>>2]=j[e+144>>2];c=j[e+140>>2];j[e+16>>2]=j[e+136>>2];j[e+20>>2]=c;I(641,f|0,1,e+16|0);c=j[114630];j[114630]=0;if((c|0)!=1){break eb}}d=D()|0;C()|0;break bb}d=D()|0;C()|0;break bb}d=D()|0;C()|0;break _a}gb(y);break Wa}d=D()|0;C()|0;jb(c);break bb}d=g}jb(e+160|0);break Ya}d=D()|0;C()|0}jb(e+160|0)}gb(y);break l}d=g}gb(y);n=n+1|0;o=n&65535;if(o>>>0<=l[a+480190>>1]){continue}break}g=d}if(!(!u|!l[a+480190>>1])){d=1;n=1;while(1){c=yy(B,d-1|0);j[114630]=0;b=H(337,c|0)|0;f=j[114630];j[114630]=0;qb:{rb:{sb:{if((f|0)!=1){if(!b){break qb}tb:{ub:{vb:{b=l[c+18>>1];wb:{if(!b){break wb}b=b+n&65535;if(!b){break wb}if(b>>>0<=l[a+480190>>1]){break vb}}j[114630]=0;H(255,c|0)|0;b=j[114630];j[114630]=0;if((b|0)!=1){break ub}break m}b=yy(B,b-1|0);f=l[c+16>>1];rc(b);o=l[c+16>>1];j[114630]=0;o=E(258,b|0,o|0)|0;q=j[114630];j[114630]=0;if((q|0)==1){break m}if(!o){break qb}j[114630]=0;j[e+136>>2]=0;j[e+160>>2]=0;I(853,e+208|0,b|0,f|0);f=j[114630];j[114630]=0;xb:{if((f|0)!=1){j[114630]=0;f=H(412,e+208|0)|0;o=j[114630];j[114630]=0;if((o|0)==1){break xb}j[114630]=0;f=H(854,f|0)|0;o=j[114630];j[114630]=0;if((o|0)==1){break xb}o=j[e+208>>2];j[114630]=0;o=H(855,o|0)|0;q=j[114630];j[114630]=0;if((q|0)==1){break xb}j[114630]=0;w=U(856,f|0,o|0,e+136|0,e+160|0,0)|0;f=j[114630];j[114630]=0;if((f|0)==1){break xb}j[114630]=0;E(338,b|0,j[e+136>>2])|0;b=j[114630];j[114630]=0;if((b|0)==1){break xb}lc(e+208|0);b=1;break tb}d=D()|0;C()|0;break l}d=D()|0;C()|0;lc(e+208|0);break l}rc(c);j[e+136>>2]=0;j[e+160>>2]=0;w=0;b=0}j[114630]=0;F(857,e+208|0,c|0);f=j[114630];j[114630]=0;yb:{zb:{if((f|0)!=1){j[114630]=0;u=H(412,e+208|0)|0;f=j[114630];j[114630]=0;if((f|0)==1){break yb}q=j[e+208>>2];if(!b){j[114630]=0;b=H(854,u|0)|0;f=j[114630];j[114630]=0;if((f|0)==1){break sb}j[114630]=0;f=H(855,q|0)|0;o=j[114630];j[114630]=0;if((o|0)==1){break sb}j[114630]=0;w=U(856,b|0,f|0,e+136|0,e+160|0,0)|0;b=j[114630];j[114630]=0;if((b|0)==1){break sb}j[114630]=0;E(338,c|0,j[e+136>>2])|0;b=j[114630];j[114630]=0;if((b|0)==1){break sb}b=j[e+136>>2];q=q-b|0;u=b+u|0}if(w){break zb}g=1;break rb}d=D()|0;C()|0;break l}j[114630]=0;d=p(d,104)+a|0;b=d+484380|0;H(465,b|0)|0;f=j[114630];j[114630]=0;if((f|0)==1){break sb}y=d+484400|0;t=d+484414|0;o=0;f=j[e+160>>2];while(1){Ab:{if(m[b>>2]<=o>>>0|(!q|(f|0)!=1?f:0)){break Ab}if(!ke(b)){break Ab}j[114630]=0;j[e+112>>2]=0;j[e+176>>2]=0;d=H(854,u|0)|0;f=j[114630];j[114630]=0;if((f|0)==1){break sb}j[114630]=0;f=H(855,q|0)|0;s=j[114630];j[114630]=0;if((s|0)==1){break sb}j[114630]=0;d=_(858,w|0,d|0,f|0,e+112|0,e+128|0,e+176|0)|0;f=j[114630];j[114630]=0;if((f|0)==1){break sb}j[114630]=0;j[e+136>>2]=d;E(338,c|0,d|0)|0;d=j[114630];j[114630]=0;if((d|0)==1){break sb}f=j[b>>2];j[114630]=0;d=j[e+136>>2];f=H(859,f-o|0)|0;s=j[114630];j[114630]=0;if((s|0)==1){break sb}_j(e+176|0,f);Bb:{if(j[e+176>>2]<1){break Bb}if(j[e+112>>2]!=(be(b)|0)){break Bb}f=0;if(j[e+112>>2]<=0){break Bb}while(1){Cb:{if(h[t|0]&1){s=j[y>>2];x=be(b);M=j[j[e+128>>2]+(f<<2)>>2];j[114630]=0;V(860,s+(p(o,x)<<1)|0,M|0,j[e+112>>2],j[e+176>>2],f|0);s=j[114630];j[114630]=0;if((s|0)!=1){break Cb}break sb}s=j[y>>2];x=be(b);M=j[j[e+128>>2]+(f<<2)>>2];j[114630]=0;V(861,s+p(o,x)|0,M|0,j[e+112>>2],j[e+176>>2],f|0);s=j[114630];j[114630]=0;if((s|0)==1){break sb}}f=f+1|0;if((f|0)<j[e+112>>2]){continue}break}}j[114630]=0;s=j[e+176>>2];f=H(862,w|0)|0;x=j[114630];j[114630]=0;if((x|0)==1){break sb}q=q-d|0;u=d+u|0;j[e+160>>2]=f;o=o+s|0;continue}break}j[114630]=0;N(863,w|0);b=j[114630];j[114630]=0;if((b|0)!=1){break rb}break sb}break sb}d=D()|0;C()|0;break l}d=D()|0;C()|0;lc(e+208|0);break l}lc(e+208|0)}n=n+1|0;d=n&65535;if(d>>>0<=l[a+480190>>1]){continue}break}}Db:{if(j[a+480180>>2]!=4){break Db}f=0;while(1){if(l[a+480192>>1]<=f>>>0){break Db}b=k[xb(A,f)|0];c=k[xb(A,f)+1|0];d=k[xb(A,f)+2|0];n=k[xb(A,f)+3|0];j[114630]=0;f=f+1|0;aa(864,a|0,f&65535,b|0,c|0,d|0,n|0);b=j[114630];j[114630]=0;if((b|0)!=1){continue}break}d=D()|0;C()|0;break l}Eb:{Fb:{Gb:{Hb:{if(!(k[v+2|0]&16)){break Hb}j[114630]=0;b=E(258,r|0,1)|0;c=j[114630];j[114630]=0;if((c|0)==1){break n}if(!b){break Hb}j[114630]=0;b=H(387,r|0)|0;c=j[114630];j[114630]=0;if((c|0)==1){break o}if(!(!(b&1)|!l[T>>1])){f=0;while(1){j[114630]=0;b=H(390,r|0)|0;c=j[114630];j[114630]=0;if((c|0)==1){break Gb}h[((f<<5)+a|0)+480288|0]=b;f=f+1|0;if(f>>>0<l[a+480188>>1]){continue}break}}while(1){j[114630]=0;b=E(258,r|0,1)|0;c=j[114630];j[114630]=0;Ib:{if((c|0)!=1){if(!b){break Hb}j[114630]=0;b=H(387,r|0)|0;c=j[114630];j[114630]=0;if((c|0)==1){break Fb}if(!b){break Hb}j[114630]=0;c=H(390,r|0)|0;d=j[114630];j[114630]=0;if((d|0)==1){break Eb}j[114630]=0;I(341,e+208|0,r|0,c|0);c=j[114630];j[114630]=0;if((c|0)==1){break Eb}if(b>>>0>250){break Ib}j[114630]=0;F(666,e+208|0,(p(b,160)+a|0)+906140|0);b=j[114630];j[114630]=0;if((b|0)!=1){break Ib}d=D()|0;C()|0;jb(e+208|0);break l}d=D()|0;C()|0;break l}jb(e+208|0);continue}}n=a+901404|0;u=a+1074304|0;w=a+484344|0;b=Qc(e+112|0);o=0;q=0;Jb:{Kb:{while(1){j[114630]=0;c=E(258,r|0,8)|0;d=j[114630];j[114630]=0;if((d|0)==1){break Jb}if(!c){break Kb}j[114630]=0;c=H(390,r|0)|0;d=j[114630];j[114630]=0;Lb:{Mb:{Nb:{Ob:{Pb:{Qb:{Rb:{Sb:{Tb:{Ub:{Vb:{Wb:{Xb:{Yb:{Zb:{_b:{$b:{if((d|0)!=1){j[114630]=0;d=H(390,r|0)|0;f=j[114630];j[114630]=0;if((f|0)==1){break $b}j[114630]=0;I(341,e+136|0,r|0,d|0);d=j[114630];j[114630]=0;if((d|0)==1){break _b}if((c|0)<=1397900629){if((c|0)==1229211981){break Yb}if((c|0)!=1229476432){break Mb}j[114630]=0;c=H(387,e+136|0)|0;d=j[114630];j[114630]=0;if((d|0)==1){break r}j[a+480216>>2]=c;j[114630]=0;c=H(387,e+136|0)|0;d=j[114630];j[114630]=0;if((d|0)==1){break r}j[a+480220>>2]=c;break Mb}if((c|0)==1397900630){break Zb}if((c|0)!=1414548815){break Mb}j[114630]=0;c=E(618,e+136|0,15275)|0;d=j[114630];j[114630]=0;if((d|0)==1){break r}if(!c){break Wb}j[114630]=0;c=H(390,e+136|0)|0;d=j[114630];j[114630]=0;if((d|0)!=1){j[114630]=0;I(341,e+160|0,e+136|0,c|0);c=j[114630];j[114630]=0;if((c|0)!=1){break Xb}}d=D()|0;C()|0;break q}d=D()|0;C()|0;break p}d=D()|0;C()|0;break p}d=D()|0;C()|0;break p}ac:{bc:{cc:{c=j[a+480180>>2];switch(c-2|0){case 1:break Mb;case 0:break Nb;case 2:break bc;default:break cc}}if((c|0)==16){break ac}if((c|0)!=32){break Mb}j[114630]=0;o=H(357,e+136|0)|0;c=j[114630];j[114630]=0;if((c|0)==1){break r}j[114630]=0;q=H(357,e+136|0)|0;c=j[114630];j[114630]=0;if((c|0)!=1){break Mb}break r}j[114630]=0;j[e+208>>2]=32;c=H(255,e+136|0)|0;d=j[114630];j[114630]=0;dc:{if((d|0)==1){break dc}j[114630]=0;j[e+160>>2]=c;c=E(33,e+208|0,e+160|0)|0;d=j[114630];j[114630]=0;if((d|0)==1){break dc}c=j[c>>2];j[114630]=0;P(865,e+136|0,b|0,4,c|0)|0;c=j[114630];j[114630]=0;if((c|0)!=1){break Mb}}d=D()|0;C()|0;break q}j[114630]=0;d=H(387,e+136|0)|0;c=j[114630];j[114630]=0;if((c|0)==1){break Lb}j[114630]=0;c=E(2,e+96|0,15256)|0;f=j[114630];j[114630]=0;ec:{fc:{gc:{if((f|0)!=1){j[114630]=0;F(219,e+160|0,c|0);f=j[114630];j[114630]=0;if((f|0)==1){break gc}j[114630]=0;j[e+176>>2]=d>>>4;j[e+128>>2]=d&15;L(533,e+208|0,e+160|0,e+176|0,e+128|0);d=j[114630];j[114630]=0;if((d|0)==1){break fc}ob(b,e+208|0);gb(e+208|0);qb(e+160|0);gb(c);break Mb}d=D()|0;C()|0;break q}d=D()|0;C()|0;break ec}d=D()|0;C()|0;qb(e+160|0)}gb(c);break q}j[114630]=0;E(632,e+136|0,n|0)|0;c=j[114630];j[114630]=0;if((c|0)==1){break r}j[114630]=0;N(633,n|0);c=j[114630];j[114630]=0;if((c|0)==1){break r}break Mb}j[114630]=0;c=H(255,e+160|0)|0;d=j[114630];j[114630]=0;if((d|0)==1){break Vb}i[e+208>>1]=c>>>5;c=me(w);j[114630]=0;i[e+176>>1]=c;c=E(477,e+208|0,e+176|0)|0;d=j[114630];j[114630]=0;if((d|0)==1){break Vb}c=l[c>>1];if(c){d=0;while(1){j[114630]=0;K(866,e+160|0,e+208|0,32)|0;f=j[114630];j[114630]=0;if((f|0)==1){break Vb}f=Hb(w,d);j[114630]=0;E(867,f|0,e+208|0)|0;f=j[114630];j[114630]=0;if((f|0)==1){break Vb}d=d+1|0;if((c|0)!=(d|0)){continue}break}}jb(e+160|0)}j[114630]=0;c=E(618,e+136|0,15280)|0;d=j[114630];j[114630]=0;if((d|0)==1){break r}if(!c){break Tb}j[114630]=0;c=H(390,e+136|0)|0;d=j[114630];j[114630]=0;if((d|0)!=1){j[114630]=0;I(341,e+208|0,e+136|0,c|0);c=j[114630];j[114630]=0;if((c|0)!=1){break Ub}}d=D()|0;C()|0;break q}d=D()|0;C()|0;jb(e+160|0);break q}j[114630]=0;c=H(255,e+208|0)|0;d=j[114630];j[114630]=0;if((d|0)==1){break Sb}i[e+160>>1]=(c>>>0)/20;c=l[a+480188>>1];j[114630]=0;i[e+176>>1]=c;c=E(477,e+160|0,e+176|0)|0;d=j[114630];j[114630]=0;if((d|0)==1){break Sb}c=l[c>>1];if(c){f=0;while(1){j[114630]=0;K(635,e+208|0,((f<<5)+a|0)+480289|0,20)|0;d=j[114630];j[114630]=0;if((d|0)==1){break Sb}f=f+1|0;if((c|0)!=(f|0)){continue}break}}jb(e+208|0)}j[114630]=0;E(652,a|0,e+136|0)|0;c=j[114630];j[114630]=0;if((c|0)==1){break r}j[114630]=0;L(653,a|0,e+136|0,1,0);c=j[114630];j[114630]=0;if((c|0)==1){break r}if((o-2186&65535)>>>0<=117){j[a+480180>>2]=16777216;j[114630]=0;I(664,a|0,e+136|0,o&65535);c=j[114630];j[114630]=0;if((c|0)==1){break r}}if(!j[u>>2]){break Mb}j[114630]=0;c=E(2,e+160|0,15285)|0;d=j[114630];j[114630]=0;if((d|0)==1){break Rb}j[114630]=0;F(242,e+176|0,u|0);d=j[114630];j[114630]=0;if((d|0)==1){break Qb}j[114630]=0;I(3,e+208|0,c|0,e+176|0);d=j[114630];j[114630]=0;if((d|0)==1){break Pb}ob(b,e+208|0);gb(e+208|0);gb(e+176|0);gb(c);break Mb}d=D()|0;C()|0;jb(e+208|0);break q}d=D()|0;C()|0;break q}d=D()|0;C()|0;break Ob}d=D()|0;C()|0;gb(e+176|0)}gb(c);break q}j[114630]=0;o=H(357,e+136|0)|0;c=j[114630];j[114630]=0;if((c|0)==1){break r}}jb(e+136|0);continue}break}d=D()|0;C()|0;break q}hc:{ic:{jc:{kc:{if(!((o&65504)!=4864|j[a+480180>>2]!=2?!((j[a+480180>>2]==32?(o-256&65535)>>>0<=275:0)|(j[a+480180>>2]==2?(o-12544&65535)>>>0<=275:0)):0)){j[114630]=0;N(634,n|0);c=j[114630];j[114630]=0;if((c|0)==1){break kc}}if(!(h[v+2|0]&1)){break hc}if(!(j[a+1074304>>2]|!l[a+480192>>1])){f=1;while(1){c=j[(((f&65535)<<2)+a|0)+900380>>2];if(c){j[114630]=0;d=E(374,c|0,2)|0;n=j[114630];j[114630]=0;if((n|0)==1){break jc}n=j[a+480180>>2];j[114630]=0;I(868,d|0,4,n|0);d=j[114630];j[114630]=0;if((d|0)==1){break ic}h[c+19|0]=k[c+19|0]+3>>>2}f=f+1|0;if(l[a+480192>>1]>=(f&65535)>>>0){continue}break}}if(m[a+1074304>>2]<18350080){j[114630]=0;c=a+1074308|0;E(479,c|0,27)|0;d=j[114630];j[114630]=0;if((d|0)==1){break kc}j[114630]=0;E(479,c|0,57)|0;c=j[114630];j[114630]=0;if((c|0)==1){break kc}}if(m[a+1074304>>2]<19070976){j[114630]=0;E(479,a+1074308|0,73)|0;c=j[114630];j[114630]=0;if((c|0)==1){break kc}}if(m[a+1074304>>2]>=19267584){break hc}j[114630]=0;E(479,a+1074308|0,50)|0;c=j[114630];j[114630]=0;if((c|0)!=1){break hc}}d=D()|0;C()|0;break p}d=D()|0;C()|0;break p}d=D()|0;C()|0;break p}lc:{mc:{nc:{oc:{pc:{qc:{rc:{sc:{tc:{uc:{vc:{wc:{xc:{yc:{zc:{Ac:{Bc:{Cc:{if(Ec(b)){j[114630]=0;c=E(2,e+80|0,15294)|0;d=j[114630];j[114630]=0;Dc:{Ec:{Fc:{if((d|0)!=1){j[114630]=0;F(219,e+136|0,c|0);d=j[114630];j[114630]=0;if((d|0)==1){break Fc}j[114630]=0;I(536,e+208|0,e+136|0,e+1575|0);d=j[114630];j[114630]=0;if((d|0)==1){break Ec}break Cc}d=D()|0;C()|0;break p}d=D()|0;C()|0;break Dc}d=D()|0;C()|0;qb(e+136|0)}gb(c);break p}j[114630]=0;c=E(2,e- -64|0,15302)|0;d=j[114630];j[114630]=0;if((d|0)==1){break Bc}j[114630]=0;F(219,e+136|0,c|0);d=j[114630];j[114630]=0;if((d|0)==1){break Ac}j[114630]=0;L(451,e+208|0,e+136|0,e+1575|0,b|0);d=j[114630];j[114630]=0;if((d|0)==1){break zc}}ob(b,e+208|0);gb(e+208|0);qb(e+136|0);gb(c);j[114630]=0;c=E(2,e+48|0,15315)|0;d=j[114630];j[114630]=0;if((d|0)==1){break wc}j[114630]=0;F(219,e+136|0,c|0);d=j[114630];j[114630]=0;if((d|0)==1){break vc}j[114630]=0;I(536,e+208|0,e+136|0,e+1575|0);d=j[114630];j[114630]=0;if((d|0)==1){break uc}ob(a+1304436|0,e+208|0);gb(e+208|0);qb(e+136|0);gb(c);j[114630]=0;c=E(2,e+208|0,15331)|0;d=j[114630];j[114630]=0;if((d|0)==1){break sc}ob(a+1304448|0,c);gb(c);c=j[a+480180>>2];if((c|0)>15){break xc}switch(c-1|0){case 1:break oc;case 3:break pc;case 0:break qc;default:break w}}d=D()|0;C()|0;break p}d=D()|0;C()|0;break yc}d=D()|0;C()|0;qb(e+136|0)}gb(c);break p}if((c|0)==16){break rc}if((c|0)==32){break nc}if((c|0)!=16777216){break w}j[114630]=0;c=E(2,e+208|0,15446)|0;d=j[114630];j[114630]=0;if((d|0)==1){break mc}ob(a+1304484|0,c);gb(c);j[114630]=0;c=E(2,e+208|0,15451)|0;d=j[114630];j[114630]=0;if((d|0)==1){break lc}ob(a+1304472|0,c);gb(c);break w}d=D()|0;C()|0;break p}d=D()|0;C()|0;break tc}d=D()|0;C()|0;qb(e+136|0)}gb(c);break p}d=D()|0;C()|0;break p}j[114630]=0;c=E(2,e+208|0,15335)|0;d=j[114630];j[114630]=0;Gc:{if((d|0)!=1){ob(a+1304484|0,c);gb(c);j[114630]=0;c=E(2,e+208|0,15339)|0;d=j[114630];j[114630]=0;if((d|0)==1){break Gc}ob(a+1304472|0,c);gb(c);break w}d=D()|0;C()|0;break p}d=D()|0;C()|0;break p}j[114630]=0;c=E(2,e+208|0,15352)|0;d=j[114630];j[114630]=0;Hc:{if((d|0)!=1){ob(a+1304484|0,c);gb(c);j[114630]=0;c=E(2,e+208|0,15356)|0;d=j[114630];j[114630]=0;if((d|0)==1){break Hc}ob(a+1304472|0,c);gb(c);break w}d=D()|0;C()|0;break p}d=D()|0;C()|0;break p}j[114630]=0;c=E(2,e+208|0,15368)|0;d=j[114630];j[114630]=0;Ic:{if((d|0)!=1){ob(a+1304484|0,c);gb(c);j[114630]=0;c=E(2,e+208|0,15371)|0;d=j[114630];j[114630]=0;if((d|0)==1){break Ic}ob(a+1304472|0,c);gb(c);break w}d=D()|0;C()|0;break p}d=D()|0;C()|0;break p}j[114630]=0;c=E(2,e+208|0,15385)|0;d=j[114630];j[114630]=0;Jc:{if((d|0)!=1){ob(a+1304484|0,c);gb(c);j[114630]=0;c=E(2,e+208|0,15389)|0;d=j[114630];j[114630]=0;if((d|0)==1){break Jc}ob(a+1304472|0,c);gb(c);break w}d=D()|0;C()|0;break p}d=D()|0;C()|0;break p}j[114630]=0;c=E(2,e+208|0,15405)|0;d=j[114630];j[114630]=0;Kc:{Lc:{Mc:{Nc:{Oc:{Pc:{Qc:{if((d|0)!=1){ob(a+1304484|0,c);gb(c);if(!(q&65535)){break Kc}j[114630]=0;c=E(2,e+32|0,15408)|0;d=j[114630];j[114630]=0;if((d|0)==1){break Qc}j[114630]=0;F(219,e+136|0,c|0);d=j[114630];j[114630]=0;if((d|0)==1){break Pc}j[114630]=0;j[e+176>>2]=(q&65280)>>>8;j[e+128>>2]=q&255;F(660,e+160|0,e+128|0);d=j[114630];j[114630]=0;if((d|0)==1){break Oc}j[114630]=0;L(645,e+208|0,e+136|0,e+176|0,e+160|0);d=j[114630];j[114630]=0;if((d|0)==1){break Nc}ob(a+1304472|0,e+208|0);gb(e+208|0);gb(e+160|0);qb(e+136|0);gb(c);break w}d=D()|0;C()|0;break p}d=D()|0;C()|0;break p}d=D()|0;C()|0;break Lc}d=D()|0;C()|0;break Mc}d=D()|0;C()|0;gb(e+160|0)}qb(e+136|0)}gb(c);break p}j[114630]=0;c=E(2,e+208|0,15430)|0;d=j[114630];j[114630]=0;if((d|0)!=1){ob(a+1304472|0,c);gb(c);break w}d=D()|0;C()|0;break p}d=D()|0;C()|0;break p}d=D()|0;C()|0;break p}d=D()|0;C()|0;break p}d=D()|0;C()|0;break l}d=D()|0;C()|0;break l}d=D()|0;C()|0;break l}d=D()|0;C()|0;break h}d=D()|0;C()|0;break h}d=D()|0;C()|0;break h}d=D()|0;C()|0;break d}d=D()|0;C()|0;break d}d=D()|0;C()|0;break d}d=D()|0;C()|0;break c}d=D()|0;C()|0;break d}ob(a+1304460|0,b);Rc:{if(j[a+1074304>>2]){j[a+1304496>>2]=7;break Rc}if(j[a+480180>>2]==1){j[a+1304496>>2]=2;break Rc}j[a+1304496>>2]=4}f=1;if(g&1){j[114630]=0;c=E(2,e+208|0,15464)|0;d=j[114630];j[114630]=0;if((d|0)==1){break t}j[114630]=0;I(646,a|0,2,c|0);a=j[114630];j[114630]=0;if((a|0)==1){break s}gb(c)}gb(b);ZO(B);YO(A);Sc(O);jb(e+1080|0);jb(e+1096|0)}jb(r)}Od(Q);break b}d=D()|0;C()|0;break p}d=D()|0;C()|0;gb(c);break p}d=D()|0;C()|0}jb(e+136|0)}gb(b);break l}d=D()|0;C()|0;break l}d=D()|0;C()|0;break l}d=D()|0;C()|0}ZO(B);break j}d=D()|0;C()|0}YO(A);break h}d=D()|0;C()|0}Sc(O)}jb(e+1080|0)}jb(e+1096|0);break d}d=D()|0;C()|0}jb(r)}Od(Q);G(d|0);z()}Za=e+1584|0;return f|0}J(0)|0;C()|0;ib();z()}function tDa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,n=0,o=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,J=0,M=0,O=0,Q=0,R=0,S=0,T=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0;d=Za-912|0;Za=d;rc(b);a:{if(!xP(b,d+856|0)){break a}if(!zP(d+856|0)){break a}if(!yb(b,Tc(yP(d+856|0),ab))){break a}if(!c){f=1;break a}od(a,8);Zh(a);h[d+855|0]=k[d+856|3]-48;e=k[d+864|0]|k[d+865|0]<<8|(k[d+866|0]<<16|k[d+867|0]<<24);xc(b,e<<24|e<<8&16711680|(e>>>8&65280|e>>>24));cd(d+832|0,b,504);j[114630]=0;E(771,b|0,d+544|0)|0;e=j[114630];j[114630]=0;b:{c:{d:{e:{f:{g:{h:{i:{j:{k:{l:{m:{n:{if((e|0)!=1){if(k[d+544|0]&128|k[d+827|0]>63){break b}Ab(d+464|0,0,80);o:{if(!(k[d+888|0]|k[d+889|0]<<8|(k[d+890|0]<<16|k[d+891|0]<<24))){break o}e=k[d+888|0]|k[d+889|0]<<8|(k[d+890|0]<<16|k[d+891|0]<<24);j[114630]=0;e=E(256,b|0,e<<8&16711680|e<<24|(e>>>8&65280|e>>>24))|0;g=j[114630];j[114630]=0;if((g|0)!=1){if(!e){break o}j[114630]=0;E(772,b|0,d+464|0)|0;e=j[114630];j[114630]=0;if((e|0)!=1){break o}}f=D()|0;C()|0;break e}j[114630]=0;I(773,d+456|0,b|0,k[d+855|0]);e=j[114630];j[114630]=0;if((e|0)!=1){_=Bf(d+456|0);e=l[d+456>>1];if((e-1&65535)>>>0>126){break b}i[a+480188>>1]=e;S=d+440|0;aDa(S);p:{if(k[d+880|0]|k[d+881|0]<<8|(k[d+882|0]<<16|k[d+883|0]<<24)){e=k[d+880|0]|k[d+881|0]<<8|(k[d+882|0]<<16|k[d+883|0]<<24);j[114630]=0;E(256,b|0,e<<8&16711680|e<<24|(e>>>8&65280|e>>>24))|0;e=j[114630];j[114630]=0;if((e|0)!=1){e=k[d+827|0];j[114630]=0;K(774,b|0,S|0,e|0)|0;e=j[114630];j[114630]=0;if((e|0)!=1){break p}}f=D()|0;C()|0;break f}if(k[d+827|0]){break c}}e=k[d+827|0];i[a+480192>>1]=e;i[a+480190>>1]=e;$=1;if(k[d+855|0]>=2){$=h[d+808|0]>-1;e=l[a+480192>>1]}if(e&65535){T=c&2;W=$^1;x=d+80|2;X=d+80|7;Y=d+80|6;B=d+80|5;J=d+80|4;u=d+56|4;n=1;s=1;t=1;while(1){j[114630]=0;M=t&65535;e=K(454,a|0,s&65535,M|0)|0;g=j[114630];j[114630]=0;q:{r:{if((g|0)!=1){if(!e){break d}o=j[((n<<2)+a|0)+900380>>2];j[114630]=0;i[d+60>>1]=0;j[d+56>>2]=0;w=H(277,d+152|0)|0;e=j[114630];j[114630]=0;s:{t:{u:{if((e|0)!=1){g=n-1|0;e=xb(S,g);v:{if(!(k[e|0]|k[e+1|0]<<8|(k[e+2|0]<<16|k[e+3|0]<<24))){break v}e=xb(S,g);e=k[e|0]|k[e+1|0]<<8|(k[e+2|0]<<16|k[e+3|0]<<24);j[114630]=0;e=E(256,b|0,e<<8&16711680|e<<24|(e>>>8&65280|e>>>24))|0;g=j[114630];j[114630]=0;if((g|0)==1){break g}if(!e){break v}j[114630]=0;E(775,b|0,d+56|0)|0;e=j[114630];j[114630]=0;if((e|0)==1){break g}e=k[d+56|0]|k[d+57|0]<<8|(k[d+58|0]<<16|k[d+59|0]<<24);j[114630]=0;I(341,d+80|0,b|0,e<<8&16711680|e<<24|(e>>>8&65280|e>>>24));e=j[114630];j[114630]=0;if((e|0)==1){break g}Ed(w,d+80|0);jb(d+80|0)}g=k[u+1|0]&15;v=(k[u|0]|k[u+1|0]<<8)&128;if(!v){break u}j[114630]=0;F(776,o|0,0);e=j[114630];j[114630]=0;ea=1;if((e|0)!=1){break t}break g}f=D()|0;C()|0;break f}if(g>>>0>=7){break t}e=k[g+14806|0];if(!g){g=e;break r}i[a+480190>>1]=(l[a+480190>>1]+e|0)-1;g=o+108|0;n=o+236|0;Q=e-2|0;q=4;while(1){r=q-4|0;f=Q<<3;A=k[r+(f+14816|0)|0]+t|0;r=k[r+(f+14864|0)|0];y=p(q,12);f=0;while(1){O=f+y|0;ma=Nc(n,O),na=A,i[ma>>1]=na;O=Pb(g,O);h[O|0]=r+k[O|0];f=f+1|0;if((f|0)!=12){continue}break}r=1;q=q+1|0;if((q|0)!=10){continue}break}g=e;break s}e=1;if((g|0)!=7){g=1;break r}r=0;j[114630]=0;F(777,o|0,-24);e=j[114630];j[114630]=0;g=1;if((e|0)==1){break g}e=1}Q=1;break q}f=D()|0;C()|0;break f}r=0;if(v|W){break q}n=o+108|0;q=7;while(1){r=p(q,12);A=p(q,-12)+72|0;f=0;while(1){y=Pb(n,f+r|0);h[y|0]=A+k[y|0];f=f+1|0;if((f|0)!=12){continue}break}q=q+1|0;if((q|0)!=10){continue}break}r=0}j[114630]=0;E(778,d+832|0,d+80|0)|0;f=j[114630];j[114630]=0;if((f|0)==1){break g}if(!(!k[J|0]|k[J|0]>16)){h[o+31|0]=k[J|0];Q=1}if(!(!k[B|0]|k[B|0]>128)){h[o+30|0]=k[B|0]}if(g){n=0;o=0;while(1){j[114630]=0;f=p(n+M|0,104)+a|0;F(386,f+484380|0,8);n=j[114630];j[114630]=0;if((n|0)==1){break g}n=k[Y|0];j[114630]=0;h[d+408|0]=n;h[d+136|0]=64;n=E(391,d+408|0,d+136|0)|0;q=j[114630];j[114630]=0;if((q|0)==1){break g}i[f+484410>>1]=k[n|0]<<2;h[f+484416|0]=k[X|0];o=o+1|0;n=o&65535;if(n>>>0<g>>>0){continue}break}}w:{if(v|!T){break w}v=Kc(d+408|0,8,1,1,0);n=k[x|0]|k[x+1|0]<<8;o=k[d+80|0]|k[d+81|0]<<8;q=k[x|0]|k[x+1|0]<<8;j[114630]=0;f=H(255,w|0)|0;A=j[114630];j[114630]=0;if((A|0)==1){break g}if(k[u+1|0]&16){lz(v);f=f>>>1|0}if(k[u+1|0]&32){gA(v);f=f>>>1|0}if(k[u+1|0]&64){ej(v,2)}f=r?(f>>>0)/((-1<<g^-1)>>>0)|0:f;if(!g){break w}o=(o<<8|o>>>8)&65535;r=o+((q<<8|q>>>8)&65535)|0;A=n<<8|n>>>8;n=0;q=0;while(1){n=p(n+M|0,104)+a|0;y=n+484380|0;j[y>>2]=f;j[114630]=0;K(400,v|0,y|0,w|0)|0;y=j[114630];j[114630]=0;if((y|0)==1){break g}o=o<<1;r=r<<1;if((A&65535)>>>0>=2){j[n+484388>>2]=r;j[n+484384>>2]=o;n=n+484414|0;i[n>>1]=l[n>>1]|2}f=f<<1;q=q+1|0;n=q&65535;if(n>>>0<g>>>0){continue}break}}jb(w);t=e+t|0;s=s+1|0;n=s&65535;if(n>>>0<=l[a+480192>>1]){continue}break}}e=d+464|4;x:{if(!(k[e|0]|k[e+1|0]<<8|(k[e+2|0]<<16|k[e+3|0]<<24))|!(k[d+472|0]|k[d+473|0]<<8)){break x}e=k[e|0]|k[e+1|0]<<8|(k[e+2|0]<<16|k[e+3|0]<<24);j[114630]=0;e=E(256,b|0,e<<8&16711680|e<<24|(e>>>8&65280|e>>>24))|0;g=j[114630];j[114630]=0;if((g|0)==1){break h}if(!e){break x}e=k[d+472|0]|k[d+473|0]<<8;i[d+152>>1]=e<<8|e>>>8;e=k[d+827|0];j[114630]=0;i[d+80>>1]=e;e=E(477,d+152|0,d+80|0)|0;g=j[114630];j[114630]=0;if((g|0)==1){break i}t=l[e>>1];if(!t){break x}e=k[d+474|0]|k[d+475|0]<<8;n=(e<<8|e>>>8)&65535;q=d+152|5;u=d+152|3;r=d+152|1;g=d+88|0;w=d+80|4;o=0;while(1){j[114630]=0;K(779,b|0,d+152|0,n|0)|0;e=j[114630];j[114630]=0;y:{z:{A:{if((e|0)!=1){o=o+1|0;e=j[((o<<2)+a|0)+900380>>2];if(!k[d+152|0]){break y}x=ep(d+80|0,0,64);ep(w,k[d+152|0]-1&65535,64);v=k[d+152|0];ep(g,v+(k[r|0]?64/k[r|0]|0:0)|0,0);j[114630]=0;j[d+436>>2]=3;j[d+432>>2]=x;f=j[d+436>>2];j[d+8>>2]=j[d+432>>2];j[d+12>>2]=f;f=e+48|0;F(780,f|0,d+8|0);s=j[114630];j[114630]=0;if((s|0)==1){break A}if(k[d+152|0]!=1){break z}ma=d,na=Lb(f),j[ma+80>>2]=na;Cd(d+424|0,d+80|0);j[114630]=0;E(781,f|0,j[d+424>>2])|0;f=j[114630];j[114630]=0;if((f|0)!=1){break z}f=D()|0;C()|0;break f}f=D()|0;C()|0;break f}f=D()|0;C()|0;break f}f=e;if(k[r|0]){s=k[r|0]<<9}else{s=32767}j[f>>2]=s;Q=1;h[e+60|0]=k[e+60|0]|1}B:{if(n>>>0<19){break B}j[e+4>>2]=k[d+170|0]+1>>>1;if(n>>>0<21){break B}i[e+28>>1]=k[d+172|0]|k[d+173|0]<<8}e=p(l[Nc(e+236|0,61)>>1],104)+a|0;h[e+484417|0]=k[u|0]<<4;C:{D:{if(n>>>0>=15){f=k[d+162|0]|k[d+163|0]<<8|(k[d+164|0]<<16|k[d+165|0]<<24);j[e+484384>>2]=f<<24|f<<8&16711680|(f>>>8&65280|f>>>24);f=k[d+166|0]|k[d+167|0]<<8|(k[d+168|0]<<16|k[d+169|0]<<24);s=f<<24|f<<8&16711680|(f>>>8&65280|f>>>24);f=k[d+162|0]|k[d+163|0]<<8|(k[d+164|0]<<16|k[d+165|0]<<24);j[e+484388>>2]=s+(f<<8&16711680|f<<24|(f>>>8&65280|f>>>24));break D}if(n>>>0<6){break C}}if(h[q|0]&1){f=e+484414|0;i[f>>1]=l[f>>1]|2}if(k[q|0]&8){f=e+484414|0;i[f>>1]=l[f>>1]|6}if(!(k[q|0]&4)){break C}i[e+484412>>1]=0}if((o|0)!=(t|0)){continue}break}}if(!(k[d+484|0]|k[d+485|0]<<8|(k[d+486|0]<<16|k[d+487|0]<<24))|!(k[d+488|0]|k[d+489|0]<<8)){break j}e=k[d+484|0]|k[d+485|0]<<8|(k[d+486|0]<<16|k[d+487|0]<<24);j[114630]=0;e=E(256,b|0,e<<8&16711680|e<<24|(e>>>8&65280|e>>>24))|0;g=j[114630];j[114630]=0;if((g|0)==1){break h}if(!e){break j}e=k[d+488|0]|k[d+489|0]<<8;i[d+152>>1]=e<<8|e>>>8;e=k[d+827|0];j[114630]=0;i[d+80>>1]=e;e=E(477,d+152|0,d+80|0)|0;g=j[114630];j[114630]=0;if((g|0)!=1){r=l[e>>1];if(!r){break j}e=k[d+490|0]|k[d+491|0]<<8;o=(e<<8|e>>>8)&65535;e=0;E:while(1){F:{j[114630]=0;K(782,b|0,d+152|0,o|0)|0;g=j[114630];j[114630]=0;if((g|0)==1){break k}j[114630]=0;I(783,d+56|0,2,d+152|0);g=j[114630];j[114630]=0;if((g|0)==1){break l}j[114630]=0;F(415,d+80|0,d+56|0);g=j[114630];j[114630]=0;if((g|0)==1){break l}e=e+1|0;n=((e<<2)+a|0)+900380|0;g=j[n>>2];j[114630]=0;E(369,g+492|0,d+80|0)|0;g=j[114630];j[114630]=0;if((g|0)==1){break m}gb(d+80|0);g=j[n>>2];j[114630]=0;F(784,d+80|0,g|0);g=j[114630];j[114630]=0;if((g|0)==1){break n}ma=d,na=_m(d+80|0),j[ma+56>>2]=na;ma=d,na=ii(d+80|0),j[ma+408>>2]=na;while(1){j[114630]=0;g=E(785,d+56|0,d+408|0)|0;f=j[114630];j[114630]=0;G:{if((f|0)!=1){if(g){break G}cp(d+80|0);if((e|0)!=(r|0)){continue E}break j}break F}j[114630]=0;g=H(786,d+56|0)|0;f=j[114630];j[114630]=0;if((f|0)!=1){f=(l[g>>1]<<5)+a|0;q=f+946324|0;g=j[n>>2];s=j[g+520>>2];j[q>>2]=j[g+516>>2];j[q+4>>2]=s;s=j[g+512>>2];q=f+946316|0;j[q>>2]=j[g+508>>2];j[q+4>>2]=s;s=j[g+504>>2];q=f+946308|0;j[q>>2]=j[g+500>>2];j[q+4>>2]=s;q=j[g+496>>2];f=f+946300|0;j[f>>2]=j[g+492>>2];j[f+4>>2]=q;Ms(d+56|0);continue}break}}break}f=D()|0;C()|0;cp(d+80|0);break f}f=D()|0;C()|0;break f}f=D()|0;C()|0;break e}f=D()|0;C()|0;break e}f=D()|0;C()|0;break f}f=D()|0;C()|0;gb(d+80|0);break f}f=D()|0;C()|0;break f}f=D()|0;C()|0;break f}j[114630]=0;N(634,a+901404|0);e=j[114630];j[114630]=0;if((e|0)==1){break h}e=a+901692|0;g=k[14912]|k[14913]<<8|(k[14914]<<16|k[14915]<<24);h[e|0]=g;h[e+1|0]=g>>>8;h[e+2|0]=g>>>16;h[e+3|0]=g>>>24;h[a+901696|0]=k[14916];rc(b);H:{I:{J:{K:{L:{M:{N:{if(!k[_|0]){break N}fa=c&1;x=a+484344|0;B=a+1304424|0;Y=a+1304400|0;A=a+484360|0;ga=d+152|1;o=d+152|4;c=d+32|4;y=d+32|2;O=d+72|2;ha=d+72|3;u=d+544|2;v=0;W=0;while(1){j[114630]=0;L(787,b|0,d+856|0,d+464|0,d+544|0);e=j[114630];j[114630]=0;O:{P:{Q:{R:{S:{T:{U:{V:{W:{if((e|0)==1){break W}e=W&255;if(e){j[114630]=0;g=H(485,A|0)|0;f=j[114630];j[114630]=0;if((f|0)==1){break W}if((g|0)==255){break d}}q=ei(A,e);w=iDa(d+408|0);xp(q);if(k[d+855|0]>1){break U}e=k[u|0]|k[u+1|0]<<8;if(((e<<8|e>>>8)&65535)>>>0>256|l[a+480188>>1]>16){break S}uP(d+152|0,d+544|0);e=k[u|0]|k[u+1|0]<<8;j[114630]=0;U(788,q|0,d+152|0,(e<<8|e>>>8)&65535,65535,65535)|0;e=j[114630];j[114630]=0;if((e|0)==1){break T}ma=d,na=Lb(q),j[ma+152>>2]=na;ma=d,na=Mb(q),j[ma+80>>2]=na;if(rb(d+152|0,d+80|0)){break V}break Q}f=D()|0;C()|0;break f}while(1){e=j[d+152>>2];i[e>>1]=l[e>>1]+v;je(d+152|0);if(rb(d+152|0,d+80|0)){continue}break}break Q}uP(d+152|0,d+544|0);if(!(k[d+164|0]|k[d+165|0]<<8)){break S}e=k[d+164|0]|k[d+165|0]<<8;if(((e<<8|e>>>8)&65535)>>>0>64|l[a+480188>>1]>64){break S}s=k[d+172|0]|k[d+173|0]<<8|(k[d+174|0]<<16|k[d+175|0]<<24);if(!(k[d+176|0]|k[d+177|0]<<8)){r=32;break R}e=k[d+176|0]|k[d+177|0]<<8;j[114630]=0;i[d+80>>1]=e<<8|e>>>8;i[d+56>>1]=800;e=E(477,d+80|0,d+56|0)|0;g=j[114630];j[114630]=0;if((g|0)!=1){e=l[e>>1];j[114630]=0;r=ig(789,((e<<5)+50>>>0)/100|0,0);e=j[114630];j[114630]=0;if((e|0)!=1){break R}}f=D()|0;C()|0;break H}f=D()|0;C()|0;break H}bp(w);break d}e=k[d+160|0]|k[d+161|0]<<8|(k[d+162|0]<<16|k[d+163|0]<<24);j[114630]=0;e=E(256,b|0,e<<8&16711680|e<<24|(e>>>8&65280|e>>>24))|0;g=j[114630];j[114630]=0;X:{if((g|0)==1){break X}Y:{if(!e){break Y}f=0;if(!l[a+480188>>1]){break Y}Z:{while(1){_:{j[114630]=0;e=H(387,b|0)|0;g=j[114630];j[114630]=0;if((g|0)==1){break _}j[114630]=0;h[d+80|0]=e;h[d+56|0]=64;e=E(391,d+80|0,d+56|0)|0;g=j[114630];j[114630]=0;if((g|0)==1){break Z}i[((f<<5)+a|0)+480286>>1]=k[e|0];f=f+1|0;if(f>>>0<l[a+480188>>1]){continue}break Y}break}f=D()|0;C()|0;break H}f=D()|0;C()|0;break H}$:{aa:{if(!(k[d+168|0]|k[d+169|0]<<8|(k[d+170|0]<<16|k[d+171|0]<<24))){break aa}e=k[d+168|0]|k[d+169|0]<<8|(k[d+170|0]<<16|k[d+171|0]<<24);j[114630]=0;e=E(256,b|0,e<<8&16711680|e<<24|(e>>>8&65280|e>>>24))|0;g=j[114630];j[114630]=0;if((g|0)==1){break X}if(!e){break aa}f=0;if(!l[a+480188>>1]){break $}while(1){ba:{j[114630]=0;e=H(790,b|0)|0;g=j[114630];j[114630]=0;if((g|0)==1){break ba}ma=((f<<5)+a|0)+480284|0,na=(Gb(e,-16,16)<<3)+128|0,i[ma>>1]=na;f=f+1|0;if(f>>>0<l[a+480188>>1]){continue}break $}break}f=D()|0;C()|0;break H}j[114630]=0;F(449,a|0,1);e=j[114630];j[114630]=0;if((e|0)==1){break X}}e=d+136|0;WCa(e);g=k[o|0]|k[o+1|0]<<8|(k[o+2|0]<<16|k[o+3|0]<<24);j[114630]=0;g=E(256,b|0,g<<8&16711680|g<<24|(g>>>8&65280|g>>>24))|0;f=j[114630];j[114630]=0;ca:{da:{ea:{fa:{ga:{if((f|0)==1){break ga}n=1;f=0;if(!g){break ca}g=k[u|0]|k[u+1|0]<<8;j[114630]=0;g=E(258,b|0,((g<<8|g>>>8)&65535)<<1)|0;t=j[114630];j[114630]=0;if((t|0)==1){break ga}if(!g){break ca}g=k[u|0]|k[u+1|0]<<8;j[114630]=0;g=K(791,b|0,e|0,(g<<8|g>>>8)&65535)|0;t=j[114630];j[114630]=0;if((t|0)==1){break ga}if(!g){break ca}ma=d,na=Lb(e),j[ma+32>>2]=na;ma=d,na=Mb(e),j[ma+128>>2]=na;if(!rb(d+32|0,d+128|0)){break da}while(1){g=k[d+166|0]|k[d+167|0]<<8;n=(g<<8|g>>>8)&65535;g=j[d+32>>2];g=k[g|0]|k[g+1|0]<<8;f=(g<<8|g>>>8)&65535;ha:{if(n>>>0<f>>>0){break ha}g=k[d+152|0]|k[d+153|0]<<8|(k[d+154|0]<<16|k[d+155|0]<<24);j[114630]=0;E(256,b|0,(g<<8&16711680|g<<24|(g>>>8&65280|g>>>24))+(f<<2)|0)|0;g=j[114630];j[114630]=0;ia:{ja:{ka:{la:{ma:{if((g|0)==1){break ma}j[114630]=0;g=H(493,b|0)|0;f=j[114630];j[114630]=0;if((f|0)==1){break ma}j[114630]=0;g=E(256,b|0,g|0)|0;f=j[114630];j[114630]=0;if((f|0)==1){break ma}if(!g){break ha}j[114630]=0;g=E(258,b|0,42)|0;f=j[114630];j[114630]=0;if((f|0)==1){break ma}if(!g){break ha}j[114630]=0;E(792,b|0,d+80|0)|0;g=j[114630];j[114630]=0;na:{if((g|0)!=1){if(Xc(q)){break na}j[114630]=0;F(793,q|0,65534);g=j[114630];j[114630]=0;if((g|0)!=1){break na}}f=D()|0;C()|0;break ea}g=k[d+120|0]|k[d+121|0]<<8;j[114630]=0;g=(g<<8|g>>>8)&65535;j[d+76>>2]=g;g=E(258,b|0,g|0)|0;f=j[114630];j[114630]=0;if((f|0)==1){break la}if(!g){j[114630]=0;g=H(540,b|0)|0;f=j[114630];j[114630]=0;if((f|0)==1){break la}jc(d+76|0,g)}jc(d+76|0,65534);f=Yb(q);j[114630]=0;F(794,q|0,f+j[d+76>>2]|0);g=j[114630];j[114630]=0;if((g|0)==1){break ja}n=0;if(!j[d+76>>2]){break ka}while(1){oa:{j[114630]=0;g=H(484,b|0)|0;t=j[114630];j[114630]=0;if((t|0)==1){break oa}g=g<<16>>16;if((g|0)>=0){j[114630]=0;F(793,q|0,g+v&65535);g=j[114630];j[114630]=0;if((g|0)==1){break oa}}n=n+1|0;if(n>>>0<m[d+76>>2]){continue}break ka}break}f=D()|0;C()|0;break ea}f=D()|0;C()|0;break ea}f=D()|0;C()|0;break ea}pa:{if(!k[d+80|0]){break pa}j[114630]=0;I(6,d+56|0,2,d+80|0);g=j[114630];j[114630]=0;qa:{if((g|0)!=1){j[114630]=0;F(486,q|0,d+56|0);g=j[114630];j[114630]=0;if((g|0)==1){break qa}gb(d+56|0);break pa}f=D()|0;C()|0;break ea}f=D()|0;C()|0;gb(d+56|0);break ea}if(!(k[d+112|0]|k[d+113|0]<<8|(k[d+114|0]<<16|k[d+115|0]<<24))){break ha}g=k[d+112|0]|k[d+113|0]<<8|(k[d+114|0]<<16|k[d+115|0]<<24);j[114630]=0;g=E(256,b|0,g<<8&16711680|g<<24|(g>>>8&65280|g>>>24))|0;n=j[114630];j[114630]=0;if((n|0)!=1){break ia}}f=D()|0;C()|0;break ea}if(!g){break ha}while(1){ra:{j[114630]=0;g=E(795,b|0,d+72|0)|0;n=j[114630];j[114630]=0;sa:{ta:{if((n|0)!=1){if(!g){break ha}g=k[ha|0];j[114630]=0;I(341,d+56|0,b|0,g|0);g=j[114630];j[114630]=0;if((g|0)==1){break ta}g=k[d+72|0]|k[d+73|0]<<8;j[114630]=0;g=H(796,f+((g<<8|g>>>8)&65535)|0)|0;n=j[114630];j[114630]=0;if((n|0)==1){break fa}i[d+54>>1]=g;if((k[d+72|0]|k[d+73|0]<<8)==65535){break ra}g=l[d+54>>1];if(Yb(q)>>>0>g>>>0){break sa}jb(d+56|0);break ha}f=D()|0;C()|0;break ea}f=D()|0;C()|0;break ea}ua:{if(k[O|0]==1){g=65535}else{if(k[O|0]!=2){break ua}j[114630]=0;g=H(484,d+56|0)|0;n=j[114630];j[114630]=0;if((n|0)==1){break fa}j[114630]=0;n=E(797,w|0,d+54|0)|0;t=j[114630];j[114630]=0;if((t|0)==1){break fa}i[n>>1]=g;g=65534}ma=bc(q,l[d+54>>1]),na=g,i[ma>>1]=na}jb(d+56|0);continue}break}jb(d+56|0)}je(d+32|0);if(rb(d+32|0,d+128|0)){continue}break}break da}f=D()|0;C()|0;break ea}f=D()|0;C()|0;jb(d+56|0)}sP(e);break H}n=0;f=1}sP(e);if(f){e=r>>>(s>>>25&1)|0;break P}bp(w);if(!n){break d}break O}f=D()|0;C()|0;break H}j[114630]=0;F(449,a|0,1);e=j[114630];j[114630]=0;va:{if((e|0)!=1){f=0;e=32;if(!l[a+480188>>1]){break P}while(1){g=k[(d+f|0)+810|0];j[114630]=0;h[d+152|0]=g;h[d+80|0]=64;g=E(391,d+152|0,d+80|0)|0;n=j[114630];j[114630]=0;if((n|0)==1){break va}i[((f<<5)+a|0)+480286>>1]=k[g|0];f=f+1|0;if(f>>>0<l[a+480188>>1]){continue}break}break P}f=D()|0;C()|0;break H}f=D()|0;C()|0;break H}n=k[d+807|0];g=k[d+804|0]|k[d+805|0]<<8;ca=k[d+807|0]&64;aa=k[d+808|0]&32;X=(k[d+808|0]&31)+1|0;ma=a,na=rP((g<<8|g>>>8)&65535,ca>>>6|0,aa>>>5|0,X),j[ma+480204>>2]=na;ma=a,na=kd(k[d+809|0],1,32),j[ma+480196>>2]=na;if(aa){j[a+480216>>2]=X;j[a+480220>>2]=X<<2}wa:{xa:{if(k[d+826|0]){g=k[d+826|0];j[114630]=0;h[d+152|0]=g;h[d+80|0]=64;g=E(391,d+152|0,d+80|0)|0;f=j[114630];j[114630]=0;if((f|0)==1){break xa}j[a+480200>>2]=k[g|0]<<2}j[a+480228>>2]=e;j[a+480232>>2]=e;j[a+480208>>2]=j[a+480208>>2]&-3|(k[d+807|0]>>>4^-1)&2;ya:{za:{Aa:{Ba:{Ca:{Da:{Ea:{Fa:{Ga:{Ha:{Ia:{Ja:{if(!(k[d+508|0]|k[d+509|0]<<8|(k[d+510|0]<<16|k[d+511|0]<<24))){break Ja}e=k[d+508|0]|k[d+509|0]<<8|(k[d+510|0]<<16|k[d+511|0]<<24);j[114630]=0;e=E(256,b|0,e<<8&16711680|e<<24|(e>>>8&65280|e>>>24))|0;g=j[114630];j[114630]=0;if((g|0)==1){break Ia}if(!e){break Ja}e=k[d+512|0]|k[d+513|0]<<8|(k[d+514|0]<<16|k[d+515|0]<<24);j[114630]=0;K(481,b|0,Y|0,e<<8&16711680|e<<24|(e>>>8&65280|e>>>24))|0;e=j[114630];j[114630]=0;if((e|0)==1){break Ia}if(k[_|0]<2){break Ja}j[114630]=0;I(13,d+152|0,2,Y|0);e=j[114630];j[114630]=0;if((e|0)==1){break Ha}j[114630]=0;F(486,q|0,d+152|0);e=j[114630];j[114630]=0;if((e|0)==1){break Ga}gb(d+152|0)}e=k[d+480|0]|k[d+481|0]<<8|(k[d+482|0]<<16|k[d+483|0]<<24);Ka:{if((e<<24|e<<8&16711680|(e>>>8&65280|e>>>24))>>>0<2){break Ka}e=k[d+476|0]|k[d+477|0]<<8|(k[d+478|0]<<16|k[d+479|0]<<24);j[114630]=0;e=E(256,b|0,e<<8&16711680|e<<24|(e>>>8&65280|e>>>24))|0;g=j[114630];j[114630]=0;if((g|0)==1){break Ia}if(!e){break Ka}e=k[d+480|0]|k[d+481|0]<<8|(k[d+482|0]<<16|k[d+483|0]<<24);j[114630]=0;P(584,B|0,b|0,(e<<8&16711680|e<<24|(e>>>8&65280|e>>>24))-1|0,4)|0;e=j[114630];j[114630]=0;if((e|0)==1){break Ia}}if(!(k[d+520|0]|k[d+521|0]<<8|(k[d+522|0]<<16|k[d+523|0]<<24))){break wa}e=k[d+520|0]|k[d+521|0]<<8|(k[d+522|0]<<16|k[d+523|0]<<24);j[114630]=0;e=E(256,b|0,e<<8&16711680|e<<24|(e>>>8&65280|e>>>24))|0;g=j[114630];j[114630]=0;if((g|0)==1){break Ia}if(!e){break wa}j[114630]=0;e=E(258,b|0,12)|0;g=j[114630];j[114630]=0;if((g|0)==1){break Ia}if(!e){break wa}j[114630]=0;E(338,b|0,6)|0;e=j[114630];j[114630]=0;if((e|0)==1){break Ia}j[114630]=0;e=H(484,b|0)|0;g=j[114630];j[114630]=0;if((g|0)==1){break Ia}if((e|0)!=1){break wa}j[114630]=0;e=H(493,b|0)|0;g=j[114630];j[114630]=0;if((g|0)==1){break Ea}if(!e){break wa}j[114630]=0;g=E(258,b|0,e|0)|0;f=j[114630];j[114630]=0;if((f|0)==1){break Ea}if(g){break Fa}break wa}f=D()|0;C()|0;break H}f=D()|0;C()|0;break H}f=D()|0;C()|0;gb(d+152|0);break H}Mc(d+152|0,B);j[114630]=0;P(584,B|0,b|0,e|0,4)|0;e=j[114630];j[114630]=0;if((e|0)==1){break za}if(!Ec(d+152|0)){j[114630]=0;e=K(798,d+56|0,2,13)|0;g=j[114630];j[114630]=0;if((g|0)==1){break Da}j[114630]=0;I(799,d+80|0,d+152|0,e|0);g=j[114630];j[114630]=0;if((g|0)==1){break Ca}j[114630]=0;I(800,d+40|0,d+80|0,B|0);g=j[114630];j[114630]=0;if((g|0)==1){break Ba}ob(B,d+40|0);gb(d+40|0);gb(d+80|0);gb(e)}gb(d+152|0);break wa}f=D()|0;C()|0;break H}f=D()|0;C()|0;break ya}f=D()|0;C()|0;break Aa}f=D()|0;C()|0;gb(d+80|0)}gb(e);break ya}f=D()|0;C()|0}gb(d+152|0);break H}f=D()|0;C()|0;break H}La:{if(!(k[d+532|0]|k[d+533|0]<<8|(k[d+534|0]<<16|k[d+535|0]<<24))|k[d+855|0]<2){break La}r=0;if(!l[a+480188>>1]){break La}while(1){e=k[d+532|0]|k[d+533|0]<<8|(k[d+534|0]<<16|k[d+535|0]<<24);j[114630]=0;e=E(256,b|0,(e<<8&16711680|e<<24|(e>>>8&65280|e>>>24))+(r<<2)|0)|0;g=j[114630];j[114630]=0;if((g|0)==1){break I}Ma:{if(!e){break Ma}j[114630]=0;e=H(493,b|0)|0;g=j[114630];j[114630]=0;if((g|0)==1){break I}j[114630]=0;f=E(256,b|0,e|0)|0;e=j[114630];j[114630]=0;if((e|0)==1){break I}e=0;g=0;if(!f){break Ma}while(1){Na:{j[114630]=0;f=E(258,b|0,8)|0;s=j[114630];j[114630]=0;Oa:{Pa:{Qa:{if((s|0)!=1){if(!f){break Na}j[114630]=0;E(801,b|0,d+152|0)|0;f=j[114630];j[114630]=0;if((f|0)==1){break Qa}if(!(k[d+152|0]|k[d+153|0]<<8|(k[d+154|0]<<16|k[d+155|0]<<24))){break Na}f=(k[d+152|0]|k[d+153|0]<<8|(k[d+154|0]<<16|k[d+155|0]<<24))&-225;switch((f<<24|f<<8&16711680|(f>>>8&65280|f>>>24))-1|0){case 1:break Oa;case 0:break Pa;default:continue}}f=D()|0;C()|0;break H}f=D()|0;C()|0;break H}e=k[o|0]|k[o+1|0]<<8|(k[o+2|0]<<16|k[o+3|0]<<24);e=e<<24|e<<8&16711680|(e>>>8&65280|e>>>24);continue}g=k[o|0]|k[o+1|0]<<8|(k[o+2|0]<<16|k[o+3|0]<<24);g=g<<24|g<<8&16711680|(g>>>8&65280|g>>>24);continue}break}if(!e|!g){break Ma}j[114630]=0;e=E(256,b|0,e|0)|0;f=j[114630];j[114630]=0;if((f|0)==1){break J}if(!e){break Ma}j[114630]=0;K(635,b|0,((r<<5)+a|0)+480289|0,g|0)|0;e=j[114630];j[114630]=0;if((e|0)==1){break J}}r=r+1|0;if(r>>>0<l[a+480188>>1]){continue}break}}e=k[d+544|0]|k[d+545|0]<<8;j[114630]=0;s=e<<8|e>>>8;F(401,x|0,v+s&65535);g=j[114630];j[114630]=0;Ra:{if((g|0)==1){break Ra}Sa:{if(e){ia=n&16;ja=v&65535;ka=((s&65535)>>>0>1?s:1)&65535;g=0;while(1){Ta:{if(!fa){break Ta}e=k[d+872|0]|k[d+873|0]<<8|(k[d+874|0]<<16|k[d+875|0]<<24);j[114630]=0;e=E(256,b|0,(e<<8&16711680|e<<24|(e>>>8&65280|e>>>24))+(g<<2)|0)|0;f=j[114630];j[114630]=0;if((f|0)==1){break Sa}if(!e){break Ta}j[114630]=0;e=H(493,b|0)|0;f=j[114630];j[114630]=0;if((f|0)==1){break Sa}j[114630]=0;e=E(256,b|0,e|0)|0;f=j[114630];j[114630]=0;if((f|0)==1){break Sa}if(!e){break Ta}J=Cb(d+136|0);j[114630]=0;M=H(277,d+80|0)|0;e=j[114630];j[114630]=0;Ua:{Va:{if((e|0)!=1){f=k[d+855|0];if(f){break Va}j[114630]=0;E(802,b|0,d+152|0)|0;e=j[114630];j[114630]=0;if((e|0)==1){break L}i[d+128>>1]=k[d+152|0];T=k[ga|0]+1|0;e=48;break Ua}f=D()|0;C()|0;break K}n=h[d+806|0];j[114630]=0;E(803,b|0,d+32|0)|0;e=j[114630];j[114630]=0;Wa:{Xa:{if((e|0)!=1){e=k[d+32|0]|k[d+33|0]<<8;i[d+128>>1]=e<<8|e>>>8;e=k[y|0]|k[y+1|0]<<8;T=((e<<8|e>>>8)&65535)+1|0;e=c;if(!(k[e|0]|k[e+1|0]<<8|(k[e+2|0]<<16|k[e+3|0]<<24))){break Wa}r=j[b+8>>2];e=k[c|0]|k[e+1|0]<<8|(k[e+2|0]<<16|k[e+3|0]<<24);j[114630]=0;E(256,b|0,e<<8&16711680|e<<24|(e>>>8&65280|e>>>24))|0;e=j[114630];j[114630]=0;if((e|0)==1){break L}j[114630]=0;E(804,b|0,d+152|0)|0;e=j[114630];j[114630]=0;if((e|0)==1){break L}e=k[o|0]|k[o+1|0]<<8|(k[o+2|0]<<16|k[o+3|0]<<24);j[114630]=0;e=E(256,b|0,e<<8&16711680|e<<24|(e>>>8&65280|e>>>24))|0;t=j[114630];j[114630]=0;if((t|0)==1){break L}if(!e){break Xa}e=k[d+160|0]|k[d+161|0]<<8|(k[d+162|0]<<16|k[d+163|0]<<24);j[114630]=0;K(481,b|0,J|0,e<<8&16711680|e<<24|(e>>>8&65280|e>>>24))|0;e=j[114630];j[114630]=0;if((e|0)!=1){break Xa}break L}break L}Ya:{if(!(k[d+168|0]|k[d+169|0]<<8|(k[d+170|0]<<16|k[d+171|0]<<24))){break Ya}e=k[d+168|0]|k[d+169|0]<<8|(k[d+170|0]<<16|k[d+171|0]<<24);j[114630]=0;e=E(256,b|0,e<<8&16711680|e<<24|(e>>>8&65280|e>>>24))|0;t=j[114630];j[114630]=0;if((t|0)==1){break L}if(!e){break Ya}j[114630]=0;e=H(493,b|0)|0;t=j[114630];j[114630]=0;if((t|0)==1){break L}j[114630]=0;e=E(256,b|0,e|0)|0;t=j[114630];j[114630]=0;if((t|0)==1){break L}if(!e){break Ya}j[114630]=0;I(341,d+56|0,b|0,p(l[d+128>>1],T)|0);e=j[114630];j[114630]=0;if((e|0)==1){break L}Ed(M,d+56|0);jb(d+56|0)}j[114630]=0;E(256,b|0,r|0)|0;e=j[114630];j[114630]=0;if((e|0)==1){break L}}e=n+(f>>>0<3?48:24)|0}j[114630]=0;f=g+ja|0;n=K(402,x|0,f&65535,T|0)|0;r=j[114630];j[114630]=0;if((r|0)==1){break L}if(n){da=Hb(x,f);j[114630]=0;E(495,da|0,J|0)|0;f=j[114630];j[114630]=0;if((f|0)==1){break L}Rf(d+128|0,l[a+480188>>1]);t=0;while(1){j[114630]=0;f=K(471,da|0,t|0,0)|0;n=j[114630];j[114630]=0;Za:{_a:{if((n|0)!=1){r=0;if(l[d+128>>1]){break _a}break Za}break L}while(1){$a:{if(!k[d+855|0]){j[114630]=0;F(805,d+152|0,b|0);n=j[114630];j[114630]=0;if((n|0)!=1){n=Pc(d+152|0);ba=Bf(d+152|0);R=k[d+152|0];h[f+1|0]=R>>>3&16|k[n|0]>>>4|R>>>1&32;h[f+3|0]=k[n|0]&15;h[f+5|0]=k[ba|0];n=R&63;n=n?n+e|0:0;break $a}break L}j[114630]=0;F(595,d+152|0,b|0);n=j[114630];j[114630]=0;ab:{bb:{if((n|0)!=1){R=Pc(d+152|0);ba=Bf(d+152|0);la=pi(d+152|0);j[114630]=0;n=H(387,M|0)|0;Z=j[114630];j[114630]=0;if((Z|0)==1){break L}h[f+4|0]=n;Z=k[d+152|0];n=Z&127;if(!n){break bb}n=e+n|0;break ab}break L}n=0;if((Z|0)!=128){break ab}h[f|0]=254}h[f+1|0]=k[R|0]&63;h[f+3|0]=k[ba|0];h[f+5|0]=k[la|0]}if(n-1>>>0<=119){h[f|0]=n}j[114630]=0;V(806,f|0,(ca|0)!=0|0,(aa|0)!=0|0,X|0,(ia|0)!=0|0);R=j[114630];j[114630]=0;if((R|0)!=1){Q=(n|0)>84&$|Q;f=f+6|0;r=r+1|0;if(l[d+128>>1]<=(r&65535)>>>0){break Za}continue}break}break L}t=t+1|0;if((T|0)!=(t|0)){continue}break}}jb(M);gb(J)}g=g+1|0;if((ka|0)!=(g|0)){continue}break}}ma=d,na=_m(w),j[ma+80>>2]=na;ma=d,na=ii(w),j[ma+56>>2]=na;cb:{while(1){j[114630]=0;e=E(807,d+80|0,d+56|0)|0;g=j[114630];j[114630]=0;if((g|0)==1){break M}db:{eb:{fb:{gb:{hb:{ib:{if(!e){if(!(k[d+464|0]|k[d+465|0]<<8|(k[d+466|0]<<16|k[d+467|0]<<24))){break ib}e=k[d+464|0]|k[d+465|0]<<8|(k[d+466|0]<<16|k[d+467|0]<<24);j[114630]=0;e=E(256,b|0,e<<8&16711680|e<<24|(e>>>8&65280|e>>>24))|0;g=j[114630];j[114630]=0;if((g|0)==1){break Ra}if(!e){break ib}v=s+v|0;bp(w);break O}j[114630]=0;e=H(808,d+80|0)|0;g=j[114630];j[114630]=0;if((g|0)==1){break hb}g=l[e>>1];if(!g){f=0;break gb}j[114630]=0;g=E(546,q|0,g-1&65535)|0;f=j[114630];j[114630]=0;if((f|0)==1){break db}f=l[e>>1];if(!g){break gb}j[114630]=0;f=E(809,q|0,f-1&65535)|0;g=j[114630];j[114630]=0;if((g|0)!=1){break fb}break db}bp(w);break N}f=D()|0;C()|0;break H}if(l[e+2>>1]==((f&65535)+1|0)){break eb}j[114630]=0;f=K(810,x|0,1,0)|0;g=j[114630];j[114630]=0;if((g|0)==1){break db}if((f|0)==65535){break eb}ma=bc(q,l[e>>1]),na=f,i[ma>>1]=na}g=Hb(x,f);e=l[e+2>>1];j[114630]=0;e=H(811,e|0)|0;n=j[114630];j[114630]=0;if((n|0)==1){break cb}j[114630]=0;e=K(497,d+152|0,12,e|0)|0;n=j[114630];j[114630]=0;if((n|0)==1){break cb}e=hn(Ee(e,j[Hb(x,f)+12>>2]-1|0));j[114630]=0;E(498,g|0,e|0)|0;e=j[114630];j[114630]=0;if((e|0)==1){break cb}s=(s&65535)>>>0>f>>>0?s:f+1|0}j[114630]=0;H(812,d+80|0)|0;e=j[114630];j[114630]=0;if((e|0)!=1){continue}break M}break}f=D()|0;C()|0;break H}f=D()|0;C()|0;break H}f=D()|0;C()|0;break H}f=D()|0;C()|0;break H}W=W+1|0;if(k[_|0]>(W&255)>>>0){continue}break}}j[114630]=0;F(488,a+484360|0,0);b=j[114630];j[114630]=0;if((b|0)!=1){if(!(Q&1)){o=l[a+480192>>1];if(o){f=1;while(1){b=(((f&65535)<<2)+a|0)+900380|0;c=j[b>>2];if(c){Fb(Ls(c));o=l[a+480192>>1]}j[b>>2]=0;f=f+1|0;if((f&65535)>>>0<=(o&65535)>>>0){continue}break}}i[a+480192>>1]=0}jb:{kb:{lb:{mb:{nb:{ob:{pb:{if(ea){j[114630]=0;b=E(2,d+152|0,14917)|0;c=j[114630];j[114630]=0;if((c|0)==1){break pb}j[114630]=0;I(646,a|0,2,b|0);c=j[114630];j[114630]=0;if((c|0)==1){break ob}gb(b)}o=14964;switch(k[d+855|0]){case 3:break kb;case 2:break lb;case 1:break mb;case 0:break nb;default:break jb}}f=D()|0;C()|0;break f}f=D()|0;C()|0;gb(b);break f}o=l[a+480188>>1]>4?14965:14986;break jb}o=15e3;break jb}o=15018;break jb}o=15036}j[114630]=0;b=E(2,d+16|0,15063)|0;c=j[114630];j[114630]=0;qb:{rb:{sb:{tb:{ub:{if((c|0)!=1){j[114630]=0;F(219,d+80|0,b|0);c=j[114630];j[114630]=0;if((c|0)==1){break ub}j[114630]=0;I(536,d+152|0,d+80|0,d+855|0);c=j[114630];j[114630]=0;if((c|0)==1){break tb}ob(a+1304436|0,d+152|0);gb(d+152|0);qb(d+80|0);gb(b);j[114630]=0;b=E(2,d+152|0,15079)|0;c=j[114630];j[114630]=0;if((c|0)==1){break rb}ob(a+1304448|0,b);gb(b);j[114630]=0;E(238,a+1304460|0,o|0)|0;b=j[114630];j[114630]=0;f=1;if((b|0)==1){break qb}j[a+1304496>>2]=2;break c}f=D()|0;C()|0;break f}f=D()|0;C()|0;break sb}f=D()|0;C()|0;qb(d+80|0)}gb(b);break f}f=D()|0;C()|0;break f}f=D()|0;C()|0;break f}f=D()|0;C()|0;break f}f=D()|0;C()|0;break H}f=D()|0;C()|0;jb(M)}gb(J);break H}f=D()|0;C()|0;break H}f=D()|0;C()|0}bp(w);break f}f=D()|0;C()|0;break f}f=D()|0;C()|0;break f}f=D()|0;C()|0;jb(w)}oP(S)}jb(d+832|0);G(f|0);z()}f=0}oP(S)}jb(d+832|0)}Za=d+912|0;return f|0}function Vr(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,n=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,J=0,M=0,O=0,Q=0,R=0,S=0,T=0,V=0,W=0,X=0,Y=0,_=0,$=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0;g=Za-176|0;Za=g;Xoa(a);J=kpa(g+144|0);e=l[d+4>>1];i[J+24>>1]=e;s=j[d>>2];j[J+16>>2]=s;ba=j[d+16>>2];ga=k[d+6|0];la=b+484360|0;if(ga>>>0>=rh(la)>>>0){ga=k[la+16|0]}na=a;V=ei(la,ga);j[114630]=0;B=E(1327,g+104|0,b|0)|0;a=j[114630];j[114630]=0;a:{if((a|0)!=1){f=j[B+4>>2];j[114630]=0;ca=K(1328,g+72|0,b|0,ga|0)|0;a=j[114630];j[114630]=0;b:{if((a|0)!=1){i[f+64>>1]=e;i[f+62>>1]=e;j[f+52>>2]=s;j[f+48>>2]=s;Y=g- -64|0;vf(Y);pa=Ws(g+56|0);c:{d:{e:{f:{g:{h:{i:{j:{k:{l:{m:{qa=c&7;sa=(qa|0)!=7;n:{if(sa){break n}j[114630]=0;K(1329,Y|0,1,1)|0;a=j[114630];j[114630]=0;if((a|0)==1){break m}j[114630]=0;K(1329,Y|0,2,1)|0;a=j[114630];j[114630]=0;if((a|0)==1){break m}j[114630]=0;K(1329,Y|0,3,1)|0;a=j[114630];j[114630]=0;if((a|0)==1){break m}j[114630]=0;K(1329,Y|0,28,1)|0;a=j[114630];j[114630]=0;if((a|0)==1){break m}j[114630]=0;K(1329,Y|0,35,1)|0;a=j[114630];j[114630]=0;if((a|0)==1){break m}j[114630]=0;K(1329,Y|0,37,1)|0;a=j[114630];j[114630]=0;if((a|0)==1){break m}j[114630]=0;K(1329,Y|0,36,1)|0;a=j[114630];j[114630]=0;if((a|0)==1){break m}j[114630]=0;K(1329,Y|0,38,1)|0;a=j[114630];j[114630]=0;if((a|0)==1){break m}j[114630]=0;K(1330,pa|0,12,1)|0;a=j[114630];j[114630]=0;if((a|0)==1){break m}j[114630]=0;K(1330,pa|0,13,1)|0;a=j[114630];j[114630]=0;if((a|0)==1){break m}if(l[b+480188>>1]){e=B+20|0;a=0;while(1){if(k[((a<<5)+b|0)+480281|0]&4){Ba=zc(e,a),Ca=-1,j[Ba+16>>2]=Ca}a=a+1|0;if(a>>>0<l[b+480188>>1]){continue}break}}if((ba|0)!=2){break n}a=l[d+12>>1];if(Yb(V)>>>0<=a>>>0){break n}a=l[bc(V,a)>>1];j[114630]=0;e=b+484344|0;s=E(442,e|0,a|0)|0;n=j[114630];j[114630]=0;if((n|0)==1){break d}if(!s){break n}n=Hb(e,a);s=j[d+8>>2];j[114630]=0;n=E(1331,n|0,s|0)|0;M=j[114630];j[114630]=0;if((M|0)==1){break d}if(!n){break n}a=Hb(e,a);j[114630]=0;a=K(471,a|0,s|0,0)|0;e=j[114630];j[114630]=0;if((e|0)==1){break e}if(!l[b+480188>>1]){break n}s=B+20|0;e=0;while(1){o:{p:{q:{switch(k[a|0]-253|0){case 0:if(l[b+480192>>1]){break p}break;case 1:case 2:break p;default:break q}}j[114630]=0;n=H(553,a|0)|0;M=j[114630];j[114630]=0;if((M|0)==1){break f}if(!n){break o}if(Wr(a)){break o}}Ba=zc(s,e),Ca=-1,j[Ba+16>>2]=Ca}a=a+6|0;e=e+1|0;if(e>>>0<l[b+480188>>1]){continue}break}}ea=f- -64|0;W=f+48|0;da=f+68|0;ua=f+44|0;ra=B+8|0;ha=c&1;A=B+20|0;O=b+1074308|0;X=b+484344|0;va=(ba|0)!=3;ta=(ba|0)!=2;M=0;while(1){j[f+48>>2]=j[f+52>>2];a=l[f+64>>1];i[f+62>>1]=a;j[114630]=0;a=E(546,V|0,a|0)|0;e=j[114630];j[114630]=0;r:{if((e|0)!=1){s:{if(!a){break s}if(m[f+48>>2]<m[Hb(X,l[bc(V,l[f+62>>1])>>1])+12>>2]){break s}j[W>>2]=0;mb(g,O,63);if(kb(g)){a=j[f+56>>2];j[f+56>>2]=0;j[f+48>>2]=a}a=l[f+64>>1]+1|0;i[f+62>>1]=a;i[f+64>>1]=a}if(o[B+32>>3]<o[d+8>>3]|va){break r}h[J+26|0]=1;break g}a=D()|0;C()|0;break c}e=l[f+62>>1];a=f;t:{if(Yb(V)>>>0>e>>>0){e=l[bc(V,l[f+62>>1])>>1];break t}e=65535}i[a+60>>1]=e;j[114630]=0;a=E(442,X|0,e&65535)|0;e=j[114630];j[114630]=0;if((e|0)==1){break i}if(!(l[f+60>>1]==65535|ta|a|l[f+62>>1]!=l[d+12>>1])){h[J+26|0]=1;break g}u:{if(l[f+60>>1]<me(X)>>>0){break u}while(1){a=f;n=a;v:{w:{if(l[a+60>>1]!=65535){e=l[f+62>>1];if(Yb(V)>>>0>e>>>0){break w}}if(l[V+28>>1]==l[f+62>>1]){break u}e=l[V+28>>1];break v}e=l[f+62>>1]+1|0}i[n+62>>1]=e;a=f;x:{if(Yb(V)>>>0>(e&65535)>>>0){e=l[bc(V,l[f+62>>1])>>1];break x}e=65535}i[a+60>>1]=e;i[f+64>>1]=l[f+62>>1];j[114630]=0;a=E(442,X|0,e&65535)|0;e=j[114630];j[114630]=0;if((e|0)==1){break h}y:{if(a){break y}a=l[f+62>>1];j[114630]=0;a=P(1332,ca|0,a|0,0,1)|0;e=j[114630];j[114630]=0;if((e|0)==1){break h}if(!a){break y}if(ba>>>0<=1){a=l[f+62>>1];j[J+8>>2]=0;i[J+20>>1]=a;if(!ba){break u}}j[114630]=0;a=P(1333,ca|0,ea|0,W|0,1)|0;e=j[114630];j[114630]=0;if((e|0)==1){break i}if(!a){break u}o[J>>3]=o[B+32>>3];j[114630]=0;F(1334,na|0,J|0);a=j[114630];j[114630]=0;if((a|0)==1){break i}j[J+16>>2]=j[W>>2];i[J+24>>1]=l[ea>>1];j[114630]=0;N(1335,B|0);a=j[114630];j[114630]=0;if((a|0)==1){break i}a=l[f+64>>1];i[f+62>>1]=a;Ba=f,Ca=l[bc(V,a)>>1],i[Ba+60>>1]=Ca;j[f+52>>2]=j[f+48>>2];break u}if(l[f+60>>1]>=me(X)>>>0){continue}break}}if(l[ea>>1]==65535){break g}a=l[f+60>>1];j[114630]=0;a=E(442,X|0,a|0)|0;e=j[114630];j[114630]=0;if((e|0)==1){break i}if(!a){if(l[V+28>>1]==l[f+62>>1]){if(!ba){break g}j[114630]=0;a=P(1333,ca|0,ea|0,W|0,1)|0;e=j[114630];j[114630]=0;if((e|0)==1){break i}if(!a){break g}o[J>>3]=o[B+32>>3];j[114630]=0;F(1334,na|0,J|0);a=j[114630];j[114630]=0;if((a|0)==1){break i}j[J+16>>2]=j[W>>2];i[J+24>>1]=l[ea>>1];j[114630]=0;N(1335,B|0);a=j[114630];j[114630]=0;if((a|0)==1){break i}j[f+52>>2]=j[f+48>>2];continue}i[f+64>>1]=l[f+62>>1]+1;continue}if(m[f+48>>2]>=m[Hb(X,l[f+60>>1])+12>>2]){j[W>>2]=0}a=l[f+62>>1];if(!((a|0)!=l[d+12>>1]|ta|j[W>>2]!=j[d+8>>2])){h[J+26|0]=1;break g}e=j[W>>2];j[114630]=0;a=P(1332,ca|0,a|0,e|0,1)|0;e=j[114630];j[114630]=0;if((e|0)==1){break i}if(a){if(ba>>>0<=1){i[J+20>>1]=l[f+62>>1];j[J+8>>2]=j[f+48>>2];if(!ba){break g}}j[114630]=0;a=P(1333,ca|0,ea|0,W|0,1)|0;e=j[114630];j[114630]=0;if((e|0)==1){break i}if(!a){break g}o[J>>3]=o[B+32>>3];j[114630]=0;F(1334,na|0,J|0);a=j[114630];j[114630]=0;if((a|0)==1){break i}j[J+16>>2]=j[W>>2];i[J+24>>1]=l[ea>>1];j[114630]=0;N(1335,B|0);a=j[114630];j[114630]=0;if((a|0)==1){break i}j[f+52>>2]=j[f+48>>2];continue}i[J+22>>1]=l[f+62>>1];a=j[f+48>>2];j[J+12>>2]=a;j[f+52>>2]=a+1;z:{A:{if(a>>>0>=m[Hb(X,l[f+60>>1])+12>>2]){j[W>>2]=0;break A}if(j[W>>2]){break z}}a=0;if(!l[b+480188>>1]){break z}while(1){S=o[B+32>>3];Ba=zc(A,a),Da=S,o[Ba>>3]=Da;e=j[f>>2];Ba=zc(A,a),Ca=e,j[Ba+8>>2]=Ca;a=a+1|0;if(a>>>0<l[b+480188>>1]){continue}break}}a=Hb(X,l[f+60>>1]);e=j[f+48>>2];j[114630]=0;a=K(471,a|0,e|0,0)|0;e=j[114630];j[114630]=0;B:{C:{D:{if((e|0)!=1){e=0;_=0;ia=0;if(!l[b+480188>>1]){break C}while(1){E:{mb(g,O,77);F:{if(Ba=kb(g),Ca=0,Ea=j[((e<<5)+b|0)+480280>>2]&1024,Ea?Ba:Ca){break F}j[114630]=0;s=H(1336,a|0)|0;n=j[114630];j[114630]=0;G:{H:{I:{if((n|0)==1){break I}if(s){J:{if(!ha){break J}s=k[a+1|0];if(s-251>>>0<5|!s){break J}j[114630]=0;s=H(1337,a|0)|0;n=j[114630];j[114630]=0;if((n|0)==1){break I}j[114630]=0;n=H(1338,a|0)|0;t=j[114630];j[114630]=0;if((t|0)==1){break E}i[g+48>>1]=n;h[g|0]=k[a+1|0];i[g+2>>1]=l[g+48>>1];j[114630]=0;n=E(1339,ra|0,g|0)|0;t=j[114630];j[114630]=0;if((t|0)==1){break E}i[n>>1]=s}ys((p(e,896)+f|0)+1418|0);break F}s=p(e,896)+f|0;n=s+1422|0;t=k[a+4|0]|k[a+5|0]<<8;h[n|0]=t;h[n+1|0]=t>>>8;s=s+1418|0;n=k[a|0]|k[a+1|0]<<8|(k[a+2|0]<<16|k[a+3|0]<<24);h[s|0]=n;h[s+1|0]=n>>>8;h[s+2|0]=n>>>16;h[s+3|0]=n>>>24;K:{switch(k[a+3|0]-16|0){case 0:s=k[a+5|0];j[114630]=0;I(1340,b|0,f|0,s|0);s=j[114630];j[114630]=0;if((s|0)==1){break I}break F;case 3:break G;case 4:break H;case 1:break K;default:break F}}mb(g,O,5);if(!kb(g)){break F}s=k[a+5|0];if(!s){break F}j[114630]=0;I(1340,b|0,f|0,s|0);s=j[114630];j[114630]=0;if((s|0)!=1){break F}}a=D()|0;C()|0;break c}s=k[a+5|0];n=s&240;if((n|0)==96){ia=(s&15)+ia|0;break F}if((n|0)!=224|_){break F}s=k[a+5|0]&15;if(j[b+480180>>2]&2){_=0;if(!s){break F}}_=s+1|0;break F}s=k[a+5|0];if((s&240)!=224){break F}_=(s&15)+1|0}a=a+6|0;e=e+1|0;if(e>>>0<l[b+480188>>1]){continue}break D}break}a=D()|0;C()|0;break c}a=D()|0;C()|0;break c}e=ia;if(_){break B}}_=1;ia=e}R=p(j[f+40>>2]+ia|0,_);L:{if(!l[b+480188>>1]){s=0;ja=0;oa=0;fa=0;ka=0;break L}u=R-1|0;n=R-_|0;T=p(n,1e4);e=0;ka=0;fa=0;oa=0;ja=0;s=0;while(1){M:{t=p(e,896)+f|0;v=t+1418|0;N:{if(cpa(v)){break N}mb(g,O,77);if(Ba=kb(g),Ca=0,Ea=j[((e<<5)+b|0)+480280>>2]&1024,Ea?Ba:Ca){break N}r=k[t+1423|0];$=t+1421|0;x=k[$|0];y=k[v|0];a=t+1419|0;w=k[a|0];if(w){h[t+1429|0]=0;h[t+1433|0]=w;Ba=zc(A,e),Ca=255,h[Ba+21|0]=Ca}j[114630]=0;w=H(553,v|0)|0;Q=j[114630];j[114630]=0;if((Q|0)==1){break M}if(w){h[t+1429|0]=y}j[114630]=0;Q=H(553,v|0)|0;w=j[114630];j[114630]=0;if((w|0)==1){break M}w=t+608|0;O:{P:{Q:{R:{S:{T:{if(k[a|0]?0:!Q){break T}Q=t+1433|0;a=k[Q|0];if(l[b+480192>>1]){if(l[b+480192>>1]<a>>>0){break T}a=j[((k[Q|0]<<2)+b|0)+900380>>2];if(!a){break T}U:{if(!(h[a+15|0]&1)){break U}Q=j[a+8>>2];j[114630]=0;I(1341,w|0,Q|0,b|0);Q=j[114630];j[114630]=0;if((Q|0)!=1){break U}a=D()|0;C()|0;break c}if(!Ld(y)){break T}a=l[Nc(a+236|0,y-1|0)>>1]}if(!a|l[b+480190>>1]<a>>>0){break T}a=p(a,104)+b|0;if(!(k[a+484414|0]&32)){break T}a=l[a+484408>>1];j[114630]=0;I(1341,w|0,a|0,b|0);a=j[114630];j[114630]=0;if((a|0)==1){break S}}V:{W:{X:{Q=t+1420|0;a=k[Q|0];switch(a-1|0){case 1:break Q;case 2:case 3:break W;case 0:break X;default:break V}}a=k[t+1422|0];Ba=zc(A,e),Ca=a,h[Ba+21|0]=Ca;break Q}a=k[t+1422|0];if(!a){break Q}h[t+1462|0]=a;break Q}if((a|0)==11){break R}break Q}a=D()|0;C()|0;break c}if(!k[t+1422|0]){break Q}rx(g,b,v,0);a=Rb(g);j[t+1384>>2]=j[g>>2]<<2;if(!k[a|0]){break Q}x=0;break P}Y:{Z:{_:{switch(x-12|0){case 0:a=j[f+48>>2];r=l[f+60>>1];j[114630]=0;a=U(1342,b|0,r|0,a|0,e&65535,0)|0;r=j[114630];j[114630]=0;if((r|0)==1){break M}j[f+56>>2]=0;i[f+64>>1]=a;if(!(j[b+480180>>2]&5?0:oa)){j[f+52>>2]=0}fa=1;if(!ha){ka=1;break N}j[t+1412>>2]=0;h[t+1469|0]=0;ka=1;break O;case 2:j[114630]=0;a=P(1343,b|0,f|0,e&65535,r|0)|0;v=j[114630];j[114630]=0;if((v|0)==1){break Z}if((a|0)==-1){x=14;break P}j[f+52>>2]=a;if(!ka){i[f+64>>1]=l[f+62>>1]+1}oa=1;if(!ha){break N}j[t+1412>>2]=0;h[t+1469|0]=0;break O;case 5:mb(g,O,5);x=17;if(kb(g)){break P}a=j[f+48>>2];v=l[f+60>>1];j[114630]=0;a=U(1342,b|0,v|0,a|0,e&65535,0)|0;v=j[114630];j[114630]=0;$:{aa:{if((v|0)!=1){a=p(a,1e4);if(!ha|!(j[b+480180>>2]&16777250)){break $}if(a>>>0<1e4){break aa}h[t+1463|0]=(a>>>0)/1e4;break $}a=D()|0;C()|0;break c}a=p(k[t+1463|0],1e4)}v=(a>>>0)/1e4|0;ba:{if(a>>>0>319999){break ba}y=p(T,v&15);a=j[f+44>>2];if((v&240)==16){a=a+y|0;break ba}v=a-y|0;a=a>>>0<v>>>0?0:v}j[f+44>>2]=a;a=j[j[b+8>>2]+20>>2];v=j[j[b+8>>2]+24>>2];mb(g,O,8);An(ua,p(a,1e4),kb(g)?255e4:p(v,1e4));break P;case 8:x=20;ca:{switch((r&240)-144>>>4|0){case 0:if(r>>>0>145){break P}j[t+696>>2]=j[t+696>>2]&-257|((r|0)==145)<<8;break P;case 1:h[t+1464|0]=r&15;break P;case 2:v=e;a=e;if(j[b+480180>>2]==2){v=l[b+480188>>1]-1|0;a=0}if(!(r&15)){fa=0;s=1;v=v&65535;if(v>>>0<(a&65535)>>>0){break P}while(1){S=o[B+32>>3];s=a&65535;Ba=zc(A,s),Da=S,o[Ba>>3]=Da;y=j[f>>2];Ba=zc(A,s),Ca=y,j[Ba+8>>2]=Ca;y=j[f+48>>2];Ba=zc(A,s),Ca=y,j[Ba+12>>2]=Ca;j[(p(s,896)+f|0)+1412>>2]=j[f+48>>2];s=1;a=a+1|0;if(v>>>0>=(a&65535)>>>0){continue}break}break P}mb(g,O,16);if(!kb(g)){fa=0;ja=1;if(j[b+480180>>2]!=2|(a&65535)>>>0>(v&65535)>>>0){break P}break Y}if((a&65535)>>>0<=(v&65535)>>>0){break Y}fa=0;ja=1;break P;case 6:break ca;default:break P}}h[t+1472|0]=r&15;break P;case 7:x=19;a=r&240;if((a|0)!=240){if((a|0)!=96){break P}if(r&15){Ba=f,Ca=j[zc(A,e)+12>>2],j[Ba+56>>2]=Ca;ja=1;break P}S=o[B+32>>3];Ba=zc(A,e),Da=S,o[Ba>>3]=Da;a=j[f>>2];Ba=zc(A,e),Ca=a,j[Ba+8>>2]=Ca;a=j[f+48>>2];Ba=zc(A,e),Ca=a,j[Ba+12>>2]=Ca;j[t+1412>>2]=j[f+48>>2];s=1;break P}h[t+1472|0]=r&15;break P;case 1:case 3:case 4:case 6:break P;default:break _}}if((x|0)!=28){break P}if((r&240)==160){mb(g,O,58);x=28;if(kb(g)){break P}h[t+1464|0]=r&15;break P}x=28;break P}a=D()|0;C()|0;break c}y=j[W>>2]+1|0;while(1){j[(p(a&65535,896)+f|0)+1412>>2]=y;ja=1;fa=0;a=a+1|0;if((a&65535)>>>0<=(v&65535)>>>0){continue}break}}if(!ha){break N}da:{ea:{fa:{ga:{ha:{ia:{ja:{switch(x-2|0){case 0:if(!r){break O}mb(g,O,90);if(!kb(g)){h[t+1440|0]=r}h[t+1439|0]=r;break O;case 1:if(!r){break O}mb(g,O,90);if(!kb(g)){h[t+1439|0]=r}h[t+1440|0]=r;break O;case 2:if(!r){break O}j[t+1384>>2]=r<<2;break O;case 8:if(!r){break O}j[t+1272>>2]=r<<8;break O;case 4:case 9:if(!r){break O}h[t+1437|0]=r;break O;case 11:Ba=zc(A,e),Ca=r,h[Ba+21|0]=Ca;break O;case 21:a=r<<(!(j[b+480180>>2]&59593760)&r<<24>>24>-1)&255;if(a>>>0<=128){j[da>>2]=a<<1;break O}if(j[b+480180>>2]&16777250){break O}j[da>>2]=256;break O;case 22:mb(g,O,9);ka:{if(kb(g)){a=t+1445|0;if(r){h[a|0]=r;break ka}r=k[a|0];break ka}if(r){h[f+1445|0]=r;break ka}r=k[f+1445|0]}a=da;v=r&240;y=r&15;la:{if(!(!v|(y|0)!=15)){x=j[da>>2]+(v>>>4<<!(j[b+480180>>2]&59593760)<<1&254)|0;break la}x=j[da>>2]-(y<<(j[b+480180>>2]&59593760?1:2))|0;if(!(!y|(v|0)!=240)){break la}x=j[da>>2]+p(n,(r>>>3&30)<<!(j[b+480180>>2]&59593760)&254)|0;if(v){break la}x=j[da>>2]-p(n,y<<(j[b+480180>>2]&59593760?1:2))|0}j[a>>2]=x;Md(da,0,256);break O;case 19:if(r>>>0>64){break O}j[t+1368>>2]=r;break O;case 20:a=t+1444|0;ma:{if(r){h[a|0]=r;break ma}r=k[a|0]}y=t+1368|0;v=j[y>>2];a=r;x=a&240;r=a&15;na:{if(!(!x|(r|0)!=15)){j[g>>2]=v+(a>>>4|0);break na}if(!(!r|(x|0)!=240)){j[g>>2]=v-r;break na}if(r){j[g>>2]=v-p(r,n);break na}j[g>>2]=v+p(n,a>>>4|0)}Md(g,0,64);j[y>>2]=j[g>>2];break O;case 7:dl(b,w,r,8);break O;case 25:break da;case 6:break ea;case 24:break fa;case 3:break ga;case 5:break ha;case 18:break ia;case 17:break ja;default:break O}}if(!l[b+480188>>1]|r>>>0>15){break ia}v=(r&1)<<14;a=0;while(1){y=p(a,896)+f|0;j[y+696>>2]=(v|j[y+696>>2]&-16385)^16384;a=a+1|0;if(a>>>0<l[b+480188>>1]){continue}break}}if((r&240)!=128){break O}dl(b,w,r&15,4);break O}if(r){h[t+1437|0]=r}r=0}Oj(w,r);break O}UK(b,w,r);break O}TK(w,r);break O}SK(w,r)}oa:{pa:{switch(k[Q|0]-2|0){case 0:dl(b,w,k[t+1422|0],6);break oa;case 5:mb(g,O,53);r=kb(g);a=k[t+1422|0];if(r){h[t+1451|0]=a&15;break oa}Oj(w,a<<4);break oa;case 6:break pa;default:break oa}}Oj(w,k[t+1422|0])}qa:{ra:{sa:{ta:{a=k[$|0];switch(a-5|0){case 3:break ra;case 0:case 2:break sa;case 1:break N;default:break ta}}switch(a-26|0){case 1:break qa;case 0:break sa;default:break N}}ua:{if(j[b+480180>>2]&16777248){a=R;if(!(k[b+480208|0]&4)){break ua}}a=n}r=k[t+1451|0];mb(g,O,21);w=kb(g);t=t+1447|0;a=p(a,r);h[t|0]=k[t|0]+(w?a<<2:a);break N}va:{if(j[b+480180>>2]&16777248){a=R;if(!(k[b+480208|0]&4)){break va}}a=n}r=k[t+1454|0];mb(g,O,21);w=kb(g);t=t+1448|0;a=p(a,r);h[t|0]=k[t|0]+(w?a<<2:a);break N}a=t+1449|0;h[a|0]=k[a|0]+p(u,k[t+1457|0]);j[114630]=0;F(1344,b|0,w|0);a=j[114630];j[114630]=0;if((a|0)==1){break M}}e=e+1|0;if(e>>>0<l[b+480188>>1]){continue}break L}break}a=D()|0;C()|0;break c}if(j[f+40>>2]==65535?j[b+480180>>2]==4:0){break g}j[f+32>>2]=j[b+480216>>2];if(RK(Hb(X,l[f+60>>1]))){Ba=f,Ca=j[Hb(X,l[f+60>>1])+16>>2],j[Ba+32>>2]=Ca}j[114630]=0;t=E(1345,b|0,f|0)|0;a=j[114630];j[114630]=0;wa:{xa:{if((a|0)!=1){a=p(t,R);o[B+32>>3]=+(a>>>0)/+m[b+24620>>2]+o[B+32>>3];j[f>>2]=a+j[f>>2];if(!(!l[b+480188>>1]|sa)){x=0;wa=(M|0)!=0&(t|0)!=(M|0);xa=R>>>0>1?R:1;ya=_-1|0;while(1){ya:{if(j[zc(A,x)+16>>2]==-1){break ya}v=1;za:{Aa:{u=p(x,896)+f|0;$=u+1421|0;switch(k[$|0]-4|0){case 0:case 2:break za;default:break Aa}}v=k[u+1420|0]==11}if(k[u+1419|0]){j[u+1268>>2]=0}T=u+1423|0;a=k[T|0];j[114630]=0;Q=u+1418|0;e=H(553,Q|0)|0;n=j[114630];j[114630]=0;if((n|0)==1){break k}w=u+608|0;n=a&15;y=0;Ba:{if(!e){break Ba}Ca:{Da:{Ea:{if(!v){break Ea}if(!k[zc(A,x)+20|0]){break Ea}e=j[u+1308>>2];j[114630]=0;e=Kn(1346,b,w,e,0);r=ab;y=j[114630];j[114630]=0;if((y|0)==1){break Da}j[u+616>>2]=e;j[u+620>>2]=r}h[u+1432|0]=k[u+1429|0];r=u+1300|0;za=j[r>>2];e=k[u+1433|0];if(!e){break Ca}j[114630]=0;aa(1347,b|0,w|0,e|0,v|0,1,1);e=j[114630];j[114630]=0;if((e|0)!=1){break Ca}break j}a=D()|0;C()|0;break c}e=k[Q|0];j[114630]=0;Z(1348,b|0,w|0,e|0,v|0,1,0,65535);e=j[114630];j[114630]=0;if((e|0)==1){break j}e=a>>>4|0;Ba=zc(A,x),Ca=1,h[Ba+20|0]=Ca;Aa=!(j[b+480180>>2]&16777250);y=k[$|0];Fa:{if(!((y-19&255)>>>0>1|n>>>0>=R>>>0)){a=n;if((k[T|0]&-16)==208){break Fa}}a=e>>>0<R>>>0?(y|0)==33?e:0:0}y=a;if(!(Aa|(!y|_>>>0<2))){y=p(j[f+40>>2]+ia|0,ya)+y|0}if(!v){Ba=zc(A,x),Ca=0,j[Ba+16>>2]=Ca}a=k[$|0];Ga:{Ha:{Ia:{if(a-19>>>0>=2){if((a|0)!=9){break Ia}break Ha}if((e|0)==8){break Ha}}if(k[u+1420|0]!=2){break Ga}}j[r>>2]=za}Ja:{Ka:{switch(a-39|0){default:if((a|0)!=10){break Ja}h[g|0]=0;a=j[f+48>>2];e=l[f+60>>1];j[114630]=0;a=U(1342,b|0,e|0,a|0,x&65535,g|0)|0;e=j[114630];j[114630]=0;if((e|0)!=1){if(!k[g|0]){a=a<<8;if(!a){a=j[u+1272>>2]}a=(k[u+1464|0]<<16)+a|0}j[114630]=0;I(1349,b|0,w|0,a|0);a=j[114630];j[114630]=0;if((a|0)!=1){break Ba}}a=D()|0;C()|0;break c;case 2:a=j[u+684>>2];e=k[T|0];j[114630]=0;e=HMa(a,0,e,0);a=ab;r=a>>>8|0;a=ig(789,(a&255)<<24|e>>>8,r);e=j[114630];j[114630]=0;if((e|0)==1){break j}j[114630]=0;I(1349,b|0,w|0,a|0);a=j[114630];j[114630]=0;if((a|0)==1){break j}break Ba;case 1:break Ja;case 0:break Ka}}if(!j[u+712>>2]){break Ja}j[114630]=0;L(1350,B|0,x&65535,M|0,-1);a=j[114630];j[114630]=0;if((a|0)==1){break j}a=k[T|0];j[114630]=0;I(1351,f|0,w|0,a|0);a=j[114630];j[114630]=0;if((a|0)==1){break j}y=j[f+40>>2]-1|0;break Ba}if(k[u+1420|0]!=15){break Ba}a=k[u+1422|0];if(a>>>0>9){break Ba}e=j[u+712>>2];if(!e){break Ba}La:{if(!a){a=j[u+1272>>2];break La}a=j[(e+(a<<2)|0)- -64>>2];j[u+1272>>2]=a}j[114630]=0;I(1349,b|0,w|0,a|0);a=j[114630];j[114630]=0;if((a|0)!=1){break Ba}a=D()|0;C()|0;break c}Ma:{Na:{Oa:{Pa:{Qa:{Ra:{Sa:{Ta:{Ua:{Va:{switch(k[Q|0]-253|0){case 0:if(l[b+480192>>1]){break Ua}break;case 1:case 2:break Ua;default:break Va}}e=k[$|0];if((e-19&255)>>>0<=1){if(n>>>0>=R>>>0){a=s;break Sa}a=s;if((k[T|0]&-16)==192){break Ua}break Sa}r=e;if((e|0)==25){break Ua}a=s;if(!((r|0)==33&(n|0)!=0&n+y>>>0<R>>>0)){break Ta}}e=k[$|0];a=1}if((e|0)==13){break Ra}}if(k[u+1420|0]==1){j[u+1296>>2]=k[u+1422|0]<<2}if((!j[u+712>>2]|a)&1){break Qa}n=0;if(e>>>0>42){break Oa}break Pa}j[u+1296>>2]=k[T|0]<<2;e=13;if(!((!j[u+712>>2]|a)&1)){break Pa}}if(!(a&1)){break Na}break Ma}mb(g,Y,e);n=1;if(kb(g)){break Oa}n=a;if(k[$|0]!=19){break Oa}e=k[T|0]&240;if((e|0)!=32){n=a;if((e|0)!=16){break Oa}}n=1}a=u+1420|0;if(k[a|0]<16){qj(g,pa,k[a|0]);if((kb(g)|n)&1){break Ma}break Na}if(n&1){break Ma}}if(wa){j[114630]=0;L(1350,B|0,x&65535,M|0,-1);a=j[114630];j[114630]=0;if((a|0)==1){break k}}Wa:{Xa:{Ya:{a=k[$|0];if(a-6>>>0>=2){Za:{switch(a-19|0){case 1:break Xa;case 0:break Ya;default:break Za}}if((a|0)!=11){break Wa}}if(!R|(j[b+480180>>2]==1?!k[T|0]:0)){break Wa}a=u+1480|0;e=0;while(1){h[a|0]=!e|k[a|0]&254;Gm(b,w,k[T|0]);e=e+1|0;if((xa|0)!=(e|0)){continue}break}break Wa}e=k[T|0];if(!(e&15)){if(!(j[b+480180>>2]&1048580)){break Wa}e=k[T|0]}a=u+1480|0;h[a|0]=k[a|0]|1;a=e&240;if((a|0)!=176){if((a|0)!=160){break Wa}Eo(b,w,e&15,0);break Wa}Do(b,w,e&15,0);break Wa}_a:{switch(k[T|0]-158|0){case 0:j[114630]=0;L(1350,B|0,x&65535,M|0,-1);a=j[114630];j[114630]=0;if((a|0)==1){break k}j[u+696>>2]=j[u+696>>2]&-129;break Wa;case 1:break _a;default:break Wa}}j[114630]=0;L(1350,B|0,x&65535,M|0,-1);a=j[114630];j[114630]=0;if((a|0)==1){break k}j[u+696>>2]=j[u+696>>2]|128;if(!j[u+684>>2]|j[w+4>>2]){break Wa}j[114630]=0;a=H(553,Q|0)|0;e=j[114630];j[114630]=0;if((e|0)==1){break k}if(k[u+696|0]&2?!a:0){break Wa}e=j[u+684>>2]-1|0;a=w;j[a>>2]=-1;j[a+4>>2]=e}e=u+1480|0;h[e|0]=k[e|0]|1;$a:{ab:{bb:{cb:{a=u+1420|0;switch(k[a|0]-3|0){case 0:case 1:break ab;case 3:break bb;case 2:break cb;default:break $a}}a=k[u+1422|0];mb(g,O,41);Eo(b,w,a,kb(g));break $a}a=k[u+1422|0];mb(g,O,41);Do(b,w,a,kb(g));break $a}r=k[u+1422|0];db:{if(r){break db}mb(g,O,41);r=0;if(!kb(g)){break db}r=k[u+1462|0];if(!r){break $a}}if(!R){break $a}n=k[a|0]==3?r<<4:r;a=0;while(1){h[e|0]=!a|k[e|0]&254;Gm(b,w,n&255);a=a+1|0;if((R|0)!=(a|0)){continue}break}}if(v){a=j[zc(A,x)+16>>2];e=zc(A,x);j[e+16>>2]=j[e+16>>2]+R;j[114630]=0;L(1350,B|0,x&65535,t|0,(a+y|0)+1|0);a=j[114630];j[114630]=0;if((a|0)!=1){break ya}a=D()|0;C()|0;break c}a=zc(A,x);j[a+16>>2]=j[a+16>>2]+(R-y|0);break ya}j[114630]=0;N(1352,w|0);a=j[114630];j[114630]=0;if((a|0)==1){break k}Ba=zc(A,x),Ca=0,j[Ba+16>>2]=Ca}x=x+1|0;if(x>>>0<l[b+480188>>1]){continue}break}}if(!ja){break wa}mb(g,O,68);if(Ba=kb(g),Ca=0,Ea=ka|oa,Ea?Ba:Ca){break wa}mb(g+48|0,O,49);if(kb(g+48|0)&ka){break wa}mb(g+40|0,O,103);M=t;if(kb(g+40|0)&fa){continue}a=0;s=apa(g);if(!l[b+480188>>1]){break xa}while(1){eb:{n=p(a,896)+f|0;e=k[n+1423|0];n=k[n+1421|0];if(!((n|0)!=19|(e-97&255)>>>0>14?!((e+79&255)>>>0<15?(n|0)==20:0):0)){S=o[zc(A,a)>>3];j[114630]=0;o[g+48>>3]=S;n=E(1353,s|0,g+48|0)|0;M=j[114630];j[114630]=0;if((M|0)==1){break eb}if(!j[n>>2]){j[114630]=0;n=E(1353,s|0,g+48|0)|0;M=j[114630];j[114630]=0;if((M|0)==1){break eb}j[n>>2]=1}j[114630]=0;n=E(1353,s|0,g+48|0)|0;M=j[114630];j[114630]=0;if((M|0)==1){break eb}n=j[n>>2];j[114630]=0;e=E(1354,n|0,(e&15)+1|0)|0;n=j[114630];j[114630]=0;if((n|0)==1){break eb}j[114630]=0;n=E(1353,s|0,g+48|0)|0;M=j[114630];j[114630]=0;if((M|0)==1){break eb}j[n>>2]=e}a=a+1|0;if(a>>>0<l[b+480188>>1]){continue}break xa}break}break l}a=D()|0;C()|0;break c}Ba=g,Ca=_m(s),j[Ba+40>>2]=Ca;Ba=g,Ca=ii(s),j[Ba+32>>2]=Ca;while(1){j[114630]=0;a=E(1355,g+40|0,g+32|0)|0;e=j[114630];j[114630]=0;if((e|0)==1){break l}if(!a){fb:{if(j[b+480180>>2]!=32){break fb}a=0;if(!l[b+480188>>1]){break fb}while(1){e=p(a,896)+f|0;if(!(k[e+1421|0]!=20|(k[e+1423|0]+79&255)>>>0>14)){S=o[B+32>>3];Ba=zc(A,a),Da=S,o[Ba>>3]=Da;e=j[f>>2];Ba=zc(A,a),Ca=e,j[Ba+8>>2]=Ca}a=a+1|0;if(a>>>0<l[b+480188>>1]){continue}break}}JK(s);break wa}j[114630]=0;a=H(1356,g+40|0)|0;e=j[114630];j[114630]=0;gb:{hb:{if((e|0)!=1){n=hb(a);e=a;S=o[B+32>>3];o[B+32>>3]=(S-o[a>>3])*+(j[n>>2]-1|0)+S;a=0;if(l[b+480188>>1]){break hb}break gb}break l}while(1){if(o[zc(A,a)>>3]!=o[e>>3]){a=a+1|0;if(a>>>0<l[b+480188>>1]){continue}break gb}break}e=j[f>>2];M=zc(A,a);j[f>>2]=j[f>>2]+p(j[n>>2]-1|0,e-j[M+8>>2]|0);mb(g+48|0,O,16);if(Ba=!kb(g+48|0),Ca=0,Ea=j[b+480180>>2]!=2,Ea?Ba:Ca){break gb}S=o[B+32>>3];Ba=zc(A,a),Da=S,o[Ba>>3]=Da;e=j[f>>2];Ba=zc(A,a),Ca=e,j[Ba+8>>2]=Ca;e=j[f+48>>2];Ba=zc(A,a),Ca=e+1|0,j[Ba+12>>2]=Ca}j[114630]=0;H(1357,g+40|0)|0;a=j[114630];j[114630]=0;if((a|0)!=1){continue}break}break l}M=t;continue}}a=D()|0;C()|0;break c}a=D()|0;C()|0;JK(s);break c}a=D()|0;C()|0;break c}a=D()|0;C()|0;break c}a=D()|0;C()|0;break c}a=D()|0;C()|0;break c}ib:{jb:{if(!(!l[b+480188>>1]|(qa|0)!=7)){a=0;while(1){if(j[zc(A,a)+16>>2]!=-1){j[114630]=0;L(1350,B|0,a&65535,M|0,-1);d=j[114630];j[114630]=0;if((d|0)==1){break jb}}a=a+1|0;if(a>>>0<l[b+480188>>1]){continue}break}}if(k[J+26|0]){i[J+20>>1]=l[f+62>>1];j[J+8>>2]=j[f+48>>2]}o[J>>3]=o[B+32>>3];j[114630]=0;F(1334,na|0,J|0);a=j[114630];j[114630]=0;if((a|0)==1){break ib}kb:{lb:{if(!ha){break lb}mb:{if(!(ba?!k[J+26|0]:0)){a=b+1074376|0;PK(a,f);qx(a);a=b+1074396|0;j[a>>2]=0;j[a+4>>2]=0;j[b+1074428>>2]=j[b+1074424>>2];h[b+1074464|0]=1;j[b+1074392>>2]=-2;a=0;d=b+1304392|0;if($c(d)){e=j[d>>2];j[114630]=0;N(1358,e|0);e=j[114630];j[114630]=0;if((e|0)==1){break ib}}nb:{if(l[b+480188>>1]){f=(qa|0)==7;while(1){e=p(a,896)+b|0;s=k[e+1075805|0];if(s){h[e+1075808|0]=s}if(!(k[zc(A,a)+21|0]==255|f)){s=zc(A,a);j[114630]=0;h[g|0]=64;s=E(391,s+21|0,g|0)|0;n=j[114630];j[114630]=0;if((n|0)==1){break nb}j[e+1075672>>2]=k[s|0]<<2}ob:{s=e+1075088|0;n=j[s>>2];if(!n|!(k[n+35|0]&2)){break ob}if(!$c(d)){break ob}n=j[d>>2];s=j[s>>2];j[114630]=0;t=n;n=a&65535;I(1359,t|0,n|0,s+68|0);s=j[114630];j[114630]=0;if((s|0)!=1){s=j[d>>2];j[114630]=0;I(1360,s|0,n|0,1);s=j[114630];j[114630]=0;if((s|0)!=1){break ob}}a=D()|0;C()|0;break c}j[e+1075e3>>2]=0;a=a+1|0;if(a>>>0<l[b+480188>>1]){continue}break}}d=ly(g);Ba=g,Ca=_m(ra),j[Ba+40>>2]=Ca;Ba=g,Ca=ii(ra),j[Ba+32>>2]=Ca;pb:{while(1){qb:{j[114630]=0;a=E(1361,g+40|0,g+32|0)|0;e=j[114630];j[114630]=0;if((e|0)==1){break qb}if(!a){if(!Loa(d)){break mb}a=0;while(1){mb(g+48|0,d,a);rb:{if(!kb(g+48|0)){break rb}e=j[(p(a,160)+b|0)+906300>>2];f=j[j[e>>2]+172>>2];j[114630]=0;N(f|0,e|0);e=j[114630];j[114630]=0;if((e|0)!=1){break rb}a=D()|0;C()|0;break c}a=a+1|0;if((a|0)!=250){continue}break}break mb}j[114630]=0;e=H(1362,g+40|0)|0;a=j[114630];j[114630]=0;if((a|0)==1){break pb}f=k[e|0]-1&255;a=j[(p(f,160)+b|0)+906300>>2];if(a){mb(g+48|0,d,f);if(!kb(g+48|0)){j[114630]=0;K(1363,d|0,f|0,1)|0;f=j[114630];j[114630]=0;if((f|0)==1){break kb}f=j[j[a>>2]+168>>2];j[114630]=0;F(f|0,a|0,-1);f=j[114630];j[114630]=0;if((f|0)==1){break kb}}f=l[e+2>>1];s=j[j[a>>2]+44>>2];e=l[e+4>>1];j[114630]=0;ma(s|0,a|0,f|0,q(q(q(e>>>0)*q(.0010010009864345193))));a=j[114630];j[114630]=0;if((a|0)==1){break kb}}j[114630]=0;H(1364,g+40|0)|0;a=j[114630];j[114630]=0;if((a|0)!=1){continue}}break}a=D()|0;C()|0;break c}a=D()|0;C()|0;break c}a=D()|0;C()|0;break c}if((c|0)==3){break mb}j[b+1074416>>2]=j[b+480196>>2];j[b+1074420>>2]=j[b+480204>>2];j[b+1074444>>2]=j[b+480200>>2]}if(k[la+16|0]==(ga|0)){break lb}j[114630]=0;F(488,la|0,ga|0);a=j[114630];j[114630]=0;if((a|0)==1){break ib}}if(c&9){j[114630]=0;F(1365,b+1304360|0,ca|0);a=j[114630];j[114630]=0;if((a|0)==1){break ib}}Co(ca);OK(B);Za=g+176|0;return}a=D()|0;C()|0;break c}a=D()|0;C()|0;break c}a=D()|0;C()|0;break c}a=D()|0;C()|0;break c}a=D()|0;C()|0;break c}a=D()|0;C()|0}Co(ca);break b}a=D()|0;C()|0}OK(B);break a}a=D()|0;C()|0}ll(na);G(a|0);z()}function OAa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,n=0,o=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,J=0,M=0,N=0,O=0,Q=0,R=0,S=0,T=0;e=Za-1728|0;Za=e;rc(b);f=e+1600|0;o=tAa(b,f);if(!o){oO(f)}a:{if(!o){break a}if(!tO(e+1600|0)){break a}if(!yb(b,Tc(256,0))){break a}b:{if(!c){break b}od(a,1048576);Zh(a);d=Db(e+1584|0,16384);j[114630]=0;F(219,e+1328|0,d|0);f=j[114630];j[114630]=0;c:{d:{e:{f:{g:{h:{i:{j:{k:{l:{m:{n:{o:{p:{q:{r:{if((f|0)!=1){x=e+1608|0;j[e+160>>2]=k[x+1|0];f=k[x|0];j[114630]=0;j[e+24>>2]=f;F(660,e+88|0,e+24|0);f=j[114630];j[114630]=0;if((f|0)==1){break r}j[114630]=0;L(645,e+240|0,e+1328|0,e+160|0,e+88|0);f=j[114630];j[114630]=0;if((f|0)==1){break q}ob(a+1304436|0,e+240|0);gb(e+240|0);gb(e+88|0);qb(e+1328|0);gb(d);d=Db(e+240|0,16401);ob(a+1304448|0,d);gb(d);vg(e+88|0,2,e+1610|0);qc(e+1328|0,e+88|0);j[114630]=0;I(13,e+240|0,7,e+1328|0);d=j[114630];j[114630]=0;if((d|0)==1){break k}ob(a+1304460|0,e+240|0);gb(e+240|0);gb(e+1328|0);j[a+1304496>>2]=7;mt(e+1328|0,2,e+1642|0);qc(e+240|0,e+1328|0);ob(a+1304400|0,e+240|0);gb(e+240|0);d=e+1712|0;i[a+480188>>1]=k[d|0]|k[d+1|0]<<8;d=kd(k[e+1716|0],1,31);j[a+480204>>2]=125e4;j[a+480208>>2]=32792;j[a+480196>>2]=d;J=e+1722|0;i[a+480192>>1]=k[J|0]|k[J+1|0]<<8;M=e+1724|0;i[a+480190>>1]=k[M|0]|k[M+1|0]<<8;d=kd(k[e+1717|0],1,32);j[a+480216>>2]=d;j[a+480228>>2]=96;j[a+480232>>2]=48;j[a+480220>>2]=d<<2;Rz(b,e+1328|0);N=a+484360|0;y=e+1706|0;xt(Eb(N),e+1328|0,k[y|0]|k[y+1|0]<<8,65535,65535);d=e+1708|0;Fe(Eb(N),k[d|0]|k[d+1|0]<<8);cd(e+1312|0,b,Of(b));j[114630]=0;d=H(390,b|0)|0;f=j[114630];j[114630]=0;if((f|0)==1){break n}j[114630]=0;I(341,e+1296|0,b|0,d|0);d=j[114630];j[114630]=0;if((d|0)==1){break n}v=l[a+480188>>1];j[114630]=0;w=E(258,e+1312|0,274)|0;d=j[114630];j[114630]=0;if((d|0)==1){break m}if(w){i[a+480188>>1]=l[a+480188>>1]+8}A=c&1;if(!A){break l}d=e+1710|0;d=k[d|0]|k[d+1|0]<<8;j[114630]=0;F(401,a+484344|0,d|0);d=j[114630];j[114630]=0;if((d|0)!=1){break l}break f}f=D()|0;C()|0;break o}f=D()|0;C()|0;break p}f=D()|0;C()|0;gb(e+88|0)}qb(e+1328|0)}gb(d);break c}f=D()|0;C()|0;break d}f=D()|0;C()|0;break e}u=e+1710|0;if(!(k[u|0]|k[u+1|0]<<8)){break g}O=a+484344|0;Q=e+1718|0;while(1){j[114630]=0;d=H(357,b|0)|0;f=j[114630];j[114630]=0;if((f|0)==1){break h}j[114630]=0;j[e+160>>2]=d;d=H(390,b|0)|0;f=j[114630];j[114630]=0;if((f|0)==1){break i}j[114630]=0;I(341,e+240|0,b|0,d+1&-2);d=j[114630];j[114630]=0;if((d|0)==1){break i}jc(e+160|0,1024);s:{if(!A){break s}d=j[e+160>>2];if(!d){break s}j[114630]=0;d=K(402,O|0,n&65535,d|0)|0;f=j[114630];j[114630]=0;t:{if((f|0)!=1){if(!d){break s}q=0;if(h[Q|0]&1){g=0;while(1){j[114630]=0;d=E(258,e+240|0,1)|0;f=j[114630];j[114630]=0;u:{if((f|0)!=1){if(!d){break s}j[114630]=0;d=H(387,e+240|0)|0;f=j[114630];j[114630]=0;if((f|0)==1){break j}f=0;if((d|0)!=255){break u}j[114630]=0;f=H(387,e+240|0)|0;d=j[114630];j[114630]=0;if((d|0)!=1){j[114630]=0;d=H(387,e+240|0)|0;o=j[114630];j[114630]=0;if((o|0)!=1){break u}}break j}break j}v:{if(!(d&127)){break v}o=Hb(O,n);j[114630]=0;o=K(471,o|0,g|0,q&65535)|0;r=j[114630];j[114630]=0;if((r|0)==1){break j}h[e+88|0]=0;h[e+89|0]=0;h[e+90|0]=0;h[e+91|0]=0;h[e+91|0]=0;h[e+92|0]=0;h[e+93|0]=0;h[e+94|0]=0;if(d&1){j[114630]=0;r=H(387,e+240|0)|0;s=j[114630];j[114630]=0;if((s|0)==1){break j}h[e+88|0]=r}if(d&2){j[114630]=0;r=H(387,e+240|0)|0;s=j[114630];j[114630]=0;if((s|0)==1){break j}h[e+89|0]=r}if(d&4){j[114630]=0;r=H(387,e+240|0)|0;s=j[114630];j[114630]=0;if((s|0)==1){break j}h[e+90|0]=r}if(d&8){j[114630]=0;r=H(387,e+240|0)|0;s=j[114630];j[114630]=0;if((s|0)==1){break j}h[e+91|0]=r}if(d&16){j[114630]=0;r=H(387,e+240|0)|0;s=j[114630];j[114630]=0;if((s|0)==1){break j}h[e+92|0]=r}if(d&32){j[114630]=0;r=H(387,e+240|0)|0;s=j[114630];j[114630]=0;if((s|0)==1){break j}h[e+93|0]=r}if(d&64){j[114630]=0;d=H(387,e+240|0)|0;r=j[114630];j[114630]=0;if((r|0)==1){break j}h[e+94|0]=d}j[114630]=0;d=E(892,o|0,e+88|0)|0;r=j[114630];j[114630]=0;if((r|0)==1){break j}j[114630]=0;j[e+24>>2]=f;j[e+224>>2]=j[e+160>>2]+(g^-1);r=E(464,e+24|0,e+224|0)|0;s=j[114630];j[114630]=0;if((s|0)==1){break j}t=d|t;R=j[r>>2];if(!R){break v}r=0;d=o;while(1){d=p(l[a+480188>>1],6)+d|0;s=k[o|0]|k[o+1|0]<<8|(k[o+2|0]<<16|k[o+3|0]<<24);h[d|0]=s;h[d+1|0]=s>>>8;h[d+2|0]=s>>>16;h[d+3|0]=s>>>24;s=k[o+4|0]|k[o+5|0]<<8;h[d+4|0]=s;h[d+5|0]=s>>>8;r=r+1|0;if((R|0)!=(r|0)){continue}break}}g=(f+g|0)+1|0;d=j[e+160>>2];if(g>>>0>=d>>>0){while(1){q=q+1|0;g=g-d|0;if(d>>>0<=g>>>0){continue}break}}if((q&65535)>>>0<v>>>0){continue}break}break s}f=0;if(j[e+160>>2]){break t}break s}break j}while(1){d=Hb(O,n);j[114630]=0;o=E(496,d|0,f|0)|0;d=j[114630];j[114630]=0;w:{x:{if((d|0)!=1){d=0;if(v){break x}break w}break j}while(1){y:{j[114630]=0;E(893,e+240|0,e+88|0)|0;g=j[114630];j[114630]=0;if((g|0)==1){break y}j[114630]=0;g=E(892,o+p(d,6)|0,e+88|0)|0;q=j[114630];j[114630]=0;if((q|0)==1){break y}t=g|t;d=d+1|0;if((v|0)!=(d|0)){continue}break w}break}break j}f=f+1|0;if(f>>>0<m[e+160>>2]){continue}break}}jb(e+240|0);n=n+1|0;if(n>>>0<(k[u|0]|k[u+1|0]<<8)>>>0){continue}break}break g}f=D()|0;C()|0;gb(e+1328|0);break c}f=D()|0;C()|0;jb(e+240|0);break e}f=D()|0;C()|0;break e}f=D()|0;C()|0;break e}d=e+1714|0;z:{if((k[d|0]|k[d+1|0]<<8)>>>0<=1|(k[d|0]|k[d+1|0]<<8)>>>0>4999){break z}if(t&1){d=k[d|0]|k[d+1|0]<<8;j[114630]=0;d=ig(458,((d>>>1|0)+11025e5>>>0)/(d>>>0)|0,0);f=j[114630];j[114630]=0;if((f|0)==1){break f}j[a+480224>>2]=0;j[a+480204>>2]=d;break z}f=j[a+480216>>2];o=j[a+480196>>2];n=k[d|0]|k[d+1|0]<<8;j[a+480224>>2]=2;d=a;B=2646e7/+(p(n,p(f,o))>>>0);A:{if(B<4294967296&B>=0){f=~~B>>>0;break A}f=0}j[d+480204>>2]=f}d=l[a+480188>>1];j[114630]=0;h[e+240|0]=0;O=K(894,e+1280|0,d|0,e+240|0)|0;d=j[114630];j[114630]=0;if((d|0)!=1){g=a+1304412|0;o=a+484344|0;s=a+1304424|0;A=e+240|3;r=0;B:{C:{D:{E:{F:{while(1){j[114630]=0;d=E(258,e+1296|0,8)|0;f=j[114630];j[114630]=0;G:{if((f|0)!=1){if(d){break G}if(l[a+480188>>1]){d=0;while(1){f=h[fc(O,d)|0];H:{if((f|0)<=(d|0)|(f|0)>=l[a+480188>>1]){break H}n=((f<<5)+a|0)+480288|0;f=k[n|0];if(!f){break H}g=((d<<5)+a|0)+480288|0;q=k[g|0];if(!q){h[g|0]=f;break H}g=(p(q-1&255,160)+a|0)+906300|0;if((fj(g)|0)!=255){while(1){g=(p(fj(g),160)+a|0)+906300|0;if((fj(g)|0)!=255){continue}break}}f=g+28|0;n=k[n|0]-1&255;n=n>>>0<250?n+128|0:0;h[f|0]=n;h[f+1|0]=n>>>8;h[f+2|0]=n>>>16;h[f+3|0]=n>>>24}d=d+1|0;if(d>>>0<l[a+480188>>1]){continue}break}}j[e+232>>2]=0;j[e+236>>2]=0;j[e+224>>2]=0;j[e+228>>2]=0;j[e+216>>2]=0;j[e+220>>2]=0;j[e+208>>2]=0;j[e+212>>2]=0;I:{J:{K:{L:{M:{N:{if(w){j[114630]=0;E(895,e+1312|0,e+240|0)|0;d=j[114630];j[114630]=0;O:{if((d|0)!=1){g=0;while(1){d=l[a+480192>>1];j[114630]=0;d=E(896,a|0,d+1&65535)|0;f=j[114630];j[114630]=0;P:{Q:{R:{S:{T:{U:{V:{if((f|0)!=1){f=g<<1;n=f+(e+224|0)|0;i[n>>1]=d;s=f+(e+208|0)|0;f=e+f|0;q=f+242|0;i[s>>1]=k[q|0]|k[q+1|0]<<8;if((d|0)==65535){break Q}f=k[f+242|0]|k[f+243|0]<<8;j[114630]=0;d=K(454,a|0,d|0,f+1&65535)|0;f=j[114630];j[114630]=0;if((f|0)==1){break V}if(!d){break P}j[114630]=0;F(508,e+160|0,16418);f=j[114630];j[114630]=0;if((f|0)==1){break U}j[114630]=0;j[e+24>>2]=g+1;I(897,e+88|0,e+160|0,e+24|0);f=j[114630];j[114630]=0;if((f|0)==1){break T}j[114630]=0;E(369,d+492|0,e+88|0)|0;d=j[114630];j[114630]=0;if((d|0)==1){break S}gb(e+88|0);qb(e+160|0);break P}f=D()|0;C()|0;break B}f=D()|0;C()|0;break B}f=D()|0;C()|0;break B}f=D()|0;C()|0;break R}f=D()|0;C()|0;gb(e+88|0)}qb(e+160|0);break B}i[n>>1]=0}g=g+1|0;if((g|0)!=8){continue}break}break O}f=D()|0;C()|0;break B}d=k[e+240|0]|k[e+241|0]<<8;j[114630]=0;s=E(395,e+160|0,d|0)|0;d=j[114630];j[114630]=0;if((d|0)==1){break I}if(k[e+240|0]|k[e+241|0]<<8){d=0;while(1){j[114630]=0;f=H(357,b|0)|0;n=j[114630];j[114630]=0;if((n|0)==1){break K}j[114630]=0;I(341,e+88|0,b|0,f<<5);f=j[114630];j[114630]=0;if((f|0)==1){break L}Ed($b(s,d),e+88|0);jb(e+88|0);d=d+1|0;if(d>>>0<(k[e+240|0]|k[e+241|0]<<8)>>>0){continue}break}}d=k[u|0]|k[u+1|0]<<8;j[114630]=0;t=K(898,e+88|0,d|0,16428)|0;d=j[114630];j[114630]=0;if((d|0)==1){break M}if(k[y|0]|k[y+1|0]<<8){n=0;while(1){g=e+n|0;W:{if(k[g+258|0]>=(k[e+240|0]|k[e+241|0]<<8)>>>0){break W}if(l[bc(Eb(N),n)>>1]>=(k[u|0]|k[u+1|0]<<8)>>>0){break W}f=l[bc(Eb(N),n)>>1];X:{if(l[bc(t,f)>>1]==65535){d=k[g+258|0];S=bc(t,f),T=d,i[S>>1]=T;break X}if(l[bc(t,f)>>1]==k[g+258|0]){break X}j[114630]=0;d=K(899,o|0,f|0,0)|0;q=j[114630];j[114630]=0;if((q|0)==1){break N}if((d|0)==65535){break X}S=bc(Eb(N),n),T=d,i[S>>1]=T;f=d}j[114630]=0;d=E(442,o|0,f|0)|0;q=j[114630];j[114630]=0;if((q|0)==1){break N}if(!d){break W}A=$b(s,k[g+258|0]);rc(A);j[114630]=0;d=H(255,A|0)|0;g=j[114630];j[114630]=0;if((g|0)==1){break N}if(!j[Hb(o,f)+12>>2]){break W}Q=d>>>5|0;q=0;while(1){d=Hb(o,f);g=l[a+480188>>1];j[114630]=0;d=K(471,d|0,q|0,g-8&65535)|0;g=j[114630];j[114630]=0;if((g|0)==1){break N}g=0;while(1){th(e+24|0);w=l[e+28>>1];h[d+4|0]=w;h[d+5|0]=w>>>8;w=j[e+24>>2];h[d|0]=w;h[d+1|0]=w>>>8;h[d+2|0]=w>>>16;h[d+3|0]=w>>>24;Y:{if(q>>>0>=Q>>>0){break Y}j[114630]=0;E(900,A|0,e+24|0)|0;w=j[114630];j[114630]=0;if((w|0)==1){break N}if(h[e+24|0]>-1){break Y}h[d|0]=61;h[d+1|0]=k[(e+224|0)+(g<<1)|0];w=k[e+24|0]&31;h[e+72|0]=w;if(w){ze(e+72|0,15);h[d+3|0]=20;h[d+5|0]=k[e+72|0]|208}h[d+2|0]=1;h[d+4|0]=k[e+25|0]+3>>>2}d=d+6|0;g=g+1|0;if((g|0)!=8){continue}break}q=q+1|0;if(q>>>0<m[Hb(o,f)+12>>2]){continue}break}}n=n+1|0;if(n>>>0<(k[y|0]|k[y+1|0]<<8)>>>0){continue}break}}ff(t);Sc(s)}d=e+1718|0;Z:{if(!(k[d|0]&2)){break Z}v=k[d|0]&8?l[a+480188>>1]:v;if(!(k[u|0]|k[u+1|0]<<8)){break Z}d=((v&65535)+((k[x|0]|k[x+1|0]<<8)>>>0>591?r:0)|0)+((k[d|0]|k[d+1|0]<<8|(k[d+2|0]<<16|k[d+3|0]<<24))>>>4&1)|0;v=0;while(1){g=0;_:{if(!d){break _}while(1){$:{j[114630]=0;f=E(258,b|0,4)|0;o=j[114630];j[114630]=0;if((o|0)==1){break $}if(!f){break _}f=k[x|0]|k[x+1|0]<<8;j[114630]=0;F(901,f|0,b|0);f=j[114630];j[114630]=0;if((f|0)==1){break $}g=g+1|0;if((d|0)!=(g|0)){continue}break _}break}f=D()|0;C()|0;break B}v=v+1|0;if(v>>>0<(k[u|0]|k[u+1|0]<<8)>>>0){continue}break}}j[114630]=0;u=E(395,e+192|0,255)|0;d=j[114630];j[114630]=0;aa:{ba:{ca:{da:{ea:{fa:{if((d|0)!=1){w=e+88|7;N=e+88|1;s=e+88|4;y=e+88|2;A=e+88|3;n=0;while(1){d=n;j[114630]=0;E(902,b|0,e+160|0)|0;f=j[114630];j[114630]=0;ga:{ha:{ia:{ja:{if((f|0)!=1){j[114630]=0;f=H(390,b|0)|0;o=j[114630];j[114630]=0;if((o|0)==1){break ja}o=k[x|0]|k[x+1|0]<<8;j[114630]=0;f=(f|0)==32?428:f;f=f?o>>>0>513?f+4|0:f:f;I(341,e+240|0,b|0,f|0);o=j[114630];j[114630]=0;if((o|0)==1){break ia}n=d+1|0;q=He(e+24|0,Ed($b(u,d),e+240|0));jb(e+240|0);if(d>>>0>=(k[J|0]|k[J+1|0]<<8)>>>0){break ga}j[114630]=0;d=n&65535;g=K(454,a|0,d|0,d|0)|0;d=j[114630];j[114630]=0;if((d|0)!=1){break ha}f=D()|0;C()|0;break ba}f=D()|0;C()|0;break aa}f=D()|0;C()|0;break aa}f=D()|0;C()|0;break aa}if(!g){break ga}j[114630]=0;I(745,e+88|0,2,e+160|0);d=j[114630];j[114630]=0;ka:{la:{ma:{if((d|0)==1){break ma}j[114630]=0;F(415,e+240|0,e+88|0);d=j[114630];j[114630]=0;if((d|0)==1){break ma}j[114630]=0;E(369,g+492|0,e+240|0)|0;d=j[114630];j[114630]=0;if((d|0)==1){break la}gb(e+240|0);if(!f){break ga}j[114630]=0;E(903,q|0,e+240|0)|0;d=j[114630];j[114630]=0;if((d|0)==1){break da}t=0;if((k[x|0]|k[x+1|0]<<8)>>>0<513){break ka}j[114630]=0;t=H(357,q|0)|0;d=j[114630];j[114630]=0;if((d|0)!=1){break ka}f=D()|0;C()|0;break ba}f=D()|0;C()|0;break ba}f=D()|0;C()|0;gb(e+240|0);break ba}f=3;na:{if((k[x|0]|k[x+1|0]<<8)>>>0<514){break na}j[114630]=0;f=H(390,q|0)|0;d=j[114630];j[114630]=0;if((d|0)!=1){break na}f=D()|0;C()|0;break ba}j[g>>2]=k[e+342|0]|k[e+343|0]<<8;h[g+16|0]=k[((k[e+344|0]|k[e+345|0]<<8)&3)+16430|0];h[g+17|0]=k[(k[e+345|0]&3)+16430|0];h[g+18|0]=k[((k[e+344|0]|k[e+345|0]<<8)>>>12&3)+16434|0];v=0;oa:{pa:{qa:{ra:{while(1){sa:{if(!(f&1)){break sa}j[114630]=0;E(904,q|0,e+88|0)|0;d=j[114630];j[114630]=0;if((d|0)==1){break ra}j[114630]=0;o=E(374,g|0,k[v+16438|0])|0;d=j[114630];j[114630]=0;if((d|0)==1){break qa}d=o;if(!(h[e+88|0]&1)|(v|0)!=3){r=k[o+12|0]&-17}else{r=k[o+12|0]|16}h[d+12|0]=r;h[o+12|0]=k[o+12|0]&254|h[e+88|0]&1;h[o+12|0]=k[o+12|0]&251|k[e+88|0]<<1&4;h[o+12|0]=k[o+12|0]&253|k[e+88|0]>>>1&2;d=k[N|0];j[114630]=0;h[e+72|0]=d;h[e+56|0]=16;d=E(391,e+72|0,e+56|0)|0;r=j[114630];j[114630]=0;if((r|0)==1){break pa}d=k[d|0];j[114630]=0;F(591,o|0,d|0);d=j[114630];j[114630]=0;if((d|0)==1){break pa}d=k[y|0];h[o+15|0]=d;h[o+16|0]=d;h[o+13|0]=k[A|0];h[o+14|0]=k[s|0];d=0;if(!sb(o)){break sa}while(1){r=(e+88|0)+(d<<2)|0;Q=k[r+8|0]|k[r+9|0]<<8;S=xb(o,d),T=Q,i[S>>1]=T;r=kd(k[r+10|0]|k[r+11|0]<<8,0,64);S=xb(o,d),T=r,h[S+2|0]=T;d=d+1|0;if(sb(o)>>>0>d>>>0){continue}break}}f=f>>>1|0;v=v+1|0;if((v|0)!=4){continue}break}if(!(h[g+60|0]&1|k[g+16|0]==3)){j[g>>2]=32767}j[114630]=0;I(905,g|0,127,1);d=j[114630];j[114630]=0;if((d|0)==1){break fa}j[114630]=0;I(906,g|0,0,1);d=j[114630];j[114630]=0;if((d|0)==1){break fa}if(!t){break ga}j[114630]=0;E(907,q|0,e+88|0)|0;d=j[114630];j[114630]=0;if((d|0)==1){break ca}if(!(t&2)){break oa}d=k[y|0]|k[y+1|0]<<8;j[114630]=0;d=Ya(908,a|0,+(d>>>0))|0;f=j[114630];j[114630]=0;if((f|0)==1){break ca}j[114630]=0;I(905,g|0,d|0,1);d=j[114630];j[114630]=0;if((d|0)==1){break ca}d=k[s|0];j[114630]=0;I(906,g|0,d|0,1);d=j[114630];j[114630]=0;if((d|0)!=1){break oa}break ca}f=D()|0;C()|0;break ba}f=D()|0;C()|0;break ba}f=D()|0;C()|0;break ba}h[g+25|0]=k[N|0]==1;if(!(t&4)){break ga}h[g+31|0]=k[w|0]+1;h[g+34|0]=k[e+96|0]+1;if(h[e+96|0]<=-1){h[g+30|0]=k[e+103|0]+1}if(k[e+100|0]){d=0;o=g+108|0;while(1){f=d+1|0;j[e+72>>2]=f+h[e+100|0];rO(e+72|0);v=j[e+72>>2];S=Pb(o,d),T=v,h[S|0]=T;d=f;if(d>>>0<128){continue}break}}j[114630]=0;F(776,g|0,0);d=j[114630];j[114630]=0;if((d|0)==1){break ca}}jb(q);if((n|0)!=255){continue}break}v=ly(e+88|0);o=e+24|4;x=ly(e+160|0);g=0;ta:{ua:{while(1){j[114630]=0;E(902,b|0,e+240|0)|0;d=j[114630];j[114630]=0;if((d|0)==1){break ta}j[114630]=0;d=H(390,b|0)|0;f=j[114630];j[114630]=0;va:{wa:{xa:{ya:{za:{Aa:{Ba:{Ca:{if((f|0)!=1){j[114630]=0;I(341,e+72|0,b|0,d|0);f=j[114630];j[114630]=0;if((f|0)==1){break Ca}if((k[M|0]|k[M+1|0]<<8)>>>0>g>>>0){j[114630]=0;I(745,e+56|0,2,e+240|0);f=j[114630];j[114630]=0;if((f|0)==1){break va}j[114630]=0;F(415,e+24|0,e+56|0);f=j[114630];j[114630]=0;if((f|0)==1){break va}j[114630]=0;E(369,((g<<5)+a|0)+946332|0,e+24|0)|0;f=j[114630];j[114630]=0;if((f|0)==1){break Ba}gb(e+24|0)}if(!d|(k[M|0]|k[M+1|0]<<8)>>>0<=g>>>0){break wa}j[114630]=0;d=p(g+1|0,104)+a|0;f=d+484380|0;F(386,f|0,32);n=j[114630];j[114630]=0;if((n|0)==1){break Aa}j[114630]=0;E(909,e+72|0,e+24|0)|0;n=j[114630];j[114630]=0;if((n|0)==1){break za}j[f>>2]=k[e+24|0]|k[e+25|0]<<8|(k[e+26|0]<<16|k[e+27|0]<<24);j[d+484404>>2]=k[o|0]|k[o+1|0]<<8|(k[o+2|0]<<16|k[o+3|0]<<24);if(k[e+32|0]>=2){n=d+484414|0;i[n>>1]=l[n>>1]|1;j[f>>2]=j[f>>2]>>>1}if(k[e+33|0]>=2){n=d+484414|0;i[n>>1]=l[n>>1]|64;j[f>>2]=j[f>>2]>>>1}t=2;Da:{if(k[e+35|0]!=1){t=6;if(k[e+35|0]!=2){break Da}}f=d+484414|0;i[f>>1]=l[f>>1]|t}j[d+484384>>2]=k[e+36|0]|k[e+37|0]<<8|(k[e+38|0]<<16|k[e+39|0]<<24);j[d+484388>>2]=k[e+40|0]|k[e+41|0]<<8|(k[e+42|0]<<16|k[e+43|0]<<24);i[d+484410>>1]=(k[e+44|0]|k[e+45|0]<<8)>>>7;if(k[e+46|0]!=128){break ya}f=d+484414|0;q=l[f>>1]|256;i[f>>1]=q;break xa}f=D()|0;C()|0;break aa}f=D()|0;C()|0;break aa}f=D()|0;C()|0;gb(e+24|0);break ua}f=D()|0;C()|0;break ua}f=D()|0;C()|0;break ua}i[d+484408>>1]=h[e+46|0]+128;q=l[d+484414>>1]}f=d+484414|0;i[f>>1]=q|32;h[d+484416|0]=k[e+47|0];if(k[e+34|0]&2){mb(e+56|0,x,g);Qd(e+56|0,1)}if(k[e+34|0]&5){i[f>>1]=l[f>>1]|16384}if(!(k[e+34|0]&8)){break wa}mb(e+56|0,v,g);Qd(e+56|0,1);d=0;while(1){f=d<<1;Ea:{if(l[f+(e+208|0)>>1]!=(g|0)){break Ea}f=j[((l[f+(e+224|0)>>1]<<2)+a|0)+900380>>2];if(!f){break Ea}h[f+14|0]=0}d=d+1|0;if((d|0)!=8){continue}break}}jb(e+72|0);g=g+1|0;if((g|0)==256){break ea}continue}break}f=D()|0;C()|0}jb(e+72|0);break aa}f=D()|0;C()|0;break aa}f=D()|0;C()|0;break B}f=D()|0;C()|0;break ba}Fa:{if(!(k[J|0]|k[J+1|0]<<8)){break Fa}f=0;Ga:{Ha:{while(1){Ia:{d=$b(u,f);j[114630]=0;d=H(255,d|0)|0;o=j[114630];j[114630]=0;if((o|0)==1){break Ia}Ja:{if(!d){f=f+1|0;break Ja}d=$b(u,f);rc(d);j[114630]=0;E(903,d|0,e+240|0)|0;d=j[114630];j[114630]=0;if((d|0)==1){break Ha}g=e+24|0;xAa(g);d=k[e+240|0]|k[e+241|0]<<8;j[114630]=0;K(910,b|0,g|0,d|0)|0;d=j[114630];j[114630]=0;if((d|0)==1){break Ga}f=f+1|0;o=j[((f<<2)+a|0)+900380>>2];if(!(!o|k[o+34|0])){j[o+4>>2]=32;j[114630]=0;F(776,o|0,0);d=j[114630];j[114630]=0;if((d|0)==1){break Ga}M=o+108|0;y=o+236|0;d=0;while(1){n=d+e|0;Ka:{if(k[n+242|0]>=(k[e+240|0]|k[e+241|0]<<8)>>>0){break Ka}t=wk(g,k[n+242|0]);n=k[t|0];q=n+1|0;r=d+12|0;S=Nc(y,r),T=q,i[S>>1]=T;if(n>>>0>=l[a+480190>>1]){break Ka}n=p(q,104)+a|0;h[n+484418|0]=k[e+338|0]&3;h[n+484419|0]=k[e+339|0];h[n+484420|0]=k[e+340|0];h[n+484421|0]=k[e+341|0];i[n+484412>>1]=k[t+1|0]<<1;h[n+484417|0]=k[t+2|0];n=q-1|0;mb(e+72|0,v,n);if(kb(e+72|0)){h[o+14|0]=0}mb(e+72|0,x,n);if(!kb(e+72|0)){break Ka}S=Pb(M,r),T=61,h[S|0]=T}d=d+1|0;if((d|0)!=96){continue}break}}qO(g)}if((k[J|0]|k[J+1|0]<<8)>>>0>f>>>0){continue}break Fa}break}f=D()|0;C()|0;break aa}f=D()|0;C()|0;break aa}f=D()|0;C()|0;qO(g);break aa}La:{Ma:{Na:{Oa:{Pa:{Qa:{Ra:{Sa:{Ta:{Ua:{Va:{Wa:{if(!(!(c&2)|!l[a+480190>>1])){g=0;while(1){g=g+1|0;d=p(g,104)+a|0;c=d+484416|0;f=h[c|0];o=d+484417|0;n=h[o|0];j[114630]=0;q=d+484380|0;fa(911,q|0,+((+(n|0)*.0078125- +(f-49|0))*.08333333333333333));f=j[114630];j[114630]=0;if((f|0)==1){break La}h[o|0]=0;h[c|0]=0;c=l[d+484414>>1];Xa:{if(!(c&16384)){c=Kc(e+240|0,c&1?16:8,c&64?3:1,0,12);j[114630]=0;K(400,c|0,q|0,b|0)|0;c=j[114630];j[114630]=0;if((c|0)!=1){break Xa}f=D()|0;C()|0;break aa}j[114630]=0;f=H(390,b|0)|0;c=j[114630];j[114630]=0;if((c|0)==1){break Wa}j[114630]=0;E(338,b|0,12)|0;c=j[114630];j[114630]=0;if((c|0)==1){break Wa}c=Cb(e+240|0);j[114630]=0;K(481,b|0,c|0,f|0)|0;f=j[114630];j[114630]=0;if((f|0)==1){break Va}j[114630]=0;E(370,d+484423|0,c|0)|0;d=j[114630];j[114630]=0;if((d|0)==1){break Va}j[114630]=0;d=E(2,e+8|0,16442)|0;f=j[114630];j[114630]=0;if((f|0)==1){break Ua}j[114630]=0;F(219,e+72|0,d|0);f=j[114630];j[114630]=0;if((f|0)==1){break Ta}j[e+4>>2]=g;f=Ty(a);j[114630]=0;I(13,e+56|0,f|0,c|0);f=j[114630];j[114630]=0;if((f|0)==1){break Sa}j[114630]=0;L(645,e+24|0,e+72|0,e+4|0,e+56|0);f=j[114630];j[114630]=0;if((f|0)==1){break Ra}j[114630]=0;I(646,a|0,2,e+24|0);f=j[114630];j[114630]=0;if((f|0)==1){break Qa}gb(e+24|0);gb(e+56|0);qb(e+72|0);gb(d);gb(c)}if(l[a+480190>>1]>g>>>0){continue}break}}Sc(u);Op(O);jb(e+1296|0);jb(e+1312|0);break b}f=D()|0;C()|0;break aa}f=D()|0;C()|0;break Ma}f=D()|0;C()|0;break Ma}f=D()|0;C()|0;break Na}f=D()|0;C()|0;break Oa}f=D()|0;C()|0;break Pa}f=D()|0;C()|0;gb(e+24|0)}gb(e+56|0)}qb(e+72|0)}gb(d)}gb(c);break aa}f=D()|0;C()|0;break aa}f=D()|0;C()|0;break ba}f=D()|0;C()|0}jb(q)}Sc(u);break B}f=D()|0;C()|0;ff(t);break J}f=D()|0;C()|0;break J}f=D()|0;C()|0;break J}f=D()|0;C()|0}Sc(s);break B}f=D()|0;C()|0;break B}f=D()|0;C()|0;break B}j[114630]=0;f=H(390,e+1296|0)|0;n=j[114630];j[114630]=0;d=a;Ya:{Za:{_a:{$a:{ab:{bb:{cb:{db:{eb:{fb:{gb:{hb:{ib:{jb:{kb:{if((n|0)!=1){j[114630]=0;n=H(390,e+1296|0)|0;q=j[114630];j[114630]=0;if((q|0)==1){break kb}j[114630]=0;I(341,e+88|0,e+1296|0,n|0);n=j[114630];j[114630]=0;if((n|0)==1){break kb}if((f|0)<=844387157){if((f|0)==4674381){break ab}if((f|0)==5068115){break $a}if(t&1|(f|0)!=726487106){break Za}j[a+480224>>2]=2;j[114630]=0;B=+$(912,e+88|0);f=j[114630];j[114630]=0;if((f|0)==1){break Ya}if(B==0){break Za}B=2646e7/(B*+(p(j[a+480216>>2],j[a+480196>>2])>>>0));if(!(B<4294967296&B>=0)){break jb}f=~~B>>>0;break ib}if((f|0)<=1314144591){if((f|0)==844387158){break _a}if((f|0)!=1280004692){break Za}q=0;if(!l[a+480188>>1]){break Za}while(1){j[114630]=0;d=E(258,e+88|0,1)|0;f=j[114630];j[114630]=0;if((f|0)==1){break E}if(!d){break Za}d=Cb(e+240|0);j[114630]=0;K(597,e+88|0,d|0,-1)|0;f=j[114630];j[114630]=0;if((f|0)==1){break gb}f=zb(d);n=nb(d);j[114630]=0;L(414,e+24|0,3,f|0,n|0);f=j[114630];j[114630]=0;if((f|0)==1){break fb}j[114630]=0;F(415,e+160|0,e+24|0);f=j[114630];j[114630]=0;if((f|0)==1){break fb}j[114630]=0;E(378,((q<<5)+a|0)+480289|0,e+160|0)|0;f=j[114630];j[114630]=0;if((f|0)==1){break eb}gb(e+160|0);gb(d);q=q+1|0;if(q>>>0<l[a+480188>>1]){continue}break}break Za}if((f|0)==1397445204){break hb}if((f|0)!=1314144592){break Za}d=0;if(!(k[u|0]|k[u+1|0]<<8)){break Za}while(1){j[114630]=0;f=E(258,e+88|0,1)|0;n=j[114630];j[114630]=0;if((n|0)==1){break cb}if(!f){break Za}j[114630]=0;f=E(913,o|0,d&65535)|0;n=j[114630];j[114630]=0;if((n|0)==1){break cb}if(!f){break Za}n=Cb(e+240|0);j[114630]=0;K(597,e+88|0,n|0,-1)|0;f=j[114630];j[114630]=0;if((f|0)==1){break bb}f=Hb(o,d);j[114630]=0;E(495,f|0,n|0)|0;f=j[114630];j[114630]=0;if((f|0)==1){break bb}gb(n);d=d+1|0;if(d>>>0<(k[u|0]|k[u+1|0]<<8)>>>0){continue}break}break Za}f=D()|0;C()|0;break B}f=D()|0;C()|0;break B}f=0}j[d+480204>>2]=f;break Za}j[114630]=0;d=H(357,e+88|0)|0;f=j[114630];j[114630]=0;if((f|0)==1){break D}j[a+480232>>2]=d>>>9;j[a+480228>>2]=d>>>8;d=0;if(!l[a+480188>>1]){break Za}while(1){j[114630]=0;f=E(914,e+88|0,e+240|0)|0;n=j[114630];j[114630]=0;if((n|0)==1){break F}if(f){i[((d<<5)+a|0)+480286>>1]=(k[e+240|0]|k[e+241|0]<<8)>>>10;f=k[A|0];S=fc(O,d),T=f,h[S|0]=T}d=d+1|0;if(d>>>0<l[a+480188>>1]){continue}break}break Za}f=D()|0;C()|0;break db}f=D()|0;C()|0;break db}f=D()|0;C()|0;gb(e+160|0)}gb(d);break C}f=D()|0;C()|0;break C}f=D()|0;C()|0;gb(n);break C}j[114630]=0;E(338,e+88|0,1)|0;d=j[114630];j[114630]=0;if((d|0)==1){break D}j[114630]=0;d=H(540,e+88|0)|0;f=j[114630];j[114630]=0;if((f|0)==1){break D}j[114630]=0;P(584,s|0,e+88|0,d|0,2)|0;d=j[114630];j[114630]=0;if((d|0)!=1){break Za}break D}j[114630]=0;E(915,e+88|0,e+24|0)|0;d=j[114630];j[114630]=0;lb:{if((d|0)!=1){d=Cb(e+240|0);j[114630]=0;K(597,e+88|0,d|0,-1)|0;f=j[114630];j[114630]=0;if((f|0)==1){break lb}if(Xs(d,16405)){j[114630]=0;I(13,e+160|0,7,d|0);f=j[114630];j[114630]=0;if((f|0)==1){break lb}ob(g,e+160|0);gb(e+160|0)}gb(d);break Za}f=D()|0;C()|0;break C}f=D()|0;C()|0;gb(d);break C}j[114630]=0;r=H(390,e+88|0)|0;d=j[114630];j[114630]=0;if((d|0)==1){break D}}jb(e+88|0);continue}break}f=D()|0;C()|0;break C}f=D()|0;C()|0;break C}f=D()|0;C()|0;break C}f=D()|0;C()|0}jb(e+88|0)}Op(O);break e}f=D()|0;C()|0;break e}f=D()|0;C()|0}jb(e+1296|0)}jb(e+1312|0)}G(f|0);z()}d=1}Za=e+1728|0;return d|0}function $f(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,r=0,s=0,t=0,u=0,v=q(0),w=0,x=0,y=0,A=0,B=0,F=0,L=0,N=0;d=Za-2928|0;Za=d;a:{b:{c:{d:{e:{if(Tp(c)){jc(b,268435456);y=j[c+8>>2];t=d+2904|0;f=t;j[f>>2]=0;j[f+4>>2]=0;ri(f+8|0);j[d+2900>>2]=0;f:{g:{h:{i:{j:{k:{l:{m:{n:{o:{f=d;p:{q:{r:{s:{if(k[a+3|0]-4>>>0<=4){j[114630]=0;e=H(540,c|0)|0;r=j[114630];j[114630]=0;if((r|0)==1){break m}j[d+2900>>2]=e;break s}e=k[a+3|0];if(e>>>0>18){break s}e=1<<e;t:{if(!(e&126991)){if(e&396800){break t}break s}if(!k[a|0]){break s}}e=j[b>>2];j[114630]=0;e=E(643,a|0,e|0)|0;g=j[114630];j[114630]=0;if((g|0)==1){break r}j[114630]=0;I(853,d+736|0,c|0,e|0);e=j[114630];j[114630]=0;if((e|0)==1){break r}e=d+736|0;g=j[e+4>>2];j[t>>2]=j[e>>2];j[t+4>>2]=g;opa(t+8|0,e+8|0);lc(d+736|0);j[114630]=0;g=H(412,t|0)|0;e=j[114630];j[114630]=0;if((e|0)==1){break m}j[d+2900>>2]=j[t>>2]}e=k[a+3|0];if(e>>>0>18){break o}r=1<<e;u:{if(!(r&126991)){e=0;if(r&396800){break u}break o}e=!k[a|0]}if(e|m[b>>2]<262145){break o}e=j[d+2900>>2];r=k[a+3|0];j[114630]=0;j[d+720>>2]=((r|0)==11)<<4;r=E(33,d+720|0,d+2900|0)|0;s=j[114630];j[114630]=0;if((s|0)!=1){j[d+736>>2]=e-j[r>>2];e=k[a+3|0];if(e>>>0>16){break q}v:{if(!(1<<e&126991)){if((e|0)==11){break v}break q}if(!(k[a|0]&7)){break q}}e=j[d+736>>2];if(e>>>0<=2147483647){e=e<<1;break p}e=-1;break p}a=D()|0;C()|0;break a}a=D()|0;C()|0;break a}e=0;j[114630]=0;r=H(1255,a|0)|0;s=j[114630];j[114630]=0;w:{x:{if((s|0)!=1){y:{z:{switch(k[a+3|0]){case 0:case 1:case 2:case 3:case 12:case 13:case 14:case 15:case 16:e=k[a|0];break y;case 9:e=16;break y;case 11:e=4;break y;case 10:case 17:case 18:break z;default:break y}}e=8}r=p(e,r)>>>3|0;e=r-1|0;s=j[d+736>>2];if(e>>>0>-1-s>>>0){break x}e=e+s|0;break w}a=D()|0;C()|0;break a}e=-1}e=(e>>>0)/(r>>>0)|0}j[f+736>>2]=e;jc(b,e);break n}f=d;A:{B:{C:{D:{if(!(k[a+3|0]==4|k[a+3|0]==5|(k[a+3|0]==8|k[a+3|0]==7))){if(k[a+3|0]!=6){break n}e=0;if(m[d+2900>>2]<10){break f}j[114630]=0;E(338,c|0,4)|0;e=j[114630];j[114630]=0;if((e|0)==1){break m}j[114630]=0;e=H(390,c|0)|0;r=j[114630];j[114630]=0;if((r|0)==1){break D}j[d+720>>2]=e;e=j[d+2900>>2];j[114630]=0;j[d+2896>>2]=e;e=E(464,d+720|0,d+2896|0)|0;r=j[114630];j[114630]=0;if((r|0)==1){break C}j[d+736>>2]=j[e>>2];cg(c,8);e=j[d+736>>2];if(e>>>0>50529027){break B}e=p(e,85);break A}j[114630]=0;j[d+736>>2]=j[d+2900>>2];e=H(1255,a|0)|0;r=j[114630];j[114630]=0;f=d;E:{F:{if((r|0)!=1){r=j[d+736>>2];e=8/(e>>>0)|0;if(r>>>0>4294967295/(e>>>0)>>>0){break F}e=p(e,r);break E}a=D()|0;C()|0;break a}e=-1}j[f+736>>2]=e;jc(b,e);break n}a=D()|0;C()|0;break a}a=D()|0;C()|0;break a}e=-1}j[f+736>>2]=e;jc(b,(e>>>0)/(k[a|0]>>>3>>>0)|0)}if(!j[b>>2]){e=0;break f}i[b+34>>1]=l[b+34>>1]&65534|k[a|0]>15;i[b+34>>1]=l[b+34>>1]&65471|(k[a+1|0]!=1)<<6;j[114630]=0;f=H(465,b|0)|0;e=j[114630];j[114630]=0;if((e|0)==1){break e}if(!f){e=0;j[b>>2]=0;break f}f=Kc(d+736|0,8,1,0,11);j[114630]=0;f=E(1256,a|0,f|0)|0;e=j[114630];j[114630]=0;G:{H:{I:{J:{K:{if((e|0)!=1){if(!f){break G}e=0;j[114630]=0;a=E(1257,c|0,d+736|0)|0;f=j[114630];j[114630]=0;if((f|0)==1){break H}if(!a){break g}a=j[b>>2];j[114630]=0;j[d+720>>2]=a+1>>>1;a=H(540,c|0)|0;f=j[114630];j[114630]=0;if((f|0)==1){break K}jc(d+720|0,a);j[114630]=0;a=H(854,g|0)|0;f=j[114630];j[114630]=0;if((f|0)==1){break J}e=j[d+720>>2];if(e){break I}e=16;break g}a=D()|0;C()|0;break a}a=D()|0;C()|0;break a}a=D()|0;C()|0;break a}a=a+16|0;b=j[b+20>>2];g=0;while(1){f=k[d+736|k[a|0]&15]+g|0;h[b|0]=f;g=k[d+736|k[a|0]>>>4]+(f&255)|0;h[b+1|0]=g;a=a+1|0;b=b+2|0;e=e-1|0;if(e){continue}break}e=j[d+720>>2]+16|0;break g}a=D()|0;C()|0;break a}if(!(k[a+3|0]!=5?k[a+3|0]!=4:0)){a=k[a+3|0];j[114630]=0;a=P(1258,d+1808|0,c|0,b|0,(a|0)==5|0)|0;b=j[114630];j[114630]=0;if((b|0)==1){break e}jb(a);e=j[c+8>>2]-y|0;break g}if(!(k[a+3|0]!=6|k[a+1|0]!=1)){j[114630]=0;E(338,c|0,4)|0;a=j[114630];j[114630]=0;if((a|0)==1){break e}j[114630]=0;a=H(390,c|0)|0;f=j[114630];j[114630]=0;L:{M:{N:{if((f|0)!=1){j[114630]=0;j[d+720>>2]=a;f=H(387,c|0)|0;e=j[114630];j[114630]=0;if((e|0)==1){break N}j[114630]=0;I(1259,d+736|0,c|0,a|0);a=j[114630];j[114630]=0;if((a|0)==1){break L}jc(d+720|0,j[d+736>>2]);j[114630]=0;a=j[d+720>>2];e=H(412,d+736|0)|0;g=j[114630];j[114630]=0;if((g|0)!=1){g=j[d+736>>2];r=j[b+20>>2];b=jk(b);j[114630]=0;V(1260,e|0,g|0,r|0,b|0,f<<24>>24);b=j[114630];j[114630]=0;if((b|0)!=1){break M}}a=D()|0;C()|0;lc(d+736|0);break a}a=D()|0;C()|0;break a}a=D()|0;C()|0;break a}e=a+9|0;lc(d+736|0);break g}a=D()|0;C()|0;break a}if(!(k[a+3|0]!=9|k[a+1|0]!=1|k[a|0]!=16)){a=j[d+2900>>2];f=l[fl(d+1800|0)>>1];j[114630]=0;e=P(1261,b|0,g|0,a|0,f|0)|0;a=j[114630];j[114630]=0;if((a|0)==1){break e}break g}if(k[a+3|0]!=8|k[a+1|0]!=1|k[a|0]>16){break l}e=0;j[114630]=0;f=E(258,c|0,8)|0;g=j[114630];j[114630]=0;if((g|0)==1){break e}if(!f){break g}j[114630]=0;f=H(390,c|0)|0;g=j[114630];j[114630]=0;if((g|0)==1){break e}j[d+2900>>2]=f;if(f>>>0<4){break g}j[114630]=0;I(341,d+720|0,c|0,f|0);f=j[114630];j[114630]=0;if((f|0)==1){break b}f=Ml(d+736|0,d+720|0);jb(d+720|0);j[114630]=0;r=H(1262,f|0)|0;e=j[114630];j[114630]=0;if((e|0)==1){break d}if(!j[b>>2]){break i}s=k[a|0];A=(s|0)!=16;a=0;g=0;while(1){O:{if(A){break O}j[114630]=0;B=E(260,f|0,8)|0;e=j[114630];j[114630]=0;if((e|0)!=1){break O}a=J(77088)|0;break j}j[114630]=0;F=E(260,f|0,1)|0;e=j[114630];j[114630]=0;if((e|0)==1){break k}j[114630]=0;e=E(260,f|0,1)|0;u=j[114630];j[114630]=0;if((u|0)==1){break k}P:{Q:{R:{if(!e){e=8;while(1){j[114630]=0;u=E(260,f|0,1)|0;x=j[114630];j[114630]=0;if((x|0)==1){break P}if(u){break R}e=e+16|0;continue}}j[114630]=0;e=E(260,f|0,3)|0;u=j[114630];j[114630]=0;if((u|0)!=1){break Q}break k}j[114630]=0;u=E(260,f|0,4)|0;x=j[114630];j[114630]=0;if((x|0)==1){break k}e=e+u|0}g=(g&255)+(((F?-1:0)^e)&255)|0;S:{if((s|0)!=16){h[j[b+20>>2]+a|0]=g;break S}i[j[b+20>>2]+(a<<1)>>1]=B&255|g<<8}a=a+1|0;if(a>>>0<m[b>>2]){continue}break i}break}a=J(77088)|0;break j}a=D()|0;C()|0;break a}T:{U:{V:{W:{X:{if(!(k[a+3|0]!=7|k[a+1|0]!=1|k[a|0]>16)){e=0;if(m[d+2900>>2]<5){break g}a=j[b+20>>2];j[114630]=0;a=H(466,a|0)|0;f=j[114630];j[114630]=0;if((f|0)==1){break X}j[114630]=0;a=H(1263,a|0)|0;f=j[114630];j[114630]=0;if((f|0)==1){break e}b=jk(b);j[114630]=0;e=K(1264,c|0,a|0,b|0)|0;a=j[114630];j[114630]=0;if((a|0)==1){break e}break g}if(!(k[a|0]!=8|k[a+1|0]!=1)){Y:{Z:{_:{$:{aa:{a=k[a+3|0];switch(a|0){case 2:break Z;case 1:break _;case 0:break $;default:break aa}}e=0;switch(a-10|0){case 0:break Y;case 2:break Z;default:break g}}j[114630]=0;e=K(1265,b|0,g|0,j[d+2900>>2])|0;a=j[114630];j[114630]=0;if((a|0)==1){break e}break g}j[114630]=0;e=K(1266,b|0,g|0,j[d+2900>>2])|0;a=j[114630];j[114630]=0;if((a|0)==1){break e}break g}a=j[d+2900>>2];f=k[ux(d+712|0)|0];j[114630]=0;e=P(1267,b|0,g|0,a|0,f|0)|0;a=j[114630];j[114630]=0;if((a|0)==1){break e}break g}j[114630]=0;e=K(1268,b|0,g|0,j[d+2900>>2])|0;a=j[114630];j[114630]=0;if((a|0)==1){break e}break g}if(!(k[a|0]!=8|k[a+1|0]!=3)){ba:{ca:{da:{ea:{f=k[a+3|0];switch(f|0){case 2:break ba;case 1:break da;case 0:break ea;default:break ca}}j[114630]=0;e=K(1269,b|0,g|0,j[d+2900>>2])|0;a=j[114630];j[114630]=0;if((a|0)==1){break e}break g}j[114630]=0;e=K(1270,b|0,g|0,j[d+2900>>2])|0;a=j[114630];j[114630]=0;if((a|0)==1){break e}break g}e=0;if((f|0)!=12){break g}}f=j[d+2900>>2];e=k[ux(d+704|0)|0];j[114630]=0;e=P(1271,b|0,g|0,f|0,e|0)|0;f=j[114630];j[114630]=0;if((f|0)==1){break e}if(k[a+3|0]!=12){break g}f=j[b>>2]<<1;if((f|0)<1){break g}a=j[b+20>>2];b=f+a|0;while(1){h[a+1|0]=k[a+1|0]+k[a|0];a=a+2|0;if(b>>>0>a>>>0){continue}break}break g}if(!(k[a|0]!=8|k[a+1|0]!=2)){e=0;fa:{switch(k[a+3|0]){case 0:j[114630]=0;e=K(1272,b|0,g|0,j[d+2900>>2])|0;a=j[114630];j[114630]=0;if((a|0)==1){break e}break g;case 1:j[114630]=0;e=K(1273,b|0,g|0,j[d+2900>>2])|0;a=j[114630];j[114630]=0;if((a|0)==1){break e}break g;case 2:break fa;default:break g}}a=j[d+2900>>2];f=k[ux(d+696|0)|0];j[114630]=0;e=P(1274,b|0,g|0,a|0,f|0)|0;a=j[114630];j[114630]=0;if((a|0)==1){break e}break g}if(!(k[a+2|0]|(k[a|0]!=16|k[a+1|0]!=1))){ga:{ha:{ia:{ja:{a=k[a+3|0];switch(a|0){case 2:break ga;case 1:break ia;case 0:break ja;default:break ha}}j[114630]=0;e=K(1275,b|0,g|0,j[d+2900>>2])|0;a=j[114630];j[114630]=0;if((a|0)==1){break e}break g}j[114630]=0;e=K(1276,b|0,g|0,j[d+2900>>2])|0;a=j[114630];j[114630]=0;if((a|0)==1){break e}break g}e=0;if((a|0)!=12){break g}}a=j[d+2900>>2];f=l[fl(d+688|0)>>1];j[114630]=0;e=P(1277,b|0,g|0,a|0,f|0)|0;a=j[114630];j[114630]=0;if((a|0)==1){break e}break g}if(!(k[a|0]!=16|k[a+1|0]!=1|k[a+2|0]!=1)){e=0;ka:{switch(k[a+3|0]){case 0:j[114630]=0;e=K(1278,b|0,g|0,j[d+2900>>2])|0;a=j[114630];j[114630]=0;if((a|0)==1){break e}break g;case 1:j[114630]=0;e=K(1279,b|0,g|0,j[d+2900>>2])|0;a=j[114630];j[114630]=0;if((a|0)==1){break e}break g;case 2:break ka;default:break g}}a=j[d+2900>>2];f=l[fl(d+680|0)>>1];j[114630]=0;e=P(1280,b|0,g|0,a|0,f|0)|0;a=j[114630];j[114630]=0;if((a|0)==1){break e}break g}if(!(k[a+2|0]|(k[a|0]!=16|k[a+1|0]!=3))){la:{ma:{na:{oa:{f=k[a+3|0];switch(f|0){case 2:break la;case 1:break na;case 0:break oa;default:break ma}}j[114630]=0;e=K(1281,b|0,g|0,j[d+2900>>2])|0;a=j[114630];j[114630]=0;if((a|0)==1){break e}break g}j[114630]=0;e=K(1282,b|0,g|0,j[d+2900>>2])|0;a=j[114630];j[114630]=0;if((a|0)==1){break e}break g}e=0;if((f|0)!=12){break g}}f=j[d+2900>>2];e=l[fl(d+672|0)>>1];j[114630]=0;e=P(1283,b|0,g|0,f|0,e|0)|0;f=j[114630];j[114630]=0;if((f|0)==1){break e}if(k[a+3|0]!=12){break g}f=j[b>>2];if(f<<1<1){break g}a=j[b+20>>2];b=a+(f<<2)|0;while(1){i[a+2>>1]=l[a+2>>1]+l[a>>1];a=a+4|0;if(b>>>0>a>>>0){continue}break}break g}if(!(k[a|0]!=16|k[a+1|0]!=3|k[a+2|0]!=1)){e=0;pa:{switch(k[a+3|0]){case 0:j[114630]=0;e=K(1284,b|0,g|0,j[d+2900>>2])|0;a=j[114630];j[114630]=0;if((a|0)==1){break e}break g;case 1:j[114630]=0;e=K(1285,b|0,g|0,j[d+2900>>2])|0;a=j[114630];j[114630]=0;if((a|0)==1){break e}break g;case 2:break pa;default:break g}}a=j[d+2900>>2];f=l[fl(d+664|0)>>1];j[114630]=0;e=P(1286,b|0,g|0,a|0,f|0)|0;a=j[114630];j[114630]=0;if((a|0)==1){break e}break g}if(!(k[a+2|0]|(k[a|0]!=16|k[a+1|0]!=2))){e=0;qa:{switch(k[a+3|0]){case 0:j[114630]=0;e=K(1287,b|0,g|0,j[d+2900>>2])|0;a=j[114630];j[114630]=0;if((a|0)==1){break e}break g;case 1:j[114630]=0;e=K(1288,b|0,g|0,j[d+2900>>2])|0;a=j[114630];j[114630]=0;if((a|0)==1){break e}break g;case 2:break qa;default:break g}}a=j[d+2900>>2];f=l[fl(d+656|0)>>1];j[114630]=0;e=P(1289,b|0,g|0,a|0,f|0)|0;a=j[114630];j[114630]=0;if((a|0)==1){break e}break g}if(!(k[a|0]!=16|k[a+1|0]!=2|k[a+2|0]!=1)){e=0;ra:{switch(k[a+3|0]){case 0:j[114630]=0;e=K(1290,b|0,g|0,j[d+2900>>2])|0;a=j[114630];j[114630]=0;if((a|0)==1){break e}break g;case 1:j[114630]=0;e=K(1291,b|0,g|0,j[d+2900>>2])|0;a=j[114630];j[114630]=0;if((a|0)==1){break e}break g;case 2:break ra;default:break g}}a=j[d+2900>>2];f=l[fl(d+648|0)>>1];j[114630]=0;e=P(1292,b|0,g|0,a|0,f|0)|0;a=j[114630];j[114630]=0;if((a|0)==1){break e}break g}if(!(k[a+3|0]|(k[a|0]!=24|k[a+1|0]!=1))){f=j[d+2900>>2];if(!k[a+2|0]){j[114630]=0;i[d>>1]=l[d+640>>1];e=P(1293,b|0,g|0,f|0,d|0)|0;a=j[114630];j[114630]=0;if((a|0)==1){break e}break g}j[114630]=0;i[d+2>>1]=l[d+632>>1];e=P(1294,b|0,g|0,f|0,d+2|0)|0;a=j[114630];j[114630]=0;if((a|0)==1){break e}break g}if(!(k[a+3|0]|(k[a|0]!=24|k[a+1|0]!=2))){f=j[d+2900>>2];if(!k[a+2|0]){j[114630]=0;i[d+4>>1]=l[d+624>>1];e=P(1295,b|0,g|0,f|0,d+4|0)|0;a=j[114630];j[114630]=0;if((a|0)==1){break e}break g}j[114630]=0;i[d+6>>1]=l[d+616>>1];e=P(1296,b|0,g|0,f|0,d+6|0)|0;a=j[114630];j[114630]=0;if((a|0)==1){break e}break g}if(!(k[a+3|0]|(k[a|0]!=32|k[a+1|0]!=1))){f=j[d+2900>>2];if(!k[a+2|0]){j[114630]=0;i[d+8>>1]=l[d+608>>1];e=P(1297,b|0,g|0,f|0,d+8|0)|0;a=j[114630];j[114630]=0;if((a|0)==1){break e}break g}j[114630]=0;i[d+10>>1]=l[d+600>>1];e=P(1298,b|0,g|0,f|0,d+10|0)|0;a=j[114630];j[114630]=0;if((a|0)==1){break e}break g}if(!(k[a+3|0]|(k[a|0]!=32|k[a+1|0]!=2))){f=j[d+2900>>2];if(!k[a+2|0]){j[114630]=0;i[d+12>>1]=l[d+592>>1];e=P(1299,b|0,g|0,f|0,d+12|0)|0;a=j[114630];j[114630]=0;if((a|0)==1){break e}break g}j[114630]=0;i[d+14>>1]=l[d+584>>1];e=P(1300,b|0,g|0,f|0,d+14|0)|0;a=j[114630];j[114630]=0;if((a|0)==1){break e}break g}if(!(k[a+3|0]|(k[a|0]!=64|k[a+1|0]!=1))){f=j[d+2900>>2];if(!k[a+2|0]){j[114630]=0;i[d+16>>1]=l[d+576>>1];e=P(1301,b|0,g|0,f|0,d+16|0)|0;a=j[114630];j[114630]=0;if((a|0)==1){break e}break g}j[114630]=0;i[d+18>>1]=l[d+568>>1];e=P(1302,b|0,g|0,f|0,d+18|0)|0;a=j[114630];j[114630]=0;if((a|0)==1){break e}break g}if(!(k[a+3|0]|(k[a|0]!=64|k[a+1|0]!=2))){f=j[d+2900>>2];if(!k[a+2|0]){j[114630]=0;i[d+20>>1]=l[d+560>>1];e=P(1303,b|0,g|0,f|0,d+20|0)|0;a=j[114630];j[114630]=0;if((a|0)==1){break e}break g}j[114630]=0;i[d+22>>1]=l[d+552>>1];e=P(1304,b|0,g|0,f|0,d+22|0)|0;a=j[114630];j[114630]=0;if((a|0)==1){break e}break g}if(!(k[a|0]!=32|k[a+1|0]!=1|k[a+3|0]!=3)){f=j[d+2900>>2];if(!k[a+2|0]){j[114630]=0;i[d+24>>1]=l[d+544>>1];e=P(1305,b|0,g|0,f|0,d+24|0)|0;a=j[114630];j[114630]=0;if((a|0)==1){break e}break g}j[114630]=0;i[d+26>>1]=l[d+536>>1];e=P(1306,b|0,g|0,f|0,d+26|0)|0;a=j[114630];j[114630]=0;if((a|0)==1){break e}break g}if(!(k[a|0]!=32|k[a+1|0]!=2|k[a+3|0]!=3)){f=j[d+2900>>2];if(!k[a+2|0]){j[114630]=0;i[d+28>>1]=l[d+528>>1];e=P(1307,b|0,g|0,f|0,d+28|0)|0;a=j[114630];j[114630]=0;if((a|0)==1){break e}break g}j[114630]=0;i[d+30>>1]=l[d+520>>1];e=P(1308,b|0,g|0,f|0,d+30|0)|0;a=j[114630];j[114630]=0;if((a|0)==1){break e}break g}if(!(k[a|0]!=64|k[a+1|0]!=1|k[a+3|0]!=3)){f=j[d+2900>>2];if(!k[a+2|0]){j[114630]=0;i[d+32>>1]=l[d+512>>1];e=P(1309,b|0,g|0,f|0,d+32|0)|0;a=j[114630];j[114630]=0;if((a|0)==1){break e}break g}j[114630]=0;i[d+34>>1]=l[d+504>>1];e=P(1310,b|0,g|0,f|0,d+34|0)|0;a=j[114630];j[114630]=0;if((a|0)==1){break e}break g}if(!(k[a|0]!=64|k[a+1|0]!=2|k[a+3|0]!=3)){f=j[d+2900>>2];if(!k[a+2|0]){j[114630]=0;i[d+36>>1]=l[d+496>>1];e=P(1311,b|0,g|0,f|0,d+36|0)|0;a=j[114630];j[114630]=0;if((a|0)==1){break e}break g}j[114630]=0;i[d+38>>1]=l[d+488>>1];e=P(1312,b|0,g|0,f|0,d+38|0)|0;a=j[114630];j[114630]=0;if((a|0)==1){break e}break g}if(!(k[a|0]!=24|(k[a+1|0]!=2?k[a+1|0]!=1:0)|k[a+3|0]!=16)){j[d+736>>2]=-2147483648;f=j[d+2900>>2];sa:{if(!k[a+2|0]){j[114630]=0;j[d+48>>2]=j[d+480>>2];j[d+476>>2]=0;a=j[d+476>>2];j[d+40>>2]=j[d+472>>2];j[d+44>>2]=a;e=U(1313,b|0,g|0,f|0,d+736|0,d+40|0)|0;a=j[114630];j[114630]=0;if((a|0)!=1){break sa}break T}j[114630]=0;j[d- -64>>2]=j[d+464>>2];j[d+460>>2]=0;a=j[d+460>>2];j[d+56>>2]=j[d+456>>2];j[d+60>>2]=a;e=U(1314,b|0,g|0,f|0,d+736|0,d+56|0)|0;a=j[114630];j[114630]=0;if((a|0)==1){break T}}if(!e){break g}a=j[d+736>>2];if((a|0)==-2147483648){break g}f=l[b+32>>1];j[114630]=0;f=HMa(f,0,a,0)+1073741824|0;a=ab;a=f>>>0<1073741824?a+1|0:a;a=ig(789,(a&2147483647)<<1|f>>>31,a>>>31|0);f=j[114630];j[114630]=0;if((f|0)==1){break T}L=b,N=kd(a,1,64),i[L+32>>1]=N;i[b+34>>1]=l[b+34>>1]|8192;break g}if(!(k[a|0]!=32|(k[a+1|0]!=2?k[a+1|0]!=1:0)|k[a+3|0]!=16)){j[d+736>>2]=-2147483648;f=j[d+2900>>2];ta:{if(!k[a+2|0]){j[114630]=0;j[d+80>>2]=j[d+448>>2];j[d+444>>2]=0;a=j[d+444>>2];j[d+72>>2]=j[d+440>>2];j[d+76>>2]=a;e=U(1315,b|0,g|0,f|0,d+736|0,d+72|0)|0;a=j[114630];j[114630]=0;if((a|0)!=1){break ta}break U}j[114630]=0;j[d+96>>2]=j[d+432>>2];j[d+428>>2]=0;a=j[d+428>>2];j[d+88>>2]=j[d+424>>2];j[d+92>>2]=a;e=U(1316,b|0,g|0,f|0,d+736|0,d+88|0)|0;a=j[114630];j[114630]=0;if((a|0)==1){break U}}if(!e){break g}a=j[d+736>>2];if((a|0)==-2147483648){break g}f=l[b+32>>1];j[114630]=0;a=HMa(f,0,a,0)+1073741824|0;f=ab;f=a>>>0<1073741824?f+1|0:f;a=ig(789,(f&2147483647)<<1|a>>>31,f>>>31|0);f=j[114630];j[114630]=0;if((f|0)==1){break U}L=b,N=kd(a,1,64),i[L+32>>1]=N;i[b+34>>1]=l[b+34>>1]|8192;break g}if(!(k[a|0]!=32|(k[a+1|0]!=2?k[a+1|0]!=1:0)|k[a+3|0]!=15)){j[d+736>>2]=1065353216;f=j[d+2900>>2];ua:{if(!k[a+2|0]){j[114630]=0;j[d+412>>2]=0;j[d+416>>2]=1065353216;a=j[d+420>>2];j[d+112>>2]=j[d+416>>2];j[d+116>>2]=a;a=j[d+412>>2];j[d+104>>2]=j[d+408>>2];j[d+108>>2]=a;e=U(1317,b|0,g|0,f|0,d+736|0,d+104|0)|0;a=j[114630];j[114630]=0;if((a|0)!=1){break ua}break V}j[114630]=0;j[d+396>>2]=0;j[d+400>>2]=1065353216;a=j[d+404>>2];j[d+128>>2]=j[d+400>>2];j[d+132>>2]=a;a=j[d+396>>2];j[d+120>>2]=j[d+392>>2];j[d+124>>2]=a;e=U(1318,b|0,g|0,f|0,d+736|0,d+120|0)|0;a=j[114630];j[114630]=0;if((a|0)==1){break V}}if(!e){break g}v=n[d+736>>2];if(v==q(1)){break g}v=Jm(q(v*q(l[b+32>>1])),q(1),q(64));j[114630]=0;a=Wa(1319,q(v))|0;f=j[114630];j[114630]=0;if((f|0)==1){break V}i[b+32>>1]=a;i[b+34>>1]=l[b+34>>1]|8192;break g}if(!(k[a|0]!=64|(k[a+1|0]!=2?k[a+1|0]!=1:0)|k[a+3|0]!=15)){j[d+736>>2]=0;j[d+740>>2]=1072693248;f=j[d+2900>>2];va:{if(!k[a+2|0]){j[114630]=0;j[d+376>>2]=0;j[d+380>>2]=1072693248;j[d+368>>2]=0;j[d+372>>2]=0;j[d+144>>2]=0;j[d+148>>2]=0;j[d+152>>2]=0;j[d+156>>2]=1072693248;a=j[d+388>>2];j[d+160>>2]=j[d+384>>2];j[d+164>>2]=a;a=j[d+364>>2];j[d+136>>2]=j[d+360>>2];j[d+140>>2]=a;e=U(1320,b|0,g|0,f|0,d+736|0,d+136|0)|0;a=j[114630];j[114630]=0;if((a|0)!=1){break va}break W}j[114630]=0;j[d+344>>2]=0;j[d+348>>2]=1072693248;j[d+336>>2]=0;j[d+340>>2]=0;j[d+176>>2]=0;j[d+180>>2]=0;j[d+184>>2]=0;j[d+188>>2]=1072693248;a=j[d+356>>2];j[d+192>>2]=j[d+352>>2];j[d+196>>2]=a;a=j[d+332>>2];j[d+168>>2]=j[d+328>>2];j[d+172>>2]=a;e=U(1321,b|0,g|0,f|0,d+736|0,d+168|0)|0;a=j[114630];j[114630]=0;if((a|0)==1){break W}}if(!e){break g}w=o[d+736>>3];if(w==1){break g}w=tx(w*+l[b+32>>1],1,64);j[114630]=0;a=na(1322,+w)|0;f=j[114630];j[114630]=0;if((f|0)==1){break W}i[b+32>>1]=a;i[b+34>>1]=l[b+34>>1]|8192;break g}if(!(k[a|0]!=32|k[a+1|0]!=1|k[a+3|0]!=13)){f=j[d+2900>>2];if(!k[a+2|0]){j[114630]=0;j[d+320>>2]=939524096;a=j[d+324>>2];j[d+200>>2]=j[d+320>>2];j[d+204>>2]=a;e=P(1323,b|0,g|0,f|0,d+200|0)|0;a=j[114630];j[114630]=0;if((a|0)==1){break e}break g}j[114630]=0;j[d+312>>2]=939524096;a=j[d+316>>2];j[d+208>>2]=j[d+312>>2];j[d+212>>2]=a;e=P(1324,b|0,g|0,f|0,d+208|0)|0;a=j[114630];j[114630]=0;if((a|0)==1){break e}break g}if(!(k[a|0]!=32|k[a+1|0]!=2|k[a+3|0]!=13)){f=j[d+2900>>2];if(!k[a+2|0]){j[114630]=0;j[d+304>>2]=939524096;a=j[d+308>>2];j[d+216>>2]=j[d+304>>2];j[d+220>>2]=a;e=P(1325,b|0,g|0,f|0,d+216|0)|0;a=j[114630];j[114630]=0;if((a|0)==1){break e}break g}j[114630]=0;j[d+296>>2]=939524096;a=j[d+300>>2];j[d+224>>2]=j[d+296>>2];j[d+228>>2]=a;e=P(1326,b|0,g|0,f|0,d+224|0)|0;a=j[114630];j[114630]=0;if((a|0)==1){break e}break g}if(!(k[a|0]!=32|k[a+1|0]!=1|k[a+3|0]!=14)){f=j[d+2900>>2];if(!k[a+2|0]){j[114630]=0;j[d+288>>2]=872415232;a=j[d+292>>2];j[d+232>>2]=j[d+288>>2];j[d+236>>2]=a;e=P(1323,b|0,g|0,f|0,d+232|0)|0;a=j[114630];j[114630]=0;if((a|0)==1){break e}break g}j[114630]=0;j[d+280>>2]=872415232;a=j[d+284>>2];j[d+240>>2]=j[d+280>>2];j[d+244>>2]=a;e=P(1324,b|0,g|0,f|0,d+240|0)|0;a=j[114630];j[114630]=0;if((a|0)==1){break e}break g}e=0;if(k[a|0]!=32|k[a+1|0]!=2|k[a+3|0]!=14){break g}f=j[d+2900>>2];if(!k[a+2|0]){j[114630]=0;j[d+272>>2]=872415232;a=j[d+276>>2];j[d+248>>2]=j[d+272>>2];j[d+252>>2]=a;e=P(1325,b|0,g|0,f|0,d+248|0)|0;a=j[114630];j[114630]=0;if((a|0)!=1){break g}break e}j[114630]=0;j[d+264>>2]=872415232;a=j[d+268>>2];j[d+256>>2]=j[d+264>>2];j[d+260>>2]=a;e=P(1326,b|0,g|0,f|0,d+256|0)|0;a=j[114630];j[114630]=0;if((a|0)==1){break e}break g}J(0)|0;C()|0;ib();z()}a=D()|0;C()|0;break a}a=D()|0;C()|0;break a}a=D()|0;C()|0;break a}a=D()|0;C()|0;break a}a=J(77088)|0}if((C()|0)!=(W(77088)|0)){break c}O(a|0)|0;j[114630]=0;M(20);a=j[114630];j[114630]=0;if((a|0)==1){break h}}e=r+4|0;jb(f);break g}a=D()|0;C()|0;break c}j[114630]=0;E(256,c|0,e+y|0)|0;a=j[114630];j[114630]=0;if((a|0)==1){break e}}lc(t)}Za=d+2928|0;return e|0}a=D()|0;C()|0;break a}a=D()|0;C()|0}jb(f);break a}a=D()|0;C()|0}lc(t);G(a|0);z()}function Joa(a){var b=0,c=0,d=0,e=0,f=0,g=0,o=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=q(0),Q=0,R=0,S=q(0),T=0,U=0;d=Za-32|0;Za=d;a:{if(!l[a+480188>>1]){E=-1;B=65535;C=-1;break a}Q=a+1075821|0;H=a+1304392|0;r=a+1074308|0;O=a+1074376|0;L=a+480209|0;C=-1;E=-1;B=65535;while(1){f=p(u,896)+a|0;s=f+1075799|0;g=k[s|0];A=f+1075797|0;w=k[A|0];D=f+1075798|0;v=k[D|0];K=f+1075796|0;F=k[K|0];I=f+1075795|0;b=k[I|0];c=j[a+1074392>>2];o=j[a+1074400>>2];t=j[a+1074416>>2];G=f+1075794|0;x=Wr(G);y=f+1075856|0;h[y|0]=j[a+480208>>2]>>>12&1|k[y|0]&254;e=(c>>>0)%(o+t>>>0)|0;c=k[G|0];if((c|0)==252){c=k[I|0];o=sx(G);t=Ur(G);b:{if(!c|c-251>>>0<5){break b}c=j[(p(c,160)+a|0)+906140>>2];if(!c){break b}bb[j[j[c>>2]+44>>2]](c,o,q(q(t>>>0)*q(.0010010009864345193)))}c=k[G|0]}c:{if(w&255|n[f+1075868>>2]==q(0)?(c&255)!=251:0){break c}z=j[a+480208>>2]&4096;d:{if(!z){t=k[f+1075878|0];break d}t=k[I|0];h[f+1075878|0]=t}c=t&255;if(c-251>>>0<5|!c){break c}o=(p(c,160)+a|0)+906140|0;if(!j[o>>2]){break c}e:{if(!z){c=l[f+1075876>>1];break e}c=Rr(k[K|0],k[D|0]);i[f+1075876>>1]=c;P=q(q(Rr(k[A|0],k[s|0])>>>0)*q(.0010010009864345193));n[f+1075872>>2]=P;s=j[o>>2];R=f+1075868|0,S=q(q(P-q(bb[j[j[s>>2]+48>>2]](s,c)))/q(al(a)>>>0)),n[R>>2]=S}s=j[a+1074392>>2];t=al(a);o=j[o>>2];if((t|0)==(s+1|0)){bb[j[j[o>>2]+44>>2]](o,c,n[f+1075872>>2]);break c}bb[j[j[o>>2]+100>>2]](o,c,n[f+1075868>>2])}s=f+1074984|0;f:{g:{h:{i:{j:{if(!MK(k[G|0])){if(k[L|0]&16){break j}break i}Ioa(s);b=0;F=0;v=0;w=0;g=0;x=0;if(!(k[L|0]&16)){break i}t=0;break g}if(!b){b=0;break h}j[f+1075768>>2]=0;break h}DK(a,s)}A=w&255;if((A|0)==33){mb(d+24|0,r,30);t=g>>>4|0;ox(a,u&65535,t+(g&15)|0,kb(d+24|0));w=33;break g}t=0;if((w-19&255)>>>0>1){break g}k:{if(!(!(j[a+480180>>2]&16777250)|g)){g=k[f+1075837|0];break k}h[f+1075837|0]=g}c=g&240;if((c|0)==208){c=g&15;if(!c){if(j[a+480180>>2]&16777248){t=1;break g}if(j[a+480180>>2]!=2){break g}break f}l:{if(c>>>0<j[a+1074400>>2]+j[a+1074416>>2]>>>0){break l}mb(d+24|0,r,14);if(!kb(d+24|0)){break l}if(!b){break f}h[f+1075809|0]=b;break f}t=c;break g}if(!(k[L|0]&16)){break g}o=19;m:{n:{o:{if(!((c|0)==96?(A|0)==19:0)){if((c|0)!=176){break n}o=20;if((A|0)!=20){break o}}mb(d+24|0,r,77);if(!(!kb(d+24|0)|!(j[((u<<5)+a|0)+480280>>2]&1024))){w=o;break g}c=Hoa(a,s,g&15);p:{if((c|0)==-1){c=E;break p}q:{if((C|0)!=-1){mb(d+24|0,r,68);C=kb(d+24|0)?c:C;break q}C=-1}mb(d+24|0,r,103);B=kb(d+24|0)?-1:B}if(!l[a+480188>>1]|j[a+480180>>2]!=2){break m}E=f+1075845|0;A=f+1075788|0;w=0;while(1){D=p(w,896)+a|0;j[D+1075788>>2]=j[A>>2];h[D+1075845|0]=k[E|0];w=w+1|0;if(w>>>0<l[a+480188>>1]){continue}break}break m}w=19;break g}if((c|0)!=224|(j[a+1074396>>2]?j[a+480180>>2]&16777250:0)){break g}c=g&15;if(j[a+480180>>2]&2?!c:0){break g}j[a+1074396>>2]=c+1;break g}w=o;E=c}M=w&255;o=(M|0)==19&j[a+480180>>2]==16&(g&240)==208;z=o?0:t;r:{if(!z|k[G|0]!=255|k[K|0]!=2){break r}mb(d+24|0,r,74);if(!kb(d+24|0)){break r}h[K|0]=0}c=j[a+1074392>>2];mb(d+24|0,r,72);s:{if(kb(d+24|0)){t=0;if(z>>>0>=m[a+1074416>>2]){break s}}mb(d+24|0,r,88);t=(e|0)==(z|0)|(c|0)==(z|0);if(!(!z|!kb(d+24|0))){break s}t=(c|0)==(z|0)}D=t;mb(d+24|0,r,44);if(kb(d+24|0)){h[y|0]=k[y|0]&254|(e|0)==(z|0)}N=g&15;e=o?N|144:g;mb(d+24|0,r,66);x=(!z|kb(d+24|0)^1)&x;t:{u:{if(!(j[a+1074392>>2]|(!b|!(j[a+480208>>2]&2097152)))){j[f+1075644>>2]=0;if(D){break u}if(!oh(s)){break t}h[f+1075809|0]=b;if(l[a+480190>>1]<b>>>0){break t}b=p(b,104)+a|0;j[f+1075672>>2]=l[b+484410>>1];j[f+1075752>>2]=h[b+484417|0];break t}if(!D){break t}}g=k[G|0];if(b){h[f+1075809|0]=b}v:{w:{if(!Ld(g)){break w}mb(d+24|0,r,67);if(!kb(d+24|0)){break w}o=j[f+1075756>>2];x:{if(!b|x){break x}y:{if(l[a+480192>>1]){c=65535;if(l[a+480192>>1]<b>>>0){break y}t=j[((b<<2)+a|0)+900380>>2];if(!t){break y}c=l[Nc(t+236|0,g-1|0)>>1];break y}c=b}c=c&65535;if(c>>>0>l[a+480190>>1]){break x}o=h[Yo(a,c)+36|0]}g=(g+o|0)-12>>>0>119?0:g;break v}if(!(j[a+480180>>2]&25165856)|!l[a+480192>>1]){break v}c=g;o=1;z:{if(!c){break z}o=Ld(c)}if(!o){break v}o=b?b:k[f+1075810|0];if(!o|(j[((o<<2)+a|0)+900380>>2]?l[a+480192>>1]>=o>>>0:0)){break v}g=0;b=0}if(!((M|0)!=25|e)){mb(d+24|0,r,55);c=kb(d+24|0);b=c?0:b;g=c?0:g}mb(d+24|0,r,65);c=(b|0)!=0;o=!g;t=kb(d+24|0);J=1;A:{if(j[a+480180>>2]&16777248){break A}mb(d+24|0,r,107);if(kb(d+24|0)){break A}mb(d+16|0,r,85);J=0;if(!kb(d+16|0)){break A}if(oh(s)){break A}J=1;y=j[f+1075088>>2];if(!y){break A}J=ke(y)^1}o=c&o;A=c&t;B:{C:{D:{E:{F:{G:{H:{I:{if(!(j[a+480180>>2]&1048580)){break I}J:{if((g|0)!=255){break J}if(!(b?0:!((M|0)==13|(F&255)==1))){mb(d+24|0,r,55);if(kb(d+24|0)){break J}}c=j[f+1075640>>2];if(h[c+60|0]&1?c:0){break J}j[f+1075672>>2]=0;b=f+1075072|0;j[b>>2]=j[b>>2]|2097152;K:{if(!(j[a+480208>>2]&4096)){break K}mb(d+24|0,r,86);if(!kb(d+24|0)){break K}j[b>>2]=j[b>>2]|4096}b=0;g=0;c=0;o=0;t=0;y=1;if(A){break C}break B}mb(d+24|0,r,59);if(!kb(d+24|0)|j[a+480208>>2]&4096){break I}c=k[f+1075803|0]-k[f+1075756|0]|0;if(!g){break G}if(g>>>0>250){J=0;A=1;c=0;break G}if(!b){mb(d+24|0,r,98);A=0;if(kb(d+24|0)){break H}}J=1;A=1;break H}c=0;t=0;if(!o){break E}break F}c=g}x=0}mb(d+24|0,r,65);if(!kb(d+24|0)){break D}g=c;t=1}o=g;c=t;y=1;if(A){break C}break B}g=c;c=1;y=A}L:{M:{if(!l[a+480192>>1]){if(l[a+480190>>1]<b>>>0){break L}o=(p(b,104)+a|0)+484380|0;break M}o=j[f+1075088>>2];if(!o){break L}}N:{if(i[o+34>>1]<0){break N}if(j[a+480180>>2]==2){if(!ke(o)){break N}}j[f+1075672>>2]=l[o+30>>1]}if(!y){break L}ls(s,l[o+28>>1],a)}o=g;t=c}mb(d+24|0,r,71);if(!(!b|!kb(d+24|0))){h[f+1075843|0]=32}O:{if(!l[a+480192>>1]){break O}mb(d+24|0,r,100);if(!b|!kb(d+24|0)){break O}if(Ld(o&255)){break O}c=j[a+480208>>2];P:{if(x){if(c&8){break P}break O}if(!(c&4)){break O}}cl(s);j[f+1075680>>2]=65536;c=f+1075072|0;j[c>>2]=j[c>>2]|2097152}if(t){mb(d+24|0,r,11);Q:{if(R=!kb(d+24|0),T=0,U=j[a+480180>>2]!=268435456,U?R:T){break Q}mb(d+24|0,r,87);g=0;if(kb(d+24|0)){g=oh(s)^1}if(l[a+480192>>1]){if((g^-1)&j[f+1075640>>2]==j[((b<<2)+a|0)+900380>>2]|l[a+480192>>1]<b>>>0){break Q}o=k[f+1075803|0];break Q}if((g^-1)&j[f+1075088>>2]==((p(b,104)+a|0)+484380|0)|b>>>0>3999){break Q}o=k[f+1075803|0]}R:{if(!l[a+480192>>1]|!(j[a+480180>>2]&1048588)){break R}cl(s);h[f+1075822|0]=0;j[f+1075764>>2]=0;j[f+1075680>>2]=65536;c=f+1075072|0;j[c>>2]=j[c>>2]&-2101249|2097152;mb(d+24|0,r,86);if(!kb(d+24|0)){break R}j[c>>2]=j[c>>2]&-2049}b=J?b:0}t=o&255;S:{if(t>>>0<251){break S}mb(d+24|0,r,50);T:{if(!b|!kb(d+24|0)){break T}if(l[a+480192>>1]){if(l[a+480192>>1]<b>>>0){break T}c=((b<<2)+a|0)+900380|0;if(!j[c>>2]){break T}g=f+1075805|0;if(!Ld(k[g|0])){break T}c=l[Nc(j[c>>2]+236|0,k[g|0]-1|0)>>1]}else{c=b}c=c&65535;if(!c|c>>>0>l[a+480190>>1]){break T}c=p(c,104)+a|0;if(i[c+484414>>1]<0){break T}j[f+1075672>>2]=l[c+484410>>1]}mb(d+24|0,r,100);if(R=kb(d+24|0),T=0,U=j[a+480208>>2]&4,U?R:T){break S}b=0}U:{if(!Ld(t)){break U}h[f+1075808|0]=o;h[f+1075805|0]=o;if(x){break U}GK(a,u&65535,b,t,0)}V:{W:{X:{Y:{if(t){g=f+1075780|0;c=i[g>>1];if(c){j[f+1075676>>2]=(c&32767)-1;if((c|0)<=-1){c=f+1075072|0;j[c>>2]=j[c>>2]|256}i[g>>1]=0}c=f+1075801|0;g=k[c|0];if(g){h[f+1075842|0]=g-1;h[c|0]=0}c=f+1075802|0;g=k[c|0];if(g){h[f+1075841|0]=g-1;h[c|0]=0}if(!b){break Y}break X}if(b){break X}b=x;break V}c=0;o=1;y=f+1075809|0;Z:{if(!k[y|0]){break Z}if(!Ld(t)){break Z}Go(a,s,k[y|0],x,j[f+1075088>>2]?0:!j[f+1075640>>2],!(j[a+480180>>2]&1048580));h[y|0]=0;c=1}b=x;break W}c=f+1075088|0;g=j[c>>2];Go(a,s,b,x,1,1);b=j[c>>2];_:{if(!b|!(k[b+35|0]&2)){break _}if(!$c(H)){break _}ds(j[H>>2],u&65535,j[c>>2]+68|0)}$:{if(j[a+480180>>2]==1){if(x){mb(d+24|0,r,85);if(kb(d+24|0)){break $}}h[f+1075809|0]=0;break $}mb(d+24|0,r,50);if(kb(d+24|0)){if(!Ld(t)){break $}}h[f+1075809|0]=0}mb(d+24|0,r,42);aa:{ba:{ca:{if(kb(d+24|0)){if(!Ld(t)|(g|0)==j[c>>2]){break ba}break ca}if(!(!(j[a+480180>>2]&16777248)|(g|0)==j[c>>2])){b=0;if(Ld(t)){break aa}}mb(d+24|0,r,107);da:{if(!kb(d+24|0)|(g|0)==j[c>>2]){break da}if(!x){if(Ld(t)){break da}}b=f+1075060|0;if(m[b>>2]>=m[s+4>>2]){break da}j[b>>2]=0;break ba}mb(d+24|0,r,85);if(!kb(d+24|0)){break ba}if(oh(s)){break ba}}j[s>>2]=0;j[s+4>>2]=0}b=x}o=0;c=0;if(!t){break V}}g=f+1075088|0;x=j[g>>2];ea:{if(!x|!(k[x+35|0]&2)){break ea}if(!$c(H)){break ea}if(!c){if(HK(j[H>>2],u&65535)){break ea}}ds(j[H>>2],u&65535,j[g>>2]+68|0)}c=u&65535;Sr(a,s,t,b,!(j[a+480180>>2]&1048580),0,c);if(!(!b|(!(j[a+480180>>2]&1048580)|o))){g=f+1075072|0;j[g>>2]=j[g>>2]|2097152;cl(s);h[f+1075822|0]=0;j[f+1075764>>2]=0}if(!(j[f+1075072>>2]&512)){break V}if(!$c(H)){break V}fa:{switch(t-253|0){case 0:mb(d+24|0,r,99);if(kb(d+24|0)){break V}break;case 1:case 2:break fa;default:break V}}Uj(j[H>>2],c)}ga:{ha:{switch((F&255)-1|0){case 0:v=v>>>0<64?v:64;j[f+1075672>>2]=v<<2;c=f+1075072|0;j[c>>2]=j[c>>2]|2097152;break ga;case 1:break ha;default:break ga}}dl(a,s,v,6)}if(l[a+480192>>1]){lJ(a,u&65535)}x=b}mb(d+24|0,r,77);if(R=kb(d+24|0),T=0,U=j[((u<<5)+a|0)+480280>>2]&1024,U?R:T){break f}b=j[a+1074392>>2];mb(d+24|0,r,75);ia:{ja:{ka:{b=b>>>0>=z>>>0;la:{if(!z|!kb(d+24|0)){break la}c=j[a+1074392>>2];if(!c){break ka}b=1;if((c|0)!=(z|0)){break la}b=!k[I|0]&(F&255)!=11}c=F&255;if(!b|c>>>0<3){break ka}if((c|0)==11){rx(d+24|0,a,G,z);b=k[Rb(d+24|0)|0];Dm(a,s,j[d+24>>2]);if(b){break ia}b=11;break ja}mb(d+24|0,r,62);ma:{if(!(!kb(d+24|0)|v)){v=0;b=0;na:{switch(c-8|0){case 0:break ma;case 1:break na;default:break ja}}if(k[L|0]&16){break ja}j[f+1075676>>2]=0;break ja}mb(d+24|0,r,41);if(kb(d+24|0)){break ma}if(v){h[f+1075838|0]=v;break ma}v=k[f+1075838|0]}b=F;oa:{switch(c-3|0){case 0:case 1:pa:{qa:{if(v){break qa}mb(d+24|0,r,41);if(!kb(d+24|0)){break qa}v=k[f+1075838|0];if(v){break pa}v=0;break ka}h[f+1075838|0]=v}Gm(a,s,((c|0)==3?v<<4:v)&255);break ka;case 2:if((z|0)!=j[a+1074392>>2]){mb(d+24|0,r,41);b=5;if(kb(d+24|0)){break ja}}mb(d+24|0,r,41);Eo(a,s,v,kb(d+24|0));b=5;break ja;case 3:if((z|0)!=j[a+1074392>>2]){mb(d+24|0,r,41);b=6;if(kb(d+24|0)){break ja}}mb(d+24|0,r,41);Do(a,s,v,kb(d+24|0));b=6;break ja;case 4:mb(d+24|0,r,53);if(kb(d+24|0)){h[f+1075827|0]=v&15;b=7;break ja}Oj(s,v<<4);b=7;break ja;case 5:Oj(s,v);b=8;break ja;case 6:mb(d+24|0,r,62);nx(a,s,v,kb(d+24|0)^1);b=9;break ja;case 7:mb(d+24|0,r,62);nx(a,s,v<<4&240,kb(d+24|0)^1);b=10;break ja;case 9:b=12;mb(d+24|0,r,12);CK(a,u&65535,v<<2&252,kb(d+24|0));break ja;case 10:mb(d+24|0,r,12);BK(a,u&65535,v<<2&252,kb(d+24|0));b=13;break ja;case 12:break oa;default:break ja}}b=15;if(!D|v>>>0>9){break ja}c=j[f+1075088>>2];if(!c){break ja}ra:{if(!v){t=j[f+1075648>>2];break ra}t=j[(c+(v<<2)|0)- -64>>2];j[f+1075648>>2]=t}Fo(a,s,t);break ja}b=F}sa:{ta:{ua:{va:{wa:{xa:{ya:{za:{Aa:{Ba:{Ca:{Da:{Ea:{Fa:{Ga:{Ha:{Ia:{Ja:{Ka:{La:{Ma:{Na:{Oa:{Pa:{Qa:{Ra:{switch(M-1|0){case 12:if(!(k[a+480209|0]&16)){break ia}b=p(u,896)+a|0;j[b+1075672>>2]=e>>>0<64?e<<2:256;b=b+1075072|0;j[b>>2]=j[b>>2]|2097152;break ia;case 1:if(j[a+480180>>2]&1?!e:0){break Qa}CK(a,u&65535,e,0);break ia;case 2:if(j[a+480180>>2]&1?!e:0){break Qa}BK(a,u&65535,e,0);break ia;case 10:if(j[a+480180>>2]==1?!e:0){break Qa}Gm(a,s,e);break ia;case 3:Dm(a,s,e);break ia;case 5:if(!(j[a+480180>>2]==1?!e:0)){Gm(a,s,e)}Dm(a,s,0);break ia;case 4:Oj(s,e);break ia;case 6:if(!(j[a+480180>>2]==1?!e:0)){Gm(a,s,e)}Oj(s,0);break ia;case 15:if(!(k[a+480209|0]&16)){break ia}break sa;case 16:mb(d+24|0,r,5);if(kb(d+24|0)){if(!e){break ia}if(j[a+480208>>2]&4096){break sa}break ia}e=Ho(a,l[a+1074436>>1],j[a+1074424>>2],u&65535,0);Sa:{if(!(j[a+480180>>2]&16777250)){break Sa}if(e){h[(p(u,896)+a|0)+1075839|0]=e;break Sa}e=k[(p(u,896)+a|0)+1075839|0]}j[d+24>>2]=p(e,1e4);jc(d+24|0,p(j[j[a+8>>2]+24>>2],1e4));Goa(a,j[d+24>>2]);break ia;case 9:if(!D|(j[a+480180>>2]==4?x:0)){break ia}h[d+24|0]=0;b=Ho(a,l[a+1074436>>1],j[a+1074424>>2],u&65535,d+24|0);c=a;g=s;if(!k[d+24|0]){o=(p(u,896)+a|0)+1075648|0;b=b<<8;Ta:{if(b){j[o>>2]=b;break Ta}b=j[o>>2]}b=(k[(p(u,896)+a|0)+1075840|0]<<16)+b|0}Fo(c,g,b);break ia;case 40:if(!D){break ia}c=HMa(j[(p(u,896)+a|0)+1075060>>2],0,e,0);b=ab;g=b>>>8|0;Fo(a,s,Tc((b&255)<<24|c>>>8,g));break ia;case 0:if(j[a+1074392>>2]){break ia}b=p(u,896)+a|0;Ua:{if(k[b+1075803|0]?j[b+1075684>>2]:0){break Ua}b=j[b+1075640>>2];if(b){if(ai(b)){break Ua}}mb(d+24|0,r,13);if(kb(d+24|0)){break Ua}if(j[a+480180>>2]&16777248){break ia}}if(!e){e=0;if(j[a+480180>>2]&5){break ia}h[(p(u,896)+a|0)+1075811|0]=1;break ia}b=p(u,896)+a|0;h[b+1075812|0]=e;h[b+1075811|0]=1;break ia;case 14:if(j[a+480180>>2]&1048580){e=e&240?e:l[(p(u,896)+a|0)+1075784>>1]&240|e;if(!(e&15)){e=l[(p(u,896)+a|0)+1075784>>1]&15|e}e=e|256}mb(d+24|0,r,23);if(kb(d+24|0)){Va:{if(!e){t=l[(p(u,896)+a|0)+1075784>>1];break Va}t=e&255;i[(p(u,896)+a|0)+1075784>>1]=t}mx(a,u&65535,t<<16>>16,(b&255)==15?v+1|0:0);break ia}Wa:{if(e){i[(p(u,896)+a|0)+1075784>>1]=e&255;break Wa}e=i[(p(u,896)+a|0)+1075784>>1]}mx(a,u&65535,e,(b&255)==15?v+1|0:0);break ia;case 39:break wa;case 38:break xa;case 34:case 35:case 36:case 37:break ya;case 13:break za;case 11:break Aa;case 29:break Ba;case 26:break Ca;case 21:break Da;case 20:break Ea;case 27:break Fa;case 24:break Ga;case 19:break Ha;case 18:break Ia;case 25:break Ja;case 7:break Ka;case 28:break La;case 8:break Ma;case 23:break Na;case 22:break Oa;case 17:break Ra;default:break ia}}if(!(k[a+480209|0]&16)){break ia}mb(d+24|0,r,22);Xa:{Ya:{if(kb(d+24|0)){if(!e){e=0;break Ya}if(k[a+480208|0]&4){break Ya}b=e&240?e-16|0:e;e=b-((b&15)!=0)|0;break Ya}mb(d+24|0,r,71);if(!kb(d+24|0)){break Xa}}b=(p(u,896)+a|0)+1075843|0;h[b|0]=k[b|0]|128}b=p(u,896)+a|0;h[b+1075811|0]=18;if(e){break Pa}}e=0;break ia}h[b+1075844|0]=e;break ia}if(!(k[a+480209|0]&16)){break ia}e=e<<!(j[a+480180>>2]&59593760);if(e>>>0<=128){j[a+1074444>>2]=e<<1;break ia}if(j[a+480180>>2]&16777250){break ia}j[a+1074444>>2]=256;break ia}mb(d+24|0,r,9);if(kb(d+24|0)){zK(a,e,(p(u,896)+a|0)+1075821|0);break ia}zK(a,e,Q);break ia}if(!(k[a+480209|0]&16)){break ia}dl(a,s,e,8);break ia}nx(a,s,e,1);break ia}TK(s,e);break ia}UK(a,s,e);break ia}Foa(a,u&65535,e);break ia}mb(d+24|0,r,78);c=a;b=u&65535;if(!(!kb(d+24|0)|e)){e=k[(p(u,896)+a|0)+1075812|0]}yK(c,b,e);break ia}mb(d+24|0,r,55);if(kb(d+24|0)){if(j[a+1074392>>2]!=(e|0)){break ia}b=j[(p(u,896)+a|0)+1075640>>2];if(h[b+60|0]&1?b:0){break ta}if(!((k[K|0]?0:!k[I|0])|e)){b=(p(u,896)+a|0)+1075072|0;j[b>>2]=j[b>>2]|4096;break ta}b=p(u,896)+a|0;j[b+1075672>>2]=0;b=b+1075072|0;j[b>>2]=j[b>>2]|2097152;break ta}if(k[a+480209|0]&16){break ta}break ia}b=(e&240)-16>>>4|0;if(b>>>0>9){break ia}if(!(1<<b&880)){if(!b){break va}if((b|0)!=1){break ia}xK(a,s,e&15);break ia}mb(d+24|0,r,58);if(kb(d+24|0)){break ia}yK(a,u&65535,e);break ia}if(!(j[a+480208>>2]&4096)|e>>>0>64){break ia}b=p(u,896)+a|0;j[b+1075744>>2]=e;b=b+1075072|0;j[b>>2]=j[b>>2]|2097152;break ia}Eoa(a,s,e);break ia}SK(s,e);break ia}if(!(k[a+480209|0]&16)){break ia}b=p(u,896)+a|0;j[b+1075712>>2]=e;mb(d+24|0,r,60);if(R=0,T=kb(d+24|0),U=k[b+1075708|0]&4,U?R:T){break ia}b=p(u,896)+a|0;j[b+1075736>>2]=e;j[b+1075724>>2]=e;break ia}j[a+1074432>>2]=0;B=Ho(a,l[a+1074436>>1],j[a+1074424>>2],u&65535,0);C=(C|0)!=-1?j[a+480180>>2]&5?0:C:C;break ia}b=VK(a,O,u&65535,e);if((b|0)==-1){break ia}if(!(k[a+480208|0]&32)){break ua}B=l[a+1074438>>1];break ua}b=w&255;Doa(a,s,e,(b|0)==35|(b|0)==37,(w-37&255)>>>0<2);break ia}QK(d,s,e);break ia}if(j[a+1074392>>2]|N>>>0>2|e>>>0>31){break ia}b=u;F=b;if((e&240)==16){F=l[a+480188>>1]-1|0;b=0}while(1){g=b&65535;c=((g<<5)+a|0)+480280|0;o=j[c>>2];Za:{if((N|0)==1){w=j[(p(g,896)+a|0)+1075072>>2]|67108864;o=o|67108864;break Za}w=j[(p(g,896)+a|0)+1075072>>2]&-67108865;o=o&-67108865}j[c>>2]=o;j[(p(g,896)+a|0)+1075072>>2]=w;b=b+1|0;if((b&65535)>>>0<=(F&65535)>>>0){continue}break}break ia}wK(a,s,e&15);break ia}C=b;break ia}Fm(a,s);break ia}WK(a,O,e)}mb(d+24|0,r,78);if(!(!e|!kb(d+24|0))){Coa(s,e&255)}b=k[I|0];if(!b){break f}h[f+1075810|0]=b}u=u+1|0;if(u>>>0<l[a+480188>>1]){continue}break}}_a:{if(!(k[a+480209|0]&16)){break _a}$a:{if(!((B&65535)!=65535|(C|0)!=-1)){if((E|0)==-1){break _a}break $a}ab:{if((E|0)==-1){break ab}b=a+1074308|0;mb(d+24|0,b,68);if(kb(d+24|0)){break ab}mb(d+16|0,b,103);c=(B&65535)==65535;if(kb(d+16|0)?!c:0){break ab}mb(d+8|0,b,49);if(c|!kb(d+8|0)){break $a}}B=(B&65535)==65535?l[a+1074438>>1]+1|0:B;j[a+480208>>2]=j[a+480208>>2]|524288;b=a+484360|0;if(Yb(Eb(b))>>>0<=(B&65535)>>>0){B=l[Eb(b)+28>>1]}c=(C|0)==-1?0:C;bb:{if(l[a+1074438>>1]==(B&65535)){break bb}b=a+1074308|0;mb(d+24|0,b,26);if(kb(d+24|0)){break bb}mb(d+16|0,b,68);if(kb(d+16|0)|j[a+480180>>2]==1|!l[a+480188>>1]){break bb}b=0;while(1){h[(p(b,896)+a|0)+1075845|0]=0;b=b+1|0;if(b>>>0<l[a+480188>>1]){continue}break}}j[a+1074428>>2]=c;if(k[a+480208|0]&32){break _a}i[a+1074440>>1]=B;break _a}j[a+1074428>>2]=E;i[a+1074440>>1]=l[a+1074438>>1];cb:{if(!j[a+1074396>>2]){break cb}if(j[a+480180>>2]==32){mb(d+24|0,a+1074308|0,103);if(kb(d+24|0)){break cb}}if(j[a+480180>>2]==2){break cb}j[a+1074428>>2]=j[a+1074428>>2]+1}if(m[Hb(a+484344|0,l[a+1074436>>1])+12>>2]<=E>>>0){j[a+1074428>>2]=0;i[a+1074440>>1]=l[a+1074440>>1]+1}gra(a+1304360|0,l[a+1074438>>1],E)}Za=d+32|0;return 1}function lKa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,J=0,M=0,O=0,P=0,Q=0,R=0,S=0;d=Za-304|0;Za=d;rc(b);a:{b:{c:{d:{e:{f:{g:{h:{i:{j:{k:{l:{m:{n:{o:{p:{q:{r:{s:{t:{u:{v:{w:{x:{y:{z:{A:{B:{C:{D:{E:{F:{G:{H:{I:{J:{K:{L:{M:{N:{O:{P:{Q:{R:{S:{if(!kf(b,d+296|0)){break S}if(!XR(d+296|0)){break S}if(!c){x=1;break S}y=tl(d+280|0,b);j[114630]=0;I(473,d+264|0,y|0,1);b=j[114630];j[114630]=0;T:{U:{V:{W:{X:{Y:{Z:{_:{if((b|0)!=1){j[114630]=0;I(474,d+128|0,d+264|0,1229866575);b=j[114630];j[114630]=0;if((b|0)==1){break Y}j[114630]=0;x=E(475,d+128|0,d+248|0)|0;b=j[114630];j[114630]=0;if((b|0)==1){break _}jb(d+128|0);if(!x){break T}j[114630]=0;F(447,a|0,524288);b=j[114630];j[114630]=0;if((b|0)==1){break c}j[114630]=0;N(476,a|0);b=j[114630];j[114630]=0;if((b|0)!=1){break Z}break c}b=D()|0;C()|0;break a}b=D()|0;C()|0;jb(d+128|0);break b}j[a+480208>>2]=12;b=k[d+256|0]|k[d+257|0]<<8;R=a,S=kd((b<<8|b>>>8)&65535,1,127),i[R+480188>>1]=S;b=k[d+248|0]|k[d+249|0]<<8;j[114630]=0;i[d+128>>1]=b<<8|b>>>8;i[d+216>>1]=255;b=E(477,d+128|0,d+216|0)|0;e=j[114630];j[114630]=0;if((e|0)==1){break d}i[a+480192>>1]=l[b>>1];b=d+248|2;b=k[b|0]|k[b+1|0]<<8;j[114630]=0;i[d+128>>1]=b<<8|b>>>8;i[d+216>>1]=3999;b=E(477,d+128|0,d+216|0)|0;e=j[114630];j[114630]=0;if((e|0)==1){break e}i[a+480190>>1]=l[b>>1];j[114630]=0;b=a+1074308|0;K(478,b|0,6,1)|0;e=j[114630];j[114630]=0;if((e|0)==1){break c}j[114630]=0;E(479,b|0,21)|0;e=j[114630];j[114630]=0;if((e|0)==1){break c}j[114630]=0;E(479,b|0,13)|0;b=j[114630];j[114630]=0;if((b|0)==1){break c}j[114630]=0;b=E(2,d+128|0,12385)|0;e=j[114630];j[114630]=0;if((e|0)==1){break f}ob(a+1304436|0,b);gb(b);j[114630]=0;b=E(2,d+128|0,12401)|0;e=j[114630];j[114630]=0;if((e|0)==1){break g}ob(a+1304448|0,b);gb(b);j[114630]=0;e=E(2,d+232|0,12405)|0;b=j[114630];j[114630]=0;if((b|0)==1){break h}j[114630]=0;F(219,d+216|0,e|0);b=j[114630];j[114630]=0;if((b|0)==1){break j}j[114630]=0;F(480,d+200|0,d+296|4);b=j[114630];j[114630]=0;if((b|0)==1){break l}j[114630]=0;F(480,d+184|0,d+296|5);b=j[114630];j[114630]=0;if((b|0)==1){break n}j[114630]=0;L(222,d+128|0,d+216|0,d+200|0,d+184|0);b=j[114630];j[114630]=0;if((b|0)==1){break o}ob(a+1304460|0,d+128|0);gb(d+128|0);gb(d+184|0);gb(d+200|0);qb(d+216|0);gb(e);j[a+1304496>>2]=2;j[114630]=0;I(474,d+216|0,d+264|0,1312902469);b=j[114630];j[114630]=0;if((b|0)==1){break p}j[114630]=0;b=H(255,d+216|0)|0;e=j[114630];j[114630]=0;if((e|0)==1){break r}j[114630]=0;f=a+1304400|0;K(481,d+216|0,f|0,b|0)|0;b=j[114630];j[114630]=0;if((b|0)==1){break r}j[114630]=0;I(474,d+200|0,d+264|0,1397706311);b=j[114630];j[114630]=0;if((b|0)==1){break s}b=a+484360|0;xp(Eb(b));$:{e=d+248|4;e=k[e|0]|k[e+1|0]<<8;aa:{if(!e){break aa}m=(e<<8|e>>>8)&65535;e=0;while(1){j[114630]=0;g=E(258,d+200|0,46)|0;n=j[114630];j[114630]=0;ba:{if((n|0)!=1){if(!g){break aa}j[114630]=0;K(482,d+200|0,d+128|0,44)|0;g=j[114630];j[114630]=0;if((g|0)!=1){if(!Ec(f)){break ba}j[114630]=0;E(483,f|0,d+128|0)|0;g=j[114630];j[114630]=0;if((g|0)!=1){break ba}}b=D()|0;C()|0;break t}b=D()|0;C()|0;break t}j[114630]=0;g=H(484,d+200|0)|0;n=j[114630];j[114630]=0;if((n|0)==1){break $}if(!Xc(Eb(b))){j[114630]=0;n=H(485,b|0)|0;o=j[114630];j[114630]=0;if((o|0)==1){break $}if((n|0)==255){break aa}}n=Eb(b);j[114630]=0;I(6,d+184|0,2,d+128|0);o=j[114630];j[114630]=0;if((o|0)==1){break u}j[114630]=0;F(486,n|0,d+184|0);n=j[114630];j[114630]=0;if((n|0)==1){break v}gb(d+184|0);n=Eb(b);j[114630]=0;U(487,n|0,d+200|0,g|0,65535,65535)|0;g=j[114630];j[114630]=0;if((g|0)==1){break $}e=e+1|0;if(m>>>0>(e&65535)>>>0){continue}break}}j[114630]=0;F(488,b|0,0);b=j[114630];j[114630]=0;if((b|0)==1){break w}j[114630]=0;I(474,d+184|0,d+264|0,1229869908);b=j[114630];j[114630]=0;if((b|0)==1){break x}j[114630]=0;b=H(489,d+184|0)|0;e=j[114630];j[114630]=0;if((e|0)==1){break G}ca:{if(!b){break ca}if(l[a+480192>>1]){m=1;while(1){j[114630]=0;E(490,d+184|0,d+128|0)|0;b=j[114630];j[114630]=0;da:{ea:{fa:{if((b|0)!=1){b=k[d+158|0]|k[d+159|0]<<8;j[114630]=0;b=K(454,a|0,m&65535,(b<<8|b>>>8)&65535)|0;e=j[114630];j[114630]=0;if((e|0)==1){break fa}if(!b){break da}e=k[d+158|0]|k[d+159|0]<<8;if(((e<<8|e>>>8)&65535)>>>0>3999){break da}j[114630]=0;I(491,d+16|0,2,d+128|0);e=j[114630];j[114630]=0;if((e|0)!=1){j[114630]=0;F(415,d- -64|0,d+16|0);e=j[114630];j[114630]=0;if((e|0)!=1){break ea}}b=D()|0;C()|0;break y}b=D()|0;C()|0;break y}b=D()|0;C()|0;break y}j[114630]=0;E(369,b+492|0,d- -64|0)|0;e=j[114630];j[114630]=0;if((e|0)==1){break z}gb(d- -64|0);j[114630]=0;I(491,d+16|0,2,d+128|0);e=j[114630];j[114630]=0;if((e|0)==1){break A}j[114630]=0;F(415,d- -64|0,d+16|0);e=j[114630];j[114630]=0;if((e|0)==1){break A}e=k[d+158|0]|k[d+159|0]<<8;j[114630]=0;E(369,((((e<<8|e>>>8)&65535)<<5)+a|0)+946300|0,d- -64|0)|0;e=j[114630];j[114630]=0;if((e|0)==1){break B}gb(d- -64|0);j[b>>2]=0;e=k[d+174|0]|k[d+175|0]<<8;j[b+8>>2]=(e<<8|e>>>8)+128&65535;jc(b+8|0,256);h[b+15|0]=k[b+15|0]|1;b=k[d+158|0]|k[d+159|0]<<8;j[114630]=0;b=p((b<<8|b>>>8)&65535,104)+a|0;F(386,b+484380|0,0);e=j[114630];j[114630]=0;if((e|0)==1){break C}e=k[d+160|0]|k[d+161|0]<<8;j[114630]=0;i[d+64>>1]=e<<8|e>>>8;i[d+16>>1]=64;e=E(477,d- -64|0,d+16|0)|0;f=j[114630];j[114630]=0;if((f|0)==1){break D}i[b+484410>>1]=l[e>>1]<<2;e=k[d+162|0]|k[d+163|0]<<8|(k[d+164|0]<<16|k[d+165|0]<<24);j[b+484404>>2]=e<<24|e<<8&16711680|(e>>>8&65280|e>>>24);if(!(k[d+170|0]|k[d+171|0]<<8|(k[d+172|0]<<16|k[d+173|0]<<24))|!(k[d+177|0]&3)){break da}e=k[d+166|0]|k[d+167|0]<<8|(k[d+168|0]<<16|k[d+169|0]<<24);g=e<<24|e<<8&16711680|(e>>>8&65280|e>>>24);j[b+484384>>2]=g;e=k[d+170|0]|k[d+171|0]<<8|(k[d+172|0]<<16|k[d+173|0]<<24);f=b+484414|0;i[f>>1]=l[f>>1]|2;j[b+484388>>2]=g+(e<<8&16711680|e<<24|(e>>>8&65280|e>>>24));if(!(k[d+177|0]&2)){break da}i[f>>1]=l[f>>1]|4}m=m+1|0;if(l[a+480192>>1]>=(m&65535)>>>0){continue}break}}j[114630]=0;I(474,d+112|0,d+264|0,1447382614);b=j[114630];j[114630]=0;if((b|0)==1){break G}j[114630]=0;L(492,d+112|0,0,a|0,0);b=j[114630];j[114630]=0;if((b|0)==1){break E}jb(d+112|0);j[114630]=0;I(474,d+96|0,d+264|0,1346719318);b=j[114630];j[114630]=0;if((b|0)==1){break G}j[114630]=0;L(492,d+96|0,1,a|0,k[d+300|0]>2|0);b=j[114630];j[114630]=0;if((b|0)==1){break F}jb(d+96|0);if(!l[a+480192>>1]){break ca}b=1;while(1){e=j[(((b&65535)<<2)+a|0)+900380>>2];if(!(!e|h[e+60|0]&1)){j[e>>2]=32767}b=b+1|0;if(l[a+480192>>1]>=(b&65535)>>>0){continue}break}}jb(d+184|0);j[114630]=0;I(474,d+128|0,d+264|0,1346458708);b=j[114630];j[114630]=0;if((b|0)==1){break H}j[114630]=0;b=H(337,d+128|0)|0;e=j[114630];j[114630]=0;if((e|0)==1){break J}if(!(c&1)|b^1){break X}j[114630]=0;I(474,d+184|0,d+264|0,1347305805);b=j[114630];j[114630]=0;if((b|0)==1){break K}j[114630]=0;E(338,d+184|0,1)|0;b=j[114630];j[114630]=0;if((b|0)==1){break M}s=d+248|6;e=k[s|0]|k[s+1|0]<<8;b=0;j[114630]=0;t=a+484344|0;F(401,t|0,(e<<8|e>>>8)&65535);e=j[114630];j[114630]=0;if((e|0)==1){break M}e=d+80|0;RJa(e);if(k[s|0]|k[s+1|0]<<8){B=d+16|5;J=d+16|3;M=d+16|4;O=d+16|2;P=d+16|1;f=0;while(1){j[114630]=0;A=H(484,d+128|0)|0;m=j[114630];j[114630]=0;ga:{ha:{ia:{ja:{ka:{if((m|0)!=1){j[114630]=0;m=H(493,d+128|0)|0;g=j[114630];j[114630]=0;if((g|0)==1){break ka}j[114630]=0;I(341,d- -64|0,d+128|0,m|0);m=j[114630];j[114630]=0;if((m|0)==1){break ja}j[114630]=0;m=K(402,t|0,f&65535,A|0)|0;g=j[114630];j[114630]=0;if((g|0)==1){break ia}if(!m){break ga}v=Cb(d+48|0);j[114630]=0;K(494,d+184|0,v|0,-1)|0;m=j[114630];j[114630]=0;if((m|0)!=1){m=Hb(t,f);j[114630]=0;E(495,m|0,v|0)|0;m=j[114630];j[114630]=0;if((m|0)!=1){break ha}}break P}b=D()|0;C()|0;break N}b=D()|0;C()|0;break N}b=D()|0;C()|0;break N}b=D()|0;C()|0;break O}m=Hb(t,f);j[114630]=0;m=E(496,m|0,0)|0;g=j[114630];j[114630]=0;if((g|0)==1){break P}TR(e);u=0;la:{while(1){j[114630]=0;g=E(258,d- -64|0,1)|0;n=j[114630];j[114630]=0;ma:{na:{oa:{if((n|0)!=1){if(!g){break la}j[114630]=0;o=H(387,d- -64|0)|0;g=j[114630];j[114630]=0;if((g|0)==1){break P}if(o){break na}R=d,S=Lb(e),j[R+40>>2]=S;R=d,S=Mb(e),j[R+32>>2]=S;if(rb(d+40|0,d+32|0)){break oa}break ma}break P}while(1){pa:{m=j[d+40>>2];g=Hb(t,f);n=k[m+1|0];m=k[m|0];j[114630]=0;m=K(497,d+16|0,m|0,n|0)|0;n=j[114630];j[114630]=0;if((n|0)==1){break pa}m=Ee(m,u);j[114630]=0;E(498,g|0,m|0)|0;m=j[114630];j[114630]=0;if((m|0)==1){break pa}je(d+40|0);if(rb(d+40|0,d+32|0)){continue}break ma}break}break P}th(d+16|0);w=l[a+480188>>1];j[114630]=0;g=H(387,d- -64|0)|0;n=j[114630];j[114630]=0;qa:{if((n|0)==1){break qa}n=p(o-1|0,6)+m|0;ra:{if(!(g&1)){break ra}j[114630]=0;q=H(387,d- -64|0)|0;r=j[114630];j[114630]=0;sa:{if((r|0)!=1){if(!q){break ra}if((q|0)!=31){break sa}h[(o>>>0>w>>>0?d+16|0:n)|0]=255;break ra}break P}if(q>>>0>253){break ra}h[(o>>>0>w>>>0?d+16|0:n)|0]=(p(q>>>4|0,12)+(q&15)|0)+13}if(g&2){j[114630]=0;q=H(387,d- -64|0)|0;r=j[114630];j[114630]=0;if((r|0)==1){break qa}h[(o>>>0>w>>>0?P:n+1|0)|0]=q}if(!(g&60)){continue}h[d+15|0]=0;h[d+14|0]=0;h[d+13|0]=0;h[d+12|0]=0;if(g&4){j[114630]=0;q=H(387,d- -64|0)|0;r=j[114630];j[114630]=0;if((r|0)==1){break P}h[d+14|0]=q}if(g&8){j[114630]=0;q=H(387,d- -64|0)|0;r=j[114630];j[114630]=0;if((r|0)==1){break P}h[d+12|0]=q}if(g&16){j[114630]=0;q=H(387,d- -64|0)|0;r=j[114630];j[114630]=0;if((r|0)==1){break P}h[d+15|0]=q}if(g&32){j[114630]=0;g=H(387,d- -64|0)|0;q=j[114630];j[114630]=0;if((q|0)==1){break P}h[d+13|0]=g}SR(d+15|0,d+13|0);SR(d+14|0,d+12|0);g=k[d+14|0];if(!(k[d+15|0]==13|g?(g|0)!=13:0)){Ug(d+15|0,d+14|0);Ug(d+13|0,d+12|0)}j[114630]=0;V(499,d+32|0,d+15|0,d+13|0,d+14|0,d+12|0);g=j[114630];j[114630]=0;ta:{if((g|0)==1){break ta}j[114630]=0;g=E(500,k[d+32|0],k[d+33|0])|0;q=j[114630];j[114630]=0;if((q|0)==1){break ta}ua:{if(!g){break ua}R=d,S=Lb(e),j[R+40>>2]=S;Cd(d+8|0,d+40|0);j[114630]=0;K(501,e|0,j[d+8>>2],d+32|0)|0;g=j[114630];j[114630]=0;if((g|0)!=1){break ua}break P}g=o>>>0>w>>>0;h[(g?O:n+2|0)|0]=k[d+15|0];h[(g?M:n+4|0)|0]=k[d+13|0];o=k[d+14|0];h[(g?J:n+3|0)|0]=o;h[(g?B:n+5|0)|0]=k[d+12|0];if((o|0)==40){Q=1;continue}if((o|0)!=31){continue}b=1;continue}break P}break P}TR(e);u=u+1|0;if(A>>>0<=u>>>0){break la}m=Hb(t,f);j[114630]=0;m=E(496,m|0,u|0)|0;g=j[114630];j[114630]=0;if((g|0)!=1){continue}break}break P}gb(v)}jb(d- -64|0);f=f+1|0;m=k[s|0]|k[s+1|0]<<8;if(f>>>0<((m<<8|m>>>8)&65535)>>>0){continue}break}}QR(e);m=b;jb(d+184|0);if(!(c&4)){break V}e=0;if(!Q){break W}f=l[a+480188>>1];if(!f){e=1;break W}b=0;while(1){e=1;g=(b<<5)+a|0;h[g+480288|0]=1;g=g+480280|0;j[g>>2]=j[g>>2]|67108864;b=b+1|0;if((f|0)!=(b|0)){continue}break}break W}b=D()|0;C()|0;break t}b=D()|0;C()|0;break b}m=0;e=0;if(!(c&4)){break U}}j[114630]=0;j[d+64>>2]=-1778364416;j[d+68>>2]=-16756736;I(474,d+184|0,d+264|0,1146310725);b=j[114630];j[114630]=0;va:{wa:{xa:{ya:{za:{Aa:{if((b|0)!=1){j[114630]=0;b=H(489,d+184|0)|0;f=j[114630];j[114630]=0;if((f|0)==1){break xa}if(!b){break za}j[114630]=0;g=H(484,d+184|0)|0;b=j[114630];j[114630]=0;if((b|0)==1){break xa}if(g){break Aa}f=e;break ya}b=D()|0;C()|0;break I}b=0;f=e;while(1){j[114630]=0;n=H(387,d+184|0)|0;o=j[114630];j[114630]=0;Ba:{Ca:{if((o|0)!=1){if(l[a+480188>>1]<=b>>>0){break Ba}if(!e){break Ca}o=((b<<5)+a|0)+480280|0;j[o>>2]=j[o>>2]&-67108865|((n|0)!=0)<<26;break Ba}break xa}if(n){break Ba}f=1;h[((b<<5)+a|0)+480288|0]=1}b=b+1|0;if((g|0)!=(b|0)){continue}break}break ya}jb(d+184|0);if(!e){break V}break va}j[114630]=0;E(502,d+184|0,d- -64|0)|0;b=j[114630];j[114630]=0;if((b|0)!=1){break wa}}b=D()|0;C()|0;jb(d+184|0);break I}jb(d+184|0);if(!(f&1)){break V}}j[114630]=0;N(503,a+906300|0);b=j[114630];j[114630]=0;Da:{Ea:{Fa:{Ga:{Ha:{Ia:{if((b|0)==1){break Ia}b=a+906316|0;j[b>>2]=810369604;j[b+4>>2]=1869112133;h[a+906324|0]=16;h[a+906325|0]=0;h[a+906326|0]=10;h[a+906327|0]=0;b=a+906328|0;h[b|0]=0;h[b+1|0]=0;h[b+2|0]=0;h[b+3|0]=0;j[114630]=0;j[d+184>>2]=0;b=a+906332|0;I(504,b|0,b+16|0,d+184|0);b=j[114630];j[114630]=0;if((b|0)==1){break Ha}j[114630]=0;e=E(85,d+184|0,12427)|0;b=j[114630];j[114630]=0;if((b|0)==1){break Ga}j[114630]=0;E(505,a+906348|0,e|0)|0;b=j[114630];j[114630]=0;if((b|0)==1){break Fa}gb(e);j[114630]=0;e=E(85,d+184|0,12432)|0;b=j[114630];j[114630]=0;if((b|0)==1){break Ea}j[114630]=0;E(506,a+906380|0,e|0)|0;b=j[114630];j[114630]=0;if((b|0)==1){break Da}gb(e);j[114630]=0;b=a+906304|0;F(507,b|0,8);e=j[114630];j[114630]=0;if((e|0)==1){break Ia}OR(d+184|0,k[d+65|0],k[d+67|0],k[d+69|0],k[d+71|0]);e=j[d+188>>2];b=j[b>>2];f=j[d+184>>2];h[b|0]=f;h[b+1|0]=f>>>8;h[b+2|0]=f>>>16;h[b+3|0]=f>>>24;h[b+4|0]=e;h[b+5|0]=e>>>8;h[b+6|0]=e>>>16;h[b+7|0]=e>>>24;break V}b=D()|0;C()|0;break I}b=D()|0;C()|0;break I}b=D()|0;C()|0;break I}b=D()|0;C()|0;gb(e);break I}b=D()|0;C()|0;break I}b=D()|0;C()|0;gb(e);break I}if(!m){break U}b=0;Ja:{Ka:{La:{Ma:{Na:{Oa:{Pa:{Qa:{Ra:{Sa:{Ta:{Ua:{Va:{Wa:{Xa:{Ya:{Za:{_a:{$a:{ab:{bb:{cb:{db:{while(1){eb:{j[114630]=0;j[d+48>>2]=p(b,127)>>>5;F(508,d- -64|0,12453);e=j[114630];j[114630]=0;if((e|0)==1){break eb}j[114630]=0;F(509,d+16|0,d+48|0);e=j[114630];j[114630]=0;if((e|0)==1){break db}j[114630]=0;I(510,d+184|0,d- -64|0,d+16|0);e=j[114630];j[114630]=0;if((e|0)==1){break cb}j[114630]=0;e=(b<<5)+a|0;F(511,d+80|0,e+902204|0);f=j[114630];j[114630]=0;if((f|0)==1){break bb}j[114630]=0;E(470,d+80|0,d+184|0)|0;f=j[114630];j[114630]=0;if((f|0)==1){break bb}gb(d+184|0);gb(d+16|0);qb(d- -64|0);j[114630]=0;F(508,d- -64|0,12462);f=j[114630];j[114630]=0;if((f|0)==1){break _a}j[114630]=0;F(509,d+16|0,d+48|0);f=j[114630];j[114630]=0;if((f|0)==1){break Za}j[114630]=0;I(510,d+184|0,d- -64|0,d+16|0);f=j[114630];j[114630]=0;if((f|0)==1){break Ya}j[114630]=0;F(511,d+80|0,e+903228|0);f=j[114630];j[114630]=0;if((f|0)==1){break Xa}j[114630]=0;E(470,d+80|0,d+184|0)|0;f=j[114630];j[114630]=0;if((f|0)==1){break Xa}gb(d+184|0);gb(d+16|0);qb(d- -64|0);j[114630]=0;F(508,d- -64|0,12471);f=j[114630];j[114630]=0;if((f|0)==1){break Ua}j[114630]=0;F(509,d+16|0,d+48|0);f=j[114630];j[114630]=0;if((f|0)==1){break Ta}j[114630]=0;I(510,d+184|0,d- -64|0,d+16|0);f=j[114630];j[114630]=0;if((f|0)==1){break Sa}j[114630]=0;F(511,d+80|0,e+904252|0);f=j[114630];j[114630]=0;if((f|0)==1){break Ra}j[114630]=0;E(470,d+80|0,d+184|0)|0;f=j[114630];j[114630]=0;if((f|0)==1){break Ra}gb(d+184|0);gb(d+16|0);qb(d- -64|0);j[114630]=0;F(508,d- -64|0,12480);f=j[114630];j[114630]=0;if((f|0)==1){break Oa}j[114630]=0;F(509,d+16|0,d+48|0);f=j[114630];j[114630]=0;if((f|0)==1){break Na}j[114630]=0;I(510,d+184|0,d- -64|0,d+16|0);f=j[114630];j[114630]=0;if((f|0)==1){break Ma}j[114630]=0;F(511,d+80|0,e+905276|0);e=j[114630];j[114630]=0;if((e|0)==1){break La}j[114630]=0;E(470,d+80|0,d+184|0)|0;e=j[114630];j[114630]=0;if((e|0)==1){break La}gb(d+184|0);gb(d+16|0);qb(d- -64|0);b=b+1|0;if((b|0)!=32){continue}break U}break}b=D()|0;C()|0;break I}b=D()|0;C()|0;break $a}b=D()|0;C()|0;break ab}b=D()|0;C()|0;gb(d+184|0)}gb(d+16|0)}qb(d- -64|0);break I}b=D()|0;C()|0;break I}b=D()|0;C()|0;break Va}b=D()|0;C()|0;break Wa}b=D()|0;C()|0;gb(d+184|0)}gb(d+16|0)}qb(d- -64|0);break I}b=D()|0;C()|0;break I}b=D()|0;C()|0;break Pa}b=D()|0;C()|0;break Qa}b=D()|0;C()|0;gb(d+184|0)}gb(d+16|0)}qb(d- -64|0);break I}b=D()|0;C()|0;break I}b=D()|0;C()|0;break Ja}b=D()|0;C()|0;break Ka}b=D()|0;C()|0;gb(d+184|0)}gb(d+16|0)}qb(d- -64|0);break I}j[114630]=0;I(474,d+184|0,d+264|0,1397575756);b=j[114630];j[114630]=0;if((b|0)==1){break Q}j[114630]=0;b=H(337,d+184|0)|0;e=j[114630];j[114630]=0;if((e|0)==1){break R}if(!(!l[a+480190>>1]|(!(c&2)|b^1))){e=1;c=1;while(1){j[114630]=0;b=H(493,d+184|0)|0;f=j[114630];j[114630]=0;fb:{if((f|0)!=1){j[114630]=0;f=H(493,d+184|0)|0;m=j[114630];j[114630]=0;if((m|0)==1){break R}if(!(b&7)){break fb}e=(p(e,104)+a|0)+484380|0;j[e>>2]=f;b=Kc(d- -64|0,b&4?32:b&2?16:8,1,1,0);j[114630]=0;K(400,b|0,e|0,d+184|0)|0;b=j[114630];j[114630]=0;if((b|0)!=1){break fb}break R}break R}c=c+1|0;e=c&65535;if(e>>>0<=l[a+480190>>1]){continue}break}}jb(d+184|0);jb(d+128|0);jb(d+200|0);jb(d+216|0)}Az(d+264|0);jb(y)}Za=d+304|0;return x|0}b=D()|0;C()|0;jb(d+184|0);break I}b=D()|0;C()|0;break I}b=D()|0;C()|0;gb(v)}jb(d- -64|0)}QR(e);break L}b=D()|0;C()|0}jb(d+184|0);break I}b=D()|0;C()|0;break I}b=D()|0;C()|0}jb(d+128|0);break t}b=D()|0;C()|0;break t}b=D()|0;C()|0;break y}b=D()|0;C()|0;jb(d+96|0);break y}b=D()|0;C()|0;jb(d+112|0);break y}b=D()|0;C()|0;break y}b=D()|0;C()|0;break y}b=D()|0;C()|0;gb(d- -64|0);break y}b=D()|0;C()|0;break y}b=D()|0;C()|0;gb(d- -64|0)}jb(d+184|0);break t}b=D()|0;C()|0;break t}b=D()|0;C()|0;break t}b=D()|0;C()|0;gb(d+184|0);break t}b=D()|0;C()|0}jb(d+200|0);break q}b=D()|0;C()|0;break q}b=D()|0;C()|0}jb(d+216|0);break b}b=D()|0;C()|0;break b}b=D()|0;C()|0;gb(d+184|0);break m}b=D()|0;C()|0}gb(d+200|0);break k}b=D()|0;C()|0}qb(d+216|0);break i}b=D()|0;C()|0}gb(e);break b}b=D()|0;C()|0;break b}b=D()|0;C()|0;break b}b=D()|0;C()|0;break b}b=D()|0;C()|0;break b}b=D()|0;C()|0;break b}b=D()|0;C()|0}Az(d+264|0)}jb(y);G(b|0);z()}function pza(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0;d=Za-320|0;Za=d;rc(b);a:{if(!$s(b,d+304|0)){break a}if(!ON(d+304|0)){break a}w=tl(d+288|0,b);v=gy(d+272|0);b:{c:{d:{e:{f:{g:{h:{i:{j:{k:{l:{m:{n:{o:{p:{q:{r:{s:{t:{u:{if(!c){j[114630]=0;L(948,d|0,w|0,1,1413891155);b=j[114630];j[114630]=0;if((b|0)==1){break s}break u}j[114630]=0;I(949,d|0,w|0,1);b=j[114630];j[114630]=0;if((b|0)==1){break t}}Tya(v,d);kl(d);j[114630]=0;I(950,d|0,v|0,1413891155);b=j[114630];j[114630]=0;v:{w:{if((b|0)!=1){j[114630]=0;e=E(951,d|0,16779)|0;b=j[114630];j[114630]=0;if((b|0)==1){break w}jb(d);if(!c){break b}if(!(e^1)){break v}break b}e=D()|0;C()|0;break c}e=D()|0;C()|0;jb(d);break c}j[114630]=0;F(447,a|0,4194304);b=j[114630];j[114630]=0;if((b|0)==1){break d}j[a+480208>>2]=12;j[114630]=0;I(950,d+256|0,v|0,1280592212);b=j[114630];j[114630]=0;if((b|0)==1){break e}j[114630]=0;b=H(255,d+256|0)|0;e=j[114630];j[114630]=0;if((e|0)==1){break g}j[114630]=0;K(679,d+256|0,a+1304400|0,b|0)|0;b=j[114630];j[114630]=0;if((b|0)==1){break g}s=a+484360|0;xp(Eb(s));q=d+240|0;bza(q);j[114630]=0;h[d+239|0]=0;I(952,d+224|0,v|0,1196314451);b=j[114630];j[114630]=0;if((b|0)==1){break i}A=d,B=Lb(d+224|0),j[A+216>>2]=B;A=d,B=Mb(d+224|0),j[A+208>>2]=B;x:{y:{z:{A:{B:{C:{if(!rb(d+216|0,d+208|0)){break C}u=d+12|0;f=d+24|0;t=d+44|0;while(1){e=tl(d+192|0,j[d+216>>2]);j[114630]=0;g=E(953,d+192|0,d+176|0)|0;b=j[114630];j[114630]=0;D:{E:{F:{G:{H:{I:{if((b|0)!=1){b=1;if(!(g&k[d+185|0]==1)){break D}A=a,B=kd(k[d+186|0],l[a+480188>>1],127),i[A+480188>>1]=B;j[114630]=0;m=H(954,d|0)|0;b=j[114630];j[114630]=0;J:{K:{L:{M:{if((b|0)!=1){j[114630]=0;I(955,d+160|0,1,d+176|0);b=j[114630];j[114630]=0;if((b|0)==1){break M}j[114630]=0;F(415,d+120|0,d+160|0);b=j[114630];j[114630]=0;if((b|0)==1){break M}j[114630]=0;F(956,d+152|0,t|0);b=j[114630];j[114630]=0;if((b|0)==1){break L}j[114630]=0;E(470,d+152|0,d+120|0)|0;b=j[114630];j[114630]=0;if((b|0)==1){break L}gb(d+120|0);if(Xc(Eb(s))){break J}j[114630]=0;b=H(485,s|0)|0;g=j[114630];j[114630]=0;if((g|0)==1){break K}if((b|0)!=255){break J}b=2;break E}e=D()|0;C()|0;break k}e=D()|0;C()|0;break l}e=D()|0;C()|0;gb(d+120|0);break l}e=D()|0;C()|0;break l}b=Eb(s);j[114630]=0;I(6,d+120|0,4,t|0);g=j[114630];j[114630]=0;N:{O:{P:{if((g|0)!=1){j[114630]=0;F(486,b|0,d+120|0);b=j[114630];j[114630]=0;if((b|0)==1){break P}gb(d+120|0);j[114630]=0;I(949,d+160|0,e|0,1);b=j[114630];j[114630]=0;if((b|0)==1){break O}A=d,B=Lb(d+160|0),j[A+144>>2]=B;A=d,B=Mb(d+160|0),j[A+136>>2]=B;if(rb(d+144|0,d+136|0)){break N}break H}e=D()|0;C()|0;break l}e=D()|0;C()|0;gb(d+120|0);break l}e=D()|0;C()|0;break l}Q:{R:{while(1){S:{e=j[d+144>>2];b=He(d+120|0,hb(e));g=k[e+4|0]|k[e+5|0]<<8|(k[e+6|0]<<16|k[e+7|0]<<24);j[d+152>>2]=k[e|0]|k[e+1|0]<<8|(k[e+2|0]<<16|k[e+3|0]<<24);j[d+156>>2]=g;r=1;T:{e=k[d+152|0]|k[d+153|0]<<8|(k[d+154|0]<<16|k[d+155|0]<<24);if((e|0)!=1212960847){if((e|0)!=1312903248){break T}e=0;if(!l[a+480188>>1]){break T}U:{while(1){j[114630]=0;g=E(258,b|0,2)|0;o=j[114630];j[114630]=0;if((o|0)==1){break U}if(!g){break T}j[114630]=0;F(472,d+96|0,b|0);g=j[114630];j[114630]=0;V:{W:{X:{Y:{if((g|0)!=1){g=Pc(d+96|0);switch(k[d+96|0]){case 4:break W;case 2:break X;case 0:break Y;default:break V}}break I}g=k[g|0];A=fc(d,e),B=g^128,h[A|0]=B;Nd(d+104|0,f,e);Qd(d+104|0,0);break V}A=fc(d,e),B=128,h[A|0]=B;Nd(d+104|0,f,e);Qd(d+104|0,1);break V}A=fc(d,e),B=128,h[A|0]=B;Nd(d+104|0,f,e);Qd(d+104|0,0)}e=e+1|0;if(e>>>0<l[a+480188>>1]){continue}break}break T}break I}if(fy(d+152|0)>>>0<9){break T}o=0;j[114630]=0;E(338,b|0,2)|0;e=j[114630];j[114630]=0;g=65535;if((e|0)==1){break S}while(1){j[114630]=0;e=E(258,b|0,1)|0;n=j[114630];j[114630]=0;Z:{_:{$:{aa:{ba:{ca:{da:{ea:{fa:{if((n|0)!=1){if(!e){break T}j[114630]=0;e=H(387,b|0)|0;n=j[114630];j[114630]=0;if((n|0)==1){break I}switch(e|0){case 0:break T;case 14:break _;case 13:break $;case 12:break ba;case 8:break ca;case 7:break da;case 4:break ea;case 1:break fa;default:break aa}}break I}if(l[d+36>>1]==65535){e=Eb(s);j[114630]=0;e=H(544,e|0)|0;n=j[114630];j[114630]=0;if((n|0)==1){break I}i[d+36>>1]=e}e=Eb(s);j[114630]=0;e=H(544,e|0)|0;n=j[114630];j[114630]=0;if((n|0)==1){break I}j[114630]=0;i[d+38>>1]=e;e=E(957,b|0,d+239|0)|0;n=j[114630];j[114630]=0;if((n|0)==1){break I}ga:{ha:{switch(e-254|0){case 1:j[114630]=0;e=T(958)|0;n=j[114630];j[114630]=0;if((n|0)!=1){break ga}break I;case 0:break ha;default:break ga}}j[114630]=0;e=T(959)|0;n=j[114630];j[114630]=0;if((n|0)==1){break I}}n=Eb(s);j[114630]=0;F(793,n|0,e|0);e=j[114630];j[114630]=0;if((e|0)==1){break I}g=(g&65535)==65535?o:g;break Z}j[114630]=0;e=H(357,b|0)|0;n=j[114630];j[114630]=0;if((n|0)==1){break I}if(e>>>0>=(g&65535)>>>0){i[d+40>>1]=e-g}Fe(Eb(s),l[d+40>>1]);break Z}j[114630]=0;e=H(387,b|0)|0;n=j[114630];j[114630]=0;if((n|0)==1){break I}h[d+43|0]=e;break Z}j[114630]=0;e=H(387,b|0)|0;n=j[114630];j[114630]=0;if((n|0)==1){break I}h[d+42|0]=e;break Z}j[114630]=0;e=E(915,b|0,d+104|0)|0;n=j[114630];j[114630]=0;if((n|0)==1){break I}if(!(e&!k[d+104|0])|(k[d+106|0]|k[d+107|0])|(k[d+105|0]!=255|k[d+108|0]!=1)){break aa}if(!k[d+109|0]){break Z}}r=0;break T}j[114630]=0;F(805,d+112|0,b|0);e=j[114630];j[114630]=0;ia:{ja:{ka:{la:{if((e|0)!=1){n=Pc(d+112|0);x=Bf(d+112|0);e=d+112|0;if(k[e|0]>=tc(d)>>>0){break Z}switch(k[x|0]){case 4:break ja;case 2:break ka;case 0:break la;default:break ia}}break I}n=k[n|0];A=fc(d,k[e|0]),B=n^128,h[A|0]=B;Nd(d+104|0,f,k[e|0]);Qd(d+104|0,0);break ia}A=fc(d,k[e|0]),B=128,h[A|0]=B;Nd(d+104|0,f,k[e|0]);Qd(d+104|0,1);break ia}A=fc(d,k[e|0]),B=128,h[A|0]=B;Nd(d+104|0,f,k[e|0]);Qd(d+104|0,0)}ma:{if(y){break ma}y=0;if(!Wj(q)){break Z}if(k[fc(MN(q),k[e|0])|0]!=k[fc(d,k[e|0])|0]){break ma}Nd(d+104|0,MN(q)+24|0,k[e|0]);n=kb(d+104|0);Nd(d+96|0,f,k[e|0]);if((kb(d+96|0)|0)==(n|0)){break Z}}y=1;break Z}j[114630]=0;F(472,d+104|0,b|0);e=j[114630];j[114630]=0;if((e|0)==1){break Q}e=Pc(d+104|0);n=d+104|0;x=k[n|0];if(tc(u)>>>0<=x>>>0){break Z}e=k[e|0];A=fc(u,k[n|0]),B=(e>>>2|0)+1|0,h[A|0]=B}o=o+1|0;continue}}jb(b);if(!r){break R}gk(d+144|0);if(rb(d+144|0,d+136|0)){continue}break H}break}break I}b=1;break F}break I}e=D()|0;C()|0;break k}e=D()|0;C()|0;jb(b);break G}b=0;if(l[d+36>>1]==65535|l[d+38>>1]==65535){break F}b=Eb(s);j[114630]=0;N(960,b|0);b=j[114630];j[114630]=0;if((b|0)!=1){b=0;j[114630]=0;F(961,q|0,m|0);e=j[114630];j[114630]=0;if((e|0)!=1){break F}}e=D()|0;C()|0}kl(d+160|0);break l}kl(d+160|0)}ey(m)}jb(d+192|0);if(!b){yf(d+216|0);if(rb(d+216|0,d+208|0)){continue}break C}break}e=0;if((b|0)!=2){break B}}e=0;j[114630]=0;F(488,s|0,0);b=j[114630];j[114630]=0;if((b|0)==1){break r}if(Xc(q)){break B}if(c&2){j[114630]=0;I(952,d+192|0,v|0,1347244868);b=j[114630];j[114630]=0;if((b|0)==1){break x}A=d,B=Lb(d+192|0),j[A+176>>2]=B;A=d,B=Mb(d+192|0),j[A+152>>2]=B;if(rb(d+176|0,d+152|0)){e=a+480190|0;f=d+13|0;g=d+17|0;r=k[d+239|0];while(1){b=j[d+176>>2];na:{oa:{pa:{qa:{ra:{if(!r){j[114630]=0;m=E(962,b|0,d|0)|0;o=j[114630];j[114630]=0;if((o|0)==1){break ra}if(!m){break na}m=k[d+52|0]|k[d+53|0]<<8;i[d+104>>1]=m+1;if(m>>>0>3998){break pa}j[114630]=0;m=E(452,e|0,d+104|0)|0;o=j[114630];j[114630]=0;if((o|0)==1){break ra}i[a+480190>>1]=l[m>>1];j[114630]=0;F(963,d|0,(p(l[d+104>>1],104)+a|0)+484380|0);m=j[114630];j[114630]=0;if((m|0)==1){break ra}j[114630]=0;I(964,d+160|0,1,f|0);m=j[114630];j[114630]=0;sa:{ta:{if((m|0)==1){break ta}j[114630]=0;F(415,d+120|0,d+160|0);m=j[114630];j[114630]=0;if((m|0)==1){break ta}j[114630]=0;E(369,((l[d+104>>1]<<5)+a|0)+946300|0,d+120|0)|0;m=j[114630];j[114630]=0;if((m|0)==1){break sa}gb(d+120|0);break pa}e=D()|0;C()|0;break oa}e=D()|0;C()|0;gb(d+120|0);break oa}j[114630]=0;m=E(965,b|0,d|0)|0;o=j[114630];j[114630]=0;if((o|0)==1){break qa}if(!m){break na}m=k[d+56|0]|k[d+57|0]<<8;i[d+104>>1]=m+1;if(m>>>0>3998){break pa}j[114630]=0;m=E(452,e|0,d+104|0)|0;o=j[114630];j[114630]=0;if((o|0)==1){break qa}i[a+480190>>1]=l[m>>1];j[114630]=0;F(966,d|0,(p(l[d+104>>1],104)+a|0)+484380|0);m=j[114630];j[114630]=0;if((m|0)==1){break qa}j[114630]=0;I(964,d+160|0,1,g|0);m=j[114630];j[114630]=0;ua:{va:{if((m|0)==1){break va}j[114630]=0;F(415,d+120|0,d+160|0);m=j[114630];j[114630]=0;if((m|0)==1){break va}j[114630]=0;E(369,((l[d+104>>1]<<5)+a|0)+946300|0,d+120|0)|0;m=j[114630];j[114630]=0;if((m|0)==1){break ua}gb(d+120|0);break pa}e=D()|0;C()|0;break oa}e=D()|0;C()|0;gb(d+120|0);break oa}e=D()|0;C()|0;break oa}e=D()|0;C()|0;break oa}if((l[d+104>>1]-1&65535)>>>0>3998){break na}m=Kc(d,8,1,0,2);j[114630]=0;K(400,m|0,(p(l[d+104>>1],104)+a|0)+484380|0,b|0)|0;b=j[114630];j[114630]=0;if((b|0)!=1){break na}e=D()|0;C()|0}Sc(d+192|0);break j}yf(d+176|0);if(rb(d+176|0,d+152|0)){continue}break}}Sc(d+192|0)}A=a,B=k[jl(q,0)+43|0],j[A+480196>>2]=B;A=a,B=p(k[jl(q,0)+42|0],1e4),j[A+480204>>2]=B;Fe(Eb(s),l[jl(q,0)+40>>1]);if(l[a+480188>>1]){b=0;while(1){j[114630]=0;e=(b<<5)+a|0;f=e+480280|0;N(432,f|0);g=j[114630];j[114630]=0;if((g|0)==1){break y}A=e+480286|0,B=k[fc(jl(q,0)+12|0,b)|0],i[A>>1]=B;A=e+480284|0,B=k[fc(jl(q,0),b)|0],i[A>>1]=B;Nd(d,jl(q,0)+24|0,b);e=kb(d);j[f>>2]=j[f>>2]&-257|(e?256:0);b=b+1|0;if(b>>>0<l[a+480188>>1]){continue}break}}wa:{if(k[d+239|0]){j[114630]=0;E(2,d|0,16788)|0;b=j[114630];j[114630]=0;if((b|0)!=1){break wa}break m}j[114630]=0;E(2,d|0,16832)|0;b=j[114630];j[114630]=0;if((b|0)==1){break m}}ob(a+1304436|0,d);gb(d);j[114630]=0;b=E(2,d|0,16866)|0;f=j[114630];j[114630]=0;e=1;if((f|0)==1){break z}ob(a+1304448|0,b);gb(b);j[a+1304496>>2]=4;if(!(c&1)|!l[a+480188>>1]){break B}j[114630]=0;I(952,d+192|0,v|0,1146045008);b=j[114630];j[114630]=0;if((b|0)==1){break n}b=Zc(d+192|0);j[114630]=0;m=a+484344|0;F(401,m|0,b&65535);b=j[114630];j[114630]=0;if((b|0)==1){break q}A=d,B=Lb(d+192|0),j[A+120>>2]=B;A=d,B=Mb(d+192|0),j[A+160>>2]=B;if(rb(d+120|0,d+160|0)){while(1){g=j[d+120>>2];j[114630]=0;b=H(255,g|0)|0;c=j[114630];j[114630]=0;xa:{ya:{za:{if((c|0)==1){break za}j[114630]=0;c=H(390,g|0)|0;e=j[114630];j[114630]=0;if((e|0)==1){break za}if((b|0)!=(c|0)){break xa}j[114630]=0;b=E(967,g|0,8)|0;c=j[114630];j[114630]=0;if((c|0)==1){break za}if(b){break ya}break xa}e=D()|0;C()|0;break o}j[114630]=0;u=E(957,g|0,d+239|0)|0;b=j[114630];j[114630]=0;if((b|0)!=1){j[114630]=0;o=H(357,g|0)|0;b=j[114630];j[114630]=0;Aa:{if((b|0)==1){break Aa}j[114630]=0;b=K(402,m|0,u|0,o|0)|0;c=j[114630];j[114630]=0;if((c|0)==1){break Aa}if(!o|b^1){break xa}r=0;while(1){Ba:{b=Hb(m,u);j[114630]=0;c=E(496,b|0,r|0)|0;b=j[114630];j[114630]=0;Ca:{Da:{Ea:{if((b|0)!=1){j[114630]=0;b=H(357,g|0)|0;e=j[114630];j[114630]=0;if((e|0)==1){break Ea}if(b>>>0<3){break Ca}j[114630]=0;I(341,d|0,g|0,b-2|0);b=j[114630];j[114630]=0;if((b|0)!=1){break Da}e=D()|0;C()|0;break o}e=D()|0;C()|0;break o}e=D()|0;C()|0;break o}while(1){j[114630]=0;b=E(258,d|0,3)|0;e=j[114630];j[114630]=0;if((e|0)==1){break Ba}if(b){j[114630]=0;F(472,d+176|0,d|0);b=j[114630];j[114630]=0;Fa:{Ga:{Ha:{Ia:{if((b|0)!=1){f=d+176|0;b=Pc(d+176|0);i[d+152>>1]=l[a+480188>>1]-1;b=k[b|0];j[114630]=0;i[d+104>>1]=b;b=E(477,d+152|0,d+104|0)|0;e=j[114630];j[114630]=0;if((e|0)==1){break Ba}e=l[b>>1];b=h[f|0];if((b|0)>-1){break Fa}j[114630]=0;b=H(387,d|0)|0;t=j[114630];j[114630]=0;if((t|0)==1){break Ba}if(k[d+239|0]){break Ha}if((b|0)!=255){break Ia}b=254;break Ga}break Ba}if(b>>>0>128){break Ga}b=(p(b>>>4|0,12)+(b&15)|0)+13|0;break Ga}b=b>>>0<85?b+36|0:b}h[c+p(e,6)|0]=b;b=k[f|0]}if(b&64){j[114630]=0;b=H(387,d|0)|0;t=j[114630];j[114630]=0;if((t|0)==1){break Ba}h[(c+p(e,6)|0)+1|0]=b+1;b=k[f|0]}if(b&32){j[114630]=0;b=H(387,d|0)|0;t=j[114630];j[114630]=0;if((t|0)==1){break Ba}h[d+152|0]=b;b=c+p(e,6)|0;h[b+2|0]=1;j[114630]=0;h[d+104|0]=127;t=E(391,d+152|0,d+104|0)|0;n=j[114630];j[114630]=0;if((n|0)==1){break Ba}h[b+4|0]=k[t|0]+1>>>1;b=k[f|0]}if(!(b&16)){continue}j[114630]=0;F(472,d+152|0,d|0);b=j[114630];j[114630]=0;if((b|0)==1){break Ba}b=c+p(e,6)|0;f=k[Pc(d+152|0)|0];h[b+5|0]=f;Ja:{switch(k[d+152|0]-1|0){case 0:h[(c+p(e,6)|0)+3|0]=11;if(!k[d+239|0]){h[b+5|0]=f<<3|15;continue}h[b+5|0]=f<<4|15;continue;case 1:h[(c+p(e,6)|0)+3|0]=11;if(k[d+239|0]){h[b+5|0]=f<<4;continue}h[b+5|0]=f<<3&240;continue;case 2:h[(c+p(e,6)|0)+3|0]=11;if(k[d+239|0]){h[b+5|0]=f|240;continue}h[b+5|0]=f>>>1|240;continue;case 3:h[(c+p(e,6)|0)+3|0]=11;if(k[d+239|0]){h[b+5|0]=f&15;continue}if(f>>>0<=1){h[b+5|0]=f|240;continue}h[b+5|0]=f>>>1&15;continue;case 10:h[(c+p(e,6)|0)+3|0]=2;A=b,B=ts(f,k[d+239|0])|240,h[A+5|0]=B;continue;case 11:h[(c+p(e,6)|0)+3|0]=2;A=b,B=ts(f,k[d+239|0]),h[A+5|0]=B;continue;case 12:h[(c+p(e,6)|0)+3|0]=3;A=b,B=ts(f,k[d+239|0])|240,h[A+5|0]=B;continue;case 13:h[(c+p(e,6)|0)+3|0]=3;A=b,B=ts(f,k[d+239|0]),h[A+5|0]=B;continue;case 14:h[(c+p(e,6)|0)+3|0]=4;if(k[d+239|0]){continue}h[b+5|0]=(f&252)>>>2;continue;case 16:h[(c+p(e,6)|0)+3|0]=20;h[b+5|0]=f&1|16;continue;case 15:h[(c+p(e,6)|0)+3|0]=6;h[b+5|0]=f&240;continue;case 17:h[(c+p(e,6)|0)+3|0]=6;h[b+5|0]=(f&240)>>>4;continue;case 18:h[(c+p(e,6)|0)+3|0]=20;continue;case 20:h[(c+p(e,6)|0)+3|0]=5;continue;case 21:h[(c+p(e,6)|0)+3|0]=20;h[b+5|0]=f&15|48;continue;case 22:h[(c+p(e,6)|0)+3|0]=7;h[b+5|0]=f|240;continue;case 23:h[(c+p(e,6)|0)+3|0]=7;continue;case 30:h[(c+p(e,6)|0)+3|0]=8;continue;case 31:h[(c+p(e,6)|0)+3|0]=20;h[b+5|0]=f&15|64;continue;case 40:h[(c+p(e,6)|0)+3|0]=10;j[114630]=0;e=H(387,d|0)|0;f=j[114630];j[114630]=0;if((f|0)==1){break Ba}h[b+5|0]=e;j[114630]=0;E(338,d|0,1)|0;b=j[114630];j[114630]=0;if((b|0)!=1){continue}break Ba;case 41:h[(c+p(e,6)|0)+3|0]=15;continue;case 42:h[(c+p(e,6)|0)+3|0]=20;h[b+5|0]=f&15|192;continue;case 43:h[(c+p(e,6)|0)+3|0]=20;h[b+5|0]=f&15|208;continue;case 50:h[(c+p(e,6)|0)+3|0]=12;h[b+5|0]=(f&254)>>>1;j[114630]=0;E(338,d|0,1)|0;b=j[114630];j[114630]=0;if((b|0)!=1){continue}break Ba;case 51:h[(c+p(e,6)|0)+3|0]=14;h[b+5|0]=0;continue;case 52:h[(c+p(e,6)|0)+3|0]=20;h[b+5|0]=f&15|176;continue;case 53:h[(c+p(e,6)|0)+3|0]=20;h[b+5|0]=f&15|224;continue;case 60:h[(c+p(e,6)|0)+3|0]=16;continue;case 61:h[(c+p(e,6)|0)+3|0]=17;continue;case 70:h[(c+p(e,6)|0)+3|0]=1;continue;case 71:h[(c+p(e,6)|0)+3|0]=20;h[b+5|0]=f&15|32;continue;case 72:h[(c+p(e,6)|0)+3|0]=20;h[b+5|0]=f&15|128;continue;default:break Ja}}h[(c+p(e,6)|0)+3|0]=0;continue}break}jb(d)}r=r+1|0;if((o|0)!=(r|0)){continue}break xa}break}e=D()|0;C()|0;jb(d);break o}e=D()|0;C()|0;break o}e=D()|0;C()|0;break o}yf(d+120|0);if(rb(d+120|0,d+160|0)){continue}break}}Ka:{if(Wj(q)>>>0<2){break Ka}if(!Wj(q)){break Ka}e=0;while(1){b=ei(s,e&255);c=jl(q,e);f=l[bc(b,l[c+36>>1])>>1];j[114630]=0;f=E(442,m|0,f|0)|0;g=j[114630];j[114630]=0;if((g|0)==1){break p}La:{if(!f){break La}f=l[c+36>>1];j[114630]=0;f=E(809,b|0,f|0)|0;b=j[114630];j[114630]=0;if((b|0)==1){break p}if(!(!y|!l[a+480188>>1])){r=c+24|0;b=0;while(1){Nd(d,r,b);o=kb(d);g=Hb(m,f);Ma:{if(o){j[114630]=0;o=K(497,d|0,20,145)|0;u=j[114630];j[114630]=0;if((u|0)!=1){o=qi(gn(Ee(o,0),b&65535));j[114630]=0;E(498,g|0,o|0)|0;g=j[114630];j[114630]=0;if((g|0)!=1){break Ma}}e=D()|0;C()|0;break o}o=k[fc(c,b)|0];j[114630]=0;o=K(497,d|0,9,o|0)|0;u=j[114630];j[114630]=0;if((u|0)!=1){o=qi(gn(Ee(o,0),b&65535));j[114630]=0;E(498,g|0,o|0)|0;g=j[114630];j[114630]=0;if((g|0)!=1){break Ma}}e=D()|0;C()|0;break o}b=b+1|0;if(b>>>0<l[a+480188>>1]){continue}break}}b=Hb(m,f);g=k[c+43|0];j[114630]=0;g=K(497,d|0,16,g|0)|0;r=j[114630];j[114630]=0;if((r|0)==1){break A}g=qi(Ee(g,0));j[114630]=0;E(498,b|0,g|0)|0;b=j[114630];j[114630]=0;if((b|0)==1){break A}b=Hb(m,f);c=k[c+42|0];j[114630]=0;c=K(497,d|0,17,c|0)|0;f=j[114630];j[114630]=0;if((f|0)!=1){c=qi(Ee(c,0));j[114630]=0;E(498,b|0,c|0)|0;b=j[114630];j[114630]=0;if((b|0)!=1){break La}}e=D()|0;C()|0;break o}e=e+1|0;if(Wj(q)>>>0>e>>>0){continue}break}}Sc(d+192|0);e=1}Sc(d+224|0);LN(q);jb(d+256|0);break b}e=D()|0;C()|0;break o}e=D()|0;C()|0;break j}e=D()|0;C()|0;break j}e=D()|0;C()|0;break j}e=D()|0;C()|0;break c}e=D()|0;C()|0;break c}e=D()|0;C()|0;break j}e=D()|0;C()|0;break o}e=D()|0;C()|0}Sc(d+192|0);break j}e=D()|0;C()|0;break j}e=D()|0;C()|0;break j}ey(m)}jb(d+192|0)}Sc(d+224|0);break h}e=D()|0;C()|0}LN(q);break f}e=D()|0;C()|0}jb(d+256|0);break c}e=D()|0;C()|0;break c}e=D()|0;C()|0}kl(v);jb(w);G(e|0);z()}kl(v);jb(w)}Za=d+320|0;return e|0}function ZHa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,n=0,o=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,J=0,M=0,O=0,Q=0,R=0;d=Za-288|0;Za=d;rc(b);f=d+264|0;g=IHa(b,f);if(!g){$Q(f)}a:{b:{c:{d:{e:{f:{g:{h:{i:{j:{k:{l:{m:{n:{o:{p:{q:{r:{s:{t:{u:{if(!g){break u}if(!cR(d+264|0)){break u}if(!c){e=1;break u}od(a,1024);Zh(a);j[a+480208>>2]=j[a+480208>>2]|12;rg(a+1074308|0,21);if(k[d+280|0]|k[d+281|0]<<8){e=k[d+280|0]|k[d+281|0]<<8;j[a+480204>>2]=p((e<<8|e>>>8)&65535,1e4)}if(k[d+278|0]|k[d+279|0]<<8){e=k[d+278|0]|k[d+279|0]<<8;j[a+480196>>2]=(e<<8|e>>>8)&65535}if(!k[d+274|0]){Qi(a,1)}e=d+264|4;e=k[e|0]|k[e+1|0]<<8|(k[e+2|0]<<16|k[e+3|0]<<24);Cz(b,a+1304400|0,(e<<24|e<<8&16711680|(e>>>8&65280|e>>>24))-14|0);b=tl(d+160|0,b);j[114630]=0;I(579,d+248|0,b|0,1);e=j[114630];j[114630]=0;v:{w:{x:{y:{z:{A:{B:{C:{D:{E:{F:{G:{H:{I:{J:{K:{L:{M:{if((e|0)!=1){jb(b);j[114630]=0;I(580,d+160|0,d+248|0,1395544366);b=j[114630];j[114630]=0;if((b|0)==1){break E}j[114630]=0;b=H(489,d+160|0)|0;e=j[114630];j[114630]=0;if((e|0)==1){break L}if(!b){break F}j[114630]=0;b=H(484,d+160|0)|0;e=j[114630];j[114630]=0;if((e|0)==1){break L}j[114630]=0;e=H(484,d+160|0)|0;f=j[114630];j[114630]=0;N:{if((f|0)==1){break N}j[114630]=0;E(338,d+160|0,4)|0;f=j[114630];j[114630]=0;if((f|0)==1){break N}f=a+484360|0;g=Eb(f);j[114630]=0;U(581,g|0,d+160|0,b|0,65535,65535)|0;b=j[114630];j[114630]=0;if((b|0)!=1){break M}}break L}e=D()|0;C()|0;jb(b);break a}Fe(Eb(f),e);jb(d+160|0);j[114630]=0;I(580,d+160|0,d+248|0,1346458708);b=j[114630];j[114630]=0;if((b|0)==1){break K}j[114630]=0;b=H(489,d+160|0)|0;e=j[114630];j[114630]=0;if((e|0)==1){break J}if(!b){break H}j[114630]=0;b=H(484,d+160|0)|0;e=j[114630];j[114630]=0;if((e|0)==1){break J}i[a+480188>>1]=b;if((b-1&65535)>>>0>31){break H}j[114630]=0;b=H(484,d+160|0)|0;e=j[114630];j[114630]=0;if((e|0)==1){break J}j[114630]=0;v=a+484344|0;F(401,v|0,b|0);b=j[114630];j[114630]=0;if((b|0)==1){break J}j[114630]=0;w=H(493,d+160|0)|0;b=j[114630];j[114630]=0;if((b|0)==1){break J}switch(w-841887796|0){case 0:case 2:break G;case 1:break H;default:break I}}e=D()|0;C()|0;jb(d+160|0);break b}e=D()|0;C()|0;break b}e=D()|0;C()|0;jb(d+160|0);break b}if(!w){break G}}jb(d+160|0);break A}jb(d+160|0);j[114630]=0;I(580,d+232|0,d+248|0,1398157625);b=j[114630];j[114630]=0;if((b|0)==1){break D}j[114630]=0;b=H(489,d+232|0)|0;e=j[114630];j[114630]=0;O:{if((e|0)==1){break O}if(!b){break B}j[114630]=0;E(338,d+232|0,2)|0;b=j[114630];j[114630]=0;if((b|0)==1){break O}j[114630]=0;e=H(493,d+232|0)|0;b=j[114630];j[114630]=0;if((b|0)==1){break c}b=a;g=b;y=(+(e>>>0)*2.3283064365386963e-10+ +(m[b+480204>>2]/1e4>>>0))*1e4;P:{if(y<4294967296&y>=0){b=~~y>>>0;break P}b=0}j[g+480204>>2]=b;j[114630]=0;E(582,d+232|0,d+160|0)|0;b=j[114630];j[114630]=0;if((b|0)==1){break c}b=0;while(1){if(l[a+480188>>1]<=b>>>0){break C}e=(d+160|0)+(b<<1)|0;e=k[e|0]|k[e+1|0]<<8;j[114630]=0;j[d+96>>2]=(e<<8|e>>>8)&65535;j[d+80>>2]=180;e=E(462,d+96|0,d+80|0)|0;f=j[114630];j[114630]=0;Q:{if((f|0)==1){break Q}e=j[e>>2];j[114630]=0;e=e-90|0;f=e>>31;e=ig(458,IMa(e<<7|45,f<<7|e>>>25,90,0),ab);f=j[114630];j[114630]=0;if((f|0)==1){break Q}i[((b<<5)+a|0)+480284>>1]=e+128;b=b+1|0;if((b|0)!=32){continue}break C}break}break c}break c}jb(d+160|0);break A}e=D()|0;C()|0;break b}e=D()|0;C()|0;break b}j[114630]=0;E(338,d+232|0,16)|0;b=j[114630];j[114630]=0;if((b|0)==1){break c}j[114630]=0;b=E(258,d+232|0,2)|0;e=j[114630];j[114630]=0;if((e|0)==1){break c}if(b){j[114630]=0;b=H(484,d+232|0)|0;e=j[114630];j[114630]=0;if((e|0)==1){break c}j[114630]=0;i[d+96>>1]=b;i[d+80>>1]=256;b=E(477,d+96|0,d+80|0)|0;e=j[114630];j[114630]=0;if((e|0)==1){break c}j[a+480200>>2]=l[b>>1]}j[114630]=0;E(338,d+232|0,128)|0;b=j[114630];j[114630]=0;if((b|0)==1){break c}j[114630]=0;b=E(582,d+232|0,d+96|0)|0;e=j[114630];j[114630]=0;R:{if((e|0)!=1){if(!b){break B}b=0;while(1){if(l[a+480188>>1]<=b>>>0){break R}e=(d+96|0)+(b<<1)|0;e=k[e|0]|k[e+1|0]<<8;j[114630]=0;j[d+80>>2]=(e<<8|e>>>8)&65535;j[d+56>>2]=128;e=E(462,d+80|0,d+56|0)|0;f=j[114630];j[114630]=0;if((f|0)!=1){i[((b<<5)+a|0)+480286>>1]=j[e>>2]/2&255;b=b+1|0;if((b|0)!=32){continue}break R}break}break c}break c}j[a+480228>>2]=j[a+480228>>2]<<1}jb(d+232|0);j[114630]=0;I(580,d+160|0,d+248|0,1413830740);b=j[114630];j[114630]=0;S:{T:{if((b|0)!=1){j[114630]=0;b=H(489,d+160|0)|0;e=j[114630];j[114630]=0;if((e|0)==1){break d}if(!b){break S}j[114630]=0;E(583,d+160|0,d+96|0)|0;b=j[114630];j[114630]=0;if((b|0)==1){break d}if((k[d+106|0]|k[d+107|0]<<8)!=65535){break T}j[114630]=0;E(338,d+160|0,1)|0;b=j[114630];j[114630]=0;if((b|0)!=1){break T}break d}e=D()|0;C()|0;break b}j[114630]=0;b=H(540,d+160|0)|0;e=j[114630];j[114630]=0;if((e|0)==1){break d}j[114630]=0;P(584,a+1304424|0,d+160|0,b|0,2)|0;b=j[114630];j[114630]=0;if((b|0)==1){break d}}jb(d+160|0);j[114630]=0;I(580,d+96|0,d+248|0,1229869908);b=j[114630];j[114630]=0;if((b|0)==1){break e}j[114630]=0;b=H(489,d+96|0)|0;e=j[114630];j[114630]=0;if((e|0)!=1){if(b){j[114630]=0;b=H(484,d+96|0)|0;e=j[114630];j[114630]=0;if((e|0)==1){break g}U:{b=b<<16>>16;f=b&32767;if(f>>>0>3999){break U}j[114630]=0;e=E(258,d+96|0,p(f,(b>>>14&2)+50|0)|0)|0;g=j[114630];j[114630]=0;if((g|0)==1){break y}if(!e){break U}i[a+480190>>1]=f;g=a+480190|0;if(!f){break z}o=d+178|0;q=(b|0)>-1;b=1;V:{W:{while(1){X:{e=b;Y:{Z:{_:{if(!q){j[114630]=0;e=H(484,d+96|0)|0;n=j[114630];j[114630]=0;if((n|0)==1){break _}e=e+1|0}j[114630]=0;i[d+56>>1]=e;E(585,d+96|0,d+160|0)|0;e=j[114630];j[114630]=0;if((e|0)!=1){if((l[d+56>>1]-1&65535)>>>0>3998){break Y}j[114630]=0;e=E(452,g|0,d+56|0)|0;n=j[114630];j[114630]=0;if((n|0)!=1){break Z}}e=D()|0;C()|0;break f}e=D()|0;C()|0;break f}i[a+480190>>1]=l[e>>1];n=l[d+56>>1];e=k[d+282|0]|k[d+283|0]<<8|(k[d+284|0]<<16|k[d+285|0]<<24);j[114630]=0;L(586,d+160|0,(p(n,104)+a|0)+484380|0,e<<8&16711680|e<<24|(e>>>8&65280|e>>>24),w|0);e=j[114630];j[114630]=0;if((e|0)==1){break X}j[114630]=0;I(587,d+80|0,2,o|0);e=j[114630];j[114630]=0;if((e|0)==1){break W}j[114630]=0;F(415,d+232|0,d+80|0);e=j[114630];j[114630]=0;if((e|0)==1){break W}j[114630]=0;E(369,((l[d+56>>1]<<5)+a|0)+946300|0,d+232|0)|0;e=j[114630];j[114630]=0;if((e|0)==1){break V}gb(d+232|0)}e=b&65535;b=b+1|0;if(e>>>0<f>>>0){continue}break z}break}e=D()|0;C()|0;break f}e=D()|0;C()|0;break f}e=D()|0;C()|0;gb(d+232|0);break f}jb(d+96|0);break A}break w}e=D()|0;C()|0;break f}e=0;break v}j[114630]=0;b=H(484,d+96|0)|0;e=j[114630];j[114630]=0;if((e|0)!=1){break x}}e=D()|0;C()|0;break f}if((b|0)==4){b=l[g>>1];j[114630]=0;i[d+160>>1]=b;i[d+232>>1]=255;b=E(477,d+160|0,d+232|0)|0;e=j[114630];j[114630]=0;if((e|0)==1){break h}i[a+480192>>1]=l[b>>1];j[114630]=0;I(580,d+232|0,d+248|0,1229278806);b=j[114630];j[114630]=0;if((b|0)==1){break i}g=d+80|4;o=d+80|3;q=d+80|5;n=d+80|7;while(1){j[114630]=0;b=E(258,d+96|0,15)|0;e=j[114630];j[114630]=0;$:{if((e|0)!=1){aa:{if(b){j[114630]=0;E(588,d+96|0,d+80|0)|0;b=j[114630];j[114630]=0;ba:{if((b|0)!=1){b=k[d+80|0]|k[d+81|0]<<8;if(l[a+480192>>1]<=((b<<8|b>>>8)&65535)>>>0){continue}b=k[d+80|0]|k[d+81|0]<<8;b=p((b<<8|b>>>8)&65535,104)+a|0;h[b+484524|0]=k[d+88|0];e=k[n|0];h[b+484523|0]=255;h[b+484525|0]=e;b=k[d+80|0]|k[d+81|0]<<8;e=k[d+80|0]|k[d+81|0]<<8;j[114630]=0;e=K(454,a|0,(b<<8|b>>>8)+1&65535,(e<<8|e>>>8)+1&65535)|0;b=j[114630];j[114630]=0;if((b|0)==1){break aa}if(!e){continue}b=k[q|0]|k[q+1|0]<<8;j[114630]=0;i[d+160>>1]=b<<8|b>>>8;i[d+56>>1]=4095;b=E(477,d+160|0,d+56|0)|0;f=j[114630];j[114630]=0;if((f|0)==1){break aa}j[e>>2]=l[b>>1];if(k[o|0]==255){continue}b=k[o|0];j[114630]=0;b=E(256,d+232|0,p(b,34)+2|0)|0;f=j[114630];j[114630]=0;if((f|0)==1){break aa}if(!b){continue}j[114630]=0;E(589,d+232|0,d+160|0)|0;b=j[114630];j[114630]=0;if((b|0)==1){break aa}h[e+60|0]=k[e+60|0]|1;b=k[d+160|0]|k[d+161|0]<<8;j[d+56>>2]=(b<<8|b>>>8)&65535;j[114630]=0;j[d+76>>2]=3;j[d+64>>2]=240;j[d+60>>2]=16;j[d+72>>2]=d+56;b=j[d+76>>2];j[d+8>>2]=j[d+72>>2];j[d+12>>2]=b;b=H(590,d+8|0)|0;f=j[114630];j[114630]=0;if((f|0)==1){break aa}j[114630]=0;f=e+48|0;F(591,f|0,b|0);b=j[114630];j[114630]=0;if((b|0)==1){break aa}b=0;if(sb(f)){break ba}break $}break aa}while(1){ca:{h[d+56|0]=64;u=(d+160|0)+(b<<1)|0;t=k[u+2|0];j[114630]=0;h[d+48|0]=t;t=E(391,d+56|0,d+48|0)|0;s=j[114630];j[114630]=0;if((s|0)==1){break ca}t=k[t|0];Q=xb(f,b),R=t,h[Q+2|0]=R;u=k[u+3|0];Q=xb(f,b),R=u,i[Q>>1]=R;b=b+1|0;if(sb(f)>>>0>b>>>0){continue}break $}break}break aa}jb(d+232|0);break w}}e=D()|0;C()|0;jb(d+232|0);break f}if(k[g|0]!=255){h[e+60|0]=k[e+60|0]|4;b=k[g|0];h[e+63|0]=b;h[e- -64|0]=b}if(Xc(f)){continue}h[e+60|0]=k[e+60|0]|2;b=sb(f)-1|0;h[e+61|0]=b;h[e+62|0]=b;continue}}}jb(d+96|0);j[114630]=0;I(592,d+96|0,d+248|0,1145131092);b=j[114630];j[114630]=0;if((b|0)==1){break j}Q=d,R=Lb(d+96|0),j[Q+48>>2]=R;Q=d,R=Mb(d+96|0),j[Q+40>>2]=R;if(rb(d+48|0,d+40|0)){J=c&1;u=d+232|4;t=(w|0)!=841887798;M=(w|0)!=841887796;while(1){o=j[d+48>>2];j[114630]=0;E(338,o|0,4)|0;b=j[114630];j[114630]=0;da:{ea:{fa:{if((b|0)!=1){j[114630]=0;e=H(484,o|0)|0;b=j[114630];j[114630]=0;if((b|0)==1){break l}j[114630]=0;q=H(484,o|0)|0;b=j[114630];j[114630]=0;if((b|0)==1){break m}q=t?q:(q>>>0)/m[a+480196>>2]|0;if(!J|e>>>0>255){break da}j[114630]=0;b=K(402,v|0,e|0,q|0)|0;f=j[114630];j[114630]=0;if((f|0)==1){break m}if(!b){break da}if(t){break ea}j[114630]=0;E(338,o|0,4)|0;b=j[114630];j[114630]=0;if((b|0)==1){break m}n=0;if(!l[a+480188>>1]){break da}while(1){j[114630]=0;b=H(484,o|0)|0;f=j[114630];j[114630]=0;if((f|0)==1){break fa}j[114630]=0;I(341,d+160|0,o|0,b+(b&1)&65535);b=j[114630];j[114630]=0;if((b|0)==1){break n}j[d+232>>2]=0;j[d+236>>2]=0;f=0;ga:{while(1){j[114630]=0;b=E(258,d+160|0,6)|0;g=j[114630];j[114630]=0;if((g|0)==1){break o}if(b^1|m[d+232>>2]>=q>>>0){break ga}b=Hb(v,e);j[114630]=0;b=K(471,b|0,j[d+232>>2],n&65535)|0;g=j[114630];j[114630]=0;ha:{ia:{if((g|0)!=1){j[114630]=0;F(593,d+56|0,d+160|0);g=j[114630];j[114630]=0;if((g|0)==1){break o}g=Pc(d+56|0);A=Bf(d+56|0);x=pi(d+56|0);s=Rb(d+56|0);O=d+61|0;r=h[d+56|0];if((r-1&255)>>>0>95){break ia}h[b|0]=r+13;if(!j[d+236>>2]){break ha}h[b+3|0]=19;j[114630]=0;j[d+80>>2]=15;r=E(462,u|0,d+80|0)|0;B=j[114630];j[114630]=0;if((B|0)==1){break o}h[b+5|0]=k[r|0]|208;break ha}break o}if((r|0)>-1){break ha}if(j[d+236>>2]){h[b+3|0]=19;j[114630]=0;j[d+80>>2]=15;r=E(462,u|0,d+80|0)|0;B=j[114630];j[114630]=0;if((B|0)!=1){h[b+5|0]=k[r|0]|192;break ha}break o}h[b|0]=254}if(k[g|0]){h[b+2|0]=1;j[114630]=0;h[d+80|0]=64;g=E(391,g|0,d+80|0)|0;r=j[114630];j[114630]=0;if((r|0)==1){break o}h[b+4|0]=k[g|0]}g=k[A|0];if(g){h[b+1|0]=g}g=k[x|0];if(g|k[s|0]){h[b+3|0]=g;h[b+5|0]=k[s|0];j[114630]=0;N(574,b|0);b=j[114630];j[114630]=0;if((b|0)==1){break o}}b=k[O|0];if(b&128){j[114630]=0;g=H(387,d+160|0)|0;s=j[114630];j[114630]=0;if((s|0)==1){break o}b=g|b<<8&32512}g=j[a+480196>>2];j[114630]=0;f=b+f|0;I(594,d+80|0,f|0,g|0);b=j[114630];j[114630]=0;if((b|0)!=1){b=j[d+84>>2];j[d+232>>2]=j[d+80>>2];j[d+236>>2]=b;continue}break}break o}jb(d+160|0);n=n+1|0;if(l[a+480188>>1]>(n&65535)>>>0){continue}break}break da}e=D()|0;C()|0;break k}e=D()|0;C()|0;break k}b=Hb(v,e);j[114630]=0;b=K(471,b|0,0,0)|0;e=j[114630];j[114630]=0;if((e|0)==1){break s}n=0;if(!q){break da}while(1){e=0;ja:{if(!l[a+480188>>1]){break ja}while(1){ka:{j[114630]=0;F(595,d+160|0,o|0);f=j[114630];j[114630]=0;if((f|0)==1){break ka}la:{if(!M){j[d+232>>2]=j[d+160>>2];s=Pc(d+232|0);r=Bf(d+232|0);A=pi(d+232|0);f=h[d+232|0];if((f|0)>=1){h[b|0]=(p((f&240)>>>4|0,12)+(f&15)|0)+12}g=b;f=k[s|0];x=f>>>2|0;if(x){h[b+2|0]=1;h[b+4|0]=x-1;f=k[s|0]}h[g+1|0]=f<<4&48|k[r|0]>>>4;h[b+3|0]=k[r|0]&15;h[b+5|0]=k[A|0];break la}j[114630]=0;f=j[d+160>>2];j[d+36>>2]=f;j[d+20>>2]=f;F(596,d+20|0,b|0);f=j[114630];j[114630]=0;if((f|0)==1){break ka}f=Pb(d+160|0,0);h[b+1|0]=k[b+1|0]|k[f|0]&48}j[114630]=0;N(574,b|0);f=j[114630];j[114630]=0;if((f|0)==1){break ka}f=k[b+3|0];ma:{if(f>>>0>11){break ma}f=1<<f;na:{if(!(f&2240)){if(!(f&12)){break ma}if(!k[b+5|0]){break na}break ma}f=k[b+5|0];g=f&240;if(g){h[b+5|0]=g;break ma}if(f){break ma}}h[b+3|0]=0}b=b+6|0;e=e+1|0;if(l[a+480188>>1]>(e&65535)>>>0){continue}break ja}break}e=D()|0;C()|0;break k}n=n+1|0;if((n|0)!=(q|0)){continue}break}}yf(d+48|0);if(rb(d+48|0,d+40|0)){continue}break}}Sc(d+96|0);j[114630]=0;I(580,d+160|0,d+248|0,1346458702);b=j[114630];j[114630]=0;if((b|0)==1){e=D()|0;C()|0;break b}j[114630]=0;b=H(489,d+160|0)|0;e=j[114630];j[114630]=0;oa:{pa:{qa:{ra:{sa:{ta:{ua:{va:{wa:{xa:{ya:{za:{Aa:{Ba:{if((e|0)!=1){if(b){f=Cb(d+96|0);b=0;Ca:{while(1){Da:{j[114630]=0;e=E(258,d+160|0,1)|0;g=j[114630];j[114630]=0;if((g|0)==1){break Da}if(!e){break Ca}if(me(v)>>>0<=b>>>0){break Ca}j[114630]=0;K(597,d+160|0,f|0,32)|0;e=j[114630];j[114630]=0;if((e|0)==1){break Da}e=Hb(v,b);j[114630]=0;E(495,e|0,f|0)|0;e=j[114630];j[114630]=0;if((e|0)==1){break Da}b=b+1|0;continue}break}e=D()|0;C()|0;gb(f);break Ba}gb(f)}jb(d+160|0);j[114630]=0;I(580,d+160|0,d+248|0,1414679374);b=j[114630];j[114630]=0;if((b|0)==1){break Aa}j[114630]=0;b=H(489,d+160|0)|0;e=j[114630];j[114630]=0;if((e|0)==1){break wa}if(!b){break xa}f=Cb(d+96|0);b=0;while(1){j[114630]=0;e=E(258,d+160|0,1)|0;g=j[114630];j[114630]=0;if((g|0)==1){break za}if(!e|l[a+480188>>1]<=b>>>0){break ya}j[114630]=0;K(597,d+160|0,f|0,32)|0;e=j[114630];j[114630]=0;if((e|0)==1){break za}j[114630]=0;E(378,((b<<5)+a|0)+480289|0,f|0)|0;e=j[114630];j[114630]=0;if((e|0)==1){break za}b=b+1|0;continue}}e=D()|0;C()|0}jb(d+160|0);break b}e=D()|0;C()|0;break b}e=D()|0;C()|0;gb(f);break va}gb(f)}jb(d+160|0);j[114630]=0;I(592,d+160|0,d+248|0,1145129300);b=j[114630];j[114630]=0;if((b|0)==1){break ua}Q=d,R=Lb(d+160|0),j[Q+96>>2]=R;Q=d,R=Mb(d+160|0),j[Q+232>>2]=R;if(rb(d+96|0,d+232|0)){e=c&2;while(1){b=j[d+96>>2];j[114630]=0;c=H(484,b|0)|0;f=j[114630];j[114630]=0;if((f|0)==1){break p}if(!(!e|c>>>0>=l[a+480190>>1])){c=p(c,104)+a|0;f=l[c+484518>>1];f=Kc(d+80|0,f&1?16:8,f&64?2:1,1,0);j[114630]=0;K(400,f|0,c+484484|0,b|0)|0;b=j[114630];j[114630]=0;if((b|0)==1){break p}}yf(d+96|0);if(rb(d+96|0,d+232|0)){continue}break}}Sc(d+160|0);b=Qc(d+96|0);if((w|0)!=841887798){break sa}j[114630]=0;c=E(2,d+160|0,12790)|0;e=j[114630];j[114630]=0;if((e|0)==1){break ta}ob(b,c);gb(c);break ra}e=D()|0;C()|0}jb(d+160|0);break b}e=D()|0;C()|0;break b}e=D()|0;C()|0;break q}j[114630]=0;I(580,d+160|0,d+248|0,1447383635);c=j[114630];j[114630]=0;Ea:{Fa:{Ga:{Ha:{Ia:{Ja:{Ka:{if((c|0)!=1){j[114630]=0;c=H(489,d+160|0)|0;e=j[114630];j[114630]=0;if((e|0)==1){break qa}if(!c){break Fa}j[114630]=0;e=H(493,d+160|0)|0;c=j[114630];j[114630]=0;if((c|0)==1){break Ka}j[114630]=0;c=E(2,d+24|0,12810)|0;f=j[114630];j[114630]=0;if((f|0)==1){break Ja}j[114630]=0;F(219,d+80|0,c|0);f=j[114630];j[114630]=0;if((f|0)==1){break Ia}j[114630]=0;j[d+56>>2]=e>>>4;j[d+48>>2]=e&15;L(598,d+232|0,d+80|0,d+56|0,d+48|0);e=j[114630];j[114630]=0;if((e|0)==1){break Ha}ob(b,d+232|0);gb(d+232|0);qb(d+80|0);break Ea}e=D()|0;C()|0;break q}e=D()|0;C()|0;break r}e=D()|0;C()|0;break r}e=D()|0;C()|0;break Ga}e=D()|0;C()|0;qb(d+80|0)}gb(c);break r}j[114630]=0;c=E(2,d+232|0,12832)|0;e=j[114630];j[114630]=0;if((e|0)==1){break t}ob(b,c)}gb(c);jb(d+160|0)}j[114630]=0;c=E(2,d+160|0,12832)|0;e=j[114630];j[114630]=0;if((e|0)==1){break pa}ob(a+1304436|0,c);gb(c);j[114630]=0;c=E(2,d+160|0,12848)|0;e=j[114630];j[114630]=0;if((e|0)==1){break oa}ob(a+1304448|0,c);gb(c);ob(a+1304460|0,b);j[a+1304496>>2]=2;gb(b);e=1;break v}e=D()|0;C()|0;break r}e=D()|0;C()|0;break q}e=D()|0;C()|0;break q}jz(d+248|0)}Za=d+288|0;return e|0}e=D()|0;C()|0;break r}e=D()|0;C()|0;break k}jb(d+160|0)}gb(b);break b}e=D()|0;C()|0;Sc(d+160|0);break b}e=D()|0;C()|0;jb(d+160|0);break k}e=D()|0;C()|0;break k}e=D()|0;C()|0;break k}e=D()|0;C()|0}Sc(d+96|0);break b}e=D()|0;C()|0;break b}e=D()|0;C()|0;break f}e=D()|0;C()|0;break f}e=D()|0;C()|0}jb(d+96|0);break b}e=D()|0;C()|0;break b}e=D()|0;C()|0;jb(d+160|0);break b}e=D()|0;C()|0;jb(d+232|0)}jz(d+248|0)}G(e|0);z()}function Swa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,n=0,o=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,J=0,M=0,O=0,Q=0,R=0,S=0;d=Za-528|0;Za=d;rc(b);a:{if(!en(b,d+448|0)){break a}if(!UM(d+448|0)){break a}if(!yb(b,Tc(TM(d+448|0),ab))){break a}b:{if(!c){break b}od(a,4);Zh(a);j[a+1074368>>2]=4;s=Qc(d+432|0);c:{d:{r=d+486|0;e:{if(!(_c(r,17536,20)|(k[d+508|0]|k[d+509|0]<<8|(k[d+510|0]<<16|k[d+511|0]<<24))!=276)){e=48;if((k[d+506|0]|k[d+507|0]<<8)>>>0<260){break e}j[114630]=0;g=K(625,d+465|0,0,20)|0;f=j[114630];j[114630]=0;if((f|0)==1){break d}e=g?1154:34;break e}if(!_c(r,17557,20)){e=1;break e}j[114630]=0;I(746,d+416|0,3,r|0);g=j[114630];j[114630]=0;f:{g:{h:{if((g|0)==1){break h}j[114630]=0;F(415,d+72|0,d+416|0);g=j[114630];j[114630]=0;if((g|0)==1){break h}j[114630]=0;I(13,d+144|0,4,d+72|0);g=j[114630];j[114630]=0;if((g|0)==1){break g}ob(s,d+144|0);gb(d+144|0);gb(d+72|0);if((k[r|0]|k[r+1|0]<<8|(k[r+2|0]<<16|k[r+3|0]<<24))!=1852141647|(k[r+4|0]|k[r+5|0]<<8|(k[r+6|0]<<16|k[r+7|0]<<24))!=542396493){break f}e=1048;break e}e=D()|0;C()|0;break c}e=D()|0;C()|0;gb(d+72|0);break c}if(!_c(r,17587,12)){e=16;if((l[d+498>>1]|l[d+500>>1]<<16)==538976288&(l[d+502>>1]|l[d+504>>1]<<16)==538976288){break e}j[a+1074368>>2]=5;break e}if(!_c(r,17601,20)){e=48;break e}if(!_c(r,17622,15)){j[114630]=0;g=a+1074308|0;E(479,g|0,54)|0;f=j[114630];j[114630]=0;if((f|0)==1){break d}j[114630]=0;E(479,g|0,51)|0;g=j[114630];j[114630]=0;e=16;if((g|0)==1){break d}break e}if(!_c(r,17638,14)){j[114630]=0;E(479,a+1074308|0,57)|0;g=j[114630];j[114630]=0;e=16;if((g|0)!=1){break e}break d}e=_c(r,17653,11)?16:256}j[114630]=0;B=d+465|0;I(746,d+72|0,3,B|0);g=j[114630];j[114630]=0;i:{j:{k:{l:{m:{if((g|0)==1){break m}j[114630]=0;F(415,d+144|0,d+72|0);g=j[114630];j[114630]=0;if((g|0)==1){break m}ob(a+1304400|0,d+144|0);gb(d+144|0);j[a+480260>>2]=1;j[a+480264>>2]=31999;x=a+484360|0;Fe(Eb(x),k[d+514|0]|k[d+515|0]<<8);i[a+480188>>1]=k[d+516|0]|k[d+517|0]<<8;g=k[d+520|0]|k[d+521|0]<<8;j[114630]=0;i[d+144>>1]=g;i[d+72>>1]=255;g=E(477,d+144|0,d+72|0)|0;f=j[114630];j[114630]=0;if((f|0)==1){break l}i[a+480192>>1]=l[g>>1];if(k[d+524|0]|k[d+525|0]<<8){j[a+480196>>2]=k[d+524|0]|k[d+525|0]<<8}if(k[d+526|0]|k[d+527|0]<<8){g=j[19866];R=a,S=kd(p(k[d+526|0]|k[d+527|0]<<8,1e4),p(j[g+20>>2],1e4),p(j[g+24>>2],1e4)),j[R+480204>>2]=S}j[a+480208>>2]=0;j[a+480208>>2]=j[a+480208>>2]&-17|(k[d+522|0]|k[d+523|0]<<8)<<4&16;g=(k[d+522|0]|k[d+523|0]<<8)<<3&32768;j[a+480208>>2]=g|j[a+480208>>2]&-32769;f=Eb(x);o=k[d+512|0]|k[d+513|0]<<8;j[114630]=0;U(581,f|0,b|0,o|0,65535,65535)|0;f=j[114630];j[114630]=0;if((f|0)==1){break d}n=(e|0)==34?g>>>15|0?146:e:e;if(!(n&1024|(k[d+512|0]|k[d+513|0]<<8))){g=Eb(x);j[114630]=0;I(1027,g|0,1,0);g=j[114630];j[114630]=0;if((g|0)==1){break d}}g=k[d+508|0]|k[d+509|0]<<8|(k[d+510|0]<<16|k[d+511|0]<<24);j[114630]=0;E(256,b|0,g+60|0)|0;g=j[114630];j[114630]=0;if((g|0)==1){break d}if((k[d+506|0]|k[d+507|0]<<8)>>>0>=260){j[114630]=0;I(1028,b|0,d+448|0,a|0);g=j[114630];j[114630]=0;if((g|0)==1){break d}}h[d+415|0]=0;t=d+416|0;Iwa(t);if(l[a+480192>>1]){break k}g=-1;break j}e=D()|0;C()|0;break c}e=D()|0;C()|0;break c}M=c&2;O=d+90|0;Q=d+177|0;o=d+173|0;e=1;g=-1;u=1;while(1){n:{j[114630]=0;f=H(390,b|0)|0;q=j[114630];j[114630]=0;o:{p:{q:{r:{s:{t:{if((q|0)!=1){cg(b,4);j[114630]=0;K(1029,b|0,d+144|0,(f?f:263)|0)|0;f=j[114630];j[114630]=0;if((f|0)==1){break n}u:{if((n|0)==1){if((k[d+144|0]|k[d+145|0]<<8|(k[d+146|0]<<16|k[d+147|0]<<24))==245){j[a+1074304>>2]=16777381;j[114630]=0;f=E(2,d+72|0,17665)|0;n=j[114630];j[114630]=0;if((n|0)!=1){ob(s,f);gb(f);n=17;break u}e=D()|0;C()|0;break i}n=16;if((k[d+144|0]|k[d+145|0]<<8|(k[d+146|0]<<16|k[d+147|0]<<24))!=263){break u}j[a+1074304>>2]=16777395;j[114630]=0;f=E(2,d+72|0,17691)|0;n=j[114630];j[114630]=0;if((n|0)!=1){ob(s,f);gb(f);n=17;break u}e=D()|0;C()|0;break i}if(k[d+171|0]|k[d+172|0]<<8){break u}v:{if(!(n&2)|(k[d+144|0]|k[d+145|0]<<8|(k[d+146|0]<<16|k[d+147|0]<<24))!=263){break v}f=o;if(k[f|0]|k[f+1|0]<<8|(k[f+2|0]<<16|k[f+3|0]<<24)){break v}n=n|16;break u}if(!(!(n&256)|(k[d+144|0]|k[d+145|0]<<8|(k[d+146|0]<<16|k[d+147|0]<<24))==29)){n=n&-257;break u}if(!(n&160)){break u}n=(k[d+144|0]|k[d+145|0]<<8|(k[d+146|0]<<16|k[d+147|0]<<24))==33?n:0}j[114630]=0;f=K(454,a|0,u&65535,0)|0;q=j[114630];j[114630]=0;if((q|0)==1){break n}if(!f){break o}q=((e<<2)+a|0)+900380|0;f=j[q>>2];j[114630]=0;F(1030,d+144|0,f|0);f=j[114630];j[114630]=0;if((f|0)==1){break n}f=k[d+170|0];w:{if((g|0)==-1){g=f;break w}if(!(n&32)|(f|0)==(g|0)){break w}n=n&-161|128}if(!(k[d+171|0]|k[d+172|0]<<8)){break o}f=k[d+385|0];e=k[d+386|0];w=k[d+387|0]|k[d+388|0]<<8;v=k[d+391|0];y=k[d+171|0]|k[d+172|0]<<8;j[114630]=0;I(1031,d+128|0,a|0,y|0);y=j[114630];j[114630]=0;if((y|0)==1){break t}n=v|(w|(e|f))?n&-4:n;e=12;while(1){f=l[Nc(j[q>>2]+236|0,e)>>1];if(Yb(d+128|0)>>>0>f>>>0){f=l[bc(d+128|0,l[Nc(j[q>>2]+236|0,e)>>1])>>1];R=Nc(j[q>>2]+236|0,e),S=f,i[R>>1]=S}e=e+1|0;if((e|0)!=108){continue}break}if((k[d+506|0]|k[d+507|0]<<8)>>>0>259){sb(t);RM(t);yg(t)}f=k[d+171|0]|k[d+172|0]<<8;j[114630]=0;f=E(1032,d+112|0,f|0)|0;e=j[114630];j[114630]=0;x:{if((e|0)!=1){e=0;if(k[d+171|0]|k[d+172|0]<<8){break x}break s}e=D()|0;C()|0;break q}y:{z:{A:{B:{while(1){j[114630]=0;E(1033,b|0,d+72|0)|0;q=j[114630];j[114630]=0;if((q|0)==1){break y}j[114630]=0;F(1034,d+56|0,d+72|0);q=j[114630];j[114630]=0;C:{if((q|0)==1){break C}j[114630]=0;F(1035,t|0,d+56|0);q=j[114630];j[114630]=0;if((q|0)==1){break C}q=k[d+72|0]|k[d+73|0]<<8|(k[d+74|0]<<16|k[d+75|0]<<24);R=xb(f,e),S=q,j[R>>2]=S;w=k[d+89|0];if(Yb(d+128|0)>>>0>e>>>0){q=l[bc(d+128|0,e)>>1];j[114630]=0;v=(p(q,104)+a|0)+484380|0;F(1036,d+72|0,v|0);y=j[114630];j[114630]=0;if((y|0)==1){break B}j[114630]=0;F(1037,Q|0,v|0);v=j[114630];j[114630]=0;if((v|0)==1){break B}j[114630]=0;I(587,d+40|0,3,O|0);v=j[114630];j[114630]=0;if((v|0)==1){break A}j[114630]=0;F(415,d+56|0,d+40|0);v=j[114630];j[114630]=0;if((v|0)==1){break A}j[114630]=0;E(369,((q<<5)+a|0)+946300|0,d+56|0)|0;q=j[114630];j[114630]=0;if((q|0)==1){break z}gb(d+56|0);n=(n&2)>>>1|0?(k[d+86|0]&3)==3?n|4:n:n}A=w|A;e=e+1|0;if(e>>>0>=(k[d+171|0]|k[d+172|0]<<8)>>>0){break s}continue}break}e=D()|0;C()|0;break r}e=D()|0;C()|0;break r}e=D()|0;C()|0;break r}e=D()|0;C()|0;gb(d+56|0);break r}e=D()|0;C()|0;break r}e=D()|0;C()|0;break i}e=D()|0;C()|0;break i}if((k[d+506|0]|k[d+507|0]<<8)>>>0<260){break p}e=0;if(!(k[d+171|0]|k[d+172|0]<<8)){break p}D:{while(1){E:{w=k[xb(t,e)+3|0];q=j[xb(f,e)>>2];j[114630]=0;I(341,d+72|0,b|0,((w|0)==11?(q+1>>>1|0)+16|0:q)|0);q=j[114630];j[114630]=0;if((q|0)==1){break E}if(!(!M|Yb(d+128|0)>>>0<=e>>>0)){w=l[bc(d+128|0,e)>>1];q=xb(t,e);q=k[q|0]|k[q+1|0]<<8|(k[q+2|0]<<16|k[q+3|0]<<24);j[114630]=0;j[d+36>>2]=q;j[d+4>>2]=q;q=P(1038,(p(w,104)+a|0)+484380|0,d+4|0,d+72|0,d+415|0)|0;w=j[114630];j[114630]=0;if((w|0)==1){break D}J=q^1|J}jb(d+72|0);e=e+1|0;if(e>>>0<(k[d+171|0]|k[d+172|0]<<8)>>>0){continue}break p}break}e=D()|0;C()|0;break r}e=D()|0;C()|0;jb(d+72|0)}Ud(f)}ff(d+128|0);break i}Ud(f);ff(d+128|0)}u=u+1|0;e=u&65535;if(e>>>0<=l[a+480192>>1]){continue}break j}break}e=D()|0;C()|0;break i}F:{G:{H:{I:{J:{K:{L:{M:{N:{O:{P:{Q:{R:{S:{T:{U:{V:{W:{if(!(!(n&2)|A&255)){j[114630]=0;f=K(625,B|0,0,20)|0;o=j[114630];j[114630]=0;if((o|0)==1){break W}n=f?n|16:n}X:{if((k[d+506|0]|k[d+507|0]<<8)>>>0>259){break X}if(c&3){j[114630]=0;I(1028,b|0,d+448|0,a|0);f=j[114630];j[114630]=0;if((f|0)==1){break W}}if(!(c&2)|!l[a+480190>>1]){break X}c=1;e=1;while(1){f=xb(t,c-1|0);j[114630]=0;K(400,f|0,(p(c,104)+a|0)+484380|0,b|0)|0;c=j[114630];j[114630]=0;if((c|0)==1){break V}e=e+1|0;c=e&65535;if(c>>>0<=l[a+480190>>1]){continue}break}}if(J&1){j[114630]=0;c=E(2,d+144|0,17716)|0;f=j[114630];j[114630]=0;if((f|0)==1){break U}j[114630]=0;I(646,a|0,2,c|0);f=j[114630];j[114630]=0;if((f|0)==1){break T}gb(c)}j[114630]=0;c=E(618,b|0,17799)|0;f=j[114630];j[114630]=0;if((f|0)==1){break W}if(c){j[114630]=0;c=H(390,b|0)|0;f=j[114630];j[114630]=0;if((f|0)==1){break W}j[114630]=0;P(584,a+1304424|0,b|0,c|0,0)|0;c=j[114630];j[114630]=0;if((c|0)==1){break W}n=n|16}j[114630]=0;f=E(618,b|0,17804)|0;c=j[114630];j[114630]=0;if((c|0)==1){break F}if(f){j[114630]=0;c=H(390,b|0)|0;o=j[114630];j[114630]=0;if((o|0)==1){break F}j[114630]=0;o=a+901404|0;K(1039,b|0,o|0,c|0)|0;c=j[114630];j[114630]=0;if((c|0)==1){break F}j[114630]=0;N(633,o|0);c=j[114630];j[114630]=0;if((c|0)==1){break F}n=n|16}j[114630]=0;c=E(618,b|0,17809)|0;o=j[114630];j[114630]=0;if((o|0)==1){break F}if(c){j[114630]=0;c=H(390,b|0)|0;o=j[114630];j[114630]=0;if((o|0)==1){break S}i[d+144>>1]=c>>>5;o=a+484344|0;c=me(o);j[114630]=0;i[d+72>>1]=c;c=E(477,d+144|0,d+72|0)|0;e=j[114630];j[114630]=0;if((e|0)==1){break R}e=l[c>>1];if(e){c=0;while(1){j[114630]=0;K(866,b|0,d+144|0,32)|0;u=j[114630];j[114630]=0;if((u|0)==1){break Q}u=Hb(o,c);j[114630]=0;E(867,u|0,d+144|0)|0;u=j[114630];j[114630]=0;if((u|0)==1){break Q}c=c+1|0;if((e|0)!=(c|0)){continue}break}}n=n|16}j[114630]=0;c=E(618,b|0,17814)|0;o=j[114630];j[114630]=0;if((o|0)==1){break F}if(c){j[114630]=0;c=H(390,b|0)|0;o=j[114630];j[114630]=0;if((o|0)==1){break P}i[d+144>>1]=(c>>>0)/20;c=l[a+480188>>1];j[114630]=0;i[d+72>>1]=c;c=E(477,d+144|0,d+72|0)|0;o=j[114630];j[114630]=0;if((o|0)==1){break O}c=l[c>>1];if(c){e=0;while(1){j[114630]=0;K(635,b|0,((e<<5)+a|0)+480289|0,20)|0;o=j[114630];j[114630]=0;if((o|0)==1){break K}e=e+1|0;if((c|0)!=(e|0)){continue}break}}n=n|16}j[114630]=0;c=E(258,b|0,8)|0;o=j[114630];j[114630]=0;if((o|0)==1){break F}if(c){c=j[b+8>>2];j[114630]=0;E(636,a|0,b|0)|0;o=j[114630];j[114630]=0;if((o|0)==1){break J}n=(c|0)==j[b+8>>2]?n:n|16}if(!(n&16)){break L}if(!(n&4)){break M}j[a+1074304>>2]=17367040;j[114630]=0;c=E(2,d+144|0,17819)|0;o=j[114630];j[114630]=0;if((o|0)==1){break N}ob(s,c);gb(c);break L}e=D()|0;C()|0;break i}e=D()|0;C()|0;break i}e=D()|0;C()|0;break i}e=D()|0;C()|0;gb(c);break i}e=D()|0;C()|0;break i}e=D()|0;C()|0;break i}e=D()|0;C()|0;break i}e=D()|0;C()|0;break i}e=D()|0;C()|0;break i}e=D()|0;C()|0;break i}if(!(n&2)){break L}j[a+1074304>>2]=18219008;j[114630]=0;c=E(2,d+144|0,17840)|0;o=j[114630];j[114630]=0;if((o|0)==1){break I}ob(s,c);gb(c)}Y:{Z:{_:{$:{aa:{ba:{ca:{if((k[r|0]|k[r+1|0]<<8|(k[r+2|0]<<16|k[r+3|0]<<24))==1852141647&(k[r+4|0]|k[r+5|0]<<8|(k[r+6|0]<<16|k[r+7|0]<<24))==542396493){j[114630]=0;c=K(1040,d+144|0,d+494|0,12)|0;o=j[114630];j[114630]=0;if((o|0)==1){break ca}j[114630]=0;I(13,d+72|0,1,c|0);o=j[114630];j[114630]=0;if((o|0)==1){break ba}j[114630]=0;o=H(1041,d+72|0)|0;e=j[114630];j[114630]=0;if((e|0)==1){break aa}j[a+1074304>>2]=o;gb(d+72|0);j[a+1074368>>2]=m[a+1074304>>2]<19007257?4:5;gb(c);n=24}if(!(!j[a+1074304>>2]|n&8)){j[a+1074368>>2]=0;Vs(a+1074308|0)}c=n&32;da:{if(!c){break da}j[a+1074368>>2]=5;if(!f){j[114630]=0;N(634,a+901404|0);f=j[114630];j[114630]=0;if((f|0)==1){break F}}if((k[d+506|0]|k[d+507|0]<<8)>>>0<260){break da}j[114630]=0;K(478,a+1074308|0,4,1)|0;f=j[114630];j[114630]=0;if((f|0)==1){break F}}if(!Ec(s)){break Y}if(!(n&256)|(A&255|g+1>>>0>1)){break Z}j[114630]=0;c=E(2,d+144|0,17868)|0;g=j[114630];j[114630]=0;if((g|0)==1){break _}ob(s,c);gb(c);break Y}e=D()|0;C()|0;break i}e=D()|0;C()|0;break $}e=D()|0;C()|0;gb(d+72|0)}gb(c);break i}e=D()|0;C()|0;break i}if(c){j[114630]=0;c=E(2,d+144|0,17880)|0;g=j[114630];j[114630]=0;if((g|0)!=1){ob(s,c);gb(c);break Y}e=D()|0;C()|0;break i}j[114630]=0;c=E(2,d+144|0,17908)|0;g=j[114630];j[114630]=0;if((g|0)==1){break H}ob(s,c);gb(c)}h[d+40|0]=0;ea:{if(l[a+480192>>1]){j[114630]=0;c=E(652,a|0,b|0)|0;g=j[114630];j[114630]=0;if((g|0)==1){break ea}h[d+40|0]=c}j[114630]=0;L(653,a|0,b|0,1,d+40|0);b=j[114630];j[114630]=0;if((b|0)==1){break ea}c=a+1074304|0;if(!(!k[d+40|0]|m[c>>2]>=18284544)){j[c>>2]=18284544}fa:{ga:{ha:{ia:{ja:{ka:{la:{ma:{na:{oa:{pa:{qa:{ra:{sa:{b=j[c>>2];if(b>>>0>=18284544){j[114630]=0;b=E(2,d+72|0,17578)|0;g=j[114630];j[114630]=0;if((g|0)==1){break sa}j[114630]=0;F(1042,d+128|0,c|0);g=j[114630];j[114630]=0;if((g|0)==1){break ra}j[114630]=0;I(3,d+144|0,b|0,d+128|0);g=j[114630];j[114630]=0;if((g|0)==1){break qa}ob(s,d+144|0);gb(d+144|0);gb(d+128|0);gb(b);b=j[c>>2]}ta:{if(!b|m[c>>2]>=19005954){break ta}j[114630]=0;b=a+484344|0;c=E(442,b|0,254)|0;g=j[114630];j[114630]=0;if((g|0)==1){break ea}if(!c){c=Eb(x);j[114630]=0;F(1043,c|0,254);c=j[114630];j[114630]=0;if((c|0)==1){break ea}}j[114630]=0;b=E(442,b|0,255)|0;c=j[114630];j[114630]=0;if((c|0)==1){break ea}if(b){break ta}b=Eb(x);j[114630]=0;c=T(958)|0;g=j[114630];j[114630]=0;if((g|0)==1){break ea}j[114630]=0;I(1044,b|0,255,c|0);b=j[114630];j[114630]=0;if((b|0)==1){break ea}}if(!k[d+415|0]){break fa}j[114630]=0;b=E(2,d+144|0,17916)|0;c=j[114630];j[114630]=0;if((c|0)==1){break oa}ob(a+1304436|0,b);gb(b);j[114630]=0;b=E(2,d+144|0,17937)|0;c=j[114630];j[114630]=0;if((c|0)==1){break na}ob(a+1304448|0,b);gb(b);j[114630]=0;b=E(2,d+24|0,17941)|0;c=j[114630];j[114630]=0;if((c|0)==1){break ma}j[114630]=0;F(219,d+72|0,b|0);c=j[114630];j[114630]=0;if((c|0)==1){break la}j[d+112>>2]=k[d+507|0];c=k[d+506|0];j[114630]=0;j[d+56>>2]=c;F(660,d+128|0,d+56|0);c=j[114630];j[114630]=0;if((c|0)==1){break ka}j[114630]=0;L(645,d+144|0,d+72|0,d+112|0,d+128|0);c=j[114630];j[114630]=0;if((c|0)==1){break ja}ob(a+1304472|0,d+144|0);gb(d+144|0);gb(d+128|0);qb(d+72|0);gb(b);j[114630]=0;c=E(2,d+144|0,17962)|0;b=j[114630];j[114630]=0;if((b|0)==1){break ga}ob(a+1304484|0,c);break G}e=D()|0;C()|0;break i}e=D()|0;C()|0;break pa}e=D()|0;C()|0;gb(d+128|0)}gb(b);break i}e=D()|0;C()|0;break i}e=D()|0;C()|0;break i}e=D()|0;C()|0;break i}e=D()|0;C()|0;break ha}e=D()|0;C()|0;break ia}e=D()|0;C()|0;gb(d+128|0)}qb(d+72|0)}gb(b);break i}e=D()|0;C()|0;break i}j[114630]=0;b=E(2,d+8|0,17941)|0;c=j[114630];j[114630]=0;ua:{va:{wa:{xa:{ya:{za:{if((c|0)!=1){j[114630]=0;F(219,d+72|0,b|0);c=j[114630];j[114630]=0;if((c|0)==1){break za}j[d+112>>2]=k[d+507|0];c=k[d+506|0];j[114630]=0;j[d+56>>2]=c;F(660,d+128|0,d+56|0);c=j[114630];j[114630]=0;if((c|0)==1){break ya}j[114630]=0;L(645,d+144|0,d+72|0,d+112|0,d+128|0);c=j[114630];j[114630]=0;if((c|0)==1){break xa}ob(a+1304436|0,d+144|0);gb(d+144|0);gb(d+128|0);qb(d+72|0);gb(b);j[114630]=0;c=E(2,d+144|0,17962)|0;b=j[114630];j[114630]=0;if((b|0)==1){break ua}ob(a+1304448|0,c);break G}e=D()|0;C()|0;break i}e=D()|0;C()|0;break va}e=D()|0;C()|0;break wa}e=D()|0;C()|0;gb(d+128|0)}qb(d+72|0)}gb(b);break i}e=D()|0;C()|0;break i}e=D()|0;C()|0;break i}e=D()|0;C()|0;break i}e=D()|0;C()|0;break i}e=D()|0;C()|0;break i}e=D()|0;C()|0;break i}gb(c);ob(a+1304460|0,s);j[a+1304496>>2]=j[a+1074304>>2]?7:4;SM(t);gb(s);break b}e=D()|0;C()|0}SM(t);break c}e=D()|0;C()|0}gb(s);G(e|0);z()}e=1}Za=d+528|0;return e|0}function zEa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,J=0,L=0,M=0,O=0,Q=0,R=0,S=0;d=Za-288|0;Za=d;rc(b);a:{b:{c:{d:{e:{f:{g:{h:{i:{j:{k:{l:{m:{n:{o:{p:{q:{r:{s:{t:{u:{v:{w:{x:{if(!Kz(b,d+280|0)){break x}if(!PP(d+280|0)){break x}if(!c){A=1;break x}L=tl(d+264|0,b);j[114630]=0;I(742,d+248|0,L|0,0);b=j[114630];j[114630]=0;y:{z:{A:{B:{C:{D:{E:{F:{G:{H:{I:{J:{K:{L:{M:{N:{if((b|0)!=1){j[114630]=0;I(743,d+232|0,d+248|0,20041);b=j[114630];j[114630]=0;if((b|0)==1){break N}j[114630]=0;b=H(337,d+232|0)|0;e=j[114630];j[114630]=0;if((e|0)==1){break E}if(!b){break y}j[114630]=0;b=E(744,d+232|0,d+136|0)|0;e=j[114630];j[114630]=0;if((e|0)==1){break E}if(!b){break y}j[114630]=0;F(447,a|0,16384);b=j[114630];j[114630]=0;if((b|0)==1){break E}j[a+480208>>2]=8;j[114630]=0;b=a+1074308|0;K(478,b|0,9,1)|0;e=j[114630];j[114630]=0;if((e|0)==1){break E}j[114630]=0;E(479,b|0,21)|0;e=j[114630];j[114630]=0;if((e|0)==1){break E}j[114630]=0;E(479,b|0,30)|0;b=j[114630];j[114630]=0;if((b|0)==1){break E}j[114630]=0;b=E(2,d+16|0,14652)|0;e=j[114630];j[114630]=0;if((e|0)==1){break K}ob(a+1304436|0,b);gb(b);j[114630]=0;b=E(2,d+16|0,14664)|0;e=j[114630];j[114630]=0;if((e|0)==1){break J}ob(a+1304448|0,b);gb(b);j[114630]=0;e=E(2,d+120|0,14668)|0;b=j[114630];j[114630]=0;if((b|0)==1){break I}b=k[d+284|0];switch(b-16|0){case 1:break H;case 0:break M;default:break L}}b=D()|0;C()|0;break a}b=D()|0;C()|0;break b}j[114630]=0;E(2,d+104|0,14683)|0;b=j[114630];j[114630]=0;if((b|0)!=1){break F}break e}if(!b){break G}j[114630]=0;E(2,d+104|0,14698)|0;b=j[114630];j[114630]=0;if((b|0)==1){break e}break F}b=D()|0;C()|0;break c}b=D()|0;C()|0;break c}b=D()|0;C()|0;break c}j[114630]=0;E(2,d+104|0,14681)|0;b=j[114630];j[114630]=0;if((b|0)!=1){break F}break e}j[114630]=0;E(2,d+104|0,14687)|0;b=j[114630];j[114630]=0;if((b|0)==1){break e}}j[114630]=0;I(3,d+16|0,e|0,d+104|0);b=j[114630];j[114630]=0;if((b|0)==1){break f}ob(a+1304460|0,d+16|0);gb(d+16|0);gb(d+104|0);gb(e);j[a+1304496>>2]=4;j[114630]=0;I(745,d+120|0,3,d+136|0);b=j[114630];j[114630]=0;if((b|0)==1){break g}j[114630]=0;F(415,d+16|0,d+120|0);b=j[114630];j[114630]=0;if((b|0)==1){break g}ob(a+1304400|0,d+16|0);gb(d+16|0);j[114630]=0;I(746,d+104|0,3,d+168|0);b=j[114630];j[114630]=0;if((b|0)==1){break h}j[114630]=0;F(415,d+120|0,d+104|0);b=j[114630];j[114630]=0;if((b|0)==1){break h}j[114630]=0;I(13,d+16|0,4,d+120|0);b=j[114630];j[114630]=0;if((b|0)==1){break i}ob(a+1304412|0,d+16|0);gb(d+16|0);gb(d+120|0);j[a+480200>>2]=k[d+192|0]+1;R=a,S=kd(k[d+193|0],1,255),j[R+480196>>2]=S;R=a,S=p(kd(k[d+194|0],4,255),1e4),j[R+480204>>2]=S;b=a+484360|0;e=Eb(b);f=k[d+188|0]|k[d+189|0]<<8;j[114630]=0;U(581,e|0,d+232|0,f|0,65535,65535)|0;e=j[114630];j[114630]=0;if((e|0)==1){break E}Fe(Eb(b),k[d+190|0]|k[d+191|0]<<8);i[a+480188>>1]=0;b=0;while(1){j[114630]=0;e=(b<<5)+a|0;f=e+480280|0;N(432,f|0);g=j[114630];j[114630]=0;if((g|0)==1){break j}g=b+d|0;n=k[g+195|0]<<1&254;i[e+480284>>1]=(n|0)==254?256:n;O:{if(h[g+195|0]<=-1){j[f>>2]=j[f>>2]|1024;break O}i[a+480188>>1]=b+1}j[114630]=0;K(747,d+232|0,e+480289|0,8)|0;e=j[114630];j[114630]=0;if((e|0)==1){break j}b=b+1|0;if((b|0)!=32){continue}break}j[114630]=0;I(743,d+16|0,d+248|0,17741);b=j[114630];j[114630]=0;if((b|0)==1){break k}Ed(d+232|0,d+16|0);jb(d+16|0);j[114630]=0;b=H(255,d+232|0)|0;e=j[114630];j[114630]=0;if((e|0)==1){break E}j[114630]=0;P(584,a+1304424|0,d+232|0,b|0,0)|0;b=j[114630];j[114630]=0;if((b|0)==1){break E}j[114630]=0;I(743,d+16|0,d+248|0,21321);b=j[114630];j[114630]=0;if((b|0)==1){break l}Ed(d+232|0,d+16|0);jb(d+16|0);j[114630]=0;b=H(337,d+232|0)|0;e=j[114630];j[114630]=0;if((e|0)==1){break E}P:{if(b){j[114630]=0;I(743,d+16|0,d+248|0,16723);b=j[114630];j[114630]=0;if((b|0)==1){break m}j[114630]=0;q=H(387,d+232|0)|0;b=j[114630];j[114630]=0;if((b|0)==1){break n}Q:{if(!q){break Q}r=c&2;while(1){j[114630]=0;e=H(387,d+232|0)|0;b=j[114630];j[114630]=0;if((b|0)==1){break n}if(!e){break Q}j[114630]=0;b=E(258,d+232|0,56)|0;f=j[114630];j[114630]=0;if((f|0)==1){break n}if(!b){break Q}if(e>>>0>l[a+480190>>1]){i[a+480190>>1]=e}j[114630]=0;b=p(e,104)+a|0;f=b+484380|0;F(386,f|0,0);g=j[114630];j[114630]=0;if((g|0)==1){break n}j[114630]=0;K(548,d+232|0,((e<<5)+a|0)+946300|0,32)|0;e=j[114630];j[114630]=0;if((e|0)==1){break n}j[114630]=0;K(551,d+232|0,b+484423|0,8)|0;e=j[114630];j[114630]=0;if((e|0)==1){break n}R:{if(k[d+284|0]<=15){j[114630]=0;e=H(357,d+232|0)|0;g=j[114630];j[114630]=0;if((g|0)!=1){break R}break n}j[114630]=0;e=H(390,d+232|0)|0;g=j[114630];j[114630]=0;if((g|0)==1){break n}}j[b+484404>>2]=e<<1;j[114630]=0;e=H(390,d+232|0)|0;g=j[114630];j[114630]=0;if((g|0)==1){break n}j[f>>2]=e;j[114630]=0;g=H(390,d+232|0)|0;e=j[114630];j[114630]=0;if((e|0)==1){break n}e=b+484384|0;j[e>>2]=g;j[114630]=0;g=H(390,d+232|0)|0;n=j[114630];j[114630]=0;if((n|0)==1){break n}n=b+484388|0;j[n>>2]=g;if(g){o=b+484414|0;i[o>>1]=l[o>>1]|2;j[n>>2]=g+j[e>>2]}j[114630]=0;g=H(387,d+232|0)|0;o=j[114630];j[114630]=0;if((o|0)==1){break P}if(k[d+284|0]<=15){i[b+484410>>1]=g}j[114630]=0;g=H(387,d+232|0)|0;o=j[114630];j[114630]=0;if((o|0)==1){break n}o=8;if(g&1){o=b+484414|0;i[o>>1]=l[o>>1]|1;j[f>>2]=j[f>>2]>>>1;j[e>>2]=j[e>>2]>>>1;j[n>>2]=j[n>>2]>>>1;o=16}b=b+484414|0;i[b>>1]=l[b>>1]&65531|g<<1&4;b=Kc(d+120|0,o,1,0,((g&12)!=0)<<3);S:{if(!r){break S}j[114630]=0;K(400,b|0,f|0,d+16|0)|0;b=j[114630];j[114630]=0;if((b|0)!=1){break S}break n}m=m+1|0;if(q>>>0>(m&255)>>>0){continue}break}}jb(d+16|0)}j[114630]=0;I(743,d+16|0,d+248|0,18761);b=j[114630];j[114630]=0;if((b|0)==1){break q}Ed(d+232|0,d+16|0);jb(d+16|0);j[114630]=0;b=H(337,d+232|0)|0;e=j[114630];j[114630]=0;if((e|0)==1){break E}T:{U:{V:{W:{if(b){q=Ky(d+120|0);r=Ky(d+104|0);o=Ky(d+88|0);j[114630]=0;I(743,d+72|0,d+248|0,17750);b=j[114630];j[114630]=0;if((b|0)==1){break r}j[114630]=0;F(748,d+72|0,q|0);b=j[114630];j[114630]=0;if((b|0)==1){break s}jb(d+72|0);j[114630]=0;I(743,d+56|0,d+248|0,17744);b=j[114630];j[114630]=0;if((b|0)==1){break r}j[114630]=0;F(748,d+56|0,r|0);b=j[114630];j[114630]=0;if((b|0)==1){break t}jb(d+56|0);j[114630]=0;I(743,d+40|0,d+248|0,17734);b=j[114630];j[114630]=0;if((b|0)==1){break r}j[114630]=0;F(748,d+40|0,o|0);b=j[114630];j[114630]=0;if((b|0)==1){break u}jb(d+40|0);j[114630]=0;t=H(387,d+232|0)|0;b=j[114630];j[114630]=0;if((b|0)==1){break v}if(t){y=d+16|4;A=d+16|2;v=d+16|6;w=d+16|5;x=d+16|3;e=d+16|1;m=0;while(1){j[114630]=0;F(472,d|0,d+232|0);b=j[114630];j[114630]=0;if((b|0)==1){break A}s=Pc(d);X:{Y:{Z:{if(!k[d|0]){break Z}b=k[s|0];j[114630]=0;b=E(258,d+232|0,p(b,14)+32|0)|0;f=j[114630];j[114630]=0;if((f|0)==1){break p}if(!b){break Z}b=k[d|0];j[114630]=0;n=K(454,a|0,b|0,0)|0;b=j[114630];j[114630]=0;if((b|0)==1){break p}if(n){break Y}}b=k[s|0];j[114630]=0;E(338,d+232|0,p(b,14)+32|0)|0;b=j[114630];j[114630]=0;if((b|0)!=1){break X}break p}j[114630]=0;K(548,d+232|0,n+492|0,32)|0;b=j[114630];j[114630]=0;if((b|0)==1){break p}if(!k[s|0]){break X}B=n+88|0;J=n+68|0;M=n+48|0;O=n+236|0;g=0;b=0;while(1){j[114630]=0;E(749,d+232|0,d+16|0)|0;f=j[114630];j[114630]=0;if((f|0)==1){break w}_:{if(!k[d+16|0]|l[a+480190>>1]<k[d+16|0]){break _}f=e;if(k[e|0]>128){h[f|0]=128}if(k[e|0]>=(b&255)>>>0){while(1){f=k[d+16|0];R=Nc(O,b&255),S=f,i[R>>1]=S;b=b+1|0;if(k[e|0]>=(b&255)>>>0){continue}break}}b=k[e|0];f=k[x|0];j[114630]=0;I(750,M|0,f|0,q|0);f=j[114630];j[114630]=0;if((f|0)==1){break w}f=k[w|0];j[114630]=0;I(750,J|0,f|0,r|0);f=j[114630];j[114630]=0;if((f|0)==1){break w}f=k[d+29|0];j[114630]=0;I(750,B|0,f|0,o|0);f=j[114630];j[114630]=0;if((f|0)==1){break w}j[n>>2]=(k[v|0]|k[v+1|0]<<8)+1>>>1;f=k[d+16|0];$:{if(k[x|0]&64){i[(p(f,104)+a|0)+484410>>1]=k[A|0];break $}u=(p(f,104)+a|0)+484414|0;i[u>>1]=l[u>>1]|32768}u=k[y|0];j[114630]=0;i[d+38>>1]=u<<1;i[d+36>>1]=254;u=E(477,d+38|0,d+36|0)|0;Q=j[114630];j[114630]=0;if((Q|0)==1){break W}b=b+1|0;f=p(f,104)+a|0;i[f+484408>>1]=l[u>>1];h[f+484418|0]=k[(k[d+27|0]&3)+14699|0];h[f+484419|0]=k[d+26|0];h[f+484420|0]=k[d+25|0];h[f+484421|0]=k[d+24|0];if(!(k[w|0]&64)){break _}f=f+484414|0;i[f>>1]=l[f>>1]|32}g=g+1|0;if(k[s|0]>(g&255)>>>0){continue}break}}m=m+1|0;if(t>>>0>(m&255)>>>0){continue}break}}$m(o);$m(r);$m(q)}A=1;r=lp(d+120|0);if(!(c&1)){break z}j[114630]=0;I(743,d+16|0,d+248|0,21076);b=j[114630];j[114630]=0;if((b|0)!=1){b=Ed(d+232|0,d+16|0);j[114630]=0;b=H(337,b|0)|0;c=j[114630];j[114630]=0;aa:{ba:{ca:{da:{ea:{fa:{if((c|0)!=1){jb(d+16|0);ga:{if(!b){break ga}j[114630]=0;c=H(357,d+232|0)|0;b=j[114630];j[114630]=0;if((b|0)==1){break fa}j[114630]=0;F(751,r|0,c+1|0);b=j[114630];j[114630]=0;if((b|0)==1){break fa}if(!c){break ga}b=1;while(1){j[114630]=0;e=H(357,d+232|0)|0;f=j[114630];j[114630]=0;if((f|0)==1){break ea}j[114630]=0;I(341,d+16|0,d+232|0,e|0);e=j[114630];j[114630]=0;if((e|0)==1){break ea}Ed($b(r,b),d+16|0);e=(b|0)==(c|0);jb(d+16|0);b=b+1|0;if(!e){continue}break}}j[114630]=0;I(743,d+16|0,d+248|0,16720);b=j[114630];j[114630]=0;if((b|0)==1){break da}b=Ed(d+232|0,d+16|0);j[114630]=0;b=H(337,b|0)|0;c=j[114630];j[114630]=0;if((c|0)==1){break ca}jb(d+16|0);if(!b){break aa}j[114630]=0;s=H(387,d+232|0)|0;b=j[114630];j[114630]=0;if((b|0)==1){break C}if(s){q=0;while(1){g=32;ha:{if(k[d+284|0]>=16){j[114630]=0;E(752,d+232|0,d+16|0)|0;b=j[114630];j[114630]=0;if((b|0)==1){break V}if(!(k[d+16|0]>32|l[a+480188>>1]>=k[d+16|0])){i[a+480188>>1]=k[d+16|0]}g=k[d+16|0];if(!g){break ha}}e=0;while(1){j[114630]=0;b=H(357,d+232|0)|0;c=j[114630];j[114630]=0;if((c|0)==1){break U}if(!(!b|l[a+480188>>1]>(e&65535)>>>0)){i[a+480188>>1]=e+1}e=e+1|0;if((e&65535)>>>0<g>>>0){continue}break}}q=q+1|0;if(s>>>0>(q&65535)>>>0){continue}break}}j[114630]=0;E(256,d+232|0,1)|0;b=j[114630];j[114630]=0;if((b|0)!=1){break ba}break C}b=D()|0;C()|0;jb(d+16|0);break B}b=D()|0;C()|0;break B}b=D()|0;C()|0;break B}b=D()|0;C()|0;break B}b=D()|0;C()|0;jb(d+16|0);break B}j[114630]=0;t=a+484344|0;F(401,t|0,s|0);b=j[114630];j[114630]=0;if((b|0)==1){break C}if(!s){break aa}M=d+16|2;O=d+16|1;c=0;while(1){v=Cb(d+104|0);q=64;w=32;if(k[d+284|0]>=16){j[114630]=0;E(752,d+232|0,d+16|0)|0;b=j[114630];j[114630]=0;if((b|0)==1){break D}w=k[d+16|0];b=k[O|0];j[114630]=0;I(753,d|0,3,M|0);e=j[114630];j[114630]=0;if((e|0)==1){break D}j[114630]=0;F(415,d+88|0,d|0);e=j[114630];j[114630]=0;if((e|0)==1){break D}ob(v,d+88|0);gb(d+88|0);q=b+1|0}j[114630]=0;b=K(402,t|0,c&65535,q|0)|0;e=j[114630];j[114630]=0;if((e|0)==1){break D}ia:{if(!b){j[114630]=0;E(338,d+232|0,w<<1)|0;b=j[114630];j[114630]=0;if((b|0)!=1){break ia}break D}b=Hb(t,c);j[114630]=0;E(495,b|0,v|0)|0;b=j[114630];j[114630]=0;if((b|0)==1){break D}x=0;if(!w){break ia}while(1){j[114630]=0;b=H(357,d+232|0)|0;e=j[114630];j[114630]=0;if((e|0)==1){break D}ja:{if(!b){break ja}if(Zc(r)>>>0<=b>>>0){break ja}y=x&65535;if(y>>>0>=l[a+480188>>1]){break ja}n=$b(r,b);rc(n);f=0;while(1){j[114630]=0;b=E(258,n|0,1)|0;e=j[114630];j[114630]=0;ka:{la:{ma:{na:{oa:{pa:{if((e|0)!=1){if(!b){break ja}b=Hb(t,c);j[114630]=0;b=K(471,b|0,f|0,y|0)|0;e=j[114630];j[114630]=0;if((e|0)==1){break D}j[114630]=0;g=H(387,n|0)|0;e=j[114630];j[114630]=0;if((e|0)==1){break D}e=g>>>2|0;switch((g&3)-1|0){case 2:break ma;case 1:break na;case 0:break oa;default:break pa}}break D}f=(e+f|0)+1|0;break ka}if(!f){f=0;break ka}g=Hb(t,c);j[114630]=0;g=K(471,g|0,f-1|0,y|0)|0;m=j[114630];j[114630]=0;if((m|0)!=1){while(1){m=k[g|0]|k[g+1|0]<<8|(k[g+2|0]<<16|k[g+3|0]<<24);h[b|0]=m;h[b+1|0]=m>>>8;h[b+2|0]=m>>>16;h[b+3|0]=m>>>24;m=k[g+4|0]|k[g+5|0]<<8;h[b+4|0]=m;h[b+5|0]=m>>>8;f=f+1|0;if(q>>>0<=f>>>0){break ka}b=p(l[a+480188>>1],6)+b|0;m=e&255;e=e-1|0;if(m){continue}break ka}}break D}if(e>>>0>=f>>>0){break la}g=Hb(t,c);j[114630]=0;e=K(471,g|0,e|0,y|0)|0;g=j[114630];j[114630]=0;if((g|0)==1){break T}g=k[e|0]|k[e+1|0]<<8|(k[e+2|0]<<16|k[e+3|0]<<24);h[b|0]=g;h[b+1|0]=g>>>8;h[b+2|0]=g>>>16;h[b+3|0]=g>>>24;e=k[e+4|0]|k[e+5|0]<<8;h[b+4|0]=e;h[b+5|0]=e>>>8;break la}if(e&1){j[114630]=0;g=H(387,n|0)|0;m=j[114630];j[114630]=0;if((m|0)==1){break T}h[b|0]=g>>>0>120?-1:g}if(e&2){j[114630]=0;g=H(387,n|0)|0;m=j[114630];j[114630]=0;if((m|0)==1){break T}h[b+1|0]=g}o=0;g=0;if(e&4){j[114630]=0;g=H(387,n|0)|0;m=j[114630];j[114630]=0;if((m|0)==1){break D}}B=0;if(e&8){j[114630]=0;m=H(387,n|0)|0;o=j[114630];j[114630]=0;if((o|0)==1){break D}B=m>>>4|0;o=m&15}J=0;m=0;if(e&16){j[114630]=0;m=H(387,n|0)|0;u=j[114630];j[114630]=0;if((u|0)==1){break D}}if(e&32){j[114630]=0;J=H(387,n|0)|0;e=j[114630];j[114630]=0;if((e|0)==1){break D}}j[114630]=0;aa(754,b|0,g|0,o|0,B|0,m|0,J|0);b=j[114630];j[114630]=0;if((b|0)==1){break D}}f=f+1|0}if(f>>>0<q>>>0){continue}break}}x=x+1|0;if((x&65535)>>>0<w>>>0){continue}break}}gb(v);c=c+1|0;if((s|0)!=(c|0)){continue}break}}j[114630]=0;I(743,d+16|0,d+248|0,20048);b=j[114630];j[114630]=0;qa:{ra:{sa:{if((b|0)!=1){b=Ed(d+232|0,d+16|0);j[114630]=0;b=H(337,b|0)|0;c=j[114630];j[114630]=0;if((c|0)==1){break sa}jb(d+16|0);if(!b){break z}a=a+484344|0;if(!me(a)){break z}while(1){j[114630]=0;b=E(258,d+232|0,16)|0;c=j[114630];j[114630]=0;if((c|0)==1){break ra}if(!b){break z}j[114630]=0;K(755,d+232|0,d+16|0,16)|0;b=j[114630];j[114630]=0;if((b|0)==1){break qa}b=Hb(a,0);j[114630]=0;E(756,b|0,d+16|0)|0;b=j[114630];j[114630]=0;if((b|0)==1){break qa}if(me(a)){continue}break}break z}b=D()|0;C()|0;break B}b=D()|0;C()|0;jb(d+16|0);break B}b=D()|0;C()|0;break B}b=D()|0;C()|0;break B}b=D()|0;C()|0;break B}b=D()|0;C()|0;break o}b=D()|0;C()|0;break B}b=D()|0;C()|0;break B}break D}break n}b=D()|0;C()|0;break c}b=D()|0;C()|0;gb(v);break B}b=D()|0;C()|0}Sc(r);break c}b=D()|0;C()|0;break o}Sc(r)}jb(d+232|0);Jy(d+248|0);jb(L)}Za=d+288|0;return A|0}b=D()|0;C()|0;break o}b=D()|0;C()|0;break o}b=D()|0;C()|0;jb(d+40|0);break o}b=D()|0;C()|0;jb(d+56|0);break o}b=D()|0;C()|0;jb(d+72|0);break o}b=D()|0;C()|0;break o}b=D()|0;C()|0;break c}b=D()|0;C()|0}$m(o);$m(r);$m(q);break c}b=D()|0;C()|0;jb(d+16|0);break c}b=D()|0;C()|0;break c}b=D()|0;C()|0;break c}b=D()|0;C()|0;break c}b=D()|0;C()|0;break c}b=D()|0;C()|0;gb(d+120|0);break c}b=D()|0;C()|0;break c}b=D()|0;C()|0;break c}b=D()|0;C()|0;gb(d+104|0);break d}b=D()|0;C()|0}gb(e)}jb(d+232|0)}Jy(d+248|0)}jb(L);G(b|0);z()}function dF(a,b,c,d,e,f,g){var n=0,o=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0;L=Za-144|0;Za=L;a:{b:{c:{if(d>>>0<=e>>>0){q=j[f>>2];N=g&4;M=N?-1:q+((d^-1)+e|0)|0;F=M+1|0;if(!(F&M)){break c}}j[f>>2]=0;j[c>>2]=0;r=-3;break b}G=e+q|0;E=j[c>>2];B=E+b|0;H=j[a+60>>2];y=j[a+40>>2];q=j[a+36>>2];C=j[a+32>>2];t=j[a+56>>2];o=j[a+4>>2];s=b;w=e;A=-1;r=-1;d:{e:{f:{g:{h:{i:{j:{k:{l:{m:{n:{o:{p:{q:{r:{s:{t:{u:{v:{w:{x:{y:{z:{A:{B:{C:{D:{E:{F:{G:{H:{I:{J:{K:{L:{M:{N:{O:{x=j[a>>2];switch(x|0){case 35:break i;case 17:break j;case 21:break k;case 37:break l;case 34:break m;case 42:break q;case 41:break r;case 53:break s;case 52:break t;case 51:break u;case 38:break v;case 27:break w;case 26:break x;case 25:break y;case 24:break z;case 23:break A;case 18:break B;case 16:break C;case 14:break D;case 11:break E;case 9:break F;case 7:break G;case 6:break H;case 3:break I;case 32:break J;case 5:break K;case 2:break M;case 1:break N;case 0:break O;case 36:break f;case 39:break g;case 10:break h;default:break d}}j[a+28>>2]=1;t=0;j[a+8>>2]=0;j[a+12>>2]=0;j[a+16>>2]=1;y=0;q=0;C=0;o=0;if(g&1){break N}break L}if((E|0)<=0){j[a>>2]=1;break e}j[a+8>>2]=k[b|0];s=b+1|0}if(s>>>0>=B>>>0){j[a>>2]=2;r=g&2?1:-4;break d}q=k[s|0];j[a+12>>2]=q;n=j[a+8>>2];r=(((q|n<<8)>>>0)%31|q&32)!=0|(n&15)!=8;q=1;s=s+1|0;if(!N){x=36;n=256<<(n>>>4);if(!(r|(n>>>0>32768|n>>>0>F>>>0))){break L}break f}x=36;if(r){break f}}n=0;break p}if((E|0)<=0){j[a>>2]=5;break e}s=b+1|0;t=k[b|0]<<o|t;o=o+8|0;n=2;break p}if((E|0)<=0){j[a>>2]=32;break e}s=b+1|0;t=k[b|0]<<o|t;D=q;o=o+8|0;break o}n=1;break p}n=4;break p}n=3;break p}n=7;break p}n=9;break p}n=10;break p}n=11;break p}n=12;break p}n=13;break p}n=14;break p}n=15;break p}n=16;break p}n=17;break p}n=8;break p}n=5;break p}n=6;break p}n=18;break p}u=2;break n}u=1;break n}P:while(1){Q:{R:{S:{T:{U:{V:{W:{X:{Y:{Z:{_:{$:{aa:{ba:{ca:{da:{ea:{fa:{ga:{ha:{ia:{ja:{ka:{la:{ma:{na:{oa:{pa:{qa:{ra:{sa:{ta:{ua:{va:{wa:{xa:{ya:{za:{Aa:{Ba:{Ca:{Da:{Ea:{Fa:{Ga:{switch(n|0){case 0:q=D;if(o>>>0>2){break Fa}n=1;continue;case 17:break na;case 16:break oa;case 15:break pa;case 14:break qa;case 13:break ra;case 12:break sa;case 11:break ta;case 10:break ua;case 9:break va;case 8:break xa;case 7:break ya;case 6:break za;case 5:break Aa;case 4:break Ca;case 3:break Da;case 2:break Ea;case 1:break Ga;default:break ma}}while(1){if(s>>>0>=B>>>0){j[a>>2]=3;r=g&2?1:-4;break d}t=k[s|0]<<o|t;n=s+1|0;s=n;o=o+8|0;if(o>>>0<3){continue}break}s=n;D=q}q=t&7;j[a+20>>2]=q;I=1;n=q>>>1|0;j[a+24>>2]=n;o=o-3|0;t=t>>>3|0;r=0;q=D;switch(n|0){case 0:break la;case 1:break wa;case 3:break h;default:break ia}}n=o&-8;t=t>>>(o&7)|0;q=0;o=0;break ja}if(s>>>0<B>>>0){break Ba}j[a>>2]=7;r=g&2?1:-4;break d}while(1){if(s>>>0>=B>>>0){j[a>>2]=6;r=g&2?1:-4;break d}t=k[s|0]<<o|t;v=o>>>0>4294967287;r=s+1|0;s=r;n=o+8|0;o=n;if(v){continue}break}s=r;o=1;break ja}h[(a+q|0)+10528|0]=k[s|0];s=s+1|0;n=o;o=2;break ja}while(1){if(s>>>0>=B>>>0){j[a>>2]=51;r=g&2?1:-4;break d}t=k[s|0]<<o|t;v=o>>>0>4294967287;r=s+1|0;s=r;n=o+8|0;o=n;if(v){continue}break}s=r;break S}if(w>>>0<G>>>0){h[w|0]=C;q=q-1|0;w=w+1|0;n=o;break W}A=2;x=52;break f}if(w>>>0<G>>>0){break ka}A=2;x=9;break f}if(s>>>0>=B>>>0){j[a>>2]=38;r=g&2?1:-4;break d}n=G-w|0;r=B-s|0;n=n>>>0<r>>>0?n:r;n=n>>>0<q>>>0?n:q;q=q-n|0;w=Vb(w,s,n)+n|0;s=n+s|0;break V}j[a+44>>2]=288;j[a+48>>2]=32;n=a+3552|0;j[n>>2]=84215045;j[n+4>>2]=84215045;n=a+3560|0;j[n>>2]=84215045;j[n+4>>2]=84215045;n=a+3568|0;j[n>>2]=84215045;j[n+4>>2]=84215045;n=a+3576|0;j[n>>2]=84215045;j[n+4>>2]=84215045;Ab(a- -64|0,8,144);Ab(a+208|0,9,112);h[a+336|0]=7;h[a+337|0]=7;h[a+338|0]=7;h[a+339|0]=7;h[a+340|0]=7;h[a+341|0]=7;h[a+342|0]=7;h[a+343|0]=7;h[a+328|0]=7;h[a+329|0]=7;h[a+330|0]=7;h[a+331|0]=7;h[a+332|0]=7;h[a+333|0]=7;h[a+334|0]=7;h[a+335|0]=7;h[a+320|0]=7;h[a+321|0]=7;h[a+322|0]=7;h[a+323|0]=7;h[a+324|0]=7;h[a+325|0]=7;h[a+326|0]=7;h[a+327|0]=7;h[a+344|0]=8;h[a+345|0]=8;h[a+346|0]=8;h[a+347|0]=8;h[a+348|0]=8;h[a+349|0]=8;h[a+350|0]=8;h[a+351|0]=8;break _}while(1){if(s>>>0>=B>>>0){j[a>>2]=11;r=g&2?1:-4;break d}t=k[s|0]<<o|t;r=s+1|0;s=r;n=o+8|0;o=n;J=h[q+42412|0];if(n>>>0<J>>>0){continue}break}s=r;r=q;o=n;q=1;break aa}while(1){if(s>>>0>=B>>>0){j[a>>2]=14;r=g&2?1:-4;break d}t=k[s|0]<<o|t;n=s+1|0;s=n;o=o+8|0;if(o>>>0<3){continue}break}s=n;n=1;break $}if(s>>>0>=B>>>0){j[a>>2]=16;r=g&2?1:-4;break d}t=k[s|0]<<o|t;s=s+1|0;o=o+8|0;if(o>>>0<15){break ha}break ga}while(1){if(s>>>0>=B>>>0){j[a>>2]=18;r=g&2?1:-4;break d}t=k[s|0]<<o|t;n=s+1|0;s=n;o=o+8|0;if(y>>>0>o>>>0){continue}break}O=C-16|0;s=n;n=3;break Z}if(s>>>0>=B>>>0){j[a>>2]=23;r=g&2?1:-4;break d}t=k[s|0]<<o|t;s=s+1|0;o=o+8|0;if(o>>>0<15){break fa}break ea}if(w>>>0>=G>>>0){A=2;x=24;break f}h[w|0]=q;w=w+1|0;u=t;break Y}while(1){if(s>>>0>=B>>>0){j[a>>2]=25;r=g&2?1:-4;break d}t=k[s|0]<<o|t;n=s+1|0;s=n;o=o+8|0;if(y>>>0>o>>>0){continue}break}s=n;n=3;break X}if(s>>>0>=B>>>0){j[a>>2]=26;r=g&2?1:-4;break d}t=k[s|0]<<o|t;s=s+1|0;o=o+8|0;if(o>>>0<15){break da}break ca}while(1){if(s>>>0>=B>>>0){j[a>>2]=27;r=g&2?1:-4;break d}t=k[s|0]<<o|t;n=s+1|0;s=n;o=o+8|0;if(y>>>0>o>>>0){continue}break}s=n;n=6;break X}if(w>>>0>=G>>>0){A=2;x=53;break f}h[w|0]=k[(H-C&M)+d|0];w=w+1|0;H=H+1|0;break ba}n=2;continue}n=8;continue}while(1){Ha:{Ia:{Ja:{Ka:{La:{switch(o|0){case 0:if(q>>>0>3){break Ka}if(!n){o=0;n=3;continue P}o=n;if(n>>>0>7){break Ia}n=4;continue P;case 1:h[(a+q|0)+10528|0]=t;n=n-8|0;t=t>>>8|0;break Ha;default:break La}}q=q+1|0;break Ja}o=n;q=l[a+10528>>1];if((q|0)==(l[a+10530>>1]^65535)){break W}break g}o=0;continue}o=1;continue}o=2;continue}}q=0;break aa}n=1;break Z}n=2;break Z}n=0;break X}n=1;break X}n=4;break X}n=5;break X}n=7;break X}while(1){Ma:{Na:{Oa:{if(!q){if(r>>>0>2){break Oa}q=r;J=h[q+42412|0];if(J>>>0<=o>>>0){break Ma}n=9;continue P}q=r<<2;j[(q+a|0)+44>>2]=j[q+42400>>2]+((-1<<J^-1)&t);r=r+1|0;o=o-J|0;t=t>>>J|0;break Na}q=0;Ab(a+7040|0,0,288);n=0;break $}q=0;continue}q=1;continue}}while(1){Pa:{Qa:{Ra:{if(!n){if(m[a+52>>2]<=q>>>0){break Ra}if(o>>>0>2){break Pa}n=10;continue P}h[(k[q+42464|0]+a|0)+7040|0]=t&7;q=q+1|0;o=o-3|0;t=t>>>3|0;break Qa}j[a+52>>2]=19;I=j[a+24>>2];D=q;break _}n=0;continue}n=1;continue}}n=0}while(1){Sa:{Ta:{Ua:{Va:{Wa:{Xa:{Ya:{Za:{_a:{switch(n|0){case 0:q=0;if((I|0)<0){u=t;q=D;break Y}E=Ab(L,0,64);r=p(I,3488)+a|0;Ab(r+352|0,0,3200);x=j[a+24>>2];n=j[((x<<2)+a|0)+44>>2];if(n){while(1){v=E+(k[(q+r|0)- -64|0]<<2)|0;j[v>>2]=j[v>>2]+1;q=q+1|0;if((n|0)!=(q|0)){continue}break}}j[E+64>>2]=0;j[E+68>>2]=0;v=0;r=0;q=1;while(1){A=q<<2;q=q+1|0;A=j[A+E>>2];v=A+v<<1;j[(E- -64|0)+(q<<2)>>2]=v;r=r+A|0;if((q|0)!=16){continue}break}if(!((v|0)==65536|r>>>0<2)){q=D;break i}if(n){n=-1;F=0;K=p(I,3488)+a|0;while(1){x=k[(F+K|0)- -64|0];$a:{if(!x){break $a}r=(E- -64|0)+(x<<2)|0;q=j[r>>2];j[r>>2]=q+1;r=0;v=x;while(1){A=r;r=q&1|r<<1;q=q>>>1|0;v=v-1|0;if(v){continue}break}if(x>>>0<=10){if(r>>>0>1023){break $a}q=x<<9|F;v=1<<x;while(1){i[((r<<1)+K|0)+352>>1]=q;r=r+v|0;if(r>>>0<1024){continue}break}break $a}r=((r&1023)<<1)+K|0;q=i[r+352>>1];ab:{if(q){r=n;n=q;break ab}i[r+352>>1]=n;r=n-2|0}q=A>>>8&8388607;if(x>>>0>=12){while(1){q=q>>>1|0;v=(((q&1)+(n^-1)<<1)+K|0)+2400|0;n=i[v>>1];if(!n){i[v>>1]=r;n=r;r=n-2|0}x=x-1|0;if(x>>>0>11){continue}break}}i[(((q>>>1&1)+(n^-1)<<1)+K|0)+2400>>1]=F;n=r}F=F+1|0;x=j[a+24>>2];if(F>>>0<m[((x<<2)+a|0)+44>>2]){continue}break}}q=0;if((x|0)!=2){break Ta}break Xa;case 1:n=i[(((t&1023)<<1)+a|0)+7328>>1];bb:{if((n|0)>=0){if((n>>9)-1>>>0>=o>>>0){break bb}break Wa}if(o>>>0<11){break bb}r=10;while(1){n=i[(((t>>>r&1)+(n^-1)<<1)+a|0)+9376>>1];if((n|0)<=-1){v=r+2|0;r=r+1|0;if(o>>>0>=v>>>0){continue}}break}if((n|0)>-1){break Wa}}n=11;continue P;case 2:r=i[(((t&1023)<<1)+a|0)+7328>>1];if((r|0)>=0){break Za}n=10;while(1){v=t>>>n|0;n=n+1|0;r=i[(((v&1)+(r^-1)<<1)+a|0)+9376>>1];if((r|0)<0){continue}break}break Ya;default:break _a}}n=h[O+42420|0]+((-1<<y^-1)&t)|0;o=o-y|0;t=t>>>y|0;r=a+q|0;Ab(r+10532|0,(C|0)==16?k[r+10531|0]:0,n);q=n+q|0;break Xa}n=r>>9;r=r&511}o=o-n|0;t=t>>>n|0;C=r;if(r>>>0>15){break Va}h[(a+q|0)+10532|0]=C;q=q+1|0}r=j[a+48>>2];n=j[a+44>>2];v=r+n|0;if(v>>>0<=q>>>0){break Ua}if(o>>>0>14){break Wa}if((B-s|0)<=1){n=1;continue}t=k[s|0]<<o|t|k[s+1|0]<<o+8;o=o+16|0;s=s+2|0}n=2;continue}if(!((C|0)!=16|q)){C=16;q=0;break j}O=C-16|0;y=h[O+42416|0];if(y>>>0<=o>>>0){break Sa}n=12;continue P}if((q|0)!=(v|0)){break k}D=a+10532|0;Vb(a- -64|0,D,n);Vb(a+3552|0,n+D|0,r);x=j[a+24>>2];D=q}I=x-1|0;j[a+24>>2]=I;n=0;continue}n=3;continue}}n=2}cb:while(1){db:{eb:{fb:{gb:{hb:{ib:{jb:{kb:{lb:{mb:{nb:{ob:{pb:{qb:{rb:{switch(n|0){case 0:n=i[(((t&1023)<<1)+a|0)+352>>1];sb:{if((n|0)>=0){if((n>>9)-1>>>0>=o>>>0){break sb}break db}if(o>>>0<11){break sb}r=10;while(1){n=i[(((t>>>r&1)+(n^-1)<<1)+a|0)+2400>>1];if((n|0)<=-1){v=r+2|0;r=r+1|0;if(o>>>0>=v>>>0){continue}}break}if((n|0)>-1){break db}}n=13;continue P;case 1:r=i[(((t&1023)<<1)+a|0)+352>>1];if((r|0)>=0){break qb}n=10;while(1){q=t>>>n|0;n=n+1|0;r=i[(((q&1)+(r^-1)<<1)+a|0)+2400>>1];if((r|0)<0){continue}break}q=r;break pb;case 3:break gb;case 4:break hb;case 5:break lb;case 6:break mb;case 2:break rb;default:break nb}}while(1){n=B-s|0;if(!((G-w|0)>1?(n|0)>=4:0)){if(o>>>0>14){t=u;break db}if((n|0)<=1){t=u;n=0;continue cb}t=k[s|0]<<o|u|k[s+1|0]<<o+8;o=o+16|0;s=s+2|0;break db}tb:{if(o>>>0>14){t=o;n=s;break tb}t=o+16|0;u=(k[s|0]|k[s+1|0]<<8)<<o|u;n=s+2|0}q=i[(((u&1023)<<1)+a|0)+352>>1];ub:{if((q|0)<0){s=10;while(1){o=u>>>s|0;s=s+1|0;q=i[(((o&1)+(q^-1)<<1)+a|0)+2400>>1];if((q|0)<0){continue}break}break ub}s=q>>9}o=t-s|0;t=u>>>s|0;if(q&256){s=n;break ob}if(o>>>0>14){r=o}else{t=(k[n|0]|k[n+1|0]<<8)<<o|t;n=n+2|0;r=o+16|0}s=n;n=i[(((t&1023)<<1)+a|0)+352>>1];vb:{if((n|0)<0){u=10;while(1){o=t>>>u|0;u=u+1|0;n=i[(((o&1)+(n^-1)<<1)+a|0)+2400>>1];if((n|0)<0){continue}break}break vb}u=n>>9}h[w|0]=q;o=r-u|0;u=t>>>u|0;if(!(n&256)){h[w+1|0]=n;w=w+2|0;continue}break}w=w+1|0;t=u;q=n;break ob}n=r>>9;q=r&511}o=o-n|0;t=t>>>n|0;if(q>>>0>255){break ob}n=14;continue P}D=256;r=q&511;n=256;if((r|0)==256){break U}y=0;n=t;v=(r<<2)-1028|0;q=j[v+41888>>2];A=q;if(r-265>>>0>19){break fb}y=j[v+42016>>2];if(y>>>0>o>>>0){n=15;continue P}n=3;continue}if(!q){u=t;q=-1;break jb}q=q-1|0;n=18;continue P}o=o-y|0;u=t>>>y|0;C=((-1<<y^-1)&t)+C|0;break kb}y=i[(((t&1023)<<1)+a|0)+3840>>1];wb:{if((y|0)<0){n=10;while(1){r=t>>>n|0;n=n+1|0;y=i[(((r&1)+(y^-1)<<1)+a|0)+5888>>1];if((y|0)<0){continue}break}r=y;break wb}n=y>>9;r=y&511}v=r<<2;C=j[v+42144>>2];o=o-n|0;t=t>>>n|0;y=0;if(r-4>>>0>25){u=t;break kb}y=j[v+42272>>2];if(y>>>0<=o>>>0){break ib}n=17;continue P}H=w-d|0;if(!(!N|H>>>0>=C>>>0)){t=u;break l}n=(H-C&M)+d|0;if((n>>>0<w>>>0?w:n)+q>>>0>G>>>0){t=u;n=7;continue}if(q>>>0>2){while(1){h[w|0]=k[n|0];h[w+1|0]=k[n+1|0];h[w+2|0]=k[n+2|0];n=n+3|0;w=w+3|0;q=q-3|0;if(q>>>0>2){continue}break}}if(!q){break jb}h[w|0]=k[n|0];if((q|0)!=1){h[w+1|0]=k[n+1|0]}w=q+w|0}n=2;continue}n=6;continue}n=i[(((t&1023)<<1)+a|0)+3840>>1];xb:{if((n|0)>=0){if((n>>9)-1>>>0>=o>>>0){break xb}break eb}if(o>>>0<11){break xb}r=10;while(1){n=i[(((t>>>r&1)+(n^-1)<<1)+a|0)+5888>>1];if((n|0)<=-1){v=r+2|0;r=r+1|0;if(o>>>0>=v>>>0){continue}}break}if((n|0)>-1){break eb}}n=16;continue P}o=o-y|0;n=t>>>y|0;A=((-1<<y^-1)&t)+q|0}q=A;t=n;if(o>>>0>14){break eb}if((B-s|0)<=1){n=4;continue}t=t|k[s|0]<<o|k[s+1|0]<<o+8;o=o+16|0;s=s+2|0}n=5;continue}n=1;continue}}if(n?q:0){break T}o=n}if(q){break Q}n=0}D=n;if(!(h[a+20|0]&1)){break R}break o}o=n;if(n>>>0>7){break S}n=5;continue}o=n-8|0;C=t&255;t=t>>>8|0;n=6;continue}n=0;continue}n=7;continue}}u=o&-8;if(!(!u|b>>>0>=s>>>0)){q=u-8|0;d=q>>>3|0;n=(b^-1)+s|0;d=d>>>0<n>>>0?d:n;u=q-(d<<3)|0;s=(d^-1)+s|0}if(!u){t=(((u&63)>>>0>=32?0:-1<<u)^-1)&t>>>(o&7);v=0;n=0;q=D;o=0;if(!(g&1)){break m}u=0;break n}Y(42424,41856,2787,42434);z()}while(1){yb:{zb:{Ab:{Bb:{Cb:{Db:{switch(u|0){case 0:if(v>>>0>3){q=v;o=n;break m}if(n){break Cb}o=0;q=v;u=1;continue;case 1:break Db;default:break Bb}}if(s>>>0<B>>>0){break zb}j[a>>2]=42;r=g&2?1:-4;break d}q=v;o=n;if(n>>>0>7){break Ab}u=2;continue}while(1){if(s>>>0>=B>>>0){j[a>>2]=41;r=g&2?1:-4;break d}t=k[s|0]<<o|t;u=o>>>0>4294967287;d=s+1|0;s=d;n=o+8|0;o=n;if(u){continue}break}s=d;v=q}u=t&255;t=t>>>8|0;n=n-8|0;break yb}u=k[s|0];s=s+1|0;v=q;n=o}j[a+16>>2]=j[a+16>>2]<<8|u;v=v+1|0;u=0;continue}}A=0;x=34;break f}x=37;A=-1;break f}x=21;A=-1;break f}x=17;A=-1;break f}x=35;A=-1;break f}x=10;A=-1;break f}x=39;A=-1}j[a>>2]=x;if(!(o>>>0<8|b>>>0>=s>>>0)){n=o-8|0;d=n>>>3|0;o=(b^-1)+s|0;d=d>>>0<o>>>0?d:o;s=(d^-1)+s|0;o=n-(d<<3)|0}r=A;break d}r=g&2?1:-4}j[a+4>>2]=o;j[a+60>>2]=H;j[a+40>>2]=y;j[a+36>>2]=q;j[a+32>>2]=C;j[a+56>>2]=(((o&63)>>>0>=32?0:-1<<o)^-1)&t;j[c>>2]=s-b;n=w-e|0;j[f>>2]=n;if(!(g&9)|(r|0)<0){break b}b=j[a+28>>2];o=b>>>16|0;t=b&65535;if(n){q=(n>>>0)%5552|0;while(1){s=0;if(q>>>0>7){while(1){b=k[e|0]+t|0;c=b+k[e+1|0]|0;d=c+k[e+2|0]|0;f=d+k[e+3|0]|0;u=f+k[e+4|0]|0;D=u+k[e+5|0]|0;v=D+k[e+6|0]|0;t=v+k[e+7|0]|0;o=t+(v+(D+(u+(f+(d+(c+(b+o|0)|0)|0)|0)|0)|0)|0)|0;e=e+8|0;s=s+8|0;if((s|7)>>>0<q>>>0){continue}break}s=q&8184}if(q>>>0>s>>>0){b=q-s|0;u=e;while(1){t=k[u|0]+t|0;o=t+o|0;u=u+1|0;s=s+1|0;if((s|0)!=(q|0)){continue}break}e=b+e|0}n=n-q|0;o=(o>>>0)%65521|0;t=(t>>>0)%65521|0;q=5552;if(n){continue}break}}b=o<<16|t;j[a+28>>2]=b;if(r){break b}r=0;if(g&1){break a}}Za=L+144|0;return r}Za=L+144|0;return j[a+16>>2]==(b|0)?0:-2}function Txa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,n=0,o=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,J=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,W=0,X=0,Y=0,Z=0;f=Za-416|0;Za=f;rc(b);t=f+208|0;e=uxa(b,t);if(!e){cN(t)}a:{b:{c:{d:{e:{f:{g:{h:{i:{if(!e){break i}if(!gN(f+208|0)){break i}if(!c){d=1;break i}od(a,134217728);d=Db(f+192|0,17360);j[114630]=0;F(219,f+144|0,d|0);t=j[114630];j[114630]=0;j:{k:{l:{m:{n:{o:{p:{q:{if((t|0)!=1){j[114630]=0;v=f+208|4;I(999,f+16|0,f+144|0,v|0);t=j[114630];j[114630]=0;if((t|0)==1){break q}ob(a+1304436|0,f+16|0);gb(f+16|0);qb(f+144|0);gb(d);d=Db(f+16|0,17384);ob(a+1304448|0,d);gb(d);j[a+480188>>2]=4;j[a+1304496>>2]=2;d=k[f+344|0]|k[f+345|0]<<8;j[a+480196>>2]=(d<<8|d>>>8)&65535;d=k[f+348|0]|k[f+349|0]<<8;j[a+480260>>2]=56;j[a+480264>>2]=13696;Y=a,Z=fN((d<<8|d>>>8)&65535),j[Y+480204>>2]=Z;kn(Eb(a+484360|0),f+216|0,k[f+208|6],65535,65535);y=a+480190|0;w=f+176|0;Fxa(w);x=qn(f+160|0);if(k[f+408|0]|k[f+409|0]<<8){break o}break n}a=D()|0;C()|0;break p}a=D()|0;C()|0;qb(f+144|0)}gb(d);break a}t=0;while(1){j[114630]=0;d=H(484,b|0)|0;e=j[114630];j[114630]=0;if((e|0)==1){break e}i[f+120>>1]=d;if((d-1&65535)>>>0>3998){break k}d=k[f+410|0]|k[f+411|0]<<8;d=(d<<8|d>>>8)&65535;r:{if((k[v|0]|k[v+1|0]<<8)!=512){break r}j[114630]=0;d=H(493,b|0)|0;e=j[114630];j[114630]=0;if((e|0)==1){break f}d=d-2|0}j[114630]=0;I(341,f+144|0,b|0,d|0);d=j[114630];j[114630]=0;s:{t:{u:{if((d|0)!=1){j[114630]=0;d=E(452,y|0,f+120|0)|0;e=j[114630];j[114630]=0;if((e|0)==1){break u}J=l[d>>1];i[a+480190>>1]=J;j[114630]=0;d=p(l[f+120>>1],104)+a|0;u=d+484380|0;F(386,u|0,1);e=j[114630];j[114630]=0;v:{if((e|0)==1){break v}e=k[v|0]|k[v+1|0]<<8;if(((e<<8|e>>>8)&65535)>>>0>1){break t}j[114630]=0;K(1e3,f+144|0,d+484423|0,31)|0;e=j[114630];j[114630]=0;if((e|0)==1){break v}j[114630]=0;E(338,f+144|0,1)|0;e=j[114630];j[114630]=0;if((e|0)==1){break v}j[114630]=0;K(388,f+144|0,((l[f+120>>1]<<5)+a|0)+946300|0,30)|0;e=j[114630];j[114630]=0;if((e|0)!=1){break s}}a=D()|0;C()|0;break c}a=D()|0;C()|0;break b}a=D()|0;C()|0;break c}e=Cb(f+16|0);j[114630]=0;K(597,f+144|0,e|0,257)|0;q=j[114630];j[114630]=0;w:{x:{if((q|0)==1){break x}j[114630]=0;E(370,d+484423|0,e|0)|0;q=j[114630];j[114630]=0;if((q|0)==1){break x}j[114630]=0;E(338,f+144|0,1)|0;q=j[114630];j[114630]=0;if((q|0)==1){break x}j[114630]=0;K(597,f+144|0,e|0,31)|0;q=j[114630];j[114630]=0;if((q|0)==1){break x}j[114630]=0;E(369,((l[f+120>>1]<<5)+a|0)+946300|0,e|0)|0;q=j[114630];j[114630]=0;if((q|0)==1){break x}if(!(j[f+152>>2]&1)){break w}j[114630]=0;E(338,f+144|0,1)|0;q=j[114630];j[114630]=0;if((q|0)!=1){break w}}a=D()|0;C()|0;gb(e);break c}gb(e)}j[114630]=0;E(1001,f+144|0,f+16|0)|0;e=j[114630];j[114630]=0;if((e|0)==1){break m}j[114630]=0;F(1002,f+16|0,u|0);e=j[114630];j[114630]=0;if((e|0)==1){break m}if((k[v|0]|k[v+1|0]<<8)==512){h[d+484417|0]=k[f+34|0]<<3}y:{if(!(k[v|0]|k[v+1|0]<<8)){break y}j[114630]=0;F(384,x|0,J|0);e=j[114630];j[114630]=0;if((e|0)==1){break m}j[114630]=0;F(1003,w|0,J|0);e=j[114630];j[114630]=0;if((e|0)==1){break m}e=ad(w,l[f+120>>1]-1|0);ec(e);dN(e);rs(e);j[114630]=0;u=H(484,b|0)|0;q=j[114630];j[114630]=0;if((q|0)==1){break g}j[114630]=0;F(1004,e|0,u|0);q=j[114630];j[114630]=0;if((q|0)==1){break g}g=0;j[f+136>>2]=0;if(!u){if(!(k[d+484414|0]&2)){break y}u=j[d+484384>>2];j[f+128>>2]=u;d=j[d+484388>>2];j[114630]=0;j[f+132>>2]=d-u;F(1005,e|0,f+128|0);d=j[114630];j[114630]=0;if((d|0)!=1){break y}a=D()|0;C()|0;break c}while(1){j[114630]=0;d=H(493,b|0)|0;q=j[114630];j[114630]=0;if((q|0)==1){break h}j[114630]=0;j[f+128>>2]=d;d=H(493,b|0)|0;q=j[114630];j[114630]=0;if((q|0)==1){break h}j[114630]=0;j[f+132>>2]=d;F(1005,e|0,f+128|0);d=j[114630];j[114630]=0;if((d|0)==1){break h}g=g+1|0;if(u>>>0>(g&65535)>>>0){continue}break}}jb(f+144|0);t=t+1|0;d=k[f+408|0]|k[f+409|0]<<8;if((t&65535)>>>0<((d<<8|d>>>8)&65535)>>>0){continue}break}}L=128;if(k[v|0]|k[v+1|0]<<8){break l}j[114630]=0;L=H(484,b|0)|0;d=j[114630];j[114630]=0;if((d|0)!=1){break l}a=D()|0;C()|0;break b}a=D()|0;C()|0;break c}t=a+480188|0;M=k[f+208|7];i[f+126>>1]=4;z:{A:{B:{if(!(k[v|0]|k[v+1|0]<<8)){g=l[t>>1];break B}e=j[b+8>>2];C:{if(!L){break C}d=0;while(1){j[114630]=0;u=H(484,b|0)|0;q=j[114630];j[114630]=0;if((q|0)==1){break A}if((u|0)==65535){break C}j[114630]=0;M=H(484,b|0)|0;u=j[114630];j[114630]=0;if((u|0)==1){break A}j[114630]=0;u=H(484,b|0)|0;q=j[114630];j[114630]=0;if((q|0)==1){break A}j[114630]=0;i[f+126>>1]=u;u=E(452,t|0,f+126|0)|0;q=j[114630];j[114630]=0;if((q|0)==1){break A}i[t>>1]=l[u>>1];j[114630]=0;E(338,b|0,p(l[f+126>>1],M)<<2)|0;u=j[114630];j[114630]=0;if((u|0)==1){break A}d=d+1|0;if((d&65535)>>>0<L>>>0){continue}break}}d=0;j[114630]=0;E(256,b|0,e|0)|0;e=j[114630];j[114630]=0;if((e|0)==1){break z}g=l[t>>1];if(g>>>0>127){break j}}j[114630]=0;P=E(1006,f+144|0,g&65535)|0;d=j[114630];j[114630]=0;if((d|0)!=1){D:{if(!L){break D}T=a+484344|0;X=c&1;Q=k[f+347|0];t=0;u=0;while(1){d=u;if(k[v|0]|k[v+1|0]<<8){j[114630]=0;d=H(484,b|0)|0;e=j[114630];j[114630]=0;if((e|0)==1){break d}if((d|0)==65535){break D}j[114630]=0;M=H(484,b|0)|0;e=j[114630];j[114630]=0;if((e|0)==1){break d}j[114630]=0;e=H(484,b|0)|0;q=j[114630];j[114630]=0;if((q|0)==1){break d}i[f+126>>1]=e}N=M&65535;E:{F:{if(!X){break F}j[114630]=0;U=d&65535;d=K(402,T|0,U|0,N|0)|0;e=j[114630];j[114630]=0;if((e|0)==1){break d}if(!d){break F}if(!N){break E}A=0;while(1){d=Hb(T,U);j[114630]=0;r=E(496,d|0,A|0)|0;d=j[114630];j[114630]=0;G:{if((d|0)!=1){g=0;B=0;H:{I:{switch((Q&3)-1|0){case 0:B=!(A&3);break H;case 1:B=!(A&1);break H;case 2:break I;default:break H}}B=(A&3)!=3}R=0;if(!l[f+126>>1]){break G}while(1){d=j[P>>2];j[114630]=0;F(595,f+128|0,b|0);e=j[114630];j[114630]=0;if((e|0)==1){break d}o=p(g,9)+d|0;d=Pc(f+128|0);q=Bf(f+128|0);n=pi(f+128|0);s=p(g,6)+r|0;h[s+1|0]=k[f+128|0];e=k[d|0];h[s|0]=e;d=k[n|0];h[s+5|0]=d;n=s+5|0;if(e){h[s|0]=e+25;h[o+8|0]=0;h[o|0]=0;h[o+1|0]=0;h[o+2|0]=0;h[o+3|0]=0;h[o+4|0]=0;h[o+5|0]=0;h[o+6|0]=0;h[o+7|0]=0;d=k[n|0]}e=d;S=k[q|0];J:{if(S>>>0>=240){d=e|(S&15)<<8;if(d){d=fN(d);j[114630]=0;d=na(1007,+(+(d>>>0)*1e-4))|0;e=j[114630];j[114630]=0;if((e|0)!=1){h[n|0]=d;h[s+3|0]=17;break J}break d}h[s+3|0]=0;break J}O=e>>>4|0;W=e<<4;q=O|W;K:{switch(S|0){case 0:e=p(g,6)+r|0;if(d){h[e+3|0]=1;break J}h[e+3|0]=0;break J;case 1:h[(p(g,6)+r|0)+3|0]=2;break J;case 2:h[(p(g,6)+r|0)+3|0]=3;break J;case 3:j[114630]=0;h[f+16|0]=15;d=E(391,n|0,f+16|0)|0;e=j[114630];j[114630]=0;if((e|0)!=1){h[o|0]=k[d|0]|16;h[o+7|0]=0;h[o+1|0]=0;h[o+2|0]=0;h[(p(g,6)+r|0)+3|0]=0;break J}break d;case 4:j[114630]=0;h[f+16|0]=15;d=E(391,n|0,f+16|0)|0;e=j[114630];j[114630]=0;if((e|0)!=1){h[o|0]=k[d|0]|32;h[o+7|0]=0;h[o+1|0]=0;h[o+2|0]=0;h[(p(g,6)+r|0)+3|0]=0;break J}break d;case 5:h[o+7|0]=0;h[o+2|0]=0;h[o+1|0]=d;h[o|0]=0;h[(p(g,6)+r|0)+3|0]=0;break J;case 6:h[o+7|0]=0;h[o+2|0]=d;h[o|0]=0;h[o+1|0]=0;h[(p(g,6)+r|0)+3|0]=0;break J;case 7:h[(p(g,6)+r|0)+3|0]=23;t=0;break J;case 8:h[(p(g,6)+r|0)+3|0]=0;t=q;break J;case 9:h[(p(g,6)+r|0)+3|0]=19;j[114630]=0;h[f+16|0]=15;d=E(391,n|0,f+16|0)|0;e=j[114630];j[114630]=0;if((e|0)!=1){h[n|0]=k[d|0]|16;break J}break d;case 10:h[(p(g,6)+r|0)+3|0]=19;j[114630]=0;h[f+16|0]=15;d=E(391,n|0,f+16|0)|0;e=j[114630];j[114630]=0;if((e|0)!=1){h[n|0]=k[d|0]|32;break J}break d;case 11:h[o+3|0]=q;h[(p(g,6)+r|0)+3|0]=0;break J;case 12:e=p(g,6)+r|0;h[e+4|0]=d;h[e+2|0]=1;h[o+3|0]=0;h[e+3|0]=0;break J;case 13:q=p(g,6)+r|0;L:{M:{if(e&240){h[(p(g,6)+r|0)+2|0]=4;d=(d&240)>>>4|0;break M}if(!(e&15)){break L}h[(p(g,6)+r|0)+2|0]=3;d=d&15}h[q+4|0]=d}h[o+3|0]=0;h[(p(g,6)+r|0)+3|0]=0;break J;case 14:h[(p(g,6)+r|0)+3|0]=19;h[n|0]=!d;break J;case 15:h[(p(g,6)+r|0)+3|0]=16;h[n|0]=(d&240)>>>4;Q=d&15;break J;case 16:h[o+5|0]=0;h[o+4|0]=d;h[(p(g,6)+r|0)+3|0]=0;break J;case 17:h[o+6|0]=e&15?d:0;h[(p(g,6)+r|0)+3|0]=0;break J;case 18:h[(p(g,6)+r|0)+3|0]=14;break J;case 19:h[o+8|0]=0;h[o+7|0]=d;h[o+2|0]=0;h[o|0]=0;h[o+1|0]=0;h[(p(g,6)+r|0)+3|0]=0;break J;case 20:h[(p(g,6)+r|0)+3|0]=12;break J;case 22:N:{d=k[s+1|0];O:{if(!d){break O}if(ec(w)>>>0<d>>>0){break O}d=ad(w,k[s+1|0]-1|0);e=k[n|0]-1|0;h[n|0]=e;j[114630]=0;E(1008,f+16|0,0)|0;q=j[114630];j[114630]=0;if((q|0)==1){break d}j[f+120>>2]=9;d=ec(d);j[114630]=0;j[f+12>>2]=d;d=E(33,f+120|0,f+12|0)|0;q=j[114630];j[114630]=0;if((q|0)==1){break N}if(m[d>>2]<=(e&255)>>>0){break O}d=p(g,6)+r|0;h[d+2|0]=15;h[d+4|0]=k[n|0]}h[(p(g,6)+r|0)+3|0]=0;break J}break d;case 23:d=k[s+1|0];P:{if(!d){break P}if(ec(w)>>>0<d>>>0){break P}d=ad(w,k[s+1|0]-1|0);e=k[n|0]-1|0;h[n|0]=e;if(ec(d)>>>0<=(e&255)>>>0){break P}Q:{if(l[ad(d,k[n|0])+8>>1]){break Q}if(!fn(a)){break Q}e=l[y>>1]+1|0;i[y>>1]=e;Y=ad(d,k[n|0]),Z=e,i[Y+8>>1]=Z}Y=s,Z=k[ad(d,k[n|0])+8|0],h[Y+1|0]=Z}h[(p(g,6)+r|0)+3|0]=0;break J;case 24:R:{d=k[s+1|0];S:{if(!d){break S}if(ec(w)>>>0<d>>>0){break S}d=ad(w,k[s+1|0]-1|0);e=k[n|0]-1|0;h[n|0]=e;j[114630]=0;E(1008,f+16|0,0)|0;q=j[114630];j[114630]=0;if((q|0)==1){break d}j[f+120>>2]=9;d=ec(d);j[114630]=0;j[f+12>>2]=d;d=E(33,f+120|0,f+12|0)|0;q=j[114630];j[114630]=0;if((q|0)==1){break R}if(m[d>>2]>(e&255)>>>0){d=p(g,6)+r|0;h[d+2|0]=15;h[d+4|0]=k[n|0]}T:{if(l[bc(x,k[s+1|0]-1|0)>>1]){break T}if(!fn(a)){break T}d=l[y>>1]+1|0;i[y>>1]=d;Y=bc(x,k[s+1|0]-1|0),Z=d,i[Y>>1]=Z}Y=s,Z=k[bc(x,k[s+1|0]-1|0)|0],h[Y+1|0]=Z}h[(p(g,6)+r|0)+3|0]=0;break J}break d;case 25:d=k[s+1|0];U:{if(!d){break U}if(ec(w)>>>0<d>>>0){break U}d=ad(w,k[s+1|0]-1|0);e=k[n|0]-1|0;h[n|0]=e;if(ec(d)>>>0<=(e&255)>>>0){break U}V:{if(l[ad(d,k[n|0])+10>>1]){break V}if(!fn(a)){break V}e=l[y>>1]+1|0;i[y>>1]=e;Y=ad(d,k[n|0]),Z=e,i[Y+10>>1]=Z}Y=s,Z=k[ad(d,k[n|0])+10|0],h[Y+1|0]=Z}h[(p(g,6)+r|0)+3|0]=0;break J;case 29:h[(p(g,6)+r|0)+3|0]=11;h[n|0]=q;if(e&15){h[n|0]=W|15;break J}if(!O){break J}h[n|0]=O|240;break J;case 32:if(e&240){h[o+3|0]=O;h[(p(g,6)+r|0)+3|0]=0;break J}h[(p(g,6)+r|0)+3|0]=19;h[n|0]=d&15|192;break J;case 33:h[(p(g,6)+r|0)+3|0]=19;j[114630]=0;h[f+16|0]=15;d=E(391,n|0,f+16|0)|0;e=j[114630];j[114630]=0;if((e|0)!=1){h[n|0]=k[d|0]|208;break J}break d;case 34:h[(p(g,6)+r|0)+3|0]=19;j[114630]=0;h[f+16|0]=15;d=E(391,n|0,f+16|0)|0;e=j[114630];j[114630]=0;if((e|0)!=1){h[n|0]=k[d|0]|144;break J}break d;case 73:h[(p(g,6)+r|0)+3|0]=10;break J;case 78:if((d&112|128)==224){h[(p(g,6)+r|0)+3|0]=19;break J}h[(p(g,6)+r|0)+3|0]=0;break J;case 79:e=p(g,6)+r|0;if(d>>>0<=31){h[e+3|0]=16;Q=0;break J}h[e+3|0]=17;break J;default:break K}}h[(p(g,6)+r|0)+3|0]=0}d=0;e=k[o+3|0];if(!(k[s+2|0]|!e)){W:{if(e>>>0>=16){h[s+2|0]=5;h[s+4|0]=e>>>4;break W}h[s+2|0]=6;h[s+4|0]=e}d=1}X:{if(k[s+3|0]){break X}e=k[o+1|0];if(e){h[s+3|0]=2;h[n|0]=e;break X}e=k[o+2|0];if(e){h[s+3|0]=3;h[n|0]=e;break X}e=k[o|0];if(e){h[s+3|0]=19;h[n|0]=e;break X}e=k[o+7|0];if(e){h[s+3|0]=4;h[o+8|0]=e;h[n|0]=e;break X}e=k[o+4|0];if(e){h[s+3|0]=5;h[o+5|0]=e;h[n|0]=e;break X}e=d;d=k[o+3|0];if(!(e|!d)){h[s+3|0]=11;h[n|0]=d;if(d&15){h[n|0]=d|240;break X}if(!(d&240)){break X}h[n|0]=d|15;break X}d=k[o+6|0];if(d){h[s+3|0]=8;h[n|0]=d;break X}if(B){h[s+3|0]=20;h[n|0]=97;B=0;break X}B=0;d=t&255;if(!d|R){break X}h[s+3|0]=24;h[n|0]=t;if(t&15){h[n|0]=t|240;R=1;break X}R=1;if(!(d&240)){break X}h[n|0]=t|15}g=g+1|0;if(g>>>0<l[f+126>>1]){continue}break}break G}break d}A=A+1|0;if((N|0)!=(A|0)){continue}break}break E}j[114630]=0;E(338,b|0,p(l[f+126>>1],N)<<2)|0;d=j[114630];j[114630]=0;if((d|0)!=1){break E}break d}u=u+1|0;if((u&65535)>>>0<L>>>0){continue}break}}j[a+480228>>2]=256/l[a+480188>>1];j[114630]=0;F(449,a|0,1);d=j[114630];j[114630]=0;if((d|0)==1){break d}if(k[v|0]|k[v+1|0]<<8){Y:{while(1){j[114630]=0;d=E(258,b|0,2)|0;t=j[114630];j[114630]=0;if((t|0)==1){break d}if(!d){break Y}j[114630]=0;d=H(484,b|0)|0;t=j[114630];j[114630]=0;if((t|0)==1){break d}if((d|0)==65535){break Y}j[114630]=0;E(338,b|0,2)|0;d=j[114630];j[114630]=0;if((d|0)==1){break d}j[114630]=0;d=H(493,b|0)|0;t=j[114630];j[114630]=0;if((t|0)!=1){j[114630]=0;E(338,b|0,d|0)|0;d=j[114630];j[114630]=0;if((d|0)!=1){continue}}break}break d}j[114630]=0;E(338,b|0,34)|0;d=j[114630];j[114630]=0;if((d|0)==1){break d}}Z:{if(!(!(c&2)|!J)){d=1;t=1;while(1){c=(p(d,104)+a|0)+484380|0;_:{if(!j[c>>2]){break _}e=Kc(f+16|0,8,1,0,0);j[114630]=0;K(400,e|0,c|0,b|0)|0;e=j[114630];j[114630]=0;if((e|0)==1){break Z}if(ec(w)>>>0<d>>>0){break _}d=d-1|0;e=ad(w,d);j[114630]=0;F(1009,c|0,e|0);e=j[114630];j[114630]=0;$:{if((e|0)!=1){if(!l[bc(x,d)>>1]){break $}e=l[bc(x,d)>>1];u=j[c>>2];j[114630]=0;V(1010,c|0,(p(e,104)+a|0)+484380|0,0,u|0,0);e=j[114630];j[114630]=0;if((e|0)!=1){break $}}break d}d=ad(w,d);Y=f,Z=Lb(d),j[Y+16>>2]=Z;Y=f,Z=Mb(d),j[Y+128>>2]=Z;if(!rb(f+16|0,f+128|0)){break _}while(1){d=j[f+16>>2];e=l[d+8>>1];if(e){u=j[d+4>>2];q=j[d>>2];j[114630]=0;V(1010,c|0,(p(e,104)+a|0)+484380|0,q|0,u|0,1);e=j[114630];j[114630]=0;if((e|0)==1){break d}}e=l[d+10>>1];if(e){u=j[d+4>>2];d=j[d>>2];j[114630]=0;V(1010,c|0,(p(e,104)+a|0)+484380|0,d|0,u|0,0);d=j[114630];j[114630]=0;if((d|0)==1){break d}}cn(f+16|0);if(rb(f+16|0,f+128|0)){continue}break}}t=t+1|0;d=t&65535;if(J>>>0>=d>>>0){continue}break}}Xx(P);d=1;break j}break d}a=D()|0;C()|0;break b}a=D()|0;C()|0;break b}a=D()|0;C()|0;break b}d=0}ff(x);eN(w)}Za=f+416|0;return d|0}a=D()|0;C()|0;break c}a=D()|0;C()|0;break c}a=D()|0;C()|0;break b}a=D()|0;C()|0;break b}a=D()|0;C()|0;Xx(P);break b}jb(f+144|0)}ff(x);eN(w)}G(a|0);z()}function v5(a){var b=0,c=0,d=0,e=0,f=0,g=0,o=0,r=0,s=0,t=0,u=0,v=0,w=q(0),x=q(0),y=0,A=0,B=0,C=0,D=q(0);t=Za-1024|0;Za=t;h[a+1377|0]=1;a:{if(!Wq(a)){break a}e=k[a+1375|0];if(!(e&2)){Nb(a,34);break a}if(e&4){Nb(a,34);break a}if(e&1){Nb(a,34);break a}if(j[a+1116>>2]!=1){Nb(a,34);break a}e=k[a+1120|0];if((e|0)!=30){b:{if((e|0)!=64){break b}if(!Dv(a,t+1018|0,6)|k[t+1018|0]!=102|(k[t+1019|0]!=105|k[t+1020|0]!=115)){break b}if(k[t+1021|0]!=104|k[t+1022|0]!=101|k[t+1023|0]!=97){break b}if((he(a)|0)!=100){break b}if(he(a)){break b}Nb(a,38);break a}Nb(a,34);break a}if((he(a)|0)!=1){Nb(a,34);break a}if(!Dv(a,t+1018|0,6)){Nb(a,10);break a}if(!Cv(t+1018|0)){Nb(a,34);break a}if(Nh(a)){Nb(a,34);break a}e=he(a);j[a+4>>2]=e;if(!e){Nb(a,34);break a}if(e>>>0>=17){Nb(a,5);break a}e=Nh(a);j[a>>2]=e;if(!e){Nb(a,34);break a}Nh(a);Nh(a);Nh(a);e=he(a);d=e>>>4|0;j[a+116>>2]=1<<d;c=e&15;j[a+112>>2]=1<<c;if(c-6>>>0>=8){Nb(a,20);break a}if((e<<24)-1610612736>>24<=-1){Nb(a,20);break a}if(c>>>0>d>>>0){Nb(a,20);break a}if(!(he(a)&1)){Nb(a,34);break a}if(!Wq(a)){break a}if(!Bv(a)){break a}if(!Av(a)){break a}c:{d:{if((pg(a)|0)==3){while(1){B=(t+1018|0)+b|0,C=pg(a),h[B|0]=C;b=b+1|0;if((b|0)!=6){continue}break}if(!Cv(t+1018|0)){Nb(a,20);break c}d=zv(a);c=Ad(a,d+1|0);j[a+20>>2]=c;if(c){b=0;e=0;if((d|0)>0){while(1){c=pg(a);h[j[a+20>>2]+b|0]=c;b=b+1|0;if((d|0)!=(b|0)){continue}break}c=j[a+20>>2]}h[c+d|0]=0;b=zv(a);j[a+24>>2]=b;b=Ad(a,b<<2);j[a+28>>2]=b;c=j[a+24>>2];e:{if(!b){b=0;if((c|0)>0){break e}}f:{if((c|0)>0){while(1){d=zv(a);b=Ad(a,d+1|0);f=e<<2;j[f+j[a+28>>2]>>2]=b;c=j[f+j[a+28>>2]>>2];if(!c){break f}b=0;if((d|0)>0){while(1){c=pg(a);h[j[f+j[a+28>>2]>>2]+b|0]=c;b=b+1|0;if((d|0)!=(b|0)){continue}break}c=j[f+j[a+28>>2]>>2]}h[c+d|0]=0;e=e+1|0;if((e|0)<j[a+24>>2]){continue}break}}if(!(pg(a)&1)){Nb(a,20);break c}RE(a,k[a+1376|0]);h[a+1376|0]=0;while(1){b=Av(a);RE(a,b);h[a+1376|0]=0;if(b){continue}break}b=0;if(!Bv(a)){break a}if(!SE(a)){if(j[a+100>>2]!=21){break a}j[a+100>>2]=20;break a}u5();if((pg(a)|0)==5){while(1){B=(t+1018|0)+b|0,C=pg(a),h[B|0]=C;b=b+1|0;if((b|0)!=6){continue}break}if(!Cv(t+1018|0)){Nb(a,20);break c}b=Tb(a,8)+1|0;j[a+120>>2]=b;b=Ad(a,p(b,2096));j[a+124>>2]=b;if(!b){Nb(a,3);break c}Ab(b,0,p(j[a+120>>2],2096));g:{h:{if(j[a+120>>2]>=1){while(1){b=j[a+124>>2];if((Tb(a,8)&255)!=66){Nb(a,20);break c}if((Tb(a,8)&255)!=67){Nb(a,20);break c}if((Tb(a,8)&255)!=86){Nb(a,20);break c}d=b+p(v,2096)|0;B=d,C=Tb(a,8)&255|Tb(a,8)<<8,j[B>>2]=C;B=d,C=Tb(a,8)&255|(Tb(a,8)<<8&65280|Tb(a,8)<<16),j[B+4>>2]=C;b=0;r=d+4|0;f=Tb(a,1);if(!f){b=Tb(a,1)}h[d+23|0]=b;if(!(j[d>>2]|!j[r>>2])){Nb(a,20);break c}e=j[r>>2];i:{if(b&255){c=km(a,e);break i}c=Ad(a,e);j[d+8>>2]=c}if(!c){Nb(a,3);break c}j:{if(!f){b=0;s=0;e=j[r>>2];if((e|0)<=0){break j}while(1){k:{l:{if(k[d+23|0]){if(!Tb(a,1)){break l}}e=Tb(a,5)+1|0;h[b+c|0]=e;if((e&255)!=32){s=s+1|0;break k}Nb(a,20);break c}h[b+c|0]=255}b=b+1|0;e=j[r>>2];if((b|0)<(e|0)){continue}break}break j}g=Tb(a,5);s=0;b=0;e=j[r>>2];if((e|0)<1){break j}while(1){f=Tb(a,Sk(e-b|0));g=g+1|0;if((g|0)>=32){Nb(a,20);break c}e=b+f|0;if((e|0)>j[r>>2]){Nb(a,20);break c}Ab(b+c|0,g,f);b=e;e=j[r>>2];if((b|0)<(e|0)){continue}break}}m:{n:{if(k[d+23|0]){if(e>>2>(s|0)){break n}b=d;f=a;if(j[a+16>>2]<(e|0)){j[a+16>>2]=e;e=j[r>>2]}g=b;b=Ad(f,e);j[g+8>>2]=b;if(!b){Nb(a,3);break c}Vb(b,c,j[r>>2]);Mh(a,c,j[r>>2]);c=j[d+8>>2];h[d+23|0]=0}g=0;b=0;e=0;f=j[r>>2];if((f|0)>=1){while(1){e=((k[b+c|0]-11&255)>>>0<244)+e|0;b=b+1|0;if((f|0)!=(b|0)){continue}break}}j[d+2092>>2]=e;b=Ad(a,f<<2);j[d+32>>2]=b;if(b){e=d+2092|0;break m}Nb(a,3);break c}j[d+2092>>2]=s;e=d+2092|0;o:{if(!s){g=0;break o}b=Ad(a,s);j[d+8>>2]=b;if(!b){Nb(a,3);break c}b=km(a,j[e>>2]<<2);j[d+32>>2]=b;if(!b){Nb(a,3);break c}g=km(a,j[e>>2]<<2);if(g){break o}Nb(a,3);break c}b=j[r>>2]+(j[e>>2]<<3)|0;if(b>>>0<=m[a+16>>2]){break m}j[a+16>>2]=b}if(!s5(d,c,j[r>>2],g)){if(k[d+23|0]){Mh(a,g,0)}Nb(a,20);break c}b=j[e>>2];if(b){b=Ad(a,(b<<2)+4|0);j[d+2084>>2]=b;if(!b){Nb(a,3);break c}b=Ad(a,(j[e>>2]<<2)+4|0);j[d+2088>>2]=b;if(!b){Nb(a,3);break c}j[d+2088>>2]=b+4;j[b>>2]=-1;r5(d,c,g)}if(k[d+23|0]){Mh(a,g,j[e>>2]<<2);Mh(a,j[d+32>>2],j[e>>2]<<2);Mh(a,c,j[r>>2]);j[d+32>>2]=0}q5(d);b=Tb(a,4);h[d+21|0]=b;b=b&255;if(b>>>0>=3){Nb(a,20);break c}if(b){B=d,D=QE(Tb(a,32)),n[B+12>>2]=D;B=d,D=QE(Tb(a,32)),n[B+16>>2]=D;B=d,C=Tb(a,4)+1|0,h[B+20|0]=C;B=d,C=Tb(a,1),h[B+22|0]=C;b=j[d>>2];c=j[r>>2];p:{if(k[d+21|0]==1){b=p5(c,b);if((b|0)>-1){break p}Nb(a,20);break c}b=p(b,c)}j[d+24>>2]=b;if(!b){Nb(a,20);break c}c=km(a,b<<1);if(!c){break h}b=0;g=j[d+24>>2];if((g|0)>0){while(1){f=Tb(a,k[d+20|0]);if((f|0)==-1){Mh(a,c,j[d+24>>2]<<1);Nb(a,20);break c}i[c+(b<<1)>>1]=f;b=b+1|0;g=j[d+24>>2];if((b|0)<(g|0)){continue}break}}q:{if(k[d+21|0]==1){s=k[d+23|0];r:{if(s){b=j[e>>2];if(b){break r}break q}b=j[r>>2]}b=Ad(a,p(j[d>>2],b)<<2);j[d+28>>2]=b;if(!b){Mh(a,c,j[d+24>>2]<<1);Nb(a,3);break c}y=j[(s?e:r)>>2];if((y|0)>=1){A=d+2088|0;w=q(0);f=0;while(1){e=f;e=s?j[j[A>>2]+(e<<2)>>2]:e;b=1;r=0;s:{g=j[d>>2];if((g|0)<1){break s}while(1){x=q(q(n[d+12>>2]+w)+q(n[d+16>>2]*q(l[c+(((e>>>0)/(b>>>0)>>>0)%m[d+24>>2]<<1)>>1])));n[j[d+28>>2]+(p(f,g)+r<<2)>>2]=x;w=k[d+22|0]?x:w;g=j[d>>2];r=r+1|0;if((g|0)<=(r|0)){break s}u=j[d+24>>2];HMa(u,0,b,0);if(!ab){b=p(b,u);continue}else{Mh(a,c,u<<1);Nb(a,20);break c}}}f=f+1|0;if((y|0)!=(f|0)){continue}break}}h[d+21|0]=2;g=j[d+24>>2];break q}b=Ad(a,g<<2);j[d+28>>2]=b;g=j[d+24>>2];if(!b){break g}if((g|0)<1){break q}w=q(n[d+12>>2]+q(n[d+16>>2]*q(l[c>>1])));n[b>>2]=w;b=1;g=j[d+24>>2];if((g|0)<=1){break q}x=q(0);while(1){x=k[d+22|0]?w:x;w=q(q(n[d+12>>2]+x)+q(n[d+16>>2]*q(l[c+(b<<1)>>1])));n[j[d+28>>2]+(b<<2)>>2]=w;b=b+1|0;g=j[d+24>>2];if((b|0)<(g|0)){continue}break}}Mh(a,c,g<<1)}v=v+1|0;if((v|0)<j[a+120>>2]){continue}break}}t:{b=Tb(a,6)+1&255;if(!b){break t}while(1){if(!Tb(a,16)){o=o+1|0;if((b|0)!=(o|0)){continue}break t}break}Nb(a,20);break c}b=Tb(a,6)+1|0;j[a+128>>2]=b;b=Ad(a,p(b,1596));j[a+260>>2]=b;u:{if(b){if(j[a+128>>2]>=1){break u}e=0;break d}Nb(a,3);break c}s=0;f=0;v:while(1){b=Tb(a,16);i[((s<<1)+a|0)+132>>1]=b;b=b&65535;if(b>>>0>=2){Nb(a,20);break c}if(!b){e=j[a+260>>2]+p(s,1596)|0;B=e,C=Tb(a,8),h[B|0]=C;B=e,C=Tb(a,16),i[B+2>>1]=C;B=e,C=Tb(a,16),i[B+4>>1]=C;B=e,C=Tb(a,6),h[B+6|0]=C;B=e,C=Tb(a,8),h[B+7|0]=C;b=(Tb(a,4)&255)+1|0;h[e+8|0]=b;if((b|0)==(b&255)){c=e+9|0;b=0;while(1){B=b+c|0,C=Tb(a,8),h[B|0]=C;b=b+1|0;if(b>>>0<k[e+8|0]){continue}break}}Nb(a,4);break c}d=j[a+260>>2]+p(s,1596)|0;o=Tb(a,5);h[d|0]=o;b=-1;e=0;c=0;if(o&255){while(1){o=Tb(a,4);h[(c+d|0)+1|0]=o;o=o&255;b=(b|0)<(o|0)?o:b;c=c+1|0;if(c>>>0<k[d|0]){continue}break}while(1){o=d+e|0;B=o,C=Tb(a,3)+1|0,h[B+33|0]=C;c=Tb(a,2);h[o+49|0]=c;w:{if(c&255){c=Tb(a,8);h[o+65|0]=c;if(j[a+120>>2]<=(c&255)){Nb(a,20);break c}if(k[o+49|0]==31){break w}}c=0;while(1){x:{g=Tb(a,8)-1|0;i[((d+(e<<4)|0)+(c<<1)|0)+82>>1]=g;if(j[a+120>>2]<=g<<16>>16){break x}c=c+1|0;if((c|0)<1<<k[o+49|0]){continue}break w}break}Nb(a,20);break c}c=(b|0)!=(e|0);e=e+1|0;if(c){continue}break}}r=2;B=d,C=Tb(a,2)+1|0,h[B+1588|0]=C;b=Tb(a,4);j[d+1592>>2]=2;g=0;i[d+338>>1]=0;h[d+1589|0]=b;i[d+340>>1]=1<<b;b=d+1592|0;o=k[d|0];y:{if(o){e=d+1589|0;while(1){c=0;v=d+k[(d+g|0)+1|0]|0;if(k[v+33|0]){while(1){o=Tb(a,k[e|0]);i[(d+(j[b>>2]<<1)|0)+338>>1]=o;r=j[b>>2]+1|0;j[b>>2]=r;c=c+1|0;if(c>>>0<k[v+33|0]){continue}break}o=k[d|0]}g=g+1|0;if(g>>>0<(o&255)>>>0){continue}break}if((r|0)<1){break y}}c=0;while(1){e=l[(d+(c<<1)|0)+338>>1];o=(t+16|0)+(c<<2)|0;i[o+2>>1]=c;i[o>>1]=e;c=c+1|0;r=j[b>>2];if((c|0)<(r|0)){continue}break}}e=d+338|0;uE(t+16|0,r,2295);c=0;r=j[b>>2];o=r-1|0;o=(o|0)>0?o:0;while(1){if((c|0)==(o|0)){c=0;z:{if((r|0)<=0){break z}while(1){h[(c+d|0)+838|0]=k[((t+16|0)+(c<<2)|0)+2|0];c=c+1|0;r=j[b>>2];if((c|0)<(r|0)){continue}break}c=2;if((r|0)<=2){break z}while(1){j[t+12>>2]=0;j[t+8>>2]=0;n5(e,c,t+12|0,t+8|0);o=d+(c<<1)|0;h[o+1088|0]=j[t+12>>2];h[o+1089|0]=j[t+8>>2];c=c+1|0;r=j[b>>2];if((c|0)<(r|0)){continue}break}}f=(f|0)<(r|0)?r:f;s=s+1|0;if((s|0)<j[a+128>>2]){continue v}e=f<<1;break d}g=l[(t+16|0)+(c<<2)>>1];c=c+1|0;if((g|0)!=l[(t+16|0)+(c<<2)>>1]){continue}break}break}Nb(a,20);break c}Nb(a,3);break c}Mh(a,c,g<<1);Nb(a,3);break c}Nb(a,20);break c}Nb(a,3);break c}Nb(a,3);break a}Nb(a,3);break c}Nb(a,20);break c}b=Tb(a,6)+1|0;j[a+264>>2]=b;b=Ad(a,p(b,24));j[a+396>>2]=b;if(!b){Nb(a,3);break c}r=0;Ab(b,0,p(j[a+264>>2],24));A:{if(j[a+264>>2]>=1){while(1){b=j[a+396>>2];c=Tb(a,16);i[((r<<1)+a|0)+268>>1]=c;if((c&65535)>>>0>=3){Nb(a,20);break c}f=b+p(r,24)|0;B=f,C=Tb(a,24),j[B>>2]=C;b=Tb(a,24);j[f+4>>2]=b;if(b>>>0<m[f>>2]){Nb(a,20);break c}B=f,C=Tb(a,24)+1|0,j[B+8>>2]=C;B=f,C=Tb(a,6)+1|0,h[B+12|0]=C;b=Tb(a,8);h[f+13|0]=b;B:{C:{if(j[a+120>>2]>(b&255)){b=0;if(k[f+12|0]){break C}c=0;break B}Nb(a,20);break c}while(1){d=(t+16|0)+b|0;o=Tb(a,3);if(Tb(a,1)){c=Tb(a,5)}else{c=0}h[d|0]=o+(c<<3);b=b+1|0;c=k[f+12|0];if(b>>>0<c>>>0){continue}break}}b=Ad(a,c<<4);j[f+20>>2]=b;if(!b){break A}if(k[f+12|0]){g=0;while(1){c=k[(t+16|0)+g|0];b=0;while(1){D:{if(c>>>b&1){d=Tb(a,8);s=b<<1;o=g<<4;i[s+(o+j[f+20>>2]|0)>>1]=d;if(j[a+120>>2]>i[s+(o+j[f+20>>2]|0)>>1]){break D}Nb(a,20);break c}i[(j[f+20>>2]+(g<<4)|0)+(b<<1)>>1]=65535}b=b+1|0;if((b|0)!=8){continue}break}g=g+1|0;if(g>>>0<k[f+12|0]){continue}break}}b=Ad(a,j[(j[a+124>>2]+p(k[f+13|0],2096)|0)+4>>2]<<2);j[f+16>>2]=b;if(!b){Nb(a,3);break c}o=0;Ab(b,0,j[(j[a+124>>2]+p(k[f+13|0],2096)|0)+4>>2]<<2);b=j[a+124>>2];c=k[f+13|0];if(j[(b+p(c,2096)|0)+4>>2]>0){while(1){d=j[p(c,2096)+b>>2];b=Ad(a,d);g=o<<2;j[g+j[f+16>>2]>>2]=b;E:{c=j[g+j[f+16>>2]>>2];if(c){if((d|0)<1){break E}b=d-1|0;h[c+b|0]=(o>>>0)%k[f+12|0];c=o;if((d|0)==1){break E}while(1){d=b-1|0;s=k[f+12|0];c=(c|0)/(s|0)|0;h[d+j[g+j[f+16>>2]>>2]|0]=(c|0)%(s|0);s=(b|0)>1;b=d;if(s){continue}break}break E}Nb(a,3);break c}o=o+1|0;b=j[a+124>>2];c=k[f+13|0];if((o|0)<j[(b+p(c,2096)|0)+4>>2]){continue}break}}r=r+1|0;if((r|0)<j[a+264>>2]){continue}break}}b=Tb(a,6)+1|0;j[a+400>>2]=b;b=Ad(a,p(b,40));j[a+404>>2]=b;if(!b){Nb(a,3);break c}g=0;Ab(b,0,p(j[a+400>>2],40));if(j[a+400>>2]>=1){while(1){b=j[a+404>>2];if(Tb(a,16)){Nb(a,20);break c}d=b+p(g,40)|0;b=Ad(a,p(j[a+4>>2],3));j[d+4>>2]=b;if(!b){Nb(a,3);break c}b=d;if(Tb(a,1)){c=Tb(a,4)+1|0}else{c=1}h[b+8|0]=c;F:{if(Tb(a,1)){b=Tb(a,8)+1|0;i[d>>1]=b;G:{c=j[a+4>>2];b=b&65535;if((c|0)>=(b|0)){f=0;if(b){break G}break F}Nb(a,20);break c}while(1){c=Tb(a,Sk(c-1|0));b=p(f,3);h[b+j[d+4>>2]|0]=c;c=Tb(a,Sk(j[a+4>>2]-1|0));h[(b+j[d+4>>2]|0)+1|0]=c;c=j[a+4>>2];b=b+j[d+4>>2]|0;o=k[b|0];if((c|0)<=(o|0)){Nb(a,20);break c}b=k[b+1|0];if((b|0)>=(c|0)){Nb(a,20);break c}if((b|0)!=(o|0)){f=f+1|0;if(f>>>0>=l[d>>1]){break F}continue}break}Nb(a,20);break c}i[d>>1]=0}if(Tb(a,2)){Nb(a,20);break c}f=j[a+4>>2];H:{I:{b=k[d+8|0];if(b>>>0<=1){c=0;if((f|0)>0){while(1){h[(j[d+4>>2]+p(c,3)|0)+2|0]=0;c=c+1|0;if((c|0)<j[a+4>>2]){continue}break}b=k[d+8|0]}if(!(b&255)){break H}break I}c=0;if((f|0)<=0){break I}while(1){J:{b=Tb(a,4);f=p(c,3);h[(f+j[d+4>>2]|0)+2|0]=b;if(k[(f+j[d+4>>2]|0)+2|0]>=k[d+8|0]){break J}c=c+1|0;if((c|0)<j[a+4>>2]){continue}break I}break}Nb(a,20);break c}b=0;while(1){Tb(a,8);f=b+d|0;c=f;B=c,C=Tb(a,8),h[B+9|0]=C;f=Tb(a,8);h[c+24|0]=f;if(j[a+128>>2]<=k[c+9|0]){Nb(a,20);break c}if(j[a+264>>2]>(f&255)){b=b+1|0;if(b>>>0>=k[d+8|0]){break H}continue}break}Nb(a,20);break c}g=g+1|0;if((g|0)<j[a+400>>2]){continue}break}}b=Tb(a,6)+1|0;j[a+408>>2]=b;c=0;K:{if((b|0)<=0){break K}while(1){b=p(c,6)+a|0;B=b,C=Tb(a,1),h[B+412|0]=C;B=b,C=Tb(a,16),i[B+414>>1]=C;B=b,C=Tb(a,16),i[B+416>>1]=C;d=Tb(a,8);h[b+413|0]=d;if(l[b+414>>1]){Nb(a,20);break c}if(l[b+416>>1]){Nb(a,20);break c}if(j[a+400>>2]>(d&255)){c=c+1|0;if((c|0)>=j[a+408>>2]){break K}continue}break}Nb(a,20);break c}PE(a);b=0;j[a+992>>2]=0;if(j[a+4>>2]>=1){while(1){c=(b<<2)+a|0;B=c,C=Ad(a,j[a+116>>2]<<2),j[B+800>>2]=C;B=c,C=Ad(a,j[a+116>>2]<<1&2147483646),j[B+928>>2]=C;d=Ad(a,e);j[c+996>>2]=d;f=j[c+800>>2];if(!(j[c+928>>2]?!(!f|!d):0)){Nb(a,3);break c}Ab(f,0,j[a+116>>2]<<2);b=b+1|0;if((b|0)<j[a+4>>2]){continue}break}}b=0;if(!OE(a,0,j[a+112>>2])){break a}if(!OE(a,1,j[a+116>>2])){break a}j[a+104>>2]=j[a+112>>2];c=j[a+116>>2];j[a+108>>2]=c;g=a;o=c<<1&2147483646;y=o;s=j[a+264>>2];d=4;L:{if((s|0)<1){break L}c=(c|0)/2|0;v=j[a+396>>2];r=0;f=0;while(1){d=v+p(f,24)|0;u=j[d+4>>2];e=c>>>0>u>>>0?u:c;u=j[d>>2];d=(e-(c>>>0>u>>>0?u:c)>>>0)/m[d+8>>2]|0;r=(d|0)>(r|0)?d:r;f=f+1|0;if((s|0)!=(f|0)){continue}break}d=(r<<2)+4|0}e=p(d,j[a+4>>2]);e=e>>>0<o>>>0?y:e;j[g+12>>2]=e;M:{N:{if(!j[a+80>>2]){break N}c=j[a+92>>2];if((c|0)!=j[a+84>>2]){break M}if(c>>>0>=(e+j[a+88>>2]|0)+1512>>>0){break N}Nb(a,3);break a}if(j[a+1380>>2]==-1){j[a+52>>2]=k[a+48|0]?0:j[a+32>>2]-j[a+36>>2]|0;b=1;break a}j[a+52>>2]=0;b=1;break a}Y(51956,50512,4182,52012);z()}Nb(a,3)}b=0}Za=t+1024|0;return b}function jya(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,J=0,L=0,M=0,O=0,P=0,Q=0;d=Za-304|0;Za=d;rc(b);a:{b:{c:{d:{e:{f:{g:{h:{if(!vs(b,d+208|0)){break h}if(!pN(d+208|0)){break h}if(!yb(b,Tc(oN(d+208|0),ab))){break h}if(!c){A=1;break h}od(a,2);j[a+480260>>2]=64;j[a+480264>>2]=32767;r=Qc(d+192|0);i:{j:{k:{l:{m:{n:{o:{p:{q:{r:{s:{t:{u:{v:{w:{n=d+248|0;switch(((k[n|0]|k[n+1|0]<<8)&61440)-4096>>>12|0){case 6:break q;case 5:break r;case 4:break s;case 3:break t;case 2:break u;case 1:break v;case 0:break w;default:break p}}x:{if(k[d+270|0]|k[d+271|0]<<8|(k[n|0]|k[n+1|0]<<8)!=4896|(k[d+260|0]|k[d+240|0]&15)){break x}if((k[d+246|0]|k[d+247|0]<<8)&65455){break x}j[a+1074304>>2]=18219008;j[114630]=0;f=E(2,d+32|0,17034)|0;g=j[114630];j[114630]=0;o=1;if((g|0)==1){break o}ob(r,f);gb(f);j[114630]=0;K(478,a+1074308|0,81,1)|0;m=j[114630];j[114630]=0;f=1;g=0;if((m|0)!=1){break i}break b}y:{if(k[d+270|0]|k[d+271|0]<<8|(k[n|0]|k[n+1|0]<<8)!=4896|(k[d+260|0]|(k[d+246|0]|k[d+247|0]<<8))){break y}if(k[d+261|0]){break y}j[114630]=0;f=E(2,d+32|0,17060)|0;g=j[114630];j[114630]=0;if((g|0)!=1){break j}e=D()|0;C()|0;break a}j[114630]=0;g=E(2,d+32|0,17074)|0;o=j[114630];j[114630]=0;e=1;if((o|0)!=1){ob(r,g);gb(g);break k}e=D()|0;C()|0;break a}j[114630]=0;g=E(2,d+32|0,17089)|0;o=j[114630];j[114630]=0;f=1;if((o|0)!=1){ob(r,g);gb(g);break k}e=D()|0;C()|0;break a}z:{A:{B:{C:{D:{m=k[n|0]|k[n+1|0]<<8;E:{if(m>>>0<=12820){j[114630]=0;f=E(2,d+32|0,17103)|0;g=j[114630];j[114630]=0;if((g|0)!=1){ob(r,f);break E}e=D()|0;C()|0;break a}j[114630]=0;f=E(2,d+160|0,17119)|0;g=j[114630];j[114630]=0;if((g|0)==1){break D}j[114630]=0;F(219,d+176|0,f|0);g=j[114630];j[114630]=0;if((g|0)==1){break C}g=k[n|0]|k[n+1|0]<<8;j[114630]=0;j[d+128>>2]=g-12820;I(245,d+32|0,d+176|0,d+128|0);g=j[114630];j[114630]=0;if((g|0)==1){break B}ob(r,d+32|0);gb(d+32|0);qb(d+176|0)}gb(f);if((k[n|0]|k[n+1|0]<<8)>>>0<12807){break l}if(k[d+264|0]|k[d+265|0]<<8|(k[d+266|0]<<16|k[d+267|0]<<24)){break z}break l}e=D()|0;C()|0;break a}e=D()|0;C()|0;break A}e=D()|0;C()|0;qb(d+176|0)}gb(f);break a}f=k[n|0]|k[n+1|0]<<8;g=k[d+264|0]|k[d+265|0]<<8|(k[d+266|0]<<16|k[d+267|0]<<24);j[114630]=0;f=E(661,f|0,g|0)|0;g=j[114630];j[114630]=0;if((g|0)==1){break n}g=qp(d+32|0);j[g+44>>2]=f;j[114630]=0;F(662,a+1304500|0,g|0);f=j[114630];j[114630]=0;if((f|0)!=1){break l}e=D()|0;C()|0;break a}e=k[n|0]|k[n+1|0]<<8;F:{if((e|0)==16640){j[114630]=0;f=E(2,d+32|0,17143)|0;g=j[114630];j[114630]=0;if((g|0)!=1){ob(r,f);gb(f);j[114630]=0;K(478,a+1074308|0,81,1)|0;f=j[114630];j[114630]=0;if((f|0)==1){break b}break F}e=D()|0;C()|0;break a}f=k[n|0]|k[n+1|0]<<8;g=k[d+262|0]|k[d+263|0]<<8;j[114630]=0;I(663,d+32|0,f|0,g|0);f=j[114630];j[114630]=0;if((f|0)==1){break m}ob(r,d+32|0);gb(d+32|0);j[a+480260>>2]=1}g=(e|0)!=16640;f=1;e=0;break i}j[114630]=0;e=E(2,d+32|0,17155)|0;g=j[114630];j[114630]=0;if((g|0)!=1){ob(r,e);gb(e);j[a+1074304>>2]=((k[n|0]|k[n+1|0]<<8)&4095)<<16;e=0;break k}e=D()|0;C()|0;break a}j[114630]=0;f=E(2,d+32|0,17143)|0;g=j[114630];j[114630]=0;if((g|0)!=1){ob(r,f);gb(f);j[114630]=0;K(478,a+1074308|0,81,1)|0;m=j[114630];j[114630]=0;f=0;g=0;if((m|0)==1){break b}break i}e=D()|0;C()|0;break a}j[114630]=0;f=E(2,d+32|0,17163)|0;g=j[114630];j[114630]=0;if((g|0)!=1){break j}e=D()|0;C()|0;break a}if((k[n|0]|k[n+1|0]<<8)!=51712){break i}j[114630]=0;f=E(2,d+32|0,17176)|0;g=j[114630];j[114630]=0;if((g|0)!=1){break j}e=D()|0;C()|0;break a}e=D()|0;C()|0;break a}e=D()|0;C()|0;break a}e=D()|0;C()|0;break a}j[114630]=0;f=1;K(478,a+1074308|0,107,1)|0;g=j[114630];j[114630]=0;if((g|0)==1){break b}j[a+480260>>2]=1;g=0;if(m>>>0>12820){break i}}j[114630]=0;g=E(2,d+144|0,17183)|0;o=j[114630];j[114630]=0;G:{H:{I:{J:{K:{if((o|0)!=1){j[114630]=0;F(219,d+176|0,g|0);o=j[114630];j[114630]=0;if((o|0)==1){break K}j[d+16>>2]=k[n+1|0]&15;o=k[n|0];j[114630]=0;j[d>>2]=o;F(660,d+128|0,d|0);o=j[114630];j[114630]=0;if((o|0)==1){break J}j[114630]=0;V(992,d+32|0,d+176|0,r|0,d+16|0,d+128|0);o=j[114630];j[114630]=0;if((o|0)==1){break I}ob(r,d+32|0);gb(d+32|0);gb(d+128|0);qb(d+176|0);gb(g);o=0;g=0;break i}e=D()|0;C()|0;break a}e=D()|0;C()|0;break G}e=D()|0;C()|0;break H}e=D()|0;C()|0;gb(d+128|0)}qb(d+176|0)}gb(g);break a}ob(r,f);gb(f);f=0;g=0}j[114630]=0;m=E(2,d+32|0,17192)|0;u=j[114630];j[114630]=0;L:{M:{N:{O:{P:{Q:{R:{S:{T:{U:{V:{W:{X:{Y:{Z:{if((u|0)!=1){ob(a+1304436|0,m);gb(m);j[114630]=0;m=E(2,d+32|0,17208)|0;u=j[114630];j[114630]=0;if((u|0)==1){break Z}ob(a+1304448|0,m);gb(m);ob(a+1304460|0,r);j[a+1304496>>2]=j[a+1074304>>2]?7:4;if(f){j[114630]=0;f=a+1074308|0;E(479,f|0,77)|0;m=j[114630];j[114630]=0;if((m|0)==1){break b}j[114630]=0;E(479,f|0,78)|0;m=j[114630];j[114630]=0;if((m|0)==1){break b}j[114630]=0;E(479,f|0,79)|0;m=j[114630];j[114630]=0;if((m|0)==1){break b}j[114630]=0;E(479,f|0,80)|0;m=j[114630];j[114630]=0;if((m|0)==1){break b}j[114630]=0;E(479,f|0,82)|0;m=j[114630];j[114630]=0;if((m|0)==1){break b}j[114630]=0;E(479,f|0,96)|0;f=j[114630];j[114630]=0;if((f|0)==1){break b}}o=((k[n|0]|k[n+1|0]<<8)&61440)>>>0<4097|((k[n|0]|k[n+1|0]<<8)>>>0<12820?((k[n|0]|k[n+1|0]<<8)&61440)==12288:0)?o:1;j[114630]=0;f=a+901404|0;N(993,f|0);m=j[114630];j[114630]=0;if((m|0)==1){break b}if(!o){j[114630]=0;N(634,f|0);f=j[114630];j[114630]=0;if((f|0)==1){break b}}j[114630]=0;I(577,d+176|0,1,d+208|0);f=j[114630];j[114630]=0;if((f|0)==1){break Y}j[114630]=0;F(415,d+32|0,d+176|0);f=j[114630];j[114630]=0;if((f|0)==1){break Y}ob(a+1304400|0,d+32|0);gb(d+32|0);if(k[d+246|0]&16){j[a+480208>>2]=j[a+480208>>2]|65536}if(h[d+246|0]&1){j[a+480208>>2]=j[a+480208>>2]|131072}if(!(k[d+246|0]&64?0:(k[n|0]|k[n+1|0]<<8)!=4864)){j[a+480208>>2]=j[a+480208>>2]|2}f=k[d+257|0];j[a+480196>>2]=f;_:{$:{if(f){if((f|0)!=255){break $}f=0;if(!e){break _}}j[a+480196>>2]=6}f=e}j[a+480204>>2]=p(k[d+258|0],1e4);if(k[d+258|0]<=32){j[a+480204>>2]=f?125e4:32e4}e=k[d+256|0];j[114630]=0;h[d+32|0]=e;h[d+176|0]=64;e=E(391,d+32|0,d+176|0)|0;o=j[114630];j[114630]=0;if((o|0)==1){break U}e=k[e|0];j[a+480200>>2]=e<<2;if(!((k[n|0]|k[n+1|0]<<8)>>>0>4895|e)){j[a+480200>>2]=256}if((k[d+250|0]|k[d+251|0]<<8)!=1|k[d+259|0]>7){break W}e=k[d+259|0];j[114630]=0;j[d+32>>2]=(e<<4)+16;j[d+176>>2]=127;e=E(462,d+32|0,d+176|0)|0;o=j[114630];j[114630]=0;if((o|0)==1){break X}j[a+480228>>2]=j[e>>2];break V}e=D()|0;C()|0;break a}e=D()|0;C()|0;break a}e=D()|0;C()|0;break a}e=D()|0;C()|0;break a}if(!(k[d+259|0]!=18?k[d+259|0]!=2:0)){j[a+480228>>2]=32;break V}e=k[d+259|0];j[114630]=0;j[d+32>>2]=e&127;j[d+176>>2]=16;e=E(552,d+32|0,d+176|0)|0;o=j[114630];j[114630]=0;if((o|0)==1){break T}j[a+480228>>2]=j[e>>2]}j[a+480232>>2]=36;if(!(!g|(k[n|0]|k[n+1|0]<<8)>>>0>=19763)){j[a+480232>>2]=64}i[a+480188>>1]=4;o=Ws(d+120|0);e=0;while(1){j[114630]=0;g=(e<<5)+a|0;q=g+480280|0;N(432,q|0);m=j[114630];j[114630]=0;if((m|0)==1){break S}m=d+e|0;u=k[m+272|0];if(k[m+272|0]!=255){i[a+480188>>1]=e+1;i[g+480284>>1]=u&8?204:51}if(h[m+272|0]<=-1){j[q>>2]=1024}if(((u&127)-16&255)>>>0<=13){i[g+480284>>1]=128;qj(d+32|0,o,e);Qd(d+32|0,1)}e=e+1|0;if((e|0)!=32){continue}break}if(!l[a+480188>>1]){i[a+480188>>1]=1}e=Eb(a+484360|0);g=k[d+240|0]|k[d+241|0]<<8;j[114630]=0;U(581,e|0,b|0,g|0,255,254)|0;e=j[114630];j[114630]=0;if((e|0)==1){break c}x=vt(d+176|0);e=k[d+242|0]|k[d+243|0]<<8;j[114630]=0;K(393,b|0,x|0,e|0)|0;e=j[114630];j[114630]=0;if((e|0)==1){break e}u=vt(d+128|0);e=k[d+244|0]|k[d+245|0]<<8;j[114630]=0;K(393,b|0,u|0,e|0)|0;e=j[114630];j[114630]=0;if((e|0)!=1){if(k[d+261|0]==252){e=0;j[114630]=0;E(994,b|0,d+32|0)|0;g=j[114630];j[114630]=0;if((g|0)==1){break g}while(1){m=(d+32|0)+e|0;g=k[m|0];aa:{if(!(g&32)){break aa}q=((e<<5)+a|0)+480284|0;if(f){qj(d+16|0,o,e);if(kb(d+16|0)){break aa}g=k[m|0]}i[q>>1]=(((g&15)<<8|8)>>>0)/15}e=e+1|0;if((e|0)!=32){continue}break}}e=k[d+242|0]|k[d+243|0]<<8;j[114630]=0;i[d+32>>1]=e;i[d+16>>1]=3999;e=E(477,d+32|0,d+16|0)|0;g=j[114630];j[114630]=0;if((g|0)==1){break R}e=l[e>>1];i[a+480190>>1]=e;if(e){g=c&2;o=d+45|0;m=d+80|0;e=0;while(1){q=bc(x,e);q=k[q|0]|k[q+1|0]<<8;j[114630]=0;q=E(256,b|0,q<<4)|0;v=j[114630];j[114630]=0;if((v|0)==1){break Q}ba:{if(!q){break ba}j[114630]=0;q=E(995,b|0,d+32|0)|0;v=j[114630];j[114630]=0;if((v|0)==1){break Q}if(!q){break ba}j[114630]=0;q=e+1|0;v=(p(q,104)+a|0)+484380|0;I(996,d+32|0,v|0,f|0);s=j[114630];j[114630]=0;if((s|0)==1){break Q}j[114630]=0;I(577,d|0,1,m|0);s=j[114630];j[114630]=0;ca:{da:{ea:{if((s|0)==1){break ea}j[114630]=0;F(415,d+16|0,d|0);s=j[114630];j[114630]=0;if((s|0)==1){break ea}j[114630]=0;E(369,((q<<5)+a|0)+946300|0,d+16|0)|0;q=j[114630];j[114630]=0;if((q|0)==1){break da}gb(d+16|0);if(!(k[d+48|0]|k[d+49|0]<<8|(k[d+50|0]<<16|k[d+51|0]<<24))|(!g|k[d+32|0]>1)){break ba}q=k[d+46|0];s=k[d+47|0];t=k[o|0];j[114630]=0;q=E(256,b|0,s<<12|q<<4|t<<20)|0;s=j[114630];j[114630]=0;if((s|0)==1){break ca}if(!q){break ba}q=k[d+250|0]|k[d+251|0]<<8;j[114630]=0;I(997,d+16|0,d+32|0,(q|0)==1|0);q=j[114630];j[114630]=0;if((q|0)!=1){j[114630]=0;K(400,d+16|0,v|0,b|0)|0;q=j[114630];j[114630]=0;if((q|0)!=1){break ba}}e=D()|0;C()|0;break f}e=D()|0;C()|0;break f}e=D()|0;C()|0;gb(d+16|0);break f}e=D()|0;C()|0;break f}e=e+1|0;if(e>>>0<l[a+480190>>1]){continue}break}}A=1;if(!(c&1)){break L}c=k[n|0]|k[n+1|0]<<8;f=k[d+244|0]|k[d+245|0]<<8;j[114630]=0;i[d+32>>1]=f;i[d+16>>1]=255;f=E(477,d+32|0,d+16|0)|0;e=j[114630];j[114630]=0;fa:{ga:{if((e|0)!=1){y=l[f>>1];j[114630]=0;q=a+484344|0;F(401,q|0,y|0);f=j[114630];j[114630]=0;if((f|0)==1){break ga}B=c>>>0<4896;if(y){break fa}v=0;s=0;break M}e=D()|0;C()|0;break f}e=D()|0;C()|0;break f}L=d+32|5;M=d+32|3;J=d+32|4;O=d+32|2;P=d+32|1;g=0;s=0;v=0;while(1){j[114630]=0;c=K(402,q|0,g&65535,64)|0;f=j[114630];j[114630]=0;if((f|0)==1){break P}ha:{if(!c){break ha}c=bc(u,g);if(!(k[c|0]|k[c+1|0]<<8)){break ha}c=bc(u,g);c=k[c|0]|k[c+1|0]<<8;j[114630]=0;c=E(256,b|0,c<<4)|0;f=j[114630];j[114630]=0;if((f|0)==1){break P}if(!c){break ha}j[114630]=0;E(338,b|0,2)|0;c=j[114630];j[114630]=0;if((c|0)==1){break P}e=0;c=Hb(q,g);j[114630]=0;c=E(496,c|0,0)|0;f=j[114630];j[114630]=0;if((f|0)==1){break O}while(1){j[114630]=0;t=H(387,b|0)|0;f=j[114630];j[114630]=0;ia:{ja:{if((f|0)!=1){if(t){break ja}if(e>>>0>62){break ha}c=Hb(q,g);j[114630]=0;e=e+1|0;c=E(496,c|0,e|0)|0;f=j[114630];j[114630]=0;if((f|0)!=1){break ia}}e=D()|0;C()|0;break f}Q=ni(d+32|0);f=t&31;o=f>>>0<l[a+480188>>1];m=p(f,6)+c|0;if(t&32){j[114630]=0;F(472,d+16|0,b|0);f=j[114630];j[114630]=0;ka:{la:{ma:{if((f|0)!=1){w=Pc(d+16|0);f=k[d+16|0];if(f>>>0>239){break ma}f=(p(f>>>4|0,12)+(f&15)|0)+13|0;break la}e=D()|0;C()|0;break f}na:{switch(f-254|0){case 0:break la;case 1:break na;default:break ka}}f=0}h[(o?m:d+32|0)|0]=f}h[(o?m+1|0:P)|0]=k[w|0]}oa:{if(!(t&64)){break oa}j[114630]=0;f=H(387,b|0)|0;w=j[114630];j[114630]=0;pa:{if((w|0)!=1){w=o?m+2|0:O;h[d+16|0]=f;if(f<<24>>24>-1|f>>>0>192){break pa}h[w|0]=2;h[(o?m+4|0:J)|0]=k[d+16|0]^128;break oa}e=D()|0;C()|0;break f}h[w|0]=1;j[114630]=0;h[d|0]=64;f=E(391,d+16|0,d|0)|0;w=j[114630];j[114630]=0;if((w|0)==1){break N}h[(o?m+4|0:J)|0]=k[f|0]}if(!(t&128)){break ia}j[114630]=0;F(472,d+16|0,b|0);f=j[114630];j[114630]=0;qa:{if((f|0)!=1){f=Pc(d+16|0);w=o?m+3|0:M;h[w|0]=k[d+16|0];t=o?m+5|0:L;h[t|0]=k[f|0];$x(o?m:Q,0);ra:{f=k[w|0];if((f|0)==20){if((k[t|0]&240)!=160){break ia}if((k[n|0]|k[n+1|0]<<8)>>>0<4896){break ra}f=k[w|0]}if((f|0)!=31){break ia}f=k[t|0];if(f>>>0<=15){break qa}B=0;break ia}h[t|0]=k[t|0]&15^136;break ia}e=D()|0;C()|0;break f}if(f>>>0<=7){s=s+1|0;break ia}v=((f|0)!=8)+v|0}if(e>>>0<64){continue}break}}g=g+1|0;if((y|0)!=(g|0)){continue}break}break M}e=D()|0;C()|0;break f}e=D()|0;C()|0;break a}e=D()|0;C()|0;break a}e=D()|0;C()|0;break a}e=D()|0;C()|0;break f}e=D()|0;C()|0;break f}e=D()|0;C()|0;break f}e=D()|0;C()|0;break f}e=D()|0;C()|0;break f}if(!B){break L}a=l[a+480188>>1];if((a|0)>(s+v|0)|(a|0)<=(v-s|0)){break L}hya(q,me(q)-1&65535)}kk(u);kk(x);gb(r)}Za=d+304|0;return A|0}e=D()|0;C()|0}kk(u);break d}e=D()|0;C()|0}kk(x);break a}e=D()|0;C()|0;break a}e=D()|0;C()|0}gb(r);G(e|0);z()}function RKa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,n=0,o=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0;e=Za-288|0;Za=e;rc(b);a:{if(sS(b,12222)){v=Cb(e+272|0);j[114630]=0;f=K(430,b|0,v|0,-1)|0;o=j[114630];j[114630]=0;b:{c:{d:{e:{f:{g:{h:{i:{j:{k:{l:{m:{n:{o:{p:{q:{r:{s:{t:{u:{if((o|0)!=1){if(!f){break b}j[114630]=0;f=E(445,b|0,e+264|0)|0;o=j[114630];j[114630]=0;v:{if((o|0)==1){break v}if(!f){break b}if(!rS(e+264|0)){break b}d=qS(e+264|0);j[114630]=0;d=ig(446,d,ab);f=j[114630];j[114630]=0;if((f|0)==1){break v}j[114630]=0;f=E(258,b|0,d|0)|0;d=j[114630];j[114630]=0;if((d|0)==1){break v}d=0;if(!f){break b}if(!c){break c}j[114630]=0;F(447,a|0,4096);d=j[114630];j[114630]=0;if((d|0)==1){break v}j[114630]=0;E(448,a+1304400|0,v|0)|0;d=j[114630];j[114630]=0;if((d|0)==1){break v}d=k[e+264|2];i[a+480188>>1]=32;i[a+480192>>1]=d;j[114630]=0;F(449,a|0,1);d=j[114630];j[114630]=0;if((d|0)==1){break v}j[114630]=0;d=E(2,e+96|0,12230)|0;f=j[114630];j[114630]=0;w:{x:{y:{z:{A:{B:{C:{D:{E:{F:{G:{if((f|0)!=1){ob(a+1304436|0,d);gb(d);j[114630]=0;d=E(2,e+96|0,12194)|0;f=j[114630];j[114630]=0;if((f|0)==1){break G}ob(a+1304448|0,d);gb(d);j[114630]=0;d=E(2,e+248|0,12244)|0;f=j[114630];j[114630]=0;if((f|0)==1){break F}j[114630]=0;F(219,e+48|0,d|0);f=j[114630];j[114630]=0;if((f|0)==1){break E}h[e+216|0]=k[e+264|1];f=k[e+264|0];j[114630]=0;h[e+8|0]=f;F(450,e+232|0,e+8|0);f=j[114630];j[114630]=0;if((f|0)==1){break D}j[114630]=0;L(451,e+96|0,e+48|0,e+216|0,e+232|0);f=j[114630];j[114630]=0;if((f|0)==1){break C}ob(a+1304460|0,e+96|0);gb(e+96|0);gb(e+232|0);qb(e+48|0);gb(d);j[a+1304496>>2]=4;if(k[e+264|0]<2){break x}j[114630]=0;i[e+96>>1]=8192;d=H(357,b|0)|0;f=j[114630];j[114630]=0;if((f|0)==1){break z}j[114630]=0;i[e+48>>1]=d;d=E(452,e+96|0,e+48|0)|0;f=j[114630];j[114630]=0;if((f|0)==1){break z}j[a+480204>>2]=p(l[d>>1],1e4)>>>8;j[114630]=0;h[e+96|0]=1;d=H(387,b|0)|0;f=j[114630];j[114630]=0;if((f|0)==1){break y}j[114630]=0;h[e+48|0]=d;d=E(453,e+96|0,e+48|0)|0;f=j[114630];j[114630]=0;if((f|0)==1){break y}j[a+480196>>2]=k[d|0];j[114630]=0;E(338,b|0,3)|0;d=j[114630];j[114630]=0;if((d|0)!=1){j[114630]=0;d=H(357,b|0)|0;f=j[114630];j[114630]=0;if((f|0)!=1){break w}}b=D()|0;C()|0;break d}b=D()|0;C()|0;break d}b=D()|0;C()|0;break d}b=D()|0;C()|0;break d}b=D()|0;C()|0;break A}b=D()|0;C()|0;break B}b=D()|0;C()|0;gb(e+232|0)}qb(e+48|0)}gb(d);break d}b=D()|0;C()|0;break d}b=D()|0;C()|0;break d}j[114630]=0;h[e+96|0]=32;d=H(387,b|0)|0;f=j[114630];j[114630]=0;H:{I:{if((f|0)==1){break I}j[114630]=0;h[e+48|0]=d;d=E(453,e+96|0,e+48|0)|0;f=j[114630];j[114630]=0;if((f|0)==1){break I}j[a+480204>>2]=p(k[d|0],1e4);j[114630]=0;h[e+96|0]=1;d=H(387,b|0)|0;f=j[114630];j[114630]=0;if((f|0)==1){break H}j[114630]=0;h[e+48|0]=d;d=E(453,e+96|0,e+48|0)|0;f=j[114630];j[114630]=0;if((f|0)==1){break H}j[a+480196>>2]=k[d|0];j[114630]=0;d=H(387,b|0)|0;f=j[114630];j[114630]=0;if((f|0)!=1){break w}b=D()|0;C()|0;break d}b=D()|0;C()|0;break d}b=D()|0;C()|0;break d}j[a+480208>>2]=d>>>2&16|12;u=qn(e+232|0);t=qn(e+216|0);J:{K:{if(!l[a+480192>>1]){break K}o=e+80|1;w=e+96|12;q=1;while(1){j[114630]=0;f=K(454,a|0,q&65535,0)|0;d=j[114630];j[114630]=0;L:{M:{N:{if((d|0)==1){break N}if(!f){break K}j[114630]=0;d=K(431,b|0,f+492|0,-1)|0;n=j[114630];j[114630]=0;if((n|0)==1){break N}if(!d){break K}j[114630]=0;n=H(387,b|0)|0;d=j[114630];j[114630]=0;O:{P:{Q:{R:{if((d|0)!=1){Ab(e+96|0,0,120);if(!n){break L}if(k[e+264|0]){j[114630]=0;d=E(455,b|0,e+96|0)|0;g=j[114630];j[114630]=0;if((g|0)==1){break R}if(!d){break L}}if(!k[e+264|0]){j[114630]=0;d=K(261,b|0,w|0,96)|0;g=j[114630];j[114630]=0;if((g|0)==1){break R}if(!d){break L}}g=f+236|0;d=0;while(1){s=k[(e+96|0)+d|0];r=l[a+480190>>1];y=Nc(g,d),A=(r+s|0)+1|0,i[y>>1]=A;d=d+1|0;if((d|0)!=120){continue}break}j[114630]=0;d=f+48|0;I(456,e+8|0,d|0,b|0);g=j[114630];j[114630]=0;if((g|0)==1){break Q}j[114630]=0;g=f+68|0;I(456,e+32|0,g|0,b|0);s=j[114630];j[114630]=0;if((s|0)==1){break Q}j[114630]=0;s=f+88|0;I(456,e+88|0,s|0,b|0);r=j[114630];j[114630]=0;if((r|0)==1){break Q}j[114630]=0;E(457,b|0,e+80|0)|0;r=j[114630];j[114630]=0;if((r|0)==1){break P}j[f>>2]=(k[o|0]|k[o+1|0]<<8)&4095;f=k[o|0]|k[o+1|0]<<8;Jz(e+80|0,d,0);Jz(e+80|0,g,1);Jz(e+80|0,s,2);y=e,A=Lb(d),j[y+48>>2]=A;y=e,A=Mb(d),j[y+72>>2]=A;if(rb(e+48|0,e+72|0)){break O}break M}b=D()|0;C()|0;break e}b=D()|0;C()|0;break e}b=D()|0;C()|0;break e}b=D()|0;C()|0;break e}while(1){S:{d=j[e+48>>2];h[e+68|0]=64;r=k[d+2|0];j[114630]=0;h[e+71|0]=((r<<6)- -64>>>0)/127;r=E(391,e+68|0,e+71|0)|0;x=j[114630];j[114630]=0;if((x|0)==1){break S}h[d+2|0]=k[r|0];Id(e+48|0);if(rb(e+48|0,e+72|0)){continue}break M}break}b=D()|0;C()|0;break e}b=D()|0;C()|0;break e}y=e,A=Lb(g),j[y+48>>2]=A;y=e,A=Mb(g),j[y+72>>2]=A;T:{if(!rb(e+48|0,e+72|0)){break T}while(1){U:{d=j[e+48>>2];h[e+68|0]=64;g=k[d+2|0];j[114630]=0;h[e+71|0]=((g<<6)+128>>>0)/255;g=E(391,e+68|0,e+71|0)|0;r=j[114630];j[114630]=0;if((r|0)==1){break U}h[d+2|0]=k[g|0];Id(e+48|0);if(rb(e+48|0,e+72|0)){continue}break T}break}b=D()|0;C()|0;break e}y=e,A=Lb(s),j[y+48>>2]=A;y=e,A=Mb(s),j[y+72>>2]=A;if(rb(e+48|0,e+72|0)){s=1<<(f>>>12&3)&65535;while(1){r=j[e+48>>2];d=h[r+2|0];f=HMa(d^-128,d>>31^-1,s,0);g=ab;d=g;V:{if((d|0)>-1?1:(d|0)>=-1?f>>>0>=4294967292:0){j[114630]=0;f=f+4|0;d=f>>>0<4?d+1|0:d;f=ig(458,((d&7)<<29|f>>>3)&536870911,0);d=j[114630];j[114630]=0;if((d|0)!=1){break V}break f}j[114630]=0;d=(f-3|0)/8|0;f=ig(458,d,d>>31);d=j[114630];j[114630]=0;if((d|0)==1){break f}}h[r+2|0]=f^128;Id(e+48|0);if(rb(e+48|0,e+72|0)){continue}break}}d=l[a+480190>>1]+1|0;i[e+68>>1]=d;W:{X:{Y:{Z:{g=d&65535;if(g>>>0<=3999){f=0;d=0;while(1){j[114630]=0;K(431,b|0,((g<<5)+a|0)+946300|0,-1)|0;g=j[114630];j[114630]=0;if((g|0)==1){break Z}j[114630]=0;E(459,b|0,e+48|0)|0;g=j[114630];j[114630]=0;if((g|0)==1){break Y}j[114630]=0;F(460,e+48|0,(p(l[e+68>>1]+d|0,104)+a|0)+484380|0);d=j[114630];j[114630]=0;if((d|0)==1){break Y}d=k[e+80|0];g=k[e+67|0];j[114630]=0;i[e+72>>1]=d|f<<8&32512|((g&3)!=0)<<15;F(461,t|0,e+72|0);d=j[114630];j[114630]=0;if((d|0)==1){break X}f=f+1|0;d=f&65535;if(n>>>0<=d>>>0){break W}g=l[e+68>>1]+d|0;if(g>>>0<=3999){continue}break}}j[114630]=0;E(338,b|0,20)|0;d=j[114630];j[114630]=0;if((d|0)!=1){break W}b=D()|0;C()|0;break e}b=D()|0;C()|0;break e}b=D()|0;C()|0;break e}b=D()|0;C()|0;break e}j[114630]=0;F(461,u|0,e+68|0);d=j[114630];j[114630]=0;if((d|0)==1){break g}j[e+48>>2]=3999;d=l[a+480190>>1];j[114630]=0;j[e+72>>2]=d+n;d=E(462,e+48|0,e+72|0)|0;f=j[114630];j[114630]=0;if((f|0)==1){break J}i[a+480190>>1]=j[d>>2]}q=q+1|0;if(l[a+480192>>1]>=(q&65535)>>>0){continue}break}}d=Cb(e+96|0);j[114630]=0;f=K(430,b|0,d|0,-1)|0;o=j[114630];j[114630]=0;_:{$:{aa:{if((o|0)!=1){if(f){j[114630]=0;I(13,e+48|0,6,d|0);f=j[114630];j[114630]=0;if((f|0)==1){break _}ob(a+1304412|0,e+48|0);gb(e+48|0)}gb(d);f=0;while(1){j[114630]=0;d=(f<<5)+a|0;N(432,d+480280|0);o=j[114630];j[114630]=0;if((o|0)==1){break aa}j[114630]=0;K(433,b|0,d+480289|0,-1)|0;d=j[114630];j[114630]=0;if((d|0)==1){break aa}f=f+1|0;if((f|0)!=32){continue}break}j[114630]=0;d=E(463,b|0,e+32|0)|0;f=j[114630];j[114630]=0;if((f|0)==1){break o}if(!d){break l}if((k[e+32|0]|k[e+33|0]<<8|(k[e+34|0]<<16|k[e+35|0]<<24))>>>0<12){break p}d=k[e+32|0]|k[e+33|0]<<8|(k[e+34|0]<<16|k[e+35|0]<<24);j[114630]=0;d=E(258,b|0,d-11|0)|0;f=j[114630];j[114630]=0;if((f|0)==1){break o}if(d){break $}break p}break q}b=D()|0;C()|0;break e}j[e+88>>2]=(k[e+32|0]|k[e+33|0]<<8|(k[e+34|0]<<16|k[e+35|0]<<24))-11;q=Rt(e+96|0);j[114630]=0;K(436,b|0,q|0,j[e+88>>2])|0;d=j[114630];j[114630]=0;if((d|0)==1){break s}j[114630]=0;j[e+48>>2]=50529027;d=E(464,e+88|0,e+48|0)|0;f=j[114630];j[114630]=0;if((f|0)==1){break t}j[e+80>>2]=p(j[d>>2],85);o=Cb(e+48|0);d=e+32|4;d=k[d|0]|k[d+1|0]<<8|(k[d+2|0]<<16|k[d+3|0]<<24);j[114630]=0;j[e+8>>2]=d;d=E(464,e+80|0,e+8|0)|0;f=j[114630];j[114630]=0;if((f|0)==1){break u}d=j[d>>2];j[114630]=0;F(111,o|0,d|0);d=j[114630];j[114630]=0;if((d|0)==1){break u}if(j[e+88>>2]){f=0;while(1){ba:{n=k[fc(q,f)|0];d=f+1|0;if(!((n|0)!=255|j[e+88>>2]-d>>>0<2)){d=h[fc(q,d)|0];n=k[fc(q,f+2|0)|0];y=e,A=_e(o),j[y+8>>2]=A;Cd(e+24|0,e+8|0);j[114630]=0;P(437,o|0,j[e+24>>2],n|0,d|0)|0;d=j[114630];j[114630]=0;if((d|0)!=1){d=f+3|0;break ba}break u}j[114630]=0;F(110,o|0,n<<24>>24);f=j[114630];j[114630]=0;if((f|0)!=1){break ba}break u}f=d;if(m[e+88>>2]>d>>>0){continue}break}}j[114630]=0;L(438,e+8|0,4,6,o|0);d=j[114630];j[114630]=0;ca:{if((d|0)!=1){ob(o,e+8|0);gb(e+8|0);d=zb(o);j[114630]=0;d=H(439,d|0)|0;f=j[114630];j[114630]=0;if((f|0)==1){break ca}f=nb(o);j[114630]=0;U(440,a+1304424|0,d|0,f|0,74,0)|0;d=j[114630];j[114630]=0;if((d|0)==1){break ca}gb(o);Od(q);break p}break u}break u}break q}b=D()|0;C()|0;break e}b=D()|0;C()|0;break d}b=D()|0;C()|0;break d}b=D()|0;C()|0;gb(o);break r}b=D()|0;C()|0;break r}b=D()|0;C()|0}Od(q);break e}b=D()|0;C()|0;gb(d);break e}d=Eb(a+484360|0);f=e+264|5;f=k[f|0]|k[f+1|0]<<8;j[114630]=0;U(441,d|0,b|0,f|0,65535,65535)|0;d=j[114630];j[114630]=0;if((d|0)==1){break o}q=c&1;if(q){d=e+264|3;d=k[d|0]|k[d+1|0]<<8;j[114630]=0;F(401,a+484344|0,d|0);d=j[114630];j[114630]=0;if((d|0)==1){break o}}d=e+264|3;da:{if(!(k[d|0]|k[d+1|0]<<8)){break da}o=a+484344|0;f=0;while(1){j[114630]=0;n=E(258,b|0,4)|0;g=j[114630];j[114630]=0;ea:{if((g|0)!=1){if(n){break ea}break da}b=D()|0;C()|0;break e}j[114630]=0;n=H(390,b|0)|0;g=j[114630];j[114630]=0;if((g|0)==1){break i}j[114630]=0;I(341,e+96|0,b|0,n|0);n=j[114630];j[114630]=0;if((n|0)==1){break j}fa:{if(!q){break fa}j[114630]=0;n=H(387,e+96|0)|0;g=j[114630];j[114630]=0;if((g|0)==1){break h}j[114630]=0;E(338,e+96|0,1)|0;g=j[114630];j[114630]=0;if((g|0)==1){break h}j[114630]=0;n=K(402,o|0,f&65535,n+1|0)|0;g=j[114630];j[114630]=0;if((g|0)==1){break h}if(!n){break fa}j[114630]=0;K(434,e+96|0,e+48|0,-1)|0;n=j[114630];j[114630]=0;if((n|0)==1){break h}n=Hb(o,f);j[114630]=0;E(435,n|0,e+48|0)|0;n=j[114630];j[114630]=0;if((n|0)==1){break h}n=Hb(o,f);j[114630]=0;I(443,n|0,1,e+96|0);n=j[114630];j[114630]=0;if((n|0)==1){break h}}jb(e+96|0);f=f+1|0;if(f>>>0<(k[d|0]|k[d+1|0]<<8)>>>0){continue}break}}if(!(c&2)){break l}if(!l[a+480190>>1]){break m}d=0;while(1){c=d+1|0;if(!k[bc(t,d)|0]){c=d+1|0;f=p(c,104)+a|0;d=Kc(e+96|0,i[f+484414>>1]&1?16:8,1,0,i[bc(t,d)>>1]>-1?0:6);j[114630]=0;K(400,d|0,f+484380|0,b|0)|0;d=j[114630];j[114630]=0;if((d|0)==1){break n}}d=c;if(d>>>0<l[a+480190>>1]){continue}break}break m}b=D()|0;C()|0;break e}b=D()|0;C()|0;break e}if(!l[a+480190>>1]){break l}b=0;while(1){c=k[bc(t,b)|0];ga:{if(!c){break ga}c=c-1&65535;if(Yb(u)>>>0<=c>>>0){break ga}c=(k[bc(t,b)+1|0]&127)+l[bc(u,c)>>1]&65535;if(c>>>0>l[a+480190>>1]){break ga}f=p(c,104);o=f+a|0;d=o+484380|0;if(!ke(d)){break ga}q=a+484380|0;n=p(b+1|0,104);c=q+n|0;i[c+34>>1]=l[c+34>>1]&65534|i[(f+q|0)+34>>1]&1;j[c>>2]=j[d>>2];j[114630]=0;c=H(465,c|0)|0;f=j[114630];j[114630]=0;if((f|0)==1){break k}if(!c){break ga}c=j[(a+n|0)+484400>>2];j[114630]=0;c=H(466,c|0)|0;f=j[114630];j[114630]=0;if((f|0)==1){break a}f=j[o+484400>>2];j[114630]=0;f=H(466,f|0)|0;o=j[114630];j[114630]=0;if((o|0)==1){break a}Vb(c,f,jk(d))}b=b+1|0;if(b>>>0<l[a+480190>>1]){continue}break}}ff(t);ff(u);break c}b=D()|0;C()|0;break e}b=D()|0;C()|0;break e}b=D()|0;C()|0;break e}b=D()|0;C()|0;jb(e+96|0);break e}b=D()|0;C()|0;break e}b=D()|0;C()|0}ff(t);ff(u)}gb(v);G(b|0);z()}d=1}gb(v)}Za=e+288|0;return d|0}J(0)|0;C()|0;ib();z()}function Yc(a){a=a|0;var b=0,c=0,d=0,e=0,f=0,g=0,h=0,i=0,l=0,n=0,o=0,p=0,q=0,r=0;p=Za-16|0;Za=p;a:{b:{c:{d:{e:{f:{g:{h:{i:{j:{k:{l:{if(a>>>0<=244){f=j[115938];i=a>>>0<11?16:a+11&-8;c=i>>>3|0;b=f>>>c|0;if(b&3){d=c+((b^-1)&1)|0;b=d<<3;e=j[b+463800>>2];a=e+8|0;c=j[e+8>>2];b=b+463792|0;m:{if((c|0)==(b|0)){q=463752,r=MMa(-2,d)&f,j[q>>2]=r;break m}j[c+12>>2]=b;j[b+8>>2]=c}b=d<<3;j[e+4>>2]=b|3;b=b+e|0;j[b+4>>2]=j[b+4>>2]|1;break a}n=j[115940];if(n>>>0>=i>>>0){break l}if(b){a=2<<c;a=(0-a|a)&b<<c;b=(0-a&a)-1|0;a=b>>>12&16;c=a;b=b>>>a|0;a=b>>>5&8;c=c|a;b=b>>>a|0;a=b>>>2&4;c=c|a;b=b>>>a|0;a=b>>>1&2;c=c|a;b=b>>>a|0;a=b>>>1&1;c=(c|a)+(b>>>a|0)|0;a=c<<3;g=j[a+463800>>2];b=j[g+8>>2];a=a+463792|0;n:{if((b|0)==(a|0)){f=MMa(-2,c)&f;j[115938]=f;break n}j[b+12>>2]=a;j[a+8>>2]=b}a=g+8|0;j[g+4>>2]=i|3;d=g+i|0;b=c<<3;e=b-i|0;j[d+4>>2]=e|1;j[b+g>>2]=e;if(n){b=n>>>3|0;c=(b<<3)+463792|0;g=j[115943];b=1<<b;o:{if(!(b&f)){j[115938]=b|f;b=c;break o}b=j[c+8>>2]}j[c+8>>2]=g;j[b+12>>2]=g;j[g+12>>2]=c;j[g+8>>2]=b}j[115943]=d;j[115940]=e;break a}h=j[115939];if(!h){break l}b=(h&0-h)-1|0;a=b>>>12&16;c=a;b=b>>>a|0;a=b>>>5&8;c=c|a;b=b>>>a|0;a=b>>>2&4;c=c|a;b=b>>>a|0;a=b>>>1&2;c=c|a;b=b>>>a|0;a=b>>>1&1;b=j[((c|a)+(b>>>a|0)<<2)+464056>>2];d=(j[b+4>>2]&-8)-i|0;c=b;while(1){p:{a=j[c+16>>2];if(!a){a=j[c+20>>2];if(!a){break p}}c=(j[a+4>>2]&-8)-i|0;e=c>>>0<d>>>0;d=e?c:d;b=e?a:b;c=a;continue}break}l=b+i|0;if(l>>>0<=b>>>0){break k}o=j[b+24>>2];e=j[b+12>>2];if((e|0)!=(b|0)){a=j[b+8>>2];j[a+12>>2]=e;j[e+8>>2]=a;break b}c=b+20|0;a=j[c>>2];if(!a){a=j[b+16>>2];if(!a){break j}c=b+16|0}while(1){g=c;e=a;c=a+20|0;a=j[c>>2];if(a){continue}c=e+16|0;a=j[e+16>>2];if(a){continue}break}j[g>>2]=0;break b}i=-1;if(a>>>0>4294967231){break l}a=a+11|0;i=a&-8;l=j[115939];if(!l){break l}f=31;d=0-i|0;if(i>>>0<=16777215){a=a>>>8|0;g=a+1048320>>>16&8;a=a<<g;c=a+520192>>>16&4;a=a<<c;b=a+245760>>>16&2;a=(a<<b>>>15|0)-(b|(c|g))|0;f=(a<<1|i>>>a+21&1)+28|0}c=j[(f<<2)+464056>>2];q:{r:{s:{if(!c){a=0;break s}a=0;b=i<<((f|0)==31?0:25-(f>>>1|0)|0);while(1){t:{g=(j[c+4>>2]&-8)-i|0;if(g>>>0>=d>>>0){break t}e=c;d=g;if(d){break t}d=0;a=c;break r}g=j[c+20>>2];c=j[((b>>>29&4)+c|0)+16>>2];a=g?(g|0)==(c|0)?a:g:a;b=b<<1;if(c){continue}break}}if(!(a|e)){a=2<<f;a=(0-a|a)&l;if(!a){break l}b=(a&0-a)-1|0;a=b>>>12&16;c=a;b=b>>>a|0;a=b>>>5&8;c=c|a;b=b>>>a|0;a=b>>>2&4;c=c|a;b=b>>>a|0;a=b>>>1&2;c=c|a;b=b>>>a|0;a=b>>>1&1;a=j[((c|a)+(b>>>a|0)<<2)+464056>>2]}if(!a){break q}}while(1){b=(j[a+4>>2]&-8)-i|0;c=b>>>0<d>>>0;d=c?b:d;e=c?a:e;b=j[a+16>>2];if(b){a=b}else{a=j[a+20>>2]}if(a){continue}break}}if(!e|j[115940]-i>>>0<=d>>>0){break l}h=e+i|0;if(h>>>0<=e>>>0){break k}f=j[e+24>>2];b=j[e+12>>2];if((e|0)!=(b|0)){a=j[e+8>>2];j[a+12>>2]=b;j[b+8>>2]=a;break c}c=e+20|0;a=j[c>>2];if(!a){a=j[e+16>>2];if(!a){break i}c=e+16|0}while(1){g=c;b=a;c=a+20|0;a=j[c>>2];if(a){continue}c=b+16|0;a=j[b+16>>2];if(a){continue}break}j[g>>2]=0;break c}c=j[115940];if(c>>>0>=i>>>0){d=j[115943];b=c-i|0;u:{if(b>>>0>=16){j[115940]=b;a=d+i|0;j[115943]=a;j[a+4>>2]=b|1;j[c+d>>2]=b;j[d+4>>2]=i|3;break u}j[115943]=0;j[115940]=0;j[d+4>>2]=c|3;a=c+d|0;j[a+4>>2]=j[a+4>>2]|1}a=d+8|0;break a}h=j[115941];if(h>>>0>i>>>0){b=h-i|0;j[115941]=b;c=j[115944];a=c+i|0;j[115944]=a;j[a+4>>2]=b|1;j[c+4>>2]=i|3;a=c+8|0;break a}a=0;l=i+47|0;b=l;if(j[116056]){c=j[116058]}else{j[116059]=-1;j[116060]=-1;j[116057]=4096;j[116058]=4096;j[116056]=p+12&-16^1431655768;j[116061]=0;j[116049]=0;c=4096}g=b+c|0;e=0-c|0;c=g&e;if(c>>>0<=i>>>0){break a}d=j[116048];if(d){b=j[116046];f=b+c|0;if(d>>>0<f>>>0|b>>>0>=f>>>0){break a}}if(k[464196]&4){break f}v:{w:{d=j[115944];if(d){a=464200;while(1){b=j[a>>2];if(d>>>0<b+j[a+4>>2]>>>0?b>>>0<=d>>>0:0){break w}a=j[a+8>>2];if(a){continue}break}}b=Ak(0);if((b|0)==-1){break g}f=c;d=j[116057];a=d-1|0;if(a&b){f=(c-b|0)+(a+b&0-d)|0}if(f>>>0<=i>>>0|f>>>0>2147483646){break g}d=j[116048];if(d){a=j[116046];e=a+f|0;if(d>>>0<e>>>0|a>>>0>=e>>>0){break g}}a=Ak(f);if((b|0)!=(a|0)){break v}break e}f=e&g-h;if(f>>>0>2147483646){break g}b=Ak(f);if((b|0)==(j[a>>2]+j[a+4>>2]|0)){break h}a=b}if(!((a|0)==-1|i+48>>>0<=f>>>0)){b=j[116058];b=b+(l-f|0)&0-b;if(b>>>0>2147483646){b=a;break e}if((Ak(b)|0)!=-1){f=b+f|0;b=a;break e}Ak(0-f|0);break g}b=a;if((a|0)!=-1){break e}break g}z()}e=0;break b}b=0;break c}if((b|0)!=-1){break e}}j[116049]=j[116049]|4}if(c>>>0>2147483646){break d}b=Ak(c);a=Ak(0);if(b>>>0>=a>>>0|(b|0)==-1|(a|0)==-1){break d}f=a-b|0;if(f>>>0<=i+40>>>0){break d}}a=j[116046]+f|0;j[116046]=a;if(a>>>0>m[116047]){j[116047]=a}x:{y:{z:{g=j[115944];if(g){a=464200;while(1){d=j[a>>2];c=j[a+4>>2];if((d+c|0)==(b|0)){break z}a=j[a+8>>2];if(a){continue}break}break y}a=j[115942];if(!(a>>>0<=b>>>0?a:0)){j[115942]=b}a=0;j[116051]=f;j[116050]=b;j[115946]=-1;j[115947]=j[116056];j[116053]=0;while(1){d=a<<3;c=d+463792|0;j[d+463800>>2]=c;j[d+463804>>2]=c;a=a+1|0;if((a|0)!=32){continue}break}d=f-40|0;a=b+8&7?-8-b&7:0;c=d-a|0;j[115941]=c;a=a+b|0;j[115944]=a;j[a+4>>2]=c|1;j[(b+d|0)+4>>2]=40;j[115945]=j[116060];break x}if(j[a+12>>2]&8|(b>>>0<=g>>>0|d>>>0>g>>>0)){break y}j[a+4>>2]=c+f;a=g+8&7?-8-g&7:0;c=a+g|0;j[115944]=c;b=j[115941]+f|0;a=b-a|0;j[115941]=a;j[c+4>>2]=a|1;j[(b+g|0)+4>>2]=40;j[115945]=j[116060];break x}if(m[115942]>b>>>0){j[115942]=b}c=b+f|0;a=464200;A:{B:{C:{D:{E:{F:{while(1){if((c|0)!=j[a>>2]){a=j[a+8>>2];if(a){continue}break F}break}if(!(k[a+12|0]&8)){break E}}a=464200;while(1){c=j[a>>2];if(c>>>0<=g>>>0){e=c+j[a+4>>2]|0;if(e>>>0>g>>>0){break D}}a=j[a+8>>2];continue}}j[a>>2]=b;j[a+4>>2]=j[a+4>>2]+f;l=(b+8&7?-8-b&7:0)+b|0;j[l+4>>2]=i|3;f=c+(c+8&7?-8-c&7:0)|0;c=(f-l|0)-i|0;h=i+l|0;if((f|0)==(g|0)){j[115944]=h;a=j[115941]+c|0;j[115941]=a;j[h+4>>2]=a|1;break B}if(j[115943]==(f|0)){j[115943]=h;a=j[115940]+c|0;j[115940]=a;j[h+4>>2]=a|1;j[a+h>>2]=a;break B}a=j[f+4>>2];if((a&3)==1){g=a&-8;G:{if(a>>>0<=255){d=j[f+8>>2];a=a>>>3|0;b=j[f+12>>2];if((b|0)==(d|0)){q=463752,r=j[115938]&MMa(-2,a),j[q>>2]=r;break G}j[d+12>>2]=b;j[b+8>>2]=d;break G}i=j[f+24>>2];b=j[f+12>>2];H:{if((f|0)!=(b|0)){a=j[f+8>>2];j[a+12>>2]=b;j[b+8>>2]=a;break H}I:{a=f+20|0;d=j[a>>2];if(d){break I}a=f+16|0;d=j[a>>2];if(d){break I}b=0;break H}while(1){e=a;b=d;a=b+20|0;d=j[a>>2];if(d){continue}a=b+16|0;d=j[b+16>>2];if(d){continue}break}j[e>>2]=0}if(!i){break G}d=j[f+28>>2];a=(d<<2)+464056|0;J:{if(j[a>>2]==(f|0)){j[a>>2]=b;if(b){break J}q=463756,r=j[115939]&MMa(-2,d),j[q>>2]=r;break G}j[i+(j[i+16>>2]==(f|0)?16:20)>>2]=b;if(!b){break G}}j[b+24>>2]=i;a=j[f+16>>2];if(a){j[b+16>>2]=a;j[a+24>>2]=b}a=j[f+20>>2];if(!a){break G}j[b+20>>2]=a;j[a+24>>2]=b}f=f+g|0;c=c+g|0}j[f+4>>2]=j[f+4>>2]&-2;j[h+4>>2]=c|1;j[c+h>>2]=c;if(c>>>0<=255){a=c>>>3|0;b=(a<<3)+463792|0;c=j[115938];a=1<<a;K:{if(!(c&a)){j[115938]=a|c;a=b;break K}a=j[b+8>>2]}j[b+8>>2]=h;j[a+12>>2]=h;j[h+12>>2]=b;j[h+8>>2]=a;break B}a=31;if(c>>>0<=16777215){a=c>>>8|0;e=a+1048320>>>16&8;a=a<<e;d=a+520192>>>16&4;a=a<<d;b=a+245760>>>16&2;a=(a<<b>>>15|0)-(b|(d|e))|0;a=(a<<1|c>>>a+21&1)+28|0}j[h+28>>2]=a;j[h+16>>2]=0;j[h+20>>2]=0;e=(a<<2)+464056|0;d=j[115939];b=1<<a;L:{if(!(d&b)){j[115939]=b|d;j[e>>2]=h;j[h+24>>2]=e;break L}a=c<<((a|0)==31?0:25-(a>>>1|0)|0);b=j[e>>2];while(1){d=b;if((j[b+4>>2]&-8)==(c|0)){break C}b=a>>>29|0;a=a<<1;e=d+(b&4)|0;b=j[e+16>>2];if(b){continue}break}j[e+16>>2]=h;j[h+24>>2]=d}j[h+12>>2]=h;j[h+8>>2]=h;break B}d=f-40|0;a=b+8&7?-8-b&7:0;c=d-a|0;j[115941]=c;a=a+b|0;j[115944]=a;j[a+4>>2]=c|1;j[(b+d|0)+4>>2]=40;j[115945]=j[116060];a=(e+(e-39&7?39-e&7:0)|0)-47|0;c=a>>>0<g+16>>>0?g:a;j[c+4>>2]=27;a=j[116053];j[c+16>>2]=j[116052];j[c+20>>2]=a;a=j[116051];j[c+8>>2]=j[116050];j[c+12>>2]=a;j[116052]=c+8;j[116051]=f;j[116050]=b;j[116053]=0;a=c+24|0;while(1){j[a+4>>2]=7;b=a+8|0;a=a+4|0;if(b>>>0<e>>>0){continue}break}if((c|0)==(g|0)){break x}j[c+4>>2]=j[c+4>>2]&-2;e=c-g|0;j[g+4>>2]=e|1;j[c>>2]=e;if(e>>>0<=255){a=e>>>3|0;b=(a<<3)+463792|0;c=j[115938];a=1<<a;M:{if(!(c&a)){j[115938]=a|c;a=b;break M}a=j[b+8>>2]}j[b+8>>2]=g;j[a+12>>2]=g;j[g+12>>2]=b;j[g+8>>2]=a;break x}a=31;j[g+16>>2]=0;j[g+20>>2]=0;if(e>>>0<=16777215){a=e>>>8|0;d=a+1048320>>>16&8;a=a<<d;c=a+520192>>>16&4;a=a<<c;b=a+245760>>>16&2;a=(a<<b>>>15|0)-(b|(c|d))|0;a=(a<<1|e>>>a+21&1)+28|0}j[g+28>>2]=a;d=(a<<2)+464056|0;c=j[115939];b=1<<a;N:{if(!(c&b)){j[115939]=b|c;j[d>>2]=g;j[g+24>>2]=d;break N}a=e<<((a|0)==31?0:25-(a>>>1|0)|0);b=j[d>>2];while(1){c=b;if((e|0)==(j[b+4>>2]&-8)){break A}b=a>>>29|0;a=a<<1;d=c+(b&4)|0;b=j[d+16>>2];if(b){continue}break}j[d+16>>2]=g;j[g+24>>2]=c}j[g+12>>2]=g;j[g+8>>2]=g;break x}a=j[d+8>>2];j[a+12>>2]=h;j[d+8>>2]=h;j[h+24>>2]=0;j[h+12>>2]=d;j[h+8>>2]=a}a=l+8|0;break a}a=j[c+8>>2];j[a+12>>2]=g;j[c+8>>2]=g;j[g+24>>2]=0;j[g+12>>2]=c;j[g+8>>2]=a}a=j[115941];if(a>>>0<=i>>>0){break d}b=a-i|0;j[115941]=b;c=j[115944];a=c+i|0;j[115944]=a;j[a+4>>2]=b|1;j[c+4>>2]=i|3;a=c+8|0;break a}j[114604]=48;a=0;break a}O:{if(!f){break O}c=j[e+28>>2];a=(c<<2)+464056|0;P:{if(j[a>>2]==(e|0)){j[a>>2]=b;if(b){break P}l=MMa(-2,c)&l;j[115939]=l;break O}j[f+(j[f+16>>2]==(e|0)?16:20)>>2]=b;if(!b){break O}}j[b+24>>2]=f;a=j[e+16>>2];if(a){j[b+16>>2]=a;j[a+24>>2]=b}a=j[e+20>>2];if(!a){break O}j[b+20>>2]=a;j[a+24>>2]=b}Q:{if(d>>>0<=15){a=d+i|0;j[e+4>>2]=a|3;a=a+e|0;j[a+4>>2]=j[a+4>>2]|1;break Q}j[e+4>>2]=i|3;j[h+4>>2]=d|1;j[d+h>>2]=d;if(d>>>0<=255){a=d>>>3|0;b=(a<<3)+463792|0;c=j[115938];a=1<<a;R:{if(!(c&a)){j[115938]=a|c;a=b;break R}a=j[b+8>>2]}j[b+8>>2]=h;j[a+12>>2]=h;j[h+12>>2]=b;j[h+8>>2]=a;break Q}a=31;if(d>>>0<=16777215){a=d>>>8|0;g=a+1048320>>>16&8;a=a<<g;c=a+520192>>>16&4;a=a<<c;b=a+245760>>>16&2;a=(a<<b>>>15|0)-(b|(c|g))|0;a=(a<<1|d>>>a+21&1)+28|0}j[h+28>>2]=a;j[h+16>>2]=0;j[h+20>>2]=0;c=(a<<2)+464056|0;S:{b=1<<a;T:{if(!(b&l)){j[115939]=b|l;j[c>>2]=h;j[h+24>>2]=c;break T}a=d<<((a|0)==31?0:25-(a>>>1|0)|0);i=j[c>>2];while(1){b=i;if((j[b+4>>2]&-8)==(d|0)){break S}c=a>>>29|0;a=a<<1;c=b+(c&4)|0;i=j[c+16>>2];if(i){continue}break}j[c+16>>2]=h;j[h+24>>2]=b}j[h+12>>2]=h;j[h+8>>2]=h;break Q}a=j[b+8>>2];j[a+12>>2]=h;j[b+8>>2]=h;j[h+24>>2]=0;j[h+12>>2]=b;j[h+8>>2]=a}a=e+8|0;break a}U:{if(!o){break U}c=j[b+28>>2];a=(c<<2)+464056|0;V:{if(j[a>>2]==(b|0)){j[a>>2]=e;if(e){break V}q=463756,r=MMa(-2,c)&h,j[q>>2]=r;break U}j[(j[o+16>>2]==(b|0)?16:20)+o>>2]=e;if(!e){break U}}j[e+24>>2]=o;a=j[b+16>>2];if(a){j[e+16>>2]=a;j[a+24>>2]=e}a=j[b+20>>2];if(!a){break U}j[e+20>>2]=a;j[a+24>>2]=e}W:{if(d>>>0<=15){a=d+i|0;j[b+4>>2]=a|3;a=a+b|0;j[a+4>>2]=j[a+4>>2]|1;break W}j[b+4>>2]=i|3;j[l+4>>2]=d|1;j[d+l>>2]=d;if(n){a=n>>>3|0;c=(a<<3)+463792|0;e=j[115943];a=1<<a;X:{if(!(a&f)){j[115938]=a|f;a=c;break X}a=j[c+8>>2]}j[c+8>>2]=e;j[a+12>>2]=e;j[e+12>>2]=c;j[e+8>>2]=a}j[115943]=l;j[115940]=d}a=b+8|0}Za=p+16|0;return a|0}function YIa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,F=0,I=0,J=0;f=Za+ -64|0;Za=f;rc(a);a:{b:{if(b>>>0<=2){I=f,J=dd(a),h[I+56|0]=J;Jb(a,2);e=f+56|2;b=Of(a);h[e|0]=b;h[e+1|0]=b>>>8;e=f+56|4;b=hf(a);h[e|0]=b;h[e+1|0]=b>>>8;h[e+2|0]=b>>>16;h[e+3|0]=b>>>24;break b}kf(a,f+56|0);if(b>>>0>5){break a}}h[f+56|1]=0}c:{t=d+484344|0;b=f+56|2;x=kd(k[b|0]|k[b+1|0]<<8,1,1024);s=ww(t,x,0);if((s|0)!=65535){e=Fp(Hb(t,s),0);i[f>>1]=l[d+480188>>1]-1;i[f+40>>1]=k[f+56|0];y=l[gf(f,f+40|0)>>1];g=y+1|0;if(l[d+480188>>1]>(g&65535)>>>0){b=g&65535;while(1){h[e+p(b,6)|0]=254;b=b+1|0;if(b>>>0<l[d+480188>>1]){continue}break}}h[c+13|0]=k[f+56|1]>>>4;b=k[c+12|0];h[f|0]=0;u=it(f+40|0,g,f);if(x){b=(b|0)!=0;while(1){d:{e:{if(!k[fc(u,0)|0]){j[114630]=0;g=H(387,a|0)|0;e=j[114630];j[114630]=0;if((e|0)==1){break c}r=g<<24>>24;if((r|0)<=-1){j[114630]=0;g=H(387,a|0)|0;e=j[114630];j[114630]=0;if((e|0)==1){break c}I=fc(u,0),J=g,h[I|0]=J}A=0;h[f|0]=0;m=r&63;f:{g:{if(!m){break g}j[114630]=0;e=H(387,a|0)|0;g=j[114630];j[114630]=0;if((g|0)==1){break c}h[f|0]=e;r=0;h:{switch(m-1|0){case 0:h[c+12|0]=0;j[114630]=0;h[f+36|0]=1;e=E(453,f+36|0,f|0)|0;b=j[114630];j[114630]=0;if((b|0)!=1){h[c+14|0]=k[e|0];h[c+15|0]=0;b=1;break f}break c;case 1:if(!e){break f}h[c+15|0]=e;b=1;h[c+12|0]=1;g=k[c+13|0];if(!g){break g}h[c+14|0]=p(p(e,g),15);break g;case 2:e=e>>>4|0;h[c+13|0]=e;if(e){b=k[c+12|0]!=0;break f}h[c+12|0]=0;break f;case 3:r=e;break f;case 5:if(!e){break f}b=(k[c+12|0]?15:14)+c|0;g=k[b|0];h[b|0]=g>>>0<256-e>>>0?e+g|0:-1;b=1;break g;case 6:break h;default:break f}}if(!e){break f}b=1;g=(k[c+12|0]?15:14)+c|0;r=k[g|0];h[g|0]=r>>>0>e+1>>>0?r-e|0:1}r=0}j[f+36>>2]=0;j[f+32>>2]=0;if(b&1){break e}break d}r=0;e=fc(u,0);h[e|0]=k[e|0]-1;j[f+36>>2]=0;j[f+32>>2]=0;A=0;if(!(b&1)){break d}}b=k[c+12|0];e=k[c+13|0];if(e?0:b){break d}i:{if(b){j[f>>2]=1;b=k[c+15|0];j[114630]=0;j[f+28>>2]=p(b,e)<<1;e=E(552,f|0,f+28|0)|0;b=j[114630];j[114630]=0;if((b|0)==1){break c}g=j[e>>2];break i}g=p(k[c+14|0],30)+30|0}b=255;j[f+36>>2]=255;while(1){o=p(b,g);if(o-1536>>>0>=10752){e=b-1|0;j[f+36>>2]=e;m=b>>>0<2;b=e;if(!m){continue}}break}j[f+32>>2]=(o|0)/48;Md(f+32|0,32,255);j[114630]=0;j[f>>2]=1;e=E(552,f|0,f+36|0)|0;b=j[114630];j[114630]=0;if((b|0)==1){break c}h[c+16|0]=j[e>>2];A=1}b=Hb(t,s);j[114630]=0;b=K(471,b|0,q|0,1)|0;e=j[114630];j[114630]=0;if((e|0)==1){break c}if(y){B=q-1|0;n=1;v=1;while(1){j:{if(!k[fc(u,n)|0]){j[114630]=0;o=H(387,a|0)|0;e=j[114630];j[114630]=0;if((e|0)==1){break c}if(o&128){j[114630]=0;g=H(387,a|0)|0;e=j[114630];j[114630]=0;if((e|0)==1){break c}I=fc(u,n),J=g,h[I|0]=J}F=1;if(o&64){j[114630]=0;g=H(387,a|0)|0;e=j[114630];j[114630]=0;if((e|0)==1){break c}h[b+1|0]=g;F=!g}k:{if(!(o&32)){break k}j[114630]=0;g=H(387,a|0)|0;e=j[114630];j[114630]=0;if((e|0)==1){break c}h[b|0]=g;if((g-1&255)>>>0<=107){e=pp(g+24|0);h[b|0]=e;I=wc(c,n),J=e,h[I+1|0]=J;break k}if((g+127&255)>>>0<=107){e=pp((g&127)+24|0);h[b|0]=e;I=wc(c,n),J=e,h[I|0]=J;h[b|0]=0;break k}if((g|0)!=255){break k}h[b|0]=254}if(!(k[b|0]|!k[b+1|0])){e=k[wc(c,n)+1|0];h[b+1|0]=0;h[b|0]=e}j[114630]=0;g=H(553,b|0)|0;e=j[114630];j[114630]=0;if((e|0)==1){break c}if(g){I=wc(c,n),J=0,h[I+5|0]=J}h[f+27|0]=0;h[f+26|0]=0;h[f+25|0]=0;h[f+24|0]=0;h[f+23|0]=0;h[f+22|0]=0;if(o&16){h[b+2|0]=1;j[114630]=0;g=H(387,a|0)|0;e=j[114630];j[114630]=0;if((e|0)==1){break c}h[b+4|0]=g+2>>>2}l:{if(!(o&8)){break l}j[114630]=0;g=H(387,a|0)|0;e=j[114630];j[114630]=0;if((e|0)==1){break c}j[114630]=0;h[f+27|0]=g;g=H(387,a|0)|0;e=j[114630];j[114630]=0;if((e|0)==1){break c}h[f+24|0]=g;m:{n:{o:{p:{q:{r:{s:{t:{e=k[f+27|0];switch(e-1|0){case 0:break n;case 9:break o;case 5:case 6:case 7:case 8:break p;case 4:break q;case 3:break r;case 2:break s;case 1:break t;default:break m}}h[b|0]=255;break m}I=b,J=k[wc(c,n)+1|0],h[I|0]=J;I=wc(c,n),J=0,h[I+5|0]=J;break m}e=ht(g,k[c+16|0]);h[f+24|0]=e;u:{if(e){h[f+27|0]=20;h[f+24|0]=e|208;break u}h[f+27|0]=0}if(k[b|0]){break l}I=b,J=k[wc(c,n)+1|0],h[I|0]=J;I=wc(c,n),J=0,h[I+5|0]=J;break l}h[f|0]=1;e=ht(g,k[c+16|0]);j[114630]=0;h[f+28|0]=e;g=E(453,f|0,f+28|0)|0;e=j[114630];j[114630]=0;if((e|0)!=1){h[f+24|0]=k[g|0];h[f+27|0]=15;I=wc(c,n),J=0,h[I+5|0]=J;break l}break c}v:{if(!q){break v}if((e|0)==k[wc(c,n)+4|0]){break v}m=Hb(t,s);j[114630]=0;g=K(497,f|0,20,(k[f+27|0]+122|160)&255)|0;e=j[114630];j[114630]=0;if((e|0)==1){break c}e=hn(gn(Ee(g,B),v&65535));j[114630]=0;g=E(498,m|0,e|0)|0;e=j[114630];j[114630]=0;if((e|0)==1){break c}if(!g){break v}e=k[f+27|0];I=wc(c,n),J=e,h[I+4|0]=J}h[f+27|0]=10;if(!k[b|0]){I=b,J=k[wc(c,n)+1|0],h[I|0]=J}I=wc(c,n),J=0,h[I+5|0]=J;break l}h[f+27|0]=20;I=f,J=k[wc(c,n)+5|0]?-98:-97,h[I+24|0]=J;e=k[wc(c,n)+5|0];I=wc(c,n),J=e^1,h[I+5|0]=J;break l}h[b|0]=254}h[f+27|0]=0}w=0;g=0;w:{if(!(o&4)){break w}j[114630]=0;g=H(387,a|0)|0;e=j[114630];j[114630]=0;if((e|0)==1){break c}j[114630]=0;h[f+26|0]=g;g=H(387,a|0)|0;e=j[114630];j[114630]=0;if((e|0)==1){break c}g=g<<24>>24;h[f+23|0]=g;e=f;x:{y:{z:{A:{B:{C:{D:{E:{F:{G:{H:{m=k[f+26|0];switch(m-1|0){case 11:break z;case 10:break A;case 7:case 8:case 9:break B;case 6:break C;case 5:break D;case 3:case 4:break E;case 2:break F;case 1:break G;case 0:break H;default:break y}}e=(g|0)>-1;h[f+26|0]=e?2:3;if(!e){g=0-g|0;h[f+23|0]=g}I:{if((g&255)>>>0<16){break I}j[114630]=0;g=H(553,b|0)|0;e=j[114630];j[114630]=0;if((e|0)==1){break c}if(!g){break I}J:{if(k[f+26|0]==2){e=k[b|0];j[114630]=0;j[f>>2]=e+(k[f+23|0]>>>4|0);j[f+28>>2]=120;g=E(462,f|0,f+28|0)|0;e=j[114630];j[114630]=0;if((e|0)!=1){break J}break c}e=k[b|0];j[114630]=0;j[f>>2]=e-(k[f+23|0]>>>4|0);j[f+28>>2]=1;g=E(552,f|0,f+28|0)|0;e=j[114630];j[114630]=0;if((e|0)==1){break c}}h[b|0]=j[g>>2];h[f+23|0]=k[f+23|0]&15}j[114630]=0;h[f|0]=15;g=E(391,f|0,f+23|0)|0;e=j[114630];j[114630]=0;if((e|0)!=1){h[f+23|0]=k[g|0]|240;g=0;break w}break c}e=ht(g&255,k[c+16|0]);h[f+23|0]=e;if(e){h[f+26|0]=20;h[f+23|0]=e|208;g=1;break w}h[f+26|0]=0;g=1;break w}g=1;break x}e=k[c+16|0];j[114630]=0;g=K(554,g&255,e|0,1)|0;e=j[114630];j[114630]=0;if((e|0)==1){break c}h[f+23|0]=g;h[f+26|0]=k[f+26|0]==4?2:3;g=1;break w}if(!k[b|0]){I=b,J=k[wc(c,n)|0],h[I|0]=J;g=k[f+23|0]}e=k[c+16|0];j[114630]=0;g=K(554,g&255,e|0,0)|0;e=j[114630];j[114630]=0;if((e|0)==1){break c}h[f+26|0]=4;h[f+23|0]=g;g=1;break w}I=b,J=pp((g&255)+25|0),h[I|0]=J;h[f+23|0]=255;h[f+26|0]=4;g=1;break w}K:{if(!q){break K}if((m|0)==k[wc(c,n)+2|0]){break K}m=Hb(t,s);j[114630]=0;g=K(497,f|0,20,(k[f+26|0]-8|48)&255)|0;e=j[114630];j[114630]=0;if((e|0)==1){break c}e=hn(gn(Ee(g,B),v&65535));j[114630]=0;g=E(498,m|0,e|0)|0;e=j[114630];j[114630]=0;if((e|0)==1){break c}if(!g){break K}e=k[f+26|0];I=wc(c,n),J=e,h[I+2|0]=J}h[f+26|0]=5;e=k[c+16|0];j[114630]=0;g=E(555,k[f+23|0],e|0)|0;e=j[114630];j[114630]=0;if((e|0)==1){break c}h[f+23|0]=g;g=1;break w}e=tR(g&255,k[c+16|0]);h[f+26|0]=18;h[f+23|0]=e;g=1;break w}e=ht(g&255,k[c+16|0]);h[f+23|0]=e;if(e){h[f+26|0]=20;h[f+23|0]=e|192;g=1;break w}h[f+26|0]=0;h[b|0]=254;g=1;break w}g=0}h[e+26|0]=g}L:{if(!(o&2)){break L}j[114630]=0;m=H(387,a|0)|0;e=j[114630];j[114630]=0;if((e|0)==1){break c}j[114630]=0;h[f+25|0]=m;o=H(387,a|0)|0;e=j[114630];j[114630]=0;if((e|0)==1){break c}h[f+22|0]=o;M:{N:{O:{P:{Q:{R:{S:{m=k[f+25|0];switch(m-1|0){case 9:break N;case 7:case 8:break O;case 6:break P;case 3:case 4:case 5:break Q;case 2:break R;case 0:case 1:break S;default:break M}}e=k[c+16|0];j[114630]=0;m=K(556,o|0,e|0,(m|0)==1|0)|0;e=j[114630];j[114630]=0;if((e|0)==1){break c}h[f+25|0]=11;h[f+22|0]=m;w=1;break L}e=tR(o,k[c+16|0]);h[f+25|0]=18;h[f+22|0]=e;w=1;break L}T:{if(!q){break T}if((m|0)==k[wc(c,n)+3|0]){break T}o=Hb(t,s);j[114630]=0;m=K(497,f|0,20,(k[f+25|0]-4|64)&255)|0;e=j[114630];j[114630]=0;if((e|0)==1){break c}e=hn(gn(Ee(m,B),v&65535));j[114630]=0;m=E(498,o|0,e|0)|0;e=j[114630];j[114630]=0;if((e|0)==1){break c}if(!m){break T}e=k[f+25|0];I=wc(c,n),J=e,h[I+3|0]=J}h[f+25|0]=8;e=k[c+16|0];j[114630]=0;m=E(555,k[f+22|0],e|0)|0;e=j[114630];j[114630]=0;if((e|0)==1){break c}h[f+22|0]=m;w=1;break L}h[f+25|0]=9;break L}e=k[c+16|0];j[114630]=0;m=K(556,o|0,e|0,(m|0)==8|0)|0;e=j[114630];j[114630]=0;if((e|0)==1){break c}h[f+25|0]=29;h[f+22|0]=m;w=1;break L}h[f+25|0]=27;e=k[c+16|0];j[114630]=0;m=E(555,o|0,e|0)|0;e=j[114630];j[114630]=0;if((e|0)==1){break c}h[f+22|0]=m;w=1;break L}h[f+25|0]=0}if(g){sR(b,q,l[d+480188>>1],k[f+26|0],f+23|0)}if(w){sR(b,q,l[d+480188>>1],k[f+25|0],f+22|0)}U:{if(!F){break U}j[114630]=0;g=H(553,b|0)|0;e=j[114630];j[114630]=0;if((e|0)==1){break c}if(!g){break U}e=k[f+26|0];if(!e){h[f+23|0]=255;h[f+26|0]=4;break U}if(k[f+25|0]|(e|0)==4){break U}h[f+22|0]=255;h[f+25|0]=4}V:{if(k[b+2|0]!=1){break V}W:{if(!k[f+26|0]){h[f+26|0]=13;h[f+23|0]=k[b+4|0];break W}if(k[f+25|0]){break V}h[f+25|0]=13;h[f+22|0]=k[b+4|0]}h[b+2|0]=0}j[114630]=0;V(499,f|0,f+26|0,f+23|0,f+25|0,f+22|0);e=j[114630];j[114630]=0;if((e|0)==1){break c}X:{if(k[b+2|0]){break X}e=k[f+26|0];if(!e){break X}h[b+2|0]=e;h[b+4|0]=k[f+23|0]}e=b;Y:{if(k[f+27|0]){j[114630]=0;V(499,f|0,f+25|0,f+22|0,f+27|0,f+24|0);g=j[114630];j[114630]=0;if((g|0)==1){break c}Z:{if(k[b+2|0]){break Z}g=k[f+25|0];if(!g){break Z}h[b+2|0]=g;h[b+4|0]=k[f+22|0]}h[b+3|0]=k[f+27|0];g=f+24|0;break Y}g=k[f+25|0];if(!g){break j}h[b+3|0]=g;g=f+22|0}h[e+5|0]=k[g|0];break j}e=fc(u,n);h[e|0]=k[e|0]-1}b=b+6|0;v=v+1|0;n=v&65535;if(y>>>0>=n>>>0){continue}break}}_:{if(!A){break _}g=Hb(t,s);j[114630]=0;e=K(497,f|0,17,k[f+32|0])|0;b=j[114630];j[114630]=0;if((b|0)==1){break c}b=qi(gn(Ee(e,q),0));j[114630]=0;E(498,g|0,b|0)|0;b=j[114630];j[114630]=0;if((b|0)==1){break c}g=Hb(t,s);j[114630]=0;e=K(497,f|0,16,k[f+36|0])|0;b=j[114630];j[114630]=0;if((b|0)!=1){b=qi(Ee(e,q));j[114630]=0;E(498,g|0,b|0)|0;b=j[114630];j[114630]=0;if((b|0)!=1){break _}}break c}$:{if(!(r&240)){break $}g=Hb(t,s);j[114630]=0;e=K(497,f|0,20,r>>>4|224)|0;b=j[114630];j[114630]=0;if((b|0)!=1){b=qR(Ee(e,q));j[114630]=0;E(498,g|0,b|0)|0;b=j[114630];j[114630]=0;if((b|0)!=1){break $}}break c}aa:{e=r&15;if(!e){break aa}b=k[c+16|0];g=Hb(t,s);b=kd((p(b,e)>>>0)/15&255,1,15);j[114630]=0;e=K(497,f|0,20,b|96)|0;b=j[114630];j[114630]=0;if((b|0)!=1){b=qR(Ee(e,q));j[114630]=0;E(498,g|0,b|0)|0;b=j[114630];j[114630]=0;if((b|0)!=1){break aa}}break c}b=0;q=q+1|0;if((x|0)!=(q|0)){continue}break}}Od(u)}Za=f- -64|0;return s|0}a=D()|0;C()|0;Od(u);G(a|0);z()}function Wka(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0;d=Za-720|0;Za=d;rc(b);a:{b:{c:{d:{e:{f:{g:{h:{i:{j:{k:{l:{m:{n:{o:{p:{q:{r:{s:{t:{u:{v:{w:{x:{y:{z:{A:{B:{C:{D:{if(!kf(b,d+712|0)){break D}if(!WI(d+712|0)){break D}if(!Us(b,d+704|0)){break D}if(!VI(d+704|0)){break D}n=1313423693;f=k[d+704|0]|k[d+705|0]<<8|(k[d+706|0]<<16|k[d+707|0]<<24);if((f|0)!=1179012417){n=1414090313;if((f|0)!=538987841){break D}}r=tl(d+688|0,b);o=Hw(d+672|0);E:{F:{G:{H:{I:{J:{K:{L:{M:{if(!c){j[114630]=0;L(1530,d+112|0,r|0,((f|0)==1179012417?1:2)|0,n|0);b=j[114630];j[114630]=0;if((b|0)!=1){break M}a=D()|0;C()|0;break a}j[114630]=0;I(1531,d+112|0,r|0,((f|0)==1179012417?1:2)|0);b=j[114630];j[114630]=0;if((b|0)==1){break L}}zka(o,d+112|0);Zk(d+112|0);j[114630]=0;I(1532,d+656|0,o|0,n|0);b=j[114630];j[114630]=0;if((b|0)!=1){j[114630]=0;b=H(337,d+656|0)|0;g=j[114630];j[114630]=0;if((g|0)==1){break G}g=0;if(!b){break E}j[114630]=0;b=E(1533,d+656|0,d+576|0)|0;n=j[114630];j[114630]=0;if((n|0)==1){break G}if(!b|!k[d+641|0]){break E}b=k[d+641|0];j[114630]=0;g=E(258,d+656|0,b|0)|0;b=j[114630];j[114630]=0;if((b|0)==1){break G}if(!c|g^1){break E}j[114630]=0;F(447,a|0,8388608);b=j[114630];j[114630]=0;if((b|0)==1){break G}j[a+480208>>2]=12;j[a+480208>>2]=j[a+480208>>2]&-17|(k[d+640|0]<<4^-1)&16;b=k[d+641|0];j[114630]=0;i[d+112>>1]=b;i[d+480>>1]=127;b=E(477,d+112|0,d+480|0)|0;g=j[114630];j[114630]=0;if((g|0)==1){break K}i[a+480188>>1]=l[b>>1];j[a+480196>>2]=k[d+642|0];j[a+480204>>2]=p(k[d+643|0],1e4);j[a+480200>>2]=k[d+648|0]<<1;j[114630]=0;E(238,a+1304436|0,((f|0)==1179012417?31715:31681)|0)|0;b=j[114630];j[114630]=0;if((b|0)==1){break G}j[114630]=0;b=E(2,d+112|0,31749)|0;g=j[114630];j[114630]=0;if((g|0)==1){break I}ob(a+1304448|0,b);gb(b);j[a+1304496>>2]=4;j[114630]=0;I(1534,d+480|0,2,d+576|0);b=j[114630];j[114630]=0;if((b|0)==1){break J}j[114630]=0;F(415,d+112|0,d+480|0);b=j[114630];j[114630]=0;if((b|0)==1){break J}ob(a+1304400|0,d+112|0);gb(d+112|0);if(!l[a+480188>>1]){break H}m=(f|0)==1179012417;b=0;while(1){j[114630]=0;n=(b<<5)+a|0;e=n+480280|0;N(432,e|0);g=j[114630];j[114630]=0;N:{O:{P:{Q:{R:{if((g|0)!=1){j[114630]=0;g=H(387,d+656|0)|0;q=j[114630];j[114630]=0;if((q|0)==1){break R}if(m){break Q}if(g>>>0<129){break P}break O}a=D()|0;C()|0;break b}a=D()|0;C()|0;break b}if(g<<24>>24<=-1){break O}j[114630]=0;j[d+112>>2]=g<<2;j[d+480>>2]=256;g=E(462,d+112|0,d+480|0)|0;e=j[114630];j[114630]=0;if((e|0)!=1){i[n+480284>>1]=j[g>>2];break N}a=D()|0;C()|0;break b}i[n+480284>>1]=g<<1;break N}j[e>>2]=1024}b=b+1|0;if(b>>>0<l[a+480188>>1]){continue}break}break H}a=D()|0;C()|0;break a}a=D()|0;C()|0;break a}a=D()|0;C()|0;break b}a=D()|0;C()|0;break b}a=D()|0;C()|0;break b}j[114630]=0;b=E(1535,o|0,1380209231)|0;g=j[114630];j[114630]=0;if((g|0)!=1){break F}}a=D()|0;C()|0;break b}if(b){j[114630]=0;I(1532,d+112|0,o|0,1380209231);b=j[114630];j[114630]=0;if((b|0)==1){break c}j[114630]=0;b=H(387,d+112|0)|0;g=j[114630];j[114630]=0;if((g|0)==1){break d}g=Eb(a+484360|0);j[114630]=0;U(581,g|0,d+112|0,b+1&255,255,254)|0;b=j[114630];j[114630]=0;if((b|0)==1){break d}jb(d+112|0)}if(c&1){j[114630]=0;i[d+40>>1]=0;I(1536,d+480|0,o|0,1414807888);b=j[114630];j[114630]=0;if((b|0)==1){break e}b=Zc(d+480|0);j[114630]=0;g=a+484344|0;F(401,g|0,b&65535);b=j[114630];j[114630]=0;if((b|0)==1){break k}s=d,t=Lb(d+480|0),j[s+544>>2]=t;s=d,t=Mb(d+480|0),j[s+64>>2]=t;if(rb(d+544|0,d- -64|0)){n=(f|0)!=1179012417;while(1){b=He(d+112|0,j[d+544>>2]);j[114630]=0;m=H(387,b|0)|0;e=j[114630];j[114630]=0;if((e|0)==1){break h}j[114630]=0;i[d+464>>1]=m;m=H(390,b|0)|0;e=j[114630];j[114630]=0;if((e|0)==1){break i}j[114630]=0;I(341,d+560|0,b|0,m|0);m=j[114630];j[114630]=0;if((m|0)==1){break i}j[114630]=0;L(1537,d+560|0,l[d+464>>1],n|0,a|0);m=j[114630];j[114630]=0;if((m|0)==1){break j}jb(d+560|0);j[114630]=0;m=E(452,d+40|0,d+464|0)|0;e=j[114630];j[114630]=0;if((e|0)==1){break i}i[d+40>>1]=l[m>>1];jb(b);yf(d+544|0);if(rb(d+544|0,d- -64|0)){continue}break}}if(l[d+40>>1]){b=0;while(1){j[114630]=0;n=b&65535;m=E(442,g|0,n|0)|0;e=j[114630];j[114630]=0;S:{if((e|0)!=1){if(m){break S}j[114630]=0;K(402,g|0,n|0,64)|0;n=j[114630];j[114630]=0;if((n|0)!=1){break S}}a=D()|0;C()|0;break f}b=b+1|0;if(l[d+40>>1]>(b&65535)>>>0){continue}break}}Sc(d+480|0)}T:{if((f|0)==1179012417){j[114630]=0;I(1536,d- -64|0,o|0,1414745673);b=j[114630];j[114630]=0;if((b|0)==1){break B}s=d,t=Lb(d- -64|0),j[s+96>>2]=t;s=d,t=Mb(d- -64|0),j[s+24>>2]=t;U:{if(rb(d+96|0,d+24|0)){g=c&2;n=d+488|0;m=d+112|1;while(1){c=He(d+544|0,j[d+96>>2]);j[114630]=0;b=E(1538,c|0,d+112|0)|0;f=j[114630];j[114630]=0;if((f|0)==1){break U}V:{if(!b){break V}b=k[m|0];if((b|0)==255){break V}j[114630]=0;b=K(454,a|0,b+1|0,0)|0;f=j[114630];j[114630]=0;if((f|0)==1){break A}if(!b){break V}f=l[a+480190>>1];j[114630]=0;I(1539,d+112|0,b|0,f|0);b=j[114630];j[114630]=0;if((b|0)==1){break A}b=0;if(!k[d+142|0]){break V}while(1){W:{if(!fn(a)){break W}j[114630]=0;f=E(1540,c|0,d+480|0)|0;e=j[114630];j[114630]=0;if((e|0)==1){break z}if(!f){break W}f=l[a+480190>>1]+1|0;i[a+480190>>1]=f;if((k[d+480|0]|k[d+481|0]<<8|(k[d+482|0]<<16|k[d+483|0]<<24))!=1347240275){break W}j[114630]=0;I(577,d+464|0,2,n|0);e=j[114630];j[114630]=0;X:{Y:{Z:{if((e|0)==1){break Z}j[114630]=0;F(415,d+40|0,d+464|0);e=j[114630];j[114630]=0;if((e|0)==1){break Z}j[114630]=0;f=f&65535;E(369,((f<<5)+a|0)+946300|0,d+40|0)|0;e=j[114630];j[114630]=0;if((e|0)==1){break Y}gb(d+40|0);j[114630]=0;f=(p(f,104)+a|0)+484380|0;I(1541,d+480|0,d+112|0,f|0);e=j[114630];j[114630]=0;if((e|0)==1){break m}if(!g){break X}j[114630]=0;F(1542,d+40|0,d+480|0);e=j[114630];j[114630]=0;if((e|0)!=1){j[114630]=0;K(400,d+40|0,f|0,c|0)|0;f=j[114630];j[114630]=0;if((f|0)!=1){break W}}a=D()|0;C()|0;break l}a=D()|0;C()|0;break l}a=D()|0;C()|0;gb(d+40|0);break l}f=jk(f);j[114630]=0;E(338,c|0,f|0)|0;f=j[114630];j[114630]=0;if((f|0)==1){break m}}b=b+1|0;if(b>>>0<k[d+142|0]){continue}break}}jb(c);yf(d+96|0);if(rb(d+96|0,d+24|0)){continue}break}}Sc(d- -64|0);break T}a=D()|0;C()|0;break l}j[114630]=0;I(1536,d+464|0,o|0,1179011410);b=j[114630];j[114630]=0;if((b|0)==1){break y}s=d,t=Lb(d+464|0),j[s+456>>2]=t;s=d,t=Mb(d+464|0),j[s+448>>2]=t;if(rb(d+456|0,d+448|0)){f=c&2;g=d+480|4;c=d+56|4;n=d+112|5;while(1){m=tl(d+544|0,j[d+456>>2]);j[114630]=0;b=H(390,d+544|0)|0;e=j[114630];j[114630]=0;if((e|0)==1){break x}_:{if((b|0)!=538986817){break _}j[114630]=0;b=E(1543,d+544|0,d+440|0)|0;e=j[114630];j[114630]=0;if((e|0)==1){break w}if(!b|(k[d+440|0]|k[d+441|0]<<8|(k[d+442|0]<<16|k[d+443|0]<<24))!=1414745673){break _}j[114630]=0;b=E(1544,d+544|0,d+112|0)|0;e=j[114630];j[114630]=0;if((e|0)==1){break v}if(!b){break _}b=k[n|0];if((b|0)==255){break _}j[114630]=0;b=K(454,a|0,b+1|0,0)|0;e=j[114630];j[114630]=0;if((e|0)==1){break u}if(!b){break _}e=l[a+480190>>1];j[114630]=0;I(1545,d+112|0,b|0,e|0);b=j[114630];j[114630]=0;if((b|0)==1){break u}j[114630]=0;I(1531,d+480|0,m|0,2);b=j[114630];j[114630]=0;if((b|0)==1){break C}j[114630]=0;I(1536,d+96|0,d+480|0,1179011410);b=j[114630];j[114630]=0;if((b|0)==1){break t}Zk(d+480|0);s=d,t=Lb(d+96|0),j[s+88>>2]=t;s=d,t=Mb(d+96|0),j[s+80>>2]=t;$:{if(!rb(d+88|0,d+80|0)){break $}aa:{while(1){b=He(d- -64|0,j[d+88>>2]);j[114630]=0;m=H(390,b|0)|0;e=j[114630];j[114630]=0;if((e|0)==1){break s}ba:{ca:{if((m|0)!=538989377){break ca}if(!fn(a)){break ca}m=k[d+436|0]|k[d+437|0]<<8;e=m-1|0;h[d+436|0]=e;h[d+437|0]=e>>>8;if(!m){jb(b);break $}m=l[a+480190>>1]+1|0;i[a+480190>>1]=m;j[114630]=0;e=E(1543,b|0,d+56|0)|0;q=j[114630];j[114630]=0;if((q|0)==1){break r}da:{if(!(!e|(k[d+56|0]|k[d+57|0]<<8|(k[d+58|0]<<16|k[d+59|0]<<24))!=1347240275)){e=k[c|0]|k[c+1|0]<<8|(k[c+2|0]<<16|k[c+3|0]<<24);j[114630]=0;I(341,d+40|0,b|0,e|0);e=j[114630];j[114630]=0;ea:{if((e|0)!=1){j[114630]=0;e=E(1546,d+40|0,d+480|0)|0;q=j[114630];j[114630]=0;if((q|0)==1){break ba}if(!e){break aa}j[114630]=0;I(745,d+8|0,2,g|0);e=j[114630];j[114630]=0;if((e|0)!=1){j[114630]=0;F(415,d+24|0,d+8|0);e=j[114630];j[114630]=0;if((e|0)!=1){break ea}}a=D()|0;C()|0;break p}a=D()|0;C()|0;break o}j[114630]=0;m=m&65535;E(369,((m<<5)+a|0)+946300|0,d+24|0)|0;e=j[114630];j[114630]=0;if((e|0)==1){break q}gb(d+24|0);j[114630]=0;m=(p(m,104)+a|0)+484380|0;I(1547,d+480|0,d+112|0,m|0);e=j[114630];j[114630]=0;if((e|0)==1){break ba}if(!f){break da}e=k[d+480|0]|k[d+481|0]<<8|(k[d+482|0]<<16|k[d+483|0]<<24);j[114630]=0;E(256,d+40|0,e+4|0)|0;e=j[114630];j[114630]=0;if((e|0)==1){break ba}j[114630]=0;F(1548,d+24|0,d+480|0);e=j[114630];j[114630]=0;if((e|0)!=1){j[114630]=0;K(400,d+24|0,m|0,d+40|0)|0;m=j[114630];j[114630]=0;if((m|0)!=1){break da}}a=D()|0;C()|0;break p}jb(b);break $}jb(d+40|0)}jb(b);yf(d+88|0);if(rb(d+88|0,d+80|0)){continue}break $}break}a=D()|0;C()|0;break p}jb(d+40|0);jb(b)}Sc(d+96|0)}jb(d+544|0);yf(d+456|0);if(rb(d+456|0,d+448|0)){continue}break}}Sc(d+464|0)}g=1}jb(d+656|0);Zk(o);jb(r)}Za=d+720|0;return g|0}a=D()|0;C()|0;break n}a=D()|0;C()|0;break b}a=D()|0;C()|0;break l}a=D()|0;C()|0;break l}a=D()|0;C()|0;break b}a=D()|0;C()|0;break n}a=D()|0;C()|0;break n}a=D()|0;C()|0;break n}a=D()|0;C()|0;break n}a=D()|0;C()|0;Zk(d+480|0);break n}a=D()|0;C()|0;break o}a=D()|0;C()|0;break o}a=D()|0;C()|0;gb(d+24|0)}jb(d+40|0)}jb(b);Sc(d+96|0)}jb(d+544|0);Sc(d+464|0);break b}a=D()|0;C()|0}jb(c);Sc(d- -64|0);break b}a=D()|0;C()|0;break f}a=D()|0;C()|0;jb(d+560|0);break g}a=D()|0;C()|0;break g}a=D()|0;C()|0}jb(b)}Sc(d+480|0);break b}a=D()|0;C()|0;break b}a=D()|0;C()|0;jb(d+112|0);break b}a=D()|0;C()|0}jb(d+656|0)}Zk(o);jb(r);G(a|0);z()}function xT(a,b,c,d){var e=0,f=0,g=0,k=0,l=0;f=Za-32|0;Za=f;a:{b:{c:{d:{e:{f:{g:{h:{i:{if(!a){break i}j:{k:{l:{m:{n:{o:{p:{q:{r:{s:{t:{u:{v:{w:{x:{y:{z:{A:{B:{C:{D:{E:{F:{G:{H:{I:{J:{K:{L:{M:{N:{O:{P:{Q:{R:{S:{if((b|0)<=1347628589){if((b|0)<=1297100333){if((b|0)<=1179931727){if((b|0)<=1145263149){if((b|0)==1095062094){break t}if((b|0)==1095126087){break q}if((b|0)!=1129524782|c>>>0>1){break i}if(!yb(d,c)){break i}k=a,l=Uc(d,c),h[k+23|0]=l;e=1;break i}if((b|0)<=1179463213){if((b|0)==1145263150){break I}if((b|0)!=1145979182|c>>>0>1){break i}if(!yb(d,c)){break i}k=a,l=Uc(d,c),h[k+18|0]=l;e=1;break i}if((b|0)==1179463214){break w}if((b|0)!=1179594286|c>>>0>4){break i}if(!yb(d,c)){break i}k=a,l=pk(d,c),j[k>>2]=l;e=1;break i}if((b|0)<=1229345325){if((b|0)==1179931728){break j}if((b|0)==1196830254){break S}if((b|0)!=1229341486|c>>>0>1){break i}if(!yb(d,c)){break i}k=a,l=Uc(d,c),h[k+21|0]=l;e=1;break i}if((b|0)<=1296182829){if((b|0)==1229345326){break F}if((b|0)!=1264266798|c>>>0>256){break i}a=a+236|0;cd(f+16|0,d,c);b=0;while(1){j[114630]=0;c=H(373,f+16|0)|0;d=j[114630];j[114630]=0;if((d|0)==1){break A}k=Nc(a,b),l=c,i[k>>1]=l;b=b+1|0;if(b>>>0<128){continue}break}jb(f+16|0);e=1;break i}if((b|0)==1296182830){break E}if((b|0)!=1296248366|c>>>0>1){break i}if(!yb(d,c)){break i}k=a,l=Uc(d,c),h[k+31|0]=l;e=1;break i}if((b|0)<=1346720333){if((b|0)<=1313692461){if((b|0)==1297100334){break D}if((b|0)==1297110852){break o}if((b|0)!=1298747438|c>>>0>1){break i}if(!yb(d,c)){break i}k=a,l=Uc(d,c),h[k+34|0]=l;e=1;break i}if((b|0)<=1345203757){if((b|0)==1313692462){break B}if((b|0)!=1313751342|c>>>0>1){break i}if(!yb(d,c)){break i}k=a,l=Uc(d,c),h[k+16|0]=l;e=1;break i}if((b|0)==1345203758){break R}if((b|0)!=1346711086){break i}j[f+16>>2]=240;k=f,l=pk(d,c),j[k>>2]=l;Nf(a+68|0,j[tb(f+16|0,f)>>2]);e=1;break i}if((b|0)<=1347179309){if((b|0)<=1346784326){if((b|0)==1346720334){break u}if((b|0)!=1346722606){break i}cd(f+16|0,d,c);j[114630]=0;a=E(374,a|0,1)|0;b=j[114630];j[114630]=0;if((b|0)==1){break f}if(sb(a)){b=0;while(1){j[114630]=0;c=H(375,f+16|0)|0;d=j[114630];j[114630]=0;if((d|0)==1){break f}k=xb(a,b),l=c,h[k+2|0]=l;b=b+1|0;if(sb(a)>>>0>b>>>0){continue}break}}jb(f+16|0);e=1;break i}if((b|0)==1346784327){break r}if((b|0)!=1347175726|c>>>0>1){break i}if(!yb(d,c)){break i}k=a,l=Uc(d,c),h[k+82|0]=l;e=1;break i}if((b|0)<=1347441453){if((b|0)==1347179310){break O}if((b|0)!=1347437358|c>>>0>1){break i}if(!yb(d,c)){break i}k=a,l=Uc(d,c),h[k+27|0]=l;e=1;break i}if((b|0)==1347441454){break C}if((b|0)!=1347443502){break i}cd(f+16|0,d,c);j[114630]=0;a=E(374,a|0,1)|0;b=j[114630];j[114630]=0;if((b|0)==1){break c}if(sb(a)){b=0;while(1){j[114630]=0;c=H(373,f+16|0)|0;d=j[114630];j[114630]=0;if((d|0)==1){break c}k=xb(a,b),l=c,i[k>>1]=l;b=b+1|0;if(sb(a)>>>0>b>>>0){continue}break}}jb(f+16|0);e=1;break i}if((b|0)<=1447374381){if((b|0)<=1349078084){if((b|0)<=1347831111){if((b|0)<=1347634477){if((b|0)==1347628590){break H}if((b|0)!=1347633710|c>>>0>1){break i}if(!yb(d,c)){break i}k=a,l=Uc(d,c),h[k+83|0]=l;e=1;break i}if((b|0)==1347634478){break N}if((b|0)!=1347703884){break i}k=a,l=p(Gp(d,c),1e4)+(m[a+40>>2]%1e4|0)|0,j[k+40>>2]=l;e=1;break i}if((b|0)<=1349076269){if((b|0)==1347831112){break v}if((b|0)!=1347833672|c>>>0>1){break i}if(!yb(d,c)){break i}k=a,l=Uc(d,c),h[k+36|0]=l;e=1;break i}if((b|0)==1349076270){break l}if((b|0)!=1349076315){break i}cd(f+16|0,d,c);j[114630]=0;a=E(374,a|0,2)|0;b=j[114630];j[114630]=0;if((b|0)==1){break g}if(sb(a)){b=0;while(1){j[114630]=0;c=H(375,f+16|0)|0;d=j[114630];j[114630]=0;if((d|0)==1){break g}k=xb(a,b),l=c,h[k+2|0]=l;b=b+1|0;if(sb(a)>>>0>b>>>0){continue}break}}jb(f+16|0);e=1;break i}if((b|0)<=1349079873){if((b|0)==1349078085){break L}if((b|0)==1349078099){break M}if((b|0)!=1349079131){break i}cd(f+16|0,d,c);j[114630]=0;a=E(374,a|0,2)|0;b=j[114630];j[114630]=0;if((b|0)==1){break d}if(sb(a)){b=0;while(1){j[114630]=0;c=H(373,f+16|0)|0;d=j[114630];j[114630]=0;if((d|0)==1){break d}k=xb(a,b),l=c,i[k>>1]=l;b=b+1|0;if(sb(a)>>>0>b>>>0){continue}break}}jb(f+16|0);e=1;break i}T:{switch(b-1349079874|0){case 3:break J;case 0:break K;case 1:case 2:break i;default:break T}}if((b|0)==1378758190){break n}if((b|0)!=1381183022|c>>>0>1){break i}if(!yb(d,c)){break i}k=a,l=Uc(d,c),h[k+24|0]=l;e=1;break i}if((b|0)<=1448226349){if((b|0)<=1447447622){if((b|0)==1447374382){break m}if((b|0)==1447383630){break s}if((b|0)!=1447385902){break i}cd(f+16|0,d,c);j[114630]=0;a=E(374,a|0,0)|0;b=j[114630];j[114630]=0;if((b|0)==1){break e}if(sb(a)){b=0;while(1){j[114630]=0;c=H(375,f+16|0)|0;d=j[114630];j[114630]=0;if((d|0)==1){break e}k=xb(a,b),l=c,h[k+2|0]=l;b=b+1|0;if(sb(a)>>>0>b>>>0){continue}break}}jb(f+16|0);e=1;break i}if((b|0)<=1447842605){if((b|0)==1447447623){break p}if((b|0)!=1447839022|c>>>0>1){break i}if(!yb(d,c)){break i}k=a,l=Uc(d,c),h[k+62|0]=l;e=1;break i}if((b|0)==1447842606){break Q}if((b|0)!=1448106798){break i}cd(f+16|0,d,c);j[114630]=0;a=E(374,a|0,0)|0;b=j[114630];j[114630]=0;if((b|0)==1){break b}if(sb(a)){b=0;while(1){j[114630]=0;c=H(373,f+16|0)|0;d=j[114630];j[114630]=0;if((d|0)==1){break b}k=xb(a,b),l=c,i[k>>1]=l;b=b+1|0;if(sb(a)>>>0>b>>>0){continue}break}}jb(f+16|0);e=1;break i}if((b|0)<=1448297773){if((b|0)==1448226350){break x}if((b|0)==1448291886){break G}if((b|0)!=1448297006|c>>>0>1){break i}if(!yb(d,c)){break i}k=a,l=Uc(d,c),h[k+63|0]=l;e=1;break i}if((b|0)<=1718508333){if((b|0)==1448297774){break P}if((b|0)!=1682320942|c>>>0>1){break i}if(!yb(d,c)){break i}k=a,l=Uc(d,c),h[k+15|0]=l;e=1;break i}if((b|0)==1718508334){break y}if((b|0)!=1851469358|c>>>0>32){break i}b=a+492|0;cd(f+16|0,d,c);d=Cb(f);if(c){a=0;while(1){j[114630]=0;e=H(376,f+16|0)|0;g=j[114630];j[114630]=0;if((g|0)==1){break z}j[114630]=0;E(377,d|0,e|0)|0;e=j[114630];j[114630]=0;if((e|0)==1){break z}a=a+1|0;if((c|0)!=(a|0)){continue}break}}j[114630]=0;E(369,b|0,d|0)|0;a=j[114630];j[114630]=0;e=1;if((a|0)==1){break z}gb(d);jb(f+16|0);break i}if(c>>>0>4){break i}if(!yb(d,c)){break i}k=a,l=pk(d,c),j[k+4>>2]=l;e=1;break i}if(c>>>0>4){break i}if(!yb(d,c)){break i}k=a,l=pk(d,c),j[k+8>>2]=l;e=1;break i}if(c>>>0>1){break i}if(!yb(d,c)){break i}k=a,l=Uc(d,c),h[k+61|0]=l;e=1;break i}if(c>>>0>1){break i}if(!yb(d,c)){break i}k=a- -64|0,l=Uc(d,c),h[k|0]=l;e=1;break i}if(c>>>0>1){break i}if(!yb(d,c)){break i}k=a,l=Uc(d,c),h[k+81|0]=l;e=1;break i}if(c>>>0>1){break i}if(!yb(d,c)){break i}k=a,l=Uc(d,c),h[k+84|0]=l;e=1;break i}if(c>>>0>1){break i}if(!yb(d,c)){break i}k=a,l=Uc(d,c),h[k+101|0]=l;e=1;break i}if(c>>>0>1){break i}if(!yb(d,c)){break i}k=a,l=Uc(d,c),h[k+102|0]=l;e=1;break i}if(c>>>0>1){break i}if(!yb(d,c)){break i}k=a,l=Uc(d,c),h[k+103|0]=l;e=1;break i}if(c>>>0>1){break i}if(!yb(d,c)){break i}k=a,l=Uc(d,c),h[k+104|0]=l;e=1;break i}if(c>>>0>1){break i}if(!yb(d,c)){break i}k=a,l=Uc(d,c),h[k+17|0]=l;e=1;break i}if(c>>>0>1){break i}if(!yb(d,c)){break i}k=a,l=Uc(d,c),h[k+19|0]=l;e=1;break i}if(c>>>0>1){break i}if(!yb(d,c)){break i}k=a,l=Uc(d,c),h[k+20|0]=l;e=1;break i}if(c>>>0>1){break i}if(!yb(d,c)){break i}k=a,l=Uc(d,c),h[k+22|0]=l;e=1;break i}if(c>>>0>2){break i}if(!yb(d,c)){break i}k=a,l=Gp(d,c),i[k+28>>1]=l;e=1;break i}if(c>>>0>1){break i}if(!yb(d,c)){break i}k=a,l=Uc(d,c),h[k+30|0]=l;e=1;break i}if(c>>>0>1){break i}if(!yb(d,c)){break i}k=a,l=$z(d,c),h[k+26|0]=l;e=1;break i}if(c>>>0>128){break i}a=a+108|0;cd(f+16|0,d,c);b=0;while(1){j[114630]=0;c=H(375,f+16|0)|0;d=j[114630];j[114630]=0;if((d|0)==1){break k}k=Pb(a,b),l=c,h[k|0]=l;b=b+1|0;if(b>>>0<128){continue}break}jb(f+16|0);e=1;break i}b=D()|0;C()|0;break a}b=D()|0;C()|0;gb(d);break a}if(c>>>0>32){break i}b=a+524|0;cd(f+16|0,d,c);d=Cb(f);if(c){a=0;while(1){j[114630]=0;e=H(376,f+16|0)|0;g=j[114630];j[114630]=0;if((g|0)==1){break h}j[114630]=0;E(377,d|0,e|0)|0;e=j[114630];j[114630]=0;if((e|0)==1){break h}a=a+1|0;if((c|0)!=(a|0)){continue}break}}j[114630]=0;E(369,b|0,d|0)|0;a=j[114630];j[114630]=0;e=1;if((a|0)!=1){gb(d);jb(f+16|0);break i}break h}if(c>>>0>2){break i}if(!yb(d,c)){break i}k=a,l=Gp(d,c),i[k+12>>1]=l;e=1;break i}if(c>>>0>1){break i}if(!yb(d,c)){break i}k=a,l=Uc(d,c),h[k+25|0]=l;e=1;break i}if(c>>>0>1){break i}if(!yb(d,c)){break i}k=a,l=Uc(d,c),h[k+35|0]=l;e=1;break i}if(c>>>0>1){break i}if(!yb(d,c)){break i}k=a,l=Uc(d,c),h[k+105|0]=l;e=1;break i}if(c>>>0>1){break i}if(!yb(d,c)){break i}k=a,l=Uc(d,c),h[k+85|0]=l;e=1;break i}if(c>>>0>1){break i}if(!yb(d,c)){break i}k=a,l=Uc(d,c),h[k+65|0]=l;e=1;break i}if(c>>>0>1){break i}if(!yb(d,c)){break i}k=a,l=Uc(d,c),h[k+100|0]=l;e=1;break i}if(c>>>0>1){break i}if(!yb(d,c)){break i}k=a,l=Uc(d,c),h[k+80|0]=l;e=1;break i}if(c>>>0>1){break i}if(!yb(d,c)){break i}k=a,l=Uc(d,c),h[k+60|0]=l;e=1;break i}if(c>>>0>1){break i}if(!yb(d,c)){break i}k=a,l=$z(d,c),h[k+33|0]=l;e=1;break i}e=1;b=pk(d,c);if(!un(b)){break i}h[a+14|0]=b;break i}j[f+16>>2]=240;k=f,l=pk(d,c),j[k>>2]=l;Nf(a+48|0,j[tb(f+16|0,f)>>2]);e=1;break i}j[f+16>>2]=240;k=f,l=pk(d,c),j[k>>2]=l;Nf(a+88|0,j[tb(f+16|0,f)>>2]);e=1;break i}b=D()|0;C()|0;break a}b=Gp(d,c);c=a;a=j[a+40>>2];j[c+40>>2]=a-((a>>>0)%1e4|0)+(b>>>0)%1e4;e=1}Za=f+32|0;return e}b=D()|0;C()|0;gb(d);break a}b=D()|0;C()|0;break a}b=D()|0;C()|0;break a}b=D()|0;C()|0;break a}b=D()|0;C()|0;break a}b=D()|0;C()|0;break a}b=D()|0;C()|0}jb(f+16|0);G(b|0);z()}function yD(a,b,c,d,e,f,g,h,i){var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0;n=Za-192|0;Za=n;z=h;F=i&65535;o=d;p=e&65535;G=(e^i)&-2147483648;m=i>>>16&32767;a:{u=e>>>16&32767;b:{c:{if(m-1>>>0<32766?u-1>>>0<=32765:0){break c}H=e&2147483647;l=H;k=d;if(!(!k&(l|0)==2147418112?!(b|c):l>>>0<2147418112)){J=d;G=e|32768;break b}H=i&2147483647;e=H;d=h;if(!(!d&(e|0)==2147418112?!(f|g):e>>>0<2147418112)){J=h;G=i|32768;b=f;c=g;break b}if(!(b|k|(l^2147418112|c))){if(!(d|f|(e^2147418112|g))){b=0;c=0;G=2147450880;break b}G=G|2147418112;b=0;c=0;break b}if(!(d|f|(e^2147418112|g))){b=0;c=0;break b}if(!(b|k|(c|l))){break a}if(!(d|f|(e|g))){G=G|2147418112;b=0;c=0;break b}if((l|0)==65535|l>>>0<65535){i=b;d=!(p|o);h=d<<6;k=s(d?b:o)+32|0;b=s(d?c:p);b=h+((b|0)==32?k:b)|0;We(n+176|0,i,c,o,p,b-15|0);I=16-b|0;o=j[n+184>>2];p=j[n+188>>2];c=j[n+180>>2];b=j[n+176>>2]}if(e>>>0>65535){break c}d=!(z|F);e=d<<6;h=s(d?f:z)+32|0;d=s(d?g:F);d=e+((d|0)==32?h:d)|0;We(n+160|0,f,g,z,F,d-15|0);I=(d+I|0)-16|0;z=j[n+168>>2];F=j[n+172>>2];f=j[n+160>>2];g=j[n+164>>2]}e=F|65536;H=e;N=z;d=z;l=e<<15|d>>>17;d=d<<15|g>>>17;h=-102865788-d|0;e=l;k=l;i=1963258675-(k+(d>>>0>4192101508)|0)|0;Ig(n+144|0,d,k,h,i);k=j[n+152>>2];Ig(n+128|0,0-k|0,0-(j[n+156>>2]+((k|0)!=0)|0)|0,h,i);h=j[n+136>>2];i=h<<1|j[n+132>>2]>>>31;h=j[n+140>>2]<<1|h>>>31;Ig(n+112|0,i,h,d,l);k=h;h=j[n+120>>2];Ig(n+96|0,i,k,0-h|0,0-(j[n+124>>2]+((h|0)!=0)|0)|0);h=j[n+104>>2];i=h<<1|j[n+100>>2]>>>31;h=j[n+108>>2]<<1|h>>>31;Ig(n+80|0,i,h,d,l);k=h;h=j[n+88>>2];Ig(n- -64|0,i,k,0-h|0,0-(j[n+92>>2]+((h|0)!=0)|0)|0);h=j[n+72>>2];i=h<<1|j[n+68>>2]>>>31;h=j[n+76>>2]<<1|h>>>31;Ig(n+48|0,i,h,d,l);k=h;h=j[n+56>>2];Ig(n+32|0,i,k,0-h|0,0-(j[n+60>>2]+((h|0)!=0)|0)|0);h=j[n+40>>2];i=h<<1|j[n+36>>2]>>>31;h=j[n+44>>2]<<1|h>>>31;Ig(n+16|0,i,h,d,l);k=h;h=j[n+24>>2];Ig(n,i,k,0-h|0,0-(j[n+28>>2]+((h|0)!=0)|0)|0);I=(u-m|0)+I|0;h=j[n+8>>2];k=j[n+12>>2]<<1|h>>>31;l=h<<1|j[n+4>>2]>>>31;h=l-1|0;l=k-(l>>>0<1)|0;k=0;C=k;i=h;q=e;e=0;r=HMa(h,k,q,e);k=ab;v=k;y=l;m=0;u=d;h=HMa(l,m,d,0);d=h+r|0;k=ab+k|0;k=d>>>0<h>>>0?k+1|0:k;h=d;d=k;k=0;l=(d|0)==(v|0)&h>>>0<r>>>0|d>>>0<v>>>0;r=HMa(y,m,q,e);e=r+d|0;l=ab+(k|l)|0;k=e;e=k>>>0<r>>>0?l+1|0:l;q=k;l=h;r=0;h=HMa(i,C,u,t);d=r+h|0;k=ab+l|0;k=d>>>0<h>>>0?k+1|0:k;h=k;u=(l|0)==(k|0)&r>>>0>d>>>0|k>>>0<l>>>0;l=q+u|0;k=e;A=l;e=l>>>0<u>>>0?k+1|0:k;q=d;r=d;u=h;d=g;B=(d&131071)<<15|f>>>17;v=HMa(i,C,B,0);d=ab;t=d;k=f;l=k<<15&-32768;x=0;D=HMa(y,m,l,x);h=D+v|0;k=ab+d|0;k=h>>>0<D>>>0?k+1|0:k;d=k;D=0;E=HMa(i,C,l,x);x=D+E|0;l=h;k=l+ab|0;k=x>>>0<E>>>0?k+1|0:k;w=(k|0)==(l|0)&x>>>0<D>>>0|k>>>0<l>>>0;k=(d|0)==(t|0)&l>>>0<v>>>0|d>>>0<t>>>0;h=d;d=HMa(y,m,B,K)+d|0;l=k+ab|0;l=d>>>0<h>>>0?l+1|0:l;h=d;d=w+d|0;k=l;k=d>>>0<h>>>0?k+1|0:k;h=d;d=d+r|0;k=k+u|0;k=d>>>0<h>>>0?k+1|0:k;r=d;v=k;h=(k|0)==(u|0)&d>>>0<q>>>0|k>>>0<u>>>0;d=h+A|0;k=e;k=d>>>0<h>>>0?k+1|0:k;e=(r|0)!=0|(v|0)!=0;d=e+d|0;l=d>>>0<e>>>0?k+1|0:k;h=d;t=0-d|0;A=0;u=HMa(t,A,i,C);d=ab;x=d;e=u;q=d;A=HMa(y,m,t,A);d=ab;w=d;B=0-(((h|0)!=0)+l|0)|0;t=0;l=HMa(i,C,B,t);h=l+A|0;k=ab+d|0;k=h>>>0<l>>>0?k+1|0:k;d=k;l=h+q|0;e=0+e|0;q=e;k=e;l=k>>>0<K>>>0?l+1|0:l;e=l;l=(x|0)==(l|0)&k>>>0<u>>>0|l>>>0<x>>>0;k=(d|0)==(w|0)&h>>>0<A>>>0|d>>>0<w>>>0;h=d;d=HMa(y,m,B,t)+d|0;k=k+ab|0;k=d>>>0<h>>>0?k+1|0:k;h=d;d=l+d|0;w=d;h=d>>>0<h>>>0?k+1|0:k;d=0-r|0;B=0-(((r|0)!=0)+v|0)|0;r=0;A=HMa(B,r,i,C);x=ab;v=d;l=HMa(d,0,y,m);d=l+A|0;k=ab+x|0;k=d>>>0<l>>>0?k+1|0:k;l=d;d=k;C=HMa(i,C,v,K);v=0+C|0;k=l+ab|0;k=v>>>0<C>>>0?k+1|0:k;v=(l|0)==(k|0)&v>>>0<D>>>0|l>>>0>k>>>0;i=(d|0)==(x|0)&l>>>0<A>>>0|d>>>0<x>>>0;l=d;d=HMa(y,m,B,r)+l|0;k=i+ab|0;k=d>>>0<l>>>0?k+1|0:k;i=d;d=d+v|0;l=d>>>0<i>>>0?k+1|0:k;i=d;d=d+q|0;k=l+e|0;k=d>>>0<i>>>0?k+1|0:k;i=d;l=d;d=k;l=(e|0)==(k|0)&l>>>0<q>>>0|e>>>0>k>>>0;e=l+w|0;k=h;k=e>>>0<l>>>0?k+1|0:k;l=e;e=i;v=e-2|0;h=v;r=d-(e>>>0<2)|0;e=r;e=(d|0)==(e|0)&h>>>0<i>>>0|d>>>0>e>>>0;d=l+e|0;k=d>>>0<e>>>0?k+1|0:k;e=d;d=d-1|0;h=k-(e>>>0<1)|0;e=0;x=e;m=d;i=o;w=i<<2|c>>>30;B=0;q=HMa(d,e,w,B);e=ab;t=e;l=e;e=c;K=(e&1073741823)<<2|b>>>30;u=0;D=h;i=0;e=HMa(K,u,h,i);d=e+q|0;l=ab+l|0;l=d>>>0<e>>>0?l+1|0:l;k=(l|0)==(t|0)&d>>>0<q>>>0|l>>>0<t>>>0;q=d;h=l;A=r;l=0;r=l;c=k;E=((p&1073741823)<<2|o>>>30)&-262145|262144;l=HMa(A,l,E,0);d=l+d|0;k=ab+h|0;k=d>>>0<l>>>0?k+1|0:k;p=d;e=k;h=(k|0)==(h|0)&d>>>0<q>>>0|h>>>0>k>>>0;d=c+h|0;k=0;k=d>>>0<h>>>0?1:k;h=HMa(D,i,E,M);d=h+d|0;l=ab+k|0;l=d>>>0<h>>>0?l+1|0:l;o=HMa(m,x,E,M);h=ab;c=d;t=HMa(w,B,D,i);d=t+o|0;k=ab+h|0;k=d>>>0<t>>>0?k+1|0:k;t=d;d=k;k=(h|0)==(k|0)&o>>>0>t>>>0|h>>>0>k>>>0;o=c+d|0;k=k+l|0;l=o;h=l>>>0<d>>>0?k+1|0:k;q=p;c=l;p=0;d=q+p|0;o=e;l=t+e|0;l=d>>>0<p>>>0?l+1|0:l;k=d;e=l;p=(l|0)==(o|0)&k>>>0<q>>>0|l>>>0<o>>>0;l=c+p|0;k=h;C=l;h=l>>>0<p>>>0?k+1|0:k;o=d;p=e;q=HMa(K,u,A,r);e=ab;t=HMa(v,0,w,B);d=t+q|0;l=ab+e|0;l=d>>>0<t>>>0?l+1|0:l;t=d;q=(e|0)==(l|0)&q>>>0>d>>>0|e>>>0>l>>>0;e=l;y=q;k=b;L=k<<2&-4;c=0;k=HMa(m,x,L,c);d=k+d|0;l=ab+l|0;l=d>>>0<k>>>0?l+1|0:l;q=d;k=d;d=l;l=(l|0)==(e|0)&k>>>0<t>>>0|e>>>0>l>>>0;e=y+l|0;k=0;k=e>>>0<l>>>0?1:k;l=e;e=o+l|0;k=k+p|0;k=e>>>0<l>>>0?k+1|0:k;t=e;l=e;e=k;p=(k|0)==(p|0)&l>>>0<o>>>0|k>>>0<p>>>0;k=p+C|0;l=h;C=k;p=k>>>0<p>>>0?l+1|0:l;y=HMa(D,i,L,c);D=ab;i=HMa(E,M,v,O);h=i+y|0;k=ab+D|0;k=h>>>0<i>>>0?k+1|0:k;E=h;l=HMa(w,B,A,r);h=h+l|0;i=k;k=k+ab|0;k=h>>>0<l>>>0?k+1|0:k;w=h;o=HMa(m,x,K,u);h=h+o|0;l=k+ab|0;l=h>>>0<o>>>0?l+1|0:l;o=h;h=l;x=0;m=(l|0)==(k|0)&o>>>0<w>>>0|l>>>0<k>>>0;l=(i|0)==(k|0)&w>>>0<E>>>0|i>>>0>k>>>0;i=l+((i|0)==(D|0)&E>>>0<y>>>0|i>>>0<D>>>0)|0;k=0;i=m+i|0;k=i;l=h|0;i=l+t|0;k=(k|x)+e|0;k=i>>>0<l>>>0?k+1|0:k;l=k;m=(e|0)==(k|0)&i>>>0<t>>>0|e>>>0>k>>>0;e=m+C|0;k=p;w=e;e=e>>>0<m>>>0?k+1|0:k;t=i;p=l;A=HMa(A,r,L,c);r=ab;k=HMa(K,u,v,O);i=k+A|0;l=ab+r|0;l=i>>>0<k>>>0?l+1|0:l;m=l;l=0;k=(m|0)==(r|0)&i>>>0<A>>>0|m>>>0<r>>>0;i=m+q|0;k=(k|l)+d|0;k=i>>>0<m>>>0?k+1|0:k;m=i;l=i;i=k;l=(d|0)==(k|0)&l>>>0<q>>>0|d>>>0>k>>>0;d=k;q=l;k=o;o=0;h=o+m|0;l=d+k|0;d=h;l=d>>>0<o>>>0?l+1|0:l;h=(i|0)==(l|0)&d>>>0<m>>>0|i>>>0>l>>>0;d=q+h|0;l=0;l=d>>>0<h>>>0?1:l;h=d;d=d+t|0;k=l+p|0;k=d>>>0<h>>>0?k+1|0:k;h=d;i=k;k=(k|0)==(p|0)&d>>>0<t>>>0|k>>>0<p>>>0;d=k+w|0;l=e;l=d>>>0<k>>>0?l+1|0:l;e=l;d:{if((l|0)==131071|l>>>0<131071){y=0;m=f;x=0;k=HMa(h,y,m,x);o=ab;l=b<<17;b=0;c=(k|0)!=0|(o|0)!=0;u=b-c|0;D=l-(b>>>0<c>>>0)|0;b=0-(((k|0)!=0)+o|0)|0;r=0-k|0;v=b;c=0;w=HMa(i,c,m,x);b=ab;B=b;o=0;q=HMa(h,y,g,o);k=q+w|0;l=ab+b|0;l=k>>>0<q>>>0?l+1|0:l;b=k;q=0;t=k;k=(k|0)==(v|0)&r>>>0<q>>>0|k>>>0>v>>>0;C=u-k|0;u=D-(k>>>0>u>>>0)|0;k=HMa(d,0,m,x);m=ab;y=HMa(h,y,z,0);p=y+k|0;k=ab+m|0;k=p>>>0<y>>>0?k+1|0:k;m=HMa(g,o,i,c);p=m+p|0;k=ab+k|0;k=((l|0)==(B|0)&b>>>0<w>>>0|l>>>0<B>>>0)+(m>>>0>p>>>0?k+1|0:k)|0;b=l+p|0;p=b;b=b>>>0<l>>>0?k+1|0:k;k=HMa(h,i,H,0);m=ab;w=p;p=HMa(f,g,e,0);k=p+k|0;l=ab+m|0;l=k>>>0<p>>>0?l+1|0:l;m=HMa(d,e,g,o);p=m+k|0;l=HMa(i,c,z,F);c=l+p|0;l=c;z=0;c=w+z|0;k=b+l|0;k=c>>>0<z>>>0?k+1|0:k;b=c;z=C-b|0;F=u-((b>>>0>C>>>0)+k|0)|0;I=I-1|0;p=r-q|0;b=v-((r>>>0<q>>>0)+t|0)|0;break d}r=i>>>1|0;l=0;o=b<<16;h=(i&1)<<31|h>>>1;i=d<<31|i>>>1;w=0;m=f;B=0;b=HMa(h,w,m,B);k=ab;u=k;k=(b|0)!=0|(k|0)!=0;v=0-k|0;E=o-(c>>>0<k>>>0)|0;q=0-b|0;t=0-(((b|0)!=0)+u|0)|0;o=0;u=HMa(h,w,g,o);b=ab;D=b;k=e<<31|d>>>1;r=r|d<<31;O=k|l;C=r;L=0;l=HMa(r,L,m,B);c=l+u|0;k=ab+b|0;k=c>>>0<l>>>0?k+1|0:k;b=k;l=c;x=l;y=0;k=(l|0)==(t|0)&y>>>0>q>>>0|l>>>0>t>>>0;A=v-k|0;v=E-(k>>>0>v>>>0)|0;k=HMa(h,i,H,0);E=ab;M=HMa(m,g,e>>>1|0,0);l=M+k|0;k=ab+E|0;E=l;l=l>>>0<M>>>0?k+1|0:k;k=E;d=(e&1)<<31|d>>>1;e=e>>>1|0;E=HMa(d,e,g,o);k=k+E|0;l=ab+l|0;F=HMa(r,O,z,F);k=F+k|0;r=0;F=k;k=HMa(g,o,C,L);o=ab;m=HMa(d,0,m,B);l=m+k|0;k=ab+o|0;k=l>>>0<m>>>0?k+1|0:k;z=HMa(h,w,z,0);l=z+l|0;k=ab+k|0;p=l;l=l>>>0<z>>>0?k+1|0:k;z=(b|0)==(D|0)&c>>>0<u>>>0|b>>>0<D>>>0;c=b;b=b+p|0;l=l+z|0;l=b>>>0<c>>>0?l+1|0:l;c=b;b=b+r|0;l=l+F|0;l=b>>>0<c>>>0?l+1|0:l;z=A-b|0;F=v-((b>>>0>A>>>0)+l|0)|0;p=q-y|0;b=t-((q>>>0<y>>>0)+x|0)|0}if((I|0)>=16384){G=G|2147418112;b=0;c=0;break b}m=I+16383|0;if((I|0)<=-16383){e:{if(m){break e}m=p;k=b<<1|m>>>31;m=m<<1;c=(g|0)==(k|0)&f>>>0<m>>>0|g>>>0<k>>>0;f=z;k=F<<1|f>>>31;g=f<<1|b>>>31;l=g;f=(l|0)==(N|0)&(k|0)==(H|0)?c:(H|0)==(k|0)&l>>>0>N>>>0|k>>>0>H>>>0;b=f+h|0;k=i;k=b>>>0<f>>>0?k+1|0:k;c=k;f=d+((i|0)==(k|0)&b>>>0<h>>>0|i>>>0>k>>>0)|0;l=e&65535;e=f;l=d>>>0>e>>>0?l+1|0:l;d=l;if(!(l&65536)){break e}J=e|J;G=d|G;break b}b=0;c=0;break b}o=p;l=b<<1|o>>>31;o=o<<1;c=(g|0)==(l|0)&f>>>0<=o>>>0|g>>>0<l>>>0;f=z;l=F<<1|f>>>31;f=f<<1|b>>>31;f=(f|0)==(N|0)&(l|0)==(H|0)?c:(H|0)==(l|0)&f>>>0>=N>>>0|l>>>0>H>>>0;b=f+h|0;k=i;k=b>>>0<f>>>0?k+1|0:k;c=k;f=d+((i|0)==(k|0)&b>>>0<h>>>0|i>>>0>k>>>0)|0;l=e&65535;l=d>>>0>f>>>0?l+1|0:l;e=0;d=e+f|0;k=(m<<16)+l|0;J=d|J;G=G|(d>>>0<e>>>0?k+1|0:k)}j[a>>2]=b;j[a+4>>2]=c;j[a+8>>2]=J;j[a+12>>2]=G;Za=n+192|0;return}j[a>>2]=0;j[a+4>>2]=0;b=!(d|f|(e|g));j[a+8>>2]=b?0:J;j[a+12>>2]=b?2147450880:G;Za=n+192|0}function UF(a,b,c,d,e,f,g){var h=0,i=0,m=0,n=0;h=Za-128|0;Za=h;a:{b:{if(g){gj(h+112|0,f,32);j[114630]=0;K(798,h+96|0,f|0,32)|0;i=j[114630];j[114630]=0;if((i|0)!=1){break b}c=D()|0;C()|0;break a}Cb(h+112|0);Cb(h+96|0)}c:{d:{e:{f:{g:{h:{i:{j:{k:{l:{m:{n:{o:{p:{q:{r:{if(er(c)){i=b+24|0;b=j[i>>2];j[114630]=0;b=E(442,b+484344|0,c&65535)|0;m=j[114630];j[114630]=0;if((m|0)==1){break r}if(b){break q}}j[114630]=0;I(2189,a|0,h+112|0,h+96|0);a=j[114630];j[114630]=0;if((a|0)!=1){break p}}c=D()|0;C()|0;break c}b=Hb(j[i>>2]+484344|0,c);if(!(j[b+12>>2]>(d|0)?(d|0)>=0:0)){j[114630]=0;I(2189,a|0,h+112|0,h+96|0);a=j[114630];j[114630]=0;if((a|0)!=1){break p}break d}if(!(l[j[i>>2]+480188>>1]>(e|0)?(e|0)>=0:0)){j[114630]=0;I(2189,a|0,h+112|0,h+96|0);a=j[114630];j[114630]=0;if((a|0)==1){break d}break p}j[114630]=0;c=K(2190,b|0,d|0,e&65535)|0;b=j[114630];j[114630]=0;if((b|0)==1){break o}Ce(h+112|0);Ce(h+96|0);j[114630]=0;b=H(553,c|0)|0;d=j[114630];j[114630]=0;s:{t:{u:{v:{w:{x:{y:{z:{A:{B:{C:{D:{E:{F:{G:{if((d|0)!=1){H:{I:{if(!b){if(!Br(c)){break I}}b=j[i>>2];d=k[c+1|0];e=k[c|0];j[114630]=0;L(2191,h- -64|0,b|0,e|0,d|0);d=j[114630];j[114630]=0;b=1;if((d|0)==1){break G}j[114630]=0;I(9,h+80|0,0,h- -64|0);d=j[114630];j[114630]=0;if((d|0)!=1){break H}c=D()|0;C()|0;break E}b=0;j[114630]=0;E(85,h+80|0,38876)|0;d=j[114630];j[114630]=0;if((d|0)==1){break v}}j[114630]=0;E(1245,h+112|0,h+80|0)|0;d=j[114630];j[114630]=0;if((d|0)==1){break F}gb(h+80|0);if(b){gb(h- -64|0)}j[114630]=0;b=H(553,c|0)|0;d=j[114630];j[114630]=0;if((d|0)==1){break e}J:{if(b){j[114630]=0;E(85,h+80|0,38880)|0;b=j[114630];j[114630]=0;if((b|0)==1){break e}break J}if(Br(c)){j[114630]=0;E(85,h+80|0,38884)|0;b=j[114630];j[114630]=0;if((b|0)!=1){break J}break e}j[114630]=0;E(85,h+80|0,38876)|0;b=j[114630];j[114630]=0;if((b|0)==1){break e}}j[114630]=0;E(1245,h+96|0,h+80|0)|0;b=j[114630];j[114630]=0;if((b|0)==1){break D}gb(h+80|0);m=f-1|0;if(m>>>0<5){break w}j[114630]=0;b=E(85,h+80|0,38894)|0;d=j[114630];j[114630]=0;if((d|0)==1){break C}j[114630]=0;E(1245,h+112|0,b|0)|0;d=j[114630];j[114630]=0;if((d|0)==1){break B}gb(b);j[114630]=0;b=E(85,h+80|0,38894)|0;d=j[114630];j[114630]=0;if((d|0)==1){break A}j[114630]=0;E(1245,h+96|0,b|0)|0;d=j[114630];j[114630]=0;if((d|0)==1){break z}gb(b);b=c+1|0;K:{if(k[c+1|0]){j[114630]=0;F(835,h+80|0,b|0);d=j[114630];j[114630]=0;if((d|0)!=1){break K}break f}j[114630]=0;E(85,h+80|0,38888)|0;d=j[114630];j[114630]=0;if((d|0)==1){break f}}j[114630]=0;E(1245,h+112|0,h+80|0)|0;d=j[114630];j[114630]=0;if((d|0)==1){break y}gb(h+80|0);L:{if(k[b|0]){j[114630]=0;E(85,h+80|0,38891)|0;b=j[114630];j[114630]=0;if((b|0)!=1){break L}break g}j[114630]=0;E(85,h+80|0,38888)|0;b=j[114630];j[114630]=0;if((b|0)==1){break g}}j[114630]=0;E(1245,h+96|0,h+80|0)|0;b=j[114630];j[114630]=0;if((b|0)!=1){break x}c=D()|0;C()|0;gb(h+80|0);break c}c=D()|0;C()|0;break c}c=D()|0;C()|0;break c}c=D()|0;C()|0;gb(h+80|0);if(!b){break c}}gb(h- -64|0);break c}c=D()|0;C()|0;gb(h+80|0);break c}c=D()|0;C()|0;break c}c=D()|0;C()|0;gb(b);break c}c=D()|0;C()|0;break c}c=D()|0;C()|0;gb(b);break c}c=D()|0;C()|0;gb(h+80|0);break c}gb(h+80|0);if(m>>>0<8){break w}j[114630]=0;b=H(1336,c|0)|0;d=j[114630];j[114630]=0;M:{N:{O:{P:{Q:{R:{S:{if((d|0)!=1){T:{if(b){j[114630]=0;b=E(85,h+48|0,38894)|0;d=j[114630];j[114630]=0;if((d|0)==1){break S}j[114630]=0;e=H(1338,c|0)|0;d=j[114630];j[114630]=0;if((d|0)==1){break R}d=0;j[114630]=0;j[h+16>>2]=e&255;F(834,h+32|0,h+16|0);n=j[114630];j[114630]=0;e=1;if((n|0)==1){break R}j[114630]=0;I(138,h+80|0,b|0,h+32|0);b=j[114630];j[114630]=0;if((b|0)!=1){break T}c=D()|0;C()|0;break i}if(k[c+2|0]){b=j[j[i>>2]+8>>2];d=k[c+2|0];j[114630]=0;b=E(2192,b|0,d|0)|0;d=j[114630];j[114630]=0;if((d|0)==1){break N}j[114630]=0;b=K(798,h+48|0,1,b|0)|0;d=j[114630];j[114630]=0;if((d|0)==1){break N}e=0;j[114630]=0;F(835,h+32|0,c+4|0);n=j[114630];j[114630]=0;d=1;if((n|0)==1){break Q}j[114630]=0;I(138,h+80|0,b|0,h+32|0);b=j[114630];j[114630]=0;if((b|0)!=1){break T}c=D()|0;C()|0;gb(h+32|0);break k}e=0;j[114630]=0;E(85,h+80|0,38908)|0;b=j[114630];j[114630]=0;d=0;if((b|0)==1){break O}}j[114630]=0;E(1245,h+112|0,h+80|0)|0;b=j[114630];j[114630]=0;if((b|0)==1){break P}gb(h+80|0);if(d){gb(h+32|0);gb(h+48|0)}if(e){gb(h+32|0);gb(h+48|0)}j[114630]=0;b=H(1336,c|0)|0;d=j[114630];j[114630]=0;if((d|0)==1){break l}U:{if(b){j[114630]=0;E(85,h+80|0,38912)|0;b=j[114630];j[114630]=0;if((b|0)==1){break l}break U}if(k[c+2|0]){j[114630]=0;E(85,h+80|0,38916)|0;b=j[114630];j[114630]=0;if((b|0)!=1){break U}break l}j[114630]=0;E(85,h+80|0,38908)|0;b=j[114630];j[114630]=0;if((b|0)==1){break l}}j[114630]=0;E(1245,h+96|0,h+80|0)|0;b=j[114630];j[114630]=0;if((b|0)!=1){break M}c=D()|0;C()|0;gb(h+80|0);break c}c=D()|0;C()|0;break c}c=D()|0;C()|0;break c}c=D()|0;C()|0;break h}c=D()|0;C()|0;break k}c=D()|0;C()|0;gb(h+80|0);if(!d){break j}gb(h+32|0);break k}c=D()|0;C()|0;break c}c=D()|0;C()|0;break c}gb(h+80|0);if(m>>>0<12){break w}j[114630]=0;b=E(85,h+80|0,38894)|0;d=j[114630];j[114630]=0;V:{W:{X:{Y:{Z:{_:{$:{aa:{ba:{if((d|0)!=1){j[114630]=0;E(1245,h+112|0,b|0)|0;d=j[114630];j[114630]=0;if((d|0)==1){break ba}gb(b);j[114630]=0;b=E(85,h+80|0,38894)|0;d=j[114630];j[114630]=0;if((d|0)==1){break aa}j[114630]=0;E(1245,h+96|0,b|0)|0;d=j[114630];j[114630]=0;if((d|0)==1){break $}gb(b);j[114630]=0;b=H(1336,c|0)|0;d=j[114630];j[114630]=0;if((d|0)==1){break _}ca:{if(b){b=0;j[114630]=0;d=H(1337,c|0)|0;e=j[114630];j[114630]=0;if((e|0)!=1){j[114630]=0;j[h+28>>2]=d&4095;F(1056,h+80|0,h+28|0);d=j[114630];j[114630]=0;if((d|0)!=1){break ca}}c=D()|0;C()|0;break c}if(k[c+3|0]){b=j[j[i>>2]+8>>2];d=k[c+3|0];j[114630]=0;b=E(2193,b|0,d|0)|0;d=j[114630];j[114630]=0;if((d|0)==1){break Z}j[114630]=0;d=K(798,h+16|0,1,b|0)|0;b=j[114630];j[114630]=0;if((b|0)==1){break Z}j[114630]=0;F(835,h|0,c+5|0);e=j[114630];j[114630]=0;b=1;if((e|0)==1){break Y}j[114630]=0;I(138,h+80|0,d|0,h|0);d=j[114630];j[114630]=0;if((d|0)!=1){break ca}c=D()|0;C()|0;gb(h);break m}b=0;j[114630]=0;E(85,h+80|0,38876)|0;d=j[114630];j[114630]=0;if((d|0)==1){break W}}j[114630]=0;E(1245,h+112|0,h+80|0)|0;d=j[114630];j[114630]=0;if((d|0)==1){break X}gb(h+80|0);if(b){gb(h);gb(h+16|0)}j[114630]=0;b=H(1336,c|0)|0;d=j[114630];j[114630]=0;if((d|0)==1){break n}da:{if(b){j[114630]=0;E(85,h+80|0,38920)|0;b=j[114630];j[114630]=0;if((b|0)==1){break n}break da}if(k[c+3|0]){j[114630]=0;E(85,h+80|0,38920)|0;b=j[114630];j[114630]=0;if((b|0)!=1){break da}break n}j[114630]=0;E(85,h+80|0,38876)|0;b=j[114630];j[114630]=0;if((b|0)==1){break n}}j[114630]=0;E(1245,h+96|0,h+80|0)|0;b=j[114630];j[114630]=0;if((b|0)!=1){break V}c=D()|0;C()|0;gb(h+80|0);break c}c=D()|0;C()|0;break c}c=D()|0;C()|0;gb(b);break c}c=D()|0;C()|0;break c}c=D()|0;C()|0;gb(b);break c}c=D()|0;C()|0;break c}c=D()|0;C()|0;break c}c=D()|0;C()|0;break m}c=D()|0;C()|0;gb(h+80|0);if(!b){break c}gb(h);break m}c=D()|0;C()|0;break c}gb(h+80|0);if(!f){break s}}ea:{fa:{if(nb(h+112|0)>>>0>f>>>0){j[114630]=0;L(232,h+80|0,h+112|0,0,f|0);b=j[114630];j[114630]=0;if((b|0)!=1){break fa}c=D()|0;C()|0;break c}if(g){b=nb(h+112|0);j[114630]=0;b=K(798,h+80|0,f-b|0,32)|0;c=j[114630];j[114630]=0;if((c|0)==1){break u}j[114630]=0;E(1245,h+112|0,b|0)|0;c=j[114630];j[114630]=0;if((c|0)==1){c=D()|0;C()|0;gb(b);break c}gb(b);if(nb(h+96|0)>>>0>f>>>0){break t}break ea}if(nb(h+96|0)>>>0<=f>>>0){break s}break t}ob(h+112|0,h+80|0);gb(h+80|0);if(nb(h+96|0)>>>0>f>>>0){break t}if(!g){break s}}b=nb(h+96|0);j[114630]=0;b=K(798,h+80|0,f-b|0,32)|0;c=j[114630];j[114630]=0;ga:{if((c|0)!=1){j[114630]=0;E(1245,h+96|0,b|0)|0;c=j[114630];j[114630]=0;if((c|0)==1){break ga}gb(b);break s}c=D()|0;C()|0;break c}c=D()|0;C()|0;gb(b);break c}c=D()|0;C()|0;break c}c=D()|0;C()|0;break c}j[114630]=0;L(232,h+80|0,h+96|0,0,f|0);b=j[114630];j[114630]=0;if((b|0)!=1){ob(h+96|0,h+80|0);gb(h+80|0);break s}c=D()|0;C()|0;break c}j[114630]=0;I(2189,a|0,h+112|0,h+96|0);a=j[114630];j[114630]=0;if((a|0)==1){break o}}gb(h+96|0);gb(h+112|0);Za=h+128|0;return}c=D()|0;C()|0;break c}c=D()|0;C()|0;break c}gb(h+16|0);break c}c=D()|0;C()|0;break c}gb(h+48|0)}if(!e){break c}}gb(h+32|0)}gb(h+48|0);break c}c=D()|0;C()|0;break c}c=D()|0;C()|0;break c}c=D()|0;C()|0;break c}c=D()|0;C()|0}gb(h+96|0)}gb(h+112|0);G(c|0);z()}function L2(a,b,c,d,e,f,g){var h=0,i=0,l=0,n=0,o=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;h=Za-8976|0;Za=h;z=d+e|0;F=0-z|0;a:{b:{while(1){if((c|0)!=48){c:{if((c|0)!=46){break a}c=j[b+4>>2];if(c>>>0>=m[b+104>>2]){break c}j[b+4>>2]=c+1;c=k[c|0];break b}}else{c=j[b+4>>2];if(c>>>0<m[b+104>>2]){o=1;j[b+4>>2]=c+1;c=k[c|0]}else{o=1;c=Jc(b)}continue}break}c=Jc(b)}t=1;if((c|0)!=48){break a}while(1){c=l;l=c-1|0;n=n-(c>>>0<1)|0;c=j[b+4>>2];d:{if(c>>>0<m[b+104>>2]){j[b+4>>2]=c+1;c=k[c|0];break d}c=Jc(b)}if((c|0)==48){continue}break}o=1}j[h+784>>2]=0;e:{f:{i=(c|0)==46;s=c-48|0;g:{h:{i:{if(i|s>>>0<=9){while(1){j:{if(i&1){if(!t){l=q;n=r;t=1;break j}i=!o;break i}i=q+1|0;r=i>>>0<1?r+1|0:r;q=i;if((v|0)<=2044){y=(c|0)==48?y:q;i=(h+784|0)+(v<<2)|0;o=i;if(u){s=(p(j[i>>2],10)+c|0)-48|0}j[o>>2]=s;o=1;i=u+1|0;c=(i|0)==9;u=c?0:i;v=c+v|0;break j}if((c|0)==48){break j}j[h+8960>>2]=j[h+8960>>2]|1;y=18396}c=j[b+4>>2];k:{if(c>>>0<m[b+104>>2]){j[b+4>>2]=c+1;c=k[c|0];break k}c=Jc(b)}i=(c|0)==46;s=c-48|0;if(i|s>>>0<10){continue}break}}l=t?l:q;n=t?n:r;if(!(!o|(c&-33)!=69)){i=wD(b,g);c=ab;s=c;l:{if(i|(c|0)!=-2147483648){break l}if(!g){break g}i=0;s=0;if(!j[b+104>>2]){break l}j[b+4>>2]=j[b+4>>2]-1}n=n+s|0;b=i+l|0;n=b>>>0<i>>>0?n+1|0:n;l=b;break f}i=!o;if((c|0)<0){break h}}if(!j[b+104>>2]){break h}j[b+4>>2]=j[b+4>>2]-1}if(!i){break f}j[114604]=28}q=0;r=0;dh(b,0,0);c=0;b=0;break e}b=j[h+784>>2];if(!b){Ih(h,+(f|0)*0);q=j[h>>2];r=j[h+4>>2];c=j[h+12>>2];b=j[h+8>>2];break e}if(!((l|0)!=(q|0)|(n|0)!=(r|0)|((r|0)>0?1:(r|0)>=0?q>>>0>9:0)|(b>>>d|0?(d|0)<=30:0))){Uf(h+48|0,f);cm(h+32|0,b);bd(h+16|0,j[h+48>>2],j[h+52>>2],j[h+56>>2],j[h+60>>2],j[h+32>>2],j[h+36>>2],j[h+40>>2],j[h+44>>2]);q=j[h+16>>2];r=j[h+20>>2];c=j[h+28>>2];b=j[h+24>>2];break e}if((n|0)>0?1:(n|0)>=0?l>>>0>(e|0)/-2>>>0:0){j[114604]=68;Uf(h+96|0,f);bd(h+80|0,j[h+96>>2],j[h+100>>2],j[h+104>>2],j[h+108>>2],-1,-1,-1,2147418111);bd(h- -64|0,j[h+80>>2],j[h+84>>2],j[h+88>>2],j[h+92>>2],-1,-1,-1,2147418111);q=j[h+64>>2];r=j[h+68>>2];c=j[h+76>>2];b=j[h+72>>2];break e}b=e-226|0;c=l>>>0<b>>>0;b=b>>31;if((b|0)>(n|0)?1:(n|0)<=(b|0)?c:0){j[114604]=68;Uf(h+144|0,f);bd(h+128|0,j[h+144>>2],j[h+148>>2],j[h+152>>2],j[h+156>>2],0,0,0,65536);bd(h+112|0,j[h+128>>2],j[h+132>>2],j[h+136>>2],j[h+140>>2],0,0,0,65536);q=j[h+112>>2];r=j[h+116>>2];c=j[h+124>>2];b=j[h+120>>2];break e}if(u){if((u|0)<=8){c=(h+784|0)+(v<<2)|0;b=j[c>>2];while(1){b=p(b,10);u=u+1|0;if((u|0)!=9){continue}break}j[c>>2]=b}v=v+1|0}m:{t=l;if((y|0)>(l|0)|(y|0)>=9|(l|0)>17){break m}if((t|0)==9){Uf(h+192|0,f);cm(h+176|0,j[h+784>>2]);bd(h+160|0,j[h+192>>2],j[h+196>>2],j[h+200>>2],j[h+204>>2],j[h+176>>2],j[h+180>>2],j[h+184>>2],j[h+188>>2]);q=j[h+160>>2];r=j[h+164>>2];c=j[h+172>>2];b=j[h+168>>2];break e}if((t|0)<=8){Uf(h+272|0,f);cm(h+256|0,j[h+784>>2]);bd(h+240|0,j[h+272>>2],j[h+276>>2],j[h+280>>2],j[h+284>>2],j[h+256>>2],j[h+260>>2],j[h+264>>2],j[h+268>>2]);Uf(h+224|0,j[(0-t<<2)+59824>>2]);yD(h+208|0,j[h+240>>2],j[h+244>>2],j[h+248>>2],j[h+252>>2],j[h+224>>2],j[h+228>>2],j[h+232>>2],j[h+236>>2]);q=j[h+208>>2];r=j[h+212>>2];c=j[h+220>>2];b=j[h+216>>2];break e}b=(p(t,-3)+d|0)+27|0;c=j[h+784>>2];if(c>>>b|0?(b|0)<=30:0){break m}Uf(h+352|0,f);cm(h+336|0,c);bd(h+320|0,j[h+352>>2],j[h+356>>2],j[h+360>>2],j[h+364>>2],j[h+336>>2],j[h+340>>2],j[h+344>>2],j[h+348>>2]);Uf(h+304|0,j[(t<<2)+59752>>2]);bd(h+288|0,j[h+320>>2],j[h+324>>2],j[h+328>>2],j[h+332>>2],j[h+304>>2],j[h+308>>2],j[h+312>>2],j[h+316>>2]);q=j[h+288>>2];r=j[h+292>>2];c=j[h+300>>2];b=j[h+296>>2];break e}while(1){c=v;v=c-1|0;if(!j[(h+784|0)+(v<<2)>>2]){continue}break}u=0;b=(t|0)%9|0;n:{if(!b){i=0;break n}g=(t|0)>-1?b:b+9|0;o:{if(!c){i=0;c=0;break o}l=j[(0-g<<2)+59824>>2];n=1e9/(l|0)|0;s=0;b=0;i=0;while(1){o=s;r=(h+784|0)+(b<<2)|0;s=j[r>>2];q=(s>>>0)/(l>>>0)|0;o=o+q|0;j[r>>2]=o;o=!o&(b|0)==(i|0);i=o?i+1&2047:i;t=o?t-9|0:t;s=p(n,s-p(l,q)|0);b=b+1|0;if((c|0)!=(b|0)){continue}break}if(!s){break o}j[(h+784|0)+(c<<2)>>2]=s;c=c+1|0}t=(t-g|0)+9|0}while(1){if(!((t|0)!=36|m[(h+784|0)+(i<<2)>>2]>=10384593?(t|0)>=36:0)){v=c+2047|0;s=0;o=c;while(1){c=o;g=v&2047;o=(h+784|0)+(g<<2)|0;b=j[o>>2];n=b>>>3|0;l=b<<29;b=l+s|0;n=b>>>0<l>>>0?n+1|0:n;l=b;s=0;if(!(!n&b>>>0<1000000001)){s=KMa(b,n,1e9,0);l=l-HMa(s,ab,1e9,0)|0}j[o>>2]=l;o=(g|0)!=(c-1&2047)?c:(g|0)==(i|0)?c:l?c:g;v=g-1|0;if((g|0)!=(i|0)){continue}break}u=u-29|0;if(!s){continue}i=i-1&2047;if((o|0)==(i|0)){b=(h+784|0)+((o+2046&2047)<<2)|0;c=o-1&2047;j[b>>2]=j[b>>2]|j[(h+784|0)+(c<<2)>>2]}t=t+9|0;j[(h+784|0)+(i<<2)>>2]=s;continue}break}p:{q:while(1){g=c+1&2047;n=(h+784|0)+((c-1&2047)<<2)|0;while(1){o=i;b=0;r:{s:{while(1){t:{l=b+o&2047;if((l|0)==(c|0)){break t}l=j[(h+784|0)+(l<<2)>>2];i=j[(b<<2)+59776>>2];if(l>>>0<i>>>0){break t}if(i>>>0<l>>>0){break s}b=b+1|0;if((b|0)!=4){continue}}break}if((t|0)!=36){break s}l=0;n=0;b=0;q=0;r=0;while(1){g=b+o&2047;if((g|0)==(c|0)){c=c+1&2047;j[((c<<2)+h|0)+780>>2]=0}bd(h+768|0,l,n,q,r,0,0,1342177280,1075633366);cm(h+752|0,j[(h+784|0)+(g<<2)>>2]);If(h+736|0,j[h+768>>2],j[h+772>>2],j[h+776>>2],j[h+780>>2],j[h+752>>2],j[h+756>>2],j[h+760>>2],j[h+764>>2]);q=j[h+744>>2];r=j[h+748>>2];l=j[h+736>>2];n=j[h+740>>2];b=b+1|0;if((b|0)!=4){continue}break}Uf(h+720|0,f);bd(h+704|0,l,n,q,r,j[h+720>>2],j[h+724>>2],j[h+728>>2],j[h+732>>2]);q=j[h+712>>2];r=j[h+716>>2];l=0;n=0;i=j[h+704>>2];s=j[h+708>>2];t=u+113|0;e=t-e|0;g=(e|0)<(d|0);d=g?(e|0)>0?e:0:d;if((d|0)<=112){break r}break p}l=(t|0)>45?9:1;u=l+u|0;i=c;if((c|0)==(o|0)){continue}r=1e9>>>l|0;s=-1<<l^-1;b=0;i=o;while(1){q=(h+784|0)+(o<<2)|0;v=j[q>>2];b=(v>>>l|0)+b|0;j[q>>2]=b;b=!b&(i|0)==(o|0);i=b?i+1&2047:i;t=b?t-9|0:t;b=p(r,s&v);o=o+1&2047;if((o|0)!=(c|0)){continue}break}if(!b){continue}if((g|0)!=(i|0)){j[(h+784|0)+(c<<2)>>2]=b;c=g;continue q}j[n>>2]=j[n>>2]|1;i=g;continue}break}break}Ih(h+656|0,Bh(1,225-d|0));AD(h+688|0,j[h+656>>2],j[h+660>>2],j[h+664>>2],j[h+668>>2],i,s,q,r);A=j[h+696>>2];B=j[h+700>>2];C=j[h+688>>2];D=j[h+692>>2];Ih(h+640|0,Bh(1,113-d|0));FB(h+672|0,i,s,q,r,j[h+640>>2],j[h+644>>2],j[h+648>>2],j[h+652>>2]);l=j[h+672>>2];n=j[h+676>>2];w=j[h+680>>2];x=j[h+684>>2];av(h+624|0,i,s,q,r,l,n,w,x);If(h+608|0,C,D,A,B,j[h+624>>2],j[h+628>>2],j[h+632>>2],j[h+636>>2]);q=j[h+616>>2];r=j[h+620>>2];i=j[h+608>>2];s=j[h+612>>2]}b=o+4&2047;u:{if((b|0)==(c|0)){break u}b=j[(h+784|0)+(b<<2)>>2];v:{if(b>>>0<=499999999){if((o+5&2047)==(c|0)?!b:0){break v}Ih(h+496|0,+(f|0)*.25);If(h+480|0,l,n,w,x,j[h+496>>2],j[h+500>>2],j[h+504>>2],j[h+508>>2]);w=j[h+488>>2];x=j[h+492>>2];l=j[h+480>>2];n=j[h+484>>2];break v}if((b|0)!=5e8){Ih(h+592|0,+(f|0)*.75);If(h+576|0,l,n,w,x,j[h+592>>2],j[h+596>>2],j[h+600>>2],j[h+604>>2]);w=j[h+584>>2];x=j[h+588>>2];l=j[h+576>>2];n=j[h+580>>2];break v}E=+(f|0);if((o+5&2047)==(c|0)){Ih(h+528|0,E*.5);If(h+512|0,l,n,w,x,j[h+528>>2],j[h+532>>2],j[h+536>>2],j[h+540>>2]);w=j[h+520>>2];x=j[h+524>>2];l=j[h+512>>2];n=j[h+516>>2];break v}Ih(h+560|0,E*.75);If(h+544|0,l,n,w,x,j[h+560>>2],j[h+564>>2],j[h+568>>2],j[h+572>>2]);w=j[h+552>>2];x=j[h+556>>2];l=j[h+544>>2];n=j[h+548>>2]}if((d|0)>111){break u}FB(h+464|0,l,n,w,x,0,0,0,1073676288);if(Ik(j[h+464>>2],j[h+468>>2],j[h+472>>2],j[h+476>>2],0,0,0,0)){break u}If(h+448|0,l,n,w,x,0,0,0,1073676288);w=j[h+456>>2];x=j[h+460>>2];l=j[h+448>>2];n=j[h+452>>2]}If(h+432|0,i,s,q,r,l,n,w,x);av(h+416|0,j[h+432>>2],j[h+436>>2],j[h+440>>2],j[h+444>>2],C,D,A,B);q=j[h+424>>2];r=j[h+428>>2];i=j[h+416>>2];s=j[h+420>>2];w:{if((-2-z|0)>=(t&2147483647)){break w}j[h+408>>2]=q;j[h+412>>2]=r&2147483647;j[h+400>>2]=i;j[h+404>>2]=s;bd(h+384|0,i,s,q,r,0,0,0,1073610752);c=BD(j[h+400>>2],j[h+404>>2],j[h+408>>2],j[h+412>>2],1081081856);b=(c|0)<0;q=b?q:j[h+392>>2];r=b?r:j[h+396>>2];i=b?i:j[h+384>>2];s=b?s:j[h+388>>2];u=((c|0)>-1)+u|0;if(G=!(g&(b|(d|0)!=(e|0))&(Ik(l,n,w,x,0,0,0,0)|0)!=0),H=0,I=(u+110|0)<=(F|0),I?G:H){break w}j[114604]=68}zD(h+368|0,i,s,q,r,u);q=j[h+368>>2];r=j[h+372>>2];c=j[h+380>>2];b=j[h+376>>2]}j[a>>2]=q;j[a+4>>2]=r;j[a+8>>2]=b;j[a+12>>2]=c;Za=h+8976|0}function Iza(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,H=0,J=0,L=0,M=0,O=0,Q=0,R=0;d=Za-304|0;Za=d;rc(b);a:{b:{c:{d:{e:{f:{g:{h:{i:{j:{if(!vs(b,d+208|0)){break j}if(!_N(d+208|0)){break j}if(!yb(b,Tc(ZN(d+208|0),ab))){break j}if(!c){J=1;break j}if(!xc(b,k[d+208|4])){break j}od(a,268435456);Zh(a);j[a+480208>>2]=4;f=Db(d+88|0,16651);ob(a+1304436|0,f);gb(f);f=Db(d+88|0,16670);ob(a+1304448|0,f);gb(f);j[a+1304496>>2]=4;Ge(d+16|0,d+208|6,48,3);qc(d+88|0,d+16|0);ob(a+1304400|0,d+88|0);gb(d+88|0);i[a+480188>>1]=k[d+262|0]+1;j[a+480228>>2]=k[d+265|0];j[a+480204>>2]=p(k[d+266|0],1e4);j[a+480196>>2]=k[d+267|0];if(k[d+262|0]){f=0;while(1){i[((f<<5)+a|0)+480284>>1]=p(k[(d+f|0)+268|0],17);f=f+1|0;if(f>>>0<k[d+262|0]){continue}break}}i[a+480190>>1]=k[d+300|0];r=Hza(d+192|0,k[d+302|0]|k[d+303|0]<<8);f=k[d+302|0]|k[d+303|0]<<8;j[114630]=0;K(934,b|0,r|0,f|0)|0;f=j[114630];j[114630]=0;if((f|0)==1){break i}x=jp(d+176|0);s=jp(d+160|0);f=k[d+301|0];j[114630]=0;K(628,b|0,x|0,f|0)|0;f=j[114630];j[114630]=0;if((f|0)==1){break f}f=k[d+300|0];j[114630]=0;K(628,b|0,s|0,f|0)|0;f=j[114630];j[114630]=0;if((f|0)==1){break f}if(k[d+300|0]){t=c&2;u=d+88|4;v=d+126|0;w=d+88|6;f=0;while(1){j[114630]=0;m=f;f=f+1|0;n=p(f,104)+a|0;g=n+484380|0;F(386,g|0,0);e=j[114630];j[114630]=0;k:{l:{if((e|0)!=1){e=xb(s,m);if(!(k[e|0]|k[e+1|0]<<8|(k[e+2|0]<<16|k[e+3|0]<<24))){break k}e=xb(s,m);e=k[e|0]|k[e+1|0]<<8|(k[e+2|0]<<16|k[e+3|0]<<24);j[114630]=0;e=E(256,b|0,e|0)|0;o=j[114630];j[114630]=0;if((o|0)==1){break c}if(!e){break k}j[114630]=0;e=E(935,b|0,d+88|0)|0;o=j[114630];j[114630]=0;if((o|0)==1){break c}if(!e){break k}j[114630]=0;I(745,d+72|0,2,w|0);e=j[114630];j[114630]=0;if((e|0)!=1){j[114630]=0;F(415,d+16|0,d+72|0);e=j[114630];j[114630]=0;if((e|0)!=1){break l}}f=D()|0;C()|0;break b}f=D()|0;C()|0;break b}j[114630]=0;E(369,((f<<5)+a|0)+946300|0,d+16|0)|0;e=j[114630];j[114630]=0;m:{n:{o:{p:{q:{if((e|0)!=1){gb(d+16|0);j[114630]=0;I(936,d+72|0,2,v|0);e=j[114630];j[114630]=0;if((e|0)==1){break q}j[114630]=0;F(415,d+16|0,d+72|0);e=j[114630];j[114630]=0;if((e|0)==1){break q}j[114630]=0;E(370,n+484423|0,d+16|0)|0;e=j[114630];j[114630]=0;if((e|0)==1){break p}gb(d+16|0);if(k[d+138|0]<=15){e=n+484414|0;i[e>>1]=l[e>>1]|32;i[n+484408>>1]=p(k[d+138|0],17)}e=k[d+139|0];j[114630]=0;h[d+16|0]=e;h[d+72|0]=64;e=E(391,d+16|0,d+72|0)|0;o=j[114630];j[114630]=0;if((o|0)==1){break o}i[n+484412>>1]=k[e|0];j[n+484404>>2]=k[d+141|0]|k[d+142|0]<<8;e=n+484384|0;j[e>>2]=k[d+147|0]|k[d+148|0]<<8|(k[d+149|0]<<16|k[d+150|0]<<24);q=n+484388|0;j[q>>2]=k[d+151|0]|k[d+152|0]<<8|(k[d+153|0]<<16|k[d+154|0]<<24);j[g>>2]=k[d+155|0]|k[d+156|0]<<8|(k[d+157|0]<<16|k[d+158|0]<<24);if(h[d+140|0]&1){break n}o=j[e>>2];e=j[q>>2];break m}f=D()|0;C()|0;gb(d+16|0);break b}f=D()|0;C()|0;break b}f=D()|0;C()|0;gb(d+16|0);break b}f=D()|0;C()|0;break b}o=j[e>>2]>>>1|0;j[e>>2]=o;e=j[q>>2]>>>1|0;j[q>>2]=e;j[g>>2]=j[g>>2]>>>1}r:{if(e>>>0<=o>>>0){break r}e=n+484414|0;i[e>>1]=l[e>>1]|2;if(!(k[d+140|0]&2)){break r}i[e>>1]=l[e>>1]|4}j[114630]=0;N(937,g|0);e=j[114630];j[114630]=0;if((e|0)==1){break c}if(!t){break k}m=xb(s,m);m=k[m|0]|k[m+1|0]<<8|(k[m+2|0]<<16|k[m+3|0]<<24);e=k[u|0];j[114630]=0;E(256,b|0,e+m|0)|0;m=j[114630];j[114630]=0;if((m|0)==1){break c}m=Kc(d+16|0,h[d+140|0]&1?16:8,1,0,1);j[114630]=0;K(400,m|0,g|0,b|0)|0;m=j[114630];j[114630]=0;if((m|0)!=1){break k}f=D()|0;C()|0;break b}if(k[d+300|0]>f>>>0){continue}break}}J=1;s:{if(!(c&1)){break s}j[d+68>>2]=0;n=a+484360|0;xp(Eb(n));Q=d,R=Lb(r),j[Q+64>>2]=R;Q=d,R=Mb(r),j[Q+56>>2]=R;if(rb(d- -64|0,d+56|0)){q=a+484344|0;w=d+88|5;t=d+88|4;while(1){m=j[d- -64>>2];c=m;t:{if(k[c+3|0]>=k[d+301|0]|k[c+2|0]>k[d+262|0]){break t}c=xb(x,k[c+3|0]);c=k[c|0]|k[c+1|0]<<8|(k[c+2|0]<<16|k[c+3|0]<<24);j[114630]=0;c=E(256,b|0,c|0)|0;f=j[114630];j[114630]=0;if((f|0)==1){break g}if(!c){break t}j[114630]=0;E(938,b|0,d+88|0)|0;c=j[114630];j[114630]=0;if((c|0)==1){break h}if(!k[t|0]){break t}c=k[m|0]|k[m+1|0]<<8;f=k[m|0]|k[m+1|0]<<8;h[d+16|0]=k[w|0];e=k[d+262|0];g=k[m+2|0];j[114630]=0;h[d+72|0]=e-g;e=E(391,d+16|0,d+72|0)|0;g=j[114630];j[114630]=0;if((g|0)==1){break d}u=k[e|0];e=k[m|0]|k[m+1|0]<<8;g=k[t|0];j[114630]=0;j[d+52>>2]=e+g;e=E(392,d+68|0,d+52|0)|0;g=j[114630];j[114630]=0;if((g|0)==1){break e}j[d+68>>2]=j[e>>2];j[d+40>>2]=0;j[d+44>>2]=0;j[d+32>>2]=0;j[d+36>>2]=0;j[d+24>>2]=0;j[d+28>>2]=0;j[d+16>>2]=0;j[d+20>>2]=0;if(!k[t|0]){break t}y=c>>>6|0;e=f&63;B=0;while(1){u:{v:{w:{x:{y:{z:{A:{f=e>>>0>63;y=f+y|0;c=y&65535;if(Yb(Eb(n))>>>0<=c>>>0){g=Eb(n);j[114630]=0;F(925,g|0,y+1&65535);g=j[114630];j[114630]=0;if((g|0)==1){break A}j[114630]=0;g=K(810,q|0,64,0)|0;o=j[114630];j[114630]=0;if((o|0)==1){break A}Q=bc(Eb(n),c),R=g,i[Q>>1]=R}v=l[bc(Eb(n),c)>>1];j[114630]=0;c=E(442,q|0,v|0)|0;g=j[114630];j[114630]=0;if((g|0)==1){break y}if(!c){break t}c=Hb(q,v);g=k[m+2|0];j[114630]=0;A=f?0:e;f=K(471,c|0,A|0,g|0)|0;c=j[114630];j[114630]=0;if((c|0)==1){break v}o=0;H=0;if(u){break z}break w}f=D()|0;C()|0;break b}while(1){j[114630]=0;F(939,d+72|0,b|0);c=j[114630];j[114630]=0;if((c|0)==1){break x}g=Pc(d+72|0);M=Bf(d+72|0);L=pi(d+72|0);O=Rb(d+72|0);e=0;c=k[d+72|0];if((c-1&255)>>>0<=142){e=(p((c&240)>>>4|0,12)+(c&15)|0)+13|0;h[(d+16|0)+o|0]=e}h[f|0]=e;c=k[g|0];h[f+2|0]=1;h[f+1|0]=c;c=k[M|0];B:{if((c|0)!=255){h[f+4|0]=c;break B}h[f+2|0]=0}c=k[L|0];C:{if(c>>>0>22){break C}h[f+3|0]=k[c+16688|0];g=k[O|0];h[f+5|0]=g;c=f+5|0;D:{switch(k[L|0]-4|0){case 3:h[c|0]=g&3|64;break C;case 4:h[c|0]=g&3|48;break C;case 7:if(sb(r)>>>0<=g>>>0){break C}g=c;c=xb(r,k[c|0]);e=k[c|0]|k[c+1|0]<<8;h[g|0]=e>>>6;c=Hb(q,v);g=l[a+480188>>1];j[114630]=0;c=K(471,c|0,A|0,g-1&65535)|0;g=j[114630];j[114630]=0;if((g|0)!=1){h[c+3|0]=14;h[c+5|0]=e&63;break C}f=D()|0;C()|0;break b;case 8:h[c|0]=j[d+52>>2]>>>6;c=Hb(q,v);e=l[a+480188>>1];j[114630]=0;c=K(471,c|0,A|0,e-1&65535)|0;e=j[114630];j[114630]=0;if((e|0)!=1){h[c+3|0]=14;h[c+5|0]=k[d+52|0]&63;break C}f=D()|0;C()|0;break b;case 10:h[c|0]=g&15|128;break C;case 12:j[114630]=0;h[d+15|0]=15;e=E(391,c|0,d+15|0)|0;g=j[114630];j[114630]=0;if((g|0)!=1){h[c|0]=k[e|0]|208;break C}f=D()|0;C()|0;break b;case 13:j[114630]=0;h[d+15|0]=15;e=E(391,c|0,d+15|0)|0;g=j[114630];j[114630]=0;if((g|0)!=1){h[c|0]=k[e|0]|192;break C}f=D()|0;C()|0;break b;case 14:j[114630]=0;h[d+15|0]=15;e=E(391,c|0,d+15|0)|0;g=j[114630];j[114630]=0;if((g|0)!=1){h[c|0]=k[e|0]|224;break C}f=D()|0;C()|0;break b;case 0:case 16:case 17:if(!(g&15)){break C}e=g&240;if(!e|(e|0)==240){break C}h[c|0]=g|15;break C;case 9:case 18:break D;default:break C}}if(e&255){break C}h[f|0]=k[(d+16|0)+o|0]}f=f+6|0;H=H+1|0;o=H&65535;if(u>>>0>o>>>0){continue}break}break w}f=D()|0;C()|0;break b}f=D()|0;C()|0;break b}if(u>>>0>=k[w|0]){break u}c=k[w|0];j[114630]=0;E(338,b|0,p(c-u|0,5)|0)|0;c=j[114630];j[114630]=0;if((c|0)!=1){break u}}f=D()|0;C()|0;break b}e=A+1|0;B=B+1|0;if(B>>>0<k[t|0]){continue}break}}Id(d- -64|0);if(rb(d- -64|0,d+56|0)){continue}break}}E:{b=j[d+68>>2];c=b&63;if(!c){break E}f=Eb(n);j[114630]=0;b=b>>>6|0;f=E(546,f|0,b&65535)|0;m=j[114630];j[114630]=0;if((m|0)!=1){if(!f){break E}b=Hb(a+484344|0,l[bc(Eb(n),b&65535)>>1]);j[114630]=0;P(940,b|0,c|0,0,1)|0;b=j[114630];j[114630]=0;if((b|0)!=1){break E}}f=D()|0;C()|0;break b}b=Eb(n);Q=d,R=Lb(b),j[Q+88>>2]=R;Q=d,R=Mb(b),j[Q+16>>2]=R;if(!rb(d+88|0,d+16|0)){break s}a=a+484344|0;e=65535;while(1){b=j[d+88>>2];if(l[b>>1]==65535){F:{if((e&65535)!=65535){break F}j[114630]=0;e=K(810,a|0,64,0)|0;c=j[114630];j[114630]=0;if((c|0)!=1){break F}f=D()|0;C()|0;break b}i[b>>1]=e}je(d+88|0);if(rb(d+88|0,d+16|0)){continue}break}}ji(s);ji(x);XN(r)}Za=d+304|0;return J|0}f=D()|0;C()|0;break a}f=D()|0;C()|0;break b}f=D()|0;C()|0;break b}f=D()|0;C()|0;break b}f=D()|0;C()|0;break b}f=D()|0;C()|0;break b}f=D()|0;C()|0}ji(s);ji(x)}XN(r);G(f|0);z()}function qma(a){var b=0,c=0,d=0,e=0,f=0,g=0,o=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0;d=Za-32|0;Za=d;a:{if(!oma(a)|!j[a+1074420>>2]){break a}b=FJ(a,a+1074376|0);j[a+1074380>>2]=b;j[a+1074404>>2]=b;w=kd(l[a+480188>>1],1,31);z=a+1074328|0;b:{if(k[z+37|0]){b=j[a+24628>>2];if((b|0)>=129){b=((p(b-128|0,w+4|0)|0)/16|0)+128|0}A=p(j[a+480228>>2],b)>>>6|0;break b}A=j[a+480228>>2]}A=k[z+37|0]?(A<<7>>>0)/k[(w>>>1|0)+20752|0]|0:A;i[a+480212>>1]=0;y=a+1304392|0;x=a+1074308|0;C=a+480210|0;D=a+480209|0;while(1){e=p(u,896)+a|0;q=e+1075072|0;c:{if(!(j[q>>2]&4096)|(j[e+1075008>>2]|(j[e+1075004>>2]|j[e+1075680>>2]))){break c}mb(d+24|0,x,64);if(kb(d+24|0)){break c}j[e+1075060>>2]=0;b=e+1075076|0;j[b>>2]=0;j[b+4>>2]=0}b=l[a+480188>>1];f=j[q>>2];d:{if(!(j[e+1075060>>2]|b>>>0>u>>>0?!(f&1024):0)){if(b>>>0>u>>>0){uJ(a,u&65535)}i[e+1075846>>1]=0;break d}o=0;B=e+1075704|0;j[B>>2]=0;r=e+1075664|0;j[r>>2]=0;w=e+1074992|0;c=w;j[c>>2]=0;j[c+4>>2]=0;j[e+1075084>>2]=0;j[d+20>>2]=1065353216;i[d+18>>1]=0;c=0;g=e+1075684|0;c=j[g>>2]?j[e+1075060>>2]!=0:c;s=e+1074984|0;E=e+1075640|0;v=j[E>>2];e:{f:{g:{if(b>>>0<=u>>>0){break g}if(k[((u<<5)+a|0)+480288|0]){break f}if(!v){break g}o=k[v+34|0]!=0}if((c|o)!=1){break e}}j[d+8>>2]=j[e+1075672>>2];j[d+4>>2]=j[e+1075748>>2];mb(d+24|0,x,28);mma(a,s,kb(d+24|0)?d+4|0:d+8|0);lma(a,s);kma(a,s,d+8|0);f=u&65535;jma(a,f,d+8|0);Md(d+8|0,0,256);b=j[d+8>>2]<<6;j[d+8>>2]=b;h:{i:{if(v){mb(d+24|0,x,31);if(kb(d+24|0)){Er(a,s)}ima(a,s,d+8|0);tJ(s,d+8|0);hma(a,s);gma(s);b=j[d+8>>2];break i}if(!(k[q+1|0]&16)){break i}j[e+1075680>>2]=0;j[d+8>>2]=0;break h}if(!b){break h}if(k[q+3|0]&8){j[r>>2]=0;break h}b=j[d+8>>2];if(k[z+36|0]){o=p(j[d+4>>2],j[e+1075744>>2]);b=b<<8;I=r,J=ic(IMa(HMa(o,o>>31,b,b>>31),ab,1048576,0),ab),j[I>>2]=J;break h}o=p(j[d+4>>2],j[e+1075744>>2]);b=p(b,j[a+1074444>>2]);I=r,J=ic(IMa(HMa(o,o>>31,b,b>>31),ab,1048576,0),ab),j[I>>2]=J}j[B>>2]=j[d+8>>2];j:{if(j[a+480180>>2]==2|j[g>>2]>=j[a+480260>>2]){break j}if(Ao(a)){break j}j[g>>2]=j[a+480260>>2]}mb(d+24|0,x,73);if(kb(d+24|0)){Gb(j[g>>2],1,31999)}b=j[g>>2];j[d+12>>2]=b;k:{if((j[q>>2]&1572864)!=1572864){break k}if(k[C|0]&32){if(!Wr(e+1075794|0)|k[D|0]&16){break k}b=j[d+12>>2]}o=e+1075696|0;l:{if(j[o>>2]==(b|0)){b=j[e+1075700>>2];break l}j[o>>2]=b;t=b;b=e+1075752|0;o=e+1075688|0;b=Zf(a,Nr(a,t,j[b>>2],j[o>>2]),j[b>>2],j[o>>2]);j[e+1075700>>2]=b}j[d+12>>2]=b}fma(a,f,d+12|0,d+18|0);if(!(!(k[C|0]&33)|j[d+12>>2]==2147483647)){m:{if(j[a+480180>>2]==2){b=452;f=3424;break m}f=p(j[e+1075752>>2]>>>4&15,24)+21024|0;b=l[f+22>>1];b=b>>>0<904?452:b>>>1|0;f=l[f>>1]<<1}Md(d+12|0,b,f);Md(g,b,f)}sJ(a,s);f=j[q>>2]}n:{if(!(f&256)|k[D|0]&64){break n}mb(d+24|0,x,37);if(!kb(d+24|0)){break n}j[e+1075668>>2]=128}f=u&65535;uJ(a,f);o:{if(!c){break o}b=rJ(a,s,d+12|0);if((b|0)<0|!(k[q+1|0]&2)){break o}if(!$c(y)){break o}No(j[y>>2],f,b>>>2&255,1)}p:{if(k[e+1075796|0]!=8){break p}q:{r:{b=k[e+1075797|0];switch(b-5|0){case 1:break p;case 0:case 2:break q;default:break r}}if((b|0)!=26){break p}}if(j[a+480180>>2]==4){if(k[D|0]&16){break p}b=e+1075823|0;h[b|0]=k[b|0]+k[e+1075827|0];break p}if(!(j[a+480180>>2]&16777248)){break p}Oj(s,k[e+1075798|0]);qJ(a,f,d+12|0,d+20|0)}qJ(a,f,d+12|0,d+20|0);if(c){j[d+8>>2]=0;dma(a,s,d+12|0,d+20|0,d+8|0);if(j[d+12>>2]<=j[a+480260>>2]){mb(d+24|0,x,81);if(kb(d+24|0)){j[e+1075060>>2]=0}j[d+12>>2]=j[a+480260>>2]}o=Yi(s);s:{if(!o){break s}b=e+1075856|0;c=k[b|0];if(j[a+1074392>>2]|!(c&4)?!(c&8):0){break s}zM(s,n[d+20>>2],i[d+18>>1],a);c=k[b|0];if(!(c&8)){h[b|0]=c&251;break s}h[b|0]=c&247}t:{if((j[q>>2]&134219264)!=512){break t}if(!$c(y)){break t}mb(d+24|0,x,99);if(!(I=!(kb(d+24|0)|!(k[q+1|0]&16)),J=0,K=j[a+480180>>2]!=2,K?I:J)){if(!(k[q+1|0]&8?j[a+480180>>2]==2:0)){if(o){b=j[g>>2]}else{b=kK(a,j[d+12>>2],j[e+1075688>>2],j[d+8>>2])}c=HMa(b,0,261625,0)+66904|0;b=ab;b=Tc(KMa(c,c>>>0<66904?b+1|0:b,133808,0),ab);c=HMa(j[a+480240>>2],0,b,0)+32768|0;b=ab;b=c>>>0<32768?b+1|0:b;c=Tc((b&65535)<<16|c>>>16,b>>>16|0);g=j[q>>2];b=1;u:{if(g&2048){break u}b=0;if(!(g&4096)){break u}b=!j[e+1075680>>2]}g=j[y>>2];mb(d+24|0,x,95);hsa(g,f,c,b,kb(d+24|0))}t=j[y>>2];b=HMa(p(j[e+1075748>>2],p(j[e+1075744>>2],j[B>>2])),0,63,0)+33554432|0;c=ab;c=b>>>0<33554432?c+1|0:c;No(t,f,Tc((c&67108863)<<6|b>>>26,c>>>26|0)&255,0);b=e+1075668|0;I=b,J=(gsa(j[y>>2],f,j[b>>2])<<7)+128|0,j[I>>2]=J}v:{b=j[E>>2];if(!b|(k[b+60|0]&7)!=1){break v}b=b+48|0;if(Xc(b)){break v}if(m[pJ(s,0)+4>>2]<l[Ti(b)>>1]){break v}if(k[Ti(b)+2|0]){break v}qh(j[y>>2],f,1);mb(d+24|0,x,109);f=kb(d+24|0);b=j[q>>2];if(!f){b=b&-513;j[q>>2]=b}j[q>>2]=b|4096;j[e+1075680>>2]=0;break t}mb(d+24|0,x,99);if(!kb(d+24|0)|!(k[q+1|0]&16)|j[e+1075680>>2]){break t}qh(j[y>>2],f,1);j[q>>2]=j[q>>2]&-513}c=HMa(Uw(a,s,j[d+12>>2],j[d+8>>2]),ab,j[a+480240>>2],0);b=ab;g=IMa(c,b,65536,0);o=ab;f=w;c=c+65535|0;b=c>>>0<65535?b+1|0:b;b=!b&c>>>0<131071;j[f>>2]=b?1:g;j[f+4>>2]=b?0:o}w:{if(!v){break w}mb(d+24|0,x,31);if(kb(d+24|0)){break w}Er(a,s)}B=e+1075004|0;F=e+1075008|0;j[q>>2]=j[q>>2]&-65537|((j[B>>2]|(j[F>>2]|j[r>>2]))!=0)<<16;f=e+1075656|0;b=f;j[b>>2]=0;j[b+4>>2]=0;g=e+1075846|0;c=k[g|0];b=c-4|0;h[g|0]=b>>>0>c>>>0?0:b;v=e+1075847|0;c=k[v|0];b=c-4|0;h[v|0]=b>>>0>c>>>0?0:b;x:{y:{z:{A:{B:{b=e+1075088|0;c=j[b>>2];C:{if(!c){break C}if(!ke(c)|!j[e+1075060>>2]){break C}if(oh(s)){break B}}o=e+1075e3|0;j[o>>2]=0;break A}o=e+1075e3|0;b=j[j[b>>2]+20>>2];j[o>>2]=b;if(b){break z}}if(!Si(s)|k[q+1|0]&24){break y}}G=j[r>>2];H=j[e+1075668>>2];b=(p(G,256-H|0)|0)/16384|0;c=b>>>0<127?b:127;b=h[g|0];if((b|0)<=-1){h[g|0]=c;t=c}else{t=b}b=c>>>1|0;if((t&255)>>>0<b>>>0){h[g|0]=b}b=(p(G,H)|0)/16384|0;c=b>>>0<127?b:127;b=h[v|0];if((b|0)<=-1){h[v|0]=c;t=c}else{t=b}b=c>>>1|0;if((t&255)>>>0>=b>>>0){break x}h[v|0]=b;break x}if(k[g|0]>=129){h[g|0]=0}if(k[v|0]<129){break x}h[v|0]=0}D:{if(j[o>>2]){b=e+1075660|0;E:{if(m[a+24624>>2]>=2){j[d+24>>2]=j[e+1075668>>2];Md(d+24|0,0,256);g=p(j[r>>2],A)>>>(k[z+37|0]?7:8)|0;c=b;F:{G:{H:{switch(j[z+32>>2]){case 0:if(!(k[a+24616|0]&16)){break G};case 1:r=j[d+24>>2];if((r|0)<=127){j[f>>2]=g>>>1;t=(p(g,r)|0)/256|0;break F}j[f>>2]=(p(g,256-r|0)|0)/256;t=g>>>1|0;break F;case 3:break H;default:break G}}_j(d+24|0,255);t=f;o=j[d+24>>2];r=65536;I:{if((o|0)<1){break I}r=l[(0-o<<1)+27872>>1]}j[t>>2]=p(r,g)>>>16;t=p(g,l[(o<<1)+27360>>1])>>>16|0;break F}r=j[d+24>>2];j[f>>2]=(p(g,256-r|0)|0)/256;t=(p(g,r)|0)/256|0}j[c>>2]=t;break E}c=p(j[r>>2],A)>>>8|0;j[f>>2]=c;j[b>>2]=c}c=j[E>>2];J:{if(c){c=k[c+14|0];if(un(c)){break J}}c=k[a+480268|0];if(un(c)){break J}if(k[C|0]&128){c=255;if(j[a+24668>>2]){break J}}c=k[a+24648|0]}r=e+1075800|0;h[r|0]=c;if(!(k[q+2|0]&2|(j[w>>2]!=0|j[w+4>>2]!=1)|(j[e+1075764>>2]|(c|0)==255))){h[r|0]=0}c=f;t=j[f>>2];f=1<<j[z+28>>2];j[c>>2]=(t|0)/(f|0);f=j[b>>2]/(f|0)|0;j[b>>2]=f;c=j[q>>2];if(!(!(c&256)|j[a+24624>>2]!=2)){j[b>>2]=0-f}if(c&128){b=j[w>>2];f=0-(j[w+4>>2]+((b|0)!=0)|0)|0;j[w>>2]=0-b;j[w+4>>2]=f}cma(a,s);if(k[q+1|0]&2){break D}b=l[a+480212>>1];i[a+480212>>1]=b+1;i[((b<<1)+a|0)+1074466>>1]=u;break D}j[B>>2]=0;j[F>>2]=0;j[e+1075060>>2]=0;if(j[e+1075076>>2]?0:!j[e+1075080>>2]){break D}b=l[a+480212>>1];i[a+480212>>1]=b+1;i[((b<<1)+a|0)+1074466>>1]=u}j[e+1075652>>2]=j[q>>2]}u=u+1|0;if((u|0)!=256){continue}break}c=1;if(m[a+24608>>2]>l[a+480212>>1]){break a}b=a+1074466|0;bma(b,b+(j[a+24608>>2]<<1)|0,b+(l[a+480212>>1]<<1)|0,a)}Za=d+32|0;return c}function cJa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,m=0,n=0,o=0,q=0,r=0,s=0;d=Za-240|0;Za=d;rc(b);a:{b:{c:{d:{e:{f:{g:{h:{i:{j:{if(!tz(b,d+168|0)){break j}if(!AR(d+168|0)){break j}if(!c){e=1;break j}od(a,131072);n=Db(d+152|0,12688);j[114630]=0;F(219,d+32|0,n|0);e=j[114630];j[114630]=0;k:{l:{m:{n:{o:{p:{q:{if((e|0)!=1){j[114630]=0;I(536,d+104|0,d+32|0,d+168|4);e=j[114630];j[114630]=0;if((e|0)==1){break q}ob(a+1304436|0,d+104|0);gb(d+104|0);qb(d+32|0);gb(n);e=Db(d+104|0,12702);ob(a+1304448|0,e);gb(e);j[a+1304496>>2]=4;UR(d+32|0,3,d+181|0);qc(d+104|0,d+32|0);ob(a+1304400|0,d+104|0);gb(d+104|0);jn(d+72|0,3,d+211|0);qc(d+32|0,d+72|0);j[114630]=0;I(13,d+104|0,4,d+32|0);e=j[114630];j[114630]=0;if((e|0)==1){break i}ob(a+1304412|0,d+104|0);gb(d+104|0);gb(d+32|0);e=qp(d+104|0);r=e,s=kd(k[d+231|0],1,31),j[r+12>>2]=s;r=e,s=kd(k[d+232|0],1,12)-1|0,j[r+16>>2]=s;j[e+20>>2]=k[d+233|0];n=a+1304500|0;sz(n);zR(n,e);m=d+72|4;n=d+88|0;HIa(n);while(1){j[114630]=0;e=E(258,b|0,8)|0;f=j[114630];j[114630]=0;if((f|0)==1){break o}if(!e){break k}j[114630]=0;E(537,b|0,d+72|0)|0;e=j[114630];j[114630]=0;if((e|0)==1){break n}e=k[m|0]|k[m+1|0]<<8|(k[m+2|0]<<16|k[m+3|0]<<24);f=k[d+172|0];r:{if((f|0)==3){f=k[d+72|0]|k[d+73|0]<<8|(k[d+74|0]<<16|k[d+75|0]<<24);if(e>>>0<=4294967292){g=2;if((f|0)==1431389523){break r}}f=k[d+172|0]}if((f|0)==4){f=k[d+72|0]|k[d+73|0]<<8|(k[d+74|0]<<16|k[d+75|0]<<24);if(e>>>0<=4294967290){g=4;if((f|0)==1431389523){break r}}f=k[d+172|0]}g=0;if(f>>>0>7){break r}e=(k[d+72|0]|k[d+73|0]<<8|(k[d+74|0]<<16|k[d+75|0]<<24))==1146113363?-1:e}j[114630]=0;I(341,d+32|0,b|0,e|0);e=j[114630];j[114630]=0;if((e|0)==1){break m}j[114630]=0;K(538,n|0,d+72|0,d+32|0)|0;e=j[114630];j[114630]=0;if((e|0)==1){break l}jb(d+32|0);j[114630]=0;E(338,b|0,g|0)|0;e=j[114630];j[114630]=0;if((e|0)!=1){continue}break}e=D()|0;C()|0;break b}e=D()|0;C()|0;break p}e=D()|0;C()|0;qb(d+32|0)}gb(n);break a}e=D()|0;C()|0;break b}e=D()|0;C()|0;break b}e=D()|0;C()|0;break b}e=D()|0;C()|0;jb(d+32|0);break b}j[114630]=0;b=H(277,d+72|0)|0;e=j[114630];j[114630]=0;s:{t:{u:{if((e|0)!=1){j[114630]=0;I(539,d+32|0,n|0,1431389523);e=j[114630];j[114630]=0;if((e|0)==1){break u}Ed(b,d+32|0);jb(d+32|0);i[d+70>>1]=0;i[d+68>>1]=65534;if(k[d+172|0]<3){break s}j[114630]=0;e=H(357,b|0)|0;f=j[114630];j[114630]=0;if((f|0)!=1){break t}break d}e=D()|0;C()|0;break b}e=D()|0;C()|0;break c}i[d+70>>1]=e;if(k[d+172|0]<4){break s}j[114630]=0;e=H(357,b|0)|0;f=j[114630];j[114630]=0;if((f|0)==1){break d}i[d+68>>1]=k[d+172|0]==4?e?e:-2:e}e=a+484360|0;f=Eb(e);j[114630]=0;g=H(540,b|0)|0;m=j[114630];j[114630]=0;if((m|0)==1){break d}j[114630]=0;U(441,f|0,b|0,g>>>1|0,65535,65535)|0;f=j[114630];j[114630]=0;if((f|0)==1){break d}f=Eb(e);j[114630]=0;f=H(541,f|0)|0;g=j[114630];j[114630]=0;if((g|0)==1){break d}Rf(d+70|0,f);f=Eb(e);j[114630]=0;f=H(541,f|0)|0;g=j[114630];j[114630]=0;if((g|0)==1){break d}Rf(d+68|0,f);j[114630]=0;I(539,d+32|0,n|0,1414807888);f=j[114630];j[114630]=0;v:{w:{x:{y:{z:{A:{B:{C:{if((f|0)!=1){Ed(b,d+32|0);jb(d+32|0);j[114630]=0;f=H(337,b|0)|0;g=j[114630];j[114630]=0;if((g|0)==1){break d}if(!(c&1)|f^1){break v}j[114630]=0;E(542,b|0,d- -64|0)|0;f=j[114630];j[114630]=0;if((f|0)==1){break C}r=a,s=kd(k[d- -64|2],1,32)+1|0,i[r+480188>>1]=s;f=d- -64|0;f=k[f|0]|k[f+1|0]<<8;j[114630]=0;f=E(395,d|0,f|0)|0;g=j[114630];j[114630]=0;if((g|0)==1){break B}r=d,s=Lb(f),j[r+16>>2]=s;r=d,s=Mb(f),j[r+56>>2]=s;if(rb(d+16|0,d+56|0)){while(1){m=j[d+16>>2];j[114630]=0;g=k[d+172|0]<3?9:8;E(338,b|0,g-4|0)|0;h=j[114630];j[114630]=0;if((h|0)==1){break A}j[114630]=0;h=H(390,b|0)|0;o=j[114630];j[114630]=0;if((o|0)==1){break z}cg(b,g);j[114630]=0;I(341,d+32|0,b|0,g+h|0);g=j[114630];j[114630]=0;if((g|0)==1){break y}Ed(m,d+32|0);jb(d+32|0);yf(d+16|0);if(rb(d+16|0,d+56|0)){continue}break}}g=l[a+480188>>1];j[114630]=0;g=E(543,d+32|0,g|0)|0;m=j[114630];j[114630]=0;if((m|0)==1){break x}m=Eb(e);j[114630]=0;h=H(544,m|0)|0;m=j[114630];j[114630]=0;if((m|0)==1){break f}j[114630]=0;m=a+484344|0;F(401,m|0,h|0);h=j[114630];j[114630]=0;if((h|0)==1){break f}h=Eb(e);r=d,s=Lb(h),j[r+16>>2]=s;r=d,s=Mb(h),j[r+56>>2]=s;if(rb(d+16|0,d+56|0)){while(1){h=j[d+16>>2];o=l[h>>1];if(Zc(f)>>>0>o>>>0){o=$b(f,l[h>>1]);j[114630]=0;o=P(545,o|0,k[d+172|0],g|0,a|0)|0;q=j[114630];j[114630]=0;if((q|0)==1){break f}i[h>>1]=o}je(d+16|0);if(rb(d+16|0,d+56|0)){continue}break}}h=Eb(e);j[114630]=0;h=E(546,h|0,l[d+68>>1])|0;o=j[114630];j[114630]=0;if((o|0)==1){break f}if(!h){break w}if(!l[d+70>>1]){h=l[d+68>>1];o=Eb(e);j[114630]=0;o=H(541,o|0)|0;q=j[114630];j[114630]=0;if((q|0)==1){break f}if(h>>>0>=o>>>0){break w}}e=l[bc(Eb(e),l[d+68>>1])>>1];h=Hb(m,e);j[114630]=0;o=K(497,d+16|0,12,k[d+70|0])|0;q=j[114630];j[114630]=0;if((q|0)!=1){e=hn(Ee(o,j[Hb(m,e)+12>>2]-1|0));j[114630]=0;E(498,h|0,e|0)|0;e=j[114630];j[114630]=0;if((e|0)!=1){break w}}break f}e=D()|0;C()|0;break c}e=D()|0;C()|0;break c}e=D()|0;C()|0;break c}e=D()|0;C()|0;break e}e=D()|0;C()|0;break e}e=D()|0;C()|0;break e}e=D()|0;C()|0;break e}pR(g);Sc(f)}j[114630]=0;I(539,d+32|0,n|0,1196641603);e=j[114630];j[114630]=0;if((e|0)==1){break h}Ed(b,d+32|0);jb(d+32|0);j[114630]=0;e=H(337,b|0)|0;f=j[114630];j[114630]=0;if((f|0)==1){break d}if(e){j[114630]=0;E(338,b|0,1)|0;e=j[114630];j[114630]=0;if((e|0)==1){break d}j[114630]=0;e=H(540,b|0)|0;f=j[114630];j[114630]=0;if((f|0)==1){break d}j[114630]=0;U(547,a+1304424|0,b|0,e|0,40,0)|0;e=j[114630];j[114630]=0;if((e|0)==1){break d}}j[114630]=0;I(539,d+32|0,n|0,1146113363);e=j[114630];j[114630]=0;if((e|0)==1){break g}j[114630]=0;I(539,d+16|0,n|0,1229999443);e=j[114630];j[114630]=0;D:{E:{if((e|0)!=1){Ed(b,d+16|0);jb(d+16|0);j[114630]=0;e=H(387,b|0)|0;f=j[114630];j[114630]=0;F:{if((f|0)!=1){i[a+480190>>1]=e;if(l[a+480190>>1]){m=!(c&2);e=1;c=1;while(1){g=30;G:{H:{I:{if(k[d+172|0]>=2){j[114630]=0;g=H(387,b|0)|0;f=j[114630];j[114630]=0;if((f|0)==1){break I}}j[114630]=0;K(548,b|0,((e<<5)+a|0)+946300|0,g|0)|0;f=j[114630];j[114630]=0;if((f|0)==1){break I}j[114630]=0;E(549,b|0,d+16|0)|0;f=j[114630];j[114630]=0;if((f|0)==1){break H}j[114630]=0;e=p(e,104)+a|0;g=e+484380|0;F(550,d+16|0,g|0);f=j[114630];j[114630]=0;if((f|0)==1){break H}f=k[d+172|0];if(f>>>0>=8){j[114630]=0;K(551,b|0,e+484423|0,8)|0;f=j[114630];j[114630]=0;if((f|0)==1){break H}f=k[d+172|0]}j[114630]=0;E(338,b|0,(f>>>0>1?6:2)|0)|0;f=j[114630];j[114630]=0;if((f|0)==1){break H}j[114630]=0;f=H(390,d+32|0)|0;h=j[114630];j[114630]=0;if((h|0)!=1){j[114630]=0;I(341,d|0,d+32|0,f|0);f=j[114630];j[114630]=0;if((f|0)!=1){break G}}e=D()|0;C()|0;break E}e=D()|0;C()|0;break E}e=D()|0;C()|0;break E}j[114630]=0;f=H(337,d|0)|0;h=j[114630];j[114630]=0;if((h|0)==1){break F}J:{if(m|f^1){break J}e=Kc(d+56|0,i[e+484414>>1]&1?16:8,1,0,(k[d+31|0]&12)==4?7:0);j[114630]=0;K(400,e|0,g|0,d|0)|0;e=j[114630];j[114630]=0;if((e|0)!=1){break J}break F}jb(d);c=c+1|0;e=c&65535;if(e>>>0<=l[a+480190>>1]){continue}break}}j[114630]=0;N(476,a|0);c=j[114630];j[114630]=0;e=1;if((c|0)!=1){break D}}e=D()|0;C()|0;break E}e=D()|0;C()|0;jb(d);break E}e=D()|0;C()|0}jb(d+32|0);break c}j[a+480204>>2]=12e5;j[a+480208>>2]=24;j[a+480196>>2]=6;j[a+480200>>2]=256;j[a+480228>>2]=48;j[a+480232>>2]=48;jb(d+32|0);jb(b);yR(n)}Za=d+240|0;return e|0}e=D()|0;C()|0;gb(d+32|0);break a}e=D()|0;C()|0;break c}e=D()|0;C()|0;break c}e=D()|0;C()|0;pR(g)}Sc(f);break c}e=D()|0;C()|0}jb(b)}yR(n)}G(e|0);z()}function iU(a,b){var c=0,d=0,e=0,f=0,g=0,n=0,o=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0;c=Za-112|0;Za=c;if(b){N=a+12|0;O=a+24592|0;P=a+24588|0;Vm(N,b,O,P);if(m[a+24624>>2]>=3){Vm(a+8204|0,b,a+24600|0,a+24596|0)}i[c+30>>1]=0;K=a+1074308|0;mb(c+8|0,K,33);g=kb(c+8|0);f=l[a+480212>>1];if(f){W=g?2:1;X=a+24648|0;Y=a+24596|0;Z=a+24600|0;_=a+8204|0;$=a+397460|0;aa=a+397456|0;ba=a+393352|0;Q=a+1074376|0;while(1){w=(L<<1)+Q|0;g=p(l[w+90>>1],896);r=g+Q|0;y=r;a:{b:{if(j[r+624>>2]){break b}e=a+g|0;if(j[e+1075080>>2]){break b}if(!j[e+1075076>>2]){break a}}d=a+g|0;n=kua(k[d+1075800|0]);s=d+1075072|0;e=j[s>>2];t=e&1;u=e>>>5|0;c:{if(!(e&8388608)){z=N;B=P;f=e;o=O;if(!(!(e&16777216)&(k[a+24612|0]&32)>>>5)){break c}}z=qea(ba,b);f=j[s>>2];B=$;o=aa}G=o;g=n|t;n=u&2;e=e>>>12|0;if(!(!(f&256)|m[a+24624>>2]<3)){G=Z;B=Y;z=_}n=g|n;t=e&8;g=r+608|0;C=bl(a,l[w+90>>1],2,1);d:{if((!C|0)==(C>>>0<251|0)){break d}f=j[(p(C,160)+a|0)+906140>>2];if(!f){break d}e=j[f+24>>2];if(!e){break d}B=f+36|0;G=f+40|0;if(!(h[f+28|0]&1)){Vm(e,b,G,B);j[f+28>>2]=j[f+28>>2]|1}z=e}ca=n|t;R=d+1075809|0;da=d+1075792|0;ea=d+1075680|0;fa=d+1075016|0;ga=d+1075012|0;ha=d+1075660|0;ia=d+1075656|0;u=d+1074992|0;D=d+1075080|0;E=d+1075076|0;S=d+1075008|0;T=d+1075004|0;I=d+1075088|0;H=d+1075068|0;t=d+1075060|0;J=d+1075064|0;F=d+1075084|0;A=0;ja=hU(c+8|0,g);w=b;while(1){e:{e=j[F>>2];e=e?e>>>0<w>>>0?e:w:w;j[c+68>>2]=e;x=j[J>>2];v=j[s>>2];n=j[u+4>>2];f=j[u>>2];j[c+56>>2]=f;j[c+60>>2]=n;f:{g:{if(!e|!(f|n)){break g}q=j[t>>2];if(!q){break g}j[y+624>>2]=j[c+8>>2];o=j[g+4>>2];d=o;e=j[g>>2];r=x&v<<30>>31;h:{if((r|0)>(d|0)){if((n|0)<-1?1:(n|0)<=-1){j[c+104>>2]=0;f=r;j[c+108>>2]=f<<1;e=Pf(c+104|0,g);n=ab;d=n;j[g>>2]=e;j[g+4>>2]=d;if(!(d>>>0<j[t>>2]+f>>>1>>>0?(f|0)<=(d|0):0)){e=0;j[g>>2]=e;d=f;j[g+4>>2]=d}q=j[c+60>>2];v=j[c+56>>2];n=v;f=0-(q+((n|0)!=0)|0)|0;n=0-n|0;j[c+56>>2]=n;j[c+60>>2]=f;j[u>>2]=n;j[u+4>>2]=f;f=j[s>>2];i:{if(f&4){f=f&-129;j[s>>2]=f;break i}f=f|128;j[s>>2]=f;o=j[t>>2]-1|0;d=o;j[g>>2]=e;j[g+4>>2]=d;j[u>>2]=v;j[u+4>>2]=q}j:{if(!(f&2)){f=j[t>>2];break j}f=j[t>>2];if(d>>>0<f>>>0){break h}}e=g;j[e>>2]=0;j[e+4>>2]=f;break g}if((o|0)>-1){break h}f=0;d=f;j[g>>2]=e;j[g+4>>2]=d;break h}if(q>>>0>o>>>0){break h}if(!(v&2)){break g}if(v&4){if((n|0)>0?1:(n|0)>=0?f>>>0>=1:0){d=0-(((f|0)!=0)+n|0)|0;f=0-f|0;j[c+56>>2]=f;j[c+60>>2]=d;j[u>>2]=f;j[u+4>>2]=d}j[s>>2]=v|128;d=1-((e|0)!=0)|0;e=0-e|0;n=((q<<1)-o|0)-d|0;d=n;f=g;j[f>>2]=e;j[f+4>>2]=d;if(d>>>0<q>>>0?d>>>0>x>>>0:0){break h}j[c+104>>2]=W;d=q-j[tb(t,c+104|0)>>2]|0;e=j[f>>2];j[g>>2]=e;j[f+4>>2]=d;break h}if((n|0)<-1?1:(n|0)<=-1){d=0-f|0;j[c+56>>2]=d;e=0-(((f|0)!=0)+n|0)|0;j[c+60>>2]=e;j[u>>2]=d;j[u+4>>2]=e}j[c+104>>2]=0;j[c+108>>2]=r-q;Bb(g,c+104|0);j[s>>2]=j[s>>2]|8192;e=j[g>>2];d=j[g+4>>2]}j[c+48>>2]=e;j[c+52>>2]=d;k:{l:{f=d;m:{if((d|0)<(r|0)){if((d|j[c+60>>2])>-1){break m}break l}if((d|0)<0){break l}}e=0;if(f>>>0>=m[t>>2]){break k}U=j[c+68>>2];j[c+44>>2]=U;e=j[c+56>>2];d=j[c+60>>2];jc(c+68|0,j[c+20>>2]);ka=c,la=Ut(c+56|0,j[c+68>>2]-1|0),j[ka+32>>2]=la;j[c+36>>2]=ab;o=d>>31;q=o;f=q+e|0;e=d>>31;d=e+d|0;M=f;n=f>>>0<q>>>0?d+1|0:d;d=j[c+36>>2]+j[c+52>>2]|0;q=j[c+48>>2];f=q+j[c+32>>2]|0;d=f>>>0<q>>>0?d+1|0:d;x=j[c+52>>2];q=x;v=j[c+48>>2];f=j[J>>2];V=f>>>0<=q>>>0&q>>>0<f+16>>>0;if(!V){j[s>>2]=j[s>>2]&-8193}o=o^M;n=e^n;n:{o:{p:{if(!j[c+12>>2]){x=j[c+60>>2];break p}e=j[c+16>>2];if(e>>>0<=x>>>0){f=c;d=j[c+60>>2];q:{if((d|0)<-1?1:(d|0)<=-1){j[c+96>>2]=v;j[c+100>>2]=q;j[c+104>>2]=0;j[c+108>>2]=e;ka=c,la=Pf(c+96|0,c+104|0),j[ka+80>>2]=la;j[c+84>>2]=ab;j[c+72>>2]=1;j[c+76>>2]=0;ka=c,la=Pf(c+80|0,c+72|0),j[ka+88>>2]=la;j[c+92>>2]=ab;d=Bl(c+88|0,o,n);break q}e=j[H>>2];j[c+104>>2]=v;j[c+108>>2]=q;j[c+96>>2]=0;j[c+100>>2]=e;ka=c,la=Pf(c+96|0,c+104|0),j[ka+80>>2]=la;j[c+84>>2]=ab;j[c+72>>2]=1;j[c+76>>2]=0;ka=c,la=Pf(c+80|0,c+72|0),j[ka+88>>2]=la;j[c+92>>2]=ab;d=Bl(c+88|0,o,n)}j[f+44>>2]=d+1;j[y+624>>2]=j[c+12>>2];break n}if(!(!(k[s+1|0]&32)|V^1)){j[c+104>>2]=v;j[c+108>>2]=q;j[c+96>>2]=0;j[c+100>>2]=r+16;ka=c,la=Pf(c+96|0,c+104|0),j[ka+80>>2]=la;j[c+84>>2]=ab;j[c+72>>2]=1;j[c+76>>2]=0;ka=c,la=Pf(c+80|0,c+72|0),j[ka+88>>2]=la;j[c+92>>2]=ab;ka=c,la=Bl(c+88|0,o,n)+1|0,j[ka+44>>2]=la;ka=y,la=j[c+12>>2]+p(j[H>>2]-r|0,Bn(j[I>>2]))|0,j[ka+624>>2]=la;break n}M=j[c+60>>2];x=M;if((x|0)<0?1:(x|0)<=0?m[c+56>>2]<1:0){break p}if(U>>>0<2|d>>>0<e>>>0){break o}j[c+104>>2]=v;j[c+108>>2]=q;j[c+96>>2]=0;j[c+100>>2]=e;ka=c,la=Pf(c+96|0,c+104|0),j[ka+80>>2]=la;j[c+84>>2]=ab;j[c+72>>2]=1;j[c+76>>2]=0;ka=c,la=Pf(c+80|0,c+72|0),j[ka+88>>2]=la;j[c+92>>2]=ab;ka=c,la=Bl(c+88|0,o,n)+1|0,j[ka+44>>2]=la;break n}if((x|0)>-1){break o}if((d|0)>=(r|0)){break n}j[c+96>>2]=v;j[c+100>>2]=q;j[c+104>>2]=0;j[c+108>>2]=f;ka=c,la=Pf(c+96|0,c+104|0),j[ka+80>>2]=la;j[c+84>>2]=ab;j[c+72>>2]=1;j[c+76>>2]=0;ka=c,la=Pf(c+80|0,c+72|0),j[ka+88>>2]=la;j[c+92>>2]=ab;ka=c,la=Bl(c+88|0,o,n)+1|0,j[ka+44>>2]=la;break n}f=d;d=j[t>>2];if((f|0)<(d|0)){break n}j[c+104>>2]=v;j[c+108>>2]=q;j[c+96>>2]=0;j[c+100>>2]=d;ka=c,la=Pf(c+96|0,c+104|0),j[ka+80>>2]=la;j[c+84>>2]=ab;j[c+72>>2]=1;j[c+76>>2]=0;ka=c,la=Pf(c+80|0,c+72|0),j[ka+88>>2]=la;j[c+92>>2]=ab;ka=c,la=Bl(c+88|0,o,n)+1|0,j[ka+44>>2]=la}An(c+44|0,1,j[c+68>>2]);e=j[c+44>>2];break k}e=0}if((e|0)>0){break f}}j[y+624>>2]=0;j[t>>2]=0;j[g>>2]=0;j[g+4>>2]=0;j[F>>2]=0;dua(g,z,w);j[G>>2]=j[G>>2]+j[E>>2];j[B>>2]=j[B>>2]+j[D>>2];j[D>>2]=0;j[E>>2]=0;j[s>>2]=j[s>>2]&-129;break e}r:{s:{if(m[a+24608>>2]>l[c+30>>1]){A=4;if(j[F>>2]){break s}A=0;if(j[S>>2]|j[T>>2]){break s}}ka=c,la=HMa(j[u>>2],j[u+4>>2],e,e>>31),j[ka+104>>2]=la;j[c+108>>2]=ab;Bb(g,c+104|0);A=0;j[D>>2]=0;j[E>>2]=0;d=(e<<3)+z|0;break r}d=(e<<3)+z|0;f=d-8|0;j[E>>2]=0-j[f>>2];r=d-4|0;j[D>>2]=0-j[r>>2];bb[j[((A|ca)<<2)+77568>>2]](g,X,z,e);j[E>>2]=j[E>>2]+j[f>>2];j[D>>2]=j[D>>2]+j[r>>2];A=1}z=d;d=j[F>>2];t:{if(!d){break t}if(d>>>0<=e>>>0){j[F>>2]=0;j[T>>2]=j[ia>>2];j[S>>2]=j[ha>>2];j[ga>>2]=0;j[fa>>2]=0;if(j[ea>>2]|!(k[s+1|0]&16)){break t}j[t>>2]=0;j[y+624>>2]=0;break t}j[F>>2]=d-e}d=0;f=0;r=j[g+4>>2];f=r>>>0>=m[H>>2]?(k[s|0]&2)>>>1|0:f;o=r;r=j[t>>2];d=j[s>>2]&2|(o>>>0<r>>>0|!r)?d:!l[da>>1];w=w-e|0;mb(c+104|0,K,85);u:{v:{w:{x:{if(!kb(c+104|0)){break x}e=k[R|0];if(!e|e>>>0>l[a+480190>>1]){break x}o=!(d|f);r=j[I>>2];e=p(k[R|0],104)+a|0;d=e+484380|0;if(o|(r|0)==(d|0)){break w}j[I>>2]=d;j[y+624>>2]=j[e+484400>>2];d=l[e+484414>>1];j[s>>2]=d|j[s>>2]&-768;f=d<<30>>31;d=j[e+484388>>2];j[t>>2]=f&d;e=j[e+484384>>2];j[J>>2]=e;j[H>>2]=d;j[g+4>>2]=e;AA(ja,g);if(!j[y+624>>2]){break e}if((w|0)>0){continue}break e}if(f){break v}break u}if(!f|(d|0)!=(r|0)){break u}}mb(c+104|0,K,83);if(!kb(c+104|0)|j[J>>2]){break u}j[g>>2]=j[g>>2];j[g+4>>2]=0;e=j[j[I>>2]+8>>2];j[t>>2]=e;j[H>>2]=e}if((w|0)>0){continue}}break}j[y+624>>2]=j[c+8>>2];i[c+30>>1]=l[c+30>>1]+A;y:{if(!A|(!C|C>>>0>250)){break y}g=j[(p(C,160)+a|0)+906140>>2];if(!g){break y}bb[j[j[g>>2]+144>>2]](g)}f=l[a+480212>>1]}L=L+1|0;if(L>>>0<(f&65535)>>>0){continue}break}}ka=a,la=l[vi(a+480214|0,c+30|0)>>1],i[ka+480214>>1]=la}Za=c+112|0}function gHa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;d=Za-272|0;Za=d;rc(b);e=d+112|0;g=dHa(b,e);if(!g){OQ(e)}a:{b:{c:{d:{e:{f:{g:{h:{i:{if(!g){break i}if(!QQ(d+112|0)){break i}if(!c){f=1;break i}od(a,j[((k[d+228|0]|k[d+229|0]<<8)<<2)+12976>>2]);e=Db(d+16|0,13016);ob(a+1304436|0,e);gb(e);e=Db(d+16|0,13038);ob(a+1304448|0,e);gb(e);e=Db(d+80|0,13042);j[114630]=0;F(219,d+96|0,e|0);f=j[114630];j[114630]=0;if((f|0)==1){break c}j[114630]=0;L(427,d+16|0,d+96|0,d+191|0,d+188|0);f=j[114630];j[114630]=0;if((f|0)==1){break d}ob(a+1304460|0,d+16|0);gb(d+16|0);qb(d+96|0);gb(e);vc(a+1304484|0,((k[d+228|0]|k[d+229|0]<<8)<<2)+13072|0);vc(a+1304472|0,j[((k[d+228|0]|k[d+229|0]<<8)<<2)+77472>>2]);j[a+1304496>>2]=4;vg(d+96|0,2,d+112|4);qc(d+16|0,d+96|0);ob(a+1304400|0,d+16|0);gb(d+16|0);vg(d+96|0,2,d+148|0);qc(d+16|0,d+96|0);if(Xs(d+16|0,13112)){j[114630]=0;I(13,d+96|0,4,d+16|0);e=j[114630];j[114630]=0;if((e|0)==1){break h}ob(a+1304412|0,d+96|0);gb(d+96|0)}gb(d+16|0);i[a+480188>>1]=32;e=0;j:{while(1){g=(e<<5)+a|0;n=g+480280|0;wg(n);k:{f=d+e|0;if(k[f+193|0]<=15){j[d+16>>2]=k[f+193|0]<<4|8;j[d+96>>2]=256;x=g+480284|0,y=j[Pd(d+16|0,d+96|0)>>2],i[x>>1]=y;break k}if(k[f+193|0]==16){i[g+480284>>1]=128;j[n>>2]=256;break k}if(k[f+193|0]!=255){break k}i[a+480188>>1]=e;break j}e=e+1|0;if((e|0)!=32){continue}break}e=l[a+480188>>1]}f=0;if(!(e&65535)){break i}j[d+16>>2]=k[d+225|0]<<2;j[d+96>>2]=256;x=a,y=j[tb(d+16|0,d+96|0)>>2],j[x+480200>>2]=y;j[a+480196>>2]=k[d+226|0];j[a+480204>>2]=p(k[d+227|0],1e4);if(xc(b,k[d+230|0]|k[d+231|0]<<8|(k[d+232|0]<<16|k[d+233|0]<<24))){mp(Eb(a+484360|0),b,k[d+234|0]+1|0,255,254)}if(!xc(b,k[d+240|0]|k[d+241|0]<<8|(k[d+242|0]<<16|k[d+243|0]<<24))){break i}i[a+480190>>1]=k[d+248|0]+1;m=d+48|0;e=1;n=1;while(1){if(fHa(b,d+16|0)){f=p(e,104)+a|0;g=f+484380|0;md(g,0);vg(d,2,d+16|0);qc(d+96|0,d);j[114630]=0;E(369,((e<<5)+a|0)+946300|0,d+96|0)|0;e=j[114630];j[114630]=0;if((e|0)==1){break e}gb(d+96|0);ek(d,2,m);qc(d+96|0,d);j[114630]=0;E(370,f+484423|0,d+96|0)|0;e=j[114630];j[114630]=0;if((e|0)==1){break f}gb(d+96|0);e=f+484404|0;j[e>>2]=k[d+74|0]|k[d+75|0]<<8;l:{if(!kp(a)){break l}o=j[e>>2];e=0;while(1){if((o|0)==l[(e<<1)+13120>>1]){h[f+484417|0]=e<<4;break l}e=e+1|0;if((e|0)!=16){continue}break}}i[f+484412>>1]=64;j[g>>2]=k[d+61|0]|k[d+62|0]<<8|(k[d+63|0]<<16|k[d+64|0]<<24);if(k[d+73|0]&2){e=f+484414|0;i[e>>1]=l[e>>1]|1;j[g>>2]=j[g>>2]>>>1}j[f+484384>>2]=k[d+65|0]|k[d+66|0]<<8|(k[d+67|0]<<16|k[d+68|0]<<24);j[f+484388>>2]=(k[d+69|0]|k[d+70|0]<<8|(k[d+71|0]<<16|k[d+72|0]<<24))-1;if(h[d+73|0]&1){e=f+484414|0;i[e>>1]=l[e>>1]|2}m:{if(k[d+73|0]&4){h[d+96|0]=k[d+76|0];h[d|0]=64;x=f+484410|0,y=k[Zb(d+96|0,d)|0]<<2,i[x>>1]=y;break m}e=f+484414|0;i[e>>1]=l[e>>1]|32768}n:{if(!(k[d+73|0]&8)){i[f+484408>>1]=128;break n}e=f+484414|0;i[e>>1]=l[e>>1]|32;g=f+484408|0;if(k[d+77|0]<=15){f=k[d+77|0];j[d>>2]=256;j[d+96>>2]=f<<4|8;q=j[Pd(d+96|0,d)>>2]}else{q=128}i[g>>1]=q;i[e>>1]=l[e>>1]&65279|(k[d+77|0]==16)<<8}n=n+1|0;e=n&65535;if(e>>>0<=l[a+480190>>1]){continue}}break}o:{if(!(c&2)){break o}if(!xc(b,k[d+244|0]|k[d+245|0]<<8|(k[d+246|0]<<16|k[d+247|0]<<24))|!l[a+480190>>1]){break o}e=1;while(1){f=p(e&65535,104)+a|0;$f(Kc(d+16|0,i[f+484414>>1]&1?16:8,1,0,1),f+484380|0,b);e=e+1|0;if(l[a+480190>>1]>=(e&65535)>>>0){continue}break}}s=a+484344|0;Jf(s,k[d+239|0]+1|0);o=Rma(vo(a));xc(b,k[d+235|0]|k[d+236|0]<<8|(k[d+237|0]<<16|k[d+238|0]<<24));v=c&1;n=0;t=1;while(1){c=Of(b);if(c>>>0>=3){cd(d+16|0,b,c-2|0);p:{if(!v){break p}j[114630]=0;c=H(337,d+16|0)|0;e=j[114630];j[114630]=0;if((e|0)==1){break g}if(!c){break p}j[114630]=0;c=K(402,s|0,n&65535,64)|0;e=j[114630];j[114630]=0;if((e|0)==1){break g}r=0;if(!c){break p}while(1){c=Hb(s,n);j[114630]=0;w=E(496,c|0,r|0)|0;c=j[114630];j[114630]=0;if((c|0)==1){break g}q:while(1){j[114630]=0;c=H(387,d+16|0)|0;e=j[114630];j[114630]=0;if((e|0)==1){break g}r:{if(!c){break r}e=c&31;if(e>>>0>=l[a+480188>>1]){break r}f=p(e,6)+w|0;if(c&32){j[114630]=0;F(472,d+96|0,d+16|0);e=j[114630];j[114630]=0;if((e|0)==1){break g}g=Pc(d+96|0);e=d+96|0;m=k[e|0];if(m){q=e;e=(m&127)-1|0;h[q|0]=e;h[f|0]=(p((e&240)>>>4|0,12)+(e&15)|0)+13;j[114630]=0;e=H(611,f|0)|0;m=j[114630];j[114630]=0;if((m|0)==1){break g}t=e&t}h[f+1|0]=k[g|0]}if(!(c&64)){continue}h[f+2|0]=0;h[f+3|0]=0;g=f+5|0;while(1){j[114630]=0;c=E(258,d+16|0,2)|0;e=j[114630];j[114630]=0;s:{t:{u:{v:{w:{x:{y:{z:{A:{B:{C:{D:{E:{F:{if((e|0)!=1){if(!c){continue q}q=k[g|0];c=k[f+3|0];j[114630]=0;F(472,d+96|0,d+16|0);e=j[114630];j[114630]=0;if((e|0)==1){break g}m=k[Pc(d+96|0)|0];h[g|0]=m;u=d+96|0;e=k[(k[u|0]&31)+13152|0];h[f+3|0]=e;switch(e-2|0){case 2:case 3:case 6:case 7:case 8:case 9:case 10:case 12:case 14:case 15:case 16:break u;case 18:break y;case 13:break z;case 17:break A;case 11:break B;case 5:break C;case 4:break D;case 1:break E;case 0:break F;default:break x}}break g}if(m>>>0<224){break s}break t}if(m>>>0>=224){break t}break s}e=m&240;if(!e){break s}h[g|0]=e;break v}e=m&240;if(!e){break s}h[g|0]=e;break v}j[114630]=0;h[d|0]=64;e=E(391,g|0,d|0)|0;m=j[114630];j[114630]=0;if((m|0)!=1){h[g|0]=k[e|0];j[114630]=0;e=E(612,o|0,1)|0;m=j[114630];j[114630]=0;if((m|0)==1){break g}if(!e){break v}h[f+2|0]=1;h[f+4|0]=k[g|0];h[f+3|0]=c;h[g|0]=q;e=c;break u}break g}j[114630]=0;e=E(613,o|0,19)|0;m=j[114630];j[114630]=0;if((m|0)==1){break g}if(e){break v}j[114630]=0;N(614,f|0);e=j[114630];j[114630]=0;if((e|0)!=1){break v}break g}j[114630]=0;e=E(613,o|0,15)|0;m=j[114630];j[114630]=0;if((m|0)==1){break g}if(e){break v}j[114630]=0;e=E(613,o|0,19)|0;m=j[114630];j[114630]=0;if((m|0)==1){break g}if(!e){break v}h[f+3|0]=19;h[g|0]=k[g|0]&15|144;break s}G:{e=m>>>4|0;if((e|0)!=8){if(e){break G}H:{switch(m&15){case 4:h[f+3|0]=20;h[g|0]=158;break s;case 0:case 1:break w;case 5:break H;default:break G}}h[f+3|0]=20;h[g|0]=159;break s}j[114630]=0;e=E(613,o|0,20)|0;m=j[114630];j[114630]=0;if((m|0)==1){break g}if(e){break v}h[f+3|0]=19;break s}h[f+3|0]=0;break s}if((e|0)!=31){break u}h[f+3|0]=17;break s}h[g|0]=m-112}e=k[f+3|0]}if((e&255)!=20){break s}e=k[g|0];if(k[f+2|0]|(e&240)!=128){break s}h[f+2|0]=2;h[f+4|0]=(((e&15)<<6|8)>>>0)/15;h[f+3|0]=c;h[g|0]=q;break s}h[g|0]=223}if(k[u|0]&32){continue}break}continue}break}r=r+1|0;if((r|0)!=64){continue}break}}jb(d+16|0)}c=k[d+239|0]>n>>>0;n=n+1|0;if(c){continue}break}c=a;if((t^-1|l[a+480188>>1]!=4)&1|j[a+480180>>2]!=1){e=j[a+480208>>2]&-8454145}else{e=j[a+480208>>2]|8454144}j[c+480208>>2]=e;f=1;if(!(k[d+253|0]|k[d+254|0]<<8|(k[d+255|0]<<16|k[d+256|0]<<24))){break i}if(!xc(b,k[d+249|0]|k[d+250|0]<<8|(k[d+251|0]<<16|k[d+252|0]<<24))){break i}Rx(a+1304424|0,b,k[d+253|0]|k[d+254|0]<<8|(k[d+255|0]<<16|k[d+256|0]<<24),4)}Za=d+272|0;return f|0}f=D()|0;C()|0;gb(d+16|0);break a}f=D()|0;C()|0;jb(d+16|0);break a}f=D()|0;C()|0;gb(d+96|0);break a}f=D()|0;C()|0;gb(d+96|0);break a}f=D()|0;C()|0;qb(d+96|0);break b}f=D()|0;C()|0}gb(e)}G(f|0);z()}function wBa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,m=0,n=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,E=0,J=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0;d=Za-336|0;Za=d;a:{if(!xc(b,1080)){break a}if(!dn(b,d+332|0)){break a}od(a,1);u=OO(d+312|0);if(!NO(d+332|0,u)){break a}e=l[u+8>>1];if((e-1&65535)>>>0>126){break a}if(!c){f=1;break a}i[a+480188>>1]=e;w=k[u+12|0];T=k[u+11|0];e=k[u+10|0];O=1;if(!Jd(d+332|0,15619)){O=Jd(d+332|0,15624)}if(k[u+13|0]){vb(a+1074308|0,5,1)}J=a+480188|0;L=T?l[J>>1]==8:0;B=Jd(d+332|0,15629);q=1;if(!Jd(d+332|0,15634)){q=Jd(d+332|0,15639)}xc(b,0);Zy(b,a+1304400|0,20);i[a+480190>>1]=31;t=(e|0)!=0;y=d+201|0;x=d+204|0;g=d+198|0;v=d+200|0;f=1;e=B;while(1){A=p(f,104)+a|0;s=A+484380|0;E=vy(b,d+176|0,s,((f<<5)+a|0)+946300|0,l[a+480188>>1]==4);s=j[s>>2];b:{if(q){h[A+484417|0]=0-(k[v|0]<<3);break b}t=s>>>0<65536&t}P=k[g|0]|k[g+1|0]<<8?!(k[x|0]|k[x+1|0]<<8)|P:P;A=e&1;e=0;c:{if(!A){break c}r=m;m=k[g|0]|k[g+1|0]<<8;m=r+(((m<<8|m>>>8)&65535)<<1)|0;if(k[v|0]){break c}if(!(k[g|0]|k[g+1|0]<<8)){e=1;break c}e=k[y|0]==64}Q=E+Q|0;n=n+s|0;f=f+1|0;if((f|0)!=32){continue}break}d:{e:{f:{g:{h:{i:{j:{k:{U=j[u+4>>2];if(U>>>0>=Q>>>0){uy(b,d+176|0);Jb(b,4);x=d+176|1;f=k[x|0];g=128;q=a+484360|0;kn(Eb(q),d+176|2,128,65535,65535);r=m;m=!f&e;v=m?r:0;e=k[d+176|0];l:{if(e>>>0>128){break l}g=e;if(e){break l}e=128;while(1){f=e-1|0;if(!l[bc(Eb(q),f)>>1]){g=1;e=f;if(e>>>0>1){continue}break l}break}g=e}R=(w|0)!=0;s=LO(b,Eb(q),g&65535,n,J,v);if(!(!m|l[a+480188>>1]!=8)){j[u>>2]=15644;R=1}m:{if(!L){break m}e=Eb(q);da=d,ea=Lb(e),j[da+160>>2]=ea;da=d,ea=Mb(e),j[da+144>>2]=ea;if(!rb(d+160|0,d+144|0)){break m}while(1){e=j[d+160>>2];i[e>>1]=l[e>>1]>>>1;je(d+160|0);if(rb(d+160|0,d+144|0)){continue}break}}Fe(Eb(q),k[x|0]);V=g-1&65535;if(!(k[x|0]!=120|l[J>>1]!=4?V>>>0>=k[x|0]:0)){Fe(Eb(q),0)}j[a+480260>>2]=56;j[a+480264>>2]=13696;j[a+480204>>2]=125e4;j[a+480196>>2]=6;f=0;e=Gb(256/l[a+480188>>1]|0,32,128);j[a+480208>>2]=0;j[a+480228>>2]=e;Qi(a,0);h[d+175|0]=0;v=1;W=1;if(!(t&1)){n:{if(!s){n=B;f=0;break n}y=d+160|5;n=B;t=0;m=0;q=0;while(1){e=0;g=0;while(1){f=ni(d+160|0);Es(b,f);w=PQ(f);o:{p:{q:{f=k[d+163|0];if((f-7&255)>>>0<3){n=0;break q}n=w?n:0;r:{s:{t:{switch(f-13|0){case 2:if(k[d+165|0]>31){break s}break o;case 1:break r;case 0:break t;default:break q}}g=g+1|0;if((g&65535)>>>0<2){break o}}n=0;break o}f=k[d+165|0];n=f>>>0>1?0:n;break p}if((f|0)!=8){if((f|0)!=14){break o}f=k[d+165|0];break p}da=d,ea=k[Vg(d+175|0,y)|0],h[da+175|0]=ea;f=h[d+165|0];if((f|0)>-1){q=1;break o}m=(f|0)!=-92&(f&255)>>>0>143|m;break o}if((f&240)!=128){break o}h[d+144|0]=f<<4;da=d,ea=k[Vg(d+175|0,d+144|0)|0],h[da+175|0]=ea}v=v&w;e=e+1|0;if((e|0)!=256){continue}break}t=t+1|0;if(s>>>0>(t&65535)>>>0){continue}break}f=0;if((q^-1|m)&1){break n}f=k[d+175|0]>47}W=n&1}xc(b,1084);q=4;q=L?q:l[J>>1];y=a+484344|0;M=s+L&65535;Jf(y,M);u:{v:{w:{x:{y:{if(!M){A=0;E=0;break y}$=a+1074308|0;aa=c&1;ba=f^1;s=0;E=0;A=0;while(1){g=!aa;z:{if(L){e=(s&65534)>>>1|0;n=s&1;if(!n){if(!Wf(y,e,64)){break y}}m=Se(Hb(y,e),0,n<<2);break z}if(!Wf(y,s&65535,64)){break y}m=Se(Hb(y,s),0,0)}if(g|!m){break y}e=l[a+480188>>1];h[d+144|0]=0;w=it(d+160|0,e,d+144|0);e=l[a+480188>>1];j[114630]=0;h[d+64|0]=0;N=K(881,d+144|0,e|0,d- -64|0)|0;e=j[114630];j[114630]=0;if((e|0)==1){break x}S=0;while(1){g=0;X=0;t=0;n=0;if(q){while(1){j[114630]=0;f=p(t,6)+m|0;F(882,b|0,f|0);e=j[114630];j[114630]=0;A:{B:{C:{if((e|0)==1){break C}e=k[f+3|0];D:{E:{F:{if(!e){if(k[f+5|0]){break F}break E}if(!T){break F}G:{switch(e-14|0){case 0:h[f+3|0]=0;h[f+5|0]=0;break F;case 1:break G;default:break F}}if(k[f+5|0]<32){break F}h[f+5|0]=31}_i(f);e=1;H:{I:{J:{r=k[f+3|0];switch(r-14|0){case 2:break D;case 0:break I;case 3:break J;default:break H}}A=k[f+5|0]<100|A;X=1;break E}if(!W){break E}h[f+5|0]=0;break E}if(!((r|0)!=9|ba)){e=k[f+5|0];if((e|0)==164){h[f+3|0]=20;h[f+5|0]=145;break E}j[114630]=0;e=H(883,e<<1)|0;r=j[114630];j[114630]=0;if((r|0)==1){break C}h[f+5|0]=e;break E}if((r|0)!=19){break E}e=k[f+5|0];if(e>>>0>15){break E}r=e&1;e=r^1;ca=!r;r=Y&1;Y=(r|0)==(e|0)?Y:ca;Z=((e|0)!=(r|0))+Z|0}e=g}if(k[f|0]){break B}if(!k[f+1|0]|L){break A}if(!k[fc(w,t)|0]){break A}if(k[fc(w,t)|0]==k[f+1|0]){break A}r=fc(N,t);g=k[r|0]+1|0;h[r|0]=g;if((g&255)>>>0<4){break A}j[114630]=0;K(478,$|0,85,1)|0;g=j[114630];j[114630]=0;if((g|0)!=1){break A}}f=D()|0;C()|0;Od(N);break w}da=fc(N,t),ea=0,h[da|0]=ea}g=k[f+1|0];if(g){da=fc(w,t),ea=g,h[da|0]=ea}g=e;n=n+1|0;t=n&65535;if(t>>>0<q>>>0){continue}break}}E=g&X|E;m=p(l[J>>1],6)+m|0;S=S+1|0;if((S|0)!=64){continue}break}Od(N);Od(w);s=s+1|0;if((M|0)!=(s|0)){continue}break}}K:{if((v^-1|P)&1){break K}L:{if(Jd(d+332|0,15629)){break L}if(Jd(d+332|0,15656)){break L}if(!Jd(d+332|0,15661)){break K}}j[a+480208>>2]=j[a+480208>>2]|2162688;e=a+1074308|0;vb(e,85,1);vb(e,91,1);vb(e,92,1);M:{if(k[d+175|0]>47){break M}vb(e,84,1);if(k[x|0]==127){break M}vb(e,83,1)}if(!v){break u}break v}if(v){break v}if(B^1|k[x|0]!=127|k[x|0]+1>>>0<V>>>0){break u}j[u>>2]=15666;break u}f=D()|0;C()|0}Od(w);break d}if((Z|0)>6|R){break u}j[a+480208>>2]=j[a+480208>>2]|8388608}if((B|R)==1){vb(a+1074308|0,89,1)}if(O){vb(a+1074308|0,84,1)}if(c&2){xc(b,(p(q,M)<<8)+1084|0);g=v&B;f=1;while(1){n=p(f,104)+a|0;c=n+484380|0;if(j[c>>2]){m=d+160|0;if(O){e=2}else{e=KO(b,15680)?11:0}e=Kc(m,8,1,0,e);m=j[b+8>>2]+DQ(e,j[c>>2])|0;if(g){da=c,ea=j[Lc(c,n+484388|0)>>2],j[da>>2]=ea}$f(e,c,b);xc(b,m)}f=f+1|0;if((f|0)!=32){continue}break}}N:{if((A&B^-1|E)&1){break N}b=JO(d+120|0,0);c=j[b+20>>2];j[d+40>>2]=j[b+16>>2];j[d+44>>2]=c;c=j[b+12>>2];j[d+32>>2]=j[b+8>>2];j[d+36>>2]=c;c=j[b+4>>2];j[d+24>>2]=j[b>>2];j[d+28>>2]=c;Vr(d+160|0,a,0,d+24|0);_=o[j[d+160>>2]>>3];ll(d+160|0);if(_<600){break N}c=a+1074308|0;vb(c,5,1);b=IO(d+96|0,_);e=j[b+20>>2];j[d+16>>2]=j[b+16>>2];j[d+20>>2]=e;e=j[b+12>>2];j[d+8>>2]=j[b+8>>2];j[d+12>>2]=e;e=j[b+4>>2];j[d>>2]=j[b>>2];j[d+4>>2]=e;Vr(d+160|0,a,0,d);b=k[j[d+160>>2]+26|0];ll(d+160|0);if(b){rg(c,5);break N}j[u>>2]=15686}uBa(d+332|0,Rb(d+332|0),d+332|0);b=Db(d+80|0,15706);j[114630]=0;F(219,d+144|0,b|0);c=j[114630];j[114630]=0;if((c|0)==1){break k}c=Rb(d+332|0);j[114630]=0;c=K(884,d+48|0,d+332|0,c|0)|0;e=j[114630];j[114630]=0;if((e|0)==1){break j}j[114630]=0;I(13,d- -64|0,1,c|0);e=j[114630];j[114630]=0;if((e|0)==1){break i}j[114630]=0;I(247,d+160|0,d+144|0,d- -64|0);e=j[114630];j[114630]=0;if((e|0)==1){break h}ob(a+1304436|0,d+160|0);gb(d+160|0);gb(d- -64|0);gb(c);qb(d+144|0);gb(b);b=Db(d+160|0,15726);ob(a+1304448|0,b);gb(b);b=j[u>>2];if(b){vc(a+1304460|0,b)}j[a+1304496>>2]=2}f=Q>>>0<=U>>>0;break a}f=D()|0;C()|0;break e}f=D()|0;C()|0;break f}f=D()|0;C()|0;break g}f=D()|0;C()|0;gb(d- -64|0)}gb(c)}qb(d+144|0)}gb(b)}G(f|0);z()}Za=d+336|0;return f|0}function bMa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,n=0,o=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0;e=Za-176|0;Za=e;rc(b);a:{b:{c:{d:{e:{f:{g:{h:{if(!bT(b,e+128|0)){break h}if(!cT(e+128|0)){break h}if(!c){t=1;break h}od(a,2048);Zh(a);d=Db(e+96|0,12026);j[114630]=0;F(219,e+112|0,d|0);o=j[114630];j[114630]=0;if((o|0)==1){break c}j[114630]=0;r=e+128|3;I(383,e+80|0,e+112|0,r|0);o=j[114630];j[114630]=0;if((o|0)==1){break d}ob(a+1304436|0,e+80|0);gb(e+80|0);qb(e+112|0);gb(d);d=Db(e+80|0,12022);ob(a+1304448|0,d);gb(d);j[a+1304496>>2]=4;i[a+480188>>1]=k[e+168|0];i[a+480190>>1]=k[e+164|0];vg(e+112|0,2,e+128|4);qc(e+80|0,e+112|0);ob(a+1304400|0,e+80|0);gb(e+80|0);if(k[r|0]<=9){i[a+480188>>1]=4;cg(b,1);Qi(a,1)}d=k[r|0];i:{if(k[r|0]>=11){o=d>>>0>11?32:16;d=0;while(1){n=((d<<5)+a|0)+480284|0;g=Yz(b)<<1;g=(g|0)>-128?g:-128;j:{if((g|0)<129){d=g+128|0;break j}j[((d<<5)+a|0)+480280>>2]=256;d=128}i[n>>1]=d;f=f+1|0;d=f&65535;if(o>>>0>d>>>0){continue}break}break i}if((d|0)!=10){break i}aT(b,e+80|0);d=0;while(1){i[((d<<5)+a|0)+480284>>1]=h[(e+80|0)+d|0]&1?64:192;d=d+1|0;if((d|0)!=16){continue}break}}k:{if(k[r|0]>=13){wt(e+80|0,b);f=Pc(e+80|0);o=a;n=e+80|0;d=k[n|0];if(d>>>0<=31){h[n|0]=125;d=125}j[o+480204>>2]=p(d,1e4);j[a+480196>>2]=k[f|0];break k}j[a+480196>>2]=6;j[a+480204>>2]=125e4}o=a+484360|0;bg(Eb(o),k[e+165|0]);u=qn(e+112|0);w=j[b+8>>2];q=k[r|0];l:{if(k[r|0]<14){break l}d=k[e+165|0];j[114630]=0;F(384,u|0,d|0);d=j[114630];j[114630]=0;if((d|0)!=1){break l}b=D()|0;C()|0;break e}m:{n:{o:{p:{q:{r:{s:{t:{u:{if(k[e+165|0]){d=0;while(1){A=bc(Eb(o),d),B=d,i[A>>1]=B;if(k[r|0]>=14){j[114630]=0;f=H(357,b|0)|0;n=j[114630];j[114630]=0;if((n|0)==1){break u}A=bc(u,d),B=f,i[A>>1]=B}f=l[a+480188>>1];j[114630]=0;E(338,b|0,f<<1)|0;f=j[114630];j[114630]=0;if((f|0)==1){break u}d=d+1|0;if(d>>>0<k[e+165|0]){continue}break}}d=l[a+480190>>1];j[114630]=0;j[e+80>>2]=0;v=K(385,e- -64|0,d|0,e+80|0)|0;d=j[114630];j[114630]=0;f=1;if((d|0)!=1){j[e+60>>2]=0;v:{if(l[a+480190>>1]){o=1;while(1){j[114630]=0;n=p(f,104)+a|0;g=n+484380|0;F(386,g|0,0);d=j[114630];j[114630]=0;if((d|0)==1){break v}j[114630]=0;s=H(387,b|0)|0;d=j[114630];j[114630]=0;if((d|0)==1){break g}j[114630]=0;K(388,b|0,((f<<5)+a|0)+946300|0,32)|0;d=j[114630];j[114630]=0;if((d|0)==1){break g}j[114630]=0;K(389,b|0,n+484423|0,13)|0;d=j[114630];j[114630]=0;if((d|0)==1){break g}j[114630]=0;d=H(390,b|0)|0;t=j[114630];j[114630]=0;if((t|0)==1){break g}t=f-1|0;A=xb(v,t),B=d,j[A>>2]=B;w:{if(k[r|0]<=9){j[114630]=0;f=H(357,b|0)|0;d=j[114630];j[114630]=0;if((d|0)!=1){break w}break g}j[114630]=0;f=H(390,b|0)|0;d=j[114630];j[114630]=0;if((d|0)==1){break g}}j[g>>2]=f;j[114630]=0;d=H(357,b|0)|0;f=j[114630];j[114630]=0;if((f|0)==1){break g}j[n+484404>>2]=d;j[114630]=0;d=H(387,b|0)|0;f=j[114630];j[114630]=0;x:{y:{z:{if((f|0)!=1){j[114630]=0;h[e+80|0]=d;h[e+48|0]=64;d=E(391,e+80|0,e+48|0)|0;f=j[114630];j[114630]=0;if((f|0)==1){break z}i[n+484410>>1]=k[d|0]<<2;if(k[r|0]>9){break y}j[114630]=0;d=H(357,b|0)|0;f=j[114630];j[114630]=0;if((f|0)==1){break g}j[n+484384>>2]=d;j[114630]=0;d=H(357,b|0)|0;break x}b=D()|0;C()|0;break f}b=D()|0;C()|0;break f}j[114630]=0;d=H(390,b|0)|0;f=j[114630];j[114630]=0;if((f|0)==1){break g}j[n+484384>>2]=d;j[114630]=0;d=H(390,b|0)|0}f=j[114630];j[114630]=0;if((f|0)==1){break g}f=n+484388|0;j[f>>2]=d;if(s){s=n+484384|0;A:{if(!(d>>>0<=j[s>>2]+2>>>0|d>>>0>m[g>>2])){d=n+484414|0;i[d>>1]=l[d>>1]|2;break A}j[f>>2]=0;j[s>>2]=0}d=xb(v,t);j[114630]=0;d=E(392,e+60|0,d|0)|0;f=j[114630];j[114630]=0;if((f|0)==1){break g}j[e+60>>2]=j[d>>2]}o=o+1|0;f=o&65535;if(f>>>0<=l[a+480190>>1]){continue}break}}n=vt(e+48|0);d=k[e+166|0]|k[e+167|0]<<8;j[114630]=0;t=K(393,b|0,n|0,d|0)|0;d=j[114630];j[114630]=0;if((d|0)==1){break t}if(!t){break m}o=0;B:{if(!Xc(n)){d=Lb(n);o=Mb(n);j[114630]=0;d=E(394,d|0,o|0)|0;o=j[114630];j[114630]=0;if((o|0)==1){break B}j[e+80>>2]=d;d=j[e+80>>2];o=k[d|0]|k[d+1|0]<<8}j[114630]=0;f=o;s=E(395,e+32|0,f|0)|0;d=j[114630];j[114630]=0;if((d|0)!=1){C:{if(f){d=0;while(1){j[114630]=0;E(396,b|0,e+24|0)|0;g=j[114630];j[114630]=0;if((g|0)==1){break s}j[114630]=0;I(341,e+80|0,b|0,p(k[e+24|0]|k[e+25|0]<<8|k[e+26|0]<<16,3)|0);g=j[114630];j[114630]=0;if((g|0)==1){break C}Ed($b(s,d),e+80|0);jb(e+80|0);d=d+1|0;if((f|0)!=(d|0)){continue}break}}if(c&2){x=Kc(e+24|0,8,1,0,1);j[114630]=0;g=E(397,e+80|0,v|0)|0;d=j[114630];j[114630]=0;if((d|0)==1){break q}d=Lb(g);f=Mb(g);j[114630]=0;F(398,d|0,f|0);d=j[114630];j[114630]=0;if((d|0)==1){break r}d=Lb(g);f=Mb(g);j[114630]=0;d=E(399,d|0,f|0)|0;f=j[114630];j[114630]=0;if((f|0)==1){break r}j[e+16>>2]=d;A=e,B=Lb(g),j[A+8>>2]=B;D:{if(!rb(e+8|0,e+16|0)){break D}while(1){j[114630]=0;d=E(258,b|0,1)|0;f=j[114630];j[114630]=0;E:{if((f|0)!=1){if(!d){break D}d=0;if(!l[a+480190>>1]){break E}while(1){j[114630]=0;f=E(258,b|0,1)|0;y=j[114630];j[114630]=0;if((y|0)==1){break r}if(!f){break E}f=d+1|0;if(j[j[e+8>>2]>>2]!=j[xb(v,d)>>2]){d=f;if(d>>>0>=l[a+480190>>1]){break E}continue}break}j[114630]=0;K(400,x|0,(p(f,104)+a|0)+484380|0,b|0)|0;d=j[114630];j[114630]=0;if((d|0)!=1){break E}break r}break r}XS(e+8|0);if(rb(e+8|0,e+16|0)){continue}break}}Ud(g)}if(!(c&1)){break n}c=k[e+165|0];j[114630]=0;g=a+484344|0;F(401,g|0,c|0);c=j[114630];j[114630]=0;F:{if((c|0)!=1){if(!k[e+165|0]){break n}w=w+((q>>>0>13)<<1)|0;c=0;while(1){G:{f=64;if(Yb(u)>>>0>c>>>0){f=l[bc(u,c)>>1]}j[114630]=0;d=K(402,g|0,c&65535,f&65535)|0;f=j[114630];j[114630]=0;if((f|0)==1){break F}H:{if(d){d=l[a+480188>>1];f=k[r|0];j[114630]=0;E(256,b|0,w+p(((f>>>0>13)<<1)+(d<<1)|0,c)|0)|0;d=j[114630];j[114630]=0;if((d|0)==1){break F}f=vt(e+80|0);d=l[a+480188>>1];j[114630]=0;d=K(393,b|0,f|0,d|0)|0;q=j[114630];j[114630]=0;if((q|0)==1){break H}I:{if(!d){break I}d=0;if(!l[a+480188>>1]){break I}while(1){J:{q=bc(f,d);if(!(k[q|0]|k[q+1|0]<<8)){break J}q=bc(f,d);if((k[q|0]|k[q+1|0]<<8)>>>0>(k[e+166|0]|k[e+167|0]<<8)>>>0){break J}q=bc(f,d);q=bc(n,(k[q|0]|k[q+1|0]<<8)-1|0);q=(k[q|0]|k[q+1|0]<<8)-1&65535;if(q>>>0>=o>>>0){break J}x=Hb(g,c);q=$b(s,q);j[114630]=0;I(403,x|0,d&65535,q|0);q=j[114630];j[114630]=0;if((q|0)!=1){break J}break G}d=d+1|0;if(d>>>0<l[a+480188>>1]){continue}break}}kk(f)}c=c+1|0;if(c>>>0>=k[e+165|0]){break n}continue}}break}b=D()|0;C()|0;kk(f);break p}b=D()|0;C()|0;break p}b=D()|0;C()|0;break p}b=D()|0;C()|0;break p}b=D()|0;C()|0;break o}b=D()|0;C()|0;break o}b=D()|0;C()|0;break f}b=D()|0;C()|0;break e}b=D()|0;C()|0;break e}b=D()|0;C()|0;break o}b=D()|0;C()|0;break p}b=D()|0;C()|0;Ud(g);break p}b=D()|0;C()|0}Sc(s)}kk(n);break f}Sc(s)}kk(n);Ud(v);ff(u)}Za=e+176|0;return t|0}b=D()|0;C()|0}Ud(v)}ff(u);break a}b=D()|0;C()|0;qb(e+112|0);break b}b=D()|0;C()|0}gb(d)}G(b|0);z()}function Yya(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0;d=Za-272|0;Za=d;rc(b);e=d+120|0;g=sya(b,e);if(!g){vN(e)}a:{b:{c:{d:{e:{if(!g){break e}if(!GN(d+120|0)){break e}if(!c){n=1;break e}od(a,4194304);e=Db(d+40|0,16870);ob(a+1304436|0,e);gb(e);e=Db(d+40|0,16866);ob(a+1304448|0,e);gb(e);j[a+1304496>>2]=4;s=a,t=kd(k[d+198|0]|k[d+199|0]<<8,k[d+200|0]|k[d+201|0]<<8,127),i[s+480188>>1]=t;e=k[d+189|0];j[a+480228>>2]=(e|0)==255?48:e;j[a+480196>>2]=k[d+187|0];j[a+480204>>2]=p(k[d+188|0],1e4);Ge(d+104|0,d+120|4,59,3);qc(d+40|0,d+104|0);ob(a+1304400|0,d+40|0);gb(d+40|0);f:{if((k[d+202|0]|k[d+203|0]<<8|(k[d+204|0]<<16|k[d+205|0]<<24))>>>0<5){break f}if(!xc(b,(k[d+202|0]|k[d+203|0]<<8|(k[d+204|0]<<16|k[d+205|0]<<24))-4|0)){break f}if(!vh(b,16904)){break f}mp(Eb(a+484360|0),b,k[d+192|0]|k[d+193|0]<<8,65535,65535)}g:{if((k[d+206|0]|k[d+207|0]<<8|(k[d+208|0]<<16|k[d+209|0]<<24))>>>0<5){break g}if(!xc(b,(k[d+206|0]|k[d+207|0]<<8|(k[d+208|0]<<16|k[d+209|0]<<24))-4|0)){break g}if(!vh(b,16909)){break g}while(1){e=(n<<5)+a|0;wg(e+480280|0);s=e+480284|0,t=((((dd(b)^-1)&15)<<8|8)>>>0)/15|0,i[s>>1]=t;n=n+1|0;if((n|0)!=32){continue}break}}h:{if((k[d+214|0]|k[d+215|0]<<8|(k[d+216|0]<<16|k[d+217|0]<<24))>>>0<5){break h}if(!xc(b,(k[d+214|0]|k[d+215|0]<<8|(k[d+216|0]<<16|k[d+217|0]<<24))-4|0)){break h}if(!vh(b,16914)){break h}cd(d+104|0,b,(k[d+196|0]|k[d+197|0]<<8)<<6);i:{if(!(k[d+196|0]|k[d+197|0]<<8)){break i}n=c&2;g=a+480190|0;q=d+53|0;while(1){j[114630]=0;e=E(975,d+104|0,d+40|0)|0;o=j[114630];j[114630]=0;if((o|0)==1){break d}if(!e){break i}e=k[d+85|0]|k[d+86|0]<<8;i[d+38>>1]=e;j:{if((e-1&65535)>>>0>3998){break j}if(ke((p(e,104)+a|0)+484380|0)){break j}j[114630]=0;e=E(452,g|0,d+38|0)|0;o=j[114630];j[114630]=0;if((o|0)==1){break c}i[a+480190>>1]=l[e>>1];j[114630]=0;F(976,d+40|0,(p(l[d+38>>1],104)+a|0)+484380|0);e=j[114630];j[114630]=0;if((e|0)==1){break c}j[114630]=0;I(977,d+8|0,1,q|0);e=j[114630];j[114630]=0;k:{l:{if((e|0)==1){break l}j[114630]=0;F(415,d+24|0,d+8|0);e=j[114630];j[114630]=0;if((e|0)==1){break l}j[114630]=0;E(369,((l[d+38>>1]<<5)+a|0)+946300|0,d+24|0)|0;e=j[114630];j[114630]=0;if((e|0)==1){break k}gb(d+24|0);if(!n){break j}e=k[d+77|0]|k[d+78|0]<<8|(k[d+79|0]<<16|k[d+80|0]<<24);j[114630]=0;E(256,b|0,e|0)|0;e=j[114630];j[114630]=0;if((e|0)==1){break c}j[114630]=0;F(978,d+24|0,d+40|0);e=j[114630];j[114630]=0;if((e|0)!=1){j[114630]=0;K(400,d+24|0,(p(l[d+38>>1],104)+a|0)+484380|0,b|0)|0;e=j[114630];j[114630]=0;if((e|0)!=1){break j}}b=D()|0;C()|0;break b}b=D()|0;C()|0;break b}b=D()|0;C()|0;gb(d+24|0);break b}m=m+1|0;if((m&65535)>>>0<(k[d+196|0]|k[d+197|0]<<8)>>>0){continue}break}}jb(d+104|0)}n=1;if(!(c&1)){break e}m:{if((k[d+210|0]|k[d+211|0]<<8|(k[d+212|0]<<16|k[d+213|0]<<24))>>>0<5){break m}if(!xc(b,(k[d+210|0]|k[d+211|0]<<8|(k[d+212|0]<<16|k[d+213|0]<<24))-4|0)){break m}if(!vh(b,16919)){break m}o=a+484344|0;Jf(o,k[d+194|0]|k[d+195|0]<<8);if(!(k[d+194|0]|k[d+195|0]<<8)){break m}q=d+24|2;g=0;while(1){if(!Us(b,d+24|0)){break m}if((k[d+24|0]|k[d+25|0]<<8)>>>0>3){cd(d+40|0,b,((k[d+24|0]|k[d+25|0]<<8)+15&131056)-4|0);c=k[q|0];j[114630]=0;c=K(402,o|0,g&65535,c|0)|0;e=j[114630];j[114630]=0;n:{if((e|0)!=1){o:{m=0;if(!c){break n}while(1){j[114630]=0;c=E(258,d+40|0,1)|0;e=j[114630];j[114630]=0;p:{q:{r:{if((e|0)!=1){if(!c|k[q|0]<=m>>>0){break q}j[114630]=0;e=H(387,d+40|0)|0;c=j[114630];j[114630]=0;if((c|0)==1){break o}if(e){break r}m=m+1|0;continue}break o}c=Hb(o,g);i[d+104>>1]=e&31;f=l[a+480188>>1];j[114630]=0;i[d+8>>1]=f-1;f=E(477,d+104|0,d+8|0)|0;r=j[114630];j[114630]=0;if((r|0)==1){break o}f=l[f>>1];j[114630]=0;c=K(471,c|0,m|0,f|0)|0;f=j[114630];j[114630]=0;if((f|0)==1){break o}if(e&128){j[114630]=0;F(472,d+104|0,d+40|0);f=j[114630];j[114630]=0;if((f|0)==1){break o}f=Pc(d+104|0);h[c|0]=k[d+104|0]+36;h[c+1|0]=k[f|0]}if(!(e&64)){break p}h[c+2|0]=1;j[114630]=0;f=H(387,d+40|0)|0;r=j[114630];j[114630]=0;s:{if((r|0)!=1){j[114630]=0;h[d+104|0]=f;h[d+8|0]=64;f=E(391,d+104|0,d+8|0)|0;r=j[114630];j[114630]=0;if((r|0)==1){break s}h[c+4|0]=k[f|0];break p}break o}break o}if(k[q|0]==64){break n}c=Hb(o,g);j[114630]=0;e=K(497,d+104|0,14,0)|0;m=j[114630];j[114630]=0;if((m|0)!=1){e=qi(Ee(e,k[q|0]-1|0));j[114630]=0;E(498,c|0,e|0)|0;c=j[114630];j[114630]=0;if((c|0)!=1){break n}}break o}if(!(e&32)){continue}j[114630]=0;F(472,d+104|0,d+40|0);e=j[114630];j[114630]=0;t:{u:{v:{w:{x:{y:{z:{A:{B:{C:{D:{E:{F:{G:{H:{I:{J:{K:{L:{M:{N:{O:{P:{Q:{R:{S:{T:{U:{V:{W:{X:{Y:{if((e|0)!=1){e=k[Pc(d+104|0)|0];h[c+5|0]=e;switch(k[d+104|0]-1|0){case 71:break u;case 70:break v;case 69:break w;case 60:break x;case 59:break y;case 52:break z;case 51:break A;case 50:break B;case 49:break C;case 42:break D;case 41:break E;case 40:break F;case 39:break G;case 30:break H;case 29:break I;case 22:break J;case 21:break K;case 20:break L;case 19:break M;case 16:break N;case 15:break O;case 14:break P;case 13:break Q;case 12:break R;case 11:break S;case 10:break T;case 9:break U;case 3:break V;case 2:break W;case 1:break X;case 0:break Y;default:break t}}break o}h[c+3|0]=11;h[c+5|0]=e<<4|15;continue}h[c+3|0]=11;h[c+5|0]=e<<4;continue}h[c+3|0]=11;h[c+5|0]=e|240;continue}h[c+3|0]=11;h[c+5|0]=e&15;continue}h[c+3|0]=2;h[c+5|0]=e|240;continue}h[c+3|0]=2;continue}h[c+3|0]=3;h[c+5|0]=e|240;continue}h[c+3|0]=3;continue}h[c+3|0]=4;continue}h[c+3|0]=20;h[c+5|0]=e|16;continue}h[c+3|0]=6;h[c+5|0]=e<<4;continue}h[c+3|0]=6;h[c+5|0]=e&15;continue}h[c+3|0]=5;continue}h[c+3|0]=20;h[c+5|0]=e|48;continue}h[c+3|0]=7;h[c+5|0]=e<<4;continue}h[c+3|0]=7;h[c+5|0]=e&15;continue}h[c+3|0]=8;continue}h[c+3|0]=20;h[c+5|0]=e|64;continue}h[c+3|0]=10;j[114630]=0;e=H(387,d+40|0)|0;f=j[114630];j[114630]=0;if((f|0)!=1){h[c+5|0]=e;j[114630]=0;E(338,d+40|0,1)|0;c=j[114630];j[114630]=0;if((c|0)!=1){continue}}break o}h[c+3|0]=15;h[c+5|0]=e&15;continue}h[c+3|0]=20;h[c+5|0]=e|192;continue}h[c+3|0]=20;h[c+5|0]=e|208;continue}h[c+3|0]=12;continue}h[c+3|0]=14;continue}h[c+3|0]=20;h[c+5|0]=e|176;continue}h[c+3|0]=20;h[c+5|0]=e|224;continue}h[c+3|0]=16;continue}h[c+3|0]=17;continue}h[c+3|0]=1;continue}h[c+3|0]=20;h[c+5|0]=e&15|32;continue}h[c+3|0]=20;h[c+5|0]=e&15|128;continue}h[c+3|0]=0;continue}}}b=D()|0;C()|0;jb(d+40|0);break a}jb(d+40|0)}g=g+1|0;if(g>>>0<(k[d+194|0]|k[d+195|0]<<8)>>>0){continue}break}}if(!(k[d+218|0]|k[d+219|0]<<8|(k[d+220|0]<<16|k[d+221|0]<<24))){break e}xc(b,k[d+218|0]|k[d+219|0]<<8|(k[d+220|0]<<16|k[d+221|0]<<24));Rx(a+1304424|0,b,Of(b),4)}Za=d+272|0;return n|0}b=D()|0;C()|0;break b}b=D()|0;C()|0}jb(d+104|0)}G(b|0);z()}function O$(a,b,c,d,e,f,g,i,l,m,n){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;i=i|0;l=l|0;m=m|0;n=n|0;var o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0;o=Za-560|0;Za=o;j[o+548>>2]=n;j[o+552>>2]=b;j[o+96>>2]=2483;s=yd(o+136|0,o+144|0,o+96|0);b=j[s>>2];j[o+132>>2]=b;j[o+128>>2]=b+400;u=Cb(o+96|0);r=Le(o+80|0);p=Le(o- -64|0);q=Le(o+48|0);t=Le(o+32|0);j[114630]=0;ba(2495,c|0,d|0,o+120|0,o+116|0,o+112|0,u|0,r|0,p|0,q|0,o+28|0);b=j[114630];j[114630]=0;if((b|0)!=1){a:{j[m>>2]=j[l>>2];v=e&512;w=v>>>9|0;n=0;e=0;while(1){b=e;b:{c:{d:{e:{if((n|0)==4){break e}j[114630]=0;c=E(2455,a|0,o+552|0)|0;d=j[114630];j[114630]=0;if((d|0)==1){break a}if(!c){break e}c=0;f:{g:{h:{i:{j:{switch(h[(o+120|0)+n|0]){case 1:if((n|0)==3){break c}j[114630]=0;c=H(2457,a|0)|0;d=j[114630];j[114630]=0;if((d|0)==1){break a}j[114630]=0;c=K(2496,i|0,8192,c|0)|0;d=j[114630];j[114630]=0;if((d|0)==1){break a}if(c){j[114630]=0;I(2497,o+16|0,a|0,0);c=j[114630];j[114630]=0;if((c|0)!=1){c=j[o+16>>2];j[114630]=0;F(112,t|0,c|0);c=j[114630];j[114630]=0;if((c|0)!=1){break i}}break a}j[f>>2]=j[f>>2]|4;a=0;break d;case 3:break h;case 0:break j;case 4:break f;case 2:break g;default:break b}}if((n|0)==3){break c}}while(1){j[114630]=0;c=E(2455,a|0,o+552|0)|0;d=j[114630];j[114630]=0;if((d|0)==1){break a}if(!c){break c}j[114630]=0;c=H(2457,a|0)|0;d=j[114630];j[114630]=0;if((d|0)==1){break a}j[114630]=0;c=K(2496,i|0,8192,c|0)|0;d=j[114630];j[114630]=0;if((d|0)==1){break a}if(!c){break c}j[114630]=0;I(2497,o+16|0,a|0,0);c=j[114630];j[114630]=0;if((c|0)!=1){c=j[o+16>>2];j[114630]=0;F(112,t|0,c|0);c=j[114630];j[114630]=0;if((c|0)!=1){continue}}break}break a}if((nb(p)|0)==(0-nb(q)|0)){break c}k:{if(nb(p)){if(nb(q)){break k}}if(nb(p)){j[114630]=0;c=H(2457,a|0)|0;d=j[114630];j[114630]=0;if((d|0)==1){break a}if((c|0)==j[zb(p)>>2]){j[114630]=0;H(2459,a|0)|0;c=j[114630];j[114630]=0;if((c|0)==1){break a}e=nb(p)>>>0>1?p:b;break b}h[g|0]=1;break c}j[114630]=0;c=H(2457,a|0)|0;d=j[114630];j[114630]=0;if((d|0)==1){break a}if((c|0)!=j[zb(q)>>2]){break c}j[114630]=0;H(2459,a|0)|0;c=j[114630];j[114630]=0;if((c|0)==1){break a}h[g|0]=1;e=nb(q)>>>0>1?q:b;break b}j[114630]=0;c=H(2457,a|0)|0;d=j[114630];j[114630]=0;if((d|0)==1){break a}if((c|0)==j[zb(p)>>2]){j[114630]=0;H(2459,a|0)|0;c=j[114630];j[114630]=0;if((c|0)==1){break a}e=nb(p)>>>0>1?p:b;break b}j[114630]=0;c=H(2457,a|0)|0;d=j[114630];j[114630]=0;if((d|0)==1){break a}if((c|0)==j[zb(q)>>2]){j[114630]=0;H(2459,a|0)|0;c=j[114630];j[114630]=0;if((c|0)==1){break a}h[g|0]=1;e=nb(q)>>>0>1?q:b;break b}j[f>>2]=j[f>>2]|4;a=0;break d}if(!(b|n>>>0<2)){e=0;if(!((n|0)==2&k[o+123|0]!=0|w)){break b}}y=o,A=nd(r),j[y+8>>2]=A;c=Cd(o+16|0,o+8|0);l:{if(!n|k[(n+o|0)+119|0]>1){break l}m:{while(1){y=o,A=tj(r),j[y+8>>2]=A;if(!rb(c,o+8|0)){break m}d=j[j[c>>2]>>2];j[114630]=0;d=K(2496,i|0,8192,d|0)|0;e=j[114630];j[114630]=0;if((e|0)!=1){if(!d){break m}Id(c);continue}break}break a}y=o,A=nd(r),j[y+8>>2]=A;c=Ks(c,o+8|0);if(nb(t)>>>0>=c>>>0){y=o,A=tj(t),j[y+8>>2]=A;c=xM(o+8|0,c);d=tj(t);e=nd(r);j[114630]=0;c=LC(c,d,e);d=j[114630];j[114630]=0;if((d|0)==1){break a}if(c){break l}}y=o,A=nd(r),j[y>>2]=A;Cd(o+8|0,o);j[o+16>>2]=j[o+8>>2]}j[o+8>>2]=j[o+16>>2];n:{while(1){y=o,A=tj(r),j[y>>2]=A;if(!rb(o+8|0,o)){break n}j[114630]=0;c=E(2455,a|0,o+552|0)|0;d=j[114630];j[114630]=0;o:{if((d|0)==1){break o}if(!c){break n}j[114630]=0;c=H(2457,a|0)|0;d=j[114630];j[114630]=0;if((d|0)==1){break o}if((c|0)!=j[j[o+8>>2]>>2]){break n}j[114630]=0;H(2459,a|0)|0;c=j[114630];j[114630]=0;if((c|0)==1){break a}Id(o+8|0);continue}break}break a}if(!v){break c}y=o,A=tj(r),j[y>>2]=A;if(!rb(o+8|0,o)){break c}j[f>>2]=j[f>>2]|4;a=0;break d}p:{while(1){q:{j[114630]=0;d=E(2455,a|0,o+552|0)|0;e=j[114630];j[114630]=0;if((e|0)==1){break q}if(!d){break p}j[114630]=0;e=H(2457,a|0)|0;d=j[114630];j[114630]=0;if((d|0)==1){break a}j[114630]=0;d=K(2496,i|0,2048,e|0)|0;x=j[114630];j[114630]=0;if((x|0)==1){break a}r:{if(d){d=j[m>>2];if((d|0)==j[o+548>>2]){j[114630]=0;I(2499,l|0,m|0,o+548|0);d=j[114630];j[114630]=0;if((d|0)==1){break a}d=j[m>>2]}j[m>>2]=d+4;j[d>>2]=e;c=c+1|0;break r}if(!c|!nb(u)|(e|0)!=j[o+112>>2]){break p}e=j[o+132>>2];if((e|0)==j[o+128>>2]){j[114630]=0;I(2490,s|0,o+132|0,o+128|0);d=j[114630];j[114630]=0;if((d|0)==1){break a}e=j[o+132>>2]}j[o+132>>2]=e+4;j[e>>2]=c;c=0}j[114630]=0;H(2459,a|0)|0;d=j[114630];j[114630]=0;if((d|0)!=1){continue}}break}break a}d=j[s>>2];s:{if(!c){break s}e=j[o+132>>2];if((d|0)==(e|0)){break s}if(j[o+128>>2]==(e|0)){j[114630]=0;I(2490,s|0,o+132|0,o+128|0);d=j[114630];j[114630]=0;if((d|0)==1){break a}e=j[o+132>>2]}j[o+132>>2]=e+4;j[e>>2]=c}t:{if(j[o+28>>2]<1){break t}j[114630]=0;c=E(2456,a|0,o+552|0)|0;d=j[114630];j[114630]=0;if((d|0)==1){break a}u:{if(!c){j[114630]=0;c=H(2457,a|0)|0;d=j[114630];j[114630]=0;if((d|0)==1){break a}if((c|0)==j[o+116>>2]){break u}}j[f>>2]=j[f>>2]|4;a=0;break d}j[114630]=0;H(2459,a|0)|0;c=j[114630];j[114630]=0;if((c|0)==1){break a}while(1){if(j[o+28>>2]<1){break t}j[114630]=0;c=E(2456,a|0,o+552|0)|0;d=j[114630];j[114630]=0;v:{if((d|0)==1){break v}w:{if(!c){j[114630]=0;c=H(2457,a|0)|0;d=j[114630];j[114630]=0;if((d|0)==1){break v}j[114630]=0;c=K(2496,i|0,2048,c|0)|0;d=j[114630];j[114630]=0;if((d|0)==1){break v}if(c){break w}}j[f>>2]=j[f>>2]|4;a=0;break d}if(j[m>>2]==j[o+548>>2]){j[114630]=0;I(2499,l|0,m|0,o+548|0);c=j[114630];j[114630]=0;if((c|0)==1){break v}}j[114630]=0;c=H(2457,a|0)|0;d=j[114630];j[114630]=0;if((d|0)==1){break v}d=j[m>>2];j[m>>2]=d+4;j[d>>2]=c;j[114630]=0;j[o+28>>2]=j[o+28>>2]-1;H(2459,a|0)|0;c=j[114630];j[114630]=0;if((c|0)!=1){continue}}break}break a}e=b;if(j[l>>2]!=j[m>>2]){break b}j[f>>2]=j[f>>2]|4;a=0;break d}x:{if(!b){break x}e=1;while(1){if(nb(b)>>>0<=e>>>0){break x}j[114630]=0;c=E(2456,a|0,o+552|0)|0;d=j[114630];j[114630]=0;y:{if((d|0)==1){break y}z:{if(!c){j[114630]=0;c=H(2457,a|0)|0;d=j[114630];j[114630]=0;if((d|0)==1){break y}if((c|0)==j[Ni(b,e)>>2]){break z}}j[f>>2]=j[f>>2]|4;a=0;break d}j[114630]=0;H(2459,a|0)|0;c=j[114630];j[114630]=0;e=e+1|0;if((c|0)!=1){continue}}break}break a}A:{if(j[s>>2]==j[o+132>>2]){break A}j[o+16>>2]=0;a=j[s>>2];j[114630]=0;le(u,a,j[o+132>>2],o+16|0);a=j[114630];j[114630]=0;if((a|0)!=1){if(!j[o+16>>2]){break A}j[f>>2]=j[f>>2]|4;a=0;break d}break a}a=1}pc(t);pc(q);pc(p);pc(r);gb(u);mc(s);Za=o+560|0;return a|0}e=b}n=n+1|0;continue}}}a=D()|0;C()|0;pc(t);pc(q);pc(p);pc(r);gb(u);mc(s);G(a|0);z()}function Sr(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;var n=0,o=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;n=Za-32|0;Za=n;j[n+28>>2]=c;a:{if((c|0)<1){break a}r=j[b+104>>2];o=j[b+656>>2];if(!(!o|j[a+480180>>2]!=16777216)){u=j[o+44>>2]!=0}b:{if(!(!o|(c|0)>128)){q=l[Nc(o+236|0,c-1|0)>>1];c:{if((q-1&65535)>>>0<=3998){r=(p(q,104)+a|0)+484380|0;break c}mb(n+16|0,a+1074308|0,43);if(!kb(n+16|0)){break c}if(!Si(b)){break a}}q=k[Pb(o+108|0,j[n+28>>2]-1|0)|0];j[n+28>>2]=q;break b}q=c}if((q|0)>=121){d:{if(!(j[a+480180>>2]&16777248?(q|0)!=255:0)){Fm(a,b);if(d){break d}mb(n+16|0,a+1074308|0,100);if(!kb(n+16|0)|!(k[a+480208|0]&4)|!k[b+811|0]){break d}j[b+88>>2]=j[b+88>>2]&-6145;break d}if(!l[a+480192>>1]){break d}j[b+88>>2]=j[b+88>>2]|4096}e:{if(j[n+28>>2]!=254){break e}f:{c=j[b+88>>2];if(!(c&512)){break f}c=j[b+88>>2];if(j[a+480180>>2]!=2){break f}j[b+88>>2]=c|2048;break e}j[b+88>>2]=c|2101248;g:{if(j[a+480180>>2]&16777248){if(!l[a+480192>>1]){break g}mb(n+16|0,a+1074308|0,50);if(kb(n+16|0)){break g}}j[b+688>>2]=0}mb(n+16|0,a+1074308|0,50);if(kb(n+16|0)){j[b+8>>2]=0;j[b+12>>2]=0}j[b+696>>2]=0}mb(n+16|0,a+1074308|0,20);if(!kb(n+16|0)){break a}h[b+819|0]=0;h[b+824|0]=0;break a}h:{i:{j:{if(u){if(d){s=k[b+819|0];if(s){break j}}j[b+708>>2]=0}if(d){break i}if(!(!r|!(j[a+480180>>2]&1048588))){j[b+772>>2]=h[r+36|0];j[b+768>>2]=h[r+37|0]}if(r){mb(n+16|0,a+1074308|0,24);q=0;t=1;if(!kb(n+16|0)){break h}j[b+704>>2]=j[r+24>>2];break h}q=0;break h}t=j[o+44>>2];i[n>>1]=s;i[n+14>>1]=q;j[n+16>>2]=0;q=(j[n+16>>2]+p(i[t+36>>1]+1|0,i[n+14>>1]-i[n>>1]|0)|0)-j[b+876>>2]|0;j[b+708>>2]=q;j[b+876>>2]=0-q}t=(r|0)!=0;q=1;if(oh(b)){break h}q=a+1074308|0;mb(n+16|0,q,54);if(kb(n+16|0)){j[b+700>>2]=0;break a}mb(n+16|0,q,39);q=(kb(n+16|0)^-1)&d}k:{if(kp(a)){j[n+28>>2]=j[n+28>>2]+j[b+772>>2];Md(n+28|0,12,131);break k}rO(n+28|0)}s=a+1074308|0;mb(n+16|0,s,34);d=b;l:{if(kb(n+16|0)){c=pp(c);break l}c=j[n+28>>2]}h[d+819|0]=c;h[b+872|0]=k[b+872|0]|8;if(!(j[a+480180>>2]&16777250?0:q)){h[b+825|0]=0}d=Zf(a,j[n+28>>2],j[b+768>>2],j[b+704>>2]);h[b+851|0]=0;mb(n+16|0,s,48);if(kb(n+16|0)){KK(a,b,o,r)}m:{if(e^1|q){break m}j[b+788>>2]=0;j[b+792>>2]=0;if(!o){break m}mb(n+16|0,s,29);if(kb(n+16|0)){h[b+820|0]=k[o+16|0]}if(!(k[o+60|0]&8)){_h(b+724|0)}if(!(k[o+80|0]&8)){_h(b+736|0)}if(!(k[o+100|0]&8)){_h(b+748|0)}if(k[o+20|0]){c=Qr(Em(a));v=k[o+20|0];mb(n+16|0,s,28);w=((p(c,v)<<16>>16)/64<<16)+65536>>16;c=b;n:{if(kb(n+16|0)){v=j[b+764>>2];break n}v=(j[b+688>>2]+1|0)/2|0}i[c+788>>1]=(p(v,w)|0)/199}o:{if(!k[o+19|0]){break o}x=b,y=(p(Qr(Em(a)),k[o+19|0])<<16>>16)/32|0,i[x+790>>1]=y;mb(n+16|0,s,28);if(kb(n+16|0)|l[b+796>>1]){break o}i[b+796>>1]=l[b+692>>1]+1}c=k[o+23|0];if(c){v=Qr(Em(a));w=k[b+857|0];h[b+818|0]=w+1;i[b+792>>1]=(p(w,(p(c,v+1|0)<<16>>16)/128<<16>>16)+1|0)/128}c=k[o+24|0];if(!c){break m}v=Qr(Em(a));w=k[b+858|0];h[b+817|0]=w+1;i[b+794>>1]=(p(w,(p(c,v+1|0)<<16>>16)/128<<16>>16)+1|0)/128}if(!t){break a}t=0;p:{q:{if(!d){break q}r:{s:{t:{if(q){u:{if(!j[b+700>>2]){j[b+700>>2]=d;if(!u){break u}break t}if(u){break t}}j[b+708>>2]=d;break t}j[b+700>>2]=d;if(u){break s}mb(n+16|0,s,69);if(kb(n+16|0)){break s}mb(n,s,46);if(kb(n)|j[a+480180>>2]==1){break s}j[b+708>>2]=d;break s}if(j[b+76>>2]|j[a+480180>>2]&2){break r}}j[b+104>>2]=r;c=j[r>>2];j[b+84>>2]=c;j[b+76>>2]=c;j[b+80>>2]=0;j[b>>2]=0;j[b+4>>2]=0;v:{w:{if(!(j[a+480208>>2]&2097152)){mb(n+16|0,s,96);if(!kb(n+16|0)){break w}}if(k[b+811|0]){break w}j[n+16>>2]=j[b+76>>2]-1;x=b,y=j[tb(b+660|0,n+16|0)>>2],j[x+4>>2]=y;break v}j[b+660>>2]=0}c=l[r+34>>1];d=c&1023;u=d|j[b+88>>2]&-525056;j[b+88>>2]=u;x:{if(c&8){j[b+80>>2]=j[r+12>>2];c=j[r+16>>2];j[b+88>>2]=(d&16?u|4:u&-524295)|2;j[b+84>>2]=c;if(c>>>0>=m[b+76>>2]){break x}j[b+76>>2]=c;break x}if(!(d&2)){break x}j[b+80>>2]=j[r+4>>2];c=j[r+8>>2];j[b+84>>2]=c;if(c>>>0>=m[b+76>>2]){break x}j[b+76>>2]=c}mb(n+16|0,s,83);if(!(!kb(n+16|0)|j[b+80>>2])){c=j[r>>2];j[b+84>>2]=c;j[b+76>>2]=c}c=j[b+88>>2];if(c&128){j[b+88>>2]=c|128;j[b+4>>2]=j[b+76>>2]-1}y:{if(k[b+842|0]>3){break y}mb(n+16|0,s,21);if(!(kb(n+16|0)|!(j[a+480180>>2]&16777248)|j[a+480208>>2]&4)){h[b+839|0]=16;break y}if(j[a+480180>>2]==16){h[b+839|0]=32;break y}if(j[a+480180>>2]&67633152){break y}h[b+839|0]=0}mb(n+16|0,s,21);if(kb(n+16|0)|k[b+845|0]>3){break r}h[b+840|0]=0}d=j[b>>2];if(m[b+76>>2]<=m[b+4>>2]){c=d;d=j[b+80>>2];j[b>>2]=c;j[b+4>>2]=d}if(!q){break q}t=1;if(!(j[a+480180>>2]&17301536)|(j[b+696>>2]?0:k[b+89|0]&16)){break q}if(!(k[a+480208|0]&8)|!k[b+811|0]){break p}}if(!(j[b+696>>2]|(!(j[a+480180>>2]&17301536)|!(k[b+89|0]&16)))){cl(b);mb(n+16|0,s,21);if(!kb(n+16|0)){h[b+838|0]=0;j[b+780>>2]=0}j[b+696>>2]=65536;j[b+88>>2]=j[b+88>>2]&-4097}if(!(k[b+811|0]|(!t|!(k[a+480208|0]&8)))){t=1;break p}if(k[b+811|0]?0:j[a+480180>>2]&1048580){break p}j[b+696>>2]=65536;j[b+88>>2]=j[b+88>>2]&-4097}mb(n+16|0,s,40);z:{A:{B:{C:{if(kb(n+16|0)){if(t){if(k[b+811|0]?k[a+480208|0]&8:0){break B}j[b+88>>2]=j[b+88>>2]&-4194305;break A}c=j[b+88>>2]&-4196353;break C}c=j[b+88>>2]&-4196353;j[b+88>>2]=c;r=1;if(t){break z}}i[b+862>>1]=65535;j[b+88>>2]=c&-6326273|2097152;mb(n+16|0,s,23);D:{if(kb(n+16|0)){break D}mb(n,s,22);if(kb(n)){break D}mb(n+16|0,s,52);if(kb(n+16|0)){break D}mb(n,s,71);if(kb(n)){break D}h[b+859|0]=0;i[b+798>>1]=0}if(e){h[b+838|0]=0;j[b+780>>2]=0}j[b+20>>2]=0;j[b+24>>2]=0;c=j[a+480208>>2]&8192;E:{if(o){F:{G:{if(!kA(o)){if(It(o)){break G}c=c>>>13^1;if(c){break F}c=(c|0)!=0;break E}x=b,y=lA(o),h[x+858|0]=y;if(!It(o)){break F}}x=b,y=nA(o),h[x+857|0]=y}c=1;d=k[o+25|0];if((d|0)==255){break E}h[b+865|0]=d;break E}j[b+788>>2]=0;j[b+792>>2]=0;c=!c}H:{if(k[b+857|0]>=127){mb(n+16|0,s,36);if(!kb(n+16|0)){break H}}r=0;if(!c){break z}if((Io(a,b,1,256)|0)<0|!(k[b+89|0]&2)){break z}c=a+1304392|0;if(!$c(c)|(g|0)==65535){break z}No(j[c>>2],g,k[b+857|0]>>>1|0,1);break z}r=0;break z}j[b+88>>2]=j[b+88>>2]&-4196353}r=1}c=j[b+88>>2];if(f){c=c&-1025;j[b+88>>2]=c}I:{J:{if(k[a+24618|0]&16?c&1024:0){break J}a=j[b+104>>2];if(f?0:!(!a|!(k[a+35|0]&4))){break J}a=j[b+656>>2];if(!a|!(k[a+15|0]&2)){break I}}if(f){break I}j[b+700>>2]=0}if(r){break a}i[b+136>>1]=0;j[b+132>>2]=4194304;j[b+112>>2]=0;j[b+116>>2]=0}Za=n+32|0}function fW(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,i=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,F=0,L=0,N=0;e=Za-1424|0;Za=e;rc(b);cq(a);a:{if(!mB(b,e+1408|0)){break a}if(!oB(e+1408|0)){break a}if(!lB(b,e+1392|0)){break a}if(!nB(e+1392|0)){break a}b:{if(!c){break b}B=e+1400|0;c=B;if((k[c|0]|k[c+1|0]<<8|(k[c+2|0]<<16|k[c+3|0]<<24))>>>0>jj(b)>>>0){break a}c=B;u=e+1392|2;if((k[c|0]|k[c+1|0]<<8|(k[c+2|0]<<16|k[c+3|0]<<24))+((k[u|0]|k[u+1|0]<<8)<<2)>>>0>jj(b)>>>0){break a}nu(a);mu(e+40|0);lu(zg(a)+28|0,e+40|0);bq(e+40|0);q=j[zg(a)+28>>2];c=e+1392|4;Pn(q,k[c|0]|k[c+1|0]<<8|(k[c+2|0]<<16|k[c+3|0]<<24));Ab(e+1136|0,0,256);c:{d:{if(k[u|0]|k[u+1|0]<<8){o=e+1112|4;p=e+1128|0;A=e+1130|0;v=e+1126|0;i=e+1124|0;while(1){d=0;c=B;if(!xc(b,(k[c|0]|k[c+1|0]<<8|(k[c+2|0]<<16|k[c+3|0]<<24))+(F<<2)|0)){break a}if(!yb(b,4)){break a}f=hf(b);if(!xc(b,f)){break a}if(!ku(b,e+1112|0)){break a}x=cW(e+1096|0,k[i|0]|k[i+1|0]<<8);c=0;e:{f:{g:{h:{i:{j:{k:{l:{m:{n:{o:{p:{q:{r:{s:{t:{u:{v:{if(!(k[i|0]|k[i+1|0]<<8)){break v}w:{while(1){d=wk(x,c);j[114630]=0;d=E(254,b|0,d|0)|0;m=j[114630];j[114630]=0;if((m|0)==1){break w}if(d){c=c+1|0;if(c>>>0>=(k[i|0]|k[i+1|0]<<8)>>>0){break v}continue}break}break u}d=D()|0;C()|0;break c}if(k[i|0]|k[i+1|0]<<8){d=j[x>>2]}else{d=0}c=k[i|0]|k[i+1|0]<<8;j[114630]=0;m=H(255,b|0)|0;n=j[114630];j[114630]=0;if((n|0)==1){break t}g=c<<3;c=f+20|0;if(m>>>0>g+c>>>0){n=c+((k[i|0]|k[i+1|0]<<8)<<3)|0;x:{if(!(h[v|0]&1)){f=0;if(!(k[i|0]|k[i+1|0]<<8)){break e}while(1){if(!d){break x}if(!In(q,d)){break x}j[114630]=0;c=E(256,b|0,n|0)|0;m=j[114630];j[114630]=0;if((m|0)==1){break s}if(!c){break x}m=fc(q,k[d|0]|k[d+1|0]<<8|(k[d+2|0]<<16|k[d+3|0]<<24));c=d;r=k[c+4|0]|k[c+5|0]<<8|(k[c+6|0]<<16|k[c+7|0]<<24);j[114630]=0;m=K(257,b|0,m|0,r|0)|0;r=j[114630];j[114630]=0;if((r|0)==1){break s}if((m|0)!=(k[c+4|0]|k[c+5|0]<<8|(k[c+6|0]<<16|k[c+7|0]<<24))){break x}d=d+8|0;f=f+1|0;if(f>>>0<(k[i|0]|k[i+1|0]<<8)>>>0){continue}break}break e}y:{z:{A:{B:{if(k[v|0]&4){if(!d){break y}if(!In(q,d)){break y}r=fc(q,k[d|0]|k[d+1|0]<<8|(k[d+2|0]<<16|k[d+3|0]<<24));y=k[d+4|0]|k[d+5|0]<<8|(k[d+6|0]<<16|k[d+7|0]<<24);m=k[A|0]|k[A+1|0]<<8;c=k[p|0]|k[p+1|0]<<8;j[114630]=0;c=E(256,b|0,c+n|0)|0;f=j[114630];j[114630]=0;if((f|0)==1){break r}if(!c){break y}c=k[o|0]|k[o+1|0]<<8|(k[o+2|0]<<16|k[o+3|0]<<24);f=k[p|0]|k[p+1|0]<<8;j[114630]=0;c=E(258,b|0,c-f|0)|0;f=j[114630];j[114630]=0;if((f|0)==1){break r}if(!c){break y}c=k[o|0]|k[o+1|0]<<8|(k[o+2|0]<<16|k[o+3|0]<<24);f=k[p|0]|k[p+1|0]<<8;j[114630]=0;I(259,e+24|0,b|0,c-f|0);c=j[114630];j[114630]=0;if((c|0)==1){break d}s=Ml(e+40|0,e+24|0);jb(e+24|0);w=0;f=0;n=0;if(!(k[i|0]|k[i+1|0]<<8)){break h}while(1){C:{j[114630]=0;c=E(260,s|0,m+1|0)|0;g=j[114630];j[114630]=0;if((g|0)==1){break C}g=m&15;t=l[(g<<1)+11024>>1];D:{E:{if(t>>>0<=c>>>0){j[114630]=0;g=k[g+11104|0];L=E(260,s|0,g|0)|0;N=j[114630];j[114630]=0;if((N|0)==1){break j}c=L+(c-t<<g)|0;if((c|0)!=(m|0)){m=c&15;break D}j[114630]=0;c=E(260,s|0,4)|0;g=j[114630];j[114630]=0;if((g|0)==1){break j}if((c|0)==15){j[114630]=0;g=E(260,s|0,1)|0;c=j[114630];j[114630]=0;if((c|0)==1){break j}c=65535;if(!g){break E}jb(e+40|0);break e}c=c+65520|0}if(c>>>0>65535){break D}}c=c&1?0-(c+1>>>1|0)|0:c>>>1|0;g=f+r|0;t=g;F:{if(k[v|0]&2){w=c+w|0;c=w;break F}c=k[v+1|0]&2?c:c^32768}h[t|0]=c;h[g+1|0]=c>>>8;f=f+2|0}if(f>>>0>=y>>>0){n=n+1|0;if(n>>>0>=(k[i|0]|k[i+1|0]<<8)>>>0){break z}c=(n<<3)+d|0;if(!In(q,c)){break B}y=k[c+4|0]|k[c+5|0]<<8|(k[c+6|0]<<16|k[c+7|0]<<24);r=fc(q,k[c|0]|k[c+1|0]<<8|(k[c+2|0]<<16|k[c+3|0]<<24));f=0}if((k[i|0]|k[i+1|0]<<8)>>>0>n>>>0){continue}break h}break}d=J(77088)|0;break i}if(!d){break y}if(!In(q,d)){break y}w=fc(q,k[d|0]|k[d+1|0]<<8|(k[d+2|0]<<16|k[d+3|0]<<24));y=k[d+4|0]|k[d+5|0]<<8|(k[d+6|0]<<16|k[d+7|0]<<24);m=k[A|0]|k[A+1|0]<<8;if((k[p|0]|k[p+1|0]<<8)>>>0>256){break y}j[114630]=0;c=E(256,b|0,n|0)|0;f=j[114630];j[114630]=0;if((f|0)==1){break q}if(!c){break y}c=k[p|0]|k[p+1|0]<<8;j[114630]=0;c=K(261,b|0,e+1136|0,c|0)|0;f=j[114630];j[114630]=0;if((f|0)==1){break q}if(c>>>0<(k[p|0]|k[p+1|0]<<8)>>>0){break y}c=k[o|0]|k[o+1|0]<<8|(k[o+2|0]<<16|k[o+3|0]<<24);f=k[p|0]|k[p+1|0]<<8;j[114630]=0;c=E(258,b|0,c-f|0)|0;f=j[114630];j[114630]=0;if((f|0)==1){break q}if(!c){break y}c=k[o|0]|k[o+1|0]<<8|(k[o+2|0]<<16|k[o+3|0]<<24);f=k[p|0]|k[p+1|0]<<8;j[114630]=0;I(259,e+24|0,b|0,c-f|0);c=j[114630];j[114630]=0;if((c|0)==1){break k}s=Ml(e+40|0,e+24|0);jb(e+24|0);r=0;f=0;n=0;if(!(k[i|0]|k[i+1|0]<<8)){break n}G:{while(1){H:{j[114630]=0;c=E(260,s|0,m+1|0)|0;g=j[114630];j[114630]=0;if((g|0)==1){break H}g=m&7;t=k[g+11056|0];I:{J:{if(t>>>0<=c>>>0){j[114630]=0;g=k[g+11064|0];L=E(260,s|0,g|0)|0;N=j[114630];j[114630]=0;if((N|0)==1){break p}c=L+(c-t<<g)|0;if((c|0)!=(m|0)){m=c&7;break I}j[114630]=0;c=E(260,s|0,3)|0;g=j[114630];j[114630]=0;if((g|0)==1){break p}if((c|0)==7){j[114630]=0;g=E(260,s|0,1)|0;c=j[114630];j[114630]=0;if((c|0)==1){break p}c=255;if(!g){break J}jb(e+40|0);break e}c=c+248|0}if(c>>>0>255){break I}}c=k[(e+1136|0)+c|0];g=c+r|0;t=c;c=(k[v|0]|k[v+1|0]<<8)&2;h[f+w|0]=c?g:t;r=c?g:r;f=f+1|0}if(f>>>0>=y>>>0){n=n+1|0;if(n>>>0>=(k[i|0]|k[i+1|0]<<8)>>>0){break G}c=(n<<3)+d|0;if(!In(q,c)){break A}y=k[c+4|0]|k[c+5|0]<<8|(k[c+6|0]<<16|k[c+7|0]<<24);w=fc(q,k[c|0]|k[c+1|0]<<8|(k[c+2|0]<<16|k[c+3|0]<<24));f=0}if((k[i|0]|k[i+1|0]<<8)>>>0>n>>>0){continue}break n}break}d=J(77088)|0;break o}jb(e+40|0);break e}jb(e+40|0);break u}jb(e+40|0);break u}jb(e+40|0);break e}}}}ju(x);d=0;break a}d=D()|0;C()|0;break c}d=D()|0;C()|0;break c}d=D()|0;C()|0;break c}d=D()|0;C()|0;break c}d=J(77088)|0}if((C()|0)!=(W(77088)|0)){break l}O(d|0)|0;j[114630]=0;M(20);c=j[114630];j[114630]=0;if((c|0)==1){break m}}jb(e+40|0);break e}d=D()|0;C()|0}jb(e+40|0);break c}d=D()|0;C()|0;break c}d=J(77088)|0}if((C()|0)!=(W(77088)|0)){break f}O(d|0)|0;j[114630]=0;M(20);c=j[114630];j[114630]=0;if((c|0)==1){break g}}jb(e+40|0);break e}d=D()|0;C()|0}jb(e+40|0);break c}ju(x);F=F+1|0;if(F>>>0<(k[u|0]|k[u+1|0]<<8)>>>0){continue}break}}yi(e+8|0,q);iu(e+16|0,e+8|0);b=Hn(e+40|0,e+16|0,0);Ed(zg(a)+12|0,b);jb(b);break b}d=D()|0;C()|0}ju(x);G(d|0);z()}d=1}Za=e+1424|0;return d|0}function X$(a,b,c,d,e,f,g,i,l,m,n){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;i=i|0;l=l|0;m=m|0;n=n|0;var o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;o=Za-560|0;Za=o;j[o+548>>2]=n;j[o+552>>2]=b;j[o+104>>2]=2483;s=yd(o+136|0,o+144|0,o+104|0);b=j[s>>2];j[o+132>>2]=b;j[o+128>>2]=b+400;u=Cb(o+104|0);r=Cb(o+88|0);p=Cb(o+72|0);q=Cb(o+56|0);t=Cb(o+40|0);j[114630]=0;ba(2486,c|0,d|0,o+120|0,o+119|0,o+118|0,u|0,r|0,p|0,q|0,o+36|0);b=j[114630];j[114630]=0;if((b|0)!=1){a:{j[m>>2]=j[l>>2];v=e&512;w=v>>>9|0;b=0;e=0;while(1){n=e;b:{c:{d:{e:{if((b|0)==4){break e}j[114630]=0;c=E(2423,a|0,o+552|0)|0;d=j[114630];j[114630]=0;if((d|0)==1){break a}if(!c){break e}c=0;f:{g:{h:{i:{j:{switch(h[(o+120|0)+b|0]){case 1:if((b|0)==3){break c}j[114630]=0;c=H(2425,a|0)|0;d=j[114630];j[114630]=0;if((d|0)==1){break a}if(ng(i,8192,c)){j[114630]=0;I(2487,o+24|0,a|0,0);c=j[114630];j[114630]=0;if((c|0)!=1){c=h[o+24|0];j[114630]=0;F(110,t|0,c|0);c=j[114630];j[114630]=0;if((c|0)!=1){break i}}break a}j[f>>2]=j[f>>2]|4;a=0;break d;case 3:break h;case 0:break j;case 4:break f;case 2:break g;default:break b}}if((b|0)==3){break c}}while(1){j[114630]=0;c=E(2423,a|0,o+552|0)|0;d=j[114630];j[114630]=0;if((d|0)==1){break a}if(!c){break c}j[114630]=0;c=H(2425,a|0)|0;d=j[114630];j[114630]=0;if((d|0)==1){break a}if(!ng(i,8192,c)){break c}j[114630]=0;I(2487,o+24|0,a|0,0);c=j[114630];j[114630]=0;if((c|0)!=1){c=h[o+24|0];j[114630]=0;F(110,t|0,c|0);c=j[114630];j[114630]=0;if((c|0)!=1){continue}}break}break a}if((nb(p)|0)==(0-nb(q)|0)){break c}k:{if(nb(p)){if(nb(q)){break k}}if(nb(p)){j[114630]=0;c=H(2425,a|0)|0;d=j[114630];j[114630]=0;if((d|0)==1){break a}if(k[Ub(p,0)|0]==(c&255)){j[114630]=0;H(2427,a|0)|0;c=j[114630];j[114630]=0;if((c|0)==1){break a}e=nb(p)>>>0>1?p:n;break b}h[g|0]=1;break c}j[114630]=0;c=H(2425,a|0)|0;d=j[114630];j[114630]=0;if((d|0)==1){break a}if(k[Ub(q,0)|0]!=(c&255)){break c}j[114630]=0;H(2427,a|0)|0;c=j[114630];j[114630]=0;if((c|0)==1){break a}h[g|0]=1;e=nb(q)>>>0>1?q:n;break b}j[114630]=0;c=H(2425,a|0)|0;d=j[114630];j[114630]=0;if((d|0)==1){break a}if(k[Ub(p,0)|0]==(c&255)){j[114630]=0;H(2427,a|0)|0;c=j[114630];j[114630]=0;if((c|0)==1){break a}e=nb(p)>>>0>1?p:n;break b}j[114630]=0;c=H(2425,a|0)|0;d=j[114630];j[114630]=0;if((d|0)==1){break a}if(k[Ub(q,0)|0]==(c&255)){j[114630]=0;H(2427,a|0)|0;c=j[114630];j[114630]=0;if((c|0)==1){break a}h[g|0]=1;e=nb(q)>>>0>1?q:n;break b}j[f>>2]=j[f>>2]|4;a=0;break d}if(!(n|b>>>0<2)){e=0;if(!((b|0)==2&k[o+123|0]!=0|w)){break b}}x=o,y=nd(r),j[x+16>>2]=y;c=Cd(o+24|0,o+16|0);l:{if(!b|k[(b+o|0)+119|0]>1){break l}while(1){m:{x=o,y=_e(r),j[x+16>>2]=y;if(!rb(c,o+16|0)){break m}if(!ng(i,8192,h[j[c>>2]])){break m}Xf(c);continue}break}x=o,y=nd(r),j[x+16>>2]=y;c=Jn(c,o+16|0);if(nb(t)>>>0>=c>>>0){x=o,y=_e(t),j[x+16>>2]=y;c=af(o+16|0,0-c|0);d=_e(t);e=nd(r);j[114630]=0;c=QC(c,d,e);d=j[114630];j[114630]=0;if((d|0)==1){break a}if(c){break l}}x=o,y=nd(r),j[x+8>>2]=y;Cd(o+16|0,o+8|0);j[o+24>>2]=j[o+16>>2]}j[o+16>>2]=j[o+24>>2];n:{while(1){x=o,y=_e(r),j[x+8>>2]=y;if(!rb(o+16|0,o+8|0)){break n}j[114630]=0;c=E(2423,a|0,o+552|0)|0;d=j[114630];j[114630]=0;o:{if((d|0)==1){break o}if(!c){break n}j[114630]=0;c=H(2425,a|0)|0;d=j[114630];j[114630]=0;if((d|0)==1){break o}if(k[j[o+16>>2]]!=(c&255)){break n}j[114630]=0;H(2427,a|0)|0;c=j[114630];j[114630]=0;if((c|0)==1){break a}Xf(o+16|0);continue}break}break a}if(!v){break c}x=o,y=_e(r),j[x+8>>2]=y;if(!rb(o+16|0,o+8|0)){break c}j[f>>2]=j[f>>2]|4;a=0;break d}p:{while(1){q:{j[114630]=0;d=E(2423,a|0,o+552|0)|0;e=j[114630];j[114630]=0;if((e|0)==1){break q}if(!d){break p}j[114630]=0;e=H(2425,a|0)|0;d=j[114630];j[114630]=0;if((d|0)==1){break a}r:{if(ng(i,2048,e)){d=j[m>>2];if((d|0)==j[o+548>>2]){j[114630]=0;I(2489,l|0,m|0,o+548|0);d=j[114630];j[114630]=0;if((d|0)==1){break a}d=j[m>>2]}j[m>>2]=d+1;h[d|0]=e;c=c+1|0;break r}if(!c|!nb(u)|k[o+118|0]!=(e&255)){break p}e=j[o+132>>2];if((e|0)==j[o+128>>2]){j[114630]=0;I(2490,s|0,o+132|0,o+128|0);d=j[114630];j[114630]=0;if((d|0)==1){break a}e=j[o+132>>2]}j[o+132>>2]=e+4;j[e>>2]=c;c=0}j[114630]=0;H(2427,a|0)|0;d=j[114630];j[114630]=0;if((d|0)!=1){continue}}break}break a}d=j[s>>2];s:{if(!c){break s}e=j[o+132>>2];if((d|0)==(e|0)){break s}if(j[o+128>>2]==(e|0)){j[114630]=0;I(2490,s|0,o+132|0,o+128|0);d=j[114630];j[114630]=0;if((d|0)==1){break a}e=j[o+132>>2]}j[o+132>>2]=e+4;j[e>>2]=c}t:{if(j[o+36>>2]<1){break t}j[114630]=0;c=E(2424,a|0,o+552|0)|0;d=j[114630];j[114630]=0;if((d|0)==1){break a}u:{if(!c){j[114630]=0;c=H(2425,a|0)|0;d=j[114630];j[114630]=0;if((d|0)==1){break a}if(k[o+119|0]==(c&255)){break u}}j[f>>2]=j[f>>2]|4;a=0;break d}j[114630]=0;H(2427,a|0)|0;c=j[114630];j[114630]=0;if((c|0)==1){break a}while(1){if(j[o+36>>2]<1){break t}j[114630]=0;c=E(2424,a|0,o+552|0)|0;d=j[114630];j[114630]=0;v:{if((d|0)==1){break v}w:{if(!c){j[114630]=0;c=H(2425,a|0)|0;d=j[114630];j[114630]=0;if((d|0)==1){break v}if(ng(i,2048,c)){break w}}j[f>>2]=j[f>>2]|4;a=0;break d}if(j[m>>2]==j[o+548>>2]){j[114630]=0;I(2489,l|0,m|0,o+548|0);c=j[114630];j[114630]=0;if((c|0)==1){break v}}j[114630]=0;c=H(2425,a|0)|0;d=j[114630];j[114630]=0;if((d|0)==1){break v}d=j[m>>2];j[m>>2]=d+1;h[d|0]=c;j[114630]=0;j[o+36>>2]=j[o+36>>2]-1;H(2427,a|0)|0;c=j[114630];j[114630]=0;if((c|0)!=1){continue}}break}break a}e=n;if(j[l>>2]!=j[m>>2]){break b}j[f>>2]=j[f>>2]|4;a=0;break d}x:{if(!n){break x}e=1;while(1){if(nb(n)>>>0<=e>>>0){break x}j[114630]=0;b=E(2424,a|0,o+552|0)|0;c=j[114630];j[114630]=0;y:{if((c|0)==1){break y}z:{if(!b){j[114630]=0;b=H(2425,a|0)|0;c=j[114630];j[114630]=0;if((c|0)==1){break y}if(k[Ub(n,e)|0]==(b&255)){break z}}j[f>>2]=j[f>>2]|4;a=0;break d}j[114630]=0;H(2427,a|0)|0;b=j[114630];j[114630]=0;e=e+1|0;if((b|0)!=1){continue}}break}break a}A:{if(j[s>>2]==j[o+132>>2]){break A}j[o+24>>2]=0;a=j[s>>2];j[114630]=0;le(u,a,j[o+132>>2],o+24|0);a=j[114630];j[114630]=0;if((a|0)!=1){if(!j[o+24>>2]){break A}j[f>>2]=j[f>>2]|4;a=0;break d}break a}a=1}gb(t);gb(q);gb(p);gb(r);gb(u);mc(s);Za=o+560|0;return a|0}e=n}b=b+1|0;continue}}}a=D()|0;C()|0;gb(t);gb(q);gb(p);gb(r);gb(u);mc(s);G(a|0);z()}function tGa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,n=0,o=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,J=0,L=0,M=0,N=0;e=Za-176|0;Za=e;a:{b:{c:{d:{e:{f:{g:{h:{if(!vh(b,14021)){break h}if(d){h[d|0]=1}r=a+1074308|0;Vs(r);i:{if(!yb(b,7)){break i}t=a+480216|0;u=a+480220|0;v=a+480224|0;w=a+1074368|0;x=a+480228|0;y=a+480232|0;A=a+480200|0;B=a+484360|0;s=a+480268|0;J=a+1304412|0;L=a+480248|0;while(1){f=hf(b);d=Of(b);if((f|0)==(k[14475]|k[14476]<<8|(k[14477]<<16|k[14478]<<24))){cg(b,6);break i}if(!(f&1616928864)|f&-2139062144){break i}if(!yb(b,d)){break i}cd(e+160|0,b,d);j:{k:{l:{m:{n:{o:{p:{q:{r:{s:{t:{u:{v:{w:{x:{y:{z:{A:{if((f|0)<=1347243309){if((f|0)<=1146367533){if((f|0)<=1130917458){if((f|0)==1127099950){break y}if((f|0)!=1129797166){break j}j[114630]=0;j[e>>2]=0;I(671,e+160|0,d|0,e|0);d=j[114630];j[114630]=0;if((d|0)==1){break v}j[a+1074300>>2]=j[e>>2];break j}if((f|0)==1130917459){break q}if((f|0)!=1145525806){break j}j[114630]=0;I(671,e+160|0,d|0,A|0);d=j[114630];j[114630]=0;if((d|0)==1){break b}break j}if((f|0)<=1213486400){if((f|0)==1146367534){break A}if((f|0)!=1196316499|d>>>0<3){break j}j[114630]=0;F(672,e+144|0,e+160|0);d=j[114630];j[114630]=0;if((d|0)==1){break o}j[114630]=0;g=K(673,e|0,e+144|0,8)|0;d=j[114630];j[114630]=0;if((d|0)==1){break n}gb(e+144|0);j[114630]=0;f=H(255,e+160|0)|0;d=j[114630];j[114630]=0;if((d|0)==1){break m}j[114630]=0;I(674,e|0,L|0,f|0);d=j[114630];j[114630]=0;if((d|0)==1){break m}Xe(g);break j}if((f|0)==1213486401){break r}if((f|0)==1280530262){break u}if((f|0)!=1297303086){break j}Vs(r);n=0;break l}if((f|0)<=1380994349){if((f|0)<=1380340803){if((f|0)==1347243310){break w}if((f|0)!=1347244882){break j}j[114630]=0;I(675,e+160|0,d|0,s|0);d=j[114630];j[114630]=0;if((d|0)==1){break b}if(un(k[s|0])){break j}h[s|0]=5;break j}if((f|0)==1380340804){break z}if((f|0)==1380986414){break s}if((f|0)!=1380991534){break j}j[114630]=0;I(671,e+160|0,d|0,t|0);d=j[114630];j[114630]=0;if((d|0)==1){break b}break j}if((f|0)<=1397768493){if((f|0)==1380994350){break k}if((f|0)!=1397052739|d>>>0<3){break j}j[114630]=0;f=H(357,e+160|0)|0;d=j[114630];j[114630]=0;if((d|0)==1){break c}if(!f|f>>>0>l[a+480190>>1]){break j}f=p(f,104)+a|0;d=f+484448|0;q=f+484484|0;while(1){j[114630]=0;g=H(390,e+160|0)|0;f=j[114630];j[114630]=0;if((f|0)==1){break p}j[d>>2]=g;d=d+4|0;if((q|0)!=(d|0)){continue}break}break j}if((f|0)==1397768494){break t}if((f|0)==1414344238){break x}if((f|0)!=1448301654){break j}j[114630]=0;I(671,e+160|0,d|0,y|0);d=j[114630];j[114630]=0;if((d|0)==1){break b}break j}j[114630]=0;I(671,e+160|0,d|0,e|0);d=j[114630];j[114630]=0;if((d|0)==1){break g}j[a+480204>>2]=p(j[e>>2],1e4)+(m[a+480204>>2]%1e4|0);break j}j[114630]=0;I(671,e+160|0,d|0,e|0);d=j[114630];j[114630]=0;if((d|0)!=1){d=j[a+480204>>2];j[a+480204>>2]=d-((d>>>0)%1e4|0)+m[e>>2]%1e4;break j}d=D()|0;C()|0;break a}if(c){break j}j[114630]=0;i[e>>1]=0;I(676,e+160|0,d|0,e|0);d=j[114630];j[114630]=0;if((d|0)!=1){M=a,N=kd(l[e>>1],l[a+480188>>1],127),i[M+480188>>1]=N;break j}d=D()|0;C()|0;break a}j[114630]=0;I(677,e+160|0,d|0,v|0);d=j[114630];j[114630]=0;if((d|0)==1){break b}break j}j[114630]=0;I(678,e+160|0,d|0,w|0);d=j[114630];j[114630]=0;if((d|0)==1){break b}break j}d=D()|0;C()|0;break a}j[114630]=0;j[e>>2]=0;I(671,e+160|0,d|0,e|0);d=j[114630];j[114630]=0;if((d|0)==1){break f}d=j[e>>2];if(!d){break j}j[a+1074304>>2]=d;break j}j[114630]=0;I(671,e+160|0,d|0,x|0);d=j[114630];j[114630]=0;if((d|0)!=1){break j}break b}if(j[a+480180>>2]==4){break j}j[114630]=0;I(676,e+160|0,d|0,e|0);d=j[114630];j[114630]=0;if((d|0)!=1){Fe(Eb(B),l[e>>1]);break j}d=D()|0;C()|0;break a}g=Cb(e);j[114630]=0;f=H(255,e+160|0)|0;d=j[114630];j[114630]=0;B:{if((d|0)==1){break B}j[114630]=0;K(679,e+160|0,g|0,f|0)|0;d=j[114630];j[114630]=0;if((d|0)==1){break B}j[114630]=0;I(13,e+144|0,0,g|0);d=j[114630];j[114630]=0;if((d|0)==1){break B}ob(J,e+144|0);gb(e+144|0);gb(g);break j}d=D()|0;C()|0;gb(g);break a}if(d&1|d>>>0>126){break j}i[e>>1]=(d>>>1|0)- -64;j[114630]=0;i[e+144>>1]=127;f=E(477,e|0,e+144|0)|0;d=j[114630];j[114630]=0;if((d|0)==1){break e}q=l[f>>1];if(q>>>0<65){break j}n=64;while(1){j[114630]=0;F(472,e|0,e+160|0);d=j[114630];j[114630]=0;if((d|0)==1){break d}d=Pc(e);f=e;C:{if(k[e|0]==255){break C}d=k[d|0];o=(n<<5)+a|0;g=o+480284|0;i[g>>1]=128;i[o+480286>>1]=d;o=o+480280|0;j[o>>2]=0;j[o>>2]=(k[f|0]&128)<<3;d=k[f|0]&127;h[f|0]=d;if(d>>>0<65){i[g>>1]=d<<2;d=k[f|0]}if((d|0)!=100){break C}j[o>>2]=j[o>>2]|256}n=n+1|0;if((q|0)!=(n|0)){continue}break}break j}d=D()|0;C()|0;break a}d=D()|0;C()|0;break a}d=D()|0;C()|0;gb(e+144|0);break a}d=D()|0;C()|0;Xe(g);break a}D:{E:{F:while(1){j[114630]=0;f=E(258,e+160|0,1)|0;d=j[114630];j[114630]=0;if((d|0)==1){break E}if(!f|n>>>0>=110){break j}j[114630]=0;g=H(387,e+160|0)|0;d=j[114630];j[114630]=0;if((d|0)==1){break D}d=0;while(1){G:{if(!(!(g>>>d&1)|n>>>0>=110)){j[114630]=0;K(478,r|0,n|0,1)|0;f=j[114630];j[114630]=0;if((f|0)==1){break G}}n=n+1|0;d=d+1|0;if((d|0)!=8){continue}continue F}break}break}d=D()|0;C()|0;break a}d=D()|0;C()|0;break a}d=D()|0;C()|0;break a}j[114630]=0;I(671,e+160|0,d|0,u|0);d=j[114630];j[114630]=0;if((d|0)==1){break b}}jb(e+160|0);if(yb(b,7)){continue}break}}An(a+480204|0,p(j[j[a+8>>2]+20>>2],1e4),p(j[j[a+8>>2]+24>>2],1e4));if(j[a+480224>>2]>=3){j[a+480224>>2]=0}if(j[a+1074368>>2]>=6){j[a+1074368>>2]=0}jc(a+480200|0,256);b=a+480248|0;if(Xc(b)){break h}Yy(b,j[a+480216>>2],16777216)}Za=e+176|0;return}d=D()|0;C()|0;break a}d=D()|0;C()|0;break a}d=D()|0;C()|0;break a}d=D()|0;C()|0;break a}d=D()|0;C()|0;break a}d=D()|0;C()|0}jb(e+160|0);G(d|0);z()}function Sea(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=q(0),f=q(0),g=q(0),i=q(0),l=q(0),m=0,o=q(0),p=q(0),r=q(0),s=q(0),t=0,u=0,v=q(0),w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=q(0),U=0,V=0,W=0,X=q(0);a:{if(!k[a+5046|0]){break a}i=n[a+4268>>2];ZG(a);if(i==n[a+4268>>2]){break a}gw(a)}b:{if(!k[a+5045|0]){break b}w=a+44|0;if(!Xg(w)){break b}x=wd(w,0);B=wd(w,1);t=Rc(w,0);u=Rc(w,1);c:{if(!(!k[a+5044|0]|(!d|k[a+4264|0]&2))){n[t>>2]=n[a+5036>>2];n[u>>2]=n[a+5040>>2];h[a+5044|0]=0;B=B+4|0;x=x+4|0;u=u+4|0;t=t+4|0;m=d-1|0;break c}m=d}y=m;d:{if(!y){break d}S=a+4960|0;D=a+4648|0;E=a+4672|0;O=a+4936|0;F=a+4696|0;G=a+4720|0;H=a+4744|0;I=a+4768|0;P=a+4840|0;C=a+4504|0;J=a+4528|0;Q=a+4912|0;K=a+4552|0;L=a+4576|0;M=a+4600|0;N=a+4624|0;R=a+4816|0;z=a+4888|0;A=a+4864|0;while(1){i=n[x>>2];i=q(q(q(n[a+5008>>2]-i)*n[a+4276>>2])+i);n[a+5008>>2]=i;W=kc(A,j[a+4880>>2]),X=i,n[W>>2]=X;i=n[B>>2];i=q(q(q(n[a+5012>>2]-i)*n[a+4276>>2])+i);n[a+5012>>2]=i;W=kc(z,j[a+4904>>2]),X=i,n[W>>2]=X;i=Lg(A,j[a+4356>>2]);f=Lg(A,j[a+4360>>2]);e=Lg(A,j[a+4364>>2]);g=Lg(A,j[a+4368>>2]);i=q(q(q(i*q(.6800000071525574))+q(q(e+Lg(A,j[a+4372>>2]))*q(-.6200000047683716)))+q(q(g+f)*q(-.5)));if(h[a+4264|0]&1){f=i;i=q(n[kc(R,j[a+4836>>2])>>2]+q(f*q(.6180340051651001)));W=kc(R,j[a+4832>>2]),X=q(f-q(i*q(.6180340051651001))),n[W>>2]=X}T=n[a+4280>>2];W=a,X=q(Lg(A,j[a+4352>>2])+n[a+5020>>2]),n[W+5020>>2]=X;f=q(Lg(z,j[a+4376>>2])+n[a+5024>>2]);n[a+5024>>2]=f;e=n[a+5020>>2];g=n[a+4980>>2];r=n[kc(N,j[a+4644>>2])>>2];s=n[a+4444>>2];g=q(n[kc(N,j[a+4644>>2])>>2]+q(s*q(g-r)));n[a+4980>>2]=g;r=n[a+4272>>2];s=q(e*q(-.7070000171661377));o=q(f*q(.7070000171661377));e=q(s+o);f=q(q(r*e)+q(n[a+4440>>2]*g));W=kc(N,j[a+4640>>2]),X=q(e-q(r*f)),n[W>>2]=X;e=n[a+4976>>2];g=n[kc(M,j[a+4620>>2])>>2];r=n[a+4436>>2];e=q(n[kc(M,j[a+4620>>2])>>2]+q(r*q(e-g)));n[a+4976>>2]=e;g=n[a+4272>>2];e=q(q(g*f)+q(n[a+4432>>2]*e));W=kc(M,j[a+4616>>2]),X=q(f-q(g*e)),n[W>>2]=X;r=q(q(f*q(-.15000000596046448))+q(e*q(-.20000000298023224)));if(h[a+4264|0]&1){f=n[a+4972>>2];g=n[kc(L,j[a+4596>>2])>>2];l=n[a+4428>>2];f=q(n[kc(L,j[a+4596>>2])>>2]+q(l*q(f-g)));n[a+4972>>2]=f;g=n[a+4272>>2];f=q(q(g*e)+q(n[a+4424>>2]*f));W=kc(L,j[a+4592>>2]),X=q(e-q(g*f)),n[W>>2]=X;e=n[a+4968>>2];g=n[kc(K,j[a+4572>>2])>>2];l=n[a+4420>>2];e=q(n[kc(K,j[a+4572>>2])>>2]+q(l*q(e-g)));n[a+4968>>2]=e;g=n[a+4272>>2];e=q(q(g*f)+q(n[a+4416>>2]*e));W=kc(K,j[a+4568>>2]),X=q(f-q(g*e)),n[W>>2]=X;r=q(q(q(f*q(.3499999940395355))+r)+q(e*q(-.3799999952316284)))}o=q(s-o);W=kc(Q,j[a+4928>>2]),X=e,n[W>>2]=X;m=kc(Q,j[a+4932>>2]);f=q(n[a+4496>>2]*n[m>>2]);n[a+5028>>2]=q(q(n[a+5028>>2]-f)*n[a+4500>>2])+f;f=n[a+4964>>2];e=n[kc(J,j[a+4548>>2])>>2];g=n[a+4412>>2];f=q(n[kc(J,j[a+4548>>2])>>2]+q(g*q(f-e)));n[a+4964>>2]=f;e=q(n[a+4408>>2]*f);f=n[a+4272>>2];g=n[a+5028>>2];e=q(e+q(f*g));W=kc(J,j[a+4544>>2]),X=q(g-q(f*e)),n[W>>2]=X;f=n[a+4960>>2];g=n[kc(C,j[a+4524>>2])>>2];s=n[a+4404>>2];f=q(n[kc(C,j[a+4524>>2])>>2]+q(s*q(f-g)));n[a+4960>>2]=f;g=n[a+4272>>2];s=q(q(g*e)+q(n[a+4400>>2]*f));W=kc(C,j[a+4520>>2]),X=q(e-q(g*s)),n[W>>2]=X;n[a+5020>>2]=s;f=Lg(z,j[a+4380>>2]);g=Lg(z,j[a+4384>>2]);l=Lg(z,j[a+4388>>2]);v=Lg(z,j[a+4392>>2]);f=q(q(q(f*q(.7070000171661377))+q(q(l+Lg(z,j[a+4396>>2]))*q(-.5)))+q(q(v+g)*q(-.6000000238418579)));l=q(e*q(.3799999952316284));if(h[a+4264|0]&1){e=f;f=q(n[kc(P,j[a+4860>>2])>>2]+q(e*q(.6180340051651001)));W=kc(P,j[a+4856>>2]),X=q(e-q(f*q(.6180340051651001))),n[W>>2]=X}v=n[a+4280>>2];e=n[a+5004>>2];g=n[kc(I,j[a+4788>>2])>>2];p=n[a+4492>>2];e=q(n[kc(I,j[a+4788>>2])>>2]+q(p*q(e-g)));n[a+5004>>2]=e;p=n[a+4272>>2];g=q(q(p*o)+q(n[a+4488>>2]*e));W=kc(I,j[a+4784>>2]),X=q(o-q(p*g)),n[W>>2]=X;e=n[a+5e3>>2];o=n[kc(H,j[a+4764>>2])>>2];p=n[a+4484>>2];e=q(n[kc(H,j[a+4764>>2])>>2]+q(p*q(e-o)));n[a+5e3>>2]=e;o=n[a+4272>>2];e=q(q(o*g)+q(n[a+4480>>2]*e));W=kc(H,j[a+4760>>2]),X=q(g-q(o*e)),n[W>>2]=X;o=q(q(e*q(-.20000000298023224))+q(l+q(g*q(-.15000000596046448))));if(h[a+4264|0]&1){g=n[a+4996>>2];l=n[kc(G,j[a+4740>>2])>>2];p=n[a+4476>>2];g=q(n[kc(G,j[a+4740>>2])>>2]+q(p*q(g-l)));n[a+4996>>2]=g;l=n[a+4272>>2];g=q(q(l*e)+q(n[a+4472>>2]*g));W=kc(G,j[a+4736>>2]),X=q(e-q(l*g)),n[W>>2]=X;e=n[a+4992>>2];l=n[kc(F,j[a+4716>>2])>>2];p=n[a+4468>>2];e=q(n[kc(F,j[a+4716>>2])>>2]+q(p*q(e-l)));n[a+4992>>2]=e;l=n[a+4272>>2];e=q(q(l*g)+q(n[a+4464>>2]*e));W=kc(F,j[a+4712>>2]),X=q(g-q(l*e)),n[W>>2]=X;o=q(q(q(g*q(.3499999940395355))+o)+q(e*q(-.3799999952316284)))}U=B+4|0;V=x+4|0;g=q(v*f);W=kc(O,j[a+4952>>2]),X=e,n[W>>2]=X;m=kc(O,j[a+4956>>2]);f=q(n[a+4496>>2]*n[m>>2]);n[a+5032>>2]=q(q(n[a+5032>>2]-f)*n[a+4500>>2])+f;f=n[a+4988>>2];e=n[kc(E,j[a+4692>>2])>>2];l=n[a+4460>>2];f=q(n[kc(E,j[a+4692>>2])>>2]+q(l*q(f-e)));n[a+4988>>2]=f;e=n[a+4272>>2];l=n[a+5032>>2];f=q(q(n[a+4456>>2]*f)+q(e*l));W=kc(E,j[a+4688>>2]),X=q(l-q(e*f)),n[W>>2]=X;l=n[a+4284>>2];e=n[a+4984>>2];v=n[kc(D,j[a+4668>>2])>>2];p=n[a+4452>>2];e=q(n[kc(D,j[a+4668>>2])>>2]+q(p*q(e-v)));n[a+4984>>2]=e;v=n[a+4272>>2];e=q(q(v*f)+q(n[a+4448>>2]*e));W=kc(D,j[a+4664>>2]),X=q(f-q(v*e)),n[W>>2]=X;n[a+5024>>2]=e;e=q(e*q(.3799999952316284));i=q(q(l*q(q(q(f-s)*q(.3799999952316284))+r))+q(T*i));f=n[a+4288>>2];m=C;while(1){Wea(m);m=m+24|0;if((S|0)!=(m|0)){continue}break}f=q(q(f*q(o-e))+g);e:{f:{if(k[a+4264|0]&2){x=V;m=U;break f}n[t>>2]=q(n[a+5036>>2]+i)*q(.5);n[u>>2]=q(n[a+5040>>2]+f)*q(.5);n[a+5040>>2]=f;n[a+5036>>2]=i;if((y|0)==1){break e}y=y-1|0;x=x+8|0;u=u+4|0;t=t+4|0;m=B+8|0}B=m;n[t>>2]=i;n[u>>2]=f;u=u+4|0;t=t+4|0;y=y-1|0;if(y){continue}break d}break}h[a+5044|0]=1}Sh(a,b,c,Rc(w,0),Rc(w,1),d)}}function Go(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,n=0,o=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;g=Za-16|0;Za=g;n=l[a+480192>>1]>=c>>>0?j[((c<<2)+a|0)+900380>>2]:n;y=j[b+764>>2];t=k[b+824|0];a:{if(!t){mb(g+8|0,a+1074308|0,11);if(kb(g+8|0)){break a}}b:{c:{if(!n){break c}if(!Ld(t)){break c}d:{o=n+236|0;r=t-1|0;if(l[Nc(o,r)>>1]){break d}mb(g+8|0,a+1074308|0,43);if(!kb(g+8|0)){break d}if(ai(n)){break d}j[b+656>>2]=n;break a}if(k[Pb(n+108|0,r)|0]>120){break a}r=l[Nc(o,r)>>1];r=(r-1&65535)>>>0<3999?(p(r,104)+a|0)+484380|0:0;break b}r=(p(c,104)+a|0)+484380|0;if(!l[a+480192>>1]){break b}if(t>>>0>250){break a}mb(g+8|0,a+1074308|0,43);if(kb(g+8|0)){if(n){r=0;if(ai(n)){break b}}h[b+825|0]=0;j[b+656>>2]=0;break a}r=0}w=j[b+104>>2];u=(w|0)!=0&(r|0)!=(w|0);o=j[b+656>>2];if(!(!n|j[a+480180>>2]!=16777216)){x=j[n+44>>2]!=0;if(x&d&j[b+656>>2]==(n|0)&u){break a}}e:{if(!(d&u)){t=r;break e}q=a+1074308|0;mb(g+8|0,q,32);f:{if(!(!kb(g+8|0)|!(k[a+480208|0]&8))){t=j[b+8>>2]|j[b+12>>2]?j[b+104>>2]:r;break f}t=r}g:{if(j[a+480180>>2]==268435456|(j[a+480180>>2]&1048580?!(!n|(o|0)!=(n|0)):0)){break g}if(j[a+480180>>2]==1){if(oh(b)){break g}}mb(g+8|0,q,79);if(!kb(g+8|0)){break e}if(!oh(b)){break e}}s=1}h:{if(!j[b+16>>2]|(!u|(!l[a+480192>>1]|(o|0)!=(n|0)))){break h}mb(g+8|0,a+1074308|0,87);if(!kb(g+8|0)){break h}s=Mf(b+810|0)^1|s}i:{j:{k:{l:{if(!(oh(b)|!(j[a+480180>>2]&16777248))){if(!n){break l}if(!ai(n)){break l}}if((o|0)==(n|0)){break k}}m:{n:{if(!d){break n}mb(g+8|0,a+1074308|0,61);if(!kb(g+8|0)){break n}q=j[b+656>>2];if(q){break m}q=0;o=j[b+104>>2];if(o){break i}}v=1;break j}o=j[b+104>>2];break i}v=0}j[b+656>>2]=n;o=t;q=n}o:{p:{q:{if(!e){break q}r:{if(j[a+480180>>2]&3){if(o){if(ke(o)){break r}}if(!Si(b)){break q}}if(!o){break p}}if(i[o+34>>1]<0){break q}j[b+688>>2]=l[o+30>>1]}n=(o|0)!=0;if(!(u&n&s)){break o}mb(g+8|0,a+1074308|0,85);if(kb(g+8|0)){j[b+768>>2]=h[o+37|0]}n=1;if(j[a+480180>>2]!=2){break o}if(!ke(o)){break o}j[b+704>>2]=j[o+24>>2];break o}if(!(!q|!k[q+34|0])){z=b;n=b;t=j[b+656>>2];s:{if(t){n=j[t+4>>2]<<2;break s}n=j[n+688>>2]}j[z+688>>2]=n;n=0;break o}n=0;j[b+688>>2]=0}if(s){break a}h[b+825|0]=0;t:{if(!q){break t}mb(g+8|0,a+1074308|0,29);if(A=0,B=!(kb(g+8|0)?0:o),C=k[q+34|0]!=0|v,C?A:B){break t}h[b+820|0]=k[q+16|0]}Zta(b,o,q);u:{if(j[a+480180>>2]&1048580?!e:0){break u}mb(g+8|0,a+1074308|0,48);if(kb(g+8|0)){break u}KK(a,b,q,o)}t=d^1;v:{w:{x:{if(!f){break x}e=a+1074308|0;mb(g+8|0,e,19);y:{z:{A:{B:{C:{D:{E:{F:{if(kb(g+8|0)){if(!j[b+76>>2]){s=1;break E}if(!(t|!c)){s=(k[a+480208|0]&8)>>>3|0;if(s){break E}break F}s=0;if(c){break F}break E}s=1;G:{if(!d|!(j[a+480180>>2]&17301536)|(!j[b+76>>2]|k[a+480208|0]&8)){break G}s=0;if(!(k[b+89|0]&16)){break G}s=!j[b+696>>2]}if(!(j[a+480180>>2]&17301536)|(!q|v)){break C}if(!s){break B}c=j[b+88>>2];f=c&6144;break D}if(d){break E}if(!(k[b+89|0]&24)){s=0;break E}s=(k[a+480208|0]&4)>>>2|0}if(!j[b+696>>2]|v){break C}if(!s){break B}c=j[b+88>>2];f=c&2048}j[b+88>>2]=c|2097152;if(!q){break y}if(f){break z}if(!(k[q+60|0]&8)){_h(b+724|0)}if(!(k[q+80|0]&8)){_h(b+736|0)}if(k[q+100|0]&8){break y}_h(b+748|0);break y}if(s){break A}}if(q){if(h[q+60|0]&1){break x}mb(g+8|0,e,32);if(kb(g+8|0)){_h(b+724|0);break x}cl(b);break x}c=0;if(!o){break w}break v}j[b+88>>2]=j[b+88>>2]|2097152;if(!q){break y}}cl(b)}mb(g+8|0,e,21);if(kb(g+8|0)){break x}h[b+838|0]=0;j[b+780>>2]=0}c=0;if(o){break v}if(!q){break w}c=1;if(ai(q)){break v}}j[b+764>>2]=0;j[b+104>>2]=0;break a}e=b;H:{I:{J:{K:{L:{if(!(!d|(n^1|j[b+104>>2]!=(o|0)))){if(j[b+76>>2]?j[a+480180>>2]&16777250:0){break a}if(j[a+480180>>2]!=4){break L}mb(g+8|0,a+1074308|0,40);if(!kb(g+8|0)|k[b+811|0]){break L}d=j[b+88>>2];break K}j[b+88>>2]=j[b+88>>2]&-6145;n=a+1074308|0;mb(g+8|0,n,18);e=b;M:{if(!(A=!kb(g+8|0),B=0,C=j[a+480180>>2]&16777248,C?A:B)){f=-640;if(!(j[b+104>>2]!=(o|0)|v)){break M}}f=-768}j[e+88>>2]=f&j[b+88>>2];N:{if(!q){break N}h[b+724|0]=k[q+60|0];h[b+736|0]=k[q+80|0];h[b+748|0]=k[q+100|0];O:{if((k[q+100|0]&17)!=17){break O}mb(g+8|0,n,36);if(kb(g+8|0)|k[b+857|0]){break O}h[b+857|0]=127}if(It(q)){A=b,B=nA(q),h[A+857|0]=B}if(!kA(q)){break N}A=b,B=lA(q),h[A+858|0]=B}if(c){break J}if(!d){break H}break I}d=j[b+88>>2]&-6145}j[e+88>>2]=d&-640;if(!c){break I}}j[b+76>>2]=0;j[b+104>>2]=0;break a}if(j[b+76>>2]){break H}c=a+1074308|0;mb(g+8|0,c,54);if(!kb(g+8|0)){mb(g,c,39);if(!kb(g)){break H}}j[b+8>>2]=0;j[b+12>>2]=0}P:{if(k[b+810|0]!=255){break P}mb(g+8|0,a+1074308|0,100);if(!kb(g+8|0)|!w|(r|0)==(w|0)|!(j[a+480208>>2]&4)){break P}c=j[b+104>>2];if(c){j[b+88>>2]=j[b+88>>2]|l[c+34>>1]&1023}j[b+764>>2]=y;j[b+688>>2]=l[o+30>>1];if(!(k[o+34|0]&32)){break a}ls(b,l[o+28>>1],a);break a}j[b+104>>2]=o;j[b+76>>2]=j[o>>2];j[b+80>>2]=j[o+4>>2];j[b+84>>2]=j[o+8>>2];d=a+1074308|0;mb(g+8|0,d,83);if(!(!kb(g+8|0)|j[b+80>>2])){j[b+84>>2]=j[o>>2]}j[b+88>>2]=j[b+88>>2]|l[o+34>>1]&1023;mb(g+8|0,d,21);if(kb(g+8|0)){h[b+838|0]=0;j[b+780>>2]=0}c=b;Q:{R:{if(x){j[b+704>>2]=j[o+24>>2];h[b+872|0]=k[b+872|0]|8;e=0;break R}if(j[a+480180>>2]&5?!(t|u):0){break Q}j[b+704>>2]=j[o+24>>2];e=h[o+37|0]}j[c+768>>2]=e}c=b;if(kp(a)){e=h[o+36|0]}else{e=0}j[c+772>>2]=e;mb(g+8|0,d,69);if(!(kb(g+8|0)|j[a+480180>>2]==1)){j[b+708>>2]=0}j[b+876>>2]=0;n=j[b+88>>2];if(n&8){j[b+80>>2]=j[o+12>>2];j[b+84>>2]=j[o+16>>2];n=n>>>2&4|n|2;j[b+88>>2]=n}S:{if(!(n&2)){n=j[b+76>>2];break S}n=j[b+76>>2];c=j[b+84>>2];if(n>>>0<=c>>>0){break S}j[b+76>>2]=c;n=c}if(!(j[a+480180>>2]&16777248)|m[b+4>>2]<n>>>0){break a}j[b>>2]=0;j[b+4>>2]=0}Za=g+16|0}function J2(a,b,c){var d=0,e=0,f=0,g=0,l=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=q(0),F=0;f=Za-304|0;Za=f;e=k[b|0];a:{if(!e){break a}b:{c:{while(1){d:{e:{if(Jk(e&255)){while(1){e=b;b=b+1|0;if(Jk(k[e+1|0])){continue}break}dh(a,0,0);while(1){b=j[a+4>>2];f:{if(b>>>0<m[a+104>>2]){j[a+4>>2]=b+1;b=k[b|0];break f}b=Jc(a)}if(Jk(b)){continue}break}b=j[a+4>>2];if(j[a+104>>2]){b=b-1|0;j[a+4>>2]=b}d=b-j[a+8>>2]|0;b=d;d=d>>31;l=b;r=r+j[a+124>>2]|0;b=u+j[a+120>>2]|0;r=b>>>0<u>>>0?r+1|0:r;u=l+b|0;r=d+r|0;r=b>>>0>u>>>0?r+1|0:r;break e}g:{h:{i:{e=k[b|0];if((e|0)==37){d=k[b+1|0];if((d|0)==42){break i}if((d|0)!=37){break h}}dh(a,0,0);e=((e|0)==37)+b|0;b=j[a+4>>2];j:{if(b>>>0<m[a+104>>2]){j[a+4>>2]=b+1;b=k[b|0];break j}b=Jc(a)}if((b|0)!=k[e|0]){if(j[a+104>>2]){j[a+4>>2]=j[a+4>>2]-1}A=0;if((b|0)>=0){break a}break c}b=u+1|0;r=b>>>0<1?r+1|0:r;u=b;break e}t=0;e=b+2|0;break g}if(!(!Jg(d)|k[b+2|0]!=36)){t=I2(c,k[b+1|0]-48|0);e=b+3|0;break g}t=j[c>>2];c=c+4|0;e=b+1|0}A=0;b=0;if(Jg(k[e|0])){while(1){b=(k[e|0]+p(b,10)|0)-48|0;d=k[e+1|0];e=e+1|0;if(Jg(d)){continue}break}}d=e;l=k[d|0];k:{if((l|0)!=109){break k}w=0;A=(t|0)!=0;l=k[e+1|0];x=0;d=e+1|0}e=d+1|0;s=3;l:{m:{switch(l-65|0){case 39:l=d+2|0;d=k[d+1|0]==104;e=d?l:e;s=d?-2:-1;break l;case 43:l=d+2|0;d=k[d+1|0]==108;e=d?l:e;s=d?3:1;break l;case 51:case 57:s=1;break l;case 11:s=2;break l;case 41:break l;case 0:case 2:case 4:case 5:case 6:case 18:case 23:case 26:case 32:case 34:case 35:case 36:case 37:case 38:case 40:case 45:case 46:case 47:case 50:case 52:case 55:break m;default:break c}}s=0;e=d}l=k[e|0];d=(l&47)==3;z=d?1:s;y=d?l|32:l;n:{if((y|0)==91){break n}o:{if((y|0)!=110){if((y|0)!=99){break o}b=(b|0)>1?b:1;break n}tD(t,z,u,r);break e}dh(a,0,0);while(1){d=j[a+4>>2];p:{if(d>>>0<m[a+104>>2]){j[a+4>>2]=d+1;d=k[d|0];break p}d=Jc(a)}if(Jk(d)){continue}break}d=j[a+4>>2];if(j[a+104>>2]){d=d-1|0;j[a+4>>2]=d}d=d-j[a+8>>2]|0;l=d;d=d>>31;v=l;g=r+j[a+124>>2]|0;l=u+j[a+120>>2]|0;g=l>>>0<u>>>0?g+1|0:g;r=l;u=v+r|0;d=d+g|0;d=r>>>0>u>>>0?d+1|0:d;r=d}l=b;C=b>>31;dh(a,b,C);d=j[a+104>>2];g=j[a+4>>2];q:{if(d>>>0>g>>>0){j[a+4>>2]=g+1;break q}if((Jc(a)|0)<0){break c}d=j[a+104>>2]}if(d){j[a+4>>2]=j[a+4>>2]-1}d=16;r:{s:{t:{u:{v:{w:{x:{switch(y-88|0){default:b=y-65|0;if(b>>>0>6|!(1<<b&113)){break r};case 9:case 13:case 14:case 15:xD(f,a,z,0);d=j[a+4>>2]-j[a+8>>2]|0;if(j[a+120>>2]==(0-d|0)&j[a+124>>2]==(0-((d>>31)+((d|0)!=0)|0)|0)){break b}if(!t){break r}g=j[f+8>>2];l=j[f+12>>2];d=j[f>>2];b=j[f+4>>2];switch(z|0){case 2:break t;case 1:break u;case 0:break v;default:break r};case 3:case 11:case 27:if((y&239)==99){Ab(f+32|0,-1,257);h[f+32|0]=0;if((y|0)!=115){break s}h[f+65|0]=0;h[f+46|0]=0;i[f+42>>1]=0;i[f+44>>1]=0;break s}v=k[e+1|0];g=(v|0)==94;Ab(f+32|0,g,257);h[f+32|0]=0;d=g?e+2|0:e+1|0;y:{z:{A:{e=k[(g?2:1)+e|0];if((e|0)!=45){if((e|0)==93){break A}s=(v|0)!=94;break y}s=(v|0)!=94;h[f+78|0]=s;break z}s=(v|0)!=94;h[f+126|0]=s}d=d+1|0}e=d;while(1){d=k[e|0];B:{if((d|0)!=45){if(!d){break c}if((d|0)!=93){break B}break s}d=45;v=k[e+1|0];if(!v|(v|0)==93){break B}g=e+1|0;e=k[e-1|0];C:{if(v>>>0<=e>>>0){d=v;break C}while(1){e=e+1|0;h[e+(f+32|0)|0]=s;d=k[g|0];if(e>>>0<d>>>0){continue}break}}e=g}h[(d+f|0)+33|0]=s;e=e+1|0;continue};case 23:d=8;break w;case 12:case 29:d=10;break w;case 1:case 2:case 4:case 5:case 6:case 7:case 8:case 10:case 16:case 18:case 19:case 20:case 21:case 22:case 25:case 26:case 28:case 30:case 31:break r;case 0:case 24:case 32:break w;case 17:break x}}d=0}g=K2(a,d);l=ab;d=j[a+4>>2]-j[a+8>>2]|0;if(j[a+120>>2]==(0-d|0)&j[a+124>>2]==(0-((d>>31)+((d|0)!=0)|0)|0)){break b}if(!(!t|(y|0)!=112)){j[t>>2]=g;break r}tD(t,z,g,l);break r}D=t,E=vD(d,b,g,l),n[D>>2]=E;break r}D=t,F=rv(d,b,g,l),o[D>>3]=F;break r}j[t>>2]=d;j[t+4>>2]=b;j[t+8>>2]=g;j[t+12>>2]=l;break r}y=(y|0)==99;s=y?b+1|0:31;v=(z|0)!=1;D:{if(!v){d=t;if(A){d=Yc(s<<2);if(!d){break d}}j[f+296>>2]=0;j[f+300>>2]=0;b=0;while(1){x=d;E:{while(1){d=j[a+4>>2];F:{if(d>>>0<m[a+104>>2]){j[a+4>>2]=d+1;d=k[d|0];break F}d=Jc(a)}if(!k[(d+f|0)+33|0]){break E}h[f+27|0]=d;d=Un(f+28|0,f+27|0,1,f+296|0);if((d|0)==-2){continue}w=0;if((d|0)==-1){break c}if(x){j[(b<<2)+x>>2]=j[f+28>>2];b=b+1|0}if(!A|(b|0)!=(s|0)){continue}break}s=s<<1|1;d=iq(x,s<<2);if(!d){break c}continue}break}w=0;d=f+296|0;g=1;G:{if(!d){break G}g=!j[d>>2]}if(!g){break c}break D}if(A){b=0;d=Yc(s);if(!d){break d}while(1){w=d;while(1){d=j[a+4>>2];H:{if(d>>>0<m[a+104>>2]){j[a+4>>2]=d+1;d=k[d|0];break H}d=Jc(a)}if(!k[(d+f|0)+33|0]){x=0;break D}h[b+w|0]=d;b=b+1|0;if((s|0)!=(b|0)){continue}break}x=0;s=s<<1|1;d=iq(w,s);if(d){continue}break}break c}b=0;if(t){while(1){d=j[a+4>>2];I:{if(d>>>0<m[a+104>>2]){j[a+4>>2]=d+1;d=k[d|0];break I}d=Jc(a)}if(k[(d+f|0)+33|0]){h[b+t|0]=d;b=b+1|0;continue}else{x=0;w=t;break D}}}while(1){b=j[a+4>>2];J:{if(b>>>0<m[a+104>>2]){j[a+4>>2]=b+1;b=k[b|0];break J}b=Jc(a)}if(k[(b+f|0)+33|0]){continue}break}w=0;x=0;b=0}d=j[a+4>>2];if(j[a+104>>2]){d=d-1|0;j[a+4>>2]=d}d=d-j[a+8>>2]|0;g=d;z=d+j[a+120>>2]|0;d=j[a+124>>2]+(d>>31)|0;d=g>>>0>z>>>0?d+1|0:d;g=z;if(!(d|g)|y&((g|0)!=(l|0)|(d|0)!=(C|0))){break b}K:{if(!A){break K}if(!v){j[t>>2]=x;break K}j[t>>2]=w}if(y){break r}if(x){j[(b<<2)+x>>2]=0}if(!w){w=0;break r}h[b+w|0]=0}d=j[a+4>>2]-j[a+8>>2]|0;b=d;d=d>>31;l=b;r=r+j[a+124>>2]|0;b=u+j[a+120>>2]|0;r=b>>>0<u>>>0?r+1|0:r;u=l+b|0;r=d+r|0;r=b>>>0>u>>>0?r+1|0:r;B=((t|0)!=0)+B|0}b=e+1|0;e=k[e+1|0];if(e){continue}break a}break}w=0;x=0}B=B?B:-1}if(!A){break a}Fb(w);Fb(x)}Za=f+304|0;return B}function I4(a,b,c,d,e,f){a=a|0;b=+b;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,i=0,l=0,m=0,n=0,o=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0;o=Za-560|0;Za=o;j[o+44>>2]=0;RMa(+b);g=OMa(1)|0;OMa(0)|0;a:{if((g|0)<-1?1:(g|0)<=-1){B=1;b=-b;RMa(+b);g=OMa(1)|0;OMa(0)|0;w=55664;break a}B=1;w=55667;if(e&2048){break a}w=55670;if(e&1){break a}B=0;A=1;w=55665}b:{if((g&2146435072)==2146435072){n=B+3|0;of(a,32,c,n,e&-65537);ve(a,w,B);d=f&32;ve(a,b!=b?d?55691:55695:d?55683:55687,3);break b}x=o+16|0;c:{d:{e:{b=zE(b,o+44|0);b=b+b;if(b!=0){g=j[o+44>>2];j[o+44>>2]=g-1;C=f|32;if((C|0)!=97){break e}break c}C=f|32;if((C|0)==97){break c}n=j[o+44>>2];q=(d|0)<0?6:d;break d}n=g-29|0;j[o+44>>2]=n;b=b*268435456;q=(d|0)<0?6:d}t=(n|0)<0?o+48|0:o+336|0;m=t;while(1){d=m;if(b<4294967296&b>=0){g=~~b>>>0}else{g=0}j[d>>2]=g;m=m+4|0;b=(b- +(g>>>0))*1e9;if(b!=0){continue}break}f:{if((n|0)<1){d=n;g=m;i=t;break f}i=t;d=n;while(1){s=(d|0)<29?d:29;g=m-4|0;g:{if(i>>>0>g>>>0){break g}d=s;l=0;while(1){v=g;D=l;E=j[g>>2];u=d&31;if((d&63)>>>0>=32){l=E<<u;E=0}else{l=(1<<u)-1&E>>>32-u;E=E<<u}u=D+E|0;l=l+F|0;l=u>>>0<E>>>0?l+1|0:l;l=KMa(u,l,1e9,0);D=v;v=HMa(l,ab,1e9,0);j[D>>2]=u-v;g=g-4|0;if(i>>>0<=g>>>0){continue}break}if(!l){break g}i=i-4|0;j[i>>2]=l}while(1){g=m;if(i>>>0<g>>>0){m=g-4|0;if(!j[m>>2]){continue}}break}d=j[o+44>>2]-s|0;j[o+44>>2]=d;m=g;if((d|0)>0){continue}break}}if((d|0)<=-1){y=((q+25|0)/9|0)+1|0;s=(C|0)==102;while(1){l=(d|0)<-9?9:0-d|0;h:{if(g>>>0<=i>>>0){i=j[i>>2]?i:i+4|0;break h}v=1e9>>>l|0;u=-1<<l^-1;d=0;m=i;while(1){D=d;d=j[m>>2];j[m>>2]=D+(d>>>l|0);d=p(v,d&u);m=m+4|0;if(m>>>0<g>>>0){continue}break}i=j[i>>2]?i:i+4|0;if(!d){break h}j[g>>2]=d;g=g+4|0}d=j[o+44>>2]+l|0;j[o+44>>2]=d;m=s?t:i;g=g-m>>2>(y|0)?m+(y<<2)|0:g;if((d|0)<0){continue}break}}m=0;i:{if(g>>>0<=i>>>0){break i}m=p(t-i>>2,9);d=10;l=j[i>>2];if(l>>>0<10){break i}while(1){m=m+1|0;d=p(d,10);if(l>>>0>=d>>>0){continue}break}}d=(q-((C|0)==102?0:m)|0)-((C|0)==103&(q|0)!=0)|0;if((d|0)<(p(g-t>>2,9)-9|0)){l=d+9216|0;s=(l|0)/9|0;n=((s<<2)+((n|0)<0?o+48|4:o+340|0)|0)-4096|0;d=10;l=l-p(s,9)|0;if((l|0)<=7){while(1){d=p(d,10);l=l+1|0;if((l|0)!=8){continue}break}}s=j[n>>2];v=(s>>>0)/(d>>>0)|0;y=n+4|0;l=s-p(d,v)|0;j:{if(l?0:(y|0)==(g|0)){break j}u=d>>>1|0;z=l>>>0<u>>>0?.5:(g|0)==(y|0)?(u|0)==(l|0)?1:1.5:1.5;b=v&1?9007199254740994:9007199254740992;if(!(k[w|0]!=45|A)){z=-z;b=-b}l=s-l|0;j[n>>2]=l;if(b+z==b){break j}d=d+l|0;j[n>>2]=d;if(d>>>0>=1e9){while(1){j[n>>2]=0;n=n-4|0;if(n>>>0<i>>>0){i=i-4|0;j[i>>2]=0}d=j[n>>2]+1|0;j[n>>2]=d;if(d>>>0>999999999){continue}break}}m=p(t-i>>2,9);d=10;l=j[i>>2];if(l>>>0<10){break j}while(1){m=m+1|0;d=p(d,10);if(l>>>0>=d>>>0){continue}break}}d=n+4|0;g=d>>>0<g>>>0?d:g}while(1){d=g;n=g>>>0<=i>>>0;if(!n){g=d-4|0;if(!j[g>>2]){continue}}break}k:{if((C|0)!=103){A=e&8;break k}g=q?q:1;l=(g|0)>(m|0)&(m|0)>-5;q=(l?m^-1:-1)+g|0;f=(l?-1:-2)+f|0;A=e&8;if(A){break k}g=-9;l:{if(n){break l}s=j[d-4>>2];if(!s){break l}l=10;g=0;if((s>>>0)%10|0){break l}while(1){n=g;g=g+1|0;l=p(l,10);if(!((s>>>0)%(l>>>0)|0)){continue}break}g=n^-1}n=p(d-t>>2,9);if((f&-33)==70){A=0;g=(g+n|0)-9|0;g=(g|0)>0?g:0;q=(g|0)>(q|0)?q:g;break k}A=0;g=((m+n|0)+g|0)-9|0;g=(g|0)>0?g:0;q=(g|0)>(q|0)?q:g}s=q|A;v=(s|0)!=0;D=a;l=c;u=f&-33;g=(m|0)>0?m:0;m:{if((u|0)==70){break m}g=m>>31;g=im(g+m^g,0,x);if((x-g|0)<=1){while(1){g=g-1|0;h[g|0]=48;if((x-g|0)<2){continue}break}}y=g-2|0;h[y|0]=f;h[g-1|0]=(m|0)<0?45:43;g=x-y|0}n=(g+(v+(q+B|0)|0)|0)+1|0;of(D,32,l,n,e);ve(a,w,B);of(a,48,c,n,e^65536);n:{o:{p:{if((u|0)==70){f=o+16|8;m=o+16|9;l=i>>>0>t>>>0?t:i;i=l;while(1){g=im(j[i>>2],0,m);q:{if((i|0)!=(l|0)){if(o+16>>>0>=g>>>0){break q}while(1){g=g-1|0;h[g|0]=48;if(o+16>>>0<g>>>0){continue}break}break q}if((g|0)!=(m|0)){break q}h[o+24|0]=48;g=f}ve(a,g,m-g|0);i=i+4|0;if(t>>>0>=i>>>0){continue}break}if(s){ve(a,55699,1)}if((q|0)<1|d>>>0<=i>>>0){break p}while(1){g=im(j[i>>2],0,m);if(g>>>0>o+16>>>0){while(1){g=g-1|0;h[g|0]=48;if(o+16>>>0<g>>>0){continue}break}}ve(a,g,(q|0)<9?q:9);g=q-9|0;i=i+4|0;if(d>>>0<=i>>>0){break o}f=(q|0)>9;q=g;if(f){continue}break}break o}r:{if((q|0)<0){break r}t=d>>>0>i>>>0?d:i+4|0;d=o+16|8;f=o+16|9;m=i;while(1){g=im(j[m>>2],0,f);if((f|0)==(g|0)){h[o+24|0]=48;g=d}s:{if((i|0)!=(m|0)){if(o+16>>>0>=g>>>0){break s}while(1){g=g-1|0;h[g|0]=48;if(o+16>>>0<g>>>0){continue}break}break s}ve(a,g,1);g=g+1|0;if((q|0)<1?!A:0){break s}ve(a,55699,1)}v=g;g=f-g|0;ve(a,v,(g|0)<(q|0)?g:q);q=q-g|0;m=m+4|0;if(t>>>0<=m>>>0){break r}if((q|0)>-1){continue}break}}of(a,48,q+18|0,18,0);ve(a,y,x-y|0);break n}g=q}of(a,48,g+9|0,9,0)}break b}n=f&32;q=n?w+9|0:w;t:{if(d>>>0>11){break t}g=12-d|0;if(!g){break t}z=8;while(1){z=z*16;g=g-1|0;if(g){continue}break}if(k[q|0]==45){b=-(z+(-b-z));break t}b=b+z-z}i=j[o+44>>2];g=i>>31;g=im(g^g+i,0,x);if((x|0)==(g|0)){h[o+15|0]=48;g=o+15|0}t=B|2;i=j[o+44>>2];m=g-2|0;h[m|0]=f+15;h[g-1|0]=(i|0)<0?45:43;l=e&8;i=o+16|0;while(1){f=i;v=i;i=n;if(r(b)<2147483648){g=~~b}else{g=-2147483648}h[v|0]=i|k[g+55648|0];i=f+1|0;b=(b- +(g|0))*16;if(!((i-(o+16|0)|0)!=1|(b==0?!(l|(d|0)>0):0))){h[f+1|0]=46;i=f+2|0}if(b!=0){continue}break}d=!d|((i-o|0)-18|0)>=(d|0)?((x-(o+16|0)|0)-m|0)+i|0:((d+x|0)-m|0)+2|0;n=d+t|0;of(a,32,c,n,e);ve(a,q,t);of(a,48,c,n,e^65536);f=i-(o+16|0)|0;ve(a,o+16|0,f);g=d;d=x-m|0;of(a,48,g-(d+f|0)|0,0,0);ve(a,m,d)}of(a,32,c,n,e^8192);Za=o+560|0;return((c|0)>(n|0)?c:n)|0}function lla(a){a=a|0;var b=0,c=0,d=0,e=0,f=0,g=0,i=0,n=0,o=0,q=0,r=0;e=Za-48|0;Za=e;d=a+1074304|0;if(!(j[d>>2]==18284544|m[a+1074304>>2]>=18285126)){rg(a+1074308|0,0)}f=a+1074308|0;mb(e+32|0,f,0);if(kb(e+32|0)){i=(j[a+480180>>2]&16777248)!=0}mb(e+32|0,f,0);if(kb(e+32|0)){o=j[a+480180>>2]==4}if(m[d>>2]<18874368){a:{if(!l[a+480192>>1]){break a}c=1;while(1){b:{b=j[(((c&65535)<<2)+a|0)+900380>>2];if(!b){break b}j[e+32>>2]=p(k[b+20|0],100)>>>6;j[e+16>>2]=100;q=b,r=j[tb(e+32|0,e+16|0)>>2],h[q+20|0]=r;c:{d:{if(i){if(m[d>>2]<18350080){g=h[b+26|0];h[b+26|0]=(((g|0)>-1?1:-1)+g|0)/2}if(m[d>>2]<18285314){break d}break c}g=h[b+26|0];h[b+26|0]=(((g|0)>-1?1:-1)+g|0)/2}yM(Dt(b,2),4,j[a+480180>>2])}e:{if(!k[b+34|0]|(m[d>>2]<18284544|m[d>>2]>=18285136)){break e}if(!ai(b)){break e}vb(f,2,1)}if(!(k[b+24|0]|(k[b+23|0]|(k[b+19|0]|k[b+20|0])))|m[d>>2]>=18285136){break b}vb(f,1,1);break a}c=c+1|0;if(l[a+480192>>1]>=(c&65535)>>>0){continue}break}}if(!(!l[a+480190>>1]|(!(j[a+480180>>2]&16777248)|m[d>>2]>=18285314&i))){b=1;while(1){c=p(b&65535,104)+a|0;g=c+484419|0;if(!(k[g|0]|!(k[c+484421|0]|k[c+484420|0]))){h[g|0]=255}b=b+1|0;if(l[a+480190>>1]>=(b&65535)>>>0){continue}break}}iwa(a+901404|0)}f:{if(j[d>>2]==18874368|m[d>>2]>=18874896|(!(j[a+480180>>2]&16777252)|!l[a+480192>>1])){break f}b=1;c=0;while(1){g:{g=j[(((b&65535)<<2)+a|0)+900380>>2];if(!(k[g+31|0]?g:0)){b=b+1|0;if(l[a+480192>>1]>=(b&65535)>>>0){continue}if(c){break g}break f}h[g+33|0]=13;c=1;b=b+1|0;if(l[a+480192>>1]>=(b&65535)>>>0){continue}}break}vb(f,3,1)}h:{if(!(j[a+480180>>2]&16777248)|(j[d>>2]==19005440|m[d>>2]>=19006226)){break h}mb(e+32|0,f,0);if(!kb(e+32|0)){mb(e+16|0,f,1);if(!kb(e+16|0)){break h}}if(!l[a+480192>>1]){break h}b=1;while(1){c=j[(((b&65535)<<2)+a|0)+900380>>2];if(!(!c|!k[c+19|0]|!(h[c+80|0]&1))){h[c+19|0]=0}b=b+1|0;if(l[a+480192>>1]>=(b&65535)>>>0){continue}break}}i:{j:{k:{if(m[d>>2]<19007233){c=a+946300|0;b=a+906300|0;while(1){g=b+80|0;kla(e+16|0,g);j[114630]=0;L(438,e+32|0,0,7,e+16|0);n=j[114630];j[114630]=0;if((n|0)==1){break j}gb(e+16|0);j[114630]=0;E(506,g|0,e+32|0)|0;g=j[114630];j[114630]=0;if((g|0)==1){break k}gb(e+32|0);b=b+160|0;if((c|0)!=(b|0)){continue}break}}if(!(j[a+480180>>2]!=4|m[d>>2]<19007257|(j[a+1074368>>2]!=4|m[d>>2]>=19071236))){dx(a,5)}if(!(!l[a+480192>>1]|(j[d>>2]==19202048|m[d>>2]>=19202055))){c=1;while(1){n=(((c&65535)<<2)+a|0)+900380|0;b=j[n>>2];l:{if(!b|!k[b+20|0]|!k[b+31|0]){break l}b=b+236|0;g=ps(b);if((b|0)!=(g|0)){while(1){if(l[b>>1]){break l}b=b+2|0;if((g|0)!=(b|0)){continue}break}}h[j[n>>2]+20|0]=0}c=c+1|0;if(l[a+480192>>1]>=(c&65535)>>>0){continue}break}}if(!(!l[a+480192>>1]|m[d>>2]>=19267584)){c=1;while(1){b=j[(((c&65535)<<2)+a|0)+900380>>2];m:{if(!b){break m}g=h[b+26|0];h[b+26|0]=(((g|0)>-1?1:-1)+g|0)/2;if(m[d>>2]>=18350080?i:0){break m}h[b+19|0]=k[b+19|0]+3>>>2}c=c+1|0;if(l[a+480192>>1]>=(c&65535)>>>0){continue}break}}n:{if(!l[a+480192>>1]|m[d>>2]>=19398674){break n}b=1;while(1){c=j[(((b&65535)<<2)+a|0)+900380>>2];if(!(!c|k[c+65|0]==255)){vb(f,94,1);break n}b=b+1|0;if(l[a+480192>>1]>=(b&65535)>>>0){continue}break}}o:{if(!l[a+480192>>1]|m[d>>2]>=19399428){break o}b=1;while(1){c=j[(((b&65535)<<2)+a|0)+900380>>2];if(!(!c|k[c+36|0]>1)){vb(f,101,1);break o}b=b+1|0;if(l[a+480192>>1]>=(b&65535)>>>0){continue}break}}b=jla(e+8|0,a);c=j[b+4>>2];j[e>>2]=j[b>>2];j[e+4>>2]=c;ila(e+32|0,a+484344|0,e);p:{q:{if(!i){break q}b=j[d>>2];if(b>>>0>=19267584){break q}vb(f,8,(b|0)==18284544|b>>>0>18285313);b=30904;while(1){c=j[d>>2];i=j[b+4>>2];vb(f,j[b>>2],c>>>0>=i>>>0|(c|0)==(i&-65536));b=b+8|0;if((b|0)!=31240){continue}break}break p}if(!o){break p}b=j[d>>2];if(b>>>0>=19267584){break p}vb(f,8,b>>>0>18285313);b=31256;while(1){vb(f,j[b>>2],m[d>>2]>=m[b+4>>2]);b=b+8|0;if((b|0)!=31488){continue}break}}r:{if(j[a+480180>>2]&16777248){b=31488;while(1){c=j[d>>2];i=j[b+4>>2];g=i&-65536;if(!(c>>>0<=g>>>0|c>>>0>=i>>>0?c>>>0>=g>>>0:0)){rg(f,j[b>>2])}b=b+8|0;if((b|0)!=31536){continue}break}break r}if(j[a+480180>>2]==4){b=31536;while(1){if(m[d>>2]<m[b+4>>2]){rg(f,j[b>>2])}b=b+8|0;if((b|0)!=31592){continue}break}break r}if(j[a+480180>>2]!=2){break r}b=31600;while(1){if(m[d>>2]<m[b+4>>2]){rg(f,j[b>>2])}b=b+8|0;if((b|0)!=31680){continue}break}}if(!(j[a+480180>>2]!=4|m[d>>2]>=18415616)){vb(f,98,1)}if(!(m[d>>2]<19333159|m[d>>2]>=19333193)){b=0;while(1){c=b+77|0;mb(e+32|0,f,c);vb(f,b+86|0,kb(e+32|0));rg(f,c);b=b+1|0;if((b|0)!=5){continue}break}}s:{if(m[d>>2]<18284544){vb(f,8,1);break s}if(m[d>>2]<18284544|m[d>>2]>18874627|j[d>>2]==18874368){break s}vb(f,6,1)}t:{if(m[d>>2]<19136512){rg(f,7);break t}if(!(j[a+480180>>2]&16777248)|(m[d>>2]<19136512|m[d>>2]>=19267584)){break t}vb(f,7,1)}mb(e+32|0,f,31);u:{if(!kb(e+32|0)|m[d>>2]<19071234|(!l[a+480192>>1]|m[d>>2]>=19398723)){break u}b=1;while(1){v:{c=j[(((b&65535)<<2)+a|0)+900380>>2];if(!c){break v}i=k[c+65|0];if(!(k[c+60|0]&4)|(i|0)==255|i>>>0<=k[c- -64|0]){break v}vb(f,97,1);break u}b=b+1|0;if(l[a+480192>>1]>=(b&65535)>>>0){continue}break}}w:{if(!l[a+480192>>1]|j[a+480180>>2]!=16777216|(m[d>>2]<19398688|m[d>>2]>19485952)){break w}if(!l[a+480190>>1]){break w}b=1;while(1){if(!(k[(p(b&65535,104)+a|0)+484415|0]&2)){b=b+1|0;if(l[a+480190>>1]>=(b&65535)>>>0){continue}break w}break}vb(f,109,1)}Za=e+48|0;return}a=D()|0;C()|0;gb(e+32|0);break i}a=D()|0;C()|0;gb(e+16|0)}G(a|0);z()}function gBa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,m=0,n=0,o=0,q=0;d=Za-224|0;Za=d;rc(b);a:{b:{c:{d:{e:{f:{if(!$s(b,d+208|0)){break f}if(!DO(d+208|0)){break f}m=zh(d+192|0);n=Qc(d+176|0);Ab(d+112|0,0,64);j[114630]=0;f=E(885,b|0,d+104|0)|0;e=j[114630];j[114630]=0;if((e|0)==1){break c}g:{if(!f){break g}f=d+104|4;g=k[f|0]|k[f+1|0]<<8|(k[f+2|0]<<16|k[f+3|0]<<24);g=(g<<8&16711680|g<<24|(g>>>8&65280|g>>>24))-4|0;g=g<<24|g<<8&16711680|(g>>>8&65280|g>>>24);h[f|0]=g;h[f+1|0]=g>>>8;h[f+2|0]=g>>>16;h[f+3|0]=g>>>24;g=0;h:{i:{j:{while(1){e=k[f|0]|k[f+1|0]<<8|(k[f+2|0]<<16|k[f+3|0]<<24);e=(e<<8&16711680|e<<24|(e>>>8&65280|e>>>24))-8|0;e=e<<24|e<<8&16711680|(e>>>8&65280|e>>>24);h[f|0]=e;h[f+1|0]=e>>>8;h[f+2|0]=e>>>16;h[f+3|0]=e>>>24;k:{if(c){break k}e=d+104|0;if((k[e|0]|k[e+1|0]<<8|(k[e+2|0]<<16|k[e+3|0]<<24))!=1413764176){break k}g=1;break g}e=k[f|0]|k[f+1|0]<<8|(k[f+2|0]<<16|k[f+3|0]<<24);j[114630]=0;I(341,d+24|0,b|0,e<<8&16711680|e<<24|(e>>>8&65280|e>>>24));e=j[114630];j[114630]=0;l:{m:{n:{o:{p:{if((e|0)!=1){j[114630]=0;e=H(337,d+24|0)|0;o=j[114630];j[114630]=0;if((o|0)==1){break o}if(e){break p}jb(d+24|0);break l}a=D()|0;C()|0;break a}e=d+104|0;e=k[e|0]|k[e+1|0]<<8|(k[e+2|0]<<16|k[e+3|0]<<24);e=e<<24|e<<8&16711680|(e>>>8&65280|e>>>24);if((e|0)<=1347699795){if((e|0)==1129139796){break n}if((e|0)!=1229866575){break m}j[114630]=0;q=E(886,d+24|0,d+112|0)|0;e=j[114630];j[114630]=0;if((e|0)==1){break o}break m}if((e|0)!=1347699796){if((e|0)!=1447383635){break m}j[114630]=0;E(338,d+24|0,4)|0;e=j[114630];j[114630]=0;if((e|0)==1){break o}j[114630]=0;e=E(887,d+24|0,16119)|0;o=j[114630];j[114630]=0;if((o|0)==1){break o}if(!e){break m}e=k[f|0]|k[f+1|0]<<8|(k[f+2|0]<<16|k[f+3|0]<<24);if((e<<24|e<<8&16711680|(e>>>8&65280|e>>>24))>>>0<7){break m}e=k[f|0]|k[f+1|0]<<8|(k[f+2|0]<<16|k[f+3|0]<<24);j[114630]=0;P(888,d+24|0,n|0,2,(e<<8&16711680|e<<24|(e>>>8&65280|e>>>24))-6|0)|0;e=j[114630];j[114630]=0;if((e|0)==1){break o}break m}j[114630]=0;g=K(889,a|0,d+24|0,c|0)|0;e=j[114630];j[114630]=0;if((e|0)!=1){break m}}a=D()|0;C()|0;jb(d+24|0);break a}CO(m,d+24|0)}jb(d+24|0);j[114630]=0;e=E(885,b|0,d+104|0)|0;o=j[114630];j[114630]=0;if((o|0)==1){break j}if(e){continue}}break}if(Ec(n)){j[114630]=0;b=E(2,d+24|0,16122)|0;c=j[114630];j[114630]=0;if((c|0)==1){break i}ob(n,b);gb(b)}if(!(g&q&1)){break h}b=d+154|0;b=k[b|0]|k[b+1|0]<<8;j[114630]=0;f=b&1;K(478,a+1074308|0,5,!f|0)|0;b=j[114630];j[114630]=0;q:{r:{s:{if((b|0)!=1){b=d+150|0;if(k[b|0]|k[b+1|0]<<8){i[d+24>>1]=64;b=k[b|0]|k[b+1|0]<<8;j[114630]=0;i[d+88>>1]=b<<8|b>>>8;b=E(477,d+24|0,d+88|0)|0;c=j[114630];j[114630]=0;if((c|0)==1){break s}j[a+480228>>2]=l[b>>1]}b=d+152|0;if(!(!f|!(k[b|0]|k[b+1|0]<<8))){b=k[b|0]|k[b+1|0]<<8;j[a+480204>>2]=p((b<<8|b>>>8)&65535,1e4)}if(k[d+112|0]){j[114630]=0;I(745,d+88|0,2,d+112|0);b=j[114630];j[114630]=0;if((b|0)==1){break r}j[114630]=0;F(415,d+24|0,d+88|0);b=j[114630];j[114630]=0;if((b|0)==1){break r}ob(a+1304400|0,d+24|0);gb(d+24|0)}b=l[d+158>>1];i[d+86>>1]=b;i[d+22>>1]=b;if(!Zo(d+22|0,1,12)){break h}b=l[d+156>>1];i[d+84>>1]=b;i[d+20>>1]=b;if(!Zo(d+20|0,1,31)){break h}b=l[d+162>>1];i[d+82>>1]=b;i[d+18>>1]=b;if(!Zo(d+18|0,0,23)){break h}b=l[d+164>>1];i[d+80>>1]=b;i[d+16>>1]=b;if(!Zo(d+16|0,0,59)){break h}b=l[d+166>>1];i[d+78>>1]=b;i[d+14>>1]=b;if(Zo(d+14|0,0,59)){break q}break h}a=D()|0;C()|0;break a}a=D()|0;C()|0;break a}a=D()|0;C()|0;break a}b=qp(d+24|0);c=d+160|0;c=k[c|0]|k[c+1|0]<<8;j[b+20>>2]=(c<<8|c>>>8)&65535;c=d+158|0;c=k[c|0]|k[c+1|0]<<8;j[b+16>>2]=((c<<8|c>>>8)&65535)-1;c=d+156|0;c=k[c|0]|k[c+1|0]<<8;j[b+12>>2]=(c<<8|c>>>8)&65535;c=d+162|0;c=k[c|0]|k[c+1|0]<<8;j[b+8>>2]=(c<<8|c>>>8)&65535;c=d+164|0;c=k[c|0]|k[c+1|0]<<8;j[b+4>>2]=(c<<8|c>>>8)&65535;c=d+166|0;c=k[c|0]|k[c+1|0]<<8;j[b>>2]=(c<<8|c>>>8)&65535;j[114630]=0;F(662,a+1304500|0,b|0);b=j[114630];j[114630]=0;if((b|0)!=1){break h}a=D()|0;C()|0;break a}a=D()|0;C()|0;break a}a=D()|0;C()|0;break a}if(g&1){j[114630]=0;b=H(337,m|0)|0;c=j[114630];j[114630]=0;if((c|0)==1){break c}if(b){b=Cb(d+24|0);j[114630]=0;K(481,m|0,b|0,32)|0;c=j[114630];j[114630]=0;if((c|0)==1){break b}if(Xs(b,16126)){j[114630]=0;I(13,d+88|0,2,b|0);c=j[114630];j[114630]=0;if((c|0)==1){break b}ob(a+1304412|0,d+88|0);gb(d+88|0)}j[114630]=0;c=H(890,m|0)|0;f=j[114630];j[114630]=0;if((f|0)==1){break b}if(!c){j[114630]=0;c=H(540,m|0)|0;f=j[114630];j[114630]=0;if((f|0)==1){break b}j[114630]=0;U(547,a+1304424|0,m|0,c|0,40,0)|0;c=j[114630];j[114630]=0;if((c|0)==1){break b}}gb(b)}j[114630]=0;b=E(2,d+88|0,16141)|0;c=j[114630];j[114630]=0;if((c|0)==1){break e}j[114630]=0;I(720,d+24|0,b|0,n|0);c=j[114630];j[114630]=0;if((c|0)==1){break d}ob(a+1304460|0,d+24|0);gb(d+24|0);gb(b)}j[a+480208>>2]=j[a+480208>>2]|2097152;j[114630]=0;a=a+1074308|0;K(478,a|0,84,1)|0;b=j[114630];j[114630]=0;if((b|0)==1){break c}j[114630]=0;K(478,a|0,83,1)|0;b=j[114630];j[114630]=0;if((b|0)==1){break c}j[114630]=0;K(478,a|0,85,1)|0;a=j[114630];j[114630]=0;if((a|0)==1){break c}}gb(n);jb(m)}Za=d+224|0;return g&1}a=D()|0;C()|0;break a}a=D()|0;C()|0;gb(b);break a}a=D()|0;C()|0;break a}a=D()|0;C()|0;gb(b)}gb(n);jb(m);G(a|0);z()}function mG(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,l=0;e=Za-448|0;Za=e;a:{if(Ri(b)){break a}g=k[Fj(b)|0];f=1;b:{if((g|0)==33){break b}if((g|0)!=63){break a}f=0}d=f;Qj(e+184|0,b,j[b+4>>2]-1|0);f=j[e+188>>2];j[b>>2]=j[e+184>>2];j[b+4>>2]=f}ld(e+184|0);f=j[e+184>>2];ld(e+416|0);h=Ej(f,j[e+420>>2],b);ld(e+184|0);f=j[b>>2];g=j[b+4>>2];c:{d:{e:{f:{if((h|0)==j[e+188>>2]){j[e+440>>2]=f;j[e+444>>2]=g;a=_b(e+432|0,38235);f=j[e+444>>2];j[e+16>>2]=j[e+440>>2];j[e+20>>2]=f;f=j[a+4>>2];j[e+8>>2]=j[a>>2];j[e+12>>2]=f;if(nc(e+16|0,e+8|0)){a=R(8)|0;j[114630]=0;d=E(2136,e+416|0,c|0)|0;b=j[114630];j[114630]=0;g:{h:{i:{if((b|0)!=1){j[114630]=0;I(2113,e+184|0,39307,d|0);b=j[114630];j[114630]=0;if((b|0)==1){break i}Wb(a,e+184|0);c=0;j[114630]=0;I(2004,a|0,83648,2012);b=j[114630];j[114630]=0;if((b|0)!=1){break c}b=D()|0;C()|0;gb(e+184|0);break h}b=D()|0;C()|0;break g}b=D()|0;c=1;C()|0}gb(d);if(!c){break d}}S(a|0);break d}if(!d){break f}d=R(8)|0;j[114630]=0;f=E(2136,e+384|0,b|0)|0;b=j[114630];j[114630]=0;a=1;j:{k:{l:{m:{n:{o:{p:{q:{r:{if((b|0)!=1){j[114630]=0;I(2113,e+400|0,39186,f|0);a=j[114630];j[114630]=0;if((a|0)==1){break r}j[114630]=0;I(2131,e+416|0,e+400|0,39322);b=j[114630];j[114630]=0;a=1;if((b|0)==1){break q}j[114630]=0;c=E(2136,e+368|0,c|0)|0;a=j[114630];j[114630]=0;if((a|0)==1){break p}j[114630]=0;I(138,e+184|0,e+416|0,c|0);b=j[114630];j[114630]=0;a=1;if((b|0)==1){break o}Wb(d,e+184|0);j[114630]=0;I(2004,d|0,83648,2012);a=j[114630];j[114630]=0;if((a|0)!=1){break c}b=D()|0;C()|0;gb(e+184|0);a=0;break n}b=D()|0;C()|0;break j}b=D()|0;a=1;C()|0;break k}b=D()|0;C()|0;break l}b=D()|0;a=1;C()|0;break m}b=D()|0;C()|0}gb(c)}gb(e+416|0)}gb(e+400|0)}gb(f)}if(!a){break d}S(d|0);break d}j[e+360>>2]=f;j[e+364>>2]=g;d=_b(e+352|0,38235);f=j[e+364>>2];j[e+176>>2]=j[e+360>>2];j[e+180>>2]=f;f=j[d+4>>2];j[e+168>>2]=j[d>>2];j[e+172>>2]=f;if(nc(e+176|0,e+168|0)){a=R(8)|0;j[114630]=0;d=E(2136,e+416|0,c|0)|0;b=j[114630];j[114630]=0;s:{t:{u:{if((b|0)!=1){j[114630]=0;I(2113,e+184|0,39307,d|0);b=j[114630];j[114630]=0;if((b|0)==1){break u}Wb(a,e+184|0);c=0;j[114630]=0;I(2004,a|0,83648,2012);b=j[114630];j[114630]=0;if((b|0)!=1){break c}b=D()|0;C()|0;gb(e+184|0);break t}b=D()|0;C()|0;break s}b=D()|0;c=1;C()|0}gb(d);if(!c){break d}}S(a|0);break d}d=j[b+4>>2];j[e+344>>2]=j[b>>2];j[e+348>>2]=d;d=_b(e+336|0,39065);f=j[e+348>>2];j[e+160>>2]=j[e+344>>2];j[e+164>>2]=f;f=j[d+4>>2];j[e+152>>2]=j[d>>2];j[e+156>>2]=f;if(nc(e+160|0,e+152|0)){b=j[c+4>>2];j[e+328>>2]=j[c>>2];j[e+332>>2]=b;b=_b(e+320|0,39258);d=j[e+332>>2];j[e+64>>2]=j[e+328>>2];j[e+68>>2]=d;d=j[b+4>>2];j[e+56>>2]=j[b>>2];j[e+60>>2]=d;if(nc(e- -64|0,e+56|0)){j[a+52>>2]=0;break f}b=j[c+4>>2];j[e+312>>2]=j[c>>2];j[e+316>>2]=b;b=_b(e+304|0,39266);d=j[e+316>>2];j[e+48>>2]=j[e+312>>2];j[e+52>>2]=d;d=j[b+4>>2];j[e+40>>2]=j[b>>2];j[e+44>>2]=d;if(nc(e+48|0,e+40|0)){j[a+52>>2]=1;break f}b=j[c+4>>2];j[e+296>>2]=j[c>>2];j[e+300>>2]=b;b=_b(e+288|0,39275);d=j[e+300>>2];j[e+32>>2]=j[e+296>>2];j[e+36>>2]=d;d=j[b+4>>2];j[e+24>>2]=j[b>>2];j[e+28>>2]=d;if(nc(e+32|0,e+24|0)){j[a+52>>2]=2;break f}a=R(8)|0;j[114630]=0;d=E(2136,e+416|0,c|0)|0;b=j[114630];j[114630]=0;v:{w:{x:{if((b|0)!=1){j[114630]=0;I(2113,e+184|0,39369,d|0);b=j[114630];j[114630]=0;if((b|0)==1){break x}Wb(a,e+184|0);c=0;j[114630]=0;I(2004,a|0,83648,2012);b=j[114630];j[114630]=0;if((b|0)!=1){break c}b=D()|0;C()|0;gb(e+184|0);break w}b=D()|0;C()|0;break v}b=D()|0;c=1;C()|0}gb(d);if(!c){break d}}S(a|0);break d}d=j[b+4>>2];j[e+280>>2]=j[b>>2];j[e+284>>2]=d;b=_b(e+272|0,39108);d=j[e+284>>2];j[e+144>>2]=j[e+280>>2];j[e+148>>2]=d;d=j[b+4>>2];j[e+136>>2]=j[b>>2];j[e+140>>2]=d;if(!nc(e+144|0,e+136|0)){break f}b=j[c+4>>2];j[e+264>>2]=j[c>>2];j[e+268>>2]=b;b=_b(e+256|0,39280);d=j[e+268>>2];j[e+128>>2]=j[e+264>>2];j[e+132>>2]=d;d=j[b+4>>2];j[e+120>>2]=j[b>>2];j[e+124>>2]=d;b=0;y:{if(nc(e+128|0,e+120|0)){break y}b=j[c+4>>2];j[e+248>>2]=j[c>>2];j[e+252>>2]=b;b=_b(e+240|0,39285);d=j[e+252>>2];j[e+112>>2]=j[e+248>>2];j[e+116>>2]=d;d=j[b+4>>2];j[e+104>>2]=j[b>>2];j[e+108>>2]=d;b=1;if(nc(e+112|0,e+104|0)){break y}b=j[c+4>>2];j[e+232>>2]=j[c>>2];j[e+236>>2]=b;b=_b(e+224|0,39291);d=j[e+236>>2];j[e+96>>2]=j[e+232>>2];j[e+100>>2]=d;d=j[b+4>>2];j[e+88>>2]=j[b>>2];j[e+92>>2]=d;b=2;if(nc(e+96|0,e+88|0)){break y}b=j[c+4>>2];j[e+216>>2]=j[c>>2];j[e+220>>2]=b;b=_b(e+208|0,39302);c=j[e+220>>2];j[e+80>>2]=j[e+216>>2];j[e+84>>2]=c;c=j[b+4>>2];j[e+72>>2]=j[b>>2];j[e+76>>2]=c;b=3;if(nc(e+80|0,e+72|0)){break y}a=R(8)|0;j[114630]=0;c=E(85,e+184|0,39394)|0;b=j[114630];j[114630]=0;if((b|0)==1){break e}Wb(a,c);j[114630]=0;I(2004,a|0,83648,2012);a=j[114630];j[114630]=0;if((a|0)!=1){break c}b=D()|0;C()|0;gb(c);break d}j[a+56>>2]=b;b=a+24|0;if(!j[j[b>>2]+24668>>2]){break f}c=j[b>>2];d=c+24664|0;f=j[d+4>>2];j[e+200>>2]=j[d>>2];j[e+204>>2]=f;d=c+24656|0;f=j[d+4>>2];j[e+192>>2]=j[d>>2];j[e+196>>2]=f;d=j[c+24652>>2];j[e+184>>2]=j[c+24648>>2];j[e+188>>2]=d;i=e,l=TF(j[a+56>>2]),j[i+204>>2]=l;if(!aw(e+184|0,j[b>>2]+24648|0)){break f}Vw(j[b>>2],e+184|0)}Za=e+448|0;return}b=D()|0;C()|0;S(a|0)}G(b|0)}z()}function oBa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;d=Za-1824|0;Za=d;rc(b);f=d+1224|0;e=TAa(b,f);if(!e){xO(f)}a:{if(!e){break a}if(!GO(d+1224|0)){break a}if(!ty(b,16,0)){break a}j[d+1216>>2]=j[d+1240>>2];f=j[d+1228>>2];j[d+1200>>2]=j[d+1224>>2];j[d+1204>>2]=f;f=d+1232|0;e=j[f+4>>2];j[d+1208>>2]=j[f>>2];j[d+1212>>2]=e;od(a,1);f=a+1074308|0;rg(f,83);vb(f,84,1);vb(f,85,1);i[a+480188>>1]=4;j[d+1196>>2]=0;i[a+480190>>1]=15;xc(b,20);s=a+480188|0;g=1;r=1;f=0;while(1){m=p(g,104)+a|0;o=m+484380|0;e=((g<<5)+a|0)+946300|0;vy(b,d+16|0,o,e,1);n=j[o>>2];b:{if(!k[Pb(e,0)|0]){break b}c:{if(_c(e,15730,3)){if(_c(e,15734,3)){break c}}if(k[Pb(e,5)|0]==58){break b}}r=0}e=k[d+44|0]|k[d+45|0]<<8;if(((e<<8|e>>>8)&65535)>>>0>=2){e=k[d+42|0]|k[d+43|0]<<8;j[m+484384>>2]=(e<<8|e>>>8)&65535;e=k[d+42|0]|k[d+43|0]<<8;q=(e<<8|e>>>8)&65535;e=k[d+44|0]|k[d+45|0]<<8;j[m+484388>>2]=q+(((e<<8|e>>>8)&65535)<<1);Rm(o)}e=k[d+38|0]|k[d+39|0]<<8;d:{if(((e<<8|e>>>8)&65535)>>>0<=4999){e=k[d+42|0]|k[d+43|0]<<8;if(((e<<8|e>>>8)&65535)>>>0<1e4){break d}}j[d+1064>>2]=5;z=d,A=j[zf(d+1196|0,d+1064|0)>>2],j[z+1196>>2]=A}f=f+n|0;g=g+1|0;if((g|0)!=16){continue}break}uy(b,d+1064|0);q=a+484360|0;kn(Eb(q),d+1064|2,128,65535,65535);g=0;s=LO(b,Eb(q),k[d+1064|0],f,s,0);e=d+1064|1;if(k[d+1064|0]?0:!(k[e|0]|s>>>0>1)){break a}if(ef(b)+65536>>>0<(s<<10)+f>>>0){break a}if(!c){g=1;break a}if(!k[e|0]){h[e|0]=120}if(!_c(d+1200|0,15738,6)){h[e|0]=120}j[a+480204>>2]=125e4;e:{if(k[e|0]==120){break e}f=a;w=145364549.18032786/+(240-k[e|0]|0);f:{if(w<4294967296&w>=0){e=~~w>>>0;break f}e=0}j[f+480204>>2]=e;if(j[d+1196>>2]>=2){j[d+16>>2]=r&1?4:5;z=d,A=j[zf(d+1196|0,d+16|0)>>2],j[z+1196>>2]=A;break e}j[d+16>>2]=r&1?1:2;z=d,A=j[zf(d+1196|0,d+16|0)>>2],j[z+1196>>2]=A}j[a+480260>>2]=452;j[a+480264>>2]=3424;j[a+480228>>2]=64;j[a+480208>>2]=j[a+480208>>2]|2097152;jn(d+1048|0,3,d+1200|0);qc(d+16|0,d+1048|0);ob(a+1304400|0,d+16|0);gb(d+16|0);Qi(a,0);x=j[b+8>>2];i[d+1046>>1]=0;g:{if(s){y=r&1;r=0;while(1){z=d,A=ry(Lb(Eb(q)),Mb(Eb(q)),d+1046|0),j[z+16>>2]=A;z=d,A=Mb(Eb(q)),j[z+1048>>2]=A;f=rb(d+16|0,d+1048|0);FO(b,d+16|0);if(f){r=py(d+16|0,0)+r|0;if(r>>>0>512){break g}}o=0;f=0;t=0;while(1){g=0;while(1){e=f;m=Ae(EO(d+16|0,o),g);u=k[Pb(m,2)|0]&15;n=k[Pb(m,3)|0];f=0;h:{if(!(e&255)|(k[m|0]|k[m+1|0]<<8|(k[m+2|0]<<16|k[m+3|0]<<24))){break h}f=e+1|0;if((f&255)>>>0<33){break h}j[d+1196>>2]=6}i:{j:{k:{switch(u-1|0){case 0:case 1:e=j[d+1196>>2];if((e|0)==1?n>>>0>=32:0){break j}m=(u|0)!=1;if(!(m|(n-1&255)>>>0>1)){j[d+1048>>2]=2;z=d,A=j[zf(d+1196|0,d+1048|0)>>2],j[z+1196>>2]=A;break i}if(m|((n|0)!=55?(n|0)!=71:0)){break i}if((e|0)<=2){break j}break i;case 10:j[d+1196>>2]=6;break i;case 11:case 12:case 13:j[d+1048>>2]=2;z=d,A=j[zf(d+1196|0,d+1048|0)>>2],j[z+1196>>2]=A;if((u|0)!=13){break i}t=((n|o)!=0)+t|0;f=1;break i;case 14:break k;default:break i}}j[d+1048>>2]=3;z=d,A=j[zf(d+1196|0,d+1048|0)>>2],j[z+1196>>2]=A;break i}j[d+1196>>2]=y}g=g+1|0;if((g|0)!=4){continue}break}o=o+1|0;if((o|0)!=64){continue}break}if((t-1&255)>>>0<2){j[d+1196>>2]=6}v=(t&255)+v|0;f=l[d+1046>>1]+1|0;i[d+1046>>1]=f;if(s>>>0>(f&65535)>>>0){continue}break}}if(!(j[d+1196>>2]!=6|s+32>>>0>=v>>>0)){j[d+1196>>2]=5}xc(b,x);u=c&1;if(u){Jf(a+484344|0,s)}if(s){t=a+484344|0;r=0;while(1){FO(b,d+16|0);l:{if(!u){break l}if(!Wf(t,r&65535,64)){break l}j[d+1048>>2]=0;o=0;while(1){v=Se(Hb(t,r),o,0);m=0;while(1){f=Ae(EO(d+16|0,o),m);f=k[f|0]|k[f+1|0]<<8|(k[f+2|0]<<16|k[f+3|0]<<24);j[d+8>>2]=f;j[d+12>>2]=f;e=v+p(m,6)|0;Ds(d+8|0,e);m:{n:{o:{p:{f=k[e+5|0];if(f){n=e+3|0;q=(d+1048|0)+m|0;g=k[e+3|0];if((g|0)!=14){break p}h[q|0]=0;g=14;break o}n=(d+1048|0)+m|0;h[n|0]=0;g=k[e+3|0];if(!g){break n}n=e+3|0;break o}q=k[q|0];if(!q){break o}if(q>>>0>=16){h[e+2|0]=3;h[e+4|0]=q>>>4;break o}h[e+2|0]=4;h[e+4|0]=q}q:{r:{s:{switch(g-12|0){case 1:if(j[d+1196>>2]!=6){g=10;h[n|0]=10;break r}f=0;h[e+5|0]=0;g=13;break r;case 0:f=f&127;h[e+5|0]=f;g=12;break r;case 2:if(j[d+1196>>2]>3?f>>>0<=1:0){break q}g=10;h[n|0]=10;h[(d+1048|0)+m|0]=f;break r;case 3:break s;default:break r}}g=15;f=f&15;h[e+5|0]=f}if(j[d+1196>>2]>1){break q}t:{u:{v:{switch(g|0){case 0:if(f>>>0>2){break u}break;case 2:break t;case 1:break u;default:break v}}h[n|0]=0;break m}h[n|0]=1;break m}g=f&15;if(g){h[n|0]=2;h[e+5|0]=g;break m}if(!(f&240)){break m}h[n|0]=3;h[e+5|0]=f>>>4;break m}_i(e);break m}h[n|0]=0}m=m+1|0;if((m|0)!=4){continue}break}o=o+1|0;if((o|0)!=64){continue}break}}r=r+1|0;if((s|0)!=(r|0)){continue}break}}e=j[d+1196>>2];f=15744;w:{if(e>>>0>=7){break w}f=j[(e<<2)+77512>>2]}e=Db(d+16|0,16009);ob(a+1304436|0,e);gb(e);e=Db(d+16|0,16022);ob(a+1304448|0,e);gb(e);vc(a+1304460|0,f);j[a+1304496>>2]=2;g=1;if(!(c&2)){break a}m=1;while(1){c=p(m,104)+a|0;f=c+484384|0;Jb(b,j[f>>2]);e=j[f>>2];j[f>>2]=0;f=c+484380|0;j[f>>2]=j[f>>2]-e;c=c+484388|0;j[c>>2]=j[c>>2]-e;Kc(d+16|0,8,1,1,0);$f(d+16|0,f,b);m=m+1|0;if((m|0)!=16){continue}break}break a}g=0}Za=d+1824|0;return g|0}function eya(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;d=Za-352|0;Za=d;xc(b,60);e=15;a:{if(!vh(b,17212)){xc(b,124);e=31;if(!vh(b,17217)){break a}}od(a,536870912);i[a+480190>>1]=e;rc(b);b:{if(l[a+480190>>1]){while(1){e=xz(b);j[(d+224|0)+(f<<2)>>2]=e;if(e>>>0>131072){break b}f=f+1|0;if(f>>>0<l[a+480190>>1]){continue}break}}j[a+480260>>2]=56;j[a+480264>>2]=13696;j[a+480196>>2]=6;f=0;i[a+480192>>1]=0;i[a+480188>>1]=4;j[a+480228>>2]=64;Qi(a,1);Jb(b,4);e=up(b);if(e>>>0<178){break a}f=a;s=177693e5/+(e>>>0);c:{if(s<4294967296&s>=0){e=~~s>>>0;break c}e=0}j[f+480204>>2]=e;Jb(b,14);d:{e:{f:{if(l[a+480190>>1]){r=d+78|0;m=1;e=0;n=1;while(1){HO(b,d+56|0);dya(d+56|0,(p(m,104)+a|0)+484380|0,j[((m<<2)+d|0)+220>>2]);f=d+56|0;while(1){if((k[f|0]-1&255)>>>0<=30){h[f|0]=32;e=e+1|0}f=f+1|0;if((r|0)!=(f|0)){continue}break}if(e>>>0>127){break b}sn(d+192|0,3,d+56|0);qc(d+208|0,d+192|0);j[114630]=0;E(369,((m<<5)+a|0)+946300|0,d+208|0)|0;f=j[114630];j[114630]=0;if((f|0)==1){break f}gb(d+208|0);n=n+1|0;m=n&65535;if(m>>>0<=l[a+480190>>1]){continue}break}}e=Db(d+56|0,17222);j[114630]=0;f=a+946332|0;m=E(998,f|0,e|0)|0;n=j[114630];j[114630]=0;r=1;g:{h:{i:{j:{if((n|0)!=1){if(!m){j[114630]=0;m=E(85,d+208|0,17233)|0;n=j[114630];j[114630]=0;if((n|0)==1){break j}j[114630]=0;r=E(998,f|0,m|0)|0;f=j[114630];j[114630]=0;if((f|0)==1){break i}gb(m)}gb(e);f=0;if(!uy(b,d+56|0)){break a}if(!mN(d+56|0)){break a}if(c){break g}break d}f=D()|0;C()|0;break h}f=D()|0;C()|0;break h}f=D()|0;C()|0;gb(m)}gb(e);break e}i[d+54>>1]=0;if(k[d+56|0]){while(1){i[d+208>>1]=k[(d+f|0)+58|0]+1;w=d,x=l[vi(d+54|0,d+208|0)>>1],i[w+54>>1]=x;f=f+1|0;if(f>>>0<k[d+56|0]){continue}break}}f=d+56|1;e=k[f|0];m=k[d+56|0];n=a+484360|0;Fe(Eb(n),e>>>0<m>>>0?k[f|0]:0);kn(Eb(n),d+56|2,k[d+56|0],65535,65535);if(l[a+480190>>1]==31){Jb(b,4)}j[d+48>>2]=0;j[d+44>>2]=0;j[d+40>>2]=0;h[d+39|0]=0;t=c&1;if(t){Jf(a+484344|0,l[d+54>>1])}if(l[d+54>>1]){u=a+484344|0;m=0;while(1){k:{l:{if(t){n=0;if(Wf(u,m&65535,64)){break l}}Jb(b,1024);break k}while(1){v=Se(Hb(u,m),n,0);f=0;while(1){rn(d+208|0,b);e=p(f,6)+v|0;m:{n:{if(k[Pb(d+208|0,0)|0]!=255){break n}h[(d+48|0)+f|0]=0;h[(d+40|0)+f|0]=0;o:{if(!r){break o}if(k[Pb(d+208|0,1)|0]!=252){break o}w=Pb(d+208|0,1),x=254,h[w|0]=x}p:{switch(k[Pb(d+208|0,1)|0]-252|0){case 2:h[e+3|0]=13;break m;case 1:break m;case 0:break p;default:break n}}h[e+3|0]=14;h[d+39|0]=9;break m}g=j[d+208>>2];j[d+32>>2]=g;j[d+12>>2]=g;Ds(d+12|0,e);g=k[e|0];q:{if(!g){break q}h[(d+40|0)+f|0]=0;h[(d+48|0)+f|0]=g;if(g>>>0>48){break q}h[d+192|0]=8;w=d,x=k[Vg(d+39|0,d+192|0)|0],h[w+39|0]=x}r:{s:{t:{u:{v:{switch(k[e+3|0]){case 0:if(k[e+5|0]){break s}break r;case 1:h[e+3|0]=1;break m;case 2:g=k[e+5|0];if(g&240){h[e+3|0]=3;h[e+5|0]=g>>>4;break m}g=g&15;if(g){h[e+3|0]=2;h[e+5|0]=g;break m}h[e+5|0]=0;break s;case 3:if(k[(d+40|0)+f|0]){break t}h[e+3|0]=19;h[e+5|0]=0;break m;case 4:if(k[(d+40|0)+f|0]){break t}h[e+3|0]=19;h[e+5|0]=1;break m;case 5:if(!k[e+1|0]){break t}h[e+3|0]=13;h[d+192|0]=63;h[d+31|0]=k[e+5|0]+(l[(p(k[e+1|0],104)+a|0)+484410>>1]>>>2|0);w=e,x=k[Zb(d+192|0,d+31|0)|0],h[w+5|0]=x;if(!k[(d+40|0)+f|0]){break u}h[e+2|0]=1;h[e+4|0]=k[e+5|0];h[e+5|0]=0;break s;case 6:g=k[e+1|0];if(!g){break t}h[e+3|0]=13;g=l[(p(g,104)+a|0)+484410>>1]>>>2|0;o=k[e+5|0];g=g>>>0<o>>>0?0:g-o|0;h[e+5|0]=g;if(!k[(d+40|0)+f|0]){break u}h[e+4|0]=g;h[e+2|0]=1;h[e+5|0]=0;break s;case 8:o=k[(d+48|0)+f|0];g=k[e+5|0];q=o+(g>>>4|0)|0;h[(d+44|0)+f|0]=q;h[e+3|0]=2;g=g&15;h[(d+40|0)+f|0]=g;w=e,x=lN(g,o,q&255),h[w+5|0]=x;break u;case 9:h[d+192|0]=8;w=d,x=k[Vg(d+39|0,d+192|0)|0],h[w+39|0]=x;break s;case 7:break v;default:break s}}g=k[(d+48|0)+f|0];o=k[e+5|0];q=g-(o>>>4|0)|0;h[(d+44|0)+f|0]=q;h[e+3|0]=3;o=o&15;h[(d+40|0)+f|0]=o;w=e,x=lN(o,q&255,g),h[w+5|0]=x}if(k[e+3|0]){break m}break r}h[e+5|0]=0}h[e+3|0]=0}o=k[(d+40|0)+f|0];if(!o){break m}q=(d+44|0)+f|0;g=k[q|0];if(g){h[(d+48|0)+f|0]=g;h[e|0]=g;h[e+5|0]=o;h[q|0]=0}h[e+3|0]=4}f=f+1|0;if((f|0)!=4){continue}break}n=n+1|0;if((n|0)!=64){continue}break}}m=m+1|0;if(m>>>0<l[d+54>>1]){continue}break}}e=l[a+480190>>1];w:{x:{y:{z:{A:{B:{if(c&2){if(!(e&65535)){break B}f=1;while(1){c=(p(f&65535,104)+a|0)+484380|0;if(j[c>>2]){$f(Kc(d+208|0,8,1,0,0),c,b);e=l[a+480190>>1]}f=f+1|0;if((f&65535)>>>0<=(e&65535)>>>0){continue}break}}if((e&65535)==15){break A}}f=0;j[114630]=0;E(2,d+208|0,17255)|0;b=j[114630];j[114630]=0;if((b|0)!=1){break z}f=D()|0;C()|0;break e}b=Db(d+16|0,17242);j[114630]=0;F(219,d+192|0,b|0);c=j[114630];j[114630]=0;f=1;if((c|0)==1){break x}j[114630]=0;I(536,d+208|0,d+192|0,d+39|0);c=j[114630];j[114630]=0;if((c|0)==1){break y}}ob(a+1304436|0,d+208|0);gb(d+208|0);if(f){qb(d+192|0);gb(d+16|0)}vc(a+1304448|0,l[a+480190>>1]==15?17286:17290);j[a+1304496>>2]=2;break d}f=D()|0;C()|0;qb(d+192|0);break w}f=D()|0;C()|0}gb(b);break e}f=D()|0;C()|0;gb(d+208|0)}G(f|0);z()}f=1;break a}f=0}Za=d+352|0;return f|0}function oma(a){var b=0,c=0,d=0,e=0,f=0,g=0,n=0,o=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;g=Za-16|0;Za=g;c=a+1074392|0;b=j[c>>2]+1|0;j[c>>2]=b;a:{b:{c:{if(al(a)>>>0>b>>>0){break c}v=a+1074984|0;q=a+1074308|0;o=a+1304360|0;n=a+484344|0;d=a+484360|0;e=a+1074438|0;s=a+1074424|0;t=a+480210|0;while(1){r=0;d:{if(!j[a+1074396>>2]){break d}r=0;if(!(k[t|0]&8)){break d}r=j[a+480180>>2]==1}e:{if(j[a+480180>>2]!=2|(k[t|0]&8?0:j[a+1074428>>2])){break e}b=0;if(!l[a+480188>>1]){break e}while(1){j[(p(b,896)+a|0)+1075788>>2]=0;b=b+1|0;if(b>>>0<l[a+480188>>1]){continue}break}}j[a+1074400>>2]=0;j[a+1074392>>2]=0;j[a+1074396>>2]=0;j[a+1074424>>2]=j[a+1074428>>2];c=l[a+1074440>>1];i[a+1074438>>1]=c;if(!(k[a+480208|0]&32)){b=a;f:{if(Yb(Eb(d))>>>0>c>>>0){c=l[bc(Eb(d),l[e>>1])>>1];break f}c=65535}i[b+1074436>>1]=c;g:{if(me(n)>>>0<=(c&65535)>>>0){break g}if(uh(Hb(n,l[a+1074436>>1]))){break g}i[a+1074436>>1]=65534}if(l[a+1074436>>1]>=me(n)>>>0){while(1){h:{i:{j:{k:{if(l[a+1074436>>1]!=65535){b=l[e>>1];if(Yb(Eb(d))>>>0>b>>>0){break k}}c=l[Eb(d)+28>>1];if(c){break i}b=l[e>>1];if(Yb(Eb(d))>>>0<b>>>0){break j}b=l[e>>1];if(!b){break j}while(1){c=b;b=b-1|0;if(!b){break j}if(l[bc(Eb(d),b)>>1]!=65535){continue}break}break i}b=l[e>>1]+1|0;i[e>>1]=b;break h}c=0}i[a+1074438>>1]=c;j[a+480208>>2]=j[a+480208>>2]&-524289;l:{if(Yb(Eb(d))>>>0<=(c&65535)>>>0){break l}while(1){if(l[bc(Eb(d),l[e>>1])>>1]!=65534){break l}b=l[e>>1]+1|0;i[e>>1]=b;if(Yb(Eb(d))>>>0>(b&65535)>>>0){continue}break}}b=l[e>>1];m:{if(Yb(Eb(d))>>>0<=b>>>0){break m}if(!Po(Eb(d),l[e>>1])){break m}b=l[e>>1];break h}Ui(o,1);break b}c=a;n:{if(Yb(Eb(d))>>>0>(b&65535)>>>0){b=l[bc(Eb(d),l[e>>1])>>1];break n}b=65535}i[c+1074436>>1]=b;o:{if(me(n)>>>0<=(b&65535)>>>0){break o}if(uh(Hb(n,l[a+1074436>>1]))){break o}i[a+1074436>>1]=65534}if(l[a+1074436>>1]>=me(n)>>>0){continue}break}}i[a+1074440>>1]=l[a+1074438>>1]}if(!tg(n,l[a+1074436>>1])){break b}if(m[a+1074424>>2]>=m[Hb(n,l[a+1074436>>1])+12>>2]){j[s>>2]=0}if(j[a+480272>>2]==-1){b=0}else{b=(k[a+480208|0]&32)>>>5|0}if(r){c=o+12|0;if(Xc(c)){c=-1}else{c=j[Ti(c)>>2]}c=(c|0)==j[s>>2]}else{c=1}p:{if(b|c^1){break p}if(!pL(o,l[e>>1],j[s>>2],1)){break p}b=j[a+480272>>2];if(b){if((b|0)>=1){j[a+480272>>2]=b-1}Ui(o,1);oJ(o,l[e>>1],j[s>>2]);break p}q:{if(k[t|0]&64){if(oL(o,e,s,1)){break q}i[a+1074438>>1]=0;i[a+1074440>>1]=0;j[a+1074424>>2]=0;j[a+1074428>>2]=0;b=k[d+16|0];if((b|0)>=(rh(d)-1|0)){Oo(d,0);Ui(o,1);a=0;break a}Oo(d,k[d+16|0]+1&255);Ui(o,1);break q}Ui(o,1);break b}b=0;while(1){Tm((p(b,896)+a|0)+1074984|0,a,b&65535);b=b+1|0;if((b|0)!=256){continue}break}JJ(a);j[a+1074416>>2]=j[a+480196>>2];j[a+1074420>>2]=j[a+480204>>2];j[a+1074444>>2]=j[a+480200>>2];i[a+1074440>>1]=l[a+1074438>>1];j[a+1074428>>2]=j[a+1074424>>2];c=o;u=Yb(Eb(d));b=l[a+1074438>>1];if(u>>>0>b>>>0){w=a,x=l[bc(Eb(d),l[a+1074438>>1])>>1],i[w+1074436>>1]=x;b=l[a+1074438>>1]}oJ(c,b&65535,j[a+1074424>>2]);if(!tg(n,l[a+1074436>>1])){break b}}b=j[a+1074424>>2]+1|0;j[a+1074428>>2]=b;r:{if(b>>>0<m[Hb(n,l[a+1074436>>1])+12>>2]){break r}if(!(k[a+480208|0]&32)){i[a+1074440>>1]=l[a+1074438>>1]+1}j[a+1074428>>2]=0;mb(g+8|0,q,63);if(!kb(g+8|0)){break r}b=j[a+1074432>>2];j[a+1074432>>2]=0;j[a+1074428>>2]=b}c=Se(Hb(n,l[a+1074436>>1]),j[a+1074424>>2],0);b=l[a+480188>>1];if(b){u=(p(b,896)+a|0)+1074984|0;b=v;while(1){mb(g+8|0,q,82);s:{if(!kb(g+8|0)|k[b+827|0]!=1){break s}f=k[c+3|0];if((f|0)!=3?(f|0)!=2:0){break s}w=b,x=Zf(a,k[b+822|0],j[b+768>>2],j[b+704>>2]),j[w+700>>2]=x}mb(g+8|0,q,91);t:{if(!kb(g+8|0)){break t}if(Mf(c)){break t}if(!Mf(b+810|0)|k[b+813|0]!=19){break t}f=k[b+815|0];if((f&240)!=208|m[a+1074416>>2]>(f&15)>>>0){break t}w=b,x=Zf(a,k[b+810|0],j[b+768>>2],0),j[w+700>>2]=x}mb(g+8|0,q,92);u:{if(!kb(g+8|0)){break u}mb(g,q,5);if(kb(g)|j[a+1074416>>2]!=1|k[b+813|0]!=17){break u}j[a+1074420>>2]=p(k[b+815|0],1e4)}f=k[c|0]|k[c+1|0]<<8|(k[c+2|0]<<16|k[c+3|0]<<24);h[b+810|0]=f;h[b+811|0]=f>>>8;h[b+812|0]=f>>>16;h[b+813|0]=f>>>24;f=k[c+4|0]|k[c+5|0]<<8;h[b+814|0]=f;h[b+815|0]=f>>>8;f=j[b+676>>2];j[b+20>>2]=j[b+672>>2];j[b+24>>2]=f;j[b+88>>2]=j[b+88>>2]&-393217;mb(g+8|0,q,21);if(!kb(g+8|0)){h[b+851|0]=0}j[b+884>>2]=0;h[b+827|0]=0;c=c+6|0;b=b+896|0;if((u|0)!=(b|0)){continue}break}}xoa(a);if(!r){break c}b=j[a+1074416>>2]+1|0;j[a+1074392>>2]=b;if(al(a)>>>0<=b>>>0){continue}break}}if(!j[a+1074416>>2]){j[a+1074416>>2]=1}b=j[a+480208>>2];v:{if(j[a+1074392>>2]){j[a+480208>>2]=b&-4097;if(j[a+480180>>2]&1048580|(k[a+480210|0]&32?0:j[a+480180>>2]==1)){break v}if(m[a+1074392>>2]>=al(a)>>>0|m[a+1074392>>2]%(j[a+1074400>>2]+j[a+1074416>>2]>>>0)){break v}j[a+480208>>2]=j[a+480208>>2]|4096;break v}j[a+480208>>2]=b&-528385|4096}a=Joa(a);break a}a=0}Za=g+16|0;return a}function uv(a,b,c,d,e,f,g){var l=0,m=0,n=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;l=Za-80|0;Za=l;j[l+76>>2]=b;B=l+55|0;y=l+56|0;b=0;a:{b:while(1){c:{if((w|0)<0){break c}if((2147483647-w|0)<(b|0)){j[114604]=61;w=-1;break c}w=b+w|0}d:{e:{f:{q=j[l+76>>2];b=q;m=k[b|0];if(m){while(1){g:{m=m&255;h:{if(!m){m=b;break h}if((m|0)!=37){break g}m=b;while(1){if(k[b+1|0]!=37){break h}n=b+2|0;j[l+76>>2]=n;m=m+1|0;r=k[b+2|0];b=n;if((r|0)==37){continue}break}}b=m-q|0;if(a){ve(a,q,b)}if(b){continue b}m=l;n=!Jg(h[j[l+76>>2]+1|0]);b=j[l+76>>2];i:{if(!(n|k[b+2|0]!=36)){x=h[b+1|0]-48|0;z=1;b=b+3|0;break i}x=-1;b=b+1|0}j[m+76>>2]=b;s=0;t=h[b|0];n=t-32|0;j:{if(n>>>0>31){m=b;break j}m=b;n=1<<n;if(!(n&75913)){break j}while(1){m=b+1|0;j[l+76>>2]=m;s=n|s;t=h[b+1|0];n=t-32|0;if(n>>>0>=32){break j}b=m;n=1<<n;if(n&75913){continue}break}}k:{if((t|0)==42){n=l;l:{m:{if(!Jg(h[m+1|0])){break m}b=j[l+76>>2];if(k[b+2|0]!=36){break m}j[((h[b+1|0]<<2)+e|0)-192>>2]=10;u=j[((h[b+1|0]<<3)+d|0)-384>>2];z=1;b=b+3|0;break l}if(z){break f}z=0;u=0;if(a){b=j[c>>2];j[c>>2]=b+4;u=j[b>>2]}b=j[l+76>>2]+1|0}j[n+76>>2]=b;if((u|0)>-1){break k}u=0-u|0;s=s|8192;break k}u=xE(l+76|0);if((u|0)<0){break f}b=j[l+76>>2]}r=-1;n:{if(k[b|0]!=46){break n}if(k[b+1|0]==42){o:{if(!Jg(h[b+2|0])){break o}b=j[l+76>>2];if(k[b+3|0]!=36){break o}j[((h[b+2|0]<<2)+e|0)-192>>2]=10;r=j[((h[b+2|0]<<3)+d|0)-384>>2];b=b+4|0;j[l+76>>2]=b;break n}if(z){break f}if(a){b=j[c>>2];j[c>>2]=b+4;b=j[b>>2]}else{b=0}r=b;b=j[l+76>>2]+2|0;j[l+76>>2]=b;break n}j[l+76>>2]=b+1;r=xE(l+76|0);b=j[l+76>>2]}m=0;while(1){A=m;v=-1;if(h[b|0]-65>>>0>57){break a}t=b+1|0;j[l+76>>2]=t;m=h[b|0];b=t;m=k[(m+p(A,58)|0)+55119|0];if(m-1>>>0<8){continue}break}p:{q:{if((m|0)!=19){if(!m){break a}if((x|0)>=0){j[(x<<2)+e>>2]=m;b=(x<<3)+d|0;m=j[b+4>>2];j[l+64>>2]=j[b>>2];j[l+68>>2]=m;break q}if(!a){break d}wE(l- -64|0,m,c,g);t=j[l+76>>2];break p}if((x|0)>-1){break a}}b=0;if(!a){continue b}}n=s&-65537;m=s&8192?n:s;v=0;x=55152;s=y;r:{s:{t:{u:{v:{w:{x:{y:{z:{A:{B:{C:{D:{E:{F:{G:{b=h[t-1|0];b=A?(b&15)==3?b&-33:b:b;switch(b-88|0){case 11:break r;case 9:case 13:case 14:case 15:break s;case 27:break x;case 12:case 17:break A;case 23:break B;case 0:case 32:break C;case 24:break D;case 22:break E;case 29:break F;case 1:case 2:case 3:case 4:case 5:case 6:case 7:case 8:case 10:case 16:case 18:case 19:case 20:case 21:case 25:case 26:case 28:case 30:case 31:break e;default:break G}}H:{switch(b-65|0){case 0:case 4:case 5:case 6:break s;case 2:break v;case 1:case 3:break e;default:break H}}if((b|0)==83){break w}break e}b=j[l+64>>2];q=j[l+68>>2];n=55152;break z}b=0;I:{switch(A&255){case 0:j[j[l+64>>2]>>2]=w;continue b;case 1:j[j[l+64>>2]>>2]=w;continue b;case 2:m=j[l+64>>2];j[m>>2]=w;j[m+4>>2]=w>>31;continue b;case 3:i[j[l+64>>2]>>1]=w;continue b;case 4:h[j[l+64>>2]]=w;continue b;case 6:j[j[l+64>>2]>>2]=w;continue b;case 7:break I;default:continue b}}m=j[l+64>>2];j[m>>2]=w;j[m+4>>2]=w>>31;continue b}r=r>>>0>8?r:8;m=m|8;b=120}q=K4(j[l+64>>2],j[l+68>>2],y,b&32);if(!(m&8)|!(j[l+64>>2]|j[l+68>>2])){break y}x=(b>>>4|0)+55152|0;v=2;break y}q=J4(j[l+64>>2],j[l+68>>2],y);if(!(m&8)){break y}b=y-q|0;r=(b|0)<(r|0)?r:b+1|0;break y}n=j[l+68>>2];q=n;b=j[l+64>>2];if((n|0)<-1?1:(n|0)<=-1){q=0-(q+((b|0)!=0)|0)|0;b=0-b|0;j[l+64>>2]=b;j[l+68>>2]=q;v=1;n=55152;break z}if(m&2048){v=1;n=55153;break z}v=m&1;n=v?55154:55152}x=n;q=im(b,q,y)}m=(r|0)>-1?m&-65537:m;b=j[l+68>>2];n=b;t=j[l+64>>2];if(!(!!(b|t)|r)){r=0;q=y;break e}b=!(n|t)+(y-q|0)|0;r=(b|0)<(r|0)?r:b;break e}b=j[l+64>>2];q=b?b:55162;b=Uq(q,0,r);s=b?b:r+q|0;m=n;r=b?b-q|0:r;break e}n=j[l+64>>2];if(r){break u}b=0;of(a,32,u,0,m);break t}j[l+12>>2]=0;j[l+8>>2]=j[l+64>>2];j[l+64>>2]=l+8;r=-1;n=l+8|0}b=0;J:{while(1){q=j[n>>2];if(!q){break J}q=AE(l+4|0,q);s=(q|0)<0;if(!(s|q>>>0>r-b>>>0)){n=n+4|0;b=b+q|0;if(r>>>0>b>>>0){continue}break J}break}v=-1;if(s){break a}}of(a,32,u,b,m);if(!b){b=0;break t}n=0;t=j[l+64>>2];while(1){q=j[t>>2];if(!q){break t}q=AE(l+4|0,q);n=q+n|0;if((n|0)>(b|0)){break t}ve(a,l+4|0,q);t=t+4|0;if(b>>>0>n>>>0){continue}break}}of(a,32,u,b,m^8192);b=(b|0)<(u|0)?u:b;continue b}b=bb[f|0](a,o[l+64>>3],u,r,m,b)|0;continue b}h[l+55|0]=j[l+64>>2];r=1;q=B;m=n;break e}n=b+1|0;j[l+76>>2]=n;m=k[b+1|0];b=n;continue}}v=w;if(a){break a}if(!z){break d}b=1;while(1){a=j[(b<<2)+e>>2];if(a){wE((b<<3)+d|0,a,c,g);v=1;b=b+1|0;if((b|0)!=10){continue}break a}break}v=1;if(b>>>0>=10){break a}while(1){if(j[(b<<2)+e>>2]){break f}b=b+1|0;if((b|0)!=10){continue}break}break a}v=-1;break a}s=s-q|0;r=(r|0)<(s|0)?s:r;n=r+v|0;b=(n|0)>(u|0)?n:u;of(a,32,b,n,m);ve(a,x,v);of(a,48,b,n,m^65536);of(a,48,r,s,0);ve(a,q,s);of(a,32,b,n,m^8192);continue}break}v=0}Za=l+80|0;return v}function aHa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,I=0;d=Za-1328|0;Za=d;rc(b);g=d+752|0;f=VGa(b,g);if(!f){IQ(g)}a:{b:{c:{if(!f){break c}if(!MQ(d+752|0)){break c}if(!yb(b,Tc(LQ(d+752|0),ab))){break c}if(!c){e=1;break c}v=Ws(d+744|0);w=1;d:{while(1){g=(e<<5)+a|0;f=g+480280|0;wg(f);n=(d+752|0)+(e<<4)|0;i[g+480284>>1]=((k[n+78|0]<<8&65280)>>>0)/255;ek(d+480|0,1,n- -64|0);qc(d+96|0,d+480|0);j[114630]=0;E(378,g+480289|0,d+96|0)|0;g=j[114630];j[114630]=0;if((g|0)==1){break b}gb(d+96|0);e:{f:{switch(k[n+79|0]){case 0:o=e+1|0;break e;case 1:j[f>>2]=1024;o=m+1|0;break e;case 2:break f;default:break d}}j[f>>2]=1024;qj(d+96|0,v,e);Qd(d+96|0,1)}w=e>>>0<31;m=m+1|0;e=e+1|0;if((e|0)!=32){continue}break}od(a,33554432);i[a+480188>>1]=o&255;e=Db(d+96|0,13326);ob(a+1304436|0,e);gb(e);e=Db(d+96|0,13340);ob(a+1304448|0,e);gb(e);j[a+1304496>>2]=4;g:{if(k[d+831|0]){break g}g=1;while(1){if(k[((g<<4)+d|0)+831|0]!=1){break g}e=1;g=g+1|0;if((g|0)!=16){continue}break}while(1){m=((e<<5)+a|0)+480280|0;j[m>>2]=j[m>>2]&-1025;e=e+1|0;if((e|0)!=16){continue}break}}vg(d+480|0,1,d+752|0);qc(d+96|0,d+480|0);ob(a+1304400|0,d+96|0);gb(d+96|0);j[a+480208>>2]=j[a+480208>>2]&-17|(k[d+790|0]|k[d+791|0]<<8)<<4&16;j[a+480196>>2]=k[d+800|0];j[a+480204>>2]=p(k[d+801|0],1e4);B=a,I=kd(k[d+802|0],0,64)<<2,j[B+480200>>2]=I;B=a,I=kd(k[d+803|0],4,127),j[B+480228>>2]=I;e=k[d+788|0]|k[d+789|0]<<8;i[a+480190>>1]=0;i[a+480192>>1]=e;Rz(b,d+480|0);xt(Eb(a+484360|0),d+480|0,k[d+784|0]|k[d+785|0]<<8,65535,255);x=c&1;if(x){Jf(a+484344|0,k[d+786|0]|k[d+787|0]<<8)}if(k[d+786|0]|k[d+787|0]<<8){y=a+484344|0;o=0;while(1){e=Of(b);t=Of(b);cd(d+96|0,b,e-4|0);h:{if(!x){break h}j[114630]=0;e=K(402,y|0,o&65535,t|0)|0;m=j[114630];j[114630]=0;if((m|0)!=1){i:{if(!e){break h}r=0;s=ni(d+16|0);if(!t){break h}while(1){j:{j[114630]=0;g=H(387,d+96|0)|0;e=j[114630];j[114630]=0;k:{l:{if((e|0)!=1){if(g){break l}r=r+1|0;break k}break i}e=s;u=g&31;if(u>>>0<l[a+480188>>1]){e=Hb(y,o);j[114630]=0;e=K(471,e|0,r|0,u|0)|0;m=j[114630];j[114630]=0;if((m|0)==1){break i}}m:{if(!(g&32)){break m}j[114630]=0;F(472,d+32|0,d+96|0);f=j[114630];j[114630]=0;m=e;n:{o:{if((f|0)!=1){n=Pc(d+32|0);f=k[d+32|0];h[e|0]=f;h[e+1|0]=k[n|0];if((f|0)!=160){break o}f=255;break n}break i}if((f|0)!=255){h[e|0]=(p(f>>>4|0,12)+(f&15)|0)+13;j[114630]=0;n=H(615,e|0)|0;f=j[114630];j[114630]=0;if((f|0)!=1){f=0;if(!n){break n}break m}break i}f=0}h[m|0]=f}m=g&192;p:{if(!m){break p}if((m|0)==192){j[114630]=0;F(595,d+32|0,d+96|0);m=j[114630];j[114630]=0;q:{r:{s:{if((m|0)!=1){n=Pc(d+32|0);g=Bf(d+32|0);m=pi(d+32|0);q=d+32|0;A=k[q|0];if((A|0)!=12){break s}j[114630]=0;h[d+8|0]=64;f=E(391,n|0,d+8|0)|0;n=j[114630];j[114630]=0;if((n|0)==1){break i}h[e+4|0]=k[f|0];f=1;break r}break i}f=k[g|0];t:{if((f|0)==12){j[114630]=0;h[d+8|0]=64;m=E(391,m|0,d+8|0)|0;g=j[114630];j[114630]=0;if((g|0)!=1){h[e+4|0]=k[m|0];f=1;break t}break i}if((A|0)==10){h[e+4|0]=(k[n|0]<<6>>>0)/255;f=2;break r}if((f|0)!=10){break q}h[e+4|0]=(k[m|0]<<6>>>0)/255;f=2}g=q;m=n}h[e+2|0]=f;f=k[g|0]}h[e+3|0]=f;h[e+5|0]=k[m|0];break p}j[114630]=0;F(472,d+32|0,d+96|0);m=j[114630];j[114630]=0;if((m|0)==1){break i}m=Pc(d+32|0);h[e+3|0]=k[d+32|0];h[e+5|0]=k[m|0]}if(k[e+3|0]){j[114630]=0;N(616,e|0);m=j[114630];j[114630]=0;if((m|0)==1){break i}}qj(d+32|0,v,u);if(!kb(d+32|0)){break k}j[114630]=0;m=H(617,e|0)|0;g=j[114630];j[114630]=0;if((g|0)==1){break j}if(!m){break k}h[e+3|0]=0}if(r>>>0<t>>>0){continue}break h}break}}}e=D()|0;C()|0;jb(d+96|0);break a}jb(d+96|0);o=o+1|0;if(o>>>0<(k[d+786|0]|k[d+787|0]<<8)>>>0){continue}break}}if(!l[a+480192>>1]){break d}n=c&2;c=0;m=1;while(1){c=c+1|0;s=c&65535;e=EJ(a,s,0);if(!(!e|!XGa(b,d+96|0))){ZGa(d+96|0,e,m&65535);e=0;u:{if(!(k[d+474|0]|k[d+475|0]<<8)){break u}while(1){v:{np(b,d+32|0);f=e+m|0;g=f&65535;w:{if((k[d+92|0]|k[d+93|0]<<8|(k[d+94|0]<<16|k[d+95|0]<<24))!=808538953|g>>>0>3999){break w}i[a+480190>>1]=f;f=p(g,104)+a|0;q=f+484380|0;YGa(d+32|0,q);iA(d+16|0,f+484423|0);j[114630]=0;E(369,((g<<5)+a|0)+946300|0,d+16|0)|0;g=j[114630];j[114630]=0;if((g|0)==1){break v}gb(d+16|0);if(!(k[d+48|0]|k[d+49|0]<<8|(k[d+50|0]<<16|k[d+51|0]<<24))){break w}cd(d+16|0,b,k[d+48|0]|k[d+49|0]<<8|(k[d+50|0]<<16|k[d+51|0]<<24));x:{if(!n){break x}g=Kc(d+8|0,i[f+484414>>1]&1?16:8,1,0,0);j[114630]=0;K(400,g|0,q|0,d+16|0)|0;g=j[114630];j[114630]=0;if((g|0)!=1){break x}e=D()|0;C()|0;jb(d+16|0);break a}jb(d+16|0)}e=e+1|0;if(e>>>0<(k[d+474|0]|k[d+475|0]<<8)>>>0){continue}break u}break}e=D()|0;C()|0;gb(d+16|0);break a}m=(k[d+474|0]|k[d+475|0]<<8)+m|0}if(s>>>0<l[a+480192>>1]){continue}break}}e=w^1}Za=d+1328|0;return e&1}e=D()|0;C()|0;gb(d+96|0)}G(e|0);z()}function qya(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,J=0,M=0;d=Za-768|0;Za=d;rc(b);e=d+160|0;f=lya(b,e);if(!f){rN(e)}a:{b:{c:{d:{e:{f:{g:{h:{i:{j:{k:{l:{m:{n:{if(!f){break n}if(!tN(d+160|0)){break n}if(!yb(b,Tc(sN(d+160|0),ab))){break n}if(!c){u=1;break n}od(a,262144);_s(d+104|0,2,d+160|0);qc(d+24|0,d+104|0);ob(a+1304400|0,d+24|0);gb(d+24|0);e=Db(d+24|0,16992);ob(a+1304436|0,e);gb(e);e=Db(d+24|0,17004);ob(a+1304448|0,e);gb(e);f=Db(d+144|0,17008);j[114630]=0;F(219,d+104|0,f|0);e=j[114630];j[114630]=0;if((e|0)==1){break c}h[d+8|0]=k[d+190|0];e=k[d+189|0];j[114630]=0;h[d+127|0]=e;F(989,d+128|0,d+127|0);e=j[114630];j[114630]=0;if((e|0)==1){break e}e=0;j[114630]=0;L(451,d+24|0,d+104|0,d+8|0,d+128|0);g=j[114630];j[114630]=0;if((g|0)==1){break f}ob(a+1304460|0,d+24|0);gb(d+24|0);gb(d+128|0);qb(d+104|0);gb(f);j[a+480208>>2]=12;j[a+1304496>>2]=4;i[a+480188>>1]=k[d+198|0]|k[d+199|0]<<8;i[d+24>>1]=k[d+194|0]|k[d+195|0]<<8;i[d+104>>1]=3999;J=a,M=l[gf(d+24|0,d+104|0)>>1],i[J+480190>>1]=M;gz(Eb(a+484360|0),d+256|0,k[d+192|0]|k[d+193|0]<<8,255,254);if(l[a+480188>>1]){while(1){f=(e<<5)+a|0;wg(f+480280|0);i[f+480284>>1]=(k[(d+e|0)+224|0]<<4|4)&244;e=e+1|0;if(e>>>0<l[a+480188>>1]){continue}break}}cd(d+104|0,b,p(k[d+194|0]|k[d+195|0]<<8,80));if(l[a+480190>>1]){g=c&2;o=d+72|0;e=0;while(1){j[114630]=0;E(990,d+104|0,d+24|0)|0;f=j[114630];j[114630]=0;if((f|0)==1){break m}j[114630]=0;I(577,d+8|0,2,o|0);f=j[114630];j[114630]=0;o:{p:{q:{if((f|0)==1){break q}j[114630]=0;F(415,d+128|0,d+8|0);f=j[114630];j[114630]=0;if((f|0)==1){break q}j[114630]=0;e=e+1|0;E(369,((e<<5)+a|0)+946300|0,d+128|0)|0;f=j[114630];j[114630]=0;if((f|0)==1){break p}gb(d+128|0);j[114630]=0;f=(p(e,104)+a|0)+484380|0;I(991,d+128|0,d+24|0,f|0);m=j[114630];j[114630]=0;r:{if((m|0)==1){break r}if(!g|!j[f>>2]){break o}m=k[d+42|0]|k[d+43|0]<<8|(k[d+44|0]<<16|k[d+45|0]<<24);j[114630]=0;m=E(256,b|0,m|0)|0;n=j[114630];j[114630]=0;if((n|0)==1){break r}if(!m){break o}j[114630]=0;K(400,d+128|0,f|0,b|0)|0;f=j[114630];j[114630]=0;if((f|0)!=1){break o}}a=D()|0;C()|0;break g}a=D()|0;C()|0;break g}a=D()|0;C()|0;gb(d+128|0);break g}if(l[a+480190>>1]>e>>>0){continue}break}}u=1;s:{if(!(c&1)){break s}c=k[d+196|0]|k[d+197|0]<<8;j[114630]=0;q=a+484344|0;F(401,q|0,c|0);c=j[114630];j[114630]=0;if((c|0)==1){break l}if(!(k[d+196|0]|k[d+197|0]<<8)){break s}v=d+24|4;w=d+24|2;x=d+24|5;y=d+24|3;A=d+24|1;o=0;while(1){j[114630]=0;c=K(402,q|0,o&65535,64)|0;e=j[114630];j[114630]=0;if((e|0)==1){break k}t:{if(!c){break t}c=(o<<1)+d|0;e=c+512|0;if(!(k[e|0]|k[e+1|0]<<8)){break t}c=k[c+512|0]|k[c+513|0]<<8;j[114630]=0;c=E(256,b|0,c<<4)|0;e=j[114630];j[114630]=0;if((e|0)==1){break k}if(!c){break t}r=0;c=Hb(q,o);j[114630]=0;s=K(471,c|0,0,0)|0;c=j[114630];j[114630]=0;if((c|0)==1){break h}while(1){j[114630]=0;c=E(258,b|0,1)|0;e=j[114630];j[114630]=0;u:{v:{w:{if((e|0)!=1){if(!c){break t}j[114630]=0;m=H(387,b|0)|0;c=j[114630];j[114630]=0;if((c|0)==1){break w}if(m){break v}r=r+1|0;s=p(l[a+480188>>1],6)+s|0;break u}a=D()|0;C()|0;break g}a=D()|0;C()|0;break g}i[d+28>>1]=0;j[d+24>>2]=0;c=m&31;f=p(c,6)+s|0;t=ni(d+24|0);g=c>>>0<l[a+480188>>1];x:{y:{z:{A:{B:{C:{D:{if(!(m&32)){break D}j[114630]=0;F(472,d+128|0,b|0);c=j[114630];j[114630]=0;if((c|0)==1){break C}e=Pc(d+128|0);n=g?f:d+24|0;c=k[d+128|0];h[n|0]=c;h[(g?f+1|0:A)|0]=k[e|0];E:{if(c){if((c|0)==254){break E}if(c>>>0<121){break D}}c=0}h[n|0]=c}if(!(m&64)){break x}j[114630]=0;F(472,d+128|0,b|0);c=j[114630];j[114630]=0;if((c|0)==1){break j}B=Pc(d+128|0);c=g?f+3|0:y;e=k[d+128|0];h[c|0]=e;n=g?f+5|0:x;h[n|0]=k[B|0];if(e>>>0>15){break B}j[114630]=0;N(574,(g?f:t)|0);e=j[114630];j[114630]=0;if((e|0)!=1){break A}a=D()|0;C()|0;break g}a=D()|0;C()|0;break g}if(e>>>0>23){break y}t=c;c=k[e+17010|0];h[t|0]=c;break z}c=k[c|0]}c=c&255;if((c|0)!=23){if((c|0)!=9){break x}c=k[n|0];F:{G:{if(c>>>0>=136){e=c&127;break G}e=128;if(c>>>0<129){break F}}h[n|0]=e;c=e}h[n|0]=(p(c&127,255)>>>0)/127;break x}j[114630]=0;h[d+8|0]=64;c=E(391,n|0,d+8|0)|0;e=j[114630];j[114630]=0;if((e|0)!=1){h[n|0]=k[c|0]<<1;break x}a=D()|0;C()|0;break g}h[c|0]=0}if(!(m&128)){break u}h[(g?f+2|0:w)|0]=1;j[114630]=0;c=H(387,b|0)|0;e=j[114630];j[114630]=0;if((e|0)==1){break i}h[(g?f+4|0:v)|0]=c}if(r>>>0<64){continue}break}}o=o+1|0;if(o>>>0<(k[d+196|0]|k[d+197|0]<<8)>>>0){continue}break}}jb(d+104|0)}Za=d+768|0;return u|0}a=D()|0;C()|0;break g}a=D()|0;C()|0;break g}a=D()|0;C()|0;break g}a=D()|0;C()|0;break g}a=D()|0;C()|0;break g}a=D()|0;C()|0}jb(d+104|0);break a}a=D()|0;C()|0;gb(d+128|0);break d}a=D()|0;C()|0}qb(d+104|0);break b}a=D()|0;C()|0}gb(f)}G(a|0);z()}function jLa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,m=0,n=0,o=0,q=0,r=0;e=Za-128|0;Za=e;rc(b);a:{if(!sS(b,12168)){break a}if(!Mz(b,e+112|0)){break a}if(!uS(e+112|0)){break a}if(!yb(b,Tc(tS(e+112|0),ab))){break a}if(!Jb(b,k[e+121|0]|k[e+122|0]<<8)){break a}b:{if(!c){break b}od(a,4096);j[a+480208>>2]=12;i[a+480188>>1]=(k[e+112|2]&31)+1;f=e+112|3;i[a+480190>>1]=k[f|0];Qi(a,1);d=Db(e+56|0,12176);ob(a+1304436|0,d);gb(d);d=Db(e+56|0,12194);ob(a+1304448|0,d);gb(d);d=Db(e+80|0,12198);j[114630]=0;F(219,e+96|0,d|0);g=j[114630];j[114630]=0;c:{d:{e:{f:{g:{h:{i:{j:{k:{l:{m:{n:{o:{if((g|0)!=1){j[114630]=0;L(427,e+56|0,e+96|0,e+112|1,e+112|0);g=j[114630];j[114630]=0;if((g|0)==1){break o}ob(a+1304460|0,e+56|0);gb(e+56|0);qb(e+96|0);gb(d);j[a+1304496>>2]=4;o=hLa(e+96|0,k[f|0]);if(l[a+480190>>1]){f=1;d=1;while(1){j[114630]=0;E(428,b|0,e+56|0)|0;g=j[114630];j[114630]=0;if((g|0)==1){break k}j[114630]=0;F(429,e+56|0,(p(f,104)+a|0)+484380|0);g=j[114630];j[114630]=0;if((g|0)==1){break k}g=k[e+72|0];Nd(e+40|0,o,f-1|0);Qd(e+40|0,(g&3)!=0);d=d+1|0;f=d&65535;if(f>>>0<=l[a+480190>>1]){continue}break}}j[114630]=0;K(430,b|0,a+1304400|0,-1)|0;f=j[114630];j[114630]=0;d=1;if((f|0)!=1){if(l[a+480190>>1]){while(1){j[114630]=0;K(431,b|0,(((d&65535)<<5)+a|0)+946300|0,-1)|0;f=j[114630];j[114630]=0;if((f|0)==1){break m}d=d+1|0;if(l[a+480190>>1]>=(d&65535)>>>0){continue}break}}if(l[a+480188>>1]){d=0;while(1){j[114630]=0;f=(d<<5)+a|0;N(432,f+480280|0);g=j[114630];j[114630]=0;if((g|0)==1){break e}j[114630]=0;K(433,b|0,f+480289|0,-1)|0;f=j[114630];j[114630]=0;if((f|0)==1){break e}d=d+1|0;if(d>>>0<l[a+480188>>1]){continue}break}}f=e+112|4;d=k[f|0]|k[f+1|0]<<8;j[114630]=0;n=a+484344|0;F(401,n|0,d|0);d=j[114630];j[114630]=0;if((d|0)!=1){break l}}b=D()|0;C()|0;break d}b=D()|0;C()|0;break n}b=D()|0;C()|0;qb(e+96|0)}gb(d);break c}b=D()|0;C()|0;break d}if(k[f|0]|k[f+1|0]<<8){d=0;while(1){j[114630]=0;K(434,b|0,e+56|0,-1)|0;g=j[114630];j[114630]=0;p:{q:{if((g|0)==1){break q}j[114630]=0;g=K(402,n|0,d&65535,64)|0;h=j[114630];j[114630]=0;if((h|0)==1){break q}if(!g){break p}g=Hb(n,d);j[114630]=0;E(435,g|0,e+56|0)|0;g=j[114630];j[114630]=0;if((g|0)!=1){break p}}b=D()|0;C()|0;break d}d=d+1|0;if(d>>>0<(k[f|0]|k[f+1|0]<<8)>>>0){continue}break}}j[114630]=0;h=H(357,b|0)|0;d=j[114630];j[114630]=0;if((d|0)==1){break f}r:{if(!h){break r}j[114630]=0;d=E(258,b|0,h|0)|0;g=j[114630];j[114630]=0;if((g|0)==1){break f}if(!d){break r}g=Rt(e+56|0);j[114630]=0;K(436,b|0,g|0,h|0)|0;d=j[114630];j[114630]=0;if((d|0)==1){break h}d=Cb(e+40|0);j[114630]=0;F(111,d|0,h|0);h=j[114630];j[114630]=0;if((h|0)==1){break i}q=e,r=Lb(g),j[q>>2]=r;q=e,r=Mb(g),j[q+32>>2]=r;if(rb(e,e+32|0)){while(1){s:{h=k[j[e>>2]];if(h&128){q=e,r=_e(d),j[q+16>>2]=r;Cd(e+24|0,e+16|0);j[114630]=0;P(437,d|0,j[e+24>>2],h&127,32)|0;h=j[114630];j[114630]=0;if((h|0)!=1){break s}break i}j[114630]=0;F(110,d|0,h<<24>>24);h=j[114630];j[114630]=0;if((h|0)!=1){break s}break i}Xf(e);if(rb(e,e+32|0)){continue}break}}j[114630]=0;L(438,e|0,4,5,d|0);h=j[114630];j[114630]=0;if((h|0)==1){break i}ob(d,e);gb(e);h=zb(d);j[114630]=0;h=H(439,h|0)|0;m=j[114630];j[114630]=0;if((m|0)==1){break i}m=nb(d);j[114630]=0;U(440,a+1304424|0,h|0,m|0,76,0)|0;h=j[114630];j[114630]=0;if((h|0)==1){break i}gb(d);Od(g)}d=Eb(a+484360|0);g=e+112|6;g=k[g|0]|k[g+1|0]<<8;j[114630]=0;U(441,d|0,b|0,g|0,65535,65535)|0;d=j[114630];j[114630]=0;if((d|0)==1){break f}t:{u:{v:{w:{if(!(k[f|0]|k[f+1|0]<<8)){break w}g=c&1;d=0;while(1){j[114630]=0;h=E(258,b|0,4)|0;m=j[114630];j[114630]=0;x:{if((m|0)!=1){if(h){break x}break w}b=D()|0;C()|0;break d}j[114630]=0;h=H(390,b|0)|0;m=j[114630];j[114630]=0;if((m|0)==1){break u}j[114630]=0;I(341,e+56|0,b|0,h|0);h=j[114630];j[114630]=0;if((h|0)==1){break t}y:{if(!g){break y}j[114630]=0;h=E(442,n|0,d&65535)|0;m=j[114630];j[114630]=0;if((m|0)==1){break v}if(!h){break y}h=Hb(n,d);j[114630]=0;I(443,h|0,0,e+56|0);h=j[114630];j[114630]=0;if((h|0)==1){break v}}jb(e+56|0);d=d+1|0;if(d>>>0<(k[f|0]|k[f+1|0]<<8)>>>0){continue}break}}if(!(!(c&2)|!l[a+480190>>1])){f=1;d=1;while(1){c=p(f,104)+a|0;g=l[c+484414>>1];Nd(e+56|0,o,f-1|0);f=Kc(e+40|0,g&1?16:8,1,0,kb(e+56|0)?6:0);j[114630]=0;K(400,f|0,c+484380|0,b|0)|0;c=j[114630];j[114630]=0;if((c|0)==1){break j}d=d+1|0;f=d&65535;if(f>>>0<=l[a+480190>>1]){continue}break}}Vd(o);break b}b=D()|0;C()|0;jb(e+56|0);break d}b=D()|0;C()|0;break d}b=D()|0;C()|0;break d}b=D()|0;C()|0;break d}b=D()|0;C()|0;break d}b=D()|0;C()|0;gb(d);break g}b=D()|0;C()|0}Od(g);break d}b=D()|0;C()|0;break d}b=D()|0;C()|0}Vd(o)}G(b|0);z()}f=1}Za=e+128|0;return f|0}function bd(a,b,c,d,e,f,g,h,i){var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0;m=Za-96|0;Za=m;q=c;w=(g&131071)<<15|f>>>17;k=i&65535;u=k;l=h;D=l<<15|g>>>17;o=(e^i)&-2147483648;p=e&65535;y=p;n=d;z=p;p=0;E=(k&131071)<<15|l>>>17;F=i>>>16&32767;M=e>>>16&32767;a:{b:{if(M-1>>>0<=32765){k=0;if(F-1>>>0<32766){break b}}r=e&2147483647;x=r;k=d;if(!(!k&(r|0)==2147418112?!(b|c):r>>>0<2147418112)){A=d;o=e|32768;break a}e=i&2147483647;r=e;d=h;if(!(!d&(e|0)==2147418112?!(f|g):e>>>0<2147418112)){A=h;o=i|32768;b=f;c=g;break a}if(!(b|k|(x^2147418112|c))){if(!(d|f|(g|r))){o=2147450880;b=0;c=0;break a}o=o|2147418112;b=0;c=0;break a}if(!(d|f|(r^2147418112|g))){d=b|k;e=c|x;b=0;c=0;if(!(d|e)){o=2147450880;break a}o=o|2147418112;break a}if(!(b|k|(c|x))){b=0;c=0;break a}if(!(d|f|(g|r))){b=0;c=0;break a}if((x|0)==65535|x>>>0<65535){h=b;i=c;d=!(n|y);e=d<<6;k=s(d?b:n)+32|0;b=s(d?c:y);b=e+((b|0)==32?k:b)|0;We(m+80|0,h,i,n,y,b-15|0);n=j[m+88>>2];q=j[m+84>>2];z=j[m+92>>2];v=16-b|0;b=j[m+80>>2]}k=v;if(r>>>0>65535){break b}c=!(l|u);d=c<<6;e=s(c?f:l)+32|0;c=s(c?g:u);c=d+((c|0)==32?e:c)|0;i=c;We(m- -64|0,f,g,l,u,c-15|0);e=j[m+76>>2];c=e;h=j[m+72>>2];d=h;d=d<<15;e=j[m+68>>2];D=e>>>17|d;d=0;f=j[m+64>>2];w=d|((e&131071)<<15|f>>>17);E=(c&131071)<<15|h>>>17;k=(v-i|0)+16|0}v=k;d=w;c=b;u=0;r=HMa(d,0,b,u);b=ab;G=b;e=f;B=e<<15&-32768;l=q;g=HMa(B,0,l,0);f=g+r|0;e=ab+b|0;e=f>>>0<g>>>0?e+1|0:e;h=f;k=f;i=0;g=HMa(c,u,B,C);f=i+g|0;b=k;k=k+ab|0;k=f>>>0<g>>>0?k+1|0:k;w=f;g=k;J=(b|0)==(k|0)&f>>>0<i>>>0|b>>>0>k>>>0;N=HMa(d,t,l,H);K=ab;q=n;f=HMa(B,C,n,0);b=f+N|0;k=ab+K|0;O=b;n=HMa(D,0,c,u);i=b+n|0;b=b>>>0<f>>>0?k+1|0:k;f=b+ab|0;x=i;f=i>>>0<n>>>0?f+1|0:f;y=f;k=f;f=(e|0)==(G|0)&h>>>0<r>>>0|e>>>0<G>>>0;h=e+x|0;k=f+k|0;r=h;k=h>>>0<e>>>0?k+1|0:k;n=k;e=h;h=k;Q=HMa(d,t,q,P);G=ab;f=B;I=z|65536;B=p;i=HMa(f,C,I,p);f=i+Q|0;k=ab+G|0;k=f>>>0<i>>>0?k+1|0:k;R=f;C=HMa(D,S,l,H);i=f+C|0;p=k;f=k+ab|0;f=i>>>0<C>>>0?f+1|0:f;L=i;E=E&2147483647|-2147483648;i=HMa(c,u,E,0);c=L+i|0;u=f;k=f+ab|0;C=c;c=c>>>0<i>>>0?k+1|0:k;z=J;i=0;f=i+e|0;k=h+C|0;J=f;h=f;e=z+f|0;z=f>>>0<i>>>0?k+1|0:k;f=z;f=e>>>0<h>>>0?f+1|0:f;h=e;i=f;v=(v+(F+M|0)|0)-16383|0;f=HMa(q,P,D,S);e=ab;t=HMa(d,t,I,B);d=t+f|0;k=ab+e|0;k=d>>>0<t>>>0?k+1|0:k;t=d;f=(e|0)==(k|0)&f>>>0>d>>>0|e>>>0>k>>>0;e=k;F=f;f=HMa(E,T,l,H);d=f+d|0;k=ab+k|0;k=d>>>0<f>>>0?k+1|0:k;f=d;d=k;l=(k|0)==(e|0)&f>>>0<t>>>0|e>>>0>k>>>0;k=F+l|0;e=0;e=k>>>0<l>>>0?1:e;t=f;l=d;F=k;f=(b|0)==(y|0)&x>>>0<O>>>0|b>>>0>y>>>0;b=f+((b|0)==(K|0)&N>>>0>O>>>0|b>>>0<K>>>0)|0;k=0;k=b>>>0<f>>>0?1:k;f=b;b=t+f|0;k=d+k|0;k=b>>>0<f>>>0?k+1|0:k;H=b;d=k;k=(k|0)==(l|0)&b>>>0<t>>>0|k>>>0<l>>>0;b=F+k|0;f=e;f=b>>>0<k>>>0?f+1|0:f;e=HMa(E,T,I,B);b=e+b|0;k=ab+f|0;t=b;e=b>>>0<e>>>0?k+1|0:k;l=HMa(E,T,q,P);f=ab;q=HMa(D,S,I,B);b=q+l|0;k=ab+f|0;k=b>>>0<q>>>0?k+1|0:k;q=b;b=k;k=(f|0)==(k|0)&l>>>0>q>>>0|f>>>0>k>>>0;l=b+t|0;e=e+k|0;e=l>>>0<b>>>0?e+1|0:e;t=l;l=0;b=l+H|0;k=d+q|0;k=b>>>0<l>>>0?k+1|0:k;f=k;l=(d|0)==(k|0)&b>>>0<H>>>0|d>>>0>k>>>0;d=t+l|0;k=e;D=d;d=d>>>0<l>>>0?k+1|0:k;q=b;l=f;f=(p|0)==(u|0)&R>>>0>L>>>0|p>>>0>u>>>0;e=f+((p|0)==(G|0)&Q>>>0>R>>>0|p>>>0<G>>>0)|0;f=e;e=f+((c|0)==(u|0)&C>>>0<L>>>0|c>>>0<u>>>0)|0;f=e;b=c+b|0;e=f+l|0;e=b>>>0<c>>>0?e+1|0:e;p=b;c=b;b=e;e=(e|0)==(l|0)&c>>>0<q>>>0|e>>>0<l>>>0;c=e+D|0;k=d;k=c>>>0<e>>>0?k+1|0:k;d=c;l=d;e=(n|0)==(z|0)&r>>>0>J>>>0|n>>>0>z>>>0;d=e+((n|0)==(y|0)&r>>>0<x>>>0|n>>>0<y>>>0)|0;f=0;f=d>>>0<e>>>0?1:f;n=d;d=d+p|0;e=b+f|0;e=d>>>0<n>>>0?e+1|0:e;c=(b|0)==(e|0)&d>>>0<p>>>0|b>>>0>e>>>0;b=l+c|0;k=b>>>0<c>>>0?k+1|0:k;c=k;c:{if(k&65536){v=v+1|0;break c}n=g>>>31|0;k=c<<1|b>>>31;b=b<<1|e>>>31;c=k;k=e<<1|d>>>31;d=d<<1|i>>>31;e=k;p=w;k=g<<1|p>>>31;w=p<<1;g=k;k=i<<1|h>>>31;h=h<<1|n;i=k}if((v|0)>=32767){o=o|2147418112;b=0;c=0;break a}d:{if((v|0)<=0){f=1-v|0;if(f>>>0>=128){b=0;c=0;break a}k=v+127|0;We(m+48|0,w,g,h,i,k);We(m+32|0,d,e,b,c,k);hm(m+16|0,w,g,h,i,f);hm(m,d,e,b,c,f);w=(j[m+48>>2]|j[m+56>>2])!=0|(j[m+52>>2]|j[m+60>>2])!=0|(j[m+32>>2]|j[m+16>>2]);g=j[m+36>>2]|j[m+20>>2];h=j[m+40>>2]|j[m+24>>2];i=j[m+44>>2]|j[m+28>>2];d=j[m>>2];e=j[m+4>>2];c=j[m+12>>2];b=j[m+8>>2];break d}c=c&65535|v<<16}A=b|A;o=c|o;if(!(!h&(i|0)==-2147483648?!(g|w):(i|0)>-1)){k=e;b=d+1|0;k=b>>>0<1?k+1|0:k;f=b;c=k;f=(e|0)==(k|0)&d>>>0>f>>>0|e>>>0>k>>>0;d=f+A|0;e=o;A=d;o=d>>>0<f>>>0?e+1|0:e;break a}if(h|w|(i^-2147483648|g)){b=d;c=e;break a}c=d&1;b=c+d|0;k=e;k=b>>>0<c>>>0?k+1|0:k;f=b;c=k;e=(e|0)==(k|0)&d>>>0>f>>>0|e>>>0>k>>>0;d=e+A|0;k=o;A=d;o=d>>>0<e>>>0?k+1|0:k}j[a>>2]=b;j[a+4>>2]=c;j[a+8>>2]=A;j[a+12>>2]=o;Za=m+96|0}function xna(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,n=0,o=0,q=0,r=0;f=Za-208|0;Za=f;i[a+480212>>1]=0;j[a+480240>>2]=65536;j[a+480244>>2]=65536;WJ(a+900380|0);VJ(a+946300|0);e=ZJ(f+48|0);j[114630]=0;d=a+906300|0;I(1404,d|0,d+4e4|0,e|0);d=j[114630];j[114630]=0;a:{b:{c:{d:{if((d|0)!=1){Bm(e);e:{if(Tp(b)){e=0;n=f+48|0;sna(n);f:{g:{h:{if(c&16){break h}j[114630]=0;h=(c|0)!=0;g=K(1405,n|0,b|0,h|0)|0;d=j[114630];j[114630]=0;if((d|0)==1){break g}d=4;i:{if(g){break i}j[114630]=0;g=K(1406,n|0,b|0,h|0)|0;d=j[114630];j[114630]=0;if((d|0)==1){break g}d=5;if(g){break i}j[114630]=0;g=K(1407,n|0,b|0,h|0)|0;d=j[114630];j[114630]=0;if((d|0)==1){break g}d=6;if(g){break i}g=0;j[114630]=0;h=K(1408,n|0,b|0,h|0)|0;d=j[114630];j[114630]=0;if((d|0)==1){break g}d=3;if(!h){break h}}if(!c){e=1;break b}if(!Xc(n)){CO(b,Vz(n,0)+12|0)}g=d}if(c&32){break b}d=77952;j:{k:{while(1){o=j[d+8>>2];h=(o>>1)+a|0;e=j[d+4>>2];e=o&1?j[j[h>>2]+e>>2]:e;j[114630]=0;e=K(e|0,h|0,b|0,c|0)|0;h=j[114630];j[114630]=0;if((h|0)!=1){if(e){break j}d=d+12|0;if((d|0)==78408){break k}continue}break}d=J(71412)|0;break f}j[a+480180>>2]=0;j[a+480184>>2]=0}if(!c){break b}if(!(j[a+480184>>2]|!g)){j[a+480184>>2]=g}bx(n);break e}d=J(71412)|0}a=C()|0;bx(n);if((W(71412)|0)!=(a|0)){break c}O(d|0)|0;j[114630]=0;M(81);a=j[114630];j[114630]=0;if((a|0)==1){d=D()|0;C()|0;j[114630]=0;M(20);a=j[114630];j[114630]=0;if((a|0)!=1){break c}J(0)|0;C()|0;ib()}z()}od(a,0);j[a+1074300>>2]=19466242}d=0;while(1){b=(d<<5)+a|0;Rf(b+480286|0,64);b=b+480284|0;if(l[b>>1]>=257){i[b>>1]=128}Tm((p(d,896)+a|0)+1074984|0,a,d&65535);d=d+1|0;if((d|0)!=127){continue}break}if(l[a+480190>>1]){g=a+1304392|0;e=1;while(1){d=p(e&65535,104)+a|0;b=d+484380|0;l:{if(ke(b)){Lx(b,a,0);break l}n=d+484414|0;h=l[n>>1];if(h&16384){break l}j[b>>2]=0;j[b+4>>2]=0;j[b+16>>2]=0;j[b+8>>2]=0;j[b+12>>2]=0;i[n>>1]=h&65505}b=d+484412|0;if(l[b>>1]>=65){i[b>>1]=64}m:{if(!(k[d+484415|0]&2)){break m}if(!Vi(g)){break m}vna(a)}e=e+1|0;if(l[a+480190>>1]>=(e&65535)>>>0){continue}break}}d=0;b=0;while(1){e=j[(((d&65535)<<2)+a|0)+900380>>2];if(e){Mta(e,j[a+480180>>2]);b=d}d=d+1|0;if(l[a+480192>>1]>=(d&65535)>>>0){continue}break}i[a+480192>>1]=b;b=a+480204|0;n:{if(m[a+480204>>2]<1e4){j[b>>2]=125e4;break n}jc(b,65535e4)}b=j[a+480196>>2];if(!b){j[a+480196>>2]=6;b=6}e=j[a+480220>>2];d=j[a+480216>>2];if(e>>>0<d>>>0){j[a+480220>>2]=d;e=d}g=a+1074416|0;j[g>>2]=b;j[a+1074420>>2]=j[a+480204>>2];j[a+1074412>>2]=e;j[a+1074408>>2]=d;j[a+1074444>>2]=j[a+480200>>2];qx(a+1074376|0);j[a+1074440>>2]=-65536;b=a+1074384|0;j[b>>2]=0;j[b+4>>2]=0;j[a+1074380>>2]=0;b=a+1074424|0;j[b>>2]=0;j[b+4>>2]=0;b=a+1074432|0;j[b>>2]=0;j[b+4>>2]=0;b=a+1074396|0;j[b>>2]=0;j[b+4>>2]=0;i[a+480276>>1]=0;j[a+1074392>>2]=j[g>>2];so(a);Ui(a+1304360|0,1);b=a+484360|0;q=f,r=Lb(b),j[q+48>>2]=r;q=f,r=Mb(b),j[q+32>>2]=r;if(!rb(f+48|0,f+32|0)){break d}while(1){b=j[f+48>>2];bg(b,Wi(b));d=l[b+28>>1];if(Yb(b)>>>0<=d>>>0){Fe(b,0)}Jx(f+48|0);if(rb(f+48|0,f+32|0)){continue}break}break d}d=D()|0;C()|0;Bm(e);break c}b=f+48|0;qna(b);o:{p:{q:{r:{s:{t:{u:{v:{w:{if((c&12)==12){d=0;while(1){g=p(d,160)+a|0;c=g+906300|0;e=c+16|0;h=k[e|0]|k[e+1|0]<<8|(k[e+2|0]<<16|k[e+3|0]<<24);e=c+20|0;x:{if(!(h|(k[e|0]|k[e+1|0]<<8|(k[e+2|0]<<16|k[e+3|0]<<24)))){break x}j[114630]=0;E(1409,c|0,a|0)|0;e=j[114630];j[114630]=0;y:{if((e|0)!=1){e=j[c>>2];if(!e){break y}c=j[g+906448>>2];g=j[j[e>>2]+56>>2];j[114630]=0;F(g|0,e|0,c|0);c=j[114630];j[114630]=0;if((c|0)!=1){break x}}d=D()|0;C()|0;break o}q=f,r=una(Lb(b),Mb(b),c),j[q+32>>2]=r;q=f,r=Mb(b),j[q+16>>2]=r;if(rb(f+32|0,f+16|0)){break x}j[114630]=0;j[f+32>>2]=g+906316;F(1410,b|0,f+32|0);e=j[114630];j[114630]=0;if((e|0)==1){break p}j[114630]=0;e=E(2,f+16|0,20526)|0;g=j[114630];j[114630]=0;if((g|0)==1){break w}c=NJ(c);j[114630]=0;I(6,f|0,0,c|0);c=j[114630];j[114630]=0;if((c|0)==1){break v}j[114630]=0;I(3,f+32|0,e|0,f|0);c=j[114630];j[114630]=0;if((c|0)==1){break u}j[114630]=0;I(646,a|0,2,f+32|0);c=j[114630];j[114630]=0;if((c|0)==1){break t}gb(f+32|0);gb(f);gb(e)}d=d+1|0;if((d|0)!=250){continue}break}}c=j[a+1074368>>2];j[114630]=0;F(1411,a|0,c|0);c=j[114630];j[114630]=0;if((c|0)==1){break q}c=j[a+480180>>2];z:{if(!c){break z}Hr(a+8|0,vo(a));if(!j[a+1074304>>2]){break z}j[114630]=0;N(1412,a|0);a=j[114630];j[114630]=0;if((a|0)==1){break q}}MJ(b);e=(c|0)!=0;break a}d=D()|0;C()|0;break o}d=D()|0;C()|0;break r}d=D()|0;C()|0;break s}d=D()|0;C()|0;gb(f+32|0)}gb(f)}gb(e);break o}d=D()|0;C()|0;break o}d=D()|0;C()|0}MJ(b)}G(d|0);z()}bx(n)}Za=f+208|0;return e|0}function z5(a,b,c,d,e,f,g){var m=0,o=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=q(0),D=0,E=0,F=0,G=q(0),H=0,I=0,J=0,K=0,L=q(0),M=0,N=0,O=0,P=0;u=Za-2368|0;Za=u;A=j[a+404>>2];D=k[c+1|0];H=A+p(D,40)|0;I=j[((k[c|0]<<2)+a|0)+104>>2];a:{t=j[a+4>>2];b:{if((t|0)>=1){while(1){m=k[(j[H+4>>2]+p(B,3)|0)+2|0];K=(u+1344|0)+(B<<2)|0;j[K>>2]=0;m=k[(m+H|0)+9|0];if(!l[((m<<1)+a|0)+132>>1]){Nb(a,21);a=0;break b}o=j[a+260>>2];c:{d:{if(Tb(a,1)){s=2;v=j[((B<<2)+a|0)+996>>2];t=o+p(m,1596)|0;J=j[(k[t+1588|0]<<2)+50684>>2];m=Sk(J)-1|0;O=v,P=Tb(a,m),i[O>>1]=P;O=v,P=Tb(a,m),i[O+2>>1]=P;w=0;if(k[t|0]){while(1){M=k[(t+w|0)+1|0];m=t+M|0;y=k[m+33|0];o=0;E=k[m+49|0];e:{if(!E){break e}m=j[a+124>>2]+p(k[m+65|0],2096)|0;if(j[a+1396>>2]<=9){Dj(a)}r=j[a+1392>>2];o=i[(m+((r&1023)<<1)|0)+36>>1];f:{if((o|0)>=0){x=r;r=k[o+j[m+8>>2]|0];j[a+1392>>2]=x>>>r;x=j[a+1396>>2]-r|0;r=(x|0)<0;j[a+1396>>2]=r?0:x;o=r?-1:o;break f}o=Qk(a,m)}if(!k[m+23|0]){break e}o=j[j[m+2088>>2]+(o<<2)>>2]}if(y){N=-1<<E^-1;y=s+y|0;while(1){m=0;r=i[((t+(M<<4)|0)+((o&N)<<1)|0)+82>>1];g:{if((r|0)<0){break g}r=j[a+124>>2]+p(r&65535,2096)|0;if(j[a+1396>>2]<=9){Dj(a)}x=j[a+1392>>2];m=i[(r+((x&1023)<<1)|0)+36>>1];h:{if((m|0)>=0){F=x;x=k[m+j[r+8>>2]|0];j[a+1392>>2]=F>>>x;F=j[a+1396>>2]-x|0;x=(F|0)<0;j[a+1396>>2]=x?0:F;m=x?-1:m;break h}m=Qk(a,r)}if(!k[r+23|0]){break g}m=j[j[r+2088>>2]+(m<<2)>>2]}o=o>>E;i[v+(s<<1)>>1]=m;s=s+1|0;if((y|0)!=(s|0)){continue}break}s=y}w=w+1|0;if(w>>>0<k[t|0]){continue}break}}if(j[a+1396>>2]!=-1){break d}}j[K>>2]=1;break c}i[u+320>>1]=257;y=t+1592|0;s=j[t+1592>>2];if((s|0)>=3){o=2;while(1){s=o<<1;w=s+t|0;E=k[w+1088|0];m=E<<1;r=t+338|0;F=l[s+r>>1];K=l[m+r>>1];x=r;w=k[w+1089|0];r=w<<1;m=l5(F,K,l[x+r>>1],i[m+v>>1],i[r+v>>1]);x=s+v|0;r=l[x>>1];i:{j:{if(r){h[w+(u+320|0)|0]=1;h[E+(u+320|0)|0]=1;h[(u+320|0)+o|0]=1;s=r<<16>>16;w=J-m|0;if((s|0)>=((m|0)>(w|0)?w:m)<<1){if((m|0)<(w|0)){break i}m=(r^-1)+J|0;break j}if(s&1){m=m-(s+1>>>1|0)|0;break j}m=(s>>1)+m|0;break j}h[(u+320|0)+o|0]=0}i[x>>1]=m}s=j[y>>2];o=o+1|0;if((s|0)>(o|0)){continue}break}}m=0;if((s|0)<=0){break c}while(1){if(!k[(u+320|0)+m|0]){i[v+(m<<1)>>1]=65535;s=j[y>>2]}m=m+1|0;if((s|0)>(m|0)){continue}break}}t=j[a+4>>2];B=B+1|0;if((t|0)>(B|0)){continue}break}}k:{l:{o=j[a+80>>2];if(!(j[a+84>>2]!=j[a+92>>2]?o:0)){Vb(u+320|0,u+1344|0,t<<2);m=l[H>>1];if(m){y=m>>>0>1?m:1;v=j[(A+p(D,40)|0)+4>>2];m=0;while(1){r=v+p(m,3)|0;s=k[r+1|0];r=(u+1344|0)+(k[r|0]<<2)|0;if(!(j[(u+1344|0)+(s<<2)>>2]?j[r>>2]:0)){j[(u+1344|0)+(s<<2)>>2]=0;j[r>>2]=0}m=m+1|0;if((y|0)!=(m|0)){continue}break}}y=I>>1;v=A+p(D,40)|0;if(k[v+8|0]){s=0;while(1){o=0;if((t|0)>=1){w=j[v+4>>2];m=0;while(1){if(k[(w+p(m,3)|0)+2|0]==(s|0)){J=o+u|0;r=m<<2;m:{if(j[r+(u+1344|0)>>2]){B=1;r=0;break m}B=0;r=j[(a+r|0)+800>>2]}h[J|0]=B;j[(u+256|0)+(o<<2)>>2]=r;o=o+1|0}m=m+1|0;if((t|0)>(m|0)){continue}break}}k5(a,u+256|0,o,y,k[(s+v|0)+24|0],u);s=s+1|0;if(s>>>0<k[v+8|0]){t=j[a+4>>2];continue}break}o=j[a+80>>2]}if(!(j[a+84>>2]!=j[a+92>>2]?o:0)){o=l[H>>1];if(o){v=(y|0)>1?y:1;r=A+p(D,40)|0;t=a+800|0;while(1){s=o;o=o-1|0;if((I|0)>=2){m=j[r+4>>2]+p(o,3)|0;B=j[t+(k[m+1|0]<<2)>>2];D=j[t+(k[m|0]<<2)>>2];m=0;while(1){A=m<<2;w=A+B|0;G=n[w>>2];A=A+D|0;C=n[A>>2];n:{if(!(C<=q(0))){if(!(G<=q(0))){L=q(C-G);break n}L=C;C=q(G+C);break n}if(!(G<=q(0))){L=q(G+C);break n}L=C;C=q(C-G)}n[A>>2]=C;n[w>>2]=L;m=m+1|0;if((v|0)!=(m|0)){continue}break}}if((s|0)>1){continue}break}}if(j[a+4>>2]<1){break k}s=y<<2;m=0;while(1){t=m<<2;v=t+a|0;o=v;o:{if(j[t+(u+320|0)>>2]){Ab(j[o+800>>2],0,s);break o}j5(a,H,m,I,j[o+800>>2],j[v+996>>2])}m=m+1|0;o=j[a+4>>2];if((m|0)<(o|0)){continue}break}break l}Y(50456,50512,3319,50704);z()}Y(50456,50512,3286,50704);z()}m=0;if((o|0)<=0){break k}while(1){i5(j[((m<<2)+a|0)+800>>2],I,a,k[c|0]);m=m+1|0;if((m|0)<j[a+4>>2]){continue}break}}PE(a);p:{if(k[a+1377|0]){j[a+1060>>2]=0-y;h[a+1377|0]=0;j[a+1064>>2]=1;j[a+1412>>2]=I-f;break p}c=j[a+1412>>2];if(!c){break p}m=e-d|0;if((m|0)<=(c|0)){j[a+1412>>2]=c-m;j[g>>2]=e;d=e;break p}d=c+d|0;j[g>>2]=d;j[a+1412>>2]=0}c=j[a+1064>>2];q:{r:{s:{if(j[a+1388>>2]==j[a+1404>>2]){t:{if(!c|!(k[a+1375|0]&4)){break t}c=j[a+1408>>2];g=j[a+1060>>2];if(c>>>0>=g+(f-d|0)>>>0){break t}e=b;b=c-g|0;b=(b>>>0>c>>>0?0:b)+d|0;b=(b|0)>(f|0)?f:b;j[e>>2]=b;j[a+1060>>2]=b+j[a+1060>>2];break q}j[a+1064>>2]=1;j[a+1060>>2]=j[a+1408>>2]+(d-y|0);break s}if(!c){break r}}j[a+1060>>2]=j[a+1060>>2]+(e-d|0)}if(j[a+84>>2]!=j[a+92>>2]?j[a+80>>2]:0){break a}j[b>>2]=f}a=1}Za=u+2368|0;return a}Y(50456,50512,3435,50704);z()}function Vza(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,u=0;e=Za-80|0;Za=e;rc(b);a:{b:{c:{d:{e:{if(eO(b,16628)){g=lp(e- -64|0);h=lp(e+48|0);q=zs(e+32|0);j[114630]=0;F(447,a|0,32768);d=j[114630];j[114630]=0;if((d|0)==1){break b}j[114630]=0;d=E(2,e+8|0,16637)|0;m=j[114630];j[114630]=0;if((m|0)==1){break c}ob(a+1304436|0,d);gb(d);j[114630]=0;d=E(2,e+8|0,16647)|0;m=j[114630];j[114630]=0;if((m|0)==1){break d}ob(a+1304448|0,d);gb(d);j[a+1304496>>2]=2;n=a+484360|0;m=e+24|4;f:{g:{h:{i:{j:{while(1){j[114630]=0;d=E(258,b|0,8)|0;f=j[114630];j[114630]=0;if((f|0)==1){break i}k:{l:{m:{n:{if(!d){break n}j[114630]=0;d=E(923,b|0,e+24|0)|0;f=j[114630];j[114630]=0;if((f|0)==1){break m}if(!d){break n}d=m;d=k[d|0]|k[d+1|0]<<8|(k[d+2|0]<<16|k[d+3|0]<<24);j[114630]=0;I(341,e+8|0,b|0,d<<8&16711680|d<<24|(d>>>8&65280|d>>>24));d=j[114630];j[114630]=0;if((d|0)==1){break l}j[114630]=0;d=H(337,e+8|0)|0;f=j[114630];j[114630]=0;if((f|0)==1){break e}if(d){break k}jb(e+8|0)}if(l[a+480188>>1]){break j}d=0;break f}a=D()|0;C()|0;break a}a=D()|0;C()|0;break a}o:{p:{q:{r:{s:{t:{d=e+24|0;d=k[d|0]|k[d+1|0]<<8|(k[d+2|0]<<16|k[d+3|0]<<24);d=d<<24|d<<8&16711680|(d>>>8&65280|d>>>24);if((d|0)<=1347175757){if((d|0)==1129140036){break t}if((d|0)==1346458708){break r}if((d|0)!=1346522948){break p}if(Zc(g)>>>0>255){break p}j[114630]=0;F(601,g|0,e+8|0);d=j[114630];j[114630]=0;if((d|0)==1){break e}break p}if((d|0)<=1396854595){if((d|0)==1347175758){break s}if(l[a+480190>>1]|(d|0)!=1396788560){break p}j[114630]=0;I(924,e+8|0,q|0,a|0);d=j[114630];j[114630]=0;if((d|0)==1){break e}break p}if((d|0)==1396854596){break q}if((d|0)!=1397769541){break p}j[114630]=0;d=H(255,e+8|0)|0;f=j[114630];j[114630]=0;if((f|0)==1){break e}if(d>>>0<2){break p}j[114630]=0;d=H(484,e+8|0)|0;f=j[114630];j[114630]=0;if((f|0)==1){break e}t=a,u=kd(d,1,255),j[t+480196>>2]=u;break p}if(l[a+480188>>1]){break p}j[114630]=0;d=H(255,e+8|0)|0;f=j[114630];j[114630]=0;if((f|0)==1){break e}f=0;if(d>>>0<8){break p}while(1){j[114630]=0;o=H(387,e+8|0)|0;d=j[114630];j[114630]=0;if((d|0)==1){break o}j[114630]=0;r=H(387,e+8|0)|0;d=j[114630];j[114630]=0;if((d|0)==1){break e}d=l[a+480188>>1];if(o|r){j[114630]=0;N(432,((d<<5)+a|0)+480280|0);d=j[114630];j[114630]=0;if((d|0)==1){break e}o=l[a+480188>>1];d=o+1|0;i[a+480188>>1]=d;i[((o<<5)+a|0)+480284>>1]=f-1>>>0<2?192:64}j[114630]=0;N(432,(((d&65535)<<5)+a|0)+480280|0);d=j[114630];j[114630]=0;if((d|0)==1){break e}d=l[a+480188>>1];i[a+480188>>1]=d+1;i[((d<<5)+a|0)+480284>>1]=f-1>>>0<2?192:64;f=f+1|0;if((f|0)!=4){continue}break}if(c){break p}jb(e+8|0);break g}j[114630]=0;d=H(255,e+8|0)|0;f=j[114630];j[114630]=0;if((f|0)==1){break e}if(d>>>0<2){break p}j[114630]=0;s=H(484,e+8|0)|0;d=j[114630];j[114630]=0;if((d|0)==1){break e}break p}d=Eb(n);j[114630]=0;f=H(255,e+8|0)|0;o=j[114630];j[114630]=0;if((o|0)==1){break e}j[114630]=0;U(581,d|0,e+8|0,f|0,255,254)|0;d=j[114630];j[114630]=0;if((d|0)!=1){break p}break e}if(Zc(h)>>>0>3998){break p}j[114630]=0;d=H(255,e+8|0)|0;f=j[114630];j[114630]=0;if((f|0)==1){break e}if(!d){break p}j[114630]=0;F(601,h|0,e+8|0);d=j[114630];j[114630]=0;if((d|0)==1){break e}}jb(e+8|0);continue}break}break e}j[a+480200>>2]=256;j[a+480204>>2]=125e4;j[a+480260>>2]=452;j[a+480264>>2]=3424;j[a+480228>>2]=48;j[a+480232>>2]=48;b=Eb(n);j[114630]=0;F(925,b|0,s&65535);b=j[114630];j[114630]=0;if((b|0)==1){break b}u:{if(!(c&1)){break u}d=0;b=Zc(g);j[114630]=0;F(401,a+484344|0,b&65535);b=j[114630];j[114630]=0;if((b|0)==1){break b}if(!Zc(g)){break u}b=0;while(1){d=$b(g,d);j[114630]=0;I(926,d|0,b&65535,a|0);d=j[114630];j[114630]=0;if((d|0)==1){break h}b=b+1|0;d=b&65535;if(Zc(g)>>>0>d>>>0){continue}break}}d=1;if(l[a+480190>>1]<2){break f}m=c&2;f=1;b=0;v:{while(1){if(!m|Zc(h)>>>0<=b>>>0){break g}w:{c=(p(f,104)+a|0)+484380|0;if(j[c>>2]){d=$b(h,b);j[114630]=0;d=H(255,d|0)|0;n=j[114630];j[114630]=0;if((n|0)==1){break w}jc(c,d);Nd(e+8|0,q,f-1|0);d=Kc(e+24|0,8,1,1,kb(e+8|0)?10:0);n=$b(h,b);j[114630]=0;K(400,d|0,c|0,n|0)|0;c=j[114630];j[114630]=0;if((c|0)==1){break v}b=b+1|0}d=1;f=f+1|0;if(f>>>0<l[a+480190>>1]){continue}break f}break}a=D()|0;C()|0;break a}a=D()|0;C()|0;break a}a=D()|0;C()|0;break a}a=D()|0;C()|0;break a}d=1}Vd(q);Sc(h);Sc(g)}Za=e+80|0;return d|0}a=D()|0;C()|0;jb(e+8|0);break a}a=D()|0;C()|0;break a}a=D()|0;C()|0;break a}a=D()|0;C()|0}Vd(q);Sc(h);Sc(g);G(a|0);z()}function sW(a,b){var c=0,d=0,e=0,f=0;c=Za-176|0;Za=c;f=yv(c+160|0);a:{b:{c:{d:{e:{f:{g:{h:{i:{j:{k:{l:{m:{n:{o:{d=j[b>>2];if(d&1){j[114630]=0;j[c+144>>2]=19466242;F(242,c+96|0,c+144|0);d=j[114630];j[114630]=0;if((d|0)==1){break o}j[114630]=0;F(201,f|0,c+96|0);d=j[114630];j[114630]=0;if((d|0)==1){break n}gb(c+96|0);d=j[b>>2]}if(!(d&4)){break l}j[114630]=0;d=T(243)|0;e=j[114630];j[114630]=0;if((e|0)==1){break k}if(!d){break m}break l}b=D()|0;C()|0;break a}b=D()|0;C()|0;gb(c+96|0);break a}j[114630]=0;N(244,c+96|0);d=j[114630];j[114630]=0;p:{if((d|0)!=1){j[114630]=0;F(201,f|0,c+96|0);d=j[114630];j[114630]=0;if((d|0)==1){break p}gb(c+96|0);break l}b=D()|0;C()|0;break a}b=D()|0;C()|0;gb(c+96|0);break a}q:{d=j[b>>2];if(!(d&8)){break q}j[114630]=0;d=E(2,c+128|0,7142)|0;e=j[114630];j[114630]=0;r:{s:{t:{u:{v:{if((e|0)!=1){j[114630]=0;F(219,c+144|0,d|0);e=j[114630];j[114630]=0;if((e|0)==1){break v}j[114630]=0;I(245,c+96|0,c+144|0,7152);e=j[114630];j[114630]=0;if((e|0)==1){break u}j[114630]=0;F(201,f|0,c+96|0);e=j[114630];j[114630]=0;if((e|0)==1){break t}gb(c+96|0);qb(c+144|0);gb(d);d=j[b>>2];break q}b=D()|0;C()|0;break a}b=D()|0;C()|0;break r}b=D()|0;C()|0;break s}b=D()|0;C()|0;gb(c+96|0)}qb(c+144|0)}gb(d);break a}w:{if(!(d&16)){break w}j[114630]=0;N(236,c+96|0);d=j[114630];j[114630]=0;x:{y:{z:{A:{B:{C:{D:{E:{F:{G:{H:{I:{J:{K:{L:{M:{N:{O:{P:{Q:{R:{S:{T:{U:{V:{if((d|0)!=1){j[114630]=0;F(246,c+144|0,c+96|0);d=j[114630];j[114630]=0;if((d|0)==1){break y}d=Ec(c+144|0);gb(c+144|0);if(!d){j[114630]=0;d=E(2,c- -64|0,7156)|0;e=j[114630];j[114630]=0;if((e|0)==1){break V}j[114630]=0;F(219,c+80|0,d|0);e=j[114630];j[114630]=0;if((e|0)==1){break U}j[114630]=0;F(246,c+48|0,c+96|0);e=j[114630];j[114630]=0;if((e|0)==1){break T}j[114630]=0;I(247,c+144|0,c+80|0,c+48|0);e=j[114630];j[114630]=0;if((e|0)==1){break S}j[114630]=0;F(201,f|0,c+144|0);e=j[114630];j[114630]=0;if((e|0)==1){break R}gb(c+144|0);gb(c+48|0);qb(c+80|0);gb(d)}if(!Ec(Ag(c+96|0))){j[114630]=0;d=E(2,c+32|0,7160)|0;e=j[114630];j[114630]=0;if((e|0)==1){break N}j[114630]=0;F(219,c+80|0,d|0);e=j[114630];j[114630]=0;if((e|0)==1){break M}e=Ag(c+96|0);j[114630]=0;I(247,c+144|0,c+80|0,e|0);e=j[114630];j[114630]=0;if((e|0)==1){break L}j[114630]=0;F(201,f|0,c+144|0);e=j[114630];j[114630]=0;if((e|0)==1){break K}gb(c+144|0);qb(c+80|0);gb(d)}j[114630]=0;F(248,c+144|0,c+96|0);d=j[114630];j[114630]=0;if((d|0)==1){break H}d=Ec(c+144|0);gb(c+144|0);if(!d){j[114630]=0;d=E(2,c+16|0,7156)|0;e=j[114630];j[114630]=0;if((e|0)==1){break G}j[114630]=0;F(219,c+80|0,d|0);e=j[114630];j[114630]=0;if((e|0)==1){break F}j[114630]=0;F(248,c+48|0,c+96|0);e=j[114630];j[114630]=0;if((e|0)==1){break E}j[114630]=0;I(247,c+144|0,c+80|0,c+48|0);e=j[114630];j[114630]=0;if((e|0)==1){break D}j[114630]=0;F(201,f|0,c+144|0);e=j[114630];j[114630]=0;if((e|0)==1){break C}gb(c+144|0);gb(c+48|0);qb(c+80|0);gb(d)}Ie(c+96|0);d=j[b>>2];break w}b=D()|0;C()|0;break a}b=D()|0;C()|0;break x}b=D()|0;C()|0;break O}b=D()|0;C()|0;break P}b=D()|0;C()|0;break Q}b=D()|0;C()|0;gb(c+144|0)}gb(c+48|0)}qb(c+80|0)}gb(d);break x}b=D()|0;C()|0;break x}b=D()|0;C()|0;break I}b=D()|0;C()|0;break J}b=D()|0;C()|0;gb(c+144|0)}qb(c+80|0)}gb(d);break x}b=D()|0;C()|0;break x}b=D()|0;C()|0;break x}b=D()|0;C()|0;break z}b=D()|0;C()|0;break A}b=D()|0;C()|0;break B}b=D()|0;C()|0;gb(c+144|0)}gb(c+48|0)}qb(c+80|0)}gb(d);break x}b=D()|0;C()|0}Ie(c+96|0);break a}W:{if(!(d&32)){break W}j[114630]=0;d=T(243)|0;e=j[114630];j[114630]=0;if((e|0)==1){break k}if(d){break W}Qc(c+96|0);j[114630]=0;F(201,f|0,c+96|0);d=j[114630];j[114630]=0;if((d|0)==1){break b}gb(c+96|0)}if(k[b|0]&64){j[114630]=0;N(249,c+96|0);b=j[114630];j[114630]=0;if((b|0)==1){break j}j[114630]=0;F(201,f|0,c+96|0);b=j[114630];j[114630]=0;if((b|0)==1){break i}gb(c+96|0)}j[114630]=0;d=E(2,c+96|0,7166)|0;b=j[114630];j[114630]=0;if((b|0)==1){break h}j[114630]=0;I(250,c|0,f|0,d|0);b=j[114630];j[114630]=0;if((b|0)==1){break g}j[114630]=0;e=E(2,c+144|0,10991)|0;b=j[114630];j[114630]=0;if((b|0)==1){break f}j[114630]=0;I(251,a|0,c|0,e|0);a=j[114630];j[114630]=0;if((a|0)==1){break e}gb(e);gb(c);gb(d);Rk(f);Za=c+176|0;return}b=D()|0;C()|0;break a}b=D()|0;C()|0;break a}b=D()|0;C()|0;gb(c+96|0);break a}b=D()|0;C()|0;break a}b=D()|0;C()|0;break c}b=D()|0;C()|0;break d}b=D()|0;C()|0;gb(e)}gb(c)}gb(d);break a}b=D()|0;C()|0;gb(c+96|0)}Rk(f);G(b|0);z()}function rKa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,u=0;e=Za-3040|0;Za=e;rc(b);l=e+1080|0;f=oKa(b,l);if(!f){_R(l)}a:{if(!f){break a}if(!cS(e+1080|0)){break a}if(!c){d=1;break a}if(!yb(b,Tc(1024,0))){break a}bS(b,e+560|0);bS(b,e+48|0);while(1){l=g<<2;f=l+(e+560|0)|0;if((k[f|0]|k[f+1|0]<<8|(k[f+2|0]<<16|k[f+3|0]<<24))>>>0>16777215){break a}l=l+(e+48|0)|0;if((k[l|0]|k[l+1|0]<<8|(k[l+2|0]<<16|k[l+3|0]<<24))>>>0<3|(k[l|0]|k[l+1|0]<<8|(k[l+2|0]<<16|k[l+3|0]<<24))>>>0>4096){break a}if(!aS(b,((k[f|0]|k[f+1|0]<<8|(k[f+2|0]<<16|k[f+3|0]<<24))+(k[l|0]|k[l+1|0]<<8|(k[l+2|0]<<16|k[l+3|0]<<24))|0)+2978|0)){break a}g=g+1|0;if((g|0)!=128){continue}break}od(a,2);Zh(a);d=Db(e+16|0,12301);ob(a+1304436|0,d);gb(d);d=Db(e+16|0,12306);ob(a+1304448|0,d);gb(d);d=Db(e+16|0,12310);ob(a+1304460|0,d);gb(d);j[a+1304496>>2]=4;d=k[e+1080|0];j[a+480204>>2]=143e4;j[a+480196>>2]=d;m=a+484360|0;Fe(Eb(m),k[e+1081|0]);j[a+480188>>2]=4194317;vb(a+1074308|0,95,1);d=0;while(1){i[((d<<5)+a|0)+480284>>1]=d&1?192:64;d=d+1|0;if((d|0)!=4){continue}break}d=0;b:{c:{d:{e:{while(1){g=d+1|0;l=p(g,104)+a|0;f=l+484380|0;md(f,2);si(e+32|0,1,(p(d,13)+e|0)+1082|0);qc(e+16|0,e+32|0);j[114630]=0;E(369,((g<<5)+a|0)+946300|0,e+16|0)|0;o=j[114630];j[114630]=0;if((o|0)==1){break e}gb(e+16|0);r=f;d=(e+1080|0)+(d<<4)|0;f=d+422|0;j[r>>2]=k[f|0]|k[f+1|0]<<8|(k[f+2|0]<<16|k[f+3|0]<<24);if((k[d+430|0]|k[d+431|0]<<8|(k[d+432|0]<<16|k[d+433|0]<<24))>>>0<=(k[d+422|0]|k[d+423|0]<<8|(k[d+424|0]<<16|k[d+425|0]<<24))>>>0){j[l+484384>>2]=k[d+426|0]|k[d+427|0]<<8|(k[d+428|0]<<16|k[d+429|0]<<24);d=k[d+430|0]|k[d+431|0]<<8|(k[d+432|0]<<16|k[d+433|0]<<24);i[l+484414>>1]=2;j[l+484388>>2]=d}j[l+484404>>2]=8287;d=g;if((d|0)!=32){continue}break}g=0;while(1){d=g+33|0;l=(p(d,104)+a|0)+484380|0;md(l,2);si(e+32|0,1,(p(g,13)+e|0)+2010|0);qc(e+16|0,e+32|0);j[114630]=0;E(369,((d<<5)+a|0)+946300|0,e+16|0)|0;d=j[114630];j[114630]=0;if((d|0)==1){break d}gb(e+16|0);j[e+24>>2]=0;j[e+16>>2]=0;j[e+20>>2]=0;d=(e+1080|0)+p(g,11)|0;f=k[d+1347|0];t=Pb(e+16|0,0),u=f,h[t|0]=u;f=k[d+1352|0];t=Pb(e+16|0,1),u=f,h[t|0]=u;f=k[d+1348|0];t=Pb(e+16|0,2),u=f,h[t|0]=u;f=k[d+1353|0];t=Pb(e+16|0,3),u=f,h[t|0]=u;f=k[d+1349|0];t=Pb(e+16|0,4),u=f,h[t|0]=u;f=k[d+1354|0];t=Pb(e+16|0,5),u=f,h[t|0]=u;f=k[d+1350|0];t=Pb(e+16|0,6),u=f,h[t|0]=u;f=k[d+1355|0];t=Pb(e+16|0,7),u=f,h[t|0]=u;f=k[d+1351|0];t=Pb(e+16|0,8),u=f,h[t|0]=u;f=k[d+1356|0];t=Pb(e+16|0,9),u=f,h[t|0]=u;d=k[d+1346|0];t=Pb(e+16|0,10),u=d,h[t|0]=u;j[e+8>>2]=j[e+24>>2];d=j[e+20>>2];j[e>>2]=j[e+16>>2];j[e+4>>2]=d;Ro(l,1,e);g=g+1|0;if((g|0)!=32){continue}break}xt(Eb(m),e+2778|0,256,255,65535);o=a+484344|0;Jf(o,128);r=c&1;l=0;f:{while(1){g=l<<2;d=g+(e+560|0)|0;xc(b,(k[d|0]|k[d+1|0]<<8|(k[d+2|0]<<16|k[d+3|0]<<24))+2978|0);d=g+(e+48|0)|0;cd(e+16|0,b,k[d|0]|k[d+1|0]<<8|(k[d+2|0]<<16|k[d+3|0]<<24));g:{if(!r){break g}j[114630]=0;d=K(402,o|0,l&65535,64)|0;g=j[114630];j[114630]=0;if((g|0)==1){break c}if(!d){break g}d=0;f=Hb(o,l);while(1){j[114630]=0;g=E(258,e+16|0,1)|0;m=j[114630];j[114630]=0;h:{i:{if((m|0)!=1){if(!g){break g}j[114630]=0;g=H(387,e+16|0)|0;m=j[114630];j[114630]=0;if((m|0)==1){break c}if(g>>>0>12){break i}j[114630]=0;m=K(471,f|0,d|0,g|0)|0;n=j[114630];j[114630]=0;if((n|0)==1){break c}j[114630]=0;F(472,e+32|0,e+16|0);n=j[114630];j[114630]=0;if((n|0)==1){break c}n=Pc(e+32|0);q=e+32|0;s=k[q|0];g=g>>>0>3;h[m|0]=((s&15)+(g?13:37)|0)+p(s>>>4&7,12);h[m+1|0]=((k[n|0]>>>4|0)+(g?33:1)|0)+(k[q|0]>>>3&16);$R(m,k[n|0],g);break h}break c}m=g-32|0;if((m&255)>>>0<=12){j[114630]=0;m=K(471,f|0,d|0,m&65535)|0;n=j[114630];j[114630]=0;if((n|0)==1){break c}j[114630]=0;n=H(387,e+16|0)|0;q=j[114630];j[114630]=0;if((q|0)==1){break c}$R(m,n,g>>>0>35);break h}if((g|0)!=64){if((g|0)!=96){break f}if(!d){break g}j[114630]=0;d=K(471,f|0,d-1|0,0)|0;g=j[114630];j[114630]=0;if((g|0)==1){break c}h[d+3|0]=14;break g}j[114630]=0;g=H(387,e+16|0)|0;m=j[114630];j[114630]=0;if((m|0)==1){break c}d=d+g|0}if(d>>>0<64){continue}break}}jb(e+16|0);l=l+1|0;if((l|0)!=128){continue}break}d=1;if(!(c&2)){break a}g=1;while(1){$f(Kc(e+16|0,8,1,0,1),(p(g,104)+a|0)+484380|0,b);g=g+1|0;if((g|0)!=33){continue}break}break a}jb(e+16|0);d=0;break a}d=D()|0;C()|0;gb(e+16|0);break b}d=D()|0;C()|0;gb(e+16|0);break b}d=D()|0;C()|0;jb(e+16|0)}G(d|0);z()}Za=e+3040|0;return d|0}function pG(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0;e=Za-416|0;Za=e;h[e+415|0]=c;a:{if(Ri(b)){break a}f=k[Fj(b)|0];c=1;b:{if((f|0)==33){break b}if((f|0)!=63){break a}c=0}d=c;Qj(e+160|0,b,j[b+4>>2]-1|0);c=j[e+164>>2];j[b>>2]=j[e+160>>2];j[b+4>>2]=c}ld(e+160|0);c=j[e+160>>2];ld(e+376|0);g=Ej(c,j[e+380>>2],b);ld(e+160|0);c=j[b>>2];f=j[b+4>>2];c:{d:{e:{f:{if((g|0)==j[e+164>>2]){j[e+400>>2]=c;j[e+404>>2]=f;a=_b(e+392|0,38235);c=j[e+404>>2];j[e+8>>2]=j[e+400>>2];j[e+12>>2]=c;c=j[a+4>>2];j[e>>2]=j[a>>2];j[e+4>>2]=c;if(nc(e+8|0,e)){a=R(8)|0;j[114630]=0;F(2135,e+376|0,e+415|0);b=j[114630];j[114630]=0;g:{h:{i:{if((b|0)!=1){j[114630]=0;I(2113,e+160|0,39307,e+376|0);b=j[114630];j[114630]=0;if((b|0)==1){break i}Wb(a,e+160|0);d=0;j[114630]=0;I(2004,a|0,83648,2012);b=j[114630];j[114630]=0;if((b|0)!=1){break e}b=D()|0;C()|0;gb(e+160|0);break h}b=D()|0;C()|0;break g}b=D()|0;d=1;C()|0}gb(e+376|0);if(!d){break f}}S(a|0);break f}if(!d){break c}a=R(8)|0;j[114630]=0;d=E(2136,e+344|0,b|0)|0;b=j[114630];j[114630]=0;c=1;j:{k:{l:{m:{n:{o:{p:{q:{r:{if((b|0)!=1){j[114630]=0;I(2113,e+360|0,39186,d|0);b=j[114630];j[114630]=0;if((b|0)==1){break r}j[114630]=0;I(2131,e+376|0,e+360|0,39322);b=j[114630];j[114630]=0;if((b|0)==1){break q}j[114630]=0;F(2135,e+328|0,e+415|0);b=j[114630];j[114630]=0;if((b|0)==1){break p}j[114630]=0;I(138,e+160|0,e+376|0,e+328|0);b=j[114630];j[114630]=0;if((b|0)==1){break o}Wb(a,e+160|0);j[114630]=0;I(2004,a|0,83648,2012);b=j[114630];j[114630]=0;if((b|0)!=1){break e}b=D()|0;C()|0;gb(e+160|0);c=0;break n}b=D()|0;C()|0;break j}b=D()|0;C()|0;break k}b=D()|0;C()|0;break l}b=D()|0;C()|0;break m}b=D()|0;C()|0}gb(e+328|0)}gb(e+376|0)}gb(e+360|0)}gb(d)}if(!c){break f}S(a|0);break f}j[e+320>>2]=c;j[e+324>>2]=f;c=_b(e+312|0,38235);d=j[e+324>>2];j[e+152>>2]=j[e+320>>2];j[e+156>>2]=d;d=j[c+4>>2];j[e+144>>2]=j[c>>2];j[e+148>>2]=d;if(!nc(e+152|0,e+144|0)){break d}a=R(8)|0;j[114630]=0;F(2135,e+376|0,e+415|0);b=j[114630];j[114630]=0;s:{t:{u:{if((b|0)!=1){j[114630]=0;I(2113,e+160|0,39307,e+376|0);b=j[114630];j[114630]=0;if((b|0)==1){break u}Wb(a,e+160|0);d=0;j[114630]=0;I(2004,a|0,83648,2012);b=j[114630];j[114630]=0;if((b|0)!=1){break e}b=D()|0;C()|0;gb(e+160|0);break t}b=D()|0;C()|0;break s}b=D()|0;d=1;C()|0}gb(e+376|0);if(!d){break f}}S(a|0)}G(b|0)}z()}c=j[b+4>>2];j[e+304>>2]=j[b>>2];j[e+308>>2]=c;c=_b(e+296|0,38924);d=j[e+308>>2];j[e+136>>2]=j[e+304>>2];j[e+140>>2]=d;d=j[c+4>>2];j[e+128>>2]=j[c>>2];j[e+132>>2]=d;v:{if(!nc(e+136|0,e+128|0)){c=j[b+4>>2];j[e+288>>2]=j[b>>2];j[e+292>>2]=c;c=_b(e+280|0,39221);d=j[e+292>>2];j[e+120>>2]=j[e+288>>2];j[e+124>>2]=d;d=j[c+4>>2];j[e+112>>2]=j[c>>2];j[e+116>>2]=d;if(!nc(e+120|0,e+112|0)){break v}}h[a+60|0]=k[e+415|0];break c}c=j[b+4>>2];j[e+272>>2]=j[b>>2];j[e+276>>2]=c;c=_b(e+264|0,38942);d=j[e+276>>2];j[e+104>>2]=j[e+272>>2];j[e+108>>2]=d;d=j[c+4>>2];j[e+96>>2]=j[c>>2];j[e+100>>2]=d;w:{if(!nc(e+104|0,e+96|0)){c=j[b+4>>2];j[e+256>>2]=j[b>>2];j[e+260>>2]=c;c=_b(e+248|0,39239);d=j[e+260>>2];j[e+88>>2]=j[e+256>>2];j[e+92>>2]=d;d=j[c+4>>2];j[e+80>>2]=j[c>>2];j[e+84>>2]=d;if(!nc(e+88|0,e+80|0)){break w}}h[a+61|0]=k[e+415|0];break c}c=j[b+4>>2];j[e+240>>2]=j[b>>2];j[e+244>>2]=c;c=_b(e+232|0,38961);d=j[e+244>>2];j[e+72>>2]=j[e+240>>2];j[e+76>>2]=d;d=j[c+4>>2];j[e+64>>2]=j[c>>2];j[e+68>>2]=d;if(nc(e+72|0,e- -64|0)){h[a+62|0]=k[e+415|0];break c}c=j[b+4>>2];j[e+224>>2]=j[b>>2];j[e+228>>2]=c;c=_b(e+216|0,38979);d=j[e+228>>2];j[e+56>>2]=j[e+224>>2];j[e+60>>2]=d;d=j[c+4>>2];j[e+48>>2]=j[c>>2];j[e+52>>2]=d;if(nc(e+56|0,e+48|0)){h[a+63|0]=k[e+415|0];break c}c=j[b+4>>2];j[e+208>>2]=j[b>>2];j[e+212>>2]=c;c=_b(e+200|0,39003);d=j[e+212>>2];j[e+40>>2]=j[e+208>>2];j[e+44>>2]=d;d=j[c+4>>2];j[e+32>>2]=j[c>>2];j[e+36>>2]=d;if(nc(e+40|0,e+32|0)){h[a+64|0]=k[e+415|0];break c}c=j[b+4>>2];j[e+192>>2]=j[b>>2];j[e+196>>2]=c;b=_b(e+184|0,39077);c=j[e+196>>2];j[e+24>>2]=j[e+192>>2];j[e+28>>2]=c;c=j[b+4>>2];j[e+16>>2]=j[b>>2];j[e+20>>2]=c;if(!nc(e+24|0,e+16|0)){break c}c=a+24|0;b=j[c>>2];d=b+24664|0;f=j[d+4>>2];j[e+176>>2]=j[d>>2];j[e+180>>2]=f;d=b+24656|0;f=j[d+4>>2];j[e+168>>2]=j[d>>2];j[e+172>>2]=f;d=j[b+24652>>2];j[e+160>>2]=j[b+24648>>2];j[e+164>>2]=d;b=e;if(k[e+415|0]){a=TF(j[a+56>>2])}else{a=0}j[b+180>>2]=a;if(!aw(e+160|0,j[c>>2]+24648|0)){break c}Vw(j[c>>2],e+160|0)}Za=e+416|0}function C9(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0;d=Za-48|0;Za=d;e=Db(d+32|0,38726);f=Ze(c,e);gb(e);a:{b:{c:{d:{e:{f:{g:{h:{i:{j:{k:{if(f){Oi(a,0,j[b+24>>2]+1304448|0);break k}e=Db(d+32|0,38731);f=Ze(c,e);gb(e);if(f){Oi(a,0,j[b+24>>2]+1304436|0);break k}e=Db(d+32|0,38741);f=Ze(c,e);gb(e);if(f){Oi(a,0,j[b+24>>2]+1304484|0);break k}e=Db(d+32|0,38754);f=Ze(c,e);gb(e);if(f){Oi(a,0,j[b+24>>2]+1304472|0);break k}e=Db(d+32|0,38772);f=Ze(c,e);gb(e);if(f){Qla(d+32|0,j[j[b+24>>2]+480184>>2]);j[114630]=0;I(9,a|0,0,d+32|0);a=j[114630];j[114630]=0;if((a|0)==1){break j}gb(d+32|0);break k}e=Db(d+32|0,38782);f=Ze(c,e);gb(e);if(f){Pla(d+32|0,j[j[b+24>>2]+480184>>2]);j[114630]=0;I(9,a|0,0,d+32|0);a=j[114630];j[114630]=0;if((a|0)!=1){gb(d+32|0);break k}c=D()|0;C()|0;gb(d+32|0);break a}e=Db(d+32|0,38797);f=Ze(c,e);gb(e);if(f){Oi(a,0,j[b+24>>2]+1304460|0);break k}e=Db(d+32|0,38805);f=Ze(c,e);gb(e);if(f){Oi(a,0,j[b+24>>2]+1304412|0);break k}e=Db(d+32|0,38812);f=Ze(c,e);gb(e);if(f){Cf(d+32|0,j[b+24>>2]+1304400|0);j[114630]=0;I(2179,a|0,b|0,d+32|0);a=j[114630];j[114630]=0;if((a|0)!=1){gb(d+32|0);break k}c=D()|0;C()|0;gb(d+32|0);break a}e=Db(d+32|0,38818);f=Ze(c,e);gb(e);if(f){l:{b=b+24|0;if(!Xc(Uv(j[b>>2]))){if(j[_F(Uv(j[b>>2]))+12>>2]){break l}}Cb(a);break k}Una(d+32|0,_F(Uv(j[b>>2])));j[114630]=0;I(9,a|0,0,d+32|0);a=j[114630];j[114630]=0;if((a|0)!=1){gb(d+32|0);break k}c=D()|0;C()|0;gb(d+32|0);break a}e=Db(d+32|0,38823);f=Ze(c,e);gb(e);if(f){c=b+24|0;HM(d+32|0,j[c>>2]+1304424|0);m:{n:{o:{if(!Ec(d+32|0)){break o}c=j[c>>2];j[114630]=0;c=H(2180,c|0)|0;e=j[114630];j[114630]=0;if((e|0)==1){break m}p:{switch(c|0){case 0:j[114630]=0;F(2181,d+16|0,b|0);c=j[114630];j[114630]=0;if((c|0)!=1){ob(d+32|0,d+16|0);gb(d+16|0);break o}c=D()|0;C()|0;break b;case 1:j[114630]=0;F(2182,d+16|0,b|0);c=j[114630];j[114630]=0;if((c|0)!=1){ob(d+32|0,d+16|0);gb(d+16|0);break o}c=D()|0;C()|0;break b;case 2:if(Ec(d+32|0)){j[114630]=0;F(2181,d+16|0,b|0);c=j[114630];j[114630]=0;if((c|0)==1){break i}ob(d+32|0,d+16|0);gb(d+16|0)}if(!Ec(d+32|0)){break o}j[114630]=0;F(2182,d+16|0,b|0);c=j[114630];j[114630]=0;if((c|0)!=1){ob(d+32|0,d+16|0);gb(d+16|0);break o}c=D()|0;C()|0;break b;case 3:if(Ec(d+32|0)){j[114630]=0;F(2182,d+16|0,b|0);c=j[114630];j[114630]=0;if((c|0)==1){break h}ob(d+32|0,d+16|0);gb(d+16|0)}if(!Ec(d+32|0)){break o}j[114630]=0;F(2181,d+16|0,b|0);c=j[114630];j[114630]=0;if((c|0)!=1){ob(d+32|0,d+16|0);gb(d+16|0);break o}c=D()|0;C()|0;break b;case 4:j[114630]=0;F(2181,d+16|0,b|0);c=j[114630];j[114630]=0;q:{r:{if((c|0)!=1){j[114630]=0;F(2182,d|0,b|0);c=j[114630];j[114630]=0;if((c|0)==1){break q}if(Ec(d+16|0)){break r}j[114630]=0;E(1245,d+32|0,d+16|0)|0;c=j[114630];j[114630]=0;if((c|0)!=1){break r}break d}c=D()|0;C()|0;break b}if(!Ec(d)){j[114630]=0;E(1245,d+32|0,d|0)|0;c=j[114630];j[114630]=0;if((c|0)==1){break d}}gb(d);gb(d+16|0);break o}c=D()|0;C()|0;break c;case 5:break p;default:break o}}j[114630]=0;F(2181,d+16|0,b|0);c=j[114630];j[114630]=0;s:{if((c|0)!=1){j[114630]=0;F(2182,d|0,b|0);c=j[114630];j[114630]=0;if((c|0)==1){break n}if(Ec(d)){break s}j[114630]=0;E(1245,d+32|0,d|0)|0;c=j[114630];j[114630]=0;if((c|0)!=1){break s}break f}c=D()|0;C()|0;break b}if(!Ec(d+16|0)){j[114630]=0;E(1245,d+32|0,d+16|0)|0;c=j[114630];j[114630]=0;if((c|0)==1){break f}}gb(d);gb(d+16|0)}j[114630]=0;I(2179,a|0,b|0,d+32|0);a=j[114630];j[114630]=0;if((a|0)==1){break m}gb(d+32|0);break k}c=D()|0;C()|0;break e}c=D()|0;C()|0;break b}e=Db(d+32|0,38831);f=Ze(c,e);gb(e);if(f){HM(d+32|0,j[b+24>>2]+1304424|0);j[114630]=0;I(2179,a|0,b|0,d+32|0);a=j[114630];j[114630]=0;if((a|0)!=1){gb(d+32|0);break k}c=D()|0;C()|0;gb(d+32|0);break a}e=c;c=Db(d+32|0,38843);e=Ze(e,c);gb(c);if(e){a=Cb(a);b=b+68|0;g=d,h=Lb(b),j[g+32>>2]=h;g=d,h=Mb(b),j[g+16>>2]=h;if(!rb(d+32|0,d+16|0)){break k}c=1;while(1){b=j[d+32>>2];if(!(c&1)){j[114630]=0;E(1990,a|0,38852)|0;c=j[114630];j[114630]=0;if((c|0)==1){break g}}j[114630]=0;E(1245,a|0,b|0)|0;b=j[114630];j[114630]=0;if((b|0)==1){break g}cn(d+32|0);c=0;if(rb(d+32|0,d+16|0)){continue}break}break k}Db(a,38235)}Za=d+48|0;return}c=D()|0;C()|0;gb(d+32|0);break a}c=D()|0;C()|0;break b}c=D()|0;C()|0;break b}c=D()|0;C()|0;gb(a);break a}c=D()|0;C()|0;gb(d)}gb(d+16|0);break b}c=D()|0;C()|0;gb(d)}gb(d+16|0)}gb(d+32|0)}G(c|0);z()}function M2(a,b,c,d,e,f){var g=0,h=0,i=0,l=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;g=Za-432|0;Za=g;h=j[b+4>>2];a:{if(h>>>0<m[b+104>>2]){j[b+4>>2]=h+1;i=k[h|0];break a}i=Jc(b)}b:{c:{while(1){if((i|0)!=48){d:{if((i|0)!=46){break b}h=j[b+4>>2];if(h>>>0>=m[b+104>>2]){break d}j[b+4>>2]=h+1;i=k[h|0];break c}}else{h=j[b+4>>2];if(h>>>0<m[b+104>>2]){z=1;j[b+4>>2]=h+1;i=k[h|0]}else{z=1;i=Jc(b)}continue}break}i=Jc(b)}y=1;if((i|0)!=48){break b}while(1){h=u;u=h-1|0;v=v-(h>>>0<1)|0;h=j[b+4>>2];e:{if(h>>>0<m[b+104>>2]){j[b+4>>2]=h+1;i=k[h|0];break e}i=Jc(b)}if((i|0)==48){continue}break}z=1}h=1073676288;while(1){f:{A=i|32;g:{h:{B=i-48|0;if(B>>>0<10){break h}if(A-97>>>0>5?(i|0)!=46:0){break f}if((i|0)!=46){break h}if(y){break f}y=1;u=p;v=l;break g}i=(i|0)>57?A-87|0:B;i:{if((l|0)<0?1:(l|0)<=0?p>>>0<=7:0){r=i+(r<<4)|0;break i}if((l|0)<0?1:(l|0)<=0?p>>>0<=28:0){Uf(g+48|0,i);bd(g+32|0,w,x,q,h,0,0,0,1073414144);w=j[g+32>>2];x=j[g+36>>2];q=j[g+40>>2];h=j[g+44>>2];bd(g+16|0,w,x,q,h,j[g+48>>2],j[g+52>>2],j[g+56>>2],j[g+60>>2]);If(g,n,o,s,t,j[g+16>>2],j[g+20>>2],j[g+24>>2],j[g+28>>2]);s=j[g+8>>2];t=j[g+12>>2];n=j[g>>2];o=j[g+4>>2];break i}if(!i|E){break i}bd(g+80|0,w,x,q,h,0,0,0,1073610752);If(g- -64|0,n,o,s,t,j[g+80>>2],j[g+84>>2],j[g+88>>2],j[g+92>>2]);s=j[g+72>>2];t=j[g+76>>2];E=1;n=j[g+64>>2];o=j[g+68>>2]}p=p+1|0;l=p>>>0<1?l+1|0:l;z=1}i=j[b+4>>2];if(i>>>0<m[b+104>>2]){j[b+4>>2]=i+1;i=k[i|0]}else{i=Jc(b)}continue}break}j:{k:{l:{if(!z){if(!j[b+104>>2]){if(f){break k}break l}c=j[b+4>>2];j[b+4>>2]=c-1;if(!f){break l}j[b+4>>2]=c-2;if(!y){break k}j[b+4>>2]=c-3;break k}if((l|0)<0?1:(l|0)<=0?p>>>0<=7:0){q=p;h=l;while(1){r=r<<4;q=q+1|0;h=q>>>0<1?h+1|0:h;if((q|0)!=8|h){continue}break}}m:{if((i&-33)==80){q=wD(b,f);i=ab;h=i;if(q|(h|0)!=-2147483648){break m}if(f){q=0;h=0;if(!j[b+104>>2]){break m}j[b+4>>2]=j[b+4>>2]-1;break m}n=0;o=0;dh(b,0,0);c=0;b=0;break j}q=0;h=0;if(!j[b+104>>2]){break m}j[b+4>>2]=j[b+4>>2]-1}if(!r){Ih(g+112|0,+(e|0)*0);n=j[g+112>>2];o=j[g+116>>2];c=j[g+120>>2];b=j[g+124>>2];break j}f=y?u:p;b=(y?v:l)<<2|f>>>30;f=q+(f<<2)|0;l=b+h|0;b=f;p=b-32|0;l=(b>>>0<q>>>0?l+1|0:l)-(b>>>0<32)|0;b=l;if((b|0)>0?1:(b|0)>=0?p>>>0>0-d>>>0:0){j[114604]=68;Uf(g+160|0,e);bd(g+144|0,j[g+160>>2],j[g+164>>2],j[g+168>>2],j[g+172>>2],-1,-1,-1,2147418111);bd(g+128|0,j[g+144>>2],j[g+148>>2],j[g+152>>2],j[g+156>>2],-1,-1,-1,2147418111);n=j[g+128>>2];o=j[g+132>>2];c=j[g+136>>2];b=j[g+140>>2];break j}b=d-226|0;f=p>>>0>=b>>>0;b=b>>31;if((b|0)<(l|0)?1:(l|0)>=(b|0)?f:0){if((r|0)>-1){while(1){If(g+416|0,n,o,s,t,0,0,0,-1073807360);h=BD(n,o,s,t,1073610752);f=(h|0)<0;b=f;If(g+400|0,n,o,s,t,b?n:j[g+416>>2],b?o:j[g+420>>2],b?s:j[g+424>>2],b?t:j[g+428>>2]);b=p;p=b-1|0;l=l-(b>>>0<1)|0;s=j[g+408>>2];t=j[g+412>>2];n=j[g+400>>2];o=j[g+404>>2];r=r<<1|(h|0)>-1;if((r|0)>-1){continue}break}}b=d;h=(p-b|0)+32|0;l=l-((b>>31)+(b>>>0>p>>>0)|0)|0;b=h;l=b>>>0<32?l+1|0:l;c=((l|0)<0?1:(l|0)<=0?c>>>0>b>>>0:0)?(b|0)>0?b:0:c;n:{if((c|0)>=113){Uf(g+384|0,e);u=j[g+392>>2];v=j[g+396>>2];w=j[g+384>>2];x=j[g+388>>2];d=0;b=0;break n}Ih(g+352|0,Bh(1,144-c|0));Uf(g+336|0,e);w=j[g+336>>2];x=j[g+340>>2];u=j[g+344>>2];v=j[g+348>>2];AD(g+368|0,j[g+352>>2],j[g+356>>2],j[g+360>>2],j[g+364>>2],w,x,u,v);C=j[g+376>>2];D=j[g+380>>2];d=j[g+372>>2];b=j[g+368>>2]}c=!(r&1)&((Ik(n,o,s,t,0,0,0,0)|0)!=0&(c|0)<32);cm(g+320|0,c+r|0);bd(g+304|0,w,x,u,v,j[g+320>>2],j[g+324>>2],j[g+328>>2],j[g+332>>2]);If(g+272|0,j[g+304>>2],j[g+308>>2],j[g+312>>2],j[g+316>>2],b,d,C,D);bd(g+288|0,c?0:n,c?0:o,c?0:s,c?0:t,w,x,u,v);If(g+256|0,j[g+288>>2],j[g+292>>2],j[g+296>>2],j[g+300>>2],j[g+272>>2],j[g+276>>2],j[g+280>>2],j[g+284>>2]);av(g+240|0,j[g+256>>2],j[g+260>>2],j[g+264>>2],j[g+268>>2],b,d,C,D);e=j[g+240>>2];d=j[g+244>>2];c=j[g+248>>2];b=j[g+252>>2];if(!Ik(e,d,c,b,0,0,0,0)){j[114604]=68}zD(g+224|0,e,d,c,b,p);n=j[g+224>>2];o=j[g+228>>2];c=j[g+232>>2];b=j[g+236>>2];break j}j[114604]=68;Uf(g+208|0,e);bd(g+192|0,j[g+208>>2],j[g+212>>2],j[g+216>>2],j[g+220>>2],0,0,0,65536);bd(g+176|0,j[g+192>>2],j[g+196>>2],j[g+200>>2],j[g+204>>2],0,0,0,65536);n=j[g+176>>2];o=j[g+180>>2];c=j[g+184>>2];b=j[g+188>>2];break j}dh(b,0,0)}Ih(g+96|0,+(e|0)*0);n=j[g+96>>2];o=j[g+100>>2];c=j[g+104>>2];b=j[g+108>>2]}j[a>>2]=n;j[a+4>>2]=o;j[a+8>>2]=c;j[a+12>>2]=b;Za=g+432|0}function hIa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;d=Za-336|0;Za=d;rc(b);a:{if(!$s(b,d+320|0)){break a}if(!eR(d+320|0)){break a}if(j[d+320>>2]==1179472708){Jb(b,4)}if(!kf(b,d+312|0)|j[d+312>>2]!=1196314451){break a}if(!c){e=1;break a}n=d+312|4;g=n;mS(b,d+120|0,k[g|0]|k[g+1|0]<<8|(k[g+2|0]<<16|k[g+3|0]<<24));if((k[d+156|0]|k[d+157|0]<<8)>>>0>128|(k[d+162|0]|k[d+163|0]<<8)>>>0>16|((k[d+160|0]|k[d+161|0]<<8)>>>0>256|(k[d+154|0]|k[d+155|0]<<8)>>>0>128)){break a}od(a,8192);e=Db(d+40|0,12774);ob(a+1304436|0,e);gb(e);e=Db(d+40|0,12786);ob(a+1304448|0,e);gb(e);j[a+1304496>>2]=4;_s(d+104|0,2,d+120|0);qc(d+40|0,d+104|0);ob(a+1304400|0,d+40|0);gb(d+40|0);i[d+40>>1]=k[d+162|0]|k[d+163|0]<<8;i[d+104>>1]=1;v=a,w=l[vi(d+40|0,d+104|0)>>1],i[v+480188>>1]=w;j[a+480196>>2]=k[d+166|0];j[a+480204>>2]=p(k[d+167|0],1e4);h[d+40|0]=k[d+164|0];h[d+104|0]=64;e=k[Zb(d+40|0,d+104|0)|0];j[a+480200>>2]=e<<2;if(!e){j[a+480200>>2]=256}e=a;b:{if(k[d+165|0]==128){j[d+40>>2]=256/l[a+480188>>1];j[d+104>>2]=128;g=j[tb(d+40|0,d+104|0)>>2];break b}g=k[d+165|0]&127}j[e+480228>>2]=g;e=0;while(1){g=(e<<5)+a|0;wg(g+480280|0);f=d+e|0;if(k[f+168|0]<=128){i[g+480284>>1]=k[f+168|0]<<1}e=e+1|0;if((e|0)!=16){continue}break}e=a+484360|0;kn(Eb(e),d+184|0,k[d+156|0]|k[d+157|0]<<8,255,254);if((k[d+154|0]|k[d+155|0]<<8)>>>0<(k[d+156|0]|k[d+157|0]<<8)>>>0){Fe(Eb(e),k[d+154|0]|k[d+155|0]<<8)}e=1;if(!kf(b,d+312|0)){break a}s=c&2;o=a+484344|0;t=c&1;u=d+76|0;while(1){c=n;cd(d+104|0,b,k[c|0]|k[c+1|0]<<8|(k[c+2|0]<<16|k[c+3|0]<<24));c:{d:{e:{if(!(!t|j[d+312>>2]!=1414807888)){j[114630]=0;r=q&65535;c=K(402,o|0,r|0,64)|0;e=j[114630];j[114630]=0;if((e|0)==1){break e}if(!c){break c}j[114630]=0;E(338,d+104|0,2)|0;c=j[114630];j[114630]=0;if((c|0)==1){break e}th(d+40|0);g=0;f:{while(1){j[114630]=0;c=E(258,d+104|0,1)|0;e=j[114630];j[114630]=0;g:{h:{if((e|0)!=1){if(c^1|g>>>0>63){break f}j[114630]=0;e=H(387,d+104|0)|0;c=j[114630];j[114630]=0;if((c|0)==1){break h}if(e){break g}g=g+1|0;continue}b=D()|0;C()|0;break d}b=D()|0;C()|0;break d}c=d+40|0;i:{j:{k:{f=e&15;l:{if(f>>>0<l[a+480188>>1]){c=Hb(o,r);j[114630]=0;c=K(471,c|0,g|0,f|0)|0;f=j[114630];j[114630]=0;if((f|0)==1){break l}}m:{if(!(e&128)){break m}j[114630]=0;f=H(387,d+104|0)|0;m=j[114630];j[114630]=0;if((m|0)==1){break k}if(!f){break m}h[c|0]=f>>>0<109?f+12|0:f}if(!(e&64)){break i}j[114630]=0;f=H(387,d+104|0)|0;m=j[114630];j[114630]=0;if((m|0)!=1){break j}}b=D()|0;C()|0;break d}b=D()|0;C()|0;break d}h[c+1|0]=f}n:{o:{p:{q:{r:{s:{t:{u:{if(e&32){h[c+2|0]=1;j[114630]=0;f=H(387,d+104|0)|0;m=j[114630];j[114630]=0;if((m|0)==1){break u}j[114630]=0;h[d+24|0]=f;h[d+8|0]=64;f=E(391,d+24|0,d+8|0)|0;m=j[114630];j[114630]=0;if((m|0)==1){break t}h[c+4|0]=k[f|0]}if(!(e&16)){continue}j[114630]=0;F(472,d+24|0,d+104|0);e=j[114630];j[114630]=0;if((e|0)==1){break s}m=Pc(d+24|0);f=d+24|0;e=k[f|0];switch(e-17|0){case 2:break q;case 0:case 1:break r;default:break p}}b=D()|0;C()|0;break d}b=D()|0;C()|0;break d}b=D()|0;C()|0;break d}e=e&15;break o}h[f|0]=33;h[m|0]=145;e=k[f|0];break n}if(e>>>0<17){break n}e=(e&240)==32?9:-1}h[f|0]=e}h[c+3|0]=e;h[c+5|0]=k[m|0];j[114630]=0;N(574,c|0);c=j[114630];j[114630]=0;if((c|0)!=1){continue}break}b=D()|0;C()|0;break d}q=q+1|0;break c}if(j[d+312>>2]!=1414745673){break c}if(!fn(a)){break c}c=l[a+480190>>1]+1|0;i[a+480190>>1]=c;j[114630]=0;E(575,d+104|0,d+40|0)|0;e=j[114630];j[114630]=0;v:{w:{x:{if((e|0)==1){break x}j[114630]=0;c=(p(c&65535,104)+a|0)+484380|0;F(576,d+40|0,c|0);e=j[114630];j[114630]=0;if((e|0)==1){break x}j[114630]=0;I(577,d+8|0,2,u|0);e=j[114630];j[114630]=0;if((e|0)==1){break w}j[114630]=0;F(415,d+24|0,d+8|0);e=j[114630];j[114630]=0;if((e|0)==1){break w}e=l[a+480190>>1];j[114630]=0;E(369,((e<<5)+a|0)+946300|0,d+24|0)|0;e=j[114630];j[114630]=0;if((e|0)==1){break v}gb(d+24|0);if(!s){break c}j[114630]=0;F(578,d+24|0,d+40|0);e=j[114630];j[114630]=0;if((e|0)!=1){j[114630]=0;K(400,d+24|0,c|0,d+104|0)|0;c=j[114630];j[114630]=0;if((c|0)!=1){break c}}b=D()|0;C()|0;break d}b=D()|0;C()|0;break d}b=D()|0;C()|0;break d}b=D()|0;C()|0;gb(d+24|0);break d}b=D()|0;C()|0}jb(d+104|0);G(b|0);z()}jb(d+104|0);e=1;if(kf(b,d+312|0)){continue}break}}Za=d+336|0;return e|0}function Kia(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,m=0;e=Za-144|0;Za=e;d=-1;a:{b:{c:{if(!qt(j[j[b>>2]-12>>2]+b|0)){b=Gk(e+40|0,b);j[114630]=0;d=E(683,e+24|0,32412)|0;f=j[114630];j[114630]=0;d:{e:{f:{g:{h:{i:{j:{k:{l:{m:{n:{o:{p:{q:{r:{s:{t:{u:{v:{w:{x:{y:{z:{A:{B:{C:{D:{E:{F:{if((f|0)!=1){j[114630]=0;j[e+16>>2]=83886084;j[e+20>>2]=0;I(684,b|0,d|0,e+16|0);f=j[114630];j[114630]=0;if((f|0)==1){break F}qb(d);j[114630]=0;h[e+15|0]=0;d=E(683,e+24|0,32422)|0;f=j[114630];j[114630]=0;if((f|0)==1){break E}j[114630]=0;K(685,b|0,e+15|0,d|0)|0;f=j[114630];j[114630]=0;if((f|0)==1){break D}qb(d);j[114630]=0;f=k[e+15|0];d=E(683,e+24|0,32427)|0;g=j[114630];j[114630]=0;if((g|0)==1){break C}j[114630]=0;f=f?0:c;L(1600,b|0,a+40|0,d|0,f|0);c=j[114630];j[114630]=0;if((c|0)==1){break B}qb(d);j[114630]=0;i[e+12>>1]=65535;c=E(683,e+24|0,32429)|0;d=j[114630];j[114630]=0;if((d|0)==1){break A}j[114630]=0;K(1178,b|0,e+12|0,c|0)|0;d=j[114630];j[114630]=0;if((d|0)==1){break z}qb(c);j[114630]=0;i[e+10>>1]=0;c=E(683,e+24|0,32431)|0;d=j[114630];j[114630]=0;if((d|0)==1){break y}j[114630]=0;K(1178,b|0,e+10|0,c|0)|0;d=j[114630];j[114630]=0;if((d|0)==1){break x}qb(c);i[a>>1]=l[e+10>>1];j[114630]=0;c=E(683,e+24|0,32433)|0;d=j[114630];j[114630]=0;if((d|0)==1){break w}j[114630]=0;L(1601,b|0,a+52|0,c|0,f|0);d=j[114630];j[114630]=0;if((d|0)==1){break v}qb(c);j[114630]=0;c=E(683,e+24|0,32435)|0;d=j[114630];j[114630]=0;if((d|0)==1){break u}j[114630]=0;K(1566,b|0,a+36|0,c|0)|0;d=j[114630];j[114630]=0;if((d|0)==1){break t}qb(c);j[114630]=0;c=E(683,e+24|0,32437)|0;d=j[114630];j[114630]=0;if((d|0)==1){break s}j[114630]=0;f=a+4|0;P(1602,b|0,f|0,c|0,1603)|0;d=j[114630];j[114630]=0;if((d|0)==1){break r}qb(c);j[114630]=0;c=E(683,e+24|0,32442)|0;d=j[114630];j[114630]=0;if((d|0)==1){break q}j[114630]=0;g=a+28|0;K(1604,b|0,g|0,c|0)|0;d=j[114630];j[114630]=0;if((d|0)==1){break p}qb(c);j[114630]=0;c=E(683,e+24|0,32447)|0;d=j[114630];j[114630]=0;if((d|0)==1){break o}j[114630]=0;K(1604,b|0,a+30|0,c|0)|0;d=j[114630];j[114630]=0;if((d|0)==1){break n}qb(c);j[114630]=0;c=E(683,e+24|0,32452)|0;d=j[114630];j[114630]=0;if((d|0)==1){break m}j[114630]=0;K(1605,b|0,a+32|0,c|0)|0;d=j[114630];j[114630]=0;if((d|0)==1){break l}qb(c);j[114630]=0;i[e+8>>1]=0;c=E(683,e+24|0,32457)|0;d=j[114630];j[114630]=0;if((d|0)==1){break c}j[114630]=0;K(1178,b|0,e+8|0,c|0)|0;d=j[114630];j[114630]=0;if((d|0)==1){break k}qb(c);d=-1;if(j[b>>2]&1073741824|(l[g>>1]+300&65535)>>>0>=601){break d}c=l[a>>1];if(c>>>0>3|(c|0)==2|i[a+30>>1]<0){break d}c=j[a+36>>2];j[114630]=0;c=H(859,c|0)|0;m=j[114630];j[114630]=0;if((m|0)==1){break j}j[114630]=0;j[e+24>>2]=c;j[e+16>>2]=0;c=K(1235,e+24|0,e+16|0,32408)|0;m=j[114630];j[114630]=0;if((m|0)==1){break i}j[a+36>>2]=j[c>>2];if(sb(f)>>>0>32767){break d}switch(l[a>>1]-1|0){case 0:break g;case 2:break h;default:break f}}a=D()|0;C()|0;break a}a=D()|0;C()|0;qb(d);break a}a=D()|0;C()|0;break a}a=D()|0;C()|0;qb(d);break a}a=D()|0;C()|0;break a}a=D()|0;C()|0;qb(d);break a}a=D()|0;C()|0;break a}a=D()|0;C()|0;qb(c);break a}a=D()|0;C()|0;break a}a=D()|0;C()|0;qb(c);break a}a=D()|0;C()|0;break a}a=D()|0;C()|0;qb(c);break a}a=D()|0;C()|0;break a}a=D()|0;C()|0;qb(c);break a}a=D()|0;C()|0;break a}a=D()|0;C()|0;qb(c);break a}a=D()|0;C()|0;break a}a=D()|0;C()|0;qb(c);break a}a=D()|0;C()|0;break a}a=D()|0;C()|0;qb(c);break a}a=D()|0;C()|0;break a}a=D()|0;C()|0;qb(c);break a}a=D()|0;C()|0;qb(c);break a}a=D()|0;C()|0;break a}a=D()|0;C()|0;break a}if(i[e+8>>1]<1){break d}i[e+6>>1]=l[a+30>>1];n[e+24>>2]=n[a+32>>2];c=l[a+28>>1];j[114630]=0;i[e+16>>1]=c;i[e+18>>1]=(c+l[e+8>>1]|0)-1;a=P(1606,a|0,e+6|0,e+24|0,e+16|0)|0;c=j[114630];j[114630]=0;if((c|0)!=1){if(a){break e}break d}a=D()|0;C()|0;break a}if(i[e+8>>1]<1){break d}n[e+24>>2]=n[a+32>>2];c=l[a+28>>1];j[114630]=0;i[e+16>>1]=c;i[e+18>>1]=(c+l[e+8>>1]|0)-1;a=U(1607,a|0,f|0,e+24|0,e+16|0,g|0)|0;c=j[114630];j[114630]=0;if((c|0)!=1){if(a){break e}break d}a=D()|0;C()|0;break a}j[114630]=0;N(1608,a|0);a=j[114630];j[114630]=0;if((a|0)==1){break b}}d=1}ag(b)}Za=e+144|0;return d|0}a=D()|0;C()|0;break a}a=D()|0;C()|0}ag(b);G(a|0);z()}function GK(a,b,c,d,e){var f=0,g=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;m=Za-16|0;Za=m;a:{if(!Ld(d&255)){break a}o=(p(b,896)+a|0)+1074984|0;b:{c:{if(e?0:!(!(j[a+480180>>2]&17825824)|!l[a+480192>>1])){break c}if(Si(o)){break c}d=p(b,896)+a|0;e=d+1075060|0;if(!j[e>>2]|k[d+1075073|0]&4){break a}c=p(b,896)+a|0;g=c+1075004|0;f=c+1075008|0;if(!(j[g>>2]|j[f>>2])){break a}c=IK(a,b);if((c|0)==65535){break a}n=a+1074984|0;c=n+p(c,896)|0;Or(c,o);h[c+851|0]=0;h[c+827|0]=0;i[c+808>>1]=b+1;j[c+88>>2]=j[c+88>>2]&-918529;ys(c+810|0);j[c+696>>2]=0;j[c+88>>2]=j[c+88>>2]|2101248;j[e>>2]=0;j[o>>2]=0;j[o+4>>2]=0;c=n+p(b,896)|0;j[c+92>>2]=0;j[c+96>>2]=0;j[g>>2]=0;j[f>>2]=0;if(!(k[d+1075073|0]&2)){break b}a=a+1304392|0;if(!$c(a)){break b}qh(j[a>>2],b,1);break b}e=p(b,896)+a|0;q=j[e+1075088>>2];c=l[a+480192>>1]<c>>>0?0:c;g=j[(c?((c<<2)+a|0)+900380|0:e+1075640|0)>>2];d:{if(!g){break d}n=d-1|0;c=l[Nc(g+236|0,n)>>1];f=a+1074308|0;mb(m+8|0,f,104);e:{if(kb(m+8|0)){mb(m,f,34);if(kb(m)){break e}}d=k[Pb(g+108|0,n)|0]}if((c-1&65535)>>>0<=3998){q=(p(c,104)+a|0)+484380|0;break d}mb(m+8|0,f,43);if(!kb(m+8|0)){break d}if(!ai(g)){break a}}if(k[e+1075073|0]&4){break a}if(b>>>0<=255){n=a+1304392|0;t=a+1074308|0;w=b+1|0;c=b;while(1){f=(b|0)==(c|0);f:{if(l[a+480188>>1]>c>>>0?!f:0){break f}e=p(c,896)+a|0;if(l[e+1075792>>1]!=(w|0)?!f:0){break f}v=e+1075640|0;f=j[v>>2];if(!f){break f}r=e+1074984|0;g:{h:{i:{j:{k:{l:{m:{switch(k[f+17|0]-1|0){case 0:if(!d){break f}s=(f|0)==(g|0)&k[e+1075803|0]==(d|0);u=s;if(!g){break l}if(s){break i}break f;case 1:if(!q|j[e+1075088>>2]!=(q|0)){break f}if((f|0)==(g|0)){break g}mb(m+8|0,t,104);if(!kb(m+8|0)){break g}break f;case 3:break k;case 2:break m;default:break f}}if(g){break j}u=(f|0)==(g|0)}if(u){break g}break f}if(!g){break f}s=k[g+34|0];if(!s){break f}if((s|0)==k[f+34|0]){break h}break f}if((f|0)!=(g|0)){break f}}if(!k[g+34|0]){break g}}if(!k[e+1075803|0]|k[f+18|0]>2){break g}mb(m+8|0,t,34);Nj(a,c&65535,AM(r,kb(m+8|0))+255|0,0);h[e+1075806|0]=0}n:{o:{switch(k[j[v>>2]+18|0]){case 0:Fm(a,r);j[e+1075672>>2]=0;if(!(k[e+1075073|0]&2)){break n}if(!$c(n)){break n}qh(j[n>>2],c&65535,1);break n;case 1:Fm(a,r);if(!(k[e+1075073|0]&2)){break n}if(!$c(n)){break n}Uj(j[n>>2],c&65535);break n;case 2:break o;default:break n}}r=e+1075072|0;f=j[r>>2];j[r>>2]=f|4096;if(!(f&512)){break n}if(!$c(n)){break n}mb(m+8|0,t,105);if(kb(m+8|0)){break n}Uj(j[n>>2],c&65535)}if(j[e+1075672>>2]){break f}j[e+1075680>>2]=0;e=e+1075072|0;j[e>>2]=j[e>>2]|2101248}c=c+1|0;if((c&65535)!=256){continue}break}}e=0;g=0;p:{if(!Si(o)){break p}if(!Ld(k[(p(b,896)+a|0)+1075803|0])){break p}q:{c=bl(a,b,2,1);if(c-251>>>0<5){break q}if(!c){break p}g=j[(p(c,160)+a|0)+906140>>2];if(!g){break q}mb(m+8|0,a+1074308|0,34);e=(y=g,z=AM(o,kb(m+8|0)),A=b,x=j[j[g>>2]+96>>2],bb[x](y|0,z|0,A|0)|0);break p}g=0}if(oh(o)?0:!e){break a}d=IK(a,b);if((d|0)==65535){break a}f=p(d,896)+a|0;c=f+1075072|0;n=f+1074984|0;r:{if(!(k[f+1075073|0]&2)){break r}q=a+1304392|0;if(!$c(q)){break r}qh(j[q>>2],d,1)}Or(n,o);j[c>>2]=j[c>>2]&-917505;h[f+1075835|0]=0;q=l[a+480188>>1];h[f+1075811|0]=0;i[f+1075792>>1]=b>>>0<q>>>0?b+1|0:0;s:{if(!g|e^1){break s}e=k[(p(b,896)+a|0)+1075804|0];if(e>>>0>3|(e|0)==1){break s}Nj(a,b,255,0);h[(p(b,896)+a|0)+1075806|0]=0}t:{u:{switch(k[(p(b,896)+a|0)+1075804|0]){case 2:Fm(a,n);if(!(k[c+1|0]&2)){break t}e=a+1304392|0;if(!$c(e)){break t}Uj(j[e>>2],b);mb(m+8|0,a+1074308|0,105);if(!kb(m+8|0)){break t}Fx(j[e>>2],b,d);break t;case 0:j[(p(d,896)+a|0)+1075680>>2]=0;e=j[c>>2];j[c>>2]=e|4096;if(!(e&512)){break t}e=a+1304392|0;if(!$c(e)){break t}qh(j[e>>2],b,1);break t;case 3:e=j[c>>2];j[c>>2]=e|4096;if(!(e&512)){break t}e=a+1304392|0;if(!$c(e)){break t}mb(m+8|0,a+1074308|0,105);g=kb(m+8|0);e=j[e>>2];if(g){Fx(e,b,d);break t}Uj(e,b);break t;case 1:break u;default:break t}}if(!(k[c+1|0]&2)){break t}e=a+1304392|0;if(!$c(e)){break t}Fx(j[e>>2],b,d)}if(!j[(p(d,896)+a|0)+1075672>>2]){j[(p(d,896)+a|0)+1075680>>2]=0;j[c>>2]=j[c>>2]|2101248}a=p(b,896)+a|0;j[a+1075060>>2]=0;j[o>>2]=0;j[o+4>>2]=0;a=a+1075076|0;j[a>>2]=0;j[a+4>>2]=0}}Za=m+16|0}function EE(a,b,c,d,e){var f=0,g=0,h=0,i=0,k=0,l=0,m=0,n=0,q=0,s=0,t=0,u=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;h=Za-560|0;Za=h;g=c;c=(c-3|0)/24|0;x=(c|0)>0?c:0;m=g+p(x,-24)|0;q=j[(e<<2)+52304>>2];k=d-1|0;if((q+k|0)>=0){g=d+q|0;c=x-k|0;while(1){o[(h+320|0)+(i<<3)>>3]=(c|0)<0?0:+j[(c<<2)+52320>>2];c=c+1|0;i=i+1|0;if((g|0)!=(i|0)){continue}break}}t=m-24|0;g=0;i=(q|0)>0?q:0;n=(d|0)<1;while(1){a:{if(n){f=0;break a}l=g+k|0;c=0;f=0;while(1){f=f+o[(c<<3)+a>>3]*o[(h+320|0)+(l-c<<3)>>3];c=c+1|0;if((d|0)!=(c|0)){continue}break}}o[(g<<3)+h>>3]=f;c=(g|0)==(i|0);g=g+1|0;if(!c){continue}break}C=47-m|0;y=48-m|0;D=m-25|0;g=q;b:{while(1){f=o[(g<<3)+h>>3];c=0;i=g;l=(g|0)<1;if(!l){while(1){n=(h+480|0)+(c<<2)|0;s=f;f=f*5.960464477539063e-8;c:{if(r(f)<2147483648){k=~~f;break c}k=-2147483648}f=+(k|0);s=s+f*-16777216;d:{if(r(s)<2147483648){k=~~s;break d}k=-2147483648}j[n>>2]=k;i=i-1|0;f=o[(i<<3)+h>>3]+f;c=c+1|0;if((g|0)!=(c|0)){continue}break}}f=Bh(f,t);f=f+v(f*.125)*-8;e:{if(r(f)<2147483648){n=~~f;break e}n=-2147483648}f=f- +(n|0);f:{g:{h:{z=(t|0)<1;i:{if(!z){i=(g<<2)+h|0;k=j[i+476>>2];c=k>>y;w=i;i=k-(c<<y)|0;j[w+476>>2]=i;n=c+n|0;k=i>>C;break i}if(t){break h}k=j[((g<<2)+h|0)+476>>2]>>23}if((k|0)<1){break f}break g}k=2;if(!(f>=.5^1)){break g}k=0;break f}c=0;i=0;if(!l){while(1){w=(h+480|0)+(c<<2)|0;A=j[w>>2];l=16777215;j:{k:{if(i){break k}l=16777216;if(A){break k}i=0;break j}j[w>>2]=l-A;i=1}c=c+1|0;if((g|0)!=(c|0)){continue}break}}l:{if(z){break l}m:{switch(D|0){case 0:c=(g<<2)+h|0;j[c+476>>2]=j[c+476>>2]&8388607;break l;case 1:break m;default:break l}}c=(g<<2)+h|0;j[c+476>>2]=j[c+476>>2]&4194303}n=n+1|0;if((k|0)!=2){break f}f=1-f;k=2;if(!i){break f}f=f-Bh(1,t)}if(f==0){i=0;n:{c=g;if((q|0)>=(c|0)){break n}while(1){c=c-1|0;i=j[(h+480|0)+(c<<2)>>2]|i;if((c|0)>(q|0)){continue}break}if(!i){break n}m=t;while(1){m=m-24|0;g=g-1|0;if(!j[(h+480|0)+(g<<2)>>2]){continue}break}break b}c=1;while(1){i=c;c=c+1|0;if(!j[(h+480|0)+(q-i<<2)>>2]){continue}break}i=g+i|0;while(1){k=d+g|0;g=g+1|0;o[(h+320|0)+(k<<3)>>3]=j[(x+g<<2)+52320>>2];c=0;f=0;if((d|0)>=1){while(1){f=f+o[(c<<3)+a>>3]*o[(h+320|0)+(k-c<<3)>>3];c=c+1|0;if((d|0)!=(c|0)){continue}break}}o[(g<<3)+h>>3]=f;if((g|0)<(i|0)){continue}break}g=i;continue}break}f=Bh(f,24-m|0);o:{if(!(f>=16777216^1)){d=(h+480|0)+(g<<2)|0;s=f;f=f*5.960464477539063e-8;p:{if(r(f)<2147483648){c=~~f;break p}c=-2147483648}f=s+ +(c|0)*-16777216;q:{if(r(f)<2147483648){a=~~f;break q}a=-2147483648}j[d>>2]=a;g=g+1|0;break o}if(r(f)<2147483648){c=~~f}else{c=-2147483648}m=t}j[(h+480|0)+(g<<2)>>2]=c}f=Bh(1,m);r:{if((g|0)<=-1){break r}c=g;while(1){o[(c<<3)+h>>3]=f*+j[(h+480|0)+(c<<2)>>2];f=f*5.960464477539063e-8;a=(c|0)>0;c=c-1|0;if(a){continue}break}l=0;if((g|0)<0){break r}a=(q|0)>0?q:0;i=g;while(1){d=a>>>0<l>>>0?a:l;m=g-i|0;c=0;f=0;while(1){f=f+o[(c<<3)+55088>>3]*o[(c+i<<3)+h>>3];t=(c|0)!=(d|0);c=c+1|0;if(t){continue}break}o[(h+160|0)+(m<<3)>>3]=f;i=i-1|0;c=(g|0)!=(l|0);l=l+1|0;if(c){continue}break}}s:{t:{u:{switch(e|0){case 3:v:{if((g|0)<1){break v}f=o[(h+160|0)+(g<<3)>>3];c=g;while(1){s=f;a=c-1|0;d=(h+160|0)+(a<<3)|0;B=o[d>>3];f=B+f;o[(h+160|0)+(c<<3)>>3]=s+(B-f);o[d>>3]=f;d=(c|0)>1;c=a;if(d){continue}break}if((g|0)<2){break v}f=o[(h+160|0)+(g<<3)>>3];c=g;while(1){s=f;a=c-1|0;d=(h+160|0)+(a<<3)|0;u=o[d>>3];f=u+f;o[(h+160|0)+(c<<3)>>3]=s+(u-f);o[d>>3]=f;d=(c|0)>2;c=a;if(d){continue}break}u=0;if((g|0)<=1){break v}while(1){u=u+o[(h+160|0)+(g<<3)>>3];a=(g|0)>2;g=g-1|0;if(a){continue}break}}f=o[h+160>>3];if(k){break t}o[b>>3]=f;f=o[h+168>>3];o[b+16>>3]=u;o[b+8>>3]=f;break s;case 0:f=0;if((g|0)>=0){while(1){f=f+o[(h+160|0)+(g<<3)>>3];a=(g|0)>0;g=g-1|0;if(a){continue}break}}o[b>>3]=k?-f:f;break s;case 1:case 2:break u;default:break s}}f=0;if((g|0)>=0){c=g;while(1){f=f+o[(h+160|0)+(c<<3)>>3];a=(c|0)>0;c=c-1|0;if(a){continue}break}}o[b>>3]=k?-f:f;f=o[h+160>>3]-f;c=1;if((g|0)>=1){while(1){f=f+o[(h+160|0)+(c<<3)>>3];a=(c|0)!=(g|0);c=c+1|0;if(a){continue}break}}o[b+8>>3]=k?-f:f;break s}o[b>>3]=-f;f=o[h+168>>3];o[b+16>>3]=-u;o[b+8>>3]=-f}Za=h+560|0;return n&7}function VF(a,b,c,d,e,f){var g=0,i=0,m=0,n=0;g=Za-48|0;Za=g;a:{b:{c:{d:{e:{f:{g:{h:{i:{j:{if(er(c)){i=b+24|0;if(tg(j[i>>2]+484344|0,c&65535)){break j}}c=a;a=Cb(g+32|0);b=Cb(g+16|0);ih(c,a,b);gb(b);gb(a);break i}b=Hb(j[i>>2]+484344|0,c);if(!(j[b+12>>2]>(d|0)?(d|0)>=0:0)){c=a;a=Cb(g+32|0);b=Cb(g+16|0);ih(c,a,b);gb(b);gb(a);break i}if(!(l[j[i>>2]+480188>>1]>(e|0)?(e|0)>=0:0)){c=a;a=Cb(g+32|0);b=Cb(g+16|0);ih(c,a,b);gb(b);gb(a);break i}if(f>>>0>=6){c=a;a=Cb(g+32|0);b=Cb(g+16|0);ih(c,a,b);gb(b);gb(a);break i}b=Se(b,d,e&65535);k:{switch(f|0){case 0:l:{m:{n:{if(!Mf(b)){if(!Br(b)){break n}}GJ(g+16|0,j[i>>2],k[b|0],k[b+1|0]);j[114630]=0;I(9,g+32|0,0,g+16|0);c=j[114630];j[114630]=0;d=1;if((c|0)!=1){break m}c=D()|0;C()|0;break b}d=0;j[114630]=0;E(85,g+32|0,38876)|0;c=j[114630];j[114630]=0;if((c|0)==1){break l}}j[114630]=0;c=H(553,b|0)|0;e=j[114630];j[114630]=0;if((e|0)==1){break c}o:{if(c){j[114630]=0;E(85,g|0,38880)|0;b=j[114630];j[114630]=0;if((b|0)==1){break c}break o}if(Br(b)){j[114630]=0;E(85,g|0,38884)|0;b=j[114630];j[114630]=0;if((b|0)!=1){break o}break c}j[114630]=0;E(85,g|0,38876)|0;b=j[114630];j[114630]=0;if((b|0)==1){break c}}ih(a,g+32|0,g);gb(g);gb(g+32|0);if(!d){break i}gb(g+16|0);break i}c=D()|0;C()|0;break a;case 1:c=b+1|0;p:{if(k[b+1|0]){Gs(g+32|0,c);break p}Db(g+32|0,38888)}q:{if(k[c|0]){j[114630]=0;E(85,g+16|0,38891)|0;b=j[114630];j[114630]=0;if((b|0)!=1){break q}break d}j[114630]=0;E(85,g+16|0,38888)|0;b=j[114630];j[114630]=0;if((b|0)==1){break d}}ih(a,g+32|0,g+16|0);gb(g+16|0);gb(g+32|0);break i;case 2:r:{if(Hm(b)){Db(g+32|0,38894);break r}if(k[b+2|0]){gj(g+32|0,1,MI(j[j[i>>2]+8>>2],k[b+2|0]));break r}Db(g+32|0,38894)}j[114630]=0;c=H(1336,b|0)|0;d=j[114630];j[114630]=0;if((d|0)==1){break e}s:{if(c){j[114630]=0;E(85,g+16|0,38894)|0;b=j[114630];j[114630]=0;if((b|0)==1){break e}break s}if(k[b+2|0]){j[114630]=0;E(85,g+16|0,38896)|0;b=j[114630];j[114630]=0;if((b|0)!=1){break s}break e}j[114630]=0;E(85,g+16|0,38894)|0;b=j[114630];j[114630]=0;if((b|0)==1){break e}}ih(a,g+32|0,g+16|0);gb(g+16|0);gb(g+32|0);break i;case 4:t:{if(Hm(b)){m=g,n=sx(b)&255,j[m>>2]=n;zy(g+32|0,g);break t}if(k[b+2|0]){Gs(g+32|0,b+4|0);break t}Db(g+32|0,38888)}j[114630]=0;c=H(1336,b|0)|0;d=j[114630];j[114630]=0;if((d|0)==1){break f}u:{if(c){j[114630]=0;E(85,g+16|0,38898)|0;b=j[114630];j[114630]=0;if((b|0)==1){break f}break u}if(k[b+2|0]){j[114630]=0;E(85,g+16|0,38898)|0;b=j[114630];j[114630]=0;if((b|0)!=1){break u}break f}j[114630]=0;E(85,g+16|0,38888)|0;b=j[114630];j[114630]=0;if((b|0)==1){break f}}ih(a,g+32|0,g+16|0);gb(g+16|0);gb(g+32|0);break i;case 3:v:{if(Hm(b)){m=g,n=(Ur(b)&3840)!=0,h[m|0]=n;c9(g+32|0,g);break v}if(k[b+3|0]){gj(g+32|0,1,LI(j[j[i>>2]+8>>2],k[b+3|0]));break v}Db(g+32|0,38901)}j[114630]=0;c=H(1336,b|0)|0;d=j[114630];j[114630]=0;if((d|0)==1){break g}w:{if(c){j[114630]=0;E(85,g+16|0,38903)|0;b=j[114630];j[114630]=0;if((b|0)==1){break g}break w}if(k[b+3|0]){j[114630]=0;E(85,g+16|0,38903)|0;b=j[114630];j[114630]=0;if((b|0)!=1){break w}break g}j[114630]=0;E(85,g+16|0,38901)|0;b=j[114630];j[114630]=0;if((b|0)==1){break g}}ih(a,g+32|0,g+16|0);gb(g+16|0);gb(g+32|0);break i;case 5:x:{if(Hm(b)){m=g,n=Ur(b)&255,j[m>>2]=n;zy(g+32|0,g);break x}if(k[b+3|0]){Gs(g+32|0,b+5|0);break x}Db(g+32|0,38888)}j[114630]=0;c=H(1336,b|0)|0;d=j[114630];j[114630]=0;if((d|0)==1){break h}y:{if(c){j[114630]=0;E(85,g+16|0,38905)|0;b=j[114630];j[114630]=0;if((b|0)==1){break h}break y}if(k[b+3|0]){j[114630]=0;E(85,g+16|0,38905)|0;b=j[114630];j[114630]=0;if((b|0)!=1){break y}break h}j[114630]=0;E(85,g+16|0,38888)|0;b=j[114630];j[114630]=0;if((b|0)==1){break h}}ih(a,g+32|0,g+16|0);gb(g+16|0);gb(g+32|0);break i;default:break k}}c=a;a=Cb(g+32|0);b=Cb(g+16|0);ih(c,a,b);gb(b);gb(a)}Za=g+48|0;return}c=D()|0;C()|0;gb(g+32|0);break a}c=D()|0;C()|0;gb(g+32|0);break a}c=D()|0;C()|0;gb(g+32|0);break a}c=D()|0;C()|0;gb(g+32|0);break a}c=D()|0;C()|0;gb(g+32|0);break a}c=D()|0;C()|0;gb(g+32|0);if(!d){break a}}gb(g+16|0)}G(c|0);z()}function Dia(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,m=0,o=0,p=q(0),r=0,s=0;d=Za-128|0;Za=d;h=-1;a:{b:{c:{d:{if(!mf(j[j[b>>2]-12>>2]+b|0)){break d}Ve(d+112|0,b);e=j[d+120>>2];f=j[d+124>>2];El(d+104|0);Aj(b,d+104|0,8);if((k[d+104|0]|k[d+105|0]<<8|(k[d+106|0]<<16|k[d+107|0]<<24))!=1414681667|(k[d+108|0]|k[d+109|0]<<8|(k[d+110|0]<<16|k[d+111|0]<<24))!=776101705){a=sg(d+88|0,e,f);c=j[a+12>>2];j[d+16>>2]=j[a+8>>2];j[d+20>>2]=c;c=j[a+4>>2];j[d+8>>2]=j[a>>2];j[d+12>>2]=c;Hi(b,d+8|0);break d}i[d+86>>1]=0;cf(b,d+86|0);if((l[d+86>>1]&65534)!=2){break d}El(d+78|0);Aj(b,d+78|0,8);if((k[d+78|0]|k[d+79|0]<<8|(k[d+80|0]<<16|k[d+81|0]<<24))!=1933333571|(k[d+82|0]|k[d+83|0]<<8|(k[d+84|0]<<16|k[d+85|0]<<24))!=1111389030){break d}i[d+76>>1]=0;cf(b,d+76|0);e=i[d+76>>1];if((e-3&65535)>>>0>1){break d}e:{f:{g:{h:{i:{j:{k:{if((e|0)<=3){e=Cb(d+112|0);j[114630]=0;f=K(721,b|0,e|0,65535)|0;m=j[114630];j[114630]=0;if((m|0)==1){break b}if(!f){break j}j[114630]=0;I(13,d- -64|0,c|0,e|0);f=j[114630];j[114630]=0;if((f|0)!=1){break k}break b}e=Cb(d+112|0);j[114630]=0;f=K(723,b|0,e|0,255)|0;m=j[114630];j[114630]=0;if((m|0)==1){break c}if(!f){break i}j[114630]=0;I(13,d- -64|0,c|0,e|0);f=j[114630];j[114630]=0;if((f|0)==1){break c}}ob(a+40|0,d- -64|0);gb(d- -64|0);gb(e);i[d+62>>1]=0;cf(b,d+62|0);i[d+60>>1]=0;cf(b,d+60|0);i[a>>1]=l[d+60>>1];i[d+58>>1]=0;l:{if(i[d+76>>1]<=3){j[d+112>>2]=0;gi(b,d+112|0);e=j[d+112>>2];if(e>>>0>65535){break d}e=pz(e);i[d+58>>1]=e;break l}cf(b,d+58|0);e=l[d+58>>1]}m:{n:{o:{p:{if(e&65535){m=a+52|0;f=0;while(1){e=Cb(d+112|0);j[114630]=0;i[d+40>>1]=0;E(1611,b|0,d+40|0)|0;g=j[114630];j[114630]=0;if((g|0)==1){break g}q:{if(i[d+76>>1]<=3){j[114630]=0;g=K(721,b|0,e|0,65535)|0;o=j[114630];j[114630]=0;if((o|0)==1){break g}if(g){break q}break e}j[114630]=0;g=K(723,b|0,e|0,255)|0;o=j[114630];j[114630]=0;if((o|0)==1){break g}if(!g){break e}}j[114630]=0;I(13,d- -64|0,c|0,e|0);g=j[114630];j[114630]=0;if((g|0)==1){break p}j[114630]=0;g=E(1612,m|0,d+40|0)|0;o=j[114630];j[114630]=0;if((o|0)==1){break o}ob(g,d- -64|0);gb(d- -64|0);gb(e);f=f+1|0;if(l[d+58>>1]>(f&65535)>>>0){continue}break}}El(d- -64|0);Aj(b,d- -64|0,8);if((k[d+64|0]|k[d+65|0]<<8|(k[d+66|0]<<16|k[d+67|0]<<24))!=1933333571|(k[d+68|0]|k[d+69|0]<<8|(k[d+70|0]<<16|k[d+71|0]<<24))!=1161720678){break d}c=l[a>>1];if(c>>>0>3|(c|0)==2){break d}c=a+4|0;if(i[d+86>>1]>2){break n}if(kI(b,c)){break m}break d}b=D()|0;C()|0;break f}b=D()|0;C()|0;gb(d- -64|0);break f}if(!jI(b,c)){break d}}c=a+16|0;r:{if(i[d+86>>1]<=2){if(kI(b,c)){break r}break d}if(!jI(b,c)){break d}}r=a,s=sb(a+16|0),j[r+36>>2]=s;i[d+56>>1]=0;cf(b,d+56|0);c=l[d+56>>1];i[a+28>>1]=c;if((c+200&65535)>>>0>400){break d}i[d+54>>1]=0;cf(b,d+54|0);c=i[d+54>>1];i[a+30>>1]=c;if((c|0)<0){break d}j[d+48>>2]=0;jo(b,d+48|0);p=n[d+48>>2];n[a+32>>2]=p;if(p<q(0)){break d}El(d+40|0);Aj(b,d+40|0,8);if((k[d+40|0]|k[d+41|0]<<8|(k[d+42|0]<<16|k[d+43|0]<<24))!=1414681667|(k[d+44|0]|k[d+45|0]<<8|(k[d+46|0]<<16|k[d+47|0]<<24))!=776298313){break d}c=a+4|0;if(sb(c)>>>0>32767){break d}f=a+32|0;s:{if(!(n[f>>2]>q(0)?i[a+30>>1]>=1:0)){if(!l[a>>1]){break s}break d}t:{switch(l[a>>1]-1|0){case 0:case 2:break t;default:break s}}if(sb(c)>>>0<i[a+30>>1]>>>0){break d}}b=0;e=j[a+36>>2];if(e){b=e-1|0;j[a+36>>2]=b}r=d,s=Fs(b),j[r+112>>2]=s;j[d+32>>2]=0;r=a,s=j[$r(d+112|0,d+32|0,32408)>>2],j[r+36>>2]=s;ko(a);h=1;if(l[a>>1]!=3){break d}if((pI(sb(c))|0)<(i[a+30>>1]-i[a+28>>1]|0)){break d}e=Jj(d+112|0);h=0;if(i[a+30>>1]>0){while(1){b=xb(c,h-i[a+28>>1]|0);j[114630]=0;F(1613,e|0,b|0);b=j[114630];j[114630]=0;if((b|0)==1){break h}h=h+1|0;if((h|0)<i[a+30>>1]){continue}break}}b=l[a+28>>1];i[d+32>>1]=b;c=sb(c);j[114630]=0;i[d+34>>1]=(b+c|0)-1;i[d+30>>1]=0;U(1607,a|0,e|0,f|0,d+32|0,d+30|0)|0;a=j[114630];j[114630]=0;h=1;if((a|0)!=1){xf(e);break d}break h}gb(e);break d}gb(e);break d}b=D()|0;C()|0;xf(e);break a}b=D()|0;C()|0}gb(e);break a}gb(e)}Za=d+128|0;return h|0}b=D()|0;C()|0;gb(e);break a}b=D()|0;C()|0;gb(e)}G(b|0);z()}function Xxa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;d=Za-192|0;Za=d;rc(b);a:{if(!fz(b,d+144|0)){break a}if(!iN(d+144|0)){break a}if(!yb(b,Tc(hN(d+144|0),ab))){break a}b:{if(!c){break b}od(a,256);jn(d+16|0,2,d+144|0);qc(d+48|0,d+16|0);ob(a+1304400|0,d+48|0);gb(d+48|0);e=Db(d+48|0,17295);ob(a+1304436|0,e);gb(e);e=Db(d+48|0,17312);ob(a+1304448|0,e);gb(e);g=Db(d+128|0,17316);j[114630]=0;F(219,d+16|0,g|0);e=j[114630];j[114630]=0;c:{d:{e:{f:{g:{h:{i:{if((e|0)!=1){j[114630]=0;F(450,d+112|0,d+175|0);e=j[114630];j[114630]=0;if((e|0)==1){break i}j[114630]=0;L(451,d+48|0,d+16|0,d+174|0,d+112|0);e=j[114630];j[114630]=0;if((e|0)==1){break h}ob(a+1304460|0,d+48|0);gb(d+48|0);gb(d+112|0);qb(d+16|0);gb(g);j[a+1304496>>2]=4;j[a+480260>>2]=64;j[a+480264>>2]=32767;j[a+480188>>2]=2031620;f=k[d+176|0];if(k[d+175|0]<=20){e=((f&255)>>>0)/10|0;f=e<<4|f-p(e,10)}g=(f&255?f:96)&255;e=LK(g);j[a+480196>>2]=g>>>4;j[a+480204>>2]=e;if(k[d+175|0]>10){break e}break d}f=D()|0;C()|0;break f}f=D()|0;C()|0;break g}f=D()|0;C()|0;gb(d+112|0)}qb(d+16|0)}gb(g);break c}h[d+48|0]=64;v=a,w=k[Zb(d+178|0,d+48|0)|0]<<2,j[v+480200>>2]=w}f=0;while(1){e=(f<<5)+a|0;wg(e+480280|0);i[e+480284>>1]=f&1?64:192;f=f+1|0;if((f|0)!=4){continue}break}f=1;j:{k:{while(1){Bs(b,d+16|0);if(k[d+28|0]!=46?k[d+28|0]:0){break k}Wxa(d+16|0,(p(f,104)+a|0)+484380|0);ek(d,2,d+16|0);qc(d+112|0,d);j[114630]=0;E(369,((f<<5)+a|0)+946300|0,d+112|0)|0;e=j[114630];j[114630]=0;if((e|0)==1){break j}gb(d+112|0);i[((f<<1)+d|0)+46>>1]=k[d+30|0]|k[d+31|0]<<8;f=f+1|0;if((f|0)!=32){continue}break}e=a+484360|0;mp(Eb(e),b,k[d+175|0]?128:64,65535,65535);e=Eb(e);v=d,w=Lb(e),j[v+16>>2]=w;v=d,w=Mb(e),j[v+112>>2]=w;if(rb(d+16|0,d+112|0)){while(1){e=j[d+16>>2];g=l[e>>1];l:{if(!((g|0)!=99?(g|0)!=255:0)){i[e>>1]=65535;break l}if(g>>>0>63){break k}}je(d+16|0);if(rb(d+16|0,d+112|0)){continue}break}}t=c&1;if(t){Jf(a+484344|0,k[d+177|0])}if(k[d+177|0]){r=a+484344|0;while(1){m:{n:{if(t){if(Wf(r,o&65535,64)){break n}}f=0;while(1){if((dd(b)+5&255)>>>0>=3){Jb(b,3)}f=f+1|0;if((f|0)!=256){continue}break}break m}v=d,w=Lb(Hb(r,o)),j[v+112>>2]=w;j[d>>2]=63;n=65535;q=0;while(1){f=0;while(1){g=f;m=0;f=0;s=0;u=0;o:{p:{q:{r:{s:{t:{e=dd(b);switch(e-251|0){case 1:break o;case 0:break r;case 2:break t;default:break s}}h[j[d+112>>2]]=254;break o}Bt(d+16|0,b);f=k[Pb(d+16|0,0)|0];s=k[Pb(d+16|0,1)|0];u=k[Pb(d+16|0,2)|0];m=254;if((e|0)==254){break q}m=e;if(e>>>0>95){break p}}m=(p(m>>>4|0,12)+(m&15)|0)+37|0}e=m;h[j[d+112>>2]]=e}h[j[d+112>>2]+1|0]=(f&248)>>>3;if(k[j[d+112>>2]+1|0]>=32){h[j[d+112>>2]+1|0]=0}e=s>>>1&120|f&7;if(e>>>0<=64){h[j[d+112>>2]+2|0]=1;h[j[d+112>>2]+4|0]=e}h[j[d+112>>2]+3|0]=k[(s&15)+17344|0];h[j[d+112>>2]+5|0]=u;u:{switch(k[j[d+112>>2]+3|0]-11|0){case 0:m=j[d+112>>2];e=k[m+5|0];if(k[j[d+112>>2]+5|0]&15){h[m+5|0]=e&15;break o}h[m+5|0]=e&240;break o;case 3:h[j[d+112>>2]+5|0]=p(k[j[d+112>>2]+5|0]&240,10)|k[j[d+112>>2]+5|0]&15;v:{if((n|0)!=65535){if(k[j[d+112>>2]+5|0]){break v}h[j[d+112>>2]+3|0]=12;h[j[d+112>>2]+5|0]=n}n=65535}jc(d,q);break o;case 1:n=k[j[d+112>>2]+5|0];j[d>>2]=63;h[j[d+112>>2]+3|0]=0;break o;case 5:if(k[d+175|0]<=20){h[j[d+112>>2]+5|0]=k[j[d+112>>2]+5|0]%10|k[j[d+112>>2]+5|0]/10<<4}if(k[j[d+112>>2]+5|0]){break o}h[j[d+112>>2]+3|0]=0;break o;case 7:break o;default:break u}}if(k[j[d+112>>2]+5|0]){break o}h[j[d+112>>2]+3|0]=0}lk(d+112|0);f=g+1|0;if((g&65535)>>>0<3){continue}break}q=q+1|0;if((q|0)!=64){continue}break}if((n|0)==65535){break m}Yk(Hb(r,o),hn(Ee(Ep(d+16|0,12,n&255),j[d>>2])))}o=o+1|0;if(o>>>0<k[d+177|0]){continue}break}}f=1;if(!(c&2)){break a}g=Kc(d+16|0,8,1,0,0);while(1){c=p(f,104)+a|0;e=c+484380|0;w:{if(!j[e>>2]|!l[c+484410>>1]){break w}c=l[((f<<1)+d|0)+46>>1];if(c>>>0<4){break w}if(!xc(b,c<<4)){break w}$f(g,e,b)}f=f+1|0;if((f|0)!=32){continue}break}break b}f=0;break a}f=D()|0;C()|0;gb(d+112|0)}G(f|0);z()}f=1}Za=d+192|0;return f|0}function t$(){var a=0,b=0,c=0,d=0,e=0;td(463472);j[115868]=64720;j[114630]=0;b=E(2516,463488,28)|0;a=j[114630];j[114630]=0;a:{b:{c:{d:{if((a|0)!=1){j[114630]=0;c=E(85,463648,64709)|0;a=j[114630];j[114630]=0;if((a|0)==1){break d}sb(b);yC(b);xC(b);td(463152);j[115788]=66336;j[114630]=0;F(2517,463472,463152);a=j[114630];j[114630]=0;if((a|0)==1){break c}td(463160);j[115790]=66368;j[114630]=0;F(2518,463472,463160);a=j[114630];j[114630]=0;if((a|0)==1){break c}td(463168);h[463180]=0;j[115794]=0;j[115792]=64740;d=463176,e=Qn(),j[d>>2]=e;j[114630]=0;F(2519,463472,463168);a=j[114630];j[114630]=0;if((a|0)==1){break c}td(463184);j[115796]=65324;j[114630]=0;F(2520,463472,463184);a=j[114630];j[114630]=0;if((a|0)==1){break c}td(463192);j[115798]=65472;j[114630]=0;F(2521,463472,463192);a=j[114630];j[114630]=0;if((a|0)==1){break c}j[114630]=0;M(2522);a=j[114630];j[114630]=0;if((a|0)==1){break c}j[114630]=0;F(2523,463472,463200);a=j[114630];j[114630]=0;if((a|0)==1){break c}td(463216);j[115804]=65620;j[114630]=0;F(2524,463472,463216);a=j[114630];j[114630]=0;if((a|0)==1){break c}j[114630]=0;rq(463224);a=j[114630];j[114630]=0;if((a|0)==1){break c}j[114630]=0;F(2526,463472,463224);a=j[114630];j[114630]=0;if((a|0)==1){break c}td(463232);i[231620]=11310;j[115808]=64840;Cb(463244);j[114630]=0;F(2527,463472,463232);a=j[114630];j[114630]=0;if((a|0)==1){break c}td(463264);j[115818]=46;j[115819]=44;j[115816]=64880;Cb(463280);j[114630]=0;F(2528,463472,463264);a=j[114630];j[114630]=0;if((a|0)==1){break c}td(463296);j[115824]=66400;j[114630]=0;F(2529,463472,463296);a=j[114630];j[114630]=0;if((a|0)==1){break c}td(463304);j[115826]=66644;j[114630]=0;F(2530,463472,463304);a=j[114630];j[114630]=0;if((a|0)==1){break c}td(463312);j[115828]=66856;j[114630]=0;F(2531,463472,463312);a=j[114630];j[114630]=0;if((a|0)==1){break c}td(463320);j[115830]=67088;j[114630]=0;F(2532,463472,463320);a=j[114630];j[114630]=0;if((a|0)==1){break c}j[114630]=0;vC();a=j[114630];j[114630]=0;if((a|0)==1){break c}j[114630]=0;F(2534,463472,463328);a=j[114630];j[114630]=0;if((a|0)==1){break c}td(463336);j[115834]=68220;j[114630]=0;F(2535,463472,463336);a=j[114630];j[114630]=0;if((a|0)==1){break c}td(463344);j[115836]=68336;j[114630]=0;F(2536,463472,463344);a=j[114630];j[114630]=0;if((a|0)==1){break c}td(463352);j[115838]=68452;j[114630]=0;F(2537,463472,463352);a=j[114630];j[114630]=0;if((a|0)==1){break c}j[114630]=0;uC();a=j[114630];j[114630]=0;if((a|0)==1){break c}j[114630]=0;F(2539,463472,463360);a=j[114630];j[114630]=0;if((a|0)==1){break c}j[114630]=0;tC();a=j[114630];j[114630]=0;if((a|0)==1){break c}j[114630]=0;F(2541,463472,463368);a=j[114630];j[114630]=0;if((a|0)==1){break c}j[114630]=0;sC();a=j[114630];j[114630]=0;if((a|0)==1){break c}j[114630]=0;F(2543,463472,463376);a=j[114630];j[114630]=0;if((a|0)==1){break c}j[114630]=0;rC();a=j[114630];j[114630]=0;if((a|0)==1){break c}j[114630]=0;F(2545,463472,463384);a=j[114630];j[114630]=0;if((a|0)==1){break c}td(463392);j[115850]=70612;j[115848]=67288;j[115850]=67336;j[114630]=0;F(2546,463472,463392);a=j[114630];j[114630]=0;if((a|0)==1){break c}td(463408);j[115854]=70648;j[115852]=67552;j[115854]=67600;j[114630]=0;F(2547,463472,463408);a=j[114630];j[114630]=0;if((a|0)==1){break c}j[114630]=0;M(2548);a=j[114630];j[114630]=0;if((a|0)==1){break c}j[114630]=0;F(2549,463472,463424);a=j[114630];j[114630]=0;if((a|0)==1){break c}j[114630]=0;M(2550);a=j[114630];j[114630]=0;if((a|0)==1){break c}j[114630]=0;F(2551,463472,463440);a=j[114630];j[114630]=0;if((a|0)==1){break c}j[114630]=0;qC();a=j[114630];j[114630]=0;if((a|0)==1){break c}j[114630]=0;F(2553,463472,463456);a=j[114630];j[114630]=0;if((a|0)==1){break c}td(463464);j[115866]=69344;j[114630]=0;F(2554,463472,463464);a=j[114630];j[114630]=0;if((a|0)==1){break c}return}a=D()|0;C()|0;break a}a=D()|0;C()|0;break b}a=D()|0;C()|0;gb(c)}BC(b)}G(a|0);z()}function GU(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,l=0,m=0;d=Za-160|0;Za=d;rc(b);cq(a);a:{if(!Vt(b,d+120|0)){break a}if(!YI(d+120|0)){break a}if(!tla(b,d+120|0)){break a}if(!c){f=1;break a}pla(d+104|0,b,d+120|0);c=d+152|0;c=k[c|0]|k[c+1|0]<<8|(k[c+2|0]<<16|k[c+3|0]<<24);j[114630]=0;c=E(256,b|0,c|0)|0;g=j[114630];j[114630]=0;b:{c:{d:{e:{f:{g:{h:{i:{if((g|0)!=1){if(!c){break b}g=d+88|0;BU(g);c=d+148|0;f=k[c|0]|k[c+1|0]<<8|(k[c+2|0]<<16|k[c+3|0]<<24);j[114630]=0;F(332,g|0,f|0);f=j[114630];j[114630]=0;if((f|0)==1){break h}if(!(k[c|0]|k[c+1|0]<<8|(k[c+2|0]<<16|k[c+3|0]<<24))){break i}f=d+120|4;while(1){j:{j[114630]=0;e=E(258,b|0,4)|0;m=j[114630];j[114630]=0;if((m|0)==1){break j}if(!e){break i}e=k[f|0]|k[f+1|0]<<8;j[114630]=0;e=E(333,b|0,e|0)|0;m=j[114630];j[114630]=0;k:{if((m|0)!=1){j[d+24>>2]=e;if(ec(d+104|0)>>>0<=e>>>0){break k}j[114630]=0;F(334,g|0,d+24|0);e=j[114630];j[114630]=0;if((e|0)!=1){break k}}b=D()|0;C()|0;break f}i=i+1|0;if(i>>>0<(k[c|0]|k[c+1|0]<<8|(k[c+2|0]<<16|k[c+3|0]<<24))>>>0){continue}break i}break}b=D()|0;C()|0;break f}b=D()|0;C()|0;break e}c=d+144|0;c=k[c|0]|k[c+1|0]<<8|(k[c+2|0]<<16|k[c+3|0]<<24);f=0;j[114630]=0;c=E(256,b|0,c|0)|0;i=j[114630];j[114630]=0;if((i|0)!=1){break g}}b=D()|0;C()|0;break f}if(!c){break c}f=d+140|0;if(!(k[f|0]|k[f+1|0]<<8|(k[f+2|0]<<16|k[f+3|0]<<24))){break d}m=d+36|0;c=d+120|4;i=0;l:{m:{n:{o:{p:{q:{while(1){j[114630]=0;e=E(258,b|0,4)|0;h=j[114630];j[114630]=0;r:{if((h|0)!=1){if(e){break r}break d}b=D()|0;C()|0;break f}e=k[c|0]|k[c+1|0]<<8;j[114630]=0;aa(335,b|0,d+84|0,d+80|0,d+76|0,d+72|0,e|0);e=j[114630];j[114630]=0;if((e|0)==1){break o}s:{t:{if(j[d+76>>2]<1){break t}e=j[d+84>>2];if((e|0)>-1){break t}e=e^-1;j[d+84>>2]=e;if(sb(g)>>>0<=e>>>0){break t}if(!Dd(ad(d+104|0,j[xb(g,j[d+84>>2])>>2]),11555)){break t}j[114630]=0;L(336,d+56|0,b|0,j[d+80>>2],j[d+76>>2]);e=j[114630];j[114630]=0;if((e|0)==1){break n}j[114630]=0;e=H(337,d+56|0)|0;h=j[114630];j[114630]=0;if((h|0)==1){break m}if(e){if((k[c|0]|k[c+1|0]<<8)>>>0<=39){j[114630]=0;E(338,d+56|0,8)|0;e=j[114630];j[114630]=0;if((e|0)==1){break m}}if((k[c|0]|k[c+1|0]<<8)>>>0<=59){j[114630]=0;E(338,d+56|0,16)|0;e=j[114630];j[114630]=0;if((e|0)==1){break m}}j[114630]=0;H(339,d+56|0)|0;e=j[114630];j[114630]=0;if((e|0)==1){break m}u:{if((k[c|0]|k[c+1|0]<<8)>>>0>=120){j[114630]=0;H(339,d+56|0)|0;e=j[114630];j[114630]=0;if((e|0)==1){break m}j[114630]=0;E(338,d+56|0,8)|0;break u}if((k[c|0]|k[c+1|0]<<8)>>>0>=100){j[114630]=0;E(338,d+56|0,4)|0;e=j[114630];j[114630]=0;if((e|0)==1){break m}j[114630]=0;H(339,d+56|0)|0;e=j[114630];j[114630]=0;if((e|0)==1){break m}j[114630]=0;E(338,d+56|0,4)|0;break u}if((k[c|0]|k[c+1|0]<<8)>>>0>=62){j[114630]=0;H(339,d+56|0)|0;e=j[114630];j[114630]=0;if((e|0)==1){break m}j[114630]=0;E(338,d+56|0,4)|0;break u}j[114630]=0;H(339,d+56|0)|0}e=j[114630];j[114630]=0;if((e|0)==1){break m}j[114630]=0;h=H(339,d+56|0)|0;e=j[114630];j[114630]=0;if((e|0)==1){break p}j[114630]=0;e=H(340,d+24|0)|0;l=j[114630];j[114630]=0;if((l|0)==1){break s}l=j[d+72>>2];v:{if((l|0)<0){break v}if(ec(d+104|0)>>>0<=l>>>0){break v}l=ad(d+104|0,j[d+72>>2]);j[114630]=0;I(13,d+8|0,2,l|0);l=j[114630];j[114630]=0;if((l|0)==1){break q}ob(d+24|0,d+8|0);gb(d+8|0)}j[114630]=0;I(341,d+8|0,d+56|0,h|0);h=j[114630];j[114630]=0;if((h|0)==1){break q}Ed(m,d+8|0);jb(d+8|0);j[114630]=0;F(342,a|0,e|0);h=j[114630];j[114630]=0;if((h|0)==1){break q}cu(e)}jb(d+56|0)}i=i+1|0;if(i>>>0<(k[f|0]|k[f+1|0]<<8|(k[f+2|0]<<16|k[f+3|0]<<24))>>>0){continue}break d}break}b=D()|0;C()|0;break l}b=D()|0;C()|0;cu(e);break l}b=D()|0;C()|0;break l}b=D()|0;C()|0;break f}b=D()|0;C()|0;break f}b=D()|0;C()|0}jb(d+56|0)}FA(g)}Vc(d+104|0);G(b|0);z()}f=Xc(a)^1}FA(g)}Vc(d+104|0)}Za=d+160|0;return f|0}function U4(a,b){var c=q(0),d=0,e=0,f=0,g=q(0),h=0,i=0,j=q(0),k=q(0),l=q(0),m=0,o=q(0),p=0,s=q(0),t=q(0),u=q(0),v=q(0);g=q(1);a:{b:{h=(SMa(a),OMa(2));c:{if((h|0)==1065353216){break c}i=(SMa(b),OMa(2));d=i&2147483647;if(!d){break c}e=h&2147483647;if(!(d>>>0<2139095041?e>>>0<=2139095040:0)){return q(a+b)}d:{e:{if((h|0)>-1){break e}m=2;if(d>>>0>1266679807){break d}if(d>>>0<1065353216){break e}f=150-(d>>>23|0)|0;p=d>>>f|0;m=0;if((d|0)!=p<<f){break d}m=2-(p&1)|0;break d}m=0}f=m;f:{if((d|0)!=1065353216){if((d|0)!=2139095040){break f}if((e|0)==1065353216){break c}if(e>>>0>=1065353217){return(i|0)>-1?b:q(0)}return(i|0)>-1?q(0):q(-b)}return(i|0)>-1?a:q(q(1)/a)}if((i|0)==1073741824){return q(a*a)}if(!((i|0)!=1056964608|(h|0)<0)){return q(y(a))}c=q(r(a));if(!(e?(h&1073741823)!=1065353216:0)){g=(i|0)<0?q(q(1)/c):c;if((h|0)>-1){break c}if(!(f|e-1065353216)){a=q(g-g);return q(a/a)}return(f|0)==1?q(-g):g}g:{if((h|0)>-1){break g}h:{switch(f|0){case 0:a=q(a-a);return q(a/a);case 1:break h;default:break g}}g=q(-1)}i:{if(d>>>0>=1291845633){if(e>>>0<=1065353207){return(i|0)<0?q(q(g*q(1.0000000150474662e+30))*q(1.0000000150474662e+30)):q(q(g*q(1.0000000031710769e-30))*q(1.0000000031710769e-30))}if(e>>>0>=1065353224){return(i|0)>0?q(q(g*q(1.0000000150474662e+30))*q(1.0000000150474662e+30)):q(q(g*q(1.0000000031710769e-30))*q(1.0000000031710769e-30))}a=q(c+q(-1));c=q(a*q(1.44268798828125));j=q(q(a*q(7052607543300837e-21))+q(q(q(a*a)*q(q(.5)-q(a*q(q(a*q(-.25))+q(.3333333432674408)))))*q(-1.4426950216293335)));a=(PMa(2,(SMa(q(c+j)),OMa(2))&-4096),TMa());o=q(a-c);break i}d=e>>>0<8388608;e=d?(SMa(q(c*q(16777216))),OMa(2)):e;h=e&8388607;f=h|1065353216;d=(e>>23)+(d?-151:-127)|0;e=0;j:{if(h>>>0<1885298){break j}if(h>>>0<6140887){e=1;break j}f=f-8388608|0;d=d+1|0}h=e<<2;o=n[h+52256>>2];j=(PMa(2,f),TMa());k=n[h+52240>>2];l=q(j-k);s=q(q(1)/q(k+j));c=q(l*s);a=(PMa(2,(SMa(c),OMa(2))&-4096),TMa());t=q(a*a);u=a;v=l;l=(PMa(2,((f>>1&-536875008)+(e<<21)|0)+541065216|0),TMa());j=q(s*q(q(v-q(a*l))-q(a*q(j-q(l-k)))));l=q(q(c+a)*j);a=q(c*c);k=q(l+q(q(a*a)*q(q(a*q(q(a*q(q(a*q(q(a*q(q(a*q(.20697501301765442))+q(.23066075146198273)))+q(.2727281153202057)))+q(.3333333432674408)))+q(.4285714328289032)))+q(.6000000238418579))));a=(PMa(2,(SMa(q(q(t+q(3))+k)),OMa(2))&-4096),TMa());l=q(u*a);c=q(q(j*a)+q(c*q(k-q(q(a+q(-3))-t))));a=(PMa(2,(SMa(q(l+c)),OMa(2))&-4096),TMa());k=q(a*q(.9619140625));j=q(n[h+52248>>2]+q(q(q(c-q(a-l))*q(.9617967009544373))+q(a*q(-.00011736857413779944))));c=q(d|0);a=(PMa(2,(SMa(q(q(o+q(k+j))+c)),OMa(2))&-4096),TMa());o=q(q(q(a-c)-o)-k)}k=(PMa(2,i&-4096),TMa());c=q(a*k);a=q(q(q(j-o)*b)+q(q(b-k)*a));b=q(c+a);f=(SMa(b),OMa(2));if((f|0)>=1124073473){break b}e=1124073472;k:{l:{if((f|0)==1124073472){if(q(a+q(4.299566569443414e-8))>q(b-c)^1){break l}break b}e=f&2147483647;if(!(a<=q(b-c)^1|(f|0)!=-1021968384)|e>>>0>=1125515265){break a}d=0;if(e>>>0<1056964609){break k}}i=(8388608>>>(e>>>23|0)-126|0)+f|0;e=i>>>23&255;d=(i&8388607|8388608)>>>150-e|0;d=(f|0)<0?0-d|0:d;c=q(c-(PMa(2,i&-8388608>>e-127),TMa()));f=(SMa(q(a+c)),OMa(2))}b=(PMa(2,f&-32768),TMa());j=q(b*q(.693145751953125));c=q(q(b*q(14286065379565116e-22))+q(q(a-q(b-c))*q(.6931471824645996)));a=q(j+c);b=q(a*a);b=q(a-q(b*q(q(b*q(q(b*q(q(b*q(q(b*q(4.138136944220605e-8))+q(-16533901998627698e-22)))+q(661375597701408e-19)))+q(-.0027777778450399637)))+q(.1666666716337204))));l=q(q(a*b)/q(b+q(-2)));b=q(c-q(a-j));a=q(q(a-q(l-q(b+q(a*b))))+q(1));f=(SMa(a),OMa(2))+(d<<23)|0;m:{if((f|0)<=8388607){a=GE(a,d);break m}a=(PMa(2,f),TMa())}g=q(g*a)}return g}return q(q(g*q(1.0000000150474662e+30))*q(1.0000000150474662e+30))}return q(q(g*q(1.0000000031710769e-30))*q(1.0000000031710769e-30))}function nG(a,b,c,d){a=a|0;b=b|0;c=+c;d=d|0;var e=0,f=0,g=0,h=0;e=Za-256|0;Za=e;o[e+248>>3]=c;a:{if(Ri(b)){break a}g=k[Fj(b)|0];f=1;b:{if((g|0)==33){break b}if((g|0)!=63){break a}f=0}d=f;Qj(e+216|0,b,j[b+4>>2]-1|0);f=j[e+220>>2];j[b>>2]=j[e+216>>2];j[b+4>>2]=f}ld(e+216|0);f=j[e+216>>2];ld(e+200|0);h=Ej(f,j[e+204>>2],b);ld(e+216|0);f=j[b>>2];g=j[b+4>>2];c:{d:{e:{f:{if((h|0)==j[e+220>>2]){j[e+240>>2]=f;j[e+244>>2]=g;a=_b(e+232|0,38235);f=j[e+244>>2];j[e+16>>2]=j[e+240>>2];j[e+20>>2]=f;f=j[a+4>>2];j[e+8>>2]=j[a>>2];j[e+12>>2]=f;if(nc(e+16|0,e+8|0)){d=R(8)|0;j[114630]=0;F(2138,e+200|0,e+248|0);a=j[114630];j[114630]=0;g:{h:{i:{if((a|0)!=1){j[114630]=0;I(2113,e+216|0,39307,e+200|0);a=j[114630];j[114630]=0;if((a|0)==1){break i}Wb(d,e+216|0);a=0;j[114630]=0;I(2004,d|0,83648,2012);b=j[114630];j[114630]=0;if((b|0)!=1){break c}b=D()|0;C()|0;gb(e+216|0);break h}b=D()|0;C()|0;break g}b=D()|0;a=1;C()|0}gb(e+200|0);if(!a){break d}}S(d|0);break d}if(!d){break f}d=R(8)|0;j[114630]=0;f=E(2136,e+168|0,b|0)|0;b=j[114630];j[114630]=0;a=1;j:{k:{l:{m:{n:{o:{p:{q:{r:{if((b|0)!=1){j[114630]=0;I(2113,e+184|0,39186,f|0);a=j[114630];j[114630]=0;if((a|0)==1){break r}j[114630]=0;I(2131,e+200|0,e+184|0,39322);b=j[114630];j[114630]=0;a=1;if((b|0)==1){break q}j[114630]=0;F(2138,e+152|0,e+248|0);a=j[114630];j[114630]=0;if((a|0)==1){break p}j[114630]=0;I(138,e+216|0,e+200|0,e+152|0);b=j[114630];j[114630]=0;a=1;if((b|0)==1){break o}Wb(d,e+216|0);j[114630]=0;I(2004,d|0,83648,2012);a=j[114630];j[114630]=0;if((a|0)!=1){break c}b=D()|0;C()|0;gb(e+216|0);a=0;break n}b=D()|0;C()|0;break j}b=D()|0;a=1;C()|0;break k}b=D()|0;C()|0;break l}b=D()|0;a=1;C()|0;break m}b=D()|0;C()|0}gb(e+152|0)}gb(e+200|0)}gb(e+184|0)}gb(f)}if(!a){break d}S(d|0);break d}j[e+144>>2]=f;j[e+148>>2]=g;d=_b(e+136|0,38235);f=j[e+148>>2];j[e+80>>2]=j[e+144>>2];j[e+84>>2]=f;f=j[d+4>>2];j[e+72>>2]=j[d>>2];j[e+76>>2]=f;if(nc(e+80|0,e+72|0)){d=R(8)|0;j[114630]=0;F(2138,e+200|0,e+248|0);a=j[114630];j[114630]=0;s:{t:{u:{if((a|0)!=1){j[114630]=0;I(2113,e+216|0,39307,e+200|0);a=j[114630];j[114630]=0;if((a|0)==1){break u}Wb(d,e+216|0);a=0;j[114630]=0;I(2004,d|0,83648,2012);b=j[114630];j[114630]=0;if((b|0)!=1){break c}b=D()|0;C()|0;gb(e+216|0);break t}b=D()|0;C()|0;break s}b=D()|0;a=1;C()|0}gb(e+200|0);if(!a){break d}}S(d|0);break d}d=j[b+4>>2];j[e+128>>2]=j[b>>2];j[e+132>>2]=d;d=_b(e+120|0,39029);f=j[e+132>>2];j[e+64>>2]=j[e+128>>2];j[e+68>>2]=f;f=j[d+4>>2];j[e+56>>2]=j[d>>2];j[e+60>>2]=f;if(nc(e- -64|0,e+56|0)){if(!k[a+28|0]){break f}c=o[e+248>>3];if(!(c<=4?!(c<=0):0)){a=R(8)|0;j[114630]=0;d=E(85,e+216|0,39327)|0;b=j[114630];j[114630]=0;if((b|0)==1){break e}Wb(a,d);j[114630]=0;I(2004,a|0,83648,2012);a=j[114630];j[114630]=0;if((a|0)!=1){break c}b=D()|0;C()|0;gb(d);break d}b=Zj(65536/c);a=a+24|0;j[j[a>>2]+480244>>2]=b;so(j[a>>2]);break f}d=j[b+4>>2];j[e+112>>2]=j[b>>2];j[e+116>>2]=d;d=_b(e+104|0,39047);f=j[e+116>>2];j[e+48>>2]=j[e+112>>2];j[e+52>>2]=f;f=j[d+4>>2];j[e+40>>2]=j[d>>2];j[e+44>>2]=f;if(nc(e+48|0,e+40|0)){if(!k[a+28|0]){break f}c=o[e+248>>3];if(!(c<=4?!(c<=0):0)){a=R(8)|0;j[114630]=0;d=E(85,e+216|0,39348)|0;b=j[114630];j[114630]=0;if((b|0)!=1){Wb(a,d);j[114630]=0;I(2004,a|0,83648,2012);a=j[114630];j[114630]=0;if((a|0)!=1){break c}b=D()|0;C()|0;gb(d);break d}b=D()|0;C()|0;S(a|0);break d}b=Zj(c*65536);a=a+24|0;j[j[a>>2]+480240>>2]=b;so(j[a>>2]);break f}d=j[b+4>>2];j[e+96>>2]=j[b>>2];j[e+100>>2]=d;b=_b(e+88|0,39144);d=j[e+100>>2];j[e+32>>2]=j[e+96>>2];j[e+36>>2]=d;d=j[b+4>>2];j[e+24>>2]=j[b>>2];j[e+28>>2]=d;if(!nc(e+32|0,e+24|0)){break f}b=Qm(o[e+248>>3]*65536);j[j[a+24>>2]+480236>>2]=b}Za=e+256|0;return}b=D()|0;C()|0;S(a|0)}G(b|0)}z()}function k5(a,b,c,d,e,f){var g=0,h=0,n=0,o=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;s=Za-16|0;Za=s;o=j[a+4>>2];h=j[a+396>>2];r=h+p(e,24)|0;q=j[r+4>>2];x=l[((e<<1)+a|0)+268>>1];g=d<<((x|0)==2);n=g>>>0>q>>>0?q:g;q=j[r>>2];q=(n-(g>>>0>q>>>0?q:g)>>>0)/m[r+8>>2]|0;t=q<<2;g=p(o,t+4|0);y=j[j[a+124>>2]+p(k[r+13|0],2096)>>2];C=j[a+92>>2];a:{if(j[a+80>>2]){g=km(a,g);o=j[a+4>>2];break a}g=Yc(g)}t=g5(g,o,t);b:{c:{d:{if((c|0)>=1){o=d<<2;g=0;while(1){if(!k[f+g|0]){Ab(j[(g<<2)+b>>2],0,o)}g=g+1|0;if((g|0)!=(c|0)){continue}break}if((c|0)==1|(x|0)!=2){break d}g=0;if((c|0)<1){break c}while(1){if(!k[f+g|0]){break c}g=g+1|0;if((g|0)!=(c|0)){continue}break}break b}g=0;if((x|0)==2){break c}}z=h+p(e,24)|0;A=z;B=(q|0)<1;d=0;while(1){if(!B){v=0;w=(c|0)<1;D=w|(d|0)!=0;o=0;while(1){g=0;if(!D){while(1){if(!k[f+g|0]){h=j[a+124>>2]+p(k[r+13|0],2096)|0;if(j[a+1396>>2]<=9){Dj(a)}n=j[a+1392>>2];e=i[(h+((n&1023)<<1)|0)+36>>1];e:{if((e|0)>=0){u=n;n=k[e+j[h+8>>2]|0];j[a+1392>>2]=u>>>n;u=j[a+1396>>2]-n|0;n=(u|0)<0;j[a+1396>>2]=n?0:u;e=n?-1:e;break e}e=Qk(a,h)}e=k[h+23|0]?j[j[h+2088>>2]+(e<<2)>>2]:e;if((e|0)==-1){break b}j[j[t+(g<<2)>>2]+(v<<2)>>2]=j[j[z+16>>2]+(e<<2)>>2]}g=g+1|0;if((g|0)!=(c|0)){continue}break}}f:{if((o|0)>=(q|0)){break f}e=0;if((y|0)<1){break f}while(1){g=0;if(!w){while(1){g:{if(k[f+g|0]){break g}h=g<<2;n=i[(j[A+20>>2]+(k[j[j[h+t>>2]+(v<<2)>>2]+e|0]<<4)|0)+(d<<1)>>1];if((n|0)<0){break g}u=j[b+h>>2];h=j[r+8>>2];if(!f5(a,j[a+124>>2]+p(n&65535,2096)|0,u,j[r>>2]+p(h,o)|0,h,x)){break b}}g=g+1|0;if((g|0)!=(c|0)){continue}break}}o=o+1|0;if((q|0)<=(o|0)){break f}e=e+1|0;if((y|0)>(e|0)){continue}break}}v=v+1|0;if((o|0)<(q|0)){continue}break}}d=d+1|0;if((d|0)!=8){continue}break}break b}if((c|0)==(g|0)){break b}z=(q|0)<1;A=z|(c|0)<3;v=h+p(e,24)|0;x=v;B=(c|0)!=2;e=0;while(1){h:{if(!B){if(z){break h}f=0;o=0;while(1){g=j[r>>2]+p(j[r+8>>2],f)|0;j[s+12>>2]=g&1;j[s+8>>2]=g>>1;if(!e){h=j[a+124>>2]+p(k[r+13|0],2096)|0;if(j[a+1396>>2]<=9){Dj(a)}n=j[a+1392>>2];g=i[(h+((n&1023)<<1)|0)+36>>1];i:{if((g|0)>=0){u=n;n=k[g+j[h+8>>2]|0];j[a+1392>>2]=u>>>n;w=j[a+1396>>2]-n|0;n=(w|0)<0;j[a+1396>>2]=n?0:w;g=n?-1:g;break i}g=Qk(a,h)}g=k[h+23|0]?j[j[h+2088>>2]+(g<<2)>>2]:g;if((g|0)==-1){break b}j[j[t>>2]+(o<<2)>>2]=j[j[v+16>>2]+(g<<2)>>2]}j:{if((f|0)>=(q|0)){break j}g=0;if((y|0)<1){break j}while(1){h=j[r+8>>2];n=i[(j[x+20>>2]+(k[j[j[t>>2]+(o<<2)>>2]+g|0]<<4)|0)+(e<<1)>>1];k:{if((n|0)>=0){if(ME(a,j[a+124>>2]+p(n&65535,2096)|0,b,2,s+12|0,s+8|0,d,h)){break k}break b}h=j[r>>2]+(h+p(f,h)|0)|0;j[s+8>>2]=h>>1;j[s+12>>2]=h&1}f=f+1|0;if((q|0)<=(f|0)){break j}g=g+1|0;if((y|0)>(g|0)){continue}break}}o=o+1|0;if((f|0)<(q|0)){continue}break}break h}if(A){break h}f=0;o=0;while(1){h=j[r>>2]+p(j[r+8>>2],f)|0;g=(h|0)/(c|0)|0;j[s+12>>2]=h-p(c,g);j[s+8>>2]=g;if(!e){h=j[a+124>>2]+p(k[r+13|0],2096)|0;if(j[a+1396>>2]<=9){Dj(a)}n=j[a+1392>>2];g=i[(h+((n&1023)<<1)|0)+36>>1];l:{if((g|0)>=0){u=n;n=k[g+j[h+8>>2]|0];j[a+1392>>2]=u>>>n;w=j[a+1396>>2]-n|0;n=(w|0)<0;j[a+1396>>2]=n?0:w;g=n?-1:g;break l}g=Qk(a,h)}g=k[h+23|0]?j[j[h+2088>>2]+(g<<2)>>2]:g;if((g|0)==-1){break b}j[j[t>>2]+(o<<2)>>2]=j[j[v+16>>2]+(g<<2)>>2]}m:{if((f|0)>=(q|0)){break m}g=0;if((y|0)<1){break m}while(1){h=j[r+8>>2];n=i[(j[x+20>>2]+(k[j[j[t>>2]+(o<<2)>>2]+g|0]<<4)|0)+(e<<1)>>1];n:{if((n|0)>=0){if(ME(a,j[a+124>>2]+p(n&65535,2096)|0,b,c,s+12|0,s+8|0,d,h)){break n}break b}h=j[r>>2]+(h+p(f,h)|0)|0;n=(h|0)/(c|0)|0;j[s+8>>2]=n;j[s+12>>2]=h-p(c,n)}f=f+1|0;if((q|0)<=(f|0)){break m}g=g+1|0;if((y|0)>(g|0)){continue}break}}o=o+1|0;if((f|0)<(q|0)){continue}break}}e=e+1|0;if((e|0)!=8){continue}break}}if(!j[a+80>>2]){Fb(t)}j[a+92>>2]=C;Za=s+16|0}function i5(a,b,c,d){var e=0,f=0,g=0,h=q(0),i=0,k=q(0),m=0,o=q(0),r=q(0),s=0,t=q(0),u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=q(0),C=q(0),D=q(0),E=q(0),F=0,G=0,H=0,I=0,J=0,K=0;v=b>>1;f=v<<2;J=j[c+92>>2];a:{if(j[c+80>>2]){u=km(c,f);break a}u=Yc(f)}f=v<<2;w=f+a|0;f=(f+u|0)-8|0;i=j[((d<<2)+c|0)+1068>>2];b:{if(!v){e=i;break b}g=a;e=i;while(1){n[f+4>>2]=q(n[e>>2]*n[g>>2])-q(n[e+4>>2]*n[g+8>>2]);n[f>>2]=q(n[e>>2]*n[g+8>>2])+q(n[e+4>>2]*n[g>>2]);e=e+8|0;f=f-8|0;g=g+16|0;if((w|0)!=(g|0)){continue}break}}if(f>>>0>=u>>>0){g=((v<<2)+a|0)-12|0;while(1){n[f+4>>2]=q(n[e+4>>2]*n[g>>2])-q(n[e>>2]*n[g+8>>2]);n[f>>2]=q(n[e>>2]*q(-n[g>>2]))-q(n[e+4>>2]*n[g+8>>2]);g=g-16|0;e=e+8|0;f=f-8|0;if(u>>>0<=f>>>0){continue}break}}H=b>>2;if((b|0)>=16){g=H<<2;f=g+u|0;m=a+g|0;e=(i+(v<<2)|0)-32|0;s=a;g=u;while(1){r=n[g>>2];o=n[f>>2];k=n[g+4>>2];h=n[f+4>>2];n[m+4>>2]=k+h;n[m>>2]=n[g>>2]+n[f>>2];k=q(h-k);h=q(o-r);n[s+4>>2]=q(n[e+16>>2]*k)-q(n[e+20>>2]*h);n[s>>2]=q(n[e+20>>2]*k)+q(n[e+16>>2]*h);r=n[g+8>>2];o=n[f+8>>2];k=n[g+12>>2];h=n[f+12>>2];n[m+12>>2]=k+h;n[m+8>>2]=n[g+8>>2]+n[f+8>>2];k=q(h-k);h=q(o-r);n[s+12>>2]=q(n[e>>2]*k)-q(n[e+4>>2]*h);n[s+8>>2]=q(n[e+4>>2]*k)+q(n[e>>2]*h);g=g+16|0;f=f+16|0;s=s+16|0;m=m+16|0;e=e-32|0;if(i>>>0<=e>>>0){continue}break}}y=Sk(b);g=b>>4;m=v-1|0;e=b>>3;f=0-e|0;LE(g,a,m,f,i);LE(g,a,m-H|0,f,i);A=b>>5;f=0-g|0;bo(A,a,m,f,i,16);bo(A,a,m-e|0,f,i,16);bo(A,a,m-(e<<1)|0,f,i,16);bo(A,a,m+p(e,-3)|0,f,i,16);s=2;if((y|0)>=10){f=y-4>>1;s=(f|0)>3?f:3;f=2;while(1){g=f;f=f+1|0;F=2<<g;if((F|0)>=1){G=8<<g;e=0;x=b>>g+2;z=0-(x>>1)|0;g=b>>g+4;while(1){bo(g,a,m-p(e,x)|0,z,i,G);e=e+1|0;if((F|0)!=(e|0)){continue}break}}if((f|0)!=(s|0)){continue}break}}I=y-7|0;if((I|0)>(s|0)){while(1){f=s;s=f+1|0;e=b>>f+6;if((e|0)>=1){K=2<<f;y=8<<f;F=y<<2;G=b>>f+2;x=0-(G>>1)|0;f=i;g=m;while(1){d5(K,a,g,x,f,y,G);g=g-8|0;f=(F<<2)+f|0;z=(e|0)>1;e=e-1|0;if(z){continue}break}}if((s|0)!=(I|0)){continue}break}}c5(A,a,m,i,b);x=v-4|0;e=((H<<2)+u|0)-16|0;if(u>>>0<=e>>>0){f=(x<<2)+u|0;g=j[((d<<2)+c|0)+1100>>2];while(1){i=(l[g>>1]<<2)+a|0;n[f+12>>2]=n[i>>2];n[f+8>>2]=n[i+4>>2];n[e+12>>2]=n[i+8>>2];n[e+8>>2]=n[i+12>>2];i=(l[g+2>>1]<<2)+a|0;n[f+4>>2]=n[i>>2];n[f>>2]=n[i+4>>2];n[e+4>>2]=n[i+8>>2];n[e>>2]=n[i+12>>2];g=g+4|0;f=f-16|0;e=e-16|0;if(u>>>0<=e>>>0){continue}break}}f=(v<<2)+u|0;i=f-16|0;if(u>>>0<i>>>0){g=j[((d<<2)+c|0)+1084>>2];m=f;e=u;while(1){B=n[g+4>>2];z=m-4|0;C=n[z>>2];o=n[e+4>>2];D=q(C+o);k=n[g>>2];E=n[e>>2];s=m-8|0;t=n[s>>2];h=q(E-t);r=q(q(B*D)-q(k*h));o=q(o-C);n[e+4>>2]=r+o;k=q(q(k*D)+q(B*h));h=q(t+E);n[e>>2]=k+h;n[z>>2]=r-o;n[s>>2]=h-k;B=n[g+12>>2];s=m-12|0;C=n[s>>2];o=n[e+12>>2];D=q(C+o);k=n[g+8>>2];E=n[e+8>>2];t=n[i>>2];h=q(E-t);r=q(q(B*D)-q(k*h));o=q(o-C);n[e+12>>2]=r+o;k=q(q(k*D)+q(B*h));h=q(t+E);n[e+8>>2]=k+h;n[i>>2]=h-k;n[s>>2]=r-o;g=g+16|0;e=e+16|0;m=i;i=i-16|0;if(e>>>0<i>>>0){continue}break}}i=f-32|0;if(u>>>0<=i>>>0){e=j[((d<<2)+c|0)+1076>>2]+(v<<2)|0;g=(x<<2)+a|0;m=((b<<2)+a|0)-16|0;while(1){t=n[e-4>>2];r=n[f-8>>2];o=n[e-8>>2];k=n[f-4>>2];h=q(q(t*r)-q(o*k));n[a>>2]=h;n[g+12>>2]=-h;h=q(q(o*q(-r))-q(k*t));n[w>>2]=h;n[m+12>>2]=h;t=n[e-12>>2];r=n[f-16>>2];o=n[e-16>>2];k=n[f-12>>2];h=q(q(t*r)-q(o*k));n[a+4>>2]=h;n[g+8>>2]=-h;h=q(q(o*q(-r))-q(k*t));n[w+4>>2]=h;n[m+8>>2]=h;t=n[e-20>>2];r=n[f-24>>2];o=n[e-24>>2];k=n[f-20>>2];h=q(q(t*r)-q(o*k));n[a+8>>2]=h;n[g+4>>2]=-h;h=q(q(o*q(-r))-q(k*t));n[w+8>>2]=h;n[m+4>>2]=h;t=n[e-28>>2];r=n[i>>2];e=e-32|0;o=n[e>>2];k=n[f-28>>2];h=q(q(t*r)-q(o*k));n[a+12>>2]=h;n[g>>2]=-h;h=q(q(o*q(-r))-q(k*t));n[w+12>>2]=h;n[m>>2]=h;m=m-16|0;g=g-16|0;w=w+16|0;a=a+16|0;f=i;i=f-32|0;if(u>>>0<=i>>>0){continue}break}}if(!j[c+80>>2]){Fb(u)}j[c+92>>2]=J}function Sqa(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,u=0;f=Za-11360|0;Za=f;rc(c);a:{b:{if(!yb(c,4)){break b}c:{while(1){d:{ZS(c,f+16|0);e:{if(!_c(f+16|0,20249,3)){Qqa(c,f+4648|0);h=3;d=0;while(1){g=k[(f+4648|0)+h|0];if(g&128){break c}d=g|d<<7;h=h+1|0;if((h|0)!=7){continue}break}Jb(c,d);break e}f:{if(_c(f+16|0,20253,3)){break f}if(!KO(c,20257)){break f}Jb(c,hf(c)+16|0);break e}if(!_c(f+16|0,20263,3)){break e}if(!_c(f+16|0,20267,3)){break e}if(k[f+16|0]){break d}cg(c,2)}if(yb(c,4)){continue}break b}break}if(JM(f+16|0)){break b}}h=0;break a}rc(c);Uy(f+11336|0,c);h=j[f+11336>>2];j[114630]=0;c=H(412,f+11336|0)|0;d=j[114630];j[114630]=0;g:{h:{if((d|0)!=1){j[114630]=0;c=H(854,c|0)|0;d=j[114630];j[114630]=0;if((d|0)!=1){break h}}h=D()|0;C()|0;break g}n=f+11320|0;dU(n);Ab(f+4648|0,0,6668);j[114630]=0;N(1233,f+4648|0);d=j[114630];j[114630]=0;i:{j:{k:{if((d|0)!=1){d=f+4640|0;j[d>>2]=0;j[d+4>>2]=0;d=f+4632|0;j[d>>2]=0;j[d+4>>2]=0;j[f+4624>>2]=0;j[f+4628>>2]=0;g=0;d=0;l:{m:{n:{while(1){j[114630]=0;m=ig(458,h,q);o=j[114630];j[114630]=0;if((o|0)==1){break l}j[114630]=0;r=U(1234,f+4648|0,c|0,m|0,f+16|0,f+4624|0)|0;m=j[114630];j[114630]=0;if((m|0)==1){break l}m=j[f+4624>>2];o=m|r;if((o|0)<=-1|!m&(r|0)>0|!o){break j}o:{if((m|0)>=1){o=j[f+4636>>2];if((o|0)!=(g|0)?g:0){break j}m=j[f+4632>>2];if((m|0)!=(d|0)?d:0){break j}if((o|0)<1|m-1>>>0>1){break k}j[114630]=0;j[f+8>>2]=0;d=ig(458,h,q);g=j[114630];j[114630]=0;if((g|0)==1){break o}j[114630]=0;j[f+4>>2]=d;d=K(1235,f+4624|0,f+8|0,f+4|0)|0;g=j[114630];j[114630]=0;if((g|0)==1){break o}d=j[d>>2];j[114630]=0;j[f+8>>2]=0;g=ig(458,h,q);s=j[114630];j[114630]=0;if((s|0)==1){break n}j[114630]=0;j[f+4>>2]=g;g=K(1235,f+4624|0,f+8|0,f+4|0)|0;s=j[114630];j[114630]=0;if((s|0)==1){break n}c=c+d|0;d=h;g=j[g>>2];h=d-g|0;q=q-((g>>31)+(d>>>0<g>>>0)|0)|0;if((r|0)>=1){t=f,u=Mb(n),j[t+8>>2]=u;Cd(f,f+8|0);j[114630]=0;P(1236,n|0,j[f>>2],f+16|0,(f+16|0)+(p(m,r)<<1)|0)|0;d=j[114630];j[114630]=0;if((d|0)==1){break m}}g=o;d=m}m=Yb(n);if((q|0)<0?1:(q|0)<=0?h>>>0<1:0){break j}if((m>>>0)/(d>>>0)>>>0<268435457){continue}break j}break}h=D()|0;C()|0;break i}h=D()|0;C()|0;break i}h=J(71412)|0;if((C()|0)!=(W(71412)|0)){break i}O(h|0)|0;j[114630]=0;M(20);c=j[114630];j[114630]=0;g=o;d=m;if((c|0)!=1){break j}h=D()|0;C()|0;break i}h=D()|0;C()|0;break i}h=D()|0;C()|0;break i}g=o;d=m}h=0;p:{q:{r:{s:{t:{if(!d|!g){break t}if(Xc(n)){break t}if((Yb(n)>>>0)/(d>>>0)>>>0>268435456){break t}j[114630]=0;E(1237,a|0,b|0)|0;c=j[114630];j[114630]=0;if((c|0)==1){break p}if(!e){j[114630]=0;c=E(85,f+16|0,20271)|0;m=j[114630];j[114630]=0;if((m|0)==1){break s}j[114630]=0;E(369,((b<<5)+a|0)+946300|0,c|0)|0;m=j[114630];j[114630]=0;if((m|0)==1){break r}gb(c);j[114630]=0;c=p(b,104)+a|0;F(386,c+484380|0,0);m=j[114630];j[114630]=0;if((m|0)==1){break p}j[c+484404>>2]=g}g=p(b,104)+a|0;c=g+484380|0;t=c,u=(Yb(n)>>>0)/(d>>>0)|0,j[t>>2]=u;m=g+484414|0;g=l[m>>1];i[m>>1]=(d|0)==2?g|65:g&65470|1;j[114630]=0;H(465,c|0)|0;d=j[114630];j[114630]=0;if((d|0)==1){break p}if(ke(c)){d=Lb(n);g=Mb(n);b=j[(p(b,104)+a|0)+484400>>2];j[114630]=0;K(1238,d|0,g|0,b|0)|0;b=j[114630];j[114630]=0;if((b|0)==1){break p}}if(!e){b=j[a+480180>>2];j[114630]=0;I(1239,c|0,32,b|0);b=j[114630];j[114630]=0;if((b|0)==1){break q}j[114630]=0;I(1240,c|0,a|0,0);a=j[114630];j[114630]=0;if((a|0)==1){break p}}h=ke(c)}yA(n);lc(f+11336|0);break a}h=D()|0;C()|0;break i}h=D()|0;C()|0;gb(c);break i}h=D()|0;C()|0;break i}h=D()|0;C()|0}yA(n)}lc(f+11336|0);G(h|0);z()}Za=f+11360|0;return h|0}function T8(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0;d=Za-352|0;Za=d;a:{if(Ri(b)){break a}e=k[Fj(b)|0];f=1;b:{if((e|0)==33){break b}if((e|0)!=63){break a}f=0}c=f;Qj(d+320|0,b,j[b+4>>2]-1|0);e=j[d+324>>2];j[b>>2]=j[d+320>>2];j[b+4>>2]=e}ld(d+320|0);e=j[d+320>>2];ld(d+304|0);e=Ej(e,j[d+308>>2],b);ld(d+320|0);c:{d:{e:{f:{if((e|0)==j[d+324>>2]){a=j[b+4>>2];j[d+344>>2]=j[b>>2];j[d+348>>2]=a;a=_b(d+336|0,38235);e=j[d+348>>2];j[d+8>>2]=j[d+344>>2];j[d+12>>2]=e;e=j[a+4>>2];j[d>>2]=j[a>>2];j[d+4>>2]=e;if(nc(d+8|0,d)){a=R(8)|0;j[114630]=0;c=E(85,d+320|0,39176)|0;b=j[114630];j[114630]=0;if((b|0)==1){break e}Wb(a,c);j[114630]=0;I(2004,a|0,83648,2012);a=j[114630];j[114630]=0;if((a|0)!=1){break c}b=D()|0;C()|0;gb(c);break d}e=0;if(!c){break f}a=R(8)|0;j[114630]=0;c=E(2136,d+304|0,b|0)|0;b=j[114630];j[114630]=0;g:{h:{i:{if((b|0)!=1){j[114630]=0;I(2113,d+320|0,39186,c|0);b=j[114630];j[114630]=0;if((b|0)==1){break i}Wb(a,d+320|0);e=0;j[114630]=0;I(2004,a|0,83648,2012);b=j[114630];j[114630]=0;if((b|0)!=1){break c}b=D()|0;C()|0;gb(d+320|0);break h}b=D()|0;C()|0;break g}b=D()|0;e=1;C()|0}gb(c);if(!e){break d}}S(a|0);break d}if(j[e+4>>2]){a=R(8)|0;j[114630]=0;c=E(85,d+320|0,39200)|0;b=j[114630];j[114630]=0;if((b|0)!=1){Wb(a,c);j[114630]=0;I(2004,a|0,83648,2012);a=j[114630];j[114630]=0;if((a|0)!=1){break c}b=D()|0;C()|0;gb(c);break d}b=D()|0;C()|0;S(a|0);break d}c=j[b+4>>2];j[d+296>>2]=j[b>>2];j[d+300>>2]=c;c=_b(d+288|0,38235);e=j[d+300>>2];j[d+152>>2]=j[d+296>>2];j[d+156>>2]=e;e=j[c+4>>2];j[d+144>>2]=j[c>>2];j[d+148>>2]=e;if(nc(d+152|0,d+144|0)){a=R(8)|0;j[114630]=0;c=E(85,d+320|0,39176)|0;b=j[114630];j[114630]=0;if((b|0)!=1){Wb(a,c);j[114630]=0;I(2004,a|0,83648,2012);a=j[114630];j[114630]=0;if((a|0)!=1){break c}b=D()|0;C()|0;gb(c);break d}b=D()|0;C()|0;S(a|0);break d}c=j[b+4>>2];j[d+280>>2]=j[b>>2];j[d+284>>2]=c;c=_b(d+272|0,38924);e=j[d+284>>2];j[d+136>>2]=j[d+280>>2];j[d+140>>2]=e;e=j[c+4>>2];j[d+128>>2]=j[c>>2];j[d+132>>2]=e;j:{if(!nc(d+136|0,d+128|0)){c=j[b+4>>2];j[d+264>>2]=j[b>>2];j[d+268>>2]=c;c=_b(d+256|0,39221);e=j[d+268>>2];j[d+120>>2]=j[d+264>>2];j[d+124>>2]=e;e=j[c+4>>2];j[d+112>>2]=j[c>>2];j[d+116>>2]=e;if(!nc(d+120|0,d+112|0)){break j}}e=k[a+60|0]!=0;break f}c=j[b+4>>2];j[d+248>>2]=j[b>>2];j[d+252>>2]=c;c=_b(d+240|0,38942);e=j[d+252>>2];j[d+104>>2]=j[d+248>>2];j[d+108>>2]=e;e=j[c+4>>2];j[d+96>>2]=j[c>>2];j[d+100>>2]=e;k:{if(!nc(d+104|0,d+96|0)){c=j[b+4>>2];j[d+232>>2]=j[b>>2];j[d+236>>2]=c;c=_b(d+224|0,39239);e=j[d+236>>2];j[d+88>>2]=j[d+232>>2];j[d+92>>2]=e;e=j[c+4>>2];j[d+80>>2]=j[c>>2];j[d+84>>2]=e;if(!nc(d+88|0,d+80|0)){break k}}e=k[a+61|0]!=0;break f}c=j[b+4>>2];j[d+216>>2]=j[b>>2];j[d+220>>2]=c;c=_b(d+208|0,38961);e=j[d+220>>2];j[d+72>>2]=j[d+216>>2];j[d+76>>2]=e;e=j[c+4>>2];j[d+64>>2]=j[c>>2];j[d+68>>2]=e;if(nc(d+72|0,d- -64|0)){e=k[a+62|0]!=0;break f}c=j[b+4>>2];j[d+200>>2]=j[b>>2];j[d+204>>2]=c;c=_b(d+192|0,38979);e=j[d+204>>2];j[d+56>>2]=j[d+200>>2];j[d+60>>2]=e;e=j[c+4>>2];j[d+48>>2]=j[c>>2];j[d+52>>2]=e;if(nc(d+56|0,d+48|0)){e=k[a+63|0]!=0;break f}c=j[b+4>>2];j[d+184>>2]=j[b>>2];j[d+188>>2]=c;c=_b(d+176|0,39003);e=j[d+188>>2];j[d+40>>2]=j[d+184>>2];j[d+44>>2]=e;e=j[c+4>>2];j[d+32>>2]=j[c>>2];j[d+36>>2]=e;if(nc(d+40|0,d+32|0)){e=k[a+64|0]!=0;break f}c=j[b+4>>2];j[d+168>>2]=j[b>>2];j[d+172>>2]=c;b=_b(d+160|0,39077);c=j[d+172>>2];j[d+24>>2]=j[d+168>>2];j[d+28>>2]=c;c=j[b+4>>2];j[d+16>>2]=j[b>>2];j[d+20>>2]=c;e=0;if(!nc(d+24|0,d+16|0)){break f}e=j[j[a+24>>2]+24668>>2]!=0}Za=d+352|0;return e|0}b=D()|0;C()|0;S(a|0)}G(b|0)}z()}function A6(a,b){var c=0,d=0,e=0,f=0,g=0;c=Za-112|0;Za=c;f=Qc(c+96|0);j[114630]=0;g=E(2,c+80|0,6848)|0;d=j[114630];j[114630]=0;a:{b:{c:{if((d|0)!=1){d=j[b+20>>2];if(d){break c}Mc(a,f);break a}a=D()|0;C()|0;break b}j[114630]=0;j[c+48>>2]=d+1900;F(191,c- -64|0,c+48|0);d=j[114630];j[114630]=0;d:{e:{if((d|0)!=1){j[114630]=0;E(192,f|0,c- -64|0)|0;d=j[114630];j[114630]=0;f:{if((d|0)!=1){gb(c- -64|0);if(m[b+16>>2]<12){break f}Mc(a,f);break a}a=D()|0;C()|0;gb(c- -64|0);break d}j[114630]=0;d=E(2,c+48|0,6850)|0;e=j[114630];j[114630]=0;g:{h:{i:{j:{k:{l:{if((e|0)!=1){e=j[b+16>>2];j[114630]=0;j[c+16>>2]=e+1;F(193,c+32|0,c+16|0);e=j[114630];j[114630]=0;if((e|0)==1){break l}j[114630]=0;I(3,c- -64|0,d|0,c+32|0);e=j[114630];j[114630]=0;if((e|0)==1){break k}j[114630]=0;E(192,f|0,c- -64|0)|0;e=j[114630];j[114630]=0;if((e|0)==1){break j}gb(c- -64|0);gb(c+32|0);gb(d);if(j[b+12>>2]-1>>>0<31){break g}Mc(a,f);break a}a=D()|0;C()|0;break d}a=D()|0;C()|0;break h}a=D()|0;C()|0;break i}a=D()|0;C()|0;gb(c- -64|0)}gb(c+32|0)}gb(d);break d}j[114630]=0;d=E(2,c+48|0,6850)|0;e=j[114630];j[114630]=0;m:{n:{o:{p:{q:{r:{s:{if((e|0)!=1){j[114630]=0;F(193,c+32|0,b+12|0);e=j[114630];j[114630]=0;if((e|0)==1){break s}j[114630]=0;I(3,c- -64|0,d|0,c+32|0);e=j[114630];j[114630]=0;if((e|0)==1){break r}j[114630]=0;E(192,f|0,c- -64|0)|0;e=j[114630];j[114630]=0;if((e|0)==1){break q}gb(c- -64|0);gb(c+32|0);gb(d);d=j[b+8>>2];if(d){break n}if(j[b+4>>2]|j[b>>2]){break m}Mc(a,f);break a}a=D()|0;C()|0;break d}a=D()|0;C()|0;break o}a=D()|0;C()|0;break p}a=D()|0;C()|0;gb(c- -64|0)}gb(c+32|0)}gb(d);break d}if(d>>>0<24){break m}Mc(a,f);break a}if(m[b+4>>2]>=60){Mc(a,f);break a}j[114630]=0;d=E(2,c- -64|0,6852)|0;e=j[114630];j[114630]=0;t:{u:{v:{w:{x:{y:{z:{A:{B:{C:{D:{E:{F:{if((e|0)!=1){j[114630]=0;E(192,f|0,d|0)|0;e=j[114630];j[114630]=0;if((e|0)==1){break F}gb(d);if(j[b+32>>2]>=1){j[114630]=0;d=E(2,c- -64|0,6854)|0;e=j[114630];j[114630]=0;if((e|0)==1){break E}ob(g,d);gb(d)}j[114630]=0;F(193,c+32|0,b+8|0);d=j[114630];j[114630]=0;if((d|0)==1){break D}j[114630]=0;d=E(2,c+16|0,6861)|0;e=j[114630];j[114630]=0;if((e|0)==1){break C}j[114630]=0;I(3,c+48|0,c+32|0,d|0);e=j[114630];j[114630]=0;if((e|0)==1){break B}j[114630]=0;F(193,c|0,b+4|0);e=j[114630];j[114630]=0;if((e|0)==1){break A}j[114630]=0;I(3,c- -64|0,c+48|0,c|0);e=j[114630];j[114630]=0;if((e|0)==1){break z}j[114630]=0;E(192,f|0,c- -64|0)|0;e=j[114630];j[114630]=0;if((e|0)==1){break y}gb(c- -64|0);gb(c);gb(c+48|0);gb(d);gb(c+32|0);if(m[b>>2]<62){break t}j[114630]=0;I(194,a|0,f|0,g|0);a=j[114630];j[114630]=0;if((a|0)!=1){break a}break e}a=D()|0;C()|0;break d}a=D()|0;C()|0;gb(d);break d}a=D()|0;C()|0;break d}a=D()|0;C()|0;break d}a=D()|0;C()|0;break u}a=D()|0;C()|0;break v}a=D()|0;C()|0;break w}a=D()|0;C()|0;break x}a=D()|0;C()|0;gb(c- -64|0)}gb(c)}gb(c+48|0)}gb(d)}gb(c+32|0);break d}j[114630]=0;d=E(2,c+48|0,6861)|0;e=j[114630];j[114630]=0;G:{H:{I:{J:{K:{if((e|0)!=1){j[114630]=0;F(193,c+32|0,b|0);b=j[114630];j[114630]=0;if((b|0)==1){break K}j[114630]=0;I(3,c- -64|0,d|0,c+32|0);b=j[114630];j[114630]=0;if((b|0)==1){break J}j[114630]=0;E(192,f|0,c- -64|0)|0;b=j[114630];j[114630]=0;if((b|0)==1){break I}gb(c- -64|0);gb(c+32|0);gb(d);j[114630]=0;E(192,f|0,g|0)|0;b=j[114630];j[114630]=0;if((b|0)==1){break e}Mc(a,f);break a}a=D()|0;C()|0;break d}a=D()|0;C()|0;break G}a=D()|0;C()|0;break H}a=D()|0;C()|0;gb(c- -64|0)}gb(c+32|0)}gb(d);break d}a=D()|0;C()|0;break d}a=D()|0;C()|0}gb(g)}gb(f);G(a|0);z()}gb(g);gb(f);Za=c+112|0}function If(a,b,c,d,e,f,g,h,i){var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,t=0,u=0;l=Za-112|0;Za=l;m=h;p=i&2147483647;n=c-(b>>>0<1)|0;k=b-1|0;r=(k|0)==-1&(n|0)==-1;t=d;q=(c|0)==(n|0)&b>>>0>k>>>0|c>>>0>n>>>0;o=d+q|0;n=e&2147483647;k=n;k=o>>>0<q>>>0?k+1|0:k;q=o-1|0;a:{b:{k=k-(o>>>0<1)|0;if(!((q|0)==-1&(k|0)==2147418111?r:k>>>0>2147418111)){k=f;o=g-(k>>>0<1)|0;k=k-1|0;r=(k|0)!=-1|(o|0)!=-1;q=(g|0)==(o|0)&f>>>0>k>>>0|g>>>0>o>>>0;o=q+m|0;k=p;k=o>>>0<q>>>0?k+1|0:k;q=o;o=o-1|0;k=k-(q>>>0<1)|0;if((o|0)==-1&(k|0)==2147418111?r:(k|0)==2147418111&(o|0)!=-1|k>>>0<2147418111){break b}}if(!(!t&(n|0)==2147418112?!(b|c):n>>>0<2147418112)){h=d;i=e|32768;f=b;g=c;break a}if(!(!m&(p|0)==2147418112?!(f|g):p>>>0<2147418112)){i=i|32768;break a}if(!(b|t|(n^2147418112|c))){k=d;d=!(b^f|d^h|(c^g|e^i^-2147483648));h=d?0:k;i=d?2147450880:e;f=d?0:b;g=d?0:c;break a}if(!(f|m|(p^2147418112|g))){break a}if(!(b|t|(c|n))){if(f|m|(g|p)){break a}f=b&f;g=c&g;h=d&h;i=e&i;break a}if(f|m|(g|p)){break b}f=b;g=c;h=d;i=e;break a}r=(m|0)==(t|0)&(n|0)==(p|0)?(c|0)==(g|0)&b>>>0<f>>>0|c>>>0<g>>>0:(n|0)==(p|0)&m>>>0>t>>>0|n>>>0<p>>>0;k=r;o=k?f:b;p=k?g:c;m=k?i:e;t=m;n=k?h:d;k=m&65535;i=r?e:i;e=i;h=r?d:h;q=i>>>16&32767;m=m>>>16&32767;if(!m){d=!(k|n);i=d<<6;m=s(d?o:n)+32|0;d=s(d?p:k);d=i+((d|0)==32?m:d)|0;We(l+96|0,o,p,n,k,d-15|0);n=j[l+104>>2];o=j[l+96>>2];p=j[l+100>>2];m=16-d|0;k=j[l+108>>2]}f=r?b:f;g=r?c:g;i=e&65535;if(!q){b=!(h|i);c=b<<6;d=s(b?f:h)+32|0;b=s(b?g:i);b=c+((b|0)==32?d:b)|0;We(l+80|0,f,g,h,i,b-15|0);q=16-b|0;h=j[l+88>>2];i=j[l+92>>2];g=j[l+84>>2];f=j[l+80>>2]}b=h;c=i<<3|b>>>29;h=b<<3|g>>>29;i=c|524288;b=n;d=k<<3|b>>>29;n=b<<3|p>>>29;u=d;r=e^t;b=f;k=g<<3|b>>>29;b=b<<3;c=k;d=m-q|0;e=b;c:{if(!d){break c}if(d>>>0>127){h=0;i=0;k=0;e=1;break c}We(l- -64|0,b,c,h,i,128-d|0);hm(l+48|0,b,c,h,i,d);h=j[l+56>>2];i=j[l+60>>2];k=j[l+52>>2];e=j[l+48>>2]|((j[l+64>>2]|j[l+72>>2])!=0|(j[l+68>>2]|j[l+76>>2])!=0)}f=k;d=n;q=u|524288;b=o;k=p<<3|b>>>29;c=b<<3;d:{if((r|0)<-1?1:(r|0)<=-1){p=e;b=c-e|0;n=h;o=d-h|0;e=(f|0)==(k|0)&c>>>0<e>>>0|f>>>0>k>>>0;h=o-e|0;c=k-((c>>>0<p>>>0)+f|0)|0;i=(q-((d>>>0<n>>>0)+i|0)|0)-(e>>>0>o>>>0)|0;if(!(b|h|(c|i))){f=0;g=0;h=0;i=0;break a}if(i>>>0>524287){break d}f=b;d=!(h|i);e=d<<6;g=s(d?b:h)+32|0;b=s(d?c:i);b=e+((b|0)==32?g:b)|0;b=b-12|0;We(l+32|0,f,c,h,i,b);m=m-b|0;h=j[l+40>>2];i=j[l+44>>2];b=j[l+32>>2];c=j[l+36>>2];break d}b=c;g=b+e|0;c=f+k|0;c=b>>>0>g>>>0?c+1|0:c;b=g;g=(c|0)==(f|0)&e>>>0>b>>>0|c>>>0<f>>>0;e=d;f=d+h|0;d=i+q|0;d=e>>>0>f>>>0?d+1|0:d;e=g+f|0;h=e;i=h>>>0<f>>>0?d+1|0:d;if(!(i&1048576)){break d}b=b&1|((c&1)<<31|b>>>1);c=h<<31|c>>>1;m=m+1|0;h=(i&1)<<31|h>>>1;i=i>>>1|0}p=0;t=t&-2147483648;if((m|0)>=32767){h=p;i=t|2147418112;f=0;g=0;break a}e=0;e:{if((m|0)>0){e=m;break e}We(l+16|0,b,c,h,i,m+127|0);hm(l,b,c,h,i,1-m|0);b=j[l>>2]|((j[l+16>>2]|j[l+24>>2])!=0|(j[l+20>>2]|j[l+28>>2])!=0);c=j[l+4>>2];h=j[l+8>>2];i=j[l+12>>2]}k=(c&7)<<29|b>>>3;m=b&7;b=k+(m>>>0>4)|0;d=h<<29|c>>>3;c=b>>>0<k>>>0?d+1|0:d;f=b;g=c;b=(d|0)==(c|0)&b>>>0<k>>>0|c>>>0<d>>>0;d=p|((i&7)<<29|h>>>3);b=b+d|0;k=t|(i>>>3&65535|e<<16);h=b;i=b>>>0<d>>>0?k+1|0:k;f:{if((m|0)==4){k=i;c=0;d=g+c|0;e=f&1;b=f+e|0;d=b>>>0<f>>>0?d+1|0:d;f=b;g=d;c=(c|0)==(d|0)&b>>>0<e>>>0|c>>>0>d>>>0;b=c+h|0;h=b;i=b>>>0<c>>>0?k+1|0:k;break f}if(!m){break a}}}j[a>>2]=f;j[a+4>>2]=g;j[a+8>>2]=h;j[a+12>>2]=i;Za=l+112|0}function _za(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,u=0;d=Za-256|0;Za=d;rc(b);a:{if(!tz(b,d+184|0)){break a}if(!gO(d+184|0)){break a}if(!yb(b,Tc(fO(d+184|0),ab))){break a}b:{if(!c){break b}od(a,16);jn(d,2,d+184|4);qc(d+16|0,d);ob(a+1304400|0,d+16|0);gb(d+16|0);i[a+480190>>1]=k[d+214|0];i[a+480188>>1]=k[d+217|0];e=Db(d+16|0,16588);ob(a+1304436|0,e);gb(e);e=Db(d+16|0,16601);ob(a+1304448|0,e);gb(e);f=Db(d+168|0,16605);j[114630]=0;F(219,d|0,f|0);e=j[114630];j[114630]=0;c:{d:{e:{f:{g:{h:{i:{if((e|0)!=1){e=d+184|3;j[d+152>>2]=k[e|0]>>>4;e=k[e|0];j[114630]=0;j[d+164>>2]=e&15;L(533,d+16|0,d|0,d+152|0,d+164|0);e=j[114630];j[114630]=0;if((e|0)==1){break i}ob(a+1304460|0,d+16|0);gb(d+16|0);qb(d);gb(f);j[a+1304496>>2]=4;if(l[a+480190>>1]){e=1;g=1;while(1){dT(b,d+16|0);Zza(d+16|0,(p(e,104)+a|0)+484380|0);sn(d+152|0,2,d+16|0);qc(d,d+152|0);j[114630]=0;E(369,((e<<5)+a|0)+946300|0,d|0)|0;e=j[114630];j[114630]=0;if((e|0)==1){break e}gb(d);g=g+1|0;e=g&65535;if(e>>>0<=l[a+480190>>1]){continue}break}}if(l[a+480188>>1]){e=0;while(1){f=(e<<5)+a|0;wg(f+480280|0);i[f+480284>>1]=(k[(d+e|0)+218|0]<<4|8)&248;e=e+1|0;if(e>>>0<l[a+480188>>1]){continue}break}}Yza(b,d+16|0);nT(Eb(a+484360|0),d+16|0,k[d+211|0]+1|0);if(k[d+216|0]){break g}o=64;break f}e=D()|0;C()|0;break h}e=D()|0;C()|0;qb(d)}gb(f);break c}o=k[d+216|0]}cd(d,b,p(k[d+208|0]|k[d+209|0]<<8,192));j:{k:{if(!(c&1)){break k}e=k[d+210|0];j[114630]=0;s=a+484344|0;F(401,s|0,e+1|0);e=j[114630];j[114630]=0;if((e|0)==1){break d}while(1){j[114630]=0;f=K(402,s|0,q&65535,o|0)|0;e=j[114630];j[114630]=0;if((e|0)==1){break j}e=0;if(!f){break k}while(1){j[114630]=0;f=H(357,b|0)|0;m=j[114630];j[114630]=0;if((m|0)==1){break d}t=e;l:{if(!f|f>>>0>(k[d+208|0]|k[d+209|0]<<8)>>>0){break l}e=t&65535;if(e>>>0>=l[a+480188>>1]){break l}j[114630]=0;E(256,d|0,p(f,192)-192|0)|0;f=j[114630];j[114630]=0;if((f|0)==1){break d}f=Hb(s,q);j[114630]=0;e=K(471,f|0,0,e|0)|0;f=j[114630];j[114630]=0;if((f|0)==1){break d}u=0;if(!o){break l}while(1){j[114630]=0;F(805,d+152|0,d|0);f=j[114630];j[114630]=0;if((f|0)==1){break d}g=Pc(d+152|0);r=Bf(d+152|0);m=e;n=d+152|0;f=k[n|0];if(f>>>0>=4){h[e|0]=(f>>>2|0)+37;f=k[n|0]}h[m+1|0]=f<<4&48|k[g|0]>>>4;f=k[r|0];m=0;r=0;m:{n:{o:{p:{q:{r:{g=k[g|0]&15;switch(g-8|0){case 0:break o;case 6:break q;case 2:break r;default:break p}}f=f&240?f&-16:f&15;g=10;break n}g=14;n=(f+16&240)>>>4|0;if(n>>>0>8){break n}if(1<<n&435){break o}break n}m=g;r=f}f=r;g=m;if(!((f|g)&255)){break m}}h[e+5|0]=f;h[e+3|0]=g;j[114630]=0;N(574,e|0);f=j[114630];j[114630]=0;if((f|0)!=1){break m}break d}e=p(l[a+480188>>1],6)+e|0;u=u+1|0;if((u|0)!=(o|0)){continue}break}}e=t+1|0;if((t&65535)>>>0<31){continue}break}e=k[d+210|0]>q>>>0;q=q+1|0;if(e){continue}break}}if(k[d+212|0]|k[d+213|0]<<8){e=k[d+212|0]|k[d+213|0]<<8;j[114630]=0;U(547,a+1304424|0,b|0,e|0,39,1)|0;e=j[114630];j[114630]=0;if((e|0)==1){break d}}if(!(!(c&2)|!l[a+480190>>1])){f=1;while(1){c=p(f&65535,104)+a|0;e=Kc(d+152|0,i[c+484414>>1]&1?16:8,1,0,1);j[114630]=0;K(400,e|0,c+484380|0,b|0)|0;c=j[114630];j[114630]=0;if((c|0)==1){break d}f=f+1|0;if(l[a+480190>>1]>=(f&65535)>>>0){continue}break}}j[a+480260>>2]=64;j[a+480264>>2]=32767;jb(d);break b}break d}e=D()|0;C()|0;gb(d);break c}e=D()|0;C()|0;jb(d)}G(e|0);z()}e=1}Za=d+256|0;return e|0}function yK(a,b,c){var d=0,e=0,f=0,g=0,i=0,m=0,n=0,o=0,q=0;f=Za-16|0;Za=f;d=c&15;g=p(b,896)+a|0;e=g+1074984|0;a:{b:{switch((c&240)-16>>>4|0){case 0:a=g+1075072|0;j[a>>2]=j[a>>2]&-1048577|((d|0)!=0)<<20;break a;case 1:if(!(k[a+480209|0]&16)){break a}if(j[a+480180>>2]!=64){b=p(b,896)+a|0;c=d<<28>>24;j[b+1075752>>2]=c;d=l[(d<<1)+21456>>1];j[b+1075688>>2]=d;e=b+1075684|0;if(!j[e>>2]){break a}o=e,q=Zf(a,k[b+1075803|0],c,d),j[o>>2]=q;break a}a=p(b,896)+a|0;b=j[a+1075088>>2];if(!b){break a}j[a+1075688>>2]=j[b+24>>2]+p(d,80);break a;case 2:if(j[a+480180>>2]==2){h[(p(b,896)+a|0)+1075826|0]=c&3;break a}mb(f+8|0,a+1074308|0,21);if(kb(f+8|0)){h[(p(b,896)+a|0)+1075826|0]=d>>>0<4?d:0;break a}h[(p(b,896)+a|0)+1075826|0]=c&7;break a;case 3:if(j[a+480180>>2]==2){h[(p(b,896)+a|0)+1075829|0]=c&3;break a}mb(f+8|0,a+1074308|0,21);if(kb(f+8|0)){h[(p(b,896)+a|0)+1075829|0]=d>>>0<4?d:0;break a}h[(p(b,896)+a|0)+1075829|0]=c&7;break a;case 4:mb(f+8|0,a+1074308|0,21);if(kb(f+8|0)){a=p(b,896)+a|0;h[a+1075825|0]=0;h[a+1075832|0]=d>>>0<4?d:0;break a}h[(p(b,896)+a|0)+1075832|0]=c&7;break a;case 5:if(j[a+1074392>>2]|!(k[a+480209|0]&16)){break a}a=a+1074400|0;j[a>>2]=j[a>>2]+d;break a;case 6:if(!(k[a+480209|0]&16)){break a}c:{switch(d|0){case 0:case 1:case 2:d=l[a+480188>>1];if(d>>>0>255){break a}e=a+1304392|0;m=b+1|0;n=(c&15)-1|0;while(1){c=p(d,896)+a|0;d:{if(l[c+1075792>>1]!=(m|0)){break d}e:{f:{switch(n|0){case 0:Fm(a,c+1074984|0);if(!(k[c+1075073|0]&2)){break e}if(!$c(e)){break e}Uj(j[e>>2],d&65535);break e;case 1:i=c+1075072|0;g=j[i>>2];j[i>>2]=g|4096;if(!(g&512)){break e}if(!$c(e)){break e}Uj(j[e>>2],d&65535);break e;default:break f}}j[c+1075680>>2]=0;i=c+1075072|0;g=j[i>>2];j[i>>2]=g|4096;if(!(g&512)){break e}if(!$c(e)){break e}qh(j[e>>2],d&65535,1)}g=j[c+1075640>>2];if(!g){break d}i=k[g+34|0];if(!i){break d}i=j[(p(i,160)+a|0)+906140>>2];if(!i){break d}bb[j[j[i>>2]+88>>2]](i,g,k[c+1075803|0]+255|0,0,b)}d=d+1|0;if((d&65535)!=256){continue}break}break a;case 3:h[(p(b,896)+a|0)+1075804|0]=0;break a;case 4:h[(p(b,896)+a|0)+1075804|0]=1;break a;case 5:h[(p(b,896)+a|0)+1075804|0]=2;break a;case 6:h[(p(b,896)+a|0)+1075804|0]=3;break a;case 7:a=(p(b,896)+a|0)+1075708|0;h[a|0]=k[a|0]&254;break a;case 8:a=(p(b,896)+a|0)+1075708|0;h[a|0]=k[a|0]|1;break a;case 9:a=(p(b,896)+a|0)+1075720|0;h[a|0]=k[a|0]&254;break a;case 10:a=(p(b,896)+a|0)+1075720|0;h[a|0]=k[a|0]|1;break a;case 11:a=(p(b,896)+a|0)+1075732|0;h[a|0]=k[a|0]&254;break a;case 12:a=(p(b,896)+a|0)+1075732|0;h[a|0]=k[a|0]|1;break a;case 13:case 14:break c;default:break a}}if(j[a+480180>>2]!=16777216){break a}b=(p(b,896)+a|0)+1075732|0;a=k[b|0];h[b|0]=(d|0)==13?a&238|1:a|17;break a;case 7:if(!(k[a+480209|0]&16)){break a}dl(a,e,d,4);break a;case 8:Aoa(a,e,d);break a;case 9:if(!(k[a+480209|0]&16)){break a}c=p(b,896)+a|0;h[c+1075840|0]=d;mb(f+8|0,a+1074308|0,35);if(kb(f+8|0)){break a}if(!Mf(c+1075794|0)){break a}b=j[(p(b,896)+a|0)+1075060>>2];a=d<<16;if(b>>>0<=a>>>0){break a}j[e+4>>2]=a;break a;case 11:g:{if(d){break g}d=1;if(j[a+480180>>2]&16777248){break g}d=0;if(j[a+480180>>2]==2){break a}}mb(f+8|0,a+1074308|0,30);c=a;if(kb(f+8|0)){a=1}else{a=j[a+480180>>2]==2}ox(c,b,d,a);break a;case 14:break b;default:break a}}if(j[a+480180>>2]==2){break a}h[(p(b,896)+a|0)+1075848|0]=d}Za=f+16|0}function fma(a,b,c,d){var e=0,f=0,g=0,n=0,o=0,q=0,r=0,s=0,t=0,u=0,v=0;n=Za-16|0;Za=n;q=p(b,896)+a|0;e=j[q+1075640>>2];a:{if(!e){break a}f=k[e+34|0];if(!f|k[e+15|0]&2|(!j[(p(f,160)+a|0)+906140>>2]|j[(p(b,896)+a|0)+1075072>>2]&134218752)){break a}f=p(b,896)+a|0;r=f+1075797|0;s=k[r|0];o=f+1075805|0;if(Ld(k[o|0])){g=k[Pb(e+108|0,k[o|0]-1|0)|0]}o=f+1075794|0;b:{c:{if((s|0)==1){e=0;d:{e:{switch((m[a+1074392>>2]%3|0)-1|0){case 0:e=k[(p(b,896)+a|0)+1075812|0]>>>4|0;break d;case 1:break e;default:break d}}e=k[(p(b,896)+a|0)+1075812|0]&15}f=p(b,896)+a|0;h[f+1075807|0]=g;if(k[f+1075806|0]==(e+g|0)){break b}if(!(k[a+480209|0]&16)){break c}if(!Mf(o)){break c}break b}e=0;if(k[o|0]|!k[(p(b,896)+a|0)+1075806|0]){break b}}f=p(b,896)+a|0;Nj(a,b,k[f+1075807|0]+e|0,l[f+1075672>>1])}f=(p(b,896)+a|0)+1075806|0;t=k[f|0];f:{if(t){Nj(a,b,t+255|0,0);break f}if(!(k[a+480209|0]&16)|(s|0)!=1){break f}if(Mf(o)){break f}if(!Ld(g)){break f}Nj(a,b,g+255|0,0)}h[f|0]=k[r|0]==1?k[(p(b,896)+a|0)+1075807|0]+e|0:0}g:{if(k[q+1075811|0]!=1){break g}if(Yi(q+1074984|0)){g=0;h:{i:{j:{switch(m[a+1074392>>2]%3|0){case 1:g=k[(p(b,896)+a|0)+1075812|0]>>>4|0;break i;case 0:break i;case 2:break j;default:break h}}g=k[(p(b,896)+a|0)+1075812|0]&15}i[d>>1]=g}a=(p(b,896)+a|0)+1075856|0;h[a|0]=k[a|0]|12;break g}if(!(!(k[a+480209|0]&16)|j[a+480180>>2]!=1048576)){d=p(b,896)+a|0;e=Zf(a,k[d+1075803|0],j[d+1075752>>2],j[d+1075688>>2]);j[c>>2]=e;j[d+1075684>>2]=e}g=a+1074308|0;mb(n+8|0,g,13);if(kb(n+8|0)){g=k[(p(b,896)+a|0)+1075812|0];if(!g){break g}b=65536;k:{switch(((m[a+1074392>>2]%(j[a+1074400>>2]+j[a+1074416>>2]>>>0)>>>0)%3|0)-1|0){case 1:g=g<<4;case 0:b=j[((g&240)<<2)+25312>>2];break;default:break k}}e=Ao(a);a=j[c>>2];d=a;a=a>>31;if(e){b=HMa(d,a,b,b>>31)+32768|0;a=ab;a=IMa(b,b>>>0<32768?a+1|0:a,65536,0)}else{a=a<<16|d>>>16;e=(b|0)/2|0;f=d<<16;d=e+f|0;a=a+(e>>31)|0;a=IMa(d,d>>>0<f>>>0?a+1|0:a,b,b>>31)}b=ab;u=c,v=ic(a,b),j[u>>2]=v;break g}mb(n+8|0,g,51);if(kb(n+8|0)){if(k[a+480209|0]&16){break g}l:{m:{d=j[a+1074416>>2];d=d-(m[a+1074392>>2]%(d>>>0)|0)|0;if((d|0)>16){break m}if((d|0)==16){break g}e=0;n:{switch((d|0)%3|0){case 0:break g;case 2:break m;case 1:break n;default:break l}}e=k[(p(b,896)+a|0)+1075812|0]>>>4|0;break l}e=k[(p(b,896)+a|0)+1075812|0]&15}b=p(b,896)+a|0;d=b+1075752|0;b=b+1075688|0;e=Nr(a,j[c>>2],j[d>>2],j[b>>2])+e|0;d=Zf(a,e,j[d>>2],j[b>>2]);j[c>>2]=d;if(e>>>0<109){break g}j[n+8>>2]=d;u=n,v=Zf(a,109,0,j[b>>2]),j[u+4>>2]=v;u=c,v=j[Lc(n+8|0,n+4|0)>>2],j[u>>2]=v;break g}d=j[a+1074392>>2];if(j[a+480180>>2]!=1){e=k[(p(b,896)+a|0)+1075803|0]}else{e=p(b,896)+a|0;e=Nr(a,j[c>>2],j[e+1075752>>2],j[e+1075688>>2])}o:{p:{switch((((j[a+480180>>2]&67633152?d+2|0:d)>>>0)%3|0)-1|0){case 0:e=(k[(p(b,896)+a|0)+1075812|0]>>>4|0)+e|0;break o;case 1:break p;default:break o}}e=(k[(p(b,896)+a|0)+1075812|0]&15)+e|0}if(!(j[a+480180>>2]&67633408|k[(p(b,896)+a|0)+1075803|0]!=(e&255))){mb(n+8|0,g,82);if(!kb(n+8|0)){break g}}f=c;q=a;if(k[a+480210|0]&32){o=e&255;if((o|0)==85){j[c>>2]=2147483647;break g}e=o>>>0>85?e-37|0:e}d=p(b,896)+a|0;u=f,v=Zf(q,e&255,j[d+1075752>>2],j[d+1075688>>2]),j[u>>2]=v;if(j[a+480180>>2]&71827712){j[d+1075684>>2]=j[c>>2];break g}mb(n+8|0,g,82);if(!kb(n+8|0)){break g}h[(p(b,896)+a|0)+1075806|0]=e}Za=n+16|0}function nGa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,i=0;e=Za-272|0;Za=e;_Fa(e+24|0,b);j[114630]=0;g=K(673,e+128|0,e+24|0,8)|0;b=j[114630];j[114630]=0;a:{b:{c:{d:{e:{f:{g:{h:{i:{j:{k:{l:{m:{n:{o:{p:{q:{r:{s:{t:{u:{v:{w:{x:{y:{z:{if((b|0)!=1){gb(e+24|0);if(c>>>0<2189){break g}j[114630]=0;b=E(682,e+24|0,g|0)|0;c=j[114630];j[114630]=0;if((c|0)==1){break c}j[114630]=0;c=E(683,e+8|0,14349)|0;d=j[114630];j[114630]=0;if((d|0)==1){break z}j[114630]=0;j[e>>2]=19466242;j[e+4>>2]=0;I(684,b|0,c|0,e|0);d=j[114630];j[114630]=0;if((d|0)==1){break y}qb(c);j[114630]=0;h[e|0]=0;c=E(683,e+8|0,14357)|0;d=j[114630];j[114630]=0;if((d|0)==1){break i}d=0;j[114630]=0;K(685,b|0,e|0,c|0)|0;f=j[114630];j[114630]=0;if((f|0)==1){break x}qb(c);if(!k[e|0]){j[114630]=0;d=H(686,a|0)|0;c=j[114630];j[114630]=0;if((c|0)==1){break w}}f=j[a+4>>2];j[114630]=0;c=E(683,e+8|0,14368)|0;i=j[114630];j[114630]=0;if((i|0)==1){break v}j[114630]=0;L(687,b|0,f|0,c|0,d|0);f=j[114630];j[114630]=0;if((f|0)==1){break u}qb(c);j[114630]=0;c=E(683,e+8|0,14370)|0;f=j[114630];j[114630]=0;if((f|0)==1){break t}j[114630]=0;L(688,b|0,a|0,c|0,d|0);d=j[114630];j[114630]=0;if((d|0)==1){break s}qb(c);j[114630]=0;c=E(683,e+8|0,14372)|0;d=j[114630];j[114630]=0;if((d|0)==1){break r}j[114630]=0;d=a+484360|0;P(689,b|0,d|0,c|0,690)|0;f=j[114630];j[114630]=0;if((f|0)==1){break q}qb(c);j[114630]=0;c=E(683,e+8|0,14374)|0;f=j[114630];j[114630]=0;if((f|0)==1){break p}j[114630]=0;P(691,b|0,a+484344|0,c|0,692)|0;f=j[114630];j[114630]=0;if((f|0)==1){break o}qb(c);j[114630]=0;f=H(686,a|0)|0;c=j[114630];j[114630]=0;if((c|0)==1){break n}j[114630]=0;c=E(683,e+8|0,14380)|0;i=j[114630];j[114630]=0;if((i|0)==1){break m}j[114630]=0;L(693,b|0,d|0,c|0,f|0);d=j[114630];j[114630]=0;if((d|0)==1){break l}qb(c);if(j[b>>2]&1073741824){j[114630]=0;c=E(2,e+8|0,14388)|0;d=j[114630];j[114630]=0;if((d|0)==1){break k}j[114630]=0;I(646,a|0,1,c|0);a=j[114630];j[114630]=0;if((a|0)==1){break j}gb(c)}ag(b);break f}a=D()|0;C()|0;gb(e+24|0);break a}a=D()|0;C()|0;break h}a=D()|0;C()|0;qb(c);break h}a=D()|0;C()|0;qb(c);break h}a=D()|0;C()|0;break h}a=D()|0;C()|0;break h}a=D()|0;C()|0;qb(c);break h}a=D()|0;C()|0;break h}a=D()|0;C()|0;qb(c);break h}a=D()|0;C()|0;break h}a=D()|0;C()|0;qb(c);break h}a=D()|0;C()|0;break h}a=D()|0;C()|0;qb(c);break h}a=D()|0;C()|0;break h}a=D()|0;C()|0;break h}a=D()|0;C()|0;qb(c);break h}a=D()|0;C()|0;break h}a=D()|0;C()|0;gb(c);break h}a=D()|0;C()|0}ag(b);break b}b=Qc(e+24|0);d=j[a+4>>2];j[114630]=0;f=H(686,a|0)|0;i=j[114630];j[114630]=0;if((i|0)==1){break e}j[114630]=0;d=P(694,d|0,g|0,b|0,f|0)|0;f=j[114630];j[114630]=0;if((f|0)==1){break e}A:{if((d|0)!=1){j[114630]=0;c=E(2,e+8|0,14437)|0;d=j[114630];j[114630]=0;B:{if((d|0)!=1){j[114630]=0;I(646,a|0,1,c|0);a=j[114630];j[114630]=0;if((a|0)==1){break B}gb(c);break A}a=D()|0;C()|0;break d}a=D()|0;C()|0;gb(c);break d}j[114630]=0;d=H(686,a|0)|0;f=j[114630];j[114630]=0;if((f|0)==1){break e}j[114630]=0;L(695,g|0,a|0,d|0,c>>>0<2188|0);a=j[114630];j[114630]=0;if((a|0)==1){break e}}gb(b)}Xe(g);Za=e+272|0;return}a=D()|0;C()|0}gb(b);break b}a=D()|0;C()|0}Xe(g)}G(a|0);z()}function mJa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,u=0,v=0;e=Za-720|0;Za=e;rc(b);f=e+104|0;g=fJa(b,f);if(!g){DR(f)}a:{if(!g){break a}if(!ER(e+104|0)){break a}b:{if(!c){break b}od(a,67108864);Zh(a);d=k[e+129|0];i[a+480190>>1]=31;i[a+480188>>1]=d;j[a+480228>>2]=256/(d>>>0);d=Db(e,12631);ob(a+1304436|0,d);gb(d);d=Db(e,12643);ob(a+1304448|0,d);gb(d);f=Db(e+88|0,12648);j[114630]=0;F(219,e- -64|0,f|0);d=j[114630];j[114630]=0;c:{d:{if((d|0)!=1){j[e+84>>2]=k[e+128|0]>>>4;d=k[e+128|0];j[114630]=0;j[e+80>>2]=d&15;L(533,e|0,e- -64|0,e+84|0,e+80|0);d=j[114630];j[114630]=0;if((d|0)!=1){ob(a+1304460|0,e);gb(e);qb(e- -64|0);gb(f);j[a+1304496>>2]=2;kn(Eb(a+484360|0),e+152|0,k[e+151|0]+1|0,65535,65535);f=0;while(1){d=f+1|0;n=p(d,104)+a|0;o=n+484380|0;md(o,1);g=(e+104|0)+(f<<2)|0;m=k[g+176|0]|k[g+177|0]<<8|(k[g+178|0]<<16|k[g+179|0]<<24);j[o>>2]=m<<24|m<<8&16711680|(m>>>8&65280|m>>>24);m=k[g+300|0]|k[g+301|0]<<8|(k[g+302|0]<<16|k[g+303|0]<<24);q=m<<24|m<<8&16711680|(m>>>8&65280|m>>>24);j[n+484384>>2]=q;m=k[g+424|0]|k[g+425|0]<<8|(k[g+426|0]<<16|k[g+427|0]<<24);j[n+484388>>2]=q+(m<<24|m<<8&16711680|(m>>>8&65280|m>>>24));if(k[g+424|0]|k[g+425|0]<<8|(k[g+426|0]<<16|k[g+427|0]<<24)){g=n+484414|0;i[g>>1]=l[g>>1]|2}Rm(o);f=(e+104|0)+f|0;h[e|0]=k[f+548|0];h[e+64|0]=64;u=n+484410|0,v=k[Zb(e,e- -64|0)|0]<<2,i[u>>1]=v;h[n+484417|0]=k[f+579|0]<<4;f=d;if((d|0)!=31){continue}break}Cz(b,a+1304400|0,32);d=1;while(1){_S(b,((d<<5)+a|0)+946300|0,30);d=d+1|0;if((d|0)!=32){continue}break}q=c&1;if(q){Jf(a+484344|0,k[e+150|0]+1|0)}o=a+484344|0;d=0;e:{while(1){n=zh(e- -64|0);f:{if(k[e+130|0]){j[114630]=0;f=H(484,b|0)|0;g=j[114630];j[114630]=0;if((g|0)==1){break e}j[114630]=0;I(341,e|0,b|0,f|0);break f}f=l[a+480188>>1];j[114630]=0;I(341,e|0,b|0,f<<8)}f=j[114630];j[114630]=0;if((f|0)==1){break e}g=d;Ed(n,e);jb(e);g:{if(!q){break g}j[114630]=0;d=K(402,o|0,g&65535,64)|0;f=j[114630];j[114630]=0;if((f|0)==1){break e}if(!d){break g}if(!k[e+130|0]){d=0;if(!l[a+480188>>1]){break g}while(1){f=0;while(1){m=Hb(o,g);j[114630]=0;m=K(471,m|0,f|0,d&65535)|0;r=j[114630];j[114630]=0;if((r|0)==1){break e}j[114630]=0;F(534,n|0,m|0);m=j[114630];j[114630]=0;if((m|0)==1){break e}f=f+1|0;if((f|0)!=64){continue}break}d=d+1|0;if(l[a+480188>>1]>(d&65535)>>>0){continue}break}break g}m=0;j[114630]=0;E(535,n|0,e|0)|0;d=j[114630];j[114630]=0;if((d|0)==1){break e}while(1){d=Hb(o,g);j[114630]=0;r=E(496,d|0,m|0)|0;d=j[114630];j[114630]=0;if((d|0)==1){break e}if(l[a+480188>>1]){s=e+m|0;d=128;f=0;while(1){h:{if(!(k[s|0]&d)){break h}j[114630]=0;F(534,n|0,r+p(f,6)|0);t=j[114630];j[114630]=0;if((t|0)!=1){break h}break e}d=d>>>1|0;f=f+1|0;if(f>>>0<l[a+480188>>1]){continue}break}}m=m+1|0;if((m|0)!=64){continue}break}}jb(n);d=g+1|0;if(g>>>0<k[e+150|0]){continue}break}d=1;if(!(c&2)){break a}c=Kc(e,8,1,1,0);while(1){$f(c,(p(d,104)+a|0)+484380|0,b);d=d+1|0;if((d|0)!=32){continue}break}break b}d=D()|0;C()|0;jb(n);break c}d=D()|0;C()|0;qb(e- -64|0);break d}d=D()|0;C()|0}gb(f)}G(d|0);z()}d=1}Za=e+720|0;return d|0}function Fb(a){a=a|0;var b=0,c=0,d=0,e=0,f=0,g=0,h=0,i=0,k=0;a:{if(!a){break a}d=a-8|0;b=j[a-4>>2];a=b&-8;f=d+a|0;b:{if(b&1){break b}if(!(b&3)){break a}b=j[d>>2];d=d-b|0;if(d>>>0<m[115942]){break a}a=a+b|0;if(j[115943]!=(d|0)){if(b>>>0<=255){e=j[d+8>>2];b=b>>>3|0;c=j[d+12>>2];if((c|0)==(e|0)){i=463752,k=j[115938]&MMa(-2,b),j[i>>2]=k;break b}j[e+12>>2]=c;j[c+8>>2]=e;break b}h=j[d+24>>2];b=j[d+12>>2];c:{if((d|0)!=(b|0)){c=j[d+8>>2];j[c+12>>2]=b;j[b+8>>2]=c;break c}d:{e=d+20|0;c=j[e>>2];if(c){break d}e=d+16|0;c=j[e>>2];if(c){break d}b=0;break c}while(1){g=e;b=c;e=b+20|0;c=j[e>>2];if(c){continue}e=b+16|0;c=j[b+16>>2];if(c){continue}break}j[g>>2]=0}if(!h){break b}e=j[d+28>>2];c=(e<<2)+464056|0;e:{if(j[c>>2]==(d|0)){j[c>>2]=b;if(b){break e}i=463756,k=j[115939]&MMa(-2,e),j[i>>2]=k;break b}j[h+(j[h+16>>2]==(d|0)?16:20)>>2]=b;if(!b){break b}}j[b+24>>2]=h;c=j[d+16>>2];if(c){j[b+16>>2]=c;j[c+24>>2]=b}c=j[d+20>>2];if(!c){break b}j[b+20>>2]=c;j[c+24>>2]=b;break b}b=j[f+4>>2];if((b&3)!=3){break b}j[115940]=a;j[f+4>>2]=b&-2;j[d+4>>2]=a|1;j[a+d>>2]=a;return}if(d>>>0>=f>>>0){break a}b=j[f+4>>2];if(!(b&1)){break a}f:{if(!(b&2)){if(j[115944]==(f|0)){j[115944]=d;a=j[115941]+a|0;j[115941]=a;j[d+4>>2]=a|1;if(j[115943]!=(d|0)){break a}j[115940]=0;j[115943]=0;return}if(j[115943]==(f|0)){j[115943]=d;a=j[115940]+a|0;j[115940]=a;j[d+4>>2]=a|1;j[a+d>>2]=a;return}a=(b&-8)+a|0;g:{if(b>>>0<=255){e=j[f+8>>2];b=b>>>3|0;c=j[f+12>>2];if((c|0)==(e|0)){i=463752,k=j[115938]&MMa(-2,b),j[i>>2]=k;break g}j[e+12>>2]=c;j[c+8>>2]=e;break g}h=j[f+24>>2];b=j[f+12>>2];h:{if((f|0)!=(b|0)){c=j[f+8>>2];j[c+12>>2]=b;j[b+8>>2]=c;break h}i:{e=f+20|0;c=j[e>>2];if(c){break i}e=f+16|0;c=j[e>>2];if(c){break i}b=0;break h}while(1){g=e;b=c;e=b+20|0;c=j[e>>2];if(c){continue}e=b+16|0;c=j[b+16>>2];if(c){continue}break}j[g>>2]=0}if(!h){break g}e=j[f+28>>2];c=(e<<2)+464056|0;j:{if(j[c>>2]==(f|0)){j[c>>2]=b;if(b){break j}i=463756,k=j[115939]&MMa(-2,e),j[i>>2]=k;break g}j[h+(j[h+16>>2]==(f|0)?16:20)>>2]=b;if(!b){break g}}j[b+24>>2]=h;c=j[f+16>>2];if(c){j[b+16>>2]=c;j[c+24>>2]=b}c=j[f+20>>2];if(!c){break g}j[b+20>>2]=c;j[c+24>>2]=b}j[d+4>>2]=a|1;j[a+d>>2]=a;if(j[115943]!=(d|0)){break f}j[115940]=a;return}j[f+4>>2]=b&-2;j[d+4>>2]=a|1;j[a+d>>2]=a}if(a>>>0<=255){a=a>>>3|0;b=(a<<3)+463792|0;c=j[115938];a=1<<a;k:{if(!(c&a)){j[115938]=a|c;a=b;break k}a=j[b+8>>2]}j[b+8>>2]=d;j[a+12>>2]=d;j[d+12>>2]=b;j[d+8>>2]=a;return}e=31;j[d+16>>2]=0;j[d+20>>2]=0;if(a>>>0<=16777215){b=a>>>8|0;g=b+1048320>>>16&8;b=b<<g;e=b+520192>>>16&4;b=b<<e;c=b+245760>>>16&2;b=(b<<c>>>15|0)-(c|(e|g))|0;e=(b<<1|a>>>b+21&1)+28|0}j[d+28>>2]=e;g=(e<<2)+464056|0;l:{m:{c=j[115939];b=1<<e;n:{if(!(c&b)){j[115939]=b|c;j[g>>2]=d;j[d+24>>2]=g;break n}e=a<<((e|0)==31?0:25-(e>>>1|0)|0);b=j[g>>2];while(1){c=b;if((j[b+4>>2]&-8)==(a|0)){break m}b=e>>>29|0;e=e<<1;g=c+(b&4)|0;b=j[g+16>>2];if(b){continue}break}j[g+16>>2]=d;j[d+24>>2]=c}j[d+12>>2]=d;j[d+8>>2]=d;break l}a=j[c+8>>2];j[a+12>>2]=d;j[c+8>>2]=d;j[d+24>>2]=0;j[d+12>>2]=c;j[d+8>>2]=a}a=j[115946]-1|0;j[115946]=a?a:-1}}function oHa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0;e=Za-976|0;Za=e;rc(b);g=e+872|0;f=kHa(b,g);if(!f){UQ(g)}a:{if(!f){break a}if(!XQ(e+872|0)){break a}if(!yb(b,Tc(WQ(e+872|0),ab))){break a}b:{if(!c){break b}od(a,512);j[a+480228>>2]=32;i[a+480188>>1]=16;j[a+480196>>2]=k[e+947|0];j[a+480200>>2]=256;j[a+480204>>2]=8e5;d=Db(e+96|0,12920);ob(a+1304436|0,d);gb(d);d=Db(e+96|0,12939);ob(a+1304448|0,d);gb(d);j[a+1304496>>2]=4;VQ(e+24|0,2,e+872|4);qc(e+96|0,e+24|0);ob(a+1304400|0,e+96|0);gb(e+96|0);d=0;while(1){g=(d<<5)+a|0;f=g+480280|0;wg(f);m=f;f=(e+872|0)+d|0;j[m>>2]=!k[f+50|0]<<10;i[g+480284>>1]=(k[f+76|0]<<4|8)&248;d=d+1|0;if((d|0)!=16){continue}break}if(k[e+968|0]|k[e+969|0]<<8){Qx(a+1304424|0,b,k[e+968|0]|k[e+969|0]<<8,132,0)}d=0;if(!mHa(b,e+96|0)){break a}d=a+484360|0;gz(Eb(d),e+96|0,k[e+353|0],255,254);Fe(Eb(d),k[e+354|0]);xc(b,k[e+919|0]|k[e+920|0]<<8);s=a+484344|0;u=c&1;g=0;c:{d:{while(1){d=(g<<1)+e|0;f=d+355|0;if(k[f|0]|k[f+1|0]<<8){cd(e+24|0,b,k[d+355|0]|k[d+356|0]<<8);d=k[d+355|0]|k[d+356|0]<<8;q=(d-2|0)/64|0;e:{if(!u){break e}j[114630]=0;f=K(402,s|0,g&65535,q|0)|0;o=j[114630];j[114630]=0;if((o|0)==1){break d}if(!f){break e}j[114630]=0;o=H(387,e+24|0)|0;f=j[114630];j[114630]=0;if((f|0)==1){break d}j[114630]=0;E(338,e+24|0,1)|0;f=j[114630];j[114630]=0;if((f|0)==1){break d}if(d>>>0>=66){v=q>>>0>1?q:1;m=0;while(1){d=Hb(s,g);j[114630]=0;w=E(496,d|0,m|0)|0;d=j[114630];j[114630]=0;r=0;if((d|0)==1){break d}while(1){j[114630]=0;F(595,e+80|0,e+24|0);d=j[114630];j[114630]=0;f:{g:{if((d|0)!=1){d=p(r,6)+w|0;x=Pc(e+80|0);f=Bf(e+80|0);t=pi(e+80|0);n=k[e+80|0];if((n-1&255)>>>0<72){break g}n=k[d|0];break f}break d}n=n+36|0;h[d|0]=n;h[d+1|0]=k[x|0]+1}if(k[f|0]|n&255){h[d+2|0]=1;y=d,A=(kd(k[f|0],1,16)<<2)-4|0,h[y+4|0]=A}f=k[t|0]&15;h[d+5|0]=f;h:{i:{switch((k[t|0]>>>4|0)-3|0){case 0:h[d+5|0]=f<<2;break h;case 1:h[d+5|0]=(6/(f+1>>>0)|0)+1;break h;case 3:case 4:h[d+5|0]=f<<3;break h;case 7:h[d+4|0]=(f<<2)+4;h[d+2|0]=1;break h;case 8:h[d+5|0]=f|128;break h;case 9:break i;default:break h}}h[d+5|0]=(6/(f+1>>>0)|0)+1|13}h[d+3|0]=k[(k[t|0]>>>4|0)+12944|0];r=r+1|0;if((r|0)!=16){continue}break}m=m+1|0;if((v|0)!=(m|0)){continue}break}}d=Hb(s,g);j[114630]=0;f=K(497,e+80|0,14,0)|0;m=j[114630];j[114630]=0;if((m|0)==1){break d}f=qi(Ee(f,o?o>>>0<q-2>>>0?o+1|0:-1:-1));j[114630]=0;E(498,d|0,f|0)|0;d=j[114630];j[114630]=0;if((d|0)==1){break d}}jb(e+24|0)}g=g+1|0;if((g|0)!=256){continue}break}d=1;if(!(c&2)){break a}PR(b,e+72|0);d=0;while(1){j:{k:{if(!(k[e+72+(d>>>3)|0]>>>(d&7)&1)){d=d+1|0;break k}if(!fz(b,e+24|0)){break b}d=d+1|0;i[a+480190>>1]=d;vg(e+8|0,1,e+24|0);qc(e+80|0,e+8|0);c=l[a+480190>>1];j[114630]=0;E(369,((c<<5)+a|0)+946300|0,e+80|0)|0;c=j[114630];j[114630]=0;if((c|0)==1){break j}gb(e+80|0);c=(p(d,104)+a|0)+484380|0;nHa(e+24|0,c);Kc(e+80|0,h[e+70|0]&1?16:8,1,0,0);$f(e+80|0,c,b)}if((d|0)!=64){continue}break b}break}d=D()|0;C()|0;gb(e+80|0);break c}d=D()|0;C()|0;jb(e+24|0)}G(d|0);z()}d=1}Za=e+976|0;return d|0}function vba(a){var b=0,c=0,d=0,e=0;b=Za-96|0;Za=b;e=Cb(a);j[114630]=0;N(236,b- -64|0);a=j[114630];j[114630]=0;a:{b:{c:{d:{e:{f:{g:{h:{i:{j:{k:{if((a|0)!=1){j[114630]=0;j[b+32>>2]=0;F(2112,b+48|0,b+32|0);a=j[114630];j[114630]=0;if((a|0)==1){break k}j[114630]=0;E(1245,e|0,b+48|0)|0;a=j[114630];j[114630]=0;if((a|0)==1){break j}gb(b+48|0);j[114630]=0;E(1990,e|0,38901)|0;a=j[114630];j[114630]=0;l:{if((a|0)==1){break l}j[114630]=0;j[b+32>>2]=5;F(2112,b+48|0,b+32|0);a=j[114630];j[114630]=0;if((a|0)==1){break i}j[114630]=0;E(1245,e|0,b+48|0)|0;a=j[114630];j[114630]=0;if((a|0)==1){break h}gb(b+48|0);j[114630]=0;E(1990,e|0,38901)|0;a=j[114630];j[114630]=0;if((a|0)==1){break l}j[114630]=0;j[b+32>>2]=7;F(2112,b+48|0,b+32|0);a=j[114630];j[114630]=0;if((a|0)==1){break g}j[114630]=0;E(1245,e|0,b+48|0)|0;a=j[114630];j[114630]=0;if((a|0)==1){break f}gb(b+48|0);j[114630]=0;a=E(85,b+48|0,38341)|0;d=j[114630];j[114630]=0;if((d|0)==1){break e}d=nb(a);gb(a);if(!d){break d}j[114630]=0;E(1990,e|0,38341)|0;a=j[114630];j[114630]=0;if((a|0)!=1){break d}}a=D()|0;C()|0;break c}a=D()|0;C()|0;break b}a=D()|0;C()|0;break c}a=D()|0;C()|0;gb(b+48|0);break c}a=D()|0;C()|0;break c}a=D()|0;C()|0;gb(b+48|0);break c}a=D()|0;C()|0;break c}a=D()|0;C()|0;gb(b+48|0);break c}a=D()|0;C()|0;break c}d=Ng(b+48|0);m:{n:{o:{p:{q:{r:{s:{t:{u:{v:{w:{x:{y:{if(j[(b- -64|0)+12>>2]){a=j[(b- -64|0)+12>>2];j[114630]=0;j[b+12>>2]=a;F(2112,b+16|0,b+12|0);a=j[114630];j[114630]=0;if((a|0)==1){break y}j[114630]=0;I(2113,b+32|0,39485,b+16|0);a=j[114630];j[114630]=0;if((a|0)==1){break x}j[114630]=0;F(1529,d|0,b+32|0);a=j[114630];j[114630]=0;if((a|0)==1){break w}gb(b+32|0);gb(b+16|0)}if(!k[(b- -64|0)+16|0]){break s}j[114630]=0;c=E(85,b+32|0,39487)|0;a=j[114630];j[114630]=0;if((a|0)==1){break u}j[114630]=0;F(1529,d|0,c|0);a=j[114630];j[114630]=0;if((a|0)==1){break t}gb(c);break r}a=D()|0;C()|0;break m}a=D()|0;C()|0;break v}a=D()|0;C()|0;gb(b+32|0)}gb(b+16|0);break m}a=D()|0;C()|0;break m}a=D()|0;C()|0;gb(c);break m}if(!k[(b- -64|0)+17|0]){break r}j[114630]=0;c=E(85,b+32|0,39496)|0;a=j[114630];j[114630]=0;if((a|0)==1){break q}j[114630]=0;F(1529,d|0,c|0);a=j[114630];j[114630]=0;if((a|0)==1){break p}gb(c)}if(k[(b- -64|0)+18|0]){break o}break n}a=D()|0;C()|0;break m}a=D()|0;C()|0;gb(c);break m}j[114630]=0;c=E(85,b+32|0,39502)|0;a=j[114630];j[114630]=0;z:{if((a|0)!=1){j[114630]=0;F(1529,d|0,c|0);a=j[114630];j[114630]=0;if((a|0)==1){break z}gb(c);break n}a=D()|0;C()|0;break m}a=D()|0;C()|0;gb(c);break m}if(Xc(d)){break a}j[114630]=0;E(1990,e|0,39506)|0;a=j[114630];j[114630]=0;if((a|0)!=1){j[114630]=0;c=E(85,b+16|0,38901)|0;a=j[114630];j[114630]=0;A:{B:{C:{if((a|0)!=1){j[114630]=0;I(2114,b+32|0,d|0,c|0);a=j[114630];j[114630]=0;if((a|0)==1){break C}j[114630]=0;E(1245,e|0,b+32|0)|0;a=j[114630];j[114630]=0;if((a|0)==1){break B}gb(b+32|0);gb(c);break a}a=D()|0;C()|0;break m}a=D()|0;C()|0;break A}a=D()|0;C()|0;gb(b+32|0)}gb(c);break m}a=D()|0;C()|0}Vc(d)}Ie(b- -64|0)}gb(e);G(a|0);z()}Vc(d);Ie(b- -64|0);Za=b+96|0}function mK(a,b,c,d,e){var f=0,g=0,m=0,n=0,o=0,r=0,s=0,t=0,u=0,v=0,w=q(0),x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=q(0),K=q(0),L=0,M=0;g=Za-48|0;Za=g;s=l[a+480192>>1]?j[(p(b,896)+a|0)+1075640>>2]:s;x=a+1074308|0;f=p(b,896)+a|0;y=f+1075805|0;B=f+1075672|0;C=f+1075772|0;z=f+1075748|0;A=f+1075744|0;D=f+1075704|0;E=f+1075676|0;F=f+1075668|0;G=f+1075648|0;H=f+1075792|0;I=f+1075072|0;o=e&127;J=q(o>>>0);u=f+1075855|0;K=q(k[u|0]);m=1;while(1){e=k[d+n|0];if(e){f=e-48|0;a:{b:{c:{if((f&255)>>>0<10){break c}if((e-65&255)>>>0<=5){f=e-55|0;break c}f=r;d:{e:{f:{switch(e-97|0){case 2:g:{e=bl(a,b,3,0);if(!e|e-251>>>0<5){break g}e=j[(p(e,160)+a|0)+906140>>2];if(!e){break g}e=yu(e,80072,80080);if(!e){break g}f=bb[j[j[e>>2]+184>>2]](e,b)|0;e=(f|0)!=255;f=e?f:0;if(e|!s){break c}break d}if(s){break d}f=0;break c;case 13:f=0;if(!Ld(k[y|0])){break e}f=k[y|0]-1|0;break e;case 21:mb(g+8|0,x,28);h:{if(!kb(g+8|0)){mb(g,x,1);e=0;if(!kb(g)){break h}}e=i[C>>1]}f=p(j[z>>2],j[A>>2]);e=p(j[a+1074444>>2],e+j[B>>2]|0);f=Gb((ic(IMa(HMa(f,f>>31,e,e>>31),ab,1048576,0),ab)|0)/2|0,1,127);break e;case 23:j[g+8>>2]=j[E>>2]/2;j[g>>2]=127;f=j[Pd(g+8|0,g)>>2];break e;case 24:j[g+8>>2]=j[F>>2]/2;j[g>>2]=127;f=j[Pd(g+8|0,g)>>2];break e;case 0:f=0;if(!s){break e}e=l[s+28>>1];if(!e){break e}f=e-1>>>7&127;break e;case 1:f=0;if(!s){break e}e=l[s+28>>1];if(!e){break e}f=e-1&127;break e;case 14:f=j[G>>2]>>>8|0;break e;case 7:e=b;if(e>>>0>=l[a+480188>>1]){e=k[H|0]-1|0}f=e&127;break e;case 12:f=j[I>>2]>>>7&1;break e;case 15:f=0;if(!s){break e}e=k[s+30|0];if(!e){break e}f=e-1&127;break e;case 25:v=u;e=o;i:{if(!c){break i}e=o;if(h[u|0]<0){break i}j:{if(r>>>0<3){break j}t=(g+16|0)+r|0;if(k[t-3|0]!=240){break j}e=o;if(k[t-2|0]>239){break i}}w=zo(a,K,J);if(w<q(4294967296)&w>=q(0)){e=~~w>>>0;break i}e=0}f=e;h[v|0]=f;break e;case 18:while(1){k:{if(!f){f=0;break k}f=f-1|0;if(k[f+(g+16|0)|0]!=240){continue}}break}if(k[(g+16|0)+f|0]!=240|r-f>>>0<5){break a}t=0;e=f+5|0;if((r|0)!=(e|0)){while(1){t=k[(g+16|0)+e|0]+t|0;e=e+1|0;if((r|0)!=(e|0)){continue}break}}f=0-t&127;break e;case 20:break f;default:break a}}e=p(j[z>>2],j[A>>2]);f=e;v=e>>31;e=p(j[a+1074444>>2],j[D>>2]);f=Gb((ic(IMa(HMa(f,v,e,e>>31),ab,67108864,0),ab)|0)/2|0,1,127)}e=((m^-1)&1)+r|0;h[e+(g+16|0)|0]=f;r=e+1|0;m=1;break b}f=Kta(s,a,b)}e=(g+16|0)+r|0;l:{if(m&1){h[e|0]=f;break l}h[e|0]=k[e|0]<<4|f;r=r+1|0}m=(m^-1)&1}}n=n+1|0;if((n|0)!=31){continue}}break}e=((m^-1)&1)+r|0;m:{if(!e){break m}f=0;m=0;while(1){d=(g+16|0)+m|0;o=h[d|0];n:{o:{p:{if((o|0)==-16){if(e-m>>>0>=4){n=4;if((k[(g+m|0)+17|0]&254)==240){break o}}n=m;q:{while(1){n=n+1|0;if(n>>>0>=e>>>0){break q}if(k[(g+16|0)+n|0]!=247){continue}break}o=n-m|0;n=o+1|0;if(n>>>0>=o>>>0){break o}}h[(g+16|0)+e|0]=247;e=e+1|0;n=e-m|0;break p}if((o|0)>=0){if(f&255){m=m-1|0;h[m+(g+16|0)|0]=f;break n}m=m+1|0;f=0;break n}L=g,M=NM(o&255),j[L+8>>2]=M;j[g>>2]=e-m;n=j[tb(g+8|0,g)>>2]}if(!n){break m}o=k[d|0];f=o>>>0<240?o:f}d=zoa(a,b,c,d,n);m=(d?d:n)+m|0}if(e>>>0>m>>>0){continue}break}}Za=g+48|0}function K2(a,b){var c=0,d=0,e=0,f=0,g=0,i=0,l=0,n=0,o=0,q=0;n=Za-16|0;Za=n;a:{b:{c:{d:{e:{f:{if(b>>>0<=36){while(1){c=j[a+4>>2];g:{if(c>>>0<m[a+104>>2]){j[a+4>>2]=c+1;c=k[c|0];break g}c=Jc(a)}if(Jk(c)){continue}break}h:{i:{switch(c-43|0){case 0:case 2:break i;default:break h}}o=(c|0)==45?-1:0;c=j[a+4>>2];if(c>>>0<m[a+104>>2]){j[a+4>>2]=c+1;c=k[c|0];break h}c=Jc(a)}j:{if(!(b&-17|(c|0)!=48)){c=j[a+4>>2];k:{if(c>>>0<m[a+104>>2]){j[a+4>>2]=c+1;c=k[c|0];break k}c=Jc(a)}if((c&-33)==88){b=16;c=j[a+4>>2];l:{if(c>>>0<m[a+104>>2]){j[a+4>>2]=c+1;c=k[c|0];break l}c=Jc(a)}if(k[c+59857|0]<16){break e}if(!j[a+104>>2]){break b}j[a+4>>2]=j[a+4>>2]-1;break b}if(b){break j}b=8;break e}b=b?b:10;if(b>>>0>k[c+59857|0]){break j}if(j[a+104>>2]){j[a+4>>2]=j[a+4>>2]-1}dh(a,0,0);j[114604]=28;b=0;a=0;break a}if((b|0)!=10){break e}d=c-48|0;if(d>>>0<=9){b=0;while(1){b=p(b,10)+d|0;c=j[a+4>>2];m:{if(c>>>0<m[a+104>>2]){j[a+4>>2]=c+1;c=k[c|0];break m}c=Jc(a)}d=c-48|0;if(b>>>0<429496729?d>>>0<=9:0){continue}break}e=b}if(d>>>0>9){break f}i=HMa(e,0,10,0);g=ab;b=d;while(1){c=j[a+4>>2];n:{if(c>>>0<m[a+104>>2]){j[a+4>>2]=c+1;c=k[c|0];break n}c=Jc(a)}d=c-48|0;l=d>>>0>9;f=g;e=b+i|0;f=e>>>0<b>>>0?f+1|0:f;if((f|0)==429496729&e>>>0>=2576980378|f>>>0>429496729|l){break f}i=HMa(e,f,10,0);g=ab;b=d;if((g|0)==-1&i>>>0<=(b^-1)>>>0|(g|0)!=-1){continue}break}b=10;break d}j[114604]=28;b=0;a=0;break a}b=10;if(d>>>0<=9){break d}break c}if(b-1&b){d=k[c+59857|0];if(d>>>0<b>>>0){while(1){g=p(b,g)+d|0;e=g>>>0<=119304646;c=j[a+4>>2];o:{if(c>>>0<m[a+104>>2]){j[a+4>>2]=c+1;c=k[c|0];break o}c=Jc(a)}d=k[c+59857|0];if(d>>>0<b>>>0?e:0){continue}break}e=g}if(b>>>0<=d>>>0){break d}g=b;while(1){l=HMa(e,f,g,0);i=ab;d=d&255;if((i|0)==-1&(d^-1)>>>0<l>>>0){break d}f=i;c=d+l|0;f=c>>>0<d>>>0?f+1|0:f;e=c;i=b;c=j[a+4>>2];p:{if(c>>>0<m[a+104>>2]){j[a+4>>2]=c+1;c=k[c|0];break p}c=Jc(a)}d=k[c+59857|0];if(i>>>0<=d>>>0){break d}Ig(n,g,0,e,f);if(!(j[n+8>>2]|j[n+12>>2])){continue}break}break d}i=h[(p(b,23)>>>5&7)+60113|0];d=k[c+59857|0];if(d>>>0<b>>>0){while(1){g=g<<i|d;e=g>>>0<=134217727;c=j[a+4>>2];q:{if(c>>>0<m[a+104>>2]){j[a+4>>2]=c+1;c=k[c|0];break q}c=Jc(a)}d=k[c+59857|0];if(d>>>0<b>>>0?e:0){continue}break}e=g}q=b>>>0<=d>>>0;g=i;l=g&31;if((g&63)>>>0>=32){i=0;l=-1>>>l|0}else{i=-1>>>l|0;l=(1<<l)-1<<32-l|-1>>>l}if(!i&e>>>0>l>>>0|q){break d}while(1){q=d&255;d=e;c=g;e=c&31;if((c&63)>>>0>=32){f=d<<e;c=0}else{f=(1<<e)-1&d>>>32-e|f<<e;c=d<<e}e=q|c;c=j[a+4>>2];r:{if(c>>>0<m[a+104>>2]){j[a+4>>2]=c+1;c=k[c|0];break r}c=Jc(a)}if((f|0)==(i|0)&e>>>0>l>>>0|f>>>0>i>>>0){break d}d=k[c+59857|0];if(d>>>0<b>>>0){continue}break}}if(k[c+59857|0]>=b>>>0){break c}while(1){f=j[a+4>>2];s:{if(f>>>0<m[a+104>>2]){j[a+4>>2]=f+1;c=k[f|0];break s}c=Jc(a)}if(k[c+59857|0]<b>>>0){continue}break}j[114604]=68;o=0;e=-1;f=-1}if(j[a+104>>2]){j[a+4>>2]=j[a+4>>2]-1}if((e|0)==-1&(f|0)==-1){if(!(o|1)){j[114604]=68;b=-2;a=-1;break a}}a=o;c=a^e;b=c-a|0;g=f;f=a>>31;a=(g^f)-(f+(a>>>0>c>>>0)|0)|0;break a}dh(a,0,0);b=0;a=0}Za=n+16|0;ab=a;return b}function mx(a,b,c,d){var e=0,f=0,g=0,n=0,o=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;g=Za-16|0;Za=g;o=p(b,896)+a|0;t=o+1075782|0;n=l[t>>1];s=a+1074308|0;mb(g+8|0,s,23);e=c&15;a:{b:{if(kb(g+8|0)){if(!(j[a+1074392>>2]|!k[(p(b,896)+a|0)+1075794|0])){i[t>>1]=e;break b}f=l[t>>1];if(f){q=f-1|0;i[t>>1]=q;f=0;if(q&65535){break b}}i[t>>1]=e;f=1;break b}mb(g+8|0,s,52);q=c&256;if(!(!q|!kb(g+8|0))){c:{if(!(k[a+480209|0]&16)){break c}f=p(b,896)+a|0;if(k[f+1075795|0]){n=KQ(f+1075794|0)?1:n}if(!k[(p(b,896)+a|0)+1075798|0]|k[f+1075796|0]!=1){break c}i[t>>1]=n;break a}f=0;if(n<<16>>16<(e|0)){break b}if(k[a+480209|0]&16){if(Mf((p(b,896)+a|0)+1075794|0)){break b}}n=0;f=1;break b}if(j[a+480180>>2]&16777250){f=n&65535?!((n<<16>>16)%((e?e:1)|0)|0):0;n=n+1|0;break b}if(j[a+480180>>2]==16){f=j[a+1074392>>2]==(e|0)&(e|0)!=0;break b}d:{e:{f:{g:{h:{if(q){f=p(b,896)+a|0;if(k[f+1075796|0]==1){e=(k[f+1075799|0]>15)+e|0}e=e?e:1;break h}if(j[a+480208>>2]&4096?!q:0){break e}e=e?e:1;if(j[a+1074416>>2]){break g}}f=0;break f}f=!(m[a+1074392>>2]%(e>>>0)|0)}n=n+1|0;break d}n=j[a+480180>>2]&1048580?0:n}if(!(n<<16>>16<(e|0)|(k[(p(b,896)+a|0)+1075794|0]|!q?!j[a+1074392>>2]:0))){f=1}mb(g+8|0,s,52);if(!kb(g+8|0)|c){break b}f=!j[a+1074392>>2]}q=o+1074984|0;r=(p(b,896)+a|0)+1075060|0;i:{if(j[r>>2]){break i}mb(g+8|0,s,38);if(!kb(g+8|0)){break i}if(!Si(q)){break a}}mb(g+8|0,s,106);if(A=0,B=kb(g+8|0),C=j[(p(b,896)+a|0)+1075680>>2],C?A:B){break a}if(f){e=p(b,896)+a|0;v=e+1075672|0;j[g+4>>2]=j[v>>2];f=c>>>4&15;j:{if(!f){e=j[e+1075072>>2];break j}mb(g+8|0,s,52);k:{if(A=kb(g+8|0),B=0,C=k[(p(b,896)+a|0)+1075796|0]==1,C?A:B){break k}e=h[f+21872|0];if(e){j[g+4>>2]=p(e,j[g+4>>2])>>4;break k}j[g+4>>2]=j[g+4>>2]+(h[f+21888|0]<<2)}Md(g+4|0,0,256);f=(p(b,896)+a|0)+1075072|0;e=j[f>>2]|2097152;j[f>>2]=e}u=p(b,896)+a|0;w=u+1075684|0;x=j[w>>2];f=k[u+1075808|0];o=0;if(e&512){mb(g+8|0,s,108);o=kb(g+8|0)}if(!(!j[r>>2]|o^1|(f-1&255)>>>0>119)){GK(a,b,0,f,1)}l:{if(!(j[a+480180>>2]&1048580)){e=0;break l}e=(c|0)<256;if((c|0)>255){break l}r=k[(p(b,896)+a|0)+1075795|0];if(!r){break l}e=1;Go(a,q,r,0,0,1)}u=u+1075072|0;m:{if(!o){break m}r=(p(b,896)+a|0)+1075088|0;if(!j[r>>2]){break m}o=a+1304392|0;if(!$c(o)){break m}qh(j[o>>2],b,1);ds(j[o>>2],b,j[r>>2]+68|0)}o=p(b,896)+a|0;r=o+1075644|0;y=j[r>>2];z=j[u>>2];j[r>>2]=0;mb(g+8|0,s,23);Sr(a,q,f,kb(g+8|0),e,0,b);if(!k[o+1075795|0]){j[r>>2]=y}if(!(!(z&4096)|j[a+480180>>2]!=4)){j[u>>2]=j[u>>2]|4096}e=o+1075794|0;j[v>>2]=j[g+4>>2];if(l[a+480192>>1]){h[e|0]=f;lJ(a,b)}if(!(k[e|0]|(!(j[a+480180>>2]&16777248)|!x))){j[w>>2]=x}f=j[a+480180>>2];mb(g+8|0,s,23);if(kb(g+8|0)){j[q>>2]=0;j[q+4>>2]=0}f=f&16777250;n:{if(d-1>>>0>9){break n}e=j[(p(b,896)+a|0)+1075088>>2];if(!e){break n}o:{if((d|0)==1){b=j[(p(b,896)+a|0)+1075648>>2];break o}o=(p(b,896)+a|0)+1075648|0;b=j[(e+(d<<2)|0)+60>>2];j[o>>2]=b}Fo(a,q,b)}n=f?n:0}mb(g+8|0,s,52);a=kb(g+8|0);mb(g+8|0,s,23);if(kb(g+8|0)){break a}i[t>>1]=(a&c>>>8)+n}Za=g+16|0}function S5(a,b,c,d){var e=0,f=0,g=0,h=0,j=q(0),k=q(0),l=q(0),m=q(0),o=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;h=Za-32|0;Za=h;n[d+4080>>2]=n[a+1152>>2];u=c-1|0;v=p(u,2304)+a|0;n[d+4084>>2]=n[v+1152>>2];n[d+4088>>2]=n[a>>2];n[d+4092>>2]=n[v>>2];n[d+4336>>2]=n[a+1156>>2];n[d+4340>>2]=n[v+1156>>2];n[d+4344>>2]=n[a+4>>2];n[d+4348>>2]=n[v+4>>2];w=(u<<1)+b|0;Yq(w,c,d+244|0);u=c<<6;Yq(u+w|0,c,d+500|0);Yq(b,c,d+240|0);Yq(b+u|0,c,d+496|0);s=49152;x=d+3840|0;f=14;while(1){o=f<<4;g=o+x|0;u=f;e=p(31-f|0,72);j=n[e+a>>2];n[g>>2]=j;n[(o|4)+x>>2]=n[e+v>>2];e=e|4;n[(o|8)+x>>2]=n[e+a>>2];n[(o|12)+x>>2]=n[e+v>>2];r=p(f,72);e=r+76|0;n[g+256>>2]=n[e+a>>2];n[g+260>>2]=n[e+v>>2];e=r+72|0;n[g-248>>2]=n[e+a>>2];n[g-244>>2]=n[e+v>>2];l=n[s>>2];r=d+o|0;k=n[r>>2];m=n[s+4>>2];n[h+16>>2]=q(j*l)-q(k*m);n[h>>2]=q(k*l)+q(j*m);e=f<<2;f=1;while(1){o=f<<2;j=n[o+g>>2];k=n[o+r>>2];n[o+(h+16|0)>>2]=q(j*l)-q(k*m);n[h+o>>2]=q(k*l)+q(j*m);f=f+1|0;if((f|0)!=4){continue}break}t=(e<<2)+x|0;o=t-3584|0;r=t-256|0;l=n[s+12>>2];m=n[s+8>>2];f=0;while(1){g=f<<2;e=g+h|0;j=n[g+o>>2];k=n[g+r>>2];n[e>>2]=q(q(j*m)+q(k*l))+n[e>>2];e=g+(h+16|0)|0;n[e>>2]=q(q(j*l)-q(k*m))+n[e>>2];f=f+1|0;if((f|0)!=4){continue}break}o=t-3328|0;r=t-512|0;l=n[s+20>>2];m=n[s+16>>2];f=0;while(1){g=f<<2;e=g+h|0;j=n[g+o>>2];k=n[g+r>>2];n[e>>2]=q(q(j*m)+q(k*l))+n[e>>2];e=g+(h+16|0)|0;n[e>>2]=q(q(k*m)-q(j*l))+n[e>>2];f=f+1|0;if((f|0)!=4){continue}break}o=t-3072|0;r=t-768|0;l=n[s+28>>2];m=n[s+24>>2];f=0;while(1){g=f<<2;e=g+h|0;j=n[g+o>>2];k=n[g+r>>2];n[e>>2]=q(q(j*m)+q(k*l))+n[e>>2];e=g+(h+16|0)|0;n[e>>2]=q(q(j*l)-q(k*m))+n[e>>2];f=f+1|0;if((f|0)!=4){continue}break}o=t-2816|0;r=t-1024|0;l=n[s+36>>2];m=n[s+32>>2];f=0;while(1){g=f<<2;e=g+h|0;j=n[g+o>>2];k=n[g+r>>2];n[e>>2]=q(q(j*m)+q(k*l))+n[e>>2];e=g+(h+16|0)|0;n[e>>2]=q(q(k*m)-q(j*l))+n[e>>2];f=f+1|0;if((f|0)!=4){continue}break}o=t-2560|0;r=t-1280|0;l=n[s+44>>2];m=n[s+40>>2];f=0;while(1){g=f<<2;e=g+h|0;j=n[g+o>>2];k=n[g+r>>2];n[e>>2]=q(q(j*m)+q(k*l))+n[e>>2];e=g+(h+16|0)|0;n[e>>2]=q(q(j*l)-q(k*m))+n[e>>2];f=f+1|0;if((f|0)!=4){continue}break}o=t-2304|0;r=t-1536|0;l=n[s+52>>2];m=n[s+48>>2];f=0;while(1){g=f<<2;e=g+h|0;j=n[g+o>>2];k=n[g+r>>2];n[e>>2]=q(q(j*m)+q(k*l))+n[e>>2];e=g+(h+16|0)|0;n[e>>2]=q(q(k*m)-q(j*l))+n[e>>2];f=f+1|0;if((f|0)!=4){continue}break}o=t-2048|0;r=t-1792|0;l=n[s+60>>2];m=n[s+56>>2];f=0;while(1){g=f<<2;e=g+h|0;j=n[g+o>>2];k=n[g+r>>2];n[e>>2]=q(q(j*m)+q(k*l))+n[e>>2];e=g+(h+16|0)|0;n[e>>2]=q(q(j*l)-q(k*m))+n[e>>2];f=f+1|0;if((f|0)!=4){continue}break}e=p(15-u|0,c)<<1;y=e+w|0,z=Oh(n[h+20>>2]),i[y>>1]=z;f=p(u+17|0,c)<<1;y=f+w|0,z=Oh(n[h+4>>2]),i[y>>1]=z;y=b+e|0,z=Oh(n[h+16>>2]),i[y>>1]=z;y=b+f|0,z=Oh(n[h>>2]),i[y>>1]=z;e=p(47-u|0,c)<<1;y=e+w|0,z=Oh(n[h+28>>2]),i[y>>1]=z;f=p(u+49|0,c)<<1;y=f+w|0,z=Oh(n[h+12>>2]),i[y>>1]=z;y=b+e|0,z=Oh(n[h+24>>2]),i[y>>1]=z;y=b+f|0,z=Oh(n[h+8>>2]),i[y>>1]=z;f=u-1|0;s=s- -64|0;if(u){continue}break}Za=h+32|0}function hq(a,b){var c=0,d=0,e=0,f=0,g=0,h=0,i=0,k=0;f=a+b|0;c=j[a+4>>2];a:{b:{if(c&1){break b}if(!(c&3)){break a}c=j[a>>2];b=c+b|0;c:{a=a-c|0;if((a|0)!=j[115943]){if(c>>>0<=255){e=j[a+8>>2];c=c>>>3|0;d=j[a+12>>2];if((d|0)!=(e|0)){break c}i=463752,k=j[115938]&MMa(-2,c),j[i>>2]=k;break b}h=j[a+24>>2];c=j[a+12>>2];d:{if((c|0)!=(a|0)){d=j[a+8>>2];j[d+12>>2]=c;j[c+8>>2]=d;break d}e:{e=a+20|0;d=j[e>>2];if(d){break e}e=a+16|0;d=j[e>>2];if(d){break e}c=0;break d}while(1){g=e;c=d;e=c+20|0;d=j[e>>2];if(d){continue}e=c+16|0;d=j[c+16>>2];if(d){continue}break}j[g>>2]=0}if(!h){break b}e=j[a+28>>2];d=(e<<2)+464056|0;f:{if(j[d>>2]==(a|0)){j[d>>2]=c;if(c){break f}i=463756,k=j[115939]&MMa(-2,e),j[i>>2]=k;break b}j[h+(j[h+16>>2]==(a|0)?16:20)>>2]=c;if(!c){break b}}j[c+24>>2]=h;d=j[a+16>>2];if(d){j[c+16>>2]=d;j[d+24>>2]=c}d=j[a+20>>2];if(!d){break b}j[c+20>>2]=d;j[d+24>>2]=c;break b}c=j[f+4>>2];if((c&3)!=3){break b}j[115940]=b;j[f+4>>2]=c&-2;j[a+4>>2]=b|1;j[f>>2]=b;return}j[e+12>>2]=d;j[d+8>>2]=e}c=j[f+4>>2];g:{if(!(c&2)){if(j[115944]==(f|0)){j[115944]=a;b=j[115941]+b|0;j[115941]=b;j[a+4>>2]=b|1;if(j[115943]!=(a|0)){break a}j[115940]=0;j[115943]=0;return}if(j[115943]==(f|0)){j[115943]=a;b=j[115940]+b|0;j[115940]=b;j[a+4>>2]=b|1;j[a+b>>2]=b;return}b=(c&-8)+b|0;h:{if(c>>>0<=255){e=j[f+8>>2];c=c>>>3|0;d=j[f+12>>2];if((d|0)==(e|0)){i=463752,k=j[115938]&MMa(-2,c),j[i>>2]=k;break h}j[e+12>>2]=d;j[d+8>>2]=e;break h}h=j[f+24>>2];c=j[f+12>>2];i:{if((f|0)!=(c|0)){d=j[f+8>>2];j[d+12>>2]=c;j[c+8>>2]=d;break i}j:{d=f+20|0;e=j[d>>2];if(e){break j}d=f+16|0;e=j[d>>2];if(e){break j}c=0;break i}while(1){g=d;c=e;d=c+20|0;e=j[d>>2];if(e){continue}d=c+16|0;e=j[c+16>>2];if(e){continue}break}j[g>>2]=0}if(!h){break h}e=j[f+28>>2];d=(e<<2)+464056|0;k:{if(j[d>>2]==(f|0)){j[d>>2]=c;if(c){break k}i=463756,k=j[115939]&MMa(-2,e),j[i>>2]=k;break h}j[h+(j[h+16>>2]==(f|0)?16:20)>>2]=c;if(!c){break h}}j[c+24>>2]=h;d=j[f+16>>2];if(d){j[c+16>>2]=d;j[d+24>>2]=c}d=j[f+20>>2];if(!d){break h}j[c+20>>2]=d;j[d+24>>2]=c}j[a+4>>2]=b|1;j[a+b>>2]=b;if(j[115943]!=(a|0)){break g}j[115940]=b;return}j[f+4>>2]=c&-2;j[a+4>>2]=b|1;j[a+b>>2]=b}if(b>>>0<=255){b=b>>>3|0;c=(b<<3)+463792|0;d=j[115938];b=1<<b;l:{if(!(d&b)){j[115938]=b|d;b=c;break l}b=j[c+8>>2]}j[c+8>>2]=a;j[b+12>>2]=a;j[a+12>>2]=c;j[a+8>>2]=b;return}e=31;j[a+16>>2]=0;j[a+20>>2]=0;if(b>>>0<=16777215){c=b>>>8|0;g=c+1048320>>>16&8;c=c<<g;e=c+520192>>>16&4;c=c<<e;d=c+245760>>>16&2;c=(c<<d>>>15|0)-(d|(e|g))|0;e=(c<<1|b>>>c+21&1)+28|0}j[a+28>>2]=e;g=(e<<2)+464056|0;m:{d=j[115939];c=1<<e;n:{if(!(d&c)){j[115939]=c|d;j[g>>2]=a;j[a+24>>2]=g;break n}e=b<<((e|0)==31?0:25-(e>>>1|0)|0);c=j[g>>2];while(1){d=c;if((j[c+4>>2]&-8)==(b|0)){break m}c=e>>>29|0;e=e<<1;g=d+(c&4)|0;c=j[g+16>>2];if(c){continue}break}j[g+16>>2]=a;j[a+24>>2]=d}j[a+12>>2]=a;j[a+8>>2]=a;return}b=j[d+8>>2];j[b+12>>2]=a;j[d+8>>2]=a;j[a+24>>2]=0;j[a+12>>2]=d;j[a+8>>2]=b}}function cD(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0;a=Za-144|0;Za=a;a:{b:{c:{d:{e:{f:{g:{h:{i:{j:{k:{l:{m:{n:{o:{p:{q:{r:{s:{t:{u:{v:{w:{x:{y:{z:{A:{B:{C:{D:{E:{if(j[19108]>=(c|0)){ou(a+96|0,c);j[114630]=0;c=E(2,a+80|0,1024)|0;d=j[114630];j[114630]=0;if((d|0)==1){break E}j[114630]=0;I(3,a+112|0,a+96|0,c|0);d=j[114630];j[114630]=0;if((d|0)==1){break D}j[114630]=0;d=E(4,a+48|0,e|0)|0;e=j[114630];j[114630]=0;if((e|0)==1){break C}j[114630]=0;e=E(2,a+32|0,1027)|0;f=j[114630];j[114630]=0;if((f|0)==1){break B}j[114630]=0;I(5,a- -64|0,d|0,e|0);f=j[114630];j[114630]=0;if((f|0)==1){break A}j[114630]=0;I(3,a+128|0,a+112|0,a- -64|0);f=j[114630];j[114630]=0;if((f|0)==1){break z}gb(a- -64|0);gb(e);gb(d);gb(a+112|0);gb(c);gb(a+96|0);if(j[b>>2]){c=j[b>>2]}else{c=1030}j[114630]=0;I(6,a+112|0,1,c|0);c=j[114630];j[114630]=0;if((c|0)==1){break t}if(j[b+4>>2]){c=j[b+4>>2]}else{c=1030}j[114630]=0;I(6,a+96|0,1,c|0);c=j[114630];j[114630]=0;if((c|0)==1){break s}b=j[b+8>>2];j[114630]=0;j[a+64>>2]=b;F(7,a+80|0,a- -64|0);b=j[114630];j[114630]=0;if((b|0)==1){break r}j[114630]=0;b=E(8,461112,1031)|0;c=j[114630];j[114630]=0;if((c|0)==1){break q}j[114630]=0;I(9,a- -64|0,0,a+112|0);c=j[114630];j[114630]=0;if((c|0)==1){break p}j[114630]=0;b=E(10,b|0,a- -64|0)|0;c=j[114630];j[114630]=0;if((c|0)==1){break o}j[114630]=0;b=E(8,b|0,1044)|0;c=j[114630];j[114630]=0;if((c|0)==1){break o}j[114630]=0;I(9,a+32|0,0,a+80|0);c=j[114630];j[114630]=0;if((c|0)==1){break n}j[114630]=0;b=E(10,b|0,a+32|0)|0;c=j[114630];j[114630]=0;if((c|0)==1){break m}j[114630]=0;b=E(8,b|0,1046)|0;c=j[114630];j[114630]=0;if((c|0)==1){break m}j[114630]=0;b=E(8,b|0,1024)|0;c=j[114630];j[114630]=0;if((c|0)==1){break m}j[114630]=0;I(9,a+16|0,0,a+128|0);c=j[114630];j[114630]=0;if((c|0)==1){break l}j[114630]=0;b=E(10,b|0,a+16|0)|0;c=j[114630];j[114630]=0;if((c|0)==1){break k}j[114630]=0;b=E(8,b|0,1048)|0;c=j[114630];j[114630]=0;if((c|0)==1){break k}j[114630]=0;I(9,a|0,0,a+96|0);c=j[114630];j[114630]=0;if((c|0)==1){break j}j[114630]=0;b=E(10,b|0,a|0)|0;c=j[114630];j[114630]=0;if((c|0)==1){break i}j[114630]=0;b=E(8,b|0,1051)|0;c=j[114630];j[114630]=0;if((c|0)==1){break i}j[114630]=0;E(11,b|0,12)|0;b=j[114630];j[114630]=0;if((b|0)==1){break i}gb(a);gb(a+16|0);gb(a+32|0);gb(a- -64|0);gb(a+80|0);gb(a+96|0);gb(a+112|0);gb(a+128|0)}Za=a+144|0;return}b=D()|0;C()|0;break u}b=D()|0;C()|0;break v}b=D()|0;C()|0;break w}b=D()|0;C()|0;break x}b=D()|0;C()|0;break y}b=D()|0;C()|0;gb(a- -64|0)}gb(e)}gb(d)}gb(a+112|0)}gb(c)}gb(a+96|0);break a}b=D()|0;C()|0;break b}b=D()|0;C()|0;break c}b=D()|0;C()|0;break d}b=D()|0;C()|0;break e}b=D()|0;C()|0;break e}b=D()|0;C()|0;break f}b=D()|0;C()|0;break f}b=D()|0;C()|0;break g}b=D()|0;C()|0;break g}b=D()|0;C()|0;break h}b=D()|0;C()|0;break h}b=D()|0;C()|0;gb(a)}gb(a+16|0)}gb(a+32|0)}gb(a- -64|0)}gb(a+80|0)}gb(a+96|0)}gb(a+112|0)}gb(a+128|0)}G(b|0);z()}function sQ(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,k=0,m=0,n=0,o=0,p=0;e=Za-144|0;Za=e;m=TFa(e+128|0);a:{b:{c:{if(d){j[114630]=0;I(710,a|0,m|0,c|0);c=j[114630];j[114630]=0;if((c|0)!=1){break c}break b}j[114630]=0;I(711,a|0,m|0,c|0);c=j[114630];j[114630]=0;if((c|0)==1){break b}}d=yv(e+112|0);d:{e:{if(l[b+480192>>1]){c=1;n=1;while(1){j[114630]=0;i[e+110>>1]=0;E(712,a|0,e+110|0)|0;k=j[114630];j[114630]=0;f:{g:{h:{i:{j:{k:{l:{m:{n:{o:{p:{q:{r:{s:{t:{u:{if((k|0)!=1){j[114630]=0;k=E(713,m|0,e+110|0)|0;f=j[114630];j[114630]=0;if((f|0)==1){break e}j[e+104>>2]=k;k=((c<<2)+b|0)+900380|0;if(!j[k>>2]){break f}c=ii(m);j[114630]=0;j[e+88>>2]=c;c=E(714,e+104|0,e+88|0)|0;f=j[114630];j[114630]=0;if((f|0)==1){break u}if(!c){break g}j[114630]=0;c=H(715,e+104|0)|0;f=j[114630];j[114630]=0;if((f|0)==1){break t}j[114630]=0;c=E(4,e+88|0,c+4|0)|0;f=j[114630];j[114630]=0;if((f|0)==1){break t}j[114630]=0;f=E(2,e+72|0,14549)|0;g=j[114630];j[114630]=0;if((g|0)==1){break i}g=ip(c,f);gb(f);if(!g){break s}j[j[k>>2]+44>>2]=0;break r}b=D()|0;C()|0;break d}b=D()|0;C()|0;break d}b=D()|0;C()|0;break d}f=j[b+4>>2];j[114630]=0;f=E(716,f|0,c|0)|0;g=j[114630];j[114630]=0;v:{w:{x:{y:{z:{A:{if((g|0)!=1){j[j[k>>2]+44>>2]=f;if(j[j[k>>2]+44>>2]){break r}j[114630]=0;f=E(2,e+72|0,14569)|0;g=j[114630];j[114630]=0;if((g|0)==1){break A}B:{C:{if(ip(c,f)){gb(f);break C}j[114630]=0;g=E(2,e+56|0,14595)|0;h=j[114630];j[114630]=0;if((h|0)==1){break z}h=ip(c,g);gb(g);gb(f);if(!h){break B}}j[114630]=0;F(717,e+72|0,c|0);f=j[114630];j[114630]=0;if((f|0)==1){break y}g=j[b+4>>2];f=hp(e+48|0,e+72|0);j[114630]=0;g=E(718,g|0,f|0)|0;h=j[114630];j[114630]=0;if((h|0)==1){break x}Kf(f);Kf(e+72|0);if(g){break r}}o=e,p=PFa(Lb(d),Mb(d),c),j[o+72>>2]=p;o=e,p=Mb(d),j[o+56>>2]=p;if(!el(e+72|0,e+56|0)){break v}j[114630]=0;F(719,d|0,c|0);f=j[114630];j[114630]=0;if((f|0)!=1){break w}}b=D()|0;C()|0;break h}b=D()|0;C()|0;break h}b=D()|0;C()|0;gb(f);break h}b=D()|0;C()|0;break h}b=D()|0;C()|0;Kf(f);Kf(e+72|0);break h}j[114630]=0;f=E(2,e+16|0,14601)|0;g=j[114630];j[114630]=0;if((g|0)==1){break q}j[114630]=0;I(720,e+32|0,f|0,c|0);g=j[114630];j[114630]=0;if((g|0)==1){break p}j[114630]=0;g=E(2,e|0,14610)|0;h=j[114630];j[114630]=0;if((h|0)==1){break o}j[114630]=0;I(3,e+56|0,e+32|0,g|0);h=j[114630];j[114630]=0;if((h|0)==1){break n}h=oy(e+72|0,e+56|0);j[114630]=0;F(624,b|0,h|0);h=j[114630];j[114630]=0;if((h|0)==1){break m}gb(e+72|0);gb(e+56|0);gb(g);gb(e+32|0);gb(f)}j[j[k>>2]+44>>2]=0}gb(c);break f}b=D()|0;C()|0;break h}b=D()|0;C()|0;break j}b=D()|0;C()|0;break k}b=D()|0;C()|0;break l}b=D()|0;C()|0;gb(e+72|0);gb(e+56|0)}gb(g)}gb(e+32|0)}gb(f);break h}b=D()|0;C()|0}gb(c);break d}if(!j[k>>2]){break f}j[j[k>>2]+44>>2]=0}n=n+1|0;c=n&65535;if(c>>>0<=l[b+480192>>1]){continue}break}}Rk(d);nQ(m);Za=e+144|0;return}b=D()|0;C()|0}Rk(d);break a}b=D()|0;C()|0}nQ(m);G(b|0);z()}function oG(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0;f=Za-224|0;Za=f;j[f+216>>2]=c;j[f+220>>2]=d;a:{if(Ri(b)){break a}d=k[Fj(b)|0];c=1;b:{if((d|0)==33){break b}if((d|0)!=63){break a}c=0}e=c;Qj(f+184|0,b,j[b+4>>2]-1|0);c=j[f+188>>2];j[b>>2]=j[f+184>>2];j[b+4>>2]=c}ld(f+184|0);c=j[f+184>>2];ld(f+168|0);g=Ej(c,j[f+172>>2],b);ld(f+184|0);c=j[b>>2];d=j[b+4>>2];c:{d:{e:{f:{if((g|0)==j[f+188>>2]){j[f+208>>2]=c;j[f+212>>2]=d;a=_b(f+200|0,38235);c=j[f+212>>2];j[f+16>>2]=j[f+208>>2];j[f+20>>2]=c;c=j[a+4>>2];j[f+8>>2]=j[a>>2];j[f+12>>2]=c;if(nc(f+16|0,f+8|0)){a=R(8)|0;j[114630]=0;F(2137,f+168|0,f+216|0);b=j[114630];j[114630]=0;g:{h:{i:{if((b|0)!=1){j[114630]=0;I(2113,f+184|0,39307,f+168|0);b=j[114630];j[114630]=0;if((b|0)==1){break i}Wb(a,f+184|0);e=0;j[114630]=0;I(2004,a|0,83648,2012);b=j[114630];j[114630]=0;if((b|0)!=1){break e}b=D()|0;C()|0;gb(f+184|0);break h}b=D()|0;C()|0;break g}b=D()|0;e=1;C()|0}gb(f+168|0);if(!e){break f}}S(a|0);break f}if(!e){break c}c=R(8)|0;j[114630]=0;d=E(2136,f+136|0,b|0)|0;b=j[114630];j[114630]=0;a=1;j:{k:{l:{m:{n:{o:{p:{q:{r:{if((b|0)!=1){j[114630]=0;I(2113,f+152|0,39186,d|0);a=j[114630];j[114630]=0;if((a|0)==1){break r}j[114630]=0;I(2131,f+168|0,f+152|0,39322);b=j[114630];j[114630]=0;a=1;if((b|0)==1){break q}j[114630]=0;F(2137,f+120|0,f+216|0);a=j[114630];j[114630]=0;if((a|0)==1){break p}j[114630]=0;I(138,f+184|0,f+168|0,f+120|0);b=j[114630];j[114630]=0;a=1;if((b|0)==1){break o}Wb(c,f+184|0);j[114630]=0;I(2004,c|0,83648,2012);a=j[114630];j[114630]=0;if((a|0)!=1){break e}b=D()|0;C()|0;gb(f+184|0);a=0;break n}b=D()|0;C()|0;break j}b=D()|0;a=1;C()|0;break k}b=D()|0;C()|0;break l}b=D()|0;a=1;C()|0;break m}b=D()|0;C()|0}gb(f+120|0)}gb(f+168|0)}gb(f+152|0)}gb(d)}if(!a){break f}S(c|0);break f}j[f+112>>2]=c;j[f+116>>2]=d;c=_b(f+104|0,38235);d=j[f+116>>2];j[f+64>>2]=j[f+112>>2];j[f+68>>2]=d;d=j[c+4>>2];j[f+56>>2]=j[c>>2];j[f+60>>2]=d;if(!nc(f- -64|0,f+56|0)){break d}a=R(8)|0;j[114630]=0;F(2137,f+168|0,f+216|0);b=j[114630];j[114630]=0;s:{t:{u:{if((b|0)!=1){j[114630]=0;I(2113,f+184|0,39307,f+168|0);b=j[114630];j[114630]=0;if((b|0)==1){break u}Wb(a,f+184|0);e=0;j[114630]=0;I(2004,a|0,83648,2012);b=j[114630];j[114630]=0;if((b|0)!=1){break e}b=D()|0;C()|0;gb(f+184|0);break t}b=D()|0;C()|0;break s}b=D()|0;e=1;C()|0}gb(f+168|0);if(!e){break f}}S(a|0)}G(b|0)}z()}c=j[b+4>>2];j[f+96>>2]=j[b>>2];j[f+100>>2]=c;c=_b(f+88|0,39021);d=j[f+100>>2];j[f+48>>2]=j[f+96>>2];j[f+52>>2]=d;d=j[c+4>>2];j[f+40>>2]=j[c>>2];j[f+44>>2]=d;if(nc(f+48|0,f+40|0)){aG(a,ic(j[f+216>>2],j[f+220>>2]));break c}c=j[b+4>>2];j[f+80>>2]=j[b>>2];j[f+84>>2]=c;b=_b(f+72|0,39169);c=j[f+84>>2];j[f+32>>2]=j[f+80>>2];j[f+36>>2]=c;c=j[b+4>>2];j[f+24>>2]=j[b>>2];j[f+28>>2]=c;if(!nc(f+32|0,f+24|0)){break c}b=ic(j[f+216>>2],j[f+220>>2]);j[j[a+32>>2]+40>>2]=b>>>0>3?1:b}Za=f+224|0}function Wia(a,b,c){var d=0,e=0,f=0,g=0,h=0,m=0;d=Za-80|0;Za=d;g=i[b+28>>1];e=i[c>>1];f=b+4|0;sb(f);a:{b:{if((e|0)>=(g|0)){if((e|0)<=(l[b+28>>1]+sb(f)<<16)-65536>>16){break b}}Qc(a);break a}c:{e=i[b+30>>1];if(!e){b=b+52|0;h=d,m=tw(b,c),j[h+56>>2]=m;h=d,m=ii(b),j[h+40>>2]=m;if(!hi(d+56|0,d+40|0)){break c}Cf(a,Sg(d+56|0)+4|0);break a}f=d;g=i[c>>1];d:{if((g|0)>=0){g=(g|0)%(e|0)|0;break d}g=e+((g^-1)%(e|0)^-1)|0}i[f+78>>1]=g;e=Qc(a);j[114630]=0;g=b+52|0;f=E(1594,g|0,d+78|0)|0;a=j[114630];j[114630]=0;e:{f:{g:{h:{i:{j:{k:{l:{m:{n:{o:{p:{q:{r:{s:{t:{u:{if((a|0)==1){break u}j[d+72>>2]=f;a=ii(g);j[114630]=0;j[d+56>>2]=a;f=E(1595,d+72|0,d+56|0)|0;a=j[114630];j[114630]=0;if((a|0)==1){break f}if(f){j[114630]=0;f=H(1596,d+72|0)|0;a=j[114630];j[114630]=0;if((a|0)==1){break u}j[114630]=0;E(237,e|0,f+4|0)|0;a=j[114630];j[114630]=0;if((a|0)==1){break u}b=i[b+30>>1];a=i[c>>1];v:{if((a|0)>=0){a=(a|0)/(b|0)|0;break v}a=((a+1|0)/(b|0)|0)-1|0}j[114630]=0;j[d+40>>2]=a+5;F(234,d+56|0,d+40|0);a=j[114630];j[114630]=0;w:{if((a|0)!=1){j[114630]=0;E(192,e|0,d+56|0)|0;a=j[114630];j[114630]=0;if((a|0)==1){break w}gb(d+56|0);break a}b=D()|0;C()|0;break e}b=D()|0;C()|0;gb(d+56|0);break e}if(i[b+30>>1]>26){break r}j[114630]=0;f=K(798,d+40|0,1,(k[d+78|0]<<24)+1090519040>>24)|0;a=j[114630];j[114630]=0;if((a|0)==1){break t}j[114630]=0;I(13,d+56|0,0,f|0);a=j[114630];j[114630]=0;if((a|0)==1){break s}ob(e,d+56|0);gb(d+56|0);gb(f);j[114630]=0;E(235,e|0,32403)|0;a=j[114630];j[114630]=0;if((a|0)!=1){break q}}b=D()|0;C()|0;break e}b=D()|0;C()|0;break e}b=D()|0;C()|0;gb(f);break e}j[114630]=0;j[d+36>>2]=i[d+78>>1]%16;F(1597,d+40|0,d+36|0);a=j[114630];j[114630]=0;if((a|0)==1){break p}j[114630]=0;j[d+20>>2]=(i[d+78>>1]/16<<16>>16)%16;F(1597,d+24|0,d+20|0);a=j[114630];j[114630]=0;if((a|0)==1){break o}j[114630]=0;I(3,d+56|0,d+40|0,d+24|0);a=j[114630];j[114630]=0;if((a|0)==1){break n}ob(e,d+56|0);gb(d+56|0);gb(d+24|0);gb(d+40|0);if(i[d+78>>1]<256){break q}j[114630]=0;I(9,d+8|0,0,e|0);a=j[114630];j[114630]=0;if((a|0)==1){break l}j[114630]=0;F(1598,d+40|0,d+8|0);a=j[114630];j[114630]=0;if((a|0)==1){break k}j[114630]=0;I(13,d+56|0,0,d+40|0);a=j[114630];j[114630]=0;if((a|0)==1){break j}ob(e,d+56|0);gb(d+56|0);gb(d+40|0);gb(d+8|0)}b=i[b+30>>1];a=i[c>>1];if((a|0)<0){break h}a=(a|0)/(b|0)|0;break g}b=D()|0;C()|0;break e}b=D()|0;C()|0;break m}b=D()|0;C()|0;gb(d+24|0)}gb(d+40|0);break e}b=D()|0;C()|0;break e}b=D()|0;C()|0;break i}b=D()|0;C()|0;gb(d+40|0)}gb(d+8|0);break e}a=((a+1|0)/(b|0)|0)-1|0}j[114630]=0;j[d+40>>2]=a+5;F(234,d+56|0,d+40|0);a=j[114630];j[114630]=0;x:{if((a|0)!=1){j[114630]=0;E(192,e|0,d+56|0)|0;a=j[114630];j[114630]=0;if((a|0)==1){break x}gb(d+56|0);break a}b=D()|0;C()|0;break e}b=D()|0;C()|0;gb(d+56|0);break e}b=D()|0;C()|0}gb(e);G(b|0);z()}b=Za-16|0;Za=b;uha(a,c);Za=b+16|0}Za=d+80|0}function pma(a,b){var c=0,d=0,e=0,f=0,g=0,h=0,i=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;m=Za-16|0;Za=m;a:{b:{c:{if(!j[a+1074376>>2]){n=a+1074448|0;c=n;j[c>>2]=0;j[c+4>>2]=0;j[a+1074456>>2]=j[a+1074444>>2];break c}h=j[a+1074456>>2];c=j[a+1074444>>2];d:{if((h|0)==(c|0)){c=j[a+1074448>>2];break d}j[a+1074456>>2]=c;e=a+24604|0;d=a+1074448|0;e:{if((c|0)>(h|0)){c=DM(e);break e}c=CM(e)}j[d>>2]=c;j[a+1074452>>2]=c}n=a+1074448|0;if((c|0)>=1){break b}}break a}h=(j[a+1074456>>2]<<12)-j[a+1074460>>2]|0;l=(h|0)/(c|0)|0;if(j[a+1074368>>2]!=2){break a}j[m+12>>2]=50;j[m+8>>2]=1e4/(j[a+1074452>>2]+1|0);g=j[zf(m+12|0,m+8|0)>>2];c=l>>31;if((g|0)>=(c+l^c)){break a}c=j[a+1074448>>2];f=j[a+1074452>>2];while(1){c=c+f|0;l=(h|0)/(c|0)|0;e=l>>31;if((g|0)<(e^e+l)){continue}break}j[n>>2]=c}f:{g:{switch(j[a+24624>>2]-1|0){case 0:if((b|0)<1){break f}e=j[a+1074444>>2];f=e<<12;c=a+12|0;h=e;d=e>>31;g=0;while(1){h:{if(j[n>>2]>=1){e=j[a+1074460>>2]+l|0;j[a+1074460>>2]=e;k=j[c>>2];p=c,q=ic(IMa(HMa(k,k>>31,e,e>>31),ab,1048576,0),ab),j[p>>2]=q;j[a+1074448>>2]=j[a+1074448>>2]-1;break h}e=j[c>>2];p=c,q=ic(IMa(HMa(e,e>>31,h,d),ab,256,0),ab),j[p>>2]=q;j[a+1074460>>2]=f}c=c+4|0;g=g+1|0;if((g|0)!=(b|0)){continue}break}break f;case 1:if((b|0)<1){break f}e=j[a+1074444>>2];d=e<<12;c=a+12|0;h=e;e=e>>31;g=0;while(1){i:{if(j[n>>2]>=1){f=j[a+1074460>>2]+l|0;j[a+1074460>>2]=f;k=j[c>>2];p=c,q=ic(IMa(HMa(k,k>>31,f,f>>31),ab,1048576,0),ab),j[p>>2]=q;f=j[a+1074460>>2];i=f;k=f>>31;f=j[c+4>>2];p=c,q=ic(IMa(HMa(i,k,f,f>>31),ab,1048576,0),ab),j[p+4>>2]=q;j[a+1074448>>2]=j[a+1074448>>2]-1;break i}f=j[c>>2];p=c,q=ic(IMa(HMa(f,f>>31,h,e),ab,256,0),ab),j[p>>2]=q;f=j[c+4>>2];p=c,q=ic(IMa(HMa(f,f>>31,h,e),ab,256,0),ab),j[p+4>>2]=q;j[a+1074460>>2]=d}c=c+8|0;g=g+1|0;if((g|0)!=(b|0)){continue}break}break f;case 3:break g;default:break f}}if((b|0)<1){break f}h=j[a+1074444>>2];k=h<<12;c=a+12|0;g=a+8204|0;e=h;h=e>>31;f=0;while(1){j:{if(j[n>>2]>=1){d=j[a+1074460>>2]+l|0;j[a+1074460>>2]=d;i=j[c>>2];p=c,q=ic(IMa(HMa(i,i>>31,d,d>>31),ab,1048576,0),ab),j[p>>2]=q;d=j[a+1074460>>2];i=d;o=d>>31;d=j[c+4>>2];p=c,q=ic(IMa(HMa(i,o,d,d>>31),ab,1048576,0),ab),j[p+4>>2]=q;d=j[a+1074460>>2];i=d;o=d>>31;d=j[g>>2];p=g,q=ic(IMa(HMa(i,o,d,d>>31),ab,1048576,0),ab),j[p>>2]=q;d=j[a+1074460>>2];i=d;o=d>>31;d=j[g+4>>2];p=g,q=ic(IMa(HMa(i,o,d,d>>31),ab,1048576,0),ab),j[p+4>>2]=q;j[a+1074448>>2]=j[a+1074448>>2]-1;break j}d=j[c>>2];p=c,q=ic(IMa(HMa(d,d>>31,e,h),ab,256,0),ab),j[p>>2]=q;d=j[c+4>>2];p=c,q=ic(IMa(HMa(d,d>>31,e,h),ab,256,0),ab),j[p+4>>2]=q;d=j[g>>2];p=g,q=ic(IMa(HMa(d,d>>31,e,h),ab,256,0),ab),j[p>>2]=q;d=j[g+4>>2];p=g,q=ic(IMa(HMa(d,d>>31,e,h),ab,256,0),ab),j[p+4>>2]=q;j[a+1074460>>2]=k}g=g+8|0;c=c+8|0;f=f+1|0;if((f|0)!=(b|0)){continue}break}}Za=m+16|0}function fU(a,b){var c=0,d=0,e=0,f=0,g=0,i=0,o=0,r=0,s=q(0),t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=q(0),E=0,F=0;i=b<<2;z=l[a+480214>>1]!=0;d=a+1074328|0;s=n[d>>2];D=n[d+4>>2];while(1){f=(p(e,160)+a|0)+906300|0;d=j[f>>2];a:{if(!d|!j[d+24>>2]){break a}if(!Xg(d+44|0)){break a}g=j[f>>2];if(!(bb[j[j[g>>2]+108>>2]](g)|0)){bb[j[j[g>>2]+104>>2]](g,1);bb[j[j[g>>2]+116>>2]](g)}d=g+44|0;w=wd(d,0);r=wd(d,1);b:{if(h[g+28|0]&1){Ox(j[g+24>>2],w,r,b,s);break b}d=g+40|0;if(!(j[g+36>>2]?0:!j[d>>2])){Vm(j[g+24>>2],b,d,g+36|0);Ox(j[g+24>>2],w,r,b,s);break b}Ab(w,0,i);Ab(r,0,i)}j[g+28>>2]=j[g+28>>2]&-2;if(St(f)){break a}z=!(k[g+28|0]&4)|z}e=e+1|0;if((e|0)!=250){continue}break}B=a+12|0;g=a+12300|0;w=a+14348|0;Ox(B,g,w,b,s);d=a+1074464|0;E=k[d|0];h[d|0]=0;i=g;d=w;while(1){o=(p(v,160)+a|0)+906300|0;f=j[o>>2];c:{if(!f|!j[f+24>>2]){break c}if(!Xg(f+44|0)){break c}x=j[o>>2];d:{if(St(o)){break d}f=j[o>>2];if(bb[j[j[f>>2]+140>>2]](f)|k[j[o>>2]+28|0]&2){break d}e=0;if(!v){break c}while(1){if((fj((p(e,160)+a|0)+906300|0)|0)==(v|0)){break d}e=e+1|0;if((v|0)!=(e|0)){continue}break}break c}f=x+44|0;A=wd(f,0);C=wd(f,1);u=j[o>>2];t=(i|0)==(A|0);i=t?g:i;r=i;d=t?w:d;c=o+28|0;f=d;e:{if(!(k[c|0]|k[c+1|0]<<8|(k[c+2|0]<<16|k[c+3|0]<<24))){break e}r=i;c=fj(o);f=d;if(c>>>0<=v>>>0){break e}f=d;if((c|0)==255){break e}c=j[(p(c,160)+a|0)+906300>>2];f=d;if(!c){break e}if(!(k[u+28|0]&4)){bb[j[j[c>>2]+144>>2]](c)}c=c+44|0;f=d;if(!Xg(c)){break e}r=wd(c,0);f=wd(c,1)}f:{if(!St(o)){break f}g:{if(t){break g}e=0;if(!b){break g}while(1){y=e<<2;c=y+A|0;t=i+y|0;n[c>>2]=n[c>>2]+n[t>>2];c=y+C|0;F=c;s=n[c>>2];c=d+y|0;n[F>>2]=s+n[c>>2];j[t>>2]=0;j[c>>2]=0;e=e+1|0;if((e|0)!=(b|0)){continue}break}}d=f;i=r;if(!(z&1)){break f}i=j[o>>2];if(i){bb[j[j[i>>2]+144>>2]](i)}i=r;e=fj(o);if(e>>>0>249|e>>>0<=v>>>0){break f}while(1){i=e&255;d=(p(i,160)+a|0)+906300|0;e=fj(d);d=j[d>>2];if(d){bb[j[j[d>>2]+144>>2]](d)}if(e>>>0>i>>>0?e>>>0<=249:0){continue}break}d=f;i=r}h:{i:{if(!((k[o+24|0]&2)>>>1|0)){if(!zA(o)|!(k[u+28|0]&4)){break i}}e=0;if(!b){break h}while(1){t=e<<2;c=t+r|0;n[c>>2]=n[c>>2]+n[t+A>>2];c=f+t|0;n[c>>2]=n[c>>2]+n[t+C>>2];e=e+1|0;if((e|0)!=(b|0)){continue}break}break h}if(E){bb[j[j[x>>2]+124>>2]](x)}bb[j[j[x>>2]+60>>2]](x,r,f,b);j[u+32>>2]=j[u+32>>2]+b;if(!zA(o)){break h}if((bb[j[j[x>>2]+152>>2]](x)|0)<1|m[u+32>>2]<j[a+24620>>2]<<2>>>0){break h}e=0;j:{if(!b){break j}while(1){k:{c=e<<2;s=n[c+r>>2];if(s>=q(1.1920928955078125e-7)|s<=q(-1.1920928955078125e-7)){break k}s=n[c+f>>2];if(s>=q(1.1920928955078125e-7)|!(s>q(-1.1920928955078125e-7))){break k}e=e+1|0;if((e|0)!=(b|0)){continue}break j}break}j[u+32>>2]=0;break h}j[u+28>>2]=j[u+28>>2]|4}j[u+28>>2]=j[u+28>>2]&-3}v=v+1|0;if((v|0)!=250){continue}break}iua(i,d,B,b,D)}function p0(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var i=0,k=0,l=0,m=0;h=Za+ -64|0;Za=h;j[h+56>>2]=b;j[e>>2]=0;hc(h,d);j[114630]=0;i=H(2450,h|0)|0;k=j[114630];j[114630]=0;a:{b:{c:{d:{e:{f:{g:{h:{i:{j:{k:{l:{m:{n:{o:{p:{q:{r:{s:{t:{u:{v:{w:{x:{y:{z:{A:{if((k|0)!=1){wb(h);switch(g-65|0){case 54:break j;case 19:break k;case 18:break l;case 17:break m;case 49:break n;case 47:break o;case 45:case 51:break p;case 12:break q;case 44:break r;case 41:break s;case 8:break t;case 7:break u;case 5:break v;case 3:break w;case 35:case 36:break x;case 34:break y;case 1:case 33:case 39:break z;case 0:case 32:break A;case 2:case 4:case 6:case 9:case 10:case 11:case 13:case 14:case 15:case 16:case 20:case 21:case 22:case 25:case 26:case 27:case 28:case 29:case 30:case 31:case 37:case 38:case 40:case 42:case 43:case 46:case 48:case 50:case 52:case 53:break d;case 24:break f;case 56:break g;case 23:break h;case 55:break i;default:break e}}a=D()|0;C()|0;wb(h);G(a|0);z()}WC(a,f+24|0,h+56|0,c,e,i);break b}VC(a,f+16|0,h+56|0,c,e,i);break b}b=bb[j[j[a+8>>2]+12>>2]](a+8|0)|0;l=h,m=Fi(a,j[h+56>>2],c,d,e,f,zb(b),zb(b)+(nb(b)<<2)|0),j[l+56>>2]=m;break b}o0(f+12|0,h+56|0,c,e,i);break b}g=j[16131];j[h+24>>2]=j[16130];j[h+28>>2]=g;g=j[16129];j[h+16>>2]=j[16128];j[h+20>>2]=g;g=j[16127];j[h+8>>2]=j[16126];j[h+12>>2]=g;g=j[16125];j[h>>2]=j[16124];j[h+4>>2]=g;l=h,m=Fi(a,b,c,d,e,f,h,h+32|0),j[l+56>>2]=m;break b}g=j[16139];j[h+24>>2]=j[16138];j[h+28>>2]=g;g=j[16137];j[h+16>>2]=j[16136];j[h+20>>2]=g;g=j[16135];j[h+8>>2]=j[16134];j[h+12>>2]=g;g=j[16133];j[h>>2]=j[16132];j[h+4>>2]=g;l=h,m=Fi(a,b,c,d,e,f,h,h+32|0),j[l+56>>2]=m;break b}n0(f+8|0,h+56|0,c,e,i);break b}m0(f+8|0,h+56|0,c,e,i);break b}l0(f+28|0,h+56|0,c,e,i);break b}j0(f+16|0,h+56|0,c,e,i);break b}i0(f+4|0,h+56|0,c,e,i);break b}h0(h+56|0,c,e,i);break b}g0(a,f+8|0,h+56|0,c,e,i);break b}g=Vb(h,64560,44);l=g,m=Fi(a,b,c,d,e,f,g,g+44|0),j[l+56>>2]=m;break b}j[h+16>>2]=j[16156];g=j[16155];j[h+8>>2]=j[16154];j[h+12>>2]=g;g=j[16153];j[h>>2]=j[16152];j[h+4>>2]=g;l=h,m=Fi(a,b,c,d,e,f,h,h+20|0),j[l+56>>2]=m;break b}f0(f,h+56|0,c,e,i);break b}g=j[16167];j[h+24>>2]=j[16166];j[h+28>>2]=g;g=j[16165];j[h+16>>2]=j[16164];j[h+20>>2]=g;g=j[16163];j[h+8>>2]=j[16162];j[h+12>>2]=g;g=j[16161];j[h>>2]=j[16160];j[h+4>>2]=g;l=h,m=Fi(a,b,c,d,e,f,h,h+32|0),j[l+56>>2]=m;break b}e0(f+24|0,h+56|0,c,e,i);break b}a=bb[j[j[a>>2]+20>>2]](a,b,c,d,e,f)|0;break a}b=bb[j[j[a+8>>2]+24>>2]](a+8|0)|0;l=h,m=Fi(a,j[h+56>>2],c,d,e,f,zb(b),zb(b)+(nb(b)<<2)|0),j[l+56>>2]=m;break b}UC(f+20|0,h+56|0,c,e,i);break b}d0(f+20|0,h+56|0,c,e,i);break b}if((g|0)==37){break c}}j[e>>2]=j[e>>2]|4;break b}c0(h+56|0,c,e,i)}a=j[h+56>>2]}Za=h- -64|0;return a|0}function Tna(a){a=a|0;var b=0,c=0,d=0,e=0,f=0,g=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0;j[a+24588>>2]=0;j[a+24592>>2]=0;j[a+4>>2]=0;j[a>>2]=20768;j[a+8>>2]=j[19867];b=a+24596|0;j[b>>2]=0;j[b+4>>2]=0;Uo(a+24604|0);_J(a+24648|0,0);tea(a+393352|0);j[a+480224>>2]=0;i[a+480212>>1]=0;j[a+480204>>2]=0;j[a+480208>>2]=0;j[a+480180>>2]=0;j[a+480184>>2]=0;b=a+480186|0;i[b>>1]=0;i[b+2>>1]=0;i[b+4>>1]=0;i[b+6>>1]=0;j[a+480240>>2]=65536;j[a+480244>>2]=65536;n=hx(a+480248|0);j[a+480272>>2]=0;f=a+484344|0;b=a+480280|0;a:{b:{c:{d:{e:{f:{g:{h:{i:{j:{k:{l:{while(1){j[114630]=0;b=H(1385,b|0)|0;d=j[114630];j[114630]=0;if((d|0)==1){break l}b=b+32|0;if((f|0)!=(b|0)){continue}break}f=a+484344|0;Kma(f);j[f+12>>2]=a;j[114630]=0;o=E(1386,a+484360|0,a|0)|0;b=j[114630];j[114630]=0;if((b|0)==1){break k}d=a+900380|0;b=a+484380|0;while(1){j[114630]=0;b=E(1008,b|0,0)|0;g=j[114630];j[114630]=0;if((g|0)==1){break j}b=b+104|0;if((d|0)!=(b|0)){continue}break}j[114630]=0;H(1387,a+901404|0)|0;b=j[114630];j[114630]=0;if((b|0)==1){break i}d=a+946300|0;g=a+906300|0;b=0;while(1){j[114630]=0;c=(p(b,160)+a|0)+906300|0;H(1388,c|0)|0;e=j[114630];j[114630]=0;if((e|0)==1){break h}b=b+1|0;if((b|0)!=250){continue}break}c=a+1074300|0;e=a+946300|0;b=e;while(1){j[114630]=0;b=H(1157,b|0)|0;k=j[114630];j[114630]=0;if((k|0)==1){break g}b=b+32|0;if((c|0)!=(b|0)){continue}break}j[a+1074300>>2]=0;j[a+1074304>>2]=0;gx(a+1074308|0);j[114630]=0;b=T(1389)|0;c=j[114630];j[114630]=0;if((c|0)==1){break f}j[114630]=0;b=H(1390,b|0)|0;c=j[114630];j[114630]=0;if((c|0)==1){break f}j[a+1074324>>2]=b;j[114630]=0;H(1391,a+1074328|0)|0;b=j[114630];j[114630]=0;if((b|0)==1){break f}j[114630]=0;H(1392,a+1074376|0)|0;b=j[114630];j[114630]=0;if((b|0)==1){break f}j[114630]=0;c=K(1328,a+1304360|0,a|0,255)|0;b=j[114630];j[114630]=0;if((b|0)==1){break f}k=Pna(a+1304392|0);q=Ona(a+1304396|0);r=Cb(a+1304400|0);s=Qc(a+1304412|0);l=a+1304424|0;Cb(l);t=XJ(a+1304436|0);m=a+1304500|0;Kna(m);h[a+1304512|0]=0;Nna(a+1304520|0);j[a+1304560>>2]=0;wo(a+12|0);Vo(a+8204|0);Vo(a+12300|0);b=a+1074408|0;j[b>>2]=4;j[b+4>>2]=16;j[a+480216>>2]=4;j[a+480220>>2]=16;WJ(a+900380|0);j[114630]=0;N(1393,e|0);b=j[114630];j[114630]=0;if((b|0)==1){break e}j[114630]=0;b=H(1394,12)|0;e=j[114630];j[114630]=0;if((e|0)==1){break e}j[b>>2]=0;j[b+4>>2]=0;j[b+8>>2]=0;Ima(b);j[a+4>>2]=b;return a|0}a=D()|0;C()|0;break a}a=D()|0;C()|0;break b}a=D()|0;C()|0;break c}a=D()|0;C()|0;break c}a=D()|0;C()|0;if(!b){break c}while(1){c=Bm(c-160|0);if((g|0)!=(c|0)){continue}break}break c}a=D()|0;C()|0;break d}a=D()|0;C()|0;break d}a=D()|0;C()|0;fx(m);Kr(t);gb(l);gb(s);gb(r);Jr(q);Ir(k);Co(c)}while(1){d=Bm(d-160|0);if((g|0)!=(d|0)){continue}break}}hs(o)}ex(f)}Ud(n);G(a|0);z()}function wMa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0;e=Za-576|0;Za=e;rc(b);d=e+72|0;g=rMa(b,d);if(!g){lT(d)}a:{if(!g){break a}if(!qT(e+72|0)){break a}b:{if(!c){break b}if(!yb(b,Tc(pT(e+72|0),ab))){break a}od(a,64);j[a+480260>>2]=112;j[a+480264>>2]=13696;j[a+480204>>2]=78e4;j[a+480196>>2]=4;i[a+480188>>1]=8;d=Db(e+40|0,11897);ob(a+1304436|0,d);gb(d);d=Db(e+40|0,11910);ob(a+1304448|0,d);gb(d);vc(a+1304460|0,l[e+72>>1]==26217?11897:11914);j[a+1304496>>2]=4;d=k[e+182|0];i[a+480190>>1]=d;c:{d:{e:{f:{if(d){f=1;g=1;while(1){uMa(b,e+40|0);if((k[e+53|0]|k[e+54|0]<<8|(k[e+55|0]<<16|k[e+56|0]<<24))>>>0>67108863){break d}vMa(e+40|0,(p(f,104)+a|0)+484380|0);si(e+8|0,2,e+40|0);qc(e+24|0,e+8|0);j[114630]=0;E(369,((f<<5)+a|0)+946300|0,e+24|0)|0;d=j[114630];j[114630]=0;if((d|0)==1){break f}gb(e+24|0);g=g+1|0;f=g&65535;if(f>>>0<=l[a+480190>>1]){continue}break}}d=e+72|2;oT(e+24|0,3,d,36);qc(e+40|0,e+24|0);ob(a+1304400|0,e+40|0);gb(e+40|0);f=0;IM(a+1304424|0,lb(d),108,36,0);d=a+484360|0;nT(Eb(d),e+185|0,128);if(l[bc(Eb(d),k[e+184|0])>>1]<k[e+183|0]){break e}break c}a=D()|0;C()|0;gb(e+24|0);G(a|0);z()}Fe(Eb(d),k[e+184|0]);break c}f=0;break a}while(1){d=(f<<5)+a|0;wg(d+480280|0);i[d+480284>>1]=f&1?208:48;f=f+1|0;if((f|0)!=8){continue}break}q=a+484344|0;Jf(q,k[e+183|0]);if(k[e+183|0]){t=c&1;while(1){g:{h:{if(t){if(Wf(q,m&65535,64)){break h}}Jb(b,1536);break g}j[e+24>>2]=-1;j[e+28>>2]=-1;r=0;while(1){f=Fp(Hb(q,m),r);g=0;while(1){Bt(e+40|0,b);d=Pc(e+40|0);n=Bf(e+40|0);o=k[d|0];s=e+40|0;d=k[s|0];if(d>>>0<=253){h[f|0]=(d>>>2|0)+37;h[f+1|0]=(d<<4&48|o>>>4)+1;h[(e+24|0)+g|0]=255;d=k[s|0]}if((d|0)!=255){h[f+2|0]=1;h[f+4|0]=(((o&15)<<6|8)>>>0)/15}o=(e+24|0)+g|0;i:{j:{d=k[n|0];k:{if((d|0)!=255){h[o|0]=d;if(d&15|(d|0)==48){break k}break j}d=k[o|0];if((d|0)==255){break i}}n=d&15;h[f+5|0]=n;l:{if(d<<24>>24<0){break l}d=d>>>4|0;h[f+3|0]=k[d+11923|0];m:{switch(d-3|0){case 0:h[f+5|0]=n|32;break j;case 1:h[f+5|0]=p(n,17);break i;case 2:break j;case 3:break m;default:break i}}n:{switch(n|0){case 0:h[f+5|0]=79;break i;case 1:break n;default:break l}}h[f+5|0]=244;break i}h[f+3|0]=0;break i}h[o|0]=255}f=f+6|0;g=g+1|0;if((g|0)!=8){continue}break}r=r+1|0;if((r|0)!=64){continue}break}d=(e+72|0)+m|0;f=d;if(k[d+369|0]<63){Yk(Hb(q,m),qi(Ee(Ep(e+40|0,14,0),k[f+369|0])))}Yk(Hb(q,m),qi(Ep(e+40|0,16,k[d+241|0])))}m=m+1|0;if(m>>>0<k[e+183|0]){continue}break}}f=1;if(!(c&2)){break a}c=Kc(e+40|0,8,1,0,1);if(!l[a+480190>>1]){break b}while(1){$f(c,(p(f&65535,104)+a|0)+484380|0,b);f=f+1|0;if(l[a+480190>>1]>=(f&65535)>>>0){continue}break}}f=1}Za=e+576|0;return f|0}function P8(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0;d=Za-192|0;Za=d;a:{if(Ri(b)){break a}e=k[Fj(b)|0];g=1;b:{if((e|0)==33){break b}if((e|0)!=63){break a}g=0}c=g;Qj(d+160|0,b,j[b+4>>2]-1|0);e=j[d+164>>2];j[b>>2]=j[d+160>>2];j[b+4>>2]=e}ld(d+160|0);e=j[d+160>>2];ld(d+144|0);e=Ej(e,j[d+148>>2],b);ld(d+160|0);c:{d:{e:{f:{if((e|0)==j[d+164>>2]){a=j[b+4>>2];j[d+184>>2]=j[b>>2];j[d+188>>2]=a;a=_b(d+176|0,38235);e=j[d+188>>2];j[d+8>>2]=j[d+184>>2];j[d+12>>2]=e;e=j[a+4>>2];j[d>>2]=j[a>>2];j[d+4>>2]=e;if(nc(d+8|0,d)){a=R(8)|0;j[114630]=0;c=E(85,d+160|0,39176)|0;b=j[114630];j[114630]=0;if((b|0)==1){break e}Wb(a,c);j[114630]=0;I(2004,a|0,83648,2012);a=j[114630];j[114630]=0;if((a|0)!=1){break c}b=D()|0;C()|0;gb(c);break d}f=0;if(!c){break f}a=R(8)|0;j[114630]=0;e=E(2136,d+144|0,b|0)|0;b=j[114630];j[114630]=0;g:{h:{i:{if((b|0)!=1){j[114630]=0;I(2113,d+160|0,39186,e|0);b=j[114630];j[114630]=0;if((b|0)==1){break i}Wb(a,d+160|0);c=0;j[114630]=0;I(2004,a|0,83648,2012);b=j[114630];j[114630]=0;if((b|0)!=1){break c}b=D()|0;C()|0;gb(d+160|0);break h}b=D()|0;C()|0;break g}b=D()|0;c=1;C()|0}gb(e);if(!c){break d}}S(a|0);break d}if(j[e+4>>2]!=2){a=R(8)|0;j[114630]=0;c=E(85,d+160|0,39200)|0;b=j[114630];j[114630]=0;if((b|0)!=1){Wb(a,c);j[114630]=0;I(2004,a|0,83648,2012);a=j[114630];j[114630]=0;if((a|0)!=1){break c}b=D()|0;C()|0;gb(c);break d}b=D()|0;C()|0;S(a|0);break d}c=j[b+4>>2];j[d+136>>2]=j[b>>2];j[d+140>>2]=c;c=_b(d+128|0,38235);e=j[d+140>>2];j[d+72>>2]=j[d+136>>2];j[d+76>>2]=e;e=j[c+4>>2];j[d+64>>2]=j[c>>2];j[d+68>>2]=e;if(nc(d+72|0,d- -64|0)){a=R(8)|0;j[114630]=0;c=E(85,d+160|0,39176)|0;b=j[114630];j[114630]=0;if((b|0)!=1){Wb(a,c);j[114630]=0;I(2004,a|0,83648,2012);a=j[114630];j[114630]=0;if((a|0)!=1){break c}b=D()|0;C()|0;gb(c);break d}b=D()|0;C()|0;S(a|0);break d}c=j[b+4>>2];j[d+120>>2]=j[b>>2];j[d+124>>2]=c;c=_b(d+112|0,39029);e=j[d+124>>2];j[d+56>>2]=j[d+120>>2];j[d+60>>2]=e;e=j[c+4>>2];j[d+48>>2]=j[c>>2];j[d+52>>2]=e;if(nc(d+56|0,d+48|0)){f=1;if(!k[a+28|0]){break f}f=65536/+m[j[a+24>>2]+480244>>2];break f}c=j[b+4>>2];j[d+104>>2]=j[b>>2];j[d+108>>2]=c;c=_b(d+96|0,39047);e=j[d+108>>2];j[d+40>>2]=j[d+104>>2];j[d+44>>2]=e;e=j[c+4>>2];j[d+32>>2]=j[c>>2];j[d+36>>2]=e;if(nc(d+40|0,d+32|0)){f=1;if(!k[a+28|0]){break f}f=+m[j[a+24>>2]+480240>>2]*152587890625e-16;break f}c=j[b+4>>2];j[d+88>>2]=j[b>>2];j[d+92>>2]=c;b=_b(d+80|0,39144);c=j[d+92>>2];j[d+24>>2]=j[d+88>>2];j[d+28>>2]=c;c=j[b+4>>2];j[d+16>>2]=j[b>>2];j[d+20>>2]=c;f=0;if(!nc(d+24|0,d+16|0)){break f}f=+m[j[a+24>>2]+480236>>2]*152587890625e-16}Za=d+192|0;return+f}b=D()|0;C()|0;S(a|0)}G(b|0)}z()}function Daa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,i=0,l=0,m=0,n=0,o=0;d=Za-160|0;Za=d;g=d+144|0;kG(g);j[g>>2]=83800;H8(g+4|0);i=a+24|0;pm(j[i>>2],g);f=k[a+62|0];e=k[a+61|0];l=k[a+60|0];m=j[i>>2];b=He(d+128|0,b);j[114630]=0;l=l?13:15;e=e?l&14:l;f=K(2139,m|0,b|0,(f?e&3:e)|0)|0;e=j[114630];j[114630]=0;a:{b:{c:{d:{e:{f:{g:{h:{i:{j:{k:{l:{m:{n:{o:{p:{q:{if((e|0)!=1){jb(b);if(!f){b=R(8)|0;j[114630]=0;c=E(85,d+112|0,38618)|0;a=j[114630];j[114630]=0;if((a|0)!=1){Wb(b,c);j[114630]=0;I(2004,b|0,83648,2012);a=j[114630];j[114630]=0;if((a|0)!=1){break a}a=D()|0;C()|0;gb(c);break b}a=D()|0;C()|0;S(b|0);break b}r:{if(k[a+63|0]){break r}j[114630]=0;F(2140,a|0,a+36|0);b=j[114630];j[114630]=0;if((b|0)!=1){break r}a=D()|0;C()|0;break b}h[a+28|0]=1;pm(j[i>>2],j[a+4>>2]);j[114630]=0;F(2141,d+112|0,g|0);b=j[114630];j[114630]=0;if((b|0)==1){break q}n=d,o=Lb(d+112|0),j[n+104>>2]=o;n=d,o=Mb(d+112|0),j[n+96>>2]=o;if(rb(d+104|0,d+96|0)){i=a+68|0;while(1){b=j[d+104>>2];f=j[b>>2];j[114630]=0;e=f;f=b+4|0;I(2142,a|0,e|0,f|0);e=j[114630];j[114630]=0;if((e|0)==1){break e}b=j[b>>2];j[114630]=0;F(2143,d+32|0,b|0);b=j[114630];j[114630]=0;if((b|0)==1){break f}j[114630]=0;I(9,d+48|0,0,d+32|0);b=j[114630];j[114630]=0;if((b|0)==1){break h}j[114630]=0;b=E(85,d+16|0,38637)|0;e=j[114630];j[114630]=0;if((e|0)==1){break j}j[114630]=0;I(138,d- -64|0,d+48|0,b|0);e=j[114630];j[114630]=0;if((e|0)==1){break l}j[114630]=0;I(800,d+80|0,d- -64|0,f|0);f=j[114630];j[114630]=0;if((f|0)==1){break n}j[114630]=0;F(1529,i|0,d+80|0);f=j[114630];j[114630]=0;if((f|0)==1){break o}gb(d+80|0);gb(d- -64|0);gb(b);gb(d+48|0);gb(d+32|0);yf(d+104|0);if(rb(d+104|0,d+96|0)){continue}break}}n=d,o=_m(c),j[n+80>>2]=o;n=d,o=ii(c),j[n+64>>2]=o;s:{while(1){j[114630]=0;b=E(2144,d+80|0,d- -64|0)|0;c=j[114630];j[114630]=0;if((c|0)==1){break d}if(!b){break p}j[114630]=0;c=H(2145,d+80|0)|0;b=j[114630];j[114630]=0;t:{if((b|0)==1){break t}j[114630]=0;b=E(120,d|0,c|0)|0;i=j[114630];j[114630]=0;if((i|0)==1){break t}j[114630]=0;L(2076,a|0,b|0,c+12|0,0);c=j[114630];j[114630]=0;if((c|0)==1){break s}gb(b);j[114630]=0;H(2146,d+80|0)|0;b=j[114630];j[114630]=0;if((b|0)!=1){continue}break d}break}a=D()|0;C()|0;break c}a=D()|0;C()|0;gb(b);break c}a=D()|0;C()|0;jb(b);break b}a=D()|0;C()|0;break b}Zv(d+112|0);hr(g);Za=d+160|0;return}a=D()|0;C()|0;gb(d+80|0);break m}a=D()|0;C()|0}gb(d- -64|0);break k}a=D()|0;C()|0}gb(b);break i}a=D()|0;C()|0}gb(d+48|0);break g}a=D()|0;C()|0}gb(d+32|0);break c}a=D()|0;C()|0;break c}a=D()|0;C()|0;break c}a=D()|0;C()|0}Zv(d+112|0)}hr(g);G(a|0)}z()}function bDa(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,i=0,j=0;f=Za-16|0;Za=f;a:{b:{c:{d:{e:{f:{g:{h:{i:{j:{k:{l:{m:{n:{o:{p:{q:{r:{s:{t:{u:{v:{w:{x:{y:{z:{g=k[a+3|0];switch(g-4|0){case 23:break j;case 22:break k;case 21:break l;case 20:break m;case 18:break n;case 17:break o;case 16:break p;case 14:break q;case 13:break r;case 12:break s;case 11:break t;case 10:break u;case 9:break v;case 8:break w;case 5:break x;case 4:break y;case 0:break z;case 42:break c;case 37:break d;case 28:break e;case 27:break f;case 26:break g;case 25:break h;case 24:break i;default:break b}}h[a+3|0]=5;h[f+15|0]=k[a+5|0]>>>3;h[f+14|0]=15;b=k[Zb(f+15|0,f+14|0)|0];h[f+13|0]=k[a+5|0]<<1&30;h[f+12|0]=15;i=a,j=k[Zb(f+13|0,f+12|0)|0]|b<<4,h[i+5|0]=j;break a}h[a+3|0]=0;break a}if((k[a+5|0]-1&255)>>>0<=19){h[a+3|0]=16;break a}h[a+3|0]=0;break a}h[a+3|0]=13;b=k[a+5|0];A:{if(!e){if(b>>>0>152){break A}h[a+5|0]=p((b&240)>>>4|0,10)+(b&15);break a}h[a+5|0]=(b&127)+1>>>1;break a}h[a+3|0]=0;break a}h[a+3|0]=11;break a}h[a+3|0]=0;break a}e=k[a+5|0];if(!e){h[a+3|0]=14;break a}if(e>>>0<=240){h[a+3|0]=17;if(e>>>0<=2){h[a+5|0]=112;break a}i=a,j=Js(+(rP(e,b,c,d)>>>0)*1e-4),h[i+5|0]=j;break a}h[a+3|0]=0;break a}h[a+3|0]=31;h[a+5|0]=k[a+5|0]|128;break a}h[a+3|0]=19;h[f+11|0]=15;i=a,j=k[Zb(a+5|0,f+11|0)|0]|16,h[i+5|0]=j;break a}h[a+3|0]=19;h[f+10|0]=15;i=a,j=k[Zb(a+5|0,f+10|0)|0]|32,h[i+5|0]=j;break a}h[a+3|0]=5;h[f+9|0]=(k[a+5|0]>>>4|0)+1;h[f+8|0]=15;b=Zb(f+9|0,f+8|0);h[a+5|0]=k[a+5|0]&15|k[b|0]<<4;break a}h[a+3|0]=19;h[a+5|0]=k[a+5|0]&15|80;break a}h[a+3|0]=19;h[f+7|0]=15;i=a,j=k[Zb(a+5|0,f+7|0)|0]|96,h[i+5|0]=j;break a}h[a+3|0]=19;h[f+6|0]=15;i=a,j=k[Zb(a+5|0,f+6|0)|0]|192,h[i+5|0]=j;break a}h[a+3|0]=10;break a}h[a+3|0]=19;h[f+5|0]=15;i=a,j=k[Zb(a+5|0,f+5|0)|0]|160,h[i+5|0]=j;break a}h[a+3|0]=19;h[f+4|0]=15;i=a,j=k[Zb(a+5|0,f+4|0)|0]|176,h[i+5|0]=j;break a}b=(k[a+5|0]<<24)-16777216>>24;if((b|0)>=0){h[a+5|0]=b;h[a+3|0]=31;break a}h[a+3|0]=0;break a}h[a+3|0]=14;break a}h[a+3|0]=19;h[f+3|0]=15;i=a,j=k[Zb(a+5|0,f+3|0)|0]|224,h[i+5|0]=j;break a}b=k[a+5|0];if(b&240){h[a+3|0]=19;h[a+5|0]=b>>>4|208;break a}if(b&15){h[a+3|0]=19;h[a+5|0]=b|144;break a}h[a+3|0]=0;break a}if(!(k[a+5|0]|k[a+4|0])){h[a+5|0]=159;h[a+3|0]=20;break a}h[a+3|0]=0;break a}b=k[a+4|0];if(b){h[a+3|0]=41;i=a,j=Zm(Tc(((k[a+5|0]<<8&65280)>>>0)/(b>>>0)|0,0)),h[i+5|0]=j;break a}h[a+3|0]=0;break a}b=k[a+5|0];if((b-17&255)>>>0>=223){h[a+3|0]=9;i=a,j=bj(((b^128)<<3)-896|0),h[i+5|0]=j;break a}h[a+3|0]=0;break a}if(g>>>0<=15){_i(a);break a}h[a+3|0]=0}Za=f+16|0}function I0(a,b,c,d,e,f,g,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;i=i|0;var l=0,m=0,n=0,o=0;i=Za-32|0;Za=i;j[i+24>>2]=b;j[e>>2]=0;hc(i+8|0,d);j[114630]=0;l=H(21,i+8|0)|0;m=j[114630];j[114630]=0;a:{b:{c:{d:{e:{f:{g:{h:{i:{j:{k:{l:{m:{n:{o:{p:{q:{r:{s:{t:{u:{v:{w:{x:{y:{z:{A:{if((m|0)!=1){wb(i+8|0);switch(g-65|0){case 54:break j;case 19:break k;case 18:break l;case 17:break m;case 49:break n;case 47:break o;case 45:case 51:break p;case 12:break q;case 44:break r;case 41:break s;case 8:break t;case 7:break u;case 5:break v;case 3:break w;case 35:case 36:break x;case 34:break y;case 1:case 33:case 39:break z;case 0:case 32:break A;case 2:case 4:case 6:case 9:case 10:case 11:case 13:case 14:case 15:case 16:case 20:case 21:case 22:case 25:case 26:case 27:case 28:case 29:case 30:case 31:case 37:case 38:case 40:case 42:case 43:case 46:case 48:case 50:case 52:case 53:break d;case 24:break f;case 56:break g;case 23:break h;case 55:break i;default:break e}}a=D()|0;C()|0;wb(i+8|0);G(a|0);z()}_C(a,f+24|0,i+24|0,c,e,l);break b}ZC(a,f+16|0,i+24|0,c,e,l);break b}b=bb[j[j[a+8>>2]+12>>2]](a+8|0)|0;n=i,o=Gi(a,j[i+24>>2],c,d,e,f,zb(b),zb(b)+nb(b)|0),j[n+24>>2]=o;break b}H0(f+12|0,i+24|0,c,e,l);break b}j[i+8>>2]=623865125;j[i+12>>2]=2032480100;n=i,o=Gi(a,b,c,d,e,f,i+8|0,i+16|0),j[n+24>>2]=o;break b}j[i+8>>2]=623728933;j[i+12>>2]=1680158061;n=i,o=Gi(a,b,c,d,e,f,i+8|0,i+16|0),j[n+24>>2]=o;break b}G0(f+8|0,i+24|0,c,e,l);break b}F0(f+8|0,i+24|0,c,e,l);break b}E0(f+28|0,i+24|0,c,e,l);break b}D0(f+16|0,i+24|0,c,e,l);break b}C0(f+4|0,i+24|0,c,e,l);break b}B0(i+24|0,c,e,l);break b}A0(a,f+8|0,i+24|0,c,e,l);break b}g=k[64479]|k[64480]<<8|(k[64481]<<16|k[64482]<<24);h[i+15|0]=g;h[i+16|0]=g>>>8;h[i+17|0]=g>>>16;h[i+18|0]=g>>>24;g=k[64476]|k[64477]<<8|(k[64478]<<16|k[64479]<<24);j[i+8>>2]=k[64472]|k[64473]<<8|(k[64474]<<16|k[64475]<<24);j[i+12>>2]=g;n=i,o=Gi(a,b,c,d,e,f,i+8|0,i+19|0),j[n+24>>2]=o;break b}h[i+12|0]=k[64487];j[i+8>>2]=k[64483]|k[64484]<<8|(k[64485]<<16|k[64486]<<24);n=i,o=Gi(a,b,c,d,e,f,i+8|0,i+13|0),j[n+24>>2]=o;break b}y0(f,i+24|0,c,e,l);break b}j[i+8>>2]=624576549;j[i+12>>2]=1394948685;n=i,o=Gi(a,b,c,d,e,f,i+8|0,i+16|0),j[n+24>>2]=o;break b}x0(f+24|0,i+24|0,c,e,l);break b}a=bb[j[j[a>>2]+20>>2]](a,b,c,d,e,f)|0;break a}b=bb[j[j[a+8>>2]+24>>2]](a+8|0)|0;n=i,o=Gi(a,j[i+24>>2],c,d,e,f,zb(b),zb(b)+nb(b)|0),j[n+24>>2]=o;break b}YC(f+20|0,i+24|0,c,e,l);break b}w0(f+20|0,i+24|0,c,e,l);break b}if((g|0)==37){break c}}j[e>>2]=j[e>>2]|4;break b}v0(i+24|0,c,e,l)}a=j[i+24>>2]}Za=i+32|0;return a|0}function oaa(a,b,c){a=a|0;b=+b;c=c|0;var d=0,e=0,f=0,g=0;d=Za-96|0;Za=d;a:{b:{c:{if(!(b<.8)){j[114630]=0;N(2152,d+24|0);e=j[114630];j[114630]=0;d:{e:{f:{g:{h:{if((e|0)!=1){c=j[c>>2];j[114630]=0;F(2153,d+8|0,c|0);c=j[114630];j[114630]=0;if((c|0)==1){break h}pm(j[d+24>>2],j[d+8>>2]);e=j[d+24>>2];c=He(d+80|0,a);j[114630]=0;a=K(2139,e|0,c|0,15)|0;e=j[114630];j[114630]=0;if((e|0)==1){break g}jb(c);if(a){a=j[d+24>>2];j[114630]=0;H(1398,a|0)|0;a=j[114630];j[114630]=0;f=1;if((a|0)==1){break f}}Gc(d+8|0);jh(d+24|0);break b}a=J(0)|0;C()|0;break c}a=J(0)|0;C()|0;break d}a=J(0)|0;C()|0;jb(c);break e}a=J(0)|0;C()|0}Gc(d+8|0)}jh(d+24|0);break c}if(!(b<.6)){j[114630]=0;N(2152,d+24|0);e=j[114630];j[114630]=0;i:{j:{k:{l:{m:{if((e|0)!=1){c=j[c>>2];j[114630]=0;F(2153,d+8|0,c|0);c=j[114630];j[114630]=0;if((c|0)==1){break m}pm(j[d+24>>2],j[d+8>>2]);e=j[d+24>>2];c=He(d- -64|0,a);j[114630]=0;a=K(2139,e|0,c|0,2)|0;e=j[114630];j[114630]=0;if((e|0)==1){break l}jb(c);if(a){a=j[d+24>>2];j[114630]=0;H(1398,a|0)|0;a=j[114630];j[114630]=0;f=.8;if((a|0)==1){break k}}Gc(d+8|0);jh(d+24|0);break b}a=J(0)|0;C()|0;break c}a=J(0)|0;C()|0;break i}a=J(0)|0;C()|0;jb(c);break j}a=J(0)|0;C()|0}Gc(d+8|0)}jh(d+24|0);break c}f=.2;if(!(b<.2)){j[114630]=0;N(2152,d+24|0);e=j[114630];j[114630]=0;n:{o:{p:{q:{r:{if((e|0)!=1){c=j[c>>2];j[114630]=0;F(2153,d+8|0,c|0);c=j[114630];j[114630]=0;if((c|0)==1){break r}pm(j[d+24>>2],j[d+8>>2]);e=j[d+24>>2];c=He(d+48|0,a);j[114630]=0;a=K(2139,e|0,c|0,0)|0;e=j[114630];j[114630]=0;if((e|0)==1){break q}jb(c);f=0;if(a){a=j[d+24>>2];j[114630]=0;H(1398,a|0)|0;a=j[114630];j[114630]=0;f=.6;if((a|0)==1){break p}}Gc(d+8|0);jh(d+24|0);break b}a=J(0)|0;C()|0;break c}a=J(0)|0;C()|0;break n}a=J(0)|0;C()|0;jb(c);break o}a=J(0)|0;C()|0}Gc(d+8|0)}jh(d+24|0);break c}if(b<.1){break b}j[114630]=0;I(853,d+24|0,a|0,2048);c=j[114630];j[114630]=0;s:{t:{u:{if((c|0)!=1){j[114630]=0;c=H(412,d+24|0)|0;e=j[114630];j[114630]=0;if((e|0)==1){break t}e=j[d+24>>2];j[114630]=0;a=H(255,a|0)|0;g=j[114630];j[114630]=0;if((g|0)==1){break t}j[114630]=0;a=EB(2154,3,0,c,e,a,0);c=j[114630];j[114630]=0;if((c|0)==1){break t}a=a+1|0;if(a>>>0>=3){break u}f=o[(a<<3)+40520>>3];lc(d+24|0);break b}a=J(0)|0;C()|0;break c}c=R(8)|0;j[114630]=0;e=E(85,d+8|0,38235)|0;a=j[114630];j[114630]=0;if((a|0)!=1){Wb(c,e);j[114630]=0;I(2004,c|0,83648,2012);a=j[114630];j[114630]=0;if((a|0)!=1){break a}a=J(0)|0;C()|0;gb(e);break s}a=J(0)|0;C()|0;S(c|0);break s}a=J(0)|0;C()|0}lc(d+24|0)}O(a|0)|0;Q();f=0}Za=d+96|0;return+f}z()}function fla(a,b){var c=0,d=0,e=0,f=0,g=0,m=0,n=0;f=l[a+4>>1];c=f+1|0;i[a+4>>1]=c;if(l[j[a>>2]+480188>>1]<=(c&65535)>>>0){i[a+4>>1]=0}a:{if(Hm(b)){break a}c=j[a>>2];e=j[c+1074304>>2];g=j[c+480180>>2];b:{if((g|0)==2){if(k[b+3|0]!=23|e>>>0>=18415616){break b}ze(b+5|0,64);break b}if(g&16777248){c:{if(k[a+6|0]|e>>>0>=18874368?e>>>0>=18285314:0){break c}d:{switch(k[b+3|0]-20|0){case 3:ze(b+5|0,128);break c;case 0:break d;default:break c}}c=k[b+5|0];if((c|0)!=208){if((c|0)!=192){break c}h[b|0]=254;h[b+3|0]=0;break c}h[b+3|0]=0}e:{if(e>>>0>=18350080){c=0;if(k[a+6|0]|e>>>0>=18874368){break e}}d=k[b+3|0]-6&255;c=0;if(d>>>0>23){break e}c=8388643>>>d&1}if(e>>>0<18874368){d=k[b+3|0];d=(d|0)==24|(d|0)==22}else{d=0}f:{if(!(d|c)){break f}d=k[b+5|0];c=d&15;if(!c|(c|0)==15){break f}d=d&240;if(!d|(d|0)==240){break f}if(k[b+3|0]==24){h[b+5|0]=d;break f}h[b+5|0]=c}if(!l[j[a>>2]+480192>>1]|((e|0)==19005440|e>>>0>=19005700)|(k[a+6|0]|l[j[a>>2]+480192>>1]>=k[b+1|0])){break b}h[b+4|0]=0;h[b+2|0]=1;break b}if((g|0)!=4){break b}g:{if(k[b+3|0]!=23|e>>>0>=19137026|(e>>>0<18874368?!(k[a+6|0]?e>>>0>=18285314:0):0)){break g}if(k[b+5|0]<65){break g}h[b+3|0]=0}if(!(k[b+3|0]!=10|(k[a+6|0]|e>>>0>=18874368?e>>>0>=18415616:0)|k[b+2|0]!=11)){h[b+3|0]=0}h:{if(k[b+2|0]!=11|e>>>0>=18874640|k[b+3|0]!=4){break h}c=k[b+4|0];if(k[a+6|0]?0:!c){break h}d=k[b+5|0];if(!d){break h}h[b+2|0]=0;m=b,n=pP(d+(c<<4)|0),h[m+5|0]=n}if(k[b+5|0]|(k[b+3|0]!=16|e>>>0>=19007241)){break b}h[b+3|0]=0}i:{if(e>>>0>=18874368){break i}c=k[b+3|0];d=k[b+5|0]&240;j:{k:{if((c|0)!=28|(d|0)!=96){a=0}else{if(!k[a+6|0]|(g|0)!=4){break k}a=e>>>0<18350080}if(!(a|(c|0)==20&(d|0)==96)){break j}}if(!f){break j}a=p(0-f|0,6)+b|0;while(1){if(!((k[a+3|0]|8)!=28|(k[a+5|0]&240)!=96)){h[a+3|0]=0}a=a+6|0;if(b>>>0>a>>>0){continue}break}}if(!f|(k[b+5|0]&240)!=224|k[b+3|0]!=20){break i}a=p(0-f|0,6)+b|0;while(1){if(!(k[a+3|0]!=20|(k[a+5|0]&240)!=224)){h[a+3|0]=0}a=a+6|0;if(b>>>0>a>>>0){continue}break}}l:{if(k[b+2|0]!=8|e>>>0>=19333175|(e|0)==19333120){break l}m:{n:{o:{p:{a=k[b+3|0];switch(a-5|0){case 1:break l;case 0:break n;case 2:break p;default:break o}}if(!k[b+4|0]){break m}h[b+3|0]=11;break l}if((a|0)!=26){break l}}c=k[b+5|0];if(!(c&15)){h[b+2|0]=0;h[b+3|0]=5;h[b+5|0]=c|k[b+4|0]&15;break l}q:{switch(a-5|0){case 1:break l;case 0:case 2:break m;default:break q}}if((a|0)!=26){break l}}h[b+2|0]=0}if(k[b+3|0]|((g|0)==16777216|k[b+2|0]!=15)){break a}h[b+2|0]=0;h[b+3|0]=10;h[b+5|0]=k[b+4|0]<<3}}function Vja(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,i=0,l=0,m=0,n=0,o=0,p=0;c=Za-48|0;Za=c;if(uh(b)){g=Kj(b);m=j[b+12>>2];f=Xja(c+32|0,g);a:{if(!m){break a}while(1){e=j[j[a>>2]-12>>2];j[114630]=0;e=H(1570,a+e|0)|0;d=j[114630];j[114630]=0;b:{if((d|0)!=1){c:{if(!e){break a}j[114630]=0;h[c+31|0]=0;E(1571,a|0,c+31|0)|0;e=j[114630];j[114630]=0;d:{if((e|0)!=1){e=h[c+31|0];if(e){break d}l=l+1|0;break b}break c}h[c+30|0]=0;e:{if((e|0)>-1){break e}j[114630]=0;E(1571,a|0,c+30|0)|0;d=j[114630];j[114630]=0;if((d|0)!=1){break e}break c}h[c+29|0]=0;th(c+16|0);f:{g:{h:{i:{j:{k:{l:{m:{n:{o:{p:{q:{r:{s:{t:{u:{v:{w:{x:{y:{z:{e=e&127;e=(e?e-1|0:0)&65535;n=e>>>0>=g>>>0;A:{B:{if(!n){j[114630]=0;i=K(471,b|0,l|0,e|0)|0;d=j[114630];j[114630]=0;if((d|0)==1){break c}if(h[c+30|0]&1){break B}break y}i=c+16|0;d=k[c+30|0];if(!(d&1)){break A}}j[114630]=0;E(1571,a|0,c+29|0)|0;d=j[114630];j[114630]=0;if((d|0)==1){break c}if(e>>>0<g>>>0){break z}d=k[c+30|0]}if(d&2){break x}break w}d=k[c+29|0];o=wc(f,e),p=d,h[o|0]=p}o=i,p=k[wc(f,e)|0],h[o|0]=p;if(!(k[c+30|0]&2)){break u}}j[114630]=0;E(1571,a|0,c+29|0)|0;d=j[114630];j[114630]=0;if((d|0)==1){break c}if(e>>>0<g>>>0){break v}d=k[c+30|0]}if(d&4){break t}break s}d=k[c+29|0];o=wc(f,e),p=d,h[o+1|0]=p}o=i,p=k[wc(f,e)+1|0],h[o+1|0]=p;if(!(k[c+30|0]&4)){break q}}j[114630]=0;E(1571,a|0,c+29|0)|0;d=j[114630];j[114630]=0;if((d|0)==1){break c}if(e>>>0<g>>>0){break r}d=k[c+30|0]}if(d&8){break p}break o}d=k[c+29|0];o=wc(f,e),p=d,h[o+2|0]=p}o=i,p=k[wc(f,e)+2|0],h[o+2|0]=p;if(!(k[c+30|0]&8)){break m}}j[114630]=0;E(1571,a|0,c+29|0)|0;d=j[114630];j[114630]=0;if((d|0)==1){break c}if(e>>>0<g>>>0){break n}d=k[c+30|0]}if(d&16){break l}break k}d=k[c+29|0];o=wc(f,e),p=d,h[o+4|0]=p}o=i,p=k[wc(f,e)+4|0],h[o+4|0]=p;if(!(k[c+30|0]&16)){break i}}j[114630]=0;E(1571,a|0,c+29|0)|0;d=j[114630];j[114630]=0;if((d|0)==1){break c}if(e>>>0<g>>>0){break j}d=k[c+30|0]}if(d&32){break h}break f}d=k[c+29|0];o=wc(f,e),p=d,h[o+3|0]=p}o=i,p=k[wc(f,e)+3|0],h[o+3|0]=p;if(!(k[c+30|0]&32)){break g}}j[114630]=0;E(1571,a|0,c+29|0)|0;d=j[114630];j[114630]=0;if((d|0)==1){break c}if(n){break f}d=k[c+29|0];o=wc(f,e),p=d,h[o+5|0]=p}o=i,p=k[wc(f,e)+5|0],h[o+5|0]=p}if(!(k[c+30|0]&64)){break b}j[114630]=0;E(1571,a|0,c+15|0)|0;e=j[114630];j[114630]=0;if((e|0)!=1){e=k[c+15|0];j[114630]=0;K(1572,a|0,e|0,-1)|0;e=j[114630];j[114630]=0;if((e|0)!=1){break b}}}}a=D()|0;C()|0;ol(f);G(a|0);z()}if(l>>>0<m>>>0){continue}break}}ol(f)}Za=c+48|0}function Z5(a,b,c,d,e){var f=0,g=0,h=0,m=0,o=0,p=0,r=0,s=q(0),t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=q(0),D=0;f=j[b+4>>2];p=j[b>>2]+((f|0)/8|0)|0;m=k[p|0]|k[p+1|0]<<8|(k[p+2|0]<<16|k[p+3|0]<<24);h=(m<<24|m<<8&16711680|(m>>>8&65280|m>>>24))<<(f&7);g=f|-8;t=p+4|0;u=j[c>>2];r=l[c+6>>1];a:{if(!r){r=0;break a}while(1){f=c+B|0;m=k[f+15|0];x=(i[(m<<1)+47984>>1]<<1)+43600|0;v=k[f+18|0];b:{if(m>>>0>=16){y=k[m+48048|0];p=32-y|0;while(1){z=k[u|0]>>>1|0;A=(r|0)>(z|0)?z:r;s=n[d>>2];while(1){o=i[(h>>>26&62)+x>>1];if((o|0)<=-1){m=5;while(1){h=h<<m;g=g+m|0;f=o&7;m=f;o=i[((h>>>32-f|0)-(o>>3)<<1)+x>>1];if((o|0)<0){continue}break}}f=o>>8;g=f+g|0;h=h<<f;w=1;while(1){D=a;f=o&15;c:{if((f|0)==15){m=h<<y;f=(h>>>p|0)+15|0;g=g+y|0;if((g|0)>=0){while(1){m=k[t|0]<<g|m;h=(g|0)>7;g=g-8|0;t=t+1|0;if(h){continue}break}}C=q(q(s*q(((m|0)>-1?1:-1)|0))*O5(f));break c}m=h;C=q(n[(((h>>>27&16|f)^16)<<2)+48080>>2]*s)}n[D>>2]=C;o=o>>4;a=a+4|0;f=(f|0)!=0;g=f+g|0;h=m<<f;f=w&1;w=0;if(f){continue}break}if((g|0)>-1){while(1){h=k[t|0]<<g|h;f=(g|0)>7;g=g-8|0;t=t+1|0;if(f){continue}break}}A=A-1|0;if(A){continue}break}r=r-z|0;d=d+4|0;u=u+1|0;if((v|0)<1){break b}v=v-1|0;if((r|0)>0){continue}break}break b}while(1){p=k[u|0]>>>1|0;w=(r|0)>(p|0)?p:r;s=n[d>>2];while(1){m=i[(h>>>26&62)+x>>1];if((m|0)<=-1){o=5;while(1){h=h<<o;g=g+o|0;f=m&7;o=f;m=i[((h>>>32-f|0)-(m>>3)<<1)+x>>1];if((m|0)<0){continue}break}}f=m>>8;g=f+g|0;h=h<<f;o=1;while(1){f=m&15;n[a>>2]=n[(((f|h>>>27&16)^16)<<2)+48080>>2]*s;m=m>>4;a=a+4|0;f=(f|0)!=0;g=f+g|0;h=h<<f;f=o&1;o=0;if(f){continue}break}if((g|0)>-1){while(1){h=k[t|0]<<g|h;f=(g|0)>7;g=g-8|0;t=t+1|0;if(f){continue}break}}w=w-1|0;if(w){continue}break}r=r-p|0;d=d+4|0;u=u+1|0;if((v|0)<1){break b}v=v-1|0;if((r|0)>0){continue}break}}B=B+1|0;if((r|0)>0){continue}break}}o=1-r|0;while(1){d:{f=k[c+26|0]?47968:47936;m=k[f+(h>>>28|0)|0];if(!(m&8)){m=k[f+((h<<4>>>32-(m&3))+(m>>>3)|0)|0]}p=m&7;g=p+g|0;if(((g+(t-j[b>>2]<<3)|0)-24|0)>(e|0)){break d}o=o-1|0;f=d;e:{if(o){break e}o=k[u|0]>>>1|0;if(!o){break d}u=u+1|0;s=n[d>>2];f=d+4|0}h=h<<p;if(m&128){n[a>>2]=(h|0)<0?q(-s):s;g=g+1|0;h=h<<1}if(m&64){n[a+4>>2]=(h|0)<0?q(-s):s;g=g+1|0;h=h<<1}o=o-1|0;d=f;f:{if(o){break f}o=k[u|0]>>>1|0;if(!o){break d}u=u+1|0;s=n[f>>2];d=f+4|0}if(m&32){n[a+8>>2]=(h|0)<0?q(-s):s;g=g+1|0;h=h<<1}if(m&16){n[a+12>>2]=(h|0)<0?q(-s):s;g=g+1|0;h=h<<1}if((g|0)>=0){while(1){h=k[t|0]<<g|h;f=(g|0)>7;g=g-8|0;t=t+1|0;if(f){continue}break}}a=a+16|0;continue}break}j[b+4>>2]=e}function kBa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;e=Za-560|0;Za=e;a:{if(!xc(b,1464)){break a}if(!dn(b,e+556|0)){break a}od(a,1);d=a+1074308|0;rg(d,83);vb(d,84,1);vb(d,85,1);b:{if(Jd(e+556|0,16026)){d=Db(e+32|0,16036);ob(a+1304436|0,d);gb(d);d=Db(e+32|0,16059);ob(a+1304448|0,d);gb(d);d=Db(e+32|0,16064);ob(a+1304460|0,d);break b}if(!Jd(e+556|0,16031)){break a}d=Db(e+32|0,16081);ob(a+1304436|0,d);gb(d);d=Db(e+32|0,16093);ob(a+1304448|0,d);gb(d);d=Db(e+32|0,16097);ob(a+1304460|0,d)}gb(d);j[a+1304496>>2]=2;d=0;xc(b,0);Zy(b,a+1304400|0,20);i[a+480190>>1]=31;f=1;while(1){d=vy(b,e+32|0,(p(f,104)+a|0)+484380|0,((f<<5)+a|0)+946300|0,1)+d|0;f=f+1|0;if((f|0)!=32){continue}break}if(d>>>0>40){break a}wt(e+552|0,b);r=Pc(e+552|0);m=e+552|0;if(k[m|0]>128){break a}jBa(b,e+32|0);d=e+544|0;f=e+32|0;g=k[r|0];c:{while(1){if(g>>>0>=k[f|0]){f=f+1|0;if((d|0)!=(f|0)){continue}break c}break}break a}t=1;if(!c){break a}j[a+480260>>2]=56;j[a+480264>>2]=13696;j[a+480204>>2]=125e4;j[a+480196>>2]=6;i[a+480192>>1]=0;i[a+480188>>1]=4;j[a+480228>>2]=64;j[a+480208>>2]=j[a+480208>>2]|2097152;Qi(a,0);s=a+484360|0;bg(Eb(s),k[m|0]);i[e+30>>1]=0;n=a+484344|0;Jf(n,k[m|0]);if(k[m|0]){g=0;while(1){x=bc(Eb(s),g),y=g,i[x>>1]=y;if(Wf(n,g&65535,64)){u=g<<2;l=0;while(1){xc(b,(k[e+32+(l+u)|0]<<8)+1468|0);f=Se(Hb(n,g),0,l&65535);d=0;while(1){Es(b,f);d:{e:{q=k[f+3|0];f:{if((q|0)!=14){if(!q){if(k[f+5|0]){break e}break f}if((q-5&255)>>>0<5){break f}break e}if(k[f+5|0]<=15){break e}}h[f+3|0]=0;break d}_i(f)}f=f+24|0;d=d+1|0;if((d|0)!=64){continue}break}l=l+1|0;if((l|0)!=4){continue}break}x=e,y=Lb(Hb(n,g)),j[x+24>>2]=y;l=0;while(1){d=0;while(1){f=d;g:{if(k[j[e+24>>2]+3|0]!=17?k[j[e+24>>2]+3|0]!=16:0){break g}h[j[e+24>>2]+3|0]=16;o=0;if(k[j[e+24>>2]+5|0]<16){break g}if(!(!(k[j[e+24>>2]+5|0]&15)|(k[j[e+24>>2]+5|0]&15)==(k[j[e+24>>2]+5|0]>>>4|0))){v=k[j[e+24>>2]+5|0]>>>4|0;w=k[j[e+24>>2]+5|0]&15;o=1}d=j[e+24>>2];h[d+5|0]=k[d+5|0]>>>4}lk(e+24|0);d=f+1|0;if((f&65535)>>>0<3){continue}break}h[e+31|0]=w;h[e+30|0]=v;d=o&255;f=0;h:{if(!d){break h}Yk(Hb(n,g),Ee(Ep(e+8|0,16,k[(e+d|0)+29|0]),l));d=o+1|0;f=(d&255)==3?1:d}o=f;l=l+1|0;if((l|0)!=64){continue}break}}g=g+1|0;if(g>>>0<k[m|0]){continue}break}}if(!(c&2)){break a}xc(b,(k[r|0]<<8)+1468|0);f=1;while(1){c=(p(f,104)+a|0)+484380|0;if(j[c>>2]){$f(Kc(e+8|0,8,1,0,0),c,b)}f=f+1|0;if((f|0)!=32){continue}break}}Za=e+560|0;return t|0}function bpa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,i=0,m=0,n=0,o=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;f=Za-32|0;Za=f;v=a+4|0;u=j[v>>2];t=a+20|0;y=j[zc(t,b)+16>>2];a:{if(y+1>>>0<2){break a}i=(p(b,896)+u|0)+608|0;if(!oh(i)){if(!k[zc(t,b)+20|0]){break a}}m=p(b,896)+u|0;if(!j[m+712>>2]){break a}D=j[(j[m+696>>2]&2?m+692|0:m+684|0)>>2];g=j[m+688>>2];n=j[m+692>>2];mb(f+24|0,j[a>>2]+1074308|0,31);z=kb(f+24|0);A=m+1356|0;r=k[A|0];B=m+616|0;e=Ut(B,c);o=ab;s=o;j[f+24>>2]=e;j[f+28>>2]=o;if(k[m+696|0]&128){j[f+24>>2]=0-e;j[f+28>>2]=0-(((e|0)!=0)+s|0)}o=n-g|0;E=o<<1;e=p(b,896)+u|0;C=e;F=e+1308|0;s=e+1480|0;G=(r&17)!=1;b:{while(1){c:{if(d>>>0>w>>>0){g=(k[A|0]&17)==1;break c}h[s|0]=k[s|0]&254;e=Se(Hb(j[a>>2]+484344|0,l[j[v>>2]+60>>1]),j[j[v>>2]+48>>2],b);n=k[e+3|0];if(k[e+2|0]==11){rx(f+16|0,j[a>>2],e,0);r=Rb(f+16|0);Dm(j[a>>2],i,j[f+16>>2]);g=1;if(k[r|0]){break c}}g=1;d:{switch(n-4|0){case 0:Dm(j[a>>2],i,k[e+5|0]);break c;case 2:break d;default:break c}}Dm(j[a>>2],i,0)}j[f+12>>2]=j[F>>2];if(z){Er(j[a>>2],i)}if(!G){rJ(j[a>>2],i,f+12|0);g=1}if(!z){Er(j[a>>2],i)}j[f+8>>2]=0;tJ(i,f+8|0);e:{f:{if(k[m+697|0]&2){break f}g:{if(!g){if(!k[zc(t,b)+20|0]){break g}}if(k[s|0]&12){zM(i,q(1),0,j[a>>2]);e=k[s|0];h[s|0]=(e&8?-9:-5)&e}H=C,I=Uw(j[a>>2],i,j[f+12>>2],0),j[H+616>>2]=I;j[C+620>>2]=ab;H=zc(t,b),I=0,h[H+20|0]=I;e=Ut(B,c);g=ab;n=g;j[f+24>>2]=e;j[f+28>>2]=g;if(!(k[m+696|0]&128)){break g}j[f+24>>2]=0-e;j[f+28>>2]=0-(((e|0)!=0)+n|0)}Bb(i,f+24|0);g=j[i+4>>2];n=g;r=j[i>>2];if(D>>>0>g>>>0){break f}e=j[m+696>>2];if(!(e&2)){break e}if(e&4){x=j[m+688>>2];r=x;e=r;if((e|0)>(n|0)?1:0){j[f+16>>2]=0;j[f+20>>2]=r<<1;H=i,I=Pf(f+16|0,i),j[H>>2]=I;j[i+4>>2]=ab;j[m+696>>2]=j[m+696>>2]^128;e=j[f+24>>2];g=0-(j[f+28>>2]+((e|0)!=0)|0)|0;j[f+24>>2]=0-e;j[f+28>>2]=g;x=j[m+688>>2];g=j[i+4>>2]}mb(f+16|0,j[a>>2]+1074308|0,33);e=(g-x>>>0)%(E-kb(f+16|0)>>>0)|0;n=e>>>0<o>>>0;h:{if(!n){j[i+4>>2]=j[m+692>>2]+(o-e|0);g=j[m+696>>2];if(!(n^(g&128)>>>7)){break h}break f}j[i+4>>2]=e+j[m+688>>2];g=j[m+696>>2];if(n^(g&128)>>>7){break f}}j[m+696>>2]=g^128;e=j[f+24>>2];g=0-(j[f+28>>2]+((e|0)!=0)|0)|0;j[f+24>>2]=0-e;j[f+28>>2]=g;break f}n=j[m+692>>2];if(n+o>>>0<=g>>>0){g=n+((g-n>>>0)%(o>>>0)|0)|0}while(1){e=g;g=e-o|0;if(e>>>0>=n>>>0){continue}break}j[i>>2]=r;j[i+4>>2]=e}w=w+1|0;if((y|0)!=(w|0)){continue}break b}break}BM(i);j[(p(b,896)+u|0)+1316>>2]=0}H=zc(t,b),I=0,j[H+16>>2]=I}Za=f+32|0}function Lwa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,n=0,o=0,q=0,r=0;e=Za+ -64|0;Za=e;a:{if(!yb(c,8)){break a}Jb(c,4);while(1){f=Ps(c);if(f){break a}if(Xra(c)){continue}break}}h[d|0]=k[d|0]!=0|f;rc(c);b:{c:{d:{e:{if(f){d=hf(c);cd(e+48|0,c,ef(c));i[a+34>>1]=l[a+34>>1]&65534|k[b|0]>15;b=l[a+34>>1]&-65|(k[b+1|0]!=1)<<6;i[a+34>>1]=b;j[a>>2]=d>>>(b&1)>>>(b>>>6&1);j[114630]=0;j[e+44>>2]=0;j[e+40>>2]=0;F(857,e+16|0,e+48|0);b=j[114630];j[114630]=0;if((b|0)==1){break d}j[114630]=0;c=H(412,e+16|0)|0;b=j[114630];j[114630]=0;if((b|0)!=1){d=j[e+16>>2];j[114630]=0;b=H(854,c|0)|0;f=j[114630];j[114630]=0;if((f|0)==1){break c}j[114630]=0;f=H(855,d|0)|0;n=j[114630];j[114630]=0;if((n|0)==1){break c}j[114630]=0;b=U(856,b|0,f|0,e+44|0,e+40|0,0)|0;f=j[114630];j[114630]=0;if((f|0)==1){break c}j[114630]=0;E(338,e+48|0,j[e+44>>2])|0;f=j[114630];j[114630]=0;if((f|0)==1){break c}f:{if(!b){break f}n=j[e+44>>2];j[114630]=0;H(465,a|0)|0;f=j[114630];j[114630]=0;if((f|0)==1){break c}f=d-n|0;n=c+n|0;c=j[e+40>>2];d=0;while(1){g:{if(m[a>>2]<=d>>>0|(!f|(c|0)!=1?c:0)){break g}if(!ke(a)){break g}j[114630]=0;j[e+12>>2]=0;j[e+8>>2]=0;c=H(854,n|0)|0;o=j[114630];j[114630]=0;if((o|0)==1){break c}j[114630]=0;o=H(855,f|0)|0;g=j[114630];j[114630]=0;if((g|0)==1){break c}j[114630]=0;c=_(858,b|0,c|0,o|0,e+12|0,e+4|0,e+8|0)|0;o=j[114630];j[114630]=0;if((o|0)==1){break c}j[114630]=0;j[e+44>>2]=c;E(338,e+48|0,c|0)|0;c=j[114630];j[114630]=0;if((c|0)==1){break c}c=j[a>>2];j[114630]=0;o=j[e+44>>2];c=H(859,c-d|0)|0;g=j[114630];j[114630]=0;if((g|0)==1){break c}_j(e+8|0,c);h:{if(j[e+8>>2]<1){break h}if(j[e+12>>2]!=(be(a)|0)){break h}c=0;if(j[e+12>>2]<=0){break h}while(1){i:{if(h[a+34|0]&1){g=j[a+20>>2];q=be(a);r=j[j[e+4>>2]+(c<<2)>>2];j[114630]=0;V(860,g+(p(d,q)<<1)|0,r|0,j[e+12>>2],j[e+8>>2],c|0);g=j[114630];j[114630]=0;if((g|0)!=1){break i}break c}g=j[a+20>>2];q=be(a);r=j[j[e+4>>2]+(c<<2)>>2];j[114630]=0;V(861,g+p(d,q)|0,r|0,j[e+12>>2],j[e+8>>2],c|0);g=j[114630];j[114630]=0;if((g|0)==1){break c}}c=c+1|0;if((c|0)<j[e+12>>2]){continue}break}}j[114630]=0;g=j[e+8>>2];c=H(862,b|0)|0;q=j[114630];j[114630]=0;if((q|0)==1){break c}f=f-o|0;n=n+o|0;j[e+40>>2]=c;d=d+g|0;continue}break}j[114630]=0;N(863,b|0);a=j[114630];j[114630]=0;if((a|0)!=1){break f}break c}lc(e+16|0);jb(e+48|0);a=(b|0)!=0;break e}break c}$f(b,a,c);a=1}Za=e- -64|0;return a|0}c=D()|0;C()|0;break b}c=D()|0;C()|0;lc(e+16|0)}jb(e+48|0);G(c|0);z()}function axa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,u=0;d=Za-208|0;Za=d;rc(b);a:{if(!fz(b,d+160|0)){break a}if(!ZM(d+160|0)){break a}if(!c){f=1;break a}if(!yb(b,Tc(YM(d+160|0),ab))){break a}od(a,128);vg(d+144|0,2,d+175|0);qc(d+72|0,d+144|0);ob(a+1304400|0,d+72|0);gb(d+72|0);f=Db(d+72|0,17473);ob(a+1304436|0,f);gb(f);f=Db(d+72|0,17486);ob(a+1304448|0,f);gb(f);e=Db(d+144|0,17490);j[114630]=0;I(1022,d+72|0,e|0,j[(k[d+174|0]<<2)+77356>>2]);f=j[114630];j[114630]=0;b:{if((f|0)!=1){ob(a+1304460|0,d+72|0);gb(d+72|0);gb(e);j[a+480208>>2]=12;j[a+1304496>>2]=4;Qx(a+1304424|0,b,k[d+207|0]<<5,32,0);t=a,u=dd(b),i[t+480190>>1]=u;c:{if(l[a+480190>>1]){m=d+136|0;g=d+134|0;f=1;e=1;while(1){d:{if(k[d+174|0]>=52){tz(b,d+72|0);break d}Xwa(b,d+72|0);n=k[g|0]|k[g+1|0]<<8;h[m|0]=n;h[m+1|0]=n>>>8;h[g|0]=171;h[g+1|0]=32}$wa(d+72|0,(p(f,104)+a|0)+484380|0);vg(d+56|0,2,d+72|0);qc(d+144|0,d+56|0);j[114630]=0;E(369,((f<<5)+a|0)+946300|0,d+144|0)|0;f=j[114630];j[114630]=0;if((f|0)==1){break c}gb(d+144|0);e=e+1|0;f=e&65535;if(f>>>0<=l[a+480190>>1]){continue}break}}mp(Eb(a+484360|0),b,256,255,254);f=0;e=dd(b);if(e>>>0>=127){break a}i[a+480188>>1]=e+1;m=dd(b);r=m+1|0;if(l[a+480188>>1]){while(1){e=(f<<5)+a|0;wg(e+480280|0);e=e+480284|0;e:{if(k[d+174|0]>=51){q=(dd(b)<<4|8)&248;break e}q=f&1?192:64}i[e>>1]=q;f=f+1|0;if(f>>>0<l[a+480188>>1]){continue}break}}g=a+484344|0;Jf(g,r);f=0;e=0;while(1){n=e&65535;if(!Wf(g,n,64)){break a}e=e+1|0;if(m>>>0>n>>>0){continue}break}if(l[a+480188>>1]){m=0;while(1){s=ni(d+72|0);n=0;while(1){if(yb(b,5)){e=0;f=Se(Hb(g,n),0,m&65535);while(1){o=_wa(s,b,k[d+174|0]);q=o+e|0;e=q>>>0>64?64-e|0:o;if(e){while(1){o=j[d+72>>2];h[f|0]=o;h[f+1|0]=o>>>8;h[f+2|0]=o>>>16;h[f+3|0]=o>>>24;o=l[d+76>>1];h[f+4|0]=o;h[f+5|0]=o>>>8;f=p(l[a+480188>>1],6)+f|0;e=e-1|0;if(e){continue}break}e=q;q=q>>>0<64;e=q?e:64;if(q){continue}}break}n=n+1|0;if((r|0)!=(n|0)){continue}}break}m=m+1|0;if(l[a+480188>>1]>(m&65535)>>>0){continue}break}}e=Zwa(d+8|0,l[a+480188>>1]);j[114630]=0;I(1023,d+32|0,g|0,e|0);g=j[114630];j[114630]=0;f=1;if((g|0)!=1){Vd(d+32|0);Vd(e);if(!(c&2)|!l[a+480190>>1]){break a}e=1;while(1){c=p(e&65535,104)+a|0;$f(Kc(d+72|0,i[c+484414>>1]&1?16:8,1,0,0),c+484380|0,b);e=e+1|0;if(l[a+480190>>1]>=(e&65535)>>>0){continue}break}break a}f=D()|0;C()|0;Vd(e);break b}f=D()|0;C()|0;gb(d+144|0);break b}f=D()|0;C()|0;gb(e)}G(f|0);z()}Za=d+208|0;return f|0}function DE(a,b){var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0;g=Za-48|0;Za=g;RMa(+a);d=OMa(1)|0;f=OMa(0)|0;a:{b:{e=d;d=e;h=e&2147483647;c:{if(h>>>0<=1074752122){if((d&1048575)==598523){break c}if(h>>>0<=1073928572){if((e|0)>0?1:(e|0)>=0){a=a+ -1.5707963267341256;c=a+ -6.077100506506192e-11;o[b>>3]=c;o[b+8>>3]=a-c+ -6.077100506506192e-11;d=1;break a}a=a+1.5707963267341256;c=a+6.077100506506192e-11;o[b>>3]=c;o[b+8>>3]=a-c+6.077100506506192e-11;d=-1;break a}if((e|0)>0?1:(e|0)>=0){a=a+ -3.1415926534682512;c=a+ -1.2154201013012384e-10;o[b>>3]=c;o[b+8>>3]=a-c+ -1.2154201013012384e-10;d=2;break a}a=a+3.1415926534682512;c=a+1.2154201013012384e-10;o[b>>3]=c;o[b+8>>3]=a-c+1.2154201013012384e-10;d=-2;break a}if(h>>>0<=1075594811){if(h>>>0<=1075183036){if((h|0)==1074977148){break c}if((e|0)>0?1:(e|0)>=0){a=a+ -4.712388980202377;c=a+ -1.8231301519518578e-10;o[b>>3]=c;o[b+8>>3]=a-c+ -1.8231301519518578e-10;d=3;break a}a=a+4.712388980202377;c=a+1.8231301519518578e-10;o[b>>3]=c;o[b+8>>3]=a-c+1.8231301519518578e-10;d=-3;break a}if((h|0)==1075388923){break c}if((e|0)>0?1:(e|0)>=0){a=a+ -6.2831853069365025;c=a+ -2.430840202602477e-10;o[b>>3]=c;o[b+8>>3]=a-c+ -2.430840202602477e-10;d=4;break a}a=a+6.2831853069365025;c=a+2.430840202602477e-10;o[b>>3]=c;o[b+8>>3]=a-c+2.430840202602477e-10;d=-4;break a}if(h>>>0>1094263290){break b}}j=a*.6366197723675814+6755399441055744+ -6755399441055744;c=a+j*-1.5707963267341256;i=j*6.077100506506192e-11;a=c-i;o[b>>3]=a;RMa(+a);d=OMa(1)|0;OMa(0)|0;e=h>>>20|0;f=(e-(d>>>20&2047)|0)<17;if(r(j)<2147483648){d=~~j}else{d=-2147483648}d:{if(f){break d}i=c;a=j*6.077100506303966e-11;c=c-a;i=j*2.0222662487959506e-21-(i-c-a);a=c-i;o[b>>3]=a;f=e;RMa(+a);e=OMa(1)|0;OMa(0)|0;if((f-(e>>>20&2047)|0)<50){break d}i=c;a=j*2.0222662487111665e-21;c=c-a;i=j*8.4784276603689e-32-(i-c-a);a=c-i;o[b>>3]=a}o[b+8>>3]=c-a-i;break a}if(h>>>0>=2146435072){a=a-a;o[b>>3]=a;o[b+8>>3]=a;d=0;break a}PMa(0,f|0);PMa(1,e&1048575|1096810496);a=+QMa();d=0;f=1;while(1){k=(g+16|0)+(d<<3)|0;if(r(a)<2147483648){d=~~a}else{d=-2147483648}c=+(d|0);o[k>>3]=c;a=(a-c)*16777216;d=1;k=f&1;f=0;if(k){continue}break}o[g+32>>3]=a;e:{if(a!=0){d=2;break e}f=1;while(1){d=f;f=d-1|0;if(o[(g+16|0)+(d<<3)>>3]==0){continue}break}}d=EE(g+16|0,g,(h>>>20|0)-1046|0,d+1|0,1);a=o[g>>3];if((e|0)<-1?1:(e|0)<=-1){o[b>>3]=-a;o[b+8>>3]=-o[g+8>>3];d=0-d|0;break a}o[b>>3]=a;o[b+8>>3]=o[g+8>>3]}Za=g+48|0;return d}



function dma(a,b,c,d,e){var f=0,g=0,i=0,l=0,m=0,o=0,r=0,s=0;o=Za-16|0;Za=o;g=j[b+104>>2];a:{if(!g|!k[g+40|0]){break a}s=Yi(b);f=Ao(a);mb(o+8|0,a+1074308|0,21);m=f?26336:25312;r=f?25312:26336;if(!(!kb(o+8|0)|s|j[a+480180>>2]==1048576)){if(!k[g+41|0]){break a}l=k[b+838|0];j[o+4>>2]=j[b+780>>2]+k[g+39|0];_j(o+4|0,k[g+40|0]<<8);d=j[o+4>>2];j[b+780>>2]=d;d=(d|0)/256|0;j[o+4>>2]=d;h[b+838|0]=k[b+838|0]+k[g+41|0];b:{c:{switch(k[g+38|0]-1|0){case 3:b=nJ(Em(a))+ -64|0;d=j[o+4>>2];break b;case 2:b=64-(l+1>>>1|0)|0;break b;case 1:b=(l+1>>>1|0)+ -64|0;break b;case 0:b=(l>>>1^-1)&64;break b;default:break c}}b=h[l+21616|0]}_j(c,8388607);a=j[c>>2]<<8;j[c>>2]=a;l=p(b,d);d=(l|0)/64|0;b=d>>31;g=b^b+d;d=g>>>2|0;b=c;d:{if((l|0)<=-64){d=j[(d<<2)+m>>2];d=ic(IMa(HMa(d,d>>31,a,a>>31),ab,65536,0),ab);a=j[c>>2];m=d-a|0;d=m;r=g&3;if(!r){break d}d=j[(r<<2)+(f?25248:25184)>>2];d=ic(IMa(HMa(d,d>>31,a,a>>31),ab,65536,0),ab)+m|0;a=j[c>>2];d=d-a|0;break d}d=j[(d<<2)+r>>2];d=ic(IMa(HMa(d,d>>31,a,a>>31),ab,65536,0),ab);a=j[c>>2];m=d-a|0;d=m;r=g&3;if(!r){break d}d=j[(r<<2)+(f?25184:25248)>>2];d=ic(IMa(HMa(d,d>>31,a,a>>31),ab,65536,0),ab)+m|0;a=j[c>>2];d=d-a|0}j[b>>2]=(a+d|0)/256;j[e>>2]=d&255;break a}e:{if(!(k[g+39|0]|j[a+480180>>2]&16777248)){j[b+780>>2]=k[g+40|0]<<8;break e}f:{g:{if(j[a+480180>>2]&16777248){l=j[b+780>>2];i=b+780|0;f=k[g+39|0]<<1;break g}if(k[b+89|0]&8){break f}l=((k[g+40|0]<<8&65280)>>>0)/k[g+39|0]|0;i=b+780|0;f=j[b+780>>2]}j[i>>2]=f+l}_j(b+780|0,k[g+40|0]<<8)}f=k[b+838|0]+k[g+41|0]|0;h[b+838|0]=f;f=f<<24>>24;h:{i:{switch(k[g+38|0]-1|0){case 3:h[b+838|0]=f+1;i=h[(f&63)+21552|0];break h;case 2:i=(64-(f>>>1|0)&127)+ -64|0;break h;case 1:i=((f>>>1|0)- -64&127)+ -64|0;break h;case 0:i=(f|0)>-1?-64:64;break h;default:break i}}f=k[b+838|0];i=0-h[f+21616|0]|0;if(j[a+480180>>2]!=1048576){break h}i=(64-h[(f+ -64&255)+21616|0]|0)/2<<16>>16}f=i;i=p(f,j[b+780>>2]);l=(i|0)/256|0;if(s){n[d>>2]=q(q(q(f|0)*q(1220703143189894e-20))*q(k[g+40|0]))+n[d>>2];h[b+872|0]=k[b+872|0]|8;break a}if(j[a+480180>>2]!=4){j:{if((i|0)<=-256){l=0-l|0;b=0-i>>>16|0;a=(b<<2)+m|0;break j}m=r;b=(i|0)/65536|0;a=m+(b<<2)|0}d=j[c>>2];a=j[a>>2];a=((p(j[((b<<2)+m|0)+4>>2]-a|0,(l|0)/4&63)|0)/64|0)+a|0;a=ic(IMa(HMa(d,d>>31,a,a>>31),ab,256,0),ab);j[c>>2]=a;j[e>>2]=a&255;j[c>>2]=j[c>>2]/256;break a}j[c>>2]=j[c>>2]+((i|0)/16384|0)}Za=o+16|0}function T0(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;var i=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;n=Za-16|0;Za=n;p=dv(g);r=Ru(g);Tf(n,r);j[f>>2]=d;a:{b:{c:{l=a;g=k[l|0];switch(g-43|0){case 0:case 2:break c;default:break b}}j[114630]=0;g=E(2476,p|0,g<<24>>24)|0;l=j[114630];j[114630]=0;if((l|0)==1){break a}l=j[f>>2];j[f>>2]=l+4;j[l>>2]=g;l=a+1|0}d:{g=l;if(!((c-g|0)<=1|k[g|0]!=48|(k[g+1|0]|32)!=120)){j[114630]=0;g=E(2476,p|0,48)|0;i=j[114630];j[114630]=0;if((i|0)==1){break a}i=j[f>>2];j[f>>2]=i+4;j[i>>2]=g;g=h[l+1|0];j[114630]=0;g=E(2476,p|0,g|0)|0;i=j[114630];j[114630]=0;if((i|0)==1){break a}i=j[f>>2];j[f>>2]=i+4;j[i>>2]=g;l=l+2|0;g=l;while(1){if(c>>>0<=g>>>0){break d}i=h[g|0];j[114630]=0;m=T(2446)|0;o=j[114630];j[114630]=0;e:{if((o|0)==1){break e}j[114630]=0;i=_u(i,m);m=j[114630];j[114630]=0;if((m|0)==1){break e}if(!i){break d}g=g+1|0;continue}break}break a}while(1){if(c>>>0<=g>>>0){break d}i=h[g|0];j[114630]=0;T(2446)|0;m=j[114630];j[114630]=0;if((m|0)==1){break a}j[114630]=0;i=Jg(i);m=j[114630];j[114630]=0;if((m|0)==1){break a}if(!i){break d}g=g+1|0;continue}}f:{if(Ec(n)){i=j[f>>2];j[114630]=0;P(2464,p|0,l|0,g|0,i|0)|0;i=j[114630];j[114630]=0;if((i|0)==1){break a}j[f>>2]=j[f>>2]+(g-l<<2);break f}o=0;j[114630]=0;uj(l,g);i=j[114630];j[114630]=0;if((i|0)==1){break a}j[114630]=0;t=H(2461,r|0)|0;i=j[114630];j[114630]=0;if((i|0)==1){break a}m=0;i=l;while(1){if(g>>>0<=i>>>0){i=j[f>>2];j[114630]=0;Sn((l-a<<2)+d|0,i);l=j[114630];j[114630]=0;if((l|0)!=1){break f}break a}g:{if(h[Ub(n,m)|0]<1){break g}if(h[Ub(n,m)|0]!=(o|0)){break g}o=j[f>>2];j[f>>2]=o+4;j[o>>2]=t;m=(nb(n)-1>>>0>m>>>0)+m|0;o=0}s=h[i|0];j[114630]=0;s=E(2476,p|0,s|0)|0;q=j[114630];j[114630]=0;if((q|0)!=1){q=j[f>>2];j[f>>2]=q+4;j[q>>2]=s;i=i+1|0;o=o+1|0;continue}break}break a}h:{while(1){if(c>>>0>g>>>0){l=k[g|0];if((l|0)==46){j[114630]=0;l=H(2465,r|0)|0;i=j[114630];j[114630]=0;if((i|0)==1){break a}m=j[f>>2];i=m+4|0;j[f>>2]=i;j[m>>2]=l;g=g+1|0;break h}j[114630]=0;l=E(2476,p|0,l<<24>>24)|0;i=j[114630];j[114630]=0;if((i|0)==1){break a}i=j[f>>2];j[f>>2]=i+4;j[i>>2]=l;g=g+1|0;continue}break}i=j[f>>2]}j[114630]=0;P(2464,p|0,g|0,c|0,i|0)|0;l=j[114630];j[114630]=0;if((l|0)==1){break a}l=f;f=j[f>>2]+(c-g<<2)|0;j[l>>2]=f;j[e>>2]=(b|0)==(c|0)?f:(b-a<<2)+d|0;gb(n);Za=n+16|0;return}a=D()|0;C()|0;gb(n);G(a|0);z()}function b1(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;var i=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;n=Za-16|0;Za=n;p=Tt(g);r=Uu(g);Tf(n,r);j[f>>2]=d;a:{b:{c:{l=a;g=k[l|0];switch(g-43|0){case 0:case 2:break c;default:break b}}j[114630]=0;g=E(22,p|0,g<<24>>24)|0;l=j[114630];j[114630]=0;if((l|0)==1){break a}l=j[f>>2];j[f>>2]=l+1;h[l|0]=g;l=a+1|0}d:{g=l;if(!((c-g|0)<=1|k[g|0]!=48|(k[g+1|0]|32)!=120)){j[114630]=0;g=E(22,p|0,48)|0;i=j[114630];j[114630]=0;if((i|0)==1){break a}i=j[f>>2];j[f>>2]=i+1;h[i|0]=g;g=h[l+1|0];j[114630]=0;g=E(22,p|0,g|0)|0;i=j[114630];j[114630]=0;if((i|0)==1){break a}i=j[f>>2];j[f>>2]=i+1;h[i|0]=g;l=l+2|0;g=l;while(1){if(c>>>0<=g>>>0){break d}i=h[g|0];j[114630]=0;m=T(2446)|0;o=j[114630];j[114630]=0;e:{if((o|0)==1){break e}j[114630]=0;i=_u(i,m);m=j[114630];j[114630]=0;if((m|0)==1){break e}if(!i){break d}g=g+1|0;continue}break}break a}while(1){if(c>>>0<=g>>>0){break d}i=h[g|0];j[114630]=0;T(2446)|0;m=j[114630];j[114630]=0;if((m|0)==1){break a}j[114630]=0;i=Jg(i);m=j[114630];j[114630]=0;if((m|0)==1){break a}if(!i){break d}g=g+1|0;continue}}f:{if(Ec(n)){i=j[f>>2];j[114630]=0;P(2441,p|0,l|0,g|0,i|0)|0;i=j[114630];j[114630]=0;if((i|0)==1){break a}j[f>>2]=j[f>>2]+(g-l|0);break f}o=0;j[114630]=0;uj(l,g);i=j[114630];j[114630]=0;if((i|0)==1){break a}j[114630]=0;t=H(2432,r|0)|0;i=j[114630];j[114630]=0;if((i|0)==1){break a}m=0;i=l;while(1){if(g>>>0<=i>>>0){i=j[f>>2];j[114630]=0;uj((l-a|0)+d|0,i);l=j[114630];j[114630]=0;if((l|0)!=1){break f}break a}g:{if(h[Ub(n,m)|0]<1){break g}if(h[Ub(n,m)|0]!=(o|0)){break g}o=j[f>>2];j[f>>2]=o+1;h[o|0]=t;m=(nb(n)-1>>>0>m>>>0)+m|0;o=0}s=h[i|0];j[114630]=0;s=E(22,p|0,s|0)|0;q=j[114630];j[114630]=0;if((q|0)!=1){q=j[f>>2];j[f>>2]=q+1;h[q|0]=s;i=i+1|0;o=o+1|0;continue}break}break a}while(1){h:{if(c>>>0>g>>>0){l=k[g|0];if((l|0)!=46){break h}j[114630]=0;l=H(2442,r|0)|0;i=j[114630];j[114630]=0;if((i|0)==1){break a}i=j[f>>2];j[f>>2]=i+1;h[i|0]=l;g=g+1|0}l=j[f>>2];j[114630]=0;P(2441,p|0,g|0,c|0,l|0)|0;l=j[114630];j[114630]=0;if((l|0)==1){break a}l=f;f=j[f>>2]+(c-g|0)|0;j[l>>2]=f;j[e>>2]=(b|0)==(c|0)?f:(b-a|0)+d|0;gb(n);Za=n+16|0;return}j[114630]=0;l=E(22,p|0,l<<24>>24)|0;i=j[114630];j[114630]=0;if((i|0)==1){break a}i=j[f>>2];j[f>>2]=i+1;h[i|0]=l;g=g+1|0;continue}}a=D()|0;C()|0;gb(n);G(a|0);z()}function R8(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0;d=Za-160|0;Za=d;a:{if(Ri(b)){break a}f=k[Fj(b)|0];e=1;b:{if((f|0)==33){break b}if((f|0)!=63){break a}e=0}c=e;Qj(d+128|0,b,j[b+4>>2]-1|0);e=j[d+132>>2];j[b>>2]=j[d+128>>2];j[b+4>>2]=e}ld(d+128|0);e=j[d+128>>2];ld(d+112|0);e=Ej(e,j[d+116>>2],b);ld(d+128|0);c:{d:{e:{f:{if((e|0)==j[d+132>>2]){a=j[b+4>>2];j[d+152>>2]=j[b>>2];j[d+156>>2]=a;a=_b(d+144|0,38235);e=j[d+156>>2];j[d+8>>2]=j[d+152>>2];j[d+12>>2]=e;e=j[a+4>>2];j[d>>2]=j[a>>2];j[d+4>>2]=e;if(nc(d+8|0,d)){a=R(8)|0;j[114630]=0;c=E(85,d+128|0,39176)|0;b=j[114630];j[114630]=0;if((b|0)==1){break e}Wb(a,c);j[114630]=0;I(2004,a|0,83648,2012);a=j[114630];j[114630]=0;if((a|0)!=1){break c}b=D()|0;C()|0;gb(c);break d}e=0;f=0;if(!c){break f}a=R(8)|0;j[114630]=0;e=E(2136,d+112|0,b|0)|0;b=j[114630];j[114630]=0;g:{h:{i:{if((b|0)!=1){j[114630]=0;I(2113,d+128|0,39186,e|0);b=j[114630];j[114630]=0;if((b|0)==1){break i}Wb(a,d+128|0);c=0;j[114630]=0;I(2004,a|0,83648,2012);b=j[114630];j[114630]=0;if((b|0)!=1){break c}b=D()|0;C()|0;gb(d+128|0);break h}b=D()|0;C()|0;break g}b=D()|0;c=1;C()|0}gb(e);if(!c){break d}}S(a|0);break d}if(j[e+4>>2]!=1){a=R(8)|0;j[114630]=0;c=E(85,d+128|0,39200)|0;b=j[114630];j[114630]=0;if((b|0)!=1){Wb(a,c);j[114630]=0;I(2004,a|0,83648,2012);a=j[114630];j[114630]=0;if((a|0)!=1){break c}b=D()|0;C()|0;gb(c);break d}b=D()|0;C()|0;S(a|0);break d}c=j[b+4>>2];j[d+104>>2]=j[b>>2];j[d+108>>2]=c;c=_b(d+96|0,38235);e=j[d+108>>2];j[d+56>>2]=j[d+104>>2];j[d+60>>2]=e;e=j[c+4>>2];j[d+48>>2]=j[c>>2];j[d+52>>2]=e;if(nc(d+56|0,d+48|0)){a=R(8)|0;j[114630]=0;c=E(85,d+128|0,39176)|0;b=j[114630];j[114630]=0;if((b|0)!=1){Wb(a,c);j[114630]=0;I(2004,a|0,83648,2012);a=j[114630];j[114630]=0;if((a|0)!=1){break c}b=D()|0;C()|0;gb(c);break d}b=D()|0;C()|0;S(a|0);break d}c=j[b+4>>2];j[d+88>>2]=j[b>>2];j[d+92>>2]=c;c=_b(d+80|0,39021);e=j[d+92>>2];j[d+40>>2]=j[d+88>>2];j[d+44>>2]=e;e=j[c+4>>2];j[d+32>>2]=j[c>>2];j[d+36>>2]=e;if(nc(d+40|0,d+32|0)){a=j[a+8>>2];e=a;f=a>>31;break f}c=j[b+4>>2];j[d+72>>2]=j[b>>2];j[d+76>>2]=c;b=_b(d- -64|0,39169);c=j[d+76>>2];j[d+24>>2]=j[d+72>>2];j[d+28>>2]=c;c=j[b+4>>2];j[d+16>>2]=j[b>>2];j[d+20>>2]=c;e=0;f=0;if(!nc(d+24|0,d+16|0)){break f}a=j[j[a+32>>2]+40>>2];e=a;f=a>>31}Za=d+160|0;ab=f;return e|0}b=D()|0;C()|0;S(a|0)}G(b|0)}z()}function Pba(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;a=Cb(a);j[114630]=0;M(81);c=j[114630];j[114630]=0;a:{b:{if((c|0)==1){c=Pa(83648,71412,71388,0)|0;d=C()|0;c:{d:{e:{if((W(83648)|0)==(d|0)){c=O(c|0)|0;j[114630]=0;E(1990,a|0,b|0)|0;b=j[114630];j[114630]=0;if((b|0)==1){break e}j[114630]=0;E(1990,a|0,37654)|0;b=j[114630];j[114630]=0;if((b|0)==1){break e}j[114630]=0;E(1990,a|0,37713)|0;b=j[114630];j[114630]=0;if((b|0)==1){break e}b=bb[j[j[c>>2]+8>>2]](c)|0;j[114630]=0;E(1990,a|0,(b?b:34181)|0)|0;b=j[114630];j[114630]=0;if((b|0)==1){break e}j[114630]=0;M(20);b=j[114630];j[114630]=0;if((b|0)!=1){break b}b=D()|0;C()|0;break a}f:{if((W(71412)|0)==(d|0)){c=O(c|0)|0;j[114630]=0;E(1990,a|0,b|0)|0;b=j[114630];j[114630]=0;if((b|0)==1){break f}j[114630]=0;E(1990,a|0,37654)|0;b=j[114630];j[114630]=0;if((b|0)==1){break f}j[114630]=0;E(1990,a|0,37697)|0;b=j[114630];j[114630]=0;if((b|0)==1){break f}b=bb[j[j[c>>2]+8>>2]](c)|0;j[114630]=0;E(1990,a|0,(b?b:34181)|0)|0;b=j[114630];j[114630]=0;if((b|0)==1){break f}j[114630]=0;M(20);b=j[114630];j[114630]=0;if((b|0)!=1){break b}b=D()|0;C()|0;break a}e=W(71388)|0;c=O(c|0)|0;g:{if((d|0)==(e|0)){j[114630]=0;E(1990,a|0,b|0)|0;b=j[114630];j[114630]=0;if((b|0)==1){break g}j[114630]=0;E(1990,a|0,37654)|0;b=j[114630];j[114630]=0;if((b|0)==1){break g}j[114630]=0;E(1990,a|0,37680)|0;b=j[114630];j[114630]=0;if((b|0)==1){break g}b=bb[j[j[c>>2]+8>>2]](c)|0;j[114630]=0;E(1990,a|0,(b?b:34181)|0)|0;b=j[114630];j[114630]=0;if((b|0)==1){break g}j[114630]=0;M(20);b=j[114630];j[114630]=0;if((b|0)!=1){break b}b=D()|0;C()|0;break a}j[114630]=0;E(1990,a|0,b|0)|0;b=j[114630];j[114630]=0;if((b|0)==1){break d}j[114630]=0;E(1990,a|0,37654)|0;b=j[114630];j[114630]=0;if((b|0)==1){break d}j[114630]=0;E(1990,a|0,37657)|0;b=j[114630];j[114630]=0;if((b|0)==1){break d}j[114630]=0;M(20);b=j[114630];j[114630]=0;if((b|0)!=1){break b}b=D()|0;C()|0;break a}b=D()|0;C()|0;j[114630]=0;M(20);c=j[114630];j[114630]=0;if((c|0)!=1){break a}break c}b=D()|0;C()|0;j[114630]=0;M(20);c=j[114630];j[114630]=0;if((c|0)!=1){break a}break c}b=D()|0;C()|0;j[114630]=0;M(20);c=j[114630];j[114630]=0;if((c|0)==1){break c}break a}b=D()|0;C()|0;j[114630]=0;M(20);c=j[114630];j[114630]=0;if((c|0)!=1){break a}}J(0)|0;C()|0;ib()}z()}return}gb(a);G(b|0);z()}function N8(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0;e=Za-160|0;Za=e;a:{if(Ri(c)){break a}g=k[Fj(c)|0];f=1;b:{if((g|0)==33){break b}if((g|0)!=63){break a}f=0}d=f;Qj(e+128|0,c,j[c+4>>2]-1|0);f=j[e+132>>2];j[c>>2]=j[e+128>>2];j[c+4>>2]=f}ld(e+128|0);f=j[e+128>>2];ld(e+112|0);h=Ej(f,j[e+116>>2],c);ld(e+128|0);f=j[c>>2];g=j[c+4>>2];c:{d:{e:{f:{if((h|0)==j[e+132>>2]){j[e+152>>2]=f;j[e+156>>2]=g;b=_b(e+144|0,38235);f=j[e+156>>2];j[e+8>>2]=j[e+152>>2];j[e+12>>2]=f;f=j[b+4>>2];j[e>>2]=j[b>>2];j[e+4>>2]=f;if(nc(e+8|0,e)){a=R(8)|0;j[114630]=0;b=E(85,e+128|0,39176)|0;c=j[114630];j[114630]=0;if((c|0)==1){break e}Wb(a,b);j[114630]=0;I(2004,a|0,83648,2012);a=j[114630];j[114630]=0;if((a|0)!=1){break c}c=D()|0;C()|0;gb(b);break d}if(d){b=R(8)|0;j[114630]=0;d=E(2136,e+112|0,c|0)|0;a=j[114630];j[114630]=0;g:{h:{i:{if((a|0)!=1){j[114630]=0;I(2113,e+128|0,39186,d|0);a=j[114630];j[114630]=0;if((a|0)==1){break i}Wb(b,e+128|0);a=0;j[114630]=0;I(2004,b|0,83648,2012);c=j[114630];j[114630]=0;if((c|0)!=1){break c}c=D()|0;C()|0;gb(e+128|0);break h}c=D()|0;C()|0;break g}c=D()|0;a=1;C()|0}gb(d);if(!a){break d}}S(b|0);break d}Cb(a);break f}j[e+104>>2]=f;j[e+108>>2]=g;d=_b(e+96|0,38235);f=j[e+108>>2];j[e+56>>2]=j[e+104>>2];j[e+60>>2]=f;f=j[d+4>>2];j[e+48>>2]=j[d>>2];j[e+52>>2]=f;if(nc(e+56|0,e+48|0)){a=R(8)|0;j[114630]=0;b=E(85,e+128|0,39176)|0;c=j[114630];j[114630]=0;if((c|0)!=1){Wb(a,b);j[114630]=0;I(2004,a|0,83648,2012);a=j[114630];j[114630]=0;if((a|0)!=1){break c}c=D()|0;C()|0;gb(b);break d}c=D()|0;C()|0;S(a|0);break d}d=j[c+4>>2];j[e+88>>2]=j[c>>2];j[e+92>>2]=d;d=_b(e+80|0,39065);f=j[e+92>>2];j[e+40>>2]=j[e+88>>2];j[e+44>>2]=f;f=j[d+4>>2];j[e+32>>2]=j[d>>2];j[e+36>>2]=f;if(nc(e+40|0,e+32|0)){j:{switch(j[b+52>>2]){case 0:Db(a,39258);break f;case 1:Db(a,39266);break f;case 2:Db(a,39275);break f;default:break j}}Cb(a);break f}d=j[c+4>>2];j[e+72>>2]=j[c>>2];j[e+76>>2]=d;c=_b(e- -64|0,39108);d=j[e+76>>2];j[e+24>>2]=j[e+72>>2];j[e+28>>2]=d;d=j[c+4>>2];j[e+16>>2]=j[c>>2];j[e+20>>2]=d;if(nc(e+24|0,e+16|0)){k:{switch(j[b+56>>2]){case 0:Db(a,39280);break f;case 1:Db(a,39285);break f;case 2:Db(a,39291);break f;case 3:Db(a,39302);break f;default:break k}}Cb(a);break f}Cb(a)}Za=e+160|0;return}c=D()|0;C()|0;S(a|0)}G(c|0)}z()}function YKa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,l=0,n=0,o=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0;e=Za-32|0;Za=e;o=ni(e+24|0);if(j[a+12>>2]){v=o+3|0;w=o+5|0;x=o+4|0;y=o+2|0;z=o+1|0;A=e+16|5;B=e+16|3;while(1){C=Fp(a,s);while(1){a:{if(!yb(c,1)){break a}q=dd(c);if((q|0)==255){break a}l=q&31;d=Kj(a)>>>0>l>>>0;l=p(l,6)+C|0;b:{if(!(q&64)){f=dd(c);g=f<<24>>24;c:{d:{e:{f=f&127;switch(f|0){case 0:break c;case 1:break e;default:break d}}h[(d?l:e+24|0)|0]=255;break c}if(!(!b|f>>>0>121)){h[(d?l:e+24|0)|0]=f-1;break c}if((f-12&255)>>>0>96|b){break c}h[(d?l:e+24|0)|0]=f+13}E=d?l+1|0:z,F=dd(c),h[E|0]=F;if((g|0)>-1){break b}}u=d?l:o;g=d?l+3|0:v;f=d?l+5|0:w;t=d?l+4|0:x;r=d?l+2|0:y;l=d?l:e+24|0;while(1){d=l;j[e+16>>2]=k[d|0]|k[d+1|0]<<8|(k[d+2|0]<<16|k[d+3|0]<<24);i[e+20>>1]=k[d+4|0]|k[d+5|0]<<8;d=dd(c);D=d&128;n=d&63;f:{if(d&64){h[r|0]=1;h[t|0]=n;break f}d=dd(c);h[f|0]=d;g:{h:{if(n>>>0<=15){h[g|0]=n;_i(u);i:{j:{k:{d=k[g|0];switch(d-9|0){case 1:case 2:case 3:break g;case 4:break j;case 0:break k;default:break i}}h[g|0]=9;h[f|0]=p(k[f|0]&15,17);break g}h[g|0]=0;h[r|0]=1;j[e+12>>2]=k[f|0]+1>>>1;j[e+8>>2]=64;E=t,F=j[Pd(e+12|0,e+8|0)>>2],h[E|0]=F;break g}if((d|0)!=19){break g}if(k[f|0]==128){break h}Fw(u);break g}if(n>>>0>44){break g}n=n-16|0;h[g|0]=k[n+12272|0];l:{switch(n|0){case 0:if(d>>>0>1){break h}h[f|0]=d|158;break g;case 1:case 2:h[e+12|0]=15;E=f,F=k[Zb(e+12|0,f)|0]|224,h[E|0]=F;break g;case 5:case 6:j[e+12>>2]=16;j[e+8>>2]=d+1;E=f,F=j[Pd(e+12|0,e+8|0)>>2]/2|240,h[E|0]=F;break g;case 14:m:{n:{o:{p:{q:{n=d>>>4|0;switch(n-1|0){case 1:break o;case 0:break p;default:break q}}switch(n-10|0){case 1:break m;case 0:break n;default:break h}}h[g|0]=2;h[f|0]=d|240;break g}h[g|0]=3;h[f|0]=d|240;break g}h[g|0]=11;h[f|0]=(d<<3&120)+8|15;break g}h[g|0]=11;h[f|0]=(d&15)+1>>>1|240;break g;case 12:break l;default:break g}}j[e+12>>2]=d+1>>>1;j[e+8>>2]=64;E=f,F=j[Pd(e+12|0,e+8|0)>>2],h[E|0]=F;break g}h[g|0]=0}Dw(g,f,B,A);if(ym(k[e+19|0])>>>0<=ym(k[g|0])>>>0){break f}r:{if(k[r|0]){break r}if(!Ew(g,f,1)){break r}h[r|0]=k[g|0];h[t|0]=k[f|0]}h[g|0]=k[e+19|0];h[f|0]=k[e+21|0]}if(D){continue}break}}if(!(q&128)){continue}}break}s=s+1|0;if(s>>>0<m[a+12>>2]){continue}break}}Za=e+32|0}function mca(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;var k=0,l=0,m=0;l=Za-80|0;Za=l;a:{b:{c:{k=Mn(1,32);d:{e:{if(!k){a=R(4)|0;Bk(a);j[114630]=0;I(2004,a|0,71412,2003);a=j[114630];j[114630]=0;if((a|0)!=1){break a}i=J(0)|0;C()|0;break e}j[k+16>>2]=0;j[k+20>>2]=0;j[k+12>>2]=f;j[k+8>>2]=e;j[k+4>>2]=d;j[k+24>>2]=0;j[k+28>>2]=0;j[k>>2]=c?c:1992;d=_r(l- -64|0);f:{g:{if(!i){break g}c=j[i>>2];if(!c){break g}while(1){h:{e=j[i+4>>2];if(e){j[114630]=0;c=E(85,l+48|0,c|0)|0;f=j[114630];j[114630]=0;i:{if((f|0)!=1){j[114630]=0;f=E(2005,d|0,c|0)|0;m=j[114630];j[114630]=0;if((m|0)==1){break i}j[114630]=0;E(483,f|0,e|0)|0;e=j[114630];j[114630]=0;if((e|0)==1){break i}break h}i=J(0)|0;C()|0;break f}i=J(0)|0;C()|0;gb(c);break f}j[114630]=0;c=E(85,l+48|0,c|0)|0;e=j[114630];j[114630]=0;j:{if((e|0)!=1){j[114630]=0;E(2006,d|0,c|0)|0;e=j[114630];j[114630]=0;if((e|0)==1){break j}break h}i=J(0)|0;C()|0;break f}i=J(0)|0;C()|0;gb(c);break f}gb(c);c=j[i+8>>2];i=i+8|0;if(c){continue}break}}c=j[a+8>>2];e=j[a+4>>2];f=j[a>>2];j[114630]=0;a=H(1394,96)|0;i=j[114630];j[114630]=0;k:{l:{m:{if((i|0)!=1){j[114630]=0;j[l+44>>2]=c;j[l+40>>2]=e;j[l+36>>2]=f;j[l+32>>2]=b;I(2007,l+48|0,k|0,k+4|0);b=j[114630];j[114630]=0;if((b|0)==1){break m}b=io(l+24|0,l+48|0);j[114630]=0;c=j[l+44>>2];j[l+16>>2]=j[l+40>>2];j[l+20>>2]=c;c=j[l+36>>2];j[l+8>>2]=j[l+32>>2];j[l+12>>2]=c;P(2081,a|0,l+8|0,b|0,d|0)|0;c=j[114630];j[114630]=0;if((c|0)==1){break l}j[k+28>>2]=a;Gc(b);Gc(l+48|0);a=j[k+28>>2];j[k+24>>2]=a?a+8|0:0;Sj(d);break d}i=J(0)|0;C()|0;break f}i=J(0)|0;C()|0;break k}i=J(0)|0;C()|0;Gc(b);Gc(l+48|0)}Fb(a)}Sj(d);O(i|0)|0;j[114630]=0;L(1984,37229,k|0,g|0,h|0);a=j[114630];j[114630]=0;if((a|0)!=1){j[114630]=0;M(20);a=j[114630];j[114630]=0;if((a|0)!=1){a=j[k+28>>2];if(a){bb[j[j[a>>2]+4>>2]](a)}j[k+24>>2]=0;j[k+28>>2]=0;a=j[k+20>>2];if(a){Fb(a);j[k+20>>2]=0}Fb(k);k=0;break d}i=J(0)|0;C()|0;break e}i=J(0)|0;C()|0;j[114630]=0;M(20);a=j[114630];j[114630]=0;if((a|0)==1){break b}}O(i|0)|0;k=0;j[114630]=0;L(1984,37229,0,g|0,h|0);a=j[114630];j[114630]=0;if((a|0)==1){break c}Q()}Za=l+80|0;return k|0}a=D()|0;C()|0;j[114630]=0;M(20);b=j[114630];j[114630]=0;if((b|0)==1){break b}G(a|0);z()}J(0)|0;C()|0;ib()}z()}function B_(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0;d=Za-336|0;Za=d;O0(a);e=j[a+28>>2];a:{if(!mf(j[j[e>>2]-12>>2]+e|0)){mg(a,1073741825);break a}Ve(d- -64|0,j[a+28>>2]);e=d- -64|0;f=j[e+12>>2];j[a+8>>2]=j[e+8>>2];j[a+12>>2]=f;v_(yc(d- -64|0,3),j[a+28>>2],d+24|0);if(_c(d+24|0,6931,3)){mg(a,1073741827);break a}h[d+335|0]=0;ch(j[a+28>>2],d+335|0);kC(d- -64|0);g=b;f=d+24|0;b=d- -64|0;e=k[d+335|0];if(e){Aj(j[a+28>>2],d- -64|0,e);e=k[d+335|0]}else{e=0}b=Vl(f,b,e);e=Nu(g,b);qb(b);if(!e){mg(a,1073741830)}if(k[a+3|0]&64){break a}ch(j[a+28>>2],d+63|0);e=k[d+63|0];b=e&3;i[a+16>>1]=(b|0)==3?4:b;if(Ch(e,6)){mj(a,9,1)}j[d+56>>2]=0;hC(j[a+28>>2],d+56|0);b=j[d+56>>2];h[d+55|0]=0;if(b>>>0>=2){ch(j[a+28>>2],d+63|0);f=k[d+63|0];if(!f){ch(j[a+28>>2],d+55|0);f=k[d+63|0]}Lk(j[a+28>>2],b+(f?-1:-2)|0,-1)}j[d+40>>2]=0;j[d+44>>2]=0;b:{if(!Ch(e,4)){break b}lj(j[a+28>>2],d+40|0);b=j[d+44>>2];f=j[d+40>>2];j[a+56>>2]=f;j[a+60>>2]=b;g=j[c+4>>2];if((g|0)==(b|0)&m[c>>2]>=f>>>0|b>>>0<g>>>0){break b}mg(a,536871424)}if(Ch(e,5)){ch(j[a+28>>2],d+63|0);Lk(j[a+28>>2],k[d+63|0],-1)}c:{if(!Ch(k[d+55|0],0)){break c}ch(j[a+28>>2],d+63|0);b=k[d+63|0];b=b&1?-1:b>>>1|0;i[a+16>>1]=b;if(b){break c}mg(a,536871168)}j[a+4>>2]=0;b=1;if(Ch(k[d+55|0],1)){hC(j[a+28>>2],a+4|0)}mj(a,6,Ch(e,2));mj(a,7,Ch(e,3));mj(a,5,l[a+16>>1]!=0);mj(a,8,Ch(e,7));d:{if(gd(a,5)){break d}if(gd(a,6)){break d}if(gd(a,7)){break d}b=gd(a,8)}mj(a,11,b);gd(a,11);b=k[d+55|0];if(Ch(b,2)){i[d+24>>1]=0;Ku(j[a+28>>2],d+24|0);Lk(j[a+28>>2],p(l[d+24>>1],gd(a,9)?2:1),-1);b=k[d+55|0]}if(Ch(b&255,3)){Lk(j[a+28>>2],5,-1)}lj(j[a+28>>2],d+40|0);c=j[d+44>>2];b=j[d+40>>2];if(!c&b>>>0>=16001|c){mg(a,1073741831);break a}j[a+92>>2]=b;if(!b){mg(a,536871040)}e:{if(!gd(a,11)){break e}lj(j[a+28>>2],d+40|0);b=j[d+44>>2];if((b|0)==2147483647|b>>>0<2147483647){break e}mg(a,1073741829);break a}Ve(d+8|0,j[a+28>>2]);DC(d+24|0,d+8|0,j[a+8>>2],j[a+12>>2]);b=j[d+36>>2];e=j[d+32>>2];if(!(b?0:(b|0)>0?1:(b|0)>=0)){mg(a,1073741832);break a}j[a+88>>2]=e;b=a;f:{if(gd(a,11)){c=j[d+40>>2];break f}c=j[a+88>>2]}j[b+64>>2]=c;if(!gd(a,11)){c=j[a+12>>2];e=j[a+88>>2];f=e+j[a+8>>2]|0;c=f>>>0<e>>>0?c+1|0:c;j[a+72>>2]=f;j[a+76>>2]=c}mj(a,10,1)}Za=d+336|0}function fia(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,l=0,m=0;e=Za-176|0;Za=e;Ve(e+160|0,b);a:{b:{c:{d:{e:{f:{g:{h:{i:{j:{k:{l:{g=dia(a,b,c,d);if(!g){mn(j[j[b>>2]-12>>2]+b|0,0);g=j[e+172>>2];j[e+8>>2]=j[e+168>>2];j[e+12>>2]=g;g=j[e+164>>2];j[e>>2]=j[e+160>>2];j[e+4>>2]=g;Hi(b,e);b=Gk(e+56|0,b);j[114630]=0;g=E(683,e+40|0,32531)|0;f=j[114630];j[114630]=0;if((f|0)==1){break b}j[114630]=0;j[e+32>>2]=3;j[e+36>>2]=0;I(684,b|0,g|0,e+32|0);f=j[114630];j[114630]=0;if((f|0)==1){break c}qb(g);j[114630]=0;h[e+31|0]=0;g=E(683,e+40|0,32534)|0;f=j[114630];j[114630]=0;if((f|0)==1){break d}j[114630]=0;K(685,b|0,e+31|0,g|0)|0;f=j[114630];j[114630]=0;if((f|0)==1){break e}qb(g);j[114630]=0;g=k[e+31|0];f=H(1619,b|0)|0;l=j[114630];j[114630]=0;if((l|0)==1){break f}j[114630]=0;l=H(1620,b|0)|0;m=j[114630];j[114630]=0;if((m|0)==1){break g}j[e+32>>2]=l;j[e+24>>2]=f;if(rb(e+24|0,e+32|0)){g=g?0:d;while(1){j[114630]=0;i[e+22>>1]=65535;d=E(683,e+40|0,32539)|0;f=j[114630];j[114630]=0;if((f|0)==1){break j}j[114630]=0;f=K(1621,b|0,e+24|0,d|0)|0;l=j[114630];j[114630]=0;if((l|0)==1){break i}qb(d);m:{if(!f){j[114630]=0;L(1622,b|0,e+24|0,c|0,g|0);d=j[114630];j[114630]=0;if((d|0)==1){break h}break m}j[114630]=0;d=E(683,e+40|0,32541)|0;f=j[114630];j[114630]=0;n:{o:{if((f|0)!=1){j[114630]=0;f=K(1621,b|0,e+24|0,d|0)|0;l=j[114630];j[114630]=0;if((l|0)==1){break o}qb(d);if(f){break n}j[114630]=0;K(1623,b|0,e+24|0,e+22|0)|0;d=j[114630];j[114630]=0;if((d|0)!=1){break m}break h}a=D()|0;C()|0;break a}a=D()|0;C()|0;qb(d);break a}j[114630]=0;d=E(683,e+40|0,32543)|0;f=j[114630];j[114630]=0;if((f|0)==1){break l}j[114630]=0;f=K(1621,b|0,e+24|0,d|0)|0;l=j[114630];j[114630]=0;if((l|0)==1){break k}qb(d);if(f){break m}j[114630]=0;L(1624,b|0,e+24|0,a|0,g|0);d=j[114630];j[114630]=0;if((d|0)==1){break h}}yf(e+24|0);if(rb(e+24|0,e+32|0)){continue}break}}a=j[b>>2];ag(b);g=a&1073741824?-1:1}Za=e+176|0;return g|0}a=D()|0;C()|0;break a}a=D()|0;C()|0;qb(d);break a}a=D()|0;C()|0;break a}a=D()|0;C()|0;qb(d);break a}a=D()|0;C()|0;break a}a=D()|0;C()|0;break a}a=D()|0;C()|0;break a}a=D()|0;C()|0;qb(g);break a}a=D()|0;C()|0;break a}a=D()|0;C()|0;qb(g);break a}a=D()|0;C()|0}ag(b);G(a|0);z()}function lua(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;e=Za-80|0;Za=e;w=j[a+16>>2];h=vf(e+48|0);j[h+8>>2]=a+112;j[h+16>>2]=j[a+128>>2];y=h,z=qf(b+327720|0,j[b+20>>2],(j[a+88>>2]&16384)>>>14|0),j[y+12>>2]=z;b=j[h+16>>2];if(b){y=h,z=uf(a+8|0,b),j[y>>2]=z;j[h+4>>2]=ab}f=j[a+44>>2];j[e+32>>2]=f;o=j[a+48>>2];j[e+36>>2]=o;m=j[a+52>>2];j[e+40>>2]=m;n=j[a+56>>2];j[e+44>>2]=n;q=j[a+40>>2];r=j[a+36>>2];k=j[a+4>>2];g=j[a>>2];j[e+24>>2]=g;j[e+28>>2]=k;b=j[a+12>>2];j[e+16>>2]=j[a+8>>2];j[e+20>>2]=b;a:{if(!d){b=q>>12;l=r>>12;break a}while(1){b=0;f=b;l=g;j[e+72>>2]=g;j[e+76>>2]=b;k=((((k&2147483647)<<1|g>>>31)&2147483646)<<1)+w|0;b:{b=j[h+16>>2];if((b|0)<=0){break b}while(1){g=(f&2147483647)<<1|l>>>31;id(j[h+8>>2],(i[(g<<1|2)+k>>1]+i[k+((g&2147483646)<<1)>>1]|0)/8<<16>>16);hd(j[h+8>>2],4);Bb(e+72|0,h);if((b|0)<2){break b}b=b-1|0;l=j[e+72>>2];f=j[e+76>>2];continue}}b=j[h+8>>2];Bb(b,b+8|0);b=j[h+8>>2];g=j[b+4>>2];if(g){f=b;b=(j[e+76>>2]&2147483647)<<1|j[e+72>>2]>>>31;id(f,(i[(b<<1|2)+k>>1]+i[k+((b&2147483646)<<1)>>1]|0)/8<<16>>16);hd(j[h+8>>2],g);b=j[h+8>>2];g=j[b>>2];j[b>>2]=g;j[b+4>>2]=0}d=d-1|0;f=pf(b,j[h+12>>2]);j[e+12>>2]=f;j[e+8>>2]=f;l=0;o=1;while(1){m=j[a+60>>2];n=m;k=(e+32|0)+(l<<3)|0;s=j[k>>2];b=Gb(s,-16777216,16776704);v=j[a+64>>2];g=Gb(j[k+4>>2],-16777216,16776704);t=j[a+68>>2];x=t;t=t>>31;j[k+4>>2]=s;s=j[a+72>>2];u=m>>31;m=f<<8;f=m;f=HMa(n,u,f,f>>31);n=ab;u=(e+8|0)+(l<<2)|0;l=HMa(v,v>>31,b,b>>31);f=l+f|0;b=ab+n|0;b=f>>>0<l>>>0?b+1|0:b;n=f;f=HMa(x,t,g,g>>31);g=n+f|0;b=ab+b|0;b=g>>>0<f>>>0?b+1|0:b;g=g+8388608|0;if(g>>>0<8388608){b=b+1|0}b=(b&16777215)<<8|g>>>24;j[u>>2]=(b|0)/256;j[k>>2]=b-(m&s);if(o){l=1;o=0;f=j[e+12>>2];continue}break}b=j[a+32>>2];r=j[a+28>>2]+r|0;l=r>>12;j[c>>2]=j[c>>2]+p(l,j[e+8>>2]);q=b+q|0;b=q>>12;j[c+4>>2]=j[c+4>>2]+p(b,j[e+12>>2]);Bb(e+24|0,e+16|0);if(d){c=c+8|0;g=j[e+24>>2];k=j[e+28>>2];continue}break}g=j[e+24>>2];k=j[e+28>>2];n=j[e+44>>2];m=j[e+40>>2];o=j[e+36>>2];f=j[e+32>>2]}j[a+40>>2]=q;j[a+20>>2]=l;j[a+36>>2]=r;j[a+56>>2]=n;j[a+52>>2]=m;j[a+48>>2]=o;j[a+44>>2]=f;j[a+24>>2]=b;j[a>>2]=g;j[a+4>>2]=k;Za=e+80|0}function zoa(a,b,c,d,e){var f=0,g=0,i=0,m=q(0),o=0,r=0,s=0,t=q(0),u=0,v=0;g=Za-32|0;Za=g;j[g+28>>2]=e;a:{if(!e){break a}f=k[d|0];i=f-250|0;if(!(i>>>0>5|!(1<<i&37))){if(l[a+480188>>1]){f=0;while(1){i=(p(f,896)+a|0)+1075841|0;h[i|0]=127;h[i+1|0]=0;f=f+1|0;if(f>>>0<l[a+480188>>1]){continue}break}}f=k[d|0]}b:{if((f&255)!=240){break b}f=k[d+1|0];if((f&254)!=240){break b}if(e>>>0<4){break a}i=(p(b,896)+a|0)+1074984|0;e=h[d+3|0];r=(e|0)<0;d=k[d+2|0];if(!(r|(f|0)==241|d)){d=p(b,896)+a|0;f=d+1075841|0;o=f;if(c){e=lK(zo(a,q(k[f|0]),q((e&255)>>>0)))}h[o|0]=e;h[d+1075802|0]=0;o=4;c=d+1075072|0;d=Io(a,i,!(j[c>>2]&32768),256);if((d|0)<0|!(k[c+1|0]&2)){break a}a=a+1304392|0;if(!$c(a)){break a}No(j[a>>2],b,d>>>2&255,1);break a}if(!(r|(f|0)==241|(d|0)!=1)){b=p(b,896)+a|0;d=b+1075842|0;c:{if(!c){break c}m=zo(a,q(k[d|0]),q((e&255)>>>0));if(m<q(4294967296)&m>=q(0)){e=~~m>>>0;break c}e=0}h[d|0]=e;h[b+1075801|0]=0;Io(a,i,!(j[b+1075072>>2]&32768),256);o=4;break a}r=(f|0)==241;if(!(r|(d|0)!=2)){o=4;if((e&255)>>>0>31){break a}b=p(b,896)+a|0;h[b+1075849|0]=(e&240)>>>4;Io(a,i,!(j[b+1075072>>2]&32768),256);break a}if(!(r|(d|0)!=3)){o=4;b=bl(a,b,3,0);if((e|0)<0|(b+5&255)>>>0<6){break a}b=(p(b,160)+a|0)+906284|0;m=q(q(((e^127)&255)>>>0)*q(.007874015718698502));if(!c){n[b>>2]=m;break a}s=b,t=zo(a,n[b>>2],m),n[s>>2]=t;break a}if(d&128?0:(f|0)!=241){break a}o=4;b=bl(a,b,3,0);if((e|0)<0|(b+5&255)>>>0<6){break a}b=j[(p(b,160)+a|0)+906140>>2];if(!b){break a}d=(f|0)==241?d+128|0:d&127;m=q(q((e&255)>>>0)*q(.007874015718698502));if(!c){bb[j[j[b>>2]+44>>2]](b,d,m);break a}u=b,v=d,t=zo(a,q(bb[j[j[b>>2]+48>>2]](b,d)),m),s=j[j[b>>2]+44>>2],bb[s](u|0,v|0,q(t));break a}d:{e:{if(l[a+480188>>1]>b>>>0){f=b+1|0;break e}f=l[(p(b,896)+a|0)+1075792>>1];if(!f){break d}}if(k[(p(b,896)+a|0)+1075075|0]&4|l[a+480188>>1]<(f&65535)>>>0){break d}b=bl(a,b,3,0);if(!b|b-251>>>0<5){break d}a=j[(p(b,160)+a|0)+906140>>2];if(!a){break d}b=k[d|0];if((b|0)==240){Qb(g+16|0,lb(d),e);bb[j[j[a>>2]+72>>2]](a,g+16|0)|0;break d}s=g,v=NM(b),j[s+12>>2]=v;b=j[tb(g+12|0,g+28|0)>>2];j[g+12>>2]=0;Vb(g+12|0,d,b);bb[j[j[a>>2]+68>>2]](a,j[g+12>>2])|0}o=j[g+28>>2]}Za=g+32|0;return o}function gw(a){a=a|0;var b=0,c=0,d=q(0),e=0;Ab(a+4960|0,0,76);h[a+5044|0]=0;j[a+5036>>2]=0;j[a+5040>>2]=0;b=j[a+4292>>2];d=n[a+4268>>2];j[114630]=0;e=a+4504|0;if(d<q(4294967296)&d>=q(0)){c=~~d>>>0}else{c=0}V(1911,e|0,67,5,c|0,b|0);b=j[114630];j[114630]=0;a:{if((b|0)==1){break a}b=j[a+4296>>2];j[114630]=0;V(1911,a+4528|0,62,5,c|0,b|0);b=j[114630];j[114630]=0;if((b|0)==1){break a}b=j[a+4300>>2];j[114630]=0;V(1911,a+4552|0,53,5,c|0,b|0);b=j[114630];j[114630]=0;if((b|0)==1){break a}b=j[a+4304>>2];j[114630]=0;V(1911,a+4576|0,43,5,c|0,b|0);b=j[114630];j[114630]=0;if((b|0)==1){break a}b=j[a+4308>>2];j[114630]=0;V(1911,a+4600|0,32,5,c|0,b|0);b=j[114630];j[114630]=0;if((b|0)==1){break a}b=j[a+4312>>2];j[114630]=0;V(1911,a+4624|0,22,5,c|0,b|0);b=j[114630];j[114630]=0;if((b|0)==1){break a}b=j[a+4316>>2];j[114630]=0;V(1911,a+4648|0,75,5,c|0,b|0);b=j[114630];j[114630]=0;if((b|0)==1){break a}b=j[a+4320>>2];j[114630]=0;V(1911,a+4672|0,69,5,c|0,b|0);b=j[114630];j[114630]=0;if((b|0)==1){break a}b=j[a+4324>>2];j[114630]=0;V(1911,a+4696|0,60,5,c|0,b|0);b=j[114630];j[114630]=0;if((b|0)==1){break a}b=j[a+4328>>2];j[114630]=0;V(1911,a+4720|0,48,5,c|0,b|0);b=j[114630];j[114630]=0;if((b|0)==1){break a}b=j[a+4332>>2];j[114630]=0;V(1911,a+4744|0,36,5,c|0,b|0);b=j[114630];j[114630]=0;if((b|0)==1){break a}b=j[a+4336>>2];j[114630]=0;V(1911,a+4768|0,25,5,c|0,b|0);b=j[114630];j[114630]=0;if((b|0)==1){break a}j[114630]=0;V(1911,a+4792|0,0,0,0,0);b=j[114630];j[114630]=0;if((b|0)==1){break a}b=j[a+4344>>2];j[114630]=0;V(1911,a+4816|0,3,0,c|0,b|0);b=j[114630];j[114630]=0;if((b|0)==1){break a}b=j[a+4348>>2];j[114630]=0;V(1911,a+4840|0,3,0,c|0,b|0);b=j[114630];j[114630]=0;if((b|0)==1){break a}j[114630]=0;V(1911,a+4864|0,407,1,c|0,0);b=j[114630];j[114630]=0;if((b|0)==1){break a}j[114630]=0;V(1911,a+4888|0,400,1,c|0,0);b=j[114630];j[114630]=0;if((b|0)==1){break a}j[114630]=0;V(1911,a+4912|0,10,0,c|0,-1);b=j[114630];j[114630]=0;if((b|0)==1){break a}j[114630]=0;V(1911,a+4936|0,10,0,c|0,-1);c=j[114630];j[114630]=0;if((c|0)==1){break a}h[a+5045|0]=1;return}c=J(71412)|0;if((C()|0)==(W(71412)|0)){O(c|0)|0;h[a+5045|0]=0;Q();return}G(c|0);z()}function CG(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;var k=0,l=0,m=0;k=Za-80|0;Za=k;a:{b:{c:{d:{e:{f:{l=Mn(1,28);if(!l){a=R(4)|0;Bk(a);j[114630]=0;I(2004,a|0,71412,2003);a=j[114630];j[114630]=0;if((a|0)!=1){break a}break f}j[l+24>>2]=0;j[l+16>>2]=0;j[l+20>>2]=0;j[l+12>>2]=f;j[l+8>>2]=e;j[l+4>>2]=d;j[l>>2]=c?c:1992;d=_r(k- -64|0);g:{h:{if(!i){break h}c=j[i>>2];if(!c){break h}while(1){i:{e=j[i+4>>2];if(e){j[114630]=0;c=E(85,k+48|0,c|0)|0;f=j[114630];j[114630]=0;j:{if((f|0)!=1){j[114630]=0;f=E(2005,d|0,c|0)|0;m=j[114630];j[114630]=0;if((m|0)==1){break j}j[114630]=0;E(483,f|0,e|0)|0;e=j[114630];j[114630]=0;if((e|0)==1){break j}break i}i=J(0)|0;C()|0;break g}i=J(0)|0;C()|0;gb(c);break g}j[114630]=0;c=E(85,k+48|0,c|0)|0;e=j[114630];j[114630]=0;k:{if((e|0)!=1){j[114630]=0;E(2006,d|0,c|0)|0;e=j[114630];j[114630]=0;if((e|0)==1){break k}break i}i=J(0)|0;C()|0;break g}i=J(0)|0;C()|0;gb(c);break g}gb(c);c=j[i+8>>2];i=i+8|0;if(c){continue}break}}c=j[a+8>>2];e=j[a+4>>2];f=j[a>>2];j[114630]=0;a=H(1394,80)|0;i=j[114630];j[114630]=0;l:{m:{n:{if((i|0)!=1){j[114630]=0;j[k+44>>2]=c;j[k+40>>2]=e;j[k+36>>2]=f;j[k+32>>2]=b;I(2007,k+48|0,l|0,l+4|0);b=j[114630];j[114630]=0;if((b|0)==1){break n}b=io(k+24|0,k+48|0);j[114630]=0;c=j[k+44>>2];j[k+16>>2]=j[k+40>>2];j[k+20>>2]=c;c=j[k+36>>2];j[k+8>>2]=j[k+32>>2];j[k+12>>2]=c;P(2008,a|0,k+8|0,b|0,d|0)|0;c=j[114630];j[114630]=0;if((c|0)==1){break m}j[l+24>>2]=a;Gc(b);Gc(k+48|0);Sj(d);c=l;break d}i=J(0)|0;C()|0;break g}i=J(0)|0;C()|0;break l}i=J(0)|0;C()|0;Gc(b);Gc(k+48|0)}Fb(a)}Sj(d);O(i|0)|0;j[114630]=0;L(1984,34722,l|0,g|0,h|0);a=j[114630];j[114630]=0;if((a|0)!=1){j[114630]=0;M(20);a=j[114630];j[114630]=0;if((a|0)==1){break f}a=j[l+24>>2];if(a){Fb(gr(a))}c=0;j[l+24>>2]=0;a=j[l+20>>2];if(a){Fb(a);j[l+20>>2]=0}Fb(l);break d}i=J(0)|0;C()|0;j[114630]=0;M(20);a=j[114630];j[114630]=0;if((a|0)!=1){break e}break b}i=J(0)|0;C()|0}O(i|0)|0;c=0;j[114630]=0;L(1984,34722,0,g|0,h|0);a=j[114630];j[114630]=0;if((a|0)==1){break c}Q()}Za=k+80|0;return c|0}a=D()|0;C()|0;j[114630]=0;M(20);b=j[114630];j[114630]=0;if((b|0)==1){break b}G(a|0);z()}J(0)|0;C()|0;ib()}z()}function Dm(a,b,c){var d=0,e=0,f=0,g=0,i=0,l=0,n=0,o=0,q=0;f=Za-16|0;Za=f;j[b+88>>2]=j[b+88>>2]|524288;a:{b:{if(!(j[a+480208>>2]&8)){mb(f+8|0,a+1074308|0,15);if(kb(f+8|0)){break b}}if(j[a+480180>>2]!=268435456){break a}}c=c?c:k[b+831|0];h[b+832|0]=c;h[b+831|0]=c}c:{if(Yi(b)){e=j[a+1074392>>2];l=j[b+880>>2];d:{if(c){j[b+776>>2]=c;break d}c=j[b+776>>2];if(!c){break c}}d=j[b+708>>2];e:{f:{if((d|0)>=1){if((c|0)<0){break f}break e}if(!d|(c|0)<1){break e}}c=0-c|0;j[b+776>>2]=c}g=b;i=(+(e>>>0)+1)*+(c|0)/+m[a+1074416>>2];g:{if(r(i)<2147483648){c=~~i;break g}c=-2147483648}j[g+880>>2]=c;if(k[b+90|0]&16){c=p(j[j[j[b+656>>2]+44>>2]+36>>2]+1|0,c);j[b+880>>2]=c}a=c-(e?l:0)|0;c=a>>31;e=d>>31;if((e+d^e)>>>0<=(c^a+c)>>>0){if(!d){break c}j[b+708>>2]=0;j[b+876>>2]=d+j[b+876>>2];h[b+872|0]=k[b+872|0]|8;break c}j[b+708>>2]=d-a;j[b+876>>2]=a+j[b+876>>2];h[b+872|0]=k[b+872|0]|8;break c}d=1;h:{if(!(h[b+872|0]&1)|j[a+480180>>2]&524352){break h}if(j[a+1074416>>2]==1){mb(f+8|0,a+1074308|0,6);if(kb(f+8|0)){break h}}d=0;if(j[a+480180>>2]!=8){break h}d=(k[a+480208|0]&2)>>>1|0}if(!(j[a+480180>>2]!=268435456|c>>>0<240)){d=h[b+872|0]&1;c=c-240|0}if(c){j[b+776>>2]=(j[a+480180>>2]==64?p(c,10):c)<<2}e=j[b+708>>2];c=j[b+700>>2];i:{if(!c){c=0;break i}if(!e|d^1){break i}g=b;j:{if((c|0)<(e|0)){d=j[b+776>>2];k:{if(!(k[a+480208|0]&16)){break k}if(j[a+480180>>2]==4){c=j[b+700>>2];break k}c=j[b+776>>2]/4|0;c=j[((c>>>0<255?c:255)<<2)+25312>>2];d=c;e=c>>31;c=j[b+700>>2];d=HMa(d,e,c,c>>31)+32768|0;c=ab;d=ic(IMa(d,d>>>0<32768?c+1|0:c,65536,0),ab);c=j[b+700>>2];d=d-c|0;d=(d|0)>1?d:1}e=j[b+708>>2];c=c+d|0;c=(c|0)>(e|0)?e:c;break j}if((c|0)<=(e|0)){break i}d=0-j[b+776>>2]|0;l:{if(!(k[a+480208|0]&16)){break l}if(j[a+480180>>2]==4){c=j[b+700>>2];break l}c=j[b+776>>2]/4|0;c=j[((c>>>0<255?c:255)<<2)+26336>>2];d=c;e=c>>31;c=j[b+700>>2];d=HMa(d,e,c,c>>31)+32768|0;c=ab;d=ic(IMa(d,d>>>0<32768?c+1|0:c,65536,0),ab);c=j[b+700>>2];d=d-c|0;d=(d|0)<-1?d:-1}e=j[b+708>>2];c=c+d|0;c=(c|0)<(e|0)?e:c}j[g+700>>2]=c}if((c|0)!=(e|0)){break c}mb(f+8|0,a+1074308|0,25);if(n=!kb(f+8|0),o=0,q=j[a+480180>>2]!=1,q?n:o){break c}j[b+708>>2]=0}Za=f+16|0}function xD(a,b,c,d){var e=0,f=0,g=0,i=0,l=0,n=0,o=0;f=Za-48|0;Za=f;a:{if(c>>>0<=2){c=c<<2;i=j[c+59836>>2];o=j[c+59824>>2];while(1){c=j[b+4>>2];b:{if(c>>>0<m[b+104>>2]){j[b+4>>2]=c+1;c=k[c|0];break b}c=Jc(b)}if(Jk(c)){continue}break}g=1;c:{d:{switch(c-43|0){case 0:case 2:break d;default:break c}}g=(c|0)==45?-1:1;c=j[b+4>>2];if(c>>>0<m[b+104>>2]){j[b+4>>2]=c+1;c=k[c|0];break c}c=Jc(b)}e:{f:{while(1){if(h[e+59752|0]==(c|32)){g:{if(e>>>0>6){break g}c=j[b+4>>2];if(c>>>0<m[b+104>>2]){j[b+4>>2]=c+1;c=k[c|0];break g}c=Jc(b)}e=e+1|0;if((e|0)!=8){continue}break f}break}if((e|0)!=3){if((e|0)==8){break f}if(!d|e>>>0<4){break e}if((e|0)==8){break f}}c=j[b+104>>2];if(c){j[b+4>>2]=j[b+4>>2]-1}if(!d|e>>>0<4){break f}while(1){if(c){j[b+4>>2]=j[b+4>>2]-1}e=e-1|0;if(e>>>0>3){continue}break}}P2(f,q(q(g|0)*q(B)));g=j[f+8>>2];i=j[f+12>>2];l=j[f>>2];n=j[f+4>>2];break a}h:{i:{j:{if(e){break j}e=0;while(1){if(h[e+59761|0]!=(c|32)){break j}k:{if(e>>>0>1){break k}c=j[b+4>>2];if(c>>>0<m[b+104>>2]){j[b+4>>2]=c+1;c=k[c|0];break k}c=Jc(b)}e=e+1|0;if((e|0)!=3){continue}break}break i}l:{switch(e|0){case 0:m:{if((c|0)!=48){break m}e=j[b+4>>2];n:{if(e>>>0<m[b+104>>2]){j[b+4>>2]=e+1;e=k[e|0];break n}e=Jc(b)}if((e&-33)==88){M2(f+16|0,b,o,i,g,d);g=j[f+24>>2];i=j[f+28>>2];l=j[f+16>>2];n=j[f+20>>2];break a}if(!j[b+104>>2]){break m}j[b+4>>2]=j[b+4>>2]-1}L2(f+32|0,b,c,o,i,g,d);g=j[f+40>>2];i=j[f+44>>2];l=j[f+32>>2];n=j[f+36>>2];break a;case 3:break i;default:break l}}if(j[b+104>>2]){j[b+4>>2]=j[b+4>>2]-1}break h}o:{c=j[b+4>>2];p:{if(c>>>0<m[b+104>>2]){j[b+4>>2]=c+1;c=k[c|0];break p}c=Jc(b)}if((c|0)==40){e=1;break o}g=0;i=2147450880;if(!j[b+104>>2]){break a}j[b+4>>2]=j[b+4>>2]-1;break a}while(1){c=j[b+4>>2];q:{if(c>>>0<m[b+104>>2]){j[b+4>>2]=c+1;c=k[c|0];break q}c=Jc(b)}if(!(c-97>>>0>=26?!(c-48>>>0<10|c-65>>>0<26|(c|0)==95):0)){e=e+1|0;continue}break}g=0;i=2147450880;if((c|0)==41){break a}c=j[b+104>>2];if(c){j[b+4>>2]=j[b+4>>2]-1}if(d){if(!e){break a}while(1){e=e-1|0;if(c){j[b+4>>2]=j[b+4>>2]-1}if(e){continue}break}break a}}j[114604]=28;dh(b,0,0)}g=0;i=0}j[a>>2]=l;j[a+4>>2]=n;j[a+8>>2]=g;j[a+12>>2]=i;Za=f+48|0}function Yk(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,i=0,n=0,o=0,q=0,r=0;i=Za-16|0;Za=i;a:{b:{if(Xc(a)|m[a+12>>2]<=m[b+4>>2]){break b}c=l[b+8>>1]>=Kj(a)>>>0;g=l[b+8>>1];if((g|0)!=65535?c:0){break b}f=g;if((f&65535)==65535){g=Kj(a)-1|0;f=0}d=Se(a,j[b+4>>2],f&65535);c:{n=k[b+12|0];d:{if(n&2){break d}q=g&65535;if(q>>>0<(f&65535)>>>0){break d}r=n&4;o=k[b+10|0];e=f;c=d;while(1){e:{if(!r){if((o|0)!=k[c+3|0]){break e}break c}if((o|0)==k[c+2|0]){break c}}c=c+6|0;e=e+1|0;if(q>>>0>=(e&65535)>>>0){continue}break}}o=g&65535;if(o>>>0>=(f&65535)>>>0){q=n&4;e=f;c=d;while(1){f:{if(!q){if(k[c+3|0]){break f}h[c+3|0]=k[b+10|0];h[c+5|0]=k[b+11|0];break c}if(k[c+2|0]){break f}h[c+2|0]=k[b+10|0];h[c+4|0]=k[b+11|0];break c}c=c+6|0;e=e+1|0;if(o>>>0>=(e&65535)>>>0){continue}break}}g:{if(!(n&1)){break g}n=j[xm(a)+480180>>2]&2;e=k[b+12|0];h:{if(e&4){break h}g=g&65535;if(g>>>0<(f&65535)>>>0){break h}while(1){i:{j:{switch(k[d+3|0]-9|0){case 4:if(!NI(j[xm(a)+8>>2],1)){break i}c=1;h[d+2|0]=1;h[d+4|0]=k[d+5|0];h[d+3|0]=k[b+10|0];h[d+5|0]=k[b+11|0];break a;case 0:break j;default:break i}}c=d;k:{if(n){e=k[d+5|0];if(e>>>0>128){break i}h[d+2|0]=2;h[d+3|0]=k[b+10|0];a=1;break k}h[d+2|0]=2;h[d+3|0]=k[b+10|0];e=k[d+5|0];a=2}h[c+4|0]=a+e>>>a;h[d+5|0]=k[b+11|0];break c}d=d+6|0;f=f+1|0;if(g>>>0>=(f&65535)>>>0){continue}break}e=k[b+12|0]}l:{if(e&4){c=k[b+11|0];d=13;m:{switch(k[b+10|0]-1|0){case 1:c=Zm(p(n?2:4,c));e=k[b+12|0];d=9;break;case 0:break m;default:break l}}h[b+11|0]=c;h[b+10|0]=d;e=e&254;h[b+12|0]=e;break l}f=k[b+11|0];h[i+14|0]=f;d=b;c=k[b+10|0];n:{o:{if(!(!n|(c|0)!=9)){if(f>>>0>128){break n}c=2;f=(f&254)>>>1|0;break o}h[i+15|0]=c;if(!Ew(i+15|0,i+14|0,1)){break n}c=k[i+15|0];if(!c){break n}e=k[b+12|0];f=k[i+14|0]}h[d+11|0]=f;h[b+10|0]=c;h[b+12|0]=e&254}e=k[b+12|0]}c=1;if(e&1){break g}h[b+12|0]=e^4;if(Yk(a,b)){break a}}p:{q:{d=j[b>>2];if((d|0)==1){if(m[a+12>>2]>j[b+4>>2]+1>>>0){break q}d=j[b>>2]}if((d|0)!=2){break b}c=0;d=j[b+4>>2];if(!d){break a}j[b+4>>2]=d-1;break p}j[b+4>>2]=j[b+4>>2]+1}h[b+12|0]=k[b+12|0]|1;c=Yk(a,b);break a}c=1;break a}c=0}Za=i+16|0;return c|0}function Rua(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;g=Za-48|0;Za=g;a:{b:{c:{k=j[a+8>>2];f=j[a+12>>2];d:{if((f|0)<1?1:(f|0)<=1?k>>>0<=805306368:0){if((f|0)>-2?1:(f|0)>=-2?k>>>0>=3489660928:0){break c}if((f|0)>-2?1:(f|0)>=-2?k>>>0>2147483647:0){break d}break b}if((f|0)>1?1:(f|0)>=1?k>>>0>2147483648:0){break b}}b=b+196648|0;break a}b=b+131112|0;break a}b=b+262184|0}w=b;x=j[a+16>>2];h=j[a+44>>2];j[g+32>>2]=h;o=j[a+48>>2];j[g+36>>2]=o;m=j[a+52>>2];j[g+40>>2]=m;n=j[a+56>>2];j[g+44>>2]=n;r=j[a+40>>2];s=j[a+36>>2];e=j[a+4>>2];l=j[a>>2];j[g+24>>2]=l;j[g+28>>2]=e;j[g+16>>2]=k;j[g+20>>2]=f;e:{if(!d){b=r>>12;f=s>>12;break e}while(1){o=1;b=((((e&2147483647)<<1|l>>>31)&2147483646)<<1)+x|0;e=(l>>>16&65520)+w|0;l=i[e+14>>1];k=i[e+12>>1];n=i[e+10>>1];t=i[e+8>>1];y=i[e+6>>1];q=i[e+4>>1];u=i[e+2>>1];v=i[e>>1];h=0;m=1;f=0;while(1){e=f<<1;j[(g+8|0)+(f<<2)>>2]=(((((((p(i[b+(e|-8)>>1],u)+p(i[b+(e|-12)>>1],v)|0)+p(i[b+(e|-4)>>1],q)|0)+p(i[b+e>>1],y)|0)+p(i[b+(e|4)>>1],t)|0)+p(i[b+(e|8)>>1],n)|0)+p(k,i[b+(e|12)>>1])|0)+p(l,i[b+(e|16)>>1])|0)/32768;e=m&1;m=0;f=1;if(e){continue}break}while(1){m=(g+8|0)+(h<<2)|0;l=j[m>>2];k=j[a+60>>2];e=(g+32|0)+(h<<3)|0;h=j[e>>2];b=Gb(h,-16777216,16776704);t=j[a+64>>2];f=Gb(j[e+4>>2],-16777216,16776704);q=j[a+68>>2];u=q;q=q>>31;j[e+4>>2]=h;v=j[a+72>>2];l=l<<8;h=l;h=HMa(k,k>>31,h,h>>31);k=ab;n=m;m=HMa(t,t>>31,b,b>>31);h=m+h|0;b=ab+k|0;b=h>>>0<m>>>0?b+1|0:b;k=h;h=HMa(u,q,f,f>>31);f=k+h|0;b=ab+b|0;b=f>>>0<h>>>0?b+1|0:b;f=f+8388608|0;if(f>>>0<8388608){b=b+1|0}b=(b&16777215)<<8|f>>>24;j[n>>2]=(b|0)/256;j[e>>2]=b-(l&v);h=1;b=o&1;o=0;if(b){continue}break}b=j[a+32>>2];s=j[a+28>>2]+s|0;f=s>>12;j[c>>2]=j[c>>2]+p(f,j[g+8>>2]);r=b+r|0;b=r>>12;j[c+4>>2]=j[c+4>>2]+p(b,j[g+12>>2]);Bb(g+24|0,g+16|0);d=d-1|0;if(d){c=c+8|0;l=j[g+24>>2];e=j[g+28>>2];continue}break}l=j[g+24>>2];e=j[g+28>>2];n=j[g+44>>2];m=j[g+40>>2];o=j[g+36>>2];h=j[g+32>>2]}j[a+40>>2]=r;j[a+20>>2]=f;j[a+36>>2]=s;j[a+56>>2]=n;j[a+52>>2]=m;j[a+48>>2]=o;j[a+44>>2]=h;j[a+24>>2]=b;j[a>>2]=l;j[a+4>>2]=e;Za=g+48|0}function qJ(a,b,c,d){var e=0,f=0,g=0,i=0,l=0,m=0,o=0;i=Za-16|0;Za=i;e=p(b,896)+a|0;a:{if(k[e+1075074|0]&2){m=1;b:{if(!(k[a+480209|0]&16)){break b}m=0;if(!(j[a+480180>>2]&16777248)){break b}m=!(k[a+480208|0]&4)}if(j[a+480180>>2]==64){a=p(b,896)+a|0;b=a+1075823|0;d=k[b|0];if(d&1){j[c>>2]=j[c>>2]+p(k[a+1075828|0],167)}h[b|0]=d+1;break a}g=e+1074984|0;c:{if(!m){break c}mb(i+8|0,a+1074308|0,21);if(!kb(i+8|0)){break c}e=p(b,896)+a|0;f=e+1075823|0;h[f|0]=k[f|0]+(k[e+1075827|0]<<2)}f=p(b,896)+a|0;l=f+1075826|0;o=f+1075823|0;e=Tw(a,k[l|0],k[o|0]);d:{if(Yi(g)){n[d>>2]=q(q(p(k[f+1075828|0],e)|0)*q(6510417279059766e-21))+n[d>>2];c=f+1075856|0;d=k[c|0];h[c|0]=d&243|8;if(j[a+1074416>>2]!=(j[a+1074392>>2]+1|0)){break d}h[c|0]=d|12;break d}if((j[a+480208>>2]&2101248)==2101248|(k[a+480209|0]&16?j[a+480180>>2]&67633152:0)){break a}e=j[a+480180>>2]&5?(k[l|0]&3)==1?0-e|0:e:e;g=a+1074308|0;mb(i+8|0,g,21);d=kb(i+8|0);f=j[a+480208>>2];e:{if(d){d=f&4;e=d?e:0-e|0;d=d?5:6;break e}d=5;f:{if(f&131072){break f}d=8;if(j[a+480180>>2]==1024){break f}d=7;if(j[a+480180>>2]&524304|(k[a+480208|0]&4?0:j[a+480180>>2]&16777248)){break f}d=6}mb(i+8|0,g,80);if(!kb(i+8|0)){break e}d=k[(p(b,896)+a|0)+1075797|0]==26?d+2|0:d}d=(p(k[(p(b,896)+a|0)+1075828|0],e)|0)/(1<<d)|0;f=0-d|0;g:{if(!(k[a+480208|0]&16)|j[a+480180>>2]==4){break g}e=j[c>>2];if((d|0)<=-1){d=kx(a,f>>>2|0);d=ic(IMa(HMa(d,d>>31,e,e>>31),ab,65536,0),ab);e=j[c>>2];d=d-e|0;g=f&3;if(!g){break g}l=d;d=oK(a,g);d=(l+ic(IMa(HMa(d,d>>31,e,e>>31),ab,65536,0),ab)|0)-j[c>>2]|0;break g}g=d&3;d=jx(a,d>>>2|0);d=ic(IMa(HMa(d,d>>31,e,e>>31),ab,65536,0),ab);e=j[c>>2];d=d-e|0;if(!g){break g}l=d;d=nK(a,g);d=(l+ic(IMa(HMa(d,d>>31,e,e>>31),ab,65536,0),ab)|0)-j[c>>2]|0}j[c>>2]=j[c>>2]+d;c=lx(a,b);if(!c){break d}d=c;e=f<<16>>16;g=j[(p(b,896)+a|0)+1075640>>2];l=2;h:{if(!g){break h}l=k[g+33|0]}bb[j[j[c>>2]+84>>2]](d,e,l<<24>>24,b)}if(!m){break a}mb(i+8|0,a+1074308|0,21);if(kb(i+8|0)){break a}h[o|0]=k[o|0]+k[(p(b,896)+a|0)+1075827|0];break a}if(!(k[e+1075654|0]&2)){break a}a=lx(a,b);if(!a){break a}bb[j[j[a>>2]+84>>2]](a,0,0,b)}Za=i+16|0}function mua(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,i=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;e=Za-80|0;Za=e;w=j[a+16>>2];i=vf(e+48|0);j[i+8>>2]=a+112;j[i+16>>2]=j[a+128>>2];y=i,z=qf(b+327720|0,j[b+20>>2],(j[a+88>>2]&16384)>>>14|0),j[y+12>>2]=z;b=j[i+16>>2];if(b){y=i,z=uf(a+8|0,b),j[y>>2]=z;j[i+4>>2]=ab}f=j[a+44>>2];j[e+32>>2]=f;o=j[a+48>>2];j[e+36>>2]=o;m=j[a+52>>2];j[e+40>>2]=m;n=j[a+56>>2];j[e+44>>2]=n;q=j[a+40>>2];r=j[a+36>>2];k=j[a+4>>2];g=j[a>>2];j[e+24>>2]=g;j[e+28>>2]=k;b=j[a+12>>2];j[e+16>>2]=j[a+8>>2];j[e+20>>2]=b;a:{if(!d){b=q>>12;l=r>>12;break a}while(1){b=0;f=b;l=g;j[e+72>>2]=g;j[e+76>>2]=b;k=(((k&2147483647)<<1|g>>>31)&-2)+w|0;b:{b=j[i+16>>2];if((b|0)<=0){break b}while(1){g=(f&2147483647)<<1|l>>>31;id(j[i+8>>2],h[(g|1)+k|0]+h[k+(g&-2)|0]<<5);hd(j[i+8>>2],4);Bb(e+72|0,i);if((b|0)<2){break b}b=b-1|0;l=j[e+72>>2];f=j[e+76>>2];continue}}b=j[i+8>>2];Bb(b,b+8|0);b=j[i+8>>2];g=j[b+4>>2];if(g){f=b;b=(j[e+76>>2]&2147483647)<<1|j[e+72>>2]>>>31;id(f,h[(b|1)+k|0]+h[k+(b&-2)|0]<<5);hd(j[i+8>>2],g);b=j[i+8>>2];g=j[b>>2];j[b>>2]=g;j[b+4>>2]=0}d=d-1|0;f=pf(b,j[i+12>>2]);j[e+12>>2]=f;j[e+8>>2]=f;l=0;o=1;while(1){m=j[a+60>>2];n=m;k=(e+32|0)+(l<<3)|0;s=j[k>>2];b=Gb(s,-16777216,16776704);v=j[a+64>>2];g=Gb(j[k+4>>2],-16777216,16776704);t=j[a+68>>2];x=t;t=t>>31;j[k+4>>2]=s;s=j[a+72>>2];u=m>>31;m=f<<8;f=m;f=HMa(n,u,f,f>>31);n=ab;u=(e+8|0)+(l<<2)|0;l=HMa(v,v>>31,b,b>>31);f=l+f|0;b=ab+n|0;b=f>>>0<l>>>0?b+1|0:b;n=f;f=HMa(x,t,g,g>>31);g=n+f|0;b=ab+b|0;b=g>>>0<f>>>0?b+1|0:b;g=g+8388608|0;if(g>>>0<8388608){b=b+1|0}b=(b&16777215)<<8|g>>>24;j[u>>2]=(b|0)/256;j[k>>2]=b-(m&s);if(o){l=1;o=0;f=j[e+12>>2];continue}break}b=j[a+32>>2];r=j[a+28>>2]+r|0;l=r>>12;j[c>>2]=j[c>>2]+p(l,j[e+8>>2]);q=b+q|0;b=q>>12;j[c+4>>2]=j[c+4>>2]+p(b,j[e+12>>2]);Bb(e+24|0,e+16|0);if(d){c=c+8|0;g=j[e+24>>2];k=j[e+28>>2];continue}break}g=j[e+24>>2];k=j[e+28>>2];n=j[e+44>>2];m=j[e+40>>2];o=j[e+36>>2];f=j[e+32>>2]}j[a+40>>2]=q;j[a+20>>2]=l;j[a+36>>2]=r;j[a+56>>2]=n;j[a+52>>2]=m;j[a+48>>2]=o;j[a+44>>2]=f;j[a+24>>2]=b;j[a>>2]=g;j[a+4>>2]=k;Za=e+80|0}function Iu(a){var b=0,c=0,d=0,e=0,f=0,g=0,h=0,k=0,n=0,o=0,p=0;c=Za-96|0;Za=c;h=a;k=a;a:{b:{c:{d:{e:{if(!(n=0,o=!gd(a,11),p=j[a+4>>2],p?n:o)){g=j[a+28>>2];e=j[a+12>>2];d=j[a+64>>2];f=d+j[a+8>>2]|0;f=sg(c+80|0,f,d>>>0>f>>>0?e+1|0:e);d=j[f+12>>2];j[c+32>>2]=j[f+8>>2];j[c+36>>2]=d;b=j[f+4>>2];j[c+24>>2]=j[f>>2];j[c+28>>2]=b;Hi(g,c+24|0);b=j[a+28>>2];if(qt(j[j[b>>2]-12>>2]+b|0)){mg(a,1073741826);break a}f=a+44|0;_Y(f,j[a+92>>2]);d=a+32|0;XC(d,j[a+92>>2]<<2);if(j[a+92>>2]){e=0;while(1){b=j[a+28>>2];if(qt(j[j[b>>2]-12>>2]+b|0)){mg(a,1073741828);break a}b=l[a+16>>1];i[c+78>>1]=b;if((b|0)==65535){Ku(j[a+28>>2],c+78|0)}n=c,o=tc(d),j[n+72>>2]=o;f:{if(!l[c+78>>1]){g=0;break f}g=l[c+78>>1];b=j[c+72>>2];if(g>>>0>-1-b>>>0){break f}Pn(d,b+g|0);Aj(j[a+28>>2],fc(d,j[c+72>>2]),l[c+78>>1]);g=l[c+78>>1]}n=$b(f,e),o=g,i[n+12>>1]=o;b=j[c+72>>2];n=$b(f,e),o=b,j[n>>2]=o;if(gd(a,6)){lj(j[a+28>>2],c+56|0);if(m[c+60>>2]>2147483647){break e}b=j[c+56>>2];n=$b(f,e),o=b,j[n+4>>2]=o}b=j[a+4>>2];g:{if(b){n=$b(f,e),o=b,j[n+8>>2]=o;break g}if(!gd(a,7)){break g}lj(j[a+28>>2],c+56|0);if(m[c+60>>2]>2147483647){break d}b=j[c+56>>2];n=$b(f,e),o=b,j[n+8>>2]=o}h:{if(j[$b(f,e)+8>>2]==-1){break h}if(gd(a,6)){break h}if(e){b=e-1|0;b=j[$b(f,b)+4>>2]+j[$b(f,b)+8>>2]|0}else{b=0}n=$b(f,e),o=b,j[n+4>>2]=o}if(gd(a,8)){i[c+56>>1]=0;Ku(j[a+28>>2],c+56|0);b=gd(a,9);Lk(j[a+28>>2],l[c+56>>1]<<b,-1)}e=e+1|0;if(e>>>0<m[a+92>>2]){continue}break}}Ve(c+56|0,j[a+28>>2]);b=j[c+68>>2];j[a+72>>2]=j[c+64>>2];j[a+76>>2]=b}mj(a,4,1);b=j[a+88>>2];if((b|0)!=j[a+64>>2]){break c}d=j[a+76>>2];b=j[a+72>>2];break b}mg(a,1073741829);break a}mg(a,1073741829);break a}d=j[a+12>>2];g=b+j[a+8>>2]|0;d=g>>>0<b>>>0?d+1|0:d;b=g}j[k+80>>2]=b;j[h+84>>2]=d;h=j[a+28>>2];d=sg(c+40|0,b,d);b=j[d+12>>2];j[c+16>>2]=j[d+8>>2];j[c+20>>2]=b;b=j[d+4>>2];j[c+8>>2]=j[d>>2];j[c+12>>2]=b;Hi(h,c+8|0);if(gd(a,6)){break a}if((n=0,o=!gd(a,7),p=j[a+4>>2],p?n:o)|!j[a+92>>2]){break a}h=j[a+80>>2];b=j[a+8>>2];d=h-b|0;h=a+44|0;e=0;while(1){b=$b(h,e);j[b+4>>2]=d+j[b+4>>2];e=e+1|0;if(e>>>0<m[a+92>>2]){continue}break}}Za=c+96|0}function Tua(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;e=Za-48|0;Za=e;a:{b:{c:{l=j[a+8>>2];f=j[a+12>>2];d:{if((f|0)<1?1:(f|0)<=1?l>>>0<=805306368:0){if((f|0)>-2?1:(f|0)>=-2?l>>>0>=3489660928:0){break c}if((f|0)>-2?1:(f|0)>=-2?l>>>0>2147483647:0){break d}break b}if((f|0)>1?1:(f|0)>=1?l>>>0>2147483648:0){break b}}b=b+196648|0;break a}b=b+131112|0;break a}b=b+262184|0}x=b;y=j[a+16>>2];g=j[a+44>>2];j[e+32>>2]=g;q=j[a+48>>2];j[e+36>>2]=q;n=j[a+52>>2];j[e+40>>2]=n;o=j[a+56>>2];j[e+44>>2]=o;s=j[a+40>>2];t=j[a+36>>2];k=j[a+4>>2];m=j[a>>2];j[e+24>>2]=m;j[e+28>>2]=k;j[e+16>>2]=l;j[e+20>>2]=f;e:{if(!d){b=s>>12;f=t>>12;break e}while(1){k=(((k&2147483647)<<1|m>>>31)&-2)+y|0;b=(m>>>16&65520)+x|0;f=i[b+14>>1];m=i[b+12>>1];l=i[b+10>>1];o=i[b+8>>1];u=i[b+6>>1];z=i[b+4>>1];r=i[b+2>>1];v=i[b>>1];g=0;q=1;n=1;b=0;while(1){j[(e+8|0)+(b<<2)>>2]=(((((((p(h[k+(b|-4)|0],r)+p(h[k+(b|-6)|0],v)|0)+p(h[k+(b|-2)|0],z)|0)+p(h[b+k|0],u)|0)+p(h[k+(b|2)|0],o)|0)+p(h[k+(b|4)|0],l)|0)+p(m,h[k+(b|6)|0])|0)+p(f,h[k+(b|8)|0])<<8)/32768;w=n&1;n=0;b=1;if(w){continue}break}while(1){n=(e+8|0)+(g<<2)|0;m=j[n>>2];l=j[a+60>>2];k=(e+32|0)+(g<<3)|0;g=j[k>>2];b=Gb(g,-16777216,16776704);u=j[a+64>>2];f=Gb(j[k+4>>2],-16777216,16776704);r=j[a+68>>2];v=r;r=r>>31;j[k+4>>2]=g;w=j[a+72>>2];m=m<<8;g=m;g=HMa(l,l>>31,g,g>>31);l=ab;o=n;n=HMa(u,u>>31,b,b>>31);g=n+g|0;b=ab+l|0;b=g>>>0<n>>>0?b+1|0:b;l=g;g=HMa(v,r,f,f>>31);f=l+g|0;b=ab+b|0;b=f>>>0<g>>>0?b+1|0:b;f=f+8388608|0;if(f>>>0<8388608){b=b+1|0}b=(b&16777215)<<8|f>>>24;j[o>>2]=(b|0)/256;j[k>>2]=b-(m&w);g=1;b=q&1;q=0;if(b){continue}break}b=j[a+32>>2];t=j[a+28>>2]+t|0;f=t>>12;j[c>>2]=j[c>>2]+p(f,j[e+8>>2]);s=b+s|0;b=s>>12;j[c+4>>2]=j[c+4>>2]+p(b,j[e+12>>2]);Bb(e+24|0,e+16|0);d=d-1|0;if(d){c=c+8|0;m=j[e+24>>2];k=j[e+28>>2];continue}break}m=j[e+24>>2];k=j[e+28>>2];o=j[e+44>>2];n=j[e+40>>2];q=j[e+36>>2];g=j[e+32>>2]}j[a+40>>2]=s;j[a+20>>2]=f;j[a+36>>2]=t;j[a+56>>2]=o;j[a+52>>2]=n;j[a+48>>2]=q;j[a+44>>2]=g;j[a+24>>2]=b;j[a>>2]=m;j[a+4>>2]=k;Za=e+48|0}function lca(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;var k=0,l=0,m=0;l=Za-48|0;Za=l;a:{b:{c:{k=Mn(1,32);d:{e:{if(!k){a=R(4)|0;Bk(a);j[114630]=0;I(2004,a|0,71412,2003);a=j[114630];j[114630]=0;if((a|0)!=1){break a}i=J(0)|0;C()|0;break e}j[k+16>>2]=0;j[k+20>>2]=0;j[k+12>>2]=f;j[k+8>>2]=e;j[k+4>>2]=d;j[k+24>>2]=0;j[k+28>>2]=0;j[k>>2]=c?c:1992;d=_r(l+32|0);f:{g:{if(!i){break g}c=j[i>>2];if(!c){break g}while(1){h:{e=j[i+4>>2];if(e){j[114630]=0;c=E(85,l+16|0,c|0)|0;f=j[114630];j[114630]=0;i:{if((f|0)!=1){j[114630]=0;f=E(2005,d|0,c|0)|0;m=j[114630];j[114630]=0;if((m|0)==1){break i}j[114630]=0;E(483,f|0,e|0)|0;e=j[114630];j[114630]=0;if((e|0)==1){break i}break h}i=J(0)|0;C()|0;break f}i=J(0)|0;C()|0;gb(c);break f}j[114630]=0;c=E(85,l+16|0,c|0)|0;e=j[114630];j[114630]=0;j:{if((e|0)!=1){j[114630]=0;E(2006,d|0,c|0)|0;e=j[114630];j[114630]=0;if((e|0)==1){break j}break h}i=J(0)|0;C()|0;break f}i=J(0)|0;C()|0;gb(c);break f}gb(c);c=j[i+8>>2];i=i+8|0;if(c){continue}break}}j[114630]=0;c=H(1394,96)|0;e=j[114630];j[114630]=0;k:{l:{m:{if((e|0)!=1){j[114630]=0;I(2007,l+16|0,k|0,k+4|0);e=j[114630];j[114630]=0;if((e|0)==1){break m}e=io(l+8|0,l+16|0);j[114630]=0;U(2082,c|0,a|0,b|0,e|0,d|0)|0;a=j[114630];j[114630]=0;if((a|0)==1){break l}j[k+28>>2]=c;Gc(e);Gc(l+16|0);a=j[k+28>>2];j[k+24>>2]=a?a+8|0:0;Sj(d);break d}i=J(0)|0;C()|0;break f}i=J(0)|0;C()|0;break k}i=J(0)|0;C()|0;Gc(e);Gc(l+16|0)}Fb(c)}Sj(d);O(i|0)|0;j[114630]=0;L(1984,37255,k|0,g|0,h|0);a=j[114630];j[114630]=0;if((a|0)!=1){j[114630]=0;M(20);a=j[114630];j[114630]=0;if((a|0)!=1){a=j[k+28>>2];if(a){bb[j[j[a>>2]+4>>2]](a)}j[k+24>>2]=0;j[k+28>>2]=0;a=j[k+20>>2];if(a){Fb(a);j[k+20>>2]=0}Fb(k);k=0;break d}i=J(0)|0;C()|0;break e}i=J(0)|0;C()|0;j[114630]=0;M(20);a=j[114630];j[114630]=0;if((a|0)==1){break b}}O(i|0)|0;k=0;j[114630]=0;L(1984,37255,0,g|0,h|0);a=j[114630];j[114630]=0;if((a|0)==1){break c}Q()}Za=l+48|0;return k|0}a=D()|0;C()|0;j[114630]=0;M(20);b=j[114630];j[114630]=0;if((b|0)==1){break b}G(a|0);z()}J(0)|0;C()|0;ib()}z()}function Pwa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,k=0,n=0,o=0;d=Za+ -64|0;Za=d;i[d+62>>1]=c;Rf(d+62|0,32);f=qn(a);j[114630]=0;F(794,f|0,l[d+62>>1]);a=j[114630];j[114630]=0;a:{if((a|0)!=1){b:{c:{if(!l[d+62>>1]){break c}while(1){a=l[b+480190>>1]+1|0;i[d+60>>1]=a;d:{e:{if((a&65535)>>>0<4e3){break e}i[d+24>>1]=1;f:{if(!l[b+480190>>1]){break f}while(1){g:{if(ke(Yo(b,l[d+24>>1]))){break g}n=d,o=ry(Lb(f),Mb(f),d+24|0),j[n+48>>2]=o;n=d,o=Mb(f),j[n+40>>2]=o;if(!el(d+48|0,d+40|0)){break g}i[d+60>>1]=l[d+24>>1];a=1;if(!l[b+480192>>1]){break f}while(1){c=j[(((a&65535)<<2)+b|0)+900380>>2];h:{if(!c){break h}c=c+236|0;e=ps(c);if((c|0)==(e|0)){break h}while(1){if(l[c>>1]==l[d+60>>1]){i[c>>1]=0}c=c+2|0;if((e|0)!=(c|0)){continue}break}}a=a+1|0;if(l[b+480192>>1]>=(a&65535)>>>0){continue}break}break f}a=l[d+24>>1]+1|0;i[d+24>>1]=a;if(l[b+480190>>1]>=(a&65535)>>>0){continue}break}}if(l[d+60>>1]<4e3){break e}a=zs(d+48|0);j[114630]=0;c=E(1045,b|0,a|0)|0;e=j[114630];j[114630]=0;i:{j:{if((e|0)==1){break j}k:{if(c){j[114630]=0;E(1046,b|0,a|0)|0;c=j[114630];j[114630]=0;if((c|0)==1){break j}e=1;if(!l[b+480192>>1]){break k}while(1){c=j[(((e&65535)<<2)+b|0)+900380>>2];l:{if(!c){break l}c=c+236|0;g=ps(c);if((c|0)==(g|0)){break l}while(1){m:{if(m[a+4>>2]<=l[c>>1]){break m}Nd(d+40|0,a,l[c>>1]);if(kb(d+40|0)){break m}i[c>>1]=0}c=c+2|0;if((g|0)!=(c|0)){continue}break}}e=e+1|0;if(l[b+480192>>1]>=(e&65535)>>>0){continue}break}break k}Vd(a);break c}Zi(d+24|0,a);j[114630]=0;I(1047,d+32|0,d+24|0,1);c=j[114630];j[114630]=0;if((c|0)!=1){Xj(d+16|0,a);j[114630]=0;h[d+15|0]=0;L(1048,d+40|0,d+32|0,d+16|0,d+15|0);c=j[114630];j[114630]=0;if((c|0)!=1){break i}}}c=D()|0;C()|0;Vd(a);break a}Zi(d,a);n=d,o=ci(d+40|0,d),i[n+60>>1]=o;Vd(a);if(l[d+60>>1]>3999){break d}}j[114630]=0;F(461,f|0,d+60|0);a=j[114630];j[114630]=0;if((a|0)==1){break b}if(l[b+480190>>1]>=l[d+60>>1]){break d}i[b+480190>>1]=l[d+60>>1]}k=k+1|0;if(l[d+62>>1]>(k&65535)>>>0){continue}break}}Za=d- -64|0;return}c=D()|0;C()|0;break a}c=D()|0;C()|0}ff(f);G(c|0);z()}function B$(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0;a=Za-1072|0;Za=a;j[a+16>>2]=f;j[a+20>>2]=g;j[a+24>>2]=h;j[a+28>>2]=i;j[a+956>>2]=a+960;l=kv(a+960|0,100,64703,a+16|0);j[a+48>>2]=2421;p=yd(a+536|0,0,a+48|0);j[a+48>>2]=2421;o=yd(a+528|0,0,a+48|0);n=a+544|0;a:{b:{c:{if(l>>>0>=100){j[114630]=0;l=T(2446)|0;n=j[114630];j[114630]=0;if((n|0)==1){break b}j[a>>2]=f;j[a+4>>2]=g;j[114630]=0;j[a+8>>2]=h;j[a+12>>2]=i;l=P(2468,a+956|0,l|0,64703,a|0)|0;f=j[114630];j[114630]=0;if((f|0)==1){break b}f=j[a+956>>2];if(!f){j[114630]=0;M(2422);a=j[114630];j[114630]=0;if((a|0)!=1){break c}break b}fe(p,f);fe(o,Yc(l<<2));if(Vi(o)){j[114630]=0;M(2422);a=j[114630];j[114630]=0;if((a|0)==1){break b}break c}n=j[o>>2]}j[114630]=0;hc(a+520|0,d);f=j[114630];j[114630]=0;d:{e:{f:{g:{h:{i:{j:{if((f|0)!=1){j[114630]=0;r=H(2450,a+520|0)|0;f=j[114630];j[114630]=0;if((f|0)==1){break j}j[114630]=0;f=j[a+956>>2];P(2464,r|0,f|0,f+l|0,n|0)|0;f=j[114630];j[114630]=0;if((f|0)==1){break j}q=l?k[j[a+956>>2]]==45:q;h=Cb(a+488|0);g=Le(a+472|0);f=Le(a+456|0);j[114630]=0;ba(2504,c|0,q|0,a+520|0,a+512|0,a+508|0,a+504|0,h|0,g|0,f|0,a+452|0);c=j[114630];j[114630]=0;if((c|0)==1){break i}j[a+36>>2]=2421;i=yd(a+40|0,0,a+36|0);c=j[a+452>>2];k:{if((c|0)<(l|0)){m=nb(f)+(l-c<<1|1)|0;break k}m=nb(f)+2|0}c=a+48|0;m=(nb(g)+m|0)+j[a+452>>2]|0;if(m>>>0<101){break h}fe(i,Yc(m<<2));c=j[i>>2];if(c){break h}j[114630]=0;M(2422);b=j[114630];j[114630]=0;if((b|0)!=1){break c}break g}l=D()|0;C()|0;break a}l=D()|0;C()|0;break e}l=D()|0;C()|0;break f}m=j[d+4>>2];j[114630]=0;ga(2505,c|0,a+36|0,a+32|0,m|0,n|0,(l<<2)+n|0,r|0,q|0,a+512|0,j[a+508>>2],j[a+504>>2],h|0,g|0,f|0,j[a+452>>2]);l=j[114630];j[114630]=0;if((l|0)!=1){j[114630]=0;b=_(2480,b|0,c|0,j[a+36>>2],j[a+32>>2],d|0,e|0)|0;c=j[114630];j[114630]=0;if((c|0)!=1){break d}}}l=D()|0;C()|0;mc(i)}pc(f);pc(g);gb(h)}wb(a+520|0);break a}mc(i);pc(f);pc(g);gb(h);wb(a+520|0);mc(o);mc(p);Za=a+1072|0;return b|0}z()}l=D()|0;C()|0}mc(o);mc(p);G(l|0);z()}function fsa(a,b){var c=0,d=0,e=0,f=0,g=0,l=0,m=0;c=Za-368|0;Za=c;HL(c+80|0);l=Vb(b,c+80|0,282);b=0;if(vh(a,20108)){cg(a,4);f=He(c- -64|0,a);j[114630]=0;e=E(1196,f|0,l|0)|0;d=j[114630];j[114630]=0;a:{b:{c:{d:{if((d|0)==1){break d}if(!e){break a}e=l+26|0;d=k[e|0];j[114630]=0;d=E(258,f|0,d|0)|0;g=j[114630];j[114630]=0;if((g|0)==1){break d}if(!d){break a}if(!k[e|0]){d=0;break c}d=0;while(1){e:{j[114630]=0;g=H(375,f|0)|0;m=j[114630];j[114630]=0;if((m|0)==1){break e}h[(b+l|0)+27|0]=g;d=d+g|0;b=b+1|0;if(b>>>0<k[e|0]){continue}break c}break}b=D()|0;C()|0;break b}b=D()|0;C()|0;break b}b=0;j[114630]=0;g=d&65535;d=E(258,f|0,g|0)|0;m=j[114630];j[114630]=0;f:{if((m|0)==1){break f}if(!d){break a}j[114630]=0;E(338,f|0,g|0)|0;b=j[114630];j[114630]=0;if((b|0)==1){break f}cg(f,IL(l));j[114630]=0;d=H(1197,c+56|0)|0;b=j[114630];j[114630]=0;g:{if((b|0)!=1){GL(c+80|0);j[114630]=0;E(1198,f|0,c+80|0)|0;b=j[114630];j[114630]=0;if((b|0)==1){break g}j[114630]=0;i[c+102>>1]=0;i[c+104>>1]=0;K(1199,d|0,c+80|0,c+107|0)|0;b=j[114630];j[114630]=0;if((b|0)==1){break g}b=k[e|0];j[114630]=0;E(338,f|0,b|0)|0;b=j[114630];j[114630]=0;if((b|0)==1){break g}b=k[e|0];j[114630]=0;e=l+27|0;K(1199,d|0,e|0,b+e|0)|0;b=j[114630];j[114630]=0;if((b|0)==1){break g}j[114630]=0;I(341,c+40|0,f|0,g|0);b=j[114630];j[114630]=0;h:{i:{j:{if((b|0)!=1){j[114630]=0;F(857,c+16|0,c+40|0);b=j[114630];j[114630]=0;if((b|0)==1){break j}j[114630]=0;F(1201,c+8|0,c+16|0);b=j[114630];j[114630]=0;if((b|0)==1){break i}j[114630]=0;E(1202,d|0,c+8|0)|0;b=j[114630];j[114630]=0;if((b|0)==1){break i}lc(c+16|0);jb(c+40|0);b=0;j[114630]=0;d=H(1203,d|0)|0;e=j[114630];j[114630]=0;if((e|0)==1){break g}e=l+22|0;if((d|0)!=(k[e|0]|k[e+1|0]<<8|(k[e+2|0]<<16|k[e+3|0]<<24))){break a}b=IL(l);j[114630]=0;E(338,a|0,b|0)|0;a=j[114630];j[114630]=0;b=1;if((a|0)!=1){break a}break f}b=D()|0;C()|0;break b}b=D()|0;C()|0;break h}b=D()|0;C()|0;lc(c+16|0)}jb(c+40|0);break b}b=D()|0;C()|0;break b}b=D()|0;C()|0;break b}b=D()|0;C()|0}jb(f);G(b|0);z()}jb(f)}Za=c+368|0;return b}function pua(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;e=Za-80|0;Za=e;t=j[a+16>>2];k=vf(e+48|0);j[k+8>>2]=a+112;j[k+16>>2]=j[a+128>>2];y=k,z=qf(b+327720|0,j[b+20>>2],(j[a+88>>2]&16384)>>>14|0),j[y+12>>2]=z;b=j[k+16>>2];if(b){y=k,z=uf(a+8|0,b),j[y>>2]=z;j[k+4>>2]=ab}b=j[a+44>>2];j[e+32>>2]=b;g=j[a+48>>2];j[e+36>>2]=g;h=j[a+52>>2];j[e+40>>2]=h;n=j[a+56>>2];j[e+44>>2]=n;u=j[a+24>>2];v=j[a+20>>2];l=j[a+4>>2];f=j[a>>2];j[e+24>>2]=f;j[e+28>>2]=l;m=j[a+12>>2];j[e+16>>2]=j[a+8>>2];j[e+20>>2]=m;if(d){while(1){b=0;g=b;h=f;j[e+72>>2]=f;j[e+76>>2]=b;l=((((l&2147483647)<<1|f>>>31)&2147483646)<<1)+t|0;a:{b=j[k+16>>2];if((b|0)<=0){break a}while(1){f=(g&2147483647)<<1|h>>>31;id(j[k+8>>2],(i[(f<<1|2)+l>>1]+i[l+((f&2147483646)<<1)>>1]|0)/8<<16>>16);hd(j[k+8>>2],4);Bb(e+72|0,k);if((b|0)<2){break a}b=b-1|0;h=j[e+72>>2];g=j[e+76>>2];continue}}b=j[k+8>>2];Bb(b,b+8|0);b=j[k+8>>2];f=j[b+4>>2];if(f){m=b;b=(j[e+76>>2]&2147483647)<<1|j[e+72>>2]>>>31;id(m,(i[(b<<1|2)+l>>1]+i[l+((b&2147483646)<<1)>>1]|0)/8<<16>>16);hd(j[k+8>>2],f);b=j[k+8>>2];f=j[b>>2];j[b>>2]=f;j[b+4>>2]=0}d=d-1|0;h=pf(b,j[k+12>>2]);j[e+12>>2]=h;j[e+8>>2]=h;g=0;n=1;while(1){m=j[a+60>>2];r=m;l=(e+32|0)+(g<<3)|0;o=j[l>>2];b=Gb(o,-16777216,16776704);s=j[a+64>>2];f=Gb(j[l+4>>2],-16777216,16776704);q=j[a+68>>2];w=q;q=q>>31;j[l+4>>2]=o;o=j[a+72>>2];m=m>>31;h=h<<8;m=HMa(r,m,h,h>>31);r=ab;x=(e+8|0)+(g<<2)|0;g=m;m=HMa(s,s>>31,b,b>>31);g=g+m|0;b=ab+r|0;b=g>>>0<m>>>0?b+1|0:b;m=g;g=HMa(w,q,f,f>>31);f=m+g|0;b=ab+b|0;b=f>>>0<g>>>0?b+1|0:b;f=f+8388608|0;if(f>>>0<8388608){b=b+1|0}b=(b&16777215)<<8|f>>>24;j[x>>2]=(b|0)/256;j[l>>2]=b-(h&o);if(n){g=1;n=0;h=j[e+12>>2];continue}break}j[c>>2]=j[c>>2]+p(j[e+8>>2],v);j[c+4>>2]=j[c+4>>2]+p(j[e+12>>2],u);Bb(e+24|0,e+16|0);if(d){c=c+8|0;f=j[e+24>>2];l=j[e+28>>2];continue}break}f=j[e+24>>2];l=j[e+28>>2];n=j[e+44>>2];h=j[e+40>>2];g=j[e+36>>2];b=j[e+32>>2]}j[a+56>>2]=n;j[a+52>>2]=h;j[a+48>>2]=g;j[a+44>>2]=b;j[a>>2]=f;j[a+4>>2]=l;Za=e+80|0}function F$(a,b,c,d,e,f,g,i,l){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;i=i|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0;a=Za-464|0;Za=a;j[a+16>>2]=f;j[a+20>>2]=g;j[a+24>>2]=i;j[a+28>>2]=l;j[a+348>>2]=a+352;m=kv(a+352|0,100,64703,a+16|0);j[a+48>>2]=2421;q=yd(a+232|0,0,a+48|0);j[a+48>>2]=2421;p=yd(a+224|0,0,a+48|0);o=a+240|0;a:{b:{c:{if(m>>>0>=100){j[114630]=0;m=T(2446)|0;o=j[114630];j[114630]=0;if((o|0)==1){break b}j[a>>2]=f;j[a+4>>2]=g;j[114630]=0;j[a+8>>2]=i;j[a+12>>2]=l;m=P(2468,a+348|0,m|0,64703,a|0)|0;f=j[114630];j[114630]=0;if((f|0)==1){break b}f=j[a+348>>2];if(!f){j[114630]=0;M(2422);a=j[114630];j[114630]=0;if((a|0)!=1){break c}break b}fe(q,f);fe(p,Yc(m));if(Vi(p)){j[114630]=0;M(2422);a=j[114630];j[114630]=0;if((a|0)==1){break b}break c}o=j[p>>2]}j[114630]=0;hc(a+216|0,d);f=j[114630];j[114630]=0;d:{e:{f:{g:{h:{i:{j:{if((f|0)!=1){j[114630]=0;s=H(21,a+216|0)|0;f=j[114630];j[114630]=0;if((f|0)==1){break j}j[114630]=0;f=j[a+348>>2];P(2441,s|0,f|0,f+m|0,o|0)|0;f=j[114630];j[114630]=0;if((f|0)==1){break j}r=m?k[j[a+348>>2]]==45:r;i=Cb(a+192|0);g=Cb(a+176|0);f=Cb(a+160|0);j[114630]=0;ba(2502,c|0,r|0,a+216|0,a+208|0,a+207|0,a+206|0,i|0,g|0,f|0,a+156|0);c=j[114630];j[114630]=0;if((c|0)==1){break i}j[a+36>>2]=2421;l=yd(a+40|0,0,a+36|0);c=j[a+156>>2];k:{if((c|0)<(m|0)){n=nb(f)+(m-c<<1|1)|0;break k}n=nb(f)+2|0}c=a+48|0;n=(nb(g)+n|0)+j[a+156>>2]|0;if(n>>>0<101){break h}fe(l,Yc(n));c=j[l>>2];if(c){break h}j[114630]=0;M(2422);b=j[114630];j[114630]=0;if((b|0)!=1){break c}break g}m=D()|0;C()|0;break a}m=D()|0;C()|0;break e}m=D()|0;C()|0;break f}n=j[d+4>>2];j[114630]=0;ga(2503,c|0,a+36|0,a+32|0,n|0,o|0,m+o|0,s|0,r|0,a+208|0,h[a+207|0],h[a+206|0],i|0,g|0,f|0,j[a+156>>2]);m=j[114630];j[114630]=0;if((m|0)!=1){j[114630]=0;b=_(17,b|0,c|0,j[a+36>>2],j[a+32>>2],d|0,e|0)|0;c=j[114630];j[114630]=0;if((c|0)!=1){break d}}}m=D()|0;C()|0;mc(l)}gb(f);gb(g);gb(i)}wb(a+216|0);break a}mc(l);gb(f);gb(g);gb(i);wb(a+216|0);mc(p);mc(q);Za=a+464|0;return b|0}z()}m=D()|0;C()|0}mc(p);mc(q);G(m|0);z()}function xla(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0;c=Za-208|0;Za=c;e=j[a+12>>2];l=1<<e;if(e>>>0>=2){k=l;o=2;f=1;while(1){k=k>>>2|0;if(k){r=p(f,3);s=f<<1;m=0;while(1){ZI(c+192|0,$b(a,m<<1));ZI(c+176|0,$b(a,m));mh(c+160|0,c+176|0,c+192|0);e=m<<o;q=f+e|0;if(e>>>0<q>>>0){while(1){d=$b(b,e);g=j[d+12>>2];j[c+152>>2]=j[d+8>>2];j[c+156>>2]=g;g=j[d+4>>2];j[c+144>>2]=j[d>>2];j[c+148>>2]=g;g=e+f|0;d=$b(b,g);h=j[d+12>>2];j[c+136>>2]=j[d+8>>2];j[c+140>>2]=h;h=j[d+4>>2];j[c+128>>2]=j[d>>2];j[c+132>>2]=h;h=e+s|0;d=$b(b,h);n=j[d+12>>2];j[c+120>>2]=j[d+8>>2];j[c+124>>2]=n;n=j[d+4>>2];j[c+112>>2]=j[d>>2];j[c+116>>2]=n;n=e+r|0;d=$b(b,n);i=j[d+12>>2];j[c+104>>2]=j[d+8>>2];j[c+108>>2]=i;i=j[d+4>>2];j[c+96>>2]=j[d>>2];j[c+100>>2]=i;Lj(c+80|0,c+144|0,c+128|0);Xh(c- -64|0,c+144|0,c+128|0);Lj(c+48|0,c+112|0,c+96|0);Xh(c+16|0,c+112|0,c+96|0);mh(c+32|0,30864,c+16|0);Lj(c+16|0,c+80|0,c+48|0);d=$b(b,e);i=j[c+28>>2];j[d+8>>2]=j[c+24>>2];j[d+12>>2]=i;i=j[c+20>>2];j[d>>2]=j[c+16>>2];j[d+4>>2]=i;Lj(c,c- -64|0,c+32|0);mh(c+16|0,c+192|0,c);d=$b(b,g);i=j[c+28>>2];j[d+8>>2]=j[c+24>>2];j[d+12>>2]=i;g=j[c+20>>2];j[d>>2]=j[c+16>>2];j[d+4>>2]=g;Xh(c,c+80|0,c+48|0);mh(c+16|0,c+176|0,c);d=$b(b,h);h=j[c+28>>2];j[d+8>>2]=j[c+24>>2];j[d+12>>2]=h;g=j[c+20>>2];j[d>>2]=j[c+16>>2];j[d+4>>2]=g;Xh(c,c- -64|0,c+32|0);mh(c+16|0,c+160|0,c);d=$b(b,n);h=j[c+28>>2];j[d+8>>2]=j[c+24>>2];j[d+12>>2]=h;g=j[c+20>>2];j[d>>2]=j[c+16>>2];j[d+4>>2]=g;e=e+1|0;if((q|0)!=(e|0)){continue}break}}m=m+1|0;if((m|0)!=(k|0)){continue}break}e=j[a+12>>2]}f=f<<2;o=o+2|0;if(o>>>0<=e>>>0){continue}break}}a:{if(!(e&1)){break a}k=l>>>1|0;if(!k){break a}e=0;while(1){l=e+k|0;a=$b(b,l);f=j[a+12>>2];j[c+200>>2]=j[a+8>>2];j[c+204>>2]=f;f=j[a+4>>2];j[c+192>>2]=j[a>>2];j[c+196>>2]=f;Xh(c+176|0,$b(b,e),c+192|0);a=$b(b,l);f=j[c+188>>2];j[a+8>>2]=j[c+184>>2];j[a+12>>2]=f;l=j[c+180>>2];j[a>>2]=j[c+176>>2];j[a+4>>2]=l;Iw($b(b,e),c+192|0);e=e+1|0;if((k|0)!=(e|0)){continue}break}}Za=c+208|0}function Yu(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,i=0,l=0;f=j[b>>2];a:{b:{c:{d:{e:{f:{g:{h:{i:{j:{k:{l:{if(!d){break l}g=j[d>>2];if(!g){break l}if(!a){d=c;break j}j[d>>2]=0;d=c;break k}m:{if(!j[j[21255]>>2]){if(!a){break m}if(!c){break a}g=c;while(1){d=h[f|0];if(d){j[a>>2]=d&57343;a=a+4|0;f=f+1|0;g=g-1|0;if(g){continue}break a}break}j[a>>2]=0;j[b>>2]=0;return c-g|0}d=c;if(!a){break i}break g}return ne(f)|0}e=1;break g}e=0;break h}e=1}while(1){if(!e){e=k[f|0]>>>3|0;if((e-16|e+(g>>26))>>>0>7){break f}i=f+1|0;e=i;n:{if(!(g&33554432)){break n}if((k[i|0]&192)!=128){break f}i=f+2|0;e=i;if(!(g&524288)){break n}if((k[i|0]&192)!=128){break f}e=f+3|0}f=e;d=d-1|0;e=1;continue}while(1){g=k[f|0];o:{if(f&3|g-1>>>0>126){break o}g=j[f>>2];if((g|g-16843009)&-2139062144){break o}while(1){d=d-4|0;g=j[f+4>>2];e=f+4|0;f=e;if(!((g-16843009|g)&-2139062144)){continue}break}f=e}e=g&255;if(e-1>>>0<=126){d=d-1|0;f=f+1|0;continue}break}e=e-194|0;if(e>>>0>50){break e}f=f+1|0;g=j[(e<<2)+60128>>2];e=0;continue}}while(1){if(!e){if(!d){break a}while(1){p:{e=k[f|0];i=e-1|0;q:{r:{if(i>>>0>126){g=e;break r}if(f&3|d>>>0<5){break q}s:{while(1){g=j[f>>2];if((g|g-16843009)&-2139062144){break s}j[a>>2]=g&255;j[a+4>>2]=k[f+1|0];j[a+8>>2]=k[f+2|0];j[a+12>>2]=k[f+3|0];a=a+16|0;f=f+4|0;d=d-4|0;if(d>>>0>4){continue}break}g=k[f|0]}e=g&255;i=e-1|0}if(i>>>0>126){break p}}j[a>>2]=e;a=a+4|0;f=f+1|0;d=d-1|0;if(d){continue}break a}break}e=e-194|0;if(e>>>0>50){break e}f=f+1|0;g=j[(e<<2)+60128>>2];e=1;continue}i=k[f|0];e=i>>>3|0;if((e-16|e+(g>>26))>>>0>7){break f}t:{u:{l=f+1|0;e=i-128|g<<6;i=l;v:{if((e|0)>-1){break v}i=k[l|0]-128|0;if(i>>>0>63){break u}l=f+2|0;e=i|e<<6;i=l;if((e|0)>-1){break v}i=k[l|0]-128|0;if(i>>>0>63){break u}e=i|e<<6;i=f+3|0}f=i;j[a>>2]=e;d=d-1|0;a=a+4|0;break t}j[114604]=25;f=f-1|0;break c}e=0;continue}}f=f-1|0;if(g){break d}g=k[f|0]}if(g&255){break d}if(a){j[a>>2]=0;j[b>>2]=0}return c-d|0}j[114604]=25;if(!a){break b}}j[b>>2]=f}return-1}j[b>>2]=f;return c|0}function FB(a,b,c,d,e,f,g,h,i){var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;k=Za-128|0;Za=k;a:{b:{c:{if(!Ik(f,g,h,i,0,0,0,0)){break c}m=nX(f,g,h,i);s=e>>>16|0;o=s&32767;if((o|0)==32767){break c}if(m){break b}}bd(k+16|0,b,c,d,e,f,g,h,i);e=j[k+16>>2];d=j[k+20>>2];c=j[k+24>>2];b=j[k+28>>2];yD(k,e,d,c,b,e,d,c,b);d=j[k+8>>2];e=j[k+12>>2];h=j[k>>2];i=j[k+4>>2];break a}m=o<<16;p=d;r=m|e&65535;n=r;q=h;r=i>>>16&32767;l=i&65535|r<<16;if((Ik(b,c,p,n,f,g,h,l)|0)<=0){if(Ik(b,c,p,n,f,g,q,l)){h=b;i=c;break a}bd(k+112|0,b,c,d,e,0,0,0,0);d=j[k+120>>2];e=j[k+124>>2];h=j[k+112>>2];i=j[k+116>>2];break a}if(o){i=c;h=b}else{bd(k+96|0,b,c,p,n,0,0,0,1081540608);h=j[k+108>>2];n=h;p=j[k+104>>2];o=(h>>>16|0)-120|0;i=j[k+100>>2];h=j[k+96>>2]}if(!r){bd(k+80|0,f,g,q,l,0,0,0,1081540608);f=j[k+92>>2];l=f;q=j[k+88>>2];r=(l>>>16|0)-120|0;g=j[k+84>>2];f=j[k+80>>2]}t=l&65535|65536;n=n&65535|65536;if((o|0)>(r|0)){while(1){l=p;m=q;u=l-m|0;m=n-((l>>>0<m>>>0)+t|0)|0;l=(g|0)==(i|0)&f>>>0>h>>>0|g>>>0>i>>>0;m=m-(l>>>0>u>>>0)|0;l=u-l|0;d:{if((m|0)>0?1:(m|0)>=0){n=h;h=h-f|0;i=i-((f>>>0>n>>>0)+g|0)|0;if(!(h|l|(i|m))){bd(k+32|0,b,c,d,e,0,0,0,0);d=j[k+40>>2];e=j[k+44>>2];h=j[k+32>>2];i=j[k+36>>2];break a}m=m<<1|l>>>31;p=l<<1|i>>>31;break d}m=n<<1|p>>>31;p=p<<1|i>>>31}n=m;m=i<<1|h>>>31;h=h<<1;i=m;o=o-1|0;if((r|0)<(o|0)){continue}break}o=r}m=p;r=m-q|0;l=n-((m>>>0<q>>>0)+t|0)|0;m=(g|0)==(i|0)&f>>>0>h>>>0|g>>>0>i>>>0;l=l-(m>>>0>r>>>0)|0;q=r-m|0;e:{if((l|0)<0){q=p;l=n;break e}p=h;h=h-f|0;i=i-((f>>>0>p>>>0)+g|0)|0;if(h|q|(i|l)){break e}bd(k+48|0,b,c,d,e,0,0,0,0);d=j[k+56>>2];e=j[k+60>>2];h=j[k+48>>2];i=j[k+52>>2];break a}if((l|0)==65535|l>>>0<65535){while(1){b=i>>>31|0;o=o-1|0;n=i<<1|h>>>31;h=h<<1;i=n;c=b;b=q;l=l<<1|b>>>31;q=c|b<<1;if(l>>>0<65536){continue}break}}b=s&32768;if((o|0)<=0){bd(k- -64|0,h,i,q,l&65535|(b|o+120)<<16,0,0,0,1065811968);d=j[k+72>>2];e=j[k+76>>2];h=j[k+64>>2];i=j[k+68>>2];break a}d=q;e=l&65535|(b|o)<<16}j[a>>2]=h;j[a+4>>2]=i;j[a+8>>2]=d;j[a+12>>2]=e;Za=k+128|0}function Xsa(a,b,c){var d=0,e=0,f=0,g=0,m=0;d=Za-160|0;Za=d;f=Gk(d+56|0,a);j[114630]=0;e=E(683,d+40|0,18621)|0;a=j[114630];j[114630]=0;a:{b:{c:{d:{if((a|0)!=1){j[114630]=0;j[d+24>>2]=19466242;j[d+28>>2]=0;I(684,f|0,e|0,d+24|0);a=j[114630];j[114630]=0;if((a|0)==1){break d}qb(e);if(!(j[f>>2]&1073741824)){break c}break a}a=D()|0;C()|0;break b}a=D()|0;C()|0;qb(e);break b}j[114630]=0;h[d+39|0]=0;e=E(683,d+40|0,18628)|0;a=j[114630];j[114630]=0;e:{f:{g:{h:{i:{j:{k:{l:{m:{n:{o:{p:{if((a|0)!=1){j[114630]=0;K(685,f|0,d+39|0,e|0)|0;a=j[114630];j[114630]=0;if((a|0)==1){break p}qb(e);e=Cb(d+40|0);j[114630]=0;g=E(683,d+24|0,18630)|0;a=j[114630];j[114630]=0;if((a|0)==1){break o}j[114630]=0;K(1177,f|0,e|0,g|0)|0;a=j[114630];j[114630]=0;if((a|0)==1){break n}qb(g);j[114630]=0;I(13,d+24|0,(k[d+39|0]?0:c)|0,e|0);a=j[114630];j[114630]=0;if((a|0)==1){break m}j[114630]=0;F(486,b|0,d+24|0);a=j[114630];j[114630]=0;if((a|0)==1){break l}gb(d+24|0);j[114630]=0;i[d+22>>1]=0;c=E(683,d+24|0,18632)|0;a=j[114630];j[114630]=0;if((a|0)==1){break f}j[114630]=0;K(1178,f|0,d+22|0,c|0)|0;a=j[114630];j[114630]=0;if((a|0)==1){break k}qb(c);Rf(d+22|0,l[j[19863]+12>>1]);j[114630]=0;c=E(683,d+24|0,18634)|0;a=j[114630];j[114630]=0;if((a|0)==1){break j}a=j[yc(d+16|0,l[d+22>>1])>>2];j[114630]=0;P(1179,f|0,b|0,c|0,a|0)|0;a=j[114630];j[114630]=0;if((a|0)==1){break i}qb(c);j[114630]=0;i[d+14>>1]=65535;c=E(683,d+24|0,18636)|0;a=j[114630];j[114630]=0;if((a|0)==1){break h}j[114630]=0;a=K(1178,f|0,d+14|0,c|0)|0;g=j[114630];j[114630]=0;if((g|0)==1){break g}g=l[d+22>>1];m=l[d+14>>1];qb(c);if(!((a|0)==1|g>>>0<=m>>>0)){Fe(b,l[d+14>>1])}gb(e);break a}a=D()|0;C()|0;break b}a=D()|0;C()|0;qb(e);break b}a=D()|0;C()|0;break e}a=D()|0;C()|0;qb(g);break e}a=D()|0;C()|0;break e}a=D()|0;C()|0;gb(d+24|0);break e}a=D()|0;C()|0;qb(c);break e}a=D()|0;C()|0;break e}a=D()|0;C()|0;qb(c);break e}a=D()|0;C()|0;break e}a=D()|0;C()|0;qb(c);break e}a=D()|0;C()|0}gb(e)}ag(f);G(a|0);z()}ag(f);Za=d+160|0}function BG(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;var k=0,l=0,m=0;l=Za-48|0;Za=l;a:{b:{c:{d:{e:{f:{k=Mn(1,28);if(!k){a=R(4)|0;Bk(a);j[114630]=0;I(2004,a|0,71412,2003);a=j[114630];j[114630]=0;if((a|0)!=1){break a}break f}j[k+24>>2]=0;j[k+16>>2]=0;j[k+20>>2]=0;j[k+12>>2]=f;j[k+8>>2]=e;j[k+4>>2]=d;j[k>>2]=c?c:1992;d=_r(l+32|0);g:{h:{if(!i){break h}c=j[i>>2];if(!c){break h}while(1){i:{e=j[i+4>>2];if(e){j[114630]=0;c=E(85,l+16|0,c|0)|0;f=j[114630];j[114630]=0;j:{if((f|0)!=1){j[114630]=0;f=E(2005,d|0,c|0)|0;m=j[114630];j[114630]=0;if((m|0)==1){break j}j[114630]=0;E(483,f|0,e|0)|0;e=j[114630];j[114630]=0;if((e|0)==1){break j}break i}i=J(0)|0;C()|0;break g}i=J(0)|0;C()|0;gb(c);break g}j[114630]=0;c=E(85,l+16|0,c|0)|0;e=j[114630];j[114630]=0;k:{if((e|0)!=1){j[114630]=0;E(2006,d|0,c|0)|0;e=j[114630];j[114630]=0;if((e|0)==1){break k}break i}i=J(0)|0;C()|0;break g}i=J(0)|0;C()|0;gb(c);break g}gb(c);c=j[i+8>>2];i=i+8|0;if(c){continue}break}}j[114630]=0;c=H(1394,80)|0;e=j[114630];j[114630]=0;l:{m:{n:{if((e|0)!=1){j[114630]=0;I(2007,l+16|0,k|0,k+4|0);e=j[114630];j[114630]=0;if((e|0)==1){break n}e=io(l+8|0,l+16|0);j[114630]=0;U(2009,c|0,a|0,b|0,e|0,d|0)|0;a=j[114630];j[114630]=0;if((a|0)==1){break m}j[k+24>>2]=c;Gc(e);Gc(l+16|0);Sj(d);c=k;break d}i=J(0)|0;C()|0;break g}i=J(0)|0;C()|0;break l}i=J(0)|0;C()|0;Gc(e);Gc(l+16|0)}Fb(c)}Sj(d);O(i|0)|0;j[114630]=0;L(1984,34745,k|0,g|0,h|0);a=j[114630];j[114630]=0;if((a|0)!=1){j[114630]=0;M(20);a=j[114630];j[114630]=0;if((a|0)==1){break f}a=j[k+24>>2];if(a){Fb(gr(a))}c=0;j[k+24>>2]=0;a=j[k+20>>2];if(a){Fb(a);j[k+20>>2]=0}Fb(k);break d}i=J(0)|0;C()|0;j[114630]=0;M(20);a=j[114630];j[114630]=0;if((a|0)!=1){break e}break b}i=J(0)|0;C()|0}O(i|0)|0;c=0;j[114630]=0;L(1984,34745,0,g|0,h|0);a=j[114630];j[114630]=0;if((a|0)==1){break c}Q()}Za=l+48|0;return c|0}a=D()|0;C()|0;j[114630]=0;M(20);b=j[114630];j[114630]=0;if((b|0)==1){break b}G(a|0);z()}J(0)|0;C()|0;ib()}z()}function Wua(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;f=Za-48|0;Za=f;a:{b:{c:{h=j[a+8>>2];e=j[a+12>>2];d:{if((e|0)<1?1:(e|0)<=1?h>>>0<=805306368:0){if((e|0)>-2?1:(e|0)>=-2?h>>>0>=3489660928:0){break c}if((e|0)>-2?1:(e|0)>=-2?h>>>0>2147483647:0){break d}break b}if((e|0)>1?1:(e|0)>=1?h>>>0>2147483648:0){break b}}b=b+196648|0;break a}b=b+131112|0;break a}b=b+262184|0}u=b;v=j[a+16>>2];b=j[a+44>>2];j[f+32>>2]=b;k=j[a+48>>2];j[f+36>>2]=k;m=j[a+52>>2];j[f+40>>2]=m;n=j[a+56>>2];j[f+44>>2]=n;w=j[a+24>>2];x=j[a+20>>2];g=j[a+4>>2];l=j[a>>2];j[f+24>>2]=l;j[f+28>>2]=g;j[f+16>>2]=h;j[f+20>>2]=e;if(d){while(1){n=1;e=((((g&2147483647)<<1|l>>>31)&2147483646)<<1)+v|0;b=(l>>>16&65520)+u|0;l=i[b+14>>1];h=i[b+12>>1];q=i[b+10>>1];r=i[b+8>>1];s=i[b+6>>1];o=i[b+4>>1];t=i[b+2>>1];y=i[b>>1];m=0;b=1;k=0;while(1){g=k<<1;j[(f+8|0)+(k<<2)>>2]=(((((((p(i[e+(g|-8)>>1],t)+p(i[e+(g|-12)>>1],y)|0)+p(i[e+(g|-4)>>1],o)|0)+p(i[e+g>>1],s)|0)+p(i[e+(g|4)>>1],r)|0)+p(i[e+(g|8)>>1],q)|0)+p(i[e+(g|12)>>1],h)|0)+p(l,i[e+(g|16)>>1])|0)/32768;g=b;b=0;k=1;if(g){continue}break}while(1){k=(f+8|0)+(m<<2)|0;l=j[k>>2];h=j[a+60>>2];q=h;g=(f+32|0)+(m<<3)|0;m=j[g>>2];b=Gb(m,-16777216,16776704);r=j[a+64>>2];e=Gb(j[g+4>>2],-16777216,16776704);o=j[a+68>>2];t=o;o=o>>31;j[g+4>>2]=m;m=j[a+72>>2];s=h>>31;l=l<<8;h=l;h=HMa(q,s,h,h>>31);q=ab;s=k;k=h;h=HMa(r,r>>31,b,b>>31);k=k+h|0;b=ab+q|0;b=h>>>0>k>>>0?b+1|0:b;h=k;k=HMa(t,o,e,e>>31);e=h+k|0;b=ab+b|0;b=e>>>0<k>>>0?b+1|0:b;e=e+8388608|0;if(e>>>0<8388608){b=b+1|0}b=(b&16777215)<<8|e>>>24;j[s>>2]=(b|0)/256;j[g>>2]=b-(l&m);m=1;b=n&1;n=0;if(b){continue}break}j[c>>2]=j[c>>2]+p(j[f+8>>2],x);j[c+4>>2]=j[c+4>>2]+p(j[f+12>>2],w);Bb(f+24|0,f+16|0);d=d-1|0;if(d){c=c+8|0;l=j[f+24>>2];g=j[f+28>>2];continue}break}l=j[f+24>>2];g=j[f+28>>2];n=j[f+44>>2];m=j[f+40>>2];k=j[f+36>>2];b=j[f+32>>2]}j[a+56>>2]=n;j[a+52>>2]=m;j[a+48>>2]=k;j[a+44>>2]=b;j[a>>2]=l;j[a+4>>2]=g;Za=f+48|0}function kea(a,b,c,d){var e=0,f=0,g=0,h=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;e=j[a+4>>2];t=e&2047;if(d){u=a+8256|0;v=a- -64|0;w=a+24640|0;x=a+16448|0;while(1){q=i[(((e+754&2047)<<2)+u|0)+2>>1];s=i[((e+1206&2047)<<2)+u>>1];f=i[(((e+1602&2047)<<2)+v|0)+2>>1];m=i[((e+1750&2047)<<2)+v>>1];k=((e+22&2047)<<2)+w|0;g=i[k+2>>1];k=i[k>>1];h=((e+502&2047)<<2)+w|0;l=i[h+2>>1];n=i[b>>1];o=i[b+2>>1];h=i[h>>1];r=Ac(i[a+32>>1]-h|0);y=i[a+24>>1];z=Ac(i[a+34>>1]-l|0);A=i[a+26>>1];B=Ac(i[a+36>>1]-k|0);C=i[a+28>>1];D=Ac(i[a+38>>1]-g|0);E=i[a+30>>1];F=a,G=Dc(Ac((p(r,y)|0)/65536<<1)+h|0),i[F+32>>1]=G;F=a,G=Dc(Ac((p(z,A)|0)/65536<<1)+l|0),i[F+34>>1]=G;F=a,G=Dc(Ac((p(B,C)|0)/65536<<1)+k|0),i[F+36>>1]=G;F=a,G=Dc(Ac((p(D,E)|0)/65536<<1)+g|0),i[F+38>>1]=G;g=Ac((p(i[a+32>>1],i[a+16>>1])|0)/32768|0);l=Ac((p(i[a+38>>1],i[a+22>>1])|0)/32768|0);k=Ac(g+((n|0)/4<<16>>16)|0);l=Ac(l+((o|0)/4<<16>>16)|0);h=Ac(k+((p(m,i[a+8>>1])|0)/-65536|0)|0);g=t<<2;n=g+v|0;o=Ac(l+((p(f,i[a+10>>1])|0)/-65536|0)|0);i[n+2>>1]=o;i[n>>1]=h;m=Ac(m+((p(h,i[a+8>>1])|0)/65536|0)|0);h=g+x|0;f=Ac(f+((p(o,i[a+10>>1])|0)/65536|0)|0);i[h+2>>1]=f;i[h>>1]=m;m=Ac(k+m|0);k=Ac(f+l|0);f=((e+426&2047)<<2)+x|0;l=i[f+2>>1];h=i[f>>1];e=((e+682&2047)<<2)+x|0;n=i[e+2>>1];o=i[e>>1];e=Ac((p(n,i[a+42>>1])+p(o,i[a+40>>1])|0)/32768|0);f=Ac((p(l,i[a+46>>1])+p(h,i[a+44>>1])|0)/32768|0);o=Ac(Ac(m+o|0)-e|0);n=Ac(Ac(k+n|0)-f|0);m=Ac(Ac(h+m|0)-e|0);k=Ac(Ac(k+l|0)-f|0);e=Ac(e+((p(i[a+8>>1],s)|0)/-65536|0)|0);f=Ac(f+((p(q,i[a+10>>1])|0)/-65536|0)|0);l=i[a+8>>1];h=i[a+10>>1];r=g+u|0;i[r+2>>1]=f;i[r>>1]=e;r=s;s=(p(e,l)|0)/65536|0;e=Ac(r+s|0);g=g+w|0;f=(p(f,h)|0)/65536|0;q=Ac(f+q|0);i[g+2>>1]=q;i[g>>1]=e;e=Ac(e+o|0);g=i[a+48>>1];q=Ac(n+q|0);j[c>>2]=(j[c>>2]+p(e,g)|0)+p(q,i[a+50>>1]);e=Ac(Ac(s)+m|0);g=i[a+52>>1];f=Ac(Ac(f)+k|0);j[c+4>>2]=(j[c+4>>2]+p(e,g)|0)+p(f,i[a+54>>1]);c=c+8|0;b=b+4|0;e=t+1|0;t=e&2047;d=d-1|0;if(d){continue}break}}j[a+4>>2]=t}function qua(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,i=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;e=Za-80|0;Za=e;t=j[a+16>>2];k=vf(e+48|0);j[k+8>>2]=a+112;j[k+16>>2]=j[a+128>>2];y=k,z=qf(b+327720|0,j[b+20>>2],(j[a+88>>2]&16384)>>>14|0),j[y+12>>2]=z;b=j[k+16>>2];if(b){y=k,z=uf(a+8|0,b),j[y>>2]=z;j[k+4>>2]=ab}b=j[a+44>>2];j[e+32>>2]=b;g=j[a+48>>2];j[e+36>>2]=g;i=j[a+52>>2];j[e+40>>2]=i;n=j[a+56>>2];j[e+44>>2]=n;u=j[a+24>>2];v=j[a+20>>2];l=j[a+4>>2];f=j[a>>2];j[e+24>>2]=f;j[e+28>>2]=l;m=j[a+12>>2];j[e+16>>2]=j[a+8>>2];j[e+20>>2]=m;if(d){while(1){b=0;g=b;i=f;j[e+72>>2]=f;j[e+76>>2]=b;l=(((l&2147483647)<<1|f>>>31)&-2)+t|0;a:{b=j[k+16>>2];if((b|0)<=0){break a}while(1){f=(g&2147483647)<<1|i>>>31;id(j[k+8>>2],h[(f|1)+l|0]+h[l+(f&-2)|0]<<5);hd(j[k+8>>2],4);Bb(e+72|0,k);if((b|0)<2){break a}b=b-1|0;i=j[e+72>>2];g=j[e+76>>2];continue}}b=j[k+8>>2];Bb(b,b+8|0);b=j[k+8>>2];f=j[b+4>>2];if(f){m=b;b=(j[e+76>>2]&2147483647)<<1|j[e+72>>2]>>>31;id(m,h[(b|1)+l|0]+h[l+(b&-2)|0]<<5);hd(j[k+8>>2],f);b=j[k+8>>2];f=j[b>>2];j[b>>2]=f;j[b+4>>2]=0}d=d-1|0;i=pf(b,j[k+12>>2]);j[e+12>>2]=i;j[e+8>>2]=i;g=0;n=1;while(1){m=j[a+60>>2];r=m;l=(e+32|0)+(g<<3)|0;o=j[l>>2];b=Gb(o,-16777216,16776704);s=j[a+64>>2];f=Gb(j[l+4>>2],-16777216,16776704);q=j[a+68>>2];w=q;q=q>>31;j[l+4>>2]=o;o=j[a+72>>2];m=m>>31;i=i<<8;m=HMa(r,m,i,i>>31);r=ab;x=(e+8|0)+(g<<2)|0;g=m;m=HMa(s,s>>31,b,b>>31);g=g+m|0;b=ab+r|0;b=g>>>0<m>>>0?b+1|0:b;m=g;g=HMa(w,q,f,f>>31);f=m+g|0;b=ab+b|0;b=f>>>0<g>>>0?b+1|0:b;f=f+8388608|0;if(f>>>0<8388608){b=b+1|0}b=(b&16777215)<<8|f>>>24;j[x>>2]=(b|0)/256;j[l>>2]=b-(i&o);if(n){g=1;n=0;i=j[e+12>>2];continue}break}j[c>>2]=j[c>>2]+p(j[e+8>>2],v);j[c+4>>2]=j[c+4>>2]+p(j[e+12>>2],u);Bb(e+24|0,e+16|0);if(d){c=c+8|0;f=j[e+24>>2];l=j[e+28>>2];continue}break}f=j[e+24>>2];l=j[e+28>>2];n=j[e+44>>2];i=j[e+40>>2];g=j[e+36>>2];b=j[e+32>>2]}j[a+56>>2]=n;j[a+52>>2]=i;j[a+48>>2]=g;j[a+44>>2]=b;j[a>>2]=f;j[a+4>>2]=l;Za=e+80|0}function NAa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,i=0;e=Za-16|0;Za=e;h[a|0]=0;c=k[b|0];if(c){h[a|0]=c>>>0>96?-1:c+12|0}h[a+1|0]=k[b+1|0];c=a;d=k[b+2|0];a:{b:{if((d-16&255)>>>0<=128){h[a+2|0]=1;d=(d-16|0)/2|0;break b}c:{switch((d+96&240)>>>4|0){case 0:h[a+2|0]=4;d=d&15;break b;case 1:h[a+2|0]=3;d=d&15;break b;case 2:h[a+2|0]=6;d=d&15;break b;case 3:break c;default:break a}}h[a+2|0]=5;d=d&15}h[c+4|0]=d}d:{e:{f:{g:{h:{i:{j:{k:{l:{m:{n:{o:{p:{q:{r:{c=k[b+4|0];if(c>>>0<=28){switch(c|0){case 16:break j;case 15:break k;case 12:break l;case 8:break m;case 4:break n;case 3:break o;case 2:break p;case 1:break q;case 0:break r;default:break d}}s:{switch(c-29|0){case 7:break f;case 5:break g;case 3:break h;case 0:break i;case 1:case 2:case 4:case 6:break d;default:break s}}if((c|0)==128){break e}if((c|0)!=157){break d}h[a+2|0]=15;c=k[b+6|0];h[a+3|0]=20;h[a+4|0]=c>>>3;h[e+15|0]=15;g=a,i=k[Zb(b+5|0,e+15|0)|0]|208,h[g+5|0]=i;break d}c=k[b+6|0];d=k[b+5|0];if(!(c|d)){break d}h[a+5|0]=d;h[a+3|0]=c;_i(a);f=k[b+6|0]==15;break d}h[a+3|0]=2;g=a,i=bj(k[b+6|0]<<4|k[b+5|0]>>>4),h[g+5|0]=i;break d}h[a+3|0]=3;g=a,i=bj(k[b+6|0]<<4|k[b+5|0]>>>4),h[g+5|0]=i;break d}h[a+3|0]=4;g=a,i=bj(k[b+6|0]<<4|k[b+5|0]>>>4),h[g+5|0]=i;break d}h[a+3|0]=5;h[a+5|0]=k[b+6|0]&240|k[b+5|0]>>>4;break d}c=k[b+5|0];if(c){h[a+5|0]=c;h[a+3|0]=9;break d}if((k[b+6|0]-1&255)>>>0>1){break d}h[a+5|0]=145;h[a+3|0]=20;break d}h[a+3|0]=13;h[a+5|0]=k[b+6|0]>>>1;break d}c=k[b+6|0];if(c){h[a+5|0]=c;h[a+3|0]=17;break d}h[a+3|0]=16;h[a+5|0]=k[b+5|0]&15;break d}h[a+3|0]=k[b+6|0];h[a+5|0]=k[b+5|0];$x(a,1);f=(k[a+3|0]&254)==16;break d}h[a+3|0]=18;h[a+5|0]=k[b+5|0];break d}h[a+3|0]=31;h[a+5|0]=k[b+6|0]>>>1;break d}h[a+3|0]=31;h[a+5|0]=k[b+6|0]>>>1&120;break d}h[a+5|0]=159;h[a+3|0]=20;break d}h[a+3|0]=21;h[a+5|0]=k[b+6|0]>>>2}b=k[b+3|0];t:{if(!b){break t}if(!k[a+3|0]){h[a+5|0]=b;h[a+3|0]=9;break t}if(k[a+2|0]){break t}h[a+2|0]=2;h[a+4|0]=b>>>2}Za=e+16|0;return f|0}function oU(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;f=Za-16|0;Za=f;if((d|0)<1){a=0}else{Pn(c,d);j[f+4>>2]=b;j[f>>2]=a;a=lb(j[c>>2]);j[f+12>>2]=d;j[f+8>>2]=a;q=d;a=0;b=0;while(1){a:{e=dg(f,b);n=dg(f,b+4|0)<<8|dg(f,b+5|0);g=dg(f,b+6|0);i=dg(f,b+7|0);t=b+8|0;b:{c:{d:{switch(e|0){case 0:b=0;if(!n){break c}while(1){Qp(f,a+b|0,dg(f,b+t|0));b=b+1|0;if((n|0)!=(b|0)){continue}break}break c;case 1:break d;default:break a}}o=dg(f,b+10|0);Qp(f,a,o);a=(a>>>0<d>>>0)+a|0;n=n+3&65532;r=i|g<<8;if(r>>>0<2){break b}k=b+11|0;b=r-1|0;g=0;l=0;m=0;p=0;while(1){i=Ef(k,g,1,f);e:{f:{g:{h:{i:{if((l|0)<=7){if(i){e=g;break f}g=g+1|0;m=8;break i}e=g+1|0;j:{if(!i){if(!Ef(k,e,1,f)){break f}e=2;k:{l:{h=g+2|0;if(!Ef(k,h,1,f)){break l}e=3;h=g+3|0;if(!Ef(k,h,1,f)){break l}e=Ef(k,h,3,f);g=g+6|0;break k}g=h+1|0}h=4;m=nU(((m<<3)+e|0)-17|0);if((m|0)!=8){break h}break j}h=4;g=e;if((m|0)!=8){break h}}m=8;h=1;if((p|0)>19){break h}}h=0;break g}p=p+8|0}e=b;m:{if((b|0)<1){break m}while(1){o=o-mU(k,g,m,f)|0;Qp(f,a,o&255);e=b-1|0;g=g+m|0;a=(a>>>0<d>>>0)+a|0;if((h|0)<1){break m}h=h-1|0;i=(b|0)>1;b=e;if(i){continue}break}}l=(l|0)==31?31:l+1|0;b=e;break e}n:{o:{p:{h=e+1|0;if(!Ef(k,h,1,f)){e=2;break p}h=e+2|0;if(!Ef(k,h,1,f)){e=4;break p}h=e+3|0;if(!Ef(k,h,1,f)){e=6;break p}i=e+5|0;if(!Ef(k,e+4|0,1,f)){g=e+8|0;h=Ef(k,i,3,f)+8|0;break n}g=e+10|0;e=16;i=Ef(k,i,5,f);break o}g=h+2|0;i=Ef(k,h+1|0,1,f)}h=e+i|0}q:{if(Ef(k,g,1,f)){i=-256;e=12;break q}g=g+1|0;e=Ef(k,g,1,f);i=e?-4352:0;e=e?14:8}g=g+1|0;s=Ef(k,g,e,f);if((h|0)>=3){l=l-((h|0)!=3)|0;l=(l|0)>0?l-1|0:0}g=e+g|0;if((h|0)<1|(b|0)<1){break e}e=(a+i|0)+(s^-1)|0;i=b;while(1){o=kU(f,e);Qp(f,a,o);b=i-1|0;a=(a>>>0<d>>>0)+a|0;if((h|0)<2){break e}e=e+1|0;h=h-1|0;s=(i|0)>1;i=b;if(s){continue}break}}p=p-(p>>3)|0;if((b|0)>0){continue}break}break b}a=a+n|0;r=n}b=n+t|0;q=q-r|0;if((q|0)>0){continue}}break}Pn(c,j[f+12>>2]-q|0);a=Xc(c)^1}Za=f+16|0;return a|0}function Xua(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;f=Za-48|0;Za=f;a:{b:{c:{g=j[a+8>>2];e=j[a+12>>2];d:{if((e|0)<1?1:(e|0)<=1?g>>>0<=805306368:0){if((e|0)>-2?1:(e|0)>=-2?g>>>0>=3489660928:0){break c}if((e|0)>-2?1:(e|0)>=-2?g>>>0>2147483647:0){break d}break b}if((e|0)>1?1:(e|0)>=1?g>>>0>2147483648:0){break b}}b=b+196648|0;break a}b=b+131112|0;break a}b=b+262184|0}v=b;w=j[a+16>>2];b=j[a+44>>2];j[f+32>>2]=b;n=j[a+48>>2];j[f+36>>2]=n;m=j[a+52>>2];j[f+40>>2]=m;o=j[a+56>>2];j[f+44>>2]=o;x=j[a+24>>2];y=j[a+20>>2];k=j[a+4>>2];l=j[a>>2];j[f+24>>2]=l;j[f+28>>2]=k;j[f+16>>2]=g;j[f+20>>2]=e;if(d){while(1){e=(((k&2147483647)<<1|l>>>31)&-2)+w|0;b=(l>>>16&65520)+v|0;l=i[b+14>>1];g=i[b+12>>1];r=i[b+10>>1];s=i[b+8>>1];t=i[b+6>>1];q=i[b+4>>1];u=i[b+2>>1];z=i[b>>1];m=0;o=1;n=1;b=0;while(1){j[(f+8|0)+(b<<2)>>2]=(((((((p(h[e+(b|-4)|0],u)+p(h[e+(b|-6)|0],z)|0)+p(h[e+(b|-2)|0],q)|0)+p(h[b+e|0],t)|0)+p(h[e+(b|2)|0],s)|0)+p(h[e+(b|4)|0],r)|0)+p(h[e+(b|6)|0],g)|0)+p(l,h[e+(b|8)|0])<<8)/32768;k=n;n=0;b=1;if(k){continue}break}while(1){e=(f+8|0)+(m<<2)|0;l=j[e>>2];g=j[a+60>>2];r=g;n=(f+32|0)+(m<<3)|0;m=j[n>>2];b=Gb(m,-16777216,16776704);s=j[a+64>>2];k=Gb(j[n+4>>2],-16777216,16776704);q=j[a+68>>2];u=q;q=q>>31;j[n+4>>2]=m;m=j[a+72>>2];t=g>>31;l=l<<8;g=l;g=HMa(r,t,g,g>>31);r=ab;t=e;e=g;g=HMa(s,s>>31,b,b>>31);e=e+g|0;b=ab+r|0;b=e>>>0<g>>>0?b+1|0:b;g=e;e=HMa(u,q,k,k>>31);k=g+e|0;b=ab+b|0;b=e>>>0>k>>>0?b+1|0:b;k=k+8388608|0;if(k>>>0<8388608){b=b+1|0}b=(b&16777215)<<8|k>>>24;j[t>>2]=(b|0)/256;j[n>>2]=b-(l&m);m=1;b=o&1;o=0;if(b){continue}break}j[c>>2]=j[c>>2]+p(j[f+8>>2],y);j[c+4>>2]=j[c+4>>2]+p(j[f+12>>2],x);Bb(f+24|0,f+16|0);d=d-1|0;if(d){c=c+8|0;l=j[f+24>>2];k=j[f+28>>2];continue}break}l=j[f+24>>2];k=j[f+28>>2];o=j[f+44>>2];m=j[f+40>>2];n=j[f+36>>2];b=j[f+32>>2]}j[a+56>>2]=o;j[a+52>>2]=m;j[a+48>>2]=n;j[a+44>>2]=b;j[a>>2]=l;j[a+4>>2]=k;Za=f+48|0}function Sh(a,b,c,d,e,f){var g=0,h=0,i=0,l=q(0),m=q(0),o=0,p=0,r=q(0),s=q(0),t=0;if(!(bb[j[j[a>>2]+132>>2]](a)|0)){g=k[j[a+20>>2]+25|0]}l=n[j[a+20>>2]+144>>2];m=q(1);if(!(bb[j[j[a>>2]+132>>2]](a)|0)){m=n[j[a+20>>2]+144>>2]}l=q(q(1)-l);a:{if((bb[j[j[a>>2]+148>>2]](a)|0)<1){break a}if(!yH(j[a+20>>2])){break a}l=q(q(l+l)+q(-1));m=q(-l)}r=n[a+4196>>2];m=q(r*m);l=q(r*l);o=a+44|0;p=wd(o,0);o=wd(o,1);b:{c:{switch(g|0){case 4:if(!f){break b}while(1){g=i<<2;h=g+b|0;t=h;m=q(n[g+p>>2]+n[h>>2]);h=c+g|0;n[t>>2]=q(m-q(n[g+o>>2]+q(m+n[h>>2])))+q(n[d+g>>2]*l);n[h>>2]=q(n[e+g>>2]*l)-m;i=i+1|0;if((i|0)!=(f|0)){continue}break}break b;case 3:if(!f){break b}while(1){g=i<<2;h=g+b|0;n[h>>2]=q(q(n[g+p>>2]*l)-n[d+g>>2])+n[h>>2];h=c+g|0;n[h>>2]=q(q(n[g+o>>2]*l)-n[e+g>>2])+n[h>>2];i=i+1|0;if((i|0)!=(f|0)){continue}break}break b;case 2:if(!f){break b}while(1){g=i<<2;h=g+b|0;n[h>>2]=q(n[h>>2]+n[d+g>>2])-q(n[g+p>>2]*m);h=c+g|0;n[h>>2]=q(n[h>>2]+n[e+g>>2])-q(n[g+o>>2]*m);i=i+1|0;if((i|0)!=(f|0)){continue}break}break b;case 1:if(!f){break b}while(1){g=i<<2;h=g+b|0;n[h>>2]=q(n[h>>2]+n[g+p>>2])-q(n[d+g>>2]*l);h=c+g|0;n[h>>2]=q(n[h>>2]+n[g+o>>2])-q(n[e+g>>2]*l);i=i+1|0;if((i|0)!=(f|0)){continue}break}break b;case 0:if(!f){break b}while(1){g=i<<2;h=g+b|0;n[h>>2]=q(q(n[g+p>>2]*m)+q(n[d+g>>2]*l))+n[h>>2];h=c+g|0;n[h>>2]=q(q(n[g+o>>2]*m)+q(n[e+g>>2]*l))+n[h>>2];i=i+1|0;if((i|0)!=(f|0)){continue}break}break b;case 5:break c;default:break b}}g=yH(j[a+20>>2]);if(!f){break b}l=g?q(l*q(.5)):l;m=g?q(m*q(.5)):m;while(1){g=i<<2;h=g+b|0;r=q(n[d+g>>2]-n[g+p>>2]);s=q(n[g+o>>2]-n[e+g>>2]);n[h>>2]=q(n[h>>2]+q(r*l))+q(s*m);g=c+g|0;n[g>>2]=q(q(s*l)+q(r*m))+n[g>>2];i=i+1|0;if((i|0)!=(f|0)){continue}break}}d:{if(!((k[j[a+20>>2]+24|0]&4)>>>2|0)){break d}if(bb[j[j[a>>2]+132>>2]](a)|!f){break d}e=0;while(1){a=e<<2;d=a+b|0;n[d>>2]=n[d>>2]+n[a+p>>2];d=a+c|0;n[d>>2]=n[d>>2]+n[a+o>>2];e=e+1|0;if((f|0)!=(e|0)){continue}break}}}function yea(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=q(0),f=q(0),g=0,h=0,i=0,k=0,l=q(0),m=0,o=0,p=0,r=0,s=q(0),t=0,u=0,v=0,w=q(0),x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=q(0),K=q(0),L=q(0),M=q(0),N=q(0),O=q(0);o=a+44|0;if(Xg(o)){B=wd(o,0);C=wd(o,1);D=Rc(o,0);E=Rc(o,1);t=j[a+4296>>2];r=j[a+4300>>2];if(d){k=a+4304|0;i=t+1|0;x=i+j[a+4272>>2]&4095;m=k+(x<<4)|0;y=i+j[a+4276>>2]&4095;g=((y<<4)+k|0)+4|0;z=i+j[a+4280>>2]&4095;p=((z<<4)+k|0)+8|0;A=i+j[a+4284>>2]&4095;h=((A<<4)+k|0)+12|0;u=j[a+4292>>2]+r|0;v=j[a+4288>>2]+r|0;G=a+69840|0;H=a+78032|0;F=d;while(1){x=x-1&4095;i=(x<<4)+k|0;e=n[i>>2];v=v&1023;I=(v<<3)+G|0;s=n[I+4>>2];J=n[h>>2];K=n[p>>2];L=n[g>>2];M=n[m>>2];N=n[C>>2];O=n[B>>2];w=n[a+4232>>2];y=y-1&4095;m=(y<<4)+k|0;l=n[m+4>>2];f=q(q(w*n[I>>2])+q(l*q(.6180340051651001)));h=r<<3;g=h+G|0;n[g+4>>2]=l-q(f*q(.6180340051651001));l=e;e=q(q(s*w)-q(e*q(.6180340051651001)));n[g>>2]=l+q(e*q(.6180340051651001));n[i>>2]=f;n[m+4>>2]=e;u=u&1023;g=(u<<3)+H|0;s=n[g+4>>2];z=z-1&4095;p=(z<<4)+k|0;f=n[p+8>>2];w=n[a+4236>>2];e=q(w*n[g>>2]);A=A-1&4095;g=(A<<4)+k|0;l=n[g+12>>2];e=q(e+q(l*q(.6180340051651001)));h=h+H|0;n[h+4>>2]=l-q(e*q(.6180340051651001));l=f;f=q(q(s*w)-q(f*q(.6180340051651001)));n[h>>2]=l+q(f*q(.6180340051651001));n[p+8>>2]=e;n[g+12>>2]=f;f=q(n[i>>2]+e);e=q(O+q(1.0000000031710769e-30));n[D>>2]=f+q(n[a+4224>>2]*e);f=q(N+q(1.0000000031710769e-30));n[E>>2]=q(q(n[a+4224>>2]*f)+n[m+4>>2])+n[g+12>>2];h=(t<<4)+k|0;s=n[a+4228>>2];e=q(s*e);n[h>>2]=q(q(n[a+4240>>2]*n[i>>2])+e)+q(M*n[a+4244>>2]);f=q(s*f);n[h+4>>2]=q(q(n[a+4248>>2]*n[m+4>>2])+f)+q(L*n[a+4252>>2]);n[h+8>>2]=q(q(n[a+4256>>2]*n[p+8>>2])-f)+q(K*n[a+4260>>2]);n[h+12>>2]=q(q(n[a+4264>>2]*n[g+12>>2])+e)+q(J*n[a+4268>>2]);h=g+12|0;p=p+8|0;g=m+4|0;E=E+4|0;D=D+4|0;C=C+4|0;B=B+4|0;u=u-1|0;v=v-1|0;r=r-1&1023;t=t-1&4095;m=i;F=F-1|0;if(F){continue}break}}j[a+4300>>2]=r;j[a+4296>>2]=t;Sh(a,b,c,Rc(o,0),Rc(o,1),d)}}function yla(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,k=0,l=0,m=0,n=0,q=0,r=0,s=0;c=Za-208|0;Za=c;f=1;e=j[a+12>>2];h=1<<e;if(e&1){i=h>>>1|0;if(i){e=0;while(1){k=e+i|0;f=$b(b,k);d=j[f+12>>2];j[c+200>>2]=j[f+8>>2];j[c+204>>2]=d;d=j[f+4>>2];j[c+192>>2]=j[f>>2];j[c+196>>2]=d;Xh(c+176|0,$b(b,e),c+192|0);f=$b(b,k);d=j[c+188>>2];j[f+8>>2]=j[c+184>>2];j[f+12>>2]=d;k=j[c+180>>2];j[f>>2]=j[c+176>>2];j[f+4>>2]=k;Iw($b(b,e),c+192|0);e=e+1|0;if((i|0)!=(e|0)){continue}break}e=j[a+12>>2]}f=2;h=h>>>3|0}else{h=h>>>2|0}k=e&-2;if(k){while(1){if(f){r=p(h,3);s=h<<1;i=0;while(1){e=$b(a,i<<1);d=j[e+12>>2];j[c+200>>2]=j[e+8>>2];j[c+204>>2]=d;d=j[e+4>>2];j[c+192>>2]=j[e>>2];j[c+196>>2]=d;e=$b(a,i);d=j[e+12>>2];j[c+184>>2]=j[e+8>>2];j[c+188>>2]=d;d=j[e+4>>2];j[c+176>>2]=j[e>>2];j[c+180>>2]=d;mh(c+160|0,c+176|0,c+192|0);e=i<<k;n=h+e|0;if(e>>>0<n>>>0){while(1){d=$b(b,e);g=j[d+12>>2];j[c+152>>2]=j[d+8>>2];j[c+156>>2]=g;g=j[d+4>>2];j[c+144>>2]=j[d>>2];j[c+148>>2]=g;g=e+h|0;mh(c+128|0,c+192|0,$b(b,g));l=e+s|0;mh(c+112|0,c+176|0,$b(b,l));q=e+r|0;mh(c+96|0,c+160|0,$b(b,q));Lj(c+80|0,c+144|0,c+112|0);Xh(c- -64|0,c+144|0,c+112|0);Lj(c+48|0,c+128|0,c+96|0);gl(c+16|0,-o[3858],-o[3859]);Xh(c,c+128|0,c+96|0);mh(c+32|0,c+16|0,c);Lj(c+16|0,c+80|0,c+48|0);d=$b(b,e);m=j[c+28>>2];j[d+8>>2]=j[c+24>>2];j[d+12>>2]=m;m=j[c+20>>2];j[d>>2]=j[c+16>>2];j[d+4>>2]=m;Xh(c+16|0,c+80|0,c+48|0);d=$b(b,g);m=j[c+28>>2];j[d+8>>2]=j[c+24>>2];j[d+12>>2]=m;g=j[c+20>>2];j[d>>2]=j[c+16>>2];j[d+4>>2]=g;Lj(c+16|0,c- -64|0,c+32|0);d=$b(b,l);l=j[c+28>>2];j[d+8>>2]=j[c+24>>2];j[d+12>>2]=l;g=j[c+20>>2];j[d>>2]=j[c+16>>2];j[d+4>>2]=g;Xh(c+16|0,c- -64|0,c+32|0);d=$b(b,q);l=j[c+28>>2];j[d+8>>2]=j[c+24>>2];j[d+12>>2]=l;g=j[c+20>>2];j[d>>2]=j[c+16>>2];j[d+4>>2]=g;e=e+1|0;if((n|0)!=(e|0)){continue}break}}i=i+1|0;if((f|0)!=(i|0)){continue}break}}h=h>>>2|0;f=f<<2;k=k-2|0;if(k){continue}break}}Za=c+208|0}function V8(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,i=0;e=Za-96|0;Za=e;a:{if(Ec(c)){break a}g=k[rG(c)|0];f=1;b:{if((g|0)==33){break b}if((g|0)!=63){break a}f=0}d=f;Tq(e+80|0,c,0,nb(c)-1|0);ob(c,e+80|0);gb(e+80|0)}ld(e+80|0);f=j[e+80>>2];ld(e+72|0);g=qG(f,j[e+76>>2],c);ld(e+80|0);c:{d:{e:{f:{g:{if(j[e+84>>2]==(g|0)){if(Dd(c,38235)){a=R(8)|0;j[114630]=0;b=E(85,e+80|0,39176)|0;c=j[114630];j[114630]=0;if((c|0)==1){break e}Wb(a,b);j[114630]=0;I(2004,a|0,83648,2012);a=j[114630];j[114630]=0;if((a|0)!=1){break c}c=D()|0;C()|0;gb(b);break d}if(!d){break g}a=R(8)|0;j[114630]=0;I(2130,e+80|0,39186,c|0);b=j[114630];j[114630]=0;if((b|0)!=1){Wb(a,e+80|0);j[114630]=0;I(2004,a|0,83648,2012);a=j[114630];j[114630]=0;if((a|0)!=1){break c}c=D()|0;C()|0;gb(e+80|0);break d}c=D()|0;C()|0;S(a|0);break d}f=Cb(e+80|0);h:{i:{j:{k:{switch(j[g+4>>2]){case 0:nh(e- -64|0,c);j[114630]=0;c=j[e+68>>2];j[e+8>>2]=j[e+64>>2];j[e+12>>2]=c;b=K(2072,b|0,e+8|0,d|0)|0;c=j[114630];j[114630]=0;if((c|0)!=1){j[114630]=0;h[e+72|0]=b;F(2135,a|0,e+72|0);a=j[114630];j[114630]=0;if((a|0)!=1){break h}}break j;case 1:nh(e+56|0,c);j[114630]=0;c=j[e+60>>2];j[e+16>>2]=j[e+56>>2];j[e+20>>2]=c;b=DB(b,e+16|0,d);c=ab;d=j[114630];j[114630]=0;if((d|0)!=1){j[114630]=0;j[e+72>>2]=b;j[e+76>>2]=c;F(2137,a|0,e+72|0);a=j[114630];j[114630]=0;if((a|0)!=1){break h}}break j;case 2:nh(e+48|0,c);j[114630]=0;c=j[e+52>>2];j[e+24>>2]=j[e+48>>2];j[e+28>>2]=c;i=+ca(2074,b|0,e+24|0,d|0);b=j[114630];j[114630]=0;if((b|0)!=1){j[114630]=0;o[e+72>>3]=i;F(2138,a|0,e+72|0);a=j[114630];j[114630]=0;if((a|0)!=1){break h}}break j;case 3:break k;default:break i}}nh(e+40|0,c);j[114630]=0;c=j[e+44>>2];j[e+32>>2]=j[e+40>>2];j[e+36>>2]=c;L(2075,a|0,b|0,e+32|0,d|0);a=j[114630];j[114630]=0;if((a|0)!=1){break h}}c=D()|0;C()|0;gb(f);break d}Mc(a,f)}gb(f);break f}Cb(a)}Za=e+96|0;return}c=D()|0;C()|0;S(a|0)}G(c|0)}z()}function Bua(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;g=Za-48|0;Za=g;y=j[a+16>>2];l=j[a+44>>2];j[g+32>>2]=l;o=j[a+48>>2];j[g+36>>2]=o;k=j[a+52>>2];j[g+40>>2]=k;h=j[a+56>>2];j[g+44>>2]=h;s=j[a+40>>2];t=j[a+36>>2];e=j[a+4>>2];m=j[a>>2];j[g+24>>2]=m;j[g+28>>2]=e;f=j[a+12>>2];j[g+16>>2]=j[a+8>>2];j[g+20>>2]=f;a:{if(!d){n=s>>12;f=t>>12;break a}while(1){o=1;e=((((e&2147483647)<<1|m>>>31)&2147483646)<<1)+y|0;f=(((m>>>16|0)+4&131064)<<1)+b|0;m=i[f+38>>1];h=i[f+36>>1];n=i[f+34>>1];q=i[f+32>>1];u=i[f+30>>1];v=i[f+28>>1];r=i[f+26>>1];w=i[f+24>>1];l=0;k=1;f=0;while(1){x=(g+8|0)+(f<<2)|0;f=f<<1;j[x>>2]=(((((p(i[e+(f|8)>>1],n)+p(i[e+(f|4)>>1],q)|0)+p(h,i[e+(f|12)>>1])|0)+p(m,i[e+(f|16)>>1])|0)/2|0)+((((p(i[e+(f|-8)>>1],r)+p(i[e+(f|-12)>>1],w)|0)+p(i[e+(f|-4)>>1],v)|0)+p(i[e+f>>1],u)|0)/2|0)|0)/16384;x=k&1;k=0;f=1;if(x){continue}break}while(1){k=(g+8|0)+(l<<2)|0;m=j[k>>2];h=j[a+60>>2];n=h;f=(g+32|0)+(l<<3)|0;q=j[f>>2];e=Gb(q,-16777216,16776704);u=j[a+64>>2];l=Gb(j[f+4>>2],-16777216,16776704);r=j[a+68>>2];w=r;r=r>>31;j[f+4>>2]=q;q=j[a+72>>2];v=h>>31;m=m<<8;h=m;h=HMa(n,v,h,h>>31);n=ab;v=k;k=h;h=HMa(u,u>>31,e,e>>31);k=k+h|0;e=ab+n|0;e=k>>>0<h>>>0?e+1|0:e;h=k;k=HMa(w,r,l,l>>31);l=h+k|0;e=ab+e|0;e=l>>>0<k>>>0?e+1|0:e;l=l+8388608|0;if(l>>>0<8388608){e=e+1|0}e=(e&16777215)<<8|l>>>24;j[v>>2]=(e|0)/256;j[f>>2]=e-(m&q);l=1;e=o&1;o=0;if(e){continue}break}e=j[a+32>>2];t=j[a+28>>2]+t|0;f=t>>12;j[c>>2]=j[c>>2]+p(f,j[g+8>>2]);s=e+s|0;n=s>>12;j[c+4>>2]=j[c+4>>2]+p(n,j[g+12>>2]);Bb(g+24|0,g+16|0);d=d-1|0;if(d){c=c+8|0;m=j[g+24>>2];e=j[g+28>>2];continue}break}m=j[g+24>>2];e=j[g+28>>2];h=j[g+44>>2];k=j[g+40>>2];o=j[g+36>>2];l=j[g+32>>2]}j[a+40>>2]=s;j[a+20>>2]=f;j[a+36>>2]=t;j[a+56>>2]=h;j[a+52>>2]=k;j[a+48>>2]=o;j[a+44>>2]=l;j[a+24>>2]=n;j[a>>2]=m;j[a+4>>2]=e;Za=g+48|0}function Cua(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;g=Za-48|0;Za=g;y=j[a+16>>2];m=j[a+44>>2];j[g+32>>2]=m;q=j[a+48>>2];j[g+36>>2]=q;l=j[a+52>>2];j[g+40>>2]=l;k=j[a+56>>2];j[g+44>>2]=k;t=j[a+40>>2];u=j[a+36>>2];e=j[a+4>>2];n=j[a>>2];j[g+24>>2]=n;j[g+28>>2]=e;f=j[a+12>>2];j[g+16>>2]=j[a+8>>2];j[g+20>>2]=f;a:{if(!d){f=t>>12;o=u>>12;break a}while(1){e=(((e&2147483647)<<1|n>>>31)&-2)+y|0;q=1;f=(((n>>>16|0)+4&131064)<<1)+b|0;n=i[f+38>>1];k=i[f+36>>1];o=i[f+34>>1];r=i[f+32>>1];v=i[f+30>>1];w=i[f+28>>1];s=i[f+26>>1];x=i[f+24>>1];m=0;l=1;f=0;while(1){j[(g+8|0)+(f<<2)>>2]=(((((p(h[e+(f|4)|0],o)+p(h[e+(f|2)|0],r)|0)+p(k,h[e+(f|6)|0])|0)+p(n,h[e+(f|8)|0])<<8)/2|0)+((((p(h[e+(f|-4)|0],s)+p(h[e+(f|-6)|0],x)|0)+p(h[e+(f|-2)|0],w)|0)+p(h[e+f|0],v)<<8)/2|0)|0)/16384;z=l&1;l=0;f=1;if(z){continue}break}while(1){l=(g+8|0)+(m<<2)|0;n=j[l>>2];k=j[a+60>>2];o=k;f=(g+32|0)+(m<<3)|0;r=j[f>>2];e=Gb(r,-16777216,16776704);v=j[a+64>>2];m=Gb(j[f+4>>2],-16777216,16776704);s=j[a+68>>2];x=s;s=s>>31;j[f+4>>2]=r;r=j[a+72>>2];w=k>>31;n=n<<8;k=n;k=HMa(o,w,k,k>>31);o=ab;w=l;l=k;k=HMa(v,v>>31,e,e>>31);l=l+k|0;e=ab+o|0;e=l>>>0<k>>>0?e+1|0:e;k=l;l=HMa(x,s,m,m>>31);m=k+l|0;e=ab+e|0;e=m>>>0<l>>>0?e+1|0:e;m=m+8388608|0;if(m>>>0<8388608){e=e+1|0}e=(e&16777215)<<8|m>>>24;j[w>>2]=(e|0)/256;j[f>>2]=e-(n&r);m=1;e=q&1;q=0;if(e){continue}break}e=j[a+32>>2];u=j[a+28>>2]+u|0;o=u>>12;j[c>>2]=j[c>>2]+p(o,j[g+8>>2]);t=e+t|0;f=t>>12;j[c+4>>2]=j[c+4>>2]+p(f,j[g+12>>2]);Bb(g+24|0,g+16|0);d=d-1|0;if(d){c=c+8|0;n=j[g+24>>2];e=j[g+28>>2];continue}break}n=j[g+24>>2];e=j[g+28>>2];k=j[g+44>>2];l=j[g+40>>2];q=j[g+36>>2];m=j[g+32>>2]}j[a+40>>2]=t;j[a+20>>2]=o;j[a+36>>2]=u;j[a+56>>2]=k;j[a+52>>2]=l;j[a+48>>2]=q;j[a+44>>2]=m;j[a+24>>2]=f;j[a>>2]=n;j[a+4>>2]=e;Za=g+48|0}function iGa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=q(0);c=Za+ -64|0;Za=c;LFa(a,b+16|0);qQ(b+48|0);h[b+143|0]=0;j[b+152>>2]=-2147483648;j[b+156>>2]=-2147483648;d=hf(a);cd(c+48|0,a,d);j[114630]=0;e=H(337,c+48|0)|0;f=j[114630];j[114630]=0;a:{b:{c:{if((f|0)==1){break c}if(!e){break b}j[114630]=0;e=b+4|0;F(507,e|0,d|0);f=j[114630];j[114630]=0;if((f|0)==1){break c}e=j[e>>2];j[114630]=0;K(698,c+48|0,e|0,d|0)|0;d=j[114630];j[114630]=0;if((d|0)!=1){break b}}a=D()|0;C()|0;break a}j[114630]=0;d=H(390,a|0)|0;e=j[114630];j[114630]=0;d:{if((e|0)==1){break d}j[114630]=0;I(341,c+32|0,a|0,d|0);a=j[114630];j[114630]=0;if((a|0)==1){break d}j[114630]=0;a=H(337,c+32|0)|0;d=j[114630];j[114630]=0;e:{if((d|0)!=1){f:{g:{h:{if(!a){break h}while(1){j[114630]=0;a=E(258,c+32|0,5)|0;d=j[114630];j[114630]=0;if((d|0)==1){break g}if(!a){break h}j[114630]=0;E(699,c+32|0,c+28|0)|0;a=j[114630];j[114630]=0;i:{if((a|0)!=1){a=4;if((k[c+28|0]|k[c+29|0]<<8|(k[c+30|0]<<16|k[c+31|0]<<24))==1414682436|(k[c+28|0]|k[c+29|0]<<8|(k[c+30|0]<<16|k[c+31|0]<<24))==1196380752){break i}j[114630]=0;a=H(390,c+32|0)|0;d=j[114630];j[114630]=0;if((d|0)!=1){break i}a=D()|0;C()|0;break e}a=D()|0;C()|0;break e}j[114630]=0;I(341,c+8|0,c+32|0,a|0);a=j[114630];j[114630]=0;j:{k:{if((a|0)!=1){if((k[c+28|0]|k[c+29|0]<<8|(k[c+30|0]<<16|k[c+31|0]<<24))!=1414682436){break k}j[114630]=0;g=q(oa(700,c+8|0));a=j[114630];j[114630]=0;if((a|0)==1){break f}n[b+144>>2]=g;break j}a=D()|0;C()|0;break e}if((k[c+28|0]|k[c+29|0]<<8|(k[c+30|0]<<16|k[c+31|0]<<24))!=1196380752){break j}j[114630]=0;a=H(390,c+8|0)|0;d=j[114630];j[114630]=0;if((d|0)==1){break f}j[b+148>>2]=a}jb(c+8|0);continue}}jb(c+32|0);jb(c+48|0);Za=c- -64|0;return}a=D()|0;C()|0;break e}a=D()|0;C()|0;jb(c+8|0);break e}a=D()|0;C()|0}jb(c+32|0);break a}a=D()|0;C()|0}jb(c+48|0);G(a|0);z()}function Xfa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=q(0),f=0,g=q(0),h=0,i=q(0),k=0,l=0,m=q(0),o=q(0),p=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=q(0),A=0,B=0,C=q(0),D=0,E=0,F=q(0);a:{if(!j[a+4276>>2]){break a}k=a+44|0;if(!Xg(k)){break a}s=wd(k,0);t=wd(k,1);u=Rc(k,0);v=Rc(k,1);B=bb[j[j[a>>2]+188>>2]](a)|0;e=q(bb[j[j[a>>2]+196>>2]](a));z=q(bb[j[j[a>>2]+184>>2]](a));w=bb[j[j[a>>2]+208>>2]](a)|0;if(d){C=q(e*q(.009999999776482582));D=w&1;l=a+4260|0;p=j[a+4256>>2];f=j[a+4272>>2];x=d;while(1){i=n[s>>2];m=n[t>>2];h=vm(a,f+p|0);f=vm(a,f);e=n[xb(l,h)>>2];E=xb(l,f),F=q(q(C*e)+q(q(m+i)*q(.5))),n[E>>2]=F;b:{if(B){g=n[a+4244>>2];e=q(n[a+4236>>2]+g);n[a+4236>>2]=e;g=q(g+n[a+4240>>2]);n[a+4240>>2]=g;if(!(e<=q(1))){e=q(e+q(-2));n[a+4236>>2]=e}if(!(g<=q(1))){n[a+4240>>2]=g+q(-2)}e=q(r(e));e=q(q(e+e)+q(-1));g=q(r(n[a+4240>>2]));g=q(q(g+g)+q(-1));break b}g=n[a+4244>>2];o=n[a+4240>>2];e=q(q(g*o)+n[a+4236>>2]);n[a+4236>>2]=e;g=q(o-q(e*g));n[a+4240>>2]=g}o=n[xb(l,vm(a,j[a+4280>>2]+j[a+4272>>2]|0))>>2];E=u,F=q(q(q(q(o-i)+q(q(q(n[xb(l,vm(a,j[a+4284>>2]+j[a+4272>>2]|0))>>2]-o)*q(.000244140625))*q(j[a+4280>>2]&4095)))*z)+i),n[E>>2]=F;i=n[xb(l,vm(a,j[a+4288>>2]+j[a+4272>>2]|0))>>2];E=v,F=q(q(q(q(i-m)+q(q(q(n[xb(l,vm(a,j[a+4292>>2]+j[a+4272>>2]|0))>>2]-i)*q(.000244140625))*q(j[a+4288>>2]&4095)))*z)+m),n[E>>2]=F;y=a;p=j[a+4256>>2];f=p;i=n[a+4248>>2];m=q(i*(D?g:e));c:{if(q(r(m))<q(2147483648)){h=~~m;break c}h=-2147483648}A=f+(w>>>0>1?h:0-h|0)|0;j[y+4288>>2]=A;f=w>>>0<4;y=a;e=q(i*e);d:{if(q(r(e))<q(2147483648)){h=~~e;break d}h=-2147483648}f=(f?h:0-h|0)+p|0;j[y+4280>>2]=f;j[a+4292>>2]=A+4096;j[a+4284>>2]=f+4096;t=t+4|0;s=s+4|0;v=v+4|0;u=u+4|0;h=a;f=j[a+4272>>2];if((f|0)<=0){f=f+(j[a+4276>>2]<<12)|0}f=f-4096|0;j[h+4272>>2]=f;x=x-1|0;if(x){continue}break}}Sh(a,b,c,Rc(k,0),Rc(k,1),d)}}function S0(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var i=0,k=0,l=0,m=0;i=Za-432|0;Za=i;j[i+424>>2]=37;j[i+428>>2]=0;k=vq(i+424|1,64458,j[c+4>>2]);j[i+380>>2]=i+384;a=Wd();a:{if(k){l=j[c+8>>2];j[i+72>>2]=g;j[i+76>>2]=h;m=i- -64|0;j[m>>2]=e;j[m+4>>2]=f;j[i+48>>2]=l;a=Je(i+384|0,30,a,i+424|0,i+48|0);break a}j[i+80>>2]=e;j[i+84>>2]=f;j[i+88>>2]=g;j[i+92>>2]=h;a=Je(i+384|0,30,a,i+424|0,i+80|0)}j[i+128>>2]=2421;l=yd(i+368|0,0,i+128|0);b:{c:{d:{if((a|0)>=30){e:{if(k){j[114630]=0;a=T(2446)|0;k=j[114630];j[114630]=0;if((k|0)==1){break c}k=j[c+8>>2];j[i+16>>2]=e;j[i+20>>2]=f;j[i+24>>2]=g;j[i+28>>2]=h;j[i>>2]=k;j[114630]=0;a=P(2468,i+380|0,a|0,i+424|0,i|0)|0;e=j[114630];j[114630]=0;if((e|0)!=1){break e}break c}j[114630]=0;a=T(2446)|0;k=j[114630];j[114630]=0;if((k|0)==1){break c}j[i+32>>2]=e;j[i+36>>2]=f;j[114630]=0;j[i+40>>2]=g;j[i+44>>2]=h;a=P(2468,i+380|0,a|0,i+424|0,i+32|0)|0;e=j[114630];j[114630]=0;if((e|0)==1){break c}}e=j[i+380>>2];if(!e){j[114630]=0;M(2422);a=j[114630];j[114630]=0;if((a|0)==1){break c}break d}fe(l,e)}e=j[i+380>>2];g=e+a|0;h=Sf(e,g,c);j[i+116>>2]=2421;f=yd(i+120|0,0,i+116|0);f:{g:{if(j[i+380>>2]==(i+384|0)){a=i+128|0;e=i+384|0;break g}a=Yc(a<<3);if(!a){j[114630]=0;M(2422);a=j[114630];j[114630]=0;if((a|0)!=1){break d}c=D()|0;C()|0;break f}fe(f,a);e=j[i+380>>2]}j[114630]=0;hc(i+104|0,c);k=j[114630];j[114630]=0;h:{i:{if((k|0)!=1){j[114630]=0;Z(2479,e|0,h|0,g|0,a|0,i+116|0,i+112|0,i+104|0);e=j[114630];j[114630]=0;if((e|0)==1){break i}wb(i+104|0);j[114630]=0;a=_(2480,b|0,a|0,j[i+116>>2],j[i+112>>2],c|0,d|0)|0;b=j[114630];j[114630]=0;if((b|0)==1){break h}mc(f);mc(l);Za=i+432|0;return a|0}c=D()|0;C()|0;break f}c=D()|0;C()|0;wb(i+104|0);break f}c=D()|0;C()|0}mc(f);break b}z()}c=D()|0;C()|0}mc(l);G(c|0);z()}function a1(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var i=0,k=0,l=0,m=0;i=Za-256|0;Za=i;j[i+248>>2]=37;j[i+252>>2]=0;k=vq(i+248|1,64458,j[c+4>>2]);j[i+204>>2]=i+208;a=Wd();a:{if(k){l=j[c+8>>2];j[i+72>>2]=g;j[i+76>>2]=h;m=i- -64|0;j[m>>2]=e;j[m+4>>2]=f;j[i+48>>2]=l;a=Je(i+208|0,30,a,i+248|0,i+48|0);break a}j[i+80>>2]=e;j[i+84>>2]=f;j[i+88>>2]=g;j[i+92>>2]=h;a=Je(i+208|0,30,a,i+248|0,i+80|0)}j[i+128>>2]=2421;l=yd(i+192|0,0,i+128|0);b:{c:{d:{if((a|0)>=30){e:{if(k){j[114630]=0;a=T(2446)|0;k=j[114630];j[114630]=0;if((k|0)==1){break c}k=j[c+8>>2];j[i+16>>2]=e;j[i+20>>2]=f;j[i+24>>2]=g;j[i+28>>2]=h;j[i>>2]=k;j[114630]=0;a=P(2468,i+204|0,a|0,i+248|0,i|0)|0;e=j[114630];j[114630]=0;if((e|0)!=1){break e}break c}j[114630]=0;a=T(2446)|0;k=j[114630];j[114630]=0;if((k|0)==1){break c}j[i+32>>2]=e;j[i+36>>2]=f;j[114630]=0;j[i+40>>2]=g;j[i+44>>2]=h;a=P(2468,i+204|0,a|0,i+248|0,i+32|0)|0;e=j[114630];j[114630]=0;if((e|0)==1){break c}}e=j[i+204>>2];if(!e){j[114630]=0;M(2422);a=j[114630];j[114630]=0;if((a|0)==1){break c}break d}fe(l,e)}e=j[i+204>>2];g=e+a|0;h=Sf(e,g,c);j[i+116>>2]=2421;f=yd(i+120|0,0,i+116|0);f:{g:{if(j[i+204>>2]==(i+208|0)){a=i+128|0;e=i+208|0;break g}a=Yc(a<<1);if(!a){j[114630]=0;M(2422);a=j[114630];j[114630]=0;if((a|0)!=1){break d}c=D()|0;C()|0;break f}fe(f,a);e=j[i+204>>2]}j[114630]=0;hc(i+104|0,c);k=j[114630];j[114630]=0;h:{i:{if((k|0)!=1){j[114630]=0;Z(2469,e|0,h|0,g|0,a|0,i+116|0,i+112|0,i+104|0);e=j[114630];j[114630]=0;if((e|0)==1){break i}wb(i+104|0);j[114630]=0;a=_(17,b|0,a|0,j[i+116>>2],j[i+112>>2],c|0,d|0)|0;b=j[114630];j[114630]=0;if((b|0)==1){break h}mc(f);mc(l);Za=i+256|0;return a|0}c=D()|0;C()|0;break f}c=D()|0;C()|0;wb(i+104|0);break f}c=D()|0;C()|0}mc(f);break b}z()}c=D()|0;C()|0}mc(l);G(c|0);z()}function Bka(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,l=0,m=0,n=0,o=0;e=Za-1136|0;Za=e;rc(b);d=e+1112|0;h=mka(b,d);if(!h){PI(d)}a:{if(!h){break a}if(!TI(e+1112|0)){break a}d=e+1120|0;if((k[d|0]|k[d+1|0]<<8|(k[d+2|0]<<16|k[d+3|0]<<24))!=(jj(b)|0)){break a}d=e+1128|0;if((k[d|0]|k[d+1|0]<<8|(k[d+2|0]<<16|k[d+3|0]<<24))!=(ef(b)|0)){break a}if(!c){f=1;break a}Ab(e+1056|0,0,56);if(n6(e+1056|0)){break a}d=k[d|0]|k[d+1|0]<<8|(k[d+2|0]<<16|k[d+3|0]<<24);j[e+1052>>2]=d;f=e+1132|0;f=k[f|0]|k[f+1|0]<<8|(k[f+2|0]<<16|k[f+3|0]<<24);i=(f|0)!=0;h=bz(e+1040|0,f);b:{c:{d:{e:{if(!f){g=1;break e}g=1;if(!d){break e}while(1){j[114630]=0;j[e+12>>2]=1024;d=E(464,e+12|0,e+1052|0)|0;g=j[114630];j[114630]=0;if((g|0)==1){break d}d=j[d>>2];j[114630]=0;K(261,b|0,e+16|0,d|0)|0;g=j[114630];j[114630]=0;if((g|0)==1){break c}j[114630]=0;l=K(1551,l|0,e+16|0,d|0)|0;g=j[114630];j[114630]=0;if((g|0)==1){break c}j[e+1072>>2]=f;j[e+1060>>2]=d;j[e+1056>>2]=e+16;g=j[h>>2];j[114630]=0;j[e+1068>>2]=g+m;n=E(1552,e+1056|0,0)|0;g=j[114630];j[114630]=0;if((g|0)==1){break c}o=j[e+1052>>2]-d|0;j[e+1052>>2]=o;g=(n|0)!=1;d=j[e+1072>>2];i=(d|0)!=0;if(!d|(n|0)==1){break e}m=(f+m|0)-d|0;f=d;if(o){continue}break}}j[114630]=0;H(1553,e+1056|0)|0;b=j[114630];j[114630]=0;f:{g:{if((b|0)!=1){f=0;b=e+1124|0;if(!((k[b|0]|k[b+1|0]<<8|(k[b+2|0]<<16|k[b+3|0]<<24))!=(l|0)|i|g)){j[114630]=0;F(831,e|0,h|0);b=j[114630];j[114630]=0;if((b|0)==1){break g}j[114630]=0;b=K(832,e+16|0,e|0,0)|0;f=j[114630];j[114630]=0;if((f|0)==1){break g}j[114630]=0;f=K(1491,a|0,b|0,c|0)|0;a=j[114630];j[114630]=0;if((a|0)==1){break f}jb(b)}Od(h);break a}a=D()|0;C()|0;break b}a=D()|0;C()|0;break b}a=D()|0;C()|0;jb(b);break b}a=D()|0;C()|0;break b}a=D()|0;C()|0}Od(h);G(a|0);z()}Za=e+1136|0;return f|0}function j9(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0;e=Za-32|0;Za=e;g=Ng(a);a=b+24|0;f=Eb(j[a>>2]+484360|0);j[114630]=0;i=H(2187,f|0)|0;f=j[114630];j[114630]=0;a:{b:{c:{if((f|0)==1){break c}j[114630]=0;F(1527,g|0,i|0);f=j[114630];j[114630]=0;if((f|0)==1){break c}d:{e:{if(i){f=0;while(1){c=l[bc(Eb(j[a>>2]+484360|0),f)>>1];d=j[a>>2];j[114630]=0;d=E(913,d+484344|0,c|0)|0;h=j[114630];j[114630]=0;if((h|0)==1){break b}f:{if(d){c=Hb(j[a>>2]+484344|0,l[bc(Eb(j[a>>2]+484360|0),f)>>1]);j[114630]=0;F(2185,e|0,c|0);c=j[114630];j[114630]=0;g:{h:{i:{if((c|0)!=1){j[114630]=0;I(2179,e+16|0,b|0,e|0);c=j[114630];j[114630]=0;if((c|0)==1){break i}j[114630]=0;F(1529,g|0,e+16|0);c=j[114630];j[114630]=0;if((c|0)==1){break h}gb(e+16|0);gb(e);break f}a=D()|0;C()|0;break a}a=D()|0;C()|0;break g}a=D()|0;C()|0;gb(e+16|0)}gb(e);break a}j[114630]=0;d=T(959)|0;h=j[114630];j[114630]=0;if((h|0)==1){break b}if((c|0)==(d|0)){j[114630]=0;c=E(85,e+16|0,38854)|0;d=j[114630];j[114630]=0;j:{if((d|0)!=1){j[114630]=0;F(1529,g|0,c|0);d=j[114630];j[114630]=0;if((d|0)==1){break j}gb(c);break f}a=D()|0;C()|0;break a}a=D()|0;C()|0;gb(c);break a}j[114630]=0;d=T(958)|0;h=j[114630];j[114630]=0;if((h|0)==1){break b}if((c|0)==(d|0)){j[114630]=0;c=E(85,e+16|0,38863)|0;d=j[114630];j[114630]=0;k:{if((d|0)!=1){j[114630]=0;F(1529,g|0,c|0);d=j[114630];j[114630]=0;if((d|0)==1){break k}gb(c);break f}a=D()|0;C()|0;break a}a=D()|0;C()|0;gb(c);break a}j[114630]=0;c=E(85,e+16|0,38872)|0;d=j[114630];j[114630]=0;if((d|0)==1){break e}j[114630]=0;F(1529,g|0,c|0);d=j[114630];j[114630]=0;if((d|0)==1){break d}gb(c)}f=f+1|0;if((i|0)!=(f|0)){continue}break}}Za=e+32|0;return}a=D()|0;C()|0;break a}a=D()|0;C()|0;gb(c);break a}a=D()|0;C()|0;break a}a=D()|0;C()|0}Vc(g);G(a|0);z()}function Rwa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,i=0,l=0,m=0,n=0,o=0;e=Za-32|0;Za=e;m=c+484344|0;Jf(m,k[b+70|0]|k[b+71|0]<<8);a:{if(k[b+70|0]|k[b+71|0]<<8){while(1){f=j[a+8>>2];g=hf(a);Jb(a,1);b:{if((k[b+58|0]|k[b+59|0]<<8)==258){c=dd(a)+1|0;break b}c=Of(a)}d=Of(a);xc(a,f+g|0);cd(e+16|0,a,d);j[114630]=0;c=K(402,m|0,l&65535,(c?c>>>0<1024?c:1024:64)|0)|0;f=j[114630];j[114630]=0;if((f|0)==1){break a}c:{if(!(c&(d|0)!=0)){break c}c=Hb(m,l);n=e,o=Lb(c),j[n+8>>2]=o;n=e,o=Mb(c),j[n>>2]=o;if(!rb(e+8|0,e)){break c}while(1){d=j[e+8>>2];j[114630]=0;c=H(387,e+16|0)|0;f=j[114630];j[114630]=0;d:{e:{f:{if((f|0)!=1){if(!(c&128)){break f}if(c&1){j[114630]=0;f=H(387,e+16|0)|0;g=j[114630];j[114630]=0;if((g|0)==1){break a}h[d|0]=f}if(c&2){break e}break d}break a}h[d|0]=c;c=255}j[114630]=0;f=H(387,e+16|0)|0;g=j[114630];j[114630]=0;if((g|0)==1){break a}h[d+1|0]=f}f=0;if(c&4){j[114630]=0;f=H(387,e+16|0)|0;g=j[114630];j[114630]=0;if((g|0)==1){break a}}if(c&8){j[114630]=0;g=H(387,e+16|0)|0;i=j[114630];j[114630]=0;if((i|0)==1){break a}h[d+3|0]=g}if(c&16){j[114630]=0;c=H(387,e+16|0)|0;g=j[114630];j[114630]=0;if((g|0)==1){break a}h[d+5|0]=c}c=d;g:{h:{g=k[d|0];if(!g){break h}i=255;if((g|0)==97){break g}if(g>>>0>96){break h}i=g+12|0;break g}i=0}h[c|0]=i;i:{if(k[d+5|0]|k[d+3|0]){j[114630]=0;N(574,d|0);c=j[114630];j[114630]=0;if((c|0)!=1){break i}break a}h[d+3|0]=0}if(k[d+1|0]==255){h[d+1|0]=0}c=f-16|0;j:{if((c&255)>>>0<=64){h[d+4|0]=c;h[d+2|0]=1;break j}if(f>>>0<96){break j}c=f&15;h[d+4|0]=c;f=f-96>>4;h[d+2|0]=k[f+17983|0];if((f|0)!=6){break j}h[d+4|0]=c<<2}lk(e+8|0);if(rb(e+8|0,e)){continue}break}}jb(e+16|0);l=l+1|0;if(l>>>0<(k[b+70|0]|k[b+71|0]<<8)>>>0){continue}break}}Za=e+32|0;return}a=D()|0;C()|0;jb(e+16|0);G(a|0);z()}function m6(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,k=0,l=0;e=Za-16|0;Za=e;d=-2;a:{if(!a){break a}c=j[a+28>>2];if(!c){break a}b=(b|0)==1?2:b;if(b>>>0>4|!(1<<b&21)){break a}f=j[c+11e3>>2];k=j[a+4>>2];j[c+11e3>>2]=0;b:{if(j[c+43780>>2]<0){break b}h=(b|0)==4;g=j[c+11004>>2];if(g?!h:0){break a}d=j[c+11008>>2]>0?9:8;j[c+11004>>2]=h|g;if(!(!f|(b|0)!=4)){j[e+12>>2]=j[a+4>>2];j[e+8>>2]=j[a+16>>2];b=j[a+12>>2];b=dF(c,j[a>>2],e+12|0,b,b,e+8|0,d|4);j[c+43780>>2]=b;d=j[e+12>>2];j[a>>2]=d+j[a>>2];j[a+4>>2]=j[a+4>>2]-d;j[a+8>>2]=d+j[a+8>>2];j[a+48>>2]=j[c+28>>2];d=j[e+8>>2];j[a+12>>2]=d+j[a+12>>2];j[a+16>>2]=j[a+16>>2]-d;j[a+20>>2]=d+j[a+20>>2];d=-3;if((b|0)<0){break a}if(!b){d=1;break a}j[c+43780>>2]=-1;d=-5;break a}f=j[c+10996>>2];if(!f){i=(b|0)!=4;l=i?d|2:d;h=c+11012|0;b=j[c+10992>>2];while(1){d=j[a+4>>2];j[e+8>>2]=32768-b;j[e+12>>2]=d;f=dF(c,j[a>>2],e+12|0,h,b+h|0,e+8|0,l);j[c+43780>>2]=f;b=j[e+12>>2];j[a>>2]=b+j[a>>2];j[a+4>>2]=j[a+4>>2]-b;j[a+8>>2]=b+j[a+8>>2];j[a+48>>2]=j[c+28>>2];b=j[e+8>>2];j[c+10996>>2]=b;d=j[a+16>>2];b=b>>>0<d>>>0?b:d;Vb(j[a+12>>2],h+j[c+10992>>2]|0,b);j[a+12>>2]=b+j[a+12>>2];j[a+16>>2]=j[a+16>>2]-b;j[a+20>>2]=b+j[a+20>>2];g=j[c+10996>>2]-b|0;j[c+10996>>2]=g;b=b+j[c+10992>>2]&32767;j[c+10992>>2]=b;if((f|0)<0){break b}d=-5;if((f|0)==1?!k:0){break a}if(!i){if(!f){d=g?-5:1;break a}if(j[a+16>>2]){continue}break a}if(f){d=0;if(g|!j[a+4>>2]){break a}if(j[a+16>>2]){continue}break a}break}d=!g;break a}b=j[a+16>>2];b=b>>>0>f>>>0?f:b;Vb(j[a+12>>2],(j[c+10992>>2]+c|0)+11012|0,b);j[a+12>>2]=b+j[a+12>>2];j[a+16>>2]=j[a+16>>2]-b;j[a+20>>2]=b+j[a+20>>2];a=j[c+10996>>2]-b|0;j[c+10996>>2]=a;j[c+10992>>2]=b+j[c+10992>>2]&32767;d=0;if(j[c+43780>>2]){break a}d=!a;break a}d=-3}Za=e+16|0;return d|0}function jma(a,b,c){var d=0,e=0,f=0,g=0,i=0;i=Za-16|0;Za=i;d=a+1074308|0;mb(i+8|0,d,71);a:{if(kb(i+8|0)){e=(p(b,896)+a|0)+1075843|0;d=h[e|0];if((d|0)>-1){break a}if(!(k[a+480209|0]&16|k[(p(b,896)+a|0)+1075811|0]!=18)){f=d&-33;h[e|0]=f;b:{c:{if((f|0)!=-64){d=d&223;if((d|0)!=128){break c}d=k[(p(b,896)+a|0)+1075844|0]>>>4|-64;break b}d=k[(p(b,896)+a|0)+1075844|0]&15|-128;break b}d=d-1|0}h[e|0]=d;e=(p(b,896)+a|0)+1075072|0;j[e>>2]=j[e>>2]|2097152}if((d&224)!=128){break a}j[c>>2]=0;break a}if(k[(p(b,896)+a|0)+1075811|0]!=18){break a}mb(i+8|0,d,22);d:{if(kb(i+8|0)){g=p(b,896)+a|0;e=g+1075843|0;f=k[e|0];d=f<<24>>24;if(!((d|0)>-1|!j[g+1075060>>2])){e:{f:{if((f|0)!=192){if((f|0)!=128){break f}d=k[(p(b,896)+a|0)+1075844|0]>>>4|-64;break e}d=k[(p(b,896)+a|0)+1075844|0]&15|-128;break e}d=d-1|0}h[e|0]=d}if((d&192)!=128){break d}j[c>>2]=0;break d}d=k[(p(b,896)+a|0)+1075844|0];e=d>>>4|0;f=e+(d&15)|0;if(!(k[a+480208|0]&4?0:j[a+480180>>2]&16777248)){f=f+2|0;e=e+1|0}g=(p(b,896)+a|0)+1075843|0;d=k[g|0];if(!(j[a+480180>>2]&4)){d=(d&255)>>>0<f>>>0?d:0;if((d&255)>>>0>=e>>>0){j[c>>2]=0}h[g|0]=d+1;break d}g:{if(k[a+480209|0]&16){d=d&255?d-1|0:0;break g}h[g|0]=d+1}if(((d&255)>>>0)%(f>>>0)>>>0<e>>>0){break d}j[c>>2]=0}d=(p(b,896)+a|0)+1075072|0;j[d>>2]=j[d>>2]|2097152}d=p(b,896)+a|0;h:{if(k[d+1075811|0]!=18){break h}f=d+1075640|0;d=j[f>>2];if(!d|!k[d+34|0]|k[d+15|0]&2){break h}d=p(b,896)+a|0;if(j[d+1075072>>2]&134218752){break h}e=d+1075805|0;if(!Ld(k[e|0])){break h}f=j[f>>2];d=j[(p(k[f+34|0],160)+a|0)+906140>>2];if(!d){break h}g=bb[j[j[d>>2]+96>>2]](d,k[e|0],b)|0;c=j[c>>2];if(!(!g|c)){bb[j[j[d>>2]+88>>2]](d,f,k[e|0]+255|0,0,b);break h}if(g|!c){break h}bb[j[j[d>>2]+88>>2]](d,f,k[e|0],l[(p(b,896)+a|0)+1075672>>1],b)}Za=i+16|0}function sf(a,b,c,d,e){var f=0,g=0,h=0,m=0,n=0;h=j[a+8>>2]+(p(l[a+14>>1],(k[a+80|0]?c:0)+b|0)>>>1|0)|0;j[a+8>>2]=h;g=k[a+79|0]?l[j[a>>2]+3836>>1]:g;b=l[a+20>>1];m=l[a+22>>1];n=l[a+70>>1];a:{b:{c:{switch(j[a+16>>2]){case 0:c=l[j[a>>2]+3832>>1];c=b+(c&l[a+34>>1]?0:l[a+24>>1]?p((b^-1)<<16>>16,l[a+36>>1]>>>l[j[a+40>>2]+((c>>>l[a+32>>1]&7)<<1)>>1]|0)>>>3|0:0)|0;i[a+20>>1]=c;if(c<<16>>16>0){break b}j[a+16>>2]=1;i[a+20>>1]=0;break b;case 1:c=l[j[a>>2]+3832>>1];c=b+(c&l[a+46>>1]?0:l[a+26>>1]?l[a+48>>1]>>>l[j[a+52>>2]+((c>>>l[a+44>>1]&7)<<1)>>1]|0:0)|0;i[a+20>>1]=c;f=c<<16>>16;c=l[a+28>>1];if((f|0)<(c|0)){break b}j[a+16>>2]=2;i[a+20>>1]=c;break b;case 2:if(k[a+78|0]){break b};case 3:c=0;f=l[j[a>>2]+3832>>1];f=b+(f&l[a+58>>1]?0:l[a+30>>1]?l[a+60>>1]>>>l[j[a+64>>2]+((f>>>l[a+56>>1]&7)<<1)>>1]|0:0)|0;i[a+20>>1]=f;if(f<<16>>16<511){break b}j[a+16>>2]=-1;i[a+20>>1]=511;j[a+72>>2]=0;break a;default:break c}}c=0;j[a+72>>2]=0;break a}g=((b+m|0)+n|0)+g<<3;if(e){d=(i[a+74>>1]+i[a+72>>1]>>e)+d|0}d=(h>>>10|0)+d|0;c=d&255;b=d&65535;d:{e:{switch(l[a+12>>1]){case 0:d=(b&512)>>>9|0;b=l[((b&256?c^255:c)<<1)+19296>>1];break d;case 1:d=0;b=l[((b&512?0:b&256?c^255:c)<<1)+19296>>1];break d;case 2:d=0;b=l[((b&256?c^255:c)<<1)+19296>>1];break d;case 3:d=0;b=l[((b&256?0:c)<<1)+19296>>1];break d;case 4:e=0;d=0;if(!(b&512)){e=(c<<1^b<<24>>31)&254;d=(b&256)>>>8|0}b=l[(e<<1)+19296>>1];break d;case 5:d=0;if(b&512){b=0}else{c=c<<1&254;b=b&128?c^255:c}b=l[(b<<1)+19296>>1];break d;case 6:d=(d&512)>>>9|0;b=0;break d;default:break e}}c=d<<3&4088;d=(b&512)>>>9|0;b=d?c^4088:c}i[a+74>>1]=l[a+72>>1];e=a;a=b+g|0;a=(a&65535)>>>0<8191?a:8191;c=0-d^l[((a&255)<<1)+18784>>1]+1024>>>((a&65280)>>>8)<<1;i[e+72>>1]=c}return c<<16>>16}function E5(a,b,c){var d=0,e=0,f=0,g=0,h=0,i=0,l=0,m=0,n=0,o=0;a:{b:{c:{f=j[a+1420>>2];if((f|0)<1){break c}while(1){j[(p(d,20)+a|0)+1436>>2]=0;d=d+1|0;if((f|0)!=(d|0)){continue}break}if((f|0)<=3){break c}h=c;break b}if((c|0)<4){break a}i=c-3|0;d:{while(1){e:{e=b+h|0;if(k[e|0]!=79|(k[e|0]|k[e+1|0]<<8|(k[e+2|0]<<16|k[e+3|0]<<24))!=(k[84688]|k[84689]<<8|(k[84690]<<16|k[84691]<<24))){break e}g=h+26|0;if((g|0)>=(i|0)){break d}l=h+27|0;n=b+g|0;c=k[n|0];if((i|0)<=(l+c|0)){break d}m=c+27|0;d=0;if(c){while(1){m=k[(d+l|0)+b|0]+m|0;d=d+1|0;if((c|0)!=(d|0)){continue}break}}d=0;c=0;while(1){l=22;d=Ev(d,k[(c+h|0)+b|0]);c=c+1|0;if((c|0)!=22){continue}break}while(1){d=Ev(d,0);l=l+1|0;if((l|0)!=26){continue}break}j[a+1420>>2]=f+1;c=p(f,20)+a|0;j[c+1432>>2]=d;j[c+1428>>2]=m-26;j[c+1424>>2]=k[e+22|0]|k[e+23|0]<<8|(k[e+24|0]<<16|k[e+25|0]<<24);if(k[(g+k[n|0]|0)+b|0]==255){d=-1}else{d=k[e+6|0]|k[e+7|0]<<8|(k[e+8|0]<<16|k[e+9|0]<<24)}j[c+1436>>2]=g;j[c+1440>>2]=d;f=j[a+1420>>2];if((f|0)!=4){break e}h=i;f=4;break b}h=h+1|0;if((i|0)!=(h|0)){continue}break}h=i}if((f|0)<1){break a}}i=0;while(1){e=p(i,20)+a|0;n=e+1432|0;c=j[n>>2];d=0;m=j[e+1436>>2];g=h-m|0;o=e+1428|0;l=j[o>>2];g=(g|0)<(l|0)?g:l;if((g|0)>=1){while(1){c=Ev(c,k[(d+m|0)+b|0]);d=d+1|0;if((g|0)!=(d|0)){continue}break}}d=l-g|0;j[o>>2]=d;j[n>>2]=c;f:{if(!d){d=c;c=e+1424|0;if((d|0)==j[c>>2]){j[a+1380>>2]=-1;j[a+992>>2]=0;j[a+1420>>2]=-1;b=j[(p(i,20)+a|0)+1440>>2];j[a+1060>>2]=b;j[a+1064>>2]=(b|0)!=-1;return g+m|0}d=f-1|0;j[a+1420>>2]=d;d=p(d,20)+a|0;j[c+16>>2]=j[d+1440>>2];e=d+1432|0;f=j[e+4>>2];j[c+8>>2]=j[e>>2];j[c+12>>2]=f;d=d+1424|0;e=j[d+4>>2];j[c>>2]=j[d>>2];j[c+4>>2]=e;f=j[a+1420>>2];break f}i=i+1|0}if((f|0)>(i|0)){continue}break}}return h}function LT(a,b,c){var d=0,e=0,f=0,g=0,l=0,m=0;e=Za-32|0;Za=e;a:{if((k[a|0]|k[a+1|0]<<8|(k[a+2|0]<<16|k[a+3|0]<<24))==1229999433){Kt(e,3,a+32|0);qc(e+16|0,e);j[114630]=0;E(369,b+492|0,e+16|0)|0;d=j[114630];j[114630]=0;if((d|0)==1){break a}gb(e+16|0);si(e,1,a+4|0);qc(e+16|0,e);j[114630]=0;E(369,b+524|0,e+16|0)|0;d=j[114630];j[114630]=0;if((d|0)==1){break a}gb(e+16|0);d=a+20|0;j[b>>2]=(k[d|0]|k[d+1|0]<<8)<<5;j[b+4>>2]=k[a+24|0]>>>1;jc(b+4|0,64);d=a+25|0;f=k[d|0]&127;j[b+8>>2]=f>>>0>64?128:f<<2;h[b+15|0]=k[b+15|0]&254|((k[d|0]^-1)&128)>>>7;h[e+16|0]=k[a+26|0];h[e|0]=100;l=b,m=k[Zb(e+16|0,e)|0],h[l+20|0]=m;h[e+16|0]=k[a+27|0];h[e|0]=64;l=b,m=k[Zb(e+16|0,e)|0],h[l+19|0]=m;h[b+16|0]=k[a+17|0];h[b+17|0]=k[a+18|0];h[b+18|0]=k[a+19|0];h[b+26|0]=k[a+22|0];h[b+27|0]=k[a+23|0];d=a+58|0;Gt(b,k[d|0]&127,k[d|0]>>>7|0);d=a+59|0;Ft(b,k[d|0]&127,k[d|0]>>>7|0);b:{c:{d:{d=a+28|0;if(!((k[d|0]|k[d+1|0]<<8)==514|(k[d|0]|k[d+1|0]<<8)==529|(k[d|0]|k[d+1|0]<<8)==544)){if((k[d|0]|k[d+1|0]<<8)!=532){break d}}d=a+61|0;if(k[d|0]==255){break d}if(k[d|0]<=128){h[b+30|0]=k[d|0]}d=k[a+62|0]|k[a+63|0]<<8;if(d>>>0<129){break c}break b}d=0;f=a+61|0;if(h[f|0]>=0){h[b+30|0]=k[f|0]+1}f=a+62|0;if(h[f|0]>=0){d=k[f|0]+1|0}f=a+63|0;if(h[f|0]<0){break c}d=(k[f|0]<<7)+d|0}i[b+28>>1]=d}d=h[a+60|0];h[b+31|0]=d;if((d|0)<=-1){h[b+31|0]=0;h[b+34|0]=d^128}d=0;c=c&16777216?240:25;Mt(a+304|0,b+48|0,0,c);Mt(a+386|0,b+68|0,32,c);Mt(a+468|0,b+88|0,32,c);h[b+100|0]=k[b+100|0]&239|k[a+468|0]>>>3&16;c=b+108|0;f=b+236|0;a=a- -64|0;while(1){g=d<<1;b=k[g+a|0];g=k[a+(g|1)|0];l=Nc(f,d),m=g,i[l>>1]=m;l=Pb(c,d),m=(b>>>0<120?b:d)+1|0,h[l|0]=m;d=d+1|0;if((d|0)!=120){continue}break}d=554}Za=e+32|0;return d}a=D()|0;C()|0;gb(e+16|0);G(a|0);z()}function zq(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;var i=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;l=Za-128|0;Za=l;j[l+120>>2]=b;n=ss(c,d);j[l+4>>2]=2421;p=yd(l+8|0,0,l+4|0);m=l+16|0;a:{b:{if(n>>>0>=101){m=Yc(n);if(!m){j[114630]=0;M(2422);a=j[114630];j[114630]=0;if((a|0)!=1){break a}b=D()|0;C()|0;break b}fe(p,m)}i=m;b=c;while(1){if((b|0)==(d|0)){c:{d:{e:while(1){f:{j[114630]=0;i=E(2423,a|0,l+120|0)|0;b=j[114630];j[114630]=0;if((b|0)==1){break f}if(!(i&(n|0)!=0)){j[114630]=0;b=E(2424,a|0,l+120|0)|0;a=j[114630];j[114630]=0;if((a|0)==1){break c}if(!b){break d}j[f>>2]=j[f>>2]|2;break d}j[114630]=0;q=H(2425,a|0)|0;b=j[114630];j[114630]=0;g:{if((b|0)!=1){if(g){break g}j[114630]=0;q=E(2426,e|0,q|0)|0;b=j[114630];j[114630]=0;if((b|0)!=1){break g}}b=D()|0;C()|0;break b}r=t+1|0;u=0;i=m;b=c;while(1){if((b|0)==(d|0)){t=r;if(!u){continue e}j[114630]=0;H(2427,a|0)|0;b=j[114630];j[114630]=0;if((b|0)!=1){i=m;b=c;if(n+o>>>0<2){continue e}while(1){if((b|0)==(d|0)){continue e}h:{if(k[i|0]!=2){break h}if((nb(b)|0)==(r|0)){break h}h[i|0]=0;o=o-1|0}i=i+1|0;b=b+12|0;continue}}b=D()|0;C()|0;break b}i:{if(k[i|0]!=1){break i}s=h[Ub(b,t)|0];j:{if(g){break j}j[114630]=0;s=E(2426,e|0,s<<24>>24)|0;v=j[114630];j[114630]=0;if((v|0)!=1){break j}b=D()|0;C()|0;break b}k:{if((q&255)==(s&255)){u=1;if((nb(b)|0)!=(r|0)){break i}h[i|0]=2;o=o+1|0;break k}h[i|0]=0}n=n-1|0}i=i+1|0;b=b+12|0;continue}}break}b=D()|0;C()|0;break b}l:{m:{while(1){if((c|0)==(d|0)){break m}if(k[m|0]!=2){m=m+1|0;c=c+12|0;continue}break}d=c;break l}j[f>>2]=j[f>>2]|4}mc(p);Za=l+128|0;return d|0}b=D()|0;C()|0}else{n:{if(!Ec(b)){h[i|0]=1;break n}h[i|0]=2;o=o+1|0;n=n-1|0}i=i+1|0;b=b+12|0;continue}break}}mc(p);G(b|0)}z()}function rX(a,b){var c=0,d=0,e=0,f=0,g=0,h=0,i=0,k=0,l=0,m=0,n=0;g=j[a+4>>2];d=g&-8;a:{if(!(g&3)){if(b>>>0<256){return 0}if(d>>>0>=b+4>>>0){c=a;if(d-b>>>0<=j[116058]<<1>>>0){break a}}return 0}e=a+d|0;b:{if(b>>>0<=d>>>0){c=d-b|0;if(c>>>0<16){break b}j[a+4>>2]=g&1|b|2;b=a+b|0;j[b+4>>2]=c|3;j[e+4>>2]=j[e+4>>2]|1;hq(b,c);break b}if(j[115944]==(e|0)){d=d+j[115941]|0;if(d>>>0<=b>>>0){break a}j[a+4>>2]=g&1|b|2;c=a+b|0;b=d-b|0;j[c+4>>2]=b|1;j[115941]=b;j[115944]=c;break b}if(j[115943]==(e|0)){d=d+j[115940]|0;if(d>>>0<b>>>0){break a}c=d-b|0;c:{if(c>>>0>=16){j[a+4>>2]=g&1|b|2;b=a+b|0;j[b+4>>2]=c|1;d=a+d|0;j[d>>2]=c;j[d+4>>2]=j[d+4>>2]&-2;break c}j[a+4>>2]=d|g&1|2;b=a+d|0;j[b+4>>2]=j[b+4>>2]|1;c=0;b=0}j[115943]=b;j[115940]=c;break b}f=j[e+4>>2];if(f&2){break a}h=d+(f&-8)|0;if(h>>>0<b>>>0){break a}k=h-b|0;d:{if(f>>>0<=255){c=j[e+8>>2];f=f>>>3|0;d=j[e+12>>2];if((d|0)==(c|0)){m=463752,n=j[115938]&MMa(-2,f),j[m>>2]=n;break d}j[c+12>>2]=d;j[d+8>>2]=c;break d}i=j[e+24>>2];d=j[e+12>>2];e:{if((e|0)!=(d|0)){c=j[e+8>>2];j[c+12>>2]=d;j[d+8>>2]=c;break e}f:{f=e+20|0;c=j[f>>2];if(c){break f}f=e+16|0;c=j[f>>2];if(c){break f}d=0;break e}while(1){l=f;d=c;f=d+20|0;c=j[f>>2];if(c){continue}f=d+16|0;c=j[d+16>>2];if(c){continue}break}j[l>>2]=0}if(!i){break d}c=j[e+28>>2];f=(c<<2)+464056|0;g:{if(j[f>>2]==(e|0)){j[f>>2]=d;if(d){break g}m=463756,n=j[115939]&MMa(-2,c),j[m>>2]=n;break d}j[(j[i+16>>2]==(e|0)?16:20)+i>>2]=d;if(!d){break d}}j[d+24>>2]=i;c=j[e+16>>2];if(c){j[d+16>>2]=c;j[c+24>>2]=d}c=j[e+20>>2];if(!c){break d}j[d+20>>2]=c;j[c+24>>2]=d}if(k>>>0<=15){j[a+4>>2]=g&1|h|2;b=a+h|0;j[b+4>>2]=j[b+4>>2]|1;break b}j[a+4>>2]=g&1|b|2;b=a+b|0;j[b+4>>2]=k|3;c=a+h|0;j[c+4>>2]=j[c+4>>2]|1;hq(b,k)}c=a}return c}function P$(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;var i=0,l=0,n=0,o=0;a=Za-624|0;Za=a;j[a+608>>2]=c;j[a+616>>2]=b;j[a+16>>2]=2483;b=yd(a+200|0,a+208|0,a+16|0);j[114630]=0;hc(a+192|0,e);i=j[114630];j[114630]=0;a:{b:{c:{d:{e:{f:{g:{h:{i:{j:{if((i|0)!=1){j[114630]=0;i=H(2450,a+192|0)|0;l=j[114630];j[114630]=0;if((l|0)==1){break j}h[a+191|0]=0;e=j[e+4>>2];j[114630]=0;c=ha(2494,a+616|0,c|0,d|0,a+192|0,e|0,f|0,a+191|0,i|0,b|0,a+196|0,a+608|0)|0;d=j[114630];j[114630]=0;if((d|0)==1){break e}if(!c){break f}c=k[64699]|k[64700]<<8|(k[64701]<<16|k[64702]<<24);h[a+183|0]=c;h[a+184|0]=c>>>8;h[a+185|0]=c>>>16;h[a+186|0]=c>>>24;c=k[64696]|k[64697]<<8|(k[64698]<<16|k[64699]<<24);j[a+176>>2]=k[64692]|k[64693]<<8|(k[64694]<<16|k[64695]<<24);j[a+180>>2]=c;j[114630]=0;P(2464,i|0,a+176|0,a+186|0,a+128|0)|0;c=j[114630];j[114630]=0;if((c|0)==1){break i}j[a+4>>2]=2421;d=yd(a+8|0,0,a+4|0);c=a+16|0;if((j[a+196>>2]-j[b>>2]|0)<393){break g}fe(d,Yc((j[a+196>>2]-j[b>>2]>>2)+2|0));if(j[d>>2]){break h}j[114630]=0;M(2422);c=j[114630];j[114630]=0;if((c|0)==1){break d}break a}e=D()|0;C()|0;break b}e=D()|0;C()|0;break c}e=D()|0;C()|0;break c}c=j[d>>2]}if(k[a+191|0]){h[c|0]=45;c=c+1|0}e=j[b>>2];while(1){if(m[a+196>>2]<=e>>>0){h[c|0]=0;j[a>>2]=g;if((pD(a+16|0,a)|0)!=1){j[114630]=0;N(2485,64676);c=j[114630];j[114630]=0;if((c|0)!=1){break a}break d}mc(d)}else{n=c,o=k[(a+176|0)+(Pu(a+128|0,a+168|0,e)-(a+128|0)>>2)|0],h[n|0]=o;c=c+1|0;e=e+4|0;continue}break}}j[114630]=0;c=E(2456,a+616|0,a+608|0)|0;d=j[114630];j[114630]=0;if((d|0)==1){break e}if(c){j[f>>2]=j[f>>2]|2}c=j[a+616>>2];wb(a+192|0);mc(b);Za=a+624|0;return c|0}e=D()|0;C()|0;break c}e=D()|0;C()|0;mc(d)}wb(a+192|0)}mc(b);G(e|0);z()}z()}function n1(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;a=Za-352|0;Za=a;j[a+336>>2]=c;j[a+344>>2]=b;h=Cb(a+208|0);j[114630]=0;hc(a+16|0,d);b=j[114630];j[114630]=0;a:{b:{c:{d:{if((b|0)!=1){j[114630]=0;b=H(2450,a+16|0)|0;c=j[114630];j[114630]=0;if((c|0)==1){break d}j[114630]=0;P(2464,b|0,64416,64442,a+224|0)|0;b=j[114630];j[114630]=0;if((b|0)==1){break d}wb(a+16|0);c=Cb(a+192|0);b=sc(c);j[114630]=0;F(149,c|0,b|0);b=j[114630];j[114630]=0;if((b|0)==1){break b}b=Ub(c,0);j[a+188>>2]=b;j[a+12>>2]=a+16;j[a+8>>2]=0;while(1){e:{j[114630]=0;d=E(2455,a+344|0,a+336|0)|0;g=j[114630];j[114630]=0;if((g|0)==1){break e}if(!d){break c}if(j[a+188>>2]==(nb(c)+b|0)){d=nb(c);b=nb(c);j[114630]=0;F(149,c|0,b<<1);b=j[114630];j[114630]=0;if((b|0)==1){break b}b=sc(c);j[114630]=0;F(149,c|0,b|0);b=j[114630];j[114630]=0;if((b|0)==1){break b}b=Ub(c,0);j[a+188>>2]=d+b}j[114630]=0;d=H(2457,a+344|0)|0;g=j[114630];j[114630]=0;if((g|0)==1){break e}j[114630]=0;d=wj(d,16,b,a+188|0,a+8|0,0,h,a+16|0,a+12|0,a+224|0);g=j[114630];j[114630]=0;if((g|0)==1){break e}if(d){break c}j[114630]=0;H(2459,a+344|0)|0;d=j[114630];j[114630]=0;if((d|0)!=1){continue}}break}break b}b=D()|0;C()|0;break a}b=D()|0;C()|0;wb(a+16|0);break a}j[114630]=0;F(149,c|0,j[a+188>>2]-b|0);b=j[114630];j[114630]=0;f:{if((b|0)==1){break f}b=zb(c);j[114630]=0;d=T(2446)|0;g=j[114630];j[114630]=0;if((g|0)==1){break f}j[a>>2]=f;j[114630]=0;b=P(2447,b|0,d|0,64449,a|0)|0;d=j[114630];j[114630]=0;if((d|0)==1){break f}if((b|0)!=1){j[e>>2]=4}j[114630]=0;b=E(2456,a+344|0,a+336|0)|0;d=j[114630];j[114630]=0;if((d|0)==1){break f}if(b){j[e>>2]=j[e>>2]|2}b=j[a+344>>2];gb(c);gb(h);Za=a+352|0;return b|0}}b=D()|0;C()|0;gb(c)}gb(h);G(b|0);z()}function xq(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;var i=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;l=Za-128|0;Za=l;j[l+120>>2]=b;n=ss(c,d);j[l+4>>2]=2421;p=yd(l+8|0,0,l+4|0);m=l+16|0;a:{b:{if(n>>>0>=101){m=Yc(n);if(!m){j[114630]=0;M(2422);a=j[114630];j[114630]=0;if((a|0)!=1){break a}b=D()|0;C()|0;break b}fe(p,m)}i=m;b=c;while(1){if((b|0)==(d|0)){c:{d:{e:while(1){f:{j[114630]=0;i=E(2455,a|0,l+120|0)|0;b=j[114630];j[114630]=0;if((b|0)==1){break f}if(!(i&(n|0)!=0)){j[114630]=0;b=E(2456,a|0,l+120|0)|0;a=j[114630];j[114630]=0;if((a|0)==1){break c}if(!b){break d}j[f>>2]=j[f>>2]|2;break d}j[114630]=0;q=H(2457,a|0)|0;b=j[114630];j[114630]=0;g:{if((b|0)!=1){if(g){break g}j[114630]=0;q=E(2458,e|0,q|0)|0;b=j[114630];j[114630]=0;if((b|0)!=1){break g}}b=D()|0;C()|0;break b}r=t+1|0;u=0;i=m;b=c;while(1){if((b|0)==(d|0)){t=r;if(!u){continue e}j[114630]=0;H(2459,a|0)|0;b=j[114630];j[114630]=0;if((b|0)!=1){i=m;b=c;if(n+o>>>0<2){continue e}while(1){if((b|0)==(d|0)){continue e}h:{if(k[i|0]!=2){break h}if((nb(b)|0)==(r|0)){break h}h[i|0]=0;o=o-1|0}i=i+1|0;b=b+12|0;continue}}b=D()|0;C()|0;break b}i:{if(k[i|0]!=1){break i}s=j[Ni(b,t)>>2];j:{if(g){break j}j[114630]=0;s=E(2458,e|0,s|0)|0;v=j[114630];j[114630]=0;if((v|0)!=1){break j}b=D()|0;C()|0;break b}k:{if((q|0)==(s|0)){u=1;if((nb(b)|0)!=(r|0)){break i}h[i|0]=2;o=o+1|0;break k}h[i|0]=0}n=n-1|0}i=i+1|0;b=b+12|0;continue}}break}b=D()|0;C()|0;break b}l:{m:{while(1){if((c|0)==(d|0)){break m}if(k[m|0]!=2){m=m+1|0;c=c+12|0;continue}break}d=c;break l}j[f>>2]=j[f>>2]|4}mc(p);Za=l+128|0;return d|0}b=D()|0;C()|0}else{n:{if(!Ec(b)){h[i|0]=1;break n}h[i|0]=2;o=o+1|0;n=n-1|0}i=i+1|0;b=b+12|0;continue}break}}mc(p);G(b|0)}z()}function J1(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;a=Za-272|0;Za=a;j[a+256>>2]=c;j[a+264>>2]=b;h=Cb(a+208|0);j[114630]=0;hc(a+16|0,d);b=j[114630];j[114630]=0;a:{b:{c:{d:{if((b|0)!=1){j[114630]=0;b=H(21,a+16|0)|0;c=j[114630];j[114630]=0;if((c|0)==1){break d}j[114630]=0;P(2441,b|0,64416,64442,a+224|0)|0;b=j[114630];j[114630]=0;if((b|0)==1){break d}wb(a+16|0);c=Cb(a+192|0);b=sc(c);j[114630]=0;F(149,c|0,b|0);b=j[114630];j[114630]=0;if((b|0)==1){break b}b=Ub(c,0);j[a+188>>2]=b;j[a+12>>2]=a+16;j[a+8>>2]=0;while(1){e:{j[114630]=0;d=E(2423,a+264|0,a+256|0)|0;g=j[114630];j[114630]=0;if((g|0)==1){break e}if(!d){break c}if(j[a+188>>2]==(nb(c)+b|0)){d=nb(c);b=nb(c);j[114630]=0;F(149,c|0,b<<1);b=j[114630];j[114630]=0;if((b|0)==1){break b}b=sc(c);j[114630]=0;F(149,c|0,b|0);b=j[114630];j[114630]=0;if((b|0)==1){break b}b=Ub(c,0);j[a+188>>2]=d+b}j[114630]=0;d=H(2425,a+264|0)|0;g=j[114630];j[114630]=0;if((g|0)==1){break e}j[114630]=0;d=xj(d,16,b,a+188|0,a+8|0,0,h,a+16|0,a+12|0,a+224|0);g=j[114630];j[114630]=0;if((g|0)==1){break e}if(d){break c}j[114630]=0;H(2427,a+264|0)|0;d=j[114630];j[114630]=0;if((d|0)!=1){continue}}break}break b}b=D()|0;C()|0;break a}b=D()|0;C()|0;wb(a+16|0);break a}j[114630]=0;F(149,c|0,j[a+188>>2]-b|0);b=j[114630];j[114630]=0;f:{if((b|0)==1){break f}b=zb(c);j[114630]=0;d=T(2446)|0;g=j[114630];j[114630]=0;if((g|0)==1){break f}j[a>>2]=f;j[114630]=0;b=P(2447,b|0,d|0,64449,a|0)|0;d=j[114630];j[114630]=0;if((d|0)==1){break f}if((b|0)!=1){j[e>>2]=4}j[114630]=0;b=E(2424,a+264|0,a+256|0)|0;d=j[114630];j[114630]=0;if((d|0)==1){break f}if(b){j[e>>2]=j[e>>2]|2}b=j[a+264>>2];gb(c);gb(h);Za=a+272|0;return b|0}}b=D()|0;C()|0;gb(c)}gb(h);G(b|0);z()}function Fua(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;f=Za-48|0;Za=f;v=j[a+16>>2];e=j[a+44>>2];j[f+32>>2]=e;k=j[a+48>>2];j[f+36>>2]=k;n=j[a+52>>2];j[f+40>>2]=n;o=j[a+56>>2];j[f+44>>2]=o;w=j[a+24>>2];x=j[a+20>>2];g=j[a+4>>2];l=j[a>>2];j[f+24>>2]=l;j[f+28>>2]=g;h=j[a+12>>2];j[f+16>>2]=j[a+8>>2];j[f+20>>2]=h;if(d){while(1){o=1;h=((((g&2147483647)<<1|l>>>31)&2147483646)<<1)+v|0;e=(((l>>>16|0)+4&131064)<<1)+b|0;l=i[e+38>>1];m=i[e+36>>1];r=i[e+34>>1];s=i[e+32>>1];t=i[e+30>>1];q=i[e+28>>1];u=i[e+26>>1];y=i[e+24>>1];n=0;e=1;k=0;while(1){g=k<<1;j[(f+8|0)+(k<<2)>>2]=(((((p(i[h+(g|8)>>1],r)+p(i[h+(g|4)>>1],s)|0)+p(i[h+(g|12)>>1],m)|0)+p(l,i[h+(g|16)>>1])|0)/2|0)+((((p(i[h+(g|-8)>>1],u)+p(i[h+(g|-12)>>1],y)|0)+p(i[h+(g|-4)>>1],q)|0)+p(i[h+g>>1],t)|0)/2|0)|0)/16384;g=e;e=0;k=1;if(g){continue}break}while(1){k=(f+8|0)+(n<<2)|0;l=j[k>>2];m=j[a+60>>2];r=m;g=(f+32|0)+(n<<3)|0;n=j[g>>2];e=Gb(n,-16777216,16776704);s=j[a+64>>2];h=Gb(j[g+4>>2],-16777216,16776704);q=j[a+68>>2];u=q;q=q>>31;j[g+4>>2]=n;n=j[a+72>>2];m=m>>31;l=l<<8;m=HMa(r,m,l,l>>31);r=ab;t=k;k=m;m=HMa(s,s>>31,e,e>>31);k=k+m|0;e=ab+r|0;e=k>>>0<m>>>0?e+1|0:e;m=k;k=HMa(u,q,h,h>>31);h=m+k|0;e=ab+e|0;e=h>>>0<k>>>0?e+1|0:e;h=h+8388608|0;if(h>>>0<8388608){e=e+1|0}e=(e&16777215)<<8|h>>>24;j[t>>2]=(e|0)/256;j[g>>2]=e-(l&n);n=1;e=o&1;o=0;if(e){continue}break}j[c>>2]=j[c>>2]+p(j[f+8>>2],x);j[c+4>>2]=j[c+4>>2]+p(j[f+12>>2],w);Bb(f+24|0,f+16|0);d=d-1|0;if(d){c=c+8|0;l=j[f+24>>2];g=j[f+28>>2];continue}break}l=j[f+24>>2];g=j[f+28>>2];o=j[f+44>>2];n=j[f+40>>2];k=j[f+36>>2];e=j[f+32>>2]}j[a+56>>2]=o;j[a+52>>2]=n;j[a+48>>2]=k;j[a+44>>2]=e;j[a>>2]=l;j[a+4>>2]=g;Za=f+48|0}function Y$(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;var i=0,l=0,n=0,o=0;a=Za-288|0;Za=a;j[a+272>>2]=c;j[a+280>>2]=b;j[a+16>>2]=2483;b=yd(a+152|0,a+160|0,a+16|0);j[114630]=0;hc(a+144|0,e);i=j[114630];j[114630]=0;a:{b:{c:{d:{e:{f:{g:{h:{i:{j:{if((i|0)!=1){j[114630]=0;i=H(21,a+144|0)|0;l=j[114630];j[114630]=0;if((l|0)==1){break j}h[a+143|0]=0;e=j[e+4>>2];j[114630]=0;c=ha(2484,a+280|0,c|0,d|0,a+144|0,e|0,f|0,a+143|0,i|0,b|0,a+148|0,a+260|0)|0;d=j[114630];j[114630]=0;if((d|0)==1){break e}if(!c){break f}c=k[64699]|k[64700]<<8|(k[64701]<<16|k[64702]<<24);h[a+135|0]=c;h[a+136|0]=c>>>8;h[a+137|0]=c>>>16;h[a+138|0]=c>>>24;c=k[64696]|k[64697]<<8|(k[64698]<<16|k[64699]<<24);j[a+128>>2]=k[64692]|k[64693]<<8|(k[64694]<<16|k[64695]<<24);j[a+132>>2]=c;j[114630]=0;P(2441,i|0,a+128|0,a+138|0,a+118|0)|0;c=j[114630];j[114630]=0;if((c|0)==1){break i}j[a+4>>2]=2421;d=yd(a+8|0,0,a+4|0);c=a+16|0;if((j[a+148>>2]-j[b>>2]|0)<99){break g}fe(d,Yc((j[a+148>>2]-j[b>>2]|0)+2|0));if(j[d>>2]){break h}j[114630]=0;M(2422);c=j[114630];j[114630]=0;if((c|0)==1){break d}break a}e=D()|0;C()|0;break b}e=D()|0;C()|0;break c}e=D()|0;C()|0;break c}c=j[d>>2]}if(k[a+143|0]){h[c|0]=45;c=c+1|0}e=j[b>>2];while(1){if(m[a+148>>2]<=e>>>0){h[c|0]=0;j[a>>2]=g;if((pD(a+16|0,a)|0)!=1){j[114630]=0;N(2485,64676);c=j[114630];j[114630]=0;if((c|0)!=1){break a}break d}mc(d)}else{n=c,o=k[((zm(a+118|0,a+128|0,e)-a|0)+a|0)+10|0],h[n|0]=o;c=c+1|0;e=e+1|0;continue}break}}j[114630]=0;c=E(2424,a+280|0,a+272|0)|0;d=j[114630];j[114630]=0;if((d|0)==1){break e}if(c){j[f>>2]=j[f>>2]|2}c=j[a+280>>2];wb(a+144|0);mc(b);Za=a+288|0;return c|0}e=D()|0;C()|0;break c}e=D()|0;C()|0;mc(d)}wb(a+144|0)}mc(b);G(e|0);z()}z()}function Vua(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0;l=Za-16|0;Za=l;a:{b:{c:{m=j[a+8>>2];g=j[a+12>>2];d:{if((g|0)<1?1:(g|0)<=1?m>>>0<=805306368:0){if((g|0)>-2?1:(g|0)>=-2?m>>>0>=3489660928:0){break c}if((g|0)>-2?1:(g|0)>=-2?m>>>0>2147483647:0){break d}break b}if((g|0)>1?1:(g|0)>=1?m>>>0>2147483648:0){break b}}s=b+196648|0;break a}s=b+131112|0;break a}s=b+262184|0}v=j[a+16>>2];f=j[a+48>>2];o=j[a+40>>2];q=j[a+36>>2];e=j[a+44>>2];k=j[a+4>>2];n=j[a>>2];j[l+8>>2]=n;j[l+12>>2]=k;j[l>>2]=m;j[l+4>>2]=g;e:{if(!d){g=o>>12;m=q>>12;break e}while(1){b=k+v|0;g=h[b+4|0];k=(n>>>16&65520)+s|0;n=i[k+14>>1];m=h[b+3|0];w=i[k+12>>1];x=h[b+2|0];y=i[k+10>>1];z=h[b+1|0];A=i[k+8>>1];B=h[b|0];C=i[k+6>>1];D=h[b-1|0];E=i[k+4>>1];F=h[b-2|0];G=i[k+2>>1];H=h[b-3|0];I=i[k>>1];b=j[a+60>>2];J=b;K=b>>31;b=e;e=Gb(e,-16777216,16776704);r=j[a+64>>2];f=Gb(f,-16777216,16776704);L=j[a+72>>2];M=j[a+32>>2];k=c;N=j[k>>2];e=HMa(r,r>>31,e,e>>31);r=ab;t=e;e=j[a+68>>2];u=HMa(e,e>>31,f,f>>31);e=t+u|0;f=ab+r|0;f=e>>>0<u>>>0?f+1|0:f;t=e;n=(((((((p(F,G)+p(H,I)|0)+p(D,E)|0)+p(B,C)|0)+p(z,A)|0)+p(x,y)|0)+p(m,w)|0)+p(g,n)<<8)/32768<<8;e=n;g=HMa(J,K,e,e>>31);e=t+g|0;f=ab+f|0;f=e>>>0<g>>>0?f+1|0:f;e=e+8388608|0;if(e>>>0<8388608){f=f+1|0}e=(f&16777215)<<8|e>>>24;f=(e|0)/256|0;q=j[a+28>>2]+q|0;m=q>>12;j[k>>2]=p(f,m)+N;o=o+M|0;g=o>>12;j[c+4>>2]=j[c+4>>2]+p(f,g);e=e-(n&L)|0;Bb(l+8|0,l);d=d-1|0;if(d){c=c+8|0;n=j[l+8>>2];k=j[l+12>>2];f=b;continue}break}n=j[l+8>>2];k=j[l+12>>2];f=b}j[a+40>>2]=o;j[a+20>>2]=m;j[a+36>>2]=q;j[a+48>>2]=f;j[a+44>>2]=e;j[a+24>>2]=g;j[a>>2]=n;j[a+4>>2]=k;Za=l+16|0}function Uua(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0;k=Za-16|0;Za=k;a:{b:{c:{l=j[a+8>>2];g=j[a+12>>2];d:{if((g|0)<1?1:(g|0)<=1?l>>>0<=805306368:0){if((g|0)>-2?1:(g|0)>=-2?l>>>0>=3489660928:0){break c}if((g|0)>-2?1:(g|0)>=-2?l>>>0>2147483647:0){break d}break b}if((g|0)>1?1:(g|0)>=1?l>>>0>2147483648:0){break b}}s=b+196648|0;break a}s=b+131112|0;break a}s=b+262184|0}v=j[a+16>>2];e=j[a+48>>2];n=j[a+40>>2];o=j[a+36>>2];m=j[a+44>>2];h=j[a+4>>2];f=j[a>>2];j[k+8>>2]=f;j[k+12>>2]=h;j[k>>2]=l;j[k+4>>2]=g;e:{if(!d){g=n>>12;l=o>>12;break e}while(1){b=(f>>>16&65520)+s|0;g=i[b>>1];h=(h<<1)+v|0;l=i[h-6>>1];q=i[b+2>>1];w=i[h-4>>1];x=i[b+4>>1];y=i[h-2>>1];z=i[b+6>>1];A=i[h>>1];B=i[b+8>>1];C=i[h+2>>1];D=i[b+10>>1];E=i[h+4>>1];F=i[b+12>>1];G=i[h+6>>1];H=i[b+14>>1];I=i[h+8>>1];u=j[a+60>>2];b=m;f=Gb(b,-16777216,16776704);r=j[a+64>>2];m=Gb(e,-16777216,16776704);J=j[a+72>>2];K=j[a+32>>2];h=c;L=j[h>>2];e=HMa(r,r>>31,f,f>>31);r=ab;t=e;q=(((((((p(q,w)+p(g,l)|0)+p(x,y)|0)+p(z,A)|0)+p(B,C)|0)+p(D,E)|0)+p(F,G)|0)+p(H,I)|0)/32768<<8;e=q;g=HMa(u,u>>31,e,e>>31);f=t+g|0;e=ab+r|0;e=f>>>0<g>>>0?e+1|0:e;t=f;f=j[a+68>>2];m=HMa(f,f>>31,m,m>>31);f=t+m|0;e=ab+e|0;e=f>>>0<m>>>0?e+1|0:e;f=f+8388608|0;if(f>>>0<8388608){e=e+1|0}f=(e&16777215)<<8|f>>>24;e=(f|0)/256|0;o=j[a+28>>2]+o|0;l=o>>12;j[h>>2]=p(e,l)+L;n=n+K|0;g=n>>12;j[c+4>>2]=j[c+4>>2]+p(e,g);m=f-(q&J)|0;Bb(k+8|0,k);d=d-1|0;if(d){c=c+8|0;f=j[k+8>>2];h=j[k+12>>2];e=b;continue}break}f=j[k+8>>2];h=j[k+12>>2];e=b}j[a+40>>2]=n;j[a+20>>2]=l;j[a+36>>2]=o;j[a+48>>2]=e;j[a+44>>2]=m;j[a+24>>2]=g;j[a>>2]=f;j[a+4>>2]=h;Za=k+16|0}function Gua(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;f=Za-48|0;Za=f;w=j[a+16>>2];g=j[a+44>>2];j[f+32>>2]=g;e=j[a+48>>2];j[f+36>>2]=e;n=j[a+52>>2];j[f+40>>2]=n;q=j[a+56>>2];j[f+44>>2]=q;x=j[a+24>>2];y=j[a+20>>2];o=j[a+4>>2];l=j[a>>2];j[f+24>>2]=l;j[f+28>>2]=o;k=j[a+12>>2];j[f+16>>2]=j[a+8>>2];j[f+20>>2]=k;if(d){while(1){k=(((o&2147483647)<<1|l>>>31)&-2)+w|0;q=1;e=(((l>>>16|0)+4&131064)<<1)+b|0;l=i[e+38>>1];m=i[e+36>>1];s=i[e+34>>1];t=i[e+32>>1];u=i[e+30>>1];r=i[e+28>>1];v=i[e+26>>1];z=i[e+24>>1];n=0;e=1;g=0;while(1){j[(f+8|0)+(g<<2)>>2]=(((((p(h[k+(g|4)|0],s)+p(h[k+(g|2)|0],t)|0)+p(h[k+(g|6)|0],m)|0)+p(l,h[k+(g|8)|0])<<8)/2|0)+((((p(h[k+(g|-4)|0],v)+p(h[k+(g|-6)|0],z)|0)+p(h[k+(g|-2)|0],r)|0)+p(h[g+k|0],u)<<8)/2|0)|0)/16384;o=e;e=0;g=1;if(o){continue}break}while(1){k=(f+8|0)+(n<<2)|0;l=j[k>>2];m=j[a+60>>2];s=m;o=(f+32|0)+(n<<3)|0;n=j[o>>2];e=Gb(n,-16777216,16776704);t=j[a+64>>2];g=Gb(j[o+4>>2],-16777216,16776704);r=j[a+68>>2];v=r;r=r>>31;j[o+4>>2]=n;n=j[a+72>>2];m=m>>31;l=l<<8;m=HMa(s,m,l,l>>31);s=ab;u=k;k=m;m=HMa(t,t>>31,e,e>>31);k=k+m|0;e=ab+s|0;e=k>>>0<m>>>0?e+1|0:e;m=k;k=HMa(v,r,g,g>>31);g=m+k|0;e=ab+e|0;e=g>>>0<k>>>0?e+1|0:e;g=g+8388608|0;if(g>>>0<8388608){e=e+1|0}e=(e&16777215)<<8|g>>>24;j[u>>2]=(e|0)/256;j[o>>2]=e-(l&n);n=1;e=q&1;q=0;if(e){continue}break}j[c>>2]=j[c>>2]+p(j[f+8>>2],y);j[c+4>>2]=j[c+4>>2]+p(j[f+12>>2],x);Bb(f+24|0,f+16|0);d=d-1|0;if(d){c=c+8|0;l=j[f+24>>2];o=j[f+28>>2];continue}break}l=j[f+24>>2];o=j[f+28>>2];q=j[f+44>>2];n=j[f+40>>2];g=j[f+32>>2];e=j[f+36>>2]}j[a+56>>2]=q;j[a+52>>2]=n;j[a+48>>2]=e;j[a+44>>2]=g;j[a>>2]=l;j[a+4>>2]=o;Za=f+48|0}function Iaa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0;e=Za-128|0;Za=e;a:{if(Ec(b)){break a}f=k[rG(b)|0];g=1;b:{if((f|0)==33){break b}if((f|0)!=63){break a}g=0}d=g;Tq(e+112|0,b,0,nb(b)-1|0);ob(b,e+112|0);gb(e+112|0)}ld(e+112|0);f=j[e+112>>2];ld(e+96|0);f=qG(f,j[e+100>>2],b);ld(e+112|0);c:{d:{e:{f:{if((f|0)==j[e+116>>2]){if(Dd(b,38235)){a=R(8)|0;j[114630]=0;I(2130,e+112|0,39307,c|0);b=j[114630];j[114630]=0;if((b|0)==1){break e}Wb(a,e+112|0);j[114630]=0;I(2004,a|0,83648,2012);a=j[114630];j[114630]=0;if((a|0)!=1){break c}b=D()|0;C()|0;gb(e+112|0);break d}if(!d){break f}a=R(8)|0;j[114630]=0;I(2130,e+80|0,39186,b|0);b=j[114630];j[114630]=0;g:{h:{i:{j:{k:{if((b|0)!=1){j[114630]=0;I(2131,e+96|0,e+80|0,39322);b=j[114630];j[114630]=0;if((b|0)==1){break k}j[114630]=0;I(800,e+112|0,e+96|0,c|0);b=j[114630];j[114630]=0;c=1;if((b|0)==1){break j}Wb(a,e+112|0);j[114630]=0;I(2004,a|0,83648,2012);b=j[114630];j[114630]=0;if((b|0)!=1){break c}b=D()|0;C()|0;gb(e+112|0);c=0;break i}b=D()|0;C()|0;break g}b=D()|0;c=1;C()|0;break h}b=D()|0;C()|0}gb(e+96|0)}gb(e+80|0);if(!c){break d}}S(a|0);break d}l:{switch(j[f+4>>2]){case 0:nh(e+72|0,b);b=(YF(c)|0)!=0;c=j[e+76>>2];j[e>>2]=j[e+72>>2];j[e+4>>2]=c;pG(a,e,b,d);break f;case 1:nh(e- -64|0,b);b=M8(c);c=j[e+68>>2];j[e+8>>2]=j[e+64>>2];j[e+12>>2]=c;oG(a,e+8|0,b,ab,d);break f;case 2:nh(e+56|0,b);h=C8(c);b=j[e+60>>2];j[e+16>>2]=j[e+56>>2];j[e+20>>2]=b;nG(a,e+16|0,h,d);break f;case 3:break l;default:break f}}nh(e+48|0,b);nh(e+40|0,c);b=j[e+52>>2];j[e+32>>2]=j[e+48>>2];j[e+36>>2]=b;b=j[e+44>>2];j[e+24>>2]=j[e+40>>2];j[e+28>>2]=b;mG(a,e+32|0,e+24|0,d)}Za=e+128|0;return}b=D()|0;C()|0;S(a|0)}G(b|0)}z()}function hva(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;b=Za-48|0;Za=b;v=j[a+16>>2];h=j[a+44>>2];j[b+32>>2]=h;n=j[a+48>>2];j[b+36>>2]=n;k=j[a+52>>2];j[b+40>>2]=k;g=j[a+56>>2];j[b+44>>2]=g;r=j[a+40>>2];s=j[a+36>>2];e=j[a+4>>2];l=j[a>>2];j[b+24>>2]=l;j[b+28>>2]=e;f=j[a+12>>2];j[b+16>>2]=j[a+8>>2];j[b+20>>2]=f;a:{if(!d){m=r>>12;f=s>>12;break a}while(1){n=1;e=((((e&2147483647)<<1|l>>>31)&2147483646)<<1)+v|0;h=(l>>>21&2040)+27888|0;l=i[h+6>>1];g=i[h+4>>1];m=i[h+2>>1];o=i[h>>1];h=0;k=1;f=0;while(1){q=(b+8|0)+(f<<2)|0;f=f<<1;j[q>>2]=(((p(i[f+e>>1],m)+p(i[e+(f|-4)>>1],o)|0)+p(g,i[e+(f|4)>>1])|0)+p(l,i[e+(f|8)>>1])|0)/16384;t=k&1;k=0;f=1;if(t){continue}break}while(1){k=(b+8|0)+(h<<2)|0;l=j[k>>2];g=j[a+60>>2];m=g;h=(b+32|0)+(h<<3)|0;o=j[h>>2];e=Gb(o,-16777216,16776704);t=j[a+64>>2];f=Gb(j[h+4>>2],-16777216,16776704);q=j[a+68>>2];w=q;q=q>>31;j[h+4>>2]=o;o=j[a+72>>2];u=g>>31;l=l<<8;g=l;g=HMa(m,u,g,g>>31);m=ab;u=k;k=g;g=HMa(t,t>>31,e,e>>31);k=k+g|0;e=ab+m|0;e=k>>>0<g>>>0?e+1|0:e;g=k;k=HMa(w,q,f,f>>31);f=g+k|0;e=ab+e|0;e=f>>>0<k>>>0?e+1|0:e;f=f+8388608|0;if(f>>>0<8388608){e=e+1|0}e=(e&16777215)<<8|f>>>24;j[u>>2]=(e|0)/256;j[h>>2]=e-(l&o);h=1;e=n&1;n=0;if(e){continue}break}e=j[a+32>>2];s=j[a+28>>2]+s|0;f=s>>12;j[c>>2]=j[c>>2]+p(f,j[b+8>>2]);r=e+r|0;m=r>>12;j[c+4>>2]=j[c+4>>2]+p(m,j[b+12>>2]);Bb(b+24|0,b+16|0);d=d-1|0;if(d){c=c+8|0;l=j[b+24>>2];e=j[b+28>>2];continue}break}l=j[b+24>>2];e=j[b+28>>2];g=j[b+44>>2];k=j[b+40>>2];n=j[b+36>>2];h=j[b+32>>2]}j[a+40>>2]=r;j[a+20>>2]=f;j[a+36>>2]=s;j[a+56>>2]=g;j[a+52>>2]=k;j[a+48>>2]=n;j[a+44>>2]=h;j[a+24>>2]=m;j[a>>2]=l;j[a+4>>2]=e;Za=b+48|0}function Ew(a,b,c){var d=0,e=0,f=0,g=0,i=0,j=0,l=0;f=Za-16|0;Za=f;e=1;a:{b:{c:{d:{e:{f:{g:{h:{i:{j:{k:{l:{d=k[a|0];switch(d|0){case 0:break a;case 3:break j;case 2:break k;case 13:break l;case 5:break b;case 9:break d;case 11:break e;case 20:break f;case 1:case 6:case 7:case 8:case 10:case 12:case 14:case 15:case 16:case 17:case 18:case 19:break g;case 4:break i;default:break h}}h[a|0]=1;h[f+15|0]=64;j=b,l=k[Zb(b,f+15|0)|0],h[j|0]=l;break a}d=k[b|0];if(!c){e=0;if(d&3|d>>>0>223){break a}}h[b|0]=(d&252)>>>2;h[a|0]=12;e=1;break a}d=k[b|0];if(!c){e=0;if(d&3|d>>>0>223){break a}}h[b|0]=(d&252)>>>2;h[a|0]=13;e=1;break a}g=k[b|0];if(g>>>0<240){d=0;while(1){i=k[d+20832|0];m:{n:{if(c){if(g>>>0<=i>>>0){break n}break m}if((g|0)!=(i|0)){break m}}h[a|0]=11;h[b|0]=d;break a}e=d>>>0<9;d=d+1|0;if((d|0)!=10){continue}break}break a}h[a|0]=11;h[b|0]=9;break a}if((d|0)==26){break c}}e=0;break a}e=0;o:{p:{q:{d=k[b|0]>>>4|0;switch(d|0){case 3:case 4:case 5:case 6:case 7:break a;case 8:break o;case 0:case 1:case 2:break p;default:break q}}if((d|0)!=15){break a}}if(!c){break a}h[b|0]=0;h[a|0]=0;e=1;break a}h[a|0]=2;h[b|0]=k[b|0]<<2&60|2;e=1;break a}e=0;c=k[b|0];if(!c){break a}d=c&15;if(!d){h[b|0]=c>>>4;h[a|0]=3;e=1;break a}g=c&240;if(!g){h[a|0]=4;e=1;break a}if((d|0)==15){h[b|0]=c>>>4;h[a|0]=5;e=1;break a}if((g|0)!=240){break a}h[b|0]=d;h[a|0]=6;e=1;break a}c=b;b=k[b|0];h[c|0]=(b|0)==255?64:b>>>2|0;h[a|0]=2;break a}r:{if(c){h[b|0]=0;break r}e=0;if(k[b|0]){break a}}h[a|0]=8;e=1;break a}s:{if(c){h[f+14|0]=k[b|0]&15;h[f+13|0]=9;d=k[Zb(f+14|0,f+13|0)|0];break s}e=0;d=k[b|0];if((d&14)>>>0>9|d&240){break a}}h[b|0]=d&15;h[a|0]=8;e=1}Za=f+16|0;return e}function m9(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0;c=Za+ -64|0;Za=c;f=Ng(a);a:{b:{c:{d:{e:{f:{g:{h:{i:{j:{k:{l:{m:{n:{if(Ph(b)){go(c+56|0);break n}j[114630]=0;F(2183,c+40|0,b|0);a=j[114630];j[114630]=0;if((a|0)==1){break m}j[114630]=0;F(2169,c+56|0,c+40|0);a=j[114630];j[114630]=0;if((a|0)==1){break l}Ye(c+40|0)}a=b+36|0;o:{if(Ph(b)){break o}a=j[c+56>>2]}e=pd(a);j[114630]=0;F(1527,f|0,e|0);e=j[114630];j[114630]=0;if((e|0)==1){break k}h=c,i=Lb(a),j[h+32>>2]=i;h=c,i=Mb(a),j[h+24>>2]=i;if(rb(c+32|0,c+24|0)){a=b+24|0;while(1){e=j[c+32>>2];b=ei(j[a>>2]+484360|0,k[e+16|0]);j[114630]=0;F(2184,c+8|0,b|0);d=j[114630];j[114630]=0;if((d|0)==1){break j}j[114630]=0;I(9,c+40|0,0,c+8|0);d=j[114630];j[114630]=0;if((d|0)==1){break i}j[114630]=0;F(1529,f|0,c+40|0);d=j[114630];j[114630]=0;if((d|0)==1){break h}gb(c+40|0);gb(c+8|0);p:{if(!Ec(WF(f))){break p}d=k[e+12|0];j[114630]=0;d=E(546,b|0,d|0)|0;g=j[114630];j[114630]=0;if((g|0)==1){break c}if(!d){break p}d=j[a>>2];j[114630]=0;d=H(686,d|0)|0;g=j[114630];j[114630]=0;if((g|0)==1){break f}b=Hb(j[a>>2]+484344|0,l[bc(b,j[e+12>>2])>>1]);j[114630]=0;F(2185,c+8|0,b|0);b=j[114630];j[114630]=0;if((b|0)==1){break e}j[114630]=0;L(438,c+40|0,0,d|0,c+8|0);b=j[114630];j[114630]=0;if((b|0)==1){break d}ob(WF(f),c+40|0);gb(c+40|0);gb(c+8|0)}gk(c+32|0);if(rb(c+32|0,c+24|0)){continue}break}}Gj(c+56|0);Za=c- -64|0;return}b=D()|0;C()|0;break a}b=D()|0;C()|0;Ye(c+40|0);break a}b=D()|0;C()|0;break b}b=D()|0;C()|0;break b}b=D()|0;C()|0;break g}b=D()|0;C()|0;gb(c+40|0)}gb(c+8|0);break b}b=D()|0;C()|0;break b}b=D()|0;C()|0;break b}b=D()|0;C()|0;gb(c+8|0);break b}b=D()|0;C()|0}Gj(c+56|0)}Vc(f);G(b|0);z()}function Foa(a,b,c){var d=0,e=0,f=0,g=0,i=0;d=c&15;f=p(b,896)+a|0;e=f+1074984|0;a:{b:{switch(c>>>4|0){case 0:if(!l[a+480188>>1]){break a}b=(c&1)<<14;c=0;while(1){d=(p(c,896)+a|0)+1075072|0;j[d>>2]=(b|j[d>>2]&-16385)^16384;c=c+1|0;if(c>>>0<l[a+480188>>1]){continue}break}break a;case 1:if(j[a+480180>>2]&1048580?0:!d){break a}rK(a,e,d);return;case 2:if(j[a+480180>>2]&1048580?0:!d){break a}pK(a,e,d);return;case 3:a=f+1075072|0;j[a>>2]=j[a>>2]&-1048577|((d|0)!=0)<<20;return;case 4:h[f+1075826|0]=c&7;return;case 5:if(!(k[a+480209|0]&16)){break a}if(j[a+480180>>2]&69206025){c=p(b,896)+a|0;e=c+1075752|0;j[e>>2]=d<<28>>24;d=c+1075684|0;if(!j[d>>2]){break a}if(!Mf(c+1075794|0)){break a}c=a;a=p(b,896)+a|0;g=d,i=Zf(c,k[a+1075803|0],j[e>>2],j[a+1075688>>2]),j[g>>2]=i;return}f=j[a+480180>>2];e=Mf((p(b,896)+a|0)+1075794|0);if((f|0)==16){if(!e){break a}c=p(b,896)+a|0;e=j[c+1075088>>2];if(!e){break a}h[e+37|0]=d;j[c+1075752>>2]=d;c=c+1075684|0;if(!j[c>>2]){break a}e=a;a=p(b,896)+a|0;g=c,i=Zf(e,k[a+1075803|0],d,j[a+1075688>>2]),j[g>>2]=i;return}if(!e){break a}b=p(b,896)+a|0;c=c<<28>>24^-128;j[b+1075752>>2]=c;d=b+1075684|0;if(!j[d>>2]){break a}g=d,i=Zf(a,k[b+1075803|0],c,j[b+1075688>>2]),j[g>>2]=i;return;case 7:h[f+1075829|0]=c&7;return;case 8:if(!(k[a+480209|0]&16)){break a}dl(a,e,d,4);return;case 9:mx(a,b,d,0);return;case 10:if(j[a+480180>>2]&1048580?0:!d){break a}Eo(a,e,d,0);return;case 11:if(j[a+480180>>2]&1048580?0:!d){break a}Do(a,e,d,0);return;case 12:ox(a,b,d,0);return;case 15:break b;default:break a}}if(j[a+480180>>2]==1){h[(p(b,896)+a|0)+1075850|0]=d;if(!(k[a+480209|0]&16)){break a}DK(a,e);return}h[(p(b,896)+a|0)+1075848|0]=d}}function TLa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,i=0,l=0,n=0;f=Za-16|0;Za=f;rc(c);a:{if(!yb(c,3)){break a}while(1){Bt(f+8|0,c);l=Pc(f+8|0);d=Bf(f+8|0);g=f+8|0;if(m[a+12>>2]<=k[g|0]){break a}e=Se(a,k[g|0],b);i=k[l|0];b:{if(i>>>0<=126){if(!(i|k[d|0])){h[e|0]=254;break b}h[e|0]=i+1;if(k[d|0]==255){break b}if(!k[e+1|0]){h[e+1|0]=n}h[e+2|0]=1;h[e+4|0]=k[d|0];break b}c:{switch(i-127|0){case 0:d=k[g|0]+h[d|0]|0;if((d|0)<0|(d|0)>=j[a+12>>2]<<16>>16){break b}d=Se(a,d,b);g=k[d|0]|k[d+1|0]<<8|(k[d+2|0]<<16|k[d+3|0]<<24);h[e|0]=g;h[e+1|0]=g>>>8;h[e+2|0]=g>>>16;h[e+3|0]=g>>>24;d=k[d+4|0]|k[d+5|0]<<8;h[e+4|0]=d;h[e+5|0]=d>>>8;break b;case 1:n=k[d|0]+1|0;h[e+1|0]=n;break b;default:break c}}d=h[d|0];h[f+7|0]=d;g=0;i=i&127;if(i>>>0<=23){g=k[i+12144|0]}d:{e:{f:{g:{h:{i:{j:{k:{l:{m:{n:{i=k[l|0];switch((i&127)-2|0){case 21:break g;case 18:break h;case 17:break i;case 16:case 20:break j;case 15:break k;case 2:break l;case 1:break m;case 0:case 8:case 9:break n;default:break e}}if((d|0)>-1){break f}d=0-d&15;break e}h[f+6|0]=64;d=k[Zb(f+7|0,f+6|0)|0];if(k[e+2|0]>1){break e}h[e+4|0]=d;h[e+2|0]=1;break b}if((d|0)>-1){g=3;break d}d=0-d&127;h[f+7|0]=d;break e}if(!d){break b}if((d|0)<=-1){d=0-d|-16;h[f+7|0]=d;break e}d=d<<4|15;h[f+7|0]=d;break e}if(!d){break b}g=(d|0)>-1;if(!g){d=0-d&15;h[f+7|0]=d;i=k[l|0]}g=g?3:2;d=((i|0)==22?-32:-16)|d;h[f+7|0]=d;break d}d=d&15|-48;h[f+7|0]=d;break e}d=d&15|-64;h[f+7|0]=d;break e}d=d- -64&127;if(!k[e+3|0]){break e}o:{switch(k[e+2|0]){case 0:case 2:break o;default:break b}}h[e+2|0]=2;h[e+4|0]=d>>>1;break b}d=d<<4}if(!(g&255)){break b}}h[e+5|0]=d;h[e+3|0]=g}if(yb(c,3)){continue}break}}Za=f+16|0}function fMa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0;d=Za-384|0;Za=d;rc(b);f=d+344|0;g=HLa(b,f);if(!g){NS(f)}a:{b:{if(!g){break b}if(!fT(d+344|0)){break b}if(!yb(b,Tc(eT(d+344|0),ab))){break b}c:{if(!c){break c}od(a,2097152);Zh(a);Qi(a,1);i[a+480188>>1]=8;j[a+480196>>2]=k[d+376|0];j[a+480204>>2]=p(k[d+377|0],1e4);i[a+480190>>1]=k[d+378|0];if(k[d+381|0]<k[d+380|0]){Fe(Eb(a+484360|0),k[d+381|0])}e=Db(d+80|0,12002);ob(a+1304436|0,e);gb(e);e=Db(d+80|0,12022);ob(a+1304448|0,e);gb(e);j[a+1304496>>2]=4;Rz(b,d+80|0);xt(Eb(a+484360|0),d+80|0,k[d+380|0],65535,65535);if(l[a+480190>>1]){e=1;f=1;while(1){dT(b,d+40|0);eMa(d+40|0,(p(e,104)+a|0)+484380|0);sn(d+8|0,2,d+40|0);qc(d+24|0,d+8|0);j[114630]=0;E(369,((e<<5)+a|0)+946300|0,d+24|0)|0;e=j[114630];j[114630]=0;if((e|0)==1){break a}gb(d+24|0);f=f+1|0;e=f&65535;if(e>>>0<=l[a+480190>>1]){continue}break}}Jb(b,p(64-k[d+378|0]|0,37));g=a+484344|0;Jf(g,k[d+379|0]);if(k[d+379|0]){n=c&1;f=0;while(1){d:{e:{if(n){if(Wf(g,f&65535,64)){break e}}Jb(b,2048);break d}e=Hb(g,f);s=d,t=Lb(e),j[s+40>>2]=t;s=d,t=Mb(e),j[s+24>>2]=t;if(!rb(d+40|0,d+24|0)){break d}while(1){e=j[d+40>>2];rn(d+8|0,b);o=Pc(d+8|0);q=Bf(d+8|0);r=pi(d+8|0);m=k[d+8|0];if((m-1&255)>>>0<=106){h[e|0]=m+13}h[e+1|0]=k[o|0];h[e+3|0]=k[q|0];h[e+5|0]=k[r|0];_i(e);lk(d+40|0);if(rb(d+40|0,d+24|0)){continue}break}}f=f+1|0;if(f>>>0<k[d+379|0]){continue}break}}if(!(c&2)){break c}e=1;c=Kc(d+40|0,8,1,0,0);if(!l[a+480190>>1]){break c}while(1){$f(c,(p(e&65535,104)+a|0)+484380|0,b);e=e+1|0;if(l[a+480190>>1]>=(e&65535)>>>0){continue}break}}e=1}Za=d+384|0;return e|0}a=D()|0;C()|0;gb(d+24|0);G(a|0);z()}function T5(a,b){var c=0,d=q(0),e=q(0),f=0,g=q(0),h=q(0),i=q(0),j=0,k=0,l=0,m=0,o=q(0),r=q(0),s=0,t=q(0),u=q(0),v=q(0),w=q(0),x=q(0),y=q(0),z=q(0);j=Za-128|0;if((b|0)>=1){while(1){k=(s<<2)+a|0;f=0;c=j;l=c;while(1){r=n[p(31-f|0,72)+k>>2];m=p(f,72)+k|0;g=n[m>>2];h=q(r+g);e=n[m+1152>>2];d=n[p(15-f|0,72)+k>>2];i=q(e+d);n[l>>2]=h+i;m=p(f,12)+49056|0;g=q(n[m+4>>2]*q(g-r));e=q(n[m>>2]*q(d-e));n[l+64>>2]=g+e;d=n[m+8>>2];n[l+32>>2]=d*q(h-i);n[l+96>>2]=q(g-e)*d;l=l+4|0;f=f+1|0;if((f|0)!=8){continue}break}f=0;while(1){t=n[c+28>>2];u=n[c>>2];v=q(t+u);w=n[c+16>>2];x=n[c+12>>2];y=q(w+x);o=q(v+y);z=n[c+24>>2];r=n[c+4>>2];h=q(z+r);i=n[c+20>>2];g=n[c+8>>2];e=q(i+g);d=q(h+e);n[c>>2]=o+d;n[c+16>>2]=q(o-d)*q(.7071067690849304);o=q(v-y);d=q(q(o+q(h-e))*q(.7071067690849304));n[c+24>>2]=q(o-d)*q(1.3065630197525024);n[c+8>>2]=q(d+o)*q(.5411961078643799);e=q(r-z);d=q(g-i);i=q(q(e+d)*q(.7071067690849304));h=q(u-t);g=q(i+h);e=q(h+e);d=q(q(q(x-w)+d)+q(e*q(-.1989123672246933)));e=q(q(d*q(.3826834261417389))+e);n[c+28>>2]=q(g-e)*q(2.562915563583374);n[c+4>>2]=q(e+g)*q(.509795606136322);e=q(d+q(e*q(-.1989123672246933)));d=q(h-i);n[c+20>>2]=q(e+d)*q(.8999761939048767);n[c+12>>2]=q(d-e)*q(.601344883441925);c=c+32|0;f=f+1|0;if((f|0)!=4){continue}break}f=0;g=n[j+32>>2];d=n[j+96>>2];h=n[j+64>>2];while(1){c=k;n[c>>2]=n[(f<<2)+j>>2];f=f+1|0;k=(f<<2)+j|0;e=n[k+96>>2];i=q(e+d);n[c+72>>2]=i+h;d=n[k+32>>2];n[c+144>>2]=d+g;h=n[k- -64>>2];n[c+216>>2]=i+h;k=c+288|0;g=d;d=e;if((f|0)!=7){continue}break}n[c+288>>2]=n[j+28>>2];e=n[j+124>>2];n[c+360>>2]=e+n[j+92>>2];d=n[j+60>>2];n[c+504>>2]=e;n[c+432>>2]=d;s=s+1|0;if((s|0)!=(b|0)){continue}break}}}function iva(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;b=Za-48|0;Za=b;w=j[a+16>>2];l=j[a+44>>2];j[b+32>>2]=l;o=j[a+48>>2];j[b+36>>2]=o;k=j[a+52>>2];j[b+40>>2]=k;g=j[a+56>>2];j[b+44>>2]=g;r=j[a+40>>2];s=j[a+36>>2];e=j[a+4>>2];m=j[a>>2];j[b+24>>2]=m;j[b+28>>2]=e;f=j[a+12>>2];j[b+16>>2]=j[a+8>>2];j[b+20>>2]=f;a:{if(!d){f=r>>12;n=s>>12;break a}while(1){e=(((e&2147483647)<<1|m>>>31)&-2)+w|0;f=(m>>>21&2040)+27888|0;m=i[f+6>>1];g=i[f+4>>1];n=i[f+2>>1];q=i[f>>1];l=0;o=1;k=1;f=0;while(1){j[(b+8|0)+(f<<2)>>2]=(((p(h[e+f|0],n)+p(h[e+(f|-2)|0],q)|0)+p(g,h[e+(f|2)|0])|0)+p(m,h[e+(f|4)|0])<<8)/16384;t=k&1;k=0;f=1;if(t){continue}break}while(1){k=(b+8|0)+(l<<2)|0;m=j[k>>2];g=j[a+60>>2];n=g;f=(b+32|0)+(l<<3)|0;q=j[f>>2];e=Gb(q,-16777216,16776704);t=j[a+64>>2];l=Gb(j[f+4>>2],-16777216,16776704);u=j[a+68>>2];x=u;u=u>>31;j[f+4>>2]=q;q=j[a+72>>2];v=g>>31;m=m<<8;g=m;g=HMa(n,v,g,g>>31);n=ab;v=k;k=g;g=HMa(t,t>>31,e,e>>31);k=k+g|0;e=ab+n|0;e=k>>>0<g>>>0?e+1|0:e;g=k;k=HMa(x,u,l,l>>31);l=g+k|0;e=ab+e|0;e=l>>>0<k>>>0?e+1|0:e;l=l+8388608|0;if(l>>>0<8388608){e=e+1|0}e=(e&16777215)<<8|l>>>24;j[v>>2]=(e|0)/256;j[f>>2]=e-(m&q);l=1;e=o&1;o=0;if(e){continue}break}e=j[a+32>>2];s=j[a+28>>2]+s|0;n=s>>12;j[c>>2]=j[c>>2]+p(n,j[b+8>>2]);r=e+r|0;f=r>>12;j[c+4>>2]=j[c+4>>2]+p(f,j[b+12>>2]);Bb(b+24|0,b+16|0);d=d-1|0;if(d){c=c+8|0;m=j[b+24>>2];e=j[b+28>>2];continue}break}m=j[b+24>>2];e=j[b+28>>2];g=j[b+44>>2];k=j[b+40>>2];o=j[b+36>>2];l=j[b+32>>2]}j[a+40>>2]=r;j[a+20>>2]=n;j[a+36>>2]=s;j[a+56>>2]=g;j[a+52>>2]=k;j[a+48>>2]=o;j[a+44>>2]=l;j[a+24>>2]=f;j[a>>2]=m;j[a+4>>2]=e;Za=b+48|0}function Pg(a,b,c){var d=0,e=0,f=0,g=0,m=0;g=Za-16|0;Za=g;a:{if((b|0)==189){h[a+3843|0]=c>>>7;h[a+3844|0]=c>>>6&1;break a}d=b&224;if(!d){if((b|0)!=8){if((b|0)!=260){break a}d=1;b=0;while(1){e=p(b>>>0<3?b:b+6|0,44)+a|0;f=e+148|0;e=e+16|0;m=c&d;b:{if(m){Om(e,f);break b}Om(e,0)}h[f+40|0]=!m;d=d<<1&510;b=b+1|0;if((b|0)!=6){continue}break}break a}h[a+3842|0]=c>>>6&1;b=0;while(1){Hx((p(b,44)+a|0)+16|0);b=b+1|0;if((b|0)!=18){continue}break}break a}if((d-160&65535)>>>0<=32){d=b&15;if(d>>>0>8){break a}d=(p(b&256?d+9|0:d,44)+a|0)+16|0;j[g+8>>2]=d;e=j[d+36>>2];j[g+12>>2]=e;a=1;f=e?2:1;c:{b=b&240;if((b|0)!=160){if((b|0)==192){break c}if((b|0)!=176){break a}a=c&32;SL(d,a>>>5|0);m=c>>>2&7;RL(d,m);c=c&3;QL(d,c);if(!e){break a}b=1;d=f>>>0>1?f:1;f=(a|0)!=0;while(1){a=j[(g+8|0)+(b<<2)>>2];SL(a,f);RL(a,m);QL(a,c);b=b+1|0;if((d|0)!=(b|0)){continue}break}break a}PL(d,c);if(!e){break a}b=f>>>0>1?f:1;while(1){PL(j[(g+8|0)+(a<<2)>>2],c);a=a+1|0;if((b|0)!=(a|0)){continue}break}break a}h[d+42|0]=(c&32)>>>5;h[d+41|0]=(c&16)>>>4;a=c>>>1&7;i[d+30>>1]=a?9-a|0:0;i[d+32>>1]=c&1;break a}if((d|0)!=224?d>>>0>=129:0){break a}f=b&31;if(-4144960>>>f&1){break a}e=a;a=h[f+19888|0];a=(e+p(b&256?a+18|0:a,84)|0)+808|0;d:{switch(d-32>>>5|0){case 0:h[a+79|0]=c>>>7;h[a+80|0]=(c&64)>>>6;h[a+78|0]=(c&32)>>>5;h[a+77|0]=(c&16)>>>4;Pm(a);i[a+14>>1]=l[((c&15)<<1)+19920>>1];break a;case 1:i[a+68>>1]=k[(c>>>6|0)+19952|0];OL(a);i[a+22>>1]=(c&63)<<2;break a;case 2:i[a+24>>1]=c>>>4;Pm(a);i[a+26>>1]=c&15;Pm(a);break a;case 3:b=c>>>4|0;i[a+28>>1]=b>>>0<15?b<<4:496;i[a+30>>1]=c&15;Pm(a);break a;case 6:break d;default:break a}}i[a+12>>1]=c&7}Za=g+16|0}function kia(a,b){var c=0,d=0,e=0,f=0,g=0,i=0;a:{b:{e=j[b>>2];c:{if(!e){d=b;break c}if(!j[b+4>>2]){d=b;break b}d=mP(b);e=j[d>>2];if(e){break b}}e=j[d+4>>2];if(e){break b}e=0;g=1;break a}j[e+8>>2]=j[d+8>>2];g=0}d:{e:{if(Rg(d)){j[j[d+8>>2]>>2]=e;if((a|0)==(d|0)){a=e;c=0;break d}c=j[d+8>>2]+4|0;break e}j[j[d+8>>2]+4>>2]=e;c=j[d+8>>2]}c=j[c>>2]}i=!k[d+12|0];if((b|0)!=(d|0)){j[d+8>>2]=j[b+8>>2];f:{if(Rg(b)){f=j[d+8>>2];break f}f=j[d+8>>2]+4|0}j[f>>2]=d;f=j[b>>2];j[d>>2]=f;an(f,d);f=j[b+4>>2];j[d+4>>2]=f;if(f){an(f,d)}h[d+12|0]=k[b+12|0];a=(a|0)==(b|0)?d:a}if(!(i|!a)){if(g){while(1){d=Rg(c);b=k[c+12|0];g:{h:{if(!d){if(!b){h[c+12|0]=1;h[j[c+8>>2]+12|0]=0;gp(j[c+8>>2]);b=j[c>>2];a=(b|0)==(a|0)?c:a;c=j[b+4>>2]}d=j[c>>2];i:{j:{k:{if(!(k[d+12|0]?0:d)){b=j[c+4>>2];if(k[b+12|0]?0:b){break k}h[c+12|0]=0;l:{b=j[c+8>>2];if((b|0)!=(a|0)){if(k[b+12|0]){break l}a=b}h[a+12|0]=1;return}if(!Rg(b)){break h}b=j[b+8>>2]+4|0;break g}b=j[c+4>>2];if(!b){break j}}if(!k[b+12|0]){break i}}h[d+12|0]=1;h[c+12|0]=0;fp(c);c=j[c+8>>2]}h[c+12|0]=k[j[c+8>>2]+12|0];h[j[c+8>>2]+12|0]=1;h[j[c+4>>2]+12|0]=1;gp(j[c+8>>2]);return}if(!b){h[c+12|0]=1;h[j[c+8>>2]+12|0]=0;fp(j[c+8>>2]);b=j[c+4>>2];a=(b|0)==(a|0)?c:a;c=j[b>>2]}d=j[c>>2];m:{if(k[d+12|0]?0:d){break m}b=j[c+4>>2];if(!(k[b+12|0]?0:b)){h[c+12|0]=0;b=j[c+8>>2];if(!(k[b+12|0]?(b|0)!=(a|0):0)){h[b+12|0]=1;return}if(Rg(b)){b=j[b+8>>2]+4|0;break g}b=j[b+8>>2];break g}if(d){if(!k[d+12|0]){break m}b=j[c+4>>2]}h[b+12|0]=1;h[c+12|0]=0;gp(c);c=j[c+8>>2]}h[c+12|0]=k[j[c+8>>2]+12|0];h[j[c+8>>2]+12|0]=1;h[j[c>>2]+12|0]=1;fp(j[c+8>>2]);return}b=j[b+8>>2]}c=j[b>>2];continue}}h[e+12|0]=1}}function nua(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;g=Za-48|0;Za=g;s=j[a+16>>2];h=vf(g+16|0);j[h+8>>2]=a+112;j[h+16>>2]=j[a+128>>2];w=h,x=qf(b+327720|0,j[b+20>>2],(j[a+88>>2]&16384)>>>14|0),j[w+12>>2]=x;b=j[h+16>>2];if(b){w=h,x=uf(a+8|0,b),j[w>>2]=x;j[h+4>>2]=ab}m=j[a+48>>2];n=j[a+40>>2];o=j[a+36>>2];b=j[a+44>>2];f=j[a+4>>2];e=j[a>>2];j[g+8>>2]=e;j[g+12>>2]=f;q=j[a+12>>2];j[g>>2]=j[a+8>>2];j[g+4>>2]=q;a:{if(!d){k=n>>12;l=o>>12;break a}while(1){q=b;b=0;k=b;j[g+40>>2]=e;j[g+44>>2]=b;f=(f<<1)+s|0;b:{b=j[h+16>>2];if((b|0)<=0){break b}while(1){id(j[h+8>>2],i[(k<<1)+f>>1]/4<<16>>16);hd(j[h+8>>2],4);Bb(g+40|0,h);if((b|0)<2){break b}b=b-1|0;k=j[g+44>>2];continue}}d=d-1|0;b=j[h+8>>2];Bb(b,b+8|0);b=j[h+8>>2];e=j[b+4>>2];if(e){id(b,i[f+(j[g+44>>2]<<1)>>1]/4<<16>>16);hd(j[h+8>>2],e);b=j[h+8>>2];e=j[b>>2];j[b>>2]=e;j[b+4>>2]=0}e=pf(b,j[h+12>>2]);k=j[a+60>>2];b=Gb(q,-16777216,16776704);l=j[a+64>>2];f=Gb(m,-16777216,16776704);t=j[a+72>>2];u=j[a+32>>2];m=c;v=j[c>>2];r=e<<8;e=r;e=HMa(k,k>>31,e,e>>31);k=ab;l=HMa(l,l>>31,b,b>>31);e=l+e|0;b=ab+k|0;b=e>>>0<l>>>0?b+1|0:b;k=e;e=j[a+68>>2];e=HMa(e,e>>31,f,f>>31);f=k+e|0;b=ab+b|0;b=f>>>0<e>>>0?b+1|0:b;f=f+8388608|0;if(f>>>0<8388608){b=b+1|0}f=(b&16777215)<<8|f>>>24;b=(f|0)/256|0;o=j[a+28>>2]+o|0;l=o>>12;j[m>>2]=p(b,l)+v;n=n+u|0;k=n>>12;j[c+4>>2]=j[c+4>>2]+p(b,k);b=f-(t&r)|0;Bb(g+8|0,g);if(d){c=c+8|0;e=j[g+8>>2];f=j[g+12>>2];m=q;continue}break}e=j[g+8>>2];f=j[g+12>>2];m=q}j[a+40>>2]=n;j[a+20>>2]=l;j[a+36>>2]=o;j[a+48>>2]=m;j[a+44>>2]=b;j[a+24>>2]=k;j[a>>2]=e;j[a+4>>2]=f;Za=g+48|0}



function Tza(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,i=0,j=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,u=0;d=Za-16|0;Za=d;a:{if(!yb(a,2)){Wf(c+484344|0,b,64);break a}m=c+484344|0;i=kd(up(a),1,1024);if(!Wf(m,b,i)|!i){break a}n=l[c+480188>>1];while(1){r=Fp(Hb(m,b),j);g=0;if(n){while(1){rn(d+8|0,a);e=Pc(d+8|0);s=Bf(d+8|0);c=p(g,6)+r|0;f=k[pi(d+8|0)|0];h[c+5|0]=f;o=0;q=k[d+8|0];if((q-1&255)>>>0<=35){h[c|0]=q+48;o=k[e|0]+1|0}e=c+5|0;h[c+1|0]=o;b:{c:{d:{switch(k[s|0]){case 1:h[c+3|0]=2;h[e|0]=f&15;break b;case 2:h[c+3|0]=3;h[e|0]=f&15;break b;case 12:if(!f){break b}h[c+3|0]=1;break b;case 13:if(!f){break b}h[c+3|0]=36;h[d+7|0]=15;t=e,u=k[Zb(d+7|0,e)|0]|16,h[t|0]=u;break b;case 30:if(!f){break b}h[c+3|0]=35;h[d+6|0]=15;t=e,u=k[Zb(d+6|0,e)|0]|16,h[t|0]=u;break b;case 21:if(!f){break b}h[c+3|0]=36;h[d+5|0]=15;t=e,u=k[Zb(d+5|0,e)|0]|80,h[t|0]=u;break b;case 17:if(!f){break b}h[c+3|0]=35;h[d+4|0]=15;t=e,u=k[Zb(d+4|0,e)|0]|80,h[t|0]=u;break b;case 15:h[c+3|0]=19;h[e|0]=(f|0)!=0;break b;case 25:h[c+3|0]=12;break b;case 27:ys(c);h[c|0]=255;break b;case 28:h[c+3|0]=16;break b;case 31:h[c+3|0]=11;e:{f:{g:{switch(f>>>4|0){case 4:if((f|0)==64){break f}h[e|0]=f&15;break b;case 5:h[e|0]=f<<4;break b;case 6:h[d+3|0]=f&15;h[d+2|0]=14;t=e,u=k[Zb(d+3|0,d+2|0)|0]|240,h[t|0]=u;break b;case 0:case 1:case 2:case 3:break f;case 7:break g;default:break e}}h[d+1|0]=f&15;h[d|0]=14;t=e,u=k[Zb(d+1|0,d)|0]<<4|15,h[t|0]=u;break b}h[c+4|0]=f;h[c+2|0]=1}h[c+3|0]=0;break c;case 0:break c;default:break d}}h[c+3|0]=0}h[e|0]=0}g=g+1|0;if((n|0)!=(g|0)){continue}break}}j=j+1|0;if((j|0)!=(i|0)){continue}break}}Za=d+16|0}function Gr(a,b,c){var d=0,e=0,f=0,g=0,h=0,i=0,k=0,l=0,n=0,o=0;f=Za-160|0;Za=f;a:{b:{c:{d:{e:{f:{g:{h:{if(!c){break h}d=j[c+4>>2];if(!d&m[c>>2]>=Wg(b)>>>0|d){break h}b=R(8)|0;j[114630]=0;E(214,b|0,20525)|0;a=j[114630];j[114630]=0;if((a|0)!=1){break g}a=D()|0;C()|0;S(b|0);break a}if(!j[b>>2]){b=R(8)|0;j[114630]=0;E(1399,b|0,20525)|0;a=j[114630];j[114630]=0;if((a|0)!=1){break f}a=D()|0;C()|0;S(b|0);break a}k=zna(f+136|0,ah(f+128|0,b));i:{j:{if(a&2){d=to(f+104|0,k);j[114630]=0;g=E(1400,d|0,c|0)|0;e=j[114630];j[114630]=0;d=1;if((e|0)==1){break i}if((g|0)==1){break j}e=to(f+80|0,k);j[114630]=0;e=E(1401,e|0,c|0)|0;h=j[114630];j[114630]=0;if((h|0)==1){break e}l=(e|0)==1;if(l){break j}h=to(f+56|0,k);j[114630]=0;h=E(1402,h|0,c|0)|0;i=j[114630];j[114630]=0;if((i|0)==1){break d}n=(h|0)==1;if(n){break j}i=to(f+32|0,k);j[114630]=0;i=E(1403,i|0,c|0)|0;o=j[114630];j[114630]=0;if((o|0)==1){break c}if((i|0)==1){break j}d=(g|0)==-1?-1:0;d=l?d:(e|0)==-1?-1:d;g=(i|0)==-1?-1:n?d:(h|0)==-1?-1:d}if(a&1){a=77952;while(1){d=j[a>>2];if(d){e=to(f+8|0,k);j[114630]=0;e=E(d|0,e|0,c|0)|0;d=j[114630];j[114630]=0;if((d|0)==1){break b}d=1;if((e|0)==1){break j}g=(e|0)==-1?-1:g}a=a+12|0;if((a|0)!=78408){continue}break}}if(c){d=0;if((g|0)!=-1){break j}a=j[c+4>>2];c=j[c>>2];j[114630]=0;a=ig(446,c,a);c=j[114630];j[114630]=0;if((c|0)!=1){d=Wg(b)>>>0<a>>>0?-1:0;break j}a=D()|0;C()|0;break a}d=0;if((g|0)!=-1){break j}d=Wg(b)>>>0>2047?1:-1}Za=f+160|0;return d}a=D()|0;C()|0;break a}X(b|0,71672,24);z()}X(b|0,71568,24);z()}a=D()|0;C()|0;break a}a=D()|0;C()|0;break a}a=D()|0;C()|0;break a}a=D()|0;C()|0}G(a|0);z()}function Wja(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0;c=Za-144|0;Za=c;e=Gk(c+40|0,a);j[114630]=0;d=E(683,c+24|0,32299)|0;a=j[114630];j[114630]=0;a:{b:{c:{d:{e:{f:{g:{h:{i:{j:{k:{l:{m:{n:{if((a|0)!=1){j[114630]=0;j[c>>2]=19466242;j[c+4>>2]=0;I(684,e|0,d|0,c|0);a=j[114630];j[114630]=0;if((a|0)==1){break n}qb(d);if(j[e>>2]&1073741824){break e}j[114630]=0;d=E(683,c+24|0,32304)|0;a=j[114630];j[114630]=0;if((a|0)==1){break m}j[114630]=0;P(1564,e|0,b|0,d|0,1565)|0;a=j[114630];j[114630]=0;if((a|0)==1){break l}qb(d);j[114630]=0;j[c+20>>2]=0;j[c+16>>2]=0;d=E(683,c+24|0,32309)|0;a=j[114630];j[114630]=0;if((a|0)==1){break k}j[114630]=0;K(1566,e|0,c+20|0,d|0)|0;a=j[114630];j[114630]=0;if((a|0)==1){break j}qb(d);j[114630]=0;d=E(683,c+24|0,32314)|0;a=j[114630];j[114630]=0;if((a|0)==1){break i}j[114630]=0;K(1566,e|0,c+16|0,d|0)|0;a=j[114630];j[114630]=0;if((a|0)==1){break h}qb(d);ika(b,j[c+20>>2],j[c+16>>2]);d=hx(c+24|0);j[114630]=0;f=E(683,c|0,32319)|0;a=j[114630];j[114630]=0;if((a|0)==1){break d}j[114630]=0;P(1567,e|0,d|0,f|0,674)|0;a=j[114630];j[114630]=0;if((a|0)==1){break g}qb(f);if(Xc(d)){break f}j[114630]=0;I(1568,d|0,j[c+20>>2],16777216);a=j[114630];j[114630]=0;if((a|0)!=1){break f}break c}a=D()|0;C()|0;break a}a=D()|0;C()|0;qb(d);break a}a=D()|0;C()|0;break a}a=D()|0;C()|0;qb(d);break a}a=D()|0;C()|0;break a}a=D()|0;C()|0;qb(d);break a}a=D()|0;C()|0;break a}a=D()|0;C()|0;qb(d);break a}a=D()|0;C()|0;qb(f);break b}j[114630]=0;F(1569,b|0,d|0);a=j[114630];j[114630]=0;if((a|0)==1){break c}Ud(d)}ag(e);Za=c+144|0;return}a=D()|0;C()|0;break b}a=D()|0;C()|0}Ud(d)}ag(e);G(a|0);z()}function QGa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0;d=Za-96|0;Za=d;b=b&4095;i[d+94>>1]=b;a:{b:{c:{d:{e:{f:{g:{if(b>>>0>=81){e=((b|0)==4095?c:b-80|0)+734016|0;c=HMa(e,e>>31,1e4,0)+14780|0;b=ab;b=IMa(c,c>>>0<14780?b+1|0:b,3652425,0);c=(((((b|0)/-4|0)+e|0)+p(b,-365)|0)+((b|0)/100|0)|0)+((b|0)/-400|0)|0;if((c|0)<=-1){b=b-1|0;c=(((e+((b|0)/-4|0)|0)+p(b,-365)|0)+((b|0)/100|0)|0)+((b|0)/-400|0)|0}e=Db(d- -64|0,13390);j[114630]=0;F(219,d+80|0,e|0);f=j[114630];j[114630]=0;h=(p(c,100)+52|0)/3060|0;h:{i:{j:{k:{l:{m:{n:{o:{if((f|0)!=1){j[114630]=0;g=b;b=h+2|0;f=(b|0)/12|0;j[d+44>>2]=g+f;F(191,d+48|0,d+44|0);g=j[114630];j[114630]=0;if((g|0)==1){break o}j[114630]=0;j[d+28>>2]=(b-p(f,12)|0)+1;F(193,d+32|0,d+28|0);b=j[114630];j[114630]=0;if((b|0)==1){break n}j[114630]=0;j[d+12>>2]=(((p(h,306)+5|0)/-10|0)+c|0)+1;F(193,d+16|0,d+12|0);b=j[114630];j[114630]=0;if((b|0)==1){break m}j[114630]=0;V(619,a|0,d+80|0,d+48|0,d+32|0,d+16|0);a=j[114630];j[114630]=0;if((a|0)==1){break l}gb(d+16|0);gb(d+32|0);gb(d+48|0);qb(d+80|0);gb(e);break g}b=D()|0;C()|0;break h}b=D()|0;C()|0;break i}b=D()|0;C()|0;break j}b=D()|0;C()|0;break k}b=D()|0;C()|0;gb(d+16|0)}gb(d+32|0)}gb(d+48|0)}qb(d+80|0)}gb(e);break a}c=Db(d,13414);j[114630]=0;F(219,d+80|0,c|0);b=j[114630];j[114630]=0;if((b|0)==1){break f}j[114630]=0;F(620,d+48|0,d+94|0);b=j[114630];j[114630]=0;if((b|0)==1){break e}j[114630]=0;I(247,a|0,d+80|0,d+48|0);a=j[114630];j[114630]=0;if((a|0)==1){break d}gb(d+48|0);qb(d+80|0);gb(c)}Za=d+96|0;return}b=D()|0;C()|0;break b}b=D()|0;C()|0;break c}b=D()|0;C()|0;gb(d+48|0)}qb(d+80|0)}gb(c)}G(b|0);z()}function vB(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=Za-128|0;Za=c;a:{b:{c:{d:{e:{f:{g:{h:{i:{j:{k:{b=j[b>>2];l:{if(!b){Db(a,7037);break l}if(!(b&65535)){e=Db(c+96|0,7045);j[114630]=0;F(219,c+112|0,e|0);d=j[114630];j[114630]=0;m:{n:{o:{p:{q:{r:{if((d|0)!=1){j[114630]=0;j[c+24>>2]=b>>>24;F(220,c+80|0,c+24|0);d=j[114630];j[114630]=0;if((d|0)==1){break r}j[114630]=0;j[c+8>>2]=b>>>16&255;F(221,c- -64|0,c+8|0);b=j[114630];j[114630]=0;if((b|0)==1){break q}j[114630]=0;L(222,a|0,c+112|0,c+80|0,c- -64|0);a=j[114630];j[114630]=0;if((a|0)==1){break p}gb(c- -64|0);gb(c+80|0);qb(c+112|0);gb(e);break l}b=D()|0;C()|0;break m}b=D()|0;C()|0;break n}b=D()|0;C()|0;break o}b=D()|0;C()|0;gb(c- -64|0)}gb(c+80|0)}qb(c+112|0)}break a}e=Db(c+48|0,7051);j[114630]=0;F(219,c+112|0,e|0);d=j[114630];j[114630]=0;if((d|0)==1){break k}j[114630]=0;j[c+44>>2]=b>>>24;F(220,c+80|0,c+44|0);d=j[114630];j[114630]=0;if((d|0)==1){break j}j[114630]=0;j[c+40>>2]=b>>>16&255;F(221,c- -64|0,c+40|0);d=j[114630];j[114630]=0;if((d|0)==1){break i}j[114630]=0;j[c+20>>2]=b>>>8&255;F(221,c+24|0,c+20|0);d=j[114630];j[114630]=0;if((d|0)==1){break h}j[114630]=0;j[c+4>>2]=b&255;F(221,c+8|0,c+4|0);b=j[114630];j[114630]=0;if((b|0)==1){break g}j[114630]=0;aa(223,a|0,c+112|0,c+80|0,c- -64|0,c+24|0,c+8|0);a=j[114630];j[114630]=0;if((a|0)==1){break f}gb(c+8|0);gb(c+24|0);gb(c- -64|0);gb(c+80|0);qb(c+112|0);gb(e)}Za=c+128|0;return}b=D()|0;C()|0;break a}b=D()|0;C()|0;break b}b=D()|0;C()|0;break c}b=D()|0;C()|0;break d}b=D()|0;C()|0;break e}b=D()|0;C()|0;gb(c+8|0)}gb(c+24|0)}gb(c- -64|0)}gb(c+80|0)}qb(c+112|0)}gb(e);G(b|0);z()}function U0(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;var f=0,g=0,h=0,i=0,k=0,l=0,m=0;f=Za-384|0;Za=f;j[f+376>>2]=37;j[f+380>>2]=0;g=vq(f+376|1,64457,j[c+4>>2]);j[f+332>>2]=f+336;a=Wd();a:{if(g){h=j[c+8>>2];o[f+40>>3]=e;j[f+32>>2]=h;a=Je(f+336|0,30,a,f+376|0,f+32|0);break a}o[f+48>>3]=e;a=Je(f+336|0,30,a,f+376|0,f+48|0)}j[f+80>>2]=2421;h=yd(f+320|0,0,f+80|0);b:{c:{d:{if((a|0)>=30){e:{if(g){j[114630]=0;a=T(2446)|0;g=j[114630];j[114630]=0;if((g|0)==1){break c}j[f>>2]=j[c+8>>2];j[114630]=0;o[f+8>>3]=e;a=P(2468,f+332|0,a|0,f+376|0,f|0)|0;g=j[114630];j[114630]=0;if((g|0)!=1){break e}break c}j[114630]=0;a=T(2446)|0;g=j[114630];j[114630]=0;if((g|0)==1){break c}o[f+16>>3]=e;j[114630]=0;a=P(2468,f+332|0,a|0,f+376|0,f+16|0)|0;g=j[114630];j[114630]=0;if((g|0)==1){break c}}g=j[f+332>>2];if(!g){j[114630]=0;M(2422);a=j[114630];j[114630]=0;if((a|0)==1){break c}break d}fe(h,g)}g=j[f+332>>2];k=g+a|0;l=Sf(g,k,c);j[f+68>>2]=2421;i=yd(f+72|0,0,f+68|0);f:{g:{if(j[f+332>>2]==(f+336|0)){a=f+80|0;g=f+336|0;break g}a=Yc(a<<3);if(!a){j[114630]=0;M(2422);a=j[114630];j[114630]=0;if((a|0)!=1){break d}c=D()|0;C()|0;break f}fe(i,a);g=j[f+332>>2]}j[114630]=0;hc(f+56|0,c);m=j[114630];j[114630]=0;h:{i:{if((m|0)!=1){j[114630]=0;Z(2479,g|0,l|0,k|0,a|0,f+68|0,f- -64|0,f+56|0);g=j[114630];j[114630]=0;if((g|0)==1){break i}wb(f+56|0);j[114630]=0;a=_(2480,b|0,a|0,j[f+68>>2],j[f+64>>2],c|0,d|0)|0;b=j[114630];j[114630]=0;if((b|0)==1){break h}mc(i);mc(h);Za=f+384|0;return a|0}c=D()|0;C()|0;break f}c=D()|0;C()|0;wb(f+56|0);break f}c=D()|0;C()|0}mc(i);break b}z()}c=D()|0;C()|0}mc(h);G(c|0);z()}function e1(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;var f=0,g=0,h=0,i=0,k=0,l=0,m=0;f=Za-208|0;Za=f;j[f+200>>2]=37;j[f+204>>2]=0;g=vq(f+200|1,64457,j[c+4>>2]);j[f+156>>2]=f+160;a=Wd();a:{if(g){h=j[c+8>>2];o[f+40>>3]=e;j[f+32>>2]=h;a=Je(f+160|0,30,a,f+200|0,f+32|0);break a}o[f+48>>3]=e;a=Je(f+160|0,30,a,f+200|0,f+48|0)}j[f+80>>2]=2421;h=yd(f+144|0,0,f+80|0);b:{c:{d:{if((a|0)>=30){e:{if(g){j[114630]=0;a=T(2446)|0;g=j[114630];j[114630]=0;if((g|0)==1){break c}j[f>>2]=j[c+8>>2];j[114630]=0;o[f+8>>3]=e;a=P(2468,f+156|0,a|0,f+200|0,f|0)|0;g=j[114630];j[114630]=0;if((g|0)!=1){break e}break c}j[114630]=0;a=T(2446)|0;g=j[114630];j[114630]=0;if((g|0)==1){break c}o[f+16>>3]=e;j[114630]=0;a=P(2468,f+156|0,a|0,f+200|0,f+16|0)|0;g=j[114630];j[114630]=0;if((g|0)==1){break c}}g=j[f+156>>2];if(!g){j[114630]=0;M(2422);a=j[114630];j[114630]=0;if((a|0)==1){break c}break d}fe(h,g)}g=j[f+156>>2];k=g+a|0;l=Sf(g,k,c);j[f+68>>2]=2421;i=yd(f+72|0,0,f+68|0);f:{g:{if(j[f+156>>2]==(f+160|0)){a=f+80|0;g=f+160|0;break g}a=Yc(a<<1);if(!a){j[114630]=0;M(2422);a=j[114630];j[114630]=0;if((a|0)!=1){break d}c=D()|0;C()|0;break f}fe(i,a);g=j[f+156>>2]}j[114630]=0;hc(f+56|0,c);m=j[114630];j[114630]=0;h:{i:{if((m|0)!=1){j[114630]=0;Z(2469,g|0,l|0,k|0,a|0,f+68|0,f- -64|0,f+56|0);g=j[114630];j[114630]=0;if((g|0)==1){break i}wb(f+56|0);j[114630]=0;a=_(17,b|0,a|0,j[f+68>>2],j[f+64>>2],c|0,d|0)|0;b=j[114630];j[114630]=0;if((b|0)==1){break h}mc(i);mc(h);Za=f+208|0;return a|0}c=D()|0;C()|0;break f}c=D()|0;C()|0;wb(f+56|0);break f}c=D()|0;C()|0}mc(i);break b}z()}c=D()|0;C()|0}mc(h);G(c|0);z()}function oua(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,i=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;g=Za-48|0;Za=g;s=j[a+16>>2];i=vf(g+16|0);j[i+8>>2]=a+112;j[i+16>>2]=j[a+128>>2];w=i,x=qf(b+327720|0,j[b+20>>2],(j[a+88>>2]&16384)>>>14|0),j[w+12>>2]=x;b=j[i+16>>2];if(b){w=i,x=uf(a+8|0,b),j[w>>2]=x;j[i+4>>2]=ab}m=j[a+48>>2];n=j[a+40>>2];o=j[a+36>>2];b=j[a+44>>2];f=j[a+4>>2];e=j[a>>2];j[g+8>>2]=e;j[g+12>>2]=f;q=j[a+12>>2];j[g>>2]=j[a+8>>2];j[g+4>>2]=q;a:{if(!d){k=n>>12;l=o>>12;break a}while(1){q=b;b=0;k=b;j[g+40>>2]=e;j[g+44>>2]=b;f=f+s|0;b:{b=j[i+16>>2];if((b|0)<=0){break b}while(1){id(j[i+8>>2],h[f+k|0]<<6);hd(j[i+8>>2],4);Bb(g+40|0,i);if((b|0)<2){break b}b=b-1|0;k=j[g+44>>2];continue}}d=d-1|0;b=j[i+8>>2];Bb(b,b+8|0);b=j[i+8>>2];e=j[b+4>>2];if(e){id(b,h[f+j[g+44>>2]|0]<<6);hd(j[i+8>>2],e);b=j[i+8>>2];e=j[b>>2];j[b>>2]=e;j[b+4>>2]=0}e=pf(b,j[i+12>>2]);k=j[a+60>>2];b=Gb(q,-16777216,16776704);l=j[a+64>>2];f=Gb(m,-16777216,16776704);t=j[a+72>>2];u=j[a+32>>2];m=c;v=j[c>>2];r=e<<8;e=r;e=HMa(k,k>>31,e,e>>31);k=ab;l=HMa(l,l>>31,b,b>>31);e=l+e|0;b=ab+k|0;b=e>>>0<l>>>0?b+1|0:b;k=e;e=j[a+68>>2];e=HMa(e,e>>31,f,f>>31);f=k+e|0;b=ab+b|0;b=f>>>0<e>>>0?b+1|0:b;f=f+8388608|0;if(f>>>0<8388608){b=b+1|0}f=(b&16777215)<<8|f>>>24;b=(f|0)/256|0;o=j[a+28>>2]+o|0;l=o>>12;j[m>>2]=p(b,l)+v;n=n+u|0;k=n>>12;j[c+4>>2]=j[c+4>>2]+p(b,k);b=f-(t&r)|0;Bb(g+8|0,g);if(d){c=c+8|0;e=j[g+8>>2];f=j[g+12>>2];m=q;continue}break}e=j[g+8>>2];f=j[g+12>>2];m=q}j[a+40>>2]=n;j[a+20>>2]=l;j[a+36>>2]=o;j[a+48>>2]=m;j[a+44>>2]=b;j[a+24>>2]=k;j[a>>2]=e;j[a+4>>2]=f;Za=g+48|0}function o1(a,b,c,d,e){var f=0,g=0;f=Za-384|0;Za=f;j[f+368>>2]=b;j[f+376>>2]=a;Qu(f+216|0,c,f+240|0,f+236|0,f+232|0);b=Cb(f+200|0);a=sc(b);j[114630]=0;F(149,b|0,a|0);a=j[114630];j[114630]=0;a:{b:{if((a|0)!=1){a=Ub(b,0);j[f+196>>2]=a;j[f+28>>2]=f+32;j[f+24>>2]=0;h[f+23|0]=1;h[f+22|0]=69;while(1){c:{j[114630]=0;c=E(2455,f+376|0,f+368|0)|0;g=j[114630];j[114630]=0;if((g|0)==1){break c}if(!c){break b}if(j[f+196>>2]==(nb(b)+a|0)){c=nb(b);a=nb(b);j[114630]=0;F(149,b|0,a<<1);a=j[114630];j[114630]=0;if((a|0)==1){break a}a=sc(b);j[114630]=0;F(149,b|0,a|0);a=j[114630];j[114630]=0;if((a|0)==1){break a}a=Ub(b,0);j[f+196>>2]=c+a}j[114630]=0;c=H(2457,f+376|0)|0;g=j[114630];j[114630]=0;if((g|0)==1){break c}j[114630]=0;c=wq(c,f+23|0,f+22|0,a,f+196|0,j[f+236>>2],j[f+232>>2],f+216|0,f+32|0,f+28|0,f+24|0,f+240|0);g=j[114630];j[114630]=0;if((g|0)==1){break c}if(c){break b}j[114630]=0;H(2459,f+376|0)|0;c=j[114630];j[114630]=0;if((c|0)!=1){continue}}break}break a}break a}d:{if(!nb(f+216|0)|!k[f+23|0]){break d}c=j[f+28>>2];if((c-(f+32|0)|0)>159){break d}j[f+28>>2]=c+4;j[c>>2]=j[f+24>>2]}j[114630]=0;L(2444,f|0,a|0,j[f+196>>2],d|0);a=j[114630];j[114630]=0;e:{if((a|0)==1){break e}a=j[f+8>>2];c=j[f+12>>2];g=j[f+4>>2];j[e>>2]=j[f>>2];j[e+4>>2]=g;j[e+8>>2]=a;j[e+12>>2]=c;j[114630]=0;le(f+216|0,f+32|0,j[f+28>>2],d);a=j[114630];j[114630]=0;if((a|0)==1){break e}j[114630]=0;a=E(2456,f+376|0,f+368|0)|0;c=j[114630];j[114630]=0;if((c|0)==1){break e}if(a){j[d>>2]=j[d>>2]|2}a=j[f+376>>2];gb(b);gb(f+216|0);Za=f+384|0;return a}}a=D()|0;C()|0;gb(b);gb(f+216|0);G(a|0);z()}function L1(a,b,c,d,e){var f=0,g=0;f=Za-288|0;Za=f;j[f+272>>2]=b;j[f+280>>2]=a;Su(f+224|0,c,f+240|0,f+239|0,f+238|0);b=Cb(f+208|0);a=sc(b);j[114630]=0;F(149,b|0,a|0);a=j[114630];j[114630]=0;a:{b:{if((a|0)!=1){a=Ub(b,0);j[f+204>>2]=a;j[f+28>>2]=f+32;j[f+24>>2]=0;h[f+23|0]=1;h[f+22|0]=69;while(1){c:{j[114630]=0;c=E(2423,f+280|0,f+272|0)|0;g=j[114630];j[114630]=0;if((g|0)==1){break c}if(!c){break b}if(j[f+204>>2]==(nb(b)+a|0)){c=nb(b);a=nb(b);j[114630]=0;F(149,b|0,a<<1);a=j[114630];j[114630]=0;if((a|0)==1){break a}a=sc(b);j[114630]=0;F(149,b|0,a|0);a=j[114630];j[114630]=0;if((a|0)==1){break a}a=Ub(b,0);j[f+204>>2]=c+a}j[114630]=0;c=H(2425,f+280|0)|0;g=j[114630];j[114630]=0;if((g|0)==1){break c}j[114630]=0;c=yq(c,f+23|0,f+22|0,a,f+204|0,h[f+239|0],h[f+238|0],f+224|0,f+32|0,f+28|0,f+24|0,f+240|0);g=j[114630];j[114630]=0;if((g|0)==1){break c}if(c){break b}j[114630]=0;H(2427,f+280|0)|0;c=j[114630];j[114630]=0;if((c|0)!=1){continue}}break}break a}break a}d:{if(!nb(f+224|0)|!k[f+23|0]){break d}c=j[f+28>>2];if((c-(f+32|0)|0)>159){break d}j[f+28>>2]=c+4;j[c>>2]=j[f+24>>2]}j[114630]=0;L(2444,f|0,a|0,j[f+204>>2],d|0);a=j[114630];j[114630]=0;e:{if((a|0)==1){break e}a=j[f+8>>2];c=j[f+12>>2];g=j[f+4>>2];j[e>>2]=j[f>>2];j[e+4>>2]=g;j[e+8>>2]=a;j[e+12>>2]=c;j[114630]=0;le(f+224|0,f+32|0,j[f+28>>2],d);a=j[114630];j[114630]=0;if((a|0)==1){break e}j[114630]=0;a=E(2424,f+280|0,f+272|0)|0;c=j[114630];j[114630]=0;if((c|0)==1){break e}if(a){j[d>>2]=j[d>>2]|2}a=j[f+280>>2];gb(b);gb(f+224|0);Za=f+288|0;return a}}a=D()|0;C()|0;gb(b);gb(f+224|0);G(a|0);z()}function zva(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;b=Za-48|0;Za=b;v=j[a+16>>2];n=j[a+44>>2];j[b+32>>2]=n;f=j[a+48>>2];j[b+36>>2]=f;l=j[a+52>>2];j[b+40>>2]=l;m=j[a+56>>2];j[b+44>>2]=m;o=j[a+40>>2];q=j[a+36>>2];e=j[a+4>>2];k=j[a>>2];j[b+24>>2]=k;j[b+28>>2]=e;g=j[a+12>>2];j[b+16>>2]=j[a+8>>2];j[b+20>>2]=g;a:{if(!d){g=o>>12;h=q>>12;break a}while(1){f=k>>>18|0;n=1;e=((((e&2147483647)<<1|k>>>31)&2147483646)<<1)+v|0;g=0;l=1;h=0;while(1){m=h<<1;k=i[m+e>>1];j[(b+8|0)+(h<<2)>>2]=k+((p(f,i[e+(m|4)>>1]-k|0)|0)/16384|0);k=l&1;l=0;h=1;if(k){continue}break}while(1){h=(b+8|0)+(g<<2)|0;l=j[h>>2];f=j[a+60>>2];m=f;k=(b+32|0)+(g<<3)|0;r=j[k>>2];e=Gb(r,-16777216,16776704);u=j[a+64>>2];g=Gb(j[k+4>>2],-16777216,16776704);s=j[a+68>>2];w=s;s=s>>31;j[k+4>>2]=r;r=j[a+72>>2];t=f>>31;l=l<<8;f=l;f=HMa(m,t,f,f>>31);m=ab;t=h;h=f;f=HMa(u,u>>31,e,e>>31);h=h+f|0;e=ab+m|0;e=h>>>0<f>>>0?e+1|0:e;f=h;h=HMa(w,s,g,g>>31);g=f+h|0;e=ab+e|0;e=g>>>0<h>>>0?e+1|0:e;g=g+8388608|0;if(g>>>0<8388608){e=e+1|0}e=(e&16777215)<<8|g>>>24;j[t>>2]=(e|0)/256;j[k>>2]=e-(l&r);g=1;e=n&1;n=0;if(e){continue}break}e=j[a+32>>2];q=j[a+28>>2]+q|0;h=q>>12;j[c>>2]=j[c>>2]+p(h,j[b+8>>2]);o=e+o|0;g=o>>12;j[c+4>>2]=j[c+4>>2]+p(g,j[b+12>>2]);Bb(b+24|0,b+16|0);d=d-1|0;if(d){c=c+8|0;k=j[b+24>>2];e=j[b+28>>2];continue}break}k=j[b+24>>2];e=j[b+28>>2];m=j[b+44>>2];l=j[b+40>>2];f=j[b+36>>2];n=j[b+32>>2]}j[a+40>>2]=o;j[a+20>>2]=h;j[a+36>>2]=q;j[a+56>>2]=m;j[a+52>>2]=l;j[a+48>>2]=f;j[a+44>>2]=n;j[a+24>>2]=g;j[a>>2]=k;j[a+4>>2]=e;Za=b+48|0}function Yua(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;h=Za-16|0;Za=h;a:{b:{c:{l=j[a+8>>2];g=j[a+12>>2];d:{if((g|0)<1?1:(g|0)<=1?l>>>0<=805306368:0){if((g|0)>-2?1:(g|0)>=-2?l>>>0>=3489660928:0){break c}if((g|0)>-2?1:(g|0)>=-2?l>>>0>2147483647:0){break d}break b}if((g|0)>1?1:(g|0)>=1?l>>>0>2147483648:0){break b}}o=b+196648|0;break a}o=b+131112|0;break a}o=b+262184|0}s=j[a+16>>2];f=j[a+48>>2];t=j[a+24>>2];u=j[a+20>>2];m=j[a+44>>2];e=j[a+4>>2];k=j[a>>2];j[h+8>>2]=k;j[h+12>>2]=e;j[h>>2]=l;j[h+4>>2]=g;e:{if(!d){b=m;m=f;break e}while(1){b=(k>>>16&65520)+o|0;g=i[b>>1];e=(e<<1)+s|0;k=i[e-6>>1];l=i[b+2>>1];v=i[e-4>>1];w=i[b+4>>1];x=i[e-2>>1];y=i[b+6>>1];z=i[e>>1];A=i[b+8>>1];B=i[e+2>>1];C=i[b+10>>1];D=i[e+4>>1];E=i[b+12>>1];F=i[e+6>>1];G=i[b+14>>1];e=i[e+8>>1];r=j[a+60>>2];b=Gb(m,-16777216,16776704);n=j[a+64>>2];f=Gb(f,-16777216,16776704);H=j[a+72>>2];I=j[c>>2];b=HMa(n,n>>31,b,b>>31);n=ab;q=b;k=(((((((p(l,v)+p(g,k)|0)+p(w,x)|0)+p(y,z)|0)+p(A,B)|0)+p(C,D)|0)+p(E,F)|0)+p(e,G)|0)/32768<<8;b=k;g=HMa(r,r>>31,b,b>>31);e=q+g|0;b=ab+n|0;b=e>>>0<g>>>0?b+1|0:b;q=e;e=j[a+68>>2];e=HMa(e,e>>31,f,f>>31);f=q+e|0;b=ab+b|0;b=e>>>0>f>>>0?b+1|0:b;f=f+8388608|0;if(f>>>0<8388608){b=b+1|0}b=(b&16777215)<<8|f>>>24;f=(b|0)/256|0;j[c>>2]=p(f,u)+I;j[c+4>>2]=j[c+4>>2]+p(f,t);b=b-(k&H)|0;Bb(h+8|0,h);d=d-1|0;if(d){c=c+8|0;k=j[h+8>>2];e=j[h+12>>2];f=m;m=b;continue}break}k=j[h+8>>2];e=j[h+12>>2]}j[a+48>>2]=m;j[a+44>>2]=b;j[a>>2]=k;j[a+4>>2]=e;Za=h+16|0}function Zua(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0;k=Za-16|0;Za=k;a:{b:{c:{l=j[a+8>>2];g=j[a+12>>2];d:{if((g|0)<1?1:(g|0)<=1?l>>>0<=805306368:0){if((g|0)>-2?1:(g|0)>=-2?l>>>0>=3489660928:0){break c}if((g|0)>-2?1:(g|0)>=-2?l>>>0>2147483647:0){break d}break b}if((g|0)>1?1:(g|0)>=1?l>>>0>2147483648:0){break b}}q=b+196648|0;break a}q=b+131112|0;break a}q=b+262184|0}s=j[a+16>>2];f=j[a+48>>2];t=j[a+24>>2];u=j[a+20>>2];n=j[a+44>>2];e=j[a+4>>2];m=j[a>>2];j[k+8>>2]=m;j[k+12>>2]=e;j[k>>2]=l;j[k+4>>2]=g;e:{if(!d){b=n;n=f;break e}while(1){b=e+s|0;g=h[b+4|0];e=(m>>>16&65520)+q|0;m=i[e+14>>1];l=h[b+3|0];v=i[e+12>>1];w=h[b+2|0];x=i[e+10>>1];y=h[b+1|0];z=i[e+8>>1];A=h[b|0];B=i[e+6>>1];C=h[b-1|0];D=i[e+4>>1];E=h[b-2|0];F=i[e+2>>1];G=h[b-3|0];e=i[e>>1];b=j[a+60>>2];H=b;I=b>>31;b=Gb(n,-16777216,16776704);o=j[a+64>>2];f=Gb(f,-16777216,16776704);J=j[a+72>>2];K=j[c>>2];b=HMa(o,o>>31,b,b>>31);o=ab;L=b;b=j[a+68>>2];r=HMa(b,b>>31,f,f>>31);f=L+r|0;b=ab+o|0;b=f>>>0<r>>>0?b+1|0:b;e=(((((((p(E,F)+p(e,G)|0)+p(C,D)|0)+p(A,B)|0)+p(y,z)|0)+p(w,x)|0)+p(l,v)|0)+p(g,m)<<8)/32768<<8;g=HMa(H,I,e,e>>31);f=f+g|0;b=ab+b|0;b=f>>>0<g>>>0?b+1|0:b;f=f+8388608|0;if(f>>>0<8388608){b=b+1|0}b=(b&16777215)<<8|f>>>24;f=(b|0)/256|0;j[c>>2]=p(f,u)+K;j[c+4>>2]=j[c+4>>2]+p(f,t);b=b-(e&J)|0;Bb(k+8|0,k);d=d-1|0;if(d){c=c+8|0;m=j[k+8>>2];e=j[k+12>>2];f=n;n=b;continue}break}m=j[k+8>>2];e=j[k+12>>2]}j[a+48>>2]=n;j[a+44>>2]=b;j[a>>2]=m;j[a+4>>2]=e;Za=k+16|0}function nCa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,i=0,j=0,l=0,m=0,n=0,o=0,p=0;g=Za-16|0;Za=g;if(c){o=b,p=dd(a),h[o|0]=p;j=b+1|0;l=c-1|0;a:{if(!l){break a}while(1){b:{c:{d=f<<1;f=d&254;d:{if(!f){if(!re(a,g+15|0)){break a}d=k[g+15|0]<<1|1;f=d&255;if(d>>>0>255){break d}break c}if((d&65535)>>>0<256){break c}}i=1;while(1){e:{f:{g:{e=f<<1&254;d=f>>>0>127;h:{if(e){break h}if(!re(a,g+14|0)){break g}d=k[g+14|0]<<1|1;e=d&255;d=d>>>0>255}i=d|i<<1;f=e<<1&254;if(f){break f}if(!re(a,g+13|0)){break g}d=k[g+13|0]<<1|1;f=d&255;if(d>>>0>255){continue}break e}f=0;break e}if(e>>>0>127){continue}}break}i:{if((i|0)<=2){n=0;i=i-2|0;break i}if(!re(a,g+12|0)){break a}d=(k[g+12|0]|i<<8)-768|0;n=((d|0)>1279?2:1)+((d|0)>31999)|0;m=d^-1;i=0}e=f<<1&254;d=f>>>0>127;j:{if(e){break j}if(!re(a,g+11|0)){break a}d=k[g+11|0]<<1|1;e=d&255;d=d>>>0>255}f=e<<1&254;e=e>>>0>127;k:{if(f){break k}if(!re(a,g+10|0)){break a}e=k[g+10|0]<<1|1;f=e&255;e=e>>>0>255}e=e|(i<<2|(d?2:0));if(!e){i=1;while(1){l:{m:{n:{e=f<<1&254;d=f>>>0>127;o:{if(e){break o}if(!re(a,g+9|0)){break n}d=k[g+9|0]<<1|1;e=d&255;d=d>>>0>255}i=d|i<<1;f=e<<1&254;if(f){break m}if(!re(a,g+8|0)){break n}d=k[g+8|0]<<1|1;f=d&255;if(d>>>0>255){continue}break l}f=0;break l}if(e>>>0>127){continue}}break}e=i+2|0}if((m|0)>-1){break a}e=e+n|0;if(l>>>0<e>>>0|(e|0)<1|((j-b|0)+m|0)<0){break a}i=j+m|0;l=l-e|0;while(1){h[j|0]=k[i|0];j=j+1|0;i=i+1|0;d=(e|0)>1;e=e-1|0;if(d){continue}break}break b}if(!re(a,j)){break a}l=l-1|0;j=j+1|0}if(l){continue}break}}a=(j-b|0)==(c|0)}else{a=0}Za=g+16|0;return a|0}function Ava(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,i=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;b=Za-48|0;Za=b;t=j[a+16>>2];l=j[a+44>>2];j[b+32>>2]=l;n=j[a+48>>2];j[b+36>>2]=n;k=j[a+52>>2];j[b+40>>2]=k;m=j[a+56>>2];j[b+44>>2]=m;o=j[a+40>>2];q=j[a+36>>2];e=j[a+4>>2];i=j[a>>2];j[b+24>>2]=i;j[b+28>>2]=e;g=j[a+12>>2];j[b+16>>2]=j[a+8>>2];j[b+20>>2]=g;a:{if(!d){g=o>>12;f=q>>12;break a}while(1){l=i>>>10&4194048;e=(((e&2147483647)<<1|i>>>31)&-2)+t|0;f=0;n=1;k=1;g=0;while(1){i=h[e+g|0];j[(b+8|0)+(g<<2)>>2]=((p(l,h[e+(g|2)|0]-i|0)|0)/16384|0)+(i<<8);i=k&1;k=0;g=1;if(i){continue}break}while(1){k=(b+8|0)+(f<<2)|0;l=j[k>>2];m=j[a+60>>2];i=(b+32|0)+(f<<3)|0;f=j[i>>2];e=Gb(f,-16777216,16776704);s=j[a+64>>2];g=Gb(j[i+4>>2],-16777216,16776704);r=j[a+68>>2];u=r;r=r>>31;j[i+4>>2]=f;v=j[a+72>>2];l=l<<8;f=l;f=HMa(m,m>>31,f,f>>31);m=ab;w=k;k=HMa(s,s>>31,e,e>>31);f=k+f|0;e=ab+m|0;e=f>>>0<k>>>0?e+1|0:e;k=f;f=HMa(u,r,g,g>>31);g=k+f|0;e=ab+e|0;e=g>>>0<f>>>0?e+1|0:e;g=g+8388608|0;if(g>>>0<8388608){e=e+1|0}e=(e&16777215)<<8|g>>>24;j[w>>2]=(e|0)/256;j[i>>2]=e-(l&v);f=1;e=n&1;n=0;if(e){continue}break}e=j[a+32>>2];q=j[a+28>>2]+q|0;f=q>>12;j[c>>2]=j[c>>2]+p(f,j[b+8>>2]);o=e+o|0;g=o>>12;j[c+4>>2]=j[c+4>>2]+p(g,j[b+12>>2]);Bb(b+24|0,b+16|0);d=d-1|0;if(d){c=c+8|0;i=j[b+24>>2];e=j[b+28>>2];continue}break}i=j[b+24>>2];e=j[b+28>>2];m=j[b+44>>2];k=j[b+40>>2];n=j[b+36>>2];l=j[b+32>>2]}j[a+40>>2]=o;j[a+20>>2]=f;j[a+36>>2]=q;j[a+56>>2]=m;j[a+52>>2]=k;j[a+48>>2]=n;j[a+44>>2]=l;j[a+24>>2]=g;j[a>>2]=i;j[a+4>>2]=e;Za=b+48|0}function j6(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,i=0,l=0,m=0,n=0,o=0,q=0,r=0;f=Za-17168|0;Za=f;j[f+17164>>2]=0;a:{b:{c:{if(k[a+6152|0]!=255|(c|0)<5){break c}if(!eo(a+6152|0,b)){break c}i=Jv(b,j[a+6148>>2])+co(b)|0;j[f+17164>>2]=i;if((c|0)==(i|0)){i=c;break b}d:{if((i+4|0)<=(c|0)){if(eo(b,b+i|0)){break d}}j[f+17164>>2]=0;break c}if(i){break b}}g=i6(b,c,Ab(a,0,6668)+6148|0,f+17164|0);i=j[f+17164>>2];if((g+i|0)<=(c|0)?i:0){break b}j[e>>2]=g;g=0;break a}c=b+g|0;j[a+6152>>2]=k[c|0]|k[c+1|0]<<8|(k[c+2|0]<<16|k[c+3|0]<<24);j[e+4>>2]=g;j[e>>2]=g+i;j[e+8>>2]=k[c+3|0]>191?1:2;q=e,r=cF(c),j[q+12>>2]=r;j[e+16>>2]=4-(k[c+1|0]>>>1&3);q=e,r=Iv(c),j[q+20>>2]=r;if(!d){g=Hv(c);break a}bF(f+17152|0,c+4|0,i-4|0);if(!(h[c+1|0]&1)){Bd(f+17152|0,16)}e:{if(j[e+16>>2]==3){g=0;b=g6(f+17152|0,f+3740|0,c);if(!((b|0)<0|j[f+17156>>2]>j[f+17160>>2])){i=f6(a,f+17152|0,f+912|0,b);if(i){l=a+2304|0;g=j[e+8>>2];m=f+8620|0;n=f+3852|0;b=0;while(1){o=Ab(n,0,4608);e6(a,f+912|0,(p(p(b,g),28)+f|0)+3740|0,g);$E(l,o,18,j[e+8>>2],d,m);g=j[e+8>>2];d=p(g,1152)+d|0;b=b+1|0;if(b>>>0<(k[c+1|0]&8?2:1)>>>0){continue}break}}d6(a,f+912|0);break e}Kv(a);break a}c6(c,f+17152|0,f);g=0;b=Ab(f+3852|0,0,4608);i=a+2304|0;l=f+8620|0;c=0;f:{while(1){c=b6(((c<<2)+f|0)+3852|0,f+17152|0,f,j[e+16>>2]|1)+c|0;if((c|0)==12){a6(f,(g<<2)+f|0,b);$E(i,b,12,j[e+8>>2],d,l);Ab(b,0,4608);d=p(j[e+8>>2],768)+d|0;c=0}if(j[f+17156>>2]<=j[f+17160>>2]){g=g+1|0;if((g|0)==3){break f}continue}break}Kv(a);g=0;break a}i=1}g=p(Hv(a+6152|0),i)}Za=f+17168|0;return g|0}function Vqa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,n=0;e=Za-48|0;Za=e;md(b,2);ek(e+16|0,2,a+1|0);qc(e+32|0,e+16|0);j[114630]=0;E(370,b+43|0,e+32|0)|0;d=j[114630];j[114630]=0;if((d|0)!=1){gb(e+32|0);a:{if(!(k[a|0]?k[a|0]!=1:0)){if(k[a|0]==1){d=a+16|0;j[b>>2]=k[d|0]|k[d+1|0]<<8|(k[d+2|0]<<16|k[d+3|0]<<24);d=a+20|0;j[e+32>>2]=k[d|0]|k[d+1|0]<<8|(k[d+2|0]<<16|k[d+3|0]<<24);j[e+16>>2]=j[b>>2]-1;g=b,n=j[tb(e+32|0,e+16|0)>>2],j[g+4>>2]=n;d=a+24|0;j[e+32>>2]=k[d|0]|k[d+1|0]<<8|(k[d+2|0]<<16|k[d+3|0]<<24);g=b,n=j[tb(e+32|0,b)>>2],j[g+8>>2]=n;i[b+34>>1]=l[b+34>>1]&65533|k[a+31|0]<<1&2}d=j[b+8>>2];if(d>>>0>m[b+4>>2]?d>>>0>=2:0){break a}i[b+34>>1]=0;j[b+4>>2]=0;j[b+8>>2]=0;break a}if(k[a|0]!=2){break a}$g(e+16|0,a+16|0);d=e+32|0;f=j[e+16>>2];f=k[f|0]|k[f+1|0]<<8|(k[f+2|0]<<16|k[f+3|0]<<24);h[d|0]=f;h[d+1|0]=f>>>8;h[d+2|0]=f>>>16;h[d+3|0]=f>>>24;$g(e+16|0,a+20|0);d=e+32|0;f=j[e+16>>2];f=k[f|0]|k[f+1|0]<<8|(k[f+2|0]<<16|k[f+3|0]<<24);h[d+4|0]=f;h[d+5|0]=f>>>8;h[d+6|0]=f>>>16;h[d+7|0]=f>>>24;$g(e+16|0,a+24|0);d=e+32|0;f=j[e+16>>2];f=k[f|0]|k[f+1|0]<<8|(k[f+2|0]<<16|k[f+3|0]<<24);h[d+8|0]=f;h[d+9|0]=f>>>8;h[d+10|0]=f>>>16;h[d+11|0]=f>>>24;j[e+8>>2]=j[e+40>>2];d=j[e+36>>2];j[e>>2]=j[e+32>>2];j[e+4>>2]=d;Ro(b,1,e)}h[e+32|0]=k[a+28|0];h[e+16|0]=64;g=b,n=k[Zb(e+32|0,e+16|0)|0]<<2,i[g+30>>1]=n;a=a+32|0;a=k[a|0]|k[a+1|0]<<8|(k[a+2|0]<<16|k[a+3|0]<<24);a=c?a&65535:a;j[b+24>>2]=a;b:{c:{if(!a){c=8363;break c}c=1024;if(a>>>0>1023){break b}}j[b+24>>2]=c}Za=e+48|0;return}a=D()|0;C()|0;gb(e+32|0);G(a|0);z()}function ZK(a,b,c){var d=0,e=0,f=0,g=0,h=0,i=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0;h=Za-16|0;Za=h;a:{if((b|0)==(c|0)){break a}j[h+12>>2]=-1953789045;XK(b,c,h+12|0);d=c-b>>2;j[h+8>>2]=d;o=sb(a);g=o+1|0;j[h+4>>2]=g;l=j[Lc(h+4|0,h+8|0)>>2];k=j[((j[h+8>>2]<<2)+b|0)-4>>2];c=d;e=c;f=11;b:{if(c>>>0>622){break b}f=7;if(d>>>0>67){break b}f=5;if(d>>>0>38){break b}f=3;if(d>>>0>6){break b}f=d-1>>>1|0}m=e-f>>>1|0;c=(m<<2)+b|0;e=p(Tr(k^(j[c>>2]^j[b>>2])),1664525);j[c>>2]=e+j[c>>2];q=m+f|0;c=(q<<2)+b|0;d=c;f=j[c>>2];c=e+o|0;j[d>>2]=f+c;j[b>>2]=c;if(o){n=j[h+8>>2];c=1;while(1){e=c-1|0;d=((c+m>>>0)%(n>>>0)<<2)+b|0;f=(c>>>0)%(n>>>0)|0;i=(f<<2)+b|0;r=p(Tr(j[((e>>>0)%(n>>>0)<<2)+b>>2]^(j[d>>2]^j[i>>2])),1664525);j[d>>2]=r+j[d>>2];d=xb(a,e);n=j[h+8>>2];e=((c+q>>>0)%(n>>>0)<<2)+b|0;k=e;s=j[e>>2];e=j[d>>2]+(f+r|0)|0;j[k>>2]=s+e;j[i>>2]=e;c=c+1|0;if(o>>>0>=c>>>0){continue}break}}c=j[h+8>>2];if(g>>>0<l>>>0){while(1){a=((g+m>>>0)%(c>>>0)<<2)+b|0;d=(g>>>0)%(c>>>0)|0;e=(d<<2)+b|0;i=p(Tr(j[((g-1>>>0)%(c>>>0)<<2)+b>>2]^(j[a>>2]^j[e>>2])),1664525);j[a>>2]=i+j[a>>2];c=j[h+8>>2];a=((g+q>>>0)%(c>>>0)<<2)+b|0;f=a;k=j[a>>2];a=d+i|0;j[f>>2]=k+a;j[e>>2]=a;g=g+1|0;if((l|0)!=(g|0)){continue}break}}if(c+l>>>0<=l>>>0){break a}g=l;while(1){a=((g+m>>>0)%(c>>>0)<<2)+b|0;d=(g>>>0)%(c>>>0)|0;e=(d<<2)+b|0;i=p(Tr(j[((g-1>>>0)%(c>>>0)<<2)+b>>2]+(j[a>>2]+j[e>>2]|0)|0),1566083941);j[a>>2]=i^j[a>>2];c=j[h+8>>2];a=((g+q>>>0)%(c>>>0)<<2)+b|0;f=a;k=j[a>>2];a=i-d|0;j[f>>2]=k^a;j[e>>2]=a;g=g+1|0;if(g>>>0<c+l>>>0){continue}break}}Za=h+16|0}function Rsa(a,b,c){var d=0,e=0,f=0,g=0;d=Za-160|0;Za=d;f=Gk(d+56|0,a);j[114630]=0;e=E(683,d+8|0,18638)|0;a=j[114630];j[114630]=0;a:{b:{c:{d:{if((a|0)!=1){j[114630]=0;j[d+48>>2]=19466242;j[d+52>>2]=0;I(684,f|0,e|0,d+48|0);a=j[114630];j[114630]=0;if((a|0)==1){break d}qb(e);if(!(j[f>>2]&1073741824)){break c}break a}a=D()|0;C()|0;break b}a=D()|0;C()|0;qb(e);break b}j[114630]=0;h[d+48|0]=0;h[d+47|0]=0;e=E(683,d+8|0,18630)|0;a=j[114630];j[114630]=0;e:{if((a|0)!=1){j[114630]=0;K(1182,f|0,d+48|0,e|0)|0;a=j[114630];j[114630]=0;if((a|0)==1){break e}qb(e);if(!k[d+48|0]){break a}ze(d+48|0,50);j[114630]=0;e=E(683,d+8|0,18646)|0;a=j[114630];j[114630]=0;f:{g:{h:{i:{if((a|0)!=1){j[114630]=0;K(1182,f|0,d+47|0,e|0)|0;a=j[114630];j[114630]=0;if((a|0)==1){break i}qb(e);e=rh(b);a=k[d+48|0];if(e>>>0<a>>>0){e=Kx(d+8|0,j[b+12>>2]);j[114630]=0;I(1183,b|0,a|0,e|0);a=j[114630];j[114630]=0;if((a|0)==1){break h}hl(e)}e=l[ei(b,0)+28>>1];h[d+7|0]=0;if(k[d+48|0]){a=0;while(1){Fe(ei(b,a&255),e);a=ei(b,k[d+7|0]);j[114630]=0;F(1184,d+8|0,d+7|0);g=j[114630];j[114630]=0;if((g|0)==1){break g}j[114630]=0;L(1185,f|0,a|0,d+8|0,c|0);a=j[114630];j[114630]=0;if((a|0)==1){break f}qb(d+8|0);a=k[d+7|0]+1|0;h[d+7|0]=a;if(k[d+48|0]>(a&255)>>>0){continue}break}}a=k[d+47|0];c=rh(b);h[b+16|0]=a>>>0<c>>>0?k[d+47|0]:0;break a}a=D()|0;C()|0;break b}a=D()|0;C()|0;qb(e);break b}a=D()|0;C()|0;hl(e);break b}a=D()|0;C()|0;break b}a=D()|0;C()|0;qb(d+8|0);break b}a=D()|0;C()|0;break b}a=D()|0;C()|0;qb(e)}ag(f);G(a|0);z()}ag(f);Za=d+160|0}function z$(a,b,c,d,e,f,g,i,l,m,n,o,p,q,r){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;i=i|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;var s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;x=Za-16|0;Za=x;j[c>>2]=a;A=d&512;while(1){if((y|0)==4){if(nb(q)>>>0>1){C=x,D=nd(q),j[C+8>>2]=D;C=c,D=cj(So(x+8|0,1),tj(q),j[c>>2]),j[C>>2]=D}d=d&176;if((d|0)!=16){if((d|0)==32){a=j[c>>2]}j[b>>2]=a}Za=x+16|0}else{a:{b:{switch(h[l+y|0]){case 0:j[b>>2]=j[c>>2];break a;case 1:j[b>>2]=j[c>>2];t=Aq(g,32);s=j[c>>2];j[c>>2]=s+4;j[s>>2]=t;break a;case 3:if(Ec(q)){break a}t=j[Ni(q,0)>>2];s=j[c>>2];j[c>>2]=s+4;j[s>>2]=t;break a;case 2:if(Ec(p)|!A){break a}C=c,D=cj(nd(p),tj(p),j[c>>2]),j[C>>2]=D;break a;case 4:break b;default:break a}}B=j[c>>2];e=i?e+4|0:e;u=e;while(1){c:{if(f>>>0<=u>>>0){break c}if(!zj(g,2048,j[u>>2])){break c}u=u+4|0;continue}break}t=r;if((t|0)>=1){while(1){s=(t|0)<1;if(!(s|e>>>0>=u>>>0)){u=u-4|0;s=j[u>>2];v=j[c>>2];j[c>>2]=v+4;j[v>>2]=s;t=t-1|0;continue}break}if(s){s=0}else{s=Aq(g,48)}while(1){v=j[c>>2];j[c>>2]=v+4;if((t|0)>=1){j[v>>2]=s;t=t-1|0;continue}break}j[v>>2]=m}d:{if((e|0)==(u|0)){t=Aq(g,48);s=j[c>>2];u=s+4|0;j[c>>2]=u;j[s>>2]=t;break d}s=-1;e:{if(Ec(o)){break e}s=h[Ub(o,0)|0]}t=0;w=0;while(1){if((e|0)!=(u|0)){f:{if((t|0)!=(s|0)){v=t;break f}s=j[c>>2];j[c>>2]=s+4;j[s>>2]=n;v=0;w=w+1|0;if(nb(o)>>>0<=w>>>0){s=t;break f}if(k[Ub(o,w)|0]==127){s=-1;break f}s=h[Ub(o,w)|0]}u=u-4|0;t=j[u>>2];z=j[c>>2];j[c>>2]=z+4;j[z>>2]=t;t=v+1|0;continue}break}u=j[c>>2]}Sn(B,u)}y=y+1|0;continue}break}}function lva(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;e=Za-48|0;Za=e;s=j[a+16>>2];b=j[a+44>>2];j[e+32>>2]=b;h=j[a+48>>2];j[e+36>>2]=h;f=j[a+52>>2];j[e+40>>2]=f;n=j[a+56>>2];j[e+44>>2]=n;t=j[a+24>>2];u=j[a+20>>2];g=j[a+4>>2];k=j[a>>2];j[e+24>>2]=k;j[e+28>>2]=g;l=j[a+12>>2];j[e+16>>2]=j[a+8>>2];j[e+20>>2]=l;if(d){while(1){n=1;l=((((g&2147483647)<<1|k>>>31)&2147483646)<<1)+s|0;b=(k>>>21&2040)+27888|0;k=i[b+6>>1];m=i[b+4>>1];r=i[b+2>>1];o=i[b>>1];f=0;b=1;h=0;while(1){g=h<<1;j[(e+8|0)+(h<<2)>>2]=(((p(i[g+l>>1],r)+p(i[l+(g|-4)>>1],o)|0)+p(i[l+(g|4)>>1],m)|0)+p(k,i[l+(g|8)>>1])|0)/16384;g=b;b=0;h=1;if(g){continue}break}while(1){k=(e+8|0)+(f<<2)|0;l=j[k>>2];m=j[a+60>>2];g=(e+32|0)+(f<<3)|0;f=j[g>>2];b=Gb(f,-16777216,16776704);o=j[a+64>>2];h=Gb(j[g+4>>2],-16777216,16776704);q=j[a+68>>2];v=q;q=q>>31;j[g+4>>2]=f;w=j[a+72>>2];l=l<<8;f=l;f=HMa(m,m>>31,f,f>>31);m=ab;x=k;k=HMa(o,o>>31,b,b>>31);f=k+f|0;b=ab+m|0;b=f>>>0<k>>>0?b+1|0:b;r=f;f=HMa(v,q,h,h>>31);h=r+f|0;b=ab+b|0;b=f>>>0>h>>>0?b+1|0:b;h=h+8388608|0;if(h>>>0<8388608){b=b+1|0}b=(b&16777215)<<8|h>>>24;j[x>>2]=(b|0)/256;j[g>>2]=b-(l&w);f=1;b=n&1;n=0;if(b){continue}break}j[c>>2]=j[c>>2]+p(j[e+8>>2],u);j[c+4>>2]=j[c+4>>2]+p(j[e+12>>2],t);Bb(e+24|0,e+16|0);d=d-1|0;if(d){c=c+8|0;k=j[e+24>>2];g=j[e+28>>2];continue}break}k=j[e+24>>2];g=j[e+28>>2];n=j[e+44>>2];f=j[e+40>>2];h=j[e+36>>2];b=j[e+32>>2]}j[a+56>>2]=n;j[a+52>>2]=f;j[a+48>>2]=h;j[a+44>>2]=b;j[a>>2]=k;j[a+4>>2]=g;Za=e+48|0}function mw(a,b,c){var d=0,e=0,f=0,g=0,h=0;d=Za-208|0;Za=d;a:{b:{c:{if(k[c|0]&2){if(j[b>>2]==-2147483648){e=gj(d+48|0,1,45);b=j[b>>2];j[114630]=0;j[d+188>>2]=b;I(137,d+192|0,d+188|0,c|0);b=j[114630];j[114630]=0;d:{e:{if((b|0)!=1){j[114630]=0;I(138,a|0,e|0,d+192|0);a=j[114630];j[114630]=0;if((a|0)==1){break e}gb(d+192|0);gb(e);break b}c=D()|0;C()|0;break d}c=D()|0;C()|0;gb(d+192|0)}gb(e);break a}e=j[b>>2];if((e|0)>-1){break c}e=gj(d+48|0,1,45);b=j[b>>2];j[114630]=0;j[d+188>>2]=0-b;I(137,d+192|0,d+188|0,c|0);b=j[114630];j[114630]=0;f:{g:{if((b|0)!=1){j[114630]=0;I(138,a|0,e|0,d+192|0);a=j[114630];j[114630]=0;if((a|0)==1){break g}gb(d+192|0);gb(e);break b}c=D()|0;C()|0;break f}c=D()|0;C()|0;gb(d+192|0)}gb(e);break a}e=Mg(d+48|0);f=j[j[e>>2]-12>>2];j[114630]=0;g=T(122)|0;h=j[114630];j[114630]=0;h:{i:{j:{k:{l:{if((h|0)==1){break l}j[114630]=0;I(123,d+40|0,f+(d+48|0)|0,g|0);f=j[114630];j[114630]=0;if((f|0)==1){break l}wb(d+40|0);j[114630]=0;F(139,e|0,c|0);f=j[114630];j[114630]=0;if((f|0)==1){break l}j[114630]=0;F(124,e|0,b|0);b=j[114630];j[114630]=0;if((b|0)==1){break l}j[114630]=0;F(125,d+8|0,e|0);b=j[114630];j[114630]=0;if((b|0)==1){break l}j[114630]=0;I(140,d+24|0,d+8|0,c|0);b=j[114630];j[114630]=0;if((b|0)==1){break k}j[114630]=0;I(141,a|0,d+24|0,c|0);a=j[114630];j[114630]=0;if((a|0)==1){break j}gb(d+24|0);gb(d+8|0);Hd(e);break b}c=D()|0;C()|0;break h}c=D()|0;C()|0;break i}c=D()|0;C()|0;gb(d+24|0)}gb(d+8|0)}Hd(e);break a}j[d+48>>2]=e;tr(a,d+48|0,c)}Za=d+208|0;return}G(c|0);z()}function fna(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,i=0,n=0,o=0,q=0,r=0;c=Za-48|0;Za=c;d=l[a+480190>>1];h[c+32|0]=0;rL(b,d+1|0,c+32|0);if(l[a+480192>>1]){g=Rt(c+32|0);d=a+484344|0;q=c,r=Lb(d),j[q+24>>2]=r;q=c,r=Mb(d),j[q+16>>2]=r;if(rb(c+24|0,c+16|0)){while(1){a:{n=j[c+24>>2];if(!uh(n)){break a}d=l[a+480188>>1];j[114630]=0;h[c|0]=0;I(1419,g|0,d|0,c|0);d=j[114630];j[114630]=0;if((d|0)!=1){b:{q=c,r=Lb(n),j[q+8>>2]=r;o=0;if(!j[n+12>>2]){break a}while(1){f=0;c:{if(!l[a+480188>>1]){break c}while(1){d:{d=j[c+8>>2];j[114630]=0;d=H(553,d|0)|0;e=j[114630];j[114630]=0;if((e|0)==1){break d}e:{if(!d){break e}d=k[j[c+8>>2]+1|0];if(!k[j[c+8>>2]+1|0]){d=k[fc(g,f)|0]}e=d&255;if(e){f:{if(e>>>0>256){break f}e=j[((k[j[c+8>>2]+1|0]<<2)+a|0)+900380>>2];if(!e){break f}e=l[Nc(e+236|0,k[j[c+8>>2]]-1|0)>>1];if(e>>>0>l[a+480190>>1]){break f}Nd(c,b,e);Qd(c,1)}q=fc(g,f),r=d,h[q|0]=r;break e}d=l[a+480192>>1];if(!d){break e}e=d;while(1){i=j[((d<<2)+a|0)+900380>>2];g:{if(!i){break g}i=l[Nc(i+236|0,k[j[c+8>>2]]-1|0)>>1];if(i>>>0>l[a+480190>>1]){break g}Nd(c,b,i);Qd(c,1)}d=d-1|0;e=e-1|0;if(e&65535){continue}break}}lk(c+8|0);f=f+1|0;if(f>>>0<l[a+480188>>1]){continue}break c}break}break b}o=o+1|0;if(o>>>0<m[n+12>>2]){continue}break}break a}}a=D()|0;C()|0;Od(g);G(a|0);z()}Ax(c+24|0);if(rb(c+24|0,c+16|0)){continue}break}}d=l[a+480190>>1];h:{if(!d){f=0;break h}f=0;e=d;while(1){Nd(c,b,d);if(!kb(c)){f=ke((p(d,104)+a|0)+484380|0)+f|0}d=d-1|0;e=e-1|0;if(e&65535){continue}break}}Od(g)}Za=c+48|0;return f&65535}function D$(a,b,c,d,e,f,g,i,l,m,n,o,p,q,r){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;i=i|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;var s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;x=Za-16|0;Za=x;j[c>>2]=a;A=d&512;while(1){if((y|0)==4){if(nb(q)>>>0>1){C=x,D=nd(q),j[C+8>>2]=D;C=c,D=cj(af(x+8|0,1),_e(q),j[c>>2]),j[C>>2]=D}d=d&176;if((d|0)!=16){if((d|0)==32){a=j[c>>2]}j[b>>2]=a}Za=x+16|0;return}a:{b:{switch(h[l+y|0]){case 0:j[b>>2]=j[c>>2];break a;case 1:j[b>>2]=j[c>>2];t=sk(g,32);s=j[c>>2];j[c>>2]=s+1;h[s|0]=t;break a;case 3:if(Ec(q)){break a}t=k[Ub(q,0)|0];s=j[c>>2];j[c>>2]=s+1;h[s|0]=t;break a;case 2:if(Ec(p)|!A){break a}C=c,D=cj(nd(p),_e(p),j[c>>2]),j[C>>2]=D;break a;case 4:break b;default:break a}}B=j[c>>2];e=i?e+1|0:e;u=e;while(1){c:{if(f>>>0<=u>>>0){break c}if(!ng(g,2048,h[u|0])){break c}u=u+1|0;continue}break}t=r;if((t|0)>=1){while(1){s=(t|0)<1;if(!(s|e>>>0>=u>>>0)){u=u-1|0;s=k[u|0];v=j[c>>2];j[c>>2]=v+1;h[v|0]=s;t=t-1|0;continue}break}if(s){s=0}else{s=sk(g,48)}while(1){v=j[c>>2];j[c>>2]=v+1;if((t|0)>=1){h[v|0]=s;t=t-1|0;continue}break}h[v|0]=m}d:{if((e|0)==(u|0)){t=sk(g,48);s=j[c>>2];j[c>>2]=s+1;h[s|0]=t;break d}s=-1;e:{if(Ec(o)){break e}s=h[Ub(o,0)|0]}t=0;w=0;while(1){if((e|0)==(u|0)){break d}f:{if((t|0)!=(s|0)){v=t;break f}s=j[c>>2];j[c>>2]=s+1;h[s|0]=n;v=0;w=w+1|0;if(nb(o)>>>0<=w>>>0){s=t;break f}if(k[Ub(o,w)|0]==127){s=-1;break f}s=h[Ub(o,w)|0]}u=u-1|0;t=k[u|0];z=j[c>>2];j[c>>2]=z+1;h[z|0]=t;t=v+1|0;continue}}uj(B,j[c>>2])}y=y+1|0;continue}}function rua(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;f=Za-48|0;Za=f;o=j[a+16>>2];h=vf(f+16|0);j[h+8>>2]=a+112;j[h+16>>2]=j[a+128>>2];v=h,w=qf(b+327720|0,j[b+20>>2],(j[a+88>>2]&16384)>>>14|0),j[v+12>>2]=w;b=j[h+16>>2];if(b){v=h,w=uf(a+8|0,b),j[v>>2]=w;j[h+4>>2]=ab}k=j[a+48>>2];q=j[a+24>>2];r=j[a+20>>2];m=j[a+44>>2];e=j[a+4>>2];g=j[a>>2];j[f+8>>2]=g;j[f+12>>2]=e;b=j[a+12>>2];j[f>>2]=j[a+8>>2];j[f+4>>2]=b;a:{if(!d){b=m;m=k;break a}while(1){b=0;l=b;j[f+40>>2]=g;j[f+44>>2]=b;e=(e<<1)+o|0;b:{b=j[h+16>>2];if((b|0)<=0){break b}while(1){id(j[h+8>>2],i[(l<<1)+e>>1]/4<<16>>16);hd(j[h+8>>2],4);Bb(f+40|0,h);if((b|0)<2){break b}b=b-1|0;l=j[f+44>>2];continue}}d=d-1|0;b=j[h+8>>2];Bb(b,b+8|0);b=j[h+8>>2];g=j[b+4>>2];if(g){id(b,i[e+(j[f+44>>2]<<1)>>1]/4<<16>>16);hd(j[h+8>>2],g);b=j[h+8>>2];g=j[b>>2];j[b>>2]=g;j[b+4>>2]=0}e=pf(b,j[h+12>>2]);g=j[a+60>>2];l=g;b=Gb(m,-16777216,16776704);n=j[a+64>>2];k=Gb(k,-16777216,16776704);s=j[a+72>>2];t=j[c>>2];u=g>>31;g=e<<8;e=g;e=HMa(l,u,e,e>>31);l=ab;n=HMa(n,n>>31,b,b>>31);e=n+e|0;b=ab+l|0;b=e>>>0<n>>>0?b+1|0:b;l=e;e=j[a+68>>2];e=HMa(e,e>>31,k,k>>31);k=l+e|0;b=ab+b|0;b=e>>>0>k>>>0?b+1|0:b;k=k+8388608|0;if(k>>>0<8388608){b=b+1|0}b=(b&16777215)<<8|k>>>24;k=(b|0)/256|0;j[c>>2]=p(k,r)+t;j[c+4>>2]=j[c+4>>2]+p(k,q);b=b-(g&s)|0;Bb(f+8|0,f);if(d){c=c+8|0;g=j[f+8>>2];e=j[f+12>>2];k=m;m=b;continue}break}g=j[f+8>>2];e=j[f+12>>2]}j[a+48>>2]=m;j[a+44>>2]=b;j[a>>2]=g;j[a+4>>2]=e;Za=f+48|0}function nva(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;e=Za-48|0;Za=e;t=j[a+16>>2];g=j[a+44>>2];j[e+32>>2]=g;b=j[a+48>>2];j[e+36>>2]=b;f=j[a+52>>2];j[e+40>>2]=f;o=j[a+56>>2];j[e+44>>2]=o;u=j[a+24>>2];v=j[a+20>>2];l=j[a+4>>2];k=j[a>>2];j[e+24>>2]=k;j[e+28>>2]=l;m=j[a+12>>2];j[e+16>>2]=j[a+8>>2];j[e+20>>2]=m;if(d){while(1){m=(((l&2147483647)<<1|k>>>31)&-2)+t|0;b=(k>>>21&2040)+27888|0;k=i[b+6>>1];n=i[b+4>>1];s=i[b+2>>1];q=i[b>>1];f=0;o=1;b=1;g=0;while(1){j[(e+8|0)+(g<<2)>>2]=(((p(h[g+m|0],s)+p(h[m+(g|-2)|0],q)|0)+p(h[m+(g|2)|0],n)|0)+p(k,h[m+(g|4)|0])<<8)/16384;l=b;b=0;g=1;if(l){continue}break}while(1){k=(e+8|0)+(f<<2)|0;m=j[k>>2];n=j[a+60>>2];l=(e+32|0)+(f<<3)|0;f=j[l>>2];b=Gb(f,-16777216,16776704);q=j[a+64>>2];g=Gb(j[l+4>>2],-16777216,16776704);r=j[a+68>>2];w=r;r=r>>31;j[l+4>>2]=f;x=j[a+72>>2];m=m<<8;f=m;f=HMa(n,n>>31,f,f>>31);n=ab;y=k;k=HMa(q,q>>31,b,b>>31);f=k+f|0;b=ab+n|0;b=f>>>0<k>>>0?b+1|0:b;s=f;f=HMa(w,r,g,g>>31);g=s+f|0;b=ab+b|0;b=g>>>0<f>>>0?b+1|0:b;g=g+8388608|0;if(g>>>0<8388608){b=b+1|0}b=(b&16777215)<<8|g>>>24;j[y>>2]=(b|0)/256;j[l>>2]=b-(m&x);f=1;b=o&1;o=0;if(b){continue}break}j[c>>2]=j[c>>2]+p(j[e+8>>2],v);j[c+4>>2]=j[c+4>>2]+p(j[e+12>>2],u);Bb(e+24|0,e+16|0);d=d-1|0;if(d){c=c+8|0;k=j[e+24>>2];l=j[e+28>>2];continue}break}k=j[e+24>>2];l=j[e+28>>2];o=j[e+44>>2];f=j[e+40>>2];g=j[e+32>>2];b=j[e+36>>2]}j[a+56>>2]=o;j[a+52>>2]=f;j[a+48>>2]=b;j[a+44>>2]=g;j[a>>2]=k;j[a+4>>2]=l;Za=e+48|0}function s1(a,b,c,d,e){var f=0,g=0,i=q(0);f=Za-368|0;Za=f;j[f+352>>2]=b;j[f+360>>2]=a;Qu(f+200|0,c,f+224|0,f+220|0,f+216|0);b=Cb(f+184|0);a=sc(b);j[114630]=0;F(149,b|0,a|0);a=j[114630];j[114630]=0;a:{b:{if((a|0)!=1){a=Ub(b,0);j[f+180>>2]=a;j[f+12>>2]=f+16;j[f+8>>2]=0;h[f+7|0]=1;h[f+6|0]=69;while(1){c:{j[114630]=0;c=E(2455,f+360|0,f+352|0)|0;g=j[114630];j[114630]=0;if((g|0)==1){break c}if(!c){break b}if(j[f+180>>2]==(nb(b)+a|0)){c=nb(b);a=nb(b);j[114630]=0;F(149,b|0,a<<1);a=j[114630];j[114630]=0;if((a|0)==1){break a}a=sc(b);j[114630]=0;F(149,b|0,a|0);a=j[114630];j[114630]=0;if((a|0)==1){break a}a=Ub(b,0);j[f+180>>2]=c+a}j[114630]=0;c=H(2457,f+360|0)|0;g=j[114630];j[114630]=0;if((g|0)==1){break c}j[114630]=0;c=wq(c,f+7|0,f+6|0,a,f+180|0,j[f+220>>2],j[f+216>>2],f+200|0,f+16|0,f+12|0,f+8|0,f+224|0);g=j[114630];j[114630]=0;if((g|0)==1){break c}if(c){break b}j[114630]=0;H(2459,f+360|0)|0;c=j[114630];j[114630]=0;if((c|0)!=1){continue}}break}break a}break a}d:{if(!nb(f+200|0)|!k[f+7|0]){break d}c=j[f+12>>2];if((c-(f+16|0)|0)>159){break d}j[f+12>>2]=c+4;j[c>>2]=j[f+8>>2]}j[114630]=0;i=q(ja(2440,a|0,j[f+180>>2],d|0));a=j[114630];j[114630]=0;e:{if((a|0)==1){break e}n[e>>2]=i;j[114630]=0;le(f+200|0,f+16|0,j[f+12>>2],d);a=j[114630];j[114630]=0;if((a|0)==1){break e}j[114630]=0;a=E(2456,f+360|0,f+352|0)|0;c=j[114630];j[114630]=0;if((c|0)==1){break e}if(a){j[d>>2]=j[d>>2]|2}a=j[f+360>>2];gb(b);gb(f+200|0);Za=f+368|0;return a}}a=D()|0;C()|0;gb(b);gb(f+200|0);G(a|0);z()}function S1(a,b,c,d,e){var f=0,g=0,i=q(0);f=Za-272|0;Za=f;j[f+256>>2]=b;j[f+264>>2]=a;Su(f+208|0,c,f+224|0,f+223|0,f+222|0);b=Cb(f+192|0);a=sc(b);j[114630]=0;F(149,b|0,a|0);a=j[114630];j[114630]=0;a:{b:{if((a|0)!=1){a=Ub(b,0);j[f+188>>2]=a;j[f+12>>2]=f+16;j[f+8>>2]=0;h[f+7|0]=1;h[f+6|0]=69;while(1){c:{j[114630]=0;c=E(2423,f+264|0,f+256|0)|0;g=j[114630];j[114630]=0;if((g|0)==1){break c}if(!c){break b}if(j[f+188>>2]==(nb(b)+a|0)){c=nb(b);a=nb(b);j[114630]=0;F(149,b|0,a<<1);a=j[114630];j[114630]=0;if((a|0)==1){break a}a=sc(b);j[114630]=0;F(149,b|0,a|0);a=j[114630];j[114630]=0;if((a|0)==1){break a}a=Ub(b,0);j[f+188>>2]=c+a}j[114630]=0;c=H(2425,f+264|0)|0;g=j[114630];j[114630]=0;if((g|0)==1){break c}j[114630]=0;c=yq(c,f+7|0,f+6|0,a,f+188|0,h[f+223|0],h[f+222|0],f+208|0,f+16|0,f+12|0,f+8|0,f+224|0);g=j[114630];j[114630]=0;if((g|0)==1){break c}if(c){break b}j[114630]=0;H(2427,f+264|0)|0;c=j[114630];j[114630]=0;if((c|0)!=1){continue}}break}break a}break a}d:{if(!nb(f+208|0)|!k[f+7|0]){break d}c=j[f+12>>2];if((c-(f+16|0)|0)>159){break d}j[f+12>>2]=c+4;j[c>>2]=j[f+8>>2]}j[114630]=0;i=q(ja(2440,a|0,j[f+188>>2],d|0));a=j[114630];j[114630]=0;e:{if((a|0)==1){break e}n[e>>2]=i;j[114630]=0;le(f+208|0,f+16|0,j[f+12>>2],d);a=j[114630];j[114630]=0;if((a|0)==1){break e}j[114630]=0;a=E(2424,f+264|0,f+256|0)|0;c=j[114630];j[114630]=0;if((c|0)==1){break e}if(a){j[d>>2]=j[d>>2]|2}a=j[f+264>>2];gb(b);gb(f+208|0);Za=f+272|0;return a}}a=D()|0;C()|0;gb(b);gb(f+208|0);G(a|0);z()}function q1(a,b,c,d,e){var f=0,g=0,i=0;f=Za-368|0;Za=f;j[f+352>>2]=b;j[f+360>>2]=a;Qu(f+200|0,c,f+224|0,f+220|0,f+216|0);b=Cb(f+184|0);a=sc(b);j[114630]=0;F(149,b|0,a|0);a=j[114630];j[114630]=0;a:{b:{if((a|0)!=1){a=Ub(b,0);j[f+180>>2]=a;j[f+12>>2]=f+16;j[f+8>>2]=0;h[f+7|0]=1;h[f+6|0]=69;while(1){c:{j[114630]=0;c=E(2455,f+360|0,f+352|0)|0;g=j[114630];j[114630]=0;if((g|0)==1){break c}if(!c){break b}if(j[f+180>>2]==(nb(b)+a|0)){c=nb(b);a=nb(b);j[114630]=0;F(149,b|0,a<<1);a=j[114630];j[114630]=0;if((a|0)==1){break a}a=sc(b);j[114630]=0;F(149,b|0,a|0);a=j[114630];j[114630]=0;if((a|0)==1){break a}a=Ub(b,0);j[f+180>>2]=c+a}j[114630]=0;c=H(2457,f+360|0)|0;g=j[114630];j[114630]=0;if((g|0)==1){break c}j[114630]=0;c=wq(c,f+7|0,f+6|0,a,f+180|0,j[f+220>>2],j[f+216>>2],f+200|0,f+16|0,f+12|0,f+8|0,f+224|0);g=j[114630];j[114630]=0;if((g|0)==1){break c}if(c){break b}j[114630]=0;H(2459,f+360|0)|0;c=j[114630];j[114630]=0;if((c|0)!=1){continue}}break}break a}break a}d:{if(!nb(f+200|0)|!k[f+7|0]){break d}c=j[f+12>>2];if((c-(f+16|0)|0)>159){break d}j[f+12>>2]=c+4;j[c>>2]=j[f+8>>2]}j[114630]=0;i=+ca(2443,a|0,j[f+180>>2],d|0);a=j[114630];j[114630]=0;e:{if((a|0)==1){break e}o[e>>3]=i;j[114630]=0;le(f+200|0,f+16|0,j[f+12>>2],d);a=j[114630];j[114630]=0;if((a|0)==1){break e}j[114630]=0;a=E(2456,f+360|0,f+352|0)|0;c=j[114630];j[114630]=0;if((c|0)==1){break e}if(a){j[d>>2]=j[d>>2]|2}a=j[f+360>>2];gb(b);gb(f+200|0);Za=f+368|0;return a}}a=D()|0;C()|0;gb(b);gb(f+200|0);G(a|0);z()}function cx(a,b){var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;h=89;i=92;j=91;k=85;l=84;m=83;n=5;o=107;p=106;q=96;c=88;r=82;s=80;t=78;u=79;v=77;w=57;x=47;d=10;e=8;f=7;a=gx(a);a:{b:{c:{d:{switch(b-1|0){default:c=(b|0)==16777216;if((b|0)!=32?!c:0){break c}vb(a,0,1);vb(a,7,1);vb(a,8,1);vb(a,9,1);vb(a,10,1);vb(a,11,1);vb(a,12,1);vb(a,13,1);vb(a,14,1);vb(a,15,1);vb(a,16,1);vb(a,17,1);vb(a,18,1);vb(a,19,1);vb(a,20,1);vb(a,21,1);vb(a,22,1);vb(a,23,1);vb(a,24,1);vb(a,25,1);vb(a,26,1);vb(a,27,1);vb(a,28,1);vb(a,29,1);vb(a,30,1);vb(a,31,1);vb(a,32,1);vb(a,33,1);vb(a,34,1);vb(a,35,1);vb(a,36,1);vb(a,37,1);vb(a,38,1);vb(a,39,1);vb(a,40,1);vb(a,41,1);vb(a,42,1);vb(a,43,1);vb(a,44,1);vb(a,45,1);vb(a,46,1);vb(a,47,1);vb(a,48,1);vb(a,103,1);vb(a,50,1);vb(a,87,1);vb(a,88,1);vb(a,100,1);vb(a,102,1);vb(a,104,1);if(!c){break a}d=108;e=105;f=99;break b;case 3:vb(a,0,1);vb(a,4,1);vb(a,8,1);vb(a,9,1);vb(a,10,1);vb(a,17,1);vb(a,40,1);vb(a,51,1);vb(a,52,1);vb(a,53,1);vb(a,54,1);vb(a,55,1);vb(a,56,1);vb(a,57,1);vb(a,58,1);vb(a,59,1);vb(a,60,1);vb(a,61,1);vb(a,62,1);vb(a,63,1);vb(a,64,1);vb(a,65,1);vb(a,66,1);vb(a,67,1);vb(a,68,1);o=98;p=93;q=90;c=89;r=88;s=86;t=76;u=75;v=74;w=73;x=72;d=71;e=70;g=69;case 1:vb(a,g,1);vb(a,e,1);vb(a,d,1);vb(a,x,1);vb(a,w,1);vb(a,v,1);n=u;m=t;l=s;k=r;j=c;i=q;c=p;h=o;break;case 2:break c;case 0:break d}}vb(a,n,1);vb(a,m,1);vb(a,l,1);vb(a,k,1);g=j;f=i;e=c;d=h}vb(a,g,1)}vb(a,f,1);vb(a,e,1);vb(a,d,1)}}function O1(a,b,c,d,e){var f=0,g=0,i=0;f=Za-272|0;Za=f;j[f+256>>2]=b;j[f+264>>2]=a;Su(f+208|0,c,f+224|0,f+223|0,f+222|0);b=Cb(f+192|0);a=sc(b);j[114630]=0;F(149,b|0,a|0);a=j[114630];j[114630]=0;a:{b:{if((a|0)!=1){a=Ub(b,0);j[f+188>>2]=a;j[f+12>>2]=f+16;j[f+8>>2]=0;h[f+7|0]=1;h[f+6|0]=69;while(1){c:{j[114630]=0;c=E(2423,f+264|0,f+256|0)|0;g=j[114630];j[114630]=0;if((g|0)==1){break c}if(!c){break b}if(j[f+188>>2]==(nb(b)+a|0)){c=nb(b);a=nb(b);j[114630]=0;F(149,b|0,a<<1);a=j[114630];j[114630]=0;if((a|0)==1){break a}a=sc(b);j[114630]=0;F(149,b|0,a|0);a=j[114630];j[114630]=0;if((a|0)==1){break a}a=Ub(b,0);j[f+188>>2]=c+a}j[114630]=0;c=H(2425,f+264|0)|0;g=j[114630];j[114630]=0;if((g|0)==1){break c}j[114630]=0;c=yq(c,f+7|0,f+6|0,a,f+188|0,h[f+223|0],h[f+222|0],f+208|0,f+16|0,f+12|0,f+8|0,f+224|0);g=j[114630];j[114630]=0;if((g|0)==1){break c}if(c){break b}j[114630]=0;H(2427,f+264|0)|0;c=j[114630];j[114630]=0;if((c|0)!=1){continue}}break}break a}break a}d:{if(!nb(f+208|0)|!k[f+7|0]){break d}c=j[f+12>>2];if((c-(f+16|0)|0)>159){break d}j[f+12>>2]=c+4;j[c>>2]=j[f+8>>2]}j[114630]=0;i=+ca(2443,a|0,j[f+188>>2],d|0);a=j[114630];j[114630]=0;e:{if((a|0)==1){break e}o[e>>3]=i;j[114630]=0;le(f+208|0,f+16|0,j[f+12>>2],d);a=j[114630];j[114630]=0;if((a|0)==1){break e}j[114630]=0;a=E(2424,f+264|0,f+256|0)|0;c=j[114630];j[114630]=0;if((c|0)==1){break e}if(a){j[d>>2]=j[d>>2]|2}a=j[f+264>>2];gb(b);gb(f+208|0);Za=f+272|0;return a}}a=D()|0;C()|0;gb(b);gb(f+208|0);G(a|0);z()}function Pra(a){var b=0,c=0,d=0,e=0;b=Za-400|0;Za=b;CL(b+384|0,8);j[114630]=0;fa(1205,b+368|0,9);e=j[114630];j[114630]=0;a:{b:{c:{d:{e:{f:{g:{h:{i:{j:{k:{if((e|0)!=1){j[114630]=0;e=E(1206,b+352|0,14)|0;c=j[114630];j[114630]=0;if((c|0)==1){break k}j[114630]=0;F(1207,b+384|0,e|0);c=j[114630];j[114630]=0;if((c|0)==1){break j}j[114630]=0;F(1207,b+368|0,e|0);c=j[114630];j[114630]=0;if((c|0)==1){break j}BL(b+280|0,4900);BL(b+208|0,32e3);yL(b+136|0,8377175819504598e-21,16754351639009197e-21,8377175819504598e-21,-1.991112714669597,.9911462233728751);j[114630]=0;c=E(1208,b+104|0,b+384|0)|0;d=j[114630];j[114630]=0;if((d|0)==1){break i}cs(b+120|0,b+280|0,c);rf(c);j[114630]=0;c=E(1208,b+72|0,b+368|0)|0;d=j[114630];j[114630]=0;if((d|0)==1){break h}cs(b+88|0,b+208|0,c);rf(c);j[114630]=0;c=E(1208,b+40|0,b+120|0)|0;d=j[114630];j[114630]=0;if((d|0)==1){break g}cs(b+56|0,b+136|0,c);rf(c);j[114630]=0;c=E(1208,b+8|0,b+88|0)|0;d=j[114630];j[114630]=0;if((d|0)==1){break f}cs(b+24|0,b+136|0,c);rf(c);Mo(b+120|0);Mo(b+56|0);Mo(b+88|0);Mo(b+24|0);Mo(b+368|0);Lo(b+120|0,$h(a,0));Lo(b+56|0,$h(a,1));Lo(b+88|0,$h(a,2));Lo(b+24|0,$h(a,3));Lo(b+368|0,$h(a,4));rf(b+24|0);rf(b+56|0);rf(b+88|0);rf(b+120|0);Ko(e);rf(b+368|0);rf(b+384|0);Za=b+400|0;return}a=D()|0;C()|0;break a}a=D()|0;C()|0;break b}a=D()|0;C()|0;break c}a=D()|0;C()|0;break c}a=D()|0;C()|0;break d}a=D()|0;C()|0;break e}a=D()|0;C()|0;rf(b+56|0)}rf(b+88|0)}rf(b+120|0)}Ko(e)}rf(b+368|0)}rf(b+384|0);G(a|0);z()}function Rea(a){var b=0,c=0,d=q(0),e=q(0),f=0,g=q(0),h=0,i=q(0),k=0,l=q(0),m=0;f=Za-16|0;Za=f;g=n[a+4268>>2];d=q(n[a+4232>>2]*q(.30000001192092896));n[f+12>>2]=n[a+4240>>2]*q(.10000000149011612);j[f+8>>2]=1000593162;b=a;i=n[lw(f+12|0,f+8|0)>>2];e=q(g*q(q(d+q(.007000000216066837))+i));a:{if(q(r(e))<q(2147483648)){c=~~e;break a}c=-2147483648}j[b+4352>>2]=c;b=1;while(1){h=((p(b&1,24)+a|0)+(b<<1&-4)|0)+4352|0;e=q(q(q(n[(b<<2)+33600>>2]*i)+d)*g);b:{if(q(r(e))<q(2147483648)){c=~~e;break b}c=-2147483648}j[h>>2]=c;b=b+1|0;if((b|0)!=12){continue}break}n[f+12>>2]=q(q(n[a+4248>>2]*q(100))*q(.009091000072658062))+q(.09091000258922577);j[f+8>>2]=1065353216;d=q(n[Vk(f+12|0,f+8|0)>>2]*g);i=q(d*q(.07500000298023224));d=q(d*q(.06700000166893005));b=0;while(1){c=(b<<2)+a|0;m=c+4316|0;k=b+k|0;e=Yd(q(.9300000071525574),q(k|0));l=q(i*e);c:{if(q(r(l))<q(2147483648)){h=~~l;break c}h=-2147483648}j[m>>2]=h;h=c+4292|0;e=q(d*e);d:{if(q(r(e))<q(2147483648)){c=~~e;break d}c=-2147483648}j[h>>2]=c;b=b+1|0;if((b|0)!=6){continue}break}c=a+4348|0;d=q(g*q(.0035299998708069324));e:{if(q(r(d))<q(2147483648)){b=~~d;break e}b=-2147483648}j[c>>2]=b;c=a+4344|0;d=q(g*q(.0032500000670552254));f:{if(q(r(d))<q(2147483648)){b=~~d;break f}b=-2147483648}j[c>>2]=b;c=a+4340|0;g=q(g*q(.009999999776482582));g:{if(q(r(g))<q(2147483648)){b=~~g;break g}b=-2147483648}j[c>>2]=b;b=0;while(1){_G((p(b,24)+a|0)+4504|0,j[((b<<2)+a|0)+4292>>2]);b=b+1|0;if(b>>>0<15){continue}break}Za=f+16|0}function lJ(a,b){var c=0,d=0,e=0,f=0,g=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,u=0,v=0;c=Za-16|0;Za=c;d=p(b,896)+a|0;a:{if(j[d+1075072>>2]&134218752){break a}if(!Si(d+1074984|0)){break a}m=j[(p(b,896)+a|0)+1075640>>2];if(k[m+15|0]&2){break a}d=bl(a,b,2,1);if(d-251>>>0<5|!d){break a}g=j[(p(d,160)+a|0)+906140>>2];if(!g){break a}e=p(b,896)+a|0;d=k[e+1075794|0];b:{if(k[e+1075796|0]==1){h[c+8|0]=64;f=k[Zb(e+1075798|0,c+8|0)|0];break b}f=255;if(k[e+1075797|0]!=13){break b}h[c+8|0]=64;f=k[Zb((p(b,896)+a|0)+1075799|0,c+8|0)|0]}o=a+1074308|0;mb(c+8|0,o,2);if(kb(c+8|0)){if(d){e=a;f=b;if(Ld(d)){d=k[Pb(m+108|0,d-1|0)|0]}Nj(e,f,d,l[(p(b,896)+a|0)+1075672>>1]);break a}if((f|0)==255){break a}bb[j[j[g>>2]+76>>2]](g,39,f,b);break a}q=j[m+4>>2];if(d){e=q<<2;j[c+4>>2]=e;if(!k[m+35|0]){e=j[(p(b,896)+a|0)+1075672>>2];j[c+4>>2]=e}n=i[(p(b,896)+a|0)+1075772>>1];mb(c+8|0,o,28);r=c,s=(kb(c+8|0)?n<<2:n)+e|0,j[r+4>>2]=s;Md(c+4|0,0,256);e=d;n=b;if(Ld(d)){e=k[Pb(m+108|0,d-1|0)|0]}Nj(a,n,e&255,l[c+4>>1])}e=k[m+35|0];mb(c+8|0,o,101);a=(d|0)!=0;c:{if(kb(c+8|0)){break c}a=Ld(d)}if(a|(f|0)==255?!(a&(e|0)==1):0){break a}d:{switch(k[m+36|0]){case 1:if((f|0)!=255){zH(g,f<<1);break a}zH(g,q<<1);break a;case 0:break d;default:break a}}if((f|0)!=255){h[c+8|0]=127;h[c+4|0]=f<<1;s=g,t=7,u=k[Zb(c+8|0,c+4|0)|0],v=b,r=j[j[g>>2]+76>>2],bb[r](s|0,t|0,u|0,v|0);break a}j[c+8>>2]=127;j[c+4>>2]=q<<1;v=g,u=7,t=k[tb(c+8|0,c+4|0)|0],s=b,r=j[j[g>>2]+76>>2],bb[r](v|0,u|0,t|0,s|0)}Za=c+16|0}function sua(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,i=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;f=Za-48|0;Za=f;o=j[a+16>>2];i=vf(f+16|0);j[i+8>>2]=a+112;j[i+16>>2]=j[a+128>>2];v=i,w=qf(b+327720|0,j[b+20>>2],(j[a+88>>2]&16384)>>>14|0),j[v+12>>2]=w;b=j[i+16>>2];if(b){v=i,w=uf(a+8|0,b),j[v>>2]=w;j[i+4>>2]=ab}k=j[a+48>>2];q=j[a+24>>2];r=j[a+20>>2];m=j[a+44>>2];e=j[a+4>>2];g=j[a>>2];j[f+8>>2]=g;j[f+12>>2]=e;b=j[a+12>>2];j[f>>2]=j[a+8>>2];j[f+4>>2]=b;a:{if(!d){b=m;m=k;break a}while(1){b=0;l=b;j[f+40>>2]=g;j[f+44>>2]=b;e=e+o|0;b:{b=j[i+16>>2];if((b|0)<=0){break b}while(1){id(j[i+8>>2],h[e+l|0]<<6);hd(j[i+8>>2],4);Bb(f+40|0,i);if((b|0)<2){break b}b=b-1|0;l=j[f+44>>2];continue}}d=d-1|0;b=j[i+8>>2];Bb(b,b+8|0);b=j[i+8>>2];g=j[b+4>>2];if(g){id(b,h[e+j[f+44>>2]|0]<<6);hd(j[i+8>>2],g);b=j[i+8>>2];g=j[b>>2];j[b>>2]=g;j[b+4>>2]=0}e=pf(b,j[i+12>>2]);g=j[a+60>>2];l=g;b=Gb(m,-16777216,16776704);n=j[a+64>>2];k=Gb(k,-16777216,16776704);s=j[a+72>>2];t=j[c>>2];u=g>>31;g=e<<8;e=g;e=HMa(l,u,e,e>>31);l=ab;n=HMa(n,n>>31,b,b>>31);e=n+e|0;b=ab+l|0;b=e>>>0<n>>>0?b+1|0:b;l=e;e=j[a+68>>2];e=HMa(e,e>>31,k,k>>31);k=l+e|0;b=ab+b|0;b=e>>>0>k>>>0?b+1|0:b;k=k+8388608|0;if(k>>>0<8388608){b=b+1|0}b=(b&16777215)<<8|k>>>24;k=(b|0)/256|0;j[c>>2]=p(k,r)+t;j[c+4>>2]=j[c+4>>2]+p(k,q);b=b-(g&s)|0;Bb(f+8|0,f);if(d){c=c+8|0;g=j[f+8>>2];e=j[f+12>>2];k=m;m=b;continue}break}g=j[f+8>>2];e=j[f+12>>2]}j[a+48>>2]=m;j[a+44>>2]=b;j[a>>2]=g;j[a+4>>2]=e;Za=f+48|0}function Dua(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0;k=Za-16|0;Za=k;f=j[a+48>>2];o=j[a+40>>2];q=j[a+36>>2];e=j[a+44>>2];t=j[a+16>>2];g=j[a+4>>2];l=j[a>>2];j[k+8>>2]=l;j[k+12>>2]=g;h=j[a+12>>2];j[k>>2]=j[a+8>>2];j[k+4>>2]=h;a:{if(!d){m=o>>12;r=q>>12;break a}while(1){h=(g<<1)+t|0;m=i[h-6>>1];g=(((l>>>16|0)+4&131064)<<1)+b|0;l=i[g+24>>1];r=i[h-4>>1];u=i[g+26>>1];v=i[h-2>>1];w=i[g+28>>1];x=i[h>>1];y=i[g+30>>1];z=i[h+2>>1];A=i[g+32>>1];B=i[h+4>>1];C=i[g+34>>1];D=i[h+6>>1];E=i[g+36>>1];F=i[h+8>>1];G=i[g+38>>1];h=j[a+60>>2];H=h;I=h>>31;h=e;e=Gb(e,-16777216,16776704);n=j[a+64>>2];f=Gb(f,-16777216,16776704);J=j[a+72>>2];K=j[a+32>>2];g=c;L=j[g>>2];e=HMa(n,n>>31,e,e>>31);n=ab;M=e;e=j[a+68>>2];s=HMa(e,e>>31,f,f>>31);e=M+s|0;f=ab+n|0;f=e>>>0<s>>>0?f+1|0:f;n=e;l=(((((p(B,C)+p(z,A)|0)+p(D,E)|0)+p(F,G)|0)/2|0)+((((p(r,u)+p(l,m)|0)+p(v,w)|0)+p(x,y)|0)/2|0)|0)/16384<<8;e=l;m=HMa(H,I,e,e>>31);e=n+m|0;f=ab+f|0;f=e>>>0<m>>>0?f+1|0:f;e=e+8388608|0;if(e>>>0<8388608){f=f+1|0}e=(f&16777215)<<8|e>>>24;f=(e|0)/256|0;q=j[a+28>>2]+q|0;r=q>>12;j[g>>2]=p(f,r)+L;o=o+K|0;m=o>>12;j[c+4>>2]=j[c+4>>2]+p(f,m);e=e-(l&J)|0;Bb(k+8|0,k);d=d-1|0;if(d){c=c+8|0;l=j[k+8>>2];g=j[k+12>>2];f=h;continue}break}l=j[k+8>>2];g=j[k+12>>2];f=h}j[a+40>>2]=o;j[a+20>>2]=r;j[a+36>>2]=q;j[a+48>>2]=f;j[a+44>>2]=e;j[a+24>>2]=m;j[a>>2]=l;j[a+4>>2]=g;Za=k+16|0}function u1(a,b,c,d,e){var f=0,g=0,h=0,i=0;f=Za-352|0;Za=f;j[f+336>>2]=b;j[f+344>>2]=a;h=Eg(c);i=am(c,f+224|0);$l(f+208|0,c,f+332|0);a=Cb(f+192|0);b=sc(a);j[114630]=0;F(149,a|0,b|0);b=j[114630];j[114630]=0;a:{b:{if((b|0)!=1){b=Ub(a,0);j[f+188>>2]=b;j[f+12>>2]=f+16;j[f+8>>2]=0;while(1){c:{j[114630]=0;c=E(2455,f+344|0,f+336|0)|0;g=j[114630];j[114630]=0;if((g|0)==1){break c}if(!c){break b}if(j[f+188>>2]==(nb(a)+b|0)){c=nb(a);b=nb(a);j[114630]=0;F(149,a|0,b<<1);b=j[114630];j[114630]=0;if((b|0)==1){break a}b=sc(a);j[114630]=0;F(149,a|0,b|0);b=j[114630];j[114630]=0;if((b|0)==1){break a}b=Ub(a,0);j[f+188>>2]=c+b}j[114630]=0;c=H(2457,f+344|0)|0;g=j[114630];j[114630]=0;if((g|0)==1){break c}j[114630]=0;c=wj(c,h,b,f+188|0,f+8|0,j[f+332>>2],f+208|0,f+16|0,f+12|0,i);g=j[114630];j[114630]=0;if((g|0)==1){break c}if(c){break b}j[114630]=0;H(2459,f+344|0)|0;c=j[114630];j[114630]=0;if((c|0)!=1){continue}}break}break a}break a}d:{if(!nb(f+208|0)){break d}c=j[f+12>>2];if((c-(f+16|0)|0)>159){break d}j[f+12>>2]=c+4;j[c>>2]=j[f+8>>2]}j[114630]=0;b=Kn(2438,b,j[f+188>>2],d,h);c=ab;h=j[114630];j[114630]=0;e:{if((h|0)==1){break e}j[e>>2]=b;j[e+4>>2]=c;j[114630]=0;le(f+208|0,f+16|0,j[f+12>>2],d);b=j[114630];j[114630]=0;if((b|0)==1){break e}j[114630]=0;b=E(2456,f+344|0,f+336|0)|0;c=j[114630];j[114630]=0;if((c|0)==1){break e}if(b){j[d>>2]=j[d>>2]|2}b=j[f+344>>2];gb(a);gb(f+208|0);Za=f+352|0;return b}}b=D()|0;C()|0;gb(a);gb(f+208|0);G(b|0);z()}function C1(a,b,c,d,e){var f=0,g=0,h=0,i=0;f=Za-352|0;Za=f;j[f+336>>2]=b;j[f+344>>2]=a;h=Eg(c);i=am(c,f+224|0);$l(f+208|0,c,f+332|0);a=Cb(f+192|0);b=sc(a);j[114630]=0;F(149,a|0,b|0);b=j[114630];j[114630]=0;a:{b:{if((b|0)!=1){b=Ub(a,0);j[f+188>>2]=b;j[f+12>>2]=f+16;j[f+8>>2]=0;while(1){c:{j[114630]=0;c=E(2455,f+344|0,f+336|0)|0;g=j[114630];j[114630]=0;if((g|0)==1){break c}if(!c){break b}if(j[f+188>>2]==(nb(a)+b|0)){c=nb(a);b=nb(a);j[114630]=0;F(149,a|0,b<<1);b=j[114630];j[114630]=0;if((b|0)==1){break a}b=sc(a);j[114630]=0;F(149,a|0,b|0);b=j[114630];j[114630]=0;if((b|0)==1){break a}b=Ub(a,0);j[f+188>>2]=c+b}j[114630]=0;c=H(2457,f+344|0)|0;g=j[114630];j[114630]=0;if((g|0)==1){break c}j[114630]=0;c=wj(c,h,b,f+188|0,f+8|0,j[f+332>>2],f+208|0,f+16|0,f+12|0,i);g=j[114630];j[114630]=0;if((g|0)==1){break c}if(c){break b}j[114630]=0;H(2459,f+344|0)|0;c=j[114630];j[114630]=0;if((c|0)!=1){continue}}break}break a}break a}d:{if(!nb(f+208|0)){break d}c=j[f+12>>2];if((c-(f+16|0)|0)>159){break d}j[f+12>>2]=c+4;j[c>>2]=j[f+8>>2]}j[114630]=0;b=Kn(2434,b,j[f+188>>2],d,h);c=ab;h=j[114630];j[114630]=0;e:{if((h|0)==1){break e}j[e>>2]=b;j[e+4>>2]=c;j[114630]=0;le(f+208|0,f+16|0,j[f+12>>2],d);b=j[114630];j[114630]=0;if((b|0)==1){break e}j[114630]=0;b=E(2456,f+344|0,f+336|0)|0;c=j[114630];j[114630]=0;if((c|0)==1){break e}if(b){j[d>>2]=j[d>>2]|2}b=j[f+344>>2];gb(a);gb(f+208|0);Za=f+352|0;return b}}b=D()|0;C()|0;gb(a);gb(f+208|0);G(b|0);z()}function Qva(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;b=Za-48|0;Za=b;v=j[a+16>>2];l=j[a+44>>2];j[b+32>>2]=l;n=j[a+48>>2];j[b+36>>2]=n;g=j[a+52>>2];j[b+40>>2]=g;h=j[a+56>>2];j[b+44>>2]=h;o=j[a+40>>2];q=j[a+36>>2];e=j[a+4>>2];k=j[a>>2];j[b+24>>2]=k;j[b+28>>2]=e;f=j[a+12>>2];j[b+16>>2]=j[a+8>>2];j[b+20>>2]=f;a:{if(!d){m=o>>12;f=q>>12;break a}while(1){e=((((e&2147483647)<<1|k>>>31)&2147483646)<<1)+v|0;h=i[e>>1];j[b+8>>2]=h;j[b+12>>2]=i[e+2>>1];f=0;n=1;while(1){g=j[a+60>>2];m=g;k=(b+32|0)+(f<<3)|0;r=j[k>>2];e=Gb(r,-16777216,16776704);u=j[a+64>>2];l=Gb(j[k+4>>2],-16777216,16776704);s=j[a+68>>2];w=s;s=s>>31;j[k+4>>2]=r;r=j[a+72>>2];t=g>>31;h=h<<8;g=h;g=HMa(m,t,g,g>>31);m=ab;t=(b+8|0)+(f<<2)|0;f=g;g=HMa(u,u>>31,e,e>>31);f=f+g|0;e=ab+m|0;e=f>>>0<g>>>0?e+1|0:e;l=HMa(w,s,l,l>>31);f=l+f|0;e=ab+e|0;e=f>>>0<l>>>0?e+1|0:e;f=f+8388608|0;if(f>>>0<8388608){e=e+1|0}e=(e&16777215)<<8|f>>>24;j[t>>2]=(e|0)/256;j[k>>2]=e-(h&r);if(n){f=1;n=0;h=j[b+12>>2];continue}break}e=j[a+32>>2];q=j[a+28>>2]+q|0;f=q>>12;j[c>>2]=j[c>>2]+p(f,j[b+8>>2]);o=e+o|0;m=o>>12;j[c+4>>2]=j[c+4>>2]+p(m,j[b+12>>2]);Bb(b+24|0,b+16|0);d=d-1|0;if(d){c=c+8|0;k=j[b+24>>2];e=j[b+28>>2];continue}break}k=j[b+24>>2];e=j[b+28>>2];h=j[b+44>>2];g=j[b+40>>2];n=j[b+36>>2];l=j[b+32>>2]}j[a+40>>2]=o;j[a+20>>2]=f;j[a+36>>2]=q;j[a+56>>2]=h;j[a+52>>2]=g;j[a+48>>2]=n;j[a+44>>2]=l;j[a+24>>2]=m;j[a>>2]=k;j[a+4>>2]=e;Za=b+48|0}function Eua(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0;l=Za-16|0;Za=l;f=j[a+48>>2];q=j[a+40>>2];r=j[a+36>>2];e=j[a+44>>2];u=j[a+16>>2];g=j[a+4>>2];m=j[a>>2];j[l+8>>2]=m;j[l+12>>2]=g;k=j[a+12>>2];j[l>>2]=j[a+8>>2];j[l+4>>2]=k;a:{if(!d){n=q>>12;s=r>>12;break a}while(1){k=g+u|0;n=h[k-3|0];g=(((m>>>16|0)+4&131064)<<1)+b|0;m=i[g+24>>1];s=h[k-2|0];v=i[g+26>>1];w=h[k-1|0];x=i[g+28>>1];y=h[k|0];z=i[g+30>>1];A=h[k+1|0];B=i[g+32>>1];C=h[k+2|0];D=i[g+34>>1];E=h[k+3|0];F=i[g+36>>1];G=h[k+4|0];H=i[g+38>>1];k=j[a+60>>2];I=k;J=k>>31;k=e;e=Gb(e,-16777216,16776704);o=j[a+64>>2];f=Gb(f,-16777216,16776704);K=j[a+72>>2];L=j[a+32>>2];g=c;M=j[g>>2];e=HMa(o,o>>31,e,e>>31);o=ab;N=e;e=j[a+68>>2];t=HMa(e,e>>31,f,f>>31);e=N+t|0;f=ab+o|0;f=e>>>0<t>>>0?f+1|0:f;o=e;m=(((((p(C,D)+p(A,B)|0)+p(E,F)|0)+p(G,H)<<8)/2|0)+((((p(s,v)+p(m,n)|0)+p(w,x)|0)+p(y,z)<<8)/2|0)|0)/16384<<8;e=m;n=HMa(I,J,e,e>>31);e=o+n|0;f=ab+f|0;f=e>>>0<n>>>0?f+1|0:f;e=e+8388608|0;if(e>>>0<8388608){f=f+1|0}e=(f&16777215)<<8|e>>>24;f=(e|0)/256|0;r=j[a+28>>2]+r|0;s=r>>12;j[g>>2]=p(f,s)+M;q=q+L|0;n=q>>12;j[c+4>>2]=j[c+4>>2]+p(f,n);e=e-(m&K)|0;Bb(l+8|0,l);d=d-1|0;if(d){c=c+8|0;m=j[l+8>>2];g=j[l+12>>2];f=k;continue}break}m=j[l+8>>2];g=j[l+12>>2];f=k}j[a+40>>2]=q;j[a+20>>2]=s;j[a+36>>2]=r;j[a+48>>2]=f;j[a+44>>2]=e;j[a+24>>2]=n;j[a>>2]=m;j[a+4>>2]=g;Za=l+16|0}function fCa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,m=0,n=0,o=0,p=0;e=Za-16|0;Za=e;a:{if((c|0)!=4){g=b+236|0;m=b+108|0;while(1){f=(d<<2)+a|0;n=k[f+4|0];o=Pb(m,d),p=n+1|0,h[o|0]=p;f=f+6|0;f=k[f|0]|k[f+1|0]<<8;o=Nc(g,d),p=f+1|0,i[o>>1]=p;d=d+1|0;if((d|0)!=120){continue}break}break a}g=b+236|0;while(1){m=((d<<2)+a|0)+6|0;m=k[m|0]|k[m+1|0]<<8;o=Nc(g,d+12|0),p=m+1|0,i[o>>1]=p;d=d+1|0;if((d|0)!=96){continue}break}}xy(a+484|0,b+48|0,0);xy(a+590|0,b+68|0,0);xy(a+696|0,b+88|0,5);d=a+806|0;j[b>>2]=k[d|0]|k[d+1|0]<<8;d=a+808|0;g=k[d|0];b:{if(h[d|0]<=-1){h[b+34|0]=g-127;break b}if(!(!(h[a|0]&1)|g>>>0>16)){h[b+31|0]=k[d|0]+1;break b}if(!k[d|0]|k[d|0]>16){break b}h[b+31|0]=k[d|0]+1}if(k[b+31|0]){c:{d:{if((c|0)==4){d=a+810|0;break d}d=a+809|0;if(h[d|0]>=0){i[b+28>>1]=k[d|0]+1}d=a+810|0;if(h[d|0]<0){break c}}h[b+30|0]=k[d|0]+1}h[b+33|0]=k[a+811|0]}if((c|0)==32){h[e+15|0]=k[a+812|0];h[e+14|0]=128;o=b,p=k[Zb(e+15|0,e+14|0)|0]>>>1|0,j[o+4>>2]=p}c=a+813|0;if((k[c|0]|k[c+1|0]<<8)>>>0<=256){j[b+8>>2]=k[c|0]|k[c+1|0]<<8;h[b+15|0]=k[b+15|0]|1}h[b+16|0]=k[a+815|0];h[b+26|0]=k[a+816|0];h[b+27|0]=k[a+817|0];h[b+17|0]=k[a+818|0];h[b+18|0]=k[a+819|0];c=a+820|0;i[e+12>>1]=k[c|0]|k[c+1|0]<<8;i[e+10>>1]=100;o=b,p=k[gf(e+12|0,e+10|0)|0],h[o+20|0]=p;c=a+822|0;i[e+8>>1]=k[c|0]|k[c+1|0]<<8;i[e+6>>1]=256;o=b,p=l[gf(e+8|0,e+6|0)>>1]>>>2|0,h[o+19|0]=p;c=a+824|0;Gt(b,k[c|0]&127,k[c|0]>>>7|0);a=a+825|0;Ft(b,k[a|0]&127,k[a|0]>>>7|0);Za=e+16|0}function Qka(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,j=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,u=0;f=Za-16|0;Za=f;a:{if(Ps(a)){break a}q=d+484344|0;m=kd(dd(a)+1|0,1,1024);if(!Wf(q,b,m)){break a}d=l[d+480188>>1];if(!d|!m){break a}r=d-1|0;while(1){if(!yb(a,1)){break a}g=dd(a);b:{if(!g){n=n+1|0;break b}d=Hb(q,b);i[f+14>>1]=g&31;i[f+12>>1]=r;d=Se(d,n,l[gf(f+14|0,f+12|0)>>1]);if(!(g&224)){break b}c:{if(!(g&128)){break c}t=d,u=dd(a),h[t+5|0]=u;d:{e=dd(a);if(e>>>0>=26){break d}e=k[e+31824|0];h[d+3|0]=e;e:{switch(e-1|0){case 0:if(!k[d+5|0]){break d}break c;case 12:if(k[d+2|0]){break c}h[d+2|0]=1;e=kd(k[d+5|0],0,64);h[d+5|0]=0;h[d+3|0]=0;h[d+4|0]=e;break c;case 5:case 6:case 10:case 23:case 28:e=k[d+5|0]&240;if(!e){break c}h[d+5|0]=e;break c;case 8:e=k[d+5|0];if(e>>>0<=128){t=d,u=bj(e<<1),h[t+5|0]=u;break c}if((e|0)!=164){break c}h[d+5|0]=145;h[d+3|0]=20;break c;case 13:e=k[d+5|0];h[d+5|0]=p(e>>>4|0,10)+(e&15);break c;case 18:Fw(d);break c;case 16:if(k[d+5|0]>31){break c}h[d+3|0]=16;break c;case 27:break e;default:break c}}s=d;e=k[d+5|0];j=e&240;o=2;f:{g:{if((j|0)==16){break g}if((j|0)!=32){break f}o=3}h[s+3|0]=o}h[d+5|0]=e&15|224;break c}h[d+3|0]=0}h:{if(!(g&64)){break h}wt(f+8|0,a);e=Pc(f+8|0);h[d+1|0]=k[f+8|0];e=k[e|0];h[d|0]=e;j=255;if((e|0)!=128){j=253;if(e>>>0<129){break h}}h[d|0]=j}if(!(g&32)){break b}h[d+2|0]=1;e=dd(a);h[d+4|0]=e;if(!c){break b}h[d+4|0]=(e<<6>>>0)/127}if(n>>>0<m>>>0){continue}break}}Za=f+16|0}function Ora(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,k=0;d=Za-48|0;Za=d;e=AL(d+32|0,1<<j[b+12>>2]);if(fg(a)){while(1){g=o[wk(a,c)>>3];zL($b(e,c),g);c=c+1|0;if(fg(a)>>>0>c>>>0){continue}break}}j[114630]=0;F(1210,b|0,e|0);c=j[114630];j[114630]=0;a:{if((c|0)==1){break a}h=d,i=Lb(e),j[h>>2]=i;h=d,i=Mb(e),j[h+24>>2]=i;b:{if(rb(d,d+24|0)){while(1){c=j[d>>2];j[114630]=0;g=+$(1211,c|0);f=j[114630];j[114630]=0;if((f|0)==1){break b}zL(c,Zn(g));yf(d);if(rb(d,d+24|0)){continue}break}}j[114630]=0;F(1212,b|0,e|0);c=j[114630];j[114630]=0;if((c|0)==1){break a}j[114630]=0;N(1213,e|0);c=j[114630];j[114630]=0;if((c|0)==1){break a}if(Zc(e)>>>0>3){c=1;while(1){Dx($b(e,c),2);Dx($b(e,(Zc(e)>>>1|0)+c|0),0);c=c+1|0;if(c>>>0<Zc(e)>>>1>>>0){continue}break}}j[114630]=0;F(1210,b|0,e|0);c=j[114630];j[114630]=0;if((c|0)==1){break a}h=d,i=Lb(e),j[h+24>>2]=i;h=d,i=Mb(e),j[h+16>>2]=i;if(rb(d+24|0,d+16|0)){while(1){c=j[d+24>>2];j[114630]=0;F(1214,d|0,c|0);f=j[114630];j[114630]=0;if((f|0)==1){break b}f=j[d+4>>2];j[c>>2]=j[d>>2];j[c+4>>2]=f;f=j[d+12>>2];j[c+8>>2]=j[d+8>>2];j[c+12>>2]=f;yf(d+24|0);if(rb(d+24|0,d+16|0)){continue}break}}j[114630]=0;F(1212,b|0,e|0);b=j[114630];j[114630]=0;if((b|0)==1){break a}j[114630]=0;N(1213,e|0);b=j[114630];j[114630]=0;if((b|0)==1){break a}if(fg(a)){c=0;while(1){g=o[$b(e,c)>>3];h=wk(a,c),k=g,o[h>>3]=k;c=c+1|0;if(fg(a)>>>0>c>>>0){continue}break}}Ko(e);Za=d+48|0;return}}a=D()|0;C()|0;Ko(e);G(a|0);z()}function y1(a,b,c,d,e){var f=0,g=0,h=0,i=0;f=Za-352|0;Za=f;j[f+336>>2]=b;j[f+344>>2]=a;h=Eg(c);i=am(c,f+224|0);$l(f+208|0,c,f+332|0);a=Cb(f+192|0);b=sc(a);j[114630]=0;F(149,a|0,b|0);b=j[114630];j[114630]=0;a:{b:{if((b|0)!=1){b=Ub(a,0);j[f+188>>2]=b;j[f+12>>2]=f+16;j[f+8>>2]=0;while(1){c:{j[114630]=0;c=E(2455,f+344|0,f+336|0)|0;g=j[114630];j[114630]=0;if((g|0)==1){break c}if(!c){break b}if(j[f+188>>2]==(nb(a)+b|0)){c=nb(a);b=nb(a);j[114630]=0;F(149,a|0,b<<1);b=j[114630];j[114630]=0;if((b|0)==1){break a}b=sc(a);j[114630]=0;F(149,a|0,b|0);b=j[114630];j[114630]=0;if((b|0)==1){break a}b=Ub(a,0);j[f+188>>2]=c+b}j[114630]=0;c=H(2457,f+344|0)|0;g=j[114630];j[114630]=0;if((g|0)==1){break c}j[114630]=0;c=wj(c,h,b,f+188|0,f+8|0,j[f+332>>2],f+208|0,f+16|0,f+12|0,i);g=j[114630];j[114630]=0;if((g|0)==1){break c}if(c){break b}j[114630]=0;H(2459,f+344|0)|0;c=j[114630];j[114630]=0;if((c|0)!=1){continue}}break}break a}break a}d:{if(!nb(f+208|0)){break d}c=j[f+12>>2];if((c-(f+16|0)|0)>159){break d}j[f+12>>2]=c+4;j[c>>2]=j[f+8>>2]}j[114630]=0;b=P(2436,b|0,j[f+188>>2],d|0,h|0)|0;c=j[114630];j[114630]=0;e:{if((c|0)==1){break e}j[e>>2]=b;j[114630]=0;le(f+208|0,f+16|0,j[f+12>>2],d);b=j[114630];j[114630]=0;if((b|0)==1){break e}j[114630]=0;b=E(2456,f+344|0,f+336|0)|0;c=j[114630];j[114630]=0;if((c|0)==1){break e}if(b){j[d>>2]=j[d>>2]|2}b=j[f+344>>2];gb(a);gb(f+208|0);Za=f+352|0;return b}}b=D()|0;C()|0;gb(a);gb(f+208|0);G(b|0);z()}function w1(a,b,c,d,e){var f=0,g=0,h=0,i=0;f=Za-352|0;Za=f;j[f+336>>2]=b;j[f+344>>2]=a;h=Eg(c);i=am(c,f+224|0);$l(f+208|0,c,f+332|0);a=Cb(f+192|0);b=sc(a);j[114630]=0;F(149,a|0,b|0);b=j[114630];j[114630]=0;a:{b:{if((b|0)!=1){b=Ub(a,0);j[f+188>>2]=b;j[f+12>>2]=f+16;j[f+8>>2]=0;while(1){c:{j[114630]=0;c=E(2455,f+344|0,f+336|0)|0;g=j[114630];j[114630]=0;if((g|0)==1){break c}if(!c){break b}if(j[f+188>>2]==(nb(a)+b|0)){c=nb(a);b=nb(a);j[114630]=0;F(149,a|0,b<<1);b=j[114630];j[114630]=0;if((b|0)==1){break a}b=sc(a);j[114630]=0;F(149,a|0,b|0);b=j[114630];j[114630]=0;if((b|0)==1){break a}b=Ub(a,0);j[f+188>>2]=c+b}j[114630]=0;c=H(2457,f+344|0)|0;g=j[114630];j[114630]=0;if((g|0)==1){break c}j[114630]=0;c=wj(c,h,b,f+188|0,f+8|0,j[f+332>>2],f+208|0,f+16|0,f+12|0,i);g=j[114630];j[114630]=0;if((g|0)==1){break c}if(c){break b}j[114630]=0;H(2459,f+344|0)|0;c=j[114630];j[114630]=0;if((c|0)!=1){continue}}break}break a}break a}d:{if(!nb(f+208|0)){break d}c=j[f+12>>2];if((c-(f+16|0)|0)>159){break d}j[f+12>>2]=c+4;j[c>>2]=j[f+8>>2]}j[114630]=0;b=P(2437,b|0,j[f+188>>2],d|0,h|0)|0;c=j[114630];j[114630]=0;e:{if((c|0)==1){break e}j[e>>2]=b;j[114630]=0;le(f+208|0,f+16|0,j[f+12>>2],d);b=j[114630];j[114630]=0;if((b|0)==1){break e}j[114630]=0;b=E(2456,f+344|0,f+336|0)|0;c=j[114630];j[114630]=0;if((c|0)==1){break e}if(b){j[d>>2]=j[d>>2]|2}b=j[f+344>>2];gb(a);gb(f+208|0);Za=f+352|0;return b}}b=D()|0;C()|0;gb(a);gb(f+208|0);G(b|0);z()}function Rva(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,i=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;b=Za-48|0;Za=b;v=j[a+16>>2];l=j[a+44>>2];j[b+32>>2]=l;n=j[a+48>>2];j[b+36>>2]=n;g=j[a+52>>2];j[b+40>>2]=g;i=j[a+56>>2];j[b+44>>2]=i;o=j[a+40>>2];q=j[a+36>>2];e=j[a+4>>2];k=j[a>>2];j[b+24>>2]=k;j[b+28>>2]=e;f=j[a+12>>2];j[b+16>>2]=j[a+8>>2];j[b+20>>2]=f;a:{if(!d){m=o>>12;f=q>>12;break a}while(1){e=(((e&2147483647)<<1|k>>>31)&-2)+v|0;i=h[e|0]<<8;j[b+8>>2]=i;j[b+12>>2]=h[e+1|0]<<8;f=0;n=1;while(1){g=j[a+60>>2];m=g;k=(b+32|0)+(f<<3)|0;r=j[k>>2];e=Gb(r,-16777216,16776704);u=j[a+64>>2];l=Gb(j[k+4>>2],-16777216,16776704);s=j[a+68>>2];w=s;s=s>>31;j[k+4>>2]=r;r=j[a+72>>2];t=g>>31;i=i<<8;g=i;g=HMa(m,t,g,g>>31);m=ab;t=(b+8|0)+(f<<2)|0;f=g;g=HMa(u,u>>31,e,e>>31);f=f+g|0;e=ab+m|0;e=f>>>0<g>>>0?e+1|0:e;l=HMa(w,s,l,l>>31);f=l+f|0;e=ab+e|0;e=f>>>0<l>>>0?e+1|0:e;f=f+8388608|0;if(f>>>0<8388608){e=e+1|0}e=(e&16777215)<<8|f>>>24;j[t>>2]=(e|0)/256;j[k>>2]=e-(i&r);if(n){f=1;n=0;i=j[b+12>>2];continue}break}e=j[a+32>>2];q=j[a+28>>2]+q|0;f=q>>12;j[c>>2]=j[c>>2]+p(f,j[b+8>>2]);o=e+o|0;m=o>>12;j[c+4>>2]=j[c+4>>2]+p(m,j[b+12>>2]);Bb(b+24|0,b+16|0);d=d-1|0;if(d){c=c+8|0;k=j[b+24>>2];e=j[b+28>>2];continue}break}k=j[b+24>>2];e=j[b+28>>2];i=j[b+44>>2];g=j[b+40>>2];n=j[b+36>>2];l=j[b+32>>2]}j[a+40>>2]=o;j[a+20>>2]=f;j[a+36>>2]=q;j[a+56>>2]=i;j[a+52>>2]=g;j[a+48>>2]=n;j[a+44>>2]=l;j[a+24>>2]=m;j[a>>2]=k;j[a+4>>2]=e;Za=b+48|0}function F1(a,b,c,d,e){var f=0,g=0,h=0,i=0;f=Za-352|0;Za=f;j[f+336>>2]=b;j[f+344>>2]=a;h=Eg(c);i=am(c,f+224|0);$l(f+208|0,c,f+332|0);a=Cb(f+192|0);b=sc(a);j[114630]=0;F(149,a|0,b|0);b=j[114630];j[114630]=0;a:{b:{if((b|0)!=1){b=Ub(a,0);j[f+188>>2]=b;j[f+12>>2]=f+16;j[f+8>>2]=0;while(1){c:{j[114630]=0;c=E(2455,f+344|0,f+336|0)|0;g=j[114630];j[114630]=0;if((g|0)==1){break c}if(!c){break b}if(j[f+188>>2]==(nb(a)+b|0)){c=nb(a);b=nb(a);j[114630]=0;F(149,a|0,b<<1);b=j[114630];j[114630]=0;if((b|0)==1){break a}b=sc(a);j[114630]=0;F(149,a|0,b|0);b=j[114630];j[114630]=0;if((b|0)==1){break a}b=Ub(a,0);j[f+188>>2]=c+b}j[114630]=0;c=H(2457,f+344|0)|0;g=j[114630];j[114630]=0;if((g|0)==1){break c}j[114630]=0;c=wj(c,h,b,f+188|0,f+8|0,j[f+332>>2],f+208|0,f+16|0,f+12|0,i);g=j[114630];j[114630]=0;if((g|0)==1){break c}if(c){break b}j[114630]=0;H(2459,f+344|0)|0;c=j[114630];j[114630]=0;if((c|0)!=1){continue}}break}break a}break a}d:{if(!nb(f+208|0)){break d}c=j[f+12>>2];if((c-(f+16|0)|0)>159){break d}j[f+12>>2]=c+4;j[c>>2]=j[f+8>>2]}j[114630]=0;b=P(2430,b|0,j[f+188>>2],d|0,h|0)|0;c=j[114630];j[114630]=0;e:{if((c|0)==1){break e}j[e>>2]=b;j[114630]=0;le(f+208|0,f+16|0,j[f+12>>2],d);b=j[114630];j[114630]=0;if((b|0)==1){break e}j[114630]=0;b=E(2456,f+344|0,f+336|0)|0;c=j[114630];j[114630]=0;if((c|0)==1){break e}if(b){j[d>>2]=j[d>>2]|2}b=j[f+344>>2];gb(a);gb(f+208|0);Za=f+352|0;return b}}b=D()|0;C()|0;gb(a);gb(f+208|0);G(b|0);z()}function A1(a,b,c,d,e){var f=0,g=0,h=0,k=0;f=Za-352|0;Za=f;j[f+336>>2]=b;j[f+344>>2]=a;h=Eg(c);k=am(c,f+224|0);$l(f+208|0,c,f+332|0);a=Cb(f+192|0);b=sc(a);j[114630]=0;F(149,a|0,b|0);b=j[114630];j[114630]=0;a:{b:{if((b|0)!=1){b=Ub(a,0);j[f+188>>2]=b;j[f+12>>2]=f+16;j[f+8>>2]=0;while(1){c:{j[114630]=0;c=E(2455,f+344|0,f+336|0)|0;g=j[114630];j[114630]=0;if((g|0)==1){break c}if(!c){break b}if(j[f+188>>2]==(nb(a)+b|0)){c=nb(a);b=nb(a);j[114630]=0;F(149,a|0,b<<1);b=j[114630];j[114630]=0;if((b|0)==1){break a}b=sc(a);j[114630]=0;F(149,a|0,b|0);b=j[114630];j[114630]=0;if((b|0)==1){break a}b=Ub(a,0);j[f+188>>2]=c+b}j[114630]=0;c=H(2457,f+344|0)|0;g=j[114630];j[114630]=0;if((g|0)==1){break c}j[114630]=0;c=wj(c,h,b,f+188|0,f+8|0,j[f+332>>2],f+208|0,f+16|0,f+12|0,k);g=j[114630];j[114630]=0;if((g|0)==1){break c}if(c){break b}j[114630]=0;H(2459,f+344|0)|0;c=j[114630];j[114630]=0;if((c|0)!=1){continue}}break}break a}break a}d:{if(!nb(f+208|0)){break d}c=j[f+12>>2];if((c-(f+16|0)|0)>159){break d}j[f+12>>2]=c+4;j[c>>2]=j[f+8>>2]}j[114630]=0;b=P(2435,b|0,j[f+188>>2],d|0,h|0)|0;c=j[114630];j[114630]=0;e:{if((c|0)==1){break e}i[e>>1]=b;j[114630]=0;le(f+208|0,f+16|0,j[f+12>>2],d);b=j[114630];j[114630]=0;if((b|0)==1){break e}j[114630]=0;b=E(2456,f+344|0,f+336|0)|0;c=j[114630];j[114630]=0;if((c|0)==1){break e}if(b){j[d>>2]=j[d>>2]|2}b=j[f+344>>2];gb(a);gb(f+208|0);Za=f+352|0;return b}}b=D()|0;C()|0;gb(a);gb(f+208|0);G(b|0);z()}function e2(a,b,c,d,e){var f=0,g=0,i=0;f=Za-272|0;Za=f;j[f+256>>2]=b;j[f+264>>2]=a;i=Eg(c);bm(f+208|0,c,f+255|0);a=Cb(f+192|0);b=sc(a);j[114630]=0;F(149,a|0,b|0);b=j[114630];j[114630]=0;a:{b:{if((b|0)!=1){b=Ub(a,0);j[f+188>>2]=b;j[f+12>>2]=f+16;j[f+8>>2]=0;while(1){c:{j[114630]=0;c=E(2423,f+264|0,f+256|0)|0;g=j[114630];j[114630]=0;if((g|0)==1){break c}if(!c){break b}if(j[f+188>>2]==(nb(a)+b|0)){c=nb(a);b=nb(a);j[114630]=0;F(149,a|0,b<<1);b=j[114630];j[114630]=0;if((b|0)==1){break a}b=sc(a);j[114630]=0;F(149,a|0,b|0);b=j[114630];j[114630]=0;if((b|0)==1){break a}b=Ub(a,0);j[f+188>>2]=c+b}j[114630]=0;c=H(2425,f+264|0)|0;g=j[114630];j[114630]=0;if((g|0)==1){break c}j[114630]=0;c=xj(c,i,b,f+188|0,f+8|0,h[f+255|0],f+208|0,f+16|0,f+12|0,64416);g=j[114630];j[114630]=0;if((g|0)==1){break c}if(c){break b}j[114630]=0;H(2427,f+264|0)|0;c=j[114630];j[114630]=0;if((c|0)!=1){continue}}break}break a}break a}d:{if(!nb(f+208|0)){break d}c=j[f+12>>2];if((c-(f+16|0)|0)>159){break d}j[f+12>>2]=c+4;j[c>>2]=j[f+8>>2]}j[114630]=0;b=Kn(2434,b,j[f+188>>2],d,i);c=ab;i=j[114630];j[114630]=0;e:{if((i|0)==1){break e}j[e>>2]=b;j[e+4>>2]=c;j[114630]=0;le(f+208|0,f+16|0,j[f+12>>2],d);b=j[114630];j[114630]=0;if((b|0)==1){break e}j[114630]=0;b=E(2424,f+264|0,f+256|0)|0;c=j[114630];j[114630]=0;if((c|0)==1){break e}if(b){j[d>>2]=j[d>>2]|2}b=j[f+264>>2];gb(a);gb(f+208|0);Za=f+272|0;return b}}b=D()|0;C()|0;gb(a);gb(f+208|0);G(b|0);z()}function V1(a,b,c,d,e){var f=0,g=0,i=0;f=Za-272|0;Za=f;j[f+256>>2]=b;j[f+264>>2]=a;i=Eg(c);bm(f+208|0,c,f+255|0);a=Cb(f+192|0);b=sc(a);j[114630]=0;F(149,a|0,b|0);b=j[114630];j[114630]=0;a:{b:{if((b|0)!=1){b=Ub(a,0);j[f+188>>2]=b;j[f+12>>2]=f+16;j[f+8>>2]=0;while(1){c:{j[114630]=0;c=E(2423,f+264|0,f+256|0)|0;g=j[114630];j[114630]=0;if((g|0)==1){break c}if(!c){break b}if(j[f+188>>2]==(nb(a)+b|0)){c=nb(a);b=nb(a);j[114630]=0;F(149,a|0,b<<1);b=j[114630];j[114630]=0;if((b|0)==1){break a}b=sc(a);j[114630]=0;F(149,a|0,b|0);b=j[114630];j[114630]=0;if((b|0)==1){break a}b=Ub(a,0);j[f+188>>2]=c+b}j[114630]=0;c=H(2425,f+264|0)|0;g=j[114630];j[114630]=0;if((g|0)==1){break c}j[114630]=0;c=xj(c,i,b,f+188|0,f+8|0,h[f+255|0],f+208|0,f+16|0,f+12|0,64416);g=j[114630];j[114630]=0;if((g|0)==1){break c}if(c){break b}j[114630]=0;H(2427,f+264|0)|0;c=j[114630];j[114630]=0;if((c|0)!=1){continue}}break}break a}break a}d:{if(!nb(f+208|0)){break d}c=j[f+12>>2];if((c-(f+16|0)|0)>159){break d}j[f+12>>2]=c+4;j[c>>2]=j[f+8>>2]}j[114630]=0;b=Kn(2438,b,j[f+188>>2],d,i);c=ab;i=j[114630];j[114630]=0;e:{if((i|0)==1){break e}j[e>>2]=b;j[e+4>>2]=c;j[114630]=0;le(f+208|0,f+16|0,j[f+12>>2],d);b=j[114630];j[114630]=0;if((b|0)==1){break e}j[114630]=0;b=E(2424,f+264|0,f+256|0)|0;c=j[114630];j[114630]=0;if((c|0)==1){break e}if(b){j[d>>2]=j[d>>2]|2}b=j[f+264>>2];gb(a);gb(f+208|0);Za=f+272|0;return b}}b=D()|0;C()|0;gb(a);gb(f+208|0);G(b|0);z()}function I9(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;b=Za-176|0;Za=b;d=Db(b+8|0,38726);j[114630]=0;E(85,b+20|0,38731)|0;e=j[114630];j[114630]=0;c=1;a:{b:{if((e|0)==1){break b}j[114630]=0;E(85,b+32|0,38741)|0;c=j[114630];j[114630]=0;if((c|0)==1){c=2;break b}j[114630]=0;E(85,b+44|0,38754)|0;c=j[114630];j[114630]=0;if((c|0)==1){c=3;break b}j[114630]=0;E(85,b+56|0,38772)|0;c=j[114630];j[114630]=0;if((c|0)==1){c=4;break b}j[114630]=0;E(85,b+68|0,38782)|0;c=j[114630];j[114630]=0;if((c|0)==1){c=5;break b}j[114630]=0;E(85,b+80|0,38797)|0;c=j[114630];j[114630]=0;if((c|0)==1){c=6;break b}j[114630]=0;E(85,b+92|0,38805)|0;c=j[114630];j[114630]=0;if((c|0)==1){c=7;break b}j[114630]=0;E(85,b+104|0,38812)|0;c=j[114630];j[114630]=0;if((c|0)==1){c=8;break b}j[114630]=0;E(85,b+116|0,38818)|0;c=j[114630];j[114630]=0;if((c|0)==1){c=9;break b}j[114630]=0;E(85,b+128|0,38823)|0;c=j[114630];j[114630]=0;if((c|0)==1){c=10;break b}j[114630]=0;E(85,b+140|0,38831)|0;c=j[114630];j[114630]=0;if((c|0)==1){c=11;break b}j[114630]=0;E(85,b+152|0,38843)|0;c=j[114630];j[114630]=0;if((c|0)==1){c=12;break b}j[114630]=0;j[b+172>>2]=13;j[b+168>>2]=d;c=j[b+172>>2];j[b>>2]=j[b+168>>2];j[b+4>>2]=c;E(2173,a|0,b|0)|0;a=j[114630];j[114630]=0;if((a|0)!=1){c=b+164|0;while(1){c=gb(c-12|0);if((d|0)!=(c|0)){continue}break}Za=b+176|0;return}c=b+164|0;break a}c=(b+8|0)+p(c,12)|0}a=D()|0;C()|0;while(1){c=gb(c-12|0);if((d|0)!=(c|0)){continue}break}G(a|0);z()}function rea(a,b,c){var d=0,e=0,f=q(0),g=0,h=0,k=0,m=0,o=0,s=0,u=0,v=0,w=q(0);e=j[a+24>>2];j[b>>2]=e;d=j[a+16>>2];j[b+4>>2]=d;j[b+8>>2]=j[a+4>>2];h=(d|0)<(e|0)?e:d;if((h|0)<=-601){g=d;d=h+600|0;j[b+4>>2]=g-d;j[b>>2]=e-d}d=b;f=q(n[a+36>>2]*q(79.30999755859375));a:{if(q(r(f))<q(2147483648)){e=~~f;break a}e=-2147483648}j[d+16>>2]=e- -8192;e=b;f=q(q(n[a+32>>2]*q(117.9612045288086))+q(4915.05029296875));b:{if(q(r(f))<q(2147483648)){d=~~f;break b}d=-2147483648}j[e+20>>2]=(d|0)<32512?d:32512;h=0;f=q(q(t(n[a+20>>2],q(.10000000149011612)))*c);c:{if(q(r(f))<q(2147483648)){e=~~f;break c}e=-2147483648}d=(e|0)<96;k=d?96:e;m=(k|0)>7500;g=m?k-7500|0:0;d=d?e-96|0:0;f=q(n[a+28>>2]*c);d:{if(q(r(f))<q(2147483648)){e=~~f;break d}e=-2147483648}f=n[a+8>>2];e=g+(d+e|0)|0;d=(e|0)<128;g=d?128:e;o=(g|0)>3800;s=o?3800:g;j[b+24>>2]=s;e=d?e-128|0:0;d=b;c=q(f*c);e:{if(q(r(c))<q(2147483648)){u=~~c;break e}u=-2147483648}g=(u+e|0)+(o?g-3800|0:0)|0;j[d+32>>2]=g;k=m?7500:k;while(1){d=p(h,12);e=d+b|0;d=d+34032|0;i[e+42>>1]=l[d+10>>1];i[e+36>>1]=l[d+4>>1];m=l[d+6>>1]|l[d+8>>1]<<16;i[e+38>>1]=m;i[e+40>>1]=m>>>16;j[e+44>>2]=k+((p(j[d>>2],s)+50|0)/100|0);h=h+1|0;if((h|0)!=8){continue}break}d=b;c=q(g|0);f=q(Yd(q(.0010000000474974513),(g|0)<4721?q(1):q(q(4720)/c))*q(32768));f:{if(q(r(f))<q(2147483648)){e=~~f;break f}e=-2147483648}j[d+12>>2]=e;c=q(n[a+12>>2]*c);v=b,w=Yd(q(.0010000000474974513),c>q(4720)?q(q(4720)/c):q(1)),n[v+28>>2]=w}function TE(a){var b=0,c=0,d=0,e=0;Fd(a,j[a+20>>2]);if(j[a+24>>2]>=1){while(1){Fd(a,j[j[a+28>>2]+(b<<2)>>2]);b=b+1|0;if((b|0)<j[a+24>>2]){continue}break}}Fd(a,j[a+28>>2]);a:{b=j[a+396>>2];if(!b|j[a+264>>2]<1){break a}while(1){c=p(e,24)+b|0;b=j[c+16>>2];if(b){d=a;if(j[(j[a+124>>2]+p(k[c+13|0],2096)|0)+4>>2]>=1){Fd(a,j[b>>2]);b=1;if(j[(j[a+124>>2]+p(k[c+13|0],2096)|0)+4>>2]>=2){while(1){Fd(a,j[j[c+16>>2]+(b<<2)>>2]);b=b+1|0;if((b|0)<j[(j[a+124>>2]+p(k[c+13|0],2096)|0)+4>>2]){continue}break}}b=j[c+16>>2]}Fd(d,b)}Fd(a,j[c+20>>2]);e=e+1|0;if((e|0)>=j[a+264>>2]){break a}b=j[a+396>>2];continue}}b=j[a+124>>2];if(b){d=a;if(j[a+120>>2]>=1){c=0;while(1){b=p(c,2096)+b|0;Fd(a,j[b+8>>2]);Fd(a,j[b+28>>2]);Fd(a,j[b+32>>2]);Fd(a,j[b+2084>>2]);b=j[b+2088>>2];Fd(a,b?b-4|0:0);c=c+1|0;if((c|0)<j[a+120>>2]){b=j[a+124>>2];continue}break}b=j[a+124>>2]}Fd(d,b)}Fd(a,j[a+260>>2]);Fd(a,j[a+396>>2]);d=j[a+404>>2];if(d){b=1;c=a;if(j[a+400>>2]>=1){Fd(a,j[d+4>>2]);if(j[a+400>>2]>=2){while(1){Fd(a,j[(j[a+404>>2]+p(b,40)|0)+4>>2]);b=b+1|0;if((b|0)<j[a+400>>2]){continue}break}}d=j[a+404>>2]}Fd(c,d)}c=1;b:{if(j[a+4>>2]<1){break b}b=0;while(1){d=(b<<2)+a|0;Fd(a,j[d+800>>2]);Fd(a,j[d+928>>2]);Fd(a,j[d+996>>2]);if(b>>>0>14){break b}b=b+1|0;if((b|0)<j[a+4>>2]){continue}break}}b=0;while(1){b=(b<<2)+a|0;Fd(a,j[b+1068>>2]);Fd(a,j[b+1076>>2]);Fd(a,j[b+1084>>2]);Fd(a,j[b+1092>>2]);Fd(a,j[b+1100>>2]);b=1;d=c&1;c=0;if(d){continue}break}}function h2(a,b,c,d,e){var f=0,g=0,i=0;f=Za-272|0;Za=f;j[f+256>>2]=b;j[f+264>>2]=a;i=Eg(c);bm(f+208|0,c,f+255|0);a=Cb(f+192|0);b=sc(a);j[114630]=0;F(149,a|0,b|0);b=j[114630];j[114630]=0;a:{b:{if((b|0)!=1){b=Ub(a,0);j[f+188>>2]=b;j[f+12>>2]=f+16;j[f+8>>2]=0;while(1){c:{j[114630]=0;c=E(2423,f+264|0,f+256|0)|0;g=j[114630];j[114630]=0;if((g|0)==1){break c}if(!c){break b}if(j[f+188>>2]==(nb(a)+b|0)){c=nb(a);b=nb(a);j[114630]=0;F(149,a|0,b<<1);b=j[114630];j[114630]=0;if((b|0)==1){break a}b=sc(a);j[114630]=0;F(149,a|0,b|0);b=j[114630];j[114630]=0;if((b|0)==1){break a}b=Ub(a,0);j[f+188>>2]=c+b}j[114630]=0;c=H(2425,f+264|0)|0;g=j[114630];j[114630]=0;if((g|0)==1){break c}j[114630]=0;c=xj(c,i,b,f+188|0,f+8|0,h[f+255|0],f+208|0,f+16|0,f+12|0,64416);g=j[114630];j[114630]=0;if((g|0)==1){break c}if(c){break b}j[114630]=0;H(2427,f+264|0)|0;c=j[114630];j[114630]=0;if((c|0)!=1){continue}}break}break a}break a}d:{if(!nb(f+208|0)){break d}c=j[f+12>>2];if((c-(f+16|0)|0)>159){break d}j[f+12>>2]=c+4;j[c>>2]=j[f+8>>2]}j[114630]=0;b=P(2430,b|0,j[f+188>>2],d|0,i|0)|0;c=j[114630];j[114630]=0;e:{if((c|0)==1){break e}j[e>>2]=b;j[114630]=0;le(f+208|0,f+16|0,j[f+12>>2],d);b=j[114630];j[114630]=0;if((b|0)==1){break e}j[114630]=0;b=E(2424,f+264|0,f+256|0)|0;c=j[114630];j[114630]=0;if((c|0)==1){break e}if(b){j[d>>2]=j[d>>2]|2}b=j[f+264>>2];gb(a);gb(f+208|0);Za=f+272|0;return b}}b=D()|0;C()|0;gb(a);gb(f+208|0);G(b|0);z()}function b2(a,b,c,d,e){var f=0,g=0,k=0;f=Za-272|0;Za=f;j[f+256>>2]=b;j[f+264>>2]=a;k=Eg(c);bm(f+208|0,c,f+255|0);a=Cb(f+192|0);b=sc(a);j[114630]=0;F(149,a|0,b|0);b=j[114630];j[114630]=0;a:{b:{if((b|0)!=1){b=Ub(a,0);j[f+188>>2]=b;j[f+12>>2]=f+16;j[f+8>>2]=0;while(1){c:{j[114630]=0;c=E(2423,f+264|0,f+256|0)|0;g=j[114630];j[114630]=0;if((g|0)==1){break c}if(!c){break b}if(j[f+188>>2]==(nb(a)+b|0)){c=nb(a);b=nb(a);j[114630]=0;F(149,a|0,b<<1);b=j[114630];j[114630]=0;if((b|0)==1){break a}b=sc(a);j[114630]=0;F(149,a|0,b|0);b=j[114630];j[114630]=0;if((b|0)==1){break a}b=Ub(a,0);j[f+188>>2]=c+b}j[114630]=0;c=H(2425,f+264|0)|0;g=j[114630];j[114630]=0;if((g|0)==1){break c}j[114630]=0;c=xj(c,k,b,f+188|0,f+8|0,h[f+255|0],f+208|0,f+16|0,f+12|0,64416);g=j[114630];j[114630]=0;if((g|0)==1){break c}if(c){break b}j[114630]=0;H(2427,f+264|0)|0;c=j[114630];j[114630]=0;if((c|0)!=1){continue}}break}break a}break a}d:{if(!nb(f+208|0)){break d}c=j[f+12>>2];if((c-(f+16|0)|0)>159){break d}j[f+12>>2]=c+4;j[c>>2]=j[f+8>>2]}j[114630]=0;b=P(2435,b|0,j[f+188>>2],d|0,k|0)|0;c=j[114630];j[114630]=0;e:{if((c|0)==1){break e}i[e>>1]=b;j[114630]=0;le(f+208|0,f+16|0,j[f+12>>2],d);b=j[114630];j[114630]=0;if((b|0)==1){break e}j[114630]=0;b=E(2424,f+264|0,f+256|0)|0;c=j[114630];j[114630]=0;if((c|0)==1){break e}if(b){j[d>>2]=j[d>>2]|2}b=j[f+264>>2];gb(a);gb(f+208|0);Za=f+272|0;return b}}b=D()|0;C()|0;gb(a);gb(f+208|0);G(b|0);z()}function Z1(a,b,c,d,e){var f=0,g=0,i=0;f=Za-272|0;Za=f;j[f+256>>2]=b;j[f+264>>2]=a;i=Eg(c);bm(f+208|0,c,f+255|0);a=Cb(f+192|0);b=sc(a);j[114630]=0;F(149,a|0,b|0);b=j[114630];j[114630]=0;a:{b:{if((b|0)!=1){b=Ub(a,0);j[f+188>>2]=b;j[f+12>>2]=f+16;j[f+8>>2]=0;while(1){c:{j[114630]=0;c=E(2423,f+264|0,f+256|0)|0;g=j[114630];j[114630]=0;if((g|0)==1){break c}if(!c){break b}if(j[f+188>>2]==(nb(a)+b|0)){c=nb(a);b=nb(a);j[114630]=0;F(149,a|0,b<<1);b=j[114630];j[114630]=0;if((b|0)==1){break a}b=sc(a);j[114630]=0;F(149,a|0,b|0);b=j[114630];j[114630]=0;if((b|0)==1){break a}b=Ub(a,0);j[f+188>>2]=c+b}j[114630]=0;c=H(2425,f+264|0)|0;g=j[114630];j[114630]=0;if((g|0)==1){break c}j[114630]=0;c=xj(c,i,b,f+188|0,f+8|0,h[f+255|0],f+208|0,f+16|0,f+12|0,64416);g=j[114630];j[114630]=0;if((g|0)==1){break c}if(c){break b}j[114630]=0;H(2427,f+264|0)|0;c=j[114630];j[114630]=0;if((c|0)!=1){continue}}break}break a}break a}d:{if(!nb(f+208|0)){break d}c=j[f+12>>2];if((c-(f+16|0)|0)>159){break d}j[f+12>>2]=c+4;j[c>>2]=j[f+8>>2]}j[114630]=0;b=P(2436,b|0,j[f+188>>2],d|0,i|0)|0;c=j[114630];j[114630]=0;e:{if((c|0)==1){break e}j[e>>2]=b;j[114630]=0;le(f+208|0,f+16|0,j[f+12>>2],d);b=j[114630];j[114630]=0;if((b|0)==1){break e}j[114630]=0;b=E(2424,f+264|0,f+256|0)|0;c=j[114630];j[114630]=0;if((c|0)==1){break e}if(b){j[d>>2]=j[d>>2]|2}b=j[f+264>>2];gb(a);gb(f+208|0);Za=f+272|0;return b}}b=D()|0;C()|0;gb(a);gb(f+208|0);G(b|0);z()}function X1(a,b,c,d,e){var f=0,g=0,i=0;f=Za-272|0;Za=f;j[f+256>>2]=b;j[f+264>>2]=a;i=Eg(c);bm(f+208|0,c,f+255|0);a=Cb(f+192|0);b=sc(a);j[114630]=0;F(149,a|0,b|0);b=j[114630];j[114630]=0;a:{b:{if((b|0)!=1){b=Ub(a,0);j[f+188>>2]=b;j[f+12>>2]=f+16;j[f+8>>2]=0;while(1){c:{j[114630]=0;c=E(2423,f+264|0,f+256|0)|0;g=j[114630];j[114630]=0;if((g|0)==1){break c}if(!c){break b}if(j[f+188>>2]==(nb(a)+b|0)){c=nb(a);b=nb(a);j[114630]=0;F(149,a|0,b<<1);b=j[114630];j[114630]=0;if((b|0)==1){break a}b=sc(a);j[114630]=0;F(149,a|0,b|0);b=j[114630];j[114630]=0;if((b|0)==1){break a}b=Ub(a,0);j[f+188>>2]=c+b}j[114630]=0;c=H(2425,f+264|0)|0;g=j[114630];j[114630]=0;if((g|0)==1){break c}j[114630]=0;c=xj(c,i,b,f+188|0,f+8|0,h[f+255|0],f+208|0,f+16|0,f+12|0,64416);g=j[114630];j[114630]=0;if((g|0)==1){break c}if(c){break b}j[114630]=0;H(2427,f+264|0)|0;c=j[114630];j[114630]=0;if((c|0)!=1){continue}}break}break a}break a}d:{if(!nb(f+208|0)){break d}c=j[f+12>>2];if((c-(f+16|0)|0)>159){break d}j[f+12>>2]=c+4;j[c>>2]=j[f+8>>2]}j[114630]=0;b=P(2437,b|0,j[f+188>>2],d|0,i|0)|0;c=j[114630];j[114630]=0;e:{if((c|0)==1){break e}j[e>>2]=b;j[114630]=0;le(f+208|0,f+16|0,j[f+12>>2],d);b=j[114630];j[114630]=0;if((b|0)==1){break e}j[114630]=0;b=E(2424,f+264|0,f+256|0)|0;c=j[114630];j[114630]=0;if((c|0)==1){break e}if(b){j[d>>2]=j[d>>2]|2}b=j[f+264>>2];gb(a);gb(f+208|0);Za=f+272|0;return b}}b=D()|0;C()|0;gb(a);gb(f+208|0);G(b|0);z()}function Dva(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;e=Za-48|0;Za=e;r=j[a+16>>2];f=j[a+44>>2];j[e+32>>2]=f;h=j[a+48>>2];j[e+36>>2]=h;n=j[a+52>>2];j[e+40>>2]=n;k=j[a+56>>2];j[e+44>>2]=k;s=j[a+24>>2];t=j[a+20>>2];b=j[a+4>>2];g=j[a>>2];j[e+24>>2]=g;j[e+28>>2]=b;l=j[a+12>>2];j[e+16>>2]=j[a+8>>2];j[e+20>>2]=l;u=a;if(d){while(1){l=g>>>18|0;n=1;k=((((b&2147483647)<<1|g>>>31)&2147483646)<<1)+r|0;f=0;b=1;h=0;while(1){m=h<<1;g=i[m+k>>1];j[(e+8|0)+(h<<2)>>2]=g+((p(l,i[k+(m|4)>>1]-g|0)|0)/16384|0);g=b;b=0;h=1;if(g){continue}break}while(1){h=(e+8|0)+(f<<2)|0;l=j[h>>2];m=j[a+60>>2];g=(e+32|0)+(f<<3)|0;f=j[g>>2];b=Gb(f,-16777216,16776704);q=j[a+64>>2];k=Gb(j[g+4>>2],-16777216,16776704);o=j[a+68>>2];v=o;o=o>>31;j[g+4>>2]=f;w=j[a+72>>2];l=l<<8;f=l;f=HMa(m,m>>31,f,f>>31);m=ab;x=h;h=HMa(q,q>>31,b,b>>31);f=h+f|0;b=ab+m|0;b=f>>>0<h>>>0?b+1|0:b;h=f;f=HMa(v,o,k,k>>31);k=h+f|0;b=ab+b|0;b=f>>>0>k>>>0?b+1|0:b;k=k+8388608|0;if(k>>>0<8388608){b=b+1|0}b=(b&16777215)<<8|k>>>24;j[x>>2]=(b|0)/256;j[g>>2]=b-(l&w);f=1;b=n&1;n=0;if(b){continue}break}j[c>>2]=j[c>>2]+p(j[e+8>>2],t);j[c+4>>2]=j[c+4>>2]+p(j[e+12>>2],s);Bb(e+24|0,e+16|0);d=d-1|0;if(d){c=c+8|0;g=j[e+24>>2];b=j[e+28>>2];continue}break}g=j[e+24>>2];b=j[e+28>>2];n=j[e+40>>2];h=j[e+36>>2];f=j[e+32>>2];k=j[e+44>>2]}j[u+56>>2]=k;j[a+52>>2]=n;j[a+48>>2]=h;j[a+44>>2]=f;j[a>>2]=g;j[a+4>>2]=b;Za=e+48|0}function Eva(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,i=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;e=Za-48|0;Za=e;t=j[a+16>>2];f=j[a+44>>2];j[e+32>>2]=f;k=j[a+48>>2];j[e+36>>2]=k;b=j[a+52>>2];j[e+40>>2]=b;n=j[a+56>>2];j[e+44>>2]=n;u=j[a+24>>2];v=j[a+20>>2];i=j[a+4>>2];g=j[a>>2];j[e+24>>2]=g;j[e+28>>2]=i;m=j[a+12>>2];j[e+16>>2]=j[a+8>>2];j[e+20>>2]=m;if(d){while(1){m=g>>>10&4194048;g=(((i&2147483647)<<1|g>>>31)&-2)+t|0;k=0;n=1;b=1;f=0;while(1){i=h[g+f|0];j[(e+8|0)+(f<<2)>>2]=((p(m,h[g+(f|2)|0]-i|0)|0)/16384|0)+(i<<8);i=b;b=0;f=1;if(i){continue}break}while(1){f=(e+8|0)+(k<<2)|0;m=j[f>>2];l=j[a+60>>2];q=l;i=(e+32|0)+(k<<3)|0;k=j[i>>2];b=Gb(k,-16777216,16776704);s=j[a+64>>2];g=Gb(j[i+4>>2],-16777216,16776704);o=j[a+68>>2];w=o;o=o>>31;j[i+4>>2]=k;k=j[a+72>>2];r=l>>31;m=m<<8;l=m;l=HMa(q,r,l,l>>31);q=ab;r=f;f=l;l=HMa(s,s>>31,b,b>>31);f=f+l|0;b=ab+q|0;b=f>>>0<l>>>0?b+1|0:b;l=f;f=HMa(w,o,g,g>>31);g=l+f|0;b=ab+b|0;b=g>>>0<f>>>0?b+1|0:b;g=g+8388608|0;if(g>>>0<8388608){b=b+1|0}b=(b&16777215)<<8|g>>>24;j[r>>2]=(b|0)/256;j[i>>2]=b-(k&m);k=1;b=n&1;n=0;if(b){continue}break}j[c>>2]=j[c>>2]+p(j[e+8>>2],v);j[c+4>>2]=j[c+4>>2]+p(j[e+12>>2],u);Bb(e+24|0,e+16|0);d=d-1|0;if(d){c=c+8|0;g=j[e+24>>2];i=j[e+28>>2];continue}break}g=j[e+24>>2];i=j[e+28>>2];n=j[e+44>>2];k=j[e+36>>2];f=j[e+32>>2];b=j[e+40>>2]}j[a+56>>2]=n;j[a+52>>2]=b;j[a+48>>2]=k;j[a+44>>2]=f;j[a>>2]=g;j[a+4>>2]=i;Za=e+48|0}function Y0(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;var i=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;n=Za-16|0;Za=n;o=dv(g);g=Ru(g);Tf(n,g);a:{b:{if(Ec(n)){j[114630]=0;P(2464,o|0,a|0,c|0,d|0)|0;g=j[114630];j[114630]=0;if((g|0)==1){break b}g=(c-a<<2)+d|0;j[f>>2]=g;break a}j[f>>2]=d;c:{d:{m=a;i=k[m|0];switch(i-43|0){case 0:case 2:break d;default:break c}}j[114630]=0;m=E(2476,o|0,i<<24>>24)|0;i=j[114630];j[114630]=0;if((i|0)==1){break b}i=j[f>>2];j[f>>2]=i+4;j[i>>2]=m;m=a+1|0}if(!(k[m|0]!=48|(c-m|0)<2|(k[m+1|0]|32)!=120)){j[114630]=0;i=E(2476,o|0,48)|0;l=j[114630];j[114630]=0;if((l|0)==1){break b}l=j[f>>2];j[f>>2]=l+4;j[l>>2]=i;i=h[m+1|0];j[114630]=0;i=E(2476,o|0,i|0)|0;l=j[114630];j[114630]=0;if((l|0)==1){break b}l=j[f>>2];j[f>>2]=l+4;j[l>>2]=i;m=m+2|0}l=0;j[114630]=0;uj(m,c);i=j[114630];j[114630]=0;if((i|0)==1){break b}j[114630]=0;r=H(2461,g|0)|0;g=j[114630];j[114630]=0;if((g|0)==1){break b}i=0;g=m;while(1){e:{if(c>>>0<=g>>>0){g=j[f>>2];j[114630]=0;Sn((m-a<<2)+d|0,g);g=j[114630];j[114630]=0;if((g|0)==1){break e}g=j[f>>2];break a}f:{if(!k[Ub(n,i)|0]){break f}if(h[Ub(n,i)|0]!=(l|0)){break f}l=j[f>>2];j[f>>2]=l+4;j[l>>2]=r;i=(nb(n)-1>>>0>i>>>0)+i|0;l=0}q=h[g|0];j[114630]=0;q=E(2476,o|0,q|0)|0;p=j[114630];j[114630]=0;if((p|0)!=1){p=j[f>>2];j[f>>2]=p+4;j[p>>2]=q;g=g+1|0;l=l+1|0;continue}}break}}a=D()|0;C()|0;gb(n);G(a|0);z()}j[e>>2]=(b|0)==(c|0)?g:(b-a<<2)+d|0;gb(n);Za=n+16|0}function Io(a,b,c,d){var e=0,f=q(0),g=q(0),o=q(0),r=0,s=0,t=0,u=0,v=q(0),w=0,x=0,y=0;e=Za-16|0;Za=e;j[e+12>>2]=i[b+792>>1]+k[b+857|0];j[e+8>>2]=i[b+794>>1]+(k[b+858|0]&127);Md(e+12|0,0,127);Md(e+8|0,0,127);t=a+1074308|0;mb(e,t,1);r=kb(e);s=j[e+12>>2];if(!r){i[b+792>>1]=0;h[b+857|0]=s;r=j[e+8>>2];i[b+794>>1]=0;h[b+858|0]=r}mb(e,t,36);r=p(s,d+256|0);s=(r|0)/256|0;w=kb(e);u=j[e+8>>2];a:{if(!(u|!w|(r|0)<65024)){s=-1;a=b+810|0;if(!Mf(a)){break a}if(Wr(a)|l[b+808>>1]|(j[b>>2]|j[b+4>>2])){break a}a=j[b+88>>2];if(a&8192){break a}j[b+88>>2]=a&-32769;break a}j[b+88>>2]=j[b+88>>2]|32768;f=Yd(q(10),q(q(0-u|0)*q(.00937500037252903)));d=mpa(a,j[e+12>>2],d);mb(e,t,36);o=q(q(d>>>0)*q(6.2831854820251465));b:{if(!(!kb(e)|j[a+480208>>2]&32768)){g=q(q(m[a+24620>>2])/o);o=q(q(f+q(-1))+q(g*f));n[e>>2]=o;f=q(g*g);break b}g=q(o/q(m[a+24620>>2]));f=q(f+f);n[e>>2]=g*q(q(1)-f);YK(e,q(2));o=q(q(f-n[e>>2])/g);n[e>>2]=o;f=q(q(1)/q(g*g))}g=q(q(o+f)+q(1));o=q(q(q(f+f)+o)/g);v=q(q(16777216)/g);f=q(q(-f)/g);c:{if(k[b+865|0]==1){x=b,y=ph(q(q(16777216)-v)),j[x+60>>2]=y;x=b,y=ph(q(o*q(16777216))),j[x+64>>2]=y;x=b,y=ph(q(f*q(16777216))),j[x+68>>2]=y;a=-1;break c}x=b,y=ph(v),j[x+60>>2]=y;x=b,y=ph(q(o*q(16777216))),j[x+64>>2]=y;x=b,y=ph(q(f*q(16777216))),j[x+68>>2]=y;a=0;if(j[b+60>>2]){break c}j[b+60>>2]=1}j[b+72>>2]=a;if(!c){break a}j[b+44>>2]=0;j[b+48>>2]=0;j[b+52>>2]=0;j[b+56>>2]=0}Za=e+16|0;return s}function i1(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;var i=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;n=Za-16|0;Za=n;o=Tt(g);g=Uu(g);Tf(n,g);a:{b:{if(Ec(n)){j[114630]=0;P(2441,o|0,a|0,c|0,d|0)|0;g=j[114630];j[114630]=0;if((g|0)==1){break b}g=(c-a|0)+d|0;j[f>>2]=g;break a}j[f>>2]=d;c:{d:{m=a;i=k[m|0];switch(i-43|0){case 0:case 2:break d;default:break c}}j[114630]=0;m=E(22,o|0,i<<24>>24)|0;i=j[114630];j[114630]=0;if((i|0)==1){break b}i=j[f>>2];j[f>>2]=i+1;h[i|0]=m;m=a+1|0}if(!(k[m|0]!=48|(c-m|0)<2|(k[m+1|0]|32)!=120)){j[114630]=0;i=E(22,o|0,48)|0;l=j[114630];j[114630]=0;if((l|0)==1){break b}l=j[f>>2];j[f>>2]=l+1;h[l|0]=i;i=h[m+1|0];j[114630]=0;i=E(22,o|0,i|0)|0;l=j[114630];j[114630]=0;if((l|0)==1){break b}l=j[f>>2];j[f>>2]=l+1;h[l|0]=i;m=m+2|0}l=0;j[114630]=0;uj(m,c);i=j[114630];j[114630]=0;if((i|0)==1){break b}j[114630]=0;r=H(2432,g|0)|0;g=j[114630];j[114630]=0;if((g|0)==1){break b}i=0;g=m;while(1){e:{if(c>>>0<=g>>>0){g=j[f>>2];j[114630]=0;uj((m-a|0)+d|0,g);g=j[114630];j[114630]=0;if((g|0)==1){break e}g=j[f>>2];break a}f:{if(!k[Ub(n,i)|0]){break f}if(h[Ub(n,i)|0]!=(l|0)){break f}l=j[f>>2];j[f>>2]=l+1;h[l|0]=r;i=(nb(n)-1>>>0>i>>>0)+i|0;l=0}q=h[g|0];j[114630]=0;q=E(22,o|0,q|0)|0;p=j[114630];j[114630]=0;if((p|0)!=1){p=j[f>>2];j[f>>2]=p+1;h[p|0]=q;g=g+1|0;l=l+1|0;continue}}break}}a=D()|0;C()|0;gb(n);G(a|0);z()}j[e>>2]=(b|0)==(c|0)?g:(b-a|0)+d|0;gb(n);Za=n+16|0}function wba(a,b){var c=0,d=0;c=Za-32|0;Za=c;a:{b:{c:{if(Dd(b,38235)){Cb(a);break c}if(Dd(b,38236)){vba(a);break c}if(Dd(b,38252)){j[c>>2]=0;ir(a,c);break c}if(Dd(b,38274)){j[c>>2]=5;ir(a,c);break c}if(Dd(b,38296)){j[c>>2]=7;ir(a,c);break c}if(Dd(b,38318)){b=Za-16|0;Za=b;gba(a);Za=b+16|0;break c}if(Dd(b,38348)){d=Db(c,38341);b=nb(d);j[114630]=0;E(85,a|0,(b?38377:38375)|0)|0;a=j[114630];j[114630]=0;if((a|0)==1){break b}gb(d);break c}if(Dd(b,38379)){uba(a);break c}if(Dd(b,38396)){tba(a);break c}if(Dd(b,38409)){sba(a);break c}if(Dd(b,38420)){rba(a);break c}if(Dd(b,38432)){qba(a);break c}if(Dd(b,38448)){xk(c);b=k[c+16|0];j[114630]=0;E(85,a|0,(b?38375:38377)|0)|0;a=j[114630];j[114630]=0;if((a|0)!=1){Ie(c);break c}b=D()|0;C()|0;Ie(c);break a}if(Dd(b,38467)){xk(c);b=k[c+17|0];j[114630]=0;E(85,a|0,(b?38375:38377)|0)|0;a=j[114630];j[114630]=0;if((a|0)!=1){Ie(c);break c}b=D()|0;C()|0;Ie(c);break a}if(Dd(b,38493)){xk(c);b=k[c+18|0];j[114630]=0;E(85,a|0,(b?38375:38377)|0)|0;a=j[114630];j[114630]=0;if((a|0)!=1){Ie(c);break c}b=D()|0;C()|0;Ie(c);break a}if(Dd(b,38511)){pba(a);break c}if(Dd(b,38517)){oba(a);break c}if(Dd(b,38532)){nba(a);break c}if(Dd(b,38540)){mba(a);break c}if(Dd(b,38548)){lba(a);break c}if(Dd(b,38556)){kba(a);break c}if(Dd(b,38560)){jba(a);break c}if(Dd(b,38578)){iba(a);break c}Cb(a)}Za=c+32|0;return}b=D()|0;C()|0;gb(d)}G(b|0);z()}function bfa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,k=0,l=0,o=0,p=0,r=q(0),s=q(0),t=0,u=0,v=q(0),w=0;g=Za-16|0;Za=g;p=a+44|0;if(Xg(p)){k=wd(p,0);l=wd(p,1);h=Rc(p,0);i=Rc(p,1);v=n[a+4212>>2];j[g+12>>2]=d;if(d){e=j[a+4224>>2];while(1){w=a;f=j[a+4220>>2];a:{if(f>>>0>e>>>0){j[g+8>>2]=f-e;f=j[tb(g+12|0,g+8|0)>>2];b:{if(!(v<q(1))){e=0;if(!f){break b}while(1){n[h>>2]=n[k>>2];n[i>>2]=n[l>>2];i=i+4|0;l=l+4|0;h=h+4|0;k=k+4|0;e=e+1|0;if((f|0)!=(e|0)){continue}break}break b}e=j[a+4224>>2];o=f+e|0;if(e>>>0>=o>>>0){break b}s=q(q(1)/q(m[a+4220>>2]));while(1){r=q(q(e>>>0)*s);n[h>>2]=r*n[k>>2];n[i>>2]=r*n[l>>2];i=i+4|0;l=l+4|0;h=h+4|0;k=k+4|0;e=e+1|0;if((o|0)!=(e|0)){continue}break}}o=j[g+12>>2]-f|0;j[g+12>>2]=o;e=f+j[a+4224>>2]|0;break a}j[g+4>>2]=j[a+4216>>2]-e;f=j[tb(g+12|0,g+4|0)>>2];c:{d:{e:{if(!(v<q(1))){e=0;if(f){break e}break d}t=j[a+4216>>2];u=j[a+4224>>2];e=t-u|0;o=e-f|0;if(e>>>0<=o>>>0){break c}s=q(q(1)/q(m[a+4220>>2]));while(1){r=q(q(e>>>0)*s);n[h>>2]=r*n[k>>2];n[i>>2]=r*n[l>>2];i=i+4|0;l=l+4|0;h=h+4|0;k=k+4|0;e=e-1|0;if(o>>>0<e>>>0){continue}break}break c}while(1){j[h>>2]=0;j[i>>2]=0;i=i+4|0;h=h+4|0;e=e+1|0;if((f|0)!=(e|0)){continue}break}}e=f<<2;l=e+l|0;k=e+k|0;t=j[a+4216>>2];u=j[a+4224>>2]}o=j[g+12>>2]-f|0;j[g+12>>2]=o;e=f+u|0;e=e>>>0<t>>>0?e:0}j[w+4224>>2]=e;if(o){continue}break}}Sh(a,b,c,Rc(p,0),Rc(p,1),d)}Za=g+16|0}function Ata(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,m=0;f=Za-32|0;Za=f;d=b&5;a:{if(!(c&5)){if(!d){break a}g=a,m=ks(h[a+36|0],h[a+37|0]),j[g+24>>2]=m;i[a+36>>1]=0;if((b|0)!=1){break a}e=HMa(j[a+24>>2],0,8272,0)+4181|0;d=ab;g=a,m=Tc(KMa(e,e>>>0<4181?d+1|0:d,8363,0),ab),j[g+24>>2]=m;break a}if(d){break a}if((c|0)==1){e=HMa(j[a+24>>2],0,8363,0)+4136|0;d=ab;g=a,m=Tc(KMa(e,e>>>0<4136?d+1|0:d,8272,0),ab),j[g+24>>2]=m}zta(a)}if(c&3){i[a+38>>1]=0;i[a+40>>1]=0;h[a+36|0]=0;i[a+34>>1]=l[a+34>>1]&65499}if(c&7){i[a+32>>1]=64;d=l[a+34>>1];if(d&8){e=j[a+16>>2];j[a+4>>2]=j[a+12>>2];j[a+8>>2]=e;d=d&16?d|6:d&65529|2}j[a+12>>2]=0;j[a+16>>2]=0;i[a+34>>1]=d&65511}d=c&4;if(d){e=l[a+34>>1];if(!(e&32)){i[a+28>>1]=128;i[a+34>>1]=e|32}ze(a+40|0,15);ze(a+41|0,63)}b:{if(!k[a+41|0]|(!(b&16777248)|!d?!(c&16777248?b&4:0):0)){break b}d=k[a+40|0];if(!d){break b}b=k[a+39|0];if(b){g=a,m=Zm(Tc(((d<<8|b>>>1)>>>0)/(b>>>0)|0,0)),h[g+39|0]=m;break b}h[a+39|0]=255}c:{d:{if((c|0)!=4){if((c|0)==16777216){break c}if((c|0)!=32|k[a+38|0]!=2){break d}h[a+38|0]=3;break d}if(k[a+38|0]!=4){break d}h[a+38|0]=0}i[a+34>>1]=l[a+34>>1]&49151}e:{if(!(!(k[a+35|0]&2)|c&16777218)){j[f+24>>2]=0;j[f+8>>2]=0;j[f+16>>2]=0;j[f+20>>2]=0;j[f>>2]=0;j[f+4>>2]=0;Ro(a,0,f);break e}if(!(k[a+35|0]&2)|(c|0)!=2){break e}a=a+68|0;b=Pb(a,8);h[b|0]=k[b|0]&3;a=Pb(a,9);h[a|0]=k[a|0]&3}Za=f+32|0}function O4(a){var b=0,c=q(0),d=q(0),e=q(0),f=0,g=q(0);a:{b:{c:{d:{e:{b=(SMa(a),OMa(2));f=b&2147483647;if(f>>>0>=1100331076){if(f>>>0>2139095040){break a}if((b|0)<0){return q(-1)}if(a>q(88.7216796875)^1){break e}return q(a*q(1.7014118346046923e+38))}if(f>>>0<1051816473){break c}if(f>>>0>1065686417){break e}if((b|0)>=0){b=1;g=q(905800061445916e-20);e=q(a+q(-.6931381225585938));break d}b=-1;g=q(-905800061445916e-20);e=q(a+q(.6931381225585938));break d}c=q(q(a*q(1.4426950216293335))+(PMa(2,(SMa(a),OMa(2))&-2147483648|1056964608),TMa()));f:{if(q(r(c))<q(2147483648)){b=~~c;break f}b=-2147483648}c=q(b|0);g=q(c*q(905800061445916e-20));e=q(a+q(c*q(-.6931381225585938)))}a=e;a=q(a-g);g=q(q(e-a)-g);break b}if(f>>>0<855638016){break a}b=0}c=q(a*q(.5));d=q(a*c);e=q(q(d*q(q(d*q(.0015807170420885086))+q(-.03333321213722229)))+q(1));c=q(q(3)-q(c*e));c=q(d*q(q(e-c)/q(q(6)-q(a*c))));if(!b){return q(a-q(q(a*c)-d))}d=q(q(q(a*q(c-g))-g)-d);g:{switch(b+1|0){case 0:return q(q(q(a-d)*q(.5))+q(-.5));case 2:if(!(a<q(-.25)^1)){return q(q(d-q(a+q(.5)))*q(-2))}a=q(a-d);return q(q(a+a)+q(1));default:break g}}f=b<<23;e=(PMa(2,f+1065353216|0),TMa());if(b>>>0>=57){a=q(q(a-d)+q(1));return q(((b|0)==128?q(q(a+a)*q(1.7014118346046923e+38)):q(a*e))+q(-1))}c=(PMa(2,1065353216-f|0),TMa());b=(b|0)<23;a=q(q((b?q(q(1)-c):q(a-q(d+c)))+(b?q(a-d):q(1)))*e)}return a}function sma(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,u=0,v=0;g=Za-32|0;Za=g;m=a+24604|0;if(!rma(m)){QJ(g+16|0,20656,20676,207);xba(g+16|0)}i=a+946300|0;e=a+906300|0;while(1){n=j[e>>2];if(!n){e=e+160|0;if((i|0)!=(e|0)){continue}}break}a:{if(!b){break a}e=j[a+480208>>2];if(e&512){break a}r=a+8204|0;s=a+1074328|0;t=a+393352|0;i=a+12|0;o=a+1304392|0;h=j[a+1074380>>2];while(1){b:{if(h){break b}l=a;h=e|512;c:{if(e&256){break c}if(qma(a)){e=j[a+480208>>2];break b}h=j[a+480208>>2]|512;if(k[a+1304512|0]){break c}e=uma(a);f=j[a+480208>>2];h=f|256;if(e){break c}h=f|512}e=h;j[l+480208>>2]=e}if(e&512){u=a+1074392|0,v=al(a),j[u>>2]=v;break a}j[g+16>>2]=512;e=j[a+1074380>>2];j[g+12>>2]=3;j[g+24>>2]=b;j[g+20>>2]=e;j[g+8>>2]=g+16;e=j[g+12>>2];j[g>>2]=j[g+8>>2];j[g+4>>2]=e;f=bR(g);if(j[a+24632>>2]){tma(a,d,f)}iU(a,f);if($c(o)){ksa(j[o>>2],i,f,(p(j[a+480232>>2],j[a+480236>>2])>>>0)/48|0)}pea(t,i,f);if(n){fU(a,f)}if(j[a+24624>>2]==1){fua(i,f)}if(k[s+36|0]){pma(a,f)}if(j[m>>2]!=128){ama(a+12|0,a+8204|0,j[a+24624>>2],f,j[a+24604>>2])}h=c;l=i;e=j[a+24624>>2];if((e|0)==4){gua(i,r,f);e=j[a+24624>>2]}bb[j[j[c>>2]+8>>2]](h,l,e,f);h=j[a+1074380>>2]-f|0;j[a+1074380>>2]=h;j[a+1074376>>2]=f+j[a+1074376>>2];q=f+q|0;b=b-f|0;if(!b){break a}e=j[a+480208>>2];if(!(e&512)){continue}break}}Za=g+32|0;return q|0}function Rw(a,b,c){var d=0,e=0,f=0,g=0,i=0,m=0,n=0,o=0,p=0,q=0;e=Za-16|0;Za=e;i=pJ(b,c);a:{if(!j[b+656>>2]|!(h[i|0]&1)){break a}g=j[i+4>>2];m=a+1074308|0;mb(e+8|0,m,31);f=kb(e+8|0);d=Ct(j[b+656>>2],c);if(Xc(d)){break a}g=g+(f^1)|0;mb(e+8|0,m,31);n=kb(e+8|0);f=k[d+12|0];b:{c:{if(!n){d:{if(!(f&2)){break d}f=l[xb(d,k[d+14|0])>>1]+!(j[a+480180>>2]&1048580)|0;if(!(!(k[b+89|0]&8)|(!(k[d+12|0]&4)|k[d+14|0]!=k[d+16|0]))){mb(e+8|0,m,70);o=kb(e+8|0)}if((g|0)!=(f|0)|o){break d}g=l[xb(d,k[d+13|0])>>1]}if(!(!(k[d+12|0]&4)|k[b+89|0]&8)){if((l[xb(d,k[d+16|0])>>1]+1|0)!=(g|0)){break b}g=l[xb(d,k[d+15|0])>>1];mb(e+8|0,m,93);if(!kb(e+8|0)|(c|0)!=1|j[b+88>>2]&2048){break b}h[i|0]=k[i|0]&254;break b}if(l[Ti(d)>>1]>=g>>>0){break b}o=1;g=l[Ti(d)>>1];break c}e:{f:{if(!(!(f&4)|k[b+669|0]&8)){if(j[i+8>>2]==-1){break f}mb(e+8|0,m,97);if(kb(e+8|0)){break f}f=k[d+12|0]}if(f&2){f=l[xb(d,k[d+13|0])>>1];n=l[xb(d,k[d+14|0])>>1]+1|0;break e}f=l[Ti(d)>>1];o=g>>>0>f>>>0;n=f;break e}f=l[xb(d,k[d+15|0])>>1];n=l[xb(d,k[d+16|0])>>1]+1|0}g=g>>>0<n>>>0?g:f}if(!o|c){break b}if(!(!(k[b+89|0]&8)|j[a+480180>>2]==16384?!(j[a+480180>>2]&16777248):0)){j[b+88>>2]=j[b+88>>2]|4096}if(k[Ti(d)+2|0]|(j[a+480180>>2]&16777248?0:!l[b+808>>1])){break b}j[b+696>>2]=0;j[b+720>>2]=0;j[b+680>>2]=0;j[b+88>>2]=j[b+88>>2]|4096}mb(e+8|0,m,31);p=i,q=kb(e+8|0)+g|0,j[p+4>>2]=q}Za=e+16|0}function _ua(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;g=Za-32|0;Za=g;a:{b:{c:{h=j[a+8>>2];e=j[a+12>>2];d:{if((e|0)<1?1:(e|0)<=1?h>>>0<=805306368:0){if((e|0)>-2?1:(e|0)>=-2?h>>>0>=3489660928:0){break c}if((e|0)>-2?1:(e|0)>=-2?h>>>0>2147483647:0){break d}break b}if((e|0)>1?1:(e|0)>=1?h>>>0>2147483648:0){break b}}n=b+196648|0;break a}n=b+131112|0;break a}n=b+262184|0}o=j[a+16>>2];l=j[a+40>>2];m=j[a+36>>2];f=j[a+4>>2];k=j[a>>2];j[g+24>>2]=k;j[g+28>>2]=f;j[g+16>>2]=h;j[g+20>>2]=e;e:{if(!d){b=l>>12;h=m>>12;break e}while(1){e=((((f&2147483647)<<1|k>>>31)&2147483646)<<1)+o|0;b=(k>>>16&65520)+n|0;k=i[b+14>>1];q=i[b+12>>1];r=i[b+10>>1];s=i[b+8>>1];t=i[b+6>>1];u=i[b+4>>1];v=i[b+2>>1];w=i[b>>1];h=0;b=1;while(1){f=h<<1;j[(g+8|0)+(h<<2)>>2]=(((((((p(i[(f|-8)+e>>1],v)+p(i[(f|-12)+e>>1],w)|0)+p(i[(f|-4)+e>>1],u)|0)+p(i[e+f>>1],t)|0)+p(i[(f|4)+e>>1],s)|0)+p(i[(f|8)+e>>1],r)|0)+p(i[(f|12)+e>>1],q)|0)+p(i[(f|16)+e>>1],k)|0)/32768;f=b;b=0;h=1;if(f){continue}break}b=j[a+32>>2];m=j[a+28>>2]+m|0;h=m>>12;j[c>>2]=j[c>>2]+p(h,j[g+8>>2]);l=b+l|0;b=l>>12;j[c+4>>2]=j[c+4>>2]+p(b,j[g+12>>2]);Bb(g+24|0,g+16|0);d=d-1|0;if(d){c=c+8|0;k=j[g+24>>2];f=j[g+28>>2];continue}break}k=j[g+24>>2];f=j[g+28>>2]}j[a+40>>2]=l;j[a+20>>2]=h;j[a+36>>2]=m;j[a+24>>2]=b;j[a>>2]=k;j[a+4>>2]=f;Za=g+32|0}function fF(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=+d;e=+e;var f=0,g=0,m=0,n=0,o=0,q=0,r=0,s=0;g=Za-16|0;Za=g;a:{b:{c:{d:{e:{m=(b|0)>=0;n=a+8|0;f:{if(Tk(n)){f=Tk(n);break f}f=fr(n)}if(!((f|0)>(b|0)?m:0)){a=R(8)|0;j[114630]=0;b=E(85,g|0,40681)|0;c=j[114630];j[114630]=0;if((c|0)==1){break e}Wb(a,b);j[114630]=0;I(2004,a|0,83648,2012);a=j[114630];j[114630]=0;if((a|0)!=1){break c}c=D()|0;C()|0;gb(b);break d}if(c>>>0>=120){a=R(8)|0;j[114630]=0;b=E(85,g|0,40700)|0;c=j[114630];j[114630]=0;if((c|0)!=1){Wb(a,b);j[114630]=0;I(2004,a|0,83648,2012);a=j[114630];j[114630]=0;if((a|0)!=1){break c}c=D()|0;C()|0;gb(b);break d}c=D()|0;C()|0;S(a|0);break d}o=c+1|0;f=255;i[g>>1]=255;if((Uk(n)|0)>255){break a}q=a+32|0;m=255;c=255;while(1){m=j[q>>2]+p(m,896)|0;if(!j[m+1075060>>2]){break b}if(k[m+1075073|0]&16){i[g>>1]=c;f=c}c=c-1|0;m=c&65535;if((Uk(n)|0)<=(m|0)){continue}break}break a}c=D()|0;C()|0;S(a|0)}G(c|0)}z()}i[g>>1]=c;f=c}a=a+32|0;c=j[a>>2]+p(f&65535,896)|0;f=c+1074984|0;Tm(f,j[a>>2],65535);h[c+1075808|0]=o;h[c+1075805|0]=o;i[c+1075792>>1]=0;cl(f);Go(j[a>>2],f,b+1|0,0,1,1);j[c+1075680>>2]=65536;Sr(j[a>>2],f,o,0,1,1,65535);r=c+1075676|0,s=Qm(tx(e*128,-128,128)+128),j[r>>2]=s;r=c+1075672|0,s=Qm(tx(d*256,0,256)),j[r>>2]=s;b=j[a>>2]+1074466|0;b=xx(b,v6(b,b+(l[j[a>>2]+480212>>1]<<1)|0,g));i[j[a>>2]+480212>>1]=b;Za=g+16|0;return l[g>>1]}function Fu(a,b,c){var d=0,e=0,f=0,g=0,h=0;a:while(1){g=b-4|0;d=a;b:while(1){c:{d:{e:{f:{g:{h:{i:{j:{e=b-d|0;a=e>>2;switch(a|0){case 2:break j;case 0:case 1:break c;case 3:break f;case 5:break h;case 4:break i;default:break g}}a=b-4|0;if(!rd(a,d)){break c}Ib(d,a);return}Eu(d,d+4|0,d+8|0,b-4|0);return}Du(d,d+4|0,d+8|0,d+12|0,b-4|0);return}if((e|0)<=123){nY(d,b);return}f=((a|0)/2<<2)+d|0;k:{if((e|0)>=3997){a=(a|0)/4<<2;h=Du(d,a+d|0,f,a+f|0,g);break k}h=Tl(d,f,g)}a=g;if(!rd(d,f)){while(1){a=a-4|0;if((d|0)==(a|0)){f=d+4|0;if(rd(d,g)){break d}while(1){if((f|0)==(g|0)){break c}if(rd(d,f)){Ib(f,g);f=f+4|0;break d}else{f=f+4|0;continue}}}if(!rd(a,f)){continue}break}Ib(d,a);h=h+1|0}e=d+4|0;if(e>>>0>=a>>>0){break e}while(1){g=e;e=e+4|0;if(rd(g,f)){continue}while(1){a=a-4|0;if(!rd(a,f)){continue}break}if(a>>>0<g>>>0){e=g;break e}else{Ib(g,a);f=(f|0)==(g|0)?a:f;h=h+1|0;continue}}}Tl(d,d+4|0,b-4|0);break c}l:{if((e|0)==(f|0)){break l}if(!rd(f,e)){break l}Ib(e,f);h=h+1|0}if(!h){g=WB(d,e);a=e+4|0;if(WB(a,b)){b=e;a=d;if(!g){continue a}break c}if(g){continue a}}if((e-d|0)<(b-e|0)){Fu(d,e,c);a=e+4|0;continue a}Fu(e+4|0,b,c);b=e;a=d;continue a}a=g;if((f|0)==(a|0)){break c}while(1){e=f;f=e+4|0;if(!rd(d,e)){continue}while(1){a=a-4|0;if(rd(d,a)){continue}break}if(a>>>0<=e>>>0){d=e;continue b}else{Ib(e,a);continue}}}break}break}}function tua(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0;e=Za-48|0;Za=e;o=j[a+16>>2];f=vf(e+16|0);j[f+8>>2]=a+112;j[f+16>>2]=j[a+128>>2];q=f,r=qf(b+327720|0,j[b+20>>2],(j[a+88>>2]&16384)>>>14|0),j[q+12>>2]=r;b=j[f+16>>2];if(b){q=f,r=uf(a+8|0,b),j[q>>2]=r;j[f+4>>2]=ab}l=j[a+40>>2];m=j[a+36>>2];h=j[a+4>>2];g=j[a>>2];j[e+8>>2]=g;j[e+12>>2]=h;b=j[a+12>>2];j[e>>2]=j[a+8>>2];j[e+4>>2]=b;a:{if(!d){b=l>>12;k=m>>12;break a}while(1){b=0;k=b;n=g;j[e+40>>2]=g;j[e+44>>2]=b;h=((((h&2147483647)<<1|g>>>31)&2147483646)<<1)+o|0;b:{b=j[f+16>>2];if((b|0)<=0){break b}while(1){g=(k&2147483647)<<1|n>>>31;id(j[f+8>>2],(i[(g<<1|2)+h>>1]+i[h+((g&2147483646)<<1)>>1]|0)/8<<16>>16);hd(j[f+8>>2],4);Bb(e+40|0,f);if((b|0)<2){break b}b=b-1|0;n=j[e+40>>2];k=j[e+44>>2];continue}}d=d-1|0;b=j[f+8>>2];Bb(b,b+8|0);b=j[f+8>>2];g=j[b+4>>2];if(g){k=b;b=(j[e+44>>2]&2147483647)<<1|j[e+40>>2]>>>31;id(k,(i[(b<<1|2)+h>>1]+i[h+((b&2147483646)<<1)>>1]|0)/8<<16>>16);hd(j[f+8>>2],g);b=j[f+8>>2];g=j[b>>2];j[b>>2]=g;j[b+4>>2]=0}h=pf(b,j[f+12>>2]);b=j[a+32>>2];m=j[a+28>>2]+m|0;k=m>>12;j[c>>2]=j[c>>2]+p(h,k);l=b+l|0;b=l>>12;j[c+4>>2]=j[c+4>>2]+p(h,b);Bb(e+8|0,e);if(d){c=c+8|0;g=j[e+8>>2];h=j[e+12>>2];continue}break}g=j[e+8>>2];h=j[e+12>>2]}j[a+40>>2]=l;j[a+20>>2]=k;j[a+36>>2]=m;j[a+24>>2]=b;j[a>>2]=g;j[a+4>>2]=h;Za=e+48|0}function JT(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;d=Za-32|0;Za=d;a:{if((k[a|0]|k[a+1|0]<<8|(k[a+2|0]<<16|k[a+3|0]<<24))==1397771593){md(b,32);si(d,1,a+4|0);qc(d+16|0,d);j[114630]=0;E(370,b+43|0,d+16|0)|0;c=j[114630];j[114630]=0;if((c|0)==1){break a}gb(d+16|0);i[b+30>>1]=k[a+19|0]<<2;Rf(b+30|0,256);i[b+32>>1]=k[a+17|0];Rf(b+32|0,64);c=a+47|0;i[b+28>>1]=(k[c|0]&127)<<2;Rf(b+28|0,256);if(h[c|0]<=-1){i[b+34>>1]=l[b+34>>1]|32}c=a+18|0;if(k[c|0]&16){i[b+34>>1]=l[b+34>>1]|2}if(k[c|0]&32){i[b+34>>1]=l[b+34>>1]|8}if(k[c|0]&64){i[b+34>>1]=l[b+34>>1]|4}if(h[c|0]<=-1){i[b+34>>1]=l[b+34>>1]|16}c=a+60|0;c=k[c|0]|k[c+1|0]<<8|(k[c+2|0]<<16|k[c+3|0]<<24);c=c?c:8363;j[b+24>>2]=c>>>0>256?c:256;c=a+48|0;j[b>>2]=k[c|0]|k[c+1|0]<<8|(k[c+2|0]<<16|k[c+3|0]<<24);c=a+52|0;j[b+4>>2]=k[c|0]|k[c+1|0]<<8|(k[c+2|0]<<16|k[c+3|0]<<24);c=a+56|0;j[b+8>>2]=k[c|0]|k[c+1|0]<<8|(k[c+2|0]<<16|k[c+3|0]<<24);c=a- -64|0;j[b+12>>2]=k[c|0]|k[c+1|0]<<8|(k[c+2|0]<<16|k[c+3|0]<<24);c=a+68|0;j[b+16>>2]=k[c|0]|k[c+1|0]<<8|(k[c+2|0]<<16|k[c+3|0]<<24);Rm(b);h[b+38|0]=k[(k[a+79|0]&7)+27872|0];h[b+41|0]=k[a+76|0];h[b+40|0]=k[a+77|0]&127;h[b+39|0]=k[a+78|0];c=512;e=a+46|0;b:{if(k[e|0]!=64){c=16384;if(k[e|0]!=128){break b}}i[b+34>>1]=l[b+34>>1]|c}a=a+72|0;c=k[a|0]|k[a+1|0]<<8|(k[a+2|0]<<16|k[a+3|0]<<24)}Za=d+32|0;return c|0}a=D()|0;C()|0;gb(d+16|0);G(a|0);z()}function Hua(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0;h=Za-16|0;Za=h;f=j[a+48>>2];o=j[a+24>>2];q=j[a+20>>2];m=j[a+44>>2];r=j[a+16>>2];g=j[a+4>>2];k=j[a>>2];j[h+8>>2]=k;j[h+12>>2]=g;e=j[a+12>>2];j[h>>2]=j[a+8>>2];j[h+4>>2]=e;a:{if(!d){e=m;m=f;break a}while(1){e=(g<<1)+r|0;s=i[e-6>>1];g=(((k>>>16|0)+4&131064)<<1)+b|0;k=i[g+24>>1];t=i[e-4>>1];u=i[g+26>>1];v=i[e-2>>1];w=i[g+28>>1];x=i[e>>1];y=i[g+30>>1];z=i[e+2>>1];A=i[g+32>>1];B=i[e+4>>1];C=i[g+34>>1];D=i[e+6>>1];E=i[g+36>>1];F=i[e+8>>1];g=i[g+38>>1];e=j[a+60>>2];G=e;H=e>>31;e=Gb(m,-16777216,16776704);l=j[a+64>>2];f=Gb(f,-16777216,16776704);I=j[a+72>>2];J=j[c>>2];e=HMa(l,l>>31,e,e>>31);l=ab;K=e;e=j[a+68>>2];n=HMa(e,e>>31,f,f>>31);e=K+n|0;f=ab+l|0;f=e>>>0<n>>>0?f+1|0:f;l=e;g=(((((p(B,C)+p(z,A)|0)+p(D,E)|0)+p(g,F)|0)/2|0)+((((p(t,u)+p(k,s)|0)+p(v,w)|0)+p(x,y)|0)/2|0)|0)/16384<<8;e=g;k=HMa(G,H,e,e>>31);e=l+k|0;f=ab+f|0;f=e>>>0<k>>>0?f+1|0:f;e=e+8388608|0;if(e>>>0<8388608){f=f+1|0}f=(f&16777215)<<8|e>>>24;e=(f|0)/256|0;j[c>>2]=p(e,q)+J;j[c+4>>2]=j[c+4>>2]+p(e,o);e=f-(g&I)|0;Bb(h+8|0,h);d=d-1|0;if(d){c=c+8|0;k=j[h+8>>2];g=j[h+12>>2];f=m;m=e;continue}break}k=j[h+8>>2];g=j[h+12>>2]}j[a+48>>2]=m;j[a+44>>2]=e;j[a>>2]=k;j[a+4>>2]=g;Za=h+16|0}function Zf(a,b,c,d){var e=0,f=0,g=0,h=0,i=0,m=0,n=0;f=Za-16|0;Za=f;j[f+12>>2]=d;e=b-1|0;g=0;a:{if(e>>>0>249){break a}h=kp(a);g=j[a+480180>>2];if(!h){if(g&17408){a=((e&255)>>>0)/12|0;g=l[((e-p(a,12)&255)<<1)+21424>>1]<<4>>>a|0;break a}if(!(j[a+480180>>2]!=64?!(k[a+480208|0]&16):0)){mb(f,a+1074308|0,7);if(!(i=!kb(f),m=0,n=j[a+480180>>2]!=64,n?i:m)){a=((e&255)>>>0)/12|0;b=HMa(j[f+12>>2],0,j[(e-p(a,12)<<6&960)+25312>>2]<<a,0);a=ab;c=a>>>21|0;g=Tc((a&2097151)<<11|b>>>21,c);break a}a=((e&255)>>>0)/12|0;g=l[((e-p(a,12)&255)<<1)+21424>>1]<<5>>>a|0;break a}if(!d){j[f+12>>2]=8363}a=((e&255)>>>0)/12|0;jc(f+12|0,-1>>>a|0);g=Tc(KMa(HMa(l[((e-p(a,12)&255)<<1)+21424>>1],0,267616,0),ab,j[f+12>>2]<<a,0),ab);break a}if(g&20){d=e>>>0>12;if(j[a+480180>>2]==16){b=c<<4}else{mb(f,a+1074308|0,76);b=kb(f)?c&-8:c}c=d?e:12;if(k[a+480208|0]&16){a=(((b|0)/-2|0)-(c<<6)|0)+8448|0;g=(a|0)>1?a:1;break a}c=c-12|0;a=((c&255)>>>0)/12|0;c=((b|0)/16|0)+(c-p(a,12)<<3&248)|0;j[f>>2]=c+8;Md(f,0,103);c=c+((b|0)<0?-1:1)|0;c=(c|0)>-8?c:-8;d=b;b=b>>31;b=(d+b^b)&15;g=p(l[((((c|0)<95?c:95)<<1)+21904|0)+16>>1],b)+p(l[(j[f>>2]<<1)+21904>>1],16-b|0)<<1>>>a|0;break a}a=c>>>4&15;if(!(e>>>0<108?!(a|e>>>0<24):0)){b=p(a,12);a=((e&255)>>>0)/12|0;g=l[(b+(e-p(a,12)&255)<<1)+21024>>1]<<5>>>a|0;break a}g=l[(b<<1)+20798>>1]<<2}Za=f+16|0;return g}function Iua(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0;k=Za-16|0;Za=k;f=j[a+48>>2];q=j[a+24>>2];r=j[a+20>>2];n=j[a+44>>2];s=j[a+16>>2];g=j[a+4>>2];l=j[a>>2];j[k+8>>2]=l;j[k+12>>2]=g;e=j[a+12>>2];j[k>>2]=j[a+8>>2];j[k+4>>2]=e;a:{if(!d){e=n;n=f;break a}while(1){e=g+s|0;t=h[e-3|0];g=(((l>>>16|0)+4&131064)<<1)+b|0;l=i[g+24>>1];u=h[e-2|0];v=i[g+26>>1];w=h[e-1|0];x=i[g+28>>1];y=h[e|0];z=i[g+30>>1];A=h[e+1|0];B=i[g+32>>1];C=h[e+2|0];D=i[g+34>>1];E=h[e+3|0];F=i[g+36>>1];G=h[e+4|0];g=i[g+38>>1];e=j[a+60>>2];H=e;I=e>>31;e=Gb(n,-16777216,16776704);m=j[a+64>>2];f=Gb(f,-16777216,16776704);J=j[a+72>>2];K=j[c>>2];e=HMa(m,m>>31,e,e>>31);m=ab;L=e;e=j[a+68>>2];o=HMa(e,e>>31,f,f>>31);e=L+o|0;f=ab+m|0;f=e>>>0<o>>>0?f+1|0:f;m=e;g=(((((p(C,D)+p(A,B)|0)+p(E,F)|0)+p(g,G)<<8)/2|0)+((((p(u,v)+p(l,t)|0)+p(w,x)|0)+p(y,z)<<8)/2|0)|0)/16384<<8;e=g;l=HMa(H,I,e,e>>31);e=m+l|0;f=ab+f|0;f=e>>>0<l>>>0?f+1|0:f;e=e+8388608|0;if(e>>>0<8388608){f=f+1|0}f=(f&16777215)<<8|e>>>24;e=(f|0)/256|0;j[c>>2]=p(e,r)+K;j[c+4>>2]=j[c+4>>2]+p(e,q);e=f-(g&J)|0;Bb(k+8|0,k);d=d-1|0;if(d){c=c+8|0;l=j[k+8>>2];g=j[k+12>>2];f=n;n=e;continue}break}l=j[k+8>>2];g=j[k+12>>2]}j[a+48>>2]=n;j[a+44>>2]=e;j[a>>2]=l;j[a+4>>2]=g;Za=k+16|0}function Uva(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;b=Za-48|0;Za=b;t=j[a+16>>2];l=j[a+44>>2];j[b+32>>2]=l;f=j[a+48>>2];j[b+36>>2]=f;h=j[a+52>>2];j[b+40>>2]=h;m=j[a+56>>2];j[b+44>>2]=m;u=j[a+24>>2];v=j[a+20>>2];e=j[a+4>>2];k=j[a>>2];j[b+24>>2]=k;j[b+28>>2]=e;g=j[a+12>>2];j[b+16>>2]=j[a+8>>2];j[b+20>>2]=g;if(d){while(1){e=((((e&2147483647)<<1|k>>>31)&2147483646)<<1)+t|0;h=i[e>>1];j[b+8>>2]=h;j[b+12>>2]=i[e+2>>1];f=0;m=1;while(1){g=j[a+60>>2];q=g;k=(b+32|0)+(f<<3)|0;n=j[k>>2];e=Gb(n,-16777216,16776704);s=j[a+64>>2];l=Gb(j[k+4>>2],-16777216,16776704);o=j[a+68>>2];w=o;o=o>>31;j[k+4>>2]=n;n=j[a+72>>2];r=g>>31;h=h<<8;g=h;g=HMa(q,r,g,g>>31);q=ab;r=(b+8|0)+(f<<2)|0;f=g;g=HMa(s,s>>31,e,e>>31);f=f+g|0;e=ab+q|0;e=f>>>0<g>>>0?e+1|0:e;l=HMa(w,o,l,l>>31);f=l+f|0;e=ab+e|0;e=f>>>0<l>>>0?e+1|0:e;f=f+8388608|0;if(f>>>0<8388608){e=e+1|0}e=(e&16777215)<<8|f>>>24;j[r>>2]=(e|0)/256;j[k>>2]=e-(h&n);if(m){f=1;m=0;h=j[b+12>>2];continue}break}j[c>>2]=j[c>>2]+p(j[b+8>>2],v);j[c+4>>2]=j[c+4>>2]+p(j[b+12>>2],u);Bb(b+24|0,b+16|0);d=d-1|0;if(d){c=c+8|0;k=j[b+24>>2];e=j[b+28>>2];continue}break}k=j[b+24>>2];m=j[b+44>>2];h=j[b+40>>2];l=j[b+32>>2];f=j[b+36>>2];e=j[b+28>>2]}j[a+56>>2]=m;j[a+52>>2]=h;j[a+48>>2]=f;j[a+44>>2]=l;j[a>>2]=k;j[a+4>>2]=e;Za=b+48|0}function $ua(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;f=Za-32|0;Za=f;a:{b:{c:{g=j[a+8>>2];e=j[a+12>>2];d:{if((e|0)<1?1:(e|0)<=1?g>>>0<=805306368:0){if((e|0)>-2?1:(e|0)>=-2?g>>>0>=3489660928:0){break c}if((e|0)>-2?1:(e|0)>=-2?g>>>0>2147483647:0){break d}break b}if((e|0)>1?1:(e|0)>=1?g>>>0>2147483648:0){break b}}o=b+196648|0;break a}o=b+131112|0;break a}o=b+262184|0}q=j[a+16>>2];m=j[a+40>>2];n=j[a+36>>2];l=j[a+4>>2];k=j[a>>2];j[f+24>>2]=k;j[f+28>>2]=l;j[f+16>>2]=g;j[f+20>>2]=e;e:{if(!d){b=m>>12;e=n>>12;break e}while(1){g=(((l&2147483647)<<1|k>>>31)&-2)+q|0;b=(k>>>16&65520)+o|0;k=i[b+14>>1];r=i[b+12>>1];s=i[b+10>>1];t=i[b+8>>1];u=i[b+6>>1];v=i[b+4>>1];w=i[b+2>>1];x=i[b>>1];b=0;e=1;while(1){j[(f+8|0)+(b<<2)>>2]=(((((((p(h[(b|-4)+g|0],w)+p(h[(b|-6)+g|0],x)|0)+p(h[(b|-2)+g|0],v)|0)+p(h[b+g|0],u)|0)+p(h[(b|2)+g|0],t)|0)+p(h[(b|4)+g|0],s)|0)+p(h[(b|6)+g|0],r)|0)+p(h[(b|8)+g|0],k)<<8)/32768;l=e;e=0;b=1;if(l){continue}break}b=j[a+32>>2];n=j[a+28>>2]+n|0;e=n>>12;j[c>>2]=j[c>>2]+p(e,j[f+8>>2]);m=b+m|0;b=m>>12;j[c+4>>2]=j[c+4>>2]+p(b,j[f+12>>2]);Bb(f+24|0,f+16|0);d=d-1|0;if(d){c=c+8|0;k=j[f+24>>2];l=j[f+28>>2];continue}break}k=j[f+24>>2];l=j[f+28>>2]}j[a+40>>2]=m;j[a+20>>2]=e;j[a+36>>2]=n;j[a+24>>2]=b;j[a>>2]=k;j[a+4>>2]=l;Za=f+32|0}function qta(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,m=0,n=0,o=0;c=Za+ -64|0;Za=c;i[c+62>>1]=b;f=Wi(a);e=ota(c+48|0,f);a:{b:{if(!f){break b}b=0;while(1){n=bc(e,b),o=b-d|0,i[n>>1]=o;j[114630]=0;g=E(1165,a|0,b|0)|0;m=j[114630];j[114630]=0;if((m|0)==1){break a}d=(l[g>>1]==l[c+62>>1])+d|0;b=b+1|0;if((f|0)!=(b|0)){continue}break}if(!(d&65535)){break b}b=Lb(a);d=Mb(a);j[114630]=0;b=K(1166,b|0,d|0,c+62|0)|0;d=j[114630];j[114630]=0;if((d|0)==1){break a}j[c+32>>2]=b;b=Cd(c+40|0,c+32|0);n=c,o=Mb(a),j[n+16>>2]=o;d=j[Cd(c+24|0,c+16|0)>>2];b=j[b>>2];j[114630]=0;K(1167,a|0,b|0,d|0)|0;b=j[114630];j[114630]=0;if((b|0)==1){break a}n=c,o=Lb(a),j[n+32>>2]=o;n=c,o=Mb(a),j[n+16>>2]=o;if(rb(c+32|0,c+16|0)){while(1){b=l[j[c+32>>2]>>1];d=j[a+24>>2];j[114630]=0;d=E(442,d+484344|0,b|0)|0;f=j[114630];j[114630]=0;if((f|0)==1){break a}c:{if(!d){break c}b=Hb(j[a+24>>2]+484344|0,b);n=c,o=Lb(b),j[n+8>>2]=o;n=c,o=Mb(b),j[n>>2]=o;if(!rb(c+8|0,c)){break c}while(1){b=j[c+8>>2];d:{if(k[b+3|0]!=12){break d}d=k[b+5|0];if(Yb(e)>>>0<=d>>>0){break d}n=b,o=k[bc(e,k[b+5|0])|0],h[n+5|0]=o}lk(c+8|0);if(rb(c+8|0,c)){continue}break}}je(c+32|0);if(rb(c+32|0,c+16|0)){continue}break}}b=l[a+28>>1];if(Yb(e)>>>0<=b>>>0){break b}n=a,o=l[bc(e,l[a+28>>1])>>1],i[n+28>>1]=o}ff(e);Za=c- -64|0;return}a=D()|0;C()|0;ff(e);G(a|0);z()}function Vva(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,i=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;b=Za-48|0;Za=b;t=j[a+16>>2];l=j[a+44>>2];j[b+32>>2]=l;f=j[a+48>>2];j[b+36>>2]=f;i=j[a+52>>2];j[b+40>>2]=i;m=j[a+56>>2];j[b+44>>2]=m;u=j[a+24>>2];v=j[a+20>>2];e=j[a+4>>2];k=j[a>>2];j[b+24>>2]=k;j[b+28>>2]=e;g=j[a+12>>2];j[b+16>>2]=j[a+8>>2];j[b+20>>2]=g;if(d){while(1){e=(((e&2147483647)<<1|k>>>31)&-2)+t|0;i=h[e|0]<<8;j[b+8>>2]=i;j[b+12>>2]=h[e+1|0]<<8;f=0;m=1;while(1){g=j[a+60>>2];q=g;k=(b+32|0)+(f<<3)|0;n=j[k>>2];e=Gb(n,-16777216,16776704);s=j[a+64>>2];l=Gb(j[k+4>>2],-16777216,16776704);o=j[a+68>>2];w=o;o=o>>31;j[k+4>>2]=n;n=j[a+72>>2];r=g>>31;i=i<<8;g=i;g=HMa(q,r,g,g>>31);q=ab;r=(b+8|0)+(f<<2)|0;f=g;g=HMa(s,s>>31,e,e>>31);f=f+g|0;e=ab+q|0;e=f>>>0<g>>>0?e+1|0:e;l=HMa(w,o,l,l>>31);f=l+f|0;e=ab+e|0;e=f>>>0<l>>>0?e+1|0:e;f=f+8388608|0;if(f>>>0<8388608){e=e+1|0}e=(e&16777215)<<8|f>>>24;j[r>>2]=(e|0)/256;j[k>>2]=e-(i&n);if(m){f=1;m=0;i=j[b+12>>2];continue}break}j[c>>2]=j[c>>2]+p(j[b+8>>2],v);j[c+4>>2]=j[c+4>>2]+p(j[b+12>>2],u);Bb(b+24|0,b+16|0);d=d-1|0;if(d){c=c+8|0;k=j[b+24>>2];e=j[b+28>>2];continue}break}k=j[b+24>>2];m=j[b+44>>2];i=j[b+40>>2];l=j[b+32>>2];f=j[b+36>>2];e=j[b+28>>2]}j[a+56>>2]=m;j[a+52>>2]=i;j[a+48>>2]=f;j[a+44>>2]=l;j[a>>2]=k;j[a+4>>2]=e;Za=b+48|0}function $Ga(a){a=a|0;var b=0,c=0,d=0,e=0,f=0;c=Za-16|0;Za=c;a:{b:{c:{d:{e:{f:{g:{h:{i:{j:{b=k[a+3|0];switch(b-14|0){case 2:case 3:case 4:case 5:break b;case 8:break f;case 6:case 7:break g;case 1:break h;case 0:break i;default:break j}}switch(b-31|0){case 2:break d;case 0:break e;default:break b}}k:{l:{b=k[a+5|0];if((b|0)!=240){if((b|0)==15){break l}if(b){break k}h[a+3|0]=11;break a}h[a+5|0]=239;break c}h[a+5|0]=254;break c}if(b>>>0>=16){h[a+5|0]=b|15;break c}h[a+5|0]=b|240;break c}h[c+15|0]=k[a+5|0]>>>4;h[c+14|0]=15;e=a,f=k[Zb(c+15|0,c+14|0)|0]|32,h[e+5|0]=f;break c}b=k[a+5|0];if(b>>>0>=16){h[c+13|0]=b>>>4;h[c+12|0]=15;e=a,f=k[Zb(c+13|0,c+12|0)|0]|240,h[e+5|0]=f;break c}h[a+5|0]=b|224;break c}h[a+5|0]=((k[a+5|0]^-1)&254)>>>1;break c}e=a,f=bj(k[a+5|0]<<1),h[e+5|0]=f;break c}b=32;m:{n:{o:{p:{q:{r:{s:{t:{d=k[a+5|0];switch(d>>>4|0){case 3:break m;case 5:break n;case 14:break o;case 12:case 13:break p;case 11:break q;case 10:break r;case 8:break s;case 0:break c;default:break t}}h[a+3|0]=0;break c}b=64;break m}b=176;break m}b=224;break m}if(d){break c}h[a+3|0]=0;break c}h[a+5|0]=119;break c}b=48}h[a+5|0]=d&15|b}b=k[a+3|0]}if(b>>>0>=36){h[a+3|0]=0;break a}h[a+3|0]=k[b+13344|0];if(k[a+2|0]|(b|0)!=12){break a}h[a+2|0]=1;h[a+3|0]=0;b=k[a+5|0];h[a+5|0]=0;h[a+4|0]=b}Za=c+16|0}function y$(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0,k=0,l=0,m=0,n=0,o=0,p=0;a=Za-496|0;Za=a;hc(a+488|0,d);j[114630]=0;m=H(2450,a+488|0)|0;g=j[114630];j[114630]=0;a:{b:{c:{d:{e:{f:{g:{if((g|0)!=1){if(nb(f)){g=j[Ni(f,0)>>2];j[114630]=0;i=E(2476,m|0,45)|0;k=j[114630];j[114630]=0;if((k|0)==1){break g}n=(g|0)==(i|0)}k=Cb(a+456|0);i=Le(a+440|0);g=Le(a+424|0);j[114630]=0;ba(2504,c|0,n|0,a+488|0,a+480|0,a+476|0,a+472|0,k|0,i|0,g|0,a+420|0);c=j[114630];j[114630]=0;if((c|0)==1){break f}j[a+4>>2]=2421;l=yd(a+8|0,0,a+4|0);h:{if((nb(f)|0)>j[a+420>>2]){c=nb(f);h=j[a+420>>2];h=(nb(g)+(c-h<<1)|0)+1|0;break h}h=nb(g)+2|0}c=a+16|0;h=(nb(i)+h|0)+j[a+420>>2]|0;if(h>>>0<101){break e}fe(l,Yc(h<<2));c=j[l>>2];if(c){break e}j[114630]=0;M(2422);b=j[114630];j[114630]=0;if((b|0)==1){break d}z()}f=D()|0;C()|0;break b}f=D()|0;C()|0;break b}f=D()|0;C()|0;break c}h=j[d+4>>2];o=zb(f);p=zb(f);f=nb(f);j[114630]=0;ga(2505,c|0,a+4|0,a|0,h|0,o|0,(f<<2)+p|0,m|0,n|0,a+480|0,j[a+476>>2],j[a+472>>2],k|0,i|0,g|0,j[a+420>>2]);f=j[114630];j[114630]=0;if((f|0)!=1){j[114630]=0;b=_(2480,b|0,c|0,j[a+4>>2],j[a>>2],d|0,e|0)|0;c=j[114630];j[114630]=0;if((c|0)!=1){break a}}}f=D()|0;C()|0;mc(l)}pc(g);pc(i);gb(k)}wb(a+488|0);G(f|0);z()}mc(l);pc(g);pc(i);gb(k);wb(a+488|0);Za=a+496|0;return b|0}function QT(a,b){var c=0,d=0,e=0,f=0,g=0,l=0,m=0,n=0,o=0,p=0,q=0;d=Za-32|0;Za=d;a:{b:{if((k[a|0]|k[a+1|0]<<8|(k[a+2|0]<<16|k[a+3|0]<<24))!=1229999433){break b}Kt(d,3,a+32|0);qc(d+16|0,d);j[114630]=0;E(369,b+492|0,d+16|0)|0;c=j[114630];j[114630]=0;if((c|0)==1){break a}gb(d+16|0);si(d,1,a+4|0);qc(d+16|0,d);j[114630]=0;E(369,b+524|0,d+16|0)|0;c=j[114630];j[114630]=0;if((c|0)==1){break a}gb(d+16|0);c=a+24|0;c=k[c|0]|k[c+1|0]<<8;j[b+4>>2]=64;j[b+8>>2]=128;j[b>>2]=c<<6;h[b+16|0]=k[a+26|0];h[b+17|0]=k[a+27|0];l=b+108|0;m=b+236|0;c=0;e=a- -64|0;while(1){f=c<<1;g=k[f+e|0];f=k[e+(f|1)|0];p=Nc(m,c),q=f,i[p>>1]=q;p=Pb(l,c),q=(g>>>0<120?g:c)+1|0,h[p|0]=q;c=c+1|0;if((c|0)!=120){continue}break}c=a+17|0;h[b+60|0]=k[b+60|0]&254|h[c|0]&1;h[b+60|0]=k[b+60|0]&253|k[c|0]&2;h[b+60|0]=k[b+60|0]&251|k[c|0]&4;l=b+61|0;h[l|0]=k[a+18|0];m=b+62|0;h[m|0]=k[a+19|0];f=b+63|0;h[f|0]=k[a+20|0];n=b- -64|0;h[n|0]=k[a+21|0];e=b+48|0;Nf(e,25);c=0;while(1){c:{o=c<<1;g=k[(o+a|0)+504|0];p=xb(e,c),q=g,i[p>>1]=q;if((g|0)==255){Nf(e,c);break c}g=k[((o|1)+a|0)+504|0];p=xb(e,c),q=g,h[p+2|0]=q;c=c+1|0;if((c|0)!=25){continue}}break}a=k[Vg(l,m)|0];if(sb(e)>>>0<=a>>>0){h[b+60|0]=k[b+60|0]&253}a=k[Vg(f,n)|0];if(sb(e)>>>0>a>>>0){break b}h[b+60|0]=k[b+60|0]&251}Za=d+32|0;return}a=D()|0;C()|0;gb(d+16|0);G(a|0);z()}function C$(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,i=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;a=Za-192|0;Za=a;hc(a+184|0,d);j[114630]=0;o=H(21,a+184|0)|0;g=j[114630];j[114630]=0;a:{b:{c:{d:{e:{f:{g:{if((g|0)!=1){if(nb(f)){g=k[Ub(f,0)|0];j[114630]=0;l=E(22,o|0,45)|0;m=j[114630];j[114630]=0;if((m|0)==1){break g}p=(g|0)==(l&255)}m=Cb(a+160|0);l=Cb(a+144|0);g=Cb(a+128|0);j[114630]=0;ba(2502,c|0,p|0,a+184|0,a+176|0,a+175|0,a+174|0,m|0,l|0,g|0,a+124|0);c=j[114630];j[114630]=0;if((c|0)==1){break f}j[a+4>>2]=2421;n=yd(a+8|0,0,a+4|0);h:{if((nb(f)|0)>j[a+124>>2]){c=nb(f);i=j[a+124>>2];i=(nb(g)+(c-i<<1)|0)+1|0;break h}i=nb(g)+2|0}c=a+16|0;i=(nb(l)+i|0)+j[a+124>>2]|0;if(i>>>0<101){break e}fe(n,Yc(i));c=j[n>>2];if(c){break e}j[114630]=0;M(2422);b=j[114630];j[114630]=0;if((b|0)==1){break d}z()}f=D()|0;C()|0;break b}f=D()|0;C()|0;break b}f=D()|0;C()|0;break c}i=j[d+4>>2];q=zb(f);r=zb(f);f=nb(f);j[114630]=0;ga(2503,c|0,a+4|0,a|0,i|0,q|0,f+r|0,o|0,p|0,a+176|0,h[a+175|0],h[a+174|0],m|0,l|0,g|0,j[a+124>>2]);f=j[114630];j[114630]=0;if((f|0)!=1){j[114630]=0;b=_(17,b|0,c|0,j[a+4>>2],j[a>>2],d|0,e|0)|0;c=j[114630];j[114630]=0;if((c|0)!=1){break a}}}f=D()|0;C()|0;mc(n)}gb(g);gb(l);gb(m)}wb(a+184|0);G(f|0);z()}mc(n);gb(g);gb(l);gb(m);wb(a+184|0);Za=a+192|0;return b|0}function IZ(a,b,c,d,e,f){var g=0,h=0,l=0,m=0,n=0,o=0;j[c>>2]=a;j[f>>2]=d;a:{b:{c:{while(1){a=j[c>>2];if(!(a>>>0>=b>>>0|d>>>0>=e>>>0)){m=2;g=k[a|0];if(g>>>0>1114111){break a}o=c;d:{if(g<<24>>24>=0){i[d>>1]=g;a=a+1|0;break d}if(g>>>0<194){break a}if(g>>>0<=223){if((b-a|0)<2){break b}h=k[a+1|0];if((h&192)!=128){break c}g=h&63|g<<6&1984;if(g>>>0>1114111){break c}i[d>>1]=g;a=a+2|0;break d}if(g>>>0<=239){if((b-a|0)<3){break b}l=k[a+2|0];h=k[a+1|0];e:{f:{if((g|0)!=237){if((g|0)!=224){break f}if((h&224)==160){break e}break c}if((h&224)==128){break e}break c}if((h&192)!=128){break c}}if((l&192)!=128){break c}g=l&63|((h&63)<<6|g<<12);if((g&65535)>>>0>1114111){break c}i[d>>1]=g;a=a+3|0;break d}if(g>>>0>244){break a}m=1;if((b-a|0)<4){break c}l=k[a+3|0];h=k[a+2|0];a=k[a+1|0];g:{h:{switch(g-240|0){case 0:if((a+112&255)>>>0>=48){break a}break g;case 4:if((a&240)!=128){break a}break g;default:break h}}if((a&192)!=128){break a}}if((h&192)!=128|(l&192)!=128){break a}if((e-d|0)<4){break c}m=2;l=l&63;n=h<<6;g=g&7;if((l|(n&4032|(a<<12&258048|g<<18)))>>>0>1114111){break c}a=a<<2;i[d>>1]=(h>>>4&3|(a&192|g<<8|a&60))+16320|55296;j[f>>2]=d+2;i[d+2>>1]=l|n&960|56320;a=j[c>>2]+4|0}j[o>>2]=a;d=j[f>>2]+2|0;j[f>>2]=d;continue}break}m=a>>>0<b>>>0}return m}return 1}return 2}function uua(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,i=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0;e=Za-48|0;Za=e;o=j[a+16>>2];f=vf(e+16|0);j[f+8>>2]=a+112;j[f+16>>2]=j[a+128>>2];q=f,r=qf(b+327720|0,j[b+20>>2],(j[a+88>>2]&16384)>>>14|0),j[q+12>>2]=r;b=j[f+16>>2];if(b){q=f,r=uf(a+8|0,b),j[q>>2]=r;j[f+4>>2]=ab}l=j[a+40>>2];m=j[a+36>>2];i=j[a+4>>2];g=j[a>>2];j[e+8>>2]=g;j[e+12>>2]=i;b=j[a+12>>2];j[e>>2]=j[a+8>>2];j[e+4>>2]=b;a:{if(!d){b=l>>12;k=m>>12;break a}while(1){b=0;k=b;n=g;j[e+40>>2]=g;j[e+44>>2]=b;i=(((i&2147483647)<<1|g>>>31)&-2)+o|0;b:{b=j[f+16>>2];if((b|0)<=0){break b}while(1){g=(k&2147483647)<<1|n>>>31;id(j[f+8>>2],h[(g|1)+i|0]+h[i+(g&-2)|0]<<5);hd(j[f+8>>2],4);Bb(e+40|0,f);if((b|0)<2){break b}b=b-1|0;n=j[e+40>>2];k=j[e+44>>2];continue}}d=d-1|0;b=j[f+8>>2];Bb(b,b+8|0);b=j[f+8>>2];g=j[b+4>>2];if(g){k=b;b=(j[e+44>>2]&2147483647)<<1|j[e+40>>2]>>>31;id(k,h[(b|1)+i|0]+h[i+(b&-2)|0]<<5);hd(j[f+8>>2],g);b=j[f+8>>2];g=j[b>>2];j[b>>2]=g;j[b+4>>2]=0}i=pf(b,j[f+12>>2]);b=j[a+32>>2];m=j[a+28>>2]+m|0;k=m>>12;j[c>>2]=j[c>>2]+p(i,k);l=b+l|0;b=l>>12;j[c+4>>2]=j[c+4>>2]+p(i,b);Bb(e+8|0,e);if(d){c=c+8|0;g=j[e+8>>2];i=j[e+12>>2];continue}break}g=j[e+8>>2];i=j[e+12>>2]}j[a+40>>2]=l;j[a+20>>2]=k;j[a+36>>2]=m;j[a+24>>2]=b;j[a>>2]=g;j[a+4>>2]=i;Za=e+48|0}function g6(a,b,c){var d=0,e=0,f=0,g=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,u=0,v=0;e=k[c+1|0];g=p((e>>>3&1)+(e>>>4&1)|0,3)+(k[c+2|0]>>>2&3)|0;m=g-((g|0)!=0)|0;g=k[c+3|0]>191?1:2;a:{if(e&8){n=Bd(a,9);g=g<<1;d=Bd(a,g+7|0);break a}n=Bd(a,g|8)>>>g|0}e=p(m,40);r=e+42784|0;s=e+43104|0;t=p(m,23)+42592|0;m=0;b:{while(1){e=k[c+3|0];o=Bd(a,12);i[b+4>>1]=o;f=Bd(a,9);i[b+6>>1]=f;if((f&65535)>>>0>288){break b}e=e>>>0>191?d<<4:d;u=b,v=Bd(a,8),h[u+10|0]=v;d=Bd(a,k[c+1|0]&8?4:9);h[b+13|0]=22;h[b+14|0]=0;j[b>>2]=t;i[b+8>>1]=d;c:{if(Bd(a,1)){d=Bd(a,2);h[b+11|0]=d;if(!(d&255)){break b}f=Bd(a,1);i[b+18>>1]=65287;h[b+12|0]=f;if(k[b+11|0]==2){d=b;d:{if(!(f&255)){j[b>>2]=r;h[b+18|0]=8;q=39;f=0;break d}j[b>>2]=s;q=30;f=k[c+1|0]&8?8:6}h[d+14|0]=q;h[b+13|0]=f;e=e&3855}d=Bd(a,10);u=b,v=Bd(a,3),h[u+21|0]=v;u=b,v=Bd(a,3),h[u+22|0]=v;u=b,v=Bd(a,3),h[u+23|0]=v;d=d<<5;break c}h[b+11|0]=0;h[b+12|0]=0;d=Bd(a,15);u=b,v=Bd(a,4),h[u+18|0]=v;f=Bd(a,3);h[b+20|0]=255;h[b+19|0]=f}h[b+17|0]=d&31;h[b+15|0]=d>>>10;h[b+16|0]=d>>>5&31;m=(o&65535)+m|0;d=b;e:{if(k[c+1|0]&8){f=Bd(a,1);break e}f=l[b+8>>1]>499}h[d+24|0]=f;u=b,v=Bd(a,1),h[u+25|0]=v;d=Bd(a,1);h[b+27|0]=e>>>12&15;h[b+26|0]=d;b=b+28|0;d=e<<4;g=g-1|0;if(g){continue}break}return(j[a+4>>2]+m|0)>(j[a+8>>2]+(n<<3)|0)?-1:n}return-1}function FMa(a,b,c,d){var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;a:{b:{c:{d:{e:{f:{g:{h:{i:{j:{g=b;if(g){e=c;if(!e){break j}f=d;if(!f){break i}f=s(f)-s(g)|0;if(f>>>0<=31){break h}break b}if((d|0)==1|d>>>0>1){break b}b=(a>>>0)/(c>>>0)|0;_a=a-p(b,c)|0;$a=0;ab=0;return b}e=d;if(!a){break g}if(!e){break f}f=e-1|0;if(f&e){break f}_a=a;$a=f&g;a=g>>>GMa(e)|0;ab=0;return a}f=e-1|0;if(!(f&e)){break e}j=(s(e)+33|0)-s(g)|0;h=0-j|0;break c}j=f+1|0;h=63-f|0;break c}_a=0;a=(g>>>0)/(e>>>0)|0;$a=g-p(a,e)|0;ab=0;return a}f=s(e)-s(g)|0;if(f>>>0<31){break d}break b}_a=a&f;$a=0;if((e|0)==1){break a}c=a;a=GMa(e);d=a&31;if((a&63)>>>0>=32){f=0;a=b>>>d|0}else{f=b>>>d|0;a=((1<<d)-1&b)<<32-d|c>>>d}ab=f;return a}j=f+1|0;h=63-f|0}e=b;g=a;f=j&63;i=f&31;if((f&63)>>>0>=32){f=0;l=e>>>i|0}else{f=e>>>i|0;l=((1<<i)-1&e)<<32-i|g>>>i}a=h&63;h=a&31;if((a&63)>>>0>=32){e=g<<h;a=0}else{e=(1<<h)-1&g>>>32-h|b<<h;a=g<<h}b=e;if(j){g=d-1|0;e=c-1|0;g=(e|0)!=-1?g+1|0:g;h=e;while(1){e=l;f=f<<1|e>>>31;e=e<<1;k=f;f=b>>>31|e;m=k;e=k;k=f;i=g-((f>>>0>h>>>0)+e|0)|0;e=i>>31;i=i>>31;f=c&i;l=k-f|0;f=m-((d&e)+(f>>>0>k>>>0)|0)|0;e=b<<1|a>>>31;a=n|a<<1;b=e|o;e=0;m=e;k=i&1;n=k;j=j-1|0;if(j){continue}break}}_a=l;$a=f;e=b<<1|a>>>31;a=k|a<<1;ab=e|m;return a}_a=a;$a=b;a=0;b=0}ab=b;return a}function yja(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0;c=Za-144|0;Za=c;e=Gk(c+40|0,a);j[114630]=0;d=E(683,c+24|0,32325)|0;a=j[114630];j[114630]=0;a:{b:{c:{d:{if((a|0)!=1){j[114630]=0;j[c+16>>2]=19466242;j[c+20>>2]=0;I(684,e|0,d|0,c+16|0);a=j[114630];j[114630]=0;if((a|0)==1){break d}qb(d);if(!(j[e>>2]&1073741824)){break c}break a}a=D()|0;C()|0;break b}a=D()|0;C()|0;qb(d);break b}a=me(b);j[114630]=0;i[c+16>>1]=a;i[c+14>>1]=65535;d=E(683,c+24|0,32331)|0;a=j[114630];j[114630]=0;e:{if((a|0)!=1){j[114630]=0;a=K(1178,e|0,c+14|0,d|0)|0;f=j[114630];j[114630]=0;if((f|0)==1){break e}qb(d);if((a|0)!=1){i[c+16>>1]=l[c+14>>1]}Rf(c+16|0,l[j[19863]+10>>1]);f:{if(l[c+16>>1]<=me(b)>>>0){break f}j[114630]=0;F(401,b|0,l[c+16>>1]);a=j[114630];j[114630]=0;if((a|0)!=1){break f}a=D()|0;C()|0;break b}i[c+12>>1]=0;if(!l[c+16>>1]){break a}a=0;g:{while(1){h:{a=Hb(b,a&65535);j[114630]=0;F(1582,c+24|0,c+12|0);d=j[114630];j[114630]=0;if((d|0)==1){break h}j[114630]=0;P(1564,e|0,a|0,c+24|0,1583)|0;a=j[114630];j[114630]=0;if((a|0)==1){break g}qb(c+24|0);a=l[c+12>>1]+1|0;i[c+12>>1]=a;if(l[c+16>>1]>(a&65535)>>>0){continue}break a}break}a=D()|0;C()|0;break b}a=D()|0;C()|0;qb(c+24|0);break b}a=D()|0;C()|0;break b}a=D()|0;C()|0;qb(d)}ag(e);G(a|0);z()}ag(e);Za=c+144|0}function bU(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,i=0,k=0;f=Za-1072|0;Za=f;e=zh(f+16|0);i=Ml(a,e);jb(e);j[a+1060>>2]=0;j[a+1064>>2]=0;j[a+1056>>2]=c;e=a+1068|0;j[e>>2]=0;j[e+4>>2]=0;j[a+1076>>2]=0;h[a+1080|0]=d;a:{b:{if(be(c)){k=a+1060|0;e=0;while(1){j[a+1060>>2]=0;j[a+1064>>2]=0;c:{if(!j[c>>2]){break c}while(1){j[114630]=0;d=E(258,b|0,2)|0;g=j[114630];j[114630]=0;d:{e:{f:{g:{if((g|0)!=1){if(!d){break c}j[114630]=0;d=H(357,b|0)|0;g=j[114630];j[114630]=0;if((g|0)==1){break g}if(!d){break d}j[114630]=0;I(341,f|0,b|0,d|0);d=j[114630];j[114630]=0;if((d|0)==1){break f}d=Ml(f+16|0,f);Ed(i,d);Vb(i+16|0,d+16|0,1040);jb(f+16|0);jb(f);j[a+1072>>2]=0;j[a+1076>>2]=0;g=Pp(j[a+1056>>2]);d=j[a+1056>>2];if(g>>>0>=2){d=j[d+20>>2];j[114630]=0;F(358,a|0,d+(e<<1)|0);d=j[114630];j[114630]=0;if((d|0)!=1){break d}break e}d=j[d+20>>2];j[114630]=0;F(359,a|0,d+e|0);d=j[114630];j[114630]=0;if((d|0)==1){break e}break d}d=D()|0;C()|0;break a}d=D()|0;C()|0;break a}d=D()|0;C()|0;break a}d=J(77088)|0;if((C()|0)!=(W(77088)|0)){break a}O(d|0)|0;j[114630]=0;M(20);d=j[114630];j[114630]=0;if((d|0)==1){break b}}if(m[k>>2]<m[c>>2]){continue}break}}e=e+1|0;if(be(j[a+1056>>2])>>>0>e>>>0){continue}break}}Za=f+1072|0;return a|0}d=D()|0;C()|0}jb(a);G(d|0);z()}function BGa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,i=0,l=0,m=0;c=Za-32|0;Za=c;a:{b:{if(!yb(b,9)){break b}i=a+484344|0;l=a+480280|0;while(1){dn(b,c+28|0);d=hf(b);c:{if(!((k[c+28|0]|k[c+29|0]<<8|(k[c+30|0]<<16|k[c+31|0]<<24))==1229999433|(k[c+28|0]|k[c+29|0]<<8|(k[c+30|0]<<16|k[c+31|0]<<24))==1397771593|((k[c+28|0]|k[c+29|0]<<8|(k[c+30|0]<<16|k[c+31|0]<<24))==1297110104|(k[c+28|0]|k[c+29|0]<<8|(k[c+30|0]<<16|k[c+31|0]<<24))==1297110099))){if(yb(b,d)){break c}}cg(b,8);break b}cd(c+8|0,b,d);d=l;d:{if((k[c+28|0]|k[c+29|0]<<8|(k[c+30|0]<<16|k[c+31|0]<<24))==1481001027){while(1){j[114630]=0;e=H(390,c+8|0)|0;f=j[114630];j[114630]=0;if((f|0)==1){break a}h[d+8|0]=e;d=d+32|0;if((i|0)!=(d|0)){continue}break d}}e:{if(k[c+28|0]!=70){break e}d=k[c+29|0];e=(d|0)==88;if((d-48&255)>>>0>9?!e:0){break e}f=k[c+30|0];if((f-48&255)>>>0>9){break e}g=k[c+31|0];if((g-48&255)>>>0>9){break e}d=(p(f,10)+(e?-16:p(d,100)+48|0)|0)+g&255;if(d>>>0>249){break d}j[114630]=0;F(666,c+8|0,(p(d,160)+a|0)+906300|0);d=j[114630];j[114630]=0;if((d|0)!=1){break d}break a}if((k[c+28|0]|k[c+29|0]<<8|(k[c+30|0]<<16|k[c+31|0]<<24))!=1430540109){break d}j[a+1074304>>2]=0;m=1}jb(c+8|0);if(yb(b,9)){continue}break}}Za=c+32|0;return m|0}a=D()|0;C()|0;jb(c+8|0);G(a|0);z()}function sDa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,j=0,m=0,n=0,o=0,p=0,q=0;d=Za-432|0;Za=d;rc(b);Fy(b,d+376|0,d+296|0,d+8|0);e=d;if(k[d+408|0]|k[d+409|0]<<8|(k[d+410|0]<<16|k[d+411|0]<<24)){f=k[d+427|0]+1|0}else{f=1}p=e,q=bj(f),h[p+4|0]=q;g=k[Zb(15087,d+4|0)|0];h[d+7|0]=g;i[d+4>>1]=4;a:{b:{if(!g){break b}g=d+291|0;while(1){c:{f=k[d+8|0]|k[d+9|0]<<8;e=f<<8|f>>>8;if(!(e<<16>>16<0|k[g|0]>63)){if(f){n=((e&65535)>>>0>1?e:1)&65535;f=0;while(1){e=k[d+392|0]|k[d+393|0]<<8|(k[d+394|0]<<16|k[d+395|0]<<24);d:{if(!xc(b,(e<<24|e<<8&16711680|(e>>>8&65280|e>>>24))+(f<<2)|0)){break d}if(!xc(b,xz(b))){break d}e=d;e:{if(!c){m=dd(b);break e}m=up(b)}i[e+2>>1]=m;p=d,q=l[vi(d+4|0,d+2|0)>>1],i[p+4>>1]=q}f=f+1|0;if((n|0)!=(f|0)){continue}break}}e=k[d+296|0]|k[d+297|0]<<8|(k[d+298|0]<<16|k[d+299|0]<<24);if((e<<24|e<<8&16711680|(e>>>8&65280|e>>>24))>>>0>o>>>0){e=k[d+296|0]|k[d+297|0]<<8|(k[d+298|0]<<16|k[d+299|0]<<24);if(xc(b,e<<24|e<<8&16711680|(e>>>8&65280|e>>>24))){break c}}h[d+7|0]=j+1;break b}eA(a);break a}e=k[d+296|0]|k[d+297|0]<<8|(k[d+298|0]<<16|k[d+299|0]<<24);Fy(b,d+376|0,d+296|0,d+8|0);o=e<<8&16711680|e<<24|(e>>>8&65280|e>>>24);j=j+1|0;if(k[d+7|0]>(j&255)>>>0){continue}break}}i[a>>1]=l[d+4>>1];h[a+2|0]=k[d+7|0]}Za=d+432|0}function cma(a,b){var c=0,d=0,e=0,f=0,g=0,h=0,i=0,m=0,n=0,o=0,q=0;f=Za-16|0;Za=f;j[b+28>>2]=0;j[b+32>>2]=0;q=b;a:{b:{c=j[b+88>>2];if(!(c&65536)){e=j[b+676>>2];d=j[b+672>>2];break b}d=j[b+20>>2];h=j[b+672>>2];c:{if((d|0)!=(h|0)){e=j[b+24>>2];g=j[b+676>>2];break c}e=j[b+24>>2];g=j[b+676>>2];if((e|0)==(g|0)){break b}}m=a+24604|0;c=f;e=(e|0)<(g|0)|(d|0)<(h|0);d:{if(e){d=DM(m);break d}d=CM(m)}j[c+12>>2]=d;mb(f,a+1074308|0,4);if(!(!kb(f)|!(j[a+480180>>2]&4))){d=j[a+24620>>2];d=HMa(d,d>>31,5,0)+500|0;c=ab;d=ic(IMa(d,d>>>0<500?c+1|0:c,1e3,0),ab);j[f+12>>2]=d}c=j[b+656>>2];e:{if(!(!c|e^1)){e=d;c=l[c+12>>1];if(c){e=(p(c,j[a+24620>>2])>>>0)/1e5|0}n=(c|0)!=0;break e}e=j[f+12>>2];n=0}i=e?e:1;c=j[b+676>>2];o=j[b+24>>2];m=c-o<<12;g=j[b+672>>2];h=j[b+20>>2];e=g-h<<12;if(!(k[b+90|0]&32|(!(h|o)|(!(c|g)|n)))){j[f+12>>2]=j[a+1074380>>2];Md(f+12|0,d,2048);g=j[b+672>>2];i=j[f+12>>2];c=j[b+676>>2]}h=(m|0)/(i|0)|0;j[b+32>>2]=h;a=(e|0)/(i|0)|0;j[b+28>>2]=a;e=((p(h,i)|0)/-4096|0)+c|0;j[b+24>>2]=e;d=((p(a,i)|0)/-4096|0)+g|0;j[b+20>>2]=d;if(a|h){j[b+100>>2]=i;a=j[b+88>>2];break a}j[b+24>>2]=c;j[b+20>>2]=g;e=c;d=g;a=j[b+88>>2]&-65537;break a}j[b+24>>2]=e;j[b+20>>2]=d;a=c&-65537}j[q+88>>2]=a&-2097153;j[b+40>>2]=e<<12;j[b+36>>2]=d<<12;Za=f+16|0}function lxa(){var a=0,b=0,c=0,d=0,e=0,f=0,g=0,i=0,k=0,l=0;b=Za-48|0;Za=b;f=b+40|0;a=f;j[a>>2]=-1;j[a+4>>2]=-1;tsa();k=b,l=WX(),j[k+8>>2]=l;j[b+12>>2]=ab;a=j[b+12>>2];j[b+16>>2]=j[b+8>>2];j[b+20>>2]=a;a=Za-16|0;Za=a;c=msa(b+16|0);Za=a+16|0;j[b+24>>2]=c;j[b+28>>2]=ab;d=j[b+24>>2];e=d<<8&16711680|d<<24;a=j[b+28>>2];c=a<<24|d>>>8;g=c&65280;c=a<<8|d>>>24;e=c&255|g|e;c=b+32|0;a=((a&255)<<24|d>>>8)&-16777216|((a&16777215)<<8|d>>>24)&16711680|(a>>>8&65280|a>>>24)|i;h[c|0]=a;h[c+1|0]=a>>>8;h[c+2|0]=a>>>16;h[c+3|0]=a>>>24;a=e;h[c+4|0]=a;h[c+5|0]=a>>>8;h[c+6|0]=a>>>16;h[c+7|0]=a>>>24;a=j[b+36>>2];j[b+24>>2]=j[b+32>>2];j[b+28>>2]=a;GM(f,b+24|0,hb(b+24|0));k=b,l=TX(),j[k+8>>2]=l;j[b+12>>2]=ab;a=j[b+12>>2];j[b+16>>2]=j[b+8>>2];j[b+20>>2]=a;a=Za-16|0;Za=a;c=isa(b+16|0);Za=a+16|0;j[b+24>>2]=c;j[b+28>>2]=ab;d=j[b+24>>2];e=d<<8&16711680|d<<24;a=j[b+28>>2];c=a<<24|d>>>8;g=c&65280;c=a<<8|d>>>24;e=c&255|g|e;c=b+32|0;a=((a&255)<<24|d>>>8)&-16777216|((a&16777215)<<8|d>>>24)&16711680|(a>>>8&65280|a>>>24)|i;h[c|0]=a;h[c+1|0]=a>>>8;h[c+2|0]=a>>>16;h[c+3|0]=a>>>24;a=e;h[c+4|0]=a;h[c+5|0]=a>>>8;h[c+6|0]=a>>>16;h[c+7|0]=a>>>24;a=j[b+36>>2];j[b+24>>2]=j[b+32>>2];j[b+28>>2]=a;GM(f,b+24|0,hb(b+24|0));Za=b+48|0;ab=j[f+4>>2];return j[f>>2]}function NO(a,b){var c=0;a:{b:{c:{d:{if(Jd(a,15629)){break d}if(Jd(a,15656)){break d}if(Jd(a,15661)){break d}if(Jd(a,16153)){break d}if(!Jd(a,16158)){break c}}i[b+8>>1]=4;j[b>>2]=16163;break b}e:{f:{if(Jd(a,15634)){break f}if(Jd(a,15639)){break f}if(!Jd(a,16196)){break e}}h[b+10|0]=1;i[b+8>>1]=4;j[b>>2]=16201;return 1}g:{if(!Jd(a,16214)){if(!Jd(a,16219)){break g}}i[b+8>>1]=8;j[b>>2]=16224;break b}h:{if(!Jd(a,16234)){if(!Jd(a,16239)){break h}}j[b>>2]=16244;i[b+8>>1]=h[a+2|0]-48;break b}i:{if(!Jd(a,15619)){if(!Jd(a,15624)){break i}}j[b+4>>2]=1;j[b>>2]=16262;i[b+8>>1]=k[a|0]==56?8:4;return 1}if(!(_c(a,16293,3)|(k[a+3|0]-52&255)>>>0>4)){j[b>>2]=16297;i[b+8>>1]=h[a+3|0]-48;break b}j:{if(_c(a,16313,3)){if(_c(a,16317,3)){break j}}if((k[a+3|0]-52&255)>>>0>5){break j}h[b+13|0]=1;h[b+11|0]=1;j[b>>2]=16321;i[b+8>>1]=h[a+3|0]-48;return 1}k:{if((k[a|0]-49&255)>>>0>8){break k}if(!_c(a+1|0,16333,3)){h[b+12|0]=1;j[b>>2]=16337;i[b+8>>1]=h[a|0]-48;return 1}if((k[a+1|0]-48&255)>>>0>9|((k[a+2|0]|k[a+3|0]<<8)!=20035?(k[a+2|0]|k[a+3|0]<<8)!=18499:0)){break k}h[b+12|0]=1;j[b>>2]=16337;i[b+8>>1]=(h[a+1|0]+p(h[a|0],10)|0)-528;return 1}if(_c(a,16368,3)|(k[a+3|0]-52&255)>>>0>5){break a}j[b>>2]=16372;i[b+8>>1]=h[a+3|0]-48}c=1}return c}function Aga(a){a=a|0;var b=0,c=0,d=0,e=0,f=q(0),g=0,h=0;c=Za-32|0;Za=c;a:{b=j[a+20>>2];b:{if(!b){break b}j[b+148>>2]=-1;g=c,h=bb[j[j[a>>2]+40>>2]](a)|0,j[g+16>>2]=h;j[c+8>>2]=1073741822;e=j[Pd(c+16|0,c+8|0)>>2];b=e<<2;if(!b){break b}d=j[a+20>>2];j[114630]=0;F(507,d+4|0,b+4|0);b=j[114630];j[114630]=0;c:{d:{e:{f:{if((b|0)!=1){b=j[a+20>>2];j[114630]=0;F(1733,c+8|0,b+4|0);b=j[114630];j[114630]=0;if((b|0)==1){break d}j[114630]=0;j[c>>2]=0;j[c+4>>2]=0;I(1734,c+16|0,c+8|0,c|0);b=j[114630];j[114630]=0;if((b|0)==1){break f}j[114630]=0;E(1735,c+16|0,0)|0;b=j[114630];j[114630]=0;g:{if((b|0)==1){break g}b=j[j[a>>2]+176>>2];j[114630]=0;F(b|0,a|0,-1);b=j[114630];j[114630]=0;if((b|0)==1){break g}if((e|0)>=1){b=0;while(1){d=j[j[a>>2]+48>>2];j[114630]=0;f=q(da(d|0,a|0,b|0));d=j[114630];j[114630]=0;if((d|0)==1){break e}j[114630]=0;n[c+8>>2]=f;E(1736,c+16|0,c+8|0)|0;d=j[114630];j[114630]=0;if((d|0)==1){break e}b=b+1|0;if((e|0)!=(b|0)){continue}break}}b=j[j[a>>2]+180>>2];j[114630]=0;N(b|0,a|0);b=j[114630];j[114630]=0;if((b|0)!=1){break b}}b=J(71412)|0;break c}b=J(71412)|0;break c}b=J(71412)|0;break c}b=J(71412)|0;break c}b=J(71412)|0}if((C()|0)!=(W(71412)|0)){break a}O(b|0)|0;Xr(j[a+20>>2]+4|0);Q()}Za=c+32|0;return}G(b|0);z()}function HKa(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,i=0,l=0,m=0,n=0,o=0,q=0,r=0;l=Za-32|0;Za=l;h[l+12|0]=0;o=kS(l+16|0,d,l+12|0);i=j[o>>2];j[l+12>>2]=d;f=d;a:{if(!b|!f){break a}while(1){r=l;g=b-1|0;f=k[a|0];b:{c:{if(!(!g|(f|0)!=(e&255))){f=k[a+1|0];j[114630]=0;j[l+8>>2]=f;f=E(33,l+8|0,l+12|0)|0;g=j[114630];j[114630]=0;d:{if((g|0)!=1){n=a+2|0;g=b-2|0;if(!g){break d}m=j[f>>2];if(!(m&255)){break d}g=k[n|0];while(1){h[i|0]=g;f=j[l+12>>2]-1|0;j[l+12>>2]=f;i=i+1|0;m=m-1|0;if(m&255){continue}break}g=b-3|0;n=a+3|0;break b}a=D()|0;C()|0;Op(o);G(a|0);z()}h[i|0]=e;f=j[l+12>>2]-1|0;break c}n=a+1|0;h[i|0]=f;f=j[l+12>>2]-1|0}j[r+12>>2]=f;i=i+1|0}if(!g){break a}a=n;b=g;if(f){continue}break}}n=j[o>>2];e=d-f|0;e:{if(!e){break e}i=128;g=0;while(1){b=k[n|0];m=0;f=0;while(1){a=c+g|0;h[a|0]=k[a|0]|(p(b&i,257)&65535)>>>(f-m&7);a=g+1|0;g=a>>>0<d>>>0?a:0;f=(a>>>0>=d>>>0)+f|0;i=(i<<8|i)>>>1&255;a=m&65535;m=m+1|0;if(a>>>0<7){continue}break}i=(i<<8|i)>>>f&255;n=n+1|0;q=q+1|0;if((q|0)!=(e|0)){continue}break}if(!e){break e}m=0;while(1){d=c;f=d;g=m<<24>>24;b=h[d|0];d=128;f:{if((b|0)==-128){break f}a=b;d=a;if((a|0)>-1){break f}d=0-(b&127)|0}m=g-(d&255)|0;h[f|0]=m;c=c+1|0;e=e-1|0;if(e){continue}break}}Op(o);Za=l+32|0}function vo(a){var b=0,c=0,d=0,e=0,f=0,g=0;c=Za-16|0;Za=c;a:{b:{c:{d:{e:{f:{g:{h:{b=j[a+480180>>2];i:{if((b|0)<=2047){if((b|0)<=31){switch(b-1|0){case 2:case 4:case 5:case 6:break d;case 7:break g;case 0:case 1:case 3:break i;default:break e}}if((b|0)<=255){if((b|0)==32){break i}if((b|0)==64){break b}break d}if((b|0)==256|(b|0)==512){break b}break d}d=1;if((b|0)<=4194303){if((b|0)<=65535){if((b|0)==2048){break b}if((b|0)!=8192){break d}break b}if((b|0)==65536){break c}if((b|0)!=2097152){break d}break a}if((b|0)>67108863){break h}if((b|0)==4194304){break f}if((b|0)!=16777216){break d}}d=j[a+480180>>2];break a}if((b|0)==67108864|(b|0)==134217728){break a}if((b|0)!=536870912){break d}break a}d=4;if(l[a+480192>>1]){break a}a=a+484344|0;f=c,g=Lb(a),j[f+8>>2]=g;f=c,g=Mb(a),j[f>>2]=g;a=1;j:{if(!rb(c+8|0,c)){break j}while(1){b=j[c+8>>2];if(!(!uh(b)|j[b+12>>2]==64)){a=4;break j}Ax(c+8|0);if(rb(c+8|0,c)){continue}break}}Za=c+16|0;return a}d=32;if(l[a+480188>>1]>16){break a}if(!l[a+480188>>1]){break b}b=0;while(1){e=(b<<5)+a|0;if(h[e+480281|0]&1|l[e+480286>>1]!=64){break a}b=b+1|0;if(b>>>0<l[a+480188>>1]){continue}break}break b}if((b|0)==16){break b}}d=32;break a}d=16777216;break a}d=2}Za=c+16|0;return d}function WHa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,m=0,n=0;f=Za-16|0;Za=f;md(b,32);e=a+4|0;e=k[e|0]|k[e+1|0]<<8|(k[e+2|0]<<16|k[e+3|0]<<24);j[b>>2]=e<<24|e<<8&16711680|(e>>>8&65280|e>>>24);e=a+10|0;e=k[e|0]|k[e+1|0]<<8|(k[e+2|0]<<16|k[e+3|0]<<24);e=e<<24|e<<8&16711680|(e>>>8&65280|e>>>24);j[b+4>>2]=e;g=e;e=a+14|0;e=k[e|0]|k[e+1|0]<<8|(k[e+2|0]<<16|k[e+3|0]<<24);j[b+8>>2]=g+(e<<24|e<<8&16711680|(e>>>8&65280|e>>>24));e=b;if(!(d?0:c)){c=a+46|0;c=k[c|0]|k[c+1|0]<<8|(k[c+2|0]<<16|k[c+3|0]<<24);c=c<<24|c<<8&16711680|(c>>>8&65280|c>>>24)}j[e+24>>2]=c;c=k[a+8|0]<<28>>24;a:{if((d|0)!=841887798){break a}d=a+42|0;if(!(k[d|0]|k[d+1|0]<<8)|(k[d|0]|k[d+1|0]<<8)==12288){break a}e=c;c=k[d|0]|k[d+1|0]<<8;c=(e-(((c<<8|c>>>8)&65535)<<7)|0)+6144|0}js(b,+(c|0)*.0006510416666666666);h[f+15|0]=k[a+9|0];h[f+14|0]=64;m=b,n=k[Zb(f+15|0,f+14|0)|0]<<2,i[m+30>>1]=n;if(h[a+40|0]&1){i[b+34>>1]=l[b+34>>1]|64;j[b>>2]=j[b>>2]>>>1;j[b+4>>2]=j[b+4>>2]>>>1;j[b+8>>2]=j[b+8>>2]>>>1}b:{if(k[a+41|0]<=8){a=j[b+4>>2];c=j[b+8>>2];break b}i[b+34>>1]=l[b+34>>1]|1;j[b>>2]=j[b>>2]>>>1;a=j[b+4>>2]>>>1|0;j[b+4>>2]=a;c=j[b+8>>2]>>>1|0;j[b+8>>2]=c}c:{if(a+1>>>0<c>>>0){i[b+34>>1]=l[b+34>>1]|2;break c}j[b+4>>2]=0;j[b+8>>2]=0}Za=f+16|0}function MP(a,b){var c=0,d=0,e=0,f=0;c=Za-16|0;Za=c;a:{d=k[a|0];b:{if(d>>>0>21){break b}h[a|0]=k[d+14784|0];c:{switch(d-8|0){case 0:h[b|0]=k[b|0]<<1;break b;case 4:h[b|0]=k[b|0]+1>>>1;break b;case 5:a=k[b|0];h[b|0]=p(a>>>4|0,10)+(a&15);break b;case 6:d:{e:{f:{g:{h:{i:{j:{k:{l:{m:{d=k[b|0];switch((d>>>4|0)-1|0){case 10:break e;case 9:break f;case 8:break g;case 6:break h;case 5:break i;case 3:break j;case 1:break k;case 0:break l;case 11:case 12:case 13:break b;case 14:break d;default:break m}}h[a|0]=0;break b}h[a|0]=29;h[c+15|0]=k[b|0]&15;h[c+14|0]=14;e=b,f=k[Zb(c+15|0,c+14|0)|0]<<4|15,h[e|0]=f;break b}h[a|0]=29;h[c+13|0]=k[b|0]&15;h[c+12|0]=14;e=b,f=k[Zb(c+13|0,c+12|0)|0]|240,h[e|0]=f;break b}h[b|0]=d&15|48;break b}h[b|0]=d&15|176;break b}h[b|0]=d&15|64;break b}h[a|0]=15;h[b|0]=k[b|0]&15;break b}h[a|0]=24;h[b|0]=(k[b|0]<<3&120)+8&240;break b}h[a|0]=24;h[b|0]=(k[b|0]&15)+1>>>1;break b}h[a|0]=10;break b;case 8:a=k[b|0];if(a>>>0<=223){h[b|0]=a>>>0>63?-16:a<<2&240;break b}if(a>>>0<=239){h[b|0]=a<<2&48|15;break b}h[b|0]=a<<4|15;break b;case 9:break c;default:break b}}a=k[b|0];if(a>>>0<=223){break a}if(a>>>0>239){break b}h[b|0]=a>>>2&3|240}Za=c+16|0;return}h[b|0]=a>>>0>63?15:a>>>2|0;Za=c+16|0}function iD(a,b,c,d,e){var f=0,g=0,i=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;m=Za-16|0;Za=m;a:{if((c|0)<=36){f=k[a|0];b:{if(!f){break b}c:{while(1){if(!Jk(f<<24>>24)){break c}f=k[a+1|0];g=a+1|0;a=g;if(f){continue}break}a=g;break b}d:{g=k[a|0];switch(g-43|0){case 0:case 2:break d;default:break b}}p=(g|0)==45?-1:0;a=a+1|0}e:{if(!(c&-17|k[a|0]!=48)){if((k[a+1|0]&223)==88){a=a+2|0;n=16;break e}a=a+1|0;n=c?c:8;break e}n=c?c:10}s=n;t=n>>31;c=0;while(1){f:{f=-48;g=h[a|0];g:{if((g-48&255)>>>0<10){break g}f=-87;if((g-97&255)>>>0<26){break g}f=-55;if((g-65&255)>>>0>25){break f}}g=f+g|0;if((g|0)>=(n|0)){break f}Ig(m,s,t,i,l);h:{if(j[m+8>>2]|j[m+12>>2]){c=1;break h}q=c;u=HMa(i,l,s,t);o=u;r=ab;f=g>>31;c=f^-1;o=(r|0)==(c|0)&(g^-1)>>>0<o>>>0|c>>>0<r>>>0;c=o?1:q;q=i;f=f+r|0;i=g+u|0;f=i>>>0<g>>>0?f+1|0:f;i=o?q:i;l=o?l:f}a=a+1|0;continue}break}if(b){j[b>>2]=a}i:{j:{if(c){j[114604]=68;a=d&1;p=a?0:p;i=d;l=e;break j}if((e|0)==(l|0)&d>>>0>i>>>0|e>>>0>l>>>0){break i}a=d&1}if(!(a|p)){j[114604]=68;a=d;d=a-1|0;e=e-(a>>>0<1)|0;break a}if((e|0)==(l|0)&d>>>0>=i>>>0|e>>>0>l>>>0){break i}j[114604]=68;break a}a=p;c=a^i;d=c-a|0;b=a>>31;e=(b^l)-((a>>>0>c>>>0)+b|0)|0;break a}j[114604]=28;d=0;e=0}Za=m+16|0;ab=e;return d}function kva(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;g=Za-16|0;Za=g;f=j[a+48>>2];o=j[a+40>>2];q=j[a+36>>2];e=j[a+44>>2];t=j[a+16>>2];m=j[a+4>>2];k=j[a>>2];j[g+8>>2]=k;j[g+12>>2]=m;b=j[a+12>>2];j[g>>2]=j[a+8>>2];j[g+4>>2]=b;a:{if(!d){l=o>>12;r=q>>12;break a}while(1){b=m+t|0;l=h[b+2|0];r=h[b+1|0];u=h[b|0];v=h[b-1|0];b=j[a+60>>2];w=b;x=b>>31;b=e;e=Gb(e,-16777216,16776704);n=j[a+64>>2];f=Gb(f,-16777216,16776704);y=j[a+72>>2];z=j[a+32>>2];m=c;A=j[c>>2];e=HMa(n,n>>31,e,e>>31);n=ab;B=e;e=j[a+68>>2];s=HMa(e,e>>31,f,f>>31);e=B+s|0;f=ab+n|0;f=e>>>0<s>>>0?f+1|0:f;n=e;e=(k>>>21&2040)+27888|0;k=(((p(u,i[e+2>>1])+p(i[e>>1],v)|0)+p(r,i[e+4>>1])|0)+p(l,i[e+6>>1])<<8)/16384<<8;e=k;l=HMa(w,x,e,e>>31);e=n+l|0;f=ab+f|0;f=e>>>0<l>>>0?f+1|0:f;e=e+8388608|0;if(e>>>0<8388608){f=f+1|0}e=(f&16777215)<<8|e>>>24;f=(e|0)/256|0;q=j[a+28>>2]+q|0;r=q>>12;j[m>>2]=p(f,r)+A;o=o+z|0;l=o>>12;j[c+4>>2]=j[c+4>>2]+p(f,l);e=e-(k&y)|0;Bb(g+8|0,g);d=d-1|0;if(d){c=c+8|0;k=j[g+8>>2];m=j[g+12>>2];f=b;continue}break}k=j[g+8>>2];m=j[g+12>>2];f=b}j[a+40>>2]=o;j[a+20>>2]=r;j[a+36>>2]=q;j[a+48>>2]=f;j[a+44>>2]=e;j[a+24>>2]=l;j[a>>2]=k;j[a+4>>2]=m;Za=g+16|0}function Kza(a,b,c,d){var e=0,f=0,g=0,h=0,i=0,k=0,l=0,m=0;f=Za-16|0;Za=f;e=ci(c,b);j[f+12>>2]=e;a:{if((e|0)<1){break a}c=j[b+4>>2];b:{if(!c){c=j[d+4>>2];break b}c=32-c|0;j[f+8>>2]=c;e=j[Pd(f+8|0,f+12|0)>>2];j[f+12>>2]=j[f+12>>2]-e;h=j[d+4>>2];i=j[j[b>>2]>>2];k=j[b+4>>2];j[f+8>>2]=e;l=32-h|0;j[f+4>>2]=l;m=tb(f+8|0,f+4|0);g=j[d>>2];i=i&(-1<<k&-1>>>c-e);c=j[d+4>>2];h=j[b+4>>2];k=c>>>0>h>>>0?i<<c-h:i>>>h-c|0;h=j[m>>2];j[g>>2]=k|j[g>>2]&(-1<<c&-1>>>l-h^-1);k=c+h|0;c=k&31;j[d+4>>2]=c;g=g+(k>>>3&536870908)|0;j[d>>2]=g;e=e-h|0;if((e|0)>=1){j[g>>2]=j[g>>2]&(-1>>>32-e^-1)|i>>>h+j[b+4>>2];j[d+4>>2]=e;c=e}j[b>>2]=j[b>>2]+4;e=j[f+12>>2]}h=32-c|0;if((e|0)>=32){i=-1<<c;k=i^-1;g=j[b>>2];while(1){e=j[d>>2];g=j[g>>2];j[e>>2]=k&j[e>>2]|g<<c;j[d>>2]=e+4;j[e+4>>2]=i&j[e+4>>2]|g>>>h;l=j[f+12>>2];e=l-32|0;j[f+12>>2]=e;g=j[b>>2]+4|0;j[b>>2]=g;if((l|0)>63){continue}break}}if((e|0)<1){break a}i=j[j[b>>2]>>2];j[f+8>>2]=h;b=Pd(f+12|0,f+8|0);c=j[d>>2];g=j[d+4>>2];b=j[b>>2];k=j[c>>2]&(-1<<g&-1>>>h-b^-1);h=i&-1>>>32-e;j[c>>2]=k|h<<g;e=b+g|0;j[d+4>>2]=e&31;c=c+(e>>>3&536870908)|0;j[d>>2]=c;e=j[f+12>>2]-b|0;j[f+12>>2]=e;if((e|0)<1){break a}j[c>>2]=j[c>>2]&(-1>>>32-e^-1)|h>>>b;j[d+4>>2]=j[f+12>>2]}vd(a,d);Za=f+16|0}function sea(a,b,c){var d=0,e=0,f=0,g=0,h=q(0),k=0,o=q(0),r=0,s=0;e=Za-144|0;Za=e;d=j[a+4>>2];if(d>>>0>=29){j[a+4>>2]=0;d=0}d=p(d,44)+82256|0;if(!(b?0:(d|0)==j[a+4112>>2])){j[a+4112>>2]=d;h=q(c>>>0);rea(d,e+8|0,h);j[a+4124>>2]=j[e+40>>2];d=LG(MG(j[e+16>>2]),h);i[a+4190>>1]=d;i[a+4188>>1]=d;d=l[e+24>>1]<<1;i[a+4198>>1]=d;i[a+4196>>1]=d;while(1){d=(g<<4)+a|0;f=(e+8|0)+p(g,12)|0;k=j[f+44>>2];j[d+4204>>2]=k;j[d+4208>>2]=k;i[d+4212>>1]=l[f+36>>1];i[d+4214>>1]=l[f+42>>1];i[d+4216>>1]=l[f+40>>1];i[d+4218>>1]=l[f+38>>1];g=g+1|0;if((g|0)!=8){continue}break}j[a+53996>>2]=j[e+32>>2];f=a+4184|0;d=j[e+12>>2];if((d|0)>-9e3){d=KG(d)}else{d=0}j[f>>2]=d;f=a+54052|0;d=j[e+8>>2];if((d|0)>=-8999){d=KG(d)}else{d=0}j[f>>2]=d;d=j[e+28>>2];f=a+54036|0;j[f>>2]=268464128;j[f+4>>2]=1879052288;d=d>>>0<32512?d:32512;i[a+54010>>1]=d;i[a+54008>>1]=d;i[a+54006>>1]=d;i[a+54004>>1]=d;j[e+4>>2]=j[e+20>>2];Md(e+4|0,0,32752);d=l[e+4>>1];i[a+54018>>1]=d;f=a+54014|0;i[f>>1]=0;i[f+2>>1]=0;i[a+54012>>1]=d;o=n[e+36>>2];r=e,s=LG(q(o*o),h),j[r>>2]=s;Md(e,256,32512);d=l[e>>1];i[a+54026>>1]=d;f=a+54022|0;i[f>>1]=0;i[f+2>>1]=0;i[a+54020>>1]=d}if(b){j[a+4120>>2]=0;OG(a)}b=p(c,5);if(b>>>0>m[a+4124>>2]){j[a+4124>>2]=b}Za=e+144|0}function Oza(a,b,c,d){var e=0,f=0,g=0,h=0,i=0,k=0,l=0,m=0,n=0;f=Za-16|0;Za=f;g=ci(c,b);j[f+12>>2]=g;a:{if((g|0)<1){break a}c=j[b+4>>2];b:{if(!c){e=j[d+4>>2];break b}e=32-c|0;j[f+8>>2]=e;c=j[Pd(f+8|0,f+12|0)>>2];j[f+12>>2]=j[f+12>>2]-c;g=j[d+4>>2];h=j[j[b>>2]>>2];k=j[b+4>>2];j[f+8>>2]=c;l=32-g|0;j[f+4>>2]=l;m=tb(f+8|0,f+4|0);i=j[d>>2];k=h&(-1<<k&-1>>>e-c);e=j[d+4>>2];g=j[b+4>>2];h=j[m>>2];j[i>>2]=(e>>>0>g>>>0?k<<e-g:k>>>g-e|0)|j[i>>2]&(-1<<e&-1>>>l-h^-1);l=e+h|0;e=l&31;j[d+4>>2]=e;i=i+(l>>>3&536870908)|0;j[d>>2]=i;c=c-h|0;if((c|0)>=1){j[i>>2]=j[i>>2]&(-1>>>32-c^-1)|k>>>g+h;j[d+4>>2]=c;e=c}j[b>>2]=j[b>>2]+4;g=j[f+12>>2]}i=32-e|0;if((g|0)>=32){l=-1<<e;m=l^-1;h=j[b>>2];c=j[d>>2];k=j[c>>2];while(1){g=j[h>>2];j[c>>2]=k&m|g<<e;k=l&j[c+4>>2]|g>>>i;j[c+4>>2]=k;n=j[f+12>>2];g=n-32|0;j[f+12>>2]=g;h=h+4|0;c=c+4|0;if((n|0)>63){continue}break}j[b>>2]=h;j[d>>2]=c}if((g|0)<1){break a}h=j[j[b>>2]>>2];j[f+8>>2]=i;b=Pd(f+12|0,f+8|0);c=j[d>>2];e=j[d+4>>2];b=j[b>>2];g=h&-1>>>32-g;j[c>>2]=j[c>>2]&(-1<<e&-1>>>i-b^-1)|g<<e;e=b+e|0;j[d+4>>2]=e&31;c=c+(e>>>3&536870908)|0;j[d>>2]=c;e=j[f+12>>2]-b|0;j[f+12>>2]=e;if((e|0)<1){break a}j[c>>2]=j[c>>2]&(-1>>>32-e^-1)|g>>>b;j[d+4>>2]=j[f+12>>2]}vd(a,d);Za=f+16|0}function dva(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;g=Za-32|0;Za=g;a:{b:{c:{h=j[a+8>>2];e=j[a+12>>2];d:{if((e|0)<1?1:(e|0)<=1?h>>>0<=805306368:0){if((e|0)>-2?1:(e|0)>=-2?h>>>0>=3489660928:0){break c}if((e|0)>-2?1:(e|0)>=-2?h>>>0>2147483647:0){break d}break b}if((e|0)>1?1:(e|0)>=1?h>>>0>2147483648:0){break b}}k=b+196648|0;break a}k=b+131112|0;break a}k=b+262184|0}l=j[a+16>>2];m=j[a+24>>2];n=j[a+20>>2];b=j[a+4>>2];f=j[a>>2];j[g+24>>2]=f;j[g+28>>2]=b;j[g+16>>2]=h;j[g+20>>2]=e;if(d){while(1){e=((((b&2147483647)<<1|f>>>31)&2147483646)<<1)+l|0;b=(f>>>16&65520)+k|0;o=i[b+14>>1];q=i[b+12>>1];r=i[b+10>>1];s=i[b+8>>1];t=i[b+6>>1];u=i[b+4>>1];v=i[b+2>>1];w=i[b>>1];h=0;b=1;while(1){f=h<<1;j[(g+8|0)+(h<<2)>>2]=(((((((p(i[(f|-8)+e>>1],v)+p(i[(f|-12)+e>>1],w)|0)+p(i[(f|-4)+e>>1],u)|0)+p(i[e+f>>1],t)|0)+p(i[(f|4)+e>>1],s)|0)+p(i[(f|8)+e>>1],r)|0)+p(i[(f|12)+e>>1],q)|0)+p(i[(f|16)+e>>1],o)|0)/32768;f=b;b=0;h=1;if(f){continue}break}j[c>>2]=j[c>>2]+p(j[g+8>>2],n);j[c+4>>2]=j[c+4>>2]+p(j[g+12>>2],m);Bb(g+24|0,g+16|0);d=d-1|0;if(d){c=c+8|0;f=j[g+24>>2];b=j[g+28>>2];continue}break}f=j[g+24>>2];b=j[g+28>>2]}j[a>>2]=f;j[a+4>>2]=b;Za=g+32|0}function jva(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;g=Za-16|0;Za=g;e=j[a+48>>2];n=j[a+40>>2];o=j[a+36>>2];f=j[a+44>>2];s=j[a+16>>2];m=j[a+4>>2];l=j[a>>2];j[g+8>>2]=l;j[g+12>>2]=m;b=j[a+12>>2];j[g>>2]=j[a+8>>2];j[g+4>>2]=b;a:{if(!d){k=n>>12;h=o>>12;break a}while(1){b=(m<<1)+s|0;h=i[b>>1];t=i[b-2>>1];u=i[b+2>>1];v=i[b+4>>1];r=j[a+60>>2];b=f;f=Gb(f,-16777216,16776704);q=j[a+64>>2];k=Gb(e,-16777216,16776704);w=j[a+72>>2];x=j[a+32>>2];m=c;y=j[c>>2];e=HMa(q,q>>31,f,f>>31);q=ab;f=e;e=(l>>>21&2040)+27888|0;l=(((p(i[e+2>>1],h)+p(i[e>>1],t)|0)+p(u,i[e+4>>1])|0)+p(v,i[e+6>>1])|0)/16384<<8;e=l;h=HMa(r,r>>31,e,e>>31);f=f+h|0;e=ab+q|0;e=f>>>0<h>>>0?e+1|0:e;h=f;f=j[a+68>>2];k=HMa(f,f>>31,k,k>>31);f=h+k|0;e=ab+e|0;e=f>>>0<k>>>0?e+1|0:e;f=f+8388608|0;if(f>>>0<8388608){e=e+1|0}f=(e&16777215)<<8|f>>>24;e=(f|0)/256|0;o=j[a+28>>2]+o|0;h=o>>12;j[m>>2]=p(e,h)+y;n=n+x|0;k=n>>12;j[c+4>>2]=j[c+4>>2]+p(e,k);f=f-(l&w)|0;Bb(g+8|0,g);d=d-1|0;if(d){c=c+8|0;l=j[g+8>>2];m=j[g+12>>2];e=b;continue}break}l=j[g+8>>2];m=j[g+12>>2];e=b}j[a+40>>2]=n;j[a+20>>2]=h;j[a+36>>2]=o;j[a+48>>2]=e;j[a+44>>2]=f;j[a+24>>2]=k;j[a>>2]=l;j[a+4>>2]=m;Za=g+16|0}function aja(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,k=q(0),o=q(0),p=0,s=0,t=0,u=q(0);h=Za-16|0;Za=h;a:{if(i[d>>1]>i[d+2>>1]){break a}if(!sb(b)){break a}g=i[e>>1];if((g|0)<i[d>>1]){break a}p=i[d+2>>1];if((g|0)>(p|0)){break a}if((sb(b)-1&65535)>>>0>(p-g&65535)>>>0|m[a+36>>2]>65535){break a}b:{if(!sb(b)){break b}while(1){if(!(n[xb(b,f)>>2]<q(0))){f=f+1|0;if(sb(b)>>>0>f>>>0){continue}break b}break}f=0;break a}f=0;if(n[c>>2]<=q(0)){break a}i[a>>1]=1;i[a+28>>1]=l[d>>1];s=a,t=pI(sb(b)),i[s+30>>1]=t;n[a+32>>2]=r(n[c>>2]);g=a+4|0;Wk(g,(i[d+2>>1]-i[d>>1]|0)+1|0);c=Lb(b);b=Mb(b);s=h,t=Lb(g),j[s+8>>2]=t;$ia(c,b,So(h+8|0,i[e>>1]-i[d>>1]|0));b=i[e>>1];f=i[a+28>>1];c:{if((b|0)<=(f|0)){c=b;break c}while(1){b=b-1|0;k=n[xb(g,i[a+30>>1]+(b-f|0)|0)>>2];o=n[a+32>>2];s=xb(g,b-i[a+28>>1]|0),u=q(k/o),n[s>>2]=u;c=i[e>>1];f=i[a+28>>1];if((f|0)>=(b|0)){break c}if((c|0)!=-32768){continue}break}}f=i[a+30>>1];b=f+c|0;d:{if((b|0)>i[d+2>>1]|(32767-f|0)<(c|0)){break d}while(1){k=n[a+32>>2];o=n[xb(g,(b-f|0)-i[a+28>>1]|0)>>2];s=xb(g,b-i[a+28>>1]|0),u=q(o*k),n[s>>2]=u;if(i[d+2>>1]<=(b|0)){break d}b=b+1|0;f=i[a+30>>1];if(i[e>>1]<=(32767-f|0)){continue}break}}ko(a);f=1}Za=h+16|0;return f|0}function T$(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;var i=0,l=0;a=Za-160|0;Za=a;j[a+144>>2]=c;j[a+152>>2]=b;j[a+20>>2]=2483;b=yd(a+24|0,a+32|0,a+20|0);j[114630]=0;hc(a+16|0,e);i=j[114630];j[114630]=0;a:{b:{c:{d:{if((i|0)!=1){j[114630]=0;i=H(21,a+16|0)|0;l=j[114630];j[114630]=0;if((l|0)==1){break b}h[a+15|0]=0;e=j[e+4>>2];j[114630]=0;c=ha(2484,a+152|0,c|0,d|0,a+16|0,e|0,f|0,a+15|0,i|0,b|0,a+20|0,a+132|0)|0;d=j[114630];j[114630]=0;if((d|0)==1){break b}if(!c){break c}Ce(g);if(!k[a+15|0]){break d}j[114630]=0;c=E(22,i|0,45)|0;d=j[114630];j[114630]=0;if((d|0)==1){break b}j[114630]=0;F(110,g|0,c|0);c=j[114630];j[114630]=0;if((c|0)!=1){break d}break b}e=D()|0;C()|0;break a}j[114630]=0;i=E(22,i|0,48)|0;c=j[114630];j[114630]=0;if((c|0)!=1){e=j[b>>2];l=j[a+20>>2];c=l-1|0;d=c>>>0<e>>>0?e:c;i=i&255;while(1){e:{if(c>>>0>e>>>0){if((i|0)==k[e|0]){break e}d=e}j[114630]=0;K(2492,g|0,d|0,l|0)|0;c=j[114630];j[114630]=0;if((c|0)!=1){break c}break b}e=e+1|0;continue}}break b}j[114630]=0;c=E(2424,a+152|0,a+144|0)|0;d=j[114630];j[114630]=0;if((d|0)==1){break b}if(c){j[f>>2]=j[f>>2]|2}c=j[a+152>>2];wb(a+16|0);mc(b);Za=a+160|0;return c|0}e=D()|0;C()|0;wb(a+16|0)}mc(b);G(e|0);z()}function xua(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0;e=Za-48|0;Za=e;l=j[a+16>>2];f=vf(e+16|0);j[f+8>>2]=a+112;j[f+16>>2]=j[a+128>>2];q=f,r=qf(b+327720|0,j[b+20>>2],(j[a+88>>2]&16384)>>>14|0),j[q+12>>2]=r;b=j[f+16>>2];if(b){q=f,r=uf(a+8|0,b),j[q>>2]=r;j[f+4>>2]=ab}m=j[a+24>>2];n=j[a+20>>2];b=j[a+4>>2];g=j[a>>2];j[e+8>>2]=g;j[e+12>>2]=b;h=j[a+12>>2];j[e>>2]=j[a+8>>2];j[e+4>>2]=h;if(d){while(1){h=0;k=g;j[e+40>>2]=g;j[e+44>>2]=o;g=((((b&2147483647)<<1|g>>>31)&2147483646)<<1)+l|0;a:{b=j[f+16>>2];if((b|0)<=0){break a}while(1){h=(h&2147483647)<<1|k>>>31;id(j[f+8>>2],(i[(h<<1|2)+g>>1]+i[g+((h&2147483646)<<1)>>1]|0)/8<<16>>16);hd(j[f+8>>2],4);Bb(e+40|0,f);if((b|0)<2){break a}b=b-1|0;k=j[e+40>>2];h=j[e+44>>2];continue}}d=d-1|0;b=j[f+8>>2];Bb(b,b+8|0);b=j[f+8>>2];h=j[b+4>>2];if(h){k=b;b=(j[e+44>>2]&2147483647)<<1|j[e+40>>2]>>>31;id(k,(i[(b<<1|2)+g>>1]+i[g+((b&2147483646)<<1)>>1]|0)/8<<16>>16);hd(j[f+8>>2],h);b=j[f+8>>2];h=j[b>>2];j[b>>2]=h;j[b+4>>2]=0}b=pf(b,j[f+12>>2]);j[c>>2]=j[c>>2]+p(b,n);j[c+4>>2]=j[c+4>>2]+p(b,m);Bb(e+8|0,e);if(d){c=c+8|0;g=j[e+8>>2];b=j[e+12>>2];continue}break}g=j[e+8>>2];b=j[e+12>>2]}j[a>>2]=g;j[a+4>>2]=b;Za=e+48|0}function xpa(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,l=0,m=0,n=0,q=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0;h=Za-16|0;Za=h;x=h,y=p(j[a>>2],be(a)),j[x+4>>2]=y;jc(h+4|0,c>>>3|0);c=lb(b);m=o[e+8>>3];l=j[h+4>>2];a:{if(!l){break a}e=l;while(1){n=0;f=c;q=k[f+4|0]|k[f+5|0]<<8|(k[f+6|0]<<16|k[f+7|0]<<24);g=k[f|0]|k[f+1|0]<<8|(k[f+2|0]<<16|k[f+3|0]<<24);v=g<<24|g<<8&16711680;s=n;n=q<<24|g>>>8;f=q<<8|g>>>24;s=s|0;n=n&65280|f&255|v;f=q;PMa(0,((f&255)<<24|g>>>8)&-16777216|((f&16777215)<<8|g>>>24)&16711680|(f>>>8&65280|f>>>24)|s);PMa(1,n&2147483647);m=u(+QMa(),m);c=c+8|0;e=e-1|0;if(e){continue}break}if(!l|m==0){break a}w=1/m;c=j[a+20>>2];while(1){e=b;a=k[e+4|0]|k[e+5|0]<<8|(k[e+6|0]<<16|k[e+7|0]<<24);g=k[e|0]|k[e+1|0]<<8|(k[e+2|0]<<16|k[e+3|0]<<24);f=g<<24;v=0;q=g<<8&16711680|f;s=a<<24|g>>>8;f=a<<8|g>>>24;e=a;PMa(0,((e&255)<<24|g>>>8)&-16777216|((e&16777215)<<8|g>>>24)&16711680|(e>>>8&65280|e>>>24)|v);PMa(1,q|(s&65280|f&255));x=h,z=+QMa()*w,o[x+8>>3]=z;wf(h+8|0,-1,1);t=o[h+8>>3]*32768;o[h+8>>3]=t;a=c;t=zd(t);b:{if(r(t)<2147483648){e=~~t;break b}e=-2147483648}x=a,y=Dc(e),i[x>>1]=y;b=b+8|0;c=c+2|0;l=l-1|0;if(l){continue}break}}if(d){o[d>>3]=m}Za=h+16|0;return j[h+4>>2]<<3}function Fo(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,n=0;e=Za-16|0;Za=e;f=a+1074308|0;mb(e+8|0,f,96);d=kb(e+8|0);j[b+660>>2]=(d?0:j[b+660>>2])+c;a:{if(!(k[b+88|0]&2)|(!(j[a+480180>>2]&18)|m[b+84>>2]>c>>>0)){break a}d=j[b+84>>2];if(!d){break a}g=c;c=j[b+80>>2];c=((g-c>>>0)%(d-c>>>0)|0)+c|0}c=c>>>(j[a+480180>>2]==16384?j[b+88>>2]&1:0)|0;b:{if(Mf(b+810|0)){d=j[b+656>>2];if(d){d=l[Nc(d+236|0,k[b+810|0]-1|0)>>1];if(!d|d>>>0>l[a+480190>>1]){break b}}if(k[a+480210|0]&32){d=c;c=j[b+660>>2];j[b+660>>2]=d+c}j[b>>2]=0;j[b+4>>2]=c;if(!(k[b+88|0]&2)|m[b+84>>2]>c>>>0?m[b+76>>2]>c>>>0:0){break b}mb(e+8|0,f,57);if(!(h=!kb(e+8|0),i=0,n=j[a+480180>>2]!=16,n?h:i)){j[b+700>>2]=0;j[b+88>>2]=j[b+88>>2]|2097152;break b}if(!(j[a+480180>>2]&1048581)){mb(e+8|0,f,27);if(kb(e+8|0)){if(k[a+480208|0]&4){d=j[b+76>>2];j[b>>2]=0;j[b+4>>2]=d;break b}j[b>>2]=0;j[b+4>>2]=0;break b}d=j[b+80>>2];j[b>>2]=0;j[b+4>>2]=d;if(!(k[a+480208|0]&4)){break b}a=j[b+76>>2];if(a>>>0<5){break b}j[b>>2]=0;j[b+4>>2]=a-2;break b}if(!(k[b+88|0]&2)|j[a+480180>>2]!=1){break b}a=j[b+80>>2];j[b>>2]=0;j[b+4>>2]=a;break b}if(!(j[a+480180>>2]&268582928)|m[b+76>>2]<=c>>>0){break b}j[b>>2]=0;j[b+4>>2]=c}Za=e+16|0}function eva(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;e=Za-32|0;Za=e;a:{b:{c:{f=j[a+8>>2];g=j[a+12>>2];d:{if((g|0)<1?1:(g|0)<=1?f>>>0<=805306368:0){if((g|0)>-2?1:(g|0)>=-2?f>>>0>=3489660928:0){break c}if((g|0)>-2?1:(g|0)>=-2?f>>>0>2147483647:0){break d}break b}if((g|0)>1?1:(g|0)>=1?f>>>0>2147483648:0){break b}}l=b+196648|0;break a}l=b+131112|0;break a}l=b+262184|0}m=j[a+16>>2];n=j[a+24>>2];o=j[a+20>>2];b=j[a+4>>2];k=j[a>>2];j[e+24>>2]=k;j[e+28>>2]=b;j[e+16>>2]=f;j[e+20>>2]=g;g=a;if(d){while(1){f=(((b&2147483647)<<1|k>>>31)&-2)+m|0;a=(k>>>16&65520)+l|0;q=i[a+14>>1];r=i[a+12>>1];s=i[a+10>>1];t=i[a+8>>1];u=i[a+6>>1];v=i[a+4>>1];w=i[a+2>>1];x=i[a>>1];b=0;a=1;while(1){j[(e+8|0)+(b<<2)>>2]=(((((((p(h[(b|-4)+f|0],w)+p(h[(b|-6)+f|0],x)|0)+p(h[(b|-2)+f|0],v)|0)+p(h[b+f|0],u)|0)+p(h[(b|2)+f|0],t)|0)+p(h[(b|4)+f|0],s)|0)+p(h[(b|6)+f|0],r)|0)+p(h[(b|8)+f|0],q)<<8)/32768;k=a;a=0;b=1;if(k){continue}break}j[c>>2]=j[c>>2]+p(j[e+8>>2],o);j[c+4>>2]=j[c+4>>2]+p(j[e+12>>2],n);Bb(e+24|0,e+16|0);d=d-1|0;if(d){c=c+8|0;k=j[e+24>>2];b=j[e+28>>2];continue}break}k=j[e+24>>2];b=j[e+28>>2]}j[g>>2]=k;j[g+4>>2]=b;Za=e+32|0}function gaa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0;b=Za-2144|0;Za=b;Ab(b+96|0,0,2048);a:{b:{c:{f=j[c+4>>2];if(!f){a=R(8)|0;j[114630]=0;b=E(85,b+80|0,38655)|0;c=j[114630];j[114630]=0;if((c|0)==1){break c}Wb(a,b);j[114630]=0;I(2004,a|0,83648,2012);a=j[114630];j[114630]=0;if((a|0)!=1){break a}c=D()|0;C()|0;gb(b);break b}g=j[c>>2];d=j[c+12>>2];e=j[c+8>>2];j[b+72>>2]=e;j[b+76>>2]=d;c=j[b+76>>2];j[b+24>>2]=j[b+72>>2];j[b+28>>2]=c;j[b+68>>2]=f;j[b+64>>2]=g;c=j[b+68>>2];j[b+16>>2]=j[b+64>>2];j[b+20>>2]=c;c=b;i=b;h=$P(b+16|0);if(h){j[b+48>>2]=e;j[b+52>>2]=d;d=j[b+52>>2];j[b+8>>2]=j[b+48>>2];j[b+12>>2]=d;j[b+44>>2]=f;j[b+40>>2]=g;d=j[b+44>>2];j[b>>2]=j[b+40>>2];j[b+4>>2]=d;d=WP(b)}else{d=0}j[i+56>>2]=d;j[c+60>>2]=0;d=0;c=2048;while(1){if(c){e=bb[f|0](g,(b+96|0)+d|0,c)|0;c=c-e|0;d=d+e|0;if(e){continue}}break}a=Gr(a,ql(b+32|0,lb(b+96|0),d),h?b+56|0:0);if(a+1>>>0>=3){a=R(8)|0;j[114630]=0;b=E(85,b+80|0,38640)|0;c=j[114630];j[114630]=0;if((c|0)!=1){Wb(a,b);j[114630]=0;I(2004,a|0,83648,2012);a=j[114630];j[114630]=0;if((a|0)!=1){break a}c=D()|0;C()|0;gb(b);break b}c=D()|0;C()|0;S(a|0);break b}Za=b+2144|0;return a|0}c=D()|0;C()|0;S(a|0)}G(c|0)}z()}function L$(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;var i=0,l=0;a=Za-448|0;Za=a;j[a+432>>2]=c;j[a+440>>2]=b;j[a+20>>2]=2483;b=yd(a+24|0,a+32|0,a+20|0);j[114630]=0;hc(a+16|0,e);i=j[114630];j[114630]=0;a:{b:{c:{d:{if((i|0)!=1){j[114630]=0;i=H(2450,a+16|0)|0;l=j[114630];j[114630]=0;if((l|0)==1){break b}h[a+15|0]=0;e=j[e+4>>2];j[114630]=0;c=ha(2494,a+440|0,c|0,d|0,a+16|0,e|0,f|0,a+15|0,i|0,b|0,a+20|0,a+432|0)|0;d=j[114630];j[114630]=0;if((d|0)==1){break b}if(!c){break c}K$(g);if(!k[a+15|0]){break d}j[114630]=0;c=E(2476,i|0,45)|0;d=j[114630];j[114630]=0;if((d|0)==1){break b}j[114630]=0;F(112,g|0,c|0);c=j[114630];j[114630]=0;if((c|0)!=1){break d}break b}e=D()|0;C()|0;break a}j[114630]=0;c=E(2476,i|0,48)|0;d=j[114630];j[114630]=0;if((d|0)==1){break b}e=j[b>>2];d=j[a+20>>2];i=d-4|0;while(1){if(!((c|0)!=j[e>>2]|e>>>0>=i>>>0)){e=e+4|0;continue}break}j[114630]=0;K(2500,g|0,e|0,d|0)|0;c=j[114630];j[114630]=0;if((c|0)!=1){break c}break b}j[114630]=0;c=E(2456,a+440|0,a+432|0)|0;d=j[114630];j[114630]=0;if((d|0)==1){break b}if(c){j[f>>2]=j[f>>2]|2}c=j[a+440>>2];wb(a+16|0);mc(b);Za=a+448|0;return c|0}e=D()|0;C()|0;wb(a+16|0)}mc(b);G(e|0);z()}function dCa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,m=0;e=Za-16|0;Za=e;md(b,0);f=k[a|0]|k[a+1|0]<<8|(k[a+2|0]<<16|k[a+3|0]<<24);a:{if(c&34){if(d){j[b+24>>2]=f;break a}g=b,m=Zj(Cg(+(f+1408|0)*.0006510416666666666)*8363),j[g+24>>2]=m;break a}h[b+37|0]=(c|0)==16?f:f^128;h[b+36|0]=k[a+4|0]}h[e+15|0]=k[a+5|0];h[e+14|0]=64;g=b,m=k[Zb(e+15|0,e+14|0)|0]<<2,i[g+30>>1]=m;d=a+6|0;if((k[d|0]|k[d+1|0]<<8)>>>0<=256){i[b+28>>1]=k[d|0]|k[d+1|0]<<8;i[b+34>>1]=l[b+34>>1]|32}d=a+8|0;j[b>>2]=k[d|0]|k[d+1|0]<<8|(k[d+2|0]<<16|k[d+3|0]<<24);d=a+12|0;j[b+4>>2]=k[d|0]|k[d+1|0]<<8|(k[d+2|0]<<16|k[d+3|0]<<24);d=a+16|0;j[b+8>>2]=k[d|0]|k[d+1|0]<<8|(k[d+2|0]<<16|k[d+3|0]<<24);d=a+20|0;if(k[d|0]&16){i[b+34>>1]=l[b+34>>1]|2}if(k[d|0]&32){i[b+34>>1]=l[b+34>>1]|4}if(h[d+1|0]&1){i[b+34>>1]=l[b+34>>1]|8}if(k[d+1|0]&2){i[b+34>>1]=l[b+34>>1]|16}h[b+38|0]=k[(k[a+22|0]&7)+27872|0];h[b+39|0]=k[a+23|0];h[b+40|0]=k[a+24|0];h[b+41|0]=k[a+25|0];if((c|0)==32){h[e+13|0]=k[a+26|0];h[e+12|0]=64;g=b,m=k[Zb(e+13|0,e+12|0)|0],i[g+32>>1]=m}c=a+27|0;j[b+12>>2]=k[c|0]|k[c+1|0]<<8|(k[c+2|0]<<16|k[c+3|0]<<24);a=a+31|0;j[b+16>>2]=k[a|0]|k[a+1|0]<<8|(k[a+2|0]<<16|k[a+3|0]<<24);Za=e+16|0}function qm(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,k=0;c=Za-80|0;Za=c;g=$v(a);e=b+24|0;a:{b:{if(rh(j[e>>2]+484360|0)){if(rh(j[e>>2]+484360|0)){a=0;while(1){f=j[e>>2];b=vG(JO(c+40|0,1),a&255,0,0);j[114630]=0;d=j[b+12>>2];j[c+8>>2]=j[b+8>>2];j[c+12>>2]=d;d=j[b+20>>2];j[c+16>>2]=j[b+16>>2];j[c+20>>2]=d;d=j[b+4>>2];j[c>>2]=j[b>>2];j[c+4>>2]=d;L(2123,c- -64|0,f|0,0,c|0);b=j[114630];j[114630]=0;c:{d:{if((b|0)!=1){i=c,k=Lb(c- -64|0),j[i+32>>2]=k;i=c,k=Mb(c- -64|0),j[i+24>>2]=k;if(rb(c+32|0,c+24|0)){break d}break c}a=D()|0;C()|0;break b}while(1){e:{b=j[c+32>>2];f=l[b+24>>1];h=o[b>>3];d=j[b+16>>2];b=c+40|0;j[b+16>>2]=a;j[b+12>>2]=f;j[b+8>>2]=d;o[b>>3]=h;j[114630]=0;F(2124,g|0,b|0);b=j[114630];j[114630]=0;if((b|0)==1){break e}Jx(c+32|0);if(rb(c+32|0,c+24|0)){continue}break c}break}a=D()|0;C()|0;ll(c- -64|0);break b}ll(c- -64|0);a=a+1|0;if(rh(j[e>>2]+484360|0)>>>0>a>>>0){continue}break}}Za=c+80|0;return}b=R(8)|0;j[114630]=0;c=E(85,c+40|0,38593)|0;a=j[114630];j[114630]=0;if((a|0)!=1){Wb(b,c);j[114630]=0;I(2004,b|0,83648,2012);a=j[114630];j[114630]=0;if((a|0)!=1){break a}a=D()|0;C()|0;gb(c);break b}a=D()|0;C()|0;S(b|0)}Ye(g);G(a|0)}z()}function KZ(a,b,c,d,e,f){var g=0,i=0;j[c>>2]=a;j[f>>2]=d;g=j[c>>2];a:{b:{while(1){if(b>>>0<=g>>>0){a=0;break a}a=2;d=l[g>>1];if(d>>>0>1114111){break a}c:{d:{if(d>>>0<=127){a=1;g=j[f>>2];if((e-g|0)<1){break a}j[f>>2]=g+1;h[g|0]=d;break d}if(d>>>0<=2047){a=j[f>>2];if((e-a|0)<2){break b}j[f>>2]=a+1;h[a|0]=d>>>6|192;a=j[f>>2];j[f>>2]=a+1;h[a|0]=d&63|128;break d}if(d>>>0<=55295){a=j[f>>2];if((e-a|0)<3){break b}j[f>>2]=a+1;h[a|0]=d>>>12|224;a=j[f>>2];j[f>>2]=a+1;h[a|0]=d>>>6&63|128;a=j[f>>2];j[f>>2]=a+1;h[a|0]=d&63|128;break d}if(d>>>0<=56319){a=1;if((b-g|0)<4){break a}i=l[g+2>>1];if((i&64512)!=56320){break c}if((e-j[f>>2]|0)<4){break a}a=d&960;if((i&1023|(d<<10&64512|a<<10))+65536>>>0>1114111){break c}j[c>>2]=g+2;g=j[f>>2];j[f>>2]=g+1;a=(a>>>6|0)+1|0;h[g|0]=a>>>2|240;g=j[f>>2];j[f>>2]=g+1;h[g|0]=a<<4&48|d>>>2&15|128;a=j[f>>2];j[f>>2]=a+1;h[a|0]=i>>>6&15|d<<4&48|128;a=j[f>>2];j[f>>2]=a+1;h[a|0]=i&63|128;break d}if(d>>>0<57344){break a}a=j[f>>2];if((e-a|0)<3){break b}j[f>>2]=a+1;h[a|0]=d>>>12|224;a=j[f>>2];j[f>>2]=a+1;h[a|0]=d>>>6&63|128;a=j[f>>2];j[f>>2]=a+1;h[a|0]=d&63|128}g=j[c>>2]+2|0;j[c>>2]=g;continue}break}return 2}return 1}return a}function wD(a,b){var c=0,d=0,e=0,f=0;a:{b:{c:{c=j[a+4>>2];d:{if(c>>>0<m[a+104>>2]){j[a+4>>2]=c+1;c=k[c|0];break d}c=Jc(a)}switch(c-43|0){case 0:case 2:break b;default:break c}}b=c-48|0;break a}f=(c|0)==45;e=!b;b=j[a+4>>2];e:{if(b>>>0<m[a+104>>2]){j[a+4>>2]=b+1;c=k[b|0];break e}c=Jc(a)}b=c-48|0;if(!(e|b>>>0<10|!j[a+104>>2])){j[a+4>>2]=j[a+4>>2]-1}}f:{if(b>>>0<10){b=0;while(1){d=p(b,10)+c|0;b=j[a+4>>2];g:{if(b>>>0<m[a+104>>2]){j[a+4>>2]=b+1;c=k[b|0];break g}c=Jc(a)}e=c-48|0;b=d-48|0;if((b|0)<214748364?e>>>0<=9:0){continue}break}d=b;b=b>>31;h:{if(e>>>0>=10){break h}while(1){d=HMa(d,b,10,0);c=d+c|0;b=ab;b=c>>>0<d>>>0?b+1|0:b;d=c-48|0;b=b-(c>>>0<48)|0;c=j[a+4>>2];i:{if(c>>>0<m[a+104>>2]){j[a+4>>2]=c+1;c=k[c|0];break i}c=Jc(a)}e=c-48|0;if(e>>>0>9){break h}if((b|0)<21474836?1:(b|0)<=21474836?d>>>0<2061584302:0){continue}break}}if(e>>>0<10){while(1){c=j[a+4>>2];j:{if(c>>>0<m[a+104>>2]){j[a+4>>2]=c+1;c=k[c|0];break j}c=Jc(a)}if(c-48>>>0<10){continue}break}}if(j[a+104>>2]){j[a+4>>2]=j[a+4>>2]-1}a=d;d=f?0-a|0:a;b=f?0-(((a|0)!=0)+b|0)|0:b;break f}b=-2147483648;if(!j[a+104>>2]){break f}j[a+4>>2]=j[a+4>>2]-1;ab=-2147483648;return 0}ab=b;return d}function jga(a){a=a|0;var b=0,c=0,d=0,e=0,f=0,g=0,i=0,l=0;c=Za+ -64|0;Za=c;dga(a);j[114630]=0;l=a;F(1749,a|0,11);b=j[114630];j[114630]=0;a:{if((b|0)!=1){b=80096;b:{c:{d:{e:{f:{g:{h:{i:{j:{k:{while(1){d=kg(44);if(d){g=j[b>>2];f=j[b+4>>2];j[114630]=0;f=E(85,c+32|0,f|0)|0;e=j[114630];j[114630]=0;if((e|0)==1){break k}j[114630]=0;F(1750,c+48|0,f|0);e=j[114630];j[114630]=0;if((e|0)==1){break j}e=j[b+8>>2];j[114630]=0;e=E(85,c|0,e|0)|0;i=j[114630];j[114630]=0;if((i|0)==1){break i}j[114630]=0;F(1750,c+16|0,e|0);i=j[114630];j[114630]=0;if((i|0)==1){break h}j[114630]=0;U(1751,d|0,g|0,1,c+48|0,c+16|0)|0;g=j[114630];j[114630]=0;if((g|0)==1){break g}qb(c+16|0);gb(e);qb(c+48|0);gb(f);j[114630]=0;j[c+60>>2]=d;F(1752,l|0,c+60|0);d=j[114630];j[114630]=0;if((d|0)==1){break b}d=j[c+60>>2];j[d+32>>2]=j[b+12>>2];j[d+36>>2]=j[b+16>>2];h[d+40|0]=k[b+20|0];h[d+41|0]=k[d+41|0]&253|k[b+21|0]<<1}b=b+24|0;if((b|0)!=80360){continue}break}Za=c- -64|0;return a|0}b=D()|0;C()|0;break c}b=D()|0;C()|0;break d}b=D()|0;C()|0;break e}b=D()|0;C()|0;break f}b=D()|0;C()|0;qb(c+16|0)}gb(e)}qb(c+48|0)}gb(f)}Fb(d);break a}b=D()|0;C()|0;break a}b=D()|0;C()|0}kw(l);G(b|0);z()}function zX(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,l=0,m=0,n=0;if(Qf(a,j[b+8>>2],e)){vu(b,c,d);return}a:{if(Qf(a,j[b>>2],e)){if(!(j[b+20>>2]!=(c|0)?j[b+16>>2]!=(c|0):0)){if((d|0)!=1){break a}j[b+32>>2]=1;return}j[b+32>>2]=d;if(j[b+44>>2]!=4){f=a+16|0;m=f+(j[a+12>>2]<<3)|0;n=b;b:{c:{while(1){d:{if(f>>>0>=m>>>0){break d}i[b+52>>1]=0;uu(f,b,c,c,1,e);if(k[b+54|0]){break d}e:{if(!k[b+53|0]){break e}if(k[b+52|0]){d=1;if(j[b+24>>2]==1){break c}l=1;g=1;if(k[a+8|0]&2){break e}break c}l=1;d=g;if(!(h[a+8|0]&1)){break c}}f=f+8|0;continue}break}d=g;a=4;if(!l){break b}}a=3}j[n+44>>2]=a;if(d&1){break a}}j[b+20>>2]=c;j[b+40>>2]=j[b+40>>2]+1;if(j[b+36>>2]!=1|j[b+24>>2]!=2){break a}h[b+54|0]=1;return}g=j[a+12>>2];f=a+16|0;jq(f,b,c,d,e);if((g|0)<2){break a}g=f+(g<<3)|0;f=a+24|0;a=j[a+8>>2];if(!(j[b+36>>2]!=1?!(a&2):0)){while(1){if(k[b+54|0]){break a}jq(f,b,c,d,e);f=f+8|0;if(g>>>0>f>>>0){continue}break}break a}if(!(a&1)){while(1){if(k[b+54|0]|j[b+36>>2]==1){break a}jq(f,b,c,d,e);f=f+8|0;if(g>>>0>f>>>0){continue}break a}}while(1){if(k[b+54|0]|(j[b+24>>2]==1?j[b+36>>2]==1:0)){break a}jq(f,b,c,d,e);f=f+8|0;if(g>>>0>f>>>0){continue}break}}}function vua(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,k=0,l=0,m=0,n=0,o=0,q=0;e=Za-48|0;Za=e;n=j[a+16>>2];f=vf(e+16|0);j[f+8>>2]=a+112;j[f+16>>2]=j[a+128>>2];o=f,q=qf(b+327720|0,j[b+20>>2],(j[a+88>>2]&16384)>>>14|0),j[o+12>>2]=q;b=j[f+16>>2];if(b){o=f,q=uf(a+8|0,b),j[o>>2]=q;j[f+4>>2]=ab}l=j[a+40>>2];m=j[a+36>>2];g=j[a+4>>2];h=j[a>>2];j[e+8>>2]=h;j[e+12>>2]=g;b=j[a+12>>2];j[e>>2]=j[a+8>>2];j[e+4>>2]=b;a:{if(!d){b=l>>12;k=m>>12;break a}while(1){b=0;k=b;j[e+40>>2]=h;j[e+44>>2]=b;g=(g<<1)+n|0;b:{b=j[f+16>>2];if((b|0)<=0){break b}while(1){id(j[f+8>>2],i[(k<<1)+g>>1]/4<<16>>16);hd(j[f+8>>2],4);Bb(e+40|0,f);if((b|0)<2){break b}b=b-1|0;k=j[e+44>>2];continue}}d=d-1|0;b=j[f+8>>2];Bb(b,b+8|0);b=j[f+8>>2];h=j[b+4>>2];if(h){id(b,i[g+(j[e+44>>2]<<1)>>1]/4<<16>>16);hd(j[f+8>>2],h);b=j[f+8>>2];h=j[b>>2];j[b>>2]=h;j[b+4>>2]=0}g=pf(b,j[f+12>>2]);b=j[a+32>>2];m=j[a+28>>2]+m|0;k=m>>12;j[c>>2]=j[c>>2]+p(g,k);l=b+l|0;b=l>>12;j[c+4>>2]=j[c+4>>2]+p(g,b);Bb(e+8|0,e);if(d){c=c+8|0;h=j[e+8>>2];g=j[e+12>>2];continue}break}h=j[e+8>>2];g=j[e+12>>2]}j[a+40>>2]=l;j[a+20>>2]=k;j[a+36>>2]=m;j[a+24>>2]=b;j[a>>2]=h;j[a+4>>2]=g;Za=e+48|0}function kga(a,b,c){var d=0,e=0,f=0,g=0,h=0,i=0,l=0,m=0,n=0;d=Za-80|0;Za=d;f=Db(d+48|0,NJ(b));j[114630]=0;F(1598,d- -64|0,f|0);e=j[114630];j[114630]=0;a:{b:{c:{if((e|0)!=1){gb(f);m=d,n=Lb(a),j[m+40>>2]=n;m=d,n=Mb(a),j[m+32>>2]=n;if(!rb(d+40|0,d+32|0)){a=0;break a}i=b+20|0;l=b+16|0;f=0;while(1){a=0;g=j[d+40>>2];e=l;if(j[j[g>>2]+32>>2]==(k[e|0]|k[e+1|0]<<8|(k[e+2|0]<<16|k[e+3|0]<<24))){a=i;a=j[j[g>>2]+36>>2]==(k[a|0]|k[a+1|0]<<8|(k[a+2|0]<<16|k[a+3|0]<<24))}e=j[g>>2];j[114630]=0;F(1748,d|0,e+8|0);e=j[114630];j[114630]=0;d:{e:{f:{g:{if((e|0)!=1){j[114630]=0;F(1598,d+16|0,d|0);e=j[114630];j[114630]=0;if((e|0)==1){break g}e=Ze(d+16|0,d- -64|0);gb(d+16|0);gb(d);if((a&e)!=1){break e}f=j[g>>2];h=3;break d}a=D()|0;C()|0;break f}a=D()|0;C()|0;gb(d)}f=d- -64|0;break b}if(!(a^1|(h|0)>1)){f=j[g>>2];h=2;break d}a=e&(h|0)<1;f=a?j[g>>2]:f;h=a?1:h}Id(d+40|0);if(rb(d+40|0,d+32|0)){continue}break}break c}a=D()|0;C()|0;break b}a=0;if(!f){break a}e=j[f+4>>2];if(!e){break a}j[114630]=0;a=K(e|0,f|0,c|0,b|0)|0;b=j[114630];j[114630]=0;if((b|0)!=1){a=(a|0)!=0;break a}a=D()|0;f=d- -64|0;C()|0}gb(f);G(a|0);z()}gb(d- -64|0);Za=d+80|0;return a}function Zga(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,l=0,m=0,p=0,s=0;h=Za-16|0;Za=h;if(!k[a+4242|0]){pw(a);a:{if(!k[a+4240|0]){break a}e=LJ(j[a+16>>2]);if(e==o[a+4288>>3]){break a}o[a+4288>>3]=e;ur(a)}g=a+4256|0;b:{if(k[a+4244|0]){if(!(o[g>>3]<=1)){o[g>>3]=1}break b}i=(j[a+4232>>2]&-2)!=4;e=o[g>>3];c:{if(r(e)<2147483648){f=~~e;break c}f=-2147483648}if(!(i|(f|0)<1)){nw(a);e=o[a+4256>>3]}o[g>>3]=e- +(f|0)}e=0;d:{e:{switch(j[a+4232>>2]){case 0:e=Kh(o[a+4256>>3]*6.283185307179586);break d;case 1:e=r(o[a+4256>>3]+ -.5)*-4+1;break d;case 2:e=o[a+4256>>3];e=e+e+ -1;break d;case 3:e=o[a+4256>>3]<.5?-1:1;break d;case 4:e=o[a+4272>>3];break d;case 5:break e;default:break d}}e=o[a+4256>>3];l=e*e*e*((e*6+ -15)*e+10);e=o[a+4272>>3];e=l*(o[a+4280>>3]-e)+e}o[h+8>>3]=(k[a+4241|0]?-e:e)*+n[a+4220>>2]+ +n[a+4224>>2];wf(h+8|0,0,1);f=Mi(a);f:{if(!f){break f}g=j[a+4236>>2];if(k[a+4243|0]){p=f,s=g>>>8&15|176|(g&127)<<8|Js(o[h+8>>3]*127)<<16,m=j[j[f>>2]+68>>2],bb[m](p|0,s|0)|0;break f}bb[j[j[f>>2]+44>>2]](f,g,q(o[h+8>>3]))}o[a+4256>>3]=o[a+4256>>3]+o[a+4264>>3]*+(d>>>0)}f=a;a=a+44|0;Sh(f,b,c,wd(a,0),wd(a,1),d);Za=h+16|0}function Uza(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;d=Za+ -64|0;Za=d;t=d,u=ef(a)>>>5|0,i[t+32>>1]=u;i[d+16>>1]=3999;t=c,u=l[gf(d+32|0,d+16|0)>>1],i[t+480190>>1]=u;jy(b,l[c+480190>>1],0);a:{if(l[c+480190>>1]){h=d+62|0;p=d+58|0;q=d+56|0;s=d+52|0;r=d+60|0;n=1;o=1;while(1){f=Yo(c,o&65535);Bs(a,d+32|0);md(f,0);jn(d,2,d+32|0);qc(d+16|0,d);j[114630]=0;E(369,((n<<5)+c|0)+946300|0,d+16|0)|0;e=j[114630];j[114630]=0;if((e|0)==1){break a}gb(d+16|0);i[f+32>>1]=64;j[f+24>>2]=8287;e=k[r|0]|k[r+1|0]<<8;i[d+16>>1]=e<<8|e>>>8;i[d>>1]=64;t=f,u=l[gf(d+16|0,d)>>1]<<2,i[t+30>>1]=u;e=s;e=(k[e|0]|k[e+1|0]<<8|(k[e+2|0]<<16|k[e+3|0]<<24))&-16777217;j[f>>2]=e<<24|e<<8&16711680|(e>>>8&65280|e>>>24);e=k[q|0]|k[q+1|0]<<8;g=k[p|0]|k[p+1|0]<<8;g=(g<<8|g>>>8)&65535;b:{if(g>>>0<2){break b}e=(e<<8|e>>>8)&65535;g=e+g<<1;if(g>>>0>m[f>>2]){break b}j[f+16>>2]=g;j[f+12>>2]=e<<1;i[f+34>>1]=l[f+34>>1]|8}if(k[h|0]|k[h+1|0]<<8){e=(k[h|0]|k[h+1|0]<<8)==512}else{e=1}Nd(d+16|0,b,n-1|0);Qd(d+16|0,e);o=o+1|0;n=o&65535;if(n>>>0<=l[c+480190>>1]){continue}break}}Za=d- -64|0;return}a=D()|0;C()|0;gb(d+16|0);G(a|0);z()}function J9(a,b){a=a|0;b=+b;var c=0,d=0,e=0,f=0,g=0,h=0,m=0;d=Za-80|0;Za=d;a:{b:{c:{d:{e:{f:{g:{if(Ph(a)){go(d+72|0);break g}qm(d+32|0,a);j[114630]=0;F(2169,d+72|0,d+32|0);c=j[114630];j[114630]=0;if((c|0)==1){break f}Ye(d+32|0)}c=a+36|0;h:{if(Ph(a)){break h}c=j[d+72>>2]}e=j[a+8>>2];if((e|0)!=-1){break c}e=jt(c);if(pd(c)){break e}break d}f=D()|0;C()|0;Ye(d+32|0);break a}while(1){if(!(o[zc(c,f)>>3]+g<=b)){e=zc(c,f);break d}g=o[e>>3]+g;f=f+1|0;if(pd(c)>>>0>f>>>0){continue}break}}b=b-g;break b}e=zc(c,e)}f=a+24|0;c=j[f>>2];h=l[e+12>>1];j[114630]=0;F(2172,c|0,h|0);c=j[114630];j[114630]=0;if((c|0)!=1){i:{h=j[f>>2];m=k[a+64|0];c=vG(IO(d+32|0,b),k[e+16|0],l[e+12>>1],j[e+8>>2]);j[114630]=0;e=j[c+12>>2];j[d+16>>2]=j[c+8>>2];j[d+20>>2]=e;e=j[c+20>>2];j[d+24>>2]=j[c+16>>2];j[d+28>>2]=e;e=j[c+4>>2];j[d+8>>2]=j[c>>2];j[d+12>>2]=e;L(2123,d+56|0,h|0,(m?7:1)|0,d+8|0);c=j[114630];j[114630]=0;if((c|0)==1){break i}c=zg(d+56|0);b=o[c>>3];e=j[c+8>>2];c=l[c+20>>1];ll(d+56|0);i[j[f>>2]+1074438>>1]=c;i[j[f>>2]+1074440>>1]=c;j[j[f>>2]+1074428>>2]=e;b=b+g;o[a+16>>3]=b;Gj(d+72|0);Za=d+80|0;return+b}}f=D()|0;C()|0;Gj(d+72|0)}G(f|0);z()}function _5(a,b,c,d,e,f){var g=0,i=0,j=0,m=0,o=0,r=0,s=0,t=0,u=0,v=q(0),w=0,x=q(0);j=Za-48|0;Za=j;o=!k[d+13|0]+(k[d+14|0]!=0)|0;r=k[d+25|0];s=j;t=b;u=j+44|0;a:{if(k[a+1|0]&8){f=k[d+27|0];g=k[l[d+8>>1]+43520|0];i=g&3;h[j+47|0]=i;h[j+46|0]=i;i=g>>>2|0;h[j+45|0]=i;h[j+44|0]=i;b=p(o,28)+43424|0;break a}f=(k[a+3|0]&16)>>>4&(f|0)!=0;b=f?12:0;g=l[d+8>>1]>>>f|0;while(1){m=1;f=3;while(1){i=f;f=k[(f+b|0)+43536|0];h[i+(j+44|0)|0]=((g|0)/(m|0)|0)%(f|0);m=p(f,m);f=i-1|0;if(i){continue}break}b=b+4|0;g=g-m|0;if((g|0)>-1){continue}break}f=-16;b=(p(o,28)+43424|0)+b|0}P5(s,t,u,b,c,f);i=k[d+14|0];b:{if(i){b=2-r|0;o=k[d+23|0]<<b;f=k[d+22|0]<<b;c=k[d+21|0]<<b;b=k[d+13|0];m=0;while(1){g=(b+m|0)+j|0;h[g|0]=c+k[g|0];h[g+1|0]=f+k[g+1|0];h[g+2|0]=o+k[g+2|0];m=m+3|0;if(i>>>0>m>>>0){continue}break}break b}if(!k[d+24|0]){break b}f=0;while(1){b=f+j|0;h[b+11|0]=k[b+11|0]+k[f+43560|0];f=f+1|0;if((f|0)!=10){continue}break}}v=Gv(q(2048),((((k[a+3|0]&224)==96)<<1)-k[d+10|0]|0)+258|0);f=0;if((i|0)!=(0-k[d+13|0]|0)){a=r+1|0;while(1){w=(f<<2)+e|0,x=Gv(v,k[f+j|0]<<a),n[w>>2]=x;f=f+1|0;if(f>>>0<k[d+14|0]+k[d+13|0]>>>0){continue}break}}Za=j+48|0}function yua(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,i=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0;e=Za-48|0;Za=e;l=j[a+16>>2];f=vf(e+16|0);j[f+8>>2]=a+112;j[f+16>>2]=j[a+128>>2];q=f,r=qf(b+327720|0,j[b+20>>2],(j[a+88>>2]&16384)>>>14|0),j[q+12>>2]=r;b=j[f+16>>2];if(b){q=f,r=uf(a+8|0,b),j[q>>2]=r;j[f+4>>2]=ab}m=j[a+24>>2];n=j[a+20>>2];b=j[a+4>>2];g=j[a>>2];j[e+8>>2]=g;j[e+12>>2]=b;i=j[a+12>>2];j[e>>2]=j[a+8>>2];j[e+4>>2]=i;if(d){while(1){i=0;k=g;j[e+40>>2]=g;j[e+44>>2]=o;g=(((b&2147483647)<<1|g>>>31)&-2)+l|0;a:{b=j[f+16>>2];if((b|0)<=0){break a}while(1){i=(i&2147483647)<<1|k>>>31;id(j[f+8>>2],h[(i|1)+g|0]+h[g+(i&-2)|0]<<5);hd(j[f+8>>2],4);Bb(e+40|0,f);if((b|0)<2){break a}b=b-1|0;k=j[e+40>>2];i=j[e+44>>2];continue}}d=d-1|0;b=j[f+8>>2];Bb(b,b+8|0);b=j[f+8>>2];i=j[b+4>>2];if(i){k=b;b=(j[e+44>>2]&2147483647)<<1|j[e+40>>2]>>>31;id(k,h[(b|1)+g|0]+h[g+(b&-2)|0]<<5);hd(j[f+8>>2],i);b=j[f+8>>2];i=j[b>>2];j[b>>2]=i;j[b+4>>2]=0}b=pf(b,j[f+12>>2]);j[c>>2]=j[c>>2]+p(b,n);j[c+4>>2]=j[c+4>>2]+p(b,m);Bb(e+8|0,e);if(d){c=c+8|0;g=j[e+8>>2];b=j[e+12>>2];continue}break}g=j[e+8>>2];b=j[e+12>>2]}j[a>>2]=g;j[a+4>>2]=b;Za=e+48|0}function Cva(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,i=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;g=Za-16|0;Za=g;f=j[a+48>>2];n=j[a+40>>2];o=j[a+36>>2];e=j[a+44>>2];s=j[a+16>>2];l=j[a+4>>2];k=j[a>>2];j[g+8>>2]=k;j[g+12>>2]=l;b=j[a+12>>2];j[g>>2]=j[a+8>>2];j[g+4>>2]=b;a:{if(!d){i=n>>12;q=o>>12;break a}while(1){b=l+s|0;q=h[b+1|0];i=h[b|0];b=j[a+60>>2];t=b;u=b>>31;b=e;e=Gb(e,-16777216,16776704);m=j[a+64>>2];f=Gb(f,-16777216,16776704);v=j[a+72>>2];w=j[a+32>>2];l=c;x=j[c>>2];e=HMa(m,m>>31,e,e>>31);m=ab;y=e;e=j[a+68>>2];r=HMa(e,e>>31,f,f>>31);e=y+r|0;f=ab+m|0;f=e>>>0<r>>>0?f+1|0:f;m=e;k=((p(q-i|0,k>>>10&4194048)|0)/16384|0)+(i<<8)<<8;e=k;i=HMa(t,u,e,e>>31);e=m+i|0;f=ab+f|0;f=e>>>0<i>>>0?f+1|0:f;e=e+8388608|0;if(e>>>0<8388608){f=f+1|0}e=(f&16777215)<<8|e>>>24;f=(e|0)/256|0;o=j[a+28>>2]+o|0;q=o>>12;j[l>>2]=p(f,q)+x;n=n+w|0;i=n>>12;j[c+4>>2]=j[c+4>>2]+p(f,i);e=e-(k&v)|0;Bb(g+8|0,g);d=d-1|0;if(d){c=c+8|0;k=j[g+8>>2];l=j[g+12>>2];f=b;continue}break}k=j[g+8>>2];l=j[g+12>>2];f=b}j[a+40>>2]=n;j[a+20>>2]=q;j[a+36>>2]=o;j[a+48>>2]=f;j[a+44>>2]=e;j[a+24>>2]=i;j[a>>2]=k;j[a+4>>2]=l;Za=g+16|0}function Gpa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,l=0,m=0,n=0,p=0,q=0,s=0;f=Za-16|0;Za=f;j[f+8>>2]=c>>>4;j[f+4>>2]=j[a>>2];d=j[tb(f+8|0,f+4|0)>>2];b=lb(b);if(d){a=j[a+20>>2];c=d;while(1){e=b;g=k[e+4|0]|k[e+5|0]<<8|(k[e+6|0]<<16|k[e+7|0]<<24);h=k[e|0]|k[e+1|0]<<8|(k[e+2|0]<<16|k[e+3|0]<<24);e=g;m=h<<8&16711680|h<<24;n=e<<24|h>>>8;g=e<<8|h>>>24;m=n&65280|g&255|m;j[f+8>>2]=((e&255)<<24|h>>>8)&-16777216|((e&16777215)<<8|h>>>24)&16711680|(e>>>8&65280|e>>>24)|p;j[f+12>>2]=m;wf(f+8|0,-1,1);l=o[f+8>>3]*32768;o[f+8>>3]=l;e=a;l=zd(l);a:{if(r(l)<2147483648){g=~~l;break a}g=-2147483648}q=e,s=Dc(g),i[q>>1]=s;e=b;g=k[e+12|0]|k[e+13|0]<<8|(k[e+14|0]<<16|k[e+15|0]<<24);h=k[e+8|0]|k[e+9|0]<<8|(k[e+10|0]<<16|k[e+11|0]<<24);e=g;m=h<<8&16711680|h<<24;n=e<<24|h>>>8;g=e<<8|h>>>24;m=n&65280|g&255|m;j[f+8>>2]=((e&255)<<24|h>>>8)&-16777216|((e&16777215)<<8|h>>>24)&16711680|(e>>>8&65280|e>>>24)|p;j[f+12>>2]=m;wf(f+8|0,-1,1);l=o[f+8>>3]*32768;o[f+8>>3]=l;e=a;l=zd(l);b:{if(r(l)<2147483648){g=~~l;break b}g=-2147483648}q=e,s=Dc(g),i[q+2>>1]=s;a=a+4|0;b=b+16|0;c=c-1|0;if(c){continue}break}}Za=f+16|0;return d<<4}function ko(a){a=a|0;var b=0,c=0,d=0,e=0,f=q(0),g=0,h=q(0),k=0,o=0,r=0,s=q(0);c=j[a+36>>2];if(!c){Wh(a+16|0);return}a:{b:{c:{switch(l[a>>1]){case 3:d=a+16|0;if(c>>>0>=1001){Wh(d);return}Wk(d,c);c=l[a+28>>1];b=a+4|0;sb(b);f=Xk(a,(c<<16)+65536>>16);c=i[a+28>>1];sb(b);b=1;f=Yd(q(f/Xk(a,c)),q(q(1)/q(j[a+36>>2]+1>>>0)));if(!j[a+36>>2]){break b}while(1){h=Yd(f,q(b>>>0));r=xb(d,b-1|0),s=h,n[r>>2]=s;b=b+1|0;if(b>>>0<=m[a+36>>2]){continue}break}break b;case 1:d=a+16|0;g=l[a+30>>1];if(g>>>0>1e3/(c>>>0)>>>0){Wh(d);return}Wk(d,p(c,g));c=i[a+28>>1];sb(a+4|0);b=l[a+30>>1];if((c|0)>=0){c=(c|0)%(b|0)|0}else{c=((c^-1)%(b|0)^-1)+b|0}if(!g){break b}while(1){b=b&65535;e=c+k<<16>>16;d:{if((e|0)>=0){b=(e|0)%(b|0)|0;break d}b=b+((e^-1)%(b|0)^-1)|0}e=1;b=b<<16;o=b>>16;f=Yd(q(Xk(a,b+65536>>16)/Xk(a,o)),q(q(1)/q(j[a+36>>2]+1>>>0)));b=1;if(j[a+36>>2]){while(1){h=Yd(f,q((b&65535)>>>0));r=xb(d,(p(j[a+36>>2],o)+e|0)-1|0),s=h,n[r>>2]=s;b=b+1|0;e=b&65535;if(e>>>0<=m[a+36>>2]){continue}break}}k=k+1|0;if(g>>>0<=(k&65535)>>>0){break b}b=l[a+30>>1];continue};case 0:break a;default:break c}}Wh(a+16|0);j[a+36>>2]=0}return}Wh(a+16|0)}function Bva(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;g=Za-16|0;Za=g;f=j[a+48>>2];n=j[a+40>>2];o=j[a+36>>2];e=j[a+44>>2];s=j[a+16>>2];l=j[a+4>>2];k=j[a>>2];j[g+8>>2]=k;j[g+12>>2]=l;b=j[a+12>>2];j[g>>2]=j[a+8>>2];j[g+4>>2]=b;a:{if(!d){h=n>>12;q=o>>12;break a}while(1){b=(l<<1)+s|0;q=i[b+2>>1];h=i[b>>1];b=j[a+60>>2];t=b;u=b>>31;b=e;e=Gb(e,-16777216,16776704);m=j[a+64>>2];f=Gb(f,-16777216,16776704);v=j[a+72>>2];w=j[a+32>>2];l=c;x=j[c>>2];e=HMa(m,m>>31,e,e>>31);m=ab;y=e;e=j[a+68>>2];r=HMa(e,e>>31,f,f>>31);e=y+r|0;f=ab+m|0;f=e>>>0<r>>>0?f+1|0:f;m=e;k=h+((p(q-h|0,k>>>18|0)|0)/16384|0)<<8;e=k;h=HMa(t,u,e,e>>31);e=m+h|0;f=ab+f|0;f=e>>>0<h>>>0?f+1|0:f;e=e+8388608|0;if(e>>>0<8388608){f=f+1|0}e=(f&16777215)<<8|e>>>24;f=(e|0)/256|0;o=j[a+28>>2]+o|0;q=o>>12;j[l>>2]=p(f,q)+x;n=n+w|0;h=n>>12;j[c+4>>2]=j[c+4>>2]+p(f,h);e=e-(k&v)|0;Bb(g+8|0,g);d=d-1|0;if(d){c=c+8|0;k=j[g+8>>2];l=j[g+12>>2];f=b;continue}break}k=j[g+8>>2];l=j[g+12>>2];f=b}j[a+40>>2]=n;j[a+20>>2]=q;j[a+36>>2]=o;j[a+48>>2]=f;j[a+44>>2]=e;j[a+24>>2]=h;j[a>>2]=k;j[a+4>>2]=l;Za=g+16|0}function Vb(a,b,c){var d=0,e=0,f=0;if(c>>>0>=512){Da(a|0,b|0,c|0)|0;return a}e=a+c|0;a:{if(!((a^b)&3)){b:{if((c|0)<1){c=a;break b}if(!(a&3)){c=a;break b}c=a;while(1){h[c|0]=k[b|0];b=b+1|0;c=c+1|0;if(e>>>0<=c>>>0){break b}if(c&3){continue}break}}d=e&-4;c:{if(d>>>0<64){break c}f=d+ -64|0;if(f>>>0<c>>>0){break c}while(1){j[c>>2]=j[b>>2];j[c+4>>2]=j[b+4>>2];j[c+8>>2]=j[b+8>>2];j[c+12>>2]=j[b+12>>2];j[c+16>>2]=j[b+16>>2];j[c+20>>2]=j[b+20>>2];j[c+24>>2]=j[b+24>>2];j[c+28>>2]=j[b+28>>2];j[c+32>>2]=j[b+32>>2];j[c+36>>2]=j[b+36>>2];j[c+40>>2]=j[b+40>>2];j[c+44>>2]=j[b+44>>2];j[c+48>>2]=j[b+48>>2];j[c+52>>2]=j[b+52>>2];j[c+56>>2]=j[b+56>>2];j[c+60>>2]=j[b+60>>2];b=b- -64|0;c=c- -64|0;if(f>>>0>=c>>>0){continue}break}}if(c>>>0>=d>>>0){break a}while(1){j[c>>2]=j[b>>2];b=b+4|0;c=c+4|0;if(d>>>0>c>>>0){continue}break}break a}if(e>>>0<4){c=a;break a}d=e-4|0;if(d>>>0<a>>>0){c=a;break a}c=a;while(1){h[c|0]=k[b|0];h[c+1|0]=k[b+1|0];h[c+2|0]=k[b+2|0];h[c+3|0]=k[b+3|0];b=b+4|0;c=c+4|0;if(d>>>0>=c>>>0){continue}break}}if(c>>>0<e>>>0){while(1){h[c|0]=k[b|0];b=b+1|0;c=c+1|0;if((e|0)!=(c|0)){continue}break}}return a}function wua(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,i=0,k=0,l=0,m=0,n=0,o=0,q=0;e=Za-48|0;Za=e;n=j[a+16>>2];f=vf(e+16|0);j[f+8>>2]=a+112;j[f+16>>2]=j[a+128>>2];o=f,q=qf(b+327720|0,j[b+20>>2],(j[a+88>>2]&16384)>>>14|0),j[o+12>>2]=q;b=j[f+16>>2];if(b){o=f,q=uf(a+8|0,b),j[o>>2]=q;j[f+4>>2]=ab}l=j[a+40>>2];m=j[a+36>>2];g=j[a+4>>2];i=j[a>>2];j[e+8>>2]=i;j[e+12>>2]=g;b=j[a+12>>2];j[e>>2]=j[a+8>>2];j[e+4>>2]=b;a:{if(!d){b=l>>12;k=m>>12;break a}while(1){b=0;k=b;j[e+40>>2]=i;j[e+44>>2]=b;g=g+n|0;b:{b=j[f+16>>2];if((b|0)<=0){break b}while(1){id(j[f+8>>2],h[g+k|0]<<6);hd(j[f+8>>2],4);Bb(e+40|0,f);if((b|0)<2){break b}b=b-1|0;k=j[e+44>>2];continue}}d=d-1|0;b=j[f+8>>2];Bb(b,b+8|0);b=j[f+8>>2];i=j[b+4>>2];if(i){id(b,h[g+j[e+44>>2]|0]<<6);hd(j[f+8>>2],i);b=j[f+8>>2];i=j[b>>2];j[b>>2]=i;j[b+4>>2]=0}g=pf(b,j[f+12>>2]);b=j[a+32>>2];m=j[a+28>>2]+m|0;k=m>>12;j[c>>2]=j[c>>2]+p(g,k);l=b+l|0;b=l>>12;j[c+4>>2]=j[c+4>>2]+p(g,b);Bb(e+8|0,e);if(d){c=c+8|0;i=j[e+8>>2];g=j[e+12>>2];continue}break}i=j[e+8>>2];g=j[e+12>>2]}j[a+40>>2]=l;j[a+20>>2]=k;j[a+36>>2]=m;j[a+24>>2]=b;j[a>>2]=i;j[a+4>>2]=g;Za=e+48|0}function Jfa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=q(0),g=q(0),h=0,i=0,k=0,l=0,m=0,o=0,p=0,s=0,t=0,v=q(0),w=0,x=0,y=0,z=q(0);a:{if(!j[a+4272>>2]){break a}h=a+44|0;if(!Xg(h)){break a}l=wd(h,0);m=wd(h,1);o=Rc(h,0);p=Rc(h,1);if(d){k=a+4256|0;e=j[a+4268>>2];s=d;while(1){f=n[m>>2];g=n[l>>2];y=xb(k,e<<1),z=g,n[y>>2]=z;y=xb(k,j[a+4268>>2]<<1|1),z=f,n[y>>2]=z;f=q(r(hH(q(q(q(r(g))+q(r(f)))*q(536870912)),31,5)));g=n[a+4276>>2];f=q(f*q(4.656612873077393e-10));f=q(q(q(g-f)*n[(f<g?4240:4236)+a>>2])+f);n[a+4276>>2]=f;t=o;v=q(n[a+4232>>2]*q(4.656612873077393e-10));g=n[a+4244>>2];f=q(q(q(n[a+4248>>2]*q(2147483648))*q(g-q(u(f,g))))+q(2147483392));b:{if(f<q(4294967296)&f>=q(0)){i=~~f>>>0;break b}i=0}e=i<<5;w=e|-2147483648;x=e;e=i>>>26|0;f=q(v*q((e?w:x)>>>(e?32-e|0:31)>>>0));e=j[a+4272>>2];e=(((e+(j[a+4252>>2]+(j[a+4268>>2]<<12)|0)|0)-1|0)/4096|0)%(e|0)<<1;y=t,z=q(f*n[xb(k,e)>>2]),n[y>>2]=z;y=p,z=q(f*n[xb(k,e|1)>>2]),n[y>>2]=z;i=j[a+4268>>2];e=i-1|0;j[a+4268>>2]=e;if(!i){e=j[a+4272>>2]+e|0;j[a+4268>>2]=e}p=p+4|0;o=o+4|0;m=m+4|0;l=l+4|0;s=s-1|0;if(s){continue}break}}Sh(a,b,c,Rc(h,0),Rc(h,1),d)}}function Lk(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0;f=Za-16|0;Za=f;j[a+4>>2]=0;if(k[Ki(f+8|0,a,1)|0]){a:{b:{c:{if((b|0)==2147483647){while(1){b=j[j[a>>2]-12>>2];j[114630]=0;b=j[(a+b|0)+24>>2];d=j[114630];j[114630]=0;if((d|0)==1){break c}j[114630]=0;b=H(2378,b|0)|0;d=j[114630];j[114630]=0;if((d|0)==1){break c}if(ce(b,-1)){break b}j[a+4>>2]=j[a+4>>2]+1;if(!ce(b,c)){continue}break}d=0;break a}while(1){if(j[a+4>>2]>=(b|0)){break a}e=j[j[a>>2]-12>>2];j[114630]=0;e=j[(a+e|0)+24>>2];g=j[114630];j[114630]=0;d:{if((g|0)==1){break d}j[114630]=0;e=H(2378,e|0)|0;g=j[114630];j[114630]=0;if((g|0)==1){break d}if(ce(e,-1)){break b}j[a+4>>2]=j[a+4>>2]+1;if(!ce(e,c)){continue}break a}break}}b=J(0)|0;C()|0;O(b|0)|0;Ii(j[j[a>>2]-12>>2]+a|0,1);b=j[j[a>>2]-12>>2];j[114630]=0;b=j[(a+b|0)+20>>2];c=j[114630];j[114630]=0;e:{f:{g:{if((c|0)!=1){if(!(b&1)){break g}j[114630]=0;M(81);a=j[114630];j[114630]=0;if((a|0)!=1){break e}}a=D()|0;C()|0;j[114630]=0;M(20);b=j[114630];j[114630]=0;if((b|0)==1){break f}G(a|0);z()}Q();d=1;break a}J(0)|0;C()|0;ib()}z()}d=2}eg(j[j[a>>2]-12>>2]+a|0,d)}Za=f+16|0;return a|0}function r5(a,b,c){var d=0,e=0,f=0,g=0,i=0,l=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;a:{if(k[a+23|0]){d=j[a+2092>>2];if((d|0)<1){break a}while(1){f=e<<2;s=f+j[a+2084>>2]|0,t=Pk(j[f+j[a+32>>2]>>2]),j[s>>2]=t;e=e+1|0;d=j[a+2092>>2];if((e|0)<(d|0)){continue}break}break a}if(j[a+4>>2]>=1){while(1){if(HE(a,k[b+e|0])){s=j[a+2084>>2]+(d<<2)|0,t=Pk(j[j[a+32>>2]+(e<<2)>>2]),j[s>>2]=t;d=d+1|0}e=e+1|0;if((e|0)<j[a+4>>2]){continue}break}}if(j[a+2092>>2]==(d|0)){break a}Y(52129,50512,1185,52152);z()}uE(j[a+2084>>2],d,2296);j[j[a+2084>>2]+(j[a+2092>>2]<<2)>>2]=-1;b:{c:{d=k[a+23|0];l=j[(d?2092:4)+a>>2];if((l|0)<1){break c}f=0;while(1){e=f;g=a;if(d&255){e=j[(f<<2)+c>>2]}n=k[b+e|0];d:{if(!HE(g,n)){break d}o=f<<2;g=Pk(j[o+j[a+32>>2]>>2]);p=j[a+2084>>2];e=0;d=j[a+2092>>2];if((d|0)>=2){while(1){i=d>>>1|0;q=i+e|0;r=m[(q<<2)+p>>2]>g>>>0;e=r?e:q;d=r?i:d-i|0;if((d|0)>1){continue}break}}d=g;g=e<<2;if((d|0)!=j[g+p>>2]){break b}if(k[a+23|0]){j[g+j[a+2088>>2]>>2]=j[c+o>>2];h[j[a+8>>2]+e|0]=n;break d}j[g+j[a+2088>>2]>>2]=f}f=f+1|0;if((l|0)==(f|0)){break c}d=k[a+23|0];continue}}return}Y(52175,50512,1215,52152);z()}function ava(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,k=0,l=0,m=0,n=0,o=0;g=Za-16|0;Za=g;a:{b:{c:{h=j[a+8>>2];f=j[a+12>>2];d:{if((f|0)<1?1:(f|0)<=1?h>>>0<=805306368:0){if((f|0)>-2?1:(f|0)>=-2?h>>>0>=3489660928:0){break c}if((f|0)>-2?1:(f|0)>=-2?h>>>0>2147483647:0){break d}break b}if((f|0)>1?1:(f|0)>=1?h>>>0>2147483648:0){break b}}n=b+196648|0;break a}n=b+131112|0;break a}n=b+262184|0}o=j[a+16>>2];k=j[a+40>>2];l=j[a+36>>2];e=j[a+4>>2];m=j[a>>2];j[g+8>>2]=m;j[g+12>>2]=e;j[g>>2]=h;j[g+4>>2]=f;e:{if(!d){b=k>>12;f=l>>12;break e}while(1){h=j[a+32>>2];l=j[a+28>>2]+l|0;f=l>>12;b=(e<<1)+o|0;e=(m>>>16&65520)+n|0;e=(((((((p(i[b-4>>1],i[e+2>>1])+p(i[b-6>>1],i[e>>1])|0)+p(i[b-2>>1],i[e+4>>1])|0)+p(i[b>>1],i[e+6>>1])|0)+p(i[b+2>>1],i[e+8>>1])|0)+p(i[b+4>>1],i[e+10>>1])|0)+p(i[b+6>>1],i[e+12>>1])|0)+p(i[b+8>>1],i[e+14>>1])|0)/32768|0;j[c>>2]=j[c>>2]+p(f,e);k=h+k|0;b=k>>12;j[c+4>>2]=j[c+4>>2]+p(e,b);Bb(g+8|0,g);d=d-1|0;if(d){c=c+8|0;m=j[g+8>>2];e=j[g+12>>2];continue}break}m=j[g+8>>2];e=j[g+12>>2]}j[a+40>>2]=k;j[a+20>>2]=f;j[a+36>>2]=l;j[a+24>>2]=b;j[a>>2]=m;j[a+4>>2]=e;Za=g+16|0}function Jua(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;f=Za-32|0;Za=f;m=j[a+40>>2];n=j[a+36>>2];o=j[a+16>>2];e=j[a+4>>2];g=e;h=j[a>>2];j[f+24>>2]=h;j[f+28>>2]=e;e=j[a+12>>2];j[f+16>>2]=j[a+8>>2];j[f+20>>2]=e;a:{if(!d){e=m>>12;l=n>>12;break a}while(1){k=((((g&2147483647)<<1|h>>>31)&2147483646)<<1)+o|0;e=(((h>>>16|0)+4&131064)<<1)+b|0;h=i[e+38>>1];q=i[e+36>>1];r=i[e+34>>1];s=i[e+32>>1];t=i[e+30>>1];u=i[e+28>>1];v=i[e+26>>1];w=i[e+24>>1];l=0;e=1;while(1){g=l<<1;j[(f+8|0)+(l<<2)>>2]=(((((p(i[(g|8)+k>>1],r)+p(i[(g|4)+k>>1],s)|0)+p(i[(g|12)+k>>1],q)|0)+p(i[(g|16)+k>>1],h)|0)/2|0)+((((p(i[(g|-8)+k>>1],v)+p(i[(g|-12)+k>>1],w)|0)+p(i[(g|-4)+k>>1],u)|0)+p(i[g+k>>1],t)|0)/2|0)|0)/16384;g=e;e=0;l=1;if(g){continue}break}e=j[a+32>>2];n=j[a+28>>2]+n|0;l=n>>12;j[c>>2]=j[c>>2]+p(l,j[f+8>>2]);m=e+m|0;e=m>>12;j[c+4>>2]=j[c+4>>2]+p(e,j[f+12>>2]);Bb(f+24|0,f+16|0);d=d-1|0;if(d){c=c+8|0;h=j[f+24>>2];g=j[f+28>>2];continue}break}h=j[f+24>>2];g=j[f+28>>2]}j[a+40>>2]=m;j[a+20>>2]=l;j[a+36>>2]=n;j[a+24>>2]=e;j[a>>2]=h;j[a+4>>2]=g;Za=f+32|0}function Gw(a,b,c){var d=0,e=0,f=0,g=0,m=0,n=0,o=0,p=0,q=0;e=Za-16|0;Za=e;d=a+2|0;if(!(k[d|0]==255|!k[d|0])){j[e+12>>2]=k[d|0]+1;j[e+8>>2]=10;Nf(b,j[Pd(e+12|0,e+8|0)>>2]);d=k[a+3|0];h[b+15|0]=d;h[b+16|0]=d;h[b+13|0]=k[a+4|0];h[b+14|0]=k[a+5|0];d=0;f=511;a:{b:{switch(c-1|0){case 1:d=4096;f=128;break a;case 0:break b;default:break a}}d=32768;f=1024}if(sb(b)){n=f>>>1|d;d=0;while(1){g=(d<<2)+a|0;c=g+6|0;c=k[c|0]|k[c+1|0]<<8;p=xb(b,d),q=c>>>4|0,i[p>>1]=q;o=b;c:{d:{if(!d){m=0;c=0;break d}c=d-1|0;if(l[xb(b,d)>>1]>=l[xb(b,c)>>1]){break c}m=d;c=l[xb(b,c)>>1]+1|0}p=xb(o,m),q=c,i[p>>1]=q}c=g+8|0;j[e+12>>2]=(((k[c|0]|k[c+1|0]<<8)<<16>>16)+n|0)/(f|0);j[e+8>>2]=0;j[e+4>>2]=64;c=j[$r(e+12|0,e+8|0,e+4|0)>>2];p=xb(b,d),q=c,h[p+2|0]=q;d=d+1|0;if(sb(b)>>>0>d>>>0){continue}break}}h[b+12|0]=k[b+12|0]&254|h[a|0]&1;c=b;e:{f:{if(!(k[a|0]&2)){break f}d=k[b+15|0];if(sb(b)>>>0<d>>>0){break f}d=k[b+12|0]|4;break e}d=k[b+12|0]&-5}h[c+12|0]=d;c=b;g:{h:{if(!(k[a|0]&4)){break h}a=k[b+13|0];if(a>>>0>k[b+14|0]){break h}if(sb(b)>>>0<a>>>0){break h}a=k[b+12|0]|2;break g}a=k[b+12|0]&-3}h[c+12|0]=a}Za=e+16|0}function CZ(a,b,c,d,e,f){var g=0,i=0,l=0,m=0,n=0,o=0;j[c>>2]=a;j[f>>2]=d;a:{b:{while(1){g=j[c>>2];if(!(g>>>0>=b>>>0|d>>>0>=e>>>0)){l=h[g|0];a=l&255;c:{if((l|0)>=0){if(a>>>0<=1114111){l=1;break c}return 2}n=2;if(a>>>0<194){break b}if(a>>>0<=223){if((b-g|0)<2){break a}i=k[g+1|0];if((i&192)!=128){break b}l=2;a=i&63|a<<6&1984;if(a>>>0<=1114111){break c}break b}if(a>>>0<=239){if((b-g|0)<3){break a}m=k[g+2|0];i=k[g+1|0];d:{e:{if((a|0)!=237){if((a|0)!=224){break e}if((i&224)==160){break d}break b}if((i&224)==128){break d}break b}if((i&192)!=128){break b}}if((m&192)!=128){break b}l=3;a=m&63|(a<<12&61440|(i&63)<<6);if(a>>>0<=1114111){break c}break b}if(a>>>0>244){break b}if((b-g|0)<4){break a}m=k[g+3|0];o=k[g+2|0];i=k[g+1|0];f:{g:{switch(a-240|0){case 0:if((i+112&255)>>>0<48){break f}break b;case 4:if((i&240)==128){break f}break b;default:break g}}if((i&192)!=128){break b}}if((o&192)!=128|(m&192)!=128){break b}l=4;a=m&63|(o<<6&4032|(a<<18&1835008|(i&63)<<12));if(a>>>0>1114111){break b}}j[d>>2]=a;j[c>>2]=g+l;d=j[f>>2]+4|0;j[f>>2]=d;continue}break}n=b>>>0>g>>>0}return n}return 1}function cva(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,k=0,l=0,m=0,n=0,o=0,q=0;f=Za-16|0;Za=f;a:{b:{c:{g=j[a+8>>2];e=j[a+12>>2];d:{if((e|0)<1?1:(e|0)<=1?g>>>0<=805306368:0){if((e|0)>-2?1:(e|0)>=-2?g>>>0>=3489660928:0){break c}if((e|0)>-2?1:(e|0)>=-2?g>>>0>2147483647:0){break d}break b}if((e|0)>1?1:(e|0)>=1?g>>>0>2147483648:0){break b}}o=b+196648|0;break a}o=b+131112|0;break a}o=b+262184|0}q=j[a+16>>2];l=j[a+40>>2];m=j[a+36>>2];b=j[a+4>>2];n=j[a>>2];j[f+8>>2]=n;j[f+12>>2]=b;j[f>>2]=g;j[f+4>>2]=e;e:{if(!d){g=l>>12;e=m>>12;break e}while(1){g=j[a+32>>2];m=j[a+28>>2]+m|0;e=m>>12;k=b+q|0;b=(n>>>16&65520)+o|0;b=(((((((p(h[k-2|0],i[b+2>>1])+p(h[k-3|0],i[b>>1])|0)+p(h[k-1|0],i[b+4>>1])|0)+p(h[k|0],i[b+6>>1])|0)+p(h[k+1|0],i[b+8>>1])|0)+p(h[k+2|0],i[b+10>>1])|0)+p(h[k+3|0],i[b+12>>1])|0)+p(h[k+4|0],i[b+14>>1])<<8)/32768|0;j[c>>2]=j[c>>2]+p(e,b);l=g+l|0;g=l>>12;j[c+4>>2]=j[c+4>>2]+p(b,g);Bb(f+8|0,f);d=d-1|0;if(d){c=c+8|0;n=j[f+8>>2];b=j[f+12>>2];continue}break}n=j[f+8>>2];b=j[f+12>>2]}j[a+40>>2]=l;j[a+20>>2]=e;j[a+36>>2]=m;j[a+24>>2]=g;j[a>>2]=n;j[a+4>>2]=b;Za=f+16|0}function ME(a,b,c,d,e,f,g,h){var l=0,m=0,o=0,r=0,s=0,t=q(0),u=0,v=0;a:{if(k[b+21|0]){r=j[f>>2];m=j[e>>2];u=1;b:{if((h|0)>=1){s=j[b>>2];v=p(d,g);while(1){if(j[a+1396>>2]<=9){Dj(a)}o=j[a+1392>>2];g=i[(((o&1023)<<1)+b|0)+36>>1];c:{if((g|0)>=0){l=o;o=k[g+j[b+8>>2]|0];j[a+1392>>2]=l>>>o;l=j[a+1396>>2]-o|0;o=(l|0)<0;j[a+1396>>2]=o?0:l;g=o?-1:g;break c}g=Qk(a,b)}if((g|0)>=j[b+2092>>2]?k[b+23|0]:0){break a}if((g|0)<=-1){if(!k[a+1376|0]){u=0;if(j[a+1384>>2]){break b}}Nb(a,21);return 0}o=p(d,r);s=((o+s|0)+m|0)>(v|0)?(v-o|0)+m|0:s;o=p(g,j[b>>2]);d:{if(k[b+22|0]){g=0;t=q(0);if((s|0)<=0){break d}while(1){t=q(n[j[b+28>>2]+(g+o<<2)>>2]+t);l=j[(m<<2)+c>>2];if(l){l=l+(r<<2)|0;n[l>>2]=n[l>>2]+t}m=m+1|0;l=(m|0)==(d|0);m=l?0:m;r=l+r|0;g=g+1|0;if((s|0)!=(g|0)){continue}break}break d}g=0;if((s|0)<=0){break d}while(1){l=j[(m<<2)+c>>2];if(l){l=l+(r<<2)|0;n[l>>2]=n[l>>2]+n[j[b+28>>2]+(g+o<<2)>>2]}m=m+1|0;l=(m|0)==(d|0);m=l?0:m;r=l+r|0;g=g+1|0;if((s|0)!=(g|0)){continue}break}}h=h-s|0;if((h|0)>0){continue}break}}j[e>>2]=m;j[f>>2]=r}return u}Nb(a,21);return 0}Y(50768,50512,1872,50804);z()}function hka(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,k=0;e=Za+ -64|0;Za=e;g=xm(a);a:{if(b-1>>>0>1023){break a}f=j[a+12>>2];if((f|0)==(b|0)){break a}if(c){c=j[g+8>>2];if(m[c+40>>2]<b>>>0|m[c+36>>2]>b>>>0){break a}f=j[a+12>>2]}f=p(Kj(a),b>>>0>f>>>0?b-f|0:f-b|0);b:{c:{if(m[a+12>>2]<b>>>0){c=e;d:{if(d){d=Mb(a);break d}d=Lb(a)}j[c+48>>2]=d;c=Cd(e+56|0,e+48|0);th(e+40|0);c=j[c>>2];j[114630]=0;P(1558,a|0,c|0,f|0,e+40|0)|0;c=j[114630];j[114630]=0;if((c|0)!=1){break b}a=J(71412)|0;break c}if(d){i=e,k=Mb(a),j[i+48>>2]=k;i=e,k=HI(e+48|0,0-f|0),j[i+40>>2]=k;c=Cd(e+32|0,e+40|0);i=e,k=Mb(a),j[i+16>>2]=k;d=j[Cd(e+24|0,e+16|0)>>2];c=j[c>>2];j[114630]=0;K(1559,a|0,c|0,d|0)|0;c=j[114630];j[114630]=0;if((c|0)!=1){break b}a=J(71412)|0;break c}i=e,k=Lb(a),j[i+40>>2]=k;c=Cd(e+8|0,e+40|0);i=e,k=Lb(a),j[i+16>>2]=k;i=e,k=HI(e+16|0,f),j[i+48>>2]=k;d=j[Cd(e,e+48|0)>>2];c=j[c>>2];j[114630]=0;K(1559,a|0,c|0,d|0)|0;c=j[114630];j[114630]=0;if((c|0)!=1){break b}a=J(71412)|0}if((C()|0)==(W(71412)|0)){O(a|0)|0;Q();break a}G(a|0);z()}j[a+12>>2]=b;h=1}Za=e- -64|0;return h|0}function pva(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;g=Za-16|0;Za=g;f=j[a+48>>2];o=j[a+24>>2];q=j[a+20>>2];b=j[a+44>>2];r=j[a+16>>2];k=j[a+4>>2];l=j[a>>2];j[g+8>>2]=l;j[g+12>>2]=k;e=j[a+12>>2];j[g>>2]=j[a+8>>2];j[g+4>>2]=e;a:{if(!d){e=b;b=f;break a}while(1){e=k+r|0;k=h[e+2|0];s=h[e+1|0];t=h[e|0];u=h[e-1|0];e=j[a+60>>2];v=e;w=e>>31;e=Gb(b,-16777216,16776704);m=j[a+64>>2];f=Gb(f,-16777216,16776704);x=j[a+72>>2];y=j[c>>2];e=HMa(m,m>>31,e,e>>31);m=ab;z=e;e=j[a+68>>2];n=HMa(e,e>>31,f,f>>31);e=z+n|0;f=ab+m|0;f=e>>>0<n>>>0?f+1|0:f;m=e;e=(l>>>21&2040)+27888|0;k=(((p(i[e+2>>1],t)+p(u,i[e>>1])|0)+p(i[e+4>>1],s)|0)+p(k,i[e+6>>1])<<8)/16384<<8;e=k;l=HMa(v,w,e,e>>31);e=m+l|0;f=ab+f|0;f=e>>>0<l>>>0?f+1|0:f;e=e+8388608|0;if(e>>>0<8388608){f=f+1|0}f=(f&16777215)<<8|e>>>24;e=(f|0)/256|0;j[c>>2]=p(e,q)+y;j[c+4>>2]=j[c+4>>2]+p(e,o);e=f-(k&x)|0;Bb(g+8|0,g);d=d-1|0;if(d){c=c+8|0;l=j[g+8>>2];k=j[g+12>>2];f=b;b=e;continue}break}l=j[g+8>>2];k=j[g+12>>2]}j[a+48>>2]=b;j[a+44>>2]=e;j[a>>2]=l;j[a+4>>2]=k;Za=g+16|0}function ova(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;g=Za-16|0;Za=g;f=j[a+48>>2];o=j[a+24>>2];q=j[a+20>>2];b=j[a+44>>2];r=j[a+16>>2];h=j[a+4>>2];k=j[a>>2];j[g+8>>2]=k;j[g+12>>2]=h;e=j[a+12>>2];j[g>>2]=j[a+8>>2];j[g+4>>2]=e;a:{if(!d){e=b;b=f;break a}while(1){e=(h<<1)+r|0;l=i[e>>1];s=i[e-2>>1];t=i[e+2>>1];u=i[e+4>>1];n=j[a+60>>2];e=Gb(b,-16777216,16776704);m=j[a+64>>2];h=Gb(f,-16777216,16776704);v=j[a+72>>2];f=j[c>>2];e=HMa(m,m>>31,e,e>>31);m=ab;w=c;x=f;f=(k>>>21&2040)+27888|0;k=(((p(l,i[f+2>>1])+p(i[f>>1],s)|0)+p(i[f+4>>1],t)|0)+p(u,i[f+6>>1])|0)/16384<<8;f=k;l=HMa(n,n>>31,f,f>>31);e=l+e|0;f=ab+m|0;f=e>>>0<l>>>0?f+1|0:f;l=e;e=j[a+68>>2];h=HMa(e,e>>31,h,h>>31);e=l+h|0;f=ab+f|0;f=e>>>0<h>>>0?f+1|0:f;e=e+8388608|0;if(e>>>0<8388608){f=f+1|0}f=(f&16777215)<<8|e>>>24;e=(f|0)/256|0;j[w>>2]=x+p(e,q);j[c+4>>2]=j[c+4>>2]+p(e,o);e=f-(k&v)|0;Bb(g+8|0,g);d=d-1|0;if(d){c=c+8|0;k=j[g+8>>2];h=j[g+12>>2];f=b;b=e;continue}break}k=j[g+8>>2];h=j[g+12>>2]}j[a+48>>2]=b;j[a+44>>2]=e;j[a>>2]=k;j[a+4>>2]=h;Za=g+16|0}function cS(a){var b=0,c=0,d=0,e=0,f=0,g=0,i=0;a:{if((k[a|0]-1&255)>>>0>14){break a}b=a+1954|0;d=a+1698|0;while(1){if(h[d|0]<=-2){break a}d=d+1|0;if((b|0)!=(d|0)){continue}break}d=0;while(1){b:{i=0;f=p(d,13)+a|0;if(k[f+14|0]){break b}e=(d<<4)+a|0;b=e+418|0;if(k[b|0]|k[b+1|0]<<8|(k[b+2|0]<<16|k[b+3|0]<<24)){break b}c=e+422|0;if(k[f+942|0]|(k[c|0]|k[c+1|0]<<8|(k[c+2|0]<<16|k[c+3|0]<<24))>>>0>1048575){break b}b=p(d,11)+a|0;f=b+1346|0;if(k[f|0]>15|k[b+1351|0]>3|k[b+1356|0]>3){break b}c:{if(!(k[c|0]|k[c+1|0]<<8|(k[c+2|0]<<16|k[c+3|0]<<24))){break c}b=e+430|0;if((k[b|0]|k[b+1|0]<<8|(k[b+2|0]<<16|k[b+3|0]<<24))>>>0>1048574){break c}if((k[b|0]|k[b+1|0]<<8|(k[b+2|0]<<16|k[b+3|0]<<24))>>>0>(k[c|0]|k[c+1|0]<<8|(k[c+2|0]<<16|k[c+3|0]<<24))>>>0){break b}e=e+426|0;if((k[e|0]|k[e+1|0]<<8|(k[e+2|0]<<16|k[e+3|0]<<24))>>>0>(k[b|0]|k[b+1|0]<<8|(k[b+2|0]<<16|k[b+3|0]<<24))>>>0){break b}}i=1;b=1;d:{if(g){break d}e:{if(k[c|0]|k[c+1|0]<<8|(k[c+2|0]<<16|k[c+3|0]<<24)){break e}if(_c(f,12323,11)){break e}b=0;break d}b=1}g=b;d=d+1|0;if((d|0)!=32){continue}}break}g=g&i}return g}function Kua(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;f=Za-32|0;Za=f;n=j[a+40>>2];o=j[a+36>>2];q=j[a+16>>2];e=j[a+4>>2];k=e;l=j[a>>2];j[f+24>>2]=l;j[f+28>>2]=e;e=j[a+12>>2];j[f+16>>2]=j[a+8>>2];j[f+20>>2]=e;a:{if(!d){g=n>>12;e=o>>12;break a}while(1){m=(((k&2147483647)<<1|l>>>31)&-2)+q|0;e=(((l>>>16|0)+4&131064)<<1)+b|0;l=i[e+38>>1];r=i[e+36>>1];s=i[e+34>>1];t=i[e+32>>1];u=i[e+30>>1];v=i[e+28>>1];w=i[e+26>>1];x=i[e+24>>1];g=0;e=1;while(1){j[(f+8|0)+(g<<2)>>2]=(((((p(h[(g|4)+m|0],s)+p(h[(g|2)+m|0],t)|0)+p(h[(g|6)+m|0],r)|0)+p(h[(g|8)+m|0],l)<<8)/2|0)+((((p(h[(g|-4)+m|0],w)+p(h[(g|-6)+m|0],x)|0)+p(h[(g|-2)+m|0],v)|0)+p(h[g+m|0],u)<<8)/2|0)|0)/16384;k=e;e=0;g=1;if(k){continue}break}k=j[a+32>>2];o=j[a+28>>2]+o|0;e=o>>12;j[c>>2]=j[c>>2]+p(e,j[f+8>>2]);n=k+n|0;g=n>>12;j[c+4>>2]=j[c+4>>2]+p(g,j[f+12>>2]);Bb(f+24|0,f+16|0);d=d-1|0;if(d){c=c+8|0;l=j[f+24>>2];k=j[f+28>>2];continue}break}l=j[f+24>>2];k=j[f+28>>2]}j[a+40>>2]=n;j[a+20>>2]=e;j[a+36>>2]=o;j[a+24>>2]=g;j[a>>2]=l;j[a+4>>2]=k;Za=f+32|0}function FH(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=q(0);c=Za+ -64|0;Za=c;d=Hn(c+48|0,vd(c+40|0,b),0);j[114630]=0;b=H(540,d|0)|0;e=j[114630];j[114630]=0;a:{if((e|0)==1){break a}j[114630]=0;b=K(1696,d|0,c|0,b|0)|0;e=j[114630];j[114630]=0;if((e|0)==1){break a}b:{if(!b|j[c>>2]!=542066252){break b}b=c|4;if(k[b|0]|k[b+1|0]<<8|(k[b+2|0]<<16|k[b+3|0]<<24)){break b}b=c+8|0;f=a,g=Jm((PMa(2,k[b|0]|k[b+1|0]<<8|(k[b+2|0]<<16|k[b+3|0]<<24)),TMa()),q(0),q(1)),n[f+4220>>2]=g;b=c+12|0;f=a,g=Jm((PMa(2,k[b|0]|k[b+1|0]<<8|(k[b+2|0]<<16|k[b+3|0]<<24)),TMa()),q(0),q(1)),n[f+4224>>2]=g;b=c+16|0;f=a,g=Jm((PMa(2,k[b|0]|k[b+1|0]<<8|(k[b+2|0]<<16|k[b+3|0]<<24)),TMa()),q(0),q(1)),n[f+4228>>2]=g;b=c+20|0;if((k[b|0]|k[b+1|0]<<8|(k[b+2|0]<<16|k[b+3|0]<<24))>>>0<=5){j[a+4232>>2]=k[b|0]|k[b+1|0]<<8|(k[b+2|0]<<16|k[b+3|0]<<24)}b=c+24|0;j[a+4236>>2]=k[b|0]|k[b+1|0]<<8|(k[b+2|0]<<16|k[b+3|0]<<24);h[a+4240|0]=k[c+28|0]!=0;h[a+4241|0]=k[c+29|0]!=0;h[a+4242|0]=k[c+30|0]!=0;h[a+4243|0]=k[c+31|0]!=0;h[a+4244|0]=k[c+32|0]!=0}jb(d);Za=c- -64|0;return}a=D()|0;C()|0;jb(d);G(a|0);z()}function A5(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0;d=Za-32|0;Za=d;a=yv(a);a:{b:{c:{d:{e:{f:{g:{h:{i:{j:{if((Vq(b,c,0)|0)!=-1){while(1){f=Vq(b,c,e);j[114630]=0;L(199,d|0,b|0,e|0,f-e|0);f=j[114630];j[114630]=0;if((f|0)==1){break j}j[114630]=0;F(200,d+16|0,d|0);f=j[114630];j[114630]=0;if((f|0)==1){break i}j[114630]=0;F(201,a|0,d+16|0);f=j[114630];j[114630]=0;if((f|0)==1){break h}gb(d+16|0);gb(d);e=Vq(b,c,e)+nb(c)|0;if((Vq(b,c,e)|0)!=-1){continue}break}}k:{if(Xc(a)){j[114630]=0;L(199,d+16|0,b|0,e|0,-1);c=j[114630];j[114630]=0;if((c|0)==1){break f}c=nb(d+16|0);gb(d+16|0);if(!c){break k}}j[114630]=0;L(199,d|0,b|0,e|0,-1);b=j[114630];j[114630]=0;if((b|0)==1){break e}j[114630]=0;F(200,d+16|0,d|0);b=j[114630];j[114630]=0;if((b|0)==1){break d}j[114630]=0;F(201,a|0,d+16|0);b=j[114630];j[114630]=0;if((b|0)==1){break c}gb(d+16|0);gb(d)}Za=d+32|0;return}e=D()|0;C()|0;break a}e=D()|0;C()|0;break g}e=D()|0;C()|0;gb(d+16|0)}gb(d);break a}e=D()|0;C()|0;break a}e=D()|0;C()|0;break a}e=D()|0;C()|0;break b}e=D()|0;C()|0;gb(d+16|0)}gb(d)}Rk(a);G(e|0);z()}function f3(a,b){var c=0,d=0,e=0,f=0,g=0,h=0,i=0,l=0,m=0;c=Za-32|0;Za=c;j[114630]=0;h=E(15,c+24|0,a|0)|0;d=j[114630];j[114630]=0;a:{b:{c:{if((d|0)!=1){d:{if(!k[h|0]){break d}d=j[(j[j[a>>2]-12>>2]+a|0)+4>>2];hc(c+16|0,j[j[a>>2]-12>>2]+a|0);j[114630]=0;f=H(2386,c+16|0)|0;e=j[114630];j[114630]=0;e:{f:{if((e|0)!=1){wb(c+16|0);e=uk(c+8|0,a);g=j[j[a>>2]-12>>2];j[114630]=0;g=a+g|0;l=H(16,g|0)|0;i=j[114630];j[114630]=0;if((i|0)==1){break f}e=j[e>>2];j[114630]=0;i=f;f=b&65535;m=b;b=d&74;b=U(2387,i|0,e|0,g|0,l|0,((b|0)==64?f:(b|0)==8?f:m)|0)|0;d=j[114630];j[114630]=0;if((d|0)==1){break f}j[c+16>>2]=b;if(!tk(c+16|0)){break d}b=j[j[a>>2]-12>>2];j[114630]=0;F(18,a+b|0,5);b=j[114630];j[114630]=0;if((b|0)!=1){break d}b=J(0)|0;C()|0;break e}b=J(0)|0;C()|0;wb(c+16|0);break e}b=J(0)|0;C()|0}nf(h);break c}nf(h);break b}b=J(0)|0;C()|0}O(b|0)|0;b=j[j[a>>2]-12>>2];j[114630]=0;N(19,a+b|0);a=j[114630];j[114630]=0;if((a|0)==1){break a}Q()}Za=c+32|0;return}a=D()|0;C()|0;j[114630]=0;M(20);b=j[114630];j[114630]=0;if((b|0)!=1){G(a|0);z()}J(0)|0;C()|0;ib();z()}function s5(a,b,c,d){var e=0,f=0,g=0,h=0,i=0,l=0,m=0,n=0;e=Za-128|0;Za=e;l=Ab(e,0,128);a:{b:{c:{d:{if((c|0)<1){break d}while(1){if(k[b+h|0]!=255){break d}h=h+1|0;if((h|0)!=(c|0)){continue}break}break c}if((c|0)!=(h|0)){break b}}f=1;if(!j[a+2092>>2]){break a}Y(52026,50512,1088,52049);z()}e=b+h|0;IE(a,0,h,0,k[e|0],d);e=k[e|0];if(e){g=e>>>0>1?e:1;f=1;while(1){j[(f<<2)+l>>2]=1<<32-f;e=(f|0)==(g|0);f=f+1|0;if(!e){continue}break}}m=1;i=h+1|0;if((i|0)>=(c|0)){f=1;break a}e:{f:{g:{while(1){h:{h=b+i|0;e=k[h|0];i:{if((e|0)==255){break i}f=e;if(!e){break e}while(1){g=(f<<2)+l|0;n=j[g>>2];if(!n){g=(f|0)>1;f=f-1|0;if(g){continue}break e}break}if(f>>>0>=32){break h}j[g>>2]=0;IE(a,Pk(n),i,m,e,d);m=m+1|0;g=k[h|0];if((g|0)==(f|0)){break i}if(g>>>0>31){break g}if((f|0)>=(g|0)){break i}while(1){e=(g<<2)+l|0;if(j[e>>2]){break f}j[e>>2]=(1<<32-g)+n;g=g-1|0;if((g|0)>(f|0)){continue}break}}f=1;i=i+1|0;if((i|0)!=(c|0)){continue}break a}break}Y(52067,50512,1111,52049);z()}Y(52084,50512,1116,52049);z()}Y(52111,50512,1118,52049);z()}f=0}Za=l+128|0;return f}function pea(a,b,c){var d=0,e=0,f=0,g=0,h=0,k=0,l=0,m=0,n=0;a:{if(!j[a+4116>>2]){if(!j[a+4120>>2]){break a}Vm(a+8|0,c,a+4104|0,a+4108|0)}f=j[a>>2];g=j[a+4184>>2];d=p(f,g)>>>4|0;d=d>>>0<32767?d:32767;i[a+4202>>1]=d;i[a+4200>>1]=d;e=j[a+54052>>2];d=p(e,f)>>>4|0;d=d>>>0<65536?d:65536;l=d+127>>>3|0;i[a+54050>>1]=l;d=d+255>>>4|0;i[a+54048>>1]=d;i[a+54046>>1]=d;i[a+54044>>1]=l;d=a+8|0;g=(e|0)<(g|0)?g:e;f=36-f>>>1|0;f=f>>>0>8?f:8;oea(b,d,16-(p((g|0)<32768?g:32768,(f|0)<16?16-f|0:0)>>15)|0,c);l=a+4172|0;c=nea(a,d,c);b:{if(!c){k=j[l>>2];break b}n=a+53996|0;mea(l,d,c);h=j[a+4180>>2];m=a+37612|0;f=d;g=c;while(1){k=h&4095;h=h-j[a+53996>>2]&4095;e=4096-(h>>>0<k>>>0?k:h)|0;e=e>>>0<g>>>0?e:g;e=e>>>0<64?e:64;lea(l,(k<<2)+m|0,f,e);kea(n,(h<<2)+m|0,f,e);h=e+j[a+4180>>2]&4095;j[a+4180>>2]=h;k=e+j[a+4172>>2]&8191;j[a+4172>>2]=k;f=(e<<3)+f|0;g=g-e|0;if(g){continue}break}}j[a+4172>>2]=k&8191;jea(a,d,b,c);c:{if(j[a+4116>>2]){j[a+4120>>2]=j[a+4124>>2];break c}b=j[a+4120>>2];if(b>>>0>c>>>0){j[a+4120>>2]=b-c;break c}OG(a);j[a+4120>>2]=0}j[a+4116>>2]=0}}function WZ(a,b,c,d,e,f,g,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;i=i|0;var l=0,m=0,n=0,o=0;n=Za-16|0;Za=n;l=c;while(1){a:{if((d|0)==(l|0)){l=d;break a}if(!j[l>>2]){break a}l=l+4|0;continue}break}j[i>>2]=f;j[e>>2]=c;while(1){b:{c:{if(!((f|0)==(g|0)|(c|0)==(d|0))){m=j[b+4>>2];j[n+8>>2]=j[b>>2];j[n+12>>2]=m;m=1;d:{e:{f:{g:{h:{o=VZ(f,e,l-c>>2,g-f|0,b,j[a+8>>2]);switch(o+1|0){case 0:break h;case 1:break c;default:break g}}j[i>>2]=f;while(1){i:{if(j[e>>2]==(c|0)){break i}b=Lu(f,j[c>>2],n+8|0,j[a+8>>2]);if((b|0)==-1){break i}f=b+j[i>>2]|0;j[i>>2]=f;c=c+4|0;continue}break}j[e>>2]=c;break f}f=j[i>>2]+o|0;j[i>>2]=f;if((f|0)==(g|0)){break d}if((d|0)==(l|0)){c=j[e>>2];l=d;continue}l=Lu(n+4|0,0,b,j[a+8>>2]);if((l|0)!=-1){break e}}m=2;break c}c=n+4|0;if(g-j[i>>2]>>>0<l>>>0){break c}while(1){if(l){f=k[c|0];m=j[i>>2];j[i>>2]=m+1;h[m|0]=f;l=l-1|0;c=c+1|0;continue}break}c=j[e>>2]+4|0;j[e>>2]=c;l=c;while(1){if((d|0)==(l|0)){l=d;break b}if(!j[l>>2]){break b}l=l+4|0;continue}}c=j[e>>2]}m=(c|0)!=(d|0)}Za=n+16|0;return m|0}f=j[i>>2];continue}}function LE(a,b,c,d,e){var f=q(0),g=q(0),h=0,i=q(0),j=q(0),k=0;if(!(a&3)){if((a|0)>=4){k=a>>>2|0;a=(c<<2)+b|0;d=a+(d<<2)|0;while(1){b=d-4|0;g=n[b>>2];i=n[d>>2];j=n[a>>2];n[a>>2]=i+j;c=a-4|0;f=n[c>>2];n[c>>2]=n[b>>2]+f;i=q(j-i);f=q(f-g);n[d>>2]=q(n[e>>2]*i)-q(n[e+4>>2]*f);n[b>>2]=q(n[e+4>>2]*i)+q(n[e>>2]*f);b=d-12|0;i=n[b>>2];c=a-8|0;f=n[c>>2];h=c;c=d-8|0;j=n[c>>2];n[h>>2]=j+f;h=a-12|0;g=n[h>>2];n[h>>2]=n[b>>2]+g;f=q(f-j);g=q(g-i);n[c>>2]=q(n[e+32>>2]*f)-q(n[e+36>>2]*g);n[b>>2]=q(n[e+36>>2]*f)+q(n[e+32>>2]*g);b=d-20|0;i=n[b>>2];c=a-16|0;f=n[c>>2];h=c;c=d-16|0;j=n[c>>2];n[h>>2]=j+f;h=a-20|0;g=n[h>>2];n[h>>2]=n[b>>2]+g;f=q(f-j);g=q(g-i);n[c>>2]=q(n[e+64>>2]*f)-q(n[e+68>>2]*g);n[b>>2]=q(n[e+68>>2]*f)+q(n[e+64>>2]*g);b=d-28|0;i=n[b>>2];c=a-24|0;f=n[c>>2];h=c;c=d-24|0;j=n[c>>2];n[h>>2]=j+f;h=a-28|0;g=n[h>>2];n[h>>2]=n[b>>2]+g;f=q(f-j);g=q(g-i);n[c>>2]=q(n[e+96>>2]*f)-q(n[e+100>>2]*g);n[b>>2]=q(n[e+100>>2]*f)+q(n[e+96>>2]*g);d=d-32|0;a=a-32|0;e=e+128|0;b=(k|0)>1;k=k-1|0;if(b){continue}break}}return}Y(51920,50512,2408,51933);z()}function wG(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,i=0,k=q(0);d=Za-48|0;Za=d;a:{b:{c:{d:{e:{switch(b-1|0){case 1:b=(c<<7)/100|0;a=a+24|0;if((b|0)==j[j[a>>2]+24604>>2]){break d}Vb(d+8|0,j[a>>2]+24604|0,40);j[d+8>>2]=b;Ww(j[a>>2],d+8|0);break d;case 2:b=a+24|0;a=j[b>>2];e=a+24664|0;f=j[e+4>>2];j[d+24>>2]=j[e>>2];j[d+28>>2]=f;e=a+24656|0;f=j[e+4>>2];j[d+16>>2]=j[e>>2];j[d+20>>2]=f;e=j[a+24652>>2];j[d+8>>2]=j[a+24648>>2];j[d+12>>2]=e;g=d,i=Uaa(c),h[g+8|0]=i;if(!aw(d+8|0,j[b>>2]+24648|0)){break d}Vw(j[b>>2],d+8|0);break d;case 3:a=a+24|0;Vb(d+8|0,j[a>>2]+24604|0,40);Taa(d+8|0,c);if(j[j[a>>2]+24640>>2]==j[d+44>>2]?j[j[a>>2]+24636>>2]==j[d+40>>2]:0){break d}Ww(j[a>>2],d+8|0);break d;default:a=R(8)|0;j[114630]=0;c=E(85,d+8|0,38676)|0;b=j[114630];j[114630]=0;if((b|0)==1){break c}Wb(a,c);j[114630]=0;I(2004,a|0,83648,2012);a=j[114630];j[114630]=0;if((a|0)!=1){break a}b=D()|0;C()|0;gb(c);break b;case 0:break e}}g=a,k=Yd(q(10),q(q(c|0)*q(.0005000000237487257))),n[g+48>>2]=k}Za=d+48|0;return}b=D()|0;C()|0;S(a|0)}G(b|0)}z()}function bya(a){a=a|0;var b=0,c=0,d=0,e=0,f=0;b=Za-48|0;Za=b;a:{b:{c:{f=a+24|0;d:{if($c(f)){break d}d=a+4|0;c=nb(d);a=lxa();e=ab;if(c){c=Wm(b+32|0);j[114630]=0;j[b+16>>2]=e;F(87,c|0,b+16|0);e=j[114630];j[114630]=0;e:{f:{g:{if((e|0)!=1){j[114630]=0;j[b+16>>2]=a;F(87,c|0,b+16|0);a=j[114630];j[114630]=0;if((a|0)==1){break g}if(nb(d)){a=0;while(1){e=k[Ub(d,a)|0];j[114630]=0;j[b+16>>2]=e;F(87,c|0,b+16|0);e=j[114630];j[114630]=0;if((e|0)==1){break b}a=a+1|0;if(nb(d)>>>0>a>>>0){continue}break}}a=Lb(c);d=Mb(c);j[114630]=0;d=K(88,b+16|0,a|0,d|0)|0;a=j[114630];j[114630]=0;if((a|0)==1){break f}j[114630]=0;F(89,b+8|0,d|0);a=j[114630];j[114630]=0;if((a|0)==1){break e}ns(f,b+8|0);bf(b+8|0);Ud(d);Ud(c);break d}a=D()|0;C()|0;break a}a=D()|0;C()|0;break a}a=D()|0;C()|0;break a}a=D()|0;C()|0;Ud(d);break a}ab=a;j[b+16>>2]=e;j[b+20>>2]=ab;c=hwa(b+32|0,b+16|0,b+24|0);j[114630]=0;F(89,b+8|0,c|0);a=j[114630];j[114630]=0;if((a|0)==1){break c}ns(f,b+8|0);bf(b+8|0);Ud(c)}Za=b+48|0;return}a=D()|0;C()|0;break a}a=D()|0;C()|0}Ud(c);G(a|0);z()}function rv(a,b,c,d){var e=0,f=0,g=0,h=0,i=0;g=Za-32|0;Za=g;e=d&2147483647;h=e;f=e-1006698496|0;e=e-1140785152|0;i=c;a:{if((f|0)==(e|0)&c>>>0>c>>>0|e>>>0>f>>>0){e=d<<4|c>>>28;c=c<<4|b>>>28;b=b&268435455;h=b;if((b|0)==134217728&a>>>0>=1|b>>>0>134217728){e=e+1073741824|0;a=c+1|0;e=a>>>0<1?e+1|0:e;f=a;break a}f=c;e=e+1073741824|0;if(a|h^134217728){break a}b=c&1;a=b+f|0;e=a>>>0<b>>>0?e+1|0:e;f=a;break a}if(!(!i&(h|0)==2147418112?!(a|b):h>>>0<2147418112)){f=c;c=d<<4|c>>>28;f=f<<4|b>>>28;e=c&524287|2146959360;break a}f=0;e=2146435072;if(h>>>0>1140785151){break a}e=0;h=h>>>16|0;if(h>>>0<15249){break a}e=d&65535|65536;We(g+16|0,a,b,c,e,h-15233|0);hm(g,a,b,c,e,15361-h|0);e=j[g+4>>2];h=e;a=j[g+8>>2];c=j[g+12>>2]<<4|a>>>28;f=a<<4|e>>>28;e=c;a=h&268435455;c=a;b=j[g>>2]|((j[g+16>>2]|j[g+24>>2])!=0|(j[g+20>>2]|j[g+28>>2])!=0);if((a|0)==134217728&b>>>0>=1|a>>>0>134217728){a=f+1|0;e=a>>>0<1?e+1|0:e;f=a;break a}if(b|c^134217728){break a}a=f+(f&1)|0;e=a>>>0<f>>>0?e+1|0:e;f=a}Za=g+32|0;PMa(0,f|0);PMa(1,d&-2147483648|e);return+QMa()}function ewa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,i=0,j=0,l=0,m=0;i=lb(b);a:{b:{c:{d:{e:{while(1){b=c;if(!c){break e}c=b-1|0;if(!k[i+c|0]){continue}break}if((d|0)!=4){break c}d=0;c=0;while(1){f:{g:{h:{e=k[c+i|0];switch(e-10|0){case 3:break h;case 0:break g;default:break f}}f=f+1|0;break f}g=g+1|0}j=((d&255)==13&(c|0)!=0&(e|0)==10)+j|0;d=e;c=c+1|0;if((c|0)!=(b|0)){continue}break}break d}b=0;if((d|0)!=4){break b}}i:{if((f|0)==(g|0)){d=2;if((f|0)==(j|0)){break i}}if(f){d=0;if(!g){break i}}d=f?3:g?1:3}if(!b){break b}}c=0;f=(d|0)!=2;e=0;while(1){e=(f|k[c+i|0]!=10)+e|0;c=c+1|0;if((c|0)!=(b|0)){continue}break}rm(a,e);f=(d|0)==1?32:13;g=(d|0)==2;j=d&-3;c=0;e=0;while(1){j:{k:{l:{m:{n:{o:{d=h[c+i|0];switch(d-10|0){case 1:case 2:break l;case 0:break n;case 3:break o;default:break m}}l=Rl(a,e),m=f,h[l|0]=m;c=c+g|0;break j}d=Rl(a,e);if(j){h[d|0]=13;break j}h[d|0]=32;break j}if(!d){break k}}l=Rl(a,e),m=d,h[l|0]=m;break j}l=Rl(a,e),m=32,h[l|0]=m}e=e+1|0;c=c+1|0;if(c>>>0<b>>>0){continue}break}break a}rm(a,0)}return 1}function d5(a,b,c,d,e,f,g){var h=q(0),i=q(0),j=q(0),k=q(0),l=0,m=q(0),o=0,r=q(0),s=q(0),t=q(0),u=q(0),v=q(0),w=q(0),x=q(0);if((a|0)>=1){l=p(f,12)+e|0;m=n[l>>2];o=f<<3;r=n[o+e>>2];f=(f<<2)+e|0;s=n[f>>2];t=n[l+4>>2];u=n[(o|4)+e>>2];v=n[f+4>>2];w=n[e+4>>2];x=n[e>>2];e=(c<<2)+b|0;f=e+(d<<2)|0;b=0-g<<2;while(1){c=f-4|0;i=n[c>>2];k=n[f>>2];j=n[e>>2];n[e>>2]=k+j;d=e-4|0;h=n[d>>2];n[d>>2]=n[c>>2]+h;h=q(h-i);i=q(j-k);n[c>>2]=q(h*x)+q(i*w);n[f>>2]=q(i*x)-q(h*w);c=f-12|0;k=n[c>>2];d=e-8|0;h=n[d>>2];g=d;d=f-8|0;j=n[d>>2];n[g>>2]=j+h;g=e-12|0;i=n[g>>2];n[g>>2]=n[c>>2]+i;i=q(i-k);h=q(h-j);n[c>>2]=q(i*s)+q(h*v);n[d>>2]=q(h*s)-q(i*v);c=f-20|0;k=n[c>>2];d=e-16|0;h=n[d>>2];g=d;d=f-16|0;j=n[d>>2];n[g>>2]=j+h;g=e-20|0;i=n[g>>2];n[g>>2]=n[c>>2]+i;i=q(i-k);h=q(h-j);n[c>>2]=q(i*r)+q(h*u);n[d>>2]=q(h*r)-q(i*u);c=f-28|0;k=n[c>>2];d=e-24|0;h=n[d>>2];g=d;d=f-24|0;j=n[d>>2];n[g>>2]=j+h;g=e-28|0;i=n[g>>2];n[g>>2]=n[c>>2]+i;i=q(i-k);h=q(h-j);n[c>>2]=q(i*m)+q(h*t);n[d>>2]=q(h*m)-q(i*t);f=b+f|0;e=b+e|0;c=(a|0)>1;a=a-1|0;if(c){continue}break}}}function Sva(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,u=0,v=0;h=Za-16|0;Za=h;e=j[a+48>>2];n=j[a+40>>2];o=j[a+36>>2];f=j[a+44>>2];s=j[a+16>>2];l=j[a+4>>2];k=j[a>>2];j[h+8>>2]=k;j[h+12>>2]=l;b=j[a+12>>2];j[h>>2]=j[a+8>>2];j[h+4>>2]=b;a:{if(!d){m=n>>12;g=o>>12;break a}while(1){m=i[(l<<1)+s>>1];g=j[a+60>>2];b=f;f=Gb(f,-16777216,16776704);q=j[a+64>>2];k=Gb(e,-16777216,16776704);t=j[a+72>>2];u=j[a+32>>2];l=c;v=j[c>>2];r=m<<8;e=r;e=HMa(g,g>>31,e,e>>31);m=ab;g=HMa(q,q>>31,f,f>>31);f=g+e|0;e=ab+m|0;e=f>>>0<g>>>0?e+1|0:e;g=f;f=j[a+68>>2];k=HMa(f,f>>31,k,k>>31);f=g+k|0;e=ab+e|0;e=f>>>0<k>>>0?e+1|0:e;f=f+8388608|0;if(f>>>0<8388608){e=e+1|0}f=(e&16777215)<<8|f>>>24;e=(f|0)/256|0;o=j[a+28>>2]+o|0;g=o>>12;j[l>>2]=p(e,g)+v;n=n+u|0;m=n>>12;j[c+4>>2]=j[c+4>>2]+p(e,m);f=f-(r&t)|0;Bb(h+8|0,h);d=d-1|0;if(d){c=c+8|0;l=j[h+12>>2];e=b;continue}break}k=j[h+8>>2];l=j[h+12>>2];e=b}j[a+40>>2]=n;j[a+20>>2]=g;j[a+36>>2]=o;j[a+48>>2]=e;j[a+44>>2]=f;j[a+24>>2]=m;j[a>>2]=k;j[a+4>>2]=l;Za=h+16|0}function wq(a,b,c,d,e,f,g,i,l,m,n,o){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;i=i|0;l=l|0;m=m|0;n=n|0;o=o|0;var p=0;p=Za-16|0;Za=p;j[p+12>>2]=a;a:{b:{if((a|0)==(f|0)){if(!k[b|0]){break b}a=0;h[b|0]=0;b=j[e>>2];j[e>>2]=b+1;h[b|0]=46;if(!nb(i)){break a}b=j[m>>2];if((b-l|0)>159){break a}c=j[n>>2];j[m>>2]=b+4;j[b>>2]=c;break a}c:{if((a|0)!=(g|0)){break c}if(!nb(i)){break c}if(!k[b|0]){break b}a=0;b=j[m>>2];if((b-l|0)>159){break a}a=j[n>>2];j[m>>2]=b+4;j[b>>2]=a;a=0;j[n>>2]=0;break a}a=-1;f=Pu(o,o+128|0,p+12|0)-o|0;if((f|0)>124){break a}g=k[(f>>2)+64416|0];d:{e:{switch(MMa(f-88|0,30)|0){case 2:case 3:b=j[e>>2];if((k[b-1|0]&95)!=(k[c|0]&127)?(b|0)!=(d|0):0){break a}j[e>>2]=b+1;h[b|0]=g;a=0;break a;case 0:case 1:h[c|0]=80;break d;default:break e}}a=h[c|0];if((a|0)!=(g&95)){break d}h[c|0]=a|128;if(!k[b|0]){break d}h[b|0]=0;if(!nb(i)){break d}a=j[m>>2];if((a-l|0)>159){break d}b=j[n>>2];j[m>>2]=a+4;j[a>>2]=b}a=j[e>>2];j[e>>2]=a+1;h[a|0]=g;a=0;if((f|0)>84){break a}j[n>>2]=j[n>>2]+1;break a}a=-1}Za=p+16|0;return a|0}function H1(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0;g=Za-32|0;Za=g;j[g+24>>2]=b;a:{b:{if(!(j[d+4>>2]&1)){j[g>>2]=-1;b=bb[j[j[a>>2]+16>>2]](a,b,c,d,e,g)|0;j[g+24>>2]=b;c:{switch(j[g>>2]){case 1:h[f|0]=1;break a;case 0:break b;default:break c}}h[f|0]=1;j[e>>2]=4;break a}hc(g,d);j[114630]=0;b=H(2450,g|0)|0;a=j[114630];j[114630]=0;d:{e:{f:{g:{if((a|0)!=1){wb(g);hc(g,d);j[114630]=0;a=H(2451,g|0)|0;d=j[114630];j[114630]=0;if((d|0)==1){break g}wb(g);j[114630]=0;F(2452,g|0,a|0);d=j[114630];j[114630]=0;if((d|0)==1){b=D()|0;C()|0;break d}j[114630]=0;F(2453,g|12,a|0);a=j[114630];j[114630]=0;if((a|0)==1){break e}j[114630]=0;d=g+24|0;a=ia(2454,g+24|0,c|0,g|0,d|0,b|0,e|0,1)|0;b=j[114630];j[114630]=0;if((b|0)==1){break f}h[f|0]=(a|0)==(g|0);b=j[g+24>>2];while(1){d=pc(d-12|0);if((g|0)!=(d|0)){continue}break}break a}b=D()|0;C()|0;wb(g);break d}b=D()|0;C()|0;wb(g);break d}b=D()|0;C()|0;while(1){d=pc(d-12|0);if((g|0)!=(d|0)){continue}break}break d}b=D()|0;C()|0;pc(g)}G(b|0);z()}h[f|0]=0}Za=g+32|0;return b|0}function FJ(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0;d=Za-16|0;Za=d;a:{b:{switch(j[a+480224>>2]-1|0){default:c=j[a+24620>>2];j[d+12>>2]=1;j[d+8>>2]=j[b+44>>2]<<1;c=HMa(c,c>>31,5e4,0);f=ab;b=j[Lc(d+12|0,d+8|0)>>2];c=ic(IMa(c,f,b,b>>31),ab);break a;case 0:c=j[a+24620>>2];j[d+12>>2]=1;j[d+8>>2]=j[b+44>>2];c=HMa(c,c>>31,1e4,0);f=ab;b=j[Lc(d+12|0,d+8|0)>>2];c=ic(IMa(c,f,b,b>>31),ab);break a;case 1:break b}}e=+m[a+24620>>2]*60/(+m[b+44>>2]*1e-4*(+(HMa(j[b+32>>2],0,j[b+40>>2],0)>>>0)+ +(ab>>>0)*4294967296));c:{d:{c=a+484344|0;if(!tg(c,l[b+60>>1])){break d}if(!(Xc(Hb(c,l[b+60>>1])+24|0)^1)){break d}c=Hb(c,l[b+60>>1])+24|0;break c}c=a+480248|0}if(!Xc(c)){e=e*5.960464477539063e-8*+m[xb(c,m[b+48>>2]%(sb(c)>>>0)|0)>>2]}e:{if(r(e)<2147483648){c=~~e;break e}c=-2147483648}e=e- +(c>>>0)+o[b+8>>3];o[b+8>>3]=e;if(!(e<1)){o[b+8>>3]=e+ -1;c=c+1|0;break a}if(o[a+1074384>>3]>-1){break a}o[b+8>>3]=e+1;c=c-1|0}b=HMa(j[a+480244>>2],0,c,0)+32768|0;a=ab;a=b>>>0<32768?a+1|0:a;a=Tc((a&65535)<<16|b>>>16,a>>>16|0);Za=d+16|0;return(a?a:1)|0}function gH(a){var b=q(0),c=0,d=0,e=0,f=0,g=q(0),i=q(0),l=0,m=q(0);c=Za-16|0;Za=c;l=c,m=q(hw(n[a+4216>>2])/q(we(j[a+16>>2])>>>0)),n[l+12>>2]=m;j[c+8>>2]=1056964608;b=q(y(q(q(ao(q(n[Vk(c+12|0,c+8|0)>>2]*q(6.2831854820251465)))*q(.4000000059604645))+q(.6000000238418579))));n[a+4236>>2]=b;n[a+4240>>2]=y(q(q(1)-q(b*b)));f=a;b=q(q(n[a+4212>>2]*q(29))+q(2));a:{if(b<q(4294967296)&b>=q(0)){d=~~b>>>0;break a}d=0}h[f+4272|0]=d;f=a;e=2;b:{if(d>>>0<4){break b}e=3;if(d>>>0<8){break b}e=d>>>0<16?4:5}h[f+4273|0]=e;g=Yd(q(10),q(q(q(n[a+4208>>2]*q(60))+q(-60))*q(.05000000074505806)));l=c,m=q(hw(n[a+4220>>2])/q(we(j[a+16>>2])>>>0)),n[l+12>>2]=m;j[c+8>>2]=1056964608;i=n[Vk(c+12|0,c+8|0)>>2];l=c,m=q(hw(n[a+4224>>2])/q(we(j[a+16>>2])>>>0)),n[l+12>>2]=m;j[c+8>>2]=1056964608;b=N4(q(n[Vk(c+12|0,c+8|0)>>2]*q(3.1415927410125732)));n[a+4268>>2]=q(q(1)-b)/q(b+q(1));b=ao(q(i*q(6.2831854820251465)));n[a+4264>>2]=-b;g=q(g*q(y(q(q(1)-q(b*b)))));b=n[a+4268>>2];n[a+4260>>2]=q(g*q(y(q(q(1)-q(b*b)))))*n[(k[a+4272|0]<<2)+33376>>2];Za=c+16|0}function Tva(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,i=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,u=0,v=0;i=Za-16|0;Za=i;e=j[a+48>>2];n=j[a+40>>2];o=j[a+36>>2];f=j[a+44>>2];s=j[a+16>>2];l=j[a+4>>2];k=j[a>>2];j[i+8>>2]=k;j[i+12>>2]=l;b=j[a+12>>2];j[i>>2]=j[a+8>>2];j[i+4>>2]=b;a:{if(!d){m=n>>12;g=o>>12;break a}while(1){m=h[l+s|0];g=j[a+60>>2];b=f;f=Gb(f,-16777216,16776704);q=j[a+64>>2];k=Gb(e,-16777216,16776704);t=j[a+72>>2];u=j[a+32>>2];l=c;v=j[c>>2];r=m<<16;e=r;e=HMa(g,g>>31,e,e>>31);m=ab;g=HMa(q,q>>31,f,f>>31);f=g+e|0;e=ab+m|0;e=f>>>0<g>>>0?e+1|0:e;g=f;f=j[a+68>>2];k=HMa(f,f>>31,k,k>>31);f=g+k|0;e=ab+e|0;e=f>>>0<k>>>0?e+1|0:e;f=f+8388608|0;if(f>>>0<8388608){e=e+1|0}f=(e&16777215)<<8|f>>>24;e=(f|0)/256|0;o=j[a+28>>2]+o|0;g=o>>12;j[l>>2]=p(e,g)+v;n=n+u|0;m=n>>12;j[c+4>>2]=j[c+4>>2]+p(e,m);f=f-(r&t)|0;Bb(i+8|0,i);d=d-1|0;if(d){c=c+8|0;l=j[i+12>>2];e=b;continue}break}k=j[i+8>>2];l=j[i+12>>2];e=b}j[a+40>>2]=n;j[a+20>>2]=g;j[a+36>>2]=o;j[a+48>>2]=e;j[a+44>>2]=f;j[a+24>>2]=m;j[a>>2]=k;j[a+4>>2]=l;Za=i+16|0}function j2(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0;g=Za-32|0;Za=g;j[g+24>>2]=b;a:{b:{if(!(j[d+4>>2]&1)){j[g>>2]=-1;b=bb[j[j[a>>2]+16>>2]](a,b,c,d,e,g)|0;j[g+24>>2]=b;c:{switch(j[g>>2]){case 1:h[f|0]=1;break a;case 0:break b;default:break c}}h[f|0]=1;j[e>>2]=4;break a}hc(g,d);j[114630]=0;b=H(21,g|0)|0;a=j[114630];j[114630]=0;d:{e:{f:{g:{if((a|0)!=1){wb(g);hc(g,d);j[114630]=0;a=H(2417,g|0)|0;d=j[114630];j[114630]=0;if((d|0)==1){break g}wb(g);j[114630]=0;F(2418,g|0,a|0);d=j[114630];j[114630]=0;if((d|0)==1){b=D()|0;C()|0;break d}j[114630]=0;F(2419,g|12,a|0);a=j[114630];j[114630]=0;if((a|0)==1){break e}j[114630]=0;d=g+24|0;a=ia(2420,g+24|0,c|0,g|0,d|0,b|0,e|0,1)|0;b=j[114630];j[114630]=0;if((b|0)==1){break f}h[f|0]=(a|0)==(g|0);b=j[g+24>>2];while(1){d=gb(d-12|0);if((g|0)!=(d|0)){continue}break}break a}b=D()|0;C()|0;wb(g);break d}b=D()|0;C()|0;wb(g);break d}b=D()|0;C()|0;while(1){d=gb(d-12|0);if((g|0)!=(d|0)){continue}break}break d}b=D()|0;C()|0;gb(g)}G(b|0);z()}h[f|0]=0}Za=g+32|0;return b|0}function SO(a,b,c,d,e){var f=0,g=0;f=Za-16|0;Za=f;g=l[c>>1];a:{if(k[d|0]<=4){while(1){d=g<<1;i[c>>1]=d;h[b|0]=(d&65534)>>>0>255;d=k[c|0];i[c>>1]=d;if(!d){if(!re(a,f+15|0)){break a}d=k[f+15|0];i[c>>1]=d<<1|1;h[b|0]=d>>>7;i[c>>1]=k[c|0]}i[e>>1]=h[b|0]+(l[e>>1]<<1);d=l[c>>1]<<1;i[c>>1]=d;h[b|0]=(d&65534)>>>0>255;d=k[c|0];i[c>>1]=d;if(!d){if(!re(a,f+14|0)){break a}d=k[f+14|0];i[c>>1]=d<<1|1;h[b|0]=d>>>7;i[c>>1]=k[c|0]}i[e>>1]=h[b|0]+(l[e>>1]<<1);d=l[c>>1]<<1;i[c>>1]=d;h[b|0]=(d&65534)>>>0>255;g=k[c|0];i[c>>1]=g;if(!g){if(!re(a,f+13|0)){break a}d=k[f+13|0];i[c>>1]=d<<1|1;h[b|0]=d>>>7;g=k[c|0];i[c>>1]=g}if(k[b|0]){continue}break a}}while(1){d=g<<1;i[c>>1]=d;h[b|0]=(d&65534)>>>0>255;d=k[c|0];i[c>>1]=d;if(!d){if(!re(a,f+12|0)){break a}d=k[f+12|0];i[c>>1]=d<<1|1;h[b|0]=d>>>7;i[c>>1]=k[c|0]}i[e>>1]=h[b|0]+(l[e>>1]<<1);d=l[c>>1]<<1;i[c>>1]=d;h[b|0]=(d&65534)>>>0>255;g=k[c|0];i[c>>1]=g;if(!g){if(!re(a,f+11|0)){break a}d=k[f+11|0];i[c>>1]=d<<1|1;h[b|0]=d>>>7;g=k[c|0];i[c>>1]=g}if(k[b|0]){continue}break}}Za=f+16|0}function yq(a,b,c,d,e,f,g,i,l,m,n,o){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;i=i|0;l=l|0;m=m|0;n=n|0;o=o|0;var p=0;p=Za-16|0;Za=p;h[p+15|0]=a;a:{b:{if((a|0)==(f|0)){if(!k[b|0]){break b}a=0;h[b|0]=0;b=j[e>>2];j[e>>2]=b+1;h[b|0]=46;if(!nb(i)){break a}b=j[m>>2];if((b-l|0)>159){break a}c=j[n>>2];j[m>>2]=b+4;j[b>>2]=c;break a}c:{if((a|0)!=(g|0)){break c}if(!nb(i)){break c}if(!k[b|0]){break b}a=0;b=j[m>>2];if((b-l|0)>159){break a}a=j[n>>2];j[m>>2]=b+4;j[b>>2]=a;a=0;j[n>>2]=0;break a}a=-1;f=zm(o,o+32|0,p+15|0)-o|0;if((f|0)>31){break a}g=k[f+64416|0];d:{e:{switch(f-22|0){case 2:case 3:b=j[e>>2];if((k[b-1|0]&95)!=(k[c|0]&127)?(b|0)!=(d|0):0){break a}j[e>>2]=b+1;h[b|0]=g;a=0;break a;case 0:case 1:h[c|0]=80;break d;default:break e}}a=h[c|0];if((a|0)!=(g&95)){break d}h[c|0]=a|128;if(!k[b|0]){break d}h[b|0]=0;if(!nb(i)){break d}a=j[m>>2];if((a-l|0)>159){break d}b=j[n>>2];j[m>>2]=a+4;j[a>>2]=b}a=j[e>>2];j[e>>2]=a+1;h[a|0]=g;a=0;if((f|0)>21){break a}j[n>>2]=j[n>>2]+1;break a}a=-1}Za=p+16|0;return a|0}function bo(a,b,c,d,e,f){var g=q(0),h=q(0),i=0,j=q(0),k=q(0),l=0;if((a|0)>=4){l=a>>>2|0;a=(c<<2)+b|0;d=a+(d<<2)|0;b=f<<2;while(1){c=d-4|0;h=n[c>>2];j=n[d>>2];k=n[a>>2];n[a>>2]=j+k;f=a-4|0;g=n[f>>2];n[f>>2]=n[c>>2]+g;j=q(k-j);g=q(g-h);n[d>>2]=q(n[e>>2]*j)-q(n[e+4>>2]*g);n[c>>2]=q(n[e+4>>2]*j)+q(n[e>>2]*g);f=d-12|0;j=n[f>>2];c=a-8|0;g=n[c>>2];i=c;c=d-8|0;k=n[c>>2];n[i>>2]=k+g;i=a-12|0;h=n[i>>2];n[i>>2]=n[f>>2]+h;i=c;c=b+e|0;g=q(g-k);h=q(h-j);n[i>>2]=q(n[c>>2]*g)-q(n[c+4>>2]*h);n[f>>2]=q(n[c+4>>2]*g)+q(n[c>>2]*h);e=d-20|0;j=n[e>>2];f=a-16|0;g=n[f>>2];i=f;f=d-16|0;k=n[f>>2];n[i>>2]=k+g;i=a-20|0;h=n[i>>2];n[i>>2]=n[e>>2]+h;c=b+c|0;g=q(g-k);h=q(h-j);n[f>>2]=q(n[c>>2]*g)-q(n[c+4>>2]*h);n[e>>2]=q(n[c+4>>2]*g)+q(n[c>>2]*h);e=d-28|0;j=n[e>>2];f=a-24|0;g=n[f>>2];i=f;f=d-24|0;k=n[f>>2];n[i>>2]=k+g;i=a-28|0;h=n[i>>2];n[i>>2]=n[e>>2]+h;c=b+c|0;g=q(g-k);h=q(h-j);n[f>>2]=q(n[c>>2]*g)-q(n[c+4>>2]*h);n[e>>2]=q(n[c+4>>2]*g)+q(n[c>>2]*h);e=b+c|0;d=d-32|0;a=a-32|0;c=(l|0)>1;l=l-1|0;if(c){continue}break}}}function zua(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,k=0,l=0,m=0,n=0,o=0,q=0;e=Za-48|0;Za=e;k=j[a+16>>2];f=vf(e+16|0);j[f+8>>2]=a+112;j[f+16>>2]=j[a+128>>2];o=f,q=qf(b+327720|0,j[b+20>>2],(j[a+88>>2]&16384)>>>14|0),j[o+12>>2]=q;b=j[f+16>>2];if(b){o=f,q=uf(a+8|0,b),j[o>>2]=q;j[f+4>>2]=ab}l=j[a+24>>2];m=j[a+20>>2];b=j[a+4>>2];h=j[a>>2];j[e+8>>2]=h;j[e+12>>2]=b;g=j[a+12>>2];j[e>>2]=j[a+8>>2];j[e+4>>2]=g;if(d){while(1){g=0;j[e+40>>2]=h;j[e+44>>2]=n;h=(b<<1)+k|0;a:{b=j[f+16>>2];if((b|0)<=0){break a}while(1){id(j[f+8>>2],i[(g<<1)+h>>1]/4<<16>>16);hd(j[f+8>>2],4);Bb(e+40|0,f);if((b|0)<2){break a}b=b-1|0;g=j[e+44>>2];continue}}d=d-1|0;b=j[f+8>>2];Bb(b,b+8|0);b=j[f+8>>2];g=j[b+4>>2];if(g){id(b,i[h+(j[e+44>>2]<<1)>>1]/4<<16>>16);hd(j[f+8>>2],g);b=j[f+8>>2];g=j[b>>2];j[b>>2]=g;j[b+4>>2]=0}b=pf(b,j[f+12>>2]);j[c>>2]=j[c>>2]+p(b,m);j[c+4>>2]=j[c+4>>2]+p(b,l);Bb(e+8|0,e);if(d){c=c+8|0;h=j[e+8>>2];b=j[e+12>>2];continue}break}h=j[e+8>>2];b=j[e+12>>2]}j[a>>2]=h;j[a+4>>2]=b;Za=e+48|0}function qW(a){a=a|0;var b=0,c=0,d=0,e=0;c=Za+ -64|0;Za=c;a=Qc(a);j[114630]=0;b=T(228)|0;d=j[114630];j[114630]=0;a:{b:{if((d|0)==1){break b}c:{d:{if(!b){break d}j[114630]=0;d=E(2,c+32|0,10984)|0;b=j[114630];j[114630]=0;if((b|0)==1){break c}j[114630]=0;b=T(228)|0;e=j[114630];j[114630]=0;e:{f:{g:{h:{if((e|0)==1){break h}j[114630]=0;j[c+12>>2]=b;F(234,c+16|0,c+12|0);b=j[114630];j[114630]=0;if((b|0)==1){break h}j[114630]=0;I(3,c+48|0,d|0,c+16|0);b=j[114630];j[114630]=0;if((b|0)==1){break g}ob(a,c+48|0);gb(c+48|0);gb(c+16|0);gb(d);j[114630]=0;b=T(230)|0;d=j[114630];j[114630]=0;if((d|0)==1){break b}if(!b){break e}j[114630]=0;E(235,a|0,10987)|0;b=j[114630];j[114630]=0;if((b|0)!=1){break e}break b}b=D()|0;C()|0;break f}b=D()|0;C()|0;gb(c+16|0)}gb(d);break a}j[114630]=0;b=T(229)|0;d=j[114630];j[114630]=0;if((d|0)==1){break b}if(!b){break d}j[114630]=0;E(235,a|0,10989)|0;b=j[114630];j[114630]=0;if((b|0)==1){break b}}Za=c- -64|0;return}b=D()|0;C()|0;break a}b=D()|0;C()|0}gb(a);G(b|0);z()}function aG(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0;d=Za-32|0;Za=d;a:{b:{c:{d:{e:{f:{g:{if(Ph(a)){go(d+24|0);break g}qm(d+8|0,a);j[114630]=0;F(2169,d+24|0,d+8|0);c=j[114630];j[114630]=0;if((c|0)==1){break f}Ye(d+8|0)}c=a+36|0;h:{if(Ph(a)){break h}c=j[d+24>>2]}if((b|0)==-1){e=4194304;break d}if((b|0)>=0){f=b;if((pd(c)|0)>(b|0)){break d}}b=R(8)|0;j[114630]=0;c=E(85,d+8|0,38710)|0;a=j[114630];j[114630]=0;if((a|0)==1){break e}Wb(b,c);j[114630]=0;I(2004,b|0,83648,2012);a=j[114630];j[114630]=0;if((a|0)!=1){break a}a=D()|0;C()|0;gb(c);break c}a=D()|0;C()|0;Ye(d+8|0);break b}a=D()|0;C()|0;S(b|0);break c}j[a+8>>2]=b;b=a+24|0;g=j[b>>2];j[g+480208>>2]=j[g+480208>>2]&-4194305|e;b=j[b>>2];e=k[zc(c,f)+16|0];j[114630]=0;F(488,b+484360|0,e|0);b=j[114630];j[114630]=0;i:{if((b|0)==1){break i}b=j[zc(c,f)+12>>2];c=j[zc(c,f)+8>>2];j[114630]=0;+ca(2020,a|0,b|0,c|0);b=j[114630];j[114630]=0;if((b|0)==1){break i}j[a+16>>2]=0;j[a+20>>2]=0;Gj(d+24|0);Za=d+32|0;return}a=D()|0;C()|0}Gj(d+24|0)}G(a|0)}z()}function BK(a,b,c,d){var e=0,f=0,g=0,i=0,l=0,m=0;e=Za-16|0;Za=e;g=p(b,896)+a|0;a:{if(c){mb(e+8|0,a+1074308|0,90);if(!kb(e+8|0)){h[(p(b,896)+a|0)+1075815|0]=c}h[(p(b,896)+a|0)+1075816|0]=c;break a}c=k[g+1075816|0]}f=g+1074984|0;i=c&255;m=0-i|0;l=d?l:!(j[a+480180>>2]&204473357);vK(a,b,m,l);b:{c:{if(j[a+480180>>2]!=16777216){break c}g=j[(p(b,896)+a|0)+1075640>>2];if(!g|!j[g+44>>2]){break c}b=c&255;if(!(b>>>0<240|d)){uK(a,f,240-i|0);break b}if(!(b>>>0<224|d)){tK(f,224-i|0);break b}sK(f,m);break b}if(j[a+480180>>2]==268435456){j[(p(b,896)+a|0)+1075692>>2]=65535}if(!(l^1|(c&255)>>>0<224)){d:{d=i&15;if(!d){break d}c=c&240;if((c|0)!=224){if((c|0)!=240){break d}pK(a,f,d);break b}if(j[a+480180>>2]==524288){break d}xK(a,f,d);break b}if(j[a+480180>>2]!=524288){break b}}e:{if(!(h[(p(b,896)+a|0)+1075856|0]&1)){break e}if(j[a+1074416>>2]==1){mb(e+8|0,a+1074308|0,6);if(kb(e+8|0)){break e}}if(j[a+480180>>2]==64){break e}if(!(j[a+480208>>2]&2)|j[a+480180>>2]!=8){break b}}qK(a,f,i<<2)}Za=e+16|0}function JIa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,l=0,m=0,n=0,o=0;f=Za-2608|0;Za=f;d=f+8|0;Ml(d,a);j[d+1056>>2]=0;j[d+1060>>2]=0;Ab(d+1064|0,0,1536);j[114630]=0;N(565,d|0);a=j[114630];j[114630]=0;a:{b:{c:{d:{e:{if((a|0)!=1){if(!c){break d}f:{while(1){j[114630]=0;n=E(260,d|0,1)|0;a=j[114630];j[114630]=0;if((a|0)==1){break f}a=0;g:{while(1){j[114630]=0;e=E(260,d|0,1)|0;o=j[114630];j[114630]=0;if((o|0)==1){break g}a=p(a,6)+d|0;a=i[(e?a+1066|0:a+1064|0)>>1];h:{if((a|0)>255){break h}e=p(a,6)+d|0;g=k[e+1068|0];if(i[e+1064>>1]<0){break h}if(i[e+1066>>1]>-1){continue}}break}g=(n?-1:0)^g;m=(m&255)+(g&255)|0;h[b+l|0]=m;l=l+1|0;if((l|0)!=(c|0)){continue}break d}break}b=J(77088)|0;break e}b=J(77088)|0;break e}b=J(77088)|0}if((C()|0)!=(W(77088)|0)){break a}O(b|0)|0;j[114630]=0;M(20);a=j[114630];j[114630]=0;if((a|0)==1){break c}}j[114630]=0;a=H(566,d|0)|0;b=j[114630];j[114630]=0;if((b|0)==1){break b}jb(d);Za=f+2608|0;return a|0}b=D()|0;C()|0;break a}b=D()|0;C()|0}jb(d);G(b|0);z()}function AZ(a,b,c){var d=0,e=0,f=0,g=0,i=0,j=0,l=0;d=a;while(1){a:{if(c>>>0<=j>>>0|b>>>0<=d>>>0){break a}g=h[d|0];f=g&255;b:{if((g|0)>=0){g=1;if(f>>>0<=1114111){break b}break a}if(f>>>0<194){break a}if(f>>>0<=223){if((b-d|0)<2){break a}e=k[d+1|0];if((e&192)!=128){break a}g=2;if((e&63|f<<6&1984)>>>0<=1114111){break b}break a}c:{d:{if(f>>>0<=239){if((b-d|0)<3){break a}i=k[d+2|0];e=k[d+1|0];if((f|0)==237){break d}if((f|0)==224){if((e&224)==160){break c}break a}if((e&192)!=128){break a}break c}if((b-d|0)<4|f>>>0>244){break a}i=k[d+3|0];l=k[d+2|0];e=k[d+1|0];e:{f:{switch(f-240|0){case 0:if((e+112&255)>>>0<48){break e}break a;case 4:if((e&240)==128){break e}break a;default:break f}}if((e&192)!=128){break a}}if((l&192)!=128|(i&192)!=128){break a}g=4;if((i&63|(l<<6&4032|(f<<18&1835008|(e&63)<<12)))>>>0>1114111){break a}break b}if((e&224)!=128){break a}}if((i&192)!=128){break a}g=3;if((i&63|(f<<12&61440|(e&63)<<6))>>>0>1114111){break a}}j=j+1|0;d=d+g|0;continue}break}return d-a|0}function $wa(a,b){var c=0,d=0,e=0,f=0,g=0;d=Za-32|0;Za=d;md(b,0);ek(d,2,a+32|0);qc(d+16|0,d);j[114630]=0;E(370,b+43|0,d+16|0)|0;c=j[114630];j[114630]=0;if((c|0)!=1){gb(d+16|0);e=a+56|0;c=a+52|0;a:{if((k[e|0]|k[e+1|0]<<8|(k[e+2|0]<<16|k[e+3|0]<<24))>>>0<=(k[c|0]|k[c+1|0]<<8|(k[c+2|0]<<16|k[c+3|0]<<24))>>>0){break a}j[b>>2]=(k[e|0]|k[e+1|0]<<8|(k[e+2|0]<<16|k[e+3|0]<<24))-(k[c|0]|k[c+1|0]<<8|(k[c+2|0]<<16|k[c+3|0]<<24));c=a+44|0;j[b+12>>2]=k[c|0]|k[c+1|0]<<8|(k[c+2|0]<<16|k[c+3|0]<<24);c=a+48|0;j[d+16>>2]=k[c|0]|k[c+1|0]<<8|(k[c+2|0]<<16|k[c+3|0]<<24);f=b,g=j[tb(d+16|0,b)>>2],j[f+16>>2]=g;i[b+30>>1]=k[a+60|0];c=a+62|0;j[b+24>>2]=k[c|0]|k[c+1|0]<<8;c=a- -64|0;if(k[c|0]|k[c+1|0]<<8){js(b,+((k[c|0]|k[c+1|0]<<8)<<16>>16)*25431315104166665e-22)}a=a+61|0;if(k[a|0]&8){i[b+34>>1]=l[b+34>>1]|8}if(k[a|0]&16){i[b+34>>1]=l[b+34>>1]|16}if(!(k[a|0]&4)){break a}i[b+34>>1]=l[b+34>>1]|1;j[b+12>>2]=j[b+12>>2]>>>1;j[b+16>>2]=j[b+16>>2]>>>1}Za=d+32|0;return}a=D()|0;C()|0;gb(d+16|0);G(a|0);z()}function Gva(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,i=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;i=Za-16|0;Za=i;g=j[a+48>>2];o=j[a+24>>2];q=j[a+20>>2];b=j[a+44>>2];r=j[a+16>>2];f=j[a+4>>2];k=j[a>>2];j[i+8>>2]=k;j[i+12>>2]=f;e=j[a+12>>2];j[i>>2]=j[a+8>>2];j[i+4>>2]=e;a:{if(!d){e=b;b=g;break a}while(1){e=f+r|0;s=h[e+1|0];e=h[e|0];f=j[a+60>>2];t=f;u=f>>31;f=Gb(b,-16777216,16776704);l=j[a+64>>2];g=Gb(g,-16777216,16776704);v=j[a+72>>2];w=j[c>>2];f=HMa(l,l>>31,f,f>>31);l=ab;m=f;f=j[a+68>>2];n=HMa(f,f>>31,g,g>>31);f=m+n|0;g=ab+l|0;g=f>>>0<n>>>0?g+1|0:g;m=f;f=((p(s-e|0,k>>>10&4194048)|0)/16384|0)+(e<<8)<<8;e=f;k=HMa(t,u,e,e>>31);e=m+k|0;g=ab+g|0;g=e>>>0<k>>>0?g+1|0:g;e=e+8388608|0;if(e>>>0<8388608){g=g+1|0}g=(g&16777215)<<8|e>>>24;e=(g|0)/256|0;j[c>>2]=p(e,q)+w;j[c+4>>2]=j[c+4>>2]+p(e,o);e=g-(f&v)|0;Bb(i+8|0,i);d=d-1|0;if(d){c=c+8|0;k=j[i+8>>2];f=j[i+12>>2];g=b;b=e;continue}break}k=j[i+8>>2];f=j[i+12>>2]}j[a+48>>2]=b;j[a+44>>2]=e;j[a>>2]=k;j[a+4>>2]=f;Za=i+16|0}function Fva(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;h=Za-16|0;Za=h;g=j[a+48>>2];o=j[a+24>>2];q=j[a+20>>2];b=j[a+44>>2];r=j[a+16>>2];f=j[a+4>>2];k=j[a>>2];j[h+8>>2]=k;j[h+12>>2]=f;e=j[a+12>>2];j[h>>2]=j[a+8>>2];j[h+4>>2]=e;a:{if(!d){e=b;b=g;break a}while(1){e=(f<<1)+r|0;s=i[e+2>>1];e=i[e>>1];f=j[a+60>>2];t=f;u=f>>31;f=Gb(b,-16777216,16776704);l=j[a+64>>2];g=Gb(g,-16777216,16776704);v=j[a+72>>2];w=j[c>>2];f=HMa(l,l>>31,f,f>>31);l=ab;m=f;f=j[a+68>>2];n=HMa(f,f>>31,g,g>>31);f=m+n|0;g=ab+l|0;g=f>>>0<n>>>0?g+1|0:g;m=f;f=e+((p(s-e|0,k>>>18|0)|0)/16384|0)<<8;e=f;k=HMa(t,u,e,e>>31);e=m+k|0;g=ab+g|0;g=e>>>0<k>>>0?g+1|0:g;e=e+8388608|0;if(e>>>0<8388608){g=g+1|0}g=(g&16777215)<<8|e>>>24;e=(g|0)/256|0;j[c>>2]=p(e,q)+w;j[c+4>>2]=j[c+4>>2]+p(e,o);e=g-(f&v)|0;Bb(h+8|0,h);d=d-1|0;if(d){c=c+8|0;k=j[h+8>>2];f=j[h+12>>2];g=b;b=e;continue}break}k=j[h+8>>2];f=j[h+12>>2]}j[a+48>>2]=b;j[a+44>>2]=e;j[a>>2]=k;j[a+4>>2]=f;Za=h+16|0}function CK(a,b,c,d){var e=0,f=0,g=0,i=0,l=0;e=Za-16|0;Za=e;i=p(b,896)+a|0;a:{if(c){mb(e+8|0,a+1074308|0,90);if(!kb(e+8|0)){h[(p(b,896)+a|0)+1075816|0]=c}h[(p(b,896)+a|0)+1075815|0]=c;break a}c=k[i+1075815|0]}f=i+1074984|0;g=c&255;l=d?l:!(j[a+480180>>2]&204473357);vK(a,b,g,l);b:{c:{if(j[a+480180>>2]!=16777216){break c}i=j[(p(b,896)+a|0)+1075640>>2];if(!i|!j[i+44>>2]){break c}b=c&255;if(!(b>>>0<240|d)){uK(a,f,g-240|0);break b}if(!(b>>>0<224|d)){tK(f,g-224|0);break b}sK(f,g);break b}if(j[a+480180>>2]==268435456){j[(p(b,896)+a|0)+1075692>>2]=1}if(!(l^1|(c&255)>>>0<224)){d:{d=g&15;if(!d){break d}c=c&240;if((c|0)!=224){if((c|0)!=240){break d}rK(a,f,d);break b}if(j[a+480180>>2]==524288){break d}wK(a,f,d);break b}if(j[a+480180>>2]!=524288){break b}}e:{if(!(h[(p(b,896)+a|0)+1075856|0]&1)){break e}if(j[a+1074416>>2]==1){mb(e+8|0,a+1074308|0,6);if(kb(e+8|0)){break e}}if(j[a+480180>>2]==64){break e}if(!(j[a+480208>>2]&2)|j[a+480180>>2]!=8){break b}}qK(a,f,0-(g<<2)|0)}Za=e+16|0}function qsa(a,b,c){var d=0,e=0,f=0,g=0,h=0,m=0;if(!k[a+40|0]){i[c>>1]=0;i[b>>1]=0;return}f=j[a+16>>2];e=l[f+3840>>1];d=0;a:{if(!(e&3)){break a}d=(l[a+20>>1]>>>7&7)>>>(k[f+3844|0]^1)>>>(e&1)|0;d=e&4?0-d|0:d}d=d<<l[a+22>>1];h=b;e=j[a+36>>2];b:{if(e){m=l[e+32>>1];g=l[a+32>>1];e=sf(j[a>>2],j[a+24>>2],d<<16>>16,0,i[a+30>>1]);f=j[a+24>>2];b=j[a+4>>2];if(!m){if(!g){d=d<<16>>16;e=sf(b,f,d,e,0);e=sf(j[a+8>>2],j[a+24>>2],d,e,0);d=sf(j[a+12>>2],j[a+24>>2],d,e,0);break b}d=d<<16>>16;f=sf(b,f,d,0,0);f=sf(j[a+8>>2],j[a+24>>2],d,f,0);d=sf(j[a+12>>2],j[a+24>>2],d,f,0)+e|0;break b}if(!g){d=d<<16>>16;e=sf(b,f,d,e,0);f=sf(j[a+8>>2],j[a+24>>2],d,0,0);d=sf(j[a+12>>2],j[a+24>>2],d,f,0)+e|0;break b}d=d<<16>>16;f=sf(b,f,d,0,0);d=(sf(j[a+8>>2],j[a+24>>2],d,f,0)+e|0)+sf(j[a+12>>2],j[a+24>>2],d,0,0)|0;break b}g=l[a+32>>1];d=d<<16>>16;e=sf(j[a>>2],j[a+24>>2],d,0,i[a+30>>1]);f=j[a+24>>2];b=j[a+4>>2];if(!g){d=sf(b,f,d,e,0);break b}d=sf(b,f,d,0,0)+e|0}i[h>>1]=k[a+41|0]?d:0;i[c>>1]=k[a+42|0]?d:0}function bKa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;g=Za-144|0;Za=g;p=up(a);if(p){u=g+8|4;v=g+8|6;w=g+8|5;n=g+8|2;q=g+8|3;while(1){JJa(a,g+8|0);e=k[g+8|0]|k[g+9|0]<<8;a:{if(!e){break a}e=(e<<8|e>>>8)&65535;if(e>>>0>l[c+480192>>1]){break a}e=j[((e<<2)+c|0)+900380>>2];if(!e){break a}e=Dt(e,b);b:{if(!k[q|0]){break b}if(h[n|0]&1){h[e+12|0]=k[e+12|0]|1}if(k[n|0]&2){h[e+12|0]=k[e+12|0]|4}if(!(k[n|0]&4)){break b}h[e+12|0]=k[e+12|0]|2}h[g+4|0]=k[q|0];h[g+7|0]=31;f=k[Zb(g+4|0,g+7|0)|0]+1|0;o=f&255;Nf(e,o);h[e+13|0]=k[w|0];h[e+14|0]=k[v|0];m=k[u|0];h[e+15|0]=m;h[e+16|0]=m;m=0;if((f|0)!=(o|0)){break a}while(1){r=g+16|0;s=m<<2;f=r+s|0;f=k[f|0]|k[f+1|0]<<8;x=xb(e,m),y=f<<8|f>>>8,i[x>>1]=y;f=(s|2)+r|0;f=k[f|0]|k[f+1|0]<<8;f=f<<8|f>>>8;i[g+4>>1]=d?(f&65535)+128>>>2|0:f;Rf(g+4|0,64);f=k[g+4|0];x=xb(e,m),y=f,h[x+2|0]=y;m=m+1|0;if((o|0)!=(m|0)){continue}break}}t=t+1|0;if((t&65535)>>>0<p>>>0){continue}break}}Za=g+144|0}function UZ(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var i=0,l=0,m=0;l=Za-16|0;Za=l;i=c;while(1){a:{if((d|0)==(i|0)){i=d;break a}if(!k[i|0]){break a}i=i+1|0;continue}break}j[h>>2]=f;j[e>>2]=c;while(1){b:{c:{d:{if((f|0)==(g|0)|(c|0)==(d|0)){break d}m=j[b+4>>2];j[l+8>>2]=j[b>>2];j[l+12>>2]=m;e:{f:{g:{m=TZ(f,e,i-c|0,g-f>>2,b,j[a+8>>2]);h:{if((m|0)==-1){while(1){i:{j[h>>2]=f;if(j[e>>2]==(c|0)){break i}g=1;j:{k:{l:{b=gC(f,c,i-c|0,l+8|0,j[a+8>>2]);switch(b+2|0){case 2:break j;case 1:break l;case 0:break f;default:break k}}j[e>>2]=c;break h}g=b}c=c+g|0;f=j[h>>2]+4|0;continue}break}j[e>>2]=c;break d}f=j[h>>2]+(m<<2)|0;j[h>>2]=f;if((f|0)==(g|0)){break e}c=j[e>>2];if((d|0)==(i|0)){i=d;continue}if(!gC(f,c,1,b,j[a+8>>2])){break g}}a=2;break c}j[h>>2]=j[h>>2]+4;c=j[e>>2]+1|0;j[e>>2]=c;i=c;while(1){if((d|0)==(i|0)){i=d;break b}if(!k[i|0]){break b}i=i+1|0;continue}}j[e>>2]=c;a=1;break c}c=j[e>>2]}a=(c|0)!=(d|0)}Za=l+16|0;return a|0}f=j[h>>2];continue}}function Hka(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0;e=Za-16|0;Za=e;md(c,0);d=a+36|0;i[e+14>>1]=k[d|0]|k[d+1|0]<<8;i[e+12>>1]=32767;f=c,g=(l[gf(e+14|0,e+12|0)>>1]<<8>>>0)/32767|0,i[f+28>>1]=g;d=a+38|0;i[e+10>>1]=k[d|0]|k[d+1|0]<<8;i[e+8>>1]=32767;f=c,g=(l[gf(e+10|0,e+8|0)>>1]<<8>>>0)/32767|0,i[f+30>>1]=g;i[c+32>>1]=64;d=a+44|0;j[c>>2]=k[d|0]|k[d+1|0]<<8|(k[d+2|0]<<16|k[d+3|0]<<24);d=a+48|0;j[c+4>>2]=k[d|0]|k[d+1|0]<<8|(k[d+2|0]<<16|k[d+3|0]<<24);d=a+52|0;j[c+8>>2]=k[d|0]|k[d+1|0]<<8|(k[d+2|0]<<16|k[d+3|0]<<24);d=a+56|0;j[c+24>>2]=k[d|0]|k[d+1|0]<<8|(k[d+2|0]<<16|k[d+3|0]<<24);d=b+166|0;if(k[d|0]<=4){h[c+38|0]=k[k[d|0]+31850|0]}h[c+39|0]=k[b+167|0];d=b+171|0;h[c+41|0]=(k[d|0]|k[d+1|0]<<8)>>>4;b=b+169|0;b=(k[b|0]|k[b+1|0]<<8)>>>2|0;h[c+40|0]=b;if(k[c+41|0]|b&255){h[c+39|0]=k[c+39|0]^-1}a=a+40|0;if(k[a|0]&4){i[c+34>>1]=l[c+34>>1]|1}if(k[a|0]&8){i[c+34>>1]=l[c+34>>1]|2}if(k[a|0]&16){i[c+34>>1]=l[c+34>>1]|4}if(k[a|0]&32){i[c+34>>1]=l[c+34>>1]|32}Za=e+16|0}function GZ(a,b,c){var d=0,e=0,f=0,g=0,h=0,i=0;e=a;while(1){a:{if(c>>>0<=g>>>0|b>>>0<=e>>>0){break a}f=k[e|0];if(f>>>0>1114111){break a}d=e+1|0;b:{if(f<<24>>24>=0){break b}if(f>>>0<194){break a}if(f>>>0<=223){if((b-e|0)<2){break a}d=k[e+1|0];if((d&192)!=128|(d&63|f<<6&1984)>>>0>1114111){break a}d=e+2|0;break b}c:{d:{if(f>>>0<=239){if((b-e|0)<3){break a}h=k[e+2|0];d=k[e+1|0];if((f|0)==237){break d}if((f|0)==224){if((d&224)==160){break c}break a}if((d&192)!=128){break a}break c}if(c-g>>>0<2|f>>>0>244|(b-e|0)<4){break a}h=k[e+3|0];i=k[e+2|0];d=k[e+1|0];e:{f:{switch(f-240|0){case 0:if((d+112&255)>>>0<48){break e}break a;case 4:if((d&240)==128){break e}break a;default:break f}}if((d&192)!=128){break a}}if((i&192)!=128|(h&192)!=128|(h&63|(i<<6&4032|(f<<18&1835008|(d&63)<<12)))>>>0>1114111){break a}g=g+1|0;d=e+4|0;break b}if((d&224)!=128){break a}}if((h&192)!=128|(h&63|(f<<12&61440|(d&63)<<6))>>>0>1114111){break a}d=e+3|0}e=d;g=g+1|0;continue}break}return e-a|0}function uE(a,b,c){var d=0,e=0,f=0,g=0,h=0;d=Za-208|0;Za=d;j[d+8>>2]=1;j[d+12>>2]=0;a:{h=b<<2;if(!h){break a}j[d+16>>2]=4;j[d+20>>2]=4;b=4;g=4;e=2;while(1){f=b;b=(g+4|0)+b|0;j[(d+16|0)+(e<<2)>>2]=b;e=e+1|0;g=f;if(b>>>0<h>>>0){continue}break}f=(a+h|0)-4|0;b:{if(f>>>0<=a>>>0){e=1;b=1;break b}e=1;b=1;while(1){c:{if((e&3)==3){tv(a,c,b,d+16|0);Rq(d+8|0,2);b=b+2|0;break c}g=b-1|0;d:{if(m[(d+16|0)+(g<<2)>>2]>=f-a>>>0){Qq(a,c,d+8|0,b,0,d+16|0);break d}tv(a,c,b,d+16|0)}if((b|0)==1){Pq(d+8|0,1);b=0;break c}Pq(d+8|0,g);b=1}e=j[d+8>>2]|1;j[d+8>>2]=e;a=a+4|0;if(f>>>0>a>>>0){continue}break}}Qq(a,c,d+8|0,b,0,d+16|0);while(1){e:{f:{g:{if(!((b|0)!=1|(e|0)!=1)){if(j[d+12>>2]){break g}break a}if((b|0)>1){break f}}f=tE(d+8|0);Rq(d+8|0,f);e=j[d+8>>2];b=b+f|0;break e}Pq(d+8|0,2);j[d+8>>2]=j[d+8>>2]^7;Rq(d+8|0,1);g=a-4|0;f=b-2|0;Qq(g-j[(d+16|0)+(f<<2)>>2]|0,c,d+8|0,b-1|0,1,d+16|0);Pq(d+8|0,1);e=j[d+8>>2]|1;j[d+8>>2]=e;Qq(g,c,d+8|0,f,1,d+16|0);b=f}a=a-4|0;continue}}Za=d+208|0}function b3(a,b,c){var d=0,e=0,f=0,g=0,h=0,i=0,l=0;d=Za-32|0;Za=d;j[114630]=0;g=E(15,d+24|0,a|0)|0;h=j[114630];j[114630]=0;a:{b:{c:{if((h|0)!=1){d:{if(!k[g|0]){break d}hc(d+16|0,j[j[a>>2]-12>>2]+a|0);j[114630]=0;h=H(2386,d+16|0)|0;e=j[114630];j[114630]=0;e:{f:{if((e|0)!=1){wb(d+16|0);e=uk(d+8|0,a);f=j[j[a>>2]-12>>2];j[114630]=0;f=a+f|0;i=H(16,f|0)|0;l=j[114630];j[114630]=0;if((l|0)==1){break f}e=j[e>>2];j[114630]=0;b=sa(2389,h|0,e|0,f|0,i|0,b|0,c|0)|0;c=j[114630];j[114630]=0;if((c|0)==1){break f}j[d+16>>2]=b;if(!tk(d+16|0)){break d}b=j[j[a>>2]-12>>2];j[114630]=0;F(18,a+b|0,5);b=j[114630];j[114630]=0;if((b|0)!=1){break d}b=J(0)|0;C()|0;break e}b=J(0)|0;C()|0;wb(d+16|0);break e}b=J(0)|0;C()|0}nf(g);break c}nf(g);break b}b=J(0)|0;C()|0}O(b|0)|0;b=j[j[a>>2]-12>>2];j[114630]=0;N(19,a+b|0);a=j[114630];j[114630]=0;if((a|0)==1){break a}Q()}Za=d+32|0;return}a=D()|0;C()|0;j[114630]=0;M(20);b=j[114630];j[114630]=0;if((b|0)!=1){G(a|0);z()}J(0)|0;C()|0;ib();z()}function Fi(a,b,c,d,e,f,g,h){var i=0,k=0,l=0,m=0,n=0;i=Za-32|0;Za=i;j[i+16>>2]=c;j[i+24>>2]=b;hc(i+8|0,d);j[114630]=0;k=H(2450,i+8|0)|0;b=j[114630];j[114630]=0;if((b|0)!=1){wb(i+8|0);j[e>>2]=0;c=0;a:{while(1){if((g|0)==(h|0)|c){break a}b:{if(yj(i+24|0,i+16|0)){break b}c:{if((Yl(k,j[g>>2])|0)==37){c=g+4|0;if((h|0)==(c|0)){break b}l=0;b=Yl(k,j[c>>2]);d:{if(!((b|0)==69|(b&255)==48)){c=g;break d}if((g+8|0)==(h|0)){break b}l=b;b=Yl(k,j[g+8>>2])}m=i,n=bb[j[j[a>>2]+36>>2]](a,j[i+24>>2],j[i+16>>2],d,e,f,b,l)|0,j[m+24>>2]=n;g=c+8|0;break c}if(zj(k,8192,j[g>>2])){while(1){e:{g=g+4|0;if((h|0)==(g|0)){g=h;break e}if(zj(k,8192,j[g>>2])){continue}}break}while(1){if(!Cq(i+24|0,i+16|0)){break c}if(!zj(k,8192,Kk(i+24|0))){break c}dm(i+24|0);continue}}if((sk(k,Kk(i+24|0))|0)==(sk(k,j[g>>2])|0)){g=g+4|0;dm(i+24|0);break c}j[e>>2]=4}c=j[e>>2];continue}break}j[e>>2]=4}if(yj(i+24|0,i+16|0)){j[e>>2]=j[e>>2]|2}Za=i+32|0;return j[i+24>>2]}a=D()|0;C()|0;wb(i+8|0);G(a|0);z()}function Aua(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,i=0,k=0,l=0,m=0,n=0,o=0,q=0;e=Za-48|0;Za=e;k=j[a+16>>2];f=vf(e+16|0);j[f+8>>2]=a+112;j[f+16>>2]=j[a+128>>2];o=f,q=qf(b+327720|0,j[b+20>>2],(j[a+88>>2]&16384)>>>14|0),j[o+12>>2]=q;b=j[f+16>>2];if(b){o=f,q=uf(a+8|0,b),j[o>>2]=q;j[f+4>>2]=ab}l=j[a+24>>2];m=j[a+20>>2];b=j[a+4>>2];i=j[a>>2];j[e+8>>2]=i;j[e+12>>2]=b;g=j[a+12>>2];j[e>>2]=j[a+8>>2];j[e+4>>2]=g;if(d){while(1){g=0;j[e+40>>2]=i;j[e+44>>2]=n;i=b+k|0;a:{b=j[f+16>>2];if((b|0)<=0){break a}while(1){id(j[f+8>>2],h[i+g|0]<<6);hd(j[f+8>>2],4);Bb(e+40|0,f);if((b|0)<2){break a}b=b-1|0;g=j[e+44>>2];continue}}d=d-1|0;b=j[f+8>>2];Bb(b,b+8|0);b=j[f+8>>2];g=j[b+4>>2];if(g){id(b,h[i+j[e+44>>2]|0]<<6);hd(j[f+8>>2],g);b=j[f+8>>2];g=j[b>>2];j[b>>2]=g;j[b+4>>2]=0}b=pf(b,j[f+12>>2]);j[c>>2]=j[c>>2]+p(b,m);j[c+4>>2]=j[c+4>>2]+p(b,l);Bb(e+8|0,e);if(d){c=c+8|0;i=j[e+8>>2];b=j[e+12>>2];continue}break}i=j[e+8>>2];b=j[e+12>>2]}j[a>>2]=i;j[a+4>>2]=b;Za=e+48|0}function $x(a,b){a=a|0;b=b|0;a:{b:{switch((k[a+3|0]|64)+ -64|0){case 0:h[a+3|0]=k[a+5|0]?42:0;return;case 1:h[a+3|0]=16;return;case 2:h[a+3|0]=12;return;case 3:h[a+3|0]=14;if(b){break a}b=a;a=k[a+5|0];h[b+5|0]=p(a>>>4|0,10)+(a&15);return;case 4:h[a+3|0]=11;return;case 5:h[a+3|0]=3;return;case 6:h[a+3|0]=2;return;case 7:h[a+3|0]=4;return;case 8:h[a+3|0]=5;return;case 9:h[a+3|0]=18;return;case 10:h[a+3|0]=1;return;case 11:h[a+3|0]=7;return;case 12:h[a+3|0]=6;return;case 13:h[a+3|0]=21;return;case 14:h[a+3|0]=22;return;case 15:h[a+3|0]=10;return;case 16:h[a+3|0]=29;return;case 17:h[a+3|0]=15;return;case 18:h[a+3|0]=8;return;case 19:h[a+3|0]=20;return;case 20:h[a+3|0]=17;return;case 21:h[a+3|0]=26;return;case 22:h[a+3|0]=23;return;case 23:h[a+3|0]=24;return;case 24:h[a+3|0]=9;return;case 25:h[a+3|0]=27;return;case 26:h[a+3|0]=31;return;case 28:h[a+3|0]=b?32:31;return;case 29:h[a+3|0]=33;return;case 27:h[a+3|0]=34;return;default:break b}}h[a+3|0]=0}}function Nua(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;f=Za-32|0;Za=f;l=j[a+24>>2];m=j[a+20>>2];n=j[a+16>>2];k=j[a+4>>2];e=k;g=j[a>>2];j[f+24>>2]=g;j[f+28>>2]=e;k=j[a+12>>2];j[f+16>>2]=j[a+8>>2];j[f+20>>2]=k;k=a;if(d){while(1){h=((((e&2147483647)<<1|g>>>31)&2147483646)<<1)+n|0;a=(((g>>>16|0)+4&131064)<<1)+b|0;o=i[a+38>>1];q=i[a+36>>1];r=i[a+34>>1];s=i[a+32>>1];t=i[a+30>>1];u=i[a+28>>1];v=i[a+26>>1];w=i[a+24>>1];g=0;a=1;while(1){e=g<<1;j[(f+8|0)+(g<<2)>>2]=(((((p(i[(e|8)+h>>1],r)+p(i[(e|4)+h>>1],s)|0)+p(i[(e|12)+h>>1],q)|0)+p(i[(e|16)+h>>1],o)|0)/2|0)+((((p(i[(e|-8)+h>>1],v)+p(i[(e|-12)+h>>1],w)|0)+p(i[(e|-4)+h>>1],u)|0)+p(i[e+h>>1],t)|0)/2|0)|0)/16384;e=a;a=0;g=1;if(e){continue}break}j[c>>2]=j[c>>2]+p(j[f+8>>2],m);j[c+4>>2]=j[c+4>>2]+p(j[f+12>>2],l);Bb(f+24|0,f+16|0);d=d-1|0;if(d){c=c+8|0;g=j[f+24>>2];e=j[f+28>>2];continue}break}g=j[f+24>>2];e=j[f+28>>2]}j[k>>2]=g;j[k+4>>2]=e;Za=f+32|0}function c3(a,b){var c=0,d=0,e=0,f=0,g=0,h=0,i=0;c=Za-32|0;Za=c;j[114630]=0;g=E(15,c+24|0,a|0)|0;d=j[114630];j[114630]=0;a:{b:{c:{if((d|0)!=1){d:{if(!k[g|0]){break d}hc(c+16|0,j[j[a>>2]-12>>2]+a|0);j[114630]=0;d=H(2386,c+16|0)|0;e=j[114630];j[114630]=0;e:{f:{if((e|0)!=1){wb(c+16|0);e=uk(c+8|0,a);f=j[j[a>>2]-12>>2];j[114630]=0;f=a+f|0;h=H(16,f|0)|0;i=j[114630];j[114630]=0;if((i|0)==1){break f}e=j[e>>2];j[114630]=0;b=U(2387,d|0,e|0,f|0,h|0,b|0)|0;d=j[114630];j[114630]=0;if((d|0)==1){break f}j[c+16>>2]=b;if(!tk(c+16|0)){break d}b=j[j[a>>2]-12>>2];j[114630]=0;F(18,a+b|0,5);b=j[114630];j[114630]=0;if((b|0)!=1){break d}b=J(0)|0;C()|0;break e}b=J(0)|0;C()|0;wb(c+16|0);break e}b=J(0)|0;C()|0}nf(g);break c}nf(g);break b}b=J(0)|0;C()|0}O(b|0)|0;b=j[j[a>>2]-12>>2];j[114630]=0;N(19,a+b|0);a=j[114630];j[114630]=0;if((a|0)==1){break a}Q()}Za=c+32|0;return}a=D()|0;C()|0;j[114630]=0;M(20);b=j[114630];j[114630]=0;if((b|0)!=1){G(a|0);z()}J(0)|0;C()|0;ib();z()}function bv(a,b){var c=0,d=0,e=0,f=0,g=0,h=0,i=0;c=Za-32|0;Za=c;j[114630]=0;g=E(15,c+24|0,a|0)|0;d=j[114630];j[114630]=0;a:{b:{c:{if((d|0)!=1){d:{if(!k[g|0]){break d}hc(c+16|0,j[j[a>>2]-12>>2]+a|0);j[114630]=0;d=H(2386,c+16|0)|0;e=j[114630];j[114630]=0;e:{f:{if((e|0)!=1){wb(c+16|0);e=uk(c+8|0,a);f=j[j[a>>2]-12>>2];j[114630]=0;f=a+f|0;h=H(16,f|0)|0;i=j[114630];j[114630]=0;if((i|0)==1){break f}e=j[e>>2];j[114630]=0;b=U(2388,d|0,e|0,f|0,h|0,b|0)|0;d=j[114630];j[114630]=0;if((d|0)==1){break f}j[c+16>>2]=b;if(!tk(c+16|0)){break d}b=j[j[a>>2]-12>>2];j[114630]=0;F(18,a+b|0,5);b=j[114630];j[114630]=0;if((b|0)!=1){break d}b=J(0)|0;C()|0;break e}b=J(0)|0;C()|0;wb(c+16|0);break e}b=J(0)|0;C()|0}nf(g);break c}nf(g);break b}b=J(0)|0;C()|0}O(b|0)|0;b=j[j[a>>2]-12>>2];j[114630]=0;N(19,a+b|0);a=j[114630];j[114630]=0;if((a|0)==1){break a}Q()}Za=c+32|0;return}a=D()|0;C()|0;j[114630]=0;M(20);b=j[114630];j[114630]=0;if((b|0)!=1){G(a|0);z()}J(0)|0;C()|0;ib();z()}function _2(a,b){var c=0,d=0,e=0,f=0,g=0,h=0,i=0;d=Za-32|0;Za=d;j[114630]=0;g=E(15,d+24|0,a|0)|0;c=j[114630];j[114630]=0;a:{b:{c:{if((c|0)!=1){d:{if(!k[g|0]){break d}hc(d+16|0,j[j[a>>2]-12>>2]+a|0);j[114630]=0;c=H(2386,d+16|0)|0;e=j[114630];j[114630]=0;e:{f:{if((e|0)!=1){wb(d+16|0);e=uk(d+8|0,a);f=j[j[a>>2]-12>>2];j[114630]=0;f=a+f|0;h=H(16,f|0)|0;i=j[114630];j[114630]=0;if((i|0)==1){break f}e=j[e>>2];j[114630]=0;c=Ma(2390,c|0,e|0,f|0,h|0,+b)|0;e=j[114630];j[114630]=0;if((e|0)==1){break f}j[d+16>>2]=c;if(!tk(d+16|0)){break d}c=j[j[a>>2]-12>>2];j[114630]=0;F(18,a+c|0,5);c=j[114630];j[114630]=0;if((c|0)!=1){break d}c=J(0)|0;C()|0;break e}c=J(0)|0;C()|0;wb(d+16|0);break e}c=J(0)|0;C()|0}nf(g);break c}nf(g);break b}c=J(0)|0;C()|0}O(c|0)|0;c=j[j[a>>2]-12>>2];j[114630]=0;N(19,a+c|0);a=j[114630];j[114630]=0;if((a|0)==1){break a}Q()}Za=d+32|0;return}a=D()|0;C()|0;j[114630]=0;M(20);d=j[114630];j[114630]=0;if((d|0)!=1){G(a|0);z()}J(0)|0;C()|0;ib();z()}function Gi(a,b,c,d,e,f,g,i){var k=0,l=0,m=0,n=0,o=0;k=Za-32|0;Za=k;j[k+16>>2]=c;j[k+24>>2]=b;hc(k+8|0,d);j[114630]=0;l=H(21,k+8|0)|0;b=j[114630];j[114630]=0;if((b|0)!=1){wb(k+8|0);j[e>>2]=0;c=0;a:{while(1){if((g|0)==(i|0)|c){break a}b:{if(Ji(k+24|0,k+16|0)){break b}c:{if((Zl(l,h[g|0])|0)==37){c=g+1|0;if((i|0)==(c|0)){break b}m=0;b=Zl(l,h[c|0]);d:{if(!((b|0)==69|(b&255)==48)){c=g;break d}if((g+2|0)==(i|0)){break b}m=b;b=Zl(l,h[g+2|0])}n=k,o=bb[j[j[a>>2]+36>>2]](a,j[k+24>>2],j[k+16>>2],d,e,f,b,m)|0,j[n+24>>2]=o;g=c+2|0;break c}if(ng(l,8192,h[g|0])){while(1){e:{g=g+1|0;if((i|0)==(g|0)){g=i;break e}if(ng(l,8192,h[g|0])){continue}}break}while(1){if(!Xn(k+24|0,k+16|0)){break c}if(!ng(l,8192,Bj(k+24|0))){break c}Mk(k+24|0);continue}}if((Tu(l,Bj(k+24|0))|0)==(Tu(l,h[g|0])|0)){g=g+1|0;Mk(k+24|0);break c}j[e>>2]=4}c=j[e>>2];continue}break}j[e>>2]=4}if(Ji(k+24|0,k+16|0)){j[e>>2]=j[e>>2]|2}Za=k+32|0;return j[k+24>>2]}a=D()|0;C()|0;wb(k+8|0);G(a|0);z()}function fva(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,k=0,l=0,m=0,n=0;f=Za-16|0;Za=f;a:{b:{c:{h=j[a+8>>2];g=j[a+12>>2];d:{if((g|0)<1?1:(g|0)<=1?h>>>0<=805306368:0){if((g|0)>-2?1:(g|0)>=-2?h>>>0>=3489660928:0){break c}if((g|0)>-2?1:(g|0)>=-2?h>>>0>2147483647:0){break d}break b}if((g|0)>1?1:(g|0)>=1?h>>>0>2147483648:0){break b}}k=b+196648|0;break a}k=b+131112|0;break a}k=b+262184|0}l=j[a+16>>2];m=j[a+24>>2];n=j[a+20>>2];b=j[a+4>>2];e=j[a>>2];j[f+8>>2]=e;j[f+12>>2]=b;j[f>>2]=h;j[f+4>>2]=g;if(d){while(1){b=(b<<1)+l|0;e=(e>>>16&65520)+k|0;b=(((((((p(i[b-4>>1],i[e+2>>1])+p(i[b-6>>1],i[e>>1])|0)+p(i[b-2>>1],i[e+4>>1])|0)+p(i[b>>1],i[e+6>>1])|0)+p(i[b+2>>1],i[e+8>>1])|0)+p(i[b+4>>1],i[e+10>>1])|0)+p(i[b+6>>1],i[e+12>>1])|0)+p(i[b+8>>1],i[e+14>>1])|0)/32768|0;j[c>>2]=j[c>>2]+p(b,n);j[c+4>>2]=j[c+4>>2]+p(b,m);Bb(f+8|0,f);d=d-1|0;if(d){c=c+8|0;e=j[f+8>>2];b=j[f+12>>2];continue}break}e=j[f+8>>2];b=j[f+12>>2]}j[a>>2]=e;j[a+4>>2]=b;Za=f+16|0}function kj(a,b){var c=0,d=0,e=0,f=0,g=0,h=0,i=0,k=0;c=Za-80|0;Za=c;d=j[a+28>>2];mn(j[j[d>>2]-12>>2]+d|0,0);if(!gd(a,4)){Iu(a)}a:{if(!j[a+4>>2]){break a}if(gd(a,6)){break a}if(gd(a,7)){break a}h=j[a+28>>2];f=j[a+84>>2];g=p(j[a+20>>2],j[a+4>>2]);e=g+j[a+80>>2]|0;e=sg(c- -64|0,e,e>>>0<g>>>0?f+1|0:f);g=j[e+12>>2];j[c+24>>2]=j[e+8>>2];j[c+28>>2]=g;d=j[e+4>>2];j[c+16>>2]=j[e>>2];j[c+20>>2]=d;Hi(h,c+16|0)}b:{if(!gd(a,5)){break b}i=a+44|0;e=Zc(i);if(!e){break b}h=a+32|0;while(1){c:{f=(j[a+96>>2]+k>>>0)%(e>>>0)|0;if(m[$b(i,f)>>2]>=tc(h)>>>0){break c}g=Vl(c+48|0,fc(h,j[$b(i,f)>>2]),l[$b(i,f)+12>>1]);d=Nu(b,g);qb(g);if(!d){break c}j[a+96>>2]=(f+1>>>0)%(e>>>0);if(j[$b(i,f)+4>>2]){g=j[a+28>>2];d=j[a+12>>2];b=j[a+8>>2];a=j[$b(i,f)+4>>2];h=b+a|0;d=sg(c+32|0,h,a>>>0>h>>>0?d+1|0:d);a=j[d+12>>2];j[c+8>>2]=j[d+8>>2];j[c+12>>2]=a;a=j[d+4>>2];j[c>>2]=j[d>>2];j[c+4>>2]=a;Hi(g,c)}k=$b(i,f);break b}k=k+1|0;if((e|0)!=(k|0)){continue}break}k=0}Za=c+80|0;return k}function _i(a){a=a|0;var b=0;a:{b:{switch(k[a+3|0]){case 0:if(!k[a+5|0]){break a}h[a+3|0]=1;return;case 1:h[a+3|0]=2;return;case 2:h[a+3|0]=3;return;case 3:h[a+3|0]=4;return;case 4:h[a+3|0]=5;return;case 5:h[a+3|0]=6;return;case 6:h[a+3|0]=7;return;case 7:h[a+3|0]=8;return;case 8:h[a+3|0]=9;return;case 9:h[a+3|0]=10;return;case 10:h[a+3|0]=11;return;case 11:h[a+3|0]=12;return;case 12:h[a+3|0]=13;return;case 13:h[a+3|0]=14;b=a;a=k[a+5|0];h[b+5|0]=p(a>>>4|0,10)+(a&15);return;case 14:h[a+3|0]=19;return;case 15:if(k[a+5|0]<=31){h[a+3|0]=16;return}h[a+3|0]=17;return;case 16:h[a+3|0]=23;return;case 17:h[a+3|0]=24;return;case 20:h[a+3|0]=25;return;case 21:h[a+3|0]=30;return;case 25:h[a+3|0]=29;return;case 27:h[a+3|0]=15;return;case 29:h[a+3|0]=18;return;case 32:h[a+3|0]=42;return;case 33:h[a+3|0]=28;return;case 34:h[a+3|0]=27;return;case 35:h[a+3|0]=31;return;case 36:h[a+3|0]=32;return;case 38:h[a+3|0]=34;return;default:break b}}h[a+3|0]=0}}function pU(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0;d=Za-80|0;Za=d;rc(b);cq(a);a:{if(!Vt(b,d+40|0)){break a}if(!BA(d+40|0)){break a}b:{if(!c){break b}c=d+40|4;e=k[c|0]|k[c+1|0]<<8|(k[c+2|0]<<16|k[c+3|0]<<24);if(!yb(b,(e<<24|e<<8&16711680|(e>>>8&65280|e>>>24))-28|0)){break a}nu(a);mu(d+24|0);lu(zg(a)+28|0,d+24|0);bq(d+24|0);e=j[zg(a)+28>>2];j[114630]=0;f=H(350,b|0)|0;b=j[114630];j[114630]=0;c:{if((b|0)==1){break c}c=k[c|0]|k[c+1|0]<<8|(k[c+2|0]<<16|k[c+3|0]<<24);b=k[d+52|0]|k[d+53|0]<<8|(k[d+54|0]<<16|k[d+55|0]<<24);j[114630]=0;c=P(351,f|0,(c<<8&16711680|c<<24|(c>>>8&65280|c>>>24))-28|0,e|0,b<<8&16711680|b<<24|(b>>>8&65280|b>>>24))|0;b=j[114630];j[114630]=0;if((b|0)==1){break c}f=0;if(!c){break a}yi(d+8|0,e);iu(d+16|0,d+8|0);b=Hn(d+24|0,d+16|0,0);Ed(zg(a)+12|0,b);jb(b);break b}b=qa(71412,77432)|0;a=C()|0;d:{if((W(71412)|0)==(a|0)){break d}if((W(77432)|0)==(a|0)){break d}G(b|0);z()}O(b|0)|0;Q();f=0;break a}f=1}Za=d+80|0;return f|0}function $Ba(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0;e=Za-16|0;Za=e;h[e+15|0]=8;i[e+12>>1]=0;j[e+8>>2]=0;if(d){r=p(c,d);c=0;while(1){if((r|0)>=1){n=(q<<1)+b|0;s=n+(r<<1)|0;while(1){t=c;i[e+6>>1]=0;SO(a,e+14|0,e+12|0,e+15|0,e+6|0);a:{b:{m=k[e+15|0];if(!m){break b}c=l[e+12>>1];while(1){f=c<<1;c=f&254;i[e+12>>1]=c;g=(f&65534)>>>0>255;h[e+14|0]=g;f=e;if(!c){if(!re(a,e+5|0)){break b}g=k[e+5|0];c=g<<1&254|1;i[e+12>>1]=c;g=g>>>7|0}o=l[e+6>>1]<<1|g;i[f+6>>1]=o;m=m-1|0;if(m&255){continue}break}break a}o=l[e+6>>1]}c=1;g=o&65535;c:{if(g>>>0<4){break c}m=15;while(1){c=m;f=c&255;if(f>>>0<2){break c}m=c-1|0;if(!(1<<f&g)){continue}break}}h[e+15|0]=(k[e+15|0]+c&254)>>>1;c=o&1;h[e+14|0]=c;f=c-1^(o&65534)>>>1;c=f+l[e+8>>1]|0;i[e+6>>1]=c;i[n>>1]=c;j[e+8>>2]=((f>>1)-(t<<16>>16)|0)+(c<<16>>16<<1);Md(e+8|0,-32768,32767);n=(d<<1)+n|0;if(s>>>0>n>>>0){continue}break}}q=q+1|0;if((q|0)!=(d|0)){continue}break}}Za=e+16|0}function gva(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,k=0,l=0,m=0,n=0,o=0;f=Za-16|0;Za=f;a:{b:{c:{k=j[a+8>>2];g=j[a+12>>2];d:{if((g|0)<1?1:(g|0)<=1?k>>>0<=805306368:0){if((g|0)>-2?1:(g|0)>=-2?k>>>0>=3489660928:0){break c}if((g|0)>-2?1:(g|0)>=-2?k>>>0>2147483647:0){break d}break b}if((g|0)>1?1:(g|0)>=1?k>>>0>2147483648:0){break b}}l=b+196648|0;break a}l=b+131112|0;break a}l=b+262184|0}m=j[a+16>>2];n=j[a+24>>2];o=j[a+20>>2];b=j[a+4>>2];e=j[a>>2];j[f+8>>2]=e;j[f+12>>2]=b;j[f>>2]=k;j[f+4>>2]=g;if(d){while(1){b=b+m|0;e=(e>>>16&65520)+l|0;b=(((((((p(h[b-2|0],i[e+2>>1])+p(h[b-3|0],i[e>>1])|0)+p(h[b-1|0],i[e+4>>1])|0)+p(h[b|0],i[e+6>>1])|0)+p(h[b+1|0],i[e+8>>1])|0)+p(h[b+2|0],i[e+10>>1])|0)+p(h[b+3|0],i[e+12>>1])|0)+p(h[b+4|0],i[e+14>>1])<<8)/32768|0;j[c>>2]=j[c>>2]+p(b,o);j[c+4>>2]=j[c+4>>2]+p(b,n);Bb(f+8|0,f);d=d-1|0;if(d){c=c+8|0;e=j[f+8>>2];b=j[f+12>>2];continue}break}e=j[f+8>>2];b=j[f+12>>2]}j[a>>2]=e;j[a+4>>2]=b;Za=f+16|0}function Tm(a,b,c){var d=0,e=0;e=Za-16|0;Za=e;h[a+861|0]=0;j[a+708>>2]=0;j[a+656>>2]=0;j[a+104>>2]=0;h[a+819|0]=0;j[a+804>>2]=0;j[a+824>>2]=0;j[a+696>>2]=0;j[a+668>>2]=0;j[a+88>>2]=j[a+88>>2]|6144;mb(e+8|0,b+1074308|0,23);if(kb(e+8|0)){i[a+798>>1]=0;i[a+800>>1]=1}h[a+866|0]=0;h[a+859|0]=0;h[a+871|0]=255;j[a+660>>2]=0;h[a+872|0]=k[a+872|0]&252;ys(a+810|0);j[a+84>>2]=0;j[a+76>>2]=0;j[a+80>>2]=0;j[a+700>>2]=0;j[a+656>>2]=0;j[a+104>>2]=0;j[a+92>>2]=0;j[a+96>>2]=0;j[a>>2]=0;j[a+4>>2]=0;h[a+865|0]=0;h[a+858|0]=0;j[a+688>>2]=0;j[a+672>>2]=0;j[a+676>>2]=0;i[a+840>>1]=0;h[a+839|0]=0;i[a+856>>1]=32512;i[a+862>>1]=0;j[a+20>>2]=0;j[a+24>>2]=0;j[a+8>>2]=0;j[a+12>>2]=0;j[a+28>>2]=0;j[a+32>>2]=0;j[a+876>>2]=0;j[a+880>>2]=0;h[a+872|0]=k[a+872|0]&243;a:{if(c>>>0>126){c=64;b=128;d=0;break a}d=(c<<5)+b|0;c=l[d+480286>>1];b=l[d+480284>>1];d=j[d+480280>>2]}i[a+796>>1]=0;j[a+760>>2]=c;j[a+692>>2]=b;j[a+88>>2]=d;h[a+817|0]=0;h[a+818|0]=0;Za=e+16|0}function SE(a){var b=0,c=0,d=0,e=0,f=0,g=0,i=0,l=0;b=j[a+32>>2];a:{b:{c:{c=j[a+1380>>2];d:{if((c|0)==-1){i=1;c=-1;break d}d=j[a+1116>>2];e:{if((d|0)<=(c|0)){break e}while(1){e=k[(a+c|0)+1120|0];b=e+b|0;if((e|0)!=255){break e}c=c+1|0;if((d|0)>(c|0)){continue}break}}if(m[a+40>>2]<b>>>0){break c}c=(c|0)==(d|0)?-1:c}while(1){if((c|0)!=-1){return 1}g=j[a+40>>2];if(g>>>0<=b+26>>>0){Nb(a,1);break a}if((k[b|0]|k[b+1|0]<<8|(k[b+2|0]<<16|k[b+3|0]<<24))!=(k[84688]|k[84689]<<8|(k[84690]<<16|k[84691]<<24))){Nb(a,21);break a}if(k[b+4|0]){Nb(a,21);break a}f:{if(i){if(!j[a+992>>2]|!(h[b+5|0]&1)){break f}Nb(a,21);break a}if(h[b+5|0]&1){break f}Nb(a,21);break a}d=b+27|0;e=k[b+26|0];b=d+e|0;if(g>>>0<b>>>0){break b}i=0;c=0;f=0;g:{if(!e){break g}while(1){l=k[c+d|0];b=l+b|0;f=c;if((l|0)!=255){break g}c=c+1|0;if((e|0)!=(c|0)){continue}break}f=e}d=f;c=(d|0)==(e|0)?-1:d;if(b>>>0<=g>>>0){continue}break}Nb(a,1);break a}Nb(a,1);break a}Nb(a,1)}return 0}function oL(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,n=0,o=0,p=0;e=Za-96|0;Za=e;h[e+95|0]=d;d=0;n=Jo(a);o=Wi(n);i[b>>1]=0;a:{if(o){while(1){p=l[bc(n,d&65535)>>1];b:{if(!tg(j[a+24>>2]+484344|0,p)){break b}d=l[b>>1];if(ec(a)>>>0<=d>>>0){j[c>>2]=0;a=1;break a}f=ad(a,l[b>>1]);Zi(e+72|0,f);Xj(e- -64|0,f);d=j[e+76>>2];j[e+32>>2]=j[e+72>>2];j[e+36>>2]=d;d=j[e+68>>2];j[e+24>>2]=j[e+64>>2];j[e+28>>2]=d;jra(e+80|0,e+32|0,e+24|0,e+95|0);d=c;c:{if(k[e+95|0]){Xj(e+56|0,f);g=0;if(nL(e+80|0,e+56|0)){break c}if(k[e+95|0]){break b}}Xj(e+56|0,f);if(nL(e+80|0,e+56|0)^1){Zi(e+48|0,f);a=j[e+84>>2];b=j[e+80>>2];j[e+40>>2]=b;j[e+44>>2]=a;c=j[e+52>>2];j[e+16>>2]=j[e+48>>2];j[e+20>>2]=c;j[e+8>>2]=b;j[e+12>>2]=a;g=xN(e+16|0,e+8|0);break c}if(m[f+4>>2]>=m[Hb(j[a+24>>2]+484344|0,p)+12>>2]){break b}g=j[f+4>>2]}j[d>>2]=g;a=1;break a}d=l[b>>1]+1|0;i[b>>1]=d;if((d&65535)>>>0<o>>>0){continue}break}}i[b>>1]=65535;j[c>>2]=-1;a=0}Za=e+96|0;return a|0}function dia(a,b,c,d){var e=0,f=0,g=0,h=0,k=0;e=Za-48|0;Za=e;j[e+44>>2]=0;gi(b,e+44|0);a:{b:{if(j[e+44>>2]!=(ok(32545)|0)){break b}j[e+40>>2]=0;gi(b,e+40|0);k=-1;f=j[e+40>>2];if(f-1>>>0>1){break b}c:{d:{e:{if((f|0)<=1){f=Cb(e+24|0);j[114630]=0;g=K(721,b|0,f|0,256)|0;h=j[114630];j[114630]=0;if((h|0)==1){break a}if(!g){break d}j[114630]=0;I(13,e+8|0,d|0,f|0);g=j[114630];j[114630]=0;if((g|0)!=1){break e}break a}f=Cb(e+24|0);j[114630]=0;g=K(723,b|0,f|0,255)|0;h=j[114630];j[114630]=0;if((h|0)==1){break a}if(!g){break c}j[114630]=0;I(13,e+8|0,d|0,f|0);g=j[114630];j[114630]=0;if((g|0)==1){break a}}ob(c,e+8|0);gb(e+8|0);gb(f);c=0;i[e+8>>1]=0;cf(b,e+8|0);j[e+24>>2]=0;gi(b,e+24|0);f=j[e+24>>2];if(f>>>0>50){break b}if(f){while(1){if(!cI(a,b,d)){break b}c=c+1|0;if(c>>>0<m[e+24>>2]){continue}break}}j[e+24>>2]=0;gi(b,e+24|0);k=j[e+24>>2]==(ok(32550)|0)?1:-1;break b}gb(f);break b}gb(f)}Za=e+48|0;return k}a=D()|0;C()|0;gb(f);G(a|0);z()}function Oua(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;f=Za-32|0;Za=f;m=j[a+24>>2];n=j[a+20>>2];o=j[a+16>>2];k=j[a+4>>2];l=k;e=j[a>>2];j[f+24>>2]=e;j[f+28>>2]=k;k=j[a+12>>2];j[f+16>>2]=j[a+8>>2];j[f+20>>2]=k;k=a;if(d){while(1){g=(((l&2147483647)<<1|e>>>31)&-2)+o|0;a=(((e>>>16|0)+4&131064)<<1)+b|0;q=i[a+38>>1];r=i[a+36>>1];s=i[a+34>>1];t=i[a+32>>1];u=i[a+30>>1];v=i[a+28>>1];w=i[a+26>>1];x=i[a+24>>1];e=0;a=1;while(1){j[(f+8|0)+(e<<2)>>2]=(((((p(h[(e|4)+g|0],s)+p(h[(e|2)+g|0],t)|0)+p(h[(e|6)+g|0],r)|0)+p(h[(e|8)+g|0],q)<<8)/2|0)+((((p(h[(e|-4)+g|0],w)+p(h[(e|-6)+g|0],x)|0)+p(h[(e|-2)+g|0],v)|0)+p(h[e+g|0],u)<<8)/2|0)|0)/16384;l=a;a=0;e=1;if(l){continue}break}j[c>>2]=j[c>>2]+p(j[f+8>>2],n);j[c+4>>2]=j[c+4>>2]+p(j[f+12>>2],m);Bb(f+24|0,f+16|0);d=d-1|0;if(d){c=c+8|0;e=j[f+24>>2];l=j[f+28>>2];continue}break}e=j[f+24>>2];l=j[f+28>>2]}j[k>>2]=e;j[k+4>>2]=l;Za=f+32|0}function Qea(a){var b=q(0),c=q(0),d=q(0),e=0,f=q(0),g=q(0),i=q(0),k=q(0),l=q(0),m=q(0),o=q(0),p=0,r=q(0);e=Za-16|0;Za=e;c=qg(a,5);f=qg(a,11);d=q(c*qg(a,4));k=q(q(d*q(.03999999910593033))+q(c*q(.02250000089406967)));c=q(f*qg(a,10));f=q(q(c*q(.03999999910593033))+q(f*q(.02250000089406967)));if(h[a+4264|0]&1){b=qg(a,3);g=qg(a,9);b=q(b*d);d=q(qg(a,2)*b);k=q(q(q(b*q(.12250000238418579))+k)+q(d*q(.1444000005722046)));b=q(g*c);c=q(qg(a,8)*b);f=q(q(q(b*q(.12250000238418579))+f)+q(c*q(.1444000005722046)))}qg(a,12);b=n[a+4496>>2];g=qg(a,1);i=qg(a,7);m=qg(a,0);o=qg(a,6);p=e,r=Yd(q(10),q(q(YG(a)+q(q(n[a+4236>>2]*q(12e3))+q(-1e4)))*q(.0005000000237487257))),n[p+12>>2]=r;j[e+8>>2]=1065353216;l=n[Vk(e+12|0,e+8|0)>>2];b=q(b*b);c=q(i*q(b*c));i=q(o*c);d=q(g*q(b*d));b=q(m*d);g=q(q(q(i+b)*q(-.5))+q(1));n[a+4284>>2]=l*q(y(q(g/q(q(q(b+c)*q(.1444000005722046))+k))));n[a+4288>>2]=l*q(y(q(g/q(q(q(i+d)*q(.1444000005722046))+f))));Za=e+16|0}function Fha(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=q(0),h=0,i=0,k=0,l=0,m=0,o=0,p=q(0),s=q(0),t=q(0),u=q(0),v=q(0),w=q(0),x=q(0),y=q(0),z=0,A=0,B=q(0);if(j[a+4220>>2]){f=a+44|0;i=wd(f,0);k=wd(f,1);l=Rc(f,0);m=Rc(f,1);if(d){h=a+4208|0;e=j[a+4224>>2];o=d;while(1){p=n[k>>2];s=n[i>>2];z=h;e=e-j[a+4228>>2]|0;if((e|0)<=-1){e=e+j[a+4220>>2]|0}e=e<<1;t=n[xb(z,e)>>2];e=xb(h,e|1);v=n[a+4248>>2];w=n[a+4256>>2];x=n[a+4252>>2];y=n[a+4244>>2];u=n[e>>2];g=q(q(q(q(p*v)+q(s*w))+q(t*x))+q(y*u));A=xb(h,j[a+4224>>2]<<1),B=q(r(g))<q(1.0000000195414814e-24)?q(0):g,n[A>>2]=B;g=q(q(q(q(v*s)+q(w*p))+q(x*u))+q(y*t));A=xb(h,j[a+4224>>2]<<1|1),B=q(r(g))<q(1.0000000195414814e-24)?q(0):g,n[A>>2]=B;e=j[a+4224>>2]+1|0;e=(e|0)==j[a+4220>>2]?0:e;j[a+4224>>2]=e;n[l>>2]=q(t*n[a+4236>>2])+q(s*n[a+4240>>2]);n[m>>2]=q(u*n[a+4236>>2])+q(p*n[a+4240>>2]);m=m+4|0;l=l+4|0;k=k+4|0;i=i+4|0;o=o-1|0;if(o){continue}break}}Sh(a,b,c,Rc(f,0),Rc(f,1),d)}}function Hi(a,b){var c=0,d=0,e=0,f=0;c=Za+ -64|0;Za=c;d=j[(j[j[a>>2]-12>>2]+a|0)+16>>2]&-3;mn(j[j[a>>2]-12>>2]+a|0,d);a:{b:{if(k[Ki(c+56|0,a,1)|0]){e=j[j[a>>2]-12>>2];j[114630]=0;e=j[(a+e|0)+24>>2];f=j[114630];j[114630]=0;c:{d:{if((f|0)==1){break d}j[114630]=0;f=j[b+12>>2];j[c+16>>2]=j[b+8>>2];j[c+20>>2]=f;f=j[b+4>>2];j[c+8>>2]=j[b>>2];j[c+12>>2]=f;L(2381,c+40|0,e|0,c+8|0,8);b=j[114630];j[114630]=0;if((b|0)==1){break d}b=sg(c+24|0,-1,-1);j[114630]=0;b=ZR(c+40|0,b);e=j[114630];j[114630]=0;if((e|0)==1){break d}b=b?d|4:d;break c}b=J(0)|0;C()|0;O(b|0)|0;b=d|1;Ii(j[j[a>>2]-12>>2]+a|0,b);d=j[j[a>>2]-12>>2];j[114630]=0;d=j[(a+d|0)+20>>2];e=j[114630];j[114630]=0;e:{if((e|0)!=1){if(!(d&1)){break e}j[114630]=0;M(81);a=j[114630];j[114630]=0;if((a|0)!=1){break a}}a=D()|0;C()|0;j[114630]=0;M(20);b=j[114630];j[114630]=0;if((b|0)==1){break b}G(a|0);z()}Q()}eg(j[j[a>>2]-12>>2]+a|0,b)}Za=c- -64|0;return}J(0)|0;C()|0;ib()}z()}function yca(a){a=a|0;var b=0,c=0,d=0,e=0,f=0;b=Za-48|0;Za=b;j[114630]=0;N(2010,a|0);c=j[114630];j[114630]=0;a:{b:{c:{d:{e:{f:{g:{h:{if((c|0)!=1){d=Cb(b+32|0);c=j[a+24>>2];j[114630]=0;F(2070,b+16|0,c|0);c=j[114630];j[114630]=0;if((c|0)==1){break h}e=b,f=Lb(b+16|0),j[e+8>>2]=f;e=b,f=Mb(b+16|0),j[e>>2]=f;if(!rb(b+8|0,b)){break f}break g}c=J(0)|0;C()|0;break c}c=J(0)|0;C()|0;break d}while(1){c=j[b+8>>2];j[114630]=0;E(1245,d|0,c|0)|0;c=j[114630];j[114630]=0;if((c|0)==1){break e}cn(b+8|0);e=b,f=Mb(b+16|0),j[e>>2]=f;if(!rb(b+8|0,b)){break f}j[114630]=0;E(1990,d|0,34201)|0;c=j[114630];j[114630]=0;if((c|0)!=1){continue}break}break e}c=Gd(zb(d));Vc(b+16|0);gb(d);break b}c=J(0)|0;C()|0;Vc(b+16|0)}gb(d)}O(c|0)|0;c=0;j[114630]=0;L(1984,36905,a|0,0,0);a=j[114630];j[114630]=0;if((a|0)==1){break a}Q()}Za=b+48|0;return c|0}a=D()|0;C()|0;j[114630]=0;M(20);b=j[114630];j[114630]=0;if((b|0)!=1){G(a|0);z()}J(0)|0;C()|0;ib();z()}function pla(a,b,c){var d=0,e=0,f=0,g=0,h=0;f=Za-16|0;Za=f;g=Ng(a);a=c+16|0;a=k[a|0]|k[a+1|0]<<8|(k[a+2|0]<<16|k[a+3|0]<<24);j[114630]=0;a=E(256,b|0,a|0)|0;d=j[114630];j[114630]=0;a:{b:{c:{if((d|0)==1){break c}d:{e:{f:{if(!a){break f}a=c+12|0;d=k[a|0]|k[a+1|0]<<8|(k[a+2|0]<<16|k[a+3|0]<<24);j[114630]=0;F(1527,g|0,d|0);d=j[114630];j[114630]=0;if((d|0)==1){break c}if(!(k[a|0]|k[a+1|0]<<8|(k[a+2|0]<<16|k[a+3|0]<<24))){break f}d=c+4|0;c=0;while(1){j[114630]=0;e=E(258,b|0,4)|0;h=j[114630];j[114630]=0;if((h|0)==1){break b}if(!e){break f}e=k[d|0]|k[d+1|0]<<8;j[114630]=0;I(1528,f|0,b|0,e|0);e=j[114630];j[114630]=0;if((e|0)==1){break e}j[114630]=0;F(1529,g|0,f|0);e=j[114630];j[114630]=0;if((e|0)==1){break d}gb(f);c=c+1|0;if(c>>>0<(k[a|0]|k[a+1|0]<<8|(k[a+2|0]<<16|k[a+3|0]<<24))>>>0){continue}break}}Za=f+16|0;return}a=D()|0;C()|0;break a}a=D()|0;C()|0;gb(f);break a}a=D()|0;C()|0;break a}a=D()|0;C()|0}Vc(g);G(a|0);z()}function fda(a){a=a|0;var b=0,c=0,d=0,e=0,f=0;b=Za-48|0;Za=b;j[114630]=0;N(2010,a|0);c=j[114630];j[114630]=0;a:{b:{c:{d:{e:{f:{g:{h:{if((c|0)!=1){d=Cb(b+32|0);c=j[a+24>>2];j[114630]=0;F(2035,b+16|0,c|0);c=j[114630];j[114630]=0;if((c|0)==1){break h}e=b,f=Lb(b+16|0),j[e+8>>2]=f;e=b,f=Mb(b+16|0),j[e>>2]=f;if(!rb(b+8|0,b)){break f}break g}c=J(0)|0;C()|0;break c}c=J(0)|0;C()|0;break d}while(1){c=j[b+8>>2];j[114630]=0;E(1245,d|0,c|0)|0;c=j[114630];j[114630]=0;if((c|0)==1){break e}cn(b+8|0);e=b,f=Mb(b+16|0),j[e>>2]=f;if(!rb(b+8|0,b)){break f}j[114630]=0;E(1990,d|0,34201)|0;c=j[114630];j[114630]=0;if((c|0)!=1){continue}break}break e}c=Gd(zb(d));Vc(b+16|0);gb(d);break b}c=J(0)|0;C()|0;Vc(b+16|0)}gb(d)}O(c|0)|0;c=0;j[114630]=0;L(1984,35662,a|0,0,0);a=j[114630];j[114630]=0;if((a|0)==1){break a}Q()}Za=b+48|0;return c|0}a=D()|0;C()|0;j[114630]=0;M(20);b=j[114630];j[114630]=0;if((b|0)!=1){G(a|0);z()}J(0)|0;C()|0;ib();z()}function vD(a,b,c,d){var e=0,f=0,g=0,h=0,i=0,k=0;h=Za-32|0;Za=h;f=d&2147483647;g=f;e=f-1065418752|0;i=f-1082064896|0;f=c;a:{if((e|0)==(i|0)&f>>>0<f>>>0|e>>>0<i>>>0){g=(d&33554431)<<7|c>>>25;f=0;k=f;i=c&33554431;if(!(!f&(i|0)==16777216?!(a|b):!f&i>>>0<16777216)){e=g+1073741825|0;break a}e=g+1073741824|0;if(i^16777216|a|(b|k)){break a}e=(g&1)+e|0;break a}if(!(!f&(g|0)==2147418112?!(a|b):g>>>0<2147418112)){e=((d&33554431)<<7|c>>>25)&4194303|2143289344;break a}e=2139095040;if(g>>>0>1082064895){break a}e=0;f=g>>>16|0;if(f>>>0<16145){break a}g=c;e=d&65535|65536;We(h+16|0,a,b,g,e,f-16129|0);hm(h,a,b,g,e,16257-f|0);b=j[h+8>>2];e=(j[h+12>>2]&33554431)<<7|b>>>25;g=j[h+4>>2];f=g;a=0;i=a;k=j[h>>2]|((j[h+16>>2]|j[h+24>>2])!=0|(j[h+20>>2]|j[h+28>>2])!=0);b=b&33554431;if(!(!a&(b|0)==16777216?!(f|k):!a&b>>>0<16777216)){e=e+1|0;break a}if(b^16777216|k|(f|i)){break a}e=(e&1)+e|0}Za=h+32|0;return PMa(2,d&-2147483648|e),TMa()}function Wva(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,u=0;h=Za-16|0;Za=h;f=j[a+48>>2];q=j[a+24>>2];r=j[a+20>>2];b=j[a+44>>2];s=j[a+16>>2];k=j[a+4>>2];l=j[a>>2];j[h+8>>2]=l;j[h+12>>2]=k;e=j[a+12>>2];j[h>>2]=j[a+8>>2];j[h+4>>2]=e;a:{if(!d){e=b;b=f;break a}while(1){l=i[(k<<1)+s>>1];g=j[a+60>>2];m=g;e=Gb(b,-16777216,16776704);o=j[a+64>>2];k=Gb(f,-16777216,16776704);t=j[a+72>>2];f=j[c>>2];n=g>>31;l=l<<8;g=l;g=HMa(m,n,g,g>>31);m=ab;n=c;u=f;f=g;g=HMa(o,o>>31,e,e>>31);e=f+g|0;f=ab+m|0;f=e>>>0<g>>>0?f+1|0:f;g=e;e=j[a+68>>2];k=HMa(e,e>>31,k,k>>31);e=g+k|0;f=ab+f|0;f=e>>>0<k>>>0?f+1|0:f;e=e+8388608|0;if(e>>>0<8388608){f=f+1|0}f=(f&16777215)<<8|e>>>24;e=(f|0)/256|0;j[n>>2]=u+p(e,r);j[c+4>>2]=j[c+4>>2]+p(e,q);e=f-(l&t)|0;Bb(h+8|0,h);d=d-1|0;if(d){c=c+8|0;k=j[h+12>>2];f=b;b=e;continue}break}l=j[h+8>>2];k=j[h+12>>2]}j[a+48>>2]=b;j[a+44>>2]=e;j[a>>2]=l;j[a+4>>2]=k;Za=h+16|0}function L6(a,b,c,d){var e=0,f=0,g=0,h=0,i=0,k=0,l=0;g=a;l=a>>31;e=HMa(a,l,1e4,0)+14780|0;a=ab;h=e;a=e>>>0<14780?a+1|0:a;f=a;e=IMa(e,a,-14609700,-1);a=g;i=e+a|0;e=l+ab|0;e=a>>>0>i>>>0?e+1|0:e;k=IMa(h,f,365242500,0);i=k+i|0;a=ab+e|0;a=i>>>0<k>>>0?a+1|0:a;k=IMa(h,f,-146097e4,-1);i=k+i|0;e=ab+a|0;e=i>>>0<k>>>0?e+1|0:e;a=IMa(h,f,3652425,0);f=ab;k=f;h=i;i=HMa(a,f,-365,-1);h=h+i|0;f=ab+e|0;f=h>>>0<i>>>0?f+1|0:f;e=f;if(!((e|0)>0?1:(e|0)>=0)){e=k-(a>>>0<1)|0;a=a-1|0;f=HMa(a,e,-365,-1)+g|0;e=l+ab|0;e=f>>>0<g>>>0?e+1|0:e;g=f;f=(a|0)/-4|0;h=f;g=g+f|0;f=(f>>31)+e|0;f=h>>>0>g>>>0?f+1|0:f;e=g;g=(a|0)/100|0;h=g;e=e+g|0;g=(g>>31)+f|0;g=e>>>0<h>>>0?g+1|0:g;f=e;e=(a|0)/-400|0;h=e;f=f+e|0;e=(e>>31)+g|0;e=f>>>0<h>>>0?e+1|0:e;h=f}k=b;f=a;b=HMa(h,e,100,0)+52|0;a=ab;a=IMa(b,b>>>0<52?a+1|0:a,3060,0);b=a+2|0;g=(b|0)/12|0;j[k>>2]=f+g;j[c>>2]=(b-p(g,12)|0)+1;a=HMa(a,ab,306,0)+5|0;e=ab;a=IMa(a,a>>>0<5?e+1|0:e,-10,-1)+h|0;j[d>>2]=a+1}function Xva(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,i=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,u=0;i=Za-16|0;Za=i;f=j[a+48>>2];q=j[a+24>>2];r=j[a+20>>2];b=j[a+44>>2];s=j[a+16>>2];k=j[a+4>>2];l=j[a>>2];j[i+8>>2]=l;j[i+12>>2]=k;e=j[a+12>>2];j[i>>2]=j[a+8>>2];j[i+4>>2]=e;a:{if(!d){e=b;b=f;break a}while(1){l=h[k+s|0];g=j[a+60>>2];m=g;e=Gb(b,-16777216,16776704);o=j[a+64>>2];k=Gb(f,-16777216,16776704);t=j[a+72>>2];f=j[c>>2];n=g>>31;l=l<<16;g=l;g=HMa(m,n,g,g>>31);m=ab;n=c;u=f;f=g;g=HMa(o,o>>31,e,e>>31);e=f+g|0;f=ab+m|0;f=e>>>0<g>>>0?f+1|0:f;g=e;e=j[a+68>>2];k=HMa(e,e>>31,k,k>>31);e=g+k|0;f=ab+f|0;f=e>>>0<k>>>0?f+1|0:f;e=e+8388608|0;if(e>>>0<8388608){f=f+1|0}f=(f&16777215)<<8|e>>>24;e=(f|0)/256|0;j[n>>2]=u+p(e,r);j[c+4>>2]=j[c+4>>2]+p(e,q);e=f-(l&t)|0;Bb(i+8|0,i);d=d-1|0;if(d){c=c+8|0;k=j[i+12>>2];f=b;b=e;continue}break}l=j[i+8>>2];k=j[i+12>>2]}j[a+48>>2]=b;j[a+44>>2]=e;j[a>>2]=l;j[a+4>>2]=k;Za=i+16|0}function _Ba(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,u=0;e=Za-16|0;Za=e;h[e+15|0]=4;i[e+12>>1]=0;j[e+8>>2]=0;if(d){r=p(c,d);s=(r|0)<1;c=0;while(1){if(!s){n=b+q|0;t=r+n|0;while(1){u=c;h[e+7|0]=0;RO(a,e+14|0,e+12|0,e+7|0);a:{b:{m=k[e+15|0];if(!m){break b}c=l[e+12>>1];while(1){f=c<<1;c=f&254;i[e+12>>1]=c;g=(f&65534)>>>0>255;h[e+14|0]=g;f=e;if(!c){if(!re(a,e+6|0)){break b}g=k[e+6|0];c=g<<1&254|1;i[e+12>>1]=c;g=g>>>7|0}o=k[e+7|0]<<1|g;h[f+7|0]=o;m=m-1|0;if(m&255){continue}break}break a}o=k[e+7|0]}c=1;g=o&255;c:{if(g>>>0<4){break c}m=7;while(1){c=m;f=c&255;if(f>>>0<2){break c}m=c-1|0;if(!(1<<f&g)){continue}break}}h[e+15|0]=(k[e+15|0]+c&254)>>>1;c=o&1;h[e+14|0]=c;f=c-1^(o&254)>>>1;c=f+k[e+8|0]|0;h[e+7|0]=c;h[n|0]=c;j[e+8>>2]=((f>>1)-(u<<24>>24)|0)+(c<<24>>24<<1);Md(e+8|0,-128,127);n=d+n|0;if(t>>>0>n>>>0){continue}break}}q=q+1|0;if((q|0)!=(d|0)){continue}break}}Za=e+16|0}function XI(a,b,c,d,e,f,g,j){var m=0,n=0,o=0,p=0,q=0,r=0,s=0;o=Za-16|0;Za=o;h[o+15|0]=c;h[o+14|0]=12;Nf(b,k[Zb(o+15|0,o+14|0)|0]);if(sb(b)){c=0;p=a+96|0;a=a+144|0;while(1){a:{b:{c:{switch(j|0){case 0:m=c<<2;n=m+p|0;n=k[n|0]|k[n+1|0]<<8;r=xb(b,c),s=n,i[r>>1]=s;m=(m|2)+p|0;break b;case 1:break c;default:break a}}m=c<<2;n=m+a|0;n=k[n|0]|k[n+1|0]<<8;r=xb(b,c),s=n,i[r>>1]=s;m=a+(m|2)|0}m=k[m|0];r=xb(b,c),s=m,h[r+2|0]=s}d:{if(!c){break d}m=c-1|0;if(l[xb(b,c)>>1]>=l[xb(b,m)>>1]){break d}if(l[xb(b,c)>>1]>255){break d}n=k[xb(b,m)+1|0];q=xb(b,c);i[q>>1]=l[q>>1]|n<<8;if(l[xb(b,c)>>1]>=l[xb(b,m)>>1]){break d}m=xb(b,c);i[m>>1]=l[m>>1]+256}c=c+1|0;if(sb(b)>>>0>c>>>0){continue}break}}h[b+12|0]=0;e:{if(!(d&1)){break e}if(Xc(b)){break e}h[b+12|0]=k[b+12|0]|1}if(e>>>0<=11){if(d&2){h[b+12|0]=k[b+12|0]|4}h[b+15|0]=e;h[b+16|0]=e}if(!(g>>>0>11|f>>>0>g>>>0)){if(d&4){h[b+12|0]=k[b+12|0]|2}h[b+14|0]=g;h[b+13|0]=f}Za=o+16|0}function XM(a,b,c){var d=0;d=k[a|0]&15;h[a|0]=k[d+17520|0];a:{b:{c:{switch(d|0){case 0:if(k[b|0]?c>>>0>=51:0){break b}h[a|0]=0;return;case 5:d=k[b|0];if(!((d&240)!=32?(d&15)!=2:0)){h[a|0]=20;h[b|0]=159;d=159}if(!((d&15)==12|(d&240)==192)|c>>>0<51){break b}h[a|0]=25;h[b|0]=0;return;case 7:if(c>>>0>51){break b}h[a|0]=0;return;case 10:a=k[b|0]&240;if(!a){break b}h[b|0]=a;return;case 11:h[b|0]=p(k[b|0]&15,17);return;case 12:h[b|0]=k[b|0]>>>2;return;case 13:a=k[b|0];h[b|0]=p(a>>>4|0,10)+(a&15);return;case 14:d:{switch((k[b|0]>>>4|0)-1|0){case 0:h[a|0]=2;break a;case 1:h[a|0]=3;break a;case 7:if(c>>>0<52){break b}h[a|0]=20;h[b|0]=k[b|0]&15|96;return;case 8:h[a|0]=15;h[b|0]=k[b|0]&15;return;case 9:h[a|0]=11;h[b|0]=k[b|0]<<4|15;return;case 10:h[a|0]=11;break a;case 11:case 12:break d;default:break b}}h[a|0]=20;return;case 15:break c;default:break b}}if(k[b|0]<48){break b}h[a|0]=17}return}h[b|0]=k[b|0]|240}function F5(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0,k=0,l=0,m=0,n=0,o=0;g=Za-16|0;Za=g;a:{if(j[a+1420>>2]>=0){j[f>>2]=0;a=E5(a,b,c);break a}j[a+100>>2]=0;j[a+32>>2]=b;j[a+40>>2]=b+c;if(!SE(a)){j[f>>2]=0;a=0;break a}if(!D5(a,g+12|0,g+4|0,g+8|0)){b:{c:{d:{c=j[a+100>>2];switch(c-32|0){case 0:break c;case 3:break d;default:break b}}j[a+100>>2]=0;while(1){if(m=0,n=(pg(a)|0)!=-1,o=j[a+96>>2],o?m:n){continue}break}j[f>>2]=0;a=j[a+32>>2]-b|0;break a}if(j[a+992>>2]){break b}j[a+100>>2]=0;while(1){if(m=0,n=(pg(a)|0)!=-1,o=j[a+96>>2],o?m:n){continue}break}j[f>>2]=0;a=j[a+32>>2]-b|0;break a}G5(a);j[a+100>>2]=c;j[f>>2]=0;a=1;break a}i=j[g+4>>2];k=C5(a,j[g+12>>2],i,j[g+8>>2]);j[g+12>>2]=k;h=j[a+4>>2];if((h|0)>=1){c=0;while(1){l=(c<<2)+a|0;j[l+864>>2]=j[l+800>>2]+(i<<2);c=c+1|0;if((h|0)!=(c|0)){continue}break}}if(d){j[d>>2]=h}j[f>>2]=k;j[e>>2]=a+864;a=j[a+32>>2]-b|0}Za=g+16|0;return a|0}function Ixa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,k=0,m=0,n=0;m=Za-112|0;Za=m;a:{b:{if(!ke(a)){break b}if(ec(b)>>>0<2){break b}f=Wx(m+8|0,a);j[f+20>>2]=0;j[f>>2]=0;c:{d=ec(b);if(d){d:{while(1){c=ad(b,g);e=j[a>>2];h=j[c>>2];if(e>>>0<=h>>>0){break d}c=j[c+4>>2];if(c>>>0>e-h>>>0){break d}e=j[f>>2];if(e>>>0>268435456-c>>>0){break d}j[f>>2]=c+e;g=g+1|0;if((d|0)!=(g|0)){continue}break}g=d}if(!Qo(f)){break b}if(!g){break c}d=0;c=0;while(1){e=ad(b,d);h=j[f+20>>2];j[114630]=0;h=H(466,h|0)|0;k=j[114630];j[114630]=0;if((k|0)==1){break a}k=j[a+20>>2];j[114630]=0;k=H(466,k|0)|0;n=j[114630];j[114630]=0;if((n|0)==1){break a}Vb(c+h|0,k+j[e>>2]|0,j[e+4>>2]);j[e>>2]=c;if(!(!d|d>>>0>9)){j[((d<<2)+f|0)- -64>>2]=c}c=j[e+4>>2]+c|0;d=d+1|0;if((g|0)!=(d|0)){continue}break}break c}if(Qo(f)){break c}break b}Sm(a);Wx(a,f);j[a+4>>2]=0;j[a+8>>2]=j[a>>2];i[a+34>>1]=l[a+34>>1]|2}Za=m+112|0;return}J(0)|0;C()|0;ib();z()}function od(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0;c=Za+ -64|0;Za=c;j[a+480180>>2]=b;b=vo(a);PJ(c,b);e=j[c+12>>2];d=a+1074316|0;j[d>>2]=j[c+8>>2];j[d+4>>2]=e;d=j[c+4>>2];j[a+1074308>>2]=j[c>>2];j[a+1074312>>2]=d;Hr(a+8|0,b);d=l[a+480192>>1];if(d){b=1;while(1){e=(((b&65535)<<2)+a|0)+900380|0;f=j[e>>2];if(f){Fb(Ls(f));d=l[a+480192>>1]}j[e>>2]=0;b=b+1|0;if((b&65535)>>>0<=d>>>0){continue}break}}j[a+480184>>2]=0;j[a+480188>>2]=0;j[a+480236>>2]=65536;j[a+480228>>2]=48;j[a+480232>>2]=48;h[a+480268|0]=5;j[a+480260>>2]=16;j[a+480264>>2]=32767;j[a+480204>>2]=125e4;j[a+480208>>2]=0;j[a+480196>>2]=6;j[a+480200>>2]=256;j[a+1074300>>2]=0;j[a+1074304>>2]=0;i[a+480192>>1]=0;dx(a,4);Ija(a+484344|0);gM(a+484360|0);Ce(a+1304400|0);Ce(a+1304412|0);Ce(a+1304424|0);b=Ab(c,0,64);c=XJ(b);Dna(a+1304436|0,c);Kr(c);sz(a+1304500|0);bs(a+480248|0);if(j[a+480180>>2]&738230281){j[a+480208>>2]=j[a+480208>>2]|8388608}Za=b- -64|0}function soa(a,b){var c=0,d=0,e=0,f=0,g=0,i=0,l=0;d=Za-16|0;Za=d;f=Cb(a);a:{if(nb(b)){while(1){e=j[Ni(b,l)>>2];b:{if(e>>>0>=2097152){j[114630]=0;F(110,f|0,63);a=j[114630];j[114630]=0;if((a|0)!=1){break b}break a}a=0;c:{d:{while(1){i=e&63;h[(d+10|0)+a|0]=i;c=a+1|0;e=e>>>6|0;if(!e){break d}a=c;if((a|0)!=6){continue}break}c=7;a=6;break c}e:{if(!a){j[114630]=0;F(110,f|0,h[d+10|0]);break e}if((c|0)!=2){break c}a=1;c=2;if((i|0)!=1){break c}j[114630]=0;F(110,f|0,h[d+10|0]|64)}a=j[114630];j[114630]=0;if((a|0)!=1){break b}break a}e=(-1<<c^-1)<<7-a;i=c+d|0;a=c;while(1){f:{if((a|0)==(c|0)){g=k[i+9|0];j[114630]=0;F(110,f|0,(e|g)<<24>>24);g=j[114630];j[114630]=0;if((g|0)==1){break a}a=a-1|0;break f}j[114630]=0;a=a-1|0;F(110,f|0,h[a+(d+10|0)|0]|-128);g=j[114630];j[114630]=0;if((g|0)==1){break a}}if(a){continue}break}}l=l+1|0;if(nb(b)>>>0>l>>>0){continue}break}}Za=d+16|0;return}a=D()|0;C()|0;gb(f);G(a|0);z()}function Ala(a,b){var c=0,d=0,e=0,f=0,g=0,i=0,l=0;d=Za-16|0;Za=d;f=Qc(a);a:{if(nb(b)){while(1){e=j[Ni(b,l)>>2];b:{if(e>>>0>=2097152){j[114630]=0;F(118,f|0,63);a=j[114630];j[114630]=0;if((a|0)!=1){break b}break a}a=0;c:{d:{while(1){i=e&63;h[(d+10|0)+a|0]=i;c=a+1|0;e=e>>>6|0;if(!e){break d}a=c;if((a|0)!=6){continue}break}c=7;a=6;break c}e:{if(!a){j[114630]=0;F(118,f|0,h[d+10|0]);break e}if((c|0)!=2){break c}a=1;c=2;if((i|0)!=1){break c}j[114630]=0;F(118,f|0,h[d+10|0]|64)}a=j[114630];j[114630]=0;if((a|0)!=1){break b}break a}e=(-1<<c^-1)<<7-a;i=c+d|0;a=c;while(1){f:{if((a|0)==(c|0)){g=k[i+9|0];j[114630]=0;F(118,f|0,(e|g)<<24>>24);g=j[114630];j[114630]=0;if((g|0)==1){break a}a=a-1|0;break f}j[114630]=0;a=a-1|0;F(118,f|0,h[a+(d+10|0)|0]|-128);g=j[114630];j[114630]=0;if((g|0)==1){break a}}if(a){continue}break}}l=l+1|0;if(nb(b)>>>0>l>>>0){continue}break}}Za=d+16|0;return}a=D()|0;C()|0;gb(f);G(a|0);z()}function hca(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0;j[114630]=0;N(2083,a|0);e=j[114630];j[114630]=0;a:{b:{c:{d:{e:{if((e|0)==1){break e}j[114630]=0;N(2036,b|0);e=j[114630];j[114630]=0;if((e|0)==1){break e}e=0;j[114630]=0;N(2084,c|0);f=j[114630];j[114630]=0;if((f|0)==1){break e}a=Ab(c,0,d);if(!k[b|0]){break b}if(Lh(b,37350)|(d|0)!=8){break d}j[a+4>>2]=2085;j[a>>2]=2086;break c}b=J(0)|0;C()|0;O(b|0)|0;j[114630]=0;L(1984,37374,a|0,0,0);a=j[114630];j[114630]=0;if((a|0)==1){break a}Q();return 0}if(Lh(b,37362)|(d|0)!=64){break b}j[a+60>>2]=2087;j[a+56>>2]=2088;j[a+52>>2]=2089;j[a+48>>2]=2090;j[a+44>>2]=2091;j[a+40>>2]=2092;j[a+36>>2]=2093;j[a+32>>2]=2094;j[a+28>>2]=2095;j[a+24>>2]=2096;j[a+20>>2]=2097;j[a+16>>2]=2098;j[a+12>>2]=2099;j[a+8>>2]=2100;j[a+4>>2]=2101;j[a>>2]=2102}e=1}return e|0}a=D()|0;C()|0;j[114630]=0;M(20);b=j[114630];j[114630]=0;if((b|0)!=1){G(a|0);z()}J(0)|0;C()|0;ib();z()}function lea(a,b,c,d){var e=0,f=0,g=0,h=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0;l=Za-32|0;Za=l;g=j[a>>2];while(1){j[(e<<2)+l>>2]=g+(j[((e<<4)+a|0)+32>>2]^-1);e=e+1|0;if((e|0)!=7){continue}break}if(d){q=i[a+28>>1]/8<<16>>16;while(1){g=0;f=0;e=0;while(1){h=(e<<2)+l|0;k=j[h>>2]+1&8191;j[h>>2]=k;o=f;f=(k<<2)+a|0;k=i[f+160>>1];h=(e<<4)+a|0;n=i[f+162>>1];f=(o+p(k,i[h+44>>1])|0)+p(n,i[h+46>>1])|0;g=(p(k,i[h+40>>1])+g|0)+p(n,i[h+42>>1])|0;e=e+1|0;if((e|0)!=4){continue}break}h=0;e=4;k=Dc((g|0)/32768|0);n=Dc((f|0)/32768|0);g=0;while(1){m=(e<<2)+l|0;f=j[m>>2]+1&8191;j[m>>2]=f;o=g;g=(f<<2)+a|0;m=i[g+160>>1];f=(e<<4)+a|0;r=i[g+162>>1];g=(o+p(m,i[f+44>>1])|0)+p(r,i[f+46>>1])|0;h=(p(i[f+40>>1],m)+h|0)+p(i[f+42>>1],r)|0;e=e+1|0;if((e|0)!=7){continue}break}e=Dc(k+((h|0)/32768|0)|0);i[b>>1]=e;j[c>>2]=p(e,q);e=Dc(n+((g|0)/32768|0)|0);i[b+2>>1]=e;j[c+4>>2]=p(e,q);c=c+8|0;b=b+4|0;d=d-1|0;if(d){continue}break}}Za=l+32|0}function IG(a,b,c,d,e,f,g,h,i){var k=0,l=0,m=0,n=0;k=Za-48|0;Za=k;j[k+44>>2]=0;if(!(i?0:!(d|g|h))){l=Qba(g?k+44|0:0)}m=!g;if(d){n=bb[d|0](l,e)|0}else{n=3}if(!(m|!(n&2))){j[g+16>>2]=l;m=g;g=j[k+44>>2];a:{if(g){g=Gd(g);break a}g=Gd(34181)}j[m+20>>2]=g}if(h){j[h>>2]=l}if(i){g=j[k+44>>2];b:{if(g){g=Gd(g);break b}g=Gd(34181)}j[i>>2]=g}g=j[k+44>>2];if(g){Fb(g);j[k+44>>2]=0}c:{if(!(n&1)){break c}j[114630]=0;F(1985,k+32|0,a|0);g=j[114630];j[114630]=0;d:{e:{if((g|0)!=1){f:{if(f){j[114630]=0;F(1986,f|0,k+32|0);g=j[114630];j[114630]=0;if((g|0)!=1){break f}break e}g=zb(k+32|0);if(b){j[114630]=0;F(b|0,g|0,c|0);g=j[114630];j[114630]=0;if((g|0)==1){break e}break f}mr(g,k)}gb(k+32|0);break c}g=J(0)|0;C()|0;break d}g=J(0)|0;C()|0;gb(k+32|0)}O(g|0)|0;j[k+28>>2]=f;j[k+24>>2]=e;j[k+20>>2]=d;j[k+16>>2]=c;j[k+12>>2]=b;j[k+4>>2]=248;j[k>>2]=37537;j[k+8>>2]=a?a:34181;a=j[13926];vE(a,37407,k);Sq(a);Q()}Za=k+48|0}function rfa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,l=0,m=0,o=q(0),p=0,s=0,t=0,u=0,v=0,w=q(0),x=q(0),y=q(0),z=0,A=0,B=q(0);f=Za-16|0;Za=f;a:{if(!j[a+4240>>2]){break a}g=a+44|0;if(!Xg(g)){break a}y=n[a+4220>>2];z=f,A=wd(g,0),j[z+8>>2]=A;z=f,A=wd(g,1),j[z+12>>2]=A;z=f,A=Rc(g,0),j[z>>2]=A;z=f,A=Rc(g,1),j[z+4>>2]=A;if(d){p=a+4208|0;l=d;while(1){h=0;i=1;m=0;while(1){s=(k[a+4264|0]?1-m|0:h)&255;e=j[a+4244>>2]-j[((s<<2)+a|0)+4248>>2]|0;if((e|0)<=-1){e=j[a+4240>>2]+e|0}t=h<<2;u=t+(f+8|0)|0;v=j[u>>2];j[u>>2]=v+4;o=n[v>>2];w=n[xb(p,(e<<1)+s|0)>>2];x=q(q(n[a+4224>>2]*w)+q(o*n[a+4260>>2]));z=xb(p,j[a+4244>>2]<<1|h),B=q(r(x))<q(1.0000000195414814e-24)?q(0):x,n[z>>2]=B;h=f+t|0;e=j[h>>2];j[h>>2]=e+4;n[e>>2]=o+q(q(w-o)*y);m=m+1|0;e=i;i=0;h=1;if(e){continue}break}i=j[a+4244>>2]+1|0;j[a+4244>>2]=(i|0)==j[a+4240>>2]?0:i;l=l-1|0;if(l){continue}break}}Sh(a,b,c,Rc(g,0),Rc(g,1),d)}Za=f+16|0}function hE(a,b){var c=0,d=0,e=0,f=0,g=0,i=0,l=0,m=0,n=0;c=Za-32|0;Za=c;a:{if(k[a+52|0]){d=j[a+48>>2];if(!b){break a}h[a+52|0]=0;j[a+48>>2]=-1;break a}j[c+24>>2]=1;e=j[zf(c+24|0,a+44|0)>>2];i=(e|0)>0?e:0;b:{while(1){if((d|0)!=(i|0)){f=Mq(j[a+32>>2]);if((f|0)==-1){break b}h[(c+24|0)+d|0]=f;d=d+1|0;continue}break}c:{if(k[a+53|0]){h[c+23|0]=k[c+24|0];break c}i=c+24|0;while(1){d:{d=j[a+40>>2];f=j[d>>2];l=j[d+4>>2];e:{g=d;d=(c+24|0)+e|0;switch(gE(j[a+36>>2],g,c+24|0,d,c+16|0,c+23|0,i,c+12|0)-1|0){case 0:break e;case 1:break b;case 2:break d;default:break c}}g=j[a+40>>2];j[g>>2]=f;j[g+4>>2]=l;if((e|0)==8){break b}f=Mq(j[a+32>>2]);if((f|0)==-1){break b}h[d|0]=f;e=e+1|0;continue}break}h[c+23|0]=k[c+24|0]}f:{if(!b){while(1){if((e|0)<1){break f}e=e-1|0;if((Nq(gg(h[e+(c+24|0)|0]),j[a+32>>2])|0)!=-1){continue}break b}}m=a,n=gg(h[c+23|0]),j[m+48>>2]=n}d=gg(h[c+23|0]);break a}d=-1}Za=c+32|0;return d}function kK(a,b,c,d){var e=0,f=0;e=Za-16|0;Za=e;j[e+12>>2]=b;f=0;a:{if(!b){break a}if(j[a+480180>>2]&20){b=a+1074308|0;mb(e,b,73);if(kb(e)){j[e+12>>2]=l[e+12>>1]}if(k[a+480208|0]&16){mb(e,b,73);b=kb(e);a=j[e+12>>2];f=j[((a>>>0)%768<<2)+22112>>2]<<6>>>(b?14-((9983-a>>>0)/768|0)&31:((a>>>0)/768|0)+2|0)|0;break a}a=j[e+12>>2];if(!a){j[e+12>>2]=1;a=1}f=229079296/(a>>>0)|0;break a}f=227001280/(b>>>0)|0;if(kp(a)){break a}f=(b+c<<4)-133808|0;if(j[a+480180>>2]==64){break a}b=j[a+480180>>2];jc(e+12|0,16777215);if(b&17408){f=Tc(KMa(HMa(c?c:8363,0,3506176,0),ab,(j[e+12>>2]<<8)+d|0,0),ab);break a}if(k[a+480208|0]&16){mb(e,a+1074308|0,7);if(kb(e)){c=d>>31;b=d;a=j[e+12>>2];d=a>>>24|0;f=a<<8;b=b+f|0;a=c+d|0;a=b>>>0<f>>>0?a+1|0:a;f=(a&15)<<28|b>>>4;break a}f=Tc(KMa(HMa(c?c:8363,0,7012352,0),ab,(j[e+12>>2]<<8)+d|0,0),ab);break a}f=Tc(KMa(-1485242368,13,(j[e+12>>2]<<8)+d|0,0),ab)}Za=e+16|0;return f}function YJ(a,b){var c=0,d=0,e=0,f=0,g=0;d=Za-16|0;Za=d;e=Le(a);f=d,g=nd(b),j[f+8>>2]=g;f=d,g=_e(b),j[f>>2]=g;a:{b:{if(!rb(d+8|0,d)){break b}a=0;b=0;while(1){c=k[j[d+8>>2]];c:{if(!a){if(!(c&128)){a=0;j[114630]=0;F(112,e|0,c|0);c=j[114630];j[114630]=0;if((c|0)!=1){break c}break a}if((c&224)==192){b=c&31;a=1;break c}if((c&240)==224){b=c&15;a=2;break c}if((c&248)==240){b=c&7;a=3;break c}b=0;j[114630]=0;F(112,e|0,65533);c=j[114630];j[114630]=0;a=0;if((c|0)==1){break a}break c}if((c&192)!=128){j[114630]=0;F(112,e|0,65533);a=j[114630];j[114630]=0;if((a|0)==1){break a}b=c&63;a=-1;break c}c=c&63|b<<6;a=a-1|0;if(a){b=c;break c}b=0;j[114630]=0;F(112,e|0,c|0);c=j[114630];j[114630]=0;a=0;if((c|0)==1){break a}}Xf(d+8|0);if(rb(d+8|0,d)){continue}break}if(!a){break b}j[114630]=0;F(112,e|0,65533);a=j[114630];j[114630]=0;if((a|0)!=1){break b}break a}Za=d+16|0;return}a=D()|0;C()|0;pc(e);G(a|0);z()}function qva(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0;e=Za-32|0;Za=e;k=j[a+40>>2];l=j[a+36>>2];n=j[a+16>>2];b=j[a+4>>2];f=b;g=j[a>>2];j[e+24>>2]=g;j[e+28>>2]=b;b=j[a+12>>2];j[e+16>>2]=j[a+8>>2];j[e+20>>2]=b;a:{if(!d){b=k>>12;h=l>>12;break a}while(1){m=((((f&2147483647)<<1|g>>>31)&2147483646)<<1)+n|0;b=(g>>>21&2040)+27888|0;g=i[b+6>>1];o=i[b+4>>1];q=i[b+2>>1];r=i[b>>1];h=0;b=1;while(1){f=h<<1;j[(e+8|0)+(h<<2)>>2]=(((p(i[f+m>>1],q)+p(i[(f|-4)+m>>1],r)|0)+p(i[(f|4)+m>>1],o)|0)+p(i[(f|8)+m>>1],g)|0)/16384;f=b;b=0;h=1;if(f){continue}break}b=j[a+32>>2];l=j[a+28>>2]+l|0;h=l>>12;j[c>>2]=j[c>>2]+p(h,j[e+8>>2]);k=b+k|0;b=k>>12;j[c+4>>2]=j[c+4>>2]+p(b,j[e+12>>2]);Bb(e+24|0,e+16|0);d=d-1|0;if(d){c=c+8|0;g=j[e+24>>2];f=j[e+28>>2];continue}break}g=j[e+24>>2];f=j[e+28>>2]}j[a+40>>2]=k;j[a+20>>2]=h;j[a+36>>2]=l;j[a+24>>2]=b;j[a>>2]=g;j[a+4>>2]=f;Za=e+32|0}function FW(){var a=0,b=0,c=0,d=0;c=Za-32|0;Za=c;a:{a=Db(c+16|0,10940);if(!nb(a)){break a}b:{if((Hf(a,10946)|0)!=-1){b=Hf(a,10946);j[114630]=0;L(232,c|0,a|0,b+1|0,-1);b=j[114630];j[114630]=0;if((b|0)==1){break b}ob(a,c);gb(c)}if((Hf(a,10948)|0)!=-1){b=Hf(a,10948);j[114630]=0;L(232,c|0,a|0,b+1|0,-1);b=j[114630];j[114630]=0;if((b|0)==1){break b}ob(a,c);gb(c)}if((Hf(a,10950)|0)!=-1){b=Hf(a,10950);j[114630]=0;L(232,c|0,a|0,0,b|0);b=j[114630];j[114630]=0;if((b|0)==1){break b}ob(a,c);gb(c)}if((Hf(a,10952)|0)!=-1){b=Hf(a,10952);j[114630]=0;L(232,c|0,a|0,0,b|0);b=j[114630];j[114630]=0;if((b|0)==1){break b}ob(a,c);gb(c)}if((Hf(a,10954)|0)!=-1){b=Hf(a,10954);j[114630]=0;L(232,c|0,a|0,0,b|0);b=j[114630];j[114630]=0;if((b|0)==1){break b}ob(a,c);gb(c)}j[114630]=0;b=H(233,a|0)|0;d=j[114630];j[114630]=0;if((d|0)!=1){break a}}c=D()|0;C()|0;gb(a);G(c|0);z()}gb(a);Za=c+32|0;return b|0}function LHa(a,b,c){var d=0,e=0,f=0,g=0,i=0,k=0;d=Za-80|0;Za=d;Ce(b);a:{if(yb(a,1)){b:{c:{d:{e:{f:{g:{while(1){j[114630]=0;e=K(602,a|0,d+16|0,64)|0;f=j[114630];j[114630]=0;if((f|0)==1){break d}j[d+8>>2]=e;e=nb(b);j[114630]=0;j[d+4>>2]=c-e;e=E(33,d+8|0,d+4|0)|0;f=j[114630];j[114630]=0;if((f|0)==1){break g}e=j[e>>2];if(!e){break b}h[d+8|0]=0;f=e+(d+16|0)|0;e=zm(d+16|0,f,d+8|0);i=d,k=_e(b),j[i+8>>2]=k;Cd(d,d+8|0);j[114630]=0;P(603,b|0,j[d>>2],d+16|0,e|0)|0;g=j[114630];j[114630]=0;if((g|0)==1){break f}j[114630]=0;E(338,a|0,e-(d+16|0)|0)|0;g=j[114630];j[114630]=0;if((g|0)==1){break e}if(e>>>0>=f>>>0){continue}break}j[114630]=0;E(338,a|0,1)|0;a=j[114630];j[114630]=0;if((a|0)!=1){break b}a=J(71412)|0;break c}a=J(71412)|0;break c}a=J(71412)|0;break c}a=J(71412)|0;break c}a=J(71412)|0}if((C()|0)!=(W(71412)|0)){break a}O(a|0)|0;Q()}e=(nb(b)|0)!=0}Za=d+80|0;return e}G(a|0);z()}function eE(a,b){var c=0,d=0,e=0,f=0,g=0,i=0,l=0;c=Za-32|0;Za=c;a:{if(k[a+52|0]){d=j[a+48>>2];if(!b){break a}h[a+52|0]=0;j[a+48>>2]=-1;break a}j[c+24>>2]=1;e=j[zf(c+24|0,a+44|0)>>2];i=(e|0)>0?e:0;b:{while(1){if((d|0)!=(i|0)){f=Mq(j[a+32>>2]);if((f|0)==-1){break b}h[(c+24|0)+d|0]=f;d=d+1|0;continue}break}c:{if(k[a+53|0]){j[c+20>>2]=h[c+24|0];break c}i=c+24|0;while(1){d:{d=j[a+40>>2];f=j[d>>2];l=j[d+4>>2];e:{g=d;d=(c+24|0)+e|0;switch(gE(j[a+36>>2],g,c+24|0,d,c+16|0,c+20|0,i,c+12|0)-1|0){case 0:break e;case 1:break b;case 2:break d;default:break c}}g=j[a+40>>2];j[g>>2]=f;j[g+4>>2]=l;if((e|0)==8){break b}f=Mq(j[a+32>>2]);if((f|0)==-1){break b}h[d|0]=f;e=e+1|0;continue}break}j[c+20>>2]=h[c+24|0]}f:{if(!b){while(1){if((e|0)<1){break f}e=e-1|0;if((Nq(h[e+(c+24|0)|0],j[a+32>>2])|0)!=-1){continue}break b}}j[a+48>>2]=j[c+20>>2]}d=j[c+20>>2];break a}d=-1}Za=c+32|0;return d}function Qk(a,b){var c=0,d=0,e=0,f=0,g=0,h=0,i=0,l=0;Dj(a);a:{b:{c:{g=j[b+32>>2];d:{if(!g){d=j[b+2084>>2];if(d){break d}break b}f=j[b+4>>2];if((f|0)<9){break c}d=j[b+2084>>2];if(!d){break c}}h=j[a+1392>>2];l=Pk(h);e=j[b+2092>>2];if((e|0)>=2){while(1){f=e>>>1|0;i=f+c|0;g=l>>>0<m[(i<<2)+d>>2];c=g?c:i;e=g?f:e-f|0;if((e|0)>1){continue}break}}e=a;d=j[a+1396>>2];c=k[b+23|0]?c:j[j[b+2088>>2]+(c<<2)>>2];b=k[c+j[b+8>>2]|0];e:{if((d|0)<(b|0)){c=-1;a=0;break e}j[a+1392>>2]=h>>>b;a=d-b|0}j[e+1396>>2]=a;return c}if(k[b+23|0]){break a}if((f|0)>=1){d=j[b+8>>2];while(1){f:{e=k[c+d|0];if((e|0)==255){break f}h=j[a+1392>>2];if(j[g+(c<<2)>>2]!=(h&(-1<<e^-1))){break f}d=j[a+1396>>2];if((d|0)>=(e|0)){j[a+1392>>2]=h>>>e;j[a+1396>>2]=d-k[j[b+8>>2]+c|0];return c}j[a+1396>>2]=0;break b}c=c+1|0;if((f|0)!=(c|0)){continue}break}}Nb(a,21);j[a+1396>>2]=0}return-1}Y(50730,50512,1690,50741);z()}function rva(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0;e=Za-32|0;Za=e;l=j[a+40>>2];m=j[a+36>>2];o=j[a+16>>2];b=j[a+4>>2];g=b;k=j[a>>2];j[e+24>>2]=k;j[e+28>>2]=b;b=j[a+12>>2];j[e+16>>2]=j[a+8>>2];j[e+20>>2]=b;a:{if(!d){f=l>>12;b=m>>12;break a}while(1){n=(((g&2147483647)<<1|k>>>31)&-2)+o|0;b=(k>>>21&2040)+27888|0;k=i[b+6>>1];q=i[b+4>>1];r=i[b+2>>1];s=i[b>>1];f=0;b=1;while(1){j[(e+8|0)+(f<<2)>>2]=(((p(h[f+n|0],r)+p(h[(f|-2)+n|0],s)|0)+p(h[(f|2)+n|0],q)|0)+p(h[(f|4)+n|0],k)<<8)/16384;g=b;b=0;f=1;if(g){continue}break}g=j[a+32>>2];m=j[a+28>>2]+m|0;b=m>>12;j[c>>2]=j[c>>2]+p(b,j[e+8>>2]);l=g+l|0;f=l>>12;j[c+4>>2]=j[c+4>>2]+p(f,j[e+12>>2]);Bb(e+24|0,e+16|0);d=d-1|0;if(d){c=c+8|0;k=j[e+24>>2];g=j[e+28>>2];continue}break}k=j[e+24>>2];g=j[e+28>>2]}j[a+40>>2]=l;j[a+20>>2]=b;j[a+36>>2]=m;j[a+24>>2]=f;j[a>>2]=k;j[a+4>>2]=g;Za=e+32|0}function jka(a,b){var c=0,d=0,e=0,f=0,g=0,h=0,i=0,k=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;n=Za-16|0;Za=n;if(ke(a)){d=l[a+34>>1];h=j[a+8>>2];o=j[a+4>>2];k=j[a>>2];r=!(d&2)|(h>>>0<=o>>>0|k>>>0<h>>>0);i=j[a+16>>2];p=j[a+12>>2];s=!(d&8)|(i>>>0<=p>>>0|i>>>0>k>>>0);t=b+1304360|0;b=b+1074984|0;u=d&4;v=d&16;while(1){a:{if(j[b+104>>2]!=(a|0)){break a}d=j[b+76>>2];if(!d){break a}b:{c:{d:{e=b;e:{f:{if(s){break f}c=j[b+88>>2];if(c&2048){break f}j[b+84>>2]=i;j[b+80>>2]=p;g=v;d=i;break e}if(r){break d}j[b+84>>2]=h;j[b+80>>2]=o;c=j[b+88>>2];g=u;d=h}j[e+76>>2]=d;f=c|2;j[b+88>>2]=f;q=b+88|0;e=1;if(!g){break c}c=c|6;e=1;g=1;break b}f=j[b+88>>2]&-3;j[b+88>>2]=f;q=b+88|0;e=0}c=f&-5;g=0}j[b+88>>2]=c;if(m[b+4>>2]>d>>>0){c=c&-129;j[b+88>>2]=c;f=j[b+80>>2];j[b>>2]=0;j[b+4>>2]=f}if(!g){j[q>>2]=c&-129}if(e){break a}j[b+76>>2]=k}b=b+896|0;if((t|0)!=(b|0)){continue}break}}Za=n+16|0}function Qba(a){var b=0,c=0,d=0,e=0;a:{if(!a){break a}c=j[a>>2];if(!c){break a}Fb(c);j[a>>2]=0}j[114630]=0;M(81);c=j[114630];j[114630]=0;e=a;b:{c:{d:{if((c|0)==1){d=Qa(71412,83532,83544,83648,71568,71672,71620,71512,71500,71816,71784,71752,71740,71388,0)|0;a=277;b=C()|0;if((b|0)==(W(71412)|0)){break d}a=358;if((W(83532)|0)==(b|0)){break d}a=359;if((W(83544)|0)==(b|0)){break d}a=357;if((W(83648)|0)==(b|0)){break d}a=300;if((W(71568)|0)==(b|0)){break d}a=299;if((W(71672)|0)==(b|0)){break d}a=298;if((W(71620)|0)==(b|0)){break d}a=297;if((W(71512)|0)==(b|0)){break d}a=296;if((W(71500)|0)==(b|0)){break d}a=289;if((W(71816)|0)==(b|0)){break d}a=288;if((W(71784)|0)==(b|0)){break d}a=287;if((W(71752)|0)==(b|0)){break d}a=286;if((W(71740)|0)==(b|0)){break d}c=257;a=267;b=(W(71388)|0)==(b|0);d=O(d|0)|0;if(b){break c}break b}z()}d=O(d|0)|0}Oba(e,d);c=a}Q();return c}function wM(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0;h[a+15|0]=0;h[a+16|0]=0;h[a+17|0]=0;h[a+18|0]=0;h[a+19|0]=0;h[a+20|0]=0;h[a+21|0]=0;h[a+22|0]=0;h[a+14|0]=5;i[a+12>>1]=0;j[a+8>>2]=128;j[a>>2]=256;j[a+4>>2]=64;j[a+28>>2]=0;h[a+27|0]=60;j[a+40>>2]=0;j[a+44>>2]=0;h[a+33|0]=2;h[a+34|0]=0;h[a+35|0]=0;h[a+36|0]=2;h[a+23|0]=0;h[a+24|0]=0;h[a+25|0]=255;h[a+26|0]=0;h[a+32|0]=0;d=Mx(a+48|0);e=Mx(a+68|0);f=Mx(a+88|0);j[114630]=0;H(1157,a+492|0)|0;c=j[114630];j[114630]=0;a:{if((c|0)==1){break a}j[114630]=0;H(1157,a+524|0)|0;c=j[114630];j[114630]=0;if((c|0)==1){break a}j[114630]=0;I(905,a|0,0,0);c=j[114630];j[114630]=0;if((c|0)==1){break a}j[114630]=0;I(906,a|0,0,0);c=j[114630];j[114630]=0;if((c|0)==1){break a}j[a+40>>2]=0;j[a+44>>2]=0;j[114630]=0;F(776,a|0,b|0);b=j[114630];j[114630]=0;if((b|0)==1){break a}Sta(a);return a|0}a=D()|0;C()|0;Ym(f);Ym(e);Ym(d);G(a|0);z()}function IK(a,b){var c=0,d=0,e=0,f=0,g=0;d=l[a+480188>>1];a:{if(d>>>0<=255){f=a+1304392|0;while(1){e=p(d,896)+a|0;c=e+1075060|0;b:{if(j[c>>2]){break b}if(!Si(e+1074984|0)){break a}if(j[c>>2]){break b}if(k[e+1075073|0]&24){break a}}if(k[e+1075073|0]&2){if(!$c(f)){break a}if(!HK(j[f>>2],d&65535)){break a}}d=d+1|0;if((d&65535)!=256){continue}break}}g=8388608;if(b>>>0<=255){b=p(b,896)+a|0;if(!j[b+1075680>>2]){d=65535;if(j[b+1075060>>2]){break a}}g=j[b+1075672>>2]|j[b+1075664>>2]<<9}d=65535;b=l[a+480188>>1];if(b>>>0>255){break a}e=0;while(1){c=p(b,896)+a|0;if(!(j[c+1075680>>2]?0:j[c+1075060>>2])){f=(j[c+1075672>>2]|j[c+1075664>>2]<<9)>>>(j[c+1075072>>2]>>>1&1)|0;c:{d:{if(f>>>0<g>>>0){c=j[c+1075712>>2];break d}if((f|0)!=(g|0)){break c}c=j[c+1075712>>2];if(e>>>0>=c>>>0){break c}}g=f;d=b;e=c}b=b+1|0;if((b&65535)!=256){continue}break a}break}d=b}return d&65535}function xv(a){var b=0,c=0,d=0,e=0,f=0,g=0;RMa(+a);e=OMa(1)|0;OMa(0)|0;b=e;e=b>>>31|0;a:{b:{c:{d:{d=a;e:{f:{b=b&2147483647;g:{if(b>>>0>=1082532651){RMa(+a);b=OMa(1)|0;b=b&2147483647;if((b|0)==2146435072&(OMa(0)|0)!=0|b>>>0>2146435072){return a}if(!(a>709.782712893384^1)){return a*8.98846567431158e+307}if(!(a<-745.1332191019411)|a<-708.3964185322641^1){break g}break b}if(b>>>0<1071001155){break d}if(b>>>0<1072734898){break f}}a=a*1.4426950408889634+o[(e<<3)+52272>>3];if(r(a)<2147483648){b=~~a;break e}b=-2147483648;break e}b=(e^1)-e|0}c=+(b|0);a=d+c*-.6931471803691238;f=c*1.9082149292705877e-10;d=a-f;break c}if(b>>>0<=1043333120){break a}b=0;d=a}c=d;g=a;c=c*c;a=d-c*(c*(c*(c*(c*4.1381367970572385e-8+ -16533902205465252e-22)+6613756321437934e-20)+ -.0027777777777015593)+.16666666666666602);c=g+(d*a/(2-a)-f)+1;if(!b){break b}c=Bh(c,b)}return c}return a+1}function _wa(a,b,c){var d=0,e=0,f=0,g=0,i=0,j=0;d=Za-16|0;Za=d;g=1;f=a;e=dd(b);if((e|0)==252){g=dd(b);e=dd(b)}h[f|0]=(e-1&255)>>>0<60?e+36|0:0;rn(d+8|0,b);b=Pc(d+8|0);f=Bf(d+8|0);e=pi(d+8|0);h[a+1|0]=k[d+8|0];h[d+7|0]=k[b|0]&15;h[d+6|0]=k[b|0]>>>4;h[d+5|0]=k[f|0];h[d+4|0]=k[e|0];XM(d+7|0,d+5|0,c);XM(d+6|0,d+4|0,c);a:{b:{c:{d:{e=k[d+7|0];c=(e|0)!=10;b=k[d+6|0];if(!(c|(b|0)!=10)){h[d+7|0]=0;i=d,j=Zm((k[d+4|0]|k[d+5|0]<<8)>>>6|0),h[i+5|0]=j;break d}if(!c){i=d,j=Zm(k[d+5|0]<<2),h[i+5|0]=j;break d}if((b|0)==10){i=d,j=Zm(k[d+4|0]<<2),h[i+4|0]=j;break d}if((b|0)!=(e|0)){break d}h[d+6|0]=0;break c}b=k[d+6|0];if((b|0)==13){break b}if(b){break a}e=k[d+7|0]}if((e&255)==13){break a}}Ug(d+7|0,d+6|0);Ug(d+5|0,d+4|0)}Dw(d+6|0,d+4|0,d+7|0,d+5|0);Cw(d,d+7|0,d+5|0,d+6|0,d+4|0);h[a+2|0]=k[d+7|0];h[a+4|0]=k[d+5|0];h[a+3|0]=k[d+6|0];h[a+5|0]=k[d+4|0];Za=d+16|0;return g}function XE(a,b,c,d){var e=0,f=0,g=0,h=q(0),i=0,j=q(0),k=0,l=q(0),m=q(0),o=q(0),p=0;e=Za-96|0;Za=e;if((d|0)>=1){while(1){n[e+48>>2]=-n[a>>2];n[e>>2]=n[a+68>>2];f=0;while(1){g=f<<3;i=f<<4;j=n[(i|8)+a>>2];h=n[(i|4)+a>>2];n[(e+48|0)+(g|4)>>2]=j+h;k=f<<1;n[(8-k<<2)+e>>2]=h-j;j=n[(a+i|0)+16>>2];h=n[(i|12)+a>>2];n[(7-k<<2)+e>>2]=j-h;n[(e+g|0)+56>>2]=-q(h+j);f=f+1|0;if((f|0)!=4){continue}break}VE(e+48|0);VE(e);n[e+4>>2]=-n[e+4>>2];n[e+12>>2]=-n[e+12>>2];n[e+20>>2]=-n[e+20>>2];n[e+28>>2]=-n[e+28>>2];i=0;while(1){f=i<<2;g=f+b|0;j=n[g>>2];k=g;h=n[f+48944>>2];l=n[f+(e+48|0)>>2];m=n[e+f>>2];g=f+36|0;o=n[g+48944>>2];n[k>>2]=q(h*l)-q(m*o);k=a+f|0;f=c+f|0;g=c+g|0;h=q(q(h*m)+q(o*l));n[k>>2]=q(j*n[f>>2])-q(n[g>>2]*h);n[(17-i<<2)+a>>2]=q(n[f>>2]*h)+q(j*n[g>>2]);i=i+1|0;if((i|0)!=9){continue}break}b=b+36|0;a=a+72|0;p=p+1|0;if((p|0)!=(d|0)){continue}break}}Za=e+96|0}function Eq(a){a=a|0;var b=0,c=0,d=0,e=0;d=Za-16|0;Za=d;c=j[j[a>>2]-12>>2];j[114630]=0;c=j[(a+c|0)+24>>2];b=j[114630];j[114630]=0;a:{b:{c:{d:{e:{if((b|0)!=1){if(!c){break b}j[114630]=0;c=E(15,d+8|0,a|0)|0;b=j[114630];j[114630]=0;if((b|0)==1){break d}if(!k[c|0]){break e}b=j[j[a>>2]-12>>2];j[114630]=0;b=j[(a+b|0)+24>>2];e=j[114630];j[114630]=0;f:{if((e|0)==1){break f}j[114630]=0;b=H(2370,b|0)|0;e=j[114630];j[114630]=0;if((e|0)==1){break f}if((b|0)!=-1){break e}b=j[j[a>>2]-12>>2];j[114630]=0;F(18,a+b|0,1);b=j[114630];j[114630]=0;if((b|0)!=1){break e}}b=J(0)|0;C()|0;nf(c);break c}b=J(0)|0;C()|0;break c}nf(c);break b}b=J(0)|0;C()|0}O(b|0)|0;c=j[j[a>>2]-12>>2];j[114630]=0;N(19,a+c|0);c=j[114630];j[114630]=0;if((c|0)==1){break a}Q()}Za=d+16|0;return a|0}a=D()|0;C()|0;j[114630]=0;M(20);c=j[114630];j[114630]=0;if((c|0)!=1){G(a|0);z()}J(0)|0;C()|0;ib();z()}function t3(a,b){var c=0,d=0,e=0,f=0,g=0;c=Za-32|0;Za=c;j[c+28>>2]=0;a:{b:{if(k[Ki(c+24|0,a,0)|0]){hc(c+16|0,j[j[a>>2]-12>>2]+a|0);j[114630]=0;d=H(2371,c+16|0)|0;e=j[114630];j[114630]=0;c:{d:{e:{f:{if((e|0)==1){break f}e=em(c+8|0,a);f=dk(c);g=j[j[a>>2]-12>>2];f=j[f>>2];e=j[e>>2];j[114630]=0;_(2374,d|0,e|0,f|0,a+g|0,c+28|0,c+20|0)|0;d=j[114630];j[114630]=0;if((d|0)==1){break f}wb(c+16|0);break e}b=J(0)|0;C()|0;wb(c+16|0);O(b|0)|0;b=j[c+28>>2]|1;j[c+28>>2]=b;Ii(j[j[a>>2]-12>>2]+a|0,b);b=j[j[a>>2]-12>>2];j[114630]=0;b=j[(a+b|0)+20>>2];d=j[114630];j[114630]=0;if((d|0)!=1){if(!(b&1)){break d}j[114630]=0;M(81);a=j[114630];j[114630]=0;if((a|0)!=1){break a}}a=D()|0;C()|0;j[114630]=0;M(20);b=j[114630];j[114630]=0;if((b|0)==1){break b}G(a|0);z()}d=j[c+20>>2];j[b>>2]=d;break c}Q()}eg(j[j[a>>2]-12>>2]+a|0,j[c+28>>2])}Za=c+32|0;return a}J(0)|0;C()|0;ib()}z()}function rca(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0;e=Za-32|0;Za=e;j[114630]=0;N(2010,a|0);d=j[114630];j[114630]=0;a:{b:{c:{d:{e:{f:{g:{if((d|0)==1){break g}j[114630]=0;N(2036,b|0);d=j[114630];j[114630]=0;if((d|0)==1){break g}j[114630]=0;N(2036,c|0);d=j[114630];j[114630]=0;if((d|0)==1){break g}d=j[a+24>>2];j[114630]=0;b=E(85,e+16|0,b|0)|0;f=j[114630];j[114630]=0;if((f|0)==1){break g}j[114630]=0;c=E(85,e|0,c|0)|0;f=j[114630];j[114630]=0;if((f|0)==1){break f}j[114630]=0;L(2076,d|0,b|0,c|0,1);d=j[114630];j[114630]=0;if((d|0)==1){break e}gb(c);gb(b);b=1;break b}d=J(0)|0;C()|0;break c}d=J(0)|0;C()|0;break d}d=J(0)|0;C()|0;gb(c)}gb(b)}O(d|0)|0;b=0;j[114630]=0;L(1984,37079,a|0,0,0);a=j[114630];j[114630]=0;if((a|0)==1){break a}Q()}Za=e+32|0;return b|0}a=D()|0;C()|0;j[114630]=0;M(20);b=j[114630];j[114630]=0;if((b|0)!=1){G(a|0);z()}J(0)|0;C()|0;ib();z()}function Mca(a,b){a=a|0;b=b|0;var c=0,d=0;d=Za-16|0;Za=d;j[114630]=0;N(2010,a|0);c=j[114630];j[114630]=0;a:{b:{c:{d:{e:{f:{g:{h:{i:{if((c|0)!=1){c=j[a+24>>2];j[114630]=0;F(2056,d|0,c|0);c=j[114630];j[114630]=0;if((c|0)==1){break i}if(ec(d)>>>0<2147483647){break h}c=R(8)|0;j[114630]=0;E(2057,c|0,36392)|0;b=j[114630];j[114630]=0;if((b|0)==1){break g}j[114630]=0;I(2004,c|0,71740,265);b=j[114630];j[114630]=0;if((b|0)!=1){break b}b=J(0)|0;C()|0;break f}b=J(0)|0;C()|0;break e}b=J(0)|0;C()|0;break e}a=34181;j:{if((b|0)<0){break j}a=34181;if((ec(d)|0)<=(b|0)){break j}a=zb(ad(d,b))}b=Gd(a);Vc(d);break d}b=J(0)|0;C()|0;S(c|0)}Vc(d)}O(b|0)|0;b=0;j[114630]=0;L(1984,36407,a|0,0,0);a=j[114630];j[114630]=0;if((a|0)==1){break c}Q()}Za=d+16|0;return b|0}a=D()|0;C()|0;j[114630]=0;M(20);b=j[114630];j[114630]=0;if((b|0)!=1){break a}J(0)|0;C()|0;ib()}z()}G(a|0);z()}function Lca(a,b){a=a|0;b=b|0;var c=0,d=0;d=Za-16|0;Za=d;j[114630]=0;N(2010,a|0);c=j[114630];j[114630]=0;a:{b:{c:{d:{e:{f:{g:{h:{i:{if((c|0)!=1){c=j[a+24>>2];j[114630]=0;F(2058,d|0,c|0);c=j[114630];j[114630]=0;if((c|0)==1){break i}if(ec(d)>>>0<2147483647){break h}c=R(8)|0;j[114630]=0;E(2057,c|0,36392)|0;b=j[114630];j[114630]=0;if((b|0)==1){break g}j[114630]=0;I(2004,c|0,71740,265);b=j[114630];j[114630]=0;if((b|0)!=1){break b}b=J(0)|0;C()|0;break f}b=J(0)|0;C()|0;break e}b=J(0)|0;C()|0;break e}a=34181;j:{if((b|0)<0){break j}a=34181;if((ec(d)|0)<=(b|0)){break j}a=zb(ad(d,b))}b=Gd(a);Vc(d);break d}b=J(0)|0;C()|0;S(c|0)}Vc(d)}O(b|0)|0;b=0;j[114630]=0;L(1984,36439,a|0,0,0);a=j[114630];j[114630]=0;if((a|0)==1){break c}Q()}Za=d+16|0;return b|0}a=D()|0;C()|0;j[114630]=0;M(20);b=j[114630];j[114630]=0;if((b|0)!=1){break a}J(0)|0;C()|0;ib()}z()}G(a|0);z()}function Kca(a,b){a=a|0;b=b|0;var c=0,d=0;d=Za-16|0;Za=d;j[114630]=0;N(2010,a|0);c=j[114630];j[114630]=0;a:{b:{c:{d:{e:{f:{g:{h:{i:{if((c|0)!=1){c=j[a+24>>2];j[114630]=0;F(2059,d|0,c|0);c=j[114630];j[114630]=0;if((c|0)==1){break i}if(ec(d)>>>0<2147483647){break h}c=R(8)|0;j[114630]=0;E(2057,c|0,36392)|0;b=j[114630];j[114630]=0;if((b|0)==1){break g}j[114630]=0;I(2004,c|0,71740,265);b=j[114630];j[114630]=0;if((b|0)!=1){break b}b=J(0)|0;C()|0;break f}b=J(0)|0;C()|0;break e}b=J(0)|0;C()|0;break e}a=34181;j:{if((b|0)<0){break j}a=34181;if((ec(d)|0)<=(b|0)){break j}a=zb(ad(d,b))}b=Gd(a);Vc(d);break d}b=J(0)|0;C()|0;S(c|0)}Vc(d)}O(b|0)|0;b=0;j[114630]=0;L(1984,36471,a|0,0,0);a=j[114630];j[114630]=0;if((a|0)==1){break c}Q()}Za=d+16|0;return b|0}a=D()|0;C()|0;j[114630]=0;M(20);b=j[114630];j[114630]=0;if((b|0)!=1){break a}J(0)|0;C()|0;ib()}z()}G(a|0);z()}function Jca(a,b){a=a|0;b=b|0;var c=0,d=0;d=Za-16|0;Za=d;j[114630]=0;N(2010,a|0);c=j[114630];j[114630]=0;a:{b:{c:{d:{e:{f:{g:{h:{i:{if((c|0)!=1){c=j[a+24>>2];j[114630]=0;F(2060,d|0,c|0);c=j[114630];j[114630]=0;if((c|0)==1){break i}if(ec(d)>>>0<2147483647){break h}c=R(8)|0;j[114630]=0;E(2057,c|0,36392)|0;b=j[114630];j[114630]=0;if((b|0)==1){break g}j[114630]=0;I(2004,c|0,71740,265);b=j[114630];j[114630]=0;if((b|0)!=1){break b}b=J(0)|0;C()|0;break f}b=J(0)|0;C()|0;break e}b=J(0)|0;C()|0;break e}a=34181;j:{if((b|0)<0){break j}a=34181;if((ec(d)|0)<=(b|0)){break j}a=zb(ad(d,b))}b=Gd(a);Vc(d);break d}b=J(0)|0;C()|0;S(c|0)}Vc(d)}O(b|0)|0;b=0;j[114630]=0;L(1984,36501,a|0,0,0);a=j[114630];j[114630]=0;if((a|0)==1){break c}Q()}Za=d+16|0;return b|0}a=D()|0;C()|0;j[114630]=0;M(20);b=j[114630];j[114630]=0;if((b|0)!=1){break a}J(0)|0;C()|0;ib()}z()}G(a|0);z()}function Ica(a,b){a=a|0;b=b|0;var c=0,d=0;d=Za-16|0;Za=d;j[114630]=0;N(2010,a|0);c=j[114630];j[114630]=0;a:{b:{c:{d:{e:{f:{g:{h:{i:{if((c|0)!=1){c=j[a+24>>2];j[114630]=0;F(2061,d|0,c|0);c=j[114630];j[114630]=0;if((c|0)==1){break i}if(ec(d)>>>0<2147483647){break h}c=R(8)|0;j[114630]=0;E(2057,c|0,36392)|0;b=j[114630];j[114630]=0;if((b|0)==1){break g}j[114630]=0;I(2004,c|0,71740,265);b=j[114630];j[114630]=0;if((b|0)!=1){break b}b=J(0)|0;C()|0;break f}b=J(0)|0;C()|0;break e}b=J(0)|0;C()|0;break e}a=34181;j:{if((b|0)<0){break j}a=34181;if((ec(d)|0)<=(b|0)){break j}a=zb(ad(d,b))}b=Gd(a);Vc(d);break d}b=J(0)|0;C()|0;S(c|0)}Vc(d)}O(b|0)|0;b=0;j[114630]=0;L(1984,36533,a|0,0,0);a=j[114630];j[114630]=0;if((a|0)==1){break c}Q()}Za=d+16|0;return b|0}a=D()|0;C()|0;j[114630]=0;M(20);b=j[114630];j[114630]=0;if((b|0)!=1){break a}J(0)|0;C()|0;ib()}z()}G(a|0);z()}function Hca(a,b){a=a|0;b=b|0;var c=0,d=0;d=Za-16|0;Za=d;j[114630]=0;N(2010,a|0);c=j[114630];j[114630]=0;a:{b:{c:{d:{e:{f:{g:{h:{i:{if((c|0)!=1){c=j[a+24>>2];j[114630]=0;F(2062,d|0,c|0);c=j[114630];j[114630]=0;if((c|0)==1){break i}if(ec(d)>>>0<2147483647){break h}c=R(8)|0;j[114630]=0;E(2057,c|0,36392)|0;b=j[114630];j[114630]=0;if((b|0)==1){break g}j[114630]=0;I(2004,c|0,71740,265);b=j[114630];j[114630]=0;if((b|0)!=1){break b}b=J(0)|0;C()|0;break f}b=J(0)|0;C()|0;break e}b=J(0)|0;C()|0;break e}a=34181;j:{if((b|0)<0){break j}a=34181;if((ec(d)|0)<=(b|0)){break j}a=zb(ad(d,b))}b=Gd(a);Vc(d);break d}b=J(0)|0;C()|0;S(c|0)}Vc(d)}O(b|0)|0;b=0;j[114630]=0;L(1984,36568,a|0,0,0);a=j[114630];j[114630]=0;if((a|0)==1){break c}Q()}Za=d+16|0;return b|0}a=D()|0;C()|0;j[114630]=0;M(20);b=j[114630];j[114630]=0;if((b|0)!=1){break a}J(0)|0;C()|0;ib()}z()}G(a|0);z()}function JI(a,b,c){var d=0,e=0,f=0,g=0,h=0,i=0,l=0;d=Za-32|0;Za=d;j[114630]=0;g=E(15,d+24|0,a|0)|0;e=j[114630];j[114630]=0;a:{b:{c:{if((e|0)!=1){d:{e:{if(!k[g|0]){break e}e=uk(d+8|0,a);h=j[(j[j[a>>2]-12>>2]+a|0)+4>>2];f=j[j[a>>2]-12>>2];j[114630]=0;f=a+f|0;i=H(16,f|0)|0;l=j[114630];j[114630]=0;if((l|0)==1){break d}e=j[e>>2];j[114630]=0;c=b+c|0;b=_(17,e|0,b|0,((h&176)==32?c:b)|0,c|0,f|0,i|0)|0;c=j[114630];j[114630]=0;if((c|0)==1){break d}j[d+16>>2]=b;if(!tk(d+16|0)){break e}b=j[j[a>>2]-12>>2];j[114630]=0;F(18,a+b|0,5);b=j[114630];j[114630]=0;if((b|0)!=1){break e}break d}nf(g);break b}b=J(0)|0;C()|0;nf(g);break c}b=J(0)|0;C()|0}O(b|0)|0;b=j[j[a>>2]-12>>2];j[114630]=0;N(19,a+b|0);b=j[114630];j[114630]=0;if((b|0)==1){break a}Q()}Za=d+32|0;return a}a=D()|0;C()|0;j[114630]=0;M(20);b=j[114630];j[114630]=0;if((b|0)==1){J(0)|0;C()|0;ib();z()}G(a|0);z()}function wH(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=q(0);b=Za-32|0;Za=b;e=j[a+20>>2];a:{if(!e){break a}if(tc(e+4|0)>>>0<4){break a}yi(b+8|0,j[a+20>>2]+4|0);e=vga(b+16|0,b+8|0);j[114630]=0;d=H(390,e|0)|0;c=j[114630];j[114630]=0;b:{if((c|0)!=1){if(d){break b}d=j[j[a>>2]+40>>2];j[114630]=0;d=H(d|0,a|0)|0;c=j[114630];j[114630]=0;c:{if((c|0)==1){break c}if(tc(j[a+20>>2]+4|0)-4>>>0<d<<2>>>0){break b}c=j[j[a>>2]+168>>2];j[114630]=0;F(c|0,a|0,-1);c=j[114630];j[114630]=0;if((c|0)==1){break c}if(d){c=0;while(1){j[114630]=0;g=q(oa(700,e|0));f=j[114630];j[114630]=0;if((f|0)==1){break c}f=j[j[a>>2]+44>>2];j[114630]=0;ma(f|0,a|0,c|0,q(g));f=j[114630];j[114630]=0;if((f|0)==1){break c}c=c+1|0;if((d|0)!=(c|0)){continue}break}}d=j[j[a>>2]+172>>2];j[114630]=0;N(d|0,a|0);a=j[114630];j[114630]=0;if((a|0)!=1){break b}}}a=D()|0;C()|0;jb(e);G(a|0);z()}jb(e)}Za=b+32|0}function rK(a,b,c){var d=0,e=0,f=0;e=Za-16|0;Za=e;a:{if(j[a+480180>>2]==4){d=k[b+833|0];if(c){h[b+833|0]=d&15|c<<4;break a}c=(d&240)>>>4|0;break a}if(j[a+480180>>2]!=1048576){break a}if(c){h[b+833|0]=c;break a}c=k[b+833|0]}b:{if(!(h[b+872|0]&1)|!(c&255)){break b}d=j[b+700>>2];if(!d){break b}c:{if(!(k[a+480208|0]&16)){break c}d=j[b+700>>2];if(j[a+480180>>2]==4){break c}c=kx(a,c&15);f=HMa(c,c>>31,d,d>>31)+32768|0;c=ab;c=ic(IMa(f,f>>>0<32768?c+1|0:c,65536,0),ab);j[b+700>>2]=c;if((c|0)!=(d|0)){break b}a=a+1074308|0;mb(e+8|0,a,7);if(!(!kb(e+8|0)|j[b+700>>2]==2147483647)){j[b+700>>2]=j[b+700>>2]+1;break b}mb(e+8|0,a,7);if(kb(e+8|0)){break b}a=j[b+700>>2];if((a|0)<2){break b}j[b+700>>2]=a-1;break b}c=d-((c&255)<<2)|0;j[b+700>>2]=c;if((c|0)>0){break b}j[b+700>>2]=1;if(j[a+480180>>2]!=2){break b}j[b+696>>2]=0;j[b+88>>2]=j[b+88>>2]|2101248}Za=e+16|0}function ula(a,b,c,d){var e=0;e=Za-48|0;Za=e;a=Cb(a);a:{b:{b=b-1|0;switch(b|0){case 0:case 3:break b;default:break a}}d=d?d-1|0:0}c:{d:{e:{f:{g:{h:{i:{j:{switch(b|0){case 0:case 1:h[e+32|0]=0;b=zm(c,c+d|0,e+32|0);j[114630]=0;K(119,a|0,c|0,b|0)|0;b=j[114630];j[114630]=0;if((b|0)!=1){break i}b=D()|0;C()|0;break c;case 2:case 3:break j;default:break i}}j[114630]=0;K(119,a|0,c|0,c+d|0)|0;b=j[114630];j[114630]=0;if((b|0)==1){break h}Vka(nd(a),_e(a),nd(a));j[114630]=0;c=E(120,e+16|0,a|0)|0;b=j[114630];j[114630]=0;if((b|0)==1){break g}j[114630]=0;d=E(85,e|0,6640)|0;b=j[114630];j[114630]=0;if((b|0)==1){break f}j[114630]=0;I(121,e+32|0,c|0,d|0);b=j[114630];j[114630]=0;if((b|0)==1){break e}ob(a,e+32|0);gb(e+32|0);gb(d);gb(c)}Za=e+48|0;return}b=D()|0;C()|0;break c}b=D()|0;C()|0;break c}b=D()|0;C()|0;break d}b=D()|0;C()|0;gb(d)}gb(c)}gb(a);G(b|0);z()}function KU(a,b,c,d){var e=0,f=0,g=0,i=0,l=0,n=0,o=0,p=0;e=Za-32|0;Za=e;h[e+24|0]=k[a|0];h[e+25|0]=k[a+1|0];h[e+26|0]=k[a+2|0];h[e+27|0]=k[a+3|0];f=HA(e+8|0);b=a+b|0;j[f+12>>2]=b-4;j[f+8>>2]=a;wi(f,k[b-1|0]);a:{if(!d){break a}a=d;while(1){if(!wi(f,1)){j[e+4>>2]=1;while(1){b=wi(f,2);j[e+4>>2]=b+j[e+4>>2];if((b|0)==3){continue}break}jc(e+4|0,a);b=0;if(j[e+4>>2]){while(1){a=a-1|0;o=c+a|0,p=wi(f,8),h[o|0]=p;b=b+1|0;if(b>>>0<m[e+4>>2]){continue}break}}if(!a){break a}}b=wi(f,2);j[e+4>>2]=b+2;b:{if((b|0)==3){b=f;i=b;g=7;c:{if(!wi(b,1)){break c}g=k[Pb(e+24|0,3)|0]}g=wi(i,g);while(1){b=wi(f,3);j[e+4>>2]=b+j[e+4>>2];if((b|0)==7){continue}break}break b}g=wi(f,k[Pb(e+24|0,b)|0])}jc(e+4|0,a);i=0;l=j[e+4>>2];if(l){while(1){b=0;n=a+g|0;if(n>>>0<d>>>0){b=k[c+n|0]}a=a-1|0;h[c+a|0]=b;i=i+1|0;if((l|0)!=(i|0)){continue}break}}if(a){continue}break}}Za=e+32|0}function PJ(a,b){var c=0;c=Za-16|0;Za=c;a=gx(a);a:{b:{c:{switch(b-1|0){default:if((b|0)!=16777216){break b}vb(a,7,1);vb(a,9,1);vb(a,10,1);vb(a,13,1);vb(a,15,1);vb(a,16,1);vb(a,17,1);vb(a,18,1);vb(a,20,1);vb(a,21,1);vb(a,24,1);vb(a,25,1);vb(a,26,1);vb(a,28,1);vb(a,30,1);vb(a,31,1);vb(a,33,1);vb(a,34,1);vb(a,39,1);vb(a,41,1);vb(a,44,1);vb(a,46,1);vb(a,45,1);vb(a,47,1);vb(a,48,1);vb(a,50,1);vb(a,99,1);vb(a,102,1);vb(a,104,1);vb(a,105,1);vb(a,108,1);break a;case 1:cx(c,2);b=j[c+12>>2];j[a+8>>2]=j[c+8>>2];j[a+12>>2]=b;b=j[c+4>>2];j[a>>2]=j[c>>2];j[a+4>>2]=b;rg(a,107);break a;case 3:cx(c,4);b=j[c+12>>2];j[a+8>>2]=j[c+8>>2];j[a+12>>2]=b;b=j[c+4>>2];j[a>>2]=j[c>>2];j[a+4>>2]=b;rg(a,4);break a;case 2:break b;case 0:break c}}vb(a,88,1);break a}cx(c,b);b=j[c+12>>2];j[a+8>>2]=j[c+8>>2];j[a+12>>2]=b;b=j[c+4>>2];j[a>>2]=j[c>>2];j[a+4>>2]=b}Za=c+16|0}function bCa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,j=0,m=0,n=0,o=0,q=0,r=0,s=0;e=Za-16|0;Za=e;h[e+15|0]=8;h[e+14|0]=0;i[e+12>>1]=0;if(d){q=p(c,d);while(1){if((q|0)>=1){m=(o<<1)+b|0;s=m+(q<<1)|0;while(1){i[e+10>>1]=0;SO(a,e+14|0,e+12|0,e+15|0,e+10|0);a:{b:{g=k[e+15|0];if(!g){break b}c=l[e+12>>1];while(1){j=c<<1;c=j&254;i[e+12>>1]=c;f=(j&65534)>>>0>255;h[e+14|0]=f;j=e;if(!c){if(!re(a,e+9|0)){break b}f=k[e+9|0];c=f<<1&254|1;i[e+12>>1]=c;f=f>>>7|0}n=l[e+10>>1]<<1|f;i[j+10>>1]=n;g=g-1|0;if(g&255){continue}break}break a}n=l[e+10>>1]}c=1;g=n&65535;c:{if(g>>>0<4){break c}j=15;while(1){c=j;f=c&255;if(f>>>0<2){break c}j=c-1|0;if(!(g&1<<f)){continue}break}}h[e+15|0]=(k[e+15|0]+c&254)>>>1;c=n&1;h[e+14|0]=c;r=(c-1^(n&65534)>>>1)+r|0;i[m>>1]=r;m=(d<<1)+m|0;if(s>>>0>m>>>0){continue}break}}o=o+1|0;if((o|0)!=(d|0)){continue}break}}Za=e+16|0}function Lua(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,k=0,l=0,m=0,n=0;g=Za-16|0;Za=g;k=j[a+40>>2];l=j[a+36>>2];n=j[a+16>>2];h=j[a+4>>2];e=h;f=j[a>>2];j[g+8>>2]=f;j[g+12>>2]=e;h=j[a+12>>2];j[g>>2]=j[a+8>>2];j[g+4>>2]=h;a:{if(!d){h=k>>12;m=l>>12;break a}while(1){h=j[a+32>>2];l=j[a+28>>2]+l|0;m=l>>12;e=(e<<1)+n|0;f=(((f>>>16|0)+4&131064)<<1)+b|0;e=(((((p(i[e+4>>1],i[f+34>>1])+p(i[e+2>>1],i[f+32>>1])|0)+p(i[e+6>>1],i[f+36>>1])|0)+p(i[e+8>>1],i[f+38>>1])|0)/2|0)+((((p(i[e-4>>1],i[f+26>>1])+p(i[e-6>>1],i[f+24>>1])|0)+p(i[e-2>>1],i[f+28>>1])|0)+p(i[e>>1],i[f+30>>1])|0)/2|0)|0)/16384|0;j[c>>2]=j[c>>2]+p(m,e);k=h+k|0;h=k>>12;j[c+4>>2]=j[c+4>>2]+p(e,h);Bb(g+8|0,g);d=d-1|0;if(d){c=c+8|0;f=j[g+8>>2];e=j[g+12>>2];continue}break}f=j[g+8>>2];e=j[g+12>>2]}j[a+40>>2]=k;j[a+20>>2]=m;j[a+36>>2]=l;j[a+24>>2]=h;j[a>>2]=f;j[a+4>>2]=e;Za=g+16|0}function jy(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0;d=Za-80|0;Za=d;a:{b:{e=j[a+4>>2];if(e>>>0<b>>>0){g=vf(d+72|0);f=b-e|0;b=xs(a);if(!(f>>>0>b>>>0|e>>>0>b-f>>>0)){Xj(d+56|0,a);b=j[d+60>>2];j[d+72>>2]=j[d+56>>2];j[d+76>>2]=b;j[a+4>>2]=j[a+4>>2]+f;break b}hb(a);b=iy(d+56|0);e=j[a+4>>2];j[114630]=0;e=E(928,a|0,e+f|0)|0;h=j[114630];j[114630]=0;c:{if((h|0)==1){break c}j[114630]=0;F(929,b|0,e|0);e=j[114630];j[114630]=0;if((e|0)==1){break c}j[b+4>>2]=j[a+4>>2]+f;Zi(d+40|0,a);Xj(d+32|0,a);Zi(d+24|0,b);j[114630]=0;e=j[d+44>>2];j[d+8>>2]=j[d+40>>2];j[d+12>>2]=e;e=j[d+36>>2];j[d>>2]=j[d+32>>2];j[d+4>>2]=e;L(930,d+48|0,d+8|0,d|0,d+24|0);e=j[114630];j[114630]=0;if((e|0)==1){break c}e=j[d+52>>2];j[d+72>>2]=j[d+48>>2];j[d+76>>2]=e;hy(a,b);Vd(b);break b}a=D()|0;C()|0;Vd(b);G(a|0);z()}j[a+4>>2]=b;break a}Hp(vd(d+16|0,g),f,c)}Za=d+80|0}function h9(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0;d=Za-32|0;Za=d;e=Ng(a);f=b+24|0;a=j[f>>2];j[114630]=0;a=H(2188,a+484344|0)|0;c=j[114630];j[114630]=0;a:{b:{c:{if((c|0)==1){break c}j[114630]=0;F(1527,e|0,a|0);a=j[114630];j[114630]=0;if((a|0)==1){break c}a=0;d:{e:{f:{g:{while(1){c=j[f>>2];j[114630]=0;c=H(2188,c+484344|0)|0;g=j[114630];j[114630]=0;if((g|0)==1){break b}if(a>>>0>=c>>>0){break d}c=Hb(j[f>>2]+484344|0,a);j[114630]=0;F(2185,d|0,c|0);c=j[114630];j[114630]=0;if((c|0)!=1){j[114630]=0;I(2179,d+16|0,b|0,d|0);c=j[114630];j[114630]=0;if((c|0)==1){break g}j[114630]=0;F(1529,e|0,d+16|0);c=j[114630];j[114630]=0;if((c|0)==1){break f}a=a+1|0;gb(d+16|0);gb(d);continue}break}a=D()|0;C()|0;break a}a=D()|0;C()|0;break e}a=D()|0;C()|0;gb(d+16|0)}gb(d);break a}Za=d+32|0;return}a=D()|0;C()|0;break a}a=D()|0;C()|0}Vc(e);G(a|0);z()}function Mua(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,k=0,l=0,m=0,n=0,o=0;g=Za-16|0;Za=g;l=j[a+40>>2];m=j[a+36>>2];o=j[a+16>>2];k=j[a+4>>2];e=k;f=j[a>>2];j[g+8>>2]=f;j[g+12>>2]=e;k=j[a+12>>2];j[g>>2]=j[a+8>>2];j[g+4>>2]=k;a:{if(!d){k=l>>12;n=m>>12;break a}while(1){k=j[a+32>>2];m=j[a+28>>2]+m|0;n=m>>12;e=e+o|0;f=(((f>>>16|0)+4&131064)<<1)+b|0;e=(((((p(h[e+2|0],i[f+34>>1])+p(h[e+1|0],i[f+32>>1])|0)+p(h[e+3|0],i[f+36>>1])|0)+p(h[e+4|0],i[f+38>>1])<<8)/2|0)+((((p(h[e-2|0],i[f+26>>1])+p(h[e-3|0],i[f+24>>1])|0)+p(h[e-1|0],i[f+28>>1])|0)+p(h[e|0],i[f+30>>1])<<8)/2|0)|0)/16384|0;j[c>>2]=j[c>>2]+p(n,e);l=k+l|0;k=l>>12;j[c+4>>2]=j[c+4>>2]+p(e,k);Bb(g+8|0,g);d=d-1|0;if(d){c=c+8|0;f=j[g+8>>2];e=j[g+12>>2];continue}break}f=j[g+8>>2];e=j[g+12>>2]}j[a+40>>2]=l;j[a+20>>2]=n;j[a+36>>2]=m;j[a+24>>2]=k;j[a>>2]=f;j[a+4>>2]=e;Za=g+16|0}function FG(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=+c;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;var k=0,l=0;k=Za+ -64|0;Za=k;j[k+60>>2]=e;e=j[a+4>>2];l=j[a>>2];a=j[a+8>>2];j[114630]=0;j[k+40>>2]=b;j[k+52>>2]=a;j[k+44>>2]=l;j[k+48>>2]=e;j[k+20>>2]=d?d:1992;I(1993,k+24|0,k+20|0,k+60|0);a=j[114630];j[114630]=0;a:{b:{c:{d:{if((a|0)!=1){b=io(k+32|0,k+24|0);j[114630]=0;a=j[k+52>>2];j[k+8>>2]=j[k+48>>2];j[k+12>>2]=a;a=j[k+44>>2];j[k>>2]=j[k+40>>2];j[k+4>>2]=a;c=+la(1994,k|0,+c,b|0);a=j[114630];j[114630]=0;if((a|0)==1){break d}Gc(b);Gc(k+24|0);break b}a=J(0)|0;C()|0;break c}a=J(0)|0;C()|0;Gc(b);Gc(k+24|0)}O(a|0)|0;j[114630]=0;Z(1995,34536,d|0,j[k+60>>2],f|0,g|0,h|0,i|0);a=j[114630];j[114630]=0;if((a|0)==1){break a}Q();c=0}Za=k- -64|0;return+c}a=D()|0;C()|0;j[114630]=0;M(20);b=j[114630];j[114630]=0;if((b|0)!=1){G(a|0);z()}J(0)|0;C()|0;ib();z()}function Fea(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,k=0,l=0,m=q(0),o=0,p=q(0),r=q(0),s=q(0),t=q(0),u=q(0),v=q(0),w=q(0),x=q(0),y=q(0);i=Za-16|0;Za=i;k=a+44|0;if(Xg(k)){h=wd(k,0);j[i+8>>2]=h;l=wd(k,1);j[i+12>>2]=l;e=Rc(k,0);j[i>>2]=e;f=Rc(k,1);j[i+4>>2]=f;a:{if(n[a+4216>>2]!=q(.5)){if(!d){break a}h=d;while(1){f=0;l=1;while(1){f=f<<2;e=f+(i+8|0)|0;g=j[e>>2];j[e>>2]=g+4;e=a+f|0;o=e+4248|0;s=n[o>>2];m=n[g>>2];t=n[a+4228>>2];u=n[a+4224>>2];v=n[a+4220>>2];w=n[a+4236>>2];x=n[a+4232>>2];g=e+4240|0;p=n[g>>2];n[o>>2]=p;n[g>>2]=m;g=e+4264|0;y=n[g>>2];e=e+4256|0;r=n[e>>2];n[g>>2]=r;m=q(q(q(q(p*u)+q(v*m))+q(s*t))-q(q(y*w)+q(r*x)));n[e>>2]=m;f=f+i|0;e=j[f>>2];j[f>>2]=e+4;n[e>>2]=m;e=l;l=0;f=1;if(e){continue}break}h=h-1|0;if(h){continue}break}break a}g=h;h=d<<2;Vb(e,g,h);Vb(f,l,h)}Sh(a,b,c,Rc(k,0),Rc(k,1),d)}Za=i+16|0}function kma(a,b,c){var d=0,e=0,f=0,g=0,i=0;d=Za-16|0;Za=d;a:{if(!(k[b+90|0]&4)|(j[a+480208>>2]&2101248)==2101248){break a}b:{if(j[c>>2]<=0){mb(d+8|0,a+1074308|0,21);if(!kb(d+8|0)){break b}}g=5;if(!(j[a+480180>>2]&5)){mb(d+8|0,a+1074308|0,21);g=kb(d+8|0)?5:6}f=Tw(a,k[b+845|0],k[b+840|0]);c:{if((k[b+845|0]&3)!=1){break c}mb(d+8|0,a+1074308|0,89);if(!kb(d+8|0)){break c}f=k[b+839|0];i=k[b+840|0];e=i<<2&124;e=(!(k[b+90|0]&2)|k[a+480209|0]&16?f:k[b+843|0]+f|0)&32?e^127:e;f=i&32?0-e|0:e}e=c;if(j[a+480180>>2]!=131072){c=j[c>>2]+((p(k[b+847|0],f)|0)/(1<<g)|0)|0}else{c=j[c>>2];c=((p(k[b+847|0],p(c,64-f|0))|0)/-8192|0)+c|0}j[e>>2]=c}if(!(j[a+480180>>2]&16777248)|k[a+480208|0]&4?k[a+480209|0]&16:0){break a}mb(d+8|0,a+1074308|0,21);c=kb(d+8|0);a=k[b+846|0];if(c){h[b+840|0]=k[b+840|0]+(a<<2);break a}h[b+840|0]=a+k[b+840|0]}Za=d+16|0}function SR(a,b){var c=0,d=0;d=k[a|0];if(d>>>0>=36){h[a|0]=0;return}c=k[d+12560|0];h[a|0]=c;a:{b:{c:{d:{e:{f:{if(c>>>0<=16){if(c-6>>>0>=2){if((c|0)==1){break f}if((c|0)!=11){break a}}c=k[b|0];a=c&240;if(!a|(a|0)==240|(c&15)==15){break a}h[b|0]=a;return}switch(c-17|0){case 1:case 3:case 4:case 5:break a;case 0:break c;case 2:break d;case 6:break e;default:break b}}if(k[b|0]){break a}h[a|0]=0;return}a=k[b|0];if(a>>>0<=64){h[b|0]=a<<1;return}h[b|0]=128;return}g:{h:{i:{j:{c=k[b|0];switch((c&240)-48>>>4|0){case 4:break g;case 2:break h;case 1:break i;case 0:break j;default:break a}}h[a|0]=20;h[b|0]=159;return}h[a|0]=20;h[b|0]=192;return}if(c&14){break a}h[a|0]=21;h[b|0]=(k[b|0]!=80)<<6;return}h[a|0]=20;h[b|0]=k[b|0]&15|160;return}if(k[b|0]>31){break a}h[a|0]=16;return}if((c|0)!=31){break a}h[b|0]=(d<<5|k[b|0]<<24>>>27)^128}}function LM(a){a=a|0;var b=0;Ab(a,0,288);Sx(a+288|0);Vo(a+800|0);h[a+2|0]=k[18178];b=k[18176]|k[18177]<<8;h[a|0]=b;h[a+1|0]=b>>>8;h[a+34|0]=k[18181];b=k[18179]|k[18180]<<8;h[a+32|0]=b;h[a+33|0]=b>>>8;b=k[18185]|k[18186]<<8|(k[18187]<<16|k[18188]<<24);h[a+99|0]=b;h[a+100|0]=b>>>8;h[a+101|0]=b>>>16;h[a+102|0]=b>>>24;b=k[18182]|k[18183]<<8|(k[18184]<<16|k[18185]<<24);h[a+96|0]=b;h[a+97|0]=b>>>8;h[a+98|0]=b>>>16;h[a+99|0]=b>>>24;b=k[18189]|k[18190]<<8|(k[18191]<<16|k[18192]<<24);h[a+128|0]=b;h[a+129|0]=b>>>8;h[a+130|0]=b>>>16;h[a+131|0]=b>>>24;b=k[18192]|k[18193]<<8|(k[18194]<<16|k[18195]<<24);h[a+131|0]=b;h[a+132|0]=b>>>8;h[a+133|0]=b>>>16;h[a+134|0]=b>>>24;h[a+260|0]=k[18200];b=k[18196]|k[18197]<<8|(k[18198]<<16|k[18199]<<24);h[a+256|0]=b;h[a+257|0]=b>>>8;h[a+258|0]=b>>>16;h[a+259|0]=b>>>24;qwa(a+288|0);pwa(a+800|0)}function Jha(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,k=0;a:{b:{if((Te(a)|0)==(b|0)){if((Te(a+12|0)|0)==(c|0)){break b}}j[114630]=0;F(1636,a|0,b|0);d=j[114630];j[114630]=0;c:{d:{if((d|0)==1){break d}j[114630]=0;e=a+12|0;F(1636,e|0,c|0);d=j[114630];j[114630]=0;if((d|0)==1){break d}j[114630]=0;f=a+24|0;F(1637,f|0,b|0);d=j[114630];j[114630]=0;if((d|0)==1){break d}j[114630]=0;g=a+36|0;F(1637,g|0,c|0);d=j[114630];j[114630]=0;if((d|0)==1){break d}if(b){d=0;while(1){h=Al(a,d);i=xb(f,d),k=h,j[i>>2]=k;d=d+1|0;if((d|0)!=(b|0)){continue}break}}if(c){break c}return 1}b=J(71412)|0;if((C()|0)!=(W(71412)|0)){break a}O(b|0)|0;_H(a);ZH(a);b=a+12|0;_H(b);ZH(b);b=a+24|0;YH(b);XH(b);a=a+36|0;YH(a);XH(a);Q();return 0}a=0;while(1){b=Al(e,a);i=xb(g,a),k=b,j[i>>2]=k;a=a+1|0;if((c|0)!=(a|0)){continue}break}}return 1}G(b|0);z()}function aCa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,j=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0;e=Za-16|0;Za=e;h[e+15|0]=4;h[e+14|0]=0;i[e+12>>1]=0;if(d){q=p(c,d);s=(q|0)<1;while(1){if(!s){m=b+o|0;t=q+m|0;while(1){h[e+11|0]=0;RO(a,e+14|0,e+12|0,e+11|0);a:{b:{g=k[e+15|0];if(!g){break b}c=l[e+12>>1];while(1){j=c<<1;c=j&254;i[e+12>>1]=c;f=(j&65534)>>>0>255;h[e+14|0]=f;j=e;if(!c){if(!re(a,e+10|0)){break b}f=k[e+10|0];c=f<<1&254|1;i[e+12>>1]=c;f=f>>>7|0}n=k[e+11|0]<<1|f;h[j+11|0]=n;g=g-1|0;if(g&255){continue}break}break a}n=k[e+11|0]}c=1;g=n&255;c:{if(g>>>0<4){break c}j=7;while(1){c=j;f=c&255;if(f>>>0<2){break c}j=c-1|0;if(!(g&1<<f)){continue}break}}h[e+15|0]=(k[e+15|0]+c&254)>>>1;c=n&1;h[e+14|0]=c;r=(c-1^(n&254)>>>1)+r|0;h[m|0]=r;m=d+m|0;if(t>>>0>m>>>0){continue}break}}o=o+1|0;if((o|0)!=(d|0)){continue}break}}Za=e+16|0}function v2(a,b,c){var d=0,e=0,f=0,g=0,i=0;i=Za-16|0;Za=i;a:{b:{c:{d:{if(a){if(c>>>0>=4){break d}d=c;break c}c=0;a=j[b>>2];d=j[a>>2];if(!d){break a}while(1){f=1;if(d>>>0>=128){g=-1;f=Cj(i+12|0,d,0);if((f|0)==-1){break a}}d=j[a+4>>2];a=a+4|0;c=c+f|0;g=c;if(d){continue}break}break a}f=j[b>>2];d=c;while(1){e=j[f>>2];e:{if(e-1>>>0>=127){if(!e){h[a|0]=0;j[b>>2]=0;break b}g=-1;e=Cj(a,e,0);if((e|0)==-1){break a}d=d-e|0;a=a+e|0;break e}h[a|0]=e;d=d-1|0;f=j[b>>2];a=a+1|0}f=f+4|0;j[b>>2]=f;if(d>>>0>3){continue}break}}if(d){f=j[b>>2];while(1){e=j[f>>2];f:{if(e-1>>>0>=127){if(!e){h[a|0]=0;j[b>>2]=0;break b}g=-1;e=Cj(i+12|0,e,0);if((e|0)==-1){break a}if(d>>>0<e>>>0){break b}Cj(a,j[f>>2],0);d=d-e|0;a=a+e|0;break f}h[a|0]=e;d=d-1|0;f=j[b>>2];a=a+1|0}f=f+4|0;j[b>>2]=f;if(d){continue}break}}g=c;break a}g=c-d|0}Za=i+16|0;return g}function mD(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0,k=0,l=0;g=Za-1040|0;Za=g;h=j[b>>2];j[g+12>>2]=h;k=a?a:g+16|0;a:{b:{c:{d=a?d:256;if(!d|!h){break c}f=c>>>2|0;l=f>>>0>=d>>>0;if(d>>>0>f>>>0?c>>>0<=131:0){break b}while(1){f=l?d:f;c=c-f|0;f=Yu(k,g+12|0,f,e);if((f|0)==-1){d=0;h=j[g+12>>2];i=-1;break c}h=(g+16|0)==(k|0);k=h?k:(f<<2)+k|0;i=f+i|0;d=d-(h?0:f)|0;h=j[g+12>>2];if(!d|!h){break c}f=c>>>2|0;l=f>>>0>=d>>>0;if(d>>>0<=f>>>0|c>>>0>131){continue}break}break b}if(!h){break a}}if(!d|!c){break a}f=i;while(1){d:{i=Un(k,h,c,e);e:{if(i+2>>>0<=2){f:{switch(i+1|0){case 1:j[g+12>>2]=0;break e;case 0:break a;default:break f}}j[e>>2]=0;break e}h=j[g+12>>2]+i|0;j[g+12>>2]=h;f=f+1|0;d=d-1|0;if(d){break d}}i=f;break a}k=k+4|0;c=c-i|0;i=f;if(c){continue}break}}if(a){j[b>>2]=j[g+12>>2]}Za=g+1040|0;return i|0}function ypa(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,l=0,m=0,n=0,q=0,s=0,t=0;f=Za-16|0;Za=f;q=f,s=p(j[a>>2],be(a)),j[q+4>>2]=s;jc(f+4|0,c>>>3|0);c=lb(b);h=o[e+8>>3];g=j[f+4>>2];a:{if(!g){break a}e=g;while(1){m=(k[c+4|0]|k[c+5|0]<<8|(k[c+6|0]<<16|k[c+7|0]<<24))&2147483647;PMa(0,k[c|0]|k[c+1|0]<<8|(k[c+2|0]<<16|k[c+3|0]<<24));PMa(1,m|0);h=u(+QMa(),h);c=c+8|0;e=e-1|0;if(e){continue}break}if(!g|h==0){break a}n=1/h;c=j[a+20>>2];while(1){a=b;e=k[a+4|0]|k[a+5|0]<<8|(k[a+6|0]<<16|k[a+7|0]<<24);PMa(0,k[a|0]|k[a+1|0]<<8|(k[a+2|0]<<16|k[a+3|0]<<24));PMa(1,e|0);q=f,t=+QMa()*n,o[q+8>>3]=t;wf(f+8|0,-1,1);l=o[f+8>>3]*32768;o[f+8>>3]=l;a=c;l=zd(l);b:{if(r(l)<2147483648){e=~~l;break b}e=-2147483648}q=a,s=Dc(e),i[q>>1]=s;b=b+8|0;c=c+2|0;g=g-1|0;if(g){continue}break}}if(d){o[d>>3]=h}Za=f+16|0;return j[f+4>>2]<<3}function w3(a,b){var c=0,d=0,e=0,f=0,g=0;c=Za-32|0;Za=c;j[c+28>>2]=0;a:{b:{if(k[Ki(c+24|0,a,0)|0]){hc(c+16|0,j[j[a>>2]-12>>2]+a|0);j[114630]=0;e=H(2371,c+16|0)|0;d=j[114630];j[114630]=0;c:{d:{if((d|0)==1){break d}d=em(c+8|0,a);f=dk(c);g=j[j[a>>2]-12>>2];f=j[f>>2];d=j[d>>2];j[114630]=0;_(2372,e|0,d|0,f|0,a+g|0,c+28|0,b|0)|0;b=j[114630];j[114630]=0;if((b|0)==1){break d}wb(c+16|0);break c}b=J(0)|0;C()|0;wb(c+16|0);O(b|0)|0;b=j[c+28>>2]|1;j[c+28>>2]=b;Ii(j[j[a>>2]-12>>2]+a|0,b);b=j[j[a>>2]-12>>2];j[114630]=0;b=j[(a+b|0)+20>>2];e=j[114630];j[114630]=0;e:{if((e|0)!=1){if(!(b&1)){break e}j[114630]=0;M(81);a=j[114630];j[114630]=0;if((a|0)!=1){break a}}a=D()|0;C()|0;j[114630]=0;M(20);b=j[114630];j[114630]=0;if((b|0)==1){break b}G(a|0);z()}Q()}eg(j[j[a>>2]-12>>2]+a|0,j[c+28>>2])}Za=c+32|0;return a}J(0)|0;C()|0;ib()}z()}function r3(a,b){var c=0,d=0,e=0,f=0,g=0;c=Za-32|0;Za=c;j[c+28>>2]=0;a:{b:{if(k[Ki(c+24|0,a,0)|0]){hc(c+16|0,j[j[a>>2]-12>>2]+a|0);j[114630]=0;e=H(2371,c+16|0)|0;d=j[114630];j[114630]=0;c:{d:{if((d|0)==1){break d}d=em(c+8|0,a);f=dk(c);g=j[j[a>>2]-12>>2];f=j[f>>2];d=j[d>>2];j[114630]=0;_(2375,e|0,d|0,f|0,a+g|0,c+28|0,b|0)|0;b=j[114630];j[114630]=0;if((b|0)==1){break d}wb(c+16|0);break c}b=J(0)|0;C()|0;wb(c+16|0);O(b|0)|0;b=j[c+28>>2]|1;j[c+28>>2]=b;Ii(j[j[a>>2]-12>>2]+a|0,b);b=j[j[a>>2]-12>>2];j[114630]=0;b=j[(a+b|0)+20>>2];e=j[114630];j[114630]=0;e:{if((e|0)!=1){if(!(b&1)){break e}j[114630]=0;M(81);a=j[114630];j[114630]=0;if((a|0)!=1){break a}}a=D()|0;C()|0;j[114630]=0;M(20);b=j[114630];j[114630]=0;if((b|0)==1){break b}G(a|0);z()}Q()}eg(j[j[a>>2]-12>>2]+a|0,j[c+28>>2])}Za=c+32|0;return a}J(0)|0;C()|0;ib()}z()}function o3(a,b){var c=0,d=0,e=0,f=0,g=0;c=Za-32|0;Za=c;j[c+28>>2]=0;a:{b:{if(k[Ki(c+24|0,a,0)|0]){hc(c+16|0,j[j[a>>2]-12>>2]+a|0);j[114630]=0;e=H(2371,c+16|0)|0;d=j[114630];j[114630]=0;c:{d:{if((d|0)==1){break d}d=em(c+8|0,a);f=dk(c);g=j[j[a>>2]-12>>2];f=j[f>>2];d=j[d>>2];j[114630]=0;_(2376,e|0,d|0,f|0,a+g|0,c+28|0,b|0)|0;b=j[114630];j[114630]=0;if((b|0)==1){break d}wb(c+16|0);break c}b=J(0)|0;C()|0;wb(c+16|0);O(b|0)|0;b=j[c+28>>2]|1;j[c+28>>2]=b;Ii(j[j[a>>2]-12>>2]+a|0,b);b=j[j[a>>2]-12>>2];j[114630]=0;b=j[(a+b|0)+20>>2];e=j[114630];j[114630]=0;e:{if((e|0)!=1){if(!(b&1)){break e}j[114630]=0;M(81);a=j[114630];j[114630]=0;if((a|0)!=1){break a}}a=D()|0;C()|0;j[114630]=0;M(20);b=j[114630];j[114630]=0;if((b|0)==1){break b}G(a|0);z()}Q()}eg(j[j[a>>2]-12>>2]+a|0,j[c+28>>2])}Za=c+32|0;return a}J(0)|0;C()|0;ib()}z()}function m3(a,b){var c=0,d=0,e=0,f=0,g=0;c=Za-32|0;Za=c;j[c+28>>2]=0;a:{b:{if(k[Ki(c+24|0,a,0)|0]){hc(c+16|0,j[j[a>>2]-12>>2]+a|0);j[114630]=0;e=H(2371,c+16|0)|0;d=j[114630];j[114630]=0;c:{d:{if((d|0)==1){break d}d=em(c+8|0,a);f=dk(c);g=j[j[a>>2]-12>>2];f=j[f>>2];d=j[d>>2];j[114630]=0;_(2377,e|0,d|0,f|0,a+g|0,c+28|0,b|0)|0;b=j[114630];j[114630]=0;if((b|0)==1){break d}wb(c+16|0);break c}b=J(0)|0;C()|0;wb(c+16|0);O(b|0)|0;b=j[c+28>>2]|1;j[c+28>>2]=b;Ii(j[j[a>>2]-12>>2]+a|0,b);b=j[j[a>>2]-12>>2];j[114630]=0;b=j[(a+b|0)+20>>2];e=j[114630];j[114630]=0;e:{if((e|0)!=1){if(!(b&1)){break e}j[114630]=0;M(81);a=j[114630];j[114630]=0;if((a|0)!=1){break a}}a=D()|0;C()|0;j[114630]=0;M(20);b=j[114630];j[114630]=0;if((b|0)==1){break b}G(a|0);z()}Q()}eg(j[j[a>>2]-12>>2]+a|0,j[c+28>>2])}Za=c+32|0;return a}J(0)|0;C()|0;ib()}z()}function Apa(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=q(0),l=q(0),m=q(0),o=0,s=0;f=Za-16|0;Za=f;o=f,s=p(j[a>>2],be(a)),j[o+8>>2]=s;jc(f+8|0,c>>>2|0);c=lb(b);h=n[e+4>>2];e=j[f+8>>2];if(e){while(1){g=k[c|0]|k[c+1|0]<<8|(k[c+2|0]<<16|k[c+3|0]<<24);h=q(u(q(r((PMa(2,g<<24|g<<8&16711680|(g>>>8&65280|g>>>24)),TMa()))),h));c=c+4|0;e=e-1|0;if(e){continue}break}}c=h==q(0);a:{if(c){break a}e=j[f+8>>2];if(!e){break a}m=c?q(1):q(q(1)/h);c=j[a+20>>2];while(1){a=k[b|0]|k[b+1|0]<<8|(k[b+2|0]<<16|k[b+3|0]<<24);n[f+12>>2]=m*(PMa(2,a<<24|a<<8&16711680|(a>>>8&65280|a>>>24)),TMa());Kd(f+12|0,q(-1));l=q(n[f+12>>2]*q(32768));n[f+12>>2]=l;a=c;l=Rd(l);b:{if(q(r(l))<q(2147483648)){g=~~l;break b}g=-2147483648}o=a,s=Dc(g),i[o>>1]=s;b=b+4|0;c=c+2|0;e=e-1|0;if(e){continue}break}}if(d){n[d>>2]=h}Za=f+16|0;return j[f+8>>2]<<2}function oya(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0;d=Za-32|0;Za=d;md(c,2);h[d+16|0]=k[b+13|0];h[d|0]=64;f=c,g=k[Zb(d+16|0,d)|0]<<2,i[f+30>>1]=g;e=b+14|0;j[c+24>>2]=(k[e|0]|k[e+1|0]<<8)<<1;ek(d,2,b+1|0);qc(d+16|0,d);j[114630]=0;E(370,c+43|0,d+16|0)|0;e=j[114630];j[114630]=0;if((e|0)!=1){gb(d+16|0);e=Kc(a,8,1,0,2);a:{if((k[b|0]&3)!=1){break a}a=b+22|0;j[c>>2]=k[a|0]|k[a+1|0]<<8|(k[a+2|0]<<16|k[a+3|0]<<24);a=b+26|0;j[c+4>>2]=k[a|0]|k[a+1|0]<<8|(k[a+2|0]<<16|k[a+3|0]<<24);a=b+30|0;a=k[a|0]|k[a+1|0]<<8|(k[a+2|0]<<16|k[a+3|0]<<24);j[c+8>>2]=a;if(a>>>0>m[c+4>>2]){j[c+8>>2]=a-1}if(k[b|0]&4){i[c+34>>1]=l[c+34>>1]|2}if(k[b|0]&8){i[c+34>>1]=l[c+34>>1]|4}if(!(k[b|0]&16)){break a}lz(e);ej(e,9);j[c>>2]=j[c>>2]>>>1;j[c+4>>2]=j[c+4>>2]>>>1;j[c+8>>2]=j[c+8>>2]>>>1}Za=d+32|0;return}a=D()|0;C()|0;gb(d+16|0);G(a|0);z()}function MKa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0;d=Za-16|0;Za=d;md(b,0);j[b>>2]=k[a|0]|k[a+1|0]<<8|(k[a+2|0]<<16|k[a+3|0]<<24);c=tt(a+4|0,a);j[b+4>>2]=k[c|0]|k[c+1|0]<<8|(k[c+2|0]<<16|k[c+3|0]<<24);c=tt(a+8|0,a);j[b+8>>2]=k[c|0]|k[c+1|0]<<8|(k[c+2|0]<<16|k[c+3|0]<<24);c=a+15|0;j[b+24>>2]=(k[c|0]|k[c+1|0]<<8)<<1;if(!(k[c|0]|k[c+1|0]<<8)){j[b+24>>2]=16726}c=a+14|0;e=b,f=(p(ks(h[a+17|0],k[c|0]<<28>>24),j[b+24>>2])>>>0)/8363|0,j[e+24>>2]=f;h[d+15|0]=k[a+18|0];h[d+14|0]=127;e=b,f=(((k[Zb(d+15|0,d+14|0)|0]<<8|64)&65344)>>>0)/127|0,i[e+30>>1]=f;if(k[c|0]>=16){c=k[c|0];i[b+34>>1]=32;i[b+28>>1]=c&240}a=a+19|0;if(k[a|0]&4){i[b+34>>1]=l[b+34>>1]|1}a:{if(!(k[a|0]&8)|m[b+4>>2]>=m[b+8>>2]){break a}i[b+34>>1]=l[b+34>>1]|2;if(k[a|0]&16){i[b+34>>1]=l[b+34>>1]|4}if(!(k[a|0]&64)){break a}i[b+34>>1]=l[b+34>>1]|128}Za=d+16|0}function KJ(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0;e=Za-16|0;Za=e;a:{b:{d=a+484360|0;if(Yb(Eb(d))>>>0<=b>>>0){break b}if(Po(Eb(d),b)){break b}while(1){b=b+1|0;c=b&65535;if(Yb(Eb(d))>>>0<=c>>>0){break a}if(!Po(Eb(d),b&65535)){continue}break}break a}c=b}if(Yb(Eb(d))>>>0>c>>>0){d=a+1074308|0;f=a+1304360|0;c=a+1074984|0;while(1){h[c+819|0]=0;j[c+700>>2]=0;h[c+861|0]=0;h[c+827|0]=0;j[c+708>>2]=0;h[c+841|0]=0;j[c+804>>2]=0;h[c+839|0]=0;h[c+840|0]=0;mb(e+8|0,d,23);if(kb(e+8|0)){i[c+798>>1]=0;i[c+800>>1]=1}h[c+859|0]=0;c=c+896|0;if((f|0)!=(c|0)){continue}break}JJ(a);c:{if(!(b&65535)){lna(a);break c}i[a+1074440>>1]=b;i[a+1074436>>1]=0;b=a+1074424|0;j[b>>2]=0;j[b+4>>2]=0;j[a+1074432>>2]=0;b=a+1074396|0;j[b>>2]=0;j[b+4>>2]=0;j[a+1074380>>2]=0;j[a+1074392>>2]=j[a+1074416>>2]}j[a+480208>>2]=j[a+480208>>2]&-769}Za=e+16|0}function yM(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,m=0;e=Za-32|0;Za=e;d=c&4;a:{if(!(b&4)){if(!d){break a}h[a+15|0]=k[a+16|0];b=k[a+12|0];h[a+12|0]=b&247;if(!(b&2)){break a}b=k[a+14|0];if(b>>>0<=k[a+13|0]){break a}if(sb(a)>>>0<=b>>>0){break a}while(1){d=kc(a,b);i[d>>1]=l[d>>1]+1;b=b+1|0;if(sb(a)>>>0>b>>>0){continue}break}break a}if(d){break a}b=k[a+14|0];b:{if(b>>>0>=k[a+15|0]){break b}d=k[a+12|0];if(!(d&2)){break b}h[a+12|0]=d&251}if(!(k[a+12|0]&2)|b>>>0<=k[a+13|0]){break a}if(sb(a)>>>0<=b>>>0){break a}d=l[kc(a,k[a+14|0])>>1];f=kc(a,k[a+14|0]-1|0);b=k[a+14|0];if(l[f>>1]<(d-1|0)){b=l[kc(a,b)>>1]-1&65535;d=To(a,b,64,64);g=e,m=Lb(a),j[g+8>>2]=m;g=e,m=So(e+8|0,k[a+14|0]),j[g+16>>2]=m;f=Cd(e+24|0,e+16|0);b=ep(e,b,d&255);Xta(a,j[f>>2],b);break a}h[a+14|0]=b-1}if((c|0)!=16777216){h[a+17|0]=255}Za=e+32|0}function Zsa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,k=0;c=Za+ -64|0;Za=c;cf(a,c+62|0);a:{b:{c:{d:{e:{f:{g:{e=j[19863];if(l[c+62>>1]>l[e+12>>1]){f=j[b+12>>2];Bz(c+16|0,18533);j[114630]=0;L(1176,c+32|0,c+16|0,c+62|0,e+12|0);d=j[114630];j[114630]=0;if((d|0)==1){break g}j[114630]=0;d=E(649,c+48|0,c+32|0)|0;g=j[114630];j[114630]=0;if((g|0)==1){break f}j[114630]=0;F(624,f|0,d|0);f=j[114630];j[114630]=0;if((f|0)==1){break e}gb(d);gb(c+32|0);qb(c+16|0);i[c+62>>1]=l[e+12>>1]}bg(ei(b,0),l[c+62>>1]);b=ei(b,0);h=c,k=Lb(b),j[h+48>>2]=k;h=c,k=Mb(b),j[h+16>>2]=k;if(rb(c+48|0,c+16|0)){break b}break a}b=D()|0;C()|0;break c}b=D()|0;C()|0;break d}b=D()|0;C()|0;gb(d)}gb(c+32|0)}qb(c+16|0);G(b|0);z()}while(1){b=j[c+48>>2];cf(a,c+14|0);i[b>>1]=l[c+14>>1];je(c+48|0);if(rb(c+48|0,c+16|0)){continue}break}}Za=c- -64|0}function oX(a){var b=0,c=q(0),d=q(0),e=q(0),f=q(0),g=0,h=q(0),i=q(0);b=(SMa(a),OMa(2));a:{b:{if(!((b|0)>-1?b>>>0>=8388608:0)){if(!(b&2147483647)){return q(q(-1)/q(a*a))}if((b|0)<=-1){return q(q(a-a)/q(0))}b=(SMa(q(a*q(33554432))),OMa(2));g=-152;break b}if(b>>>0>2139095039){break a}g=-127;a=q(0);if((b|0)==1065353216){break a}}b=b+4913933|0;h=q((b>>>23|0)+g|0);a=q((PMa(2,(b&8388607)+1060439283|0),TMa())+q(-1));c=q(a*q(a*q(.5)));d=q(a/q(a+q(2)));e=q(d*d);f=q(e*e);i=a;a=(PMa(2,(SMa(q(a-c)),OMa(2))&-4096),TMa());c=q(q(q(i-a)-c)+q(d*q(c+q(q(e*q(q(f*q(.2849878668785095))+q(.6666666269302368)))+q(f*q(q(f*q(.24279078841209412))+q(.40000972151756287)))))));a=q(q(h*q(.3010292053222656))+q(q(a*q(.434326171875))+q(q(c*q(.434326171875))+q(q(h*q(7.903415166765626e-7))+q(q(c+a)*q(-3168997136526741e-20))))))}return a}function rD(a,b){var c=0,d=0,e=0;a:{if(k[b|0]){break a}b=$u(60432);if(k[b|0]?b:0){break a}b=$u(p(a,12)+60448|0);if(k[b|0]?b:0){break a}b=$u(60520);if(k[b|0]?b:0){break a}b=60525}b:{while(1){e=k[b+c|0];if(!(!e|(e|0)==47)){e=15;c=c+1|0;if((c|0)!=15){continue}break b}break}e=c}d=60525;c:{d:{c=k[b|0];e:{f:{if(!(k[b+e|0]|(c|0)==46)){d=b;if((c|0)!=67){break f}}if(!k[d+1|0]){break e}}if(!Lh(d,60525)){break e}if(Lh(d,60533)){break d}}if(!a){c=60356;if(k[d+1|0]==46){break c}}return 0}c=j[115418];if(c){while(1){if(!Lh(d,c+8|0)){break c}c=j[c+24>>2];if(c){continue}break}}c=j[115418];if(c){while(1){if(!Lh(d,c+8|0)){return c}c=j[c+24>>2];if(c){continue}break}}c=Yc(28);g:{if(!c){c=0;break g}b=j[15090];j[c>>2]=j[15089];j[c+4>>2]=b;b=c+8|0;Vb(b,d,e);h[b+e|0]=0;j[c+24>>2]=j[115418];j[115418]=c}c=a|c?c:60356}return c}function Zka(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;d=Za-16|0;Za=d;md(b,4);i[b+30>>1]=k[a+12|0]<<2;Rf(b+30|0,256);c=k[a+15|0];i[b+34>>1]=32;i[b+28>>1]=c;h[b+37|0]=k[a+13|0];h[b+36|0]=k[a+16|0];j[b>>2]=k[a|0]|k[a+1|0]<<8|(k[a+2|0]<<16|k[a+3|0]<<24);c=a+4|0;e=k[c|0]|k[c+1|0]<<8|(k[c+2|0]<<16|k[c+3|0]<<24);j[b+4>>2]=e;c=a+8|0;j[b+8>>2]=e+(k[c|0]|k[c+1|0]<<8|(k[c+2|0]<<16|k[c+3|0]<<24));a=a+14|0;if(k[a|0]&16){j[b>>2]=j[b>>2]>>>1;j[b+4>>2]=j[b+4>>2]>>>1;j[b+8>>2]=j[b+8>>2]>>>1}if(k[a|0]&32){j[b>>2]=j[b>>2]>>>1;j[b+4>>2]=j[b+4>>2]>>>1;j[b+8>>2]=j[b+8>>2]>>>1}a:{if(!(k[a|0]&3)|m[b+8>>2]<=m[b+4>>2]){break a}i[b+34>>1]=l[b+34>>1]|2;if(!(k[a|0]&2)){break a}i[b+34>>1]=l[b+34>>1]|4}a=Db(d,31680);j[114630]=0;E(370,b+43|0,a|0)|0;b=j[114630];j[114630]=0;if((b|0)!=1){gb(a);Za=d+16|0;return}b=D()|0;C()|0;gb(a);G(b|0);z()}function spa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=q(0),g=0,h=0,l=q(0),m=0,o=0;e=Za-16|0;Za=e;j[e+12>>2]=c>>>3;j[e+8>>2]=j[a>>2];h=j[tb(e+12|0,e+8|0)>>2];l=n[d>>2];b=lb(b);if(h){a=j[a+20>>2];c=h;while(1){d=k[b|0]|k[b+1|0]<<8|(k[b+2|0]<<16|k[b+3|0]<<24);n[e+12>>2]=l*(PMa(2,d<<24|d<<8&16711680|(d>>>8&65280|d>>>24)),TMa());Kd(e+12|0,q(-1));f=q(n[e+12>>2]*q(32768));n[e+12>>2]=f;d=a;f=Rd(f);a:{if(q(r(f))<q(2147483648)){g=~~f;break a}g=-2147483648}m=d,o=Dc(g),i[m>>1]=o;d=k[b+4|0]|k[b+5|0]<<8|(k[b+6|0]<<16|k[b+7|0]<<24);n[e+12>>2]=l*(PMa(2,d<<24|d<<8&16711680|(d>>>8&65280|d>>>24)),TMa());Kd(e+12|0,q(-1));f=q(n[e+12>>2]*q(32768));n[e+12>>2]=f;d=a;f=Rd(f);b:{if(q(r(f))<q(2147483648)){g=~~f;break b}g=-2147483648}m=d,o=Dc(g),i[m+2>>1]=o;a=a+4|0;b=b+8|0;c=c-1|0;if(c){continue}break}}Za=e+16|0;return h<<3}function gwa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,j=0,m=0;e=Za-48|0;Za=e;i[a>>1]=0;i[a+2>>1]=0;i[a+4>>1]=0;dn(b,e+44|0);a:{if(!JM(e+44|0)){break a}d=k[e+46|0];g=k[e+47|0];f=k[e+45|0];h[a+4|0]=1;j=f>>>3&3;c=(j|0)!=3;m=f>>>1&3;f=m^3;g=g>>>0<192;i[a+2>>1]=l[(p(c,6)+18424|0)+(f<<1)>>1]<<g;f=p(p(k[f+(p(c,3)+18201|0)|0],l[((p(c,90)+18208|0)+p(f,30)|0)+(d>>>3&30)>>1]),1e3);d=d>>>1|0;d=p(((f>>>0)/l[(p(j,6)+18400|0)+(d&6)>>1]|0)+(d&1)|0,(m|0)==3?4:1);i[a>>1]=d;c=k[g+((c<<1)+18436|0)|0];if(c+8>>>0>(d&65535)>>>0){break a}fwa(b,e,c+4|0);b=2;if(c>>>0>2){while(1){if(k[b+e|0]){break a}b=b+1|0;if((c|0)!=(b|0)){continue}break}}b=a;c=c+e|0;d=1;b:{if((k[c|0]|k[c+1|0]<<8|(k[c+2|0]<<16|k[c+3|0]<<24))==1868983881){break b}d=(k[c|0]|k[c+1|0]<<8|(k[c+2|0]<<16|k[c+3|0]<<24))==1735289176}h[b+5|0]=d}Za=e+48|0;return a|0}function faa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,k=0,l=0,m=0,n=0;e=Za-48|0;Za=e;h=ho(a,c);i=eG(a+4|0);k=dG(a+24|0);l=cG(a+32|0);m=$v(a+36|0);j[a+56>>2]=3;n=Ng(a+68|0);j[114630]=0;F(2159,a|0,d|0);c=j[114630];j[114630]=0;a:{b:{c:{d:{if((c|0)!=1){c=j[b>>2];f=j[b+4>>2];g=j[b+12>>2];b=j[b+8>>2];j[e+8>>2]=b;j[e+12>>2]=g;j[114630]=0;j[e+24>>2]=b;j[e+28>>2]=g;j[e+16>>2]=c;j[e+20>>2]=f;j[e>>2]=c;j[e+4>>2]=f;I(2160,e+32|0,e|0,0);b=j[114630];j[114630]=0;if((b|0)==1){break d}j[114630]=0;I(2161,a|0,e+32|0,d|0);b=j[114630];j[114630]=0;if((b|0)==1){break c}jb(e+32|0);j[114630]=0;N(2162,a|0);b=j[114630];j[114630]=0;if((b|0)==1){break b}Za=e+48|0;return a|0}a=D()|0;C()|0;break a}a=D()|0;C()|0;break a}a=D()|0;C()|0;jb(e+32|0);break a}a=D()|0;C()|0}Vc(n);Ye(m);bf(l);jh(k);Gc(i);Gc(h);G(a|0);z()}function epa(a){a=a|0;var b=0,c=0,d=0,e=0,f=0;e=Za-32|0;Za=e;roa(a+8|0);j[a+32>>2]=0;j[a+36>>2]=0;c=a+4|0;j[j[c>>2]>>2]=0;j[j[c>>2]+40>>2]=j[j[a>>2]+480196>>2];j[j[c>>2]+44>>2]=j[j[a>>2]+480204>>2];j[j[c>>2]+68>>2]=j[j[a>>2]+480200>>2];f=l[j[a>>2]+480188>>1];b=e;j[b+24>>2]=0;j[b+28>>2]=0;j[b+16>>2]=0;j[b+20>>2]=0;j[b+8>>2]=0;j[b+12>>2]=0;b=b+8|0;j[b>>2]=0;j[b+4>>2]=0;h[b+21|0]=255;h[b+13|0]=0;h[b+14|0]=0;h[b+15|0]=0;h[b+16|0]=0;h[b+17|0]=0;h[b+18|0]=0;h[b+19|0]=0;h[b+20|0]=0;j[b+8>>2]=0;j[b+12>>2]=0;Toa(a+20|0,f,b);if(l[j[a>>2]+480188>>1]){while(1){b=p(d,896);Tm((b+j[c>>2]|0)+608|0,j[a>>2],d&65535);h[(b+j[c>>2]|0)+1445|0]=0;h[(b+j[c>>2]|0)+1444|0]=0;h[(b+j[c>>2]|0)+1429|0]=0;h[(b+j[c>>2]|0)+1432|0]=0;h[(b+j[c>>2]|0)+1427|0]=0;d=d+1|0;if(d>>>0<l[j[a>>2]+480188>>1]){continue}break}}Za=e+32|0}function P4(a,b){var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0;d=Za-32|0;Za=d;RMa(+a);g=OMa(1)|0;e=OMa(0)|0;RMa(+b);f=OMa(1)|0;h=OMa(0)|0;i=g&2147483647;c=i;f=f&2147483647;j=(c|0)==(f|0)&e>>>0<h>>>0|c>>>0<f>>>0;g=j?e:h;c=j?c:f;j=c;PMa(0,g|0);PMa(1,c|0);a=+QMa();c=c>>>20|0;a:{if((c|0)==2047){break a}l=e;e=(f|0)==(i|0)&e>>>0>h>>>0|f>>>0<i>>>0;h=e?l:h;i=e?i:f;e=i;PMa(0,h|0);PMa(1,e|0);b=+QMa();b:{if(!(g|j)){break b}g=e>>>20|0;if((g|0)==2047){break b}if((g-c|0)>=65){a=b+a;break a}c:{if(g>>>0>=1534){a=a*1.90109156629516e-211;b=b*1.90109156629516e-211;k=5.260135901548374e+210;break c}k=1;if(c>>>0>572){break c}a=a*5.260135901548374e+210;b=b*5.260135901548374e+210;k=1.90109156629516e-211}CE(d+24|0,d+16|0,b);CE(d+8|0,d,a);a=k*y(o[d>>3]+o[d+16>>3]+o[d+8>>3]+o[d+24>>3]);break a}a=b}Za=d+32|0;return a}function tr(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0;d=Za-176|0;Za=d;e=Mg(d+40|0);f=j[j[e>>2]-12>>2];j[114630]=0;g=T(122)|0;h=j[114630];j[114630]=0;a:{b:{c:{d:{e:{if((h|0)==1){break e}j[114630]=0;I(123,d+32|0,f+(d+40|0)|0,g|0);f=j[114630];j[114630]=0;if((f|0)==1){break e}wb(d+32|0);j[114630]=0;F(142,e|0,c|0);f=j[114630];j[114630]=0;if((f|0)==1){break e}j[114630]=0;F(133,e|0,b|0);b=j[114630];j[114630]=0;if((b|0)==1){break e}j[114630]=0;F(125,d|0,e|0);b=j[114630];j[114630]=0;if((b|0)==1){break e}j[114630]=0;I(140,d+16|0,d|0,c|0);b=j[114630];j[114630]=0;if((b|0)==1){break d}j[114630]=0;I(141,a|0,d+16|0,c|0);a=j[114630];j[114630]=0;if((a|0)==1){break c}gb(d+16|0);gb(d);Hd(e);Za=d+176|0;return}c=D()|0;C()|0;break a}c=D()|0;C()|0;break b}c=D()|0;C()|0;gb(d+16|0)}gb(d)}Hd(e);G(c|0);z()}function lH(a){var b=0,c=q(0),d=0,e=0,f=q(0);b=Za-16|0;Za=b;d=we(j[a+16>>2]);e=a,f=Yd(q(10),q(q(q(n[a+4208>>2]*q(120))+q(-60))*q(.05000000074505806))),n[e+4232>>2]=f;c=q(q(d>>>0)*q(.0010000000474974513));e=a,f=Yd(q(10),q(q(-1)/q(q(q(n[a+4212>>2]*q(499.989990234375))+q(.009999999776482582))*c))),n[e+4236>>2]=f;e=a,f=Yd(q(10),q(q(-1)/q(q(q(n[a+4216>>2]*q(2950))+q(50))*c))),n[e+4240>>2]=f;j[b+12>>2]=1325400064;e=b,f=q(q(T4(q(Yd(q(10),q(q(q(n[a+4220>>2]*q(60))+q(-60))*q(.05000000074505806)))*q(2147483648)))*q(96817624))+q(67108864)),n[e+8>>2]=f;e=a,f=q(n[Vk(b+12|0,b+8|0)>>2]*q(4.656612873077393e-10)),n[e+4244>>2]=f;n[a+4248>>2]=q(q(-1)/q(q(n[a+4224>>2]*q(99))+q(1)))+q(1);d=a;c=q(q(q(n[a+4228>>2]*q(4))*c)+q(2));a:{if(q(r(c))<q(2147483648)){a=~~c;break a}a=-2147483648}j[d+4252>>2]=a;Za=b+16|0}function dea(){var a=0,b=0,c=0,d=0,e=0;a=Za-48|0;Za=a;c=Cb(a+32|0);j[114630]=0;N(1989,a+16|0);b=j[114630];j[114630]=0;a:{b:{c:{d:{e:{f:{if((b|0)!=1){d=a,e=Lb(a+16|0),j[d+8>>2]=e;d=a,e=Mb(a+16|0),j[d>>2]=e;if(!rb(a+8|0,a)){break e}break f}b=J(0)|0;C()|0;break c}while(1){b=j[a+8>>2];j[114630]=0;E(1245,c|0,b|0)|0;b=j[114630];j[114630]=0;if((b|0)==1){break d}cn(a+8|0);d=a,e=Mb(a+16|0),j[d>>2]=e;if(!rb(a+8|0,a)){break e}j[114630]=0;E(1990,c|0,34201)|0;b=j[114630];j[114630]=0;if((b|0)!=1){continue}break}break d}b=Gd(zb(c));Vc(a+16|0);gb(c);break b}b=J(0)|0;C()|0;Vc(a+16|0)}gb(c);O(b|0)|0;b=0;j[114630]=0;L(1984,34203,0,0,0);c=j[114630];j[114630]=0;if((c|0)==1){break a}Q()}Za=a+48|0;return b|0}a=D()|0;C()|0;j[114630]=0;M(20);c=j[114630];j[114630]=0;if((c|0)!=1){G(a|0);z()}J(0)|0;C()|0;ib();z()}function oEa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0;g=Za-16|0;Za=g;h[g+14|0]=d;h[g+15|0]=c;h[g+13|0]=e;h[g+12|0]=f;if((d-1&255)>>>0<=5){h[g+14|0]=d+15}MP(g+15|0,g+13|0);MP(g+14|0,g+12|0);a:{if(k[g+15|0]==10){h[g+13|0]=k[g+13|0]&15?-1:k[g+12|0];if(k[g+14|0]!=10){break a}h[g+14|0]=0;break a}if(k[g+14|0]!=10){break a}h[g+12|0]=k[g+12|0]&15?-1:0}if(b){h[a+2|0]=1;h[a+4|0]=b+2>>>2}Dw(g+15|0,g+13|0,g+14|0,g+12|0);c=k[g+15|0];b:{if(!c){break b}d=k[g+14|0];if(!d){h[g+14|0]=c;h[g+12|0]=k[g+13|0];h[g+15|0]=0;break b}if(!((c|0)==20|(c|0)!=(d|0))){h[g+15|0]=0;break b}if(!b){Cw(g+8|0,g+15|0,g+13|0,g+14|0,g+12|0);h[a+2|0]=k[g+15|0];h[a+4|0]=k[g+13|0];break b}if(ym(c)>>>0<=ym(k[g+14|0])>>>0){break b}Ug(g+15|0,g+14|0);Ug(g+13|0,g+12|0)}h[a+3|0]=k[g+14|0];h[a+5|0]=k[g+12|0];Za=g+16|0}function daa(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0,k=0,l=0,m=0;f=Za-32|0;Za=f;d=ho(a,d);h=eG(a+4|0);i=dG(a+24|0);k=cG(a+32|0);l=$v(a+36|0);j[a+56>>2]=3;m=Ng(a+68|0);j[114630]=0;F(2159,a|0,e|0);g=j[114630];j[114630]=0;a:{b:{c:{d:{if((g|0)!=1){j[114630]=0;b=H(2166,b|0)|0;g=j[114630];j[114630]=0;if((g|0)==1){break d}j[114630]=0;I(2167,f+8|0,b|0,c|0);b=j[114630];j[114630]=0;if((b|0)==1){break d}j[114630]=0;I(2168,f+16|0,f+8|0,0);b=j[114630];j[114630]=0;if((b|0)==1){break d}j[114630]=0;I(2161,a|0,f+16|0,e|0);b=j[114630];j[114630]=0;if((b|0)==1){break c}jb(f+16|0);j[114630]=0;N(2162,a|0);b=j[114630];j[114630]=0;if((b|0)!=1){break a}}a=D()|0;C()|0;break b}a=D()|0;C()|0;break b}a=D()|0;C()|0;jb(f+16|0)}Vc(m);Ye(l);bf(k);jh(i);Gc(h);Gc(d);G(a|0);z()}Za=f+32|0;return a|0}function jY(a,b){var c=0;while(1){if(j[a>>2]==1){continue}break}a:{b:{if(!j[a>>2]){c:{lf(a,1);j[114630]=0;c=j[114630];j[114630]=0;d:{if((c|0)==1){break d}j[114630]=0;N(2568,b|0);b=j[114630];j[114630]=0;if((b|0)==1){break d}j[114630]=0;b=j[114630];j[114630]=0;if((b|0)==1){break d}j[a>>2]=-1;j[114630]=0;b=j[114630];j[114630]=0;if((b|0)==1){break d}j[114630]=0;b=j[114630];j[114630]=0;if((b|0)!=1){break c}}b=J(0)|0;C()|0;O(b|0)|0;j[114630]=0;b=j[114630];j[114630]=0;e:{if((b|0)==1){break e}lf(a,0);j[114630]=0;a=j[114630];j[114630]=0;if((a|0)==1){break e}j[114630]=0;a=j[114630];j[114630]=0;if((a|0)==1){break e}j[114630]=0;M(81);a=j[114630];j[114630]=0;if((a|0)!=1){break a}}a=D()|0;C()|0;j[114630]=0;M(20);b=j[114630];j[114630]=0;if((b|0)==1){break b}G(a|0);z()}}return}J(0)|0;C()|0;ib()}z()}function yP(a){var b=0,c=0,d=0,e=0;b=Za-48|0;Za=b;c=k[a+8|0]|k[a+9|0]<<8|(k[a+10|0]<<16|k[a+11|0]<<24);j[b+8>>2]=(c<<24|c<<8&16711680|(c>>>8&65280|c>>>24))+788;j[b+12>>2]=0;c=k[a+16|0]|k[a+17|0]<<8|(k[a+18|0]<<16|k[a+19|0]<<24);j[b+16>>2]=c<<24|c<<8&16711680|(c>>>8&65280|c>>>24);j[b+20>>2]=0;c=b;e=b;if(k[a+24|0]|k[a+25|0]<<8|(k[a+26|0]<<16|k[a+27|0]<<24)){d=k[a+24|0]|k[a+25|0]<<8|(k[a+26|0]<<16|k[a+27|0]<<24);d=d<<24|d<<8&16711680|(d>>>8&65280|d>>>24)}else{d=52}j[e+24>>2]=d;j[c+28>>2]=0;c=k[a+32|0]|k[a+33|0]<<8|(k[a+34|0]<<16|k[a+35|0]<<24);j[b+44>>2]=4;j[b+40>>2]=b+8;a=j[b+44>>2];j[b>>2]=j[b+40>>2];j[b+4>>2]=a;j[b+32>>2]=(c<<8&16711680|c<<24|(c>>>8&65280|c>>>24))+80;j[b+36>>2]=0;d=TCa(j[b>>2],j[b>>2]+(j[b+4>>2]<<3)|0);a=j[d>>2];Za=b+48|0;ab=j[d+4>>2]-(a>>>0<52)|0;return a-52|0}function so(a){var b=0,c=0,d=0,e=0,f=0,g=0;c=Za-16|0;Za=c;a:{b:{switch(j[a+480224>>2]-1|0){default:b=j[a+24620>>2];d=b>>31;j[c+8>>2]=1;j[c>>2]=j[a+1074420>>2]<<1;d=HMa(b,d,5e4,0);e=ab;b=j[Lc(c+8|0,c)>>2];b=ic(IMa(d,e,b,b>>31),ab);j[a+1074404>>2]=b;break a;case 1:b=j[a+24620>>2];j[c+8>>2]=1;j[c+12>>2]=0;f=c,g=HMa(j[a+1074420>>2],0,HMa(j[a+1074408>>2],0,j[a+1074416>>2],0),ab),j[f>>2]=g;j[c+4>>2]=ab;d=HMa(b,0,6e5,0);e=ab;b=Tma(c+8|0,c);b=KMa(d,e,j[b>>2],j[b+4>>2]);j[a+1074404>>2]=b;break a;case 0:break b}}b=j[a+24620>>2];d=b>>31;j[c+8>>2]=1;j[c>>2]=j[a+1074420>>2];d=HMa(b,d,1e4,0);e=ab;b=j[Lc(c+8|0,c)>>2];b=ic(IMa(d,e,b,b>>31),ab);j[a+1074404>>2]=b}d=a+1074404|0;a=j[a+480244>>2];b=HMa(a,a>>31,b,b>>31)+32768|0;a=ab;a=ic(IMa(b,b>>>0<32768?a+1|0:a,65536,0),ab);j[d>>2]=a?a:1;Za=c+16|0}function Dpa(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,l=0,m=0,n=0,o=0,q=0,r=0;l=Za-16|0;Za=l;q=l,r=p(j[a>>2],be(a)),j[q+12>>2]=r;jc(l+12|0,c>>>2|0);c=lb(b);h=j[e+4>>2];f=j[l+12>>2];a:{if(!f){g=h;break a}while(1){e=lb(k[c|0]);e=e|lb(k[c+1|0])<<8|lb(k[c+2|0])<<16|lb(k[c+3|0])<<24;b:{if((e|0)<=-1){g=-2147483648;if((e|0)==-2147483648){break b}e=0-e|0}g=e>>>0>h>>>0?e:h}c=c+4|0;h=g;f=f-1|0;if(f){continue}break}}c:{if(!g){break c}e=j[l+12>>2];if(!e){break c}m=g-1|0;n=g>>>1|0;o=g;c=j[a+20>>2];while(1){a=lb(k[b|0]);a=a|lb(k[b+1|0])<<8|lb(k[b+2|0])<<16|lb(k[b+3|0])<<24;h=a>>31;f=a;a=h;h=a<<31|f>>>1;f=n|f<<31;a=m&a>>31;q=c,r=ic(IMa(f-a|0,h-(a>>>0>f>>>0)|0,o,0),ab)>>>16|0,i[q>>1]=r;b=b+4|0;c=c+2|0;e=e-1|0;if(e){continue}break}}if(d){j[d>>2]=g}Za=l+16|0;return j[l+12>>2]<<2}function Cpa(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,l=0,m=0,n=0,o=0,q=0,r=0;l=Za-16|0;Za=l;q=l,r=p(j[a>>2],be(a)),j[q+12>>2]=r;jc(l+12|0,c>>>2|0);c=lb(b);h=j[e+4>>2];f=j[l+12>>2];a:{if(!f){g=h;break a}while(1){e=lb(k[c+3|0]);e=e|lb(k[c+2|0])<<8|lb(k[c+1|0])<<16|lb(k[c|0])<<24;b:{if((e|0)<=-1){g=-2147483648;if((e|0)==-2147483648){break b}e=0-e|0}g=e>>>0>h>>>0?e:h}c=c+4|0;h=g;f=f-1|0;if(f){continue}break}}c:{if(!g){break c}e=j[l+12>>2];if(!e){break c}m=g-1|0;n=g>>>1|0;o=g;c=j[a+20>>2];while(1){a=lb(k[b+3|0]);a=a|lb(k[b+2|0])<<8|lb(k[b+1|0])<<16|lb(k[b|0])<<24;h=a>>31;f=a;a=h;h=a<<31|f>>>1;f=n|f<<31;a=m&a>>31;q=c,r=ic(IMa(f-a|0,h-(a>>>0>f>>>0)|0,o,0),ab)>>>16|0,i[q>>1]=r;b=b+4|0;c=c+2|0;e=e-1|0;if(e){continue}break}}if(d){j[d>>2]=g}Za=l+16|0;return j[l+12>>2]<<2}function qK(a,b,c){var d=0,e=0,f=0,g=0,h=0,i=0;e=Za-16|0;Za=e;a:{if(!j[b+700>>2]){break a}f=j[a+480180>>2]==64?p(c,-20):c;b:{if(!(!(k[a+480208|0]&16)|j[a+480180>>2]==4)){g=j[b+700>>2];c=f>>31;j[e+12>>2]=(c+f^c)>>>2;jc(e+12|0,255);d=j[e+12>>2];c:{if(!d){break c}h=b;c=j[b+700>>2];i=c;c=c>>31;d:{if((f|0)<=-1){d=kx(a,d);break d}d=jx(a,d)}d=HMa(i,c,d,d>>31)+32768|0;c=ab;c=ic(IMa(d,d>>>0<32768?c+1|0:c,65536,0),ab);j[h+700>>2]=c;if((c|0)!=(g|0)){break c}mb(e,a+1074308|0,7);d=kb(e);c=j[b+700>>2];if((d|0)==(f>>>31|0)){if((c|0)==2147483647){break c}j[b+700>>2]=j[b+700>>2]+1;break c}if((c|0)<2){break c}j[b+700>>2]=c-1}c=j[b+700>>2];break b}c=f+j[b+700>>2]|0;j[b+700>>2]=c}if((c|0)>0){break a}j[b+700>>2]=1;if(j[a+480180>>2]!=2){break a}j[b+696>>2]=0;j[b+88>>2]=j[b+88>>2]|2101248}Za=e+16|0}function ZG(a){var b=q(0),c=0,d=q(0),e=q(0),f=q(0),g=0,i=0,k=0,l=q(0);c=Za-16|0;Za=c;i=a,k=bi(q(n[a+4256>>2]*q(3))),j[i+4264>>2]=k;i=a,l=q(we(j[a+16>>2])>>>((j[a+4264>>2]>>>1^-1)&1)>>>0),n[i+4268>>2]=l;n[a+4272>>2]=q(n[a+4244>>2]*q(100))*q(.0061803399585187435);i=c,l=Yd(q(10),q(q(YG(a)+q(q(n[a+4228>>2]*q(11e3))+q(-1e4)))*q(.0005000000237487257))),n[i+12>>2]=l;j[c+8>>2]=1065353216;i=a,l=q(n[Vk(c+12|0,c+8|0)>>2]*q(.7609999775886536)),n[i+4280>>2]=l;g=a;b=Yd(q(10),q(q(q(n[a+4212>>2]*q(1e4))+q(-1e4))*q(.0010000000474974513)));if(b!=q(1)){d=ao(q(q(XG(a)*q(6.2831854820251465))/n[a+4268>>2]));e=q(b+b);f=q(b*b);b=q(b*q(8));b=Jm(q(q(q(q(d*e)+q(-2))+q(y(q(q(q(f*q(-4))+b)+q(q(q(q(f*q(4))*d)-b)*d)))))/q(e+q(-2))),q(0),q(1))}else{b=q(0)}n[g+4276>>2]=b;Rea(a);Qea(a);h[a+5046|0]=0;Za=c+16|0}function Hva(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,k=0,l=0,m=0,n=0,o=0;e=Za-32|0;Za=e;k=j[a+40>>2];l=j[a+36>>2];n=j[a+16>>2];b=j[a+4>>2];g=b;f=j[a>>2];j[e+24>>2]=f;j[e+28>>2]=b;b=j[a+12>>2];j[e+16>>2]=j[a+8>>2];j[e+20>>2]=b;a:{if(!d){h=k>>12;b=l>>12;break a}while(1){o=f>>>18|0;g=((((g&2147483647)<<1|f>>>31)&2147483646)<<1)+n|0;h=0;b=1;while(1){m=h<<1;f=i[m+g>>1];j[(e+8|0)+(h<<2)>>2]=f+((p(i[(m|4)+g>>1]-f|0,o)|0)/16384|0);f=b;b=0;h=1;if(f){continue}break}f=j[a+32>>2];l=j[a+28>>2]+l|0;b=l>>12;j[c>>2]=j[c>>2]+p(b,j[e+8>>2]);k=f+k|0;h=k>>12;j[c+4>>2]=j[c+4>>2]+p(h,j[e+12>>2]);Bb(e+24|0,e+16|0);d=d-1|0;if(d){c=c+8|0;f=j[e+24>>2];g=j[e+28>>2];continue}break}f=j[e+24>>2];g=j[e+28>>2]}j[a+40>>2]=k;j[a+20>>2]=b;j[a+36>>2]=l;j[a+24>>2]=h;j[a>>2]=f;j[a+4>>2]=g;Za=e+32|0}function R4(a){var b=0,c=q(0),d=q(0),e=0,f=0,g=q(0),h=q(0);e=(SMa(a),OMa(2));f=e>>>31|0;a:{b:{c:{d:{d=a;e:{f:{b=e&2147483647;g:{if(b>>>0>=1118743632){if(b>>>0>2139095040){return a}if(!((e|0)<0|b>>>0<1118925336)){return q(a*q(1.7014118346046923e+38))}if(b>>>0<=1120924084|(e|0)>-1){break g}break b}if(b>>>0<1051816473){break d}if(b>>>0<1065686419){break f}}a=q(q(a*q(1.4426950216293335))+n[(f<<2)+52288>>2]);if(q(r(a))<q(2147483648)){b=~~a;break e}b=-2147483648;break e}b=(f^1)-f|0}c=q(b|0);a=q(d+q(c*q(-.693145751953125)));g=q(c*q(1428606765330187e-21));d=q(a-g);break c}if(b>>>0<=956301312){break a}b=0;d=a}c=d;h=a;c=q(c*c);a=q(d-q(c*q(q(c*q(-.0027667332906275988))+q(.16666625440120697))));c=q(q(h+q(q(q(d*a)/q(q(2)-a))-g))+q(1));if(!b){break b}c=GE(c,b)}return c}return q(a+q(1))}function ao(a){var b=q(0),c=0,d=0,e=0,f=0;c=Za-16|0;Za=c;e=(SMa(a),OMa(2));d=e&2147483647;a:{if(d>>>0<=1061752794){b=q(1);if(d>>>0<964689920){break a}b=fh(+a);break a}if(d>>>0<=1081824209){f=+a;if(d>>>0>=1075235812){b=q(-fh(((e|0)>-1?-3.141592653589793:3.141592653589793)+f));break a}if((e|0)<=-1){b=gh(f+1.5707963267948966);break a}b=gh(1.5707963267948966-f);break a}if(d>>>0<=1088565717){if(d>>>0>=1085271520){b=fh(((e|0)>-1?-6.283185307179586:6.283185307179586)+ +a);break a}if((e|0)<=-1){b=gh(-4.71238898038469- +a);break a}b=gh(+a+ -4.71238898038469);break a}b=q(a-a);if(d>>>0>=2139095040){break a}b:{switch(wv(a,c+8|0)&3){case 0:b=fh(o[c+8>>3]);break a;case 1:b=gh(-o[c+8>>3]);break a;case 2:b=q(-fh(o[c+8>>3]));break a;default:break b}}b=gh(o[c+8>>3])}a=b;Za=c+16|0;return a}function aga(a,b,c){var d=0,e=0,f=0,g=0,h=0;d=Za-176|0;Za=d;e=Mg(d+40|0);f=j[j[e>>2]-12>>2];j[114630]=0;g=T(122)|0;h=j[114630];j[114630]=0;a:{b:{c:{d:{e:{if((h|0)==1){break e}j[114630]=0;I(123,d+32|0,f+(d+40|0)|0,g|0);f=j[114630];j[114630]=0;if((f|0)==1){break e}wb(d+32|0);j[114630]=0;F(148,e|0,c|0);f=j[114630];j[114630]=0;if((f|0)==1){break e}j[114630]=0;F(132,e|0,b|0);b=j[114630];j[114630]=0;if((b|0)==1){break e}j[114630]=0;F(125,d|0,e|0);b=j[114630];j[114630]=0;if((b|0)==1){break e}j[114630]=0;I(140,d+16|0,d|0,c|0);b=j[114630];j[114630]=0;if((b|0)==1){break d}j[114630]=0;I(141,a|0,d+16|0,c|0);a=j[114630];j[114630]=0;if((a|0)==1){break c}gb(d+16|0);gb(d);Hd(e);Za=d+176|0;return}c=D()|0;C()|0;break a}c=D()|0;C()|0;break b}c=D()|0;C()|0;gb(d+16|0)}gb(d)}Hd(e);G(c|0);z()}function tH(a,b,c){var d=0,e=0,f=0,g=0,h=0;d=Za-176|0;Za=d;e=Mg(d+40|0);f=j[j[e>>2]-12>>2];j[114630]=0;g=T(122)|0;h=j[114630];j[114630]=0;a:{b:{c:{d:{e:{if((h|0)==1){break e}j[114630]=0;I(123,d+32|0,f+(d+40|0)|0,g|0);f=j[114630];j[114630]=0;if((f|0)==1){break e}wb(d+32|0);j[114630]=0;F(147,e|0,c|0);f=j[114630];j[114630]=0;if((f|0)==1){break e}j[114630]=0;F(130,e|0,b|0);b=j[114630];j[114630]=0;if((b|0)==1){break e}j[114630]=0;F(125,d|0,e|0);b=j[114630];j[114630]=0;if((b|0)==1){break e}j[114630]=0;I(140,d+16|0,d|0,c|0);b=j[114630];j[114630]=0;if((b|0)==1){break d}j[114630]=0;I(141,a|0,d+16|0,c|0);a=j[114630];j[114630]=0;if((a|0)==1){break c}gb(d+16|0);gb(d);Hd(e);Za=d+176|0;return}c=D()|0;C()|0;break a}c=D()|0;C()|0;break b}c=D()|0;C()|0;gb(d+16|0)}gb(d)}Hd(e);G(c|0);z()}function Qxa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0;e=Za-16|0;Za=e;c=k[a|0]|k[a+1|0]<<8|(k[a+2|0]<<16|k[a+3|0]<<24);j[b>>2]=c<<24|c<<8&16711680|(c>>>8&65280|c>>>24);h[e+15|0]=k[a+4|0];h[e+14|0]=64;f=b,g=k[Zb(e+15|0,e+14|0)|0]<<2,i[f+30>>1]=g;c=a+6|0;d=k[c|0]|k[c+1|0]<<8|(k[c+2|0]<<16|k[c+3|0]<<24);j[b+4>>2]=d<<24|d<<8&16711680|(d>>>8&65280|d>>>24);a=a+10|0;a=k[a|0]|k[a+1|0]<<8|(k[a+2|0]<<16|k[a+3|0]<<24);d=a<<24|a<<8&16711680|(a>>>8&65280|a>>>24);a=k[c|0]|k[c+1|0]<<8|(k[c+2|0]<<16|k[c+3|0]<<24);a=d+(a<<8&16711680|a<<24|(a>>>8&65280|a>>>24))|0;j[b+8>>2]=a;d=j[b+4>>2];c=j[b>>2];if(d>>>0>=c>>>0){d=c-1|0;j[b+4>>2]=d}if(a>>>0>c>>>0){j[b+8>>2]=c;a=c}a:{if(a>>>0<d>>>0){j[b+4>>2]=0;j[b+8>>2]=0;break a}if(a>>>0<=d>>>0){break a}j[b+68>>2]=d;i[b+34>>1]=l[b+34>>1]|2}Za=e+16|0}function xj(a,b,c,d,e,f,g,i,l,m){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;i=i|0;l=l|0;m=m|0;var n=0,o=0,p=0;n=Za-16|0;Za=n;h[n+15|0]=a;a:{b:{c:{if(j[d>>2]!=(c|0)){break c}o=43;p=a&255;if((p|0)!=k[m+24|0]){o=45;if(k[m+25|0]!=(p|0)){break c}}j[d>>2]=c+1;h[c|0]=o;break b}if(!(!nb(g)|(a|0)!=(f|0))){a=0;b=j[l>>2];if((b-i|0)>159){break a}a=j[e>>2];j[l>>2]=b+4;j[b>>2]=a;break b}a=-1;f=zm(m,m+26|0,n+15|0)-m|0;if((f|0)>23){break a}d:{e:{switch(b-8|0){case 0:case 2:if((b|0)>(f|0)){break d}break a;case 1:break d;default:break e}}if((b|0)!=16|(f|0)<22){break d}b=j[d>>2];if((b|0)==(c|0)|(b-c|0)>2|k[b-1|0]!=48){break a}a=0;j[e>>2]=0;j[d>>2]=b+1;h[b|0]=k[f+64416|0];break a}a=j[d>>2];j[d>>2]=a+1;h[a|0]=k[f+64416|0];j[e>>2]=j[e>>2]+1;a=0;break a}a=0;j[e>>2]=0}Za=n+16|0;return a|0}function wj(a,b,c,d,e,f,g,i,l,m){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;i=i|0;l=l|0;m=m|0;var n=0,o=0;n=Za-16|0;Za=n;j[n+12>>2]=a;a:{b:{c:{if(j[d>>2]!=(c|0)){break c}o=43;if(j[m+96>>2]!=(a|0)){o=45;if(j[m+100>>2]!=(a|0)){break c}}j[d>>2]=c+1;h[c|0]=o;break b}if(!(!nb(g)|(a|0)!=(f|0))){a=0;b=j[l>>2];if((b-i|0)>159){break a}a=j[e>>2];j[l>>2]=b+4;j[b>>2]=a;break b}a=-1;g=Pu(m,m+104|0,n+12|0)-m|0;if((g|0)>92){break a}f=g>>2;d:{e:{switch(b-8|0){case 0:case 2:if((b|0)>(f|0)){break d}break a;case 1:break d;default:break e}}if((b|0)!=16|(g|0)<88){break d}b=j[d>>2];if((b|0)==(c|0)|(b-c|0)>2|k[b-1|0]!=48){break a}a=0;j[e>>2]=0;j[d>>2]=b+1;h[b|0]=k[f+64416|0];break a}a=j[d>>2];j[d>>2]=a+1;h[a|0]=k[f+64416|0];j[e>>2]=j[e>>2]+1;a=0;break a}a=0;j[e>>2]=0}Za=n+16|0;return a|0}function nf(a){var b=0,c=0;b=j[a+4>>2];c=j[j[b>>2]-12>>2];j[114630]=0;b=j[(b+c|0)+24>>2];c=j[114630];j[114630]=0;a:{if((c|0)==1){break a}b:{if(!b){break b}b=j[a+4>>2];c=j[j[b>>2]-12>>2];j[114630]=0;b=mf(b+c|0);c=j[114630];j[114630]=0;if((c|0)==1){break a}if(!b){break b}b=j[a+4>>2];if(!(j[(j[j[b>>2]-12>>2]+b|0)+4>>2]&8192)){break b}if(MB()){break b}b=j[a+4>>2];c=j[j[b>>2]-12>>2];j[114630]=0;b=j[(b+c|0)+24>>2];c=j[114630];j[114630]=0;c:{if((c|0)==1){break c}j[114630]=0;b=H(2370,b|0)|0;c=j[114630];j[114630]=0;if((c|0)==1){break c}if((b|0)!=-1){break b}a=j[a+4>>2];b=j[j[a>>2]-12>>2];j[114630]=0;F(18,a+b|0,1);a=j[114630];j[114630]=0;if((a|0)!=1){break b}}a=J(0)|0;C()|0;O(a|0)|0;j[114630]=0;M(20);a=j[114630];j[114630]=0;if((a|0)==1){break a}}return}J(0)|0;C()|0;ib();z()}function eq(a,b){a=a|0;b=b|0;var c=0,d=0;d=Za-16|0;Za=d;a=Qc(a);a:{b:{c:{switch(b|0){case 0:j[114630]=0;b=E(2,d|0,7167)|0;c=j[114630];j[114630]=0;if((c|0)==1){break a}ob(a,b);gb(b);break b;case 1:j[114630]=0;b=E(2,d|0,7192)|0;c=j[114630];j[114630]=0;if((c|0)!=1){ob(a,b);gb(b);break b}break a;case 2:j[114630]=0;b=E(2,d|0,7237)|0;c=j[114630];j[114630]=0;if((c|0)!=1){ob(a,b);gb(b);break b}break a;case 3:j[114630]=0;b=E(2,d|0,7264)|0;c=j[114630];j[114630]=0;if((c|0)!=1){ob(a,b);gb(b);break b}break a;case 4:j[114630]=0;b=E(2,d|0,7290)|0;c=j[114630];j[114630]=0;if((c|0)!=1){ob(a,b);gb(b);break b}break a;case 5:break c;default:break b}}j[114630]=0;b=E(2,d|0,7319)|0;c=j[114630];j[114630]=0;if((c|0)==1){break a}ob(a,b);gb(b)}Za=d+16|0;return}b=D()|0;C()|0;gb(a);G(b|0);z()}function EZ(a,b,c,d,e,f){var g=0;j[c>>2]=a;j[f>>2]=d;d=j[c>>2];a:{while(1){if(b>>>0<=d>>>0){g=0;break a}g=2;a=j[d>>2];if(a>>>0>1114111|(a&-2048)==55296){break a}b:{c:{if(a>>>0<=127){g=1;d=j[f>>2];if((e-d|0)<1){break a}j[f>>2]=d+1;h[d|0]=a;break c}if(a>>>0<=2047){d=j[f>>2];if((e-d|0)<2){break b}j[f>>2]=d+1;h[d|0]=a>>>6|192;d=j[f>>2];j[f>>2]=d+1;h[d|0]=a&63|128;break c}d=j[f>>2];g=e-d|0;if(a>>>0<=65535){if((g|0)<3){break b}j[f>>2]=d+1;h[d|0]=a>>>12|224;d=j[f>>2];j[f>>2]=d+1;h[d|0]=a>>>6&63|128;d=j[f>>2];j[f>>2]=d+1;h[d|0]=a&63|128;break c}if((g|0)<4){break b}j[f>>2]=d+1;h[d|0]=a>>>18|240;d=j[f>>2];j[f>>2]=d+1;h[d|0]=a>>>12&63|128;d=j[f>>2];j[f>>2]=d+1;h[d|0]=a>>>6&63|128;d=j[f>>2];j[f>>2]=d+1;h[d|0]=a&63|128}d=j[c>>2]+4|0;j[c>>2]=d;continue}break}return 1}return g}function w$(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;b=Za-32|0;Za=b;d=Cb(b+16|0);j[114630]=0;c=FC(b+8|0);e=j[114630];j[114630]=0;a:{b:{c:{if((e|0)!=1){j[114630]=0;e=Qe(d);g=j[114630];j[114630]=0;if((g|0)==1){break c}g=zb(f);h=zb(f);f=nb(f);j[114630]=0;P(2511,c|0,e|0,g|0,(f<<2)+h|0)|0;c=j[114630];j[114630]=0;if((c|0)==1){break c}c=zb(d);j[114630]=0;e=j[114630];j[114630]=0;if((e|0)!=1){break b}a=D()|0;C()|0;break a}a=D()|0;C()|0;break a}a=D()|0;C()|0;break a}e=Le(a);j[114630]=0;a=EC(b+8|0);f=j[114630];j[114630]=0;if((f|0)!=1){d:{j[114630]=0;f=Qe(e);g=j[114630];j[114630]=0;if((g|0)==1){break d}g=ne(c);j[114630]=0;P(2514,a|0,f|0,c|0,c+g|0)|0;a=j[114630];j[114630]=0;if((a|0)==1){break d}gb(d);Za=b+32|0;return}}a=D()|0;C()|0;pc(e)}gb(d);G(a|0);z()}function FE(a){var b=0,c=0,d=0,e=0;b=Za-16|0;Za=b;e=(SMa(a),OMa(2));c=e&2147483647;a:{if(c>>>0<=1061752794){if(c>>>0<964689920){break a}a=gh(+a);break a}if(c>>>0<=1081824209){d=+a;if(c>>>0<=1075235811){if((e|0)<=-1){a=q(-fh(d+1.5707963267948966));break a}a=fh(d+ -1.5707963267948966);break a}a=gh(-(((e|0)>-1?-3.141592653589793:3.141592653589793)+d));break a}if(c>>>0<=1088565717){d=+a;if(c>>>0<=1085271519){if((e|0)<=-1){a=fh(d+4.71238898038469);break a}a=q(-fh(d+ -4.71238898038469));break a}a=gh(((e|0)>-1?-6.283185307179586:6.283185307179586)+d);break a}if(c>>>0>=2139095040){a=q(a-a);break a}b:{switch(wv(a,b+8|0)&3){case 0:a=gh(o[b+8>>3]);break a;case 1:a=fh(o[b+8>>3]);break a;case 2:a=gh(-o[b+8>>3]);break a;default:break b}}a=q(-fh(o[b+8>>3]))}Za=b+16|0;return a}function yfa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=q(0),l=0,m=0,o=0,p=0,r=q(0),s=q(0),t=0,u=0,v=0,w=0;g=Za-16|0;Za=g;l=a+44|0;if(Xg(l)){v=g,w=wd(l,0),j[v+8>>2]=w;v=g,w=wd(l,1),j[v+12>>2]=w;v=g,w=Rc(l,0),j[v>>2]=w;v=g,w=Rc(l,1),j[v+4>>2]=w;if(d){t=k[a+4273|0];u=k[a+4272|0];m=d;while(1){e=0;o=1;while(1){h=e<<2;f=h+(g+8|0)|0;e=j[f>>2];j[f>>2]=e+4;f=a+h|0;p=f+4228|0;i=q(q(n[a+4236>>2]*n[p>>2])+q(n[a+4240>>2]*n[e>>2]));n[p>>2]=i;i=q(n[a+4260>>2]*hH(q(i*q(1073741824)),u,t));e=f+4244|0;r=n[a+4264>>2];f=f+4252|0;s=n[f>>2];i=q(i-q(q(n[a+4268>>2]*n[e>>2])+q(r*s)));n[f>>2]=i;n[e>>2]=s+q(i*r);e=g+h|0;h=j[e>>2];j[e>>2]=h+4;n[h>>2]=i*q(9.313225746154785e-10);h=o;o=0;e=1;if(h){continue}break}m=m-1|0;if(m){continue}break}}Sh(a,b,c,Rc(l,0),Rc(l,1),d)}Za=g+16|0}function E9(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0;e=Za-32|0;Za=e;h=Cb(a);a=Cb(e+16|0);a:{b:{c:{d:{f=b+24|0;if(!l[j[f>>2]+480192>>1]){break d}b=1;while(1){c=j[f>>2];j[114630]=0;c=E(2177,c|0,b&65535)|0;d=j[114630];j[114630]=0;if((d|0)==1){break c}j[114630]=0;c=E(85,e|0,c|0)|0;d=j[114630];j[114630]=0;if((d|0)==1){break c}d=Ec(c);j[114630]=0;E(1245,a|0,c|0)|0;g=j[114630];j[114630]=0;if((g|0)==1){break b}j[114630]=0;E(1990,a|0,38852)|0;g=j[114630];j[114630]=0;if((g|0)==1){break b}i=d^1|i;gb(c);b=b+1|0;if(l[j[f>>2]+480192>>1]>=(b&65535)>>>0){continue}break}if(!(i&1)){break d}j[114630]=0;E(448,h|0,a|0)|0;b=j[114630];j[114630]=0;if((b|0)!=1){break d}b=D()|0;C()|0;break a}gb(a);Za=e+32|0;return}b=D()|0;C()|0;break a}b=D()|0;C()|0;gb(c)}gb(a);gb(h);G(b|0);z()}function D9(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0;e=Za-32|0;Za=e;h=Cb(a);a=Cb(e+16|0);a:{b:{c:{d:{f=b+24|0;if(!l[j[f>>2]+480190>>1]){break d}b=1;while(1){c=j[f>>2];j[114630]=0;c=E(2178,c|0,b&65535)|0;d=j[114630];j[114630]=0;if((d|0)==1){break c}j[114630]=0;c=E(85,e|0,c|0)|0;d=j[114630];j[114630]=0;if((d|0)==1){break c}d=Ec(c);j[114630]=0;E(1245,a|0,c|0)|0;g=j[114630];j[114630]=0;if((g|0)==1){break b}j[114630]=0;E(1990,a|0,38852)|0;g=j[114630];j[114630]=0;if((g|0)==1){break b}i=d^1|i;gb(c);b=b+1|0;if(l[j[f>>2]+480190>>1]>=(b&65535)>>>0){continue}break}if(!(i&1)){break d}j[114630]=0;E(448,h|0,a|0)|0;b=j[114630];j[114630]=0;if((b|0)!=1){break d}b=D()|0;C()|0;break a}gb(a);Za=e+32|0;return}b=D()|0;C()|0;break a}b=D()|0;C()|0;gb(c)}gb(a);gb(h);G(b|0);z()}function C5(a,b,c,d){var e=0,f=0,g=0,h=0,i=0,k=0,l=0,m=0,o=0;a:{h=j[a+992>>2];b:{if(!h){e=j[a+4>>2];i=0;break b}o=y5(a,h);if(!o){break a}e=j[a+4>>2];if((e|0)>=1){m=(h|0)<1;while(1){if(!m){g=(f<<2)+a|0;k=g;e=0;while(1){l=j[g+800>>2]+(c+e<<2)|0;i=e<<2;n[l>>2]=q(n[o+(h+(e^-1)<<2)>>2]*n[i+j[k+928>>2]>>2])+q(n[i+o>>2]*n[l>>2]);e=e+1|0;if((h|0)!=(e|0)){continue}break}e=j[a+4>>2]}f=f+1|0;if((f|0)<(e|0)){continue}break}}i=j[a+992>>2]}m=b-d|0;j[a+992>>2]=m;if((e|0)>=1){f=0;while(1){if((b|0)>(d|0)){g=(f<<2)+a|0;k=g;e=0;l=d;while(1){n[j[k+928>>2]+(e<<2)>>2]=n[j[g+800>>2]+(l<<2)>>2];e=e+1|0;l=e+d|0;if((e|0)!=(m|0)){continue}break}e=j[a+4>>2]}f=f+1|0;if((f|0)<(e|0)){continue}break}}if(!i){break a}g=a;k=j[a+1416>>2];a=((b|0)<(d|0)?b:d)-c|0;j[g+1416>>2]=k+a;return a}return 0}function ds(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,i=0;a:{g=jsa(a,b);if((g|0)==255){break a}b=0;if(Vi(a)){break a}e=mi(a+314|0,g);d=k[c+8|0]|k[c+9|0]<<8|(k[c+10|0]<<16|k[c+11|0]<<24);h[e+8|0]=d;h[e+9|0]=d>>>8;h[e+10|0]=d>>>16;h[e+11|0]=d>>>24;d=k[c+4|0]|k[c+5|0]<<8|(k[c+6|0]<<16|k[c+7|0]<<24);f=k[c|0]|k[c+1|0]<<8|(k[c+2|0]<<16|k[c+3|0]<<24);h[e|0]=f;h[e+1|0]=f>>>8;h[e+2|0]=f>>>16;h[e+3|0]=f>>>24;h[e+4|0]=d;h[e+5|0]=d>>>8;h[e+6|0]=d>>>16;h[e+7|0]=d>>>24;f=KL(g);i=f+3|0;d=1;while(1){e=d;d=d?f:i;Pg(j[a>>2],(d|32)&65535,k[Pb(c,b)|0]);Pg(j[a>>2],(d|64)&65535,k[Pb(c,b|2)|0]);Pg(j[a>>2],(d|96)&65535,k[Pb(c,b|4)|0]);Pg(j[a>>2],(d|128)&65535,k[Pb(c,b|6)|0]);Pg(j[a>>2],(d|224)&65535,k[Pb(c,b|8)|0]);d=0;b=1;if(e){continue}break}Pg(j[a>>2],es(g)|192,k[Pb(c,10)|0])}}function Jva(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,i=0,k=0,l=0,m=0,n=0;e=Za-32|0;Za=e;k=j[a+40>>2];l=j[a+36>>2];m=j[a+16>>2];b=j[a+4>>2];i=b;f=j[a>>2];j[e+24>>2]=f;j[e+28>>2]=b;b=j[a+12>>2];j[e+16>>2]=j[a+8>>2];j[e+20>>2]=b;a:{if(!d){g=k>>12;b=l>>12;break a}while(1){n=f>>>10&4194048;i=(((i&2147483647)<<1|f>>>31)&-2)+m|0;g=0;b=1;while(1){f=h[i+g|0];j[(e+8|0)+(g<<2)>>2]=((p(h[(g|2)+i|0]-f|0,n)|0)/16384|0)+(f<<8);f=b;b=0;g=1;if(f){continue}break}f=j[a+32>>2];l=j[a+28>>2]+l|0;b=l>>12;j[c>>2]=j[c>>2]+p(b,j[e+8>>2]);k=f+k|0;g=k>>12;j[c+4>>2]=j[c+4>>2]+p(g,j[e+12>>2]);Bb(e+24|0,e+16|0);d=d-1|0;if(d){c=c+8|0;f=j[e+24>>2];i=j[e+28>>2];continue}break}f=j[e+24>>2];i=j[e+28>>2]}j[a+40>>2]=k;j[a+20>>2]=b;j[a+36>>2]=l;j[a+24>>2]=g;j[a>>2]=f;j[a+4>>2]=i;Za=e+32|0}function Fpa(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,l=0,m=0,n=0,o=0,q=0,r=0;l=Za-16|0;Za=l;q=l,r=p(j[a>>2],be(a)),j[q+12>>2]=r;jc(l+12|0,(c>>>0)/3|0);c=lb(b);h=j[e+4>>2];f=j[l+12>>2];a:{if(!f){g=h;break a}while(1){e=lb(k[c|0]);e=lb(k[c+1|0])<<16|e<<8|lb(k[c+2|0])<<24;b:{if((e|0)<=-1){g=-2147483648;if((e|0)==-2147483648){break b}e=0-e|0}g=e>>>0>h>>>0?e:h}c=c+3|0;h=g;f=f-1|0;if(f){continue}break}}c:{if(!g){break c}e=j[l+12>>2];if(!e){break c}m=g-1|0;n=g>>>1|0;o=g;c=j[a+20>>2];while(1){a=lb(k[b|0]);a=lb(k[b+1|0])<<16|a<<8|lb(k[b+2|0])<<24;h=a>>31;f=a;a=h;h=a<<31|f>>>1;f=n|f<<31;a=m&a>>31;q=c,r=ic(IMa(f-a|0,h-(a>>>0>f>>>0)|0,o,0),ab)>>>16|0,i[q>>1]=r;b=b+3|0;c=c+2|0;e=e-1|0;if(e){continue}break}}if(d){j[d>>2]=g}Za=l+16|0;return p(j[l+12>>2],3)|0}function Epa(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,l=0,m=0,n=0,o=0,q=0,r=0;l=Za-16|0;Za=l;q=l,r=p(j[a>>2],be(a)),j[q+12>>2]=r;jc(l+12|0,(c>>>0)/3|0);c=lb(b);h=j[e+4>>2];f=j[l+12>>2];a:{if(!f){g=h;break a}while(1){e=lb(k[c+2|0]);e=lb(k[c+1|0])<<16|e<<8|lb(k[c|0])<<24;b:{if((e|0)<=-1){g=-2147483648;if((e|0)==-2147483648){break b}e=0-e|0}g=e>>>0>h>>>0?e:h}c=c+3|0;h=g;f=f-1|0;if(f){continue}break}}c:{if(!g){break c}e=j[l+12>>2];if(!e){break c}m=g-1|0;n=g>>>1|0;o=g;c=j[a+20>>2];while(1){a=lb(k[b+2|0]);a=lb(k[b+1|0])<<16|a<<8|lb(k[b|0])<<24;h=a>>31;f=a;a=h;h=a<<31|f>>>1;f=n|f<<31;a=m&a>>31;q=c,r=ic(IMa(f-a|0,h-(a>>>0>f>>>0)|0,o,0),ab)>>>16|0,i[q>>1]=r;b=b+3|0;c=c+2|0;e=e-1|0;if(e){continue}break}}if(d){j[d>>2]=g}Za=l+16|0;return p(j[l+12>>2],3)|0}function RI(a,b,c,d,e,f,g){var j=0,m=0,n=0;j=Za-16|0;Za=j;h[j+15|0]=b;h[j+14|0]=10;Nf(g,k[Zb(j+15|0,j+14|0)|0]);h[g+15|0]=c;h[g+16|0]=c;h[g+14|0]=e;h[g+13|0]=d;if(sb(g)){c=0;while(1){b=p(c,3)+f|0;d=k[b|0]|k[b+1|0]<<8;m=xb(g,c),n=d>>>4|0,i[m>>1]=n;a:{b:{if(!c){e=0;d=0;break b}d=c-1|0;if(l[xb(g,c)>>1]>=l[xb(g,d)>>1]){break a}e=c;d=l[xb(g,d)>>1]+1|0}m=xb(g,e),n=d,i[m>>1]=n}b=kd(k[b+2|0],0,64);m=xb(g,c),n=b,h[m+2|0]=n;c=c+1|0;if(sb(g)>>>0>c>>>0){continue}break}}c=k[g+12|0]&-2|a&1;h[g+12|0]=c;b=g;c:{d:{if(!(a&2)){break d}d=k[g+15|0];e=sb(g);c=k[g+12|0];if(d>>>0>e>>>0){break d}c=c|4;break c}c=c&251}h[b+12|0]=c;b=g;e:{f:{if(!(a&4)){break f}a=k[g+13|0];if(a>>>0>k[g+14|0]){break f}d=sb(g);c=k[g+12|0];if(a>>>0>d>>>0){break f}a=c|2;break e}a=c&253}h[b+12|0]=a;Za=j+16|0}function Hpa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,l=0,m=0;e=Za-16|0;Za=e;j[e+8>>2]=c>>>4;j[e+4>>2]=j[a>>2];d=j[tb(e+8|0,e+4|0)>>2];b=lb(b);if(d){a=j[a+20>>2];c=d;while(1){g=k[b+4|0]|k[b+5|0]<<8|(k[b+6|0]<<16|k[b+7|0]<<24);j[e+8>>2]=k[b|0]|k[b+1|0]<<8|(k[b+2|0]<<16|k[b+3|0]<<24);j[e+12>>2]=g;wf(e+8|0,-1,1);f=o[e+8>>3]*32768;o[e+8>>3]=f;g=a;f=zd(f);a:{if(r(f)<2147483648){h=~~f;break a}h=-2147483648}l=g,m=Dc(h),i[l>>1]=m;g=k[b+12|0]|k[b+13|0]<<8|(k[b+14|0]<<16|k[b+15|0]<<24);j[e+8>>2]=k[b+8|0]|k[b+9|0]<<8|(k[b+10|0]<<16|k[b+11|0]<<24);j[e+12>>2]=g;wf(e+8|0,-1,1);f=o[e+8>>3]*32768;o[e+8>>3]=f;g=a;f=zd(f);b:{if(r(f)<2147483648){h=~~f;break b}h=-2147483648}l=g,m=Dc(h),i[l+2>>1]=m;a=a+4|0;b=b+16|0;c=c-1|0;if(c){continue}break}}Za=e+16|0;return d<<4}function Tea(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;d=Th(a,b,c,d);j[a+4260>>2]=0;j[a>>2]=81648;c=a+4960|0;e=a+4504|0;b=e;while(1){Jj(b);b=b+24|0;if((c|0)!=(b|0)){continue}break}h[a+5046|0]=1;i[a+5044>>1]=0;j[a+4208>>2]=1063675494;j[a+4212>>2]=1065185444;j[a+4256>>2]=1059760811;b=a+4248|0;j[b>>2]=1065353216;j[b+4>>2]=1048525618;b=a+4240|0;j[b>>2]=1038174126;j[b+4>>2]=1065353216;b=a+4232|0;j[b>>2]=1047457519;j[b+4>>2]=1062836634;b=a+4224|0;j[b>>2]=1053079357;j[b+4>>2]=1059859440;b=a+4216|0;j[b>>2]=0;j[b+4>>2]=1032805417;j[114630]=0;K(1634,a+44|0,2,2)|0;b=j[114630];j[114630]=0;a:{if((b|0)!=1){j[114630]=0;N(1635,d|0);b=j[114630];j[114630]=0;if((b|0)!=1){break a}}a=D()|0;C()|0;while(1){c=c-24|0;xf(c);if((c|0)!=(e|0)){continue}break}Ke(d);G(a|0);z()}return a|0}function ela(a,b,c,d){var e=0,f=0;e=1;b=+(a|0)-b;f=b+ -3.5;if(!(r(f)<1e-8)){a:{b:{switch(d|0){case 0:e=.5-ge(b*.8975979010256552)*.5;break a;case 1:e=ge(b*.8975979010256552)*-.46+.54;break a;case 2:b=b*.8975979010256552;e=ge(b+b);e=ge(b)*-.5+.42+e*.08;break a;case 3:b=b*.8975979010256552;e=ge(b+b);e=ge(b)*-.49364+.44959+e*.05677;break a;case 4:b=b*.8975979010256552;e=ge(b+b);e=ge(b)*-.49755+.42323+e*.07922;break a;case 5:b=b*.8975979010256552;e=ge(b+b);e=ge(b)*-.48829+.35875+e*.14128+ge(b*3)*-.01168;break a;case 6:b=b*.8975979010256552;e=ge(b+b);e=ge(b)*-.49703+.40217+e*.09392+ge(b*3)*-.00183;break a;case 7:break b;default:break a}}b=b*.8975979010256552;e=ge(b+b);e=ge(b)*-.49804+.40243+e*.09831+ge(b*3)*-.00122}b=f*3.141592653589793;c=Kh(b*c)/b}return c*e}function Ve(a,b){var c=0,d=0,e=0;d=Za-32|0;Za=d;a=sg(a,-1,-1);a:{b:{if(k[Ki(d+24|0,b,1)|0]){c=j[j[b>>2]-12>>2];j[114630]=0;c=j[(b+c|0)+24>>2];e=j[114630];j[114630]=0;c:{d:{if((e|0)==1){break d}j[114630]=0;Ca(2380,d+8|0,c|0,0,0,1,8);c=j[114630];j[114630]=0;if((c|0)==1){break d}c=j[d+12>>2];j[a>>2]=j[d+8>>2];j[a+4>>2]=c;c=j[d+20>>2];j[a+8>>2]=j[d+16>>2];j[a+12>>2]=c;a=0;break c}a=J(0)|0;C()|0;O(a|0)|0;Ii(j[j[b>>2]-12>>2]+b|0,1);a=j[j[b>>2]-12>>2];j[114630]=0;a=j[(a+b|0)+20>>2];c=j[114630];j[114630]=0;e:{if((c|0)!=1){if(!(a&1)){break e}j[114630]=0;M(81);a=j[114630];j[114630]=0;if((a|0)!=1){break a}}a=D()|0;C()|0;j[114630]=0;M(20);b=j[114630];j[114630]=0;if((b|0)==1){break b}G(a|0);z()}Q();a=1}eg(j[j[b>>2]-12>>2]+b|0,a)}Za=d+32|0;return}J(0)|0;C()|0;ib()}z()}function Mt(a,b,c,d){var e=0,f=0,g=0,j=0,m=0,n=0,o=0;f=Za-16|0;Za=f;h[f+15|0]=d;h[b+12|0]=k[a|0]&15|k[b+12|0]&240;g=a+1|0;Nf(b,k[Zb(g,f+15|0)|0]);d=k[Zb(a+2|0,f+15|0)|0];h[b+13|0]=d;n=b,o=kd(k[a+3|0],d,k[f+15|0]),h[n+14|0]=o;d=k[Zb(a+4|0,f+15|0)|0];h[b+15|0]=d;n=b,o=kd(k[a+5|0],d,k[f+15|0]),h[n+16|0]=o;h[f+14|0]=25;if(k[Zb(f+14|0,g)|0]){d=0;while(1){e=p(d,3)+a|0;j=Gb(k[e+6|0]+c<<24>>24,0,64);n=xb(b,d),o=j,h[n+2|0]=o;e=e+7|0;e=k[e|0]|k[e+1|0]<<8;n=xb(b,d),o=e,i[n>>1]=o;a:{if(!d){break a}e=d-1|0;if(l[xb(b,d)>>1]>=l[xb(b,e)>>1]){break a}if(l[xb(b,d)>>1]>255){break a}j=k[xb(b,e)+1|0];m=xb(b,d);i[m>>1]=l[m>>1]|j<<8;if(l[xb(b,d)>>1]>=l[xb(b,e)>>1]){break a}e=xb(b,d);i[e>>1]=l[e>>1]+256}h[f+14|0]=25;d=d+1|0;if(d>>>0<k[Zb(f+14|0,g)|0]){continue}break}}Za=f+16|0}function tBa(a,b,c){var d=0,e=0,f=0,g=0,m=0,n=0;f=Za-16|0;Za=f;md(b,1);d=a+22|0;d=k[d|0]|k[d+1|0]<<8;j[b>>2]=((d<<8|d>>>8)&65535)<<1;h[b+37|0]=k[a+24|0]<<4;h[f+15|0]=k[a+25|0];h[f+14|0]=64;m=b,n=k[Zb(f+15|0,f+14|0)|0]<<2,i[m+30>>1]=n;d=a+26|0;d=k[d|0]|k[d+1|0]<<8;g=(d<<8|d>>>8)&65535;d=g<<1;a=a+28|0;a=k[a|0]|k[a+1|0]<<8;a=(a<<8|a>>>8)&65535;e=a<<1;a:{if(a>>>0<=1){a=j[b>>2];break a}a=j[b>>2];d=d+e>>>0<=a>>>0?d:a>>>0<e+g>>>0?d:g}b:{c:{switch(a|0){case 2:j[b>>2]=0;break b;case 0:break b;default:break c}}j[b+4>>2]=d;e=d+e|0;j[b+8>>2]=e;if(a>>>0<=d>>>0){d=a-1|0;j[b+4>>2]=d}if(!(e-d>>>0>3?!(e>>>0<4|d>>>0>e>>>0):0)){j[b+4>>2]=0;j[b+8>>2]=0;e=0;d=0}if(!(a>>>0<=e>>>0|e>>>0>8|(!c|d))){j[b+8>>2]=0;break b}if(d>>>0>=e>>>0){break b}i[b+34>>1]=l[b+34>>1]|2}Za=f+16|0}function rJ(a,b,c){var d=0,e=0,f=0,g=0,i=0,l=0,m=0;e=Za-16|0;Za=e;g=-1;a:{if(!Sw(a,b,2)){break a}i=j[b+656>>2];f=a+1074308|0;mb(e+8|0,f,31);b:{if(kb(e+8|0)){d=j[b+752>>2];if(d){break b}break a}d=j[b+752>>2]}mb(e+8|0,f,31);f=d-kb(e+8|0)|0;d=j[a+480180>>2];d=(d|0)==4096?64:(d|0)==16384?192:512;d=To(i+88|0,f,d,j[a+480180>>2]==4096?255:64)-(d>>>1|0)|0;if(k[b+748|0]&16){g=Io(a,b,!(j[b+88>>2]&32768),d);break a}if(Yi(b)){if((d|0)==j[b+768>>2]){break a}j[b+768>>2]=d;h[b+872|0]=k[b+872|0]|8;break a}b=Ao(a);j[e+8>>2]=d;f=c;c:{if((d|0)<=-1){j[e+8>>2]=0-d;_j(e+8|0,255);a=(j[e+8>>2]<<2)+(b?26336:25312)|0;break c}_j(e+8|0,255);a=(j[e+8>>2]<<2)+(b?25312:26336)|0}a=j[a>>2];b=a;d=a>>31;a=j[c>>2];l=f,m=ic(IMa(HMa(b,d,a,a>>31),ab,65536,0),ab),j[l>>2]=m}Za=e+16|0;return g}function pK(a,b,c){var d=0,e=0,f=0;e=Za-16|0;Za=e;a:{if(j[a+480180>>2]==4){d=k[b+833|0];if(c){h[b+833|0]=d&240|c&15;break a}c=d&15;break a}if(j[a+480180>>2]!=1048576){break a}if(c){h[b+833|0]=c;break a}c=k[b+833|0]}b:{c:{if(!(h[b+872|0]&1)|!(c&255)){break c}d=j[b+700>>2];if(!d){break c}if(!(k[a+480208|0]&16)){break b}d=j[b+700>>2];if(j[a+480180>>2]==4){break b}c=jx(a,c&15);f=HMa(c,c>>31,d,d>>31)+32768|0;c=ab;c=ic(IMa(f,f>>>0<32768?c+1|0:c,65536,0),ab);j[b+700>>2]=c;if((c|0)!=(d|0)){break c}a=a+1074308|0;mb(e+8|0,a,7);if(!(kb(e+8|0)|j[b+700>>2]==2147483647)){j[b+700>>2]=j[b+700>>2]+1;break c}mb(e+8|0,a,7);if(!kb(e+8|0)){break c}a=j[b+700>>2];if((a|0)<2){break c}j[b+700>>2]=a-1}Za=e+16|0;return}a=((c&255)<<2)+d|0;j[b+700>>2]=(a|0)<65535?a:65535;Za=e+16|0}function c5(a,b,c,d,e){var f=q(0),g=q(0),h=0,i=q(0),j=q(0),k=q(0),l=0;if((0-(a<<4)|0)<=-1){b=(c<<2)+b|0;c=b-(a<<6)|0;k=n[(e>>3<<2)+d>>2];while(1){a=b-32|0;f=n[a>>2];i=n[b>>2];n[b>>2]=f+i;d=b-4|0;g=n[d>>2];e=d;d=b-36|0;j=n[d>>2];n[e>>2]=j+g;n[a>>2]=i-f;n[d>>2]=g-j;d=b-8|0;g=n[d>>2];e=d;d=b-40|0;i=n[d>>2];n[e>>2]=i+g;e=b-12|0;f=n[e>>2];h=e;e=b-44|0;j=n[e>>2];n[h>>2]=j+f;f=q(f-j);g=q(g-i);n[d>>2]=q(f+g)*k;n[e>>2]=q(f-g)*k;d=b-20|0;g=n[d>>2];e=b-52|0;f=n[e>>2];h=b-16|0;i=n[h>>2];l=h;h=b-48|0;j=n[h>>2];n[l>>2]=i+j;n[d>>2]=f+g;n[h>>2]=g-f;n[e>>2]=j-i;d=b-60|0;g=n[d>>2];e=b-28|0;f=n[e>>2];h=b-24|0;i=n[h>>2];l=h;h=b-56|0;j=n[h>>2];n[l>>2]=i+j;n[e>>2]=g+f;g=q(f-g);f=q(j-i);n[h>>2]=q(g+f)*k;n[d>>2]=q(f-g)*k;JE(b);JE(a);b=b+ -64|0;if(c>>>0<b>>>0){continue}break}}}function Zza(a,b){var c=0,d=0,e=0,f=0;d=Za-16|0;Za=d;md(b,0);i[d+14>>1]=k[a+35|0]<<2;i[d+12>>1]=256;e=b,f=l[gf(d+14|0,d+12|0)>>1],i[e+30>>1]=f;c=a+22|0;a:{if((k[c|0]|k[c+1|0]<<8|(k[c+2|0]<<16|k[c+3|0]<<24))>>>0<3){break a}j[b>>2]=k[c|0]|k[c+1|0]<<8|(k[c+2|0]<<16|k[c+3|0]<<24);c=a+26|0;j[b+4>>2]=k[c|0]|k[c+1|0]<<8|(k[c+2|0]<<16|k[c+3|0]<<24);c=a+30|0;j[d+8>>2]=k[c|0]|k[c+1|0]<<8|(k[c+2|0]<<16|k[c+3|0]<<24);j[d+4>>2]=1;e=b,f=j[Lc(d+8|0,d+4|0)>>2]-1|0,j[e+8>>2]=f;jc(b+8|0,j[b>>2]);b:{if(m[b+8>>2]<=j[b+4>>2]+4>>>0){j[b+4>>2]=0;j[b+8>>2]=0;break b}i[b+34>>1]=l[b+34>>1]|2}c=a+34|0;h[b+37|0]=k[c|0];e=b,f=ks(0,h[c|0]<<4),j[e+24>>2]=f;if(!(h[a+36|0]&1)){break a}i[b+34>>1]=l[b+34>>1]|1;j[b>>2]=j[b>>2]>>>1;j[b+4>>2]=j[b+4>>2]>>>1;j[b+8>>2]=j[b+8>>2]>>>1}Za=d+16|0}function VE(a){var b=q(0),c=q(0),d=q(0),e=q(0),f=q(0),g=q(0),h=q(0),i=q(0),j=q(0),k=q(0),l=q(0),m=q(0),o=q(0),p=q(0);b=n[a+32>>2];c=n[a+8>>2];e=n[a+16>>2];f=q(q(b-c)+e);i=n[a>>2];j=n[a+24>>2];k=q(i-j);n[a+16>>2]=f+k;d=n[a+4>>2];g=n[a+20>>2];h=n[a+28>>2];l=q(q(d-q(g+h))*q(.8660253882408142));k=q(k-q(f*q(.5)));n[a+4>>2]=l+k;m=q(q(g+d)*q(.9848077297210693));f=q(n[a+12>>2]*q(.8660253882408142));o=q(q(h+d)*q(-.6427876353263855));p=q(q(m-f)+o);d=q(i+q(j*q(.5)));i=q(q(b+c)*q(.7660444378852844));b=q(q(e-b)*q(.1736481785774231));j=q(q(d-i)+b);n[a+12>>2]=p+j;n[a+20>>2]=j-p;n[a+28>>2]=k-l;g=q(q(g-h)*q(.3420201539993286));h=q(g-q(f+m));c=q(q(e+c)*q(.9396926164627075));b=q(q(d+c)-b);n[a+32>>2]=h+b;e=q(q(g+f)+o);c=q(q(d-c)+i);n[a+24>>2]=e+c;n[a+8>>2]=c-e;n[a>>2]=b-h}function Fm(a,b){var c=0,d=0,e=0,f=0,g=0,i=0,m=0;c=j[b+88>>2];d=c|2048;j[b+88>>2]=d;e=j[b+656>>2];if(!(!e|h[b+724|0]&1)){d=c|6144;j[b+88>>2]=d}a:{if(!j[b+76>>2]){break a}b:{if(!(d&8)|c&2048){break b}c=j[b+104>>2];if(!c){break b}f=l[c+34>>1];if(f&2){j[b+88>>2]=(f&4?d|4:d&-135)|2;d=j[c>>2];j[b+76>>2]=d;f=j[c+4>>2];j[b+80>>2]=f;c=j[c+8>>2];j[b+84>>2]=c;if(c>>>0<d>>>0){j[b+76>>2]=c;g=c}else{g=d}d=j[b+4>>2];if(g>>>0>=d>>>0){break b}j[b>>2]=0;j[b+4>>2]=((d-f>>>0)%(c-f>>>0)|0)+f;break b}j[b+88>>2]=d&-135;j[b+76>>2]=j[c>>2]}if(!e){break a}if(!(!j[e>>2]|(j[a+480180>>2]&1064964?0:!(k[e+60|0]&2)))){j[b+88>>2]=j[b+88>>2]|4096}if(k[e+65|0]==255|j[b+732>>2]!=-1){break a}a=e+48|0;i=b,m=To(a,j[b+728>>2],256,64),j[i+732>>2]=m;i=b,m=l[xb(a,k[e+65|0])>>1],j[i+728>>2]=m}}function g9(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0;c=Za-32|0;Za=c;g=Ng(a);f=b+24|0;a=l[j[f>>2]+480192>>1];j[114630]=0;F(1527,g|0,a|0);a=j[114630];j[114630]=0;a:{if((a|0)!=1){b:{c:{d:{e:{if(l[j[f>>2]+480192>>1]){a=1;while(1){d=j[f>>2];j[114630]=0;d=E(2177,d|0,a&65535)|0;e=j[114630];j[114630]=0;if((e|0)==1){break e}j[114630]=0;d=E(85,c|0,d|0)|0;e=j[114630];j[114630]=0;if((e|0)==1){break e}j[114630]=0;I(2179,c+16|0,b|0,d|0);e=j[114630];j[114630]=0;if((e|0)==1){break d}j[114630]=0;F(1529,g|0,c+16|0);e=j[114630];j[114630]=0;if((e|0)==1){break c}gb(c+16|0);gb(d);a=a+1|0;if(l[j[f>>2]+480192>>1]>=(a&65535)>>>0){continue}break}}Za=c+32|0;return}a=D()|0;C()|0;break a}a=D()|0;C()|0;break b}a=D()|0;C()|0;gb(c+16|0)}gb(d);break a}a=D()|0;C()|0}Vc(g);G(a|0);z()}function f9(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0;c=Za-32|0;Za=c;g=Ng(a);f=b+24|0;a=l[j[f>>2]+480190>>1];j[114630]=0;F(1527,g|0,a|0);a=j[114630];j[114630]=0;a:{if((a|0)!=1){b:{c:{d:{e:{if(l[j[f>>2]+480190>>1]){a=1;while(1){d=j[f>>2];j[114630]=0;d=E(2178,d|0,a&65535)|0;e=j[114630];j[114630]=0;if((e|0)==1){break e}j[114630]=0;d=E(85,c|0,d|0)|0;e=j[114630];j[114630]=0;if((e|0)==1){break e}j[114630]=0;I(2179,c+16|0,b|0,d|0);e=j[114630];j[114630]=0;if((e|0)==1){break d}j[114630]=0;F(1529,g|0,c+16|0);e=j[114630];j[114630]=0;if((e|0)==1){break c}gb(c+16|0);gb(d);a=a+1|0;if(l[j[f>>2]+480190>>1]>=(a&65535)>>>0){continue}break}}Za=c+32|0;return}a=D()|0;C()|0;break a}a=D()|0;C()|0;break b}a=D()|0;C()|0;gb(c+16|0)}gb(d);break a}a=D()|0;C()|0}Vc(g);G(a|0);z()}function A$(a,b,c,d,e,f,g,i,k,l){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;i=i|0;k=k|0;l=l|0;var m=0,n=0,o=0;m=Za-16|0;Za=m;a:{if(a){a=KC(c);b:{if(b){pj(m,a);b=j[m>>2];h[d|0]=b;h[d+1|0]=b>>>8;h[d+2|0]=b>>>16;h[d+3|0]=b>>>24;oj(m,a);break b}sq(m,a);b=j[m>>2];h[d|0]=b;h[d+1|0]=b>>>8;h[d+2|0]=b>>>16;h[d+3|0]=b>>>24;Gg(m,a)}Dh(k,m);pc(m);n=e,o=Hh(a),j[n>>2]=o;n=f,o=Gh(a),j[n>>2]=o;Tf(m,a);ob(g,m);gb(m);Hg(m,a);Dh(i,m);pc(m);a=nj(a);break a}a=JC(c);c:{if(b){pj(m,a);b=j[m>>2];h[d|0]=b;h[d+1|0]=b>>>8;h[d+2|0]=b>>>16;h[d+3|0]=b>>>24;oj(m,a);break c}sq(m,a);b=j[m>>2];h[d|0]=b;h[d+1|0]=b>>>8;h[d+2|0]=b>>>16;h[d+3|0]=b>>>24;Gg(m,a)}Dh(k,m);pc(m);n=e,o=Hh(a),j[n>>2]=o;n=f,o=Gh(a),j[n>>2]=o;Tf(m,a);ob(g,m);gb(m);Hg(m,a);Dh(i,m);pc(m);a=nj(a)}j[l>>2]=a;Za=m+16|0}function uva(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0;e=Za-32|0;Za=e;k=j[a+24>>2];l=j[a+20>>2];m=j[a+16>>2];g=j[a+4>>2];b=g;f=j[a>>2];j[e+24>>2]=f;j[e+28>>2]=b;g=j[a+12>>2];j[e+16>>2]=j[a+8>>2];j[e+20>>2]=g;if(d){while(1){g=((((b&2147483647)<<1|f>>>31)&2147483646)<<1)+m|0;b=(f>>>21&2040)+27888|0;n=i[b+6>>1];o=i[b+4>>1];q=i[b+2>>1];r=i[b>>1];h=0;b=1;while(1){f=h<<1;j[(e+8|0)+(h<<2)>>2]=(((p(i[f+g>>1],q)+p(i[(f|-4)+g>>1],r)|0)+p(i[(f|4)+g>>1],o)|0)+p(i[(f|8)+g>>1],n)|0)/16384;f=b;b=0;h=1;if(f){continue}break}j[c>>2]=j[c>>2]+p(j[e+8>>2],l);j[c+4>>2]=j[c+4>>2]+p(j[e+12>>2],k);Bb(e+24|0,e+16|0);d=d-1|0;if(d){c=c+8|0;f=j[e+24>>2];b=j[e+28>>2];continue}break}f=j[e+24>>2];b=j[e+28>>2]}j[a>>2]=f;j[a+4>>2]=b;Za=e+32|0}function Pla(a,b){var c=0,d=0,e=0,f=0,g=0,h=0;e=Za-48|0;Za=e;c=78944;g=Ola(e+32|0);a=Qc(a);while(1){if(j[c>>2]==(b|0)){f=j[c+4>>2];j[114630]=0;f=E(2,e+16|0,f|0)|0;d=j[114630];j[114630]=0;a:{b:{c:{d:{e:{f:{if((d|0)!=1){j[114630]=0;I(1515,e|0,g|0,f|0);d=j[114630];j[114630]=0;if((d|0)==1){break d}if(!k[e+4|0]){break a}if(!Ec(a)){j[114630]=0;d=E(2,e|0,20816)|0;h=j[114630];j[114630]=0;if((h|0)==1){break f}j[114630]=0;E(192,a|0,d|0)|0;h=j[114630];j[114630]=0;if((h|0)==1){break e}gb(d)}j[114630]=0;E(192,a|0,f|0)|0;d=j[114630];j[114630]=0;if((d|0)!=1){break a}c=D()|0;C()|0;break c}c=D()|0;C()|0;break b}c=D()|0;C()|0;break c}c=D()|0;C()|0;gb(d);break c}c=D()|0;C()|0}gb(f)}gb(a);gJ(g);G(c|0);z()}gb(f)}c=c+12|0;if((c|0)!=78992){continue}break}gJ(g);Za=e+48|0}function Kpa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=q(0),h=0,l=0,m=0;e=Za-16|0;Za=e;j[e+12>>2]=c>>>3;j[e+8>>2]=j[a>>2];d=j[tb(e+12|0,e+8|0)>>2];b=lb(b);if(d){a=j[a+20>>2];c=d;while(1){f=k[b|0]|k[b+1|0]<<8|(k[b+2|0]<<16|k[b+3|0]<<24);j[e+12>>2]=f<<24|f<<8&16711680|(f>>>8&65280|f>>>24);Kd(e+12|0,q(-1));g=q(n[e+12>>2]*q(32768));n[e+12>>2]=g;f=a;g=Rd(g);a:{if(q(r(g))<q(2147483648)){h=~~g;break a}h=-2147483648}l=f,m=Dc(h),i[l>>1]=m;f=k[b+4|0]|k[b+5|0]<<8|(k[b+6|0]<<16|k[b+7|0]<<24);j[e+12>>2]=f<<24|f<<8&16711680|(f>>>8&65280|f>>>24);Kd(e+12|0,q(-1));g=q(n[e+12>>2]*q(32768));n[e+12>>2]=g;f=a;g=Rd(g);b:{if(q(r(g))<q(2147483648)){h=~~g;break b}h=-2147483648}l=f,m=Dc(h),i[l+2>>1]=m;a=a+4|0;b=b+8|0;c=c-1|0;if(c){continue}break}}Za=e+16|0;return d<<3}function zP(a){var b=0,c=0;a:{if(_c(a,15083,3)){break a}b=a+3|0;if(k[b|0]<48|k[b|0]>51){break a}b=a+8|0;c=k[b|0]|k[b+1|0]<<8|(k[b+2|0]<<16|k[b+3|0]<<24);if((c<<24|c<<8&16711680|(c>>>8&65280|c>>>24))>>>0<52){break a}b=k[b|0]|k[b+1|0]<<8|(k[b+2|0]<<16|k[b+3|0]<<24);if((b<<24|b<<8&16711680|(b>>>8&65280|b>>>24))>>>0>4294966507){break a}b=a+16|0;b=k[b|0]|k[b+1|0]<<8|(k[b+2|0]<<16|k[b+3|0]<<24);if((b<<24|b<<8&16711680|(b>>>8&65280|b>>>24))>>>0<52){break a}b=a+24|0;if(k[b|0]|k[b+1|0]<<8|(k[b+2|0]<<16|k[b+3|0]<<24)){b=k[b|0]|k[b+1|0]<<8|(k[b+2|0]<<16|k[b+3|0]<<24);if((b<<24|b<<8&16711680|(b>>>8&65280|b>>>24))>>>0<52){break a}}a=a+32|0;a=k[a|0]|k[a+1|0]<<8|(k[a+2|0]<<16|k[a+3|0]<<24);return(a<<24|a<<8&16711680|(a>>>8&65280|a>>>24))>>>0<4294967216}return 0}function RG(a){var b=0,c=0,d=0,e=0,f=0,g=q(0),h=0,i=0,k=0,l=0,o=0,p=0,r=q(0);c=we(j[a+16>>2]);g=q(q(n[a+4220>>2]*q(.9980000257492065))+q(.0010000000474974513));d=-9965.784284662086/+q(q(q(n[a+4216>>2]*q(2999.9990234375))+q(.0010000000474974513))*q(c>>>0));p=a,r=q(Cg(d*+m[a+4288>>2])),n[p+4232>>2]=r;p=a+4236|0,r=q(Cg(d*+m[a+4292>>2])),n[p>>2]=r;o=d*(1/+g+ -1);c=0;h=a+4272|0;i=a+4232|0;while(1){k=j[(c<<2)+h>>2];e=c<<1&-4;f=Cg(o*+(k+j[(e+h|0)+16>>2]>>>0));b=Cg(d*+(k>>>0));g=n[e+i>>2];e=(c<<3)+i|0;f=f*.5;n[e+12>>2]=b*(.5-f);n[e+8>>2]=b*(f+.5);b=b*+g;b=(((b+1)*b+1)*b+1)*b+1;l=b*b+l;c=c+1|0;if((c|0)!=4){continue}break}d=Cg(+QG(n[a+4208>>2])*.16609640474436813);b=Cg(+QG(n[a+4212>>2])*.33219280948873625);n[a+4228>>2]=d*4*y(b)/y(l);n[a+4224>>2]=d*y(1-b)}function Nka(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;md(c,0);i[c+28>>1]=k[a+36|0]<<2;d=k[a+37|0];i[c+32>>1]=64;i[c+30>>1]=d<<2;d=a+40|0;j[c>>2]=k[d|0]|k[d+1|0]<<8|(k[d+2|0]<<16|k[d+3|0]<<24);d=a+44|0;j[c+4>>2]=k[d|0]|k[d+1|0]<<8|(k[d+2|0]<<16|k[d+3|0]<<24);d=a+48|0;j[c+8>>2]=k[d|0]|k[d+1|0]<<8|(k[d+2|0]<<16|k[d+3|0]<<24);d=a+52|0;j[c+24>>2]=k[d|0]|k[d+1|0]<<8|(k[d+2|0]<<16|k[d+3|0]<<24);d=b+151|0;if(k[d|0]<5){h[c+38|0]=k[k[d|0]+31850|0]}h[c+39|0]=k[b+152|0];d=b+156|0;h[c+41|0]=(k[d|0]|k[d+1|0]<<8)>>>4;b=b+154|0;b=(k[b|0]|k[b+1|0]<<8)>>>2|0;h[c+40|0]=b;if(k[c+41|0]|b&255){h[c+39|0]=k[c+39|0]^-1}a=a+38|0;if(k[a|0]&4){i[c+34>>1]=l[c+34>>1]|1}if(k[a|0]&8){i[c+34>>1]=l[c+34>>1]|2}if(k[a|0]&16){i[c+34>>1]=l[c+34>>1]|4}if(k[a|0]&32){i[c+34>>1]=l[c+34>>1]|32}}function E$(a,b,c,d,e,f,g,i,k,l){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;i=i|0;k=k|0;l=l|0;var m=0,n=0,o=0;m=Za-16|0;Za=m;a:{if(a){a=OC(c);b:{if(b){pj(m,a);b=j[m>>2];h[d|0]=b;h[d+1|0]=b>>>8;h[d+2|0]=b>>>16;h[d+3|0]=b>>>24;oj(m,a);break b}sq(m,a);b=j[m>>2];h[d|0]=b;h[d+1|0]=b>>>8;h[d+2|0]=b>>>16;h[d+3|0]=b>>>24;Gg(m,a)}ob(k,m);gb(m);n=e,o=Hh(a),h[n|0]=o;n=f,o=Gh(a),h[n|0]=o;Tf(m,a);ob(g,m);gb(m);Hg(m,a);ob(i,m);gb(m);a=nj(a);break a}a=NC(c);c:{if(b){pj(m,a);b=j[m>>2];h[d|0]=b;h[d+1|0]=b>>>8;h[d+2|0]=b>>>16;h[d+3|0]=b>>>24;oj(m,a);break c}sq(m,a);b=j[m>>2];h[d|0]=b;h[d+1|0]=b>>>8;h[d+2|0]=b>>>16;h[d+3|0]=b>>>24;Gg(m,a)}ob(k,m);gb(m);n=e,o=Hh(a),h[n|0]=o;n=f,o=Gh(a),h[n|0]=o;Tf(m,a);ob(g,m);gb(m);Hg(m,a);ob(i,m);gb(m);a=nj(a)}j[l>>2]=a;Za=m+16|0}function Zn(a){var b=0,c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0;RMa(+a);b=OMa(1)|0;e=OMa(0)|0;a:{b:{c:{d:{if((b|0)>0?1:(b|0)>=0){f=b;if(b>>>0>1048575){break d}}if(!(b&2147483647|e)){return-1/(a*a)}if((b|0)>-1){break c}return(a-a)/0}if(f>>>0>2146435071){break a}b=1072693248;g=-1023;if((f|0)!=1072693248){b=f;break b}if(e){break b}return 0}RMa(+(a*0x40000000000000));b=OMa(1)|0;e=OMa(0)|0;g=-1077}b=b+614242|0;d=+((b>>>20|0)+g|0);PMa(0,e|0);PMa(1,(b&1048575)+1072079006|0);a=+QMa()+ -1;c=a/(a+2);h=d*.6931471803691238;i=a;j=d*1.9082149292705877e-10;k=c;d=a*(a*.5);c=c*c;a=c*c;a=h+(i+(j+k*(d+(a*(a*(a*.15313837699209373+.22222198432149784)+.3999999999940942)+c*(a*(a*(a*.14798198605116586+.1818357216161805)+.2857142874366239)+.6666666666666735)))-d))}return a}function c8(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=Za-80|0;Za=d;a=j[a+4>>2];ou(d+16|0,b);j[114630]=0;b=E(2,d|0,38637)|0;e=j[114630];j[114630]=0;a:{b:{c:{d:{e:{f:{g:{h:{if((e|0)!=1){j[114630]=0;I(3,d+32|0,d+16|0,b|0);e=j[114630];j[114630]=0;if((e|0)==1){break h}j[114630]=0;I(720,d+48|0,d+32|0,c|0);c=j[114630];j[114630]=0;if((c|0)==1){break g}j[114630]=0;I(9,d- -64|0,0,d+48|0);c=j[114630];j[114630]=0;if((c|0)==1){break f}c=j[j[a>>2]+8>>2];j[114630]=0;F(c|0,a|0,d- -64|0);a=j[114630];j[114630]=0;if((a|0)==1){break e}gb(d- -64|0);gb(d+48|0);gb(d+32|0);gb(b);gb(d+16|0);Za=d+80|0;return}a=D()|0;C()|0;break a}a=D()|0;C()|0;break b}a=D()|0;C()|0;break c}a=D()|0;C()|0;break d}a=D()|0;C()|0;gb(d- -64|0)}gb(d+48|0)}gb(d+32|0)}gb(b)}gb(d+16|0);G(a|0);z()}function Yv(a,b,c,d,e,f){var g=0,i=0,k=q(0),l=0;g=Za-96|0;Za=g;i=a+24|0;ro(j[i>>2]);h[j[i>>2]+1304512|0]=j[a+52>>2]!=0;j[g+92>>2]=f;j[g+88>>2]=e;j[g+84>>2]=d;j[g+80>>2]=c;c=iG(g+32|0,g+80|0,jG(g+80|0),b);d=j[a+32>>2];k=n[a+48>>2];e=j[c+12>>2];j[g+8>>2]=j[c+8>>2];j[g+12>>2]=e;e=j[c+4>>2];j[g>>2]=j[c>>2];j[g+4>>2]=e;d=Caa(g+48|0,g,d,k);e=0;a:{while(1){if(b){c=j[i>>2];j[g+24>>2]=b;j[g+28>>2]=0;j[114630]=0;j[g+16>>2]=134217727;j[g+20>>2]=0;f=E(2147,g+24|0,g+16|0)|0;l=j[114630];j[114630]=0;if((l|0)==1){break a}f=j[f>>2];j[114630]=0;c=K(2148,c|0,f|0,d|0)|0;f=j[114630];j[114630]=0;if((f|0)==1){break a}e=c+e|0;b=b-c|0;if(c){continue}}break}if(!(j[a+52>>2]!=1|e)){a=j[i>>2];j[a+480208>>2]=j[a+480208>>2]&-513}Za=g+96|0;return e}a=D()|0;C()|0;G(a|0);z()}function Xv(a,b,c,d,e,f){var g=0,i=0,k=q(0),l=0;g=Za-96|0;Za=g;i=a+24|0;ro(j[i>>2]);h[j[i>>2]+1304512|0]=j[a+52>>2]!=0;j[g+92>>2]=f;j[g+88>>2]=e;j[g+84>>2]=d;j[g+80>>2]=c;c=iG(g+32|0,g+80|0,jG(g+80|0),b);d=j[a+32>>2];k=n[a+48>>2];e=j[c+12>>2];j[g+8>>2]=j[c+8>>2];j[g+12>>2]=e;e=j[c+4>>2];j[g>>2]=j[c>>2];j[g+4>>2]=e;d=yaa(g+48|0,g,d,k);e=0;a:{while(1){if(b){c=j[i>>2];j[g+24>>2]=b;j[g+28>>2]=0;j[114630]=0;j[g+16>>2]=134217727;j[g+20>>2]=0;f=E(2147,g+24|0,g+16|0)|0;l=j[114630];j[114630]=0;if((l|0)==1){break a}f=j[f>>2];j[114630]=0;c=K(2148,c|0,f|0,d|0)|0;f=j[114630];j[114630]=0;if((f|0)==1){break a}e=c+e|0;b=b-c|0;if(c){continue}}break}if(!(j[a+52>>2]!=1|e)){a=j[i>>2];j[a+480208>>2]=j[a+480208>>2]&-513}Za=g+96|0;return e}a=D()|0;C()|0;G(a|0);z()}function Pia(a,b,c){var d=0,e=0,f=q(0),g=0,h=0,k=0;a:{if(c){g=j[a+36>>2];if(g){break a}}return Xk(a,b+c<<16>>16)}d=g+1|0;b:{if((c|0)>=0){e=c;c=(c|0)/(d|0)|0;e=e-p(d,c)|0;break b}e=g-((c^-1)%(d|0)|0)|0;c=((c+1|0)/(d|0)|0)-1|0}k=i[a+28>>1];h=a+4|0;sb(h);f=q(1);c=b+c<<16>>16;c:{if((c|0)<(k|0)){break c}if((c|0)>(l[a+28>>1]+sb(h)<<16)-65536>>16){break c}if(!e){return n[xb(h,c-i[a+28>>1]|0)>>2]}b=l[a>>1];d:{if((b|0)==3){b=a+16|0;if(sb(b)){f=n[xb(b,e-1|0)>>2];break d}b=l[a>>1]}e:{if((b&65535)!=1){break e}b=a+16|0;if(!sb(b)){break e}d=l[a+30>>1];if((c|0)>=0){d=(c|0)%(d|0)|0}else{d=d+((c^-1)%(d|0)^-1)|0}f=n[xb(b,(p(d<<16>>16,g)+e|0)-1|0)>>2];break d}f=Yd(q(Xk(a,(c<<16)+65536>>16)/Xk(a,c)),q(q(e|0)/q(d|0)))}f=q(n[xb(h,c-i[a+28>>1]|0)>>2]*f)}return f}function Fw(a){a=a|0;var b=0;a:{b:{c:{if(k[a+3|0]!=19){break c}h[a+3|0]=20;d:{e:{f:{g:{h:{i:{j:{k:{l:{m:{n:{o:{b=k[a+5|0];switch(b>>>4|0){case 6:break j;case 5:break k;case 4:break l;case 3:break m;case 2:break n;case 1:break o;case 0:break b;case 13:break d;case 12:break e;case 11:break f;case 10:break g;case 9:break h;case 7:break i;default:break c}}h[a+3|0]=2;break a}h[a+3|0]=3;break a}h[a+5|0]=b&15|16;return}h[a+5|0]=b&3|48;return}h[a+5|0]=b&15|32;return}h[a+5|0]=b&15|176;return}h[a+5|0]=b&3|64;return}h[a+3|0]=15;h[a+5|0]=b&15;return}if(b&15){h[a+3|0]=11;h[a+5|0]=b<<4|15;return}break b}if(b&15){h[a+3|0]=11;break a}break b}if((b|0)!=192){break c}h[a|0]=254;break b}if((b|0)!=208){break c}h[a+3|0]=0}return}h[a+3|0]=0;return}h[a+5|0]=b|240}function Bla(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0;c=Za-80|0;Za=c;h=AL(a,1<<b-1);j[a+12>>2]=b;a:{b=1<<b;f=b>>>2|0;if(f){i=1/+(b>>>0);b=f;e=1;while(1){j[114630]=0;o[c+40>>3]=+(b>>>0)*-6.283185307179586*i;I(1524,c+48|0,30864,c+40|0);d=j[114630];j[114630]=0;if((d|0)==1){break a}j[114630]=0;F(1214,c- -64|0,c+48|0);d=j[114630];j[114630]=0;if((d|0)==1){break a}d=$b(h,e);g=j[c+76>>2];j[d+8>>2]=j[c+72>>2];j[d+12>>2]=g;g=j[c+68>>2];j[d>>2]=j[c+64>>2];j[d+4>>2]=g;e=e<<1;b=b>>>1|0;if(b){continue}break}}b=gl(c+24|0,1,0);j[114630]=0;e=j[b+12>>2];j[c+16>>2]=j[b+8>>2];j[c+20>>2]=e;e=j[b+4>>2];j[c+8>>2]=j[b>>2];j[c+12>>2]=e;L(1525,a|0,0,f|0,c+8|0);b=j[114630];j[114630]=0;if((b|0)==1){break a}Za=c+80|0;return a|0}a=D()|0;C()|0;Ko(h);G(a|0);z()}function Uwa(a,b){var c=0,d=0,e=0;d=Za-16|0;Za=d;if(!(k[b+5|0]|k[b+3|0]!=4)){Nd(d+8|0,a,l[a+14>>1]);Qd(d+8|0,0);h[b+3|0]=0}c=k[b+2|0];a:{if((c|0)!=11){break a}c=11;if(k[b+4|0]){break a}Nd(d+8|0,a,l[a+14>>1]);c=0;Qd(d+8|0,0);h[b+2|0]=0}b:{c:{d:{if(!k[b|0]){Nd(d+8|0,a,l[a+14>>1]);if(kb(d+8|0)){break d}c=k[b+2|0]}e=k[b+3|0];Nd(d+8|0,a,l[a+14>>1]);Qd(d+8|0,(e|0)==4|(c|0)==11);c=k[b+3|0];break c}c=k[b+3|0];e=k[b+2|0];if(!(c|(e|0)==11)){h[b+5|0]=0;h[b+3|0]=4;break b}if(e|(c|0)==4){break c}h[b+4|0]=0;h[b+2|0]=11}e:{if(!(!k[a+16|0]|c)){h[b+5|0]=125;h[b+3|0]=17;break e}f:{switch(c-16|0){case 0:break f;case 1:break e;default:break b}}if(k[b+5|0]){break b}h[b+5|0]=6;h[a+16|0]=1;break b}h[a+16|0]=0}i[a+14>>1]=(l[a+14>>1]+1>>>0)%l[a+12>>1];Za=d+16|0}function YGa(a,b){var c=0,d=0;d=Za-32|0;Za=d;md(b,0);si(d,1,a);qc(d+16|0,d);j[114630]=0;E(370,b+43|0,d+16|0)|0;c=j[114630];j[114630]=0;if((c|0)!=1){gb(d+16|0);c=a+16|0;j[b>>2]=k[c|0]|k[c+1|0]<<8|(k[c+2|0]<<16|k[c+3|0]<<24);c=a+20|0;j[b+4>>2]=k[c|0]|k[c+1|0]<<8|(k[c+2|0]<<16|k[c+3|0]<<24);c=a+24|0;j[b+8>>2]=k[c|0]|k[c+1|0]<<8|(k[c+2|0]<<16|k[c+3|0]<<24);c=a+28|0;j[b+24>>2]=k[c|0]|k[c+1|0]<<8|(k[c+2|0]<<16|k[c+3|0]<<24);i[b+30>>1]=k[a+32|0]<<2;i[b+28>>1]=k[a+33|0];a=a+48|0;if(h[a|0]&1){i[b+34>>1]=l[b+34>>1]|2}if(k[a|0]&2){i[b+34>>1]=l[b+34>>1]|4}if(k[a|0]&4){i[b+34>>1]=l[b+34>>1]|1;j[b>>2]=j[b>>2]>>>1;j[b+4>>2]=j[b+4>>2]>>>1;j[b+8>>2]=j[b+8>>2]>>>1}if(k[a|0]&8){i[b+34>>1]=l[b+34>>1]|32}Za=d+32|0;return}a=D()|0;C()|0;gb(d+16|0);G(a|0);z()}function Bda(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0,k=0,l=0,n=0,o=0;if(m[b+24>>2]>m[b+44>>2]){j[b+44>>2]=j[b+24>>2]}l=-1;n=-1;h=f&24;a:{if(!h|((h|0)==24?(e|0)==1:0)){break a}h=j[b+44>>2];if(h){g=h-zb(b+32|0)|0;o=g;g=g>>31}b:{c:{switch(e|0){case 1:if(f&8){e=j[b+12>>2]-j[b+8>>2]|0;i=e;k=e>>31;break b}e=j[b+24>>2]-j[b+20>>2]|0;i=e;k=e>>31;break b;case 0:break b;case 2:break c;default:break a}}i=o;k=g}d=d+k|0;c=c+i|0;d=i>>>0>c>>>0?d+1|0:d;e=c;c=d;if((d|0)<0|((d|0)>(g|0)?1:(g|0)<=(d|0)?e>>>0>o>>>0:0)){break a}d=f&8;d:{if(!(c|e)){break d}if(j[b+12>>2]?0:d){break a}if(!(f&16)){break d}if(!j[b+24>>2]){break a}}if(d){um(b,j[b+8>>2],e+j[b+8>>2]|0,j[b+44>>2])}if(f&16){ew(b,j[b+20>>2],j[b+28>>2]);kr(b,e)}l=e;n=c}sg(a,l,n)}function Hya(a){a=a|0;var b=0,c=0,d=0,e=0,f=0,g=0;c=Za-16|0;Za=c;f=Cb(a+4|0);d=Aya(a+16|0);h[a+20|0]=0;g=uya(a+24|0);j[114630]=0;N(80,c+8|0);b=j[114630];j[114630]=0;a:{b:{c:{if((b|0)!=1){Yx(d,ud(c+8|0));bf(c+8|0);h[a+20|0]=0;b=0;break c}b=qa(71412,71388)|0;e=C()|0;if((e|0)==(W(71412)|0)){O(b|0)|0;j[114630]=0;M(81);a=j[114630];j[114630]=0;if((a|0)==1){b=D()|0;C()|0;j[114630]=0;M(20);a=j[114630];j[114630]=0;if((a|0)!=1){break b}J(0)|0;C()|0;ib()}z()}if((W(71388)|0)!=(e|0)){break b}O(b|0)|0;h[a+20|0]=0;j[114630]=0;M(20);b=j[114630];j[114630]=0;if((b|0)==1){b=D()|0;C()|0;break b}b=k[a+20|0]}if(b&255){break a}j[114630]=0;N(82,a|0);b=j[114630];j[114630]=0;if((b|0)!=1){break a}b=D()|0;C()|0}bf(g);bf(d);gb(f);G(b|0);z()}Za=c+16|0;return a|0}function Xya(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0;d=Za-32|0;Za=d;md(b,0);si(d,1,a);qc(d+16|0,d);j[114630]=0;E(370,b+43|0,d+16|0)|0;c=j[114630];j[114630]=0;if((c|0)!=1){gb(d+16|0);c=a+48|0;j[b>>2]=k[c|0]|k[c+1|0]<<8|(k[c+2|0]<<16|k[c+3|0]<<24);c=a+52|0;j[b+4>>2]=k[c|0]|k[c+1|0]<<8|(k[c+2|0]<<16|k[c+3|0]<<24);c=a+56|0;j[b+8>>2]=k[c|0]|k[c+1|0]<<8|(k[c+2|0]<<16|k[c+3|0]<<24);c=a+62|0;j[b+24>>2]=k[c|0]|k[c+1|0]<<8;js(b,+((k[a+60|0]^8)-120|0)*.005208333333333333);h[d+16|0]=k[a+61|0];h[d|0]=64;e=b,f=k[Zb(d+16|0,d)|0]<<2,i[e+30>>1]=f;i[b+34>>1]=0;a=a+47|0;if(k[a|0]&4){i[b+34>>1]=l[b+34>>1]|1;j[b>>2]=j[b>>2]>>>1}if(k[a|0]&32){i[b+34>>1]=l[b+34>>1]|4}if(h[a|0]<=-1){i[b+34>>1]=l[b+34>>1]|2}Za=d+32|0;return}a=D()|0;C()|0;gb(d+16|0);G(a|0);z()}function iJ(a,b){var c=q(0),d=q(0),e=q(0);a:{b:{c:{switch(b|0){case 0:oo(a,q(1));no(a,q(3.725290298461914e-9));mo(a,q(268435456));lo(a,0);break b;case 1:oo(a,q(32));no(a,q(4.656612873077393e-10));mo(a,q(2147483648));lo(a,0);break b;case 2:oo(a,q(2));no(a,q(7.450580596923828e-9));mo(a,q(134217728));lo(a,1);break b;default:oo(a,q(1));no(a,q(7.450580596923828e-9));mo(a,q(134217728));lo(a,1);Pw(a,0);_k(a,1);Ow(a,1);d=q(256);c=q(128);e=q(128);b=0;break a;case 4:case 5:break c}}oo(a,q(.75));no(a,q(7.450580596923828e-9));mo(a,q(134217728));lo(a,1);Pw(a,0);b=(b|0)==4;_k(a,b?2:3);Ow(a,1);d=q(256);c=b?q(256):q(192);e=c;b=1;break a}Pw(a,1);_k(a,0);Ow(a,0);d=q(128);e=q(100);c=q(256);b=4}n[a+16>>2]=c;n[a+20>>2]=e;n[a+24>>2]=d;j[a+28>>2]=b}function nca(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0;d=Za-32|0;Za=d;j[114630]=0;N(2010,a|0);e=j[114630];j[114630]=0;a:{b:{c:{if((e|0)==1){break c}j[114630]=0;N(2036,b|0);e=j[114630];j[114630]=0;if((e|0)==1){break c}j[114630]=0;N(2036,c|0);f=j[114630];j[114630]=0;e=1;if((f|0)==1){break c}f=j[a+24>>2];b=_b(d+24|0,b);c=_b(d+16|0,c);j[114630]=0;g=j[b+4>>2];j[d+8>>2]=j[b>>2];j[d+12>>2]=g;b=j[c+4>>2];j[d>>2]=j[c>>2];j[d+4>>2]=b;L(2080,f|0,d+8|0,d|0,1);b=j[114630];j[114630]=0;if((b|0)!=1){break b}}b=J(0)|0;C()|0;O(b|0)|0;j[114630]=0;L(1984,37201,a|0,0,0);a=j[114630];j[114630]=0;if((a|0)==1){break a}Q();e=0}Za=d+32|0;return e|0}a=D()|0;C()|0;j[114630]=0;M(20);b=j[114630];j[114630]=0;if((b|0)!=1){G(a|0);z()}J(0)|0;C()|0;ib();z()}function Bpa(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=q(0),h=q(0),l=0,m=q(0),o=0,s=0;f=Za-16|0;Za=f;o=f,s=p(j[a>>2],be(a)),j[o+8>>2]=s;jc(f+8|0,c>>>2|0);c=lb(b);g=n[e+4>>2];e=j[f+8>>2];if(e){while(1){g=q(u(q(r((PMa(2,k[c|0]|k[c+1|0]<<8|(k[c+2|0]<<16|k[c+3|0]<<24)),TMa()))),g));c=c+4|0;e=e-1|0;if(e){continue}break}}c=g==q(0);a:{if(c){break a}e=j[f+8>>2];if(!e){break a}m=c?q(1):q(q(1)/g);c=j[a+20>>2];while(1){n[f+12>>2]=m*(PMa(2,k[b|0]|k[b+1|0]<<8|(k[b+2|0]<<16|k[b+3|0]<<24)),TMa());Kd(f+12|0,q(-1));h=q(n[f+12>>2]*q(32768));n[f+12>>2]=h;a=c;h=Rd(h);b:{if(q(r(h))<q(2147483648)){l=~~h;break b}l=-2147483648}o=a,s=Dc(l),i[o>>1]=s;b=b+4|0;c=c+2|0;e=e-1|0;if(e){continue}break}}if(d){n[d>>2]=g}Za=f+16|0;return j[f+8>>2]<<2}function vva(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0;e=Za-32|0;Za=e;l=j[a+24>>2];m=j[a+20>>2];n=j[a+16>>2];b=j[a+4>>2];f=j[a>>2];j[e+24>>2]=f;j[e+28>>2]=b;g=j[a+12>>2];j[e+16>>2]=j[a+8>>2];j[e+20>>2]=g;if(d){while(1){k=(((b&2147483647)<<1|f>>>31)&-2)+n|0;b=(f>>>21&2040)+27888|0;o=i[b+6>>1];q=i[b+4>>1];r=i[b+2>>1];s=i[b>>1];g=0;b=1;while(1){j[(e+8|0)+(g<<2)>>2]=(((p(h[g+k|0],r)+p(h[(g|-2)+k|0],s)|0)+p(h[(g|2)+k|0],q)|0)+p(h[(g|4)+k|0],o)<<8)/16384;f=b;b=0;g=1;if(f){continue}break}j[c>>2]=j[c>>2]+p(j[e+8>>2],m);j[c+4>>2]=j[c+4>>2]+p(j[e+12>>2],l);Bb(e+24|0,e+16|0);d=d-1|0;if(d){c=c+8|0;f=j[e+24>>2];b=j[e+28>>2];continue}break}f=j[e+24>>2];b=j[e+28>>2]}j[a>>2]=f;j[a+4>>2]=b;Za=e+32|0}function IW(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0;g=Za-96|0;Za=g;di(g+48|0,g+40|0,c);j[114630]=0;I(224,g+60|0,g+32|0,d|0);d=j[114630];j[114630]=0;c=1;a:{b:{c:{d:{e:{if((d|0)!=1){j[114630]=0;I(224,g+72|0,g+24|0,e|0);c=j[114630];j[114630]=0;if((c|0)==1){break e}j[114630]=0;I(224,g+84|0,g+16|0,f|0);c=j[114630];j[114630]=0;if((c|0)==1){break d}j[114630]=0;F(225,g+8|0,g+48|0);c=j[114630];j[114630]=0;if((c|0)==1){break b}j[114630]=0;I(72,a|0,b|0,g+8|0);a=j[114630];j[114630]=0;if((a|0)==1){break b}uB(g+48|0);Za=g+96|0;return}d=D()|0;C()|0;break c}d=D()|0;c=2;C()|0;break c}d=D()|0;C()|0;c=3}c=(g+48|0)+p(c,12)|0;while(1){c=gb(c-12|0);if((c|0)!=(g+48|0)){continue}break}break a}d=D()|0;C()|0;uB(g+48|0)}G(d|0);z()}function KJa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0;f=Cb(a);g=nb(b);j[114630]=0;F(523,f|0,g|0);a=j[114630];j[114630]=0;if((a|0)!=1){a:{if(g){while(1){a=d+1|0;e=k[Ub(b,d)|0];b:{c:{if((a|0)==(g|0)|(e|0)!=37){break c}e=k[Ub(b,a)|0];d=e-49|0;if((d&255)>>>0<=8){if(oJa(c)>>>0<=d>>>0){d=a;break b}j[114630]=0;d=E(524,c|0,d|0)|0;e=j[114630];j[114630]=0;if((e|0)!=1){j[114630]=0;E(525,f|0,d|0)|0;e=j[114630];j[114630]=0;d=a;if((e|0)!=1){break b}}break a}if((e|0)==37){d=a;e=37;break c}j[114630]=0;K(526,f|0,1,37)|0;h=j[114630];j[114630]=0;d=a;if((h|0)==1){break a}}j[114630]=0;K(526,f|0,1,e<<24>>24)|0;a=j[114630];j[114630]=0;if((a|0)==1){break a}}d=d+1|0;if((g|0)!=(d|0)){continue}break}}return}}a=D()|0;C()|0;gb(f);G(a|0);z()}function YQ(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,i=0,k=0,l=0,m=0,n=0;e=Za-32|0;Za=e;j[e+24>>2]=b;m=e,n=nd(a),j[m+8>>2]=n;g=Jn(e+24|0,e+8|0);b=ti(c,d);a:{b:{if(!b){break b}if(hz(c,zb(a),zb(a)+nb(a)|0)){b=Yh(e+8|0,c,d);c=j[e+24>>2];d=zb(b);g=zb(b);i=nb(b);j[114630]=0;c=P(610,a|0,c|0,d|0,g+i|0)|0;a=j[114630];j[114630]=0;if((a|0)!=1){gb(b);break a}a=D()|0;C()|0;gb(b);G(a|0);z()}i=nb(a);f=sc(a);c:{if(b>>>0<=f-i>>>0){f=zb(a);k=i-g|0;if(!k){break c}l=g+f|0;Il(b+l|0,l,k);break c}xl(a,f,(b+i|0)-f|0,i,g,0,b);f=j[a>>2]}b=b+i|0;Bg(a,b);h[e+8|0]=0;Sd(b+f|0,e+8|0);if((c|0)==(d|0)){break b}b=g+f|0;while(1){Sd(b,c);b=b+1|0;c=c+1|0;if((d|0)!=(c|0)){continue}break}}m=e,n=nd(a),j[m+8>>2]=n;c=af(e+8|0,g)}Za=e+32|0;return c|0}function jF(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0;f=Za-16|0;Za=f;a:{b:{c:{d:{if((b|0)>=0){if((Uk(a+8|0)|0)>(b|0)){break d}}b=R(8)|0;j[114630]=0;c=E(85,f|0,40665)|0;a=j[114630];j[114630]=0;if((a|0)==1){break c}Wb(b,c);j[114630]=0;I(2004,b|0,83648,2012);a=j[114630];j[114630]=0;if((a|0)!=1){break a}a=D()|0;C()|0;gb(c);break b}d=a+32|0;a=(j[d>>2]+(b<<5)|0)+480280|0;c=c?134218752:0;j[a>>2]=c|j[a>>2]&-134218753;a=(j[d>>2]+p(b,896)|0)+1075072|0;j[a>>2]=c|j[a>>2]&-134218753;a=l[j[d>>2]+480188>>1];if(a>>>0<=255){b=b+1|0;while(1){e=p(a,896);if((b|0)==l[(e+j[d>>2]|0)+1075792>>1]){e=(e+j[d>>2]|0)+1075072|0;j[e>>2]=c|j[e>>2]&-134218753}a=a+1|0;if((a&65535)!=256){continue}break}}Za=f+16|0;return}a=D()|0;C()|0;S(b|0)}G(a|0)}z()}function hua(a){var b=0,c=0,d=0,e=0,f=0,g=0;d=Za-16|0;Za=d;yc(d+8|0,a);a:{b:{c:{b=a+16|0;d:{if($c(b)){while(1){e:{e=j[b>>2];j[114630]=0;e=H(98,e|0)|0;g=j[114630];j[114630]=0;if((g|0)==1){break e}c=c|e;f=f+32|0;if(f>>>0<32){continue}break d}break}b=J(71388)|0;if((C()|0)!=(W(71388)|0)){break a}O(b|0)|0;h[a+20|0]=0;j[114630]=0;N(82,a|0);b=j[114630];j[114630]=0;if((b|0)==1){break c}j[114630]=0;M(20);b=j[114630];j[114630]=0;if((b|0)!=1){break d}b=D()|0;C()|0;break a}h[a+20|0]=0}if(!k[a+20|0]){a=j[a+24>>2];j[114630]=0;a=H(99,a|0)|0;b=j[114630];j[114630]=0;if((b|0)==1){break b}c=a^c}Za=d+16|0;return c}b=D()|0;C()|0;j[114630]=0;M(20);a=j[114630];j[114630]=0;if((a|0)!=1){break a}J(0)|0;C()|0;ib();z()}b=D()|0;C()|0}G(b|0);z()}function SFa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0;d=Za-32|0;Za=d;j[d+28>>2]=0;gi(a,d+28|0);a:{b:{e=j[d+28>>2];c:{if(e>>>0>500){break c}d:{e:{f:{if(e){while(1){e=Cb(d+16|0);j[114630]=0;i[d+14>>1]=0;f=K(721,a|0,e|0,255)|0;g=j[114630];j[114630]=0;if((g|0)==1){break b}if(!f){break d}j[114630]=0;E(712,a|0,d+14|0)|0;f=j[114630];j[114630]=0;if((f|0)==1){break b}j[114630]=0;I(13,d|0,c|0,e|0);f=j[114630];j[114630]=0;if((f|0)==1){break f}j[114630]=0;f=E(722,b|0,d+14|0)|0;g=j[114630];j[114630]=0;if((g|0)==1){break e}ob(f,d);gb(d);gb(e);h=h+1|0;if(h>>>0<m[d+28>>2]){continue}break}}mf(j[j[a>>2]-12>>2]+a|0);break c}a=D()|0;C()|0;break a}a=D()|0;C()|0;gb(d);break a}gb(e)}Za=d+32|0;return}a=D()|0;C()|0}gb(e);G(a|0);z()}function RFa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0;d=Za-32|0;Za=d;i[d+30>>1]=0;cf(a,d+30|0);a:{b:{e=l[d+30>>1];c:{if(e>>>0>500){break c}d:{e:{f:{if(e){while(1){e=Cb(d+16|0);j[114630]=0;i[d+14>>1]=0;f=K(723,a|0,e|0,255)|0;g=j[114630];j[114630]=0;if((g|0)==1){break b}if(!f){break d}j[114630]=0;E(712,a|0,d+14|0)|0;f=j[114630];j[114630]=0;if((f|0)==1){break b}j[114630]=0;I(13,d|0,c|0,e|0);f=j[114630];j[114630]=0;if((f|0)==1){break f}j[114630]=0;f=E(722,b|0,d+14|0)|0;g=j[114630];j[114630]=0;if((g|0)==1){break e}ob(f,d);gb(d);gb(e);h=h+1|0;if(h>>>0<l[d+30>>1]){continue}break}}mf(j[j[a>>2]-12>>2]+a|0);break c}a=D()|0;C()|0;break a}a=D()|0;C()|0;gb(d);break a}gb(e)}Za=d+32|0;return}a=D()|0;C()|0}gb(e);G(a|0);z()}function IAa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0;f=Qc(a);g=nb(b);j[114630]=0;F(73,f|0,g|0);a=j[114630];j[114630]=0;if((a|0)!=1){a:{if(g){while(1){a=d+1|0;e=k[Ub(b,d)|0];b:{c:{if((a|0)==(g|0)|(e|0)!=37){break c}e=k[Ub(b,a)|0];d=e-49|0;if((d&255)>>>0<=8){if(rza(c)>>>0<=d>>>0){d=a;break b}j[114630]=0;d=E(74,c|0,d|0)|0;e=j[114630];j[114630]=0;if((e|0)!=1){j[114630]=0;E(75,f|0,d|0)|0;e=j[114630];j[114630]=0;d=a;if((e|0)!=1){break b}}break a}if((e|0)==37){d=a;e=37;break c}j[114630]=0;K(76,f|0,1,37)|0;h=j[114630];j[114630]=0;d=a;if((h|0)==1){break a}}j[114630]=0;K(76,f|0,1,e<<24>>24)|0;a=j[114630];j[114630]=0;if((a|0)==1){break a}}d=d+1|0;if((g|0)!=(d|0)){continue}break}}return}}a=D()|0;C()|0;gb(f);G(a|0);z()}function tpa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=q(0),g=0,h=0,l=q(0),m=0,o=0;e=Za-16|0;Za=e;j[e+12>>2]=c>>>3;j[e+8>>2]=j[a>>2];c=j[tb(e+12|0,e+8|0)>>2];l=n[d>>2];b=lb(b);if(c){a=j[a+20>>2];d=c;while(1){n[e+12>>2]=l*(PMa(2,k[b|0]|k[b+1|0]<<8|(k[b+2|0]<<16|k[b+3|0]<<24)),TMa());Kd(e+12|0,q(-1));f=q(n[e+12>>2]*q(32768));n[e+12>>2]=f;h=a;f=Rd(f);a:{if(q(r(f))<q(2147483648)){g=~~f;break a}g=-2147483648}m=h,o=Dc(g),i[m>>1]=o;n[e+12>>2]=l*(PMa(2,k[b+4|0]|k[b+5|0]<<8|(k[b+6|0]<<16|k[b+7|0]<<24)),TMa());Kd(e+12|0,q(-1));f=q(n[e+12>>2]*q(32768));n[e+12>>2]=f;h=a;f=Rd(f);b:{if(q(r(f))<q(2147483648)){g=~~f;break b}g=-2147483648}m=h,o=Dc(g),i[m+2>>1]=o;a=a+4|0;b=b+8|0;d=d-1|0;if(d){continue}break}}Za=e+16|0;return c<<3}function nD(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0,k=0;g=Za-272|0;Za=g;h=j[b>>2];j[g+12>>2]=h;i=a?a:g+16|0;e=0;a:{b:{c:{d=a?d:256;if(!d|!h){break c}f=c>>>0>=d>>>0;if(!(f|c>>>0>32)){break b}while(1){f=f?d:c;c=c-f|0;f=v2(i,g+12|0,f);if((f|0)==-1){d=0;h=j[g+12>>2];e=-1;break c}h=(g+16|0)==(i|0);i=h?i:f+i|0;e=e+f|0;d=d-(h?0:f)|0;h=j[g+12>>2];if(!d|!h){break c}f=c>>>0>=d>>>0;if(f|c>>>0>=33){continue}break}break b}if(!h){break a}}if(!d|!c){break a}f=e;while(1){d:{k=Cj(i,j[h>>2],0);e:{if(k+1>>>0<=1){e=-1;if(k){break a}j[g+12>>2]=0;break e}h=j[g+12>>2]+4|0;j[g+12>>2]=h;f=f+k|0;d=d-k|0;if(d){break d}}e=f;break a}i=i+k|0;e=f;c=c-1|0;if(c){continue}break}}if(a){j[b>>2]=j[g+12>>2]}Za=g+272|0;return e|0}function cna(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0;d=Za-32|0;Za=d;a:{b:{c:{d:{e:{if(Ri(b)){break e}i[d+8>>1]=l[a+480190>>1];i[d+24>>1]=j[b+4>>2]-1;c=l[gf(d+8|0,d+24|0)>>1];if(!c){break e}g=c;while(1){Nd(d+8|0,b,c);if(!kb(d+8|0)){j[114630]=0;e=E(1420,a|0,c&65535)|0;f=j[114630];j[114630]=0;if((f|0)==1){break b}if(e){j[114630]=0;e=E(85,d+8|0,20525)|0;f=j[114630];j[114630]=0;if((f|0)==1){break d}j[114630]=0;E(369,((c<<5)+a|0)+946300|0,e|0)|0;f=j[114630];j[114630]=0;if((f|0)==1){break c}gb(e);h=h+1|0}if(!(l[a+480190>>1]!=(c|0)|c>>>0<2)){i[a+480190>>1]=l[a+480190>>1]-1}}c=c-1|0;g=g-1|0;if(g&65535){continue}break}}Za=d+32|0;return h&65535}c=D()|0;C()|0;break a}c=D()|0;C()|0;gb(e);break a}c=D()|0;C()|0}G(c|0);z()}function D4(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,k=0;d=Za-32|0;Za=d;e=j[a+28>>2];j[d+16>>2]=e;f=j[a+20>>2];j[d+28>>2]=c;j[d+24>>2]=b;b=f-e|0;j[d+20>>2]=b;e=b+c|0;k=2;b=d+16|0;a:{b:{c:{if(!Oq(ka(j[a+60>>2],d+16|0,2,d+12|0)|0)){while(1){f=j[d+12>>2];if((f|0)==(e|0)){break c}if((f|0)<=-1){break b}g=j[b+4>>2];h=g>>>0<f>>>0;i=(h<<3)+b|0;g=f-(h?g:0)|0;j[i>>2]=g+j[i>>2];i=(h?12:4)+b|0;j[i>>2]=j[i>>2]-g;e=e-f|0;b=h?b+8|0:b;k=k-h|0;if(!Oq(ka(j[a+60>>2],b|0,k|0,d+12|0)|0)){continue}break}}if((e|0)!=-1){break b}}b=j[a+44>>2];j[a+28>>2]=b;j[a+20>>2]=b;j[a+16>>2]=b+j[a+48>>2];a=c;break a}j[a+28>>2]=0;j[a+16>>2]=0;j[a+20>>2]=0;j[a>>2]=j[a>>2]|32;a=0;if((k|0)==2){break a}a=c-j[b+4>>2]|0}Za=d+32|0;return a|0}function Ci(a,b,c){var d=0;a:{if((a|0)==(b|0)){break a}if((b-a|0)-c>>>0<=0-(c<<1)>>>0){Vb(a,b,c);return}d=(a^b)&3;b:{c:{if(a>>>0<b>>>0){if(d){break b}if(!(a&3)){break c}while(1){if(!c){break a}h[a|0]=k[b|0];b=b+1|0;c=c-1|0;a=a+1|0;if(a&3){continue}break}break c}d:{if(d){break d}if(a+c&3){while(1){if(!c){break a}c=c-1|0;d=c+a|0;h[d|0]=k[b+c|0];if(d&3){continue}break}}if(c>>>0<=3){break d}while(1){c=c-4|0;j[c+a>>2]=j[b+c>>2];if(c>>>0>3){continue}break}}if(!c){break a}while(1){c=c-1|0;h[c+a|0]=k[b+c|0];if(c){continue}break}break a}if(c>>>0<=3){break b}while(1){j[a>>2]=j[b>>2];b=b+4|0;a=a+4|0;c=c-4|0;if(c>>>0>3){continue}break}}if(!c){break a}while(1){h[a|0]=k[b|0];a=a+1|0;b=b+1|0;c=c-1|0;if(c){continue}break}}}function xca(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;d=Za-32|0;Za=d;j[114630]=0;N(2010,a|0);c=j[114630];j[114630]=0;a:{b:{c:{d:{e:{f:{if((c|0)==1){break f}j[114630]=0;N(2036,b|0);c=j[114630];j[114630]=0;if((c|0)==1){break f}e=j[a+24>>2];j[114630]=0;c=E(85,d|0,b|0)|0;b=j[114630];j[114630]=0;if((b|0)==1){break e}j[114630]=0;L(2071,d+16|0,e|0,c|0,1);b=j[114630];j[114630]=0;if((b|0)==1){break d}b=Gd(zb(d+16|0));gb(d+16|0);gb(c);break b}b=J(0)|0;C()|0;break c}b=J(0)|0;C()|0;break c}b=J(0)|0;C()|0;gb(c)}O(b|0)|0;b=0;j[114630]=0;L(1984,36929,a|0,0,0);a=j[114630];j[114630]=0;if((a|0)==1){break a}Q()}Za=d+32|0;return b|0}a=D()|0;C()|0;j[114630]=0;M(20);b=j[114630];j[114630]=0;if((b|0)!=1){G(a|0);z()}J(0)|0;C()|0;ib();z()}function Ab(a,b,c){var d=0,e=0,f=0;a:{if(!c){break a}f=a+c|0;h[f-1|0]=b;h[a|0]=b;if(c>>>0<3){break a}h[f-2|0]=b;h[a+1|0]=b;h[f-3|0]=b;h[a+2|0]=b;if(c>>>0<7){break a}h[f-4|0]=b;h[a+3|0]=b;if(c>>>0<9){break a}f=0-a&3;e=f+a|0;d=p(b&255,16843009);j[e>>2]=d;b=c-f&-4;c=b+e|0;j[c-4>>2]=d;if(b>>>0<9){break a}j[e+8>>2]=d;j[e+4>>2]=d;j[c-8>>2]=d;j[c-12>>2]=d;if(b>>>0<25){break a}j[e+24>>2]=d;j[e+20>>2]=d;j[e+16>>2]=d;j[e+12>>2]=d;j[c-16>>2]=d;j[c-20>>2]=d;j[c-24>>2]=d;j[c-28>>2]=d;c=b;b=e&4|24;c=c-b|0;if(c>>>0<32){break a}d=HMa(d,0,1,1);f=ab;b=b+e|0;while(1){j[b+24>>2]=d;e=f;j[b+28>>2]=e;j[b+16>>2]=d;j[b+20>>2]=e;j[b+8>>2]=d;j[b+12>>2]=e;j[b>>2]=d;j[b+4>>2]=e;b=b+32|0;c=c-32|0;if(c>>>0>31){continue}break}}return a}function eda(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;d=Za-32|0;Za=d;j[114630]=0;N(2010,a|0);c=j[114630];j[114630]=0;a:{b:{c:{d:{e:{f:{if((c|0)==1){break f}j[114630]=0;N(2036,b|0);c=j[114630];j[114630]=0;if((c|0)==1){break f}e=j[a+24>>2];j[114630]=0;c=E(85,d|0,b|0)|0;b=j[114630];j[114630]=0;if((b|0)==1){break e}j[114630]=0;I(2037,d+16|0,e|0,c|0);b=j[114630];j[114630]=0;if((b|0)==1){break d}b=Gd(zb(d+16|0));gb(d+16|0);gb(c);break b}b=J(0)|0;C()|0;break c}b=J(0)|0;C()|0;break c}b=J(0)|0;C()|0;gb(c)}O(b|0)|0;b=0;j[114630]=0;L(1984,35695,a|0,0,0);a=j[114630];j[114630]=0;if((a|0)==1){break a}Q()}Za=d+32|0;return b|0}a=D()|0;C()|0;j[114630]=0;M(20);b=j[114630];j[114630]=0;if((b|0)!=1){G(a|0);z()}J(0)|0;C()|0;ib();z()}function aea(a){a=a|0;var b=0;b=34280;a:{b:{c:{d:{e:{f:{g:{h:{i:{j:{k:{l:{m:{n:{if((a|0)<=276){if(!a){break n}if((a|0)==257){break m}if((a|0)!=267){break a}b=34317;break a}switch(a-277|0){case 1:case 2:case 3:case 4:case 5:case 6:case 7:case 8:case 13:case 14:case 15:case 16:case 17:case 18:break a;case 10:break j;case 9:break k;case 0:break l;case 23:break c;case 22:break d;case 21:break e;case 20:break f;case 19:break g;case 12:break h;case 11:break i;default:break b}}b=34181;break a}b=34294;break a}b=34336;break a}b=34350;break a}b=34364;break a}b=34376;break a}b=34396;break a}b=34417;break a}b=34429;break a}b=34448;break a}b=34480;break a}b=34502;break a}if((a|0)!=357){break a}b=34519}return Gd(b)|0}function zD(a,b,c,d,e,f){var g=0;g=Za-80|0;Za=g;a:{if((f|0)>=16384){bd(g+32|0,b,c,d,e,0,0,0,2147352576);d=j[g+40>>2];e=j[g+44>>2];b=j[g+32>>2];c=j[g+36>>2];if((f|0)<32767){f=f-16383|0;break a}bd(g+16|0,b,c,d,e,0,0,0,2147352576);f=((f|0)<49149?f:49149)-32766|0;d=j[g+24>>2];e=j[g+28>>2];b=j[g+16>>2];c=j[g+20>>2];break a}if((f|0)>-16383){break a}bd(g- -64|0,b,c,d,e,0,0,0,65536);d=j[g+72>>2];e=j[g+76>>2];b=j[g+64>>2];c=j[g+68>>2];if((f|0)>-32765){f=f+16382|0;break a}bd(g+48|0,b,c,d,e,0,0,0,65536);f=((f|0)>-49146?f:-49146)+32764|0;d=j[g+56>>2];e=j[g+60>>2];b=j[g+48>>2];c=j[g+52>>2]}bd(g,b,c,d,e,0,0,0,f+16383<<16);b=j[g+12>>2];j[a+8>>2]=j[g+8>>2];j[a+12>>2]=b;b=j[g+4>>2];j[a>>2]=j[g>>2];j[a+4>>2]=b;Za=g+80|0}function Aj(a,b,c){var d=0,e=0,f=0;e=Za-16|0;Za=e;j[a+4>>2]=0;a:{b:{d=4;c:{if(!k[Ki(e+8|0,a,1)|0]){break c}d=j[j[a>>2]-12>>2];j[114630]=0;d=j[(a+d|0)+24>>2];f=j[114630];j[114630]=0;d:{if((f|0)==1){break d}j[114630]=0;b=K(2379,d|0,b|0,c|0)|0;d=j[114630];j[114630]=0;if((d|0)==1){break d}j[a+4>>2]=b;d=(b|0)==(c|0)?0:6;break c}b=J(0)|0;C()|0;O(b|0)|0;Ii(j[j[a>>2]-12>>2]+a|0,1);b=j[j[a>>2]-12>>2];j[114630]=0;b=j[(a+b|0)+20>>2];c=j[114630];j[114630]=0;e:{if((c|0)!=1){if(!(b&1)){break e}j[114630]=0;M(81);a=j[114630];j[114630]=0;if((a|0)!=1){break a}}a=D()|0;C()|0;j[114630]=0;M(20);b=j[114630];j[114630]=0;if((b|0)==1){break b}G(a|0);z()}Q();d=1}eg(j[j[a>>2]-12>>2]+a|0,d);Za=e+16|0;return}J(0)|0;C()|0;ib()}z()}function eMa(a,b){var c=0,d=0,e=0,f=0,g=0,m=0;e=Za-16|0;Za=e;md(b,0);h[b+37|0]=k[a+22|0]<<4;h[e+15|0]=k[a+23|0];h[e+14|0]=64;g=b,m=k[Zb(e+15|0,e+14|0)|0]<<2,i[g+30>>1]=m;h[b+36|0]=k[a+24|0];c=a+25|0;j[b>>2]=k[c|0]|k[c+1|0]<<8|(k[c+2|0]<<16|k[c+3|0]<<24);d=a+33|0;a:{if((k[d|0]|k[d+1|0]<<8|(k[d+2|0]<<16|k[d+3|0]<<24))>>>0<3){break a}f=k[c|0]|k[c+1|0]<<8|(k[c+2|0]<<16|k[c+3|0]<<24);c=a+29|0;if(f>>>0<(k[c|0]|k[c+1|0]<<8|(k[c+2|0]<<16|k[c+3|0]<<24))+(k[d|0]|k[d+1|0]<<8|(k[d+2|0]<<16|k[d+3|0]<<24))>>>0){break a}i[b+34>>1]=l[b+34>>1]|2;j[b+4>>2]=k[c|0]|k[c+1|0]<<8|(k[c+2|0]<<16|k[c+3|0]<<24);j[b+8>>2]=(k[c|0]|k[c+1|0]<<8|(k[c+2|0]<<16|k[c+3|0]<<24))+(k[d|0]|k[d+1|0]<<8|(k[d+2|0]<<16|k[d+3|0]<<24))}Za=e+16|0}function Gm(a,b,c){var d=0,e=0,f=0,g=0,i=0;a:{if(c){h[b+829|0]=c;break a}c=k[b+829|0]}d=j[a+480180>>2]&202376205?c&240?c&-16:c&15:c;c=j[b+688>>2];b:{if(j[a+480180>>2]&69206029){break b}e=d&240;f=d&15;if((f|0)==15){if(e){Eo(a,b,(d&240)>>>4|0,0);return}if(!(h[b+872|0]&1)){break b}c=k[a+480208|0]&2?c:c-60|0;break b}if((e|0)!=240){break b}if(f){Do(a,b,f,0);return}if(!(h[b+872|0]&1)){break b}c=k[a+480208|0]&2?c:c+60|0}c:{if(j[a+1074416>>2]!=1|j[a+480180>>2]!=524288?!(!(h[b+872|0]&1)|k[a+480208|0]&2):0){break c}e=d&255;d=d&15;d:{if(d){if(j[a+480180>>2]&16777248?e&240:0){break d}c=c-(d<<2)|0;break d}c=(e>>>2&60)+c|0}if(j[a+480180>>2]!=1){break c}j[b+88>>2]=j[b+88>>2]|2097152}g=b,i=Gb(c,0,256),j[g+688>>2]=i}function Pua(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,k=0,l=0,m=0;g=Za-16|0;Za=g;k=j[a+24>>2];l=j[a+20>>2];m=j[a+16>>2];h=j[a+4>>2];e=h;f=j[a>>2];j[g+8>>2]=f;j[g+12>>2]=e;h=j[a+12>>2];j[g>>2]=j[a+8>>2];j[g+4>>2]=h;if(d){while(1){e=(e<<1)+m|0;f=(((f>>>16|0)+4&131064)<<1)+b|0;e=(((((p(i[e+4>>1],i[f+34>>1])+p(i[e+2>>1],i[f+32>>1])|0)+p(i[e+6>>1],i[f+36>>1])|0)+p(i[e+8>>1],i[f+38>>1])|0)/2|0)+((((p(i[e-4>>1],i[f+26>>1])+p(i[e-6>>1],i[f+24>>1])|0)+p(i[e-2>>1],i[f+28>>1])|0)+p(i[e>>1],i[f+30>>1])|0)/2|0)|0)/16384|0;j[c>>2]=j[c>>2]+p(e,l);j[c+4>>2]=j[c+4>>2]+p(e,k);Bb(g+8|0,g);d=d-1|0;if(d){c=c+8|0;f=j[g+8>>2];e=j[g+12>>2];continue}break}f=j[g+8>>2];e=j[g+12>>2]}j[a>>2]=f;j[a+4>>2]=e;Za=g+16|0}function Ipa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,l=0,m=0,n=0,p=0,q=0,s=0;g=Za-16|0;Za=g;j[g+8>>2]=c>>>3;j[g+4>>2]=j[a>>2];d=j[tb(g+8|0,g+4|0)>>2];b=lb(b);if(d){a=j[a+20>>2];c=d;while(1){n=0;e=b;h=k[e+4|0]|k[e+5|0]<<8|(k[e+6|0]<<16|k[e+7|0]<<24);l=k[e|0]|k[e+1|0]<<8|(k[e+2|0]<<16|k[e+3|0]<<24);f=h<<24|l>>>8;e=0;p=f&65280;f=e;e=h<<8|l>>>24;f=f|n;n=e&255|p|(l<<24|l<<8&16711680);e=g;j[e+8>>2]=((h&255)<<24|l>>>8)&-16777216|((h&16777215)<<8|l>>>24)&16711680|(h>>>8&65280|h>>>24)|f;j[e+12>>2]=n;wf(e+8|0,-1,1);m=o[e+8>>3]*32768;o[e+8>>3]=m;e=a;m=zd(m);a:{if(r(m)<2147483648){f=~~m;break a}f=-2147483648}q=e,s=Dc(f),i[q>>1]=s;a=a+2|0;b=b+8|0;c=c-1|0;if(c){continue}break}}Za=g+16|0;return d<<3}function wE(a,b,c,d){a:{if(b>>>0>20){break a}b:{switch(b-9|0){case 0:b=j[c>>2];j[c>>2]=b+4;j[a>>2]=j[b>>2];return;case 1:b=j[c>>2];j[c>>2]=b+4;b=j[b>>2];j[a>>2]=b;j[a+4>>2]=b>>31;return;case 2:b=j[c>>2];j[c>>2]=b+4;j[a>>2]=j[b>>2];j[a+4>>2]=0;return;case 3:b=j[c>>2]+7&-8;j[c>>2]=b+8;c=j[b+4>>2];j[a>>2]=j[b>>2];j[a+4>>2]=c;return;case 4:b=j[c>>2];j[c>>2]=b+4;b=i[b>>1];j[a>>2]=b;j[a+4>>2]=b>>31;return;case 5:b=j[c>>2];j[c>>2]=b+4;j[a>>2]=l[b>>1];j[a+4>>2]=0;return;case 6:b=j[c>>2];j[c>>2]=b+4;b=h[b|0];j[a>>2]=b;j[a+4>>2]=b>>31;return;case 7:b=j[c>>2];j[c>>2]=b+4;j[a>>2]=k[b|0];j[a+4>>2]=0;return;case 8:b=j[c>>2]+7&-8;j[c>>2]=b+8;o[a>>3]=o[b>>3];return;case 9:break b;default:break a}}bb[d|0](a,c)}}function xy(a,b,c){var d=0,e=0,f=0,g=0,j=0,m=0;g=Za-16|0;Za=g;if(h[a|0]&1){h[b+12|0]=k[b+12|0]|1}if(k[a|0]&2){h[b+12|0]=k[b+12|0]|4}if(k[a|0]&4){h[b+12|0]=k[b+12|0]|2}if(k[a|0]&16){h[b+12|0]=k[b+12|0]|16}if(k[a|0]&32){h[b+12|0]=k[b+12|0]|8}h[g+15|0]=k[a+1|0];h[g+14|0]=25;Nf(b,k[Zb(g+15|0,g+14|0)|0]);h[b+15|0]=k[a+2|0];h[b+16|0]=k[a+3|0];h[b+13|0]=k[a+4|0];h[b+14|0]=k[a+5|0];if(sb(b)){while(1){f=(d<<2)+a|0;e=f+6|0;e=k[e|0]|k[e+1|0]<<8;j=xb(b,d),m=e,i[j>>1]=m;a:{if(!d){break a}e=d-1|0;if(l[xb(b,d)>>1]>=l[xb(b,e)>>1]){break a}e=l[xb(b,e)>>1];j=xb(b,d),m=e+1|0,i[j>>1]=m}f=f+8|0;f=Gb((k[f|0]|k[f+1|0]<<8)<<16>>16>>c,0,64);j=xb(b,d),m=f,h[j+2|0]=m;d=d+1|0;if(sb(b)>>>0>d>>>0){continue}break}}Za=g+16|0}function sva(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,k=0,l=0,m=0;b=Za-16|0;Za=b;h=j[a+40>>2];k=j[a+36>>2];m=j[a+16>>2];g=j[a+4>>2];e=g;f=j[a>>2];j[b+8>>2]=f;j[b+12>>2]=e;g=j[a+12>>2];j[b>>2]=j[a+8>>2];j[b+4>>2]=g;a:{if(!d){g=h>>12;l=k>>12;break a}while(1){g=j[a+32>>2];k=j[a+28>>2]+k|0;l=k>>12;e=(e<<1)+m|0;f=(f>>>21&2040)+27888|0;e=(((p(i[e>>1],i[f+2>>1])+p(i[e-2>>1],i[f>>1])|0)+p(i[e+2>>1],i[f+4>>1])|0)+p(i[e+4>>1],i[f+6>>1])|0)/16384|0;j[c>>2]=j[c>>2]+p(l,e);h=g+h|0;g=h>>12;j[c+4>>2]=j[c+4>>2]+p(e,g);Bb(b+8|0,b);d=d-1|0;if(d){c=c+8|0;f=j[b+8>>2];e=j[b+12>>2];continue}break}f=j[b+8>>2];e=j[b+12>>2]}j[a+40>>2]=h;j[a+20>>2]=l;j[a+36>>2]=k;j[a+24>>2]=g;j[a>>2]=f;j[a+4>>2]=e;Za=b+16|0}function mea(a,b,c){var d=0,e=0,f=0,g=0,h=0,k=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;e=l[a+22>>1];f=l[a+20>>1];g=j[a+4>>2];if(c){n=i[a+26>>1];t=i[a+18>>1];o=i[a+24>>1];u=i[a+16>>1];m=j[a>>2]-1|0;q=a+32928|0;while(1){h=Ac(j[b>>2]);d=Ac(j[b+4>>2]);f=Ac((f<<16>>16)-h|0);e=Ac((e<<16>>16)-d|0);f=Dc(Ac((p(f,u)|0)/65536<<1)+h|0);e=Dc(Ac((p(e,t)|0)/65536<<1)+d|0);d=(g<<2)+q|0;h=i[d+2>>1];r=i[d>>1];d=Dc(((p(r,o)|0)/-65536|0)+f|0);g=g+1&127;k=(g<<2)+q|0;s=Dc(((p(h,n)|0)/-65536|0)+e|0);i[k+2>>1]=s;i[k>>1]=d;m=m+1&8191;k=(m<<2)+a|0;v=k,w=Dc(((p(d,o)|0)/65536|0)+r|0),i[v+160>>1]=w;v=k,w=Dc(h+((p(n,s)|0)/65536|0)|0),i[v+162>>1]=w;b=b+8|0;c=c-1|0;if(c){continue}break}}i[a+22>>1]=e;i[a+20>>1]=f;j[a+4>>2]=g}function e6(a,b,c,d){var e=0,f=0,g=0,h=0,i=0,m=0;if((d|0)>=1){f=b+7548|0;i=a+6152|0;while(1){g=p(e,28)+c|0;m=l[g+4>>1];h=j[b+4>>2];_5(i,(p(e,39)+b|0)+16156|0,b,g,f,e);Z5((p(e,2304)+b|0)+2940|0,b,g,f,m+h|0);e=e+1|0;if((e|0)!=(d|0)){continue}break}}e=k[a+6155|0];a:{if(e&16){Y5(b+2940|0,b+16195|0,c,a+6152|0);break a}if((e&224)!=96){break a}ZE(b+2940|0,576)}if((d|0)>=1){m=b+7708|0;e=0;while(1){f=k[a+6153|0];f=(k[c+12|0]!=0)<<1<<((p((f>>>3&1)+(f>>>4&1)|0,3)+(k[a+6154|0]>>>2&3)|0)==2);g=(p(e,2304)+b|0)+2940|0;i=g;if(k[c+14|0]){X5(((p(e,2304)+b|0)+p(f,72)|0)+2940|0,m,j[c>>2]+k[c+13|0]|0);h=f-1|0}else{h=31}W5(i,h);V5(g,p(e,1152)+a|0,k[c+11|0],f);U5(g);c=c+28|0;e=e+1|0;if((e|0)!=(d|0)){continue}break}}}function qla(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0;e=Za-16|0;Za=e;d=Cb(e);a:{b:{if(c>>>0>=64){j[114630]=0;c=H(339,b|0)|0;f=j[114630];j[114630]=0;if((f|0)==1){break a}if((c|0)<=0){j[114630]=0;E(85,a|0,30880)|0;a=j[114630];j[114630]=0;if((a|0)!=1){break b}break a}j[114630]=0;F(111,d|0,c|0);c=j[114630];j[114630]=0;if((c|0)==1){break a}}c:{while(1){d:{j[114630]=0;c=H(387,b|0)|0;f=j[114630];j[114630]=0;if((f|0)==1){break d}if(!c){break c}j[114630]=0;K(1526,d|0,1,((c-65&255)>>>0<26?c+32|0:c)<<24>>24)|0;c=j[114630];j[114630]=0;if((c|0)!=1){continue}}break}break a}j[114630]=0;E(338,b|0,4)|0;b=j[114630];j[114630]=0;if((b|0)==1){break a}Mc(a,d)}gb(d);Za=e+16|0;return}a=D()|0;C()|0;gb(d);G(a|0);z()}function ND(a){a=a|0;var b=0,c=0,d=0,e=0;d=Za-16|0;Za=d;a:{b:{if(!j[(j[j[a>>2]-12>>2]+a|0)+24>>2]){break b}j[114630]=0;c=E(2383,d+8|0,a|0)|0;b=j[114630];j[114630]=0;c:{if((b|0)!=1){d:{if(!k[c|0]){break d}b=j[(j[j[a>>2]-12>>2]+a|0)+24>>2];j[114630]=0;b=H(2384,b|0)|0;e=j[114630];j[114630]=0;if((e|0)!=1){if((b|0)!=-1){break d}b=j[j[a>>2]-12>>2];j[114630]=0;F(2385,a+b|0,1);b=j[114630];j[114630]=0;if((b|0)!=1){break d}}b=J(0)|0;C()|0;MD(c);break c}MD(c);break b}b=J(0)|0;C()|0}O(b|0)|0;c=j[j[a>>2]-12>>2];j[114630]=0;N(19,a+c|0);c=j[114630];j[114630]=0;if((c|0)==1){break a}Q()}Za=d+16|0;return a|0}a=D()|0;C()|0;j[114630]=0;M(20);c=j[114630];j[114630]=0;if((c|0)!=1){G(a|0);z()}J(0)|0;C()|0;ib();z()}function c6(a,b,c){var d=0,e=0,f=0,g=0,i=0,j=0,l=0,m=0;e=R5(a,c);a:{if(!k[c+768|0]){e=0;break a}g=50112;while(1){if((d|0)==(j|0)){g=k[e|0]+50112|0;j=k[e+2|0]+j|0;l=k[e+1|0];e=e+3|0}m=d<<1;f=k[Bd(b,l)+g|0];h[(m+c|0)+770|0]=f;i=k[c+769|0];if(i>>>0>d>>>0){f=k[Bd(b,l)+g|0];i=k[c+769|0]}h[((m|1)+c|0)+770|0]=i?f:0;d=d+1|0;f=k[c+768|0];if(d>>>0<f>>>0){continue}break}if(!f){e=f<<1;break a}d=0;while(1){g=c+d|0;b:{if(!k[g+770|0]){e=6;break b}e=2;if((k[a+1|0]&6)==6){break b}e=Bd(b,2);f=k[c+768|0]}h[g+834|0]=e;e=f<<1&510;d=d+1|0;if(e>>>0>d>>>0){continue}break}}Q5(b,c+770|0,c+834|0,e,c);d=k[c+769|0];a=k[c+768|0];if(d>>>0<a>>>0){while(1){h[((d<<1|1)+c|0)+770|0]=0;d=d+1|0;if(a>>>0>d>>>0){continue}break}}}function Qua(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,k=0,l=0,m=0,n=0;g=Za-16|0;Za=g;l=j[a+24>>2];m=j[a+20>>2];n=j[a+16>>2];k=j[a+4>>2];e=k;f=j[a>>2];j[g+8>>2]=f;j[g+12>>2]=e;k=j[a+12>>2];j[g>>2]=j[a+8>>2];j[g+4>>2]=k;if(d){while(1){e=e+n|0;f=(((f>>>16|0)+4&131064)<<1)+b|0;e=(((((p(h[e+2|0],i[f+34>>1])+p(h[e+1|0],i[f+32>>1])|0)+p(h[e+3|0],i[f+36>>1])|0)+p(h[e+4|0],i[f+38>>1])<<8)/2|0)+((((p(h[e-2|0],i[f+26>>1])+p(h[e-3|0],i[f+24>>1])|0)+p(h[e-1|0],i[f+28>>1])|0)+p(h[e|0],i[f+30>>1])<<8)/2|0)|0)/16384|0;j[c>>2]=j[c>>2]+p(e,m);j[c+4>>2]=j[c+4>>2]+p(e,l);Bb(g+8|0,g);d=d-1|0;if(d){c=c+8|0;f=j[g+8>>2];e=j[g+12>>2];continue}break}f=j[g+8>>2];e=j[g+12>>2]}j[a>>2]=f;j[a+4>>2]=e;Za=g+16|0}function fLa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0;d=Za-16|0;Za=d;md(b,0);j[b>>2]=k[a|0]|k[a+1|0]<<8|(k[a+2|0]<<16|k[a+3|0]<<24);c=tt(a+4|0,a);j[b+4>>2]=k[c|0]|k[c+1|0]<<8|(k[c+2|0]<<16|k[c+3|0]<<24);c=tt(a+8|0,a);j[b+8>>2]=k[c|0]|k[c+1|0]<<8|(k[c+2|0]<<16|k[c+3|0]<<24);h[d+15|0]=127;h[d+14|0]=k[a+15|0];f=b,g=(((k[Zb(d+15|0,d+14|0)|0]<<8|64)&65344)>>>0)/127|0,i[f+30>>1]=g;e=a+12|0;if(k[e|0]>=16){c=k[e|0];i[b+34>>1]=32;i[b+28>>1]=c&240}c=a+13|0;j[b+24>>2]=(k[c|0]|k[c+1|0]<<8)<<1;if(!(k[c|0]|k[c+1|0]<<8)){j[b+24>>2]=16726}f=b,g=(p(ks(0,k[e|0]<<28>>24),j[b+24>>2])>>>0)/8363|0,j[f+24>>2]=g;if(m[b+4>>2]<m[b+8>>2]){i[b+34>>1]=l[b+34>>1]|2}if(k[a+16|0]&132){i[b+34>>1]=l[b+34>>1]|1}Za=d+16|0}function Fba(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,l=0,m=0,n=0,o=0;e=Za-16|0;Za=e;a:{b:{if(!ce(b,-1)){f=j[a+12>>2];g=j[a+8>>2];if(j[a+24>>2]==j[a+28>>2]){c=-1;if(!(k[a+48|0]&16)){break a}h=j[a+24>>2];i=j[a+20>>2];l=j[a+44>>2];m=j[a+20>>2];j[114630]=0;c=a+32|0;F(110,c|0,0);d=j[114630];j[114630]=0;if((d|0)==1){break b}d=sc(c);j[114630]=0;F(149,c|0,d|0);d=j[114630];j[114630]=0;if((d|0)==1){break b}d=zb(c);ew(a,d,nb(c)+d|0);kr(a,h-i|0);j[a+44>>2]=j[a+20>>2]+(l-m|0)}j[e+12>>2]=j[a+24>>2]+1;n=a,o=j[Lc(e+12|0,a+44|0)>>2],j[n+44>>2]=o;if(k[a+48|0]&8){c=zb(a+32|0);um(a,c,c+(f-g|0)|0,j[a+44>>2])}c=yG(a,tm(b));break a}c=jr(b);break a}a=J(0)|0;C()|0;O(a|0)|0;Q();c=-1}Za=e+16|0;return c|0}function Aoa(a,b,c){var d=0,e=0,f=0,g=0;a:{d=j[a+480208>>2];if(!(d&4096)){break a}b:{switch(c&15){case 0:j[b+88>>2]=j[b+88>>2]&-257;return;case 1:j[b+692>>2]=128;j[b+88>>2]=j[b+88>>2]|256;return;case 8:j[b+88>>2]=j[b+88>>2]&-25165825|16777216;return;case 9:j[b+88>>2]=j[b+88>>2]&-25165825|8388608;return;case 10:j[a+480208>>2]=d&-16385;return;case 11:j[a+480208>>2]=d|16384;return;case 12:j[a+480208>>2]=d&-8193;return;case 13:j[a+480208>>2]=d|8192;return;case 14:j[b+88>>2]=j[b+88>>2]&-129;return;case 15:break b;default:break a}}c:{if(!j[b+76>>2]|(j[b>>2]|j[b+4>>2])){break c}if(e=!Mf(b+810|0),f=0,g=k[b+88|0]&2,g?e:f){break c}c=j[b+76>>2]-1|0;j[b>>2]=-1;j[b+4>>2]=c}j[b+88>>2]=j[b+88>>2]|128}}function tva(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,k=0,l=0,m=0,n=0;e=Za-16|0;Za=e;k=j[a+40>>2];l=j[a+36>>2];n=j[a+16>>2];g=j[a+4>>2];b=g;f=j[a>>2];j[e+8>>2]=f;j[e+12>>2]=b;g=j[a+12>>2];j[e>>2]=j[a+8>>2];j[e+4>>2]=g;a:{if(!d){g=k>>12;m=l>>12;break a}while(1){g=j[a+32>>2];l=j[a+28>>2]+l|0;m=l>>12;b=b+n|0;f=(f>>>21&2040)+27888|0;b=(((p(h[b|0],i[f+2>>1])+p(h[b-1|0],i[f>>1])|0)+p(h[b+1|0],i[f+4>>1])|0)+p(h[b+2|0],i[f+6>>1])<<8)/16384|0;j[c>>2]=j[c>>2]+p(m,b);k=g+k|0;g=k>>12;j[c+4>>2]=j[c+4>>2]+p(b,g);Bb(e+8|0,e);d=d-1|0;if(d){c=c+8|0;f=j[e+8>>2];b=j[e+12>>2];continue}break}f=j[e+8>>2];b=j[e+12>>2]}j[a+40>>2]=k;j[a+20>>2]=m;j[a+36>>2]=l;j[a+24>>2]=g;j[a>>2]=f;j[a+4>>2]=b;Za=e+16|0}function X8(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;b=Za-32|0;Za=b;e=Ng(a);ld(b+24|0);j[114630]=0;a=E(2194,j[b+24>>2],j[b+28>>2])|0;c=j[114630];j[114630]=0;a:{b:{if((c|0)==1){break b}j[114630]=0;F(1527,e|0,a|0);a=j[114630];j[114630]=0;if((a|0)==1){break b}a=0;c:{while(1){j[114630]=0;c=E(2194,j[b+24>>2],j[b+28>>2])|0;d=j[114630];j[114630]=0;d:{if((d|0)!=1){if((a|0)<(c|0)){break d}Za=b+32|0;return}a=D()|0;C()|0;break a}c=j[j[b+24>>2]+(a<<3)>>2];j[114630]=0;c=E(85,b+8|0,c|0)|0;d=j[114630];j[114630]=0;if((d|0)!=1){j[114630]=0;F(1529,e|0,c|0);d=j[114630];j[114630]=0;if((d|0)==1){break c}gb(c);a=a+1|0;continue}break}a=D()|0;C()|0;break a}a=D()|0;C()|0;gb(c);break a}a=D()|0;C()|0}Vc(e);G(a|0);z()}function GH(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;c=Za-48|0;Za=c;j[c+8>>2]=542066252;d=c+8|4;h[d|0]=0;h[d+1|0]=0;h[d+2|0]=0;h[d+3|0]=0;d=j[b+4220>>2];h[c+16|0]=d;h[c+17|0]=d>>>8;h[c+18|0]=d>>>16;h[c+19|0]=d>>>24;d=j[b+4224>>2];h[c+20|0]=d;h[c+21|0]=d>>>8;h[c+22|0]=d>>>16;h[c+23|0]=d>>>24;d=j[b+4228>>2];h[c+24|0]=d;h[c+25|0]=d>>>8;h[c+26|0]=d>>>16;h[c+27|0]=d>>>24;d=j[b+4232>>2];h[c+28|0]=d;h[c+29|0]=d>>>8;h[c+30|0]=d>>>16;h[c+31|0]=d>>>24;d=j[b+4236>>2];h[c+32|0]=d;h[c+33|0]=d>>>8;h[c+34|0]=d>>>16;h[c+35|0]=d>>>24;h[c+36|0]=k[b+4240|0];h[c+37|0]=k[b+4241|0];h[c+38|0]=k[b+4242|0];h[c+39|0]=k[b+4243|0];h[c+40|0]=k[b+4244|0];b=b+4208|0;fk(b,33);Vb(j[b>>2],c+8|0,33);yi(c,b);vd(a,c);Za=c+48|0}function qX(a,b){var c=0,d=0,e=0,f=0,g=0;c=16;d=a>>>0>16?a:16;a:{if(!(d-1&d)){a=d;break a}while(1){a=c;c=a<<1;if(a>>>0<d>>>0){continue}break}}if(-64-a>>>0<=b>>>0){j[114604]=48;return 0}d=b>>>0<11?16:b+11&-8;c=Yc((d+a|0)+12|0);if(!c){return 0}b=c-8|0;b:{if(!(c&a-1)){a=b;break b}f=c-4|0;g=j[f>>2];c=((a+c|0)-1&0-a)-8|0;a=c-b>>>0>15?c:a+c|0;c=a-b|0;e=(g&-8)-c|0;if(!(g&3)){b=j[b>>2];j[a+4>>2]=e;j[a>>2]=b+c;break b}j[a+4>>2]=e|j[a+4>>2]&1|2;e=a+e|0;j[e+4>>2]=j[e+4>>2]|1;j[f>>2]=c|j[f>>2]&1|2;j[a+4>>2]=j[a+4>>2]|1;hq(b,c)}b=j[a+4>>2];c:{if(!(b&3)){break c}c=b&-8;if(c>>>0<=d+16>>>0){break c}j[a+4>>2]=d|b&1|2;b=a+d|0;d=c-d|0;j[b+4>>2]=d|3;c=a+c|0;j[c+4>>2]=j[c+4>>2]|1;hq(b,d)}return a+8|0}function iI(a,b,c){var d=0,e=0,f=0,g=0,h=0;e=Za-48|0;Za=e;f=Cb(e+32|0);j[114630]=0;E(1614,a|0,e+24|0)|0;d=j[114630];j[114630]=0;a:{b:{if((d|0)!=1){g=j[e+28>>2];d=j[e+24>>2];Ce(f);j[114630]=0;g=!g&d>>>0<255?d:255;F(149,f|0,g|0);d=j[114630];j[114630]=0;if((d|0)==1){break a}if(g){d=0;while(1){h=Ub(f,d);j[114630]=0;E(1615,a|0,h|0)|0;h=j[114630];j[114630]=0;if((h|0)==1){break a}d=d+1|0;if((g|0)!=(d|0)){continue}break}}if((RB(f)|0)!=-1){a=RB(f);j[114630]=0;F(149,f|0,a|0);a=j[114630];j[114630]=0;if((a|0)==1){break a}}j[114630]=0;I(13,e+8|0,c|0,f|0);a=j[114630];j[114630]=0;if((a|0)!=1){break b}break a}break a}ob(b,e+8|0);gb(e+8|0);gb(f);Za=e+48|0;return}a=D()|0;C()|0;gb(f);G(a|0);z()}function N9(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,m=0;d=Za+ -64|0;Za=d;a:{b:{if((b|0)>=0){e=a+24|0;if((Wi(Eb(j[e>>2]+484360|0))|0)>(b|0)){break b}}a=a+16|0;break a}g=l[bc(Eb(j[e>>2]+484360|0),b)>>1];c:{if(!yp(j[e>>2]+484344|0,g)){break c}if((c|0)>=0){f=c;if((f|0)<j[Hb(j[e>>2]+484344|0,g)+12>>2]){break c}}a=a+16|0;break a}i[j[e>>2]+1074438>>1]=b;b=b&65535;KJ(j[e>>2],b);j[j[e>>2]+1074428>>2]=f;c=j[e>>2];e=k[a+64|0];b=Uma(d+24|0,b,f);f=j[b+20>>2];j[d+16>>2]=j[b+16>>2];j[d+20>>2]=f;f=j[b+12>>2];j[d+8>>2]=j[b+8>>2];j[d+12>>2]=f;f=j[b+4>>2];j[d>>2]=j[b>>2];j[d+4>>2]=f;Vr(d+48|0,c,e?7:1,d);h=a,m=o[zg(d+48|0)>>3],o[h+16>>3]=m;ll(d+48|0);a=a+16|0}Za=d- -64|0;return+o[a>>3]}function Z4(a,b,c,d){var e=0,f=0,g=0,h=q(0),i=q(0),j=0,k=0,l=0,m=0,o=0,p=q(0);a:{if((a|0)<4){break a}e=a>>2;m=(e|0)>1?e:1;i=q(a|0);h=q(q(1)/i);e=0;while(1){j=e<<2;f=+q(q(q(g<<2)*q(3.1415927410125732))*h);o=j+b|0,p=q(ge(f)),n[o>>2]=p;k=e|1;l=k<<2;o=l+b|0,p=q(-q(Kh(f))),n[o>>2]=p;f=+q(q(q(k|0)*q(1.5707963705062866))*h);o=c+j|0,p=q(q(ge(f))*q(.5)),n[o>>2]=p;o=c+l|0,p=q(q(Kh(f))*q(.5)),n[o>>2]=p;e=e+2|0;g=g+1|0;if((m|0)!=(g|0)){continue}break}if((a|0)<8){break a}a=a>>3;a=(a|0)>1?a:1;h=q(q(1)/i);e=0;g=0;while(1){b=e|1;f=+q(q(q(b<<1)*q(3.1415927410125732))*h);o=(e<<2)+d|0,p=q(ge(f)),n[o>>2]=p;o=(b<<2)+d|0,p=q(-q(Kh(f))),n[o>>2]=p;e=e+2|0;g=g+1|0;if((a|0)!=(g|0)){continue}break}}}function xo(a,b,c){var d=0,e=0,f=0;d=Cb(a);a=nb(b);j[114630]=0;F(111,d|0,a|0);a=j[114630];j[114630]=0;if((a|0)!=1){a:{if(nb(b)){while(1){f=j[Ni(b,e)>>2];a=32;b:{c:{while(1){if(j[(a<<2)+c>>2]!=(f|0)){a=a+1|0;if(a>>>0<256){continue}break c}break}j[114630]=0;F(110,d|0,a<<24>>24);a=j[114630];j[114630]=0;if((a|0)!=1){break b}break a}a=0;while(1){d:{if(j[(a<<2)+c>>2]==(f|0)){j[114630]=0;F(110,d|0,a<<24>>24);a=j[114630];j[114630]=0;if((a|0)!=1){break b}break a}if(a>>>0>30){break d}a=a+1|0;if(a>>>0<256){continue}}break}j[114630]=0;F(110,d|0,63);a=j[114630];j[114630]=0;if((a|0)!=1){break b}break a}e=e+1|0;if(nb(b)>>>0>e>>>0){continue}break}}return}}a=D()|0;C()|0;gb(d);G(a|0);z()}function Un(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,i=0,l=0,m=0;i=Za-16|0;Za=i;f=d?d:461656;d=j[f>>2];a:{b:{c:{if(!b){if(d){break c}break a}e=-2;if(!c){break a}l=a?a:i+12|0;d:{if(d){a=c;break d}a=k[b|0];d=a<<24>>24;if((d|0)>=0){j[l>>2]=a;e=(d|0)!=0;break a}a=h[b|0];if(!j[j[21255]>>2]){j[l>>2]=a&57343;e=1;break a}a=(a&255)-194|0;if(a>>>0>50){break c}d=j[(a<<2)+60128>>2];a=c-1|0;if(!a){break b}b=b+1|0}g=k[b|0];m=g>>>3|0;if((m-16|(d>>26)+m)>>>0>7){break c}while(1){a=a-1|0;d=g-128|d<<6;if((d|0)>=0){j[f>>2]=0;j[l>>2]=d;e=c-a|0;break a}if(!a){break b}b=b+1|0;g=k[b|0];if((g&192)==128){continue}break}}j[f>>2]=0;j[114604]=25;e=-1;break a}j[f>>2]=d}Za=i+16|0;return e|0}function gka(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,k=0,l=0;f=Za-32|0;Za=f;j[f+24>>2]=b;b=j[a>>2];k=f,l=Lb(a),j[k>>2]=l;b=b+p(Ar(f+24|0,f),6)|0;a:{b:{if(!c){break b}g=j[hb(a)>>2];h=j[a+4>>2];if((g-h|0)/6>>>0>=c>>>0){e=c;i=h-b|0;g=(i|0)/6|0;if(g>>>0<c>>>0){Wy(a,c-g|0,d);e=g;if(!i){break b}}eka(a,b,h,p(c,6)+b|0);g=b;if(b>>>0<=d>>>0){d=m[a+4>>2]>d>>>0?p(c,6)+d|0:d}Nja(g,e,d);break b}e=hb(a);e=VP(f,Ly(a,Lf(a)+c|0),(b-j[a>>2]|0)/6|0,e);j[114630]=0;I(707,e|0,c|0,d|0);c=j[114630];j[114630]=0;if((c|0)==1){break a}j[114630]=0;b=K(1560,a|0,e|0,b|0)|0;a=j[114630];j[114630]=0;if((a|0)==1){break a}Os(e)}a=Qe(b);Za=f+32|0;return a|0}a=D()|0;C()|0;Os(e);G(a|0);z()}function Rqa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,k=0,l=0;e=Za-32|0;Za=e;j[e+24>>2]=b;b=j[a>>2];k=e,l=Lb(a),j[k>>2]=l;b=b+(wp(e+24|0,e)<<1)|0;a:{f=xx(c,d);b:{if((f|0)<1){break b}g=j[hb(a)>>2];h=j[a+4>>2];if((f|0)<=g-h>>1){j[e>>2]=d;i=h-b|0;g=i>>1;if((f|0)>(g|0)){j[e>>2]=c;j[e>>2]=j[e>>2]+(g<<1);_L(a,j[e>>2],d,f-g|0);if((i|0)<1){break b}}Pqa(a,b,h,(f<<1)+b|0);Pe(c,j[e>>2],b);break b}h=hb(a);f=UT(e,ui(a,Yb(a)+f|0),b-j[a>>2]>>1,h);j[114630]=0;I(1241,f|0,c|0,d|0);c=j[114630];j[114630]=0;if((c|0)==1){break a}j[114630]=0;b=K(1242,a|0,f|0,b|0)|0;a=j[114630];j[114630]=0;if((a|0)==1){break a}qA(f)}a=Qe(b);Za=e+32|0;return a|0}a=D()|0;C()|0;qA(f);G(a|0);z()}function Hna(a){var b=0,c=0;j[114630]=0;H(1398,a|0)|0;b=j[114630];j[114630]=0;if((b|0)!=1){b=j[a+4>>2];if(b){Fna(b);Fb(b)}j[a+4>>2]=0;fx(a+1304500|0);Kr(a+1304436|0);gb(a+1304424|0);gb(a+1304412|0);gb(a+1304400|0);Jr(a+1304396|0);Ir(a+1304392|0);Co(a+1304360|0);b=a+946300|0;c=a+906300|0;while(1){b=Bm(b-160|0);if((c|0)!=(b|0)){continue}break}hs(a+484360|0);ex(a+484344|0);Ud(a+480248|0);return a}J(0)|0;C()|0;fx(a+1304500|0);Kr(a+1304436|0);gb(a+1304424|0);gb(a+1304412|0);gb(a+1304400|0);Jr(a+1304396|0);Ir(a+1304392|0);Co(a+1304360|0);b=a+946300|0;c=a+906300|0;while(1){b=Bm(b-160|0);if((c|0)!=(b|0)){continue}break}hs(a+484360|0);ex(a+484344|0);Ud(a+480248|0);ib();z()}function Lpa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=q(0),g=0,h=0,l=0,m=0;e=Za-16|0;Za=e;j[e+12>>2]=c>>>3;j[e+8>>2]=j[a>>2];d=j[tb(e+12|0,e+8|0)>>2];b=lb(b);if(d){a=j[a+20>>2];c=d;while(1){j[e+12>>2]=k[b|0]|k[b+1|0]<<8|(k[b+2|0]<<16|k[b+3|0]<<24);Kd(e+12|0,q(-1));f=q(n[e+12>>2]*q(32768));n[e+12>>2]=f;h=a;f=Rd(f);a:{if(q(r(f))<q(2147483648)){g=~~f;break a}g=-2147483648}l=h,m=Dc(g),i[l>>1]=m;j[e+12>>2]=k[b+4|0]|k[b+5|0]<<8|(k[b+6|0]<<16|k[b+7|0]<<24);Kd(e+12|0,q(-1));f=q(n[e+12>>2]*q(32768));n[e+12>>2]=f;h=a;f=Rd(f);b:{if(q(r(f))<q(2147483648)){g=~~f;break b}g=-2147483648}l=h,m=Dc(g),i[l+2>>1]=m;a=a+4|0;b=b+8|0;c=c-1|0;if(c){continue}break}}Za=e+16|0;return d<<3}function nx(a,b,c,d){var e=0,f=0;e=Za-16|0;Za=e;a:{if(!d){break a}if(c){h[b+835|0]=c;break a}c=k[b+835|0]}c=j[a+480180>>2]&1048580?c&240?c&-16:c&15:c;b:{c:{d:{if(!(j[a+480180>>2]&1048580)){d=c&240;c=c&15;if(!(!d|(c|0)!=15)){if(!(k[a+480209|0]&16)){break b}c=0-(d>>>2|0)|0;break d}f=j[a+480208>>2]&4096;if(!(!c|(d|0)!=240)){if(!f){break b}c=c<<2;break c}if(f){break b}if(c){c=c<<2;if(!d|!(j[a+480180>>2]&16777248)){break c}break b}c=0-(d>>>2|0)|0;break d}if(k[a+480209|0]&16){break b}mb(e+8|0,a+1074308|0,56);a=c&240;a=a?a>>>2|0:0-(c<<2&60)|0;c=a;if(!kb(e+8|0)){break d}c=(a|0)/4<<24>>24}if(!c){break b}}a=Gb(j[b+692>>2]+c|0,0,256);i[b+796>>1]=0;j[b+692>>2]=a}Za=e+16|0}function Wta(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,k=0;d=Za-48|0;Za=d;a:{b:{if(j[a+8>>2]!=j[Ob(a)>>2]){break b}g=a+8|0;h=a+4|0;c=j[a+4>>2];e=j[a>>2];if(c>>>0>e>>>0){f=c;c=((c-e>>2)+1|0)/-2<<2;i=g,k=Pe(f,j[g>>2],f+c|0),j[i>>2]=k;j[h>>2]=c+j[h>>2];break b}i=d,k=j[Ob(a)>>2]-j[a>>2]>>1,j[i+24>>2]=k;j[d+44>>2]=1;c=j[Lc(d+24|0,d+44|0)>>2];c=wn(d+24|0,c,c>>>2|0,j[a+16>>2]);e=yc(d+16|0,j[a+4>>2]);f=j[yc(d+8|0,j[a+8>>2])>>2];e=j[e>>2];j[114630]=0;I(1156,c|0,e|0,f|0);e=j[114630];j[114630]=0;if((e|0)==1){break a}Ib(a,c);Ib(h,c+4|0);Ib(g,c+8|0);Ib(Ob(a),Ob(c));xh(c)}DP(j[a+16>>2],j[a+8>>2],b);j[a+8>>2]=j[a+8>>2]+4;Za=d+48|0;return}a=D()|0;C()|0;xh(c);G(a|0);z()}function T4(a){var b=0,c=q(0),d=q(0),e=q(0),f=0,g=q(0),h=q(0);b=(SMa(a),OMa(2));a:{b:{if(!((b|0)>-1?b>>>0>=8388608:0)){if(!(b&2147483647)){return q(q(-1)/q(a*a))}if((b|0)<=-1){return q(q(a-a)/q(0))}b=(SMa(q(a*q(33554432))),OMa(2));f=-152;break b}if(b>>>0>2139095039){break a}f=-127;a=q(0);if((b|0)==1065353216){break a}}b=b+4913933|0;g=q((b>>>23|0)+f|0);a=q((PMa(2,(b&8388607)+1060439283|0),TMa())+q(-1));c=q(a/q(a+q(2)));d=q(c*c);e=q(d*d);h=a;a=q(a*q(a*q(.5)));a=q(q(g*q(.6931381225585938))+q(h+q(q(q(g*q(905800061445916e-20))+q(c*q(a+q(q(d*q(q(e*q(.2849878668785095))+q(.6666666269302368)))+q(e*q(q(e*q(.24279078841209412))+q(.40000972151756287)))))))-a)))}return a}function MJa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,k=0;d=Za-48|0;Za=d;a:{b:{if(j[a+8>>2]!=j[Ob(a)>>2]){break b}g=a+8|0;h=a+4|0;c=j[a+4>>2];e=j[a>>2];if(c>>>0>e>>>0){f=c;c=((c-e>>1)+1|0)/-2<<1;i=g,k=tJa(f,j[g>>2],f+c|0),j[i>>2]=k;j[h>>2]=c+j[h>>2];break b}i=d,k=j[Ob(a)>>2]-j[a>>2]|0,j[i+24>>2]=k;j[d+44>>2]=1;c=j[Lc(d+24|0,d+44|0)>>2];c=KR(d+24|0,c,c>>>2|0,j[a+16>>2]);e=yc(d+16|0,j[a+4>>2]);f=j[yc(d+8|0,j[a+8>>2])>>2];e=j[e>>2];j[114630]=0;I(522,c|0,e|0,f|0);e=j[114630];j[114630]=0;if((e|0)==1){break a}Ib(a,c);Ib(h,c+4|0);Ib(g,c+8|0);Ib(Ob(a),Ob(c));nt(c)}wz(j[a+16>>2],j[a+8>>2],b);j[a+8>>2]=j[a+8>>2]+2;Za=d+48|0;return}a=D()|0;C()|0;nt(c);G(a|0);z()}function lF(a,b,c){a=a|0;b=b|0;c=+c;var d=0,e=0;d=Za-16|0;Za=d;a:{b:{c:{d:{if((b|0)>=0){if((Uk(a+8|0)|0)>(b|0)){break d}}a=R(8)|0;j[114630]=0;d=E(85,d|0,40665)|0;b=j[114630];j[114630]=0;if((b|0)==1){break c}Wb(a,d);j[114630]=0;I(2004,a|0,83648,2012);a=j[114630];j[114630]=0;if((a|0)!=1){break a}b=D()|0;C()|0;gb(d);break b}if(!(c<=1?!(c<0):0)){a=R(8)|0;j[114630]=0;d=E(85,d|0,40643)|0;b=j[114630];j[114630]=0;if((b|0)!=1){Wb(a,d);j[114630]=0;I(2004,a|0,83648,2012);a=j[114630];j[114630]=0;if((a|0)!=1){break a}b=D()|0;C()|0;gb(d);break b}b=D()|0;C()|0;S(a|0);break b}e=Qm(c*64);j[(j[a+32>>2]+p(b,896)|0)+1075744>>2]=e;Za=d+16|0;return}b=D()|0;C()|0;S(a|0)}G(b|0)}z()}function _ga(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;b=Th(a,b,c,d);j[a>>2]=79684;c=ri(a+4208|0);d=a+4288|0;j[d>>2]=0;j[d+4>>2]=0;j[a+4280>>2]=0;j[a+4284>>2]=0;j[114630]=0;d=T(1389)|0;e=j[114630];j[114630]=0;a:{if((e|0)==1){break a}j[114630]=0;d=H(1390,d|0)|0;e=j[114630];j[114630]=0;if((e|0)==1){break a}j[a+4228>>2]=1049926264;j[a+4232>>2]=0;j[a+4220>>2]=1056964608;j[a+4224>>2]=1056964608;j[a+4296>>2]=d;h[a+4244|0]=0;j[a+4236>>2]=2147483647;j[a+4240>>2]=0;ow(a);ur(a);j[114630]=0;K(1634,a+44|0,2,2)|0;d=j[114630];j[114630]=0;if((d|0)==1){break a}j[114630]=0;N(1635,b|0);d=j[114630];j[114630]=0;if((d|0)==1){break a}return a|0}a=D()|0;C()|0;xg(c);Ke(b);G(a|0);z()}function yKa(a,b,c){var d=0,e=0,f=0;d=Za+ -64|0;Za=d;De(d+40|0,a,c);a=j[d+40>>2];j[114630]=0;e=H(412,d+40|0)|0;f=j[114630];j[114630]=0;a:{b:{c:{if((f|0)==1){break c}j[114630]=0;e=H(413,e|0)|0;f=j[114630];j[114630]=0;if((f|0)==1){break c}j[114630]=0;L(414,d+8|0,3,e|0,a|0);e=j[114630];j[114630]=0;if((e|0)==1){break c}j[114630]=0;F(415,d+24|0,d+8|0);e=j[114630];j[114630]=0;if((e|0)==1){break c}j[114630]=0;F(469,d|0,b|0);b=j[114630];j[114630]=0;if((b|0)==1){break b}j[114630]=0;E(470,d|0,d+24|0)|0;b=j[114630];j[114630]=0;if((b|0)==1){break b}gb(d+24|0);lc(d+40|0);Za=d- -64|0;return!c|(a|0)!=0}a=D()|0;C()|0;break a}a=D()|0;C()|0;gb(d+24|0)}lc(d+40|0);G(a|0);z()}function hG(a,b,c,d){var e=0,f=0,g=0,i=0,k=q(0),l=0;e=Za-80|0;Za=e;g=a+24|0;ro(j[g>>2]);h[j[g>>2]+1304512|0]=j[a+52>>2]!=0;c=Xd(e+32|0,d,c,b);d=j[a+32>>2];k=n[a+48>>2];j[e+8>>2]=j[c+8>>2];i=j[c+4>>2];j[e>>2]=j[c>>2];j[e+4>>2]=i;i=waa(e+48|0,e,d,k);c=0;a:{while(1){if(b){d=j[g>>2];j[e+24>>2]=b;j[e+28>>2]=0;j[114630]=0;j[e+16>>2]=134217727;j[e+20>>2]=0;f=E(2147,e+24|0,e+16|0)|0;l=j[114630];j[114630]=0;if((l|0)==1){break a}f=j[f>>2];j[114630]=0;d=K(2148,d|0,f|0,i|0)|0;f=j[114630];j[114630]=0;if((f|0)==1){break a}c=c+d|0;b=b-d|0;if(d){continue}}break}if(!(j[a+52>>2]!=1|c)){a=j[g>>2];j[a+480208>>2]=j[a+480208>>2]&-513}Za=e+80|0;return c}a=D()|0;C()|0;G(a|0);z()}function gG(a,b,c,d){var e=0,f=0,g=0,i=0,k=q(0),l=0;e=Za-80|0;Za=e;g=a+24|0;ro(j[g>>2]);h[j[g>>2]+1304512|0]=j[a+52>>2]!=0;c=Xd(e+32|0,d,c,b);d=j[a+32>>2];k=n[a+48>>2];j[e+8>>2]=j[c+8>>2];i=j[c+4>>2];j[e>>2]=j[c>>2];j[e+4>>2]=i;i=uaa(e+48|0,e,d,k);c=0;a:{while(1){if(b){d=j[g>>2];j[e+24>>2]=b;j[e+28>>2]=0;j[114630]=0;j[e+16>>2]=134217727;j[e+20>>2]=0;f=E(2147,e+24|0,e+16|0)|0;l=j[114630];j[114630]=0;if((l|0)==1){break a}f=j[f>>2];j[114630]=0;d=K(2148,d|0,f|0,i|0)|0;f=j[114630];j[114630]=0;if((f|0)==1){break a}c=c+d|0;b=b-d|0;if(d){continue}}break}if(!(j[a+52>>2]!=1|c)){a=j[g>>2];j[a+480208>>2]=j[a+480208>>2]&-513}Za=e+80|0;return c}a=D()|0;C()|0;G(a|0);z()}function cEa(a,b,c){var d=0,e=0,f=0;d=Za+ -64|0;Za=d;De(d+40|0,a,c);a=j[d+40>>2];j[114630]=0;e=H(412,d+40|0)|0;f=j[114630];j[114630]=0;a:{b:{c:{if((f|0)==1){break c}j[114630]=0;e=H(413,e|0)|0;f=j[114630];j[114630]=0;if((f|0)==1){break c}j[114630]=0;L(414,d+8|0,3,e|0,a|0);e=j[114630];j[114630]=0;if((e|0)==1){break c}j[114630]=0;F(415,d+24|0,d+8|0);e=j[114630];j[114630]=0;if((e|0)==1){break c}j[114630]=0;F(761,d|0,b|0);b=j[114630];j[114630]=0;if((b|0)==1){break b}j[114630]=0;E(470,d|0,d+24|0)|0;b=j[114630];j[114630]=0;if((b|0)==1){break b}gb(d+24|0);lc(d+40|0);Za=d- -64|0;return!c|(a|0)!=0}a=D()|0;C()|0;break a}a=D()|0;C()|0;gb(d+24|0)}lc(d+40|0);G(a|0);z()}function SJa(a,b,c){var d=0,e=0,f=0;d=Za+ -64|0;Za=d;De(d+40|0,a,c);a=j[d+40>>2];j[114630]=0;e=H(412,d+40|0)|0;f=j[114630];j[114630]=0;a:{b:{c:{if((f|0)==1){break c}j[114630]=0;e=H(413,e|0)|0;f=j[114630];j[114630]=0;if((f|0)==1){break c}j[114630]=0;L(414,d+8|0,2,e|0,a|0);e=j[114630];j[114630]=0;if((e|0)==1){break c}j[114630]=0;F(415,d+24|0,d+8|0);e=j[114630];j[114630]=0;if((e|0)==1){break c}j[114630]=0;F(518,d|0,b|0);b=j[114630];j[114630]=0;if((b|0)==1){break b}j[114630]=0;E(470,d|0,d+24|0)|0;b=j[114630];j[114630]=0;if((b|0)==1){break b}gb(d+24|0);lc(d+40|0);Za=d- -64|0;return!c|(a|0)!=0}a=D()|0;C()|0;break a}a=D()|0;C()|0;gb(d+24|0)}lc(d+40|0);G(a|0);z()}function IFa(a,b,c){var d=0,e=0,f=0;d=Za+ -64|0;Za=d;De(d+40|0,a,c);a=j[d+40>>2];j[114630]=0;e=H(412,d+40|0)|0;f=j[114630];j[114630]=0;a:{b:{c:{if((f|0)==1){break c}j[114630]=0;e=H(413,e|0)|0;f=j[114630];j[114630]=0;if((f|0)==1){break c}j[114630]=0;L(414,d+8|0,2,e|0,a|0);e=j[114630];j[114630]=0;if((e|0)==1){break c}j[114630]=0;F(415,d+24|0,d+8|0);e=j[114630];j[114630]=0;if((e|0)==1){break c}j[114630]=0;F(511,d|0,b|0);b=j[114630];j[114630]=0;if((b|0)==1){break b}j[114630]=0;E(470,d|0,d+24|0)|0;b=j[114630];j[114630]=0;if((b|0)==1){break b}gb(d+24|0);lc(d+40|0);Za=d- -64|0;return!c|(a|0)!=0}a=D()|0;C()|0;break a}a=D()|0;C()|0;gb(d+24|0)}lc(d+40|0);G(a|0);z()}function Zw(a){var b=0,c=0,d=0,e=0,f=0,g=0,h=0,i=0,k=0,l=0,m=0,n=0;c=Za-16|0;Za=c;if(!Xc(a)){m=c,n=Lb(a),j[m+8>>2]=n;m=c,n=Mb(a),j[m>>2]=n;if(rb(c+8|0,c)){while(1){b=j[c+8>>2];An(b,4194304,67108864);e=j[b>>2];f=e+f|0;b=g;b=f>>>0<e>>>0?b+1|0:b;g=b;Id(c+8|0);if(rb(c+8|0,c)){continue}break}}b=sb(a);h=sb(a);m=c,n=Lb(a),j[m+8>>2]=n;m=c,n=Mb(a),j[m>>2]=n;b=KMa(f,g,b,0);e=ab;f=h<<24;g=0;if(rb(c+8|0,c)){h=b;e=((e&1)<<31|b>>>1)&2147483647;while(1){b=j[c+8>>2];i=b;d=j[b>>2];b=d>>>8|0;d=e+(d<<24)|0;b=b+k|0;b=Tc(KMa(d,e>>>0>d>>>0?b+1|0:b,h,l),ab);j[i>>2]=b;d=f;f=d-b|0;g=g-(b>>>0>d>>>0)|0;Id(c+8|0);if(rb(c+8|0,c)){continue}break}}a=kc(a,0);j[a>>2]=f+j[a>>2]}Za=c+16|0}function C2(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,k=0,l=0;e=Za-32|0;Za=e;a:{if(qD(c)){while(1){if(a>>>d&1){k=(d<<2)+c|0,l=rD(d,b),j[k>>2]=l}d=d+1|0;if((d|0)!=6){continue}break}break a}while(1){i=(e+8|0)+(d<<2)|0;f=1<<d&a;g=j[(d<<2)+c>>2];b:{if(!(f|!c)){break b}g=rD(d,f?b:60539)}f=g;j[i>>2]=f;h=((f|0)!=0)+h|0;d=d+1|0;if((d|0)!=6){continue}break}c=60384;c:{d:{switch(h|0){case 0:break a;case 1:break d;default:break c}}if(j[e+8>>2]!=60356){break c}c=60408;break a}c=Yc(24);if(!c){break a}a=j[e+12>>2];j[c>>2]=j[e+8>>2];j[c+4>>2]=a;a=j[e+28>>2];j[c+16>>2]=j[e+24>>2];j[c+20>>2]=a;a=j[e+20>>2];j[c+8>>2]=j[e+16>>2];j[c+12>>2]=a}Za=e+32|0;return c|0}function b6(a,b,c,d){var e=0,f=0,g=0,h=0,i=0,j=0,l=0,m=0,o=0,r=0,s=q(0);f=k[c+768|0];e=576;while(1){a:{if(!(f&255)){f=0;break a}i=(p(d,l)<<2)+a|0;j=0;while(1){m=e;g=k[(c+j|0)+770|0];b:{if(!g){break b}if(g>>>0<=16){if((d|0)<1){break b}h=(-1<<g-1)+1|0;e=0;while(1){r=(e<<2)+i|0,s=q(Bd(b,g)+h|0),n[r>>2]=s;e=e+1|0;if((e|0)!=(d|0)){continue}break}break b}h=2<<g-17;g=h|1;e=Bd(b,(g-(h>>>3|0)|0)+2|0);if((d|0)<1){break b}h=h>>>1|0;f=0;while(1){o=e;e=(e>>>0)/(g>>>0)|0;n[(f<<2)+i>>2]=(o-p(g,e)|0)-h|0;f=f+1|0;if((f|0)!=(d|0)){continue}break}}e=18-m|0;i=(m<<2)+i|0;j=j+1|0;f=k[c+768|0];if(j>>>0<f<<1>>>0){continue}break}}l=l+1|0;if((l|0)!=4){continue}break}return d<<2}function Jc(a){var b=0,c=0,d=0,e=0,f=0,g=0,i=0,l=0,n=0;a:{c=j[a+112>>2];d=j[a+116>>2];b:{if(c|d){b=c>>>0<=m[a+120>>2];c=j[a+124>>2];if((d|0)<(c|0)?1:(d|0)<=(c|0)?b:0){break b}}g=qv(a);if((g|0)>-1){break a}}j[a+104>>2]=0;return-1}i=a;b=j[a+116>>2];l=b;d=j[a+8>>2];c=d;f=j[a+112>>2];c:{if(!(b|f)){break c}c=d;e=j[a+120>>2]^-1;f=e+f|0;b=(j[a+124>>2]^-1)+l|0;b=f>>>0<e>>>0?b+1|0:b;l=j[a+4>>2];e=d-l|0;n=f>>>0>=e>>>0;e=e>>31;if((b|0)>(e|0)?1:(e|0)<=(b|0)?n:0){break c}c=f+l|0}j[i+104>>2]=c;i=j[a+4>>2];if(d){c=a;b=(d-i|0)+1|0;d=b+j[a+120>>2]|0;a=j[a+124>>2]+(b>>31)|0;j[c+120>>2]=d;j[c+124>>2]=d>>>0<b>>>0?a+1|0:a}a=i-1|0;if(k[a|0]!=(g|0)){h[a|0]=g}return g}function qg(a,b){var c=q(0),d=q(0),e=q(0),f=q(0),g=q(0);d=n[a+4268>>2];f=XG(a);c=q(q(n[a+4224>>2]*q(1.899999976158142))+q(.10000000149011612));e=Yd(q(10),q(q(q(j[((b<<2)+a|0)+4292>>2])*q(-3))/q(n[a+4268>>2]*q(q(n[a+4220>>2]*q(19.899999618530273))+q(.10000000149011612)))));c=q(q(Yd(e,q(q(2)-q(q(2)/c)))+q(-1))/q(q(1)-ao(c>q(1)?q(3.1415927410125732):q(q(f*q(6.2831854820251465))/d))));a:{if(c==q(0)){break a}f=q(c+c);d=q(q(-2)-f);c=q(y(q(q(d*d)+q(q(c*c)*q(-4)))));g=q(q(c-d)/f);if(q(r(g))<=q(1)){break a}g=q(q(-q(c+d))/f)}b=(b<<3)+a|0;n[b+4404>>2]=g;n[b+4400>>2]=e;c=n[a+4272>>2];c=q(c*c);d=q(q(1)-c);e=q(e*e);return q(q(q(q(d*d)*e)/q(q(1)-q(c*e)))+c)}function fza(a,b){a=a|0;b=b|0;var c=0,d=0;d=Za-32|0;Za=d;md(b,0);IN(d,a+1|0);qc(d+16|0,d);j[114630]=0;E(370,b+43|0,d+16|0)|0;c=j[114630];j[114630]=0;if((c|0)!=1){gb(d+16|0);c=a+73|0;j[b+24>>2]=k[c|0]|k[c+1|0]<<8|(k[c+2|0]<<16|k[c+3|0]<<24);c=a+54|0;j[b>>2]=k[c|0]|k[c+1|0]<<8|(k[c+2|0]<<16|k[c+3|0]<<24);c=a+58|0;j[b+4>>2]=k[c|0]|k[c+1|0]<<8|(k[c+2|0]<<16|k[c+3|0]<<24);c=a+62|0;if(k[c|0]|k[c+1|0]<<8|(k[c+2|0]<<16|k[c+3|0]<<24)){j[b+8>>2]=(k[c|0]|k[c+1|0]<<8|(k[c+2|0]<<16|k[c+3|0]<<24))+1}i[b+30>>1]=(k[a+68|0]<<1)+2;i[b+34>>1]=l[b+34>>1]&65533|k[a|0]>>>6&2;jc(b+8|0,j[b>>2]);jc(b+4|0,j[b+8>>2]);Za=d+32|0;return}a=D()|0;C()|0;gb(d+16|0);G(a|0);z()}function Qya(a,b){var c=0,d=0,e=0;c=Za+ -64|0;Za=c;De(c+40|0,a,4);a=j[c+40>>2];j[114630]=0;d=H(412,c+40|0)|0;e=j[114630];j[114630]=0;a:{b:{c:{if((e|0)==1){break c}j[114630]=0;d=H(413,d|0)|0;e=j[114630];j[114630]=0;if((e|0)==1){break c}j[114630]=0;L(414,c+8|0,3,d|0,a|0);a=j[114630];j[114630]=0;if((a|0)==1){break c}j[114630]=0;F(415,c+24|0,c+8|0);a=j[114630];j[114630]=0;if((a|0)==1){break c}j[114630]=0;F(981,c|0,b|0);a=j[114630];j[114630]=0;if((a|0)==1){break b}j[114630]=0;E(470,c|0,c+24|0)|0;a=j[114630];j[114630]=0;if((a|0)==1){break b}gb(c+24|0);lc(c+40|0);Za=c- -64|0;return}a=D()|0;C()|0;break a}a=D()|0;C()|0;gb(c+24|0)}lc(c+40|0);G(a|0);z()}function Mva(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,k=0,l=0,m=0,n=0,o=0;e=Za-32|0;Za=e;l=j[a+24>>2];m=j[a+20>>2];n=j[a+16>>2];g=j[a+4>>2];f=g;b=j[a>>2];j[e+24>>2]=b;j[e+28>>2]=f;g=j[a+12>>2];j[e+16>>2]=j[a+8>>2];j[e+20>>2]=g;if(d){while(1){o=b>>>18|0;h=((((f&2147483647)<<1|b>>>31)&2147483646)<<1)+n|0;g=0;b=1;while(1){k=g<<1;f=i[k+h>>1];j[(e+8|0)+(g<<2)>>2]=f+((p(i[(k|4)+h>>1]-f|0,o)|0)/16384|0);f=b;b=0;g=1;if(f){continue}break}j[c>>2]=j[c>>2]+p(j[e+8>>2],m);j[c+4>>2]=j[c+4>>2]+p(j[e+12>>2],l);Bb(e+24|0,e+16|0);d=d-1|0;if(d){c=c+8|0;b=j[e+24>>2];f=j[e+28>>2];continue}break}b=j[e+24>>2];f=j[e+28>>2]}j[a>>2]=b;j[a+4>>2]=f;Za=e+32|0}function Ik(a,b,c,d,e,f,g,h){var i=0,j=0,k=0,l=0,m=0,n=0;j=1;i=d&2147483647;m=i;k=c;a:{if(!c&(i|0)==2147418112?a|b:(i|0)==2147418112&(c|0)!=0|i>>>0>2147418112){break a}l=h&2147483647;n=l;i=g;if(!g&(l|0)==2147418112?e|f:(l|0)==2147418112&(g|0)!=0|l>>>0>2147418112){break a}if(!(a|e|(i|k)|(b|f|(m|n)))){return 0}k=d&h;if((k|0)>0?1:(k|0)>=0){j=-1;if((c|0)==(g|0)&(d|0)==(h|0)?(b|0)==(f|0)&a>>>0<e>>>0|b>>>0<f>>>0:(d|0)<(h|0)?1:(d|0)<=(h|0)?c>>>0<g>>>0:0){break a}return(a^e|c^g)!=0|(b^f|d^h)!=0}j=-1;if((c|0)==(g|0)&(d|0)==(h|0)?(b|0)==(f|0)&a>>>0>e>>>0|b>>>0>f>>>0:(d|0)>(h|0)?1:(d|0)>=(h|0)?c>>>0>g>>>0:0){break a}j=(a^e|c^g)!=0|(b^f|d^h)!=0}return j}function sla(a,b){var c=0,d=0,e=0,f=0,g=0,h=0,i=0,l=0,m=0,n=0,o=0;e=ne(11555);if(e){n=j[a+12>>2];c=b+16|0;if(Yj(a,k[c|0]|k[c+1|0]<<8|(k[c+2|0]<<16|k[c+3|0]<<24))){g=b+12|0;c=g;a:{if(!(k[c|0]|k[c+1|0]<<8|(k[c+2|0]<<16|k[c+3|0]<<24))){break a}h=b+4|0;while(1){if(!jf(a,4)){break a}b:{if((k[h|0]|k[h+1|0]<<8)>>>0>=64){if((rla(a)|0)<1){break b}}d=0;b=1;while(1){c=st(a);if(c){o=qo(c<<24>>24);i=d>>>0>=e>>>0;l=i&b;c=l;c:{if(i){break c}c=l;if(!(b&1)){break c}c=k[d+11555|0]==(o&255)}b=c;d=d+1|0;continue}break}Fc(a,4);f=b?(d|0)==(e|0)?1:f:f}m=m+1|0;b=g;if(m>>>0<(k[b|0]|k[b+1|0]<<8|(k[b+2|0]<<16|k[b+3|0]<<24))>>>0){continue}break}}d=f&1}Yj(a,n)}return d}function pwa(a){var b=0,c=0,d=0;b=Za+ -64|0;Za=b;a:{b:{c:{d:{e:{while(1){j[b+60>>2]=c;j[b+60>>2]=c<<3;Bz(b+32|0,c>>>0<16?18126:18061);j[114630]=0;F(509,b+16|0,b+60|0);d=j[114630];j[114630]=0;if((d|0)==1){break e}j[114630]=0;I(510,b+48|0,b+32|0,b+16|0);d=j[114630];j[114630]=0;if((d|0)==1){break d}j[114630]=0;F(511,b+8|0,(c<<5)+a|0);d=j[114630];j[114630]=0;if((d|0)==1){break c}j[114630]=0;E(470,b+8|0,b+48|0)|0;d=j[114630];j[114630]=0;if((d|0)==1){break c}gb(b+48|0);gb(b+16|0);qb(b+32|0);c=c+1|0;if((c|0)!=128){continue}break}Za=b- -64|0;return}c=D()|0;C()|0;break a}c=D()|0;C()|0;break b}c=D()|0;C()|0;gb(b+48|0)}gb(b+16|0)}qb(b+32|0);G(c|0);z()}function tla(a,b){var c=0,d=0,e=0,f=0,g=0,h=0,i=0,l=0,m=0,n=0,o=0;e=ne(11555);if(e){n=j[a+8>>2];c=b+16|0;if(xc(a,k[c|0]|k[c+1|0]<<8|(k[c+2|0]<<16|k[c+3|0]<<24))){g=b+12|0;c=g;a:{if(!(k[c|0]|k[c+1|0]<<8|(k[c+2|0]<<16|k[c+3|0]<<24))){break a}h=b+4|0;while(1){if(!yb(a,4)){break a}b:{if((k[h|0]|k[h+1|0]<<8)>>>0>=64){if((lh(a)|0)<1){break b}}d=0;b=1;while(1){c=dd(a);if(c){o=qo(c<<24>>24);i=d>>>0>=e>>>0;l=i&b;c=l;c:{if(i){break c}c=l;if(!(b&1)){break c}c=k[d+11555|0]==(o&255)}b=c;d=d+1|0;continue}break}Jb(a,4);f=b?(d|0)==(e|0)?1:f:f}m=m+1|0;b=g;if(m>>>0<(k[b|0]|k[b+1|0]<<8|(k[b+2|0]<<16|k[b+3|0]<<24))>>>0){continue}break}}d=f&1}xc(a,n)}return d}function hsa(a,b,c,d,e){var f=0,g=0,m=0,n=0,o=0,p=0;g=Za-16|0;Za=g;m=Vj(a,b);a:{if((m|0)==255){break a}if(Vi(a)){break a}b:{if(c>>>0>6208431){n=7;c=1023;break b}f=7;c:{if(c>>>0>3104215){break c}f=6;if(c>>>0>1552107){break c}f=5;if(c>>>0>776053){break c}f=4;if(c>>>0>388026){break c}f=3;if(c>>>0>194013){break c}f=2;if(c>>>0>97006){break c}f=c>>>0>48503}n=f;c=HMa(1<<20-f,0,c,0)+24858e3|0;f=ab;c=Tc(KMa(c,c>>>0<24858e3?f+1|0:f,49716e3,0),ab)}if(e){i[g+14>>1]=(b&3)+c;i[g+12>>1]=1023;c=l[gf(g+14|0,g+12|0)>>1]}e=es(m);b=a+4|0;o=Pb(b,m),p=(n<<10|c)>>>8|(d?0:32),h[o|0]=p;Pg(j[a>>2],e|160,c&255);Pg(j[a>>2],e|176,k[Pb(b,m)|0]);h[a+530|0]=1}Za=g+16|0}function Cma(a){var b=0,c=0,d=0;d=Za-32|0;Za=d;vM(d);b=j[d+28>>2];c=j[d+24>>2];h[a+24|0]=c;h[a+25|0]=c>>>8;h[a+26|0]=c>>>16;h[a+27|0]=c>>>24;h[a+28|0]=b;h[a+29|0]=b>>>8;h[a+30|0]=b>>>16;h[a+31|0]=b>>>24;b=j[d+20>>2];c=j[d+16>>2];h[a+16|0]=c;h[a+17|0]=c>>>8;h[a+18|0]=c>>>16;h[a+19|0]=c>>>24;h[a+20|0]=b;h[a+21|0]=b>>>8;h[a+22|0]=b>>>16;h[a+23|0]=b>>>24;b=j[d+12>>2];c=j[d+8>>2];h[a+8|0]=c;h[a+9|0]=c>>>8;h[a+10|0]=c>>>16;h[a+11|0]=c>>>24;h[a+12|0]=b;h[a+13|0]=b>>>8;h[a+14|0]=b>>>16;h[a+15|0]=b>>>24;b=j[d+4>>2];c=j[d>>2];h[a|0]=c;h[a+1|0]=c>>>8;h[a+2|0]=c>>>16;h[a+3|0]=c>>>24;h[a+4|0]=b;h[a+5|0]=b>>>8;h[a+6|0]=b>>>16;h[a+7|0]=b>>>24;Za=d+32|0}function Zha(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0;e=Za+ -64|0;Za=e;j[e+56>>2]=d;d=j[a+28>>2];mn(j[j[d>>2]-12>>2]+d|0,0);if(j[j[b>>2]+4>>2]){h=j[a+28>>2];f=j[a+12>>2];g=j[j[b>>2]+4>>2];d=g+j[a+8>>2]|0;f=sg(e+40|0,d,d>>>0<g>>>0?f+1|0:f);d=j[f+12>>2];j[e+8>>2]=j[f+8>>2];j[e+12>>2]=d;d=j[f+4>>2];j[e>>2]=j[f>>2];j[e+4>>2]=d;Hi(h,e)}Ve(e+16|0,j[a+28>>2]);d=j[e+28>>2];j[e+32>>2]=j[e+24>>2];j[e+36>>2]=d;cI(c,j[a+28>>2],j[e+56>>2]);c=j[b>>2];b=Vl(e+16|0,fc(a+32|0,j[j[b>>2]>>2]),l[j[b>>2]+12>>1]);j[114630]=0;P(1625,a|0,c|0,b|0,e+32|0)|0;a=j[114630];j[114630]=0;if((a|0)!=1){qb(b);Za=e- -64|0;return}a=D()|0;C()|0;qb(b);G(a|0);z()}function LO(a,b,c,d,e,f){var g=0,h=0,k=0,m=0,n=0,o=0,q=0;while(1){n=l[bc(b,g)>>1];o=n+1|0;q=(h&65535)>>>0>n>>>0|n>>>0>127;k=q?k:c>>>0>g>>>0?o:k;m=(m&65535)>>>0>n>>>0?m:o;h=q?h:o;g=g+1|0;if((g|0)!=128){continue}break}bg(b,c);c=j[a+8>>2];a:{b:{if(!f){break b}g=h&65535;if((c+((g<<11)+f|0)|0)!=(jj(a)&-2)){break b}xc(a,c+(g<<10)|0);if(ty(a,16,1)){i[e>>1]=8}xc(a,c);break a}g=k&65535;if((g|0)==(h&65535)){h=k;break a}if(l[e>>1]!=4|f){break a}xc(a,c+(g<<10)|0);f=ty(a,64,1);xc(a,c);h=f?h:k}f=m&65535;c:{if(f>>>0>(h&65535)>>>0){if(((c+d|0)+(p(f,l[e>>1])<<8)|0)==(jj(a)|0)){break c}}if(f>>>0>=255){sy(b,254,65534);sy(b,255,65535)}m=h}return m&65535}function $ha(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0;e=Za+ -64|0;Za=e;j[e+56>>2]=d;d=j[a+28>>2];mn(j[j[d>>2]-12>>2]+d|0,0);if(j[j[b>>2]+4>>2]){h=j[a+28>>2];f=j[a+12>>2];g=j[j[b>>2]+4>>2];d=g+j[a+8>>2]|0;f=sg(e+40|0,d,d>>>0<g>>>0?f+1|0:f);d=j[f+12>>2];j[e+8>>2]=j[f+8>>2];j[e+12>>2]=d;d=j[f+4>>2];j[e>>2]=j[f>>2];j[e+4>>2]=d;Hi(h,e)}Ve(e+16|0,j[a+28>>2]);d=j[e+28>>2];j[e+32>>2]=j[e+24>>2];j[e+36>>2]=d;iI(j[a+28>>2],c,j[e+56>>2]);c=j[b>>2];b=Vl(e+16|0,fc(a+32|0,j[j[b>>2]>>2]),l[j[b>>2]+12>>1]);j[114630]=0;P(1625,a|0,c|0,b|0,e+32|0)|0;a=j[114630];j[114630]=0;if((a|0)!=1){qb(b);Za=e- -64|0;return}a=D()|0;C()|0;qb(b);G(a|0);z()}function xia(a,b,c){var d=0,e=0,f=0,g=0,h=0;d=Za-48|0;Za=d;lj(a,d+40|0);e=j[d+44>>2];if(!e&m[d+40>>2]>256|e){j[d+40>>2]=256;j[d+44>>2]=0}a:{b:{c:{d:{if(j[d+40>>2]|j[d+44>>2]){while(1){cf(a,d+38|0);e=Cb(d+24|0);j[114630]=0;K(723,a|0,e|0,255)|0;f=j[114630];j[114630]=0;if((f|0)==1){break d}j[114630]=0;I(13,d+8|0,c|0,e|0);f=j[114630];j[114630]=0;if((f|0)==1){break c}j[114630]=0;f=E(1612,b|0,d+38|0)|0;h=j[114630];j[114630]=0;if((h|0)==1){break b}ob(f,d+8|0);gb(d+8|0);gb(e);e=j[d+44>>2];g=g+1|0;if(!e&g>>>0<m[d+40>>2]|e){continue}break}}Za=d+48|0;return}a=D()|0;C()|0;break a}a=D()|0;C()|0;break a}a=D()|0;C()|0;gb(d+8|0)}gb(e);G(a|0);z()}function jsa(a,b){var c=0,d=0,e=0,f=0,g=0,j=0,m=0,n=0;g=255;a:{b:{e=a+58|0;c=k[Pb(e,b)|0];if((c|0)==255){break b}if(h[Pb(e,b)|0]>-1){break a}d=a+22|0;c=c&127;if(l[Nc(d,c)>>1]!=65535){if(l[Nc(d,c)>>1]!=(b|0)){break b}}m=Nc(d,c),n=b,i[m>>1]=n;m=Pb(e,b),n=c,h[m|0]=n;break a}j=a+4|0;f=a+22|0;c=0;d=255;while(1){if(l[Nc(f,c)>>1]==65535){m=Nc(f,c),n=b,i[m>>1]=n;m=Pb(e,b),n=c,h[m|0]=n;break a}if(!(k[Pb(j,c)|0]&32)){g=h[Pb(e,l[Nc(f,c)>>1])|0]>-1?g:c;d=c}c=c+1|0;if((c|0)!=18){continue}break}if((d&255)!=255){c=(g&255)==255?d:g;d=c&255;m=Pb(e,l[Nc(f,d)>>1]),n=255,h[m|0]=n;m=Nc(f,d),n=b,i[m>>1]=n;m=Pb(e,b),n=c,h[m|0]=n}c=Vj(a,b)}return c&255}function Kaa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0;c=Za-32|0;Za=c;uG(c+24|0);sG(a+24|0,ud(c+24|0));jh(c+24|0);i[a+28>>1]=0;Jaa(c+24|0,rM());ns(a+32|0,c+24|0);bf(c+24|0);tG(c+24|0,j[a>>2]);DG(a+4|0,ud(c+24|0));Gc(c+24|0);pm(j[a+24>>2],j[a+4>>2]);j[a+60>>2]=0;j[a+48>>2]=1065353216;j[a+52>>2]=0;j[a+16>>2]=0;j[a+20>>2]=0;j[a+8>>2]=0;h[a- -64|0]=0;e=c,f=_m(b),j[e+24>>2]=f;e=c,f=ii(b),j[e+16>>2]=f;a:{if(hi(c+24|0,c+16|0)){while(1){d=Sg(c+24|0);b=Cf(c,d);j[114630]=0;L(2076,a|0,b|0,d+12|0,0);d=j[114630];j[114630]=0;if((d|0)==1){break a}gb(b);dp(c+24|0);if(hi(c+24|0,c+16|0)){continue}break}}Za=c+32|0;return}a=D()|0;C()|0;gb(b);G(a|0);z()}function ZGa(a,b,c){var d=0,e=0,f=0,g=0,l=0,n=0;d=Za-32|0;Za=d;vg(d,1,a);qc(d+16|0,d);j[114630]=0;E(369,b+492|0,d+16|0)|0;e=j[114630];j[114630]=0;if((e|0)!=1){gb(d+16|0);a:{if(!(k[a+378|0]|k[a+379|0]<<8)){break a}j[d+16>>2]=120;j[d>>2]=116;if(!j[tb(d+16|0,d)>>2]){break a}f=b+236|0;e=0;while(1){g=k[(a+e|0)+32|0];l=Nc(f,e+12|0),n=c+g|0,i[l>>1]=n;j[d+16>>2]=120;j[d>>2]=116;e=e+1|0;if(e>>>0<m[tb(d+16|0,d)>>2]){continue}break}}j[b>>2]=k[a+376|0]|k[a+377|0]<<8;dz(a,b+48|0,0);dz(a,b+68|0,1);dz(a,b+88|0,2);a=k[b+100|0];if(a&1){h[b+100|0]=a|16}if(!(j[b>>2]|h[b+60|0]&1)){j[b>>2]=32767}Za=d+32|0;return}a=D()|0;C()|0;gb(d+16|0);G(a|0);z()}function WB(a,b){var c=0,d=0,e=0,f=0,g=0,h=0,i=0;f=Za-16|0;Za=f;c=1;a:{b:{switch(b-a>>2){case 2:b=b-4|0;if(!rd(b,a)){break a}Ib(a,b);break a;case 3:Tl(a,a+4|0,b-4|0);break a;case 4:Eu(a,a+4|0,a+8|0,b-4|0);break a;case 5:Du(a,a+4|0,a+8|0,a+12|0,b-4|0);break a;case 0:case 1:break a;default:break b}}e=a+8|0;Tl(a,a+4|0,e);d=a+12|0;c:{while(1){g=(b|0)==(d|0);if(g){break c}d:{if(rd(d,e)){j[f+12>>2]=j[d>>2];h=d;while(1){e:{c=e;j[h>>2]=j[c>>2];if((a|0)==(c|0)){c=a;break e}h=c;e=c-4|0;if(rd(f+12|0,e)){continue}}break}j[c>>2]=j[f+12>>2];i=i+1|0;if((i|0)==8){break d}}e=d;d=d+4|0;continue}break}c=(d+4|0)==(b|0)}c=c|g}Za=f+16|0;return c&1}function Lva(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,i=0,k=0,l=0,m=0,n=0;b=Za-16|0;Za=b;g=j[a+40>>2];i=j[a+36>>2];n=j[a+16>>2];f=j[a+4>>2];e=f;k=j[a>>2];j[b+8>>2]=k;j[b+12>>2]=e;f=j[a+12>>2];j[b>>2]=j[a+8>>2];j[b+4>>2]=f;a:{if(!d){f=g>>12;l=i>>12;break a}while(1){f=j[a+32>>2];m=e+n|0;e=h[m|0];i=j[a+28>>2]+i|0;l=i>>12;e=((p(h[m+1|0]-e|0,k>>>10&4194048)|0)/16384|0)+(e<<8)|0;j[c>>2]=j[c>>2]+p(l,e);g=f+g|0;f=g>>12;j[c+4>>2]=j[c+4>>2]+p(e,f);Bb(b+8|0,b);d=d-1|0;if(d){c=c+8|0;k=j[b+8>>2];e=j[b+12>>2];continue}break}k=j[b+8>>2];e=j[b+12>>2]}j[a+40>>2]=g;j[a+20>>2]=l;j[a+36>>2]=i;j[a+24>>2]=f;j[a>>2]=k;j[a+4>>2]=e;Za=b+16|0}function Nva(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,i=0,k=0,l=0,m=0,n=0;e=Za-32|0;Za=e;k=j[a+24>>2];l=j[a+20>>2];m=j[a+16>>2];b=j[a+4>>2];f=j[a>>2];j[e+24>>2]=f;j[e+28>>2]=b;g=j[a+12>>2];j[e+16>>2]=j[a+8>>2];j[e+20>>2]=g;if(d){while(1){n=f>>>10&4194048;i=(((b&2147483647)<<1|f>>>31)&-2)+m|0;g=0;b=1;while(1){f=h[g+i|0];j[(e+8|0)+(g<<2)>>2]=((p(h[(g|2)+i|0]-f|0,n)|0)/16384|0)+(f<<8);f=b;b=0;g=1;if(f){continue}break}j[c>>2]=j[c>>2]+p(j[e+8>>2],l);j[c+4>>2]=j[c+4>>2]+p(j[e+12>>2],k);Bb(e+24|0,e+16|0);d=d-1|0;if(d){c=c+8|0;f=j[e+24>>2];b=j[e+28>>2];continue}break}f=j[e+24>>2];b=j[e+28>>2]}j[a>>2]=f;j[a+4>>2]=b;Za=e+32|0}function B5(a,b,c,d,e,f){var g=0,h=0,i=0,l=0;j[a+1504>>2]=0;j[a+1508>>2]=0;a:{if(j[a+96>>2]){break a}if(!m5(a)){break a}if(Tb(a,1)){Nb(a,35);return 0}h=c;b:{c:{if(!(j[a+84>>2]!=j[a+92>>2]?j[a+80>>2]:0)){c=Tb(a,Sk(j[a+408>>2]-1|0));if((c|0)==-1|(c|0)>=j[a+408>>2]){break a}j[f>>2]=c;c=p(c,6)+a|0;if(!k[c+412|0]){g=j[a+112>>2];f=g>>1;break c}g=j[a+116>>2];f=g>>1;i=Tb(a,1);l=Tb(a,1);if(!k[c+412|0]|i){break c}j[b>>2]=g-j[a+112>>2]>>2;b=j[a+112>>2]+g>>2;break b}Y(50456,50512,3137,50544);z()}j[b>>2]=0;b=f}j[h>>2]=b;d:{if(!(!k[c+412|0]|l)){b=p(g,3);j[d>>2]=b-j[a+112>>2]>>2;g=b+j[a+112>>2]>>2;break d}j[d>>2]=f}j[e>>2]=g;g=1}return g}function Yha(a,b,c){var d=0,e=0,f=0,g=0,h=0;d=Za+ -64|0;Za=d;e=j[a+28>>2];mn(j[j[e>>2]-12>>2]+e|0,0);if(j[j[b>>2]+4>>2]){h=j[a+28>>2];e=j[a+12>>2];g=j[j[b>>2]+4>>2];f=g+j[a+8>>2]|0;f=sg(d+48|0,f,f>>>0<g>>>0?e+1|0:e);g=j[f+12>>2];j[d+16>>2]=j[f+8>>2];j[d+20>>2]=g;e=j[f+4>>2];j[d+8>>2]=j[f>>2];j[d+12>>2]=e;Hi(h,d+8|0)}Ve(d+24|0,j[a+28>>2]);e=j[d+36>>2];j[d+40>>2]=j[d+32>>2];j[d+44>>2]=e;bb[1181](j[a+28>>2],c,j[j[b>>2]+8>>2]);c=j[b>>2];e=Vl(d+24|0,fc(a+32|0,j[j[b>>2]>>2]),l[j[b>>2]+12>>1]);j[114630]=0;b=P(1625,a|0,c|0,e|0,d+40|0)|0;a=j[114630];j[114630]=0;if((a|0)!=1){qb(e);Za=d- -64|0;return b}a=D()|0;C()|0;qb(e);G(a|0);z()}function Kva(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,k=0,l=0,m=0,n=0;b=Za-16|0;Za=b;g=j[a+40>>2];h=j[a+36>>2];n=j[a+16>>2];f=j[a+4>>2];e=f;k=j[a>>2];j[b+8>>2]=k;j[b+12>>2]=e;f=j[a+12>>2];j[b>>2]=j[a+8>>2];j[b+4>>2]=f;a:{if(!d){f=g>>12;l=h>>12;break a}while(1){f=j[a+32>>2];m=(e<<1)+n|0;e=i[m>>1];h=j[a+28>>2]+h|0;l=h>>12;e=e+((p(i[m+2>>1]-e|0,k>>>18|0)|0)/16384|0)|0;j[c>>2]=j[c>>2]+p(l,e);g=f+g|0;f=g>>12;j[c+4>>2]=j[c+4>>2]+p(e,f);Bb(b+8|0,b);d=d-1|0;if(d){c=c+8|0;k=j[b+8>>2];e=j[b+12>>2];continue}break}k=j[b+8>>2];e=j[b+12>>2]}j[a+40>>2]=g;j[a+20>>2]=l;j[a+36>>2]=h;j[a+24>>2]=f;j[a>>2]=k;j[a+4>>2]=e;Za=b+16|0}function Gna(a){a=a|0;var b=0,c=0,d=0;c=a+1304360|0;b=a+1074984|0;while(1){j[b+104>>2]=0;j[b+656>>2]=0;j[b+76>>2]=0;j[b+16>>2]=0;b=b+896|0;if((c|0)!=(b|0)){continue}break}BI(a+484344|0);Ce(a+1304400|0);Ce(a+1304412|0);Ce(a+1304424|0);sz(a+1304500|0);c=a+900380|0;b=a+484380|0;while(1){Sm(b);b=b+104|0;if((c|0)!=(b|0)){continue}break}c=a+901404|0;b=a+900380|0;while(1){d=j[b>>2];if(d){Fb(Ls(d))}j[b>>2]=0;b=b+4|0;if((c|0)!=(b|0)){continue}break}c=a+946300|0;b=a+906300|0;while(1){vH(b);b=b+160|0;if((c|0)!=(b|0)){continue}break}j[a+480180>>2]=0;j[a+480184>>2]=0;a=a+480186|0;i[a>>1]=0;i[a+2>>1]=0;i[a+4>>1]=0;i[a+6>>1]=0;return 1}function hF(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;e=Za-16|0;Za=e;a:{b:{c:{d=a+8|0;d:{if(!Tk(d)){if((b|0)<0|(fr(d)|0)<=(b|0)){break d}a=Yo(j[a+32>>2],b+1&65535);i[a+34>>1]=l[a+34>>1]&64511|(c?1024:0);break b}d=Tk(d);if((b|0)<0){break d}if((b|0)<(d|0)){break c}}a=R(8)|0;j[114630]=0;c=E(85,e|0,40681)|0;b=j[114630];j[114630]=0;e:{if((b|0)!=1){Wb(a,c);j[114630]=0;I(2004,a|0,83648,2012);a=j[114630];j[114630]=0;if((a|0)!=1){break a}b=D()|0;C()|0;gb(c);break e}b=D()|0;C()|0;S(a|0)}G(b|0);z()}b=b+1<<2;a=a+32|0;if(!j[(b+j[a>>2]|0)+900380>>2]){break b}a=j[(b+j[a>>2]|0)+900380>>2];h[a+15|0]=k[a+15|0]&253|(c?2:0)}Za=e+16|0;return}z()}function fIa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0;d=Za-32|0;Za=d;md(b,0);si(d,1,a);qc(d+16|0,d);j[114630]=0;E(370,b+43|0,d+16|0)|0;c=j[114630];j[114630]=0;if((c|0)!=1){gb(d+16|0);c=a+32|0;j[b+24>>2]=k[c|0]|k[c+1|0]<<8|(k[c+2|0]<<16|k[c+3|0]<<24);c=a+13|0;i[b+34>>1]=l[b+34>>1]&65533|(k[c|0]|k[c+1|0]<<8)<<1&2;c=a+16|0;j[b>>2]=k[c|0]|k[c+1|0]<<8|(k[c+2|0]<<16|k[c+3|0]<<24);c=a+20|0;j[b+4>>2]=k[c|0]|k[c+1|0]<<8|(k[c+2|0]<<16|k[c+3|0]<<24);c=a+24|0;j[b+8>>2]=k[c|0]|k[c+1|0]<<8|(k[c+2|0]<<16|k[c+3|0]<<24);h[d+16|0]=k[a+15|0];h[d|0]=64;e=b,f=k[Zb(d+16|0,d)|0]<<2,i[e+30>>1]=f;Za=d+32|0;return}a=D()|0;C()|0;gb(d+16|0);G(a|0);z()}function _0(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0;f=Za-48|0;Za=f;j[f+40>>2]=b;a:{if(!(j[c+4>>2]&1)){c=bb[j[j[a>>2]+24>>2]](a,b,c,d,e)|0;break a}hc(f+24|0,c);j[114630]=0;a=H(2451,f+24|0)|0;b=j[114630];j[114630]=0;b:{if((b|0)!=1){wb(f+24|0);c:{if(e){Hg(f+24|0,a);break c}Gg(f+24|0,a)}g=f,h=nd(f+24|0),j[g+16>>2]=h;while(1){g=f,h=tj(f+24|0),j[g+8>>2]=h;if(!rb(f+16|0,f+8|0)){c=j[f+40>>2];pc(f+24|0);break a}a=j[j[f+16>>2]>>2];j[114630]=0;E(2474,f+40|0,a|0)|0;a=j[114630];j[114630]=0;if((a|0)!=1){Id(f+16|0);continue}break}c=D()|0;C()|0;pc(f+24|0);break b}c=D()|0;C()|0;wb(f+24|0)}G(c|0);z()}Za=f+48|0;return c|0}function sca(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=Za-32|0;Za=c;j[114630]=0;N(2010,a|0);d=j[114630];j[114630]=0;a:{b:{c:{if((d|0)==1){break c}j[114630]=0;N(2036,b|0);d=j[114630];j[114630]=0;if((d|0)==1){break c}d=j[a+24>>2];b=_b(c+8|0,b);j[114630]=0;e=j[b+4>>2];j[c>>2]=j[b>>2];j[c+4>>2]=e;L(2075,c+16|0,d|0,c|0,1);b=j[114630];j[114630]=0;if((b|0)==1){break c}b=Gd(zb(c+16|0));gb(c+16|0);break b}b=J(0)|0;C()|0;O(b|0)|0;b=0;j[114630]=0;L(1984,37051,a|0,0,0);a=j[114630];j[114630]=0;if((a|0)==1){break a}Q()}Za=c+32|0;return b|0}a=D()|0;C()|0;j[114630]=0;M(20);b=j[114630];j[114630]=0;if((b|0)!=1){G(a|0);z()}J(0)|0;C()|0;ib();z()}function Rla(a){var b=0,c=0,d=0,e=0,f=0;b=Za+ -64|0;Za=b;a:{e=j[a+4>>2];if(!e){break a}d=78416;while(1){c=j[a+4>>2];j[b+56>>2]=j[a>>2];j[b+60>>2]=c;c=_b(b+48|0,j[d+8>>2]);f=j[b+60>>2];j[b+24>>2]=j[b+56>>2];j[b+28>>2]=f;f=j[c+4>>2];j[b+16>>2]=j[c>>2];j[b+20>>2]=f;if(hJ(b+24|0,b+16|0)){break a}d=d+12|0;if((d|0)!=78932){continue}break}d=78944;while(1){b:{c=j[a+4>>2];j[b+40>>2]=j[a>>2];j[b+44>>2]=c;c=_b(b+32|0,j[d+8>>2]);e=j[b+44>>2];j[b+8>>2]=j[b+40>>2];j[b+12>>2]=e;e=j[c+4>>2];j[b>>2]=j[c>>2];j[b+4>>2]=e;c=hJ(b+8|0,b);if(c){break b}d=d+12|0;if((d|0)!=78992){continue}}break}Za=b- -64|0;return c}Za=b- -64|0;return(e|0)!=0}function sR(a,b,c,d,e){var f=0,g=0,i=0,j=0,l=0,m=0;a:{if(!d){break a}j=k[e|0];if(!j|!b){break a}g=d-6|0;l=35>>>g&(g&255)>>>0<6;i=p(0-c|0,6);m=(d-2&255)>>>0>2;while(1){g=a+i|0;f=k[g+3|0];b:{if(!((f-2&255)>>>0>2|m)){c=1;if(k[(a+i|0)+5|0]<224){break b}break a}c=(d|0)==(f|0);if(!(1<<f&2240)|(!l|f>>>0>11)){break b}c=1}c:{if(m){break c}f=a+i|0;if((k[f+2|0]-11&255)>>>0>2){break c}if(k[f+4|0]){break a}}d:{if(!l){break d}f=a+i|0;if((k[f+2|0]-3&255)>>>0>3){break d}if(k[f+4|0]){break a}}e:{if(!c){break e}c=j;a=k[(a+i|0)+5|0];if(a?(c|0)!=(a|0):0){break a}if((a|0)!=(c|0)){break e}h[e|0]=0;return}a=g;b=b-1|0;if(b){continue}break}}}function l1(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,i=0;f=Za-48|0;Za=f;j[f+40>>2]=b;a:{if(!(j[c+4>>2]&1)){c=bb[j[j[a>>2]+24>>2]](a,b,c,d,e)|0;break a}hc(f+24|0,c);j[114630]=0;a=H(2417,f+24|0)|0;b=j[114630];j[114630]=0;b:{if((b|0)!=1){wb(f+24|0);c:{if(e){Hg(f+24|0,a);break c}Gg(f+24|0,a)}g=f,i=nd(f+24|0),j[g+16>>2]=i;while(1){g=f,i=_e(f+24|0),j[g+8>>2]=i;if(!rb(f+16|0,f+8|0)){c=j[f+40>>2];gb(f+24|0);break a}a=h[j[f+16>>2]];j[114630]=0;E(2391,f+40|0,a|0)|0;a=j[114630];j[114630]=0;if((a|0)!=1){Xf(f+16|0);continue}break}c=D()|0;C()|0;gb(f+24|0);break b}c=D()|0;C()|0;wb(f+24|0)}G(c|0);z()}Za=f+48|0;return c|0}function Yva(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,k=0,l=0,m=0;b=Za-16|0;Za=b;h=j[a+40>>2];k=j[a+36>>2];m=j[a+16>>2];e=j[a+4>>2];f=e;g=j[a>>2];j[b+8>>2]=g;j[b+12>>2]=e;e=j[a+12>>2];j[b>>2]=j[a+8>>2];j[b+4>>2]=e;a:{if(!d){e=h>>12;l=k>>12;break a}while(1){f=((((f&2147483647)<<1|g>>>31)&2147483646)<<1)+m|0;g=i[f+2>>1];e=j[a+32>>2];k=j[a+28>>2]+k|0;l=k>>12;j[c>>2]=j[c>>2]+p(l,i[f>>1]);h=e+h|0;e=h>>12;j[c+4>>2]=j[c+4>>2]+p(g,e);Bb(b+8|0,b);d=d-1|0;if(d){c=c+8|0;g=j[b+8>>2];f=j[b+12>>2];continue}break}g=j[b+8>>2];f=j[b+12>>2]}j[a+40>>2]=h;j[a+20>>2]=l;j[a+36>>2]=k;j[a+24>>2]=e;j[a>>2]=g;j[a+4>>2]=f;Za=b+16|0}function dBa(a,b,c,d){var e=0,f=0,g=0;e=Za-80|0;Za=e;Ce(b);De(e+56|0,a,d);a=j[e+56>>2];j[114630]=0;f=H(412,e+56|0)|0;g=j[114630];j[114630]=0;a:{b:{c:{if((g|0)==1){break c}j[114630]=0;f=H(413,f|0)|0;g=j[114630];j[114630]=0;if((g|0)==1){break c}j[114630]=0;L(414,e+8|0,2,f|0,a|0);f=j[114630];j[114630]=0;if((f|0)==1){break c}j[114630]=0;F(415,e+24|0,e+8|0);f=j[114630];j[114630]=0;if((f|0)==1){break c}j[114630]=0;I(13,e+40|0,c|0,e+24|0);c=j[114630];j[114630]=0;if((c|0)==1){break b}ob(b,e+40|0);gb(e+40|0);gb(e+24|0);lc(e+56|0);Za=e+80|0;return!d|(a|0)!=0}a=D()|0;C()|0;break a}a=D()|0;C()|0;gb(e+24|0)}lc(e+56|0);G(a|0);z()}function MBa(a,b,c,d){var e=0,f=0,g=0;e=Za-80|0;Za=e;Ce(b);De(e+56|0,a,d);a=j[e+56>>2];j[114630]=0;f=H(412,e+56|0)|0;g=j[114630];j[114630]=0;a:{b:{c:{if((g|0)==1){break c}j[114630]=0;f=H(413,f|0)|0;g=j[114630];j[114630]=0;if((g|0)==1){break c}j[114630]=0;L(414,e+8|0,3,f|0,a|0);f=j[114630];j[114630]=0;if((f|0)==1){break c}j[114630]=0;F(415,e+24|0,e+8|0);f=j[114630];j[114630]=0;if((f|0)==1){break c}j[114630]=0;I(13,e+40|0,c|0,e+24|0);c=j[114630];j[114630]=0;if((c|0)==1){break b}ob(b,e+40|0);gb(e+40|0);gb(e+24|0);lc(e+56|0);Za=e+80|0;return!d|(a|0)!=0}a=D()|0;C()|0;break a}a=D()|0;C()|0;gb(e+24|0)}lc(e+56|0);G(a|0);z()}function Ki(a,b,c){var d=0,e=0,f=0,g=0,i=0;d=Za-32|0;Za=d;h[a|0]=0;f=mf(j[j[b>>2]-12>>2]+b|0);e=j[j[b>>2]-12>>2]+b|0;a:{b:{if(f){if(j[e+72>>2]){Eq(j[(j[j[b>>2]-12>>2]+b|0)+72>>2])}c:{if(!(j[(j[j[b>>2]-12>>2]+b|0)+4>>2]&4096)|c){break c}hc(d+24|0,j[j[b>>2]-12>>2]+b|0);j[114630]=0;f=H(21,d+24|0)|0;c=j[114630];j[114630]=0;if((c|0)==1){break a}wb(d+24|0);c=em(d+16|0,b);e=dk(d+8|0);while(1){d:{if(!Xn(c,e)){break d}if(!ng(f,8192,Bj(c))){break d}Mk(c);continue}break}if(!Ji(c,e)){break c}eg(j[j[b>>2]-12>>2]+b|0,6)}g=a,i=mf(j[j[b>>2]-12>>2]+b|0),h[g|0]=i;break b}eg(e,4)}Za=d+32|0;return a}a=D()|0;C()|0;wb(d+24|0);G(a|0);z()}function wK(a,b,c){var d=0,e=0;a:{if(j[a+480180>>2]==4){d=k[b+834|0];if(c){h[b+834|0]=d&15|c<<4;break a}c=(d&240)>>>4|0;break a}if(j[a+480180>>2]!=1048576){break a}if(c){h[b+833|0]=c;break a}c=k[b+833|0]}b:{if(!(h[b+872|0]&1)|!(c&255)){break b}d=j[b+700>>2];if(!d){break b}c:{if(!(k[a+480208|0]&16)){break c}d=j[b+700>>2];if(j[a+480180>>2]==4){break c}e=b;a=oK(a,c&15);b=HMa(a,a>>31,d,d>>31)+32768|0;a=ab;a=ic(IMa(b,b>>>0<32768?a+1|0:a,65536,0),ab);j[e+700>>2]=((a|0)==(d|0))+a;return}c=d-(c&255)|0;j[b+700>>2]=c;if((c|0)>0){break b}j[b+700>>2]=1;if(j[a+480180>>2]!=2){break b}j[b+696>>2]=0;j[b+88>>2]=j[b+88>>2]|2101248}}function lD(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=Za-16|0;Za=d;Za=d+16|0;e=0;a:{if(!b){break a}b:{if(!c){break b}a=a?a:d+12|0;d=k[b|0];e=d<<24>>24;if((e|0)>=0){j[a>>2]=d;e=(e|0)!=0;break a}d=h[b|0];if(!j[j[21255]>>2]){j[a>>2]=d&57343;e=1;break a}d=(d&255)-194|0;if(d>>>0>50){break b}d=j[(d<<2)+60128>>2];if(d<<p(c,6)-6<0?c>>>0<=3:0){break b}c=k[b+1|0];e=c>>>3|0;if((e-16|e+(d>>26))>>>0>7){break b}c=c-128|d<<6;if((c|0)>=0){j[a>>2]=c;e=2;break a}d=k[b+2|0]-128|0;if(d>>>0>63){break b}c=d|c<<6;if((c|0)>=0){j[a>>2]=c;e=3;break a}b=k[b+3|0]-128|0;if(b>>>0>63){break b}j[a>>2]=b|c<<6;e=4;break a}j[114604]=25;e=-1}return e|0}function yE(a,b,c,d,e){var f=0,g=0,i=0;f=Za-208|0;Za=f;j[f+204>>2]=c;Ab(f+160|0,0,40);j[f+200>>2]=j[f+204>>2];a:{if((uv(0,b,f+200|0,f+80|0,f+160|0,d,e)|0)<0){b=-1;break a}g=j[a+76>>2]>=0;c=j[a>>2];if(h[a+74|0]<=0){j[a>>2]=c&-33}i=c&32;b:{if(j[a+48>>2]){b=uv(a,b,f+200|0,f+80|0,f+160|0,d,e);break b}j[a+48>>2]=80;j[a+16>>2]=f+80;j[a+28>>2]=f;j[a+20>>2]=f;c=j[a+44>>2];j[a+44>>2]=f;d=uv(a,b,f+200|0,f+80|0,f+160|0,d,e);b=d;if(!c){break b}bb[j[a+36>>2]](a,0,0)|0;j[a+48>>2]=0;j[a+44>>2]=c;j[a+28>>2]=0;j[a+16>>2]=0;b=j[a+20>>2];j[a+20>>2]=0;b=b?d:-1}c=a;a=j[a>>2];j[c>>2]=a|i;b=a&32?-1:b;if(!g){break a}}Za=f+208|0;return b}function Oma(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,i=0,k=0,m=0;g=Za-32|0;Za=g;a:{if(l[a+480192>>1]<b>>>0){break a}b=j[((b<<2)+a|0)+900380>>2];if(!b){break a}uM(g+16|0,b);k=g,m=nP(g+16|0),j[k+8>>2]=m;k=g,m=aj(g+16|0),j[k>>2]=m;while(1){b:{j[114630]=0;b=E(785,g+8|0,g|0)|0;i=j[114630];j[114630]=0;if((i|0)==1){break b}if(!b){cp(g+16|0);break a}j[114630]=0;b=H(786,g+8|0)|0;i=j[114630];j[114630]=0;if((i|0)==1){break b}b=l[b>>1];if(b>>>0<=l[a+480190>>1]){b=p(b,104)+a|0;h[b+484421|0]=f;h[b+484418|0]=c;h[b+484420|0]=e;h[b+484419|0]=d}Ms(g+8|0);continue}break}a=D()|0;C()|0;cp(g+16|0);G(a|0);z()}Za=g+32|0}function Zva(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,i=0,k=0,l=0,m=0;b=Za-16|0;Za=b;i=j[a+40>>2];k=j[a+36>>2];m=j[a+16>>2];e=j[a+4>>2];f=e;g=j[a>>2];j[b+8>>2]=g;j[b+12>>2]=e;e=j[a+12>>2];j[b>>2]=j[a+8>>2];j[b+4>>2]=e;a:{if(!d){e=i>>12;l=k>>12;break a}while(1){f=(((f&2147483647)<<1|g>>>31)&-2)+m|0;g=h[f+1|0];e=j[a+32>>2];k=j[a+28>>2]+k|0;l=k>>12;j[c>>2]=j[c>>2]+(p(l,h[f|0])<<8);i=e+i|0;e=i>>12;j[c+4>>2]=j[c+4>>2]+(p(g,e)<<8);Bb(b+8|0,b);d=d-1|0;if(d){c=c+8|0;g=j[b+8>>2];f=j[b+12>>2];continue}break}g=j[b+8>>2];f=j[b+12>>2]}j[a+40>>2]=i;j[a+20>>2]=l;j[a+36>>2]=k;j[a+24>>2]=e;j[a>>2]=g;j[a+4>>2]=f;Za=b+16|0}function Wxa(a,b){var c=0,d=0,e=0,f=0,g=0;d=Za-32|0;Za=d;md(b,0);ek(d,2,a);qc(d+16|0,d);j[114630]=0;E(370,b+43|0,d+16|0)|0;c=j[114630];j[114630]=0;a:{b:{if((c|0)!=1){gb(d+16|0);c=a+24|0;j[b+24>>2]=k[c|0]|k[c+1|0]<<8;h[d+16|0]=k[a+22|0];h[d|0]=64;f=b,g=k[Zb(d+16|0,d)|0]<<2,i[f+30>>1]=g;c=a+16|0;j[b>>2]=k[c|0]|k[c+1|0]<<8;c=a+18|0;j[b+4>>2]=k[c|0]|k[c+1|0]<<8;a=a+20|0;a=k[a|0]|k[a+1|0]<<8;j[b+8>>2]=a;c=j[b>>2];if(c>>>0>1){break b}j[b>>2]=0;break a}a=D()|0;C()|0;gb(d+16|0);G(a|0);z()}if((a|0)==65535){break a}e=j[b+4>>2];if(a>>>0<=e>>>0|c>>>0<=e>>>0){break a}i[b+34>>1]=2;f=b,g=j[tb(b+8|0,b)>>2],j[f+8>>2]=g}Za=d+32|0}function iya(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0;f=Za-80|0;Za=f;di(f+40|0,f+32|0,c);j[114630]=0;I(240,f+52|0,f+24|0,d|0);d=j[114630];j[114630]=0;c=1;a:{b:{c:{d:{if((d|0)!=1){j[114630]=0;I(224,f- -64|0,f+16|0,e|0);c=j[114630];j[114630]=0;if((c|0)==1){break d}j[114630]=0;F(241,f+8|0,f+40|0);c=j[114630];j[114630]=0;if((c|0)==1){break b}j[114630]=0;I(72,a|0,b|0,f+8|0);a=j[114630];j[114630]=0;if((a|0)==1){break b}Nl(f+40|0);Za=f+80|0;return}d=D()|0;C()|0;break c}d=D()|0;C()|0;c=2}c=(f+40|0)+p(c,12)|0;while(1){c=gb(c-12|0);if((c|0)!=(f+40|0)){continue}break}break a}d=D()|0;C()|0;Nl(f+40|0)}G(d|0);z()}



function wta(a,b){var c=0,d=0,e=0,f=0,g=0,h=0,k=0,m=0,n=0;f=Za+ -64|0;Za=f;d=be(a);m=d<<6;h=j[a+20>>2];g=h+(p(j[a>>2],d)<<1)|0;while(1){if(d){k=p(d,e);n=p(e^-1,d);c=0;while(1){i[g+(c+k<<1)>>1]=l[g+(c-d<<1)>>1];i[(c+n<<1)+h>>1]=l[(c<<1)+h>>1];c=c+1|0;if((c|0)!=(d|0)){continue}break}}e=e+1|0;if((e|0)!=16){continue}break}g=g+(d<<5)|0;c=l[a+34>>1];if(c&2){k=j[a+8>>2];e=j[a+4>>2];mb(f+32|0,b+1074308|0,33);pM(f+40|0,g,(p(d,e)<<1)+h|0,k-e|0,d,(c&4)>>>2|0,kb(f+32|0));c=l[a+34>>1]}if(c&8){e=j[a+16>>2];a=j[a+12>>2];mb(f+32|0,b+1074308|0,33);pM(f+8|0,g+(m<<1)|0,(p(a,d)<<1)+h|0,e-a|0,d,(c&16)>>>4|0,kb(f+32|0))}Za=f- -64|0}function caa(a,b){a=a|0;b=b|0;var c=0,d=q(0);c=Za-16|0;Za=c;a:{b:{c:{d:{switch(b-1|0){case 0:d=q(oX(n[a+48>>2])*q(2e3));if(!(q(r(d))<q(2147483648))){break c}a=~~d;break b;case 1:a=(p(j[j[a+24>>2]+24604>>2],100)|0)/128|0;break b;case 2:a=baa(k[j[a+24>>2]+24648|0]);break b;case 3:j[c>>2]=0;aaa(c,j[a+24>>2]+24604|0);a=j[c>>2];break b;default:break d}}a=R(8)|0;j[114630]=0;c=E(85,c|0,38676)|0;b=j[114630];j[114630]=0;e:{if((b|0)!=1){Wb(a,c);j[114630]=0;I(2004,a|0,83648,2012);a=j[114630];j[114630]=0;if((a|0)!=1){break a}b=D()|0;C()|0;gb(c);break e}b=D()|0;C()|0;S(a|0)}G(b|0);z()}a=-2147483648}Za=c+16|0;return a|0}z()}function Ho(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,i=0,l=0,m=0,n=0,o=0,q=0;f=Za-16|0;Za=f;if(e){h[e|0]=0}m=a+484344|0;d=Se(Hb(m,b),c,d);g=k[d+5|0];a:{b:{c:{d:{i=k[d+3|0];switch(i-10|0){case 2:case 4:case 7:break c;case 0:break d;default:break a}}j[f+12>>2]=2;l=0;break b}j[f+12>>2]=1;l=0;if((i|0)!=17){break b}l=j[a+480180>>2]==4}o=f,q=j[Hb(m,b)+12>>2]+(c^-1)|0,j[o+8>>2]=q;c=j[tb(f+8|0,f+12|0)>>2];if(!c){break a}while(1){n=p(Kj(Hb(m,b)),6);a=n+d|0;if(k[a+3|0]!=34){break a}i=g<<8;g=l?g>>>0<256?i+ -8192|0:i:i;d=k[(d+n|0)+5|0];c=c-1|0;if(e){h[e|0]=1}g=d|g;d=a;if(c){continue}break}}Za=f+16|0;return g|0}function oI(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=q(0),h=0,k=q(0),m=0,o=0,p=q(0);e=Za-16|0;Za=e;if(!(!l[b>>1]|i[d>>1]>i[d+2>>1]|(!(n[c>>2]>q(0))|(i[d+2>>1]-i[d>>1]|0)>32766))){i[a>>1]=3;f=a+4|0;Wh(f);i[a+28>>1]=65472;j[e+12>>2]=1065353216;qI(f,128,e+12|0);j[a+32>>2]=0;i[a+30>>1]=0;Wh(a+16|0);i[a+28>>1]=l[d>>1];m=a,o=Xia(l[b>>1]),i[m+30>>1]=o;g=q(r(n[c>>2]));n[a+32>>2]=g;g=Yd(g,q(q(1)/q(i[a+30>>1])));h=1;Wk(f,(i[d+2>>1]-i[d>>1]|0)+1|0);b=i[d>>1];if((b|0)<=i[d+2>>1]){while(1){k=Yd(g,q(b|0));m=xb(f,b-i[a+28>>1]|0),p=k,n[m>>2]=p;c=i[d+2>>1]>(b|0);b=b+1|0;if(c){continue}break}}ko(a)}Za=e+16|0;return h|0}function OGa(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0;f=Za-80|0;Za=f;di(f+40|0,f+32|0,c);j[114630]=0;I(224,f+52|0,f+24|0,d|0);d=j[114630];j[114630]=0;c=1;a:{b:{c:{d:{if((d|0)!=1){j[114630]=0;I(224,f- -64|0,f+16|0,e|0);c=j[114630];j[114630]=0;if((c|0)==1){break d}j[114630]=0;F(241,f+8|0,f+40|0);c=j[114630];j[114630]=0;if((c|0)==1){break b}j[114630]=0;I(72,a|0,b|0,f+8|0);a=j[114630];j[114630]=0;if((a|0)==1){break b}Nl(f+40|0);Za=f+80|0;return}d=D()|0;C()|0;break c}d=D()|0;C()|0;c=2}c=(f+40|0)+p(c,12)|0;while(1){c=gb(c-12|0);if((c|0)!=(f+40|0)){continue}break}break a}d=D()|0;C()|0;Nl(f+40|0)}G(d|0);z()}function vsa(a,b){var c=0,d=0,e=0;j[a+3832>>2]=0;j[a+3836>>2]=0;c=a+3837|0;h[c|0]=0;h[c+1|0]=0;h[c+2|0]=0;h[c+3|0]=0;h[c+4|0]=0;h[c+5|0]=0;h[c+6|0]=0;h[c+7|0]=0;while(1){lf((p(e,84)+a|0)+808|0,a);e=e+1|0;if((e|0)!=36){continue}break}while(1){j[(p(d,44)+a|0)+32>>2]=a;d=d+1|0;if((d|0)!=18){continue}break}d=0;while(1){c=j[(d<<2)+19808>>2];e=(p(d,44)+a|0)+16|0;a:{if(!(!(1<<d&3591)|d>>>0>11)){c=p(c,84)+a|0;UL(e,c+808|0,c+1060|0,c+1312|0,c+1564|0);break a}c=p(c,84)+a|0;UL(e,c+808|0,c+1060|0,0,0)}d=d+1|0;if((d|0)!=18){continue}break}d=0;while(1){Pm((p(d,84)+a|0)+808|0);d=d+1|0;if((d|0)!=36){continue}break}TL(a,b)}function uW(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0;f=Za-80|0;Za=f;Ol(f+40|0,f+32|0,c);j[114630]=0;I(240,f+52|0,f+24|0,d|0);d=j[114630];j[114630]=0;c=1;a:{b:{c:{d:{if((d|0)!=1){j[114630]=0;I(240,f- -64|0,f+16|0,e|0);c=j[114630];j[114630]=0;if((c|0)==1){break d}j[114630]=0;F(241,f+8|0,f+40|0);c=j[114630];j[114630]=0;if((c|0)==1){break b}j[114630]=0;I(72,a|0,b|0,f+8|0);a=j[114630];j[114630]=0;if((a|0)==1){break b}Nl(f+40|0);Za=f+80|0;return}d=D()|0;C()|0;break c}d=D()|0;C()|0;c=2}c=(f+40|0)+p(c,12)|0;while(1){c=gb(c-12|0);if((c|0)!=(f+40|0)){continue}break}break a}d=D()|0;C()|0;Nl(f+40|0)}G(d|0);z()}function Z2(a,b){var c=0,d=0,e=0;c=Za-16|0;Za=c;j[114630]=0;e=E(15,c+8|0,a|0)|0;d=j[114630];j[114630]=0;a:{b:{c:{if((d|0)!=1){d:{if(!k[e|0]){break d}d=uk(c,a);j[114630]=0;E(2391,d|0,b|0)|0;b=j[114630];j[114630]=0;if((b|0)!=1){if(!tk(d)){break d}b=j[j[a>>2]-12>>2];j[114630]=0;F(18,a+b|0,1);b=j[114630];j[114630]=0;if((b|0)!=1){break d}}b=J(0)|0;C()|0;nf(e);break c}nf(e);break b}b=J(0)|0;C()|0}O(b|0)|0;b=j[j[a>>2]-12>>2];j[114630]=0;N(19,a+b|0);a=j[114630];j[114630]=0;if((a|0)==1){break a}Q()}Za=c+16|0;return}a=D()|0;C()|0;j[114630]=0;M(20);b=j[114630];j[114630]=0;if((b|0)!=1){G(a|0);z()}J(0)|0;C()|0;ib();z()}function Pza(a,b,c,d){var e=0,f=0,g=0,h=0;f=Za-16|0;Za=f;c=ci(c,b);j[f+12>>2]=c;a:{if((c|0)<1){break a}e=j[b+4>>2];b:{if(!e){e=j[d>>2];break b}g=32-e|0;j[f+8>>2]=g;c=j[Pd(f+8|0,f+12|0)>>2];j[f+12>>2]=j[f+12>>2]-c;e=j[d>>2];g=-1<<j[b+4>>2]&-1>>>g-c;h=j[b>>2];j[e>>2]=j[e>>2]&(g^-1)|g&j[h>>2];c=c+j[d+4>>2]|0;j[d+4>>2]=c&31;e=e+(c>>>3&536870908)|0;j[d>>2]=e;j[b>>2]=h+4;c=j[f+12>>2]}h=e;e=(c|0)/32|0;c=e<<2;Ci(h,j[b>>2],c);e=j[f+12>>2]-(e<<5)|0;j[f+12>>2]=e;g=c+j[d>>2]|0;j[d>>2]=g;if((e|0)<1){break a}h=b;b=c+j[b>>2]|0;j[h>>2]=b;c=-1>>>32-e|0;j[g>>2]=j[g>>2]&(c^-1)|c&j[b>>2];j[d+4>>2]=j[f+12>>2]}vd(a,d);Za=f+16|0}function F2(a,b,c){var d=0,e=0,f=0,g=0,h=0,i=0,l=0,m=0,n=0,o=0,p=0;f=j[a>>2]+1794895138|0;e=Hk(j[a+8>>2],f);g=Hk(j[a+12>>2],f);d=Hk(j[a+16>>2],f);a:{if(b>>>2>>>0<=e>>>0){break a}h=b-(e<<2)|0;if((d|g)&3|(h>>>0<=g>>>0|d>>>0>=h>>>0)){break a}n=d>>>2|0;o=g>>>2|0;g=0;while(1){h=e>>>1|0;i=h+g|0;l=i<<1;d=(l+o<<2)+a|0;m=Hk(j[d>>2],f);d=Hk(j[d+4>>2],f);if(d>>>0>=b>>>0|b-d>>>0<=m>>>0|k[(d+m|0)+a|0]){break a}d=Lh(c,a+d|0);if(!d){c=(n+l<<2)+a|0;e=Hk(j[c>>2],f);c=Hk(j[c+4>>2],f);if(c>>>0>=b>>>0|e>>>0>=b-c>>>0){break a}p=k[(c+e|0)+a|0]?0:a+c|0;break a}if((e|0)==1){break a}d=(d|0)<0;e=d?h:e-h|0;g=d?g:i;continue}}return p}function Wf(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0;e=Za+ -64|0;Za=e;a:{b:{if(c-1>>>0>1023){break b}if(tg(a,b)){break b}c:{d:{if(df(a)>>>0<=b>>>0){d=yw(e+8|0,a);j[114630]=0;I(1577,a|0,b+1|0,d|0);f=j[114630];j[114630]=0;if((f|0)==1){break d}$k(d)}d=te(a,b);j[114630]=0;E(1578,d|0,c|0)|0;c=j[114630];j[114630]=0;e:{if((c|0)!=1){c=te(a,b);j[c+16>>2]=0;j[c+20>>2]=0;c=te(a,b);j[114630]=0;E(1579,c|0,32324)|0;c=j[114630];j[114630]=0;if((c|0)!=1){break e}}a=J(71412)|0;b=C()|0;break c}g=uh(te(a,b));break b}a=J(71412)|0;b=C()|0;$k(d)}if((W(71412)|0)!=(b|0)){break a}O(a|0)|0;Q()}Za=e- -64|0;return g|0}G(a|0);z()}function x$(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0;b=Za-32|0;Za=b;d=Cb(b+16|0);j[114630]=0;c=Qe(d);e=j[114630];j[114630]=0;a:{b:{if((e|0)==1){break b}e=zb(f);g=zb(f);f=nb(f);j[114630]=0;P(2507,b+8|0,c|0,e|0,f+g|0)|0;c=j[114630];j[114630]=0;if((c|0)==1){break b}c=zb(d);j[114630]=0;e=j[114630];j[114630]=0;c:{if((e|0)!=1){e=Cb(a);j[114630]=0;a=Qe(e);f=j[114630];j[114630]=0;if((f|0)==1){break c}f=ne(c);j[114630]=0;P(2509,b|0,a|0,c|0,c+f|0)|0;a=j[114630];j[114630]=0;if((a|0)==1){break c}gb(d);Za=b+32|0;return}a=D()|0;C()|0;break a}a=D()|0;C()|0;gb(e);break a}a=D()|0;C()|0}gb(d);G(a|0);z()}function N4(a){var b=0,c=0,d=0,e=0;e=Za-16|0;Za=e;c=(SMa(a),OMa(2));b=c&2147483647;a:{if(b>>>0<=1061752794){if(b>>>0<964689920){break a}a=jm(+a,0);break a}if(b>>>0<=1081824209){d=+a;if(b>>>0<=1075235811){a=jm(((c|0)>-1?-1.5707963267948966:1.5707963267948966)+d,1);break a}a=jm(((c|0)>-1?-3.141592653589793:3.141592653589793)+d,0);break a}if(b>>>0<=1088565717){d=+a;if(b>>>0<=1085271519){a=jm(((c|0)>-1?-4.71238898038469:4.71238898038469)+d,1);break a}a=jm(((c|0)>-1?-6.283185307179586:6.283185307179586)+d,0);break a}if(b>>>0>=2139095040){a=q(a-a);break a}b=wv(a,e+8|0);a=jm(o[e+8>>3],b&1)}Za=e+16|0;return a}function qca(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0;d=Za-16|0;Za=d;j[114630]=0;N(2010,a|0);e=j[114630];j[114630]=0;a:{b:{c:{if((e|0)==1){break c}j[114630]=0;N(2036,b|0);e=j[114630];j[114630]=0;if((e|0)==1){break c}e=j[a+24>>2];b=_b(d+8|0,b);j[114630]=0;f=j[b+4>>2];j[d>>2]=j[b>>2];j[d+4>>2]=f;L(2077,e|0,d|0,(c|0)!=0|0,1);c=j[114630];j[114630]=0;b=1;if((c|0)!=1){break b}}b=J(0)|0;C()|0;O(b|0)|0;j[114630]=0;L(1984,37102,a|0,0,0);a=j[114630];j[114630]=0;if((a|0)==1){break a}Q();b=0}Za=d+16|0;return b|0}a=D()|0;C()|0;j[114630]=0;M(20);b=j[114630];j[114630]=0;if((b|0)!=1){G(a|0);z()}J(0)|0;C()|0;ib();z()}function IH(a,b,c){a=a|0;b=b|0;c=q(c);var d=0;d=Za-16|0;Za=d;n[d+12>>2]=c;pw(a);Kd(d+12|0,q(0));a:{b:{switch(b|0){case 0:n[a+4220>>2]=n[d+12>>2];break a;case 1:n[a+4224>>2]=n[d+12>>2];break a;case 2:n[a+4228>>2]=n[d+12>>2];ow(a);break a;case 3:h[a+4240|0]=n[d+12>>2]>=q(.5);ow(a);break a;case 4:b=a;a=ph(q(n[d+12>>2]*q(32)));j[b+4232>>2]=(a|0)<5?a:5;Za=d+16|0;return;case 5:h[a+4241|0]=n[d+12>>2]>=q(.5);break a;case 6:h[a+4242|0]=n[d+12>>2]>=q(.5);break a;case 7:h[a+4244|0]=n[d+12>>2]>=q(.5);break a;case 8:break b;default:break a}}b=a;c=n[d+12>>2];if(c==q(0)){nw(a);c=n[d+12>>2]}o[b+4256>>3]=c}Za=d+16|0}function MU(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0;d=Za-48|0;Za=d;rc(b);cq(a);a:{if(!kf(b,d+40|0)){break a}if(!JA(d+40|0)){break a}if(!c){f=1;break a}if(!yb(b,4)){break a}nu(a);mu(d+24|0);lu(zg(a)+28|0,d+24|0);bq(d+24|0);c=j[zg(a)+28>>2];e=jj(b);if(e&1){break a}g=e-4|0;xc(b,g);e=dd(b);e=dd(b)<<8|e<<16|dd(b);if(!e){break a}j[114630]=0;F(331,c|0,e|0);h=j[114630];j[114630]=0;f=1;if((h|0)==1){a=J(71412)|0;if((C()|0)==(W(71412)|0)){O(a|0)|0;Q();f=0;break a}G(a|0);z()}xc(b,4);KU(IA(b),g,lb(j[c>>2]),e);yi(d+8|0,c);iu(d+16|0,d+8|0);b=Hn(d+24|0,d+16|0,0);Ed(zg(a)+12|0,b);jb(b)}Za=d+48|0;return f|0}function Yma(a,b,c){var d=0,e=0,f=0;d=Za-32|0;Za=d;a:{if(HJ(b)){j[d+16>>2]=j[5144];c=j[5141];j[d>>2]=j[5140];j[d+4>>2]=c;c=j[5143];j[d+8>>2]=j[5142];j[d+12>>2]=c;Db(a,((b<<2)+d|0)-1004|0);break a}if(Ld(b)){f=Qc(d);j[114630]=0;e=b-1|0;b=(e<<16>>16)/12|0;c=E(1428,f|0,(e-p(b,12)<<16>>16<<2)+c|0)|0;e=j[114630];j[114630]=0;b:{if((e|0)==1){break b}j[114630]=0;b=K(1429,c|0,1,(b<<16)+3145728>>16)|0;c=j[114630];j[114630]=0;if((c|0)==1){break b}j[114630]=0;E(4,a|0,b|0)|0;a=j[114630];j[114630]=0;if((a|0)==1){break b}gb(f);break a}a=D()|0;C()|0;gb(f);G(a|0);z()}if(!b){Db(a,20580);break a}Db(a,20584)}Za=d+32|0}function N$(a,b,c,d,e,f,g,i,k,l){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;i=i|0;k=k|0;l=l|0;var m=0,n=0,o=0;m=Za-16|0;Za=m;a:{if(a){a=KC(b);pj(m,a);b=j[m>>2];h[c|0]=b;h[c+1|0]=b>>>8;h[c+2|0]=b>>>16;h[c+3|0]=b>>>24;oj(m,a);Dh(k,m);pc(m);Gg(m,a);Dh(i,m);pc(m);n=d,o=Hh(a),j[n>>2]=o;n=e,o=Gh(a),j[n>>2]=o;Tf(m,a);ob(f,m);gb(m);Hg(m,a);Dh(g,m);pc(m);a=nj(a);break a}a=JC(b);pj(m,a);b=j[m>>2];h[c|0]=b;h[c+1|0]=b>>>8;h[c+2|0]=b>>>16;h[c+3|0]=b>>>24;oj(m,a);Dh(k,m);pc(m);Gg(m,a);Dh(i,m);pc(m);n=d,o=Hh(a),j[n>>2]=o;n=e,o=Gh(a),j[n>>2]=o;Tf(m,a);ob(f,m);gb(m);Hg(m,a);Dh(g,m);pc(m);a=nj(a)}j[l>>2]=a;Za=m+16|0}function vW(a){var b=0,c=0,d=0;b=Za+ -64|0;Za=b;d=Qc(a);j[114630]=0;c=E(2,b+16|0,7127)|0;a=j[114630];j[114630]=0;a:{b:{c:{d:{e:{f:{if((a|0)!=1){j[114630]=0;F(219,b+32|0,c|0);a=j[114630];j[114630]=0;if((a|0)==1){break f}j[114630]=0;j[b+12>>2]=13;j[b+8>>2]=0;j[b+4>>2]=0;V(239,b+48|0,b+32|0,b+12|0,b+8|0,b+4|0);a=j[114630];j[114630]=0;if((a|0)==1){break e}j[114630]=0;E(192,d|0,b+48|0)|0;a=j[114630];j[114630]=0;if((a|0)==1){break d}gb(b+48|0);qb(b+32|0);gb(c);Za=b- -64|0;return}a=D()|0;C()|0;break a}a=D()|0;C()|0;break b}a=D()|0;C()|0;break c}a=D()|0;C()|0;gb(b+48|0)}qb(b+32|0)}gb(c)}gb(d);G(a|0);z()}function TGa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0;e=Za-704|0;Za=e;a:{b:{if(d>>>0<=511){d=0;if(!SGa(b,e+24|0)){break b}QT(e+24|0,c);d=554;break b}f=j[b+8>>2];RGa(b,e+24|0);d=KT(e+24|0,c,j[a+480180>>2]);xc(b,f+d|0);if(!vh(b,13380)){break b}cd(e+8|0,b,hf(b));j[114630]=0;b=H(255,e+8|0)|0;a=j[114630];j[114630]=0;if((a|0)==1){break a}j[114630]=0;a=E(618,e+8|0,13385)|0;f=j[114630];j[114630]=0;if((f|0)==1){break a}if(a){j[114630]=0;a=H(387,e+8|0)|0;f=j[114630];j[114630]=0;if((f|0)==1){break a}h[c+34|0]=a>>>0>250?0:a}d=(b+d|0)+8|0;jb(e+8|0)}Za=e+704|0;return d|0}a=D()|0;C()|0;jb(e+8|0);G(a|0);z()}function Qu(a,b,c,d,e){var f=0,g=0;f=Za-16|0;Za=f;hc(f+8|0,b);j[114630]=0;b=H(2450,f+8|0)|0;g=j[114630];j[114630]=0;a:{if((g|0)==1){break a}j[114630]=0;P(2464,b|0,64416,64448,c|0)|0;b=j[114630];j[114630]=0;if((b|0)==1){break a}j[114630]=0;b=H(2451,f+8|0)|0;c=j[114630];j[114630]=0;if((c|0)==1){break a}j[114630]=0;c=H(2465,b|0)|0;g=j[114630];j[114630]=0;if((g|0)==1){break a}j[d>>2]=c;j[114630]=0;c=H(2461,b|0)|0;d=j[114630];j[114630]=0;if((d|0)==1){break a}j[e>>2]=c;j[114630]=0;F(2462,a|0,b|0);a=j[114630];j[114630]=0;if((a|0)==1){break a}wb(f+8|0);Za=f+16|0;return}a=D()|0;C()|0;wb(f+8|0);G(a|0);z()}function Pm(a){var b=0,c=0,d=0;b=(l[a+24>>1]<<2)+(l[j[a+4>>2]+28>>1]>>>(!k[a+77|0]<<1)|0)|0;j[a+40>>2]=((b&3)<<4)+18720;c=b>>>2|0;b=b>>>0<48;d=b?12-c|0:0;i[a+32>>1]=d;i[a+36>>1]=b?1:1<<c-12;i[a+34>>1]=-1<<d^-1;if(l[a+24>>1]==15){i[a+36>>1]=4095}b=(l[a+26>>1]<<2)+(l[j[a+4>>2]+28>>1]>>>(!k[a+77|0]<<1)|0)|0;j[a+52>>2]=((b&3)<<4)+18720;c=b>>>2|0;b=b>>>0<48;d=b?12-c|0:0;i[a+44>>1]=d;i[a+48>>1]=b?1:1<<c-12;i[a+46>>1]=-1<<d^-1;b=(l[a+30>>1]<<2)+(l[j[a+4>>2]+28>>1]>>>(!k[a+77|0]<<1)|0)|0;j[a+64>>2]=((b&3)<<4)+18720;c=b>>>2|0;b=b>>>0<48;d=b?12-c|0:0;i[a+56>>1]=d;i[a+60>>1]=b?1:1<<c-12;i[a+58>>1]=-1<<d^-1}function Dga(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=q(0);c=Za-4112|0;Za=c;f=bb[j[j[a>>2]+112>>2]](a)|0;if(!f){bb[j[j[a>>2]+116>>2]](a)}j[c+12>>2]=0;Cga(a+44|0);if(b){g=c+2064|0;while(1){j[c+8>>2]=b;jc(c+8|0,512);Vo(c+16|0);bb[j[j[a>>2]+60>>2]](a,c+16|0,g,j[c+8>>2]);d=0;e=0;if(j[c+8>>2]){while(1){d=(c+16|0)+(e<<2)|0;n[c+4>>2]=r(n[d>>2]);h=c,i=n[lw(c+12|0,c+4|0)>>2],n[h+12>>2]=i;n[c+4>>2]=r(n[d+2048>>2]);h=c,i=n[lw(c+12|0,c+4|0)>>2],n[h+12>>2]=i;d=j[c+8>>2];e=e+1|0;if(d>>>0>e>>>0){continue}break}}b=b-d|0;if(b){continue}break}}if(!f){bb[j[j[a>>2]+120>>2]](a)}Za=c+4112|0;return q(n[c+12>>2])}function dz(a,b,c){var d=0,e=0,f=0,g=0,m=0,n=0;e=Za-16|0;Za=e;d=(c<<3)+a|0;f=k[d+356|0];h[b+12|0]=k[b+12|0]&248|f&1|f<<1&4|f>>>1&2;Nf(b,kd(k[d+352|0],2,16));h[b+13|0]=k[d+354|0];h[b+14|0]=k[d+355|0];d=k[d+353|0];h[b+15|0]=d;h[b+16|0]=d;d=0;i[e+14>>1]=0;if(sb(b)){f=((c|0)!=0)<<1;a=(c<<6)+a|0;while(1){c=a+(d<<2)|0;g=c+160|0;i[e+12>>1]=k[g|0]|k[g+1|0]<<8;g=l[vi(e+14|0,e+12|0)>>1];i[e+14>>1]=g;m=xb(b,d),n=g,i[m>>1]=n;i[e+14>>1]=l[e+14>>1]+1;c=c+162|0;j[e+8>>2]=(k[c|0]|k[c+1|0]<<8)>>>f;j[e+4>>2]=64;c=j[Pd(e+8|0,e+4|0)>>2];m=xb(b,d),n=c,h[m+2|0]=n;d=d+1|0;if(sb(b)>>>0>d>>>0){continue}break}}Za=e+16|0}function Lza(a,b,c,d){var e=0,f=0,g=0,h=0;f=Za-16|0;Za=f;c=ci(c,b);j[f+12>>2]=c;a:{if((c|0)<1){break a}e=j[b+4>>2];if(e){g=32-e|0;j[f+8>>2]=g;c=j[Pd(f+8|0,f+12|0)>>2];j[f+12>>2]=j[f+12>>2]-c;e=j[d>>2];g=-1<<j[b+4>>2]&-1>>>g-c;j[e>>2]=j[e>>2]&(g^-1)|g&j[j[b>>2]>>2];c=c+j[d+4>>2]|0;j[d+4>>2]=c&31;j[d>>2]=e+(c>>>3&536870908);j[b>>2]=j[b>>2]+4;c=j[f+12>>2]}e=(c|0)/32|0;c=e<<2;Ci(j[d>>2],j[b>>2],c);e=j[f+12>>2]-(e<<5)|0;j[f+12>>2]=e;j[d>>2]=c+j[d>>2];if((e|0)<1){break a}g=b;b=c+j[b>>2]|0;j[g>>2]=b;c=j[d>>2];g=c;h=j[c>>2];c=-1>>>32-e|0;j[g>>2]=h&(c^-1)|c&j[b>>2];j[d+4>>2]=j[f+12>>2]}vd(a,d);Za=f+16|0}function Yq(a,b,c){var d=0,e=0;d=a,e=Oh(q(q(q(q(q(q(q(q(q(n[c+3328>>2]+n[c+256>>2])*q(213))+q(q(n[c+3584>>2]-n[c>>2])*q(29)))+q(q(n[c+3072>>2]-n[c+512>>2])*q(459)))+q(q(n[c+2816>>2]+n[c+768>>2])*q(2037)))+q(q(n[c+2560>>2]-n[c+1024>>2])*q(5153)))+q(q(n[c+2304>>2]+n[c+1280>>2])*q(6574)))+q(q(n[c+2048>>2]-n[c+1536>>2])*q(37489)))+q(n[c+1792>>2]*q(75038)))),i[d>>1]=e;d=(b<<5)+a|0,e=Oh(q(q(q(q(q(q(q(q(n[c+3080>>2]*q(1567))+q(n[c+3592>>2]*q(104)))+q(n[c+2568>>2]*q(9727)))+q(n[c+2056>>2]*q(64019)))+q(n[c+1544>>2]*q(-9975)))+q(n[c+1032>>2]*q(-45)))+q(n[c+520>>2]*q(146)))+q(n[c+8>>2]*q(-5)))),i[d>>1]=e}function W$(a,b,c,d,e,f,g,i,k,l){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;i=i|0;k=k|0;l=l|0;var m=0,n=0,o=0;m=Za-16|0;Za=m;a:{if(a){a=OC(b);pj(m,a);b=j[m>>2];h[c|0]=b;h[c+1|0]=b>>>8;h[c+2|0]=b>>>16;h[c+3|0]=b>>>24;oj(m,a);ob(k,m);gb(m);Gg(m,a);ob(i,m);gb(m);n=d,o=Hh(a),h[n|0]=o;n=e,o=Gh(a),h[n|0]=o;Tf(m,a);ob(f,m);gb(m);Hg(m,a);ob(g,m);gb(m);a=nj(a);break a}a=NC(b);pj(m,a);b=j[m>>2];h[c|0]=b;h[c+1|0]=b>>>8;h[c+2|0]=b>>>16;h[c+3|0]=b>>>24;oj(m,a);ob(k,m);gb(m);Gg(m,a);ob(i,m);gb(m);n=d,o=Hh(a),h[n|0]=o;n=e,o=Gh(a),h[n|0]=o;Tf(m,a);ob(f,m);gb(m);Hg(m,a);ob(g,m);gb(m);a=nj(a)}j[l>>2]=a;Za=m+16|0}function oca(a,b,c){a=a|0;b=b|0;c=+c;var d=0,e=0,f=0;e=Za-16|0;Za=e;j[114630]=0;N(2010,a|0);d=j[114630];j[114630]=0;a:{b:{c:{if((d|0)==1){break c}j[114630]=0;N(2036,b|0);d=j[114630];j[114630]=0;if((d|0)==1){break c}d=j[a+24>>2];b=_b(e+8|0,b);j[114630]=0;f=j[b+4>>2];j[e>>2]=j[b>>2];j[e+4>>2]=f;Ua(2079,d|0,e|0,+c,1);d=j[114630];j[114630]=0;b=1;if((d|0)!=1){break b}}b=J(0)|0;C()|0;O(b|0)|0;j[114630]=0;L(1984,37164,a|0,0,0);a=j[114630];j[114630]=0;if((a|0)==1){break a}Q();b=0}Za=e+16|0;return b|0}a=D()|0;C()|0;j[114630]=0;M(20);b=j[114630];j[114630]=0;if((b|0)!=1){G(a|0);z()}J(0)|0;C()|0;ib();z()}function Su(a,b,c,d,e){var f=0,g=0;f=Za-16|0;Za=f;hc(f+8|0,b);j[114630]=0;b=H(21,f+8|0)|0;g=j[114630];j[114630]=0;a:{if((g|0)==1){break a}j[114630]=0;P(2441,b|0,64416,64448,c|0)|0;b=j[114630];j[114630]=0;if((b|0)==1){break a}j[114630]=0;b=H(2417,f+8|0)|0;c=j[114630];j[114630]=0;if((c|0)==1){break a}j[114630]=0;c=H(2442,b|0)|0;g=j[114630];j[114630]=0;if((g|0)==1){break a}h[d|0]=c;j[114630]=0;c=H(2432,b|0)|0;d=j[114630];j[114630]=0;if((d|0)==1){break a}h[e|0]=c;j[114630]=0;F(2433,a|0,b|0);a=j[114630];j[114630]=0;if((a|0)==1){break a}wb(f+8|0);Za=f+16|0;return}a=D()|0;C()|0;wb(f+8|0);G(a|0);z()}function NE(a){var b=0,c=0,d=0,e=0,f=0,g=0;if(he(a)){Nb(a,31);return 0}f=a,g=he(a),h[f+1375|0]=g;d=Nh(a);b=Nh(a);Nh(a);f=a,g=Nh(a),j[f+1112>>2]=g;Nh(a);c=he(a);j[a+1116>>2]=c;if(!Dv(a,a+1120|0,c)){Nb(a,10);return 0}j[a+1404>>2]=-2;a:{if((b&d)==-1){break a}b=j[a+1116>>2];while(1){if((b|0)<1){break a}b=b-1|0;if(k[(b+a|0)+1120|0]==255){continue}break}j[a+1408>>2]=d;j[a+1404>>2]=b}if(k[a+1377|0]){e=j[a+1116>>2];b=27;b:{if((e|0)<1){break b}c=0;b=0;while(1){c=k[(a+b|0)+1120|0]+c|0;b=b+1|0;if((e|0)!=(b|0)){continue}break}b=c+27|0}j[a- -64>>2]=d;j[a+60>>2]=j[a+56>>2]+(b+e|0)}j[a+1380>>2]=0;return 1}function Pt(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0;c=Za-16|0;Za=c;j[c+12>>2]=b;a:{b:{c:{if(b>>>0<=4294967279){f=sc(a);h=c,i=nb(a),j[h+8>>2]=i;b=j[Lc(c+12|0,c+8|0)>>2];j[c+12>>2]=b;d=Fk(b);j[c+12>>2]=d;if((d|0)==(f|0)){break a}if((d|0)==10){g=1;b=a;e=j[a>>2];break b}b=j[c+12>>2]+1|0;if(d>>>0>f>>>0){b=Rh(b);break c}j[114630]=0;b=E(30,a|0,b|0)|0;e=j[114630];j[114630]=0;if((e|0)!=1){break c}a=J(0)|0;C()|0;O(a|0)|0;Q();break a}jg();z()}g=qe(a);e=zb(a)}kh(b,e,nb(a)+1|0);if(g){Yf(a,e,f+1|0)}d:{if((d|0)!=10){lg(a,j[c+12>>2]+1|0);ee(a,j[c+8>>2]);lf(a,b);break d}Ue(a,j[c+8>>2])}}Za=c+16|0}function $X(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0;c=Za-16|0;Za=c;j[c+12>>2]=b;a:{b:{c:{if(b>>>0<=1073741807){f=oq(a);h=c,i=nb(a),j[h+8>>2]=i;b=j[Lc(c+12|0,c+8|0)>>2];j[c+12>>2]=b;d=Ul(b);j[c+12>>2]=d;if((d|0)==(f|0)){break a}g=1;if((d|0)==1){b=a;e=j[a>>2];break b}b=j[c+12>>2]+1|0;if(d>>>0>f>>>0){b=Ck(b);break c}j[114630]=0;b=E(2841,a|0,b|0)|0;e=j[114630];j[114630]=0;if((e|0)!=1){break c}a=J(0)|0;C()|0;O(a|0)|0;Q();break a}jg();z()}g=qe(a);e=zb(a)}Jh(b,e,nb(a)+1|0);if(g){On(e,f+1|0)}d:{if((d|0)!=1){lg(a,j[c+12>>2]+1|0);ee(a,j[c+8>>2]);lf(a,b);break d}Ue(a,j[c+8>>2])}}Za=c+16|0}function gF(a,b){a=a|0;b=b|0;var c=0,d=0;d=Za-16|0;Za=d;a:{b:{c:{c=a+8|0;d:{if(!Tk(c)){if((b|0)<0|(fr(c)|0)<=(b|0)){break d}c=(k[Yo(j[a+32>>2],b+1&65535)+35|0]&4)>>>2|0;break b}c=Tk(c);if((b|0)<0){break d}if((b|0)<(c|0)){break c}}a=R(8)|0;j[114630]=0;c=E(85,d|0,40681)|0;b=j[114630];j[114630]=0;e:{if((b|0)!=1){Wb(a,c);j[114630]=0;I(2004,a|0,83648,2012);a=j[114630];j[114630]=0;if((a|0)!=1){break a}b=D()|0;C()|0;gb(c);break e}b=D()|0;C()|0;S(a|0)}G(b|0);z()}b=b+1<<2;a=a+32|0;c=1;if(!j[(b+j[a>>2]|0)+900380>>2]){break b}c=(k[j[(b+j[a>>2]|0)+900380>>2]+15|0]&2)>>>1|0}Za=d+16|0;return c|0}z()}function jGa(a,b,c){var d=0,e=0,f=0;d=Za+ -64|0;Za=d;De(d+40|0,a,c);a=j[d+40>>2];j[114630]=0;e=H(412,d+40|0)|0;f=j[114630];j[114630]=0;a:{b:{c:{if((f|0)==1){break c}j[114630]=0;e=H(413,e|0)|0;f=j[114630];j[114630]=0;if((f|0)==1){break c}j[114630]=0;L(414,d+8|0,2,e|0,a|0);e=j[114630];j[114630]=0;if((e|0)==1){break c}j[114630]=0;F(415,d+24|0,d+8|0);e=j[114630];j[114630]=0;if((e|0)==1){break c}j[114630]=0;E(378,b|0,d+24|0)|0;b=j[114630];j[114630]=0;if((b|0)==1){break b}gb(d+24|0);lc(d+40|0);Za=d- -64|0;return!c|(a|0)!=0}a=D()|0;C()|0;break a}a=D()|0;C()|0;gb(d+24|0)}lc(d+40|0);G(a|0);z()}function QLa(a,b,c){var d=0,e=0,f=0;d=Za+ -64|0;Za=d;De(d+40|0,a,c);a=j[d+40>>2];j[114630]=0;e=H(412,d+40|0)|0;f=j[114630];j[114630]=0;a:{b:{c:{if((f|0)==1){break c}j[114630]=0;e=H(413,e|0)|0;f=j[114630];j[114630]=0;if((f|0)==1){break c}j[114630]=0;L(414,d+8|0,2,e|0,a|0);e=j[114630];j[114630]=0;if((e|0)==1){break c}j[114630]=0;F(415,d+24|0,d+8|0);e=j[114630];j[114630]=0;if((e|0)==1){break c}j[114630]=0;E(369,b|0,d+24|0)|0;b=j[114630];j[114630]=0;if((b|0)==1){break b}gb(d+24|0);lc(d+40|0);Za=d- -64|0;return!c|(a|0)!=0}a=D()|0;C()|0;break a}a=D()|0;C()|0;gb(d+24|0)}lc(d+40|0);G(a|0);z()}function PLa(a,b,c){var d=0,e=0,f=0;d=Za+ -64|0;Za=d;De(d+40|0,a,c);a=j[d+40>>2];j[114630]=0;e=H(412,d+40|0)|0;f=j[114630];j[114630]=0;a:{b:{c:{if((f|0)==1){break c}j[114630]=0;e=H(413,e|0)|0;f=j[114630];j[114630]=0;if((f|0)==1){break c}j[114630]=0;L(414,d+8|0,1,e|0,a|0);e=j[114630];j[114630]=0;if((e|0)==1){break c}j[114630]=0;F(415,d+24|0,d+8|0);e=j[114630];j[114630]=0;if((e|0)==1){break c}j[114630]=0;E(370,b|0,d+24|0)|0;b=j[114630];j[114630]=0;if((b|0)==1){break b}gb(d+24|0);lc(d+40|0);Za=d- -64|0;return!c|(a|0)!=0}a=D()|0;C()|0;break a}a=D()|0;C()|0;gb(d+24|0)}lc(d+40|0);G(a|0);z()}function KIa(a,b,c){var d=0,e=0,f=0;d=Za+ -64|0;Za=d;De(d+40|0,a,c);a=j[d+40>>2];j[114630]=0;e=H(412,d+40|0)|0;f=j[114630];j[114630]=0;a:{b:{c:{if((f|0)==1){break c}j[114630]=0;e=H(413,e|0)|0;f=j[114630];j[114630]=0;if((f|0)==1){break c}j[114630]=0;L(414,d+8|0,3,e|0,a|0);e=j[114630];j[114630]=0;if((e|0)==1){break c}j[114630]=0;F(415,d+24|0,d+8|0);e=j[114630];j[114630]=0;if((e|0)==1){break c}j[114630]=0;E(370,b|0,d+24|0)|0;b=j[114630];j[114630]=0;if((b|0)==1){break b}gb(d+24|0);lc(d+40|0);Za=d- -64|0;return!c|(a|0)!=0}a=D()|0;C()|0;break a}a=D()|0;C()|0;gb(d+24|0)}lc(d+40|0);G(a|0);z()}function Exa(a,b,c){var d=0,e=0,f=0;d=Za+ -64|0;Za=d;De(d+40|0,a,c);a=j[d+40>>2];j[114630]=0;e=H(412,d+40|0)|0;f=j[114630];j[114630]=0;a:{b:{c:{if((f|0)==1){break c}j[114630]=0;e=H(413,e|0)|0;f=j[114630];j[114630]=0;if((f|0)==1){break c}j[114630]=0;L(414,d+8|0,2,e|0,a|0);e=j[114630];j[114630]=0;if((e|0)==1){break c}j[114630]=0;F(415,d+24|0,d+8|0);e=j[114630];j[114630]=0;if((e|0)==1){break c}j[114630]=0;E(370,b|0,d+24|0)|0;b=j[114630];j[114630]=0;if((b|0)==1){break b}gb(d+24|0);lc(d+40|0);Za=d- -64|0;return!c|(a|0)!=0}a=D()|0;C()|0;break a}a=D()|0;C()|0;gb(d+24|0)}lc(d+40|0);G(a|0);z()}function uca(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0;c=Za-16|0;Za=c;j[114630]=0;N(2010,a|0);d=j[114630];j[114630]=0;a:{b:{c:{if((d|0)==1){break c}j[114630]=0;N(2036,b|0);d=j[114630];j[114630]=0;if((d|0)==1){break c}d=j[a+24>>2];b=_b(c+8|0,b);j[114630]=0;f=j[b+4>>2];j[c>>2]=j[b>>2];j[c+4>>2]=f;e=+ca(2074,d|0,c|0,1);b=j[114630];j[114630]=0;if((b|0)!=1){break b}}b=J(0)|0;C()|0;O(b|0)|0;j[114630]=0;L(1984,37014,a|0,0,0);a=j[114630];j[114630]=0;if((a|0)==1){break a}Q();e=0}Za=c+16|0;return+e}a=D()|0;C()|0;j[114630]=0;M(20);b=j[114630];j[114630]=0;if((b|0)!=1){G(a|0);z()}J(0)|0;C()|0;ib();z()}function fS(a,b,c){var d=0,e=0,f=0;d=Za+ -64|0;Za=d;De(d+40|0,a,c);a=j[d+40>>2];j[114630]=0;e=H(412,d+40|0)|0;f=j[114630];j[114630]=0;a:{b:{c:{if((f|0)==1){break c}j[114630]=0;e=H(413,e|0)|0;f=j[114630];j[114630]=0;if((f|0)==1){break c}j[114630]=0;L(414,d+8|0,3,e|0,a|0);e=j[114630];j[114630]=0;if((e|0)==1){break c}j[114630]=0;F(415,d+24|0,d+8|0);e=j[114630];j[114630]=0;if((e|0)==1){break c}j[114630]=0;E(369,b|0,d+24|0)|0;b=j[114630];j[114630]=0;if((b|0)==1){break b}gb(d+24|0);lc(d+40|0);Za=d- -64|0;return!c|(a|0)!=0}a=D()|0;C()|0;break a}a=D()|0;C()|0;gb(d+24|0)}lc(d+40|0);G(a|0);z()}function eS(a,b,c){var d=0,e=0,f=0;d=Za+ -64|0;Za=d;De(d+40|0,a,c);a=j[d+40>>2];j[114630]=0;e=H(412,d+40|0)|0;f=j[114630];j[114630]=0;a:{b:{c:{if((f|0)==1){break c}j[114630]=0;e=H(413,e|0)|0;f=j[114630];j[114630]=0;if((f|0)==1){break c}j[114630]=0;L(414,d+8|0,3,e|0,a|0);e=j[114630];j[114630]=0;if((e|0)==1){break c}j[114630]=0;F(415,d+24|0,d+8|0);e=j[114630];j[114630]=0;if((e|0)==1){break c}j[114630]=0;E(378,b|0,d+24|0)|0;b=j[114630];j[114630]=0;if((b|0)==1){break b}gb(d+24|0);lc(d+40|0);Za=d- -64|0;return!c|(a|0)!=0}a=D()|0;C()|0;break a}a=D()|0;C()|0;gb(d+24|0)}lc(d+40|0);G(a|0);z()}function VIa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;md(b,0);j[b>>2]=k[a|0]|k[a+1|0]<<8|(k[a+2|0]<<16|k[a+3|0]<<24);c=a+4|0;j[b+12>>2]=k[c|0]|k[c+1|0]<<8|(k[c+2|0]<<16|k[c+3|0]<<24);c=a+8|0;j[b+16>>2]=k[c|0]|k[c+1|0]<<8|(k[c+2|0]<<16|k[c+3|0]<<24);c=a+12|0;c=k[c|0]|k[c+1|0]<<8;i[b+32>>1]=64;j[b+24>>2]=c;e=b;c=a+14|0;d=256;a:{if(!k[c|0]){break a}d=k[c|0]+1|0}i[e+30>>1]=d;i[b+34>>1]=l[b+34>>1]&32767|!k[c|0]<<15;a=a+15|0;if(!(!(h[a|0]&1)|m[b+16>>2]<=m[b+12>>2])){i[b+34>>1]=l[b+34>>1]|8}if(k[a|0]&2){i[b+34>>1]=l[b+34>>1]|1;j[b>>2]=j[b>>2]>>>1;j[b+12>>2]=j[b+12>>2]>>>1;j[b+16>>2]=j[b+16>>2]>>>1}}function IM(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,i=0,k=0,l=0,m=0,n=0,o=0;f=Za-16|0;Za=f;j[f+8>>2]=e;j[f+12>>2]=d;a:{if(!d){break a}Ce(a);Pt(a,c);if(!c){break a}e=0;while(1){l=c-g|0;j[f+4>>2]=l;i=j[tb(f+12|0,f+4|0)>>2];Ln(a,lb(b)+g|0,i);us(a,1,13);k=e+i|0;if(k>>>0>e>>>0){while(1){b:{c:{d:{m=h[Rl(a,e)|0];switch(m-10|0){case 1:case 2:break b;case 0:case 3:break c;default:break d}}if(m){break b}}n=Rl(a,e),o=32,h[n|0]=o}e=e+1|0;if((k|0)!=(e|0)){continue}break}}j[f+4>>2]=l-i;e=k+1|0;g=j[tb(f+8|0,f+4|0)>>2]+(i+g|0)|0;if(g>>>0<c>>>0){continue}break}}Za=f+16|0;return(d|0)!=0|0}function wca(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;d=Za-16|0;Za=d;j[114630]=0;N(2010,a|0);c=j[114630];j[114630]=0;a:{b:{c:{if((c|0)==1){break c}j[114630]=0;N(2036,b|0);c=j[114630];j[114630]=0;if((c|0)==1){break c}c=j[a+24>>2];b=_b(d+8|0,b);j[114630]=0;e=j[b+4>>2];j[d>>2]=j[b>>2];j[d+4>>2]=e;b=K(2072,c|0,d|0,1)|0;c=j[114630];j[114630]=0;if((c|0)!=1){break b}}b=J(0)|0;C()|0;O(b|0)|0;j[114630]=0;L(1984,36952,a|0,0,0);a=j[114630];j[114630]=0;if((a|0)==1){break a}Q();b=0}Za=d+16|0;return b|0}a=D()|0;C()|0;j[114630]=0;M(20);b=j[114630];j[114630]=0;if((b|0)!=1){G(a|0);z()}J(0)|0;C()|0;ib();z()}function Ui(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,i=0,k=0,m=0;c=Za-32|0;Za=c;g=Jo(a);f=Wi(g);ora(a,f);a:{if(!b){break a}d=a+12|0;bs(d);if(jd(d)>>>0>1023){break a}j[c+28>>2]=0;e=j[a+24>>2]+484344|0;k=c,m=Lb(e),j[k+24>>2]=m;k=c,m=Mb(e),j[k+16>>2]=m;if(rb(c+24|0,c+16|0)){while(1){j[c+12>>2]=j[j[c+24>>2]+12>>2];k=c,m=j[Lc(c+28|0,c+12|0)>>2],j[k+28>>2]=m;Ax(c+24|0);if(rb(c+24|0,c+16|0)){continue}break}e=j[c+28>>2]}else{e=0}sL(d,e)}if(f){d=0;while(1){e=ad(a,d);i=zx(a,l[bc(g,d)>>1]);b:{if(b){h[c+28|0]=0;rL(e,i,c+28|0);break b}jy(e,i,0)}d=d+1|0;if((f|0)!=(d|0)){continue}break}}Za=c+32|0}function pca(a,b,c,d){var e=0,f=0,g=0;e=Za-16|0;Za=e;j[114630]=0;N(2010,a|0);f=j[114630];j[114630]=0;a:{b:{c:{if((f|0)==1){break c}j[114630]=0;N(2036,b|0);f=j[114630];j[114630]=0;if((f|0)==1){break c}f=j[a+24>>2];b=_b(e+8|0,b);j[114630]=0;g=j[b+4>>2];j[e>>2]=j[b>>2];j[e+4>>2]=g;ua(2078,f|0,e|0,c|0,d|0,1);c=j[114630];j[114630]=0;b=1;if((c|0)!=1){break b}}b=J(0)|0;C()|0;O(b|0)|0;j[114630]=0;L(1984,37133,a|0,0,0);a=j[114630];j[114630]=0;if((a|0)==1){break a}Q();b=0}Za=e+16|0;return b}a=D()|0;C()|0;j[114630]=0;M(20);b=j[114630];j[114630]=0;if((b|0)!=1){G(a|0);z()}J(0)|0;C()|0;ib();z()}function Pma(a,b){var c=0,d=0;c=j[b+4>>2];j[a>>2]=j[b>>2];j[a+4>>2]=c;c=k[b+11|0]|k[b+12|0]<<8|(k[b+13|0]<<16|k[b+14|0]<<24);d=k[b+7|0]|k[b+8|0]<<8|(k[b+9|0]<<16|k[b+10|0]<<24);h[a+7|0]=d;h[a+8|0]=d>>>8;h[a+9|0]=d>>>16;h[a+10|0]=d>>>24;h[a+11|0]=c;h[a+12|0]=c>>>8;h[a+13|0]=c>>>16;h[a+14|0]=c>>>24;h[a+15|0]=k[b+15|0];c=j[b+44>>2];j[a+40>>2]=j[b+40>>2];j[a+44>>2]=c;c=j[b+36>>2];j[a+32>>2]=j[b+32>>2];j[a+36>>2]=c;c=j[b+28>>2];j[a+24>>2]=j[b+24>>2];j[a+28>>2]=c;c=j[b+20>>2];j[a+16>>2]=j[b+16>>2];j[a+20>>2]=c;_w(a+48|0,b+48|0);_w(a+68|0,b+68|0);_w(a+88|0,b+88|0);Vb(a+108|0,b+108|0,448)}function vta(a,b){var c=0,d=0,e=0,f=0,g=0,i=0,m=0,n=0,o=0;f=Za+ -64|0;Za=f;d=be(a);n=d<<6;i=j[a+20>>2];g=i+p(j[a>>2],d)|0;while(1){if(d){m=p(d,e);o=p(e^-1,d);c=0;while(1){h[g+(c+m|0)|0]=k[g+(c-d|0)|0];h[(c+o|0)+i|0]=k[c+i|0];c=c+1|0;if((c|0)!=(d|0)){continue}break}}e=e+1|0;if((e|0)!=16){continue}break}g=g+(d<<4)|0;c=l[a+34>>1];if(c&2){m=j[a+8>>2];e=j[a+4>>2];mb(f+32|0,b+1074308|0,33);oM(f+40|0,g,p(d,e)+i|0,m-e|0,d,(c&4)>>>2|0,kb(f+32|0));c=l[a+34>>1]}if(c&8){e=j[a+16>>2];a=j[a+12>>2];mb(f+32|0,b+1074308|0,33);oM(f+8|0,g+n|0,p(a,d)+i|0,e-a|0,d,(c&16)>>>4|0,kb(f+32|0))}Za=f- -64|0}function dl(a,b,c,d){var e=0,f=0;e=Za-16|0;Za=e;f=a+1074308|0;mb(e+8|0,f,84);a:{if(kb(e+8|0)){break a}b:{if(j[a+480208>>2]&16384){break b}if((d|0)!=8){mb(e+8|0,f,10);if(!kb(e+8|0)){break b}}j[b+88>>2]=j[b+88>>2]&-257}c:{d:{e:{switch(d-4|0){case 0:c=((c<<8|8)>>>0)/15|0;break d;case 2:c=(c>>>0<64?c:64)<<2;break d;default:break e}}if(!(j[a+480180>>2]&2107410)){break d}if(c>>>0<=128){c=c<<1;break d}if((c|0)!=164){break c}j[b+88>>2]=j[b+88>>2]|256;c=128}j[b+692>>2]=c}i[b+796>>1]=0;j[b+88>>2]=j[b+88>>2]|2097152;mb(e+8|0,f,10);if(!kb(e+8|0)){break a}h[b+851|0]=0;i[b+790>>1]=0}Za=e+16|0}function Cg(a){var b=0,c=0,d=0,e=0;a:{RMa(+a);b=OMa(1)|0;OMa(0)|0;c=b;b=b&2147483647;b:{if(b>>>0>=1083174912){if(!((c|0)<0|b>>>0<1083179008)){return a*8.98846567431158e+307}if(b>>>0>=2146435072){return-1/a}if(a<=-1075^1){break a}d=0;if((c|0)<-1?1:(c|0)<=-1){break b}break a}if(b>>>0>1016070143){break a}d=a+1}return d}e=a+26388279066624;RMa(+e);OMa(1)|0;c=(OMa(0)|0)+128|0;b=c<<4&4080;d=o[b+72336>>3];a=a-(e+ -26388279066624)-o[(b|8)+72336>>3];return Bh(d+d*a*(a*(a*(a*(a*.0013333559164630223+.009618129842126066)+.0555041086648214)+.2402265069591)+.6931471805599453),(c&-256)/256|0)}function wX(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,l=0,m=0,n=0,o=0,p=0;if(Qf(a,j[b+8>>2],f)){wu(b,c,d,e);return}l=k[b+53|0];g=j[a+12>>2];h[b+53|0]=0;m=k[b+52|0];h[b+52|0]=0;n=a+16|0;uu(n,b,c,d,e,f);o=k[b+53|0];l=l|o;p=k[b+52|0];m=m|p;a:{if((g|0)<2){break a}n=n+(g<<3)|0;g=a+24|0;while(1){if(k[b+54|0]){break a}b:{if(p){if(j[b+24>>2]==1){break a}if(k[a+8|0]&2){break b}break a}if(!o){break b}if(!(h[a+8|0]&1)){break a}}i[b+52>>1]=0;uu(g,b,c,d,e,f);o=k[b+53|0];l=o|l;p=k[b+52|0];m=p|m;g=g+8|0;if(n>>>0>g>>>0){continue}break}}h[b+53|0]=(l&255)!=0;h[b+52|0]=(m&255)!=0}function _Ja(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0;e=Za-32|0;Za=e;j[e+24>>2]=b;b=j[a>>2];f=e,g=Lb(a),j[f>>2]=g;b=b+(wp(e+24|0,e)<<1)|0;a:{b:{if(m[a+4>>2]<m[hb(a)>>2]){d=j[a+4>>2];if((d|0)==(b|0)){OJa(a,c);break b}NJa(a,b,d,b+2|0);c=b>>>0<=c>>>0?m[a+4>>2]>c>>>0?c+2|0:c:c;h[b|0]=k[c|0];h[b+1|0]=k[c+1|0];break b}d=hb(a);d=KR(e,ui(a,Yb(a)+1|0),b-j[a>>2]>>1,d);j[114630]=0;F(514,d|0,c|0);c=j[114630];j[114630]=0;if((c|0)==1){break a}j[114630]=0;b=K(515,a|0,d|0,b|0)|0;a=j[114630];j[114630]=0;if((a|0)==1){break a}nt(d)}a=Qe(b);Za=e+32|0;return a|0}a=D()|0;C()|0;nt(d);G(a|0);z()}function i6(a,b,c,d){var e=0,f=0,g=0,h=0,i=0,k=0,l=0,m=0,n=0;a:{if((b|0)>=5){l=b-4|0;while(1){if(_E(a)){g=Jv(a,j[c>>2]);h=g+co(a)|0;i=0;b:{c:{if(g){break c}f=4;n=e+4|0;while(1){if(((f<<1)+e|0)>=(l|0)){break b}g=0;k=a+f|0;d:{if(!eo(a,k)){break d}i=f-co(a)|0;m=co(k)+i|0;if((m+(f+n|0)|0)>(b|0)){break d}if(!eo(a,k+m|0)){break d}j[c>>2]=i;g=i;h=f}i=!g;if(f>>>0>2302){break c}f=f+1|0;if(!g){continue}break}}if((e+h|0)>(b|0)|i){break b}if($5(a,b-e|0,g)){break a}}if(!((b|0)!=(h|0)|e)){e=0;h=b;break a}j[c>>2]=0}a=a+1|0;e=e+1|0;if((l|0)!=(e|0)){continue}break}}h=0;e=b}j[d>>2]=h;return e}function gu(a,b,c,d){var e=0,f=0;e=Za-32|0;Za=e;j[e+28>>2]=d;a:{f=j[b>>2];b:{if(!(bb[j[j[f>>2]+40>>2]](f,c,d)|0)){zh(a);break b}vk(e+8|0,b);j[114630]=0;b=H(271,b|0)|0;d=j[114630];j[114630]=0;if((d|0)==1){break a}d=j[j[b>>2]+24>>2];j[114630]=0;b=H(d|0,b|0)|0;d=j[114630];j[114630]=0;if((d|0)==1){break a}j[114630]=0;j[e+4>>2]=b-c;b=E(33,e+28|0,e+4|0)|0;d=j[114630];j[114630]=0;if((d|0)==1){break a}b=j[b>>2];j[114630]=0;L(272,e+16|0,e+8|0,c|0,b|0);b=j[114630];j[114630]=0;if((b|0)==1){break a}NA(a,e+16|0,0);jb(e+16|0);jb(e+8|0)}Za=e+32|0;return}a=D()|0;C()|0;jb(e+8|0);G(a|0);z()}function vca(a,b){var c=0,d=0,e=0;d=Za-16|0;Za=d;j[114630]=0;N(2010,a|0);c=j[114630];j[114630]=0;a:{b:{c:{if((c|0)==1){break c}j[114630]=0;N(2036,b|0);c=j[114630];j[114630]=0;if((c|0)==1){break c}c=j[a+24>>2];b=_b(d+8|0,b);j[114630]=0;e=j[b+4>>2];j[d>>2]=j[b>>2];j[d+4>>2]=e;b=DB(c,d,1);e=j[114630];j[114630]=0;c=ab;if((e|0)!=1){break b}}b=J(0)|0;C()|0;O(b|0)|0;j[114630]=0;L(1984,36983,a|0,0,0);a=j[114630];j[114630]=0;if((a|0)==1){break a}Q();b=0;c=0}Za=d+16|0;ab=c;return b}a=D()|0;C()|0;j[114630]=0;M(20);b=j[114630];j[114630]=0;if((b|0)!=1){G(a|0);z()}J(0)|0;C()|0;ib();z()}function tFa(a,b){var c=0,d=0;c=(a|0)==(b|0);h[b+12|0]=c;a:{if(c){break a}while(1){if(k[j[b+8>>2]+12|0]){break a}d=Rg(j[b+8>>2]);c=j[b+8>>2];b:{c:{if(d){c=j[j[c+8>>2]+4>>2];if(!(!c|k[c+12|0])){c=c+12|0;b=j[b+8>>2];h[b+12|0]=1;b=j[b+8>>2];break c}if(!Rg(b)){b=j[b+8>>2];gp(b)}a=j[b+8>>2];h[a+12|0]=1;a=j[a+8>>2];h[a+12|0]=0;fp(a);return}c=j[j[c+8>>2]>>2];if(!c|k[c+12|0]){break b}c=c+12|0;b=j[b+8>>2];h[b+12|0]=1;b=j[b+8>>2]}h[b+12|0]=(a|0)==(b|0);h[c|0]=1;if((a|0)!=(b|0)){continue}break a}break}if(Rg(b)){b=j[b+8>>2];fp(b)}a=j[b+8>>2];h[a+12|0]=1;a=j[a+8>>2];h[a+12|0]=0;gp(a)}}function l4(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0;c=Za-32|0;Za=c;d=ce(b,-1);e=k[a+52|0];a:{if(d){d=b;if(e){break a}d=j[a+48>>2];f=a,g=ce(d,-1)^1,h[f+52|0]=g;break a}if(e){f=c,g=tm(j[a+48>>2]),h[f+19|0]=g;b:{c:{switch(Jq(j[a+36>>2],j[a+40>>2],c+19|0,c+20|0,c+12|0,c+24|0,c+32|0,c+20|0)-1|0){case 2:d=j[a+48>>2];j[c+20>>2]=c+25;h[c+24|0]=d;default:while(1){d=j[c+20>>2];e=1;if(d>>>0<=c+24>>>0){break b}d=d-1|0;j[c+20>>2]=d;if((Nq(h[d|0],j[a+32>>2])|0)!=-1){continue}break}break;case 0:case 1:break c}}d=-1;e=0}if(!e){break a}}h[a+52|0]=1;j[a+48>>2]=b;d=b}Za=c+32|0;return d|0}function AA(a,b){var c=0,d=0,e=0,f=0,g=0,h=0,i=0;e=Za-16|0;Za=e;c=j[b+16>>2];j[a+4>>2]=0;j[a>>2]=c;d=b+80|0;g=a;c=j[b+84>>2];f=j[d>>2];a:{if(c>>>0<=15){break a}j[e+12>>2]=c-16;f=j[Lc(d,e+12|0)>>2]}j[g+8>>2]=f;b:{if(!(k[b+88|0]&2)|!k[b+816|0]){break b}c:{d:{e:{if(!((j[b+88>>2]&2050)==2?(k[j[b+104>>2]+34|0]&8)>>>3|0:0)){c=j[b+104>>2];break e}c=j[b+104>>2];if(j[b+80>>2]!=j[c+12>>2]){break e}d=j[b+84>>2];if((d|0)==j[c+16>>2]){break d}}b=j[b+84>>2];if((b|0)!=j[c+8>>2]){break b}b=(j[c>>2]-b|0)+48|0;break c}b=(j[c>>2]-d|0)+112|0}h=a,i=j[a>>2]+p(Bn(c),b)|0,j[h+4>>2]=i}Za=e+16|0}function u8(a){var b=0,c=0,d=0,e=0;c=Za-160|0;Za=c;a=om(c+16|0,a,8);d=j[j[a>>2]-12>>2];j[114630]=0;b=T(122)|0;e=j[114630];j[114630]=0;a:{if((e|0)==1){break a}j[114630]=0;I(123,c+8|0,d+(c+16|0)|0,b|0);d=j[114630];j[114630]=0;if((d|0)==1){break a}wb(c+8|0);j[114630]=0;d=E(180,a|0,144)|0;b=j[114630];j[114630]=0;if((b|0)==1){break a}j[114630]=0;d=E(181,d|0,c+4|0)|0;b=j[114630];j[114630]=0;if((b|0)==1){break a}b=j[j[d>>2]-12>>2];j[114630]=0;d=H(174,b+d|0)|0;b=j[114630];j[114630]=0;if((b|0)==1){break a}b=j[c+4>>2];Xe(a);Za=c+160|0;return d?0:b}c=D()|0;C()|0;Xe(a);G(c|0);z()}function MD(a){var b=0,c=0;a:{b=j[a+4>>2];b:{if(!j[(j[j[b>>2]-12>>2]+b|0)+24>>2]){break b}b=j[a+4>>2];if(!mf(j[j[b>>2]-12>>2]+b|0)){break b}b=j[a+4>>2];if(!(j[(j[j[b>>2]-12>>2]+b|0)+4>>2]&8192)){break b}if(MB()){break b}b=j[a+4>>2];b=j[(j[j[b>>2]-12>>2]+b|0)+24>>2];j[114630]=0;b=H(2384,b|0)|0;c=j[114630];j[114630]=0;if((c|0)!=1){if((b|0)!=-1){break b}a=j[a+4>>2];b=j[j[a>>2]-12>>2];j[114630]=0;F(2385,a+b|0,1);a=j[114630];j[114630]=0;if((a|0)!=1){break b}}a=J(0)|0;C()|0;O(a|0)|0;j[114630]=0;M(20);a=j[114630];j[114630]=0;if((a|0)==1){break a}}return}J(0)|0;C()|0;ib();z()}function To(a,b,c,d){var e=0,f=0,g=0,h=0,i=0,m=0,n=0;f=Za-16|0;Za=f;g=sb(a)-1|0;a:{if((sb(a)|0)==1){break a}while(1){if(l[kc(a,e)>>1]>=(b|0)){g=e;break a}e=e+1|0;if(e>>>0<sb(a)-1>>>0){continue}break}}h=l[kc(a,g)>>1];j[f+12>>2]=0;b:{if((b|0)>=(h|0)){m=f,n=(k[kc(a,g)+2|0]<<16)/(d|0)|0,j[m+12>>2]=n;break b}e=0;if(g){e=g-1|0;i=(k[kc(a,e)+2|0]<<16)/(d|0)|0;j[f+12>>2]=i;e=l[kc(a,e)>>1]}if((b|0)<=(e|0)|e>>>0>=h>>>0){break b}m=f,n=((p(((k[kc(a,g)+2|0]<<16)/(d|0)|0)-i|0,b-e|0)|0)/(h-e|0)|0)+i|0,j[m+12>>2]=n}Md(f+12|0,0,65536);Za=f+16|0;return(p(j[f+12>>2],c)+32768|0)/65536|0}function Fv(a,b,c){var d=0,e=0,f=0,g=q(0),h=q(0),i=q(0),j=q(0),k=q(0),l=q(0),m=q(0),o=0;d=Za-32|0;Za=d;UE(q(-n[a>>2]),q(n[a+12>>2]+n[a+24>>2]),q(n[a+36>>2]+n[a+48>>2]),d+20|0);UE(n[a+60>>2],q(n[a+48>>2]-n[a+36>>2]),q(n[a+24>>2]-n[a+12>>2]),d+8|0);n[d+12>>2]=-n[d+12>>2];a=0;while(1){e=a<<2;f=e+c|0;h=n[f>>2];o=f;f=e+49024|0;g=n[f>>2];i=n[e+(d+20|0)>>2];j=n[e+(d+8|0)>>2];k=n[f+12>>2];n[o>>2]=q(g*i)-q(j*k);f=b+e|0;l=n[(0-a<<2)+49032>>2];e=5-a<<2;m=n[e+49024>>2];g=q(q(g*j)+q(k*i));n[f>>2]=q(h*l)-q(m*g);n[b+e>>2]=q(m*h)+q(g*l);a=a+1|0;if((a|0)!=3){continue}break}Za=d+32|0}function l9(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0;c=Za-32|0;Za=c;f=Ng(a);a:{b:{c:{d:{e:{e=b+24|0;if(l[j[e>>2]+480188>>1]){a=0;while(1){d=j[e>>2];j[114630]=0;F(2186,c|0,(d+(a<<5)|0)+480289|0);d=j[114630];j[114630]=0;if((d|0)==1){break e}j[114630]=0;I(2179,c+16|0,b|0,c|0);d=j[114630];j[114630]=0;if((d|0)==1){break d}j[114630]=0;F(1529,f|0,c+16|0);d=j[114630];j[114630]=0;if((d|0)==1){break c}gb(c+16|0);gb(c);a=a+1|0;if(a>>>0<l[j[e>>2]+480188>>1]){continue}break}}Za=c+32|0;return}a=D()|0;C()|0;break a}a=D()|0;C()|0;break b}a=D()|0;C()|0;gb(c+16|0)}gb(c)}Vc(f);G(a|0);z()}function fya(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0;c=Za-144|0;Za=c;_x(a);a:{b:{if(!jf(a,64)){break b}c:{d:{e:{if(!Yj(a,60)){break e}if(!nN(a,17212)){break e}b=15;break d}_x(a);if(!jf(a,128)){break b}b=0;f=1;if(!Yj(a,124)){break d}d=31;if(nN(a,17217)){break c}}d=b;if(f){break a}}_x(a);b=0;while(1){if(aya(a)>>>0>131072){break a}b=b+1|0;if((b&65535)>>>0<d>>>0){continue}break}Fc(a,4);if(!jf(a,2)){break b}if($xa(a)>>>0<178){break a}e=-1;b=p(d,30);if(!jf(a,b)){break a}Fc(a,b);b=a;a=c+8|0;b=Zxa(b,a);if(!b){zO(a)}if(!b){break a}e=mN(c+8|0);break a}e=-1}Za=c+144|0;return e|0}function d4(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,i=0,l=0;c=Za-32|0;Za=c;a:{b:{c:{if(ce(b,-1)){break c}i=c,l=tm(b),h[i+23|0]=l;if(k[a+44|0]){if((Bi(c+23|0,1,1,j[a+32>>2])|0)!=1){break b}break c}j[c+16>>2]=c+24;f=c+32|0;g=c+24|0;d=c+23|0;while(1){e=Jq(j[a+36>>2],j[a+40>>2],d,g,c+12|0,c+24|0,f,c+16|0);if(j[c+12>>2]==(d|0)){break b}if((e|0)==3){if((Bi(d,1,1,j[a+32>>2])|0)==1){break c}break b}if(e>>>0>1){break b}d=j[c+16>>2]-(c+24|0)|0;if((Bi(c+24|0,1,d,j[a+32>>2])|0)!=(d|0)){break b}d=j[c+12>>2];if((e|0)==1){continue}break}}a=jr(b);break a}a=-1}Za=c+32|0;return a|0}function tHa(a,b,c,d){var e=0,f=0,g=0,h=0,i=0,l=0,n=0,o=0;e=Za-32|0;Za=e;j[e+28>>2]=d;a:{b:{if(k[a+24|0]){if(!d){break a}i=a+40|0;break b}l=bb[j[j[a>>2]+44>>2]](a,b,c,d)|0;break a}while(1){f=DIa(a,c);g=c-j[mi(i,f)>>2]|0;j[e+8>>2]=4096-g;n=e,o=j[tb(e+8|0,e+28|0)>>2],j[n+24>>2]=o;d=e;if(m[mi(i,f)+4>>2]>g>>>0){h=j[mi(i,f)+4>>2]-g|0}else{h=0}j[d+20>>2]=h;d=j[tb(e+24|0,e+20|0)>>2];nz(e+8|0,a,f);h=j[e+8>>2];nz(e,a,f);Pe(g+h|0,d+(j[e>>2]+g|0)|0,b);f=j[e+28>>2]-d|0;j[e+28>>2]=f;l=d+l|0;if(d>>>0<m[e+24>>2]){break a}c=c+d|0;b=b+d|0;if(f){continue}break}}Za=e+32|0;return l}function j5(a,b,c,d,e,f){var g=0,h=0,m=0,o=0,r=0,s=0,t=q(0);h=1;b=k[(k[(j[b+4>>2]+p(c,3)|0)+2|0]+b|0)+9|0];if(!l[((b<<1)+a|0)+132>>1]){Nb(a,21);return}m=d>>1;g=j[a+260>>2]+p(b,1596)|0;b=p(k[g+1588|0],i[f>>1]);a=0;o=j[g+1592>>2];if((o|0)>=2){r=g+1592|0;s=g+1588|0;while(1){d=k[(g+h|0)+838|0]<<1;c=i[d+f>>1];if((c|0)>=0){c=p(k[s|0],c&65535);d=l[(d+g|0)+338>>1];if((d|0)!=(a|0)){e5(e,a,b,d,c,m);o=j[r>>2];a=d}b=c}h=h+1|0;if((o|0)>(h|0)){continue}break}}if((a|0)<(m|0)){t=n[(b<<2)+50896>>2];while(1){b=(a<<2)+e|0;n[b>>2]=n[b>>2]*t;a=a+1|0;if((m|0)!=(a|0)){continue}break}}}function ij(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0;a:{c=j[a+28>>2];if((c|0)>=(b|0)){e=j[a+24>>2];break a}i=a+32|0;f=j[a+20>>2];d=j[a+16>>2];g=c;while(1){b:{if(d>>>0>=f>>>0){f=aq(a,i,1024);j[a+16>>2]=0;j[a+20>>2]=f;if(!f){break b}d=0;g=j[a+28>>2]}h=d+1|0;j[a+16>>2]=h;d=k[(a+d|0)+32|0];c=g+8|0;j[a+28>>2]=c;e=j[a+24>>2]|d<<g;j[a+24>>2]=e;d=h;g=c;if((c|0)<(b|0)){continue}break a}break}a=R(8)|0;j[114630]=0;H(264,a|0)|0;b=j[114630];j[114630]=0;if((b|0)==1){b=D()|0;C()|0;S(a|0);G(b|0);z()}X(a|0,77088,265);z()}j[a+28>>2]=c-b;j[a+24>>2]=e>>>b;return(-1<<b^-1)&e}function dza(a,b){a=a|0;b=b|0;var c=0,d=0;d=Za-32|0;Za=d;md(b,0);IN(d,a+1|0);qc(d+16|0,d);j[114630]=0;E(370,b+43|0,d+16|0)|0;c=j[114630];j[114630]=0;if((c|0)!=1){gb(d+16|0);c=a+78|0;j[b+24>>2]=k[c|0]|k[c+1|0]<<8;c=a+58|0;j[b>>2]=k[c|0]|k[c+1|0]<<8|(k[c+2|0]<<16|k[c+3|0]<<24);c=a+62|0;j[b+4>>2]=k[c|0]|k[c+1|0]<<8|(k[c+2|0]<<16|k[c+3|0]<<24);c=a+66|0;j[b+8>>2]=k[c|0]|k[c+1|0]<<8|(k[c+2|0]<<16|k[c+3|0]<<24);i[b+30>>1]=(k[a+73|0]<<1)+2;i[b+34>>1]=l[b+34>>1]&65533|k[a|0]>>>6&2;jc(b+8|0,j[b>>2]);jc(b+4|0,j[b+8>>2]);Za=d+32|0;return}a=D()|0;C()|0;gb(d+16|0);G(a|0);z()}function x4(a){a=a|0;var b=0;b=j[13929];w4(b);v4();u4(b);t4();b=j[13930];mE(461412,b,461460);pv(460776,461412);lE(461468,b,461516);ov(460860,461468);b=j[13926];mE(461524,b,461572);pv(460944,461524);pv(461112,j[(j[j[115236]-12>>2]+460944|0)+24>>2]);lE(461580,b,461628);ov(461028,461580);ov(461196,j[(j[j[115257]-12>>2]+461028|0)+24>>2]);Lq(j[j[115150]-12>>2]+460600|0,460776);Lq(j[j[115172]-12>>2]+460688|0,460860);kE(j[j[115236]-12>>2]+460944|0);kE(j[j[115257]-12>>2]+461028|0);Lq(j[j[115236]-12>>2]+460944|0,460776);Lq(j[j[115257]-12>>2]+461028|0,460860);return a|0}function DIa(a,b){var c=0,d=0,e=0,f=0,g=0,i=0,l=0;d=Za-16|0;Za=d;f=a+40|0;c=a+232|0;g=b-(b&4095)|0;a:{while(1){b:{b=j[Ae(c,e)>>2];if(!k[mi(f,b)+8|0]){break b}if(j[mi(f,b)>>2]!=(g|0)){break b}i=d,l=j[Ae(c,e)>>2],j[i+8>>2]=l;a=e<<2;et(c,a+c|0,(a+c|0)+4|0);a=j[d+8>>2];i=Ae(c,0),l=a,j[i>>2]=l;break a}e=e+1|0;if((e|0)!=16){continue}break}i=d,l=j[Ae(c,15)>>2],j[i+8>>2]=l;et(c,c+60|0,c- -64|0);b=j[d+8>>2];i=Ae(c,0),l=b,j[i>>2]=l;b=j[Ae(c,0)>>2];c=mi(f,b);j[c>>2]=g;nz(d+8|0,a,b);i=c,l=bb[j[j[a>>2]+44>>2]](a,j[d+8>>2],g,4096)|0,j[i+4>>2]=l;h[c+8|0]=1}Za=d+16|0;return b}function h4(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0;c=Za-32|0;Za=c;d=ce(b,-1);e=k[a+52|0];a:{if(d){d=b;if(e){break a}d=j[a+48>>2];f=a,g=ce(d,-1)^1,h[f+52|0]=g;break a}if(e){j[c+16>>2]=j[a+48>>2];b:{c:{switch(Jq(j[a+36>>2],j[a+40>>2],c+16|0,c+20|0,c+12|0,c+24|0,c+32|0,c+20|0)-1|0){case 2:d=j[a+48>>2];j[c+20>>2]=c+25;h[c+24|0]=d;default:while(1){d=j[c+20>>2];e=1;if(d>>>0<=c+24>>>0){break b}d=d-1|0;j[c+20>>2]=d;if((Nq(h[d|0],j[a+32>>2])|0)!=-1){continue}break}break;case 0:case 1:break c}}d=-1;e=0}if(!e){break a}}h[a+52|0]=1;j[a+48>>2]=b;d=b}Za=c+32|0;return d|0}function wva(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,k=0,l=0;b=Za-16|0;Za=b;h=j[a+24>>2];k=j[a+20>>2];l=j[a+16>>2];g=j[a+4>>2];e=g;f=j[a>>2];j[b+8>>2]=f;j[b+12>>2]=e;g=j[a+12>>2];j[b>>2]=j[a+8>>2];j[b+4>>2]=g;if(d){while(1){e=(e<<1)+l|0;f=(f>>>21&2040)+27888|0;e=(((p(i[e>>1],i[f+2>>1])+p(i[e-2>>1],i[f>>1])|0)+p(i[e+2>>1],i[f+4>>1])|0)+p(i[e+4>>1],i[f+6>>1])|0)/16384|0;j[c>>2]=j[c>>2]+p(e,k);j[c+4>>2]=j[c+4>>2]+p(e,h);Bb(b+8|0,b);d=d-1|0;if(d){c=c+8|0;f=j[b+8>>2];e=j[b+12>>2];continue}break}f=j[b+8>>2];e=j[b+12>>2]}j[a>>2]=f;j[a+4>>2]=e;Za=b+16|0}function ywa(a,b,c){var d=0,e=0,f=0;e=Za-16|0;Za=e;j[e+12>>2]=c;d=j[b+4>>2];a:{if(d){j[e+8>>2]=32-d;c=j[tb(e+8|0,e+12|0)>>2];d=j[b>>2];f=-1<<j[b+4>>2]&-1>>>j[e+8>>2]-c&(j[d>>2]^-1);if(f){Cc(a,d,GMa(f));break a}f=j[e+12>>2];if((f|0)==(c|0)){Ux(a,b,c);break a}c=f-c|0;j[e+12>>2]=c;j[b>>2]=d+4}if(c>>>0>=32){d=j[b>>2];while(1){f=j[d>>2];if((f|0)!=-1){Cc(a,d,GMa(f^-1));break a}d=d+4|0;j[b>>2]=d;c=c-32|0;j[e+12>>2]=c;if(c>>>0>31){continue}break}}b:{if(!c){d=j[b>>2];break b}d=j[b>>2];b=(j[d>>2]^-1)&-1>>>32-c;if(!b){break b}Cc(a,d,GMa(b));break a}Cc(a,d,c)}Za=e+16|0}function rsa(a,b,c){var d=0,e=0,f=0,g=0;d=Za-16|0;Za=d;while(1){qsa((p(e,44)+a|0)+16|0,d+14|0,d+12|0);f=i[d+12>>1]+f|0;g=i[d+14>>1]+g|0;e=e+1|0;if((e|0)!=18){continue}break}e=b;b=(g|0)<32767?g:32767;i[e>>1]=(b|0)>-32768?b:-32768;b=(f|0)<32767?f:32767;i[c>>1]=(b|0)>-32768?b:-32768;i[a+3832>>1]=l[a+3832>>1]+1;b=(l[a+3834>>1]+1>>>0)%13440|0;i[a+3834>>1]=b;b=((b>>>0<6720?b:13440-b|0)|0)/256|0;i[a+3836>>1]=b;if(!k[a+3843|0]){i[a+3836>>1]=(b&65532)>>>2}b=l[a+3838>>1]+1|0;i[a+3838>>1]=b;if((b&65535)>>>0>=1024){i[a+3838>>1]=0;i[a+3840>>1]=l[a+3840>>1]+1&7}Za=d+16|0}function _va(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,k=0,l=0,m=0;b=Za-16|0;Za=b;g=j[a+40>>2];h=j[a+36>>2];m=j[a+16>>2];e=j[a+4>>2];f=e;k=j[a>>2];j[b+8>>2]=k;j[b+12>>2]=e;e=j[a+12>>2];j[b>>2]=j[a+8>>2];j[b+4>>2]=e;a:{if(!d){e=g>>12;l=h>>12;break a}while(1){e=j[a+32>>2];f=i[(f<<1)+m>>1];h=j[a+28>>2]+h|0;l=h>>12;j[c>>2]=j[c>>2]+p(f,l);g=e+g|0;e=g>>12;j[c+4>>2]=j[c+4>>2]+p(f,e);Bb(b+8|0,b);d=d-1|0;if(d){c=c+8|0;f=j[b+12>>2];continue}break}k=j[b+8>>2];f=j[b+12>>2]}j[a+40>>2]=g;j[a+20>>2]=l;j[a+36>>2]=h;j[a+24>>2]=e;j[a>>2]=k;j[a+4>>2]=f;Za=b+16|0}function Ih(a,b){var c=0,d=0,e=0,f=0,g=0,h=0,i=0,k=0;f=Za-16|0;Za=f;RMa(+b);h=OMa(1)|0;e=OMa(0)|0;g=h&2147483647;c=g;d=e;g=c+ -1048576|0;a:{if((g|0)==2145386495|g>>>0<2145386495){i=d<<28;e=c>>>4|0;c=(c&15)<<28|d>>>4;d=e+1006632960|0;break a}if((c|0)==2146435072|c>>>0>2146435072){i=e<<28;c=h;e=c>>>4|0;c=(c&15)<<28|d>>>4;d=e|2147418112;break a}if(!(c|d)){c=0;d=0;break a}g=c;c=c>>>0<1?s(e)+32|0:s(c);We(f,d,g,0,0,c+49|0);k=j[f>>2];i=j[f+4>>2];e=15372-c<<16;c=j[f+8>>2];d=e|j[f+12>>2]^65536}j[a>>2]=k;j[a+4>>2]=i;j[a+8>>2]=c;j[a+12>>2]=h&-2147483648|d;Za=f+16|0}function hra(a,b,c){var d=0,e=0,f=0;e=Za-16|0;Za=e;j[e+12>>2]=c;d=j[b+4>>2];a:{if(d){j[e+8>>2]=32-d;c=j[tb(e+8|0,e+12|0)>>2];f=-1<<d&-1>>>j[e+8>>2]-c;d=j[b>>2];f=f&(j[d>>2]^-1);if(f){Cc(a,d,GMa(f));break a}f=j[e+12>>2];if((f|0)==(c|0)){gL(a,b,c);break a}c=f-c|0;j[e+12>>2]=c;j[b>>2]=d+4}if(c>>>0>=32){d=j[b>>2];while(1){f=j[d>>2];if((f|0)!=-1){Cc(a,d,GMa(f^-1));break a}d=d+4|0;j[b>>2]=d;c=c-32|0;j[e+12>>2]=c;if(c>>>0>31){continue}break}}b:{if(!c){d=j[b>>2];break b}d=j[b>>2];b=(j[d>>2]^-1)&-1>>>32-c;if(!b){break b}Cc(a,d,GMa(b));break a}Cc(a,d,c)}Za=e+16|0}function _ma(a,b){var c=0,d=0,e=0,f=0;c=Za-16|0;Za=c;n[c+8>>2]=2;i[c+14>>1]=12;j[c+4>>2]=15;d=ue(64);j[114630]=0;e=H(1422,d|0)|0;f=j[114630];j[114630]=0;a:{b:{if((f|0)!=1){d=ax(c,e);e=j[d>>2];j[114630]=0;F(1423,e|0,b|0);b=j[114630];j[114630]=0;if((b|0)==1){break b}b=j[d>>2];j[114630]=0;b=K(1424,b|0,c+14|0,c+8|0)|0;e=j[114630];j[114630]=0;if((e|0)==1){break b}c:{if(!b){$w(a);break c}b=j[d>>2];j[114630]=0;F(1425,b|0,c+4|0);b=j[114630];j[114630]=0;if((b|0)==1){break b}hp(a,d)}Kf(d);Za=c+16|0;return}a=D()|0;C()|0;Fb(d);break a}a=D()|0;C()|0;Kf(d)}G(a|0);z()}function $va(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,i=0,k=0,l=0,m=0;b=Za-16|0;Za=b;g=j[a+40>>2];i=j[a+36>>2];m=j[a+16>>2];e=j[a+4>>2];f=e;k=j[a>>2];j[b+8>>2]=k;j[b+12>>2]=e;e=j[a+12>>2];j[b>>2]=j[a+8>>2];j[b+4>>2]=e;a:{if(!d){e=g>>12;l=i>>12;break a}while(1){e=j[a+32>>2];f=h[f+m|0]<<8;i=j[a+28>>2]+i|0;l=i>>12;j[c>>2]=j[c>>2]+p(f,l);g=e+g|0;e=g>>12;j[c+4>>2]=j[c+4>>2]+p(f,e);Bb(b+8|0,b);d=d-1|0;if(d){c=c+8|0;f=j[b+12>>2];continue}break}k=j[b+8>>2];f=j[b+12>>2]}j[a+40>>2]=g;j[a+20>>2]=l;j[a+36>>2]=i;j[a+24>>2]=e;j[a>>2]=k;j[a+4>>2]=f;Za=b+16|0}function yva(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,k=0,l=0,m=0;b=Za-16|0;Za=b;k=j[a+24>>2];l=j[a+20>>2];m=j[a+16>>2];g=j[a+4>>2];e=g;f=j[a>>2];j[b+8>>2]=f;j[b+12>>2]=e;g=j[a+12>>2];j[b>>2]=j[a+8>>2];j[b+4>>2]=g;if(d){while(1){e=e+m|0;f=(f>>>21&2040)+27888|0;e=(((p(h[e|0],i[f+2>>1])+p(h[e-1|0],i[f>>1])|0)+p(h[e+1|0],i[f+4>>1])|0)+p(h[e+2|0],i[f+6>>1])<<8)/16384|0;j[c>>2]=j[c>>2]+p(e,l);j[c+4>>2]=j[c+4>>2]+p(e,k);Bb(b+8|0,b);d=d-1|0;if(d){c=c+8|0;f=j[b+8>>2];e=j[b+12>>2];continue}break}f=j[b+8>>2];e=j[b+12>>2]}j[a>>2]=f;j[a+4>>2]=e;Za=b+16|0}function sJ(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,i=0;c=Za-16|0;Za=c;a:{if(k[b+813|0]!=27){a=h[b+851|0];break a}e=a+1074308|0;mb(c+8|0,e,21);d=kb(c+8|0);f=a;a=k[b+841|0];a=Tw(f,k[b+848|0],d?a:a+16>>>2|0);mb(c+8|0,e,45);b:{if(!(!kb(c+8|0)|k[b+848|0]!=3)){f=b;d=k[b+841|0];c:{if(!(!d|d>>>0>=k[b+849|0])){a=k[b+852|0];d=d+1|0;break c}h[b+852|0]=a;d=1}h[f+841|0]=d;a=a<<24>>24;break b}h[b+841|0]=k[b+841|0]+k[b+849|0]}mb(c+8|0,e,47);if(!kb(c+8|0)){break a}h[b+851|0]=a}if(a){g=b,i=Gb(j[b+684>>2]+((p(k[b+850|0],a)+2|0)/8|0)|0,0,256),j[g+684>>2]=i}Za=c+16|0}function ima(a,b,c){var d=0,e=0,f=0,g=0,h=0,i=0,m=0,n=0;d=Za-16|0;Za=d;a:{if(!Sw(a,b,0)){break a}e=j[b+656>>2];h=a+1074308|0;mb(d+8|0,h,31);b:{if(kb(d+8|0)){a=j[b+728>>2];if(a){break b}break a}a=j[b+728>>2]}mb(d+8|0,h,31);f=e+48|0;i=a-kb(d+8|0)|0;a=To(f,i,256,64);g=k[e+65|0];c:{if((g|0)==255){break c}b=j[b+732>>2];if((b|0)==-1){break c}g=k[xb(f,g)+2|0];f=l[xb(f,k[e+65|0])>>1];mb(d+8|0,h,94);e=g<<2;a=(f|0)==(i|0)?e:a;if(kb(d+8|0)){a=b+(a-e<<1)|0;break c}if(!g){a=0;break c}a=(p(a,b)|0)/(e|0)|0}m=c,n=(p(j[c>>2],Gb(a,0,512))|0)/256|0,j[m>>2]=n}Za=d+16|0}function iZ(){var a=0;a:{if(h[462768]&1){break a}if(!fd(462768)){break a}a=462480;while(1){a=Cb(a)+12|0;if((a|0)!=462768){continue}break}ed(462768)}vc(462480,69852);vc(462492,69860);vc(462504,69869);vc(462516,69875);vc(462528,69881);vc(462540,69885);vc(462552,69890);vc(462564,69895);vc(462576,69902);vc(462588,69912);vc(462600,69920);vc(462612,69929);vc(462624,69938);vc(462636,69942);vc(462648,69946);vc(462660,69950);vc(462672,69881);vc(462684,69954);vc(462696,69958);vc(462708,69962);vc(462720,69966);vc(462732,69970);vc(462744,69974);vc(462756,69978)}function Rda(a,b,c,d,e,f,g,h,i,k){var l=0,m=0,n=0,o=0;m=Za-32|0;Za=m;o=j[c>>2];n=j[c+8>>2];l=m;c=j[c+4>>2];j[l+8>>2]=c;j[l+12>>2]=n;j[114630]=0;j[l+24>>2]=c;j[l+28>>2]=n;j[l+20>>2]=o;j[l+16>>2]=d;c=j[l+20>>2];j[l>>2]=j[l+16>>2];j[l+4>>2]=c;d=wa(2002,a|0,b|0,l|0)|0;a=j[114630];j[114630]=0;a:{if((a|0)==1){a=J(0)|0;C()|0;O(a|0)|0;j[114630]=0;Z(1995,34684,e|0,f|0,g|0,h|0,i|0,k|0);a=j[114630];j[114630]=0;if((a|0)==1){break a}Q();d=-255}Za=m+32|0;return d}b=D()|0;C()|0;j[114630]=0;M(20);a=j[114630];j[114630]=0;if((a|0)!=1){G(b|0);z()}J(0)|0;C()|0;ib();z()}function fZ(){var a=0;a:{if(h[463072]&1){break a}if(!fd(463072)){break a}a=462784;while(1){a=Le(a)+12|0;if((a|0)!=463072){continue}break}ed(463072)}Ic(462784,69984);Ic(462796,70016);Ic(462808,70052);Ic(462820,70076);Ic(462832,70100);Ic(462844,70116);Ic(462856,70136);Ic(462868,70156);Ic(462880,70184);Ic(462892,70224);Ic(462904,70256);Ic(462916,70292);Ic(462928,70328);Ic(462940,70344);Ic(462952,70360);Ic(462964,70376);Ic(462976,70100);Ic(462988,70392);Ic(463e3,70408);Ic(463012,70424);Ic(463024,70440);Ic(463036,70456);Ic(463048,70472);Ic(463060,70488)}function iqa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,l=0,m=0;e=Za-16|0;Za=e;j[e+12>>2]=c;j[e+8>>2]=j[a>>2]<<1;f=j[tb(e+8|0,e+12|0)>>2];j[e+8>>2]=j[a>>2]<<1;j[e+4>>2]=j[e+12>>2]-f;h=j[tb(e+8|0,e+4|0)>>2]>>>1|0;c=lb(b);l=f>>>1|0;if(l){g=j[a+20>>2];f=l;m=d;while(1){m=(lb(k[c|0])+m|0)+(lb(k[c+1|0])<<8)|0;i[g>>1]=m;g=g+4|0;c=c+2|0;f=f-1|0;if(f){continue}break}}b=lb(b);if(h){g=j[a+20>>2]+2|0;c=b+(j[a>>2]<<1)|0;f=h;while(1){d=(lb(k[c|0])+d|0)+(lb(k[c+1|0])<<8)|0;i[g>>1]=d;g=g+4|0;c=c+2|0;f=f-1|0;if(f){continue}break}}Za=e+16|0;return h+l<<1}function fqa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,l=0,m=0;e=Za-16|0;Za=e;j[e+12>>2]=c;j[e+8>>2]=j[a>>2]<<1;f=j[tb(e+8|0,e+12|0)>>2];j[e+8>>2]=j[a>>2]<<1;j[e+4>>2]=j[e+12>>2]-f;h=j[tb(e+8|0,e+4|0)>>2]>>>1|0;c=lb(b);l=f>>>1|0;if(l){g=j[a+20>>2];f=l;m=d;while(1){m=(lb(k[c+1|0])+m|0)+(lb(k[c|0])<<8)|0;i[g>>1]=m;g=g+4|0;c=c+2|0;f=f-1|0;if(f){continue}break}}b=lb(b);if(h){g=j[a+20>>2]+2|0;c=b+(j[a>>2]<<1)|0;f=h;while(1){d=(lb(k[c+1|0])+d|0)+(lb(k[c|0])<<8)|0;i[g>>1]=d;g=g+4|0;c=c+2|0;f=f-1|0;if(f){continue}break}}Za=e+16|0;return h+l<<1}function a4(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0;c=Za-32|0;Za=c;a:{b:{c:{if(ce(b,-1)){break c}j[c+20>>2]=b;if(k[a+44|0]){if((Bi(c+20|0,4,1,j[a+32>>2])|0)!=1){break b}break c}j[c+16>>2]=c+24;f=c+32|0;g=c+24|0;d=c+20|0;while(1){e=Jq(j[a+36>>2],j[a+40>>2],d,g,c+12|0,c+24|0,f,c+16|0);if(j[c+12>>2]==(d|0)){break b}if((e|0)==3){if((Bi(d,1,1,j[a+32>>2])|0)==1){break c}break b}if(e>>>0>1){break b}d=j[c+16>>2]-(c+24|0)|0;if((Bi(c+24|0,1,d,j[a+32>>2])|0)!=(d|0)){break b}d=j[c+12>>2];if((e|0)==1){continue}break}}a=jr(b);break a}a=-1}Za=c+32|0;return a|0}function Hxa(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0;a:{b:{if(!ke(a)){break b}f=j[a>>2];if(f>>>0<=c>>>0|f-c>>>0<d>>>0){break b}Sm(b);Wx(b,a);j[b+20>>2]=0;j[b>>2]=d;if(!Qo(b)){break b}if(j[a>>2]!=(d|0)){Ab(b+68|0,0,36)}f=j[b+20>>2];j[114630]=0;f=H(466,f|0)|0;g=j[114630];j[114630]=0;if((g|0)==1){break a}a=j[a+20>>2];j[114630]=0;a=H(466,a|0)|0;g=j[114630];j[114630]=0;if((g|0)==1){break a}Vb(f,a+c|0,d);a=l[b+34>>1];if(e){j[b+8>>2]=d;j[b+4>>2]=0;i[b+34>>1]=a|2;return}j[b+4>>2]=0;j[b+8>>2]=0;i[b+34>>1]=a&65533}return}J(0)|0;C()|0;ib();z()}function cO(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0;e=Za-80|0;Za=e;a:{if(j[b+4>>2]==j[d+4>>2]){f=j[b+4>>2];j[e+72>>2]=j[b>>2];j[e+76>>2]=f;b=j[c+4>>2];j[e+64>>2]=j[c>>2];j[e+68>>2]=b;b=vd(e+56|0,d);c=j[e+76>>2];j[e+8>>2]=j[e+72>>2];j[e+12>>2]=c;c=j[e+68>>2];j[e>>2]=j[e+64>>2];j[e+4>>2]=c;Pza(a,e+8|0,e,b);break a}f=j[b+4>>2];j[e+48>>2]=j[b>>2];j[e+52>>2]=f;b=j[c+4>>2];j[e+40>>2]=j[c>>2];j[e+44>>2]=b;b=vd(e+32|0,d);c=j[e+52>>2];j[e+24>>2]=j[e+48>>2];j[e+28>>2]=c;c=j[e+44>>2];j[e+16>>2]=j[e+40>>2];j[e+20>>2]=c;Oza(a,e+24|0,e+16|0,b)}Za=e+80|0}function u2(a,b){var c=0,d=0,e=0,f=0;c=Za-16|0;Za=c;j[c+12>>2]=0;gD(a,c+12|0,1);d=j[c+12>>2];e=d>>>2&3;h[c+11|0]=e;if(e){h[c+4|0]=3;d=k[Zb(c+4|0,c+11|0)|0];h[c+4|0]=0;h[c|0]=0;h[c+10|0]=0;a:{if(!d){break a}ch(a,c+4|0);if((d|0)==1){break a}ch(a,c);if(d>>>0<3){break a}ch(a,c+10|0);f=k[c+10|0]<<24}d=k[c+12|0]|k[c+4|0]<<8|k[c|0]<<16|f;j[c+12>>2]=d}j[c+4>>2]=d>>>4;j[c>>2]=1e6;rm(b,j[tb(c+4|0,c)>>2]);if(nb(b)){d=0;while(1){Aj(a,Ub(b,d),1);d=d+1|0;if(nb(b)>>>0>d>>>0){continue}break}}b=(j[c+12>>2]>>>4|0)-nb(b)|0;j[c+12>>2]=b;if(b){Lk(a,b,-1)}Za=c+16|0}function jqa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,l=0,m=0;d=Za-16|0;Za=d;j[d+12>>2]=c;j[d+8>>2]=j[a>>2]<<1;e=j[tb(d+8|0,d+12|0)>>2];j[d+8>>2]=j[a>>2]<<1;j[d+4>>2]=j[d+12>>2]-e;g=j[tb(d+8|0,d+4|0)>>2]>>>1|0;c=lb(b);h=e>>>1|0;if(h){f=j[a+20>>2];e=h;while(1){l=f,m=(lb(k[c|0])|lb(k[c+1|0])<<8)^32768,i[l>>1]=m;f=f+4|0;c=c+2|0;e=e-1|0;if(e){continue}break}}b=lb(b);if(g){f=j[a+20>>2]+2|0;c=b+(j[a>>2]<<1)|0;e=g;while(1){l=f,m=(lb(k[c|0])|lb(k[c+1|0])<<8)^32768,i[l>>1]=m;f=f+4|0;c=c+2|0;e=e-1|0;if(e){continue}break}}Za=d+16|0;return g+h<<1}function gqa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,l=0,m=0;d=Za-16|0;Za=d;j[d+12>>2]=c;j[d+8>>2]=j[a>>2]<<1;e=j[tb(d+8|0,d+12|0)>>2];j[d+8>>2]=j[a>>2]<<1;j[d+4>>2]=j[d+12>>2]-e;g=j[tb(d+8|0,d+4|0)>>2]>>>1|0;c=lb(b);h=e>>>1|0;if(h){f=j[a+20>>2];e=h;while(1){l=f,m=(lb(k[c+1|0])|lb(k[c|0])<<8)^32768,i[l>>1]=m;f=f+4|0;c=c+2|0;e=e-1|0;if(e){continue}break}}b=lb(b);if(g){f=j[a+20>>2]+2|0;c=b+(j[a>>2]<<1)|0;e=g;while(1){l=f,m=(lb(k[c+1|0])|lb(k[c|0])<<8)^32768,i[l>>1]=m;f=f+4|0;c=c+2|0;e=e-1|0;if(e){continue}break}}Za=d+16|0;return g+h<<1}function WX(){var a=0,b=0,c=0,d=0;a=Za-48|0;Za=a;j[114630]=0;b=E(2844,0,a+32|0)|0;c=j[114630];j[114630]=0;a:{b:{c:{if((c|0)==1){break c}if(b){j[114630]=0;a=j[114630];j[114630]=0;if((a|0)==1){break c}a=j[114604];j[114630]=0;F(2831,a|0,70905);a=j[114630];j[114630]=0;if((a|0)!=1){break b}break c}b=mq(a+16|0,a+32|0);j[a+4>>2]=j[a+36>>2]/1e3;c=mq(a+8|0,a+4|0);j[114630]=0;b=CB(2846,b,c);c=ab;d=j[114630];j[114630]=0;if((d|0)!=1){break a}}J(0)|0;C()|0;ib()}z()}j[a+24>>2]=b;j[a+28>>2]=c;b=Tj(a+40|0,a+24|0);c=j[b+4>>2];b=j[b>>2];Za=a+48|0;ab=c;return b}function Awa(a,b,c){var d=0,e=0,f=0;e=Za-16|0;Za=e;j[e+12>>2]=c;d=j[b+4>>2];a:{if(d){j[e+8>>2]=32-d;c=tb(e+8|0,e+12|0);d=j[b>>2];c=j[c>>2];f=j[d>>2]&(-1<<j[b+4>>2]&-1>>>j[e+8>>2]-c);if(f){Cc(a,d,GMa(f));break a}f=j[e+12>>2];if((f|0)==(c|0)){Ux(a,b,c);break a}c=f-c|0;j[e+12>>2]=c;j[b>>2]=d+4}if(c>>>0>=32){d=j[b>>2];while(1){f=j[d>>2];if(f){Cc(a,d,GMa(f));break a}d=d+4|0;j[b>>2]=d;c=c-32|0;j[e+12>>2]=c;if(c>>>0>31){continue}break}}b:{if(!c){d=j[b>>2];break b}d=j[b>>2];b=j[d>>2]&-1>>>32-c;if(!b){break b}Cc(a,d,GMa(b));break a}Cc(a,d,c)}Za=e+16|0}function Hoa(a,b,c){var d=0,e=0,f=0;e=Za-16|0;Za=e;a:{b:{if(c){d=k[b+861|0];c:{if(d){c=d-1|0;h[b+861|0]=c;if(c&255){break c}mb(e+8|0,a+1074308|0,16);if(!kb(e+8|0)){c=-1;if(j[a+480180>>2]!=2){break a}}j[b+804>>2]=j[a+1074424>>2]+1;break b}mb(e+8|0,a+1074308|0,17);if(!(kb(e+8|0)|j[a+480180>>2]&3|!l[a+480188>>1])){d=a+1074984|0;while(1){if(k[d+861|0]?(b|0)!=(d|0):0){break b}d=d+896|0;f=f+1|0;if(l[a+480188>>1]>(f&65535)>>>0){continue}break}}h[b+861|0]=c}c=j[b+804>>2];j[a+1074432>>2]=c;break a}j[b+804>>2]=j[a+1074424>>2]}c=-1}Za=e+16|0;return c}function dya(a,b,c){var d=0,e=0,f=0,g=0,m=0;d=Za-16|0;Za=d;md(b,1);j[b>>2]=c;h[b+37|0]=k[a+24|0]<<4;h[d+15|0]=k[a+25|0];h[d+14|0]=64;g=b,m=k[Zb(d+15|0,d+14|0)|0]<<2,i[g+30>>1]=m;c=a+26|0;c=k[c|0]|k[c+1|0]<<8;a=a+28|0;e=j[b>>2];a:{if(!e){break a}f=k[a|0]|k[a+1|0]<<8;a=(c<<8|c>>>8)&65535;j[b+4>>2]=a;c=(((f<<8|f>>>8)&65535)<<1)+a|0;j[b+8>>2]=c;if(a>>>0>=e>>>0){a=e-1|0;j[b+4>>2]=a}if(c>>>0>e>>>0){j[b+8>>2]=e;c=e}if(!(c-a>>>0>3?!(c>>>0<4|a>>>0>c>>>0):0)){j[b+4>>2]=0;j[b+8>>2]=0;break a}if(a>>>0>=c>>>0){break a}i[b+34>>1]=l[b+34>>1]|2}Za=d+16|0}function zya(a,b,c){var d=0,e=0,f=0,g=0,h=0,i=0;d=Za-80|0;Za=d;e=j[a+4>>2];f=j[b+4>>2];g=j[b>>2];j[d+72>>2]=g;j[d+76>>2]=f;h=j[c+4>>2];c=j[c>>2];j[d+64>>2]=c;j[d+68>>2]=h;j[d+24>>2]=g;j[d+28>>2]=f;j[d+16>>2]=c;j[d+20>>2]=h;b=xN(d+24|0,d+16|0)+j[a+4>>2]|0;j[a+4>>2]=b;if(!((b-1^e-1)>>>0<32?e:0)){i=j[a>>2];j[(b>>>0<33?i:i+(b-1>>>3&536870908)|0)>>2]=0}j[d+48>>2]=c;j[d+52>>2]=h;j[d+56>>2]=g;j[d+60>>2]=f;vn(d+40|0,a,e);a=j[d+60>>2];j[d+8>>2]=j[d+56>>2];j[d+12>>2]=a;a=j[d+52>>2];j[d>>2]=j[d+48>>2];j[d+4>>2]=a;cO(d+32|0,d+8|0,d,d+40|0);Za=d+80|0}function nga(a,b){var c=0,d=0,e=0,f=0,g=0,h=0,i=0,k=0,l=0,m=0,n=0,o=0;e=Za-16|0;Za=e;d=j[a+8>>2];c=j[a+12>>2];a:{if((c|0)<0){break a}if(i=1,k=(m=pb(a)>>>0<d>>>0,n=0,o=(c|0)>=0,o?m:n),l=(c|0)>0,l?i:k){break a}d=pb(a);f=j[a+8>>2];g=0-((d>>>0<f>>>0)+j[a+12>>2]|0)|0;c=e;j[c+8>>2]=d-f;j[c+12>>2]=g;i=c,k=Wg(b),j[i>>2]=k;j[c+4>>2]=0;c=cz(c+8|0,c);c=JQ(j[c>>2],j[c+4>>2]);if((c|0)!=(Wg(b)|0)){break a}Pe(j[b>>2],j[b>>2]+c|0,lb(j[a>>2]+j[a+8>>2]|0));b=a;d=c+j[a+8>>2]|0;a=j[a+12>>2];j[b+8>>2]=d;j[b+12>>2]=c>>>0>d>>>0?a+1|0:a;h=1}Za=e+16|0;return h}function ira(a,b,c){var d=0,e=0,f=0;e=Za-16|0;Za=e;j[e+12>>2]=c;d=j[b+4>>2];a:{if(d){j[e+8>>2]=32-d;c=tb(e+8|0,e+12|0);f=j[b>>2];c=j[c>>2];d=j[f>>2]&(-1<<d&-1>>>j[e+8>>2]-c);if(d){Cc(a,f,GMa(d));break a}d=j[e+12>>2];if((d|0)==(c|0)){gL(a,b,c);break a}c=d-c|0;j[e+12>>2]=c;j[b>>2]=f+4}if(c>>>0>=32){d=j[b>>2];while(1){f=j[d>>2];if(f){Cc(a,d,GMa(f));break a}d=d+4|0;j[b>>2]=d;c=c-32|0;j[e+12>>2]=c;if(c>>>0>31){continue}break}}b:{if(!c){d=j[b>>2];break b}d=j[b>>2];b=j[d>>2]&-1>>>32-c;if(!b){break b}Cc(a,d,GMa(b));break a}Cc(a,d,c)}Za=e+16|0}function aU(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0;d=Za-16|0;Za=d;j[d+12>>2]=j[j[a+1056>>2]>>2]-j[a+1060>>2];j[d+8>>2]=16384;e=j[tb(d+12|0,d+8|0)>>2];j[a+1068>>2]=e;j[d+4>>2]=17;a:{if(!e){break a}c=17;while(1){f=1<<c-1;e=ij(a,c);b:{c:{d:{if((c|0)<=6){if((e|0)!=(f|0)){break d}Mp(d+4|0,ij(a,4));break b}if((c|0)>16){break c}c=f-8|0;if((c|0)>(e|0)|(e|0)>(f+7|0)){break d}Mp(d+4|0,e-c|0);break b}vA(a,e,f,b);break b}c=e&(f^-1);if(e&f){j[d+4>>2]=c+1;break b}vA(a,c,0,b)}c=j[d+4>>2];if((c|0)>17){break a}if(j[a+1068>>2]){continue}break}}Za=d+16|0}function upa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=q(0),g=0,h=0,l=q(0),m=0,o=0;e=Za-16|0;Za=e;j[e+8>>2]=c>>>2;j[e+4>>2]=j[a>>2];g=j[tb(e+8|0,e+4|0)>>2];l=n[d>>2];b=lb(b);if(g){d=j[a+20>>2];c=g;while(1){a=k[b|0]|k[b+1|0]<<8|(k[b+2|0]<<16|k[b+3|0]<<24);n[e+12>>2]=l*(PMa(2,a<<24|a<<8&16711680|(a>>>8&65280|a>>>24)),TMa());Kd(e+12|0,q(-1));f=q(n[e+12>>2]*q(32768));n[e+12>>2]=f;a=d;f=Rd(f);a:{if(q(r(f))<q(2147483648)){h=~~f;break a}h=-2147483648}m=a,o=Dc(h),i[m>>1]=o;d=d+2|0;b=b+4|0;c=c-1|0;if(c){continue}break}}Za=e+16|0;return g<<2}function SAa(a,b){var c=0,d=0,e=0,f=0;f=64;while(1){c=b;d=k[c+4|0]|k[c+5|0]<<8|(k[c+6|0]<<16|k[c+7|0]<<24);e=k[c|0]|k[c+1|0]<<8|(k[c+2|0]<<16|k[c+3|0]<<24);h[a|0]=e;h[a+1|0]=e>>>8;h[a+2|0]=e>>>16;h[a+3|0]=e>>>24;h[a+4|0]=d;h[a+5|0]=d>>>8;h[a+6|0]=d>>>16;h[a+7|0]=d>>>24;d=k[c+12|0]|k[c+13|0]<<8|(k[c+14|0]<<16|k[c+15|0]<<24);c=k[c+8|0]|k[c+9|0]<<8|(k[c+10|0]<<16|k[c+11|0]<<24);h[a+8|0]=c;h[a+9|0]=c>>>8;h[a+10|0]=c>>>16;h[a+11|0]=c>>>24;h[a+12|0]=d;h[a+13|0]=d>>>8;h[a+14|0]=d>>>16;h[a+15|0]=d>>>24;a=a+16|0;f=f-1|0;if(f){continue}break}}function kEa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,i=0;d=Za-32|0;Za=d;g=d+8|0;e=b;i=e;if(AP(e,d+24|0)){f=d+26|0;f=k[f|0]|k[f+1|0]<<8|(k[f+2|0]<<16|k[f+3|0]<<24)}cd(g,i,f);e=k[d+24|0]|k[d+25|0]<<8|(k[d+26|0]<<16|k[d+27|0]<<24);h[a|0]=e;h[a+1|0]=e>>>8;h[a+2|0]=e>>>16;h[a+3|0]=e>>>24;e=k[d+28|0]|k[d+29|0]<<8;h[a+4|0]=e;h[a+5|0]=e>>>8;Fl(a+8|0,d+8|0);jb(d+8|0);a:{if(!c){break a}e=(f>>>0)%(c>>>0)|0;if(!e){break a}j[114630]=0;E(338,b|0,c-e|0)|0;b=j[114630];j[114630]=0;if((b|0)!=1){break a}b=D()|0;C()|0;Re(a);G(b|0);z()}Za=d+32|0}function Uka(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0;e=Za-32|0;Za=e;f=Hw(a);a:{b:{c:{d:{while(1){j[114630]=0;a=E(258,b|0,8)|0;g=j[114630];j[114630]=0;if((g|0)==1){break b}if(a){j[114630]=0;I(1549,e+8|0,b|0,c|0);a=j[114630];j[114630]=0;if((a|0)==1){break d}j[114630]=0;F(1550,f|0,e+8|0);a=j[114630];j[114630]=0;if((a|0)==1){break c}Re(e+8|0);a=jt(f);if((k[a|0]|k[a+1|0]<<8|(k[a+2|0]<<16|k[a+3|0]<<24))!=(d|0)){continue}}break}Za=e+32|0;return}a=D()|0;C()|0;break a}a=D()|0;C()|0;Re(e+8|0);break a}a=D()|0;C()|0}Zk(f);G(a|0);z()}function $T(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0;d=Za-16|0;Za=d;j[d+12>>2]=j[j[a+1056>>2]>>2]-j[a+1060>>2];j[d+8>>2]=32768;e=j[tb(d+12|0,d+8|0)>>2];j[a+1068>>2]=e;j[d+4>>2]=9;a:{if(!e){break a}c=9;while(1){f=1<<c-1;e=ij(a,c);b:{c:{d:{if((c|0)<=6){if((e|0)!=(f|0)){break d}Mp(d+4|0,ij(a,3));break b}if((c|0)>8){break c}c=f-4|0;if((c|0)>(e|0)|(e|0)>(f+3|0)){break d}Mp(d+4|0,e-c|0);break b}uA(a,e,f,b);break b}c=e&(f^-1);if(e&f){j[d+4>>2]=c+1;break b}uA(a,c,0,b)}c=j[d+4>>2];if((c|0)>9){break a}if(j[a+1068>>2]){continue}break}}Za=d+16|0}function hta(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,k=0,m=0,n=0;c=Za-16|0;Za=c;f=l[nk(a,b)>>1];a:{if(!Po(a,b)){break a}d=j[a+24>>2]+484360|0;m=c,n=Lb(d),j[m+8>>2]=n;m=c,n=Mb(d),j[m>>2]=n;if(!rb(c+8|0,c)){break a}h=f&65535;while(1){b:{g=j[c+8>>2];k=kt(g);if(k){e=0;while(1){if(!(!((a|0)!=(g|0)|(b|0)!=(e|0))|l[bc(g,e)>>1]!=(h|0))){d=yI(j[a+24>>2]+484344|0,h,0);if((d|0)!=65535){break b}}e=e+1|0;if((k|0)!=(e|0)){continue}break}}Jx(c+8|0);if(rb(c+8|0,c)){continue}break a}break}m=nk(a,b),n=d,i[m>>1]=n;f=d}Za=c+16|0;return f&65535}function Z0(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0;a=Za-32|0;Za=a;i[a+28>>1]=k[64464]|k[64465]<<8;j[a+24>>2]=k[64460]|k[64461]<<8|(k[64462]<<16|k[64463]<<24);vj(a+24|1,64452,1,j[c+4>>2]);g=j[c+4>>2];f=a-16|0;Za=f;h=Wd();j[a>>2]=e;e=g>>>9&1;g=Je(f,e+13|0,h,a+24|0,a)+f|0;h=Sf(f,g,c);e=f-((e<<3)+107&112)|0;Za=e;hc(a+8|0,c);j[114630]=0;Z(2475,f|0,h|0,g|0,e|0,a+20|0,a+16|0,a+8|0);f=j[114630];j[114630]=0;if((f|0)!=1){wb(a+8|0);b=_l(b,e,j[a+20>>2],j[a+16>>2],c,d);Za=a+32|0;return b|0}b=D()|0;C()|0;wb(a+8|0);G(b|0);z()}function NKa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0;d=Za-208|0;Za=d;Kz(c,a);mS(c,d+16|0,p(k[a+4|0],3));a:{if(k[a+4|0]<2){break a}h[d+12|0]=64;Nf(b,k[Zb(a+4|0,d+12|0)|0]);h[b+13|0]=k[a+2|0];h[b+14|0]=k[a+3|0];a=k[a+1|0];h[b+15|0]=a;h[b+16|0]=a;if(!sb(b)){break a}a=0;while(1){if(a){c=l[xb(b,a-1|0)>>1];j[d+12>>2]=1;e=(d+16|0)+p(a,3)|0;j[d+8>>2]=(h[e+1|0]&1)<<8|k[e|0];e=l[zf(d+12|0,d+8|0)>>1];f=xb(b,a),g=c+e|0,i[f>>1]=g}c=k[((d+16|0)+p(a,3)|0)+2|0];f=xb(b,a),g=c,h[f+2|0]=g;a=a+1|0;if(sb(b)>>>0>a>>>0){continue}break}}Za=d+208|0}function oza(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0;e=Za-32|0;Za=e;f=gy(a);a:{b:{c:{d:{while(1){j[114630]=0;a=E(258,b|0,8)|0;g=j[114630];j[114630]=0;if((g|0)==1){break b}if(a){j[114630]=0;I(968,e+8|0,b|0,c|0);a=j[114630];j[114630]=0;if((a|0)==1){break d}j[114630]=0;F(969,f|0,e+8|0);a=j[114630];j[114630]=0;if((a|0)==1){break c}Re(e+8|0);a=jt(f);if((k[a|0]|k[a+1|0]<<8|(k[a+2|0]<<16|k[a+3|0]<<24))!=(d|0)){continue}}break}Za=e+32|0;return}a=D()|0;C()|0;break a}a=D()|0;C()|0;Re(e+8|0);break a}a=D()|0;C()|0}kl(f);G(a|0);z()}function fea(a){a=a|0;var b=0,c=0;b=Za-32|0;Za=b;a:{b:{if(!a){a=Gd(34181);break b}j[114630]=0;c=E(85,b|0,a|0)|0;a=j[114630];j[114630]=0;c:{d:{if((a|0)!=1){j[114630]=0;F(1988,b+16|0,c|0);a=j[114630];j[114630]=0;if((a|0)==1){break d}a=Gd(zb(b+16|0));gb(b+16|0);gb(c);break b}a=J(0)|0;C()|0;break c}a=J(0)|0;C()|0;gb(c)}O(a|0)|0;a=0;j[114630]=0;L(1984,34182,0,0,0);c=j[114630];j[114630]=0;if((c|0)==1){break a}Q()}Za=b+32|0;return a|0}a=D()|0;C()|0;j[114630]=0;M(20);b=j[114630];j[114630]=0;if((b|0)!=1){G(a|0);z()}J(0)|0;C()|0;ib();z()}function Jka(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,l=0,m=0;d=Za-32|0;Za=d;vg(d,2,a+6|0);qc(d+16|0,d);j[114630]=0;E(369,b+492|0,d+16|0)|0;e=j[114630];j[114630]=0;if((e|0)!=1){gb(d+16|0);f=b+236|0;g=c+1|0;c=0;e=0;while(1){h=k[(a+c|0)+38|0];l=Nc(f,c),m=g+h|0,i[l>>1]=m;e=e+1|0;c=e&255;if(c>>>0<128){continue}break}c=a+226|0;j[b>>2]=(k[c|0]|k[c+1|0]<<8)<<5;Gw(a+180|0,b+48|0,0);Gw(a+228|0,b+88|0,2);Gw(a+276|0,b+68|0,1);a=a+324|0;if(!(k[a|0]|k[a+1|0]<<8)){Ab(b+236|0,0,256)}Za=d+32|0;return}a=D()|0;C()|0;gb(d+16|0);G(a|0);z()}function zca(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;g=Za-16|0;Za=g;j[114630]=0;N(2010,a|0);h=j[114630];j[114630]=0;a:{b:{if((h|0)!=1){c:{h=j[a+24>>2];j[114630]=0;Z(2069,g|0,h|0,b|0,c|0,d|0,e|0,(f|0)!=0|0);b=j[114630];j[114630]=0;if((b|0)==1){break c}b=Gd(zb(g));gb(g);break b}}b=J(0)|0;C()|0;O(b|0)|0;b=0;j[114630]=0;L(1984,36860,a|0,0,0);a=j[114630];j[114630]=0;if((a|0)==1){break a}Q()}Za=g+16|0;return b|0}a=D()|0;C()|0;j[114630]=0;M(20);b=j[114630];j[114630]=0;if((b|0)!=1){G(a|0);z()}J(0)|0;C()|0;ib();z()}function kqa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,l=0,m=0;d=Za-16|0;Za=d;j[d+12>>2]=c;j[d+8>>2]=j[a>>2]<<1;e=j[tb(d+8|0,d+12|0)>>2];j[d+8>>2]=j[a>>2]<<1;j[d+4>>2]=j[d+12>>2]-e;g=j[tb(d+8|0,d+4|0)>>2]>>>1|0;c=lb(b);h=e>>>1|0;if(h){f=j[a+20>>2];e=h;while(1){l=f,m=lb(k[c|0])|lb(k[c+1|0])<<8,i[l>>1]=m;f=f+4|0;c=c+2|0;e=e-1|0;if(e){continue}break}}b=lb(b);if(g){f=j[a+20>>2]+2|0;c=b+(j[a>>2]<<1)|0;e=g;while(1){l=f,m=lb(k[c|0])|lb(k[c+1|0])<<8,i[l>>1]=m;f=f+4|0;c=c+2|0;e=e-1|0;if(e){continue}break}}Za=d+16|0;return g+h<<1}function hqa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,l=0,m=0;d=Za-16|0;Za=d;j[d+12>>2]=c;j[d+8>>2]=j[a>>2]<<1;e=j[tb(d+8|0,d+12|0)>>2];j[d+8>>2]=j[a>>2]<<1;j[d+4>>2]=j[d+12>>2]-e;g=j[tb(d+8|0,d+4|0)>>2]>>>1|0;c=lb(b);h=e>>>1|0;if(h){f=j[a+20>>2];e=h;while(1){l=f,m=lb(k[c+1|0])|lb(k[c|0])<<8,i[l>>1]=m;f=f+4|0;c=c+2|0;e=e-1|0;if(e){continue}break}}b=lb(b);if(g){f=j[a+20>>2]+2|0;c=b+(j[a>>2]<<1)|0;e=g;while(1){l=f,m=lb(k[c+1|0])|lb(k[c|0])<<8,i[l>>1]=m;f=f+4|0;c=c+2|0;e=e-1|0;if(e){continue}break}}Za=d+16|0;return g+h<<1}function Aca(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;g=Za-16|0;Za=g;j[114630]=0;N(2010,a|0);h=j[114630];j[114630]=0;a:{b:{if((h|0)!=1){c:{h=j[a+24>>2];j[114630]=0;Z(2068,g|0,h|0,b|0,c|0,d|0,e|0,(f|0)!=0|0);b=j[114630];j[114630]=0;if((b|0)==1){break c}b=Gd(zb(g));gb(g);break b}}b=J(0)|0;C()|0;O(b|0)|0;b=0;j[114630]=0;L(1984,36818,a|0,0,0);a=j[114630];j[114630]=0;if((a|0)==1){break a}Q()}Za=g+16|0;return b|0}a=D()|0;C()|0;j[114630]=0;M(20);b=j[114630];j[114630]=0;if((b|0)!=1){G(a|0);z()}J(0)|0;C()|0;ib();z()}function GO(a){var b=0,c=0,d=0,e=0,f=0,g=0,h=0,i=0;c=rBa(a);a:{if(c>>>0>5){break a}while(1){b=p(d,30)+a|0;c=qBa(b+20|0)+c|0;if(c>>>0>48){break a}e=b+45|0;if(k[b+44|0]|k[e|0]>64){break a}b=b+42|0;f=k[b|0]|k[b+1|0]<<8;if(((f<<8|f>>>8)&65535)>>>0>32768){break a}b=k[b|0]|k[b+1|0]<<8;g=((b<<8|b>>>8)&65535)+g|0;h=k[e|0]|h;d=d+1|0;if((d|0)!=15){continue}break}if(!g|!(h&255)){break a}b=a+470|0;if(k[b|0]>128){break a}c=a+471|0;if(k[c|0]>220){break a}a=a+472|0;a=k[_Aa(a,a+128|0)|0];if(a>>>0>63|(a|k[b|0]?0:!k[c|0])){break a}i=1}return i}function yu(a,b,c){var d=0,e=0,f=0;d=Za+ -64|0;Za=d;f=j[a>>2];e=j[f-4>>2];f=j[f-8>>2];j[d+20>>2]=0;j[d+16>>2]=b;j[d+12>>2]=a;j[d+8>>2]=c;b=0;Ab(d+24|0,0,39);a=a+f|0;a:{if(Qf(e,c,0)){j[d+56>>2]=1;bb[j[j[e>>2]+20>>2]](e,d+8|0,a,a,1,0);b=j[d+32>>2]==1?a:0;break a}bb[j[j[e>>2]+24>>2]](e,d+8|0,a,1,0);b:{switch(j[d+44>>2]){case 0:b=j[d+48>>2]==1?j[d+36>>2]==1?j[d+40>>2]==1?j[d+28>>2]:0:0:0;break a;case 1:break b;default:break a}}if(j[d+32>>2]!=1){if(j[d+48>>2]|j[d+36>>2]!=1|j[d+40>>2]!=1){break a}}b=j[d+24>>2]}Za=d- -64|0;return b}function zK(a,b,c){var d=0,e=0,f=0;d=Za-16|0;Za=d;a:{if(b){h[c|0]=b;break a}b=k[c|0]}b=j[a+480180>>2]&1048580?b&240?b&-16:b&15:b;c=b&240;e=b&255;b=b&15;b:{c:{d:{if(!(!c|(b|0)!=15)){if(!(k[a+480209|0]&16)){break b}b=e>>>3&30;break d}f=j[a+480208>>2]&4096;if(!(!b|(c|0)!=240)){if(!f){break b}b=0-(b<<1)|0;break c}if(f){break b}if(c){if(j[a+480180>>2]&59314208?b:0){break b}b=e>>>3&30;break d}b=0-(b<<1)|0}if(!b){break b}}c=a+1074444|0;j[d+12>>2]=j[c>>2]+(b<<!(j[a+480180>>2]&59314208));Md(d+12|0,0,256);j[c>>2]=j[d+12>>2]}Za=d+16|0}function Qq(a,b,c,d,e,f){var g=0,h=0,i=0,k=0;g=Za-240|0;Za=g;h=j[c>>2];j[g+232>>2]=h;c=j[c+4>>2];j[g>>2]=a;j[g+236>>2]=c;k=1;a:{b:{c:{if(!(c|(h|0)!=1)){c=a;break c}h=a;while(1){i=(d<<2)+f|0;c=h-j[i>>2]|0;if((bb[b|0](c,a)|0)<1){c=h;break c}d:{if(!((d|0)<2|e)){e=j[i-8>>2];i=h-4|0;if((bb[b|0](i,c)|0)>-1){break d}if((bb[b|0](i-e|0,c)|0)>-1){break d}}j[(k<<2)+g>>2]=c;e=tE(g+232|0);Rq(g+232|0,e);k=k+1|0;d=d+e|0;e=0;h=c;if(j[g+236>>2]|j[g+232>>2]!=1){continue}break b}break}c=h;break b}if(e){break a}}sE(g,k);tv(c,b,d,f)}Za=g+240|0}function uma(a){var b=0,c=0,d=0,e=0,f=0,g=0,h=0;c=j[a+24620>>2];c=ic(IMa(HMa(c,c>>31,100,0),ab,1e3,0),ab);a:{if(!c){break a}e=c>>>0<1048576?c:1048576;j[a+1074380>>2]=e;b=l[a+480212>>1];if(!b){break a}h=b>>>0>1?b:1;f=a+1074376|0;b=0;while(1){a=p(l[((b<<1)+f|0)+90>>1],896)+f|0;d=a+1280|0;j[d>>2]=0;j[d+4>>2]=0;j[a+708>>2]=e;d=j[a+632>>2]<<12;j[a+648>>2]=d;g=j[a+628>>2]<<12;j[a+644>>2]=g;j[a+696>>2]=j[a+696>>2]|65536;j[a+636>>2]=(0-g|0)/(e|0);j[a+640>>2]=(0-d|0)/(e|0);b=b+1|0;if((h|0)!=(b|0)){continue}break}}return(c|0)!=0}function Xta(a,b,c){var d=0,e=0,f=0,g=0;e=Za-32|0;Za=e;j[e+24>>2]=b;b=j[a>>2];f=e,g=Lb(a),j[f>>2]=g;b=b+(Ks(e+24|0,e)<<2)|0;a:{b:{if(m[a+4>>2]<m[hb(a)>>2]){d=j[a+4>>2];if((d|0)!=(b|0)){break b}EP(a,c);break a}d=hb(a);d=wn(e,ie(a,sb(a)+1|0),b-j[a>>2]>>2,d);j[114630]=0;F(1154,d|0,c|0);c=j[114630];j[114630]=0;c:{if((c|0)==1){break c}j[114630]=0;b=K(1155,a|0,d|0,b|0)|0;a=j[114630];j[114630]=0;if((a|0)==1){break c}xh(d);break a}a=D()|0;C()|0;xh(d);G(a|0);z()}Tta(a,b,d,b+4|0);i[b>>1]=l[c>>1];h[b+2|0]=k[c+2|0]}Qe(b);Za=e+32|0}function TX(){var a=0,b=0,c=0,d=0;a=Za-48|0;Za=a;j[114630]=0;b=E(2844,1,a+32|0)|0;c=j[114630];j[114630]=0;a:{b:{c:{if((c|0)==1){break c}if(b){j[114630]=0;a=j[114630];j[114630]=0;if((a|0)==1){break c}a=j[114604];j[114630]=0;F(2831,a|0,70942);a=j[114630];j[114630]=0;if((a|0)!=1){break b}break c}b=mq(a+16|0,a+32|0);c=mq(a+8|0,a+32|4);j[114630]=0;b=CB(2847,b,c);c=ab;d=j[114630];j[114630]=0;if((d|0)!=1){break a}}J(0)|0;C()|0;ib()}z()}j[a+24>>2]=b;j[a+28>>2]=c;b=Tj(a+40|0,a+24|0);c=j[b+4>>2];b=j[b>>2];Za=a+48|0;ab=c;return b}function xK(a,b,c){var d=0,e=0;a:{if(j[a+480180>>2]==4){d=k[b+834|0];if(c){h[b+834|0]=d&240|c&15;break a}c=d&15;break a}if(j[a+480180>>2]!=1048576){break a}if(c){h[b+833|0]=c;break a}c=k[b+833|0]}b:{if(!(h[b+872|0]&1)|!(c&255)){break b}d=j[b+700>>2];if(!d){break b}c:{if(!(k[a+480208|0]&16)){break c}d=j[b+700>>2];if(j[a+480180>>2]==4){break c}e=b;a=nK(a,c&15);b=HMa(a,a>>31,d,d>>31)+32768|0;a=ab;a=ic(IMa(b,b>>>0<32768?a+1|0:a,65536,0),ab);j[e+700>>2]=a-((a|0)==(d|0));return}a=(c&255)+d|0;j[b+700>>2]=(a|0)<65535?a:65535}}function k1(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0;a=Za-32|0;Za=a;i[a+28>>1]=k[64464]|k[64465]<<8;j[a+24>>2]=k[64460]|k[64461]<<8|(k[64462]<<16|k[64463]<<24);vj(a+24|1,64452,1,j[c+4>>2]);g=j[c+4>>2];f=a-16|0;Za=f;h=Wd();j[a>>2]=e;g=Je(f,(g>>>9&1)+13|0,h,a+24|0,a)+f|0;h=Sf(f,g,c);e=f-32|0;Za=e;hc(a+8|0,c);j[114630]=0;Z(2466,f|0,h|0,g|0,e|0,a+20|0,a+16|0,a+8|0);f=j[114630];j[114630]=0;if((f|0)!=1){wb(a+8|0);b=Dl(b,e,j[a+20>>2],j[a+16>>2],c,d);Za=a+32|0;return b|0}b=D()|0;C()|0;wb(a+8|0);G(b|0);z()}function mza(a){a=a|0;var b=0,c=0,d=0,e=0;b=Za-16|0;Za=b;h[b+15|0]=128;d=it(a,127,b+15|0);j[114630]=0;h[b+14|0]=64;e=K(881,a+12|0,127,b+14|0)|0;c=j[114630];j[114630]=0;a:{b:{if((c|0)!=1){j[114630]=0;h[b+13|0]=0;K(970,a+24|0,127,b+13|0)|0;c=j[114630];j[114630]=0;if((c|0)==1){break b}j[a+36>>2]=-1;j[a+40>>2]=108855296;h[a+44|0]=0;h[a+45|0]=0;h[a+46|0]=0;h[a+47|0]=0;h[a+48|0]=0;h[a+49|0]=0;h[a+50|0]=0;h[a+51|0]=0;h[a+52|0]=0;h[a+53|0]=0;Za=b+16|0;return a|0}a=D()|0;C()|0;break a}a=D()|0;C()|0;Od(e)}Od(d);G(a|0);z()}function lj(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,i=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;e=Za-16|0;Za=e;j[b>>2]=0;j[b+4>>2]=0;h[e+15|0]=0;i=Dg(a,e+15|0);g=k[e+15|0];j[b>>2]=(g&252)>>>2;j[b+4>>2]=0;c=g&3;if(c){n=(c|0)==1?1:-1<<c^-1;while(1){h[e+15|0]=0;o=Dg(a,e+15|0);d=j[b>>2];p=j[b+4>>2];l=k[e+15|0];c=f;f=m+1|0;c=f>>>0<1?c+1|0:c;m=f;f=c;g=b;q=b;r=d;c=(m<<3)-2|0;d=c&31;if((c&63)>>>0>=32){c=l<<d;d=0}else{c=(1<<d)-1&l>>>32-d;d=l<<d}j[q>>2]=r|d;j[g+4>>2]=c|p;i=i&o;if((m|0)!=(n|0)|f){continue}break}}Za=e+16|0;return i|0}function mBa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;d=Za-528|0;Za=d;c=-1;a:{if(!jf(a,1468)){break a}Yj(a,1464);PO(a,d+524|0);if(!Jd(d+524|0,16026)){c=0;if(!Jd(d+524|0,16031)){break a}}Yj(a,20);b=1;while(1){c=-1;if(!MO(a,d)){break a}e=wy(d)+e|0;c=b&65535;b=b+1|0;if(c>>>0<31){continue}break}c=0;if(e>>>0>40){break a}RAa(a,d+520|0);e=Pc(d+520|0);c=0;if(k[d+520|0]>128){break a}lBa(a,d);a=d+512|0;b=d;c=k[e|0];b:{while(1){if(c>>>0<k[b|0]){break b}b=b+1|0;if((a|0)!=(b|0)){continue}break}c=1;break a}c=0}Za=d+528|0;return c|0}function M8(a){var b=0,c=0,d=0,e=0;b=Za-160|0;Za=b;a=om(b+16|0,a,8);c=j[j[a>>2]-12>>2];j[114630]=0;d=T(122)|0;e=j[114630];j[114630]=0;a:{if((e|0)==1){break a}j[114630]=0;I(123,b+8|0,c+(b+16|0)|0,d|0);c=j[114630];j[114630]=0;if((c|0)==1){break a}wb(b+8|0);j[114630]=0;c=E(178,a|0,b|0)|0;d=j[114630];j[114630]=0;if((d|0)==1){break a}d=j[j[c>>2]-12>>2];j[114630]=0;c=H(174,c+d|0)|0;d=j[114630];j[114630]=0;if((d|0)==1){break a}d=j[b+4>>2];e=j[b>>2];Xe(a);Za=b+160|0;ab=c?0:d;return c?0:e}b=D()|0;C()|0;Xe(a);G(b|0);z()}function g1(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0;a=Za-32|0;Za=a;i[a+28>>1]=k[64464]|k[64465]<<8;j[a+24>>2]=k[64460]|k[64461]<<8|(k[64462]<<16|k[64463]<<24);vj(a+24|1,64452,0,j[c+4>>2]);g=j[c+4>>2];f=a-16|0;Za=f;h=Wd();j[a>>2]=e;g=Je(f,g>>>9&1|12,h,a+24|0,a)+f|0;h=Sf(f,g,c);e=f-32|0;Za=e;hc(a+8|0,c);j[114630]=0;Z(2466,f|0,h|0,g|0,e|0,a+20|0,a+16|0,a+8|0);f=j[114630];j[114630]=0;if((f|0)!=1){wb(a+8|0);b=Dl(b,e,j[a+20>>2],j[a+16>>2],c,d);Za=a+32|0;return b|0}b=D()|0;C()|0;wb(a+8|0);G(b|0);z()}function cla(a,b){var c=0,d=0,e=0,f=0,g=0,l=0;d=Za-16|0;Za=d;e=a+206|0;j[b>>2]=k[e|0]|k[e+1|0]<<8;XI(a,b+48|0,k[a+192|0],k[a+200|0],k[a+194|0],k[a+195|0],k[a+196|0],0);XI(a,b+68|0,k[a+193|0],k[a+201|0],k[a+197|0],k[a+198|0],k[a+199|0],1);e=b+236|0;while(1){f=k[a+c|0];g=Nc(e,c+12|0),l=f,i[g>>1]=l;c=c+1|0;if((c|0)!=96){continue}break}if(k[a+208|0]){h[b+31|0]=k[a+209|0]+1;ala(b+31|0);c=a+210|0;i[d+14>>1]=k[c|0]|k[c+1|0]<<8;i[d+12>>1]=127;g=b,l=k[gf(d+14|0,d+12|0)|0]+1|0,h[g+30|0]=l}h[b+33|0]=k[a+212|0];Za=d+16|0}function W0(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0;a=Za-32|0;Za=a;i[a+28>>1]=k[64464]|k[64465]<<8;j[a+24>>2]=k[64460]|k[64461]<<8|(k[64462]<<16|k[64463]<<24);vj(a+24|1,64452,0,j[c+4>>2]);g=j[c+4>>2];f=a-16|0;Za=f;h=Wd();j[a>>2]=e;g=Je(f,g>>>9&1|12,h,a+24|0,a)+f|0;h=Sf(f,g,c);e=f-96|0;Za=e;hc(a+8|0,c);j[114630]=0;Z(2475,f|0,h|0,g|0,e|0,a+20|0,a+16|0,a+8|0);f=j[114630];j[114630]=0;if((f|0)!=1){wb(a+8|0);b=_l(b,e,j[a+20>>2],j[a+16>>2],c,d);Za=a+32|0;return b|0}b=D()|0;C()|0;wb(a+8|0);G(b|0);z()}function Nx(a,b){var c=0,d=0,e=0,f=0;c=Za-16|0;Za=c;a:{if(Xc(a)){break a}i[j[a>>2]>>1]=0;ze(j[a>>2]+2|0,b);e=c,f=Lb(a),j[e>>2]=f;e=c,f=So(c,1),j[e+8>>2]=f;e=c,f=Mb(a),j[e>>2]=f;if(!rb(c+8|0,c)){break a}while(1){d=j[c+8>>2];e=c,f=xM(c+8|0,1),j[e>>2]=f;d=l[vi(d,j[c>>2])>>1];i[j[c+8>>2]>>1]=d;ze(j[c+8>>2]+2|0,b);XS(c+8|0);e=c,f=Mb(a),j[e>>2]=f;if(rb(c+8|0,c)){continue}break}}ze(a+14|0,sb(a)-1&255);ze(a+13|0,k[a+14|0]);ze(a+16|0,sb(a)-1&255);ze(a+15|0,k[a+16|0]);if(k[a+17|0]!=255){ze(a+17|0,sb(a)-1&255)}Za=c+16|0}function Cka(a,b,c,d,e){var f=0,g=0,i=0;f=Za-16|0;Za=f;j[f+8>>2]=e;j[f+12>>2]=c;g=j[tb(f+12|0,f+8|0)>>2];a:{b:{if(!g){c=b;break b}e=g;c=b;while(1){i=k[d|0];h[c|0]=i;if(!i){break a}d=d+1|0;c=c+1|0;e=e-1|0;if(e){continue}break}}e=0}c:{d:{e:{switch(a-1|0){case 0:case 1:d=j[f+12>>2];h[f+7|0]=0;Cr(c,((c+d|0)-g|0)+e|0,f+7|0);break d;case 2:case 3:break e;default:break c}}d=j[f+12>>2];h[f+6|0]=32;Cr(c,((c+d|0)-g|0)+e|0,f+6|0)}f:{switch(a-1|0){case 0:case 3:break f;default:break c}}h[(j[f+12>>2]+b|0)-1|0]=0}Za=f+16|0}function Cca(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0;f=Za-16|0;Za=f;j[114630]=0;N(2010,a|0);g=j[114630];j[114630]=0;a:{b:{if((g|0)!=1){c:{g=j[a+24>>2];j[114630]=0;aa(2066,f|0,g|0,b|0,c|0,d|0,e|0);b=j[114630];j[114630]=0;if((b|0)==1){break c}b=Gd(zb(f));gb(f);break b}}b=J(0)|0;C()|0;O(b|0)|0;b=0;j[114630]=0;L(1984,36715,a|0,0,0);a=j[114630];j[114630]=0;if((a|0)==1){break a}Q()}Za=f+16|0;return b|0}a=D()|0;C()|0;j[114630]=0;M(20);b=j[114630];j[114630]=0;if((b|0)!=1){G(a|0);z()}J(0)|0;C()|0;ib();z()}function Bca(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0;f=Za-16|0;Za=f;j[114630]=0;N(2010,a|0);g=j[114630];j[114630]=0;a:{b:{if((g|0)!=1){c:{g=j[a+24>>2];j[114630]=0;aa(2067,f|0,g|0,b|0,c|0,d|0,e|0);b=j[114630];j[114630]=0;if((b|0)==1){break c}b=Gd(zb(f));gb(f);break b}}b=J(0)|0;C()|0;O(b|0)|0;b=0;j[114630]=0;L(1984,36765,a|0,0,0);a=j[114630];j[114630]=0;if((a|0)==1){break a}Q()}Za=f+16|0;return b|0}a=D()|0;C()|0;j[114630]=0;M(20);b=j[114630];j[114630]=0;if((b|0)!=1){G(a|0);z()}J(0)|0;C()|0;ib();z()}function yX(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;if(Qf(a,j[b+8>>2],e)){vu(b,c,d);return}a:{if(Qf(a,j[b>>2],e)){if(!(j[b+20>>2]!=(c|0)?j[b+16>>2]!=(c|0):0)){if((d|0)!=1){break a}j[b+32>>2]=1;return}j[b+32>>2]=d;b:{if(j[b+44>>2]==4){break b}i[b+52>>1]=0;a=j[a+8>>2];bb[j[j[a>>2]+20>>2]](a,b,c,c,1,e);if(k[b+53|0]){j[b+44>>2]=3;if(!k[b+52|0]){break b}break a}j[b+44>>2]=4}j[b+20>>2]=c;j[b+40>>2]=j[b+40>>2]+1;if(j[b+36>>2]!=1|j[b+24>>2]!=2){break a}h[b+54|0]=1;return}a=j[a+8>>2];bb[j[j[a>>2]+24>>2]](a,b,c,d,e)}}function GT(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;oF(b);a:{if(!(k[a|0]|k[a+1|0]<<8)){c=a+2|0;if(!(k[c|0]|k[c+1|0]<<8)){break a}}j[b+20>>2]=((k[a|0]|k[a+1|0]<<8)>>>9|0)+80;d=b,e=Gb((k[a|0]|k[a+1|0]<<8)>>>5&15,1,12)-1|0,j[d+16>>2]=e;d=b,e=Gb((k[a|0]|k[a+1|0]<<8)&31,1,31),j[d+12>>2]=e;c=a+2|0;d=b,e=Gb((k[c|0]|k[c+1|0]<<8)>>>11|0,0,23),j[d+8>>2]=e;d=b,e=Gb((k[c|0]|k[c+1|0]<<8)>>>5&63,0,59),j[d+4>>2]=e;d=b,e=Gb((k[c|0]|k[c+1|0]<<8)<<1&62,0,59),j[d>>2]=e}a=a+4|0;j[b+44>>2]=k[a|0]|k[a+1|0]<<8|(k[a+2|0]<<16|k[a+3|0]<<24)}function GGa(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,m=0,n=0;f=Za-32|0;Za=f;j[f+28>>2]=c;h=yb(b,c<<2);a:{if(!h){break a}jc(f+28|0,65535);bg(a,l[f+28>>1]);m=f,n=Lb(a),j[m+16>>2]=n;m=f,n=Mb(a),j[m+8>>2]=n;if(!rb(f+16|0,f+8|0)){break a}while(1){a=j[f+16>>2];Us(b,f+24|0);c=f+24|0;c=k[c|0]|k[c+1|0]<<8|(k[c+2|0]<<16|k[c+3|0]<<24);i[a>>1]=c;c=c&65535;g=65535;b:{c:{if((c|0)==(d|0)){break c}if((c|0)!=(e|0)){break b}g=65534}i[a>>1]=g}je(f+16|0);if(rb(f+16|0,f+8|0)){continue}break}}Za=f+32|0;return h|0}function R0(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,l=0;a=Za-208|0;Za=a;i[a+204>>1]=k[64470]|k[64471]<<8;j[a+200>>2]=k[64466]|k[64467]<<8|(k[64468]<<16|k[64469]<<24);f=Wd();j[a>>2]=e;h=Je(a+176|0,20,f,a+200|0,a);e=h+(a+176|0)|0;f=Sf(a+176|0,e,c);hc(a+8|0,c);j[114630]=0;g=H(2450,a+8|0)|0;l=j[114630];j[114630]=0;if((l|0)!=1){wb(a+8|0);aD(g,a+176|0,e,a+16|0);g=b;b=(a+16|0)+(h<<2)|0;b=_l(g,a+16|0,(e|0)==(f|0)?b:((f-a<<2)+a|0)-688|0,b,c,d);Za=a+208|0;return b|0}b=D()|0;C()|0;wb(a+8|0);G(b|0);z()}function hm(a,b,c,d,e,f){var g=0,h=0,i=0,k=0;a:{if(f&64){c=f+ -64|0;b=c&31;if((c&63)>>>0>=32){c=0;b=e>>>b|0}else{c=e>>>b|0;b=((1<<b)-1&e)<<32-b|d>>>b}d=0;e=0;break a}if(!f){break a}h=e;i=d;k=64-f|0;g=k&31;if((k&63)>>>0>=32){h=i<<g;k=0}else{h=(1<<g)-1&i>>>32-g|h<<g;k=i<<g}i=b;g=f;b=g&31;if((g&63)>>>0>=32){g=0;b=c>>>b|0}else{g=c>>>b|0;b=((1<<b)-1&c)<<32-b|i>>>b}b=k|b;c=g|h;g=d;d=f&31;if((f&63)>>>0>=32){h=0;d=e>>>d|0}else{h=e>>>d|0;d=((1<<d)-1&e)<<32-d|g>>>d}e=h}j[a>>2]=b;j[a+4>>2]=c;j[a+8>>2]=d;j[a+12>>2]=e}function Tw(a,b,c){var d=0,e=0;e=Za-16|0;Za=e;mb(e+8|0,a+1074308|0,21);a:{if(kb(e+8|0)){c=c&255;b:{switch((b&3)-1|0){default:d=h[c+21616|0];break a;case 0:d=64-(c+1>>>1|0)|0;break a;case 1:d=(c>>>0<128)<<6;break a;case 2:break b}}d=nJ(Em(a))+ -64|0;break a}d=h[(c>>>1&31)+20720|0];if(j[a+480180>>2]&67633152){break a}a=c&63;c:{switch((b&3)-1|0){default:d=h[a+21488|0];break a;case 0:d=(a>>>0<32?0:255)-(a<<2)|0;break a;case 1:d=a>>>0<32?127:-127;break a;case 2:break c}}d=h[a+21552|0]}a=d;Za=e+16|0;return a}function Mqa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0;e=Za-16|0;Za=e;f=Cb(a);a:{b:{c:{if(ec(b)){a=0;while(1){d:{if(!a){break d}j[114630]=0;E(1245,f|0,c|0)|0;d=j[114630];j[114630]=0;if((d|0)!=1){break d}a=D()|0;C()|0;break a}d=ad(b,a);j[114630]=0;F(1246,e|0,d|0);d=j[114630];j[114630]=0;if((d|0)==1){break c}j[114630]=0;E(1245,f|0,e|0)|0;d=j[114630];j[114630]=0;if((d|0)==1){break b}gb(e);a=a+1|0;if(ec(b)>>>0>a>>>0){continue}break}}Za=e+16|0;return}a=D()|0;C()|0;break a}a=D()|0;C()|0;gb(e)}gb(f);G(a|0);z()}function Qw(a,b,c,d){var e=0,f=0,g=0,h=0,j=0,k=0;h=Za-16|0;Za=h;a:{if((c|0)<2){break a}k=(c-2|0)/2|0;f=d-a|0;if((k|0)<f>>1){break a}g=f+1|0;e=(g<<1)+a|0;f=f+2|0;if((f|0)<(c|0)){j=po(b,l[e>>1],l[e+2>>1]);e=j?e+2|0:e;g=j?f:g}if(po(b,l[e>>1],l[d>>1])){break a}i[h+14>>1]=l[d>>1];while(1){b:{f=e;i[d>>1]=l[e>>1];if((g|0)>(k|0)){break b}d=g<<1;g=d|1;e=(g<<1)+a|0;d=d+2|0;if((d|0)<(c|0)){j=po(b,l[e>>1],l[e+2>>1]);e=j?e+2|0:e;g=j?d:g}d=f;if(!po(b,l[e>>1],l[h+14>>1])){continue}}break}i[f>>1]=l[h+14>>1]}Za=h+16|0}function sda(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;j[114630]=0;N(2010,a|0);d=j[114630];j[114630]=0;a:{if((d|0)==1){break a}j[114630]=0;N(2021,c|0);d=j[114630];j[114630]=0;if((d|0)==1){break a}d=j[a+24>>2];j[114630]=0;b=E(2022,d|0,b|0)|0;d=j[114630];j[114630]=0;if((d|0)==1){break a}j[c>>2]=b;return 1}b=J(0)|0;C()|0;O(b|0)|0;j[114630]=0;L(1984,35262,a|0,0,0);a=j[114630];j[114630]=0;if((a|0)!=1){Q();return 0}a=D()|0;C()|0;j[114630]=0;M(20);b=j[114630];j[114630]=0;if((b|0)!=1){G(a|0);z()}J(0)|0;C()|0;ib();z()}function g2(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0;e=Za-16|0;Za=e;a:{b:{c:{if((a|0)!=(b|0)){g=j[114604];j[114604]=0;a=hD(a,e+12|0,d,Wd());d=ab;f=j[114604];d:{if(f){if(j[e+12>>2]!=(b|0)){break d}if((f|0)==68){break b}break c}j[114604]=g;if(j[e+12>>2]==(b|0)){break c}}}j[c>>2]=4;b=0;break a}if(((d|0)<-1?1:(d|0)<=-1?a>>>0<2147483648:0)|((d|0)>0?1:(d|0)>=0?a>>>0>2147483647:0)){break b}b=a;break a}j[c>>2]=4;b=2147483647;if((d|0)>0?1:(d|0)>=0?a>>>0>=1:0){break a}b=-2147483648}Za=e+16|0;return b|0}function U8(a){var b=0,c=0,d=0,e=0;b=Za-160|0;Za=b;a=om(b+16|0,a,8);d=j[j[a>>2]-12>>2];j[114630]=0;c=T(122)|0;e=j[114630];j[114630]=0;a:{if((e|0)==1){break a}j[114630]=0;I(123,b+8|0,d+(b+16|0)|0,c|0);d=j[114630];j[114630]=0;if((d|0)==1){break a}wb(b+8|0);j[114630]=0;d=E(177,a|0,b+6|0)|0;c=j[114630];j[114630]=0;if((c|0)==1){break a}c=j[j[d>>2]-12>>2];j[114630]=0;d=H(174,c+d|0)|0;c=j[114630];j[114630]=0;if((c|0)==1){break a}c=l[b+6>>1];Xe(a);Za=b+160|0;return(d?0:c)&65535}b=D()|0;C()|0;Xe(a);G(b|0);z()}function Jpa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,l=0,m=0;e=Za-16|0;Za=e;j[e+8>>2]=c>>>3;j[e+4>>2]=j[a>>2];d=j[tb(e+8|0,e+4|0)>>2];b=lb(b);if(d){a=j[a+20>>2];c=d;while(1){g=k[b+4|0]|k[b+5|0]<<8|(k[b+6|0]<<16|k[b+7|0]<<24);j[e+8>>2]=k[b|0]|k[b+1|0]<<8|(k[b+2|0]<<16|k[b+3|0]<<24);j[e+12>>2]=g;wf(e+8|0,-1,1);f=o[e+8>>3]*32768;o[e+8>>3]=f;g=a;f=zd(f);a:{if(r(f)<2147483648){h=~~f;break a}h=-2147483648}l=g,m=Dc(h),i[l>>1]=m;a=a+2|0;b=b+8|0;c=c-1|0;if(c){continue}break}}Za=e+16|0;return d<<3}function Mpa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=q(0),h=0,l=0,m=0;e=Za-16|0;Za=e;j[e+8>>2]=c>>>2;j[e+4>>2]=j[a>>2];d=j[tb(e+8|0,e+4|0)>>2];b=lb(b);if(d){c=j[a+20>>2];a=d;while(1){f=k[b|0]|k[b+1|0]<<8|(k[b+2|0]<<16|k[b+3|0]<<24);j[e+12>>2]=f<<24|f<<8&16711680|(f>>>8&65280|f>>>24);Kd(e+12|0,q(-1));g=q(n[e+12>>2]*q(32768));n[e+12>>2]=g;f=c;g=Rd(g);a:{if(q(r(g))<q(2147483648)){h=~~g;break a}h=-2147483648}l=f,m=Dc(h),i[l>>1]=m;c=c+2|0;b=b+4|0;a=a-1|0;if(a){continue}break}}Za=e+16|0;return d<<2}function nW(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0;e=Za-16|0;Za=e;f=Qc(a);a:{b:{c:{if(ec(b)){a=0;while(1){d:{if(!a){break d}j[114630]=0;E(192,f|0,c|0)|0;d=j[114630];j[114630]=0;if((d|0)!=1){break d}a=D()|0;C()|0;break a}d=ad(b,a);j[114630]=0;F(252,e|0,d|0);d=j[114630];j[114630]=0;if((d|0)==1){break c}j[114630]=0;E(192,f|0,e|0)|0;d=j[114630];j[114630]=0;if((d|0)==1){break b}gb(e);a=a+1|0;if(ec(b)>>>0>a>>>0){continue}break}}Za=e+16|0;return}a=D()|0;C()|0;break a}a=D()|0;C()|0;gb(e)}gb(f);G(a|0);z()}function wv(a,b){var c=0,d=0,e=0,f=0,g=0,h=0;e=Za-16|0;Za=e;f=(SMa(a),OMa(2));c=f&2147483647;a:{if(c>>>0<=1305022426){g=+a;d=g*.6366197723675814+6755399441055744+ -6755399441055744;o[b>>3]=g+d*-1.5707963109016418+d*-1.5893254773528196e-8;if(r(d)<2147483648){c=~~d;break a}c=-2147483648;break a}if(c>>>0>=2139095040){o[b>>3]=q(a-a);c=0;break a}h=c;c=(c>>>23|0)-150|0;o[e+8>>3]=(PMa(2,h-(c<<23)|0),TMa());c=EE(e+8|0,e,c,1,0);d=o[e>>3];if((f|0)<=-1){o[b>>3]=-d;c=0-c|0;break a}o[b>>3]=d}Za=e+16|0;return c}function $0(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,l=0;a=Za-96|0;Za=a;i[a+92>>1]=k[64470]|k[64471]<<8;j[a+88>>2]=k[64466]|k[64467]<<8|(k[64468]<<16|k[64469]<<24);f=Wd();j[a>>2]=e;h=Je(a- -64|0,20,f,a+88|0,a);e=h+(a- -64|0)|0;f=Sf(a- -64|0,e,c);hc(a+8|0,c);j[114630]=0;g=H(21,a+8|0)|0;l=j[114630];j[114630]=0;if((l|0)!=1){wb(a+8|0);dD(g,a- -64|0,e,a+16|0);g=b;b=(a+16|0)+h|0;b=Dl(g,a+16|0,(e|0)==(f|0)?b:((f-a|0)+a|0)-48|0,b,c,d);Za=a+96|0;return b|0}b=D()|0;C()|0;wb(a+8|0);G(b|0);z()}function mM(a,b){var c=0,d=0,e=0,f=0,g=0,i=0,l=0,m=0,n=0;n=b?33:32;f=j[a+8>>2];c=f-1|0;d=j[a+12>>2];g=j[a>>2]+p(d,31)|0;i=b?1:-1;e=i;while(1){b=0;if((d|0)>0){while(1){h[b+g|0]=k[j[a+4>>2]+(p(c,d)+b|0)|0];b=b+1|0;d=j[a+12>>2];if((b|0)<(d|0)){continue}break}f=j[a+8>>2]}b=p(d,i);l=f-1|0;a:{if(!((l|0)!=(c|0)|(e|0)<1)){if(!k[a+16|0]){e=1;c=0;break a}e=-1;c=c-((c|0)!=0&k[a+17|0]!=0)|0;break a}if(!((e|0)>-1|c)){c=k[a+16|0];e=c?1:-1;c=c?0:l;break a}c=c+e|0}g=b+g|0;m=m+1|0;if((n|0)!=(m|0)){continue}break}}function Ro(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=l[a+34>>1];if(!b){b=a;if(d&512){qM(a);d=l[a+34>>1]}i[b+34>>1]=d&65023;return}j[a>>2]=4;i[a+34>>1]=d&64958|512;Qo(a);b=k[c+8|0]|k[c+9|0]<<8|(k[c+10|0]<<16|k[c+11|0]<<24);h[a+76|0]=b;h[a+77|0]=b>>>8;h[a+78|0]=b>>>16;h[a+79|0]=b>>>24;b=k[c+4|0]|k[c+5|0]<<8|(k[c+6|0]<<16|k[c+7|0]<<24);c=k[c|0]|k[c+1|0]<<8|(k[c+2|0]<<16|k[c+3|0]<<24);h[a+68|0]=c;h[a+69|0]=c>>>8;h[a+70|0]=c>>>16;h[a+71|0]=c>>>24;h[a+72|0]=b;h[a+73|0]=b>>>8;h[a+74|0]=b>>>16;h[a+75|0]=b>>>24}function Mta(a,b){var c=0,d=0,e=0;jc(a,65536);jc(a+4|0,64);jc(a+8|0,256);Rf(a+28|0,16384);ze(a+30|0,128);ze(a+31|0,17);if(k[a+16|0]>=4){h[a+16|0]=0}if(k[a+17|0]>=5){h[a+17|0]=0}if(k[a+18|0]>=3){h[a+18|0]=0}ze(a+19|0,64);ze(a+20|0,100);Rta(a+26|0);ze(a+23|0,64);ze(a+24|0,64);Nx(a+48|0,64);Nx(a+68|0,64);Nx(a+88|0,(b|0)==4096?255:64);c=a+108|0;b=0;while(1){a:{if(k[Pb(c,b)|0]){if(k[Pb(c,b)|0]<121){break a}}d=Pb(c,b),e=b+1|0,h[d|0]=e}b=b+1|0;if(b>>>0<128){continue}break}if(!un(k[a+14|0])){h[a+14|0]=5}}function vK(a,b,c,d){var e=0,f=0,g=0;e=Za-16|0;Za=e;a:{b:{c:{f=!d;d=c>>31;d=d+c^d;if(f|d>>>0<224){break c}mb(e+8|0,a+1074308|0,3);if(kb(e+8|0)){break c}if(!(h[(p(b,896)+a|0)+1075856|0]&1)){break a}c=p((c>>31)+((c|0)>0)|0,d&15);c=d>>>0>239?c<<2:c;break b}if(h[(p(b,896)+a|0)+1075856|0]&1){mb(e+8|0,a+1074308|0,3);if(!kb(e+8|0)){break a}}c=c<<2}if(!c){break a}d=lx(a,b);if(!d){break a}f=d;a=j[(p(b,896)+a|0)+1075640>>2];g=13;d:{if(!a){break d}g=k[a+33|0]}bb[j[j[d>>2]+80>>2]](f,c,g<<24>>24,b)}Za=e+16|0}function qr(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0;d=Za-32|0;Za=d;e=a;c=j[b>>2];f=j[b+8>>2];c=c&24576?c:j[b+4>>2]?(f|0)!=-1?c&-12289|8192:c:c;b=143;a:{b:{if(c&1){break b}if(!(c&2)){break a}b=144}_v(e,b)}c:{if(c&4096){break c}if(c&8192){g=d,h=Qe(4),j[g+24>>2]=h;lG(a,d+24|0);break c}if(!(c&16384)){break c}g=d,h=Qe(256),j[g+16>>2]=h;lG(a,d+16|0)}b=a;d:{if(c&16){e=145}else{if(!(c&32)){break d}e=146}_v(b,e)}if((f|0)!=-1){g=d,h=Qe(f),j[g+8>>2]=h;j[(j[j[a>>2]-12>>2]+a|0)+8>>2]=j[d+8>>2]}Za=d+32|0}function eKa(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,m=0,n=0;f=Za-32|0;Za=f;j[f+28>>2]=c;h=yb(b,c<<1);a:{if(!h){break a}jc(f+28|0,65535);bg(a,l[f+28>>1]);m=f,n=Lb(a),j[m+16>>2]=n;m=f,n=Mb(a),j[m+8>>2]=n;if(!rb(f+16|0,f+8|0)){break a}while(1){a=j[f+16>>2];Lz(b,f+24|0);c=f+24|0;c=k[c|0]|k[c+1|0]<<8;c=c<<8|c>>>8;i[a>>1]=c;c=c&65535;g=65535;b:{c:{if((c|0)==(d|0)){break c}if((c|0)!=(e|0)){break b}g=65534}i[a>>1]=g}je(f+16|0);if(rb(f+16|0,f+8|0)){continue}break}}Za=f+32|0;return h|0}function YF(a){var b=0,c=0,d=0,e=0;b=Za-160|0;Za=b;a=om(b+16|0,a,8);d=j[j[a>>2]-12>>2];j[114630]=0;c=T(122)|0;e=j[114630];j[114630]=0;a:{if((e|0)==1){break a}j[114630]=0;I(123,b+8|0,d+(b+16|0)|0,c|0);d=j[114630];j[114630]=0;if((d|0)==1){break a}wb(b+8|0);j[114630]=0;d=E(173,a|0,b+4|0)|0;c=j[114630];j[114630]=0;if((c|0)==1){break a}c=j[j[d>>2]-12>>2];j[114630]=0;d=H(174,c+d|0)|0;c=j[114630];j[114630]=0;if((c|0)==1){break a}c=j[b+4>>2];Xe(a);Za=b+160|0;return d?0:c}b=D()|0;C()|0;Xe(a);G(b|0);z()}function We(a,b,c,d,e,f){var g=0,h=0,i=0,k=0;a:{if(f&64){d=b;e=f+ -64|0;b=e&31;if((e&63)>>>0>=32){e=d<<b;d=0}else{e=(1<<b)-1&d>>>32-b|c<<b;d=d<<b}b=0;c=0;break a}if(!f){break a}g=d;i=f;d=f&31;if((f&63)>>>0>=32){h=g<<d;k=0}else{h=(1<<d)-1&g>>>32-d|e<<d;k=g<<d}d=c;g=b;f=64-f|0;e=f&31;if((f&63)>>>0>=32){f=0;d=d>>>e|0}else{f=d>>>e|0;d=((1<<e)-1&d)<<32-e|g>>>e}d=k|d;e=f|h;f=b;b=i&31;if((i&63)>>>0>=32){h=f<<b;b=0}else{h=(1<<b)-1&f>>>32-b|c<<b;b=f<<b}c=h}j[a>>2]=b;j[a+4>>2]=c;j[a+8>>2]=d;j[a+12>>2]=e}function C8(a){var b=0,c=0,d=0,e=0,f=0;b=Za-160|0;Za=b;a=om(b+16|0,a,8);c=j[j[a>>2]-12>>2];j[114630]=0;d=T(122)|0;e=j[114630];j[114630]=0;a:{if((e|0)==1){break a}j[114630]=0;I(123,b+8|0,c+(b+16|0)|0,d|0);c=j[114630];j[114630]=0;if((c|0)==1){break a}wb(b+8|0);j[114630]=0;c=E(179,a|0,b|0)|0;d=j[114630];j[114630]=0;if((d|0)==1){break a}d=j[j[c>>2]-12>>2];j[114630]=0;c=H(174,c+d|0)|0;d=j[114630];j[114630]=0;if((d|0)==1){break a}f=o[b>>3];Xe(a);Za=b+160|0;return c?0:f}b=D()|0;C()|0;Xe(a);G(b|0);z()}function Ppa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0;e=Za-16|0;Za=e;j[e+12>>2]=c>>>4;j[e+8>>2]=j[a>>2];d=j[tb(e+12|0,e+8|0)>>2];b=lb(b);if(d){a=j[a+20>>2];c=d;while(1){lb(k[b|0]);lb(k[b+1|0]);lb(k[b+2|0]);lb(k[b+3|0]);lb(k[b+4|0]);lb(k[b+5|0]);f=a,g=lb(k[b+6|0])|lb(k[b+7|0])<<8,i[f>>1]=g;lb(k[b+8|0]);lb(k[b+9|0]);lb(k[b+10|0]);lb(k[b+11|0]);lb(k[b+12|0]);lb(k[b+13|0]);f=a,g=lb(k[b+14|0])|lb(k[b+15|0])<<8,i[f+2>>1]=g;a=a+4|0;b=b+16|0;c=c-1|0;if(c){continue}break}}Za=e+16|0;return d<<4}function Opa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0;e=Za-16|0;Za=e;j[e+12>>2]=c>>>4;j[e+8>>2]=j[a>>2];d=j[tb(e+12|0,e+8|0)>>2];b=lb(b);if(d){a=j[a+20>>2];c=d;while(1){lb(k[b+7|0]);lb(k[b+6|0]);lb(k[b+5|0]);lb(k[b+4|0]);lb(k[b+3|0]);lb(k[b+2|0]);f=a,g=lb(k[b+1|0])|lb(k[b|0])<<8,i[f>>1]=g;lb(k[b+15|0]);lb(k[b+14|0]);lb(k[b+13|0]);lb(k[b+12|0]);lb(k[b+11|0]);lb(k[b+10|0]);f=a,g=lb(k[b+9|0])|lb(k[b+8|0])<<8,i[f+2>>1]=g;a=a+4|0;b=b+16|0;c=c-1|0;if(c){continue}break}}Za=e+16|0;return d<<4}function R9(a){a=a|0;var b=0,c=0,d=0,e=0,f=0;b=Za-32|0;Za=b;a:{b:{if(Ph(a)){go(b+24|0);break b}qm(b+8|0,a);j[114630]=0;F(2169,b+24|0,b+8|0);c=j[114630];j[114630]=0;if((c|0)==1){break a}Ye(b+8|0)}c=a+36|0;c:{if(Ph(a)){break c}c=j[b+24>>2]}a=j[a+8>>2];d:{if((a|0)==-1){e=b,f=Lb(c),j[e+8>>2]=f;e=b,f=Mb(c),j[e>>2]=f;if(!rb(b+8|0,b)){break d}while(1){d=o[j[b+8>>2]>>3]+d;gk(b+8|0);if(rb(b+8|0,b)){continue}break}break d}d=o[zc(c,a)>>3]}Gj(b+24|0);Za=b+32|0;return+d}a=D()|0;C()|0;Ye(b+8|0);G(a|0);z()}function vpa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=q(0),g=0,h=q(0),l=0,m=0,o=0;e=Za-16|0;Za=e;j[e+8>>2]=c>>>2;j[e+4>>2]=j[a>>2];c=j[tb(e+8|0,e+4|0)>>2];h=n[d>>2];b=lb(b);if(c){a=j[a+20>>2];d=c;while(1){n[e+12>>2]=h*(PMa(2,k[b|0]|k[b+1|0]<<8|(k[b+2|0]<<16|k[b+3|0]<<24)),TMa());Kd(e+12|0,q(-1));f=q(n[e+12>>2]*q(32768));n[e+12>>2]=f;l=a;f=Rd(f);a:{if(q(r(f))<q(2147483648)){g=~~f;break a}g=-2147483648}m=l,o=Dc(g),i[m>>1]=o;a=a+2|0;b=b+4|0;d=d-1|0;if(d){continue}break}}Za=e+16|0;return c<<2}function U1(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0;e=Za-16|0;Za=e;a:{b:{c:{if((a|0)!=(b|0)){d:{e:{f=k[a|0];if((f|0)!=45){break e}a=a+1|0;if((b|0)!=(a|0)){break e}break d}h=j[114604];j[114604]=0;a=Wu(a,e+12|0,d,Wd());d=ab;g=j[114604];f:{if(g){if(j[e+12>>2]!=(b|0)){break f}if((g|0)==68){break c}break b}j[114604]=h;if(j[e+12>>2]==(b|0)){break b}}}}j[c>>2]=4;a=0;b=0;break a}j[c>>2]=4;a=-1;b=-1;break a}b=a;c=(f|0)==45;a=c?0-a|0:a;b=c?0-(d+((b|0)!=0)|0)|0:d}Za=e+16|0;ab=b;return a|0}function Goa(a,b){var c=0,d=0,e=0,f=0,g=0,h=0;c=Za-16|0;Za=c;j[c+8>>2]=b;d=j[a+8>>2];a:{if((j[a+480180>>2]&16392?1e4:32e4)>>>0<=b>>>0){b=j[a+480208>>2];mb(c,a+1074308|0,92);if((kb(c)|0)==((b&4096)>>>12|0)){break a}j[c>>2]=p(j[d+24>>2],1e4);g=a+1074420|0,h=j[tb(c+8|0,c)>>2],j[g>>2]=h;break a}if(k[a+480209|0]&16){break a}e=a+1074420|0;b=(b>>>0)/1e4|0;f=p(b&15,1e4);j[e>>2]=j[e>>2]+((b&240)==16?f:0-f|0);b=j[d+20>>2];d=j[d+24>>2];mb(c,a+1074308|0,8);An(e,p(b,1e4),kb(c)?255e4:p(d,1e4))}Za=c+16|0}function k7(a,b,c,d,e){var f=0,g=0,h=0,k=0,l=0,m=0,n=0,p=0,q=0,s=0;h=Za-16|0;Za=h;if(e){m=c+16|0;while(1){k=0;if(d){while(1){g=zd(o[Kg(b,k,l)>>3]*134217728);f=Ae(c,k);n=f;f=Xi(g)+(j[f>>2]>>1)|0;p=f;f=ar(m)+f&-4096;j[n>>2]=p-f;o[h+8>>3]=+(f|0)*7.450580596923828e-9;wf(h+8|0,-1,1);g=o[h+8>>3]*32768;o[h+8>>3]=g;g=zd(g);a:{if(r(g)<2147483648){f=~~g;break a}f=-2147483648}f=Dc(f);q=lm(a,k,l),s=f,i[q>>1]=s;k=k+1|0;if((k|0)!=(d|0)){continue}break}}l=l+1|0;if((l|0)!=(e|0)){continue}break}}Za=h+16|0}function gS(a,b,c){var d=0,e=0,f=0;d=Za+ -64|0;Za=d;Ce(b);De(d+40|0,a,c);a=j[d+40>>2];j[114630]=0;e=H(412,d+40|0)|0;f=j[114630];j[114630]=0;a:{if((f|0)==1){break a}j[114630]=0;e=H(413,e|0)|0;f=j[114630];j[114630]=0;if((f|0)==1){break a}j[114630]=0;L(414,d+8|0,3,e|0,a|0);e=j[114630];j[114630]=0;if((e|0)==1){break a}j[114630]=0;F(415,d+24|0,d+8|0);e=j[114630];j[114630]=0;if((e|0)==1){break a}ob(b,d+24|0);gb(d+24|0);lc(d+40|0);Za=d- -64|0;return!c|(a|0)!=0}a=D()|0;C()|0;lc(d+40|0);G(a|0);z()}function O7(a,b,c,d,e){var f=0,g=0,h=0,k=0,l=0,m=0,n=0,p=0,q=0,s=0;h=Za-16|0;Za=h;if(e){m=c+16|0;while(1){k=0;if(d){while(1){g=zd(o[Kg(b,k,l)>>3]*134217728);f=Ae(c,k);n=f;f=Xi(g)+(j[f>>2]>>1)|0;p=f;f=ar(m)+f&-4096;j[n>>2]=p-f;o[h+8>>3]=+(f|0)*7.450580596923828e-9;wf(h+8|0,-1,1);g=o[h+8>>3]*32768;o[h+8>>3]=g;g=zd(g);a:{if(r(g)<2147483648){f=~~g;break a}f=-2147483648}f=Dc(f);q=nm(a,k,l),s=f,i[q>>1]=s;k=k+1|0;if((k|0)!=(d|0)){continue}break}}l=l+1|0;if((l|0)!=(e|0)){continue}break}}Za=h+16|0}function MR(a,b,c){var d=0,e=0,f=0;d=Za+ -64|0;Za=d;Ce(b);De(d+40|0,a,c);a=j[d+40>>2];j[114630]=0;e=H(412,d+40|0)|0;f=j[114630];j[114630]=0;a:{if((f|0)==1){break a}j[114630]=0;e=H(413,e|0)|0;f=j[114630];j[114630]=0;if((f|0)==1){break a}j[114630]=0;L(414,d+8|0,2,e|0,a|0);e=j[114630];j[114630]=0;if((e|0)==1){break a}j[114630]=0;F(415,d+24|0,d+8|0);e=j[114630];j[114630]=0;if((e|0)==1){break a}ob(b,d+24|0);gb(d+24|0);lc(d+40|0);Za=d- -64|0;return!c|(a|0)!=0}a=D()|0;C()|0;lc(d+40|0);G(a|0);z()}function _l(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0,k=0;i=Za-16|0;Za=i;a:{b:{if(!a){break b}h=j[e+12>>2];g=c-b|0;if((g|0)>=1){g=g>>2;if((Cl(a,b,g)|0)!=(g|0)){break b}}b=d-b>>2;b=(b|0)<(h|0)?h-b|0:0;if((b|0)>=1){f=$C(i,b,f);h=zb(f);j[114630]=0;h=K(2478,a|0,h|0,b|0)|0;g=j[114630];j[114630]=0;if((g|0)==1){break a}pc(f);if((b|0)!=(h|0)){break b}}b=d-c|0;if((b|0)>=1){b=b>>2;if((Cl(a,c,b)|0)!=(b|0)){break b}}_x(e);k=a}Za=i+16|0;return k|0}a=D()|0;C()|0;pc(f);G(a|0);z()}function UG(a){var b=q(0),c=q(0),d=q(0),e=q(0),f=q(0),g=0;YK(a+4208|0,n[a+4272>>2]);b=q(q(n[a+4208>>2]*q(15920))+q(80));g=we(j[a+16>>2]);c=Yd(q(10),q(q(q(n[a+4216>>2]*q(30))+q(-15))*q(.02500000037252903)));b=q(q(b*q(6.2831854820251465))/q(g>>>0));d=FE(b);e=ao(b);d=q(d*Q4(q(q(q(b*q(.02888113260269165))*q(q(n[a+4212>>2]*q(35))+q(1)))/d)));f=q(d/c);b=q(f+q(1));n[a+4236>>2]=q(q(1)-f)/b;e=q(q(e*q(-2))/b);n[a+4232>>2]=e;c=q(d*c);n[a+4228>>2]=q(q(1)-c)/b;n[a+4224>>2]=e;n[a+4220>>2]=q(c+q(1))/b}function HW(a){a=a|0;var b=0,c=0,d=0,e=0;b=Za-32|0;Za=b;c=Db(b,7035);j[114630]=0;I(226,b+16|0,a|0,c|0);a=j[114630];j[114630]=0;a:{b:{c:{if((a|0)!=1){gb(c);if(ec(b+16|0)){break c}a=0;break a}d=D()|0;C()|0;gb(c);break b}a=0;while(1){d:{c=ad(b+16|0,d);j[114630]=0;c=H(227,c|0)|0;e=j[114630];j[114630]=0;if((e|0)==1){break d}a=(c&255)<<24-(d<<3)|a;c=ec(b+16|0);if(d>>>0>2){break a}d=d+1|0;if(c>>>0>d>>>0){continue}break a}break}d=D()|0;C()|0;Rk(b+16|0)}G(d|0);z()}Rk(b+16|0);Za=b+32|0;return a|0}function Pva(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,i=0,k=0,l=0;b=Za-16|0;Za=b;i=j[a+24>>2];k=j[a+20>>2];l=j[a+16>>2];f=j[a+4>>2];e=f;g=j[a>>2];j[b+8>>2]=g;j[b+12>>2]=e;f=j[a+12>>2];j[b>>2]=j[a+8>>2];j[b+4>>2]=f;if(d){while(1){f=e+l|0;e=h[f|0];e=((p(h[f+1|0]-e|0,g>>>10&4194048)|0)/16384|0)+(e<<8)|0;j[c>>2]=j[c>>2]+p(e,k);j[c+4>>2]=j[c+4>>2]+p(e,i);Bb(b+8|0,b);d=d-1|0;if(d){c=c+8|0;g=j[b+8>>2];e=j[b+12>>2];continue}break}g=j[b+8>>2];e=j[b+12>>2]}j[a>>2]=g;j[a+4>>2]=e;Za=b+16|0}function yMa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0;e=vh(b,11882);a:{if(!e){break a}if(!yb(b,6)){break a}while(1){b:{d=hf(b);c:{if((d|0)==(ok(11887)|0)){break c}c=k[11892]|k[11893]<<8|(k[11894]<<16|k[11895]<<24);if(!(d&1616928864)|d&-2139062144){break c}if((c|0)!=(d|0)){break b}}cg(b,4);break a}c=1;g=Of(b);if(l[a+480192>>1]){while(1){f=j[(((c&65535)<<2)+a|0)+900380>>2];if(f){AMa(f,d,g,b)}c=c+1|0;if(l[a+480192>>1]>=(c&65535)>>>0){continue}break}}if(yb(b,6)){continue}break}}return e|0}function X0(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0;a=Za-32|0;Za=a;j[a+24>>2]=37;j[a+28>>2]=0;vj(a+24|1,64454,1,j[c+4>>2]);h=j[c+4>>2];g=a-32|0;Za=g;i=Wd();j[a>>2]=e;j[a+4>>2]=f;e=h>>>9&1;f=Je(g,e+23|0,i,a+24|0,a)+g|0;h=Sf(g,f,c);e=g-((e<<3)+187&240)|0;Za=e;hc(a+8|0,c);j[114630]=0;Z(2475,g|0,h|0,f|0,e|0,a+20|0,a+16|0,a+8|0);f=j[114630];j[114630]=0;if((f|0)!=1){wb(a+8|0);b=_l(b,e,j[a+20>>2],j[a+16>>2],c,d);Za=a+32|0;return b|0}b=D()|0;C()|0;wb(a+8|0);G(b|0);z()}function V0(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0;a=Za-32|0;Za=a;j[a+24>>2]=37;j[a+28>>2]=0;vj(a+24|1,64454,0,j[c+4>>2]);h=j[c+4>>2];g=a-32|0;Za=g;i=Wd();j[a>>2]=e;j[a+4>>2]=f;e=h>>>9&1;f=Je(g,e+23|0,i,a+24|0,a)+g|0;h=Sf(g,f,c);e=g-((e<<3)+187&240)|0;Za=e;hc(a+8|0,c);j[114630]=0;Z(2475,g|0,h|0,f|0,e|0,a+20|0,a+16|0,a+8|0);f=j[114630];j[114630]=0;if((f|0)!=1){wb(a+8|0);b=_l(b,e,j[a+20>>2],j[a+16>>2],c,d);Za=a+32|0;return b|0}b=D()|0;C()|0;wb(a+8|0);G(b|0);z()}function nM(a,b){var c=0,d=0,e=0,f=0,g=0,h=0,m=0,n=0,o=0,q=0,r=0;m=b?33:32;e=j[a+8>>2]-1|0;n=e-((e|0)!=0&k[a+17|0]!=0)|0;f=j[a+12>>2];g=j[a>>2]+p(f,62)|0;d=b?1:-1;o=p(f,d)<<1;c=e;while(1){if((f|0)>=1){q=p(c,f);r=j[a+4>>2];b=0;while(1){i[(b<<1)+g>>1]=l[(b+q<<1)+r>>1];b=b+1|0;if((f|0)!=(b|0)){continue}break}}a:{if(!((c|0)!=(e|0)|(d|0)<=0)){b=k[a+16|0];d=b?-1:1;c=b?n:0;break a}if(!((d|0)>-1|c)){b=k[a+16|0];d=b?1:-1;c=b?0:e;break a}c=d+c|0}g=g+o|0;h=h+1|0;if((m|0)!=(h|0)){continue}break}}function Ova(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,k=0,l=0;b=Za-16|0;Za=b;h=j[a+24>>2];k=j[a+20>>2];l=j[a+16>>2];f=j[a+4>>2];e=f;g=j[a>>2];j[b+8>>2]=g;j[b+12>>2]=e;f=j[a+12>>2];j[b>>2]=j[a+8>>2];j[b+4>>2]=f;if(d){while(1){f=(e<<1)+l|0;e=i[f>>1];e=e+((p(i[f+2>>1]-e|0,g>>>18|0)|0)/16384|0)|0;j[c>>2]=j[c>>2]+p(e,k);j[c+4>>2]=j[c+4>>2]+p(e,h);Bb(b+8|0,b);d=d-1|0;if(d){c=c+8|0;g=j[b+8>>2];e=j[b+12>>2];continue}break}g=j[b+8>>2];e=j[b+12>>2]}j[a>>2]=g;j[a+4>>2]=e;Za=b+16|0}function M5(a,b,c,d,e,f){var g=0,h=0,i=0,l=q(0),m=0,o=0,p=q(0),r=q(0),s=0;h=k[c|0];if(h){s=k[d+1|0]&8?7:64;m=c;while(1){o=k[d+3|0]&32;a:{b:{if(j[((i>>>0)%3<<2)+e>>2]>=(i|0)){break b}g=k[b+i|0];if(g>>>0>=s>>>0){break b}p=o?q(1.4142135381698608):q(1);c:{if(k[d+1|0]&8){g=g<<3;l=n[g+48672>>2];r=n[(g|4)+48672>>2];break c}l=Gv(q(1),g+1>>>1<<f);g=g&1;r=g?q(1):l;l=g?l:q(1)}K5(a,h,q(l*p),q(r*p));break a}if(!o){break a}ZE(a,h)}a=(k[m|0]<<2)+a|0;i=i+1|0;m=i+c|0;h=k[m|0];if(h){continue}break}}}function a2(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0;e=Za-16|0;Za=e;a:{b:{c:{d:{if((a|0)!=(b|0)){e:{f:{f=k[a|0];if((f|0)!=45){break f}a=a+1|0;if((b|0)!=(a|0)){break f}break e}h=j[114604];j[114604]=0;a=Wu(a,e+12|0,d,Wd());d=ab;g=j[114604];g:{if(g){if(j[e+12>>2]!=(b|0)){break g}if((g|0)==68){break c}break d}j[114604]=h;if(j[e+12>>2]==(b|0)){break d}}}}j[c>>2]=4;a=0;break a}if(!d&a>>>0<=65535){break b}}j[c>>2]=4;a=65535;break a}a=(f|0)==45?0-a|0:a}Za=e+16|0;return a&65535}function awa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,k=0,l=0;b=Za-16|0;Za=b;g=j[a+24>>2];h=j[a+20>>2];k=j[a+16>>2];e=j[a+4>>2];f=j[a>>2];j[b+8>>2]=f;j[b+12>>2]=e;l=j[a+12>>2];j[b>>2]=j[a+8>>2];j[b+4>>2]=l;if(d){while(1){e=((((e&2147483647)<<1|f>>>31)&2147483646)<<1)+k|0;f=i[e+2>>1];j[c>>2]=j[c>>2]+p(i[e>>1],h);j[c+4>>2]=j[c+4>>2]+p(f,g);Bb(b+8|0,b);d=d-1|0;if(d){c=c+8|0;f=j[b+8>>2];e=j[b+12>>2];continue}break}f=j[b+8>>2];e=j[b+12>>2]}j[a>>2]=f;j[a+4>>2]=e;Za=b+16|0}function nda(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0;j[114630]=0;N(2010,a|0);h=j[114630];j[114630]=0;a:{b:{if((h|0)!=1){h=j[a+24>>2];j[114630]=0;b=ia(2027,h|0,b|0,c|0,d|0,e|0,f|0,g|0)|0;c=j[114630];j[114630]=0;if((c|0)!=1){break b}}b=J(0)|0;C()|0;O(b|0)|0;j[114630]=0;L(1984,35378,a|0,0,0);a=j[114630];j[114630]=0;if((a|0)==1){break a}Q();b=0}return b|0}a=D()|0;C()|0;j[114630]=0;M(20);b=j[114630];j[114630]=0;if((b|0)!=1){G(a|0);z()}J(0)|0;C()|0;ib();z()}function kda(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0;j[114630]=0;N(2010,a|0);h=j[114630];j[114630]=0;a:{b:{if((h|0)!=1){h=j[a+24>>2];j[114630]=0;b=ia(2030,h|0,b|0,c|0,d|0,e|0,f|0,g|0)|0;c=j[114630];j[114630]=0;if((c|0)!=1){break b}}b=J(0)|0;C()|0;O(b|0)|0;j[114630]=0;L(1984,35467,a|0,0,0);a=j[114630];j[114630]=0;if((a|0)==1){break a}Q();b=0}return b|0}a=D()|0;C()|0;j[114630]=0;M(20);b=j[114630];j[114630]=0;if((b|0)!=1){G(a|0);z()}J(0)|0;C()|0;ib();z()}function DK(a,b){var c=0,d=0,e=0;a:{b:{if(!k[b+866|0]|j[a+480180>>2]!=1){break b}d=j[b+104>>2];if(!d){break b}if(!ke(d)|(l[d+34>>1]&3)!=2){break b}c=k[b+867|0]+k[(k[b+866|0]&15)+21408|0]|0;h[b+867|0]=c;if(c<<24>>24>-1){break b}h[b+867|0]=0;c=j[b+784>>2]+1|0;j[b+784>>2]=c>>>0<j[d+8>>2]-j[d+4>>2]>>>0?c:0;c=j[d+20>>2];j[114630]=0;c=H(466,c|0)|0;e=j[114630];j[114630]=0;if((e|0)==1){break a}b=lb(c)+(j[b+784>>2]+j[d+4>>2]|0)|0;h[b|0]=k[b|0]^-1;Lx(d,a,0)}return}J(0)|0;C()|0;ib();z()}function vqa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,i=0,l=0,m=0;d=Za-16|0;Za=d;j[d+12>>2]=c;j[d+8>>2]=j[a>>2];g=j[tb(d+8|0,d+12|0)>>2];j[d+8>>2]=j[a>>2];j[d+4>>2]=j[d+12>>2]-g;i=j[tb(d+8|0,d+4|0)>>2];c=lb(b);if(g){e=j[a+20>>2];f=g;while(1){l=e,m=lb(k[c|0])^128,h[l|0]=m;e=e+2|0;c=c+1|0;f=f-1|0;if(f){continue}break}}b=lb(b);if(i){c=b+j[a>>2]|0;e=j[a+20>>2]+1|0;f=i;while(1){l=e,m=lb(k[c|0])^128,h[l|0]=m;e=e+2|0;c=c+1|0;f=f-1|0;if(f){continue}break}}Za=d+16|0;return g+i|0}function uqa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,i=0,l=0,m=0;e=Za-16|0;Za=e;j[e+12>>2]=c;j[e+8>>2]=j[a>>2];i=j[tb(e+8|0,e+12|0)>>2];j[e+8>>2]=j[a>>2];j[e+4>>2]=j[e+12>>2]-i;l=j[tb(e+8|0,e+4|0)>>2];c=lb(b);if(i){f=j[a+20>>2];g=i;m=d;while(1){m=lb(k[c|0])+m|0;h[f|0]=m;f=f+2|0;c=c+1|0;g=g-1|0;if(g){continue}break}}b=lb(b);if(l){c=b+j[a>>2]|0;f=j[a+20>>2]+1|0;g=l;while(1){d=lb(k[c|0])+d|0;h[f|0]=d;f=f+2|0;c=c+1|0;g=g-1|0;if(g){continue}break}}Za=e+16|0;return i+l|0}function bwa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,i=0,k=0,l=0;b=Za-16|0;Za=b;g=j[a+24>>2];i=j[a+20>>2];k=j[a+16>>2];e=j[a+4>>2];f=j[a>>2];j[b+8>>2]=f;j[b+12>>2]=e;l=j[a+12>>2];j[b>>2]=j[a+8>>2];j[b+4>>2]=l;if(d){while(1){e=(((e&2147483647)<<1|f>>>31)&-2)+k|0;f=h[e+1|0];j[c>>2]=j[c>>2]+(p(h[e|0],i)<<8);j[c+4>>2]=j[c+4>>2]+(p(f,g)<<8);Bb(b+8|0,b);d=d-1|0;if(d){c=c+8|0;f=j[b+8>>2];e=j[b+12>>2];continue}break}f=j[b+8>>2];e=j[b+12>>2]}j[a>>2]=f;j[a+4>>2]=e;Za=b+16|0}function I$(a,b,c){var d=0,e=0,f=0,g=0;f=Za-16|0;Za=f;d=nb(a);e=oq(a);g=Is(b,c);a:{if(!g){break a}if(hz(b,zb(a),zb(a)+(nb(a)<<2)|0)){d=Za-16|0;Za=d;fD(f,b,c);Za=d+16|0;b=f;c=zb(b);d=nb(b);j[114630]=0;K(2501,a|0,c|0,d|0)|0;c=j[114630];j[114630]=0;if((c|0)!=1){pc(b);break a}a=D()|0;C()|0;pc(b);G(a|0);z()}if(e-d>>>0<g>>>0){PB(a,e,(d+g|0)-e|0,d,d)}e=zb(a)+(d<<2)|0;while(1){if((b|0)!=(c|0)){ye(e,b);b=b+4|0;e=e+4|0;continue}break}j[f>>2]=0;ye(e,f);Bg(a,d+g|0)}Za=f+16|0;return a}function dca(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=+d;e=+e;var f=0,g=0;j[114630]=0;N(2083,a|0);f=j[114630];j[114630]=0;a:{b:{if((f|0)!=1){f=j[a+28>>2];g=j[j[f>>2]+72>>2];j[114630]=0;b=Ra(g|0,f|0,b|0,c|0,+d,+e)|0;c=j[114630];j[114630]=0;if((c|0)!=1){break b}}b=J(0)|0;C()|0;O(b|0)|0;j[114630]=0;L(1984,38080,a|0,0,0);a=j[114630];j[114630]=0;if((a|0)==1){break a}Q();b=-1}return b|0}a=D()|0;C()|0;j[114630]=0;M(20);b=j[114630];j[114630]=0;if((b|0)!=1){G(a|0);z()}J(0)|0;C()|0;ib();z()}function Y7(a,b){var c=0,d=0,e=0,f=0;c=Za-80|0;Za=c;d=j[a>>2];f=j[d+4>>2];e=j[d+24>>2];j[c+40>>2]=j[d+20>>2];j[c+44>>2]=e;e=j[d+16>>2];j[c+32>>2]=j[d+12>>2];j[c+36>>2]=e;hh(c- -64|0,c+32|0,f);d=Xd(c+48|0,j[j[a+4>>2]>>2],j[j[a+8>>2]>>2],j[j[a+12>>2]>>2]);f=j[j[a+12>>2]>>2];a=j[j[a+8>>2]>>2];e=j[c+76>>2];j[c+24>>2]=j[c+72>>2];j[c+28>>2]=e;e=j[c+68>>2];j[c+16>>2]=j[c+64>>2];j[c+20>>2]=e;j[c+8>>2]=j[d+8>>2];e=j[d+4>>2];j[c>>2]=j[d>>2];j[c+4>>2]=e;W7(c+16|0,c,b,a,f);Za=c+80|0}function X7(a,b){var c=0,d=0,e=0,f=0;c=Za-80|0;Za=c;d=j[a>>2];f=j[d+4>>2];e=j[d+24>>2];j[c+40>>2]=j[d+20>>2];j[c+44>>2]=e;e=j[d+16>>2];j[c+32>>2]=j[d+12>>2];j[c+36>>2]=e;hh(c- -64|0,c+32|0,f);d=Xd(c+48|0,j[j[a+4>>2]>>2],j[j[a+8>>2]>>2],j[j[a+12>>2]>>2]);f=j[j[a+12>>2]>>2];a=j[j[a+8>>2]>>2];e=j[c+76>>2];j[c+24>>2]=j[c+72>>2];j[c+28>>2]=e;e=j[c+68>>2];j[c+16>>2]=j[c+64>>2];j[c+20>>2]=e;j[c+8>>2]=j[d+8>>2];e=j[d+4>>2];j[c>>2]=j[d>>2];j[c+4>>2]=e;U7(c+16|0,c,b,a,f);Za=c+80|0}function Wla(a,b){a=a|0;b=b|0;var c=0;b=78416;Ula(a);a:{while(1){b:{if(!Xc(a)){if(!Lh(j[b+8>>2],j[Ti(a)>>2])){break b}}j[114630]=0;F(1511,a|0,b+8|0);c=j[114630];j[114630]=0;if((c|0)!=1){break b}break a}b=b+12|0;if((b|0)!=78932){continue}break}b=78944;while(1){c:{if(!Xc(a)){if(!Lh(j[b+8>>2],j[Ti(a)>>2])){break c}}j[114630]=0;F(1511,a|0,b+8|0);c=j[114630];j[114630]=0;if((c|0)!=1){break c}break a}b=b+12|0;if((b|0)!=78992){continue}break}return}b=D()|0;C()|0;Nw(a);G(b|0);z()}function Sv(a,b){var c=0,d=0,e=0,f=0;c=Za-80|0;Za=c;d=j[a>>2];f=j[d+4>>2];e=j[d+24>>2];j[c+40>>2]=j[d+20>>2];j[c+44>>2]=e;e=j[d+16>>2];j[c+32>>2]=j[d+12>>2];j[c+36>>2]=e;hh(c- -64|0,c+32|0,f);d=Xd(c+48|0,j[j[a+4>>2]>>2],j[j[a+8>>2]>>2],j[j[a+12>>2]>>2]);f=j[j[a+12>>2]>>2];a=j[j[a+8>>2]>>2];e=j[c+76>>2];j[c+24>>2]=j[c+72>>2];j[c+28>>2]=e;e=j[c+68>>2];j[c+16>>2]=j[c+64>>2];j[c+20>>2]=e;j[c+8>>2]=j[d+8>>2];e=j[d+4>>2];j[c>>2]=j[d>>2];j[c+4>>2]=e;V7(c+16|0,c,b,a,f);Za=c+80|0}function S7(a,b){var c=0,d=0,e=0,f=0;c=Za-80|0;Za=c;d=j[a>>2];f=j[d+4>>2];e=j[d+24>>2];j[c+40>>2]=j[d+20>>2];j[c+44>>2]=e;e=j[d+16>>2];j[c+32>>2]=j[d+12>>2];j[c+36>>2]=e;hh(c- -64|0,c+32|0,f);d=Xd(c+48|0,j[j[a+4>>2]>>2],j[j[a+8>>2]>>2],j[j[a+12>>2]>>2]);f=j[j[a+12>>2]>>2];a=j[j[a+8>>2]>>2];e=j[c+76>>2];j[c+24>>2]=j[c+72>>2];j[c+28>>2]=e;e=j[c+68>>2];j[c+16>>2]=j[c+64>>2];j[c+20>>2]=e;j[c+8>>2]=j[d+8>>2];e=j[d+4>>2];j[c>>2]=j[d>>2];j[c+4>>2]=e;Q7(c+16|0,c,b,a,f);Za=c+80|0}function Rv(a,b){var c=0,d=0,e=0,f=0;c=Za-80|0;Za=c;d=j[a>>2];f=j[d+4>>2];e=j[d+24>>2];j[c+40>>2]=j[d+20>>2];j[c+44>>2]=e;e=j[d+16>>2];j[c+32>>2]=j[d+12>>2];j[c+36>>2]=e;hh(c- -64|0,c+32|0,f);d=Xd(c+48|0,j[j[a+4>>2]>>2],j[j[a+8>>2]>>2],j[j[a+12>>2]>>2]);f=j[j[a+12>>2]>>2];a=j[j[a+8>>2]>>2];e=j[c+76>>2];j[c+24>>2]=j[c+72>>2];j[c+28>>2]=e;e=j[c+68>>2];j[c+16>>2]=j[c+64>>2];j[c+20>>2]=e;j[c+8>>2]=j[d+8>>2];e=j[d+4>>2];j[c>>2]=j[d>>2];j[c+4>>2]=e;P7(c+16|0,c,b,a,f);Za=c+80|0}function R7(a,b){var c=0,d=0,e=0,f=0;c=Za-80|0;Za=c;d=j[a>>2];f=j[d+4>>2];e=j[d+24>>2];j[c+40>>2]=j[d+20>>2];j[c+44>>2]=e;e=j[d+16>>2];j[c+32>>2]=j[d+12>>2];j[c+36>>2]=e;hh(c- -64|0,c+32|0,f);d=Xd(c+48|0,j[j[a+4>>2]>>2],j[j[a+8>>2]>>2],j[j[a+12>>2]>>2]);f=j[j[a+12>>2]>>2];a=j[j[a+8>>2]>>2];e=j[c+76>>2];j[c+24>>2]=j[c+72>>2];j[c+28>>2]=e;e=j[c+68>>2];j[c+16>>2]=j[c+64>>2];j[c+20>>2]=e;j[c+8>>2]=j[d+8>>2];e=j[d+4>>2];j[c>>2]=j[d>>2];j[c+4>>2]=e;O7(c+16|0,c,b,a,f);Za=c+80|0}function Qv(a,b){var c=0,d=0,e=0,f=0;c=Za-80|0;Za=c;d=j[a>>2];f=j[d+4>>2];e=j[d+24>>2];j[c+40>>2]=j[d+20>>2];j[c+44>>2]=e;e=j[d+16>>2];j[c+32>>2]=j[d+12>>2];j[c+36>>2]=e;hh(c- -64|0,c+32|0,f);d=Xd(c+48|0,j[j[a+4>>2]>>2],j[j[a+8>>2]>>2],j[j[a+12>>2]>>2]);f=j[j[a+12>>2]>>2];a=j[j[a+8>>2]>>2];e=j[c+76>>2];j[c+24>>2]=j[c+72>>2];j[c+28>>2]=e;e=j[c+68>>2];j[c+16>>2]=j[c+64>>2];j[c+20>>2]=e;j[c+8>>2]=j[d+8>>2];e=j[d+4>>2];j[c>>2]=j[d>>2];j[c+4>>2]=e;C7(c+16|0,c,b,a,f);Za=c+80|0}function J7(a,b){var c=0,d=0,e=0,f=0;c=Za-80|0;Za=c;d=j[a>>2];f=j[d+4>>2];e=j[d+24>>2];j[c+40>>2]=j[d+20>>2];j[c+44>>2]=e;e=j[d+16>>2];j[c+32>>2]=j[d+12>>2];j[c+36>>2]=e;hh(c- -64|0,c+32|0,f);d=Xd(c+48|0,j[j[a+4>>2]>>2],j[j[a+8>>2]>>2],j[j[a+12>>2]>>2]);f=j[j[a+12>>2]>>2];a=j[j[a+8>>2]>>2];e=j[c+76>>2];j[c+24>>2]=j[c+72>>2];j[c+28>>2]=e;e=j[c+68>>2];j[c+16>>2]=j[c+64>>2];j[c+20>>2]=e;j[c+8>>2]=j[d+8>>2];e=j[d+4>>2];j[c>>2]=j[d>>2];j[c+4>>2]=e;H7(c+16|0,c,b,a,f);Za=c+80|0}function G7(a,b){var c=0,d=0,e=0,f=0;c=Za-80|0;Za=c;d=j[a>>2];f=j[d+4>>2];e=j[d+24>>2];j[c+40>>2]=j[d+20>>2];j[c+44>>2]=e;e=j[d+16>>2];j[c+32>>2]=j[d+12>>2];j[c+36>>2]=e;hh(c- -64|0,c+32|0,f);d=Xd(c+48|0,j[j[a+4>>2]>>2],j[j[a+8>>2]>>2],j[j[a+12>>2]>>2]);f=j[j[a+12>>2]>>2];a=j[j[a+8>>2]>>2];e=j[c+76>>2];j[c+24>>2]=j[c+72>>2];j[c+28>>2]=e;e=j[c+68>>2];j[c+16>>2]=j[c+64>>2];j[c+20>>2]=e;j[c+8>>2]=j[d+8>>2];e=j[d+4>>2];j[c>>2]=j[d>>2];j[c+4>>2]=e;D7(c+16|0,c,b,a,f);Za=c+80|0}function E7(a,b){var c=0,d=0,e=0,f=0;c=Za-80|0;Za=c;d=j[a>>2];f=j[d+4>>2];e=j[d+24>>2];j[c+40>>2]=j[d+20>>2];j[c+44>>2]=e;e=j[d+16>>2];j[c+32>>2]=j[d+12>>2];j[c+36>>2]=e;hh(c- -64|0,c+32|0,f);d=Xd(c+48|0,j[j[a+4>>2]>>2],j[j[a+8>>2]>>2],j[j[a+12>>2]>>2]);f=j[j[a+12>>2]>>2];a=j[j[a+8>>2]>>2];e=j[c+76>>2];j[c+24>>2]=j[c+72>>2];j[c+28>>2]=e;e=j[c+68>>2];j[c+16>>2]=j[c+64>>2];j[c+20>>2]=e;j[c+8>>2]=j[d+8>>2];e=j[d+4>>2];j[c>>2]=j[d>>2];j[c+4>>2]=e;B7(c+16|0,c,b,a,f);Za=c+80|0}function Dl(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0,k=0;i=Za-16|0;Za=i;a:{b:{if(!a){break b}g=j[e+12>>2];h=c-b|0;if((h|0)>=1){if((Cl(a,b,h)|0)!=(h|0)){break b}}b=d-b|0;b=(b|0)<(g|0)?g-b|0:0;if((b|0)>=1){f=gj(i,b,f);g=zb(f);j[114630]=0;g=K(28,a|0,g|0,b|0)|0;h=j[114630];j[114630]=0;if((h|0)==1){break a}gb(f);if((b|0)!=(g|0)){break b}}b=d-c|0;if((b|0)>=1){if((Cl(a,c,b)|0)!=(b|0)){break b}}_x(e);k=a}Za=i+16|0;return k|0}a=D()|0;C()|0;gb(f);G(a|0);z()}function $q(a,b){var c=0,d=0,e=0,f=0;c=Za-80|0;Za=c;d=j[a>>2];f=j[d+4>>2];e=j[d+24>>2];j[c+40>>2]=j[d+20>>2];j[c+44>>2]=e;e=j[d+16>>2];j[c+32>>2]=j[d+12>>2];j[c+36>>2]=e;hh(c- -64|0,c+32|0,f);d=Xd(c+48|0,j[j[a+4>>2]>>2],j[j[a+8>>2]>>2],j[j[a+12>>2]>>2]);f=j[j[a+12>>2]>>2];a=j[j[a+8>>2]>>2];e=j[c+76>>2];j[c+24>>2]=j[c+72>>2];j[c+28>>2]=e;e=j[c+68>>2];j[c+16>>2]=j[c+64>>2];j[c+20>>2]=e;j[c+8>>2]=j[d+8>>2];e=j[d+4>>2];j[c>>2]=j[d>>2];j[c+4>>2]=e;I7(c+16|0,c,b,a,f);Za=c+80|0}function xba(a){var b=0,c=0,d=0;b=Za-160|0;Za=b;c=Db(b+120|0,38211);j[114630]=0;I(6,b+104|0,1,20681);d=j[114630];j[114630]=0;a:{b:{c:{d:{e:{if((d|0)!=1){j[114630]=0;I(3,b+136|0,c|0,b+104|0);d=j[114630];j[114630]=0;if((d|0)==1){break e}j[114630]=0;V(2111,b+88|0,a|0,1,38204,b+136|0);a=j[114630];j[114630]=0;if((a|0)==1){break d}gb(b+136|0);gb(b+104|0);break a}a=D()|0;C()|0;break b}a=D()|0;C()|0;break c}a=D()|0;C()|0;gb(b+136|0)}gb(b+104|0)}gb(c);G(a|0);z()}gb(c);Za=b+160|0}function h1(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0;a=Za-32|0;Za=a;j[a+24>>2]=37;j[a+28>>2]=0;vj(a+24|1,64454,1,j[c+4>>2]);h=j[c+4>>2];g=a-32|0;Za=g;i=Wd();j[a>>2]=e;j[a+4>>2]=f;f=Je(g,(h>>>9&1)+23|0,i,a+24|0,a)+g|0;h=Sf(g,f,c);e=g-48|0;Za=e;hc(a+8|0,c);j[114630]=0;Z(2466,g|0,h|0,f|0,e|0,a+20|0,a+16|0,a+8|0);f=j[114630];j[114630]=0;if((f|0)!=1){wb(a+8|0);b=Dl(b,e,j[a+20>>2],j[a+16>>2],c,d);Za=a+32|0;return b|0}b=D()|0;C()|0;wb(a+8|0);G(b|0);z()}function f1(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0;a=Za-32|0;Za=a;j[a+24>>2]=37;j[a+28>>2]=0;vj(a+24|1,64454,0,j[c+4>>2]);h=j[c+4>>2];g=a-32|0;Za=g;i=Wd();j[a>>2]=e;j[a+4>>2]=f;f=Je(g,(h>>>9&1)+23|0,i,a+24|0,a)+g|0;h=Sf(g,f,c);e=g-48|0;Za=e;hc(a+8|0,c);j[114630]=0;Z(2466,g|0,h|0,f|0,e|0,a+20|0,a+16|0,a+8|0);f=j[114630];j[114630]=0;if((f|0)!=1){wb(a+8|0);b=Dl(b,e,j[a+20>>2],j[a+16>>2],c,d);Za=a+32|0;return b|0}b=D()|0;C()|0;wb(a+8|0);G(b|0);z()}function DQ(a,b){a=a|0;b=b|0;var c=0,d=0;d=k[a+3|0];a:{if(d>>>0>18){break a}d=1<<d;b:{if(!(d&126991)){if(d&396800){break b}break a}if(!k[a|0]){break a}}c:{d:{switch(k[a+3|0]){case 10:case 17:case 18:c=8;break c;case 0:case 1:case 2:case 3:case 12:case 13:case 14:case 15:case 16:c=k[a|0];if(!(c&7)){break c};case 11:c=k[a+3|0];return p($y(a),b+1>>>1|0)+(((c|0)==11)<<4)|0;case 9:break d;default:break c}}c=16}d=k[a+3|0];c=p($y(a),p(c>>>3|0,b))+(((d|0)==11)<<4)|0}return c|0}function tN(a){var b=0;a:{if((k[a+44|0]|k[a+45|0]<<8|(k[a+46|0]<<16|k[a+47|0]<<24))!=1179472976|k[a+28|0]!=26|k[a+30|0]>2){break a}b=a+40|0;if(k[b|0]|k[b+1|0]<<8){break a}b=a+38|0;if(!(k[b|0]|k[b+1|0]<<8)|(k[b|0]|k[b+1|0]<<8)>>>0>32){break a}b=a+32|0;if(!(k[b|0]|k[b+1|0]<<8)|(k[b|0]|k[b+1|0]<<8)>>>0>256){break a}b=a+34|0;if(!(k[b|0]|k[b+1|0]<<8)|(k[b|0]|k[b+1|0]<<8)>>>0>255){break a}a=a+36|0;if(!(k[a|0]|k[a+1|0]<<8)){break a}return(k[a|0]|k[a+1|0]<<8)>>>0<129}return 0}function l7(a,b,c,d,e){var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,p=0;g=Za-16|0;Za=g;if(e){l=c+4|0;while(1){h=0;if(d){while(1){f=o[Kg(b,h,j)>>3];Pb(c,h);m=g,n=+(Xi(zd(f*134217728))-1024+((br(l)^-2147483648)>>>21)|0)*7.450580596923828e-9,o[m+8>>3]=n;wf(g+8|0,-1,1);f=o[g+8>>3]*32768;o[g+8>>3]=f;f=zd(f);a:{if(r(f)<2147483648){k=~~f;break a}k=-2147483648}k=Dc(k);m=lm(a,h,j),p=k,i[m>>1]=p;h=h+1|0;if((h|0)!=(d|0)){continue}break}}j=j+1|0;if((j|0)!=(e|0)){continue}break}}Za=g+16|0}function bna(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0;c=Za-32|0;Za=c;a:{if((b-1&65535)>>>0>3998){break a}f=1;e=(p(b,104)+a|0)+484380|0;if(!ke(e)){break a}g=a+1304360|0;d=a+1074984|0;while(1){if(j[d+104>>2]==(e|0)){j[d+76>>2]=0;j[d>>2]=0;j[d+4>>2]=0;j[d+16>>2]=0}d=d+896|0;if((g|0)!=(d|0)){continue}break}Sm(e);j[e>>2]=0;a=(p(b,104)+a|0)+484414|0;i[a>>1]=l[a>>1]&65470;j[c+24>>2]=0;j[c+8>>2]=0;j[c+16>>2]=0;j[c+20>>2]=0;j[c>>2]=0;j[c+4>>2]=0;Ro(e,0,c)}Za=c+32|0;return f|0}function P7(a,b,c,d,e){var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,p=0;g=Za-16|0;Za=g;if(e){l=c+4|0;while(1){h=0;if(d){while(1){f=o[Kg(b,h,j)>>3];Pb(c,h);m=g,n=+(Xi(zd(f*134217728))-1024+((br(l)^-2147483648)>>>21)|0)*7.450580596923828e-9,o[m+8>>3]=n;wf(g+8|0,-1,1);f=o[g+8>>3]*32768;o[g+8>>3]=f;f=zd(f);a:{if(r(f)<2147483648){k=~~f;break a}k=-2147483648}k=Dc(k);m=nm(a,h,j),p=k,i[m>>1]=p;h=h+1|0;if((h|0)!=(d|0)){continue}break}}j=j+1|0;if((j|0)!=(e|0)){continue}break}}Za=g+16|0}function wqa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,i=0,l=0,m=0;d=Za-16|0;Za=d;j[d+12>>2]=c;j[d+8>>2]=j[a>>2];g=j[tb(d+8|0,d+12|0)>>2];j[d+8>>2]=j[a>>2];j[d+4>>2]=j[d+12>>2]-g;i=j[tb(d+8|0,d+4|0)>>2];c=lb(b);if(g){e=j[a+20>>2];f=g;while(1){l=e,m=Im(k[c|0]),h[l|0]=m;e=e+2|0;c=c+1|0;f=f-1|0;if(f){continue}break}}b=lb(b);if(i){c=b+j[a>>2]|0;e=j[a+20>>2]+1|0;f=i;while(1){l=e,m=Im(k[c|0]),h[l|0]=m;e=e+2|0;c=c+1|0;f=f-1|0;if(f){continue}break}}Za=d+16|0;return g+i|0}function Y5(a,b,c,d){var e=0,f=0,g=0,l=0,m=0,n=0,o=0;f=Za-16|0;Za=f;m=k[c+14|0];g=m+k[c+13|0]|0;N5(a+2304|0,j[c>>2],g,f+4|0);if(k[c+13|0]){e=j[f+12>>2];l=j[f+8>>2];n=j[f+4>>2];l=(l|0)>(n|0)?l:n;e=(e|0)>(l|0)?e:l;j[f+12>>2]=e;j[f+8>>2]=e;j[f+4>>2]=e}m=m?3:1;l=g-m|0;e=0;while(1){n=e+l|0;g=n-m|0;o=k[d+1|0]<<28>>31&3;a:{if((g|0)<=j[(f+4|0)+(e<<2)>>2]){break a}o=k[b+g|0]}g=o;h[b+n|0]=g;e=e+1|0;if((m|0)!=(e|0)){continue}break}M5(a,b,j[c>>2],d,f+4|0,i[c+36>>1]&1);Za=f+16|0}function Uq(a,b,c){var d=0,e=0;d=(c|0)!=0;a:{b:{c:{if(!c|!(a&3)){break c}e=b&255;while(1){if((e|0)==k[a|0]){break b}a=a+1|0;c=c-1|0;d=(c|0)!=0;if(!c){break c}if(a&3){continue}break}}if(!d){break a}}d:{if(k[a|0]==(b&255)|c>>>0<4){break d}d=p(b&255,16843009);while(1){e=d^j[a>>2];if((e^-1)&e-16843009&-2139062144){break d}a=a+4|0;c=c-4|0;if(c>>>0>3){continue}break}}if(!c){break a}b=b&255;while(1){if((b|0)==k[a|0]){return a}a=a+1|0;c=c-1|0;if(c){continue}break}}return 0}function qE(a){var b=0,c=0,d=0,e=0,f=0,g=0,h=0,i=0,k=0,l=0;h=j[a+104>>2];b=(h<<3)+a|0;c=((h+7>>>0)%12<<3)+a|0;f=j[c>>2];e=j[c+4>>2];i=j[a+96>>2];k=j[a+100>>2];a:{if(!(i|k)){g=j[b+4>>2];d=g;c=j[b>>2];l=(d|0)==(e|0)&c>>>0>f>>>0|e>>>0<d>>>0;break a}g=j[b+4>>2];d=g;c=j[b>>2];l=(d|0)==(e|0)&c>>>0>=f>>>0|e>>>0<d>>>0}d=f-i|0;j[b>>2]=d-c;j[b+4>>2]=e-((f>>>0<i>>>0)+k|0)-((c>>>0>d>>>0)+g)&65535;j[a+104>>2]=(h+1>>>0)%12;j[a+96>>2]=l;j[a+100>>2]=0;ab=j[b+4>>2];return j[b>>2]}function sfa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;b=Th(a,b,c,d);j[a>>2]=81008;d=Jj(a+4208|0);j[a+4240>>2]=0;j[a+4244>>2]=0;c=we(c);j[a+4260>>2]=0;j[a+4256>>2]=c;j[a+4236>>2]=0;c=a+4228|0;j[c>>2]=1048576e3;j[c+4>>2]=1048576e3;j[a+4220>>2]=1056964608;j[a+4224>>2]=1056964608;j[114630]=0;K(1634,a+44|0,2,2)|0;c=j[114630];j[114630]=0;a:{if((c|0)==1){break a}j[114630]=0;N(1635,b|0);c=j[114630];j[114630]=0;if((c|0)==1){break a}return a|0}a=D()|0;C()|0;xf(d);Ke(b);G(a|0);z()}function gca(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0;j[114630]=0;N(2083,a|0);e=j[114630];j[114630]=0;a:{b:{if((e|0)!=1){e=j[a+28>>2];f=j[j[e>>2]+12>>2];j[114630]=0;b=P(f|0,e|0,b|0,c|0,d|0)|0;c=j[114630];j[114630]=0;if((c|0)!=1){break b}}b=J(0)|0;C()|0;O(b|0)|0;j[114630]=0;L(1984,37764,a|0,0,0);a=j[114630];j[114630]=0;if((a|0)==1){break a}Q();b=-1}return b|0}a=D()|0;C()|0;j[114630]=0;M(20);b=j[114630];j[114630]=0;if((b|0)!=1){G(a|0);z()}J(0)|0;C()|0;ib();z()}function fca(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0;j[114630]=0;N(2083,a|0);e=j[114630];j[114630]=0;a:{b:{if((e|0)!=1){e=j[a+28>>2];f=j[j[e>>2]+8>>2];j[114630]=0;b=P(f|0,e|0,b|0,c|0,d|0)|0;c=j[114630];j[114630]=0;if((c|0)!=1){break b}}b=J(0)|0;C()|0;O(b|0)|0;j[114630]=0;L(1984,37721,a|0,0,0);a=j[114630];j[114630]=0;if((a|0)==1){break a}Q();b=-1}return b|0}a=D()|0;C()|0;j[114630]=0;M(20);b=j[114630];j[114630]=0;if((b|0)!=1){G(a|0);z()}J(0)|0;C()|0;ib();z()}function eD(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0;e=Za-16|0;Za=e;a:{b:{c:{d:{if((a|0)!=(b|0)){e:{f:{f=k[a|0];if((f|0)!=45){break f}a=a+1|0;if((b|0)!=(a|0)){break f}break e}h=j[114604];j[114604]=0;a=Wu(a,e+12|0,d,Wd());d=ab;g=j[114604];g:{if(g){if(j[e+12>>2]!=(b|0)){break g}if((g|0)==68){break c}break d}j[114604]=h;if(j[e+12>>2]==(b|0)){break d}}}}j[c>>2]=4;a=0;break a}if(!d){break b}}j[c>>2]=4;a=-1;break a}a=(f|0)==45?0-a|0:a}Za=e+16|0;return a|0}function ZKa(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,m=0;f=Za-32|0;Za=f;j[f+28>>2]=c;g=yb(b,c<<1);a:{if(!g){break a}jc(f+28|0,65535);bg(a,l[f+28>>1]);h=f,m=Lb(a),j[h+16>>2]=m;h=f,m=Mb(a),j[h+8>>2]=m;if(!rb(f+16|0,f+8|0)){break a}while(1){a=j[f+16>>2];Lz(b,f+24|0);c=f+24|0;c=k[c|0]|k[c+1|0]<<8;i[a>>1]=c;b:{if((c|0)==(d|0)){c=65535}else{if((c|0)!=(e|0)){break b}c=65534}i[a>>1]=c}je(f+16|0);if(rb(f+16|0,f+8|0)){continue}break}}Za=f+32|0;return g|0}function Cj(a,b,c){a=a|0;b=b|0;c=c|0;a:{if(a){if(b>>>0<=127){break a}b:{if(!j[j[21255]>>2]){if((b&-128)==57216){break a}break b}if(b>>>0<=2047){h[a+1|0]=b&63|128;h[a|0]=b>>>6|192;return 2}if(!((b&-8192)!=57344?b>>>0>=55296:0)){h[a+2|0]=b&63|128;h[a|0]=b>>>12|224;h[a+1|0]=b>>>6&63|128;return 3}if(b-65536>>>0<=1048575){h[a+3|0]=b&63|128;h[a|0]=b>>>18|240;h[a+2|0]=b>>>6&63|128;h[a+1|0]=b>>>12&63|128;return 4}}j[114604]=25;a=-1}else{a=1}return a|0}h[a|0]=b;return 1}function bca(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0;j[114630]=0;N(2083,a|0);d=j[114630];j[114630]=0;e=1;a:{b:{if((d|0)!=1){d=j[a+28>>2];f=j[j[d>>2]+64>>2];j[114630]=0;I(f|0,d|0,b|0,(c|0)!=0|0);b=j[114630];j[114630]=0;if((b|0)!=1){break b}}b=J(0)|0;C()|0;O(b|0)|0;j[114630]=0;L(1984,38026,a|0,0,0);a=j[114630];j[114630]=0;if((a|0)==1){break a}Q();e=0}return e|0}a=D()|0;C()|0;j[114630]=0;M(20);b=j[114630];j[114630]=0;if((b|0)!=1){G(a|0);z()}J(0)|0;C()|0;ib();z()}function $ba(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0;j[114630]=0;N(2083,a|0);d=j[114630];j[114630]=0;e=1;a:{b:{if((d|0)!=1){d=j[a+28>>2];f=j[j[d>>2]+56>>2];j[114630]=0;I(f|0,d|0,b|0,(c|0)!=0|0);b=j[114630];j[114630]=0;if((b|0)!=1){break b}}b=J(0)|0;C()|0;O(b|0)|0;j[114630]=0;L(1984,37978,a|0,0,0);a=j[114630];j[114630]=0;if((a|0)==1){break a}Q();e=0}return e|0}a=D()|0;C()|0;j[114630]=0;M(20);b=j[114630];j[114630]=0;if((b|0)!=1){G(a|0);z()}J(0)|0;C()|0;ib();z()}function EJ(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0;d=Za-560|0;Za=d;i[d+558>>1]=b;a:{b:{if((b-1&65535)>>>0>254){break b}f=((b<<2)+a|0)+900380|0;e=j[f>>2];c:{if(e){b=wM(d,c);Pma(e,b);Ls(b);break c}b=kg(556);if(!b){e=0;j[f>>2]=0;break b}j[114630]=0;e=E(1430,b|0,c|0)|0;c=j[114630];j[114630]=0;if((c|0)==1){break a}j[((l[d+558>>1]<<2)+a|0)+900380>>2]=b}g=a,h=l[vi(a+480192|0,d+558|0)>>1],i[g+480192>>1]=h}Za=d+560|0;return e|0}a=D()|0;C()|0;Fb(b);G(a|0);z()}function Npa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=q(0),g=0,h=0,l=0,m=0;e=Za-16|0;Za=e;j[e+8>>2]=c>>>2;j[e+4>>2]=j[a>>2];d=j[tb(e+8|0,e+4|0)>>2];b=lb(b);if(d){a=j[a+20>>2];c=d;while(1){j[e+12>>2]=k[b|0]|k[b+1|0]<<8|(k[b+2|0]<<16|k[b+3|0]<<24);Kd(e+12|0,q(-1));f=q(n[e+12>>2]*q(32768));n[e+12>>2]=f;h=a;f=Rd(f);a:{if(q(r(f))<q(2147483648)){g=~~f;break a}g=-2147483648}l=h,m=Dc(g),i[l>>1]=m;a=a+2|0;b=b+4|0;c=c-1|0;if(c){continue}break}}Za=e+16|0;return d<<2}function yEa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0;d=Za-32|0;Za=d;GDa(a);e=a;a:{b:{c:{d:{while(1){j[114630]=0;a=E(258,b|0,6)|0;f=j[114630];j[114630]=0;if((f|0)==1){break b}if(!a){break c}j[114630]=0;I(757,d+8|0,b|0,c|0);a=j[114630];j[114630]=0;if((a|0)!=1){j[114630]=0;F(758,e|0,d+8|0);a=j[114630];j[114630]=0;if((a|0)==1){break d}Re(d+8|0);continue}break}a=D()|0;C()|0;break a}a=D()|0;C()|0;Re(d+8|0);break a}Za=d+32|0;return}a=D()|0;C()|0}Jy(e);G(a|0);z()}function kKa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0;d=Za-32|0;Za=d;CJa(a);e=a;a:{b:{c:{d:{while(1){j[114630]=0;a=E(258,b|0,8)|0;f=j[114630];j[114630]=0;if((f|0)==1){break b}if(!a){break c}j[114630]=0;I(512,d+8|0,b|0,c|0);a=j[114630];j[114630]=0;if((a|0)!=1){j[114630]=0;F(513,e|0,d+8|0);a=j[114630];j[114630]=0;if((a|0)==1){break d}Re(d+8|0);continue}break}a=D()|0;C()|0;break a}a=D()|0;C()|0;Re(d+8|0);break a}Za=d+32|0;return}a=D()|0;C()|0}Az(e);G(a|0);z()}function YHa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0;d=Za-32|0;Za=d;FHa(a);e=a;a:{b:{c:{d:{while(1){j[114630]=0;a=E(258,b|0,8)|0;f=j[114630];j[114630]=0;if((f|0)==1){break b}if(!a){break c}j[114630]=0;I(599,d+8|0,b|0,c|0);a=j[114630];j[114630]=0;if((a|0)!=1){j[114630]=0;F(600,e|0,d+8|0);a=j[114630];j[114630]=0;if((a|0)==1){break d}Re(d+8|0);continue}break}a=D()|0;C()|0;break a}a=D()|0;C()|0;Re(d+8|0);break a}Za=d+32|0;return}a=D()|0;C()|0}jz(e);G(a|0);z()}function rH(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;b=Th(a,b,c,d);j[a>>2]=80368;c=Jj(a+4260|0);j[a+4232>>2]=1061997773;d=a+4224|0;j[d>>2]=1061158912;j[d+4>>2]=1059082943;d=a+4216|0;j[d>>2]=1038174126;j[d+4>>2]=1065353216;j[a+4208>>2]=1056964608;j[a+4212>>2]=1036831949;j[114630]=0;K(1634,a+44|0,2,2)|0;d=j[114630];j[114630]=0;a:{if((d|0)==1){break a}j[114630]=0;N(1635,b|0);d=j[114630];j[114630]=0;if((d|0)==1){break a}return a|0}a=D()|0;C()|0;xf(c);Ke(b);G(a|0);z()}function gGa(a,b){var c=0,d=0,e=0,f=0,g=0;e=Za-16|0;Za=e;a:{if(Ps(a)){j[b>>2]=0;a=0;break a}f=ug(a,e,16);d=lb(k[e|0]);c=d&127;j[b>>2]=c;d=d<<24>>24;b:{if(!(f>>>0<2|(d|0)>-1)){d=c?32-s(c)|0:0;c=1;while(1){g=lb(k[c+e|0]);j[b>>2]=g&127|j[b>>2]<<7;d=d+7|0;c=c+1|0;if((f|0)==(c|0)){Jb(a,f);f=ug(a,e,16);c=0}g=g<<24>>24;if((g|0)<0?c>>>0<f>>>0:0){continue}break}Jb(a,c);a=(g|0)<0;if(d>>>0<33){break b}j[b>>2]=-1;a=0;break a}Jb(a,1);a=(d|0)<0}a=a^1}Za=e+16|0;return a}function Tka(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0;d=Za-32|0;Za=d;e=Hw(a);a:{b:{c:{d:{while(1){j[114630]=0;a=E(258,b|0,8)|0;f=j[114630];j[114630]=0;if((f|0)==1){break b}if(!a){break c}j[114630]=0;I(1549,d+8|0,b|0,c|0);a=j[114630];j[114630]=0;if((a|0)!=1){j[114630]=0;F(1550,e|0,d+8|0);a=j[114630];j[114630]=0;if((a|0)==1){break d}Re(d+8|0);continue}break}a=D()|0;C()|0;break a}a=D()|0;C()|0;Re(d+8|0);break a}Za=d+32|0;return}a=D()|0;C()|0}Zk(e);G(a|0);z()}function nza(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0;d=Za-32|0;Za=d;e=gy(a);a:{b:{c:{d:{while(1){j[114630]=0;a=E(258,b|0,8)|0;f=j[114630];j[114630]=0;if((f|0)==1){break b}if(!a){break c}j[114630]=0;I(968,d+8|0,b|0,c|0);a=j[114630];j[114630]=0;if((a|0)!=1){j[114630]=0;F(969,e|0,d+8|0);a=j[114630];j[114630]=0;if((a|0)==1){break d}Re(d+8|0);continue}break}a=D()|0;C()|0;break a}a=D()|0;C()|0;Re(d+8|0);break a}Za=d+32|0;return}a=D()|0;C()|0}kl(e);G(a|0);z()}function Tv(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0;a:{if(!er(b)){break a}a=a+24|0;if(!tg(j[a>>2]+484344|0,b&65535)){break a}b=Hb(j[a>>2]+484344|0,b);if((d|0)<0|j[b+12>>2]<=(c|0)|(c|0)<0|(l[j[a>>2]+480188>>1]<=(d|0)|e>>>0>5)){break a}a=Se(b,c,d&65535);b:{switch(e|0){case 0:f=k[a|0];break a;case 1:f=k[a+1|0];break a;case 2:f=k[a+2|0];break a;case 3:f=k[a+3|0];break a;case 4:f=k[a+4|0];break a;case 5:break b;default:break a}}f=k[a+5|0]}return f|0}function vL(a,b){var c=0,d=0,e=0,f=0;i[a+24>>1]=0;j[a+20>>2]=0;j[a>>2]=0;j[a+4>>2]=0;j[a+8>>2]=0;j[a+12>>2]=0;e=a;d=3546895/+(b>>>0);c=d*.25;a:{if(r(c)<2147483648){b=~~c;break a}b=-2147483648}j[e+16>>2]=b;c=(d- +(b<<2))*4294967296;b:{if(r(c)<0x8000000000000000){f=~~c>>>0;b=r(c)>=1?c>0?~~t(v(c*2.3283064365386963e-10),4294967295)>>>0:~~w((c- +(~~c>>>0>>>0))*2.3283064365386963e-10)>>>0:0;break b}b=-2147483648}j[a>>2]=0;j[a+4>>2]=0;j[a+8>>2]=f;j[a+12>>2]=b}function Zba(a,b,c){a=a|0;b=b|0;c=+c;var d=0,e=0,f=0;j[114630]=0;N(2083,a|0);d=j[114630];j[114630]=0;e=1;a:{b:{if((d|0)!=1){d=j[a+28>>2];f=j[j[d>>2]+48>>2];j[114630]=0;Ta(f|0,d|0,b|0,+c);b=j[114630];j[114630]=0;if((b|0)!=1){break b}}b=J(0)|0;C()|0;O(b|0)|0;j[114630]=0;L(1984,37940,a|0,0,0);a=j[114630];j[114630]=0;if((a|0)==1){break a}Q();e=0}return e|0}a=D()|0;C()|0;j[114630]=0;M(20);b=j[114630];j[114630]=0;if((b|0)!=1){G(a|0);z()}J(0)|0;C()|0;ib();z()}function S6(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0;e=Za-48|0;Za=e;f=j[b+12>>2];j[e+40>>2]=j[b+8>>2];j[e+44>>2]=f;f=j[b+4>>2];j[e+32>>2]=j[b>>2];j[e+36>>2]=f;b=ho(e+24|0,c);j[114630]=0;c=j[e+44>>2];j[e+16>>2]=j[e+40>>2];j[e+20>>2]=c;c=j[e+36>>2];j[e+8>>2]=j[e+32>>2];j[e+12>>2]=c;P(2008,a+8|0,e+8|0,b|0,d|0)|0;c=j[114630];j[114630]=0;if((c|0)!=1){Gc(b);xF(a);b=wF(a+88|0);j[a>>2]=84360;j[b>>2]=84448;Za=e+48|0;return a|0}a=D()|0;C()|0;Gc(b);G(a|0);z()}function oda(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0;j[114630]=0;N(2010,a|0);f=j[114630];j[114630]=0;a:{b:{if((f|0)!=1){f=j[a+24>>2];j[114630]=0;b=U(2026,f|0,b|0,c|0,d|0,e|0)|0;c=j[114630];j[114630]=0;if((c|0)!=1){break b}}b=J(0)|0;C()|0;O(b|0)|0;j[114630]=0;L(1984,35351,a|0,0,0);a=j[114630];j[114630]=0;if((a|0)==1){break a}Q();b=0}return b|0}a=D()|0;C()|0;j[114630]=0;M(20);b=j[114630];j[114630]=0;if((b|0)!=1){G(a|0);z()}J(0)|0;C()|0;ib();z()}function lda(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0;j[114630]=0;N(2010,a|0);f=j[114630];j[114630]=0;a:{b:{if((f|0)!=1){f=j[a+24>>2];j[114630]=0;b=U(2029,f|0,b|0,c|0,d|0,e|0)|0;c=j[114630];j[114630]=0;if((c|0)!=1){break b}}b=J(0)|0;C()|0;O(b|0)|0;j[114630]=0;L(1984,35434,a|0,0,0);a=j[114630];j[114630]=0;if((a|0)==1){break a}Q();b=0}return b|0}a=D()|0;C()|0;j[114630]=0;M(20);b=j[114630];j[114630]=0;if((b|0)!=1){G(a|0);z()}J(0)|0;C()|0;ib();z()}function R$(a,b,c){var d=0,e=0,f=0,g=0;f=Za-32|0;Za=f;d=nb(a);e=sc(a);g=ti(b,c);a:{if(!g){break a}if(hz(b,zb(a),zb(a)+nb(a)|0)){b=Yh(f+16|0,b,c);c=zb(b);d=nb(b);j[114630]=0;K(2493,a|0,c|0,d|0)|0;c=j[114630];j[114630]=0;if((c|0)!=1){gb(b);break a}a=D()|0;C()|0;gb(b);G(a|0);z()}if(e-d>>>0<g>>>0){xl(a,e,(d+g|0)-e|0,d,d,0,0)}e=zb(a)+d|0;while(1){if((b|0)!=(c|0)){Sd(e,b);b=b+1|0;e=e+1|0;continue}break}h[f+15|0]=0;Sd(e,f+15|0);Bg(a,d+g|0)}Za=f+32|0;return a}function Dca(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0;j[114630]=0;N(2010,a|0);f=j[114630];j[114630]=0;a:{b:{if((f|0)!=1){f=j[a+24>>2];j[114630]=0;b=U(2065,f|0,b|0,c|0,d|0,e|0)|0;c=j[114630];j[114630]=0;if((c|0)!=1){break b}}b=J(0)|0;C()|0;O(b|0)|0;j[114630]=0;L(1984,36668,a|0,0,0);a=j[114630];j[114630]=0;if((a|0)==1){break a}Q();b=0}return b|0}a=D()|0;C()|0;j[114630]=0;M(20);b=j[114630];j[114630]=0;if((b|0)!=1){G(a|0);z()}J(0)|0;C()|0;ib();z()}function oR(a){a=a|0;var b=0,c=0,d=0,e=0,f=0,g=0;a:{b=j[a+1060>>2];if((b|0)>255){break a}while(1){f=(p(b,6)+a|0)+1068|0,g=ij(a,7),h[f|0]=g;d=ij(a,1);e=ij(a,1);c=j[a+1056>>2];if((c|0)>255){break a}b=j[a+1060>>2]+1|0;j[a+1056>>2]=b;j[a+1060>>2]=b;b:{if(d){i[(p(c,6)+a|0)+1064>>1]=b;oR(a);b=j[a+1060>>2];break b}i[(p(c,6)+a|0)+1064>>1]=65535}j[a+1056>>2]=b;if(e){i[(p(c,6)+a|0)+1066>>1]=b;if((b|0)<=255){continue}break a}break}i[(p(c,6)+a|0)+1066>>1]=65535}}function QB(a,b,c,d,e,f,g,h){var i=0,k=0,l=0;i=Za-16|0;Za=i;if((b^-1)+1073741807>>>0>=c>>>0){k=zb(a);a:{if(b>>>0<536870887){j[i+8>>2]=b<<1;j[i+12>>2]=b+c;c=Ul(j[Lc(i+12|0,i+8|0)>>2]);break a}c=1073741806}l=c+1|0;c=Ck(l);if(e){Jh(c,k,e)}if(g){Jh(c+(e<<2)|0,h,g)}d=d-f|0;h=d-e|0;if(h){e=e<<2;Jh((e+c|0)+(g<<2)|0,(e+k|0)+(f<<2)|0,h)}b=b+1|0;if((b|0)!=2){On(k,b)}lf(a,c);lg(a,l);b=a;a=d+g|0;ee(b,a);j[i+4>>2]=0;ye(c+(a<<2)|0,i+4|0);Za=i+16|0;return}jg();z()}function _ka(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,l=0,m=0,n=0;c=Za-32|0;Za=c;cla(a+33|0,b);l=b+236|0;e=a+27|0;while(1){f=0;g=(a+d|0)+33|0;if(k[g|0]<(k[e|0]|k[e+1|0]<<8)>>>0){f=k[g|0]}m=Nc(l,d+12|0),n=f,i[m>>1]=n;d=d+1|0;if((d|0)!=96){continue}break}sn(c,3,a+4|0);qc(c+16|0,c);j[114630]=0;E(369,b+492|0,c+16|0)|0;d=j[114630];j[114630]=0;if((d|0)!=1){gb(c+16|0);if(!k[a+241|0]){h[b+30|0]=k[a+26|0]}Za=c+32|0;return}a=D()|0;C()|0;gb(c+16|0);G(a|0);z()}function Tb(a,b){var c=0,d=0,e=0;a:{b:{c=j[a+1396>>2];if((c|0)>=0){c:{if((b|0)>(c|0)){if((b|0)>=25){break b}if(!c){j[a+1392>>2]=0}while(1){c=-1;e=Xq(a);d=0;if((e|0)==-1){break c}d=j[a+1396>>2];c=d+8|0;j[a+1396>>2]=c;j[a+1392>>2]=j[a+1392>>2]+(e<<d);if((b|0)>(c|0)){continue}break}}if((b|0)>(c|0)){break a}d=j[a+1392>>2];j[a+1392>>2]=d>>>b;c=c-b|0;d=d&(-1<<b^-1)}j[a+1396>>2]=c}return d}return Tb(a,24)+(Tb(a,b-24|0)<<24)|0}Y(50566,50512,1617,50585);z()}function e5(a,b,c,d,e,f){var g=0,h=0,i=0,j=0,k=0,l=q(0);e=e-c|0;h=d-b|0;i=(e|0)/(h|0)|0;f=(d|0)>(f|0)?f:d;a:{if((f|0)<=(b|0)){break a}d=(b<<2)+a|0;n[d>>2]=n[d>>2]*n[((c&255)<<2)+50896>>2];d=b+1|0;if((f|0)<=(d|0)){break a}b=e>>31;j=b+e^b;b=i>>31;k=j-p(b+i^b,h)|0;e=(e|0)>-1?1:-1;b=0;while(1){g=(d<<2)+a|0;j=g;l=n[g>>2];b=b+k|0;g=(b|0)<(h|0);c=(c+i|0)+(g?0:e)|0;n[j>>2]=l*n[((c&255)<<2)+50896>>2];b=b-(g?0:h)|0;d=d+1|0;if((f|0)!=(d|0)){continue}break}}}function tja(a,b){var c=0,d=0,e=0,f=0,g=0;c=Za-144|0;Za=c;d=Mg(c+8|0);e=j[j[d>>2]-12>>2];j[114630]=0;f=T(122)|0;g=j[114630];j[114630]=0;a:{if((g|0)==1){break a}j[114630]=0;I(123,c|0,e+(c+8|0)|0,f|0);e=j[114630];j[114630]=0;if((e|0)==1){break a}wb(c);j[114630]=0;F(130,d|0,b|0);b=j[114630];j[114630]=0;if((b|0)==1){break a}j[114630]=0;F(125,a|0,d|0);a=j[114630];j[114630]=0;if((a|0)==1){break a}Hd(d);Za=c+144|0;return}a=D()|0;C()|0;Hd(d);G(a|0);z()}function nia(a,b){var c=0,d=0,e=0,f=0,g=0;c=Za-144|0;Za=c;d=Mg(c+8|0);e=j[j[d>>2]-12>>2];j[114630]=0;f=T(122)|0;g=j[114630];j[114630]=0;a:{if((g|0)==1){break a}j[114630]=0;I(123,c|0,e+(c+8|0)|0,f|0);e=j[114630];j[114630]=0;if((e|0)==1){break a}wb(c);j[114630]=0;F(134,d|0,b|0);b=j[114630];j[114630]=0;if((b|0)==1){break a}j[114630]=0;F(125,a|0,d|0);a=j[114630];j[114630]=0;if((a|0)==1){break a}Hd(d);Za=c+144|0;return}a=D()|0;C()|0;Hd(d);G(a|0);z()}function eia(a,b){var c=0,d=0,e=0,f=0,g=0;c=Za-144|0;Za=c;d=Mg(c+8|0);e=j[j[d>>2]-12>>2];j[114630]=0;f=T(122)|0;g=j[114630];j[114630]=0;a:{if((g|0)==1){break a}j[114630]=0;I(123,c|0,e+(c+8|0)|0,f|0);e=j[114630];j[114630]=0;if((e|0)==1){break a}wb(c);j[114630]=0;F(135,d|0,b|0);b=j[114630];j[114630]=0;if((b|0)==1){break a}j[114630]=0;F(125,a|0,d|0);a=j[114630];j[114630]=0;if((a|0)==1){break a}Hd(d);Za=c+144|0;return}a=D()|0;C()|0;Hd(d);G(a|0);z()}function dja(a,b){var c=0,d=0,e=0,f=0,g=0;c=Za-144|0;Za=c;d=Mg(c+8|0);e=j[j[d>>2]-12>>2];j[114630]=0;f=T(122)|0;g=j[114630];j[114630]=0;a:{if((g|0)==1){break a}j[114630]=0;I(123,c|0,e+(c+8|0)|0,f|0);e=j[114630];j[114630]=0;if((e|0)==1){break a}wb(c);j[114630]=0;F(131,d|0,b|0);b=j[114630];j[114630]=0;if((b|0)==1){break a}j[114630]=0;F(125,a|0,d|0);a=j[114630];j[114630]=0;if((a|0)==1){break a}Hd(d);Za=c+144|0;return}a=D()|0;C()|0;Hd(d);G(a|0);z()}function Oha(a,b){var c=0,d=0,e=0,f=0,g=0;c=Za-144|0;Za=c;d=Mg(c+8|0);e=j[j[d>>2]-12>>2];j[114630]=0;f=T(122)|0;g=j[114630];j[114630]=0;a:{if((g|0)==1){break a}j[114630]=0;I(123,c|0,e+(c+8|0)|0,f|0);e=j[114630];j[114630]=0;if((e|0)==1){break a}wb(c);j[114630]=0;F(136,d|0,b|0);b=j[114630];j[114630]=0;if((b|0)==1){break a}j[114630]=0;F(125,a|0,d|0);a=j[114630];j[114630]=0;if((a|0)==1){break a}Hd(d);Za=c+144|0;return}a=D()|0;C()|0;Hd(d);G(a|0);z()}function Cia(a,b){var c=0,d=0,e=0,f=0,g=0;c=Za-144|0;Za=c;d=Mg(c+8|0);e=j[j[d>>2]-12>>2];j[114630]=0;f=T(122)|0;g=j[114630];j[114630]=0;a:{if((g|0)==1){break a}j[114630]=0;I(123,c|0,e+(c+8|0)|0,f|0);e=j[114630];j[114630]=0;if((e|0)==1){break a}wb(c);j[114630]=0;F(133,d|0,b|0);b=j[114630];j[114630]=0;if((b|0)==1){break a}j[114630]=0;F(125,a|0,d|0);a=j[114630];j[114630]=0;if((a|0)==1){break a}Hd(d);Za=c+144|0;return}a=D()|0;C()|0;Hd(d);G(a|0);z()}function nI(a,b){var c=0,d=0,e=0,f=0,g=0;c=Za-144|0;Za=c;d=Mg(c+8|0);e=j[j[d>>2]-12>>2];j[114630]=0;f=T(122)|0;g=j[114630];j[114630]=0;a:{if((g|0)==1){break a}j[114630]=0;I(123,c|0,e+(c+8|0)|0,f|0);e=j[114630];j[114630]=0;if((e|0)==1){break a}wb(c);j[114630]=0;F(132,d|0,b|0);b=j[114630];j[114630]=0;if((b|0)==1){break a}j[114630]=0;F(125,a|0,d|0);a=j[114630];j[114630]=0;if((a|0)==1){break a}Hd(d);Za=c+144|0;return}a=D()|0;C()|0;Hd(d);G(a|0);z()}function Jw(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0;f=Za-48|0;Za=f;a:{if(!c){c=$b(a,b);a=j[d+12>>2];j[c+8>>2]=j[d+8>>2];j[c+12>>2]=a;a=j[d+4>>2];j[c>>2]=j[d>>2];j[c+4>>2]=a;break a}e=j[d+12>>2];j[f+24>>2]=j[d+8>>2];j[f+28>>2]=e;g=j[d+4>>2];e=f;j[e+16>>2]=j[d>>2];j[e+20>>2]=g;g=c>>>1|0;Jw(a,b,g,e+16|0);mh(e+32|0,d,$b(a,c));d=j[e+44>>2];j[e+8>>2]=j[e+40>>2];j[e+12>>2]=d;d=j[e+36>>2];j[e>>2]=j[e+32>>2];j[e+4>>2]=d;Jw(a,b|c,g,e)}Za=f+48|0}function Bw(a,b){var c=0,d=0,e=0,f=0,g=0;c=Za-144|0;Za=c;d=Mg(c+8|0);e=j[j[d>>2]-12>>2];j[114630]=0;f=T(122)|0;g=j[114630];j[114630]=0;a:{if((g|0)==1){break a}j[114630]=0;I(123,c|0,e+(c+8|0)|0,f|0);e=j[114630];j[114630]=0;if((e|0)==1){break a}wb(c);j[114630]=0;F(124,d|0,b|0);b=j[114630];j[114630]=0;if((b|0)==1){break a}j[114630]=0;F(125,a|0,d|0);a=j[114630];j[114630]=0;if((a|0)==1){break a}Hd(d);Za=c+144|0;return}a=D()|0;C()|0;Hd(d);G(a|0);z()}function Z9(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0;h=Za-16|0;Za=h;a:{b:{c:{if(!(g?!(!f|(!d|!e)):0)){b=R(8)|0;j[114630]=0;c=E(85,h|0,38697)|0;a=j[114630];j[114630]=0;if((a|0)==1){break c}Wb(b,c);j[114630]=0;I(2004,b|0,83648,2012);a=j[114630];j[114630]=0;if((a|0)!=1){break a}a=D()|0;C()|0;gb(c);break b}Qh(a,b,4);c=Yv(a,c,d,e,f,g);o[a+16>>3]=+(c>>>0)/+(b|0)+o[a+16>>3];Za=h+16|0;return c|0}a=D()|0;C()|0;S(b|0)}G(a|0)}z()}function W9(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0;h=Za-16|0;Za=h;a:{b:{c:{if(!(g?!(!f|(!d|!e)):0)){b=R(8)|0;j[114630]=0;c=E(85,h|0,38697)|0;a=j[114630];j[114630]=0;if((a|0)==1){break c}Wb(b,c);j[114630]=0;I(2004,b|0,83648,2012);a=j[114630];j[114630]=0;if((a|0)!=1){break a}a=D()|0;C()|0;gb(c);break b}Qh(a,b,4);c=Xv(a,c,d,e,f,g);o[a+16>>3]=+(c>>>0)/+(b|0)+o[a+16>>3];Za=h+16|0;return c|0}a=D()|0;C()|0;S(b|0)}G(a|0)}z()}function eca(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;j[114630]=0;N(2083,a|0);c=j[114630];j[114630]=0;d=1;a:{b:{if((c|0)!=1){c=j[a+28>>2];e=j[j[c>>2]+76>>2];j[114630]=0;F(e|0,c|0,b|0);b=j[114630];j[114630]=0;if((b|0)!=1){break b}}b=J(0)|0;C()|0;O(b|0)|0;j[114630]=0;L(1984,38090,a|0,0,0);a=j[114630];j[114630]=0;if((a|0)==1){break a}Q();d=0}return d|0}a=D()|0;C()|0;j[114630]=0;M(20);b=j[114630];j[114630]=0;if((b|0)!=1){G(a|0);z()}J(0)|0;C()|0;ib();z()}function Zla(a,b){var c=0,d=0,e=0,f=0;c=Za-16|0;Za=c;j[c+12>>2]=j[a+4>>2];j[c+8>>2]=j[b+4>>2];a:{b:{if(!j[tb(c+12|0,c+8|0)>>2]){break b}while(1){e=qo(h[fc(a,d)|0]);f=qo(h[fc(b,d)|0]);if((e|0)!=(f|0)){d=(e&255)>>>0<(f&255)>>>0?-1:1;break a}if(e){j[c+12>>2]=j[a+4>>2];j[c+8>>2]=j[b+4>>2];d=d+1|0;if(d>>>0>=m[tb(c+12|0,c+8|0)>>2]){break b}continue}break}d=0;break a}d=0;if(j[a+4>>2]==j[b+4>>2]){break a}d=m[a+4>>2]<m[b+4>>2]?-1:1}Za=c+16|0;return d}function Uja(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0;d=Za-16|0;Za=d;hc(a,b);j[114630]=0;I(128,d+8|0,b|0,c|0);e=j[114630];j[114630]=0;a:{if((e|0)==1){break a}wb(d+8|0);j[114630]=0;e=H(27,b|0)|0;f=j[114630];j[114630]=0;if((f|0)==1){break a}if(e){j[114630]=0;b=H(27,b|0)|0;e=j[114630];j[114630]=0;if((e|0)==1){break a}j[114630]=0;I(129,d|0,b|0,c|0);b=j[114630];j[114630]=0;if((b|0)==1){break a}wb(d)}Za=d+16|0;return}b=D()|0;C()|0;wb(a);G(b|0);z()}function Sba(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;j[114630]=0;N(2083,a|0);c=j[114630];j[114630]=0;d=1;a:{b:{if((c|0)!=1){c=j[a+28>>2];e=j[j[c>>2]+20>>2];j[114630]=0;F(e|0,c|0,b|0);b=j[114630];j[114630]=0;if((b|0)!=1){break b}}b=J(0)|0;C()|0;O(b|0)|0;j[114630]=0;L(1984,37818,a|0,0,0);a=j[114630];j[114630]=0;if((a|0)==1){break a}Q();d=0}return d|0}a=D()|0;C()|0;j[114630]=0;M(20);b=j[114630];j[114630]=0;if((b|0)!=1){G(a|0);z()}J(0)|0;C()|0;ib();z()}function Rba(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;j[114630]=0;N(2083,a|0);c=j[114630];j[114630]=0;d=1;a:{b:{if((c|0)!=1){c=j[a+28>>2];e=j[j[c>>2]+16>>2];j[114630]=0;F(e|0,c|0,b|0);b=j[114630];j[114630]=0;if((b|0)!=1){break b}}b=J(0)|0;C()|0;O(b|0)|0;j[114630]=0;L(1984,37800,a|0,0,0);a=j[114630];j[114630]=0;if((a|0)==1){break a}Q();d=0}return d|0}a=D()|0;C()|0;j[114630]=0;M(20);b=j[114630];j[114630]=0;if((b|0)!=1){G(a|0);z()}J(0)|0;C()|0;ib();z()}function BD(a,b,c,d,e){var f=0,g=0,h=0,i=0,j=0;h=-1;f=d&2147483647;i=f;g=c;a:{if(!c&(f|0)==2147418112?a|b:(f|0)==2147418112&(c|0)!=0|f>>>0>2147418112){break a}f=e&2147483647;j=f;if((f|0)==2147418112?0:f>>>0>2147418112){break a}if(!(a|g|(i|j|b))){return 0}g=d&e;if((g|0)>0?1:(g|0)>=0){if(!c&(d|0)==(e|0)?0:(d|0)<(e|0)){break a}return(a|c)!=0|(d^e|b)!=0}if(!c&(d|0)==(e|0)?a|b:(d|0)>(e|0)?1:(d|0)>=(e|0)?c:0){break a}h=(a|c)!=0|(d^e|b)!=0}return h}function mp(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,m=0;f=Za-32|0;Za=f;j[f+28>>2]=c;g=yb(b,c);a:{if(!g){break a}jc(f+28|0,65535);bg(a,l[f+28>>1]);h=f,m=Lb(a),j[h+16>>2]=m;h=f,m=Mb(a),j[h+8>>2]=m;if(!rb(f+16|0,f+8|0)){break a}while(1){a=j[f+16>>2];CHa(b,f+27|0);c=k[f+27|0];i[a>>1]=c;b:{if((c|0)==(d|0)){c=65535}else{if((c|0)!=(e|0)){break b}c=65534}i[a>>1]=c}je(f+16|0);if(rb(f+16|0,f+8|0)){continue}break}}Za=f+32|0;return g|0}function dla(a,b,c){var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;f=Za+ -64|0;Za=f;while(1){h=+(g-4096|0)*.0001220703125;e=0;d=0;while(1){j=ela(d,h,b,c);o[(d<<3)+f>>3]=j;e=j+e;d=d+1|0;if((d|0)!=8){continue}break}e=1/e;l=g<<3;d=0;while(1){m=(d+l<<1)+a|0;h=u(t(v(o[(d<<3)+f>>3]*32768*e+.5),32768),-32768);a:{if(r(h)<2147483648){k=~~h;break a}k=-2147483648}i[m>>1]=k;d=d+1|0;if((d|0)!=8){continue}break}g=g+1|0;if((g|0)!=8193){continue}break}Za=f- -64|0}function Xba(a,b){a=a|0;b=+b;var c=0,d=0,e=0;j[114630]=0;N(2083,a|0);c=j[114630];j[114630]=0;d=1;a:{b:{if((c|0)!=1){c=j[a+28>>2];e=j[j[c>>2]+40>>2];j[114630]=0;fa(e|0,c|0,+b);c=j[114630];j[114630]=0;if((c|0)!=1){break b}}d=J(0)|0;C()|0;O(d|0)|0;j[114630]=0;L(1984,37904,a|0,0,0);a=j[114630];j[114630]=0;if((a|0)==1){break a}Q();d=0}return d|0}a=D()|0;C()|0;j[114630]=0;M(20);d=j[114630];j[114630]=0;if((d|0)!=1){G(a|0);z()}J(0)|0;C()|0;ib();z()}function Vba(a,b){a=a|0;b=+b;var c=0,d=0,e=0;j[114630]=0;N(2083,a|0);c=j[114630];j[114630]=0;d=1;a:{b:{if((c|0)!=1){c=j[a+28>>2];e=j[j[c>>2]+32>>2];j[114630]=0;fa(e|0,c|0,+b);c=j[114630];j[114630]=0;if((c|0)!=1){break b}}d=J(0)|0;C()|0;O(d|0)|0;j[114630]=0;L(1984,37870,a|0,0,0);a=j[114630];j[114630]=0;if((a|0)==1){break a}Q();d=0}return d|0}a=D()|0;C()|0;j[114630]=0;M(20);d=j[114630];j[114630]=0;if((d|0)!=1){G(a|0);z()}J(0)|0;C()|0;ib();z()}function Tba(a,b){a=a|0;b=+b;var c=0,d=0,e=0;j[114630]=0;N(2083,a|0);c=j[114630];j[114630]=0;d=1;a:{b:{if((c|0)!=1){c=j[a+28>>2];e=j[j[c>>2]+24>>2];j[114630]=0;fa(e|0,c|0,+b);c=j[114630];j[114630]=0;if((c|0)!=1){break b}}d=J(0)|0;C()|0;O(d|0)|0;j[114630]=0;L(1984,37836,a|0,0,0);a=j[114630];j[114630]=0;if((a|0)==1){break a}Q();d=0}return d|0}a=D()|0;C()|0;j[114630]=0;M(20);d=j[114630];j[114630]=0;if((d|0)!=1){G(a|0);z()}J(0)|0;C()|0;ib();z()}function TI(a){var b=0;a:{if((k[a|0]|k[a+1|0]<<8|(k[a+2|0]<<16|k[a+3|0]<<24))!=1163089229){break a}b=a+4|0;if((k[b|0]|k[b+1|0]<<8|(k[b+2|0]<<16|k[b+3|0]<<24))!=-1095062050?(k[b|0]|k[b+1|0]<<8|(k[b+2|0]<<16|k[b+3|0]<<24))!=-1346458146:0){break a}b=a+16|0;if(!(k[b|0]|k[b+1|0]<<8|(k[b+2|0]<<16|k[b+3|0]<<24))){break a}a=a+8|0;return((k[b|0]|k[b+1|0]<<8|(k[b+2|0]<<16|k[b+3|0]<<24))+24|0)==(k[a|0]|k[a+1|0]<<8|(k[a+2|0]<<16|k[a+3|0]<<24))}return 0}function pda(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;j[114630]=0;N(2010,a|0);e=j[114630];j[114630]=0;a:{b:{if((e|0)!=1){e=j[a+24>>2];j[114630]=0;b=P(2025,e|0,b|0,c|0,d|0)|0;c=j[114630];j[114630]=0;if((c|0)!=1){break b}}b=J(0)|0;C()|0;O(b|0)|0;j[114630]=0;L(1984,35326,a|0,0,0);a=j[114630];j[114630]=0;if((a|0)==1){break a}Q();b=0}return b|0}a=D()|0;C()|0;j[114630]=0;M(20);b=j[114630];j[114630]=0;if((b|0)!=1){G(a|0);z()}J(0)|0;C()|0;ib();z()}function mda(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;j[114630]=0;N(2010,a|0);e=j[114630];j[114630]=0;a:{b:{if((e|0)!=1){e=j[a+24>>2];j[114630]=0;b=P(2028,e|0,b|0,c|0,d|0)|0;c=j[114630];j[114630]=0;if((c|0)!=1){break b}}b=J(0)|0;C()|0;O(b|0)|0;j[114630]=0;L(1984,35403,a|0,0,0);a=j[114630];j[114630]=0;if((a|0)==1){break a}Q();b=0}return b|0}a=D()|0;C()|0;j[114630]=0;M(20);b=j[114630];j[114630]=0;if((b|0)!=1){G(a|0);z()}J(0)|0;C()|0;ib();z()}function jda(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;j[114630]=0;N(2010,a|0);e=j[114630];j[114630]=0;a:{b:{if((e|0)!=1){e=j[a+24>>2];j[114630]=0;b=P(2031,e|0,b|0,c|0,d|0)|0;c=j[114630];j[114630]=0;if((c|0)!=1){break b}}b=J(0)|0;C()|0;O(b|0)|0;j[114630]=0;L(1984,35498,a|0,0,0);a=j[114630];j[114630]=0;if((a|0)==1){break a}Q();b=0}return b|0}a=D()|0;C()|0;j[114630]=0;M(20);b=j[114630];j[114630]=0;if((b|0)!=1){G(a|0);z()}J(0)|0;C()|0;ib();z()}function ida(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;j[114630]=0;N(2010,a|0);e=j[114630];j[114630]=0;a:{b:{if((e|0)!=1){e=j[a+24>>2];j[114630]=0;b=P(2032,e|0,b|0,c|0,d|0)|0;c=j[114630];j[114630]=0;if((c|0)!=1){break b}}b=J(0)|0;C()|0;O(b|0)|0;j[114630]=0;L(1984,35537,a|0,0,0);a=j[114630];j[114630]=0;if((a|0)==1){break a}Q();b=0}return b|0}a=D()|0;C()|0;j[114630]=0;M(20);b=j[114630];j[114630]=0;if((b|0)!=1){G(a|0);z()}J(0)|0;C()|0;ib();z()}function hda(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;j[114630]=0;N(2010,a|0);e=j[114630];j[114630]=0;a:{b:{if((e|0)!=1){e=j[a+24>>2];j[114630]=0;b=P(2033,e|0,b|0,c|0,d|0)|0;c=j[114630];j[114630]=0;if((c|0)!=1){break b}}b=J(0)|0;C()|0;O(b|0)|0;j[114630]=0;L(1984,35574,a|0,0,0);a=j[114630];j[114630]=0;if((a|0)==1){break a}Q();b=0}return b|0}a=D()|0;C()|0;j[114630]=0;M(20);b=j[114630];j[114630]=0;if((b|0)!=1){G(a|0);z()}J(0)|0;C()|0;ib();z()}function gda(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;j[114630]=0;N(2010,a|0);e=j[114630];j[114630]=0;a:{b:{if((e|0)!=1){e=j[a+24>>2];j[114630]=0;b=P(2034,e|0,b|0,c|0,d|0)|0;c=j[114630];j[114630]=0;if((c|0)!=1){break b}}b=J(0)|0;C()|0;O(b|0)|0;j[114630]=0;L(1984,35619,a|0,0,0);a=j[114630];j[114630]=0;if((a|0)==1){break a}Q();b=0}return b|0}a=D()|0;C()|0;j[114630]=0;M(20);b=j[114630];j[114630]=0;if((b|0)!=1){G(a|0);z()}J(0)|0;C()|0;ib();z()}function _ba(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;j[114630]=0;N(2083,a|0);c=j[114630];j[114630]=0;a:{b:{if((c|0)!=1){c=j[a+28>>2];e=j[j[c>>2]+52>>2];j[114630]=0;d=+Sa(e|0,c|0,b|0);b=j[114630];j[114630]=0;if((b|0)!=1){break b}}b=J(0)|0;C()|0;O(b|0)|0;j[114630]=0;L(1984,37959,a|0,0,0);a=j[114630];j[114630]=0;if((a|0)==1){break a}Q();d=0}return+d}a=D()|0;C()|0;j[114630]=0;M(20);b=j[114630];j[114630]=0;if((b|0)!=1){G(a|0);z()}J(0)|0;C()|0;ib();z()}function fEa(a,b){var c=0,d=0,e=0,f=0;d=Za-16|0;Za=d;h[b+12|0]=0;GP(b);ODa(b);c=k[a+1|0];a:{if(!c){break a}f=0-c|0;while(1){h[d+7|0]=64;f=(f<<16>>16)+c|0;NDa(b,ep(d+8|0,f&65535,k[Zb(((e<<1)+a|0)+2|0,d+7|0)|0]));e=e+1|0;if((e|0)==15){break a}c=k[((e<<1)+a|0)+1|0];if(c){continue}break}}c=k[a+32|0];h[b+14|0]=c>>>4;h[b+13|0]=c&15;a=k[a+31|0];c=a&15;h[b+15|0]=c;h[b+16|0]=c;if(a&16){h[b+12|0]=k[b+12|0]|4}if(a&32){h[b+12|0]=k[b+12|0]|2}Za=d+16|0}function cca(a,b){a=a|0;b=b|0;var c=0,d=0;j[114630]=0;N(2083,a|0);c=j[114630];j[114630]=0;a:{b:{if((c|0)!=1){c=j[a+28>>2];d=j[j[c>>2]+68>>2];j[114630]=0;b=E(d|0,c|0,b|0)|0;c=j[114630];j[114630]=0;if((c|0)!=1){break b}}b=J(0)|0;C()|0;O(b|0)|0;j[114630]=0;L(1984,38053,a|0,0,0);a=j[114630];j[114630]=0;if((a|0)==1){break a}Q();b=-1}return b|0}a=D()|0;C()|0;j[114630]=0;M(20);b=j[114630];j[114630]=0;if((b|0)!=1){G(a|0);z()}J(0)|0;C()|0;ib();z()}function aca(a,b){a=a|0;b=b|0;var c=0,d=0;j[114630]=0;N(2083,a|0);c=j[114630];j[114630]=0;a:{b:{if((c|0)!=1){c=j[a+28>>2];d=j[j[c>>2]+60>>2];j[114630]=0;b=E(d|0,c|0,b|0)|0;c=j[114630];j[114630]=0;if((c|0)!=1){break b}}b=J(0)|0;C()|0;O(b|0)|0;j[114630]=0;L(1984,38002,a|0,0,0);a=j[114630];j[114630]=0;if((a|0)==1){break a}Q();b=-1}return b|0}a=D()|0;C()|0;j[114630]=0;M(20);b=j[114630];j[114630]=0;if((b|0)!=1){G(a|0);z()}J(0)|0;C()|0;ib();z()}function Th(a,b,c,d){var e=0,f=0;j[a+20>>2]=d;j[a+16>>2]=c;j[a+12>>2]=b;j[a+4>>2]=0;j[a+8>>2]=0;j[a>>2]=79888;c=a+24|0;j[c>>2]=0;j[c+4>>2]=0;j[c+16>>2]=0;j[c+8>>2]=0;j[c+12>>2]=0;Hga(a+44|0);j[a+4196>>2]=1065353216;j[a+4200>>2]=0;b=0;i[a+4204>>1]=0;j[c>>2]=a+99&-8;e=j[a+20>>2];d=j[a+16>>2];if((e|0)!=(d+906300|0)){f=a+4200|0;while(1){a:{c=b+1|0;if(b>>>0>247){break a}b=c;if((e|0)!=((p(c,160)+d|0)+906300|0)){continue}}break}h[f|0]=c}return a}function zW(a,b){a=a|0;b=b|0;var c=0;a=Qc(a);a:{if(k[b+16|0]){j[114630]=0;E(235,a|0,7065)|0;c=j[114630];j[114630]=0;if((c|0)==1){break a}}if(k[b+17|0]){j[114630]=0;E(235,a|0,7072)|0;c=j[114630];j[114630]=0;if((c|0)==1){break a}}if(Ec(a)){j[114630]=0;E(235,a|0,7079)|0;c=j[114630];j[114630]=0;if((c|0)==1){break a}}if(k[b+18|0]){j[114630]=0;E(235,a|0,7085)|0;b=j[114630];j[114630]=0;if((b|0)==1){break a}}return}b=D()|0;C()|0;gb(a);G(b|0);z()}function u$(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0;e=Za-160|0;Za=e;j[e+152>>2]=b;f=e+144|0;a:{b:while(1){if(c>>>0<d>>>0){j[e+8>>2]=c;if((bb[j[j[a>>2]+16>>2]](a,e+144|0,c,(d-c|0)>32?c+32|0:d,e+8|0,e+16|0,f,e+12|0)|0)==2){break a}b=e+16|0;if(j[e+8>>2]==(c|0)){break a}while(1)if(m[e+12>>2]<=b>>>0){c=j[e+8>>2];continue b}else{j[e+4>>2]=j[b>>2];OB(j[e+152>>2],j[e+4>>2]);b=b+4|0;continue}}break}Za=e+160|0;return j[e+152>>2]}Wl(65236);z()}function b5(a,b,c,d){var e=0,f=0,g=q(0);f=KE(a,b);a:{if((f|0)<0){break a}e=j[b>>2];a=(d|0)>(e|0)?e:d;f=p(e,f);if(k[b+22|0]){e=1;if((a|0)<1){break a}d=0;while(1){e=(d<<2)+c|0;g=q(n[j[b+28>>2]+(d+f<<2)>>2]+g);n[e>>2]=n[e>>2]+g;g=q(n[b+12>>2]+g);e=1;d=d+1|0;if((a|0)!=(d|0)){continue}break}break a}e=1;if((a|0)<1){break a}d=0;while(1){e=(d<<2)+c|0;n[e>>2]=n[e>>2]+n[j[b+28>>2]+(d+f<<2)>>2];e=1;d=d+1|0;if((a|0)!=(d|0)){continue}break}}return e}function ZH(a){var b=0,c=0,d=0,e=0;c=Za-32|0;Za=c;a:{b:{if(Ij(a)>>>0<=Te(a)>>>0){break b}b=hb(a);d=Te(a);e=Te(a);j[114630]=0;b=P(1638,c+8|0,d|0,e|0,b|0)|0;d=j[114630];j[114630]=0;c:{d:{if((d|0)!=1){j[114630]=0;F(1639,a|0,b|0);a=j[114630];j[114630]=0;if((a|0)==1){break d}wr(b);break b}a=J(0)|0;C()|0;break c}a=J(0)|0;C()|0;wr(b)}O(a|0)|0;j[114630]=0;M(20);a=j[114630];j[114630]=0;if((a|0)==1){break a}}Za=c+32|0;return}J(0)|0;C()|0;ib();z()}function XH(a){var b=0,c=0,d=0,e=0;c=Za-32|0;Za=c;a:{b:{if(jd(a)>>>0<=sb(a)>>>0){break b}b=hb(a);d=sb(a);e=sb(a);j[114630]=0;b=P(1640,c+8|0,d|0,e|0,b|0)|0;d=j[114630];j[114630]=0;c:{d:{if((d|0)!=1){j[114630]=0;F(1641,a|0,b|0);a=j[114630];j[114630]=0;if((a|0)==1){break d}vr(b);break b}a=J(0)|0;C()|0;break c}a=J(0)|0;C()|0;vr(b)}O(a|0)|0;j[114630]=0;M(20);a=j[114630];j[114630]=0;if((a|0)==1){break a}}Za=c+32|0;return}J(0)|0;C()|0;ib();z()}function RO(a,b,c,d){var e=0,f=0;f=Za-16|0;Za=f;e=l[c>>1];while(1){a:{e=e<<1;i[c>>1]=e;h[b|0]=(e&65534)>>>0>255;e=k[c|0];i[c>>1]=e;if(!e){if(!re(a,f+15|0)){break a}e=k[f+15|0];i[c>>1]=e<<1|1;h[b|0]=e>>>7;i[c>>1]=k[c|0]}h[d|0]=k[b|0]+(k[d|0]<<1);e=l[c>>1]<<1;i[c>>1]=e;h[b|0]=(e&65534)>>>0>255;e=k[c|0];i[c>>1]=e;if(!e){if(!re(a,f+14|0)){break a}e=k[f+14|0];i[c>>1]=e<<1|1;h[b|0]=e>>>7;e=k[c|0];i[c>>1]=e}if(k[b|0]){continue}}break}Za=f+16|0}function Me(a,b,c,d){var e=0,f=0,g=0,h=0,i=0,k=0;e=Za-16|0;Za=e;g=Am(a);f=e;i=e;a:{if(b){k=j[b+4>>2];h=j[b>>2];break a}h=Am(a)}j[i+8>>2]=h;j[f+12>>2]=k;f=j[a+12>>2];a=1;b:{if(!b){break b}a=c+f|0;d=c>>>0>a>>>0?d+1|0:d;b=a;j[e>>2]=2048;j[e+4>>2]=0;a=Wz(e+8|0,e);c=j[a>>2];a=j[a+4>>2];c:{if(!a&c>>>0>g>>>0|a){a=-1;if(!d&b>>>0<=g>>>0){break c}break b}a=0;c=j[e+12>>2];if((c|0)==(d|0)&b>>>0>m[e+8>>2]|c>>>0<d>>>0){break b}}a=1}Za=e+16|0;return a}function HM(a,b){var c=0,d=0,e=0,f=0;c=Za-16|0;Za=c;a=Cb(a);d=nb(b);j[114630]=0;F(111,a|0,d|0);d=j[114630];j[114630]=0;if((d|0)!=1){a:{e=c,f=nd(b),j[e+8>>2]=f;e=c,f=_e(b),j[e>>2]=f;if(rb(c+8|0,c)){while(1){b=k[j[c+8>>2]];b:{if((b|0)==13){j[114630]=0;F(110,a|0,10);break b}j[114630]=0;F(110,a|0,b<<24>>24)}b=j[114630];j[114630]=0;if((b|0)==1){break a}Xf(c+8|0);if(rb(c+8|0,c)){continue}break}}Za=c+16|0;return}}b=D()|0;C()|0;gb(a);G(b|0);z()}function rga(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,i=0,l=0,m=0;d=Za-32|0;Za=d;f=j[c+12>>2];a:{if(!f){break a}g=h[c+16|0];e=nb(b);if(!e){break a}i=e-1|0;c=0;while(1){b:{if(!c|(c>>>0)%(f>>>0)){break b}if((c|0)==(i|0)){if(k[Ub(b,0)|0]==43){break b}if(k[Ub(b,0)|0]==45){break b}}l=d,m=nd(b),j[l+8>>2]=m;l=d,m=af(d+8|0,e-c|0),j[l+16>>2]=m;Cd(d+24|0,d+16|0);Wv(b,j[d+24>>2],1,g)}c=c+1|0;if((e|0)!=(c|0)){continue}break}}Mc(a,b);Za=d+32|0}function A4(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0;d=Za-32|0;Za=d;j[d+16>>2]=b;e=j[a+48>>2];j[d+20>>2]=c-((e|0)!=0);f=j[a+44>>2];j[d+28>>2]=e;j[d+24>>2]=f;e=-1;a:{b:{if(!Oq(Na(j[a+60>>2],d+16|0,2,d+12|0)|0)){e=j[d+12>>2];if((e|0)>0){break b}}j[a>>2]=j[a>>2]|e&48^16;break a}g=j[d+20>>2];if(g>>>0>=e>>>0){break a}f=j[a+44>>2];j[a+4>>2]=f;j[a+8>>2]=f+(e-g|0);if(j[a+48>>2]){j[a+4>>2]=f+1;h[(b+c|0)-1|0]=k[f|0]}e=c}Za=d+32|0;return e|0}function wR(a){var b=0,c=0,d=0,e=0;c=Za-32|0;Za=c;a:{b:{if(Af(a)>>>0<=tc(a)>>>0){break b}b=hb(a);d=tc(a);e=tc(a);j[114630]=0;b=P(39,c+8|0,d|0,e|0,b|0)|0;d=j[114630];j[114630]=0;c:{d:{if((d|0)!=1){j[114630]=0;F(40,a|0,b|0);a=j[114630];j[114630]=0;if((a|0)==1){break d}At(b);break b}a=J(0)|0;C()|0;break c}a=J(0)|0;C()|0;At(b)}O(a|0)|0;j[114630]=0;M(20);a=j[114630];j[114630]=0;if((a|0)==1){break a}}Za=c+32|0;return}J(0)|0;C()|0;ib();z()}function uba(a){var b=0,c=0,d=0;b=Za-48|0;Za=b;qB(b+16|0);j[114630]=0;c=E(2,b|0,39576)|0;d=j[114630];j[114630]=0;a:{b:{c:{d:{if((d|0)!=1){j[114630]=0;I(251,b+32|0,b+16|0,c|0);d=j[114630];j[114630]=0;if((d|0)==1){break d}j[114630]=0;I(9,a|0,0,b+32|0);a=j[114630];j[114630]=0;if((a|0)==1){break c}gb(b+32|0);gb(c);gb(b+16|0);Za=b+48|0;return}a=D()|0;C()|0;break a}a=D()|0;C()|0;break b}a=D()|0;C()|0;gb(b+32|0)}gb(c)}gb(b+16|0);G(a|0);z()}function tn(a,b,c){var d=0,e=0,f=0,g=0,h=0,i=0,k=0,l=0,m=0,n=0;d=Za-32|0;Za=d;j[d+24>>2]=0;j[d+28>>2]=0;j[d+16>>2]=0;j[d+20>>2]=0;j[d+12>>2]=c;a:{if(c){while(1){j[d+8>>2]=16;e=j[tb(d+8|0,d+12|0)>>2];f=j[a>>2];if((e|0)!=((k=f,l=lb(d+16|0),m=j[a+8>>2]+g|0,n=e,i=j[j[f>>2]+28>>2],bb[i](k|0,l|0,m|0,n|0)|0)|0)){break a}if(_c(d+16|0,b+g|0,e)){break a}f=j[d+12>>2]-e|0;j[d+12>>2]=f;g=e+g|0;if(f){continue}break}}Jb(a,c);h=1}Za=d+32|0;return h}function Yca(a,b){a=a|0;b=b|0;var c=0,d=q(0);j[114630]=0;N(2010,a|0);c=j[114630];j[114630]=0;a:{b:{if((c|0)!=1){c=j[a+24>>2];j[114630]=0;d=q(da(2045,c|0,b|0));b=j[114630];j[114630]=0;if((b|0)!=1){break b}}b=J(0)|0;C()|0;O(b|0)|0;j[114630]=0;L(1984,35973,a|0,0,0);a=j[114630];j[114630]=0;if((a|0)==1){break a}Q();d=q(0)}return q(d)}a=D()|0;C()|0;j[114630]=0;M(20);b=j[114630];j[114630]=0;if((b|0)!=1){G(a|0);z()}J(0)|0;C()|0;ib();z()}



function Kfa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;b=Th(a,b,c,d);j[a>>2]=80600;c=Jj(a+4256|0);d=a+4224|0;j[d>>2]=1017370378;j[d+4>>2]=1065353216;d=a+4216|0;j[d>>2]=1028670828;j[d+4>>2]=1059760811;j[a+4208>>2]=1056964608;j[a+4212>>2]=1017370378;j[114630]=0;K(1634,a+44|0,2,2)|0;d=j[114630];j[114630]=0;a:{if((d|0)==1){break a}j[114630]=0;N(1635,b|0);d=j[114630];j[114630]=0;if((d|0)==1){break a}return a|0}a=D()|0;C()|0;xf(c);Ke(b);G(a|0);z()}function qda(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;j[114630]=0;N(2010,a|0);d=j[114630];j[114630]=0;e=1;a:{b:{if((d|0)!=1){d=j[a+24>>2];j[114630]=0;I(2024,d|0,b|0,c|0);b=j[114630];j[114630]=0;if((b|0)!=1){break b}}b=J(0)|0;C()|0;O(b|0)|0;j[114630]=0;L(1984,35294,a|0,0,0);a=j[114630];j[114630]=0;if((a|0)==1){break a}Q();e=0}return e|0}a=D()|0;C()|0;j[114630]=0;M(20);b=j[114630];j[114630]=0;if((b|0)!=1){G(a|0);z()}J(0)|0;C()|0;ib();z()}function Uw(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0;e=Za-16|0;Za=e;f=e;a:{if(!Yi(b)){c=kK(a,c,j[b+704>>2],d);break a}c=j[b+700>>2]}j[f+12>>2]=c;b=j[b+656>>2];b:{if(!b){break b}f=j[b+40>>2];if(!f){break b}d=(f|0)/2|0;b=j[a+1074420>>2];b=HMa(b,b>>31,c,c>>31);c=d+b|0;d=ab+(d>>31)|0;g=e,h=ic(IMa(c,b>>>0>c>>>0?d+1|0:d,f,f>>31),ab),j[g+12>>2]=h}jc(e+12|0,2147483647);a=IMa(0,j[e+12>>2],j[a+24620>>2]<<4,0);Za=e+16|0;return a|0}function tda(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;j[114630]=0;N(2010,a|0);d=j[114630];j[114630]=0;a:{b:{if((d|0)!=1){d=j[a+24>>2];j[114630]=0;e=+ca(2020,d|0,b|0,c|0);b=j[114630];j[114630]=0;if((b|0)!=1){break b}}b=J(0)|0;C()|0;O(b|0)|0;j[114630]=0;L(1984,35224,a|0,0,0);a=j[114630];j[114630]=0;if((a|0)==1){break a}Q();e=0}return+e}a=D()|0;C()|0;j[114630]=0;M(20);b=j[114630];j[114630]=0;if((b|0)!=1){G(a|0);z()}J(0)|0;C()|0;ib();z()}function Xca(a,b){a=a|0;b=b|0;var c=0,d=q(0);j[114630]=0;N(2010,a|0);c=j[114630];j[114630]=0;a:{b:{if((c|0)!=1){c=j[a+24>>2];j[114630]=0;d=q(da(2046,c|0,b|0));b=j[114630];j[114630]=0;if((b|0)!=1){break b}}b=J(0)|0;C()|0;O(b|0)|0;j[114630]=0;L(1984,36016,a|0,0,0);a=j[114630];j[114630]=0;if((a|0)==1){break a}Q();d=q(0)}return q(d)}a=D()|0;C()|0;j[114630]=0;M(20);b=j[114630];j[114630]=0;if((b|0)!=1){G(a|0);z()}J(0)|0;C()|0;ib();z()}function Wca(a,b){a=a|0;b=b|0;var c=0,d=q(0);j[114630]=0;N(2010,a|0);c=j[114630];j[114630]=0;a:{b:{if((c|0)!=1){c=j[a+24>>2];j[114630]=0;d=q(da(2047,c|0,b|0));b=j[114630];j[114630]=0;if((b|0)!=1){break b}}b=J(0)|0;C()|0;O(b|0)|0;j[114630]=0;L(1984,36059,a|0,0,0);a=j[114630];j[114630]=0;if((a|0)==1){break a}Q();d=q(0)}return q(d)}a=D()|0;C()|0;j[114630]=0;M(20);b=j[114630];j[114630]=0;if((b|0)!=1){G(a|0);z()}J(0)|0;C()|0;ib();z()}function Vca(a,b){a=a|0;b=b|0;var c=0,d=q(0);j[114630]=0;N(2010,a|0);c=j[114630];j[114630]=0;a:{b:{if((c|0)!=1){c=j[a+24>>2];j[114630]=0;d=q(da(2048,c|0,b|0));b=j[114630];j[114630]=0;if((b|0)!=1){break b}}b=J(0)|0;C()|0;O(b|0)|0;j[114630]=0;L(1984,36103,a|0,0,0);a=j[114630];j[114630]=0;if((a|0)==1){break a}Q();d=q(0)}return q(d)}a=D()|0;C()|0;j[114630]=0;M(20);b=j[114630];j[114630]=0;if((b|0)!=1){G(a|0);z()}J(0)|0;C()|0;ib();z()}function Uca(a,b){a=a|0;b=b|0;var c=0,d=q(0);j[114630]=0;N(2010,a|0);c=j[114630];j[114630]=0;a:{b:{if((c|0)!=1){c=j[a+24>>2];j[114630]=0;d=q(da(2049,c|0,b|0));b=j[114630];j[114630]=0;if((b|0)!=1){break b}}b=J(0)|0;C()|0;O(b|0)|0;j[114630]=0;L(1984,36151,a|0,0,0);a=j[114630];j[114630]=0;if((a|0)==1){break a}Q();d=q(0)}return q(d)}a=D()|0;C()|0;j[114630]=0;M(20);b=j[114630];j[114630]=0;if((b|0)!=1){G(a|0);z()}J(0)|0;C()|0;ib();z()}function lna(a){var b=0,c=0;while(1){Tm((p(b,896)+a|0)+1074984|0,a,b&65535);b=b+1|0;if((b|0)!=256){continue}break}Ui(a+1304360|0,1);j[a+1074444>>2]=j[a+480200>>2];b=a+1074416|0;j[b>>2]=j[a+480196>>2];j[a+1074420>>2]=j[a+480204>>2];j[a+480208>>2]=j[a+480208>>2]&-769;qx(a+1074376|0);i[a+1074440>>1]=0;c=a+1074428|0;j[c>>2]=0;j[c+4>>2]=0;c=a+1074396|0;j[c>>2]=0;j[c+4>>2]=0;j[a+1074376>>2]=0;j[a+1074380>>2]=0;j[a+1074392>>2]=j[b>>2]}function vea(a){a=a|0;var b=0,c=0,d=0,e=0,f=0,g=0;h[a+4202|0]=1;b=bi(q(q(we(j[a+16>>2])>>>0)*q(.04500000178813934)));c=bi(q(q(b>>>0)*q(1.1892070770263672)));d=bi(q(q(c>>>0)*q(1.1892070770263672)));g=bi(q(q(d>>>0)*q(1.1892070770263672)));e=bi(q(q(b+d>>>0)*q(.11546666920185089)));f=bi(q(q(c+g>>>0)*q(.11546666920185089)));j[a+4292>>2]=f;j[a+4288>>2]=e;j[a+4276>>2]=d-e;j[a+4272>>2]=b-e;j[a+4284>>2]=g-f;j[a+4280>>2]=c-f;RG(a);PG(a)}function Yba(a){a=a|0;var b=0,c=0,d=0;j[114630]=0;N(2083,a|0);b=j[114630];j[114630]=0;a:{b:{if((b|0)!=1){b=j[a+28>>2];d=j[j[b>>2]+44>>2];j[114630]=0;c=+$(d|0,b|0);b=j[114630];j[114630]=0;if((b|0)!=1){break b}}b=J(0)|0;C()|0;O(b|0)|0;j[114630]=0;L(1984,37922,a|0,0,0);a=j[114630];j[114630]=0;if((a|0)==1){break a}Q();c=0}return+c}a=D()|0;C()|0;j[114630]=0;M(20);b=j[114630];j[114630]=0;if((b|0)!=1){G(a|0);z()}J(0)|0;C()|0;ib();z()}function Wba(a){a=a|0;var b=0,c=0,d=0;j[114630]=0;N(2083,a|0);b=j[114630];j[114630]=0;a:{b:{if((b|0)!=1){b=j[a+28>>2];d=j[j[b>>2]+36>>2];j[114630]=0;c=+$(d|0,b|0);b=j[114630];j[114630]=0;if((b|0)!=1){break b}}b=J(0)|0;C()|0;O(b|0)|0;j[114630]=0;L(1984,37887,a|0,0,0);a=j[114630];j[114630]=0;if((a|0)==1){break a}Q();c=0}return+c}a=D()|0;C()|0;j[114630]=0;M(20);b=j[114630];j[114630]=0;if((b|0)!=1){G(a|0);z()}J(0)|0;C()|0;ib();z()}function Uba(a){a=a|0;var b=0,c=0,d=0;j[114630]=0;N(2083,a|0);b=j[114630];j[114630]=0;a:{b:{if((b|0)!=1){b=j[a+28>>2];d=j[j[b>>2]+28>>2];j[114630]=0;c=+$(d|0,b|0);b=j[114630];j[114630]=0;if((b|0)!=1){break b}}b=J(0)|0;C()|0;O(b|0)|0;j[114630]=0;L(1984,37853,a|0,0,0);a=j[114630];j[114630]=0;if((a|0)==1){break a}Q();c=0}return+c}a=D()|0;C()|0;j[114630]=0;M(20);b=j[114630];j[114630]=0;if((b|0)!=1){G(a|0);z()}J(0)|0;C()|0;ib();z()}function P2(a,b){var c=0,d=0,e=0,f=0,g=0,h=0,i=0;d=Za-16|0;Za=d;f=(SMa(b),OMa(2));c=f&2147483647;a:{if(c-8388608>>>0<=2130706431){e=c;c=c>>>7|0;g=e<<25;c=c+1065353216|0;break a}if(c>>>0>=2139095040){c=f;e=c>>>7|0;g=c<<25;c=e|2147418112;break a}if(!c){c=0;break a}e=c;c=s(c);We(d,e,0,0,0,c+81|0);h=j[d>>2];i=j[d+4>>2];g=j[d+8>>2];c=j[d+12>>2]^65536|16265-c<<16}j[a>>2]=h;j[a+4>>2]=i;j[a+8>>2]=g;j[a+12>>2]=f&-2147483648|c;Za=d+16|0}function Lha(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0;b=Th(a,b,c,d);j[a>>2]=79480;d=Jj(a+4208|0);j[a+4220>>2]=0;j[a+4224>>2]=0;e=a,f=we(c),j[e+4232>>2]=f;j[114630]=0;N(1633,a+4260|0);c=j[114630];j[114630]=0;a:{if((c|0)==1){break a}j[114630]=0;K(1634,a+44|0,2,2)|0;c=j[114630];j[114630]=0;if((c|0)==1){break a}j[114630]=0;N(1635,b|0);c=j[114630];j[114630]=0;if((c|0)==1){break a}return a|0}a=D()|0;C()|0;xf(d);Ke(b);G(a|0);z()}function Ds(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,i=0;d=(k[Pb(a,0)|0]&15)<<8|k[Pb(a,1)|0];a:{if(!d|(d|0)==4095){break a}e=108;while(1){f=l[(c<<1)+20848>>1];if(f>>>0<=d>>>0){if(!(!c|(d|0)==(f|0)|(l[(c<<1)+20846>>1]-d|0)>=(d-f|0))){e=c+24|0;break a}e=c+25|0;break a}c=c+1|0;if(c>>>0<84){continue}break}}h[b|0]=e;c=k[Pb(a,2)|0];g=b,i=k[Pb(a,0)|0]&16|c>>>4,h[g+1|0]=i;g=b,i=k[Pb(a,2)|0]&15,h[g+3|0]=i;g=b,i=k[Pb(a,3)|0],h[g+5|0]=i}function Doa(a,b,c,d,e){var f=0,g=0;if(k[a+480209|0]&16){if((c&255)>>>0>=16){h[b+869|0]=(c&240)>>>4}a=c&15;if(a){h[b+870|0]=a}h[b+868|0]=k[b+869|0];return}c=k[b+868|0]-1|0;h[b+868|0]=c;a:{if(c&255){break a}h[b+868|0]=k[b+869|0];c=k[b+870|0];c=d?c:0-c|0;b:{if(Yi(b)){j[b+876>>2]=j[b+876>>2]+p(c,j[j[j[b+656>>2]+44>>2]+36>>2]);break b}f=b,g=Zf(a,Nr(a,j[b+700>>2],0,0)+c|0,8363,0),j[f+700>>2]=g}if(!e){break a}j[b>>2]=0;j[b+4>>2]=0}}function cea(a){a=a|0;var b=0,c=0;b=Za-16|0;Za=b;a:{b:{if(!a){break b}a=_b(b+8|0,a);j[114630]=0;c=j[a+4>>2];j[b>>2]=j[a>>2];j[b+4>>2]=c;a=H(1991,b|0)|0;c=j[114630];j[114630]=0;if((c|0)!=1){break a}a=J(0)|0;C()|0;O(a|0)|0;j[114630]=0;L(1984,34236,0,0,0);a=j[114630];j[114630]=0;if((a|0)!=1){Q();break b}a=D()|0;C()|0;j[114630]=0;M(20);b=j[114630];j[114630]=0;if((b|0)!=1){G(a|0);z()}J(0)|0;C()|0;ib();z()}a=0}Za=b+16|0;return a|0}function Gz(a,b,c){var d=0,e=0,f=0,g=0,h=0,i=0,k=0,l=0,m=0,n=0;d=Za-32|0;Za=d;j[d+24>>2]=0;j[d+28>>2]=0;j[d+16>>2]=0;j[d+20>>2]=0;j[d+12>>2]=c;a:{if(c){while(1){j[d+8>>2]=16;e=j[tb(d+8|0,d+12|0)>>2];if((e|0)!=((k=a,l=lb(d+16|0),m=j[a+12>>2]+f|0,n=e,i=j[j[a>>2]+28>>2],bb[i](k|0,l|0,m|0,n|0)|0)|0)){break a}if(_c(d+16|0,b+f|0,e)){break a}g=j[d+12>>2]-e|0;j[d+12>>2]=g;f=e+f|0;if(g){continue}break}}Fc(a,c);h=1}Za=d+32|0;return h}function nHa(a,b){var c=0;md(b,0);c=a+32|0;j[b>>2]=k[c|0]|k[c+1|0]<<8|(k[c+2|0]<<16|k[c+3|0]<<24);c=a+38|0;j[b+4>>2]=k[c|0]|k[c+1|0]<<8|(k[c+2|0]<<16|k[c+3|0]<<24);c=a+42|0;c=k[c|0]|k[c+1|0]<<8|(k[c+2|0]<<16|k[c+3|0]<<24);j[b+24>>2]=16726;j[b+8>>2]=c;i[b+30>>1]=k[a+37|0]<<4;if(h[a+46|0]&1){j[b>>2]=j[b>>2]>>>1;j[b+4>>2]=j[b+4>>2]>>>1;j[b+8>>2]=j[b+8>>2]>>>1}if(!(!(k[a+47|0]&8)|m[b+8>>2]<=m[b+4>>2])){i[b+34>>1]=l[b+34>>1]|2}}function Wwa(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0;g=Za-48|0;Za=g;a:{b:{if(c>>>0>d>>>0){break b}if(me(b)>>>0<=d>>>0){break b}while(1){f=c&65535;if(uh(te(b,f))){h=Lb(te(b,f));i=Mb(te(b,f));f=WM(g,e);j[114630]=0;L(1026,g+24|0,h|0,i|0,f|0);h=j[114630];j[114630]=0;if((h|0)==1){break a}Vd(g+24|0);Vd(f)}c=c+1|0;if((c&65535)>>>0<=d>>>0){continue}break}}VM(a,e);Za=g+48|0;return}a=D()|0;C()|0;Vd(f);G(a|0);z()}function E3(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0;e=Za-16|0;Za=e;while(1){a:{if((c|0)<=(f|0)){break a}d=j[a+16>>2];g=j[a+12>>2];b:{if(d>>>0>g>>>0){j[e+12>>2]=2147483647;j[e+8>>2]=d-g>>2;j[e+4>>2]=c-f;d=j[Pd(e+12|0,Pd(e+8|0,e+4|0))>>2];Jh(b,j[a+12>>2],d);j[a+12>>2]=j[a+12>>2]+(d<<2);b=(d<<2)+b|0;break b}d=bb[j[j[a>>2]+40>>2]](a)|0;if((d|0)==-1){break a}j[b>>2]=d;d=1;b=b+4|0}f=d+f|0;continue}break}Za=e+16|0;return f|0}function q5(a){var b=0,c=0,d=0,e=0;Ab(a+36|0,255,2048);b=j[(k[a+23|0]?2092:4)+a>>2];if((b|0)>=1){b=(b|0)<32767?b:32767;e=(b|0)>1?b:1;d=j[a+8>>2];while(1){a:{if(k[c+d|0]>10){break a}b:{if(k[a+23|0]){b=Pk(j[j[a+2084>>2]+(c<<2)>>2]);break b}b=j[j[a+32>>2]+(c<<2)>>2]}if(b>>>0>1023){break a}while(1){i[((b<<1)+a|0)+36>>1]=c;d=j[a+8>>2];b=(1<<k[d+c|0])+b|0;if(b>>>0<1024){continue}break}}c=c+1|0;if((e|0)!=(c|0)){continue}break}}}function mba(a){var b=0,c=0,d=0;b=Za-48|0;Za=b;c=Db(b+16|0,39581);j[114630]=0;F(2115,b|0,2);d=j[114630];j[114630]=0;a:{b:{c:{d:{if((d|0)!=1){j[114630]=0;I(3,b+32|0,c|0,b|0);d=j[114630];j[114630]=0;if((d|0)==1){break d}j[114630]=0;I(9,a|0,0,b+32|0);a=j[114630];j[114630]=0;if((a|0)==1){break c}gb(b+32|0);gb(b);gb(c);Za=b+48|0;return}a=D()|0;C()|0;break a}a=D()|0;C()|0;break b}a=D()|0;C()|0;gb(b+32|0)}gb(b)}gb(c);G(a|0);z()}function I3(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,i=0,k=0;e=Za-16|0;Za=e;while(1){a:{if((c|0)<=(f|0)){break a}d=j[a+16>>2];g=j[a+12>>2];b:{if(d>>>0>g>>>0){j[e+12>>2]=2147483647;j[e+8>>2]=d-g;j[e+4>>2]=c-f;d=j[Pd(e+12|0,Pd(e+8|0,e+4|0))>>2];kh(b,j[a+12>>2],d);j[a+12>>2]=j[a+12>>2]+d;break b}d=bb[j[j[a>>2]+40>>2]](a)|0;if((d|0)==-1){break a}i=b,k=tm(d),h[i|0]=k;d=1}b=b+d|0;f=d+f|0;continue}break}Za=e+16|0;return f|0}function yda(a,b){a=a|0;b=b|0;var c=0,d=0;j[114630]=0;N(2010,a|0);c=j[114630];j[114630]=0;d=1;a:{b:{if((c|0)!=1){c=j[a+24>>2];j[114630]=0;F(2015,c|0,b|0);b=j[114630];j[114630]=0;if((b|0)!=1){break b}}b=J(0)|0;C()|0;O(b|0)|0;j[114630]=0;L(1984,35052,a|0,0,0);a=j[114630];j[114630]=0;if((a|0)==1){break a}Q();d=0}return d|0}a=D()|0;C()|0;j[114630]=0;M(20);b=j[114630];j[114630]=0;if((b|0)!=1){G(a|0);z()}J(0)|0;C()|0;ib();z()}function u7(a,b){var c=0,d=0,e=0,f=0;c=Za-80|0;Za=c;d=j[a>>2];f=j[d+4>>2];j[c+40>>2]=j[d+20>>2];e=j[d+16>>2];j[c+32>>2]=j[d+12>>2];j[c+36>>2]=e;mm(c- -64|0,c+32|0,f);d=Xd(c+48|0,j[j[a+4>>2]>>2],j[j[a+8>>2]>>2],j[j[a+12>>2]>>2]);f=j[j[a+12>>2]>>2];a=j[j[a+8>>2]>>2];j[c+24>>2]=j[c+72>>2];e=j[c+68>>2];j[c+16>>2]=j[c+64>>2];j[c+20>>2]=e;j[c+8>>2]=j[d+8>>2];e=j[d+4>>2];j[c>>2]=j[d>>2];j[c+4>>2]=e;s7(c+16|0,c,b,a,f);Za=c+80|0}function t7(a,b){var c=0,d=0,e=0,f=0;c=Za-80|0;Za=c;d=j[a>>2];f=j[d+4>>2];j[c+40>>2]=j[d+20>>2];e=j[d+16>>2];j[c+32>>2]=j[d+12>>2];j[c+36>>2]=e;mm(c- -64|0,c+32|0,f);d=Xd(c+48|0,j[j[a+4>>2]>>2],j[j[a+8>>2]>>2],j[j[a+12>>2]>>2]);f=j[j[a+12>>2]>>2];a=j[j[a+8>>2]>>2];j[c+24>>2]=j[c+72>>2];e=j[c+68>>2];j[c+16>>2]=j[c+64>>2];j[c+20>>2]=e;j[c+8>>2]=j[d+8>>2];e=j[d+4>>2];j[c>>2]=j[d>>2];j[c+4>>2]=e;q7(c+16|0,c,b,a,f);Za=c+80|0}function o7(a,b){var c=0,d=0,e=0,f=0;c=Za-80|0;Za=c;d=j[a>>2];f=j[d+4>>2];j[c+40>>2]=j[d+20>>2];e=j[d+16>>2];j[c+32>>2]=j[d+12>>2];j[c+36>>2]=e;mm(c- -64|0,c+32|0,f);d=Xd(c+48|0,j[j[a+4>>2]>>2],j[j[a+8>>2]>>2],j[j[a+12>>2]>>2]);f=j[j[a+12>>2]>>2];a=j[j[a+8>>2]>>2];j[c+24>>2]=j[c+72>>2];e=j[c+68>>2];j[c+16>>2]=j[c+64>>2];j[c+20>>2]=e;j[c+8>>2]=j[d+8>>2];e=j[d+4>>2];j[c>>2]=j[d>>2];j[c+4>>2]=e;m7(c+16|0,c,b,a,f);Za=c+80|0}function n7(a,b){var c=0,d=0,e=0,f=0;c=Za-80|0;Za=c;d=j[a>>2];f=j[d+4>>2];j[c+40>>2]=j[d+20>>2];e=j[d+16>>2];j[c+32>>2]=j[d+12>>2];j[c+36>>2]=e;mm(c- -64|0,c+32|0,f);d=Xd(c+48|0,j[j[a+4>>2]>>2],j[j[a+8>>2]>>2],j[j[a+12>>2]>>2]);f=j[j[a+12>>2]>>2];a=j[j[a+8>>2]>>2];j[c+24>>2]=j[c+72>>2];e=j[c+68>>2];j[c+16>>2]=j[c+64>>2];j[c+20>>2]=e;j[c+8>>2]=j[d+8>>2];e=j[d+4>>2];j[c>>2]=j[d>>2];j[c+4>>2]=e;k7(c+16|0,c,b,a,f);Za=c+80|0}function e7(a,b){var c=0,d=0,e=0,f=0;c=Za-80|0;Za=c;d=j[a>>2];f=j[d+4>>2];j[c+40>>2]=j[d+20>>2];e=j[d+16>>2];j[c+32>>2]=j[d+12>>2];j[c+36>>2]=e;fo(c- -64|0,c+32|0,f);d=Xd(c+48|0,j[j[a+4>>2]>>2],j[j[a+8>>2]>>2],j[j[a+12>>2]>>2]);f=j[j[a+12>>2]>>2];a=j[j[a+8>>2]>>2];j[c+24>>2]=j[c+72>>2];e=j[c+68>>2];j[c+16>>2]=j[c+64>>2];j[c+20>>2]=e;j[c+8>>2]=j[d+8>>2];e=j[d+4>>2];j[c>>2]=j[d>>2];j[c+4>>2]=e;c7(c+16|0,c,b,a,f);Za=c+80|0}function a7(a,b){var c=0,d=0,e=0,f=0;c=Za-80|0;Za=c;d=j[a>>2];f=j[d+4>>2];j[c+40>>2]=j[d+20>>2];e=j[d+16>>2];j[c+32>>2]=j[d+12>>2];j[c+36>>2]=e;fo(c- -64|0,c+32|0,f);d=Xd(c+48|0,j[j[a+4>>2]>>2],j[j[a+8>>2]>>2],j[j[a+12>>2]>>2]);f=j[j[a+12>>2]>>2];a=j[j[a+8>>2]>>2];j[c+24>>2]=j[c+72>>2];e=j[c+68>>2];j[c+16>>2]=j[c+64>>2];j[c+20>>2]=e;j[c+8>>2]=j[d+8>>2];e=j[d+4>>2];j[c>>2]=j[d>>2];j[c+4>>2]=e;_6(c+16|0,c,b,a,f);Za=c+80|0}function _q(a,b){var c=0,d=0,e=0,f=0;c=Za-80|0;Za=c;d=j[a>>2];f=j[d+4>>2];j[c+40>>2]=j[d+20>>2];e=j[d+16>>2];j[c+32>>2]=j[d+12>>2];j[c+36>>2]=e;fo(c- -64|0,c+32|0,f);d=Xd(c+48|0,j[j[a+4>>2]>>2],j[j[a+8>>2]>>2],j[j[a+12>>2]>>2]);f=j[j[a+12>>2]>>2];a=j[j[a+8>>2]>>2];j[c+24>>2]=j[c+72>>2];e=j[c+68>>2];j[c+16>>2]=j[c+64>>2];j[c+20>>2]=e;j[c+8>>2]=j[d+8>>2];e=j[d+4>>2];j[c>>2]=j[d>>2];j[c+4>>2]=e;d7(c+16|0,c,b,a,f);Za=c+80|0}function T7(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=a+32|0;zi(c,b);j[a+44>>2]=0;b=j[a+48>>2];if(b&8){d=a,e=zb(c)+nb(c)|0,j[d+44>>2]=e;um(a,zb(c),zb(c),j[a+44>>2]);b=j[a+48>>2]}a:{if(!(b&16)){break a}b=nb(c);d=a,e=b+zb(c)|0,j[d+44>>2]=e;rm(c,sc(c));ew(a,zb(c),zb(c)+nb(c)|0);if(!(k[a+48|0]&3)){break a}b:{if((b|0)<=-1){c=b-2147483647|0;while(1){b=c;kr(a,2147483647);c=1;if((b|0)<0){continue}break}break b}if(!b){break a}}kr(a,b)}}function Pv(a,b){var c=0,d=0,e=0,f=0;c=Za-80|0;Za=c;d=j[a>>2];f=j[d+4>>2];j[c+40>>2]=j[d+20>>2];e=j[d+16>>2];j[c+32>>2]=j[d+12>>2];j[c+36>>2]=e;mm(c- -64|0,c+32|0,f);d=Xd(c+48|0,j[j[a+4>>2]>>2],j[j[a+8>>2]>>2],j[j[a+12>>2]>>2]);f=j[j[a+12>>2]>>2];a=j[j[a+8>>2]>>2];j[c+24>>2]=j[c+72>>2];e=j[c+68>>2];j[c+16>>2]=j[c+64>>2];j[c+20>>2]=e;j[c+8>>2]=j[d+8>>2];e=j[d+4>>2];j[c>>2]=j[d>>2];j[c+4>>2]=e;r7(c+16|0,c,b,a,f);Za=c+80|0}function Ov(a,b){var c=0,d=0,e=0,f=0;c=Za-80|0;Za=c;d=j[a>>2];f=j[d+4>>2];j[c+40>>2]=j[d+20>>2];e=j[d+16>>2];j[c+32>>2]=j[d+12>>2];j[c+36>>2]=e;mm(c- -64|0,c+32|0,f);d=Xd(c+48|0,j[j[a+4>>2]>>2],j[j[a+8>>2]>>2],j[j[a+12>>2]>>2]);f=j[j[a+12>>2]>>2];a=j[j[a+8>>2]>>2];j[c+24>>2]=j[c+72>>2];e=j[c+68>>2];j[c+16>>2]=j[c+64>>2];j[c+20>>2]=e;j[c+8>>2]=j[d+8>>2];e=j[d+4>>2];j[c>>2]=j[d>>2];j[c+4>>2]=e;l7(c+16|0,c,b,a,f);Za=c+80|0}function Nv(a,b){var c=0,d=0,e=0,f=0;c=Za-80|0;Za=c;d=j[a>>2];f=j[d+4>>2];j[c+40>>2]=j[d+20>>2];e=j[d+16>>2];j[c+32>>2]=j[d+12>>2];j[c+36>>2]=e;fo(c- -64|0,c+32|0,f);d=Xd(c+48|0,j[j[a+4>>2]>>2],j[j[a+8>>2]>>2],j[j[a+12>>2]>>2]);f=j[j[a+12>>2]>>2];a=j[j[a+8>>2]>>2];j[c+24>>2]=j[c+72>>2];e=j[c+68>>2];j[c+16>>2]=j[c+64>>2];j[c+20>>2]=e;j[c+8>>2]=j[d+8>>2];e=j[d+4>>2];j[c>>2]=j[d>>2];j[c+4>>2]=e;Z6(c+16|0,c,b,a,f);Za=c+80|0}function Ada(a,b){a=a|0;b=b|0;var c=0,d=0;j[114630]=0;N(2010,a|0);c=j[114630];j[114630]=0;d=1;a:{b:{if((c|0)!=1){c=j[a+24>>2];j[114630]=0;F(2013,c|0,b|0);b=j[114630];j[114630]=0;if((b|0)!=1){break b}}b=J(0)|0;C()|0;O(b|0)|0;j[114630]=0;L(1984,34986,a|0,0,0);a=j[114630];j[114630]=0;if((a|0)==1){break a}Q();d=0}return d|0}a=D()|0;C()|0;j[114630]=0;M(20);b=j[114630];j[114630]=0;if((b|0)!=1){G(a|0);z()}J(0)|0;C()|0;ib();z()}function $6(a,b){var c=0,d=0,e=0,f=0;c=Za-80|0;Za=c;d=j[a>>2];f=j[d+4>>2];j[c+40>>2]=j[d+20>>2];e=j[d+16>>2];j[c+32>>2]=j[d+12>>2];j[c+36>>2]=e;fo(c- -64|0,c+32|0,f);d=Xd(c+48|0,j[j[a+4>>2]>>2],j[j[a+8>>2]>>2],j[j[a+12>>2]>>2]);f=j[j[a+12>>2]>>2];a=j[j[a+8>>2]>>2];j[c+24>>2]=j[c+72>>2];e=j[c+68>>2];j[c+16>>2]=j[c+64>>2];j[c+20>>2]=e;j[c+8>>2]=j[d+8>>2];e=j[d+4>>2];j[c>>2]=j[d>>2];j[c+4>>2]=e;Y6(c+16|0,c,b,a,f);Za=c+80|0}function md(a,b){a=a|0;b=b|0;var c=0,d=0;d=Za-16|0;Za=d;Sm(a);j[a+16>>2]=0;j[a+8>>2]=0;j[a+12>>2]=0;j[a>>2]=0;j[a+4>>2]=0;i[a+32>>1]=64;j[a+24>>2]=8363;j[a+28>>2]=16777344;j[a+36>>2]=0;h[a+39|0]=0;h[a+40|0]=0;h[a+41|0]=0;h[a+42|0]=0;c=l[a+34>>1]&-25151;i[a+34>>1]=(b|0)==4?c|32:c;b=Db(d,18532);j[114630]=0;E(370,a+43|0,b|0)|0;c=j[114630];j[114630]=0;if((c|0)!=1){gb(b);qM(a);Za=d+16|0;return}a=D()|0;C()|0;gb(b);G(a|0);z()}function cI(a,b,c){var d=0,e=0;d=Za-16|0;Za=d;a:{if(sb(a)>>>0>511){break a}if(!mf(j[j[b>>2]-12>>2]+b|0)){break a}Xha(d+8|0,b,c);b:{c:{if(!$c(d+8|0)){j[114630]=0;I(1626,d|0,b|0,c|0);b=j[114630];j[114630]=0;if((b|0)==1){break c}oQ(d+8|0,ud(d));Kf(d)}if(!$c(d+8|0)){break b}e=j[d+8>>2];j[114630]=0;F(1627,a|0,d+8|0);a=j[114630];j[114630]=0;if((a|0)!=1){break b}}a=D()|0;C()|0;Kf(d+8|0);G(a|0);z()}Kf(d+8|0)}Za=d+16|0;return e}function JE(a){var b=q(0),c=0,d=q(0),e=q(0),f=q(0),g=q(0),h=0,i=q(0),j=0,k=0,l=q(0),m=q(0),o=q(0),p=q(0),r=0;j=a-24|0;b=n[j>>2];c=a-8|0;d=n[c>>2];e=q(b+d);k=a-16|0;f=n[k>>2];l=n[a>>2];g=q(f+l);n[a>>2]=e+g;n[c>>2]=g-e;c=a-28|0;g=n[c>>2];h=a-12|0;m=n[h>>2];e=q(g+m);r=h;h=a-20|0;i=n[h>>2];a=a-4|0;o=n[a>>2];p=q(i+o);n[r>>2]=p-e;i=q(o-i);b=q(d-b);n[c>>2]=i+b;d=q(m-g);f=q(l-f);n[k>>2]=d+f;n[j>>2]=f-d;n[a>>2]=p+e;n[h>>2]=i-b}function lAa(a){var b=0;b=Za-16|0;Za=b;h[a|0]=0;h[a+1|0]=0;h[a+2|0]=0;h[a+3|0]=0;h[a+4|0]=0;h[a+5|0]=0;h[a+6|0]=0;h[a+7|0]=0;h[a+24|0]=0;h[a+25|0]=0;h[a+26|0]=0;h[a+27|0]=0;h[a+28|0]=0;h[a+29|0]=0;h[a+30|0]=0;h[a+31|0]=0;h[a+16|0]=0;h[a+17|0]=0;h[a+18|0]=0;h[a+19|0]=0;h[a+20|0]=0;h[a+21|0]=0;h[a+22|0]=0;h[a+23|0]=0;h[a+8|0]=0;h[a+9|0]=0;h[a+10|0]=0;h[a+11|0]=0;h[a+12|0]=0;h[a+13|0]=0;h[a+14|0]=0;h[a+15|0]=0;Za=b+16|0}function uo(a,b,c){var d=0,e=0;a=Le(a);d=nb(b);j[114630]=0;F(113,a|0,d|0);d=j[114630];j[114630]=0;if((d|0)!=1){a:{if(nb(b)){while(1){d=k[Ub(b,e)|0];b:{if(d>>>0<256){d=j[(d<<2)+c>>2];j[114630]=0;F(112,a|0,d|0);d=j[114630];j[114630]=0;if((d|0)!=1){break b}break a}j[114630]=0;F(112,a|0,65533);d=j[114630];j[114630]=0;if((d|0)==1){break a}}e=e+1|0;if(nb(b)>>>0>e>>>0){continue}break}}return}}b=D()|0;C()|0;pc(a);G(b|0);z()}function Gca(a,b){a=a|0;b=b|0;var c=0;j[114630]=0;N(2010,a|0);c=j[114630];j[114630]=0;a:{b:{if((c|0)!=1){c=j[a+24>>2];j[114630]=0;b=E(2063,c|0,b|0)|0;c=j[114630];j[114630]=0;if((c|0)!=1){break b}}b=J(0)|0;C()|0;O(b|0)|0;j[114630]=0;L(1984,36599,a|0,0,0);a=j[114630];j[114630]=0;if((a|0)==1){break a}Q();b=0}return b|0}a=D()|0;C()|0;j[114630]=0;M(20);b=j[114630];j[114630]=0;if((b|0)!=1){G(a|0);z()}J(0)|0;C()|0;ib();z()}function Fca(a,b){a=a|0;b=b|0;var c=0;j[114630]=0;N(2010,a|0);c=j[114630];j[114630]=0;a:{b:{if((c|0)!=1){c=j[a+24>>2];j[114630]=0;b=E(2064,c|0,b|0)|0;c=j[114630];j[114630]=0;if((c|0)!=1){break b}}b=J(0)|0;C()|0;O(b|0)|0;j[114630]=0;L(1984,36632,a|0,0,0);a=j[114630];j[114630]=0;if((a|0)==1){break a}Q();b=0}return b|0}a=D()|0;C()|0;j[114630]=0;M(20);b=j[114630];j[114630]=0;if((b|0)!=1){G(a|0);z()}J(0)|0;C()|0;ib();z()}function BO(a){var b=0;b=Za-16|0;Za=b;h[a|0]=0;h[a+1|0]=0;h[a+2|0]=0;h[a+3|0]=0;h[a+4|0]=0;h[a+5|0]=0;h[a+6|0]=0;h[a+7|0]=0;h[a+22|0]=0;h[a+23|0]=0;h[a+24|0]=0;h[a+25|0]=0;h[a+26|0]=0;h[a+27|0]=0;h[a+28|0]=0;h[a+29|0]=0;h[a+16|0]=0;h[a+17|0]=0;h[a+18|0]=0;h[a+19|0]=0;h[a+20|0]=0;h[a+21|0]=0;h[a+22|0]=0;h[a+23|0]=0;h[a+8|0]=0;h[a+9|0]=0;h[a+10|0]=0;h[a+11|0]=0;h[a+12|0]=0;h[a+13|0]=0;h[a+14|0]=0;h[a+15|0]=0;Za=b+16|0}function cwa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,k=0,l=0;b=Za-16|0;Za=b;g=j[a+24>>2];h=j[a+20>>2];k=j[a+16>>2];e=j[a+4>>2];f=j[a>>2];j[b+8>>2]=f;j[b+12>>2]=e;l=j[a+12>>2];j[b>>2]=j[a+8>>2];j[b+4>>2]=l;if(d){while(1){e=i[(e<<1)+k>>1];j[c>>2]=j[c>>2]+p(e,h);j[c+4>>2]=j[c+4>>2]+p(e,g);Bb(b+8|0,b);d=d-1|0;if(d){c=c+8|0;e=j[b+12>>2];continue}break}f=j[b+8>>2];e=j[b+12>>2]}j[a>>2]=f;j[a+4>>2]=e;Za=b+16|0}function _9(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0;f=Za-16|0;Za=f;a:{b:{c:{if(!(e?d:0)){b=R(8)|0;j[114630]=0;c=E(85,f|0,38697)|0;a=j[114630];j[114630]=0;if((a|0)==1){break c}Wb(b,c);j[114630]=0;I(2004,b|0,83648,2012);a=j[114630];j[114630]=0;if((a|0)!=1){break a}a=D()|0;C()|0;gb(c);break b}Qh(a,b,2);c=Yv(a,c,d,e,0,0);o[a+16>>3]=+(c>>>0)/+(b|0)+o[a+16>>3];Za=f+16|0;return c|0}a=D()|0;C()|0;S(b|0)}G(a|0)}z()}function X9(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0;f=Za-16|0;Za=f;a:{b:{c:{if(!(e?d:0)){b=R(8)|0;j[114630]=0;c=E(85,f|0,38697)|0;a=j[114630];j[114630]=0;if((a|0)==1){break c}Wb(b,c);j[114630]=0;I(2004,b|0,83648,2012);a=j[114630];j[114630]=0;if((a|0)!=1){break a}a=D()|0;C()|0;gb(c);break b}Qh(a,b,2);c=Xv(a,c,d,e,0,0);o[a+16>>3]=+(c>>>0)/+(b|0)+o[a+16>>3];Za=f+16|0;return c|0}a=D()|0;C()|0;S(b|0)}G(a|0)}z()}function KX(){var a=0,b=0,c=0,d=0,e=0,f=0;a=Za-48|0;Za=a;a:{b=j[115935];if(b){c=b+48|0;if(JB(c)){d=a;if(j[c>>2]==1126902529&j[c+4>>2]==1129074247){c=j[b+44>>2]}else{c=b+80|0}j[d+44>>2]=c;d=j[b>>2];b=j[d+4>>2];if(bb[j[j[17847]+16>>2]](71388,d,a+44|0)|0){break a}j[a+20>>2]=b;j[a+16>>2]=j[21347];z()}j[a+32>>2]=j[21347];z()}z()}c=j[21347];d=j[a+44>>2];e=a,f=bb[j[j[d>>2]+8>>2]](d)|0,j[e+8>>2]=f;j[a+4>>2]=b;j[a>>2]=c;z()}function Eoa(a,b,c){var d=0,e=0,f=0,g=0,i=0;a:{if(c){h[b+836|0]=c;break a}c=k[b+836|0]}b:{c:{d:{e=c&240;d=c&15;if(!(!e|(d|0)!=15)){if(!(k[a+480209|0]&16)){break b}break d}f=j[a+480208>>2]&4096;if(!(!d|(e|0)!=240)){if(!f){break b}c=0-d|0;break c}if(f){break b}if(!d){break d}c=0-d|0;if(!e){break c}if(j[a+480180>>2]&25690144){break b}break c}c=(c&255)>>>4|0;if(!c){break b}}g=b,i=Gb(j[b+760>>2]+c|0,0,64),j[g+760>>2]=i}}function BA(a){var b=0;a:{if((k[a|0]|k[a+1|0]<<8|(k[a+2|0]<<16|k[a+3|0]<<24))!=1179340888|(k[a+8|0]|k[a+9|0]<<8|(k[a+10|0]<<16|k[a+11|0]<<24))!=1213419859){break a}b=a+4|0;if(!(k[b|0]|k[b+1|0]<<8|(k[b+2|0]<<16|k[b+3|0]<<24))){break a}a=a+12|0;if(!(k[a|0]|k[a+1|0]<<8|(k[a+2|0]<<16|k[a+3|0]<<24))){break a}a=k[b|0]|k[b+1|0]<<8|(k[b+2|0]<<16|k[b+3|0]<<24);return(a<<24|a<<8&16711680|(a>>>8&65280|a>>>24))>>>0>27}return 0}function kca(a){a=a|0;var b=0;j[114630]=0;N(2083,a|0);b=j[114630];j[114630]=0;if((b|0)!=1){j[a+24>>2]=0;b=j[a+28>>2];if(b){bb[j[j[b>>2]+4>>2]](b)}j[a+28>>2]=0;b=j[a+20>>2];if(b){Fb(b);j[a+20>>2]=0}Fb(a);return}b=J(0)|0;C()|0;O(b|0)|0;j[114630]=0;L(1984,37293,a|0,0,0);a=j[114630];j[114630]=0;if((a|0)!=1){Q();return}a=D()|0;C()|0;j[114630]=0;M(20);b=j[114630];j[114630]=0;if((b|0)!=1){G(a|0);z()}J(0)|0;C()|0;ib();z()}function vda(a,b){a=a|0;b=+b;var c=0;j[114630]=0;N(2010,a|0);c=j[114630];j[114630]=0;a:{b:{if((c|0)!=1){c=j[a+24>>2];j[114630]=0;b=+Va(2018,c|0,+b);c=j[114630];j[114630]=0;if((c|0)!=1){break b}}c=J(0)|0;C()|0;O(c|0)|0;j[114630]=0;L(1984,35152,a|0,0,0);a=j[114630];j[114630]=0;if((a|0)==1){break a}Q();b=0}return+b}a=D()|0;C()|0;j[114630]=0;M(20);c=j[114630];j[114630]=0;if((c|0)!=1){G(a|0);z()}J(0)|0;C()|0;ib();z()}function dwa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,i=0,k=0,l=0;b=Za-16|0;Za=b;g=j[a+24>>2];i=j[a+20>>2];k=j[a+16>>2];e=j[a+4>>2];f=j[a>>2];j[b+8>>2]=f;j[b+12>>2]=e;l=j[a+12>>2];j[b>>2]=j[a+8>>2];j[b+4>>2]=l;if(d){while(1){e=h[e+k|0]<<8;j[c>>2]=j[c>>2]+p(e,i);j[c+4>>2]=j[c+4>>2]+p(e,g);Bb(b+8|0,b);d=d-1|0;if(d){c=c+8|0;e=j[b+12>>2];continue}break}f=j[b+8>>2];e=j[b+12>>2]}j[a>>2]=f;j[a+4>>2]=e;Za=b+16|0}function R5(a,b){var c=0,d=0,e=0;a:{b:{c:{c=k[a+3|0];e=c>>>6|0;switch(e-1|0){case 2:break a;case 0:break c;default:break b}}d=(c>>>2&12)+4|0;break a}d=32}c=k[a+1|0];d:{if((c&6)==6){a=32;c=50204;break d}if(!(c&8)){a=30;c=50207;break d}c=k[a+2|0]>>>2&3;a=Iv(a)>>>((e|0)!=3)|0;a=a?a:192;if(a>>>0<=55){a=(c|0)==2?12:8;c=50228;break d}a=(c|0)!=1?a>>>0>95?30:27:27;c=50216}h[b+768|0]=a;h[b+769|0]=(a|0)<(d|0)?a:d;return c}function Oka(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,l=0;d=Za-32|0;Za=d;_s(d,2,a+2|0);qc(d+16|0,d);j[114630]=0;E(369,b+492|0,d+16|0)|0;e=j[114630];j[114630]=0;if((e|0)!=1){gb(d+16|0);e=b+236|0;f=c+1|0;c=0;while(1){g=k[(a+c|0)+31|0];h=Nc(e,c),l=f+g|0,i[h>>1]=l;c=c+1|0;if(c>>>0<120){continue}break}c=a+223|0;j[b>>2]=(k[c|0]|k[c+1|0]<<8)<<5;Eka(a+158|0,b);Za=d+32|0;return}a=D()|0;C()|0;gb(d+16|0);G(a|0);z()}function qu(a,b,c,d,e,f,g,i){var k=0,l=0,m=0;k=Za-16|0;Za=k;if((b^-1)-17>>>0>=c>>>0){l=zb(a);a:{if(b>>>0<2147483623){j[k+8>>2]=b<<1;j[k+12>>2]=b+c;c=Fk(j[Lc(k+12|0,k+8|0)>>2]);break a}c=-18}m=c+1|0;c=Rh(m);if(e){kh(c,l,e)}if(g){kh(c+e|0,i,g)}d=d-f|0;i=d-e|0;if(i){kh((c+e|0)+g|0,(e+l|0)+f|0,i)}b=b+1|0;if((b|0)!=11){Yf(a,l,b)}lf(a,c);lg(a,m);b=a;a=d+g|0;ee(b,a);h[k+7|0]=0;Sd(a+c|0,k+7|0);Za=k+16|0;return}jg();z()}function d2(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0;e=Za-16|0;Za=e;a:{b:{if((a|0)!=(b|0)){g=j[114604];j[114604]=0;d=hD(a,e+12|0,d,Wd());a=ab;f=j[114604];c:{if(f){if(j[e+12>>2]!=(b|0)){break c}if((f|0)==68){break b}break a}j[114604]=g;if(j[e+12>>2]==(b|0)){break a}}}j[c>>2]=4;d=0;a=0;break a}j[c>>2]=4;if((a|0)>0?1:(a|0)>=0?d>>>0>=1:0){d=-1;a=2147483647;break a}d=0;a=-2147483648}Za=e+16|0;ab=a;return d|0}function cs(a,b,c){var d=0,e=0,f=0,g=0,h=0,i=0;d=Za-16|0;Za=d;j[b+40>>2]=0;j[b+44>>2]=0;e=b- -64|0;j[e>>2]=0;j[e+4>>2]=0;j[b+56>>2]=0;j[b+60>>2]=0;j[b+48>>2]=0;j[b+52>>2]=0;while(1){xL(b,o[wk(c,0)>>3]);f=f+1|0;if((f|0)!=1e4){continue}break}g=d,h=Lb(c),j[g+8>>2]=h;g=d,h=Mb(c),j[g>>2]=h;if(rb(d+8|0,d)){while(1){e=j[d+8>>2];g=e,i=xL(b,o[e>>3]),o[g>>3]=i;Cx(d+8|0);if(rb(d+8|0,d)){continue}break}}Hra(a,c);Za=d+16|0}function Av(a){var b=0,c=0,d=0;a:{b:{if(!j[a+1384>>2]){b=j[a+1380>>2];if((b|0)==-1){j[a+1388>>2]=j[a+1116>>2]-1;if(!Wq(a)){j[a+1384>>2]=1;return 0}if(!(h[a+1375|0]&1)){break b}b=j[a+1380>>2]}d=b+1|0;j[a+1380>>2]=d;c=k[(a+b|0)+1120|0];if((c|0)!=255){j[a+1388>>2]=b;j[a+1384>>2]=1}if(j[a+1116>>2]<=(d|0)){j[a+1380>>2]=-1}if(k[a+1376|0]){break a}h[a+1376|0]=c}return c}Nb(a,32);return 0}Y(50630,50512,1549,50651);z()}function zda(a){a=a|0;var b=0,c=0;j[114630]=0;N(2010,a|0);b=j[114630];j[114630]=0;a:{b:{if((b|0)!=1){b=j[a+24>>2];j[114630]=0;b=H(2014,b|0)|0;c=j[114630];j[114630]=0;if((c|0)!=1){break b}}b=J(0)|0;C()|0;O(b|0)|0;j[114630]=0;L(1984,35016,a|0,0,0);a=j[114630];j[114630]=0;if((a|0)==1){break a}Q();b=-1}return b|0}a=D()|0;C()|0;j[114630]=0;M(20);b=j[114630];j[114630]=0;if((b|0)!=1){G(a|0);z()}J(0)|0;C()|0;ib();z()}function laa(a,b,c){a=a|0;b=+b;c=c|0;var d=0,e=0,f=0,g=0;d=Za+ -64|0;Za=d;e=j[a>>2];f=j[a+4>>2];g=j[a+12>>2];a=j[a+8>>2];j[d+16>>2]=a;j[d+20>>2]=g;j[d+40>>2]=a;j[d+44>>2]=g;j[d+32>>2]=e;j[d+36>>2]=f;j[d+8>>2]=e;j[d+12>>2]=f;fG(d+48|0,d+8|0,0);a=ho(d+24|0,c);j[114630]=0;b=+la(2155,d+48|0,+b,a|0);c=j[114630];j[114630]=0;if((c|0)!=1){Gc(a);jb(d+48|0);Za=d- -64|0;return+b}c=D()|0;C()|0;Gc(a);jb(d+48|0);G(c|0);z()}function jea(a,b,c,d){var e=0,f=0,g=0,h=0,i=0,k=0;f=j[a+4160>>2];g=j[a+4156>>2];if(d){k=j[a+4164>>2];e=j[a+4168>>2];while(1){h=j[b>>2];i=j[b+4>>2];e=e-i|0;f=(((e|0)/1024|0)-e|0)+f|0;j[c+4>>2]=f+j[c+4>>2];e=k-h|0;e=(((e|0)/1024|0)-e|0)+g|0;j[c>>2]=e+j[c>>2];f=f+((f|0)/-512|0)|0;g=e+((e|0)/-512|0)|0;c=c+8|0;b=b+8|0;e=i;k=h;d=d-1|0;if(d){continue}break}}j[a+4168>>2]=i;j[a+4164>>2]=h;j[a+4160>>2]=f;j[a+4156>>2]=g}function xda(a){a=a|0;var b=0,c=0;j[114630]=0;N(2010,a|0);b=j[114630];j[114630]=0;a:{b:{if((b|0)!=1){b=j[a+24>>2];j[114630]=0;b=H(2016,b|0)|0;c=j[114630];j[114630]=0;if((c|0)!=1){break b}}b=J(0)|0;C()|0;O(b|0)|0;j[114630]=0;L(1984,35084,a|0,0,0);a=j[114630];j[114630]=0;if((a|0)==1){break a}Q();b=0}return b|0}a=D()|0;C()|0;j[114630]=0;M(20);b=j[114630];j[114630]=0;if((b|0)!=1){G(a|0);z()}J(0)|0;C()|0;ib();z()}function cda(a){a=a|0;var b=0,c=0;j[114630]=0;N(2010,a|0);b=j[114630];j[114630]=0;a:{b:{if((b|0)!=1){b=j[a+24>>2];j[114630]=0;b=H(2039,b|0)|0;c=j[114630];j[114630]=0;if((c|0)!=1){break b}}b=J(0)|0;C()|0;O(b|0)|0;j[114630]=0;L(1984,35764,a|0,0,0);a=j[114630];j[114630]=0;if((a|0)==1){break a}Q();b=0}return b|0}a=D()|0;C()|0;j[114630]=0;M(20);b=j[114630];j[114630]=0;if((b|0)!=1){G(a|0);z()}J(0)|0;C()|0;ib();z()}function bda(a){a=a|0;var b=0,c=0;j[114630]=0;N(2010,a|0);b=j[114630];j[114630]=0;a:{b:{if((b|0)!=1){b=j[a+24>>2];j[114630]=0;b=H(2040,b|0)|0;c=j[114630];j[114630]=0;if((c|0)!=1){break b}}b=J(0)|0;C()|0;O(b|0)|0;j[114630]=0;L(1984,35797,a|0,0,0);a=j[114630];j[114630]=0;if((a|0)==1){break a}Q();b=0}return b|0}a=D()|0;C()|0;j[114630]=0;M(20);b=j[114630];j[114630]=0;if((b|0)!=1){G(a|0);z()}J(0)|0;C()|0;ib();z()}function ada(a){a=a|0;var b=0,c=0;j[114630]=0;N(2010,a|0);b=j[114630];j[114630]=0;a:{b:{if((b|0)!=1){b=j[a+24>>2];j[114630]=0;b=H(2041,b|0)|0;c=j[114630];j[114630]=0;if((c|0)!=1){break b}}b=J(0)|0;C()|0;O(b|0)|0;j[114630]=0;L(1984,35830,a|0,0,0);a=j[114630];j[114630]=0;if((a|0)==1){break a}Q();b=0}return b|0}a=D()|0;C()|0;j[114630]=0;M(20);b=j[114630];j[114630]=0;if((b|0)!=1){G(a|0);z()}J(0)|0;C()|0;ib();z()}function _ca(a){a=a|0;var b=0,c=0;j[114630]=0;N(2010,a|0);b=j[114630];j[114630]=0;a:{b:{if((b|0)!=1){b=j[a+24>>2];j[114630]=0;b=H(2043,b|0)|0;c=j[114630];j[114630]=0;if((c|0)!=1){break b}}b=J(0)|0;C()|0;O(b|0)|0;j[114630]=0;L(1984,35898,a|0,0,0);a=j[114630];j[114630]=0;if((a|0)==1){break a}Q();b=0}return b|0}a=D()|0;C()|0;j[114630]=0;M(20);b=j[114630];j[114630]=0;if((b|0)!=1){G(a|0);z()}J(0)|0;C()|0;ib();z()}function Zca(a){a=a|0;var b=0,c=0;j[114630]=0;N(2010,a|0);b=j[114630];j[114630]=0;a:{b:{if((b|0)!=1){b=j[a+24>>2];j[114630]=0;b=H(2044,b|0)|0;c=j[114630];j[114630]=0;if((c|0)!=1){break b}}b=J(0)|0;C()|0;O(b|0)|0;j[114630]=0;L(1984,35929,a|0,0,0);a=j[114630];j[114630]=0;if((a|0)==1){break a}Q();b=0}return b|0}a=D()|0;C()|0;j[114630]=0;M(20);b=j[114630];j[114630]=0;if((b|0)!=1){G(a|0);z()}J(0)|0;C()|0;ib();z()}function Tca(a){a=a|0;var b=0,c=0;j[114630]=0;N(2010,a|0);b=j[114630];j[114630]=0;a:{b:{if((b|0)!=1){b=j[a+24>>2];j[114630]=0;b=H(2050,b|0)|0;c=j[114630];j[114630]=0;if((c|0)!=1){break b}}b=J(0)|0;C()|0;O(b|0)|0;j[114630]=0;L(1984,36200,a|0,0,0);a=j[114630];j[114630]=0;if((a|0)==1){break a}Q();b=0}return b|0}a=D()|0;C()|0;j[114630]=0;M(20);b=j[114630];j[114630]=0;if((b|0)!=1){G(a|0);z()}J(0)|0;C()|0;ib();z()}function Sca(a){a=a|0;var b=0,c=0;j[114630]=0;N(2010,a|0);b=j[114630];j[114630]=0;a:{b:{if((b|0)!=1){b=j[a+24>>2];j[114630]=0;b=H(2051,b|0)|0;c=j[114630];j[114630]=0;if((c|0)!=1){break b}}b=J(0)|0;C()|0;O(b|0)|0;j[114630]=0;L(1984,36232,a|0,0,0);a=j[114630];j[114630]=0;if((a|0)==1){break a}Q();b=0}return b|0}a=D()|0;C()|0;j[114630]=0;M(20);b=j[114630];j[114630]=0;if((b|0)!=1){G(a|0);z()}J(0)|0;C()|0;ib();z()}function Rca(a){a=a|0;var b=0,c=0;j[114630]=0;N(2010,a|0);b=j[114630];j[114630]=0;a:{b:{if((b|0)!=1){b=j[a+24>>2];j[114630]=0;b=H(2052,b|0)|0;c=j[114630];j[114630]=0;if((c|0)!=1){break b}}b=J(0)|0;C()|0;O(b|0)|0;j[114630]=0;L(1984,36264,a|0,0,0);a=j[114630];j[114630]=0;if((a|0)==1){break a}Q();b=0}return b|0}a=D()|0;C()|0;j[114630]=0;M(20);b=j[114630];j[114630]=0;if((b|0)!=1){G(a|0);z()}J(0)|0;C()|0;ib();z()}function Qca(a){a=a|0;var b=0,c=0;j[114630]=0;N(2010,a|0);b=j[114630];j[114630]=0;a:{b:{if((b|0)!=1){b=j[a+24>>2];j[114630]=0;b=H(2053,b|0)|0;c=j[114630];j[114630]=0;if((c|0)!=1){break b}}b=J(0)|0;C()|0;O(b|0)|0;j[114630]=0;L(1984,36294,a|0,0,0);a=j[114630];j[114630]=0;if((a|0)==1){break a}Q();b=0}return b|0}a=D()|0;C()|0;j[114630]=0;M(20);b=j[114630];j[114630]=0;if((b|0)!=1){G(a|0);z()}J(0)|0;C()|0;ib();z()}function Oca(a){a=a|0;var b=0,c=0;j[114630]=0;N(2010,a|0);b=j[114630];j[114630]=0;a:{b:{if((b|0)!=1){b=j[a+24>>2];j[114630]=0;b=H(2054,b|0)|0;c=j[114630];j[114630]=0;if((c|0)!=1){break b}}b=J(0)|0;C()|0;O(b|0)|0;j[114630]=0;L(1984,36326,a|0,0,0);a=j[114630];j[114630]=0;if((a|0)==1){break a}Q();b=0}return b|0}a=D()|0;C()|0;j[114630]=0;M(20);b=j[114630];j[114630]=0;if((b|0)!=1){G(a|0);z()}J(0)|0;C()|0;ib();z()}function Nca(a){a=a|0;var b=0,c=0;j[114630]=0;N(2010,a|0);b=j[114630];j[114630]=0;a:{b:{if((b|0)!=1){b=j[a+24>>2];j[114630]=0;b=H(2055,b|0)|0;c=j[114630];j[114630]=0;if((c|0)!=1){break b}}b=J(0)|0;C()|0;O(b|0)|0;j[114630]=0;L(1984,36361,a|0,0,0);a=j[114630];j[114630]=0;if((a|0)==1){break a}Q();b=0}return b|0}a=D()|0;C()|0;j[114630]=0;M(20);b=j[114630];j[114630]=0;if((b|0)!=1){G(a|0);z()}J(0)|0;C()|0;ib();z()}function K1(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,k=0;e=Za-32|0;Za=e;a:{if((b|0)!=(c|0)){k=j[114604];j[114604]=0;wY(e,b,e+28|0);b=j[e+8>>2];f=j[e+12>>2];g=j[e>>2];h=j[e+4>>2];i=j[114604];b:{if(i){if(j[e+28>>2]!=(c|0)){break b}if((i|0)!=68){break a}j[d>>2]=4;break a}j[114604]=k;if(j[e+28>>2]==(c|0)){break a}}}j[d>>2]=4;g=0;h=0;b=0;f=0}j[a>>2]=g;j[a+4>>2]=h;j[a+8>>2]=b;j[a+12>>2]=f;Za=e+32|0}function $ca(a){a=a|0;var b=0,c=0;j[114630]=0;N(2010,a|0);b=j[114630];j[114630]=0;a:{b:{if((b|0)!=1){b=j[a+24>>2];j[114630]=0;b=H(2042,b|0)|0;c=j[114630];j[114630]=0;if((c|0)!=1){break b}}b=J(0)|0;C()|0;O(b|0)|0;j[114630]=0;L(1984,35863,a|0,0,0);a=j[114630];j[114630]=0;if((a|0)==1){break a}Q();b=0}return b|0}a=D()|0;C()|0;j[114630]=0;M(20);b=j[114630];j[114630]=0;if((b|0)!=1){G(a|0);z()}J(0)|0;C()|0;ib();z()}function kF(a,b){a=a|0;b=b|0;var c=0;c=Za-16|0;Za=c;a:{b:{c:{d:{if((b|0)>=0){if((Uk(a+8|0)|0)>(b|0)){break d}}a=R(8)|0;j[114630]=0;c=E(85,c|0,40665)|0;b=j[114630];j[114630]=0;if((b|0)==1){break c}Wb(a,c);j[114630]=0;I(2004,a|0,83648,2012);a=j[114630];j[114630]=0;if((a|0)!=1){break a}b=D()|0;C()|0;gb(c);break b}Za=c+16|0;return+(+j[(j[a+32>>2]+p(b,896)|0)+1075744>>2]*.015625)}b=D()|0;C()|0;S(a|0)}G(b|0)}z()}function wda(a){a=a|0;var b=0,c=0;j[114630]=0;N(2010,a|0);b=j[114630];j[114630]=0;a:{b:{if((b|0)!=1){b=j[a+24>>2];j[114630]=0;c=+$(2017,b|0);b=j[114630];j[114630]=0;if((b|0)!=1){break b}}b=J(0)|0;C()|0;O(b|0)|0;j[114630]=0;L(1984,35116,a|0,0,0);a=j[114630];j[114630]=0;if((a|0)==1){break a}Q();c=0}return+c}a=D()|0;C()|0;j[114630]=0;M(20);b=j[114630];j[114630]=0;if((b|0)!=1){G(a|0);z()}J(0)|0;C()|0;ib();z()}function uda(a){a=a|0;var b=0,c=0;j[114630]=0;N(2010,a|0);b=j[114630];j[114630]=0;a:{b:{if((b|0)!=1){b=j[a+24>>2];j[114630]=0;c=+$(2019,b|0);b=j[114630];j[114630]=0;if((b|0)!=1){break b}}b=J(0)|0;C()|0;O(b|0)|0;j[114630]=0;L(1984,35188,a|0,0,0);a=j[114630];j[114630]=0;if((a|0)==1){break a}Q();c=0}return+c}a=D()|0;C()|0;j[114630]=0;M(20);b=j[114630];j[114630]=0;if((b|0)!=1){G(a|0);z()}J(0)|0;C()|0;ib();z()}function iaa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;b=Za-32|0;Za=b;j[b+24>>2]=e;j[b+28>>2]=f;a:{a=Gr(a,ql(b+16|0,lb(c),d),b+24|0);if(a+1>>>0>=3){a=R(8)|0;j[114630]=0;b=E(85,b|0,38640)|0;c=j[114630];j[114630]=0;b:{if((c|0)!=1){Wb(a,b);j[114630]=0;I(2004,a|0,83648,2012);a=j[114630];j[114630]=0;if((a|0)!=1){break a}d=D()|0;C()|0;gb(b);break b}d=D()|0;C()|0;S(a|0)}G(d|0);z()}Za=b+32|0;return a|0}z()}function ge(a){var b=0,c=0,d=0;b=Za-16|0;Za=b;RMa(+a);d=OMa(1)|0;OMa(0)|0;d=d&2147483647;a:{if(d>>>0<=1072243195){c=1;if(d>>>0<1044816030){break a}c=_n(a,0);break a}c=a-a;if(d>>>0>=2146435072){break a}b:{switch(DE(a,b)&3){case 0:c=_n(o[b>>3],o[b+8>>3]);break a;case 1:c=-$n(o[b>>3],o[b+8>>3],1);break a;case 2:c=-_n(o[b>>3],o[b+8>>3]);break a;default:break b}}c=$n(o[b>>3],o[b+8>>3],1)}a=c;Za=b+16|0;return a}function eka(a,b,c,d){var e=0,f=0,g=0,h=0,i=0,k=0;g=Za-16|0;Za=g;i=j[a+4>>2];d=p((i-d|0)/6|0,6)+b|0;e=op(g,a,(c-d|0)/6|0);a:{if(c>>>0>d>>>0){f=d;while(1){h=hb(a);k=j[e+4>>2];j[114630]=0;I(1561,h|0,k|0,f|0);h=j[114630];j[114630]=0;if((h|0)==1){break a}j[e+4>>2]=j[e+4>>2]+6;f=f+6|0;if(f>>>0<c>>>0){continue}break}}ub(e);a=d-b|0;if(a){Ci(p((a|0)/-6|0,6)+i|0,b,a)}Za=g+16|0;return}a=D()|0;C()|0;ub(e);G(a|0);z()}function dda(a){a=a|0;var b=0,c=0;j[114630]=0;N(2010,a|0);b=j[114630];j[114630]=0;a:{b:{if((b|0)!=1){b=j[a+24>>2];j[114630]=0;c=+$(2038,b|0);b=j[114630];j[114630]=0;if((b|0)!=1){break b}}b=J(0)|0;C()|0;O(b|0)|0;j[114630]=0;L(1984,35723,a|0,0,0);a=j[114630];j[114630]=0;if((a|0)==1){break a}Q();c=0}return+c}a=D()|0;C()|0;j[114630]=0;M(20);b=j[114630];j[114630]=0;if((b|0)!=1){G(a|0);z()}J(0)|0;C()|0;ib();z()}function G3(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,i=0,k=0,l=0;e=Za-16|0;Za=e;while(1){a:{if((c|0)<=(f|0)){break a}d=j[a+28>>2];g=j[a+24>>2];if(d>>>0<=g>>>0){if(((k=a,l=gg(h[b|0]),i=j[j[a>>2]+52>>2],bb[i](k|0,l|0)|0)|0)==-1){break a}f=f+1|0;b=b+1|0}else{j[e+12>>2]=d-g;j[e+8>>2]=c-f;d=j[Pd(e+12|0,e+8|0)>>2];kh(j[a+24>>2],b,d);j[a+24>>2]=d+j[a+24>>2];f=f+d|0;b=b+d|0}continue}break}Za=e+16|0;return f|0}function Vu(a,b,c,d){var e=0,f=0,g=0,h=0,i=0,k=0,l=0;e=Za-160|0;Za=e;Ab(e+16|0,0,144);j[e+92>>2]=-1;j[e+60>>2]=b;j[e+24>>2]=-1;j[e+20>>2]=b;dh(e+16|0,0,0);xD(e,e+16|0,d,1);d=j[e+8>>2];g=j[e+12>>2];h=j[e>>2];i=j[e+4>>2];if(c){k=c;f=b;b=j[e+20>>2]-j[e+24>>2]|0;l=b;c=b+j[e+136>>2]|0;b=j[e+140>>2]+(b>>31)|0;b=c>>>0<l>>>0?b+1|0:b;j[k>>2]=!(b|c)?f:f+c|0}j[a>>2]=h;j[a+4>>2]=i;j[a+8>>2]=d;j[a+12>>2]=g;Za=e+160|0}function koa(a,b){var c=0,d=0;a=Cb(a);c=nb(b);j[114630]=0;F(111,a|0,c|0);c=j[114630];j[114630]=0;if((c|0)!=1){a:{if(nb(b)){while(1){c=j[Ni(b,d)>>2];b:{if(c>>>0<=127){j[114630]=0;F(110,a|0,c<<24>>24);c=j[114630];j[114630]=0;if((c|0)!=1){break b}break a}j[114630]=0;F(110,a|0,63);c=j[114630];j[114630]=0;if((c|0)==1){break a}}d=d+1|0;if(nb(b)>>>0>d>>>0){continue}break}}return}}b=D()|0;C()|0;gb(a);G(b|0);z()}function iF(a,b){a=a|0;b=b|0;var c=0;c=Za-16|0;Za=c;a:{b:{c:{d:{if((b|0)>=0){if((Uk(a+8|0)|0)>(b|0)){break d}}a=R(8)|0;j[114630]=0;c=E(85,c|0,40665)|0;b=j[114630];j[114630]=0;if((b|0)==1){break c}Wb(a,c);j[114630]=0;I(2004,a|0,83648,2012);a=j[114630];j[114630]=0;if((a|0)!=1){break a}b=D()|0;C()|0;gb(c);break b}Za=c+16|0;return(k[(j[a+32>>2]+p(b,896)|0)+1075073|0]&4)>>>2|0}b=D()|0;C()|0;S(a|0)}G(b|0)}z()}function coa(a,b){var c=0,d=0;a=Cb(a);c=nb(b);j[114630]=0;F(111,a|0,c|0);c=j[114630];j[114630]=0;if((c|0)!=1){a:{if(nb(b)){while(1){c=j[Ni(b,d)>>2];b:{if(c>>>0<=255){j[114630]=0;F(110,a|0,c<<24>>24);c=j[114630];j[114630]=0;if((c|0)!=1){break b}break a}j[114630]=0;F(110,a|0,63);c=j[114630];j[114630]=0;if((c|0)==1){break a}}d=d+1|0;if(nb(b)>>>0>d>>>0){continue}break}}return}}b=D()|0;C()|0;gb(a);G(b|0);z()}function Q4(a){var b=q(0),c=q(0),d=0;c=(PMa(2,(SMa(a),OMa(2))&-2147483648|1056964608),TMa());d=(SMa(a),OMa(2))&2147483647;b=(PMa(2,d),TMa());a:{if(d>>>0<=1118925334){b=O4(b);if(d>>>0<=1065353215){if(d>>>0<964689920){break a}return q(c*q(q(b+b)-q(q(b*b)/q(b+q(1)))))}return q(c*q(b+q(b/q(b+q(1)))))}a=q(q(c+c)*q(q(R4(q(b+q(-162.88958740234375)))*q(1.661534994731145e+35))*q(1.661534994731145e+35)))}return a}function PJa(a,b){var c=0,d=0,e=0;vp(a);h[a+8|0]=0;j[a+4>>2]=b;j[a>>2]=76464;b=ri(a+12|0);h[a+24|0]=0;j[114630]=0;E(35,a+28|0,0)|0;c=j[114630];j[114630]=0;if((c|0)!=1){b=a+40|0;c=b+192|0;while(1){j[b>>2]=0;j[b+4>>2]=0;h[b+8|0]=0;b=b+12|0;if((c|0)!=(b|0)){continue}break}if(k[a+24|0]){a=a+232|0;b=0;while(1){d=Ae(a,b),e=b,j[d>>2]=e;b=b+1|0;if((b|0)!=16){continue}break}}return}a=D()|0;C()|0;xg(b);G(a|0);z()}function xk(a){var b=0,c=0;nn(a,1,10879);j[114630]=0;b=T(228)|0;c=j[114630];j[114630]=0;a:{if((c|0)==1){break a}j[a+12>>2]=b;j[114630]=0;b=T(229)|0;c=j[114630];j[114630]=0;if((c|0)==1){break a}h[a+16|0]=b;j[114630]=0;b=T(230)|0;c=j[114630];j[114630]=0;if((c|0)==1){break a}h[a+18|0]=0;h[a+17|0]=b;j[114630]=0;N(231,a+20|0);b=j[114630];j[114630]=0;if((b|0)==1){break a}return}b=D()|0;C()|0;gb(a);G(b|0);z()}function naa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;b=Za-32|0;Za=b;j[b+24>>2]=e;j[b+28>>2]=f;a:{a=Gr(a,ql(b+16|0,c,d),b+24|0);if(a+1>>>0>=3){a=R(8)|0;j[114630]=0;b=E(85,b|0,38640)|0;c=j[114630];j[114630]=0;b:{if((c|0)!=1){Wb(a,b);j[114630]=0;I(2004,a|0,83648,2012);a=j[114630];j[114630]=0;if((a|0)!=1){break a}d=D()|0;C()|0;gb(b);break b}d=D()|0;C()|0;S(a|0)}G(d|0);z()}Za=b+32|0;return a|0}z()}function Y9(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;e=Za-16|0;Za=e;a:{b:{c:{if(!d){b=R(8)|0;j[114630]=0;c=E(85,e|0,38697)|0;a=j[114630];j[114630]=0;if((a|0)==1){break c}Wb(b,c);j[114630]=0;I(2004,b|0,83648,2012);a=j[114630];j[114630]=0;if((a|0)!=1){break a}a=D()|0;C()|0;gb(c);break b}Qh(a,b,1);c=Xv(a,c,d,0,0,0);o[a+16>>3]=+(c>>>0)/+(b|0)+o[a+16>>3];Za=e+16|0;return c|0}a=D()|0;C()|0;S(b|0)}G(a|0)}z()}function $9(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;e=Za-16|0;Za=e;a:{b:{c:{if(!d){b=R(8)|0;j[114630]=0;c=E(85,e|0,38697)|0;a=j[114630];j[114630]=0;if((a|0)==1){break c}Wb(b,c);j[114630]=0;I(2004,b|0,83648,2012);a=j[114630];j[114630]=0;if((a|0)!=1){break a}a=D()|0;C()|0;gb(c);break b}Qh(a,b,1);c=Yv(a,c,d,0,0,0);o[a+16>>3]=+(c>>>0)/+(b|0)+o[a+16>>3];Za=e+16|0;return c|0}a=D()|0;C()|0;S(b|0)}G(a|0)}z()}function tO(a){var b=0;a:{if((k[a|0]|k[a+1|0]<<8|(k[a+2|0]<<16|k[a+3|0]<<24))!=808604749){break a}b=a+8|0;if((k[b|0]|k[b+1|0]<<8)>>>0<512|(k[b|0]|k[b+1|0]<<8)>>>0>767){break a}b=a+112|0;if(!(k[b|0]|k[b+1|0]<<8)|(k[b|0]|k[b+1|0]<<8)>>>0>64){break a}b=a+106|0;if((k[b|0]|k[b+1|0]<<8)>>>0>256){break a}b=a+122|0;if((k[b|0]|k[b+1|0]<<8)>>>0>255){break a}a=a+124|0;return(k[a|0]|k[a+1|0]<<8)>>>0<4e3}return 0}function KE(a,b){var c=0,d=0,e=0;if(!k[b+21|0]){Nb(a,21);return-1}if(j[a+1396>>2]<=9){Dj(a)}c=j[a+1392>>2];e=i[(((c&1023)<<1)+b|0)+36>>1];a:{if((e|0)>=0){d=c;c=k[e+j[b+8>>2]|0];j[a+1392>>2]=d>>>c;c=j[a+1396>>2]-c|0;d=(c|0)<0;j[a+1396>>2]=d?0:c;c=d?-1:e;break a}c=Qk(a,b)}if(!((c|0)>=j[b+2092>>2]?k[b+23|0]:0)){if(!((c|0)>-1|(j[a+1384>>2]?!k[a+1376|0]:0))){Nb(a,21)}return c}Y(50840,50512,1778,50862);z()}function $fa(a){var b=0,c=0,d=0,e=0,f=0,g=0;b=Za-16|0;Za=b;f=b,g=Lb(a),j[f+8>>2]=g;f=b,g=Mb(a),j[f>>2]=g;if(rb(b+8|0,b)){while(1){e=j[b+8>>2];a:{while(1){c=j[e>>2];d=j[c>>2];if(!d){break a}c=j[j[d>>2]+8>>2];j[114630]=0;N(c|0,d|0);c=j[114630];j[114630]=0;if((c|0)!=1){continue}break}J(0)|0;C()|0;kw(a);ib();z()}qb(c+20|0);qb(c+8|0);Fb(c);Id(b+8|0);if(rb(b+8|0,b)){continue}break}}kw(a);Za=b+16|0;return a}function Mna(a,b){var c=0,d=0;a=Le(a);c=nb(b);j[114630]=0;F(113,a|0,c|0);c=j[114630];j[114630]=0;if((c|0)!=1){a:{if(nb(b)){while(1){c=h[Ub(b,d)|0];b:{if((c|0)>=0){j[114630]=0;F(112,a|0,c&255);c=j[114630];j[114630]=0;if((c|0)!=1){break b}break a}j[114630]=0;F(112,a|0,65533);c=j[114630];j[114630]=0;if((c|0)==1){break a}}d=d+1|0;if(nb(b)>>>0>d>>>0){continue}break}}return}}b=D()|0;C()|0;pc(a);G(b|0);z()}function $ma(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0;c=Za-16|0;Za=c;_ma(a,b);b=0;a:{b:{c:{while(1){d=j[a>>2];j[114630]=0;i[c+14>>1]=b;e=E(2,c|0,(b<<2)+20768|0)|0;f=j[114630];j[114630]=0;if((f|0)==1){break c}j[114630]=0;I(1421,d|0,c+14|0,e|0);d=j[114630];j[114630]=0;if((d|0)==1){break b}gb(e);b=b+1|0;if((b|0)!=12){continue}break}Za=c+16|0;return}b=D()|0;C()|0;break a}b=D()|0;C()|0;gb(e)}Kf(a);G(b|0);z()}function kCa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;e=Za-48|0;Za=e;di(e+24|0,e+16|0,c);j[114630]=0;I(869,e+36|0,e+8|0,d|0);c=j[114630];j[114630]=0;a:{b:{if((c|0)!=1){j[114630]=0;F(668,e|0,e+24|0);c=j[114630];j[114630]=0;if((c|0)!=1){j[114630]=0;I(517,a|0,b|0,e|0);a=j[114630];j[114630]=0;if((a|0)!=1){break a}}c=D()|0;C()|0;Ne(e+24|0);break b}c=D()|0;C()|0;gb(e+24|0)}G(c|0);z()}Ne(e+24|0);Za=e+48|0}function Ysa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;e=Za-48|0;Za=e;_y(e+24|0,e+16|0,c);j[114630]=0;I(667,e+36|0,e+8|0,d|0);c=j[114630];j[114630]=0;a:{b:{if((c|0)!=1){j[114630]=0;F(668,e|0,e+24|0);c=j[114630];j[114630]=0;if((c|0)!=1){j[114630]=0;I(517,a|0,b|0,e|0);a=j[114630];j[114630]=0;if((a|0)!=1){break a}}c=D()|0;C()|0;Ne(e+24|0);break b}c=D()|0;C()|0;gb(e+24|0)}G(c|0);z()}Ne(e+24|0);Za=e+48|0}function V9(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;e=Za-16|0;Za=e;a:{b:{c:{if(!d){b=R(8)|0;j[114630]=0;c=E(85,e|0,38697)|0;a=j[114630];j[114630]=0;if((a|0)==1){break c}Wb(b,c);j[114630]=0;I(2004,b|0,83648,2012);a=j[114630];j[114630]=0;if((a|0)!=1){break a}a=D()|0;C()|0;gb(c);break b}Qh(a,b,2);c=hG(a,c,2,d);o[a+16>>3]=+(c>>>0)/+(b|0)+o[a+16>>3];Za=e+16|0;return c|0}a=D()|0;C()|0;S(b|0)}G(a|0)}z()}function Uaa(a){var b=0,c=0;c=Za-16|0;Za=c;b=3;a:{b:{if(!a|(a|0)>7){break b}b=2;if((a|0)>2){break b}b=1;if((a|0)==2){break b}b=0;if((a|0)>0){break b}b=R(8)|0;j[114630]=0;c=E(85,c|0,39891)|0;a=j[114630];j[114630]=0;c:{if((a|0)!=1){Wb(b,c);j[114630]=0;I(2004,b|0,83648,2012);a=j[114630];j[114630]=0;if((a|0)!=1){break a}a=D()|0;C()|0;gb(c);break c}a=D()|0;C()|0;S(b|0)}G(a|0);z()}Za=c+16|0;return b}z()}function U9(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;e=Za-16|0;Za=e;a:{b:{c:{if(!d){b=R(8)|0;j[114630]=0;c=E(85,e|0,38697)|0;a=j[114630];j[114630]=0;if((a|0)==1){break c}Wb(b,c);j[114630]=0;I(2004,b|0,83648,2012);a=j[114630];j[114630]=0;if((a|0)!=1){break a}a=D()|0;C()|0;gb(c);break b}Qh(a,b,4);c=hG(a,c,4,d);o[a+16>>3]=+(c>>>0)/+(b|0)+o[a+16>>3];Za=e+16|0;return c|0}a=D()|0;C()|0;S(b|0)}G(a|0)}z()}function T9(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;e=Za-16|0;Za=e;a:{b:{c:{if(!d){b=R(8)|0;j[114630]=0;c=E(85,e|0,38697)|0;a=j[114630];j[114630]=0;if((a|0)==1){break c}Wb(b,c);j[114630]=0;I(2004,b|0,83648,2012);a=j[114630];j[114630]=0;if((a|0)!=1){break a}a=D()|0;C()|0;gb(c);break b}Qh(a,b,2);c=gG(a,c,2,d);o[a+16>>3]=+(c>>>0)/+(b|0)+o[a+16>>3];Za=e+16|0;return c|0}a=D()|0;C()|0;S(b|0)}G(a|0)}z()}function S9(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;e=Za-16|0;Za=e;a:{b:{c:{if(!d){b=R(8)|0;j[114630]=0;c=E(85,e|0,38697)|0;a=j[114630];j[114630]=0;if((a|0)==1){break c}Wb(b,c);j[114630]=0;I(2004,b|0,83648,2012);a=j[114630];j[114630]=0;if((a|0)!=1){break a}a=D()|0;C()|0;gb(c);break b}Qh(a,b,4);c=gG(a,c,4,d);o[a+16>>3]=+(c>>>0)/+(b|0)+o[a+16>>3];Za=e+16|0;return c|0}a=D()|0;C()|0;S(b|0)}G(a|0)}z()}function xr(a){var b=0,c=0,d=0;b=k[a+4266|0];n[a+4236>>2]=q(b>>>0)*q(.00390625);j[a+4228>>2]=(p(j[a+4232>>2],k[a+4264|0])+250>>>0)/500;n[a+4240>>2]=q(256-b|0)*q(.00390625);c=k[a+4267|0];b=k[a+4265|0];n[a+4244>>2]=q(p(c,b)|0)*q(152587890625e-16);d=c|-256;n[a+4256>>2]=q(p(d,b|-256)|0)*q(152587890625e-16);n[a+4252>>2]=q(p(b,d)|0)*q(152587890625e-16);n[a+4248>>2]=q(p(256-b|0,c)|0)*q(152587890625e-16)}function xGa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;e=Za-48|0;Za=e;Ol(e+24|0,e+16|0,c);j[114630]=0;I(224,e+36|0,e+8|0,d|0);c=j[114630];j[114630]=0;a:{b:{if((c|0)!=1){j[114630]=0;F(78,e|0,e+24|0);c=j[114630];j[114630]=0;if((c|0)!=1){j[114630]=0;I(72,a|0,b|0,e|0);a=j[114630];j[114630]=0;if((a|0)!=1){break a}}c=D()|0;C()|0;Ne(e+24|0);break b}c=D()|0;C()|0;gb(e+24|0)}G(c|0);z()}Ne(e+24|0);Za=e+48|0}function lJa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;e=Za-48|0;Za=e;Ol(e+24|0,e+16|0,c);j[114630]=0;I(240,e+36|0,e+8|0,d|0);c=j[114630];j[114630]=0;a:{b:{if((c|0)!=1){j[114630]=0;F(78,e|0,e+24|0);c=j[114630];j[114630]=0;if((c|0)!=1){j[114630]=0;I(72,a|0,b|0,e|0);a=j[114630];j[114630]=0;if((a|0)!=1){break a}}c=D()|0;C()|0;Ne(e+24|0);break b}c=D()|0;C()|0;gb(e+24|0)}G(c|0);z()}Ne(e+24|0);Za=e+48|0}function iLa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;e=Za-48|0;Za=e;Qz(e+24|0,e+16|0,c);j[114630]=0;I(444,e+36|0,e+8|0,d|0);c=j[114630];j[114630]=0;a:{b:{if((c|0)!=1){j[114630]=0;F(78,e|0,e+24|0);c=j[114630];j[114630]=0;if((c|0)!=1){j[114630]=0;I(72,a|0,b|0,e|0);a=j[114630];j[114630]=0;if((a|0)!=1){break a}}c=D()|0;C()|0;Ne(e+24|0);break b}c=D()|0;C()|0;gb(e+24|0)}G(c|0);z()}Ne(e+24|0);Za=e+48|0}function uAa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;e=Za-48|0;Za=e;kO(e+24|0,e+16|0,c);j[114630]=0;I(77,e+36|0,e+8|0,d|0);c=j[114630];j[114630]=0;a:{b:{if((c|0)!=1){j[114630]=0;F(78,e|0,e+24|0);c=j[114630];j[114630]=0;if((c|0)!=1){j[114630]=0;I(72,a|0,b|0,e|0);a=j[114630];j[114630]=0;if((a|0)!=1){break a}}c=D()|0;C()|0;Ne(e+24|0);break b}c=D()|0;C()|0;gb(e+24|0)}G(c|0);z()}Ne(e+24|0);Za=e+48|0}function rM(){var a=0,b=0;a=Za-240|0;Za=a;a:{b:{if(h[85560]&1){break b}if(!fd(85560)){break b}j[114630]=0;T(102)|0;b=j[114630];j[114630]=0;if((b|0)==1){break a}j[114630]=0;F(103,a+120|0,85408);b=j[114630];j[114630]=0;if((b|0)==1){break a}j[114630]=0;E(104,85440,Vb(a,a+120|0,120)|0)|0;b=j[114630];j[114630]=0;if((b|0)==1){break a}ed(85560)}Za=a+240|0;return 85440}a=D()|0;C()|0;Zd(85560);G(a|0);z()}function Qx(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0;f=Za-32|0;Za=f;j[f+8>>2]=c;g=f,h=ef(b),j[g+28>>2]=h;De(f+8|0,b,j[tb(f+8|0,f+28|0)>>2]);j[114630]=0;b=H(412,f+8|0)|0;c=j[114630];j[114630]=0;a:{if((c|0)==1){break a}c=j[f+8>>2];j[114630]=0;a=U(440,a|0,b|0,c|0,d|0,e|0)|0;b=j[114630];j[114630]=0;if((b|0)==1){break a}lc(f+8|0);Za=f+32|0;return a|0}a=D()|0;C()|0;lc(f+8|0);G(a|0);z()}function Kh(a){var b=0,c=0;b=Za-16|0;Za=b;RMa(+a);c=OMa(1)|0;OMa(0)|0;c=c&2147483647;a:{if(c>>>0<=1072243195){if(c>>>0<1045430272){break a}a=$n(a,0,0);break a}if(c>>>0>=2146435072){a=a-a;break a}b:{switch(DE(a,b)&3){case 0:a=$n(o[b>>3],o[b+8>>3],1);break a;case 1:a=_n(o[b>>3],o[b+8>>3]);break a;case 2:a=-$n(o[b>>3],o[b+8>>3],1);break a;default:break b}}a=-_n(o[b>>3],o[b+8>>3])}Za=b+16|0;return a}function JW(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;e=Za-48|0;Za=e;di(e+24|0,e+16|0,c);j[114630]=0;I(224,e+36|0,e+8|0,d|0);c=j[114630];j[114630]=0;a:{b:{if((c|0)!=1){j[114630]=0;F(78,e|0,e+24|0);c=j[114630];j[114630]=0;if((c|0)!=1){j[114630]=0;I(72,a|0,b|0,e|0);a=j[114630];j[114630]=0;if((a|0)!=1){break a}}c=D()|0;C()|0;Ne(e+24|0);break b}c=D()|0;C()|0;gb(e+24|0)}G(c|0);z()}Ne(e+24|0);Za=e+48|0}function NN(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0;d=Za-16|0;Za=d;e=lp(a);f=d,g=Lb(b),j[f+8>>2]=g;f=d,g=Mb(b),j[f>>2]=g;a:{if(rb(d+8|0,d)){while(1){a=j[d+8>>2];if((k[a|0]|k[a+1|0]<<8|(k[a+2|0]<<16|k[a+3|0]<<24))==(c|0)){a=hb(a);j[114630]=0;F(601,e|0,a|0);a=j[114630];j[114630]=0;if((a|0)==1){break a}}gk(d+8|0);if(rb(d+8|0,d)){continue}break}}Za=d+16|0;return}a=D()|0;C()|0;Sc(e);G(a|0);z()}function wGa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;e=Za-48|0;Za=e;nia(e+24|0,c);j[114630]=0;I(667,e+36|0,e+8|0,d|0);c=j[114630];j[114630]=0;a:{b:{if((c|0)!=1){j[114630]=0;F(668,e|0,e+24|0);c=j[114630];j[114630]=0;if((c|0)!=1){j[114630]=0;I(517,a|0,b|0,e|0);a=j[114630];j[114630]=0;if((a|0)!=1){break a}}c=D()|0;C()|0;Ne(e+24|0);break b}c=D()|0;C()|0;gb(e+24|0)}G(c|0);z()}Ne(e+24|0);Za=e+48|0}function dGa(a,b){a=a|0;b=b|0;var c=0,d=0;c=Za-48|0;Za=c;FEa(c+24|0,b);j[114630]=0;F(702,c+8|0,c+24|0);b=j[114630];j[114630]=0;a:{if((b|0)==1){break a}j[114630]=0;F(703,c+16|0,c+8|0);b=j[114630];j[114630]=0;if((b|0)==1){break a}b=j[c+16>>2];d=j[c+20>>2];j[114630]=0;K(704,a|0,b|0,d|0)|0;a=j[114630];j[114630]=0;if((a|0)==1){break a}lc(c+24|0);Za=c+48|0;return}a=D()|0;C()|0;lc(c+24|0);G(a|0);z()}function W4(a,b){var c=0;a:{b:{if((a^b)&3){break b}if(b&3){while(1){c=k[b|0];h[a|0]=c;if(!c){break a}a=a+1|0;b=b+1|0;if(b&3){continue}break}}c=j[b>>2];if((c^-1)&c-16843009&-2139062144){break b}while(1){j[a>>2]=c;c=j[b+4>>2];a=a+4|0;b=b+4|0;if(!(c-16843009&(c^-1)&-2139062144)){continue}break}}c=k[b|0];h[a|0]=c;if(!c){break a}while(1){c=k[b+1|0];h[a+1|0]=c;a=a+1|0;b=b+1|0;if(c){continue}break}}}function v$(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0;e=Za+ -64|0;Za=e;j[e+56>>2]=b;f=e+48|0;a:{b:while(1){if(c>>>0<d>>>0){j[e+8>>2]=c;if((bb[j[j[a>>2]+12>>2]](a,e+48|0,c,d,e+8|0,e+16|0,f,e+12|0)|0)==2){break a}b=e+16|0;if(j[e+8>>2]==(c|0)){break a}while(1)if(m[e+12>>2]<=b>>>0){c=j[e+8>>2];continue b}else{GC(e+56|0,b);b=b+1|0;continue}}break}Za=e- -64|0;return j[e+56>>2]}Wl(65236);z()}



function sF(a,b){a=a|0;b=+b;var c=0,d=0;c=Za-16|0;Za=c;a:{b:{c:{if(!(b<=4?!(b<=0):0)){d=R(8)|0;j[114630]=0;c=E(85,c|0,40601)|0;a=j[114630];j[114630]=0;if((a|0)==1){break c}Wb(d,c);j[114630]=0;I(2004,d|0,83648,2012);a=j[114630];j[114630]=0;if((a|0)!=1){break a}a=D()|0;C()|0;gb(c);break b}d=Zj(65536/b);a=a+32|0;j[j[a>>2]+480244>>2]=d;so(j[a>>2]);Za=c+16|0;return}a=D()|0;C()|0;S(d|0)}G(a|0)}z()}function qF(a,b){a=a|0;b=+b;var c=0,d=0;c=Za-16|0;Za=c;a:{b:{c:{if(!(b<=4?!(b<=0):0)){d=R(8)|0;j[114630]=0;c=E(85,c|0,40622)|0;a=j[114630];j[114630]=0;if((a|0)==1){break c}Wb(d,c);j[114630]=0;I(2004,d|0,83648,2012);a=j[114630];j[114630]=0;if((a|0)!=1){break a}a=D()|0;C()|0;gb(c);break b}d=Zj(b*65536);a=a+32|0;j[j[a>>2]+480240>>2]=d;so(j[a>>2]);Za=c+16|0;return}a=D()|0;C()|0;S(d|0)}G(a|0)}z()}function Mw(a,b,c){var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;d=t(c,.999);c=d*32768;h=d*3.141592653589793;j=Dr(b);while(1){k=a;l=c;e=((f<<12^-1)&28672)+(f>>>3|0)|0;if((e|0)!=16384){g=+(e-16384|0);d=g*.000244140625;g=Dr(y(g*-152587890625e-16*d+1)*b);d=h*d;d=g*Kh(d)/(d*j)}else{d=1}d=v(l*d+.5);a:{if(r(d)<2147483648){e=~~d;break a}e=-2147483648}i[k>>1]=e;a=a+2|0;f=f+1|0;if((f|0)!=32768){continue}break}}function R6(a,b){var c=0,d=0,e=0,f=0,g=0,h=0;c=Za-16|0;Za=c;d=j[b+4>>2];b=j[b>>2];j[c+12>>2]=0;j[c+8>>2]=0;j[c+4>>2]=0;L6(Mv(1970,1,1)+IMa(b,d,86400,0)|0,c+12|0,c+8|0,c+4|0);oF(a);j[a+20>>2]=j[c+12>>2]-1900;j[a+16>>2]=j[c+8>>2]-1;e=j[c+4>>2];g=a,h=JMa(IMa(b,d,3600,0),ab,24),j[g+8>>2]=h;j[a+12>>2]=e;d=IMa(b,d,60,0);e=ab;g=a,h=JMa(d,e,60),j[g+4>>2]=h;f=a;a=HMa(d,e,60,0);j[f>>2]=b-a;Za=c+16|0}function PKa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;e=Za-48|0;Za=e;nS(e+24|0,c);j[114630]=0;I(224,e+36|0,e+8|0,d|0);c=j[114630];j[114630]=0;a:{b:{if((c|0)!=1){j[114630]=0;F(78,e|0,e+24|0);c=j[114630];j[114630]=0;if((c|0)!=1){j[114630]=0;I(72,a|0,b|0,e|0);a=j[114630];j[114630]=0;if((a|0)!=1){break a}}c=D()|0;C()|0;Ne(e+24|0);break b}c=D()|0;C()|0;gb(e+24|0)}G(c|0);z()}Ne(e+24|0);Za=e+48|0}function OE(a,b,c){var d=0,e=0,f=0,g=0,h=0,i=0,k=0;d=(b<<2)+a|0;e=d+1068|0;g=c<<1&-4;i=e,k=Ad(a,g),j[i>>2]=k;f=d+1076|0;i=f,k=Ad(a,g),j[i>>2]=k;h=d+1084|0;d=Ad(a,c&-4);j[h>>2]=d;a:{b:{e=j[e>>2];if(!(!e|!d)){f=j[f>>2];if(f){break b}}break a}Z4(c,e,f,d);d=(b<<2)+a|0;b=Ad(a,g);j[d+1092>>2]=b;if(!b){break a}Y4(c,b);b=Ad(a,c>>2&-2);j[d+1100>>2]=b;if(!b){break a}X4(c,b);return 1}Nb(a,3);return 0}function tu(a,b,c){var d=0,e=0,f=0;f=j[c+16>>2];a:{if(f){d=f}else{if(lX(c)){break a}d=j[c+16>>2]}f=j[c+20>>2];if(d-f>>>0<b>>>0){return bb[j[c+36>>2]](c,a,b)|0}b:{if(h[c+75|0]<0){break b}d=b;while(1){e=d;if(!e){e=0;break b}d=e-1|0;if(k[d+a|0]!=10){continue}break}d=bb[j[c+36>>2]](c,a,e)|0;if(d>>>0<e>>>0){break a}a=a+e|0;b=b-e|0;f=j[c+20>>2]}Vb(f,a,b);j[c+20>>2]=j[c+20>>2]+b;d=b+e|0}return d}function Jda(a){a=a|0;var b=0;j[114630]=0;N(2010,a|0);b=j[114630];j[114630]=0;if((b|0)!=1){b=j[a+24>>2];if(b){Fb(gr(b))}j[a+24>>2]=0;b=j[a+20>>2];if(b){Fb(b);j[a+20>>2]=0}Fb(a);return}b=J(0)|0;C()|0;O(b|0)|0;j[114630]=0;L(1984,34780,a|0,0,0);a=j[114630];j[114630]=0;if((a|0)!=1){Q();return}a=D()|0;C()|0;j[114630]=0;M(20);b=j[114630];j[114630]=0;if((b|0)!=1){G(a|0);z()}J(0)|0;C()|0;ib();z()}function CW(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0;c=Za-32|0;Za=c;a:{b:{c:{d:{if(!(d=!Ec(b),e=0,f=j[b+12>>2],f?d:e)){Qc(a);break d}BW(c+16|0,b);j[114630]=0;F(234,c|0,b+12|0);b=j[114630];j[114630]=0;if((b|0)==1){break c}j[114630]=0;I(3,a|0,c+16|0,c|0);a=j[114630];j[114630]=0;if((a|0)==1){break b}gb(c);gb(c+16|0)}Za=c+32|0;return}b=D()|0;C()|0;break a}b=D()|0;C()|0;gb(c)}gb(c+16|0);G(b|0);z()}function $E(a,b,c,d,e,f){var g=0,h=0;if((d|0)>=1){while(1){T5(p(g,2304)+b|0,c);g=g+1|0;if((g|0)!=(d|0)){continue}break}}f=Vb(f,a,3840);if((c|0)>=1){h=d<<5;g=0;while(1){S5((g<<2)+b|0,(p(g,h)<<1)+e|0,d,f+(g<<8)|0);g=g+2|0;if((g|0)<(c|0)){continue}break}}b=c<<6;a:{if((d|0)==1){g=0;while(1){n[(g<<2)+a>>2]=n[f+(b+g<<2)>>2];c=g>>>0<958;g=g+2|0;if(c){continue}break}break a}Vb(a,f+(b<<2)|0,3840)}}function yT(a,b){var c=0,d=0,e=0;d=Za-16|0;Za=d;j[d+12>>2]=b;c=j[a+4>>2];a:{if(!c){c=j[a>>2];break a}j[d+8>>2]=32-c;b=tb(d+8|0,d+12|0);c=j[a>>2];b=j[b>>2];j[c>>2]=j[c>>2]&(-1<<j[a+4>>2]&-1>>>j[d+8>>2]-b^-1);b=j[d+12>>2]-b|0;j[d+12>>2]=b;c=c+4|0;j[a>>2]=c}e=c;c=b>>>5<<2;Ab(e,0,c);b=j[d+12>>2]-(b&-32)|0;j[d+12>>2]=b;if(b){e=a;a=c+j[a>>2]|0;j[e>>2]=a;j[a>>2]=j[a>>2]&(-1>>>32-b^-1)}Za=d+16|0}function D2(a){var b=0,c=0;a:{if(a&3){while(1){b=k[a|0];if(!b|(b|0)==61){break a}a=a+1|0;if(a&3){continue}break}}b=j[a>>2];b:{if((b^-1)&b-16843009&-2139062144){break b}while(1){b=b^1027423549;if((b^-1)&b-16843009&-2139062144){break b}b=j[a+4>>2];a=a+4|0;if(!(b-16843009&(b^-1)&-2139062144)){continue}break}}while(1){b=a;c=k[b|0];if(c){a=b+1|0;if((c|0)!=61){continue}}break}return b}return a}function Fy(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;xP(a,b);e=b+8|0;e=k[e|0]|k[e+1|0]<<8|(k[e+2|0]<<16|k[e+3|0]<<24);xc(a,(e<<24|e<<8&16711680|(e>>>8&65280|e>>>24))+504|0);wP(a,d);a:{b=b+32|0;if(!(k[b|0]|k[b+1|0]<<8|(k[b+2|0]<<16|k[b+3|0]<<24))){break a}b=k[b|0]|k[b+1|0]<<8|(k[b+2|0]<<16|k[b+3|0]<<24);if(!xc(a,b<<24|b<<8&16711680|(b>>>8&65280|b>>>24))){break a}en(a,c);return}Ab(c,0,80)}function aE(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=Za-32|0;Za=d;c=Db(d,c);j[114630]=0;I(2352,d+16|0,b|0,c|0);e=j[114630];j[114630]=0;a:{b:{if((e|0)!=1){j[114630]=0;E(2353,a|0,d+16|0)|0;e=j[114630];j[114630]=0;if((e|0)==1){break b}gb(d+16|0);gb(c);j[a>>2]=58396;c=j[b+4>>2];j[a+8>>2]=j[b>>2];j[a+12>>2]=c;Za=d+32|0;return a|0}a=D()|0;C()|0;break a}a=D()|0;C()|0;gb(d+16|0)}gb(c);G(a|0);z()}function CL(a,b){a=a|0;b=+b;var c=0,d=0,e=0,f=0,g=0,h=0,i=0;e=Dr(b);d=Lra(a);a=0;a:{while(1){c=1;if((a|0)!=1024){j[114630]=0;c=+(a-1024|0);f=+Xa(1209,+(y(c*c*-9.5367431640625e-7+1)*b));g=j[114630];j[114630]=0;if((g|0)==1){break a}c=c*.0372006759294457;c=f*Kh(c)/(c*e)}h=wk(d,a),i=c*.011841342921061943,o[h>>3]=i;a=a+1|0;if((a|0)!=2048){continue}break}return}a=D()|0;C()|0;rf(d);G(a|0);z()}function Afa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;b=Th(a,b,c,d);j[a+4224>>2]=1049951732;c=a+4216|0;j[c>>2]=1065353216;j[c+4>>2]=1049951732;j[a+4208>>2]=1060320051;j[a+4212>>2]=1041865114;j[a>>2]=80804;j[114630]=0;K(1634,a+44|0,2,2)|0;c=j[114630];j[114630]=0;a:{if((c|0)==1){break a}j[114630]=0;N(1635,b|0);c=j[114630];j[114630]=0;if((c|0)==1){break a}return a|0}a=D()|0;C()|0;Ke(b);G(a|0);z()}function Dda(a,b){a=a|0;b=b|0;var c=0;j[114630]=0;N(2010,a|0);c=j[114630];j[114630]=0;a:{b:{if((c|0)!=1){j[a+16>>2]=b;b=j[a+20>>2];if(!b){break b}Fb(b);j[a+20>>2]=0;return}b=J(0)|0;C()|0;O(b|0)|0;j[114630]=0;L(1984,34929,a|0,0,0);a=j[114630];j[114630]=0;if((a|0)==1){break a}Q()}return}a=D()|0;C()|0;j[114630]=0;M(20);b=j[114630];j[114630]=0;if((b|0)!=1){G(a|0);z()}J(0)|0;C()|0;ib();z()}function Bya(a,b){var c=0,d=0,e=0;c=AN(a,b);j[114630]=0;e=E(985,a+12|0,b+12|0)|0;d=j[114630];j[114630]=0;a:{b:{if((d|0)!=1){j[114630]=0;E(986,a+24|0,b+24|0)|0;d=j[114630];j[114630]=0;if((d|0)==1){break b}c=j[b+40>>2];j[a+36>>2]=j[b+36>>2];j[a+40>>2]=c;i[a+52>>1]=l[b+52>>1];c=j[b+48>>2];j[a+44>>2]=j[b+44>>2];j[a+48>>2]=c;return}a=D()|0;C()|0;break a}a=D()|0;C()|0;Od(e)}Od(c);G(a|0);z()}function jw(a){var b=q(0),c=q(0),d=0,e=q(0),f=0;b=q(we(j[a+16>>2])>>>0);c=q(q(bb[j[j[a>>2]+200>>2]](a))*b);d=a,e=q(q(c*q(2.0480000972747803))*q(bb[j[j[a>>2]+192>>2]](a))),n[d+4248>>2]=e;d=a,f=ph(q(q(c*q(4.0960001945495605))+q(8192))),j[d+4256>>2]=f;c=q(bb[j[j[a>>2]+204>>2]](a));n[a+4252>>2]=c;b=q(c/b);if(!(bb[j[j[a>>2]+188>>2]](a)|0)){b=FE(q(b*q(3.1415927410125732)))}n[a+4244>>2]=b+b}function Tpa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0;e=Za-16|0;Za=e;j[e+12>>2]=c>>>3;j[e+8>>2]=j[a>>2];d=j[tb(e+12|0,e+8|0)>>2];b=lb(b);if(d){a=j[a+20>>2];c=d;while(1){lb(k[b|0]);lb(k[b+1|0]);f=a,g=lb(k[b+2|0])|lb(k[b+3|0])<<8,i[f>>1]=g;lb(k[b+4|0]);lb(k[b+5|0]);f=a,g=lb(k[b+6|0])|lb(k[b+7|0])<<8,i[f+2>>1]=g;a=a+4|0;b=b+8|0;c=c-1|0;if(c){continue}break}}Za=e+16|0;return d<<3}function Spa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0;e=Za-16|0;Za=e;j[e+12>>2]=c>>>3;j[e+8>>2]=j[a>>2];d=j[tb(e+12|0,e+8|0)>>2];b=lb(b);if(d){a=j[a+20>>2];c=d;while(1){lb(k[b+3|0]);lb(k[b+2|0]);f=a,g=lb(k[b+1|0])|lb(k[b|0])<<8,i[f>>1]=g;lb(k[b+7|0]);lb(k[b+6|0]);f=a,g=lb(k[b+5|0])|lb(k[b+4|0])<<8,i[f+2>>1]=g;a=a+4|0;b=b+8|0;c=c-1|0;if(c){continue}break}}Za=e+16|0;return d<<3}function Jp(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,i=0;c=Za-16|0;Za=c;e=j[a+4>>2];d=j[a>>2];h[c+12|0]=0;Cr(d,d+e|0,c+12|0);d=zb(b);e=zb(b);g=c,i=nb(b),j[g+12>>2]=i;j[c+8>>2]=j[a+4>>2]-1;Pe(d,e+j[tb(c+12|0,c+8|0)>>2]|0,j[a>>2]);d=j[a>>2];g=c,i=nb(b),j[g+12>>2]=i;j[c+8>>2]=j[a+4>>2]-1;b=j[tb(c+12|0,c+8|0)>>2];e=j[a+4>>2];f=j[a>>2];h[c+7|0]=0;Cr(b+d|0,e+f|0,c+7|0);Za=c+16|0;return a|0}function Eha(a){a=a|0;var b=0,c=0;b=j[a+20>>2];j[b+148>>2]=-1;j[114630]=0;F(507,b+4|0,8);b=j[114630];j[114630]=0;if((b|0)!=1){c=j[j[a+20>>2]+4>>2];b=j[a+4264>>2];a=j[a+4260>>2];h[c|0]=a;h[c+1|0]=a>>>8;h[c+2|0]=a>>>16;h[c+3|0]=a>>>24;h[c+4|0]=b;h[c+5|0]=b>>>8;h[c+6|0]=b>>>16;h[c+7|0]=b>>>24;return}b=J(71412)|0;if((C()|0)==(W(71412)|0)){O(b|0)|0;Xr(j[a+20>>2]+4|0);Q();return}G(b|0);z()}function oZ(){var a=0;a:{if(h[462296]&1){break a}if(!fd(462296)){break a}a=462128;while(1){a=Cb(a)+12|0;if((a|0)!=462296){continue}break}ed(462296)}vc(462128,69424);vc(462140,69431);vc(462152,69438);vc(462164,69446);vc(462176,69456);vc(462188,69465);vc(462200,69472);vc(462212,69481);vc(462224,69485);vc(462236,69489);vc(462248,69493);vc(462260,69497);vc(462272,69501);vc(462284,69505)}function lZ(){var a=0;a:{if(h[462472]&1){break a}if(!fd(462472)){break a}a=462304;while(1){a=Le(a)+12|0;if((a|0)!=462472){continue}break}ed(462472)}Ic(462304,69512);Ic(462316,69540);Ic(462328,69568);Ic(462340,69600);Ic(462352,69640);Ic(462364,69676);Ic(462376,69704);Ic(462388,69740);Ic(462400,69756);Ic(462412,69772);Ic(462424,69788);Ic(462436,69804);Ic(462448,69820);Ic(462460,69836)}function eF(a,b){a=a|0;b=b|0;var c=0;c=Za-16|0;Za=c;a:{b:{c:{if(b>>>0>=256){a=R(8)|0;j[114630]=0;c=E(85,c|0,40665)|0;b=j[114630];j[114630]=0;if((b|0)==1){break c}Wb(a,c);j[114630]=0;I(2004,a|0,83648,2012);a=j[114630];j[114630]=0;if((a|0)!=1){break a}b=D()|0;C()|0;gb(c);break b}a=j[a+32>>2]+p(b,896)|0;j[a+1075e3>>2]=0;j[a+1075060>>2]=0;Za=c+16|0;return}b=D()|0;C()|0;S(a|0)}G(b|0)}z()}function Rx(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0;e=Za-32|0;Za=e;j[e+8>>2]=c;f=e,g=ef(b),j[f+28>>2]=g;De(e+8|0,b,j[tb(e+8|0,e+28|0)>>2]);j[114630]=0;b=H(412,e+8|0)|0;c=j[114630];j[114630]=0;a:{if((c|0)==1){break a}c=j[e+8>>2];j[114630]=0;P(1057,a|0,b|0,c|0,d|0)|0;a=j[114630];j[114630]=0;if((a|0)==1){break a}lc(e+8|0);Za=e+32|0;return 1}a=D()|0;C()|0;lc(e+8|0);G(a|0);z()}function C3(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0;d=Za-16|0;Za=d;while(1){a:{if((c|0)<=(e|0)){break a}f=j[a+24>>2];g=j[a+28>>2];if(f>>>0>=g>>>0){if((bb[j[j[a>>2]+52>>2]](a,j[b>>2])|0)==-1){break a}e=e+1|0;b=b+4|0}else{j[d+12>>2]=g-f>>2;j[d+8>>2]=c-e;f=j[Pd(d+12|0,d+8|0)>>2];Jh(j[a+24>>2],b,f);g=f<<2;j[a+24>>2]=g+j[a+24>>2];e=e+f|0;b=b+g|0}continue}break}Za=d+16|0;return e|0}function zT(a,b){var c=0,d=0,e=0;d=Za-16|0;Za=d;j[d+12>>2]=b;c=j[a+4>>2];a:{if(!c){c=j[a>>2];break a}j[d+8>>2]=32-c;b=tb(d+8|0,d+12|0);c=j[a>>2];b=j[b>>2];j[c>>2]=j[c>>2]|-1<<j[a+4>>2]&-1>>>j[d+8>>2]-b;b=j[d+12>>2]-b|0;j[d+12>>2]=b;c=c+4|0;j[a>>2]=c}e=c;c=b>>>5<<2;Ab(e,255,c);b=j[d+12>>2]-(b&-32)|0;j[d+12>>2]=b;if(b){e=a;a=c+j[a>>2]|0;j[e>>2]=a;j[a>>2]=j[a>>2]|-1>>>32-b}Za=d+16|0}function rL(a,b,c){var d=0,e=0,f=0,g=0;d=Za-32|0;Za=d;j[a+4>>2]=0;a:{if(b){b:{if(xs(a)>>>0>=b>>>0){j[a+4>>2]=b;break b}hb(a);e=iy(d+16|0);j[114630]=0;f=E(928,a|0,b|0)|0;g=j[114630];j[114630]=0;if((g|0)==1){break a}j[114630]=0;F(929,e|0,f|0);f=j[114630];j[114630]=0;if((f|0)==1){break a}j[e+4>>2]=b;hy(a,e);Vd(e)}Zi(d,a);Hp(d,b,k[c|0])}Za=d+32|0;return}a=D()|0;C()|0;Vd(e);G(a|0);z()}function _Fa(a,b){var c=0,d=0;c=Za-48|0;Za=c;Uy(c+24|0,b);j[114630]=0;F(702,c+8|0,c+24|0);b=j[114630];j[114630]=0;a:{if((b|0)==1){break a}j[114630]=0;F(703,c+16|0,c+8|0);b=j[114630];j[114630]=0;if((b|0)==1){break a}b=j[c+16>>2];d=j[c+20>>2];j[114630]=0;K(704,a|0,b|0,d|0)|0;a=j[114630];j[114630]=0;if((a|0)==1){break a}lc(c+24|0);Za=c+48|0;return}a=D()|0;C()|0;lc(c+24|0);G(a|0);z()}function h7(a){var b=0,c=0,d=0,e=0;e=Za-16|0;Za=e;b=Mv(j[a+20>>2]+1900|0,j[a+16>>2]+1|0,j[a+12>>2])-Mv(1970,1,1)|0;c=HMa(b,b>>31,86400,0);b=p(j[a+8>>2],3600);d=b;c=c+b|0;b=ab+(b>>31)|0;b=c>>>0<d>>>0?b+1|0:b;d=p(j[a+4>>2],60);c=d+c|0;b=(d>>31)+b|0;b=c>>>0<d>>>0?b+1|0:b;a=j[a>>2];d=a;c=a+c|0;a=(a>>31)+b|0;a=AF(e+8|0,c,c>>>0<d>>>0?a+1|0:a);b=j[a>>2];Za=e+16|0;ab=j[a+4>>2];return b}function qza(a,b){a=a|0;b=b|0;var c=0;b=Za-32|0;Za=b;c=-1;a:{if(!mz(a,b+16|0)){break a}c=0;if(!ON(b+16|0)){break a}c=-1;if(!hj(a,b+8|0)){break a}a=b+8|4;c=0;if(!(k[a|0]|k[a+1|0]<<8|(k[a+2|0]<<16|k[a+3|0]<<24))){break a}a=b+8|0;c=k[a|0]|k[a+1|0]<<8|(k[a+2|0]<<16|k[a+3|0]<<24);a=b+8|0;c=(c|0)==((k[a|0]|k[a+1|0]<<8|(k[a+2|0]<<16|k[a+3|0]<<24))&2139062143)}a=c;Za=b+32|0;return a|0}function q6(a,b,c){a=a|0;b=b|0;c=c|0;a=a^-1;if(c>>>0>3){while(1){a=j[((k[b|0]^a&255)<<2)+40832>>2]^a>>>8;a=a>>>8^j[((k[b+1|0]^a&255)<<2)+40832>>2];a=a>>>8^j[((k[b+2|0]^a&255)<<2)+40832>>2];a=a>>>8^j[((k[b+3|0]^a&255)<<2)+40832>>2];b=b+4|0;c=c-4|0;if(c>>>0>3){continue}break}}if(c){while(1){a=j[((k[b|0]^a&255)<<2)+40832>>2]^a>>>8;b=b+1|0;c=c-1|0;if(c){continue}break}}return a^-1}function lW(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0;d=Za-48|0;Za=d;a:{b:{e=iW(zb(b),nb(b),zb(c),nb(c));if((e|0)!=-1){f=d,g=nd(b),j[f+32>>2]=g;c=Cd(d+40|0,d+32|0);f=d,g=nd(b),j[f+8>>2]=g;f=d,g=af(d+8|0,e),j[f+16>>2]=g;e=Cd(d+24|0,d+16|0);Ex(b,j[c>>2],j[e>>2]);break b}if(!nb(b)){break b}if((hW(zb(b),nb(b),zb(c),nb(c))|0)!=(nb(b)-1|0)){break b}Qc(a);break a}Mc(a,b)}Za=d+48|0}function MQ(a){var b=0,c=0,d=0;a:{if((k[a+60|0]|k[a+61|0]<<8|(k[a+62|0]<<16|k[a+63|0]<<24))!=808537417){break a}b=a+32|0;if((k[b|0]|k[b+1|0]<<8)>>>0>256){break a}b=a+36|0;if((k[b|0]|k[b+1|0]<<8)>>>0>255){break a}b=a+576|0;a=a- -64|0;while(1){c=0;b:{switch(k[a+15|0]){case 0:case 1:d=1;break;case 2:break b;default:break a}}c=d;a=a+16|0;if((b|0)!=(a|0)){continue}break}}return c&1}function Cda(a){a=a|0;var b=0;j[114630]=0;N(2010,a|0);b=j[114630];j[114630]=0;a:{b:{if((b|0)!=1){j[a+16>>2]=0;b=j[a+20>>2];if(!b){break b}Fb(b);j[a+20>>2]=0;return}b=J(0)|0;C()|0;O(b|0)|0;j[114630]=0;L(1984,34959,a|0,0,0);a=j[114630];j[114630]=0;if((a|0)==1){break a}Q()}return}a=D()|0;C()|0;j[114630]=0;M(20);b=j[114630];j[114630]=0;if((b|0)!=1){G(a|0);z()}J(0)|0;C()|0;ib();z()}function Qh(a,b,c){var d=0,e=0,f=0,g=0,i=0;d=Za-48|0;Za=d;e=a+24|0;f=j[j[e>>2]+24620>>2];a:{if(!((f|0)!=(b|0)|j[j[e>>2]+24624>>2]!=(c|0))){if(k[a+29|0]){break a}wJ(j[e>>2],1);break a}Vb(d+8|0,j[e>>2]+24604|0,40);g=j[d+40>>2];i=j[d+44>>2];j[d+28>>2]=c;j[d+24>>2]=b;_k(d+8|0,g);Om(d+8|0,i);Ww(j[e>>2],d+8|0);if((b|0)==(f|0)){break a}kna(j[e>>2]);jna(j[e>>2])}h[a+29|0]=1;Za=d+48|0}function Cw(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,i=0;f=Za-16|0;Za=f;a:{while(1){i=g&255;if(Ew(b,c,i>>>0>1)){h[f+15|0]=0;h[f+14|0]=0;II(a,f+15|0,f+14|0);break a}Ug(b,d);Ug(c,e);g=g+1|0;if(i>>>0<3){continue}break}if(ym(k[b|0])>>>0>ym(k[d|0])>>>0){Ug(b,d);Ug(c,e)}h[f+11|0]=k[b|0];II(f+12|0,f+11|0,c);h[b|0]=0;h[c|0]=0;b=l[f+12>>1];h[a|0]=b;h[a+1|0]=b>>>8}Za=f+16|0}function hla(a,b,c,d){var e=0,f=0,g=0,h=0,i=0,k=0;e=Za-32|0;Za=e;a:{if(me(b)>>>0>c>>>0){f=j[d>>2];g=j[d+4>>2];while(1){d=h&65535;if(uh(te(b,d))){i=Lb(te(b,d));k=Mb(te(b,d));d=e;j[d+24>>2]=f;j[d+28>>2]=g;j[d+8>>2]=f;j[d+12>>2]=g;gla(d+16|0,i,k,d+8|0)}h=h+1|0;if((h&65535)>>>0<=c>>>0){continue}break}j[a>>2]=f;j[a+4>>2]=g;break a}b=j[d+4>>2];j[a>>2]=j[d>>2];j[a+4>>2]=b}Za=e+32|0}function cR(a){var b=0,c=0;a:{if((k[a|0]|k[a+1|0]<<8|(k[a+2|0]<<16|k[a+3|0]<<24))!=777268804){break a}b=a+4|0;c=k[b|0]|k[b+1|0]<<8|(k[b+2|0]<<16|k[b+3|0]<<24);if((c<<24|c<<8&16711680|(c>>>8&65280|c>>>24))>>>0<14){break a}b=k[b|0]|k[b+1|0]<<8|(k[b+2|0]<<16|k[b+3|0]<<24);if((b<<24|b<<8&16711680|(b>>>8&65280|b>>>24))>>>0>256){break a}a=a+8|0;return!(k[a|0]|k[a+1|0]<<8)}return 0}function Vha(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0;e=Za-16|0;Za=e;d=ue(64);j[114630]=0;f=H(1422,d|0)|0;g=j[114630];j[114630]=0;a:{if((g|0)!=1){d=ax(e+8|0,f);f=j[d>>2];j[114630]=0;b=K(1629,f|0,b|0,c|0)|0;c=j[114630];j[114630]=0;b:{c:{if((c|0)!=1){if((b|0)==1){break c}$w(a);break b}a=D()|0;C()|0;Kf(d);break a}hp(a,d)}Kf(d);Za=e+16|0;return}a=D()|0;C()|0;Fb(d)}G(a|0);z()}function Ita(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0;d=Za-32|0;Za=d;j[d+24>>2]=b;a:{b=wh(d+8|0,a+8|0,Hta(b,c));if(j[b>>2]!=j[b+4>>2]){while(1){c=j[a+16>>2];e=j[b>>2];f=j[d+24>>2];j[114630]=0;I(766,c|0,e|0,f|0);c=j[114630];j[114630]=0;if((c|0)==1){break a}j[b>>2]=j[b>>2]+4;Id(d+24|0);if(j[b>>2]!=j[b+4>>2]){continue}break}}cc(b);Za=d+32|0;return}a=D()|0;C()|0;cc(b);G(a|0);z()}function vJa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0;d=Za-32|0;Za=d;j[d+24>>2]=b;a:{b=yl(d+8|0,a+8|0,vz(b,c));if(j[b>>2]!=j[b+4>>2]){while(1){c=j[a+16>>2];e=j[b>>2];f=j[d+24>>2];j[114630]=0;I(521,c|0,e|0,f|0);c=j[114630];j[114630]=0;if((c|0)==1){break a}j[b>>2]=j[b>>2]+2;je(d+24|0);if(j[b>>2]!=j[b+4>>2]){continue}break}}cc(b);Za=d+32|0;return}a=D()|0;C()|0;cc(b);G(a|0);z()}function Eda(a){a=a|0;var b=0;j[114630]=0;N(2010,a|0);b=j[114630];j[114630]=0;a:{b:{if((b|0)!=1){a=j[a+20>>2];if(!a){break b}return Gd(a)|0}b=J(0)|0;C()|0;O(b|0)|0;j[114630]=0;L(1984,34891,a|0,0,0);a=j[114630];j[114630]=0;if((a|0)==1){break a}Q();return 0}return Gd(34181)|0}a=D()|0;C()|0;j[114630]=0;M(20);b=j[114630];j[114630]=0;if((b|0)!=1){G(a|0);z()}J(0)|0;C()|0;ib();z()}function Fh(a,b,c,d,e){var f=0,g=0;f=Za-16|0;Za=f;j[f+8>>2]=b;a:{if(Ji(a,f+8|0)){j[c>>2]=j[c>>2]|6;b=0;break a}b=Bj(a);if(!ng(d,2048,b)){j[c>>2]=j[c>>2]|4;b=0;break a}b=Zl(d,b);while(1){b:{Mk(a);b=b-48|0;if(!Xn(a,f+8|0)|(e|0)<2){break b}g=Bj(a);if(!ng(d,2048,g)){break a}e=e-1|0;b=Zl(d,g)+p(b,10)|0;continue}break}if(!Ji(a,f+8|0)){break a}j[c>>2]=j[c>>2]|2}Za=f+16|0;return b}function Eh(a,b,c,d,e){var f=0,g=0;f=Za-16|0;Za=f;j[f+8>>2]=b;a:{if(yj(a,f+8|0)){j[c>>2]=j[c>>2]|6;b=0;break a}b=Kk(a);if(!zj(d,2048,b)){j[c>>2]=j[c>>2]|4;b=0;break a}b=Yl(d,b);while(1){b:{dm(a);b=b-48|0;if(!Cq(a,f+8|0)|(e|0)<2){break b}g=Kk(a);if(!zj(d,2048,g)){break a}e=e-1|0;b=Yl(d,g)+p(b,10)|0;continue}break}if(!yj(a,f+8|0)){break a}j[c>>2]=j[c>>2]|2}Za=f+16|0;return b}function nF(a,b){a=a|0;b=+b;var c=0,d=0;c=Za-16|0;Za=c;a:{b:{c:{if(!(b<=1?!(b<0):0)){d=R(8)|0;j[114630]=0;c=E(85,c|0,40643)|0;a=j[114630];j[114630]=0;if((a|0)==1){break c}Wb(d,c);j[114630]=0;I(2004,d|0,83648,2012);a=j[114630];j[114630]=0;if((a|0)!=1){break a}a=D()|0;C()|0;gb(c);break b}d=Zj(b*256);j[j[a+32>>2]+1074444>>2]=d;Za=c+16|0;return}a=D()|0;C()|0;S(d|0)}G(a|0)}z()}function Wga(a,b){a=a|0;b=b|0;var c=q(0);a:{switch(b|0){case 0:return q(n[a+4220>>2]);case 1:return q(n[a+4224>>2]);case 2:return q(n[a+4228>>2]);case 3:return q(k[a+4240|0]?q(1):q(0));case 4:return q(q(q(j[a+4232>>2])*q(.03125)));case 5:return q(k[a+4241|0]?q(1):q(0));case 6:return q(k[a+4242|0]?q(1):q(0));case 7:c=k[a+4244|0]?q(1):q(0);break;default:break a}}return q(c)}function eta(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0;d=Za-16|0;Za=d;j[d+12>>2]=b;a:{if(Zg(a)>>>0>=b>>>0){g=d,h=de(a),j[g+8>>2]=h;e=j[a>>2];b=c;f=j[tb(d+12|0,d+8|0)>>2];if(f){while(1){e=tta(e,b)+32|0;f=f-1|0;if(f){continue}break}}b=j[d+12>>2];e=j[d+8>>2];if(b>>>0>e>>>0){Ix(a,b-e|0,c);break a}fM(a,j[a>>2]+(b<<5)|0);break a}dta(a);cta(a,Hl(a,b));Ix(a,b,c)}Za=d+16|0}function Ura(a){var b=0;b=Za-16|0;Za=b;h[a|0]=0;h[a+1|0]=0;h[a+2|0]=0;h[a+3|0]=0;h[a+4|0]=0;h[a+5|0]=0;h[a+6|0]=0;h[a+7|0]=0;h[a+23|0]=0;h[a+24|0]=0;h[a+25|0]=0;h[a+26|0]=0;h[a+16|0]=0;h[a+17|0]=0;h[a+18|0]=0;h[a+19|0]=0;h[a+20|0]=0;h[a+21|0]=0;h[a+22|0]=0;h[a+23|0]=0;h[a+8|0]=0;h[a+9|0]=0;h[a+10|0]=0;h[a+11|0]=0;h[a+12|0]=0;h[a+13|0]=0;h[a+14|0]=0;h[a+15|0]=0;Za=b+16|0}function ox(a,b,c,d){a:{if(j[a+1074392>>2]!=(c|0)){break a}b:{if(d){c=p(b,896)+a|0;j[c+1075680>>2]=0;d=c+1074992|0;j[d>>2]=0;j[d+4>>2]=0;d=c+1075072|0;c=j[d>>2]|4096;j[d>>2]=c;break b}c=p(b,896)+a|0;j[c+1075672>>2]=0;c=j[c+1075072>>2]}d=p(b,896)+a|0;j[d+1075072>>2]=c|2097152;Nj(a,b,255,0);if(!(k[d+1075073|0]&2)){break a}a=a+1304392|0;if(!$c(a)){break a}qh(j[a>>2],b,0)}}function m7(a,b,c,d,e){var f=0,g=0,h=0,j=0,k=0,l=0,m=0;g=Za-16|0;Za=g;if(e){while(1){h=0;if(d){while(1){f=o[Kg(b,h,j)>>3];Pb(c,h);o[g+8>>3]=f;wf(g+8|0,-1,1);f=o[g+8>>3]*32768;o[g+8>>3]=f;f=zd(f);a:{if(r(f)<2147483648){k=~~f;break a}k=-2147483648}k=Dc(k);l=lm(a,h,j),m=k,i[l>>1]=m;h=h+1|0;if((h|0)!=(d|0)){continue}break}}j=j+1|0;if((j|0)!=(e|0)){continue}break}}Za=g+16|0}function Q7(a,b,c,d,e){var f=0,g=0,h=0,j=0,k=0,l=0,m=0;g=Za-16|0;Za=g;if(e){while(1){h=0;if(d){while(1){f=o[Kg(b,h,j)>>3];Pb(c,h);o[g+8>>3]=f;wf(g+8|0,-1,1);f=o[g+8>>3]*32768;o[g+8>>3]=f;f=zd(f);a:{if(r(f)<2147483648){k=~~f;break a}k=-2147483648}k=Dc(k);l=nm(a,h,j),m=k,i[l>>1]=m;h=h+1|0;if((h|0)!=(d|0)){continue}break}}j=j+1|0;if((j|0)!=(e|0)){continue}break}}Za=g+16|0}function YBa(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=q(0),h=0,j=0,k=0,l=0;f=Za-16|0;Za=f;if(d){a=(e<<1)+a|0;e=0;c=c<<1;while(1){n[f+12>>2]=n[b>>2];Kd(f+12|0,q(-1));g=q(n[f+12>>2]*q(32768));n[f+12>>2]=g;j=a;g=Rd(g);a:{if(q(r(g))<q(2147483648)){h=~~g;break a}h=-2147483648}k=j,l=Dc(h),i[k>>1]=l;b=b+4|0;a=a+c|0;e=e+1|0;if((e|0)!=(d|0)){continue}break}}Za=f+16|0}function zM(a,b,c,d){var e=0,f=0,g=0,h=0;e=Za-16|0;Za=e;if(Yi(a)){f=k[(Ld(k[a+819|0])?a+819|0:a+821|0)|0];mb(e+8|0,d+1074308|0,34);a:{if(!kb(e+8|0)){break a}d=f;if(d){if(d>>>0>120){break a}f=k[Pb(j[a+656>>2]+108|0,d-1|0)|0];break a}f=0}g=a,h=bi(q(q(q(j[a+704>>2]<<4)*b)*Pia(j[j[a+656>>2]+44>>2],(c+f<<16)-3997696>>16,j[a+876>>2]+j[a+768>>2]|0))),j[g+700>>2]=h}Za=e+16|0}function P5(a,b,c,d,e,f){var g=0,i=0,j=0,l=0,m=0,n=0;while(1){g=k[d+j|0];if(g){a:{if(f&8){Vb(a,b,g);break a}l=k[c+j|0];if(!l){Ab(a,0,g);Ab(b,0,g);break a}n=(f|0)>-1?-1:-1<<l^-1;i=0;while(1){m=Bd(e,l);h[b+i|0]=(m|0)==(n|0)?-1:m;h[a+i|0]=m;i=i+1|0;if((i|0)!=(g|0)){continue}break}}f=f<<1;a=a+g|0;b=b+g|0;j=j+1|0;if((j|0)!=4){continue}}break}h[a+2|0]=0;h[a|0]=0;h[a+1|0]=0}function kI(a,b){var c=0,d=0,e=0,f=q(0),g=0,h=q(0);c=Za-16|0;Za=c;e=0;a:{if(!mf(j[j[a>>2]-12>>2]+a|0)){break a}j[c+12>>2]=0;gi(a,c+12|0);d=j[c+12>>2];e=0;if(d>>>0>65535){break a}Wk(b,d);if(j[c+12>>2]){d=0;while(1){j[c+8>>2]=0;jo(a,c+8|0);f=n[c+8>>2];g=xb(b,d),h=f,n[g>>2]=h;d=d+1|0;if(d>>>0<m[c+12>>2]){continue}break}}e=mf(j[j[a>>2]-12>>2]+a|0)}d=e;Za=c+16|0;return d}function jI(a,b){var c=0,d=0,e=0,f=q(0),g=0,h=q(0);c=Za-16|0;Za=c;e=0;a:{if(!mf(j[j[a>>2]-12>>2]+a|0)){break a}i[c+14>>1]=0;cf(a,c+14|0);d=l[c+14>>1];e=0;if(d>>>0>65535){break a}Wk(b,d);if(l[c+14>>1]){d=0;while(1){j[c+8>>2]=0;jo(a,c+8|0);f=n[c+8>>2];g=xb(b,d),h=f,n[g>>2]=h;d=d+1|0;if(d>>>0<l[c+14>>1]){continue}break}}e=mf(j[j[a>>2]-12>>2]+a|0)}a=e;Za=c+16|0;return a}function Xpa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0;e=Za-16|0;Za=e;j[e+12>>2]=(c>>>0)/6;j[e+8>>2]=j[a>>2];d=j[tb(e+12|0,e+8|0)>>2];b=lb(b);if(d){a=j[a+20>>2];c=d;while(1){lb(k[b|0]);f=a,g=lb(k[b+1|0])|lb(k[b+2|0])<<8,i[f>>1]=g;lb(k[b+3|0]);f=a,g=lb(k[b+4|0])|lb(k[b+5|0])<<8,i[f+2>>1]=g;a=a+4|0;b=b+6|0;c=c-1|0;if(c){continue}break}}Za=e+16|0;return p(d,6)|0}function Wpa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0;e=Za-16|0;Za=e;j[e+12>>2]=(c>>>0)/6;j[e+8>>2]=j[a>>2];d=j[tb(e+12|0,e+8|0)>>2];b=lb(b);if(d){a=j[a+20>>2];c=d;while(1){lb(k[b+2|0]);f=a,g=lb(k[b+1|0])|lb(k[b|0])<<8,i[f>>1]=g;lb(k[b+5|0]);f=a,g=lb(k[b+4|0])|lb(k[b+3|0])<<8,i[f+2>>1]=g;a=a+4|0;b=b+6|0;c=c-1|0;if(c){continue}break}}Za=e+16|0;return p(d,6)|0}function Sk(a){if((a|0)>=0){if((a|0)<=16383){if((a|0)<=15){return h[a+50672|0]}if((a|0)<=511){return h[(a>>>5|0)+50672|0]+5|0}return h[(a>>>10|0)+50672|0]+10|0}if((a|0)<=16777215){if((a|0)<=524287){return h[(a>>>15|0)+50672|0]+15|0}return h[(a>>>20|0)+50672|0]+20|0}if((a|0)<=536870911){return h[(a>>>25|0)+50672|0]+25|0}a=h[(a>>>30|0)+50672|0]+30|0}else{a=0}return a}function p5(a,b){var c=0,d=0,e=q(0),f=0;d=v(xv(+q(q(Zn(+q(a|0)))/q(b|0))));a:{if(r(d)<2147483648){c=~~d;break a}c=-2147483648}f=c;d=v(sv(+q(q(c|0)+q(1)),b));b:{if(r(d)<2147483648){c=~~d;break b}c=-2147483648}c=f+((c|0)<=(a|0))|0;e=q(c|0);if(!(sv(+q(e+q(1)),b)<=+(a|0))){d=v(sv(+e,b));c:{if(r(d)<2147483648){b=~~d;break c}b=-2147483648}return(b|0)>(a|0)?-1:c}return-1}function n6(a){var b=0;if(!a){return-2}j[a+44>>2]=0;j[a+48>>2]=0;j[a+52>>2]=0;j[a+20>>2]=0;j[a+24>>2]=0;j[a+8>>2]=0;b=j[a+32>>2];if(!b){j[a+32>>2]=2293;b=2293}if(!j[a+36>>2]){j[a+36>>2]=2294}b=bb[b|0](j[a+40>>2],1,43784)|0;if(!b){return-4}j[a+28>>2]=b;j[b+43780>>2]=1;j[b+10992>>2]=0;j[b+10996>>2]=0;j[b>>2]=0;j[b+11008>>2]=15;j[b+11e3>>2]=1;j[b+11004>>2]=0;return 0}function vq(a,b,c){var d=0,e=0;if(c&2048){h[a|0]=43;a=a+1|0}if(c&1024){h[a|0]=35;a=a+1|0}d=c&260;if((d|0)!=260){h[a|0]=46;h[a+1|0]=42;a=a+2|0}c=c&16384;while(1){e=k[b|0];if(e){h[a|0]=e;a=a+1|0;b=b+1|0;continue}break}a:{b:{if((d|0)!=256){if((d|0)!=4){break b}b=c?70:102;break a}b=c?69:101;break a}b=c?65:97;if((d|0)==260){break a}b=c?71:103}h[a|0]=b;return(d|0)!=260}function Rpa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0;e=Za-16|0;Za=e;j[e+12>>2]=c>>>3;j[e+8>>2]=j[a>>2];d=j[tb(e+12|0,e+8|0)>>2];b=lb(b);if(d){a=j[a+20>>2];c=d;while(1){lb(k[b|0]);lb(k[b+1|0]);lb(k[b+2|0]);lb(k[b+3|0]);lb(k[b+4|0]);lb(k[b+5|0]);f=a,g=lb(k[b+6|0])|lb(k[b+7|0])<<8,i[f>>1]=g;a=a+2|0;b=b+8|0;c=c-1|0;if(c){continue}break}}Za=e+16|0;return d<<3}function Qpa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0;e=Za-16|0;Za=e;j[e+12>>2]=c>>>3;j[e+8>>2]=j[a>>2];d=j[tb(e+12|0,e+8|0)>>2];b=lb(b);if(d){a=j[a+20>>2];c=d;while(1){lb(k[b+7|0]);lb(k[b+6|0]);lb(k[b+5|0]);lb(k[b+4|0]);lb(k[b+3|0]);lb(k[b+2|0]);f=a,g=lb(k[b+1|0])|lb(k[b|0])<<8,i[f>>1]=g;a=a+2|0;b=b+8|0;c=c-1|0;if(c){continue}break}}Za=e+16|0;return d<<3}function PC(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0;e=Za-16|0;Za=e;f=j[Rb(a)>>2];d=j[c>>2]-j[a>>2]|0;a:{if(d>>>0<2147483647){d=d<<1;break a}d=-1}d=d?d:4;h=j[b>>2];i=j[a>>2];g=iq((f|0)==2483?0:j[a>>2],d);if(g){if((f|0)!=2483){ud(a)}j[e+4>>2]=2421;f=yd(e+8|0,g,e+4|0);MC(a,f);mc(f);j[b>>2]=j[a>>2]+(h-i|0);j[c>>2]=j[a>>2]+(d&-4);Za=e+16|0;return}Gu();z()}function f5(a,b,c,d,e,f){var g=0,h=0;a:{if(f){g=1;if((e|0)<1){break a}f=0;while(1){if(!b5(a,b,(d<<2)+c|0,e-f|0)){return 0}h=j[b>>2];d=h+d|0;f=f+h|0;if((f|0)<(e|0)){continue}break}break a}g=1;f=(e|0)/j[b>>2]|0;if((f|0)<1){break a}c=(d<<2)+c|0;e=e-d|0;g=0;d=0;while(1){if(!a5(a,b,c+(d<<2)|0,e-d|0,f)){break a}d=d+1|0;if((f|0)!=(d|0)){continue}break}return 1}return g}function GE(a,b){a:{if((b|0)>=128){a=q(a*q(1.7014118346046923e+38));if((b|0)<255){b=b-127|0;break a}a=q(a*q(1.7014118346046923e+38));b=((b|0)<381?b:381)-254|0;break a}if((b|0)>-127){break a}a=q(a*q(1.1754943508222875e-38));if((b|0)>-253){b=b+126|0;break a}a=q(a*q(1.1754943508222875e-38));b=((b|0)>-378?b:-378)+252|0}return q(a*(PMa(2,(b<<23)+1065353216|0),TMa()))}function uja(a,b){var c=0,d=0,e=0;e=sja(a,b);j[a+20>>2]=j[b+20>>2];c=j[b+16>>2];j[a+12>>2]=j[b+12>>2];j[a+16>>2]=c;j[114630]=0;c=E(1584,a+24|0,b+24|0)|0;d=j[114630];j[114630]=0;a:{b:{if((d|0)!=1){j[114630]=0;E(120,a+36|0,b+36|0)|0;d=j[114630];j[114630]=0;if((d|0)==1){break b}j[a+48>>2]=j[b+48>>2];return}a=D()|0;C()|0;break a}a=D()|0;C()|0;Ud(c)}ol(e);G(a|0);z()}function tF(a,b){a=a|0;b=b|0;var c=0;c=Za-16|0;Za=c;a:{b:{c:{if(b-32>>>0>=481){a=R(8)|0;j[114630]=0;c=E(85,c|0,40587)|0;b=j[114630];j[114630]=0;if((b|0)==1){break c}Wb(a,c);j[114630]=0;I(2004,a|0,83648,2012);a=j[114630];j[114630]=0;if((a|0)!=1){break a}b=D()|0;C()|0;gb(c);break b}j[j[a+32>>2]+1074420>>2]=p(b,1e4);Za=c+16|0;return}b=D()|0;C()|0;S(a|0)}G(b|0)}z()}function haa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;b=Za-32|0;Za=b;a:{a=Gr(a,ql(b+24|0,lb(c),d),0);if(a+1>>>0>=3){a=R(8)|0;j[114630]=0;b=E(85,b+8|0,38640)|0;c=j[114630];j[114630]=0;b:{if((c|0)!=1){Wb(a,b);j[114630]=0;I(2004,a|0,83648,2012);a=j[114630];j[114630]=0;if((a|0)!=1){break a}d=D()|0;C()|0;gb(b);break b}d=D()|0;C()|0;S(a|0)}G(d|0);z()}Za=b+32|0;return a|0}z()}function Tia(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,k=0;d=Za-16|0;Za=d;g=d;e=i[b>>1];f=e;b=i[a+30>>1];a:{if(!b){break a}if((e|0)>=0){f=(e|0)%(b|0)|0;break a}f=((e^-1)%(b|0)^-1)+b|0}i[g+14>>1]=f;b:{if(!Ec(c)){zi(mI(a+52|0,d+14|0),c);break b}a=a+52|0;h=d,k=tw(a,d+14|0),j[h+8>>2]=k;h=d,k=ii(a),j[h>>2]=k;if(!hi(d+8|0,d)){break b}Sia(a,j[d+8>>2])}Za=d+16|0}function Bja(a,b,c){var d=0,e=0;e=Za-32|0;Za=e;a:{b:{if((j[hb(a)>>2]-j[a+4>>2]|0)/52>>>0>=b>>>0){xw(a,b,c);break b}d=hb(a);d=qja(e+8|0,zI(a,df(a)+b|0),df(a),d);j[114630]=0;I(1580,d|0,b|0,c|0);b=j[114630];j[114630]=0;if((b|0)==1){break a}j[114630]=0;F(1581,a|0,d|0);a=j[114630];j[114630]=0;if((a|0)==1){break a}rI(d)}Za=e+32|0;return}a=D()|0;C()|0;rI(d);G(a|0);z()}function Pqa(a,b,c,d){var e=0,f=0,g=0,h=0,i=0,k=0;g=Za-16|0;Za=g;i=j[a+4>>2];d=(i-d|0)+b|0;e=yh(g,a,c-d>>1);a:{if(c>>>0>d>>>0){f=d;while(1){h=hb(a);k=j[e+4>>2];j[114630]=0;I(1243,h|0,k|0,f|0);h=j[114630];j[114630]=0;if((h|0)==1){break a}j[e+4>>2]=j[e+4>>2]+2;f=f+2|0;if(f>>>0<c>>>0){continue}break}}ub(e);et(b,d,i);Za=g+16|0;return}a=D()|0;C()|0;ub(e);G(a|0);z()}function NJa(a,b,c,d){var e=0,f=0,g=0,h=0,i=0,k=0;g=Za-16|0;Za=g;i=j[a+4>>2];d=(i-d|0)+b|0;e=yh(g,a,c-d>>1);a:{if(c>>>0>d>>>0){f=d;while(1){h=hb(a);k=j[e+4>>2];j[114630]=0;I(521,h|0,k|0,f|0);h=j[114630];j[114630]=0;if((h|0)==1){break a}j[e+4>>2]=j[e+4>>2]+2;f=f+2|0;if(f>>>0<c>>>0){continue}break}}ub(e);uJa(b,d,i);Za=g+16|0;return}a=D()|0;C()|0;ub(e);G(a|0);z()}function Tta(a,b,c,d){var e=0,f=0,g=0,h=0,i=0,k=0;g=Za-16|0;Za=g;i=j[a+4>>2];d=(i-d|0)+b|0;e=_d(g,a,c-d>>2);a:{if(c>>>0>d>>>0){f=d;while(1){h=hb(a);k=j[e+4>>2];j[114630]=0;I(766,h|0,k|0,f|0);h=j[114630];j[114630]=0;if((h|0)==1){break a}j[e+4>>2]=j[e+4>>2]+4;f=f+4|0;if(f>>>0<c>>>0){continue}break}}ub(e);et(b,d,i);Za=g+16|0;return}a=D()|0;C()|0;ub(e);G(a|0);z()}function Gea(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;b=Th(a,b,c,d);j[a+4272>>2]=1065353216;j[a+4216>>2]=1056964608;j[a+4208>>2]=1056880300;j[a+4212>>2]=1050733080;j[a>>2]=81852;j[114630]=0;K(1634,a+44|0,2,2)|0;c=j[114630];j[114630]=0;a:{if((c|0)==1){break a}j[114630]=0;N(1635,b|0);c=j[114630];j[114630]=0;if((c|0)==1){break a}return a|0}a=D()|0;C()|0;Ke(b);G(a|0);z()}function Eo(a,b,c,d){a:{if(j[a+480180>>2]==4){if(c){h[b+830|0]=k[b+830|0]&15|c<<4;break a}c=k[b+830|0]>>>4|0;break a}if(d){if(c){h[b+854|0]=c;break a}c=k[b+854|0];break a}if(c){h[b+830|0]=c;break a}c=k[b+830|0]}b:{if(!(h[b+872|0]&1)){break b}c=j[b+688>>2]+((c&255)<<2)|0;j[b+688>>2]=(c|0)<256?c:256;if(!(j[a+480180>>2]&1)){break b}j[b+88>>2]=j[b+88>>2]|2097152}}function U$(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0;e=Za-16|0;Za=e;f=j[Rb(a)>>2];d=j[c>>2]-j[a>>2]|0;a:{if(d>>>0<2147483647){d=d<<1;break a}d=-1}d=d?d:1;h=j[b>>2];i=j[a>>2];g=iq((f|0)==2483?0:j[a>>2],d);if(g){if((f|0)!=2483){ud(a)}j[e+4>>2]=2421;f=yd(e+8|0,g,e+4|0);MC(a,f);mc(f);j[b>>2]=j[a>>2]+(h-i|0);j[c>>2]=d+j[a>>2];Za=e+16|0;return}Gu();z()}function Xha(a,b,c){var d=0,e=0,f=0,g=0;e=Za-16|0;Za=e;d=ue(64);j[114630]=0;f=H(1422,d|0)|0;g=j[114630];j[114630]=0;a:{if((g|0)!=1){d=ax(e+8|0,f);f=j[d>>2];j[114630]=0;b=K(1628,f|0,b|0,c|0)|0;c=j[114630];j[114630]=0;b:{c:{if((c|0)!=1){if((b|0)==1){break c}$w(a);break b}a=D()|0;C()|0;Kf(d);break a}hp(a,d)}Kf(d);Za=e+16|0;return}a=D()|0;C()|0;Fb(d)}G(a|0);z()}function L5(a,b,c){var d=0,e=0,f=0,g=0,h=0;f=Za-80|0;Za=f;if((c|0)>=1){g=f|8;h=f|4;while(1){d=Vb(f,a,72);e=j[b+20>>2];j[a+16>>2]=j[b+16>>2];j[a+20>>2]=e;e=j[b+12>>2];j[a+8>>2]=j[b+8>>2];j[a+12>>2]=e;e=j[b+4>>2];j[a>>2]=j[b>>2];j[a+4>>2]=e;e=d;d=b+24|0;Fv(e,a+24|0,d);Fv(h,a+48|0,d);Fv(g,b,d);a=a+72|0;b=b+36|0;d=(c|0)>1;c=c-1|0;if(d){continue}break}}Za=f+80|0}function Gda(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;j[114630]=0;N(2010,a|0);d=j[114630];j[114630]=0;if((d|0)!=1){j[a+16>>2]=0;j[a+12>>2]=c;j[a+8>>2]=b;return}b=J(0)|0;C()|0;O(b|0)|0;j[114630]=0;L(1984,34831,a|0,0,0);a=j[114630];j[114630]=0;if((a|0)!=1){Q();return}a=D()|0;C()|0;j[114630]=0;M(20);b=j[114630];j[114630]=0;if((b|0)!=1){G(a|0);z()}J(0)|0;C()|0;ib();z()}function $Fa(a,b,c){var d=0,e=0;e=Za-32|0;Za=e;a:{b:{if((j[hb(a)>>2]-j[a+4>>2]|0)/6>>>0>=b>>>0){Wy(a,b,c);break b}d=hb(a);d=VP(e+8|0,Ly(a,Lf(a)+b|0),Lf(a),d);j[114630]=0;I(707,d|0,b|0,c|0);b=j[114630];j[114630]=0;if((b|0)==1){break a}j[114630]=0;F(708,a|0,d|0);a=j[114630];j[114630]=0;if((a|0)==1){break a}Os(d)}Za=e+32|0;return}a=D()|0;C()|0;Os(d);G(a|0);z()}function mpa(a,b,c){var d=0,e=q(0),f=q(0),g=0,h=0;d=Za-16|0;Za=d;e=q(p(c+256|0,b)>>>0);b=d;a:{if(j[a+480180>>2]!=33554432){f=q(110);e=q(q(e/(k[a+480209|0]&128?q(10240):q(12288)))+q(.25));break a}f=q(125);e=q(e*q(9227362170349807e-20))}g=b,h=ph(q(Yd(q(2),e)*f)),j[g+12>>2]=h;Md(d+12|0,120,2e4);Za=d+16|0;a=j[a+24620>>2];b=j[d+12>>2];return(a|0)<b<<1?a>>>1|0:b}function gja(a){a=a|0;var b=0,c=0,d=0,e=0,f=0,g=0;b=Za-16|0;Za=b;i[a>>1]=0;c=Jj(a+4|0);d=Jj(a+16|0);j[a+36>>2]=0;e=Qc(a+40|0);f=fja(a+52|0);Wh(c);i[a+28>>1]=65472;j[114630]=0;j[b+12>>2]=1065353216;I(1587,c|0,128,b+12|0);g=j[114630];j[114630]=0;if((g|0)!=1){j[a+32>>2]=0;i[a+30>>1]=0;Wh(d);Za=b+16|0;return a|0}a=D()|0;C()|0;kQ(f);gb(e);xf(d);xf(c);G(a|0);z()}function bja(a,b,c){var d=0,e=0;e=Za-32|0;Za=e;a:{b:{if(j[hb(a)>>2]-j[a+4>>2]>>2>>>0>=b>>>0){sw(a,b,c);break b}d=hb(a);d=uw(e+8|0,ie(a,sb(a)+b|0),sb(a),d);j[114630]=0;I(1591,d|0,b|0,c|0);b=j[114630];j[114630]=0;if((b|0)==1){break a}j[114630]=0;F(1592,a|0,d|0);a=j[114630];j[114630]=0;if((a|0)==1){break a}wm(d)}Za=e+32|0;return}a=D()|0;C()|0;wm(d);G(a|0);z()}function Msa(a,b,c){var d=0,e=0;e=Za-32|0;Za=e;a:{b:{if(j[hb(a)>>2]-j[a+4>>2]>>5>>>0>=b>>>0){Ix(a,b,c);break b}d=hb(a);d=XL(e+8|0,Hl(a,de(a)+b|0),de(a),d);j[114630]=0;I(1188,d|0,b|0,c|0);b=j[114630];j[114630]=0;if((b|0)==1){break a}j[114630]=0;F(1175,a|0,d|0);a=j[114630];j[114630]=0;if((a|0)==1){break a}fs(d)}Za=e+32|0;return}a=D()|0;C()|0;fs(d);G(a|0);z()}function uF(a,b){a=a|0;b=b|0;var c=0;c=Za-16|0;Za=c;a:{b:{c:{if(b-1>>>0>=65535){a=R(8)|0;j[114630]=0;c=E(85,c|0,40568)|0;b=j[114630];j[114630]=0;if((b|0)==1){break c}Wb(a,c);j[114630]=0;I(2004,a|0,83648,2012);a=j[114630];j[114630]=0;if((a|0)!=1){break a}b=D()|0;C()|0;gb(c);break b}j[j[a+32>>2]+1074416>>2]=b;Za=c+16|0;return}b=D()|0;C()|0;S(a|0)}G(b|0)}z()}function $l(a,b,c){var d=0,e=0,f=0;d=Za-16|0;Za=d;hc(d+8|0,b);j[114630]=0;b=H(2451,d+8|0)|0;e=j[114630];j[114630]=0;a:{if((e|0)==1){break a}j[114630]=0;e=H(2461,b|0)|0;f=j[114630];j[114630]=0;if((f|0)==1){break a}j[c>>2]=e;j[114630]=0;F(2462,a|0,b|0);a=j[114630];j[114630]=0;if((a|0)==1){break a}wb(d+8|0);Za=d+16|0;return}a=D()|0;C()|0;wb(d+8|0);G(a|0);z()}function uJ(a,b){var c=0,d=0;a:{if(l[a+480188>>1]<=b>>>0){break a}b:{c:{c=p(b,896)+a|0;d=k[c+1075797|0];switch(d-31|0){case 1:break b;case 0:break c;default:break a}}if(!(k[a+480209|0]&16)){break a}}c=h[c+1075799|0];if((c|0)>=0){mK(a,b,(d|0)==32,((k[(p(b,896)+a|0)+1075848|0]<<5)+a|0)+901692|0,c&255);return}mK(a,b,(d|0)==32,(((c&127)<<5)+a|0)+902204|0,0)}}function mMa(a,b,c){var d=0,e=0;e=Za-32|0;Za=e;a:{b:{if(j[hb(a)>>2]-j[a+4>>2]>>1>>>0>=b>>>0){zt(a,b,c);break b}d=hb(a);d=yt(e+8|0,ui(a,Yb(a)+b|0),Yb(a),d);j[114630]=0;I(379,d|0,b|0,c|0);b=j[114630];j[114630]=0;if((b|0)==1){break a}j[114630]=0;F(380,a|0,d|0);a=j[114630];j[114630]=0;if((a|0)==1){break a}mk(d)}Za=e+32|0;return}a=D()|0;C()|0;mk(d);G(a|0);z()}function lra(a,b){var c=0,d=0;d=Za-32|0;Za=d;a:{b:{if((j[hb(a)>>2]-j[a+4>>2]|0)/12>>>0>=b>>>0){ara(a,b);break b}c=hb(a);c=$qa(d+8|0,fm(a,ec(a)+b|0),ec(a),c);j[114630]=0;F(1229,c|0,b|0);b=j[114630];j[114630]=0;if((b|0)==1){break a}j[114630]=0;F(1230,a|0,c|0);a=j[114630];j[114630]=0;if((a|0)==1){break a}iL(c)}Za=d+32|0;return}a=D()|0;C()|0;iL(c);G(a|0);z()}function bm(a,b,c){var d=0,e=0,f=0;d=Za-16|0;Za=d;hc(d+8|0,b);j[114630]=0;b=H(2417,d+8|0)|0;e=j[114630];j[114630]=0;a:{if((e|0)==1){break a}j[114630]=0;e=H(2432,b|0)|0;f=j[114630];j[114630]=0;if((f|0)==1){break a}h[c|0]=e;j[114630]=0;F(2433,a|0,b|0);a=j[114630];j[114630]=0;if((a|0)==1){break a}wb(d+8|0);Za=d+16|0;return}a=D()|0;C()|0;wb(d+8|0);G(a|0);z()}function XBa(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=q(0),i=0,j=0,k=0,l=0;f=Za-16|0;Za=f;if(d){a=a+e|0;e=0;while(1){n[f+12>>2]=n[b>>2];Kd(f+12|0,q(-1));g=q(n[f+12>>2]*q(128));n[f+12>>2]=g;j=a;g=Rd(g);a:{if(q(r(g))<q(2147483648)){i=~~g;break a}i=-2147483648}k=j,l=NBa(i),h[k|0]=l;a=a+c|0;b=b+4|0;e=e+1|0;if((e|0)!=(d|0)){continue}break}}Za=f+16|0}function zea(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;b=Th(a,b,c,d);c=a+4216|0;j[c>>2]=1051372203;j[c+4>>2]=0;j[a+4208>>2]=1065353216;j[a+4212>>2]=1065353216;j[a>>2]=82056;j[114630]=0;K(1634,a+44|0,2,2)|0;c=j[114630];j[114630]=0;a:{if((c|0)==1){break a}j[114630]=0;N(1635,b|0);c=j[114630];j[114630]=0;if((c|0)==1){break a}return a|0}a=D()|0;C()|0;Ke(b);G(a|0);z()}function q7(a,b,c,d,e){var f=0,g=0,h=0,k=0,l=0,m=0,n=0,o=0;if(e){l=c+16|0;while(1){g=0;if(d){while(1){f=j[tf(b,g,h)>>2];k=Ae(c,g);f=f+(j[k>>2]>>1)|0;m=f;f=ar(l)+f&-4096;j[k>>2]=m-f;f=f-2147481600>>>12|0;f=f>>>0>491520?f:491520;n=lm(a,g,h),o=(f|0)<557055?f:557055,i[n>>1]=o;g=g+1|0;if((g|0)!=(d|0)){continue}break}}h=h+1|0;if((h|0)!=(e|0)){continue}break}}}function mFa(a,b,c){var d=0,e=0;e=Za-32|0;Za=e;a:{b:{if(j[hb(a)>>2]-j[a+4>>2]>>2>>>0>=b>>>0){US(a,b,c);break b}d=hb(a);d=as(e+8|0,ie(a,sb(a)+b|0),sb(a),d);j[114630]=0;I(735,d|0,b|0,c|0);b=j[114630];j[114630]=0;if((b|0)==1){break a}j[114630]=0;F(96,a|0,d|0);a=j[114630];j[114630]=0;if((a|0)==1){break a}Rj(d)}Za=e+32|0;return}a=D()|0;C()|0;Rj(d);G(a|0);z()}function bEa(a,b){var c=0,d=0;d=Za-32|0;Za=d;a:{b:{if((j[hb(a)>>2]-j[a+4>>2]|0)/33>>>0>=b>>>0){$Da(a,b);break b}c=hb(a);c=ZDa(d+8|0,_Da(a,$j(a)+b|0),$j(a),c);j[114630]=0;F(762,c|0,b|0);b=j[114630];j[114630]=0;if((b|0)==1){break a}j[114630]=0;F(763,a|0,c|0);a=j[114630];j[114630]=0;if((a|0)==1){break a}LP(c)}Za=d+32|0;return}a=D()|0;C()|0;LP(c);G(a|0);z()}function U7(a,b,c,d,e){var f=0,g=0,h=0,k=0,l=0,m=0,n=0,o=0;if(e){l=c+16|0;while(1){g=0;if(d){while(1){f=j[tf(b,g,h)>>2];k=Ae(c,g);f=f+(j[k>>2]>>1)|0;m=f;f=ar(l)+f&-4096;j[k>>2]=m-f;f=f-2147481600>>>12|0;f=f>>>0>491520?f:491520;n=nm(a,g,h),o=(f|0)<557055?f:557055,i[n>>1]=o;g=g+1|0;if((g|0)!=(d|0)){continue}break}}h=h+1|0;if((h|0)!=(e|0)){continue}break}}}function Sda(a,b,c,d,e,f,g,h,i,k){j[114630]=0;a=xa(2001,a|0,b|0,c|0,d|0)|0;b=j[114630];j[114630]=0;a:{if((b|0)==1){a=J(0)|0;C()|0;O(a|0)|0;j[114630]=0;Z(1995,34641,e|0,f|0,g|0,h|0,i|0,k|0);a=j[114630];j[114630]=0;if((a|0)==1){break a}Q();a=-255}return a}a=D()|0;C()|0;j[114630]=0;M(20);b=j[114630];j[114630]=0;if((b|0)!=1){G(a|0);z()}J(0)|0;C()|0;ib();z()}function Iq(a,b,c,d){var e=0,f=0;e=Za-160|0;Za=e;Vb(e+8|0,58080,144);a:{b:{if(b-1>>>0>=2147483647){if(b){break b}b=1;a=e+159|0}j[e+52>>2]=a;j[e+28>>2]=a;f=-2-a|0;b=b>>>0>f>>>0?f:b;j[e+56>>2]=b;a=a+b|0;j[e+36>>2]=a;j[e+24>>2]=a;a=yE(e+8|0,c,d,2297,2298);if(!b){break a}b=j[e+28>>2];h[b-((b|0)==j[e+24>>2])|0]=0;break a}j[114604]=61;a=-1}Za=e+160|0;return a}function Dxa(a,b){var c=0,d=0;d=Za-32|0;Za=d;a:{b:{if((j[hb(a)>>2]-j[a+4>>2]|0)/12>>>0>=b>>>0){rxa(a,b);break b}c=hb(a);c=Zx(d+8|0,fm(a,ec(a)+b|0),ec(a),c);j[114630]=0;F(1014,c|0,b|0);b=j[114630];j[114630]=0;if((b|0)==1){break a}j[114630]=0;F(1015,a|0,c|0);a=j[114630];j[114630]=0;if((a|0)==1){break a}$M(c)}Za=d+32|0;return}a=D()|0;C()|0;$M(c);G(a|0);z()}function THa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0;d=Za-16|0;Za=d;a=lp(a);e=d,f=Lb(b),j[e+8>>2]=f;e=d,f=Mb(b),j[e>>2]=f;a:{if(rb(d+8|0,d)){while(1){b=j[d+8>>2];if((ok(b)|0)==(c|0)){b=hb(b);j[114630]=0;F(601,a|0,b|0);b=j[114630];j[114630]=0;if((b|0)==1){break a}}gk(d+8|0);if(rb(d+8|0,d)){continue}break}}Za=d+16|0;return}b=D()|0;C()|0;Sc(a);G(b|0);z()}function tS(a){var b=0,c=0,d=0,e=0,f=0;b=a+9|0;d=k[b|0]|k[b+1|0]<<8;c=HMa(k[a+3|0],0,18,0);d=d+c|0;b=ab;b=c>>>0>d>>>0?b+1|0:b;c=d;d=b;f=c;b=a+6|0;c=k[b|0]|k[b+1|0]<<8;b=c>>>31|0;e=c<<1;c=f+e|0;b=b+d|0;b=c>>>0<e>>>0?b+1|0:b;d=b;a=a+4|0;a=k[a|0]|k[a+1|0]<<8;b=a>>>30|0;e=a<<2;c=e+c|0;a=b+d|0;a=c>>>0<e>>>0?a+1|0:a;b=c+3|0;if(b>>>0<3){a=a+1|0}ab=a;return b}function rha(a,b){var c=0,d=0;d=Za-32|0;Za=d;a:{b:{if(j[hb(a)>>2]-j[a+4>>2]>>11>>>0>=b>>>0){nha(a,b);break b}c=hb(a);c=PH(d+8|0,mha(a,Te(a)+b|0),Te(a),c);j[114630]=0;F(1643,c|0,b|0);b=j[114630];j[114630]=0;if((b|0)==1){break a}j[114630]=0;F(1639,a|0,c|0);a=j[114630];j[114630]=0;if((a|0)==1){break a}wr(c)}Za=d+32|0;return}a=D()|0;C()|0;wr(c);G(a|0);z()}function raa(a){a=a|0;var b=0,c=0,d=0,e=0;b=Za-32|0;Za=b;a=Ng(a);j[114630]=0;F(2150,b+16|0,0);c=j[114630];j[114630]=0;a:{b:{if((c|0)!=1){c=Lb(b+16|0);d=Mb(b+16|0);e=j[yc(b+8|0,a)>>2];j[114630]=0;K(2151,c|0,d|0,e|0)|0;c=j[114630];j[114630]=0;if((c|0)==1){break b}Nw(b+16|0);Za=b+32|0;return}c=D()|0;C()|0;break a}c=D()|0;C()|0;Nw(b+16|0)}Vc(a);G(c|0);z()}function kGa(a,b){var c=0,d=0;d=Za-32|0;Za=d;a:{b:{if((j[hb(a)>>2]-j[a+4>>2]|0)/48>>>0>=b>>>0){_Ea(a,b);break b}c=hb(a);c=iR(d+8|0,jR(a,li(a)+b|0),li(a),c);j[114630]=0;F(697,c|0,b|0);b=j[114630];j[114630]=0;if((b|0)==1){break a}j[114630]=0;F(558,a|0,c|0);a=j[114630];j[114630]=0;if((a|0)==1){break a}at(c)}Za=d+32|0;return}a=D()|0;C()|0;at(c);G(a|0);z()}function fGa(a,b,c){var d=0,e=0;e=Za-32|0;Za=e;a:{b:{if(j[hb(a)>>2]-j[a+4>>2]>>>0>=b>>>0){dt(a,b,c);break b}d=hb(a);d=wl(e+8|0,ul(a,tc(a)+b|0),tc(a),d);j[114630]=0;I(701,d|0,b|0,c|0);b=j[114630];j[114630]=0;if((b|0)==1){break a}j[114630]=0;F(364,a|0,d|0);a=j[114630];j[114630]=0;if((a|0)==1){break a}Lp(d)}Za=e+32|0;return}a=D()|0;C()|0;Lp(d);G(a|0);z()}function WP(a){var b=0,c=0,d=0,e=0,f=0,g=0;a:{b=j[a>>2];b:{if(!b){break b}c=j[a+8>>2];if(!c){break b}a=j[a+12>>2];if(!a){break b}e=bb[a|0](b)|0;d=ab;f=d;if((d|0)<0){break b}if((bb[c|0](b,0,0,0)|0)<=-1){break a}if((bb[c|0](b,0,0,2)|0)<=-1){break a}d=bb[a|0](b)|0;a=ab;bb[c|0](b,e,f,0)|0;if((a|0)<0){break b}g=JQ(d,a)}return g}bb[c|0](b,e,f,0)|0;return 0}function Tda(a,b,c,d,e,f,g,h,i,k,l,m){j[114630]=0;a=EB(2e3,a,b,c,d,e,f);b=j[114630];j[114630]=0;a:{if((b|0)==1){a=J(0)|0;C()|0;O(a|0)|0;j[114630]=0;Z(1995,34615,g|0,h|0,i|0,k|0,l|0,m|0);a=j[114630];j[114630]=0;if((a|0)==1){break a}Q();a=-255}return a}a=D()|0;C()|0;j[114630]=0;M(20);b=j[114630];j[114630]=0;if((b|0)!=1){G(a|0);z()}J(0)|0;C()|0;ib();z()}function Dw(a,b,c,d){var e=0,f=0;a:{e=k[a|0];f=k[c|0];b:{if(!(k[d|0]|((e|0)!=11|(f-5&255)>>>0>1))){h[a|0]=(f|0)==5?7:6;break b}if((f|0)==11){if(k[b|0]|(e-5&255)>>>0>1){break a}h[a|0]=(e|0)==5?7:6;h[b|0]=k[d|0];break b}if(!((e|0)!=10|(f|0)!=20|k[d|0]!=159)){h[a|0]=39;break b}if((f|0)!=10|(e|0)!=20|k[b|0]!=159){break a}h[a|0]=39;h[b|0]=k[d|0]}h[c|0]=0}}function qha(a,b){var c=0,d=0;d=Za-32|0;Za=d;a:{b:{if(j[hb(a)>>2]-j[a+4>>2]>>2>>>0>=b>>>0){dha(a,b);break b}c=hb(a);c=NH(d+8|0,ie(a,sb(a)+b|0),sb(a),c);j[114630]=0;F(1644,c|0,b|0);b=j[114630];j[114630]=0;if((b|0)==1){break a}j[114630]=0;F(1641,a|0,c|0);a=j[114630];j[114630]=0;if((a|0)==1){break a}vr(c)}Za=d+32|0;return}a=D()|0;C()|0;vr(c);G(a|0);z()}function hAa(a,b){var c=0,d=0;d=Za-32|0;Za=d;a:{b:{if(j[hb(a)>>2]-j[a+4>>2]>>3>>>0>=b>>>0){gAa(a,b);break b}c=hb(a);c=eAa(d+8|0,fAa(a,fg(a)+b|0),fg(a),c);j[114630]=0;F(920,c|0,b|0);b=j[114630];j[114630]=0;if((b|0)==1){break a}j[114630]=0;F(921,a|0,c|0);a=j[114630];j[114630]=0;if((a|0)==1){break a}hO(c)}Za=d+32|0;return}a=D()|0;C()|0;hO(c);G(a|0);z()}function Zia(a,b){var c=0,d=0;d=Za-32|0;Za=d;a:{b:{if(j[hb(a)>>2]-j[a+4>>2]>>2>>>0>=b>>>0){sia(a,b);break b}c=hb(a);c=uw(d+8|0,ie(a,sb(a)+b|0),sb(a),c);j[114630]=0;F(1593,c|0,b|0);b=j[114630];j[114630]=0;if((b|0)==1){break a}j[114630]=0;F(1592,a|0,c|0);a=j[114630];j[114630]=0;if((a|0)==1){break a}wm(c)}Za=d+32|0;return}a=D()|0;C()|0;wm(c);G(a|0);z()}function tLa(a,b){var c=0,d=0;d=Za-32|0;Za=d;a:{b:{if(j[hb(a)>>2]-j[a+4>>2]>>1>>>0>=b>>>0){sLa(a,b);break b}c=hb(a);c=rLa(d+8|0,ui(a,Yb(a)+b|0),Yb(a),c);j[114630]=0;F(423,c|0,b|0);b=j[114630];j[114630]=0;if((b|0)==1){break a}j[114630]=0;F(424,a|0,c|0);a=j[114630];j[114630]=0;if((a|0)==1){break a}BS(c)}Za=d+32|0;return}a=D()|0;C()|0;BS(c);G(a|0);z()}function nta(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0;d=Za-32|0;Za=d;j[d+16>>2]=b;e=d,f=ry(a,b,c),j[e+24>>2]=f;a:{if(!rb(d+24|0,d+16|0)){break a}j[d+8>>2]=j[d+24>>2];if(!rb(je(d+8|0),d+16|0)){break a}while(1){if(l[j[d+8>>2]>>1]!=l[c>>1]){i[j[d+24>>2]>>1]=l[j[d+8>>2]>>1];je(d+24|0)}if(rb(je(d+8|0),d+16|0)){continue}break}}Za=d+32|0;return j[d+24>>2]}function iN(a){var b=0,c=0;a:{if(k[a+29|0]!=2){break a}b=k[a+28|0];if(k[a+30|0]!=2|((b|0)!=2?(b|0)!=26:0)){break a}b=k[a+31|0];if(b>>>0>21|!(1<<b&3146753)|k[a+33|0]>64){break a}b=k[a+34|0];if((b|0)!=88?b>>>0>=65:0){break a}b=a+28|0;a=a+20|0;while(1){c=k[a|0]-32|0;if((c&255)>>>0<=94){a=a+1|0;if((b|0)!=(a|0)){continue}}break}c=(c&255)>>>0<95}return c}function eFa(a,b){var c=0,d=0;d=Za-32|0;Za=d;a:{b:{if(j[hb(a)>>2]-j[a+4>>2]>>2>>>0>=b>>>0){cFa(a,b);break b}c=hb(a);c=bFa(d+8|0,ie(a,sb(a)+b|0),sb(a),c);j[114630]=0;F(738,c|0,b|0);b=j[114630];j[114630]=0;if((b|0)==1){break a}j[114630]=0;F(739,a|0,c|0);a=j[114630];j[114630]=0;if((a|0)==1){break a}aQ(c)}Za=d+32|0;return}a=D()|0;C()|0;aQ(c);G(a|0);z()}function bqa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0;e=Za-16|0;Za=e;j[e+12>>2]=c>>>2;j[e+8>>2]=j[a>>2];f=j[tb(e+12|0,e+8|0)>>2];b=lb(b);if(f){a=j[a+20>>2];c=f;g=d;while(1){g=(lb(k[b|0])+g|0)+(lb(k[b+1|0])<<8)|0;i[a>>1]=g;d=(lb(k[b+2|0])+d|0)+(lb(k[b+3|0])<<8)|0;i[a+2>>1]=d;a=a+4|0;b=b+4|0;c=c-1|0;if(c){continue}break}}Za=e+16|0;return f<<2}function _pa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0;e=Za-16|0;Za=e;j[e+12>>2]=c>>>2;j[e+8>>2]=j[a>>2];f=j[tb(e+12|0,e+8|0)>>2];b=lb(b);if(f){a=j[a+20>>2];c=f;g=d;while(1){g=(lb(k[b+1|0])+g|0)+(lb(k[b|0])<<8)|0;i[a>>1]=g;d=(lb(k[b+3|0])+d|0)+(lb(k[b+2|0])<<8)|0;i[a+2>>1]=d;a=a+4|0;b=b+4|0;c=c-1|0;if(c){continue}break}}Za=e+16|0;return f<<2}function Una(a,b){var c=0,d=0,e=0,f=0,g=0,h=0;c=Za-192|0;Za=c;Vb(c+144|0,b,44);d=j[b+44>>2];if(d){Vb(c+44|0,b,44);g=c,h=h7(c+44|0),j[g+96>>2]=h;j[c+100>>2]=ab;b=j[c+100>>2];f=j[c+96>>2];e=Lqa(zd(+(d>>>0)*.054945054945054944));d=f+e|0;b=ab+b|0;R6(c+96|0,AF(c+88|0,d,d>>>0<e>>>0?b+1|0:b));Vb(c+144|0,c+96|0,44)}b=a;a=Vb(c,c+144|0,44);A6(b,a);Za=a+192|0}function LCa(a,b){var c=0,d=0;d=Za-32|0;Za=d;a:{b:{if(j[hb(a)>>2]-j[a+4>>2]>>2>>>0>=b>>>0){KCa(a,b);break b}c=hb(a);c=JCa(d+8|0,ie(a,sb(a)+b|0),sb(a),c);j[114630]=0;F(818,c|0,b|0);b=j[114630];j[114630]=0;if((b|0)==1){break a}j[114630]=0;F(819,a|0,c|0);a=j[114630];j[114630]=0;if((a|0)==1){break a}iP(c)}Za=d+32|0;return}a=D()|0;C()|0;iP(c);G(a|0);z()}function Hda(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;j[114630]=0;N(2010,a|0);d=j[114630];j[114630]=0;if((d|0)!=1){j[a+4>>2]=c;j[a>>2]=b?b:1992;return}b=J(0)|0;C()|0;O(b|0)|0;j[114630]=0;L(1984,34803,a|0,0,0);a=j[114630];j[114630]=0;if((a|0)!=1){Q();return}a=D()|0;C()|0;j[114630]=0;M(20);b=j[114630];j[114630]=0;if((b|0)!=1){G(a|0);z()}J(0)|0;C()|0;ib();z()}function CCa(a,b){var c=0,d=0;d=Za-32|0;Za=d;a:{b:{if(j[hb(a)>>2]-j[a+4>>2]>>1>>>0>=b>>>0){BCa(a,b);break b}c=hb(a);c=ACa(d+8|0,ui(a,Yb(a)+b|0),Yb(a),c);j[114630]=0;F(825,c|0,b|0);b=j[114630];j[114630]=0;if((b|0)==1){break a}j[114630]=0;F(826,a|0,c|0);a=j[114630];j[114630]=0;if((a|0)==1){break a}dP(c)}Za=d+32|0;return}a=D()|0;C()|0;dP(c);G(a|0);z()}function zga(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0;d=Za-16|0;Za=d;a:{if(!(k[c+1|0]&4)){break a}c=j[c+4>>2];g=d,h=nd(b),j[g+8>>2]=h;b:{if(!nb(b)){break b}if(k[Ub(b,0)|0]==43){Xf(d+8|0);c=c+1|0;break b}if(k[Ub(b,0)|0]!=45){break b}Xf(d+8|0);c=c+1|0}if(nb(b)>>>0>=c>>>0){break a}e=Cd(d,d+8|0);f=nb(b);Wv(b,j[e>>2],c-f|0,48)}Mc(a,b);Za=d+16|0}function xza(a,b){var c=0,d=0;d=Za-32|0;Za=d;a:{b:{if(j[hb(a)>>2]-j[a+4>>2]>>2>>>0>=b>>>0){WN(a,b);break b}c=hb(a);c=wza(d+8|0,ie(a,sb(a)+b|0),sb(a),c);j[114630]=0;F(946,c|0,b|0);b=j[114630];j[114630]=0;if((b|0)==1){break a}j[114630]=0;F(947,a|0,c|0);a=j[114630];j[114630]=0;if((a|0)==1){break a}PN(c)}Za=d+32|0;return}a=D()|0;C()|0;PN(c);G(a|0);z()}function w_(a,b){var c=0,d=0;d=Za-32|0;Za=d;a:{b:{if(j[nq(a)>>2]-j[a+4>>2]>>2>>>0>=b>>>0){AC(a,b);break b}c=Ek(a);c=DY(d+8|0,EY(a,sb(a)+b|0),sb(a),c);j[114630]=0;F(2563,c|0,b|0);b=j[114630];j[114630]=0;if((b|0)==1){break a}j[114630]=0;F(2564,a|0,c|0);a=j[114630];j[114630]=0;if((a|0)==1){break a}XB(c)}Za=d+32|0;return}a=D()|0;C()|0;XB(c);G(a|0);z()}function r4(){var a=0;j[114630]=0;H(2311,460776)|0;a=j[114630];j[114630]=0;a:{if((a|0)==1){break a}j[114630]=0;H(2312,460860)|0;a=j[114630];j[114630]=0;if((a|0)==1){break a}j[114630]=0;H(2311,461112)|0;a=j[114630];j[114630]=0;if((a|0)==1){break a}j[114630]=0;H(2312,461196)|0;a=j[114630];j[114630]=0;if((a|0)==1){break a}return}J(0)|0;C()|0;ib();z()}function jAa(a){var b=0;b=Za-16|0;Za=b;h[a|0]=0;h[a+1|0]=0;h[a+2|0]=0;h[a+3|0]=0;h[a+4|0]=0;h[a+5|0]=0;h[a+6|0]=0;h[a+7|0]=0;h[a+24|0]=0;h[a+25|0]=0;h[a+16|0]=0;h[a+17|0]=0;h[a+18|0]=0;h[a+19|0]=0;h[a+20|0]=0;h[a+21|0]=0;h[a+22|0]=0;h[a+23|0]=0;h[a+8|0]=0;h[a+9|0]=0;h[a+10|0]=0;h[a+11|0]=0;h[a+12|0]=0;h[a+13|0]=0;h[a+14|0]=0;h[a+15|0]=0;Za=b+16|0}function gN(a){var b=0;a:{if((k[a|0]|k[a+1|0]<<8|(k[a+2|0]<<16|k[a+3|0]<<24))!=860902483){break a}b=a+4|0;b=k[b|0]|k[b+1|0]<<8;if(((b<<8|b>>>8)&65535)>>>0>2|k[a+6|0]>128){break a}b=a+200|0;b=k[b|0]|k[b+1|0]<<8;if(((b<<8|b>>>8)&65535)>>>0>3999){break a}b=a+140|0;if(!(k[b|0]|k[b+1|0]<<8)){break a}a=a+148|0;return(k[a|0]|k[a+1|0]<<8)==12800}return 0}function eY(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0;f=Za-16|0;Za=f;j[f+8>>2]=e;j[f+12>>2]=c;c=nb(a);if(!((e|0)==-1|c>>>0<b>>>0)){j[f>>2]=c-b;g=f,h=j[tb(f+12|0,f)>>2],j[g+4>>2]=h;b=Cm(zb(a)+b|0,d,j[tb(f+4|0,f+8|0)>>2]);a:{if(b){break a}b=-1;a=j[f+4>>2];c=j[f+8>>2];if(a>>>0<c>>>0){break a}b=a>>>0>c>>>0}Za=f+16|0;return b|0}Sl();z()}function dEa(a,b){var c=0,d=0;d=Za-32|0;Za=d;a:{b:{if(j[hb(a)>>2]-j[a+4>>2]>>4>>>0>=b>>>0){SS(a,b);break b}c=hb(a);c=ZQ(d+8|0,gq(a,Zc(a)+b|0),Zc(a),c);j[114630]=0;F(760,c|0,b|0);b=j[114630];j[114630]=0;if((b|0)==1){break a}j[114630]=0;F(609,a|0,c|0);a=j[114630];j[114630]=0;if((a|0)==1){break a}Ys(c)}Za=d+32|0;return}a=D()|0;C()|0;Ys(c);G(a|0);z()}function RLa(a,b){var c=0,d=0;d=Za-32|0;Za=d;a:{b:{if(j[hb(a)>>2]-j[a+4>>2]>>1>>>0>=b>>>0){GS(a,b);break b}c=hb(a);c=yt(d+8|0,ui(a,Yb(a)+b|0),Yb(a),c);j[114630]=0;F(410,c|0,b|0);b=j[114630];j[114630]=0;if((b|0)==1){break a}j[114630]=0;F(380,a|0,c|0);a=j[114630];j[114630]=0;if((a|0)==1){break a}mk(c)}Za=d+32|0;return}a=D()|0;C()|0;mk(c);G(a|0);z()}function Oqa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0;e=Za-16|0;Za=e;a:{c=yl(e,a+8|0,xx(b,c));if(j[c>>2]!=j[c+4>>2]){while(1){d=j[a+16>>2];f=j[c>>2];j[114630]=0;I(1244,d|0,f|0,b|0);d=j[114630];j[114630]=0;if((d|0)==1){break a}d=j[c>>2]+2|0;j[c>>2]=d;b=b+2|0;if((d|0)!=j[c+4>>2]){continue}break}}cc(c);Za=e+16|0;return}a=D()|0;C()|0;cc(c);G(a|0);z()}function Lka(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0;d=Za-48|0;Za=d;a:{b:{e=CN(b,c);if((e|0)!=-1){f=d,g=nd(b),j[f+16>>2]=g;f=d,g=af(d+16|0,e),j[f+24>>2]=g;f=d,g=af(d+24|0,1),j[f+32>>2]=g;c=Cd(d+40|0,d+32|0);f=d,g=_e(b),j[f>>2]=g;e=Cd(d+8|0,d);Ex(b,j[c>>2],j[e>>2]);break b}if(!nb(b)){break b}if(hL(b,c)){break b}Cb(a);break a}Mc(a,b)}Za=d+48|0}function Dha(a,b){a=a|0;b=b|0;var c=0;a:{b:{if((tc(j[a+20>>2]+4|0)|0)!=8){break b}c=j[j[a+20>>2]+4>>2];if((k[c|0]|k[c+1|0]<<8|(k[c+2|0]<<16|k[c+3|0]<<24))!=1869112133){break b}b=j[j[a+20>>2]+4>>2];c=k[b|0]|k[b+1|0]<<8|(k[b+2|0]<<16|k[b+3|0]<<24);b=k[b+4|0]|k[b+5|0]<<8|(k[b+6|0]<<16|k[b+7|0]<<24);j[a+4260>>2]=c;j[a+4264>>2]=b;break a}wH(a,b)}xr(a)}function BMa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0;d=Za-48|0;Za=d;a:{b:{e=CN(b,c);if((e|0)!=-1){f=d,g=nd(b),j[f+16>>2]=g;f=d,g=af(d+16|0,e),j[f+24>>2]=g;f=d,g=af(d+24|0,1),j[f+32>>2]=g;c=Cd(d+40|0,d+32|0);f=d,g=_e(b),j[f>>2]=g;e=Cd(d+8|0,d);Ex(b,j[c>>2],j[e>>2]);break b}if(!nb(b)){break b}if(hL(b,c)){break b}Qc(a);break a}Mc(a,b)}Za=d+48|0}function RT(a,b){var c=0,d=0;d=Za-32|0;Za=d;a:{b:{if(j[hb(a)>>2]-j[a+4>>2]>>2>>>0>=b>>>0){ET(a,b);break b}c=hb(a);c=wn(d+8|0,ie(a,sb(a)+b|0),sb(a),c);j[114630]=0;F(367,c|0,b|0);b=j[114630];j[114630]=0;if((b|0)==1){break a}j[114630]=0;F(368,a|0,c|0);a=j[114630];j[114630]=0;if((a|0)==1){break a}xh(c)}Za=d+32|0;return}a=D()|0;C()|0;xh(c);G(a|0);z()}function Do(a,b,c,d){a:{if(j[a+480180>>2]==4){d=k[b+830|0];if(c){h[b+830|0]=d&240|c;break a}c=d&15;break a}if(d){if(c){h[b+854|0]=c;break a}c=k[b+854|0];break a}if(c){h[b+830|0]=c;break a}c=k[b+830|0]}b:{if(!(h[b+872|0]&1)){break b}c=j[b+688>>2]-((c&255)<<2)|0;j[b+688>>2]=(c|0)>0?c:0;if(!(j[a+480180>>2]&1)){break b}j[b+88>>2]=j[b+88>>2]|2097152}}function Bh(a,b){a:{if((b|0)>=1024){a=a*8.98846567431158e+307;if((b|0)<2047){b=b-1023|0;break a}a=a*8.98846567431158e+307;b=((b|0)<3069?b:3069)-2046|0;break a}if((b|0)>-1023){break a}a=a*2.2250738585072014e-308;if((b|0)>-2045){b=b+1022|0;break a}a=a*2.2250738585072014e-308;b=((b|0)>-3066?b:-3066)+2044|0}PMa(0,0);PMa(1,b+1023<<20);return a*+QMa()}function AY(a,b){var c=0,d=0;d=Za-32|0;Za=d;a:{b:{if(j[hb(a)>>2]-j[a+4>>2]>>4>>>0>=b>>>0){TW(a,b);break b}c=hb(a);c=SW(d+8|0,gq(a,Zc(a)+b|0),Zc(a),c);j[114630]=0;F(211,c|0,b|0);b=j[114630];j[114630]=0;if((b|0)==1){break a}j[114630]=0;F(212,a|0,c|0);a=j[114630];j[114630]=0;if((a|0)==1){break a}BB(c)}Za=d+32|0;return}a=D()|0;C()|0;BB(c);G(a|0);z()}function zl(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;d=Za-16|0;Za=d;h[d+15|0]=b;a:{b:{c:{d:{if(qe(a)){c=Mj(a)-1|0;e=j[a+4>>2];if((c|0)==(e|0)){break d}break b}e=10;c=10;b=k[a+11|0];if((b|0)!=10){break c}}xl(a,c,1,c,c,0,0);b=e;if(qe(a)){break b}}c=a;Ue(a,b+1|0);break a}c=j[a>>2];ee(a,e+1|0);b=e}a=b+c|0;Sd(a,d+15|0);h[d+14|0]=0;Sd(a+1|0,d+14|0);Za=d+16|0}function dqa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0;d=Za-16|0;Za=d;j[d+12>>2]=c>>>2;j[d+8>>2]=j[a>>2];e=j[tb(d+12|0,d+8|0)>>2];b=lb(b);if(e){a=j[a+20>>2];c=e;while(1){f=a,g=(lb(k[b|0])|lb(k[b+1|0])<<8)^32768,i[f>>1]=g;f=a,g=(lb(k[b+2|0])|lb(k[b+3|0])<<8)^32768,i[f+2>>1]=g;a=a+4|0;b=b+4|0;c=c-1|0;if(c){continue}break}}Za=d+16|0;return e<<2}function Q5(a,b,c,d,e){var f=0,g=0,h=0,i=q(0),j=0,l=0,m=0;if((d|0)>=1){while(1){f=k[b|0];g=0;a:{if(!f){break a}g=19>>>k[c+h|0]&3|4}b=b+1|0;m=p(f,3)-6|0;f=4;i=q(0);while(1){if(f&g){j=Bd(a,6);l=(j|0)/3|0;i=q(n[((j-p(l,3)|0)+m<<2)+50240>>2]*q(2097152>>>l|0))}n[e>>2]=i;e=e+4|0;f=f>>>1|0;if(f){continue}break}h=h+1|0;if((h|0)!=(d|0)){continue}break}}}function $pa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0;d=Za-16|0;Za=d;j[d+12>>2]=c>>>2;j[d+8>>2]=j[a>>2];e=j[tb(d+12|0,d+8|0)>>2];b=lb(b);if(e){a=j[a+20>>2];c=e;while(1){f=a,g=(lb(k[b+1|0])|lb(k[b|0])<<8)^32768,i[f>>1]=g;f=a,g=(lb(k[b+3|0])|lb(k[b+2|0])<<8)^32768,i[f+2>>1]=g;a=a+4|0;b=b+4|0;c=c-1|0;if(c){continue}break}}Za=d+16|0;return e<<2}function uMa(a,b){if(!pMa(a,b)){a=Za-16|0;Za=a;h[b|0]=0;h[b+1|0]=0;h[b+2|0]=0;h[b+3|0]=0;h[b+4|0]=0;h[b+5|0]=0;h[b+6|0]=0;h[b+7|0]=0;h[b+24|0]=0;h[b+16|0]=0;h[b+17|0]=0;h[b+18|0]=0;h[b+19|0]=0;h[b+20|0]=0;h[b+21|0]=0;h[b+22|0]=0;h[b+23|0]=0;h[b+8|0]=0;h[b+9|0]=0;h[b+10|0]=0;h[b+11|0]=0;h[b+12|0]=0;h[b+13|0]=0;h[b+14|0]=0;h[b+15|0]=0;Za=a+16|0}}function foa(a,b,c,d){var e=0,f=0,g=0,i=0,k=0;e=Za-16|0;Za=e;b=Rb(b);a=eoa(a,ac(20,4),ak(e+8|0,b));f=j[a>>2];j[114630]=0;f=H(1376,f+14|0)|0;g=j[114630];j[114630]=0;a:{if((g|0)==1){break a}j[114630]=0;V(1379,b|0,f|0,20485,c|0,d|0);b=j[114630];j[114630]=0;if((b|0)==1){break a}i=Rb(a),k=1,h[i+4|0]=k;Za=e+16|0;return}b=D()|0;C()|0;cK(a);G(b|0);z()}function Lba(a,b,c,d){var e=0,f=0,g=0,i=0,k=0;e=Za-16|0;Za=e;b=Rb(b);a=Fqa(a,ac(40,4),ak(e+8|0,b));f=j[a>>2];j[114630]=0;f=H(1251,f+16|0)|0;g=j[114630];j[114630]=0;a:{if((g|0)==1){break a}j[114630]=0;V(2103,b|0,f|0,38127,c|0,d|0);b=j[114630];j[114630]=0;if((b|0)==1){break a}i=Rb(a),k=1,h[i+4|0]=k;Za=e+16|0;return}b=D()|0;C()|0;dL(a);G(b|0);z()}function rY(a,b){var c=0,d=0;d=Za-32|0;Za=d;a:{b:{if(j[hb(a)>>2]-j[a+4>>2]>>>0>=b>>>0){NW(a,b);break b}c=hb(a);c=wl(d+8|0,ul(a,tc(a)+b|0),tc(a),c);j[114630]=0;F(213,c|0,b|0);b=j[114630];j[114630]=0;if((b|0)==1){break a}j[114630]=0;F(209,a|0,c|0);a=j[114630];j[114630]=0;if((a|0)==1){break a}Xl(c)}Za=d+32|0;return}a=D()|0;C()|0;Xl(c);G(a|0);z()}function oia(a,b,c,d){var e=0,f=0,g=0,i=0,k=0;e=Za-16|0;Za=e;b=Rb(b);a=mia(a,ac(32,4),ak(e+8|0,b));f=j[a>>2];j[114630]=0;f=H(732,f+16|0)|0;g=j[114630];j[114630]=0;a:{if((g|0)==1){break a}j[114630]=0;V(1617,b|0,f|0,32530,c|0,d|0);b=j[114630];j[114630]=0;if((b|0)==1){break a}i=Rb(a),k=1,h[i+4|0]=k;Za=e+16|0;return}b=D()|0;C()|0;eI(a);G(b|0);z()}function fJ(a,b){var c=0,d=0,e=0,f=0;if(b){Pra(a+327720|0);Mw(a+131112|0,9.6377,.97);Mw(a+196648|0,8.5,.5);Mw(a+262184|0,2.7625,.425)}c=a+368680|0;if(!(d=0,e=eJ(c,a),f=b,f?d:e)){dla(a+24|0,o[a+8>>3],k[a+16|0]);b=j[a+20>>2];j[c+16>>2]=j[a+16>>2];j[c+20>>2]=b;b=j[a+12>>2];j[c+8>>2]=j[a+8>>2];j[c+12>>2]=b;b=j[a+4>>2];j[c>>2]=j[a>>2];j[c+4>>2]=b}}function XT(a,b){var c=0,d=0;d=Za-32|0;Za=d;a:{b:{if(j[hb(a)>>2]-j[a+4>>2]>>>0>=b>>>0){rA(a,b);break b}c=hb(a);c=wl(d+8|0,ul(a,tc(a)+b|0),tc(a),c);j[114630]=0;F(363,c|0,b|0);b=j[114630];j[114630]=0;if((b|0)==1){break a}j[114630]=0;F(364,a|0,c|0);a=j[114630];j[114630]=0;if((a|0)==1){break a}Lp(c)}Za=d+32|0;return}a=D()|0;C()|0;Lp(c);G(a|0);z()}function OB(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;d=Za-16|0;Za=d;j[d+12>>2]=b;a:{b:{c:{d:{if(qe(a)){c=Mj(a)-1|0;e=j[a+4>>2];if((c|0)==(e|0)){break d}break b}e=1;c=1;b=k[a+11|0];if((b|0)!=1){break c}}PB(a,c,1,c,c);b=e;if(qe(a)){break b}}c=a;Ue(a,b+1|0);break a}c=j[a>>2];ee(a,e+1|0);b=e}a=(b<<2)+c|0;ye(a,d+12|0);j[d+8>>2]=0;ye(a+4|0,d+8|0);Za=d+16|0}function wFa(a,b,c,d){var e=0,f=0,g=0,i=0,k=0;e=Za-16|0;Za=e;b=Rb(b);a=uFa(a,ac(32,4),ak(e+8|0,b));f=j[a>>2];j[114630]=0;f=H(728,f+16|0)|0;g=j[114630];j[114630]=0;a:{if((g|0)==1){break a}j[114630]=0;V(729,b|0,f|0,14646,c|0,d|0);b=j[114630];j[114630]=0;if((b|0)==1){break a}i=Rb(a),k=1,h[i+4|0]=k;Za=e+16|0;return}b=D()|0;C()|0;lQ(a);G(b|0);z()}function vCa(a,b,c,d){var e=0,f=0,g=0,i=0,k=0;e=Za-16|0;Za=e;b=Rb(b);a=uCa(a,ac(20,4),ak(e+8|0,b));f=j[a>>2];j[114630]=0;f=H(822,f+14|0)|0;g=j[114630];j[114630]=0;a:{if((g|0)==1){break a}j[114630]=0;V(828,b|0,f|0,15166,c|0,d|0);b=j[114630];j[114630]=0;if((b|0)==1){break a}i=Rb(a),k=1,h[i+4|0]=k;Za=e+16|0;return}b=D()|0;C()|0;cP(a);G(b|0);z()}function fO(a){var b=0,c=0,d=0,e=0,f=0;b=a+28|0;e=k[b|0]|k[b+1|0]<<8;b=HMa(k[a+30|0],0,37,0);c=ab;d=b;b=a+24|0;b=HMa(k[b|0]|k[b+1|0]<<8,0,192,0);d=d+b|0;c=ab+c|0;c=b>>>0>d>>>0?c+1|0:c;b=c;f=e;e=d;a=k[a+26|0];c=a>>>26|0;d=a<<6;e=e+d|0;a=b+c|0;a=d>>>0>e>>>0?a+1|0:a;b=e;c=f+b|0;a=b>>>0>c>>>0?a+1|0:a;b=c+192|0;if(b>>>0<192){a=a+1|0}ab=a;return b}function QIa(a,b,c){var d=0,e=0,f=0,g=0;e=Za-32|0;Za=e;f=hb(a);d=oIa(e+8|0,hk(a,pd(a)+1|0),pd(a),f);g=j[d+8>>2];j[114630]=0;L(559,f|0,g|0,b|0,c|0);b=j[114630];j[114630]=0;a:{if((b|0)==1){break a}j[d+8>>2]=j[d+8>>2]+24;j[114630]=0;F(560,a|0,d|0);a=j[114630];j[114630]=0;if((a|0)==1){break a}fR(d);Za=e+32|0;return}a=D()|0;C()|0;fR(d);G(a|0);z()}function OIa(a,b){var c=0,d=0;d=Za-32|0;Za=d;a:{b:{if(j[hb(a)>>2]-j[a+4>>2]>>>0>=b>>>0){FR(a,b);break b}c=hb(a);c=wl(d+8|0,ul(a,tc(a)+b|0),tc(a),c);j[114630]=0;F(41,c|0,b|0);b=j[114630];j[114630]=0;if((b|0)==1){break a}j[114630]=0;F(40,a|0,c|0);a=j[114630];j[114630]=0;if((a|0)==1){break a}At(c)}Za=d+32|0;return}a=D()|0;C()|0;At(c);G(a|0);z()}function le(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0;a:{if(!nb(a)|(c-b|0)<5){break a}Sn(b,c);e=c-4|0;c=zb(a);f=c+nb(a)|0;while(1){b:{a=h[c|0];if(b>>>0>=e>>>0){break b}if((a|0)<1|(a|0)>=127|j[b>>2]==h[c|0]){c=(f-c|0)>1?c+1|0:c;b=b+4|0;continue}else{j[d>>2]=4;return}}break}if((a|0)<1|(a|0)>=127|h[c|0]>>>0>j[e>>2]-1>>>0){break a}j[d>>2]=4}}function baa(a){var b=0,c=0;b=Za-16|0;Za=b;a:{b:{c:{if(a>>>0>=6){c=R(8)|0;j[114630]=0;b=E(85,b|0,39840)|0;a=j[114630];j[114630]=0;if((a|0)==1){break c}Wb(c,b);j[114630]=0;I(2004,c|0,83648,2012);a=j[114630];j[114630]=0;if((a|0)!=1){break a}a=D()|0;C()|0;gb(b);break b}Za=b+16|0;return j[(a<<24>>24<<2)+40544>>2]}a=D()|0;C()|0;S(c|0)}G(a|0)}z()}function Zna(a,b,c,d){var e=0,f=0,g=0,i=0,k=0;e=Za-16|0;Za=e;b=Rb(b);a=Yna(a,dK(1),ak(e+8|0,b));f=j[a>>2];j[114630]=0;f=H(1381,f+16|0)|0;g=j[114630];j[114630]=0;a:{if((g|0)==1){break a}j[114630]=0;V(1383,b|0,f|0,20485,c|0,d|0);b=j[114630];j[114630]=0;if((b|0)==1){break a}i=Rb(a),k=1,h[i+4|0]=k;Za=e+16|0;return}b=D()|0;C()|0;aK(a);G(b|0);z()}function DX(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=Za+ -64|0;Za=d;e=1;a:{if(Qf(a,b,0)){break a}e=0;if(!b){break a}b=yu(b,71944,71992);e=0;if(!b){break a}Ab(d+8|4,0,52);j[d+56>>2]=1;j[d+20>>2]=-1;j[d+16>>2]=a;j[d+8>>2]=b;bb[j[j[b>>2]+28>>2]](b,d+8|0,j[c>>2],1);a=j[d+32>>2];if((a|0)==1){j[c>>2]=j[d+24>>2]}e=(a|0)==1}a=e;Za=d- -64|0;return a|0}function rP(a,b,c,d){var e=0,f=0,g=0;e=Za-16|0;Za=e;j[e+12>>2]=a;f=+(p(a,d)>>>0)*2500;a:{if(!(!c|b)){break a}b:{if(!(!a|!b)){jc(e+12|0,10);a=k[j[e+12>>2]+15155|0];j[e+12>>2]=a;break b}if(a-1>>>0>9){break b}f=7338401.379310345/+(a>>>0);break a}f=+(a>>>0)*37878.78787878787}g=f;c:{if(f<4294967296&f>=0){a=~~g>>>0;break c}a=0}Za=e+16|0;return a}function N5(a,b,c,d){var e=0,f=0,g=0,h=0,i=0;j[d+8>>2]=-1;j[d>>2]=-1;j[d+4>>2]=-1;if((c|0)>=1){while(1){h=b+e|0;f=k[h|0];a:{if(!f){f=0;break a}g=0;while(1){i=g<<2;if(!(n[i+a>>2]!=q(0)|n[(i|4)+a>>2]!=q(0))){g=g+2|0;if(g>>>0<f>>>0){continue}break a}break}j[((e>>>0)%3<<2)+d>>2]=e;f=k[h|0]}a=(f<<2)+a|0;e=e+1|0;if((e|0)!=(c|0)){continue}break}}}function Ig(a,b,c,d,e){var f=0,g=0,h=0,i=0,k=0,l=0,m=0,n=0;h=e;e=0;i=e;f=c;c=0;e=HMa(h,e,f,c);k=ab;g=b;l=HMa(d,0,b,0);b=ab;d=HMa(d,m,f,c);c=b+d|0;b=ab;b=c>>>0<d>>>0?b+1|0:b;f=b;d=b+e|0;b=k;b=d>>>0<f>>>0?b+1|0:b;f=d;e=b;b=HMa(g,n,h,i)+c|0;d=ab;d=b>>>0<c>>>0?d+1|0:d;g=d;d=d+f|0;j[a+8>>2]=d;j[a+12>>2]=d>>>0<g>>>0?e+1|0:e;j[a>>2]=l;j[a+4>>2]=b}function wu(a,b,c,d){h[a+53|0]=1;a:{if(j[a+4>>2]!=(c|0)){break a}h[a+52|0]=1;c=j[a+16>>2];if(!c){j[a+36>>2]=1;j[a+24>>2]=d;j[a+16>>2]=b;if((d|0)!=1|j[a+48>>2]!=1){break a}h[a+54|0]=1;return}if((b|0)==(c|0)){c=j[a+24>>2];if((c|0)==2){j[a+24>>2]=d;c=d}if(j[a+48>>2]!=1|(c|0)!=1){break a}h[a+54|0]=1;return}h[a+54|0]=1;j[a+36>>2]=j[a+36>>2]+1}}function ica(a,b){a=a|0;b=b|0;var c=0;if(m[a+24>>2]>m[a+44>>2]){j[a+44>>2]=j[a+24>>2]}a:{if(m[a+8>>2]>=m[a+12>>2]){break a}if(ce(b,-1)){um(a,j[a+8>>2],j[a+12>>2]-1|0,j[a+44>>2]);return jr(b)|0}if(!(k[a+48|0]&16)){if(!ce(tm(b),h[j[a+12>>2]-1|0])){break a}}um(a,j[a+8>>2],j[a+12>>2]-1|0,j[a+44>>2]);c=tm(b);h[j[a+12>>2]]=c;return b|0}return-1}function gz(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,m=0,n=0;f=Za-16|0;Za=f;j[f+12>>2]=c;jc(f+12|0,256);jc(f+12|0,65535);h=l[f+12>>1];bg(a,h);if(h){c=0;while(1){g=k[b+c|0];a:{if((g|0)==(d|0)){g=65535;break a}if((e|0)!=(g|0)){break a}g=65534}m=nk(a,c),n=g,i[m>>1]=n;c=c+1|0;if((h|0)!=(c|0)){continue}break}}Za=f+16|0;return 1}function xl(a,b,c,d,e,f,g){var h=0,i=0,k=0;h=Za-16|0;Za=h;if(-17-b>>>0>=c>>>0){i=zb(a);a:{if(b>>>0<2147483623){j[h+8>>2]=b<<1;j[h+12>>2]=b+c;c=Fk(j[Lc(h+12|0,h+8|0)>>2]);break a}c=-18}k=c+1|0;c=Rh(k);if(e){kh(c,i,e)}d=(d-f|0)-e|0;if(d){kh((c+e|0)+g|0,(e+i|0)+f|0,d)}b=b+1|0;if((b|0)!=11){Yf(a,i,b)}lf(a,c);lg(a,k);Za=h+16|0;return}jg();z()}function vka(a,b){var c=0,d=0,e=0,f=0;d=Za-32|0;Za=d;e=hb(a);c=uka(d+8|0,hk(a,pd(a)+1|0),pd(a),e);f=j[c+8>>2];j[114630]=0;I(1556,e|0,f|0,b|0);b=j[114630];j[114630]=0;a:{if((b|0)==1){break a}j[c+8>>2]=j[c+8>>2]+24;j[114630]=0;F(1557,a|0,c|0);a=j[114630];j[114630]=0;if((a|0)==1){break a}QI(c);Za=d+32|0;return}a=D()|0;C()|0;QI(c);G(a|0);z()}function hma(a,b){var c=0,d=0,e=0,f=0,g=0;c=Za-16|0;Za=c;a:{if(!Sw(a,b,1)){break a}e=j[b+656>>2];d=a+1074308|0;mb(c+8|0,d,31);b:{if(kb(c+8|0)){a=j[b+740>>2];if(a){break b}break a}a=j[b+740>>2]}mb(c+8|0,d,31);d=To(e+68|0,a-kb(c+8|0)|0,64,64)-32|0;a=j[b+684>>2];f=b,g=Gb(((p(d,(a|0)>127?256-a|0:a)|0)/32|0)+a|0,0,256),j[f+684>>2]=g}Za=c+16|0}function fG(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=Za-48|0;Za=d;e=j[b+12>>2];j[d+8>>2]=j[b+8>>2];j[d+12>>2]=e;e=j[b+4>>2];j[d>>2]=j[b>>2];j[d+4>>2]=e;e=$P(d);a:{if(e){kaa(d+24|0,b);Xt(d+32|0,d+24|0);break a}jaa(d+16|0,b);Xt(d+32|0,d+16|0)}b=a;a=Jl(d+40|0,d+32|0);NA(b,a,c);jb(a);jb(d+32|0);b:{if(!e){jb(d+16|0);break b}jb(d+24|0)}Za=d+48|0}function Uoa(a,b){var c=0,d=0,e=0,f=0;d=Za-32|0;Za=d;e=hb(a);c=loa(d+8|0,Hl(a,de(a)+1|0),de(a),e);f=j[c+8>>2];j[114630]=0;I(1367,e|0,f|0,b|0);b=j[114630];j[114630]=0;a:{if((b|0)==1){break a}j[c+8>>2]=j[c+8>>2]+32;j[114630]=0;F(1368,a|0,c|0);a=j[114630];j[114630]=0;if((a|0)==1){break a}eK(c);Za=d+32|0;return}a=D()|0;C()|0;eK(c);G(a|0);z()}function Sy(a,b,c){var d=0,e=0,f=0,g=0,i=0,l=0;a:{if(k[a+20|0]){break a}b=(-1-b>>>0<c>>>0?-1-b|0:c)+b|0;if(b>>>0<=m[a+16>>2]){break a}b=az(b,4096);CQ(a,b-j[a+16>>2]|0);d=a,e=(g=a,i=fc(a+4|0,j[a+16>>2]),l=b-j[a+16>>2]|0,f=j[j[a>>2]+48>>2],bb[f](g|0,i|0,l|0)|0)+j[a+16>>2]|0,j[d+16>>2]=e;if(!(bb[j[j[a>>2]+44>>2]](a)|0)){break a}h[a+20|0]=1}}function nna(a,b){var c=0,d=0,e=0,f=0;d=Za-32|0;Za=d;e=hb(a);c=wma(d+8|0,ie(a,sb(a)+1|0),sb(a),e);f=j[c+8>>2];j[114630]=0;I(1416,e|0,f|0,b|0);b=j[114630];j[114630]=0;a:{if((b|0)==1){break a}j[c+8>>2]=j[c+8>>2]+4;j[114630]=0;F(1417,a|0,c|0);a=j[114630];j[114630]=0;if((a|0)==1){break a}yJ(c);Za=d+32|0;return}a=D()|0;C()|0;yJ(c);G(a|0);z()}function eEa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0;if(k[a+40|0]){e=0}else{a:{b:{d=j[a+28>>2];if(d){if(!c){break a}d=bb[d|0](j[a+24>>2],b,c)|0;if(!d){break b}while(1){e=d+e|0;f=e>>>0<d>>>0?f+1|0:f;c=c-d|0;if(!c){break a}b=b+d|0;d=bb[j[a+28>>2]](j[a+24>>2],b,c)|0;if(d){continue}break}break b}h[a+40|0]=1;return 0}h[a+40|0]=1}}return e|0}function _ya(a,b){var c=0,d=0,e=0,f=0;d=Za-32|0;Za=d;e=hb(a);c=Dya(d+8|0,Eya(a,Wj(a)+1|0),Wj(a),e);f=j[c+8>>2];j[114630]=0;I(973,e|0,f|0,b|0);b=j[114630];j[114630]=0;a:{if((b|0)==1){break a}j[c+8>>2]=j[c+8>>2]+56;j[114630]=0;F(974,a|0,c|0);a=j[114630];j[114630]=0;if((a|0)==1){break a}BN(c);Za=d+32|0;return}a=D()|0;C()|0;BN(c);G(a|0);z()}function _sa(a,b){var c=0,d=0,e=0,f=0;d=Za-32|0;Za=d;e=hb(a);c=XL(d+8|0,Hl(a,de(a)+1|0),de(a),e);f=j[c+8>>2];j[114630]=0;I(1174,e|0,f|0,b|0);b=j[114630];j[114630]=0;a:{if((b|0)==1){break a}j[c+8>>2]=j[c+8>>2]+32;j[114630]=0;F(1175,a|0,c|0);a=j[114630];j[114630]=0;if((a|0)==1){break a}fs(c);Za=d+32|0;return}a=D()|0;C()|0;fs(c);G(a|0);z()}function Zaa(a,b){var c=0,d=0,e=0,f=0;d=Za-32|0;Za=d;e=hb(a);c=o8(d+8|0,gq(a,Zc(a)+1|0),Zc(a),e);f=j[c+8>>2];j[114630]=0;I(2121,e|0,f|0,b|0);b=j[114630];j[114630]=0;a:{if((b|0)==1){break a}j[c+8>>2]=j[c+8>>2]+16;j[114630]=0;F(2122,a|0,c|0);a=j[114630];j[114630]=0;if((a|0)==1){break a}LF(c);Za=d+32|0;return}a=D()|0;C()|0;LF(c);G(a|0);z()}function Sla(a,b){var c=0,d=0,e=0,f=0;d=Za-32|0;Za=d;e=hb(a);c=Jla(d+8|0,ie(a,sb(a)+1|0),sb(a),e);f=j[c+8>>2];j[114630]=0;I(1513,e|0,f|0,b|0);b=j[114630];j[114630]=0;a:{if((b|0)==1){break a}j[c+8>>2]=j[c+8>>2]+4;j[114630]=0;F(1514,a|0,c|0);a=j[114630];j[114630]=0;if((a|0)==1){break a}cJ(c);Za=d+32|0;return}a=D()|0;C()|0;cJ(c);G(a|0);z()}function Sha(a,b){var c=0,d=0,e=0,f=0;d=Za-32|0;Za=d;e=hb(a);c=Rha(d+8|0,ie(a,sb(a)+1|0),sb(a),e);f=j[c+8>>2];j[114630]=0;I(1630,e|0,f|0,b|0);b=j[114630];j[114630]=0;a:{if((b|0)==1){break a}j[c+8>>2]=j[c+8>>2]+4;j[114630]=0;F(1631,a|0,c|0);a=j[114630];j[114630]=0;if((a|0)==1){break a}$H(c);Za=d+32|0;return}a=D()|0;C()|0;$H(c);G(a|0);z()}function Rza(a,b){a=a|0;b=b|0;var c=0,d=0;c=Za-48|0;Za=c;a:{if(xs(a)>>>0<b>>>0){hb(a);d=iy(c+32|0);j[114630]=0;F(932,d|0,b|0);b=j[114630];j[114630]=0;if((b|0)==1){break a}Zi(c+16|0,a);Xj(c+8|0,a);j[114630]=0;I(933,d|0,c+16|0,c+8|0);b=j[114630];j[114630]=0;if((b|0)==1){break a}hy(a,d);Vd(d)}Za=c+48|0;return}a=D()|0;C()|0;Vd(d);G(a|0);z()}function Oaa(a,b){var c=0,d=0,e=0,f=0;d=Za-32|0;Za=d;e=hb(a);c=i8(d+8|0,hk(a,pd(a)+1|0),pd(a),e);f=j[c+8>>2];j[114630]=0;I(2126,e|0,f|0,b|0);b=j[114630];j[114630]=0;a:{if((b|0)==1){break a}j[c+8>>2]=j[c+8>>2]+24;j[114630]=0;F(2127,a|0,c|0);a=j[114630];j[114630]=0;if((a|0)==1){break a}JF(c);Za=d+32|0;return}a=D()|0;C()|0;JF(c);G(a|0);z()}function Iqa(a,b){var c=0,d=0,e=0,f=0;d=Za-32|0;Za=d;e=hb(a);c=bL(d+8|0,fm(a,ec(a)+1|0),ec(a),e);f=j[c+8>>2];j[114630]=0;I(1249,e|0,f|0,b|0);b=j[114630];j[114630]=0;a:{if((b|0)==1){break a}j[c+8>>2]=j[c+8>>2]+12;j[114630]=0;F(1250,a|0,c|0);a=j[114630];j[114630]=0;if((a|0)==1){break a}Yr(c);Za=d+32|0;return}a=D()|0;C()|0;Yr(c);G(a|0);z()}function GL(a){h[a|0]=0;h[a+1|0]=0;h[a+2|0]=0;h[a+3|0]=0;h[a+4|0]=0;h[a+5|0]=0;h[a+6|0]=0;h[a+7|0]=0;h[a+23|0]=0;h[a+24|0]=0;h[a+25|0]=0;h[a+26|0]=0;h[a+16|0]=0;h[a+17|0]=0;h[a+18|0]=0;h[a+19|0]=0;h[a+20|0]=0;h[a+21|0]=0;h[a+22|0]=0;h[a+23|0]=0;h[a+8|0]=0;h[a+9|0]=0;h[a+10|0]=0;h[a+11|0]=0;h[a+12|0]=0;h[a+13|0]=0;h[a+14|0]=0;h[a+15|0]=0}function Cwa(a,b){var c=0,d=0,e=0,f=0;d=Za-32|0;Za=d;e=hb(a);c=twa(d+8|0,ie(a,sb(a)+1|0),sb(a),e);f=j[c+8>>2];j[114630]=0;I(1052,e|0,f|0,b|0);b=j[114630];j[114630]=0;a:{if((b|0)==1){break a}j[c+8>>2]=j[c+8>>2]+4;j[114630]=0;F(1053,a|0,c|0);a=j[114630];j[114630]=0;if((a|0)==1){break a}OM(c);Za=d+32|0;return}a=D()|0;C()|0;OM(c);G(a|0);z()}function Axa(a,b){var c=0,d=0,e=0,f=0;d=Za-32|0;Za=d;e=hb(a);c=Zx(d+8|0,fm(a,ec(a)+1|0),ec(a),e);f=j[c+8>>2];j[114630]=0;I(1016,e|0,f|0,b|0);b=j[114630];j[114630]=0;a:{if((b|0)==1){break a}j[c+8>>2]=j[c+8>>2]+12;j[114630]=0;F(1011,a|0,c|0);a=j[114630];j[114630]=0;if((a|0)==1){break a}qs(c);Za=d+32|0;return}a=D()|0;C()|0;qs(c);G(a|0);z()}function yia(a,b){var c=0,d=0,e=0,f=0;d=Za-32|0;Za=d;e=hb(a);c=uw(d+8|0,ie(a,sb(a)+1|0),sb(a),e);f=j[c+8>>2];j[114630]=0;I(1599,e|0,f|0,b|0);b=j[114630];j[114630]=0;a:{if((b|0)==1){break a}j[c+8>>2]=j[c+8>>2]+4;j[114630]=0;F(1592,a|0,c|0);a=j[114630];j[114630]=0;if((a|0)==1){break a}wm(c);Za=d+32|0;return}a=D()|0;C()|0;wm(c);G(a|0);z()}function ssa(a,b,c){var d=0,e=0,f=0,g=0;d=j[a+4>>2];e=j[a>>2];if((d|0)>=(e|0)){f=a+14|0;g=a+12|0;while(1){j[a+8>>2]=j[a+12>>2];rsa(a,g,f);e=j[a>>2];d=j[a+4>>2]-e|0;j[a+4>>2]=d;if((d|0)>=(e|0)){continue}break}}f=b;b=e-d|0;i[f>>1]=(p(i[a+12>>1],d)+p(b,i[a+8>>1])|0)/(e|0);i[c>>1]=(p(i[a+14>>1],d)+p(b,i[a+10>>1])|0)/(e|0);j[a+4>>2]=d+49716}function bga(a,b){var c=0,d=0,e=0,f=0;d=Za-32|0;Za=d;e=hb(a);c=sH(d+8|0,ie(a,sb(a)+1|0),sb(a),e);f=j[c+8>>2];j[114630]=0;I(1757,e|0,f|0,b|0);b=j[114630];j[114630]=0;a:{if((b|0)==1){break a}j[c+8>>2]=j[c+8>>2]+4;j[114630]=0;F(1754,a|0,c|0);a=j[114630];j[114630]=0;if((a|0)==1){break a}pr(c);Za=d+32|0;return}a=D()|0;C()|0;pr(c);G(a|0);z()}function Lya(a,b){var c=0,d=0,e=0,f=0;d=Za-32|0;Za=d;e=hb(a);c=Kya(d+8|0,hk(a,pd(a)+1|0),pd(a),e);f=j[c+8>>2];j[114630]=0;I(982,e|0,f|0,b|0);b=j[114630];j[114630]=0;a:{if((b|0)==1){break a}j[c+8>>2]=j[c+8>>2]+24;j[114630]=0;F(983,a|0,c|0);a=j[114630];j[114630]=0;if((a|0)==1){break a}EN(c);Za=d+32|0;return}a=D()|0;C()|0;EN(c);G(a|0);z()}function HDa(a,b){var c=0,d=0,e=0,f=0;d=Za-32|0;Za=d;e=hb(a);c=EDa(d+8|0,hk(a,pd(a)+1|0),pd(a),e);f=j[c+8>>2];j[114630]=0;I(768,e|0,f|0,b|0);b=j[114630];j[114630]=0;a:{if((b|0)==1){break a}j[c+8>>2]=j[c+8>>2]+24;j[114630]=0;F(769,a|0,c|0);a=j[114630];j[114630]=0;if((a|0)==1){break a}BP(c);Za=d+32|0;return}a=D()|0;C()|0;BP(c);G(a|0);z()}function GHa(a,b){var c=0,d=0,e=0,f=0;d=Za-32|0;Za=d;e=hb(a);c=EHa(d+8|0,hk(a,pd(a)+1|0),pd(a),e);f=j[c+8>>2];j[114630]=0;I(605,e|0,f|0,b|0);b=j[114630];j[114630]=0;a:{if((b|0)==1){break a}j[c+8>>2]=j[c+8>>2]+24;j[114630]=0;F(606,a|0,c|0);a=j[114630];j[114630]=0;if((a|0)==1){break a}_Q(c);Za=d+32|0;return}a=D()|0;C()|0;_Q(c);G(a|0);z()}function FJa(a,b){var c=0,d=0,e=0,f=0;d=Za-32|0;Za=d;e=hb(a);c=BJa(d+8|0,hk(a,pd(a)+1|0),pd(a),e);f=j[c+8>>2];j[114630]=0;I(528,e|0,f|0,b|0);b=j[114630];j[114630]=0;a:{if((b|0)==1){break a}j[c+8>>2]=j[c+8>>2]+24;j[114630]=0;F(529,a|0,c|0);a=j[114630];j[114630]=0;if((a|0)==1){break a}IR(c);Za=d+32|0;return}a=D()|0;C()|0;IR(c);G(a|0);z()}function zFa(a,b){var c=0,d=0,e=0,f=0;d=Za-32|0;Za=d;e=hb(a);c=VD(d+8|0,fm(a,ec(a)+1|0),ec(a),e);f=j[c+8>>2];j[114630]=0;I(727,e|0,f|0,b|0);b=j[114630];j[114630]=0;a:{if((b|0)==1){break a}j[c+8>>2]=j[c+8>>2]+12;j[114630]=0;F(205,a|0,c|0);a=j[114630];j[114630]=0;if((a|0)==1){break a}Dq(c);Za=d+32|0;return}a=D()|0;C()|0;Dq(c);G(a|0);z()}function wHa(a,b){var c=0,d=0,e=0,f=0;d=Za-32|0;Za=d;e=hb(a);c=ZQ(d+8|0,gq(a,Zc(a)+1|0),Zc(a),e);f=j[c+8>>2];j[114630]=0;I(608,e|0,f|0,b|0);b=j[114630];j[114630]=0;a:{if((b|0)==1){break a}j[c+8>>2]=j[c+8>>2]+16;j[114630]=0;F(609,a|0,c|0);a=j[114630];j[114630]=0;if((a|0)==1){break a}Ys(c);Za=d+32|0;return}a=D()|0;C()|0;Ys(c);G(a|0);z()}function rx(a,b,c,d){var e=0,f=0;e=Za-16|0;Za=e;a:{if(j[b+480180>>2]&64671904){b=k[c+4|0];h[e|0]=0;j[a>>2]=k[(b&15)+20832|0];h[a+4|0]=k[e|0];break a}h[e+15|0]=0;f=k[c+4|0];if(!(k[c+3|0]!=4|j[b+480180>>2]!=4)){h[e+15|0]=1;f=f<<1}mb(e,b+1074308|0,66);if(!(!d|!kb(e))){j[e>>2]=0;fi(a,e,e+15|0);break a}j[e>>2]=f<<4;fi(a,e,e+15|0)}Za=e+16|0}function pja(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0;e=Za-16|0;Za=e;a:{b=nja(e,a+8|0,b);if(j[b>>2]!=j[b+4>>2]){while(1){d=j[a+16>>2];f=j[b>>2];j[114630]=0;I(1576,d|0,f|0,c|0);d=j[114630];j[114630]=0;if((d|0)==1){break a}d=j[b>>2]+52|0;j[b>>2]=d;if((d|0)!=j[b+4>>2]){continue}break}}cc(b);Za=e+16|0;return}a=D()|0;C()|0;cc(b);G(a|0);z()}function SIa(a,b){var c=0,d=0,e=0,f=0;d=Za-32|0;Za=d;e=hb(a);c=iR(d+8|0,jR(a,li(a)+1|0),li(a),e);f=j[c+8>>2];j[114630]=0;I(557,e|0,f|0,b|0);b=j[114630];j[114630]=0;a:{if((b|0)==1){break a}j[c+8>>2]=j[c+8>>2]+48;j[114630]=0;F(558,a|0,c|0);a=j[114630];j[114630]=0;if((a|0)==1){break a}at(c);Za=d+32|0;return}a=D()|0;C()|0;at(c);G(a|0);z()}function Asa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0;e=Za-16|0;Za=e;a:{b=zsa(e,a+8|0,b);if(j[b>>2]!=j[b+4>>2]){while(1){d=j[a+16>>2];f=j[b>>2];j[114630]=0;I(1172,d|0,f|0,c|0);d=j[114630];j[114630]=0;if((d|0)==1){break a}d=j[b>>2]+32|0;j[b>>2]=d;if((d|0)!=j[b+4>>2]){continue}break}}cc(b);Za=e+16|0;return}a=D()|0;C()|0;cc(b);G(a|0);z()}function xU(a,b){var c=0,d=0,e=0,f=0;d=Za-32|0;Za=d;e=hb(a);c=YA(d+8|0,Hl(a,de(a)+1|0),de(a),e);f=j[c+8>>2];j[114630]=0;I(347,e|0,f|0,b|0);b=j[114630];j[114630]=0;a:{if((b|0)==1){break a}j[c+8>>2]=j[c+8>>2]+32;j[114630]=0;F(267,a|0,c|0);a=j[114630];j[114630]=0;if((a|0)==1){break a}Zp(c);Za=d+32|0;return}a=D()|0;C()|0;Zp(c);G(a|0);z()}function m4(a,b){var c=0,d=0,e=0,f=0;d=Za-32|0;Za=d;e=hb(a);c=VD(d+8|0,fm(a,ec(a)+1|0),ec(a),e);f=j[c+8>>2];j[114630]=0;I(204,e|0,f|0,b|0);b=j[114630];j[114630]=0;a:{if((b|0)==1){break a}j[c+8>>2]=j[c+8>>2]+12;j[114630]=0;F(205,a|0,c|0);a=j[114630];j[114630]=0;if((a|0)==1){break a}Dq(c);Za=d+32|0;return}a=D()|0;C()|0;Dq(c);G(a|0);z()}function dE(a){a=a|0;var b=0,c=0,d=0,e=0,f=0;b=Za-16|0;Za=b;e=b+16|0;a:{while(1){c=j[a+36>>2];f=bb[j[j[c>>2]+20>>2]](c,j[a+40>>2],b+8|0,e,b+4|0)|0;c=-1;d=j[b+4>>2]-(b+8|0)|0;if((d|0)!=(Bi(b+8|0,1,d,j[a+32>>2])|0)){break a}b:{switch(f-1|0){case 1:break a;case 0:continue;default:break b}}break}c=Sq(j[a+32>>2])?-1:0}Za=b+16|0;return c|0}function LDa(a,b){var c=0,d=0,e=0,f=0;d=Za-32|0;Za=d;e=hb(a);c=wn(d+8|0,ie(a,sb(a)+1|0),sb(a),e);f=j[c+8>>2];j[114630]=0;I(766,e|0,f|0,b|0);b=j[114630];j[114630]=0;a:{if((b|0)==1){break a}j[c+8>>2]=j[c+8>>2]+4;j[114630]=0;F(368,a|0,c|0);a=j[114630];j[114630]=0;if((a|0)==1){break a}xh(c);Za=d+32|0;return}a=D()|0;C()|0;xh(c);G(a|0);z()}function KT(a,b,c){var d=0,e=0;c=LT(a,b,c);if(!c){return 0}if(!((k[a+550|0]|k[a+551|0]<<8|(k[a+552|0]<<16|k[a+553|0]<<24))!=1297110104?(k[a+550|0]|k[a+551|0]<<8|(k[a+552|0]<<16|k[a+553|0]<<24))!=1481920589:0)){c=b+236|0;b=0;while(1){e=k[(a+b|0)+554|0];d=Nc(c,b);i[d>>1]=l[d>>1]|e<<8;b=b+1|0;if((b|0)!=120){continue}break}c=674}return c}function JKa(a,b){var c=0,d=0,e=0,f=0;d=Za-32|0;Za=d;e=hb(a);c=yt(d+8|0,ui(a,Yb(a)+1|0),Yb(a),e);f=j[c+8>>2];j[114630]=0;I(381,e|0,f|0,b|0);b=j[114630];j[114630]=0;a:{if((b|0)==1){break a}j[c+8>>2]=j[c+8>>2]+2;j[114630]=0;F(380,a|0,c|0);a=j[114630];j[114630]=0;if((a|0)==1){break a}mk(c);Za=d+32|0;return}a=D()|0;C()|0;mk(c);G(a|0);z()}function H9(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0;d=cL(a);a:{if(!j[b+4>>2]){break a}c=j[b+4>>2];j[114630]=0;F(2174,a|0,c|0);c=j[114630];j[114630]=0;if((c|0)!=1){c=j[b>>2];e=j[b>>2];f=p(j[b+4>>2],12);b=j[b+4>>2];j[114630]=0;L(2175,a|0,c|0,e+f|0,b|0);b=j[114630];j[114630]=0;if((b|0)!=1){break a}}a=D()|0;C()|0;DA(d);G(a|0);z()}return a|0}function zU(a,b){var c=0,d=0,e=0,f=0;d=Za-32|0;Za=d;e=hb(a);c=EA(d+8|0,ie(a,sb(a)+1|0),sb(a),e);f=j[c+8>>2];j[114630]=0;I(346,e|0,f|0,b|0);b=j[114630];j[114630]=0;a:{if((b|0)==1){break a}j[c+8>>2]=j[c+8>>2]+4;j[114630]=0;F(343,a|0,c|0);a=j[114630];j[114630]=0;if((a|0)==1){break a}Sp(c);Za=d+32|0;return}a=D()|0;C()|0;Sp(c);G(a|0);z()}function via(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0;e=Za-16|0;Za=e;a:{b=wh(e,a+8|0,b);if(j[b>>2]!=j[b+4>>2]){while(1){d=j[a+16>>2];f=j[b>>2];j[114630]=0;I(1599,d|0,f|0,c|0);d=j[114630];j[114630]=0;if((d|0)==1){break a}d=j[b>>2]+4|0;j[b>>2]=d;if((d|0)!=j[b+4>>2]){continue}break}}cc(b);Za=e+16|0;return}a=D()|0;C()|0;cc(b);G(a|0);z()}function dra(a,b){var c=0,d=0,e=0,f=0;d=Za-32|0;Za=d;e=hb(a);c=as(d+8|0,ie(a,sb(a)+1|0),sb(a),e);f=j[c+8>>2];j[114630]=0;I(411,e|0,f|0,b|0);b=j[114630];j[114630]=0;a:{if((b|0)==1){break a}j[c+8>>2]=j[c+8>>2]+4;j[114630]=0;F(96,a|0,c|0);a=j[114630];j[114630]=0;if((a|0)==1){break a}Rj(c);Za=d+32|0;return}a=D()|0;C()|0;Rj(c);G(a|0);z()}function a0(a,b){var c=0,d=0,e=0,f=0;d=Za-32|0;Za=d;e=hb(a);c=wl(d+8|0,ul(a,tc(a)+1|0),tc(a),e);f=j[c+8>>2];j[114630]=0;I(210,e|0,f|0,b|0);b=j[114630];j[114630]=0;a:{if((b|0)==1){break a}j[c+8>>2]=j[c+8>>2]+1;j[114630]=0;F(209,a|0,c|0);a=j[114630];j[114630]=0;if((a|0)==1){break a}Xl(c);Za=d+32|0;return}a=D()|0;C()|0;Xl(c);G(a|0);z()}function TEa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0;e=Za-16|0;Za=e;a:{b=REa(e,a+8|0,b);if(j[b>>2]!=j[b+4>>2]){while(1){d=j[a+16>>2];f=j[b>>2];j[114630]=0;I(706,d|0,f|0,c|0);d=j[114630];j[114630]=0;if((d|0)==1){break a}d=j[b>>2]+6|0;j[b>>2]=d;if((d|0)!=j[b+4>>2]){continue}break}}cc(b);Za=e+16|0;return}a=D()|0;C()|0;cc(b);G(a|0);z()}function PB(a,b,c,d,e){var f=0,g=0,h=0;f=Za-16|0;Za=f;if(1073741807-b>>>0>=c>>>0){g=zb(a);a:{if(b>>>0<536870887){j[f+8>>2]=b<<1;j[f+12>>2]=b+c;c=Ul(j[Lc(f+12|0,f+8|0)>>2]);break a}c=1073741806}h=c+1|0;c=Ck(h);if(e){Jh(c,g,e)}d=d-e|0;if(d){e=e<<2;Jh(e+c|0,e+g|0,d)}b=b+1|0;if((b|0)!=2){On(g,b)}lf(a,c);lg(a,h);Za=f+16|0;return}jg();z()}function GEa(a,b){var c=0,d=0,e=0,f=0;c=Za-16|0;Za=c;a:{if(!b){break a}if(!yb(a,b)){break a}while(1){h[c+11|0]=0;b:{if(b>>>0>d>>>0){Ff(a,c+11|0);e=h[c+11|0];f=e>>>31|0;break b}e=0-f|0}h[(c+12|0)+d|0]=e;d=d+1|0;if((d|0)!=4){continue}break}j[c+4>>2]=j[c+12>>2];a=c+4|0;d=k[a|0]|k[a+1|0]<<8|(k[a+2|0]<<16|k[a+3|0]<<24)}Za=c+16|0;return d}function xva(a,b){var c=0,d=0,e=0,f=0;d=Za-32|0;Za=d;e=hb(a);c=as(d+8|0,ie(a,sb(a)+1|0),sb(a),e);f=j[c+8>>2];j[114630]=0;I(95,e|0,f|0,b|0);b=j[114630];j[114630]=0;a:{if((b|0)==1){break a}j[c+8>>2]=j[c+8>>2]+4;j[114630]=0;F(96,a|0,c|0);a=j[114630];j[114630]=0;if((a|0)==1){break a}Rj(c);Za=d+32|0;return}a=D()|0;C()|0;Rj(c);G(a|0);z()}function lFa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0;e=Za-16|0;Za=e;a:{b=wh(e,a+8|0,b);if(j[b>>2]!=j[b+4>>2]){while(1){d=j[a+16>>2];f=j[b>>2];j[114630]=0;I(411,d|0,f|0,c|0);d=j[114630];j[114630]=0;if((d|0)==1){break a}d=j[b>>2]+4|0;j[b>>2]=d;if((d|0)!=j[b+4>>2]){continue}break}}cc(b);Za=e+16|0;return}a=D()|0;C()|0;cc(b);G(a|0);z()}function kMa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0;e=Za-16|0;Za=e;a:{b=yl(e,a+8|0,b);if(j[b>>2]!=j[b+4>>2]){while(1){d=j[a+16>>2];f=j[b>>2];j[114630]=0;I(381,d|0,f|0,c|0);d=j[114630];j[114630]=0;if((d|0)==1){break a}d=j[b>>2]+2|0;j[b>>2]=d;if((d|0)!=j[b+4>>2]){continue}break}}cc(b);Za=e+16|0;return}a=D()|0;C()|0;cc(b);G(a|0);z()}function UEa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0;e=Za-16|0;Za=e;a:{b=Hs(e,a+8|0,b);if(j[b>>2]!=j[b+4>>2]){while(1){d=j[a+16>>2];f=j[b>>2];j[114630]=0;I(571,d|0,f|0,c|0);d=j[114630];j[114630]=0;if((d|0)==1){break a}d=j[b>>2]+1|0;j[b>>2]=d;if((d|0)!=j[b+4>>2]){continue}break}}cc(b);Za=e+16|0;return}a=D()|0;C()|0;cc(b);G(a|0);z()}function RHa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0;e=Za-32|0;Za=e;j[e+28>>2]=d;a:{if(k[a+8|0]){d=a+12|0;g=e,h=tc(d)-c|0,j[g+24>>2]=h;a=j[tb(e+24|0,e+28|0)>>2];g=e,h=Lb(d),j[g+24>>2]=h;f=af(e+24|0,c);g=e,h=Lb(d),j[g+8>>2]=h;g=e,h=af(e+8|0,c),j[g+16>>2]=h;cj(f,af(e+16|0,a),b);break a}a=tHa(a,b,c,d)}Za=e+32|0;return a|0}function GN(a){var b=0;a:{if((k[a|0]|k[a+1|0]<<8|(k[a+2|0]<<16|k[a+3|0]<<24))!=-28486832|k[a+63|0]!=26){break a}b=a+65|0;if(k[a- -64|0]&3|(k[a+66|0]|(k[b|0]!=1?k[b|0]!=16:0))){break a}b=a+78|0;if((k[b|0]|k[b+1|0]<<8)>>>0>127){break a}a=a+80|0;if((k[a|0]|k[a+1|0]<<8)>>>0>127){break a}a=Nya(b,a);return(k[a|0]|k[a+1|0]<<8)!=0}return 0}function JLa(a,b){var c=0,d=0,e=0;c=Za-32|0;Za=c;j[c+16>>2]=b;j[c+24>>2]=a;d=c,e=lLa(a,b),j[d+24>>2]=e;if(rb(c+24|0,c+16|0)){j[c>>2]=j[c+24>>2];Id(c);if(rb(Id(c),c+16|0)){while(1){if(!el(j[c+24>>2],j[c>>2])){a=j[j[c>>2]>>2];d=j[Id(c+24|0)>>2],e=a,j[d>>2]=e}if(rb(Id(c),c+16|0)){continue}break}}Id(c+24|0)}Za=c+32|0;return j[c+24>>2]}function zt(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0;e=Za-16|0;Za=e;a:{b=yh(e,a,b);if(j[b+4>>2]!=j[b+8>>2]){while(1){d=hb(a);f=j[b+4>>2];j[114630]=0;I(381,d|0,f|0,c|0);d=j[114630];j[114630]=0;if((d|0)==1){break a}d=j[b+4>>2]+2|0;j[b+4>>2]=d;if((d|0)!=j[b+8>>2]){continue}break}}ub(b);Za=e+16|0;return}a=D()|0;C()|0;ub(b);G(a|0);z()}function dt(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0;e=Za-16|0;Za=e;a:{b=vl(e,a,b);if(j[b+4>>2]!=j[b+8>>2]){while(1){d=hb(a);f=j[b+4>>2];j[114630]=0;I(571,d|0,f|0,c|0);d=j[114630];j[114630]=0;if((d|0)==1){break a}d=j[b+4>>2]+1|0;j[b+4>>2]=d;if((d|0)!=j[b+8>>2]){continue}break}}ub(b);Za=e+16|0;return}a=D()|0;C()|0;ub(b);G(a|0);z()}function Wy(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0;e=Za-16|0;Za=e;a:{b=op(e,a,b);if(j[b+4>>2]!=j[b+8>>2]){while(1){d=hb(a);f=j[b+4>>2];j[114630]=0;I(706,d|0,f|0,c|0);d=j[114630];j[114630]=0;if((d|0)==1){break a}d=j[b+4>>2]+6|0;j[b+4>>2]=d;if((d|0)!=j[b+8>>2]){continue}break}}ub(b);Za=e+16|0;return}a=D()|0;C()|0;ub(b);G(a|0);z()}function US(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0;e=Za-16|0;Za=e;a:{b=_d(e,a,b);if(j[b+4>>2]!=j[b+8>>2]){while(1){d=hb(a);f=j[b+4>>2];j[114630]=0;I(411,d|0,f|0,c|0);d=j[114630];j[114630]=0;if((d|0)==1){break a}d=j[b+4>>2]+4|0;j[b+4>>2]=d;if((d|0)!=j[b+8>>2]){continue}break}}ub(b);Za=e+16|0;return}a=D()|0;C()|0;ub(b);G(a|0);z()}function ST(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0;e=Za-16|0;Za=e;a:{b=vl(e,a,b);if(j[b+4>>2]!=j[b+8>>2]){while(1){d=hb(a);f=j[b+4>>2];j[114630]=0;I(366,d|0,f|0,c|0);d=j[114630];j[114630]=0;if((d|0)==1){break a}d=j[b+4>>2]+1|0;j[b+4>>2]=d;if((d|0)!=j[b+8>>2]){continue}break}}ub(b);Za=e+16|0;return}a=D()|0;C()|0;ub(b);G(a|0);z()}function Mra(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0;c=Za-16|0;Za=c;hb(b);f=wL(a,c+8|0);a:{d=fg(b);if(!d){break a}j[114630]=0;F(1215,a|0,d|0);e=j[114630];j[114630]=0;if((e|0)!=1){e=j[b+4>>2];b=j[b>>2];j[114630]=0;L(1216,a|0,b|0,e|0,d|0);b=j[114630];j[114630]=0;if((b|0)!=1){break a}}a=D()|0;C()|0;Bx(f);G(a|0);z()}Za=c+16|0;return a|0}function nU(a){var b=0;a:{b:{c:{d:{if((a|0)<=-1){a=R(8)|0;j[114630]=0;H(352,a|0)|0;b=j[114630];j[114630]=0;if((b|0)!=1){break c}break d}if(a>>>0<56){break a}a=R(8)|0;j[114630]=0;H(352,a|0)|0;b=j[114630];j[114630]=0;if((b|0)!=1){break b}}b=D()|0;C()|0;S(a|0);G(b|0);z()}X(a|0,77432,265);z()}X(a|0,77432,265);z()}return k[a+11680|0]}function eqa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0;d=Za-16|0;Za=d;j[d+12>>2]=c>>>2;j[d+8>>2]=j[a>>2];e=j[tb(d+12|0,d+8|0)>>2];b=lb(b);if(e){a=j[a+20>>2];c=e;while(1){f=a,g=lb(k[b|0])|lb(k[b+1|0])<<8,i[f>>1]=g;f=a,g=lb(k[b+2|0])|lb(k[b+3|0])<<8,i[f+2>>1]=g;a=a+4|0;b=b+4|0;c=c-1|0;if(c){continue}break}}Za=d+16|0;return e<<2}function aqa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0;d=Za-16|0;Za=d;j[d+12>>2]=c>>>2;j[d+8>>2]=j[a>>2];e=j[tb(d+12|0,d+8|0)>>2];b=lb(b);if(e){a=j[a+20>>2];c=e;while(1){f=a,g=lb(k[b+1|0])|lb(k[b|0])<<8,i[f>>1]=g;f=a,g=lb(k[b+3|0])|lb(k[b+2|0])<<8,i[f+2>>1]=g;a=a+4|0;b=b+4|0;c=c-1|0;if(c){continue}break}}Za=d+16|0;return e<<2}function _V(a){var b=0,c=0,d=0,e=0;d=Za-32|0;Za=d;c=hb(a);b=YA(d+8|0,Hl(a,de(a)+1|0),de(a),c);e=j[b+8>>2];j[114630]=0;F(266,c|0,e|0);c=j[114630];j[114630]=0;a:{if((c|0)==1){break a}j[b+8>>2]=j[b+8>>2]+32;j[114630]=0;F(267,a|0,b|0);a=j[114630];j[114630]=0;if((a|0)==1){break a}Zp(b);Za=d+32|0;return}a=D()|0;C()|0;Zp(b);G(a|0);z()}function ow(a){var b=0,c=0,d=0,e=0;b=Cg(+n[a+4228>>2]*8)*.25+ -.25;o[a+4248>>3]=b;if(k[a+4240|0]){e=a;if(b<=45e-5){b=0}else{b=Zn(b)*1.4426950408889634;d=v(b);b=b-d;c=0;a:{if(b<.2075187496394219){break a}c=.4150374992788438;if(b<.5){break a}c=.5849625007211562;if(b<.792481250360578){break a}c=1}b=Cg(c+d)*.5}o[e+4248>>3]=b}ur(a)}function kH(a){a=a|0;var b=0,c=0;c=Za-16|0;Za=c;b=(we(j[a+16>>2])|0)/5|0;b=ic(b,b>>31);j[a+4272>>2]=b;j[114630]=0;j[c+12>>2]=0;I(1642,a+4256|0,b<<1,c+12|0);b=j[114630];j[114630]=0;a:{if((b|0)==1){b=J(71412)|0;if((C()|0)!=(W(71412)|0)){break a}O(b|0)|0;j[a+4272>>2]=0;Q()}j[a+4276>>2]=0;j[a+4268>>2]=0;Za=c+16|0;return}G(b|0);z()}function eH(a){var b=q(0),c=0,d=q(0),e=0;b=n[a+4224>>2];n[a+4260>>2]=y(q(q(1)-q(b*b)));h[a+4264|0]=n[a+4236>>2]>q(.5);c=a;d=q(j[a+4256>>2]<<1>>>0);b=q(n[a+4228>>2]*d);a:{if(b<q(4294967296)&b>=q(0)){e=~~b>>>0;break a}e=0}j[c+4248>>2]=e;c=a+4252|0;b=q(n[a+4232>>2]*d);b:{if(b<q(4294967296)&b>=q(0)){a=~~b>>>0;break b}a=0}j[c>>2]=a}function YS(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0;c=Za-16|0;Za=c;hb(b);f=PS(a,c+8|0);a:{d=sb(b);if(!d){break a}j[114630]=0;F(404,a|0,d|0);e=j[114630];j[114630]=0;if((e|0)!=1){e=j[b+4>>2];b=j[b>>2];j[114630]=0;L(408,a|0,b|0,e|0,d|0);b=j[114630];j[114630]=0;if((b|0)!=1){break a}}a=D()|0;C()|0;ms(f);G(a|0);z()}Za=c+16|0;return a|0}function EFa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0;d=Za-16|0;Za=d;Ce(b);j[d+12>>2]=0;a:{if(!gi(a,d+12|0)){break a}f=c;c=j[d+12>>2];if(f>>>0<c>>>0){break a}if(!c){e=1;break a}c=0;while(1){b:{h[d+11|0]=0;if(!Dg(a,d+11|0)){break b}zl(b,h[d+11|0]);e=1;c=c+1|0;if((c|0)!=j[d+12>>2]){continue}break a}break}e=0}Za=d+16|0;return e|0}function AN(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0;c=Za-16|0;Za=c;hb(b);f=yN(a,c+8|0);a:{d=tc(b);if(!d){break a}j[114630]=0;F(563,a|0,d|0);e=j[114630];j[114630]=0;if((e|0)!=1){e=j[b+4>>2];b=j[b>>2];j[114630]=0;L(987,a|0,b|0,e|0,d|0);b=j[114630];j[114630]=0;if((b|0)!=1){break a}}a=D()|0;C()|0;Np(f);G(a|0);z()}Za=c+16|0;return a|0}function m5(a){var b=0,c=0;a:{b:{c:{if(j[a+1380>>2]!=-1){break c}b=he(a);if(j[a+96>>2]){break b}if((b|0)!=79){break a}if((he(a)|0)!=103){break a}if((he(a)|0)!=103){break a}if((he(a)|0)!=83){break a}if(!NE(a)){break b}if(!(h[a+1375|0]&1)){break c}h[a+1376|0]=0;j[a+1384>>2]=0;Nb(a,32);return 0}c=Bv(a)}return c}Nb(a,30);return 0}function QQ(a){a:{if((k[a|0]|k[a+1|0]<<8|(k[a+2|0]<<16|k[a+3|0]<<24))!=-28490681|k[a+68|0]!=13|(k[a+69|0]!=10|k[a+70|0]!=26)){break a}if(k[a+76|0]|((k[a+71|0]|k[a+72|0]<<8|(k[a+73|0]<<16|k[a+74|0]<<24))!=1397116231|k[a+75|0]!=1)){break a}a=a+116|0;if((k[a|0]|k[a+1|0]<<8)>>>0>=10){break a}return(k[a|0]|k[a+1|0]<<8)!=0}return 0}function CFa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0;d=Za-16|0;Za=d;Ce(b);h[d+15|0]=0;a:{if(!Dg(a,d+15|0)){break a}f=c;c=k[d+15|0];if(f>>>0<c>>>0){break a}if(!c){e=1;break a}c=0;while(1){b:{h[d+14|0]=0;if(!Dg(a,d+14|0)){break b}zl(b,h[d+14|0]);e=1;c=c+1|0;if(k[d+15|0]!=(c&255)){continue}break a}break}e=0}Za=d+16|0;return e|0}function tv(a,b,c,d){var e=0,f=0,g=0,h=0,i=0,k=0;g=Za-240|0;Za=g;j[g>>2]=a;h=1;a:{if((c|0)<2){break a}e=a;while(1){e=e-4|0;i=c-2|0;f=e-j[(i<<2)+d>>2]|0;if((bb[b|0](a,f)|0)>=0){if((bb[b|0](a,e)|0)>-1){break a}}k=f;f=(bb[b|0](f,e)|0)>-1;e=f?k:e;j[(h<<2)+g>>2]=e;h=h+1|0;c=f?c-1|0:i;if((c|0)>1){continue}break}}sE(g,h);Za=g+240|0}function r7(a,b,c,d,e){var f=0,g=0,h=0,k=0,l=0,m=0;if(e){k=c+4|0;while(1){g=0;if(d){while(1){f=j[tf(b,g,h)>>2];Pb(c,g);f=(f+((br(k)^-2147483648)>>>21|0)|0)-2147482624>>>12|0;f=f>>>0>491520?f:491520;l=lm(a,g,h),m=(f|0)<557055?f:557055,i[l>>1]=m;g=g+1|0;if((g|0)!=(d|0)){continue}break}}h=h+1|0;if((h|0)!=(e|0)){continue}break}}}function ne(a){var b=0,c=0,d=0;a:{b:{b=a;if(!(b&3)){break b}if(!k[a|0]){return 0}while(1){b=b+1|0;if(!(b&3)){break b}if(k[b|0]){continue}break}break a}while(1){c=b;b=b+4|0;d=j[c>>2];if(!((d^-1)&d-16843009&-2139062144)){continue}break}if(!(d&255)){return c-a|0}while(1){d=k[c+1|0];b=c+1|0;c=b;if(d){continue}break}}return b-a|0}function lha(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;d=Za-16|0;Za=d;a:{b=gha(d,a+8|0,b);if(j[b>>2]!=j[b+4>>2]){while(1){c=j[a+16>>2];e=j[b>>2];j[114630]=0;F(1645,c|0,e|0);c=j[114630];j[114630]=0;if((c|0)==1){break a}c=j[b>>2]+2048|0;j[b>>2]=c;if((c|0)!=j[b+4>>2]){continue}break}}cc(b);Za=d+16|0;return}a=D()|0;C()|0;cc(b);G(a|0);z()}function V7(a,b,c,d,e){var f=0,g=0,h=0,k=0,l=0,m=0;if(e){k=c+4|0;while(1){g=0;if(d){while(1){f=j[tf(b,g,h)>>2];Pb(c,g);f=(f+((br(k)^-2147483648)>>>21|0)|0)-2147482624>>>12|0;f=f>>>0>491520?f:491520;l=nm(a,g,h),m=(f|0)<557055?f:557055,i[l>>1]=m;g=g+1|0;if((g|0)!=(d|0)){continue}break}}h=h+1|0;if((h|0)!=(e|0)){continue}break}}}function vy(a,b,c,d,e){var f=0;f=Za-32|0;Za=f;HO(a,b);tBa(b,c,e);sn(f,3,b);qc(f+16|0,f);j[114630]=0;E(369,d|0,f+16|0)|0;a=j[114630];j[114630]=0;if((a|0)!=1){a=d+32|0;gb(f+16|0);while(1){if((k[d|0]-1&255)>>>0<=30){h[d|0]=32}d=d+1|0;if((a|0)!=(d|0)){continue}break}a=wy(b);Za=f+32|0;return a}a=D()|0;C()|0;gb(f+16|0);G(a|0);z()}function om(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0;d=or(a+60|0);j[a>>2]=76992;j[d>>2]=77012;j[114630]=0;e=a+8|0;K(175,a|0,77024,e|0)|0;f=j[114630];j[114630]=0;if((f|0)!=1){a:{j[a>>2]=76992;j[d>>2]=77012;j[114630]=0;K(176,e|0,b|0,c|8)|0;b=j[114630];j[114630]=0;if((b|0)==1){break a}return a|0}}a=D()|0;C()|0;og(d);G(a|0);z()}function mW(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=Za-32|0;Za=d;b=Cf(d,b);j[114630]=0;I(253,d+16|0,b|0,c|0);e=j[114630];j[114630]=0;a:{b:{if((e|0)!=1){j[114630]=0;I(5,a|0,d+16|0,c|0);a=j[114630];j[114630]=0;if((a|0)==1){break b}gb(d+16|0);gb(b);Za=d+32|0;return}a=D()|0;C()|0;break a}a=D()|0;C()|0;gb(d+16|0)}gb(b);G(a|0);z()}function NR(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0;d=Za-32|0;Za=d;f=d+8|0;g=b;if(zz(b,d+24|0)){e=DJa(d+24|0)}cd(f,g,e);a=yz(a,d+24|0,d+8|0);jb(d+8|0);a:{if(!c){break a}e=(e>>>0)%(c>>>0)|0;if(!e){break a}j[114630]=0;E(338,b|0,c-e|0)|0;b=j[114630];j[114630]=0;if((b|0)!=1){break a}b=D()|0;C()|0;Re(a);G(b|0);z()}Za=d+32|0}function x5(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,i=0;f=Za-1520|0;Za=f;w5(f+8|0,e);h[f+56|0]=1;j[f+48>>2]=a+b;j[f+40>>2]=a;a:{b:{if(!v5(f+8|0)){j[d>>2]=j[f+104>>2]?1:j[f+108>>2];break b}b=Ad(f+8|0,1512);if(b){g=c,i=j[Vb(b,f+8|0,1512)+32>>2]-a|0,j[g>>2]=i;j[d>>2]=0;break a}TE(f+8|0)}b=0}Za=f+1520|0;return b|0}function sE(a,b){var c=0,d=0,e=0,f=0,g=0,h=0;d=4;e=Za-256|0;Za=e;a:{if((b|0)<2){break a}h=(b<<2)+a|0;j[h>>2]=e;c=e;while(1){f=d>>>0<256?d:256;Vb(c,j[a>>2],f);c=0;while(1){g=(c<<2)+a|0;c=c+1|0;Vb(j[g>>2],j[(c<<2)+a>>2],f);j[g>>2]=j[g>>2]+f;if((b|0)!=(c|0)){continue}break}d=d-f|0;if(!d){break a}c=j[h>>2];continue}}Za=e+256|0}function KN(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0;d=Za-32|0;Za=d;f=d+8|0;g=b;if(zz(b,d+24|0)){e=fy(d+24|0)}cd(f,g,e);a=yz(a,d+24|0,d+8|0);jb(d+8|0);a:{if(!c){break a}e=(e>>>0)%(c>>>0)|0;if(!e){break a}j[114630]=0;E(338,b|0,c-e|0)|0;b=j[114630];j[114630]=0;if((b|0)!=1){break a}b=D()|0;C()|0;Re(a);G(b|0);z()}Za=d+32|0}function qxa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;d=Za-16|0;Za=d;a:{b=_M(d,a+8|0,b);if(j[b>>2]!=j[b+4>>2]){while(1){c=j[a+16>>2];e=j[b>>2];j[114630]=0;F(1019,c|0,e|0);c=j[114630];j[114630]=0;if((c|0)==1){break a}c=j[b>>2]+12|0;j[b>>2]=c;if((c|0)!=j[b+4>>2]){continue}break}}cc(b);Za=d+16|0;return}a=D()|0;C()|0;cc(b);G(a|0);z()}function _qa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;d=Za-16|0;Za=d;a:{b=_M(d,a+8|0,b);if(j[b>>2]!=j[b+4>>2]){while(1){c=j[a+16>>2];e=j[b>>2];j[114630]=0;F(1232,c|0,e|0);c=j[114630];j[114630]=0;if((c|0)==1){break a}c=j[b>>2]+12|0;j[b>>2]=c;if((c|0)!=j[b+4>>2]){continue}break}}cc(b);Za=d+16|0;return}a=D()|0;C()|0;cc(b);G(a|0);z()}function ZEa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;d=Za-16|0;Za=d;a:{b=XEa(d,a+8|0,b);if(j[b>>2]!=j[b+4>>2]){while(1){c=j[a+16>>2];e=j[b>>2];j[114630]=0;F(741,c|0,e|0);c=j[114630];j[114630]=0;if((c|0)==1){break a}c=j[b>>2]+48|0;j[b>>2]=c;if((c|0)!=j[b+4>>2]){continue}break}}cc(b);Za=d+16|0;return}a=D()|0;C()|0;cc(b);G(a|0);z()}function YDa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;d=Za-16|0;Za=d;a:{b=TDa(d,a+8|0,b);if(j[b>>2]!=j[b+4>>2]){while(1){c=j[a+16>>2];e=j[b>>2];j[114630]=0;F(764,c|0,e|0);c=j[114630];j[114630]=0;if((c|0)==1){break a}c=j[b>>2]+33|0;j[b>>2]=c;if((c|0)!=j[b+4>>2]){continue}break}}cc(b);Za=d+16|0;return}a=D()|0;C()|0;cc(b);G(a|0);z()}function PI(a){var b=0;b=Za-16|0;Za=b;h[a|0]=0;h[a+1|0]=0;h[a+2|0]=0;h[a+3|0]=0;h[a+4|0]=0;h[a+5|0]=0;h[a+6|0]=0;h[a+7|0]=0;h[a+16|0]=0;h[a+17|0]=0;h[a+18|0]=0;h[a+19|0]=0;h[a+20|0]=0;h[a+21|0]=0;h[a+22|0]=0;h[a+23|0]=0;h[a+8|0]=0;h[a+9|0]=0;h[a+10|0]=0;h[a+11|0]=0;h[a+12|0]=0;h[a+13|0]=0;h[a+14|0]=0;h[a+15|0]=0;Za=b+16|0}function $Q(a){var b=0;b=Za-16|0;Za=b;h[a|0]=0;h[a+1|0]=0;h[a+2|0]=0;h[a+3|0]=0;h[a+4|0]=0;h[a+5|0]=0;h[a+6|0]=0;h[a+7|0]=0;h[a+14|0]=0;h[a+15|0]=0;h[a+16|0]=0;h[a+17|0]=0;h[a+18|0]=0;h[a+19|0]=0;h[a+20|0]=0;h[a+21|0]=0;h[a+8|0]=0;h[a+9|0]=0;h[a+10|0]=0;h[a+11|0]=0;h[a+12|0]=0;h[a+13|0]=0;h[a+14|0]=0;h[a+15|0]=0;Za=b+16|0}function $P(a){var b=0,c=0,d=0,e=0,f=0;a:{b=j[a>>2];b:{if(!b){break b}c=j[a+8>>2];if(!c){break b}a=j[a+12>>2];if(!a){break b}e=bb[a|0](b)|0;d=ab;if((d|0)<0){break b}if((bb[c|0](b,0,0,0)|0)<=-1){break a}if((bb[c|0](b,0,0,2)|0)<=-1){break a}bb[a|0](b)|0;a=ab;bb[c|0](b,e,d,0)|0;f=(a|0)>-1}return f}bb[c|0](b,e,d,0)|0;return 0}function yDa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;d=Za-16|0;Za=d;a:{b=yB(d,a+8|0,b);if(j[b>>2]!=j[b+4>>2]){while(1){c=j[a+16>>2];e=j[b>>2];j[114630]=0;F(418,c|0,e|0);c=j[114630];j[114630]=0;if((c|0)==1){break a}c=j[b>>2]+16|0;j[b>>2]=c;if((c|0)!=j[b+4>>2]){continue}break}}cc(b);Za=d+16|0;return}a=D()|0;C()|0;cc(b);G(a|0);z()}function vra(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;d=Za-16|0;Za=d;a:{b=Ql(d,a,b);if(j[b+4>>2]!=j[b+8>>2]){while(1){c=hb(a);e=j[b+4>>2];j[114630]=0;F(1225,c|0,e|0);c=j[114630];j[114630]=0;if((c|0)==1){break a}c=j[b+4>>2]+16|0;j[b+4>>2]=c;if((c|0)!=j[b+8>>2]){continue}break}}ub(b);Za=d+16|0;return}a=D()|0;C()|0;ub(b);G(a|0);z()}function ria(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;d=Za-16|0;Za=d;a:{b=wh(d,a+8|0,b);if(j[b>>2]!=j[b+4>>2]){while(1){c=j[a+16>>2];e=j[b>>2];j[114630]=0;F(1616,c|0,e|0);c=j[114630];j[114630]=0;if((c|0)==1){break a}c=j[b>>2]+4|0;j[b>>2]=c;if((c|0)!=j[b+4>>2]){continue}break}}cc(b);Za=d+16|0;return}a=D()|0;C()|0;cc(b);G(a|0);z()}function dAa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;d=Za-16|0;Za=d;a:{b=bAa(d,a+8|0,b);if(j[b>>2]!=j[b+4>>2]){while(1){c=j[a+16>>2];e=j[b>>2];j[114630]=0;F(922,c|0,e|0);c=j[114630];j[114630]=0;if((c|0)==1){break a}c=j[b>>2]+8|0;j[b>>2]=c;if((c|0)!=j[b+4>>2]){continue}break}}cc(b);Za=d+16|0;return}a=D()|0;C()|0;cc(b);G(a|0);z()}function cha(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;d=Za-16|0;Za=d;a:{b=wh(d,a+8|0,b);if(j[b>>2]!=j[b+4>>2]){while(1){c=j[a+16>>2];e=j[b>>2];j[114630]=0;F(1647,c|0,e|0);c=j[114630];j[114630]=0;if((c|0)==1){break a}c=j[b>>2]+4|0;j[b>>2]=c;if((c|0)!=j[b+4>>2]){continue}break}}cc(b);Za=d+16|0;return}a=D()|0;C()|0;cc(b);G(a|0);z()}function Qna(a){a=a|0;var b=0,c=0,d=0,e=0;d=Za-896|0;Za=d;b=Ab(a,0,66);j[b+72>>2]=0;j[b+76>>2]=0;j[b+68>>2]=256;i[b+66>>1]=65535;j[b+80>>2]=0;j[b+84>>2]=0;h[b+88|0]=1;e=b+229984|0;c=b+608|0;a=c;while(1){a=TJ(a)+896|0;if((e|0)!=(a|0)){continue}break}a=Ab(d,0,896);Jma(c,((c+229376|0)-c|0)/896|0,TJ(a));Za=a+896|0;return b|0}function PBa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;d=Za-16|0;Za=d;a:{b=EBa(d,a,b);if(j[b+4>>2]!=j[b+8>>2]){while(1){c=hb(a);e=j[b+4>>2];j[114630]=0;F(877,c|0,e|0);c=j[114630];j[114630]=0;if((c|0)==1){break a}c=j[b+4>>2]+20|0;j[b+4>>2]=c;if((c|0)!=j[b+8>>2]){continue}break}}ub(b);Za=d+16|0;return}a=D()|0;C()|0;ub(b);G(a|0);z()}function zCa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;d=Za-16|0;Za=d;a:{b=yl(d,a+8|0,b);if(j[b>>2]!=j[b+4>>2]){while(1){c=j[a+16>>2];e=j[b>>2];j[114630]=0;F(827,c|0,e|0);c=j[114630];j[114630]=0;if((c|0)==1){break a}c=j[b>>2]+2|0;j[b>>2]=c;if((c|0)!=j[b+4>>2]){continue}break}}cc(b);Za=d+16|0;return}a=D()|0;C()|0;cc(b);G(a|0);z()}function vza(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;d=Za-16|0;Za=d;a:{b=wh(d,a+8|0,b);if(j[b>>2]!=j[b+4>>2]){while(1){c=j[a+16>>2];e=j[b>>2];j[114630]=0;F(944,c|0,e|0);c=j[114630];j[114630]=0;if((c|0)==1){break a}c=j[b>>2]+4|0;j[b>>2]=c;if((c|0)!=j[b+4>>2]){continue}break}}cc(b);Za=d+16|0;return}a=D()|0;C()|0;cc(b);G(a|0);z()}function qLa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;d=Za-16|0;Za=d;a:{b=yl(d,a+8|0,b);if(j[b>>2]!=j[b+4>>2]){while(1){c=j[a+16>>2];e=j[b>>2];j[114630]=0;F(425,c|0,e|0);c=j[114630];j[114630]=0;if((c|0)==1){break a}c=j[b>>2]+2|0;j[b>>2]=c;if((c|0)!=j[b+4>>2]){continue}break}}cc(b);Za=d+16|0;return}a=D()|0;C()|0;cc(b);G(a|0);z()}function aFa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;d=Za-16|0;Za=d;a:{b=wh(d,a+8|0,b);if(j[b>>2]!=j[b+4>>2]){while(1){c=j[a+16>>2];e=j[b>>2];j[114630]=0;F(740,c|0,e|0);c=j[114630];j[114630]=0;if((c|0)==1){break a}c=j[b>>2]+4|0;j[b>>2]=c;if((c|0)!=j[b+4>>2]){continue}break}}cc(b);Za=d+16|0;return}a=D()|0;C()|0;cc(b);G(a|0);z()}function RW(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;d=Za-16|0;Za=d;a:{b=yB(d,a+8|0,b);if(j[b>>2]!=j[b+4>>2]){while(1){c=j[a+16>>2];e=j[b>>2];j[114630]=0;F(216,c|0,e|0);c=j[114630];j[114630]=0;if((c|0)==1){break a}c=j[b>>2]+16|0;j[b>>2]=c;if((c|0)!=j[b+4>>2]){continue}break}}cc(b);Za=d+16|0;return}a=D()|0;C()|0;cc(b);G(a|0);z()}function Qja(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;d=Za-16|0;Za=d;a:{b=op(d,a,b);if(j[b+4>>2]!=j[b+8>>2]){while(1){c=hb(a);e=j[b+4>>2];j[114630]=0;F(1574,c|0,e|0);c=j[114630];j[114630]=0;if((c|0)==1){break a}c=j[b+4>>2]+6|0;j[b+4>>2]=c;if((c|0)!=j[b+8>>2]){continue}break}}ub(b);Za=d+16|0;return}a=D()|0;C()|0;ub(b);G(a|0);z()}function ICa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;d=Za-16|0;Za=d;a:{b=wh(d,a+8|0,b);if(j[b>>2]!=j[b+4>>2]){while(1){c=j[a+16>>2];e=j[b>>2];j[114630]=0;F(820,c|0,e|0);c=j[114630];j[114630]=0;if((c|0)==1){break a}c=j[b>>2]+4|0;j[b>>2]=c;if((c|0)!=j[b+4>>2]){continue}break}}cc(b);Za=d+16|0;return}a=D()|0;C()|0;cc(b);G(a|0);z()}function Hia(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=q(0),f=0,g=0,h=q(0);c=Za-32|0;Za=c;lj(a,c+24|0);f=c,g=Tc(j[c+24>>2],j[c+28>>2]),j[f+16>>2]=g;j[c+12>>2]=256;Wk(b,j[tb(c+16|0,c+12|0)>>2]);if(sb(b)){while(1){j[c+16>>2]=0;jo(a,c+16|0);e=n[c+16>>2];f=xb(b,d),h=e,n[f>>2]=h;d=d+1|0;if(sb(b)>>>0>d>>>0){continue}break}}Za=c+32|0}function Ewa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;d=Za-16|0;Za=d;a:{b=_d(d,a,b);if(j[b+4>>2]!=j[b+8>>2]){while(1){c=hb(a);e=j[b+4>>2];j[114630]=0;F(1051,c|0,e|0);c=j[114630];j[114630]=0;if((c|0)==1){break a}c=j[b+4>>2]+4|0;j[b+4>>2]=c;if((c|0)!=j[b+8>>2]){continue}break}}ub(b);Za=d+16|0;return}a=D()|0;C()|0;ub(b);G(a|0);z()}function Bra(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;d=Za-16|0;Za=d;a:{b=Wp(d,a,b);if(j[b+4>>2]!=j[b+8>>2]){while(1){c=hb(a);e=j[b+4>>2];j[114630]=0;F(1222,c|0,e|0);c=j[114630];j[114630]=0;if((c|0)==1){break a}c=j[b+4>>2]+8|0;j[b+4>>2]=c;if((c|0)!=j[b+8>>2]){continue}break}}ub(b);Za=d+16|0;return}a=D()|0;C()|0;ub(b);G(a|0);z()}function ALa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;d=Za-16|0;Za=d;a:{b=yl(d,a+8|0,b);if(j[b>>2]!=j[b+4>>2]){while(1){c=j[a+16>>2];e=j[b>>2];j[114630]=0;F(420,c|0,e|0);c=j[114630];j[114630]=0;if((c|0)==1){break a}c=j[b>>2]+2|0;j[b>>2]=c;if((c|0)!=j[b+4>>2]){continue}break}}cc(b);Za=d+16|0;return}a=D()|0;C()|0;cc(b);G(a|0);z()}function xX(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;if(Qf(a,j[b+8>>2],e)){vu(b,c,d);return}a:{if(!Qf(a,j[b>>2],e)){break a}if(!(j[b+20>>2]!=(c|0)?j[b+16>>2]!=(c|0):0)){if((d|0)!=1){break a}j[b+32>>2]=1;return}j[b+20>>2]=c;j[b+32>>2]=d;j[b+40>>2]=j[b+40>>2]+1;if(!(j[b+36>>2]!=1|j[b+24>>2]!=2)){h[b+54|0]=1}j[b+44>>2]=4}}function nea(a,b,c){var d=0,e=0,f=0,g=0,h=0,k=0,l=0,m=0;e=j[a+4144>>2];f=j[a+4140>>2];if(c){h=i[a+4188>>1];while(1){d=g<<3;k=(d|4)+b|0;m=j[k>>2];d=b+d|0;l=j[d>>2]>>12;f=(p(l-f|0,h)>>15)+l|0;j[d>>2]=f;d=m>>12;e=(p(d-e|0,h)>>15)+d|0;j[k>>2]=e;g=g+1|0;if((g|0)!=(c|0)){continue}break}}j[a+4144>>2]=e;j[a+4140>>2]=f;return c}function WT(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;d=Za-16|0;Za=d;a:{b=Hs(d,a+8|0,b);if(j[b>>2]!=j[b+4>>2]){while(1){c=j[a+16>>2];e=j[b>>2];j[114630]=0;F(365,c|0,e|0);c=j[114630];j[114630]=0;if((c|0)==1){break a}c=j[b>>2]+1|0;j[b>>2]=c;if((c|0)!=j[b+4>>2]){continue}break}}cc(b);Za=d+16|0;return}a=D()|0;C()|0;cc(b);G(a|0);z()}function SS(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;d=Za-16|0;Za=d;a:{b=Ql(d,a,b);if(j[b+4>>2]!=j[b+8>>2]){while(1){c=hb(a);e=j[b+4>>2];j[114630]=0;F(418,c|0,e|0);c=j[114630];j[114630]=0;if((c|0)==1){break a}c=j[b+4>>2]+16|0;j[b+4>>2]=c;if((c|0)!=j[b+8>>2]){continue}break}}ub(b);Za=d+16|0;return}a=D()|0;C()|0;ub(b);G(a|0);z()}function SBa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;d=Za-16|0;Za=d;a:{b=_d(d,a,b);if(j[b+4>>2]!=j[b+8>>2]){while(1){c=hb(a);e=j[b+4>>2];j[114630]=0;F(875,c|0,e|0);c=j[114630];j[114630]=0;if((c|0)==1){break a}c=j[b+4>>2]+4|0;j[b+4>>2]=c;if((c|0)!=j[b+8>>2]){continue}break}}ub(b);Za=d+16|0;return}a=D()|0;C()|0;ub(b);G(a|0);z()}function PCa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;d=Za-16|0;Za=d;a:{b=Hs(d,a+8|0,b);if(j[b>>2]!=j[b+4>>2]){while(1){c=j[a+16>>2];e=j[b>>2];j[114630]=0;F(38,c|0,e|0);c=j[114630];j[114630]=0;if((c|0)==1){break a}c=j[b>>2]+1|0;j[b>>2]=c;if((c|0)!=j[b+4>>2]){continue}break}}cc(b);Za=d+16|0;return}a=D()|0;C()|0;cc(b);G(a|0);z()}function MW(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;d=Za-16|0;Za=d;a:{b=Hs(d,a+8|0,b);if(j[b>>2]!=j[b+4>>2]){while(1){c=j[a+16>>2];e=j[b>>2];j[114630]=0;F(218,c|0,e|0);c=j[114630];j[114630]=0;if((c|0)==1){break a}c=j[b>>2]+1|0;j[b>>2]=c;if((c|0)!=j[b+4>>2]){continue}break}}cc(b);Za=d+16|0;return}a=D()|0;C()|0;cc(b);G(a|0);z()}function EIa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;d=Za-16|0;Za=d;a:{b=op(d,a,b);if(j[b+4>>2]!=j[b+8>>2]){while(1){c=hb(a);e=j[b+4>>2];j[114630]=0;F(569,c|0,e|0);c=j[114630];j[114630]=0;if((c|0)==1){break a}c=j[b+4>>2]+6|0;j[b+4>>2]=c;if((c|0)!=j[b+8>>2]){continue}break}}ub(b);Za=d+16|0;return}a=D()|0;C()|0;ub(b);G(a|0);z()}function DT(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;d=Za-16|0;Za=d;a:{b=wh(d,a+8|0,b);if(j[b>>2]!=j[b+4>>2]){while(1){c=j[a+16>>2];e=j[b>>2];j[114630]=0;F(371,c|0,e|0);c=j[114630];j[114630]=0;if((c|0)==1){break a}c=j[b>>2]+4|0;j[b>>2]=c;if((c|0)!=j[b+4>>2]){continue}break}}cc(b);Za=d+16|0;return}a=D()|0;C()|0;cc(b);G(a|0);z()}function zF(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;e=Za-48|0;Za=e;j[e+40>>2]=c;j[e+44>>2]=b;j[e+36>>2]=d;b=j[a+8>>2];j[e+28>>2]=e+36;j[e+24>>2]=e+40;c=j[e+28>>2];j[e+8>>2]=j[e+24>>2];j[e+12>>2]=c;j[e+16>>2]=a;j[e+20>>2]=e+44;c=j[e+20>>2];j[e>>2]=j[e+16>>2];j[e+4>>2]=c;g7(b,e);j[a+4>>2]=j[a+4>>2]+j[e+36>>2];Za=e+48|0}function yF(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;e=Za-48|0;Za=e;j[e+40>>2]=c;j[e+44>>2]=b;j[e+36>>2]=d;b=j[a+8>>2];j[e+28>>2]=e+36;j[e+24>>2]=e+40;c=j[e+28>>2];j[e+8>>2]=j[e+24>>2];j[e+12>>2]=c;j[e+16>>2]=a;j[e+20>>2]=e+44;c=j[e+20>>2];j[e>>2]=j[e+16>>2];j[e+4>>2]=c;f7(b,e);j[a+4>>2]=j[a+4>>2]+j[e+36>>2];Za=e+48|0}function rA(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;d=Za-16|0;Za=d;a:{b=vl(d,a,b);if(j[b+4>>2]!=j[b+8>>2]){while(1){c=hb(a);e=j[b+4>>2];j[114630]=0;F(365,c|0,e|0);c=j[114630];j[114630]=0;if((c|0)==1){break a}c=j[b+4>>2]+1|0;j[b+4>>2]=c;if((c|0)!=j[b+8>>2]){continue}break}}ub(b);Za=d+16|0;return}a=D()|0;C()|0;ub(b);G(a|0);z()}function pL(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0;e=Za-16|0;Za=e;a:{if(Yb(Jo(a))>>>0<=b>>>0){break a}b:{c:{if(ec(a)>>>0>b>>>0){if(m[ad(a,b)+4>>2]>c>>>0){break c}}if(!d){break a}yx(a,b,c,1);break b}Nd(e+8|0,ad(a,b),c);f=kb(e+8|0);if(f|!d){break a}Nd(e+8|0,ad(a,b),c);Qd(e+8|0,1);qL(a,b,c)}f=0}Za=e+16|0;return f|0}function WV(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;d=Za-16|0;Za=d;a:{b=Wp(d,a,b);if(j[b+4>>2]!=j[b+8>>2]){while(1){c=hb(a);e=j[b+4>>2];j[114630]=0;F(270,c|0,e|0);c=j[114630];j[114630]=0;if((c|0)==1){break a}c=j[b+4>>2]+8|0;j[b+4>>2]=c;if((c|0)!=j[b+8>>2]){continue}break}}ub(b);Za=d+16|0;return}a=D()|0;C()|0;ub(b);G(a|0);z()}function WN(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;d=Za-16|0;Za=d;a:{b=_d(d,a,b);if(j[b+4>>2]!=j[b+8>>2]){while(1){c=hb(a);e=j[b+4>>2];j[114630]=0;F(944,c|0,e|0);c=j[114630];j[114630]=0;if((c|0)==1){break a}c=j[b+4>>2]+4|0;j[b+4>>2]=c;if((c|0)!=j[b+8>>2]){continue}break}}ub(b);Za=d+16|0;return}a=D()|0;C()|0;ub(b);G(a|0);z()}function Sfa(a){a=a|0;var b=0,c=0;c=Za-16|0;Za=c;b=we(j[a+16>>2]);b=ic(IMa(HMa(b,b>>31,3840,0),ab,1e3,0),ab);j[a+4276>>2]=b;j[114630]=0;j[c+12>>2]=0;I(1642,a+4260|0,b|0,c+12|0);b=j[114630];j[114630]=0;a:{if((b|0)==1){b=J(71412)|0;if((C()|0)!=(W(71412)|0)){break a}O(b|0)|0;j[a+4276>>2]=0;Q()}Za=c+16|0;return}G(b|0);z()}function HF(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;e=Za-48|0;Za=e;j[e+40>>2]=c;j[e+44>>2]=b;j[e+36>>2]=d;b=j[a+8>>2];j[e+28>>2]=e+36;j[e+24>>2]=e+40;c=j[e+28>>2];j[e+8>>2]=j[e+24>>2];j[e+12>>2]=c;j[e+16>>2]=a;j[e+20>>2]=e+44;c=j[e+20>>2];j[e>>2]=j[e+16>>2];j[e+4>>2]=c;_7(b,e);j[a+4>>2]=j[a+4>>2]+j[e+36>>2];Za=e+48|0}function GS(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;d=Za-16|0;Za=d;a:{b=yh(d,a,b);if(j[b+4>>2]!=j[b+8>>2]){while(1){c=hb(a);e=j[b+4>>2];j[114630]=0;F(420,c|0,e|0);c=j[114630];j[114630]=0;if((c|0)==1){break a}c=j[b+4>>2]+2|0;j[b+4>>2]=c;if((c|0)!=j[b+8>>2]){continue}break}}ub(b);Za=d+16|0;return}a=D()|0;C()|0;ub(b);G(a|0);z()}function GF(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;e=Za-48|0;Za=e;j[e+40>>2]=c;j[e+44>>2]=b;j[e+36>>2]=d;b=j[a+8>>2];j[e+28>>2]=e+36;j[e+24>>2]=e+40;c=j[e+28>>2];j[e+8>>2]=j[e+24>>2];j[e+12>>2]=c;j[e+16>>2]=a;j[e+20>>2]=e+44;c=j[e+20>>2];j[e>>2]=j[e+16>>2];j[e+4>>2]=c;Z7(b,e);j[a+4>>2]=j[a+4>>2]+j[e+36>>2];Za=e+48|0}function EF(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;e=Za-48|0;Za=e;j[e+40>>2]=c;j[e+44>>2]=b;j[e+36>>2]=d;b=j[a+8>>2];j[e+28>>2]=e+36;j[e+24>>2]=e+40;c=j[e+28>>2];j[e+8>>2]=j[e+24>>2];j[e+12>>2]=c;j[e+16>>2]=a;j[e+20>>2]=e+44;c=j[e+20>>2];j[e>>2]=j[e+16>>2];j[e+4>>2]=c;L7(b,e);j[a+4>>2]=j[a+4>>2]+j[e+36>>2];Za=e+48|0}function DF(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;e=Za-48|0;Za=e;j[e+40>>2]=c;j[e+44>>2]=b;j[e+36>>2]=d;b=j[a+8>>2];j[e+28>>2]=e+36;j[e+24>>2]=e+40;c=j[e+28>>2];j[e+8>>2]=j[e+24>>2];j[e+12>>2]=c;j[e+16>>2]=a;j[e+20>>2]=e+44;c=j[e+20>>2];j[e>>2]=j[e+16>>2];j[e+4>>2]=c;K7(b,e);j[a+4>>2]=j[a+4>>2]+j[e+36>>2];Za=e+48|0}function CF(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;e=Za-48|0;Za=e;j[e+40>>2]=c;j[e+44>>2]=b;j[e+36>>2]=d;b=j[a+8>>2];j[e+28>>2]=e+36;j[e+24>>2]=e+40;c=j[e+28>>2];j[e+8>>2]=j[e+24>>2];j[e+12>>2]=c;j[e+16>>2]=a;j[e+20>>2]=e+44;c=j[e+20>>2];j[e>>2]=j[e+16>>2];j[e+4>>2]=c;y7(b,e);j[a+4>>2]=j[a+4>>2]+j[e+36>>2];Za=e+48|0}function BF(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;e=Za-48|0;Za=e;j[e+40>>2]=c;j[e+44>>2]=b;j[e+36>>2]=d;b=j[a+8>>2];j[e+28>>2]=e+36;j[e+24>>2]=e+40;c=j[e+28>>2];j[e+8>>2]=j[e+24>>2];j[e+12>>2]=c;j[e+16>>2]=a;j[e+20>>2]=e+44;c=j[e+20>>2];j[e>>2]=j[e+16>>2];j[e+4>>2]=c;v7(b,e);j[a+4>>2]=j[a+4>>2]+j[e+36>>2];Za=e+48|0}function qT(a){var b=0,c=0,d=0;a:{if(k[a+110|0]>64|((k[a|0]|k[a+1|0]<<8)!=20042?(k[a|0]|k[a+1|0]<<8)!=26217:0)|(h[a+112|0]<0|k[a+111|0]>128)){break a}while(1){b=a+c|0;d=h[b+113|0];if(!(((d&255)>>>0<254?(d|0)<=-1:0)|(k[b+241|0]?0:(d|0)>=0)|k[b+369|0]>=64)){b=1;c=c+1|0;if((c|0)!=128){continue}break a}break}b=0}return b}function _z(a,b){var c=0,d=0,e=0,f=0;c=Za-16|0;Za=c;a:{if(!b){break a}if(!yb(a,b)){break a}while(1){h[c+11|0]=0;f=(c+12|0)+d|0;if(b>>>0>d>>>0){Ff(a,c+11|0);e=k[c+11|0]}else{e=0}h[f|0]=e;d=d+1|0;if((d|0)!=4){continue}break}j[c+4>>2]=j[c+12>>2];a=c+4|0;d=k[a|0]|k[a+1|0]<<8|(k[a+2|0]<<16|k[a+3|0]<<24)}Za=c+16|0;return d}function Fda(a){a=a|0;var b=0;j[114630]=0;N(2010,a|0);b=j[114630];j[114630]=0;if((b|0)!=1){return j[a+16>>2]}b=J(0)|0;C()|0;O(b|0)|0;j[114630]=0;L(1984,34861,a|0,0,0);a=j[114630];j[114630]=0;if((a|0)!=1){Q();return-1}a=D()|0;C()|0;j[114630]=0;M(20);b=j[114630];j[114630]=0;if((b|0)!=1){G(a|0);z()}J(0)|0;C()|0;ib();z()}function FR(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;d=Za-16|0;Za=d;a:{b=vl(d,a,b);if(j[b+4>>2]!=j[b+8>>2]){while(1){c=hb(a);e=j[b+4>>2];j[114630]=0;F(38,c|0,e|0);c=j[114630];j[114630]=0;if((c|0)==1){break a}c=j[b+4>>2]+1|0;j[b+4>>2]=c;if((c|0)!=j[b+8>>2]){continue}break}}ub(b);Za=d+16|0;return}a=D()|0;C()|0;ub(b);G(a|0);z()}function jca(a){a=a|0;var b=0;j[114630]=0;N(2083,a|0);b=j[114630];j[114630]=0;a:{if((b|0)==1){b=J(0)|0;C()|0;O(b|0)|0;j[114630]=0;L(1984,37320,a|0,0,0);a=j[114630];j[114630]=0;if((a|0)==1){break a}Q();a=0}return a|0}a=D()|0;C()|0;j[114630]=0;M(20);b=j[114630];j[114630]=0;if((b|0)!=1){G(a|0);z()}J(0)|0;C()|0;ib();z()}function YI(a){var b=0,c=0;a:{if((k[a|0]|k[a+1|0]<<8|(k[a+2|0]<<16|k[a+3|0]<<24))!=-1641380927){break a}b=a+12|0;if(!(k[b|0]|k[b+1|0]<<8|(k[b+2|0]<<16|k[b+3|0]<<24))){break a}b=a+20|0;if(!(k[b|0]|k[b+1|0]<<8|(k[b+2|0]<<16|k[b+3|0]<<24))){break a}a=a+28|0;c=(k[a|0]|k[a+1|0]<<8|(k[a+2|0]<<16|k[a+3|0]<<24))!=0}return c}function W5(a,b){var c=0,d=0,e=0,f=q(0),g=q(0),h=q(0),i=q(0);if((b|0)>=1){while(1){d=0;while(1){c=d<<2;e=c+a|0;c=c+48736|0;f=n[c>>2];g=n[e+72>>2];h=n[c+32>>2];c=(17-d<<2)+a|0;i=n[c>>2];n[e+72>>2]=q(f*g)-q(h*i);n[c>>2]=q(h*g)+q(f*i);d=d+1|0;if((d|0)!=8){continue}break}a=a+72|0;d=(b|0)>1;b=b-1|0;if(d){continue}break}}}function OG(a){var b=0;j[a+4116>>2]=0;j[a+4132>>2]=0;j[a+4136>>2]=0;i[a+4128>>1]=0;j[a+4104>>2]=0;j[a+4108>>2]=0;b=a+4140|0;j[b>>2]=0;j[b+4>>2]=0;b=a+4148|0;j[b>>2]=0;j[b+4>>2]=0;NG(a+4164|0);NG(a+4156|0);wo(a+54060|0);wo(a+62252|0);wo(a+70444|0);wo(a+78636|0);Ab(a+4332|0,0,32768);Sx(a+37100|0);Ab(a+37612|0,0,16384)}function xw(a,b,c){var d=0,e=0,f=0;e=Za-16|0;Za=e;a:{b=wja(e,a,b);if(j[b+4>>2]!=j[b+8>>2]){while(1){d=hb(a);f=j[b+4>>2];j[114630]=0;I(1576,d|0,f|0,c|0);d=j[114630];j[114630]=0;if((d|0)==1){break a}d=j[b+4>>2]+52|0;j[b+4>>2]=d;if((d|0)!=j[b+8>>2]){continue}break}}ub(b);Za=e+16|0;return}a=D()|0;C()|0;ub(b);G(a|0);z()}function sja(a,b){var c=0,d=0,e=0,f=0;c=Za-16|0;Za=c;hb(b);f=tI(a,c+8|0);a:{d=Lf(b);if(!d){break a}j[114630]=0;F(680,a|0,d|0);e=j[114630];j[114630]=0;if((e|0)!=1){e=j[b+4>>2];b=j[b>>2];j[114630]=0;L(1585,a|0,b|0,e|0,d|0);b=j[114630];j[114630]=0;if((b|0)!=1){break a}}a=D()|0;C()|0;Ts(f);G(a|0);z()}Za=c+16|0;return a}function eua(a,b,c,d){var e=0,f=0,g=0;a:{e=j[c>>2];f=j[d>>2];if(e|f){if(!b){break a}while(1){j[c>>2]=e-(((-2147483648-e>>>31|0)-1&255)+e>>8);j[d>>2]=j[d>>2]-(((-2147483648-f>>>31|0)-1&255)+f>>8);e=g<<3;j[e+a>>2]=j[c>>2];j[(e|4)+a>>2]=j[d>>2];g=g+1|0;if((g|0)==(b|0)){break a}f=j[d>>2];e=j[c>>2];continue}}EM(a,b<<1)}}function J8(a,b){var c=0,d=0,e=0;d=Za-16|0;Za=d;j[d+12>>2]=j[a+4>>2];c=j[b+4>>2];j[114630]=0;j[d+8>>2]=c;c=E(33,d+12|0,d+8|0)|0;e=j[114630];j[114630]=0;if((e|0)!=1){c=Cm(j[a>>2],j[b>>2],j[c>>2]);a:{if(c){break a}c=0;if(j[a+4>>2]==j[b+4>>2]){break a}c=m[a+4>>2]<m[b+4>>2]?-1:1}Za=d+16|0;return c}J(0)|0;C()|0;ib();z()}function Hsa(a,b){var c=0,d=0,e=0,f=0;c=Za-16|0;Za=c;hb(b);f=$L(a,c+8|0);a:{d=Yb(b);if(!d){break a}j[114630]=0;F(916,a|0,d|0);e=j[114630];j[114630]=0;if((e|0)!=1){e=j[b+4>>2];b=j[b>>2];j[114630]=0;L(1190,a|0,b|0,e|0,d|0);b=j[114630];j[114630]=0;if((b|0)!=1){break a}}a=D()|0;C()|0;ut(f);G(a|0);z()}Za=c+16|0;return a}function FEa(a,b){var c=0,d=0,e=0;d=ri(a+8|0);j[114630]=0;c=H(540,b|0)|0;e=j[114630];j[114630]=0;a:{b:{if((e|0)==1){break b}j[114630]=0;I(421,a|0,b|0,c|0);c=j[114630];j[114630]=0;if((c|0)==1){break b}a=j[a>>2];j[114630]=0;E(338,b|0,a|0)|0;a=j[114630];j[114630]=0;if((a|0)!=1){break a}}a=D()|0;C()|0;xg(d);G(a|0);z()}}function gK(a,b,c){var d=0,e=0,f=0;e=Za-16|0;Za=e;a:{b=ik(e,a,b);if(j[b+4>>2]!=j[b+8>>2]){while(1){d=hb(a);f=j[b+4>>2];j[114630]=0;I(1378,d|0,f|0,c|0);d=j[114630];j[114630]=0;if((d|0)==1){break a}d=j[b+4>>2]+24|0;j[b+4>>2]=d;if((d|0)!=j[b+8>>2]){continue}break}}ub(b);Za=e+16|0;return}a=D()|0;C()|0;ub(b);G(a|0);z()}function Ix(a,b,c){var d=0,e=0,f=0;e=Za-16|0;Za=e;a:{b=Cn(e,a,b);if(j[b+4>>2]!=j[b+8>>2]){while(1){d=hb(a);f=j[b+4>>2];j[114630]=0;I(1172,d|0,f|0,c|0);d=j[114630];j[114630]=0;if((d|0)==1){break a}d=j[b+4>>2]+32|0;j[b+4>>2]=d;if((d|0)!=j[b+8>>2]){continue}break}}ub(b);Za=e+16|0;return}a=D()|0;C()|0;ub(b);G(a|0);z()}function uM(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=Za-16|0;Za=c;e=Qta(a);a=b+236|0;b=ps(a);a:{if((a|0)!=(b|0)){while(1){d=l[a>>1];i[c+14>>1]=d;if(d){j[114630]=0;I(1158,c|0,e|0,c+14|0);d=j[114630];j[114630]=0;if((d|0)==1){break a}}a=a+2|0;if((b|0)!=(a|0)){continue}break}}Za=c+16|0;return}a=D()|0;C()|0;cp(e);G(a|0);z()}function sw(a,b,c){var d=0,e=0,f=0;e=Za-16|0;Za=e;a:{b=_d(e,a,b);if(j[b+4>>2]!=j[b+8>>2]){while(1){d=hb(a);f=j[b+4>>2];j[114630]=0;I(1599,d|0,f|0,c|0);d=j[114630];j[114630]=0;if((d|0)==1){break a}d=j[b+4>>2]+4|0;j[b+4>>2]=d;if((d|0)!=j[b+8>>2]){continue}break}}ub(b);Za=e+16|0;return}a=D()|0;C()|0;ub(b);G(a|0);z()}function a6(a,b,c){var d=0,e=0,f=0;d=k[a+769|0];e=p(d,72)+c|0;Vb(e+2304|0,e,p(k[a+768|0]-d|0,72));if(k[a+768|0]){e=0;while(1){d=0;while(1){f=(d<<2)+c|0;n[f>>2]=n[f>>2]*n[b>>2];f=f+2304|0;n[f>>2]=n[f>>2]*n[b+12>>2];d=d+1|0;if((d|0)!=12){continue}break}b=b+24|0;c=c+72|0;e=e+1|0;if(e>>>0<k[a+768|0]){continue}break}}}function Kja(a,b,c){var d=0,e=0,f=0;e=Za-16|0;Za=e;j[e+8>>2]=a;if((b|0)>=1){while(1){d=j[e+8>>2];a=c;f=k[a|0]|k[a+1|0]<<8|(k[a+2|0]<<16|k[a+3|0]<<24);h[d|0]=f;h[d+1|0]=f>>>8;h[d+2|0]=f>>>16;h[d+3|0]=f>>>24;a=k[a+4|0]|k[a+5|0]<<8;h[d+4|0]=a;h[d+5|0]=a>>>8;a=(b|0)>1;lk(e+8|0);b=b-1|0;if(a){continue}break}}Za=e+16|0}function nha(a,b){var c=0,d=0,e=0;d=Za-16|0;Za=d;a:{b=kha(d,a,b);if(j[b+4>>2]!=j[b+8>>2]){while(1){c=hb(a);e=j[b+4>>2];j[114630]=0;F(1645,c|0,e|0);c=j[114630];j[114630]=0;if((c|0)==1){break a}c=j[b+4>>2]+2048|0;j[b+4>>2]=c;if((c|0)!=j[b+8>>2]){continue}break}}ub(b);Za=d+16|0;return}a=D()|0;C()|0;ub(b);G(a|0);z()}function Vpa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0;e=Za-16|0;Za=e;j[e+12>>2]=c>>>2;j[e+8>>2]=j[a>>2];d=j[tb(e+12|0,e+8|0)>>2];b=lb(b);if(d){a=j[a+20>>2];c=d;while(1){lb(k[b|0]);lb(k[b+1|0]);f=a,g=lb(k[b+2|0])|lb(k[b+3|0])<<8,i[f>>1]=g;a=a+2|0;b=b+4|0;c=c-1|0;if(c){continue}break}}Za=e+16|0;return d<<2}function Upa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0;e=Za-16|0;Za=e;j[e+12>>2]=c>>>2;j[e+8>>2]=j[a>>2];d=j[tb(e+12|0,e+8|0)>>2];b=lb(b);if(d){a=j[a+20>>2];c=d;while(1){lb(k[b+3|0]);lb(k[b+2|0]);f=a,g=lb(k[b+1|0])|lb(k[b|0])<<8,i[f>>1]=g;a=a+2|0;b=b+4|0;c=c-1|0;if(c){continue}break}}Za=e+16|0;return d<<2}function HT(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;e=a;a=b+18|0;d=b+46|0;b=Kc(e,k[a|0]&2?16:8,1,0,(k[d|0]^-1)&1);if(!(!(k[a|0]&4)|c>>>0<532)){gA(b)}if(k[a|0]&8){ej(b,k[d|0]&4?5:4);return}if(!(k[a|0]&2|k[d|0]!=255)){ej(b,11);return}if(k[d|0]&2){h[b+2|0]=1}if(k[d|0]&4){ej(b,2)}if(!(!(k[d|0]&8)|!(k[a|0]&2))){ej(b,9)}}function iea(){var a=0,b=0;j[114630]=0;a=T(1983)|0;b=j[114630];j[114630]=0;a:{if((b|0)==1){a=J(0)|0;C()|0;O(a|0)|0;j[114630]=0;L(1984,34128,0,0,0);a=j[114630];j[114630]=0;if((a|0)==1){break a}Q();a=0}return a|0}b=D()|0;C()|0;j[114630]=0;M(20);a=j[114630];j[114630]=0;if((a|0)!=1){G(b|0);z()}J(0)|0;C()|0;ib();z()}function gea(){var a=0,b=0;j[114630]=0;a=T(1987)|0;b=j[114630];j[114630]=0;a:{if((b|0)==1){a=J(0)|0;C()|0;O(a|0)|0;j[114630]=0;L(1984,34156,0,0,0);a=j[114630];j[114630]=0;if((a|0)==1){break a}Q();a=0}return a|0}b=D()|0;C()|0;j[114630]=0;M(20);a=j[114630];j[114630]=0;if((a|0)!=1){G(b|0);z()}J(0)|0;C()|0;ib();z()}function Uda(){var a=0,b=0;j[114630]=0;a=T(1999)|0;b=j[114630];j[114630]=0;a:{if((b|0)==1){a=J(0)|0;C()|0;O(a|0)|0;j[114630]=0;L(1984,34568,0,0,0);a=j[114630];j[114630]=0;if((a|0)==1){break a}Q();a=0}return a|0}b=D()|0;C()|0;j[114630]=0;M(20);a=j[114630];j[114630]=0;if((a|0)!=1){G(b|0);z()}J(0)|0;C()|0;ib();z()}function mma(a,b,c){var d=0,e=0;d=Za-16|0;Za=d;a=a+1074308|0;mb(d+8|0,a,28);a:{if(kb(d+8|0)){j[c>>2]=j[c>>2]+i[b+788>>1];Md(c,0,64);break a}mb(d+8|0,a,1);e=kb(d+8|0);a=i[b+788>>1];if(e){j[c>>2]=a+j[c>>2];Md(c,0,256);break a}j[b+688>>2]=a+j[b+688>>2];Md(b+688|0,0,256);j[c>>2]=j[b+688>>2];i[b+788>>1]=0}Za=d+16|0}function lLa(a,b){var c=0;c=Za-32|0;Za=c;j[c+16>>2]=b;j[c+24>>2]=a;a:{b:{if(!rb(c+24|0,c+16|0)){break b}j[c+8>>2]=j[c+24>>2];if(!rb(Id(c+8|0),c+16|0)){break b}while(1){if(el(j[c+24>>2],j[c+8>>2])){a=j[c+24>>2];break a}j[c+24>>2]=j[c+8>>2];if(rb(Id(c+8|0),c+16|0)){continue}break}}a=j[c+16>>2]}Za=c+32|0;return a}function kJa(a,b){a=a|0;b=b|0;var c=0;Es(a,b);_i(b);a=k[b+3|0];a:{if((a|0)!=9){if((a|0)!=19){break a}a=k[b+5|0];c=a&240;if((c|0)!=128){if((c|0)!=64){if((c|0)!=48|a>>>0>49){break a}h[b+5|0]=159;h[b+3|0]=20;return}if((a|0)!=64){break a}h[b+3|0]=0;h[b|0]=254;return}h[b+3|0]=20;h[b+5|0]=a&15|160;return}h[b+3|0]=0}}function dua(a,b,c){var d=0,e=0,f=0,g=0,h=0;d=j[a+96>>2];e=j[a+92>>2];if(d|e){if(c){while(1){f=g<<3;h=f+b|0;e=e-(((-2147483648-e>>>31|0)-1&255)+e>>8)|0;j[h>>2]=e+j[h>>2];f=(f|4)+b|0;d=d-(((-2147483648-d>>>31|0)-1&255)+d>>8)|0;j[f>>2]=d+j[f>>2];g=g+1|0;if((g|0)!=(c|0)){continue}break}}j[a+96>>2]=d;j[a+92>>2]=e}}function aV(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0;e=Za-48|0;Za=e;En(a);j[a>>2]=77336;f=_g(e+40|0);XU(e+24|0,b,c,d);j[114630]=0;j[e+16>>2]=j[e+32>>2];b=j[e+28>>2];j[e+8>>2]=j[e+24>>2];j[e+12>>2]=b;K(287,a+12|0,f|0,e+8|0)|0;b=j[114630];j[114630]=0;if((b|0)!=1){Za=e+48|0;return a|0}a=D()|0;C()|0;G(a|0);z()}function Wza(a,b){a=a|0;b=b|0;var c=0;b=Za-16|0;Za=b;c=-1;a:{if(!jf(a,8)){break a}c=0;if(!Gz(a,16628,8)){break a}c=-1;if(!hj(a,b+8|0)){break a}a=b+8|4;c=0;if(!(k[a|0]|k[a+1|0]<<8|(k[a+2|0]<<16|k[a+3|0]<<24))){break a}c=!((k[b+8|0]|k[b+9|0]<<8|(k[b+10|0]<<16|k[b+11|0]<<24))&-2139062144)}a=c;Za=b+16|0;return a|0}function rxa(a,b){var c=0,d=0,e=0;d=Za-16|0;Za=d;a:{b=Ok(d,a,b);if(j[b+4>>2]!=j[b+8>>2]){while(1){c=hb(a);e=j[b+4>>2];j[114630]=0;F(1019,c|0,e|0);c=j[114630];j[114630]=0;if((c|0)==1){break a}c=j[b+4>>2]+12|0;j[b+4>>2]=c;if((c|0)!=j[b+8>>2]){continue}break}}ub(b);Za=d+16|0;return}a=D()|0;C()|0;ub(b);G(a|0);z()}function h6(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0;d=Za-16|0;Za=d;a=YE(a,d+8|0);e=nb(b);f=nb(c);b=zb(b);j[114630]=0;L(195,a|0,b|0,e|0,e+f|0);b=j[114630];j[114630]=0;a:{if((b|0)!=1){b=zb(c);j[114630]=0;K(196,a|0,b|0,f|0)|0;b=j[114630];j[114630]=0;if((b|0)!=1){break a}}b=D()|0;C()|0;gb(a);G(b|0);z()}Za=d+16|0}function ara(a,b){var c=0,d=0,e=0;d=Za-16|0;Za=d;a:{b=Ok(d,a,b);if(j[b+4>>2]!=j[b+8>>2]){while(1){c=hb(a);e=j[b+4>>2];j[114630]=0;F(1232,c|0,e|0);c=j[114630];j[114630]=0;if((c|0)==1){break a}c=j[b+4>>2]+12|0;j[b+4>>2]=c;if((c|0)!=j[b+8>>2]){continue}break}}ub(b);Za=d+16|0;return}a=D()|0;C()|0;ub(b);G(a|0);z()}function $Da(a,b){var c=0,d=0,e=0;d=Za-16|0;Za=d;a:{b=WDa(d,a,b);if(j[b+4>>2]!=j[b+8>>2]){while(1){c=hb(a);e=j[b+4>>2];j[114630]=0;F(764,c|0,e|0);c=j[114630];j[114630]=0;if((c|0)==1){break a}c=j[b+4>>2]+33|0;j[b+4>>2]=c;if((c|0)!=j[b+8>>2]){continue}break}}ub(b);Za=d+16|0;return}a=D()|0;C()|0;ub(b);G(a|0);z()}function sia(a,b){var c=0,d=0,e=0;d=Za-16|0;Za=d;a:{b=_d(d,a,b);if(j[b+4>>2]!=j[b+8>>2]){while(1){c=hb(a);e=j[b+4>>2];j[114630]=0;F(1616,c|0,e|0);c=j[114630];j[114630]=0;if((c|0)==1){break a}c=j[b+4>>2]+4|0;j[b+4>>2]=c;if((c|0)!=j[b+8>>2]){continue}break}}ub(b);Za=d+16|0;return}a=D()|0;C()|0;ub(b);G(a|0);z()}function nY(a,b){var c=0,d=0,e=0,f=0,g=0;f=Za-16|0;Za=f;d=a+8|0;Tl(a,a+4|0,d);c=a+12|0;while(1){if((b|0)!=(c|0)){if(rd(c,d)){j[f+12>>2]=j[c>>2];g=c;while(1){a:{e=d;j[g>>2]=j[e>>2];if((a|0)==(e|0)){e=a;break a}g=e;d=e-4|0;if(rd(f+12|0,d)){continue}}break}j[e>>2]=j[f+12>>2]}d=c;c=c+4|0;continue}break}Za=f+16|0}function eba(a,b){var c=0,d=0,e=0,f=0;c=Za-16|0;Za=c;hb(b);f=dba(a,c+8|0);a:{d=Zc(b);if(!d){break a}j[114630]=0;F(2116,a|0,d|0);e=j[114630];j[114630]=0;if((e|0)!=1){e=j[b+4>>2];b=j[b>>2];j[114630]=0;L(2117,a|0,b|0,e|0,d|0);a=j[114630];j[114630]=0;if((a|0)!=1){break a}}a=D()|0;C()|0;xG(f);G(a|0);z()}Za=c+16|0}function dha(a,b){var c=0,d=0,e=0;d=Za-16|0;Za=d;a:{b=_d(d,a,b);if(j[b+4>>2]!=j[b+8>>2]){while(1){c=hb(a);e=j[b+4>>2];j[114630]=0;F(1647,c|0,e|0);c=j[114630];j[114630]=0;if((c|0)==1){break a}c=j[b+4>>2]+4|0;j[b+4>>2]=c;if((c|0)!=j[b+8>>2]){continue}break}}ub(b);Za=d+16|0;return}a=D()|0;C()|0;ub(b);G(a|0);z()}function _Ea(a,b){var c=0,d=0,e=0;d=Za-16|0;Za=d;a:{b=kR(d,a,b);if(j[b+4>>2]!=j[b+8>>2]){while(1){c=hb(a);e=j[b+4>>2];j[114630]=0;F(741,c|0,e|0);c=j[114630];j[114630]=0;if((c|0)==1){break a}c=j[b+4>>2]+48|0;j[b+4>>2]=c;if((c|0)!=j[b+8>>2]){continue}break}}ub(b);Za=d+16|0;return}a=D()|0;C()|0;ub(b);G(a|0);z()}function WH(a){a=a|0;var b=0,c=0;c=Za-16|0;Za=c;b=j[a+4232>>2];b=(b>>>1)+(b>>>6)|0;j[a+4220>>2]=b;j[114630]=0;j[c+12>>2]=0;I(1642,a+4208|0,b<<1,c+12|0);b=j[114630];j[114630]=0;a:{if((b|0)==1){b=J(71412)|0;if((C()|0)!=(W(71412)|0)){break a}O(b|0)|0;j[a+4220>>2]=0;Q()}j[a+4224>>2]=0;Za=c+16|0;return}G(b|0);z()}function $3(a,b){var c=0,d=0,e=0;a:{b:{while(1){if(k[c+56176|0]!=(a|0)){d=87;c=c+1|0;if((c|0)!=87){continue}break b}break}d=c;if(c){break b}a=56272;break a}c=56272;while(1){e=k[c|0];a=c+1|0;c=a;if(e){continue}c=a;d=d-1|0;if(d){continue}break}}b=j[b+20>>2];if(b){b=F2(j[b>>2],j[b+4>>2],a)}else{b=0}return b?b:a}function zN(a,b){a=a|0;b=b|0;var c=0;c=Za-48|0;Za=c;j[a>>2]=0;j[a+4>>2]=0;j[c+44>>2]=0;hb(b);Hc(a+8|0,c+44|0,c+40|0);if(j[b+4>>2]){Ip(a,j[b+4>>2]);Zi(c+32|0,b);Xj(c+24|0,b);b=j[c+36>>2];j[c+16>>2]=j[c+32>>2];j[c+20>>2]=b;b=j[c+28>>2];j[c+8>>2]=j[c+24>>2];j[c+12>>2]=b;zya(a,c+16|0,c+8|0)}Za=c+48|0;return a|0}function sLa(a,b){var c=0,d=0,e=0;d=Za-16|0;Za=d;a:{b=yh(d,a,b);if(j[b+4>>2]!=j[b+8>>2]){while(1){c=hb(a);e=j[b+4>>2];j[114630]=0;F(425,c|0,e|0);c=j[114630];j[114630]=0;if((c|0)==1){break a}c=j[b+4>>2]+2|0;j[b+4>>2]=c;if((c|0)!=j[b+8>>2]){continue}break}}ub(b);Za=d+16|0;return}a=D()|0;C()|0;ub(b);G(a|0);z()}function nya(a){a=a|0;var b=0,c=0,d=0,e=0,f=0;b=Za-16|0;Za=b;e=ue(1);j[114630]=0;c=E(85,b|0,1434)|0;d=j[114630];j[114630]=0;a:{b:{if((d|0)!=1){j[114630]=0;d=E(86,e|0,c|0)|0;f=j[114630];j[114630]=0;if((f|0)==1){break b}Oxa(a,d);gb(c);Za=b+16|0;return}a=D()|0;C()|0;break a}a=D()|0;C()|0;gb(c)}Fb(e);G(a|0);z()}function gY(a,b,c,d){var e=0,f=0,g=0,i=0,k=0;g=Za-16|0;Za=g;f=nb(a);if(f>>>0>=b>>>0){if(c){e=sc(a);a:{if(e-f>>>0>=c>>>0){e=zb(a);i=f-b|0;if(!i){break a}k=b+e|0;Il(k+c|0,k,i);break a}xl(a,e,(c+f|0)-e|0,f,b,0,c);e=j[a>>2]}dy(b+e|0,c,d);b=a;a=c+f|0;Bg(b,a);h[g+15|0]=0;Sd(a+e|0,g+15|0)}Za=g+16|0;return}Sl();z()}function gAa(a,b){var c=0,d=0,e=0;d=Za-16|0;Za=d;a:{b=Wp(d,a,b);if(j[b+4>>2]!=j[b+8>>2]){while(1){c=hb(a);e=j[b+4>>2];j[114630]=0;F(922,c|0,e|0);c=j[114630];j[114630]=0;if((c|0)==1){break a}c=j[b+4>>2]+8|0;j[b+4>>2]=c;if((c|0)!=j[b+8>>2]){continue}break}}ub(b);Za=d+16|0;return}a=D()|0;C()|0;ub(b);G(a|0);z()}function cFa(a,b){var c=0,d=0,e=0;d=Za-16|0;Za=d;a:{b=_d(d,a,b);if(j[b+4>>2]!=j[b+8>>2]){while(1){c=hb(a);e=j[b+4>>2];j[114630]=0;F(740,c|0,e|0);c=j[114630];j[114630]=0;if((c|0)==1){break a}c=j[b+4>>2]+4|0;j[b+4>>2]=c;if((c|0)!=j[b+8>>2]){continue}break}}ub(b);Za=d+16|0;return}a=D()|0;C()|0;ub(b);G(a|0);z()}function Zpa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0;e=Za-16|0;Za=e;j[e+12>>2]=(c>>>0)/3;j[e+8>>2]=j[a>>2];d=j[tb(e+12|0,e+8|0)>>2];b=lb(b);if(d){a=j[a+20>>2];c=d;while(1){lb(k[b|0]);f=a,g=lb(k[b+1|0])|lb(k[b+2|0])<<8,i[f>>1]=g;a=a+2|0;b=b+3|0;c=c-1|0;if(c){continue}break}}Za=e+16|0;return p(d,3)|0}function Ypa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0;e=Za-16|0;Za=e;j[e+12>>2]=(c>>>0)/3;j[e+8>>2]=j[a>>2];d=j[tb(e+12|0,e+8|0)>>2];b=lb(b);if(d){a=j[a+20>>2];c=d;while(1){lb(k[b+2|0]);f=a,g=lb(k[b+1|0])|lb(k[b|0])<<8,i[f>>1]=g;a=a+2|0;b=b+3|0;c=c-1|0;if(c){continue}break}}Za=e+16|0;return p(d,3)|0}function TW(a,b){var c=0,d=0,e=0;d=Za-16|0;Za=d;a:{b=Ql(d,a,b);if(j[b+4>>2]!=j[b+8>>2]){while(1){c=hb(a);e=j[b+4>>2];j[114630]=0;F(216,c|0,e|0);c=j[114630];j[114630]=0;if((c|0)==1){break a}c=j[b+4>>2]+16|0;j[b+4>>2]=c;if((c|0)!=j[b+8>>2]){continue}break}}ub(b);Za=d+16|0;return}a=D()|0;C()|0;ub(b);G(a|0);z()}function Q1(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=q(0),f=0;d=Za-16|0;Za=d;a:{if((a|0)!=(b|0)){f=j[114604];j[114604]=0;Wd();e=t2(a,d+12|0);a=j[114604];b:{if(a){if(j[d+12>>2]!=(b|0)){break b}if((a|0)!=68){break a}j[c>>2]=4;break a}j[114604]=f;if(j[d+12>>2]==(b|0)){break a}}}j[c>>2]=4;e=q(0)}Za=d+16|0;return q(e)}function KCa(a,b){var c=0,d=0,e=0;d=Za-16|0;Za=d;a:{b=_d(d,a,b);if(j[b+4>>2]!=j[b+8>>2]){while(1){c=hb(a);e=j[b+4>>2];j[114630]=0;F(820,c|0,e|0);c=j[114630];j[114630]=0;if((c|0)==1){break a}c=j[b+4>>2]+4|0;j[b+4>>2]=c;if((c|0)!=j[b+8>>2]){continue}break}}ub(b);Za=d+16|0;return}a=D()|0;C()|0;ub(b);G(a|0);z()}function Hja(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0;d=Za-16|0;Za=d;j[d+12>>2]=b;a:{if(Pi(a)>>>0>=b>>>0){f=d,g=df(a),j[f+8>>2]=g;xja(j[a>>2],j[tb(d+12|0,d+8|0)>>2],c);e=j[d+8>>2];b=j[d+12>>2];if(e>>>0<b>>>0){xw(a,b-e|0,c);break a}AI(a,j[a>>2]+p(b,52)|0);break a}Gja(a);Eja(a,zI(a,b));xw(a,b,c)}Za=d+16|0}function BCa(a,b){var c=0,d=0,e=0;d=Za-16|0;Za=d;a:{b=yh(d,a,b);if(j[b+4>>2]!=j[b+8>>2]){while(1){c=hb(a);e=j[b+4>>2];j[114630]=0;F(827,c|0,e|0);c=j[114630];j[114630]=0;if((c|0)==1){break a}c=j[b+4>>2]+2|0;j[b+4>>2]=c;if((c|0)!=j[b+8>>2]){continue}break}}ub(b);Za=d+16|0;return}a=D()|0;C()|0;ub(b);G(a|0);z()}function vMa(a,b){var c=0;md(b,0);j[b+24>>2]=8363;c=a+13|0;j[b>>2]=k[c|0]|k[c+1|0]<<8|(k[c+2|0]<<16|k[c+3|0]<<24);c=a+17|0;j[b+4>>2]=k[c|0]|k[c+1|0]<<8|(k[c+2|0]<<16|k[c+3|0]<<24);a=a+21|0;a=k[a|0]|k[a+1|0]<<8|(k[a+2|0]<<16|k[a+3|0]<<24);a=a>>>0>m[b>>2]?j[b+4>>2]?a:0:a;j[b+8>>2]=a;if(a){i[b+34>>1]=2;Rm(b)}}function qwa(a){var b=0,c=0;b=Za-80|0;Za=b;j[b+76>>2]=0;c=Db(b- -64|0,18062);j[114630]=0;F(511,b+48|0,a|0);a=j[114630];j[114630]=0;a:{b:{c:{if((a|0)==1){break c}j[114630]=0;E(470,b+48|0,c|0)|0;a=j[114630];j[114630]=0;if((a|0)==1){break c}gb(c);break b}a=D()|0;C()|0;gb(c);break a}Za=b+80|0;return}G(a|0);z()}function NW(a,b){var c=0,d=0,e=0;d=Za-16|0;Za=d;a:{b=vl(d,a,b);if(j[b+4>>2]!=j[b+8>>2]){while(1){c=hb(a);e=j[b+4>>2];j[114630]=0;F(218,c|0,e|0);c=j[114630];j[114630]=0;if((c|0)==1){break a}c=j[b+4>>2]+1|0;j[b+4>>2]=c;if((c|0)!=j[b+8>>2]){continue}break}}ub(b);Za=d+16|0;return}a=D()|0;C()|0;ub(b);G(a|0);z()}function ET(a,b){var c=0,d=0,e=0;d=Za-16|0;Za=d;a:{b=_d(d,a,b);if(j[b+4>>2]!=j[b+8>>2]){while(1){c=hb(a);e=j[b+4>>2];j[114630]=0;F(371,c|0,e|0);c=j[114630];j[114630]=0;if((c|0)==1){break a}c=j[b+4>>2]+4|0;j[b+4>>2]=c;if((c|0)!=j[b+8>>2]){continue}break}}ub(b);Za=d+16|0;return}a=D()|0;C()|0;ub(b);G(a|0);z()}function u0(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;g=Za-32|0;Za=g;h=j[16167];j[g+24>>2]=j[16166];j[g+28>>2]=h;h=j[16165];j[g+16>>2]=j[16164];j[g+20>>2]=h;h=j[16163];j[g+8>>2]=j[16162];j[g+12>>2]=h;h=j[16161];j[g>>2]=j[16160];j[g+4>>2]=h;a=Fi(a,b,c,d,e,f,g,g+32|0);Za=g+32|0;return a|0}function lI(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0;d=Za-16|0;Za=d;j[d+12>>2]=b;a:{if(jd(a)>>>0>=b>>>0){f=d,g=sb(a),j[f+8>>2]=g;jia(j[a>>2],j[tb(d+12|0,d+8|0)>>2],c);e=j[d+8>>2];b=j[d+12>>2];if(e>>>0<b>>>0){sw(a,b-e|0,c);break a}vw(a,j[a>>2]+(b<<2)|0);break a}Oia(a);Nia(a,ie(a,b));sw(a,b,c)}Za=d+16|0}function Toa(a,b,c){var d=0,e=0,f=0,g=0;d=Za-16|0;Za=d;j[d+12>>2]=b;a:{if(Be(a)>>>0>=b>>>0){f=d,g=pd(a),j[f+8>>2]=g;ooa(j[a>>2],j[tb(d+12|0,d+8|0)>>2],c);e=j[d+8>>2];b=j[d+12>>2];if(e>>>0<b>>>0){gK(a,b-e|0,c);break a}b=j[a>>2]+p(b,24)|0;pd(a);hK(a,b);Wo(a);break a}qoa(a);poa(a,hk(a,b));gK(a,b,c)}Za=d+16|0}function Nr(a,b,c,d){var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0;e=Za-16|0;Za=e;if(b){mb(e+8|0,a+1074308|0,73);k=kb(e+8|0)?c- -64|0:c;c=120;i=Ao(a);l=i^-1;f=1;while(1){g=c>>>1|0;j=g+f|0;h=Zf(a,j,k,d);a:{if(!(h>>>0>b>>>0&l|!h|b>>>0>h>>>0&i)){c=g;break a}f=j+1|0;c=(g^-1)+c|0}if(c){continue}break}}Za=e+16|0;return f}function zja(a,b){a=a|0;b=b|0;var c=0,d=0;c=Za-48|0;Za=c;d=c+40|0;b=l[b>>1];h[d|0]=b;h[d+1|0]=b>>>8;qk(c+16|0,c+40|0);b=lb(j[c+16>>2]);qk(c+8|0,c+40|0);b=Yh(c+24|0,b,lb(j[c+8>>2]+2|0));j[114630]=0;E(1187,a|0,b|0)|0;a=j[114630];j[114630]=0;if((a|0)!=1){gb(b);Za=c+48|0;return}a=D()|0;C()|0;gb(b);G(a|0);z()}function zJ(a,b,c){var d=0,e=0,f=0,g=0;d=Za-16|0;Za=d;e=ti(b,c);a:{if(e>>>0<=Af(a)>>>0){j[d+12>>2]=c;if(tc(a)>>>0<e>>>0){j[d+12>>2]=b;f=d,g=tc(a)+j[d+12>>2]|0,j[f+12>>2]=g;Pe(b,j[d+12>>2],j[a>>2]);by(a,j[d+12>>2],c,e-tc(a)|0);break a}rR(a,Pe(b,c,j[a>>2]));break a}_K(a);rp(a,ul(a,e));by(a,b,c,e)}Za=d+16|0}function _ja(a,b,c){var d=0,e=0,f=0;d=Za-16|0;Za=d;e=(c-b|0)/6|0;a:{if(ki(a)>>>0>=e>>>0){j[d+12>>2]=c;if(Lf(a)>>>0<e>>>0){j[d+12>>2]=b;f=Lf(a);j[d+12>>2]=j[d+12>>2]+p(f,6);Aw(b,j[d+12>>2],j[a>>2]);zw(a,j[d+12>>2],c,e-Lf(a)|0);break a}Vy(a,Aw(b,c,j[a>>2]));break a}DI(a);uQ(a,Ly(a,e));zw(a,b,c,e)}Za=d+16|0}function Uf(a,b){var c=0,d=0,e=0,f=0,g=0,h=0;d=Za-16|0;Za=d;g=a;h=a;a:{if(!b){b=0;break a}c=b>>31;e=c+b^c;c=s(e);We(d,e,0,0,0,c+81|0);e=0+j[d+8>>2]|0;c=(j[d+12>>2]^65536)+(16414-c<<16)|0;c=e>>>0<f>>>0?c+1|0:c;f=b&-2147483648|c;c=j[d+4>>2];b=j[d>>2]}j[h>>2]=b;j[g+4>>2]=c;j[a+8>>2]=e;j[a+12>>2]=f;Za=d+16|0}function SZ(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0;f=Za-16|0;Za=f;j[e>>2]=c;a=Lu(f+12|0,0,b,j[a+8>>2]);c=2;a:{if(a+1>>>0<2){break a}b=a-1|0;c=1;if(b>>>0>d-j[e>>2]>>>0){break a}c=f+12|0;while(1){if(b){a=k[c|0];d=j[e>>2];j[e>>2]=d+1;h[d|0]=a;b=b-1|0;c=c+1|0;continue}break}c=0}Za=f+16|0;return c|0}function xd(a,b,c){var d=0,e=0,f=0,g=0;d=Za-16|0;Za=d;Ll(b);b=z_(d+8|0,b);a:{a=a+16|0;if(sb(a)>>>0<=c>>>0){j[114630]=0;F(2560,a|0,c+1|0);e=j[114630];j[114630]=0;if((e|0)==1){break a}}if(j[xb(a,c)>>2]){Kl(j[xb(a,c)>>2])}e=ud(b);f=xb(a,c),g=e,j[f>>2]=g;nC(b);Za=d+16|0;return}a=D()|0;C()|0;nC(b);G(a|0);z()}function sqa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0;d=Za-16|0;Za=d;j[d+12>>2]=c>>>1;j[d+8>>2]=j[a>>2];e=j[tb(d+12|0,d+8|0)>>2];b=lb(b);if(e){a=j[a+20>>2];c=e;while(1){f=a,g=lb(k[b|0])^128,h[f|0]=g;f=a,g=lb(k[b+1|0])^128,h[f+1|0]=g;a=a+2|0;b=b+2|0;c=c-1|0;if(c){continue}break}}Za=d+16|0;return e<<1}function rqa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0;e=Za-16|0;Za=e;j[e+12>>2]=c>>>1;j[e+8>>2]=j[a>>2];f=j[tb(e+12|0,e+8|0)>>2];b=lb(b);if(f){a=j[a+20>>2];c=f;g=d;while(1){g=lb(k[b|0])+g|0;h[a|0]=g;d=lb(k[b+1|0])+d|0;h[a+1|0]=d;a=a+2|0;b=b+2|0;c=c-1|0;if(c){continue}break}}Za=e+16|0;return f<<1}function dfa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;b=Th(a,b,c,d);j[a+4208>>2]=1017370378;j[a+4212>>2]=0;j[a>>2]=81444;j[114630]=0;K(1634,a+44|0,2,2)|0;c=j[114630];j[114630]=0;a:{if((c|0)==1){break a}j[114630]=0;N(1635,b|0);c=j[114630];j[114630]=0;if((c|0)==1){break a}return a|0}a=D()|0;C()|0;Ke(b);G(a|0);z()}function NB(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0;d=Za-16|0;Za=d;a=bw(a,d+8|0);e=ne(b);f=nb(c);j[114630]=0;L(2842,a|0,b|0,e|0,e+f|0);b=j[114630];j[114630]=0;a:{if((b|0)!=1){b=zb(c);j[114630]=0;K(2493,a|0,b|0,f|0)|0;b=j[114630];j[114630]=0;if((b|0)!=1){break a}}b=D()|0;C()|0;gb(a);G(b|0);z()}Za=d+16|0}function $u(a){var b=0,c=0,d=0,e=0;e=ne(a);a:{if(!j[115415]|!k[a|0]){break a}b=D2(a);if(k[b|0]==61?b:0){break a}b=j[j[115415]>>2];if(!b){break a}b:{while(1){d=V4(a,b,e);b=j[115415];if(!d){d=j[b+(c<<2)>>2]+e|0;if(k[d|0]==61){break b}}c=c+1|0;b=j[b+(c<<2)>>2];if(b){continue}break}return 0}c=d+1|0}return c}function yBa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0;c=Za+ -64|0;Za=c;b=-1;a:{if(!jf(a,1084)){break a}Yj(a,1080);PO(a,c+60|0);d=OO(c+40|0);b=0;if(!NO(c+60|0,d)){break a}Yj(a,20);b=1;while(1){MO(a,c+8|0);e=wy(c+8|0)+e|0;f=b&65535;b=b+1|0;if(f>>>0<31){continue}break}b=m[d+4>>2]>=e>>>0}Za=c- -64|0;return b|0}function SKa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;d=Za-16|0;Za=d;a:{b:{if(!jf(a,7)){break b}c=0;if(!vS(a,12222)){break a}if(!jf(a,1)){break b}c=-1;if(!Fc(a,st(a))){break a}c=d+8|0;e=vKa(a,c);if(!e){dS(c)}c=-1;if(!e){break a}c=0;if(!rS(d+8|0)){break a}c=Me(a,b,qS(d+8|0),ab);break a}c=-1}Za=d+16|0;return c|0}function CQ(a,b){var c=0,d=0,e=0,f=0,g=0;d=Za-16|0;Za=d;c=a+4|0;a:{if(tc(c)>>>0>=j[a+16>>2]+b>>>0){break a}if(!tc(c)){fk(c,az(j[a+16>>2]+b|0,65536));break a}f=d,g=tc(c),j[f+12>>2]=g;e=yQ(d+12|0);a=j[a+16>>2]+b|0;if(e>>>0<a>>>0){fk(c,az(a,65536));break a}f=d,g=tc(c),j[f+8>>2]=g;fk(c,yQ(d+8|0))}Za=d+16|0}function uK(a,b,c){var d=0,e=0,f=0,g=0,i=0;e=j[a+1074416>>2];a=j[a+1074392>>2];h[b+872|0]=k[b+872|0]|8;g=b;d=a?k[b+833|0]:0;i=(c|0)>-1?0-d|0:d;f=(+(a>>>0)+1)*+(c|0)/+(e>>>0);a:{if(r(f)<2147483648){d=~~f;break a}d=-2147483648}j[g+876>>2]=i+(d+j[b+876>>2]|0);c=(a+1|0)==(e|0)?c:d;a=c>>31;h[b+833|0]=a^a+c}function gra(a,b,c){var d=0,e=0,f=0,g=0,h=0;d=Za-16|0;Za=d;f=a+12|0;jM(d+8|0,f);mL(d,f);a:{if(!is(d+8|0,d)|(c|0)==-1){break a}while(1){g=j[fra(d+8|0)>>2];yx(a,b,g,0);e=d+8|0;h=j[e+4>>2];j[d>>2]=j[e>>2];j[d+4>>2]=h;lL(e+4|0);mL(d,f);e=is(d+8|0,d);if((c|0)==(g|0)){break a}if(e){continue}break}}Za=d+16|0}function Rd(a){var b=q(0),c=q(0),d=0,e=0;d=(SMa(a),OMa(2));e=d>>>23&255;if(e>>>0<=149){if(e>>>0<=125){return q(a*q(0))}a=(d|0)>-1?a:q(-a);b=q(q(q(a+q(8388608))+q(-8388608))-a);a:{if(!(b>q(.5)^1)){c=q(q(a+b)+q(-1));break a}a=q(a+b);c=a;if(b<=q(-.5)^1){break a}c=q(a+q(1))}a=c;a=(d|0)>-1?a:q(-a)}return a}function Lqa(a){if(!(a<0x8000000000000000)){ab=2147483647;return-1}if(!(a>-0x8000000000000000)){ab=-2147483648;return 0}if(r(a)<0x8000000000000000){ab=r(a)>=1?a>0?~~t(v(a*2.3283064365386963e-10),4294967295)>>>0:~~w((a- +(~~a>>>0>>>0))*2.3283064365386963e-10)>>>0:0;return~~a>>>0}ab=-2147483648;return 0}function xt(a,b,c,d,e){var f=0,g=0,h=0,m=0,n=0;f=Za-16|0;Za=f;j[f+12>>2]=c;jc(f+12|0,256);jc(f+12|0,65535);h=l[f+12>>1];bg(a,h);if(h){c=0;while(1){g=k[b+c|0];a:{if((g|0)==(d|0)){g=65535;break a}if((e|0)!=(g|0)){break a}g=65534}m=nk(a,c),n=g,i[m>>1]=n;c=c+1|0;if((h|0)!=(c|0)){continue}break}}Za=f+16|0}function ksa(a,b,c,d){var e=0,f=0;e=Za-16|0;Za=e;a:{if(!k[a+530|0]){break a}f=HMa(d,0,6169,0);d=ab;d=Tc((d&65535)<<16|f>>>16,d>>>16|0);if(!c){break a}while(1){ssa(j[a>>2],e+14|0,e+12|0);j[b>>2]=j[b>>2]+p(d,i[e+14>>1]);j[b+4>>2]=j[b+4>>2]+p(d,i[e+12>>1]);b=b+8|0;c=c-1|0;if(c){continue}break}}Za=e+16|0}function kn(a,b,c,d,e){var f=0,g=0,h=0,m=0,n=0;f=Za-16|0;Za=f;j[f+12>>2]=c;jc(f+12|0,128);jc(f+12|0,65535);h=l[f+12>>1];bg(a,h);if(h){c=0;while(1){g=k[b+c|0];a:{if((g|0)==(d|0)){g=65535;break a}if((e|0)!=(g|0)){break a}g=65534}m=nk(a,c),n=g,i[m>>1]=n;c=c+1|0;if((h|0)!=(c|0)){continue}break}}Za=f+16|0}function jra(a,b,c,d){var e=0;e=Za-32|0;Za=e;a:{if(k[d|0]){d=j[b+4>>2];j[e+24>>2]=j[b>>2];j[e+28>>2]=d;b=ci(c,b);c=j[e+28>>2];j[e+8>>2]=j[e+24>>2];j[e+12>>2]=c;ira(a,e+8|0,b);break a}d=j[b+4>>2];j[e+16>>2]=j[b>>2];j[e+20>>2]=d;b=ci(c,b);c=j[e+20>>2];j[e>>2]=j[e+16>>2];j[e+4>>2]=c;hra(a,e,b)}Za=e+32|0}function iua(a,b,c,d,e){var f=q(0),g=0,h=0,i=0;if(d){while(1){h=c;f=q(n[a>>2]*e);a:{if(q(r(f))<q(2147483648)){g=~~f;break a}g=-2147483648}j[h>>2]=g;h=c;f=q(n[b>>2]*e);b:{if(q(r(f))<q(2147483648)){g=~~f;break b}g=-2147483648}j[h+4>>2]=g;c=c+8|0;b=b+4|0;a=a+4|0;i=i+1|0;if((i|0)!=(d|0)){continue}break}}}function Ina(a,b){var c=0,d=0;a=Le(a);c=nb(b);j[114630]=0;F(113,a|0,c|0);c=j[114630];j[114630]=0;if((c|0)!=1){a:{if(nb(b)){while(1){c=k[Ub(b,d)|0];j[114630]=0;F(112,a|0,c|0);c=j[114630];j[114630]=0;if((c|0)==1){break a}d=d+1|0;if(nb(b)>>>0>d>>>0){continue}break}}return}}b=D()|0;C()|0;pc(a);G(b|0);z()}function p9(a){a=a|0;var b=0,c=0;b=Za-32|0;Za=b;a:{b:{if(Ph(a)){go(b+24|0);break b}qm(b+8|0,a);j[114630]=0;F(2169,b+24|0,b+8|0);c=j[114630];j[114630]=0;if((c|0)==1){break a}Ye(b+8|0)}c=a+36|0;c:{if(Ph(a)){break c}c=j[b+24>>2]}a=pd(c);Gj(b+24|0);Za=b+32|0;return a|0}a=D()|0;C()|0;Ye(b+8|0);G(a|0);z()}function ena(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0;d=Za-16|0;Za=d;j[d+12>>2]=b;a:{if(Af(a)>>>0>=b>>>0){f=d,g=tc(a),j[f+8>>2]=g;dj(j[a>>2],j[tb(d+12|0,d+8|0)>>2],c);e=j[d+8>>2];b=j[d+12>>2];if(e>>>0<b>>>0){dt(a,b-e|0,c);break a}Ot(a,b+j[a>>2]|0);break a}dna(a);rp(a,ul(a,b));dt(a,b,c)}Za=d+16|0}function aJ(a,b,c){var d=0,e=0,f=0,g=0;f=Za-16|0;Za=f;e=ti(b,c);if(e>>>0<=4294967279){a:{if(e>>>0<=10){Ue(a,e);d=a;break a}g=Fk(e)+1|0;d=Rh(g);lf(a,d);lg(a,g);ee(a,e)}if((b|0)!=(c|0)){while(1){Sd(d,b);d=d+1|0;b=b+1|0;if((c|0)!=(b|0)){continue}break}}h[f+15|0]=0;Sd(d,f+15|0);Za=f+16|0;return}jg();z()}function N1(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0;d=Za-16|0;Za=d;a:{if((a|0)!=(b|0)){f=j[114604];j[114604]=0;Wd();e=s2(a,d+12|0);a=j[114604];b:{if(a){if(j[d+12>>2]!=(b|0)){break b}if((a|0)!=68){break a}j[c>>2]=4;break a}j[114604]=f;if(j[d+12>>2]==(b|0)){break a}}}j[c>>2]=4;e=0}Za=d+16|0;return+e}function Cqa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0;e=Za-16|0;Za=e;j[e+12>>2]=c>>>1;j[e+8>>2]=j[a>>2];f=j[tb(e+12|0,e+8|0)>>2];b=lb(b);if(f){a=j[a+20>>2];c=f;while(1){g=lb(k[b|0])+d|0;d=g+lb(k[b+1|0])|0;i[a>>1]=d<<8|g&255;a=a+2|0;b=b+2|0;c=c-1|0;if(c){continue}break}}Za=e+16|0;return f<<1}function ooa(a,b,c){var d=0,e=0,f=0;if(b){while(1){d=c;e=j[d+4>>2];j[a>>2]=j[d>>2];j[a+4>>2]=e;e=l[d+18>>1]|l[d+20>>1]<<16;f=l[d+14>>1]|l[d+16>>1]<<16;i[a+14>>1]=f;i[a+16>>1]=f>>>16;i[a+18>>1]=e;i[a+20>>1]=e>>>16;e=j[d+12>>2];j[a+8>>2]=j[d+8>>2];j[a+12>>2]=e;a=a+24|0;b=b-1|0;if(b){continue}break}}}function a5(a,b,c,d,e){var f=0,g=0,h=0,i=q(0),l=q(0);g=KE(a,b);a:{if((g|0)<0){break a}f=1;a=j[b>>2];h=(a|0)<(d|0)?a:d;if((h|0)<1){break a}a=p(a,g);d=0;while(1){f=(p(d,e)<<2)+c|0;l=q(n[j[b+28>>2]+(a+d<<2)>>2]+i);n[f>>2]=n[f>>2]+l;i=k[b+22|0]?l:i;f=1;d=d+1|0;if((h|0)!=(d|0)){continue}break}}return f}function RZ(a){a=a|0;var b=0,c=0;b=j[a+8>>2];j[114630]=0;b=P(2576,0,0,4,b|0)|0;c=j[114630];j[114630]=0;a:{if((c|0)==1){break a}b:{if(b){a=-1}else{a=j[a+8>>2];if(a){break b}a=1}return a|0}j[114630]=0;a=H(2577,a|0)|0;b=j[114630];j[114630]=0;if((b|0)==1){break a}return(a|0)==1|0}J(0)|0;C()|0;ib();z()}function Ei(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0;c=Za-48|0;Za=c;a:{if(!b){b=1;if(gd(a,5)){break a}b=wC(c+32|0);e=j[a+8>>2];f=j[d>>2];j[b+4>>2]=f-e;Ve(c,j[a+28>>2]);DC(c+16|0,c,j[d>>2],j[d+4>>2]);j[b+8>>2]=j[c+24>>2]}j[a>>2]=j[a>>2]|134217728;j[a+20>>2]=j[a+20>>2]+1;b=0}Za=c+48|0;return b|0}function voa(a,b){var c=0,d=0,e=0,f=0;c=Za-16|0;Za=c;j[114630]=0;H(1372,a+4|0)|0;d=j[114630];j[114630]=0;a:{b:{if((d|0)!=1){j[114630]=0;j[c+12>>2]=0;K(1373,a+8|0,c+12|0,b|0)|0;b=j[114630];j[114630]=0;if((b|0)!=1){break b}break a}break a}e=a,f=Rb(a),j[e>>2]=f;Za=c+16|0;return}J(0)|0;C()|0;ib();z()}function sGa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=Za-32|0;Za=d;_y(d+16|0,d+8|0,c);j[114630]=0;F(516,d|0,d+16|0);c=j[114630];j[114630]=0;a:{if((c|0)==1){break a}j[114630]=0;I(517,a|0,b|0,d|0);a=j[114630];j[114630]=0;if((a|0)==1){break a}qb(d+16|0);Za=d+32|0;return}a=D()|0;C()|0;qb(d+16|0);G(a|0);z()}function cja(a,b){var c=0,d=0,e=0,f=0;c=Za-16|0;Za=c;j[114630]=0;H(1589,a+4|0)|0;d=j[114630];j[114630]=0;a:{b:{if((d|0)!=1){j[114630]=0;j[c+12>>2]=0;K(1590,a+8|0,c+12|0,b|0)|0;b=j[114630];j[114630]=0;if((b|0)!=1){break b}break a}break a}e=a,f=Rb(a),j[e>>2]=f;Za=c+16|0;return}J(0)|0;C()|0;ib();z()}function VJa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=Za-32|0;Za=d;di(d+16|0,d+8|0,c);j[114630]=0;F(516,d|0,d+16|0);c=j[114630];j[114630]=0;a:{if((c|0)==1){break a}j[114630]=0;I(517,a|0,b|0,d|0);a=j[114630];j[114630]=0;if((a|0)==1){break a}qb(d+16|0);Za=d+32|0;return}a=D()|0;C()|0;qb(d+16|0);G(a|0);z()}function SB(a,b,c){var d=0,e=0,f=0,g=0,i=0;g=Za-16|0;Za=g;d=nb(a);f=sc(a);a:{if(f-d>>>0>=c>>>0){if(!c){break a}e=zb(a);i=e;f=d;if(d){Il(c+e|0,e,f);b=b>>>0>=e>>>0?d+e>>>0>b>>>0?b+c|0:b:b}Il(i,b,c);b=c+d|0;Bg(a,b);h[g+15|0]=0;Sd(b+e|0,g+15|0);break a}qu(a,f,(c+d|0)-f|0,d,0,0,c,b)}Za=g+16|0;return a}function Poa(a,b){var c=0,d=0,e=0,f=0;c=Za-16|0;Za=c;j[114630]=0;H(1369,a+4|0)|0;d=j[114630];j[114630]=0;a:{b:{if((d|0)!=1){j[114630]=0;j[c+12>>2]=0;K(1370,a+8|0,c+12|0,b|0)|0;b=j[114630];j[114630]=0;if((b|0)!=1){break b}break a}break a}e=a,f=Rb(a),j[e>>2]=f;Za=c+16|0;return}J(0)|0;C()|0;ib();z()}function Nta(a,b){var c=0,d=0,e=0,f=0;c=Za-16|0;Za=c;j[114630]=0;H(1159,a+4|0)|0;d=j[114630];j[114630]=0;a:{b:{if((d|0)!=1){j[114630]=0;j[c+12>>2]=0;K(1160,a+8|0,c+12|0,b|0)|0;b=j[114630];j[114630]=0;if((b|0)!=1){break b}break a}break a}e=a,f=Rb(a),j[e>>2]=f;Za=c+16|0;return}J(0)|0;C()|0;ib();z()}function Mla(a,b){var c=0,d=0,e=0,f=0;c=Za-16|0;Za=c;j[114630]=0;H(1516,a+4|0)|0;d=j[114630];j[114630]=0;a:{b:{if((d|0)!=1){j[114630]=0;j[c+12>>2]=0;K(1517,a+8|0,c+12|0,b|0)|0;b=j[114630];j[114630]=0;if((b|0)!=1){break b}break a}break a}e=a,f=Rb(a),j[e>>2]=f;Za=c+16|0;return}J(0)|0;C()|0;ib();z()}function Kqa(a,b){var c=0,d=0,e=0,f=0;c=Za-16|0;Za=c;j[114630]=0;H(1247,a+4|0)|0;d=j[114630];j[114630]=0;a:{b:{if((d|0)!=1){j[114630]=0;j[c+12>>2]=0;K(1248,a+8|0,c+12|0,b|0)|0;b=j[114630];j[114630]=0;if((b|0)!=1){break b}break a}break a}e=a,f=Rb(a),j[e>>2]=f;Za=c+16|0;return}J(0)|0;C()|0;ib();z()}function tqa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0;d=Za-16|0;Za=d;j[d+12>>2]=c>>>1;j[d+8>>2]=j[a>>2];e=j[tb(d+12|0,d+8|0)>>2];b=lb(b);if(e){a=j[a+20>>2];c=e;while(1){f=a,g=Im(k[b|0]),h[f|0]=g;f=a,g=Im(k[b+1|0]),h[f+1|0]=g;a=a+2|0;b=b+2|0;c=c-1|0;if(c){continue}break}}Za=d+16|0;return e<<1}function Mg(a){var b=0,c=0,d=0;c=or(a+56|0);j[a>>2]=76808;j[c>>2]=76828;j[114630]=0;b=a+4|0;K(126,a|0,76840,b|0)|0;d=j[114630];j[114630]=0;if((d|0)!=1){a:{j[a>>2]=76808;j[c>>2]=76828;j[114630]=0;E(127,b|0,16)|0;b=j[114630];j[114630]=0;if((b|0)==1){break a}return a}}a=D()|0;C()|0;og(c);G(a|0);z()}function vBa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=Za-32|0;Za=d;di(d+16|0,d+8|0,c);j[114630]=0;F(71,d|0,d+16|0);c=j[114630];j[114630]=0;a:{if((c|0)==1){break a}j[114630]=0;I(72,a|0,b|0,d|0);a=j[114630];j[114630]=0;if((a|0)==1){break a}qb(d+16|0);Za=d+32|0;return}a=D()|0;C()|0;qb(d+16|0);G(a|0);z()}function sta(a,b,c){var d=0,e=0,f=0;d=Za-16|0;Za=d;e=vz(b,c);a:{if(e>>>0<=Df(a)>>>0){j[d+8>>2]=c;if(Yb(a)>>>0<e>>>0){j[d+8>>2]=b;f=Yb(a);j[d+8>>2]=j[d+8>>2]+(f<<1);cj(b,j[d+8>>2],j[a>>2]);lM(a,j[d+8>>2],c,e-Yb(a)|0);break a}Cp(a,cj(b,c,j[a>>2]));break a}kM(a);ky(a,ui(a,e));lM(a,b,c,e)}Za=d+16|0}function pna(a,b){var c=0,d=0;c=b+4|0;d=k[c|0]|k[c+1|0]<<8|(k[c+2|0]<<16|k[c+3|0]<<24);c=j[a>>2]+20|0;if((d|0)==(k[c|0]|k[c+1|0]<<8|(k[c+2|0]<<16|k[c+3|0]<<24))){a=j[a>>2]+16|0;a=(k[b|0]|k[b+1|0]<<8|(k[b+2|0]<<16|k[b+3|0]<<24))==(k[a|0]|k[a+1|0]<<8|(k[a+2|0]<<16|k[a+3|0]<<24))}else{a=0}return a}function aMa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=Za-32|0;Za=d;Qz(d+16|0,d+8|0,c);j[114630]=0;F(71,d|0,d+16|0);c=j[114630];j[114630]=0;a:{if((c|0)==1){break a}j[114630]=0;I(72,a|0,b|0,d|0);a=j[114630];j[114630]=0;if((a|0)==1){break a}qb(d+16|0);Za=d+32|0;return}a=D()|0;C()|0;qb(d+16|0);G(a|0);z()}function XCa(a,b){var c=0,d=0,e=0,f=0;c=Za-16|0;Za=c;j[114630]=0;H(814,a+4|0)|0;d=j[114630];j[114630]=0;a:{b:{if((d|0)!=1){j[114630]=0;j[c+12>>2]=0;K(815,a+8|0,c+12|0,b|0)|0;b=j[114630];j[114630]=0;if((b|0)!=1){break b}break a}break a}e=a,f=Rb(a),j[e>>2]=f;Za=c+16|0;return}J(0)|0;C()|0;ib();z()}function Qza(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0;d=Za-48|0;Za=d;f=j[a+4>>2];e=Nza(vd(d+40|0,b),vd(d+32|0,c))+j[a+4>>2]|0;j[a+4>>2]=e;if(!((e-1^f-1)>>>0<32?f:0)){g=j[a>>2];j[(e>>>0<33?g:(e-1>>>3&536870908)+g|0)>>2]=0}b=vd(d+24|0,b);c=vd(d+16|0,c);vn(d+8|0,a,f);Mza(d,b,c,d+8|0);Za=d+48|0}function FFa(a,b){var c=0,d=0,e=0,f=0;c=Za-16|0;Za=c;j[114630]=0;H(725,a+4|0)|0;d=j[114630];j[114630]=0;a:{b:{if((d|0)!=1){j[114630]=0;j[c+12>>2]=0;K(726,a+8|0,c+12|0,b|0)|0;b=j[114630];j[114630]=0;if((b|0)!=1){break b}break a}break a}e=a,f=Rb(a),j[e>>2]=f;Za=c+16|0;return}J(0)|0;C()|0;ib();z()}function xFa(a,b,c){var d=0,e=0,f=0;d=se(a);e=Rb(a);a:{if(d){b:{while(1){c:{f=d+16|0;d:{if(bn(hb(a),c,f)){if(!j[d>>2]){break a}e=d;break d}if(!bn(hb(a),f,c)){break b}e=d+4|0;if(!j[d+4>>2]){break c}d=e;e=d}d=j[d>>2];continue}break}j[b>>2]=d;return e}j[b>>2]=d;return e}d=Rb(a)}j[b>>2]=d;return d}function wCa(a,b,c){var d=0,e=0,f=0;d=se(a);e=Rb(a);a:{if(d){b:{while(1){c:{f=d+14|0;d:{if(bn(hb(a),c,f)){if(!j[d>>2]){break a}e=d;break d}if(!bn(hb(a),f,c)){break b}e=d+4|0;if(!j[d+4>>2]){break c}d=e;e=d}d=j[d>>2];continue}break}j[b>>2]=d;return e}j[b>>2]=d;return e}d=Rb(a)}j[b>>2]=d;return d}function sba(a){var b=0,c=0;b=Za-48|0;Za=b;xk(b);j[114630]=0;F(246,b+32|0,b|0);c=j[114630];j[114630]=0;a:{b:{if((c|0)!=1){j[114630]=0;I(9,a|0,0,b+32|0);a=j[114630];j[114630]=0;if((a|0)==1){break b}gb(b+32|0);Ie(b);Za=b+48|0;return}a=D()|0;C()|0;break a}a=D()|0;C()|0;gb(b+32|0)}Ie(b);G(a|0);z()}function pia(a,b,c){var d=0,e=0,f=0;d=se(a);e=Rb(a);a:{if(d){b:{while(1){c:{f=d+16|0;d:{if(yr(hb(a),c,f)){if(!j[d>>2]){break a}e=d;break d}if(!yr(hb(a),f,c)){break b}e=d+4|0;if(!j[d+4>>2]){break c}d=e;e=d}d=j[d>>2];continue}break}j[b>>2]=d;return e}j[b>>2]=d;return e}d=Rb(a)}j[b>>2]=d;return d}function oW(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=Za-32|0;Za=d;Ol(d+16|0,d+8|0,c);j[114630]=0;F(71,d|0,d+16|0);c=j[114630];j[114630]=0;a:{if((c|0)==1){break a}j[114630]=0;I(72,a|0,b|0,d|0);a=j[114630];j[114630]=0;if((a|0)==1){break a}qb(d+16|0);Za=d+32|0;return}a=D()|0;C()|0;qb(d+16|0);G(a|0);z()}function hH(a,b,c){var d=0,e=0,f=0,g=0;if(q(r(a))<q(2147483648)){d=~~a}else{d=-2147483648}f=d&-2147483648;e=f?0-d|0:d;a:{if(!((e|0)<0|(b|0)<1)){while(1){d=b-1|0;e=e<<1;if((e|0)<0){break a}g=(b|0)>1;b=d;if(g){continue}break a}}d=b}b=(e>>>31|0)+d<<31-c|(e&2147483647)>>>c;return q((f?b^-1|f:b)|0)}function goa(a,b,c){var d=0,e=0,f=0;d=se(a);e=Rb(a);a:{if(d){b:{while(1){c:{hb(a);f=d+14|0;d:{if(bK(c,f)){if(!j[d>>2]){break a}e=d;break d}hb(a);if(!bK(f,c)){break b}e=d+4|0;if(!j[d+4>>2]){break c}d=e;e=d}d=j[d>>2];continue}break}j[b>>2]=d;return e}j[b>>2]=d;return e}d=Rb(a)}j[b>>2]=d;return d}function bl(a,b,c,d){var e=0;a:{if(b>>>0>255){break a}b:{c:{d:{e:{switch(c|0){case 1:break b;case 3:break c;case 0:break d;case 2:break e;default:break a}}e=FK(a,b,d);if(e-251>>>0<5){break d}if(e){break a}}return EK(a,b,d)}e=EK(a,b,d);if(e-251>>>0<5){break b}if(e){break a}}e=FK(a,b,d)}return e}function _na(a,b,c){var d=0,e=0,f=0;d=se(a);e=Rb(a);a:{if(d){b:{while(1){c:{hb(a);f=d+16|0;d:{if($J(c,f)){if(!j[d>>2]){break a}e=d;break d}hb(a);if(!$J(f,c)){break b}e=d+4|0;if(!j[d+4>>2]){break c}d=e;e=d}d=j[d>>2];continue}break}j[b>>2]=d;return e}j[b>>2]=d;return e}d=Rb(a)}j[b>>2]=d;return d}function X6(a,b,c){var d=0,e=0;d=Za-32|0;Za=d;j[d+24>>2]=c;a:{if((a|0)!=(b|0)){while(1){c=Db(d+8|0,j[a>>2]);j[114630]=0;E(2202,d+24|0,c|0)|0;e=j[114630];j[114630]=0;if((e|0)==1){break a}gb(c);a=a+4|0;if((b|0)!=(a|0)){continue}break}c=j[d+24>>2]}Za=d+32|0;return c}a=D()|0;C()|0;gb(c);G(a|0);z()}function KK(a,b,c,d){var e=0,f=0;f=Za-16|0;Za=f;e=-2147483648;e=!c|!(h[c+15|0]&1)?e:j[c+8>>2];a:{b:{if(!(!d|!(k[d+34|0]&32))){e=l[d+28>>1];break b}if((e|0)==-2147483648){break a}}ls(b,e,a);mb(f+8|0,a+1074308|0,10);if(!kb(f+8|0)|j[a+480208>>2]&16384){break a}j[b+88>>2]=j[b+88>>2]&-257}Za=f+16|0}function Gqa(a,b,c){var d=0,e=0,f=0;d=se(a);e=Rb(a);a:{if(d){b:{while(1){c:{f=d+16|0;d:{if(Zr(hb(a),c,f)){if(!j[d>>2]){break a}e=d;break d}if(!Zr(hb(a),f,c)){break b}e=d+4|0;if(!j[d+4>>2]){break c}d=e;e=d}d=j[d>>2];continue}break}j[b>>2]=d;return e}j[b>>2]=d;return e}d=Rb(a)}j[b>>2]=d;return d}function Gla(a,b,c){var d=0,e=0,f=0;d=se(a);e=Rb(a);a:{if(d){b:{while(1){c:{f=d+16|0;d:{if($I(hb(a),c,f)){if(!j[d>>2]){break a}e=d;break d}if(!$I(hb(a),f,c)){break b}e=d+4|0;if(!j[d+4>>2]){break c}d=e;e=d}d=j[d>>2];continue}break}j[b>>2]=d;return e}j[b>>2]=d;return e}d=Rb(a)}j[b>>2]=d;return d}function Eta(a,b,c){var d=0,e=0,f=0;d=se(a);e=Rb(a);a:{if(d){b:{while(1){c:{f=d+14|0;d:{if(zn(hb(a),c,f)){if(!j[d>>2]){break a}e=d;break d}if(!zn(hb(a),f,c)){break b}e=d+4|0;if(!j[d+4>>2]){break c}d=e;e=d}d=j[d>>2];continue}break}j[b>>2]=d;return e}j[b>>2]=d;return e}d=Rb(a)}j[b>>2]=d;return d}function yx(a,b,c,d){var e=0,f=0;e=Za-16|0;Za=e;f=Jo(a);a:{if(Yb(f)>>>0<=b>>>0){break a}if(zx(a,l[bc(f,b)>>1])>>>0<=c>>>0){break a}b:{if(ec(a)>>>0>b>>>0){if(m[ad(a,b)+4>>2]>c>>>0){break b}}Ui(a,0);if(ec(a)>>>0<=b>>>0){break a}}Nd(e+8|0,ad(a,b),c);Qd(e+8|0,d);if(!d){break a}qL(a,b,c)}Za=e+16|0}function w4(a){var b=0,c=0;b=Za-16|0;Za=b;c=Hq(461284);j[115331]=461340;j[115329]=a;j[115321]=55732;h[461336]=0;j[115333]=-1;Kq(b+8|0,c);a=j[j[115321]+8>>2];j[114630]=0;F(a|0,461284,b+8|0);a=j[114630];j[114630]=0;if((a|0)!=1){wb(b+8|0);Za=b+16|0;return}a=D()|0;C()|0;wb(b+8|0);Nk(c);G(a|0);z()}function u4(a){var b=0,c=0;b=Za-16|0;Za=b;c=WD(461348);j[115347]=461404;j[115345]=a;j[115337]=55872;h[461400]=0;j[115349]=-1;Kq(b+8|0,c);a=j[j[115337]+8>>2];j[114630]=0;F(a|0,461348,b+8|0);a=j[114630];j[114630]=0;if((a|0)!=1){wb(b+8|0);Za=b+16|0;return}a=D()|0;C()|0;wb(b+8|0);Yn(c);G(a|0);z()}function nT(a,b,c){var d=0,e=0,f=0,g=0,h=0;d=Za-16|0;Za=d;j[d+12>>2]=c;jc(d+12|0,128);jc(d+12|0,65535);f=l[d+12>>1];bg(a,f);if(f){c=0;while(1){e=k[b+c|0];a:{if((e|0)==255){e=65535;break a}if((e|0)!=254){break a}e=65534}g=nk(a,c),h=e,i[g>>1]=h;c=c+1|0;if((f|0)!=(c|0)){continue}break}}Za=d+16|0}function bla(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,i=0;e=Za-16|0;Za=e;f=ti(b,c);d=sc(a);if(f>>>0>d>>>0){g=d;i=f-d|0;d=nb(a);xl(a,g,i,d,0,d,0)}d=zb(a);if((b|0)!=(c|0)){while(1){Sd(d,b);d=d+1|0;b=b+1|0;if((c|0)!=(b|0)){continue}break}}h[e+15|0]=0;Sd(d,e+15|0);Bg(a,f);Za=e+16|0;return a|0}function Zz(a,b){var c=0,d=0,e=0,f=0;c=Za-16|0;Za=c;a:{if(!b){break a}if(!yb(a,b)){break a}f=1;while(1){h[c+13|0]=0;e=(c+14|0)+d|0;if(b>>>0>d>>>0){Ff(a,c+13|0);d=k[c+13|0]}else{d=0}h[e|0]=d;d=1;e=f;f=0;if(e){continue}break}i[c+10>>1]=l[c+14>>1];a=c+10|0;d=k[a|0]|k[a+1|0]<<8}Za=c+16|0;return d}function DEa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0;if(!j[a+300>>2]){return 0}if((bb[j[a+304>>2]](j[a+296>>2],c,0,0)|0)>=0){while(1){a:{g=f;c=h;if(!d){break a}e=bb[j[a+300>>2]](j[a+296>>2],b,d)|0;d=d-e|0;b=b+e|0;f=e+g|0;c=f>>>0<e>>>0?c+1|0:c;h=c;if(e){continue}}break}}return g|0}function dH(a){a=a|0;var b=0,c=0;c=Za-16|0;Za=c;b=j[a+4256>>2];j[a+4240>>2]=b<<1;j[114630]=0;j[c+12>>2]=0;I(1642,a+4208|0,b<<2,c+12|0);b=j[114630];j[114630]=0;a:{if((b|0)==1){b=J(71412)|0;if((C()|0)!=(W(71412)|0)){break a}O(b|0)|0;j[a+4240>>2]=0;Q()}j[a+4244>>2]=0;Za=c+16|0;return}G(b|0);z()}function MM(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0;c=Za-16|0;Za=c;d=j[b+4>>2];j[c+8>>2]=j[b>>2];j[c+12>>2]=d;e=c,f=nb(a),j[e+4>>2]=f;j[c>>2]=j[c+12>>2];a=Cm(zb(a),j[c+8>>2],j[tb(c+4|0,c)>>2]);a:{if(a){break a}a=-1;b=j[c>>2];d=j[c+4>>2];if(b>>>0>d>>>0){break a}a=b>>>0<d>>>0}Za=c+16|0;return a|0}function pqa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0;d=Za-16|0;Za=d;j[d+12>>2]=c>>>1;j[d+8>>2]=j[a>>2];e=j[tb(d+12|0,d+8|0)>>2];b=lb(b);if(e){a=j[a+20>>2];c=e;while(1){f=a,g=(lb(k[b|0])|lb(k[b+1|0])<<8)^32768,i[f>>1]=g;a=a+2|0;b=b+2|0;c=c-1|0;if(c){continue}break}}Za=d+16|0;return e<<1}function mqa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0;d=Za-16|0;Za=d;j[d+12>>2]=c>>>1;j[d+8>>2]=j[a>>2];e=j[tb(d+12|0,d+8|0)>>2];b=lb(b);if(e){a=j[a+20>>2];c=e;while(1){f=a,g=(lb(k[b+1|0])|lb(k[b|0])<<8)^32768,i[f>>1]=g;a=a+2|0;b=b+2|0;c=c-1|0;if(c){continue}break}}Za=d+16|0;return e<<1}function Uta(a){var b=0,c=0,d=0;b=j[a+2496>>2];c=(b+1>>>0)%624|0;d=j[(c<<2)+a>>2];b=p(d&1,-1727483681)^(j[((b+397>>>0)%624<<2)+a>>2]^(d&2147483647|j[(b<<2)+a>>2]&-2147483648)>>>1);j[(j[a+2496>>2]<<2)+a>>2]=b;j[a+2496>>2]=c;a=b^b>>>11;a=a<<7&-1658038656^a;a=a<<15&-272236544^a;return a>>>18^a}function LAa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=Za-32|0;Za=d;pO(d+16|0,c);j[114630]=0;F(516,d|0,d+16|0);c=j[114630];j[114630]=0;a:{if((c|0)==1){break a}j[114630]=0;I(517,a|0,b|0,d|0);a=j[114630];j[114630]=0;if((a|0)==1){break a}qb(d+16|0);Za=d+32|0;return}a=D()|0;C()|0;qb(d+16|0);G(a|0);z()}function uR(a,b,c){var d=0;d=Za-32|0;Za=d;j[d+16>>2]=b;j[d+24>>2]=a;j[d+8>>2]=c;a:{if(!rb(d+24|0,d+16|0)){break a}while(1){a=j[d+24>>2];if(j[j[d+8>>2]>>2]==(k[a|0]|k[a+1|0]<<8|(k[a+2|0]<<16|k[a+3|0]<<24))){break a}gk(d+24|0);if(rb(d+24|0,d+16|0)){continue}break}}Za=d+32|0;return j[d+24>>2]}function tQ(a){var b=0,c=0,d=0,e=0,f=0,g=0,i=0;if(!k[a+20|0]){if(!(bb[j[j[a>>2]+44>>2]](a)|0)){b=a+4|0;while(1){CQ(a,65536);c=a,d=(f=a,g=fc(b,j[a+16>>2]),i=65536,e=j[j[a>>2]+48>>2],bb[e](f|0,g|0,i|0)|0)+j[a+16>>2]|0,j[c+16>>2]=d;if(!(bb[j[j[a>>2]+44>>2]](a)|0)){continue}break}}h[a+20|0]=1}}function jwa(a){var b=0,c=0,d=0;d=a+32|0;while(1){b=k[a|0];a:{b:{if((b-97&255)>>>0<=5){c=b-32|0;break b}c=99;c:{if(b>>>0<=106){if(b-88>>>0<2){break c}if((b|0)==75){break b}break a}if(b-120>>>0<2){break c}if((b|0)==107){break b}break a}c=122}h[a|0]=c}a=a+1|0;if((d|0)!=(a|0)){continue}break}}function Sxa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=Za-32|0;Za=d;Gxa(d+16|0,c);j[114630]=0;F(71,d|0,d+16|0);c=j[114630];j[114630]=0;a:{if((c|0)==1){break a}j[114630]=0;I(72,a|0,b|0,d|0);a=j[114630];j[114630]=0;if((a|0)==1){break a}qb(d+16|0);Za=d+32|0;return}a=D()|0;C()|0;qb(d+16|0);G(a|0);z()}function xoa(a){var b=0,c=0,d=0,e=0;c=a+1074412|0;a:{b:{b=a+484344|0;if(yp(b,l[a+1074436>>1])){if(RK(Hb(b,l[a+1074436>>1]))){break b}}j[a+1074408>>2]=j[a+480216>>2];a=j[a+480220>>2];break a}d=a+1074408|0,e=j[Hb(b,l[a+1074436>>1])+16>>2],j[d>>2]=e;a=j[Hb(b,l[a+1074436>>1])+20>>2]}j[c>>2]=a}function tma(a,b,c){var d=0,e=0,f=0,g=0;e=Za-16|0;Za=e;g=c<<2;while(1){j[e>>2]=0;f=((d<<11)+a|0)+16396|0;XK(f,g+f|0,e);d=d+1|0;if((d|0)!=4){continue}break}d=0;while(1){j[(d<<2)+e>>2]=((d<<11)+a|0)+16396;d=d+1|0;if((d|0)!=4){continue}break}bb[j[j[b>>2]+8>>2]](b,e,j[a+24632>>2],c);Za=e+16|0}function oqa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0;e=Za-16|0;Za=e;j[e+12>>2]=c>>>1;j[e+8>>2]=j[a>>2];f=j[tb(e+12|0,e+8|0)>>2];b=lb(b);if(f){a=j[a+20>>2];c=f;while(1){d=(lb(k[b|0])+d|0)+(lb(k[b+1|0])<<8)|0;i[a>>1]=d;a=a+2|0;b=b+2|0;c=c-1|0;if(c){continue}break}}Za=e+16|0;return f<<1}function mE(a,b,c){var d=0,e=0,f=0,g=0,i=0;d=Za-16|0;Za=d;e=Hq(a);j[a+32>>2]=b;j[a>>2]=55972;Kq(d+8|0,e);j[114630]=0;b=H(2309,d+8|0)|0;f=j[114630];j[114630]=0;if((f|0)!=1){wb(d+8|0);j[a+40>>2]=c;j[a+36>>2]=b;g=a,i=gm(b),h[g+44|0]=i;Za=d+16|0;return}a=D()|0;C()|0;wb(d+8|0);Nk(e);G(a|0);z()}function lqa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0;e=Za-16|0;Za=e;j[e+12>>2]=c>>>1;j[e+8>>2]=j[a>>2];f=j[tb(e+12|0,e+8|0)>>2];b=lb(b);if(f){a=j[a+20>>2];c=f;while(1){d=(lb(k[b+1|0])+d|0)+(lb(k[b|0])<<8)|0;i[a>>1]=d;a=a+2|0;b=b+2|0;c=c-1|0;if(c){continue}break}}Za=e+16|0;return f<<1}function lE(a,b,c){var d=0,e=0,f=0,g=0,i=0;d=Za-16|0;Za=d;e=WD(a);j[a+32>>2]=b;j[a>>2]=56076;Kq(d+8|0,e);j[114630]=0;b=H(2310,d+8|0)|0;f=j[114630];j[114630]=0;if((f|0)!=1){wb(d+8|0);j[a+40>>2]=c;j[a+36>>2]=b;g=a,i=gm(b),h[g+44|0]=i;Za=d+16|0;return}a=D()|0;C()|0;wb(d+8|0);Yn(e);G(a|0);z()}function bJa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=Za-32|0;Za=d;nS(d+16|0,c);j[114630]=0;F(71,d|0,d+16|0);c=j[114630];j[114630]=0;a:{if((c|0)==1){break a}j[114630]=0;I(72,a|0,b|0,d|0);a=j[114630];j[114630]=0;if((a|0)==1){break a}qb(d+16|0);Za=d+32|0;return}a=D()|0;C()|0;qb(d+16|0);G(a|0);z()}function Ke(a){a=a|0;var b=0,c=0;j[a>>2]=79888;b=j[a+12>>2];if(j[b>>2]==(a|0)){j[b>>2]=j[a+4>>2]}b=j[a+20>>2];if(b){j[b>>2]=0;j[a+20>>2]=0}b=j[a+4>>2];if(b){j[b+8>>2]=j[a+8>>2]}c=j[a+8>>2];if(c){j[c+4>>2]=b}j[a+4>>2]=0;j[a+8>>2]=0;b=a+44|0;sr(b+36|0);sr(b+24|0);rr(b+12|0);rr(b);return a|0}function KI(a,b){a=a|0;b=b|0;var c=0,d=0;a:{b:{c:{c=a-12|0;d:{if(c>>>0>28){break d}a=1;d=1<<c;if(d&270014517){break b}if(d&65792){break c}if((c|0)!=7){break d}b=b&240;if(!b|(b|0)==96|(b|0)==224){break b}}return 0}a=0;b=(b&240)-96|0;if(b>>>0<144){break a}}return a|0}return 297>>>(b>>>4)&1}function cm(a,b){var c=0,d=0,e=0,f=0,g=0,h=0;c=Za-16|0;Za=c;g=a;h=a;a:{if(!b){b=0;e=0;break a}d=b;b=s(b);We(c,d,0,0,0,b+81|0);d=0+j[c+8>>2]|0;b=(j[c+12>>2]^65536)+(16414-b<<16)|0;b=d>>>0<f>>>0?b+1|0:b;f=d;d=b;b=j[c+4>>2];e=j[c>>2]}j[h>>2]=e;j[g+4>>2]=b;j[a+8>>2]=f;j[a+12>>2]=d;Za=c+16|0}function QU(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,k=0,l=0;e=Za-16|0;Za=e;j[e+12>>2]=d;d=0;if(m[a+16>>2]>c>>>0){d=j[a+4>>2];f=j[a+12>>2];j[e+8>>2]=j[a+16>>2]-c;d=(h=d,i=b,k=c+f|0,l=j[tb(e+12|0,e+8|0)>>2],g=j[j[d>>2]+28>>2],bb[g](h|0,i|0,k|0,l|0)|0)}Za=e+16|0;return d|0}function wsa(a){j[a>>2]=0;j[a+4>>2]=0;j[a+68>>2]=0;j[a+72>>2]=0;j[a+24>>2]=0;j[a+28>>2]=0;i[a+20>>1]=511;j[a+16>>2]=-1;i[a+14>>1]=1;i[a+6>>1]=0;i[a+8>>1]=0;i[a+10>>1]=0;i[a+12>>1]=0;h[a+73|0]=0;h[a+74|0]=0;h[a+75|0]=0;h[a+76|0]=0;h[a+77|0]=0;h[a+78|0]=0;h[a+79|0]=0;h[a+80|0]=0;return a}function ita(a,b,c){var d=0,e=0,f=0,g=0;d=Za-16|0;Za=d;j[d+12>>2]=b;a:{if(Df(a)>>>0>=b>>>0){f=d,g=Yb(a),j[f+8>>2]=g;Dy(j[a>>2],j[tb(d+12|0,d+8|0)>>2],c);e=j[d+8>>2];b=j[d+12>>2];if(e>>>0<b>>>0){zt(a,b-e|0,c);break a}Cp(a,j[a>>2]+(b<<1)|0);break a}kM(a);ky(a,ui(a,b));zt(a,b,c)}Za=d+16|0}function X5(a,b,c){var d=0,e=0,f=0,g=0,h=0,i=0;e=b;f=k[c|0];if(f){d=a;while(1){i=f<<1;g=0;while(1){n[e>>2]=n[d>>2];n[e+4>>2]=n[(f<<2)+d>>2];h=i<<2;n[e+8>>2]=n[h+d>>2];d=d+4|0;e=e+12|0;g=g+1|0;if((g|0)!=(f|0)){continue}break}d=d+h|0;f=k[c+3|0];c=c+3|0;if(f){continue}break}}Vb(a,b,e-b|0)}function BW(a,b){var c=0,d=0,e=0;c=Za-16|0;Za=c;a=YE(a,c+8|0);d=nb(b);e=ne(7063);b=zb(b);j[114630]=0;L(195,a|0,b|0,d|0,d+e|0);b=j[114630];j[114630]=0;a:{if((b|0)!=1){j[114630]=0;K(196,a|0,7063,e|0)|0;b=j[114630];j[114630]=0;if((b|0)!=1){break a}}b=D()|0;C()|0;gb(a);G(b|0);z()}Za=c+16|0}function aba(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=Za-48|0;Za=d;j[d+44>>2]=b;Oi(d+8|0,0,c);b=d+24|0;j[b>>2]=j[d+44>>2];Mc(b+4|0,d+8|0);j[114630]=0;F(2120,a+4|0,d+24|0);a=j[114630];j[114630]=0;if((a|0)!=1){Rs(d+24|0);gb(d+8|0);Za=d+48|0;return}a=D()|0;C()|0;Rs(d+24|0);gb(d+8|0);G(a|0);z()}function aW(a,b,c){var d=0,e=0,f=0,g=0;d=Za-16|0;Za=d;j[d+12>>2]=c;f=nb(a);if(f>>>0>=b>>>0){if(c){g=zb(a);e=f-b|0;j[d+8>>2]=e;c=j[tb(d+12|0,d+8|0)>>2];j[d+12>>2]=c;e=e-c|0;if(e){b=b+g|0;Il(b,b+c|0,e);c=j[d+12>>2]}b=a;a=f-c|0;Bg(b,a);h[d+7|0]=0;Sd(a+g|0,d+7|0)}Za=d+16|0;return}Sl();z()}function m1(a,b){var c=0,d=0;c=Za-16|0;Za=c;hc(c+8|0,a);j[114630]=0;a=H(2450,c+8|0)|0;d=j[114630];j[114630]=0;a:{if((d|0)==1){break a}j[114630]=0;P(2464,a|0,64416,64442,b|0)|0;a=j[114630];j[114630]=0;if((a|0)==1){break a}wb(c+8|0);Za=c+16|0;return b}a=D()|0;C()|0;wb(c+8|0);G(a|0);z()}function lma(a,b){var c=0;c=Za-16|0;Za=c;a=a+1074308|0;mb(c+8|0,a,28);a:{b:{if(!kb(c+8|0)){mb(c,a,1);if(!kb(c)){break b}}j[b+684>>2]=j[b+692>>2]+i[b+790>>1];Md(b+684|0,0,256);break a}j[b+692>>2]=j[b+692>>2]+i[b+790>>1];Md(b+692|0,0,256);i[b+790>>1]=0;j[b+684>>2]=j[b+692>>2]}Za=c+16|0}function N3(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=Za-16|0;Za=d;a:{if(j[b>>2]){if(!Ec(c)){pu(c,58384)}e=j[b+4>>2];bb[j[j[e>>2]+24>>2]](d,e,j[b>>2]);j[114630]=0;E(1245,c|0,d|0)|0;b=j[114630];j[114630]=0;if((b|0)==1){break a}gb(d)}Mc(a,c);Za=d+16|0;return}a=D()|0;C()|0;gb(d);G(a|0);z()}function qqa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0;d=Za-16|0;Za=d;j[d+12>>2]=c>>>1;j[d+8>>2]=j[a>>2];e=j[tb(d+12|0,d+8|0)>>2];b=lb(b);if(e){a=j[a+20>>2];c=e;while(1){f=a,g=lb(k[b|0])|lb(k[b+1|0])<<8,i[f>>1]=g;a=a+2|0;b=b+2|0;c=c-1|0;if(c){continue}break}}Za=d+16|0;return e<<1}function nqa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0;d=Za-16|0;Za=d;j[d+12>>2]=c>>>1;j[d+8>>2]=j[a>>2];e=j[tb(d+12|0,d+8|0)>>2];b=lb(b);if(e){a=j[a+20>>2];c=e;while(1){f=a,g=lb(k[b+1|0])|lb(k[b|0])<<8,i[f>>1]=g;a=a+2|0;b=b+2|0;c=c-1|0;if(c){continue}break}}Za=d+16|0;return e<<1}function AC(a,b){a=a|0;b=b|0;var c=0,d=0;d=Za-16|0;Za=d;b=_d(d,a,b);c=j[b+4>>2];a:{while(1){if(j[b+8>>2]==(c|0)){break a}Ek(a);c=j[b+4>>2];j[114630]=0;os(c);c=j[114630];j[114630]=0;if((c|0)!=1){c=j[b+4>>2]+4|0;j[b+4>>2]=c;continue}break}a=D()|0;C()|0;ub(b);G(a|0);z()}ub(b);Za=d+16|0}function zd(a){var b=0,c=0,d=0,e=0;RMa(+a);b=OMa(1)|0;OMa(0)|0;e=b;b=b>>>20&2047;if(b>>>0<=1074){if(b>>>0<=1021){return a*0}a=(e|0)>-1?a:-a;c=a+4503599627370496+ -4503599627370496-a;a:{if(!(c>.5^1)){d=a+c+ -1;break a}a=a+c;d=a;if(c<=-.5^1){break a}d=a+1}a=d;a=(e|0)>-1?a:-a}return a}function fD(a,b,c){var d=0,e=0,f=0,g=0;f=Za-16|0;Za=f;e=Is(b,c);if(e>>>0<=1073741807){a:{if(e>>>0<=1){Ue(a,e);d=a;break a}g=Ul(e)+1|0;d=Ck(g);lf(a,d);lg(a,g);ee(a,e)}while(1){if((b|0)!=(c|0)){ye(d,b);d=d+4|0;b=b+4|0;continue}break}j[f+12>>2]=0;ye(d,f+12|0);Za=f+16|0;return}jg();z()}function s7(a,b,c,d,e){var f=0,g=0,h=0,k=0,l=0;if(e){while(1){g=0;if(d){while(1){f=j[tf(b,g,h)>>2];Pb(c,g);f=f-2147481600>>>12|0;f=f>>>0>491520?f:491520;k=lm(a,g,h),l=(f|0)<557055?f:557055,i[k>>1]=l;g=g+1|0;if((g|0)!=(d|0)){continue}break}}h=h+1|0;if((h|0)!=(e|0)){continue}break}}}function W7(a,b,c,d,e){var f=0,g=0,h=0,k=0,l=0;if(e){while(1){g=0;if(d){while(1){f=j[tf(b,g,h)>>2];Pb(c,g);f=f-2147481600>>>12|0;f=f>>>0>491520?f:491520;k=nm(a,g,h),l=(f|0)<557055?f:557055,i[k>>1]=l;g=g+1|0;if((g|0)!=(d|0)){continue}break}}h=h+1|0;if((h|0)!=(e|0)){continue}break}}}function VX(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=Za-32|0;Za=c;a=UX(c+8|0,a);d=j[a>>2];e=j[a+4>>2];a=j[b+4>>2];j[c>>2]=j[b>>2];j[c+4>>2]=a;e=j[c+4>>2]+e|0;b=j[c>>2];d=d+b|0;j[c+16>>2]=d;j[c+20>>2]=b>>>0>d>>>0?e+1|0:e;a=Tj(c+24|0,c+16|0);b=j[a+4>>2];a=j[a>>2];Za=c+32|0;ab=b;return a|0}function RX(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=Za-32|0;Za=c;a=lY(c+8|0,a);d=j[a>>2];e=j[a+4>>2];a=j[b+4>>2];j[c>>2]=j[b>>2];j[c+4>>2]=a;e=j[c+4>>2]+e|0;b=j[c>>2];d=d+b|0;j[c+16>>2]=d;j[c+20>>2]=b>>>0>d>>>0?e+1|0:e;a=Tj(c+24|0,c+16|0);b=j[a+4>>2];a=j[a>>2];Za=c+32|0;ab=b;return a|0}function GJ(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;e=Za-16|0;Za=e;a:{b:{if(!Ld(c)|(!d|j[b+480180>>2]!=16777216)|l[b+480192>>1]<d>>>0){break b}d=j[((d<<2)+b|0)+900380>>2];if(!d){break b}d=j[d+44>>2];if(!d){break b}i[e+14>>1]=c-61;Wia(a,d,e+14|0);break a}Yma(a,c,j[b>>2])}Za=e+16|0}function FQ(a){var b=0,c=0,d=0,e=0;b=a+32|0;d=k[b|0]|k[b+1|0]<<8;b=a+38|0;e=k[b|0]|k[b+1|0]<<8;b=a+34|0;a=a+36|0;c=k[a|0]|k[a+1|0]<<8;b=(k[b|0]|k[b+1|0]<<8)+c|0;a=0;a=b>>>0<c>>>0?1:a;c=b;b=e+b|0;a=b>>>0<c>>>0?a+1|0:a;a=a<<2|b>>>30;c=b<<2;b=d+c|0;a=b>>>0<c>>>0?a+1|0:a;ab=a;return b}function OZ(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0;while(1){a:{if((c|0)==(d|0)|e>>>0<=g>>>0){break a}f=1;b:{c:{h=NZ(c,d-c|0,b,j[a+8>>2]);switch(h+2|0){case 0:case 1:break a;case 2:break b;default:break c}}f=h}g=g+1|0;i=f+i|0;c=c+f|0;continue}break}return i|0}function wW(a){var b=0,c=0;c=Za-32|0;Za=c;a=Qc(a);j[114630]=0;N(236,c|0);b=j[114630];j[114630]=0;a:{b:{if((b|0)!=1){b=Ag(c);j[114630]=0;E(237,a|0,b|0)|0;b=j[114630];j[114630]=0;if((b|0)==1){break b}Ie(c);Za=c+32|0;return}b=D()|0;C()|0;break a}b=D()|0;C()|0;Ie(c)}gb(a);G(b|0);z()}function fga(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;j[a+4>>2]=b;j[a>>2]=0;b=gs(a+8|0,e);j[114630]=0;E(1755,a+20|0,d|0)|0;d=j[114630];j[114630]=0;if((d|0)!=1){j[a+32>>2]=0;j[a+36>>2]=0;h[a+42|0]=0;h[a+40|0]=0;h[a+41|0]=k[a+41|0]&240|c|8;return a|0}a=D()|0;C()|0;qb(b);G(a|0);z()}function Boa(a,b,c){a=a|0;b=b|0;c=c|0;a:{switch(b|0){case 0:soa(a,c);return;case 1:koa(a,c);return;case 2:coa(a,c);return;case 3:xo(a,c,1520);return;case 4:xo(a,c,2544);return;case 5:xo(a,c,3568);return;case 6:xo(a,c,4592);return;case 7:xo(a,c,5616);return;default:break a}}Cb(a)}function ZCa(a,b,c){var d=0,e=0;d=Za-16|0;Za=d;e=Is(b,c);a:{if(e>>>0<=jd(a)>>>0){j[d+12>>2]=c;if(sb(a)>>>0<e>>>0){j[d+12>>2]=b;hP(d+12|0,sb(a));Pe(b,j[d+12>>2],j[a>>2]);zp(a,j[d+12>>2],c,e-sb(a)|0);break a}Lt(a,Pe(b,c,j[a>>2]));break a}gP(a);FCa(a,ie(a,e));zp(a,b,c,e)}Za=d+16|0}function Z3(a,b,c,d){var e=0,f=0,g=0;e=Za-16|0;Za=e;d=d-c|0;a:{if(!d){b=a;break a}f=b-a|0;if((d|0)>(f|0)){break a}h[e+15|0]=k[c|0];g=1-d|0;while(1){a=Gn(a,f+g|0,e+15|0);if(!a){break a}if(!Cm(a,c,d)){b=a;break a}a=a+1|0;f=b-a|0;if((d|0)<=(f|0)){continue}break}}Za=e+16|0;return b}function Pja(a,b,c){var d=0,e=0;d=Za-16|0;Za=d;e=Is(b,c);a:{if(e>>>0<=jd(a)>>>0){j[d+12>>2]=c;if(sb(a)>>>0<e>>>0){j[d+12>>2]=b;hP(d+12|0,sb(a));Pe(b,j[d+12>>2],j[a>>2]);zp(a,j[d+12>>2],c,e-sb(a)|0);break a}hQ(a,Pe(b,c,j[a>>2]));break a}Oja(a);VS(a,ie(a,e));zp(a,b,c,e)}Za=d+16|0}function Bd(a,b){var c=0,d=0,e=0,f=0;c=j[a+4>>2];d=c+b|0;j[a+4>>2]=d;if((d|0)<=j[a+8>>2]){d=j[a>>2]+(c>>3)|0;a=c&7;c=k[d|0]&255>>>a;a=a+b|0;a:{if((a|0)<9){b=a;break a}while(1){b=a-8|0;e=c<<b|e;f=(a|0)>16;c=k[d+1|0];a=b;d=d+1|0;if(f){continue}break}}a=c>>>8-b|e}else{a=0}return a}function Tg(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0;e=Za-32|0;Za=e;g=kj(a,c);Ve(e+8|0,j[a+28>>2]);f=j[e+20>>2];j[e+24>>2]=j[e+16>>2];j[e+28>>2]=f;a:{b:{if(!g){f=-1;if(!gd(a,5)){break b}break a}f=j[g+8>>2]}bb[d|0](j[a+28>>2],b,f)}a=Ei(a,g,c,e+24|0);Za=e+32|0;return a|0}function im(a,b,c){var d=0,e=0,f=0;a:{if(b>>>0<1){d=a;break a}while(1){d=KMa(a,b,10,0);e=ab;f=e;e=HMa(d,e,10,0);c=c-1|0;h[c|0]=a-e|48;e=b>>>0>9;a=d;b=f;if(e){continue}break}}if(d){while(1){c=c-1|0;a=(d>>>0)/10|0;h[c|0]=d-p(a,10)|48;b=d>>>0>9;d=a;if(b){continue}break}}return c}function xqa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0;d=Za-16|0;Za=d;j[d+12>>2]=c;j[d+8>>2]=j[a>>2];e=j[tb(d+12|0,d+8|0)>>2];b=lb(b);if(e){a=j[a+20>>2];c=e;while(1){f=a,g=Gb(Im(k[b|0]),-64,63)<<1,h[f|0]=g;a=a+1|0;b=b+1|0;c=c-1|0;if(c){continue}break}}Za=d+16|0;return e|0}function wLa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0;j[a>>2]=0;j[a+4>>2]=0;if(!yb(b,c)){c=ef(b)}j[a>>2]=c;d=j[b>>2];if(bb[j[j[d>>2]+16>>2]](d)|0){c=a;a=j[b>>2];e=c,f=(bb[j[j[a>>2]+20>>2]](a)|0)+j[b+8>>2]|0,j[e+4>>2]=f;return}d=a+8|0;fk(d,j[a>>2]);if(!Xc(d)){ug(b,fc(d,0),c)}}function n5(a,b,c,d){var e=0,f=0,g=0,h=0,i=0,k=0;if((b|0)>=1){h=(b<<1)+a|0;i=-1;k=65536;while(1){g=(f<<1)+a|0;e=l[g>>1];if(!((i|0)>=(e|0)|l[h>>1]<=e>>>0)){j[c>>2]=f;e=l[g>>1];i=e}if(!((e|0)>=(k|0)|l[h>>1]>=e>>>0)){j[d>>2]=f;k=l[g>>1]}f=f+1|0;if((f|0)!=(b|0)){continue}break}}}function iV(a){var b=0;b=Za-16|0;Za=b;h[a|0]=0;h[a+1|0]=0;h[a+2|0]=0;h[a+3|0]=0;h[a+4|0]=0;h[a+5|0]=0;h[a+6|0]=0;h[a+7|0]=0;h[a+16|0]=0;h[a+17|0]=0;h[a+18|0]=0;h[a+19|0]=0;h[a+8|0]=0;h[a+9|0]=0;h[a+10|0]=0;h[a+11|0]=0;h[a+12|0]=0;h[a+13|0]=0;h[a+14|0]=0;h[a+15|0]=0;Za=b+16|0}function Q6(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0;f=Za-16|0;Za=f;d=ho(f+8|0,d);j[114630]=0;U(2009,a+8|0,b|0,c|0,d|0,e|0)|0;b=j[114630];j[114630]=0;if((b|0)!=1){Gc(d);xF(a);b=wF(a+88|0);j[a>>2]=84360;j[b>>2]=84448;Za=f+16|0;return a|0}a=D()|0;C()|0;Gc(d);G(a|0);z()}function Osa(a,b){a=a|0;b=b|0;var c=0;c=Za-48|0;Za=c;h[c+40|0]=k[b|0];Up(c+16|0,c+40|0);b=lb(j[c+16>>2]);Up(c+8|0,c+40|0);b=Yh(c+24|0,b,lb(j[c+8>>2]+1|0));j[114630]=0;E(1187,a|0,b|0)|0;a=j[114630];j[114630]=0;if((a|0)!=1){gb(b);Za=c+48|0;return}a=D()|0;C()|0;gb(b);G(a|0);z()}function vA(a,b,c,d){var e=0,f=0;b=j[a+1072>>2]+((b&c?0-(c<<1)|0:0)+b|0)|0;j[a+1072>>2]=b;c=b+j[a+1076>>2]|0;j[a+1076>>2]=c;i[(j[a+1064>>2]<<1)+d>>1]=k[a+1080|0]?c:b;j[a+1060>>2]=j[a+1060>>2]+1;e=a,f=be(j[a+1056>>2])+j[a+1064>>2]|0,j[e+1064>>2]=f;j[a+1068>>2]=j[a+1068>>2]-1}function Nj(a,b,c,d){var e=0,f=0;a:{f=j[(p(b,896)+a|0)+1075640>>2];if(!f){break a}if(!ai(f)){break a}e=k[f+34|0];if(e-251>>>0<5|!e){break a}e=j[(p(e,160)+a|0)+906140>>2];if(!e){break a}bb[j[j[e>>2]+88>>2]](e,f,c,d,b);if(c>>>0>250){break a}i[(p(b,896)+a|0)+1075846>>1]=65535}}function xxa(a,b){var c=0;c=Za-16|0;Za=c;a=dxa(c,a,b);b=j[a+4>>2];if((b|0)!=j[a+8>>2]){while(1){h[b|0]=0;h[b+1|0]=0;h[b+2|0]=0;h[b+3|0]=0;h[b+4|0]=0;h[b+5|0]=0;h[b+6|0]=0;h[b+7|0]=0;h[b+8|0]=0;b=j[a+4>>2]+9|0;j[a+4>>2]=b;if(j[a+8>>2]!=(b|0)){continue}break}}ub(a);Za=c+16|0}function jfa(a,b,c){a=a|0;b=b|0;c=q(c);var d=0;d=Za-16|0;Za=d;n[d+12>>2]=c;if((b|0)<=6){Kd(d+12|0,q(0));c=n[d+12>>2];a:{if(!((b|0)!=1|c>=q(1))){j[d+12>>2]=0;c=q(0);break a}if((b|0)!=4){break a}c=q(Rd(q(c*q(4)))*q(.25));n[d+12>>2]=c}n[((b<<2)+a|0)+4208>>2]=c;jw(a)}Za=d+16|0}function Z6(a,b,c,d,e){var f=0,g=0,h=0,i=0,j=0,k=q(0);if(e){while(1){f=0;if(d){while(1){h=o[Kg(b,f,g)>>3];Pb(c,f);i=Xi(zd(h*134217728));j=tf(a,f,g),k=q(+(i|0)*7.450580596923828e-9),n[j>>2]=k;f=f+1|0;if((f|0)!=(d|0)){continue}break}}g=g+1|0;if((g|0)!=(e|0)){continue}break}}}function Y6(a,b,c,d,e){var f=0,g=0,h=0,i=0,j=0,k=q(0);if(e){while(1){f=0;if(d){while(1){h=o[Kg(b,f,g)>>3];Ae(c,f);i=Xi(zd(h*134217728));j=tf(a,f,g),k=q(+(i|0)*7.450580596923828e-9),n[j>>2]=k;f=f+1|0;if((f|0)!=(d|0)){continue}break}}g=g+1|0;if((g|0)!=(e|0)){continue}break}}}function Vfa(a,b,c){a=a|0;b=b|0;c=q(c);var d=0;d=Za-16|0;Za=d;n[d+12>>2]=c;if((b|0)<=6){Kd(d+12|0,q(0));c=n[d+12>>2];a:{if(!((b|0)!=3|c>=q(1))){j[d+12>>2]=0;c=q(0);break a}if((b|0)!=4){break a}c=q(Rd(q(c*q(4)))*q(.25));n[d+12>>2]=c}n[((b<<2)+a|0)+4208>>2]=c;jw(a)}Za=d+16|0}function C7(a,b,c,d,e){var f=0,g=0,h=0,i=0,j=0,k=q(0);if(e){while(1){f=0;if(d){while(1){h=o[Kg(b,f,g)>>3];Pb(c,f);i=Xi(zd(h*134217728));j=Um(a,f,g),k=q(+(i|0)*7.450580596923828e-9),n[j>>2]=k;f=f+1|0;if((f|0)!=(d|0)){continue}break}}g=g+1|0;if((g|0)!=(e|0)){continue}break}}}function B7(a,b,c,d,e){var f=0,g=0,h=0,i=0,j=0,k=q(0);if(e){while(1){f=0;if(d){while(1){h=o[Kg(b,f,g)>>3];Ae(c,f);i=Xi(zd(h*134217728));j=Um(a,f,g),k=q(+(i|0)*7.450580596923828e-9),n[j>>2]=k;f=f+1|0;if((f|0)!=(d|0)){continue}break}}g=g+1|0;if((g|0)!=(e|0)){continue}break}}}function vv(a){var b=0,c=0;a:{if(m[a+20>>2]<=m[a+28>>2]){break a}bb[j[a+36>>2]](a,0,0)|0;if(j[a+20>>2]){break a}return-1}b=j[a+4>>2];c=j[a+8>>2];if(b>>>0<c>>>0){b=b-c|0;bb[j[a+40>>2]](a,b,b>>31,1)|0}j[a+28>>2]=0;j[a+16>>2]=0;j[a+20>>2]=0;j[a+4>>2]=0;j[a+8>>2]=0;return 0}function VH(a,b){var c=0,d=0;c=Za-16|0;Za=c;hc(c+8|0,a);j[114630]=0;a=H(21,c+8|0)|0;d=j[114630];j[114630]=0;a:{if((d|0)==1){break a}j[114630]=0;a=E(22,a|0,b|0)|0;b=j[114630];j[114630]=0;if((b|0)==1){break a}wb(c+8|0);Za=c+16|0;return a}a=D()|0;C()|0;wb(c+8|0);G(a|0);z()}function Qi(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;if(!(b?0:!(j[a+480180>>2]&1))){e=j[a+24616>>2]&524288;b=0;while(1){c=(b<<5)+a|0;i[c+480286>>1]=64;d=c+480280|0;j[d>>2]=j[d>>2]&-257;d=c+480284|0;c=(b&3)-1>>>0<2;i[d>>1]=e?c<<8:c?192:64;b=b+1|0;if((b|0)!=127){continue}break}}}function MLa(a,b){var c=0;c=Za-32|0;Za=c;j[c+16>>2]=b;j[c+24>>2]=a;a:{if(!rb(c+24|0,c+16|0)){break a}j[c>>2]=j[c+24>>2];if(!rb(je(c),c+16|0)){break a}while(1){if(OS(j[c+24>>2],j[c>>2])){j[c+24>>2]=j[c>>2]}if(rb(je(c),c+16|0)){continue}break}}Za=c+32|0;return j[c+24>>2]}function Fga(a){var b=q(0),c=0,d=0;b=q(1);c=j[a+20>>2];if(c){b=q(q(k[c+26|0])*q(.10000000149011612))}b=b<q(.10000000149011612)?q(1):b;c=a;if(bb[j[j[a>>2]+132>>2]](a)|0){d=AH(j[a+16>>2]);a=j[a+16>>2];b=q(q(b*q(m[a+480232>>2]))/q(n[d+8>>2]*n[AH(a)+20>>2]))}n[c+4196>>2]=b}function CY(a,b){a=a|0;b=b|0;var c=0;c=Za-16|0;Za=c;a=wh(c,a+8|0,b);b=j[a>>2];a:{while(1){if(j[a+4>>2]==(b|0)){break a}b=j[a>>2];j[114630]=0;os(b);b=j[114630];j[114630]=0;if((b|0)!=1){b=j[a>>2]+4|0;j[a>>2]=b;continue}break}b=D()|0;C()|0;cc(a);G(b|0);z()}cc(a);Za=c+16|0}function $n(a,b,c){var d=0,e=0,f=0;d=a*a;f=d*(d*d)*(d*1.58969099521155e-10+ -2.5050760253406863e-8)+(d*(d*27557313707070068e-22+ -.0001984126982985795)+.00833333333332249);e=d*a;if(!c){return e*(d*f+ -.16666666666666632)+a}return a-(d*(b*.5-e*f)-b+e*.16666666666666632)}function uA(a,b,c,d){var e=0,f=0;b=j[a+1072>>2]+((b&c?0-(c<<1)|0:0)+b|0)|0;j[a+1072>>2]=b;c=b+j[a+1076>>2]|0;j[a+1076>>2]=c;h[j[a+1064>>2]+d|0]=k[a+1080|0]?c:b;j[a+1060>>2]=j[a+1060>>2]+1;e=a,f=be(j[a+1056>>2])+j[a+1064>>2]|0,j[e+1064>>2]=f;j[a+1068>>2]=j[a+1068>>2]-1}function Ze(a,b){var c=0,d=0,e=0,f=0;c=nb(a);a:{if((c|0)!=(nb(b)|0)){break a}d=zb(a);b=zb(b);b:{if(!qe(a)){if(c){break b}return 1}return!Cm(d,b,c)}while(1){a=k[b|0];e=k[d|0];f=(a|0)==(e|0);if((a|0)!=(e|0)){break a}b=b+1|0;d=d+1|0;c=c-1|0;if(c){continue}break}}return f}function zE(a,b){var c=0,d=0,e=0;RMa(+a);c=OMa(1)|0;d=OMa(0)|0;e=c;c=c>>>20&2047;if((c|0)!=2047){if(!c){c=b;if(a==0){b=0}else{a=zE(a*0x10000000000000000,b);b=j[b>>2]+ -64|0}j[c>>2]=b;return a}j[b>>2]=c-1022;PMa(0,d|0);PMa(1,e&-2146435073|1071644672);a=+QMa()}return a}function py(a,b){var c=0,d=0,e=0,f=0;c=a;d=a+1024|0;a:{if((d|0)==(a|0)){b=0;break a}f=b?224:240;b=0;while(1){a=c;e=a+16|0;if((a|0)!=(e|0)){while(1){b=((k[Pb(a,0)|0]&f)!=0)+b|0;a=a+4|0;if((e|0)!=(a|0)){continue}break}}c=c+16|0;if((d|0)!=(c|0)){continue}break}}return b}function Dka(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=Za-32|0;Za=c;e=-1;d=a;a=c+8|0;d=oka(d,a);if(!d){PI(a)}a:{if(!d){break a}e=0;if(!TI(c+8|0)){break a}if(b){a=c+16|0;if(j[b>>2]!=(k[a|0]|k[a+1|0]<<8|(k[a+2|0]<<16|k[a+3|0]<<24))|j[b+4>>2]){break a}}e=1}Za=c+32|0;return e|0}function e4(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0;a:{if(!k[a+44|0]){c=(c|0)>0?c:0;while(1){if((c|0)==(d|0)){break a}if(((f=a,g=gg(h[b|0]),e=j[j[a>>2]+52>>2],bb[e](f|0,g|0)|0)|0)==-1){return d|0}else{b=b+1|0;d=d+1|0;continue}}}c=Bi(b,1,c,j[a+32>>2])}return c|0}function $ya(a,b){var c=0,d=0,e=0;e=Za-16|0;Za=e;c=e;j[c>>2]=a;d=j[a+4>>2];j[c+4>>2]=d;j[c+8>>2]=d+56;d=hb(a);a=j[c+4>>2];j[114630]=0;I(973,d|0,a|0,b|0);a=j[114630];j[114630]=0;if((a|0)!=1){j[c+4>>2]=j[c+4>>2]+56;ub(c);Za=e+16|0;return}a=D()|0;C()|0;ub(c);G(a|0);z()}function zqa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0;d=Za-16|0;Za=d;j[d+12>>2]=c;j[d+8>>2]=j[a>>2];e=j[tb(d+12|0,d+8|0)>>2];b=lb(b);if(e){a=j[a+20>>2];c=e;while(1){f=a,g=lb(k[b|0])^128,h[f|0]=g;a=a+1|0;b=b+1|0;c=c-1|0;if(c){continue}break}}Za=d+16|0;return e|0}function LIa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=Za-16|0;Za=d;h[d+15|0]=1;h[d+14|0]=a>>>2;a=k[Vg(d+15|0,d+14|0)|0];e=b>>>0<2|a>>>0<15;if(!e){h[d+13|0]=1;h[d+12|0]=((a+b|0)-2|0)/(b-1|0);a=k[Vg(d+13|0,d+12|0)|0]}Za=d+16|0;return(c?a<<4|(e?15:0):a&15|(e?-16:0))&255}function u9(a,b){a=a|0;b=b|0;var c=q(0),d=q(0);a:{if((b|0)<0){break a}a=a+24|0;if(l[j[a>>2]+480188>>1]<=(b|0)){break a}b=p(b,896);c=q(q(k[(b+j[a>>2]|0)+1075847|0])*q(.0078125));d=q(c*c);c=q(q(k[(b+j[a>>2]|0)+1075846|0])*q(.0078125));c=q(y(q(d+q(c*c))))}return q(c)}function wi(a,b){var c=0,d=0,e=0,f=0;if(b){c=j[a>>2];while(1){a:{if(c){d=j[a+4>>2];break a}j[a>>2]=8;c=j[a+12>>2];if((c|0)!=j[a+8>>2]){c=c-1|0;j[a+12>>2]=c}d=k[c|0];c=8}c=c-1|0;j[a>>2]=c;j[a+4>>2]=d>>>1;e=d&1|e<<1;f=f+1|0;if((f|0)!=(b|0)){continue}break}}return e}function ix(a,b){var c=0,d=0;a:{if(b){ix(a,j[b>>2]);ix(a,j[b+4>>2]);a=Rb(a);j[114630]=0;c=H(1381,b+16|0)|0;d=j[114630];j[114630]=0;if((d|0)==1){break a}j[114630]=0;F(1382,a|0,c|0);c=j[114630];j[114630]=0;if((c|0)==1){break a}Cs(a,b,1)}return}J(0)|0;C()|0;ib();z()}function iEa(a,b,c){var d=0;d=Za-32|0;Za=d;j[d+16>>2]=b;j[d+24>>2]=a;j[d+8>>2]=c;a:{if(!rb(d+24|0,d+16|0)){break a}while(1){a=j[d+24>>2];if(j[j[d+8>>2]>>2]==(k[a|0]|k[a+1|0]<<8)){break a}gk(d+24|0);if(rb(d+24|0,d+16|0)){continue}break}}Za=d+32|0;return j[d+24>>2]}function _1(a,b,c){var d=0;d=Za-16|0;Za=d;j[d+12>>2]=c;j[d+8>>2]=0;j[d+4>>2]=4;zk(a,d+8|0,j[tb(d+12|0,d+4|0)>>2]);a=ab;if((a|0)>0?1:(a|0)>=0){j[d+4>>2]=4;tb(d+12|0,d+4|0)}j[d+4>>2]=j[d+8>>2];a=d+4|0;j[b>>2]=k[a|0]|k[a+1|0]<<8|(k[a+2|0]<<16|k[a+3|0]<<24);Za=d+16|0}function Lr(a,b){var c=0,d=0;a:{if(b){Lr(a,j[b>>2]);Lr(a,j[b+4>>2]);a=Rb(a);j[114630]=0;c=H(1376,b+14|0)|0;d=j[114630];j[114630]=0;if((d|0)==1){break a}j[114630]=0;F(1377,a|0,c|0);c=j[114630];j[114630]=0;if((c|0)==1){break a}$o(a,b,1)}return}J(0)|0;C()|0;ib();z()}function GQ(a){var b=0;a:{if((k[a|0]|k[a+1|0]<<8|(k[a+2|0]<<16|k[a+3|0]<<24))!=778924148?(k[a|0]|k[a+1|0]<<8|(k[a+2|0]<<16|k[a+3|0]<<24))!=1297108297:0){break a}b=a+34|0;if((k[b|0]|k[b+1|0]<<8)>>>0>255){break a}a=a+36|0;return(k[a|0]|k[a+1|0]<<8)>>>0<4e3}return 0}function Y4(a,b){var c=q(0),d=0,e=0,f=0,g=q(0);if((a|0)>=2){a=a>>1;d=(a|0)>1?a:1;e=1/+(a|0);a=0;while(1){c=q(Kh((+(a|0)*1.5707963705062866+.7853981852531433)*e));f=(a<<2)+b|0,g=q(Kh(+q(c*c)*1.5707963705062866)),n[f>>2]=g;a=a+1|0;if((d|0)!=(a|0)){continue}break}}}function PH(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0;e=Za-16|0;Za=e;j[e+12>>2]=0;Bc(a+12|0,d);if(b){d=b;if(b>>>0>2097151){oc(32651);z()}f=ac(d<<11,4)}j[a>>2]=f;c=(c<<11)+f|0;j[a+8>>2]=c;j[a+4>>2]=c;g=Ob(a),h=(b<<11)+f|0,j[g>>2]=h;Za=e+16|0;return a|0}function NH(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0;e=Za-16|0;Za=e;j[e+12>>2]=0;Bc(a+12|0,d);if(b){d=b;if(b>>>0>1073741823){oc(32651);z()}f=ac(d<<2,4)}j[a>>2]=f;c=(c<<2)+f|0;j[a+8>>2]=c;j[a+4>>2]=c;g=Ob(a),h=(b<<2)+f|0,j[g>>2]=h;Za=e+16|0;return a|0}function NEa(a,b){var c=0,d=0;c=Za-16|0;Za=c;d=j[b+12>>2];j[c+8>>2]=j[b+8>>2];j[c+12>>2]=d;d=j[b+4>>2];j[c>>2]=j[b>>2];j[c+4>>2]=d;PJa(a,WP(c));j[a>>2]=76580;d=j[b+4>>2];j[a+296>>2]=j[b>>2];j[a+300>>2]=d;d=j[b+12>>2];j[a+304>>2]=j[b+8>>2];j[a+308>>2]=d;Za=c+16|0}function Koa(a,b){var c=0,d=0,e=0,f=0;c=Za-96|0;Za=c;ZK(b,c,c+96|0);b=0;while(1){d=b<<3;e=d+a|0;f=j[c+d>>2];d=j[(d|4)+c>>2];j[e>>2]=f;j[e+4>>2]=d&65535;b=b+1|0;if((b|0)!=12){continue}break}j[a+104>>2]=0;j[a+96>>2]=!(j[a+88>>2]|j[a+92>>2]);j[a+100>>2]=0;Za=c+96|0}function yqa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0;e=Za-16|0;Za=e;j[e+12>>2]=c;j[e+8>>2]=j[a>>2];f=j[tb(e+12|0,e+8|0)>>2];b=lb(b);if(f){a=j[a+20>>2];c=f;while(1){d=lb(k[b|0])+d|0;h[a|0]=d;a=a+1|0;b=b+1|0;c=c-1|0;if(c){continue}break}}Za=e+16|0;return f|0}function gJa(a){var b=0,c=0,d=0,e=0;if(!k[a+8|0]){if(k[a+24|0]){h[a+24|0]=0;c=a+40|0;while(1){d=mi(c,b),e=0,h[d+8|0]=e;b=b+1|0;if((b|0)!=16){continue}break}b=a+28|0;fk(b,0);wR(b)}b=a+12|0;fk(b,j[a+4>>2]);bb[j[j[a>>2]+44>>2]](a,j[b>>2],0,j[a+4>>2])|0;h[a+8|0]=1}}function bta(a){a=a|0;var b=0,c=0,d=0;c=Za-32|0;Za=c;b=255;a:{if(rh(a)>>>0<=49){b=Kx(c,j[a+12>>2]);j[114630]=0;F(1173,a|0,b|0);d=j[114630];j[114630]=0;if((d|0)==1){break a}hl(b);Oo(a,rh(a)-1&255);b=rh(a)-1|0}Za=c+32|0;return b&255}a=D()|0;C()|0;hl(b);G(a|0);z()}function Qy(a,b){var c=0,d=0;a:{if(b){Qy(a,j[b>>2]);Qy(a,j[b+4>>2]);a=Rb(a);j[114630]=0;c=H(732,b+16|0)|0;d=j[114630];j[114630]=0;if((d|0)==1){break a}j[114630]=0;F(733,a|0,c|0);c=j[114630];j[114630]=0;if((c|0)==1){break a}Yg(a,b,1)}return}J(0)|0;C()|0;ib();z()}function Oy(a,b){var c=0,d=0;a:{if(b){Oy(a,j[b>>2]);Oy(a,j[b+4>>2]);a=Rb(a);j[114630]=0;c=H(728,b+16|0)|0;d=j[114630];j[114630]=0;if((d|0)==1){break a}j[114630]=0;F(731,a|0,c|0);c=j[114630];j[114630]=0;if((c|0)==1){break a}Yg(a,b,1)}return}J(0)|0;C()|0;ib();z()}function No(a,b,c,d){var e=0,f=0,g=0,i=0;a:{e=Vj(a,b);if((e|0)==255){break a}if(Vi(a)){break a}b=mi(a+314|0,e);e=KL(e);if(!(f=0,g=!(h[Pb(b,10)|0]&1),i=d,i?f:g)){Pg(j[a>>2],e- -64&65535,JL(c,k[Pb(b,2)|0]))}if(d){break a}Pg(j[a>>2],e+67&65535,JL(c,k[Pb(b,3)|0]))}}function E2(){var a=0,b=0;a=Za-16|0;Za=a;a:{if(Ka(a+12|0,a+8|0)|0){break a}b=Yc((j[a+12>>2]<<2)+4|0);j[115415]=b;if(!b){break a}b=Yc(j[a+8>>2]);if(!b){j[115415]=0;break a}j[j[115415]+(j[a+12>>2]<<2)>>2]=0;if(!(Ja(j[115415],b|0)|0)){break a}j[115415]=0}Za=a+16|0}function Ay(a,b){var c=0,d=0;a:{if(b){Ay(a,j[b>>2]);Ay(a,j[b+4>>2]);a=Rb(a);j[114630]=0;c=H(822,b+14|0)|0;d=j[114630];j[114630]=0;if((d|0)==1){break a}j[114630]=0;F(823,a|0,c|0);c=j[114630];j[114630]=0;if((c|0)==1){break a}$o(a,b,1)}return}J(0)|0;C()|0;ib();z()}function Aqa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0;d=Za-16|0;Za=d;j[d+12>>2]=c;j[d+8>>2]=j[a>>2];e=j[tb(d+12|0,d+8|0)>>2];b=lb(b);if(e){a=j[a+20>>2];c=e;while(1){f=a,g=Im(k[b|0]),h[f|0]=g;a=a+1|0;b=b+1|0;c=c-1|0;if(c){continue}break}}Za=d+16|0;return e|0}function ww(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;a:{if(!df(a)){break a}while(1){if(!uh(te(a,e))){break a}d=d+1|0;e=d&65535;if(df(a)>>>0>e>>>0){continue}break}}if(!(l[j[j[a+12>>2]+8>>2]+10>>1]<=(d&65535)>>>0?c:0)){return(Wf(a,d&65535,b)?d:-1)&65535}return 65535}function Vna(a,b){var c=0,d=0,e=0;a:{if(k[a+4|0]){c=j[a>>2];j[114630]=0;d=H(1381,b+16|0)|0;e=j[114630];j[114630]=0;if((e|0)==1){break a}j[114630]=0;F(1382,c|0,d|0);c=j[114630];j[114630]=0;if((c|0)==1){break a}}if(b){Cs(j[a>>2],b,1)}return}J(0)|0;C()|0;ib();z()}function O5(a){var b=0,c=0,d=q(0);if((a|0)<=128){return n[(a<<2)+48144>>2]}c=(a|0)<1024;a=c?a<<3:a;b=a<<1&64;d=q(q((a&63)-b|0)/q((a&-64)+b|0));return q(q(q(q(q(q(d*q(.2222222238779068))+q(1.3333333730697632))*d)+q(1))*(c?q(16):q(256)))*n[(a+b>>6<<2)+48144>>2])}function Dj(a){var b=0,c=0;a:{b=j[a+1396>>2];if((b|0)>24){break a}if(!b){j[a+1392>>2]=0}while(1){if(k[a+1376|0]?0:j[a+1384>>2]){break a}c=Xq(a);if((c|0)==-1){break a}b=j[a+1396>>2];j[a+1396>>2]=b+8;j[a+1392>>2]=j[a+1392>>2]+(c<<b);if((b|0)<17){continue}break}}}function CC(a){a=a|0;var b=0,c=0,d=0;j[a>>2]=64792;b=j[a+8>>2];j[114630]=0;c=T(2446)|0;d=j[114630];j[114630]=0;a:{if((d|0)!=1){if((b|0)==(c|0)){break a}b=j[a+8>>2];j[114630]=0;Zu(b);b=j[114630];j[114630]=0;if((b|0)!=1){break a}}J(0)|0;C()|0;ib();z()}return a|0}function AX(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0;if(Qf(a,j[b+8>>2],0)){xu(b,c,d);return}e=j[a+12>>2];f=a+16|0;GB(f,b,c,d);a:{if((e|0)<2){break a}e=(e<<3)+f|0;a=a+24|0;while(1){GB(a,b,c,d);a=a+8|0;if(e>>>0<=a>>>0){break a}if(!k[b+54|0]){continue}break}}}function $na(a,b){var c=0,d=0,e=0;a:{if(k[a+4|0]){c=j[a>>2];j[114630]=0;d=H(1376,b+14|0)|0;e=j[114630];j[114630]=0;if((e|0)==1){break a}j[114630]=0;F(1377,c|0,d|0);c=j[114630];j[114630]=0;if((c|0)==1){break a}}if(b){$o(j[a>>2],b,1)}return}J(0)|0;C()|0;ib();z()}function wx(a,b){var c=0,d=0;a:{if(b){wx(a,j[b>>2]);wx(a,j[b+4>>2]);a=Rb(a);j[114630]=0;c=H(1251,b+16|0)|0;d=j[114630];j[114630]=0;if((d|0)==1){break a}j[114630]=0;F(1252,a|0,c|0);a=j[114630];j[114630]=0;if((a|0)==1){break a}vx(b)}return}J(0)|0;C()|0;ib();z()}function hC(a,b){var c=0,d=0,e=0,f=0,g=0;c=Za-16|0;Za=c;j[b>>2]=0;h[c+15|0]=0;f=Dg(a,c+15|0);d=k[c+15|0];j[b>>2]=d>>>2;d=d&3;if(d){while(1){h[c+15|0]=0;g=Dg(a,c+15|0);e=e+1|0;j[b>>2]=j[b>>2]|k[c+15|0]<<(e<<3)-2;f=f&g;if((d|0)!=(e|0)){continue}break}}Za=c+16|0}function Nq(a,b){var c=0,d=0,e=0;c=-1;a:{if((a|0)==-1){break a}e=j[b+76>>2]>=0;b:{d=j[b+4>>2];c:{if(!d){oE(b);d=j[b+4>>2];if(!d){break c}}if(j[b+44>>2]-8>>>0<d>>>0){break b}}if(!e){break a}return-1}c=d-1|0;j[b+4>>2]=c;h[c|0]=a;j[b>>2]=j[b>>2]&-17;c=a}return c}function AK(a,b,c){a:{switch(b|0){case 0:YJ(a,c);return;case 1:Mna(a,c);return;case 2:Ina(a,c);return;case 3:uo(a,c,1520);return;case 4:uo(a,c,2544);return;case 5:uo(a,c,3568);return;case 6:uo(a,c,4592);return;case 7:uo(a,c,5616);return;default:break a}}Le(a)}function $D(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=Za-16|0;Za=c;d=R(16)|0;bE();a=Cc(c+8|0,a,85376);j[114630]=0;e=j[a+4>>2];j[c>>2]=j[a>>2];j[c+4>>2]=e;K(2354,d|0,c|0,b|0)|0;a=j[114630];j[114630]=0;if((a|0)!=1){X(d|0,58432,2355);z()}a=D()|0;C()|0;S(d|0);G(a|0);z()}function rCa(a,b){var c=0,d=0,e=0;a:{if(k[a+4|0]){c=j[a>>2];j[114630]=0;d=H(822,b+14|0)|0;e=j[114630];j[114630]=0;if((e|0)==1){break a}j[114630]=0;F(823,c|0,d|0);c=j[114630];j[114630]=0;if((c|0)==1){break a}}if(b){$o(j[a>>2],b,1)}return}J(0)|0;C()|0;ib();z()}function qFa(a,b){var c=0,d=0,e=0;a:{if(k[a+4|0]){c=j[a>>2];j[114630]=0;d=H(728,b+16|0)|0;e=j[114630];j[114630]=0;if((e|0)==1){break a}j[114630]=0;F(731,c|0,d|0);c=j[114630];j[114630]=0;if((c|0)==1){break a}}if(b){Yg(j[a>>2],b,1)}return}J(0)|0;C()|0;ib();z()}function lia(a,b){var c=0,d=0,e=0;a:{if(k[a+4|0]){c=j[a>>2];j[114630]=0;d=H(732,b+16|0)|0;e=j[114630];j[114630]=0;if((e|0)==1){break a}j[114630]=0;F(733,c|0,d|0);c=j[114630];j[114630]=0;if((c|0)==1){break a}}if(b){Yg(j[a>>2],b,1)}return}J(0)|0;C()|0;ib();z()}function hJ(a,b){var c=0,d=0,e=0,f=0;c=Za-32|0;Za=c;if(j[a+4>>2]==j[b+4>>2]){d=j[a+4>>2];e=j[a>>2];j[c+24>>2]=e;j[c+28>>2]=d;f=j[b+4>>2];a=c;b=j[b>>2];j[a+16>>2]=b;j[a+20>>2]=f;j[a+8>>2]=e;j[a+12>>2]=d;j[a>>2]=b;j[a+4>>2]=f;d=!Zla(a+8|0,a)}Za=c+32|0;return d}function cV(a,b,c,d){var e=0,f=0,g=0;f=Za-48|0;Za=f;e=f+40|0;e=bV(f+24|0,TA(e,1),Cc(f+16|0,e,1));g=j[e>>2];j[114630]=0;P(285,g|0,b|0,c|0,d|0)|0;b=j[114630];j[114630]=0;if((b|0)!=1){Fn(a,Ob(j[e>>2]),ud(e));MA(e);Za=f+48|0;return}a=D()|0;C()|0;MA(e);G(a|0);z()}function KAa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=Pz(a);a:{if(!b){break a}j[114630]=0;F(916,a|0,b|0);e=j[114630];j[114630]=0;if((e|0)!=1){j[114630]=0;I(917,a|0,b|0,c|0);b=j[114630];j[114630]=0;if((b|0)!=1){break a}}a=D()|0;C()|0;ut(d);G(a|0);z()}return a|0}function $La(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=Px(a);a:{if(!b){break a}j[114630]=0;F(404,a|0,b|0);e=j[114630];j[114630]=0;if((e|0)!=1){j[114630]=0;I(405,a|0,b|0,c|0);b=j[114630];j[114630]=0;if((b|0)!=1){break a}}a=D()|0;C()|0;ms(d);G(a|0);z()}return a|0}function s0(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0;g=Za-16|0;Za=g;j[g+8>>2]=b;hc(g,d);j[114630]=0;b=H(2450,g|0)|0;d=j[114630];j[114630]=0;if((d|0)!=1){wb(g);WC(a,f+24|0,g+8|0,c,e,b);Za=g+16|0;return j[g+8>>2]}a=D()|0;C()|0;wb(g);G(a|0);z()}function r0(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0;g=Za-16|0;Za=g;j[g+8>>2]=b;hc(g,d);j[114630]=0;b=H(2450,g|0)|0;d=j[114630];j[114630]=0;if((d|0)!=1){wb(g);VC(a,f+16|0,g+8|0,c,e,b);Za=g+16|0;return j[g+8>>2]}a=D()|0;C()|0;wb(g);G(a|0);z()}function kS(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=eU(a);a:{if(!b){break a}j[114630]=0;F(467,a|0,b|0);e=j[114630];j[114630]=0;if((e|0)!=1){j[114630]=0;I(468,a|0,b|0,c|0);b=j[114630];j[114630]=0;if((b|0)!=1){break a}}a=D()|0;C()|0;xA(d);G(a|0);z()}return a|0}function it(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=Qt(a);a:{if(!b){break a}j[114630]=0;F(563,a|0,b|0);e=j[114630];j[114630]=0;if((e|0)!=1){j[114630]=0;I(564,a|0,b|0,c|0);b=j[114630];j[114630]=0;if((b|0)!=1){break a}}a=D()|0;C()|0;Np(d);G(a|0);z()}return a|0}function _X(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0;f=Za-16|0;Za=f;d=oq(a);e=nb(a);a:{if(d-e>>>0>=c>>>0){if(!c){break a}d=zb(a);Jh(d+(e<<2)|0,b,c);b=c+e|0;Bg(a,b);j[f+12>>2]=0;ye(d+(b<<2)|0,f+12|0);break a}QB(a,d,(c+e|0)-d|0,e,e,0,c,b)}Za=f+16|0;return a|0}function BQ(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=Xy(a);a:{if(!b){break a}j[114630]=0;F(680,a|0,b|0);e=j[114630];j[114630]=0;if((e|0)!=1){j[114630]=0;I(681,a|0,b|0,c|0);b=j[114630];j[114630]=0;if((b|0)!=1){break a}}a=D()|0;C()|0;Ts(d);G(a|0);z()}return a|0}function pta(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0;d=Za-32|0;Za=d;j[d+16>>2]=c;j[d+24>>2]=b;b=j[a>>2];e=d,f=Lb(a),j[e+8>>2]=f;b=b+(wp(d+24|0,d+8|0)<<1)|0;if(rb(d+24|0,d+16|0)){Cp(a,Pe(b+(wp(d+16|0,d+24|0)<<1)|0,j[a+4>>2],b))}a=Qe(b);Za=d+32|0;return a|0}function kfa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;rH(a,b,c,d);j[a+4232>>2]=1056964608;b=a+4224|0;j[b>>2]=1056964608;j[b+4>>2]=1048406533;b=a+4216|0;j[b>>2]=1020054733;j[b+4>>2]=1065353216;j[a+4208>>2]=1056964608;j[a+4212>>2]=1065353216;j[a>>2]=81212;return a|0}function fka(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0;d=Za-32|0;Za=d;j[d+16>>2]=c;j[d+24>>2]=b;b=j[a>>2];e=d,f=Lb(a),j[e+8>>2]=f;b=b+p(Ar(d+24|0,d+8|0),6)|0;if(rb(d+24|0,d+16|0)){Vy(a,Aw(b+p(Ar(d+16|0,d+24|0),6)|0,j[a+4>>2],b))}a=Qe(b);Za=d+32|0;return a|0}function f8(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0;d=Za-16|0;Za=d;e=Hq(a);j[a>>2]=76912;f=bw(a+32|0,d+8|0);j[a+48>>2]=c;j[a+44>>2]=0;j[114630]=0;F(182,a|0,b|0);b=j[114630];j[114630]=0;if((b|0)!=1){Za=d+16|0;return a|0}a=D()|0;C()|0;gb(f);Nk(e);G(a|0);z()}function aaa(a,b){var c=0,d=0,e=0;c=Za-80|0;Za=c;j[c+40>>2]=j[b+32>>2];j[c>>2]=j[b+36>>2];e=j[zf(c+40|0,c)>>2];a:{if(j[b+32>>2]==j[Uo(c+40|0)+32>>2]){d=-1;if(j[b+36>>2]==j[Uo(c)+36>>2]){break a}}d=0;if((e|0)<1){break a}d=(e+500|0)/1e3|0}j[a>>2]=d;Za=c+80|0}function zr(a,b,c){var d=0,e=0,f=0;d=Za-32|0;Za=d;a:{if(!(!b|!c)){e=Db(d,b);j[114630]=0;I(1562,d+16|0,e|0,c|0);f=j[114630];j[114630]=0;if((f|0)==1){break a}ob(a+36|0,d+16|0);gb(d+16|0);gb(e)}Za=d+32|0;return(b|0)!=0&(c|0)!=0}a=D()|0;C()|0;gb(e);G(a|0);z()}function m2(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0;a:{while(1){if((d|0)!=(e|0)){a=-1;if((b|0)==(c|0)){break a}f=j[b>>2];g=j[d>>2];if((f|0)<(g|0)){break a}if((f|0)>(g|0)){return 1}else{d=d+4|0;b=b+4|0;continue}}break}a=(b|0)!=(c|0)}return a|0}function ar(a){var b=0,c=0,d=0,e=0;b=Za-16|0;Za=b;j[b+12>>2]=12;j[b+8>>2]=32;if(j[tb(b+12|0,b+8|0)>>2]){while(1){e=Bo(a);j[b+8>>2]=32;c=c<<15^e;d=d+15|0;if(d>>>0<m[tb(b+12|0,b+8|0)>>2]){continue}break}}Za=b+16|0;a=j[b+12>>2];return(a>>>0>31?-1:-1<<a^-1)&c}function Xma(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=Za-16|0;Za=d;e=Za-16|0;Za=e;xJ(d,b,c<<24>>24);Za=e+16|0;b=d;c=zb(d);e=nb(d);j[114630]=0;K(196,a|0,c|0,e|0)|0;c=j[114630];j[114630]=0;if((c|0)!=1){gb(b);Za=d+16|0;return a|0}a=D()|0;C()|0;gb(b);G(a|0);z()}function Usa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0;e=Za-32|0;Za=e;j[e+24>>2]=d;d=kj(a,c);Ve(e,j[a+28>>2]);f=j[e+12>>2];j[e+16>>2]=j[e+8>>2];j[e+20>>2]=f;a:{if(!d){if(gd(a,5)){break a}}Ssa(e+24|0,j[a+28>>2],b)}a=Ei(a,d,c,e+16|0);Za=e+32|0;return a|0}function L0(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0;g=Za-16|0;Za=g;j[g+8>>2]=b;hc(g,d);j[114630]=0;b=H(21,g|0)|0;d=j[114630];j[114630]=0;if((d|0)!=1){wb(g);_C(a,f+24|0,g+8|0,c,e,b);Za=g+16|0;return j[g+8>>2]}a=D()|0;C()|0;wb(g);G(a|0);z()}function K0(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0;g=Za-16|0;Za=g;j[g+8>>2]=b;hc(g,d);j[114630]=0;b=H(21,g|0)|0;d=j[114630];j[114630]=0;if((d|0)!=1){wb(g);ZC(a,f+16|0,g+8|0,c,e,b);Za=g+16|0;return j[g+8>>2]}a=D()|0;C()|0;wb(g);G(a|0);z()}function wla(a){a=a|0;var b=0,c=0,d=0,e=0,f=0;b=Za-16|0;Za=b;d=Zc(a);e=b,f=Lb(a),j[e+8>>2]=f;e=b,f=Mb(a),j[e>>2]=f;if(rb(b+8|0,b)){c=+(d>>>0);while(1){a=j[b+8>>2];o[a>>3]=o[a>>3]/c;o[a+8>>3]=o[a+8>>3]/c;yf(b+8|0);if(rb(b+8|0,b)){continue}break}}Za=b+16|0}function qS(a){var b=0,c=0,d=0,e=0;b=a+5|0;b=k[b|0]|k[b+1|0]<<8;c=b+k[a+2|0]|0;d=b>>>0>c>>>0?1:d;b=c;c=b<<1;b=d<<1|b>>>31;e=c;a=a+3|0;a=k[a|0]|k[a+1|0]<<8;d=a>>>30|0;c=a<<2;e=e+c|0;a=b+d|0;a=c>>>0>e>>>0?a+1|0:a;b=e+47|0;if(b>>>0<47){a=a+1|0}ab=a;return b}function EK(a,b,c){var d=0,e=0;d=(c|0)==1;c=j[(p(b,896)+a|0)+1075072>>2];a:{if(d&(c&134218752)!=0|c&67108864){break a}if(l[a+480188>>1]<=b>>>0){c=l[(p(b,896)+a|0)+1075792>>1];b=c?c-1|0:b}b=b&65535;if(b>>>0>126){break a}e=k[((b<<5)+a|0)+480288|0]}return e}function p2(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0;a:{while(1){if((d|0)!=(e|0)){a=-1;if((b|0)==(c|0)){break a}f=h[b|0];g=h[d|0];if((f|0)<(g|0)){break a}if((f|0)>(g|0)){return 1}else{d=d+1|0;b=b+1|0;continue}}break}a=(b|0)!=(c|0)}return a|0}function Jz(a,b,c){var d=0,e=0;a=a+3|0;a=(k[a|0]|k[a+1|0]<<8)>>>p(c,3)|0;d=a>>>2&1|k[b+12|0]&-4;e=d|a<<1&2;if(a&2){h[b+12|0]=e|4;return}h[b+12|0]=e&251;if(!(!(a>>>9-(c<<1)&1)|(a&3)!=1)){a=k[b+13|0]|k[b+14|0]<<8;h[b+15|0]=a;h[b+16|0]=a>>>8;h[b+12|0]=d|4}}function DMa(a,b,c,d){var e=0,f=0,g=0,h=0;e=b;f=e>>31;e=e>>31;a=a^e;g=a-e|0;h=(b^f)-((a>>>0<e>>>0)+f|0)|0;e=d;f=e>>31;e=e>>31;a=c^e;e=KMa(g,h,a-e|0,(d^f)-((a>>>0<e>>>0)+f|0)|0);b=b^d;c=b>>31;a=b>>31;b=e^a;d=b-a|0;ab=(c^ab)-((a>>>0>b>>>0)+c|0)|0;return d}function wDa(a){var b=0;b=Za-16|0;Za=b;h[a|0]=0;h[a+1|0]=0;h[a+2|0]=0;h[a+3|0]=0;h[a+4|0]=0;h[a+5|0]=0;h[a+6|0]=0;h[a+7|0]=0;h[a+16|0]=0;h[a+17|0]=0;h[a+8|0]=0;h[a+9|0]=0;h[a+10|0]=0;h[a+11|0]=0;h[a+12|0]=0;h[a+13|0]=0;h[a+14|0]=0;h[a+15|0]=0;Za=b+16|0}function aka(a,b){a=a|0;b=b|0;var c=0,d=0;d=Za-32|0;Za=d;c=Kj(a);if(b){c=p(b,c);a:{b:{if(j[a+12>>2]!=(b|0)){break b}if((Lf(a)|0)!=(c|0)){break b}cka(a);break a}th(d+8|0);c=BQ(d+16|0,c,d+8|0);$ja(a,c);ol(c);j[a+12>>2]=b}a=1}else{a=0}Za=d+32|0;return a|0}function Wi(a){a=a|0;var b=0,c=0;b=Za-48|0;Za=b;if(!Xc(a)){jM(b+32|0,a);iM(b+24|0,a);c=j[b+36>>2];j[b+16>>2]=j[b+32>>2];j[b+20>>2]=c;c=j[b+28>>2];j[b+8>>2]=j[b+24>>2];j[b+12>>2]=c;mta(b+40|0,b+16|0,b+8|0);c=vz(Lb(a),j[b+44>>2])}Za=b+48|0;return c&65535}function kna(a){var b=0,c=0;c=a+946300|0;b=a+906300|0;while(1){a=j[b>>2];a:{if(!a){break a}if(!(bb[j[j[a>>2]+112>>2]](a)|0)){break a}bb[j[j[a>>2]+104>>2]](a,0);bb[j[j[a>>2]+92>>2]](a);bb[j[j[a>>2]+120>>2]](a)}b=b+160|0;if((c|0)!=(b|0)){continue}break}}function oE(a){var b=0,c=0;b=k[a+74|0];h[a+74|0]=b-1|b;if(m[a+20>>2]>m[a+28>>2]){bb[j[a+36>>2]](a,0,0)|0}j[a+28>>2]=0;j[a+16>>2]=0;j[a+20>>2]=0;b=j[a>>2];if(b&4){j[a>>2]=b|32;return-1}c=j[a+44>>2]+j[a+48>>2]|0;j[a+8>>2]=c;j[a+4>>2]=c;return b<<27>>31}function d7(a,b,c,d,e){var f=0,g=0,h=0,i=0,k=q(0);if(e){while(1){f=0;if(d){while(1){h=j[tf(b,f,g)>>2];Pb(c,f);i=tf(a,f,g),k=q(q(h|0)*q(7.450580596923828e-9)),n[i>>2]=k;f=f+1|0;if((f|0)!=(d|0)){continue}break}}g=g+1|0;if((g|0)!=(e|0)){continue}break}}}function c7(a,b,c,d,e){var f=0,g=0,h=0,i=0,k=q(0);if(e){while(1){f=0;if(d){while(1){h=j[tf(b,f,g)>>2];Ae(c,f);i=tf(a,f,g),k=q(q(h|0)*q(7.450580596923828e-9)),n[i>>2]=k;f=f+1|0;if((f|0)!=(d|0)){continue}break}}g=g+1|0;if((g|0)!=(e|0)){continue}break}}}function I7(a,b,c,d,e){var f=0,g=0,h=0,i=0,k=q(0);if(e){while(1){f=0;if(d){while(1){h=j[tf(b,f,g)>>2];Pb(c,f);i=Um(a,f,g),k=q(q(h|0)*q(7.450580596923828e-9)),n[i>>2]=k;f=f+1|0;if((f|0)!=(d|0)){continue}break}}g=g+1|0;if((g|0)!=(e|0)){continue}break}}}function H7(a,b,c,d,e){var f=0,g=0,h=0,i=0,k=q(0);if(e){while(1){f=0;if(d){while(1){h=j[tf(b,f,g)>>2];Ae(c,f);i=Um(a,f,g),k=q(q(h|0)*q(7.450580596923828e-9)),n[i>>2]=k;f=f+1|0;if((f|0)!=(d|0)){continue}break}}g=g+1|0;if((g|0)!=(e|0)){continue}break}}}function tEa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=Za-48|0;Za=c;a:{if(!yb(a,1)){break a}gEa(b);d=dd(a);if(!d){break a}while(1){d=d-1|0;b:{if(!aEa(a,c+8|0)){break b}e=k[c+8|0];if(e>>>0>63){break b}Vb(OP(b,e),c+8|0,33)}if(d&255){continue}break}}Za=c+48|0}function gr(a){var b=0,c=0;b=a+24|0;c=j[b>>2];j[114630]=0;H(1398,c|0)|0;c=j[114630];j[114630]=0;if((c|0)!=1){Vc(a+68|0);Ye(a+36|0);bf(a+32|0);jh(b);Gc(a+4|0);Gc(a);return a}J(0)|0;C()|0;Vc(a+68|0);Ye(a+36|0);bf(a+32|0);jh(b);Gc(a+4|0);Gc(a);ib();z()}function Sw(a,b,c){var d=0,e=0,f=0;e=Za-16|0;Za=e;f=j[b+656>>2];d=0;a:{if(!f){break a}f=Ct(f,c);d=a+1074308|0;mb(e+8|0,d,31);a=0;if(!kb(e+8|0)){mb(e,d,93);a=kb(e)^1}if(!(h[mJ(b,c)|0]&1)){d=0;if(!(h[f+12|0]&1)|a){break a}}d=Xc(f)^1}Za=e+16|0;return d}function f6(a,b,c,d){var e=0,f=0,g=0,h=0,i=0;g=j[b+4>>2];h=j[b+8>>2];e=j[a+6144>>2];f=e-d|0;e=(d|0)<(e|0)?d:e;f=Vb(c+12|0,(((f|0)>0?f:0)+a|0)+6156|0,e);i=j[b>>2]+(j[b+4>>2]/8|0)|0;b=(h-g|0)/8|0;Vb(e+f|0,i,b);bF(c,f,b+e|0);return j[a+6144>>2]>=(d|0)}function TJa(a,b,c){var d=0;d=Za-32|0;Za=d;j[d+16>>2]=b;j[d+24>>2]=a;j[d+8>>2]=c;a:{if(!rb(d+24|0,d+16|0)){break a}while(1){if((ok(j[d+24>>2])|0)==j[j[d+8>>2]>>2]){break a}gk(d+24|0);if(rb(d+24|0,d+16|0)){continue}break}}Za=d+32|0;return j[d+24>>2]}function s$(a,b){a=a|0;b=b|0;var c=0,d=0;c=G_(a);a:{if(!b){break a}j[114630]=0;F(2555,a|0,b|0);d=j[114630];j[114630]=0;if((d|0)!=1){j[114630]=0;F(2556,a|0,b|0);b=j[114630];j[114630]=0;if((b|0)!=1){break a}}a=D()|0;C()|0;zC(c);G(a|0);z()}return a|0}function q0(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;a=Za-16|0;Za=a;j[a+8>>2]=b;hc(a,d);j[114630]=0;b=H(2450,a|0)|0;d=j[114630];j[114630]=0;if((d|0)!=1){wb(a);UC(f+20|0,a+8|0,c,e,b);Za=a+16|0;return j[a+8>>2]}b=D()|0;C()|0;wb(a);G(b|0);z()}function hCa(a,b){a=a|0;b=b|0;var c=0,d=0;c=UBa(a);a:{if(!b){break a}j[114630]=0;F(870,a|0,b|0);d=j[114630];j[114630]=0;if((d|0)!=1){j[114630]=0;F(871,a|0,b|0);b=j[114630];j[114630]=0;if((b|0)!=1){break a}}a=D()|0;C()|0;UO(c);G(a|0);z()}return a|0}function eCa(a,b){a=a|0;b=b|0;var c=0,d=0;c=RBa(a);a:{if(!b){break a}j[114630]=0;F(872,a|0,b|0);d=j[114630];j[114630]=0;if((d|0)!=1){j[114630]=0;F(873,a|0,b|0);b=j[114630];j[114630]=0;if((b|0)!=1){break a}}a=D()|0;C()|0;TO(c);G(a|0);z()}return a|0}function VFa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0;e=Za-32|0;Za=e;j[e+24>>2]=d;d=kj(a,c);Ve(e,j[a+28>>2]);f=j[e+12>>2];j[e+16>>2]=j[e+8>>2];j[e+20>>2]=f;a:{if(!d){if(gd(a,5)){break a}}sQ(j[a+28>>2],b,j[e+24>>2],0)}Ei(a,d,c,e+16|0);Za=e+32|0}function Owa(a,b){a=a|0;b=b|0;var c=0,d=0;c=Px(a);a:{if(!b){break a}j[114630]=0;F(404,a|0,b|0);d=j[114630];j[114630]=0;if((d|0)!=1){j[114630]=0;F(1049,a|0,b|0);b=j[114630];j[114630]=0;if((b|0)!=1){break a}}a=D()|0;C()|0;ms(c);G(a|0);z()}return a|0}function vj(a,b,c,d){var e=0;if(d&2048){h[a|0]=43;a=a+1|0}if(d&512){h[a|0]=35;a=a+1|0}while(1){e=k[b|0];if(e){h[a|0]=e;a=a+1|0;b=b+1|0;continue}break}e=d&74;b=111;a:{if((e|0)==64){break a}b=d&16384?88:120;if((e|0)==8){break a}b=c?100:117}h[a|0]=b}function kaa(a,b){var c=0,d=0,e=0;c=Za-48|0;Za=c;d=E8(c+24|0,ac(324,4),Cc(c+16|0,c+40|0,1));e=j[d>>2];j[114630]=0;E(2157,e|0,b|0)|0;b=j[114630];j[114630]=0;if((b|0)!=1){Fn(a,Ob(j[d>>2]),ud(d));SF(d);Za=c+48|0;return}a=D()|0;C()|0;SF(d);G(a|0);z()}function WLa(a,b){a=a|0;b=b|0;var c=0,d=0;c=TS(a);a:{if(!b){break a}j[114630]=0;F(406,a|0,b|0);d=j[114630];j[114630]=0;if((d|0)!=1){j[114630]=0;F(407,a|0,b|0);b=j[114630];j[114630]=0;if((b|0)!=1){break a}}a=D()|0;C()|0;RS(c);G(a|0);z()}return a|0}function WFa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0;e=Za-32|0;Za=e;j[e+24>>2]=d;d=kj(a,c);Ve(e,j[a+28>>2]);f=j[e+12>>2];j[e+16>>2]=j[e+8>>2];j[e+20>>2]=f;a:{if(!d){if(gd(a,5)){break a}}MEa(j[a+28>>2],b,j[e+24>>2])}Ei(a,d,c,e+16|0);Za=e+32|0}function UFa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0;e=Za-32|0;Za=e;j[e+24>>2]=d;d=kj(a,c);Ve(e,j[a+28>>2]);f=j[e+12>>2];j[e+16>>2]=j[e+8>>2];j[e+20>>2]=f;a:{if(!d){if(gd(a,5)){break a}}Rsa(j[a+28>>2],b,j[e+24>>2])}Ei(a,d,c,e+16|0);Za=e+32|0}function Nsa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0;e=Za-32|0;Za=e;j[e+24>>2]=d;d=kj(a,c);Ve(e,j[a+28>>2]);f=j[e+12>>2];j[e+16>>2]=j[e+8>>2];j[e+20>>2]=f;a:{if(!d){if(gd(a,5)){break a}}Xsa(j[a+28>>2],b,j[e+24>>2])}Ei(a,d,c,e+16|0);Za=e+32|0}function Ln(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0;f=Za-16|0;Za=f;d=sc(a);e=nb(a);a:{if(d-e>>>0>=c>>>0){if(!c){break a}d=zb(a);kh(d+e|0,b,c);b=c+e|0;Bg(a,b);h[f+15|0]=0;Sd(b+d|0,f+15|0);break a}qu(a,d,(c+e|0)-d|0,e,e,0,c,b)}Za=f+16|0;return a|0}function Iia(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0;e=Za-32|0;Za=e;j[e+24>>2]=d;d=kj(a,c);Ve(e,j[a+28>>2]);f=j[e+12>>2];j[e+16>>2]=j[e+8>>2];j[e+20>>2]=f;a:{if(!d){if(gd(a,5)){break a}}xia(j[a+28>>2],b,j[e+24>>2])}Ei(a,d,c,e+16|0);Za=e+32|0}function Eqa(a,b){var c=0,d=0;a:{if(k[a+4|0]){a=j[a>>2];j[114630]=0;c=H(1251,b+16|0)|0;d=j[114630];j[114630]=0;if((d|0)==1){break a}j[114630]=0;F(1252,a|0,c|0);a=j[114630];j[114630]=0;if((a|0)==1){break a}}if(b){vx(b)}return}J(0)|0;C()|0;ib();z()}function mna(a,b,c,d){var e=0;e=Za-16|0;Za=e;a:{b:{if((b|0)==(c|0)){b=a;a=zb(d);Yh(b,a,nb(d)+a|0);break b}AK(e,c,d);j[114630]=0;I(115,a|0,b|0,e|0);a=j[114630];j[114630]=0;if((a|0)==1){break a}pc(e)}Za=e+16|0;return}a=D()|0;C()|0;pc(e);G(a|0);z()}function jaa(a,b){var c=0,d=0,e=0;c=Za-48|0;Za=c;d=B8(c+24|0,ac(56,4),Cc(c+16|0,c+40|0,1));e=j[d>>2];j[114630]=0;E(2158,e|0,b|0)|0;b=j[114630];j[114630]=0;if((b|0)!=1){Fn(a,Ob(j[d>>2]),ud(d));PF(d);Za=c+48|0;return}a=D()|0;C()|0;PF(d);G(a|0);z()}function bz(a,b){a=a|0;b=b|0;var c=0,d=0;c=Qt(a);a:{if(!b){break a}j[114630]=0;F(563,a|0,b|0);d=j[114630];j[114630]=0;if((d|0)!=1){j[114630]=0;F(669,a|0,b|0);b=j[114630];j[114630]=0;if((b|0)!=1){break a}}a=D()|0;C()|0;Np(c);G(a|0);z()}return a|0}function Jia(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0;e=Za-32|0;Za=e;j[e+24>>2]=d;d=kj(a,c);Ve(e,j[a+28>>2]);f=j[e+12>>2];j[e+16>>2]=j[e+8>>2];j[e+20>>2]=f;a:{if(!d){if(gd(a,5)){break a}}iI(j[a+28>>2],b,j[e+24>>2])}Ei(a,d,c,e+16|0);Za=e+32|0}function J0(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;a=Za-16|0;Za=a;j[a+8>>2]=b;hc(a,d);j[114630]=0;b=H(21,a|0)|0;d=j[114630];j[114630]=0;if((d|0)!=1){wb(a);YC(f+20|0,a+8|0,c,e,b);Za=a+16|0;return j[a+8>>2]}b=D()|0;C()|0;wb(a);G(b|0);z()}function Fla(a,b,c){var d=0,e=0,f=0,g=0;d=Za-16|0;Za=d;b=Rb(b);a=Ela(a,ac(28,4),ak(d+8|0,b));e=j[a>>2];j[114630]=0;I(1521,b|0,e+16|0,c|0);b=j[114630];j[114630]=0;if((b|0)!=1){f=Rb(a),g=1,h[f+4|0]=g;Za=d+16|0;return}b=D()|0;C()|0;_I(a);G(b|0);z()}function Dta(a,b,c){var d=0,e=0,f=0,g=0;d=Za-16|0;Za=d;b=Rb(b);a=Cta(a,ac(16,4),ak(d+8|0,b));e=j[a>>2];j[114630]=0;I(1162,b|0,e+14|0,c|0);b=j[114630];j[114630]=0;if((b|0)!=1){f=Rb(a),g=1,h[f+4|0]=g;Za=d+16|0;return}b=D()|0;C()|0;sM(a);G(b|0);z()}function d1(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;e=Za-16|0;Za=e;j[e+12>>2]=b;j[e+8>>2]=d;b=bh(e,e+12|0);j[114630]=0;a=K(2471,a|0,c|0,j[e+8>>2])|0;c=j[114630];j[114630]=0;if((c|0)!=1){oe(b);Za=e+16|0;return a|0}a=D()|0;C()|0;oe(b);G(a|0);z()}function _n(a,b){var c=0,d=0,e=0,f=0;c=a*a;d=c*.5;e=1-d;f=1-e-d;d=c*c;return e+(f+(c*(c*(c*(c*2480158728947673e-20+ -.001388888888887411)+.0416666666666666)+d*d*(c*(c*-1.1359647557788195e-11+2.087572321298175e-9)+ -2.7557314351390663e-7))-a*b))}function EJa(a,b){a=a|0;b=b|0;var c=0,d=0;c=bA(a);a:{if(!b){break a}j[114630]=0;F(36,a|0,b|0);d=j[114630];j[114630]=0;if((d|0)!=1){j[114630]=0;F(37,a|0,b|0);b=j[114630];j[114630]=0;if((b|0)!=1){break a}}a=D()|0;C()|0;jT(c);G(a|0);z()}return a|0}function iIa(a,b){a=a|0;b=b|0;var c=0;b=Za-32|0;Za=b;c=-1;a:{if(!mz(a,b+16|0)){break a}c=0;if(!eR(b+16|0)){break a}if(j[b+16>>2]==1179472708){c=-1;if(!Fc(a,4)){break a}}c=-1;if(!hj(a,b+8|0)){break a}c=j[b+8>>2]==1196314451}Za=b+32|0;return c|0}function Wd(){var a=0,b=0;a:{b:{if(h[461844]&1){break b}if(!fd(461844)){break b}j[114630]=0;a=K(2448,2147483647,64709,0)|0;b=j[114630];j[114630]=0;if((b|0)==1){break a}j[115460]=a;ed(461844)}return j[115460]}a=D()|0;C()|0;Zd(461844);G(a|0);z()}function PV(a,b){var c=0,d=0,e=0;c=Za-48|0;Za=c;d=OV(c+24|0,ac(24,4),Cc(c+16|0,c+40|0,1));e=j[d>>2];j[114630]=0;E(273,e|0,b|0)|0;b=j[114630];j[114630]=0;if((b|0)!=1){Fn(a,Ob(j[d>>2]),ud(d));fB(d);Za=c+48|0;return}a=D()|0;C()|0;fB(d);G(a|0);z()}function Nja(a,b,c){var d=0,e=0;if(b){while(1){d=c;e=k[d|0]|k[d+1|0]<<8|(k[d+2|0]<<16|k[d+3|0]<<24);h[a|0]=e;h[a+1|0]=e>>>8;h[a+2|0]=e>>>16;h[a+3|0]=e>>>24;d=k[d+4|0]|k[d+5|0]<<8;h[a+4|0]=d;h[a+5|0]=d>>>8;a=a+6|0;b=b-1|0;if(b){continue}break}}}function LL(a){a=a|0;var b=0,c=0,d=0;b=Za-16|0;Za=b;if(k[a+530|0]){while(1){d=c&65535;qh(a,d,1);c=c+1|0;if(d>>>0<255){continue}break}h[a+530|0]=0}h[b+15|0]=0;dj(a+4|0,18,b+15|0);Dy(a+22|0,18,20106);h[b+14|0]=255;dj(a+58|0,256,b+14|0);Za=b+16|0}function BEa(a){a:{if((k[a|0]|k[a+1|0]<<8|(k[a+2|0]<<16|k[a+3|0]<<24))!=(ok(14647)|0)){break a}a=a+4|0;if((k[a|0]|k[a+1|0]<<8|(k[a+2|0]<<16|k[a+3|0]<<24))>>>0>259){break a}return(k[a|0]|k[a+1|0]<<8|(k[a+2|0]<<16|k[a+3|0]<<24))>>>0>255}return 0}function uka(a,b,c,d){var e=0,f=0,g=0,h=0;e=Za-16|0;Za=e;j[e+12>>2]=0;Bc(a+12|0,d);if(b){d=b;if(b>>>0>178956970){oc(31753);z()}f=ac(p(d,24),4)}j[a>>2]=f;c=p(c,24)+f|0;j[a+8>>2]=c;j[a+4>>2]=c;g=Ob(a),h=p(b,24)+f|0,j[g>>2]=h;Za=e+16|0;return a}function oIa(a,b,c,d){var e=0,f=0,g=0,h=0;e=Za-16|0;Za=e;j[e+12>>2]=0;Bc(a+12|0,d);if(b){d=b;if(b>>>0>178956970){oc(12706);z()}f=ac(p(d,24),4)}j[a>>2]=f;c=p(c,24)+f|0;j[a+8>>2]=c;j[a+4>>2]=c;g=Ob(a),h=p(b,24)+f|0,j[g>>2]=h;Za=e+16|0;return a}function jpa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;j[a>>2]=b;c=a+4|0;woa(c,PK(ue(229984),b+1074376|0));b=Woa(a+8|0);d=a+20|0;uoa(d);j[114630]=0;N(1335,a|0);e=j[114630];j[114630]=0;if((e|0)!=1){return a|0}a=D()|0;C()|0;NK(d);jK(b);bf(c);G(a|0);z()}function iq(a,b){var c=0,d=0;if(!a){return Yc(b)}if(b>>>0>=4294967232){j[114604]=48;return 0}c=rX(a-8|0,b>>>0<11?16:b+11&-8);if(c){return c+8|0}c=Yc(b);if(!c){return 0}d=j[a-4>>2];d=(d&3?-4:-8)+(d&-8)|0;Vb(c,a,b>>>0>d>>>0?d:b);Fb(a);return c}function ZDa(a,b,c,d){var e=0,f=0,g=0,h=0;e=Za-16|0;Za=e;j[e+12>>2]=0;Bc(a+12|0,d);if(b){d=b;if(b>>>0>130150524){oc(14703);z()}f=ac(p(d,33),1)}j[a>>2]=f;c=p(c,33)+f|0;j[a+8>>2]=c;j[a+4>>2]=c;g=Ob(a),h=p(b,33)+f|0,j[g>>2]=h;Za=e+16|0;return a}function Kya(a,b,c,d){var e=0,f=0,g=0,h=0;e=Za-16|0;Za=e;j[e+12>>2]=0;Bc(a+12|0,d);if(b){d=b;if(b>>>0>178956970){oc(16924);z()}f=ac(p(d,24),4)}j[a>>2]=f;c=p(c,24)+f|0;j[a+8>>2]=c;j[a+4>>2]=c;g=Ob(a),h=p(b,24)+f|0,j[g>>2]=h;Za=e+16|0;return a}function EHa(a,b,c,d){var e=0,f=0,g=0,h=0;e=Za-16|0;Za=e;j[e+12>>2]=0;Bc(a+12|0,d);if(b){d=b;if(b>>>0>178956970){oc(12852);z()}f=ac(p(d,24),4)}j[a>>2]=f;c=p(c,24)+f|0;j[a+8>>2]=c;j[a+4>>2]=c;g=Ob(a),h=p(b,24)+f|0,j[g>>2]=h;Za=e+16|0;return a}function EDa(a,b,c,d){var e=0,f=0,g=0,h=0;e=Za-16|0;Za=e;j[e+12>>2]=0;Bc(a+12|0,d);if(b){d=b;if(b>>>0>178956970){oc(14703);z()}f=ac(p(d,24),4)}j[a>>2]=f;c=p(c,24)+f|0;j[a+8>>2]=c;j[a+4>>2]=c;g=Ob(a),h=p(b,24)+f|0,j[g>>2]=h;Za=e+16|0;return a}function BJa(a,b,c,d){var e=0,f=0,g=0,h=0;e=Za-16|0;Za=e;j[e+12>>2]=0;Bc(a+12|0,d);if(b){d=b;if(b>>>0>178956970){oc(12489);z()}f=ac(p(d,24),4)}j[a>>2]=f;c=p(c,24)+f|0;j[a+8>>2]=c;j[a+4>>2]=c;g=Ob(a),h=p(b,24)+f|0,j[g>>2]=h;Za=e+16|0;return a}function $qa(a,b,c,d){var e=0,f=0,g=0,h=0;e=Za-16|0;Za=e;j[e+12>>2]=0;Bc(a+12|0,d);if(b){d=b;if(b>>>0>357913941){oc(20181);z()}f=ac(p(d,12),4)}j[a>>2]=f;c=p(c,12)+f|0;j[a+8>>2]=c;j[a+4>>2]=c;g=Ob(a),h=p(b,12)+f|0,j[g>>2]=h;Za=e+16|0;return a}function zKa(a){var b=0;b=Za-16|0;Za=b;h[a|0]=0;h[a+1|0]=0;h[a+2|0]=0;h[a+3|0]=0;h[a+4|0]=0;h[a+5|0]=0;h[a+6|0]=0;h[a+7|0]=0;h[a+16|0]=0;h[a+8|0]=0;h[a+9|0]=0;h[a+10|0]=0;h[a+11|0]=0;h[a+12|0]=0;h[a+13|0]=0;h[a+14|0]=0;h[a+15|0]=0;Za=b+16|0}function una(a,b,c){var d=0;d=Za-32|0;Za=d;j[d+16>>2]=b;j[d+24>>2]=a;j[d+8>>2]=c;a:{if(!rb(d+24|0,d+16|0)){break a}while(1){if(pna(d+8|0,j[j[d+24>>2]>>2])){break a}Id(d+24|0);if(rb(d+24|0,d+16|0)){continue}break}}Za=d+32|0;return j[d+24>>2]}function i8(a,b,c,d){var e=0,f=0,g=0,h=0;e=Za-16|0;Za=e;j[e+12>>2]=0;Bc(a+12|0,d);if(b){d=b;if(b>>>0>178956970){oc(39508);z()}f=ac(p(d,24),8)}j[a>>2]=f;c=p(c,24)+f|0;j[a+8>>2]=c;j[a+4>>2]=c;g=Ob(a),h=p(b,24)+f|0,j[g>>2]=h;Za=e+16|0;return a}function hd(a,b){var c=0,d=0,e=0,f=0,g=0;a:{c=l[a+20>>1];if(c){d=l[a+22>>1];g=c+d|0;c=d;while(1){e=((c&127)<<2)+a|0;f=l[e+28>>1]+b|0;i[e+28>>1]=f;if((f&65535)>>>0>=2048){break a}c=c+1|0;if((g|0)!=(c|0)){continue}break}}return}i[a+20>>1]=c-d}function Zx(a,b,c,d){var e=0,f=0,g=0,h=0;e=Za-16|0;Za=e;j[e+12>>2]=0;Bc(a+12|0,d);if(b){d=b;if(b>>>0>357913941){oc(17388);z()}f=ac(p(d,12),4)}j[a>>2]=f;c=p(c,12)+f|0;j[a+8>>2]=c;j[a+4>>2]=c;g=Ob(a),h=p(b,12)+f|0,j[g>>2]=h;Za=e+16|0;return a}function WK(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0;d=Za-16|0;Za=d;a:{if(!c){break a}j[b+40>>2]=c;if(j[a+480180>>2]!=256){break a}j[d+12>>2]=c>>>4;j[d+8>>2]=1;e=b,f=j[Lc(d+12|0,d+8|0)>>2],j[e+40>>2]=f;e=b,f=LK(c&255),j[e+44>>2]=f}Za=d+16|0}function Dya(a,b,c,d){var e=0,f=0,g=0,h=0;e=Za-16|0;Za=e;j[e+12>>2]=0;Bc(a+12|0,d);if(b){d=b;if(b>>>0>76695844){oc(16924);z()}f=ac(p(d,56),4)}j[a>>2]=f;c=p(c,56)+f|0;j[a+8>>2]=c;j[a+4>>2]=c;g=Ob(a),h=p(b,56)+f|0,j[g>>2]=h;Za=e+16|0;return a}function iR(a,b,c,d){var e=0,f=0,g=0,h=0;e=Za-16|0;Za=e;j[e+12>>2]=0;Bc(a+12|0,d);if(b){d=b;if(b>>>0>89478485){oc(12706);z()}f=ac(p(d,48),4)}j[a>>2]=f;c=p(c,48)+f|0;j[a+8>>2]=c;j[a+4>>2]=c;g=Ob(a),h=p(b,48)+f|0,j[g>>2]=h;Za=e+16|0;return a}function WE(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0;e=Za-16|0;Za=e;if(d>>>0<=4294967279){a:{if(d>>>0<=10){Ue(a,c);d=a;break a}f=Fk(d)+1|0;d=Rh(f);lf(a,d);lg(a,f);ee(a,c)}kh(d,b,c);h[e+15|0]=0;Sd(c+d|0,e+15|0);Za=e+16|0;return}jg();z()}function VD(a,b,c,d){var e=0,f=0,g=0,h=0;e=Za-16|0;Za=e;j[e+12>>2]=0;Bc(a+12|0,d);if(b){d=b;if(b>>>0>357913941){oc(6863);z()}f=ac(p(d,12),4)}j[a>>2]=f;c=p(c,12)+f|0;j[a+8>>2]=c;j[a+4>>2]=c;g=Ob(a),h=p(b,12)+f|0,j[g>>2]=h;Za=e+16|0;return a}function Bsa(a,b,c){var d=0;d=Za-16|0;Za=d;j[d+12>>2]=c;i[d+10>>1]=0;j[d+4>>2]=2;zk(a,d+10|0,j[tb(d+12|0,d+4|0)>>2]);a=ab;if((a|0)>0?1:(a|0)>=0){j[d+4>>2]=2;tb(d+12|0,d+4|0)}i[d+4>>1]=l[d+10>>1];a=d+4|0;i[b>>1]=k[a|0]|k[a+1|0]<<8;Za=d+16|0}function wma(a,b,c,d){var e=0,f=0,g=0,h=0;e=Za-16|0;Za=e;j[e+12>>2]=0;Bc(a+12|0,d);if(b){d=b;if(b>>>0>1073741823){oc(20588);z()}f=ac(d<<2,4)}j[a>>2]=f;c=(c<<2)+f|0;j[a+8>>2]=c;j[a+4>>2]=c;g=Ob(a),h=(b<<2)+f|0,j[g>>2]=h;Za=e+16|0;return a}function twa(a,b,c,d){var e=0,f=0,g=0,h=0;e=Za-16|0;Za=e;j[e+12>>2]=0;Bc(a+12|0,d);if(b){d=b;if(b>>>0>1073741823){oc(17993);z()}f=ac(d<<2,1)}j[a>>2]=f;c=(c<<2)+f|0;j[a+8>>2]=c;j[a+4>>2]=c;g=Ob(a),h=(b<<2)+f|0,j[g>>2]=h;Za=e+16|0;return a}function tV(a){var b=0,c=0,d=0;b=Za-48|0;Za=b;c=sV(b+24|0,ac(16,4),Cc(b+16|0,b+40|0,1));d=j[c>>2];j[114630]=0;H(279,d|0)|0;d=j[114630];j[114630]=0;if((d|0)!=1){Fn(a,Ob(j[c>>2]),ud(c));WA(c);Za=b+48|0;return}a=D()|0;C()|0;WA(c);G(a|0);z()}function rLa(a,b,c,d){var e=0,f=0,g=0,h=0;e=Za-16|0;Za=e;j[e+12>>2]=0;Bc(a+12|0,d);if(b){d=b;if(b>>>0>2147483647){oc(12065);z()}f=ac(d<<1,1)}j[a>>2]=f;c=(c<<1)+f|0;j[a+8>>2]=c;j[a+4>>2]=c;g=Ob(a),h=(b<<1)+f|0,j[g>>2]=h;Za=e+16|0;return a}function bFa(a,b,c,d){var e=0,f=0,g=0,h=0;e=Za-16|0;Za=e;j[e+12>>2]=0;Bc(a+12|0,d);if(b){d=b;if(b>>>0>1073741823){oc(14480);z()}f=ac(d<<2,1)}j[a>>2]=f;c=(c<<2)+f|0;j[a+8>>2]=c;j[a+4>>2]=c;g=Ob(a),h=(b<<2)+f|0,j[g>>2]=h;Za=e+16|0;return a}function UB(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;a:{if(a-b>>2>>>0<c>>>0){while(1){c=c-1|0;d=c<<2;j[d+a>>2]=j[b+d>>2];if(c){continue}break a}}if(!c){break a}d=a;while(1){j[d>>2]=j[b>>2];d=d+4|0;b=b+4|0;c=c-1|0;if(c){continue}break}}return a|0}function Rha(a,b,c,d){var e=0,f=0,g=0,h=0;e=Za-16|0;Za=e;j[e+12>>2]=0;Bc(a+12|0,d);if(b){d=b;if(b>>>0>1073741823){oc(32555);z()}f=ac(d<<2,4)}j[a>>2]=f;c=(c<<2)+f|0;j[a+8>>2]=c;j[a+4>>2]=c;g=Ob(a),h=(b<<2)+f|0,j[g>>2]=h;Za=e+16|0;return a}function Jla(a,b,c,d){var e=0,f=0,g=0,h=0;e=Za-16|0;Za=e;j[e+12>>2]=0;Bc(a+12|0,d);if(b){d=b;if(b>>>0>1073741823){oc(30794);z()}f=ac(d<<2,4)}j[a>>2]=f;c=(c<<2)+f|0;j[a+8>>2]=c;j[a+4>>2]=c;g=Ob(a),h=(b<<2)+f|0,j[g>>2]=h;Za=e+16|0;return a}function JCa(a,b,c,d){var e=0,f=0,g=0,h=0;e=Za-16|0;Za=e;j[e+12>>2]=0;Bc(a+12|0,d);if(b){d=b;if(b>>>0>1073741823){oc(15088);z()}f=ac(d<<2,1)}j[a>>2]=f;c=(c<<2)+f|0;j[a+8>>2]=c;j[a+4>>2]=c;g=Ob(a),h=(b<<2)+f|0,j[g>>2]=h;Za=e+16|0;return a}function ACa(a,b,c,d){var e=0,f=0,g=0,h=0;e=Za-16|0;Za=e;j[e+12>>2]=0;Bc(a+12|0,d);if(b){d=b;if(b>>>0>2147483647){oc(15088);z()}f=ac(d<<1,1)}j[a>>2]=f;c=(c<<1)+f|0;j[a+8>>2]=c;j[a+4>>2]=c;g=Ob(a),h=(b<<1)+f|0,j[g>>2]=h;Za=e+16|0;return a}function sH(a,b,c,d){var e=0,f=0,g=0,h=0;e=Za-16|0;Za=e;j[e+12>>2]=0;Bc(a+12|0,d);if(b){d=b;if(b>>>0>1073741823){oc(33245);z()}f=ac(d<<2,4)}j[a>>2]=f;c=(c<<2)+f|0;j[a+8>>2]=c;j[a+4>>2]=c;g=Ob(a),h=(b<<2)+f|0,j[g>>2]=h;Za=e+16|0;return a}function qba(a){var b=0,c=0;b=Za-48|0;Za=b;xk(b+16|0);a:{if(j[b+28>>2]){c=j[b+28>>2];j[114630]=0;j[b+12>>2]=c;F(2112,a|0,b+12|0);a=j[114630];j[114630]=0;if((a|0)!=1){break a}a=D()|0;C()|0;Ie(b+16|0);G(a|0);z()}Cb(a)}Ie(b+16|0);Za=b+48|0}function ola(a,b){a=a|0;b=b|0;var c=0,d=0;c=Za-32|0;Za=c;a:{if(Vf(a)>>>0<b>>>0){d=hb(a);b=bL(c+8|0,b,ec(a),d);j[114630]=0;F(1250,a|0,b|0);a=j[114630];j[114630]=0;if((a|0)==1){break a}Yr(b)}Za=c+32|0;return}a=D()|0;C()|0;Yr(b);G(a|0);z()}function hga(a,b){a=a|0;b=b|0;var c=0,d=0;c=Za-32|0;Za=c;a:{if(jd(a)>>>0<b>>>0){d=hb(a);b=sH(c+8|0,b,sb(a),d);j[114630]=0;F(1754,a|0,b|0);a=j[114630];j[114630]=0;if((a|0)==1){break a}pr(b)}Za=c+32|0;return}a=D()|0;C()|0;pr(b);G(a|0);z()}function eAa(a,b,c,d){var e=0,f=0,g=0,h=0;e=Za-16|0;Za=e;j[e+12>>2]=0;Bc(a+12|0,d);if(b){d=b;if(b>>>0>536870911){oc(16520);z()}f=ac(d<<3,1)}j[a>>2]=f;c=(c<<3)+f|0;j[a+8>>2]=c;j[a+4>>2]=c;g=Ob(a),h=(b<<3)+f|0,j[g>>2]=h;Za=e+16|0;return a}function UT(a,b,c,d){var e=0,f=0,g=0,h=0;e=Za-16|0;Za=e;j[e+12>>2]=0;Bc(a+12|0,d);if(b){d=b;if(b>>>0>2147483647){oc(11736);z()}f=ac(d<<1,2)}j[a>>2]=f;c=(c<<1)+f|0;j[a+8>>2]=c;j[a+4>>2]=c;g=Ob(a),h=(b<<1)+f|0,j[g>>2]=h;Za=e+16|0;return a}function Nxa(a,b){a=a|0;b=b|0;var c=0,d=0;c=Za-32|0;Za=c;a:{if(Vf(a)>>>0<b>>>0){d=hb(a);b=Zx(c+8|0,b,ec(a),d);j[114630]=0;F(1011,a|0,b|0);a=j[114630];j[114630]=0;if((a|0)==1){break a}qs(b)}Za=c+32|0;return}a=D()|0;C()|0;qs(b);G(a|0);z()}function Lo(a,b){var c=0,d=0,e=0,f=0,g=0,h=0;f=1/(o[j[a+4>>2]-8>>3]-o[j[a>>2]>>3]);while(1){d=-zd(o[wk(a,c)>>3]*131072*f);a:{if(r(d)<2147483648){e=~~d;break a}e=-2147483648}g=Ae(b,c),h=e,j[g>>2]=h;c=c+1|0;if((c|0)!=2048){continue}break}}function KR(a,b,c,d){var e=0,f=0,g=0,h=0;e=Za-16|0;Za=e;j[e+12>>2]=0;Bc(a+12|0,d);if(b){d=b;if(b>>>0>2147483647){oc(12489);z()}f=ac(d<<1,1)}j[a>>2]=f;c=(c<<1)+f|0;j[a+8>>2]=c;j[a+4>>2]=c;g=Ob(a),h=(b<<1)+f|0,j[g>>2]=h;Za=e+16|0;return a}function EA(a,b,c,d){var e=0,f=0,g=0,h=0;e=Za-16|0;Za=e;j[e+12>>2]=0;Bc(a+12|0,d);if(b){d=b;if(b>>>0>1073741823){oc(11561);z()}f=ac(d<<2,4)}j[a>>2]=f;c=(c<<2)+f|0;j[a+8>>2]=c;j[a+4>>2]=c;g=Ob(a),h=(b<<2)+f|0,j[g>>2]=h;Za=e+16|0;return a}function fDa(a,b){a=a|0;b=b|0;var c=0,d=0;c=Za-32|0;Za=c;a:{if(Df(a)>>>0<b>>>0){d=hb(a);b=yt(c+8|0,b,Yb(a),d);j[114630]=0;F(380,a|0,b|0);a=j[114630];j[114630]=0;if((a|0)==1){break a}mk(b)}Za=c+32|0;return}a=D()|0;C()|0;mk(b);G(a|0);z()}function hU(a,b){var c=0,d=0,e=0;j[a>>2]=0;j[a+4>>2]=0;j[a+8>>2]=0;j[a+12>>2]=0;if(j[b+16>>2]){AA(a,b);c=j[b+12>>2];d=c>>31;e=d+j[b+8>>2]|0;b=c>>31;c=b+c|0;c=e>>>0<d>>>0?c+1|0:c;b=b^c;j[a+12>>2]=b>>>0>8191?2:16384/(b+1>>>0)|0}return a}function cua(a,b,c,d){var e=0,f=0,g=0,h=0;a:{if((d|0)==65536){break a}c=p(b,c);if(!c){break a}b=d;f=d>>31;d=0;while(1){e=j[a>>2];g=a,h=ic(IMa(HMa(e,e>>31,b,f),ab,65536,0),ab),j[g>>2]=h;a=a+4|0;d=d+1|0;if((c|0)!=(d|0)){continue}break}}}function Tfa(a){a=a|0;var b=0;bb[j[j[a>>2]+124>>2]](a);jw(a);j[a+4236>>2]=0;h[a+4202|0]=1;b=bb[j[j[a>>2]+188>>2]](a)|0;j[a+4272>>2]=0;n[a+4240>>2]=b?q(.5):q(1);b=j[a+4256>>2];j[a+4292>>2]=b;j[a+4288>>2]=b;j[a+4284>>2]=b;j[a+4280>>2]=b}function SW(a,b,c,d){var e=0,f=0,g=0,h=0;e=Za-16|0;Za=e;j[e+12>>2]=0;Bc(a+12|0,d);if(b){d=b;if(b>>>0>268435455){oc(6967);z()}f=ac(d<<4,4)}j[a>>2]=f;c=(c<<4)+f|0;j[a+8>>2]=c;j[a+4>>2]=c;g=Ob(a),h=(b<<4)+f|0,j[g>>2]=h;Za=e+16|0;return a}function PEa(a,b){var c=0,d=0,e=0;c=ri(a+8|0);j[114630]=0;d=H(540,b|0)|0;e=j[114630];j[114630]=0;a:{if((e|0)==1){break a}j[114630]=0;I(421,a|0,b|0,d|0);a=j[114630];j[114630]=0;if((a|0)==1){break a}return}a=D()|0;C()|0;xg(c);G(a|0);z()}function Nea(a,b,c){a=a|0;b=b|0;c=q(c);var d=0;d=Za-16|0;Za=d;n[d+12>>2]=c;if((b|0)<=12){Kd(d+12|0,q(0));c=n[d+12>>2];if((b|0)==12){c=q(Rd(q(c*q(3)))*q(.3333333432674408));n[d+12>>2]=c}n[((b<<2)+a|0)+4208>>2]=c;h[a+5046|0]=1}Za=d+16|0}function FU(a,b){a=a|0;b=b|0;var c=0,d=0;c=Za-32|0;Za=c;a:{if(jd(a)>>>0<b>>>0){d=hb(a);b=EA(c+8|0,b,sb(a),d);j[114630]=0;F(343,a|0,b|0);a=j[114630];j[114630]=0;if((a|0)==1){break a}Sp(b)}Za=c+32|0;return}a=D()|0;C()|0;Sp(b);G(a|0);z()}function Eca(a){a=a|0;if(m[a+24>>2]>m[a+44>>2]){j[a+44>>2]=j[a+24>>2]}a:{if(!(k[a+48|0]&8)){break a}if(m[a+16>>2]<m[a+44>>2]){um(a,j[a+8>>2],j[a+12>>2],j[a+44>>2])}if(m[a+12>>2]>=m[a+16>>2]){break a}return gg(h[j[a+12>>2]])|0}return-1}function AL(a,b){var c=0,d=0;c=xra(a);a:{if(!b){break a}j[114630]=0;F(1218,a|0,b|0);d=j[114630];j[114630]=0;if((d|0)!=1){j[114630]=0;F(1219,a|0,b|0);b=j[114630];j[114630]=0;if((b|0)!=1){break a}}a=D()|0;C()|0;uL(c);G(a|0);z()}return a}function zta(a){var b=0,c=0,d=0,e=0;b=Za-16|0;Za=b;e=b+8|0;d=j[a+24>>2];c=0;a:{if(!d){break a}c=Qm(Zn(+(d>>>0)*.00011957431543704412)*2215.9795828054475)}rE(e,Gb(c,-16384,16383),128);h[a+36|0]=j[b+8>>2];h[a+37|0]=j[b+12>>2];Za=b+16|0}function ota(a,b){var c=0,d=0;c=Pz(a);a:{if(!b){break a}j[114630]=0;F(916,a|0,b|0);d=j[114630];j[114630]=0;if((d|0)!=1){j[114630]=0;F(1168,a|0,b|0);b=j[114630];j[114630]=0;if((b|0)!=1){break a}}a=D()|0;C()|0;ut(c);G(a|0);z()}return a}function kJ(a,b,c){var d=0,e=0,f=0,g=0,h=0;if(b){g=c;h=c>>31;c=0;while(1){d=j[a>>2];e=j[a+4>>2];f=(d+e|0)/2|0;d=d-e|0;d=ic(IMa(HMa(d,d>>31,g,h),ab,256,0),ab);j[a+4>>2]=f-d;j[a>>2]=d+f;a=a+8|0;c=c+1|0;if((c|0)!=(b|0)){continue}break}}}function _$(a,b,c,d,e,f){var g=0;g=Za-144|0;Za=g;j[g+28>>2]=g+132;TC(a,g+32|0,g+28|0,d,e,f);j[g+16>>2]=0;j[g+20>>2]=0;j[g+12>>2]=g+32;a=Z$(b,g+12|0,fP(b,j[c>>2]),g+16|0,j[a>>2]);if((a|0)==-1){Wl(65236);z()}j[c>>2]=(a<<2)+b;Za=g+144|0}function Xja(a,b){var c=0,d=0;c=Xy(a);a:{if(!b){break a}j[114630]=0;F(680,a|0,b|0);d=j[114630];j[114630]=0;if((d|0)!=1){j[114630]=0;F(1563,a|0,b|0);b=j[114630];j[114630]=0;if((b|0)!=1){break a}}a=D()|0;C()|0;Ts(c);G(a|0);z()}return a}function Hza(a,b){var c=0,d=0;c=Dza(a);a:{if(!b){break a}j[114630]=0;F(941,a|0,b|0);d=j[114630];j[114630]=0;if((d|0)!=1){j[114630]=0;F(942,a|0,b|0);b=j[114630];j[114630]=0;if((b|0)!=1){break a}}a=D()|0;C()|0;VN(c);G(a|0);z()}return a}function tea(a){var b=0;j[a>>2]=8;j[a+4>>2]=0;i[a+4128>>1]=0;b=a+4120|0;j[b>>2]=0;j[b+4>>2]=0;b=a+4112|0;j[b>>2]=0;j[b+4>>2]=0;j[a+4104>>2]=0;j[a+4108>>2]=0;Ab(a+4132|0,0,40);EM(a+8|0,1024);Ab(a+4172|0,0,49824);Ab(a+53996|0,0,32832)}function tJ(a,b){var c=0,d=0;a:{if(!(k[a+89|0]&16)){break a}c=j[a+656>>2];if(!c){break a}c=j[c>>2];if(c){d=a;a=j[a+696>>2]-(c<<1)|0;a=(a|0)>0?a:0;j[d+696>>2]=a;j[b>>2]=(p(a,j[b>>2])|0)/65536;return}if(j[a+696>>2]){break a}j[b>>2]=0}}function V4(a,b,c){var d=0,e=0,f=0;if(!c){return 0}d=k[a|0];a:{if(!d){break a}while(1){b:{e=k[b|0];if((e|0)!=(d|0)){break b}c=c-1|0;if(!c|!e){break b}b=b+1|0;d=k[a+1|0];a=a+1|0;if(d){continue}break a}break}f=d}return(f&255)-k[b|0]|0}function Sf(a,b,c){c=j[c+4>>2]&176;if((c|0)==32){return b}a:{if((c|0)!=16){break a}b:{c:{c=k[a|0];switch(c-43|0){case 0:case 2:break c;default:break b}}return a+1|0}if((c|0)!=48|(b-a|0)<2|(k[a+1|0]|32)!=120){break a}a=a+2|0}return a}function JGa(a,b){a=a|0;b=b|0;var c=0;c=Za-32|0;Za=c;a:{if(b){Db(c,b);break a}Cb(c)}j[114630]=0;F(665,c+16|0,c|0);b=j[114630];j[114630]=0;if((b|0)!=1){Mc(a,c+16|0);gb(c+16|0);gb(c);Za=c+32|0;return a|0}a=D()|0;C()|0;gb(c);G(a|0);z()}function IY(a){var b=0,c=0,d=0;b=j[a>>2];j[114630]=0;c=T(2446)|0;d=j[114630];j[114630]=0;a:{if((d|0)==1){break a}if((b|0)!=(c|0)){a=j[a>>2];j[114630]=0;Zu(a);a=j[114630];j[114630]=0;if((a|0)==1){break a}}return}J(0)|0;C()|0;ib();z()}function zma(a,b,c){var d=0;d=Za-16|0;Za=d;a:{b:{if(!b){b=a;a=zb(c);Yh(b,a,nb(c)+a|0);break b}YJ(d,c);j[114630]=0;I(115,a|0,b|0,d|0);a=j[114630];j[114630]=0;if((a|0)==1){break a}pc(d)}Za=d+16|0;return}a=D()|0;C()|0;pc(d);G(a|0);z()}function cW(a,b){var c=0,d=0;c=YV(a);a:{if(!b){break a}j[114630]=0;F(262,a|0,b|0);d=j[114630];j[114630]=0;if((d|0)!=1){j[114630]=0;F(263,a|0,b|0);b=j[114630];j[114630]=0;if((b|0)!=1){break a}}a=D()|0;C()|0;iB(c);G(a|0);z()}return a}function b4(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;a:{if(!k[a+44|0]){c=(c|0)>0?c:0;while(1){if((c|0)==(d|0)){break a}if((bb[j[j[a>>2]+52>>2]](a,j[b>>2])|0)==-1){return d|0}else{b=b+4|0;d=d+1|0;continue}}}c=Bi(b,4,c,j[a+32>>2])}return c|0}function RIa(a,b,c){var d=0,e=0,f=0;e=Za-16|0;Za=e;d=ik(e,a,1);a=hb(a);f=j[d+4>>2];j[114630]=0;L(559,a|0,f|0,b|0,c|0);a=j[114630];j[114630]=0;if((a|0)!=1){j[d+4>>2]=j[d+4>>2]+24;ub(d);Za=e+16|0;return}a=D()|0;C()|0;ub(d);G(a|0);z()}function N7(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=q(0);e=Za-16|0;Za=e;f=j[a+4>>2];EF(a,b,c,d);g=n[a+28>>2];b=j[a+24>>2];j[e+8>>2]=j[a+20>>2];j[e+12>>2]=b;b=j[a+16>>2];j[e>>2]=j[a+12>>2];j[e+4>>2]=b;yba(e,f,c,d,g);Za=e+16|0}function mV(a,b,c,d){var e=0;a:{if((a|0)==(b|0)){break a}while(1){e=c;if((e|0)!=(d|0)){while(1){if(bb[26](h[a|0],h[e|0])|0){break a}e=e+1|0;if((e|0)!=(d|0)){continue}break}}a=a+1|0;if((b|0)!=(a|0)){continue}break}return b}return a}function Mo(a){var b=0,c=0,d=0,e=0;b=Za-16|0;Za=b;c=Dra(Lb(a),Mb(a));d=b,e=Lb(a),j[d+8>>2]=e;d=b,e=Mb(a),j[d>>2]=e;if(rb(b+8|0,b)){c=-c;while(1){a=j[b+8>>2];c=o[a>>3]+c;o[a>>3]=c;Cx(b+8|0);if(rb(b+8|0,b)){continue}break}}Za=b+16|0}function rB(){var a=0,b=0,c=0;b=Za-16|0;Za=b;a=Db(b,10940);a:{if(!nb(a)){break a}c=1;if((Hf(a,10946)|0)!=-1){break a}if((Hf(a,10948)|0)!=-1){break a}if((Hf(a,10952)|0)!=-1){break a}c=(Hf(a,10954)|0)!=-1}gb(a);Za=b+16|0;return c|0}function pf(a,b){var c=0,d=0,e=0,f=0;c=l[a+24>>1]<<17;e=l[a+20>>1];if(e){d=l[a+22>>1];e=e+d|0;while(1){f=c;c=((d&127)<<2)+a|0;c=f-p(j[Ae(b,l[c+28>>1])>>2],i[c+26>>1])|0;d=d+1|0;if((e|0)!=(d|0)){continue}break}}return(c|0)/32768|0}function kLa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;d=Za-16|0;Za=d;c=-1;a:{if(!jf(a,7)){break a}c=0;if(!vS(a,12168)){break a}c=d;e=CKa(a,d);if(!e){iS(c)}c=-1;if(!e){break a}c=0;if(!uS(d)){break a}c=Me(a,b,tS(d),ab)}Za=d+16|0;return c|0}function g0(a,b,c,d,e,f){a=bb[j[j[a+8>>2]+8>>2]](a+8|0)|0;if((nb(a)|0)==(0-nb(a+12|0)|0)){j[e>>2]=j[e>>2]|4;return}a=xq(c,d,a,a+24|0,f,e,0)-a|0;c=j[b>>2];if(!(a|(c|0)!=12)){j[b>>2]=0;return}if(!((a|0)!=12|(c|0)>11)){j[b>>2]=c+12}}function Sma(a,b,c){var d=0;d=Za-16|0;Za=d;a:{b:{if(!b){b=a;a=zb(c);Yh(b,a,nb(c)+a|0);break b}AK(d,b,c);j[114630]=0;F(116,a|0,d|0);a=j[114630];j[114630]=0;if((a|0)==1){break a}pc(d)}Za=d+16|0;return}a=D()|0;C()|0;pc(d);G(a|0);z()}function QK(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;a=Za-16|0;Za=a;d=j[b+104>>2];if(d){j[b+88>>2]=j[b+88>>2]&-131|128;d=j[d>>2];j[b+76>>2]=d;j[a+12>>2]=c<<8;j[a+8>>2]=d-1;c=d+(j[tb(a+12|0,a+8|0)>>2]^-1)|0;j[b>>2]=0;j[b+4>>2]=c}Za=a+16|0}function A0(a,b,c,d,e,f){a=bb[j[j[a+8>>2]+8>>2]](a+8|0)|0;if((nb(a)|0)==(0-nb(a+12|0)|0)){j[e>>2]=j[e>>2]|4;return}a=zq(c,d,a,a+24|0,f,e,0)-a|0;c=j[b>>2];if(!(a|(c|0)!=12)){j[b>>2]=0;return}if(!((a|0)!=12|(c|0)>11)){j[b>>2]=c+12}}function jIa(a){var b=0;b=Za-16|0;Za=b;h[a|0]=0;h[a+1|0]=0;h[a+2|0]=0;h[a+3|0]=0;h[a+4|0]=0;h[a+5|0]=0;h[a+6|0]=0;h[a+7|0]=0;h[a+8|0]=0;h[a+9|0]=0;h[a+10|0]=0;h[a+11|0]=0;h[a+12|0]=0;h[a+13|0]=0;h[a+14|0]=0;h[a+15|0]=0;Za=b+16|0}function zHa(a){var b=0;b=Za-16|0;Za=b;h[a|0]=0;h[a+1|0]=0;h[a+2|0]=0;h[a+3|0]=0;h[a+4|0]=0;h[a+5|0]=0;h[a+6|0]=0;h[a+7|0]=0;h[a+7|0]=0;h[a+8|0]=0;h[a+9|0]=0;h[a+10|0]=0;h[a+11|0]=0;h[a+12|0]=0;h[a+13|0]=0;h[a+14|0]=0;Za=b+16|0}function xN(a,b){var c=0,d=0,e=0,f=0;c=Za-32|0;Za=c;d=j[a+4>>2];e=j[a>>2];j[c+24>>2]=e;j[c+28>>2]=d;f=j[b+4>>2];a=j[b>>2];j[c+16>>2]=a;j[c+20>>2]=f;j[c+8>>2]=e;j[c+12>>2]=d;j[c>>2]=a;j[c+4>>2]=f;a=bO(c+8|0,c);Za=c+32|0;return a}function xLa(a,b,c){var d=0;d=ri(a+8|0);j[114630]=0;I(421,a|0,b|0,c|0);c=j[114630];j[114630]=0;a:{if((c|0)!=1){a=j[a>>2];j[114630]=0;E(338,b|0,a|0)|0;a=j[114630];j[114630]=0;if((a|0)!=1){break a}}a=D()|0;C()|0;xg(d);G(a|0);z()}}function gsa(a,b,c){var d=0,e=0;b=Vj(a,b);a:{if((b|0)==255){break a}if(Vi(a)){break a}d=k[Pb(mi(a+314|0,b),10)|0];e=j[a>>2];a=d&-49;a=(c|0)<171?a|16:a;a=((c|0)>84?a|32:a)&255;Pg(e,es(b)|192,a);d=(a>>>5&1)+(a<<27>>31)|0}return d}function wka(a,b){var c=0,d=0,e=0;d=Za-16|0;Za=d;c=ik(d,a,1);a=hb(a);e=j[c+4>>2];j[114630]=0;I(1556,a|0,e|0,b|0);a=j[114630];j[114630]=0;if((a|0)!=1){j[c+4>>2]=j[c+4>>2]+24;ub(c);Za=d+16|0;return}a=D()|0;C()|0;ub(c);G(a|0);z()}function rpa(a,b){var c=0;c=Za-2496|0;Za=c;ZK(b,c,c+2496|0);b=Vb(a,c,2496);j[b+2496>>2]=0;a:{if(j[b>>2]<=-1){break a}a=1;while(1){if(j[b+(a<<2)>>2]){break a}a=a+1|0;if((a|0)!=624){continue}break}j[b>>2]=-2147483648}Za=c+2496|0}function _aa(a,b){var c=0,d=0,e=0;d=Za-16|0;Za=d;c=Ql(d,a,1);a=hb(a);e=j[c+4>>2];j[114630]=0;I(2121,a|0,e|0,b|0);a=j[114630];j[114630]=0;if((a|0)!=1){j[c+4>>2]=j[c+4>>2]+16;ub(c);Za=d+16|0;return}a=D()|0;C()|0;ub(c);G(a|0);z()}function Voa(a,b){var c=0,d=0,e=0;d=Za-16|0;Za=d;c=Cn(d,a,1);a=hb(a);e=j[c+4>>2];j[114630]=0;I(1367,a|0,e|0,b|0);a=j[114630];j[114630]=0;if((a|0)!=1){j[c+4>>2]=j[c+4>>2]+32;ub(c);Za=d+16|0;return}a=D()|0;C()|0;ub(c);G(a|0);z()}function Paa(a,b){var c=0,d=0,e=0;d=Za-16|0;Za=d;c=ik(d,a,1);a=hb(a);e=j[c+4>>2];j[114630]=0;I(2126,a|0,e|0,b|0);a=j[114630];j[114630]=0;if((a|0)!=1){j[c+4>>2]=j[c+4>>2]+24;ub(c);Za=d+16|0;return}a=D()|0;C()|0;ub(c);G(a|0);z()}function Jqa(a,b){var c=0,d=0,e=0;d=Za-16|0;Za=d;c=Ok(d,a,1);a=hb(a);e=j[c+4>>2];j[114630]=0;I(1249,a|0,e|0,b|0);a=j[114630];j[114630]=0;if((a|0)!=1){j[c+4>>2]=j[c+4>>2]+12;ub(c);Za=d+16|0;return}a=D()|0;C()|0;ub(c);G(a|0);z()}function Bxa(a,b){var c=0,d=0,e=0;d=Za-16|0;Za=d;c=Ok(d,a,1);a=hb(a);e=j[c+4>>2];j[114630]=0;I(1016,a|0,e|0,b|0);a=j[114630];j[114630]=0;if((a|0)!=1){j[c+4>>2]=j[c+4>>2]+12;ub(c);Za=d+16|0;return}a=D()|0;C()|0;ub(c);G(a|0);z()}function $sa(a,b){var c=0,d=0,e=0;d=Za-16|0;Za=d;c=Cn(d,a,1);a=hb(a);e=j[c+4>>2];j[114630]=0;I(1174,a|0,e|0,b|0);a=j[114630];j[114630]=0;if((a|0)!=1){j[c+4>>2]=j[c+4>>2]+32;ub(c);Za=d+16|0;return}a=D()|0;C()|0;ub(c);G(a|0);z()}function zia(a,b){var c=0,d=0,e=0;d=Za-16|0;Za=d;c=_d(d,a,1);a=hb(a);e=j[c+4>>2];j[114630]=0;I(1599,a|0,e|0,b|0);a=j[114630];j[114630]=0;if((a|0)!=1){j[c+4>>2]=j[c+4>>2]+4;ub(c);Za=d+16|0;return}a=D()|0;C()|0;ub(c);G(a|0);z()}function xHa(a,b){var c=0,d=0,e=0;d=Za-16|0;Za=d;c=Ql(d,a,1);a=hb(a);e=j[c+4>>2];j[114630]=0;I(608,a|0,e|0,b|0);a=j[114630];j[114630]=0;if((a|0)!=1){j[c+4>>2]=j[c+4>>2]+16;ub(c);Za=d+16|0;return}a=D()|0;C()|0;ub(c);G(a|0);z()}function us(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0;f=Za-16|0;Za=f;if(b){e=sc(a);d=nb(a);g=d+b|0;if(e-d>>>0<b>>>0){xl(a,e,g-e|0,d,d,0,0)}e=d;d=zb(a);dy(e+d|0,b,c);Bg(a,g);h[f+15|0]=0;Sd(d+g|0,f+15|0)}Za=f+16|0;return a|0}function r9(a,b){a=a|0;b=b|0;var c=q(0);a:{if((b|0)<0){break a}a=a+24|0;if(l[j[a>>2]+480188>>1]<=(b|0)){break a}b=p(b,896);if(!(h[(b+j[a>>2]|0)+1075073|0]&1)){break a}c=q(q(k[(b+j[a>>2]|0)+1075846|0])*q(.0078125))}return q(c)}function q9(a,b){a=a|0;b=b|0;var c=q(0);a:{if((b|0)<0){break a}a=a+24|0;if(l[j[a>>2]+480188>>1]<=(b|0)){break a}b=p(b,896);if(!(h[(b+j[a>>2]|0)+1075073|0]&1)){break a}c=q(q(k[(b+j[a>>2]|0)+1075847|0])*q(.0078125))}return q(c)}function ona(a,b){var c=0,d=0,e=0;d=Za-16|0;Za=d;c=_d(d,a,1);a=hb(a);e=j[c+4>>2];j[114630]=0;I(1416,a|0,e|0,b|0);a=j[114630];j[114630]=0;if((a|0)!=1){j[c+4>>2]=j[c+4>>2]+4;ub(c);Za=d+16|0;return}a=D()|0;C()|0;ub(c);G(a|0);z()}function nJ(a){var b=0,c=0,d=0;b=Za-16|0;Za=b;j[b+12>>2]=7;j[b+8>>2]=32;if(j[tb(b+12|0,b+8|0)>>2]){while(1){d=Bo(a);j[b+12>>2]=7;j[b+8>>2]=32;c=c+15|0;if(c>>>0<m[tb(b+12|0,b+8|0)>>2]){continue}break}c=d&127}Za=b+16|0;return c}function eR(a){if(!((k[a+8|0]|k[a+9|0]<<8|(k[a+10|0]<<16|k[a+11|0]<<24))==1179472708?(k[a|0]|k[a+1|0]<<8|(k[a+2|0]<<16|k[a+3|0]<<24))==1179011410:0)){return(k[a|0]|k[a+1|0]<<8|(k[a+2|0]<<16|k[a+3|0]<<24))==1179472708}return 1}function cga(a,b){var c=0,d=0,e=0;d=Za-16|0;Za=d;c=_d(d,a,1);a=hb(a);e=j[c+4>>2];j[114630]=0;I(1757,a|0,e|0,b|0);a=j[114630];j[114630]=0;if((a|0)!=1){j[c+4>>2]=j[c+4>>2]+4;ub(c);Za=d+16|0;return}a=D()|0;C()|0;ub(c);G(a|0);z()}function _A(a){var b=0;b=Za-16|0;Za=b;h[a|0]=0;h[a+1|0]=0;h[a+2|0]=0;h[a+3|0]=0;h[a+4|0]=0;h[a+5|0]=0;h[a+6|0]=0;h[a+7|0]=0;h[a+6|0]=0;h[a+7|0]=0;h[a+8|0]=0;h[a+9|0]=0;h[a+10|0]=0;h[a+11|0]=0;h[a+12|0]=0;h[a+13|0]=0;Za=b+16|0}function Tla(a,b){var c=0,d=0,e=0;d=Za-16|0;Za=d;c=_d(d,a,1);a=hb(a);e=j[c+4>>2];j[114630]=0;I(1513,a|0,e|0,b|0);a=j[114630];j[114630]=0;if((a|0)!=1){j[c+4>>2]=j[c+4>>2]+4;ub(c);Za=d+16|0;return}a=D()|0;C()|0;ub(c);G(a|0);z()}function Tha(a,b){var c=0,d=0,e=0;d=Za-16|0;Za=d;c=_d(d,a,1);a=hb(a);e=j[c+4>>2];j[114630]=0;I(1630,a|0,e|0,b|0);a=j[114630];j[114630]=0;if((a|0)!=1){j[c+4>>2]=j[c+4>>2]+4;ub(c);Za=d+16|0;return}a=D()|0;C()|0;ub(c);G(a|0);z()}function TIa(a,b){var c=0,d=0,e=0;d=Za-16|0;Za=d;c=kR(d,a,1);a=hb(a);e=j[c+4>>2];j[114630]=0;I(557,a|0,e|0,b|0);a=j[114630];j[114630]=0;if((a|0)!=1){j[c+4>>2]=j[c+4>>2]+48;ub(c);Za=d+16|0;return}a=D()|0;C()|0;ub(c);G(a|0);z()}function PIa(a,b){var c=0,d=0;c=GIa(a);a:{if(!b){break a}j[114630]=0;F(561,a|0,b|0);d=j[114630];j[114630]=0;if((d|0)!=1){j[114630]=0;F(562,a|0,b|0);a=j[114630];j[114630]=0;if((a|0)!=1){break a}}a=D()|0;C()|0;nR(c);G(a|0);z()}}function Mya(a,b){var c=0,d=0,e=0;d=Za-16|0;Za=d;c=ik(d,a,1);a=hb(a);e=j[c+4>>2];j[114630]=0;I(982,a|0,e|0,b|0);a=j[114630];j[114630]=0;if((a|0)!=1){j[c+4>>2]=j[c+4>>2]+24;ub(c);Za=d+16|0;return}a=D()|0;C()|0;ub(c);G(a|0);z()}function IDa(a,b){var c=0,d=0,e=0;d=Za-16|0;Za=d;c=ik(d,a,1);a=hb(a);e=j[c+4>>2];j[114630]=0;I(768,a|0,e|0,b|0);a=j[114630];j[114630]=0;if((a|0)!=1){j[c+4>>2]=j[c+4>>2]+24;ub(c);Za=d+16|0;return}a=D()|0;C()|0;ub(c);G(a|0);z()}function HHa(a,b){var c=0,d=0,e=0;d=Za-16|0;Za=d;c=ik(d,a,1);a=hb(a);e=j[c+4>>2];j[114630]=0;I(605,a|0,e|0,b|0);a=j[114630];j[114630]=0;if((a|0)!=1){j[c+4>>2]=j[c+4>>2]+24;ub(c);Za=d+16|0;return}a=D()|0;C()|0;ub(c);G(a|0);z()}function GJa(a,b){var c=0,d=0,e=0;d=Za-16|0;Za=d;c=ik(d,a,1);a=hb(a);e=j[c+4>>2];j[114630]=0;I(528,a|0,e|0,b|0);a=j[114630];j[114630]=0;if((a|0)!=1){j[c+4>>2]=j[c+4>>2]+24;ub(c);Za=d+16|0;return}a=D()|0;C()|0;ub(c);G(a|0);z()}function Dwa(a,b){var c=0,d=0,e=0;d=Za-16|0;Za=d;c=_d(d,a,1);a=hb(a);e=j[c+4>>2];j[114630]=0;I(1052,a|0,e|0,b|0);a=j[114630];j[114630]=0;if((a|0)!=1){j[c+4>>2]=j[c+4>>2]+4;ub(c);Za=d+16|0;return}a=D()|0;C()|0;ub(c);G(a|0);z()}function AFa(a,b){var c=0,d=0,e=0;d=Za-16|0;Za=d;c=Ok(d,a,1);a=hb(a);e=j[c+4>>2];j[114630]=0;I(727,a|0,e|0,b|0);a=j[114630];j[114630]=0;if((a|0)!=1){j[c+4>>2]=j[c+4>>2]+12;ub(c);Za=d+16|0;return}a=D()|0;C()|0;ub(c);G(a|0);z()}function yU(a,b){var c=0,d=0,e=0;d=Za-16|0;Za=d;c=Cn(d,a,1);a=hb(a);e=j[c+4>>2];j[114630]=0;I(347,a|0,e|0,b|0);a=j[114630];j[114630]=0;if((a|0)!=1){j[c+4>>2]=j[c+4>>2]+32;ub(c);Za=d+16|0;return}a=D()|0;C()|0;ub(c);G(a|0);z()}function s4(a,b){var c=0,d=0,e=0;d=Za-16|0;Za=d;c=Ok(d,a,1);a=hb(a);e=j[c+4>>2];j[114630]=0;I(204,a|0,e|0,b|0);a=j[114630];j[114630]=0;if((a|0)!=1){j[c+4>>2]=j[c+4>>2]+12;ub(c);Za=d+16|0;return}a=D()|0;C()|0;ub(c);G(a|0);z()}function jna(a){var b=0,c=0;c=a+946300|0;b=a+906300|0;while(1){a=j[b>>2];a:{if(!a){break a}if(bb[j[j[a>>2]+112>>2]](a)|0){break a}bb[j[j[a>>2]+104>>2]](a,1);bb[j[j[a>>2]+116>>2]](a)}b=b+160|0;if((c|0)!=(b|0)){continue}break}}function era(a,b){var c=0,d=0,e=0;d=Za-16|0;Za=d;c=_d(d,a,1);a=hb(a);e=j[c+4>>2];j[114630]=0;I(411,a|0,e|0,b|0);a=j[114630];j[114630]=0;if((a|0)!=1){j[c+4>>2]=j[c+4>>2]+4;ub(c);Za=d+16|0;return}a=D()|0;C()|0;ub(c);G(a|0);z()}function OJa(a,b){var c=0,d=0,e=0;d=Za-16|0;Za=d;c=yh(d,a,1);a=hb(a);e=j[c+4>>2];j[114630]=0;I(520,a|0,e|0,b|0);a=j[114630];j[114630]=0;if((a|0)!=1){j[c+4>>2]=j[c+4>>2]+2;ub(c);Za=d+16|0;return}a=D()|0;C()|0;ub(c);G(a|0);z()}function KKa(a,b){var c=0,d=0,e=0;d=Za-16|0;Za=d;c=yh(d,a,1);a=hb(a);e=j[c+4>>2];j[114630]=0;I(381,a|0,e|0,b|0);a=j[114630];j[114630]=0;if((a|0)!=1){j[c+4>>2]=j[c+4>>2]+2;ub(c);Za=d+16|0;return}a=D()|0;C()|0;ub(c);G(a|0);z()}function K8(a,b){var c=0,d=0,e=0;c=Za-32|0;Za=c;b=_b(c+24|0,j[b>>2]);d=j[a>>2];a=j[d+4>>2];d=j[d>>2];j[c+16>>2]=d;j[c+20>>2]=a;e=j[b+4>>2];j[c+8>>2]=j[b>>2];j[c+12>>2]=e;j[c>>2]=d;j[c+4>>2]=a;a=nc(c+8|0,c);Za=c+32|0;return a}function CMa(a,b,c,d){var e=0,f=0,g=0,h=0,i=0,j=0;e=c>>>16|0;f=a>>>16|0;j=p(e,f);g=c&65535;h=a&65535;i=p(g,h);f=(i>>>16|0)+p(f,g)|0;e=(f&65535)+p(e,h)|0;a=(p(b,c)+j|0)+p(a,d)+(f>>>16)+(e>>>16)|0;b=i&65535|e<<16;ab=a;return b}function t_(){var a=0;a:{b:{if(h[461868]&1){break b}if(!fd(461868)){break b}j[114630]=0;T(2566)|0;a=j[114630];j[114630]=0;if((a|0)==1){break a}j[115466]=461860;ed(461868)}return j[115466]}a=D()|0;C()|0;Zd(461868);G(a|0);z()}function oC(){var a=0;a:{b:{if(h[461856]&1){break b}if(!fd(461856)){break b}j[114630]=0;T(2562)|0;a=j[114630];j[114630]=0;if((a|0)==1){break a}j[115463]=461848;ed(461856)}return j[115463]}a=D()|0;C()|0;Zd(461856);G(a|0);z()}function k0(a,b){var c=0,d=0,e=0;d=Za-16|0;Za=d;c=vl(d,a,1);a=hb(a);e=j[c+4>>2];j[114630]=0;I(210,a|0,e|0,b|0);a=j[114630];j[114630]=0;if((a|0)!=1){j[c+4>>2]=j[c+4>>2]+1;ub(c);Za=d+16|0;return}a=D()|0;C()|0;ub(c);G(a|0);z()}function Iva(a,b){var c=0,d=0,e=0;d=Za-16|0;Za=d;c=_d(d,a,1);a=hb(a);e=j[c+4>>2];j[114630]=0;I(95,a|0,e|0,b|0);a=j[114630];j[114630]=0;if((a|0)!=1){j[c+4>>2]=j[c+4>>2]+4;ub(c);Za=d+16|0;return}a=D()|0;C()|0;ub(c);G(a|0);z()}function Hr(a,b){var c=0;c=79452;a:{b:{c:{switch(b-2|0){default:if((b|0)==16777216){break a}if((b|0)!=32){break b}c=79468;break a;case 2:c=79464;break a;case 1:break b;case 0:break c}}c=79460;break a}c=79456}j[a>>2]=j[c>>2]}function EP(a,b){var c=0,d=0,e=0;d=Za-16|0;Za=d;c=_d(d,a,1);a=hb(a);e=j[c+4>>2];j[114630]=0;I(766,a|0,e|0,b|0);a=j[114630];j[114630]=0;if((a|0)!=1){j[c+4>>2]=j[c+4>>2]+4;ub(c);Za=d+16|0;return}a=D()|0;C()|0;ub(c);G(a|0);z()}function Baa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=Za-16|0;Za=d;e=d+8|0;j[e>>2]=83904;j[e>>2]=83860;j[114630]=0;a=P(2149,a|0,b|0,c|0,e|0)|0;b=j[114630];j[114630]=0;if((b|0)!=1){Za=d+16|0;return a|0}a=D()|0;C()|0;G(a|0);z()}function B2(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0;d=Za-16|0;Za=d;j[d+12>>2]=c;j[d+8>>2]=c;e=-1;c=Iq(0,0,b,c);a:{if((c|0)<0){break a}f=a;c=c+1|0;a=Yc(c);j[f>>2]=a;if(!a){break a}e=Iq(a,c,b,j[d+12>>2])}Za=d+16|0;return e|0}function AU(a,b){var c=0,d=0,e=0;d=Za-16|0;Za=d;c=_d(d,a,1);a=hb(a);e=j[c+4>>2];j[114630]=0;I(346,a|0,e|0,b|0);a=j[114630];j[114630]=0;if((a|0)!=1){j[c+4>>2]=j[c+4>>2]+4;ub(c);Za=d+16|0;return}a=D()|0;C()|0;ub(c);G(a|0);z()}function wg(a){a=a|0;var b=0,c=0;b=Za-16|0;Za=b;h[a+8|0]=0;j[a>>2]=0;j[a+4>>2]=4194432;c=Db(b,11931);j[114630]=0;E(378,a+9|0,c|0)|0;a=j[114630];j[114630]=0;if((a|0)!=1){gb(c);Za=b+16|0;return}a=D()|0;C()|0;gb(c);G(a|0);z()}function t9(a,b){a=a|0;b=b|0;var c=q(0);a:{if((b|0)<0){break a}a=a+24|0;if(l[j[a>>2]+480188>>1]<=(b|0)){break a}b=p(b,896);if(h[(b+j[a>>2]|0)+1075073|0]&1){break a}c=q(q(k[(b+j[a>>2]|0)+1075846|0])*q(.0078125))}return q(c)}function s9(a,b){a=a|0;b=b|0;var c=q(0);a:{if((b|0)<0){break a}a=a+24|0;if(l[j[a>>2]+480188>>1]<=(b|0)){break a}b=p(b,896);if(h[(b+j[a>>2]|0)+1075073|0]&1){break a}c=q(q(k[(b+j[a>>2]|0)+1075847|0])*q(.0078125))}return q(c)}function qra(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;pra(a);d=a;e=Wm(a+12|0);h[a+30|0]=c;i[a+28>>1]=0;j[a+24>>2]=b;j[114630]=0;F(1227,a|0,1);b=j[114630];j[114630]=0;if((b|0)!=1){return a|0}a=D()|0;C()|0;Ud(e);tL(d);G(a|0);z()}function gia(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=Za-16|0;Za=c;a:{if(sb(a)){while(1){Cf(c,j[xb(a,d)>>2]+40|0);e=ip(c,b);gb(c);if(e){a=j[xb(a,d)>>2];break a}d=d+1|0;if(sb(a)>>>0>d>>>0){continue}break}}a=0}Za=c+16|0;return a|0}function ema(a,b,c){var d=0;d=Za-32|0;Za=d;j[d+16>>2]=b;j[d+24>>2]=a;j[d+8>>2]=c;if(rb(d+24|0,d+16|0)){while(1){a=bb[117](h[j[d+24>>2]])|0;h[j[d+8>>2]]=a;Xf(d+24|0);Xf(d+8|0);if(rb(d+24|0,d+16|0)){continue}break}}Za=d+32|0}function dY(a,b,c){var d=0,e=0,f=0;d=Za-16|0;Za=d;if(c>>>0<=1073741807){a:{if(c>>>0<=1){Ue(a,c);e=a;break a}f=Ul(c)+1|0;e=Ck(f);lf(a,e);lg(a,f);ee(a,c)}Jh(e,b,c);j[d+12>>2]=0;ye((c<<2)+e|0,d+12|0);Za=d+16|0;return}jg();z()}function ZX(a,b,c){var d=0,e=0,f=0;d=Za-16|0;Za=d;if(b>>>0<=1073741807){a:{if(b>>>0<=1){Ue(a,b);e=a;break a}f=Ul(b)+1|0;e=Ck(f);lf(a,e);lg(a,f);ee(a,b)}aY(e,b,c);j[d+12>>2]=0;ye((b<<2)+e|0,d+12|0);Za=d+16|0;return}jg();z()}function XC(a,b){var c=0,d=0;c=Za-32|0;Za=c;a:{if(Af(a)>>>0<b>>>0){d=hb(a);b=wl(c+8|0,b,tc(a),d);j[114630]=0;F(209,a|0,b|0);a=j[114630];j[114630]=0;if((a|0)==1){break a}Xl(b)}Za=c+32|0;return}a=D()|0;C()|0;Xl(b);G(a|0);z()}function Wma(a,b){a=a|0;b=b|0;var c=0,d=0;c=Za-16|0;Za=c;j[a+480180>>2]=b;PJ(c,vo(a));d=j[c+12>>2];b=a+1074316|0;j[b>>2]=j[c+8>>2];j[b+4>>2]=d;b=j[c+4>>2];j[a+1074308>>2]=j[c>>2];j[a+1074312>>2]=b;Hr(a+8|0,vo(a));Za=c+16|0}function Qma(a,b){a=a|0;b=b|0;var c=0;c=65535;a:{if(l[j[a+8>>2]+58>>1]<b>>>0){break a}while(1){if(!j[(((b&65535)<<2)+a|0)+900380>>2]){c=b;break a}b=b+1|0;if(l[j[a+8>>2]+58>>1]>=(b&65535)>>>0){continue}break}}return c&65535}function sL(a,b){var c=0,d=0;c=Za-32|0;Za=c;a:{if(jd(a)>>>0<b>>>0){d=hb(a);b=as(c+8|0,b,sb(a),d);j[114630]=0;F(96,a|0,b|0);a=j[114630];j[114630]=0;if((a|0)==1){break a}Rj(b)}Za=c+32|0;return}a=D()|0;C()|0;Rj(b);G(a|0);z()}function aGa(a,b){var c=0,d=0,e=0;c=Za-16|0;Za=c;d=2;e=j[a>>2];if((e|0)!=1){j[c+12>>2]=e>>>1;j[c+8>>2]=-1-j[a>>2];d=tb(c+12|0,c+8|0);j[c+12>>2]=j[a>>2]+j[d>>2];j[c+8>>2]=j[b>>2];d=j[tb(c+12|0,c+8|0)>>2]}Za=c+16|0;return d}function _6(a,b,c,d,e){var f=0,g=0,h=0,i=0,j=q(0);if(e){while(1){f=0;if(d){while(1){h=o[Kg(b,f,g)>>3];Pb(c,f);i=tf(a,f,g),j=q(h),n[i>>2]=j;f=f+1|0;if((f|0)!=(d|0)){continue}break}}g=g+1|0;if((g|0)!=(e|0)){continue}break}}}function Ywa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=Za-32|0;Za=d;e=me(b);c=WM(d+8|0,c);j[114630]=0;V(1025,a|0,b|0,0,e-1&65535,c|0);a=j[114630];j[114630]=0;if((a|0)!=1){Vd(c);Za=d+32|0;return}a=D()|0;C()|0;Vd(c);G(a|0);z()}function Uia(a,b){var c=0,d=0,e=0;c=Za-16|0;Za=c;d=c,e=qia(a,b,se(a),Rb(a)),j[d+8>>2]=e;d=c,e=aj(a),j[d>>2]=e;a:{b:{if(!rb(c+8|0,c)){break b}if(yr(hb(a),b,Sg(c+8|0))){break b}a=j[c+8>>2];break a}a=aj(a)}Za=c+16|0;return a}function OEa(a,b,c){var d=0;d=Za-32|0;Za=d;j[d+28>>2]=c;h[d+27|0]=0;j[d+20>>2]=1;zk(a,d+27|0,j[tb(d+28|0,d+20|0)>>2]);a=ab;if((a|0)>0?1:(a|0)>=0){j[d+16>>2]=1;tb(d+28|0,d+16|0)}h[d+8|0]=k[d+27|0];h[b|0]=k[d+8|0];Za=d+32|0}function Iba(a,b){var c=0,d=0,e=0;c=Za-16|0;Za=c;d=c,e=Gba(a,b,se(a),Rb(a)),j[d+8>>2]=e;d=c,e=aj(a),j[d>>2]=e;a:{b:{if(!rb(c+8|0,c)){break b}if(Zr(hb(a),b,Sg(c+8|0))){break b}a=j[c+8>>2];break a}a=aj(a)}Za=c+16|0;return a}function H$(a,b,c){var d=0;d=Za-32|0;Za=d;j[d+16>>2]=b;j[d+24>>2]=a;j[d+8>>2]=c;while(1){a:{a=rb(d+24|0,d+16|0);if(!a){break a}if(!el(j[d+24>>2],j[d+8>>2])){break a}Id(d+24|0);Id(d+8|0);continue}break}Za=d+32|0;return a^1}function D7(a,b,c,d,e){var f=0,g=0,h=0,i=0,j=q(0);if(e){while(1){f=0;if(d){while(1){h=o[Kg(b,f,g)>>3];Pb(c,f);i=Um(a,f,g),j=q(h),n[i>>2]=j;f=f+1|0;if((f|0)!=(d|0)){continue}break}}g=g+1|0;if((g|0)!=(e|0)){continue}break}}}function BFa(a,b){var c=0,d=0,e=0;c=Za-16|0;Za=c;d=c,e=pFa(a,b,se(a),Rb(a)),j[d+8>>2]=e;d=c,e=aj(a),j[d>>2]=e;a:{b:{if(!rb(c+8|0,c)){break b}if(bn(hb(a),b,Sg(c+8|0))){break b}a=j[c+8>>2];break a}a=aj(a)}Za=c+16|0;return a}function tY(a,b){a=a|0;b=b|0;var c=0;c=Za-16|0;Za=c;a:{if(Xs(b,70676)){NB(c,70689,b);a=zb(c);j[114630]=0;F(2831,44,a|0);a=j[114630];j[114630]=0;if((a|0)!=1){break a}a=D()|0;C()|0;gb(c);G(a|0);z()}Za=c+16|0;return a|0}z()}function pZ(a){a=a|0;a:{b:{if(h[461944]&1){break b}if(!fd(461944)){break b}j[114630]=0;M(2581);a=j[114630];j[114630]=0;if((a|0)==1){break a}j[115485]=462128;ed(461944)}return j[115485]}a=D()|0;C()|0;Zd(461944);G(a|0);z()}function mZ(a){a=a|0;a:{b:{if(h[461952]&1){break b}if(!fd(461952)){break b}j[114630]=0;M(2583);a=j[114630];j[114630]=0;if((a|0)==1){break a}j[115487]=462304;ed(461952)}return j[115487]}a=D()|0;C()|0;Zd(461952);G(a|0);z()}function jZ(a){a=a|0;a:{b:{if(h[461960]&1){break b}if(!fd(461960)){break b}j[114630]=0;M(2585);a=j[114630];j[114630]=0;if((a|0)==1){break a}j[115489]=462480;ed(461960)}return j[115489]}a=D()|0;C()|0;Zd(461960);G(a|0);z()}function gZ(a){a=a|0;a:{b:{if(h[461968]&1){break b}if(!fd(461968)){break b}j[114630]=0;M(2587);a=j[114630];j[114630]=0;if((a|0)==1){break a}j[115491]=462784;ed(461968)}return j[115491]}a=D()|0;C()|0;Zd(461968);G(a|0);z()}function dZ(a){a=a|0;a:{b:{if(h[461976]&1){break b}if(!fd(461976)){break b}j[114630]=0;M(2589);a=j[114630];j[114630]=0;if((a|0)==1){break a}j[115493]=463088;ed(461976)}return j[115493]}a=D()|0;C()|0;Zd(461976);G(a|0);z()}function aZ(a){a=a|0;a:{b:{if(h[461984]&1){break b}if(!fd(461984)){break b}j[114630]=0;M(2591);a=j[114630];j[114630]=0;if((a|0)==1){break a}j[115495]=463120;ed(461984)}return j[115495]}a=D()|0;C()|0;Zd(461984);G(a|0);z()}function Lra(a){var b=0,c=0;c=Cra(a);j[114630]=0;F(1215,a|0,2048);b=j[114630];j[114630]=0;a:{if((b|0)!=1){j[114630]=0;F(1217,a|0,2048);b=j[114630];j[114630]=0;if((b|0)!=1){break a}}a=D()|0;C()|0;Bx(c);G(a|0);z()}return a}function npa(a,b){a=a|0;b=+b;var c=0,d=0,e=0;c=Za-16|0;Za=c;d=c,e=(j[a+480208>>2]&32768?28.85390081777927:34.624680981335125)*(Zn(b)+ -4.8737671609324025),o[d+8>>3]=e;wf(c+8|0,0,127);a=Js(o[c+8>>3]);Za=c+16|0;return a|0}function lx(a,b){var c=0,d=0;c=p(b,896)+a|0;a:{if(j[c+1075072>>2]&134218752){break a}if(!Si(c+1074984|0)){break a}b=k[j[(p(b,896)+a|0)+1075640>>2]+34|0];if((b+5&255)>>>0<6){break a}d=j[(p(b,160)+a|0)+906140>>2]}return d}function lN(a,b,c){var d=0;d=Za-16|0;Za=d;h[d+15|0]=a;a=0;if(!(c>>>0>108|b>>>0>108|(c>>>0<25|b>>>0<25)|b>>>0>=c>>>0)){h[d+14|0]=(l[(b<<1)+20798>>1]-l[(c<<1)+20798>>1]|0)/5;a=k[Zb(d+15|0,d+14|0)|0]}Za=d+16|0;return a&255}function gua(a,b,c){var d=0,e=0,f=0;c=c-1|0;if((c|0)>-1){while(1){d=c<<4;e=c<<3;f=e|4;j[(d|12)+a>>2]=j[f+b>>2];j[(d|8)+a>>2]=j[b+e>>2];j[(d|4)+a>>2]=j[a+f>>2];j[a+d>>2]=j[a+e>>2];d=(c|0)>0;c=c-1|0;if(d){continue}break}}}function Xq(a){var b=0;a:{b=k[a+1376|0];b:{if(!b){b=-1;if(j[a+1384>>2]){break b}if(!Av(a)){break b}b=k[a+1376|0];if(!b){break a}}h[a+1376|0]=b-1;j[a+1400>>2]=j[a+1400>>2]+1;b=he(a)}return b}Y(50594,50512,1563,50614);z()}function TM(a){var b=0,c=0,d=0;b=a- -64|0;d=k[b|0]|k[b+1|0]<<8;b=a+70|0;a=a+72|0;c=k[a|0]|k[a+1|0]<<8;a=(k[b|0]|k[b+1|0]<<8)+c|0;b=0;b=a>>>0<c>>>0?1:b;c=a;a=b<<2|a>>>30;c=c<<2;b=d+c|0;a=b>>>0<c>>>0?a+1|0:a;ab=a;return b}function ODa(a){var b=0,c=0;c=Za-32|0;Za=c;a:{if(jd(a)>>>0<15){b=hb(a);b=wn(c+8|0,15,sb(a),b);j[114630]=0;F(368,a|0,b|0);a=j[114630];j[114630]=0;if((a|0)==1){break a}xh(b)}Za=c+32|0;return}a=D()|0;C()|0;xh(b);G(a|0);z()}function NIa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=Za-16|0;Za=d;e=0;a:{if(!a){break a}e=a|-16;if(!(a>>>0<16&c?0:b>>>0>=2)){break a}h[d+15|0]=1;h[d+14|0]=(a|0)/(b-1|0);e=k[Vg(d+15|0,d+14|0)|0]}a=e;Za=d+16|0;return a&255}function Eka(a,b){var c=0,d=0,e=0,f=0;c=a+1|0;d=a+2|0;e=a+3|0;f=a+4|0;RI(k[a|0]&15,k[c|0]&15,k[d|0]&15,k[e|0]&15,k[f|0]&15,a+5|0,b+48|0);RI(k[a|0]>>>4|0,k[c|0]>>>4|0,k[d|0]>>>4|0,k[e|0]>>>4|0,k[f|0]>>>4|0,a+35|0,b+68|0)}function QZ(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;e=Za-16|0;Za=e;j[e+12>>2]=d;d=bh(e+8|0,e+12|0);j[114630]=0;a=lD(a,b,c);b=j[114630];j[114630]=0;if((b|0)!=1){oe(d);Za=e+16|0;return a|0}a=D()|0;C()|0;oe(d);G(a|0);z()}function Pea(a,b){var c=0,d=0;c=Za-32|0;Za=c;d=j[b+48>>2];a:{if(d&16){if(m[b+24>>2]>m[b+44>>2]){j[b+44>>2]=j[b+24>>2]}Yh(a,j[b+20>>2],j[b+44>>2]);break a}if(d&8){Yh(a,j[b+8>>2],j[b+16>>2]);break a}bw(a,c+8|0)}Za=c+32|0}function $V(a){var b=0,c=0,d=0;c=Za-16|0;Za=c;b=Cn(c,a,1);a=hb(a);d=j[b+4>>2];j[114630]=0;F(266,a|0,d|0);a=j[114630];j[114630]=0;if((a|0)!=1){j[b+4>>2]=j[b+4>>2]+32;ub(b);Za=c+16|0;return}a=D()|0;C()|0;ub(b);G(a|0);z()}function xJ(a,b,c){var d=0,e=0,f=0;d=Za-16|0;Za=d;if(b>>>0<=4294967279){a:{if(b>>>0<=10){Ue(a,b);e=a;break a}f=Fk(b)+1|0;e=Rh(f);lf(a,e);lg(a,f);ee(a,b)}dy(e,b,c);h[d+15|0]=0;Sd(b+e|0,d+15|0);Za=d+16|0;return}jg();z()}function oN(a){var b=0,c=0,d=0;b=a+32|0;d=k[b|0]|k[b+1|0]<<8;b=a+34|0;a=a+36|0;c=k[a|0]|k[a+1|0]<<8;a=(k[b|0]|k[b+1|0]<<8)+c|0;b=0;b=a>>>0<c>>>0?1:b;c=a;a=b<<1|a>>>31;c=c<<1;b=d+c|0;a=b>>>0<c>>>0?a+1|0:a;ab=a;return b}function mva(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=Za-32|0;Za=d;j[d+24>>2]=c;j[d+16>>2]=b;if(rb(d+16|0,d+24|0)){while(1){j[d+12>>2]=j[j[d+16>>2]>>2];Vx(a,d+12|0);Id(d+16|0);if(rb(d+16|0,d+24|0)){continue}break}}Za=d+32|0}function eha(a,b){var c=0,d=0;a:{while(1){if(j[a+8>>2]==(b|0)){break a}c=j[a+16>>2];d=j[a+8>>2]-2048|0;j[a+8>>2]=d;j[114630]=0;F(1646,c|0,d|0);c=j[114630];j[114630]=0;if((c|0)!=1){continue}break}J(0)|0;C()|0;ib();z()}}function bba(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;e=Za-16|0;Za=e;d=Ql(e,a,d);a=hb(a);j[114630]=0;L(2119,a|0,b|0,c|0,d+4|0);a=j[114630];j[114630]=0;if((a|0)!=1){ub(d);Za=e+16|0;return}a=D()|0;C()|0;ub(d);G(a|0);z()}function Xo(a,b,c){var d=0,e=0,f=0;d=Za-16|0;Za=d;if(c>>>0<=4294967279){a:{if(c>>>0<=10){Ue(a,c);e=a;break a}f=Fk(c)+1|0;e=Rh(f);lf(a,e);lg(a,f);ee(a,c)}kh(e,b,c);h[d+15|0]=0;Sd(c+e|0,d+15|0);Za=d+16|0;return}jg();z()}function NL(a,b){a:{if(k[a+76|0]==(b|0)){break a}h[a+76|0]=b;if(b){b=0;if(l[a+24>>1]==15){i[a+20>>1]=0;b=1}j[a+8>>2]=0;j[a+16>>2]=b;return}b:{switch(j[a+16>>2]+1|0){case 0:case 4:break a;default:break b}}j[a+16>>2]=3}}function sd(a){var b=0,c=0,d=0;b=Za-32|0;Za=b;j[b+12>>2]=0;j[b+8>>2]=2559;c=j[b+12>>2];j[b>>2]=j[b+8>>2];j[b+4>>2]=c;d=j[b+4>>2];c=b+16|0;j[c+4>>2]=j[b>>2];j[c+8>>2]=d;j[c>>2]=a;r_(a,c);Za=b+32|0;return j[a+4>>2]-1|0}function nB(a){var b=0;a:{b=a+2|0;if(!(k[b|0]|k[b+1|0]<<8)){break a}a=a+4|0;if(!(k[a|0]|k[a+1|0]<<8|(k[a+2|0]<<16|k[a+3|0]<<24))){break a}return(k[a|0]|k[a+1|0]<<8|(k[a+2|0]<<16|k[a+3|0]<<24))>>>0<2147483649}return 0}function Vka(a,b,c){var d=0;d=Za-32|0;Za=d;j[d+16>>2]=b;j[d+24>>2]=a;j[d+8>>2]=c;if(rb(d+24|0,d+16|0)){while(1){a=h[j[d+24>>2]];h[j[d+8>>2]]=a?a:32;Xf(d+24|0);Xf(d+8|0);if(rb(d+24|0,d+16|0)){continue}break}}Za=d+32|0}function Rm(a){a=a|0;jc(a+16|0,j[a>>2]);jc(a+8|0,j[a>>2]);if(m[a+12>>2]>=m[a+16>>2]){j[a+12>>2]=0;j[a+16>>2]=0;i[a+34>>1]=l[a+34>>1]&65511}if(m[a+4>>2]>=m[a+8>>2]){j[a+4>>2]=0;j[a+8>>2]=0;i[a+34>>1]=l[a+34>>1]&65529}}function F9(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;e=Za-16|0;Za=e;d=Ok(e,a,d);a=hb(a);j[114630]=0;L(2176,a|0,b|0,c|0,d+4|0);a=j[114630];j[114630]=0;if((a|0)!=1){ub(d);Za=e+16|0;return}a=D()|0;C()|0;ub(d);G(a|0);z()}function tka(a,b){var c=0,d=0;a:{while(1){if(j[a+8>>2]==(b|0)){break a}c=j[a+16>>2];d=j[a+8>>2]-24|0;j[a+8>>2]=d;j[114630]=0;F(1555,c|0,d|0);c=j[114630];j[114630]=0;if((c|0)!=1){continue}break}J(0)|0;C()|0;ib();z()}}function ixa(a,b){var c=0,d=0;a:{while(1){if(j[a+8>>2]==(b|0)){break a}c=j[a+16>>2];d=j[a+8>>2]-12|0;j[a+8>>2]=d;j[114630]=0;F(1017,c|0,d|0);c=j[114630];j[114630]=0;if((c|0)!=1){continue}break}J(0)|0;C()|0;ib();z()}}function hja(a,b){var c=0,d=0;a:{while(1){if(j[a+8>>2]==(b|0)){break a}c=j[a+16>>2];d=j[a+8>>2]-52|0;j[a+8>>2]=d;j[114630]=0;F(1433,c|0,d|0);c=j[114630];j[114630]=0;if((c|0)!=1){continue}break}J(0)|0;C()|0;ib();z()}}function gxa(a,b){var c=0,d=0;a:{while(1){if(j[a+8>>2]==(b|0)){break a}c=j[a+16>>2];d=j[a+8>>2]-12|0;j[a+8>>2]=d;j[114630]=0;F(1018,c|0,d|0);c=j[114630];j[114630]=0;if((c|0)!=1){continue}break}J(0)|0;C()|0;ib();z()}}function Wqa(a,b){var c=0,d=0;a:{while(1){if(j[a+8>>2]==(b|0)){break a}c=j[a+16>>2];d=j[a+8>>2]-12|0;j[a+8>>2]=d;j[114630]=0;F(1231,c|0,d|0);c=j[114630];j[114630]=0;if((c|0)!=1){continue}break}J(0)|0;C()|0;ib();z()}}function WY(a){a=a|0;a:{b:{if(h[462016]&1){break b}if(!fd(462016)){break b}j[114630]=0;E(2594,462004,64984)|0;a=j[114630];j[114630]=0;if((a|0)==1){break a}ed(462016)}return 462004}a=D()|0;C()|0;Zd(462016);G(a|0);z()}function SY(a){a=a|0;a:{b:{if(h[462048]&1){break b}if(!fd(462048)){break b}j[114630]=0;E(2594,462036,65032)|0;a=j[114630];j[114630]=0;if((a|0)==1){break a}ed(462048)}return 462036}a=D()|0;C()|0;Zd(462048);G(a|0);z()}function OY(a){a=a|0;a:{b:{if(h[462080]&1){break b}if(!fd(462080)){break b}j[114630]=0;E(2594,462068,65092)|0;a=j[114630];j[114630]=0;if((a|0)==1){break a}ed(462080)}return 462068}a=D()|0;C()|0;Zd(462080);G(a|0);z()}function KY(a){a=a|0;a:{b:{if(h[462112]&1){break b}if(!fd(462112)){break b}j[114630]=0;E(2594,462100,65188)|0;a=j[114630];j[114630]=0;if((a|0)==1){break a}ed(462112)}return 462100}a=D()|0;C()|0;Zd(462112);G(a|0);z()}function D8(a,b){a=a|0;b=b|0;var c=0,d=0;c=Za-16|0;Za=c;En(a);j[a>>2]=83928;d=_g(c+8|0);b=_g(b);j[114630]=0;K(2197,a+12|0,d|0,b|0)|0;b=j[114630];j[114630]=0;if((b|0)!=1){Za=c+16|0;return a|0}a=D()|0;C()|0;G(a|0);z()}function Csa(a,b){var c=0,d=0;a:{while(1){if(j[a+8>>2]==(b|0)){break a}c=j[a+16>>2];d=j[a+8>>2]-32|0;j[a+8>>2]=d;j[114630]=0;F(1189,c|0,d|0);c=j[114630];j[114630]=0;if((c|0)!=1){continue}break}J(0)|0;C()|0;ib();z()}}function Bv(a){var b=0;a:{b:{while(1){if(j[a+1380>>2]!=-1){break b}b=0;if(!Wq(a)){break a}if(!(h[a+1375|0]&1)){continue}break}Nb(a,32);return 0}j[a+1396>>2]=0;j[a+1400>>2]=0;j[a+1384>>2]=0;h[a+1376|0]=0;b=1}return b}function A8(a,b){a=a|0;b=b|0;var c=0,d=0;c=Za-16|0;Za=c;En(a);j[a>>2]=83968;d=_g(c+8|0);b=_g(b);j[114630]=0;K(2199,a+12|0,d|0,b|0)|0;b=j[114630];j[114630]=0;if((b|0)!=1){Za=c+16|0;return a|0}a=D()|0;C()|0;G(a|0);z()}function zJa(a,b){var c=0,d=0;a:{while(1){if(j[a+8>>2]==(b|0)){break a}c=j[a+16>>2];d=j[a+8>>2]-24|0;j[a+8>>2]=d;j[114630]=0;F(527,c|0,d|0);c=j[114630];j[114630]=0;if((c|0)!=1){continue}break}J(0)|0;C()|0;ib();z()}}function xL(a,b){var c=0,d=0,e=0,f=0;e=o[a+48>>3];c=o[a+40>>3];o[a+48>>3]=c;f=o[a+64>>3];d=o[a+56>>3];o[a+64>>3]=d;o[a+40>>3]=b;b=c*o[a+8>>3]+o[a>>3]*b+e*o[a+16>>3]-(f*o[a+32>>3]+d*o[a+24>>3]);o[a+56>>3]=b;return b}function vya(a,b){var c=0,d=0;a:{while(1){if(j[a+8>>2]==(b|0)){break a}c=j[a+16>>2];d=j[a+8>>2]-56|0;j[a+8>>2]=d;j[114630]=0;F(984,c|0,d|0);c=j[114630];j[114630]=0;if((c|0)!=1){continue}break}J(0)|0;C()|0;ib();z()}}function vma(a,b){var c=0,d=0;a:{while(1){if(j[a+8>>2]==(b|0)){break a}c=j[a+16>>2];d=j[a+8>>2]-4|0;j[a+8>>2]=d;j[114630]=0;F(1435,c|0,d|0);c=j[114630];j[114630]=0;if((c|0)!=1){continue}break}J(0)|0;C()|0;ib();z()}}function swa(a,b){var c=0,d=0;a:{while(1){if(j[a+8>>2]==(b|0)){break a}c=j[a+16>>2];d=j[a+8>>2]-4|0;j[a+8>>2]=d;j[114630]=0;F(1054,c|0,d|0);c=j[114630];j[114630]=0;if((c|0)!=1){continue}break}J(0)|0;C()|0;ib();z()}}function rHa(a,b){var c=0,d=0;a:{while(1){if(j[a+8>>2]==(b|0)){break a}c=j[a+16>>2];d=j[a+8>>2]-16|0;j[a+8>>2]=d;j[114630]=0;F(426,c|0,d|0);c=j[114630];j[114630]=0;if((c|0)!=1){continue}break}J(0)|0;C()|0;ib();z()}}function qIa(a,b){var c=0,d=0;a:{while(1){if(j[a+8>>2]==(b|0)){break a}c=j[a+16>>2];d=j[a+8>>2]-48|0;j[a+8>>2]=d;j[114630]=0;F(573,c|0,d|0);c=j[114630];j[114630]=0;if((c|0)!=1){continue}break}J(0)|0;C()|0;ib();z()}}function nIa(a,b){var c=0,d=0;a:{while(1){if(j[a+8>>2]==(b|0)){break a}c=j[a+16>>2];d=j[a+8>>2]-24|0;j[a+8>>2]=d;j[114630]=0;F(572,c|0,d|0);c=j[114630];j[114630]=0;if((c|0)!=1){continue}break}J(0)|0;C()|0;ib();z()}}function ls(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=Za-16|0;Za=d;mb(d+8|0,c+1074308|0,102);a:{if(!kb(d+8|0)){break a}c=l[a+692>>1]+1|0;i[a+796>>1]=c;if(!(h[a+89|0]&1)){break a}i[a+796>>1]=c|32768}j[a+692>>2]=b;Za=d+16|0}function k8(a,b){var c=0,d=0;a:{while(1){if(j[a+8>>2]==(b|0)){break a}c=j[a+16>>2];d=j[a+8>>2]-16|0;j[a+8>>2]=d;j[114630]=0;F(2200,c|0,d|0);c=j[114630];j[114630]=0;if((c|0)!=1){continue}break}J(0)|0;C()|0;ib();z()}}function hoa(a,b){var c=0,d=0;a:{while(1){if(j[a+8>>2]==(b|0)){break a}c=j[a+16>>2];d=j[a+8>>2]-32|0;j[a+8>>2]=d;j[114630]=0;F(891,c|0,d|0);c=j[114630];j[114630]=0;if((c|0)!=1){continue}break}J(0)|0;C()|0;ib();z()}}function gW(a,b){a=a|0;b=b|0;var c=0,d=0;b=Za-32|0;Za=b;c=b+16|0;d=FV(a,c);if(!d){aB(c)}c=-1;a:{if(!d){break a}c=0;if(!oB(b+16|0)){break a}c=b;a=EV(a,b);if(!a){_A(c)}c=-1;if(!a){break a}c=nB(b)}Za=b+32|0;return c|0}function e8(a,b){var c=0,d=0;a:{while(1){if(j[a+8>>2]==(b|0)){break a}c=j[a+16>>2];d=j[a+8>>2]-24|0;j[a+8>>2]=d;j[114630]=0;F(2201,c|0,d|0);c=j[114630];j[114630]=0;if((c|0)!=1){continue}break}J(0)|0;C()|0;ib();z()}}function dka(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0;ct(a);e=j[b+4>>2];d=b+4|0;TP(hb(a),j[a>>2],c,d);f=c;c=b+8|0;CI(hb(a),f,j[a+4>>2],c);Ib(a,d);Ib(a+4|0,c);Ib(hb(a),Ob(b));j[b>>2]=j[b+4>>2];gt(a,Lf(a));return e|0}function aha(a,b){var c=0,d=0;a:{while(1){if(j[a+8>>2]==(b|0)){break a}c=j[a+16>>2];d=j[a+8>>2]-4|0;j[a+8>>2]=d;j[114630]=0;F(1648,c|0,d|0);c=j[114630];j[114630]=0;if((c|0)!=1){continue}break}J(0)|0;C()|0;ib();z()}}function _fa(a,b){var c=0,d=0;a:{while(1){if(j[a+8>>2]==(b|0)){break a}c=j[a+16>>2];d=j[a+8>>2]-4|0;j[a+8>>2]=d;j[114630]=0;F(1758,c|0,d|0);c=j[114630];j[114630]=0;if((c|0)!=1){continue}break}J(0)|0;C()|0;ib();z()}}function Vta(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0;$e(a);e=j[b+4>>2];d=b+4|0;oi(hb(a),j[a>>2],c,d);f=c;c=b+8|0;on(hb(a),f,j[a+4>>2],c);Ib(a,d);Ib(a+4|0,c);Ib(hb(a),Ob(b));j[b>>2]=j[b+4>>2];Pj(a,sb(a));return e|0}function QDa(a,b){var c=0,d=0;a:{while(1){if(j[a+8>>2]==(b|0)){break a}c=j[a+16>>2];d=j[a+8>>2]-33|0;j[a+8>>2]=d;j[114630]=0;F(765,c|0,d|0);c=j[114630];j[114630]=0;if((c|0)!=1){continue}break}J(0)|0;C()|0;ib();z()}}function Nha(a,b){var c=0,d=0;a:{while(1){if(j[a+8>>2]==(b|0)){break a}c=j[a+16>>2];d=j[a+8>>2]-4|0;j[a+8>>2]=d;j[114630]=0;F(1434,c|0,d|0);c=j[114630];j[114630]=0;if((c|0)!=1){continue}break}J(0)|0;C()|0;ib();z()}}function NV(a,b){a=a|0;b=b|0;var c=0,d=0;c=Za-16|0;Za=c;En(a);j[a>>2]=77128;d=_g(c+8|0);b=_g(b);j[114630]=0;K(275,a+12|0,d|0,b|0)|0;b=j[114630];j[114630]=0;if((b|0)!=1){Za=c+16|0;return a|0}a=D()|0;C()|0;G(a|0);z()}function Jya(a,b){var c=0,d=0;a:{while(1){if(j[a+8>>2]==(b|0)){break a}c=j[a+16>>2];d=j[a+8>>2]-24|0;j[a+8>>2]=d;j[114630]=0;F(980,c|0,d|0);c=j[114630];j[114630]=0;if((c|0)!=1){continue}break}J(0)|0;C()|0;ib();z()}}function Ila(a,b){var c=0,d=0;a:{while(1){if(j[a+8>>2]==(b|0)){break a}c=j[a+16>>2];d=j[a+8>>2]-4|0;j[a+8>>2]=d;j[114630]=0;F(1519,c|0,d|0);c=j[114630];j[114630]=0;if((c|0)!=1){continue}break}J(0)|0;C()|0;ib();z()}}function Dqa(a,b){var c=0,d=0;a:{while(1){if(j[a+8>>2]==(b|0)){break a}c=j[a+16>>2];d=j[a+8>>2]-12|0;j[a+8>>2]=d;j[114630]=0;F(348,c|0,d|0);c=j[114630];j[114630]=0;if((c|0)!=1){continue}break}J(0)|0;C()|0;ib();z()}}function DHa(a,b){var c=0,d=0;a:{while(1){if(j[a+8>>2]==(b|0)){break a}c=j[a+16>>2];d=j[a+8>>2]-24|0;j[a+8>>2]=d;j[114630]=0;F(604,c|0,d|0);c=j[114630];j[114630]=0;if((c|0)!=1){continue}break}J(0)|0;C()|0;ib();z()}}function ADa(a,b){var c=0,d=0;a:{while(1){if(j[a+8>>2]==(b|0)){break a}c=j[a+16>>2];d=j[a+8>>2]-24|0;j[a+8>>2]=d;j[114630]=0;F(767,c|0,d|0);c=j[114630];j[114630]=0;if((c|0)!=1){continue}break}J(0)|0;C()|0;ib();z()}}function yCa(a,b){var c=0,d=0;a:{while(1){if(j[a+8>>2]==(b|0)){break a}c=j[a+16>>2];d=j[a+8>>2]-2|0;j[a+8>>2]=d;j[114630]=0;F(824,c|0,d|0);c=j[114630];j[114630]=0;if((c|0)!=1){continue}break}J(0)|0;C()|0;ib();z()}}function uza(a,b){var c=0,d=0;a:{while(1){if(j[a+8>>2]==(b|0)){break a}c=j[a+16>>2];d=j[a+8>>2]-4|0;j[a+8>>2]=d;j[114630]=0;F(945,c|0,d|0);c=j[114630];j[114630]=0;if((c|0)!=1){continue}break}J(0)|0;C()|0;ib();z()}}function tia(a,b){var c=0,d=0;a:{while(1){if(j[a+8>>2]==(b|0)){break a}c=j[a+16>>2];d=j[a+8>>2]-4|0;j[a+8>>2]=d;j[114630]=0;F(734,c|0,d|0);c=j[114630];j[114630]=0;if((c|0)!=1){continue}break}J(0)|0;C()|0;ib();z()}}function rJa(a,b){var c=0,d=0;a:{while(1){if(j[a+8>>2]==(b|0)){break a}c=j[a+16>>2];d=j[a+8>>2]-2|0;j[a+8>>2]=d;j[114630]=0;F(531,c|0,d|0);c=j[114630];j[114630]=0;if((c|0)!=1){continue}break}J(0)|0;C()|0;ib();z()}}function pY(a){var b=0;j[114630]=0;a=H(2832,a|0)|0;b=j[114630];j[114630]=0;a:{if((b|0)==1){a=J(0)|0;C()|0;O(a|0)|0;j[114630]=0;M(20);b=j[114630];j[114630]=0;a=0;if((b|0)==1){break a}}return a}J(0)|0;C()|0;ib();z()}function pLa(a,b){var c=0,d=0;a:{while(1){if(j[a+8>>2]==(b|0)){break a}c=j[a+16>>2];d=j[a+8>>2]-2|0;j[a+8>>2]=d;j[114630]=0;F(422,c|0,d|0);c=j[114630];j[114630]=0;if((c|0)!=1){continue}break}J(0)|0;C()|0;ib();z()}}function oY(a,b){var c=0,d=0;c=Za-16|0;Za=c;b=b>>>0>4?b:4;a=a?a:1;a:{while(1){if(!pX(c+12|0,b,a)){break a}d=j[115937];if(d){bb[d|0]();continue}break}a=R(4)|0;Bk(a);X(a|0,71412,2003);z()}Za=c+16|0;return j[c+12>>2]}function kg(a){var b=0;j[114630]=0;a=H(1394,a|0)|0;b=j[114630];j[114630]=0;a:{if((b|0)==1){a=J(0)|0;C()|0;O(a|0)|0;j[114630]=0;M(20);b=j[114630];j[114630]=0;a=0;if((b|0)==1){break a}}return a}J(0)|0;C()|0;ib();z()}function kV(a,b){var c=0,d=0;a:{while(1){if(j[a+8>>2]==(b|0)){break a}c=j[a+16>>2];d=j[a+8>>2]-32|0;j[a+8>>2]=d;j[114630]=0;F(276,c|0,d|0);c=j[114630];j[114630]=0;if((c|0)!=1){continue}break}J(0)|0;C()|0;ib();z()}}function jm(a,b){var c=0,d=0,e=0;c=a*a;d=c*a;e=d*(c*.13339200271297674+.3333313950307914)+a;a=c*c;a=e+d*a*(c*.024528318116654728+.05338123784456704+a*(c*.009465647849436732+.002974357433599673));return q(b?-1/a:a)}function jMa(a,b){var c=0,d=0;a:{while(1){if(j[a+8>>2]==(b|0)){break a}c=j[a+16>>2];d=j[a+8>>2]-2|0;j[a+8>>2]=d;j[114630]=0;F(382,c|0,d|0);c=j[114630];j[114630]=0;if((c|0)!=1){continue}break}J(0)|0;C()|0;ib();z()}}function cqa(a,b){var c=0,d=0;a:{while(1){if(j[a+8>>2]==(b|0)){break a}c=j[a+16>>2];d=j[a+8>>2]-4|0;j[a+8>>2]=d;j[114630]=0;F(107,c|0,d|0);c=j[114630];j[114630]=0;if((c|0)!=1){continue}break}J(0)|0;C()|0;ib();z()}}function aAa(a,b){var c=0,d=0;a:{while(1){if(j[a+8>>2]==(b|0)){break a}c=j[a+16>>2];d=j[a+8>>2]-8|0;j[a+8>>2]=d;j[114630]=0;F(919,c|0,d|0);c=j[114630];j[114630]=0;if((c|0)!=1){continue}break}J(0)|0;C()|0;ib();z()}}function UY(a){a=a|0;a:{b:{if(h[462032]&1){break b}if(!fd(462032)){break b}j[114630]=0;E(85,462020,65020)|0;a=j[114630];j[114630]=0;if((a|0)==1){break a}ed(462032)}return 462020}a=D()|0;C()|0;Zd(462032);G(a|0);z()}function QY(a){a=a|0;a:{b:{if(h[462064]&1){break b}if(!fd(462064)){break b}j[114630]=0;E(85,462052,65068)|0;a=j[114630];j[114630]=0;if((a|0)==1){break a}ed(462064)}return 462052}a=D()|0;C()|0;Zd(462064);G(a|0);z()}function QEa(a,b){var c=0,d=0;a:{while(1){if(j[a+8>>2]==(b|0)){break a}c=j[a+16>>2];d=j[a+8>>2]-6|0;j[a+8>>2]=d;j[114630]=0;F(736,c|0,d|0);c=j[114630];j[114630]=0;if((c|0)!=1){continue}break}J(0)|0;C()|0;ib();z()}}function OW(a,b){var c=0,d=0;a:{while(1){if(j[a+8>>2]==(b|0)){break a}c=j[a+16>>2];d=j[a+8>>2]-16|0;j[a+8>>2]=d;j[114630]=0;F(217,c|0,d|0);c=j[114630];j[114630]=0;if((c|0)!=1){continue}break}J(0)|0;C()|0;ib();z()}}function N2(a,b){var c=0,d=0;a:{while(1){if(j[a+8>>2]==(b|0)){break a}c=j[a+16>>2];d=j[a+8>>2]-12|0;j[a+8>>2]=d;j[114630]=0;F(206,c|0,d|0);c=j[114630];j[114630]=0;if((c|0)!=1){continue}break}J(0)|0;C()|0;ib();z()}}function MY(a){a=a|0;a:{b:{if(h[462096]&1){break b}if(!fd(462096)){break b}j[114630]=0;E(85,462084,65176)|0;a=j[114630];j[114630]=0;if((a|0)==1){break a}ed(462096)}return 462084}a=D()|0;C()|0;Zd(462096);G(a|0);z()}function JR(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0;rk(a);e=j[b+4>>2];d=b+4|0;oi(hb(a),j[a>>2],c,d);f=c;c=b+8|0;on(hb(a),f,j[a+4>>2],c);Ib(a,d);Ib(a+4|0,c);Ib(hb(a),Ob(b));j[b>>2]=j[b+4>>2];Nt(a,Yb(a));return e|0}function HCa(a,b){var c=0,d=0;a:{while(1){if(j[a+8>>2]==(b|0)){break a}c=j[a+16>>2];d=j[a+8>>2]-4|0;j[a+8>>2]=d;j[114630]=0;F(817,c|0,d|0);c=j[114630];j[114630]=0;if((c|0)!=1){continue}break}J(0)|0;C()|0;ib();z()}}function $Ea(a,b){var c=0,d=0;a:{while(1){if(j[a+8>>2]==(b|0)){break a}c=j[a+16>>2];d=j[a+8>>2]-4|0;j[a+8>>2]=d;j[114630]=0;F(737,c|0,d|0);c=j[114630];j[114630]=0;if((c|0)!=1){continue}break}J(0)|0;C()|0;ib();z()}}function yFa(a,b,c,d,e){var f=0,g=0;f=Za-32|0;Za=f;g=xFa(b,f+28|0,c);c=j[g>>2];h[f+27|0]=0;if(!c){wFa(f+8|0,b,d,e);bk(b,j[f+28>>2],g,j[f+8>>2]);c=ud(f+8|0);h[f+27|0]=1;lQ(f+8|0)}fi(a,yc(f+8|0,c),f+27|0);Za=f+32|0}function sU(a,b){var c=0,d=0;a:{while(1){if(j[a+8>>2]==(b|0)){break a}c=j[a+16>>2];d=j[a+8>>2]-4|0;j[a+8>>2]=d;j[114630]=0;F(349,c|0,d|0);c=j[114630];j[114630]=0;if((c|0)!=1){continue}break}J(0)|0;C()|0;ib();z()}}function jza(a,b){a=a|0;b=b|0;var c=0;c=Za-16|0;Za=c;JN(a,c+11|0);if((k[c+11|0]|k[c+12|0]<<8|(k[c+13|0]<<16|k[c+14|0]<<24))==1414807888){JN(a,c+11|0);h[b|0]=1;a=0}else{a=1}a=aza(a+(c+11|0)|0);Za=c+16|0;return a|0}function VT(a,b){var c=0,d=0;a:{while(1){if(j[a+8>>2]==(b|0)){break a}c=j[a+16>>2];d=j[a+8>>2]-1|0;j[a+8>>2]=d;j[114630]=0;F(361,c|0,d|0);c=j[114630];j[114630]=0;if((c|0)!=1){continue}break}J(0)|0;C()|0;ib();z()}}function UW(a,b){var c=0,d=0;a:{while(1){if(j[a+8>>2]==(b|0)){break a}c=j[a+16>>2];d=j[a+8>>2]-1|0;j[a+8>>2]=d;j[114630]=0;F(215,c|0,d|0);c=j[114630];j[114630]=0;if((c|0)!=1){continue}break}J(0)|0;C()|0;ib();z()}}function UK(a,b,c){var d=0,e=0;d=Za-16|0;Za=d;e=c&15;if(e){h[b+844|0]=e}c=c&240;if(c){h[b+843|0]=c>>>4}j[b+88>>2]=j[b+88>>2]|131072;mb(d+8|0,a+1074308|0,80);if(!(!e|!kb(d+8|0))){h[b+844|0]=k[b+844|0]<<2}Za=d+16|0}function UCa(a,b,c,d,e){var f=0,g=0;f=Za-32|0;Za=f;g=wCa(b,f+28|0,c);c=j[g>>2];h[f+27|0]=0;if(!c){vCa(f+8|0,b,d,e);bk(b,j[f+28>>2],g,j[f+8>>2]);c=ud(f+8|0);h[f+27|0]=1;cP(f+8|0)}fi(a,yc(f+8|0,c),f+27|0);Za=f+32|0}function TT(a,b){var c=0,d=0;a:{while(1){if(j[a+8>>2]==(b|0)){break a}c=j[a+16>>2];d=j[a+8>>2]-2|0;j[a+8>>2]=d;j[114630]=0;F(362,c|0,d|0);c=j[114630];j[114630]=0;if((c|0)!=1){continue}break}J(0)|0;C()|0;ib();z()}}function Roa(a,b,c,d,e){var f=0,g=0;f=Za-32|0;Za=f;g=goa(b,f+28|0,c);c=j[g>>2];h[f+27|0]=0;if(!c){foa(f+8|0,b,d,e);bk(b,j[f+28>>2],g,j[f+8>>2]);c=ud(f+8|0);h[f+27|0]=1;cK(f+8|0)}fi(a,yc(f+8|0,c),f+27|0);Za=f+32|0}function Ria(a,b,c,d,e){var f=0,g=0;f=Za-32|0;Za=f;g=pia(b,f+28|0,c);c=j[g>>2];h[f+27|0]=0;if(!c){oia(f+8|0,b,d,e);bk(b,j[f+28>>2],g,j[f+8>>2]);c=ud(f+8|0);h[f+27|0]=1;eI(f+8|0)}fi(a,yc(f+8|0,c),f+27|0);Za=f+32|0}function Ooa(a,b,c,d,e){var f=0,g=0;f=Za-32|0;Za=f;g=_na(b,f+28|0,c);c=j[g>>2];h[f+27|0]=0;if(!c){Zna(f+8|0,b,d,e);bk(b,j[f+28>>2],g,j[f+8>>2]);c=ud(f+8|0);h[f+27|0]=1;aK(f+8|0)}fi(a,yc(f+8|0,c),f+27|0);Za=f+32|0}function Nda(a,b,c,d,e){var f=0,g=0;f=Za-32|0;Za=f;g=Gqa(b,f+28|0,c);c=j[g>>2];h[f+27|0]=0;if(!c){Lba(f+8|0,b,d,e);bk(b,j[f+28>>2],g,j[f+8>>2]);c=ud(f+8|0);h[f+27|0]=1;dL(f+8|0)}fi(a,yc(f+8|0,c),f+27|0);Za=f+32|0}function Ena(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=Za-32|0;Za=d;a=j[a+1304560>>2];a:{if(a){bb[j[j[a>>2]+8>>2]](a,b,c);break a}if(j[19108]<(b|0)){break a}QJ(d+8|0,20495,20516,132);cD(d+24|0,d+8|0,b,20486,c)}Za=d+32|0}function AT(a,b){var c=0,d=0;a:{while(1){if(j[a+8>>2]==(b|0)){break a}c=j[a+16>>2];d=j[a+8>>2]-4|0;j[a+8>>2]=d;j[114630]=0;F(372,c|0,d|0);c=j[114630];j[114630]=0;if((c|0)!=1){continue}break}J(0)|0;C()|0;ib();z()}}function $Ka(a,b){var c=0,d=0;a:{while(1){if(j[a+8>>2]==(b|0)){break a}c=j[a+16>>2];d=j[a+8>>2]-1|0;j[a+8>>2]=d;j[114630]=0;F(32,c|0,d|0);c=j[114630];j[114630]=0;if((c|0)!=1){continue}break}J(0)|0;C()|0;ib();z()}}function ysa(a,b){a=a|0;b=b|0;var c=0,d=0;d=a+808|0;c=a+16|0;while(1){c=xsa(c)+44|0;if((d|0)!=(c|0)){continue}break}d=a+3832|0;c=a+808|0;while(1){c=wsa(c)+84|0;if((d|0)!=(c|0)){continue}break}vsa(a,b);return a|0}function nn(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=Za-16|0;Za=d;a:{if(c){Db(d,c);break a}Cb(d)}j[114630]=0;I(13,a|0,b|0,d|0);a=j[114630];j[114630]=0;if((a|0)!=1){gb(d);Za=d+16|0;return}a=D()|0;C()|0;gb(d);G(a|0);z()}function Ww(a,b){var c=0;c=j[b+24>>2];c=c?c:1;j[a+24628>>2]=c>>>0<512?c:512;a:{if(!(j[b+16>>2]!=j[a+24620>>2]|j[b+20>>2]!=j[a+24624>>2])){c=0;if(j[b+12>>2]==j[a+24616>>2]){break a}}c=1}Vb(a+24604|0,b,40);wJ(a,c)}function aua(a,b,c,d,e){var f=0,g=0,h=0,i=0;if(!(!d|e==q(1))){while(1){if(c){i=b+g|0;f=0;while(1){h=tf(a,f,i);n[h>>2]=n[h>>2]*e;f=f+1|0;if((f|0)!=(c|0)){continue}break}}g=g+1|0;if((g|0)!=(d|0)){continue}break}}}function MH(a,b){var c=0,d=0;c=j[a+4>>2];a:{while(1){if((b|0)==(c|0)){break a}d=hb(a);j[114630]=0;c=c-2048|0;F(1646,d|0,c|0);d=j[114630];j[114630]=0;if((d|0)!=1){continue}break}J(0)|0;C()|0;ib();z()}j[a+4>>2]=b}function IV(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0;e=Za-16|0;Za=e;j[e+12>>2]=d;d=0;f=j[a+8>>2];if(f>>>0>c>>>0){j[e+8>>2]=f-c;d=tb(e+8|0,e+12|0);a=j[a+4>>2]+c|0;d=j[d>>2];Pe(a,a+d|0,b)}Za=e+16|0;return d|0}function Gk(a,b){a=a|0;b=b|0;E1(a);j[a+28>>2]=b;bD(a+32|0);c1(a+44|0);j[a+72>>2]=0;j[a+76>>2]=0;j[a+64>>2]=0;j[a+56>>2]=0;j[a+60>>2]=0;j[a+80>>2]=0;j[a+84>>2]=0;j[a+88>>2]=0;j[a+92>>2]=0;j[a+96>>2]=0;return a|0}function $ta(a,b,c,d,e){var f=0,g=0,h=0,i=0;if(!(!d|e==q(1))){while(1){if(c){i=b+g|0;f=0;while(1){h=Um(a,f,i);n[h>>2]=n[h>>2]*e;f=f+1|0;if((f|0)!=(c|0)){continue}break}}g=g+1|0;if((g|0)!=(d|0)){continue}break}}}function xka(a,b){var c=0,d=0;c=j[a+4>>2];a:{while(1){if((b|0)==(c|0)){break a}d=hb(a);j[114630]=0;c=c-24|0;F(1555,d|0,c|0);d=j[114630];j[114630]=0;if((d|0)!=1){continue}break}J(0)|0;C()|0;ib();z()}j[a+4>>2]=b}function tra(a,b){var c=0,d=0;c=j[a+4>>2];a:{while(1){if((b|0)==(c|0)){break a}d=hb(a);j[114630]=0;c=c-16|0;F(1226,d|0,c|0);d=j[114630];j[114630]=0;if((d|0)!=1){continue}break}J(0)|0;C()|0;ib();z()}j[a+4>>2]=b}function sxa(a,b){var c=0,d=0;c=j[a+4>>2];a:{while(1){if((b|0)==(c|0)){break a}d=hb(a);j[114630]=0;c=c-12|0;F(1018,d|0,c|0);d=j[114630];j[114630]=0;if((d|0)!=1){continue}break}J(0)|0;C()|0;ib();z()}j[a+4>>2]=b}function pA(a){var b=0,c=0;b=Za-16|0;Za=b;hb(a);j[b+12>>2]=2147483647;j[114630]=0;j[b+8>>2]=2147483647;a=E(33,b+12|0,b+8|0)|0;c=j[114630];j[114630]=0;if((c|0)!=1){Za=b+16|0;return j[a>>2]}J(0)|0;C()|0;ib();z()}function gv(a){a=a|0;var b=0;j[a>>2]=59064;j[114630]=0;F(2368,a|0,0);b=j[114630];j[114630]=0;if((b|0)!=1){wb(a+28|0);Fb(j[a+32>>2]);Fb(j[a+36>>2]);Fb(j[a+48>>2]);Fb(j[a+60>>2]);return a|0}J(0)|0;C()|0;ib();z()}function aza(a){var b=0,c=0,d=0;b=Za-16|0;Za=b;a:{b:{if(!a){a=0;break b}c=Db(b,a);j[114630]=0;a=H(972,c|0)|0;d=j[114630];j[114630]=0;if((d|0)==1){break a}gb(c)}Za=b+16|0;return a}a=D()|0;C()|0;gb(c);G(a|0);z()}function YY(a){a=a|0;a:{b:{if(h[462e3]&1){break b}if(!fd(462e3)){break b}j[114630]=0;E(85,461988,64972)|0;a=j[114630];j[114630]=0;if((a|0)==1){break a}ed(462e3)}return 461988}a=D()|0;C()|0;Zd(462e3);G(a|0);z()}function Vw(a,b){var c=0,d=0;c=j[b+4>>2];j[a+24648>>2]=j[b>>2];j[a+24652>>2]=c;d=j[b+20>>2];c=a+24664|0;j[c>>2]=j[b+16>>2];j[c+4>>2]=d;d=j[b+12>>2];c=a+24656|0;j[c>>2]=j[b+8>>2];j[c+4>>2]=d;vJ(a+24648|0);IJ(a)}function UDa(a){var b=0,c=0;b=Za-16|0;Za=b;hb(a);j[b+12>>2]=130150524;j[114630]=0;j[b+8>>2]=2147483647;a=E(33,b+12|0,b+8|0)|0;c=j[114630];j[114630]=0;if((c|0)!=1){Za=b+16|0;return j[a>>2]}J(0)|0;C()|0;ib();z()}function Mm(a){var b=0,c=0;b=Za-16|0;Za=b;hb(a);j[b+12>>2]=1073741823;j[114630]=0;j[b+8>>2]=2147483647;a=E(33,b+12|0,b+8|0)|0;c=j[114630];j[114630]=0;if((c|0)!=1){Za=b+16|0;return j[a>>2]}J(0)|0;C()|0;ib();z()}function Lsa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;e=Za-16|0;Za=e;j[e>>2]=c;j[e+8>>2]=b;if(rb(e+8|0,e)){while(1){Ap(a,j[d>>2],j[e+8>>2]);je(e+8|0);j[d>>2]=j[d>>2]+2;if(rb(e+8|0,e)){continue}break}}Za=e+16|0}function FBa(a){var b=0,c=0;b=Za-16|0;Za=b;hb(a);j[b+12>>2]=214748364;j[114630]=0;j[b+8>>2]=2147483647;a=E(33,b+12|0,b+8|0)|0;c=j[114630];j[114630]=0;if((c|0)!=1){Za=b+16|0;return j[a>>2]}J(0)|0;C()|0;ib();z()}function zra(a,b){var c=0,d=0;c=j[a+4>>2];a:{while(1){if((b|0)==(c|0)){break a}d=hb(a);j[114630]=0;c=c-8|0;F(1223,d|0,c|0);d=j[114630];j[114630]=0;if((d|0)!=1){continue}break}J(0)|0;C()|0;ib();z()}j[a+4>>2]=b}function yya(a){var b=0,c=0;b=Za-16|0;Za=b;hb(a);j[b+12>>2]=76695844;j[114630]=0;j[b+8>>2]=2147483647;a=E(33,b+12|0,b+8|0)|0;c=j[114630];j[114630]=0;if((c|0)!=1){Za=b+16|0;return j[a>>2]}J(0)|0;C()|0;ib();z()}function yIa(a,b){var c=0,d=0;c=j[a+4>>2];a:{while(1){if((b|0)==(c|0)){break a}d=hb(a);j[114630]=0;c=c-24|0;F(572,d|0,c|0);d=j[114630];j[114630]=0;if((d|0)!=1){continue}break}J(0)|0;C()|0;ib();z()}j[a+4>>2]=b}function xu(a,b,c){var d=0;d=j[a+16>>2];if(!d){j[a+36>>2]=1;j[a+24>>2]=c;j[a+16>>2]=b;return}a:{if((b|0)==(d|0)){if(j[a+24>>2]!=2){break a}j[a+24>>2]=c;return}h[a+54|0]=1;j[a+24>>2]=2;j[a+36>>2]=j[a+36>>2]+1}}function xma(a,b){var c=0,d=0;c=j[a+4>>2];a:{while(1){if((b|0)==(c|0)){break a}d=hb(a);j[114630]=0;c=c-4|0;F(1435,d|0,c|0);d=j[114630];j[114630]=0;if((d|0)!=1){continue}break}J(0)|0;C()|0;ib();z()}j[a+4>>2]=b}function xEa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0;d=Za-16|0;Za=d;j[d+12>>2]=c;e=d,f=iEa(Lb(b),Mb(b),d+12|0),j[e+8>>2]=f;e=d,f=Mb(b),j[e>>2]=f;a:{if(rb(d+8|0,d)){He(a,hb(j[d+8>>2]));break a}zh(a)}Za=d+16|0}function wwa(a,b){var c=0,d=0;c=j[a+4>>2];a:{while(1){if((b|0)==(c|0)){break a}d=hb(a);j[114630]=0;c=c-4|0;F(1054,d|0,c|0);d=j[114630];j[114630]=0;if((d|0)!=1){continue}break}J(0)|0;C()|0;ib();z()}j[a+4>>2]=b}function wl(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0;e=Za-16|0;Za=e;j[e+12>>2]=0;Bc(a+12|0,d);if(b){f=Rh(b)}j[a>>2]=f;c=c+f|0;j[a+8>>2]=c;j[a+4>>2]=c;g=Ob(a),h=b+f|0,j[g>>2]=h;Za=e+16|0;return a|0}function tIa(a){var b=0,c=0;b=Za-16|0;Za=b;hb(a);j[b+12>>2]=89478485;j[114630]=0;j[b+8>>2]=2147483647;a=E(33,b+12|0,b+8|0)|0;c=j[114630];j[114630]=0;if((c|0)!=1){Za=b+16|0;return j[a>>2]}J(0)|0;C()|0;ib();z()}function p8(a,b){var c=0,d=0;c=j[a+4>>2];a:{while(1){if((b|0)==(c|0)){break a}d=hb(a);j[114630]=0;c=c-16|0;F(2200,d|0,c|0);d=j[114630];j[114630]=0;if((d|0)!=1){continue}break}J(0)|0;C()|0;ib();z()}j[a+4>>2]=b}function oz(a){var b=0,c=0;b=Za-16|0;Za=b;hb(a);j[b+12>>2]=715827882;j[114630]=0;j[b+8>>2]=2147483647;a=E(33,b+12|0,b+8|0)|0;c=j[114630];j[114630]=0;if((c|0)!=1){Za=b+16|0;return j[a>>2]}J(0)|0;C()|0;ib();z()}function jL(a,b){var c=0,d=0;c=j[a+4>>2];a:{while(1){if((b|0)==(c|0)){break a}d=hb(a);j[114630]=0;c=c-12|0;F(1231,d|0,c|0);d=j[114630];j[114630]=0;if((d|0)!=1){continue}break}J(0)|0;C()|0;ib();z()}j[a+4>>2]=b}function j8(a,b){var c=0,d=0;c=j[a+4>>2];a:{while(1){if((b|0)==(c|0)){break a}d=hb(a);j[114630]=0;c=c-24|0;F(2201,d|0,c|0);d=j[114630];j[114630]=0;if((d|0)!=1){continue}break}J(0)|0;C()|0;ib();z()}j[a+4>>2]=b}function hK(a,b){var c=0,d=0;c=j[a+4>>2];a:{while(1){if((b|0)==(c|0)){break a}d=hb(a);j[114630]=0;c=c-24|0;F(1375,d|0,c|0);d=j[114630];j[114630]=0;if((d|0)!=1){continue}break}J(0)|0;C()|0;ib();z()}j[a+4>>2]=b}function fq(a){var b=0,c=0;b=Za-16|0;Za=b;hb(a);j[b+12>>2]=268435455;j[114630]=0;j[b+8>>2]=2147483647;a=E(33,b+12|0,b+8|0)|0;c=j[114630];j[114630]=0;if((c|0)!=1){Za=b+16|0;return j[a>>2]}J(0)|0;C()|0;ib();z()}function cKa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0;e=Za-16|0;Za=e;g=j[j[b>>2]+20>>2];f=j[c+12>>2];j[e+8>>2]=j[c+8>>2];j[e+12>>2]=f;f=j[c+4>>2];j[e>>2]=j[c>>2];j[e+4>>2]=f;bb[g|0](a,b,e,d);Za=e+16|0}function au(a){var b=0,c=0;b=Za-16|0;Za=b;hb(a);j[b+12>>2]=536870911;j[114630]=0;j[b+8>>2]=2147483647;a=E(33,b+12|0,b+8|0)|0;c=j[114630];j[114630]=0;if((c|0)!=1){Za=b+16|0;return j[a>>2]}J(0)|0;C()|0;ib();z()}function aN(a,b){var c=0,d=0;c=j[a+4>>2];a:{while(1){if((b|0)==(c|0)){break a}d=hb(a);j[114630]=0;c=c-12|0;F(1017,d|0,c|0);d=j[114630];j[114630]=0;if((d|0)!=1){continue}break}J(0)|0;C()|0;ib();z()}j[a+4>>2]=b}function aM(a,b){var c=0,d=0;c=j[a+4>>2];a:{while(1){if((b|0)==(c|0)){break a}d=hb(a);j[114630]=0;c=c-32|0;F(1189,d|0,c|0);d=j[114630];j[114630]=0;if((d|0)!=1){continue}break}J(0)|0;C()|0;ib();z()}j[a+4>>2]=b}function Zfa(a,b){var c=0,d=0;c=j[a+4>>2];a:{while(1){if((b|0)==(c|0)){break a}d=hb(a);j[114630]=0;c=c-4|0;F(1758,d|0,c|0);d=j[114630];j[114630]=0;if((d|0)!=1){continue}break}J(0)|0;C()|0;ib();z()}j[a+4>>2]=b}function XAa(a,b){var c=0,d=0;c=j[a+4>>2];a:{while(1){if((b|0)==(c|0)){break a}d=hb(a);j[114630]=0;c=c-32|0;F(891,d|0,c|0);d=j[114630];j[114630]=0;if((d|0)!=1){continue}break}J(0)|0;C()|0;ib();z()}j[a+4>>2]=b}function UA(a){var b=0,c=0;b=Za-16|0;Za=b;hb(a);j[b+12>>2]=134217727;j[114630]=0;j[b+8>>2]=2147483647;a=E(33,b+12|0,b+8|0)|0;c=j[114630];j[114630]=0;if((c|0)!=1){Za=b+16|0;return j[a>>2]}J(0)|0;C()|0;ib();z()}function Tl(a,b,c){var d=0,e=0;d=rd(b,a);e=rd(c,b);a:{b:{if(!d){d=0;if(!e){break a}Ib(b,c);d=1;if(!rd(b,a)){break a}Ib(a,b);break b}if(e){Ib(a,c);return 1}Ib(a,b);d=1;if(!rd(c,b)){break a}Ib(b,c)}d=2}return d}function Sq(a){var b=0;if(a){if(j[a+76>>2]<=-1){return vv(a)}return vv(a)}if(j[21342]){b=Sq(j[21342])}a=j[114609];if(a){while(1){if(m[a+20>>2]>m[a+28>>2]){b=vv(a)|b}a=j[a+56>>2];if(a){continue}break}}return b}function Rya(a,b){var c=0,d=0;c=j[a+4>>2];a:{while(1){if((b|0)==(c|0)){break a}d=hb(a);j[114630]=0;c=c-24|0;F(980,d|0,c|0);d=j[114630];j[114630]=0;if((d|0)!=1){continue}break}J(0)|0;C()|0;ib();z()}j[a+4>>2]=b}function PD(a){var b=0,c=0;b=Za-16|0;Za=b;hb(a);j[b+12>>2]=357913941;j[114630]=0;j[b+8>>2]=2147483647;a=E(33,b+12|0,b+8|0)|0;c=j[114630];j[114630]=0;if((c|0)!=1){Za=b+16|0;return j[a>>2]}J(0)|0;C()|0;ib();z()}function Kla(a,b){var c=0,d=0;c=j[a+4>>2];a:{while(1){if((b|0)==(c|0)){break a}d=hb(a);j[114630]=0;c=c-4|0;F(1519,d|0,c|0);d=j[114630];j[114630]=0;if((d|0)!=1){continue}break}J(0)|0;C()|0;ib();z()}j[a+4>>2]=b}function KHa(a,b){var c=0,d=0;c=j[a+4>>2];a:{while(1){if((b|0)==(c|0)){break a}d=hb(a);j[114630]=0;c=c-24|0;F(604,d|0,c|0);d=j[114630];j[114630]=0;if((d|0)!=1){continue}break}J(0)|0;C()|0;ib();z()}j[a+4>>2]=b}function KDa(a,b){var c=0,d=0;c=j[a+4>>2];a:{while(1){if((b|0)==(c|0)){break a}d=hb(a);j[114630]=0;c=c-24|0;F(767,d|0,c|0);d=j[114630];j[114630]=0;if((d|0)!=1){continue}break}J(0)|0;C()|0;ib();z()}j[a+4>>2]=b}function Iya(a,b){var c=0,d=0;c=j[a+4>>2];a:{while(1){if((b|0)==(c|0)){break a}d=hb(a);j[114630]=0;c=c-56|0;F(984,d|0,c|0);d=j[114630];j[114630]=0;if((d|0)!=1){continue}break}J(0)|0;C()|0;ib();z()}j[a+4>>2]=b}function Ioa(a){var b=0,c=0;b=Za-16|0;Za=b;i[b+12>>1]=0;j[b+8>>2]=0;ni(b+8|0);c=l[b+12>>1];h[a+814|0]=c;h[a+815|0]=c>>>8;c=j[b+8>>2];h[a+810|0]=c;h[a+811|0]=c>>>8;h[a+812|0]=c>>>16;h[a+813|0]=c>>>24;Za=b+16|0}function Hla(a,b,c,d){var e=0,f=0;e=Za-32|0;Za=e;f=Gla(b,e+28|0,c);c=j[f>>2];h[e+27|0]=0;if(!c){Fla(e+8|0,b,d);bk(b,j[e+28>>2],f,j[e+8>>2]);c=ud(e+8|0);h[e+27|0]=1;_I(e+8|0)}fi(a,yc(e+8|0,c),e+27|0);Za=e+32|0}function HR(a){var b=0,c=0;b=Za-16|0;Za=b;hb(a);j[b+12>>2]=178956970;j[114630]=0;j[b+8>>2]=2147483647;a=E(33,b+12|0,b+8|0)|0;c=j[114630];j[114630]=0;if((c|0)!=1){Za=b+16|0;return j[a>>2]}J(0)|0;C()|0;ib();z()}function HJa(a,b){var c=0,d=0;c=j[a+4>>2];a:{while(1){if((b|0)==(c|0)){break a}d=hb(a);j[114630]=0;c=c-24|0;F(527,d|0,c|0);d=j[114630];j[114630]=0;if((d|0)!=1){continue}break}J(0)|0;C()|0;ib();z()}j[a+4>>2]=b}function Fta(a,b,c,d){var e=0,f=0;e=Za-32|0;Za=e;f=Eta(b,e+28|0,c);c=j[f>>2];h[e+27|0]=0;if(!c){Dta(e+8|0,b,d);bk(b,j[e+28>>2],f,j[e+8>>2]);c=ud(e+8|0);h[e+27|0]=1;sM(e+8|0)}fi(a,yc(e+8|0,c),e+27|0);Za=e+32|0}function Fma(a,b){var c=0,d=0;c=j[a+4>>2];a:{while(1){if((b|0)==(c|0)){break a}d=hb(a);j[114630]=0;c=c-4|0;F(1434,d|0,c|0);d=j[114630];j[114630]=0;if((d|0)!=1){continue}break}J(0)|0;C()|0;ib();z()}j[a+4>>2]=b}function BJ(a,b){var c=0,d=0;c=j[a+4>>2];a:{while(1){if((b|0)==(c|0)){break a}d=hb(a);j[114630]=0;c=c-52|0;F(1433,d|0,c|0);d=j[114630];j[114630]=0;if((d|0)!=1){continue}break}J(0)|0;C()|0;ib();z()}j[a+4>>2]=b}function BBa(a,b){var c=0,d=0;c=j[a+4>>2];a:{while(1){if((b|0)==(c|0)){break a}d=hb(a);j[114630]=0;c=c-20|0;F(880,d|0,c|0);d=j[114630];j[114630]=0;if((d|0)!=1){continue}break}J(0)|0;C()|0;ib();z()}j[a+4>>2]=b}function yS(a,b){var c=0,d=0;c=j[a+4>>2];a:{while(1){if((b|0)==(c|0)){break a}d=hb(a);j[114630]=0;c=c-16|0;F(426,d|0,c|0);d=j[114630];j[114630]=0;if((d|0)!=1){continue}break}J(0)|0;C()|0;ib();z()}j[a+4>>2]=b}function y2(a,b){var c=0,d=0;c=j[a+4>>2];a:{while(1){if((b|0)==(c|0)){break a}d=hb(a);j[114630]=0;c=c-12|0;F(206,d|0,c|0);d=j[114630];j[114630]=0;if((d|0)!=1){continue}break}J(0)|0;C()|0;ib();z()}j[a+4>>2]=b}function wJa(a,b){var c=0,d=0;c=j[a+4>>2];a:{while(1){if((b|0)==(c|0)){break a}d=hb(a);j[114630]=0;c=c-2|0;F(531,d|0,c|0);d=j[114630];j[114630]=0;if((d|0)!=1){continue}break}J(0)|0;C()|0;ib();z()}j[a+4>>2]=b}function vI(a){var b=0,c=0;b=Za-16|0;Za=b;hb(a);j[b+12>>2]=82595524;j[114630]=0;j[b+8>>2]=2147483647;a=E(33,b+12|0,b+8|0)|0;c=j[114630];j[114630]=0;if((c|0)!=1){Za=b+16|0;return j[a>>2]}J(0)|0;C()|0;ib();z()}function uU(a,b){var c=0,d=0;c=j[a+4>>2];a:{while(1){if((b|0)==(c|0)){break a}d=hb(a);j[114630]=0;c=c-12|0;F(348,d|0,c|0);d=j[114630];j[114630]=0;if((d|0)!=1){continue}break}J(0)|0;C()|0;ib();z()}j[a+4>>2]=b}function mla(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;g=b,h=lh(a),j[g>>2]=h;lh(a);if(f>>>0>=60){Jb(a,4)}g=e,h=lh(a),j[g>>2]=h;Jb(a,4);b=lh(a);j[d>>2]=b;if((b|0)>=1){g=c,h=lh(a),j[g>>2]=h}}function lR(a,b){var c=0,d=0;c=j[a+4>>2];a:{while(1){if((b|0)==(c|0)){break a}d=hb(a);j[114630]=0;c=c-48|0;F(573,d|0,c|0);d=j[114630];j[114630]=0;if((d|0)!=1){continue}break}J(0)|0;C()|0;ib();z()}j[a+4>>2]=b}function ioa(a,b){var c=0;c=j[b+4>>2];j[a>>2]=j[b>>2];j[a+4>>2]=c;c=j[b+28>>2];j[a+24>>2]=j[b+24>>2];j[a+28>>2]=c;c=j[b+20>>2];j[a+16>>2]=j[b+16>>2];j[a+20>>2]=c;c=j[b+12>>2];j[a+8>>2]=j[b+8>>2];j[a+12>>2]=c}function hha(a){var b=0,c=0;b=Za-16|0;Za=b;hb(a);j[b+12>>2]=2097151;j[114630]=0;j[b+8>>2]=2147483647;a=E(33,b+12|0,b+8|0)|0;c=j[114630];j[114630]=0;if((c|0)!=1){Za=b+16|0;return j[a>>2]}J(0)|0;C()|0;ib();z()}function eV(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;e=Za-16|0;Za=e;b=vk(e+8|0,b);j[114630]=0;L(284,a|0,b|0,c|0,d|0);a=j[114630];j[114630]=0;if((a|0)!=1){jb(b);Za=e+16|0;return}a=D()|0;C()|0;jb(b);G(a|0);z()}function Xea(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0;f=Za-16|0;Za=f;b=ic(IMa(HMa(d,d>>31,b,b>>31),ab,1e3,0),ab);j[a+16>>2]=0;j[a+12>>2]=b+c;_G(a,e);b=j[a+12>>2];j[f+12>>2]=0;lI(a,b,f+12|0);Za=f+16|0}function WR(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0;d=Za-16|0;Za=d;j[d+12>>2]=c;e=d,f=TJa(Lb(b),Mb(b),d+12|0),j[e+8>>2]=f;e=d,f=Mb(b),j[e>>2]=f;a:{if(rb(d+8|0,d)){He(a,hb(j[d+8>>2]));break a}zh(a)}Za=d+16|0}function KP(a,b){var c=0,d=0;c=j[a+4>>2];a:{while(1){if((b|0)==(c|0)){break a}d=hb(a);j[114630]=0;c=c-33|0;F(765,d|0,c|0);d=j[114630];j[114630]=0;if((d|0)!=1){continue}break}J(0)|0;C()|0;ib();z()}j[a+4>>2]=b}function JH(a,b){var c=0,d=0;c=j[a+4>>2];a:{while(1){if((b|0)==(c|0)){break a}d=hb(a);j[114630]=0;c=c-4|0;F(1648,d|0,c|0);d=j[114630];j[114630]=0;if((d|0)!=1){continue}break}J(0)|0;C()|0;ib();z()}j[a+4>>2]=b}function HBa(a,b){var c=0,d=0;c=j[a+4>>2];a:{while(1){if((b|0)==(c|0)){break a}d=hb(a);j[114630]=0;c=c-4|0;F(879,d|0,c|0);d=j[114630];j[114630]=0;if((d|0)!=1){continue}break}J(0)|0;C()|0;ib();z()}j[a+4>>2]=b}function DV(a,b){var c=0,d=0;c=j[a+4>>2];a:{while(1){if((b|0)==(c|0)){break a}d=hb(a);j[114630]=0;c=c-32|0;F(276,d|0,c|0);d=j[114630];j[114630]=0;if((d|0)!=1){continue}break}J(0)|0;C()|0;ib();z()}j[a+4>>2]=b}function BIa(a,b){var c=0,d=0;c=j[a+4>>2];a:{while(1){if((b|0)==(c|0)){break a}d=hb(a);j[114630]=0;c=c-6|0;F(570,d|0,c|0);d=j[114630];j[114630]=0;if((d|0)!=1){continue}break}J(0)|0;C()|0;ib();z()}j[a+4>>2]=b}function AB(a,b){var c=0,d=0;c=j[a+4>>2];a:{while(1){if((b|0)==(c|0)){break a}d=hb(a);j[114630]=0;c=c-16|0;F(217,d|0,c|0);d=j[114630];j[114630]=0;if((d|0)!=1){continue}break}J(0)|0;C()|0;ib();z()}j[a+4>>2]=b}function wB(a,b){var c=0,d=0;c=j[a+4>>2];a:{while(1){if((b|0)==(c|0)){break a}d=hb(a);j[114630]=0;c=c-1|0;F(215,d|0,c|0);d=j[114630];j[114630]=0;if((d|0)!=1){continue}break}J(0)|0;C()|0;ib();z()}j[a+4>>2]=b}function tU(a,b){var c=0,d=0;c=j[a+4>>2];a:{while(1){if((b|0)==(c|0)){break a}d=hb(a);j[114630]=0;c=c-4|0;F(349,d|0,c|0);d=j[114630];j[114630]=0;if((d|0)!=1){continue}break}J(0)|0;C()|0;ib();z()}j[a+4>>2]=b}function sA(a,b){var c=0,d=0;c=j[a+4>>2];a:{while(1){if((b|0)==(c|0)){break a}d=hb(a);j[114630]=0;c=c-1|0;F(361,d|0,c|0);d=j[114630];j[114630]=0;if((d|0)!=1){continue}break}J(0)|0;C()|0;ib();z()}j[a+4>>2]=b}function rz(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0;d=Za-16|0;Za=d;j[d+12>>2]=c;e=d,f=uR(Lb(b),Mb(b),d+12|0),j[e+8>>2]=f;e=d,f=Mb(b),j[e>>2]=f;a:{if(rb(d+8|0,d)){He(a,hb(j[d+8>>2]));break a}zh(a)}Za=d+16|0}function ry(a,b,c){var d=0;d=Za-16|0;Za=d;j[d>>2]=b;j[d+8>>2]=a;a:{if(!rb(d+8|0,d)){break a}while(1){if(l[j[d+8>>2]>>1]==l[c>>1]){break a}je(d+8|0);if(rb(d+8|0,d)){continue}break}}Za=d+16|0;return j[d+8>>2]}function jP(a,b){var c=0,d=0;c=j[a+4>>2];a:{while(1){if((b|0)==(c|0)){break a}d=hb(a);j[114630]=0;c=c-4|0;F(817,d|0,c|0);d=j[114630];j[114630]=0;if((d|0)!=1){continue}break}J(0)|0;C()|0;ib();z()}j[a+4>>2]=b}function jO(a,b){var c=0,d=0;c=j[a+4>>2];a:{while(1){if((b|0)==(c|0)){break a}d=hb(a);j[114630]=0;c=c-8|0;F(919,d|0,c|0);d=j[114630];j[114630]=0;if((d|0)!=1){continue}break}J(0)|0;C()|0;ib();z()}j[a+4>>2]=b}function jA(a,b,c){var d=0,e=0,f=0,g=0;d=Za-16|0;Za=d;e=j[a+4>>2];f=e+b|0;j[a+4>>2]=f;if(!((f-1^e-1)>>>0<32?e:0)){g=j[a>>2];j[(f>>>0<33?g:(f-1>>>3&536870908)+g|0)>>2]=0}vn(d+8|0,a,e);Hp(d+8|0,b,c);Za=d+16|0}function iT(a,b){var c=0,d=0;c=j[a+4>>2];a:{while(1){if((b|0)==(c|0)){break a}d=hb(a);j[114630]=0;c=c-2|0;F(382,d|0,c|0);d=j[114630];j[114630]=0;if((d|0)!=1){continue}break}J(0)|0;C()|0;ib();z()}j[a+4>>2]=b}function iQ(a,b){var c=0,d=0;c=j[a+4>>2];a:{while(1){if((b|0)==(c|0)){break a}d=hb(a);j[114630]=0;c=c-4|0;F(734,d|0,c|0);d=j[114630];j[114630]=0;if((d|0)!=1){continue}break}J(0)|0;C()|0;ib();z()}j[a+4>>2]=b}function hV(a,b){var c=0,d=0;c=j[a+4>>2];a:{while(1){if((b|0)==(c|0)){break a}d=hb(a);j[114630]=0;c=c-8|0;F(283,d|0,c|0);d=j[114630];j[114630]=0;if((d|0)!=1){continue}break}J(0)|0;C()|0;ib();z()}j[a+4>>2]=b}function fQ(a,b){var c=0,d=0;c=j[a+4>>2];a:{while(1){if((b|0)==(c|0)){break a}d=hb(a);j[114630]=0;c=c-6|0;F(736,d|0,c|0);d=j[114630];j[114630]=0;if((d|0)!=1){continue}break}J(0)|0;C()|0;ib();z()}j[a+4>>2]=b}function fA(a,b){var c=0,d=0;c=j[a+4>>2];a:{while(1){if((b|0)==(c|0)){break a}d=hb(a);j[114630]=0;c=c-4|0;F(372,d|0,c|0);d=j[114630];j[114630]=0;if((d|0)!=1){continue}break}J(0)|0;C()|0;ib();z()}j[a+4>>2]=b}function exa(){var a=0,b=0,c=0;a=Za-16|0;Za=a;j[a+12>>2]=477218588;j[114630]=0;j[a+8>>2]=2147483647;b=E(33,a+12|0,a+8|0)|0;c=j[114630];j[114630]=0;if((c|0)!=1){Za=a+16|0;return j[b>>2]}J(0)|0;C()|0;ib();z()}function eP(a,b){var c=0,d=0;c=j[a+4>>2];a:{while(1){if((b|0)==(c|0)){break a}d=hb(a);j[114630]=0;c=c-2|0;F(824,d|0,c|0);d=j[114630];j[114630]=0;if((d|0)!=1){continue}break}J(0)|0;C()|0;ib();z()}j[a+4>>2]=b}function bQ(a,b){var c=0,d=0;c=j[a+4>>2];a:{while(1){if((b|0)==(c|0)){break a}d=hb(a);j[114630]=0;c=c-4|0;F(737,d|0,c|0);d=j[114630];j[114630]=0;if((d|0)!=1){continue}break}J(0)|0;C()|0;ib();z()}j[a+4>>2]=b}function _T(a,b){var c=0,d=0;c=j[a+4>>2];a:{while(1){if((b|0)==(c|0)){break a}d=hb(a);j[114630]=0;c=c-1|0;F(360,d|0,c|0);d=j[114630];j[114630]=0;if((d|0)!=1){continue}break}J(0)|0;C()|0;ib();z()}j[a+4>>2]=b}function ZT(a,b){var c=0,d=0;c=j[a+4>>2];a:{while(1){if((b|0)==(c|0)){break a}d=hb(a);j[114630]=0;c=c-2|0;F(362,d|0,c|0);d=j[114630];j[114630]=0;if((d|0)!=1){continue}break}J(0)|0;C()|0;ib();z()}j[a+4>>2]=b}function VL(a,b){var c=0,d=0;c=j[a+4>>2];a:{while(1){if((b|0)==(c|0)){break a}d=hb(a);j[114630]=0;c=c-4|0;F(107,d|0,c|0);d=j[114630];j[114630]=0;if((d|0)!=1){continue}break}J(0)|0;C()|0;ib();z()}j[a+4>>2]=b}function QN(a,b){var c=0,d=0;c=j[a+4>>2];a:{while(1){if((b|0)==(c|0)){break a}d=hb(a);j[114630]=0;c=c-4|0;F(945,d|0,c|0);d=j[114630];j[114630]=0;if((d|0)!=1){continue}break}J(0)|0;C()|0;ib();z()}j[a+4>>2]=b}function MIa(a,b){a=a|0;b=b|0;var c=0;c=Za-16|0;Za=c;j[c+12>>2]=1;j[c+8>>2]=a>>>4;b=Gb(128/(p(j[zf(c+12|0,c+8|0)>>2],b)|0)|0,1,15);h[c+7|0]=1;h[c+6|0]=a&15;a=k[Vg(c+7|0,c+6|0)|0];Za=c+16|0;return a|b<<4&240}function IJ(a){var b=0,c=0;b=Za-544|0;Za=b;if(!(!(k[a+480210|0]&128)|!j[a+24668>>2])){vL(b,we(a));c=a+1304360|0;a=a+1074984|0;while(1){Vb(a+112|0,b,538);a=a+896|0;if((c|0)!=(a|0)){continue}break}}Za=b+544|0}function DS(a,b){var c=0,d=0;c=j[a+4>>2];a:{while(1){if((b|0)==(c|0)){break a}d=hb(a);j[114630]=0;c=c-2|0;F(422,d|0,c|0);d=j[114630];j[114630]=0;if((d|0)!=1){continue}break}J(0)|0;C()|0;ib();z()}j[a+4>>2]=b}function wJ(a,b){var c=0;if(b){ro(a);c=a+24596|0;j[c>>2]=0;j[c+4>>2]=0;j[a+24588>>2]=0;j[a+24592>>2]=0;IJ(a)}vJ(a+24648|0);sea(a+393352|0,b,j[a+24620>>2]);b=a+1304392|0;if($c(b)){ML(j[b>>2],j[a+24620>>2])}}function j7(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=q(0);e=Za-16|0;Za=e;f=j[a+4>>2];zF(a,b,c,d);g=n[a+24>>2];j[e+8>>2]=j[a+20>>2];b=j[a+16>>2];j[e>>2]=j[a+12>>2];j[e+4>>2]=b;zba(e,f,c,d,g);Za=e+16|0}function bC(a){var b=0,c=0;b=Za-16|0;Za=b;Ek(a);j[b+12>>2]=1073741823;j[114630]=0;j[b+8>>2]=2147483647;a=tb(b+12|0,b+8|0);c=j[114630];j[114630]=0;if((c|0)!=1){Za=b+16|0;return j[a>>2]}J(0)|0;C()|0;ib();z()}function Xaa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=Za-16|0;Za=d;a=j[a+24>>2];Fr(d,0,c);j[114630]=0;I(646,a|0,b|0,d|0);a=j[114630];j[114630]=0;if((a|0)!=1){gb(d);Za=d+16|0;return}a=D()|0;C()|0;gb(d);G(a|0);z()}function TC(a,b,c,d,e,f){var g=0,i=0,k=0;g=Za-16|0;Za=g;h[g+15|0]=0;h[g+14|0]=f;h[g+13|0]=e;h[g+12|0]=37;if(f){Ug(g+13|0,g+14|0)}i=c,k=(Ia(b|0,gT(b,j[c>>2])|0,g+12|0,d|0,j[a>>2])|0)+b|0,j[i>>2]=k;Za=g+16|0}function QS(a,b){var c=0,d=0;c=j[a+4>>2];a:{while(1){if((b|0)==(c|0)){break a}d=hb(a);j[114630]=0;c=c-1|0;F(32,d|0,c|0);d=j[114630];j[114630]=0;if((d|0)!=1){continue}break}J(0)|0;C()|0;ib();z()}j[a+4>>2]=b}function Hga(a){var b=0,c=0,d=0,e=0;b=CH(a);c=CH(a+12|0);d=BH(a+24|0);e=BH(a+36|0);j[114630]=0;K(1634,a|0,2,0)|0;a=j[114630];j[114630]=0;if((a|0)!=1){return}a=D()|0;C()|0;sr(e);sr(d);rr(c);rr(b);G(a|0);z()}function Bwa(a,b,c){var d=0;d=Za-16|0;Za=d;j[d+12>>2]=c;j[d>>2]=4896;c=j[tb(d+12|0,d)>>2];if(!yb(a,c)){c=ef(a)}My(d,b);ug(a,j[d>>2],c);My(d,b);Ab(j[d>>2]+c|0,0,4896-c|0);Jb(a,j[d+12>>2]);Za=d+16|0;return c}function dJ(){var a=0;a:{b:{if(h[457384]&1){break b}if(!fd(457384)){break b}j[114630]=0;E(1518,88680,1)|0;a=j[114630];j[114630]=0;if((a|0)==1){break a}ed(457384)}return}a=D()|0;C()|0;Zd(457384);G(a|0);z()}function Wv(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0;e=Za-32|0;Za=e;j[e+24>>2]=b;f=e,g=nd(a),j[f+16>>2]=g;b=Jn(e+24|0,e+16|0);gY(a,b,c,d);f=e,g=nd(a),j[f+8>>2]=g;a=af(e+8|0,b);Za=e+32|0;return a|0}function Pta(){var a=0;a:{b:{if(h[85436]&1){break b}if(!fd(85436)){break b}j[114630]=0;H(100,85408)|0;a=j[114630];j[114630]=0;if((a|0)==1){break a}ed(85436)}return 85408}a=D()|0;C()|0;Zd(85436);G(a|0);z()}function Or(a,b){a=Vb(a,b,88);j[a+88>>2]=j[b+88>>2];Vb(a+92|0,b+92|0,576);j[a+668>>2]=j[b+668>>2];Vb(a+672|0,b+672|0,52);px(a+724|0,b+724|0);px(a+736|0,b+736|0);px(a+748|0,b+748|0);Vb(a+760|0,b+760|0,135)}function Hx(a){var b=0,c=0,d=0;b=l[a+20>>1];i[a+28>>1]=l[a+22>>1]<<1|(k[j[a+16>>2]+3842|0]?b>>>9|0:b>>>8&1);b=0;while(1){c=(b<<2)+a|0;d=j[c>>2];if(d){Pm(d);OL(j[c>>2])}b=b+1|0;if((b|0)!=4){continue}break}}function y4(){var a=0;a:{b:{if(h[461640]&1){break b}if(!fd(461640)){break b}j[114630]=0;H(2305,461636)|0;a=j[114630];j[114630]=0;if((a|0)==1){break a}ed(461640)}return}a=D()|0;C()|0;Zd(461640);G(a|0);z()}function v6(a,b,c){var d=0;d=u6(a,b,c);a:{if((d|0)==(b|0)){break a}a=d+2|0;if((b|0)==(a|0)){break a}while(1){if(l[a>>1]!=l[c>>1]){i[d>>1]=l[a>>1];d=d+2|0}a=a+2|0;if((b|0)!=(a|0)){continue}break}}return d}function of(a,b,c,d,e){var f=0;f=Za-256|0;Za=f;if(!(e&73728|(c|0)<=(d|0))){c=c-d|0;d=c>>>0<256;Ab(f,b&255,d?c:256);if(!d){while(1){ve(a,f,256);c=c-256|0;if(c>>>0>255){continue}break}}ve(a,f,c)}Za=f+256|0}function ic(a,b){a=a|0;b=b|0;var c=0;c=Za-32|0;Za=c;j[c+24>>2]=a;j[c+28>>2]=b;j[c+16>>2]=-2147483648;j[c+20>>2]=-1;j[c+8>>2]=2147483647;j[c+12>>2]=0;a=EQ(c+16|0,cz(c+24|0,c+8|0));Za=c+32|0;return j[a>>2]}function dh(a,b,c){var d=0,e=0,f=0,g=0;j[a+112>>2]=b;j[a+116>>2]=c;d=j[a+8>>2];g=j[a+4>>2];e=d-g|0;f=e>>31;j[a+120>>2]=e;j[a+124>>2]=f;j[a+104>>2]=b|c?((c|0)<(f|0)?1:(c|0)<=(f|0)?b>>>0<e>>>0:0)?b+g|0:d:d}function dO(a,b,c){var d=0,e=0,f=0,g=0;e=Za-16|0;Za=e;d=sc(a);a:{if(d>>>0>=c>>>0){d=zb(a);Il(d,b,c);h[e+15|0]=0;Sd(c+d|0,e+15|0);Bg(a,c);break a}f=d;g=c-d|0;d=nb(a);qu(a,f,g,d,0,d,c,b)}Za=e+16|0;return a}function YA(a,b,c,d){var e=0,f=0,g=0,h=0;e=Za-16|0;Za=e;j[e+12>>2]=0;Bc(a+12|0,d);if(b){f=TA(j[a+16>>2],b)}j[a>>2]=f;c=(c<<5)+f|0;j[a+8>>2]=c;j[a+4>>2]=c;g=Ob(a),h=(b<<5)+f|0,j[g>>2]=h;Za=e+16|0;return a}function Q$(a,b,c){var d=0;d=Za-32|0;Za=d;j[d+16>>2]=b;j[d+24>>2]=a;j[d+8>>2]=c;while(1){a=rb(d+24|0,d+16|0);if(!(!a|k[j[d+24>>2]]!=k[j[d+8>>2]])){Xf(d+24|0);Xf(d+8|0);continue}break}Za=d+32|0;return a^1}function Gwa(a,b,c){var d=0;d=Za-16|0;Za=d;j[d+12>>2]=c;j[d>>2]=263;c=j[tb(d+12|0,d)>>2];if(!yb(a,c)){c=ef(a)}PM(d,b);ug(a,j[d>>2],c);PM(d,b);Ab(j[d>>2]+c|0,0,263-c|0);Jb(a,j[d+12>>2]);Za=d+16|0;return c}function DY(a,b,c,d){var e=0,f=0,g=0,h=0;e=Za-16|0;Za=e;j[e+12>>2]=0;Bc(a+12|0,d);if(b){f=aC(j[a+16>>2],b)}j[a>>2]=f;c=(c<<2)+f|0;j[a+8>>2]=c;j[a+4>>2]=c;g=Ob(a),h=(b<<2)+f|0,j[g>>2]=h;Za=e+16|0;return a}function pN(a){var b=0;a:{if((k[a+44|0]|k[a+45|0]<<8|(k[a+46|0]<<16|k[a+47|0]<<24))!=1297236819|k[a+29|0]!=16){break a}a=a+42|0;if((k[a|0]|k[a+1|0]<<8)!=2?(k[a|0]|k[a+1|0]<<8)!=1:0){break a}b=1}return b}function oB(a){var b=0;b=a;if((k[b|0]|k[b+1|0]<<8|(k[b+2|0]<<16|k[b+3|0]<<24))==1129474426&(k[b+4|0]|k[b+5|0]<<8|(k[b+6|0]<<16|k[b+7|0]<<24))==1634291279){a=a+8|0;return(k[a|0]|k[a+1|0]<<8)==14}return 0}function gya(a,b){var c=0;c=Za-16|0;Za=c;j[c>>2]=b;j[c+8>>2]=a;if(rb(c+8|0,c)){while(1){a=j[c+8>>2];if(k[a+3|0]==31){h[a+3|0]=20;h[a+5|0]=k[a+5|0]|128}lk(c+8|0);if(rb(c+8|0,c)){continue}break}}Za=c+16|0}function LQ(a){var b=0,c=0;b=a+36|0;c=HMa(k[b|0]|k[b+1|0]<<8,0,384,0);a=a+34|0;b=k[a|0]|k[a+1|0]<<8;a=b>>>30|0;b=b<<2;c=c+b|0;a=a+ab|0;a=b>>>0>c>>>0?a+1|0:a;b=c+256|0;if(b>>>0<256){a=a+1|0}ab=a;return b}function BI(a){var b=0,c=0,d=0;if(df(a)){while(1){b=a;d=c&65535;if(df(b)>>>0>d>>>0){b=te(b,d);j[b+20>>2]=0;j[b+12>>2]=0;j[b+16>>2]=0;GI(b);Ce(b+36|0)}c=c+1|0;if(df(a)>>>0>(c&65535)>>>0){continue}break}}}function Ad(a,b){var c=0,d=0,e=0;b=b+7&-8;j[a+8>>2]=b+j[a+8>>2];d=j[a+80>>2];a:{if(d){c=b;b=j[a+88>>2];e=c+b|0;c=0;if((e|0)>j[a+92>>2]){break a}j[a+88>>2]=e;return b+d|0}if(!b){return 0}c=Yc(b)}return c}function nFa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0;e=Za-16|0;Za=e;j[e+12>>2]=d;Sy(a,c,d);d=0;f=j[a+16>>2];if(f>>>0>c>>>0){j[e+8>>2]=f-c;d=j[tb(e+8|0,e+12|0)>>2];GFa(a,b,c,d)}Za=e+16|0;return d|0}function lS(a){var b=0,c=0;b=Za-16|0;Za=b;hb(a);j[b+12>>2]=-1;j[114630]=0;j[b+8>>2]=2147483647;a=E(33,b+12|0,b+8|0)|0;c=j[114630];j[114630]=0;if((c|0)!=1){Za=b+16|0;return j[a>>2]}J(0)|0;C()|0;ib();z()}function b8(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;e=Za-16|0;Za=e;IF(b,c,d,n[a+28>>2]);HF(a,b,c,d);b=j[a+24>>2];j[e+8>>2]=j[a+20>>2];j[e+12>>2]=b;b=j[a+16>>2];j[e>>2]=j[a+12>>2];j[e+4>>2]=b;Za=e+16|0}function _Ca(a,b,c){var d=0;d=Za-16|0;Za=d;j[d+12>>2]=c;j[d>>2]=22;c=j[tb(d+12|0,d)>>2];if(!yb(a,c)){c=ef(a)}Zs(d,b);ug(a,j[d>>2],c);Zs(d,b);Ab(j[d>>2]+c|0,0,22-c|0);Jb(a,j[d+12>>2]);Za=d+16|0;return c}function YCa(a,b,c){var d=0;d=Za-16|0;Za=d;j[d+12>>2]=c;j[d>>2]=40;c=j[tb(d+12|0,d)>>2];if(!yb(a,c)){c=ef(a)}Cy(d,b);ug(a,j[d>>2],c);Cy(d,b);Ab(j[d>>2]+c|0,0,40-c|0);Jb(a,j[d+12>>2]);Za=d+16|0;return c}function Qp(a,b,c){a:{if(m[a+12>>2]<=b>>>0){a=R(8)|0;j[114630]=0;H(352,a|0)|0;b=j[114630];j[114630]=0;if((b|0)!=1){break a}b=D()|0;C()|0;S(a|0);G(b|0);z()}h[j[a+8>>2]+b|0]=c;return}X(a|0,77432,265);z()}function QBa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;if(FBa(a)>>>0<b>>>0){Oc();z()}hb(a);c=b;if(c>>>0>214748364){oc(15551);z()}c=ac(p(c,20),4);j[a>>2]=c;j[a+4>>2]=c;d=hb(a),e=c+p(b,20)|0,j[d>>2]=e;_o(a);_o(a)}function LZ(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;a=Za-16|0;Za=a;j[a+12>>2]=c;j[a+8>>2]=f;b=KZ(c,d,a+12|0,f,g,a+8|0);j[e>>2]=j[a+12>>2];j[h>>2]=j[a+8>>2];Za=a+16|0;return b|0}function Jga(a,b,c){var d=0;d=Za-16|0;Za=d;j[d+12>>2]=c;j[d>>2]=33;c=j[tb(d+12|0,d)>>2];if(!yb(a,c)){c=ef(a)}Iy(d,b);ug(a,j[d>>2],c);Iy(d,b);Ab(j[d>>2]+c|0,0,33-c|0);Jb(a,j[d+12>>2]);Za=d+16|0;return c}function JZ(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;a=Za-16|0;Za=a;j[a+12>>2]=c;j[a+8>>2]=f;b=IZ(c,d,a+12|0,f,g,a+8|0);j[e>>2]=j[a+12>>2];j[h>>2]=j[a+8>>2];Za=a+16|0;return b|0}function Ija(a){var b=0,c=0,d=0;b=Za+ -64|0;Za=b;BI(a);d=df(a);c=yw(b+8|0,a);j[114630]=0;I(1575,a|0,d|0,c|0);a=j[114630];j[114630]=0;if((a|0)!=1){$k(c);Za=b- -64|0;return}a=D()|0;C()|0;$k(c);G(a|0);z()}function FZ(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;a=Za-16|0;Za=a;j[a+12>>2]=c;j[a+8>>2]=f;b=EZ(c,d,a+12|0,f,g,a+8|0);j[e>>2]=j[a+12>>2];j[h>>2]=j[a+8>>2];Za=a+16|0;return b|0}function DZ(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;a=Za-16|0;Za=a;j[a+12>>2]=c;j[a+8>>2]=f;b=CZ(c,d,a+12|0,f,g,a+8|0);j[e>>2]=j[a+12>>2];j[h>>2]=j[a+8>>2];Za=a+16|0;return b|0}function v4(){var a=0,b=0;b=or(460608);j[115150]=58772;j[b>>2]=58792;j[115151]=0;j[114630]=0;F(2307,j[14690]+460600|0,461284);a=j[114630];j[114630]=0;if((a|0)!=1){return}a=D()|0;C()|0;og(b);G(a|0);z()}function t4(){var a=0,b=0;b=jE(460696);j[115172]=58820;j[b>>2]=58840;j[115173]=0;j[114630]=0;F(2308,j[14702]+460688|0,461348);a=j[114630];j[114630]=0;if((a|0)!=1){return}a=D()|0;C()|0;og(b);G(a|0);z()}function sEa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=b&63;if($j(c)>>>0>d>>>0){fEa(OP(c,d),a)}a:{b:{if(b<<24>>24>=0){b=a+12|0;break b}b=a+12|0;if(Xc(a)){break b}a=k[a+12|0]|1;break a}a=k[a+12|0]&-2}h[b|0]=a}function lta(a,b){var c=0;c=Za+ -64|0;Za=c;b=Soa(c+16|0,b);b=Qoa(c,b,b+48|0);j[114630]=0;K(106,a|0,b|0,0)|0;a=j[114630];j[114630]=0;if((a|0)!=1){Ud(b);Za=c- -64|0;return}a=D()|0;C()|0;Ud(b);G(a|0);z()}function gla(a,b,c,d){var e=0;e=Za-16|0;Za=e;j[e>>2]=c;j[e+8>>2]=b;if(rb(e+8|0,e)){while(1){fla(d,j[e+8>>2]);lk(e+8|0);if(rb(e+8|0,e)){continue}break}}b=j[d+4>>2];j[a>>2]=j[d>>2];j[a+4>>2]=b;Za=e+16|0}function VZ(a,b,c,d,e,f){var g=0;g=Za-16|0;Za=g;j[g+12>>2]=f;f=bh(g+8|0,g+12|0);j[114630]=0;a=nD(a,b,c,d,e);b=j[114630];j[114630]=0;if((b|0)!=1){oe(f);Za=g+16|0;return a}a=D()|0;C()|0;oe(f);G(a|0);z()}function TZ(a,b,c,d,e,f){var g=0;g=Za-16|0;Za=g;j[g+12>>2]=f;f=bh(g+8|0,g+12|0);j[114630]=0;a=mD(a,b,c,d,e);b=j[114630];j[114630]=0;if((b|0)!=1){oe(f);Za=g+16|0;return a}a=D()|0;C()|0;oe(f);G(a|0);z()}function sBa(a,b){a=a|0;b=b|0;var c=0,d=0;c=Za-608|0;Za=c;b=c+8|0;d=VAa(a,b);if(!d){xO(b)}b=-1;a:{if(!d){break a}b=0;if(!GO(c+8|0)){break a}b=-1;if(!jf(a,1024)){break a}b=pBa(a)}Za=c+608|0;return b|0}function gM(a){a=a|0;var b=0,c=0;b=Za-32|0;Za=b;h[a+16|0]=0;c=Kx(b,j[a+12>>2]);j[114630]=0;I(1170,a|0,1,c|0);a=j[114630];j[114630]=0;if((a|0)!=1){hl(c);Za=b+32|0;return}a=D()|0;C()|0;hl(c);G(a|0);z()}function _ra(){var a=0;a:{b:{if(h[87636]&1){break b}if(!fd(87636)){break b}j[114630]=0;H(1204,87632)|0;a=j[114630];j[114630]=0;if((a|0)==1){break a}ed(87636)}return}a=D()|0;C()|0;Zd(87636);G(a|0);z()}function ZN(a){var b=0,c=0,d=0,e=0;ab=0;d=k[a+4|0];e=k[a+92|0];c=k[a+93|0];b=a+94|0;b=c+(k[b|0]|k[b+1|0]<<8)|0;a=0;a=b>>>0<c>>>0?1:a;c=b;b=e+b|0;a=b>>>0<c>>>0?a+1|0:a;c=b<<2;b=d+c|0;b=b-96|0;return b}function Sza(a,b){a=a|0;b=b|0;var c=0,d=0;c=Za-16|0;Za=c;d=cA(a);if(d>>>0>=b>>>0){a=xs(a);if(a>>>0<d>>>1>>>0){j[c+12>>2]=a<<1;j[c+8>>2]=b+31&-32;d=j[Lc(c+12|0,c+8|0)>>2]}Za=c+16|0;return d|0}Oc();z()}function tsa(){var a=0;a:{b:{if(h[85568]&1){break b}if(!fd(85568)){break b}j[114630]=0;H(108,85564)|0;a=j[114630];j[114630]=0;if((a|0)==1){break a}ed(85568)}return}a=D()|0;C()|0;Zd(85568);G(a|0);z()}function RGa(a,b){var c=0,d=0;c=Za-16|0;Za=c;j[c+12>>2]=674;j[c>>2]=674;d=j[tb(c+12|0,c)>>2];if(!yb(a,d)){d=ef(a)}eQ(c,b);ug(a,j[c>>2],d);eQ(c,b);Ab(j[c>>2]+d|0,0,674-d|0);Jb(a,j[c+12>>2]);Za=c+16|0}function PFa(a,b,c){var d=0;d=Za-16|0;Za=d;j[d>>2]=b;j[d+8>>2]=a;a:{if(!rb(d+8|0,d)){break a}while(1){if(ip(j[d+8>>2],c)){break a}cn(d+8|0);if(rb(d+8|0,d)){continue}break}}Za=d+16|0;return j[d+8>>2]}function Nma(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;c=Za-16|0;Za=c;cf(a,c+14|0);Yy(b,l[c+14>>1],16777216);if(l[c+14>>1]){while(1){gi(a,xb(b,d));d=d+1|0;if(d>>>0<l[c+14>>1]){continue}break}}Zw(b);Za=c+16|0}function JJ(a){var b=0,c=0;c=a+946300|0;a=a+906300|0;while(1){b=j[a>>2];a:{if(!b){break a}if(!(bb[j[j[b>>2]+112>>2]](b)|0)){break a}bb[j[j[b>>2]+92>>2]](b)}a=a+160|0;if((c|0)!=(a|0)){continue}break}}function pX(a,b,c){var d=0;a:{b:{if((b|0)==8){b=Yc(c);break b}d=28;if(b&3|(LMa(b>>>2|0)|0)!=1){break a}d=48;if(-64-b>>>0<c>>>0){break a}b=qX(b>>>0>16?b:16,c)}if(!b){return 48}j[a>>2]=b;d=0}return d}function kU(a,b){a:{if(m[a+12>>2]<=b>>>0){a=R(8)|0;j[114630]=0;H(352,a|0)|0;b=j[114630];j[114630]=0;if((b|0)!=1){break a}b=D()|0;C()|0;S(a|0);G(b|0);z()}return k[j[a+8>>2]+b|0]}X(a|0,77432,265);z()}function PZ(a){a=a|0;var b=0,c=0,d=0;b=Za-16|0;Za=b;j[b+12>>2]=a;a=bh(b+8|0,b+12|0);j[114630]=0;c=kD();d=j[114630];j[114630]=0;if((d|0)!=1){oe(a);Za=b+16|0;return c|0}b=D()|0;C()|0;oe(a);G(b|0);z()}function yL(a,b,c,d,e,f){j[a+40>>2]=0;j[a+44>>2]=0;o[a+32>>3]=f;o[a+24>>3]=e;o[a+16>>3]=d;o[a+8>>3]=c;o[a>>3]=b;j[a+48>>2]=0;j[a+52>>2]=0;j[a+56>>2]=0;j[a+60>>2]=0;a=a- -64|0;j[a>>2]=0;j[a+4>>2]=0}function xra(a){var b=0,c=0;b=Za-16|0;Za=b;j[a>>2]=0;j[a+4>>2]=0;j[114630]=0;j[b+12>>2]=0;K(1224,a+8|0,b+12|0,b+8|0)|0;c=j[114630];j[114630]=0;if((c|0)!=1){Za=b+16|0;return a}J(0)|0;C()|0;ib();z()}function gC(a,b,c,d,e){var f=0;f=Za-16|0;Za=f;j[f+12>>2]=e;e=bh(f+8|0,f+12|0);j[114630]=0;a=Un(a,b,c,d);b=j[114630];j[114630]=0;if((b|0)!=1){oe(e);Za=f+16|0;return a}a=D()|0;C()|0;oe(e);G(a|0);z()}function aBa(a,b,c,d){var e=0;e=Za-16|0;Za=e;j[e>>2]=b;j[e+8>>2]=a;if(rb(e+8|0,e)){while(1){if(l[j[e+8>>2]>>1]==l[c>>1]){i[j[e+8>>2]>>1]=l[d>>1]}je(e+8|0);if(rb(e+8|0,e)){continue}break}}Za=e+16|0}function Z$(a,b,c,d,e){var f=0;f=Za-16|0;Za=f;j[f+12>>2]=e;e=bh(f+8|0,f+12|0);j[114630]=0;a=Yu(a,b,c,d);b=j[114630];j[114630]=0;if((b|0)!=1){oe(e);Za=f+16|0;return a}a=D()|0;C()|0;oe(e);G(a|0);z()}function Jf(a,b){a=a|0;b=b|0;var c=0,d=0;c=Za+ -64|0;Za=c;d=yw(c+8|0,a);j[114630]=0;I(1577,a|0,b|0,d|0);a=j[114630];j[114630]=0;if((a|0)!=1){$k(d);Za=c- -64|0;return}a=D()|0;C()|0;$k(d);G(a|0);z()}function Cra(a){var b=0,c=0;b=Za-16|0;Za=b;j[a>>2]=0;j[a+4>>2]=0;j[114630]=0;j[b+12>>2]=0;K(1221,a+8|0,b+12|0,b+8|0)|0;c=j[114630];j[114630]=0;if((c|0)!=1){Za=b+16|0;return a}J(0)|0;C()|0;ib();z()}function qja(a,b,c,d){var e=0,f=0,g=0,h=0;e=Za-16|0;Za=e;j[e+12>>2]=0;Bc(a+12|0,d);if(b){f=sI(b)}j[a>>2]=f;c=p(c,52)+f|0;j[a+8>>2]=c;j[a+4>>2]=c;g=Ob(a),h=p(b,52)+f|0,j[g>>2]=h;Za=e+16|0;return a}function cL(a){var b=0,c=0;b=Za-16|0;Za=b;j[a>>2]=0;j[a+4>>2]=0;j[114630]=0;j[b+12>>2]=0;K(1254,a+8|0,b+12|0,b+8|0)|0;c=j[114630];j[114630]=0;if((c|0)!=1){Za=b+16|0;return a}J(0)|0;C()|0;ib();z()}function Yaa(a,b){a=a|0;b=b|0;var c=0;c=Za-16|0;Za=c;a=j[a+24>>2];Fr(c,0,b);j[114630]=0;I(646,a|0,1,c|0);a=j[114630];j[114630]=0;if((a|0)!=1){gb(c);Za=c+16|0;return}a=D()|0;C()|0;gb(c);G(a|0);z()}function Xwa(a,b){var c=0,d=0;c=Za-16|0;Za=c;j[c+12>>2]=64;j[c>>2]=66;d=j[tb(c+12|0,c)>>2];if(!yb(a,d)){d=ef(a)}bt(c,b);ug(a,j[c>>2],d);bt(c,b);Ab(j[c>>2]+d|0,0,66-d|0);Jb(a,j[c+12>>2]);Za=c+16|0}function UBa(a){var b=0,c=0;b=Za-16|0;Za=b;j[a>>2]=0;j[a+4>>2]=0;j[114630]=0;j[b+12>>2]=0;K(874,a+8|0,b+12|0,b+8|0)|0;c=j[114630];j[114630]=0;if((c|0)!=1){Za=b+16|0;return a}J(0)|0;C()|0;ib();z()}function RBa(a){var b=0,c=0;b=Za-16|0;Za=b;j[a>>2]=0;j[a+4>>2]=0;j[114630]=0;j[b+12>>2]=0;K(876,a+8|0,b+12|0,b+8|0)|0;c=j[114630];j[114630]=0;if((c|0)!=1){Za=b+16|0;return a}J(0)|0;C()|0;ib();z()}function Oh(a){var b=0;b=32767;a:{if(a>=q(32766.5)){break a}b=32768;if(a<=q(-32767.5)){break a}a=q(a+q(.5));b:{if(q(r(a))<q(2147483648)){b=~~a;break b}b=-2147483648}b=b+(b>>15)|0}return b<<16>>16}function Mq(a){var b=0;if(j[a+76>>2]<0){b=j[a+4>>2];if(b>>>0<m[a+8>>2]){j[a+4>>2]=b+1;return k[b|0]}return qv(a)}b=j[a+4>>2];a:{if(b>>>0<m[a+8>>2]){j[a+4>>2]=b+1;a=k[b|0];break a}a=qv(a)}return a}function GIa(a){var b=0,c=0;b=Za-16|0;Za=b;j[a>>2]=0;j[a+4>>2]=0;j[114630]=0;j[b+12>>2]=0;K(568,a+8|0,b+12|0,b+8|0)|0;c=j[114630];j[114630]=0;if((c|0)!=1){Za=b+16|0;return a}J(0)|0;C()|0;ib();z()}function FK(a,b,c){var d=0,e=0;d=j[(p(b,896)+a|0)+1075640>>2];a:{if(!d){break a}b:{if((c|0)!=1){break b}a=j[(p(b,896)+a|0)+1075088>>2];if(!a){break b}if(k[a+35|0]&4){break a}}e=k[d+34|0]}return e}function Dza(a){var b=0,c=0;b=Za-16|0;Za=b;j[a>>2]=0;j[a+4>>2]=0;j[114630]=0;j[b+12>>2]=0;K(943,a+8|0,b+12|0,b+8|0)|0;c=j[114630];j[114630]=0;if((c|0)!=1){Za=b+16|0;return a}J(0)|0;C()|0;ib();z()}function zs(a){var b=0,c=0;b=Za-16|0;Za=b;j[a>>2]=0;j[a+4>>2]=0;j[114630]=0;j[b+12>>2]=0;K(927,a+8|0,b+12|0,b+8|0)|0;c=j[114630];j[114630]=0;if((c|0)!=1){Za=b+16|0;return a}J(0)|0;C()|0;ib();z()}function iy(a){var b=0,c=0;b=Za-16|0;Za=b;j[a>>2]=0;j[a+4>>2]=0;j[b+12>>2]=0;j[114630]=0;K(931,a+8|0,b+12|0,b+8|0)|0;c=j[114630];j[114630]=0;if((c|0)!=1){Za=b+16|0;return a}J(0)|0;C()|0;ib();z()}function id(a,b){var c=0;if(l[a+24>>1]!=(b&65535)){i[a+22>>1]=l[a+22>>1]-1&127;if(l[a+20>>1]<128){i[a+20>>1]=l[a+20>>1]+1}c=(l[a+22>>1]<<2)+a|0;i[c+28>>1]=0;i[c+26>>1]=b-l[a+24>>1];i[a+24>>1]=b}}function eU(a){var b=0,c=0;b=Za-16|0;Za=b;j[a>>2]=0;j[a+4>>2]=0;j[114630]=0;j[b+12>>2]=0;K(354,a+8|0,b+12|0,b+8|0)|0;c=j[114630];j[114630]=0;if((c|0)!=1){Za=b+16|0;return a}J(0)|0;C()|0;ib();z()}function dg(a,b){a:{if(m[a+4>>2]<=b>>>0){a=R(8)|0;j[114630]=0;H(352,a|0)|0;b=j[114630];j[114630]=0;if((b|0)!=1){break a}b=D()|0;C()|0;S(a|0);G(b|0);z()}return k[j[a>>2]+b|0]}X(a|0,77432,265);z()}function bL(a,b,c,d){var e=0,f=0,g=0,h=0;e=Za-16|0;Za=e;j[e+12>>2]=0;Bc(a+12|0,d);if(b){f=aL(b)}j[a>>2]=f;c=p(c,12)+f|0;j[a+8>>2]=c;j[a+4>>2]=c;g=Ob(a),h=p(b,12)+f|0,j[g>>2]=h;Za=e+16|0;return a}function _Aa(a,b){var c=0,d=0;d=Za-16|0;Za=d;a:{if((a|0)==(b|0)){break a}c=a+1|0;if((c|0)==(b|0)){break a}while(1){a=k[a|0]<k[c|0]?c:a;c=c+1|0;if((c|0)!=(b|0)){continue}break}}Za=d+16|0;return a}function YV(a){var b=0,c=0;b=Za-16|0;Za=b;j[a>>2]=0;j[a+4>>2]=0;j[114630]=0;j[b+12>>2]=0;K(269,a+8|0,b+12|0,b+8|0)|0;c=j[114630];j[114630]=0;if((c|0)!=1){Za=b+16|0;return a}J(0)|0;C()|0;ib();z()}function Xy(a){var b=0,c=0;b=Za-16|0;Za=b;j[a>>2]=0;j[a+4>>2]=0;j[114630]=0;j[b+12>>2]=0;K(705,a+8|0,b+12|0,b+8|0)|0;c=j[114630];j[114630]=0;if((c|0)!=1){Za=b+16|0;return a}J(0)|0;C()|0;ib();z()}function TS(a){var b=0,c=0;b=Za-16|0;Za=b;j[a>>2]=0;j[a+4>>2]=0;j[114630]=0;j[b+12>>2]=0;K(417,a+8|0,b+12|0,b+8|0)|0;c=j[114630];j[114630]=0;if((c|0)!=1){Za=b+16|0;return a}J(0)|0;C()|0;ib();z()}function Qt(a){var b=0,c=0;b=Za-16|0;Za=b;j[a>>2]=0;j[a+4>>2]=0;j[114630]=0;j[b+12>>2]=0;K(355,a+8|0,b+12|0,b+8|0)|0;c=j[114630];j[114630]=0;if((c|0)!=1){Za=b+16|0;return a}J(0)|0;C()|0;ib();z()}function Pz(a){var b=0,c=0;b=Za-16|0;Za=b;j[a>>2]=0;j[a+4>>2]=0;j[114630]=0;j[b+12>>2]=0;K(409,a+8|0,b+12|0,b+8|0)|0;c=j[114630];j[114630]=0;if((c|0)!=1){Za=b+16|0;return a}J(0)|0;C()|0;ib();z()}function FKa(a,b,c){var d=0;d=Za-16|0;Za=d;j[d+12>>2]=c;j[d>>2]=192;c=j[tb(d+12|0,d)>>2];if(!yb(a,c)){c=ef(a)}rt(d,b);ug(a,j[d>>2],c);rt(d,b);Ab(j[d>>2]+c|0,0,192-c|0);Jb(a,j[d+12>>2]);Za=d+16|0}function FIa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;if(oz(a)>>>0<b>>>0){Oc();z()}hb(a);c=b;if(c>>>0>715827882){oc(12706);z()}c=ac(p(c,6),1);j[a>>2]=c;j[a+4>>2]=c;d=hb(a),e=c+p(b,6)|0,j[d>>2]=e;gt(a,0)}function x9(a){a=a|0;var b=0;a=a+24|0;b=ZF(j[a>>2]);if(Wi(Eb(j[a>>2]+484360|0))>>>0<=b>>>0){return l[j[a>>2]+1074436>>1]}b=l[bc(Eb(j[a>>2]+484360|0),b)>>1];return(yp(j[a>>2]+484344|0,b)?b:-1)|0}function wza(a,b,c,d){var e=0,f=0,g=0,h=0;e=Za-16|0;Za=e;j[e+12>>2]=0;Bc(a+12|0,d);if(b){f=RN(b)}j[a>>2]=f;c=(c<<2)+f|0;j[a+8>>2]=c;j[a+4>>2]=c;g=Ob(a),h=(b<<2)+f|0,j[g>>2]=h;Za=e+16|0;return a}function loa(a,b,c,d){var e=0,f=0,g=0,h=0;e=Za-16|0;Za=e;j[e+12>>2]=0;Bc(a+12|0,d);if(b){f=dK(b)}j[a>>2]=f;c=(c<<5)+f|0;j[a+8>>2]=c;j[a+4>>2]=c;g=Ob(a),h=(b<<5)+f|0,j[g>>2]=h;Za=e+16|0;return a}function bA(a){var b=0,c=0;b=Za-16|0;Za=b;j[a>>2]=0;j[a+4>>2]=0;j[114630]=0;j[b+12>>2]=0;K(31,a+8|0,b+12|0,b+8|0)|0;c=j[114630];j[114630]=0;if((c|0)!=1){Za=b+16|0;return a}J(0)|0;C()|0;ib();z()}function aia(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=Za-16|0;Za=d;e=1;a=a+32|0;if(m[j[b>>2]>>2]<tc(a)>>>0){a=Vl(d,fc(a,j[j[b>>2]>>2]),l[j[b>>2]+12>>1]);b=Nu(c,a);qb(a);e=b^1}Za=d+16|0;return e|0}function TBa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;if(Mm(a)>>>0<b>>>0){Oc();z()}hb(a);c=b;if(c>>>0>1073741823){oc(15551);z()}c=ac(c<<2,1);j[a>>2]=c;j[a+4>>2]=c;d=hb(a),e=c+(b<<2)|0,j[d>>2]=e;Pj(a,0)}function Px(a){var b=0,c=0;b=Za-16|0;Za=b;j[a>>2]=0;j[a+4>>2]=0;j[114630]=0;j[b+12>>2]=0;K(94,a+8|0,b+12|0,b+8|0)|0;c=j[114630];j[114630]=0;if((c|0)!=1){Za=b+16|0;return a}J(0)|0;C()|0;ib();z()}function Ip(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;if(cA(a)>>>0<b>>>0){Oc();z()}hb(a);b=(b-1>>>5|0)+1|0;c=b;if(b>>>0>1073741823){oc(11804);z()}c=ac(c<<2,4);j[a+4>>2]=0;j[a>>2]=c;d=hb(a),e=b,j[d>>2]=e}function EG(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=ue(12);b=j[b>>2];c=j[c>>2];j[114630]=0;b=K(1996,d|0,b|0,c|0)|0;c=j[114630];j[114630]=0;if((c|0)!=1){Vda(a,b);return}a=D()|0;C()|0;Fb(d);G(a|0);z()}function yt(a,b,c,d){var e=0,f=0,g=0,h=0;e=Za-16|0;Za=e;j[e+12>>2]=0;Bc(a+12|0,d);if(b){f=hT(b)}j[a>>2]=f;c=(c<<1)+f|0;j[a+8>>2]=c;j[a+4>>2]=c;g=Ob(a),h=(b<<1)+f|0,j[g>>2]=h;Za=e+16|0;return a}function wra(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;if(fq(a)>>>0<b>>>0){Oc();z()}hb(a);c=b;if(c>>>0>268435455){oc(20113);z()}c=ac(c<<4,8);j[a>>2]=c;j[a+4>>2]=c;d=hb(a),e=c+(b<<4)|0,j[d>>2]=e;Pl(a,0)}function wn(a,b,c,d){var e=0,f=0,g=0,h=0;e=Za-16|0;Za=e;j[e+12>>2]=0;Bc(a+12|0,d);if(b){f=dA(b)}j[a>>2]=f;c=(c<<2)+f|0;j[a+8>>2]=c;j[a+4>>2]=c;g=Ob(a),h=(b<<2)+f|0,j[g>>2]=h;Za=e+16|0;return a}function w5(a,b){var c=0;c=Ab(a,0,1512);if(b){a=j[b+4>>2];j[c+80>>2]=j[b>>2];j[c+84>>2]=a;a=a&-8;j[c+92>>2]=a;j[c+84>>2]=a}j[c+96>>2]=0;j[c+100>>2]=0;j[c+1420>>2]=-1;j[c+124>>2]=0;j[c+32>>2]=0}function uw(a,b,c,d){var e=0,f=0,g=0,h=0;e=Za-16|0;Za=e;j[e+12>>2]=0;Bc(a+12|0,d);if(b){f=fI(b)}j[a>>2]=f;c=(c<<2)+f|0;j[a+8>>2]=c;j[a+4>>2]=c;g=Ob(a),h=(b<<2)+f|0,j[g>>2]=h;Za=e+16|0;return a}function pfa(a,b,c){a=a|0;b=b|0;c=q(c);var d=0;d=Za-16|0;Za=d;n[d+12>>2]=c;if((b|0)<=4){Kd(d+12|0,q(0));c=n[d+12>>2];if((b|0)==4){c=Rd(c);n[d+12>>2]=c}n[((b<<2)+a|0)+4220>>2]=c;eH(a)}Za=d+16|0}function o8(a,b,c,d){var e=0,f=0,g=0,h=0;e=Za-16|0;Za=e;j[e+12>>2]=0;Bc(a+12|0,d);if(b){f=NF(b)}j[a>>2]=f;c=(c<<4)+f|0;j[a+8>>2]=c;j[a+4>>2]=c;g=Ob(a),h=(b<<4)+f|0,j[g>>2]=h;Za=e+16|0;return a}function lM(a,b,c,d){var e=0;e=Za-16|0;Za=e;d=yh(e,a,d);a=hb(a);j[114630]=0;L(1164,a|0,b|0,c|0,d+4|0);a=j[114630];j[114630]=0;if((a|0)!=1){ub(d);Za=e+16|0;return}a=D()|0;C()|0;ub(d);G(a|0);z()}function jxa(a,b){var c=0;c=Za-16|0;Za=c;j[a>>2]=0;j[a+4>>2]=0;j[c+12>>2]=0;j[114630]=0;K(1021,a+8|0,c+12|0,b|0)|0;b=j[114630];j[114630]=0;if((b|0)!=1){Za=c+16|0;return a}J(0)|0;C()|0;ib();z()}function fwa(a,b,c){var d=0;d=Za-16|0;Za=d;j[d+12>>2]=c;j[d>>2]=36;c=j[tb(d+12|0,d)>>2];if(!yb(a,c)){c=ef(a)}Rp(d,b);ug(a,j[d>>2],c);Rp(d,b);Ab(j[d>>2]+c|0,0,36-c|0);Jb(a,j[d+12>>2]);Za=d+16|0}function dba(a,b){var c=0;c=Za-16|0;Za=c;j[a>>2]=0;j[a+4>>2]=0;j[c+12>>2]=0;j[114630]=0;K(2118,a+8|0,c+12|0,b|0)|0;b=j[114630];j[114630]=0;if((b|0)!=1){Za=c+16|0;return a}J(0)|0;C()|0;ib();z()}function cY(a,b,c){var d=0,e=0,f=0;e=Za-16|0;Za=e;d=oq(a);a:{if(d>>>0>=c>>>0){d=zb(a);bY(d,b,c);j[e+12>>2]=0;ye(d+(c<<2)|0,e+12|0);Bg(a,c);break a}f=a;a=nb(a);QB(f,d,c-d|0,a,0,a,c,b)}Za=e+16|0}function as(a,b,c,d){var e=0,f=0,g=0,h=0;e=Za-16|0;Za=e;j[e+12>>2]=0;Bc(a+12|0,d);if(b){f=$K(b)}j[a>>2]=f;c=(c<<2)+f|0;j[a+8>>2]=c;j[a+4>>2]=c;g=Ob(a),h=(b<<2)+f|0,j[g>>2]=h;Za=e+16|0;return a}function ZQ(a,b,c,d){var e=0,f=0,g=0,h=0;e=Za-16|0;Za=e;j[e+12>>2]=0;Bc(a+12|0,d);if(b){f=zS(b)}j[a>>2]=f;c=(c<<4)+f|0;j[a+8>>2]=c;j[a+4>>2]=c;g=Ob(a),h=(b<<4)+f|0,j[g>>2]=h;Za=e+16|0;return a}function ZE(a,b){var c=0,d=0,e=0,f=q(0),g=q(0),h=0;if((b|0)>=1){h=a+2304|0;while(1){c=d<<2;e=c+a|0;c=c+h|0;f=n[c>>2];g=n[e>>2];n[e>>2]=f+g;n[c>>2]=g-f;d=d+1|0;if((d|0)!=(b|0)){continue}break}}}function XL(a,b,c,d){var e=0,f=0,g=0,h=0;e=Za-16|0;Za=e;j[e+12>>2]=0;Bc(a+12|0,d);if(b){f=ZL(b)}j[a>>2]=f;c=(c<<5)+f|0;j[a+8>>2]=c;j[a+4>>2]=c;g=Ob(a),h=(b<<5)+f|0,j[g>>2]=h;Za=e+16|0;return a}function Vwa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;e=Za-16|0;Za=e;j[e>>2]=c;j[e+8>>2]=b;if(rb(e+8|0,e)){while(1){Uwa(d,j[e+8>>2]);lk(e+8|0);if(rb(e+8|0,e)){continue}break}}VM(a,d);Za=e+16|0}function VP(a,b,c,d){var e=0,f=0,g=0,h=0;e=Za-16|0;Za=e;j[e+12>>2]=0;Bc(a+12|0,d);if(b){f=XP(b)}j[a>>2]=f;c=p(c,6)+f|0;j[a+8>>2]=c;j[a+4>>2]=c;g=Ob(a),h=p(b,6)+f|0,j[g>>2]=h;Za=e+16|0;return a}function NZ(a,b,c,d){var e=0;e=Za-16|0;Za=e;j[e+12>>2]=d;d=bh(e+8|0,e+12|0);j[114630]=0;a=jD(a,b,c);b=j[114630];j[114630]=0;if((b|0)!=1){oe(d);Za=e+16|0;return a}a=D()|0;C()|0;oe(d);G(a|0);z()}function Lu(a,b,c,d){var e=0;e=Za-16|0;Za=e;j[e+12>>2]=d;d=bh(e+8|0,e+12|0);j[114630]=0;a=Cj(a,b,c);b=j[114630];j[114630]=0;if((b|0)!=1){oe(d);Za=e+16|0;return a}a=D()|0;C()|0;oe(d);G(a|0);z()}function Isa(a,b){var c=0,d=0;c=Hsa(a,b);j[114630]=0;E(4,a+12|0,b+12|0)|0;d=j[114630];j[114630]=0;if((d|0)!=1){j[a+24>>2]=j[b+24>>2];i[a+28>>1]=l[b+28>>1];return}a=D()|0;C()|0;ff(c);G(a|0);z()}function Gra(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;if(au(a)>>>0<b>>>0){Oc();z()}hb(a);c=b;if(c>>>0>536870911){oc(20113);z()}c=ac(c<<3,8);j[a>>2]=c;j[a+4>>2]=c;d=hb(a),e=c+(b<<3)|0,j[d>>2]=e;$t(a,0)}function Aea(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=kg(86224);if(!d){return 0}j[114630]=0;a=P(1960,d|0,a|0,b|0,c|0)|0;b=j[114630];j[114630]=0;if((b|0)!=1){return a|0}a=D()|0;C()|0;Fb(d);G(a|0);z()}function $ea(a,b,c){a=a|0;b=b|0;c=q(c);var d=0;d=Za-16|0;Za=d;n[d+12>>2]=c;if((b|0)<=1){Kd(d+12|0,q(0));c=n[d+12>>2];if((b|0)==1){c=Rd(c);n[d+12>>2]=c}n[((b<<2)+a|0)+4208>>2]=c;$G(a)}Za=d+16|0}function yaa(a,b,c,d){var e=0,f=0;e=Za-16|0;Za=e;f=j[b+12>>2];j[e+8>>2]=j[b+8>>2];j[e+12>>2]=f;f=j[b+4>>2];j[e>>2]=j[b>>2];j[e+4>>2]=f;xaa(a,e,c);n[a+28>>2]=d;j[a>>2]=84144;Za=e+16|0;return a}function wL(a,b){var c=0;c=Za-16|0;Za=c;j[a>>2]=0;j[a+4>>2]=0;j[c+12>>2]=0;j[114630]=0;K(1220,a+8|0,c+12|0,b|0)|0;b=j[114630];j[114630]=0;if((b|0)!=1){Za=c+16|0;return a}J(0)|0;C()|0;ib();z()}function tfa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=kg(4268);if(!d){return 0}j[114630]=0;a=P(1850,d|0,a|0,b|0,c|0)|0;b=j[114630];j[114630]=0;if((b|0)!=1){return a|0}a=D()|0;C()|0;Fb(d);G(a|0);z()}function tI(a,b){var c=0;c=Za-16|0;Za=c;j[a>>2]=0;j[a+4>>2]=0;j[c+12>>2]=0;j[114630]=0;K(1586,a+8|0,c+12|0,b|0)|0;b=j[114630];j[114630]=0;if((b|0)!=1){Za=c+16|0;return a}J(0)|0;C()|0;ib();z()}function oea(a,b,c,d){var e=0,f=0,g=0;if(d){while(1){e=g<<3;f=e+a|0;j[f>>2]=j[f>>2]+p(j[b+e>>2]>>4,c);e=e|4;f=e+a|0;j[f>>2]=j[f>>2]+p(j[b+e>>2]>>4,c);g=g+1|0;if((g|0)!=(d|0)){continue}break}}}function lfa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=kg(4296);if(!d){return 0}j[114630]=0;a=P(1874,d|0,a|0,b|0,c|0)|0;b=j[114630];j[114630]=0;if((b|0)!=1){return a|0}a=D()|0;C()|0;Fb(d);G(a|0);z()}function efa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=kg(4228);if(!d){return 0}j[114630]=0;a=P(1887,d|0,a|0,b|0,c|0)|0;b=j[114630];j[114630]=0;if((b|0)!=1){return a|0}a=D()|0;C()|0;Fb(d);G(a|0);z()}function Yfa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=kg(4296);if(!d){return 0}j[114630]=0;a=P(1770,d|0,a|0,b|0,c|0)|0;b=j[114630];j[114630]=0;if((b|0)!=1){return a|0}a=D()|0;C()|0;Fb(d);G(a|0);z()}function XV(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;if(au(a)>>>0<b>>>0){Oc();z()}hb(a);c=b;if(c>>>0>536870911){oc(11120);z()}c=ac(c<<3,1);j[a>>2]=c;j[a+4>>2]=c;d=hb(a),e=c+(b<<3)|0,j[d>>2]=e;$t(a,0)}function V6(a,b){var c=0;c=Za-16|0;Za=c;j[a>>2]=0;j[a+4>>2]=0;j[c+12>>2]=0;j[114630]=0;K(2203,a+8|0,c+12|0,b|0)|0;b=j[114630];j[114630]=0;if((b|0)!=1){Za=c+16|0;return a}J(0)|0;C()|0;ib();z()}function Uea(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=kg(5048);if(!d){return 0}j[114630]=0;a=P(1910,d|0,a|0,b|0,c|0)|0;b=j[114630];j[114630]=0;if((b|0)!=1){return a|0}a=D()|0;C()|0;Fb(d);G(a|0);z()}function Mha(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=kg(4268);if(!d){return 0}j[114630]=0;a=P(1632,d|0,a|0,b|0,c|0)|0;b=j[114630];j[114630]=0;if((b|0)!=1){return a|0}a=D()|0;C()|0;Fb(d);G(a|0);z()}function Lfa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=kg(4280);if(!d){return 0}j[114630]=0;a=P(1803,d|0,a|0,b|0,c|0)|0;b=j[114630];j[114630]=0;if((b|0)!=1){return a|0}a=D()|0;C()|0;Fb(d);G(a|0);z()}function Iea(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=kg(4276);if(!d){return 0}j[114630]=0;a=P(1937,d|0,a|0,b|0,c|0)|0;b=j[114630];j[114630]=0;if((b|0)!=1){return a|0}a=D()|0;C()|0;Fb(d);G(a|0);z()}function H5(a){var b=0,c=0,d=0;b=Za-16|0;Za=b;yc(b+8|0,a+116|0);j[114630]=0;c=Ba(198,a|0)|0;a=C()|0;c=c|0;d=j[114630];j[114630]=0;if((d|0)!=1){Za=b+16|0;ab=a;return c}a=D()|0;C()|0;G(a|0);z()}function Fg(a,b){var c=0,d=0;a=j[a>>2];b=sd(b);c=b;d=a+16|0;if(sb(d)>>>0>b>>>0){c=j[xb(d,c)>>2]!=0}else{c=0}if(!c){a=R(4)|0;sm(a);j[a>>2]=71836;X(a|0,71896,2565);z()}return j[xb(a+16|0,b)>>2]}function E4(a){a=a|0;var b=0,c=0,d=0,e=0,f=0;d=a;b=j[a+112>>2];if((b|0)>=11){e=a;b=378;while(1){qE(e);c=f-(b>>>0<1)|0;b=b-1|0;f=c;if(b|c){continue}break}b=0}j[d+112>>2]=b+1;a=qE(a);return a|0}function Caa(a,b,c,d){var e=0,f=0;e=Za-16|0;Za=e;f=j[b+12>>2];j[e+8>>2]=j[b+8>>2];j[e+12>>2]=f;f=j[b+4>>2];j[e>>2]=j[b>>2];j[e+4>>2]=f;Aaa(a,e,c);n[a+28>>2]=d;j[a>>2]=84040;Za=e+16|0;return a}function Bfa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=kg(4276);if(!d){return 0}j[114630]=0;a=P(1827,d|0,a|0,b|0,c|0)|0;b=j[114630];j[114630]=0;if((b|0)!=1){return a|0}a=D()|0;C()|0;Fb(d);G(a|0);z()}function $ga(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=kg(4304);if(!d){return 0}j[114630]=0;a=P(1695,d|0,a|0,b|0,c|0)|0;b=j[114630];j[114630]=0;if((b|0)!=1){return a|0}a=D()|0;C()|0;Fb(d);G(a|0);z()}function $L(a,b){var c=0;c=Za-16|0;Za=c;j[a>>2]=0;j[a+4>>2]=0;j[c+12>>2]=0;j[114630]=0;K(1191,a+8|0,c+12|0,b|0)|0;b=j[114630];j[114630]=0;if((b|0)!=1){Za=c+16|0;return a}J(0)|0;C()|0;ib();z()}function yN(a,b){var c=0;c=Za-16|0;Za=c;j[a>>2]=0;j[a+4>>2]=0;j[c+12>>2]=0;j[114630]=0;K(988,a+8|0,c+12|0,b|0)|0;b=j[114630];j[114630]=0;if((b|0)!=1){Za=c+16|0;return a}J(0)|0;C()|0;ib();z()}function uoa(a){var b=0;b=Za-16|0;Za=b;j[a>>2]=0;j[a+4>>2]=0;j[114630]=0;j[b+12>>2]=0;K(1374,a+8|0,b+12|0,b+8|0)|0;a=j[114630];j[114630]=0;if((a|0)!=1){Za=b+16|0;return}J(0)|0;C()|0;ib();z()}function uDa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;d=Za+ -64|0;Za=d;c=d+8|0;e=NCa(a,c);if(!e){lP(c)}c=-1;a:{if(!e){break a}c=0;if(!zP(d+8|0)){break a}c=Me(a,b,yP(d+8|0),ab)}Za=d- -64|0;return c|0}function sna(a){var b=0;b=Za-16|0;Za=b;j[a>>2]=0;j[a+4>>2]=0;j[114630]=0;j[b+12>>2]=0;K(1413,a+8|0,b+12|0,b+8|0)|0;a=j[114630];j[114630]=0;if((a|0)!=1){Za=b+16|0;return}J(0)|0;C()|0;ib();z()}function qna(a){var b=0;b=Za-16|0;Za=b;j[a>>2]=0;j[a+4>>2]=0;j[114630]=0;j[b+12>>2]=0;K(1415,a+8|0,b+12|0,b+8|0)|0;a=j[114630];j[114630]=0;if((a|0)!=1){Za=b+16|0;return}J(0)|0;C()|0;ib();z()}function qga(a){var b=0;b=Za-16|0;Za=b;j[a>>2]=0;j[a+4>>2]=0;j[114630]=0;j[b+12>>2]=0;K(1737,a+8|0,b+12|0,b+8|0)|0;a=j[114630];j[114630]=0;if((a|0)!=1){Za=b+16|0;return}J(0)|0;C()|0;ib();z()}function pra(a){var b=0;b=Za-16|0;Za=b;j[a>>2]=0;j[a+4>>2]=0;j[114630]=0;j[b+12>>2]=0;K(1228,a+8|0,b+12|0,b+8|0)|0;a=j[114630];j[114630]=0;if((a|0)!=1){Za=b+16|0;return}J(0)|0;C()|0;ib();z()}function pga(a){var b=0;b=Za-16|0;Za=b;j[a>>2]=0;j[a+4>>2]=0;j[114630]=0;j[b+12>>2]=0;K(1738,a+8|0,b+12|0,b+8|0)|0;a=j[114630];j[114630]=0;if((a|0)!=1){Za=b+16|0;return}J(0)|0;C()|0;ib();z()}function mxa(a){var b=0;b=Za-16|0;Za=b;j[a>>2]=0;j[a+4>>2]=0;j[114630]=0;j[b+12>>2]=0;K(1020,a+8|0,b+12|0,b+8|0)|0;a=j[114630];j[114630]=0;if((a|0)!=1){Za=b+16|0;return}J(0)|0;C()|0;ib();z()}function gma(a){var b=0,c=0,d=0,e=0,f=0;a:{b=j[a+656>>2];c=h[b+26|0];if(!c){break a}d=k[a+819|0];if(!d){break a}e=a,f=Gb(j[a+684>>2]+((p((k[b+27|0]^-1)+d|0,c)|0)/2|0)|0,0,256),j[e+684>>2]=f}}function gi(a,b){var c=0,d=0;c=Za-16|0;Za=c;j[c+12>>2]=0;a=zk(a,c+12|0,4);j[c+8>>2]=j[c+12>>2];d=b;b=c+8|0;j[d>>2]=k[b|0]|k[b+1|0]<<8|(k[b+2|0]<<16|k[b+3|0]<<24);Za=c+16|0;return!ab&(a|0)==4}function fta(a){var b=0;b=Za-16|0;Za=b;j[a>>2]=0;j[a+4>>2]=0;j[114630]=0;j[b+12>>2]=0;K(1171,a+8|0,b+12|0,b+8|0)|0;a=j[114630];j[114630]=0;if((a|0)!=1){Za=b+16|0;return}J(0)|0;C()|0;ib();z()}function eja(a){var b=0;b=Za-16|0;Za=b;j[a>>2]=0;j[a+4>>2]=0;j[114630]=0;j[b+12>>2]=0;K(1588,a+8|0,b+12|0,b+8|0)|0;a=j[114630];j[114630]=0;if((a|0)!=1){Za=b+16|0;return}J(0)|0;C()|0;ib();z()}function dga(a){var b=0;b=Za-16|0;Za=b;j[a>>2]=0;j[a+4>>2]=0;j[114630]=0;j[b+12>>2]=0;K(1756,a+8|0,b+12|0,b+8|0)|0;a=j[114630];j[114630]=0;if((a|0)!=1){Za=b+16|0;return}J(0)|0;C()|0;ib();z()}function _w(a,b){var c=0;Dma(a,b);h[a+12|0]=k[b+12|0];c=k[b+13|0]|k[b+14|0]<<8|(k[b+15|0]<<16|k[b+16|0]<<24);h[a+13|0]=c;h[a+14|0]=c>>>8;h[a+15|0]=c>>>16;h[a+16|0]=c>>>24;h[a+17|0]=k[b+17|0]}function YP(a,b,c){a=a|0;b=b|0;c=c|0;a=k[c|0]|k[c+1|0]<<8|(k[c+2|0]<<16|k[c+3|0]<<24);h[b|0]=a;h[b+1|0]=a>>>8;h[b+2|0]=a>>>16;h[b+3|0]=a>>>24;a=k[c+4|0]|k[c+5|0]<<8;h[b+4|0]=a;h[b+5|0]=a>>>8}function Xoa(a){var b=0;b=Za-16|0;Za=b;j[a>>2]=0;j[a+4>>2]=0;j[114630]=0;j[b+12>>2]=0;K(1366,a+8|0,b+12|0,b+8|0)|0;a=j[114630];j[114630]=0;if((a|0)!=1){Za=b+16|0;return}J(0)|0;C()|0;ib();z()}function Ula(a){var b=0;b=Za-16|0;Za=b;j[a>>2]=0;j[a+4>>2]=0;j[114630]=0;j[b+12>>2]=0;K(1512,a+8|0,b+12|0,b+8|0)|0;a=j[114630];j[114630]=0;if((a|0)!=1){Za=b+16|0;return}J(0)|0;C()|0;ib();z()}function Qaa(a){var b=0;b=Za-16|0;Za=b;j[a>>2]=0;j[a+4>>2]=0;j[114630]=0;j[b+12>>2]=0;K(2125,a+8|0,b+12|0,b+8|0)|0;a=j[114630];j[114630]=0;if((a|0)!=1){Za=b+16|0;return}J(0)|0;C()|0;ib();z()}function PS(a,b){var c=0;c=Za-16|0;Za=c;j[a>>2]=0;j[a+4>>2]=0;j[c+12>>2]=0;j[114630]=0;K(419,a+8|0,c+12|0,b|0)|0;b=j[114630];j[114630]=0;if((b|0)!=1){Za=c+16|0;return a}J(0)|0;C()|0;ib();z()}function Kna(a){var b=0;b=Za-16|0;Za=b;j[a>>2]=0;j[a+4>>2]=0;j[114630]=0;j[b+12>>2]=0;K(1397,a+8|0,b+12|0,b+8|0)|0;a=j[114630];j[114630]=0;if((a|0)!=1){Za=b+16|0;return}J(0)|0;C()|0;ib();z()}function Kma(a){var b=0;b=Za-16|0;Za=b;j[a>>2]=0;j[a+4>>2]=0;j[114630]=0;j[b+12>>2]=0;K(1431,a+8|0,b+12|0,b+8|0)|0;a=j[114630];j[114630]=0;if((a|0)!=1){Za=b+16|0;return}J(0)|0;C()|0;ib();z()}function Jta(a){var b=0;b=Za-16|0;Za=b;j[a>>2]=0;j[a+4>>2]=0;j[114630]=0;j[b+12>>2]=0;K(1161,a+8|0,b+12|0,b+8|0)|0;a=j[114630];j[114630]=0;if((a|0)!=1){Za=b+16|0;return}J(0)|0;C()|0;ib();z()}function JA(a){if(!((k[a|0]|k[a+1|0]<<8|(k[a+2|0]<<16|k[a+3|0]<<24))!=808603728|(k[a+4|0]-9&255)>>>0>6|((k[a+5|0]-9&255)>>>0>6|(k[a+6|0]-9&255)>>>0>6))){return(k[a+7|0]-9&255)>>>0<7}return 0}function Iwa(a){var b=0;b=Za-16|0;Za=b;j[a>>2]=0;j[a+4>>2]=0;j[114630]=0;j[b+12>>2]=0;K(1050,a+8|0,b+12|0,b+8|0)|0;a=j[114630];j[114630]=0;if((a|0)!=1){Za=b+16|0;return}J(0)|0;C()|0;ib();z()}function Ima(a){var b=0;b=Za-16|0;Za=b;j[a>>2]=0;j[a+4>>2]=0;j[114630]=0;j[b+12>>2]=0;K(1432,a+8|0,b+12|0,b+8|0)|0;a=j[114630];j[114630]=0;if((a|0)!=1){Za=b+16|0;return}J(0)|0;C()|0;ib();z()}function G_(a){var b=0,c=0;b=Za-16|0;Za=b;j[a>>2]=0;j[a+4>>2]=0;j[b+12>>2]=0;j[114630]=0;cC(a+16|0,b+12|0,b+8|0);c=j[114630];j[114630]=0;if((c|0)!=1){Za=b+16|0;return a}J(0)|0;C()|0;ib();z()}function GFa(a,b,c,d){var e=0,f=0,g=0,h=0;e=Za-32|0;Za=e;a=a+4|0;g=e,h=Lb(a),j[g+24>>2]=h;f=af(e+24|0,c);g=e,h=Lb(a),j[g+8>>2]=h;g=e,h=af(e+8|0,c),j[g+16>>2]=h;cj(f,af(e+16|0,d),b);Za=e+32|0}function Fxa(a){var b=0;b=Za-16|0;Za=b;j[a>>2]=0;j[a+4>>2]=0;j[114630]=0;j[b+12>>2]=0;K(1013,a+8|0,b+12|0,b+8|0)|0;a=j[114630];j[114630]=0;if((a|0)!=1){Za=b+16|0;return}J(0)|0;C()|0;ib();z()}function Cf(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;d=Za-16|0;Za=d;c=a;a:{if(!qe(b)){j[c+8>>2]=j[b+8>>2];e=j[b+4>>2];j[c>>2]=j[b>>2];j[c+4>>2]=e;break a}Xo(a,j[b>>2],j[b+4>>2])}Za=d+16|0;return a|0}function Aka(a){var b=0;b=Za-16|0;Za=b;j[a>>2]=0;j[a+4>>2]=0;j[114630]=0;j[b+12>>2]=0;K(1554,a+8|0,b+12|0,b+8|0)|0;a=j[114630];j[114630]=0;if((a|0)!=1){Za=b+16|0;return}J(0)|0;C()|0;ib();z()}function xAa(a){var b=0;b=Za-16|0;Za=b;j[a>>2]=0;j[a+4>>2]=0;j[114630]=0;j[b+12>>2]=0;K(918,a+8|0,b+12|0,b+8|0)|0;a=j[114630];j[114630]=0;if((a|0)!=1){Za=b+16|0;return}J(0)|0;C()|0;ib();z()}function qd(a,b){var c=0,d=0,e=0,f=0,g=0,h=0,i=0,k=0;c=Za-16|0;Za=c;d=j[a>>2];e=a,f=(h=d,i=j[a+8>>2],k=Kb(c+8|0,b),g=j[j[d>>2]+32>>2],bb[g](h|0,i|0,k|0)|0)+j[a+8>>2]|0,j[e+8>>2]=f;Za=c+16|0}function mGa(a){var b=0;b=Za-16|0;Za=b;j[a>>2]=0;j[a+4>>2]=0;j[114630]=0;j[b+12>>2]=0;K(696,a+8|0,b+12|0,b+8|0)|0;a=j[114630];j[114630]=0;if((a|0)!=1){Za=b+16|0;return}J(0)|0;C()|0;ib();z()}function hEa(a){var b=0;b=Za-16|0;Za=b;j[a>>2]=0;j[a+4>>2]=0;j[114630]=0;j[b+12>>2]=0;K(759,a+8|0,b+12|0,b+8|0)|0;a=j[114630];j[114630]=0;if((a|0)!=1){Za=b+16|0;return}J(0)|0;C()|0;ib();z()}function bza(a){var b=0;b=Za-16|0;Za=b;j[a>>2]=0;j[a+4>>2]=0;j[114630]=0;j[b+12>>2]=0;K(971,a+8|0,b+12|0,b+8|0)|0;a=j[114630];j[114630]=0;if((a|0)!=1){Za=b+16|0;return}J(0)|0;C()|0;ib();z()}function aDa(a){var b=0;b=Za-16|0;Za=b;j[a>>2]=0;j[a+4>>2]=0;j[114630]=0;j[b+12>>2]=0;K(813,a+8|0,b+12|0,b+8|0)|0;a=j[114630];j[114630]=0;if((a|0)!=1){Za=b+16|0;return}J(0)|0;C()|0;ib();z()}function ZB(a,b){var c=0,d=0;c=j[a+4>>2];a:{while(1){if((b|0)==(c|0)){break a}Ek(a);j[114630]=0;c=c-4|0;d=j[114630];j[114630]=0;if((d|0)!=1){continue}break}J(0)|0;C()|0;ib();z()}j[a+4>>2]=b}function WCa(a){var b=0;b=Za-16|0;Za=b;j[a>>2]=0;j[a+4>>2]=0;j[114630]=0;j[b+12>>2]=0;K(816,a+8|0,b+12|0,b+8|0)|0;a=j[114630];j[114630]=0;if((a|0)!=1){Za=b+16|0;return}J(0)|0;C()|0;ib();z()}function Uya(a){var b=0;b=Za-16|0;Za=b;j[a>>2]=0;j[a+4>>2]=0;j[114630]=0;j[b+12>>2]=0;K(979,a+8|0,b+12|0,b+8|0)|0;a=j[114630];j[114630]=0;if((a|0)!=1){Za=b+16|0;return}J(0)|0;C()|0;ib();z()}function Taa(a,b){var c=0;c=Za-48|0;Za=c;a:{if((b|0)==-1){_k(a,j[Uo(c+8|0)+32>>2]);Om(a,j[Uo(c+8|0)+36>>2]);break a}if((b|0)<=0){_k(a,0);Om(a,0);break a}b=p(b,1e3);_k(a,b);Om(a,b)}Za=c+48|0}function S2(){var a=0,b=0;a=Za-16|0;Za=a;b=R(16)|0;a=R2(a+8|0);j[114630]=0;K(2393,b|0,59072,a|0)|0;a=j[114630];j[114630]=0;if((a|0)!=1){X(b|0,59144,2394);z()}a=D()|0;C()|0;S(b|0);G(a|0);z()}function RJa(a){var b=0;b=Za-16|0;Za=b;j[a>>2]=0;j[a+4>>2]=0;j[114630]=0;j[b+12>>2]=0;K(519,a+8|0,b+12|0,b+8|0)|0;a=j[114630];j[114630]=0;if((a|0)!=1){Za=b+16|0;return}J(0)|0;C()|0;ib();z()}function OLa(a){var b=0;b=Za-16|0;Za=b;j[a>>2]=0;j[a+4>>2]=0;j[114630]=0;j[b+12>>2]=0;K(416,a+8|0,b+12|0,b+8|0)|0;a=j[114630];j[114630]=0;if((a|0)!=1){Za=b+16|0;return}J(0)|0;C()|0;ib();z()}function NM(a){var b=0,c=0;a:{b:{b=a&240;if((b|0)!=192){if((b|0)==240){break b}c=3;if((b|0)!=208){break a}}c=2;break a}c=1;a=a+15&255;if(a>>>0>2){break a}return 131842>>>(a<<3)&255}return c}function HIa(a){var b=0;b=Za-16|0;Za=b;j[a>>2]=0;j[a+4>>2]=0;j[114630]=0;j[b+12>>2]=0;K(567,a+8|0,b+12|0,b+8|0)|0;a=j[114630];j[114630]=0;if((a|0)!=1){Za=b+16|0;return}J(0)|0;C()|0;ib();z()}function H8(a){var b=0;b=Za-16|0;Za=b;j[a>>2]=0;j[a+4>>2]=0;j[114630]=0;j[b+12>>2]=0;K(2195,a+8|0,b+12|0,b+8|0)|0;a=j[114630];j[114630]=0;if((a|0)!=1){Za=b+16|0;return}J(0)|0;C()|0;ib();z()}function GDa(a){var b=0;b=Za-16|0;Za=b;j[a>>2]=0;j[a+4>>2]=0;j[114630]=0;j[b+12>>2]=0;K(770,a+8|0,b+12|0,b+8|0)|0;a=j[114630];j[114630]=0;if((a|0)!=1){Za=b+16|0;return}J(0)|0;C()|0;ib();z()}function FHa(a){var b=0;b=Za-16|0;Za=b;j[a>>2]=0;j[a+4>>2]=0;j[114630]=0;j[b+12>>2]=0;K(607,a+8|0,b+12|0,b+8|0)|0;a=j[114630];j[114630]=0;if((a|0)!=1){Za=b+16|0;return}J(0)|0;C()|0;ib();z()}function CJa(a){var b=0;b=Za-16|0;Za=b;j[a>>2]=0;j[a+4>>2]=0;j[114630]=0;j[b+12>>2]=0;K(530,a+8|0,b+12|0,b+8|0)|0;a=j[114630];j[114630]=0;if((a|0)!=1){Za=b+16|0;return}J(0)|0;C()|0;ib();z()}function yha(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;c=j[b>>2];a:{if((Wg(b)|0)!=8){break a}d=c;if((k[d|0]|k[d+1|0]<<8|(k[d+2|0]<<16|k[d+3|0]<<24))!=1869112133){break a}Vb(a+4260|0,c,Wg(b));xr(a)}}function xMa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;d=Za-512|0;Za=d;c=d+8|0;e=sMa(a,c);if(!e){lT(c)}c=-1;a:{if(!e){break a}c=0;if(!qT(d+8|0)){break a}c=Me(a,b,pT(d+8|0),ab)}Za=d+512|0;return c|0}function wha(a,b,c){a=a|0;b=b|0;c=q(c);var d=0,e=0,f=q(0);d=Za-16|0;Za=d;e=d,f=q(q(bb[j[j[a>>2]+48>>2]](a,b))+c),n[e+12>>2]=f;Kd(d+12|0,q(0));bb[j[j[a>>2]+44>>2]](a,b,n[d+12>>2]);Za=d+16|0}function tD(a,b,c,d){a:{if(!a){break a}b:{switch(b+2|0){case 0:h[a|0]=c;return;case 1:i[a>>1]=c;return;case 2:case 3:j[a>>2]=c;return;case 5:break b;default:break a}}j[a>>2]=c;j[a+4>>2]=d}}function rV(a){a=a|0;var b=0,c=0;b=Za-16|0;Za=b;En(a);j[a>>2]=77232;j[114630]=0;K(281,a+12|0,b+8|0,b|0)|0;c=j[114630];j[114630]=0;if((c|0)!=1){Za=b+16|0;return a|0}a=D()|0;C()|0;G(a|0);z()}function rU(a,b){a=a|0;b=b|0;var c=0,d=0;c=Za-48|0;Za=c;d=-1;a:{if(!GA(a,c+8|0)){break a}d=0;if(!BA(c+8|0)){break a}if(b){if(!qU(c+8|0,j[b>>2],j[b+4>>2])){break a}}d=1}Za=c+48|0;return d|0}function pHa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;d=Za-112|0;Za=d;c=d+8|0;e=lHa(a,c);if(!e){UQ(c)}c=-1;a:{if(!e){break a}c=0;if(!XQ(d+8|0)){break a}c=Me(a,b,WQ(d+8|0),ab)}Za=d+112|0;return c|0}function j1(a){var b=0;b=Za-16|0;Za=b;j[a>>2]=0;j[a+4>>2]=0;j[114630]=0;j[b+12>>2]=0;K(207,a+8|0,b+12|0,b+8|0)|0;a=j[114630];j[114630]=0;if((a|0)!=1){Za=b+16|0;return}J(0)|0;C()|0;ib();z()}function dU(a){var b=0;b=Za-16|0;Za=b;j[a>>2]=0;j[a+4>>2]=0;j[114630]=0;j[b+12>>2]=0;K(356,a+8|0,b+12|0,b+8|0)|0;a=j[114630];j[114630]=0;if((a|0)!=1){Za=b+16|0;return}J(0)|0;C()|0;ib();z()}function c1(a){var b=0;b=Za-16|0;Za=b;j[a>>2]=0;j[a+4>>2]=0;j[114630]=0;j[b+12>>2]=0;K(208,a+8|0,b+12|0,b+8|0)|0;a=j[114630];j[114630]=0;if((a|0)!=1){Za=b+16|0;return}J(0)|0;C()|0;ib();z()}function Xka(a,b){a=a|0;b=b|0;var c=0;b=Za-16|0;Za=b;c=-1;a:{if(!hj(a,b+8|0)){break a}c=0;if(!WI(b+8|0)){break a}c=b;a=kN(a,b);if(!a){cQ(c)}c=-1;if(!a){break a}c=VI(b)}Za=b+16|0;return c|0}function TCa(a,b){var c=0,d=0;d=Za-16|0;Za=d;a:{if((a|0)==(b|0)){break a}c=a+8|0;if((c|0)==(b|0)){break a}while(1){a=Uz(a,c)?c:a;c=c+8|0;if((c|0)!=(b|0)){continue}break}}Za=d+16|0;return a}function NHa(a,b){var c=0,d=0;d=Za-16|0;Za=d;a:{if((a|0)==(b|0)){break a}c=a+4|0;if((c|0)==(b|0)){break a}while(1){a=rd(c,a)?c:a;c=c+4|0;if((c|0)!=(b|0)){continue}break}}Za=d+16|0;return a}function DC(a,b,c,d){var e=0;e=j[b+4>>2];j[a>>2]=j[b>>2];j[a+4>>2]=e;e=j[b+12>>2];j[a+8>>2]=j[b+8>>2];j[a+12>>2]=e;b=j[a+8>>2];d=j[a+12>>2]-(d+(b>>>0<c>>>0)|0)|0;j[a+8>>2]=b-c;j[a+12>>2]=d}function BU(a){var b=0;b=Za-16|0;Za=b;j[a>>2]=0;j[a+4>>2]=0;j[114630]=0;j[b+12>>2]=0;K(345,a+8|0,b+12|0,b+8|0)|0;a=j[114630];j[114630]=0;if((a|0)!=1){Za=b+16|0;return}J(0)|0;C()|0;ib();z()}function B4(a){var b=0;b=Za-16|0;Za=b;j[a>>2]=0;j[a+4>>2]=0;j[114630]=0;j[b+12>>2]=0;K(203,a+8|0,b+12|0,b+8|0)|0;a=j[114630];j[114630]=0;if((a|0)!=1){Za=b+16|0;return}J(0)|0;C()|0;ib();z()}function wya(a,b){var c=0;wN(a,b);wN(a+12|0,b+12|0);ay(a+24|0,b+24|0);i[a+52>>1]=l[b+52>>1];c=j[b+48>>2];j[a+44>>2]=j[b+44>>2];j[a+48>>2]=c;c=j[b+40>>2];j[a+36>>2]=j[b+36>>2];j[a+40>>2]=c}function v0(a,b,c,d){var e=0;e=Za-16|0;Za=e;j[e+8>>2]=b;b=6;a:{b:{if(Ji(a,e+8|0)){break b}b=4;if((Zl(d,Bj(a))|0)!=37){break b}b=2;if(!Ji(Mk(a),e+8|0)){break a}}j[c>>2]=j[c>>2]|b}Za=e+16|0}function qG(a,b,c){var d=0;d=Za-16|0;Za=d;j[d+8>>2]=c;a:{if((a|0)==(b|0)){break a}while(1){if(T6(j[a>>2],j[d+8>>2])){break a}a=a+8|0;if((b|0)!=(a|0)){continue}break}a=b}Za=d+16|0;return a}function m_(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;a:{while(1){if((c|0)==(d|0)){break a}b:{if(m[c>>2]>127){break b}if(!(l[Qn()+(j[c>>2]<<1)>>1]&b)){break b}c=c+4|0;continue}break}d=c}return d|0}function io(a,b){var c=0,d=0,e=0;c=Za-16|0;Za=c;d=c,e=ud(b),j[d+12>>2]=e;j[114630]=0;K(1997,a|0,c+12|0,b|0)|0;b=j[114630];j[114630]=0;if((b|0)!=1){Za=c+16|0;return a}J(0)|0;C()|0;ib();z()}function ho(a,b){var c=0,d=0,e=0;c=Za-16|0;Za=c;d=c,e=ud(b),j[d+12>>2]=e;j[114630]=0;K(2156,a|0,c+12|0,b|0)|0;b=j[114630];j[114630]=0;if((b|0)!=1){Za=c+16|0;return a}J(0)|0;C()|0;ib();z()}function h0(a,b,c,d){var e=0;e=Za-16|0;Za=e;j[e+8>>2]=b;while(1){a:{if(!Cq(a,e+8|0)){break a}if(!zj(d,8192,Kk(a))){break a}dm(a);continue}break}if(yj(a,e+8|0)){j[c>>2]=j[c>>2]|2}Za=e+16|0}function c0(a,b,c,d){var e=0;e=Za-16|0;Za=e;j[e+8>>2]=b;b=6;a:{b:{if(yj(a,e+8|0)){break b}b=4;if((Yl(d,Kk(a))|0)!=37){break b}b=2;if(!yj(dm(a),e+8|0)){break a}}j[c>>2]=j[c>>2]|b}Za=e+16|0}function Mv(a,b,c){b=(b+9|0)%12|0;a=((b<<24>>24)/-10<<24>>24)+a|0;return(((((((a|0)/4|0)+c|0)+p(a,365)|0)+((a|0)/-100|0)|0)+((a|0)/400|0)|0)+((p(b,20054016)+327680>>16)/10<<16>>16)|0)-1|0}function B0(a,b,c,d){var e=0;e=Za-16|0;Za=e;j[e+8>>2]=b;while(1){a:{if(!Xn(a,e+8|0)){break a}if(!ng(d,8192,Bj(a))){break a}Mk(a);continue}break}if(Ji(a,e+8|0)){j[c>>2]=j[c>>2]|2}Za=e+16|0}function zMa(a){var b=0;b=k[a+15|0];h[a+15|0]=0;h[a+60|0]=b>>>1&2|b<<1&4|(k[a+60|0]&240|b&1);h[a+80|0]=b>>>4&2|b>>>2&4|(k[a+80|0]&240|b>>>3&1);h[a+100|0]=b>>>5&4|(k[a+100|0]&224|b>>>6&1)}function wy(a){var b=0,c=0;c=(k[a+24|0]>15)+(k[a+25|0]>64)|0;b=a+26|0;b=k[b|0]|k[b+1|0]<<8;a=a+22|0;a=k[a|0]|k[a+1|0]<<8;return c+(((b<<8|b>>>8)&65535)>>>0>((a<<8|a>>>8)&65535)<<1>>>0)|0}function o_(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;while(1){if((b|0)!=(c|0)){a=d;if(m[b>>2]<=127){e=l[Qn()+(j[b>>2]<<1)>>1]}else{e=0}i[a>>1]=e;d=d+2|0;b=b+4|0;continue}break}return c|0}function lX(a){var b=0;b=k[a+74|0];h[a+74|0]=b-1|b;b=j[a>>2];if(b&8){j[a>>2]=b|32;return-1}j[a+4>>2]=0;j[a+8>>2]=0;b=j[a+44>>2];j[a+28>>2]=b;j[a+20>>2]=b;j[a+16>>2]=b+j[a+48>>2];return 0}function hp(a,b){var c=0,d=0,e=0;c=Za-16|0;Za=c;d=c,e=ud(b),j[d+12>>2]=e;j[114630]=0;K(724,a|0,c+12|0,b|0)|0;b=j[114630];j[114630]=0;if((b|0)!=1){Za=c+16|0;return a}J(0)|0;C()|0;ib();z()}function gMa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;d=Za-48|0;Za=d;c=d+8|0;e=ILa(a,c);if(!e){NS(c)}c=-1;a:{if(!e){break a}c=0;if(!fT(d+8|0)){break a}c=Me(a,b,eT(d+8|0),ab)}Za=d+48|0;return c|0}function T6(a,b){var c=0;a:{c=ne(a);if((c|0)==(nb(b)|0)){j[114630]=0;a=U(344,b|0,0,-1,a|0,c|0)|0;b=j[114630];j[114630]=0;if((b|0)==1){break a}a=!a}else{a=0}return a}J(0)|0;C()|0;ib();z()}function Dd(a,b){var c=0;a:{c=ne(b);if((c|0)==(nb(a)|0)){j[114630]=0;a=U(344,a|0,0,-1,b|0,c|0)|0;b=j[114630];j[114630]=0;if((b|0)==1){break a}a=!a}else{a=0}return a}J(0)|0;C()|0;ib();z()}function Cga(a){var b=0,c=0,d=0,e=0;b=Za-16|0;Za=b;if(Te(a)){while(1){d=Al(a,c);e=Al(a,c);j[b+12>>2]=0;oga(d,(e+2048|0)-d>>2,b+12|0);c=c+1|0;if(Te(a)>>>0>c>>>0){continue}break}}Za=b+16|0}function rla(a){var b=0,c=0,d=0,e=0;d=st(a);b=d&63;a:{if(!(d&64)){break a}c=6;while(1){e=st(a);b=(e&127)<<c|b;if(c>>>0>24){break a}c=c+7|0;if(e&128){continue}break}}return d&128?0-b|0:b}function Xk(a,b){var c=0,d=q(0),e=0;e=i[a+28>>1];c=a+4|0;sb(c);d=q(1);a:{if((b|0)<(e|0)){break a}if((l[a+28>>1]+sb(c)<<16)-65536>>16<(b|0)){break a}d=n[xb(c,b-i[a+28>>1]|0)>>2]}return d}function Qda(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0;f=Za-16|0;Za=f;j[f+8>>2]=j[a+8>>2];g=j[a+4>>2];j[f>>2]=j[a>>2];j[f+4>>2]=g;a=CG(f,b,c,d,0,0,0,0,e);Za=f+16|0;return a|0}function Nra(a){var b=0,c=0,d=0;b=Jra(a)<<24;a=0;while(1){d=b<<1|c>>>31;c=c<<1;b=(b|0)>-1;c=b?c:c^-1798752855;b=b?d:d^-1382821323;a=a+1|0;if((a|0)!=8){continue}break}a=Fra(c,b);return a}function Mda(a,b){var c=0,d=0,e=0;c=Za-32|0;Za=c;d=c,e=Iba(a,b),j[d+24>>2]=e;d=c,e=aj(a),j[d+16>>2]=e;b=0;if(!el(c+24|0,c+16|0)){Hba(a,j[yc(c+8|0,j[c+24>>2])>>2]);b=1}Za=c+32|0;return b}function Lh(a,b){var c=0,d=0;c=k[a|0];d=k[b|0];a:{if(!c|(d|0)!=(c|0)){break a}while(1){d=k[b+1|0];c=k[a+1|0];if(!c){break a}b=b+1|0;a=a+1|0;if((c|0)==(d|0)){continue}break}}return c-d|0}function D5(a,b,c,d){var e=0,f=0;e=Za-16|0;Za=e;f=0;a:{if(!B5(a,c,e+8|0,d,e+4|0,e+12|0)){break a}f=z5(a,b,(p(j[e+12>>2],6)+a|0)+412|0,j[c>>2],j[d>>2],j[e+4>>2],c)}a=f;Za=e+16|0;return a}function By(a,b){var c=0;a:{if(b){By(a,j[b>>2]);By(a,j[b+4>>2]);a=Rb(a);j[114630]=0;F(821,a|0,b+14|0);c=j[114630];j[114630]=0;if((c|0)==1){break a}Ai(a,b,1)}return}J(0)|0;C()|0;ib();z()}function Ak(a){var b=0,c=0;b=j[21348];c=a+3&-4;a=b+c|0;a:{if(a>>>0<=b>>>0?(c|0)>=1:0){break a}if(a>>>0>VMa()<<16>>>0){if(!(Ea(a|0)|0)){break a}}j[21348]=a;return b}j[114604]=48;return-1}function sKa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;d=Za-1968|0;Za=d;c=d+8|0;e=pKa(a,c);if(!e){_R(c)}c=-1;a:{if(!e){break a}c=0;if(!cS(d+8|0)){break a}c=Me(a,b,1024,0)}Za=d+1968|0;return c|0}function poa(a,b){var c=0,d=0,e=0;if(HR(a)>>>0<b>>>0){Oc();z()}hb(a);c=b;if(c>>>0>178956970){oc(20384);z()}c=ac(p(c,24),8);j[a>>2]=c;j[a+4>>2]=c;d=hb(a),e=c+p(b,24)|0,j[d>>2]=e;lt(a,0)}function mDa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=Za-16|0;Za=c;j[c+8>>2]=b;d=c,e=Lb(a),j[d>>2]=e;b=Ks(c+8|0,c);b=j[a>>2]+(b<<2)|0;Lt(a,Pe(b+4|0,j[a+4>>2],b));a=Qe(b);Za=c+16|0;return a|0}function lh(a){var b=0,c=0,d=0,e=0;d=dd(a);b=d&63;a:{if(!(d&64)){break a}c=6;while(1){e=dd(a);b=(e&127)<<c|b;if(c>>>0>24){break a}c=c+7|0;if(e&128){continue}break}}return d&128?0-b|0:b}function lV(a,b){var c=0,d=0,e=0;c=Za-16|0;Za=c;d=c,e=ud(b),j[d+12>>2]=e;j[114630]=0;K(282,a|0,c+12|0,b|0)|0;a=j[114630];j[114630]=0;if((a|0)!=1){Za=c+16|0;return}J(0)|0;C()|0;ib();z()}function Uqa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;a:{if(k[b+30|0]!=4){break a}d=b+31|0;if(k[d|0]&4|k[d|0]&2){break a}Kc(a,8,1,0,11);return}d=a;a=b+31|0;Kc(d,k[a|0]&4?16:8,k[a|0]&2|1,0,c^1)}function LG(a,b){var c=0,d=0,e=0;if(a>q(.9999989867210388)){d=0}else{a=q(a*a);e=+a;c=ge(31415.926535897932/+b);d=Qm((32768-(y((1-c)*+q(a+a)+(c*c-1)*+q(a*a))+c*e)*32768)/(1-e))}return d}function $U(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=Za-32|0;Za=d;j[d+24>>2]=b;_p(j[d+24>>2]);j[d+16>>2]=j[c+8>>2];b=j[c+4>>2];j[d+8>>2]=j[c>>2];j[d+12>>2]=b;_U(a,d+8|0);Za=d+32|0;return a|0}function $5(a,b,c){var d=0,e=0,f=0;while(1){f=d;d=a+d|0;d=(f+Jv(d,c)|0)+co(d)|0;if((d+4|0)>(b|0)){return(e|0)!=0}if(!eo(a,a+d|0)){return 0}e=e+1|0;if((e|0)!=10){continue}break}return 1}function mha(a,b){var c=0,d=0;c=Za-16|0;Za=c;j[c+12>>2]=b;d=b;b=hha(a);if(d>>>0<=b>>>0){a=Ij(a);if(a>>>0<b>>>1>>>0){j[c+8>>2]=a<<1;b=j[Lc(c+8|0,c+12|0)>>2]}Za=c+16|0;return b}Oc();z()}function av(a,b,c,d,e,f,g,h,i){var k=0;k=Za-16|0;Za=k;If(k,b,c,d,e,f,g,h,i^-2147483648);b=j[k+4>>2];j[a>>2]=j[k>>2];j[a+4>>2]=b;b=j[k+12>>2];j[a+8>>2]=j[k+8>>2];j[a+12>>2]=b;Za=k+16|0}function aq(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0;d=j[a>>2];b=(f=d,g=lb(b),h=j[a+8>>2],i=c,e=j[j[d>>2]+28>>2],bb[e](f|0,g|0,h|0,i|0)|0);j[a+8>>2]=b+j[a+8>>2];return b|0}function _Da(a,b){var c=0,d=0;c=Za-16|0;Za=c;j[c+12>>2]=b;d=b;b=UDa(a);if(d>>>0<=b>>>0){a=nl(a);if(a>>>0<b>>>1>>>0){j[c+8>>2]=a<<1;b=j[Lc(c+8|0,c+12|0)>>2]}Za=c+16|0;return b}Oc();z()}function R2(a){var b=0,c=0;b=Za-16|0;Za=b;a:{if(h[461652]&1){break a}if(!fd(461652)){break a}ed(461652)}Cc(b+8|0,1,85380);c=j[b+12>>2];j[a>>2]=j[b+8>>2];j[a+4>>2]=c;Za=b+16|0;return a}function Lxa(a,b){a=a|0;b=b|0;var c=0,d=0;c=zxa(a);a:{if(b){j[114630]=0;F(1012,a|0,b|0);d=j[114630];j[114630]=0;if((d|0)==1){break a}xxa(a,b)}return a|0}a=D()|0;C()|0;Xx(c);G(a|0);z()}function Eya(a,b){var c=0,d=0;c=Za-16|0;Za=c;j[c+12>>2]=b;d=b;b=yya(a);if(d>>>0<=b>>>0){a=Xm(a);if(a>>>0<b>>>1>>>0){j[c+8>>2]=a<<1;b=j[Lc(c+8|0,c+12|0)>>2]}Za=c+16|0;return b}Oc();z()}function Du(a,b,c,d,e){var f=0;f=Eu(a,b,c,d);if(rd(e,d)){Ib(d,e);if(!rd(d,c)){return f+1|0}Ib(c,d);if(!rd(c,b)){return f+2|0}Ib(b,c);if(!rd(b,a)){return f+3|0}Ib(a,b);f=f+4|0}return f}function y8(a,b){var c=0,d=0;c=Za-32|0;Za=c;j[c+24>>2]=b;b=j[c+24>>2];d=j[b+12>>2];j[c+16>>2]=j[b+8>>2];j[c+20>>2]=d;d=j[b+4>>2];j[c+8>>2]=j[b>>2];j[c+12>>2]=d;NEa(a,c+8|0);Za=c+32|0}function u5(){var a=0,b=0,c=0;while(1){b=a<<24;c=0;while(1){b=b>>31&79764919^b<<1;c=c+1|0;if((c|0)!=8){continue}break}j[(a<<2)+457392>>2]=b;a=a+1|0;if((a|0)!=256){continue}break}}



function t8(a,b){var c=0,d=0;c=Za-32|0;Za=c;j[c+24>>2]=b;b=j[c+24>>2];d=j[b+12>>2];j[c+16>>2]=j[b+8>>2];j[c+20>>2]=d;d=j[b+4>>2];j[c+8>>2]=j[b>>2];j[c+12>>2]=d;uEa(a,c+8|0);Za=c+32|0}function jR(a,b){var c=0,d=0;c=Za-16|0;Za=c;j[c+12>>2]=b;d=b;b=tIa(a);if(d>>>0<=b>>>0){a=rl(a);if(a>>>0<b>>>1>>>0){j[c+8>>2]=a<<1;b=j[Lc(c+8|0,c+12|0)>>2]}Za=c+16|0;return b}Oc();z()}function ib(){var a=0;j[114630]=0;a=j[114630];j[114630]=0;a:{if((a|0)!=1){a=j[115935];if(!a){break a}if(!JB(a+48|0)){break a}IB(j[a+12>>2]);z()}J(0)|0;C()|0;ib();z()}IB(j[21346]);z()}function fAa(a,b){var c=0,d=0;c=Za-16|0;Za=c;j[c+12>>2]=b;d=b;b=au(a);if(d>>>0<=b>>>0){a=xi(a);if(a>>>0<b>>>1>>>0){j[c+8>>2]=a<<1;b=j[Lc(c+8|0,c+12|0)>>2]}Za=c+16|0;return b}Oc();z()}function U5(a){var b=0,c=0,d=0;c=a+72|0;while(1){a=1;while(1){b=(a<<2)+c|0;n[b>>2]=-n[b>>2];b=a>>>0<16;a=a+2|0;if(b){continue}break}c=c+144|0;a=d>>>0<30;d=d+2|0;if(a){continue}break}}function MEa(a,b,c){var d=0,e=0;d=Za-16|0;Za=d;e=Qc(d);j[114630]=0;P(694,b|0,a|0,e|0,c|0)|0;a=j[114630];j[114630]=0;if((a|0)!=1){gb(e);Za=d+16|0;return}a=D()|0;C()|0;gb(e);G(a|0);z()}function zI(a,b){var c=0,d=0;c=Za-16|0;Za=c;j[c+12>>2]=b;d=b;b=vI(a);if(d>>>0<=b>>>0){a=Pi(a);if(a>>>0<b>>>1>>>0){j[c+8>>2]=a<<1;b=j[Lc(c+8|0,c+12|0)>>2]}Za=c+16|0;return b}Oc();z()}function yxa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;if(exa()>>>0<b>>>0){Oc();z()}c=b;if(c>>>0>=477218589){oc(17388);z()}c=ac(p(c,9),1);j[a>>2]=c;j[a+4>>2]=c;d=hb(a),e=c+p(b,9)|0,j[d>>2]=e}function ul(a,b){var c=0,d=0;c=Za-16|0;Za=c;j[c+12>>2]=b;d=b;b=lS(a);if(d>>>0<=b>>>0){a=Af(a);if(a>>>0<b>>>1>>>0){j[c+8>>2]=a<<1;b=j[Lc(c+8|0,c+12|0)>>2]}Za=c+16|0;return b}Oc();z()}function ui(a,b){var c=0,d=0;c=Za-16|0;Za=c;j[c+12>>2]=b;d=b;b=pA(a);if(d>>>0<=b>>>0){a=Df(a);if(a>>>0<b>>>1>>>0){j[c+8>>2]=a<<1;b=j[Lc(c+8|0,c+12|0)>>2]}Za=c+16|0;return b}Oc();z()}function ie(a,b){var c=0,d=0;c=Za-16|0;Za=c;j[c+12>>2]=b;d=b;b=Mm(a);if(d>>>0<=b>>>0){a=jd(a);if(a>>>0<b>>>1>>>0){j[c+8>>2]=a<<1;b=j[Lc(c+8|0,c+12|0)>>2]}Za=c+16|0;return b}Oc();z()}function hk(a,b){var c=0,d=0;c=Za-16|0;Za=c;j[c+12>>2]=b;d=b;b=HR(a);if(d>>>0<=b>>>0){a=Be(a);if(a>>>0<b>>>1>>>0){j[c+8>>2]=a<<1;b=j[Lc(c+8|0,c+12|0)>>2]}Za=c+16|0;return b}Oc();z()}function gq(a,b){var c=0,d=0;c=Za-16|0;Za=c;j[c+12>>2]=b;d=b;b=fq(a);if(d>>>0<=b>>>0){a=Ah(a);if(a>>>0<b>>>1>>>0){j[c+8>>2]=a<<1;b=j[Lc(c+8|0,c+12|0)>>2]}Za=c+16|0;return b}Oc();z()}function fm(a,b){var c=0,d=0;c=Za-16|0;Za=c;j[c+12>>2]=b;d=b;b=PD(a);if(d>>>0<=b>>>0){a=Vf(a);if(a>>>0<b>>>1>>>0){j[c+8>>2]=a<<1;b=j[Lc(c+8|0,c+12|0)>>2]}Za=c+16|0;return b}Oc();z()}function cZ(){var a=0;a:{if(h[463112]&1){break a}if(!fd(463112)){break a}a=463088;while(1){a=Cb(a)+12|0;if((a|0)!=463112){continue}break}ed(463112)}vc(463088,70504);vc(463100,70507)}function Vma(a){a=a|0;var b=0;b=1;a=j[a+480180>>2];a:{b:{if((a|0)<=16383){if((a|0)==4|(a|0)!=32){break b}break a}if((a|0)==16384){break b}if((a|0)==16777216){break a}}b=2}return b|0}function Tga(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0;c=Za-16|0;Za=c;a=Mi(a);d=1;a:{if(!a){break a}d=(f=a,g=ah(c+8|0,b),e=j[j[a>>2]+72>>2],bb[e](f|0,g|0)|0)}a=d;Za=c+16|0;return a|0}function Ly(a,b){var c=0,d=0;c=Za-16|0;Za=c;j[c+12>>2]=b;d=b;b=oz(a);if(d>>>0<=b>>>0){a=ki(a);if(a>>>0<b>>>1>>>0){j[c+8>>2]=a<<1;b=j[Lc(c+8|0,c+12|0)>>2]}Za=c+16|0;return b}Oc();z()}function LKa(a,b){var c=0,d=0,e=0;c=Za-16|0;Za=c;d=yb(a,120);a:{if(d){e=Za-16|0;Za=e;Qb(c+8|0,b,120);Za=e+16|0;qd(a,c+8|0);break a}a=Za-16|0;Za=a;tKa(b);Za=a+16|0}Za=c+16|0;return d}function Hl(a,b){var c=0,d=0;c=Za-16|0;Za=c;j[c+12>>2]=b;d=b;b=UA(a);if(d>>>0<=b>>>0){a=Zg(a);if(a>>>0<b>>>1>>>0){j[c+8>>2]=a<<1;b=j[Lc(c+8|0,c+12|0)>>2]}Za=c+16|0;return b}Oc();z()}function GG(a,b,c,d,e){a=a|0;b=b|0;c=+c;d=d|0;e=e|0;var f=0,g=0;f=Za-16|0;Za=f;j[f+8>>2]=j[a+8>>2];g=j[a+4>>2];j[f>>2]=j[a>>2];j[f+4>>2]=g;c=FG(f,b,c,d,e,0,0,0,0);Za=f+16|0;return+c}function FDa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=Za-16|0;Za=d;j[d+12>>2]=c;c=0;a=bb[j[j[a>>2]+24>>2]](a)|0;if(a>>>0>b>>>0){j[d+8>>2]=a-b;c=j[tb(d+12|0,d+8|0)>>2]}Za=d+16|0;return c|0}function EY(a,b){var c=0,d=0;c=Za-16|0;Za=c;j[c+12>>2]=b;d=b;b=bC(a);if(d>>>0<=b>>>0){a=Dk(a);if(a>>>0<b>>>1>>>0){j[c+8>>2]=a<<1;b=j[Lc(c+8|0,c+12|0)>>2]}Za=c+16|0;return b}Oc();z()}function $la(a,b,c,d){var e=0,f=0;_la(a,b,d);if((b|0)!=(c|0)){f=b-a>>1;e=b;while(1){if(po(d,l[e>>1],l[a>>1])){jJ(e,a);Qw(a,d,f,a)}e=e+2|0;if((e|0)!=(c|0)){continue}break}}Yla(a,b,d)}function $Y(){var a=0;a:{if(h[463144]&1){break a}if(!fd(463144)){break a}a=463120;while(1){a=Le(a)+12|0;if((a|0)!=463144){continue}break}ed(463144)}Ic(463120,70512);Ic(463132,70524)}function sAa(a,b){var c=0,d=0;c=Za-16|0;Za=c;d=Za-16|0;Za=d;Qb(c+8|0,b,1030);Za=d+16|0;b=pb(c+8|0);d=Xb(a,Kb(c,c+8|0));if((b|0)==(d|0)){Jb(a,pb(c+8|0))}Za=c+16|0;return(b|0)==(d|0)}function rGa(a,b){a=a|0;b=b|0;var c=0;c=Za-32|0;Za=c;j[c+24>>2]=0;j[c+28>>2]=0;j[c+16>>2]=0;j[c+20>>2]=0;j[c+8>>2]=0;j[c+12>>2]=0;j[c>>2]=0;j[c+4>>2]=0;wQ(b,c,32);vQ(a,c);Za=c+32|0}function q8(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;if((b|0)!=(c|0)){a=j[d>>2];while(1){j[a>>2]=j[b>>2];Cf(a+4|0,b+4|0);a=j[d>>2]+16|0;j[d>>2]=a;b=b+16|0;if((c|0)!=(b|0)){continue}break}}}function dV(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;e=Za-32|0;Za=e;j[e+24>>2]=d;j[e+28>>2]=c;cV(e+8|0,b,e+28|0,e+24|0);Xt(e+16|0,e+8|0);Jl(a,e+16|0);jb(e+16|0);jb(e+8|0);Za=e+32|0}function VI(a){var b=0;a:{if((k[a|0]|k[a+1|0]<<8|(k[a+2|0]<<16|k[a+3|0]<<24))!=1179012417){b=0;if((k[a|0]|k[a+1|0]<<8|(k[a+2|0]<<16|k[a+3|0]<<24))!=538987841){break a}}b=1}return b}function IGa(a,b){a=a|0;b=b|0;var c=0;c=Za-16|0;Za=c;ws(c,b);j[114630]=0;I(646,a|0,4,c|0);a=j[114630];j[114630]=0;if((a|0)!=1){gb(c);Za=c+16|0;return}a=D()|0;C()|0;gb(c);G(a|0);z()}function GB(a,b,c,d){var e=0,f=0,g=0,h=0;f=j[a+4>>2];a=j[a>>2];g=a;h=b;e=0;a:{if(!c){break a}b=f>>8;e=b;if(!(f&1)){break a}e=j[b+j[c>>2]>>2]}bb[j[j[a>>2]+28>>2]](g,h,e+c|0,f&2?d:2)}function FI(a,b){var c=0,d=0;d=a;c=b;if((a|0)!=(b|0)){_ja(d,j[c>>2],j[c+4>>2])}j[a+12>>2]=j[b+12>>2];j[a+16>>2]=j[b+16>>2];j[a+20>>2]=j[b+20>>2];EI(a+24|0,b+24|0);zi(a+36|0,b+36|0)}function t5(a){a=a|0;var b=0,c=0;b=Za-16|0;Za=b;Oi(b,0,a);j[114630]=0;a=H(202,b|0)|0;c=j[114630];j[114630]=0;if((c|0)!=1){gb(b);Za=b+16|0;return a|0}a=D()|0;C()|0;gb(b);G(a|0);z()}function rka(a,b){var c=0,d=0;c=Za-16|0;Za=c;d=Za-16|0;Za=d;Qb(c+8|0,b,225);Za=d+16|0;b=pb(c+8|0);d=Xb(a,Kb(c,c+8|0));if((b|0)==(d|0)){Jb(a,pb(c+8|0))}Za=c+16|0;return(b|0)==(d|0)}function qka(a,b){var c=0,d=0;c=Za-16|0;Za=c;d=Za-16|0;Za=d;Qb(c+8|0,b,326);Za=d+16|0;b=pb(c+8|0);d=Xb(a,Kb(c,c+8|0));if((b|0)==(d|0)){Jb(a,pb(c+8|0))}Za=c+16|0;return(b|0)==(d|0)}function qAa(a,b){var c=0,d=0;c=Za-16|0;Za=c;d=Za-16|0;Za=d;Qb(c+8|0,b,274);Za=d+16|0;b=pb(c+8|0);d=Xb(a,Kb(c,c+8|0));if((b|0)==(d|0)){Jb(a,pb(c+8|0))}Za=c+16|0;return(b|0)==(d|0)}function oAa(a,b){var c=0,d=0;c=Za-16|0;Za=c;d=Za-16|0;Za=d;Qb(c+8|0,b,106);Za=d+16|0;b=pb(c+8|0);d=Xb(a,Kb(c,c+8|0));if((b|0)==(d|0)){Jb(a,pb(c+8|0))}Za=c+16|0;return(b|0)==(d|0)}function kFa(a,b){var c=0,d=0;c=Za-16|0;Za=c;d=Za-16|0;Za=d;Qb(c+8|0,b,554);Za=d+16|0;b=pb(c+8|0);d=Xb(a,Kb(c,c+8|0));if((b|0)==(d|0)){Jb(a,pb(c+8|0))}Za=c+16|0;return(b|0)==(d|0)}function jHa(a,b){var c=0,d=0;c=Za-16|0;Za=c;d=Za-16|0;Za=d;Qb(c+8|0,b,771);Za=d+16|0;b=pb(c+8|0);d=Xb(a,Kb(c,c+8|0));if((b|0)==(d|0)){Jb(a,pb(c+8|0))}Za=c+16|0;return(b|0)==(d|0)}function fw(a){a=a|0;var b=0;a:{if(!a){a=R(8)|0;j[114630]=0;H(2023,a|0)|0;b=j[114630];j[114630]=0;if((b|0)!=1){break a}b=D()|0;C()|0;S(a|0);G(b|0);z()}return}X(a|0,83544,2012);z()}function dR(a){var b=0;b=Za-16|0;Za=b;h[a|0]=0;h[a+1|0]=0;h[a+2|0]=0;h[a+3|0]=0;h[a+4|0]=0;h[a+5|0]=0;h[a+6|0]=0;h[a+7|0]=0;h[a+8|0]=0;h[a+9|0]=0;h[a+10|0]=0;h[a+11|0]=0;Za=b+16|0}function b0(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;c=Za-128|0;Za=c;j[c+12>>2]=c+116;TC(a+8|0,c+16|0,c+12|0,e,f,g);a=vY(c+16|0,j[c+12>>2],b);Za=c+128|0;return a|0}function UGa(a,b){var c=0,d=0;c=Za-16|0;Za=c;d=Za-16|0;Za=d;Qb(c+8|0,b,384);Za=d+16|0;b=pb(c+8|0);d=Xb(a,Kb(c,c+8|0));if((b|0)==(d|0)){Jb(a,pb(c+8|0))}Za=c+16|0;return(b|0)==(d|0)}function OCa(a,b){var c=0,d=0;c=Za-16|0;Za=c;d=Za-16|0;Za=d;Qb(c+8|0,b,284);Za=d+16|0;b=pb(c+8|0);d=Xb(a,Kb(c,c+8|0));if((b|0)==(d|0)){Jb(a,pb(c+8|0))}Za=c+16|0;return(b|0)==(d|0)}function JBa(a,b){var c=0,d=0;c=Za-16|0;Za=c;d=Za-16|0;Za=d;Qb(c+8|0,b,422);Za=d+16|0;b=pb(c+8|0);d=Xb(a,Kb(c,c+8|0));if((b|0)==(d|0)){Jb(a,pb(c+8|0))}Za=c+16|0;return(b|0)==(d|0)}function IJa(a,b){var c=0,d=0;c=Za-16|0;Za=c;d=Za-16|0;Za=d;Qb(c+8|0,b,136);Za=d+16|0;b=pb(c+8|0);d=Xb(a,Kb(c,c+8|0));if((b|0)==(d|0)){Jb(a,pb(c+8|0))}Za=c+16|0;return(b|0)==(d|0)}function GBa(a,b){var c=0,d=0;c=Za-16|0;Za=c;d=Za-16|0;Za=d;Qb(c+8|0,b,826);Za=d+16|0;b=pb(c+8|0);d=Xb(a,Kb(c,c+8|0));if((b|0)==(d|0)){Jb(a,pb(c+8|0))}Za=c+16|0;return(b|0)==(d|0)}function AG(a){a=a|0;var b=0;a:{if(!a){a=R(8)|0;j[114630]=0;H(2011,a|0)|0;b=j[114630];j[114630]=0;if((b|0)!=1){break a}b=D()|0;C()|0;S(a|0);G(b|0);z()}return}X(a|0,83532,2012);z()}function $$(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;c=Za-416|0;Za=c;j[c+12>>2]=c+416;_$(a+8|0,c+16|0,c+12|0,e,f,g);a=uY(c+16|0,j[c+12>>2],b);Za=c+416|0;return a|0}function zDa(a,b){var c=0,d=0;c=Za-16|0;Za=c;d=Za-16|0;Za=d;Qb(c+8|0,b,91);Za=d+16|0;b=pb(c+8|0);d=Xb(a,Kb(c,c+8|0));if((b|0)==(d|0)){Jb(a,pb(c+8|0))}Za=c+16|0;return(b|0)==(d|0)}function yHa(a,b){var c=0,d=0;c=Za-16|0;Za=c;d=Za-16|0;Za=d;Qb(c+8|0,b,34);Za=d+16|0;b=pb(c+8|0);d=Xb(a,Kb(c,c+8|0));if((b|0)==(d|0)){Jb(a,pb(c+8|0))}Za=c+16|0;return(b|0)==(d|0)}function xJa(a,b){var c=0,d=0;c=Za-16|0;Za=c;d=Za-16|0;Za=d;Qb(c+8|0,b,50);Za=d+16|0;b=pb(c+8|0);d=Xb(a,Kb(c,c+8|0));if((b|0)==(d|0)){Jb(a,pb(c+8|0))}Za=c+16|0;return(b|0)==(d|0)}function xDa(a,b){var c=0,d=0;c=Za-16|0;Za=c;d=Za-16|0;Za=d;Qb(c+8|0,b,18);Za=d+16|0;b=pb(c+8|0);d=Xb(a,Kb(c,c+8|0));if((b|0)==(d|0)){Jb(a,pb(c+8|0))}Za=c+16|0;return(b|0)==(d|0)}function xCa(a,b){var c=0,d=0;c=Za-16|0;Za=c;d=Za-16|0;Za=d;Qb(c+8|0,b,42);Za=d+16|0;b=pb(c+8|0);d=Xb(a,Kb(c,c+8|0));if((b|0)==(d|0)){Jb(a,pb(c+8|0))}Za=c+16|0;return(b|0)==(d|0)}function tza(a,b){var c=0,d=0;c=Za-16|0;Za=c;d=Za-16|0;Za=d;Qb(c+8|0,b,71);Za=d+16|0;b=pb(c+8|0);d=Xb(a,Kb(c,c+8|0));if((b|0)==(d|0)){Jb(a,pb(c+8|0))}Za=c+16|0;return(b|0)==(d|0)}function ska(a,b){var c=0,d=0;c=Za-16|0;Za=c;d=Za-16|0;Za=d;Qb(c+8|0,b,73);Za=d+16|0;b=pb(c+8|0);d=Xb(a,Kb(c,c+8|0));if((b|0)==(d|0)){Jb(a,pb(c+8|0))}Za=c+16|0;return(b|0)==(d|0)}function pka(a,b){var c=0,d=0;c=Za-16|0;Za=c;d=Za-16|0;Za=d;Qb(c+8|0,b,60);Za=d+16|0;b=pb(c+8|0);d=Xb(a,Kb(c,c+8|0));if((b|0)==(d|0)){Jb(a,pb(c+8|0))}Za=c+16|0;return(b|0)==(d|0)}function pMa(a,b){var c=0,d=0;c=Za-16|0;Za=c;d=Za-16|0;Za=d;Qb(c+8|0,b,25);Za=d+16|0;b=pb(c+8|0);d=Xb(a,Kb(c,c+8|0));if((b|0)==(d|0)){Jb(a,pb(c+8|0))}Za=c+16|0;return(b|0)==(d|0)}function nAa(a,b){var c=0,d=0;c=Za-16|0;Za=c;d=Za-16|0;Za=d;Qb(c+8|0,b,72);Za=d+16|0;b=pb(c+8|0);d=Xb(a,Kb(c,c+8|0));if((b|0)==(d|0)){Jb(a,pb(c+8|0))}Za=c+16|0;return(b|0)==(d|0)}function my(a,b){var c=0,d=0,e=0,f=0,g=0,h=0,i=0;c=Za-16|0;Za=c;d=a,e=(g=a,h=j[a+12>>2],i=Kb(c+8|0,b),f=j[j[a>>2]+32>>2],bb[f](g|0,h|0,i|0)|0)+j[a+12>>2]|0,j[d+12>>2]=e;Za=c+16|0}function kAa(a,b){var c=0,d=0;c=Za-16|0;Za=c;d=Za-16|0;Za=d;Qb(c+8|0,b,26);Za=d+16|0;b=pb(c+8|0);d=Xb(a,Kb(c,c+8|0));if((b|0)==(d|0)){Jb(a,pb(c+8|0))}Za=c+16|0;return(b|0)==(d|0)}function iS(a){var b=0;b=Za-16|0;Za=b;h[a|0]=0;h[a+1|0]=0;h[a+2|0]=0;h[a+3|0]=0;h[a+4|0]=0;h[a+5|0]=0;h[a+6|0]=0;h[a+7|0]=0;h[a+7|0]=0;h[a+8|0]=0;h[a+9|0]=0;h[a+10|0]=0;Za=b+16|0}function cHa(a,b){var c=0,d=0;c=Za-16|0;Za=c;d=Za-16|0;Za=d;Qb(c+8|0,b,62);Za=d+16|0;b=pb(c+8|0);d=Xb(a,Kb(c,c+8|0));if((b|0)==(d|0)){Jb(a,pb(c+8|0))}Za=c+16|0;return(b|0)==(d|0)}function Zwa(a,b){var c=0;c=zs(a);h[a+16|0]=0;i[a+14>>1]=0;i[a+12>>1]=b;j[114630]=0;I(1024,c|0,b|0,0);b=j[114630];j[114630]=0;if((b|0)!=1){return a}a=D()|0;C()|0;Vd(c);G(a|0);z()}function GLa(a,b){var c=0,d=0;c=Za-16|0;Za=c;d=Za-16|0;Za=d;Qb(c+8|0,b,37);Za=d+16|0;b=pb(c+8|0);d=Xb(a,Kb(c,c+8|0));if((b|0)==(d|0)){Jb(a,pb(c+8|0))}Za=c+16|0;return(b|0)==(d|0)}function Bta(a,b){var c=0;a:{if(k[a+4|0]){c=j[a>>2];j[114630]=0;F(821,c|0,b+14|0);c=j[114630];j[114630]=0;if((c|0)==1){break a}}if(b){Ai(j[a>>2],b,1)}return}J(0)|0;C()|0;ib();z()}function AKa(a,b){var c=0,d=0;c=Za-16|0;Za=c;d=Za-16|0;Za=d;Qb(c+8|0,b,17);Za=d+16|0;b=pb(c+8|0);d=Xb(a,Kb(c,c+8|0));if((b|0)==(d|0)){Jb(a,pb(c+8|0))}Za=c+16|0;return(b|0)==(d|0)}function AHa(a,b){var c=0,d=0;c=Za-16|0;Za=c;d=Za-16|0;Za=d;Qb(c+8|0,b,15);Za=d+16|0;b=pb(c+8|0);d=Xb(a,Kb(c,c+8|0));if((b|0)==(d|0)){Jb(a,pb(c+8|0))}Za=c+16|0;return(b|0)==(d|0)}function n_(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;while(1){a:{if((c|0)!=(d|0)){if(m[c>>2]>127){break a}if(!(l[Qn()+(j[c>>2]<<1)>>1]&b)){break a}}else{c=d}return c|0}c=c+4|0;continue}}function jV(a,b){var c=0,d=0;c=Za-16|0;Za=c;d=Za-16|0;Za=d;Qb(c+8|0,b,20);Za=d+16|0;b=pb(c+8|0);d=Xb(a,Kb(c,c+8|0));if((b|0)==(d|0)){Jb(a,pb(c+8|0))}Za=c+16|0;return(b|0)==(d|0)}function hBa(a,b){var c=0,d=0;c=Za-16|0;Za=c;if(qe(a)){Yf(a,j[a>>2],Mj(a))}j[a+8>>2]=j[b+8>>2];d=j[b+4>>2];j[a>>2]=j[b>>2];j[a+4>>2]=d;Ue(b,0);h[c+15|0]=0;Sd(b,c+15|0);Za=c+16|0}function aya(a){var b=0,c=0;b=Za-16|0;Za=b;if(kN(a,b+8|0)){a=b+8|0;a=k[a|0]|k[a+1|0]<<8|(k[a+2|0]<<16|k[a+3|0]<<24);c=a<<24|a<<8&16711680|(a>>>8&65280|a>>>24)}Za=b+16|0;return c}function _N(a){var b=0;a:{if((k[a|0]|k[a+1|0]<<8|(k[a+2|0]<<16|k[a+3|0]<<24))!=441273424|k[a+5|0]!=16){break a}b=a+54|0;if(!k[b|0]|k[b|0]>32){break a}return k[a+4|0]>95}return 0}function W2(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=Za-16|0;Za=d;e=j[c+4>>2];c=j[c>>2];j[d>>2]=c;j[d+4>>2]=e;j[d+8>>2]=c;j[d+12>>2]=e;aE(a,d,b);j[a>>2]=59044;Za=d+16|0;return a|0}function N0(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0;g=Za-16|0;Za=g;j[g+8>>2]=624576549;j[g+12>>2]=1394948685;a=Gi(a,b,c,d,e,f,g+8|0,g+16|0);Za=g+16|0;return a|0}function Ej(a,b,c){var d=0;d=Za-16|0;Za=d;j[d+8>>2]=c;a:{if((a|0)==(b|0)){break a}while(1){if(K8(d+8|0,a)){break a}a=a+8|0;if((b|0)!=(a|0)){continue}break}a=b}Za=d+16|0;return a}function AM(a,b){var c=0;c=k[a+822|0];a:{if(c){break a}c=bj(k[a+819|0]-j[a+772>>2]|0);if(!b|!c|(!j[a+656>>2]|c>>>0>=129)){break a}c=k[Pb(j[a+656>>2]+108|0,c-1|0)|0]}return c&255}function xz(a){var b=0,c=0;b=Za-16|0;Za=b;if(Xp(a,b+8|0)){a=b+8|0;a=k[a|0]|k[a+1|0]<<8|(k[a+2|0]<<16|k[a+3|0]<<24);c=a<<24|a<<8&16711680|(a>>>8&65280|a>>>24)}Za=b+16|0;return c}function rya(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;d=Za-608|0;Za=d;c=d;e=mya(a,d);if(!e){rN(c)}c=-1;a:{if(!e){break a}c=0;if(!tN(d)){break a}c=Me(a,b,sN(d),ab)}Za=d+608|0;return c|0}function pv(a,b){var c=0;c=or(a+4|0);j[a>>2]=58868;j[c>>2]=58888;j[114630]=0;F(2307,j[14714]+a|0,b|0);a=j[114630];j[114630]=0;if((a|0)!=1){return}a=D()|0;C()|0;og(c);G(a|0);z()}function ov(a,b){var c=0;c=jE(a+4|0);j[a>>2]=58916;j[c>>2]=58936;j[114630]=0;F(2308,j[14726]+a|0,b|0);a=j[114630];j[114630]=0;if((a|0)!=1){return}a=D()|0;C()|0;og(c);G(a|0);z()}function mCa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=Za-16|0;Za=d;e=WO(d,b);b=Za-16|0;Za=b;KBa(d+8|0,WO(b,e));Za=b+16|0;fu(a,d+8|0);j[a+12>>2]=c;j[a+8>>2]=0;Za=d+16|0;return a|0}function gta(a,b){a=a|0;b=b|0;var c=0;fta(a);c=a;h[a+16|0]=0;j[a+12>>2]=b;j[114630]=0;N(1169,a|0);b=j[114630];j[114630]=0;if((b|0)!=1){return a|0}a=D()|0;C()|0;hs(c);G(a|0);z()}function dFa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=Za-16|0;Za=d;j[d+12>>2]=c;Sy(a,b,c);c=0;a=j[a+16>>2];if(a>>>0>b>>>0){j[d+8>>2]=a-b;c=j[tb(d+8|0,d+12|0)>>2]}Za=d+16|0;return c|0}function d6(a,b){var c=0,d=0,e=0,f=0,g=0;d=j[b+8>>2]>>>3|0;e=j[b+4>>2]+7>>>3|0;c=d-e|0;f=(c|0)>511;g=f?511:c;if((c|0)>=1){Ci(a+6156|0,((f?d-511|0:e)+b|0)+12|0,g)}j[a+6144>>2]=g}function cf(a,b){a=a|0;b=b|0;var c=0,d=0;c=Za-16|0;Za=c;i[c+14>>1]=0;a=zk(a,c+14|0,2);i[c+12>>1]=l[c+14>>1];d=b;b=c+12|0;i[d>>1]=k[b|0]|k[b+1|0]<<8;Za=c+16|0;return!ab&(a|0)==2}function bHa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;d=Za-576|0;Za=d;c=d;e=WGa(a,d);if(!e){IQ(c)}c=-1;a:{if(!e){break a}c=0;if(!MQ(d)){break a}c=Me(a,b,LQ(d),ab)}Za=d+576|0;return c|0}function X4(a,b){var c=0,d=0,e=0,f=0;if((a|0)>=8){c=a>>3;c=(c|0)>1?c:1;d=36-Sk(a)|0;a=0;while(1){e=(a<<1)+b|0,f=Pk(a)>>>d<<2,i[e>>1]=f;a=a+1|0;if((c|0)!=(a|0)){continue}break}}}function W3(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=Za-16|0;Za=d;bb[j[j[a>>2]+12>>2]](d+8|0,a,b);a=d+8|0;if(ce(j[a+4>>2],j[c+4>>2])){a=j[a>>2]==j[c>>2]}else{a=0}Za=d+16|0;return a|0}function Mza(a,b,c,d){var e=0;e=Za-48|0;Za=e;a:{if(j[b+4>>2]==j[d+4>>2]){Lza(a,vd(e+40|0,b),vd(e+32|0,c),vd(e+24|0,d));break a}Kza(a,vd(e+16|0,b),vd(e+8|0,c),vd(e,d))}Za=e+48|0}function MGa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;d=Za-192|0;Za=d;c=d;e=iFa(a,d);if(!e){dQ(c)}c=-1;a:{if(!e){break a}c=0;if(!GQ(d)){break a}c=Me(a,b,FQ(d),ab)}Za=d+192|0;return c|0}function Ku(a,b){var c=0,d=0;c=Za-16|0;Za=c;i[b>>1]=0;h[c+15|0]=0;Dg(a,c+15|0);d=k[c+15|0];i[b>>1]=d>>>1;if(d&1){h[c+15|0]=0;Dg(a,c+15|0);i[b>>1]=l[b>>1]|k[c+15|0]<<7}Za=c+16|0}function yI(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=65535;a:{if(!tg(a,b)){break a}c=ww(a,j[te(a,b)+12>>2],c);d=65535;if((c|0)==65535){break a}b=te(a,b);FI(te(a,c),b);d=c}return d|0}function Yia(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0;d=Za-16|0;Za=d;e=l[a+28>>1];i[d+8>>1]=e;f=d,g=(sb(a+4|0)+e|0)-1|0,i[f+10>>1]=g;a=oI(a,b,c,d+8|0);Za=d+16|0;return a|0}function P9(a,b){var c=0,d=0,e=0,f=0;c=V6(a,hb(b));j[a>>2]=j[b>>2];j[a+4>>2]=j[b+4>>2];d=j[hb(b)>>2];e=hb(c),f=d,j[e>>2]=f;e=hb(b),f=0,j[e>>2]=f;j[b>>2]=0;j[b+4>>2]=0;return a}function G$(a,b){var c=0,d=0;c=Za-16|0;Za=c;if(qe(a)){On(j[a>>2],Mj(a))}j[a+8>>2]=j[b+8>>2];d=j[b+4>>2];j[a>>2]=j[b>>2];j[a+4>>2]=d;Ue(b,0);j[c+12>>2]=0;ye(b,c+12|0);Za=c+16|0}function A7(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;e=Za-16|0;Za=e;IF(b,c,d,n[a+24>>2]);CF(a,b,c,d);j[e+8>>2]=j[a+20>>2];b=j[a+16>>2];j[e>>2]=j[a+12>>2];j[e+4>>2]=b;Za=e+16|0}function zY(a,b){var c=0;a:{while(1){if(j[a+8>>2]==(b|0)){break a}j[a+8>>2]=j[a+8>>2]-4;j[114630]=0;c=j[114630];j[114630]=0;if((c|0)!=1){continue}break}J(0)|0;C()|0;ib();z()}}function rba(a){var b=0,c=0;b=Za-32|0;Za=b;xk(b);c=Ag(b);j[114630]=0;I(9,a|0,0,c|0);a=j[114630];j[114630]=0;if((a|0)!=1){Ie(b);Za=b+32|0;return}a=D()|0;C()|0;Ie(b);G(a|0);z()}function mP(a){var b=0;b=j[a+4>>2];if(!b){if(!Rg(a)){while(1){a=j[a+8>>2];if(!Rg(a)){continue}break}}return j[a+8>>2]}a=b;while(1){b=a;a=j[a>>2];if(a){continue}break}return b}function U3(a,b){var c=0,d=0,e=0;c=Za-1040|0;Za=c;e=j[114604];d=T3(_3(b,c+16|0),c+16|0);if(!k[d|0]){j[c>>2]=b;kv(c+16|0,1024,58612,c);d=c+16|0}j[114604]=e;Db(a,d);Za=c+1040|0}function Twa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;d=Za-80|0;Za=d;c=d;e=xwa(a,d);if(!e){_P(c)}c=-1;a:{if(!e){break a}c=0;if(!UM(d)){break a}c=Me(a,b,TM(d),ab)}Za=d+80|0;return c|0}function Lw(a,b){a:{if(b){Lw(a,j[b>>2]);Lw(a,j[b+4>>2]);a=Rb(a);j[114630]=0;F(1520,a|0,b+16|0);a=j[114630];j[114630]=0;if((a|0)==1){break a}bJ(b)}return}J(0)|0;C()|0;ib();z()}function Cea(a){a=a|0;var b=0,c=q(0);h[a+4202|0]=1;b=a,c=Jm(q(q(q(we(j[a+16>>2])>>>0)*q(20938023226335645e-21))+q(-.005025125574320555)),q(0),q(1)),n[b+4272>>2]=c;UG(a);TG(a)}function qL(a,b,c){var d=0;d=Za-16|0;Za=d;j[d+12>>2]=c;if(l[a+28>>1]!=(b|0)){bs(a+12|0);i[a+28>>1]=b}c=a+12|0;if(Xc(c)){sL(c,zx(a,l[bc(Jo(a),b)>>1]))}kra(c,d+12|0);Za=d+16|0}function PAa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;d=Za-128|0;Za=d;c=d;e=vAa(a,d);if(!e){oO(c)}c=-1;a:{if(!e){break a}c=0;if(!tO(d)){break a}c=Me(a,b,256,0)}Za=d+128|0;return c|0}function tB(a){var b=0;a:{if(!(m[a>>2]<=18285140|m[a>>2]>=18350592)){b=1;if(j[a>>2]!=18350080){break a}}a=j[a>>2];b=0;if(a>>>0<=18350592){break a}b=(a|0)!=(a&-256)}return b}function osa(a){var b=0,c=0;b=Za-16|0;Za=b;j[114630]=0;j[b+12>>2]=0;K(1193,a|0,b+12|0,b+8|0)|0;c=j[114630];j[114630]=0;if((c|0)!=1){Za=b+16|0;return a}J(0)|0;C()|0;ib();z()}function mC(a){a=a|0;var b=0,c=0;j[a>>2]=64720;b=a+16|0;while(1){if(sb(b)>>>0>c>>>0){if(j[xb(b,c)>>2]){Kl(j[xb(b,c)>>2])}c=c+1|0;continue}break}gb(a+176|0);BC(b);return a|0}function dI(a,b){var c=0,d=0,e=0;c=Za-16|0;Za=c;d=yc(c+8|0,b);Ms(d);if(j[a>>2]==(b|0)){j[a>>2]=j[d>>2]}e=hb(a);j[e>>2]=j[e>>2]-1;kia(j[Rb(a)>>2],b);Za=c+16|0;return j[d>>2]}function XQ(a){a:{if((k[a|0]|k[a+1|0]<<8|(k[a+2|0]<<16|k[a+3|0]<<24))!=-28163770){break a}if(_c(a+44|0,12960,3)){break a}a=a+47|0;return(k[a|0]|k[a+1|0]<<8)>>>0>97}return 0}function Vya(a,b){a=a|0;b=b|0;var c=0,d=0;c=1;d=a;a=b+47|0;b=Kc(d,k[a|0]&4?16:8,1,0,0);a:{b:{if(k[a|0]&8){break b}c=2;if(k[a|0]&16){break b}if(k[a|0]&127){break a}}ej(b,c)}}function Pna(a){var b=0,c=0;b=Za-16|0;Za=b;j[114630]=0;j[b+12>>2]=0;K(1395,a|0,b+12|0,b+8|0)|0;c=j[114630];j[114630]=0;if((c|0)!=1){Za=b+16|0;return a}J(0)|0;C()|0;ib();z()}function Ona(a){var b=0,c=0;b=Za-16|0;Za=b;j[114630]=0;j[b+12>>2]=0;K(1396,a|0,b+12|0,b+8|0)|0;c=j[114630];j[114630]=0;if((c|0)!=1){Za=b+16|0;return a}J(0)|0;C()|0;ib();z()}function Nfa(a,b,c){var d=0;d=Za-16|0;Za=d;aga(d,b,c);j[114630]=0;I(13,a|0,0,d|0);a=j[114630];j[114630]=0;if((a|0)!=1){gb(d);Za=d+16|0;return}a=D()|0;C()|0;gb(d);G(a|0);z()}function JQ(a,b){var c=0;c=Za-32|0;Za=c;j[c+24>>2]=a;j[c+28>>2]=b;j[c+16>>2]=0;j[c+20>>2]=0;j[c+8>>2]=-1;j[c+12>>2]=0;a=EQ(c+16|0,cz(c+24|0,c+8|0));Za=c+32|0;return j[a>>2]}function Gaa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;Cc(a+12|0,0,0);d=a+20|0;c=d;e=c+16|0;while(1){c=dk(c)+4|0;if((e|0)!=(c|0)){continue}break}AJ(d+16|0,b);j[a+40>>2]=1;return a|0}function Dra(a,b){var c=0,d=0;c=Za-16|0;Za=c;j[c>>2]=b;j[c+8>>2]=a;if(rb(c+8|0,c)){while(1){d=o[j[c+8>>2]>>3]+d;Cx(c+8|0);if(rb(c+8|0,c)){continue}break}}Za=c+16|0;return d}function zfa(a,b,c){var d=0;d=Za-16|0;Za=d;tr(d,b,c);j[114630]=0;I(13,a|0,0,d|0);a=j[114630];j[114630]=0;if((a|0)!=1){gb(d);Za=d+16|0;return}a=D()|0;C()|0;gb(d);G(a|0);z()}function qia(a,b,c,d){var e=0,f=0;e=Za-16|0;Za=e;if(c){while(1){f=yr(hb(a),c+16|0,b);d=f?d:c;c=j[(f?4:0)+c>>2];if(c){continue}break}}a=j[yc(e+8|0,d)>>2];Za=e+16|0;return a}function pFa(a,b,c,d){var e=0,f=0;e=Za-16|0;Za=e;if(c){while(1){f=bn(hb(a),c+16|0,b);d=f?d:c;c=j[(f?4:0)+c>>2];if(c){continue}break}}a=j[yc(e+8|0,d)>>2];Za=e+16|0;return a}function gp(a){var b=0,c=0;c=j[a+4>>2];b=j[c>>2];j[a+4>>2]=b;if(b){an(b,a)}j[c+8>>2]=j[a+8>>2];a:{if(Rg(a)){b=j[a+8>>2];break a}b=j[a+8>>2]+4|0}j[b>>2]=c;j[c>>2]=a;an(a,c)}function fp(a){var b=0,c=0;c=j[a>>2];b=j[c+4>>2];j[a>>2]=b;if(b){an(b,a)}j[c+8>>2]=j[a+8>>2];a:{if(Rg(a)){b=j[a+8>>2];break a}b=j[a+8>>2]+4|0}j[b>>2]=c;j[c+4>>2]=a;an(a,c)}function eG(a){var b=0,c=0;b=Za-16|0;Za=b;j[114630]=0;j[b+12>>2]=0;K(2163,a|0,b+12|0,b+8|0)|0;c=j[114630];j[114630]=0;if((c|0)!=1){Za=b+16|0;return a}J(0)|0;C()|0;ib();z()}function dG(a){var b=0,c=0;b=Za-16|0;Za=b;j[114630]=0;j[b+12>>2]=0;K(2164,a|0,b+12|0,b+8|0)|0;c=j[114630];j[114630]=0;if((c|0)!=1){Za=b+16|0;return a}J(0)|0;C()|0;ib();z()}function cG(a){var b=0,c=0;b=Za-16|0;Za=b;j[114630]=0;j[b+12>>2]=0;K(2165,a|0,b+12|0,b+8|0)|0;c=j[114630];j[114630]=0;if((c|0)!=1){Za=b+16|0;return a}J(0)|0;C()|0;ib();z()}function Ufa(a,b,c){var d=0;d=Za-16|0;Za=d;tH(d,b,c);j[114630]=0;I(13,a|0,0,d|0);a=j[114630];j[114630]=0;if((a|0)!=1){gb(d);Za=d+16|0;return}a=D()|0;C()|0;gb(d);G(a|0);z()}function Rka(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=Za-16|0;Za=c;j[c+12>>2]=b;d=c,e=uR(Lb(a),Mb(a),c+12|0),j[d+8>>2]=e;d=c,e=Mb(a),j[d>>2]=e;a=rb(c+8|0,c);Za=c+16|0;return a|0}function Gfa(a,b,c){var d=0;d=Za-16|0;Za=d;mw(d,b,c);j[114630]=0;I(13,a|0,0,d|0);a=j[114630];j[114630]=0;if((a|0)!=1){gb(d);Za=d+16|0;return}a=D()|0;C()|0;gb(d);G(a|0);z()}function Gba(a,b,c,d){var e=0,f=0;e=Za-16|0;Za=e;if(c){while(1){f=Zr(hb(a),c+16|0,b);d=f?d:c;c=j[(f?4:0)+c>>2];if(c){continue}break}}a=j[yc(e+8|0,d)>>2];Za=e+16|0;return a}function xga(a,b){a=a|0;b=b|0;var c=0,d=0;c=Za-16|0;Za=c;j[c+12>>2]=0;d=c+12|0;h[d|0]=b;h[d+1|0]=b>>>8;h[d+2|0]=b>>>16;h[d+3|0]=b>>>24;a=xH(a,c+12|0);Za=c+16|0;return a|0}function uya(a){var b=0,c=0;b=Za-16|0;Za=b;j[114630]=0;j[b+12>>2]=0;K(84,a|0,b+12|0,b+8|0)|0;c=j[114630];j[114630]=0;if((c|0)!=1){Za=b+16|0;return a}J(0)|0;C()|0;ib();z()}function mia(a,b,c){var d=0;d=Za-16|0;Za=d;j[d+12>>2]=b;j[114630]=0;K(1618,a|0,d+12|0,c|0)|0;b=j[114630];j[114630]=0;if((b|0)!=1){Za=d+16|0;return a}J(0)|0;C()|0;ib();z()}function i3(a,b){a=a|0;b=b|0;j[a+4>>2]=b;h[a|0]=0;if(mf(j[j[b>>2]-12>>2]+b|0)){if(j[(j[j[b>>2]-12>>2]+b|0)+72>>2]){ND(j[(j[j[b>>2]-12>>2]+b|0)+72>>2])}h[a|0]=1}return a|0}function fK(a,b,c){a=a|0;b=b|0;c=c|0;a=j[c+4>>2];j[b>>2]=j[c>>2];j[b+4>>2]=a;a=j[c+20>>2];j[b+16>>2]=j[c+16>>2];j[b+20>>2]=a;a=j[c+12>>2];j[b+8>>2]=j[c+8>>2];j[b+12>>2]=a}function eoa(a,b,c){var d=0;d=Za-16|0;Za=d;j[d+12>>2]=b;j[114630]=0;K(1380,a|0,d+12|0,c|0)|0;b=j[114630];j[114630]=0;if((b|0)!=1){Za=d+16|0;return a}J(0)|0;C()|0;ib();z()}function Yna(a,b,c){var d=0;d=Za-16|0;Za=d;j[d+12>>2]=b;j[114630]=0;K(1384,a|0,d+12|0,c|0)|0;b=j[114630];j[114630]=0;if((b|0)!=1){Za=d+16|0;return a}J(0)|0;C()|0;ib();z()}function Wea(a){var b=0,c=0;b=j[a+16>>2];c=b-1|0;j[a+16>>2]=c;if((b|0)<=0){j[a+16>>2]=c+j[a+12>>2]}b=j[a+20>>2];c=b-1|0;j[a+20>>2]=c;if((b|0)<=0){j[a+20>>2]=c+j[a+12>>2]}}function U2(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=a;a=b+28|0;d=Rn(d,a);lC(a,c);j[114630]=0;F(2368,b|0,1);a=j[114630];j[114630]=0;if((a|0)==1){a=D()|0;C()|0;wb(d);G(a|0);z()}}function Mn(a,b){var c=0,d=0,e=0;c=0;a:{if(!a){break a}d=HMa(a,0,b,0);e=ab;c=d;if((a|b)>>>0<65536){break a}c=e?-1:d}b=c;a=Yc(b);if(!(!a|!(k[a-4|0]&3))){Ab(a,0,b)}return a}function MDa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;a=bb[j[j[a>>2]+24>>2]](a)|0;a:{if(!c){d=1;if((a|0)==(b|0)){break a}}d=0;if(a>>>0<=b>>>0){break a}d=a-b>>>0>=c>>>0}return d|0}function Fqa(a,b,c){var d=0;d=Za-16|0;Za=d;j[d+12>>2]=b;j[114630]=0;K(1253,a|0,d+12|0,c|0)|0;b=j[114630];j[114630]=0;if((b|0)!=1){Za=d+16|0;return a}J(0)|0;C()|0;ib();z()}function Ex(a,b,c){var d=0,e=0,f=0;d=Za-32|0;Za=d;j[d+16>>2]=c;j[d+24>>2]=b;e=d,f=nd(a),j[e+8>>2]=f;b=a;a=Jn(d+24|0,d+8|0);aW(b,a,Jn(d+16|0,d+24|0));af(d+8|0,a);Za=d+32|0}function Ela(a,b,c){var d=0;d=Za-16|0;Za=d;j[d+12>>2]=b;j[114630]=0;K(1522,a|0,d+12|0,c|0)|0;b=j[114630];j[114630]=0;if((b|0)!=1){Za=d+16|0;return a}J(0)|0;C()|0;ib();z()}function Cta(a,b,c){var d=0;d=Za-16|0;Za=d;j[d+12>>2]=b;j[114630]=0;K(1163,a|0,d+12|0,c|0)|0;b=j[114630];j[114630]=0;if((b|0)!=1){Za=d+16|0;return a}J(0)|0;C()|0;ib();z()}function B3(a,b){a=a|0;b=b|0;j[a+4>>2]=b;h[a|0]=0;if(mf(j[j[b>>2]-12>>2]+b|0)){if(j[(j[j[b>>2]-12>>2]+b|0)+72>>2]){Eq(j[(j[j[b>>2]-12>>2]+b|0)+72>>2])}h[a|0]=1}return a|0}function Aya(a){var b=0,c=0;b=Za-16|0;Za=b;j[114630]=0;j[b+12>>2]=0;K(83,a|0,b+12|0,b+8|0)|0;c=j[114630];j[114630]=0;if((c|0)!=1){Za=b+16|0;return a}J(0)|0;C()|0;ib();z()}function yz(a,b,c){var d=0;d=k[b|0]|k[b+1|0]<<8|(k[b+2|0]<<16|k[b+3|0]<<24);b=k[b+4|0]|k[b+5|0]<<8|(k[b+6|0]<<16|k[b+7|0]<<24);j[a>>2]=d;j[a+4>>2]=b;Fl(a+8|0,c);return a}function uFa(a,b,c){var d=0;d=Za-16|0;Za=d;j[d+12>>2]=b;j[114630]=0;K(730,a|0,d+12|0,c|0)|0;b=j[114630];j[114630]=0;if((b|0)!=1){Za=d+16|0;return a}J(0)|0;C()|0;ib();z()}function uCa(a,b,c){var d=0;d=Za-16|0;Za=d;j[d+12>>2]=b;j[114630]=0;K(829,a|0,d+12|0,c|0)|0;b=j[114630];j[114630]=0;if((b|0)!=1){Za=d+16|0;return a}J(0)|0;C()|0;ib();z()}function nba(a){var b=0;b=Za-16|0;Za=b;nn(b,0,7349);j[114630]=0;I(9,a|0,0,b|0);a=j[114630];j[114630]=0;if((a|0)!=1){gb(b);Za=b+16|0;return}a=D()|0;C()|0;gb(b);G(a|0);z()}function lba(a){var b=0;b=Za-16|0;Za=b;nn(b,0,9345);j[114630]=0;I(9,a|0,0,b|0);a=j[114630];j[114630]=0;if((a|0)!=1){gb(b);Za=b+16|0;return}a=D()|0;C()|0;gb(b);G(a|0);z()}function k_(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;while(1){if((b|0)!=(c|0)){d=b;a=j[b>>2];if(a>>>0<=127){a=j[qq()+(j[b>>2]<<2)>>2]}j[d>>2]=a;b=b+4|0;continue}break}return c|0}function i_(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;while(1){if((b|0)!=(c|0)){d=b;a=j[b>>2];if(a>>>0<=127){a=j[pq()+(j[b>>2]<<2)>>2]}j[d>>2]=a;b=b+4|0;continue}break}return c|0}function ax(a,b){var c=0;c=Za-16|0;Za=c;j[114630]=0;j[c+12>>2]=b;K(1426,a|0,c+12|0,c+8|0)|0;b=j[114630];j[114630]=0;if((b|0)!=1){Za=c+16|0;return a}J(0)|0;C()|0;ib();z()}function E8(a,b,c){var d=0;d=Za-16|0;Za=d;j[d+12>>2]=b;j[114630]=0;K(2196,a|0,d+12|0,c|0)|0;b=j[114630];j[114630]=0;if((b|0)!=1){Za=d+16|0;return a}J(0)|0;C()|0;ib();z()}function B8(a,b,c){var d=0;d=Za-16|0;Za=d;j[d+12>>2]=b;j[114630]=0;K(2198,a|0,d+12|0,c|0)|0;b=j[114630];j[114630]=0;if((b|0)!=1){Za=d+16|0;return a}J(0)|0;C()|0;ib();z()}function zwa(a,b){a=a|0;b=b|0;var c=0,d=0;c=ue(2500);j[114630]=0;b=K(92,c|0,b|0,0)|0;d=j[114630];j[114630]=0;if((d|0)!=1){Sua(a,b);return}a=D()|0;C()|0;Fb(c);G(a|0);z()}function woa(a,b){var c=0;c=Za-16|0;Za=c;j[114630]=0;j[c+12>>2]=b;K(1371,a|0,c+12|0,c+8|0)|0;a=j[114630];j[114630]=0;if((a|0)!=1){Za=c+16|0;return}J(0)|0;C()|0;ib();z()}function uha(a,b){var c=0;c=Za-16|0;Za=c;dja(c,b);j[114630]=0;I(13,a|0,0,c|0);a=j[114630];j[114630]=0;if((a|0)!=1){gb(c);Za=c+16|0;return}a=D()|0;C()|0;gb(c);G(a|0);z()}function sV(a,b,c){var d=0;d=Za-16|0;Za=d;j[d+12>>2]=b;j[114630]=0;K(280,a|0,d+12|0,c|0)|0;b=j[114630];j[114630]=0;if((b|0)!=1){Za=d+16|0;return a}J(0)|0;C()|0;ib();z()}function lsa(a,b){var c=0;c=Za-16|0;Za=c;j[114630]=0;j[c+12>>2]=b;K(1195,a|0,c+12|0,c+8|0)|0;a=j[114630];j[114630]=0;if((a|0)!=1){Za=c+16|0;return}J(0)|0;C()|0;ib();z()}function iga(a,b){var c=0;c=Za-16|0;Za=c;j[114630]=0;j[c+12>>2]=b;K(1753,a|0,c+12|0,c+8|0)|0;a=j[114630];j[114630]=0;if((a|0)!=1){Za=c+16|0;return}J(0)|0;C()|0;ib();z()}function gna(a,b){var c=0;c=Za-16|0;Za=c;j[114630]=0;j[c+12>>2]=b;K(1418,a|0,c+12|0,c+8|0)|0;a=j[114630];j[114630]=0;if((a|0)!=1){Za=c+16|0;return}J(0)|0;C()|0;ib();z()}function bha(a,b){var c=0;c=Za-16|0;Za=c;Cia(c,b);j[114630]=0;I(13,a|0,0,c|0);a=j[114630];j[114630]=0;if((a|0)!=1){gb(c);Za=c+16|0;return}a=D()|0;C()|0;gb(c);G(a|0);z()}function bV(a,b,c){var d=0;d=Za-16|0;Za=d;j[d+12>>2]=b;j[114630]=0;K(286,a|0,d+12|0,c|0)|0;b=j[114630];j[114630]=0;if((b|0)!=1){Za=d+16|0;return a}J(0)|0;C()|0;ib();z()}function Vda(a,b){var c=0;c=Za-16|0;Za=c;j[114630]=0;j[c+12>>2]=b;K(1998,a|0,c+12|0,c+8|0)|0;a=j[114630];j[114630]=0;if((a|0)!=1){Za=c+16|0;return}J(0)|0;C()|0;ib();z()}function OV(a,b,c){var d=0;d=Za-16|0;Za=d;j[d+12>>2]=b;j[114630]=0;K(274,a|0,d+12|0,c|0)|0;b=j[114630];j[114630]=0;if((b|0)!=1){Za=d+16|0;return a}J(0)|0;C()|0;ib();z()}function Kta(a,b,c){var d=0;a:{if(c>>>0>=256){break a}if(k[a+31|0]==17){a=l[(p(c,896)+b|0)+1075792>>1];return(a?a-1|0:c)&15}if(!ai(a)){break a}d=k[a+31|0]-1&15}return d}function Haa(a,b){var c=0;c=Za-16|0;Za=c;j[114630]=0;j[c+12>>2]=b;K(2132,a|0,c+12|0,c+8|0)|0;a=j[114630];j[114630]=0;if((a|0)!=1){Za=c+16|0;return}J(0)|0;C()|0;ib();z()}function Faa(a,b){var c=0;c=Za-16|0;Za=c;j[114630]=0;j[c+12>>2]=b;K(2133,a|0,c+12|0,c+8|0)|0;a=j[114630];j[114630]=0;if((a|0)!=1){Za=c+16|0;return}J(0)|0;C()|0;ib();z()}function FM(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=Za-16|0;Za=d;if((b|0)!=(c|0)){while(1){j[d+12>>2]=j[b>>2];Vx(a,d+12|0);b=b+4|0;if((c|0)!=(b|0)){continue}break}}Za=d+16|0}function Eaa(a,b){var c=0;c=Za-16|0;Za=c;j[114630]=0;j[c+12>>2]=b;K(2134,a|0,c+12|0,c+8|0)|0;a=j[114630];j[114630]=0;if((a|0)!=1){Za=c+16|0;return}J(0)|0;C()|0;ib();z()}function y7(a,b){a:{switch(j[a+40>>2]){case 0:u7(b,a);return;case 2:Pv(b,hb(a));return;case 3:t7(b,Ag(a));return;case 1:Pv(b,hb(a));return;default:break a}}Pv(b,hb(a))}function v7(a,b){a:{switch(j[a+40>>2]){case 0:o7(b,a);return;case 2:Ov(b,hb(a));return;case 3:n7(b,Ag(a));return;case 1:Ov(b,hb(a));return;default:break a}}Ov(b,hb(a))}function oha(a,b){var c=0;c=Za-16|0;Za=c;nI(c,b);j[114630]=0;I(13,a|0,0,c|0);a=j[114630];j[114630]=0;if((a|0)!=1){gb(c);Za=c+16|0;return}a=D()|0;C()|0;gb(c);G(a|0);z()}function nc(a,b){var c=0,d=0;c=Za-16|0;Za=c;if(j[a+4>>2]==j[b+4>>2]){d=j[b+4>>2];b=j[b>>2];j[c>>2]=b;j[c+4>>2]=d;j[c+8>>2]=b;j[c+12>>2]=d;d=!J8(a,c)}Za=c+16|0;return d}function iha(a,b){var c=0;c=Za-16|0;Za=c;Bw(c,b);j[114630]=0;I(13,a|0,0,c|0);a=j[114630];j[114630]=0;if((a|0)!=1){gb(c);Za=c+16|0;return}a=D()|0;C()|0;gb(c);G(a|0);z()}function g7(a,b){a:{switch(j[a+40>>2]){case 0:_q(b,a);return;case 2:_q(b,hb(a));return;case 3:e7(b,Ag(a));return;case 1:_q(b,hb(a));return;default:break a}}_q(b,hb(a))}function fe(a,b){var c=0;c=j[a>>2];j[a>>2]=b;a:{if(!c){break a}a=j[Rb(a)>>2];j[114630]=0;N(a|0,c|0);a=j[114630];j[114630]=0;if((a|0)!=1){break a}J(0)|0;C()|0;ib();z()}}function f7(a,b){a:{switch(j[a+40>>2]){case 0:a7(b,a);return;case 2:Nv(b,hb(a));return;case 3:$6(b,Ag(a));return;case 1:Nv(b,hb(a));return;default:break a}}Nv(b,hb(a))}function e9(a,b){a=a|0;b=b|0;var c=0;c=-1;a:{if((b|0)<0){break a}a=a+24|0;if((Wi(Eb(j[a>>2]+484360|0))|0)<=(b|0)){break a}c=l[bc(Eb(j[a>>2]+484360|0),b)>>1]}return c|0}function ana(a,b){a=a|0;b=b|0;var c=0;c=Za-16|0;Za=c;j[114630]=0;a=E(1420,a|0,b|0)|0;b=j[114630];j[114630]=0;if((b|0)!=1){Za=c+16|0;return a|0}a=D()|0;C()|0;G(a|0);z()}function _E(a){var b=0,c=0;a:{if(k[a|0]!=255){break a}b=k[a+1|0];if(!(b&6)|(b&240)!=240&(b&254)!=226){break a}a=k[a+2|0];if((a&240)==240){break a}c=(a&12)!=12}return c}function _7(a,b){a:{switch(j[a+40>>2]){case 0:Y7(b,a);return;case 2:Sv(b,hb(a));return;case 3:X7(b,Ag(a));return;case 1:Sv(b,hb(a));return;default:break a}}Sv(b,hb(a))}function Z7(a,b){a:{switch(j[a+40>>2]){case 0:S7(b,a);return;case 2:Rv(b,hb(a));return;case 3:R7(b,Ag(a));return;case 1:Rv(b,hb(a));return;default:break a}}Rv(b,hb(a))}function UH(a,b){var c=0;c=Za-16|0;Za=c;tja(c,b);j[114630]=0;I(13,a|0,0,c|0);a=j[114630];j[114630]=0;if((a|0)!=1){gb(c);Za=c+16|0;return}a=D()|0;C()|0;gb(c);G(a|0);z()}function O9(a,b){var c=0;c=Za-16|0;Za=c;j[114630]=0;j[c+12>>2]=b;K(2171,a|0,c+12|0,c+8|0)|0;a=j[114630];j[114630]=0;if((a|0)!=1){Za=c+16|0;return}J(0)|0;C()|0;ib();z()}function Mia(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=Za-16|0;Za=c;d=c,e=Fs(j[b>>2]),j[d+12>>2]=e;j[c+8>>2]=0;d=a,e=j[$r(c+12|0,c+8|0,32408)>>2],j[d+36>>2]=e;ko(a);Za=c+16|0}function MT(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=Za-16|0;Za=d;j[a>>2]=0;j[a+4>>2]=0;j[d+12>>2]=0;Hc(a+8|0,d+12|0,d+8|0);if(b){Ip(a,b);jA(a,b,k[c|0])}Za=d+16|0;return a|0}function L7(a,b){a:{switch(j[a+40>>2]){case 0:$q(b,a);return;case 2:$q(b,hb(a));return;case 3:J7(b,Ag(a));return;case 1:$q(b,hb(a));return;default:break a}}$q(b,hb(a))}function K7(a,b){a:{switch(j[a+40>>2]){case 0:G7(b,a);return;case 2:Qv(b,hb(a));return;case 3:E7(b,Ag(a));return;case 1:Qv(b,hb(a));return;default:break a}}Qv(b,hb(a))}function psa(a,b){a=a|0;b=b|0;var c=0;c=osa(a);h[a+530|0]=0;j[114630]=0;F(1192,a|0,b|0);b=j[114630];j[114630]=0;if((b|0)!=1){return a|0}a=D()|0;C()|0;bf(c);G(a|0);z()}function nsa(a,b){var c=0,d=0;c=ue(3848);b=j[b>>2];j[114630]=0;b=E(1194,c|0,b|0)|0;d=j[114630];j[114630]=0;if((d|0)!=1){lsa(a,b);return}a=D()|0;C()|0;Fb(c);G(a|0);z()}function nBa(a,b){var c=0;c=Za-32|0;Za=c;a:{if(yb(a,1024)){ny(c+24|0,b);qd(a,c+24|0);break a}j[c+16>>2]=0;j[c+20>>2]=0;j[c+8>>2]=0;j[c+12>>2]=0;SAa(b,c+8|0)}Za=c+32|0}function hea(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0;if(b){f=j[b+24>>2];g=j[b+8>>2];h=j[b+4>>2];i=j[b>>2];e=j[b+12>>2]}else{e=0}IG(a,i,h,g,e,f,b,c,d)}function _c(a,b,c){var d=0,e=0,f=0;a:{if(!c){break a}while(1){d=k[a|0];e=k[b|0];if((d|0)==(e|0)){b=b+1|0;a=a+1|0;c=c-1|0;if(c){continue}break a}break}f=d-e|0}return f}function ZV(a,b){var c=0;c=Za-16|0;Za=c;j[114630]=0;j[c+12>>2]=b;K(268,a|0,c+12|0,c+8|0)|0;a=j[114630];j[114630]=0;if((a|0)!=1){Za=c+16|0;return}J(0)|0;C()|0;ib();z()}function Xh(a,b,c){var d=0;d=j[b+4>>2];j[a>>2]=j[b>>2];j[a+4>>2]=d;d=j[b+12>>2];j[a+8>>2]=j[b+8>>2];j[a+12>>2]=d;o[a>>3]=o[a>>3]-o[c>>3];o[a+8>>3]=o[a+8>>3]-o[c+8>>3]}function U6(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;if((b|0)!=(c|0)){e=j[d>>2];while(1){Py(a,e,b);e=j[d>>2]+12|0;j[d>>2]=e;b=b+12|0;if((c|0)!=(b|0)){continue}break}}}function Sua(a,b){var c=0;c=Za-16|0;Za=c;j[114630]=0;j[c+12>>2]=b;K(97,a|0,c+12|0,c+8|0)|0;a=j[114630];j[114630]=0;if((a|0)!=1){Za=c+16|0;return}J(0)|0;C()|0;ib();z()}function Oxa(a,b){var c=0;c=Za-16|0;Za=c;j[114630]=0;j[c+12>>2]=b;K(90,a|0,c+12|0,c+8|0)|0;a=j[114630];j[114630]=0;if((a|0)!=1){Za=c+16|0;return}J(0)|0;C()|0;ib();z()}function GKa(a,b){var c=0;c=Za-16|0;Za=c;Za=c+16|0;return(k[b|0]|k[b+1|0]<<8|(k[b+2|0]<<16|k[b+3|0]<<24))>>>0<(k[a|0]|k[a+1|0]<<8|(k[a+2|0]<<16|k[a+3|0]<<24))>>>0?b:a}function waa(a,b,c,d){var e=0,f=0;e=Za-16|0;Za=e;j[e+8>>2]=j[b+8>>2];f=j[b+4>>2];j[e>>2]=j[b>>2];j[e+4>>2]=f;vaa(a,e,c);n[a+24>>2]=d;j[a>>2]=84216;Za=e+16|0;return a}function uaa(a,b,c,d){var e=0,f=0;e=Za-16|0;Za=e;j[e+8>>2]=j[b+8>>2];f=j[b+4>>2];j[e>>2]=j[b>>2];j[e+4>>2]=f;taa(a,e,c);n[a+24>>2]=d;j[a>>2]=84288;Za=e+16|0;return a}function rna(a,b){var c=0,d=0;c=ue(532);b=j[b>>2];j[114630]=0;b=E(1414,c|0,b|0)|0;d=j[114630];j[114630]=0;if((d|0)!=1){gna(a,b);return}a=D()|0;C()|0;Fb(c);G(a|0);z()}function jFa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;Sy(a,b,c);a=j[a+16>>2];a:{if(!c){d=1;if((a|0)==(b|0)){break a}}d=0;if(a>>>0<=b>>>0){break a}d=a-b>>>0>=c>>>0}return d|0}function go(a){var b=0;b=Za-16|0;Za=b;j[114630]=0;j[b+12>>2]=0;K(2170,a|0,b+12|0,b+8|0)|0;a=j[114630];j[114630]=0;if((a|0)!=1){Za=b+16|0;return}J(0)|0;C()|0;ib();z()}function OU(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=Za-16|0;Za=d;j[d+12>>2]=c;c=0;a=j[a+16>>2];if(a>>>0>b>>>0){j[d+8>>2]=a-b;c=j[tb(d+12|0,d+8|0)>>2]}Za=d+16|0;return c|0}function H2(a,b,c){var d=0,e=0,f=0;e=j[a+84>>2];d=c+256|0;f=Uq(e,0,d);d=f?f-e|0:d;c=c>>>0>d>>>0?d:c;Vb(b,e,c);b=e+d|0;j[a+84>>2]=b;j[a+8>>2]=b;j[a+4>>2]=c+e;return c}function $w(a){var b=0;b=Za-16|0;Za=b;j[114630]=0;j[b+12>>2]=0;K(1427,a|0,b+12|0,b+8|0)|0;a=j[114630];j[114630]=0;if((a|0)!=1){Za=b+16|0;return}J(0)|0;C()|0;ib();z()}function zka(a,b){var c=0,d=0,e=0;yka(a);il(a,b);j[a>>2]=j[b>>2];j[a+4>>2]=j[b+4>>2];c=j[hb(b)>>2];d=hb(a),e=c,j[d>>2]=e;d=hb(b),e=0,j[d>>2]=e;j[b>>2]=0;j[b+4>>2]=0}function vV(a){var b=0;b=Za-16|0;Za=b;j[114630]=0;j[b+12>>2]=0;K(278,a|0,b+12|0,b+8|0)|0;a=j[114630];j[114630]=0;if((a|0)!=1){Za=b+16|0;return}J(0)|0;C()|0;ib();z()}function sra(a,b){var c=0,d=0,e=0;d=a;c=j[a+4>>2];e=c>>>8|0;a=j[a>>2];c=(c&255)<<24|a>>>8;a=(((a^b)&255)<<3)+85584|0;b=j[a>>2];a=j[a+4>>2]^e;j[d>>2]=b^c;j[d+4>>2]=a}function rwa(a,b){var c=0;c=Za-16|0;Za=c;nh(c+8|0,b);j[114630]=0;a=E(1055,a|0,c+8|0)|0;b=j[114630];j[114630]=0;if((b|0)!=1){Za=c+16|0;return a}J(0)|0;C()|0;ib();z()}function pJa(a,b,c){var d=0;if((b|0)>=1){while(1){d=j[c>>2];h[a|0]=d;h[a+1|0]=d>>>8;h[a+2|0]=d>>>16;h[a+3|0]=d>>>24;a=a+4|0;d=(b|0)>1;b=b-1|0;if(d){continue}break}}}function msa(a){var b=0,c=0,d=0,e=0;b=Za-16|0;Za=b;d=b,e=HMa(j[a>>2],j[a+4>>2],1e3,0),j[d>>2]=e;j[b+4>>2]=ab;c=Tj(b+8|0,b);a=j[c>>2];Za=b+16|0;ab=j[c+4>>2];return a}function mra(a,b){var c=0,d=0,e=0;bra(a);il(a,b);j[a>>2]=j[b>>2];j[a+4>>2]=j[b+4>>2];c=j[hb(b)>>2];d=hb(a),e=c,j[d>>2]=e;d=hb(b),e=0,j[d>>2]=e;j[b>>2]=0;j[b+4>>2]=0}function lY(a,b){var c=0,d=0;c=Za-16|0;Za=c;d=Za-16|0;Za=d;b=kY(b);Za=d+16|0;j[c+8>>2]=b;j[c+12>>2]=ab;b=j[c+12>>2];j[a>>2]=j[c+8>>2];j[a+4>>2]=b;Za=c+16|0;return a}function kxa(a,b){var c=0,d=0,e=0;c=jxa(a,hb(b));j[a>>2]=j[b>>2];j[a+4>>2]=j[b+4>>2];a=j[hb(b)>>2];d=hb(c),e=a,j[d>>2]=e;d=hb(b),e=0,j[d>>2]=e;j[b>>2]=0;j[b+4>>2]=0}function kba(a){var b=0;b=Za-16|0;Za=b;eq(b,0);j[114630]=0;I(9,a|0,0,b|0);a=j[114630];j[114630]=0;if((a|0)!=1){gb(b);Za=b+16|0;return}a=D()|0;C()|0;gb(b);G(a|0);z()}function jba(a){var b=0;b=Za-16|0;Za=b;eq(b,2);j[114630]=0;I(9,a|0,0,b|0);a=j[114630];j[114630]=0;if((a|0)!=1){gb(b);Za=b+16|0;return}a=D()|0;C()|0;gb(b);G(a|0);z()}function iba(a){var b=0;b=Za-16|0;Za=b;eq(b,3);j[114630]=0;I(9,a|0,0,b|0);a=j[114630];j[114630]=0;if((a|0)!=1){gb(b);Za=b+16|0;return}a=D()|0;C()|0;gb(b);G(a|0);z()}function c_(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;while(1){if((b|0)!=(c|0)){d=b;a=h[b|0];if((a|0)>=0){a=j[qq()+(h[b|0]<<2)>>2]}h[d|0]=a;b=b+1|0;continue}break}return c|0}function a_(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;while(1){if((b|0)!=(c|0)){d=b;a=h[b|0];if((a|0)>=0){a=j[pq()+(h[b|0]<<2)>>2]}h[d|0]=a;b=b+1|0;continue}break}return c|0}function UX(a,b){var c=0,d=0;c=Za-16|0;Za=c;d=Za-16|0;Za=d;b=QX(b);Za=d+16|0;j[c+8>>2]=b;j[c+12>>2]=ab;b=j[c+12>>2];j[a>>2]=j[c+8>>2];j[a+4>>2]=b;Za=c+16|0;return a}function Tya(a,b){var c=0,d=0,e=0;Sya(a);il(a,b);j[a>>2]=j[b>>2];j[a+4>>2]=j[b+4>>2];c=j[hb(b)>>2];d=hb(a),e=c,j[d>>2]=e;d=hb(b),e=0,j[d>>2]=e;j[b>>2]=0;j[b+4>>2]=0}function ON(a){if(!((k[a|0]|k[a+1|0]<<8|(k[a+2|0]<<16|k[a+3|0]<<24))!=541938512|(k[a+8|0]|k[a+9|0]<<8|(k[a+10|0]<<16|k[a+11|0]<<24))!=1162627398)){return 1}return 0}function JM(a){var b=0,c=0;a:{if(k[a|0]!=255){break a}b=k[a+1|0];if(!(b&6)|(b&224)!=224|(b&24)==8){break a}a=k[a+2|0];if((a&12)==12){break a}c=(a&240)!=240}return c}function GV(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=Za-16|0;Za=d;j[d+12>>2]=c;c=0;a=j[a+8>>2];if(a>>>0>b>>>0){j[d+8>>2]=a-b;c=j[tb(d+12|0,d+8|0)>>2]}Za=d+16|0;return c|0}function F4(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;e=Za-16|0;Za=e;a=Oq(ta(j[a+60>>2],b|0,c|0,d&255,e+8|0)|0);Za=e+16|0;ab=a?-1:j[e+12>>2];return(a?-1:j[e+8>>2])|0}function Dla(a,b){var c=0;c=Za-16|0;Za=c;nh(c+8|0,b);j[114630]=0;a=E(1523,a|0,c+8|0)|0;b=j[114630];j[114630]=0;if((b|0)!=1){Za=c+16|0;return a}J(0)|0;C()|0;ib();z()}function yG(a,b){var c=0,d=0,e=0,f=0;c=j[a+24>>2];if((c|0)==j[a+28>>2]){return e=a,f=gg(b),d=j[j[a>>2]+52>>2],bb[d](e|0,f|0)|0}j[a+24>>2]=c+1;h[c|0]=b;return gg(b)}function opa(a,b){var c=0,d=0,e=0;_K(a);il(a,b);j[a>>2]=j[b>>2];j[a+4>>2]=j[b+4>>2];c=j[hb(b)>>2];d=hb(a),e=c,j[d>>2]=e;d=hb(b),e=0,j[d>>2]=e;j[b>>2]=0;j[b+4>>2]=0}function kja(a,b){var c=0;jja(a,b);j[a+20>>2]=j[b+20>>2];c=j[b+16>>2];j[a+12>>2]=j[b+12>>2];j[a+16>>2]=c;ija(a+24|0,b+24|0);Mc(a+36|0,b+36|0);j[a+48>>2]=j[b+48>>2]}function kY(a){var b=0,c=0,d=0,e=0;b=Za-16|0;Za=b;d=b,e=HMa(j[a>>2],j[a+4>>2],1e9,0),j[d>>2]=e;j[b+4>>2]=ab;c=Tj(b+8|0,b);a=j[c>>2];Za=b+16|0;ab=j[c+4>>2];return a}function jja(a,b){var c=0,d=0,e=0;c=tI(a,hb(b));j[a>>2]=j[b>>2];j[a+4>>2]=j[b+4>>2];a=j[hb(b)>>2];d=hb(c),e=a,j[d>>2]=e;d=hb(b),e=0,j[d>>2]=e;j[b>>2]=0;j[b+4>>2]=0}function ija(a,b){var c=0,d=0,e=0;c=PS(a,hb(b));j[a>>2]=j[b>>2];j[a+4>>2]=j[b+4>>2];a=j[hb(b)>>2];d=hb(c),e=a,j[d>>2]=e;d=hb(b),e=0,j[d>>2]=e;j[b>>2]=0;j[b+4>>2]=0}function QX(a){var b=0,c=0,d=0,e=0;b=Za-16|0;Za=b;d=b,e=HMa(j[a>>2],j[a+4>>2],1e6,0),j[d>>2]=e;j[b+4>>2]=ab;c=Tj(b+8|0,b);a=j[c>>2];Za=b+16|0;ab=j[c+4>>2];return a}function Pk(a){a=a>>>1&1431655765|a<<1&-1431655766;a=a>>>2&858993459|a<<2&-858993460;a=a>>>4&252645135|a<<4&-252645136;return MMa(a>>>8&16711935|a<<8&-16711936,16)}function Maa(a,b){var c=0,d=0,e=0;d8(a);il(a,b);j[a>>2]=j[b>>2];j[a+4>>2]=j[b+4>>2];c=j[hb(b)>>2];d=hb(a),e=c,j[d>>2]=e;d=hb(b),e=0,j[d>>2]=e;j[b>>2]=0;j[b+4>>2]=0}function Lta(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;a=a+108|0;c=a+128|0;if((a|0)!=(c|0)){while(1){d=a,e=pp(k[a|0]+b|0),h[d|0]=e;a=a+1|0;if((c|0)!=(a|0)){continue}break}}}function Hra(a,b){var c=0,d=0,e=0;c=wL(a,hb(b));j[a>>2]=j[b>>2];j[a+4>>2]=j[b+4>>2];a=j[hb(b)>>2];d=hb(c),e=a,j[d>>2]=e;d=hb(b),e=0,j[d>>2]=e;j[b>>2]=0;j[b+4>>2]=0}function Esa(a,b){var c=0,d=0,e=0;c=$L(a,hb(b));j[a>>2]=j[b>>2];j[a+4>>2]=j[b+4>>2];a=j[hb(b)>>2];d=hb(c),e=a,j[d>>2]=e;d=hb(b),e=0,j[d>>2]=e;j[b>>2]=0;j[b+4>>2]=0}function Dma(a,b){var c=0,d=0,e=0;gP(a);il(a,b);j[a>>2]=j[b>>2];j[a+4>>2]=j[b+4>>2];c=j[hb(b)>>2];d=hb(a),e=c,j[d>>2]=e;d=hb(b),e=0,j[d>>2]=e;j[b>>2]=0;j[b+4>>2]=0}function Ao(a){var b=0,c=0;b=Za-16|0;Za=b;a:{if(!(j[a+480208>>2]&16)){break a}mb(b+8|0,a+1074308|0,7);if(!kb(b+8|0)){break a}c=j[a+480180>>2]!=4}Za=b+16|0;return c}function $ja(a,b){var c=0,d=0,e=0;DI(a);il(a,b);j[a>>2]=j[b>>2];j[a+4>>2]=j[b+4>>2];c=j[hb(b)>>2];d=hb(a),e=c,j[d>>2]=e;d=hb(b),e=0,j[d>>2]=e;j[b>>2]=0;j[b+4>>2]=0}function wN(a,b){var c=0,d=0,e=0;c=yN(a,hb(b));j[a>>2]=j[b>>2];j[a+4>>2]=j[b+4>>2];a=j[hb(b)>>2];d=hb(c),e=a,j[d>>2]=e;d=hb(b),e=0,j[d>>2]=e;j[b>>2]=0;j[b+4>>2]=0}function uG(a){a=a|0;var b=0,c=0,d=0;b=ue(1304568);j[114630]=0;c=H(2128,b|0)|0;d=j[114630];j[114630]=0;if((d|0)!=1){Haa(a,c);return}a=D()|0;C()|0;Fb(b);G(a|0);z()}function tba(a){var b=0;b=Za-16|0;Za=b;kW(b);j[114630]=0;I(9,a|0,0,b|0);a=j[114630];j[114630]=0;if((a|0)!=1){gb(b);Za=b+16|0;return}a=D()|0;C()|0;gb(b);G(a|0);z()}function pba(a){var b=0;b=Za-16|0;Za=b;wW(b);j[114630]=0;I(9,a|0,0,b|0);a=j[114630];j[114630]=0;if((a|0)!=1){gb(b);Za=b+16|0;return}a=D()|0;C()|0;gb(b);G(a|0);z()}function oba(a){var b=0;b=Za-16|0;Za=b;vW(b);j[114630]=0;I(9,a|0,0,b|0);a=j[114630];j[114630]=0;if((a|0)!=1){gb(b);Za=b+16|0;return}a=D()|0;C()|0;gb(b);G(a|0);z()}function mta(a,b,c){a:{if(!is(b,c)){break a}while(1){if(l[kta(b)>>1]!=65535){break a}cM(b+4|0);if(is(b,c)){continue}break}}c=j[b+4>>2];j[a>>2]=j[b>>2];j[a+4>>2]=c}function bua(a,b,c,d){var e=0;a:{if(d==q(1)){break a}b=p(b,c);if(!b){break a}e=+d;c=0;while(1){o[a>>3]=o[a>>3]*e;a=a+8|0;c=c+1|0;if((b|0)!=(c|0)){continue}break}}}function Xb(a,b){var c=0,d=0,e=0,f=0,g=0,h=0;c=Za-16|0;Za=c;d=j[a>>2];a=(f=d,g=j[a+8>>2],h=Kb(c+8|0,b),e=j[j[d>>2]+32>>2],bb[e](f|0,g|0,h|0)|0);Za=c+16|0;return a}function TJ(a){j[a>>2]=0;j[a+4>>2]=0;j[a+88>>2]=0;j[a+8>>2]=0;j[a+12>>2]=0;vL(a+112|0,48e3);j[a+668>>2]=0;Yw(a+724|0);Yw(a+736|0);Yw(a+748|0);ni(a+810|0);return a}function Jb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=yb(a,b);if(c){j[a+8>>2]=j[a+8>>2]+b;return c|0}b=a;a=j[a>>2];d=b,e=bb[j[j[a>>2]+24>>2]](a)|0,j[d+8>>2]=e;return c|0}function Hwa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=Wm(a);j[114630]=0;I(91,a|0,b|0,c|0);b=j[114630];j[114630]=0;if((b|0)!=1){return a|0}a=D()|0;C()|0;Ud(d);G(a|0);z()}function yba(a,b,c,d,e){var f=0,g=0;f=Za-16|0;Za=f;g=j[a+12>>2];j[f+8>>2]=j[a+8>>2];j[f+12>>2]=g;g=j[a+4>>2];j[f>>2]=j[a>>2];j[f+4>>2]=g;$ta(f,b,c,d,e);Za=f+16|0}function ue(a){a=a|0;var b=0;a=a?a:1;a:{while(1){b=Yc(a);if(b){break a}b=j[115937];if(b){bb[b|0]();continue}break}a=R(4)|0;Bk(a);X(a|0,71412,2003);z()}return b|0}function tX(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=Za-16|0;Za=d;j[d+12>>2]=j[c>>2];a=bb[j[j[a>>2]+16>>2]](a,b,d+12|0)|0;if(a){j[c>>2]=j[d+12>>2]}Za=d+16|0;return a|0}function cT(a){var b=0,c=0;a:{if(_c(a,12061,3)){break a}b=a+3|0;if(k[b|0]<8|k[b|0]>14){break a}a=a+40|0;if(k[b|0]>9?!(k[a|0]<33?k[a|0]:0):0){break a}c=1}return c}function XX(a,b){a=a|0;b=b|0;sm(a);j[a>>2]=71452;b=zb(b);j[114630]=0;E(2843,a+4|0,b|0)|0;b=j[114630];j[114630]=0;if((b|0)!=1){return a|0}a=D()|0;C()|0;G(a|0);z()}function Uo(a){j[a+8>>2]=0;j[a+12>>2]=0;j[a>>2]=128;j[a+4>>2]=256;j[a+32>>2]=363;j[a+36>>2]=952;j[a+16>>2]=48e3;j[a+20>>2]=2;j[a+24>>2]=128;j[a+28>>2]=0;return a}function Cla(a,b){a:{if(k[a+4|0]){a=j[a>>2];j[114630]=0;F(1520,a|0,b+16|0);a=j[114630];j[114630]=0;if((a|0)==1){break a}}if(b){bJ(b)}return}J(0)|0;C()|0;ib();z()}function jta(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=Za-16|0;Za=d;i[d+12>>1]=c;i[d+14>>1]=b;Rf(d+14|0,l[j[j[a+24>>2]+8>>2]+12>>1]);ita(a,l[d+14>>1],d+12|0);Za=d+16|0}function Le(a){var b=0,c=0;b=Za-16|0;Za=b;j[114630]=0;K(114,a|0,b+8|0,b|0)|0;c=j[114630];j[114630]=0;if((c|0)!=1){Km(a);Za=b+16|0;return a}J(0)|0;C()|0;ib();z()}function $za(a,b){a=a|0;b=b|0;var c=0,d=0;d=Za-80|0;Za=d;c=-1;a:{if(!BR(a,d+8|0)){break a}c=0;if(!gO(d+8|0)){break a}c=Me(a,b,fO(d+8|0),ab)}Za=d+80|0;return c|0}function zH(a,b){var c=0;c=Za-16|0;Za=c;j[c+12>>2]=b;j[c+8>>2]=127;b=tb(c+12|0,c+8|0);n[j[a+20>>2]+144>>2]=q(q(m[b>>2])*q(-.007874015718698502))+q(1);Za=c+16|0}function yd(a,b,c){var d=0;d=Za-16|0;Za=d;j[d+12>>2]=b;j[114630]=0;Tn(a,d+12|0,c);b=j[114630];j[114630]=0;if((b|0)!=1){Za=d+16|0;return a}J(0)|0;C()|0;ib();z()}function iW(a,b,c,d){var e=0,f=0;f=-1;a:{if(!b){break a}e=b;b=a;e=e+b|0;while(1){if(Gn(c,d,b)){b=b+1|0;if((e|0)!=(b|0)){continue}break a}break}f=b-a|0}return f}function O3(a,b,c){a=a|0;b=b|0;c=c|0;b=c;a:{if((c|0)>=257){bE();c=85376;break a}b:{if(h[461644]&1){break b}if(!fd(461644)){break b}ed(461644)}c=85372}Cc(a,b,c)}function Lla(a){dJ();Pe(219792,285328,a+131112|0);Pe(285328,350864,a+196648|0);Pe(350864,416400,a+262184|0);Pe(88704,219792,a+24|0);Vb(a+327720|0,416400,40960)}function Ep(a,b,c){a=a|0;b=b|0;c=c|0;h[a+11|0]=c;h[a+10|0]=b;h[a+12|0]=k[a+12|0]&251;i[a+8>>1]=65535;j[a>>2]=0;j[a+4>>2]=0;h[a+12|0]=k[a+12|0]&252|1;return a|0}function DO(a){if((k[a|0]|k[a+1|0]<<8|(k[a+2|0]<<16|k[a+3|0]<<24))==1297239878){return(k[a+8|0]|k[a+9|0]<<8|(k[a+10|0]<<16|k[a+11|0]<<24))==1279545165}return 0}function Cb(a){var b=0,c=0;b=Za-16|0;Za=b;j[114630]=0;K(14,a|0,b+8|0,b|0)|0;c=j[114630];j[114630]=0;if((c|0)!=1){Km(a);Za=b+16|0;return a}J(0)|0;C()|0;ib();z()}function uIa(a,b){a=a|0;b=b|0;var c=0;hR(a);c=b+4|0;sIa(hb(a),j[a>>2],j[a+4>>2],c);Ib(a,c);Ib(a+4|0,b+8|0);Ib(hb(a),Ob(b));j[b>>2]=j[b+4>>2];li(a);rl(a);rl(a)}function mga(a,b){a=a|0;b=b|0;var c=0,d=0;c=Za-16|0;Za=c;d=b+1304396|0;if(!$c(d)){lga(c+8|0);SJ(d,ud(c+8|0));Jr(c+8|0)}a=kga(j[d>>2],a,b);Za=c+16|0;return a|0}function ila(a,b,c){var d=0,e=0,f=0;d=Za-16|0;Za=d;f=me(b);e=j[c+4>>2];c=j[c>>2];j[d>>2]=c;j[d+4>>2]=e;j[d+8>>2]=c;j[d+12>>2]=e;hla(a,b,f-1&65535,d);Za=d+16|0}function ika(a,b,c){a:{if(!b){break a}if(m[j[xm(a)+8>>2]+40>>2]<b>>>0|b>>>0>c>>>0){break a}if(m[j[xm(a)+8>>2]+40>>2]<c>>>0){break a}j[a+20>>2]=c;j[a+16>>2]=b}}function hY(a,b){var c=0,d=0;c=Za-16|0;Za=c;a:{if(qe(a)){d=j[a>>2];h[c+15|0]=0;Sd(b+d|0,c+15|0);ee(a,b);break a}h[c+14|0]=0;Sd(a+b|0,c+14|0);Ue(a,b)}Za=c+16|0}function bw(a,b){var c=0;c=Za-16|0;Za=c;j[114630]=0;K(150,a|0,c+8|0,b|0)|0;b=j[114630];j[114630]=0;if((b|0)!=1){Km(a);Za=c+16|0;return a}J(0)|0;C()|0;ib();z()}function YE(a,b){var c=0;c=Za-16|0;Za=c;j[114630]=0;K(197,a|0,c+8|0,b|0)|0;b=j[114630];j[114630]=0;if((b|0)!=1){Km(a);Za=c+16|0;return a}J(0)|0;C()|0;ib();z()}function XDa(a,b){a=a|0;b=b|0;var c=0;NP(a);c=b+4|0;SDa(hb(a),j[a>>2],j[a+4>>2],c);Ib(a,c);Ib(a+4|0,b+8|0);Ib(hb(a),Ob(b));j[b>>2]=j[b+4>>2];$j(a);nl(a);nl(a)}function XA(a){a=a|0;var b=0,c=0;b=Qc(a);j[114630]=0;H(277,a+12|0)|0;c=j[114630];j[114630]=0;if((c|0)!=1){vV(a+28|0);return a|0}a=D()|0;C()|0;gb(b);G(a|0);z()}function Vs(a){var b=0;b=Za-16|0;Za=b;Cc(b+8|0,a,0);j[114630]=0;I(670,b+8|0,110,0);a=j[114630];j[114630]=0;if((a|0)!=1){Za=b+16|0;return}J(0)|0;C()|0;ib();z()}function Qc(a){var b=0,c=0;b=Za-16|0;Za=b;j[114630]=0;K(1,a|0,b+8|0,b|0)|0;c=j[114630];j[114630]=0;if((c|0)!=1){Km(a);Za=b+16|0;return a}J(0)|0;C()|0;ib();z()}function QM(a,b){var c=0;c=j[a+4>>2];a:{if((b|0)>=0){b=b+c|0;j[a>>2]=j[a>>2]+(b>>>3&536870908);break a}b=b+c|0;j[a>>2]=j[a>>2]+((b-31|0)/32<<2)}j[a+4>>2]=b&31}function HC(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;a=Za-16|0;Za=a;j[a+8>>2]=b;while(1){if(c>>>0<d>>>0){GC(a+8|0,c);c=c+1|0;continue}break}Za=a+16|0;return j[a+8>>2]}function EMa(a,b,c){var d=0,e=0;d=b>>31;e=a^d;a=b>>31;FMa(e-d|0,(b^a)-((d>>>0>e>>>0)+a|0)|0,c,0);ab=$a;b=d^_a;c=b-d|0;ab=(a^ab)-((b>>>0<d>>>0)+a|0)|0;return c}function Cya(a,b){a=a|0;b=b|0;var c=0;HN(a);c=b+4|0;xya(hb(a),j[a>>2],j[a+4>>2],c);Ib(a,c);Ib(a+4|0,b+8|0);Ib(hb(a),Ob(b));j[b>>2]=j[b+4>>2];Wj(a);Xm(a);Xm(a)}function wAa(a,b,c){var d=0,e=0;d=Za-16|0;Za=d;iAa(b,c);c=yb(a,c<<3);if(c){e=Za-16|0;Za=e;Qb(d+8|0,j[b>>2],fg(b)<<3);Za=e+16|0;qd(a,d+8|0)}Za=d+16|0;return c}function pha(a,b){a=a|0;b=b|0;var c=0;LH(a);c=b+4|0;oi(hb(a),j[a>>2],j[a+4>>2],c);Ib(a,c);Ib(a+4|0,b+8|0);Ib(hb(a),Ob(b));j[b>>2]=j[b+4>>2];Te(a);Ij(a);Ij(a)}function k2(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;a=0;while(1){if((b|0)!=(c|0)){a=j[b>>2]+(a<<4)|0;d=a&-268435456;a=(d|d>>>24)^a;b=b+4|0;continue}break}return a|0}function Wl(a){a=a|0;var b=0;b=R(8)|0;j[114630]=0;E(2057,b|0,a|0)|0;a=j[114630];j[114630]=0;if((a|0)!=1){X(b|0,71740,265);z()}a=D()|0;C()|0;S(b|0);G(a|0);z()}function TG(a){a=a|0;var b=0;j[a+4240>>2]=0;j[a+4244>>2]=0;b=a+4264|0;j[b>>2]=0;j[b+4>>2]=0;b=a+4256|0;j[b>>2]=0;j[b+4>>2]=0;a=a+4248|0;j[a>>2]=0;j[a+4>>2]=0}function E_(){var a=0,b=0;td(463200);j[115800]=64792;j[114630]=0;a=T(2446)|0;b=j[114630];j[114630]=0;if((b|0)!=1){j[115802]=a;return}a=D()|0;C()|0;G(a|0);z()}function CIa(a,b){a=a|0;b=b|0;h[b|0]=0;h[b+1|0]=0;h[b+2|0]=0;h[b+3|0]=0;h[b+4|0]=0;h[b+5|0]=0;h[b+4|0]=6;h[b+5|0]=0;h[b|0]=0;h[b+1|0]=0;h[b+2|0]=8;h[b+3|0]=4}function ug(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0;d=j[a>>2];return(f=d,g=lb(b),h=j[a+8>>2],i=c,e=j[j[d>>2]+28>>2],bb[e](f|0,g|0,h|0,i|0)|0)|0}function uT(a,b){var c=0,d=0;c=Za-16|0;Za=c;a:{if(!b){break a}if(!yb(a,b)){break a}h[c+15|0]=0;Ff(a,c+15|0);h[c+8|0]=k[c+15|0];d=k[c+8|0]}Za=c+16|0;return d}function tT(a,b){var c=0,d=0;c=Za-16|0;Za=c;a:{if(!b){break a}if(!yb(a,b)){break a}h[c+15|0]=0;Ff(a,c+15|0);h[c+8|0]=k[c+15|0];d=h[c+8|0]}Za=c+16|0;return d}function t0(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0;g=a;a=bb[j[j[a+8>>2]+20>>2]](a+8|0)|0;return Fi(g,b,c,d,e,f,zb(a),zb(a)+(nb(a)<<2)|0)|0}function n2(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;a=0;while(1){if((b|0)!=(c|0)){a=h[b|0]+(a<<4)|0;d=a&-268435456;a=(d|d>>>24)^a;b=b+1|0;continue}break}return a|0}function jua(a,b,c,d,e){var f=0;if(d){while(1){n[b>>2]=q(j[a>>2])*e;n[c>>2]=q(j[a+4>>2])*e;c=c+4|0;a=a+8|0;b=b+4|0;f=f+1|0;if((f|0)!=(d|0)){continue}break}}}function gh(a){var b=0,c=0;b=a*a;c=b*a;return q(c*(b*b)*(b*2718311493989822e-21+ -.00019839334836096632)+(c*(b*.008333329385889463+ -.16666666641626524)+a))}function f4(a,b,c,d){var e=0;e=Za-16|0;Za=e;j[e+12>>2]=d;d=nb(b);if(d>>>0<c>>>0){Sl();z()}b=zb(b);j[e+4>>2]=d-c;Xo(a,b+c|0,j[tb(e+12|0,e+4|0)>>2]);Za=e+16|0}function hya(a,b){var c=0,d=0;if(me(a)>>>0>b>>>0){while(1){if(uh(te(a,c))){gya(Lb(te(a,c)),Mb(te(a,c)))}d=d+1|0;c=d&65535;if(c>>>0<=b>>>0){continue}break}}}function bk(a,b,c,d){j[d+8>>2]=b;j[d>>2]=0;j[d+4>>2]=0;j[c>>2]=d;if(j[j[a>>2]>>2]){j[a>>2]=j[j[a>>2]>>2]}tFa(j[Rb(a)>>2],j[c>>2]);a=hb(a);j[a>>2]=j[a>>2]+1}function bP(a){var b=0;a:{if(_c(a,15547,3)){break a}b=a+4|0;if((k[b|0]|k[b+1|0]<<8|(k[b+2|0]<<16|k[b+3|0]<<24))>>>0<423){break a}return k[a+3|0]<6}return 0}function aB(a){var b=0;b=Za-16|0;Za=b;h[a|0]=0;h[a+1|0]=0;h[a+2|0]=0;h[a+3|0]=0;h[a+4|0]=0;h[a+5|0]=0;h[a+6|0]=0;h[a+7|0]=0;h[a+8|0]=0;h[a+9|0]=0;Za=b+16|0}function ML(a,b){a=a|0;b=b|0;var c=0;c=Za-16|0;Za=c;j[c+12>>2]=b;a:{if(Vi(a)){nsa(c+8|0,c+12|0);ns(a,c+8|0);bf(c+8|0);break a}TL(j[a>>2],b)}LL(a);Za=c+16|0}function K5(a,b,c,d){var e=0,f=0,g=q(0);if((b|0)>=1){while(1){f=(e<<2)+a|0;g=n[f>>2];n[f+2304>>2]=g*d;n[f>>2]=g*c;e=e+1|0;if((e|0)!=(b|0)){continue}break}}}function Gt(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0;d=Za-16|0;Za=d;h[d+15|0]=b;h[d+14|0]=127;e=a,f=k[Zb(d+15|0,d+14|0)|0]|(c?-128:0),h[e+21|0]=f;Za=d+16|0}function Ft(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0;d=Za-16|0;Za=d;h[d+15|0]=b;h[d+14|0]=127;e=a,f=k[Zb(d+15|0,d+14|0)|0]|(c?-128:0),h[e+22|0]=f;Za=d+16|0}function xaa(a,b,c){dr(a);j[a+8>>2]=c;j[a+4>>2]=0;j[a>>2]=84192;c=j[b+4>>2];j[a+12>>2]=j[b>>2];j[a+16>>2]=c;c=j[b+12>>2];j[a+20>>2]=j[b+8>>2];j[a+24>>2]=c}function wfa(a,b,c){a=a|0;b=b|0;c=q(c);var d=0;d=Za-16|0;Za=d;n[d+12>>2]=c;if((b|0)<=4){Kd(d+12|0,q(0));n[((b<<2)+a|0)+4208>>2]=n[d+12>>2];gH(a)}Za=d+16|0}function wea(a,b,c){a=a|0;b=b|0;c=q(c);var d=0;d=Za-16|0;Za=d;n[d+12>>2]=c;if((b|0)<=3){Kd(d+12|0,q(0));n[((b<<2)+a|0)+4208>>2]=n[d+12>>2];RG(a)}Za=d+16|0}function d9(a,b){a=a|0;b=b|0;var c=0;a:{if(!er(b)){break a}a=a+24|0;if(!tg(j[a>>2]+484344|0,b&65535)){break a}c=j[Hb(j[a>>2]+484344|0,b)+12>>2]}return c|0}function Yra(a,b,c){var d=0;d=Za-16|0;Za=d;j[d+8>>2]=c;j[d>>2]=b;if(rb(d,d+8|0)){while(1){EL(a,k[j[d>>2]]);Xf(d);if(rb(d,d+8|0)){continue}break}}Za=d+16|0}function WEa(a,b){var c=0,d=0;c=Za-16|0;Za=c;My(c+8|0,b);b=pb(c+8|0);d=Xb(a,Kb(c,c+8|0));if((b|0)==(d|0)){Jb(a,pb(c+8|0))}Za=c+16|0;return(b|0)==(d|0)}



function VK(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;a:{if(d>>>0>=64){d=-1;if(j[a+480180>>2]&2){break a}}j[b+56>>2]=0;d=Ho(a,l[b+60>>1],j[b+48>>2],c,0)}return d|0}function Uj(a,b){var c=0,d=0;a:{b=Vj(a,b);if((b|0)==255){break a}if(Vi(a)){break a}c=a+4|0;d=Pb(c,b);h[d|0]=k[d|0]&223;Pg(j[a>>2],es(b)|176,k[Pb(c,b)|0])}}function PU(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;a=j[a+16>>2];a:{if(!c){d=1;if((a|0)==(b|0)){break a}}d=0;if(a>>>0<=b>>>0){break a}d=a-b>>>0>=c>>>0}return d|0}function MZ(a){a=a|0;var b=0;a=j[a+8>>2];if(!a){return 1}j[114630]=0;a=H(2577,a|0)|0;b=j[114630];j[114630]=0;if((b|0)!=1){return a|0}J(0)|0;C()|0;ib();z()}function Loa(a){var b=0,c=0;b=250;c=a;a:{while(1){if(j[c>>2]){break a}c=c+4|0;b=b-32|0;if(b>>>0>31){continue}break}return(j[a+28>>2]&67108863)!=0}return 1}function Jaa(a,b){var c=0,d=0;c=ue(44);j[114630]=0;b=E(2129,c|0,b|0)|0;d=j[114630];j[114630]=0;if((d|0)!=1){Faa(a,b);return}a=D()|0;C()|0;Fb(c);G(a|0);z()}function I1(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;e=Za-16|0;Za=e;j[e+12>>2]=b;j[e+8>>2]=d;b=bh(e,e+12|0);a=sD(a,c,j[e+8>>2]);oe(b);Za=e+16|0;return a|0}function Hfa(a,b,c){a=a|0;b=b|0;c=q(c);var d=0;d=Za-16|0;Za=d;n[d+12>>2]=c;if((b|0)<=5){Kd(d+12|0,q(0));n[((b<<2)+a|0)+4208>>2]=n[d+12>>2];lH(a)}Za=d+16|0}function Dea(a,b,c){a=a|0;b=b|0;c=q(c);var d=0;d=Za-16|0;Za=d;n[d+12>>2]=c;if((b|0)<=2){Kd(d+12|0,q(0));n[((b<<2)+a|0)+4208>>2]=n[d+12>>2];UG(a)}Za=d+16|0}function Aaa(a,b,c){dr(a);j[a+8>>2]=c;j[a+4>>2]=0;j[a>>2]=84096;c=j[b+4>>2];j[a+12>>2]=j[b>>2];j[a+16>>2]=c;c=j[b+12>>2];j[a+20>>2]=j[b+8>>2];j[a+24>>2]=c}function to(a,b){var c=0;j[a>>2]=76752;j[a>>2]=77168;c=j[b+8>>2];j[a+4>>2]=j[b+4>>2];j[a+8>>2]=c;c=j[b+16>>2];j[a+12>>2]=j[b+12>>2];j[a+16>>2]=c;return a}function qf(a,b,c){a:{switch(b-1|0){case 0:if(c){return $h(a,1)}return $h(a,0);case 1:if(c){return $h(a,3)}return $h(a,2);default:break a}}return $h(a,4)}function br(a){var b=0,c=0,d=0;b=MMa(j[a>>2],1)^270549120;c=j[a+4>>2];d=(b+(c<<2)|0)+2019860093|0;j[a>>2]=d;b=a;a=p(MMa(d,16),5)+c|0;j[b+4>>2]=a;return a}function al(a){var b=0,c=0,d=0;b=Za-16|0;Za=b;c=j[a+1074400>>2];d=j[a+1074416>>2];j[b+12>>2]=1;a=j[Lc(a+1074396|0,b+12|0)>>2];Za=b+16|0;return p(a,c+d|0)}function LB(a,b){a=a|0;b=b|0;sm(a);j[a>>2]=71452;j[114630]=0;E(2843,a+4|0,b|0)|0;b=j[114630];j[114630]=0;if((b|0)!=1){return a|0}a=D()|0;C()|0;G(a|0);z()}function HV(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;a=j[a+8>>2];a:{if(!c){d=1;if((a|0)==(b|0)){break a}}d=0;if(a>>>0<=b>>>0){break a}d=a-b>>>0>=c>>>0}return d|0}function Gv(a,b){var c=0;while(1){c=(b|0)<120?b:120;a=q(q(n[((c&3)<<2)+43584>>2]*a)*q(1073741824>>>(c>>2)|0));b=b-c|0;if((b|0)>0){continue}break}return a}function CEa(a,b){a=a|0;b=b|0;var c=0,d=0;d=Za-16|0;Za=d;c=-1;a:{if(!hj(a,d+8|0)){break a}c=0;if(!BEa(d+8|0)){break a}c=Me(a,b,36,0)}Za=d+16|0;return c|0}function Bi(a,b,c,d){var e=0,f=0;e=p(b,c);f=e;a:{if(j[d+76>>2]<=-1){a=tu(a,e,d);break a}a=tu(a,e,d)}if((f|0)==(a|0)){return b?c:0}return(a>>>0)/(b>>>0)|0}function xE(a){var b=0,c=0,d=0;if(Jg(h[j[a>>2]])){while(1){b=j[a>>2];d=h[b|0];j[a>>2]=b+1;c=(p(c,10)+d|0)-48|0;if(Jg(h[b+1|0])){continue}break}}return c}function wY(a,b,c){var d=0;d=Za-16|0;Za=d;q2(d,b,c,Wd());b=j[d+4>>2];j[a>>2]=j[d>>2];j[a+4>>2]=b;b=j[d+12>>2];j[a+8>>2]=j[d+8>>2];j[a+12>>2]=b;Za=d+16|0}function uHa(a,b){a=a|0;b=b|0;var c=0;yk(a);c=b+4|0;sHa(hb(a),j[a>>2],j[a+4>>2],c);Ib(a,c);Ib(a+4|0,b+8|0);Ib(hb(a),Ob(b));j[b>>2]=j[b+4>>2];Pl(a,Zc(a))}function rma(a){var b=0;a:{if(!j[a+16>>2]){break a}b=j[a+20>>2];if(b>>>0>4|!(1<<b&22)){break a}a=j[a+28>>2];if(a>>>0>4){break a}return 23>>>a&1}return 0}function pxa(a,b){a=a|0;b=b|0;var c=0;Li(a);c=b+4|0;nxa(hb(a),j[a>>2],j[a+4>>2],c);Ib(a,c);Ib(a+4|0,b+8|0);Ib(hb(a),Ob(b));j[b>>2]=j[b+4>>2];Wn(a,ec(a))}function p4(a,b){a=a|0;b=b|0;var c=0,d=0;b=mv(b);j[a+36>>2]=b;c=a,d=Am(b),j[c+44>>2]=d;c=a,d=gm(j[a+36>>2]),h[c+53|0]=d;if(j[a+44>>2]>=9){Wl(55824);z()}}function oja(a,b){a=a|0;b=b|0;var c=0;DJ(a);c=b+4|0;mja(hb(a),j[a>>2],j[a+4>>2],c);Ib(a,c);Ib(a+4|0,b+8|0);Ib(hb(a),Ob(b));j[b>>2]=j[b+4>>2];uI(a,df(a))}function lpa(a){if(!(a<q(2147483648))){return 2147483647}if(!(a>q(-2147483648))){return-2147483648}if(q(r(a))<q(2147483648)){return~~a}return-2147483648}function lga(a){var b=0,c=0,d=0;b=ue(12);j[114630]=0;c=H(1747,b|0)|0;d=j[114630];j[114630]=0;if((d|0)!=1){iga(a,c);return}a=D()|0;C()|0;Fb(b);G(a|0);z()}function km(a,b){var c=0,d=0;b=b+7&-8;d=j[a+80>>2];a:{if(d){b=j[a+92>>2]-b|0;c=0;if((b|0)<j[a+88>>2]){break a}j[a+92>>2]=b;return b+d|0}c=Yc(b)}return c}function k4(a,b){a=a|0;b=b|0;var c=0,d=0;b=lv(b);j[a+36>>2]=b;c=a,d=Am(b),j[c+44>>2]=d;c=a,d=gm(j[a+36>>2]),h[c+53|0]=d;if(j[a+44>>2]>=9){Wl(55824);z()}}function em(a,b){var c=0;c=j[j[b>>2]-12>>2];j[114630]=0;b=j[(b+c|0)+24>>2];c=j[114630];j[114630]=0;if((c|0)!=1){j[a>>2]=b;return a}J(0)|0;C()|0;ib();z()}function Zqa(a,b){a=a|0;b=b|0;var c=0;Li(a);c=b+4|0;Xqa(hb(a),j[a>>2],j[a+4>>2],c);Ib(a,c);Ib(a+4|0,b+8|0);Ib(hb(a),Ob(b));j[b>>2]=j[b+4>>2];Wn(a,ec(a))}function Zo(a,b,c){var d=0;d=b;b=k[a|0]|k[a+1|0]<<8;if((d|0)<=((b<<8|b>>>8)&65535)){a=k[a|0]|k[a+1|0]<<8;a=((a<<8|a>>>8)&65535)<=(c|0)}else{a=0}return a}function Qha(a,b){a=a|0;b=b|0;var c=0;$e(a);c=b+4|0;Pha(hb(a),j[a>>2],j[a+4>>2],c);Ib(a,c);Ib(a+4|0,b+8|0);Ib(hb(a),Ob(b));j[b>>2]=j[b+4>>2];Pj(a,sb(a))}function IE(a,b,c,d,e,f){var g=0,i=0;g=j[a+32>>2];i=g+(c<<2)|0;a:{if(!k[a+23|0]){break a}i=g;g=d<<2;j[i+g>>2]=b;h[j[a+8>>2]+d|0]=e;b=c;i=f+g|0}j[i>>2]=b}function Gsa(a,b){a=a|0;b=b|0;var c=0;Gl(a);c=b+4|0;Dsa(hb(a),j[a>>2],j[a+4>>2],c);Ib(a,c);Ib(a+4|0,b+8|0);Ib(hb(a),Ob(b));j[b>>2]=j[b+4>>2];Yp(a,de(a))}function DDa(a,b){a=a|0;b=b|0;var c=0;sh(a);c=b+4|0;BDa(hb(a),j[a>>2],j[a+4>>2],c);Ib(a,c);Ib(a+4|0,b+8|0);Ib(hb(a),Ob(b));j[b>>2]=j[b+4>>2];lt(a,pd(a))}function Cxa(a,b){a=a|0;b=b|0;var c=0;Li(a);c=b+4|0;hxa(hb(a),j[a>>2],j[a+4>>2],c);Ib(a,c);Ib(a+4|0,b+8|0);Ib(hb(a),Ob(b));j[b>>2]=j[b+4>>2];Wn(a,ec(a))}function xc(a,b){a=a|0;b=b|0;var c=0,d=0;a:{if(m[a+8>>2]<b>>>0){d=j[a>>2];c=0;if(bb[j[j[d>>2]+24>>2]](d)>>>0<b>>>0){break a}}j[a+8>>2]=b;c=1}return c|0}function sp(a,b){a=a|0;b=b|0;var c=0;sh(a);c=b+4|0;AJa(hb(a),j[a>>2],j[a+4>>2],c);Ib(a,c);Ib(a+4|0,b+8|0);Ib(hb(a),Ob(b));j[b>>2]=j[b+4>>2];lt(a,pd(a))}function joa(a,b){a=a|0;b=b|0;var c=0;Gl(a);c=b+4|0;oi(hb(a),j[a>>2],j[a+4>>2],c);Ib(a,c);Ib(a+4|0,b+8|0);Ib(hb(a),Ob(b));j[b>>2]=j[b+4>>2];Yp(a,de(a))}function f_(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;while(1){if((b|0)!=(c|0)){a=j[b>>2];h[e|0]=a>>>0<128?a:d;e=e+1|0;b=b+4|0;continue}break}return c|0}function cAa(a,b){a=a|0;b=b|0;var c=0;$p(a);c=b+4|0;oi(hb(a),j[a>>2],j[a+4>>2],c);Ib(a,c);Ib(a+4|0,b+8|0);Ib(hb(a),Ob(b));j[b>>2]=j[b+4>>2];$t(a,fg(a))}function SEa(a,b){a=a|0;b=b|0;var c=0;ct(a);c=b+4|0;TP(hb(a),j[a>>2],j[a+4>>2],c);Ib(a,c);Ib(a+4|0,b+8|0);Ib(hb(a),Ob(b));j[b>>2]=j[b+4>>2];gt(a,Lf(a))}function Pda(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=Za-32|0;Za=c;d=c,e=eL(b),j[d+16>>2]=e;Nda(c+24|0,a,b,c+16|0,c+8|0);a=Sg(c+24|0);Za=c+32|0;return a+12|0}function M0(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0;g=a;a=bb[j[j[a+8>>2]+20>>2]](a+8|0)|0;return Gi(g,b,c,d,e,f,zb(a),zb(a)+nb(a)|0)|0}function IL(a){var b=0,c=0,d=0;b=a+26|0;c=k[b|0]+27|0;if(k[b|0]){while(1){c=k[(a+d|0)+27|0]+c|0;d=d+1|0;if(d>>>0<k[b|0]){continue}break}}return c&65535}function zza(a,b){var c=0,d=0;c=Za-16|0;Za=c;TN(c+8|0,b);b=pb(c+8|0);d=Xb(a,Kb(c,c+8|0));if((b|0)==(d|0)){Jb(a,pb(c+8|0))}Za=c+16|0;return(b|0)==(d|0)}function yV(a,b){a=a|0;b=b|0;var c=0;Gl(a);c=b+4|0;oV(hb(a),j[a>>2],j[a+4>>2],c);Ib(a,c);Ib(a+4|0,b+8|0);Ib(hb(a),Ob(b));j[b>>2]=j[b+4>>2];Yp(a,de(a))}function xwa(a,b){var c=0,d=0;c=Za-16|0;Za=c;ZP(c+8|0,b);b=pb(c+8|0);d=Wc(a,Kb(c,c+8|0));if((b|0)==(d|0)){Fc(a,pb(c+8|0))}Za=c+16|0;return(b|0)==(d|0)}function xIa(a,b){var c=0,d=0;c=Za-16|0;Za=c;bt(c+8|0,b);b=pb(c+8|0);d=Wc(a,Kb(c,c+8|0));if((b|0)==(d|0)){Fc(a,pb(c+8|0))}Za=c+16|0;return(b|0)==(d|0)}function wKa(a,b){var c=0,d=0;c=Za-16|0;Za=c;Up(c+8|0,b);b=pb(c+8|0);d=Wc(a,Kb(c,c+8|0));if((b|0)==(d|0)){Fc(a,pb(c+8|0))}Za=c+16|0;return(b|0)==(d|0)}function wIa(a,b){var c=0,d=0;c=Za-16|0;Za=c;bt(c+8|0,b);b=pb(c+8|0);d=Xb(a,Kb(c,c+8|0));if((b|0)==(d|0)){Jb(a,pb(c+8|0))}Za=c+16|0;return(b|0)==(d|0)}function vxa(a,b){var c=0,d=0;c=Za-16|0;Za=c;bN(c+8|0,b);b=pb(c+8|0);d=Wc(a,Kb(c,c+8|0));if((b|0)==(d|0)){Fc(a,pb(c+8|0))}Za=c+16|0;return(b|0)==(d|0)}function vwa(a,b){var c=0,d=0;c=Za-16|0;Za=c;Cy(c+8|0,b);b=pb(c+8|0);d=Xb(a,Kb(c,c+8|0));if((b|0)==(d|0)){Jb(a,pb(c+8|0))}Za=c+16|0;return(b|0)==(d|0)}function vKa(a,b){var c=0,d=0;c=Za-16|0;Za=c;Fz(c+8|0,b);b=pb(c+8|0);d=Wc(a,Kb(c,c+8|0));if((b|0)==(d|0)){Fc(a,pb(c+8|0))}Za=c+16|0;return(b|0)==(d|0)}function vAa(a,b){var c=0,d=0;c=Za-16|0;Za=c;nO(c+8|0,b);b=pb(c+8|0);d=Wc(a,Kb(c,c+8|0));if((b|0)==(d|0)){Fc(a,pb(c+8|0))}Za=c+16|0;return(b|0)==(d|0)}function uxa(a,b){var c=0,d=0;c=Za-16|0;Za=c;bN(c+8|0,b);b=pb(c+8|0);d=Xb(a,Kb(c,c+8|0));if((b|0)==(d|0)){Jb(a,pb(c+8|0))}Za=c+16|0;return(b|0)==(d|0)}function uKa(a,b){var c=0,d=0;c=Za-16|0;Za=c;Fz(c+8|0,b);b=pb(c+8|0);d=Xb(a,Kb(c,c+8|0));if((b|0)==(d|0)){Jb(a,pb(c+8|0))}Za=c+16|0;return(b|0)==(d|0)}function tya(a,b){var c=0,d=0;c=Za-16|0;Za=c;uN(c+8|0,b);b=pb(c+8|0);d=Wc(a,Kb(c,c+8|0));if((b|0)==(d|0)){Fc(a,pb(c+8|0))}Za=c+16|0;return(b|0)==(d|0)}function tAa(a,b){var c=0,d=0;c=Za-16|0;Za=c;nO(c+8|0,b);b=pb(c+8|0);d=Xb(a,Kb(c,c+8|0));if((b|0)==(d|0)){Jb(a,pb(c+8|0))}Za=c+16|0;return(b|0)==(d|0)}function sya(a,b){var c=0,d=0;c=Za-16|0;Za=c;uN(c+8|0,b);b=pb(c+8|0);d=Xb(a,Kb(c,c+8|0));if((b|0)==(d|0)){Jb(a,pb(c+8|0))}Za=c+16|0;return(b|0)==(d|0)}function sMa(a,b){var c=0,d=0;c=Za-16|0;Za=c;kT(c+8|0,b);b=pb(c+8|0);d=Wc(a,Kb(c,c+8|0));if((b|0)==(d|0)){Fc(a,pb(c+8|0))}Za=c+16|0;return(b|0)==(d|0)}function rMa(a,b){var c=0,d=0;c=Za-16|0;Za=c;kT(c+8|0,b);b=pb(c+8|0);d=Xb(a,Kb(c,c+8|0));if((b|0)==(d|0)){Jb(a,pb(c+8|0))}Za=c+16|0;return(b|0)==(d|0)}function pKa(a,b){var c=0,d=0;c=Za-16|0;Za=c;YR(c+8|0,b);b=pb(c+8|0);d=Wc(a,Kb(c,c+8|0));if((b|0)==(d|0)){Fc(a,pb(c+8|0))}Za=c+16|0;return(b|0)==(d|0)}function oka(a,b){var c=0,d=0;c=Za-16|0;Za=c;OI(c+8|0,b);b=pb(c+8|0);d=Wc(a,Kb(c,c+8|0));if((b|0)==(d|0)){Fc(a,pb(c+8|0))}Za=c+16|0;return(b|0)==(d|0)}function oKa(a,b){var c=0,d=0;c=Za-16|0;Za=c;YR(c+8|0,b);b=pb(c+8|0);d=Xb(a,Kb(c,c+8|0));if((b|0)==(d|0)){Jb(a,pb(c+8|0))}Za=c+16|0;return(b|0)==(d|0)}function mya(a,b){var c=0,d=0;c=Za-16|0;Za=c;qN(c+8|0,b);b=pb(c+8|0);d=Wc(a,Kb(c,c+8|0));if((b|0)==(d|0)){Fc(a,pb(c+8|0))}Za=c+16|0;return(b|0)==(d|0)}function mka(a,b){var c=0,d=0;c=Za-16|0;Za=c;OI(c+8|0,b);b=pb(c+8|0);d=Xb(a,Kb(c,c+8|0));if((b|0)==(d|0)){Jb(a,pb(c+8|0))}Za=c+16|0;return(b|0)==(d|0)}function mIa(a,b){var c=0,d=0;c=Za-16|0;Za=c;Sz(c+8|0,b);b=pb(c+8|0);d=Xb(a,Kb(c,c+8|0));if((b|0)==(d|0)){Jb(a,pb(c+8|0))}Za=c+16|0;return(b|0)==(d|0)}function mAa(a,b){var c=0,d=0;c=Za-16|0;Za=c;mO(c+8|0,b);b=pb(c+8|0);d=Xb(a,Kb(c,c+8|0));if((b|0)==(d|0)){Jb(a,pb(c+8|0))}Za=c+16|0;return(b|0)==(d|0)}function m8(a,b){a=a|0;b=b|0;var c=0;yk(a);c=b+4|0;l8(hb(a),j[a>>2],j[a+4>>2],c);Ib(a,c);Ib(a+4|0,b+8|0);Ib(hb(a),Ob(b));j[b>>2]=j[b+4>>2];Pl(a,Zc(a))}function lya(a,b){var c=0,d=0;c=Za-16|0;Za=c;qN(c+8|0,b);b=pb(c+8|0);d=Xb(a,Kb(c,c+8|0));if((b|0)==(d|0)){Jb(a,pb(c+8|0))}Za=c+16|0;return(b|0)==(d|0)}function lHa(a,b){var c=0,d=0;c=Za-16|0;Za=c;TQ(c+8|0,b);b=pb(c+8|0);d=Wc(a,Kb(c,c+8|0));if((b|0)==(d|0)){Fc(a,pb(c+8|0))}Za=c+16|0;return(b|0)==(d|0)}function kIa(a,b){var c=0,d=0;c=Za-16|0;Za=c;JS(c+8|0,b);b=pb(c+8|0);d=Xb(a,Kb(c,c+8|0));if((b|0)==(d|0)){Jb(a,pb(c+8|0))}Za=c+16|0;return(b|0)==(d|0)}function kHa(a,b){var c=0,d=0;c=Za-16|0;Za=c;TQ(c+8|0,b);b=pb(c+8|0);d=Xb(a,Kb(c,c+8|0));if((b|0)==(d|0)){Jb(a,pb(c+8|0))}Za=c+16|0;return(b|0)==(d|0)}function iHa(a,b){var c=0,d=0;c=Za-16|0;Za=c;RQ(c+8|0,b);b=pb(c+8|0);d=Xb(a,Kb(c,c+8|0));if((b|0)==(d|0)){Jb(a,pb(c+8|0))}Za=c+16|0;return(b|0)==(d|0)}function iFa(a,b){var c=0,d=0;c=Za-16|0;Za=c;rt(c+8|0,b);b=pb(c+8|0);d=Wc(a,Kb(c,c+8|0));if((b|0)==(d|0)){Fc(a,pb(c+8|0))}Za=c+16|0;return(b|0)==(d|0)}function hh(a,b,c){j[b+12>>2]=j[b+12>>2]+c;j[b+8>>2]=j[b+8>>2]-c;c=j[b+4>>2];j[a>>2]=j[b>>2];j[a+4>>2]=c;c=j[b+12>>2];j[a+8>>2]=j[b+8>>2];j[a+12>>2]=c}function hJa(a,b){var c=0,d=0;c=Za-16|0;Za=c;CR(c+8|0,b);b=pb(c+8|0);d=Wc(a,Kb(c,c+8|0));if((b|0)==(d|0)){Fc(a,pb(c+8|0))}Za=c+16|0;return(b|0)==(d|0)}function hFa(a,b){var c=0,d=0;c=Za-16|0;Za=c;rt(c+8|0,b);b=pb(c+8|0);d=Xb(a,Kb(c,c+8|0));if((b|0)==(d|0)){Jb(a,pb(c+8|0))}Za=c+16|0;return(b|0)==(d|0)}function h8(a,b){a=a|0;b=b|0;var c=0;sh(a);c=b+4|0;g8(hb(a),j[a>>2],j[a+4>>2],c);Ib(a,c);Ib(a+4|0,b+8|0);Ib(hb(a),Ob(b));j[b>>2]=j[b+4>>2];lt(a,pd(a))}function fJa(a,b){var c=0,d=0;c=Za-16|0;Za=c;CR(c+8|0,b);b=pb(c+8|0);d=Xb(a,Kb(c,c+8|0));if((b|0)==(d|0)){Jb(a,pb(c+8|0))}Za=c+16|0;return(b|0)==(d|0)}function eHa(a,b){var c=0,d=0;c=Za-16|0;Za=c;NQ(c+8|0,b);b=pb(c+8|0);d=Wc(a,Kb(c,c+8|0));if((b|0)==(d|0)){Fc(a,pb(c+8|0))}Za=c+16|0;return(b|0)==(d|0)}function eDa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=Za-32|0;Za=c;d=c,e=_g(b),j[d+16>>2]=e;UCa(c+24|0,a,b,c+16|0,c+8|0);a=Ns(c+24|0);Za=c+32|0;return a+2|0}function dpa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=Za-32|0;Za=c;d=c,e=eL(b),j[d+16>>2]=e;Roa(c+24|0,a,b,c+16|0,c+8|0);a=Ns(c+24|0);Za=c+32|0;return a+4|0}function dIa(a,b){var c=0,d=0;c=Za-16|0;Za=c;kz(c+8|0,b);b=pb(c+8|0);d=Wc(a,Kb(c,c+8|0));if((b|0)==(d|0)){Fc(a,pb(c+8|0))}Za=c+16|0;return(b|0)==(d|0)}function dHa(a,b){var c=0,d=0;c=Za-16|0;Za=c;NQ(c+8|0,b);b=pb(c+8|0);d=Xb(a,Kb(c,c+8|0));if((b|0)==(d|0)){Jb(a,pb(c+8|0))}Za=c+16|0;return(b|0)==(d|0)}function cIa(a,b){var c=0,d=0;c=Za-16|0;Za=c;kz(c+8|0,b);b=pb(c+8|0);d=Xb(a,Kb(c,c+8|0));if((b|0)==(d|0)){Jb(a,pb(c+8|0))}Za=c+16|0;return(b|0)==(d|0)}function bIa(a,b){var c=0,d=0;c=Za-16|0;Za=c;uz(c+8|0,b);b=pb(c+8|0);d=Xb(a,Kb(c,c+8|0));if((b|0)==(d|0)){Jb(a,pb(c+8|0))}Za=c+16|0;return(b|0)==(d|0)}function bBa(a,b){var c=0,d=0;c=Za-16|0;Za=c;AO(c+8|0,b);b=pb(c+8|0);d=Xb(a,Kb(c,c+8|0));if((b|0)==(d|0)){Jb(a,pb(c+8|0))}Za=c+16|0;return(b|0)==(d|0)}function _xa(a,b){var c=0,d=0;c=Za-16|0;Za=c;qk(c+8|0,b);b=pb(c+8|0);d=Wc(a,Kb(c,c+8|0));if((b|0)==(d|0)){Fc(a,pb(c+8|0))}Za=c+16|0;return(b|0)==(d|0)}function Zxa(a,b){var c=0,d=0;c=Za-16|0;Za=c;yO(c+8|0,b);b=pb(c+8|0);d=Wc(a,Kb(c,c+8|0));if((b|0)==(d|0)){Fc(a,pb(c+8|0))}Za=c+16|0;return(b|0)==(d|0)}function ZAa(a,b){var c=0,d=0;c=Za-16|0;Za=c;AO(c+8|0,b);b=pb(c+8|0);d=Wc(a,Kb(c,c+8|0));if((b|0)==(d|0)){Fc(a,pb(c+8|0))}Za=c+16|0;return(b|0)==(d|0)}function YAa(a,b){var c=0,d=0;c=Za-16|0;Za=c;yO(c+8|0,b);b=pb(c+8|0);d=Xb(a,Kb(c,c+8|0));if((b|0)==(d|0)){Jb(a,pb(c+8|0))}Za=c+16|0;return(b|0)==(d|0)}function Xz(a,b){a=a|0;b=b|0;var c=0;Dp(a);c=b+4|0;oi(hb(a),j[a>>2],j[a+4>>2],c);Ib(a,c);Ib(a+4|0,b+8|0);Ib(hb(a),Ob(b));j[b>>2]=j[b+4>>2];wS(a,tc(a))}function Wra(a,b){var c=0,d=0;c=Za-16|0;Za=c;DL(c+8|0,b);b=pb(c+8|0);d=Xb(a,Kb(c,c+8|0));if((b|0)==(d|0)){Jb(a,pb(c+8|0))}Za=c+16|0;return(b|0)==(d|0)}function WGa(a,b){var c=0,d=0;c=Za-16|0;Za=c;HQ(c+8|0,b);b=pb(c+8|0);d=Wc(a,Kb(c,c+8|0));if((b|0)==(d|0)){Fc(a,pb(c+8|0))}Za=c+16|0;return(b|0)==(d|0)}function Vxa(a,b){var c=0,d=0;c=Za-16|0;Za=c;RQ(c+8|0,b);b=pb(c+8|0);d=Wc(a,Kb(c,c+8|0));if((b|0)==(d|0)){Fc(a,pb(c+8|0))}Za=c+16|0;return(b|0)==(d|0)}function VGa(a,b){var c=0,d=0;c=Za-16|0;Za=c;HQ(c+8|0,b);b=pb(c+8|0);d=Xb(a,Kb(c,c+8|0));if((b|0)==(d|0)){Jb(a,pb(c+8|0))}Za=c+16|0;return(b|0)==(d|0)}function VEa(a,b){var c=0,d=0;c=Za-16|0;Za=c;ZP(c+8|0,b);b=pb(c+8|0);d=Xb(a,Kb(c,c+8|0));if((b|0)==(d|0)){Jb(a,pb(c+8|0))}Za=c+16|0;return(b|0)==(d|0)}function VAa(a,b){var c=0,d=0;c=Za-16|0;Za=c;wO(c+8|0,b);b=pb(c+8|0);d=Wc(a,Kb(c,c+8|0));if((b|0)==(d|0)){Fc(a,pb(c+8|0))}Za=c+16|0;return(b|0)==(d|0)}function UAa(a,b){var c=0,d=0;c=Za-16|0;Za=c;ny(c+8|0,b);b=pb(c+8|0);d=Wc(a,Kb(c,c+8|0));if((b|0)==(d|0)){Fc(a,pb(c+8|0))}Za=c+16|0;return(b|0)==(d|0)}function Tz(a,b){a=a|0;b=b|0;var c=0;rk(a);c=b+4|0;oi(hb(a),j[a>>2],j[a+4>>2],c);Ib(a,c);Ib(a+4|0,b+8|0);Ib(hb(a),Ob(b));j[b>>2]=j[b+4>>2];Nt(a,Yb(a))}function TKa(a,b,c){var d=0,e=0;d=Za-16|0;Za=d;cU(b,c);c=yb(a,c);if(c){e=Za-16|0;Za=e;Qb(d+8|0,j[b>>2],tc(b));Za=e+16|0;qd(a,d+8|0)}Za=d+16|0;return c}function TAa(a,b){var c=0,d=0;c=Za-16|0;Za=c;wO(c+8|0,b);b=pb(c+8|0);d=Xb(a,Kb(c,c+8|0));if((b|0)==(d|0)){Jb(a,pb(c+8|0))}Za=c+16|0;return(b|0)==(d|0)}function SD(a,b){a=a|0;b=b|0;var c=0;Li(a);c=b+4|0;j3(hb(a),j[a>>2],j[a+4>>2],c);Ib(a,c);Ib(a+4|0,b+8|0);Ib(hb(a),Ob(b));j[b>>2]=j[b+4>>2];Wn(a,ec(a))}function QW(a,b){a=a|0;b=b|0;var c=0;yk(a);c=b+4|0;oi(hb(a),j[a>>2],j[a+4>>2],c);Ib(a,c);Ib(a+4|0,b+8|0);Ib(hb(a),Ob(b));j[b>>2]=j[b+4>>2];Pl(a,Zc(a))}function QCa(a,b){var c=0,d=0;c=Za-16|0;Za=c;kP(c+8|0,b);b=pb(c+8|0);d=Xb(a,Kb(c,c+8|0));if((b|0)==(d|0)){Jb(a,pb(c+8|0))}Za=c+16|0;return(b|0)==(d|0)}function PDa(a,b){var c=0,d=0;c=Za-16|0;Za=c;Iy(c+8|0,b);b=pb(c+8|0);d=Xb(a,Kb(c,c+8|0));if((b|0)==(d|0)){Jb(a,pb(c+8|0))}Za=c+16|0;return(b|0)==(d|0)}function Og(a,b){a=a|0;b=b|0;var c=0;$e(a);c=b+4|0;oi(hb(a),j[a>>2],j[a+4>>2],c);Ib(a,c);Ib(a+4|0,b+8|0);Ib(hb(a),Ob(b));j[b>>2]=j[b+4>>2];Pj(a,sb(a))}function NCa(a,b){var c=0,d=0;c=Za-16|0;Za=c;kP(c+8|0,b);b=pb(c+8|0);d=Wc(a,Kb(c,c+8|0));if((b|0)==(d|0)){Fc(a,pb(c+8|0))}Za=c+16|0;return(b|0)==(d|0)}function KEa(a,b){var c=0,d=0;c=Za-16|0;Za=c;RP(c+8|0,b);b=pb(c+8|0);d=Xb(a,Kb(c,c+8|0));if((b|0)==(d|0)){Jb(a,pb(c+8|0))}Za=c+16|0;return(b|0)==(d|0)}function JHa(a,b){var c=0,d=0;c=Za-16|0;Za=c;Zs(c+8|0,b);b=pb(c+8|0);d=Wc(a,Kb(c,c+8|0));if((b|0)==(d|0)){Fc(a,pb(c+8|0))}Za=c+16|0;return(b|0)==(d|0)}function JDa(a,b){var c=0,d=0;c=Za-16|0;Za=c;Hz(c+8|0,b);b=pb(c+8|0);d=Wc(a,Kb(c,c+8|0));if((b|0)==(d|0)){Fc(a,pb(c+8|0))}Za=c+16|0;return(b|0)==(d|0)}function ILa(a,b){var c=0,d=0;c=Za-16|0;Za=c;MS(c+8|0,b);b=pb(c+8|0);d=Wc(a,Kb(c,c+8|0));if((b|0)==(d|0)){Fc(a,pb(c+8|0))}Za=c+16|0;return(b|0)==(d|0)}function IHa(a,b){var c=0,d=0;c=Za-16|0;Za=c;Zs(c+8|0,b);b=pb(c+8|0);d=Xb(a,Kb(c,c+8|0));if((b|0)==(d|0)){Jb(a,pb(c+8|0))}Za=c+16|0;return(b|0)==(d|0)}function HLa(a,b){var c=0,d=0;c=Za-16|0;Za=c;MS(c+8|0,b);b=pb(c+8|0);d=Xb(a,Kb(c,c+8|0));if((b|0)==(d|0)){Jb(a,pb(c+8|0))}Za=c+16|0;return(b|0)==(d|0)}function Fwa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;e=Za-16|0;Za=e;a:{if(k[d|0]){Awa(a,vd(e+8|0,b),ci(c,b));break a}ywa(a,vd(e,b),ci(c,b))}Za=e+16|0}function ELa(a,b){var c=0,d=0;c=Za-16|0;Za=c;KS(c+8|0,b);b=pb(c+8|0);d=Wc(a,Kb(c,c+8|0));if((b|0)==(d|0)){Fc(a,pb(c+8|0))}Za=c+16|0;return(b|0)==(d|0)}function DLa(a,b){var c=0,d=0;c=Za-16|0;Za=c;KS(c+8|0,b);b=pb(c+8|0);d=Xb(a,Kb(c,c+8|0));if((b|0)==(d|0)){Jb(a,pb(c+8|0))}Za=c+16|0;return(b|0)==(d|0)}function DKa(a,b){var c=0,d=0;c=Za-16|0;Za=c;Hz(c+8|0,b);b=pb(c+8|0);d=Xb(a,Kb(c,c+8|0));if((b|0)==(d|0)){Jb(a,pb(c+8|0))}Za=c+16|0;return(b|0)==(d|0)}function DFa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=Za-32|0;Za=c;d=c,e=_g(b),j[d+16>>2]=e;yFa(c+24|0,a,b,c+16|0,c+8|0);a=Sg(c+24|0);Za=c+32|0;return a+4|0}function CKa(a,b){var c=0,d=0;c=Za-16|0;Za=c;hS(c+8|0,b);b=pb(c+8|0);d=Wc(a,Kb(c,c+8|0));if((b|0)==(d|0)){Fc(a,pb(c+8|0))}Za=c+16|0;return(b|0)==(d|0)}function BY(a,b){a=a|0;b=b|0;var c=0;pC(a);c=b+4|0;oi(Ek(a),j[a>>2],j[a+4>>2],c);Ib(a,c);Ib(a+4|0,b+8|0);Ib(nq(a),Ob(b));j[b>>2]=j[b+4>>2];$B(a,sb(a))}function BKa(a,b){var c=0,d=0;c=Za-16|0;Za=c;hS(c+8|0,b);b=pb(c+8|0);d=Xb(a,Kb(c,c+8|0));if((b|0)==(d|0)){Jb(a,pb(c+8|0))}Za=c+16|0;return(b|0)==(d|0)}function Aza(a,b){var c=0,d=0;c=Za-16|0;Za=c;TN(c+8|0,b);b=pb(c+8|0);d=Wc(a,Kb(c,c+8|0));if((b|0)==(d|0)){Fc(a,pb(c+8|0))}Za=c+16|0;return(b|0)==(d|0)}function $oa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=Za-32|0;Za=c;d=c,e=_g(b),j[d+16>>2]=e;Ooa(c+24|0,a,b,c+16|0,c+8|0);a=Sg(c+24|0);Za=c+32|0;return a+8|0}function $Aa(a,b){var c=0,d=0;c=Za-16|0;Za=c;ny(c+8|0,b);b=pb(c+8|0);d=Xb(a,Kb(c,c+8|0));if((b|0)==(d|0)){Jb(a,pb(c+8|0))}Za=c+16|0;return(b|0)==(d|0)}function wU(a,b){var c=0,d=0;c=Za-16|0;Za=c;Rp(c+8|0,b);b=pb(c+8|0);d=Wc(a,Kb(c,c+8|0));if((b|0)==(d|0)){Fc(a,pb(c+8|0))}Za=c+16|0;return(b|0)==(d|0)}function vU(a,b){var c=0,d=0;c=Za-16|0;Za=c;Rp(c+8|0,b);b=pb(c+8|0);d=Xb(a,Kb(c,c+8|0));if((b|0)==(d|0)){Jb(a,pb(c+8|0))}Za=c+16|0;return(b|0)==(d|0)}function uk(a,b){var c=0;c=j[j[b>>2]-12>>2];j[114630]=0;b=H(27,b+c|0)|0;c=j[114630];j[114630]=0;if((c|0)!=1){j[a>>2]=b;return a}J(0)|0;C()|0;ib();z()}function uEa(a,b){var c=0;zGa(a);j[a>>2]=76636;c=j[b+4>>2];j[a+24>>2]=j[b>>2];j[a+28>>2]=c;c=j[b+12>>2];j[a+32>>2]=j[b+8>>2];j[a+36>>2]=c;h[a+40|0]=0}function r2(a,b,c){var d=0;d=Za-16|0;Za=d;Vu(d,b,c,2);b=j[d+4>>2];j[a>>2]=j[d>>2];j[a+4>>2]=b;b=j[d+12>>2];j[a+8>>2]=j[d+8>>2];j[a+12>>2]=b;Za=d+16|0}function qU(a,b,c){a=a+4|0;a=k[a|0]|k[a+1|0]<<8|(k[a+2|0]<<16|k[a+3|0]<<24);return!c&b>>>0>=(a<<24|a<<8&16711680|(a>>>8&65280|a>>>24))-8>>>0|(c|0)!=0}function mI(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=Za-32|0;Za=c;d=c,e=_g(b),j[d+16>>2]=e;Ria(c+24|0,a,b,c+16|0,c+8|0);a=Sg(c+24|0);Za=c+32|0;return a+4|0}function kN(a,b){var c=0,d=0;c=Za-16|0;Za=c;$g(c+8|0,b);b=pb(c+8|0);d=Wc(a,Kb(c,c+8|0));if((b|0)==(d|0)){Fc(a,pb(c+8|0))}Za=c+16|0;return(b|0)==(d|0)}function hW(a,b,c,d){var e=0;if(!d){return-1}b=a+b|0;e=-1;a:{while(1){if((a|0)==(b|0)){break a}b=b-1|0;if(!Gn(c,d,b)){continue}break}e=b-a|0}return e}function cba(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;if(fq(a)>>>0<b>>>0){Oc();z()}hb(a);c=NF(b);j[a>>2]=c;j[a+4>>2]=c;d=hb(a),e=(b<<4)+c|0,j[d>>2]=e;Pl(a,0)}function Zt(a,b){var c=0,d=0;c=Za-16|0;Za=c;Yt(c+8|0,b);b=pb(c+8|0);d=Xb(a,Kb(c,c+8|0));if((b|0)==(d|0)){Jb(a,pb(c+8|0))}Za=c+16|0;return(b|0)==(d|0)}function ZZ(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;while(1){if((b|0)!=(c|0)){a=h[b|0];h[e|0]=(a|0)>-1?a:d;e=e+1|0;b=b+1|0;continue}break}return c|0}function YX(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0;c=ne(b);d=ue(c+13|0);j[d+8>>2]=0;j[d+4>>2]=c;j[d>>2]=c;e=a,f=Vb(d+12|0,b,c+1|0),j[e>>2]=f;return a|0}function Xp(a,b){var c=0,d=0;c=Za-16|0;Za=c;$g(c+8|0,b);b=pb(c+8|0);d=Xb(a,Kb(c,c+8|0));if((b|0)==(d|0)){Jb(a,pb(c+8|0))}Za=c+16|0;return(b|0)==(d|0)}function Wc(a,b){var c=0,d=0,e=0,f=0,g=0;c=Za-16|0;Za=c;a=(e=a,f=j[a+12>>2],g=Kb(c+8|0,b),d=j[j[a>>2]+32>>2],bb[d](e|0,f|0,g|0)|0);Za=c+16|0;return a}function OBa(a,b,c){var d=0;d=ri(a+8|0);j[114630]=0;I(421,a|0,b|0,c|0);a=j[114630];j[114630]=0;if((a|0)!=1){return}a=D()|0;C()|0;xg(d);G(a|0);z()}



function Nna(a){j[a>>2]=0;j[a+4>>2]=0;j[a+32>>2]=0;j[a+36>>2]=1072693248;j[a+24>>2]=0;j[a+28>>2]=0;j[a+16>>2]=0;j[a+20>>2]=0;j[a+8>>2]=0;j[a+12>>2]=0}function LLa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;if(fq(a)>>>0<b>>>0){Oc();z()}hb(a);c=zS(b);j[a>>2]=c;j[a+4>>2]=c;d=hb(a),e=(b<<4)+c|0,j[d>>2]=e;Pl(a,0)}function LJ(a){if(j[a+480224>>2]==2){return+m[a+1074420>>2]*1e-4}return+m[a+24620>>2]*60/(+m[a+1074404>>2]*+(p(j[a+1074408>>2],j[a+1074416>>2])>>>0))}function Kp(a,b){var c=0,d=0;c=Za-16|0;Za=c;qk(c+8|0,b);b=pb(c+8|0);d=Xb(a,Kb(c,c+8|0));if((b|0)==(d|0)){Jb(a,pb(c+8|0))}Za=c+16|0;return(b|0)==(d|0)}function JU(a,b){var c=0,d=0;c=Za-16|0;Za=c;Yt(c+8|0,b);b=pb(c+8|0);d=Wc(a,Kb(c,c+8|0));if((b|0)==(d|0)){Fc(a,pb(c+8|0))}Za=c+16|0;return(b|0)==(d|0)}function JAa(a,b){a=a|0;b=b|0;a:{if(a>>>0>=515){a=hf(b);hf(b);break a}a=Of(b);Of(b)}if(a){while(1){if(a&1){Jb(b,260)}a=a>>>1|0;if(a){continue}break}}}function G9(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;if(PD(a)>>>0<b>>>0){Oc();z()}hb(a);c=aL(b);j[a>>2]=c;j[a+4>>2]=c;d=hb(a),e=p(b,12)+c|0,j[d>>2]=e;Wn(a,0)}function G8(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;if(c){e=d<<2;a=0;while(1){if(d){Ab(j[(a<<2)+b>>2],0,e)}a=a+1|0;if((c|0)!=(a|0)){continue}break}}}function Ff(a,b){var c=0,d=0;c=Za-16|0;Za=c;Up(c+8|0,b);b=pb(c+8|0);d=Xb(a,Kb(c,c+8|0));if((b|0)==(d|0)){Jb(a,pb(c+8|0))}Za=c+16|0;return(b|0)==(d|0)}function FV(a,b){var c=0,d=0;c=Za-16|0;Za=c;$A(c+8|0,b);b=pb(c+8|0);d=Wc(a,Kb(c,c+8|0));if((b|0)==(d|0)){Fc(a,pb(c+8|0))}Za=c+16|0;return(b|0)==(d|0)}function F8(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;if(c){e=d<<3;a=0;while(1){if(d){Ab(j[(a<<2)+b>>2],0,e)}a=a+1|0;if((c|0)!=(a|0)){continue}break}}}function EV(a,b){var c=0,d=0;c=Za-16|0;Za=c;ZA(c+8|0,b);b=pb(c+8|0);d=Wc(a,Kb(c,c+8|0));if((b|0)==(d|0)){Fc(a,pb(c+8|0))}Za=c+16|0;return(b|0)==(d|0)}function Di(a){var b=0;b=R(8)|0;j[114630]=0;E(214,b|0,a|0)|0;a=j[114630];j[114630]=0;if((a|0)!=1){X(b|0,71672,24);z()}a=D()|0;C()|0;S(b|0);G(a|0);z()}function Cza(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;if(Mm(a)>>>0<b>>>0){Oc();z()}hb(a);c=RN(b);j[a>>2]=c;j[a+4>>2]=c;d=hb(a),e=(b<<2)+c|0,j[d>>2]=e;Pj(a,0)}function BV(a,b){var c=0,d=0;c=Za-16|0;Za=c;$A(c+8|0,b);b=pb(c+8|0);d=Xb(a,Kb(c,c+8|0));if((b|0)==(d|0)){Jb(a,pb(c+8|0))}Za=c+16|0;return(b|0)==(d|0)}function AV(a,b){var c=0,d=0;c=Za-16|0;Za=c;ZA(c+8|0,b);b=pb(c+8|0);d=Xb(a,Kb(c,c+8|0));if((b|0)==(d|0)){Jb(a,pb(c+8|0))}Za=c+16|0;return(b|0)==(d|0)}function AP(a,b){var c=0,d=0;c=Za-16|0;Za=c;iz(c+8|0,b);b=pb(c+8|0);d=Xb(a,Kb(c,c+8|0));if((b|0)==(d|0)){Jb(a,pb(c+8|0))}Za=c+16|0;return(b|0)==(d|0)}function uQ(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;if(oz(a)>>>0<b>>>0){Oc();z()}hb(a);c=XP(b);j[a>>2]=c;j[a+4>>2]=c;d=hb(a),e=p(b,6)+c|0,j[d>>2]=e;gt(a,0)}function oc(a){var b=0;b=R(8)|0;j[114630]=0;E(23,b|0,a|0)|0;a=j[114630];j[114630]=0;if((a|0)!=1){X(b|0,71620,24);z()}a=D()|0;C()|0;S(b|0);G(a|0);z()}function kya(a,b){a=a|0;b=b|0;var c=0,d=0;d=Za-96|0;Za=d;c=-1;a:{if(!$N(a,d)){break a}c=0;if(!pN(d)){break a}c=Me(a,b,oN(d),ab)}Za=d+96|0;return c|0}function ky(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;if(pA(a)>>>0<b>>>0){Oc();z()}hb(a);c=hT(b);j[a>>2]=c;j[a+4>>2]=c;d=hb(a),e=(b<<1)+c|0,j[d>>2]=e;Nt(a,0)}function bxa(a,b){a=a|0;b=b|0;var c=0,d=0;d=Za-48|0;Za=d;c=-1;a:{if(!jN(a,d)){break a}c=0;if(!ZM(d)){break a}c=Me(a,b,YM(d),ab)}Za=d+48|0;return c|0}function Yxa(a,b){a=a|0;b=b|0;var c=0,d=0;d=Za-48|0;Za=d;c=-1;a:{if(!jN(a,d)){break a}c=0;if(!iN(d)){break a}c=Me(a,b,hN(d),ab)}Za=d+48|0;return c|0}function Yla(a,b,c){var d=0,e=0;d=b-a|0;if((d|0)>=3){d=d>>>1|0;while(1){jJ(a,b-2|0);Qw(a,c,d-1|0,a);b=b-2|0;e=(d|0)>2;d=d-1|0;if(e){continue}break}}}function VS(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;if(Mm(a)>>>0<b>>>0){Oc();z()}hb(a);c=$K(b);j[a>>2]=c;j[a+4>>2]=c;d=hb(a),e=(b<<2)+c|0,j[d>>2]=e;Pj(a,0)}function K$(a){var b=0,c=0;b=Za-16|0;Za=b;a:{if(qe(a)){c=j[a>>2];j[b+12>>2]=0;ye(c,b+12|0);ee(a,0);break a}j[b+8>>2]=0;ye(a,b+8|0);Ue(a,0)}Za=b+16|0}function Jza(a,b){a=a|0;b=b|0;var c=0,d=0;d=Za-96|0;Za=d;c=-1;a:{if(!$N(a,d)){break a}c=0;if(!_N(d)){break a}c=Me(a,b,ZN(d),ab)}Za=d+96|0;return c|0}function F_(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;if(bC(a)>>>0<b>>>0){Oc();z()}c=aC(Ek(a),b);j[a>>2]=c;j[a+4>>2]=c;d=nq(a),e=(b<<2)+c|0,j[d>>2]=e;$B(a,0)}function Dsa(a,b,c,d){var e=0;if((b|0)!=(c|0)){e=j[d>>2];while(1){c=c-32|0;YL(a,e-32|0,c);e=j[d>>2]-32|0;j[d>>2]=e;if((b|0)!=(c|0)){continue}break}}}function Ce(a){var b=0,c=0;b=Za-16|0;Za=b;a:{if(qe(a)){c=j[a>>2];h[b+15|0]=0;Sd(c,b+15|0);ee(a,0);break a}h[b+14|0]=0;Sd(a,b+14|0);Ue(a,0)}Za=b+16|0}function BDa(a,b,c,d){var e=0;if((b|0)!=(c|0)){e=j[d>>2];while(1){c=c-24|0;CP(a,e-24|0,c);e=j[d>>2]-24|0;j[d>>2]=e;if((b|0)!=(c|0)){continue}break}}}function AJa(a,b,c,d){var e=0;if((b|0)!=(c|0)){e=j[d>>2];while(1){c=c-24|0;tp(a,e-24|0,c);e=j[d>>2]-24|0;j[d>>2]=e;if((b|0)!=(c|0)){continue}break}}}function vX(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;if(Qf(a,j[b+8>>2],f)){wu(b,c,d,e);return}a=j[a+8>>2];bb[j[j[a>>2]+20>>2]](a,b,c,d,e,f)}function uY(a,b,c){var d=0;d=Za-16|0;Za=d;j[d+8>>2]=c;while(1){if((a|0)!=(b|0)){FD(d+8|0,j[a>>2]);a=a+4|0;continue}break}Za=d+16|0;return j[d+8>>2]}function paa(a){a=a|0;var b=0,c=0;b=Za-16|0;Za=b;c=j[a+4>>2];a=j[a>>2];j[b>>2]=a;j[b+4>>2]=c;j[b+8>>2]=a;j[b+12>>2]=c;a=Rla(b);Za=b+16|0;return a|0}function oV(a,b,c,d){var e=0;if((b|0)!=(c|0)){e=j[d>>2];while(1){c=c-32|0;SA(a,e-32|0,c);e=j[d>>2]-32|0;j[d>>2]=e;if((b|0)!=(c|0)){continue}break}}}function l8(a,b,c,d){var e=0;if((b|0)!=(c|0)){e=j[d>>2];while(1){c=c-16|0;MF(a,e-16|0,c);e=j[d>>2]-16|0;j[d>>2]=e;if((b|0)!=(c|0)){continue}break}}}function j3(a,b,c,d){var e=0;if((b|0)!=(c|0)){e=j[d>>2];while(1){c=c-12|0;hv(a,e-12|0,c);e=j[d>>2]-12|0;j[d>>2]=e;if((b|0)!=(c|0)){continue}break}}}function iJa(a,b){var c=0,d=0;c=Za-16|0;Za=c;d=yb(a,64);a:{if(d){uz(c+8|0,b);qd(a,c+8|0);break a}a=Za-16|0;Za=a;eJa(b);Za=a+16|0}Za=c+16|0;return d}function Zra(a,b){var c=0,d=0;c=Za-16|0;Za=c;d=yb(a,27);a:{if(d){DL(c+8|0,b);qd(a,c+8|0);break a}a=Za-16|0;Za=a;Qra(b);Za=a+16|0}Za=c+16|0;return d}function UKa(a,b,c){var d=0;d=Za-16|0;Za=d;j[d+12>>2]=c;c=0;if(Ff(a,d+8|0)){j[d+4>>2]=k[d+8|0];c=yKa(a,b,j[tb(d+4|0,d+12|0)>>2])}Za=d+16|0;return c}function SLa(a,b){var c=0,d=0;c=Za-16|0;Za=c;d=yb(a,16);a:{if(d){JS(c+8|0,b);qd(a,c+8|0);break a}a=Za-16|0;Za=a;CLa(b);Za=a+16|0}Za=c+16|0;return d}function OHa(a,b){var c=0,d=0;c=Za-16|0;Za=c;d=yb(a,64);a:{if(d){uz(c+8|0,b);qd(a,c+8|0);break a}a=Za-16|0;Za=a;BHa(b);Za=a+16|0}Za=c+16|0;return d}function Lx(a,b,c){a=a|0;b=b|0;c=c|0;a:{if(!ke(a)){break a}Rm(a);if(c){jka(a,b)}if((Pp(a)|0)==2){wta(a,b);return}if((Pp(a)|0)!=1){break a}vta(a,b)}}function HU(a,b){a=a|0;b=b|0;var c=0;b=Za-48|0;Za=b;c=-1;a:{if(!GA(a,b+8|0)){break a}c=0;if(!YI(b+8|0)){break a}c=sla(a,b+8|0)}Za=b+48|0;return c|0}function zAa(a,b){var c=0,d=0;c=Za-16|0;Za=c;d=yb(a,6);a:{if(d){iz(c+8|0,b);qd(a,c+8|0);break a}a=Za-16|0;Za=a;rAa(b);Za=a+16|0}Za=c+16|0;return d}function vY(a,b,c){var d=0;d=Za-16|0;Za=d;j[d+8>>2]=c;while(1){if((a|0)!=(b|0)){GD(d+8|0,h[a|0]);a=a+1|0;continue}break}Za=d+16|0;return j[d+8>>2]}function sv(a,b){var c=0,d=0;c=b&1?a:1;if(b+1>>>0>=3){d=b;while(1){a=a*a;d=(d|0)/2|0;c=d&1?a*c:c;if(d+1>>>0>2){continue}break}}return(b|0)<0?1/c:c}function kwa(a){var b=0,c=0;qQ(a);a:{while(1){c=a+b|0;if(k[c|0]){b=b+1|0;if((b|0)!=32){continue}break a}break}if(b>>>0>31){break a}Ab(c,0,32-b|0)}}function hX(a,b,c,d,e,f,g,h,i,j,k,l){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;return Tda(a,b,c,d,e,f,g,h,i,j,k,l)|0}function Yka(a,b){a=a|0;b=b|0;var c=0;if(!(k[b+14|0]&48|k[b+17|0]!=173)){Kc(a,8,1,0,11);return}c=a;a=b+14|0;Kc(c,k[a|0]&16?16:8,k[a|0]&32?3:1,0,2)}function Y8(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0;h=Za-32|0;Za=h;UF(h+8|0,b,c,d,e,f,g);Mc(a,h+20|0);Lm(h+8|0);Za=h+32|0}function XKa(a,b,c){var d=0;d=Za-16|0;Za=d;j[d+12>>2]=c;c=0;if(Ff(a,d+8|0)){j[d+4>>2]=k[d+8|0];c=gS(a,b,j[tb(d+4|0,d+12|0)>>2])}Za=d+16|0;return c}function WKa(a,b,c){var d=0;d=Za-16|0;Za=d;j[d+12>>2]=c;c=0;if(Ff(a,d+8|0)){j[d+4>>2]=k[d+8|0];c=fS(a,b,j[tb(d+4|0,d+12|0)>>2])}Za=d+16|0;return c}function VKa(a,b,c){var d=0;d=Za-16|0;Za=d;j[d+12>>2]=c;c=0;if(Ff(a,d+8|0)){j[d+4>>2]=k[d+8|0];c=eS(a,b,j[tb(d+4|0,d+12|0)>>2])}Za=d+16|0;return c}function VBa(a,b){var c=0,d=0;c=Za-16|0;Za=c;d=yb(a,2);a:{if(d){qk(c+8|0,b);qd(a,c+8|0);break a}a=Za-16|0;Za=a;IBa(b);Za=a+16|0}Za=c+16|0;return d}function QJa(a,b,c){var d=0;d=Za-16|0;Za=d;j[d+12>>2]=c;c=0;if(Ff(a,d+8|0)){j[d+4>>2]=k[d+8|0];c=MR(a,b,j[tb(d+4|0,d+12|0)>>2])}Za=d+16|0;return c}function Ou(a){var b=0,c=0;j[114630]=0;c=T(2567)|0;b=j[114630];j[114630]=0;if((b|0)!=1){b=a;a=j[c>>2];j[b>>2]=a;Ll(a);return}J(0)|0;C()|0;ib();z()}function LJa(a,b){var c=0,d=0;c=Za-16|0;Za=c;d=yb(a,8);a:{if(d){Yt(c+8|0,b);qd(a,c+8|0);break a}a=Za-16|0;Za=a;qJa(b);Za=a+16|0}Za=c+16|0;return d}function L8(a,b){a=a|0;b=b|0;var c=0,d=0;c=Za-32|0;Za=c;d=j[b+4>>2];j[c+8>>2]=j[b>>2];j[c+12>>2]=d;Xo(a,j[c+8>>2],j[c+12>>2]);Za=c+32|0;return a|0}function L3(a,b){a=a|0;b=b|0;var c=0,d=0;c=j[a+40>>2];while(1){if(c){c=c-1|0;d=c<<2;bb[j[j[a+32>>2]+d>>2]](b,a,j[d+j[a+36>>2]>>2]);continue}break}}function KLa(a,b){var c=0,d=0;c=Za-16|0;Za=c;d=yb(a,3);a:{if(d){Sz(c+8|0,b);qd(a,c+8|0);break a}a=Za-16|0;Za=a;nLa(b);Za=a+16|0}Za=c+16|0;return d}function Fx(a,b,c){var d=0,e=0,f=0;d=Vj(a,b);if((d|0)!=255){e=Nc(a+22|0,d),f=c,i[e>>1]=f;a=a+58|0;e=Pb(a,b),f=255,h[e|0]=f;e=Pb(a,c),f=d,h[e|0]=f}}function Fra(a,b){var c=0,d=0,e=0;while(1){d=d<<1|c>>>31;c=a&1|c<<1;a=(b&1)<<31|a>>>1;b=b>>>1|0;e=e+1|0;if((e|0)!=64){continue}break}ab=d;return c}function D_(){var a=0;td(463424);j[114630]=0;H(2561,463432)|0;a=j[114630];j[114630]=0;if((a|0)!=1){j[115856]=67788;return}a=D()|0;C()|0;G(a|0);z()}function C_(){var a=0;td(463440);j[114630]=0;H(2561,463448)|0;a=j[114630];j[114630]=0;if((a|0)!=1){j[115860]=67944;return}a=D()|0;C()|0;G(a|0);z()}function zla(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=j[b+4>>2];j[a>>2]=j[b>>2];j[a+4>>2]=d;d=j[b+12>>2];j[a+8>>2]=j[b+8>>2];j[a+12>>2]=d;Dx(a,o[c>>3])}function u6(a,b,c){a:{if((a|0)==(b|0)){break a}c=l[c>>1];while(1){if((c|0)==l[a>>1]){break a}a=a+2|0;if((b|0)!=(a|0)){continue}break}a=b}return a}function Z8(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0;h=Za-32|0;Za=h;UF(h+8|0,b,c,d,e,f,g);Mc(a,h+8|0);Lm(h+8|0);Za=h+32|0}function Pha(a,b,c,d){var e=0;if((b|0)!=(c|0)){e=j[d>>2];while(1){c=c-4|0;aI(a,e-4|0,c);e=j[d>>2]-4|0;j[d>>2]=e;if((b|0)!=(c|0)){continue}break}}}function PK(a,b){var c=0,d=0;c=Vb(a,b,602);a=0;while(1){d=p(a,896);Or((d+c|0)+608|0,(b+d|0)+608|0);a=a+1|0;if((a|0)!=256){continue}break}return c}function HE(a,b){a:{b:{if(k[a+23|0]){a=1;if((b|0)!=255){break b}Y(52206,50512,1165,52221);z()}if((b|0)!=255){break a}a=0}return a}return b>>>0>10}function Eu(a,b,c,d){var e=0;e=Tl(a,b,c);if(rd(d,c)){Ib(c,d);if(!rd(c,b)){return e+1|0}Ib(b,c);if(!rd(b,a)){return e+2|0}Ib(a,b);e=e+3|0}return e}function $G(a){var b=0;b=(we(j[a+16>>2])>>>0)/(bi(q(n[a+4208>>2]*q(999)))+1>>>0)|0;b=b>>>0>2?b:2;j[a+4216>>2]=b;j[a+4220>>2]=b>>>1;jc(a+4224|0,b)}function y5(a,b){var c=0;b=b<<1;c=a+1092|0;a:{b:{if((b|0)==j[a+112>>2]){break b}c=0;if((b|0)!=j[a+116>>2]){break a}c=a+1096|0}c=j[c>>2]}return c}function sD(a,b,c){var d=0;d=Za-144|0;Za=d;d=Ab(d,0,144);j[d+76>>2]=-1;j[d+44>>2]=a;j[d+32>>2]=2416;j[d+84>>2]=a;a=J2(d,b,c);Za=d+144|0;return a}function qv(a){var b=0,c=0;b=Za-16|0;Za=b;c=-1;a:{if(oE(a)){break a}if((bb[j[a+32>>2]](a,b+15|0,1)|0)!=1){break a}c=k[b+15|0]}Za=b+16|0;return c}function oJa(a){var b=0;b=j[a+4>>2];a=j[a>>2];j[114630]=0;a=E(532,a|0,b|0)|0;b=j[114630];j[114630]=0;if((b|0)!=1){return a}J(0)|0;C()|0;ib();z()}function eo(a,b){var c=0;a:{if(!_E(b)|(k[b+1|0]^k[a+1|0])>>>0>1){break a}b=k[b+2|0];a=k[a+2|0];if((b^a)&12){break a}c=b>>>0<16^a>>>0>15}return c}function _la(a,b,c){var d=0,e=0;b=b-a|0;if((b|0)>=3){d=b>>1;b=(d-2|0)/2|0;while(1){Qw(a,c,d,(b<<1)+a|0);e=(b|0)>0;b=b-1|0;if(e){continue}break}}}function Uma(a,b,c){h[a+6|0]=255;j[a+16>>2]=0;i[a+4>>1]=0;j[a>>2]=0;if(!((b|0)==65535|(c|0)==-1)){j[a+8>>2]=c;j[a+16>>2]=2;i[a+12>>1]=b}return a}function Dg(a,b){a=a|0;b=b|0;var c=0;c=Za-16|0;Za=c;h[c+15|0]=0;a=zk(a,c+15|0,1);h[c+8|0]=k[c+15|0];h[b|0]=k[c+8|0];Za=c+16|0;return!ab&(a|0)==1}function zm(a,b,c){a:{if((a|0)==(b|0)){break a}c=k[c|0];while(1){if((c|0)==k[a|0]){break a}a=a+1|0;if((b|0)!=(a|0)){continue}break}a=b}return a}function uu(a,b,c,d,e,f){var g=0,h=0,i=0;g=j[a+4>>2];h=g>>8;a=j[a>>2];i=a;if(g&1){h=j[j[d>>2]+h>>2]}bb[j[j[a>>2]+20>>2]](i,b,c,d+h|0,g&2?e:2,f)}function sy(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=Za-16|0;Za=d;i[d+14>>1]=b;i[d+12>>1]=c;if((b|0)!=(c|0)){aBa(Lb(a),Mb(a),d+14|0,d+12|0)}Za=d+16|0}function rza(a){var b=0;b=j[a+4>>2];a=j[a>>2];j[114630]=0;a=E(79,a|0,b|0)|0;b=j[114630];j[114630]=0;if((b|0)!=1){return a}J(0)|0;C()|0;ib();z()}function rp(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;if(lS(a)>>>0<b>>>0){Oc();z()}hb(a);c=Rh(b);j[a>>2]=c;j[a+4>>2]=c;d=hb(a),e=b+c|0,j[d>>2]=e;wS(a,0)}function n8(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=j[b>>2];j[a>>2]=d;j[j[d-12>>2]+a>>2]=j[b+4>>2];j[a+4>>2]=0;nr(j[j[a>>2]-12>>2]+a|0,c);return a|0}function eIa(a,b){a=a|0;b=b|0;var c=0;a=Kc(a,8,1,0,1);c=2;b=b+13|0;a:{if(!(k[b|0]&64)){c=0;if(!(k[b|0]&2)){break a}}ej(a,c)}if(k[b|0]&4){lz(a)}}function V5(a,b,c,d){if(d){XE(a,b,48800,d);b=p(d,36)+b|0;a=p(d,72)+a|0}if((c|0)==2){L5(a,b,32-d|0);return}XE(a,b,p((c|0)==3,72)+48800|0,32-d|0)}function Qoa(a,b,c){var d=0;d=Wm(a);j[114630]=0;I(109,a|0,b|0,c|0);b=j[114630];j[114630]=0;if((b|0)!=1){return a}a=D()|0;C()|0;Ud(d);G(a|0);z()}function QO(a){var b=0;b=j[a+4>>2];a=j[a>>2];j[114630]=0;a=E(878,a|0,b|0)|0;b=j[114630];j[114630]=0;if((b|0)!=1){return a}J(0)|0;C()|0;ib();z()}function KA(a){var b=0;b=j[a+4>>2];a=j[a>>2];j[114630]=0;a=E(288,a|0,b|0)|0;b=j[114630];j[114630]=0;if((b|0)!=1){return a}J(0)|0;C()|0;ib();z()}function Jo(a){var b=0,c=0,d=0;c=k[a+30|0];d=rh(j[a+24>>2]+484360|0);b=j[a+24>>2]+484360|0;if(c>>>0>=d>>>0){return Eb(b)}return ei(b,k[a+30|0])}function In(a,b){var c=0;c=a;a=b+4|0;return VV(c,k[b|0]|k[b+1|0]<<8|(k[b+2|0]<<16|k[b+3|0]<<24),k[a|0]|k[a+1|0]<<8|(k[a+2|0]<<16|k[a+3|0]<<24))}function $Ia(a){a=a|0;var b=0,c=0,d=0;b=Za-16|0;Za=b;i[b+14>>1]=1;c=b,d=kt(a),i[c+12>>1]=d;a=l[vi(b+14|0,b+12|0)>>1];Za=b+16|0;return a-1&65535}function uwa(a,b,c){a=a|0;b=b|0;c=c|0;a=k[c|0]|k[c+1|0]<<8|(k[c+2|0]<<16|k[c+3|0]<<24);h[b|0]=a;h[b+1|0]=a>>>8;h[b+2|0]=a>>>16;h[b+3|0]=a>>>24}function pb(a){var b=0;b=j[a+4>>2];a=j[a>>2];j[114630]=0;a=E(34,a|0,b|0)|0;b=j[114630];j[114630]=0;if((b|0)!=1){return a}J(0)|0;C()|0;ib();z()}function hwa(a,b,c){var d=0;d=Wm(a);j[114630]=0;I(93,a|0,b|0,c|0);b=j[114630];j[114630]=0;if((b|0)!=1){return a}a=D()|0;C()|0;Ud(d);G(a|0);z()}function Wg(a){var b=0;b=j[a+4>>2];a=j[a>>2];j[114630]=0;a=E(29,a|0,b|0)|0;b=j[114630];j[114630]=0;if((b|0)!=1){return a}J(0)|0;C()|0;ib();z()}function q2(a,b,c,d){d=Za-16|0;Za=d;r2(d,b,c);b=j[d+4>>2];j[a>>2]=j[d>>2];j[a+4>>2]=b;b=j[d+12>>2];j[a+8>>2]=j[d+8>>2];j[a+12>>2]=b;Za=d+16|0}function hLa(a,b){var c=0;c=Za-16|0;Za=c;j[a>>2]=0;j[a+4>>2]=0;j[c+12>>2]=0;Hc(a+8|0,c+12|0,c+8|0);if(b){Ip(a,b);jA(a,b,0)}Za=c+16|0;return a}function hGa(a,b){var c=0,d=0;c=Za-16|0;Za=c;d=yb(a,12);a:{if(d){kz(c+8|0,b);qd(a,c+8|0);break a}h[c+7|0]=0;dj(b,12,c+7|0)}Za=c+16|0;return d}function boa(a,b){var c=0,d=0,e=0;d=k[a|0];e=k[b|0];c=1;a:{if(d>>>0<e>>>0){break a}c=0;if(d>>>0>e>>>0){break a}c=l[a+2>>1]<l[b+2>>1]}return c}function Y3(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;e=j[a+20>>2];d=j[a+16>>2]-e|0;d=c>>>0<d>>>0?c:d;Vb(e,b,d);j[a+20>>2]=d+j[a+20>>2];return c|0}function WG(a){a=a|0;var b=0,c=0;j[a>>2]=81648;b=a+4960|0;c=a+4504|0;while(1){b=b-24|0;xf(b);if((b|0)!=(c|0)){continue}break}Ke(a);return a|0}function T3(a,b){a:{b:{switch(a+1|0){case 0:a=j[114604];break;case 1:break a;default:break b}}b=58408;if((a|0)==28){break a}La();z()}return b}function Mga(a){a=a|0;var b=0;b=Za-16|0;Za=b;GH(b+8|0,a,0);if(Wg(b+8|0)){a=j[a+20>>2];j[a+148>>2]=-1;zJ(a+4|0,j[b+8>>2],j[b+12>>2])}Za=b+16|0}function pT(a){var b=0,c=0;c=HMa(k[a+111|0],0,1536,0);b=ab;a=HMa(k[a+110|0],0,25,0);c=c+a|0;b=ab+b|0;b=a>>>0>c>>>0?b+1|0:b;a=c;ab=b;return a}function nX(a,b,c,d){var e=0,f=0;f=d&65535;d=d>>>16&32767;a:{if((d|0)!=32767){e=4;if(d){break a}return a|c|(b|f)?3:2}e=!(a|c|(b|f))}return e}function jla(a,b){var c=0,d=0,e=0;c=Za-16|0;Za=c;i[a+4>>1]=0;j[a>>2]=b;mb(c+8|0,b+1074308|0,0);d=a,e=kb(c+8|0),h[d+6|0]=e;Za=c+16|0;return a}function g5(a,b,c){var d=0,e=0;if((b|0)>=1){d=(b<<2)+a|0;while(1){j[(e<<2)+a>>2]=d;d=c+d|0;e=e+1|0;if((e|0)!=(b|0)){continue}break}}return a}function IP(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0;return(e=a,f=j[c>>2],g=b,h=pb(c),d=j[j[a>>2]+28>>2],bb[d](e|0,f|0,g|0,h|0)|0)|0}function xya(a,b,c,d){if((b|0)!=(c|0)){a=j[d>>2];while(1){c=c-56|0;wya(a-56|0,c);a=j[d>>2]-56|0;j[d>>2]=a;if((b|0)!=(c|0)){continue}break}}}function ur(a){var b=0;b=o[a+4248>>3]/+(we(j[a+16>>2])>>>0);o[a+4264>>3]=b;if(k[a+4240|0]){o[a+4264>>3]=b*.016666666666666666*o[a+4288>>3]}}function rBa(a){var b=0,c=0,d=0;c=a+20|0;while(1){d=b;b=h[a|0];b=d+((b&255)!=0&(b|0)<32)|0;a=a+1|0;if((c|0)!=(a|0)){continue}break}return b}function qBa(a){var b=0,c=0,d=0;c=a+22|0;while(1){d=b;b=h[a|0];b=d+((b&255)!=0&(b|0)<32)|0;a=a+1|0;if((c|0)!=(a|0)){continue}break}return b}function nxa(a,b,c,d){if((b|0)!=(c|0)){a=j[d>>2];while(1){c=c-12|0;kxa(a-12|0,c);a=j[d>>2]-12|0;j[d>>2]=a;if((b|0)!=(c|0)){continue}break}}}function mja(a,b,c,d){if((b|0)!=(c|0)){a=j[d>>2];while(1){c=c-52|0;kja(a-52|0,c);a=j[d>>2]-52|0;j[d>>2]=a;if((b|0)!=(c|0)){continue}break}}}function jq(a,b,c,d,e){var f=0,g=0,h=0;f=j[a+4>>2];g=f>>8;a=j[a>>2];h=a;if(f&1){g=j[j[c>>2]+g>>2]}bb[j[j[a>>2]+24>>2]](h,b,c+g|0,f&2?d:2,e)}function gO(a){a:{if(_c(a,16624,3)|k[a+3|0]>31|(h[a+27|0]<0|k[a+32|0]>64)){break a}a=a+33|0;if(k[a|0]>32){break a}return k[a|0]!=0}return 0}function cia(a){a=a|0;var b=0,c=0,d=0;b=Za-16|0;Za=b;if(!gd(a,4)){Iu(a)}c=b,d=Lb(a+44|0),j[c>>2]=d;a=j[Cd(b+8|0,b)>>2];Za=b+16|0;return a|0}function bia(a){a=a|0;var b=0,c=0,d=0;b=Za-16|0;Za=b;if(!gd(a,4)){Iu(a)}c=b,d=Mb(a+44|0),j[c>>2]=d;a=j[Cd(b+8|0,b)>>2];Za=b+16|0;return a|0}function Xi(a){if(!(a<2147483647)){return 2147483647}if(!(a>-2147483648)){return-2147483648}if(r(a)<2147483648){return~~a}return-2147483648}function Vra(){var a=0,b=0,c=0,d=0;while(1){b=(a<<3)+85584|0;c=b,d=Nra(a&255),j[c>>2]=d;j[b+4>>2]=ab;a=a+1|0;if((a|0)!=256){continue}break}}function sHa(a,b,c,d){if((b|0)!=(c|0)){a=j[d>>2];while(1){c=c-16|0;Fl(a-16|0,c);a=j[d>>2]-16|0;j[d>>2]=a;if((b|0)!=(c|0)){continue}break}}}function nJa(a,b){a=a|0;b=b|0;var c=0,d=0;b=Za-624|0;Za=b;d=-1;c=a;a=b+8|0;c=hJa(c,a);if(!c){DR(a)}if(c){d=ER(b+8|0)}Za=b+624|0;return d|0}function isa(a){var b=0,c=0;b=Za-16|0;Za=b;c=j[a+4>>2];j[b>>2]=j[a>>2];j[b+4>>2]=c;c=Tj(b+8|0,b);a=j[c>>2];Za=b+16|0;ab=j[c+4>>2];return a}function fua(a,b){var c=0,d=0;if(b){while(1){d=c<<3;j[(c<<2)+a>>2]=(j[(d|4)+a>>2]+j[a+d>>2]|0)/2;c=c+1|0;if((c|0)!=(b|0)){continue}break}}}function fh(a){var b=0;a=a*a;b=a*a;return q(a*-.499999997251031+1+b*.04166662332373906+a*b*(a*2439044879627741e-20+ -.001388676377460993))}function dMa(a,b){var c=0,d=0;c=Za-16|0;Za=c;a:{if(yb(a,256)){d=Za-16|0;Za=d;Qb(c+8|0,b,256);Za=d+16|0;qd(a,c+8|0);break a}kC(b)}Za=c+16|0}function Zya(a,b){a=a|0;b=b|0;var c=0,d=0;b=Za-160|0;Za=b;d=-1;c=a;a=b+8|0;c=tya(c,a);if(!c){vN(a)}if(c){d=GN(b+8|0)}Za=b+160|0;return d|0}function YZ(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;a=Za-16|0;Za=a;j[a+12>>2]=e;j[a+8>>2]=d-c;b=tb(a+12|0,a+8|0);Za=a+16|0;return j[b>>2]}function Xqa(a,b,c,d){if((b|0)!=(c|0)){a=j[d>>2];while(1){c=c-12|0;ay(a-12|0,c);a=j[d>>2]-12|0;j[d>>2]=a;if((b|0)!=(c|0)){continue}break}}}function Tc(a,b){a=a|0;b=b|0;var c=0;c=Za-16|0;Za=c;j[c+8>>2]=a;j[c+12>>2]=b;j[c>>2]=-1;j[c+4>>2]=0;a=Wz(c+8|0,c);Za=c+16|0;return j[a>>2]}function Pxa(a,b){a=a|0;b=b|0;var c=0;c=ec(a);if(c>>>0<b>>>0){Dxa(a,b-c|0);return}if(b>>>0<c>>>0){b=j[a>>2]+p(b,12)|0;ec(a);aN(a,b);rs(a)}}function Iha(a,b){a=a|0;b=b|0;var c=0;c=Te(a);if(c>>>0<b>>>0){rha(a,b-c|0);return}if(b>>>0<c>>>0){b=j[a>>2]+(b<<11)|0;Te(a);MH(a,b);QH(a)}}function Eja(a,b){var c=0,d=0,e=0;if(vI(a)>>>0<b>>>0){Oc();z()}hb(a);c=sI(b);j[a>>2]=c;j[a+4>>2]=c;d=hb(a),e=p(b,52)+c|0,j[d>>2]=e;uI(a,0)}function EGa(a,b){a=a|0;b=b|0;var c=0;c=li(a);if(c>>>0<b>>>0){kGa(a,b-c|0);return}if(b>>>0<c>>>0){b=j[a>>2]+p(b,48)|0;li(a);lR(a,b);vR(a)}}function rEa(a,b){a=a|0;b=b|0;var c=0;c=Zc(a);if(c>>>0<b>>>0){dEa(a,b-c|0);return}if(b>>>0<c>>>0){b=j[a>>2]+(b<<4)|0;Zc(a);yS(a,b);zB(a)}}function qh(a,b,c){a=a|0;b=b|0;c=c|0;a:{if((Vj(a,b)|0)==255){break a}Uj(a,b);No(a,b,0,0);if(!c){break a}a=Pb(a+58|0,b);h[a|0]=k[a|0]|128}}function cta(a,b){var c=0,d=0,e=0;if(UA(a)>>>0<b>>>0){Oc();z()}hb(a);c=ZL(b);j[a>>2]=c;j[a+4>>2]=c;d=hb(a),e=(b<<5)+c|0,j[d>>2]=e;Yp(a,0)}function bj(a){a=a|0;var b=0;b=Za-16|0;Za=b;j[b+12>>2]=a;j[b+8>>2]=0;j[b+4>>2]=255;a=k[zf(b+8|0,Pd(b+12|0,b+4|0))|0];Za=b+16|0;return a|0}function aoa(a,b){var c=0;c=Za-16|0;Za=c;j[c+8>>2]=b;b=j[c+8>>2];b=l[b>>1]|l[b+2>>1]<<16;i[a+4>>1]=0;i[a>>1]=b;i[a+2>>1]=b>>>16;Za=c+16|0}function Nia(a,b){var c=0,d=0,e=0;if(Mm(a)>>>0<b>>>0){Oc();z()}hb(a);c=fI(b);j[a>>2]=c;j[a+4>>2]=c;d=hb(a),e=(b<<2)+c|0,j[d>>2]=e;Pj(a,0)}function NGa(a,b){a=a|0;b=b|0;var c=0;c=Za-32|0;Za=c;h[c+16|0]=44;j[c+8>>2]=-1;j[c+12>>2]=0;j[c>>2]=1042;j[c+4>>2]=2;Nfa(a,b,c);Za=c+32|0}function LK(a){a=50-(p(k[(a>>>4|0)+20368|0],a&15)>>>4|0)|0;a=a>>>0>23863?65536:23863/(a>>>0)|0;return ic((a+119315e4>>>0)/(a<<1>>>0)|0,0)}function Hha(a,b){a=a|0;b=b|0;var c=0;c=sb(a);if(c>>>0<b>>>0){qha(a,b-c|0);return}if(b>>>0<c>>>0){b=j[a>>2]+(b<<2)|0;sb(a);JH(a,b);yg(a)}}function H4(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=b;b=j[b>>2]+15&-16;j[c>>2]=b+16;d=a,e=rv(j[b>>2],j[b+4>>2],j[b+8>>2],j[b+12>>2]),o[d>>3]=e}function FCa(a,b){var c=0,d=0,e=0;if(Mm(a)>>>0<b>>>0){Oc();z()}hb(a);c=dA(b);j[a>>2]=c;j[a+4>>2]=c;d=hb(a),e=(b<<2)+c|0,j[d>>2]=e;Pj(a,0)}function Dc(a){var b=0;b=Za-16|0;Za=b;j[b+12>>2]=a;j[b+8>>2]=-32768;j[b+4>>2]=32767;a=i[zf(b+8|0,Pd(b+12|0,b+4|0))>>1];Za=b+16|0;return a}function Cu(a,b){sm(a);j[a>>2]=71432;j[114630]=0;E(2843,a+4|0,b|0)|0;a=j[114630];j[114630]=0;if((a|0)!=1){return}a=D()|0;C()|0;G(a|0);z()}function pya(a,b){a=a|0;b=b|0;var c=0;c=Za-32|0;Za=c;h[c+16|0]=44;j[c+8>>2]=-1;j[c+12>>2]=0;j[c>>2]=1042;j[c+4>>2]=2;Iz(a,b,c);Za=c+32|0}function owa(a,b){a=a|0;b=b|0;var c=0;c=Za-32|0;Za=c;h[c+16|0]=44;j[c+8>>2]=-1;j[c+12>>2]=0;j[c>>2]=1058;j[c+4>>2]=3;VO(a,b,c);Za=c+32|0}function oGa(a,b){a=a|0;b=b|0;var c=0;c=Za-32|0;Za=c;h[c+16|0]=44;j[c+8>>2]=-1;j[c+12>>2]=0;j[c>>2]=1042;j[c+4>>2]=2;Zq(a,b,c);Za=c+32|0}function cE(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;if(c){d=a;while(1){j[d>>2]=j[b>>2];d=d+4|0;b=b+4|0;c=c-1|0;if(c){continue}break}}return a|0}function aIa(a,b){a=a|0;b=b|0;var c=0,d=0;b=Za-32|0;Za=b;d=-1;c=a;a=b+8|0;c=JHa(c,a);if(!c){$Q(a)}if(c){d=cR(b+8|0)}Za=b+32|0;return d|0}function a9(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0;g=Za-32|0;Za=g;VF(g+8|0,b,c,d,e,f);Mc(a,g+20|0);Lm(g+8|0);Za=g+32|0}function Yoa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=Za-16|0;Za=d;if(b>>>0>=250){Di(20452);z()}mb(d+8|0,a,b);Qd(d+8|0,c);Za=d+16|0;return a|0}function WJa(a,b){a=a|0;b=b|0;var c=0;c=Za-32|0;Za=c;h[c+16|0]=44;j[c+8>>2]=-1;j[c+12>>2]=0;j[c>>2]=1058;j[c+4>>2]=2;tr(a,b,c);Za=c+32|0}function Via(a,b){a=a|0;b=b|0;var c=0;c=Za-32|0;Za=c;h[c+16|0]=44;j[c+8>>2]=-1;j[c+12>>2]=0;j[c>>2]=1058;j[c+4>>2]=1;Zq(a,b,c);Za=c+32|0}function QKa(a,b){a=a|0;b=b|0;var c=0;c=Za-32|0;Za=c;h[c+16|0]=44;j[c+8>>2]=-1;j[c+12>>2]=0;j[c>>2]=1025;j[c+4>>2]=2;Iz(a,b,c);Za=c+32|0}function N6(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;a=Tv(a+8|0,b,c,d,2);if(a>>>0<16){a=k[a+32240|0]}else{a=0}if(a>>>0<=4){return a+1|0}return 0}function MG(a){var b=0,c=q(0);if(!a){return q(1)}if((a|0)>=-99999){b=+(a|0)*.0016609640474436812;c=q(Cg(b-x(b+.5)))}else{c=q(0)}return c}function M6(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;a=Tv(a+8|0,b,c,d,3);if(a>>>0<43){a=k[a+32192|0]}else{a=0}if(a>>>0<=4){return a+1|0}return 0}function AEa(a,b){a=a|0;b=b|0;var c=0,d=0;b=Za-16|0;Za=b;d=-1;c=a;a=b+8|0;c=JDa(c,a);if(!c){jS(a)}if(c){d=PP(b+8|0)}Za=b+16|0;return d|0}function zy(a,b){a=a|0;b=b|0;var c=0;c=Za-32|0;Za=c;h[c+16|0]=44;j[c+8>>2]=-1;j[c+12>>2]=0;j[c>>2]=1058;j[c+4>>2]=2;VO(a,b,c);Za=c+32|0}function zba(a,b,c,d,e){var f=0,g=0;f=Za-16|0;Za=f;j[f+8>>2]=j[a+8>>2];g=j[a+4>>2];j[f>>2]=j[a>>2];j[f+4>>2]=g;aua(f,b,c,d,e);Za=f+16|0}function y_(a,b){a=a|0;b=b|0;var c=0;c=sb(a);if(c>>>0<b>>>0){w_(a,b-c|0);return}if(b>>>0<c>>>0){b=j[a>>2]+(b<<2)|0;sb(a);ZB(a,b);xC(a)}}function vb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=Za-16|0;Za=d;if(b>>>0>=110){Di(12352);z()}mb(d+8|0,a,b);Qd(d+8|0,c);Za=d+16|0;return a|0}function t6(a,b){a=a|0;b=b|0;var c=0;c=Za-32|0;Za=c;h[c+16|0]=44;j[c+8>>2]=-1;j[c+12>>2]=0;j[c>>2]=1025;j[c+4>>2]=4;Zq(a,b,c);Za=c+32|0}function qB(a){a=a|0;var b=0;a=Qc(a);j[114630]=0;E(238,a|0,7090)|0;b=j[114630];j[114630]=0;if((b|0)==1){b=D()|0;C()|0;gb(a);G(b|0);z()}}function k6(a,b){a=a|0;b=b|0;var c=0;c=Za-32|0;Za=c;h[c+16|0]=44;j[c+8>>2]=-1;j[c+12>>2]=0;j[c>>2]=1025;j[c+4>>2]=2;Zq(a,b,c);Za=c+32|0}function ipa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=Za-16|0;Za=d;if(b>>>0>=43){Di(20452);z()}mb(d+8|0,a,b);Qd(d+8|0,c);Za=d+16|0;return a|0}function iKa(a,b){a=a|0;b=b|0;var c=0;c=Za-32|0;Za=c;h[c+16|0]=44;j[c+8>>2]=-1;j[c+12>>2]=0;j[c>>2]=274;j[c+4>>2]=0;Iz(a,b,c);Za=c+32|0}function hpa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=Za-16|0;Za=d;if(b>>>0>=16){Di(20452);z()}qj(d+8|0,a,b);Qd(d+8|0,c);Za=d+16|0;return a|0}function fj(a){var b=0;b=a+28|0;a=b;if((k[a|0]|k[a+1|0]<<8|(k[a+2|0]<<16|k[a+3|0]<<24))>>>0>=128){a=k[b|0]^-128}else{a=255}return a&255}function b9(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0;g=Za-32|0;Za=g;VF(g+8|0,b,c,d,e,f);Mc(a,g+8|0);Lm(g+8|0);Za=g+32|0}function _8(a,b,c){b=Cf(a,b);j[114630]=0;E(120,a+12|0,c|0)|0;a=j[114630];j[114630]=0;if((a|0)!=1){return}a=D()|0;C()|0;gb(b);G(a|0);z()}function KW(a,b){a=a|0;b=b|0;var c=0;c=Za-32|0;Za=c;h[c+16|0]=44;j[c+8>>2]=-1;j[c+12>>2]=0;j[c>>2]=1058;j[c+4>>2]=2;Kw(a,b,c);Za=c+32|0}function Jd(a,b){a=a|0;b=b|0;return(k[a|0]|k[a+1|0]<<8|(k[a+2|0]<<16|k[a+3|0]<<24))==(k[b|0]|k[b+1|0]<<8|(k[b+2|0]<<16|k[b+3|0]<<24))|0}function Gs(a,b){a=a|0;b=b|0;var c=0;c=Za-32|0;Za=c;h[c+16|0]=44;j[c+8>>2]=-1;j[c+12>>2]=0;j[c>>2]=1058;j[c+4>>2]=2;tH(a,b,c);Za=c+32|0}function Fc(a,b){var c=0,d=0,e=0;c=jf(a,b);if(c){j[a+12>>2]=j[a+12>>2]+b;return c}d=a,e=bb[j[j[a>>2]+24>>2]](a)|0,j[d+12>>2]=e;return c}function $Ha(a,b){a=a|0;b=b|0;var c=0;c=Za-32|0;Za=c;h[c+16|0]=44;j[c+8>>2]=-1;j[c+12>>2]=0;j[c>>2]=257;j[c+4>>2]=0;Kw(a,b,c);Za=c+32|0}function hia(a,b,c){var d=0;d=Za-16|0;Za=d;j[d+12>>2]=0;j[d+8>>2]=c;j[d+4>>2]=4;zk(a,d+12|0,j[tb(d+8|0,d+4|0)>>2]);j[b>>2]=0;Za=d+16|0}function _oa(a,b){a=a|0;b=b|0;var c=0,d=0;d=Za-16|0;Za=d;if(!(!a|!b)){c=Pr(a);a=Noa(a,b);c=p(Pr(b),(c|0)/(a|0)|0)}Za=d+16|0;return c|0}function Rq(a,b){var c=0,d=0;a:{if(b>>>0<=31){d=j[a+4>>2];c=a;break a}b=b-32|0;c=a+4|0}c=j[c>>2];j[a+4>>2]=d>>>b;j[a>>2]=d<<32-b|c>>>b}function Pga(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;if(!(!d|!Ld(c&255))){IH(a,8,q(0))}a=Mi(a);if(a){bb[j[j[a>>2]+88>>2]](a,b,c,d,e)}}function LW(a,b){a=a|0;b=b|0;var c=0;c=Za-32|0;Za=c;h[c+16|0]=44;j[c+8>>2]=-1;j[c+12>>2]=0;j[c>>2]=290;j[c+4>>2]=0;Kw(a,b,c);Za=c+32|0}function K4(a,b,c,d){if(a|b){while(1){c=c-1|0;h[c|0]=k[(a&15)+55648|0]|d;a=(b&15)<<28|a>>>4;b=b>>>4|0;if(a|b){continue}break}}return c}function uBa(a,b,c){var d=0;if((a|0)!=(b|0)){while(1){d=k[a|0];h[c|0]=d>>>0>32?d:32;c=c+1|0;a=a+1|0;if((b|0)!=(a|0)){continue}break}}}function sB(){var a=0,b=0,c=0;a=Za-16|0;Za=a;b=Db(a,10940);c=0;a:{if(!nb(b)){break a}c=(Hf(b,10950)|0)!=-1}gb(b);Za=a+16|0;return c|0}function hf(a){var b=0,c=0;b=Za-16|0;Za=b;if(Xp(a,b+8|0)){a=b+8|0;c=k[a|0]|k[a+1|0]<<8|(k[a+2|0]<<16|k[a+3|0]<<24)}Za=b+16|0;return c}function dS(a){var b=0;b=Za-16|0;Za=b;h[a|0]=0;h[a+1|0]=0;h[a+2|0]=0;h[a+3|0]=0;h[a+3|0]=0;h[a+4|0]=0;h[a+5|0]=0;h[a+6|0]=0;Za=b+16|0}function Qla(a,b){var c=0;c=78944;while(1){if(j[c>>2]==(b|0)){nn(a,0,j[c+8>>2]);return}c=c+12|0;if((c|0)!=78992){continue}break}Qc(a)}function NBa(a){var b=0;b=Za-16|0;Za=b;j[b+12>>2]=a;j[b+8>>2]=-128;j[b+4>>2]=127;a=h[zf(b+8|0,Pd(b+12|0,b+4|0))|0];Za=b+16|0;return a}function Hp(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=Za-16|0;Za=d;a:{if(!b){break a}if(c){zT(vd(d+8|0,a),b);break a}yT(vd(d,a),b)}Za=d+16|0}function mfa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=j[b>>2];j[a>>2]=d;j[j[d-12>>2]+a>>2]=j[b+4>>2];nr(j[j[a>>2]-12>>2]+a|0,c);return a|0}function eW(a,b,c,d){var e=0;e=a+b|0;b=-1;a:{while(1){if((a|0)==(e|0)){break a}e=e-1|0;if(Gn(c,d,e)){continue}break}b=e-a|0}return b}function Md(a,b,c){var d=0;a:{if((b|0)>(c|0)){break a}d=j[a>>2];if((d|0)<(b|0)){j[a>>2]=b;return}if((c|0)>=(d|0)){break a}j[a>>2]=c}}function Je(a,b,c,d,e){var f=0;f=Za-16|0;Za=f;j[f+12>>2]=c;j[f+8>>2]=e;c=bh(f,f+12|0);a=Iq(a,b,d,j[f+8>>2]);oe(c);Za=f+16|0;return a}function G5(a){j[a+1420>>2]=0;j[a+992>>2]=0;j[a+1504>>2]=0;j[a+1508>>2]=0;j[a+1412>>2]=0;j[a+1416>>2]=0;h[a+1377|0]=0;j[a+1064>>2]=0}function Dja(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=df(a);if(d>>>0<b>>>0){Bja(a,b-d|0,c);return}if(b>>>0<d>>>0){AI(a,j[a>>2]+p(b,52)|0)}}function Coa(a,b){h[a+860|0]=b;h[a+832|0]=b;h[a+831|0]=b;h[a+829|0]=b;h[a+828|0]=b;i[a+800>>1]=b;h[a+846|0]=b>>>4;h[a+847|0]=b<<2&60}function An(a,b,c){var d=0;a:{if(b>>>0>c>>>0){break a}d=j[a>>2];if(d>>>0<b>>>0){j[a>>2]=b;return}if(c>>>0>=d>>>0){break a}j[a>>2]=c}}function xha(a){a=a|0;a=Za-16|0;Za=a;j[a+12>>2]=1869112133;Za=a+16|0;a=a+12|0;return k[a|0]|k[a+1|0]<<8|(k[a+2|0]<<16|k[a+3|0]<<24)}function xW(){var a=0,b=0;a=Za-16|0;Za=a;j[a+8>>2]=19466242;a:{if(tB(a+8|0)){break a}if(sB()){break a}b=rB()^1}Za=a+16|0;return b|0}function qKa(a,b){var c=0;c=Za-16|0;Za=c;a:{if(yb(a,512)){Ez(c+8|0,b);qd(a,c+8|0);break a}a=Za-16|0;Za=a;nKa(b);Za=a+16|0}Za=c+16|0}function qGa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=Lf(a);if(d>>>0<b>>>0){$Fa(a,b-d|0,c);return}if(b>>>0<d>>>0){Vy(a,j[a>>2]+p(b,6)|0)}}function iAa(a,b){var c=0;c=fg(a);if(c>>>0<b>>>0){hAa(a,b-c|0);return}if(b>>>0<c>>>0){b=j[a>>2]+(b<<3)|0;fg(a);jO(a,b);xi(a);fg(a)}}function ev(a){a=a|0;var b=0;b=j[a+12>>2];if((b|0)==j[a+16>>2]){return bb[j[j[a>>2]+40>>2]](a)|0}j[a+12>>2]=b+1;return gg(h[b|0])|0}function Yza(a,b){var c=0;c=Za-16|0;Za=c;a:{if(yb(a,128)){RP(c+8|0,b);qd(a,c+8|0);break a}a=Za-16|0;Za=a;Xza(b);Za=a+16|0}Za=c+16|0}function Psa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=de(a);if(d>>>0<b>>>0){Msa(a,b-d|0,c);return}if(b>>>0<d>>>0){fM(a,j[a>>2]+(b<<5)|0)}}function Pq(a,b){var c=0,d=0;a:{if(b>>>0<=31){d=j[a>>2];c=a+4|0;break a}b=b-32|0;c=a}c=j[c>>2];j[a>>2]=d<<b;j[a+4>>2]=c<<b|d>>>32-b}function z8(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=Za-16|0;Za=d;j[d>>2]=c;j[d+8>>2]=b;_p(j[d+8>>2]);y8(a,j[d>>2]);Za=d+16|0;return a|0}function v8(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=Za-16|0;Za=d;j[d>>2]=c;j[d+8>>2]=b;_p(j[d+8>>2]);t8(a,j[d>>2]);Za=d+16|0;return a|0}function qI(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=sb(a);if(d>>>0<b>>>0){bja(a,b-d|0,c);return}if(b>>>0<d>>>0){vw(a,j[a>>2]+(b<<2)|0)}}function Pn(a,b){a=a|0;b=b|0;var c=0;c=tc(a);if(c>>>0<b>>>0){rY(a,b-c|0);return}if(b>>>0<c>>>0){b=j[a>>2]+b|0;tc(a);wB(a,b);ap(a)}}function MV(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=Za-16|0;Za=d;j[d>>2]=c;j[d+8>>2]=b;_p(j[d+8>>2]);LV(a,j[d>>2]);Za=d+16|0;return a|0}function AR(a){var b=0;b=a;if((k[b|0]|k[b+1|0]<<8|(k[b+2|0]<<16|k[b+3|0]<<24))==1179468868){return(k[a+4|0]-1&255)>>>0<10}return 0}function Qqa(a,b){var c=0;c=Za-16|0;Za=c;a:{if(yb(a,7)){Fz(c+8|0,b);qd(a,c+8|0);break a}a=Za-16|0;Za=a;Nqa(b);Za=a+16|0}Za=c+16|0}function Qia(a,b){var c=0,d=0;c=Za-16|0;Za=c;j[c+8>>2]=b;b=j[c+8>>2];d=dI(a,b);a=Rb(a);Rs(Sg(c+8|0));Yg(a,b,1);Za=c+16|0;return d}function FT(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;return(c=MMa(0-MMa(b^1230262859,25)|0,4)^1247037516,d=b,e=(a&4088)>>>0>=520,e?c:d)|0}function vaa(a,b,c){dr(a);j[a+8>>2]=c;j[a+4>>2]=0;j[a>>2]=84264;c=j[b+4>>2];j[a+12>>2]=j[b>>2];j[a+16>>2]=c;j[a+20>>2]=j[b+8>>2]}function taa(a,b,c){dr(a);j[a+8>>2]=c;j[a+4>>2]=0;j[a>>2]=84336;c=j[b+4>>2];j[a+12>>2]=j[b>>2];j[a+16>>2]=c;j[a+20>>2]=j[b+8>>2]}function nE(a,b,c,d,e){if(b>>>0>=d>>>0){if(!e){return d}b=a+b|0;c=Z3(a+d|0,b,c,c+e|0);a=(b|0)==(c|0)?-1:c-a|0}else{a=-1}return a}function h3(a,b){var c=0;c=j[a+24>>2];if((c|0)==j[a+28>>2]){return bb[j[j[a>>2]+52>>2]](a,b)|0}j[a+24>>2]=c+4;j[c>>2]=b;return b}function ay(a,b){var c=0,d=0;j[a>>2]=j[b>>2];j[a+4>>2]=j[b+4>>2];j[a+8>>2]=j[b+8>>2];j[b>>2]=0;j[b+4>>2]=0;c=hb(b),d=0,j[c>>2]=d}function Ht(a,b){var c=0,d=0,e=0;c=Za-16|0;Za=c;e=j[b+4>>2];d=j[b>>2];h[c+15|0]=0;d=zm(d,d+e|0,c+15|0);Yh(a,j[b>>2],d);Za=c+16|0}function Cna(a){var b=0,c=0;c=a+946300|0;a=a+906300|0;while(1){b=j[a>>2];if(b){Fga(b)}a=a+160|0;if((c|0)!=(a|0)){continue}break}}function rg(a,b){a=a|0;b=b|0;var c=0;c=Za-16|0;Za=c;if(b>>>0>=110){Di(12596);z()}mb(c+8|0,a,b);Qd(c+8|0,0);Za=c+16|0;return a|0}function h_(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;while(1){if((b|0)!=(c|0)){j[d>>2]=h[b|0];d=d+4|0;b=b+1|0;continue}break}return c|0}function ZC(a,b,c,d,e,f){a=bb[j[j[a+8>>2]+4>>2]](a+8|0)|0;a=zq(c,d,a,a+288|0,f,e,0)-a|0;if((a|0)<=287){j[b>>2]=((a|0)/12|0)%12}}function VC(a,b,c,d,e,f){a=bb[j[j[a+8>>2]+4>>2]](a+8|0)|0;a=xq(c,d,a,a+288|0,f,e,0)-a|0;if((a|0)<=287){j[b>>2]=((a|0)/12|0)%12}}function Mi(a){var b=0,c=0;b=fj(j[a+20>>2]);if(!(b>>>0>249|k[a+4200|0]>=b>>>0)){c=j[(j[a+16>>2]+p(b,160)|0)+906300>>2]}return c}function FL(a,b,c){a=a|0;b=b|0;c=c|0;if((b|0)!=(c|0)){while(1){EL(a,k[b|0]);b=b+1|0;if((c|0)!=(b|0)){continue}break}}return a|0}function Dv(a,b,c){var d=0;d=j[a+32>>2];if(m[a+40>>2]<d+c>>>0){j[a+96>>2]=1;return 0}Vb(b,d,c);j[a+32>>2]=j[a+32>>2]+c;return 1}function DM(a){var b=0;b=j[a+16>>2];a=j[a+32>>2];b=HMa(b,b>>31,a,a>>31)+5e5|0;a=ab;return ic(IMa(b,b>>>0<5e5?a+1|0:a,1e6,0),ab)}function CM(a){var b=0;b=j[a+16>>2];a=j[a+36>>2];b=HMa(b,b>>31,a,a>>31)+5e5|0;a=ab;return ic(IMa(b,b>>>0<5e5?a+1|0:a,1e6,0),ab)}function yka(a){var b=0,c=0;if(j[a>>2]){pd(a);SI(a);Wo(a);Gf(hb(a),j[a>>2],Be(a));b=hb(a),c=0,j[b>>2]=c;j[a>>2]=0;j[a+4>>2]=0}}function uGa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=tc(a);if(d>>>0<b>>>0){fGa(a,b-d|0,c);return}if(b>>>0<d>>>0){Ot(a,j[a>>2]+b|0)}}function qoa(a){var b=0,c=0;if(j[a>>2]){pd(a);iK(a);Wo(a);yo(hb(a),j[a>>2],Be(a));b=hb(a),c=0,j[b>>2]=c;j[a>>2]=0;j[a+4>>2]=0}}function ora(a,b){var c=0;c=ec(a);if(c>>>0<b>>>0){lra(a,b-c|0);return}if(b>>>0<c>>>0){b=j[a>>2]+p(b,12)|0;ec(a);jL(a,b);rs(a)}}function oe(a){a:{a=j[a>>2];if(a){j[114630]=0;Xu(a);a=j[114630];j[114630]=0;if((a|0)==1){break a}}return}J(0)|0;C()|0;ib();z()}function hHa(a,b){a=a|0;b=b|0;var c=0,d=0;b=Za-160|0;Za=b;c=-1;d=b;a=eHa(a,b);if(!a){OQ(d)}if(a){c=QQ(b)}Za=b+160|0;return c|0}function h5(a){a:{if((he(a)|0)!=79){break a}if((he(a)|0)!=103){break a}if((he(a)|0)!=103){break a}return(he(a)|0)==83}return 0}function gX(a,b,c,d,e,f,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;return Sda(a,b,c,d,e,f,g,h,i,j)|0}function fX(a,b,c,d,e,f,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;return Rda(a,b,c,d,e,f,g,h,i,j)|0}function dta(a){var b=0,c=0;if(j[a>>2]){de(a);bM(a);hu(a);Yg(hb(a),j[a>>2],Zg(a));b=hb(a),c=0,j[b>>2]=c;j[a>>2]=0;j[a+4>>2]=0}}function dna(a){var b=0,c=0;if(j[a>>2]){tc(a);tA(a);ap(a);Yf(hb(a),j[a>>2],Af(a));b=hb(a),c=0,j[b>>2]=c;j[a>>2]=0;j[a+4>>2]=0}}function bra(a){var b=0,c=0;if(j[a>>2]){ec(a);kL(a);rs(a);eh(hb(a),j[a>>2],Vf(a));b=hb(a),c=0,j[b>>2]=c;j[a>>2]=0;j[a+4>>2]=0}}function Uxa(a,b){a=a|0;b=b|0;var c=0,d=0;b=Za-208|0;Za=b;c=-1;d=b;a=vxa(a,b);if(!a){cN(d)}if(a){c=gN(b)}Za=b+208|0;return c|0}function UL(a,b,c,d,e){j[a+12>>2]=e;j[a+8>>2]=d;j[a+4>>2]=c;j[a>>2]=b;if(b){ee(b,a)}if(c){ee(c,a)}if(d){ee(d,a)}if(e){ee(e,a)}}function Sya(a){var b=0,c=0;if(j[a>>2]){pd(a);FN(a);Wo(a);Gf(hb(a),j[a>>2],Be(a));b=hb(a),c=0,j[b>>2]=c;j[a>>2]=0;j[a+4>>2]=0}}function IB(a){j[114630]=0;M(a|0);a=j[114630];j[114630]=0;if((a|0)!=1){j[114630]=0;z()}a=J(0)|0;C()|0;O(a|0)|0;j[114630]=0;z()}function Gja(a){var b=0,c=0;if(j[a>>2]){df(a);CJ(a);wI(a);Xw(hb(a),j[a>>2],Pi(a));b=hb(a),c=0,j[b>>2]=c;j[a>>2]=0;j[a+4>>2]=0}}function AMa(a,b,c,d){if((ok(11872)|0)==(b|0)){Jb(d,c);return}if(!xT(a,b,c,d)){Jb(d,c);return}if((ok(11877)|0)==(b|0)){zMa(a)}}function $xa(a){var b=0,c=0;b=Za-16|0;Za=b;if(_xa(a,b+8|0)){a=b+8|0;a=k[a|0]|k[a+1|0]<<8;c=a<<8|a>>>8}Za=b+16|0;return c&65535}function $Z(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;while(1){if((b|0)!=(c|0)){h[d|0]=k[b|0];d=d+1|0;b=b+1|0;continue}break}return c|0}function yza(a,b){var c=0;c=sb(a);if(c>>>0<b>>>0){xza(a,b-c|0);return}if(b>>>0<c>>>0){b=j[a>>2]+(b<<2)|0;sb(a);QN(a,b);yg(a)}}function uLa(a,b){var c=0;c=Yb(a);if(c>>>0<b>>>0){tLa(a,b-c|0);return}if(b>>>0<c>>>0){b=j[a>>2]+(b<<1)|0;Yb(a);DS(a,b);Bp(a)}}function mU(a,b,c,d){var e=0,f=0;e=(b|0)/8|0;a=e+a|0;f=dg(d,a);return(dg(d,a+1|0)<<8|f<<16|dg(d,a+2|0))<<(b-(e<<3)|0)+8>>32-c}function kpa(a){h[a+26|0]=0;i[a+24>>1]=0;j[a+16>>2]=0;j[a+20>>2]=-1;j[a+8>>2]=-1;j[a+12>>2]=-1;j[a>>2]=0;j[a+4>>2]=0;return a}function fFa(a,b){var c=0;c=sb(a);if(c>>>0<b>>>0){eFa(a,b-c|0);return}if(b>>>0<c>>>0){b=j[a>>2]+(b<<2)|0;sb(a);bQ(a,b);yg(a)}}function d8(a){var b=0,c=0;if(j[a>>2]){pd(a);KF(a);Wo(a);yo(hb(a),j[a>>2],Be(a));b=hb(a),c=0,j[b>>2]=c;j[a>>2]=0;j[a+4>>2]=0}}function _3(a,b){var c=0;a=$3(a,j[21255]);c=ne(a);if(c>>>0>=1024){Vb(b,a,1023);h[b+1023|0]=0;return 68}Vb(b,a,c+1|0);return 0}function Yj(a,b){var c=0;a:{if(m[a+12>>2]<b>>>0){c=0;if(bb[j[j[a>>2]+24>>2]](a)>>>0<b>>>0){break a}}j[a+12>>2]=b;c=1}return c}function Qj(a,b,c){var d=0;d=Za-16|0;Za=d;j[d+12>>2]=c;c=j[b>>2];j[d+8>>2]=j[b+4>>2];Cc(a,c,j[tb(d+12|0,d+8|0)>>2]);Za=d+16|0}function MCa(a,b){var c=0;c=sb(a);if(c>>>0<b>>>0){LCa(a,b-c|0);return}if(b>>>0<c>>>0){b=j[a>>2]+(b<<2)|0;sb(a);jP(a,b);yg(a)}}function H3(a){a=a|0;var b=0;if((bb[j[j[a>>2]+36>>2]](a)|0)==-1){return-1}b=a;a=j[a+12>>2];j[b+12>>2]=a+1;return gg(h[a|0])|0}function DCa(a,b){var c=0;c=Yb(a);if(c>>>0<b>>>0){CCa(a,b-c|0);return}if(b>>>0<c>>>0){b=j[a>>2]+(b<<1)|0;Yb(a);eP(a,b);Bp(a)}}function BX(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;if(Qf(a,j[b+8>>2],0)){xu(b,c,d);return}a=j[a+8>>2];bb[j[j[a>>2]+28>>2]](a,b,c,d)}function yma(a,b){var c=0,d=0;j[a>>2]=j[b>>2];c=b+4|0;d=a+4|0;if((c|0)!=(d|0)){zJ(d,j[c>>2],j[c+4>>2])}Vb(a+16|0,b+16|0,144)}function vna(a){var b=0,c=0;b=Za-16|0;Za=b;c=a+1304392|0;if(!$c(c)){rna(b+8|0,a+24620|0);RJ(c,ud(b+8|0));Ir(b+8|0)}Za=b+16|0}function up(a){var b=0,c=0;b=Za-16|0;Za=b;if(Kp(a,b+8|0)){a=b+8|0;a=k[a|0]|k[a+1|0]<<8;c=a<<8|a>>>8}Za=b+16|0;return c&65535}function l6(a){a=a|0;var b=0;if(!a){return-2}b=j[a+28>>2];if(!b){return 0}bb[j[a+36>>2]](j[a+40>>2],b);j[a+28>>2]=0;return 0}function hN(a){var b=0,c=0;b=k[a+33|0];c=b>>>24|0;a=k[a+31|0]?1120:1056;b=a+(b<<8)|0;c=a>>>0>b>>>0?c+1|0:c;a=b;ab=c;return a}function cMa(a,b){a=a|0;b=b|0;var c=0,d=0;b=Za-48|0;Za=b;c=-1;d=b;a=ELa(a,b);if(!a){LS(d)}if(a){c=cT(b)}Za=b+48|0;return c|0}function c9(a,b){var c=0;c=Za-32|0;Za=c;h[c+16|0]=44;j[c+8>>2]=-1;j[c+12>>2]=0;j[c>>2]=1058;j[c+4>>2]=1;Xga(a,b,c);Za=c+32|0}function bY(a,b,c){a:{if(c){j[114630]=0;UB(a,b,c);a=j[114630];j[114630]=0;if((a|0)==1){break a}}return}J(0)|0;C()|0;ib();z()}function aY(a,b,c){a:{if(b){j[114630]=0;VB(a,c,b);a=j[114630];j[114630]=0;if((a|0)==1){break a}}return}J(0)|0;C()|0;ib();z()}function _C(a,b,c,d,e,f){a=bb[j[j[a+8>>2]>>2]](a+8|0)|0;a=zq(c,d,a,a+168|0,f,e,0)-a|0;if((a|0)<=167){j[b>>2]=((a|0)/12|0)%7}}function ZJ(a){a=a|0;j[a>>2]=0;ri(a+4|0);j[a+152>>2]=0;j[a+156>>2]=0;j[a+144>>2]=0;j[a+148>>2]=0;Ab(a+16|0,0,128);return a|0}function WD(a){j[a>>2]=58704;Ou(a+4|0);j[a+24>>2]=0;j[a+28>>2]=0;j[a+16>>2]=0;j[a+20>>2]=0;j[a+8>>2]=0;j[a+12>>2]=0;return a}function WC(a,b,c,d,e,f){a=bb[j[j[a+8>>2]>>2]](a+8|0)|0;a=xq(c,d,a,a+168|0,f,e,0)-a|0;if((a|0)<=167){j[b>>2]=((a|0)/12|0)%7}}function Jh(a,b,c){a:{if(c){j[114630]=0;cE(a,b,c);a=j[114630];j[114630]=0;if((a|0)==1){break a}}return}J(0)|0;C()|0;ib();z()}function Hq(a){j[a>>2]=58640;Ou(a+4|0);j[a+24>>2]=0;j[a+28>>2]=0;j[a+16>>2]=0;j[a+20>>2]=0;j[a+8>>2]=0;j[a+12>>2]=0;return a}function Ef(a,b,c,d){var e=0;a=((b|0)/8|0)+a|0;e=dg(d,a);return((dg(d,a+1|0)<<8|e<<16|dg(d,a+2|0))<<(b&7)&16777215)>>>24-c|0}function Bb(a,b){var c=0,d=0,e=0;c=a;d=j[b>>2];e=d+j[a>>2]|0;a=j[a+4>>2]+j[b+4>>2]|0;j[c>>2]=e;j[c+4>>2]=e>>>0<d>>>0?a+1|0:a}function xI(a){a=a|0;var b=0,c=0;b=me(a);while(1){c=b;if(c&65535){b=c-1|0;if(!tg(a,b&65535)){continue}}break}return c&65535}function _Y(a,b){var c=0;c=Zc(a);if(c>>>0<b>>>0){AY(a,b-c|0);return}if(b>>>0<c>>>0){b=j[a>>2]+(b<<4)|0;Zc(a);AB(a,b);zB(a)}}function _U(a,b){var c=0,d=0;c=Za-16|0;Za=c;d=a;a=vk(c+8|0,j[b>>2]);WU(d,a,j[j[b+4>>2]>>2],j[j[b+8>>2]>>2]);jb(a);Za=c+16|0}function Q2(a,b){j[a+20>>2]=0;j[a+24>>2]=b;j[a+12>>2]=0;j[a+4>>2]=4098;j[a+8>>2]=6;j[a+16>>2]=!b;Ab(a+32|0,0,40);Ou(a+28|0)}function Fs(a){a=a|0;var b=0;b=Za-16|0;Za=b;j[b+12>>2]=a;j[b+8>>2]=2147483647;a=j[tb(b+12|0,b+8|0)>>2];Za=b+16|0;return a|0}function Dr(a){a=+a;var b=0,c=0,d=0;d=a*a;a=0;b=1;c=1;while(1){a=a+2;c=d*c/(a*a);b=c+b;if(b*1e-7<c){continue}break}return+b}function t2(a,b){var c=0,d=q(0);c=Za-16|0;Za=c;Vu(c,a,b,0);d=vD(j[c>>2],j[c+4>>2],j[c+8>>2],j[c+12>>2]);Za=c+16|0;return d}function sza(a,b){var c=0;c=Za-16|0;Za=c;a:{if(yb(a,5)){Hz(c+8|0,b);qd(a,c+8|0);break a}h[c+7|0]=0;dj(b,5,c+7|0)}Za=c+16|0}function qHa(a,b){var c=0;c=Za-16|0;Za=c;a:{if(yb(a,6)){iz(c+8|0,b);qd(a,c+8|0);break a}h[c+7|0]=0;dj(b,6,c+7|0)}Za=c+16|0}function nw(a){var b=0,c=0;o[a+4272>>3]=o[a+4280>>3];b=a,c=+q(q(Yga(a+4296|0)|0)*q(-4.656612873077393e-10)),o[b+4280>>3]=c}function ly(a){j[a>>2]=0;j[a+4>>2]=0;j[a+24>>2]=0;j[a+28>>2]=0;j[a+16>>2]=0;j[a+20>>2]=0;j[a+8>>2]=0;j[a+12>>2]=0;return a}function iMa(a,b){var c=0;c=Za-16|0;Za=c;a:{if(yb(a,3)){Sz(c+8|0,b);qd(a,c+8|0);break a}h[c+7|0]=0;dj(b,3,c+7|0)}Za=c+16|0}function gEa(a){var b=0;b=$j(a);if(b>>>0<64){bEa(a,64-b|0);return}if(b>>>0>64){b=j[a>>2]+2112|0;$j(a);KP(a,b);nl(a);$j(a)}}function eJ(a,b){var c=0;if(!(k[a|0]!=k[b|0]|o[a+8>>3]!=o[b+8>>3]|k[a+16|0]!=k[b+16|0])){c=j[a+20>>2]==j[b+20>>2]}return c}function VB(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;if(c){d=a;while(1){j[d>>2]=b;d=d+4|0;c=c-1|0;if(c){continue}break}}return a|0}function HEa(a,b){var c=0;a:{if(!b){break a}if(!yb(a,b)){break a}if(b>>>0<=3){return GEa(a,b)}c=hf(a);Jb(a,b-4|0)}return c}function FLa(a,b){var c=0;c=Za-16|0;Za=c;a:{if(yb(a,4)){$g(c+8|0,b);qd(a,c+8|0);break a}h[c+7|0]=0;dj(b,4,c+7|0)}Za=c+16|0}function BM(a){a=a|0;j[a+700>>2]=0;i[a+862>>1]=0;j[a+688>>2]=0;j[a>>2]=0;j[a+4>>2]=0;j[a+8>>2]=0;j[a+12>>2]=0;j[a+16>>2]=0}function yAa(a,b){var c=0,d=0;c=Za-16|0;Za=c;d=yb(a,32);a:{if(d){mO(c+8|0,b);qd(a,c+8|0);break a}lO(b)}Za=c+16|0;return d}function oK(a,b){var c=0;c=Za-16|0;Za=c;mb(c+8|0,a+1074308|0,7);a=kb(c+8|0);Za=c+16|0;return j[(b<<2)+(a?25184:25248)>>2]}function nK(a,b){var c=0;c=Za-16|0;Za=c;mb(c+8|0,a+1074308|0,7);a=kb(c+8|0);Za=c+16|0;return j[(b<<2)+(a?25248:25184)>>2]}function kx(a,b){var c=0;c=Za-16|0;Za=c;mb(c+8|0,a+1074308|0,7);a=kb(c+8|0);Za=c+16|0;return j[(b<<2)+(a?25312:26336)>>2]}function jx(a,b){var c=0;c=Za-16|0;Za=c;mb(c+8|0,a+1074308|0,7);a=kb(c+8|0);Za=c+16|0;return j[(b<<2)+(a?26336:25312)>>2]}function Yta(a){if(!(a<q(4294967296))){return-1}if(!(a>q(0))){return 0}if(a<q(4294967296)&a>=q(0)){return~~a>>>0}return 0}function Pu(a,b,c){c=j[c>>2];while(1){a:{if((a|0)!=(b|0)){if((c|0)!=j[a>>2]){break a}}else{a=b}return a}a=a+4|0;continue}}function Jna(a){var b=0,c=0;b=Za-16|0;Za=b;c=a+128e3|0;while(1){Cma(a);a=a+32|0;if((c|0)!=(a|0)){continue}break}Za=b+16|0}function JEa(a,b){var c=0;a:{if(!b){break a}if(!yb(a,b)){break a}if(b>>>0<=3){return _z(a,b)}c=hf(a);Jb(a,b-4|0)}return c}function IEa(a,b){var c=0;a:{if(!b){break a}if(!yb(a,b)){break a}if(b>>>0<=1){return Zz(a,1)}c=Of(a);Jb(a,b-2|0)}return c}function qpa(a){if(!(a<q(65535))){return 65535}if(!(a>q(0))){return 0}if(a<q(4294967296)&a>=q(0)){return~~a>>>0}return 0}function pM(a,b,c,d,e,f,g){h[a+17|0]=g;h[a+16|0]=f;j[a+12>>2]=e;j[a+8>>2]=d;j[a+4>>2]=c;j[a>>2]=b;if(d){nM(a,1);nM(a,0)}}function oM(a,b,c,d,e,f,g){h[a+17|0]=g;h[a+16|0]=f;j[a+12>>2]=e;j[a+8>>2]=d;j[a+4>>2]=c;j[a>>2]=b;if(d){mM(a,1);mM(a,0)}}function fV(a){a=a|0;var b=0;a:{if(!ce(-1,j[a+76>>2])){a=j[a+76>>2];break a}b=a;a=VH(a,32);j[b+76>>2]=a}return a<<24>>24}function WI(a){var b=0;b=a;if((k[b|0]|k[b+1|0]<<8|(k[b+2|0]<<16|k[b+3|0]<<24))==1179011410){return fy(a)>>>0>80}return 0}function UM(a){var b=0;b=a+68|0;if(!(!(k[b|0]|k[b+1|0]<<8)|(k[b|0]|k[b+1|0]<<8)>>>0>127)){return!_c(a,17965,17)}return 0}function Soa(a,b){var c=0,d=0,e=0;while(1){d=(c<<2)+a|0,e=hua(b),j[d>>2]=e;c=c+1|0;if((c|0)!=12){continue}break}return a}function Rra(a){var b=0,c=0;a=a<<24;while(1){b=a<<1;a=(a|0)>-1?b:b^79764919;c=c+1|0;if((c|0)!=8){continue}break}return a}function RAa(a,b){var c=0;c=Za-16|0;Za=c;a:{if(jf(a,2)){qk(c+8|0,b);my(a,c+8|0);break a}h[c+7|0]=0;IS(b,c+7|0)}Za=c+16|0}function NFa(a,b){var c=0,d=0;c=Za-16|0;Za=c;d=yb(a,4);a:{if(d){$g(c+8|0,b);qd(a,c+8|0);break a}SP(b)}Za=c+16|0;return d}function Lj(a,b,c){var d=0;d=j[b+4>>2];j[a>>2]=j[b>>2];j[a+4>>2]=d;d=j[b+12>>2];j[a+8>>2]=j[b+8>>2];j[a+12>>2]=d;Iw(a,c)}function JD(a){var b=0;b=j[a+12>>2];if((b|0)==j[a+16>>2]){return bb[j[j[a>>2]+40>>2]](a)|0}j[a+12>>2]=b+4;return j[b>>2]}function DJa(a){a=a+4|0;a=k[a|0]|k[a+1|0]<<8|(k[a+2|0]<<16|k[a+3|0]<<24);return a<<24|a<<8&16711680|(a>>>8&65280|a>>>24)}function D3(a){a=a|0;var b=0;if((bb[j[j[a>>2]+36>>2]](a)|0)==-1){return-1}b=a;a=j[a+12>>2];j[b+12>>2]=a+4;return j[a>>2]}function BLa(a,b){var c=0;c=Za-16|0;Za=c;a:{if(yb(a,2)){qk(c+8|0,b);qd(a,c+8|0);break a}h[c+7|0]=0;IS(b,c+7|0)}Za=c+16|0}function $S(a,b){a=a|0;b=b|0;var c=0;c=Yb(a);if(c>>>0<b>>>0){RLa(a,b-c|0);return}if(b>>>0<c>>>0){Cp(a,j[a>>2]+(b<<1)|0)}}function xV(a){j[a>>2]=0;j[a+4>>2]=0;j[a+24>>2]=0;j[a+28>>2]=0;j[a+16>>2]=0;j[a+20>>2]=0;j[a+8>>2]=0;j[a+12>>2]=0;XA(a)}function s2(a,b){var c=0,d=0;c=Za-16|0;Za=c;Vu(c,a,b,1);d=rv(j[c>>2],j[c+4>>2],j[c+8>>2],j[c+12>>2]);Za=c+16|0;return d}function ld(a){var b=0;b=Za-16|0;Za=b;j[b+12>>2]=83680;j[b+8>>2]=83784;j[a>>2]=j[b+12>>2];j[a+4>>2]=j[b+8>>2];Za=b+16|0}function hna(a,b){a=a|0;b=b|0;if(b>>>0>255){return 20525}a=j[((b<<2)+a|0)+900380>>2];if(!a){return 20525}return a+492|0}function Ssa(a,b,c){var d=0;$S(c,j[a>>2]);if(j[a>>2]){while(1){WL(b,bc(c,d));d=d+1|0;if(d>>>0<m[a>>2]){continue}break}}}function PP(a){var b=0;b=a;if((k[b|0]|k[b+1|0]<<8|(k[b+2|0]<<16|k[b+3|0]<<24))==1279544644){return k[a+4|0]<32}return 0}function Nf(a,b){a=a|0;b=b|0;var c=0;c=sb(a);if(c>>>0<b>>>0){RT(a,b-c|0);return}if(b>>>0<c>>>0){Lt(a,j[a>>2]+(b<<2)|0)}}function Kxa(a,b){a=a|0;b=b|0;var c=0;i[a+34>>1]=0;c=Za-16|0;Za=c;wxa(a+43|0);Za=c+16|0;j[a+20>>2]=0;md(a,b);return a|0}function Kd(a,b){var c=q(0);a:{if(b>q(1)){break a}c=n[a>>2];if(!(c>=b)){n[a>>2]=b;return}if(c<=q(1)){break a}n[a>>2]=1}}function ER(a){var b=0;a:{if(_c(a,12667,20)){break a}b=a+25|0;if(!k[b|0]|k[b|0]>8){break a}return h[a+47|0]>-1}return 0}function Dna(a,b){ob(a,b);ob(a+12|0,b+12|0);ob(a+24|0,b+24|0);ob(a+36|0,b+36|0);ob(a+48|0,b+48|0);j[a+60>>2]=j[b+60>>2]}function yY(a){var b=0,c=0,d=0;c=j[a+4>>2];b=j[a>>2];a=j[a+8>>2];b=b+(a>>1)|0;d=b;if(a&1){c=j[c+j[b>>2]>>2]}bb[c|0](d)}function pz(a){a=a|0;var b=0;b=Za-16|0;Za=b;j[b+12>>2]=a;j[b+8>>2]=65535;a=l[tb(b+12|0,b+8|0)>>1];Za=b+16|0;return a|0}function he(a){var b=0;b=j[a+32>>2];a:{if(b>>>0>=m[a+40>>2]){j[a+96>>2]=1;a=0;break a}j[a+32>>2]=b+1;a=k[b|0]}return a}function eJa(a){var b=0,c=0;b=Za-16|0;Za=b;c=a- -64|0;while(1){Oe(a);a=a+1|0;if((c|0)!=(a|0)){continue}break}Za=b+16|0}function Zta(a,b,c){var d=0;d=64;j[a+764>>2]=64;if(b){d=l[b+32>>1];j[a+764>>2]=d}if(c){j[a+764>>2]=p(j[c+4>>2],d)>>>6}}function Sra(){var a=0,b=0,c=0;while(1){b=(a<<2)+87648|0,c=Rra(a&255),j[b>>2]=c;a=a+1|0;if((a|0)!=256){continue}break}}function J4(a,b,c){if(a|b){while(1){c=c-1|0;h[c|0]=a&7|48;a=(b&7)<<29|a>>>3;b=b>>>3|0;if(a|b){continue}break}}return c}function BHa(a){var b=0,c=0;b=Za-16|0;Za=b;c=a- -64|0;while(1){Oz(a);a=a+2|0;if((c|0)!=(a|0)){continue}break}Za=b+16|0}function toa(a,b){j[114630]=0;I(25,a|0,p(b,24)|0,8);a=j[114630];j[114630]=0;if((a|0)!=1){return}J(0)|0;C()|0;ib();z()}function tKa(a){var b=0,c=0;b=Za-16|0;Za=b;c=a+120|0;while(1){Oe(a);a=a+1|0;if((c|0)!=(a|0)){continue}break}Za=b+16|0}function rIa(a,b){j[114630]=0;I(25,a|0,p(b,48)|0,4);a=j[114630];j[114630]=0;if((a|0)!=1){return}J(0)|0;C()|0;ib();z()}function pP(a){a=a|0;var b=0;b=Za-16|0;Za=b;i[b+14>>1]=a;i[b+12>>1]=255;a=k[gf(b+14|0,b+12|0)|0];Za=b+16|0;return a|0}function nKa(a){var b=0,c=0;b=Za-16|0;Za=b;c=a+512|0;while(1){Dz(a);a=a+4|0;if((c|0)!=(a|0)){continue}break}Za=b+16|0}function mY(a){var b=0;b=a+8|0;if(!j[b>>2]){bb[j[j[a>>2]+16>>2]](a);return}if((eu(b)|0)==-1){bb[j[j[a>>2]+16>>2]](a)}}function Xza(a){var b=0,c=0;b=Za-16|0;Za=b;c=a+128|0;while(1){Oe(a);a=a+1|0;if((c|0)!=(a|0)){continue}break}Za=b+16|0}function XR(a){var b=0;b=a;if((k[b|0]|k[b+1|0]<<8|(k[b+2|0]<<16|k[b+3|0]<<24))==810369604){return k[a+4|0]<4}return 0}function Wb(a,b){var c=0;sm(a);j[a+4>>2]=0;j[a>>2]=83636;c=a;a=Yc(nb(b)+1|0);j[c+4>>2]=a;if(a){Vb(a,zb(b),nb(b)+1|0)}}function RDa(a,b){j[114630]=0;I(25,a|0,p(b,33)|0,1);a=j[114630];j[114630]=0;if((a|0)!=1){return}J(0)|0;C()|0;ib();z()}function QF(a,b){j[114630]=0;I(25,a|0,p(b,324)|0,4);a=j[114630];j[114630]=0;if((a|0)!=1){return}J(0)|0;C()|0;ib();z()}function QAa(a){var b=0,c=0;b=Za-16|0;Za=b;c=a+512|0;while(1){Oe(a);a=a+1|0;if((c|0)!=(a|0)){continue}break}Za=b+16|0}function Hma(a,b){j[114630]=0;I(25,a|0,p(b,52)|0,4);a=j[114630];j[114630]=0;if((a|0)!=1){return}J(0)|0;C()|0;ib();z()}function ES(a,b){a=a|0;b=b|0;var c=0;c=j[b+4>>2];if(c){Qb(a,c,j[b>>2]);return}b=b+8|0;if(!Xc(b)){yi(a,b);return}vf(a)}function ECa(a,b){j[114630]=0;I(25,a|0,p(b,20)|0,4);a=j[114630];j[114630]=0;if((a|0)!=1){return}J(0)|0;C()|0;ib();z()}function zna(a,b){var c=0;c=Za-16|0;Za=c;Nn(c+8|0,ah(c,b));yna(a,c+8|0);j[a+16>>2]=0;j[a+12>>2]=0;Za=c+16|0;return a}function yoa(a){if(!(a<q(255))){return 255}if(!(a>q(0))){return 0}if(a<q(4294967296)&a>=q(0)){return~~a>>>0}return 0}function wxa(a){var b=0,c=0;b=Za-16|0;Za=b;c=a+22|0;while(1){Oe(a);a=a+1|0;if((c|0)!=(a|0)){continue}break}Za=b+16|0}function sZ(a){var b=0,c=0;b=Za-16|0;Za=b;c=a+256|0;while(1){Oe(a);a=a+1|0;if((c|0)!=(a|0)){continue}break}Za=b+16|0}function pAa(a){var b=0,c=0;b=Za-16|0;Za=b;c=a+32|0;while(1){Oe(a);a=a+1|0;if((c|0)!=(a|0)){continue}break}Za=b+16|0}function oMa(a,b){var c=0;c=Za-16|0;Za=c;i[c+12>>1]=65535;i[c+14>>1]=b;nMa(a,l[gf(12e3,c+14|0)>>1],c+12|0);Za=c+16|0}function dB(a,b){j[114630]=0;I(25,a|0,p(b,24)|0,4);a=j[114630];j[114630]=0;if((a|0)!=1){return}J(0)|0;C()|0;ib();z()}function cxa(a,b){j[114630]=0;I(25,a|0,p(b,9)|0,1);a=j[114630];j[114630]=0;if((a|0)!=1){return}J(0)|0;C()|0;ib();z()}function Vj(a,b){a=a+58|0;if(h[Pb(a,b)|0]<0){return 255}if(k[Pb(a,b)|0]!=255){a=k[Pb(a,b)|0]&127}else{a=255}return a}function Qra(a){var b=0,c=0;b=Za-16|0;Za=b;c=a+27|0;while(1){Oe(a);a=a+1|0;if((c|0)!=(a|0)){continue}break}Za=b+16|0}function O2(a,b){j[114630]=0;I(25,a|0,p(b,12)|0,4);a=j[114630];j[114630]=0;if((a|0)!=1){return}J(0)|0;C()|0;ib();z()}function Lma(a){var b=0,c=0;b=Za-16|0;Za=b;c=a+20|0;while(1){Oe(a);a=a+1|0;if((c|0)!=(a|0)){continue}break}Za=b+16|0}function Era(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;e=Za-16|0;Za=e;d=Wp(e,a,d);on(hb(a),b,c,d+4|0);ub(d);Za=e+16|0}function DN(a,b){j[114630]=0;I(25,a|0,p(b,56)|0,4);a=j[114630];j[114630]=0;if((a|0)!=1){return}J(0)|0;C()|0;ib();z()}function CLa(a){var b=0,c=0;b=Za-16|0;Za=b;c=a+16|0;while(1){Oe(a);a=a+1|0;if((c|0)!=(a|0)){continue}break}Za=b+16|0}function AIa(a,b){j[114630]=0;I(25,a|0,p(b,6)|0,1);a=j[114630];j[114630]=0;if((a|0)!=1){return}J(0)|0;C()|0;ib();z()}function ABa(a){var b=0,c=0;b=Za-16|0;Za=b;if(Kp(a,b+8|0)){a=b+8|0;c=(k[a|0]|k[a+1|0]<<8)<<16>>16}Za=b+16|0;return c}function zw(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;e=Za-16|0;Za=e;d=op(e,a,d);CI(hb(a),b,c,d+4|0);ub(d);Za=e+16|0}function zp(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;e=Za-16|0;Za=e;d=_d(e,a,d);on(hb(a),b,c,d+4|0);ub(d);Za=e+16|0}function rAa(a){var b=0,c=0;b=Za-16|0;Za=b;c=a+6|0;while(1){Oe(a);a=a+1|0;if((c|0)!=(a|0)){continue}break}Za=b+16|0}function qJa(a){var b=0,c=0;b=Za-16|0;Za=b;c=a+8|0;while(1){Oe(a);a=a+1|0;if((c|0)!=(a|0)){continue}break}Za=b+16|0}function nLa(a){var b=0,c=0;b=Za-16|0;Za=b;c=a+3|0;while(1){Oe(a);a=a+1|0;if((c|0)!=(a|0)){continue}break}Za=b+16|0}function iu(a,b){var c=0,d=0,e=0;c=Za-16|0;Za=c;j[c>>2]=j[b>>2];d=c,e=j[b>>2]+KA(b)|0,j[d+4>>2]=e;TV(a,c);Za=c+16|0}function fk(a,b){a=a|0;b=b|0;var c=0;c=tc(a);if(c>>>0<b>>>0){OIa(a,b-c|0);return}if(b>>>0<c>>>0){rR(a,j[a>>2]+b|0)}}function fY(a,b){var c=0,d=0;c=Za-16|0;Za=c;h[c+15|0]=0;d=-1;if(b){b=Gn(a,b,c+15|0);d=b?b-a|0:-1}Za=c+16|0;return d}function by(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;e=Za-16|0;Za=e;d=vl(e,a,d);on(hb(a),b,c,d+4|0);ub(d);Za=e+16|0}function _L(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;e=Za-16|0;Za=e;d=yh(e,a,d);on(hb(a),b,c,d+4|0);ub(d);Za=e+16|0}function Nqa(a){var b=0,c=0;b=Za-16|0;Za=b;c=a+7|0;while(1){Oe(a);a=a+1|0;if((c|0)!=(a|0)){continue}break}Za=b+16|0}function LEa(a){var b=0,c=0;b=Za-16|0;Za=b;c=a+4|0;while(1){Oe(a);a=a+1|0;if((c|0)!=(a|0)){continue}break}Za=b+16|0}function IBa(a){var b=0,c=0;b=Za-16|0;Za=b;c=a+2|0;while(1){Oe(a);a=a+1|0;if((c|0)!=(a|0)){continue}break}Za=b+16|0}function Hn(a,b,c){var d=0;d=Za-16|0;Za=d;Nn(d+8|0,ah(d,b));fu(a,d+8|0);j[a+12>>2]=c;j[a+8>>2]=0;Za=d+16|0;return a}function Gga(a){a=a|0;var b=0,c=0;j[j[a+20>>2]>>2]=a;c=j[a+12>>2];b=j[c>>2];j[a+4>>2]=b;if(b){j[b+8>>2]=a}j[c>>2]=a}function AD(a,b,c,d,e,f,g,h,i){j[a>>2]=b;j[a+4>>2]=c;j[a+8>>2]=d;j[a+12>>2]=e&65535|(i>>>16&32768|e>>>16&32767)<<16}function xsa(a){j[a+16>>2]=0;j[a+20>>2]=0;j[a+36>>2]=0;h[a+40|0]=1;j[a+24>>2]=0;j[a+28>>2]=0;i[a+32>>1]=0;return a}function vga(a,b){var c=0;c=Za-16|0;Za=c;hI(c+8|0,Kb(c,b));fu(a,c+8|0);j[a+12>>2]=0;j[a+8>>2]=0;Za=c+16|0;return a}function oga(a,b,c){var d=0;if((b|0)>=1){while(1){n[a>>2]=n[c>>2];a=a+4|0;d=(b|0)>1;b=b-1|0;if(d){continue}break}}}function Zoa(a,b,c){var d=0;if((b|0)>=1){while(1){j[a>>2]=j[c>>2];a=a+4|0;d=(b|0)>1;b=b-1|0;if(d){continue}break}}}function Uha(a,b){a=a|0;b=b|0;var c=0;a:{if(sb(a)>>>0>511){break a}if(!$c(b)){break a}c=j[b>>2];bI(a,b)}return c|0}function Oja(a){var b=0,c=0;if(j[a>>2]){bs(a);xe(hb(a),j[a>>2],jd(a));b=hb(a),c=0,j[b>>2]=c;j[a>>2]=0;j[a+4>>2]=0}}function Oia(a){var b=0,c=0;if(j[a>>2]){Wh(a);xe(hb(a),j[a>>2],jd(a));b=hb(a),c=0,j[b>>2]=c;j[a>>2]=0;j[a+4>>2]=0}}function OR(a,b,c,d,e){h[a+4|0]=b;h[a|0]=69;h[a+1|0]=99;h[a+2|0]=104;h[a+3|0]=111;h[a+7|0]=e;h[a+6|0]=d;h[a+5|0]=c}function Bha(a,b,c){a=a|0;b=b|0;c=q(c);var d=0,e=0;if((b|0)<=3){d=(a+b|0)+4264|0,e=lK(q(c*q(255))),h[d|0]=e;xr(a)}}function nMa(a,b,c){var d=0;d=Yb(a);if(d>>>0<b>>>0){mMa(a,b-d|0,c);return}if(b>>>0<d>>>0){Cp(a,j[a>>2]+(b<<1)|0)}}function lwa(a){a=a|0;var b=0;b=KM(a);if((b|0)!=(a|0)){while(1){kwa(a);a=a+32|0;if((b|0)!=(a|0)){continue}break}}}function lGa(a,b,c){var d=0;d=Za-16|0;Za=d;fFa(b,c);c=yb(a,c<<2);if(c){Ny(d+8|0,b);qd(a,d+8|0)}Za=d+16|0;return c}function kM(a){var b=0,c=0;if(j[a>>2]){xp(a);yn(hb(a),j[a>>2],Df(a));b=hb(a),c=0,j[b>>2]=c;j[a>>2]=0;j[a+4>>2]=0}}function gP(a){var b=0,c=0;if(j[a>>2]){GP(a);Et(hb(a),j[a>>2],jd(a));b=hb(a),c=0,j[b>>2]=c;j[a>>2]=0;j[a+4>>2]=0}}function fha(a,b){j[114630]=0;I(25,a|0,b<<11,4);a=j[114630];j[114630]=0;if((a|0)!=1){return}J(0)|0;C()|0;ib();z()}function fH(a){a=a|0;j[a+4244>>2]=0;j[a+4248>>2]=0;j[a+4228>>2]=0;j[a+4232>>2]=0;a=a+4252|0;j[a>>2]=0;j[a+4>>2]=0}function _K(a){var b=0,c=0;if(j[a>>2]){Xr(a);Yf(hb(a),j[a>>2],Af(a));b=hb(a),c=0,j[b>>2]=c;j[a>>2]=0;j[a+4>>2]=0}}function Xia(a){var b=0;b=Za-16|0;Za=b;i[b+14>>1]=a;i[b+12>>1]=32767;a=i[gf(b+14|0,b+12|0)>>1];Za=b+16|0;return a}function VV(a,b,c){a:{if(tc(a)>>>0<=b>>>0){break a}if(tc(a)>>>0<c>>>0){break a}return tc(a)-b>>>0>=c>>>0}return 0}function VCa(a,b,c){var d=0;d=Za-16|0;Za=d;DCa(b,c);c=yb(a,c<<1);if(c){CS(d+8|0,b);qd(a,d+8|0)}Za=d+16|0;return c}function TK(a,b){var c=0;c=b&15;if(c){h[a+847|0]=c<<2}b=b&240;if(b){h[a+846|0]=b>>>4}j[a+88>>2]=j[a+88>>2]|262144}function Q0(a,b){a:{if((a|0)==(b|0)){break a}while(1){b=b-1|0;if(b>>>0<=a>>>0){break a}Ug(a,b);a=a+1|0;continue}}}function P0(a,b){a:{if((a|0)==(b|0)){break a}while(1){b=b-4|0;if(b>>>0<=a>>>0){break a}Ib(a,b);a=a+4|0;continue}}}function Oj(a,b){var c=0;c=b&15;if(c){h[a+844|0]=c<<2}b=b&240;if(b){h[a+843|0]=b>>>4}j[a+88>>2]=j[a+88>>2]|131072}function NLa(a,b,c){var d=0;d=Za-16|0;Za=d;uLa(b,c);c=yb(a,c<<1);if(c){CS(d+8|0,b);qd(a,d+8|0)}Za=d+16|0;return c}function JFa(a,b,c){var d=0;d=sb(a);if(d>>>0<b>>>0){mFa(a,b-d|0,c);return}if(b>>>0<d>>>0){hQ(a,j[a>>2]+(b<<2)|0)}}function GD(a,b){a=a|0;b=b|0;var c=0;c=j[a>>2];a:{if(!c){break a}if(!ce(yG(c,b),-1)){break a}j[a>>2]=0}return a|0}function FD(a,b){a=a|0;b=b|0;var c=0;c=j[a>>2];a:{if(!c){break a}if(!ce(h3(c,b),-1)){break a}j[a>>2]=0}return a|0}function DI(a){var b=0,c=0;if(j[a>>2]){GI(a);ft(hb(a),j[a>>2],ki(a));b=hb(a),c=0,j[b>>2]=c;j[a>>2]=0;j[a+4>>2]=0}}function Bza(a,b,c){var d=0;d=Za-16|0;Za=d;yza(b,c);c=yb(a,c<<2);if(c){Ny(d+8|0,b);qd(a,d+8|0)}Za=d+16|0;return c}function $ka(a,b){a=a|0;b=b|0;h[b+38|0]=k[a+202|0];h[b+39|0]=k[a+203|0];h[b+40|0]=k[a+204|0];h[b+41|0]=k[a+205|0]}function $Ca(a,b,c){var d=0;d=Za-16|0;Za=d;MCa(b,c);c=yb(a,c<<2);if(c){Ny(d+8|0,b);qd(a,d+8|0)}Za=d+16|0;return c}function yra(a,b){j[114630]=0;I(25,a|0,b<<3,8);a=j[114630];j[114630]=0;if((a|0)!=1){return}J(0)|0;C()|0;ib();z()}function wf(a,b,c){var d=0;a:{if(b>c){break a}d=o[a>>3];if(!(d>=b)){o[a>>3]=b;return}if(c>=d){break a}o[a>>3]=c}}function vLa(a,b){j[114630]=0;I(25,a|0,b<<1,1);a=j[114630];j[114630]=0;if((a|0)!=1){return}J(0)|0;C()|0;ib();z()}function usa(a,b){j[114630]=0;I(25,a|0,b<<2,4);a=j[114630];j[114630]=0;if((a|0)!=1){return}J(0)|0;C()|0;ib();z()}function rra(a,b){j[114630]=0;I(25,a|0,b<<4,8);a=j[114630];j[114630]=0;if((a|0)!=1){return}J(0)|0;C()|0;ib();z()}function nka(a,b,c){var d=0;if((b|0)>=1){while(1){h[a|0]=k[c|0];a=a+1|0;d=(b|0)>1;b=b-1|0;if(d){continue}break}}}function gFa(a,b){j[114630]=0;I(25,a|0,b<<2,1);a=j[114630];j[114630]=0;if((a|0)!=1){return}J(0)|0;C()|0;ib();z()}function WAa(a,b){j[114630]=0;I(25,a|0,b<<5,8);a=j[114630];j[114630]=0;if((a|0)!=1){return}J(0)|0;C()|0;ib();z()}function Jra(a){var b=0,c=0;while(1){b=a&1|b<<1;a=(a&254)>>>1|0;c=c+1|0;if((c|0)!=8){continue}break}return b&255}function GCa(a){var b=0;b=Za-16|0;Za=b;h[a|0]=0;h[a+1|0]=0;h[a+2|0]=0;h[a+3|0]=0;h[a+4|0]=0;h[a+5|0]=0;Za=b+16|0}function CE(a,b,c){var d=0,e=0,f=0;e=c*c;o[a>>3]=e;f=c;d=c*134217729;c=d+(c-d);d=f-c;o[b>>3]=d*d+(c*c-e+(c+c)*d)}function xB(a,b){j[114630]=0;I(25,a|0,b<<4,4);a=j[114630];j[114630]=0;if((a|0)!=1){return}J(0)|0;C()|0;ib();z()}function tJa(a,b,c){if((a|0)!=(b|0)){while(1){GR(c,a);c=c+2|0;a=a+2|0;if((b|0)!=(a|0)){continue}break}}return c}function rda(a){a=a|0;var b=0,c=0;b=Za-16|0;Za=b;c=Db(b,38147);Wb(a,c);gb(c);j[a>>2]=83616;Za=b+16|0;return a|0}function ok(a){a=k[a|0]|k[a+1|0]<<8|(k[a+2|0]<<16|k[a+3|0]<<24);return a<<24|a<<8&16711680|(a>>>8&65280|a>>>24)}function jG(a){var b=0;a:{while(1){if(!j[(b<<2)+a>>2]){break a}b=b+1|0;if((b|0)!=4){continue}break}b=4}return b}function gV(a,b){j[114630]=0;I(25,a|0,b<<3,1);a=j[114630];j[114630]=0;if((a|0)!=1){return}J(0)|0;C()|0;ib();z()}function g4(a,b){a=a|0;b=b|0;var c=0,d=0;bb[j[j[a>>2]+24>>2]](a)|0;b=mv(b);j[a+36>>2]=b;c=a,d=gm(b),h[c+44|0]=d}function c4(a,b){a=a|0;b=b|0;var c=0,d=0;bb[j[j[a>>2]+24>>2]](a)|0;b=lv(b);j[a+36>>2]=b;c=a,d=gm(b),h[c+44|0]=d}function aJa(a,b,c){a=a|0;b=b|0;c=c|0;a:{if(m[a+4>>2]<m[hb(a)>>2]){RIa(a,b,c);break a}QIa(a,b,c)}return jt(a)|0}function YT(a,b){j[114630]=0;I(25,a|0,b<<1,2);a=j[114630];j[114630]=0;if((a|0)!=1){return}J(0)|0;C()|0;ib();z()}function Wr(a){var b=0;b=1;a:{switch(k[a+3|0]-4|0){default:b=k[a+2|0]==11;break;case 0:case 2:break a}}return b}function So(a,b){var c=0;c=Za-16|0;Za=c;j[c+8>>2]=j[a>>2];j[c+8>>2]=j[c+8>>2]+(b<<2);Za=c+16|0;return j[c+8>>2]}function RA(a,b){j[114630]=0;I(25,a|0,b<<5,4);a=j[114630];j[114630]=0;if((a|0)!=1){return}J(0)|0;C()|0;ib();z()}function MX(a){var b=0,c=0,d=0;b=Za-16|0;Za=b;c=j[yc(b+8|0,j[a+4>>2])>>2],d=1,h[c|0]=d;h[j[a+8>>2]]=1;Za=b+16|0}function Ida(a){a=a|0;var b=0,c=0;b=Za-16|0;Za=b;c=Db(b,38128);Wb(a,c);gb(c);j[a>>2]=83596;Za=b+16|0;return a|0}function Eg(a){a:{a=j[a+4>>2]&74;if(a){if((a|0)==64){return 8}if((a|0)!=8){break a}return 16}return 0}return 10}function Bz(a,b){a=a|0;b=b|0;var c=0;c=Za-16|0;Za=c;j[c+12>>2]=b;b=a;a=Db(c,j[c+12>>2]);oy(b,a);gb(a);Za=c+16|0}function BT(a,b){j[114630]=0;I(25,a|0,b<<2,2);a=j[114630];j[114630]=0;if((a|0)!=1){return}J(0)|0;C()|0;ib();z()}function rQ(a,b,c){a=a|0;b=b|0;c=c|0;a:{switch(c+1|0){case 0:case 2:ch(a,b);return;default:break a}}OEa(a,b,c)}function pI(a){var b=0;b=Za-16|0;Za=b;j[b+12>>2]=a;j[b+8>>2]=32767;a=i[tb(b+12|0,b+8|0)>>1];Za=b+16|0;return a}function is(a,b){var c=0;c=Za-16|0;Za=c;j[c+8>>2]=j[a+4>>2];j[c>>2]=j[b+4>>2];a=rb(c+8|0,c);Za=c+16|0;return a}function ht(a,b){var c=0;c=Za-16|0;Za=c;j[c+12>>2]=(p(a,b)>>>0)/255;Md(c+12|0,0,15);Za=c+16|0;return k[c+12|0]}function dM(a,b,c){a=a|0;b=b|0;c=c|0;a:{switch(c+1|0){case 0:case 3:WL(a,b);return;default:break a}}Bsa(a,b,c)}function Qf(a,b,c){if(!c){return j[a+4>>2]==j[b+4>>2]}if((a|0)==(b|0)){return 1}return!Lh(j[a+4>>2],j[b+4>>2])}function Qd(a,b){var c=0;c=j[a+4>>2];if(b){a=j[a>>2];j[a>>2]=j[a>>2]|c;return}a=j[a>>2];j[a>>2]=j[a>>2]&(c^-1)}function NX(a){var b=0;a:{a=j[a+8>>2];b=k[a|0];if((b|0)!=1){if(b&2){break a}h[a|0]=2;a=1}else{a=0}return a}z()}function $4(a,b){j[114630]=0;I(25,a|0,b|0,1);a=j[114630];j[114630]=0;if((a|0)!=1){return}J(0)|0;C()|0;ib();z()}function ym(a){var b=0;while(1){if(k[b+32256|0]==(a|0)){return b}b=b+1|0;if(b>>>0<43){continue}break}return 0}function mJ(a,b){a:{switch(b-1|0){default:return a+724|0;case 0:return a+736|0;case 1:break a}}return a+748|0}function LBa(a){if(!(a<4294967295)){return-1}if(!(a>0)){return 0}if(a<4294967296&a>=0){return~~a>>>0}return 0}function IO(a,b){h[a+6|0]=255;j[a+16>>2]=0;i[a+4>>1]=0;j[a>>2]=0;if(!(b<0)){o[a+8>>3]=b;j[a+16>>2]=3}return a}function Ama(a,b,c){var d=0;if((b|0)>=1){while(1){yma(a,c);a=a+160|0;d=(b|0)>1;b=b-1|0;if(d){continue}break}}}function tP(a,b){a=a|0;b=b|0;var c=0;c=Za-16|0;Za=c;i[c+14>>1]=b;if((kt(a)|0)!=65535){oS(a,c+14|0)}Za=c+16|0}function qq(){var a=0;j[114630]=0;a=j[114630];j[114630]=0;if((a|0)!=1){return j[15328]}J(0)|0;C()|0;ib();z()}function pq(){var a=0;j[114630]=0;a=j[114630];j[114630]=0;if((a|0)!=1){return j[15716]}J(0)|0;C()|0;ib();z()}function ppa(a){if(!(a<65535)){return 65535}if(!(a>0)){return 0}if(a<4294967296&a>=0){return~~a>>>0}return 0}function noa(a,b){var c=0;if(!b){return a}while(1){c=b;b=(a>>>0)%(b>>>0)|0;a=c;if(b){continue}break}return c}function YC(a,b,c,d,e){b=Fh(b,c,d,e,4);if(!(k[d|0]&4)){j[a>>2]=((b|0)<69?b+2e3|0:(b|0)<100?b+1900|0:b)-1900}}function Wk(a,b){var c=0;c=sb(a);if(c>>>0<b>>>0){Zia(a,b-c|0);return}if(b>>>0<c>>>0){vw(a,j[a>>2]+(b<<2)|0)}}function UC(a,b,c,d,e){b=Eh(b,c,d,e,4);if(!(k[d|0]&4)){j[a>>2]=((b|0)<69?b+2e3|0:(b|0)<100?b+1900|0:b)-1900}}function Qn(){var a=0;j[114630]=0;a=j[114630];j[114630]=0;if((a|0)!=1){return j[15135]}J(0)|0;C()|0;ib();z()}function QD(a){var b=0;b=j[a+12>>2];if((b|0)==j[a+16>>2]){return bb[j[j[a>>2]+36>>2]](a)|0}return gg(h[b|0])}function Po(a,b){a=a|0;b=b|0;if(Yb(a)>>>0>b>>>0){a=tg(j[a+24>>2]+484344|0,l[nk(a,b)>>1])}else{a=0}return a|0}function Jma(a,b,c){var d=0;if((b|0)>=1){while(1){Or(a,c);a=a+896|0;d=(b|0)>1;b=b-1|0;if(d){continue}break}}}function Hba(a,b){var c=0;c=Za-16|0;Za=c;j[c+8>>2]=b;b=j[c+8>>2];dI(a,b);Rb(a);Lm(Sg(c+8|0));vx(b);Za=c+16|0}function vx(a){j[114630]=0;I(25,a|0,40,4);a=j[114630];j[114630]=0;if((a|0)!=1){return}J(0)|0;C()|0;ib();z()}function iwa(a){var b=0;b=KM(a);if((b|0)!=(a|0)){while(1){jwa(a);a=a+32|0;if((b|0)!=(a|0)){continue}break}}}function bJ(a){j[114630]=0;I(25,a|0,28,4);a=j[114630];j[114630]=0;if((a|0)!=1){return}J(0)|0;C()|0;ib();z()}function Zm(a){var b=0;b=Za-16|0;Za=b;j[b+12>>2]=a;j[b+8>>2]=255;a=k[tb(b+12|0,b+8|0)|0];Za=b+16|0;return a}function VLa(a,b){a=a|0;b=b|0;var c=0;c=Za-16|0;Za=c;j[c>>2]=b;j[c+8>>2]=a;mLa(j[c+8>>2],j[c>>2]);Za=c+16|0}function UE(a,b,c,d){n[d+4>>2]=c+a;a=q(a+q(c*q(-.5)));b=q(b*q(.8660253882408142));n[d+8>>2]=a-b;n[d>>2]=a+b}function Sta(a){var b=0,c=0;b=a+108|0;a=0;while(1){c=Pb(b,a);a=a+1|0;h[c|0]=a;if(a>>>0<128){continue}break}}function Lg(a,b){var c=0;c=a;b=j[a+16>>2]+b|0;a=j[a+12>>2];b=(b|0)%(a|0)|0;return n[kc(c,(b>>31&a)+b|0)>>2]}function HY(a,b){j[114630]=0;nv(a,b<<2,4);a=j[114630];j[114630]=0;if((a|0)!=1){return}J(0)|0;C()|0;ib();z()}function Gxa(a,b){var c=0;c=Za-16|0;Za=c;b=k[b|0]|k[b+1|0]<<8;i[c+14>>1]=b<<8|b>>>8;oha(a,c+14|0);Za=c+16|0}function sY(a){a=a|0;a=Za-16|0;Za=a;if(Ha(a+12|0,4)|0){$D(j[114604],70718);z()}Za=a+16|0;return j[a+12>>2]}function pCa(a,b){a=a|0;b=b|0;var c=0;b=Za-16|0;Za=b;c=-1;if(hj(a,b+8|0)){c=bP(b+8|0)}Za=b+16|0;return c|0}function mKa(a,b){a=a|0;b=b|0;var c=0;b=Za-16|0;Za=b;c=-1;if(hj(a,b+8|0)){c=XR(b+8|0)}Za=b+16|0;return c|0}function dJa(a,b){a=a|0;b=b|0;var c=0;b=Za-80|0;Za=b;c=-1;if(BR(a,b+8|0)){c=AR(b+8|0)}Za=b+80|0;return c|0}function cF(a){var b=0;b=j[(k[a+2|0]&12)+42484>>2];a=k[a+1|0];return b>>>((a>>>3^-1)&1)>>>((a>>>4^-1)&1)|0}function af(a,b){var c=0;c=Za-16|0;Za=c;j[c+8>>2]=j[a>>2];j[c+8>>2]=j[c+8>>2]+b;Za=c+16|0;return j[c+8>>2]}function _B(a,b,c){j[114630]=0;YB(a,b,c);a=j[114630];j[114630]=0;if((a|0)!=1){return}J(0)|0;C()|0;ib();z()}function Wna(a,b){var c=0,d=0;c=Za-16|0;Za=c;j[c+8>>2]=b;d=o[j[c+8>>2]>>3];j[a+8>>2]=0;o[a>>3]=d;Za=c+16|0}function Jv(a,b){var c=0;c=(p(p(Hv(a),Iv(a)),125)>>>0)/(cF(a)>>>0)|0;a=(k[a+1|0]&6)==6?c&-4:c;return a?a:b}function Ct(a,b){a:{switch(b-1|0){default:return a+48|0;case 0:return a+68|0;case 1:break a}}return a+88|0}function Bo(a){var b=0,c=0,d=0;b=a;a=j[a>>2];c=b,d=lb(p(a,214013)+2531011|0),j[c>>2]=d;return a>>>16&32767}function yw(a,b){Xy(a);j[a+20>>2]=0;j[a+12>>2]=0;j[a+16>>2]=0;hx(a+24|0);Cb(a+36|0);j[a+48>>2]=b;return a}function yta(a,b){var c=0;a=xta(a,b);a:{if(!a){break a}b=pY(a);if(!b){break a}c=Ab(b,0,a)- -64|0}return c}function roa(a){var b=0,c=0;Lr(a,se(a));b=hb(a),c=0,j[b>>2]=c;b=a,c=Rb(a),j[b>>2]=c;b=Rb(a),c=0,j[b>>2]=c}function lBa(a,b){var c=0;c=Za-16|0;Za=c;a:{if(jf(a,512)){Ez(c+8|0,b);my(a,c+8|0);break a}vO(b)}Za=c+16|0}function l5(a,b,c,d,e){var f=0;e=e-d|0;f=e>>31;a=(p(a-b|0,f^e+f)|0)/(c-b|0)|0;return((e|0)<0?0-a|0:a)+d|0}function jBa(a,b){var c=0;c=Za-16|0;Za=c;a:{if(yb(a,512)){Ez(c+8|0,b);qd(a,c+8|0);break a}vO(b)}Za=c+16|0}function iC(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j[e>>2]=c;j[h>>2]=f;return 3}function Of(a){var b=0,c=0;b=Za-16|0;Za=b;if(Kp(a,b+8|0)){a=b+8|0;c=k[a|0]|k[a+1|0]<<8}Za=b+16|0;return c}function NU(a,b){a=a|0;b=b|0;var c=0;b=Za-16|0;Za=b;c=-1;if(hj(a,b+8|0)){c=JA(b+8|0)}Za=b+16|0;return c|0}function KD(a){var b=0;b=j[a+12>>2];if((b|0)==j[a+16>>2]){return bb[j[j[a>>2]+36>>2]](a)|0}return j[b>>2]}function I2(a,b){var c=0;c=Za-16|0;j[c+12>>2]=a;a=b>>>0>1?((b<<2)+a|0)-4|0:a;j[c+8>>2]=a+4;return j[a>>2]}function Es(a,b){a=a|0;b=b|0;var c=0;c=Za-16|0;Za=c;rn(c+8|0,a);j[c+4>>2]=j[c+8>>2];Ds(c+4|0,b);Za=c+16|0}function E1(a){j[a>>2]=0;j[a+4>>2]=0;j[a+20>>2]=0;i[a+16>>1]=65535;j[a+8>>2]=0;j[a+12>>2]=0;j[a+24>>2]=11}function mh(a,b,c){var d=0,e=0,f=0,g=0;d=o[c>>3];e=o[b>>3];f=o[c+8>>3];g=o[b+8>>3];gl(a,d*e-f*g,e*f+d*g)}function Yy(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=Za-16|0;Za=d;j[d+12>>2]=c;JFa(a,b,d+12|0);Zw(a);Za=d+16|0}function Yga(a){var b=0,c=0,d=0;while(1){b=Bo(a)^b<<15;d=c>>>0<17;c=c+15|0;if(d){continue}break}return b}function T_(a,b,c){var d=0;d=Za-16|0;Za=d;if(b>>>0>=12){Di(6934);z()}qj(d+8|0,a,b);Qd(d+8|0,c);Za=d+16|0}function RCa(a){if(!(a<255)){return 255}if(!(a>0)){return 0}if(a<4294967296&a>=0){return~~a>>>0}return 0}function Pf(a,b){var c=0,d=0;c=j[a>>2];d=j[b>>2];ab=j[a+4>>2]-(j[b+4>>2]+(c>>>0<d>>>0)|0)|0;return c-d|0}function OL(a){i[a+70>>1]=k[((l[j[a+4>>2]+22>>1]<<4|l[j[a+4>>2]+20>>1]>>>6)&65535)+19968|0]>>>l[a+68>>1]}function Mx(a){Jta(a);h[a+12|0]=0;h[a+13|0]=0;h[a+14|0]=0;h[a+15|0]=0;h[a+16|0]=0;h[a+17|0]=255;return a}function GM(a,b,c){if((b|0)!=(c|0)){while(1){sra(a,lb(k[b|0]));b=b+1|0;if((c|0)!=(b|0)){continue}break}}}function DGa(a,b){a=a|0;b=b|0;var c=0;a=WEa(a,b);if(!a){c=Za-16|0;Za=c;Ab(b,0,4896);Za=c+16|0}return a|0}function CAa(a,b){a=a|0;b=b|0;var c=0;a=sAa(a,b);if(!a){c=Za-16|0;Za=c;Ab(b,0,1030);Za=c+16|0}return a|0}function y3(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return bb[j[j[a>>2]+16>>2]](a,b,c,d,e,f)|0}function xBa(a,b){var c=0;c=Za-16|0;Za=c;a:{if(jf(a,4)){$g(c+8|0,b);my(a,c+8|0);break a}SP(b)}Za=c+16|0}function v3(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return bb[j[j[a>>2]+24>>2]](a,b,c,d,e,f)|0}function uJa(a,b,c){if((a|0)!=(b|0)){while(1){c=c-2|0;b=b-2|0;GR(c,b);if((a|0)!=(b|0)){continue}break}}}function q3(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return bb[j[j[a>>2]+28>>2]](a,b,c,d,e,f)|0}function ou(a,b){a=a|0;b=b|0;var c=0;b=b-1|0;c=1085;a:{if(b>>>0>4){break a}c=j[(b<<2)+76436>>2]}Db(a,c)}function lCa(a,b){a=a|0;b=b|0;var c=0;a=JBa(a,b);if(!a){c=Za-16|0;Za=c;Ab(b,0,422);Za=c+16|0}return a|0}function l3(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return bb[j[j[a>>2]+44>>2]](a,b,c,d,e,f)|0}function jJ(a,b){var c=0;c=Za-16|0;Za=c;i[c+14>>1]=l[a>>1];i[a>>1]=l[b>>1];i[b>>1]=l[c+14>>1];Za=c+16|0}function gCa(a,b){a=a|0;b=b|0;var c=0;a=GBa(a,b);if(!a){c=Za-16|0;Za=c;Ab(b,0,826);Za=c+16|0}return a|0}function a3(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return bb[j[j[a>>2]+20>>2]](a,b,c,d,e,f)|0}function Pka(a,b){a=a|0;b=b|0;var c=0;a=rka(a,b);if(!a){c=Za-16|0;Za=c;Ab(b,0,225);Za=c+16|0}return a|0}function MAa(a,b){a=a|0;b=b|0;var c=0;a=qAa(a,b);if(!a){c=Za-16|0;Za=c;Ab(b,0,274);Za=c+16|0}return a|0}function Kka(a,b){a=a|0;b=b|0;var c=0;a=qka(a,b);if(!a){c=Za-16|0;Za=c;Ab(b,0,326);Za=c+16|0}return a|0}function Ib(a,b){var c=0;c=Za-16|0;Za=c;j[c+12>>2]=j[a>>2];j[a>>2]=j[b>>2];j[b>>2]=j[c+12>>2];Za=c+16|0}function HAa(a,b){a=a|0;b=b|0;var c=0;a=oAa(a,b);if(!a){c=Za-16|0;Za=c;Ab(b,0,106);Za=c+16|0}return a|0}function Fn(a,b,c){var d=0;d=Za-16|0;Za=d;a=vf(a);j[a+4>>2]=c;j[a>>2]=b;j[d+4>>2]=b;j[d>>2]=b;Za=d+16|0}function $O(a,b){var c=0;c=m[b>>2]>m[a>>2];a=j[a+4>>2];b=j[b+4>>2];return(a|0)<(b|0)?1:(a|0)<=(b|0)?c:0}function zxa(a){var b=0;b=Za-16|0;Za=b;j[a>>2]=0;j[a+4>>2]=0;j[b+12>>2]=0;os(a+8|0);Za=b+16|0;return a}function wP(a,b){a=a|0;b=b|0;var c=0;a=OCa(a,b);if(!a){c=Za-16|0;Za=c;Ab(b,0,284);Za=c+16|0}return a|0}function wEa(a,b){a=a|0;b=b|0;var c=0;a=zDa(a,b);if(!a){c=Za-16|0;Za=c;Ab(b,0,91);Za=c+16|0}return a|0}function v_(a,b,c){var d=0;if(j[a>>2]){while(1){ch(b,c+d|0);d=d+1|0;if(d>>>0<m[a>>2]){continue}break}}}function ty(a,b,c){var d=0,e=0;d=Za-1024|0;Za=d;if($Aa(a,d)){e=py(d,c)>>>0<=b>>>0}Za=d+1024|0;return e}function tta(a,b){if((a|0)!=(b|0)){sta(a,Lb(b),Mb(b));zi(a+12|0,b+12|0);i[a+28>>1]=l[b+28>>1]}return a}function sCa(a,b){var c=0;c=Za-16|0;Za=c;j[c+8>>2]=b;b=l[j[c+8>>2]>>1];i[a+2>>1]=0;i[a>>1]=b;Za=c+16|0}function qM(a){var b=0,c=0;while(1){c=(b<<2)+a|0;b=b+1|0;j[c+68>>2]=b<<11;if((b|0)!=9){continue}break}}function gDa(a,b){a=a|0;b=b|0;var c=0;a=xCa(a,b);if(!a){c=Za-16|0;Za=c;Ab(b,0,42);Za=c+16|0}return a|0}function eaa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=Za-16|0;Za=d;Nn(d+8|0,ah(d,b));Hn(a,d+8|0,c);Za=d+16|0}function cU(a,b){var c=0;c=tc(a);if(c>>>0<b>>>0){XT(a,b-c|0);return}if(b>>>0<c>>>0){Ot(a,j[a>>2]+b|0)}}function Xu(a){a=a|0;var b=0;b=j[21255];if(a){j[21255]=(a|0)==-1?458496:a}return((b|0)==458496?-1:b)|0}function UHa(a,b){a=a|0;b=b|0;var c=0;a=yHa(a,b);if(!a){c=Za-16|0;Za=c;Ab(b,0,34);Za=c+16|0}return a|0}function Ska(a,b){a=a|0;b=b|0;var c=0;a=ska(a,b);if(!a){c=Za-16|0;Za=c;Ab(b,0,73);Za=c+16|0}return a|0}function OX(a){var b=0,c=0;b=Za-16|0;Za=b;if(!k[j[yc(b+8|0,j[a+4>>2])>>2]]){c=NX(a)}Za=b+16|0;return c}function Nwa(a,b){a=a|0;b=b|0;var c=0;a=vwa(a,b);if(!a){c=Za-16|0;Za=c;Ab(b,0,40);Za=c+16|0}return a|0}function Ika(a,b){a=a|0;b=b|0;var c=0;a=pka(a,b);if(!a){c=Za-16|0;Za=c;Ab(b,0,60);Za=c+16|0}return a|0}function GAa(a,b){a=a|0;b=b|0;var c=0;a=nAa(a,b);if(!a){c=Za-16|0;Za=c;Ab(b,0,72);Za=c+16|0}return a|0}function Fza(a,b){a=a|0;b=b|0;var c=0;a=tza(a,b);if(!a){c=Za-16|0;Za=c;Ab(b,0,71);Za=c+16|0}return a|0}function zx(a,b){if(tg(j[a+24>>2]+484344|0,b)){a=j[Hb(j[a+24>>2]+484344|0,b)+12>>2]}else{a=1}return a}function r_(a,b){var c=0,d=0;c=Za-16|0;Za=c;if(j[a>>2]!=-1){d=c+8|0;yc(d,b);yc(c,d);jY(a,c)}Za=c+16|0}function np(a,b){a=a|0;b=b|0;var c=0;a=bIa(a,b);if(!a){c=Za-16|0;Za=c;Ab(b,0,64);Za=c+16|0}return a|0}function VR(a,b){a=a|0;b=b|0;var c=0;a=xJa(a,b);if(!a){c=Za-16|0;Za=c;Ab(b,0,50);Za=c+16|0}return a|0}function Iv(a){var b=0;b=k[a+1|0];return k[(p(b>>>1&3,15)+p(b>>>3&1,45)+(k[a+2|0]>>>4)|0)+42481|0]<<1}function jS(a){var b=0;b=Za-16|0;Za=b;h[a|0]=0;h[a+1|0]=0;h[a+2|0]=0;h[a+3|0]=0;h[a+4|0]=0;Za=b+16|0}function Rta(a){var b=0;a:{b=h[a|0];if((b|0)<-32){h[a|0]=224;return}if((b|0)<=32){break a}h[a|0]=32}}function QFa(a,b){a=a|0;b=b|0;var c=0;c=Za-16|0;Za=c;a=j[yc(c+8|0,BFa(a,b))>>2];Za=c+16|0;return a|0}function O0(a){var b=0;b=Za-16|0;Za=b;j[a>>2]=0;a=a+32|0;XC(a,32);h[b+15|0]=0;z0(a,b+15|0);Za=b+16|0}function El(a){h[a|0]=0;h[a+1|0]=0;h[a+2|0]=0;h[a+3|0]=0;h[a+4|0]=0;h[a+5|0]=0;h[a+6|0]=0;h[a+7|0]=0}function Cha(a,b){a=a|0;b=b|0;return q((b|0)<=3?q(q(k[(a+b|0)+4264|0])*q(.003921568859368563)):q(0))}function xH(a,b){a=a|0;b=b|0;var c=0;c=Za-16|0;Za=c;$g(c+8|0,b);a=wga(a,c+8|0);Za=c+16|0;return a|0}function tw(a,b){a=a|0;b=b|0;var c=0;c=Za-16|0;Za=c;a=j[yc(c+8|0,Uia(a,b))>>2];Za=c+16|0;return a|0}function o0(a,b,c,d,e){b=Eh(b,c,d,e,2);c=j[d>>2];if(!(c&4|b-1>>>0>30)){j[a>>2]=b;return}j[d>>2]=c|4}function m0(a,b,c,d,e){b=Eh(b,c,d,e,2);c=j[d>>2];if(!(c&4|b-1>>>0>11)){j[a>>2]=b;return}j[d>>2]=c|4}function j0(a,b,c,d,e){b=Eh(b,c,d,e,2);c=j[d>>2];if(!(c&4|(b|0)>12)){j[a>>2]=b-1;return}j[d>>2]=c|4}function eT(a){var b=0;b=k[a+35|0];a=b>>>21|0;b=(b<<11)+2624|0;if(b>>>0<2624){a=a+1|0}ab=a;return b}function Uz(a,b){var c=0,d=0;c=j[a+4>>2];d=j[b+4>>2];return(c|0)==(d|0)&m[b>>2]>m[a>>2]|c>>>0<d>>>0}function SV(a,b,c,d){if(!d|!b){a=-1}else{b=a+b|0;c=mV(a,b,c,c+d|0);a=(b|0)==(c|0)?-1:c-a|0}return a}function Qo(a){a=a|0;var b=0;Sm(a);b=yta(j[a>>2],Bn(a));j[a+20>>2]=b;if(!b){return 0}return jk(a)|0}function Ota(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=Za-16|0;Za=d;Fta(d+8|0,b,c,c);tM(a,d+8|0);Za=d+16|0}function Nla(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=Za-16|0;Za=d;Hla(d+8|0,b,c,c);tM(a,d+8|0);Za=d+16|0}function Mc(a,b){var c=0;c=j[b+4>>2];j[a>>2]=j[b>>2];j[a+4>>2]=c;j[a+8>>2]=j[b+8>>2];Km(b);return a}function Mba(a,b){a=a|0;b=b|0;var c=0;c=j[a+4>>2];b=zb(b);if(c){bb[c|0](b,j[a+8>>2]);return}mr(b,a)}function Jja(a,b){a=a|0;b=b|0;h[b|0]=0;h[b+1|0]=0;h[b+2|0]=0;h[b+3|0]=0;h[b+4|0]=0;h[b+5|0]=0;ni(b)}function H0(a,b,c,d,e){b=Fh(b,c,d,e,2);c=j[d>>2];if(!(c&4|b-1>>>0>30)){j[a>>2]=b;return}j[d>>2]=c|4}function F0(a,b,c,d,e){b=Fh(b,c,d,e,2);c=j[d>>2];if(!(c&4|b-1>>>0>11)){j[a>>2]=b;return}j[d>>2]=c|4}function D0(a,b,c,d,e){b=Fh(b,c,d,e,2);c=j[d>>2];if(!(c&4|(b|0)>12)){j[a>>2]=b-1;return}j[d>>2]=c|4}function p_(a,b,c){a=a|0;b=b|0;c=c|0;if(c>>>0<=127){a=(l[Qn()+(c<<1)>>1]&b)!=0}else{a=0}return a|0}function pDa(a,b){a=a|0;b=b|0;var c=0;c=Za-16|0;Za=c;i[c+14>>1]=b;Dy(a+236|0,128,c+14|0);Za=c+16|0}function l0(a,b,c,d,e){b=Eh(b,c,d,e,3);c=j[d>>2];if(!(c&4|(b|0)>365)){j[a>>2]=b;return}j[d>>2]=c|4}function iBa(a,b){a=a|0;b=b|0;var c=0;b=Za-16|0;Za=b;c=-1;if(mz(a,b)){c=DO(b)}Za=b+16|0;return c|0}function ama(a,b,c,d,e){a:{if((e|0)==128|c>>>0<2){break a}kJ(a,d,e);if(c>>>0<4){break a}kJ(b,d,e)}}function ag(a){var b=0;b=a+44|0;yk(b);if(j[b>>2]){AB(b,j[b>>2]);Ai(hb(b),j[b>>2],Ah(b))}QA(a+32|0)}function Zh(a){a=a|0;var b=0,c=0;while(1){c=b&65535;Bna(a,c);b=b+1|0;if(c>>>0<126){continue}break}}function WW(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return bb[a|0](b,c,d,e,f,g)|0}function Vea(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;bb[j[j[b>>2]+8>>2]](b,c);d=a;a=b+4|0;Rn(d,a);lC(a,c)}function Oba(a,b){if(a){b=bb[j[j[b>>2]+8>>2]](b)|0;a:{if(b){b=Gd(b);break a}b=Gd(34181)}j[a>>2]=b}}function Nga(a,b,c){a=a|0;b=b|0;c=c|0;a=Mi(a);if(!a){return 0}return bb[j[j[a>>2]+96>>2]](a,b,c)|0}function E0(a,b,c,d,e){b=Fh(b,c,d,e,3);c=j[d>>2];if(!(c&4|(b|0)>365)){j[a>>2]=b;return}j[d>>2]=c|4}function y0(a,b,c,d,e){b=Fh(b,c,d,e,2);c=j[d>>2];if(!(c&4|(b|0)>60)){j[a>>2]=b;return}j[d>>2]=c|4}function vH(a){a=a|0;var b=0;b=j[a>>2];if(b){bb[j[j[b>>2]+8>>2]](b);j[a>>2]=0}a=a+4|0;Xr(a);wR(a)}function tMa(a,b){a=a|0;b=b|0;var c=0;c=Za-16|0;Za=c;mT(c+8|0,a);Jp(c+8|0,b);Za=c+16|0;return a|0}function pGa(a,b){a=a|0;b=b|0;var c=0;c=Za-16|0;Za=c;iA(c,a);a=Ze(c,b);gb(c);Za=c+16|0;return a|0}function n0(a,b,c,d,e){b=Eh(b,c,d,e,2);c=j[d>>2];if(!(c&4|(b|0)>23)){j[a>>2]=b;return}j[d>>2]=c|4}function i0(a,b,c,d,e){b=Eh(b,c,d,e,2);c=j[d>>2];if(!(c&4|(b|0)>59)){j[a>>2]=b;return}j[d>>2]=c|4}function hg(a,b,c){a=a|0;b=b|0;c=c|0;ye(a,b);b=j[c+4>>2];j[a+4>>2]=j[c>>2];j[a+8>>2]=b;return a|0}function fxa(a,b,c){a=a|0;b=b|0;c=c|0;a=j[c+4>>2];j[b>>2]=j[c>>2];j[b+4>>2]=a;j[b+8>>2]=j[c+8>>2]}function f0(a,b,c,d,e){b=Eh(b,c,d,e,2);c=j[d>>2];if(!(c&4|(b|0)>60)){j[a>>2]=b;return}j[d>>2]=c|4}function cya(a,b){a=a|0;b=b|0;var c=0;c=Za-16|0;Za=c;NT(c,a);a=Ze(c,b);gb(c);Za=c+16|0;return a|0}function cfa(a,b){a=a|0;b=b|0;Hq(a);j[a>>2]=76912;Cb(a+32|0);j[a+48>>2]=b;j[a+44>>2]=0;return a|0}function Ug(a,b){var c=0;c=Za-16|0;Za=c;h[c+15|0]=k[a|0];h[a|0]=k[b|0];h[b|0]=k[c+15|0];Za=c+16|0}function Ira(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=o[b+8>>3];d=xv(o[b>>3]);e=Kh(c);gl(a,d*ge(c),d*e)}function G0(a,b,c,d,e){b=Fh(b,c,d,e,2);c=j[d>>2];if(!(c&4|(b|0)>23)){j[a>>2]=b;return}j[d>>2]=c|4}function C0(a,b,c,d,e){b=Fh(b,c,d,e,2);c=j[d>>2];if(!(c&4|(b|0)>59)){j[a>>2]=b;return}j[d>>2]=c|4}function x0(a,b,c,d,e){b=Fh(b,c,d,e,1);c=j[d>>2];if(!(c&4|(b|0)>6)){j[a>>2]=b;return}j[d>>2]=c|4}function sFa(a,b){var c=0;c=Za-16|0;Za=c;j[c+8>>2]=b;i[a>>1]=l[j[c+8>>2]>>1];Qc(a+4|0);Za=c+16|0}function rO(a){var b=0,c=0;b=1;c=j[a>>2];a:{if((c|0)>=1){b=120;if((c|0)<121){break a}}j[a>>2]=b}}function rI(a){hja(a,j[a+4>>2]);if(j[a>>2]){Xw(j[a+16>>2],j[a>>2],(j[Ob(a)>>2]-j[a>>2]|0)/52|0)}}function e0(a,b,c,d,e){b=Eh(b,c,d,e,1);c=j[d>>2];if(!(c&4|(b|0)>6)){j[a>>2]=b;return}j[d>>2]=c|4}function at(a){qIa(a,j[a+4>>2]);if(j[a>>2]){gR(j[a+16>>2],j[a>>2],(j[Ob(a)>>2]-j[a>>2]|0)/48|0)}}function ala(a){var b=0;a:{b=k[a|0];if(b>>>0<1){h[a|0]=1;return}if(b>>>0<=16){break a}h[a|0]=16}}function YM(a){var b=0;b=k[a+47|0];a=b>>>27|0;b=(b<<5)+259|0;if(b>>>0<259){a=a+1|0}ab=a;return b}function Pca(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;bb[j[j[b>>2]+16>>2]](a,b,j[c+8>>2],j[c+12>>2],0,d)}function PT(a,b){a=a|0;b=b|0;var c=0;c=Za-16|0;Za=c;Jt(c+8|0,a);Jp(c+8|0,b);Za=c+16|0;return a|0}function LP(a){QDa(a,j[a+4>>2]);if(j[a>>2]){JP(j[a+16>>2],j[a>>2],(j[Ob(a)>>2]-j[a>>2]|0)/33|0)}}function IT(a,b){a=a|0;b=b|0;var c=0;c=Za-16|0;Za=c;hA(c+8|0,a);Jp(c+8|0,b);Za=c+16|0;return a|0}function HI(a,b){var c=0;c=Za-16|0;Za=c;j[c+8>>2]=j[a>>2];AQ(c+8|0,b);Za=c+16|0;return j[c+8>>2]}function BN(a){vya(a,j[a+4>>2]);if(j[a>>2]){cy(j[a+16>>2],j[a>>2],(j[Ob(a)>>2]-j[a>>2]|0)/56|0)}}function vGa(a,b){a=a|0;b=b|0;var c=0;c=Za-16|0;Za=c;zQ(c,b);Mc(a,c);gb(c);Za=c+16|0;return a|0}function uX(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;if(Qf(a,j[b+8>>2],f)){wu(b,c,d,e)}}function sJa(a,b){var c=0;c=Za-16|0;Za=c;j[c>>2]=b;j[c+8>>2]=a;a=wp(c,c+8|0);Za=c+16|0;return a}function po(a,b,c){a=j[a>>2]+1074984|0;return j[(a+p(b,896)|0)+680>>2]>j[(a+p(c,896)|0)+680>>2]}function pBa(a){var b=0,c=0;b=Za-1024|0;Za=b;if(UAa(a,b)){c=py(b,0)>>>0<17}Za=b+1024|0;return c}function p7(a,b){var c=0;c=j[a+4>>2];j[a+8>>2]=j[a+8>>2]-b;j[a>>2]=j[a>>2]+(p(b,c)<<1);return a}function ofa(a){a=a|0;var b=0,c=0;h[a+4202|0]=1;b=a,c=we(j[a+16>>2]),j[b+4256>>2]=c;eH(a);dH(a)}function nla(a,b){a=a|0;b=b|0;lh(a);lh(a);a:{if(b>>>0>=60){Jb(a,4);break a}lh(a)}return lh(a)|0}function kta(a){var b=0;b=Za-16|0;Za=b;j[b+8>>2]=j[a+4>>2];a=j[cM(b+8|0)>>2];Za=b+16|0;return a}function jKa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;bb[j[j[b>>2]+16>>2]](a,b,c,d,e,f)}function fra(a){var b=0;b=Za-16|0;Za=b;j[b+8>>2]=j[a+4>>2];a=j[lL(b+8|0)>>2];Za=b+16|0;return a}function bka(a,b,c){var d=0;d=Za-16|0;Za=d;j[d>>2]=b;j[d+8>>2]=a;Kja(a,Ar(d,d+8|0),c);Za=d+16|0}function b7(a,b){var c=0;c=j[a+4>>2];j[a+8>>2]=j[a+8>>2]-b;j[a>>2]=j[a>>2]+(p(b,c)<<2);return a}function QE(a){var b=0;b=+((a&2097151)>>>0);return q(Bh(+q((a|0)>-1?b:-b),(a>>>21&1023)-788|0))}function Os(a){QEa(a,j[a+4>>2]);if(j[a>>2]){ft(j[a+16>>2],j[a>>2],(j[Ob(a)>>2]-j[a>>2]|0)/6|0)}}function Lz(a,b){a=a|0;b=b|0;var c=0;a=Kp(a,b);if(!a){c=Za-16|0;Za=c;Oz(b);Za=c+16|0}return a|0}function Lga(a,b){a=a|0;b=b|0;b=Za-16|0;Za=b;yi(b,j[a+20>>2]+4|0);FH(a,vd(b+8|0,b),0);Za=b+16|0}function Hta(a,b){var c=0;c=Za-16|0;Za=c;j[c>>2]=b;j[c+8>>2]=a;a=Ks(c,c+8|0);Za=c+16|0;return a}function Aha(a){a=a|0;var b=0,c=0;h[a+4202|0]=1;b=a,c=we(j[a+16>>2]),j[b+4232>>2]=c;xr(a);WH(a)}function zBa(a,b){a=a|0;b=b|0;var c=0,d=0;c=Za-16|0;Za=c;d=a;a=Mc(c,b);oy(d,a);gb(a);Za=c+16|0}function tR(a,b){return(Gb((p(a>>>4|0,b)>>>0)/15|0,1,15)<<4|Gb((p(a&15,b)>>>0)/15|0,1,15))&255}function nja(a,b,c){var d=0;j[a>>2]=j[b>>2];d=j[b>>2];j[a+8>>2]=b;j[a+4>>2]=p(c,52)+d;return a}function mr(a,b){a=a|0;b=b|0;b=Za-16|0;Za=b;j[b>>2]=a;a=j[13926];vE(a,34267,b);Sq(a);Za=b+16|0}function js(a,b){a=a|0;b=+b;var c=0,d=0,e=0;c=j[a+24>>2];d=a,e=Zj(Cg(b)*+(c>>>0)),j[d+24>>2]=e}function gha(a,b,c){var d=0;j[a>>2]=j[b>>2];d=j[b>>2];j[a+8>>2]=b;j[a+4>>2]=(c<<11)+d;return a}function XEa(a,b,c){var d=0;j[a>>2]=j[b>>2];d=j[b>>2];j[a+8>>2]=b;j[a+4>>2]=p(c,48)+d;return a}function TDa(a,b,c){var d=0;j[a>>2]=j[b>>2];d=j[b>>2];j[a+8>>2]=b;j[a+4>>2]=p(c,33)+d;return a}function zsa(a,b,c){var d=0;j[a>>2]=j[b>>2];d=j[b>>2];j[a+8>>2]=b;j[a+4>>2]=(c<<5)+d;return a}function tj(a){var b=0;b=Za-16|0;Za=b;a=j[yc(b+8|0,zb(a)+(nb(a)<<2)|0)>>2];Za=b+16|0;return a}function sIa(a,b,c,d){a=c-b|0;c=j[d>>2]+p((a|0)/-48|0,48)|0;j[d>>2]=c;if((a|0)>=1){Vb(c,b,a)}}function qea(a,b){if(!j[a+4116>>2]){Vm(a+8|0,b,a+4104|0,a+4108|0)}j[a+4116>>2]=1;return a+8|0}function hxa(a,b,c,d){a=c-b|0;c=j[d>>2]+p((a|0)/-12|0,12)|0;j[d>>2]=c;if((a|0)>=1){Vb(c,b,a)}}function e3(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return bb[j[j[a>>2]+16>>2]](a,b,c,d,e)|0}function d3(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return bb[j[j[a>>2]+24>>2]](a,b,c,d,e)|0}function cka(a){var b=0,c=0;b=Za-16|0;Za=b;c=Lb(a);a=Mb(a);th(b+8|0);bka(c,a,b+8|0);Za=b+16|0}function bAa(a,b,c){var d=0;j[a>>2]=j[b>>2];d=j[b>>2];j[a+8>>2]=b;j[a+4>>2]=(c<<3)+d;return a}function _M(a,b,c){var d=0;j[a>>2]=j[b>>2];d=j[b>>2];j[a+8>>2]=b;j[a+4>>2]=p(c,12)+d;return a}function V3(a,b,c){a=a|0;b=b|0;c=c|0;if(ce(a,j[b+4>>2])){a=j[b>>2]==(c|0)}else{a=0}return a|0}function SDa(a,b,c,d){a=c-b|0;c=j[d>>2]+p((a|0)/-33|0,33)|0;j[d>>2]=c;if((a|0)>=1){Vb(c,b,a)}}function REa(a,b,c){var d=0;j[a>>2]=j[b>>2];d=j[b>>2];j[a+8>>2]=b;j[a+4>>2]=p(c,6)+d;return a}function $W(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;a=bb[a|0](b,c,d,e)|0;ea(ab|0);return a|0}function zo(a,b,c){a=al(a)-j[a+1074392>>2]|0;if(a>>>0>=2){c=q(q(q(c-b)/q(a>>>0))+b)}return c}function zk(a,b,c){var d=0;d=Za-16|0;Za=d;Qb(d+8|0,lb(b),c);a=RR(a,d+8|0);Za=d+16|0;return a}function yl(a,b,c){var d=0;j[a>>2]=j[b>>2];d=j[b>>2];j[a+8>>2]=b;j[a+4>>2]=(c<<1)+d;return a}function yB(a,b,c){var d=0;j[a>>2]=j[b>>2];d=j[b>>2];j[a+8>>2]=b;j[a+4>>2]=(c<<4)+d;return a}function wh(a,b,c){var d=0;j[a>>2]=j[b>>2];d=j[b>>2];j[a+8>>2]=b;j[a+4>>2]=(c<<2)+d;return a}function wga(a,b){var c=0;c=Za-16|0;Za=c;Nn(c+8|0,ah(c,b));a=nga(a,c+8|0);Za=c+16|0;return a}function tp(a,b,c){a=a|0;b=b|0;c=c|0;a=j[c+4>>2];j[b>>2]=j[c>>2];j[b+4>>2]=a;Fl(b+8|0,c+8|0)}function tE(a){var b=0;b=GMa(j[a>>2]-1|0);if(!b){a=GMa(j[a+4>>2]);return a?a+32|0:0}return b}function oD(a){var b=0,c=0;c=a;while(1){b=c;c=b+4|0;if(j[b>>2]){continue}break}return b-a>>2}function jC(a){a=a|0;var b=0;j[a>>2]=64740;b=j[a+8>>2];if(!(!b|!k[a+12|0])){Fb(b)}return a|0}function ip(a,b){var c=0;c=nb(a);if((c|0)==(nb(b)|0)){a=!Cm(zb(a),zb(b),c)}else{a=0}return a}function iia(a,b){var c=0;c=Za-16|0;Za=c;j[c+8>>2]=0;jo(a,c+8|0);n[b>>2]=n[c+8>>2];Za=c+16|0}function g8(a,b,c,d){a=c-b|0;c=j[d>>2]+p((a|0)/-24|0,24)|0;j[d>>2]=c;if((a|0)>=1){Vb(c,b,a)}}function _J(a,b){a=a|0;b=b|0;UJ(a);UJ(a+368680|0);if(b){fJ(a,1);return a|0}Lla(a);return a|0}function Yz(a){var b=0;b=Za-16|0;Za=b;a=Ff(a,b+15|0);Za=b+16|0;return(a?k[b+15|0]:0)<<24>>24}function Wda(a,b,c){a=a|0;b=b|0;c=c|0;cw(a);j[a+8>>2]=c;j[a+4>>2]=b;j[a>>2]=83564;return a|0}function Sna(a){a=a|0;var b=0;j[a>>2]=0;b=Za-16|0;Za=b;Lma(a+9|0);Za=b+16|0;wg(a);return a|0}function Rma(a){var b=0;b=Za-16|0;Za=b;j[b+12>>2]=0;Hr(b+12|0,a);Za=b+16|0;return j[b+12>>2]}function MMa(a,b){var c=0,d=0;c=b&31;d=(-1>>>c&a)<<c;c=a;a=0-b&31;return d|(c&-1<<a)>>>a}



function Eia(a,b,c){a=a|0;b=b|0;c=c|0;if(!((c|0)!=-1?(c|0)!=4:0)){iia(a,b);return}hia(a,b,c)}function Bna(a,b){if(b>>>0<=126){wg(((b<<5)+a|0)+480280|0);Tm((p(b,896)+a|0)+1074984|0,a,b)}}function $2(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;return bb[j[j[a>>2]+32>>2]](a,b,c,d,e)|0}function yb(a,b){a=a|0;b=b|0;var c=0;c=j[a>>2];return bb[j[j[c>>2]+36>>2]](c,j[a+8>>2],b)|0}function xta(a,b){if(a-1>>>0<=268435455){a=a+208|0;HMa(b,0,a,0);return ab?0:p(a,b)}return 0}function wr(a){eha(a,j[a+4>>2]);if(j[a>>2]){KH(j[a+16>>2],j[a>>2],j[Ob(a)>>2]-j[a>>2]>>11)}}function qx(a){var b=0;j[a+72>>2]=0;j[a+76>>2]=0;b=j[a+68>>2];j[a+80>>2]=b;j[a+84>>2]=b<<12}function _G(a,b){var c=0;c=j[a+12>>2];if((c|0)>=1){j[a+20>>2]=(j[a+16>>2]+(b+c|0)|0)%(c|0)}}function YJa(a,b){a=a|0;b=b|0;var c=0;c=Za-16|0;Za=c;vg(c,1,a);oA(c,b);Za=c+16|0;return a|0}function Xda(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;IG(a,b,c,d,e,0,0,f,g)}function XJa(a,b){a=a|0;b=b|0;var c=0;c=Za-16|0;Za=c;mt(c,1,a);oA(c,b);Za=c+16|0;return a|0}function UJ(a){j[a+20>>2]=0;h[a+16|0]=7;j[a+8>>2]=1889785610;j[a+12>>2]=1072630333;h[a|0]=3}function Qz(a,b,c){a=a|0;b=b|0;c=c|0;b=Za-16|0;Za=b;h[b+15|0]=k[c|0];UH(a,b+15|0);Za=b+16|0}function QA(a){var b=0;Dp(a);b=a;if(j[b>>2]){wB(b,j[b>>2]);Yf(hb(b),j[b>>2],Af(b))}return a}function Jwa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=Za-16|0;Za=d;Xo(a,b,c);Za=d+16|0;return a|0}function IA(a){a=a|0;var b=0;b=j[a>>2];return lb((bb[j[j[b>>2]+20>>2]](b)|0)+j[a+8>>2]|0)|0}function Hea(a){var b=0;b=j[19209];j[a>>2]=b;j[j[b-12>>2]+a>>2]=j[19212];lr(a+4|0);return a}function CI(a,b,c,d){a=c-b|0;if((a|0)>=1){Vb(j[d>>2],b,a);j[d>>2]=j[d>>2]+p((a>>>0)/6|0,6)}}function yi(a,b){a=a|0;b=b|0;var c=0,d=0;j[a>>2]=j[b>>2];c=a,d=j[b>>2]+tc(b)|0,j[c+4>>2]=d}function hO(a){aAa(a,j[a+4>>2]);if(j[a>>2]){_t(j[a+16>>2],j[a>>2],j[Ob(a)>>2]-j[a>>2]>>3)}}function gj(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=Za-16|0;Za=d;xJ(a,b,c);Za=d+16|0;return a|0}function bB(a,b){var c=0,d=0;vp(a);j[a>>2]=77168;j[a+4>>2]=j[b>>2];c=a,d=Wg(b),j[c+8>>2]=d}function Yh(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=Za-16|0;Za=d;aJ(a,b,c);Za=d+16|0;return a|0}function TP(a,b,c,d){a=c-b|0;c=j[d>>2]+p((a|0)/-6|0,6)|0;j[d>>2]=c;if((a|0)>=1){Vb(c,b,a)}}function Sga(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;a=Mi(a);if(a){bb[j[j[a>>2]+76>>2]](a,b,c,d)}}function Rja(a,b,c){a=a|0;b=b|0;c=c|0;if(!((c|0)!=-1?(c|0)!=4:0)){gi(a,b);return}gD(a,b,c)}function Rga(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;a=Mi(a);if(a){bb[j[j[a>>2]+80>>2]](a,b,c,d)}}function Qga(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;a=Mi(a);if(a){bb[j[j[a>>2]+84>>2]](a,b,c,d)}}function Mka(a,b){a=a|0;b=b|0;var c=0;c=a;a=b+38|0;Kc(c,(k[a|0]|k[a+1|0]<<8)&4?16:8,1,0,0)}function Gka(a,b){a=a|0;b=b|0;var c=0;c=a;a=b+40|0;Kc(c,(k[a|0]|k[a+1|0]<<8)&4?16:8,1,0,0)}function Fk(a){var b=0;if(a>>>0>=11){b=a+16&-16;a=b-1|0;a=(a|0)==11?b:a}else{a=10}return a}function DD(a){var b=0;b=j[a>>2];if(b){if(!ce(QD(b),-1)){return!j[a>>2]}j[a>>2]=0}return 1}function CD(a){var b=0;b=j[a>>2];if(b){if(!ce(KD(b),-1)){return!j[a>>2]}j[a>>2]=0}return 1}function $7(a){var b=0;b=j[19255];j[a>>2]=b;j[j[b-12>>2]+a>>2]=j[19258];lr(a+8|0);return a}function st(a){var b=0;b=Za-16|0;Za=b;a=wKa(a,b+15|0);Za=b+16|0;return(a?k[b+15|0]:0)&255}function rE(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=(b|0)/(c|0)|0;j[a>>2]=d;j[a+4>>2]=b-p(c,d)}function mHa(a,b){var c=0;a=jHa(a,b);if(!a){c=Za-16|0;Za=c;Ab(b,0,771);Za=c+16|0}return a}function kv(a,b,c,d){var e=0;e=Za-16|0;Za=e;j[e+12>>2]=d;a=Iq(a,b,c,d);Za=e+16|0;return a}function jia(a,b,c){if(b){while(1){n[a>>2]=n[c>>2];a=a+4|0;b=b-1|0;if(b){continue}break}}}function gd(a,b){var c=0;c=Za-16|0;Za=c;qj(c+8|0,a+24|0,b);a=kb(c+8|0);Za=c+16|0;return a}function dw(a){a=a|0;var b=0;j[a>>2]=83636;b=j[a+4>>2];if(b){Fb(b);j[a+4>>2]=0}return a|0}function cX(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;bb[a|0](b,c,d,e,f,g)}function XGa(a,b){var c=0;a=UGa(a,b);if(!a){c=Za-16|0;Za=c;Ab(b,0,384);Za=c+16|0}return a}function X2(a,b,c){a=a|0;b=b|0;c=c|0;if(!((c|0)==1|(c|0)>256)){jv(a,c);return}Db(a,58961)}function SGa(a,b){var c=0;a=kFa(a,b);if(!a){c=Za-16|0;Za=c;Ab(b,0,554);Za=c+16|0}return a}function SCa(a,b,c){if(b){while(1){i[a>>1]=l[c>>1];a=a+2|0;b=b-1|0;if(b){continue}break}}}function Jba(a,b){var c=0;c=Za-16|0;Za=c;j[c+8>>2]=b;Mc(a,j[c+8>>2]);Cb(a+12|0);Za=c+16|0}function HH(a){a=a|0;var b=0;b=o[a+4264>>3]*+m[j[a+16>>2]+1074376>>2];o[a+4256>>3]=b-x(b)}function yga(a,b,c){a=a|0;b=b|0;c=c|0;vd(a,b);b=j[c+4>>2];j[a+8>>2]=j[c>>2];j[a+12>>2]=b}function mm(a,b,c){b=p7(b,c);c=j[b+4>>2];j[a>>2]=j[b>>2];j[a+4>>2]=c;j[a+8>>2]=j[b+8>>2]}function jo(a,b){var c=0;c=Za-16|0;Za=c;$g(c+8|0,b);Aia(a,c+8|0);$g(c,b);pb(c);Za=c+16|0}function fo(a,b,c){b=b7(b,c);c=j[b+4>>2];j[a>>2]=j[b>>2];j[a+4>>2]=c;j[a+8>>2]=j[b+8>>2]}function fHa(a,b){var c=0;a=cHa(a,b);if(!a){c=Za-16|0;Za=c;Ab(b,0,62);Za=c+16|0}return a}function dd(a){var b=0;b=Za-16|0;Za=b;a=Ff(a,b+15|0);Za=b+16|0;return(a?k[b+15|0]:0)&255}function _e(a){var b=0;b=Za-16|0;Za=b;a=j[yc(b+8|0,zb(a)+nb(a)|0)>>2];Za=b+16|0;return a}function Uga(a,b){a=a|0;b=b|0;a=Mi(a);if(!a){return 1}return bb[j[j[a>>2]+68>>2]](a,b)|0}function Tqa(a,b,c){var d=0;d=Za-16|0;Za=d;if(!pt(a,b)){b=pt(c,a)?c:a}Za=d+16|0;return b}function Fsa(a,b){Esa(a,b);Mc(a+12|0,b+12|0);i[a+28>>1]=l[b+28>>1];j[a+24>>2]=j[b+24>>2]}function tK(a,b){var c=0;c=k[a+872|0];if(c&1){h[a+872|0]=c|8;j[a+876>>2]=j[a+876>>2]+b}}function sT(a){var b=0,c=0;b=Za-16|0;Za=b;if(Ff(a,b+8|0)){c=k[b+8|0]}Za=b+16|0;return c}function pD(a,b){var c=0;c=Za-16|0;Za=c;j[c+12>>2]=b;a=sD(a,64672,b);Za=c+16|0;return a}function ni(a){h[a|0]=0;h[a+1|0]=0;h[a+2|0]=0;h[a+3|0]=0;h[a+4|0]=0;h[a+5|0]=0;return a}function hMa(a,b,c){if(b){while(1){h[a|0]=k[c|0];a=a+1|0;b=b-1|0;if(b){continue}break}}}function ah(a,b){var c=0,d=0;j[a>>2]=j[b>>2];c=a,d=j[b>>2]+Wg(b)|0,j[c+4>>2]=d;return a}function WO(a,b){var c=0,d=0;j[a>>2]=j[b>>2];c=a,d=j[b>>2]+QO(b)|0,j[c+4>>2]=d;return a}function RU(a){a=a|0;var b=0;b=j[a+4>>2];return(bb[j[j[b>>2]+20>>2]](b)|0)+j[a+12>>2]|0}function Kl(a){var b=0;b=eu(a+4|0);if((b|0)==-1){bb[j[j[a>>2]+8>>2]](a)}return(b|0)==-1}function Kb(a,b){var c=0,d=0;j[a>>2]=j[b>>2];c=a,d=j[b>>2]+pb(b)|0,j[c+4>>2]=d;return a}function Hs(a,b,c){var d=0;j[a>>2]=j[b>>2];d=j[b>>2];j[a+8>>2]=b;j[a+4>>2]=c+d;return a}function He(a,b){var c=0;vk(a,b);c=j[b+12>>2];j[a+8>>2]=j[b+8>>2];j[a+12>>2]=c;return a}function Er(a,b){if(!(j[a+480180>>2]==8?h[b+872|0]&1:0)){Rw(a,b,0);Rw(a,b,1);Rw(a,b,2)}}function Ed(a,b){var c=0;RV(a,b);c=j[b+12>>2];j[a+8>>2]=j[b+8>>2];j[a+12>>2]=c;return a}function EL(a,b){var c=0;b=lb(b);c=a;a=j[a>>2];j[c>>2]=a<<8^j[((b^a>>>24)<<2)+87648>>2]}function DP(a,b,c){a=a|0;b=b|0;c=c|0;a=l[c>>1]|l[c+2>>1]<<16;i[b>>1]=a;i[b+2>>1]=a>>>16}function yQ(a){var b=0;b=Za-16|0;Za=b;j[b+12>>2]=-1;a=aGa(a,b+12|0);Za=b+16|0;return a}function uB(a){var b=0;b=a+48|0;while(1){b=gb(b-12|0);if((b|0)!=(a|0)){continue}break}}function fN(a){var b=0;b=44325e5/+(a>>>0);if(b<4294967296&b>=0){return~~b>>>0}return 0}function Zd(a){var b=0,c=0,d=0;b=Za-16|0;Za=b;c=j[Bu(b,a)+8>>2],d=0,h[c|0]=d;Za=b+16|0}function YB(a,b,c){a=a|0;b=b|0;c=c|0;if((a|0)==(b|0)){h[a+112|0]=0;return}nv(b,c<<2,4)}function XJ(a){Qc(a);Qc(a+12|0);Qc(a+24|0);Qc(a+36|0);Qc(a+48|0);j[a+60>>2]=0;return a}function Nl(a){var b=0;b=a+36|0;while(1){b=gb(b-12|0);if((b|0)!=(a|0)){continue}break}}function Ne(a){var b=0;b=a+24|0;while(1){b=gb(b-12|0);if((b|0)!=(a|0)){continue}break}}function LMa(a){var b=0,c=0;while(1){c=b;if(a){a=a-1&a;b=b+1|0;continue}break}return c}function KFa(a){var b=0;b=Za-16|0;Za=b;a=Xp(a,b+8|0);Za=b+16|0;return a?n[b+8>>2]:q(0)}function Ju(a,b){a=a|0;b=b|0;var c=0;c=Za-16|0;Za=c;dY(a,b,oD(b));Za=c+16|0;return a|0}function JL(a,b){return(a>>>0<=62?63-(p((b^-1)&63,(a?a+1|0:0)&255)>>>6|0)|b&192:b)&255}function Db(a,b){a=a|0;b=b|0;var c=0;c=Za-16|0;Za=c;Xo(a,b,ne(b));Za=c+16|0;return a|0}function $R(a,b,c){h[a+2|0]=1;b=b&15;if(c){b=k[b+12336|0]}else{b=(b<<2)+4|0}h[a+4|0]=b}function ts(a,b){a:{if(b){break a}if(a>>>0<=3){a=a|-16;break a}a=a>>>2|0}return a&255}function tG(a,b){a=a|0;b=b|0;var c=0;c=ue(8);kG(c);j[c+4>>2]=b;j[c>>2]=84008;Eaa(a,c)}function o5(a,b){a=a|0;b=b|0;a=l[a>>1];b=l[b>>1];return(a>>>0<b>>>0?-1:a>>>0>b>>>0)|0}function nZ(a){a=a|0;a=462296;while(1){a=gb(a-12|0);if((a|0)!=462128){continue}break}}function kua(a){a=a+1|0;if((a&255)>>>0<=5){return j[(a<<24>>24<<2)+18440>>2]}return 0}function kZ(a){a=a|0;a=462472;while(1){a=pc(a-12|0);if((a|0)!=462304){continue}break}}function k9(a,b){a=a|0;b=b|0;var c=0;c=Za-16|0;Za=c;mT(c+8|0,b);Ht(a,c+8|0);Za=c+16|0}function hZ(a){a=a|0;a=462768;while(1){a=gb(a-12|0);if((a|0)!=462480){continue}break}}function eZ(a){a=a|0;a=463072;while(1){a=pc(a-12|0);if((a|0)!=462784){continue}break}}function bZ(a){a=a|0;a=463112;while(1){a=gb(a-12|0);if((a|0)!=463088){continue}break}}function _4(a,b){a=a|0;b=b|0;a=j[a>>2];b=j[b>>2];return(a>>>0<b>>>0?-1:a>>>0>b>>>0)|0}function ZY(a){a=a|0;a=463144;while(1){a=pc(a-12|0);if((a|0)!=463120){continue}break}}function Xga(a,b,c){var d=0;d=Za-16|0;Za=d;j[d+12>>2]=k[b|0];mw(a,d+12|0,c);Za=d+16|0}function V$(a,b,c){a=a|0;b=b|0;c=c|0;c=ev(j[b>>2])<<24;j[a+4>>2]=j[b>>2];h[a|0]=c>>24}function Ul(a){var b=0;if(a>>>0>=2){b=a+4&-4;a=b-1|0;a=(a|0)==2?b:a}else{a=1}return a}function Nza(a,b){var c=0;c=Za-16|0;Za=c;a=bO(vd(c+8|0,a),vd(c,b));Za=c+16|0;return a}function Naa(a,b){a=a|0;b=b|0;var c=0;c=Za-16|0;Za=c;qm(c,a);Maa(b,c);Ye(c);Za=c+16|0}function z_(a,b){var c=0;c=Za-16|0;Za=c;j[c+12>>2]=b;ye(a,c+12|0);Za=c+16|0;return a}function th(a){h[a|0]=0;h[a+1|0]=0;h[a+2|0]=0;h[a+3|0]=0;h[a+4|0]=0;h[a+5|0]=0;ni(a)}function ef(a){a=a|0;var b=0;b=j[a>>2];return(bb[j[j[b>>2]+24>>2]](b)|0)-j[a+8>>2]|0}function d_(a,b){a=a|0;b=b|0;if((b|0)>=0){b=j[qq()+((b&255)<<2)>>2]}return b<<24>>24}function b_(a,b){a=a|0;b=b|0;if((b|0)>=0){b=j[pq()+((b&255)<<2)>>2]}return b<<24>>24}function Qe(a){a=a|0;var b=0;b=Za-16|0;Za=b;a=j[yc(b+8|0,a)>>2];Za=b+16|0;return a|0}function Lda(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return BG(a,b,c,d,0,0,0,0,e)|0}function $ia(a,b,c){var d=0;d=Za-16|0;Za=d;yc(d+8|0,ez(pl(a),pl(b),pl(c)));Za=d+16|0}function z1(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return y1(b,c,d,e,f)|0}function yLa(a){a=a|0;var b=0;b=Za-16|0;Za=b;FS(b+8|0,a);Za=b+16|0;return j[b+8>>2]}function x1(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return w1(b,c,d,e,f)|0}function v1(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return u1(b,c,d,e,f)|0}function t1(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return s1(b,c,d,e,f)|0}function r1(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return q1(b,c,d,e,f)|0}function p1(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return o1(b,c,d,e,f)|0}function lka(a,b){a=a|0;b=b|0;if(b>>>0<=42){return k[j[a+84>>2]+b|0]!=63|0}return 0}function lMa(a,b){var c=0,d=0;c=Za-16|0;Za=c;d=zn(c+8|0,b,a);Za=c+16|0;return d?b:a}function i2(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return h2(b,c,d,e,f)|0}function f2(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return e2(b,c,d,e,f)|0}function dD(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return bb[j[j[a>>2]+32>>2]](a,b,c,d)|0}function c2(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return b2(b,c,d,e,f)|0}function bma(a,b,c,d){var e=0;e=Za-16|0;Za=e;j[e+8>>2]=d;$la(a,b,c,e+8|0);Za=e+16|0}function aEa(a,b){var c=0;a=PDa(a,b);if(!a){c=Za-16|0;Za=c;HP(b);Za=c+16|0}return a}function aD(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return bb[j[j[a>>2]+48>>2]](a,b,c,d)|0}function ZIa(a,b){a=a|0;b=b|0;PIa(a,b);h[a+16|0]=6;j[a+12>>2]=2015363072;return a|0}function Ye(a){var b=0;sh(a);b=a;if(j[b>>2]){KF(b);yo(hb(b),j[b>>2],Be(b))}return a}function YW(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;a=bb[a|0](b,c,d)|0;ea(ab|0);return a|0}function Y1(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return X1(b,c,d,e,f)|0}function W1(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return V1(b,c,d,e,f)|0}function T1(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return S1(b,c,d,e,f)|0}function QV(a,b){var c=0;c=Za-16|0;Za=c;PV(c+8|0,b);Jl(a,c+8|0);jb(c+8|0);Za=c+16|0}function P1(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return O1(b,c,d,e,f)|0}function M1(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return L1(b,c,d,e,f)|0}function LV(a,b){var c=0;c=Za-16|0;Za=c;j[c+8>>2]=b;bB(a,ah(c,j[c+8>>2]));Za=c+16|0}function Jl(a,b){j[a>>2]=j[b>>2];j[a+4>>2]=j[b+4>>2];j[b>>2]=0;j[b+4>>2]=0;return a}function GY(a,b){if(!(k[a+112|0]|b>>>0>28)){h[a+112|0]=1;return a}return ac(b<<2,4)}function G1(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return F1(b,c,d,e,f)|0}function D1(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return C1(b,c,d,e,f)|0}function B1(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return A1(b,c,d,e,f)|0}function AAa(a){var b=0;b=Za-16|0;Za=b;a=Zt(a,b+8|0);Za=b+16|0;return a?o[b+8>>3]:0}function $1(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return Z1(b,c,d,e,f)|0}function xja(a,b,c){if(b){while(1){FI(a,c);a=a+52|0;b=b-1|0;if(b){continue}break}}}function wja(a,b,c){j[a>>2]=b;b=j[b+4>>2];j[a+4>>2]=b;j[a+8>>2]=b+p(c,52);return a}function px(a,b){var c=0;h[a|0]=k[b|0];c=j[b+8>>2];j[a+4>>2]=j[b+4>>2];j[a+8>>2]=c}function nk(a,b){a=a|0;b=b|0;if(Yb(a)>>>0<=b>>>0){pE();z()}return j[a>>2]+(b<<1)|0}function nP(a){var b=0;b=Za-16|0;Za=b;a=j[yc(b+8|0,j[a>>2])>>2];Za=b+16|0;return a}function kha(a,b,c){j[a>>2]=b;b=j[b+4>>2];j[a+4>>2]=b;j[a+8>>2]=b+(c<<11);return a}function gba(a){var b=0;b=Za-16|0;Za=b;j[b+12>>2]=38341;Db(a,j[b+12>>2]);Za=b+16|0}function gU(a,b){var c=0,d=0;c=Za-16|0;Za=c;d=zn(c+8|0,a,b);Za=c+16|0;return d?b:a}function _g(a){var b=0,c=0;b=Za-16|0;Za=b;c=b+8|0;cB(c,a);Za=b+16|0;return j[c>>2]}function Xx(a){if(j[a>>2]){ee(a,j[a>>2]);cxa(j[a>>2],(j[hb(a)>>2]-j[a>>2]|0)/9|0)}}function WDa(a,b,c){j[a>>2]=b;b=j[b+4>>2];j[a+4>>2]=b;j[a+8>>2]=b+p(c,33);return a}function SK(a,b){var c=0;c=b&15;if(c){h[a+850|0]=c}b=b&240;if(b){h[a+849|0]=b>>>4}}function RE(a,b){b=j[a+32>>2]+b|0;j[a+32>>2]=b;if(b>>>0>=m[a+40>>2]){j[a+96>>2]=1}}function NI(a,b){a=a|0;b=b|0;if(b>>>0<=15){return k[j[a+88>>2]+b|0]!=63|0}return 0}function EBa(a,b,c){j[a>>2]=b;b=j[b+4>>2];j[a+4>>2]=b;j[a+8>>2]=b+p(c,20);return a}function CBa(a){var b=0,c=0;b=Za-16|0;Za=b;c=a;a=zh(b);_O(c,a,0,0);jb(a);Za=b+16|0}function wz(a,b,c){a=a|0;b=b|0;c=c|0;a=k[c|0]|k[c+1|0]<<8;h[b|0]=a;h[b+1|0]=a>>>8}function kka(a,b){var c=0;c=Za-16|0;Za=c;j[c+12>>2]=k[b|0];Bw(a,c+12|0);Za=c+16|0}function kR(a,b,c){j[a>>2]=b;b=j[b+4>>2];j[a+4>>2]=b;j[a+8>>2]=b+p(c,48);return a}function ik(a,b,c){j[a>>2]=b;b=j[b+4>>2];j[a+4>>2]=b;j[a+8>>2]=b+p(c,24);return a}function gza(a,b){a=a|0;b=b|0;if(j[a+4>>2]!=j[hb(a)>>2]){$ya(a,b);return}_ya(a,b)}function fpa(a,b){a=a|0;b=b|0;if(j[a+4>>2]!=j[hb(a)>>2]){Voa(a,b);return}Uoa(a,b)}function fB(a){var b=0;b=j[a>>2];j[a>>2]=0;if(b){a=Rb(a);Gf(j[a>>2],b,j[a+4>>2])}}function ega(a,b){a=a|0;b=b|0;if(j[a+4>>2]!=j[hb(a)>>2]){cga(a,b);return}bga(a,b)}function dxa(a,b,c){j[a>>2]=b;b=j[b+4>>2];j[a+4>>2]=b;j[a+8>>2]=b+p(c,9);return a}function Xt(a,b){var c=0;j[a>>2]=j[b>>2];c=a;a=j[b+4>>2];j[c+4>>2]=a;if(a){Ll(a)}}function Wx(a,b){a=Vb(a,b,34);i[a+34>>1]=l[b+34>>1];Vb(a+36|0,b+36|0,68);return a}function WA(a){var b=0;b=j[a>>2];j[a>>2]=0;if(b){a=Rb(a);Ai(j[a>>2],b,j[a+4>>2])}}function Vla(a,b){a=a|0;b=b|0;if(j[a+4>>2]!=j[hb(a)>>2]){Tla(a,b);return}Sla(a,b)}function Sia(a,b){var c=0;c=Za-16|0;Za=c;yc(c+8|0,Qia(a,j[yc(c,b)>>2]));Za=c+16|0}function PF(a){var b=0;b=j[a>>2];j[a>>2]=0;if(b){a=Rb(a);cy(j[a>>2],b,j[a+4>>2])}}function Ok(a,b,c){j[a>>2]=b;b=j[b+4>>2];j[a+4>>2]=b;j[a+8>>2]=b+p(c,12);return a}function OFa(a,b){a=a|0;b=b|0;if(j[a+4>>2]!=j[hb(a)>>2]){AFa(a,b);return}zFa(a,b)}function Mxa(a,b){a=a|0;b=b|0;if(j[a+4>>2]!=j[hb(a)>>2]){Bxa(a,b);return}Axa(a,b)}function MHa(a,b){a=a|0;b=b|0;if(j[a+4>>2]!=j[hb(a)>>2]){xHa(a,b);return}wHa(a,b)}function MA(a){var b=0;b=j[a>>2];j[a>>2]=0;if(b){a=Rb(a);Yg(j[a>>2],b,j[a+4>>2])}}function DG(a,b){var c=0;c=j[a>>2];j[a>>2]=b;if(c){if(c){bb[j[j[c>>2]+4>>2]](c)}}}function Bia(a,b){a=a|0;b=b|0;if(j[a+4>>2]!=j[hb(a)>>2]){zia(a,b);return}yia(a,b)}function zR(a,b){a=a|0;b=b|0;if(j[a+4>>2]!=j[hb(a)>>2]){TIa(a,b);return}SIa(a,b)}function yh(a,b,c){j[a>>2]=b;b=j[b+4>>2];j[a+4>>2]=b;j[a+8>>2]=b+(c<<1);return a}function wia(a,b){var c=0;c=Za-16|0;Za=c;lq(a,j[b>>2],j[b>>2]+pb(b)|0);Za=c+16|0}function tna(a,b){a=a|0;b=b|0;if(m[a+4>>2]<m[hb(a)>>2]){ona(a,b);return}nna(a,b)}function op(a,b,c){j[a>>2]=b;b=j[b+4>>2];j[a+4>>2]=b;j[a+8>>2]=b+p(c,6);return a}function oS(a,b){a=a|0;b=b|0;if(j[a+4>>2]!=j[hb(a)>>2]){KKa(a,b);return}JKa(a,b)}function nd(a){var b=0;b=Za-16|0;Za=b;a=j[yc(b+8|0,zb(a))>>2];Za=b+16|0;return a}function jEa(a,b){a=a|0;b=b|0;if(m[a+4>>2]<m[hb(a)>>2]){IDa(a,b);return}HDa(a,b)}function ii(a){var b=0;b=Za-16|0;Za=b;a=j[yc(b+8|0,aj(a))>>2];Za=b+16|0;return a}function cza(a,b){a=a|0;b=b|0;if(m[a+4>>2]<m[hb(a)>>2]){Mya(a,b);return}Lya(a,b)}function ata(a,b){a=a|0;b=b|0;if(m[a+4>>2]<m[hb(a)>>2]){$sa(a,b);return}_sa(a,b)}function aj(a){var b=0;b=Za-16|0;Za=b;a=j[yc(b+8|0,Rb(a))>>2];Za=b+16|0;return a}function _m(a){var b=0;b=Za-16|0;Za=b;a=j[yc(b+8|0,nP(a))>>2];Za=b+16|0;return a}function _d(a,b,c){j[a>>2]=b;b=j[b+4>>2];j[a+4>>2]=b;j[a+8>>2]=b+(c<<2);return a}function Wp(a,b,c){j[a>>2]=b;b=j[b+4>>2];j[a+4>>2]=b;j[a+8>>2]=b+(c<<3);return a}function UJa(a,b){a=a|0;b=b|0;if(m[a+4>>2]<m[hb(a)>>2]){GJa(a,b);return}FJa(a,b)}function Raa(a,b){a=a|0;b=b|0;if(m[a+4>>2]<m[hb(a)>>2]){Paa(a,b);return}Oaa(a,b)}function Ql(a,b,c){j[a>>2]=b;b=j[b+4>>2];j[a+4>>2]=b;j[a+8>>2]=b+(c<<4);return a}function PHa(a,b){a=a|0;b=b|0;if(m[a+4>>2]<m[hb(a)>>2]){HHa(a,b);return}GHa(a,b)}function Mwa(a,b){a=a|0;b=b|0;if(m[a+4>>2]<m[hb(a)>>2]){Dwa(a,b);return}Cwa(a,b)}function KBa(a,b){var c=0;c=Za-16|0;Za=c;lq(a,j[b>>2],j[b>>2]+QO(b)|0);Za=c+16|0}function Fka(a,b){a=a|0;b=b|0;if(m[a+4>>2]<m[hb(a)>>2]){wka(a,b);return}vka(a,b)}function Cn(a,b,c){j[a>>2]=b;b=j[b+4>>2];j[a+4>>2]=b;j[a+8>>2]=b+(c<<5);return a}function Aia(a,b){var c=0;c=Za-16|0;Za=c;hI(c+8|0,Kb(c,b));RR(a,c+8|0);Za=c+16|0}function $aa(a,b){a=a|0;b=b|0;if(m[a+4>>2]<m[hb(a)>>2]){_aa(a,b);return}Zaa(a,b)}function uV(a){var b=0;b=Za-16|0;Za=b;tV(b+8|0);Jl(a,b+8|0);jb(b+8|0);Za=b+16|0}function lIa(a){var b=0;b=Za-16|0;Za=b;h[a|0]=0;h[a+1|0]=0;h[a+2|0]=0;Za=b+16|0}function l2(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;b=Za-16|0;Za=b;fD(a,c,d);Za=b+16|0}function fL(a,b){a=a|0;b=b|0;if(m[a+4>>2]<m[hb(a)>>2]){Jqa(a,b);return}Iqa(a,b)}function bI(a,b){a=a|0;b=b|0;if(m[a+4>>2]<m[hb(a)>>2]){Tha(a,b);return}Sha(a,b)}function ZR(a,b){a=a|0;b=b|0;return j[b+8>>2]==j[a+8>>2]&j[a+12>>2]==j[b+12>>2]}function XW(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;bb[a|0](b,c,d,e,f)}function Vx(a,b){a=a|0;b=b|0;if(m[a+4>>2]<m[hb(a)>>2]){Iva(a,b);return}xva(a,b)}function TV(a,b){var c=0;c=Za-16|0;Za=c;lq(a,j[b>>2],j[b>>2]+KA(b)|0);Za=c+16|0}function SX(a,b){var c=0;c=Za-16|0;Za=c;lq(a,j[b>>2],j[b>>2]+Wg(b)|0);Za=c+16|0}function CO(a,b){var c=0;cBa(a,b);c=j[b+12>>2];j[a+8>>2]=j[b+8>>2];j[a+12>>2]=c}function ys(a){h[a|0]=0;h[a+1|0]=0;h[a+2|0]=0;h[a+3|0]=0;h[a+4|0]=0;h[a+5|0]=0}function vE(a,b,c){var d=0;d=Za-16|0;Za=d;j[d+12>>2]=c;yE(a,b,c,0,0);Za=d+16|0}function txa(a,b){a=a|0;b=b|0;Li(b);if(j[b>>2]){dN(b);eh(hb(b),j[b>>2],Vf(b))}}function s6(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=+d;e=+e;return fF(a-88|0,b,c,d,e)|0}function ks(a,b){return Zj(Cg((+(a|0)*128+ +(b|0))*.0006510416666666666)*8363)}function cpa(a){var b=0;if(!(k[a+2|0]|(k[a|0]|k[a+1|0]))){b=!k[a+3|0]}return b}function cBa(a,b){var c=0;c=Za-16|0;Za=c;b=vk(c+8|0,b);gB(b,a);jb(b);Za=c+16|0}function _W(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return bb[a|0](b,c,d,e)|0}function WU(a,b,c,d){vp(a);j[a>>2]=77376;vk(a+4|0,b);j[a+16>>2]=d;j[a+12>>2]=c}function R3(a,b,c){a=a|0;b=b|0;c=c|0;if((c|0)>=257){Db(a,58232);return}jv(a,c)}function P3(a,b,c){a=a|0;b=b|0;c=c|0;if((c|0)>=257){Db(a,58311);return}jv(a,c)}function Oea(a,b){a=a|0;b=b|0;return q((b|0)<=12?n[((b<<2)+a|0)+4208>>2]:q(0))}function Noa(a,b){var c=0;c=Za-16|0;Za=c;a=noa(Pr(a),Pr(b));Za=c+16|0;return a}function Fl(a,b){var c=0;Jl(a,b);c=j[b+12>>2];j[a+8>>2]=j[b+8>>2];j[a+12>>2]=c}function EU(a,b){a=a|0;b=b|0;if(j[a+4>>2]!=j[hb(a)>>2]){AU(a,b);return}zU(a,b)}function z7(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;cr(b,c,d,n[a+24>>2]);BF(a,b,c,d)}function xfa(a,b){a=a|0;b=b|0;return q((b|0)<=4?n[((b<<2)+a|0)+4208>>2]:q(0))}function xea(a,b){a=a|0;b=b|0;return q((b|0)<=3?n[((b<<2)+a|0)+4208>>2]:q(0))}function vk(a,b){j[a>>2]=j[b>>2];b=j[b+4>>2];j[a+4>>2]=b;if(b){Ll(b)}return a}function qfa(a,b){a=a|0;b=b|0;return q((b|0)<=4?n[((b<<2)+a|0)+4220>>2]:q(0))}function qMa(a,b){var c=0,d=0;c=Za-16|0;Za=c;d=Uz(b,a);Za=c+16|0;return d?b:a}function qCa(a,b){var c=0,d=0;c=Za-16|0;Za=c;d=$O(a,b);Za=c+16|0;return d?b:a}function ina(a,b){a=a|0;b=b|0;return(b>>>0<4e3?((b<<5)+a|0)+946300|0:20525)|0}function iY(a,b){var c=0;c=nb(a);if(c>>>0<b>>>0){us(a,b-c|0,0);return}hY(a,b)}function iCa(a,b){var c=0,d=0;c=Za-16|0;Za=c;d=$O(b,a);Za=c+16|0;return d?b:a}function i7(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;cr(b,c,d,n[a+24>>2]);yF(a,b,c,d)}function afa(a,b){a=a|0;b=b|0;return q((b|0)<=1?n[((b<<2)+a|0)+4208>>2]:q(0))}function a8(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;cr(b,c,d,n[a+28>>2]);GF(a,b,c,d)}function Wfa(a,b){a=a|0;b=b|0;return q((b|0)<=6?n[((b<<2)+a|0)+4208>>2]:q(0))}function Tma(a,b){var c=0,d=0;c=Za-16|0;Za=c;d=Uz(a,b);Za=c+16|0;return d?b:a}function S4(a,b){a=a|0;b=b|0;if(m[a+4>>2]<m[hb(a)>>2]){s4(a,b);return}m4(a,b)}function RV(a,b){var c=0;c=Za-16|0;Za=c;b=Jl(c+8|0,b);gB(b,a);jb(b);Za=c+16|0}function Nya(a,b){var c=0,d=0;c=Za-16|0;Za=c;d=OS(a,b);Za=c+16|0;return d?b:a}function Mh(a,b,c){if(j[a+80>>2]){j[a+92>>2]=j[a+92>>2]+(c+7&-8);return}Fb(b)}function M7(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;cr(b,c,d,n[a+28>>2]);DF(a,b,c,d)}function Lna(a){var b=0;b=Za-16|0;Za=b;a=j[AJ(b+8|0,a)>>2];Za=b+16|0;return a}function Ifa(a,b){a=a|0;b=b|0;return q((b|0)<=5?n[((b<<2)+a|0)+4208>>2]:q(0))}function IKa(a,b){var c=0,d=0;c=Za-16|0;Za=c;d=pt(b,a);Za=c+16|0;return d?b:a}function Efa(a,b){var c=0,d=0;c=Za-16|0;Za=c;d=uH(b,a);Za=c+16|0;return d?b:a}function Eea(a,b){a=a|0;b=b|0;return q((b|0)<=2?n[((b<<2)+a|0)+4208>>2]:q(0))}function EKa(a,b){var c=0,d=0;c=Za-16|0;Za=c;d=pt(a,b);Za=c+16|0;return d?b:a}function CX(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;if(Qf(a,j[b+8>>2],0)){xu(b,c,d)}}function CU(a,b){a=a|0;b=b|0;if(m[a+4>>2]<m[hb(a)>>2]){yU(a,b);return}xU(a,b)}function Bga(a,b){var c=0,d=0;c=Za-16|0;Za=c;d=uH(a,b);Za=c+16|0;return d?b:a}function zi(a,b){a=a|0;b=b|0;if((a|0)!=(b|0)){a=dO(a,zb(b),nb(b))}return a|0}function wV(a,b){var c=0,d=0;c=Za-16|0;Za=c;d=rd(b,a);Za=c+16|0;return d?b:a}function pl(a){var b=0;b=Za-16|0;Za=b;j[b+8>>2]=a;Za=b+16|0;return j[b+8>>2]}function pW(a,b){var c=0,d=0;c=Za-16|0;Za=c;d=rd(a,b);Za=c+16|0;return d?b:a}function on(a,b,c,d){a=c-b|0;if((a|0)>=1){Vb(j[d>>2],b,a);j[d>>2]=j[d>>2]+a}}function oi(a,b,c,d){a=c-b|0;c=j[d>>2]-a|0;j[d>>2]=c;if((a|0)>=1){Vb(c,b,a)}}function iG(a,b,c,d){j[a+12>>2]=0;j[a+8>>2]=d;j[a+4>>2]=c;j[a>>2]=b;return a}function fy(a){a=a+4|0;return k[a|0]|k[a+1|0]<<8|(k[a+2|0]<<16|k[a+3|0]<<24)}function eL(a){var b=0;b=Za-16|0;Za=b;cB(b+8|0,a);Za=b+16|0;return j[b+8>>2]}function cd(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=j[b+8>>2];Jb(b,c);gu(a,b,d,c)}function bE(){a:{if(h[461648]&1){break a}if(!fd(461648)){break a}ed(461648)}}function R1(a,b){var c=0,d=0;c=Za-16|0;Za=c;d=TB(b,a);Za=c+16|0;return d?b:a}function OT(a,b){var c=0,d=0;c=Za-16|0;Za=c;d=TB(a,b);Za=c+16|0;return d?b:a}function MC(a,b){var c=0,d=0;fe(a,ud(b));b=j[Rb(b)>>2];c=Rb(a),d=b,j[c>>2]=d}function vl(a,b,c){j[a>>2]=b;b=j[b+4>>2];j[a+4>>2]=b;j[a+8>>2]=b+c;return a}function pB(a,b){a=a|0;b=b|0;var c=0;c=Za-16|0;Za=c;di(a,c+8|0,b);Za=c+16|0}function gE(a,b,c,d,e,f,g,h){return bb[j[j[a>>2]+16>>2]](a,b,c,d,e,f,g,h)|0}function aS(a,b){a=a|0;b=b|0;a=j[a>>2];return bb[j[j[a>>2]+36>>2]](a,0,b)|0}function ZM(a){if((k[a+14|0]-49&255)>>>0<=3){return!_c(a,17504,14)}return 0}function WM(a,b){zN(a,b);h[a+16|0]=k[b+16|0];j[a+12>>2]=j[b+12>>2];return a}function Nn(a,b){a=a|0;b=b|0;var c=0;c=Za-16|0;Za=c;SX(a,ah(c,b));Za=c+16|0}function MI(a,b){a=a|0;b=b|0;return(b>>>0<=15?h[j[a+88>>2]+b|0]:63)<<24>>24}function LI(a,b){a=a|0;b=b|0;return(b>>>0<=42?h[j[a+84>>2]+b|0]:63)<<24>>24}function Jq(a,b,c,d,e,f,g,h){return bb[j[j[a>>2]+12>>2]](a,b,c,d,e,f,g,h)|0}function AW(a,b){a=a|0;b=b|0;var c=0;c=Za-16|0;Za=c;Ol(a,c+8|0,b);Za=c+16|0}function vm(a,b){a=j[a+4276>>2];return(((a<<12&b>>31)+b|0)/4096|0)%(a|0)|0}function tg(a,b){a=a|0;b=b|0;if(yp(a,b)){a=uh(te(a,b))}else{a=0}return a|0}function sg(a,b,c){j[a+8>>2]=b;j[a+12>>2]=c;j[a>>2]=0;j[a+4>>2]=0;return a}function l_(a,b){a=a|0;b=b|0;if(b>>>0<=127){b=j[qq()+(b<<2)>>2]}return b|0}function j_(a,b){a=a|0;b=b|0;if(b>>>0<=127){b=j[pq()+(b<<2)>>2]}return b|0}function gL(a,b,c){var d=0;d=j[b+4>>2];j[a>>2]=j[b>>2];j[a+4>>2]=d;QM(a,c)}function eGa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=c,e=JEa(a,b),j[d>>2]=e}function cg(a,b){var c=0;c=a;a=j[a+8>>2];b=a-b|0;j[c+8>>2]=a>>>0<b>>>0?0:b}function bGa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=c,e=IEa(a,b),i[d>>1]=e}function Xra(a){var b=0;b=Za-288|0;Za=b;a=fsa(a,HL(b));Za=b+288|0;return a}function Ola(a){var b=0;b=Za-16|0;Za=b;Mla(a,b+8|0);Za=b+16|0;return a}



function Bu(a,b){j[a+12>>2]=0;j[a+4>>2]=b;j[a>>2]=b;j[a+8>>2]=b+1;return a}function zj(a,b,c){a=a|0;b=b|0;c=c|0;return bb[j[j[a>>2]+12>>2]](a,b,c)|0}function yJ(a){vma(a,j[a+4>>2]);if(j[a>>2]){xe(j[a+16>>2],j[a>>2],_f(a))}}function wm(a){tia(a,j[a+4>>2]);if(j[a>>2]){xe(j[a+16>>2],j[a>>2],_f(a))}}function vr(a){aha(a,j[a+4>>2]);if(j[a>>2]){xe(j[a+16>>2],j[a>>2],_f(a))}}function qs(a){gxa(a,j[a+4>>2]);if(j[a>>2]){eh(j[a+16>>2],j[a>>2],Vn(a))}}function pr(a){_fa(a,j[a+4>>2]);if(j[a>>2]){xe(j[a+16>>2],j[a>>2],_f(a))}}function nt(a){rJa(a,j[a+4>>2]);if(j[a>>2]){pn(j[a+16>>2],j[a>>2],xn(a))}}function mk(a){jMa(a,j[a+4>>2]);if(j[a>>2]){yn(j[a+16>>2],j[a>>2],xn(a))}}function k3(a,b,c){a=a|0;b=b|0;c=c|0;return bb[j[j[a>>2]+32>>2]](a,b,c)|0}function iP(a){HCa(a,j[a+4>>2]);if(j[a>>2]){$i(j[a+16>>2],j[a>>2],_f(a))}}function iL(a){Wqa(a,j[a+4>>2]);if(j[a>>2]){eh(j[a+16>>2],j[a>>2],Vn(a))}}function iA(a,b){var c=0;c=Za-16|0;Za=c;hA(c+8|0,b);Ht(a,c+8|0);Za=c+16|0}function fs(a){Csa(a,j[a+4>>2]);if(j[a>>2]){Yg(j[a+16>>2],j[a>>2],bu(a))}}function fR(a){nIa(a,j[a+4>>2]);if(j[a>>2]){Gf(j[a+16>>2],j[a>>2],sl(a))}}function eK(a){hoa(a,j[a+4>>2]);if(j[a>>2]){Cs(j[a+16>>2],j[a>>2],bu(a))}}function dP(a){yCa(a,j[a+4>>2]);if(j[a>>2]){pn(j[a+16>>2],j[a>>2],xn(a))}}function cJ(a){Ila(a,j[a+4>>2]);if(j[a>>2]){xe(j[a+16>>2],j[a>>2],_f(a))}}function aQ(a){$Ea(a,j[a+4>>2]);if(j[a>>2]){$i(j[a+16>>2],j[a>>2],_f(a))}}function _Q(a){DHa(a,j[a+4>>2]);if(j[a>>2]){Gf(j[a+16>>2],j[a>>2],sl(a))}}function Ys(a){rHa(a,j[a+4>>2]);if(j[a>>2]){Ai(j[a+16>>2],j[a>>2],ru(a))}}function Yr(a){Dqa(a,j[a+4>>2]);if(j[a>>2]){eh(j[a+16>>2],j[a>>2],Vn(a))}}function Yja(a,b,c){a=a|0;b=b|0;c=c|0;if(nb(b)>>>0>c>>>0){rm(b,c)}Mc(a,b)}function VW(a,b,c){a=a|0;b=b|0;c=c|0;a=bb[a|0](b,c)|0;ea(ab|0);return a|0}function Tj(a,b){var c=0;c=j[b+4>>2];j[a>>2]=j[b>>2];j[a+4>>2]=c;return a}function Rj(a){cqa(a,j[a+4>>2]);if(j[a>>2]){xe(j[a+16>>2],j[a>>2],_f(a))}}function QI(a){tka(a,j[a+4>>2]);if(j[a>>2]){Gf(j[a+16>>2],j[a>>2],sl(a))}}function PN(a){uza(a,j[a+4>>2]);if(j[a>>2]){$i(j[a+16>>2],j[a>>2],_f(a))}}function OM(a){swa(a,j[a+4>>2]);if(j[a>>2]){$i(j[a+16>>2],j[a>>2],_f(a))}}function NT(a,b){var c=0;c=Za-16|0;Za=c;Jt(c+8|0,b);Ht(a,c+8|0);Za=c+16|0}function Kc(a,b,c,d,e){h[a+3|0]=e;h[a+2|0]=d;h[a+1|0]=c;h[a|0]=b;return a}function JO(a,b){h[a+6|0]=255;j[a+16>>2]=b;i[a+4>>1]=0;j[a>>2]=0;return a}function IR(a){zJa(a,j[a+4>>2]);if(j[a>>2]){Gf(j[a+16>>2],j[a>>2],sl(a))}}function Fna(a){$e(a);if(j[a>>2]){Fma(a,j[a>>2]);xe(hb(a),j[a>>2],jd(a))}}function Ega(a,b){a=a|0;b=b|0;a=j[a+20>>2]+24|0;h[a|0]=k[a|0]&253|(b?2:0)}function EN(a){Jya(a,j[a+4>>2]);if(j[a>>2]){Gf(j[a+16>>2],j[a>>2],sl(a))}}function Cl(a,b,c){a=a|0;b=b|0;c=c|0;return bb[j[j[a>>2]+48>>2]](a,b,c)|0}function BS(a){pLa(a,j[a+4>>2]);if(j[a>>2]){pn(j[a+16>>2],j[a>>2],xn(a))}}function BP(a){ADa(a,j[a+4>>2]);if(j[a>>2]){Gf(j[a+16>>2],j[a>>2],sl(a))}}function At(a){$Ka(a,j[a+4>>2]);if(j[a>>2]){Yf(j[a+16>>2],j[a>>2],Nz(a))}}function $M(a){ixa(a,j[a+4>>2]);if(j[a>>2]){eh(j[a+16>>2],j[a>>2],Vn(a))}}function $H(a){Nha(a,j[a+4>>2]);if(j[a>>2]){xe(j[a+16>>2],j[a>>2],_f(a))}}function yR(a){sh(a);if(j[a>>2]){yIa(a,j[a>>2]);Gf(hb(a),j[a>>2],Be(a))}}function xh(a){AT(a,j[a+4>>2]);if(j[a>>2]){Et(j[a+16>>2],j[a>>2],_f(a))}}function xQ(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=c,e=pQ(a,b),j[d>>2]=e}function qA(a){TT(a,j[a+4>>2]);if(j[a>>2]){yn(j[a+16>>2],j[a>>2],xn(a))}}function ll(a){Gl(a);if(j[a>>2]){XAa(a,j[a>>2]);Cs(hb(a),j[a>>2],Zg(a))}}function kw(a){$e(a);if(j[a>>2]){Zfa(a,j[a>>2]);xe(hb(a),j[a>>2],jd(a))}}function kW(a){var b=0;b=Za-16|0;Za=b;j[b+8>>2]=53;sW(a,b+8|0);Za=b+16|0}function kDa(a){a=a|0;Z2(a,VH(j[j[a>>2]-12>>2]+a|0,10));Eq(a);return a|0}function jz(a){sh(a);if(j[a>>2]){KHa(a,j[a>>2]);Gf(hb(a),j[a>>2],Be(a))}}function cGa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=c,e=pQ(a,b),h[d|0]=e}function Zp(a){kV(a,j[a+4>>2]);if(j[a>>2]){Yg(j[a+16>>2],j[a>>2],bu(a))}}function ZD(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;sg(a,-1,-1)}function Xl(a){UW(a,j[a+4>>2]);if(j[a>>2]){Yf(j[a+16>>2],j[a>>2],Nz(a))}}function XB(a){zY(a,j[a+4>>2]);if(j[a>>2]){_B(j[a+16>>2],j[a>>2],_f(a))}}function Sp(a){sU(a,j[a+4>>2]);if(j[a>>2]){xe(j[a+16>>2],j[a>>2],_f(a))}}function OS(a,b){return(k[a|0]|k[a+1|0]<<8)>>>0<(k[b|0]|k[b+1|0]<<8)>>>0}function OD(a,b){b=!j[a+24>>2]|b;j[a+16>>2]=b;if(b&j[a+20>>2]){S2();z()}}function Ny(a,b){var c=0;c=Za-16|0;Za=c;Qb(a,j[b>>2],sb(b)<<2);Za=c+16|0}function Nw(a){$e(a);if(j[a>>2]){Kla(a,j[a>>2]);xe(hb(a),j[a>>2],jd(a))}}function MJ(a){$e(a);if(j[a>>2]){xma(a,j[a>>2]);xe(hb(a),j[a>>2],jd(a))}}function Lp(a){VT(a,j[a+4>>2]);if(j[a>>2]){Yf(j[a+16>>2],j[a>>2],Nz(a))}}function LN(a){HN(a);if(j[a>>2]){Iya(a,j[a>>2]);cy(hb(a),j[a>>2],Xm(a))}}function LF(a){k8(a,j[a+4>>2]);if(j[a>>2]){Ai(j[a+16>>2],j[a>>2],ru(a))}}function Jy(a){sh(a);if(j[a>>2]){KDa(a,j[a>>2]);Gf(hb(a),j[a>>2],Be(a))}}function JF(a){e8(a,j[a+4>>2]);if(j[a>>2]){yo(j[a+16>>2],j[a>>2],sl(a))}}function Dq(a){N2(a,j[a+4>>2]);if(j[a>>2]){eh(j[a+16>>2],j[a>>2],Vn(a))}}function CS(a,b){var c=0;c=Za-16|0;Za=c;Qb(a,j[b>>2],Yb(b)<<1);Za=c+16|0}function BB(a){OW(a,j[a+4>>2]);if(j[a>>2]){Ai(j[a+16>>2],j[a>>2],ru(a))}}function Az(a){sh(a);if(j[a>>2]){HJa(a,j[a>>2]);Gf(hb(a),j[a>>2],Be(a))}}function zv(a){return((pg(a)+(pg(a)<<8)|0)+(pg(a)<<16)|0)+(pg(a)<<24)|0}function yA(a){rk(a);if(j[a>>2]){ZT(a,j[a>>2]);yn(hb(a),j[a>>2],Df(a))}}function wC(a){i[a+12>>1]=0;j[a+8>>2]=-1;j[a>>2]=0;j[a+4>>2]=0;return a}function sP(a){rk(a);if(j[a>>2]){eP(a,j[a>>2]);pn(hb(a),j[a>>2],Df(a))}}function qO(a){$p(a);if(j[a>>2]){jO(a,j[a>>2]);_t(hb(a),j[a>>2],xi(a))}}function pF(a){a=a|0;return+(+m[j[a+32>>2]+480240>>2]*152587890625e-16)}function oP(a){$e(a);if(j[a>>2]){jP(a,j[a>>2]);$i(hb(a),j[a>>2],jd(a))}}function ng(a,b,c){return(c|0)>=0?(l[j[a+8>>2]+((c&255)<<1)>>1]&b)!=0:0}function kk(a){rk(a);if(j[a>>2]){DS(a,j[a>>2]);pn(hb(a),j[a>>2],Df(a))}}function ji(a){$e(a);if(j[a>>2]){bQ(a,j[a>>2]);$i(hb(a),j[a>>2],jd(a))}}function eN(a){Li(a);if(j[a>>2]){aN(a,j[a>>2]);eh(hb(a),j[a>>2],Vf(a))}}function dx(a,b){a=a|0;b=b|0;j[a+1074368>>2]=b;iJ(a+1074328|0,b);Cna(a)}function _v(a,b){a=a|0;b=b|0;bb[b|0](j[j[a>>2]-12>>2]+a|0)|0;return a|0}function _b(a,b){var c=0,d=0;j[a>>2]=b;c=a,d=ne(b),j[c+4>>2]=d;return a}function TL(a,b){j[a+4>>2]=0;j[a+8>>2]=0;j[a>>2]=b?b:49716;j[a+12>>2]=0}function Rk(a){Li(a);if(j[a>>2]){y2(a,j[a>>2]);eh(hb(a),j[a>>2],Vf(a))}}function OO(a){j[a+8>>2]=0;j[a>>2]=0;j[a+4>>2]=40;i[a+12>>1]=0;return a}function Mu(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;j[e>>2]=c;return 3}function Moa(a,b,c){a=a|0;b=b|0;c=c|0;Koa(a,b);j[a+112>>2]=0;return a|0}function KL(a){if(a>>>0<=8){return k[a+20096|0]}return k[a+20087|0]|256}function HZ(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return GZ(c,d,e)|0}function FA(a){$e(a);if(j[a>>2]){tU(a,j[a>>2]);xe(hb(a),j[a>>2],jd(a))}}function BZ(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return AZ(c,d,e)|0}function Ac(a){if((a|0)>=-32768){return(a|0)>32767?32767:a}return-32768}function $m(a){NP(a);if(j[a>>2]){KP(a,j[a>>2]);JP(hb(a),j[a>>2],nl(a))}}function zGa(a){vp(a);j[a>>2]=76520;ri(a+4|0);h[a+20|0]=0;j[a+16>>2]=0}function w0(a,b,c,d,e){b=Fh(b,c,d,e,4);if(!(k[d|0]&4)){j[a>>2]=b-1900}}function vu(a,b,c){if(!(j[a+28>>2]==1|j[a+4>>2]!=(b|0))){j[a+28>>2]=c}}function tx(a,b,c){a:{if(a<b){break a}b=c;if(b<a){break a}b=a}return b}function rj(a,b){a=a|0;b=b|0;h[a|0]=2;h[a+1|0]=3;h[a+2|0]=0;h[a+3|0]=4}function kc(a,b){if(sb(a)>>>0<=b>>>0){pE();z()}return j[a>>2]+(b<<2)|0}function iDa(a){var b=0;b=Za-16|0;Za=b;XCa(a,b+8|0);Za=b+16|0;return a}function fja(a){var b=0;b=Za-16|0;Za=b;cja(a,b+8|0);Za=b+16|0;return a}function fd(a){var b=0;b=Za-16|0;Za=b;a=OX(Bu(b,a));Za=b+16|0;return a}function d0(a,b,c,d,e){b=Eh(b,c,d,e,4);if(!(k[d|0]&4)){j[a>>2]=b-1900}}function apa(a){var b=0;b=Za-16|0;Za=b;Poa(a,b+8|0);Za=b+16|0;return a}function Woa(a){var b=0;b=Za-16|0;Za=b;voa(a,b+8|0);Za=b+16|0;return a}function TFa(a){var b=0;b=Za-16|0;Za=b;FFa(a,b+8|0);Za=b+16|0;return a}function S8(a,b){a=a|0;b=b|0;var c=0;c=Za-16|0;Za=c;kka(a,b);Za=c+16|0}function RR(a,b){Aj(a,lb(j[b>>2]),pb(b));a=j[a+4>>2];ab=a>>31;return a}function RJ(a,b){var c=0;c=j[a>>2];j[a>>2]=b;if(c){if(c){bf(c);Fb(c)}}}function Qta(a){var b=0;b=Za-16|0;Za=b;Nta(a,b+8|0);Za=b+16|0;return a}function Q8(a,b){a=a|0;b=b|0;var c=0;c=Za-16|0;Za=c;eia(a,b);Za=c+16|0}function O8(a,b){a=a|0;b=b|0;var c=0;c=Za-16|0;Za=c;Oha(a,b);Za=c+16|0}function Jm(a,b,c){a:{if(a<b){break a}b=c;if(b<a){break a}b=a}return b}function Iw(a,b){o[a>>3]=o[b>>3]+o[a>>3];o[a+8>>3]=o[b+8>>3]+o[a+8>>3]}function HA(a){j[a>>2]=0;j[a+4>>2]=0;j[a+8>>2]=0;j[a+12>>2]=0;return a}function A3(a){a=a|0;j[a+16>>2]=j[a+16>>2]|1;if(h[a+20|0]&1){pa();z()}}function $C(a,b,c){var d=0;d=Za-16|0;Za=d;ZX(a,b,c);Za=d+16|0;return a}function yna(a,b){var c=0;c=Za-16|0;Za=c;Bma(a,ah(c+8|0,b));Za=c+16|0}function sX(a){a=a|0;if(!a){return 0}return(yu(a,71944,72088)|0)!=0|0}function sG(a,b){var c=0;c=j[a>>2];j[a>>2]=b;if(c){if(c){Fb(Hna(c))}}}function rW(a,b){a=a|0;b=b|0;var c=0;c=Za-16|0;Za=c;vB(a,b);Za=c+16|0}function oQ(a,b){var c=0;c=j[a>>2];j[a>>2]=b;if(c){if(c){Fb(oFa(c))}}}function nu(a){a:{if(m[a+4>>2]<m[hb(a)>>2]){$V(a);break a}_V(a)}zg(a)}function kra(a,b){if(j[a+4>>2]!=j[hb(a)>>2]){era(a,b);return}dra(a,b)}function ir(a,b){a=a|0;b=b|0;var c=0;c=Za-16|0;Za=c;pO(a,b);Za=c+16|0}function ci(a,b){return(j[a+4>>2]-j[b+4>>2]|0)+(j[a>>2]-j[b>>2]<<3)|0}function aL(a){if(a>>>0>357913941){oc(20272);z()}return ac(p(a,12),4)}function _r(a){var b=0;b=Za-16|0;Za=b;Kqa(a,b+8|0);Za=b+16|0;return a}function SJ(a,b){var c=0;c=j[a>>2];j[a>>2]=b;if(c){if(c){Fb($fa(c))}}}function SF(a){var b=0;b=j[a>>2];j[a>>2]=0;if(b){QF(b,j[Rb(a)+4>>2])}}function Mja(a,b,c){b=b-a|0;if(b){Ci(c,a,b)}return p((b|0)/6|0,6)+c|0}function LFa(a,b){if(!KEa(a,b)){a=Za-16|0;Za=a;Ab(b,0,128);Za=a+16|0}}function JJa(a,b){if(!IJa(a,b)){a=Za-16|0;Za=a;Ab(b,0,136);Za=a+16|0}}function JB(a){return(j[a>>2]&-256)==1126902528&j[a+4>>2]==1129074247}function CDa(a,b){j[a>>2]=j[b>>2];i[a+4>>1]=l[b+4>>1];Fl(a+8|0,b+8|0)}function tCa(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;sCa(b,j[d>>2])}function s_(a){a=a|0;var b=0;b=j[115468]+1|0;j[115468]=b;j[a+4>>2]=b}function sI(a){if(a>>>0>82595524){oc(32335);z()}return ac(p(a,52),4)}function kla(a,b){var c=0;c=Za-16|0;Za=c;mt(c,1,b);qc(a,c);Za=c+16|0}function jB(a,b){var c=0;c=j[a>>2];j[a>>2]=b;if(c){if(c){Fb(QA(c))}}}function hy(a,b){Ib(a,b);Ib(a+4|0,b+4|0);Ib(hb(a),hb(b));hb(a);hb(b)}function doa(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;aoa(b,j[d>>2])}function ZW(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return bb[a|0](b,c,d)|0}function Xna(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;Wna(b,j[d>>2])}function XP(a){if(a>>>0>715827882){oc(14480);z()}return ac(p(a,6),1)}function TA(a,b){if(b>>>0>134217727){oc(11120);z()}return ac(b<<5,4)}function MF(a,b,c){a=a|0;b=b|0;c=c|0;j[b>>2]=j[c>>2];Mc(b+4|0,c+4|0)}function Kx(a,b){qn(a);Qc(a+12|0);i[a+28>>1]=0;j[a+24>>2]=b;return a}function Kn(a,b,c,d,e){b=za(a|0,b|0,c|0,d|0,e|0)|0;ab=C()|0;return b}function Kba(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;Jba(b,j[d>>2])}function Hk(a,b){return b?a<<8&16711680|a<<24|(a>>>8&65280|a>>>24):a}function C4(a,b){a=a|0;b=b|0;if(!j[114630]){j[114631]=b;j[114630]=a}}function Bma(a,b){var c=0;c=Za-16|0;Za=c;bB(a,ah(c+8|0,b));Za=c+16|0}function uL(a){if(j[a>>2]){tra(a,j[a>>2]);hb(a);rra(j[a>>2],Ah(a))}}function qV(a,b,c){a=a|0;b=b|0;c=c|0;vp(a);j[a>>2]=77272;return a|0}function oFa(a){kQ(a+52|0);gb(a+40|0);xf(a+16|0);xf(a+4|0);return a}function mQ(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;sFa(b,j[d>>2])}function kd(a,b,c){if(a>>>0>=b>>>0){return a>>>0>c>>>0?c:a}return b}function hT(a){if(a>>>0>2147483647){oc(11932);z()}return ac(a<<1,2)}function fu(a,b){var c=0;c=Za-16|0;Za=c;QV(a,ah(c+8|0,b));Za=c+16|0}function fI(a){if(a>>>0>1073741823){oc(32462);z()}return ac(a<<2,4)}function eBa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return dBa(a,b,c,d)|0}function dT(a,b){if(!GLa(a,b)){a=Za-16|0;Za=a;Ab(b,0,37);Za=a+16|0}}function dA(a){if(a>>>0>1073741823){oc(11804);z()}return ac(a<<2,2)}function WBa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return MBa(a,b,c,d)|0}function Tn(a,b,c){a=a|0;b=b|0;c=c|0;ye(a,b);ye(a+4|0,c);return a|0}function Sm(a){var b=0;b=j[a+20>>2];if(b){Fb(b+ -64|0)}j[a+20>>2]=0}function RN(a){if(a>>>0>1073741823){oc(16711);z()}return ac(a<<2,1)}function QJ(a,b,c,d){j[a+12>>2]=0;j[a+8>>2]=d;j[a+4>>2]=c;j[a>>2]=b}function NDa(a,b){if(m[a+4>>2]<m[hb(a)>>2]){EP(a,b);return}LDa(a,b)}function I5(a){a=a|0;var b=0;b=j[a+100>>2];j[a+100>>2]=0;return b|0}function Hy(a){a=a|0;j[a>>2]=76464;xg(a+28|0);xg(a+12|0);return a|0}function EB(a,b,c,d,e,f,g){return ya(a|0,b|0,c|0,d|0,e|0,f|0,g|0)|0}function Ck(a){if(a>>>0>1073741823){oc(70536);z()}return ac(a<<2,4)}function Bx(a){if(j[a>>2]){zra(a,j[a>>2]);hb(a);yra(j[a>>2],xi(a))}}function zS(a){if(a>>>0>268435455){oc(12065);z()}return ac(a<<4,4)}function sK(a,b){j[a+876>>2]=j[a+876>>2]+b;h[a+872|0]=k[a+872|0]|8}function nm(a,b,c){return j[j[a>>2]+(b<<2)>>2]+(j[a+12>>2]+c<<1)|0}function nR(a){if(j[a>>2]){BIa(a,j[a>>2]);ft(hb(a),j[a>>2],ki(a))}}function jD(a,b,c){a=a|0;b=b|0;c=c|0;return Un(0,a,b,c?c:461676)|0}function g_(a,b,c){a=a|0;b=b|0;c=c|0;return(b>>>0<128?b:c)<<24>>24}function dX(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return pca(a,b,c,d)|0}function dK(a){if(a>>>0>134217727){oc(20384);z()}return ac(a<<5,8)}function cC(a,b,c){a=a|0;b=b|0;c=c|0;os(a);h[a+128|0]=0;return a|0}function ZL(a){if(a>>>0>134217727){oc(18648);z()}return ac(a<<5,4)}function VM(a,b){ay(a,b);h[a+16|0]=k[b+16|0];j[a+12>>2]=j[b+12>>2]}function Um(a,b,c){return j[j[a>>2]+(b<<2)>>2]+(j[a+12>>2]+c<<2)|0}function UO(a){if(j[a>>2]){HBa(a,j[a>>2]);$i(hb(a),j[a>>2],jd(a))}}function TO(a){if(j[a>>2]){BBa(a,j[a>>2]);$o(hb(a),j[a>>2],_o(a))}}function Se(a,b,c){a=a|0;b=b|0;c=c|0;return wc(a,p(Kj(a),b)+c|0)|0}function NF(a){if(a>>>0>268435455){oc(39508);z()}return ac(a<<4,4)}function IIa(a){a=a|0;return j[a+16>>2]+(j[a+8>>2]-j[a+20>>2]|0)|0}function Gj(a){var b=0;b=j[a>>2];j[a>>2]=0;if(b){if(b){Fb(Ye(b))}}}function Gb(a,b,c){if((a|0)>=(b|0)){return(a|0)>(c|0)?c:a}return b}function $K(a){if(a>>>0>1073741823){oc(1447);z()}return ac(a<<2,4)}function z0(a,b){if(m[a+4>>2]<m[hb(a)>>2]){k0(a,b);return}a0(a,b)}function xG(a){if(j[a>>2]){p8(a,j[a>>2]);Ai(hb(a),j[a>>2],Ah(a))}}function xA(a){if(j[a>>2]){_T(a,j[a>>2]);Yf(hb(a),j[a>>2],Af(a))}}function sN(a){a=a+34|0;a=HMa(k[a|0]|k[a+1|0]<<8,0,80,0);return a}function qEa(a,b){a=a|0;b=b|0;a=xDa(a,b);if(!a){wDa(b)}return a|0}function mF(a){a=a|0;return+(+j[j[a+32>>2]+1074444>>2]*.00390625)}function iB(a){if(j[a>>2]){hV(a,j[a>>2]);_t(hb(a),j[a>>2],xi(a))}}function gLa(a,b){a=a|0;b=b|0;a=AKa(a,b);if(!a){zKa(b)}return a|0}function esa(a,b){a=a|0;b=b|0;a=Wra(a,b);if(!a){Ura(b)}return a|0}function bh(a,b){var c=0,d=0;c=a,d=Xu(j[b>>2]),j[c>>2]=d;return a}function _Ia(a,b){a=a|0;b=b|0;a=mIa(a,b);if(!a){lIa(b)}return a|0}function Yi(a){a=j[a+656>>2];if(!a){return 0}return j[a+44>>2]!=0}function WQ(a){ab=0;a=a+47|0;a=(k[a|0]|k[a+1|0]<<8)-98|0;return a}function WIa(a,b){a=a|0;b=b|0;a=kIa(a,b);if(!a){jIa(b)}return a|0}function VN(a){if(j[a>>2]){QN(a,j[a>>2]);$i(hb(a),j[a>>2],jd(a))}}function VHa(a,b){a=a|0;b=b|0;a=AHa(a,b);if(!a){zHa(b)}return a|0}function TU(a){a=a|0;a=j[a+4>>2];return bb[j[j[a>>2]+12>>2]](a)|0}function SU(a){a=a|0;a=j[a+4>>2];return bb[j[j[a>>2]+16>>2]](a)|0}function RS(a){if(j[a>>2]){yS(a,j[a>>2]);Ai(hb(a),j[a>>2],Ah(a))}}function Hv(a){a=k[a+1|0];return(a&6)==6?384:1152>>>((a&14)==2)|0}function FAa(a,b){a=a|0;b=b|0;a=kAa(a,b);if(!a){jAa(b)}return a|0}function DA(a){if(j[a>>2]){uU(a,j[a>>2]);eh(hb(a),j[a>>2],Vf(a))}}function AJ(a,b){var c=0,d=0;c=a,d=H5(b),j[c>>2]=d;Bo(a);return a}function qaa(a,b,c){a=a|0;b=b|0;c=c|0;return X6(pl(a),pl(b),c)|0}function qDa(a,b){a=a|0;b=b|0;a=AP(a,b);if(!a){GCa(b)}return a|0}function mLa(a,b){var c=0;c=Za-16|0;Za=c;Fu(a,b,c+8|0);Za=c+16|0}function lb(a){a=a|0;var b=0;b=Za-16|0;Za=b;Za=b+16|0;return a|0}function jH(a){a=a|0;j[a>>2]=80600;xf(a+4256|0);Ke(a);return a|0}function iw(a){a=a|0;j[a>>2]=80368;xf(a+4260|0);Ke(a);return a|0}function hI(a,b){var c=0;c=Za-16|0;Za=c;wia(a,Kb(c,b));Za=c+16|0}function cH(a){a=a|0;j[a>>2]=81008;xf(a+4208|0);Ke(a);return a|0}function Zda(a,b){a=a|0;b=b|0;if(!b){return 3}j[b>>2]=a;return 0}function Yx(a,b){var c=0;c=j[a>>2];j[a>>2]=b;if(c){if(c){Fb(c)}}}function UU(a){a=a|0;a=j[a+4>>2];return bb[j[j[a>>2]+8>>2]](a)|0}function TH(a){a=a|0;j[a>>2]=79480;xf(a+4208|0);Ke(a);return a|0}function Kr(a){gb(a+48|0);gb(a+36|0);gb(a+24|0);gb(a+12|0);gb(a)}function Im(a){var b=0;b=Za-16|0;Za=b;Za=b+16|0;return a<<24>>24}function FY(a){a=a|0;var b=0,c=0;b=a,c=Wd(),j[b>>2]=c;return a|0}function EH(a){a=a|0;j[a>>2]=79684;xg(a+4208|0);Ke(a);return a|0}function Bs(a,b){a=a|0;b=b|0;a=mAa(a,b);if(!a){lAa(b)}return a|0}function BL(a,b){b=1/(564505.8718779281/b+1);yL(a,b,0,0,b+ -1,0)}function $ra(a,b){a=a|0;b=b|0;FL(a,j[b>>2],j[b+4>>2]);return a|0}function xf(a){$e(a);if(j[a>>2]){jQ(a);xe(hb(a),j[a>>2],jd(a))}}function vs(a,b){a=a|0;b=b|0;a=zza(a,b);if(!a){UN(b)}return a|0}function tL(a){Li(a);if(j[a>>2]){kL(a);eh(hb(a),j[a>>2],Vf(a))}}function sr(a){$e(a);if(j[a>>2]){OH(a);xe(hb(a),j[a>>2],jd(a))}}function sk(a,b){a=a|0;b=b|0;return bb[j[j[a>>2]+28>>2]](a,b)|0}function rr(a){LH(a);if(j[a>>2]){RH(a);KH(hb(a),j[a>>2],Ij(a))}}function qo(a){a=a|0;return((a-65&255)>>>0<26?a+32|0:a)<<24>>24}function pS(a,b){a=a|0;b=b|0;a=uKa(a,b);if(!a){dS(b)}return a|0}function oH(a){a=a|0;return q(q(q(n[a+4228>>2]*q(198))+q(-99)))}function nr(a,b){a=a|0;b=b|0;Q2(a,b);j[a+72>>2]=0;j[a+76>>2]=-1}function kl(a){sh(a);if(j[a>>2]){FN(a);Gf(hb(a),j[a>>2],Be(a))}}function jj(a){a=a|0;a=j[a>>2];return bb[j[j[a>>2]+24>>2]](a)|0}function hs(a){Gl(a);if(j[a>>2]){bM(a);Yg(hb(a),j[a>>2],Zg(a))}}function fx(a){hR(a);if(j[a>>2]){xR(a);gR(hb(a),j[a>>2],rl(a))}}function fT(a){if(!_c(a,12035,25)){return k[a+34|0]<65}return 0}function ex(a){DJ(a);if(j[a>>2]){CJ(a);Xw(hb(a),j[a>>2],Pi(a))}}function en(a,b){a=a|0;b=b|0;a=VEa(a,b);if(!a){_P(b)}return a|0}function cj(a,b,c){a=a|0;b=b|0;c=c|0;return ez(pl(a),pl(b),c)|0}function bx(a){Gl(a);if(j[a>>2]){kB(a);Yg(hb(a),j[a>>2],Zg(a))}}function bX(a,b){a=a|0;b=b|0;a=bb[a|0](b)|0;ea(ab|0);return a|0}function bT(a,b){a=a|0;b=b|0;a=DLa(a,b);if(!a){LS(b)}return a|0}function _u(a,b){a=a|0;b=b|0;return(Jg(a)|0)!=0|(a|32)-97>>>0<6}function _O(a,b,c,d){He(a,b);i[a+18>>1]=d;i[a+16>>1]=c;return a}function Zk(a){sh(a);if(j[a>>2]){SI(a);Gf(hb(a),j[a>>2],Be(a))}}function Ym(a){$e(a);if(j[a>>2]){FP(a);Et(hb(a),j[a>>2],jd(a))}}function Xd(a,b,c,d){j[a+8>>2]=d;j[a+4>>2]=c;j[a>>2]=b;return a}function Tu(a,b){a=a|0;b=b|0;return bb[j[j[a>>2]+12>>2]](a,b)|0}function SM(a){$e(a);if(j[a>>2]){RM(a);$i(hb(a),j[a>>2],jd(a))}}function QR(a){rk(a);if(j[a>>2]){LR(a);pn(hb(a),j[a>>2],Df(a))}}function NK(a){sh(a);if(j[a>>2]){iK(a);yo(hb(a),j[a>>2],Be(a))}}function Mz(a,b){a=a|0;b=b|0;a=BKa(a,b);if(!a){iS(b)}return a|0}function Kz(a,b){a=a|0;b=b|0;a=DKa(a,b);if(!a){jS(b)}return a|0}function Gd(a){var b=0;b=Mn(ne(a)+1|0,1);if(b){W4(b,a)}return b}function Aq(a,b){a=a|0;b=b|0;return bb[j[j[a>>2]+44>>2]](a,b)|0}function $s(a,b){a=a|0;b=b|0;a=cIa(a,b);if(!a){dR(b)}return a|0}function zh(a){a=a|0;uV(a);j[a+8>>2]=0;j[a+12>>2]=0;return a|0}function vG(a,b,c,d){i[a+4>>1]=c;h[a+6|0]=b;j[a>>2]=d;return a}function sM(a){var b=0;b=j[a>>2];j[a>>2]=0;if(b){Bta(Rb(a),b)}}function qc(a,b){a=a|0;b=b|0;ula(a,k[b+8|0],j[b>>2],j[b+4>>2])}function ny(a,b){var c=0;c=Za-16|0;Za=c;Qb(a,b,1024);Za=c+16|0}function mB(a,b){a=a|0;b=b|0;a=BV(a,b);if(!a){aB(b)}return a|0}function lr(a){a=a|0;j[a>>2]=76912;gb(a+32|0);Nk(a);return a|0}function lQ(a){var b=0;b=j[a>>2];j[a>>2]=0;if(b){qFa(Rb(a),b)}}function lB(a,b){a=a|0;b=b|0;a=AV(a,b);if(!a){_A(b)}return a|0}function ku(a,b){a=a|0;b=b|0;a=jV(a,b);if(!a){iV(b)}return a|0}function kf(a,b){a=a|0;b=b|0;a=Zt(a,b);if(!a){OA(b)}return a|0}function jf(a,b){return bb[j[j[a>>2]+36>>2]](a,j[a+12>>2],b)|0}function eI(a){var b=0;b=j[a>>2];j[a>>2]=0;if(b){lia(Rb(a),b)}}function dL(a){var b=0;b=j[a>>2];j[a>>2]=0;if(b){Eqa(Rb(a),b)}}function cP(a){var b=0;b=j[a>>2];j[a>>2]=0;if(b){rCa(Rb(a),b)}}function cK(a){var b=0;b=j[a>>2];j[a>>2]=0;if(b){$na(Rb(a),b)}}function aK(a){var b=0;b=j[a>>2];j[a>>2]=0;if(b){Vna(Rb(a),b)}}function _I(a){var b=0;b=j[a>>2];j[a>>2]=0;if(b){Cla(Rb(a),b)}}function YR(a,b){var c=0;c=Za-16|0;Za=c;Qb(a,b,1954);Za=c+16|0}function Waa(a,b,c){a=a|0;b=b|0;c=c|0;OJ(a,0,Ty(j[b+24>>2]),c)}function Vt(a,b){a=a|0;b=b|0;a=vU(a,b);if(!a){CA(b)}return a|0}function Us(a,b){a=a|0;b=b|0;a=Xp(a,b);if(!a){cQ(b)}return a|0}function Tp(a){a=a|0;a=j[a>>2];return bb[j[j[a>>2]+8>>2]](a)|0}function PQ(a){a=a|0;a=k[a|0];return Ld(a)^1|(a-49&255)>>>0<36}function My(a,b){var c=0;c=Za-16|0;Za=c;Qb(a,b,4896);Za=c+16|0}function Mp(a,b){var c=0;c=b+1|0;j[a>>2]=j[a>>2]>(c|0)?c:b+2|0}function M$(a,b,c){a=a|0;b=b|0;c=c|0;Cc(a,JD(j[b>>2]),j[b>>2])}function CHa(a,b){if(!Ff(a,b)){a=Za-16|0;Za=a;Oe(b);Za=a+16|0}}function Ana(a,b){a=a|0;b=b|0;Cu(a,b);j[a>>2]=71532;return a|0}function yO(a,b){var c=0;c=Za-16|0;Za=c;Qb(a,b,130);Za=c+16|0}function x7(a,b){a=a|0;b=b|0;Cu(a,b);j[a>>2]=71588;return a|0}function wO(a,b){var c=0;c=Za-16|0;Za=c;Qb(a,b,600);Za=c+16|0}function w8(a){a=a|0;var b=0;b=Za-16|0;Za=b;QF(a,1);Za=b+16|0}function vd(a,b){j[a>>2]=j[b>>2];j[a+4>>2]=j[b+4>>2];return a}function uN(a,b){var c=0;c=Za-16|0;Za=c;Qb(a,b,146);Za=c+16|0}function rt(a,b){var c=0;c=Za-16|0;Za=c;Qb(a,b,192);Za=c+16|0}function r8(a){a=a|0;var b=0;b=Za-16|0;Za=b;DN(a,1);Za=b+16|0}function qN(a,b){var c=0;c=Za-16|0;Za=c;Qb(a,b,608);Za=c+16|0}function pV(a){a=a|0;var b=0;b=Za-16|0;Za=b;xB(a,1);Za=b+16|0}function nO(a,b){var c=0;c=Za-16|0;Za=c;Qb(a,b,126);Za=c+16|0}function nL(a,b){return j[a>>2]==j[b>>2]&j[a+4>>2]==j[b+4>>2]}function mq(a,b){b=j[b>>2];j[a>>2]=b;j[a+4>>2]=b>>31;return a}function mX(a,b){a=a|0;b=b|0;Cu(a,b);j[a>>2]=71640;return a|0}function kT(a,b){var c=0;c=Za-16|0;Za=c;Qb(a,b,497);Za=c+16|0}function eQ(a,b){var c=0;c=Za-16|0;Za=c;Qb(a,b,674);Za=c+16|0}function cDa(a,b,c){a=a|0;b=b|0;c=c|0;Mc(a,SB(c,zb(b),nb(b)))}function bN(a,b){var c=0;c=Za-16|0;Za=c;Qb(a,b,204);Za=c+16|0}function az(a,b){a=(a+b|0)-1|0;return a-((a>>>0)%(b>>>0)|0)|0}function YU(a){a=a|0;var b=0;b=Za-16|0;Za=b;RA(a,1);Za=b+16|0}function Wsa(a,b,c){a=a|0;b=b|0;c=c|0;return Tg(a,b,c,1180)|0}function Vsa(a,b,c){a=a|0;b=b|0;c=c|0;return Tg(a,b,c,1181)|0}function Tja(a,b,c){a=a|0;b=b|0;c=c|0;return Tg(a,b,c,1573)|0}function Rl(a,b){if(nb(a)>>>0<=b>>>0){Sl();z()}return Ub(a,b)}function RP(a,b){var c=0;c=Za-16|0;Za=c;Qb(a,b,128);Za=c+16|0}function Qsa(a,b,c){a=a|0;b=b|0;c=c|0;return Tg(a,b,c,1186)|0}function PM(a,b){var c=0;c=Za-16|0;Za=c;Qb(a,b,263);Za=c+16|0}function Oo(a,b){a=a|0;b=b|0;if(de(a)>>>0>b>>>0){h[a+16|0]=b}}function NQ(a,b){var c=0;c=Za-16|0;Za=c;Qb(a,b,157);Za=c+16|0}function KV(a){a=a|0;var b=0;b=Za-16|0;Za=b;dB(a,1);Za=b+16|0}function HQ(a,b){var c=0;c=Za-16|0;Za=c;Qb(a,b,576);Za=c+16|0}function Gia(a,b,c){a=a|0;b=b|0;c=c|0;return Tg(a,b,c,1609)|0}function Fia(a,b,c){a=a|0;b=b|0;c=c|0;return Tg(a,b,c,1610)|0}function Ez(a,b){var c=0;c=Za-16|0;Za=c;Qb(a,b,512);Za=c+16|0}function DB(a,b,c){b=va(2073,a|0,b|0,c|0)|0;ab=C()|0;return b}function CR(a,b){var c=0;c=Za-16|0;Za=c;Qb(a,b,610);Za=c+16|0}function wna(a,b,c){a=a|0;b=b|0;c=c|0;Ama(a,(b-a|0)/160|0,c)}function uz(a,b){var c=0;c=Za-16|0;Za=c;Qb(a,b,64);Za=c+16|0}function rF(a){a=a|0;return+(65536/+m[j[a+32>>2]+480244>>2])}function pw(a){a=a|0;j[a+32>>2]=0;j[a+28>>2]=j[a+28>>2]&-7|2}function oA(a,b){Cka(k[a+8|0],j[a>>2],j[a+4>>2],zb(b),nb(b))}function nma(a,b){a=a|0;b=b|0;ema(nd(b),_e(b),nd(b));Mc(a,b)}function nV(a,b){Mc(a,b);Fl(a+12|0,b+12|0);lV(a+28|0,b+28|0)}function mO(a,b){var c=0;c=Za-16|0;Za=c;Qb(a,b,32);Za=c+16|0}function kz(a,b){var c=0;c=Za-16|0;Za=c;Qb(a,b,12);Za=c+16|0}function kP(a,b){var c=0;c=Za-16|0;Za=c;Qb(a,b,52);Za=c+16|0}function hS(a,b){var c=0;c=Za-16|0;Za=c;Qb(a,b,11);Za=c+16|0}function bt(a,b){var c=0;c=Za-16|0;Za=c;Qb(a,b,66);Za=c+16|0}function _R(a){var b=0;b=Za-16|0;Za=b;Ab(a,0,1954);Za=b+16|0}function Zs(a,b){var c=0;c=Za-16|0;Za=c;Qb(a,b,22);Za=c+16|0}function ZP(a,b){var c=0;c=Za-16|0;Za=c;Qb(a,b,80);Za=c+16|0}function ZA(a,b){var c=0;c=Za-16|0;Za=c;Qb(a,b,14);Za=c+16|0}function YFa(a,b,c){a=a|0;b=b|0;c=c|0;return Tg(a,b,c,709)|0}function XIa(a,b,c){a=a|0;b=b|0;c=c|0;return fS(a,b,c)|0}



function VJ(a){a=a|0;var b=0;b=Za-16|0;Za=b;Jna(a);Za=b+16|0}function TQ(a,b){var c=0;c=Za-16|0;Za=c;Qb(a,b,98);Za=c+16|0}function TN(a,b){var c=0;c=Za-16|0;Za=c;Qb(a,b,96);Za=c+16|0}function Rp(a,b){var c=0;c=Za-16|0;Za=c;Qb(a,b,36);Za=c+16|0}function RQ(a,b){var c=0;c=Za-16|0;Za=c;Qb(a,b,48);Za=c+16|0}function Oga(a){a=a|0;a=Mi(a);if(a){bb[j[j[a>>2]+92>>2]](a)}}function OI(a,b){var c=0;c=Za-16|0;Za=c;Qb(a,b,24);Za=c+16|0}function MS(a,b){var c=0;c=Za-16|0;Za=c;Qb(a,b,38);Za=c+16|0}function KS(a,b){var c=0;c=Za-16|0;Za=c;Qb(a,b,41);Za=c+16|0}function JS(a,b){var c=0;c=Za-16|0;Za=c;Qb(a,b,16);Za=c+16|0}function Iy(a,b){var c=0;c=Za-16|0;Za=c;Qb(a,b,33);Za=c+16|0}function Gn(a,b,c){if(!b){return 0}return Uq(a,gg(h[c|0]),b)}function DL(a,b){var c=0;c=Za-16|0;Za=c;Qb(a,b,27);Za=c+16|0}function Cy(a,b){var c=0;c=Za-16|0;Za=c;Qb(a,b,40);Za=c+16|0}function AO(a,b){var c=0;c=Za-16|0;Za=c;Qb(a,b,30);Za=c+16|0}function $A(a,b){var c=0;c=Za-16|0;Za=c;Qb(a,b,10);Za=c+16|0}function zO(a){var b=0;b=Za-16|0;Za=b;Ab(a,0,130);Za=b+16|0}function xO(a){var b=0;b=Za-16|0;Za=b;Ab(a,0,600);Za=b+16|0}function vN(a){var b=0;b=Za-16|0;Za=b;Ab(a,0,146);Za=b+16|0}function rN(a){var b=0;b=Za-16|0;Za=b;Ab(a,0,608);Za=b+16|0}function qk(a,b){var c=0;c=Za-16|0;Za=c;Qb(a,b,2);Za=c+16|0}function oO(a){var b=0;b=Za-16|0;Za=b;Ab(a,0,126);Za=b+16|0}function lT(a){var b=0;b=Za-16|0;Za=b;Ab(a,0,497);Za=b+16|0}function iz(a,b){var c=0;c=Za-16|0;Za=c;Qb(a,b,6);Za=c+16|0}function eu(a){var b=0;b=a;a=j[a>>2]-1|0;j[b>>2]=a;return a}function ed(a){var b=0;b=Za-16|0;Za=b;MX(Bu(b,a));Za=b+16|0}function eX(a,b){a=a|0;b=b|0;a=vca(a,b);ea(ab|0);return a|0}function dQ(a){var b=0;b=Za-16|0;Za=b;Ab(a,0,192);Za=b+16|0}function cN(a){var b=0;b=Za-16|0;Za=b;Ab(a,0,204);Za=b+16|0}function asa(a,b){a=a|0;b=b|0;Yra(a,Lb(b),Mb(b));return a|0}function _p(a){var b=0;b=Za-16|0;Za=b;j[b+8>>2]=a;Za=b+16|0}function _Z(a,b,c){a=a|0;b=b|0;c=c|0;return((b|0)>-1?b:c)|0}function Yt(a,b){var c=0;c=Za-16|0;Za=c;Qb(a,b,8);Za=c+16|0}function Vaa(a){a=a|0;wG(a,2,100);Oo(j[a+24>>2]+484360|0,0)}function Up(a,b){var c=0;c=Za-16|0;Za=c;Qb(a,b,1);Za=c+16|0}function Sz(a,b){var c=0;c=Za-16|0;Za=c;Qb(a,b,3);Za=c+16|0}function OQ(a){var b=0;b=Za-16|0;Za=b;Ab(a,0,157);Za=b+16|0}function IQ(a){var b=0;b=Za-16|0;Za=b;Ab(a,0,576);Za=b+16|0}function Hz(a,b){var c=0;c=Za-16|0;Za=c;Qb(a,b,5);Za=c+16|0}function Fz(a,b){var c=0;c=Za-16|0;Za=c;Qb(a,b,7);Za=c+16|0}function EI(a,b){if((a|0)!=(b|0)){Pja(a,j[b>>2],j[b+4>>2])}}function DR(a){var b=0;b=Za-16|0;Za=b;Ab(a,0,610);Za=b+16|0}function $g(a,b){var c=0;c=Za-16|0;Za=c;Qb(a,b,4);Za=c+16|0}function z9(a){a=a|0;return m[j[a+24>>2]+1074420>>2]/1e4|0}function z4(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;ab=0;return 0}function um(a,b,c,d){j[a+16>>2]=d;j[a+12>>2]=c;j[a+8>>2]=b}function uf(a,b){a=IMa(j[a>>2],j[a+4>>2],b,b>>31);return a}function pp(a){if((a|0)>=1){return(a|0)<120?a:120}return 1}function nb(a){if(qe(a)){return j[a+4>>2]}return k[a+11|0]}function mR(a){var b=0;b=Za-16|0;Za=b;Ab(a,0,66);Za=b+16|0}function lP(a){var b=0;b=Za-16|0;Za=b;Ab(a,0,52);Za=b+16|0}function aX(a,b,c){a=a|0;b=b|0;c=c|0;return bb[a|0](b,c)|0}function _P(a){var b=0;b=Za-16|0;Za=b;Ab(a,0,80);Za=b+16|0}function UQ(a){var b=0;b=Za-16|0;Za=b;Ab(a,0,98);Za=b+16|0}function UN(a){var b=0;b=Za-16|0;Za=b;Ab(a,0,96);Za=b+16|0}function SQ(a){var b=0;b=Za-16|0;Za=b;Ab(a,0,48);Za=b+16|0}function NS(a){var b=0;b=Za-16|0;Za=b;Ab(a,0,38);Za=b+16|0}function LS(a){var b=0;b=Za-16|0;Za=b;Ab(a,0,41);Za=b+16|0}function HB(a){a=j[a>>2]-12|0;if((eu(a+8|0)|0)<=-1){Fb(a)}}function Gu(){var a=0;a=R(4)|0;Bk(a);X(a|0,71412,2003);z()}function CA(a){var b=0;b=Za-16|0;Za=b;Ab(a,0,36);Za=b+16|0}function zC(a){if(j[a>>2]){yC(a);_B(Ek(a),j[a>>2],Dk(a))}}function vn(a,b,c){Cc(a,j[b>>2]+(c>>>3&536870908)|0,c&31)}function ut(a){if(j[a>>2]){HS(a);yn(hb(a),j[a>>2],Df(a))}}function tf(a,b,c){return j[a>>2]+(p(j[a+4>>2],c)+b<<2)|0}function rDa(a,b,c){a=a|0;b=b|0;c=c|0;return $Ca(a,b,c)|0}function oDa(a,b,c){a=a|0;b=b|0;c=c|0;return _Ca(a,b,c)|0}function o9(a){a=a|0;return Wi(Eb(j[a+24>>2]+484360|0))|0}function nEa(a,b,c){a=a|0;b=b|0;c=c|0;return cEa(a,b,c)|0}function ms(a){if(j[a>>2]){eM(a);xe(hb(a),j[a>>2],jd(a))}}function lm(a,b,c){return j[a>>2]+(p(j[a+4>>2],c)+b<<1)|0}function lDa(a,b,c){a=a|0;b=b|0;c=c|0;return YCa(a,b,c)|0}function ke(a){if(!j[a+20>>2]){return 0}return j[a>>2]!=0}function jU(a){a=a|0;hB(a,11650);j[a>>2]=77452;return a|0}function jT(a){if(j[a>>2]){WS(a);Yf(hb(a),j[a>>2],Af(a))}}function hba(a,b,c){a=a|0;b=b|0;c=c|0;Mc(a,SB(c,b,ne(b)))}function hKa(a,b,c){a=a|0;b=b|0;c=c|0;return SJa(a,b,c)|0}function hDa(a,b,c){a=a|0;b=b|0;c=c|0;return VCa(a,b,c)|0}function ew(a,b,c){j[a+28>>2]=c;j[a+20>>2]=b;j[a+24>>2]=b}function eLa(a,b,c){a=a|0;b=b|0;c=c|0;return XKa(a,b,c)|0}function dLa(a,b,c){a=a|0;b=b|0;c=c|0;return WKa(a,b,c)|0}function cLa(a,b,c){a=a|0;b=b|0;c=c|0;return VKa(a,b,c)|0}function bva(a,b,c){a=a|0;b=b|0;c=c|0;rpa(a,b);return a|0}function bLa(a,b,c){a=a|0;b=b|0;c=c|0;return UKa(a,b,c)|0}function _ha(a,b,c){a=a|0;b=b|0;c=c|0;return Yha(a,b,c)|0}function _Ka(a,b,c){a=a|0;b=b|0;c=c|0;return TKa(a,b,c)|0}function ZLa(a,b,c){a=a|0;b=b|0;c=c|0;return PLa(a,b,c)|0}function YLa(a,b,c){a=a|0;b=b|0;c=c|0;return NLa(a,b,c)|0}function Vd(a){if(j[a>>2]){xe(hb(a),j[a>>2],j[hb(a)>>2])}}function UV(a){a=a|0;hB(a,11072);j[a>>2]=77108;return a|0}function UIa(a,b,c){a=a|0;b=b|0;c=c|0;return KIa(a,b,c)|0}function Ts(a){if(j[a>>2]){gQ(a);ft(hb(a),j[a>>2],ki(a))}}function Si(a){a=j[a+656>>2];if(!a){return 0}return ai(a)}function Rxa(a,b,c){a=a|0;b=b|0;c=c|0;return Exa(a,b,c)|0}function Qwa(a,b,c){a=a|0;b=b|0;c=c|0;return Gwa(a,b,c)|0}function QHa(a,b,c){a=a|0;b=b|0;c=c|0;return LHa(a,b,c)|0}function PE(a){while(1){if((Xq(a)|0)!=-1){continue}break}}function OJ(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;mna(a,b,c,d)}function Np(a){if(j[a>>2]){tA(a);Yf(hb(a),j[a>>2],Af(a))}}function Nd(a,b,c){Cc(a,j[b>>2]+(c>>>3&536870908)|0,1<<c)}function Kwa(a,b,c){a=a|0;b=b|0;c=c|0;return Bwa(a,b,c)|0}function Kga(a,b,c){a=a|0;b=b|0;c=c|0;return Jga(a,b,c)|0}function Kg(a,b,c){return j[a>>2]+(p(j[a+4>>2],c)+b<<3)|0}function Gza(a,b,c){a=a|0;b=b|0;c=c|0;return Bza(a,b,c)|0}function FGa(a,b,c){a=a|0;b=b|0;c=c|0;return lGa(a,b,c)|0}function Ev(a,b){return j[((a>>>24^b)<<2)+457392>>2]^a<<8}function EAa(a,b,c){a=a|0;b=b|0;c=c|0;return wAa(a,b,c)|0}function CGa(a,b,c){a=a|0;b=b|0;c=c|0;return jGa(a,b,c)|0}function $Ja(a,b,c){a=a|0;b=b|0;c=c|0;return QJa(a,b,c)|0}function wQ(a,b,c){a=a|0;b=b|0;c=c|0;return IFa(a,b,c)|0}function vEa(a,b,c){a=a|0;b=b|0;c=c|0;return eS(a,b,c)|0}function p6(a,b,c){a=a|0;b=b|0;c=c|0;return Yc(p(b,c))|0}function oT(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;Ge(a,c,d,b)}function lC(a,b){Ll(j[b>>2]);Kl(j[a>>2]);j[a>>2]=j[b>>2]}function fC(a){a=a|0;j[a>>2]=64840;gb(a+12|0);return a|0}function eC(a){a=a|0;j[a>>2]=64880;gb(a+16|0);return a|0}function bW(a,b,c){a=a|0;b=b|0;c=c|0;gu(a,b,j[b+8>>2],c)}function _ea(a){a=a|0;$G(a);h[a+4202|0]=1;j[a+4224>>2]=0}function _S(a,b,c){a=a|0;b=b|0;c=c|0;return QLa(a,b,c)|0}function ZFa(a,b){a=a|0;b=b|0;Db(a,b?b:14548);return a|0}function YD(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;sg(a,-1,-1)}function Wq(a){if(!h5(a)){Nb(a,30);return 0}return NE(a)}function Tq(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;f4(a,b,c,d)}function RF(a){a=a|0;j[a>>2]=83928;Hy(a+12|0);return a|0}function OF(a){a=a|0;j[a>>2]=83968;Gy(a+12|0);return a|0}function Nh(a){return he(a)|he(a)<<8|he(a)<<16|he(a)<<24}function Ls(a){Ym(a+88|0);Ym(a+68|0);Ym(a+48|0);return a}function LA(a){a=a|0;j[a>>2]=77336;Wt(a+12|0);return a|0}function KQ(a){a=a|0;if(!k[a|0]){return 1}return Mf(a)|0}function HGa(a,b,c){a=a|0;b=b|0;c=c|0;return Uq(a,b,c)|0}function HFa(a,b){a=a|0;b=b|0;return JI(a,zb(b),nb(b))|0}function Dz(a){h[a|0]=0;h[a+1|0]=0;h[a+2|0]=0;h[a+3|0]=0}function Dx(a,b){o[a>>3]=o[a>>3]*b;o[a+8>>3]=o[a+8>>3]*b}function DU(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;gu(a,b,c,d)}function CB(a,b,c){b=ra(a|0,b|0,c|0)|0;ab=C()|0;return b}function Bl(a,b,c){a=IMa(j[a>>2],j[a+4>>2],b,c);return a}function $r(a,b,c){a=a|0;b=b|0;c=c|0;return Tqa(a,b,c)|0}function sc(a){if(qe(a)){a=Mj(a)-1|0}else{a=10}return a}function rS(a){if(k[a+1|0]==2){return k[a|0]<3}return 0}function qD(a){return(a|0)!=0&(a|0)!=60384&(a|0)!=60408}function pIa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;yz(b,c,d)}function nC(a){var b=0;b=j[a>>2];j[a>>2]=0;if(b){Kl(b)}}function kq(a){a=a|0;j[a>>2]=71452;HB(a+4|0);return a|0}function hr(a){a=a|0;j[a>>2]=83800;Zv(a+4|0);return a|0}function hD(a,b,c,d){a=iD(a,b,c,0,-2147483648);return a}function gpa(a,b){a=a|0;b=b|0;return m[a+12>>2]>b>>>0|0}function ez(a,b,c){b=b-a|0;if(b){Ci(c,a,b)}return b+c|0}function eea(a){a=a|0;return Hd(j[j[a>>2]-12>>2]+a|0)|0}function bF(a,b,c){j[a+4>>2]=0;j[a>>2]=b;j[a+8>>2]=c<<3}function Zy(a,b,c){a=a|0;b=b|0;c=c|0;return gS(a,b,c)|0}function Yn(a){a=a|0;j[a>>2]=58704;wb(a+4|0);return a|0}function YG(a){return q(q(n[a+4208>>2]*q(1e4))+q(-1e4))}function XG(a){return q(q(n[a+4252>>2]*q(19980))+q(20))}function Wt(a){a=a|0;j[a>>2]=77376;jb(a+4|0);return a|0}function Vq(a,b,c){return nE(zb(a),nb(a),zb(b),c,nb(b))}function SN(a,b,c){a=a|0;b=b|0;c=c|0;return us(a,b,c)|0}function S$(a,b,c){a=a|0;b=b|0;c=c|0;return R$(a,b,c)|0}function QC(a,b,c){a=a|0;b=b|0;c=c|0;return Q$(a,b,c)|0}function Nk(a){a=a|0;j[a>>2]=58640;wb(a+4|0);return a|0}function LC(a,b,c){a=a|0;b=b|0;c=c|0;return H$(a,b,c)|0}function J$(a,b,c){a=a|0;b=b|0;c=c|0;return I$(a,b,c)|0}function Hc(a,b,c){a=a|0;b=b|0;c=c|0;ye(a,b);return a|0}function Gy(a){a=a|0;j[a>>2]=76520;xg(a+4|0);return a|0}function G2(a,b,c){a=a|0;b=b|0;c=c|0;return H2(a,b,c)|0}function Cz(a,b,c){a=a|0;b=b|0;c=c|0;return MR(a,b,c)|0}function CN(a,b){return eW(zb(a),nb(a),zb(b),nb(b))}



function Au(a){a=a|0;j[a>>2]=71432;HB(a+4|0);return a|0}function A2(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return d|0}function zha(a,b,c){a=a|0;b=b|0;c=c|0;ql(a,b+4260|0,8)}function vO(a){var b=0;b=Za-16|0;Za=b;QAa(a);Za=b+16|0}function pg(a){var b=0;b=Xq(a);j[a+1396>>2]=0;return b}function oq(a){if(qe(a)){a=Mj(a)-1|0}else{a=1}return a}function o2(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;Yh(a,c,d)}function mH(a){a=a|0;return bi(q(n[a+4224>>2]*q(4)))|0}function lO(a){var b=0;b=Za-16|0;Za=b;pAa(a);Za=b+16|0}function co(a){return k[a+2|0]&2?(k[a+1|0]&6)==6?4:1:0}function ac(a,b){if(aF(b)){return oY(a,b)}return ue(a)}function Ut(a,b){a=HMa(j[a>>2],j[a+4>>2],b,0);return a}function UD(a){a=a|0;return Fq(j[j[a>>2]-12>>2]+a|0)|0}function Tf(a,b){a=a|0;b=b|0;bb[j[j[b>>2]+20>>2]](a,b)}function SP(a){var b=0;b=Za-16|0;Za=b;LEa(a);Za=b+16|0}function PL(a,b){i[a+20>>1]=l[a+20>>1]&768|b&255;Gx(a)}function Ms(a){var b=0,c=0;b=a,c=mP(j[a>>2]),j[b>>2]=c}function M9(a,b){a=a|0;b=b|0;j[j[a+24>>2]+480272>>2]=b}function Ii(a,b){j[a+16>>2]=!j[a+24>>2]|(j[a+16>>2]|b)}function ID(a){a=a|0;return Bq(j[j[a>>2]-12>>2]+a|0)|0}function Hg(a,b){a=a|0;b=b|0;bb[j[j[b>>2]+24>>2]](a,b)}function Gg(a,b){a=a|0;b=b|0;bb[j[j[b>>2]+28>>2]](a,b)}function F7(a){a=a|0;return Xe(j[j[a>>2]-12>>2]+a|0)|0}function yp(a,b){a=a|0;b=b|0;return me(a)>>>0>b>>>0|0}function uia(a,b,c){a=a|0;b=b|0;c=c|0;n[b>>2]=n[c>>2]}function uO(a,b){a=a|0;b=b|0;j[a>>2]=b;j[a+4>>2]=b+12}function tW(a,b){a=a|0;b=b|0;j[a>>2]=b;j[a+4>>2]=b+36}function n9(a){a=a|0;return xI(j[a+24>>2]+484344|0)|0}function kC(a){var b=0;b=Za-16|0;Za=b;sZ(a);Za=b+16|0}function iO(a,b){a=a|0;b=b|0;j[a>>2]=b;j[a+4>>2]=b+24}function gb(a){if(qe(a)){Yf(a,j[a>>2],Mj(a))}return a}function dc(a,b,c){a=a|0;b=b|0;c=c|0;os(a);return a|0}function cQ(a){var b=0;b=Za-16|0;Za=b;Dz(a);Za=b+16|0}function _La(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0}function Zl(a,b){return bb[j[j[a>>2]+36>>2]](a,b,0)|0}function ZJa(a,b,c){a=a|0;b=b|0;c=c|0;pJa(a,b-a>>2,c)}function Yl(a,b){return bb[j[j[a>>2]+52>>2]](a,b,0)|0}function Xla(a){a=a|0;n[a+12>>2]=1;iJ(a,4);return a|0}function Wha(a,b){a=a|0;b=b|0;b3(a,j[b>>2],j[b+4>>2])}function W6(a,b){a=a|0;b=b|0;fL(j[a>>2],b);return a|0}function Vga(a){a=a|0;h[a+4202|0]=1;ur(a);nw(a);HH(a)}function VA(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return 0}function OA(a){var b=0;b=Za-16|0;Za=b;El(a);Za=b+16|0}function Mfa(a){a=a|0;return q(q(n[a+4232>>2]*q(20)))}function Hh(a){a=a|0;return bb[j[j[a>>2]+12>>2]](a)|0}function Gh(a){a=a|0;return bb[j[j[a>>2]+16>>2]](a)|0}function Ge(a,b,c,d){h[a+8|0]=d;j[a+4>>2]=c;j[a>>2]=b}function GW(a,b){a=a|0;b=b|0;j[a>>2]=b;j[a+4>>2]=b+48}function Dba(a){a=a|0;a=j[a+4>>2];return(a?a:38169)|0}function Am(a){a=a|0;return bb[j[j[a>>2]+24>>2]](a)|0}function w9(a){a=a|0;return j[j[a+24>>2]+1074424>>2]}function nH(a){a=a|0;return q(q(n[a+4216>>2]*q(10)))}function ffa(a){a=a|0;return q(q(n[a+4232>>2]*q(4)))}function bR(a){a=a|0;return j[NHa(j[a>>2],aR(a))>>2]}function _Ga(a){a=a|0;return KI(k[a+3|0],k[a+5|0])|0}function XU(a,b,c,d){yc(a,b);yc(a+4|0,c);yc(a+8|0,d)}function Sja(a,b){a=a|0;b=b|0;a=a+24|0;EI(a,b);Zw(a)}function PGa(a,b){a=a|0;b=b|0;return JI(a,b,ne(b))|0}function Nm(a,b,c){a=a|0;b=b|0;c=c|0;j[b>>2]=j[c>>2]}function GMa(a){if(a){return 31-s(a-1^a)|0}return 32}function Dn(a){a=a|0;a=a+12|0;bb[j[j[a>>2]>>2]](a)|0}function Ap(a,b,c){a=a|0;b=b|0;c=c|0;i[b>>1]=l[c>>1]}function A9(a){a=a|0;return j[j[a+24>>2]+1074416>>2]}function zL(a,b){j[a+8>>2]=0;j[a+12>>2]=0;o[a>>3]=b}function z6(a,b,c){a=a|0;b=b|0;c=c|0;jF(a-88|0,b,c)}function x6(a,b,c){a=a|0;b=b|0;c=c|0;hF(a-88|0,b,c)}function vc(a,b){a=a|0;b=b|0;return dO(a,b,ne(b))|0}function v9(a){a=a|0;return l[j[a+24>>2]+480214>>1]}function ud(a){var b=0;b=j[a>>2];j[a>>2]=0;return b}function sx(a){a=a|0;return Rr(k[a+2|0],k[a+4|0])|0}function qy(a,b){a=a|0;b=b|0;return Ln(a,b,ne(b))|0}function ql(a,b,c){j[a>>2]=b;j[a+4>>2]=b+c;return a}function pc(a){if(qe(a)){On(j[a>>2],Mj(a))}return a}function mb(a,b,c){Cc(a,(c>>>3&536870908)+b|0,1<<c)}function hL(a,b){return SV(zb(a),nb(a),zb(b),nb(b))}function fr(a){a=a|0;return l[j[a+24>>2]+480190>>1]}function Zja(a,b){a=a|0;b=b|0;zi(a+36|0,b);return 1}function Ur(a){a=a|0;return Rr(k[a+3|0],k[a+5|0])|0}function Uk(a){a=a|0;return l[j[a+24>>2]+480188>>1]}function Tk(a){a=a|0;return l[j[a+24>>2]+480192>>1]}function Rn(a,b){b=j[b>>2];j[a>>2]=b;Ll(b);return a}function Oq(a){if(!a){return 0}j[114604]=a;return-1}function NA(a,b,c){vk(a,b);j[a+12>>2]=c;j[a+8>>2]=0}function Ml(a,b){He(a,b);Ab(a+16|0,0,1040);return a}function L9(a){a=a|0;return j[j[a+24>>2]+480272>>2]}function IC(a,b,c){a=a|0;b=b|0;c=c|0;zb(b);return-1}function Hd(a){a=a|0;a=Hea(a);og(a+56|0);return a|0}function Gta(a){a=a|0;bf(85432);bf(85424);gb(85412)}function FC(a){a=a|0;rq(a);j[a>>2]=65852;return a|0}function EC(a){a=a|0;rq(a);j[a>>2]=65948;return a|0}function Cm(a,b,c){if(!c){return 0}return _c(a,b,c)}function Ara(a,b){a=a|0;b=b|0;j[b>>2]=0;j[b+4>>2]=0}function y6(a,b){a=a|0;b=b|0;return iF(a-88|0,b)|0}function w6(a,b){a=a|0;b=b|0;return gF(a-88|0,b)|0}function su(a,b,c){a=a|0;b=b|0;c=c|0;h[b|0]=k[c|0]}function rta(a,b){a=a|0;b=b|0;return Vb(a,b,116)|0}function pEa(a,b,c){a=a|0;b=b|0;c=c|0;Ge(a,c,16,b)}function nz(a,b,c){ql(a,j[b+28>>2]+(c<<12)|0,4096)}function nDa(a,b){a=a|0;b=b|0;ZCa(a,j[b>>2],aR(b))}function kp(a){return(j[a+480180>>2]&740327453)!=0}function jb(a){a=j[a+4>>2];if(a){if(Kl(a)){mY(a)}}}function hz(a,b,c){return a>>>0<c>>>0&a>>>0>=b>>>0}function fi(a,b,c){j[a>>2]=j[b>>2];h[a+4|0]=k[c|0]}function eza(a,b,c){a=a|0;b=b|0;c=c|0;Ge(a,c,33,b)}function cl(a){_h(a+724|0);_h(a+736|0);_h(a+748|0)}function bG(a,b){$F(a,74);j[a+4>>2]=j[a+4>>2]|b&74}function Xe(a){a=a|0;a=$7(a);og(a+60|0);return a|0}function XO(a,b,c){a=a|0;b=b|0;c=c|0;Mc(a,qy(b,c))}function Wya(a,b,c){a=a|0;b=b|0;c=c|0;Ge(a,c,24,b)}function Vp(a,b,c){a=a|0;b=b|0;c=c|0;Mc(a,aP(b,c))}function Ux(a,b,c){a=a|0;b=b|0;c=c|0;QM(vd(a,b),c)}function RK(a){return j[a+16>>2]!=(0-j[a+20>>2]|0)}function Kra(a){a=a|0;return+P4(o[a>>3],o[a+8>>3])}function C6(a,b,c){a=a|0;b=b|0;c=+c;lF(a-88|0,b,c)}function xP(a,b){a=QCa(a,b);if(!a){lP(b)}return a}function vg(a,b,c){a=a|0;b=b|0;c=c|0;Ge(a,c,32,b)}function uy(a,b){a=YAa(a,b);if(!a){zO(b)}return a}function tz(a,b){a=wIa(a,b);if(!a){mR(b)}return a}function sn(a,b,c){a=a|0;b=b|0;c=c|0;Ge(a,c,22,b)}function sl(a){return(j[Ob(a)>>2]-j[a>>2]|0)/24|0}function rl(a){return(j[hb(a)>>2]-j[a>>2]|0)/48|0}function nl(a){return(j[hb(a)>>2]-j[a>>2]|0)/33|0}function mz(a,b){a=dIa(a,b);if(!a){dR(b)}return a}function mt(a,b,c){a=a|0;b=b|0;c=c|0;Ge(a,c,64,b)}function mEa(a,b){a=a|0;b=b|0;return zr(a,b,17)|0}function lza(a,b,c){a=a|0;b=b|0;c=c|0;Ge(a,c,9,b)}function lG(a,b){Vv(j[j[a>>2]-12>>2]+a|0,j[b>>2])}function kb(a){return(j[a+4>>2]&j[j[a>>2]>>2])!=0}function jn(a,b,c){a=a|0;b=b|0;c=c|0;Ge(a,c,20,b)}function jN(a,b){a=Vxa(a,b);if(!a){SQ(b)}return a}function gl(a,b,c){o[a+8>>3]=c;o[a>>3]=b;return a}function fz(a,b){a=iHa(a,b);if(!a){SQ(b)}return a}function ek(a,b,c){a=a|0;b=b|0;c=c|0;Ge(a,c,12,b)}function ce(a,b){a=a|0;b=b|0;return(a|0)==(b|0)|0}function aLa(a,b){a=a|0;b=b|0;return zr(a,b,11)|0}function _s(a,b,c){a=a|0;b=b|0;c=c|0;Ge(a,c,28,b)}function _o(a){return(j[hb(a)>>2]-j[a>>2]|0)/20|0}function Xm(a){return(j[hb(a)>>2]-j[a>>2]|0)/56|0}function Vn(a){return(j[Ob(a)>>2]-j[a>>2]|0)/12|0}function Vf(a){return(j[hb(a)>>2]-j[a>>2]|0)/12|0}function VQ(a,b,c){a=a|0;b=b|0;c=c|0;Ge(a,c,40,b)}function UR(a,b,c){a=a|0;b=b|0;c=c|0;Ge(a,c,30,b)}function Pi(a){return(j[hb(a)>>2]-j[a>>2]|0)/52|0}function MO(a,b){a=ZAa(a,b);if(!a){BO(b)}return a}function Kt(a,b,c){a=a|0;b=b|0;c=c|0;Ge(a,c,26,b)}function IF(a,b,c,d){cua(a,b,c,ph(q(d*q(65536))))}function Hf(a,b){return nE(zb(a),nb(a),b,0,ne(b))}function EEa(a,b){a=a|0;b=b|0;return bb[b|0](a)|0}function Cc(a,b,c){j[a+4>>2]=c;j[a>>2]=b;return a}function Bg(a,b){if(qe(a)){ee(a,b);return}Ue(a,b)}function Be(a){return(j[hb(a)>>2]-j[a>>2]|0)/24|0}function BR(a,b){a=xIa(a,b);if(!a){mR(b)}return a}function A_(){t$();j[115462]=463472;return 461848}function AF(a,b,c){j[a>>2]=b;j[a+4>>2]=c;return a}function AE(a,b){if(!a){return 0}return Cj(a,b,0)}function $N(a,b){a=Aza(a,b);if(!a){UN(b)}return a}function zb(a){if(qe(a)){return j[a>>2]}return a}function vQ(a,b){a=a|0;b=b|0;return zr(a,b,32)|0}function vIa(a,b,c){a=a|0;b=b|0;c=c|0;Vb(b,c,48)}function tM(a,b){yc(a,j[b>>2]);h[a+4|0]=k[b+4|0]}function rja(a,b){a=a|0;b=b|0;YS(a,b);return a|0}function oh(a){return j[a+8>>2]!=0|j[a+12>>2]!=0}function nv(a,b,c){a=a|0;b=b|0;c=c|0;aF(c);Fb(a)}function ki(a){return(j[hb(a)>>2]-j[a>>2]|0)/6|0}function hj(a,b){a=JU(a,b);if(!a){OA(b)}return a}function hfa(a){a=a|0;return n[a+4212>>2]<q(1)|0}function fBa(a,b){a=a|0;b=b|0;return tn(a,b,2)|0}function ep(a,b,c){h[a+2|0]=c;i[a>>1]=b;return a}function dsa(a){a=a|0;j[a>>2]=0;_ra();return a|0}function ZBa(a,b,c){a=a|0;b=b|0;c=c|0;OBa(a,b,c)}function Yw(a){j[a+4>>2]=0;j[a+8>>2]=-1;h[a|0]=0}function Xg(a){return(Te(a)|0)!=(0-Te(a+12|0)|0)}function Pfa(a){a=a|0;return n[a+4220>>2]<q(1)|0}function Km(a){j[a>>2]=0;j[a+4>>2]=0;j[a+8>>2]=0}function KGa(a,b){a=a|0;b=b|0;return tn(a,b,3)|0}function II(a,b,c){h[a|0]=k[b|0];h[a+1|0]=k[c|0]}function Gx(a){j[a+24>>2]=l[a+20>>1]<<l[a+22>>1]}function GR(a,b){h[a|0]=k[b|0];h[a+1|0]=k[b+1|0]}function GA(a,b){a=wU(a,b);if(!a){CA(b)}return a}function Cja(a,b){a=a|0;b=b|0;return zr(a,b,1)|0}function B6(a,b){a=a|0;b=b|0;return+kF(a-88|0,b)}function yGa(a,b){a=a|0;b=b|0;return gGa(a,b)|0}function vh(a,b){a=a|0;b=b|0;return tn(a,b,4)|0}function vfa(a){a=a|0;h[a+4202|0]=1;gH(a);fH(a)}function vT(a,b){a=a|0;b=b|0;zl(a,b);return a|0}function ss(a,b){a=a|0;b=b|0;return(b-a|0)/12|0}function r$(a,b){a=a|0;b=b|0;xd(a,b,sd(461680))}function q$(a,b){a=a|0;b=b|0;xd(a,b,sd(461688))}function pd(a){return(j[a+4>>2]-j[a>>2]|0)/24|0}function p$(a,b){a=a|0;b=b|0;xd(a,b,sd(461884))}function o$(a,b){a=a|0;b=b|0;xd(a,b,sd(461876))}function nj(a){return bb[j[j[a>>2]+36>>2]](a)|0}function n$(a,b){a=a|0;b=b|0;xd(a,b,sd(461892))}function ml(a,b,c){a=a|0;b=b|0;c=c|0;return a|0}function li(a){return(j[a+4>>2]-j[a>>2]|0)/48|0}function l$(a,b){a=a|0;b=b|0;xd(a,b,sd(461900))}function k$(a,b){a=a|0;b=b|0;xd(a,b,sd(461908))}function jJa(a,b){a=a|0;b=b|0;return iJa(a,b)|0}function jCa(a,b){a=a|0;b=b|0;return VBa(a,b)|0}function iX(a){a=a|0;a=Za-a&-16;Za=a;return a|0}function i$(a,b){a=a|0;b=b|0;xd(a,b,sd(461916))}function h$(a,b){a=a|0;b=b|0;xd(a,b,sd(461924))}function gs(a,b){a=a|0;b=b|0;Cf(a,b);return a|0}function gm(a){return bb[j[j[a>>2]+28>>2]](a)|0}function g$(a,b){a=a|0;b=b|0;xd(a,b,sd(461932))}function f$(a,b){a=a|0;b=b|0;xd(a,b,sd(461696))}function et(a,b,c){b=b-a|0;if(b){Ci(c-b|0,a,b)}}function eg(a,b){a=a|0;b=b|0;OD(a,j[a+16>>2]|b)}function ec(a){return(j[a+4>>2]-j[a>>2]|0)/12|0}function eO(a,b){a=a|0;b=b|0;return tn(a,b,8)|0}function e$(a,b){a=a|0;b=b|0;xd(a,b,sd(461704))}function df(a){return(j[a+4>>2]-j[a>>2]|0)/52|0}function d$(a,b){a=a|0;b=b|0;xd(a,b,sd(461712))}function c$(a,b){a=a|0;b=b|0;xd(a,b,sd(461720))}function bsa(a,b){a=a|0;b=b|0;return Zra(a,b)|0}function a$(a,b){a=a|0;b=b|0;xd(a,b,sd(461760))}function __(a,b){a=a|0;b=b|0;xd(a,b,sd(461776))}function Z_(a,b){a=a|0;b=b|0;xd(a,b,sd(461784))}function X_(a,b){a=a|0;b=b|0;xd(a,b,sd(461792))}function XLa(a,b){a=a|0;b=b|0;return MLa(a,b)|0}function XHa(a,b){a=a|0;b=b|0;return OHa(a,b)|0}function Wu(a,b,c,d){a=iD(a,b,c,-1,-1);return a}function Wj(a){return(j[a+4>>2]-j[a>>2]|0)/56|0}function V_(a,b){a=a|0;b=b|0;xd(a,b,sd(461800))}function ULa(a,b){a=a|0;b=b|0;return JLa(a,b)|0}function S_(a,b){a=a|0;b=b|0;xd(a,b,sd(461808))}function Q_(a,b){a=a|0;b=b|0;xd(a,b,sd(461816))}function Q9(a,b){a=a|0;b=b|0;O9(a,P9(ue(12),b))}function P_(a,b){a=a|0;b=b|0;xd(a,b,sd(461728))}function Oi(a,b,c){a=a|0;b=b|0;c=c|0;zma(a,b,c)}function Oda(a,b){a=a|0;b=b|0;return Mda(a,b)|0}function O_(a,b){a=a|0;b=b|0;xd(a,b,sd(461736))}function OKa(a,b){a=a|0;b=b|0;return LKa(a,b)|0}function Mea(a){a=a|0;ZG(a);gw(a);h[a+4202|0]=1}function M_(a,b){a=a|0;b=b|0;xd(a,b,sd(461744))}function K_(a,b){a=a|0;b=b|0;xd(a,b,sd(461752))}function I_(a,b){a=a|0;b=b|0;xd(a,b,sd(461824))}function H_(a,b){a=a|0;b=b|0;xd(a,b,sd(461832))}function Fr(a,b,c){a=a|0;b=b|0;c=c|0;Sma(a,b,c)}function Fp(a,b){a=a|0;b=b|0;return Se(a,b,0)|0}function Ffa(a){a=a|0;h[a+4202|0]=1;kH(a);lH(a)}function De(a,b,c){a=a|0;b=b|0;c=c|0;xLa(a,b,c)}function Bj(a){a=a|0;return QD(j[a>>2])<<24>>24}function BAa(a,b){a=a|0;b=b|0;return zAa(a,b)|0}function AGa(a,b){a=a|0;b=b|0;return hGa(a,b)|0}function $j(a){return(j[a+4>>2]-j[a>>2]|0)/33|0}function $_(a,b){a=a|0;b=b|0;xd(a,b,sd(461768))}function zf(a,b){a=a|0;b=b|0;return EKa(a,b)|0}function vja(a,b,c){a=a|0;b=b|0;c=c|0;uja(b,c)}function ve(a,b,c){if(!(k[a|0]&32)){tu(b,c,a)}}function sO(a,b){a=a|0;b=b|0;return yAa(a,b)|0}function moa(a,b,c){a=a|0;b=b|0;c=c|0;ioa(b,c)}function gf(a,b){a=a|0;b=b|0;return lMa(a,b)|0}function es(a){return(a>>>0<9?a:a-9|256)&65535}function dn(a,b){a=a|0;b=b|0;return NFa(a,b)|0}function ak(a,b){h[a+4|0]=0;j[a>>2]=b;return a}function aT(a,b){a=a|0;b=b|0;return SLa(a,b)|0}function aR(a){return j[a>>2]+(j[a+4>>2]<<2)|0}function _Ha(a){a=a|0;gJa(a);return j[a+12>>2]}function ZS(a,b){a=a|0;b=b|0;return KLa(a,b)|0}function Yo(a,b){return(p(b,104)+a|0)+484380|0}function Yda(a){a=a|0;JG(j[j[a>>2]-12>>2]+a|0)}function X3(a,b,c){a=a|0;b=b|0;c=c|0;Cc(a,c,b)}function Wz(a,b){a=a|0;b=b|0;return qMa(a,b)|0}function SL(a,b){NL(j[a>>2],b);NL(j[a+4>>2],b)}function Qb(a,b,c){a=a|0;b=b|0;c=c|0;ql(a,b,c)}function Pd(a,b){a=a|0;b=b|0;return IKa(a,b)|0}function PR(a,b){a=a|0;b=b|0;return LJa(a,b)|0}function Lf(a){return(j[a+4>>2]-j[a>>2]|0)/6|0}function Jsa(a,b,c){a=a|0;b=b|0;c=c|0;Isa(b,c)}function HL(a){GL(a);Ab(a+27|0,0,255);return a}function Fya(a,b,c){a=a|0;b=b|0;c=c|0;Bya(b,c)}function Fj(a){return(j[a+4>>2]+j[a>>2]|0)-1|0}function En(a){eB(a);j[a+8>>2]=0;j[a>>2]=70816}function Ar(a,b){return(j[a>>2]-j[b>>2]|0)/6|0}function $y(a){a=a|0;return(k[a+1|0]==1?1:2)|0}function $8(a,b,c){a=a|0;b=b|0;c=c|0;_8(a,b,c)}function zz(a,b){a=a|0;b=b|0;return Zt(a,b)|0}function yj(a,b){a=a|0;b=b|0;return LD(a,b)|0}function x3(a,b){a=a|0;b=b|0;return w3(a,b)|0}function w7(a){a=a|0;FF(j[j[a>>2]-12>>2]+a|0)}function vi(a,b){a=a|0;b=b|0;return gU(a,b)|0}function vf(a){j[a>>2]=0;j[a+4>>2]=0;return a}function vHa(a,b,c){a=a|0;b=b|0;c=c|0;He(b,c)}function u3(a,b){a=a|0;b=b|0;return t3(a,b)|0}function ti(a,b){a=a|0;b=b|0;return gT(a,b)|0}function tb(a,b){a=a|0;b=b|0;return wV(a,b)|0}function s3(a,b){a=a|0;b=b|0;return r3(a,b)|0}function rb(a,b){a=a|0;b=b|0;return el(a,b)^1}function rFa(a){a=a|0;tQ(a);return j[a+16>>2]}function qR(a){h[a+12|0]=k[a+12|0]|2;return a}function pu(a,b){a=a|0;b=b|0;return qy(a,b)|0}function p3(a,b){a=a|0;b=b|0;return o3(a,b)|0}function n3(a,b){a=a|0;b=b|0;return m3(a,b)|0}function mwa(a){a=a|0;Sx(a+288|0);Vo(a+800|0)}function kO(a,b,c){a=a|0;b=b|0;c=c|0;bha(a,c)}function jc(a,b){if(m[a>>2]>b>>>0){j[a>>2]=b}}function hi(a,b){a=a|0;b=b|0;return rb(a,b)|0}function cw(a){a=a|0;j[a>>2]=83668;return a|0}function ai(a){return(k[a+31|0]-1&255)>>>0<17}function _j(a,b){if(j[a>>2]>(b|0)){j[a>>2]=b}}function Zb(a,b){a=a|0;b=b|0;return R1(a,b)|0}function YN(a,b){a=a|0;b=b|0;return ad(a,b)|0}function YL(a,b,c){a=a|0;b=b|0;c=c|0;Fsa(b,c)}function YK(a,b){if(!(n[a>>2]<=b)){n[a>>2]=b}}function Xn(a,b){a=a|0;b=b|0;return RD(a,b)^1}function Vg(a,b){a=a|0;b=b|0;return OT(a,b)|0}function Tsa(a,b,c){a=a|0;b=b|0;c=c|0;u2(a,b)}function TD(a){a=a|0;fv(j[j[a>>2]-12>>2]+a|0)}function Rf(a,b){if(l[a>>1]>b>>>0){i[a>>1]=b}}function QP(a,b,c){a=a|0;b=b|0;c=c|0;return 0}function Ol(a,b,c){a=a|0;b=b|0;c=c|0;iha(a,c)}function OK(a){NK(a+20|0);jK(a+8|0);bf(a+4|0)}function Lc(a,b){a=a|0;b=b|0;return pW(a,b)|0}function KMa(a,b,c,d){a=FMa(a,b,c,d);return a}function Ji(a,b){a=a|0;b=b|0;return RD(a,b)|0}function Ij(a){return j[hb(a)>>2]-j[a>>2]>>11}function IMa(a,b,c,d){a=DMa(a,b,c,d);return a}function HMa(a,b,c,d){a=CMa(a,b,c,d);return a}function HD(a){a=a|0;cv(j[j[a>>2]-12>>2]+a|0)}function Dt(a,b){a=a|0;b=b|0;return Ct(a,b)|0}function Cq(a,b){a=a|0;b=b|0;return LD(a,b)^1}function CP(a,b,c){a=a|0;b=b|0;c=c|0;CDa(b,c)}function As(a,b){a=a|0;b=b|0;return aP(a,b)|0}function zaa(a){a=a|0;$F(a,16384);return a|0}function y9(a){a=a|0;return ZF(j[a+24>>2])|0}function xn(a){return j[Ob(a)>>2]-j[a>>2]>>1}function xi(a){return j[hb(a)>>2]-j[a>>2]>>3}function vFa(a){a=a|0;tQ(a);return j[a+4>>2]}function sga(a,b){a=a|0;b=b|0;return Rh(b)|0}function saa(a){a=a|0;Vv(a,16384);return a|0}function ru(a){return j[Ob(a)>>2]-j[a>>2]>>4}function qw(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0}function jd(a){return j[hb(a)>>2]-j[a>>2]>>2}function hw(a){return q(q(a*q(7900))+q(100))}function hv(a,b,c){a=a|0;b=b|0;c=c|0;Mc(b,c)}function gfa(a){a=a|0;return q(n[a+4220>>2])}function di(a,b,c){a=a|0;b=b|0;c=c|0;ws(a,c)}function bu(a){return j[Ob(a)>>2]-j[a>>2]>>5}function aI(a,b,c){a=a|0;b=b|0;c=c|0;hp(b,c)}function _y(a,b,c){a=a|0;b=b|0;c=c|0;nI(a,c)}function _f(a){return j[Ob(a)>>2]-j[a>>2]>>2}function Zg(a){return j[hb(a)>>2]-j[a>>2]>>5}function YEa(a,b){a=a|0;b=b|0;qp(Ab(b,0,48))}function SA(a,b,c){a=a|0;b=b|0;c=c|0;nV(b,c)}function Rg(a){return j[j[a+8>>2]>>2]==(a|0)}function Py(a,b,c){a=a|0;b=b|0;c=c|0;Cf(b,c)}function Ofa(a){a=a|0;return q(n[a+4212>>2])}function G4(a){a=a|0;return Oa(j[a+60>>2])|0}function Dk(a){return j[nq(a)>>2]-j[a>>2]>>2}function Df(a){return j[hb(a)>>2]-j[a>>2]>>1}function Ah(a){return j[hb(a)>>2]-j[a>>2]>>4}function ze(a,b){if(k[a|0]>b>>>0){h[a|0]=b}}function xY(a,b){a=a|0;b=b|0;return Ck(b)|0}function vha(a,b){a=a|0;b=b|0;h[a+4201|0]=b}function uga(a,b,c){a=a|0;b=b|0;c=c|0;vf(a)}function u_(){Rn(461860,oC());return 461860}function qH(a){a=a|0;bb[j[j[a>>2]+4>>2]](a)}function pH(a){a=a|0;return q(n[a+4208>>2])}function or(a){SG(a);j[a>>2]=59164;return a}function jE(a){SG(a);j[a>>2]=59236;return a}function ig(a,b,c){return Aa(a|0,b|0,c|0)|0}function dm(a){a=a|0;JD(j[a>>2]);return a|0}function _ia(a,b){a=a|0;b=b|0;f3(a,i[b>>1])}function Vh(a,b){a=a|0;b=b|0;return q(q(0))}function Te(a){return j[a+4>>2]-j[a>>2]>>11}function RL(a,b){i[a+22>>1]=b&7;Gx(a);Hx(a)}function Nz(a){return j[Ob(a)>>2]-j[a>>2]|0}function Mk(a){a=a|0;ev(j[a>>2]);return a|0}function Lja(a,b){a=a|0;b=b|0;c3(a,j[b>>2])}function Lia(a,b){a=a|0;b=b|0;bv(a,l[b>>1])}function L4(a,b){a=a|0;b=b|0;return Jg(a)|0}function KG(a){return ph(q(MG(a)*q(32768)))}function HJ(a){return a>>>0<=255&a>>>0>=251}function Gha(a,b){a=a|0;b=b|0;_2(a,o[b>>3])}function Af(a){return j[hb(a)>>2]-j[a>>2]|0}function $F(a,b){j[a+4>>2]=j[a+4>>2]&(b^-1)}function zpa(a){a=q(a);return qpa(Rd(a))|0}function z3(a){a=a|0;return Fg(a,461696)|0}function wp(a,b){return j[a>>2]-j[b>>2]>>1}function sq(a,b){bb[j[j[b>>2]+40>>2]](a,b)}function sb(a){return j[a+4>>2]-j[a>>2]>>2}function pj(a,b){bb[j[j[b>>2]+44>>2]](a,b)}function oj(a,b){bb[j[j[b>>2]+32>>2]](a,b)}function mv(a){a=a|0;return Fg(a,461892)|0}function lv(a){a=a|0;return Fg(a,461900)|0}function lja(a,b){a=a|0;b=b|0;bv(a,k[b|0])}function kD(){return(j[j[21255]>>2]?4:1)|0}function jha(a,b){a=a|0;b=b|0;Ab(b,0,2048)}function gI(a,b){a=a|0;b=b|0;bv(a,j[b>>2])}function g3(a){a=a|0;return Fg(a,461712)|0}function fg(a){return j[a+4>>2]-j[a>>2]>>3}function fba(a,b){a=a|0;b=b|0;eba(a,b+4|0)}function fKa(a,b){a=a|0;b=b|0;zi(a+12|0,b)}function ey(a){Vd(a+24|0);Od(a+12|0);Od(a)}function er(a){return(a|0)<=65535&(a|0)>=0}function dv(a){a=a|0;return Fg(a,461876)|0}function de(a){return j[a+4>>2]-j[a>>2]>>5}function cu(a){bq(a+28|0);jb(a+12|0);gb(a)}function Zma(a,b){a=a|0;b=b|0;zi(a+40|0,b)}function Zc(a){return j[a+4>>2]-j[a>>2]>>4}function Yb(a){return j[a+4>>2]-j[a>>2]>>1}function W8(a,b){a=a|0;b=b|0;return b-a>>3}function Uu(a){a=a|0;return Fg(a,461924)|0}function Tt(a){a=a|0;return Fg(a,461884)|0}function Ru(a){a=a|0;return Fg(a,461932)|0}function QL(a,b){h[a+21|0]=b&3;Gx(a);Hx(a)}function QG(a){return q(q(a*q(96))+q(-96))}function Mj(a){return j[a+8>>2]&2147483647}function Ks(a,b){return j[a>>2]-j[b>>2]>>2}function JV(a){a=a|0;return j[a+4>>2]!=0|0}function Fja(a,b){a=a|0;b=b|0;Pea(a,b+4|0)}function B9(a){a=a|0;return+LJ(j[a+24>>2])}function Aja(a,b){a=a|0;b=b|0;Cf(a,b+36|0)}function $k(a){gb(a+36|0);Ud(a+24|0);ol(a)}function zn(a,b,c){return l[b>>1]<l[c>>1]}function zc(a,b){return j[a>>2]+p(b,24)|0}function zA(a){return(k[a+24|0]&16)>>>4|0}function yy(a,b){return j[a>>2]+p(b,20)|0}function yr(a,b,c){return i[b>>1]<i[c>>1]}function xm(a){return j[j[a+48>>2]+12>>2]}function vZ(a,b){a=a|0;b=b|0;Cf(a,b+16|0)}function te(a,b){return j[a>>2]+p(b,52)|0}function tc(a){return j[a+4>>2]-j[a>>2]|0}function r6(a,b){a=a|0;b=b|0;eF(a-88|0,b)}function lL(a){j[a>>2]=j[a>>2]-4;return a}function jl(a,b){return j[a>>2]+p(b,56)|0}function je(a){j[a>>2]=j[a>>2]+2;return a}function hc(a,b){a=a|0;b=b|0;Rn(a,b+28|0)}function fn(a){return l[a+480190>>1]<3999}function cM(a){j[a>>2]=j[a>>2]-2;return a}function ad(a,b){return j[a>>2]+p(b,12)|0}function aP(a,b){return Ln(a,zb(b),nb(b))}function Zr(a,b,c){return rwa(b,c)>>>31|0}function ZI(a,b){gl(a,o[b>>3],-o[b+8>>3])}function XF(a,b){a=a|0;b=b|0;Cf(a,b+12|0)}function Vl(a,b,c){Yh(a,b,b+c|0);return a}function PG(a){a=a|0;Ab(a+4296|0,0,81928)}function OP(a,b){return j[a>>2]+p(b,33)|0}function Lv(a){a=a|0;gr(a+8|0);return a|0}function Kk(a){a=a|0;return KD(j[a>>2])|0}function Kha(a){a=a|0;OR(a,80,150,80,255)}function Kea(a){a=a|0;return j[a+4260>>2]}function K6(a,b){a=a|0;b=b|0;uF(a-88|0,b)}function Jn(a,b){return j[a>>2]-j[b>>2]|0}function J6(a,b){a=a|0;b=b|0;tF(a-88|0,b)}function J5(a){a=a|0;if(a){TE(a);Fd(a,a)}}function Id(a){j[a>>2]=j[a>>2]+4;return a}function Hu(a){a=a|0;IY(a+8|0);return a|0}function Fq(a){a=a|0;og(a+8|0);return a|0}function Cd(a,b){j[a>>2]=j[b>>2];return a}function Bq(a){a=a|0;og(a+4|0);return a|0}function Al(a,b){return j[a>>2]+(b<<11)|0}function $I(a,b,c){return Dla(b,c)>>>31|0}function yJa(a,b){a=a|0;b=b|0;Cc(a,b,44)}function yH(a){return(k[a+24|0]&8)>>>3|0}function xb(a,b){return j[a>>2]+(b<<2)|0}function xKa(a,b){a=a|0;b=b|0;Cc(a,b,11)}function wpa(a){a=+a;return ppa(zd(a))|0}function wk(a,b){return j[a>>2]+(b<<3)|0}function wc(a,b){return j[a>>2]+p(b,6)|0}function vDa(a,b){a=a|0;b=b|0;Cc(a,b,17)}function vC(){td(463328);j[115832]=68072}function ub(a){j[j[a>>2]+4>>2]=j[a+4>>2]}function uZ(a,b){a=a|0;b=b|0;Db(a,64912)}function uC(){td(463360);j[115840]=68568}function tha(a){a=a|0;return k[a+4201|0]}function tZ(a,b){a=a|0;b=b|0;Ju(a,64920)}function tC(){td(463368);j[115842]=68732}function sha(a){a=a|0;return k[a+4202|0]}function sC(){td(463376);j[115844]=68896}function rZ(a,b){a=a|0;b=b|0;Db(a,64940)}function rG(a){return(zb(a)+nb(a)|0)-1|0}function rC(){td(463384);j[115846]=69060}function qZ(a,b){a=a|0;b=b|0;Ju(a,64948)}function qC(){td(463456);j[115864]=69224}function mf(a){a=a|0;return!j[a+16>>2]|0}function lg(a,b){j[a+8>>2]=b|-2147483648}function kza(a,b){a=a|0;b=b|0;Cc(a,b,10)}function kr(a,b){j[a+24>>2]=j[a+24>>2]+b}function gB(a,b){Ib(a,b);Ib(a+4|0,b+4|0)}function el(a,b){return j[a>>2]==j[b>>2]}function eB(a){j[a+4>>2]=0;j[a>>2]=70760}function bea(a){a=a|0;return(a|0)==277|0}function bc(a,b){return j[a>>2]+(b<<1)|0}function Xc(a){return j[a>>2]==j[a+4>>2]}function Vz(a,b){return j[a>>2]+(b<<5)|0}function Saa(a){a=a|0;bG(a,2);return a|0}function P6(a){a=a|0;return Lv(a-88|0)|0}function Ns(a){a=a|0;return j[a>>2]+14|0}function Mf(a){a=a|0;return Ld(k[a|0])|0}function Laa(a){a=a|0;bG(a,8);return a|0}function Kj(a){return l[xm(a)+480188>>1]}function Jk(a){return(a|0)==32|a-9>>>0<5}function I6(a,b){a=a|0;b=+b;sF(a-88|0,b)}function Hm(a){a=a|0;return MK(k[a|0])|0}function G6(a,b){a=a|0;b=+b;qF(a-88|0,b)}function E6(a,b){a=a|0;b=+b;nF(a-88|0,b)}function Bn(a){return p(Pp(a),be(a))&255}function $b(a,b){return j[a>>2]+(b<<4)|0}function zLa(a,b){a=a|0;b=b|0;i[b>>1]=0}function ura(a,b){a=a|0;b=b|0;gl(b,0,0)}function uea(a){a=a|0;return-2013527448}function uH(a,b){return n[a>>2]<n[b>>2]}function tca(a){a=a|0;return j[a+16>>2]}function rd(a,b){return m[a>>2]<m[b>>2]}function pt(a,b){return j[a>>2]<j[b>>2]}function mA(a,b){a=a|0;b=b|0;return b|0}function kt(a){a=a|0;return pz(Yb(a))|0}function ih(a,b,c){Mc(a,b);Mc(a+12|0,c)}function hP(a,b){j[a>>2]=j[a>>2]+(b<<2)}function dy(a,b,c){if(b){Ab(a,gg(c),b)}}function _h(a){j[a+4>>2]=0;j[a+8>>2]=-1}function SC(a,b){a=a|0;b=b|0;gj(a,1,45)}function RC(a,b){a=a|0;b=b|0;$C(a,1,45)}function Oya(a,b){a=a|0;b=b|0;Cc(a,b,5)}function Jt(a,b){a=a|0;b=b|0;Cc(a,b,32)}function Js(a){a=+a;return RCa(zd(a))|0}function HK(a,b){return(Vj(a,b)|0)!=255}function Fd(a,b){if(!j[a+80>>2]){Fb(b)}}function AQ(a,b){j[a>>2]=j[a>>2]+p(b,6)}function $J(a,b){return o[a>>3]<o[b>>3]}function zQ(a,b){a=a|0;b=b|0;Fr(a,0,b)}function uta(a,b){a=a|0;b=b|0;lta(a,b)}function ufa(a){a=a|0;return-284078960}function q_(a){a=a|0;yY(j[j[a>>2]>>2])}function nwa(a){a=a|0;LM(a);return a|0}function nra(a,b){a=a|0;b=b|0;mra(a,b)}function nfa(a){a=a|0;return-281111764}function lU(a){a=a|0;return j[a+24>>2]}function lEa(a){a=a|0;return k[a+40|0]}function jk(a){return p(j[a>>2],Bn(a))}function ifa(a){a=a|0;return-271958638}function hM(a,b){j[a+4>>2]=b;j[a>>2]=b}function hB(a,b){LB(a,b);j[a>>2]=71692}function csa(a){a=a|0;Vra();return a|0}function cc(a){j[j[a+8>>2]>>2]=j[a>>2]}function cA(a){hb(a);return 2147483647}function be(a){return k[a+34|0]&64?2:1}function _da(a,b){a=a|0;b=b|0;return 2}function Zea(a){a=a|0;return-620920304}function Vv(a,b){j[a+4>>2]=j[a+4>>2]|b}function Tra(a){a=a|0;Sra();return a|0}function TF(a){return a?(a|0)==2?3:2:1}function SHa(a,b){a=a|0;b=b|0;qHa(b,a)}function Qfa(a){a=a|0;return-270114148}function Pr(a){return(a|0)<=-1?0-a|0:a}function Ni(a,b){return zb(a)+(b<<2)|0}function Mr(a){a=a|0;return 2147483647}function Mma(a,b){a=a|0;b=b|0;Ala(a,b)}function MFa(a){a=a|0;return q(KFa(a))}function Lea(a){a=a|0;return-275227023}function Ld(a){return(a-1&255)>>>0<120}function K9(a){a=a|0;return+o[a+16>>3]}function K3(a){a=a|0;return j[a+20>>2]}function Iga(a){a=a|0;return 542066252}function IU(a){a=a|0;return j[a+12>>2]}function H6(a){a=a|0;return+rF(a-88|0)}function F6(a){a=a|0;return+pF(a-88|0)}function Eza(a,b){a=a|0;b=b|0;sza(b,a)}function Dfa(a){a=a|0;return-285139079}function D6(a){a=a|0;return+mF(a-88|0)}function Bea(a){a=a|0;return 302837129}function Aba(a,b){a=a|0;b=b|0;wba(a,b)}function $da(a,b){a=a|0;b=b|0;return 3}function wt(a,b){a=a|0;b=b|0;BLa(b,a)}function wF(a){j[a>>2]=84616;return a}function vM(a){a=a|0;lO(a);return a|0}function tga(a,b,c){a=a|0;b=b|0;c=c|0}function rw(a,b){a=a|0;b=b|0;return 1}function rn(a,b){a=a|0;b=b|0;FLa(b,a)}function qz(a){a=a|0;return j[a+8>>2]}function qt(a){return(k[a+16|0]&5)!=0}function qe(a){return k[a+11|0]>>>7|0}function ot(a){a=a|0;return j[a+4>>2]}function og(a){a=a|0;gv(a);return a|0}function o4(a){a=a|0;return hE(a,0)|0}function n4(a){a=a|0;return hE(a,1)|0}function kA(a){return k[a+22|0]>>>7|0}function j4(a){a=a|0;return eE(a,0)|0}function iv(a){a=a|0;kq(a);return a|0}function i4(a){a=a|0;return eE(a,1)|0}function gn(a,b){i[a+8>>1]=b;return a}function gga(a,b){a=a|0;b=b|0;gs(a,b)}function gIa(a){a=a|0;return k[a+8|0]}function dp(a){a=a|0;Ms(a);return a|0}function ck(a){a=a|0;Ws(a);return a|0}function cCa(a){a=a|0;return ABa(a)|0}function bg(a,b){a=a|0;b=b|0;oMa(a,b)}function _ta(a){a=a|0;return Uta(a)|0}function Zu(a){a=a|0;if(qD(a)){Fb(a)}}function ZF(a){return l[a+1074438>>1]}function Uy(a,b){a=a|0;b=b|0;PEa(a,b)}function Ty(a){return j[a+1304496>>2]}function TB(a,b){return k[a|0]<k[b|0]}function Rna(a){a=a|0;return Lna(a)|0}function RD(a,b){return DD(a)^DD(b)^1}function RB(a){return fY(zb(a),nb(a))}function Ps(a){a=a|0;return yb(a,1)^1}function Pp(a){return h[a+34|0]&1?2:1}function Ox(a,b,c,d,e){jua(a,b,c,d,e)}function LD(a,b){return CD(a)^CD(b)^1}function JMa(a,b,c){return EMa(a,b,c)}function It(a){return k[a+21|0]>>>7|0}function HO(a,b){if(!bBa(a,b)){BO(b)}}function HG(a,b){a=a|0;b=b|0;return 0}function Gq(a,b){a=a|0;b=b|0;return-1}function Ee(a,b){j[a+4>>2]=b;return a}function Eb(a){return Vz(a,k[a+16|0])}function ED(a){a=a|0;iv(a);return a|0}function Bt(a,b){a=a|0;b=b|0;iMa(b,a)}function zg(a){return j[a+4>>2]-32|0}function xs(a){return j[hb(a)>>2]<<5}function xZ(a){a=a|0;return h[a+8|0]}function ws(a,b){a=a|0;b=b|0;Cf(a,b)}function wZ(a){a=a|0;return h[a+9|0]}function vw(a,b){sb(a);iQ(a,b);yg(a)}function vla(a){a=a|0;return lh(a)|0}function uj(a,b){a=a|0;b=b|0;Q0(a,b)}function rm(a,b){a=a|0;b=b|0;iY(a,b)}function rR(a,b){tc(a);QS(a,b);ap(a)}function oxa(a,b){a=a|0;b=b|0;mxa(b)}function jt(a){return j[a+4>>2]-24|0}function hQ(a,b){sb(a);VL(a,b);yg(a)}function gKa(a){a=a|0;return up(a)|0}function fM(a,b){de(a);aM(a,b);hu(a)}function dKa(a){a=a|0;return Tp(a)|0}function aO(a,b){a=a|0;b=b|0;Pt(a,b)}function aKa(a){a=a|0;return xz(a)|0}function _F(a){return j[a+4>>2]-48|0}function Yea(a){a=a|0;j[a+4224>>2]=0}function XFa(a){a=a|0;return Ty(a)|0}function WF(a){return j[a+4>>2]-12|0}function Vy(a,b){Lf(a);fQ(a,b);UP(a)}function Sn(a,b){a=a|0;b=b|0;P0(a,b)}function Rc(a,b){return Al(a+12|0,b)}function Pya(a){a=a|0;return U8(a)|0}function Ot(a,b){tc(a);sA(a,b);ap(a)}function NG(a){j[a>>2]=0;j[a+4>>2]=0}function MN(a){return j[a+4>>2]-56|0}function MK(a){return(a+5&255)>>>0<2}function Lt(a,b){sb(a);fA(a,b);yg(a)}function Ll(a){j[a+4>>2]=j[a+4>>2]+1}function FS(a,b){a=a|0;b=b|0;ES(a,b)}function DBa(a,b){a=a|0;b=b|0;CBa(b)}function Cp(a,b){Yb(a);iT(a,b);Bp(a)}function Bqa(a){a=a|0;return jj(a)|0}function Aw(a,b,c){return Mja(a,b,c)}function AI(a,b){df(a);BJ(a,b);wI(a)}function yc(a,b){j[a>>2]=b;return a}function xM(a,b){return So(a,0-b|0)}function we(a){return j[a+24620>>2]}function wT(a){a=a|0;return sT(a)|0}function wA(a){a=a|0;return Of(a)|0}function qY(a){a=a|0;return ue(a)|0}function qP(a){a=a|0;return Ns(a)|0}function oLa(a,b){a=a|0;b=b|0;zh(b)}function nA(a){return k[a+21|0]&127}function mi(a,b){return p(b,12)+a|0}function lA(a){return k[a+22|0]&127}function kh(a,b,c){if(c){Vb(a,b,c)}}function i9(a){a=a|0;return qt(a)|0}function fc(a,b){return j[a>>2]+b|0}function eA(a){h[a+2|0]=0;i[a>>1]=0}function dW(a){a=a|0;return hf(a)|0}function cra(a,b){a=a|0;b=b|0;Vd(b)}function bn(a,b,c){return zn(a,b,c)}function aA(a){a=a|0;return Yz(a)|0}function Yqa(a,b){a=a|0;b=b|0;zs(b)}function VDa(a,b){a=a|0;b=b|0;HP(b)}function Ti(a){return j[a+4>>2]-4|0}function Ss(a){a=a|0;return Sg(a)|0}function Qr(a){return Bo(a)<<24>>24}function Pe(a,b,c){return ez(a,b,c)}function Mb(a){return Qe(j[a+4>>2])}function M4(a){a=a|0;return u8(a)|0}function LU(a){a=a|0;return dd(a)|0}function Ksa(a,b){a=a|0;b=b|0;hl(b)}function KB(a){a=a|0;return j[a>>2]}function Il(a,b,c){if(c){Ci(a,b,c)}}function Hqa(a,b){a=a|0;b=b|0;Lm(b)}function Gya(a,b){a=a|0;b=b|0;ey(b)}function Gma(a,b){a=a|0;b=b|0;$k(b)}function GC(a,b){zl(j[a>>2],h[b|0])}function Ema(a,b){a=a|0;b=b|0;Kf(b)}function DW(a){a=a|0;return YF(a)|0}function DAa(a){a=a|0;return+AAa(a)}function Cv(a){return!_c(a,84692,6)}function zV(a,b){a=a|0;b=b|0;xV(b)}function xS(a,b){a=a|0;b=b|0;jb(b)}function uD(a,b){a=a|0;b=b|0;qb(b)}function tq(a,b){a=a|0;b=b|0;Le(a)}function td(a){eB(a);j[a>>2]=65268}function sj(a,b){a=a|0;b=b|0;Cb(a)}function rq(a){td(a);j[a>>2]=65736}function pm(a,b){j[a+1304560>>2]=b}function o6(a,b){a=a|0;b=b|0;Fb(b)}function nh(a,b){Cc(a,zb(b),nb(b))}function mg(a,b){j[a>>2]=j[a>>2]|b}function ln(a,b){a=a|0;b=b|0;Re(b)}function jr(a){return ce(a,-1)?0:a}function Xj(a,b){vn(a,b,j[b+4>>2])}function XK(a,b,c){Zoa(a,b-a>>2,c)}function Uh(a){a=a|0;h[a+4202|0]=0}function Tx(a,b){a=a|0;b=b|0;os(b)}function Sg(a){return j[a>>2]+16|0}function Ry(a,b){a=a|0;b=b|0;Rs(b)}function Rr(a,b){return a<<8|b}



function Qs(a,b){a=a|0;b=b|0;Dz(b)}function Ph(a){return Xc(a+36|0)^1}function PW(a,b){a=a|0;b=b|0;wC(b)}function PA(a,b){a=a|0;b=b|0;El(b)}function Oz(a){h[a|0]=0;h[a+1|0]=0}function OC(a){return Fg(a,461768)}function NC(a){return Fg(a,461760)}function Kv(a){a=a|0;h[a+6152|0]=0}function KC(a){return Fg(a,461784)}function JC(a){return Fg(a,461776)}function Ey(a,b){a=a|0;b=b|0;Oe(b)}function EW(a){a=a|0;nn(a,1,10956)}function CV(a,b){a=a|0;b=b|0;cu(b)}function CT(a,b){a=a|0;b=b|0;eA(b)}function Bk(a){sm(a);j[a>>2]=71324}function Bc(a,b){os(a);yc(a+4|0,b)}function AS(a,b){a=a|0;b=b|0;Oz(b)}function $h(a,b){return(b<<13)+a|0}function yf(a){j[a>>2]=j[a>>2]+16}function vS(a,b){return Gz(a,b,7)}function uS(a){return k[a+1|0]==1}function tl(a,b){He(a,b);return a}function se(a){return j[Rb(a)>>2]}function sS(a,b){return tn(a,b,7)}function qi(a){j[a>>2]=1;return a}function oy(a,b){Mc(a,b);return a}function nN(a,b){return Gz(a,b,4)}function mj(a,b,c){T_(a+24|0,b,c)}function me(a){return df(a)&65535}function jDa(a){a=a|0;Hy(a);Fb(a)}function hza(a){a=a|0;tP(a,65535)}function hn(a){j[a>>2]=2;return a}function gk(a){j[a>>2]=j[a>>2]+24}function fl(a){i[a>>1]=0;return a}function dk(a){j[a>>2]=0;return a}function dDa(a){a=a|0;Gy(a);Fb(a)}function cr(a,b,c,d){bua(a,b,c,d)}function cn(a){j[a>>2]=j[a>>2]+12}function aw(a,b){return eJ(a,b)^1}function Y2(a){a=a|0;return 58952}function Xs(a,b){return Dd(a,b)^1}function Vm(a,b,c,d){eua(a,b,c,d)}function Uv(a){return a+1304500|0}function Ub(a,b){return zb(a)+b|0}function St(a){return h[a+24|0]&1}function S3(a){a=a|0;return 58224}function Q3(a){a=a|0;return 58304}function Nc(a,b){return(b<<1)+a|0}function Nba(a){a=a|0;cw(a);Fb(a)}function Lb(a){return Qe(j[a>>2])}function KO(a,b){return tn(a,b,5)}function Jx(a){j[a>>2]=j[a>>2]+32}function Jg(a){return a-48>>>0<10}function IX(a){a=a|0;return 71299}function HX(a){a=a|0;return 71336}function Em(a){return a+1074324|0}function EX(a){a=a|0;return 71848}function EO(a,b){return(b<<4)+a|0}function Cr(a,b,c){nka(a,b-a|0,c)}function Bm(a){xg(a+4|0);return a}function Ax(a){j[a>>2]=j[a>>2]+52}function Ae(a,b){return(b<<2)+a|0}function AH(a){return a+1074328|0}function zu(a){a=a|0;Au(a);Fb(a)}function zG(a){a=a|0;dw(a);Fb(a)}function yk(a){Ah(a);Zc(a);Ah(a)}function ye(a,b){j[a>>2]=j[b>>2]}function xp(a){Yb(a);HS(a);Bp(a)}function vz(a,b){return sJa(a,b)}function ux(a){h[a|0]=0;return a}function uP(a,b){Vb(a,b+4|0,256)}function tt(a,b){return GKa(a,b)}function sz(a){li(a);xR(a);vR(a)}function sh(a){Be(a);pd(a);Be(a)}function rk(a){Df(a);Yb(a);Df(a)}function qp(a){return Ab(a,0,48)}function ph(a){return lpa(Rd(a))}function pQ(a,b){return HEa(a,b)}function pC(a){Dk(a);sb(a);Dk(a)}function mN(a){return k[a|0]<129}function lw(a,b){return Bga(a,b)}function lk(a){j[a>>2]=j[a>>2]+6}function lK(a){return yoa(Rd(a))}function iE(a){a=a|0;Nk(a);Fb(a)}function hR(a){rl(a);li(a);rl(a)}function fE(a){a=a|0;Yn(a);Fb(a)}function du(a){a=a|0;kq(a);Fb(a)}function cz(a,b){return iCa(a,b)}function ct(a){ki(a);Lf(a);ki(a)}function cq(a){de(a);kB(a);hu(a)}function bs(a){sb(a);eM(a);yg(a)}function bi(a){return Yta(Rd(a))}function bK(a,b){return boa(a,b)}function aH(a){a=a|0;iw(a);Fb(a)}function _H(a){Te(a);RH(a);QH(a)}function Zj(a){return LBa(zd(a))}function ZO(a){_o(a);_o(a);TO(a)}function YH(a){sb(a);OH(a);yg(a)}function Xr(a){tc(a);WS(a);ap(a)}function Xf(a){j[a>>2]=j[a>>2]+1}function Wh(a){sb(a);jQ(a);yg(a)}function Vk(a,b){return Efa(a,b)}function TR(a){Yb(a);LR(a);Bp(a)}function PX(a,b){a=a|0;b=b|0;z()}function NP(a){nl(a);$j(a);nl(a)}function Li(a){Vf(a);ec(a);Vf(a)}function LH(a){Ij(a);Te(a);Ij(a)}function Hj(a){a=a|0;Ke(a);Fb(a)}function HN(a){Xm(a);Wj(a);Xm(a)}function Gl(a){Zg(a);de(a);Zg(a)}function GP(a){sb(a);FP(a);yg(a)}function GI(a){Lf(a);gQ(a);UP(a)}function EQ(a,b){return qCa(a,b)}function Dp(a){Af(a);tc(a);Af(a)}function DJ(a){Pi(a);df(a);Pi(a)}function Cx(a){j[a>>2]=j[a>>2]+8}function Br(a){return HJ(k[a|0])}function $p(a){xi(a);fg(a);xi(a)}function $e(a){jd(a);sb(a);jd(a)}function $c(a){return j[a>>2]!=0}function wd(a,b){return Al(a,b)}function uq(a){a=a|0;return 127}function tm(a){return a<<24>>24}function si(a,b,c){Ge(a,c,13,b)}function ro(a){i[a+480214>>1]=0}function rh(a){return de(a)&255}function re(a,b){return Ff(a,b)}function qj(a,b,c){Cc(a,b,1<<c)}function pk(a,b){return _z(a,b)}function pJ(a,b){return mJ(a,b)}function mu(a){ZV(a,bD(ue(12)))}function hl(a){gb(a+12|0);ff(a)}function ei(a,b){return Vz(a,b)}function bO(a,b){return ci(b,a)}function am(a,b){return m1(a,b)}function aC(a,b){return GY(a,b)}function Yd(a,b){return U4(a,b)}function XY(a){a=a|0;gb(461988)}function VY(a){a=a|0;pc(462004)}function Uc(a,b){return uT(a,b)}function Td(a){a=a|0;return a|0}function TY(a){a=a|0;gb(462020)}function Ri(a){return!j[a+4>>2]}function Rfa(a){a=a|0;Fb(iw(a))}function RY(a){a=a|0;pc(462036)}function Qm(a){return Xi(zd(a))}function PY(a){a=a|0;gb(462052)}function O6(a){a=a|0;vF(a-88|0)}function Nu(a,b){return Ze(a,b)}function NY(a){a=a|0;pc(462068)}function Lm(a){gb(a+12|0);gb(a)}function LY(a){a=a|0;gb(462084)}function Kda(a){a=a|0;Fb(lr(a))}function Jea(a){a=a|0;return 13}function JY(a){a=a|0;pc(462100)}function Is(a,b){return fP(a,b)}function Ie(a){gb(a+20|0);gb(a)}function Hb(a,b){return te(a,b)}function Gp(a,b){return Zz(a,b)}function Eba(a){a=a|0;Fb(dw(a))}function Co(a){Ud(a+12|0);tL(a)}function Ch(a,b){return a>>>b&1}function $z(a,b){return tT(a,b)}function zZ(a){a=a|0;Fb(fC(a))}function yZ(a){a=a|0;Fb(eC(a))}function xx(a,b){return b-a>>1}function x_(a){a=a|0;Fb(mC(a))}function x8(a){a=a|0;Fb(RF(a))}function vt(a){OLa(a);return a}function vF(a){a=a|0;Fb(Lv(a))}function s8(a){a=a|0;Fb(OF(a))}function oJ(a,b,c){yx(a,b,c,1)}function jp(a){mGa(a);return a}function iH(a){a=a|0;Fb(jH(a))}function gy(a){Uya(a);return a}function fv(a){a=a|0;Fb(Fq(a))}function fP(a,b){return b-a>>2}function e_(a){a=a|0;Fb(jC(a))}function dC(a){a=a|0;Fb(Hu(a))}function cv(a){a=a|0;Fb(Bq(a))}function bH(a){a=a|0;Fb(cH(a))}function aF(a){return a>>>0>16}function _D(a){a=a|0;Fb(og(a))}function ZU(a){a=a|0;Fb(LA(a))}function XZ(a){a=a|0;Fb(CC(a))}function VU(a){a=a|0;Fb(Wt(a))}function VG(a){a=a|0;Fb(WG(a))}function V2(a){a=a|0;Fb(ED(a))}function Tr(a){return a>>>27^a}function T2(a){a=a|0;Fb(gv(a))}function Sd(a,b){h[a|0]=k[b|0]}function SH(a){a=a|0;Fb(TH(a))}function Nb(a,b){j[a+100>>2]=b}function MB(){return(Ga()|0)>0}function M3(a){a=a|0;Fb(iv(a))}function Ky(a){hEa(a);return a}function KM(a){return a+4896|0}function Jxa(a){a=a|0;return 9}function Jj(a){eja(a);return a}function JG(a){a=a|0;Fb(Hd(a))}function J3(a){a=a|0;Fb(Nk(a))}function Ic(a,b){cY(a,b,oD(b))}function I8(a){a=a|0;Fb(hr(a))}function Hw(a){Aka(a);return a}function GX(a){a=a|0;Fb(Au(a))}function FX(a){a=a|0;Fb(kq(a))}function FF(a){a=a|0;Fb(Xe(a))}function F3(a){a=a|0;Fb(Yn(a))}function DH(a){a=a|0;Fb(EH(a))}function Cfa(a){a=a|0;return 6}function CH(a){qga(a);return a}function Bba(){return 19466242}function BH(a){pga(a);return a}function $v(a){Qaa(a);return a}function yv(a){B4(a);return a}function vP(a){a=a|0;return 7}function un(a){return a>>>0<5}function uh(a){return Xc(a)^1}function tk(a){return!j[a>>2]}function ri(a){bA(a);return a}function qn(a){Pz(a);return a}function ps(a){return a+256|0}function mS(a,b,c){FKa(a,b,c)}function lp(a){TS(a);return a}function jW(a){a=a|0;return 3}function hx(a){Wm(a);return a}function gx(a){HA(a);return a}function gT(a,b){return b-a|0}function dq(a){a=a|0;return 4}function dj(a,b,c){hMa(a,b,c)}function dN(a){sxa(a,j[a>>2])}function bD(a){j1(a);return a}function ae(a){a=a|0;return 1}function _k(a,b){j[a+32>>2]=b}function Zq(a,b,c){Gfa(a,b,c)}function XD(a){a=a|0;return-1}function Ws(a){dk(a);return a}function Wm(a){Px(a);return a}function Vi(a){return $c(a)^1}function UI(a){a=a|0;return 5}function Sb(a){a=a|0;return 0}function SI(a){xka(a,j[a>>2])}function Rt(a){Qt(a);return a}function Rh(a){return ac(a,1)}function RM(a){wwa(a,j[a>>2])}function Pb(a,b){return a+b|0}function Om(a,b){j[a+36>>2]=b}function Ng(a){cL(a);return a}function Lq(a,b){j[a+72>>2]=b}function LR(a){wJa(a,j[a>>2])}function Kw(a,b,c){zfa(a,b,c)}function Iz(a,b,c){Ufa(a,b,c)}function Fe(a,b){i[a+28>>1]=b}function FN(a){Rya(a,j[a>>2])}function EM(a,b){Ab(a,0,b<<2)}function Dy(a,b,c){SCa(a,b,c)}function $d(a){a=a|0;return 2}function yC(a){ZB(a,j[a>>2])}function xR(a){lR(a,j[a>>2])}function xF(a){j[a>>2]=84592}function wS(a,b){Af(a);Af(a)}function vp(a){j[a>>2]=76752}function uI(a,b){Pi(a);Pi(a)}function tA(a){sA(a,j[a>>2])}function sm(a){j[a>>2]=71360}function rT(){E2();y4();dJ()}function oo(a,b){n[a+8>>2]=b}function ns(a,b){Yx(a,ud(b))}function nq(a){return a+16|0}function mo(a,b){n[a+4>>2]=b}function lu(a,b){jB(a,ud(b))}function lt(a,b){Be(a);Be(a)}function lq(a,b,c){Cc(a,b,c)}function lo(a,b){h[a+36|0]=b}function kL(a){jL(a,j[a>>2])}function kG(a){j[a>>2]=83840}function kB(a){DV(a,j[a>>2])}function jQ(a){iQ(a,j[a>>2])}function jM(a,b){hM(a,Mb(b))}function il(a,b){hb(b);hb(a)}function iM(a,b){hM(a,Lb(b))}function iK(a){hK(a,j[a>>2])}function gt(a,b){ki(a);ki(a)}function gc(a,b){a=a|0;b=b|0}function gQ(a){fQ(a,j[a>>2])}function gD(a,b,c){_1(a,b,c)}function ee(a,b){j[a+4>>2]=b}function eM(a){VL(a,j[a>>2])}function dr(a){j[a>>2]=84120}function bM(a){aM(a,j[a>>2])}function an(a,b){j[a+8>>2]=b}function Yp(a,b){Zg(a);Zg(a)}function Wn(a,b){Vf(a);Vf(a)}function WS(a){QS(a,j[a>>2])}function VO(a,b,c){mw(a,b,c)}function Ue(a,b){h[a+11|0]=b}function SG(a){j[a>>2]=59064}function RH(a){MH(a,j[a>>2])}function Pw(a,b){h[a+37|0]=b}function Pl(a,b){Ah(a);Ah(a)}function Pj(a,b){jd(a);jd(a)}function Ow(a,b){h[a+38|0]=b}function Ob(a){return a+12|0}function OH(a){JH(a,j[a>>2])}function Nt(a,b){Df(a);Df(a)}function NJ(a){return a+80|0}function Kq(a,b){Rn(a,b+4|0)}function KF(a){j8(a,j[a>>2])}function IN(a,b){Ge(a,b,8,2)}function HS(a){iT(a,j[a>>2])}function FP(a){fA(a,j[a>>2])}function Ek(a){return a+32|0}function Cba(){return 327687}function CJ(a){BJ(a,j[a>>2])}function Ag(a){return a+20|0}function $t(a,b){xi(a);xi(a)}function $B(a,b){Dk(a);Dk(a)}function zIa(){return 65535}function yo(a,b,c){toa(b,c)}function xe(a,b,c){usa(b,c)}function wo(a){Ab(a,0,8192)}function pn(a,b,c){vLa(b,c)}function pi(a){return a+3|0}function pE(){Di(55708);z()}function mT(a,b){Cc(a,b,20)}function jg(){oc(70892);z()}function iza(){return 65534}function hb(a){return a+8|0}function hA(a,b){Cc(a,b,22)}function gg(a){return a&255}function gR(a,b,c){rIa(b,c)}function ft(a,b,c){AIa(b,c)}function ej(a,b){h[a+3|0]=b}function _x(a){j[a+12>>2]=0}function Xw(a,b,c){Hma(b,c)}function WJ(a){Ab(a,0,1024)}function Vo(a){Ab(a,0,4096)}function Sl(){Di(70892);z()}function Rb(a){return a+4|0}function Pc(a){return a+1|0}function Oc(){oc(55708);z()}function LX(){return 463740}function KH(a,b,c){fha(b,c)}function JP(a,b,c){RDa(b,c)}function Ec(a){return!nb(a)}function Cs(a,b,c){WAa(b,c)}function Bf(a){return a+2|0}function BE(){return 458416}function $o(a,b,c){ECa(b,c)}function $i(a,b,c){gFa(b,c)}function zB(a){Ah(a);Zc(a)}function z2(){return 60540}function yn(a,b,c){YT(b,c)}function yg(a){jd(a);sb(a)}function yW(a){a=a|0;xk(a)}function xg(a){Dp(a);jT(a)}function xC(a){Dk(a);sb(a)}function x2(){return 61312}function wb(a){Kl(j[a>>2])}function wI(a){Pi(a);df(a)}function w2(){return 62864}function vR(a){rl(a);li(a)}function uc(a){a=a|0;Fb(a)}function rs(a){Vf(a);ec(a)}function rf(a){$p(a);Bx(a)}function rc(a){j[a+8>>2]=0}function qQ(a){h[a+31|0]=0}function pR(a){ct(a);nR(a)}function ol(a){ct(a);Ts(a)}function no(a,b){n[a>>2]=b}function nQ(a){Oy(a,se(a))}function maa(){return 2048}function lf(a,b){j[a>>2]=b}function kQ(a){Qy(a,se(a))}function ju(a){$p(a);iB(a)}function jK(a){Lr(a,se(a))}function hu(a){Zg(a);de(a)}function gJ(a){Lw(a,se(a))}function ff(a){rk(a);ut(a)}function eh(a,b,c){O2(b,c)}function cy(a,b,c){DN(b,c)}function cp(a){By(a,se(a))}function bp(a){Ay(a,se(a))}function ap(a){Af(a);tc(a)}function _t(a,b,c){gV(b,c)}function Zv(a){yk(a);xG(a)}function Zi(a,b){vn(a,b,0)}function Yg(a,b,c){RA(b,c)}function Yf(a,b,c){$4(b,c)}function YO(a){$e(a);UO(a)}function XN(a){$e(a);VN(a)}function Wo(a){Be(a);pd(a)}function Vc(a){Li(a);DA(a)}function Ud(a){$e(a);ms(a)}function UP(a){ki(a);Lf(a)}function Sx(a){Ab(a,0,512)}function Sj(a){wx(a,se(a))}function Sc(a){yk(a);RS(a)}function QH(a){Ij(a);Te(a)}function Op(a){Dp(a);xA(a)}function Od(a){Dp(a);Np(a)}function Ko(a){yk(a);uL(a)}function JK(a){ix(a,se(a))}function IS(a,b){dj(a,2,b)}function Gf(a,b,c){dB(b,c)}function Et(a,b,c){BT(b,c)}function Bp(a){Df(a);Yb(a)}function BC(a){pC(a);zC(a)}function Ai(a,b,c){xB(b,c)}function q4(a){a=a|0;r4()}function ob(a,b){hBa(a,b)}function oF(a){Ab(a,0,44)}function kX(){return Za|0}function kE(a){Vv(a,8192)}function jX(a){a=a|0;Za=a}function gA(a){h[a+1|0]=3}function bS(a,b){qKa(a,b)}function Rz(a,b){dMa(a,b)}function PO(a,b){xBa(a,b)}function JN(a,b){Qya(a,b)}function HP(a){Ab(a,0,33)}function FO(a,b){nBa(a,b)}function pO(a,b){Bw(a,b)}function os(a){j[a>>2]=0}function nS(a,b){UH(a,b)}function mn(a,b){OD(a,b)}function mL(a,b){iM(a,b)}function lz(a){h[a|0]=16}function lc(a){xg(a+8|0)}function jv(a,b){U3(a,b)}function j$(){rq(463224)}function ch(a,b){Dg(a,b)}function cB(a,b){yc(a,b)}function WL(a,b){cf(a,b)}function Rs(a){gb(a+4|0)}function Re(a){jb(a+8|0)}function Qg(a){a=a|0;z()}function On(a,b){HY(a,b)}function Dh(a,b){G$(a,b)}function Oe(a){h[a|0]=0}function vJ(a){fJ(a,0)}function mc(a){fe(a,0)}function jh(a){sG(a,0)}function bq(a){jB(a,0)}function bf(a){Yx(a,0)}function Kf(a){oQ(a,0)}function Jr(a){SJ(a,0)}function Ir(a){RJ(a,0)}function Gc(a){DG(a,0)}function qb(a){gb(a)}function pe(a){a=a|0}function XS(a){Id(a)}function m$(){E_()}function b$(){vC()}function Y_(){uC()}function W_(){tC()}function U_(){sC()}function R_(){rC()}function N_(){D_()}function L_(){C_()}function J_(){qC()}function JX(){z()}
// EMSCRIPTEN_END_FUNCS
a=k;var bb=NMa([null,ml,Db,Vp,Cf,BMa,nn,$Ha,PGa,Oi,HFa,EEa,kDa,Fr,ml,B3,fV,Dl,eg,A3,Q,Tt,sk,x7,Au,nv,ce,lU,Cl,ti,sga,dc,gc,tb,ti,EJa,rp,FR,Ey,wl,Xz,PCa,Hy,Qg,ae,ae,gIa,_Ha,ot,RHa,IP,MDa,FDa,JX,Gy,Qg,ae,Sb,ae,vFa,rFa,nFa,jFa,dFa,jDa,DEa,dDa,lEa,eEa,Td,Qg,uO,IAa,aO,YN,As,SN,kO,iO,ss,nya,pa,bya,Hc,Hc,Db,tY,Vx,Hwa,zwa,Hc,mva,bva,FM,dc,Nm,Og,Hc,sY,_ta,Hya,Gta,Pta,uta,rta,pe,Moa,gc,csa,FM,zl,Pt,OB,$X,ml,Boa,Mma,qo,zl,bla,Cf,Lka,oC,Uja,Lja,Fja,mfa,cfa,U2,Vea,lja,_ia,Lia,gI,gI,Wha,Gha,tr,Vp,qr,zga,rga,qr,Saa,Laa,zaa,saa,qr,qr,rm,ml,Hd,JG,eea,Yda,Bq,cv,ID,HD,lr,Kda,gc,ml,Bda,Pca,Sb,Sb,I3,Eca,H3,ica,G3,Fba,u3,i9,n8,f8,x3,p3,n3,_v,s3,T7,Xe,FF,F7,w7,Fq,fv,UD,TD,t6,As,k6,h6,WE,Ln,ml,E4,Tq,ws,S4,M4,dc,hv,SD,uD,dc,dc,Xz,su,RW,QW,MW,mX,gc,PW,gc,Ey,zBa,LW,KW,JW,IW,di,GW,A5,t5,FW,sB,rB,EW,Tq,DW,AW,pu,yW,zi,vc,uW,Ol,tW,rW,xW,qW,oW,CW,vBa,zW,qB,nW,mW,pB,lW,kf,jj,xc,aq,yb,bW,ij,aq,XV,WV,UV,kq,zV,yV,Hc,dc,PA,KB,eV,NV,hg,MV,CV,zh,Hc,rV,hg,qV,Hc,gc,dV,aV,hg,$U,ti,du,ot,Td,uc,Dn,HG,KV,uc,JV,ae,ae,ot,qz,IV,IP,HV,GV,Td,uc,Dn,pV,uc,Sb,ae,ae,Sb,Sb,VA,LA,ZU,Dn,YU,Wt,VU,UU,TU,SU,RU,tca,QU,PU,OU,Pn,FU,nla,EU,mla,DU,Tp,Jb,vla,XA,cd,CU,Og,eY,dc,Nm,SA,uD,gc,IA,oU,jU,du,dc,dc,dc,wA,aU,$T,gc,gc,gc,WT,Xz,Ey,su,DT,Og,PT,IT,CT,gc,wA,Dt,wT,aA,vT,tMa,kMa,Tz,Ap,gc,aMa,$S,$La,md,LU,_S,ZLa,dW,Zb,Lc,YLa,XLa,WLa,ZS,YS,VLa,ULa,$f,Jf,Wf,TLa,VS,US,LLa,SS,zp,dc,ALa,Nm,yLa,lb,oT,qc,dc,dc,oLa,dc,zLa,wLa,gc,qLa,Tz,AS,xS,iLa,gLa,fLa,eLa,dLa,wg,cLa,bLa,aLa,_Ka,Wv,OJ,lb,IM,ZKa,tg,YKa,Qz,pS,Tc,od,zi,Qi,QKa,PKa,vi,Vg,EJ,OKa,NKa,Kz,ic,ku,MKa,oS,Pd,Mz,tb,Qo,lb,rp,ST,xKa,Jp,Se,wt,kKa,WR,mB,Zh,gf,vb,rg,iKa,Cz,hKa,vc,gKa,bta,fKa,eKa,Oo,dKa,VR,UR,bKa,aKa,$Ja,Zja,Fp,Ep,Yk,Cw,KI,_Ja,PR,vH,ZJa,YJa,XJa,fk,Bz,WJa,VJa,Jt,NR,UJa,MJa,JR,uO,KJa,yJa,dc,wz,wz,vJa,aO,YN,As,SN,ln,tp,sp,dc,gc,ss,lJa,kJa,jJa,bJa,zz,aJa,rz,ef,$Ia,_Ia,ZIa,kt,YIa,Po,Qx,XIa,WIa,VIa,UIa,zf,Mf,NIa,MIa,LIa,vIa,uIa,pIa,sp,FIa,EIa,rp,dt,oR,IIa,dc,dc,CIa,gc,su,ln,gc,_i,np,fIa,_s,eIa,YHa,WR,mp,XHa,$s,Rx,VR,WHa,sn,VHa,UHa,bR,Nf,THa,SHa,rE,rn,Ds,QHa,uAa,NR,PHa,MHa,ug,YQ,ln,tp,sp,dc,vHa,uHa,YQ,PQ,NI,lka,Fw,KQ,$Ga,_Ga,vh,OGa,NGa,Wma,KGa,JGa,IGa,HGa,Kt,GGa,FGa,EGa,kf,GT,DGa,lwa,mwa,CGa,BGa,TGa,en,JT,AGa,Ro,HT,DQ,yGa,xGa,Ena,Lc,wGa,vGa,bz,uGa,yMa,tGa,sGa,rGa,BQ,qGa,$x,pGa,oGa,FT,zR,QGa,nGa,zQ,iGa,_y,iO,rA,Hp,eGa,dGa,om,Nma,cGa,bGa,xQ,xQ,Zy,uQ,Wy,Gk,ZFa,B_,YFa,XFa,WFa,VFa,Tg,Zsa,Tg,yja,UFa,fia,sQ,dc,ZEa,aq,dn,MFa,UEa,FS,Nn,Yh,dc,YP,TEa,SEa,rQ,SFa,RFa,cf,QFa,hi,Ss,gia,$ma,Uha,OFa,Vp,EFa,DFa,CFa,Hc,ck,Hc,Py,Td,mQ,hg,Ry,Td,Ry,gc,lFa,gc,gc,aFa,Og,Qs,YEa,yEa,xEa,wEa,vg,jn,vEa,tEa,lB,sEa,rEa,qEa,pEa,oEa,nEa,mEa,kEa,jEa,dc,yDa,vDa,YDa,XDa,VDa,gc,DP,ln,CP,DDa,dc,wP,en,sDa,rDa,qDa,pDa,Lta,kf,oDa,nDa,mDa,lDa,VQ,uM,rb,Ns,Fy,gz,Tc,aA,hDa,gDa,tP,fDa,Us,pz,eDa,gj,cDa,Vp,kf,Lz,kf,Vt,Bt,bDa,hi,qP,hta,ww,pP,dp,dc,ck,Hc,dc,gc,ICa,Og,Qs,gc,Td,gc,gc,zCa,Tz,AS,tCa,hg,nCa,yi,mCa,lCa,zy,Gs,kCa,jCa,hCa,gCa,fCa,eCa,bT,dCa,cCa,lb,bCa,aCa,$Ba,_Ba,gwa,Sqa,VA,ZBa,lb,Fs,x5,Uy,F5,Fs,YBa,XBa,I5,J5,Oma,WBa,wQ,vQ,yM,di,TBa,SBa,QBa,PBa,dc,Qs,dc,DBa,ti,gc,xS,it,Es,bj,Yh,kf,np,fBa,eBa,wBa,Ps,gc,NAa,pS,kS,MAa,Qma,LAa,KAa,yI,dn,JAa,sO,HAa,GAa,Gt,Ft,Bs,npa,FAa,EAa,js,DAa,yp,CAa,BAa,ky,zt,dc,gc,dAa,cAa,PA,kf,Uza,bg,Tza,Hc,Sza,Rza,cO,Hc,Ip,Qza,Gza,Fza,ek,Rm,Bs,Eza,hka,Cza,WN,dc,Qs,gc,vza,Og,oza,nza,rz,eO,NN,Mz,mza,lza,kza,jza,zIa,iza,hza,gza,vs,fza,eza,vs,dza,aS,KN,cza,MT,dc,Pya,Fya,Cya,np,Xya,Wya,Vya,dc,ln,Oya,tp,sp,Gya,AN,zN,by,dc,pya,en,oya,iya,LM,sO,en,Vqa,Uqa,cya,Sxa,Rxa,ku,Qxa,Pxa,Nxa,Mxa,Lxa,Js,Kxa,Ixa,Hxa,Cxa,yxa,dc,qxa,pxa,fxa,txa,gc,oxa,dc,dc,XO,Ywa,jy,Wwa,Vwa,jta,Rwa,Qwa,_ka,Pwa,Owa,Nwa,Yka,Mwa,Zka,$ka,Lwa,Kwa,Jwa,HW,vB,qta,sy,fna,cna,Ux,Fwa,Ewa,dc,Tx,uwa,Og,gc,MM,owa,ewa,dwa,cwa,bwa,awa,$va,_va,Zva,Yva,Xva,Wva,Vva,Uva,Tva,Sva,Rva,Qva,Pva,Ova,Nva,Mva,Lva,Kva,Jva,Hva,Gva,Fva,Eva,Dva,Cva,Bva,Ava,zva,yva,wva,vva,uva,tva,sva,rva,qva,pva,ova,nva,lva,kva,jva,iva,hva,gva,fva,eva,dva,cva,ava,$ua,_ua,Zua,Yua,Xua,Wua,Vua,Uua,Tua,Rua,Qua,Pua,Oua,Nua,Mua,Lua,Kua,Jua,Iua,Hua,Gua,Fua,Eua,Dua,Cua,Bua,Aua,zua,yua,xua,wua,vua,uua,tua,sua,rua,qua,pua,oua,nua,mua,lua,Wta,Vta,Ita,vM,Ota,ck,Hc,dc,Ap,hg,Lsa,nk,nta,pta,GS,gM,eta,dc,Jsa,ata,YL,Gsa,Ysa,Wsa,Vsa,Usa,Tsa,dM,Qsa,Psa,Osa,Nsa,rQ,gs,Asa,Ksa,_L,dc,ML,Hc,ysa,Hc,esa,dsa,bsa,FL,asa,ES,$ra,KB,Tra,CL,Bla,Ora,Mra,Dr,yla,Kra,xla,wla,Ira,Gra,Era,Bra,wra,vra,dc,dc,Ara,gc,dc,ura,gc,Ui,dc,_qa,Zqa,cra,Yqa,Kv,j6,$r,Rqa,ana,cj,Ata,Lx,Oqa,JR,Ap,Ap,As,pB,ck,Hc,hv,SD,Td,Hqa,hg,dc,$y,Jd,aT,bU,De,HKa,Cqa,Bqa,lb,JIa,Aqa,zqa,yqa,xqa,wqa,vqa,uqa,tqa,sqa,rqa,qqa,pqa,oqa,nqa,mqa,lqa,kqa,jqa,iqa,hqa,gqa,fqa,eqa,dqa,bqa,aqa,$pa,_pa,Zpa,Ypa,Xpa,Wpa,Vpa,Upa,Tpa,Spa,Rpa,Qpa,Ppa,Opa,Npa,Mpa,Lpa,Kpa,Jpa,Ipa,Hpa,Gpa,Fpa,Epa,Dpa,Cpa,Bpa,Apa,zpa,ypa,xpa,wpa,vpa,upa,tpa,spa,jpa,qra,ipa,hpa,gpa,pL,oL,fpa,epa,Hm,Ur,sx,dpa,WK,ls,Ho,VK,sJ,FJ,Uw,Go,Sr,Fo,bpa,QK,BM,$oa,_oa,hi,Ss,dp,LL,ds,qh,hi,qP,Yoa,dp,nra,dc,moa,joa,ck,Hc,Hc,ck,Hc,dc,gc,Td,gc,fK,doa,hg,Td,gc,Xna,hg,Sna,gta,nwa,ZJ,rM,Rna,Xla,Qna,VJ,ue,Hc,Hc,dc,Gna,Ana,gW,NU,HU,rU,wna,pU,MU,fW,GU,mga,tna,dx,lla,dc,psa,dc,Nm,Og,Hc,ena,bna,Tia,gja,Zma,Yia,Mia,Hc,Hc,qy,Xma,wM,dc,dc,Gma,Ema,gc,Twa,Swa,MGa,LGa,kya,jya,Yxa,Xxa,uDa,tDa,$za,_za,AEa,zEa,mKa,lKa,pHa,oHa,kLa,jLa,SKa,RKa,Wza,Vza,rya,qya,bxa,axa,dJa,cJa,iIa,hIa,gMa,fMa,cMa,bMa,qza,pza,Zya,Yya,PAa,OAa,CEa,QP,hHa,gHa,bHa,aHa,nJa,mJa,aIa,ZHa,Jza,Iza,Xka,Wka,Dka,Bka,iBa,gBa,fya,eya,Uxa,Txa,yBa,mBa,kBa,xMa,wMa,sKa,rKa,pCa,oCa,sBa,oBa,Vla,dc,Nm,Og,Nla,ck,Hc,_J,gc,uD,Py,hg,MM,zla,Jw,us,ola,qla,fL,Uka,Tka,rz,Ska,mt,Rka,NN,Qka,Pka,Oka,np,Nka,Mka,kf,Kka,Jka,Ika,Hka,Gka,KN,Fka,q6,m6,l6,dc,ln,tp,sp,gka,fka,dka,YP,Yja,Qja,Tg,Vja,Tja,Tg,Yy,Sja,mf,Dg,Lk,Rja,Jja,Hja,vja,Dja,aka,Cja,pja,oja,zja,Wja,rja,zw,dc,qI,dc,ck,Hc,via,Og,ria,tw,hi,Ss,Via,nma,uia,Jia,Iia,Tg,Hia,Gia,Fia,oI,aja,ko,dM,Eia,cf,mI,Bia,lj,Dg,Tx,mQ,hg,cia,bia,aia,$ha,_ha,Zha,Ei,Vha,bI,Dia,Kia,aI,Qha,Lha,Kha,Jha,Gga,Iha,Hha,PH,pha,NH,Og,lI,lha,cha,jha,gc,Tx,gc,TH,SH,SH,xha,Sb,pe,Sb,Sb,Sb,gc,dq,Bha,Cha,Eha,Dha,Fha,Vh,rw,rw,qw,qw,qw,_La,pe,QP,wha,vha,tha,sha,Aha,Uh,WH,Ega,Sb,Sb,ae,pw,$d,$d,ae,zha,yha,gc,pe,gc,pe,_ga,Kga,EH,DH,DH,Iga,Sb,pe,Sb,Sb,Sb,gc,Jxa,IH,Wga,Mga,Lga,Zga,Vh,Uga,Tga,Sga,Rga,Qga,Pga,Oga,Nga,Vga,Uh,HH,Sb,Sb,ae,$d,$d,ae,GH,FH,yi,yga,xga,xH,dc,dc,Ke,Qg,Aga,wH,Dga,Sb,uga,tga,jga,ws,hga,gga,fga,ega,Hc,Og,gs,dc,Nm,gc,Yfa,Lfa,Bfa,tfa,lfa,efa,Uea,Iea,Aea,Mha,$ga,rH,iw,Rfa,qH,Qfa,Sb,pe,Sb,Sb,Sb,gc,vP,Vfa,Wfa,Xfa,Vh,Tfa,Uh,Sfa,Sb,Sb,ae,$d,$d,gc,pe,pH,Pfa,Ofa,oH,Mfa,nH,mH,Kfa,jH,iH,iH,Dfa,Sb,pe,Sb,Sb,Sb,gc,Cfa,Hfa,Ifa,Jfa,Vh,Ffa,Uh,kH,Sb,Sb,ae,$d,$d,Afa,Hj,Hj,ufa,Sb,pe,Sb,Sb,Sb,gc,UI,wfa,xfa,yfa,Vh,vfa,Uh,fH,Sb,Sb,ae,$d,$d,sfa,cH,bH,bH,nfa,Sb,pe,Sb,Sb,Sb,gc,UI,pfa,qfa,rfa,Vh,ofa,Uh,dH,Sb,Sb,ae,$d,$d,kfa,aH,aH,ifa,vP,jfa,pH,hfa,gfa,oH,ffa,nH,mH,dfa,Hj,Hj,Zea,Sb,pe,Sb,Sb,Sb,gc,$d,$ea,afa,bfa,Vh,_ea,Uh,Yea,Sb,Sb,ae,$d,$d,Tea,Xea,WG,VG,VG,Lea,Sb,pe,Sb,Sb,Kea,gc,Jea,Nea,Oea,Sea,Vh,Mea,Uh,gw,Sb,Sb,ae,$d,$d,gc,pe,Gea,Hj,Hj,Bea,Sb,pe,Sb,Sb,Sb,gc,jW,Dea,Eea,Fea,Vh,Cea,Uh,TG,Sb,Sb,ae,$d,$d,zea,Hj,Hj,uea,Sb,pe,Sb,Sb,Sb,gc,dq,wea,xea,yea,Vh,vea,Uh,PG,Sb,Sb,ae,$d,$d,Cba,hea,Pba,Yaa,Bba,Aba,raa,pu,paa,mr,EG,laa,Xda,Wda,Hc,Hc,maa,iaa,haa,gaa,Td,X,Pda,Oda,EG,faa,daa,AG,Ida,dw,aG,qz,M9,L9,R9,J9,K9,N9,fw,caa,rda,wG,$9,_9,Z9,Y9,X9,W9,V9,U9,T9,S9,I9,fw,C9,B9,A9,z9,y9,x9,w9,v9,u9,t9,s9,r9,q9,p9,Uk,o9,n9,Tk,fr,m9,LB,l9,j9,h9,g9,f9,e9,d9,Tv,b9,a9,Z8,Y8,X8,V8,T8,R8,P8,N8,Iaa,pG,oG,nG,mG,S6,Q6,AG,fw,gca,fca,eca,dca,cca,bca,aca,$ba,_ba,Zba,Yba,Xba,Wba,Vba,Uba,Tba,Sba,Rba,Kba,cw,Nba,Mba,zG,Dba,zG,Eba,cD,ir,hba,Mqa,eq,cba,bba,dc,q8,$aa,MF,m8,Vr,Raa,dc,fK,h8,Tna,Gaa,NB,XO,Hc,Hc,Hc,S8,L8,Q8,O8,xna,Naa,fba,Xaa,ou,hi,Ss,dp,Wz,Baa,sma,Wla,qaa,uG,tG,naa,oaa,Hc,D8,A8,Kaa,fG,Daa,Vaa,Hc,Hc,Hc,lb,Qb,eaa,Q9,Hc,Hc,KJ,H9,G9,F9,U6,hna,ina,Waa,Vma,E9,D9,qm,XF,Aja,k9,Wi,xI,$8,Se,GJ,MI,LI,W8,dc,hg,z8,hg,v8,Ry,gc,W6,dc,Qg,hr,I8,aba,Td,Qg,Td,uc,G8,F8,Qg,RF,x8,Dn,w8,OF,s8,Dn,r8,uc,c8,Td,uc,b8,a8,uc,HF,GF,Qg,uc,N7,M7,uc,EF,DF,uc,A7,z7,uc,CF,BF,uc,j7,i7,uc,zF,yF,Lv,vF,N6,M6,uF,tF,sF,rF,qF,pF,nF,mF,lF,kF,jF,iF,hF,gF,fF,eF,P6,O6,K6,J6,I6,H6,G6,F6,E6,D6,C6,B6,z6,y6,x6,w6,s6,r6,Td,Qg,Td,Qg,p6,o6,o5,_4,I4,H4,G4,D4,F4,A4,Sb,z4,x4,q4,nr,nr,mv,lv,Eq,ND,Nk,iE,p4,ZD,YD,o4,n4,l4,Gq,Yn,fE,k4,ml,ZD,YD,Sb,Sb,E3,j4,i4,h4,C3,Gq,iE,g4,dE,XD,Gq,e4,d4,fE,c4,dE,XD,D3,Gq,b4,a4,Y3,N3,XX,aE,iv,Td,uc,S3,X3,W3,V3,R3,uc,Q3,O3,P3,M3,L3,cE,Am,z3,v3,K3,y3,q3,a3,l3,ev,k3,jKa,cKa,ZR,i3,Am,eg,g3,e3,d3,a3,$2,GD,pe,W2,ED,J3,F3,gc,Fq,fv,UD,TD,Bq,cv,ID,HD,uc,Y2,X2,V2,gv,T2,og,_D,og,_D,G2,Uu,Hg,Gg,zq,Fb,Gu,Xn,Ji,Bj,Tu,Mk,Tn,xj,g2,le,Gh,Tf,d2,a2,eD,eD,U1,yq,Q1,dD,Hh,N1,K1,hc,Wd,I1,C2,Xu,dv,Ru,Hg,Gg,xq,Cq,yj,Kk,sk,dm,wj,Gh,Tf,wq,aD,Hh,i1,uj,d1,b1,Tn,B2,_u,L4,FD,Y0,Aq,Sn,Cl,T0,_l,Tn,Yu,pe,X$,Wl,W$,V$,QC,U$,PC,Tn,S$,Ln,O$,N$,zj,M$,LC,PC,J$,_X,E$,D$,A$,z$,Qe,HC,A2,HC,FC,v$,EC,Qe,u$,Zu,s$,r$,q$,p$,o$,n$,m$,l$,k$,j$,i$,h$,g$,f$,e$,d$,c$,b$,a$,$_,__,Z_,Y_,X_,W_,V_,U_,S_,R_,Q_,P_,O_,N_,M_,L_,K_,J_,I_,H_,F_,AC,cC,Tx,s_,y_,FY,A_,CY,BY,Td,u_,t_,q_,z2,x2,w2,nD,Cj,mD,Un,QZ,PZ,lD,kD,jD,oZ,nZ,lZ,kZ,iZ,hZ,fZ,eZ,cZ,bZ,$Y,ZY,XY,Ju,VY,TY,RY,PY,NY,LY,JY,YB,gc,mC,x_,qH,jC,e_,d_,c_,b_,a_,mA,$Z,_Z,ZZ,CC,XZ,WZ,UZ,SZ,RZ,Sb,OZ,MZ,fC,zZ,xZ,wZ,XF,uZ,rZ,eC,yZ,qz,IU,vZ,tZ,qZ,Td,uc,uc,p_,o_,n_,m_,l_,k_,j_,i_,mA,h_,g_,f_,uc,iC,iC,Mu,ae,ae,YZ,ae,uc,LZ,JZ,Mu,Sb,Sb,HZ,dq,uc,FZ,DZ,Mu,Sb,Sb,BZ,dq,uc,uc,Td,uc,p2,o2,n2,Td,uc,m2,l2,k2,uc,j2,i2,f2,c2,$1,Y1,W1,T1,P1,M1,J1,uc,H1,G1,D1,B1,z1,x1,v1,t1,r1,p1,n1,uc,l1,k1,h1,g1,f1,e1,a1,$0,uc,_0,Z0,X0,W0,V0,U0,S0,R0,Td,uc,$d,N0,M0,L0,K0,J0,I0,pZ,jZ,dZ,QY,MY,YY,UY,Td,uc,$d,u0,t0,s0,r0,q0,p0,mZ,gZ,aZ,OY,KY,WY,SY,Hu,dC,b0,Hu,dC,$$,uc,uq,uq,sj,sj,sj,SC,Sb,rj,rj,uc,uq,uq,sj,sj,sj,SC,Sb,rj,rj,uc,Mr,Mr,sj,tq,tq,RC,Sb,rj,rj,uc,Mr,Mr,sj,tq,tq,RC,Sb,rj,rj,uc,Y$,T$,uc,P$,L$,uc,F$,C$,uc,B$,y$,uc,IC,x$,gc,uc,IC,w$,gc,$D,qY,Td,Qg,Qg,Sb,Sb,Sb,UB,VB,xY,WE,YX,Fa,BE,VX,RX,KX,LX,PX,uc,HX,uc,IX,GX,ot,FX,zu,zu,zu,du,uc,EX,Td,uc,pe,pe,DX,uX,xX,CX,uc,vX,yX,BX,uc,wX,zX,AX]);function VMa(){return g.byteLength/65536|0}function WMa(cNa){cNa=cNa|0;var cb=VMa()|0;var db=cb+cNa|0;if(cb<db&&db<65536){var eb=new ArrayBuffer(p(db,65536));var fb=new Int8Array(eb);fb.set(h);h=new Int8Array(eb);i=new Int16Array(eb);j=new Int32Array(eb);k=new Uint8Array(eb);l=new Uint16Array(eb);m=new Uint32Array(eb);n=new Float32Array(eb);o=new Float64Array(eb);g=eb;f.buffer=g;a=k}return cb}return{"ya":rT,"za":bb,"Aa":iea,"Ba":gea,"Ca":uc,"Da":Fb,"Ea":fea,"Fa":dea,"Ga":cea,"Ha":mr,"Ia":gc,"Ja":bea,"Ka":aea,"La":$da,"Ma":rw,"Na":_da,"Oa":HG,"Pa":Zda,"Qa":Td,"Ra":GG,"Sa":FG,"Ta":GG,"Ua":Uda,"Va":hX,"Wa":gX,"Xa":fX,"Ya":Qda,"Za":CG,"_a":Lda,"$a":BG,"ab":Jda,"bb":Hda,"cb":Gda,"db":Fda,"eb":Eda,"fb":Dda,"gb":Cda,"hb":Ada,"ib":zda,"jb":yda,"kb":xda,"lb":wda,"mb":vda,"nb":uda,"ob":tda,"pb":sda,"qb":qda,"rb":pda,"sb":oda,"tb":nda,"ub":mda,"vb":lda,"wb":kda,"xb":jda,"yb":ida,"zb":hda,"Ab":gda,"Bb":fda,"Cb":eda,"Db":dda,"Eb":cda,"Fb":bda,"Gb":ada,"Hb":$ca,"Ib":_ca,"Jb":Zca,"Kb":Yca,"Lb":Xca,"Mb":Wca,"Nb":Vca,"Ob":Uca,"Pb":Tca,"Qb":Sca,"Rb":Rca,"Sb":Qca,"Tb":Oca,"Ub":Nca,"Vb":Mca,"Wb":Lca,"Xb":Kca,"Yb":Jca,"Zb":Ica,"_b":Hca,"$b":Gca,"ac":Fca,"bc":Dca,"cc":Cca,"dc":Bca,"ec":Aca,"fc":zca,"gc":yca,"hc":xca,"ic":wca,"jc":eX,"kc":uca,"lc":sca,"mc":rca,"nc":qca,"oc":dX,"pc":oca,"qc":nca,"rc":mca,"sc":lca,"tc":kca,"uc":jca,"vc":hca,"wc":Yc,"xc":BE,"yc":kX,"zc":jX,"Ac":iX,"Bc":C4,"Cc":tX,"Dc":sX,"Ec":cX,"Fc":bX,"Gc":aX,"Hc":$W,"Ic":WW,"Jc":_W,"Kc":ZW,"Lc":YW,"Mc":XW,"Nc":WW,"Oc":VW}}return UMa(XMa)}


// EMSCRIPTEN_END_ASM




)(asmLibraryArg);
  },

  instantiate: /** @suppress{checkTypes} */ function(binary, info) {
    return {
      then: function(ok) {
        var module = new WebAssembly.Module(binary);
        ok({
          'instance': new WebAssembly.Instance(module)
        });
        // Emulate a simple WebAssembly.instantiate(..).then(()=>{}).catch(()=>{}) syntax.
        return { catch: function() {} };
      }
    };
  },

  RuntimeError: Error
};

// We don't need to actually download a wasm binary, mark it as present but empty.
wasmBinary = [];


